# AqEquil

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.13530217.svg)](https://doi.org/10.5281/zenodo.13530217)

Boyer, G., Robare, J., Park, N., Ely, T., Shock, E.L.

## About

AqEquil is a Python 3 package that enables users to rapidly perform aqueous speciation calculations of water chemistry data for multiple samples by interfacing with [geochemical speciation software EQ3/6](https://github.com/LLNL/EQ3_6) (Wolery 2013, [Wolery 1979](https://inis.iaea.org/collection/NCLCollectionStore/_Public/10/474/10474294.pdf)). AqEquil uses [a modified version of EQ3/6](https://github.com/39alpha/eq3_6/tree/main) created by the 39Alpha research team for easy local installation.

Water sample data in CSV format is automatically converted to a format readable by EQ3 and then speciated. Distributions of aqueous species, mineral saturation indices, oxidation reduction potentials, and more are data-mined and returned as Pandas tables and interactive Plotly visualizations.

Speciated fluids can be further reacted with minerals or other fluids in mass transfer calculations to produce tables and interactive diagrams of reaction paths and composition changes as a function of reaction progress.

## Requirements

AqEquil has been tested with Ubuntu 22.04.3 LTS.

This installation requires the Linux version of EQ3/6 v8.0a, which can downloaded [here](https://github.com/LLNL/EQ3_6). Installation instructions are provided there.

AqEquil must be installed into an environment with an R installation. See [these instructions](https://docs.anaconda.com/anaconda/user-guide/tasks/using-r-language/) for installing R with Anaconda.

Additionally, the CHNOSZ package must be installed in R (see instructions below).

## Installation

### Installing EQ3/6 for Linux

I recommend using [this github version of EQ3/6 v.8.0a adapted by the 39Alpha team](https://github.com/39alpha/eq3_6/tree/main). Installation instructions are found there.

Create an environment variable called `EQ36DO` and set it to wherever you installed EQ3/6. (`/usr/local/bin` by default). Set another environment variable called `EQ36DA` to the directory containing your data1 thermodynamic database files (if you have one).

### Installing CHNOSZ version 1.4.3

Open an R session. Install CHNOSZ version 1.4.3 package with:

```install.packages('http://cran.r-project.org/src/contrib/Archive/CHNOSZ/CHNOSZ_1.4.3.tar.gz', repos=NULL, type='source')```

Once CHNOSZ is installed you can quit the R session.

Compatibility with CHNOSZ v.2.0.0 is forthcoming.

### Installing AqEquil

Install AqEquil using pip:

```pip install AqEquil```

### Usage

See this [demo notebook](https://nbviewer.jupyter.org/github/worm-portal/WORM-Library/blob/master/3-Aqueous-Speciation/1-Introduction-to-Aq-Speciation/2-Intro-to-Multi-Aq-Speciation.ipynb) for usage examples.

suppressMessages({
  library(CHNOSZ)
  library(dplyr)
})
options(stringsAsFactors=F)


vprint <- function(string, verbose=2){
  # print messages depending on desired level of 'verbose'-ness.
  if(verbose > 0){
    print(string)
  } else if(verbose >= 0){
    if(grepl("warning", tolower(string)) | grepl("error", tolower(string))){
      print(string)
    }
  }
}


header_unit <- function(header, keepcase=FALSE){
  # get units from a header
  # (unit should always be at end of header after an underscore)
  split_header <- strsplit(header, "_")[[1]] # split header by underscore
  if(!keepcase){
    tolower(split_header[length(split_header)]) # get last string in split
  } else {
    split_header[length(split_header)] # get last string in split
  }
}

uc_molal <- function(value=1, chemical="H+", unit="ppm"){
  # convert unit name to lowercase
  unit <- tolower(unit)

  # convert ppb to ppm
  if(unit == "ppb"){
    value <- value/1000
  }

  # convert ppm or mg/L to molality
  if(unit == "ppb" | unit == "ppm" | unit == "mg/l"){
    value <- value*0.001/mass(info(info("water"))$formula)
    return(value)
  } else if(unit == "molality" | unit == "molal"){
    return(value)
  } else {
    stop("Error in uc_molal(): unit must be either ppb, ppm, or mg/L")
  }
}


header_species <- function(header){
    # get chemical species from header
    # (should always be at start of header before an underscore)
  split_header <- strsplit(header, "_")[[1]][1] # split header by underscore
}


EQ3_jflags <- c("Suppressed", "Molality", "Molarity", "mg/L",
              "mg/kg.sol", "Alk., eq/kg.H2O", "Alk., eq/L",
              "Alk., eq/kg.sol", "Alk., mg/L CaCO3", "Alk., mg/L HCO3-",
              "Log activity", "Log act combo", "Log mean act", "pX",
              "pH", "pHCl", "pmH", "pmX", "Hetero. equil.",
              "Homo. equil.", "Make non-basis", "logfO2")

# function to convert ppb, ppm, or mg/L to molality
acceptable_units <- c("ppb", "ppm", "mg/l", "molality", "molal")

preprocess <- function(input_filename,
                       exclude,
                       grid_temps,
                       grid_press,
                       strict_minimum_pressure,
                       dynamic_db,
                       poly_coeffs_1,
                       poly_coeffs_2,
                       water_model,
                       verbose=2){

  # Read input
  r <- read.csv(input_filename,
                header=TRUE,
                check.names=F,
                stringsAsFactors=F,
                colClasses="character")
    
  df <- as.data.frame(r)
    
  df_numeric <- df[!(names(df) %in% exclude)]
    
  df_numeric <- df_numeric[, df_numeric[1, ] != "Hetero. equil."]
    
  num_cols <- names(df_numeric)
  num_cols <- match(num_cols, colnames(df))
  num_cols <- num_cols[num_cols != 1]

  # specify headers and subheaders
  header1 <- names(df)
  header2 <- df[1, ]

  # create concatenated header_subheader column names
  for(i in 1:length(header1)){
    if(is.na(header2[i])){
      header2[i] <- ""
    }
    if(header2[i] != ""){
      colnames(df)[i] <- paste(header1[i], header2[i], sep="_")
    }else{
      colnames(df)[i] <- header1[i]
    }
      
  }
  #colnames(df) <- paste(header1, header2, sep="_")
  df = df[-1, ] # remove subheader row
  colnames(df)[1] <- "Sample" # rename "_" as sample name header

  # Convert data to numeric ------------------------------------------------------
  # convert columns to numeric
  df[, num_cols] <- mutate_all(df[, num_cols], function(x) as.numeric(as.character(x)))

  # convert these special columns to numeric even if excluded from aqueous block
  special_numeric <- c("rho_", "Pressure_", "redox_", "Temperature_", "pe_", "Eh_", "logfO2_")               

  for(col in special_numeric){
    if(TRUE %in% grepl(col, colnames(df))){
      this_match <- grep(col, colnames(df))
      df[, this_match] <- as.numeric(as.character(df[, this_match]))
    }
  }              

  # add columns to exclusion list
  exclude <- c(exclude, "", "Sample", "rho", "Pressure", "redox", "Temperature", "pe", "Eh", "logfO2")

  # find temperature (in degK)
  if("Temperature_degC" %in% names(df)){
    temp_degC <- df[, "Temperature_degC"]
    temp_degK <- temp_degC + 273.15
  } else if("Temperature_degK" %in% names(df)){
    temp_degK <- df[, "Temperature_degK"]
    temp_degC <- temp_degK - 273.15
  } else {
    stop("Error: need a column for 'Temperature' with units in 'degC' or 'degK'")
  }
          
  # handle TP-dependent preprocessing
  if(!dynamic_db){
      
    grid_temps <- as.numeric(as.character(grid_temps))
    grid_press <- as.numeric(as.character(grid_press))
    minimum_pressure <- min(grid_press)
    
    ### interpolate pressure
      
    f1 <- function(T) {
      sum = 0
      for(i in 1:length(poly_coeffs_1)){
        sum = sum + poly_coeffs_1[i]*T^(i-1)
      }
      return(sum)
    }
      
    f2 <- function(T) {
      sum = 0
      for(i in 1:length(poly_coeffs_2)){
        sum = sum + poly_coeffs_2[i]*T^(i-1)
      }
      return(sum)
    }
      
    pressure_bar <- c()
    for(T in temp_degC){
      if(grid_temps[1] <= T && T <= grid_temps[length(poly_coeffs_1)-1]){ # todo: check if this length(poly_coeffs_1) is correct... should be "4" for grid length of 8
        pressure_bar <- c(pressure_bar, f1(T))
      }else if (grid_temps[length(poly_coeffs_1)-1] <= T && T <= grid_temps[length(grid_temps)]){ # todo: check if this length(poly_coeffs_1) is correct... should be "4" for grid length of 8
        pressure_bar <- c(pressure_bar, f2(T))
      }else{
        stop(paste0("Error: one or more temperatures in this sample set is outside of the temperature range of this thermodynamic dataset (", grid_temps[1], " to ", grid_temps[8], " C)."))
      }
    }
    
    if(strict_minimum_pressure){
      for(i in 1:length(pressure_bar)){
        if(pressure_bar[i] < minimum_pressure){
          pressure_bar[i] <- minimum_pressure
        }
      }
    }
      
  }else{
    if("Pressure_bar" %in% colnames(df)){
        
      if(any(is.na(df[, "Pressure_bar"]))){
        vprint(paste("Warning: a pressure value is missing for one or more",
          "samples in the sample input file. Defaulting to water",
          "saturation pressure for these missing pressures..."),
          verbose=verbose)
          
        water(water_model)
        psat_pressures <- water("Psat", T=temp_degC+273.15)[[1]]
        
        df[, "Pressure_bar"][is.na(df[, "Pressure_bar"])] <- psat_pressures[is.na(df[, "Pressure_bar"])]
      }
        
      pressure_bar <- df[, "Pressure_bar"]
        
    }else{
      # assume PSAT if no pressure column in sample input file

      vprint(paste("Warning: a column for Pressure was not found in the",
        "sample input file. Defaulting to water saturation pressure..."),
             verbose=verbose)
      water(water_model)
      pressure_bar <- water("Psat", T=temp_degC+273.15)[[1]]
    }
    
    minimum_pressure <- 0
  }

  # create unique df row names that will become .3i filenames
  row_order <- make.names(df$Sample, unique=TRUE)
  rownames(df) <- row_order
             
  input_processed_list = list("df"=df,
                              "temp_degC"=temp_degC,
                              "pressure_bar"=pressure_bar,
                              "minimum_pressure"=minimum_pressure,
                              "exclude"=exclude)

  return(input_processed_list)
}

                               
                               
                               
                               
                               
                               
write_3i_file <- function(df,
                          temp_degC,
                          pressure_bar,
                          minimum_pressure,
                          strict_minimum_pressure,
                          pressure_override,
                          suppress_missing,
                          exclude,
                          allowed_aq_block_species,
                          charge_balance_on,
                          suppress,
                          alter_options,
                          aq_scale,
                          get_solid_solutions,
                          input_dir,
                          redox_flag,
                          redox_aux,
                          default_logfO2,
                          water_model,
                          warned_about_redox_column,
                          activity_model,
                          verbose){
    
  # Set water model --------------------------------------------------------------                          
  suppressMessages(water(water_model))
    
  row <- 1

  # calculate rho and append
  df[1, "rho"] <- water("rho", T=temp_degC+273.15, P=pressure_bar)[[1]]
  df[1, "rho"] <- df[1, "rho"]/1000 #convert rho to g/cm3
    
    
  # Handle redox block ---------------------------------------------------------
  df$redox_flag <- redox_flag
  df$redox_value <- NA
  df$redox_unit <- NA

  this_redox_flag <- redox_flag
  assigned <- FALSE
 
  # use gaseous O2 in aqueous species block
  if(redox_flag == -3){
    redox_col_index <- grep("O2(g)", names(df), fixed = T, value = T)
    tryCatch({
      redox_col_index <- redox_col_index[substring(redox_col_index, 1, nchar("O2(g)")) == "O2(g)"]
      unit <- strsplit(redox_col_index, "_")[[1]][2]
    }, error=function(e){
      redox_col_index = 0
    })
    if(length(redox_col_index) > 0){
      if(!is.na(df[row, redox_col_index])){
        this_redox_value <- unit # subheader should always be "Hetero. equil." whenever redox flag -3 is used (required)
        this_redox_unit <- "using O2(g) in aqueous species block"
      } else {
        vprint(paste0("Warning: non-numeric 'O2(g)' value in sample ",
                        df[row, "Sample"], ". Resorting to using ",
                        "Log fO2 (log bars) with a value of ", default_logfO2),
                        verbose=verbose)
        this_redox_flag <- 0
        this_redox_value <- sprintf("%.4E", default_logfO2)
        this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
        assigned <- TRUE
      }
    } else {
      if(!warned_about_redox_column){
        vprint(paste("Warning: no 'O2(g)' column found. Resorting to using",
                      "Log fO2 (log bars) with a value of", default_logfO2),
                      verbose=verbose)
        warned_about_redox_column <- TRUE
      }
      this_redox_flag <- 0
      this_redox_value <- sprintf("%.4E", default_logfO2)
      this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
      assigned <- TRUE
    }
  }

  # specify pe in pe units
  if(redox_flag == -2){
    redox_col_index <- grep("^pe_", names(df))
    if(!(identical(redox_col_index, integer(0)) | identical(redox_col_index, character(0)))){
      if(!is.na(df[row, redox_col_index])){
        this_redox_value <- sprintf("%.4E", df[row, redox_col_index])
        this_redox_unit <- "pe, pe units"
      } else {
        vprint(paste0("Warning: non-numeric pe value in sample ",
                        df[row, "Sample"], ". Resorting to using ",
                        "Log fO2 (log bars) with a value of ", default_logfO2),
                verbose=verbose)
        this_redox_flag <- 0
        this_redox_value <- sprintf("%.4E", default_logfO2)
        this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
        assigned <- TRUE
      }
    } else {
      if(!warned_about_redox_column){
        vprint(paste0("Warning: no 'pe' column found. Resorting to using ",
                      "Log fO2 (log bars) with a value of ", default_logfO2),
                verbose=verbose)
        warned_about_redox_column <- TRUE
      }
      this_redox_flag <- 0
      this_redox_value <- sprintf("%.4E", default_logfO2)
      this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
      assigned <- TRUE
    }
  }

  # specify Eh in volts
  if(redox_flag == -1){
    redox_col_index <- grep("Eh_volts", names(df))
    if(!(identical(redox_col_index, integer(0)) | identical(redox_col_index, character(0)))){
      if(!is.na(df[row, redox_col_index])){
        this_redox_value <- sprintf("%.4E", df[row, redox_col_index])
        this_redox_unit <- "Eh, volts"
      } else {
        vprint(paste0("Warning: non-numeric Eh value in sample ",
                        df[row, "Sample"], ". Resorting to using ",
                        "Log fO2 (log bars) with a value of ", default_logfO2),
                verbose=verbose)
        this_redox_flag <- 0
        this_redox_value <- sprintf("%.4E", default_logfO2)
        this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
        assigned <- TRUE
      }
    } else {
      if(!warned_about_redox_column){
        vprint(paste0("Warning: no 'Eh' column found with 'volts' units. ",
                      "Resorting to using Log fO2 (log bars) with a value of ",
                      default_logfO2),
                verbose=verbose)
        warned_about_redox_column <- TRUE
      }
      this_redox_flag <- 0
      this_redox_value <- sprintf("%.4E", default_logfO2)
      this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
      assigned <- TRUE
    }
  }

  if(redox_flag == 0 && assigned == FALSE){
    redox_col_index <- grep("logfO2", names(df))
    if(!(identical(redox_col_index, integer(0)) | identical(redox_col_index, character(0)))){
      if(!is.na(df[row, redox_col_index])){
        this_redox_value <- sprintf("%.4E", df[row, redox_col_index])
        this_redox_unit <- "Log fO2 (log bars) [from logfO2 column]"
      } else {
        vprint(paste0("Warning: non-numeric logfO2 value in sample ",
                        df[row, "Sample"], ". Resorting to using ",
                        "a logfO2 value of ", default_logfO2),
                verbose=verbose)
        this_redox_flag <- 0
        this_redox_value <- sprintf("%.4E", default_logfO2)
        this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
        assigned <- TRUE
      }
    } else {
      if(!warned_about_redox_column){
        vprint(paste("Warning: no 'logfO2' column found. Attempting to find a",
                    "column for aqueous O2 to estimate logfO2 at sample temperature and",
                    "pressure..."),
                verbose=verbose)
        warned_about_redox_column <- TRUE
      }
      redox_col_index <- grep("(^O2,AQ)|(^O2_)", names(df)) # TODO: make more flexible (June 25, 2020)
      if(length(redox_col_index) > 0){
        if(!is.na(df[row, redox_col_index])){
          header_name <- names(df)[redox_col_index]
          this_header_unit <- header_unit(header_name)
          if(this_header_unit %in% c(acceptable_units, EQ3_jflags)){
            O2_molal <- uc_molal(value=df[row, redox_col_index],
                                  chemical="O2", unit=this_header_unit)
            if(is.na(temp_degC[row]) | is.na(pressure_bar[row])){
              vprint(paste0("Warning: non-numeric temperature or pressure value ",
                              "in sample ", df[row, "Sample"], ". Resorting to ",
                              "using Log fO2 (log bars) with a value of ", default_logfO2),
                      verbose=verbose)
              this_redox_flag <- 0
              this_redox_value <- sprintf("%.4E", default_logfO2)
              this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
              assigned <- TRUE
            } else {
              suppressMessages({
              logfO2 <- log10(O2_molal*10^subcrt(c("O2", "O2"),
                                                  c(-1, 1),
                                                  c("aq", "g"),
                                                  T=temp_degC[row],
                                                  P=pressure_bar[row],
                                                  exceed.rhomin=TRUE,
                                                  exceed.Ttr=TRUE)$out$logK)
              })
              if(!is.finite(logfO2)){
                logfO2 <- default_logfO2
                this_redox_value <- sprintf("%.4E", default_logfO2)
                this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
              }else{
                this_redox_unit <- paste("Log fO2 (log bars) [calculated from O2(aq) = O2(g) at",
                                          "temperature and pressure of sample]")
              }
              assigned <- TRUE
              this_redox_value <- sprintf("%.4E", logfO2)
            }
          } else {
            vprint(paste("Warning: column found for aqueous O2, but units are not recognized. Resorting to using Log fO2",
                            "(log bars) with a value of", default_logfO2, "for all samples."),
                    verbose=verbose)
            this_redox_flag <- 0
            this_redox_value <- sprintf("%.4E", default_logfO2)
            this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
            assigned <- TRUE
            }
        } else {
          vprint(paste0("Warning: non-numeric aqueous O2 value in sample ",
                          df[row, "Sample"], ". Resorting to using ",
                          "Log fO2 (log bars) with a value of ", default_logfO2),
                          verbose=verbose)
          this_redox_flag <- 0
          this_redox_value <- sprintf("%.4E", default_logfO2)
          this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
          assigned <- TRUE
        }
      } else {
          if(!warned_about_redox_column){
            vprint(paste("Warning: a column for aqueous O2 was not found. Resorting to",
                        "using Log fO2 (log bars) with a value of ",
                        default_logfO2),
                    verbose=verbose)
            warned_about_redox_column <- TRUE
          }
          this_redox_flag <- 0
          this_redox_value <- sprintf("%.4E", default_logfO2)
          this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
          assigned <- TRUE
      }
    }
  }

  # specify aux species redox couple
  if(redox_flag == 1){

    redox_col_index <- grep(paste0(redox_aux, "_"), names(df), fixed = T, value = T)
    redox_col_index <- redox_col_index[substring(redox_col_index, 1, nchar(redox_aux)) == redox_aux]
      
    if(length(redox_col_index) == 1){
      if(!is.na(df[row, redox_col_index])){
        this_redox_value <- sprintf("%.4E", df[row, redox_col_index])
        this_redox_unit <- paste(redox_aux, "aux. sp.")
      } else {
        vprint(paste0("Warning: non-numeric ", redox_aux, " value in sample ",
                        df[row, "Sample"], ". Resorting to using ",
                        "Log fO2 (log bars) with a value of ", default_logfO2),
                verbose=verbose)
        this_redox_flag <- 0
        this_redox_value <- sprintf("%.4E", default_logfO2)
        this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
        assigned <- TRUE
      }
    } else if (length(redox_col_index) > 1){
          if(!warned_about_redox_column){
            vprint(paste("Warning: multiple matches for a", redox_aux, "column found:", paste(redox_col_index, collapse=" "), ". Resorting to using",
                          "Log fO2 (log bars) with a value of ", default_logfO2),
                    verbose=verbose)
            warned_about_redox_column <- TRUE
          }
      this_redox_flag <- 0
      this_redox_value <- sprintf("%.4E", default_logfO2)
      this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
      assigned <- TRUE
    } else {
          if(!warned_about_redox_column){
            vprint(paste("Warning: no", redox_aux, "column found. Resorting to using",
                          "Log fO2 (log bars) with a value of ", default_logfO2),
                    verbose=verbose)
            warned_about_redox_column <- TRUE
          }
      this_redox_flag <- 0
      this_redox_value <- sprintf("%.4E", default_logfO2)
      this_redox_unit <- paste0("Log fO2 (log bars) [default = ", default_logfO2, "]")
      assigned <- TRUE
    }
  }
    
  # append redox values
  df[row, "redox_flag"] <- this_redox_flag
  df[row, "redox_value"] <- this_redox_value
  df[row, "redox_unit"] <- this_redox_unit

  # check that the redox state of the sample is within the stability region of water
  if(this_redox_flag != 1){
    T <- temp_degC
    P <- pressure_bar

    # reduction
    logaH2O <- 0 # a good starting guess is 0 before actually doing the speciation...
    logfH2 <- logaH2O
    logK <- suppressMessages(subcrt(c("H2O", "O2", "H2"), c(-1, 0.5, 1), c("liq", "gas", "gas"), T=T+273.15, P=P, convert=FALSE))$out$logK 
    logfO2_red <- 2 * (logK - logfH2 + logaH2O)

    # oxidation
    logfO2_ox <- 0
      
    if(charge_balance_on != "H+" && (this_redox_flag == -1 || this_redox_flag == -2)){ # Eh or pe, excluding situations where charge balance is on pH
      pH <- df[row, "H+_pH"]
      Eh_ox <- convert(logfO2_ox, 'E0', T=T+273.15, P=P, pH=pH, logaH2O=logaH2O)
      pe_ox <- convert(convert(logfO2_ox, 'E0', T = T+273.15, P=P, pH=pH, logaH2O=logaH2O), "pe", T=T+273.15)
      Eh_red <- convert(logfO2_red, 'E0', T = T+273.15, P=P, pH=pH, logaH2O=logaH2O)
      pe_red <- convert(convert(logfO2_red, 'E0', T=T+273.15, P=P, pH=pH, logaH2O=logaH2O), "pe", T=T+273.15)

      if(this_redox_flag == -1){ # Eh
        if(as.numeric(this_redox_value) <= Eh_red){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too reduced)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has an Eh of", round(as.numeric(this_redox_value), 2), "volts, which is below the", round(Eh_red, 2),
                       "volt threshold for stable water at this temperature, pressure, and pH."))
        }else if (as.numeric(this_redox_value) >= Eh_ox){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too oxidized)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has an Eh of", round(as.numeric(this_redox_value), 2), "volts, which is above the", round(Eh_ox, 2),
                       "volt threshold for stable water at this temperature, pressure, and pH."))
        }
      }else{ # pe
        if(as.numeric(this_redox_value) <= pe_red){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too reduced)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has a pe of", round(as.numeric(this_redox_value), 2), "which is below the", round(pe_red, 2),
                       "pe threshold for stable water at this temperature, pressure, and pH."))
        }else if (as.numeric(this_redox_value) >= pe_ox){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too oxidized)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has a pe of", round(as.numeric(this_redox_value), 2), "which is above the", round(pe_ox, 2),
                       "pe threshold for stable water at this temperature, pressure, and pH."))
        }
      }
    }else if (this_redox_flag == 0){ # logfO2
        if(as.numeric(this_redox_value) <= logfO2_red){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too reduced)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has a logfO2 of", round(as.numeric(this_redox_value), 2), "which is below the", round(logfO2_red, 2),
                       "logfO2 threshold for stable water at this temperature and pressure."))
        }else if (as.numeric(this_redox_value) >= logfO2_ox){
          vprint(paste("Warning: the sample", df[row, "Sample"], "may be outside of the stability region of water (too oxidized)",
                       "which may cause the speciation calculation to fail.",
                       "The sample has a logfO2 of", round(as.numeric(this_redox_value), 2), "which is above the", round(logfO2_ox, 2),
                       "logfO2 threshold for stable water at this temperature and pressure."))
        }
    }else if (this_redox_flag == -3){ # O2(g)
      # there should be no reason to check this because O2(g) must be set to heterogeneous equilibrium
      # with minerals. Assumedly, this keeps samples from becoming too reduced or oxidized.
    }
      
  }
    
  if(charge_balance_on == "none"){
    eq3.cb_block <- paste("\n|Electrical balancing option (iebal3):                                         |",
  "|  [x] ( 0) No balancing is done                                               |",
  "|  [ ] ( 1) Balance on species |None                    | (uebal)              |", sep="\n")

  } else {
    eq3.cb_block <- paste(
    "\n|Electrical balancing option (iebal3):                                         |",
    "|  [ ] ( 0) No balancing is done                                               |",
    paste0("|  [x] ( 1) Balance on species |", format(charge_balance_on, width=24), "| (uebal)              |"), sep="\n")
  }
    
  eq3.filename <- paste0(c(rownames(df)[row], ".3i"), collapse = "") #create the name of the file

  eq3.header1 <- paste("|------------------------------------------------------------------------------|",
  "| Title                  | (utitl(n))                                          |",
  "|------------------------------------------------------------------------------|",
  "|                                                                              |",
  "|", sep="\n")

  eq3.samplename <- paste(c("Sample:", format(df[row, "Sample"], width=70)), collapse = " ")

  eq3.header2 <- paste("|",
  "|                                                                              |",
  "|------------------------------------------------------------------------------|",
  "|Special Basis Switches (for model definition only)       | (nsbswt)           |",
  "|------------------------------------------------------------------------------|",
  "|Replace |None                                            | (usbsw(1,n))       |",
  "|   with |None                                            | (usbsw(2,n))       |",
  "|------------------------------------------------------------------------------|",
  "|Temperature (C)         | ", sep="\n")

  eq3.temperature <- sprintf("%.5E", temp_degC[row])
    
  if (pressure_override){
    eq3.header3 <-              paste("| (tempc)                                |",
      "|------------------------------------------------------------------------------|",
      "|Pressure option (jpres3):                                                     |",
      "|  [ ] ( 0) Data file reference curve value                                    |",
      "|  [ ] ( 1) 1.013-bar/steam-saturation curve value                             |",
      paste0("|  [x] ( 2) Value (bars) |", format(sprintf("%.5E", pressure_bar[row]), width=12, justify="right"),
              "| (press)                                |"),
      "|------------------------------------------------------------------------------|",
      "|Density (g/cm3)         | ", sep="\n")
  }else if(strict_minimum_pressure == FALSE | pressure_bar[row] > minimum_pressure){
    eq3.header3 <-              paste("| (tempc)                                |",
      "|------------------------------------------------------------------------------|",
      "|Pressure option (jpres3):                                                     |",
      "|  [x] ( 0) Data file reference curve value                                    |",
      "|  [ ] ( 1) 1.013-bar/steam-saturation curve value                             |",
      "|  [ ] ( 2) Value (bars) | 1.00000E+00| (press)                                |",
      "|------------------------------------------------------------------------------|",
      "|Density (g/cm3)         | ", sep="\n")
  }else{
    eq3.header3 <-              paste("| (tempc)                                |",
      "|------------------------------------------------------------------------------|",
      "|Pressure option (jpres3):                                                     |",
      "|  [ ] ( 0) Data file reference curve value                                    |",
      "|  [ ] ( 1) 1.013-bar/steam-saturation curve value                             |",
      paste0("|  [x] ( 2) Value (bars) |", format(sprintf("%.5E", minimum_pressure), width=12, justify="right"),
              "| (press)                                |"),
      "|------------------------------------------------------------------------------|",
      "|Density (g/cm3)         | ", sep="\n")
  }
      
      
  eq3.density <- sprintf("%.5E", df[row, "rho"])

  eq3.header4 <-               paste("| (rho)                                  |",
  "|------------------------------------------------------------------------------|",
  "|Total dissolved solutes option (itdsf3):                                      |",
  "|  [x] ( 0) Value (mg/kg.sol) | 0.00000E+00| (tdspkg)                          |",
  "|  [ ] ( 1) Value (mg/L)      | 0.00000E+00| (tdspl)                           |",
  "|------------------------------------------------------------------------------|",
                                        sep="\n")

  # cb_block will be pasted here (one for all samples)

  eq3.header5 <- paste("\n|------------------------------------------------------------------------------|",
  "|Default redox constraint (irdxc3):                                            |", sep="\n")

  default_redox_minus3 <- "\n|  [ ] (-3) Use O2(g) line in the aqueous basis species block                  |"
  default_redox_minus2 <-   "|  [ ] (-2) pe (pe units)      | 0.00000E+00| (pei)                            |"
  default_redox_minus1 <-   "|  [ ] (-1) Eh (volts)         | 0.00000E+00| (ehi)                            |"
  default_redox_0      <-   "|  [ ] ( 0) Log fO2 (log bars) | 0.00000E+00| (fo2lgi)                         |"
  default_redox_1      <-   "|  [ ] ( 1) Couple (aux. sp.)  |None                    | (uredox)             |"


  if(df[row, "redox_flag"] == -3){
    default_redox_minus3 <- "\n|  [x] (-3) Use O2(g) line in the aqueous basis species block                  |"
  } else if(df[row, "redox_flag"] == -2){
    default_redox_minus2 <- paste0("|  [x] (-2) pe (pe units)      |",
                          format(df[row, "redox_value"], width=12, justify="right"),
                          "| (pei)                            |")
  } else if(df[row, "redox_flag"] == -1){
    default_redox_minus1 <- paste0("|  [x] (-1) Eh (volts)         |",
                          format(df[row, "redox_value"], width=12, justify="right"),
                          "| (ehi)                            |")
  } else if(df[row, "redox_flag"] == 0){
    default_redox_0 <- paste0("|  [x] ( 0) Log fO2 (log bars) |",
                          format(df[row, "redox_value"], width=12, justify="right"),
                          "| (fo2lgi)                         |")
  } else if(df[row, "redox_flag"] == 1){
    default_redox_1 <- paste0("|  [x] ( 1) Couple (aux. sp.)  | ",
                          format(redox_aux, width=23, justify="left"),
                          "| (uredox)             |")
  } else {
    stop(paste0("Error when writing .3i file for sample ", df[row, "Sample"],
                ". Redox flag was not recognized! Choose -3, -2, -1, 0, or 1."))
  }
  redox_block <- paste(default_redox_minus3, default_redox_minus2,
                        default_redox_minus1, default_redox_0,
                        default_redox_1, sep = "\n")

  eq3.header6 <- paste("\n|------------------------------------------------------------------------------|",
                        "|Aqueous Basis Species/Constraint Species        |Conc., etc. |Units/Constraint|",
                        "| (uspeci(n)/ucospi(n))                          | (covali(n))|(ujf3(jflgi(n)))|",
                        "|------------------------------------------------------------------------------|",
                        sep = "\n")
      
  if(allowed_aq_block_species[1] == "all"){
    allowed_aq_block_species <- unlist(lapply(names(df), FUN=header_species))
  }
      
  # handle aqueous block
  aqueous_lines <- c()
  for(column in names(df)){
    if(suppress_missing & is.na(df[row, column])){
      df[row, column] <- 0
    }
    if(!is.na(df[row, column])){
      species_name  <- header_species(column)
      if(!(species_name %in% exclude) && (species_name %in% allowed_aq_block_species)){
        species_value <- df[row, column]
        # EQ3 won't balance on a species if its concentration is 0 so
        # change it to a very small non-zero value
        if(charge_balance_on == species_name && as.numeric(species_value)==0){
          species_value <- 1e-18
        }
        species_unit  <- header_unit(column, keepcase=TRUE)
          
        if(!(species_unit %in% EQ3_jflags)){
          if(tolower(species_unit) == "ppb"){
            species_value <- species_value/1000
            species_unit <- "mg/L"
          } else if(tolower(species_unit) == "ppm"){
            species_unit <- "mg/L"
          } else {
            print(paste("Error creating .3i file:", species_unit,
            "is not a recognized aqueous block jflag. Try checking",
            "capitalization and spelling to match one of the following:",
            paste(EQ3_jflags, collapse=" ")))
          }
        }
        if(species_unit == "Hetero. equil."){
          species_value_split <- strsplit(species_value, " ")[[1]]
          if(length(species_value_split) == 2){
            # for gases
            species_value <- species_value_split[1]
            hetero_equil_species <- species_value_split[2]
          }else{
            # for minerals
            hetero_equil_species <- species_value
            species_value <- 0
          }
              
        }
        species_value <- format(sprintf("%.5E", as.numeric(species_value)), width=12, justify="right")
        this_aq_line <- paste0("\n|",
                              format(species_name, width=48), "|",
                              species_value,  "|",
                              format(species_unit, width=16),   "|")
        # handle additional line for 'Hetero. equil.' jflag
        if(species_unit == "Hetero. equil."){
          this_aq_line <- paste0(this_aq_line, "\n", "|->|", format(hetero_equil_species, width=45), "| ", format("(ucospi(n))", width=28), "|")
        }
        aqueous_lines <- c(aqueous_lines, this_aq_line)
      }
    }
  }

  # suppressing species
  for(species in suppress){
    this_aq_line <- paste0("\n|",
                            format(species, width=48), "| ",
                            sprintf("%.5E", 0),  "|",
                            format("Suppressed", width=16),   "|")
    aqueous_lines <- c(aqueous_lines, this_aq_line)
  }

  aqueous_block <- paste(aqueous_lines, collapse="")

  eq3.ender1 <- paste("\n|------------------------------------------------------------------------------|",
  "* Valid jflag strings (ujf3(jflgi(n))) are:                                    *",
  "*    Suppressed          Molality            Molarity                          *",
  "*    mg/L                mg/kg.sol           Alk., eq/kg.H2O                   *",
  "*    Alk., eq/L          Alk., eq/kg.sol     Alk., mg/L CaCO3                  *",
  "*    Alk., mg/L HCO3-    Log activity        Log act combo                     *",
  "*    Log mean act        pX                  pH                                *",
  "*    pHCl                pmH                 pmX                               *",
  "*    Hetero. equil.      Homo. equil.        Make non-basis                    *",
  "*------------------------------------------------------------------------------*",
  "|Create Ion Exchangers  | (net)                                                |",
  "|------------------------------------------------------------------------------|",
  "|Advisory: no exchanger creation blocks follow on this file.                   |",
  "|Option: on further processing (writing a PICKUP file or running XCON3 on the  |",
  "|present file), force the inclusion of at least one such block (qgexsh):       |",
  "|  [ ] (.true.)                                                                |",
  "|------------------------------------------------------------------------------|",
  "|Ion Exchanger Compositions      | (neti)                                      |",
  "|------------------------------------------------------------------------------|",
  "|Exchanger phase |None                    | (ugexpi(n))                        |",
  "|------------------------------------------------------------------------------|",
  "|->|Moles/kg.H2O    |  0.0000    | (cgexpi(n))                                 |",
  "|------------------------------------------------------------------------------|",
  "|->|Exchange site   |None    | (ugexji(j,n))                                   |",
  "|------------------------------------------------------------------------------|",
  "|--->|Exchange species        |Eq. frac.   | (this is a table header)          |",
  "|------------------------------------------------------------------------------|",
  "|--->|None                    | 0.00000E+00| (ugexsi(i,j,n), egexsi(i,j,n))    |",
  "|------------------------------------------------------------------------------|",
  "|Solid Solution Compositions     | (nxti)                                      |",
  "|------------------------------------------------------------------------------|",
  "|Solid Solution          |None                    | (usoli(n))                 |",
  "|------------------------------------------------------------------------------|",
  "|->|Component               |Mole frac.  | (this is a table header)            |",
  "|------------------------------------------------------------------------------|",
  "|->|None                    | 0.00000E+00| (umemi(i,n), xbari(i,n))            |",
  "|------------------------------------------------------------------------------|",
  "|Alter/Suppress Options  | (nxmod)                                             |",
  "|------------------------------------------------------------------------------|",
  "|Species                                         |Option          |Alter value |",
  "| (uxmod(n))                                     |(ukxm(kxmod(n)))| (xlkmod(n))|",
  "|------------------------------------------------------------------------------|", sep="\n")
      
  alter_block <- c()
  if(length(alter_options) > 0){
    for(i in 1:length(alter_options)){
      species <- names(alter_options)[i]
      option <- alter_options[[i]]
      if(length(option == 3)){
        alter_line <- paste0("\n|",
                              format(species, width=48), "| ",
                              format(option[1], width=15), "|",
                              format(sprintf("%.5E", as.numeric(option[2])), width=12, justify="right"), "|")
      }
      alter_block <- c(alter_block, alter_line)
    }
    alter_block <- paste(alter_block, collapse="")
  }else{
    alter_block <- "\n|None                                            |None            | 0.00000E+00|"
  }

  if(get_solid_solutions){
    ss_checkbox_ignore <- " "
    ss_checkbox_permit <- "x"
  }else{
    ss_checkbox_ignore <- "x"
    ss_checkbox_permit <- " "
  }
      
  eq3.ender2 <- paste("\n|------------------------------------------------------------------------------|",
  "* Valid alter/suppress strings (ukxm(kxmod(n))) are:                           *",
  "*    Suppress            Replace             AugmentLogK                       *",
  "*    AugmentG                                                                  *",
  "*------------------------------------------------------------------------------*",
  "|Iopt Model Option Switches (\"( 0)\" marks default choices)                     |",
  "|------------------------------------------------------------------------------|",
  "|iopt(4) - Solid Solutions:                                                    |",
  paste0("|  [", ss_checkbox_ignore, "] ( 0) Ignore                                                             |"),
  paste0("|  [", ss_checkbox_permit, "] ( 1) Permit                                                             |"),
  "|------------------------------------------------------------------------------|",
  "|iopt(11) - Auto Basis Switching in pre-N-R Optimization:                      |",
  "|  [x] ( 0) Turn off                                                           |",
  "|  [ ] ( 1) Turn on                                                            |",
  "|------------------------------------------------------------------------------|",
  "|iopt(17) - PICKUP File Options:                                               |",
  "|  [ ] (-1) Don't write a PICKUP file                                          |",
  "|  [x] ( 0) Write a PICKUP file                                                |",
  "|------------------------------------------------------------------------------|",
  "|iopt(19) - Advanced EQ3NR PICKUP File Options:                                |",
  "|  [ ] ( 0) Write a normal EQ3NR PICKUP file                                   |",
  "|  [ ] ( 1) Write an EQ6 INPUT file with Quartz dissolving, relative rate law  |",
  "|  [ ] ( 2) Write an EQ6 INPUT file with Albite dissolving, TST rate law       |",
  "|  [x] ( 3) Write an EQ6 INPUT file with Fluid 1 set up for fluid mixing       |",
  "|------------------------------------------------------------------------------|",
  "|Iopg Activity Coefficient Option Switches (\"( 0)\" marks default choices)      |",
  "|------------------------------------------------------------------------------|", sep="\n")

davies_box <- " "
bdot_box <- " "
pitzer_box <- " "
if(activity_model == "davies"){
  davies_box <- "x"
}else if(activity_model == "b-dot"){
  bdot_box <- "x"
}else if(activity_model == "pitzer"){
  pitzer_box <- "x"
}else{
  print("Error: activity model is not recognized. Try 'b-dot', 'davies', or 'pitzer'")
}

eq3.ender3 <- paste("\n|iopg(1) - Aqueous Species Activity Coefficient Model:                         |",
  paste0("|  [", davies_box, "] (-1) The Davies equation                                                |"),
  paste0("|  [", bdot_box, "] ( 0) The B-dot equation                                                 |"),
  paste0("|  [", pitzer_box, "] ( 1) Pitzer's equations                                                 |"),
  paste0("|  [ ] ( 2) HC + DH equations                                                  |"),
  "|------------------------------------------------------------------------------|",
  "|iopg(2) - Choice of pH Scale (Rescales Activity Coefficients):                |",
  "|  [ ] (-1) \"Internal\" pH scale (no rescaling)                                 |",
  "|  [x] ( 0) NBS pH scale (uses the Bates-Guggenheim equation)                  |",
  "|  [ ] ( 1) Mesmer pH scale (numerically, pH = -log m(H+))                     |",
  "|------------------------------------------------------------------------------|",
  "|Iopr Print Option Switches (\"( 0)\" marks default choices)                     |",
  "|------------------------------------------------------------------------------|",
  "|iopr(1) - Print All Species Read from the Data File:                          |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print                                                              |",
  "|------------------------------------------------------------------------------|",
  "|iopr(2) - Print All Reactions:                                                |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print the reactions                                                |",
  "|  [ ] ( 2) Print the reactions and log K values                               |",
  "|  [ ] ( 3) Print the reactions, log K values, and associated data             |",
  "|------------------------------------------------------------------------------|",
  "|iopr(3) - Print the Aqueous Species Hard Core Diameters:                      |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print                                                              |",
  "|------------------------------------------------------------------------------|",
  "|iopr(4) - Print a Table of Aqueous Species Concentrations, Activities, etc.:  |",
  "|  [ ] (-3) Omit species with molalities < 1.e-8                               |",
  "|  [ ] (-2) Omit species with molalities < 1.e-12                              |",
  "|  [ ] (-1) Omit species with molalities < 1.e-20                              |",
  "|  [x] ( 0) Omit species with molalities < 1.e-100                             |",
  "|  [ ] ( 1) Include all species                                                |",
  "|------------------------------------------------------------------------------|",
  "|iopr(5) - Print a Table of Aqueous Species/H+ Activity Ratios:                |",
  "|  [ ] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print cation/H+ activity ratios only                               |",
  "|  [x] ( 2) Print cation/H+ and anion/H+ activity ratios                       |",
  "|  [ ] ( 3) Print ion/H+ activity ratios and neutral species activities        |",
  "|------------------------------------------------------------------------------|",
  "|iopr(6) - Print a Table of Aqueous Mass Balance Percentages:                  |",
  "|  [ ] (-1) Don't print                                                        |",
  "|  [x] ( 0) Print those species comprising at least 99% of each mass balance   |",
  "|  [ ] ( 1) Print all contributing species                                     |",
  "|------------------------------------------------------------------------------|",
  "|iopr(7) - Print Tables of Saturation Indices and Affinities:                  |",
  "|  [ ] (-1) Don't print                                                        |",
  "|  [x] ( 0) Print, omitting those phases undersaturated by more than 10 kcal   |",
  "|  [ ] ( 1) Print for all phases                                               |",
  "|------------------------------------------------------------------------------|",
  "|iopr(8) - Print a Table of Fugacities:                                        |",
  "|  [ ] (-1) Don't print                                                        |",
  "|  [x] ( 0) Print                                                              |",
  "|------------------------------------------------------------------------------|",
  "|iopr(9) - Print a Table of Mean Molal Activity Coefficients:                  |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print                                                              |",
  "|------------------------------------------------------------------------------|",
  "|iopr(10) - Print a Tabulation of the Pitzer Interaction Coefficients:         |",
  "|  [ ] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print a summary tabulation                                         |",
  "|  [x] ( 2) Print a more detailed tabulation                                   |",
  "|------------------------------------------------------------------------------|",
  "|iopr(17) - PICKUP file format (\"W\" or \"D\"):                                   |",
  "|  [x] ( 0) Use the format of the INPUT file                                   |",
  "|  [ ] ( 1) Use \"W\" format                                                     |",
  "|  [ ] ( 2) Use \"D\" format                                                     |",
  "|------------------------------------------------------------------------------|",
  "|Iodb Debugging Print Option Switches (\"( 0)\" marks default choices)           |",
  "|------------------------------------------------------------------------------|",
  "|iodb(1) - Print General Diagnostic Messages:                                  |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print Level 1 diagnostic messages                                  |",
  "|  [ ] ( 2) Print Level 1 and Level 2 diagnostic messages                      |",
  "|------------------------------------------------------------------------------|",
  "|iodb(3) - Print Pre-Newton-Raphson Optimization Information:                  |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print summary information                                          |",
  "|  [ ] ( 2) Print detailed information (including the beta and del vectors)    |",
  "|  [ ] ( 3) Print more detailed information (including matrix equations)       |",
  "|  [ ] ( 4) Print most detailed information (including activity coefficients)  |",
  "|------------------------------------------------------------------------------|",
  "|iodb(4) - Print Newton-Raphson Iteration Information:                         |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print summary information                                          |",
  "|  [ ] ( 2) Print detailed information (including the beta and del vectors)    |",
  "|  [ ] ( 3) Print more detailed information (including the Jacobian)           |",
  "|  [ ] ( 4) Print most detailed information (including activity coefficients)  |",
  "|------------------------------------------------------------------------------|",
  "|iodb(6) - Print Details of Hypothetical Affinity Calculations:                |",
  "|  [x] ( 0) Don't print                                                        |",
  "|  [ ] ( 1) Print summary information                                          |",
  "|  [ ] ( 2) Print detailed information                                         |",
  "|------------------------------------------------------------------------------|",
  "|Numerical Parameters                                                          |",
  "|------------------------------------------------------------------------------|",
  "| Beta convergence tolerance      | 0.00000E+00| (tolbt)                       |",
  "| Del convergence tolerance       | 0.00000E+00| (toldl)                       |",
  "| Max. Number of N-R Iterations   |   0        | (itermx)                      |",
  "|------------------------------------------------------------------------------|",
  "|Ordinary Basis Switches (for numerical purposes only)    | (nobswt)           |",
  "|------------------------------------------------------------------------------|",
  "|Replace |None                                            | (uobsw(1,n))       |",
  "|   with |None                                            | (uobsw(2,n))       |",
  "|------------------------------------------------------------------------------|",
  "|Sat. flag tolerance     | 0.00000E+00| (tolspf)                               |",
  "|------------------------------------------------------------------------------|",
  paste0("|Aq. Phase Scale Factor  |",
         format(sprintf("%.5E", as.numeric(aq_scale)), width=12, justify="right"),
         "| (scamas)                               |"),
  "|------------------------------------------------------------------------------|",
  "|End of problem                                                                |",
  "|------------------------------------------------------------------------------|", sep="\n")


  this_file <- paste0(eq3.header1, eq3.samplename, eq3.header2,
                      eq3.temperature, eq3.header3, eq3.density,
                      eq3.header4, eq3.cb_block, eq3.header5,
                      redox_block, eq3.header6, aqueous_block,
                      eq3.ender1, alter_block, eq3.ender2, eq3.ender3,
                      collapse = "")
    
  write(this_file, paste0(input_dir, "/", eq3.filename), append=FALSE)

  return(warned_about_redox_column)
    
}

# load packages
suppressMessages({
  library(CHNOSZ)
  library(MASS)
  library(dplyr)
  library(comprehenr)
  library(stringr)
  library(pracma)
})

known_oxstates <- c("H"="+", "O"="-2", "F"="-",
                    "Cl"="-", "Na"="+", "Li"="+",
                    "K"="+", "Ca"="+2", "Mg"="+2", "Z"="+")#,
#                   "Si"="+4", "Al"="+3") # useful for aluminosilicates

############ Helper functions

# print messages if 'verbose' setting >= vlevel of message.
vmessage <- function(m, vlevel, verbose){
  if(verbose >= vlevel){
    print(m)
  }
}


get_lcm <- function(vector){
  # get least common multiple of a vector of numbers
  # e.g., get_lcm(c(1, 4, 6, 3)) will return 12
  for(i in 1:(length(vector)-1)){
    if(i == 1){
      result <- pracma::Lcm(vector[i], vector[i+1])
    }else{
      result <- pracma::Lcm(result, vector[i+1])
    }
  }
  return(result)
}


format_pseudoelement_name_R <- function(e){
    
  # Format a pseudoelement name
  # E.g., "Fejiip" -> "Fe+2"
  # This is the R version of an analagous python function in MassTransfer.py

  if(nchar(e) > 2){
    e_split_list <- strsplit(e, split = "j")[[1]]
        
    if(str_sub(e_split_list[2], -1)  == "p"){
      charge_sign <- "+"
    }else if(str_sub(e_split_list[2], -1) == "n"){
      charge_sign <- "-"
    }else if(str_sub(e_split_list[2], -1) == "z"){
      charge_sign <- ""
    }else{
      stop("ERROR in format_pseudoelement_name_R(): charge sign is not recognized")
    }
        
    if(charge_sign != ""){
      charge_magnitude_roman <- toupper(str_sub(e_split_list[2],1,-2))
      charge_magnitude <- as.numeric(as.roman(charge_magnitude_roman))
    }else{
      charge_magnitude <- 0
    }
        
    formatted_elem_name <- paste0(e_split_list[1], charge_sign, charge_magnitude)
        
  }else{
    formatted_elem_name <- e
  }
        
  return(formatted_elem_name)
}


# function for inserting a row at index r while shifting other rows down
insertRow <- function(existingDF, newrow, r) {
  if(r < nrow(existingDF)){
    existingDF[seq(r+1,nrow(existingDF)+1),] <- existingDF[seq(r,nrow(existingDF)),]
    existingDF[r,] <- newrow
    return(existingDF)
  }else{
    return(rbind(existingDF, newrow))
  }
}

# checks if sp in a dissrxn all match strict basis names
all_in_strict_basis <- function(s, strict_basis_names, fixed_species){
  s <- s[c(FALSE, TRUE)]
  s <- s[2:length(s)]
  s <- s[!s %in% fixed_species]
  return(all(s %in% strict_basis_names))
}

# function to vectorize all_in_strict_basis()
split_and_check_dissrxn <- function(dissrxn, strict_basis_names, fixed_species){
  s <- str_split(dissrxn, " ")
  s <- unlist(lapply(s, all_in_strict_basis, strict_basis_names, fixed_species))
  return(s)
}

# order thermo_df to put strict basis species in the front, aux basis species in
# the middle (and sort them to prevent EQ3 errors), and everything else at the
# end.
order_thermo_df <- function(thermo_df, fixed_species, verbose){
    
  basis_entries <- filter(thermo_df, tag=="basis")
  aux_entries   <- filter(thermo_df, tag=="aux")
  other_entries <- filter(thermo_df, tag!="basis" & tag!="aux")
    
  aux_entries_with_only_strict <- aux_entries[split_and_check_dissrxn(aux_entries[, "dissrxn"], basis_entries[, "name"], fixed_species), ]
  aux_entries_with_other_aux   <- aux_entries[!split_and_check_dissrxn(aux_entries[, "dissrxn"], basis_entries[, "name"], fixed_species), ]
  aux_entries_with_strict_aux <- aux_entries_with_other_aux[split_and_check_dissrxn(aux_entries_with_other_aux[, "dissrxn"], c(aux_entries_with_only_strict[, "name"], basis_entries[, "name"]), fixed_species), ]
    
  if(!identical(aux_entries_with_other_aux[, "dissrxn"], character(0))){
    aux_entries_with_nonstrict_aux <- aux_entries_with_other_aux[!split_and_check_dissrxn(aux_entries_with_other_aux[, "dissrxn"], c(aux_entries_with_only_strict[, "name"], basis_entries[, "name"]), fixed_species), ]
  }else{
    aux_entries_with_nonstrict_aux <- data.frame()
  }
    
  if(nrow(aux_entries_with_nonstrict_aux) > 0){
    # sort aux species with nonstrict aux so that their order of 
    # declaration won't cause EQPT errors.
    counter <- 0
    max_counter_steps <- 10
    while(counter < max_counter_steps){
      counter <- counter + 1
      previous_state <- aux_entries_with_nonstrict_aux[,"name"]
      for(i in 1:nrow(aux_entries_with_nonstrict_aux)){
        # for each auxiliary species with other aux species in its dissrxn...
        # get s, a vector of containing species in its dissxn
        s <- str_split(aux_entries_with_nonstrict_aux[i, "dissrxn"], " ")[[1]]
        s <- s[2:length(s)]
        s <- s[!s %in% fixed_species]
        s <- s[!s %in% c(aux_entries_with_nonstrict_aux[i, "name"])] # exclude itself
          
        for(sp in s){
          # for each species in the dissrxn...
          for(ii in 1:nrow(aux_entries_with_nonstrict_aux)){
            # for each row in the nonstrict aux df...
              
            if(sp == aux_entries_with_nonstrict_aux[ii,"name"]){
              # if the species is in the nonstrict aux df,
              # copy the original aux species directly after the aux species in
              # its dissrxn.
              if(i < ii){
                  # if the original aux species is in a row before the aux species
                  # in its dissrxn, reorder it.
                  
#                   print("Original aux species:")
#                   print(aux_entries_with_nonstrict_aux[i, "name"])
#                   print("... the aux species in its dissrxn:")
#                   print(aux_entries_with_nonstrict_aux[ii, "name"])
#                   print("The i's")
#                   print(i)
#                   print(ii)

                  aux_entries_with_nonstrict_aux <- insertRow(aux_entries_with_nonstrict_aux, aux_entries_with_nonstrict_aux[i, ], ii+1)

                  # and delete the original row
                  aux_entries_with_nonstrict_aux <- aux_entries_with_nonstrict_aux[-c(i), ]
              }
            }
          }
        }
      }
        
      #print(aux_entries_with_nonstrict_aux[, "name"])
        
      if(all(aux_entries_with_nonstrict_aux[,"name"] == previous_state)){
        break
      }
      previous_state <- aux_entries_with_nonstrict_aux[,"name"]
      
    }
    if(counter >= max_counter_steps){
      m <- paste("Warning: Could not automatically re-order the auxiliary basis species",
                 paste(aux_entries_with_nonstrict_aux[,"name"], collapse=", "), ". This might happen if there are",
                 "many interdependencies of auxiliary basis species in their dissociation reactions.")
      vmessage(m, 1, verbose)
    }
  
  }
    
  thermo_df <- rbind(basis_entries, aux_entries_with_only_strict,
                     aux_entries_with_strict_aux, aux_entries_with_nonstrict_aux,
                     other_entries)

  return(thermo_df)
}


# helper function from Jeff Dick's CHNOSZ
# to retrieve the coefficients of reactions to form the species from the basis species
species.basis <- function(species=get("thermo", CHNOSZ)$species$ispecies) {
  # current basis elements
  bmat <- basis.elements()
  tbmat <- t(bmat)
  # what are the elements?
  belem <- rownames(tbmat)
  # get the species makeup into a matrix
  mkp <- as.matrix(sapply(makeup(species, count.zero=TRUE), c))
  # the positions of the species elements in the basis elements
  ielem <- match(rownames(mkp), belem)
  # the elements of the species must be contained by the basis species
  if(any(is.na(ielem))) stop(paste("element(s) not in the basis:", 
    paste(rownames(mkp)[is.na(ielem)], collapse=" ")))
  # the positions of the basis elements in the species elements
  jelem <- match(belem, rownames(mkp))
  # keep track of which ones are NA's; 
  # index them as one here but turn them to zero later
  ina <- is.na(jelem)
  jelem[ina] <- 1
  # now put the species matrix into the same order as the basis
  mkp <- mkp[jelem, , drop=FALSE]
  # fill zeros for any basis element not in the species
  mkp[ina, ] <- 0
  # solve for the basis coefficients and transpose
  nbasis <- t(apply(mkp, 2, function(x) solve(tbmat, x)))
  # very small numbers are probably a floating point artifact
  # can cause problems in situations where zeros are needed
  # (manifests as issue in longex("phosphate"), where which.balance()
  #  identifies H2O as conserved component)
  # 20140201 set digits (to R default) becuase getOption("digits") is changed in knitr
  out <- zapsmall(nbasis, digits=7)
  # add names of species and basis species
  colnames(out) <- colnames(tbmat)
  # add names of species only if it was a character argument
  if(all(is.character(species))) rownames(out) <- species
  return(out)
} 

                    
# modified version of subcrt() that only performs balancing
subcrt_bal <- function(ispecies, coeff){
    
  thermo <- get("thermo", CHNOSZ)
  species <- as.character(thermo$OBIGT$name[ispecies])
  state <- as.character(thermo$OBIGT$state[ispecies])
    
  # the mass balance; should be zero for a balanced reaction
  mss <- makeup(ispecies, coeff, sum=TRUE)

  # take out very small numbers
  mss[abs(mss) < 1e-7] <- 0
  # report and try to fix any non-zero mass balance
  if(any(mss!=0)) {
    # the missing composition: the negative of the mass balance
    miss <- -mss
    # drop elements that are zero
    miss <- miss[miss!=0]
    # look for basis species that have our compositoin
    tb <- thermo$basis

    if(all(names(miss) %in% colnames(tb)[1:nrow(tb)])) {
      # the missing composition as formula
      ft <- as.chemical.formula(miss)
      # the basis species needed to supply it
      bc <- species.basis(ft)
      # drop zeroes
      bc.new <- bc[,(bc[1,]!=0),drop=FALSE]
      bc <- bc.new
      ispecies.new <- tb$ispecies[match(colnames(bc),rownames(tb))]
      b.species <- thermo$OBIGT$formula[ispecies.new]
      newspecies <- c(ispecies, tb$ispecies[match(colnames(bc), rownames(tb))])
      newcoeff <- c(coeff, as.numeric(bc[1, ]))
      return(list('newspecies'=newspecies, 'newcoeff'=newcoeff))
    }
  } else {
    return(list('newspecies'=ispecies, 'newcoeff'=as.numeric(coeff)))
  }
}

# print messages if 'verbose' setting >= vlevel of message.
vmessage <- function(m, vlevel, verbose){
  if(verbose >= vlevel){
    print(m)
  }
}


# function to return 0 if a value is NA
check_get <- function(val){
  ifelse(is.na(val), 0, val)
}


get_oxstate <- function(makeup_list){
    
  ifelse(length(setdiff(names(makeup_list), names(known_oxstates))) == 1,
  {
  ox_state <- c(- check_get(makeup_list["F"])*(-1) -
              check_get(makeup_list["Cl"])*(-1) -
              check_get(makeup_list["H"]) -
              check_get(makeup_list["Li"]) -
              check_get(makeup_list["K"]) -
              check_get(makeup_list["Na"]) -
              check_get(makeup_list["Ca"])*(2) -
              check_get(makeup_list["Mg"])*(2) -
#               check_get(makeup_list["Si"])*(4) - # useful for aluminosilicates
#               check_get(makeup_list["Al"])*(3) - # useful for aluminosilicates
              check_get(makeup_list["O"])*(-2) +
              check_get(makeup_list["Z"]))
  ox_state <- ox_state/check_get(makeup_list[setdiff(names(makeup_list), names(known_oxstates))])
  ox_state <- ifelse(ox_state %% 1 == 0, ox_state, NA) # filter out results with non-integer oxidation states
  names(ox_state) <- setdiff(names(makeup_list), names(known_oxstates))
  return(ox_state)
  },
  {
   return(NA)
  })
}


# function to print charge (e.g. a charge of +1 is displayed as "+", a charge of -2 is displayed as "-2")
format_charge <- function(charge){
  sign <- ifelse(charge >= 0, "+", "-")
  mag <- ifelse(abs(charge) == 1, "", as.character(abs(charge)))

  sign <- ifelse(charge == 0, "", sign)
  mag <- ifelse(charge == 0, "", mag)

  return(paste0(sign, mag))
}


errcheck <- function(expr, me="", mw="", verbose){
  tryCatch(expr,
    error = function(e){
      if(me != ""){
        vmessage(paste0("An error occurred:\n", me, "Additional detail:\n", e), 1, verbose)
        stop()
      }else{
        vmessage(paste0("An error occurred:\n", e), 1, verbose)
        stop()
      }
            
      },
      warning = function(w){
        if(mw != ""){
          print(paste0("A warning occurred:\n", mw, "Additional detail:\n", w), 1, verbose)
        }else{
          print(paste0("A warning occurred:\n", w), 1, verbose)
        }
      }
  )
}


match_basis_comp <- function(sp_elems, elem){
  if(elem %in% sp_elems){
    match <- all(sp_elems %in% unique(c(elem, "H", "O", "Z")))
  }else{
    match <- FALSE
  }
  return(match)
}




################################ get_dissrxn

### INPUT EXAMPLE
# sp_name <- "tyrosine"
# # Preferred basis species for elements
# # (Not all elements have to be specified)
# basis_pref <- c("C"="HCO3-", "N"="NH4+")
# HOZ_balancers <- c("H+", "O2", "H2O") # might be data0-specific (e.g., "O2(g)")
# thermo_df has to be the entire thermo datasheet.
#   Needed to determine whether aux species are better than strict basis depending on ox state.
#   If NULL, just uses strict basis species, or what it determines to be strict basis.

get_dissrxn <- function(sp_name, redox_elem_states, basis_pref=c(), aux_pref=c(),
                        HOZ_balancers=c("H+", "O2", "H2O"),
                        thermo_df=NULL, verbose=2){
    
  if(length(sp_name) > 1 & length(unique(sp_name)) == 1){
    sp_name = unique(sp_name)
  }
    
  names(sp_name) <- sp_name
    
  if(length(sp_name) > 0){
    # get a vector of elements that make up the (non-basis) species
    basis_elem <- (function (x) setdiff(names(unlist(makeup(x))), c("H", "O", "Z"))) (thermo_df[, "formula_modded"])             
    basis_elem <- c(basis_elem, names(basis_pref))    
  }else{
    # if there are no species, define basis list in dissrxns and exit the function
    dissrxns <- list(basis_list = basis_pref)
    return(dissrxns)
  }
       
  basis_elem <- unique(basis_elem)
  
  # This part starts the process of finding new basis species to represent elements
  # when they become redox-isolated. For example, finding new strict basis
  # species for S-2 and S+6 if sulfur becomes redox-isolated.
  # EQ3/6 basis species must be aqueous (or gaseous, as with O2(g)).
  sp <- thermo_df %>% filter(!(state %in% c("cr", "cr2", "cr3", "cr4", "cr5", "liq")))
  #sp <- thermo_df

  sp_formula <- sp$formula_modded
  sp_formula_makeup <- makeup(sp_formula)
  names(sp_formula_makeup) <- sp$name
                   
  # loop through each element and assign preferred basis species (if supplied)
  # or automatically choose compatible basis species
  basis_list <- list()
       
  for(elem in basis_elem){
    # if a preferred basis species exists for this element, assign it and move to next element
    if(elem %in% names(basis_pref)){
      # print(elem)
      # print(basis_pref[elem])
      basis_list[[elem]] <- c(info(info(basis_pref[elem]), check.it=F)$name)
      names(basis_list[[elem]]) <- basis_pref[elem]
      next
    }

    # get index of species that fulfill requirements of EQ3's definition of a basis species for this element
    idx <- unlist(lapply(lapply(sp_formula_makeup, names), match_basis_comp, elem=elem))

    # provide a vector of potential basis species for this element
    basis_list[[elem]] <- sp$name[idx]
    names(basis_list[[elem]]) <- sp$name[idx]
      
    # get formula makeup of potential basis species
    frm_mkup <- lapply(unlist(lapply(lapply(lapply(basis_list[[elem]], FUN=info), FUN=info), `[`, "formula")), makeup)
      
    # if possible, narrow down this list to basis species with a matching element abundance of 1
    abund1 <- unlist(lapply(frm_mkup, function(x) x[elem]==1))
    if(sum(abund1 != 0)){
      # assign narrowed list of matches to basis list
      basis_list[[elem]] <-  unlist(basis_list[[elem]][abund1])
    }

    # filter out species with "[" in the name (e.g. "[-CH3]"). These kinds of groups are in CHNOSZ's OBIGT.
    basis_list[[elem]] <-  unlist(basis_list[[elem]][!grepl("\\[", names(basis_list[[elem]]))])

    # error handling in case a suitable basis species cannot be found
    errcheck(length(basis_list[[elem]]) == 0, me=paste0("A suitable basis species could be found to represent the element ", elem, "."))
  }
                            
  # further narrow down the list of potential basis species by grabbing the basis species
  # with the fewest elements+charge from available basis species. In the end there should
  # only be one basis species assigned to each element.
                            
  # check whether basis species in the basis_list are actually given as basis
  # species in thermo_df.
  elements_without_basis <- c()
  for(elem in names(basis_list)){
    if(length(basis_list[[elem]]) == 0){
      elements_without_basis <- c(elements_without_basis, elem)
    }
  }
                      
  if(length(elements_without_basis) > 0){
      
    # Discard non-basis species containing elements that do not have a
    # representative basis species
    sp_all <- thermo_df
    sp_all_formula <- sp_all$formula_modded
    sp_all_formula_makeup <- makeup(sp_all_formula)
    names(sp_all_formula_makeup) <- sp_all$name
    sp_all_elem_names <- lapply(sp_all_formula_makeup, names)
    
    problem_sp = c()
    for(ewb in elements_without_basis){
      for(s in names(sp_all_elem_names)){
        if(ewb %in% sp_all_elem_names[[s]]){
          problem_sp <- c(problem_sp, s)
        }
      }
    }
    problem_sp <- unique(problem_sp)

    for(ewb in elements_without_basis){
      basis_list[[ewb]] <- NULL
      basis_elem <- basis_elem[basis_elem != ewb]
    }
    thermo_df <- thermo_df %>% filter(!(name %in% problem_sp))
      
    rm_i <- c()
    for(i in 1:length(sp_name)){
      if(sp_name[[i]] %in% problem_sp){
        rm_i <- c(rm_i, -i)
      }
    }
    sp_name <- sp_name[rm_i]
    
    elements_without_basis_formatted <- c()
    for(e in elements_without_basis){
      elements_without_basis_formatted <- c(elements_without_basis_formatted, format_pseudoelement_name_R(e))
    }

    msg <- paste("Warning: The following elements (or oxidation states)",
                 "appear in chemical species but do not have representative",
                 "basis species:", paste(elements_without_basis_formatted, collapse=", "),
                 ". Species that contain these:", paste(problem_sp, collapse=", "),
                 ". These species will be excluded from the speciation...")
    print(msg)
      
  }else{
    problem_sp <- c()
  }
                            
  simplest_basis <- c()
  for(elem in basis_elem){
    form <- lapply(info(info(basis_list[[elem]]))$formula, makeup)
    sums <- unlist(lapply(lapply(form, abs), sum))
    idx <- which(sums==min(sums))
    if(length(idx) > 1){
      idx <- idx[1]
    }
      
    simplest_basis[elem] <- basis_list[[elem]][idx]
  }

  dissrxns <- lapply(sp_name, spec_diss, simplest_basis, sp_formula_makeup,
                     HOZ_balancers, redox_elem_states, aux_pref,
                     thermo_df, verbose)

  names(dissrxns) <- sp_name

  dissrxns[["basis_list"]] <- simplest_basis
  dissrxns[["rejected_species"]] <- problem_sp
  dissrxns[["thermo_df_modified"]] <- thermo_df
        
  return(dissrxns)

}

# supply a species name, get a dissrxn.
# (meant to lapply this over all species names)
spec_diss <- function(sp, simplest_basis, sp_formula_makeup, HOZ_balancers,
                      redox_elem_states, aux_pref, thermo_df=NULL, verbose=2){
    
  # determine a balanced dissociation reaction into basis species

  # get the elemental composition
  comp <- makeup(thermo_df[thermo_df["name"]==sp, "formula_modded"][1])
    
  # get the elements that are not H, O, Z (charge)
  basis_elem <- setdiff(names(comp), c("H", "O", "Z"))
    
  # Instantiate a list of chosen basis species and their coeffs in the dissrxns.
  # Start with strict basis species only. E.g., if SO4-2 is a strict basis species:
  # Pb(HS)3-, chosen_basis$Pb is Pb+2:1 and chosen_basis$S is SO4-2:3
  # In the code below, auxiliary basis species can be chosen instead:
  # Pb(HS)3-, chosen_basis$Pb is Pb+2:1 and chosen_basis$S is HS-:3
  chosen_basis <- list()
    
  # Check whether an auxiliary basis species given in thermo_df would work
  # better than a strict basis species.

  if(!is.null(thermo_df)){
      
    sp_formula_ox = thermo_df[thermo_df["name"]==sp, "formula_ox_modded"][1]

    if(sp_formula_ox=="nan"){
      # Triggers when there is no value given in the formula_ox column in
      # thermo_df for this species.
        
      basis(c(unlist(simplest_basis), "H+")) # TODO: this may fail depending on the strict basis species within thermo_df
      out <- subcrt(c(sp), c(-1))

      coeffs <- out$reaction$coeff
      names <- out$reaction$name
      names[names == "water"] <- "H2O" # prevent CHNOSZ from renaming 'H2O' (name req. by EQ3) to 'water'
        
      for(i in 1:length(coeffs)){
        if(i == 1){
          sp_dissrxn <- paste(sprintf("%.4f", round(coeffs[i], 4)), names[i])
        }else{
          sp_dissrxn <- paste(sp_dissrxn, sprintf("%.4f", round(coeffs[i], 4)), names[i])
        }
      }
      
      return(sp_dissrxn)
    }
      
    for(elem in basis_elem){
        
      sp_formula_ox_split <- strsplit(sp_formula_ox, " ")
        
#       print(paste("species:", sp))
#       print(paste("elem:", elem))
#       print(paste("formula ox:", sp_formula_ox))
#       print(paste("formula ox split:", sp_formula_ox_split))
        
      # get the element plus oxidation state from formula ox
      # e.g., turn "2Al+3" into "Al+3"
      # or "0.165Mg+2" to "Mg+2"
      step1 <- sp_formula_ox_split[[1]]
      step2 <- step1[grepl(paste0(elem,"([^a-z]|$)"), step1)]
      step3 <- gsub("^[[:digit:]]+(\\.[[:digit:]]+)?", "", step2)
      sp_ox_elem <- makeup(step3)
      sp_num_elem <- as.numeric(gsub("([0-9]?)[A-Z].*", "\\1", sp_formula_ox_split[[1]][grepl(paste0(elem,"([^a-z]|$)"), sp_formula_ox_split[[1]], perl=T)], perl=T))
      sp_num_elem <- ifelse(is.na(sp_num_elem), 1, sp_num_elem)
      names(sp_num_elem) <- rep(simplest_basis[[elem]], length(sp_num_elem))
      n_elem_in_basis <- sp_formula_makeup[[simplest_basis[elem]]][elem]
      chosen_basis[[elem]] <- sp_num_elem/n_elem_in_basis

      if(elem %in% names(simplest_basis) && elem %in% names(aux_pref)){
        # get oxidation states of this element available in strict and aux basis species
        strict_df = thermo_df %>%
          filter(name == simplest_basis[elem]) %>%
          select(formula_ox_modded)
        aux_df = thermo_df %>%
          filter(name %in% aux_pref[names(aux_pref)==elem]) %>%
          filter(name != sp) %>% # prevents an aux species from dissociating into itself
          select(formula_ox_modded)
        basis_df <- rbind(strict_df, aux_df)
        basis_df["ave_ox_state_of_elem"] <- 0
        basis_formula_ox_split <- lapply(basis_df["formula_ox_modded"], strsplit, " ")$formula_ox_modded
          
        idx <- 1
        for(line in basis_formula_ox_split){
          basis_num_elem <- as.numeric(gsub("([0-9]?)[A-Z].*", "\\1", line[grepl(paste0(elem,"([^a-z]|$)"), line, perl=T)], perl=T))
          basis_num_elem <- ifelse(is.na(basis_num_elem), 1, basis_num_elem)
          basis_ox_elem <- makeup(gsub("^[[:digit:]]+(\\.[[:digit:]]+)?", "", line[grepl(paste0(elem,"([^a-z]|$)"), line, perl=T)]))
          if(length(basis_num_elem) > 1){
            basis_oxstates <- c()
            basis_total_atoms <- c()
            for(i in 1:length(basis_num_elem)){
              if(!("Z" %in% names(basis_ox_elem[[i]]))){
                basis_ox_elem[[i]]["Z"] <- 0
              }
              basis_oxstates <- c(basis_oxstates, basis_ox_elem[[i]]["Z"]*basis_num_elem[i])
              basis_total_atoms <- c(basis_total_atoms, basis_num_elem[i])
            }
            basis_ave_ox_state_of_elem <- sum(basis_oxstates)/sum(basis_total_atoms)
          }else{
            if(!("Z" %in% names(basis_ox_elem))){
              basis_ave_ox_state_of_elem <- 0
            }else{
              basis_ave_ox_state_of_elem <- basis_ox_elem["Z"]
            }

          }
          basis_df[idx, "ave_ox_state_of_elem"] <- basis_ave_ox_state_of_elem
          idx <- idx + 1
        }
        
        # get the oxidation state of the element in the non-basis species
        sp_formula_ox = thermo_df[thermo_df["name"]==sp, "formula_ox_modded"]
        
        # For each oxidation state of this element in the non-basis species,
        # pick the closest strict or aux basis species.
        if(is.list(sp_ox_elem)){
          # Species has an element in two different oxidation states
          # e.g., hastingsite has both Fe+2 and Fe+3

          # When there is more than one instance of this element in the non-basis species,
          # find the basis species with the closest oxidation states and assign.
          chosen_basis_species_vec <- c()
          basis_ave_ox_states <- unlist(basis_df["ave_ox_state_of_elem"]) 
        
          names(basis_ave_ox_states) <- unlist(basis_df["formula_ox_modded"])
          for(i in 1:length(sp_ox_elem)){
            if(!("Z" %in% names(sp_ox_elem[[i]]))){
              sp_ox_elem[[i]]["Z"] <- 0
            }
            chosen_basis_species_vec <- c(chosen_basis_species_vec, names(which.min(abs(basis_ave_ox_states-sp_ox_elem[[i]]["Z"])))[1])
          }

          basis_num_elems <- c()
          for(basis in chosen_basis_species_vec){
            n_elem_in_basis <- sp_formula_makeup[[basis]][elem]
            basis_num_elems <- c(basis_num_elems, n_elem_in_basis)
          }
          names(sp_num_elem) <- chosen_basis_species_vec
          chosen_basis[[elem]] <- sp_num_elem/basis_num_elems
          
            
        }else{
          # Species has an element with one oxidation state
          # e.g., aegerine has Fe+3 (not Fe+3 AND Fe+2)
            
          # Find the basis species with the closest oxidation state to the
          # element inside the non-basis species and assign.
          if(!("Z" %in% names(sp_ox_elem))){
            sp_ox_elem["Z"] <- 0
          }
          basis_ave_ox_states <- unlist(basis_df["ave_ox_state_of_elem"])
          names(basis_ave_ox_states) <-  unlist(basis_df["formula_ox_modded"])
            
          # if there is more than one basis species matching the oxidation state of
          # this element in the non-basis species, just pick the first one, thus the [1].
          # Maybe there is a better way to decide but I'm going with this for now.
          chosen_basis_name <- names(which.min(abs(basis_ave_ox_states-sp_ox_elem["Z"])))[1]
            
          n_elem_in_basis <- sp_formula_makeup[[chosen_basis_name]][elem]
            
          names(sp_num_elem) <- chosen_basis_name
            
          chosen_basis[[elem]] <- sp_num_elem/n_elem_in_basis
          
        }

      }

      # sum together basis species coeffs sharing a name (e.g., c(HS-:1, HS-:1) is summed to c(HS-:2))
      chosen_basis[[elem]] <- tapply(unlist(chosen_basis[[elem]]), names(unlist(chosen_basis[[elem]])), sum)
    }
  }
    
#   print(sp)
#   print("Chosen basis")
#   print(chosen_basis)
    
  # set basis species in CHNOSZ so that a dissociation reaction can be autobalanced
  basis(unique(c(simplest_basis[basis_elem], HOZ_balancers)))

  basis_to_include <- unlist(lapply(chosen_basis, names))
  coeffs_to_include <- unlist(lapply(chosen_basis, `[`))

  isp <- suppressMessages(info(c(sp, basis_to_include)))

  autobalance <- subcrt_bal(isp, c(-1, coeffs_to_include))

  # find least common denominator (LCD) between species that is dissociating and its
  # basis species, then multiply coefficients so that none a non-integer
  # e.g., coefficients c(-1.0000000, 0.5000000, 0.1666667, 1.0000000, -1.0000000)
  # have an LCD of 6, so the new coefficients will be:
  # c(-6.0000000, 3.0000000, 1.0000000, 6.0000000, -6.0000000)
  if(any(abs(autobalance$newcoeff)%%1==0)){ # check if all coefficients are integers...

    fracs = autobalance$newcoeff

    f <- fractions(fracs) # convert decimal fractions to whole fractions
    frac_list <- strsplit(attr(f,"fracs"),"/") # create a list of numerators and denominators

    # convert numerators and denominators to numeric, and assign to independent vectors
    numerators <- c()
    denominators <- c()
    for(i in 1:length(frac_list)){
      frac_list[[i]] <- as.numeric(frac_list[[i]])
      if(length(frac_list[[i]])>1){
        frac_list[[i]][2] <- as.numeric(frac_list[[i]][2])
      }else{
        # if there is no denominator given (for whole numbers), assign 1 as denominator
        frac_list[[i]][2] <- 1
      }
      numerators <- c(numerators, frac_list[[i]][1])
      denominators <- c(denominators, frac_list[[i]][2])
    }

    # find the least common multiple of the denominators
    lcm <- get_lcm(denominators)

    # multiply numerators by the lcm, then divide numerators by denominators to get whole numbers
    numerators <- numerators*lcm
    denominators <- denominators
    coeffs <- numerators/denominators

    coeffs = round(as.numeric(coeffs), 4)
    names(coeffs) = names(autobalance$newcoeff)
    autobalance$newcoeff = coeffs
  }

  
    
  spec_names <- thermo()$OBIGT[autobalance$newspecies, "name"]
    
  spec_names[spec_names == "water"] <- "H2O" # prevent CHNOSZ from renaming 'H2O' (name req. by EQ3) to 'water'
  sp_dissrxn <- autobalance$newcoeff  
    
  names(sp_dissrxn) <- spec_names
    
  sp_dissrxn <- paste(c(rbind(sprintf("%.4f", round(sp_dissrxn, 4)), names(sp_dissrxn))), collapse=" ")
    
  return(sp_dissrxn)
}



                            
suppress_redox_and_generate_dissrxns <- function(thermo_df,
                              water_model,
                              exceed_Ttr,
                              suppress_redox,
                              exclude_category,
                              element_df,
                              fixed_species=c("H2O", "H+", "O2(g)", "water", "e-"),
                              verbose=1){

  # specify molecules to balance H, O, and charge (Z)
  HOZ_balancers <- c("H+", "O2(g)", "H2O") # might be dataset-specific (e.g., "O2(g)")
    
  # remove leading and trailing whitespace from dissrxn and formula_ox columns
  ws_cols <- c("dissrxn", "formula_ox")
  thermo_df[ws_cols] <- lapply(thermo_df[ws_cols], trimws)
    
  # exclude rows based on categories
  if(length(exclude_category) > 0){
    for(cat in names(exclude_category)){
      thermo_df <- thermo_df %>%
        filter(!(!!as.name(cat)) %in% exclude_category[[cat]])
    }
  }
    
  # Ensure that EQ3NR-required species are in thermo_df by marking
  # them as "required" in category 1 of the thermodynamic db CSV.
    
  # get all unique oxidation states of elements in the entire dataset
  elem_ox <- c()
  for(entry in thermo_df$formula_ox){
    entry <- strsplit(entry, " ")[[1]]
    for(elem in entry){
      e <- unlist(strsplit(elem, "[0-9](?=[A-Z])", perl=T))
      e <- e[length(e)]
      elem_ox <- c(elem_ox, e)
    }
  }
  elem_ox <- unique(elem_ox)
  elem_ox = elem_ox[ !elem_ox == 'nan']
    
  # Create pseudoelement names.
  # Fe+3 is formatted as Fejiiip. C-4 is formatted as Fejivn. S0 is formatted as Sjz
  # Element name is separated from charge by 'j' (because no element in the periodic table has a lowercase j)
  # The letter at the end is either p (for positive), n (for negative), or z (for zero)
  # The letters in between j and n/p/z is the magnitude of the charge in roman numerals.
  redox_elem_states <- list()
  for(elem in suppress_redox){
      
    # check for multiple oxidation states for this element in thermo_df$formula_ox
    elem_ox_match <- unlist(lapply(lapply(makeup(elem_ox), FUN=names), `[`, 1)) # remove 'Z' in makeup()
    redox_entry <- c()

    matches <- elem_ox[elem_ox_match == elem]
      
    for(match in matches){
      if(grepl("\\+", match)){
        mag <- tolower(as.roman(as.numeric(strsplit(match, "\\+")[[1]][2])))
        if(is.na(mag)){
          mag <- "i"
        }
        redox_entry[match] <- paste0(elem, "j", mag, "p")
      }else if(grepl("\\-", match)){
        mag <- tolower(as.roman(as.numeric(strsplit(match, "\\-")[[1]][2])))
        if(is.na(mag)){
          mag <- "i"
        }
        redox_entry[match] <- paste0(elem, "j", mag, "n") # n for negative charge
      }else{
        redox_entry[match] <- paste0(elem, "jz") # z for zero charge
      }
    }
    redox_elem_states[[elem]] <- redox_entry

  }
    
  # use element dataframe
  thermo(element = element_df)
    
  # Add oxidation-separated elements to CHNOSZ's database of elements
  # element, state, source, mass, s, n
  for(elem in names(redox_elem_states)){
    for(elem_ox in names(redox_elem_states[[elem]])){
      old <- thermo()$element
      elem_entry <- filter(thermo()$element, element==elem)[1, ] # todo: more elegant solution for getting one matching entry, e.g. in the case of matching Cl
      Xprops <- data.frame(element=unname(redox_elem_states[[elem]][elem_ox]),
                          state=elem_entry[, "state"],
                          source=paste("redox suppression workaround for", elem_ox),
                          mass=elem_entry[, "mass"],
                          s=elem_entry[, "s"],
                          n=elem_entry[, "n"])
      new <- rbind(old, Xprops)
      suppressMessages(thermo(element=new))
    }
  }

  known_species <- to_vec(for(i in 1:length(known_oxstates)) paste0(names(known_oxstates)[i], known_oxstates[i]))
      
  thermo_df["formula_modded"] <- thermo_df["formula"]
  thermo_df["formula_ox_modded"] <- thermo_df["formula_ox"]
                          
  # create pseudoelements and assign to molecular formulae
  if(length(suppress_redox) > 0){

    # loop through species
    for(idx in 1:nrow(thermo_df)){

      species_name <- thermo_df[idx, "name"]
      sp_formula <- thermo_df[thermo_df[, "name"] == species_name, "formula"]
      sp_formula_ox <- thermo_df[thermo_df[, "name"] == species_name, "formula_ox"]

      # the species has no value for 'formula_ox' (the [1] is to have a single value to test vs nan in the case of mineral polymorphs)
      if(sp_formula_ox[1] == "nan"){
        thermo_df[thermo_df[, "name"] == species_name, "formula_modded"] <- sp_formula
        thermo_df[thermo_df[, "name"] == species_name, "formula_ox_modded"] <- sp_formula_ox
        next
      }

      # get makeup and charge of this species
      this_makeup <- makeup(thermo_df[idx, "formula"])
        
      elems <- names(this_makeup)
      charge <- this_makeup["Z"]
      if(is.na(charge)){
        charge <- 0
      }

      # for each element in this species, see if it matches an entry in redox_elem_states
      this_formula <- c()
      for(elem in elems){

        if(elem %in% names(redox_elem_states)){

          # get oxidation state info
          formula_ox <- strsplit(sp_formula_ox, " ")
          names(formula_ox) <- species_name
            
          # assign abundances to each ox elem
          for(elem_ox in formula_ox[[species_name]]){

            # determine the formula coefficient
            this_coeff <- as.numeric(gsub("([0-9]?)[A-Z].*", "\\1", elem_ox, perl=T))
            if(is.na(this_coeff)){
              this_coeff <- 1
            }

            # determine the element
            e <- unlist(strsplit(elem_ox, "[0-9](?=[A-Z])", perl=T))
            e <- e[length(e)]

            this_formula[e] <- this_coeff
            
          }
            
          # create a modified formula_ox column in the modified_thermo_df if there
          # is redox suppression, such that "Fe+2 2Cl-" becomes "Fejiip+2 2Cl-"
          this_formula_modded <- this_formula
          for(ox_elem in names(redox_elem_states)){
            for(ox_state in names(this_formula)){
              if(grepl(paste0(ox_elem,"([^a-z]|$)"), ox_state)){
                  
                # handle positive oxidation states
                splitname <- strsplit(ox_state, "\\+")[[1]]
                if(length(splitname) > 1){
                  ox_charge <- "+"
                }else{
                  # handle negative oxidation states
                  splitname <- strsplit(ox_state, "\\-")[[1]]
                  if(length(splitname) > 1){
                    ox_charge <- "-"
                  }else{
                    ox_charge <- ""
                  }
                }
                
                if(length(splitname) != 1){
                  ox_charge_magnitude <- as.numeric(splitname[2])
                }else{
                  ox_charge_magnitude <- 0
                }

                pseudoelem_ox_charge <- redox_elem_states[[ox_elem]][ox_state]
                if(ox_charge_magnitude !=0){
                  pseudoelem_ox_charge <- paste0(pseudoelem_ox_charge, ox_charge, ox_charge_magnitude)
                }
                
                this_formula_names <- names(this_formula_modded)
                this_formula_names[this_formula_names == ox_state] <- pseudoelem_ox_charge
                names(this_formula_modded) <- this_formula_names
                
              }
            }
          }
            
          to_collapse <- c()
          for(x in names(this_formula_modded)){
            formula_ox_vec <- c(rbind(this_formula_modded[x], x))
            this_formula_ox_modded <- paste(formula_ox_vec[formula_ox_vec!="1"], collapse="")
            to_collapse <- c(to_collapse, this_formula_ox_modded)
          }
          this_formula_ox_modded <- paste(to_collapse, collapse=" ")

          thermo_df[thermo_df[, "name"] == species_name, "formula_ox_modded"] <- this_formula_ox_modded
            
        }
      }
        
      modified_formula <- c()
      previous_elems <- c()

      for(name in names(this_formula)){

        elem <- names(which(sapply(lapply(redox_elem_states, FUN=names), FUN=function(x) name %in% x)))

        if(!identical(elem, character(0))){
          modified_formula[redox_elem_states[[elem]][name]] <- this_formula[name]
        }else{
          e_makeup <- names(makeup(name))
          elem <- e_makeup[!(e_makeup %in% c("Z"))]
          if(elem %in% previous_elems){
            modified_formula[elem] <- modified_formula[elem] + this_formula[name]
          }else{
            modified_formula[elem] <- this_formula[name]
          }
        }
        previous_elems <- c(previous_elems, elem)
      }

                                   
      formula_vec <- c(rbind(names(modified_formula), modified_formula))
      formula <- paste(formula_vec[formula_vec!="1"], collapse="")
                                   
      if(formula==""){
        formula <- thermo_df[idx, "formula_modded"]
      }else{
        formula <- paste0(formula, format_charge(charge))
      }
                                   
      thermo_df[thermo_df[, "name"] == species_name, "formula_modded"] <- formula
    }
  }
                                   
  # reorder thermo_df so that strict basis are first, then aux that depend only
  # on strict basis, then aux that depend on other aux, then everything else.
  # Prevents EQPT errors.
  thermo_df <- order_thermo_df(thermo_df, fixed_species, verbose)
                                   
  thermo_df %>% mutate_if(is.factor, as.character) -> thermo_df
                                   
  # include modified file in CHNOSZ database
  to_mod_OBIGT <- thermo_df[c("name", "abbrv", "formula_modded",
                              "state", "ref1", "ref2", "date",
                              "E_units", "G", "H", "S", "Cp",
                              "V", "a1.a", "a2.b", "a3.c",
                              "a4.d", "c1.e", "c2.f",
                              "omega.lambda", "z.T")]
                                   
  names(to_mod_OBIGT) <- c("name", "abbrv", "formula",
                            "state", "ref1", "ref2", "date",
                            "E_units", "G", "H", "S", "Cp",
                            "V", "a1.a", "a2.b", "a3.c",
                            "a4.d", "c1.e", "c2.f",
                            "omega.lambda", "z.T")

  suppressMessages({
    thermo(OBIGT=thermo()$OBIGT[unique(info(fixed_species)), ]) # replaces the default OBIGT database with user-supplied database
    mod.OBIGT(to_mod_OBIGT, replace=TRUE) # produces a message
    basis(delete=TRUE)
  })
  
                                   
  # begin handling basis preferences
  basis_df <- thermo_df %>%
    filter(tag=="basis")
  aux_df <- thermo_df %>%
    filter(tag=="aux")
                                   
  basis_pref <- basis_df[, "name"]
                                   
  basis_pref_elements <- lapply(lapply(lapply(basis_df[,"formula_modded"], makeup), names), setdiff, c("Z", "O", "H"))

  # handle the possibility of a basis species with more than one non-OH element,
  # e.g., glycine as a basis species has C and N.
  for(i in 1:length(basis_pref_elements)){
      
    if(length(basis_pref_elements[[i]]) > 1){
        
        msg <- paste0("Error during database processing. The strict basis ",
                     "species '", basis_pref[i], "' has more than one ",
                     "element besides O and H. This can be solved by making ",
                     "this species an auxiliary basis species with a dissociation ",
                     "reaction into strict basis species representing the elements ",
                     paste(basis_pref_elements[[i]], collapse=" "))
        stop(msg)

    }
  }
                                   
  names(basis_pref) <- basis_pref_elements
                                   
  aux_pref <- unlist(aux_df[, "name"])
  aux_pref_names <- lapply(lapply(lapply(aux_df[,"formula_modded"], makeup), names), setdiff, c("Z", "O", "H"))

  # Remove aux basis species from the preferred list if they contain more than
  # one element besides O and H.
  #     E.g., remove CN-, OCN-, etc.
  keep <- c()
  for(i in 1:length(aux_pref)){
    if(length(aux_pref_names[[i]])==1){
      keep <- c(keep, i)
    }
  }
  aux_pref <- aux_pref[keep]
  aux_pref_names <- aux_pref_names[keep]
                                   
  if(!identical(aux_pref, character(0))){
    # Also remove aux basis species from the preferred list if they have more than
    # one atom of the same element.
    #     E.g., remove S2-2, S2O3-2, etc.
    keep <- c()
    for(i in 1:length(aux_pref)){
      if(makeup(thermo_df[thermo_df[, "name"]==aux_pref[[i]], "formula_modded"])[aux_pref_names[[i]]] == 1){
        keep <- c(keep, i)
      }
    }
    aux_pref <- aux_pref[keep]
    aux_pref_names <- aux_pref_names[keep]
      
    # Also remove aux basis species from the preferred list if their dissociation
    # reaction includes another aux basis species
    #    E.g., remove H2S (aux) if its dissociation reaction includes HS- (aux) 
    reject <- c()
    if(length(aux_pref) > 0){
      for(i in 1:length(aux_pref)){
        auxd <- strsplit(thermo_df[thermo_df[, "name"]==aux_pref[[i]], "dissrxn"], " ")[[1]]
        auxd <- auxd[3:length(auxd)]
        for(a in aux_pref){
          if(a %in% auxd){
            reject <- c(reject, i)
          }
        }
      }
    }

    if(length(reject)>0){
      reject <- unique(reject)
      aux_pref <- aux_pref[-reject]
      aux_pref_names <- aux_pref_names[-reject]
    }
    names(aux_pref) <- aux_pref_names
      
  }else{
    aux_pref <- list()
    aux_pref_names <- c()
  }
                                   
  # EQ3 has H2O and O2(g) hard-coded as basis species for the
  # elements H and O, respectively.
  basis_pref["H"] <- "H2O"
  basis_pref["O"] <- "O2(g)"
                                   
  # Ensure that each element has a representative strict basis species.
  # If not, assign one from aux species.
  # If that fails, assign one from a valid non-basis species.
  # First check that each element has only one valid basis species.
  #   1. get a vector of ALL elements except for O and H
  all_elements <- lapply(lapply(lapply(thermo_df[,"formula_modded"], makeup), names), setdiff, c("Z", "O", "H"))
  all_elements <- unique(unlist(all_elements))
  #   2. check that all elements are represented by basis species
  elem_need_basis <- setdiff(all_elements, names(basis_pref))
  #   3. check auxiliary basis species to see if any can be used as strict basis for unrepresented elements
  #      and assign to basis_prefs. Remove from aux basis prefs.
  if(length(elem_need_basis) > 0){
    for(elem in elem_need_basis){
      if(elem %in% names(aux_pref)){
        valid_aux <- aux_pref[names(aux_pref) == elem]
        
        basis_pref <- c(basis_pref, valid_aux[1]) # add valid aux to basis prefs. The [1] just selects the first valid aux species if there are multiple. Selection method can probably be improved.
        aux_pref <- aux_pref[aux_pref != valid_aux]
        thermo_df[thermo_df[, "name"] == valid_aux, "tag"] <- "basis"

      }else{
        # Pick a basis species from valid non-basis...
        # The dissociation reaction generator will do this automatically.
      }
    }
  }
                                   
  # get names of species that need dissrxns:
  #  1. non-basis species in the datafile lacking a dissociation reaction
  #  2. non-basis species with incorrect or unbalanced dissociation reactions.
  #     Note: unbalanced dissociation reactions can occur when suppressing redox on element(s).
  #     (e.g., chalcopyrite, CuFeS2, which contains Fe+3, might be written to dissociate into Fe+2.
  #     This creates an unbalanced reaction if iron oxidation states are all different pseudoelements)
  
  # for each dissrxn, determine if unbalanced. If so, flag a thermo_df 'need_dissrxn' column.
  thermo_df[, "regenerate_dissrxn"] <- FALSE
  all_basis_species <- c()
  for(species in thermo_df[, "name"]){
    
    tag <- thermo_df[thermo_df[, "name"] == species, "tag"]
      
    if(tag[1] != "basis"){
      dissrxn <- thermo_df[thermo_df[, "name"] == species, "dissrxn"]
      dissrxn <- strsplit(dissrxn, " ")[[1]] # split the rxn into coeffs and species
      dissrxn_names <- dissrxn[c(FALSE, TRUE)] # get names of reactants and products
      all_basis_species <- c(all_basis_species, dissrxn_names[2:length(dissrxn_names)])
      dissrxn_ispecies <- suppressMessages(info(dissrxn_names))
      dissrxn_coefs <- dissrxn[c(TRUE, FALSE)] # get coeffs of reactants and products
      dissrxn_coefs <- as.numeric(dissrxn_coefs) # convert coeffs from str to numeric

      tryCatch({
        subcrt_bal(dissrxn_ispecies, dissrxn_coefs)
      }, error=function(e){
        thermo_df[thermo_df[, "name"] == species, "regenerate_dissrxn"] <<- TRUE # assign global variable with <<- because this is within the error function
      })
    }
  }
  all_basis_species <- unique(all_basis_species)
                                   
  # check whether there are species in dissociation reactions that are missing or
  # not tagged in the database as 'basis' or 'aux'.
  missing_basis_species <- c()
  species_to_blame <- c()
  species_in_dissrxns_that_are_not_basis <- c()
  for(basis in all_basis_species){
    if(!(basis %in% thermo_df$name) && !(basis %in% fixed_species)){
       missing_basis_species <- c(missing_basis_species, basis)
    }else if(!(basis %in% basis_df$name) && !(basis %in% aux_df$name) && !(basis %in% fixed_species)){
      species_in_dissrxns_that_are_not_basis <- c(species_in_dissrxns_that_are_not_basis, basis)
    }
  }

  if(length(missing_basis_species) == 1){
    if(is.na(missing_basis_species)){
      missing_basis_species = c()
    }
  }
                                   
  if(length(missing_basis_species) > 0){
    for(species in thermo_df[, "name"]){
      tag <- thermo_df[thermo_df[, "name"] == species, "tag"]
      if(length(tag)>1){
        tag <- tag[1]
      }
      if(tag != "basis"){
        dissrxn <- thermo_df[thermo_df[, "name"] == species, "dissrxn"]
        dissrxn <- strsplit(dissrxn, " ")[[1]] # split the rxn into coeffs and species
        dissrxn_names <- dissrxn[c(FALSE, TRUE)] # get names of reactants and products
        for(n in dissrxn_names){
          if(n %in% missing_basis_species){
            species_to_blame <- c(species_to_blame, species)
          }
        }
      }
    }
    species_to_blame <- unique(species_to_blame)

    msg_missing_basis <- paste("The following species appear in dissociation",
      "reactions but are not included in the database: [", paste(missing_basis_species, collapse=", "),
      "]. These missing species are found in the dissociation reactions of [",
      paste(species_to_blame, collapse=", "), "].")
  }else{
    msg_missing_basis <- ""
  }
  
  species_to_blame_have_bad_basis <- c()
  if(length(species_in_dissrxns_that_are_not_basis) > 0){
    for(species in thermo_df[, "name"]){
      tag <- thermo_df[thermo_df[, "name"] == species, "tag"]
      if(length(tag)>1){
        tag <- tag[1]
      }
      if(tag != "basis"){
        dissrxn <- thermo_df[thermo_df[, "name"] == species, "dissrxn"]
        dissrxn <- strsplit(dissrxn, " ")[[1]] # split the rxn into coeffs and species
        dissrxn_names <- dissrxn[c(FALSE, TRUE)] # get names of reactants and products
        dissrxn_names <- dissrxn_names[2:length(dissrxn_names)]
        for(n in dissrxn_names){
          if(n %in% species_in_dissrxns_that_are_not_basis){
            species_to_blame_have_bad_basis <- c(species_to_blame_have_bad_basis, species)
          }
        }
      }
    }
    species_to_blame_have_bad_basis <- unique(species_to_blame_have_bad_basis)
    msg_not_basis <- paste("The following species appear in dissociation",
      "reactions but are not tagged as strict or auxiliary basis species: [",
      paste(species_in_dissrxns_that_are_not_basis, collapse=", "),
      "]. These non-basis species are found in the dissociation reactions of [",
      paste(species_to_blame_have_bad_basis, collapse=", "), "].")
  }else{
    msg_not_basis <- ""
  }
  if(length(missing_basis_species) > 0 | length(species_in_dissrxns_that_are_not_basis) > 0){
    stop(paste("One or more errors were encountered during database processing.",
               msg_missing_basis, msg_not_basis))
  }

  df_needs_dissrxns <- thermo_df %>%
    filter(tag != "basis") %>%
    filter(regenerate_dissrxn == TRUE)
      
  if(nrow(df_needs_dissrxns) > 0){
    if(length(suppress_redox) == 0){
      needs_dissrxns_message <- paste("Balanced dissociation reactions are missing for species:",
                                      paste(unique(unlist(df_needs_dissrxns["name"])), collapse=", "))
    }else{
      needs_dissrxns_message <- paste("Balanced and/or redox-suppressed dissociation reactions are missing for species:",
                                      paste(unique(unlist(df_needs_dissrxns["name"])), collapse=", "))
    }
      
    vmessage(needs_dissrxns_message, 1, verbose)
    vmessage("Generating dissociation reactions for these species using strict and auxiliary basis species containing a maximum of one atom of one element besides O and H...", 1, verbose)
  }
     
  # generate dissociation reactions
  dissrxns <- get_dissrxn(sp_name=unlist(df_needs_dissrxns["name"]),
                                           basis_pref=basis_pref,
                                           aux_pref=aux_pref,
                                           HOZ_balancers=HOZ_balancers,
                                           thermo_df=thermo_df,
                                           verbose=verbose,
                                           redox_elem_states=redox_elem_states)
                                   
  # Produce a warning message about which dissrxns were (re)generated and what they are.
  if("thermo_df_modified" %in% names(dissrxns)){
    thermo_df <- dissrxns[["thermo_df_modified"]]
  }
                                   
  
  if(nrow(df_needs_dissrxns) > 0){

    names <- df_needs_dissrxns[["name"]]
    names <- names[! names %in% dissrxns[["rejected_species"]]]
    generated_dissrxns <- dissrxns[names]
      
    nonbasis_idx <- unlist(lapply(lapply(lapply(generated_dissrxns, strsplit, " "), `[[`, 1), FUN=function(x) x[2] != x[4])) # x[2] != x[4] refers to picking dissrxns that do not look something like -1.0000 HCO3- 1.0000 HCO3-

    if(!is.null(nonbasis_idx)){
      basis_idx <- !nonbasis_idx
      nonbasis_names <- names(nonbasis_idx)[nonbasis_idx]
      nonbasis_names <- unique(nonbasis_names)
      basis_names <- names(basis_idx)[basis_idx]

      vmessage(paste(nonbasis_names, ":", generated_dissrxns[nonbasis_names], " \n"), 1, verbose)
                    
      if(!identical(basis_names, character(0))){
        vmessage(paste("Species that have been converted into strict basis:", paste(unique(basis_names), collapse=", ")), 1, verbose)
      }
    }
    # replace dissrxns with any regenerated dissrxns
    for(name in names){
        
#       print(name)
#       print(dissrxns[[name]])
#       print(thermo_df[thermo_df["name"]==name, "dissrxn"])
        
      thermo_df[thermo_df["name"]==name, "dissrxn"] <- dissrxns[[name]]
    }
  }
#   print(tail(thermo_df))


  # restore thermo()
  to_mod_OBIGT <- thermo_df[c("name", "abbrv", "formula",
                              "state", "ref1", "ref2", "date",
                              "E_units", "G", "H", "S", "Cp",
                              "V", "a1.a", "a2.b", "a3.c",
                              "a4.d", "c1.e", "c2.f",
                              "omega.lambda", "z.T")]
                                  
  suppressMessages({
    thermo(OBIGT=thermo()$OBIGT[unique(info(fixed_species)), ]) # replaces the default OBIGT database with user-supplied database
    mod.OBIGT(to_mod_OBIGT, replace=TRUE) # produces a message
  })
                                  
  thermo_df[is.na(thermo_df)]=''
                                  
  out_list = list("thermo_df"=thermo_df, "dissrxns"=dissrxns, "basis_pref"=basis_pref)

  return(out_list)
}

# hidden functions in Jeff Dick's CHNOSZ package

info.character <- function(species, state=NULL, check.protein=TRUE) {
  # returns the rownumbers of thermo()$OBIGT having an exact match of 'species' to
  # thermo()$OBIGT$[species|abbrv|formula] or NA otherwise
  # a match to thermo()$OBIGT$state is also required if 'state' is not NULL

  # (first occurence of a match to species is returned otherwise)
  thermo <- get("thermo", CHNOSZ)
  # find matches for species name, abbreviation or formula
  matches.species <- thermo$OBIGT$name==species | thermo$OBIGT$abbrv==species | thermo$OBIGT$formula==species
  # since thermo()$OBIGT$abbrv contains NAs, convert NA results to FALSE
  matches.species[is.na(matches.species)] <- FALSE
  # turn it in to no match if it's a protein in the wrong state
  ip <- pinfo(species)
  if(any(matches.species) & !is.na(ip) & !is.null(state)) {
    matches.state <- matches.species & grepl(state, thermo$OBIGT$state)
    if(!any(matches.state)) matches.species <- FALSE
  }
  # no match, not available
  if(!any(matches.species)) {
    # unless it's a protein
    if(check.protein) {
      # did we find a protein? add its properties to OBIGT
      if(!is.na(ip)) {
        # here we use a default state from thermo()$opt$state
        if(is.null(state)) state <- thermo$opt$state
        # add up protein properties
        eos <- protein.OBIGT(ip, state=state)
        # the real assignment work 
        nrows <- suppressMessages(mod.OBIGT(eos))
        thermo <- get("thermo", CHNOSZ)
        matches.species <- rep(FALSE, nrows)
        matches.species[nrows] <- TRUE
      } else return(NA)
    } else return(NA)
  }
  # do we demand a particular state
  if(!is.null(state)) {
    # special treatment for H2O: aq retrieves the liq
    if(species %in% c("H2O", "water") & state=="aq") state <- "liq"
    # the matches for both species and state
    matches.state <- matches.species & state == thermo$OBIGT$state
    if(!any(matches.state)) {
      # the requested state is not available for this species
      available.states <- thermo$OBIGT$state[matches.species]
      if(length(available.states)==1) a.s.verb <- "is" else a.s.verb <- "are"
      a.s.text <- paste("'", available.states, "'", sep="", collapse=" ")
      message("info.character: requested state '", state, "' for ", species, 
        " but only ", a.s.text, " ", a.s.verb, " available")
      # warn about looking for aqueous methane (changed to CH4) 20200707
      if(identical(species, "methane") & identical(state, "aq")) {
        warning("'methane' is not an aqueous species; use 'CH4' instead\nTo revert to the old behavior, run mod.OBIGT(info('CH4'), name = 'methane')")
      }
      return(NA)
    }
    matches.species <- matches.state
  }
  # all of the species that match
  ispecies.out <- ispecies <- which(matches.species)
  # processing for more than one match
  if(length(ispecies) > 1) {
    # if a single name matches, use that one (useful for distinguishing pseudo-H4SiO4 and H4SiO4) 20171020
    matches.name <- matches.species & thermo$OBIGT$name==species
    if(sum(matches.name)==1) ispecies.out <- which(matches.name)
    else ispecies.out <- ispecies[1]  # otherwise, return only the first species that matches
    # let user know if there is more than one state for this species
    mystate <- thermo$OBIGT$state[ispecies.out]
    ispecies.other <- ispecies[!ispecies %in% ispecies.out]
    otherstates <- thermo$OBIGT$state[ispecies.other]
    # for minerals (cr), use the word "phase"; otherwise, use "state" 20190209
    word <- "state"
    # substitute the mineral name for "cr" 20190121
    if(mystate == "cr" | sum(otherstates=="cr") > 1) {
      word <- "phase"
      otherstates[otherstates=="cr"] <- thermo$OBIGT$name[ispecies.other[otherstates=="cr"]]
    }
    transtext <- othertext <- ""
    # we count, but don't show the states for phase transitions (cr2, cr3, etc)
    istrans <- otherstates %in% c("cr2", "cr3", "cr4", "cr5", "cr6", "cr7", "cr8", "cr9")
    if(mystate=="cr") {
      # if we are "cr" we show the number of phase transitions
      ntrans <- sum(istrans)
      if(ntrans == 1) transtext <- paste(" with", ntrans, "phase transition")
      else if(ntrans > 1) transtext <- paste(" with", ntrans, "phase transitions")
      # if it's not already in the species name, substitute the mineral name for "cr" 20190121
      if(species != thermo$OBIGT$name[ispecies.out]) mystate <- thermo$OBIGT$name[ispecies.out]
    }
    otherstates <- otherstates[!istrans]
    if(length(otherstates) == 1) othertext <- paste0("; other available ", word, " is ", otherstates)
    if(length(otherstates) > 1) othertext <- paste0("; other available ", word, "s are ", paste(otherstates, collapse=", "))
    if(transtext != "" | othertext != "") {
      starttext <- paste0("info.character: found ", species, "(", mystate, ")")
      message(starttext, transtext, othertext)
    }
  }
  return(ispecies.out)
}

can.be.numeric <- function(x) {
  # return FALSE if length of argument is zero
  if(length(x) == 0) FALSE else
  if(length(x) > 1) as.logical(sapply(x, can.be.numeric)) else {
    if(is.numeric(x)) TRUE else
    if(!is.na(as.numeric.nowarn(x))) TRUE else
    if(x %in% c('.','+','-')) TRUE else FALSE
  }
}
        
# something like R's as.numeric(), but without the "NAs introduced by coercion" warnings
# (needed because testthat somehow detects the warnings suppressed by suppressWarnings) 20170427
as.numeric.nowarn <- function(x) {
  if(length(x) == 0) numeric() else
  if(length(x) > 1) sapply(x, as.numeric.nowarn) else
  # http://stackoverflow.com/questions/12643009/regular-expression-for-floating-point-numbers
  if(grepl("^[+-]?([0-9]*[.])?[0-9]+$", x)) as.numeric(x) else NA_real_
}

outvert <- function(value,units) {
  # converts the given value from the given units to
  # those specified in thermo()$opt
  units <- tolower(units)
  opt <- get("thermo", CHNOSZ)$opt
  if(units %in% c('c','k')) {
    if(units=='c' & opt$T.units=='K') return(convert(value,'k'))
    if(units=='k' & opt$T.units=='C') return(convert(value,'c'))
  }
  if(units %in% c('j','cal')) {
    if(units=='j' & opt$E.units=='Cal') return(convert(value,'cal'))
    if(units=='cal' & opt$E.units=='J') return(convert(value,'j'))
  }
  if(units %in% c('bar','mpa')) {
    if(units=='mpa' & opt$P.units=='bar') return(convert(value,'bar'))
    if(units=='bar' & opt$P.units=='MPa') return(convert(value,'mpa'))
  }
  return(value)
}

# to retrieve the coefficients of reactions to form the species from the basis species
species.basis <- function(species=get("thermo", CHNOSZ)$species$ispecies) {
  # current basis elements
  bmat <- basis.elements()
  tbmat <- t(bmat)
  # what are the elements?
  belem <- rownames(tbmat)
  # get the species makeup into a matrix
  mkp <- as.matrix(sapply(makeup(species, count.zero=TRUE), c))
  # the positions of the species elements in the basis elements
  ielem <- match(rownames(mkp), belem)
  # the elements of the species must be contained by the basis species
  if(any(is.na(ielem))) stop(paste("element(s) not in the basis:", 
    paste(rownames(mkp)[is.na(ielem)], collapse=" ")))
  # the positions of the basis elements in the species elements
  jelem <- match(belem, rownames(mkp))
  # keep track of which ones are NA's; 
  # index them as one here but turn them to zero later
  ina <- is.na(jelem)
  jelem[ina] <- 1
  # now put the species matrix into the same order as the basis
  mkp <- mkp[jelem, , drop=FALSE]
  # fill zeros for any basis element not in the species
  mkp[ina, ] <- 0
  # solve for the basis coefficients and transpose
  nbasis <- t(apply(mkp, 2, function(x) solve(tbmat, x)))
  # very small numbers are probably a floating point artifact
  # can cause problems in situations where zeros are needed
  # (manifests as issue in longex("phosphate"), where which.balance()
  #  identifies H2O as conserved component)
  # 20140201 set digits (to R default) becuase getOption("digits") is changed in knitr
  out <- zapsmall(nbasis, digits=7)
  # add names of species and basis species
  colnames(out) <- colnames(tbmat)
  # add names of species only if it was a character argument
  if(all(is.character(species))) rownames(out) <- species
  return(out)
} 

subcrt_bal <- function(species, coeff, state, P){
    
  thermo <- get("thermo", CHNOSZ)
  
    
#   if(is.numeric(species[1])) {
    ispecies <- species
    species <- as.character(thermo$OBIGT$name[ispecies])
    state <- as.character(thermo$OBIGT$state[ispecies])
#   } else {
#     # from names, get species indices and states and possibly
#     # keep track of phase species (cr,cr2 ...)
#     ispecies <- numeric()
#     newstate <- character()
#     for(i in 1:length(species)) {
#       # get the species index for a named species
#       if(!can.be.numeric(species[i])) si <- info.character(species[i], state[i])
#       else {
#         # check that a numeric argument is a rownumber of thermo()$OBIGT
#         si <- as.numeric(species[i])
#         if(!si %in% 1:nrow(thermo$OBIGT)) stop(paste(species[i], "is not a row number of thermo()$OBIGT"))
#       }
#       # that could have the side-effect of adding a protein; re-read thermo
#       thermo <- get("thermo", CHNOSZ)
#       if(is.na(si[1])) stop('no info found for ',species[i],' ',state[i])
#       if(!is.null(state[i])) is.cr <- state[i]=='cr' else is.cr <- FALSE
#       if(thermo$OBIGT$state[si[1]]=='cr' & (is.null(state[i]) | is.cr)) {
#         newstate <- c(newstate,'cr')
#         ispecies <- c(ispecies,si[1])
#       } else {
#         newstate <- c(newstate,as.character(thermo$OBIGT$state[si[1]]))
#         ispecies <- c(ispecies,si[1])
#       }
#     }
#   }
          
    # the mass balance; should be zero for a balanced reaction
    mss <- makeup(ispecies, coeff, sum=TRUE)
    # take out very small numbers
    mss[abs(mss) < 1e-7] <- 0
    # report and try to fix any non-zero mass balance
    if(any(mss!=0)) {
      # the missing composition: the negative of the mass balance
      miss <- -mss
      # drop elements that are zero
      miss <- miss[miss!=0]
      #message("subcrt: reaction is not balanced; it is missing this composition:")
      # we have to do this awkward dance to send a formatted matrix to message
      #message(paste(capture.output(print(miss)), collapse="\n"))
      # look for basis species that have our compositoin
      tb <- thermo$basis
      if(!is.null(tb)) {
        if(all(names(miss) %in% colnames(tb)[1:nrow(tb)])) {
          # the missing composition as formula
          ft <- as.chemical.formula(miss)
          # the basis species needed to supply it
          bc <- species.basis(ft)
          # drop zeroes
          bc.new <- bc[,(bc[1,]!=0),drop=FALSE]
          # and get the states
          b.state <- as.character(thermo$basis$state)[bc[1,]!=0]
          bc <- bc.new
          # special thing for Psat
          if(identical(P[[1]], "Psat")) P <- "Psat"
          else P <- outvert(P,"bar")
          # add to logact values if present
          if(!is.null(logact)) {
            ila <- match(colnames(bc),rownames(thermo$basis))
            nla <- !(can.be.numeric(thermo$basis$logact[ila]))
            if(any(nla)) warning('subcrt: logact values of basis species',
              c2s(rownames(thermo$basis)[ila]),'are NA.')
            logact <- c(logact,thermo$basis$logact[ila])
          }
          # warn user and do it!
          ispecies.new <- tb$ispecies[match(colnames(bc),rownames(tb))]
          b.species <- thermo$OBIGT$formula[ispecies.new]
          if(identical(species,b.species) & identical(state,b.state))
            message("subcrt: balanced reaction, but it is a non-reaction; restarting...")
          #else message('subcrt: adding missing composition from basis definition and restarting...')
          newspecies <- c(species, tb$ispecies[match(colnames(bc), rownames(tb))])
          newcoeff <- c(coeff, as.numeric(bc[1, ]))
          newstate <- c(state, b.state)
          return(list('newspecies'=newspecies, 'newcoeff'=newcoeff, 'newstate'=newstate))
        } else warnings <- c(warnings, paste('reaction among', paste(species, collapse = ","), 'was unbalanced, missing', as.chemical.formula(miss)))
      } else warnings <- c(warnings, paste('reaction among', paste(species, collapse = ","), 'was unbalanced, missing', as.chemical.formula(miss)))
    }
}


# basis("CHNOS+")

# start_time <- Sys.time()
# subcrt_bal(species=c(18, 16), coeff=c(-1, 1), state=c("aq", "aq"))
# print(Sys.time()-start_time)
                    
# start_time <- Sys.time()
# subcrt(species=c(18, 16), coeff=c(-1, 1), state=c("aq", "aq"))$reaction
# print(Sys.time()-start_time)

generate_template <- function(thermo_df, template_name, template_type, fixed_species){
  # create a template for sample input
  if(template_type == 'strict'){
    species_names <- thermo_df %>% filter(tag == "basis")
  }else if(template_type == 'all basis'){
    species_names <- thermo_df %>% filter(tag == "basis" | tag == "aux")
  }else{
    species_names <- thermo_df
  }
      
  species_names <- sort(unlist(species_names[, "name"]))
  input_template <- data.frame(Sample=c("id"), `H+`=c("pH"), Temperature=c("degC"), logfO2=c("logfO2"), check.names=F)
  for(species in species_names){
    if(!(species %in% fixed_species)){
      input_template[[species]] <- c("Molality")
    }
  }
    
  write.csv(input_template, template_name, row.names=F)
}

library(CHNOSZ)

calc_bdot <- function(T){
  # Calculate bdot parameter at a given temperature.

  # GB notes:
  # The equation used by dbcreate to approximate the curve in Fig 3
  # of Helgeson 1969 results in numbers that are close to, but not
  # exactly the same as those in data0.jus:

  # Bdot parameter grid:
  #  0.0376   0.0443   0.0505   0.0529   0.0479   0.0322   0.0000   0.0000  # from dbcreate
  #  0.0374   0.0430   0.0460   0.0470   0.0470   0.0340   0.0000   0.0000  # from data0.jus

  # Close but not exact! data0.jus is closer to what is depicted in Fig 3 of Helgeson 1969.
  # Not sure what other equation to use, though. Will keep the dbcreate equation for now.
  # TODO: look into alternative equations.

  b1 <-  0.0374
  b2 <-  1.3569e-4
  b3 <-  2.6411e-7
  b4 <- -4.6103e-9  

  result <- b1 + b2*T + b3*(T-25.0)^2 + b4*(T-25.0)^3
    
  return(ifelse(T >= 300, 0, result))

}

fill_data0_head <- function(data0_template, db, grid_temps, grid_press,
                            water_model, activity_model){
    
  data0_template <- paste(data0_template, collapse="\n")
    
  # make sure the TP grid is in the correct form, esp. for single TP values
  grid_temps <- unlist(grid_temps)
  grid_press <- unlist(grid_press)
  grid_temps_original <- grid_temps
  if(length(grid_temps) == 1){
    grid_temps <- grid_temps + 10*(0:7) # only the first T value is valid, but this is needed for EQ3
    grid_press <- rep(grid_press, length(grid_temps))
  }
    
  # calculate debye huckel a and b parameters for the grid
  if(length(grid_temps_original) >= 8){
    A_DH_grid <- unlist(water("A_DH", T=273.15+grid_temps, P=grid_press))
    B_DH_grid <- unlist(water("B_DH", T=273.15+grid_temps, P=grid_press)*10^-8)
  }else if(length(grid_temps_original) == 1){
    A_DH_grid <- unlist(water("A_DH", T=273.15+grid_temps[1], P=grid_press[1]))
    A_DH_grid <- c(A_DH_grid, rep(0, 7))
    B_DH_grid <- unlist(water("B_DH", T=273.15+grid_temps[1], P=grid_press[1])*10^-8)
    B_DH_grid <- c(B_DH_grid, rep(0, 7))
  }

  if(activity_model == "pitzer"){
    Aphi_DH_grid <- (A_DH_grid*2.303)/3
    Aphi_DH_grid_f <- as.character(format(round(Aphi_DH_grid, 4), nsmall = 4, scientific=F))
  }

  # Ensure that the number of characters expressing pressure allows for spaces between values in the header
  # e.g., avoid a line like: 50000.000050000.000050000.000050000.0000
  # This is important for DEW calculations
  if(nchar(as.character(format(round(grid_press[1], 4), nsmall=4, scientific=F))) == 10){
    pdig <- 3
  }else if (nchar(as.character(format(round(grid_press[1], 4), nsmall=4, scientific=F))) < 10){
    pdig <- 4
  }else{
    # 
  }
      
  # format grid values
  grid_temps_f <- as.character(format(round(grid_temps, 4), nsmall = 4, scientific=F))
  grid_press_f <- as.character(format(round(grid_press, pdig), nsmall = pdig, scientific=F))
  A_DH_grid_f <- as.character(format(round(A_DH_grid, 4), nsmall = 4, scientific=F))
  B_DH_grid_f <- as.character(format(round(B_DH_grid, 4), nsmall = 4, scientific=F))

  # calculate bdot parameter
  if(length(grid_temps_original) == 1){
    bdot_grid_f <- c(as.character(format(round(calc_bdot(grid_temps[1]), 4), nsmall = 4, scientific=F)), rep("0.0000", 7))
  }else{
    bdot_grid_f <- as.character(format(round(calc_bdot(grid_temps), 4), nsmall = 4, scientific=F))
  }
    
  # cco2 (coefficients for the drummond (1981) polynomial)
  # GB note: might not change with T or P?
  # Examination of various data0 files seems to indicate that DBcreate does not change these values.

  # Calculate the "log k for eh reaction" grid.
  # From eq. 9 in EQPT user manual (version 7.0) by Daveler and Wolery:
  if(length(grid_temps_original) >= 8){
      
    suppressMessages({
        logK_Eh_vals <- subcrt(c("H2O", "O2", "e-", "H+"),
                               c(-2, 1, 4, 4),
                               c("liq", "gas", "aq", "aq"),
                               T=grid_temps,
                               P=round(grid_press, 9),
                               exceed.rhomin=TRUE,
                               exceed.Ttr=TRUE)$out$logK
    })
      
  }else if(length(grid_temps_original) == 1){
      
    suppressMessages({
        logK_Eh_vals <- subcrt(c("H2O", "O2", "e-", "H+"),
                               c(-2, 1, 4, 4),
                               c("liq", "gas", "aq", "aq"),
                               T=grid_temps[1],
                               P=round(grid_press[1], 9),
                               exceed.rhomin=TRUE,
                               exceed.Ttr=TRUE)$out$logK
    })
      
    logK_Eh_vals <- c(logK_Eh_vals, rep(0, 7))
      
  }
      
  logk_grid_f <- as.character(format(round(logK_Eh_vals, 4), nsmall = 4))
    
  tempgrid <- c("     ")
  presgrid <- c("     ")
  A_DHgrid <- c("     ")
  B_DHgrid <- c("     ")
  bdotgrid <- c("     ")
  logkgrid <- c("     ")
  Aphi_DHgrid <- c("     ")
  for(i in 1:length(grid_temps)){

      tempgrid <- c(tempgrid, paste0(paste(rep(" ", 10-nchar(grid_temps_f[i])), collapse=""), grid_temps_f[i]))
      presgrid <- c(presgrid, paste0(paste(rep(" ", 10-nchar(grid_press_f[i])), collapse=""), grid_press_f[i]))
      A_DHgrid <- c(A_DHgrid, paste0(paste(rep(" ", 10-nchar(A_DH_grid_f[i])), collapse=""), A_DH_grid_f[i]))
      B_DHgrid <- c(B_DHgrid, paste0(paste(rep(" ", 10-nchar(B_DH_grid_f[i])), collapse=""), B_DH_grid_f[i]))
      bdotgrid <- c(bdotgrid, paste0(paste(rep(" ", 10-nchar(bdot_grid_f[i])), collapse=""), bdot_grid_f[i]))
      logkgrid <- c(logkgrid, paste0(paste(rep(" ", 10-nchar(logk_grid_f[i])), collapse=""), logk_grid_f[i]))
      if(activity_model == "pitzer"){
        Aphi_DHgrid <- c(Aphi_DHgrid, paste0(paste(rep(" ", 10-nchar(Aphi_DH_grid_f[i])), collapse=""), Aphi_DH_grid_f[i]))
      }
      if(i%%6 == 0){
          tempgrid <- c(tempgrid, "\n     ")
          presgrid <- c(presgrid, "\n     ")
          A_DHgrid <- c(A_DHgrid, "\n     ")
          B_DHgrid <- c(B_DHgrid, "\n     ")
          bdotgrid <- c(bdotgrid, "\n     ")
          logkgrid <- c(logkgrid, "\n     ")
          if(activity_model == "pitzer"){
            Aphi_DHgrid <- c(Aphi_DHgrid, "\n     ")
          }
      }
  }
  tempgrid <- paste(tempgrid, collapse="")
  presgrid <- paste(presgrid, collapse="")
  A_DHgrid <- paste(A_DHgrid, collapse="")
  B_DHgrid <- paste(B_DHgrid, collapse="")
  bdotgrid <- paste(bdotgrid, collapse="")
  logkgrid <- paste(logkgrid, collapse="")
  if(activity_model == "pitzer"){
    Aphi_DHgrid <- paste(Aphi_DHgrid, collapse="")
  }

  # insert minimum and maximum temperature values into data0 template
  temp_min_max_insertlines <- "\nTemperature limits \\(degC\\)\n.*\ntemperatures\n"
  t_min <- min(grid_temps)
  t_max <- max(grid_temps)
  t_min_f <- as.character(format(round(t_min, 4), nsmall = 4, scientific=F))
  t_max_f <- as.character(format(round(t_max, 4), nsmall = 4, scientific=F))
  t_min_max <- paste0(paste(rep(" ", 10-nchar(t_min_f)), collapse=""), t_min_f)
  t_min_max <- paste0(t_min_max, paste(rep(" ", 10-nchar(t_max_f)), collapse=""), t_max_f)
  t_min_max <- paste0("     ", t_min_max)
  data0_template <- sub(temp_min_max_insertlines, paste0("\nTemperature limits (degC)\n", t_min_max, "\ntemperatures\n"), data0_template)

  # insert temperature grid values into data0 template
  tempgrid_insertlines <- "\ntemperatures\n.*\npressures\n"
  data0_template <- sub(tempgrid_insertlines, paste0("\ntemperatures\n", tempgrid, "\npressures\n"), data0_template)

  # insert pressure grid values into data0 template
  presgrid_insertlines <- "\npressures\n.*\ndebye huckel a \\(adh\\)\n"
  data0_template <- sub(presgrid_insertlines, paste0("\npressures\n", presgrid, "\ndebye huckel a (adh)\n"), data0_template)

  if(activity_model == "b-dot" | activity_model == "davies"){
    
    # insert Debeye Huckel A and B parameter values into data0 template
    A_DHgrid_insertlines <- "\ndebye huckel a \\(adh\\)\n.*\ndebye huckel b \\(bdh\\)\n"
    data0_template <- sub(A_DHgrid_insertlines, paste0("\ndebye huckel a (adh)\n", A_DHgrid, "\ndebye huckel b (bdh)\n"), data0_template)
    B_DHgrid_insertlines <- "\ndebye huckel b \\(bdh\\)\n.*\nbdot\n"
    data0_template <- sub(B_DHgrid_insertlines, paste0("\ndebye huckel b (bdh)\n", B_DHgrid, "\nbdot\n"), data0_template)

    # insert bdot grid values into data0 template
    bdotgrid_insertlines <- "\nbdot\n.*\ncco2"
    data0_template <- sub(bdotgrid_insertlines, paste0("\nbdot\n", bdotgrid, "\ncco2"), data0_template)

  }else if (activity_model == 'pitzer'){
      
    # insert Debeye Huckel A phi values into data0 template
    Aphi_DHgrid_insertlines <- "\ndebye huckel a \\(adh\\)\n.*\nlog k for eh reaction\n"
    data0_template <- sub(Aphi_DHgrid_insertlines, paste0("\ndebye huckel aphi\n", Aphi_DHgrid, "\nlog k for eh reaction\n"), data0_template)
  }
      
  # insert logk (eh) grid values into data0 template
  logkgrid_insertlines <- "\nlog k for eh reaction\n.*\n\\+-+\nbdot parameters"
  logkgrid_end_insert <- "\n+--------------------------------------------------------------------\nbdot parameters"
  data0_template <- sub(logkgrid_insertlines, paste0("\nlog k for eh reaction\n", logkgrid, logkgrid_end_insert), data0_template)
    
  # modify the data0 header lines
  desc <- "data0.%s\nWater model: %s\nTP points: %s"
  min_desc <- "data0.min\nminimal working data0 file"
  data0_template <- sub(min_desc, sprintf(desc, db, water_model, length(grid_temps_original)), data0_template)

  return(data0_template) # returns a single string
    
}

library(dplyr)
library(CHNOSZ)
library(stringr)


### helper functions

# trims away leading and trailing spaces and condenses multiple spaces between words
trimspace <- function(str){
    gsub("(?<=[\\s])\\s*|^\\s+|\\s+$", "", str, perl=TRUE)
}

# isolate a substring by trimming off the portions before and after it
isolate_block <- function(str, begin_str, end_str){
  return(sub(end_str, "", sub(begin_str, "", str)))
}

### main functions

mine_3o <- function(this_file,
                    this_pressure,
                    get_aq_dist=T,
                    get_mass_contribution=T,
                    get_mineral_sat=T,
                    get_redox=T,
                    get_charge_balance=T,
                    get_ion_activity_ratios=T,
                    get_fugacity=T,
                    get_basis_totals=T,
                    get_solid_solutions=T,
                    mass_contribution_other=T,
                    verbose=1){
    
  # set directory to rxn_3o folder where .3o files are kept
  setwd("rxn_3o")
    
  # read .3o file as a string
  fileName <- this_file
  extractme <- readChar(fileName, file.info(fileName)$size) # readChar requires filesize, which is obtained from file.info()$size

  # get sample name
  this_name <- trimspace(isolate_block(extractme, begin_str="^.*\\|Sample:\\s+", end_str="\\|\\n\\|.*$"))
    
  if(verbose > 1){
    writeLines(paste0("Processing EQ3 output for ", this_name))
  }

  # check if file experienced errors. If so, skip processing the file:
  if (grepl("Normal exit", extractme) == FALSE | grepl("\\* Error", extractme)){
#     if(verbose > 0){
#       writeLines(paste0("\nSample ", this_name, " experienced errors during speciation:"))
#       output_error <- str_extract_all(extractme, regex("\\* Error.*?\n(\n|$)", dotall=T))
#       output_error <- lapply(output_error, function(x) gsub("\n", " ", x))
#       output_error <- lapply(output_error, str_squish)
        
#       for(i in 1:length(output_error)){
#         writeLines(output_error[[i]])
#       }
      
#     }

    setwd("../")
    return(list())
  }

  sample_3o <- list()

  sample_3o[["filename"]] <- this_file
  sample_3o[["name"]] <- this_name
  
  ### Begin mining temperature, pressure, water properties
    
  # mine params
  sample_3o[["temperature"]] <- isolate_block(str=extractme, begin_str="^.*Temperature=\\s+", end_str="\\s+.*$")
  sample_3o[["pressure"]] <- this_pressure #isolate_block(str=extractme, begin_str="^.*Pressure=\\s+", end_str="\\s+.*$")
  sample_3o[["logact_H2O"]] <- isolate_block(str=extractme, begin_str="^.*Log activity of water=\\s+", end_str="\\s+.*$")
  sample_3o[["H2O_density"]] <- isolate_block(str=extractme, begin_str="^.*Solution density =\\s+", end_str="\\s+.*$")
  sample_3o[["H2O_molality"]] <- 55.348/as.numeric(sample_3o[["H2O_density"]])
  sample_3o[["H2O_log_molality"]] <- log10(sample_3o[["H2O_molality"]])
  sample_3o[["ionic_strength"]] <- isolate_block(str=extractme, begin_str="^.*Ionic strength \\(I\\)=\\s+", end_str="\\s+.*$")

  ### Begin extracting 'Distribution of Aqueous Solute Species' ###
  if (get_aq_dist){
    # string to isolate the aqueous species distribution section:
    front_trim <- "^.*\n\n\n\n                --- Distribution of Aqueous Solute Species ---\n\n    Species                  Molality    Log Molality   Log Gamma  Log Activity\n\n\\s+"

    # isolate species distribution block
    species_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n.*$")

    # split into substrings, each representing a separate row in the table
    species_block <- strsplit(species_block, "\n")
      
    #create an empty data frame to store results
    df <- data.frame(species = character(0),
                      molality = character(0),
                      log_molality = character(0),
                      log_gamma = character(0),
                      log_activity = character(0),
                      stringsAsFactors = FALSE)

    # convert into dataframe
    for(this_row in species_block[[1]]){

      # mine row data
      this_row <- trimspace(this_row)
      this_row_data <- strsplit(this_row, " ")[[1]]

      # create a dataframe with results
      this_df <- data.frame(species=this_row_data[1],
                            molality=this_row_data[2],
                            log_molality=this_row_data[3],
                            log_gamma=this_row_data[4],
                            log_activity=this_row_data[5],
                            stringsAsFactors=FALSE)

      # bind distribution of aqueous species to dataframe
      df <- rbind(df, this_df)

    }

    if(!("H2O" %in% df$species)){
      # add a row for water
      df <- rbind(df, data.frame(species="H2O",
                      molality=sample_3o[["H2O_molality"]],
                      log_molality=sample_3o[["H2O_log_molality"]],
                      log_gamma=1,
                      log_activity=sample_3o[["logact_H2O"]],
                      stringsAsFactors=FALSE))
    }

    # set rownames of aqueous species block as species names
    rownames(df) <- df$species
    df$species <- NULL
      
    # add aqueous block to this sample data
    sample_3o[["aq_distribution"]] <- df
      
  } # end of 'aqueous distribution' extraction
    

  if(get_mass_contribution){
    ### begin extracting 'Major Species by Contribution to Aqueous Mass Balances' ###
    
    # string to isolate the species saturation section:
    front_trim <- "^.*\n\n\n      --- Major Species by Contribution to Aqueous Mass Balances ---\n\n\n"

    # isolate contribution block
    contrib_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n\n\n.*$")
    
    # split into substrings, each representing a separate row in the table
    contrib_block <- strsplit(contrib_block, "\n")
    # remove blank linkes
    contrib_block[[1]] <- contrib_block[[1]][contrib_block[[1]] != ""]
  
    # loop through rows in this block and mine contributions
    mine_vals <- FALSE
    for(this_row in contrib_block[[1]]){
      if(grepl("Accounting for", this_row)){
        # get basis species for this block
        this_basis <- sub(" Species Accounting for 99% or More of Aqueous ", "", this_row)
      } else if (grepl("Per Cent", this_row)){
        # get ready to mine data for this basis species
        mine_vals <- TRUE
        df_basis <- data.frame(species=character(0),
                               molality=character(0),
                               factor=character(0),
                               percent=character(0),
                               stringsAsFactors = FALSE)
      } else if (mine_vals && !grepl(" - - - - - - - - -", this_row)){
        # mine data from this row
        row_data <- trimspace(this_row)
        row_data <- strsplit(row_data, " ")[[1]]
        df_basis <- rbind(df_basis, data.frame(species=row_data[1], factor=row_data[2],
                        molality=row_data[3], percent=row_data[4], stringsAsFactors = FALSE))
      } else if (grepl(" - - - - - - - - -", this_row)){
        # stop mining for this basis species
        mine_vals <- FALSE
        # specify rownames for this contribution block
        rownames(df_basis) <- df_basis$species
        df_basis$species <- NULL
        # add contribution data to list of sample data
        sample_3o[["mass_contribution"]][[this_basis]] <- df_basis
      }
    }
  } # end 'aqueous contribution' extraction


  ### Begin mining mineral saturation section  
  if(get_mineral_sat){
      
    # string to isolate the mineral saturation section:
    front_trim <- "^.*\n\n\n\n           --- Saturation States of Pure Solids ---\n\n       Phase                      Log Q/K    Affinity, kcal\n\n\\s+"

    # isolate mineral block
    mineral_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n.*$")

    # split into substrings, each representing a separate row in the table
    mineral_block <- strsplit(mineral_block, "\n")

    # create an empty data frame to store results
    df <- data.frame(mineral = character(0),
                     logQoverK = character(0),
                     affinity = character(0),
                     stringsAsFactors = FALSE)

    # convert into dataframe
    for(this_row in mineral_block[[1]]){
      # get row data
      this_row_data <- strsplit(trimspace(this_row), " ")[[1]]
      
      # create a dataframe with mined data
      this_df <- data.frame(mineral = this_row_data[1],
                            logQoverK = this_row_data[2],
                            affinity = this_row_data[3],
                            stringsAsFactors = FALSE)
      
      # bind results to dataframe
      df <- rbind(df, this_df)
    }
    rownames(df) <- df$mineral
    df$mineral <- NULL
      
    # add mineral saturation block to this sample data
    sample_3o[["mineral_sat"]] <- df

    if(get_solid_solutions){
      if(grepl("--- Saturation States of Hypothetical Solid Solutions ---", extractme)){
        # string to isolate the solid solution saturation section:
        front_trim <- "^.*\n\n\n                --- Saturation States of Hypothetical Solid Solutions ---\n\n"

        # isolate solid solution block
        ss_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n                     --- Fugacities ---.*$") # end_str might be different if fugacity section is not present

        if(ss_block != " None"){
          
        # split into substrings, each representing a separate solid solution
        ss_block <- strsplit(ss_block, "\n\n\n                --- ")[[1]]

        
          
        ss_entries <- list()
        for(ss_entry in ss_block){
          ss_entry <- strsplit(ss_entry, " ---\n\n   ")[[1]]
          ss_name <- ss_entry[1]
          ss_name <- sub("\n                --- ", "", ss_name) # needed to clean up the first ss_entry name
          ss_data <- ss_entry[2]
          ss_data <- sub("Ideal solution\n\n    Component                    x           Log x   Log lambda  Log activity\n\n", "", ss_data)[[1]]
          ss_entry <- strsplit(ss_data, "\n\n\n    Mineral                       Log Q/K         Aff, kcal    State\n\n")



          ss_entry <- lapply(ss_entry, FUN=strsplit, "\n")[[1]]
          ss_entry <- lapply(ss_entry, FUN=trimws, "l")
          ss_entry <- lapply(ss_entry, FUN=strsplit, "[ ]{2,}", perl=TRUE)
            
          names(ss_entry) <- c("ideal solution", "mineral")


          ideal_sol_df <- data.frame(component=character(),
                                   x=numeric(),
                                   `Log x`=numeric(),
                                   `Log lambda`=numeric(),
                                   `Log activity`=numeric(),
                                   stringsAsFactors = FALSE)
          for(row in ss_entry[["ideal solution"]]){

            x <- suppressWarnings(as.numeric(row[2]))
            if(is.na(x)){
              x <- 0
            }

            ideal_sol_df <- rbind(ideal_sol_df, data.frame(component=as.character(row[1]),
                                                         x = x,
                                                         `Log x` = as.numeric(row[3]),
                                                         `Log lambda` = as.numeric(row[4]),
                                                         `Log activity` = as.numeric(row[5])),
                                                         stringsAsFactors=FALSE)
          }
          names(ideal_sol_df) <- c("component", "x", "Log x", "Log lambda", "Log activity") # rename columns because check.names doesn't work when creating the dataframes
          ss_entry[["ideal solution"]] <- ideal_sol_df

          mineral_ss_df <- data.frame(mineral=character(),                                   
                                    `Log Q/K`=numeric(),
                                    `Aff, kcal`=numeric(),
                                    `State`=character(),
                                    stringsAsFactors = FALSE)
          for(row in ss_entry[["mineral"]]){


            if(length(row) == 3){
              row <- c(row, "")
            }
            mineral_ss_df <- rbind(mineral_ss_df, data.frame(mineral=as.character(row[1]),
                                                             `Log Q/K`=as.numeric(row[2]),
                                                             `Aff, kcal`=as.numeric(row[3]),
                                                             `State`=row[4]),
                                                             stringsAsFactors = FALSE)
          }
          names(mineral_ss_df) <- c("mineral", "Log Q/K", "Aff, kcal", "State") # rename columns because check.names doesn't work when creating the dataframes
          ss_entry[["mineral"]] <- mineral_ss_df

          ss_entries[[ss_name]] <- ss_entry
        }
        sample_3o[["solid_solutions"]] <- ss_entries
      }else{
        sample_3o[["solid_solutions"]] <- NA
        }
      }
    }
  } # end 'mineral saturation affinity' extraction
    

  ### Begin mining redox data
  if(get_redox){
    # string to isolate the redox section:
    front_trim <- "^.*\n\n\n\n                --- Aqueous Redox Reactions ---\n\n   Couple                           Eh, volts      pe-      log fO2   Ah, kcal\n\n\\s+"

    # isolate redox block
    redox_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n.*$")

    # split into substrings, each representing a separate row in the table
    redox_block <- strsplit(redox_block, "\n")

    #create an empty data frame to store results
    df <- data.frame(couple = character(0),
                     Eh = character(0),
                     pe = character(0),
                     logfO2 = character(0),
                     Ah = character(0),
                     stringsAsFactors = FALSE)

    # convert into dataframe
    for(this_row in redox_block[[1]]){
      
      # get row data
      this_row_data <- strsplit(trimspace(this_row), " ")[[1]]

      # create a dataframe with results
      this_df <- data.frame(couple = this_row_data[1],
                            Eh = this_row_data[2],
                            pe = this_row_data[3],
                            logfO2 = this_row_data[4],
                            Ah = this_row_data[5],
                            stringsAsFactors = FALSE)
      
      # bind results to dataframe
      df <- rbind(df, this_df)
    }
    rownames(df) <- df$couple
    df$couple <- NULL
    
    # add mineral saturation block to this sample data
    sample_3o[["redox"]] <- df
  } # end redox extraction
    

  ### begin mining charge balance data
  if(get_charge_balance){
    # string to isolate ionic strength:
    front_trim <- "^.*Ionic strength \\(I\\)=\\s+"

    # isolate ionic strength
    IS <- isolate_block(str=extractme, begin_str=front_trim, end_str="\\s+.*$")
    names(IS) <- "ionic strength"

    # string to isolate stoichiometric ionic strength:
    front_trim <- "^.*Stoichiometric ionic strength=\\s+"

    IS_stoich <- isolate_block(str=extractme, begin_str=front_trim, end_str="\\s+.*$")
    names(IS_stoich) <- "stoichiometric ionic strength"

    # string to isolate the electrical balance section:
    front_trim <- "^.*Sigma\\(mz\\) cations=\\s+"

    elec_block <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n.*$")

    # split electrical block into strings and numerics
    elec_block <- strsplit(elec_block, "=\\s+|\n\\s+")[[1]]

    elec_block <- c("sigma(mz) cations"=elec_block[1],
                    "sigma(mz) anions"=elec_block[3],
                    "total charge"=elec_block[5],
                    "mean charge"=elec_block[7],
                    "charge imbalance"=elec_block[9])

    # string to isolate charge balance:
    front_trim <- "^.*The electrical imbalance is:\n\n\\s+"

    cbal_bal <- isolate_block(str=extractme, begin_str=front_trim, end_str="\n\n.*$")

    # split electrical block into strings and numerics
    cbal_block <- strsplit(cbal_bal, " per cent|\n\\s+")[[1]]

    cbal_block <- c("charge imbalance % of total charge"=cbal_block[1],
                    "charge imbalance % of mean charge"=cbal_block[3])
  
    sample_3o[["charge_balance"]] <- c(IS, IS_stoich, elec_block, cbal_block)
  } # end charge balance extraction


  if(get_ion_activity_ratios){
    ion_ratio_block <- isolate_block(extractme, "^.*--- Ion-H\\+ Activity Ratios ---\n\n", "\n\n.*$")
    ion_ratio_block_split <- strsplit(ion_ratio_block, "\n")[[1]]
    ion_ratio_block_split <- strsplit(ion_ratio_block_split, "=")
      
    if (!identical(ion_ratio_block_split, character(0))){
      
    ion_ratio_logs <- trimspace(lapply(ion_ratio_block_split, `[[`, 1))
    ion_ratio_values <- suppressWarnings(as.numeric(lapply(ion_ratio_block_split, `[[`, 2)))
      
    which_to_divide <- grepl("/", ion_ratio_logs) # which of these ratios divide by H+ (instead of multiply?)
    hydrogen_exponents <- unlist(lapply(lapply(strsplit(gsub("^Log \\( a\\(", "", gsub(" \\)$", "", ion_ratio_logs)), "\\)xx "), `[[`, 2), as.numeric))
    ion <- unlist(lapply(strsplit(gsub("^Log \\( a\\(", "", gsub(" \\)$", "", ion_ratio_logs)), "\\) [x|/] a\\("), `[[`, 1))
    ion_times <- lapply(strsplit(gsub("^Log \\( a\\(", "", gsub(" \\)$", "", ion_ratio_logs)), "\\) x a\\(")[!which_to_divide], `[[`, 1)
    ion_divide <- lapply(strsplit(gsub("^Log \\( a\\(", "", gsub(" \\)$", "", ion_ratio_logs)), "\\) / a\\(")[which_to_divide], `[[`, 1)
  
    names(ion_ratio_values)[!which_to_divide] <- paste0("Log(", ion_times, " x H+**", hydrogen_exponents[!which_to_divide], ")")
    names(ion_ratio_values)[which_to_divide]  <- paste0("Log(", ion_divide, " / H+**", hydrogen_exponents[which_to_divide], ")")
    
    ion_ratio_values[is.na(ion_ratio_values)] <- "NA"

    df <- data.frame("values"=ion_ratio_values,
               "H_exponent"=hydrogen_exponents,
               "divide"=which_to_divide,
               "ion"=ion)

    df <- transform(transform(df, values = as.character(values)), values=as.numeric(values))
    df <- transform(df, ion = as.character(ion))
    sample_3o[["ion_activity_ratios"]] <- df
    }
  }

  ### begin fugacity mining
  if(get_fugacity){
    fugacity_block <- isolate_block(extractme, "^.*--- Fugacities ---\n\n", "\n\n\n.*$")
    str <- str_squish(strsplit(fugacity_block, "\n")[[1]])
    str <- str[3:length(str)]
    split_str <- strsplit(str, " ")
    df <- data.frame(gas=unlist(lapply(split_str, `[[`, 1)),
                     log_fugacity=as.numeric(unlist(lapply(split_str, `[[`, 2))),
                     stringsAsFactors=F, row.names=1)
      
    # fix an annoying behavior with R dataframes ignoring rownames when there is
    # only one row
    if(nrow(df) == 1){
      rownames(df) <- unlist(lapply(split_str, `[[`, 1))[1]
      df <- df[ , !(names(df)=="gas"), drop=FALSE]
    }
    sample_3o[["fugacity"]] <- df
  }

                             
  ### begin sensible composition mining ("basis totals")
  if(get_basis_totals){
    sc_block <- isolate_block(extractme, "^.*--- Sensible Composition of the Aqueous Solution ---\n\n", "\n\n   The above data have.*$")
    str <- str_squish(strsplit(sc_block, "\n")[[1]])
    str <- str[3:length(str)]
    split_str <- strsplit(str, " ")
    sc_names <- unlist(lapply(lapply(split_str, `[[`, 1), paste0, "_total"))
    df <- data.frame(species=sc_names,
                     `mg/L`=as.numeric(unlist(lapply(split_str, `[[`, 2))),
                     `mg/kg.sol`=as.numeric(unlist(lapply(split_str, `[[`, 3))),
                     `molarity`=as.numeric(unlist(lapply(split_str, `[[`, 4))),
                     `molality`=as.numeric(unlist(lapply(split_str, `[[`, 5))),
                     stringsAsFactors=F, row.names=1)
    
    # fix an annoying behavior with R dataframes ignoring rownames when there is
    # only one row
    if(nrow(df) == 1){
      rownames(df) <- sc_names[1]
      df <- df[ , !(names(df)=="species"), drop=FALSE]
    }
      
    sample_3o[["basis_totals"]] <- df

  }
                             
  setwd("../")
                             
  return(sample_3o)

}


# function to melt aqueous contribution data from multiple samples into
# a single dataframe and then return it.
melt_mass_contribution <- function(batch_3o, other=F, verbose=1){

  # initialize empty dataframe
  df_aq_cont <- data.frame(sample=character(0),
                           basis=character(0),
                           species=character(0),
                           factor=character(0),
                           molality=character(0),
                           percent=character(0),
                           stringsAsFactors=FALSE)

  # get all aqueous contribution data
  mass_contributions <- lapply(batch_3o[["sample_data"]], `[[`, 'mass_contribution')  

  # loop through each sample and basis species
  for(sample in names(mass_contributions)){
    if(verbose > 1){
      writeLines(paste0("Processing mass contribution of basis species in ", sample, "..."))
    }
    for(basis in names(mass_contributions[[sample]])){
      df <- mass_contributions[[sample]][[basis]]
      df[, "basis"] <- basis
      df[, "sample"] <- sample
      df[, "species"] <- rownames(df)
      rownames(df) <- NULL
        
      if(other){
        percent <- round(100-sum(as.numeric(df[, "percent"])), 2)
        df <- rbind(df, data.frame(sample=sample,
                                   basis=basis,
                                   species="Other",
                                   factor=NA,
                                   molality=NA,
                                   percent=toString(percent),
                                   stringsAsFactors=FALSE))
      }
        
      df_aq_cont <- rbind(df_aq_cont, df)
    }
  }
  
  df_aq_cont <- df_aq_cont[, c("sample", "basis", "species", "factor", "molality", "percent")]
    
  return(df_aq_cont)

}


# function to create report versions of data categories (aq distributions, etc.)
create_report_df <- function(data, category, out_type){
    
  df_cat <- lapply(data, `[[`, category)
    
  all_species <- unique(unlist(lapply(lapply(df_cat, FUN=t), FUN=colnames)))
    
  df <- read.csv(text=paste(all_species, collapse="\t"), check.names=FALSE, sep="\t", stringsAsFactors=FALSE)
    
  for(i in 1:length(df_cat)){
    row <- as.data.frame(t(df_cat[[i]])[out_type, , drop=FALSE], stringsAsFactors=FALSE)
    df <- bind_rows(mutate_all(df, as.character), mutate_all(row, as.character))
  }
    
  df <- df[, order(colnames(df))]
  df_cat <- cbind.data.frame(sample=names(df_cat), df,  stringsAsFactors = FALSE)
    
  return(df_cat)
    
}

# function to compile a report
compile_report <- function(data, csv_filename, aq_dist_type, mineral_sat_type,
                           redox_type, get_aq_dist, get_mineral_sat, get_redox,
                           get_charge_balance, get_ion_activity_ratios, get_fugacity,
                           get_basis_totals, input_processed_df,
                           df_input_processed_names){
    
  report_list <- list()
    
  # open processed input file and initialize report with it
  report <- input_processed_df
  names(report) <- df_input_processed_names
  #report <- read.csv(csv_filename, check.names=FALSE, stringsAsFactors=FALSE)
   
  report_list[["divs"]][["input"]] <- names(report)[2:length(report)] # start at 2 to exclude "sample" column
    
  # create report versions of EQ3 output blocks
  if(get_aq_dist){
    aq_distribution <- create_report_df(data=data, category='aq_distribution', out_type=aq_dist_type)
    report_list[["divs"]][["aq_distribution"]] <- names(aq_distribution)[2:length(aq_distribution)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(aq_distribution, by=c("Sample"="sample"))
  }
    
  if(get_mineral_sat){
    mineral_sat <- create_report_df(data=data, category='mineral_sat', out_type=mineral_sat_type)
    report_list[["divs"]][["mineral_sat"]] <- names(mineral_sat)[2:length(mineral_sat)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(mineral_sat, by=c("Sample"="sample"))
  }
    
  if(get_redox){
    redox <- create_report_df(data=data, category='redox', out_type=redox_type)
    report_list[["divs"]][["redox"]] <- names(redox)[2:length(redox)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(redox, by=c("Sample"="sample"))
  }
    
  if(get_charge_balance){
    charge_balance <- create_report_df(data=data, category='charge_balance', out_type=1)
    report_list[["divs"]][["charge_balance"]] <- names(charge_balance)[2:length(charge_balance)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(charge_balance, by=c("Sample"="sample"))
  }
    
  if(get_ion_activity_ratios){
    if('ion_activity_ratios' %in% names(data)){
    ion_activity_ratios <- create_report_df(data=data, category='ion_activity_ratios', out_type=1)
    report_list[["divs"]][["ion_activity_ratios"]] <- names(ion_activity_ratios)[2:length(ion_activity_ratios)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(ion_activity_ratios, by=c("Sample"="sample"))
    }
  }
    
  if(get_fugacity){
    fugacities <- create_report_df(data=data, category='fugacity', out_type=1)
    report_list[["divs"]][["fugacity"]] <- names(fugacities)[2:length(fugacities)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(fugacities, by=c("Sample"="sample"))
  }
    
  if(get_basis_totals){
    sc <- create_report_df(data=data, category='basis_totals', out_type=4) # 4 is the molality column
    report_list[["divs"]][["basis_totals"]] <- names(sc)[2:length(sc)] # start at 2 to exclude "sample" column
    report <- report %>% inner_join(sc, by=c("Sample"="sample"))
  }
    
  rownames(report) <- report$Sample
  report$Sample <- NULL

  report_list[["report"]] <- report
    
  return(report_list)

}


### main
main_3o_mine <- function(files_3o,
                         get_aq_dist,
                         get_mass_contribution,
                         get_mineral_sat,
                         get_redox,
                         get_charge_balance,
                         get_ion_activity_ratios,
                         get_fugacity,
                         get_basis_totals,
                         get_solid_solutions,
                         mass_contribution_other,
                         csv_filename,
                         aq_dist_type,
                         mineral_sat_type,
                         redox_type,
                         input_filename,
                         input_pressures,
                         batch_3o_filename,
                         df_input_processed,
                         df_input_processed_names,
                         verbose){
    
  start_time <- Sys.time()

  # instantiate an empty object to store data from all 3o files
  batch_3o <- list()
  
  if(verbose > 1){
    writeLines("Now processing EQ3 output files...")
  }
    
  names(input_pressures) <- files_3o
    
  # process each .3o file
  for(file in files_3o){
      
    # add this sample's aqueous data to list of all sample data
    sample_3o <- mine_3o(file,
                         this_pressure=input_pressures[file],
                         get_aq_dist=get_aq_dist,
                         get_mass_contribution=get_mass_contribution,
                         get_mineral_sat=get_mineral_sat,
                         get_redox=get_redox,
                         get_charge_balance=get_charge_balance,
                         get_ion_activity_ratios=get_ion_activity_ratios,
                         get_fugacity=get_fugacity,
                         get_basis_totals=get_basis_totals,
                         get_solid_solutions=get_solid_solutions,
                         mass_contribution_other=mass_contribution_other,
                         verbose=verbose)
      
    # if this file could be processed, add its data to the batch_3o object
    if(length(sample_3o)>1){
      batch_3o[["sample_data"]][[sample_3o[["name"]]]] <- sample_3o
    }
  }
    
  if(verbose > 1){
    writeLines("Finished processing EQ3 output files...")
  }
    
  # compile aqueous contribution data into a single melted dataframe and
  # append it to the batch_3o object.
  if(get_mass_contribution && length(batch_3o)>0){
    if(verbose > 1){
      writeLines("Now processing mass contribution data...")
    }
    batch_3o[["mass_contribution"]] <- melt_mass_contribution(batch_3o=batch_3o,
                                                              other=mass_contribution_other,
                                                              verbose=verbose)
    if(verbose > 1){
      writeLines("Finished processing mass contribution data...")
    }
  }
    
  if(length(batch_3o)>0){
    # create a report summarizing 3o data from all samples
    report_list <- compile_report(data=batch_3o[["sample_data"]],
                                  csv_filename=csv_filename,
                                  aq_dist_type,
                                  mineral_sat_type,
                                  redox_type,
                                  get_aq_dist,
                                  get_mineral_sat,
                                  get_redox,
                                  get_charge_balance,
                                  get_ion_activity_ratios,
                                  get_fugacity,
                                  get_basis_totals,
                                  df_input_processed,
                                  df_input_processed_names)
    

    # add the report to the batch_3o object
    report <- report_list[["report"]]
    batch_3o[["report"]] <- report
    batch_3o[["report_divs"]] <- report_list[["divs"]]
  }else{
    return(list())
  }
    
  # store user input file data
  batch_3o[["input"]] <- read.csv(input_filename, check.names=FALSE, stringsAsFactors=FALSE)
    
  # save the batch_3o object as an rds file
  if(!is.null(batch_3o_filename)){
    saveRDS(batch_3o, file=batch_3o_filename)
  }
      
  time_elapsed <- Sys.time() - start_time
  if(verbose > 1){
    writeLines(paste("Finished mining .3o files. Time elapsed:", round(time_elapsed, 2), "seconds"))
  }

  return(batch_3o)
}

# load packages
suppressMessages({
  library(CHNOSZ)
  library(dplyr)
  library(comprehenr)
  library(stringr)
})

# print messages if 'verbose' setting >= vlevel of message.
vmessage <- function(m, vlevel, verbose){
  if(verbose >= vlevel){
    print(m)
  }
}

# function to round up the last digit of a four-digit number
# e.g., 52.6112 becomes 52.6113.
# This function is useful for reporting rounded PSAT pressures that keeps water in the liquid phase
roundup <- function(x, n){
  return(round(x, n) + 10^-n)
}

check_TP_grid <- function(grid_temps, grid_press, P1, water_model="SUPCRT92", check_for_errors=TRUE, verbose=1){

  grid_temps <- as.numeric(grid_temps)
    
  # set water model
  suppressMessages(water(water_model))
  
  # round grid temperatures to four decimal places
  grid_temps <- round(grid_temps, 4)
    
  # calculate PSAT pressure if specified by user or if pressure grid
  # has a number of values that does not equal temperature grid length.
  if(tolower(grid_press[1]) == "psat"){
    vmessage("Calculating pressure grid along liquid-vapor saturation curve...", 2, verbose)
    grid_press <- water("Psat", T=grid_temps+273.15, P1=P1)[[1]]
  }
    
  grid_press <- as.numeric(grid_press)
    
  # check TP polynomial
  if(length(grid_temps) >= 8){

    if(length(grid_temps)%% 2 == 0){
      # even-length TP grid
      n_mid1 = floor(length(grid_temps)/2)+1
      n_mid2 = n_mid1-1
    }else{
      # odd-length TP grid
      n_mid1 = floor(length(grid_temps)/2)+1
      n_mid2 = n_mid1-1
    }
      
    # third order polynomial for the first T-P range
    poly_coeffs_1 <- lm(grid_press[1:n_mid1] ~ poly(grid_temps[1:n_mid1], length(grid_temps[1:n_mid1])-1, raw=T))$coefficients # don't touch raw=T!

    # fourth order polynomial for the second T-P range
    poly_coeffs_2 <- lm(grid_press[n_mid1:length(grid_temps)] ~ poly(grid_temps[n_mid1:length(grid_temps)], length(grid_temps[n_mid1:length(grid_temps)])-1, raw=T))$coefficients # don't touch raw=T!

    for(T in grid_temps[1:n_mid2]){
        test_sum_1 = 0
        for(i in 1:(length(poly_coeffs_1))){
          test_sum_1 = test_sum_1 + poly_coeffs_1[i]*T**(i-1)
        }
        if(is.na(test_sum_1)){
          stop(paste0("Error: Could not compute the coefficients of an interpolating polynomial
                       for the first half of the values of the temperature grid: [", paste(grid_temps[1:n_mid2], collapse=", "), "]."))
        }
        test_sum_2 = 0
        for(i in 1:(length(poly_coeffs_1))){
          test_sum_2 = test_sum_2 + poly_coeffs_2[i]*T**(i-1)
        }
        if(is.na(test_sum_1)){
        stop(paste0("Error: Could not compute the coefficients of an interpolating polynomial
                     for the last half of the values of the temperature grid: [", paste(grid_temps[n_mid2:length(grid_temps)], collapse=", "), "]."))
        }
    }

  }else{
    poly_coeffs_1 <- 'None'
    poly_coeffs_2 <- 'None'
  }

  if(check_for_errors){
    # check that water is a liquid at each T-P point
    TP_grid_errors <- c()
    for(i in 1:length(grid_temps)){
      if(length(grid_press) == 1 && i == 2){
        # break on 2nd T-P point in dynamic db
        break
      }
        
      tryCatch({
        psat_press <<- suppressMessages(water("Psat", T=grid_temps[i]+273.15, P1=P1)[[1]])
      }, error=function(e){
        psat_press <<- NA
      })
      if(is.na(psat_press)){
        tryCatch({
            rho_val <<- suppressMessages(water("rho", T=grid_temps[i]+273.15, P=grid_press[i], P1=P1)[[1]])
        }, error=function(e){
            rho_val <<- NA
        })
        if(is.na(rho_val)){
          TP_grid_errors <- c(TP_grid_errors,
                              paste("\nWater density could not be calculated at",
                                    grid_temps[i], "degrees C and",
                                    grid_press[i], "bar with the water model", water_model))
        }else if(rho_val <= 310){
          TP_grid_errors <- c(TP_grid_errors,
                              paste("\nWater density is", roundup(rho_val, 3), "kg m^3 at",
                                    grid_temps[i], "degrees C and",
                                    grid_press[i], "bar. This is too low (< 310 kg m^3)",
                                    "for this calculation. Increase pressure or decrease temperature."))
        }
      }else if(grid_press[i] < psat_press){
          
        TP_grid_errors <- c(TP_grid_errors,
                            paste("\n", grid_press[i], "bar is below liquid-vapor",
                                  "saturation pressure", roundup(psat_press, 4),
                                  "bar at", grid_temps[i], "degrees C."))
      }
    }
    if(length(TP_grid_errors) > 0){
      stop(paste(paste(TP_grid_errors, collapse="\n"),
                 "\n\nIncrease the pressure at these temperature points",
                 "to keep water in a liquid state."))
    }
      
  
        
    
  }
    
  return(list("grid_temps"=grid_temps, "grid_press"=grid_press,
              "poly_coeffs_1"=poly_coeffs_1, "poly_coeffs_2"=poly_coeffs_2))
}

# load packages
suppressMessages({
  library(CHNOSZ)
  library(dplyr)
  library(comprehenr)
  library(stringr)
})

############ Helper functions

# print messages if 'verbose' setting >= vlevel of message.
vmessage <- function(m, vlevel, verbose){
  if(verbose >= vlevel){
    print(m)
  }
}


# function to create a string of a certain length by adding additional spaces.
# e.g., "H2O" becomes "H2O    " if nspaces=7.
# Spaces can be added before the string by specifying spaces_after=FALSE
fillspace <- function(str, nspaces, spaces_after=TRUE){
tryCatch({
    out <<- ifelse(spaces_after,
         paste0(str, paste(rep(" ", nspaces-nchar(str)), collapse="")),
         paste0(paste(rep(" ", nspaces-nchar(str)), collapse=""), str))
    },
    error = function(e){
        out <<- ""
      },
      warning = function(w){
        print(paste("WARNING"))
      }
  )

  return(out)
}


# function to specify how many decimals are printed
# e.g. 12.433 becomes "12.4330" if k=4
s_d <- function(x, k) trimws(format(round(x, k), nsmall=k, scientific=F))


# main function
create_data0 <- function(thermo_df,
                         element_df,
                         solid_solution_df=NULL,
                         db,
                         water_model,
                         template,
                         dissrxns,
                         basis_pref=c(),
                         exceed_Ttr=FALSE,
                         fixed_species=c("H2O", "H+", "O2(g)", "water", "Cl-", "e-"),
                         verbose){
    
  # set water model
  suppressMessages({
      water(water_model)
  })
    
  # initialize lists and vectors
  azero_vec <- c()
  neutral_ion_type_vec <- c()
  dissociation_list <- list()
  tag_vec <- c()
    
  for(i in 1:nrow(thermo_df)){
      # for each row in the data file...

      # look up azero bdot param
      azero_temp <- thermo_df[i, "azero"]
      names(azero_temp) <- thermo_df[i, "name"]
      azero_vec <- c(azero_vec, azero_temp)

      # look up neutral ion type
      nit_temp <- thermo_df[i, "neutral_ion_type"]
      names(nit_temp) <- thermo_df[i, "name"]
      neutral_ion_type_vec <- c(neutral_ion_type_vec, nit_temp)
      
      # look up dissociation reaction
      species_name <- thermo_df[i, "name"]
      
      if(thermo_df[i, "dissrxn"] != "" && is.null(dissrxns[[species_name]])){
        dissrxn <- thermo_df[i, "dissrxn"]
      }else if(!(is.null(dissrxns[[species_name]]))){
        # use auto-balanced dissociation reaction if no dissociation reaction is found for non-basis
        dissrxn <- dissrxns[[species_name]]
      }else if(thermo_df[i, "tag"] == "basis"){
        # pass
      }else{
        message("Error: dissociation reaction could not be generated for:")
        message(thermo_df[i, "name"])
      }
      
      if(thermo_df[i, "tag"] != "basis"){
        dissrxn <- strsplit(dissrxn, " ")[[1]] # split the rxn into coeffs and species
        #dissrxn_temp <- dissrxn[3:length(dissrxn)] # ignore the and diss. spec. name and coeff
        dissrxn_names <- dissrxn[c(FALSE, TRUE)] # get names of reactants and products
        dissrxn_coefs <- dissrxn[c(TRUE, FALSE)] # get coeffs of reactants and products
        dissrxn_coefs <- as.numeric(dissrxn_coefs) # convert coeffs from str to numeric
        names(dissrxn_coefs) <- dissrxn_names # set vector names to react and prod names
        dissociation_list[[species_name]] <- dissrxn_coefs # assign to dissociation list
      }
    
      # look up tag
      tag_temp <- thermo_df[i, "tag"]
      names(tag_temp) <- thermo_df[i, "name"]
      tag_vec <- c(tag_vec, tag_temp)
  }

  # initialize vector of name differences between OBIGT and SLOP
  CHNOSZ_data0_name_diff <- c()

  add_obigt_df <- thermo_df

  # remove raw line indicators '\r' in data0.min template
  data0_template <- gsub("\r", "", template)
      
  # initialize a vector to store names of species that must be skipped
  # due to one or more NA in its dissrxn logK grid
  skipped_species <- c()
    
  # loop through species in thermo_df
  for(idx in 1:nrow(thermo_df)){

    entry <- thermo_df[idx, ]
    name <- entry$name
      
    if (name %in% c("O2(g)", "H2O", "H+")){
      vmessage(paste(name, "is included as a basis species by default. Moving to the next species..."), 2, verbose)
      next
    }
    if (entry$state %in% paste0("cr", 2:20)){
      next
    }
      
    date <- entry$date
    date <- strtrim(date, 9) # truncates date if greater than 9 letters
    elem <- makeup(thermo_df[idx, "formula_modded"]) # get elemental composition
      
    aux_basis <- FALSE
    if(name %in% lapply(dissrxns[["basis_list"]], `[[`, 1)){
      # if this species is marked as a preferred basis species, move to the next species
      vmessage(paste0("'", name, "' (basis species) processed successfully."), 2, verbose)
      next
    }else if(thermo_df[thermo_df[, "name"]==name, "tag"][1] == "basis"){
      # if this is marked as a basis in the data0 supplemental file, move to the next species
      vmessage(paste0("'", name, "' (basis species) processed successfully."), 2, verbose)
      next
    }else if(thermo_df[thermo_df[, "name"]==name, "tag"][1] == "aux"){
      # if this species is an auxiliary basis species, flag and continue with aqueous formatting
      aux_basis <- TRUE
    }
        
    # format charge for this species' data0 entry
    if("Z" %in% names(elem)){
      charge <- elem["Z"]
      elem <- elem[which(names(elem) != "Z")]
      formatted_charge <- format(round(charge, 1), nsmall = 1, scientific=F)
    } else {
      formatted_charge <- "0.0"
    }
      
    # format the element block of this species' data0 entry
    elem_list <- c()
        
    for(i in 1:length(names(elem))){

      # get element value and name from makeup
      elem_val <- s_d(elem[i], 4)
      elem_name <- names(elem)[i]
        
      # conditional formatting based on position
      if(i == 1 | i %% 4 == 0){ # first entry of a line
        max_length <- 8
        end_char <- ""
        if(nchar(elem_name) != 2){elem_name <- paste0(elem_name, " ")}
      }else if(i %% 3 == 0 && i != length(names(elem))){ # last entry of a line
        max_length <- 15
        end_char <- "\n"
      } else {
        max_length <- 15
        end_char <- ""
        if(nchar(elem_name) != 2){elem_name <- paste0(elem_name, " ")}
      }

      # paste together value and element name
      pasted_entry <- paste(elem_val, elem_name)

      # get decimal position and format spaces accordingly
      decimal_position <- gregexpr(pattern ='\\.', pasted_entry)[[1]]
      pasted_entry <- paste0(paste(rep(" ", max_length-decimal_position), collapse=""), pasted_entry, end_char)

      # add entry to element list
      elem_list <- c(elem_list, pasted_entry)
    }
      
    n_elements <- as.character(length(elem_list))
    element_list <- paste(elem_list, collapse="")
      
    # format the dissociation reaction block of this species' data0 entry
    if(name %in% names(dissociation_list)){
      species_name_list <- names(dissociation_list[[name]])
      species_val_list <- unname(dissociation_list[[name]])
    }

    n_species <- length(species_name_list)

    nchar <- 25 # spaces taken by entries in dissociation reaction (25 char)

    # convert species names to their data0 counterparts
    for(species in species_name_list){
      if(species %in% names(CHNOSZ_data0_name_diff)){
        species_name_list[which(species_name_list == species)] <- CHNOSZ_data0_name_diff[species]
      }
    }
    
    logK_list <- paste0("logK_grid_", name, "")
      
    # loop through species in dissociation reaction and format for data0
    spec_list <- c()
    for(i in 1:n_species){
      # get species value and name
      species_val <- format(round(species_val_list[i], 4), nsmall=4, scientific=F)
      species_name <- species_name_list[i]
      # conditional formatting based on position
      if(i == 1 | i %% 2 != 0){ # first entry of a line
        max_length <- 7
        end_char <- ""
        species_name <- fillspace(species_name, nchar)
      }else if(i %% 2 == 0 && i != n_species){ # last entry of a line
        max_length <- 8
        end_char <- "\n"
      } else {
        max_length <- 8
        end_char <- ""
        species_name <- fillspace(species_name, nchar)
      }
      # paste together coeff and element name
      pasted_entry <- paste0(species_val, "  ", species_name)
      # get decimal position and format spaces accordingly
      decimal_position <- gregexpr(pattern ='\\.', pasted_entry)[[1]]
      pasted_entry <- paste0(paste(rep(" ", max_length-decimal_position), collapse=""), pasted_entry, end_char)
      # add entry to element list
      spec_list <- c(spec_list, pasted_entry)
    }
    
    # instantiate template and begin formatting aq, cr, gas, liq entries
    species_list <- paste(spec_list, collapse="")
    n_species <- as.character(n_species) # convert to string
    template <- "+--------------------------------------------------------------------\n%s\n    date last revised = %s\n%s\n     charge  =   %s\n%s\n     %s element(s):\n%s\n     %s species in aqueous dissociation reaction:      \n%s\n**** logK grid [T, P @ Miscellaneous parameters]=%s\n%s"
    if(entry$state == "aq"){
      formatted_name = name
      volume = "*"
      if(aux_basis){
        keys = " keys   = aux              active"
        insertline_regex <- "\\+-+\naqueous species"
        insertline <- "+--------------------------------------------------------------------\naqueous species"
      } else {
        keys = " keys   = aqueous          active"
        insertline_regex <- "\\+-+\nsolids"
        insertline <- "+--------------------------------------------------------------------\nsolids"
      }
    } else if (entry$state == "cr"){
      formatted_name = paste0(fillspace(name, 24), entry$formula)
      tag = tag_vec[entry$name] # for solids, this is a tag like "refsate", "polymorph", or "idealized"
      formatted_tag = fillspace(tag, 17)
      keys = sprintf(" keys   = solid            %sactive", formatted_tag)
      formatted_V0PrTr = fillspace(entry$V, 9, spaces_after=FALSE)
      volume = sprintf("     V0PrTr = %s cm**3/mol", formatted_V0PrTr)
      insertline_regex <- "\\+-+\nliquids"
      insertline <- "+--------------------------------------------------------------------\nliquids"
    } else if (entry$state == "gas"){
      formatted_name = name
      tag = tag_vec[entry$name] # for gases, this is a tag like "refsate"
      formatted_tag = fillspace(tag, 17)
      keys = sprintf(" keys   = gas              %sactive", formatted_tag)
      volume = "     V0PrTr = 24465.000 cm**3/mol  (source = ideal gas law)"
      insertline_regex <- "\\+-+\nsolid solutions"
      insertline <- "+--------------------------------------------------------------------\nsolid solutions"
    } else if (entry$state == "liq"){
      formatted_name = paste0(fillspace(name, 24), entry$formula)
      tag = tag_vec[entry$name] # for liquids, this is a tag like "refsate"
      formatted_tag = fillspace(tag, 17)
      keys = sprintf(" keys   = liquid           %sactive", formatted_tag)
      formatted_V0PrTr = fillspace(entry$V, 9, spaces_after=FALSE)
      volume = sprintf("     V0PrTr = %s cm**3/mol", formatted_V0PrTr)
      insertline_regex <- "\\+-+\ngases"
      insertline <- "+--------------------------------------------------------------------\ngases"
    } else {
      # throw an error if entry is not aq, gas, cr, liq, or ss.
      stop(paste("Error: in", entry$name, "...", entry$state,
                 "is not a recognized state. Must be aq, gas, cr, liq, or ss."))
    }
      
    # append to aq, solid, gas, or liq portion of data0.min template
    output <- sprintf(template, formatted_name, date, keys, formatted_charge, volume, n_elements, element_list, n_species, species_list, name, logK_list)
    
    if(name == "O2"){
      # temporary placeholder values that are overwritten with calculated values later.
      O2_entry <- "\\+-+\nO2\n.*=O2\n         2.6560    3.0310    3.1080    3.0350\n         2.8740    2.6490    2.3540    1.8830"
      data0_template <- sub(O2_entry, paste0(output), data0_template)
    }else if(name == "H2O(g)"){
      # temporary placeholder values that are overwritten with calculated values later.
      steam_entry <- "\\+-+\nH2O\\(g\\)\n.*=H2O\\(g\\)\n         2.2990    0.9950   -0.0060   -0.6630\n        -1.1560   -1.5340   -1.8290   -2.0630"
      data0_template <- sub(steam_entry, paste0(output), data0_template)
    }else{
      data0_template <- sub(insertline_regex, paste0(output, "\n", insertline), data0_template)
    }
      
    vmessage(paste0("'", name, "' processed successfully."), 2, verbose)
  }
    
  # handle basis species
  basis_entry_template <- "+--------------------------------------------------------------------\n%s\n    date last revised =  %s\n keys   = basis            active\n     charge  =   %s\n     %s element(s):\n%s"
    
  for(basis in lapply(dissrxns[["basis_list"]], `[[`, 1)){

    # go to the next basis species if it is among these hard-coded by EQ3:
    # (these are already in the data0.min template used to build all data0 files)
    if(basis %in% fixed_species){
      next
    }

    # get the date on the basis species entry
    suppressMessages({
      date_basis <- info(info(basis))$date
    })

    # get the basis species formula
    basis_formula <- add_obigt_df[add_obigt_df[, "name"] == basis, "formula_modded"][1]

    # get the elemental makeup of the basis species
    elem_list_basis <- makeup(basis_formula)

    # extract charge from elemental composition of basis species
    if("Z" %in% names(elem_list_basis)){
      charge_basis <- elem_list_basis["Z"]
      elem_list_basis <- elem_list_basis[which(names(elem_list_basis) != "Z")]
      formatted_charge_basis <- format(round(charge_basis, 1), nsmall = 1, scientific=F)
    } else {
      formatted_charge_basis <- "0.0"
    }
      
    # begin formatting for data0 entry
    n_elem_basis <- length(elem_list_basis)
    elem_list_basis_names <- names(elem_list_basis)
    elem_list_basis_coefs <- as.character(format(round(elem_list_basis, 4), nsmall = 4, scientific=F))
    elem_list_basis_formatted <- ""
              
    for(i in 1:length(elem_list_basis_names)){
        if(i == 1){
            sp <- "      "
        }else{
            sp <- "              "
        }
        elem_list_basis_formatted <- paste0(elem_list_basis_formatted, sp, elem_list_basis_coefs[i], " ", elem_list_basis_names[i])
    }

    basis_entry <- sprintf(basis_entry_template, basis, date_basis, formatted_charge_basis, n_elem_basis, elem_list_basis_formatted)

    # add basis entry to data0.min template
    basis_insertline_regex <- "\\+--------------------------------------------------------------------\nO2\\(g\\)"
    basis_insertline <- "+--------------------------------------------------------------------\nO2\\(g\\)"

    data0_template <- sub(basis_insertline_regex, paste0(basis_entry, "\n", basis_insertline), data0_template)
  }

  # handle elements

  # check for elements not already in data0.min template and append
  elem_template <- sub("^.*\nelements\n\\+-+", "", data0_template) # strip away string before element section in template
  elem_template <- sub("\n\\+-+\nbasis species.*$", "", elem_template) # strip away string after element section
  elem_temp_lines <- strsplit(elem_template, "\n")[[1]] # split element section by line
  elem_temp_names <- sub("\\s+.*$", "", elem_temp_lines) # isolate element names by stripping everything after them
  elem_addme <- setdiff(names(dissrxns[["basis_list"]]), elem_temp_names) # check which elements to add to template

  # REQUIRED BY EQ3: ensure that elements appear in the same order as the basis species representing those elements.
  elem_addme <- elem_addme[order(match(elem_addme,names(dissrxns[["basis_list"]])))]
    
  # loop through elements that need to be added to the data0 template
  for(elem in elem_addme){
      
    weight <- trimws(format(round(mass(elem), 5), nsmall=5, scientific=F))
      
    # format a line for the new element
    elem_temp_lines <- c(elem_temp_lines,
                         paste(elem,
                               paste(rep(" ", 16-(nchar(elem) + nchar(weight))), collapse=''),
                               weight,
                               collapse=""))
  }
    
  # join the elements back together into a full element block
  elem_block <- paste(elem_temp_lines, collapse="\n")

  # insert the full element block into the data0 template
  data0_template <- sub("elements\n\\+-+\n.*\n\\+-+\nbasis species",
                        paste0("elements\n+--------------------------------------------------------------------", elem_block, "\n+--------------------------------------------------------------------\nbasis species"),
                        data0_template)
    

  vmessage("Handling solid solutions...", 2, verbose)

  # handle solid solutions
  if(!is.null(solid_solution_df)){
    for(i in 1:nrow(solid_solution_df)){

      entry <- solid_solution_df[i, ]
      name <- entry$name

      vmessage(paste("Processing", name), 2, verbose)

      date <- entry$date
      species_name_list <- strsplit(entry$components, " ")[[1]]
      nextflag <- FALSE
        
      for(species in species_name_list){
        if(!(species %in% add_obigt_df$name)){
          vmessage(paste0("Error encountered when processing the solid solution '",
                          name, "': '", species,
                          "' was not found in the data file as a pure mineral. Skipping it..."),
                   1, verbose)
          nextflag <- TRUE
          break
        } else if (species %in% skipped_species){
          vmessage(paste0("Error encountered when processing the solid solution '",
                          name, "': the dissociation reaction for '", species,
                          "' contained one or more NAs in its logK grid. Skipping it..."),
                   1, verbose)
          nextflag <- TRUE
          break
        }
      }
      if(nextflag){next}

      n_species <- length(species_name_list)
      species_val_list <- rep(1, n_species)
      nchar <- 23 # spaces taken by entries in ss endmember list (23 char)

      # loop through species and format for data0
      spec_list <- c()
      for(i in 1:n_species){

        # get species value and name
        species_val <- format(round(species_val_list[i], 4), nsmall = 4, scientific=F)
        species_name <- species_name_list[i]

        # conditional formatting based on position
        if(i == 1 | i %% 2 != 0){ # first entry of a line
          max_length <- 7
          end_char <- ""
          species_name <- fillspace(species_name, nchar)
        }else if(i %% 2 == 0 && i != n_species){ # last entry of a line
          max_length <- 8
          end_char <- "\n"
        } else {
          max_length <- 8
          end_char <- ""
          species_name <- fillspace(species_name, nchar)
        }

        # paste together value and element name
        pasted_entry <- paste0(species_val, "  ", species_name)

        # get decimal position and format spaces accordingly
        decimal_position <- gregexpr(pattern ='\\.', pasted_entry)[[1]]
        pasted_entry <- paste0(paste(rep(" ", max_length-decimal_position), collapse=""), pasted_entry, end_char)

        # add entry to element list
        spec_list <- c(spec_list, pasted_entry)
      }
      species_list <- paste(spec_list, collapse="")

      n_species <- as.character(n_species) # convert to string

      ss_template <- "+--------------------------------------------------------------------\n%s\n    date last revised = %s\n%s\n  %s components\n%s\n type   = %s\n%s\n%s"

      model_param_list <- c(entry$mp1, entry$mp2, entry$mp3, entry$mp4, entry$mp5, entry$mp6)
      site_param_list  <- c(entry$sp1, entry$sp2, entry$sp3, entry$sp4,  entry$sp5, entry$sp6)

      model_param_list <- paste(s_d(model_param_list, 3), collapse=" ")
      site_param_list  <- paste(s_d(site_param_list, 3), collapse=" ")

      if(as.numeric(entry$n_model_params) > 0){
        model_param_template <- sprintf("  %s model parameters\n%s", entry$n_model_params, model_param_list)
      }else{
        model_param_template <- "  0 model parameters"
      }

      if(as.numeric(entry$n_site_params) > 0){
        site_param_template <- sprintf("  %s site parameters\n%s", entry$n_site_params, site_param_list)
      }else{
        site_param_template <- "  0 site parameters"
      }

      # ss:
      formatted_name = paste0(fillspace(name, 24), entry$formula)

      tag = entry$tag # for solid solutions, this is a tag like "cubic maclaurin", "ideal", "regular"
      formatted_tag = fillspace(tag, 17)
      keys = sprintf(" keys   = ss               %sactive", formatted_tag)

      insertline_regex <- "\\+-+\nreferences"
      insertline <- "+--------------------------------------------------------------------\nreferences"

      # create output for solid solution entries

      output <- sprintf(ss_template,
                        formatted_name,
                        date,
                        keys,
                        n_species,
                        species_list,
                        entry$type,
                        model_param_template,
                        site_param_template)

      data0_template <- sub(insertline_regex, paste0(output, "\n", insertline), data0_template)

    }
  } else {
    vmessage("No solid solutions supplied. Moving on...", 2, verbose)
  }

  add_bdot_line <- function(spec_name, spec_azero, neutral_ion_type){
      bdot_entry <- paste(spec_name,
          paste(rep(" ", 36-(nchar(spec_name) + nchar(spec_azero))), collapse=''),
          spec_azero,
          "  ",
          fillspace(neutral_ion_type, 2, spaces_after=FALSE),
          collapse="")

      # add bdot entry to data0.min template
      bdot_insertline_regex <- "\\+--------------------------------------------------------------------\nelements"
      bdot_insertline <- "+--------------------------------------------------------------------\nelements"
      data0_template <<- sub(bdot_insertline_regex, paste0(bdot_entry, "\n", bdot_insertline), data0_template)
  }

  # format basis and non-basis species for bdot parameter section
  bdot_formatted <- c()

  if(water_model %in% c("SUPCRT92", "IAPWS95")){
    # azero and neutral ion type parameter defaults for fixed species
    Cl_azero <- 3
    O2_azero <- 3
    O2g_azero <- 3
    OH_azero <- 3
    H2O_azero <- 3
    H_azero <- 9
    Cl_neutral_ion_type <- 0
    O2_neutral_ion_type <- -1
    O2g_neutral_ion_type <- 0
    H2O_neutral_ion_type <- 0
    H_neutral_ion_type <- 0
  }else if(water_model == "DEW"){
    Cl_azero <- 3.7
    O2_azero <- -0.5
    O2g_azero <- 0
    OH_azero <- 3.7
    H2O_azero <- 0
    H_azero <- 3.7
    Cl_neutral_ion_type <- 0
    O2_neutral_ion_type <- 0
    O2g_neutral_ion_type <- 0
    H2O_neutral_ion_type <- 0
    H_neutral_ion_type <- 0
  }

  for (sp in c("Cl-", "O2", "O2(g)", "H2O", "H+")){
      if(sp == "Cl-"){
        spec_name <- "Cl-"
        spec_azero <- as.character(format(round(Cl_azero, 4), nsmall = 4, scientific=F))
        neutral_ion_type <- Cl_neutral_ion_type
      }else if(sp == "O2"){
        spec_name <- "O2"
        spec_azero <- as.character(format(round(O2_azero, 4), nsmall = 4, scientific=F))
        neutral_ion_type <- O2_neutral_ion_type
      }else if(sp == "O2(g)"){
        spec_name <- "O2(g)"
        spec_azero <- as.character(format(round(O2g_azero, 4), nsmall = 4, scientific=F))
        neutral_ion_type <- O2g_neutral_ion_type
      }else if(sp == "H2O"){
        spec_name <- "H2O"
        spec_azero <- as.character(format(round(H2O_azero, 4), nsmall = 4, scientific=F))
        neutral_ion_type <- H2O_neutral_ion_type
      }else if(sp == "H+"){
        spec_name <- "H+"
        spec_azero <- as.character(format(round(H_azero, 4), nsmall = 4, scientific=F))
        neutral_ion_type <- H_neutral_ion_type
      }
      add_bdot_line(spec_name, spec_azero, neutral_ion_type)
  }

  for(i in 1:length(azero_vec)){
      if(add_obigt_df[i, "name"] %in% c("Cl-", "O2", "H2O", "H+")){
        next
      }else if(add_obigt_df[i, "state"] == "aq"){
        spec_name <- names(azero_vec)[i]
        spec_azero <- as.character(format(round(azero_vec[i], 4), nsmall = 4, scientific=F))

        if(spec_azero == "NaN"){
          if(add_obigt_df[i, "z.T"] != 0){
            if(water_model %in% c("SUPCRT92", "IAPWS95")){
              spec_azero <- "4.0000"
            }else if(water_model == "DEW"){
              spec_azero <- "3.7000"
            }
          }else{
            if(water_model %in% c("SUPCRT92", "IAPWS95")){
              spec_azero <- "0.0000"
            }else if(water_model == "DEW"){
              spec_azero <- "-0.5000"
            }
          }
        }
          
        neutral_ion_type <- neutral_ion_type_vec[i]
        add_bdot_line(spec_name, spec_azero, neutral_ion_type)
      }
  }

  return(data0_template)
    
}

      subroutine adgexp(ne,noutpt,nttyo,ugexpd)
c
c     This subroutine assigns a default name to the ne-th generic ion
c     exchange phase. The general model is "Exchanger(n)", where n
c     is the index number ne.
c
c     This subroutine is called by:
c
c       EQLIB/intexi.f
c       EQ3NR/intge3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ne     = index number of the current generic ion exchange phase
c
c     Principal output:
c
c       ugexpd = default name of the ne-th generic ion exchange phase
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ne
c
      character*24 ugexpd
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      ugexpd = ' '
      ugexpd(1:10) = 'Exchanger('
      if (ne .le. 9) then
        write (ugexpd(11:11),'(i1)') ne
        ugexpd(12:12) = ')'
      elseif (ne .le. 99) then
        write (ugexpd(11:12),'(i2)') ne
        ugexpd(13:13) = ')'
      elseif (ne .le. 999) then
        write (ugexpd(11:13),'(i3)') ne
        ugexpd(14:14) = ')'
      elseif (ne .le. 9999) then
        write (ugexpd(11:14),'(i4)') ne
        ugexpd(15:15) = ')'
      elseif (ne .le. 99999) then
        write (ugexpd(11:15),'(i5)') ne
        ugexpd(16:16) = ')'
      elseif (ne .le. 999999) then
        write (ugexpd(11:16),'(i6)') ne
        ugexpd(17:17) = ')'
      elseif (ne .le. 9999999) then
        write (ugexpd(11:17),'(i7)') ne
        ugexpd(18:18) = ')'
      elseif (ne .le. 99999999) then
        write (ugexpd(11:18),'(i8)') ne
        ugexpd(19:19) = ')'
      else
        write (noutpt,1000) ne
        write (nttyo,1000) ne
 1000   format (/' * Error - (EQLIB/adgexp) Programming error trap:',
     $  ' The index',/7x,'number ',i12,' of a generic ion exchange',
     $  ' phase',/7x,'is too large to fit in the 8-character field',
     $  ' reserved for it',/7x,'in the default site name.')
        stop
      endif
c
      end

      subroutine iiemop(iemop,iemos,iindx1,ipndx1,jsflag,kdim,kmax,
     $ ncmpe,ncmpr,noutpt,npet,npetmx,npt,nptmax,nset,nsetmx,nstmax,
     $ nttyo,uaqsln,uspec,uphase)
c
c     This subroutine initializes the indexing used for tracking the
c     numbers of moles of phases present in the Equilibrium System (ES).
c     This indexing must be re-initialized whenever a change occurs
c     in the ES phase assemblage. The iemop array contains the indices
c     of the phases in the ES. The iemos array contains the indicies
c     of the active species in these phases, except that only the
c     species H2O(l) is included in the case of the aqueous solution
c     phase. solution. The ncmpe array is a species range pointer
c     array for the phases analogous to ncmpr.
c
c     The iemop and emop arrays respectively contain the indices and
c     numbers of moles of the phases currently in the ES. The iemos
c     and emos array are the analogs for the species of these phases.
c     However, only the species H2O(l) is represented for the aqueous
c     solution.  The ncmpe array is a species range pointer array for
c     the phases analogous to ncmpr.
c
c     The fdpe0 and fdse0 arrays respectively contain the finite
c     differences for the data in the emop and emos arrays. The demop
c     and demos arrays contain the corresponding derivatives with
c     respect to the reaction progress variable, xi.
c
c     This subroutine is called by:
c
c       EQ6/dumpdp.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,npetmx,nptmax,nsetmx,nstmax
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iemos(nsetmx),iindx1(kmax),ipndx1(kmax),
     $ jsflag(nstmax),ncmpe(2,npetmx),ncmpr(2,nptmax)
c
      integer kdim,npet,npt,nset
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      character*24 uaqsln
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,j2,kcol,np,npe,nplast,nr1,nr2,ns,nse
c
      integer ilnobl
c
      character*56 uspn56
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Loop over all phases present in the ES.
c
      npe = 0
      nse = 0
      nplast = 0
      do kcol = 1,kdim
        np = ipndx1(kcol)
        if (np .ne. nplast) then
          npe = npe + 1
          iemop(npe) = np
          nplast = np
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          if (uphase(np)(1:24) .eq. uaqsln(1:24)) nr2 = nr1
          ncmpe(1,npe) = nse + 1
          do ns = nr1,nr2
            if (jsflag(ns) .le. 0) then
              nse = nse + 1
c
              if (nse .gt. nsetmx) then
c
c               Calling sequence substitutions:
c                 uspec(ns) for unam48
c
                call fmspnm(jlen,uspec(ns),uspn56)
                write (ux8,'(i5)') nsetmx
                call lejust(ux8)
                j2 = ilnobl(ux8)
                write (noutpt,1000) ux8(1:j2),uspn56(1:jlen)
                write (nttyo,1000) ux8(1:j2),uspn56(1:jlen)
 1000           format(/' * Error - (EQ6/iiemop) Have too many species',
     $          ' to track by finite differences.',/7x,'Exceeded the',
     $          ' dimensioned limit of ',a,' upon trying to set up',
     $          /7x,'tracking for ',a,'. Increase the dimensioning',
     $          /7x,'parameter nsetpa.')
              endif
c
              iemos(nse) = ns
            endif
          enddo
          ncmpe(2,npe) = nse
        endif
      enddo
      npet = npe
      nset = nse
c
      end

      subroutine gmmmat(act,afrc1,cdac,cdacb,cdrs,csigma,eps100,
     $ fkrc,idirec,iindx1,iktmax,imchmx,imech,jcode,jreac,kbt,kdim,
     $ kmax,mmmatr,nbasp,nbt,nbtmax,ncmpr,ndac,ndacb,ndact,ndctmx,
     $ ndrs,ndrsmx,ndrsr,noutpt,nptmax,nrct,nrctmx,nrk,nrndex,nstmax,
     $ nttyo,nxridx,nxrtmx,rk,rtcnst,rxbar,sfcar,ureac,xlks)
c
c     This subroutine calculates the matrix M (mmmatr) used in turn to
c     calculate the Jacobian matrix J[r] (armatr) used by the higher-
c     order (stiff) ODE integrator. The dependence of J[r] on exact
c     kinetic rate law expressions (coded in EQ6\crrate.f) is handled
c     through the M matrix. This matrix expresses the dependency of the
c     rate laws on the thermodynamic activities of species, which
c     presently must all be of type aqueous.
c
c       The present subroutine must be tightly coordinated with
c     EQ6\ccrate.f in order to maintain proper consistency and thus
c     the correctness of the calculated M matrix. If such coordination
c     and consistency is compromised, the higher-order (stiff) ODE
c     solver may fail to converge.
c
c     This subroutine is called by:
c
c       EQ6/garmat.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       mmmatr = the matrix M, which is used to calculate the Jacobian
c                  matrix J[r] used by the higher-order (stiff) ODE
c                  integrator
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nbtmax,ndctmx,ndrsmx,nrctmx,nptmax,
     $ nstmax,nxrtmx
c
      integer noutpt,nttyo
c
      integer kbt,kdim,nbt,nrct
c
      integer idirec(nrctmx),iindx1(kmax),imech(2,nrctmx),jcode(nrctmx),
     $ jreac(nrctmx),nbasp(nbtmax),ndac(ndctmx,imchmx,2,nrctmx),
     $ ncmpr(2,nptmax),ndacb(nbt,imchmx,2,nrct),ndact(imchmx,2,nrctmx),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),nrk(2,nrctmx),nrndex(nrctmx),
     $ nxridx(nrctmx)
c
      character*24 ureac(nrctmx)
c
      real(8) act(nstmax),afrc1(nrctmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ cdacb(nbt,imchmx,2,nrct),cdrs(ndrsmx),csigma(imchmx,2,nrctmx),
     $ fkrc(nrctmx),mmmatr(nrct,kmax),rk(imchmx,2,nrctmx),sfcar(nrctmx),
     $ rxbar(iktmax,nxrtmx),xlks(nstmax)
c
      real(8) eps100,rtcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ik,j2,j3,k,n,nb,np,nr1,nr2,nrc,ns,nse,nxr
c
      integer ilnobl
c
      logical qovstp
c
      character(len=8) ux8
c
      real(8) affr,aprod,cx,cxs,efx,fs,mijk,skfq,thetij,vij,xk,xlk
c
      real(8) coefdr,texp
c
c-----------------------------------------------------------------------
c
c     First zero the matrix M.
c
      do nrc = 1,nrct
        do k = 1,kmax
          mmmatr(nrc,k) = 0.
        enddo
      enddo
c
c     Loop on reactants (rows of M).
c
      do nrc = 1,nrct
c
        affr = afrc1(nrc)
        qovstp = affr.lt.0. .and. nrk(2,nrc).eq.0 .and. jreac(nrc).le.0
        if (jreac(nrc).le.0 .and.
     $    (abs(affr).gt.eps100 .or. qovstp))then
c
c         Have an active reactant. It is not exhausted or formally
c         saturated as indicated by its jreac flag. Also, it either
c         has a finite affinity or the overstep condition pertains.
c         Compute the corresponding row of M. For a reactant not
c         satisfying these conditions, the rate is taken to be zero,
c         and the corresponding row of M should be left filled with
c         zeroes.
c
          fs = fkrc(nrc)*sfcar(nrc)
c
          if (idirec(nrc) .eq. 1) then
c
c           The rate law expression used follows the net forward rate
c           format.
c
            if (nrk(1,nrc) .eq. 1) then
c
c             Have a specified relative rate (arbitrary kinetics).
c             Leave the current row of M filled with zeroes.
c
              continue
            elseif (nrk(1,nrc) .eq. 2) then
c
c             Have the TST-like rate equation (multi-term). Compute
c             the contribution of each successive term to the current
c             row of M and accumulate all contributions.
c
c             First get the equilibrium constant K (xk).
c
              np = nrndex(nrc)
              xlk = 0.
              if (jcode(nrc) .eq. 0) then
                ns = ncmpr(1,np)
                xlk = xlks(ns)
              elseif (jcode(nrc) .eq. 1) then
                nxr = nxridx(nrc)
                ik = 0
                nr1 = ncmpr(1,np)
                nr2 = ncmpr(2,np)
                do ns = nr1,nr2
                  ik = ik + 1
                  xlk = xlk + rxbar(ik,nxr)*xlks(ns)
                enddo
              else
                write (noutpt,"(' Illegal jcode value in gmmmat.f')")
                write (nttyo,"(' Illegal jcode value in gmmmat.f')")
                stop
              endif
              xk = texp(xlk)
c
c             Loop over terms in the rate law.
c
              do i = 1,imech(1,nrc)
c
c               Calculate the kinetic activity product (aprod).
c
                aprod = 1.
                do n = 1,ndact(i,1,nrc)
                  ns = ndac(n,i,1,nrc)
                  aprod = aprod*act(ns)**cdac(n,i,1,nrc)
                enddo
c
                skfq = rk(i,1,nrc)*fs*aprod
                efx = affr/(csigma(i,1,nrc)*rtcnst)
                vij = skfq*(1.0 - exp(-efx))
c
                do k = 1,kbt
                  nb = iindx1(k)
                  nse = nbasp(nb)
                  if (jcode(nrc) .eq. 0) then
                    ns = ncmpr(1,np)
                    cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
                  elseif (jcode(nrc) .eq. 1) then
                    nxr = nxridx(nrc)
                    cx = 0.
                    ik = 0
                    nr1 = ncmpr(1,np)
                    nr2 = ncmpr(2,np)
                    do ns = nr1,nr2
                      ik = ik + 1
                      cxs = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
                      cx = cx + rxbar(ik,nxr)*cxs
                    enddo
                  else
                    write (noutpt,
     $              "(' Illegal jcode value in gmmmat.f')")
                    write (nttyo,"(' Illegal jcode value in gmmmat.f')")
                    stop
                  endif
                  thetij = -skfq*exp(-efx)/csigma(i,1,nrc)
                  mijk = -vij*ndacb(nse,i,1,nrc) + cx*thetij
                  mmmatr(nrc,k) = mmmatr(nrc,k) + mijk
                enddo
              enddo
c
            elseif (nrk(1,nrc) .eq. 3) then
c
c             Have a specified rate (no affinity dependence).
c             Leave the current row of M filled with zeroes.
c
            else
c
c             Unrecognized rate law code.
c
              j2 = ilnobl(ureac(nrc))
              write (ux8,'(i5)') nrk(1,nrc)
              call lejust(ux8)
              j3 = ilnobl(ux8)
              write (noutpt,1000) ureac(nrc)(1:j2),ux8(1:j3)
              write (nttyo,1000) ureac(nrc)(1:j2),ux8(1:j3)
 1000         format(/' * Error - (EQ6/gmmmat) The reactant ',a,
     $        ' has an',/7x,'unrecognized forward rate law code'
     $        ' of ',a,'.')
              stop
            endif
          else
c
c           The rate law expression used follows the net backward rate
c           format.
c
            if (nrk(2,nrc) .eq. 1) then
c
c             Have specified the case of instantaneous equilibrium.
c             For now, leave the current row of M filled with zeroes.
c
              continue
            elseif (nrk(2,nrc) .eq. 2) then
c
c             Have the TST-like rate equation (multi-term). Compute
c             the contribution of each successive term to the current
c             row of M and accumulate all contributions.
c
c             First get the equilibrium constant K (xk).
c
              np = nrndex(nrc)
              xlk = 0.
              if (jcode(nrc) .eq. 0) then
                ns = ncmpr(1,np)
                xlk = xlks(ns)
              elseif (jcode(nrc) .eq. 1) then
                nxr = nxridx(nrc)
                ik = 0
                nr1 = ncmpr(1,np)
                nr2 = ncmpr(2,np)
                do ns = nr1,nr2
                  ik = ik + 1
                  xlk = xlk + rxbar(ik,nxr)*xlks(ns)
                enddo
              else
                write (noutpt,"(' Illegal jcode value in gmmmat.f')")
                write (nttyo,"(' Illegal jcode value in gmmmat.f')")
                stop
              endif
              xk = texp(xlk)
c
c             Loop over terms in the rate law.
c
              do i = 1,imech(2,nrc)
c
c               Calculate the kinetic activity product (aprod).
c
                aprod = 1.
                do n = 1,ndact(i,2,nrc)
                  ns = ndac(n,i,2,nrc)
                  aprod = aprod*act(ns)**cdac(n,i,2,nrc)
                enddo
c
                skfq = rk(i,2,nrc)*fs*aprod
                efx = affr/(csigma(i,2,nrc)*rtcnst)
                vij = skfq*(1.0 - exp(efx))
c
                do k = 1,kbt
                  nb = iindx1(k)
                  nse = nbasp(nb)
                  if (jcode(nrc) .eq. 0) then
                    ns = ncmpr(1,np)
                    cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
                  elseif (jcode(nrc) .eq. 1) then
                    nxr = nxridx(nrc)
                    cx = 0.
                    ik = 0
                    nr1 = ncmpr(1,np)
                    nr2 = ncmpr(2,np)
                    do ns = nr1,nr2
                      ik = ik + 1
                      cxs = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
                      cx = cx + rxbar(ik,nxr)*cxs
                    enddo
                  else
                    write (noutpt,
     $              "(' Illegal jcode value in gmmmat.f')")
                    write (nttyo,"(' Illegal jcode value in gmmmat.f')")
                    stop
                  endif
                  thetij = -skfq*exp(efx)/(csigma(i,2,nrc))
                  mijk = -vij*ndacb(nse,i,2,nrc) + cx*thetij
                  mmmatr(nrc,k) = mmmatr(nrc,k) + mijk
                enddo
              enddo
c
            elseif (nrk(2,nrc) .eq. 3) then
c
c             Have a specified rate (no affinity dependence).
c             Leave the current row of M filled with zeroes.
c
            else
c
c             Unrecognized rate law code.
c
              j2 = ilnobl(ureac(nrc))
              write (ux8,'(i5)') nrk(2,nrc)
              call lejust(ux8)
              j3 = ilnobl(ux8)
              write (noutpt,1020) ureac(nrc)(1:j2),ux8(1:j3)
              write (nttyo,1020) ureac(nrc)(1:j2),ux8(1:j3)
 1020         format(/' * Error - (EQ6/gmmmat) The reactant ',a,
     $        ' has an',/7x,'unrecognized backward rate law code'
     $        ' of ',a,'.')
              stop
            endif
          endif
        endif
      enddo
c
      end

      subroutine gabswx(beta,ibswx,iindx1,kbt,kmax,nbt,nbtmax)
c
c     This subroutine supports automatic basis switching as a
c     pre-Newton-Raphson optimization technique. It resolves conflicts
c     in the ibswx array, which contains candidate switches. This array
c     could call for the same non-basis species to be switched with
c     more than one basis species. The approach here is to use the size
c     of the associated relative mass balance residual to any resolve
c     conflicts. This subroutine is somewhat similar to EQLIB/gbfac.f,
c     which resolves conflicts affecting continued fraction
c     calculations.
c
c     This subroutine is called by:
c
c       EQLIB/absswa.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ibswx = array of indices of species not in the active
c                 master set that are candidates for switching into
c                 the basis set
c       beta  = array of normalized Newton-Raphson residual functions
c       kbt   = number of species in the active basis set
c
c     Principal output:
c
c       ibswx = input array modified to remove conflicts.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax
c
      integer ibswx(nbtmax),iindx1(kmax)
c
      integer kbt,nbt
c
      real(8) beta(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer kcol,kk,krow,nb,nbig,nb1,nb2,ns1,ns2
c
      real(8) bbig,frac
c
c-----------------------------------------------------------------------
c
c     Find the largest residual among potential basis switching cases.
c
      nbig = 0
      bbig = 0.
      do kcol = 1,kbt
        nb = iindx1(kcol)
        if (ibswx(nb) .gt. 0) then
          if (beta(kcol) .gt. bbig) then
            nbig = nb
            bbig = beta(kcol)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Eliminate candidates not involving largest residuals.
c
      if (bbig .le. 0.5) then
c
c       If the largest residual is not very large, wipe out all other
c       proposed switches.
c
        do nb = 1,nbt
          if (nb .ne. nbig) ibswx(nb) = 0
        enddo
        go to 999
      else
c
c       If the largest residual is rather large, wipe out all other
c       proposed switches with residuals that are not within two
c       orders of magnitude of the largest residual.
c
        do kcol = 1,kbt
          nb = iindx1(kcol)
          if (ibswx(nb) .gt. 0) then
            frac = beta(kcol)/bbig
            if (frac .le. 1.e-2) ibswx(nb) = 0
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Eliminate any remaining conflicts.
c
      do krow = 1,kbt - 1
        nb1 = iindx1(krow)
        ns1 = ibswx(nb1)
        if (ns1 .gt. 0) then
          kk = krow + 1
          do kcol = kk,kbt
            nb2 = iindx1(kcol)
            ns2 = ibswx(nb2)
            if (ns2 .eq. ns1) then
              if (beta(krow) .gt. beta(kcol)) then
                ibswx(nb2) = 0
              else
                ibswx(nb1) = 0
                go to 25
              endif
            endif
          enddo
        endif
   25   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine tpraa(alamaa,atheta,iaapr,ipbtmx,jpfcmx,naapr,
     $ natmax,ncvaa,nerr,noutpt,npx3mx,nthdt,nttyo,nwarn,pcvaa,
     $ qpdaa,uaqsp,uthdtr)
c
c     Test and process the Pitzer data for aa' (anion, different
c     anion) pairs read from the DATA0 file. Find and flag errors,
c     such as duplication of data (e.g., two data blocks for the same
c     aa' pair). Calculate the conventional primitive Pitzer parameters
c     from the observable compound parameters read from the data file:
c
c       theta(aa') -> lambda(aa')
c
c     Check the coverage of entered Pitzer data against all possible
c     anion-distinct anion pairs that can be composed of the aqueous
c     anions present on the data file.
c
c     This subroutine is complementary to tprcc.f, which does the
c     same thing for cc' (cation, different cation) pairs.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,naapr,natmax,npx3mx
c
      integer noutpt,nttyo
c
      integer iaapr(2,naapr)
c
      integer ncvaa,nerr,nthdt,nwarn
c
      logical qpdaa(naapr)
c
      character(len=24) uaqsp(natmax),uthdtr(3,npx3mx)
c
      real*8 alamaa(jpfcmx,0:ipbtmx,naapr),atheta(jpfcmx,npx3mx)
c
      real*8 pcvaa
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,jth,jthpr,j2,j3,j4,j5,n,ncount,ndupl,nlistl,
     $ nn,nodatc
c
      integer ilnobl
c
      logical qmatch,qzerov
c
      character*56 ustr56
      character*24 unam1,unam2
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Limit on the list of pairs for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the data arrays.
c
      do n = 1,naapr
        qpdaa(n) = .false.
        do j = 1,jpfcmx
          do i = 0,ipbtmx
            alamaa(j,i,n) = 0.
          enddo
        enddo
      enddo
c
c     Check the entered data for aa' pairs.
c
      nodatc = 0
c
      do n = 1,naapr
        i = iaapr(1,n)
        j = iaapr(2,n)
        unam1 = uaqsp(i)
        unam2 = uaqsp(j)
c
        jthpr = 0
        ndupl = 0
c
c       Search for unam1, unam2 in the species triplet blocks.
c       This is actually done by searching the uthdtr array,
c       not the utripl array.
c
        do jth = 1,nthdt
          if (unam1(1:24) .eq. uthdtr(1,jth)(1:24)) then
            if (unam2(1:24) .eq. uthdtr(2,jth)(1:24)) then
              jthpr = jth
              go to 110
            endif
          endif
        enddo
  110   continue
c
        if (jthpr .gt. 0) then
c
c         Have found an entry in the triplet blocks.
c
          qpdaa(n) = .true.
c
c         Store the data.
c
          do j = 1,jpfcmx
            alamaa(j,0,n) = atheta(j,jthpr)
            do i = 1,ipbtmx
              alamaa(j,i,n) = 0.
            enddo
          enddo
c
c         Search for duplicates in the species triplets blocks.
c         Ignore duplications in the triplet blocks if the
c         values are all zeros (take this to mean "no data input")
c         or if the values all match the first-encountered
c         values (exact duplication).
c
          do jth = jthpr + 1,nthdt
            if (unam1(1:24) .eq. uthdtr(1,jth)(1:24)) then
              if (unam2(1:24) .eq. uthdtr(2,jth)(1:24)) then
                qzerov = .true.
                do j = 1,jpfcmx
                  if (atheta(j,jth) .ne. 0.) qzerov = .false.
                enddo
                qmatch = .true.
                do j = 1,jpfcmx
                  if ((atheta(j,jth) - atheta(j,jthpr)) .gt. 1.e-6)
     $            qmatch = .false.
                enddo
                if (.not.qzerov .and. .not.qmatch)
     $          ndupl = ndupl + 1
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam2(1:j3)
              write (nttyo,1010) unam1(1:j2),unam2(1:j3)
 1010         format(/' * Error - (EQPT/tpraa) Have found a',
     $        ' duplicate data block on the DATA0 file',
     $        /7x,"for the aa' pair ",a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j5 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
              write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
 1020         format(/' * Error - (EQPT/tpraa) Have found ',a,
     $        ' duplicate data blocks on the DATA0 file',
     $        /7x,"for the aa' pair ",a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
        endif
c
        if (jthpr.le.0) then
c
c         No data block was found on the DATA0 file.
c         Note that qpdaa(n) is left with a value of .false.
c
          nodatc = nodatc + 1
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1040)
        write (nttyo,1040)
 1040   format(/' * Warning - (EQPT/tpraa) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  " aa' pairs:",/)
c
        ncount = 0
        do n = 1,naapr
          if (.not.qpdaa(n)) then
            ncount = ncount + 1
            i = iaapr(1,n)
            j = iaapr(2,n)
            unam1 = uaqsp(i)
            unam2 = uaqsp(j)
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            ustr56 = unam1(1:j2) // ', ' // unam2(1:j3)
            j4 = ilnobl(ustr56)
            write (noutpt,1050) ustr56(1:j4)
            write (nttyo,1050) ustr56(1:j4)
 1050       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1060) ux8(1:j3)
          write (nttyo,1060) ux8(1:j3)
 1060     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1070)
        write (nttyo,1070)
 1070   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvaa = naapr - nodatc
      pcvaa = (100.*ncvaa)/float(naapr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine adgexj(je,noutpt,nttyo,ugexjd)
c
c     This subroutine assigns a default name for the je-th site of a
c     generic exchange phase. The general model is "S(n)", where n
c     is the site number. However, if n is larger than 99999, the S
c     and both parentheses are all dropped.
c
c     This subroutine is called by:
c
c       EQLIB/intexi.f
c       EQ3NR/intge3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       je     = site index
c
c     Principal output:
c
c       ugexjd = default name of the je-th site of a generic ion
c                  exchange phase
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer je
c
      character*8 ugexjd
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      ugexjd = ' '
      ugexjd(1:2) = 'S('
      if (je .le. 9) then
        write (ugexjd(3:3),'(i1)') je
        ugexjd(4:4) = ')'
      elseif (je .le. 99) then
        write (ugexjd(3:4),'(i2)') je
        ugexjd(5:5) = ')'
      elseif (je .le. 999) then
        write (ugexjd(3:5),'(i3)') je
        ugexjd(6:6) = ')'
      elseif (je .le. 9999) then
        write (ugexjd(3:6),'(i4)') je
        ugexjd(7:7) = ')'
      elseif (je .le. 99999) then
        write (ugexjd(3:7),'(i5)') je
        ugexjd(8:8) = ')'
      elseif (je .le. 999999) then
        ugexjd = 'S '
        write (ugexjd(2:7),'(i6)') je
      elseif (je .le. 9999999) then
        ugexjd = 'S '
        write (ugexjd(2:8),'(i7)') je
      elseif (je .le. 99999999) then
        ugexjd = ' '
        write (ugexjd(1:8),'(i8)') je
      else
        write (noutpt,1000) je
        write (nttyo,1000) je
 1000   format (/' * Error - (EQLIB/adgexj) Programming error trap:',
     $  ' The site',/7x,'number ',i12,' for a generic ion exchange',
     $  ' phase',/7x,'is too large to fit in the 8-character field',
     $  ' reserved for it',/7x,'in the default site name.')
        stop
      endif
c
      end

      subroutine tprn2(abeta,acphi,alamn2,amun3,in2pr,ipbtmx,
     $ jpfcmx,natmax,ncvn2,nerr,nn2pr,nn3tr,noutpt,npx2mx,npx2t,
     $ nttyo,nwarn,pcvn2,qpdn2,uaqsp,upair)
c
c     Test and process Pitzer data read from the data file that
c     pertain to a single neutral species (nn and nnn combinations,
c     such as CO2(aq)-CO2(aq) and CO2(aq)-CO2(aq)-CO2(aq). Find and
c     flag errors, such as duplication of data (e.g., two data
c     blocks for the same pair composed of a repeated neutral).
c     The conventional primitive Pitzer parameters are identical
c     to the observable parameters read from the data file:
c
c       lambda(nn) -> lambda(nn)
c       mu(nnn)    -> mu(nnn)
c
c     Check the coverage of entered Pitzer data against all possible
c     pairs that can be composed by repeating a neutral species present
c     on the data file.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,nn2pr,nn3tr,npx2mx
c
      integer noutpt,nttyo
c
      integer in2pr(nn2pr)
c
      integer ncvn2,nerr,npx2t,nwarn
c
      logical qpdn2(nn2pr)
c
      character(len=24) uaqsp(natmax),upair(2,npx2mx)
c
      real*8 abeta(jpfcmx,0:ipbtmx,npx2mx),acphi(jpfcmx,npx2mx),
     $ alamn2(jpfcmx,0:ipbtmx,nn2pr),amun3(jpfcmx,nn3tr)
c
      real*8 pcvn2
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,jp,jpair,j2,j3,j4,j5,n,ncount,ndupl,nlistl,
     $ nn,nodatc
c
      integer ilnobl
c
      character*56 ustr56
      character*24 unam1
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Limit on the list of pairs for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the data arrays.
c
      do n = 1,nn2pr
        qpdn2(n) = .false.
        do j = 1,jpfcmx
          do i = 0,ipbtmx
            alamn2(j,i,n) = 0.
          enddo
        enddo
      enddo
c
c     Note: nn3tr = nn2pr.
c
      do n = 1,nn3tr
        do j = 1,jpfcmx
          amun3(j,n) = 0.
        enddo
      enddo
c
c     Check the entered data for nn pairs.
c
      nodatc = 0
c
      do n = 1,nn2pr
        i = in2pr(n)
        unam1 = uaqsp(i)
c
c       Search for unam1 in the upair array.
c
        call srch22(jpair,unam1,unam1,upair,npx2mx,npx2t)
c
        if (jpair .gt. 0) then
c
c         Have found an entry.
c
          qpdn2(n) = .true.
c
c         Store the data.
c
          do j = 1,jpfcmx
            do i = 0,ipbtmx
              alamn2(j,i,n) = abeta(j,i,jpair)
            enddo
          enddo
c
          do j = 1,jpfcmx
            amun3(j,n)   = acphi(j,jpair)
          enddo
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jp = jpair + 1,npx2t
            if (unam1(1:24) .eq. upair(1,jp)(1:24)) then
              if (unam1(1:24) .eq. upair(2,jp)(1:24)) then
                ndupl = ndupl + 1
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            j2 = ilnobl(unam1)
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam1(1:j2)
              write (nttyo,1010) unam1(1:j2),unam1(1:j2)
 1010         format(/' * Error - (EQPT/tprn2) Have found a',
     $        ' duplicate data block on the DATA0 file',
     $        /7x,'for the nn pair ',a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j5 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam1(1:j2)
              write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam1(1:j2)
 1020         format(/' * Error - (EQPT/tprn2) Have found ',a,
     $        ' duplicate data blocks on the DATA0 file',
     $        /7x,'for the nn pair ',a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
        else
c
c         No data block was found on the DATA0 file.
c         Note that qpdn2(n) is left with a value of .false.
c
          nodatc = nodatc + 1
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1050)
        write (nttyo,1050)
 1050   format(/' * Warning - (EQPT/tprn2) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  ' nn pairs:',/)
c
        ncount = 0
        do n = 1,nn2pr
          if (.not.qpdn2(n)) then
            ncount = ncount + 1
            i = in2pr(n)
            unam1 = uaqsp(i)
            j2 = ilnobl(unam1)
            ustr56 = unam1(1:j2) // ', ' // unam1(1:j2)
            j4 = ilnobl(ustr56)
            write (noutpt,1060) ustr56(1:j4)
            write (nttyo,1060) ustr56(1:j4)
 1060       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1070) ux8(1:j3)
          write (nttyo,1070) ux8(1:j3)
 1070     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1080)
        write (nttyo,1080)
 1080   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvn2 = nn2pr - nodatc
      pcvn2 = (100.*ncvn2)/float(nn2pr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine getbasename(filename, indices)
            implicit none
            character(*), intent(in) :: filename
            integer, intent(out) :: indices(2)
            integer :: n, temp, slashtemp, extindex, slashindex

            n = len(filename)
            temp = index(filename, '/')
            slashtemp = 0
            slashindex = 0
            do while (temp.ne.0 .and. slashtemp.ne.n)
                slashtemp = slashtemp + temp
                slashindex = slashtemp
                temp = index(filename(slashtemp+1:), '/')
            end do

            extindex = index(filename(slashindex+1:), '.')
            if (extindex.eq.0) then
                extindex = n + 1
            else
                extindex = slashindex + extindex
            end if

            indices(1) = slashindex + 1
            indices(2) = extindex - 1
      end subroutine

      subroutine gpheh(acflg,actlg,actwlg,adh,ah,ahmes,ahnbs,conc,
     $ eh,ehfac,ehmes,ehnbs,farad,fo2lg,fxi,iopg,mrmlra,nchlor,nhydr,
     $ nopgmx,noutpt,nstmax,nttyo,pch,pe,pemes,penbs,ph,phcl,phmes,
     $ phnbs,qphcl,qredox,qrho,xlke)
c
c     This subroutine computes the pH, redox potential, and pe
c     (electron activity function) on the operational pH scale used
c     in the calculations (see iopg(2)), the NBS pH scale,
c     and the scale on which pH is numerically equal to -log m(H+).
c     It also computes the pHCl, which is equivalent to pH + pCl.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of logarithms of activity coefficients
c       actlg  = array of logarithms of aqueous species activities;
c                  actlg(nchlor) is the log activity of Cl-
c       actwlg = the log activity of water
c       adh    = the Debye-Huckel A(gamma) parameter
c       conc   = array of species concentrations
c       ehfac  = the Eh factor
c       farad  = the Faraday constant
c       iopg   = array of activity coefficient option switches;
c                  iopg(2) defines the operational pH scale used in
c                  the computation:
c                    -1 = Internal scale corresponding to the activity
c                           coefficient model defined by iopg(1)
c                     0 = The NBS pH scale (log gamma Cl- is defined
c                           by the Bates-Guggenheim expression)
c                     1 = The Mesmer pH scale (log gamma H+ is defined
c                           as zero)
c       fo2lg  = log oxygen fugacity
c       nchlor = species index of the chloride ion
c       nhydr  = species index of the hydrogen ion
c       qredox = logical flag, = .true. if there is oxidation-reduction
c                  in the modeled system
c       qrho   = .true. if a solution density value is available
c       fxi    = the ionic strength
c       xlke   = log K for special reaction for calculating Eh
c                 from log oxygen fugacity
c
c     Principal output:
c
c       ah     = Ah corresponding to the pH used in the computation
c       ahmes  = Ah corresponding to the Mesmer pH scale
c       ahnbs  = Ah corresponding to the NBS pH scale
c       eh     = Eh corresponding to the pH used in the computation
c       ehmes  = Eh corresponding to the Mesmer pH scale
c       ehnbs  = Eh corresponding to the NBS pH scale
c       ph     = pH on scale used in computation
c       phcl   = pHCl
c       phmes  = pH on the Mesmer scale
c       phnbs  = pH on the NBS scale
c       pe     = pe function corresonding to Eh
c       pemes  = pe function corresonding to the Mesmer pH scale
c       penbs  = pe function corresonding to the NBS pH scale
c       qhcl   = logical flag, = .true. if pHCl is defined
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nopgmx,nstmax
c
      integer noutpt,nttyo
c
      integer iopg(nopgmx)
      integer nchlor,nhydr
c
      logical qphcl,qredox,qrho
c
      real(8) tlg
c
      real(8) acflg(nstmax),actlg(nstmax),conc(nstmax)
      real(8) actwlg,adh,ah,ahmes,ahnbs,eh,ehfac,ehmes,ehnbs,farad,
     $ fo2lg,fxi,mrmlra,pch,pe,pemes,penbs,ph,phcl,phmes,phnbs,xlke
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 acfnbs,ahfx,delacf,ehfx,eterm,eterm0,eterm1
c
c----------------------------------------------------------------------
c
c     Compute pH, Eh, and pe for the operational pH scale.
c
      ph = -actlg(nhydr)
      eh = -99999.
      pe = -99999.
      ah = -99999.
      ehfx = 0.25*ehfac
      ahfx = 0.001*farad
      if (qredox) then
        eterm = fo2lg - 4.*ph - 2.*actwlg - xlke
        eh = ehfx*eterm
        pe = eh/ehfac
        ah = ahfx*eh
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute pH, Eh, and pe consistent with the NBS pH scale.
c     Note that this requires the activity coefficient of the chloride
c     ion on the operational scale.
c
      if (iopg(2) .eq. 0)  then
        phnbs = ph
        ehnbs = eh
        penbs = pe
        ahnbs = ah
      else
        phnbs = -99999.
        ehnbs = -99999.
        penbs = -99999.
        ahnbs = -99999.
        if (nchlor. gt. 0) then
          call nbsgam(acfnbs,adh,fxi,nchlor,noutpt,nttyo)
          delacf = acfnbs - acflg(nchlor)
          phnbs = ph + delacf
          if (qredox) then
            eterm0 = eterm + 4.*(ph - phnbs)
            ehnbs = ehfx*eterm0
            penbs = ehnbs/ehfac
            ahnbs = ahfx*ehnbs
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute pH, Eh, and pe consistent with the Mesmer pH scale.
c     Mesmer pH is the same as pmH.
c
      ehmes = -99999.
      pemes = -99999.
      if (iopg(2) .eq. 1) then
        phmes = ph
        ehmes = eh
        pemes = pe
        ahmes = ah
      else
        delacf = - acflg(nhydr)
        phmes = ph - delacf
        if (qredox) then
          eterm1 = eterm + 4.*(ph - phmes)
          ehmes = ehfx*eterm1
          pemes = ehmes/ehfac
          ahmes = ahfx*ehmes
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute pcH.
c
      pch = 99999.
      if (qrho) then
        pch = phmes - tlg(mrmlra)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute pHCl = pH + pCl
c
      qphcl = .false.
      phcl = -99999.
      if (nchlor .gt. 0) then
        if (conc(nchlor) .gt. 0.) then
          qphcl = .true.
          phcl = ph - actlg(nchlor)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine tleapy(yy,qleapy)
c
c     This subroutine determines if the year yy is a leap year. The
c     logical flag qleapy is returned as true if this is the case.
c     Modern era rules apply:
c
c       1. Any year not evenly divisible by 4 is not a leap year.
c       2. If a year is evenly divisible by 100 (i.e., is a "century
c          year"), it is not a leap year, unless it is also evenly
c          divisible by 400.
c
c     Examples:
c
c        1. The year 1998 is not a leap year because it is not evenly
c           divisible by 4.
c        2. Century years like 1700, 1800, and 1900 are not leap years
c           because they are not evenly divisible by 400.
c        3. Century years like 1600 and 2000 are leap years because
c           they are evenly divisible by 400.
c
c     The modern era rules (part of the Gregorian calendar) first
c     applied in 1582. The first leap year of the Gregorian calendar
c     was therefore 1584. This subroutine will not return any prior
c     year as a leap year. Thus, 1580 is not a leap year.
c
c     This subroutine is called by:
c
c       EQLIB/initim.f
c       EQLIB/runtim.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       yy     = year, assumed to be an integer up to four digits
c
c     Output:
c
c       qleapy = logical flag, true if yy is a leap year.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer yy
c
      logical qleapy
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      qleapy = .false.
c
      if (yy .ge. 1584) then
c
c       Have a year sufficiently recent to possibly be a leap year.
c
        if (mod(yy,4) .eq. 0) then
c
c         Have a year evenly divisible by 4. It might be a leap year.
c
          if (mod(yy,100) .eq. 0) then
c
c           Have a century year. It might be a leap year.
c
            if (mod(yy,400) .eq. 0) then
c
c             Have a century year that is evenly divisible by 400.
c             This is a leap year.
c
              qleapy = .true.
            endif
          else
c
c           Have a year evenly divisible by 4, but it is not a
c           century year. This is a leap year.
c
            qleapy = .true.
          endif
        endif
      endif
c
      end

      subroutine optmzr(aamatr,abar,acflg,acflgo,act,actlg,
     $ adh,adhh,adhv,afcnst,al10,alpha,amtb,aphi,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,bgamx,bneg,bpx,cco2,cdrs,cdrsx,cdrtw,cdrw,
     $ cegexs,cgexj,cjbasp,cnufac,conc,conclg,cpgexs,cscale,
     $ csts,coval,delvec,dlogxw,egexjc,egexjf,egexs,ehfac,
     $ eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,fugalg,fxi,fxio,
     $ gmmatr,ibetmx,ibpxt,ibswx,ielam,iern1,iern2,ifcphi1,
     $ ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,
     $ igas,igstak,iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,
     $ ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,insgf,iodb,iopg,
     $ iopt,ipch,ipcv,ipivot,ipndx1,irdxc3,istack,ixbasp,ixrn1,
     $ ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,jgsort,jgstak,
     $ jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,kction,
     $ kdim,kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,loph,losp,
     $ lsort,mgext,moph,mosp,mrgexs,mtb,narn1,narn2,narxt,nat,
     $ nbasp,nbaspd,nbaspx,nbw,nbt,nbtd,nchlor,ncmpr,ncosp,ndrs,
     $ ndrsx,ndrsr,ndrsrd,ndrsrx,nelect,nern1,nern2,net,ngexsa,
     $ nfac,ngext,nhydr,nhydx,ngrn1,ngrn2,ngt,noutpt,no2gaq,
     $ nphasx,npt,nst,nsts,nstsr,ntfx,ntfxt,ntpr,nttyo,omega,
     $ omeglg,press,qbassw,qblamx,qhawep,qpit75,qredox,q6mode,
     $ rhsvec,sigmam,sigmmo,smp100,tempc,tempk,tfx,tolbig,tolneg,
     $ tolxpt,ubacmx,ubbig,ubetmx,ubgamx,ubneg,ugexj,ugexmo,
     $ uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zgexj,zvclg1,zvec1)
c
c     This subroutine optimizes the starting values prior to hybrid
c     Newton-Raphson iteration. The structure is somewhat similar to
c     that in EQ3NR/arrset.f. Automatic basis switching is done in
c     "loops." Inside loops are "passes," in which the activity
c     coefficients are readjusted. Inside passes are "cycles," in which
c     the chief iteration variables are adjusted.
c
c     In the present subroutine, the cycle algorithm is based on
c     minimizing the function:
c
c       aleph = Sum(i) zeta(i)**2
c
c     where i spans the set of primary iteration variables and zeta
c     is a residual vector derived from the beta residual vectors
c     normally used in EQ3/6. In EQ3NR/arrset.f, the cycle algorithm
c     is the continued-fraction algorithm. That algorithm is not
c     well suited to dealing with nonpphysical mass balances,
c     which must be dealt with for basis species like H2O(l), H+,
c     O2(g,aq), and e-. Nor is it well-suited for dealing with
c     non-aqueous species (e.g., pure minerals) when they are not
c     switched into the active basis set but are instead treated as
c     "extended" basis species. Hence the change of algorithm.
c
c     This subroutine does not change the presumed phase assemblage.
c
c     This subroutine is called by:
c
c       EQ6/eqcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       nhydr  = species index of the hydrogen ion
c       nhydx  = species index of the hydroxide ion
c       nchlor = species index of the chloride ion
c       qblamx = .true. if solid solutions are in the matrix
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),ibswx(nbtmax),igstak(ngtmax),iindx1(kmax),
     $ insgf(natmax),iodb(nodbmx),iopg(nopgmx),iopt(noptmx),
     $ ipivot(kmax),ipndx1(kmax),istack(nstmax),ixbasp(nbtmax),
     $ jcsort(nstmax),jern1(jetmax,netmax),jern2(jetmax,netmax),
     $ jflag(nstmax),jgext(netmax),jgsort(ngtmax),jgstak(ngtmax),
     $ jjsort(nstmax),jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),
     $ jsol(nxtmax),jssort(nstmax),jstack(nstmax),kction(nbtmax),
     $ narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),
     $ ncmpr(2,nptmax),ncosp(nbtmax),ndrs(ndrsmx),ndrsx(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrd(2,nstmax),ndrsrx(2,nstmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax),nphasx(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax),ntfx(ntfxmx)
c
      integer nfac(nbtmax)
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer ibetmx,ielam,iern1,iern2,ifrn1,ifrn2,igas,ilrn1,ilrn2,
     $ imrn1,imrn2,ipch,ipcv,irdxc3,ixrn1,ixrn2,izmax,kbt,kdim,kelect,
     $ khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,narn1,narn2,nat,nbw,nbt,
     $ nbtd,nchlor,nelect,nern1,nern2,net,nhydr,nhydx,ngrn1,ngrn2,ngt,
     $ no2gaq,npt,nst,ntpr,ntfxt
c
      logical qabsw,qbassw,qblamx,qhawep,qpit75,qredox,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubacmx,ubbig,ubetmx,ubgamx,ubneg
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),act(nstmax),
     $ actlg(nstmax),alpha(kmax),amtb(nbtmax),azero(natmax),
     $ a3bars(natmax),beta(kmax),bpx(ibpxmx,nxtmax),cco2(5),
     $ cdrs(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),
     $ cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),conclg(nstmax),
     $ coval(nbtmax),cpgexs(ietmax,jetmax,netmax),cscale(nstmax),
     $ csts(nstsmx)
c
      real*8 delvec(kmax),dlogxw(nbtmax),egexjc(jetmax,netmax),
     $ egexjf(jetmax,netmax),egexs(ietmax,jetmax,netmax),
     $ fsort(ngtmax),fugac(ngtmax),fugalg(ngtmax),gmmatr(kmax,kmax),
     $ mgext(jetmax,netmax),mrgexs(ietmax,jetmax,netmax),
     $ mtb(nbtmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ moph(nptmax),mosp(nstmax),rhsvec(kmax),tfx(ntfxmx),
     $ weight(nstmax),wfac(iktmax,nxtmax),xbar(nstmax),xbarlg(nstmax),
     $ zchar(nstmax),zchcu6(nstmax),zchsq2(nstmax),
     $ zgexj(jetmax,netmax),zvclg1(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,afcnst,al10,avcnst,a3bar,bacfmx,bbig,betamx,bgamx,
     $ bneg,ehfac,eps100,fje,fjeo,fo2,fo2lg,fxi,fxio,omega,omeglg,press,
     $ sigmam,sigmmo,smp100,tempc,tempk,tolbig,tolneg,tolxpt,xbarw,
     $ xbarwc,xbrwlc,xbrwlg,zetsqm,zetsqo
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c
      integer, dimension(:), allocatable :: iastak,jasort,jastak
      integer, dimension(:), allocatable :: kmvar,knflag
c
      real(8), dimension(:), allocatable :: daleph,delprc,dijmaj
      real(8), dimension(:), allocatable :: zesort,zeta,zetasq
c
      real(8), dimension(:), allocatable :: efac
c
      integer isv_nbtmax,isv_kmax
c
      SAVE isv_nbtmax,isv_kmax
c
      SAVE daleph,delprc,dijmaj,efac,iastak,jasort,jastak,kmvar,knflag,
     $ zesort,zeta,zetasq
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icorr,kdirec,iebal,iter,j,jdim,jlen,jlen1,jlen2,j2,k,
     $ kbig,kcol,kcorr,kcscan,ker,kk,kkdim,kount,krow,krscan,n,nb,
     $ nbigger,nchange,ncycle,ncylim,negafc,nloop,nlopmx,npass,nplim,
     $ nredox,ns,nscan,nsd,nswtch,ns1,ns2
c
      integer ilnobl
c
      logical qbswx,qcgam,qcfxi,qcsigm,qcycnc,qpracf,qscan2,qsclim,
     $ qscosc,qstops,qtestc,qtestp,qxbarw
c
      character*56 uspn56,usp156,usp256
      character*48 uzebig,uzeneg
      character*24 ujtp
c
      real*8 abig,actwlc,adij,alefnc,alepoe,alepoo,aleph,alephm,av,ax,
     $ azex,betfnc,bfje,bfxi,bsigmm,btmxoe,btmxoo,bx,chfacf,chfsgm,cx,
     $ dij,dscan,dscmin,dx,dzx,dzxclm,eh,eps1hi,rlxgam,tolatf,tolgpt,
     $ zebig,zeneg,zetamx,zetsum,zex,zvclim,zvclgi,zvclgo,zvcnew,zx,
     $ zx1,zx2
c
      real*8 texp
c
c-----------------------------------------------------------------------
c
c     The following are iteration limits:
c
c       nlopmx = the maximum number of auto basis switching loops
c       nplim  = the maximum number of passes
c       ncylim = the maximum number of cycles
c
c     Passes refine estimates of the ionic strength, etc., the
c     activity of water, and activity coefficients of aqueous species.
c     Cycles are embedded in passes. They refine estimates of species
c     concentrations before new estimates of ionic strength, etc.,
c
      data nlopmx/12/,nplim  /7/,ncylim /15/
c
c     The following are local tolerance parameters for the
c     optimization:
c
      data tolatf /0.005/,tolgpt /0.1/
c
c     The following is the minimum scan increment.
c
      data dscmin /0.05/
c
c     The following are not used by EQ6, but are needed to satisfy
c     some subroutine calls.
c
      data iebal  /0/,nredox /0/
      data eh     /0./
c
c     The following is set to .false. to turn off iterative improvement
c     of xbarw in ncmpex.f.
c
      data qxbarw/.false./
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(iastak)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
        isv_nbtmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(iastak,jasort,jastak)
          DEALLOCATE(kmvar,knflag)
          DEALLOCATE(daleph,delprc,dijmaj)
          DEALLOCATE(zesort,zeta,zetasq)
          isv_kmax = 0
        endif
c
        if (nbtmax .ne. isv_nbtmax) then
          DEALLOCATE(efac)
          isv_nbtmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(iastak(kmax),jasort(kmax),jastak(kmax))
        ALLOCATE(kmvar(kmax),knflag(kmax))
        ALLOCATE(daleph(kmax),delprc(kmax),dijmaj(kmax))
        ALLOCATE(zesort(kmax),zeta(kmax),zetasq(kmax))
        isv_kmax = kmax
      endif
c
      if (isv_nbtmax .eq. 0) then
        ALLOCATE(efac(nbtmax))
        isv_nbtmax = nbtmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        iastak(k) = 0
        jasort(k) = 0
        jastak(k) = 0
        kmvar(k) = 0
        knflag(k) = 0
      enddo
c
      do k = 1,kmax
        daleph(k) = 0.
        delprc(k) = 0.
        dijmaj(k) = 0.
        zesort(k) = 0.
        zeta(k) = 0.
        zetasq(k) = 0.
      enddo
c
      do n = 1,nbtmax
        efac(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1000)
 1000   format(/' Starting Pre-Newton-Raphson Optimization.',/)
      endif
c
      qbswx = .false.
      eps1hi = 1.0/eps100
c
      bsigmm = 0.
      bfxi = 0.
      bgamx = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
c
c       Print the active data file basis set.
c
        write (noutpt,1010)
 1010   format(/16x,'--- Active Data File Basis Set ---',
     $  //2x,'krow   Name',30x,'Constraint',/)
c
        do krow = 1,kdim
          if (krow .le. kbt) then
            ujtp = 'Mass balance, moles'
          elseif (krow.ge.km1 .and. krow.le.kxt) then
            ujtp = 'Mass action'
          else
            ujtp = 'Defining equation'
          endif
          j2 = ilnobl(ujtp)
c
          if (krow .le. kbt) then
            nb = iindx1(krow)
            ns = nbaspd(nb)
          else
            ns = iindx1(krow)
          endif
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
c
          write (noutpt,1020) krow,uspn56,ujtp(1:j2)
 1020     format(1x,i4,2x,a32,2x,a)
        enddo
c
        write (noutpt,1030)
 1030   format(/1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The label below is a return point after an automatic basis switch.
c     Here nloop is the loop counter for auto basis switching.
c
      nloop = -1
c
  200 nloop = nloop + 1
      if (iodb(3) .ge. 1) write (noutpt,1040) nloop
 1040 format(6x,'nloop= ',i2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
        if (qbassw) then
c
c       Print the computational basis set.
c
          write (noutpt,1050)
 1050     format(16x,'--- Basis Set Changes ---',
     $    //2x,'krow   Data File',25x,'Current',/)
c
          do krow = 1,kbt
            nb = iindx1(krow)
            ns1 = nbaspd(nb)
            ns2 = nbasp(nb)
            if (ns1 .ne. ns2) then
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(ns1) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(ns1),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(ns2) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(ns2),usp256)
              jlen2 = min(jlen2,32)
              write (noutpt,1060) krow,usp156,usp256(1:jlen2)
 1060         format(1x,i4,2x,a32,2x,a)
            endif
          enddo
c
          if (kxt .gt. kbt) write (noutpt,1070)
 1070     format(16x,'--- Extended Basis Species ---',
     $    //2x,'krow   Species',/)
c
          do krow = km1,kxt
            ns = iindx1(krow)
            call fmspnx(jlen,uspec(ns),uspn56)
            jlen = min(jlen,32)
            write (noutpt,1080) krow,uspn56(1:jlen)
 1080       format(1x,i4,2x,a)
          enddo
c
          write (noutpt,1030)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note: At this point, do not recalculate values of the following:
c
c       The SUM(i) m(i) function (sigmam)
c       The ionic strength (fxi)
c       The J electrostatic moment function (fje)
c       The activity coefficients of aqueous species
c       The mole fraction of water
c       The activity coefficients of exchanger species
c       The activity coefficients of solid solution components
c         present in the equilibrium system.
c
c     This subroutine is always called with initial values for all of
c     these parameters. At the start of an EQ6 run, all these parameters
c     are initialized by EQ6/exivar.f. After that, new values are
c     subsequently generated by normal stepping procedures in
c     EQ6/path.f.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here npass is the pass counter.
c
      npass = -1
c
c     The label below is a return point for subsequent passes. A pass
c     is an adjustment for the ionic strength, etc., the activity of
c     water, and the activity coefficients of the solute species.
c
  210 npass = npass + 1
c
c     Note:
c
c       alefnc = aleph convergence function
c       negafc = the number of successive iterations that the
c                convergence function alefnc
c       betfnc = beta convergence function
c
      alefnc = 0.
      alepoe = 0.
      alepoo = 0.
      negafc = 0
c
      betfnc = 0.
      btmxoe = 0.
      btmxoo = 0.
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1110) npass
 1110   format(/11x,'npass= ',i2)
        write (noutpt,1120) sigmam,fxi,fje,xbrwlc,xbarwc
 1120   format(/13x,'sigmam= ',1pe12.5,/13x,'fxi= ',1pe12.5,
     $  /13x,'fje= ',1pe12.5,
     $  //13x,'xbrwlc= ',0pf9.5,/13x,'xbarwc= ',1pe12.5,/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here ncycle is the cycle counter.
c
      ncycle = -1
c
      qcsigm =abs(bsigmm) .le. tolgpt
      qcfxi = abs(bfxi) .le. tolgpt
      qcgam = bgamx .le. tolgpt
c
      qtestp = qcsigm .and. qcfxi .and. qcgam
c
      do krow = 1,kdim
        delprc(krow) = 0.
      enddo
c
      if (iodb(3) .ge. 1) write (noutpt,1190)
 1190 format(/14x,'Beginning cycle corrections',/)
c
c     The label below is a return point for beginning a new cycle.
c     A cycle is an structure within a pass in which the concentrations
c     of the basis species are adjusted, while the ionic strength, etc.,
c     and the activity coefficients are held constant.
c
  220 ncycle = ncycle + 1
      if (iodb(3) .ge. 1) write (noutpt,1200) ncycle
 1200 format(16x,'ncycle= ',i2)
      ker = 0
      qabsw = iopt(11).ge.1 .and. npass.eq.1 .and. ncycle.eq.1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Expand the description of the equilibrium system from the
c     extended basis variables.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
      xbarw = xbar(narn1)
      xbrwlg = xbarlg(narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the usual residuals (the alpha vector and beta vectors).
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
      do krow = 1,kdim
        bx = beta(krow)
        if (krow .le. kbt) then
c
c         Mass balance element.
c
          if (bx .ge. 0.0) then
c
c           Have a non-negative beta(i) value. Set zeta(i) = beta(i).
c
            zeta(krow) = bx
          else
c
c           Have a negative beta(i) value.
c
            dx = 1.0 + bx
            if (dx .gt. eps100) then
c
c             Have (-1.0 + eps100) < beta(i) < 0.0.
c             Set zeta(i) = 1.0 - 1.0/(1.0 + beta(i)).
c
              zeta(krow) = 1.0 - (1.0/dx)
            else
c
c             Have beta(i) < (-1.0 + eps100).
c             Set zeta(i) = 1.0 - (1.0/eps100).
c
              zeta(krow) = 1.0 - eps1hi
            endif
          endif
        else
c
c         Mass action element.
c
c         zeta(i) = 0.001*beta(i)/cscale(i).
c
          ns = iindx1(krow)
          zeta(krow) = 0.001*bx/cscale(ns)
        endif
      enddo
c
c     Calculate the aleph and zeta-squared functions.
c
      aleph = 0.
      do krow = 1,kdim
        zetasq(krow) = zeta(krow)*zeta(krow)
        aleph = aleph + zetasq(krow)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the aleph convergence function.
c
      alefnc = 0.
      if (mod(ncycle,2) .eq. 0) then
        if (alepoe .ge. smp100) alefnc = (alepoe - aleph)/alepoe
        alepoe = aleph
      else
        if (alepoo .ge. smp100) alefnc = (alepoo - aleph)/alepoo
        alepoo = aleph
      endif
c
c     Calculate the beta convergence function.
c
      betfnc = 0.
      if (mod(ncycle,2) .eq. 0) then
        if (btmxoe .ge. smp100) betfnc = (btmxoe - betamx)/btmxoe
        btmxoe = betamx
      else
        if (btmxoo .ge. smp100) betfnc = (btmxoo - betamx)/btmxoo
        btmxoo = betamx
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print values of master iteration variables.
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1230)
 1230   format(//10x,'--- Pre-Newton-Raphson Optimization Summary ---',
     $  //2x,'kcol   Name',32x,'zvclg1      zvec1',/)
c
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          zx1 = zvclg1(kcol)
          zx2 = texp(zx1)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1240) kcol,uspn56,zx1,zx2
 1240     format(1x,i4,2x,a32,2x,f10.4,2x,1pe12.5)
        enddo
c
        do kcol = km1,kxt
          ns = iindx1(kcol)
          zx1 = zvclg1(kcol)
          zx2 = texp(zx1)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1240) kcol,uspn56,zx1,zx2
        enddo
c
        write (noutpt,1250)
 1250   format(/1x,'krow   Name',28x,'Alpha',9x,'Beta',9x,'Zeta',/)
c
        do krow = 1,kbt
          nb = iindx1(krow)
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1260) krow,uspn56,alpha(krow),beta(krow),
     $    zeta(krow)
 1260     format(1x,i3,2x,a28,2x,1pe12.5,2x,e12.5,2x,e12.5)
        enddo
c
        do krow = km1,kxt
          ns = iindx1(krow)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1260) krow,uspn56,alpha(krow),beta(krow),
     $    zeta(krow)
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
c
c       Calculate some data on the state of the zeta residual
c       functions.
c
        zetamx = 0.
        zebig = 0
        uzebig = 'None'
        zeneg = 0
        uzeneg = 'None'
        do kcol = 1,kdim
          zex = zeta(kcol)
          if (zex .gt. zebig) then
            zebig = zex
            uzebig = uzvec1(kcol)
          endif
          if (zex .lt. zeneg) then
            zeneg = zex
            uzeneg = uzvec1(kcol)
          endif
          azex = abs(zex)
          if (azex .gt. zetamx) then
            zetamx = azex
          endif
        enddo
c
c       Write some data on the state of the aleph and beta residual
c       functions.
c
        write (noutpt,1270) aleph,alefnc
 1270   format(/19x,'aleph= ',1pe12.5,', alefnc= ',e12.5)
c
c       Write some data on the state of the beta residual functions.
c
c       Calling sequence substitutions:
c         jlen1 for jlen
c         ubbig for unam48
c         usp156 for uspn56
c
        call fmspnx(jlen1,ubbig,usp156)
c
c       Calling sequence substitutions:
c         jlen2 for jlen
c         ubneg for unam48
c         usp246 for uspn56
c
        call fmspnx(jlen2,ubneg,usp256)
c
        write (noutpt,1280) betamx,betfnc,bbig,usp156(1:jlen1),
     $  bneg,usp256(1:jlen2)
 1280   format(/18x,'betamx= ',1pe12.5,', betfnc= ',e12.5,
     $  /18x,'  bbig= ',1pe12.5,', ubbig= ',a,
     $  /18x,'  bneg= ',1pe12.5,', ubneg= ',a)
c
c       Write some data on the state of the zeta residual functions.
c
c       Calling sequence substitutions:
c         jlen1 for jlen
c         uzebig for unam48
c         usp156 for uspn56
c
        call fmspnx(jlen1,uzebig,usp156)
c
c       Calling sequence substitutions:
c         jlen2 for jlen
c         uzeneg for unam48
c         usp256 for uspn56
c
        call fmspnx(jlen2,uzeneg,usp256)
c
        write (noutpt,1290) zetamx,zebig,usp156(1:jlen1),
     $  zeneg,usp256(1:jlen2)
 1290   format(/18x,'zetamx= ',1pe12.5,
     $  /18x,' zebig= ',1pe12.5,', uzebig= ',a,
     $  /18x,' zeneg= ',1pe12.5,', uzeneg= ',a,/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the mass balance residuals see if another cycle should be
c     made before attempting to make an improved estimate of the
c     ionic strength.
c
      qtestc = betamx.le.tolxpt .and. bbig.le.tolbig .and.
     $  bneg.ge.tolneg
c
      if (ncycle.gt.2 .and. alefnc.le.tolatf) then
        negafc = negafc + 1
      else
        negafc = 0
      endif
c
      qcycnc = negafc .ge. 4
c
c     Quit doing cycles if:
c
c       1. The cycle convergence criteria are met.
c       2. The maximum number of cycles have been done.
c       3. The convergence function alefnc indicates that the cycles
c            are not converging.
c
      if (qtestc) go to 400
      if (ncycle .ge. ncylim) go to 400
      if (qcycnc) then
        if (iodb(3) .ge. 1) then
          write (noutpt,1292)
 1292     format(11x,'The cycles are not converging.',/)
        endif
        go to 400
       endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Identify the dominant species in each mass balance and
c     compute the corresponding exponent for a continued
c     fraction correction.
c
c     Presently the species determined as the dominant can only be an
c     aqueous species or an exchanger species. Minerals and solid
c     solution component species are ignored.
c
      call cfracf(cdrs,csts,efac,jcsort,jflag,jssort,kmax,mosp,
     $ narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $ nern2,nfac,nst,nstmax,nsts,nstsmx,nstsr,q6mode,weight)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
c
c       Write a table containing the preliminary results.
c
        kount = 0
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          nsd = nfac(nb)
          if (nsd.ne.0 .and. nsd.ne.ns) kount = kount + 1
        enddo
c
        if (kount .gt. 0) then
          write (noutpt,1300)
 1300     format(16x,'--- Mass Balance Dominants ---',/)
          write (noutpt,1310)
 1310     format(4x,'Master Species',21x,'Dominant Species',/)
c
          do kcol = 1,kbt
            nb = iindx1(kcol)
            ns = nbasp(nb)
            nsd = nfac(nb)
            if (nsd.ne.0 .and. nsd.ne.ns) then
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(ns) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(ns),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(nsd) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(nsd),usp256)
              jlen2 = min(jlen2,32)
              write (noutpt,1320) usp156,usp256(1:jlen2)
 1320         format(2x,a32,3x,a)
            endif
          enddo
          write (noutpt,1030)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qabsw .and. nloop.lt.nlopmx) then
c
c       In automatic basis switching mode (iopt(11) .ge. 1), try to
c       first reduce the magntiude of large positive mass balance
c       residuals by making one or more basis switches.
c
c       Note that this block utilizes the efac array calculated above.
c       This array is primarily thought of as being connected with
c       the continued fraction (cycle) algorithm, but it has its use
c       in automatic basis switching mode.
c
        call absswa(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $  axhfsx,axlks,axlksx,axvfs,axvfsx,beta,cdrs,cdrsx,cdrtw,cdrw,
     $  csts,dhfs,dvfs,efac,eps100,ibswx,iebal,iindx1,iodb,ipch,ipchmx,
     $  ipcv,ipcvmx,jcsort,jflag,jsflag,jssort,kbt,kmax,mosp,narn1,
     $  narn2,narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ncosp,
     $  ndrs,ndrsmx,ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,
     $  noutpt,nst,nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,
     $  presg,press,qbassw,qbswx,q6mode,tempc,uspec,uzvec1,weight,
     $  xvfs,xlks,xhfs)
c
        if (nswtch .gt. 0) then
c
          do ns = 1,nstmax
            mosp(ns) = 0.
          enddo
c
          av = -99999.
          call initav(losp,nstmax,av)
c
c         Reset the ixbasp and cjbasp arrays. The former is a flag
c         array, each member of which denotes whether the
c         thermodynamic activity of the corresponding basis species
c         is defined in terms of molality (= 0) or mole fraction (= 1).
c         The cjbasp array contains any site stoichiometric factors
c         associated with the operational basis species.
c
          call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $    jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $    netmax,nphasx,nstmax)
c
c         Go back for another loop.
c
          go to 200
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Sort the zeta-squared terms.
c
c     Calling sequence substitutions:
c       zesort for asort
c       zetasq for aval
c       jasort for jsort
c       iastak for istack
c       jastak for jstack
c       kmax for nmax
c       kdim for nval
c
c     Insure that each sort made by calling EQLIBU/qsortw.f is made
c     starting from scratch. That is, the jasort array left over
c     from a previous call to EQLIBU/qsortw is not used as a starting
c     point for the current sort.
c
      do k = 1,kdim
        jasort(k) = k
      enddo
c
      call qsortw(zesort,zetasq,iastak,jasort,jastak,kmax,noutpt,
     $ nttyo,kdim)
c
c     Reverse the sorting order, so that the values proceed from
c     greatest to smallest.
c
      do k = 1,kdim
        jastak(k) = jasort(kdim + 1 - k)
      enddo
c
      do k = 1,kdim
        krow = jastak(k)
        jasort(k) = krow
        zesort(k) = zetasq(krow)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the set of zeta-squared terms to work on. Consider only
c     the kkdim largest ones, those that account for 99% of aleph.
c     If there are more than three, truncate to three.
c
      ax = 0.
      kkdim = 0
      zetsum = 0.
      do k = 1,kdim
        kkdim = kkdim + 1
        zetsum = zetsum + zesort(k)
        ax = zetsum/aleph
        if (ax .ge. 0.99) go to 270
      enddo
  270 continue
      if (kkdim .gt. 3) kkdim = 3
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the vector of partial derivatives d aleph/d log z(j),
c     where aleph is the sum of squares of the zeta residuals and
c     log z(j) is j-th primary iteration variable. At present, z(j)
c     is always the number of moles of the j-th member of the
c     "extended" basis set. Note that:
c
c       d aleph/d log z(j) = 2 * Sum(i) zeta(i)*(d zeta(i)/d log z(j))
c
c     where:
c
c       d zeta(i)/d log z(j) = d alpha(i)/d log z(j)
c
c            for zeta(i) = alpha(i);
c
c
c       d zeta(i)/d log z(j) = d beta(i)/d log z(j)
c
c         = [1./amtb(i)] * d alpha(i)/d log z(j)
c
c            for zeta(i) = beta(i)
c
c       where amtb(i) is treated as a constant, which it really isn't
c       when i refers to a species like H2O, H+, OH-, O2(g,aq), or e-;
c       and
c
c
c       d zeta(i)/d log z(j) = [0.001/cscale(i)] * d alpha(i)/d log z(j)
c
c            for zeta(i) = [0.001/cscale(i)] * alpha(i)
c
c
c     Note that  d alpha(i)/d log z(j) = Jacob(i,j), where [Jacob] is
c     the Jacobian matrix used in Newton-Raphson iteration.
c
c     Get the Jacobian.
c
      call matrix(aamatr,al10,bpx,cdrs,cdrtw,cdrw,cjbasp,
     $ cnufac,conc,csts,dlogxw,eps100,ibpxmx,iebal,iern1,ietmax,
     $ iindx1,ipndx1,irdxc3,ixbasp,ixrn1,jcsort,jern1,jern2,jetmax,
     $ jflag,jjsort,jsitex,kbt,kction,kdim,kelect,khydr,kmax,kmt,
     $ km1,ko2gaq,kwater,kxt,kx1,mosp,narn1,narn2,nbasp,nbt,nbtmax,
     $ nbw,ncosp,ndrs,ndrsmx,ndrsr,nelect,nern1,nern2,netmax,
     $ noutpt,no2gaq,nphasx,nredox,nst,nstmax,nsts,nstsmx,nstsr,
     $ ntfx,ntfxmx,ntfxt,nttyo,nxtmax,omega,qredox,q6mode,tfx,
     $ ugexmo,uspec,weight,xbar,xbarw,xbarwc,zchar)
c
c     Compute the d aleph/d log z(j) vector.
c
      do kcol = 1,kdim
        daleph(kcol) = 0.
      enddo
c
      do krow = 1,kbt
        nb = iindx1(krow)
        bx = beta(krow)
        if (bx .ge. 0.0) then
c
c         Have a non-negative beta(i) value: zeta(i) = beta(i).
c
          if (amtb(nb) .gt. eps100) then
            cx = 2.*zeta(krow)/amtb(nb)
          else
            cx = 2.*zeta(krow)*eps1hi
          endif
        else
c
c         Have a negative beta(i) value.
c
          dx = 1.0 + bx
          if (dx .gt. eps100) then
c
c           Have (-1.0 + eps100) < beta(i) < 0.0:
c           zeta(i) = 1.0 - 1.0/(1.0 + beta(i)).
c
            cx = 2.*zeta(krow)**3/amtb(nb)
          else
c
c           Have beta(i) < (-1.0 + eps100):
c           zeta(i) = 1.0 - (1.0/eps100).
c
            if (amtb(nb) .gt. eps100) then
              cx = 2.*eps1hi**3/amtb(nb)
            else
              cx = 2.*eps1hi**4
            endif
          endif
        endif
        do kcol = 1,kdim
          daleph(kcol) = daleph(kcol) + cx*aamatr(krow,kcol)
        enddo
      enddo
c
      do krow = km1,kxt
        ns = iindx1(krow)
        cx = 0.001/cscale(ns)
        do kcol = 1,kdim
          daleph(kcol) = daleph(kcol) + cx*aamatr(krow,kcol)
        enddo
      enddo
c
      if (iodb(3) .ge. 4) then
        write (noutpt,1330)
 1330   format(/7x,'--- Partial Derivatives of Aleph ---',
     $  //'  krow    Variable',25x,'daleph(krow)',/)
        do krow = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(krow) for unam48
c
          call fmspnx(jlen,uzvec1(krow),uspn56)
c
          write (noutpt,1340) krow,uspn56,daleph(krow)
 1340     format(2x,i3,3x,a32,3x,1pe12.5)
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now find the primary iteration variable that is the principal
c     determining variable for each of the most significant zeta-
c     squared variables.
c
      do k = 1,kkdim
        kmvar(k) = 0
      enddo
c
      do k = 1,kkdim
        krow = jasort(k)
        if (krow .le. kbt) then
          nb = iindx1(krow)
          bx = beta(krow)
          if (bx .ge. 0.0) then
c
c           Have a non-negative beta(i) value: zeta(i) = beta(i).
c
            if (amtb(nb) .gt. eps100) then
              cx = 2.*zeta(krow)/amtb(nb)
            else
              cx = 2.*zeta(krow)*eps1hi
            endif
          else
c
c           Have a negative beta(i) value.
c
            dx = 1.0 + bx
            if (dx .gt. eps100) then
c
c             Have (-1.0 + eps100) < beta(i) < 0.0:
c             zeta(i) = 1.0 - 1.0/(1.0 + beta(i)).
c
              if (amtb(nb) .gt. eps100) then
                cx = 2.*zeta(krow)**3/amtb(nb)
              else
                cx = 2.*zeta(krow)**4
              endif
            else
c
c             Have beta(i) < (-1.0 + eps100):
c             zeta(i) = 1.0 - (1.0/eps1000.
c
              if (amtb(nb) .gt. eps100) then
                cx = 2.*eps1hi**3/amtb(nb)
              else
                cx = 2.*eps1hi**4
              endif
            endif
          endif
        else
          ns = iindx1(krow)
          cx = 0.002*zeta(krow)/cscale(ns)
        endif
        kbig = 0
        abig = 0.
        do kcol = 1,kdim
          dij = cx*aamatr(krow,kcol)
          adij = abs(dij)
          if (adij .gt. abig) then
            if (krow.gt.kbt .or. kcol.ne.kwater .or. krow.eq.kwater)
     $        then
c
c             For a mass balance row other than that for H2O, disallow
c             H2O as the principal determining species.
c
              kbig = kcol
              abig = adij
              dijmaj(krow) = dij
            endif
          endif
        enddo
        kmvar(k) = kbig
      enddo
c
c     Special restrictions apply to H2O, H+, O2(g,aq), and e-.
c
      do k = 1,kkdim
        krow = jasort(k)
        kcol = kmvar(k)
c
        if (krow.eq.kwater .or. krow.eq.khydr .or.
     $    krow.eq.ko2gaq .or. krow.eq.kelect) then
c
c         Only H2O may be adjusted for the H2O row, only H+ for the H+
c         row, only O2(g,aq) for the O2 row, and e- for the e- row.
c
          if (kcol .ne. krow) kmvar(k) = krow
          go to 290
        endif
c
        if (krow .le. kbt) then
          kcol = kmvar(k)
          if (kcol.eq.kwater .or. kcol.eq.khydr .or.
     $      kcol.eq.ko2gaq .or. kcol.eq.kelect) then
c
c           H2O may be adjusted only for the H2O row, among mass
c           balance rows, H+ for the H+ row, O2(g,aq) for the O2 row,
c           and e- for the e- row.
c
            if (kcol .ne. krow) kmvar(k) = krow
          endif
        endif
c
  290   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a return point if no cycle corrections were
c     generated and an alternate set of variables to correct is to be
c     tried.
c
  350 continue
c
      if (iodb(3) .ge. 2) then
        write (noutpt,1400)
 1400   format(/11x,'--- Principal Dependencies ---',
     $  //4x,'Row Variable (i)',19x,'Column Variable (j)',/)
c
        do k = 1, kkdim
          krow = jasort(k)
          if (krow .le. kbt) then
            nb = iindx1(krow)
            ns = nbaspd(nb)
          else
            ns = iindx1(krow)
          endif
          kcol = kmvar(k)
c
c         Calling sequence substitutions:
c           jlen1 for jlen
c           uspec(ns) for unam48
c           usp156 for uspn56
c
          call fmspnx(jlen1,uspec(ns),usp156)
c
          if (kcol .gt. 0) then
c
c           Calling sequence substitutions:
c             jlen2 for jlen
c             uzvec1(kcol) for unam48
c             usp256 for uspn56
c
            call fmspnx(jlen2,uzvec1(kcol),usp256)
          else
            usp256 = 'None'
            jlen2 = 4
          endif
c
          write (noutpt,1410) usp156,usp256(1:jlen2)
 1410     format(2x,a32,3x,a)
        enddo
      endif
c
      if (iodb(3) .ge. 2) write (noutpt,1030)
c
      do k = 1,kkdim
        if (kmvar(k) .eq. 0) then
          krow = jasort(k)
c
          if (krow .le. kbt) then
            nb = iindx1(krow)
            ns = nbaspd(nb)
          elseif (krow.ge.km1 .and. krow.le.kxt) then
            ns = iindx1(krow)
          endif
          kcol = krow
          kmvar(k) = kcol
c
c         Calling sequence substitutions:
c           jlen1 for jlen
c           uspec(ns) for unam48
c           usp156 for uspn56
c
          call fmspnx(jlen1,uspec(ns),usp156)
c
c         Calling sequence substitutions:
c           jlen2 for jlen
c           uzvec1(kcol) for unam48
c           usp256 for uspn56
c
          call fmspnx(jlen2,uzvec1(kcol),usp256)
c
          write (noutpt,1440) usp156(1:jlen1),usp256(1:jlen2)
          write (nttyo,1440) usp156(1:jlen1),usp256(1:jlen2)
 1440     format(/" * Warning- (EQ6/optmzr) Couldn't find a variable",
     $    ' to adjust to reduce',/7x,'the aleph residual for ',
     $    a,'. Will use the variable associated',/7x,'with ',a,'.')
        endif
      enddo
c
c     Find and flag all instances in which a principal determining
c     variable duplicates a prior entry in the list. Set knflag(k) = 0
c     for such duplications, otherwise set knflag(k) = 1.
c
      do k = 1,kkdim
        knflag(k) = 1
      enddo
c
      do k = 1,kkdim - 1
        do kk = k + 1,kkdim
          if (kmvar(kk) .eq. kmvar(k)) knflag(kk) = 0
        enddo
      enddo
c
c     Find the number of variables to be corrected in the current
c     cycle.
c
      jdim = 0
      do k = 1,kkdim
        if (knflag(k) .eq. 1) jdim = jdim + 1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
c
c       Write a table containing data on the structure of the
c       corrections to be made for the current step.
c
        write (noutpt,1530)
 1530   format(/6x,'--- Structure for Current Cycle Corrections',
     $  ' ---',/)
c
        write (noutpt,1540)
 1540   format(4x,'Row Variable (i)',19x,'zeta(i)**2',/)
c
        do k = 1,kkdim
          krow = jasort(k)
          if (krow .le. kbt) then
            nb = iindx1(krow)
            ns = nbaspd(nb)
          else
            ns = iindx1(krow)
          endif
c
c         Calling sequence substitutions:
c           jlen1 for jlen
c           uspec(ns) for unam48
c           usp156 for uspn56
c
          call fmspnx(jlen1,uspec(ns),usp156)
c
          write (noutpt,1550) usp156,zesort(k)
 1550     format(2x,a32,3x,1pe12.5)
        enddo
c
        write (noutpt,1560)
 1560   format(//4x,'Column Variable (j)',9x,'d zeta(i)**2/d log z(j)',
     $  /)
c
        do k = 1,kkdim
c
c         Note: write all duplications, so don't test to see if
c         knflag(k) = 1.
c
          krow = jasort(k)
          kcol = kmvar(k)
c
c         Calling sequence substitutions:
c           jlen2 for jlen
c           uzvec1(kcol) for unam48
c           usp256 for uspn56
c
          call fmspnx(jlen,uzvec1(kcol),usp256)
c
          write (noutpt,1550) usp256,dijmaj(krow)
        enddo
        write (noutpt,1030)
      endif
c
      if (jdim .gt. 1) then
c
c       If the magnitude of aleph is quite large, correct only one
c       variable per cycle.
c
        if (aleph .gt. 1.e+10) then
          if (iodb(3) .ge. 3) then
            write (noutpt,1570)
 1570       format(' Because of the large magnitude of aleph, only',
     $      ' one variable will be',/' corrected in this cycle.',/)
          endif
          jdim = 1
          do k = 2,kkdim
            knflag(k) = 0
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute the cycle algorithm.
c
c     Testing has shown that the alpha residual for the O2(g,aq) mass
c     balance taken as a function of the log fO2 variable can have
c     a shape like the following:
c
c
c                   -----------------------------------
c                  |    x                              |
c                  |    x                              |
c                  |    x                              |
c                  |    x                              |
c                  |    x                              |
c            ^     |    x                              |
c            |     |     x                             |
c                  |      x                            |
c          alpha   |       xxxxxxxxxxxxxx              |
c                0 |-----------------------x-----------|
c                  |                          x        |
c                  |                           x       |
c                  |                            x      |
c                  |                            x      |
c                  |                            x      |
c                  |                            x      |
c                  |                            x      |
c                  |                            x      |
c                  |                            x      |
c                   -----------------------------------
c
c                               log fO2 ->
c
c     For this variable, the zeta residual is the alpha residual.
c     The function is nearly flat over about an 8-10 unit range of
c     log fO2, and very steep on the sides. It looks like a step
c     function rotated 90 degrees. The corresponding plot of aleph
c     versus log fO2 looks like a square well.
c
c     On the limbs, the slopes are so steep that attempting to
c     extrapolate to a zero residual using first-order partial
c     derivatives produces corrections that are practically
c     infinitesimal. Thus, any method that generates the values of
c     corrections from first-order partial derivatives is pretty much
c     guaranteed to fail. This rules out using whole classes of
c     methods.
c
c     Within the "flat" region, the Newton-Raphson method is
c     pretty much guaranteed to succeed. In the present subroutine
c     what we need is something that will get us in or near the flat
c     region when we are literally "out on a limb."
c
c     One possibility is to use a scanning procedure. Another is to
c     use a non-scanning method that does not use derivatives. An
c     example of the latter would be the cycle algorithm that
c     is employed for pre-Newton-Raphson optimiztion by EQ3NR. However,
c     that algorithm does not extend well to EQ6 problems. In EQ6, mass
c     balances must be considered for basis species such as H2O(l), H+,
c     and O2(g,aq) (or alternatives such as OH- and e-). These mass
c     balances are distinct in that some species can make negative
c     contributions. Also, EQ6 problems require consideration of some
c     heterogeneous mass action equations when the active basis set is
c     "extended" to include non-aqueous species (e.g., minerals).
c
c     In the present version of this subroutine, we will use a simple
c     scannning approach. Although the first-order partial derivatives
c     appear to be not useful in estimating the actual magnitude of
c     needed corrections, they do appear to identify the primary
c     iteration variables that are most in need of correction. They
c     also appear to define the direction in which one should be
c     scanning.
c
      kcorr = 0
      do krow = 1,kdim
        delvec(krow) = 0.
      enddo
c
      j = 0
      do k = 1,kkdim
        if (knflag(k) .eq. 1) then
          j = j + 1
          krscan = jasort(k)
          kcscan = kmvar(k)
c
          if (iodb(3) .ge. 2) then
c
c           Calling sequence substitutions:
c             uzvec1(kcscan) for unam48
c
            call fmspnx(jlen,uzvec1(kcscan),uspn56)
c
            write (noutpt,1610) uspn56(1:jlen)
 1610       format(/'   --- Scanning on ',a,' ---',
     $      //'  zvclg1(kcscan)  zetasq(krscan)',3x,'aleph',10x,
     $     'dscan',/)
            dscan = 0.
            write (noutpt,1620) zvclg1(kcscan),zetasq(krscan),aleph,
     $      dscan
 1620       format(5x,f9.4,3x,1pe12.5,3x,e12.5,3x,e12.5)
          endif
c
c         Get the direction in which to start scanning. Look at the
c         sign of the appropriate partial derivative to get this.
c         The other direction will be scanned if no improvement can
c         be made in the initial direction.
c
c         Note: could try dijmaj(krscan) in place of dalpeh(kcscan)
c         below.
c
          if (daleph(kcscan) .gt. 0.) then
            kdirec = -1
          else
            kdirec = 1
          endif
c
          if (kcscan .eq. krscan) then
            if (zeta(krscan) .gt. 0.) then
              kdirec = -1
            else
              kdirec = 1
            endif
          endif
c
          qscan2 = .false.
c
c         The label below is a return point if the scan is being
c         continued in the opposite direction.
c
  300     continue
c
c         Set the initial value of the scan increment.
c
          if (kcscan .eq. kwater) then
            dscan = 0.0625
            if (abs(zeta(krscan)) .gt. 10.) dscan = 0.125
            if (abs(zeta(krscan)) .gt. 1.e+2) dscan = 0.25
            if (abs(zeta(krscan)) .gt. 1.e+4) dscan = 0.5
            if (abs(zeta(krscan)) .gt. 1.e+8) dscan = 1.0
          elseif (kcscan .eq. khydr) then
            dscan = 0.0625
            if (abs(zeta(krscan)) .gt. 10.) dscan = 0.125
            if (abs(zeta(krscan)) .gt. 1.e+2) dscan = 0.25
            if (abs(zeta(krscan)) .gt. 1.e+4) dscan = 0.5
            if (abs(zeta(krscan)) .gt. 1.e+8) dscan = 1.0
            if (abs(zeta(krscan)) .gt. 1.e+16) dscan = 2.0
          elseif (kcscan .eq. ko2gaq) then
            dscan = 0.25
            if (abs(zeta(krscan)) .gt. 10.) dscan = 0.5
            if (abs(zeta(krscan)) .gt. 1.e+2) dscan = 1.0
            if (abs(zeta(krscan)) .gt. 1.e+4) dscan = 2.0
            if (abs(zeta(krscan)) .gt. 1.e+8) dscan = 4.0
            if (abs(zeta(krscan)) .gt. 1.e+12) dscan = 6.0
            if (abs(zeta(krscan)) .gt. 1.e+16) dscan = 8.0
            if (abs(zeta(krscan)) .gt. 1.e+24) dscan = 12.0
            if (abs(zeta(krscan)) .gt. 1.e+32) dscan = 16.0
          elseif (kcscan .eq. kelect) then
            dscan = 0.125
            if (abs(zeta(krscan)) .gt. 10.) dscan = 0.5
            if (abs(zeta(krscan)) .gt. 1.e+2) dscan = 1.0
            if (abs(zeta(krscan)) .gt. 1.e+4) dscan = 2.0
            if (abs(zeta(krscan)) .gt. 1.e+8) dscan = 4.0
            if (abs(zeta(krscan)) .gt. 1.e+12) dscan = 6.0
            if (abs(zeta(krscan)) .gt. 1.e+16) dscan = 8.0
            if (abs(zeta(krscan)) .gt. 1.e+24) dscan = 12.0
            if (abs(zeta(krscan)) .gt. 1.e+32) dscan = 16.0
          else
            dscan = 0.125
            if (abs(zeta(krscan)) .gt. 10.) dscan = 0.5
            if (abs(zeta(krscan)) .gt. 1.e+2) dscan = 1.0
            if (abs(zeta(krscan)) .gt. 1.e+4) dscan = 2.0
            if (abs(zeta(krscan)) .gt. 1.e+8) dscan = 4.0
            if (abs(zeta(krscan)) .gt. 1.e+12) dscan = 6.0
            if (abs(zeta(krscan)) .gt. 1.e+16) dscan = 8.0
            if (abs(zeta(krscan)) .gt. 1.e+24) dscan = 12.0
            if (abs(zeta(krscan)) .gt. 1.e+32) dscan = 16.0
          endif
c
          icorr = 0
          zvclgi = zvclg1(kcscan)
c
          if (kdirec .gt. 0) then
            zvclim = 99999.
          else
            zvclim = -99999.
          endif
c
          nscan = 0
          qstops = .false.
c
          zvclgo = zvclg1(kcscan)
          zetsqo = zetasq(krscan)
          zetsqm = zetsqo
          alephm = aleph
          nbigger = 0
c
c         The following is a return point for continuing the scan.
c
  410     nscan = nscan + 1
c
c         Increment the variable being scanned.
c
          zvclg1(kcscan) = zvclg1(kcscan) + kdirec*dscan
c
c         Apply a total change limit for a given cycle.
c
          dzxclm = 40.0
          if (kcscan .eq. kwater) dzxclm = 2.0
          if (kcscan .eq. khydr) dzxclm = 4.0
          if (kcscan.ge.km1 .and.kcscan.le.kxt) then
            dzxclm = 0.25
          endif
c
          qsclim = .false.
          dzx = zvclg1(kcscan) - zvclgi
          if (abs(dzx) .gt. dzxclm) then
            qsclim = .true.
            if (kdirec .gt. 0) then
              zvclg1(kcscan) = zvclgi + dzxclm
            else
              zvclg1(kcscan) = zvclgi - dzxclm
            endif
          endif
c
c         Expand the description of the equilibrium system using the
c         incremented variable.
c
          call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $    conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $    fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $    iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $    jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $    jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $    kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $    narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $    nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $    no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $    press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $    xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
          xbarw = xbar(narn1)
          xbrwlg = xbarlg(narn1)
c
c         Recompute the residuals.
c
          call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $    betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $    ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $    kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $    narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $    nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $    nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $    tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $    xlks,zchar)
c
c         Recompute the zeta residuals and the aleph residual.
c
          do krow = 1,kdim
            bx = beta(krow)
            if (krow .le. kbt) then
c
c             Mass balance element.
c
              if (bx .ge. 0.0) then
c
c               Have a non-negative beta(i) value. Set zeta(i) = beta(i).
c
                zeta(krow) = bx
              else
c
c               Have a negative beta(i) value.
c
                dx = 1.0 + bx
                if (dx .gt. eps100) then
c
c                 Have (-1.0 + eps100) < beta(i) < 0.0.
c                 Set zeta(i) = 1.0 - 1.0/(1.0 + beta(i)).
c
                  zeta(krow) = 1.0 - (1.0/dx)
                else
c
c                 Have beta(i) < (-1.0 + eps100).
c                 Set zeta(i) = 1.0 - (1.0/eps100).
c
                  zeta(krow) = 1.0 - eps1hi
                endif
              endif
            else
c
c             Mass action element.
c
c             zeta(i) = 0.001*beta(i)/cscale(i).
c
              ns = iindx1(krow)
              zeta(krow) = 0.001*bx/cscale(ns)
            endif
          enddo
c
c         Calculate the aleph and zeta-squared functions.
c
          aleph = 0.
          do krow = 1,kdim
            zetasq(krow) = zeta(krow)*zeta(krow)
            aleph = aleph + zetasq(krow)
          enddo
c
          if (iodb(3) .ge. 2) then
            write (noutpt,1620) zvclg1(kcscan),zetasq(krscan),aleph,
     $      dscan
            if (nscan .le. 0) then
c
c             The best point for this scan within the limits of the
c             minimum non-zero scan increment was the initial point.
c
              write (noutpt,1630)
 1630         format(/5x,'No correction was made.')
            endif
          endif
c
c         If the scan has stepped back to a previous point because
c         it gave a smaller residual, exit the scan now that all
c         residual functions have been recalculated.
c
          if (qstops) go to 420
c
c         Now check the results at the current point of the scan.
c         Is the new point better or not? If either the current
c         zeta-squared function or the aleph function has increased,
c         then the scan has over-corrected.
c
          if (aleph .gt. alephm) nbigger = nbigger + 1
          if (zetasq(krscan).gt.zetsqm .or.
     $      (aleph.gt.alephm .and. nbigger.ge.2)) then
c
c           Have over-corrected. Back up.
c
            nscan = nscan - 1
            nbigger = nbigger - 1
            zvclim = zvclg1(kcscan)
            zvclg1(kcscan) = zvclgo
c
c           Note: not everything has been reset here. It is still
c           necessary to go back and re-expand the description of the
c           equilibrium system.
c
            if (dscan .gt. dscmin) then
c
c             Reduce the scan increment.
c
              dscan = 0.5*dscan
c
c             Reduce the scan increment again if the new value of the
c             iteration variable would match the previously tried
c             extreme value.
c
              zvcnew = zvclg1(kcscan) + kdirec*dscan
              if (kdirec .gt. 0) then
                if (zvcnew .gt. (zvclim - eps100)) dscan = 0.5*dscan
              else
                if (zvcnew .lt. (zvclim + eps100)) dscan = 0.5*dscan
              endif
              if (dscan .lt. dscmin) dscan = dscmin
c
c             Go back and try the new, reduced scan increment.
c
            else
c
c             The previous value for this scan was better than any
c             subsequent adjusted value within the limitations imposed
c             by the minimum scan increment.
c
              dscan = 0.
              nscan = nscan  -1
c
c             Set up to stop the current scan.
c
              qstops = .true.
            endif
c
c           Go back and re-expand the system and recalculate all
c           residual functions. If qstops is .true., the scan increment
c           is zero and the only purpose in going back is to ensure
c           that all the residual functions are consistent with the
c           last point of the scan before continuing with the next
c           optimization step (e.g., next scan, cycle, pass), if any.
c
            qsclim = .false.
            go to 410
          endif
c
c         At this point, a non-zero correction has resulted in an
c         improvement, at least in the current zeta-squared function.
c
          icorr = icorr + 1
          zvclgo = zvclg1(kcscan)
          zetsqo = zetasq(krscan)
          zetsqm = min(zetsqm,zetsqo)
          if (aleph.lt. alephm) then
c
c           The aleph function was also improved.
c
            alephm = aleph
            nbigger = 0
          endif
c
          if (.not.qsclim .and. nscan .lt. 10) then
c
            zx = zvclg1(kcscan) - zvclgi
            if (abs(zx) .lt. dzxclm) then
c
c             Continue the current scan, using the same scan increment.
c
              go to 410
            endif
          endif
c
  420     if (iodb(3) .ge. 2) write (noutpt,1030)
c
c         At this point, a scan in one direction is complete.
c
          if (icorr .eq. 0) then
c
c           No correction was made by the scan in the current
c           direction.
c
            if (.not.qscan2) then
c
c             Go back and scan in the other direction.
c
              qscan2 = .true.
              kdirec = -kdirec
              if (iodb(3) .ge. 2) then
                write (noutpt,1640)
 1640           format(5x,'Scanning in the opposite direction',/)
              endif
              go to 300
            endif
          endif
c
c         End corrections for the current variable on this cycle.
c         Calculate the total correction for this scan.
c
          delvec(kcscan) = zvclg1(kcscan) - zvclgi
c
c         Count the number of variables which were actually corrected.
c
          if (icorr .gt. 0) kcorr = kcorr + 1
        endif
      enddo
c
      if (kcorr .le. 0) then
        if (iodb(3) .ge. 2) then
          write (noutpt,1650)
 1650     format(11x,'No corrections were generated.')
        endif
c
c       See if an alternate set of variables to correct should be
c       tried. For example, if H+ was to be corrected to reduce the
c       residual for Al+++, try correcting Al+++.
c
        nchange = 0
        do k = 1,kkdim
          krow = jasort(k)
          kcol = kmvar(k)
          if (kcol .ne. krow) then
            kmvar(k) = krow
            nchange = nchange + 1
          endif
        enddo
        if (nchange .gt. 0) then
          if (iodb(3) .ge. 2) then
            write (noutpt,1660)
 1660       format(11x,'Changing the set of variables to be',
     $      ' corrected',/11x,'and trying again.',/)
          endif
          go to 350
        endif
        write (noutpt,1662)
 1662   format(1x)
      endif
c
c     Check for an oscillating scan.
c
      qscosc = .false.
c
      do kcol = 1,kdim
        if (abs(delvec(kcol) + delprc(kcol)) .gt. eps100) go to 370
      enddo
c
c     The scan is oscillating. See if an alternate set of variables
c     to correct should be tried. For example, if H+ was to be
c     corrected to reduce the residual for Al+++, try correcting Al+++.
c
      if (iodb(3) .ge. 2) then
        write (noutpt,1670)
 1670   format(/11x,'The corrections are oscillating.')
      endif
c
      nchange = 0
      do k = 1,kkdim
        krow = jasort(k)
        kcol = kmvar(k)
        if (kcol .ne. krow) then
          kmvar(k) = krow
          nchange = nchange + 1
        endif
      enddo
      if (nchange .gt. 0) then
        if (iodb(3) .ge. 2) then
          write (noutpt,1660)
        endif
        go to 350
      endif
      write (noutpt,1662)
c
      qscosc = .true.
c
  370 continue
c
      do kcol = 1,kdim
        delprc(kcol) = delvec(kcol)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3).ge.1 .and. kcorr.gt.0) then
c
c       Summarize the scan corrections for the current cycle.
c
        write (noutpt,1680)
 1680   format(/16x,'--- Cycle Corrections ---',
     $  //2x,'krow   Name',32x,'zvclgi',6x,'zvclg1',6x,'delvec',/)
c
        do k = 1,kkdim
          if (knflag(k) .eq. 1) then
            krow = jasort(k)
            kcol = kmvar(k)
            if (delvec(kcol) .ne. 0.) then
c
c             Calling sequence substitutions:
c               uzvec1(kcol) for unam48
c
              call fmspnx(jlen,uzvec1(kcol),uspn56)
              zvclgi = zvclg1(kcol) - delvec(kcol)
              write (noutpt,1690) krow,uspn56,zvclgi,zvclg1(kcol),
     $        delvec(kcol)
 1690         format(1x,i4,2x,a32,2x,f10.4,2x,f10.4,2x,f10.4)
            endif
          endif
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kcorr.le.0 .or. qscosc .or. qsclim) go to 400
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Go back for another cycle.
c
      go to 220
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The cycles for the current pass have been completed. Test to
c     see if another pass should be made.
c
  400 if (iodb(3) .ge. 1) then
        write (noutpt,1700) npass,ncycle
 1700   format(13x,'Completed pass ',i3,' in ',i3,' cycles.')
      endif
c
c     Save the current values of the ionic strength, etc., and of the
c     the ativity coefficients.
c
      sigmmo = sigmam
      fxio = fxi
      fjeo = fje
      do ns = narn1,narn2
        acflgo(ns)=acflg(ns)
      enddo
c
c     Determine the maximum allowed change factors for "Sigma m",
c     etc. (chfsgm) and the log activity coefficients for aqueous
c     species (chfacf).
c
      chfsgm = 1.3
      if (sigmam .le. 2.e-1) chfsgm = 5.
      if (sigmam .le. 1.e-2) chfsgm = 10.
      if (sigmam .le. 1.e-3) chfsgm = 100.
      if (qtestc .and. chfsgm.lt.100.) chfsgm = 100.
      chfacf = 0.05
c
c     Note: setting iter = 0 would fix the activity coefficients
c     in concentrated solutions. Setting it to a high value (here
c     99999) insures that the activity coefficients are recalculated
c     as desired.
c
      iter = 99999
      rlxgam = 1.0
      qpracf = iodb(3) .ge. 4
c
      call ngcadv(abar,acflg,acflgo,actwlc,adh,adhh,adhv,
     $ afcnst,al10,aphi,azero,a3bar,a3bars,bacfmx,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,bgamx,bpx,bsigmm,bfje,bfxi,cco2,cgexj,
     $ chfacf,chfsgm,conc,delam,dgpit,dpelm,dpslm,dselm,elam,
     $ eps100,fje,fjeo,fxi,fxio,gpit,ibpxt,ielam,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilzeta,insgf,iopg,iter,ipndx1,ixrn1,
     $ ixrn2,izmax,jcsort,jern1,jern2,jgext,jsol,kx1,kxt,nalpha,
     $ napt,narn1,narn2,nchlor,ncmpr,net,nhydr,nmut,nmux,nmxi,
     $ nmxx,noutpt,nslt,nslx,nst,nsxi,nsxx,nttyo,omega,palpha,
     $ pelm,pmu,press,pslamn,pslm,qhawep,qpit75,qpracf,q6mode,
     $ rlxgam,selm,sigmam,sigmmo,tempk,ubacmx,ubgamx,uphase,
     $ uspec,wfac,xbar,xbarlg,xbarwc,xbrwlc,zchar,zchcu6,zchsq2)
c
c     Recalculate the concentrations, etc., of dependent species.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
      xbarw = xbar(narn1)
      xbrwlg = xbarlg(narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1720) bsigmm
 1720   format(/13x,'bsigmm= ',1pe12.5)
        write (noutpt,1730) bfxi
 1730   format(13x,'bfxi= ',1pe12.5)
        write (noutpt,1740) bfje
 1740   format(13x,'bfje= ',1pe12.5)
        j2 = ilnobl(ubgamx(1:24))
        write (noutpt,1750) bgamx,ubgamx(1:j2)
 1750   format(13x,'bgamx= ',1pe12.5,', ubgamx= ',a)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qcsigm =abs(bsigmm) .le. tolgpt
      qcfxi = abs(bfxi) .le. tolgpt
      qcgam = bgamx .le. tolgpt
c
      qtestp = qcsigm .and. qcfxi .and. qcgam
c
c     Are pass criteria satisfied?
c
      if (.not.qtestp) then
c
c       Pass criteria are not satisfied. Test for maximum number
c       of passes.
c
        if (npass .ge. nplim) then
c
c         Quit. Optimization ended outside requested limits
c         because the pass requirements were not satisfied.
c
          if (iodb(3) .ge. 1) then
            if (ker .lt. 2) then
              write (noutpt,1800)
 1800         format(/'   Done. Optimization ended outside requested',
     $        ' limits.',/)
            else
              write (noutpt,1810)
 1810         format(/'   Done. Optimization ended outside allowable',
     $        ' limits.',/)
            endif
          endif
          go to 999
        endif
c
c       Do another pass.
c
        go to 210
      endif
c
c     Are cycle criteria satisfied?
c
      if (qtestc) then
c
c       Yes, optimization succeeded.
c
        if (iodb(3) .ge. 1) then
          write (noutpt,1830)
 1830     format(/'   Done. Optimization ended within requested',
     $   ' limits.',/)
        endif
        go to 999
c
      elseif (ncycle.eq.0 .and. kcorr .le. 0) then
c
c       No cycle corrections were generated after starting a new
c       pass. Quit.
c
        if (iodb(3) .ge. 1) then
          if (ker .lt. 2) then
            write (noutpt,1800)
          else
            write (noutpt,1810)
          endif
        endif
        go to 999
c
      elseif (npass .le. 2) then
c
c       The pass convergence criteria are satisfied, but the cycle
c       convergence criteria are not.
c
c       Try another pass.
c
        go to 210
c
      else
c
c       Quit. Optimization ended outside requested limits
c       because cycle requirements were not met.
c
        if (iodb(3) .ge. 1) then
          if (ker .lt. 2) then
            write (noutpt,1800)
          else
            write (noutpt,1810)
          endif
        endif
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine path(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,
     $ adbdtv,adh,adhh,adhv,afcnst,aftarg,al10,aphi,apx,atwt,
     $ avcnst,awmax,awmaxi,awmin,awmini,azero,bdh,bdhh,bdhv,bdot,
     $ bdoth,bdotv,bpx,cbsr,cbsri,cco2,cdac,cdrs,cdrsd,cdrsx,
     $ cegexs,cesr,cesri,cess,cpgexs,cscale,csigma,csts,dadhh,
     $ dadhv,dbdhh,dbdhv,dbdth,dbdtv,dlaplo,dlaprn,dleplo,dleprn,
     $ dlhplo,dlhprn,dloplo,dloprn,dltplo,dltpll,dltprl,dltprn,
     $ dlxdmp,dlxmax,dlxmin,dlxmx0,dlxplo,dlxpll,dlxprl,dlxprn,
     $ eact,egers,egersi,egexjf,ehfac,ehmax,ehmaxi,ehmin,ehmini,
     $ elecsr,electr,eps100,farad,fkrc,hact,iact,iapxt,iaqsln,
     $ ibpxt,ibsrti,ielam,iern1,iern2,iesrti,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igerti,
     $ iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,
     $ ilrn2,ilzeta,imech,imrn1,imrn2,insgf,iodb,iopg,iopr,iopt,
     $ ipch,ipndx1,ipcv,irang,itermx,ixrn1,ixrn2,ixrti,izmax,
     $ jcode,jffg,jflag,jflagd,jflgi,jgerti,jpflag,jpress,jptffl,
     $ jreac,jsflag,jsitex,jsol,jtemp,kbt,kct,kdim,kelect,khydr,
     $ khydx,km1,kmt,ko2gaq,kprs,krdxsp,ksplmx,ksppmx,kstpmx,kwater,
     $ kxmod,kx1,kxt,loph,losp,modr,moffg,moph,morr,mosp,mprph,
     $ mprphi,mprsp,mprspi,mrgers,mrgexs,mtb,mtbi,mtbaq,mtbaqi,
     $ mte,mteaq,mwtrc,mwtsp,narn1,narn2,narxt,nat,nbasp,nbaspd,
     $ nbaspi,nbaspx,nbkupa,nbkupb,nbt,nbtd,nbti,nbw,nchlor,
     $ ncmpr,nct,ndac,ndact,nelect,nern1,nern2,ness,nessr,net,
     $ ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,ndrsrx,nert,newin,nffg,
     $ nfrn1,nfrn2,ngrn1,ngrn2,ngt,nhydr,nhydx,nllnmx,nlrn1,
     $ nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,nobswt,noutpt,no2gaq,npchk,
     $ nphasx,nprob,nprpti,nprsti,npslmx,npt,nrct,nrdxsp,nrk,
     $ nrndex,nsbswt,nsk,nsrt,nsslmx,nst,nsts,nstsr,ntabx,ntf1,
     $ ntf1t,ntf2,ntf2t,ntitl1,ntitl2,ntitld,ntpr,ntprt,ntrymx,
     $ nttyo,nxmod,nxopex,nxopt,nxridx,nxrn1,nxrn2,nxrt,nxt,o2max,
     $ o2maxi,o2min,o2mini,phmax,phmaxi,phmin,phmini,prcinf,
     $ press,pressb,pressd,pressi,ptk,qcnpre,qcntmp,qdwipp,
     $ qecon,qgexsh,qhawep,qoptmz,qpit75,qredox,qscon,qtatxt,
     $ rconst,rcnstv,rk,rkb,rtcnst,rxbar,rxbari,sfcar,smp100,
     $ sscrew,ssfcar,tempc,tempcb,tempcd,tempci,tempcu,tempk,
     $ tf1,tf2,timemx,time1,timmxi,tistrt,tistti,trkb,ttk,tolaft,
     $ tolbt,toldl,tolsat,tolsst,tolxsf,tolxst,tolxsu,uaqsln,
     $ ubmtbi,ubsri,ucxri,udac,uelem,uesri,uffg,ufixf,ugerji,
     $ ugermo,ugersi,uinfor,ulinex,uobsw,uphase,uplatm,uprphi,
     $ uprspi,ureac,usbsw,uspec,usteq6,utitl1,utitl2,utitld,
     $ uveeq6,uxcat,uxmod,uxopex,uxopt,uzvec1,uzveci,vosp0,vreac,
     $ wfac,xgers,xgersi,ximax,ximaxi,xistrt,xistti,xi1,xlkffg,
     $ xlkmod,zchar,zchcu6,zchsq2,zklgmn,zklogl,zklogu,zvclgi,
     $ zvclg1,zvec1)
c
c     This subroutine is the control subroutine for tracing a reaction
c     path. It determines a variable step size, which is in terms of an
c     overall reaction progress variable. The corresponding time step,
c     if defined, is computed as a dependent variable. This subroutine
c     also detects and responds to various events, such as saturation
c     of irreversible reactions and exhaustion of reactants.
c
c     The mathematical treatment of the algebraic relations is
c     analogous to the predictor-corrector method of integrating
c     differential equations. Finite difference expressions of order
c     up to nordmx are used as predictor functions. These are
c     manipulated into the form of truncated Taylor's series.
c     EQ6/eqcalc.f is used as the "corrector." This subroutine does
c     equilbrium calculations using a hybrid Newton-Raphson algorithm.
c     Note that it corrects to satisfy algebraic equations, not
c     differential equations.
c
c     In kinetic mode (iopt(2) > 0), rate laws are integrated using an
c     actual predictor-corrector algorithm. Algebraic equations continue
c     to be dealt with as described above. Rate law integration is
c     done using finite-difference expressions of the same order
c     as those used to represent algebraic variables.
c
c     Apart from no time/time, there are three distinct calculational
c     modes:
c
c       (1) Normal mode- The step size is constrained to keep the
c         predictor functions fairly accurate. There is less burden
c         on the Newton-Raphson thermodynamic calculations.
c         Normal mode requires longer run times and is more
c         expensive than economy mode. Normal mode must be used
c         for some kinds of problems. Examples include the cases
c         iopt(2) > 0 (kinetic mode) and iopt(1) = 2, (flow-through
c         open system mode). Setting iopt(13) = 0 insures that
c         normal mode will be selected. It will automatically be
c         selected if economy or super-economy modes are not valid
c         options.
c
c       (2) Economy mode- The step size is allowed to become large
c         more quickly than in normal mode. The predictor functions
c         are limited to second order. There is no attempt to
c         constrain the step size in order to keep these functions
c         accurate. The burden on the equilibrium calculations is
c         heavier than in normal mode, because the initial values of
c         the unknowns will generally be farther off the mark.
c         Economy mode is intended to be faster and cheaper than
c         normal mode. The useful information density along the
c         reaction path with economy mode is essentially equivalent to
c         that obtained with normal mode. Use iopt(13) = 1 to select
c         economy mode.
c
c       (3) Super economy mode- This is a special from of economy
c         mode. The step size is typically large. It defaults to
c         dlxprn, the linear print interval. Phase boundaries are
c         ignored. The order of the finite differences is restricted
c         to zero. Super economy mode provides much less information
c         density along the reaction path than does economy mode or
c         normal mode. Use iopt(13) = 2 to select super economy mode.
c
c     The step size is controlled by various constraints. One of these
c     is the estimated accuracy of the predictor functions. If the
c     system is rapidly changing, delxi will be small and the run time
c     per unit reaction progress will be long. This is generally the
c     case at the start of a reaction path simulation. When the system
c     is changing slowly with respect to reaction progress, delxi may
c     become large. Other controls on the step size include:
c
c        (1) The initial step size (for order zero)
c        (2) An arbitrary upper limit on step size
c        (3) The print interval requirements
c        (4) The plot interval requirements
c        (5) An arbitrary dump interval (flow-through model only)
c        (6) The exhaustion of any reactant
c        (7) The appearance or disappearance of any secondary
c            phase (unless iopt(3) .ge. 1)
c        (8) A maximum in the mass of any secondary mineral
c            (fluid-centered flow-through model only)
c        (9) Crossing 100 degrees C, if temperature is changing with
c            reaction progress
c       (10) The terminal value of reaction progress
c       (11) The terminal value of time, or infinite time
c
c     In the flow-through open system model (iopt(1) = 2), masses of
c     secondary minerals are shifted to the physically removed
c     subsystem after any of (5) through (11) above.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
      include 'eqlib/eql1s.h'
      include 'eqlib/eqlwd.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbkupa,nbkupb,newin,noutpt,ntabx,nttyo
c
      integer jcode(nrctmx),jreac(nrctmx),nrndex(nrctmx),nxridx(nrctmx)
c
      integer iact(imchmx,2,nrctmx),imech(2,nrctmx),
     $ ndac(ndctmx,imchmx,2,nrctmx),ndact(imchmx,2,nrctmx),
     $ nrk(2,nrctmx),nsk(nrctmx)
c
      integer ibsrti(nsrtmx),iesrti(nsrtmx),igerti(jetmax,nertmx),
     $ ixrti(nxrtmx),jflgi(nbtmax),jgerti(nertmx)
c
      integer iapxt(nxtmax),ibpxt(nxtmax),iindx1(kmax),
     $ ipndx1(kmax),insgf(natmax),iodb(nodbmx),iopg(nopgmx),
     $ iopr(noprmx),iopt(noptmx),jffg(nffgmx),jflag(nstmax),
     $ jflagd(nstmax),jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),
     $ jsol(nxtmax),kxmod(nxmdmx)
c
      integer narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),
     $ nbaspi(nbtmax),nbaspx(nbtmax),ncmpr(2,nptmax),ness(nessmx),
     $ nessr(2,nstmax),ndrs(ndrsmx),ndrsd(ndrsmx),ndrsx(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrd(2,nstmax),ndrsrx(2,nstmax),npchk(nptmax),
     $ nphasx(nstmax),nsts(nstsmx),nstsr(2,nstmax),ntf1(ntf1mx),
     $ ntf2(ntf2mx)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer kprs,nbti,nprpti,nprsti
c
      integer iaqsln,ielam,igas,ipch,ipcv,itermx,irang,izmax,jpress,
     $ jptffl,jtemp,kbt,kct,kdim,kelect,khydr,khydx,km1,kmt,ko2gaq,
     $ krdxsp,ksplmx,ksppmx,kstpmx,kwater,kx1,kxt,nbtd,nbw,nchlor,
     $ nelect,nert,nffg,nhydr,nhydx,nllnmx,nmrt,nobswt,no2gaq,nprob,
     $ npslmx,nrct,nrdxsp,nsbswt,nsrt,nsslmx,ntf1t,ntf2t,ntitl1,
     $ ntitl2,ntitld,ntpr,ntprt,ntrymx,nxmod,nxopex,nxopt,nxrt
c
      logical qcnpre,qcntmp,qdwipp,qecon,qgexsh,qhawep,qoptmz,qpit75,
     $ qredox,qscon,qstart,qtatxt,qvhfxi,qvlsow
c
      character(len=nllnmx) ulinex
      character(len=80) utitl1(ntitmx),utitl2(ntitmx),utitld(ntidmx)
      character(len=48) ubmtbi(nbtmax),uprspi(nprsmx),uzveci(kmax)
      character(len=48) uobsw(2,nbtmax),usbsw(2,nbtmax),uspec(nstmax),
     $ uxmod(nxmdmx),uzvec1(kmax)
      character (len=24) ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ ugersi(ietmax,jetmax,nertmx),uprphi(nprpmx)
      character(len=24) ugermo(nertmx),ureac(nrctmx)
      character(len=24) uffg(nffgmx),uphase(nptmax),uxcat(nxopmx),
     $ uxopex(nxpemx)
      character(len=24) udac(ndctmx,imchmx,2,nrctmx)
      character(len=24) uaqsln
      character(len=8) uesri(nctmax,nsrtmx),ugerji(jetmax,nertmx)
      character(len=8) uelem(nctmax),uxopt(nxopmx)
      character(len=8) ufixf,uinfor,uplatm,usteq6,uveeq6
c
      real(8) aadh(narxmx,ntprmx),aadhh(narxmx,ntprmx),
     $ aadhv(narxmx,ntprmx),aaphi(narxmx,ntprmx),
     $ abdh(narxmx,ntprmx),abdhh(narxmx,ntprmx),
     $ abdhv(narxmx,ntprmx),abdot(narxmx,ntprmx),
     $ abdoth(narxmx,ntprmx),abdotv(narxmx,ntprmx)
c
      real(8) dadhh(ipchmx),dadhv(ipcvmx),dbdhh(ipchmx),dbdhv(ipcvmx),
     $ dbdth(ipchmx),dbdtv(ipcvmx)
c
      real(8) cbsri(nbt1mx,nsrtmx),cesri(nctmax,nsrtmx),
     $ egersi(ietmax,jetmax,nertmx),mprphi(nprpmx),mprspi(nprsmx),
     $ mtbi(nbtmax),mtbaqi(nbtmax),rxbari(iktmax,nxrtmx),
     $ xgersi(ietmax,jetmax,nertmx),zvclgi(kmax)
c
      real(8) adadhh(narxmx,ntprmx,ipchmx),
     $ adadhv(narxmx,ntprmx,ipcvmx),adbdhh(narxmx,ntprmx,ipchmx),
     $ adbdhv(narxmx,ntprmx,ipcvmx),adbdth(narxmx,ntprmx,ipchmx),
     $ adbdtv(narxmx,ntprmx,ipcvmx)
c
       real(8) cdac(ndctmx,imchmx,2,nrctmx),csigma(imchmx,2,nrctmx),
     $ eact(imchmx,2,nrctmx),fkrc(nrctmx),hact(imchmx,2,nrctmx),
     $ rkb(imchmx,2,nrctmx),trkb(imchmx,2,nrctmx)
c
      real(8) cbsr(nbt1mx,nsrtmx),cesr(nctmax,nsrtmx),
     $ egers(ietmax,jetmax,nertmx),elecsr(nsrtmx),modr(nrctmx),
     $ mrgers(ietmax,jetmax,nertmx),morr(nrctmx),mwtrc(nrctmx),
     $ rxbar(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),vreac(nrctmx),
     $ xgers(ietmax,jetmax,nertmx)
c
      real(8) apx(iapxmx,nxtmax),atwt(nctmax),
     $ azero(natmax),bpx(ibpxmx,nxtmax),cco2(5),
     $ cegexs(ietmax,jetmax,netmax),cpgexs(ietmax,jetmax,netmax),
     $ cess(nessmx),cdrs(ndrsmx),cdrsd(ndrsmx),cdrsx(ndrsmx),
     $ cscale(nstmax),csts(nstsmx),
     $ egexjf(jetmax,netmax),loph(nptmax),losp(nstmax),
     $ moph(nptmax),mosp(nstmax),moffg(nffgmx),mprph(nptmax),
     $ mprsp(nstmax),mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),
     $ mtbaq(nbtmax),mte(nctmax),mteaq(nctmax),mwtsp(nstmax),
     $ ptk(nptkmx),rk(imchmx,2,nrctmx),
     $ sscrew(nsscmx),tempcu(ntprmx),tf1(ntf1mx),tf2(ntf2mx),
     $ ttk(nttkmx),vosp0(nstmax),wfac(iktmax,nxtmax),xlkffg(nffgmx),
     $ xlkmod(nxmdmx),zchar(nstmax),zchcu6(nstmax),zchsq2(nstmax),
     $ zvclg1(kmax),zvec1(kmax)
c
      real(8) adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real(8) afcnst,aftarg,al10,avcnst,awmax,awmaxi,awmin,awmini,
     $ dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxdmp,dlxmax,dlxmin,dlxmx0,dlxpll,dlxplo,
     $ dlxprl,dlxprn,ehfac,ehmax,ehmaxi,ehmin,ehmini,electr,eps100,
     $ farad,o2max,o2maxi,o2min,o2mini,phmax,phmaxi,phmin,phmini,
     $ prcinf,press,pressb,pressd,pressi,rcnstv,rconst,rtcnst,
     $ smp100,tempc,tempcb,tempcd,tempci,tempk,timemx,time1,timmxi,
     $ tistrt,tistti,tolaft,tolbt,toldl,tolsat,tolsst,tolxsf,tolxst,
     $ tolxsu, ximax,ximaxi,xistrt,xistti,xi1,zklgmn,zklogl,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with static global dimensioning.
c
      character(len=32) uxtype(jso_par)
c
      real(8) egexjc(jet_par,net_par),egexpa(net_par),egexpc(net_par),
     $ egexs(iet_par,jet_par,net_par),egexw(ket_par,net_par),
     $ xgexw(ket_par,net_par)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with variable global dimensioning.
c
      integer, dimension(:), allocatable :: ibswx,idirec
c
      integer, dimension(:), allocatable :: igstak,ipivot,ipivtr,
     $ istack,ixbasp,jcsort,jgstak,jgsort,jjsort,jssort,jstack,
     $ kction
c
      integer, dimension(:), allocatable :: iemop,iemop0,iemos,iemos0,
     $ iexr,iindx0,ipndx0,jexr,jreac0,jsca,jscr
c
      integer, dimension(:,:), allocatable :: ncmpe,ncmpe0
c
      integer, dimension(:,:,:), allocatable :: ndactb
c
      integer, dimension(:,:,:,:), allocatable :: ndacb
c
      logical, dimension(:), allocatable :: qxknph
c
      character(len=48), dimension(:), allocatable :: uzvec0
      character(len=8), dimension(:), allocatable :: ulbeta,uldel
c
      real(8), dimension(:,:), allocatable :: akmat0,akmat1,daffp0,
     $ dafrc0,demop0,demos0,drer0,drer0s,dzvc0,dzvc0s,fdafm1,fdaf0,
     $ fdarm1,fdar0,fdpem1,fdpe0,fdrem1,fdre0,fdre1,fdrrm1,fdrr0,
     $ fdrr1,fdsem1,fdse0,fdzvm1,fdzv0
c
      real(8), dimension(:), allocatable :: affp,affp0,affs,afrc0,
     $ afrc1,afrcp,cjbasp,cnufac,ctb,daw0,deh0,do20,dph0,drir0,drir0s,
     $ dxsm00,dxsm10,dxsm11,dxval0,d1zvc1,d1emp1,d2emp1,ehrc,emop,
     $ emop0,emos,emos0,fdaw0,fdawm1,fdeh0,fdehm1,fdo20,fdo2m1,
     $ fdph0,fdphm1,fdrim1,fdri0,fdri1,fo2lrc
c
      real(8), dimension(:), allocatable :: acflg,acflgo,acflg0,act,
     $ actlg,ahrc,affpd,affsd,alpha,amtb,a3bars,beta,betao,cdrtw,cdrw,
     $ conc,conclg,cteaq,delvco,delvec,dlogxw,fsort,fugac,fugalg,
     $ lsort,ppmwb,ppmwe,rhsvec,rreacn,rreac0,rreac1,rrelrp,rrelr0,
     $ rrelr1,sfcar0,sidrph,sidrsp,wodr,worr,xbar,xbarlg
c
      real(8), dimension(:), allocatable :: modr0,mophg,mophj,mopht,
     $ moph0,morr0,mospg,mospj,mospt,mosp0,mtb0,perc,voph,vophg,
     $ vophj,vopht,vosp,vospg,vospj,vospt,weight,woph,wophg,wophj,
     $ wopht,wosp,wospg,wospj,wospt,xirct,xirct0,zvclg0,zvec0
c
      real(8), dimension(:), allocatable :: alphar,betar,delvcr,rhsvcr,
     $ dvjdte
c
      real(8), dimension(:), allocatable :: hhcvec,xhcvec
c
      real(8), dimension(:,:), allocatable :: aamatr,gmmatr
      real(8), dimension(:,:), allocatable :: armatr,grmatr
      real(8), dimension(:,:), allocatable :: aimatr,mmmatr,sgmatr,
     $ xxmatr,xymatr,rrxfi1
c
      real(8), dimension(:,:,:,:), allocatable :: cdacb
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nbkupn
c
      integer nrct1
c
      integer i,iavkdm,ibtrmx,idlrmx,ier,iexrt,inmax,iter,iwdh2o,
     $ iwnffg,j,jcut,jexrt,jexrtx,jordlm,jsawth,jscat,jscatx,jscrt,
     $ jscrtx,j2,j3,kaft1,kcol,kdim0,kly,km10,kmt0,kord,kordlm,kordp1,
     $ kordsv,kpsat,kpsst,kstep,kstpab,kstppl,kstppr,kstpmn,kstpze,kx10,
     $ kxt0,kzmax,n,naft1,nb,nc,ncorr,ncut,ndelay,ne,ng,nlwffg,nmax,
     $ nord,nordr,nordrs,nordsv,nordz,nordzs,np,npe,npet,npet0,npts,
     $ nrc,nr1,nr2,ns,nsawth,nse,nset,nset0,nswtch,ntpr0,nwdh2o,
     $ nweope,nwndpc,nwnffg
c
      integer iarmxn,ilnobl
c
      logical qabswx,qadjdx,qaflip,qaft1,qbassw,qbseqc,qbswx,qbye,
     $ qconst,qodeok,qftpr2,qdmpr1,qdmpr2,qdump,qhcon,qmin,qmod,qmod1,
     $ qmod2,qphcl,qplaw0,qplaw1,qpleh0,qpleh1,qplolt,qplolx,qplott,
     $ qplotx,qplo20,qplo21,qplph0,qplph1,qpr,qpraw0,qpraw1,qpreh0,
     $ qpreh1,qprnlt,qprnlx,qprntt,qprntx,qpro20,qpro21,qprph0,qprph1,
     $ qrapch,qreax,qreq,qrho,qriinf,qrpcfl,qsawth,qshoot,qskip,
     $ qstabl,qstabr,qstabz,qstop,qstopx,qtplo,qtprn,qtrch,qtvchk,
     $ qwhcfa,qx,qxbarw,qzdump,qzplot,qzprnt,qztayl,q6mode
c
      character(len=48) ubacmx,ubgamx
      character(len=24) ustr24,ux24
      character(len=16) ux16,ux16a,ux16b
      character(len=8) upkfor
c
      real(8) abar,acfw,acfwlg,actw,actwlc,actwlg,adel,adlzlg,adx,aft1,
     $ aft0,aftm1,ah,ahmes,ahnbs,alk,alki,alk1,alk2,av,avkdim,avdlxi,
     $ awstrt,aw0,aw0plo,aw0prn,aw1,aw1plo,aw1prn,a3bar,bacfmx,bbig,
     $ betamx,bgamx,bneg,deltim,delxi,delxia,dlxilm,dlximx,dlxipl,
     $ dlxipr,dlxisv,dlxis2,dlxlim,dlxode,dlxtmx,dlxtpr,dlxtpl,dvoso,
     $ dwoso,dx,dxdmp,dxsave,dx1,dx2,eh,ehmes,ehnbs,ehstrt,eh0,eh0plo,
     $ eh0prn,eh1,eh1plo,eh1prn,fdlim,fdx,fje,fjeo,fje0,fjest,fo2,
     $ fo2lg,fo2lg0,fo2lg1,fxi,fxio,fxi0,fxist,fxprpl,morrw1,mx,lprcin,
     $ lx,osc,oscst,omega,omeglg,o2strt,o20plo,o20prn,o21plo,o21prn
c
      real(8) pch,pe,pemes,penbs,ph,phcl,phmes,phnbs,phstrt,ph0,ph0plo,
     $ ph0prn,ph1,ph1plo,ph1prn,prminf,rho,rirecp,rirec0,rirec1,rx0,
     $ rx1,rxx,scale,scalim,scfcr,scfcrs,scfcz,scfczs,scnsti,scnstd,
     $ screwd,sigmam,sigmmo,sigmm0,sigmst,tempc0,thours,time0,tiplol,
     $ tiplot,tiplxx,tiprnl,tiprnt,tiprxx,tistrd,tistry,tistsv,tmins,
     $ tolsar,tolsrr,tyears,vodrt,tdays,vosoct,vosol,wfh2o,wftds,
     $ whcfac,wkgh2o,wwstrt,wkgsol,wkgwi,wodrt,woh2o,worrt,wosoct,
     $ wosol,wotds,wx,xbarw,xbarwc,xbrwlc,xbrwlg,xf,xidump,xilim,
     $ xim1,xiplol,xiplot,xiprnl,xiprnt,xistsv,xi0,xlf,xval0,xx
c
      real(8) dxe0mx,dxe1mx,dxe0pl,dxe1pl,dxe0pr,dxe1pr,dxh0mx,dxh1mx,
     $ dxh0pl,dxh1pl,dxh0pr,dxh1pr,dxo0mx,dxo1mx,dxo0pl,dxo1pl,
     $ dxo0pr,dxo1pr,dxw0mx,dxw1mx,dxw0pl,dxw1pl,dxw0pr,dxw1pr
c
      real(8) btrfnc,btrmax,btrmxo,dlrfnc,dlrmax,dlrmxo
c
      real(8) mlmrra,mrmlra,rhoc,rhowc,tdsgks,tdsglw,tdspkc,tdsplc
c
      real(8) fctrl,texp,tlg
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Local data needed to assist in writing
c     an EQ6 pickup file. These variables do not appear on that file
c     itself.
c
      integer ibsrt1,iesrt1
c
      character(len=24), dimension(:), allocatable :: ubsr1
      character(len=8), dimension(:), allocatable :: uesr1
c
      character(len=24) ureac1
c
      real(8), dimension(:), allocatable :: cbsr1,cesr1
c
c-----------------------------------------------------------------------
c
c     Names of solid solution models.
c
      data uxtype(1) /'Ideal solution                  '/
      data uxtype(2) /'Binary, third-order Maclaurin   '/
      data uxtype(3) /'Binary, parabolic Maclaurin     '/
      data uxtype(4) /'Binary, cubic Maclaurin (P,T)   '/
      data uxtype(5) /'Binary, Guggenheim (T)          '/
      data uxtype(6) /'Ternary, regular                '/
      data uxtype(7) /'Plagioclase (Newton et al. 1980)'/
c
c     Limit on the number of points of reaction progress beyond the
c     starting point at which warnings are issued regarding fugacities
c     not being at specified values.
c
      data nlwffg / 3 /
c
c     The variable "alk" is not used in this subroutine except to
c     satisfy certain EQLIB subroutine calls.
c
      data alk /0./
c
      data fxprpl /0.2/
c
      data qxbarw/.false./
c
c-----------------------------------------------------------------------
c
c     Allocate additional arrays needed to compute the reaction path.
c
      ALLOCATE(ctb(nbtmax))
      ALLOCATE(ppmwb(nbtmax))
      ALLOCATE(ehrc(nbtmax))
      ALLOCATE(cjbasp(nbtmax))
      ALLOCATE(ibswx(nbtmax))
      ALLOCATE(ixbasp(nbtmax))
      ALLOCATE(dlogxw(nbtmax))
c
      ALLOCATE(aamatr(kmax,kmax))
      ALLOCATE(gmmatr(kmax,kmax))
c
      ALLOCATE(iindx0(kmax))
      ALLOCATE(ipivot(kmax))
      ALLOCATE(ipndx0(kmax))
c
      ALLOCATE(alpha(kmax))
      ALLOCATE(beta(kmax))
      ALLOCATE(betao(kmax))
      ALLOCATE(delvco(kmax))
      ALLOCATE(delvec(kmax))
      ALLOCATE(d1zvc1(kmax))
      ALLOCATE(rhsvec(kmax))
      ALLOCATE(zvclg0(kmax))
      ALLOCATE(zvec0(kmax))
c
      ALLOCATE(uzvec0(kmax))
      ALLOCATE(uldel(kmax))
      ALLOCATE(ulbeta(kmax))
c
      ALLOCATE(a3bars(natmax))
c
      ALLOCATE(kction(nbtmax))
c
      ALLOCATE(ahrc(nbtmax))
      ALLOCATE(amtb(nbtmax))
      ALLOCATE(fo2lrc(nbtmax))
      ALLOCATE(mtb0(nbtmax))
      ALLOCATE(perc(nbtmax))
c
      ALLOCATE(igstak(ngtmax))
      ALLOCATE(jgstak(ngtmax))
      ALLOCATE(jgsort(ngtmax))
c
      ALLOCATE(cteaq(nctmax))
      ALLOCATE(ppmwe(nctmax))
c
      ALLOCATE(fsort(ngtmax))
      ALLOCATE(fugac(ngtmax))
      ALLOCATE(fugalg(ngtmax))
c
      ALLOCATE(ncmpe(2,npetmx))
      ALLOCATE(ncmpe0(2,npetmx))
c
      ALLOCATE(dzvc0(nrd1mx,kmax))
      ALLOCATE(dzvc0s(nrd1mx,kmax))
      ALLOCATE(fdzvm1(nrd1mx,kmax))
      ALLOCATE(fdzv0(nrd1mx,kmax))
c
      ALLOCATE(akmat0(nrd1mx,nrd1mx))
      ALLOCATE(akmat1(nrd1mx,nrd1mx))
c
      ALLOCATE(daffp0(nordmx,nptmax))
      ALLOCATE(fdafm1(nordmx,nptmax))
      ALLOCATE(fdaf0(nordmx,nptmax))
c
      ALLOCATE(dafrc0(nordmx,nrctmx))
      ALLOCATE(drer0(nrd1mx,nrctmx))
      ALLOCATE(drer0s(nrd1mx,nrctmx))
      ALLOCATE(fdarm1(nordmx,nrctmx))
      ALLOCATE(fdar0(nordmx,nrctmx))
      ALLOCATE(fdrem1(nordmx,nrctmx))
      ALLOCATE(fdre0(nordmx,nrctmx))
      ALLOCATE(fdre1(nordmx,nrctmx))
      ALLOCATE(fdrrm1(nrd1mx,nrctmx))
      ALLOCATE(fdrr0(nrd1mx,nrctmx))
      ALLOCATE(fdrr1(nrd1mx,nrctmx))
c
      ALLOCATE(demop0(nordmx,npetmx))
      ALLOCATE(fdpem1(nordmx,npetmx))
      ALLOCATE(fdpe0(nordmx,npetmx))
c
      ALLOCATE(demos0(nordmx,nsetmx))
      ALLOCATE(fdsem1(nordmx,nsetmx))
      ALLOCATE(fdse0(nordmx,nsetmx))
c
      ALLOCATE(daw0(nordmx))
      ALLOCATE(fdawm1(nordmx))
      ALLOCATE(fdaw0(nordmx))
      ALLOCATE(deh0(nordmx))
      ALLOCATE(fdehm1(nordmx))
      ALLOCATE(fdeh0(nordmx))
      ALLOCATE(do20(nordmx))
      ALLOCATE(fdo2m1(nordmx))
      ALLOCATE(fdo20(nordmx))
      ALLOCATE(dph0(nordmx))
      ALLOCATE(fdphm1(nordmx))
      ALLOCATE(fdph0(nordmx))
c
      ALLOCATE(dxsm00(nrd1mx))
      ALLOCATE(dxsm10(nrd1mx))
      ALLOCATE(dxsm11(nrd1mx))
c
      ALLOCATE(drir0(nrd1mx))
      ALLOCATE(drir0s(nrd1mx))
c
      ALLOCATE(fdrim1(nrd1mx))
      ALLOCATE(fdri0(nrd1mx))
      ALLOCATE(fdri1(nrd1mx))
c
      ALLOCATE(dxval0(nrd1mx))
c
      ALLOCATE(iemop(npetmx))
      ALLOCATE(iemop0(npetmx))
c
      ALLOCATE(d1emp1(npetmx))
      ALLOCATE(d2emp1(npetmx))
      ALLOCATE(emop(npetmx))
      ALLOCATE(emop0(npetmx))
c
      ALLOCATE(qxknph(nptmax))
c
      ALLOCATE(affp(nptmax))
      ALLOCATE(affp0(nptmax))
      ALLOCATE(affpd(nptmax))
      ALLOCATE(mophg(nptmax))
      ALLOCATE(mophj(nptmax))
      ALLOCATE(mopht(nptmax))
      ALLOCATE(moph0(nptmax))
      ALLOCATE(sidrph(nptmax))
      ALLOCATE(voph(nptmax))
      ALLOCATE(vophj(nptmax))
      ALLOCATE(vophg(nptmax))
      ALLOCATE(vopht(nptmax))
      ALLOCATE(woph(nptmax))
      ALLOCATE(wophg(nptmax))
      ALLOCATE(wophj(nptmax))
      ALLOCATE(wopht(nptmax))
c
      ALLOCATE(iexr(nrctmx))
      ALLOCATE(jexr(nrctmx))
      ALLOCATE(jreac0(nrctmx))
      ALLOCATE(jsca(nrctmx))
      ALLOCATE(jscr(nrctmx))
c
      ALLOCATE(afrc0(nrctmx))
      ALLOCATE(afrc1(nrctmx))
      ALLOCATE(afrcp(nrctmx))
      ALLOCATE(idirec(nrctmx))
      ALLOCATE(sfcar0(nrctmx))
      ALLOCATE(modr0(nrctmx))
      ALLOCATE(morr0(nrctmx))
      ALLOCATE(rreacn(nrctmx))
      ALLOCATE(rreac0(nrctmx))
      ALLOCATE(rreac1(nrctmx))
      ALLOCATE(rrelrp(nrctmx))
      ALLOCATE(rrelr0(nrctmx))
      ALLOCATE(rrelr1(nrctmx))
      ALLOCATE(wodr(nrctmx))
      ALLOCATE(worr(nrctmx))
      ALLOCATE(xirct(nrctmx))
      ALLOCATE(xirct0(nrctmx))
c
      ALLOCATE(rrxfi1(imchmx,nrctmx))
c
      ALLOCATE(iemos(nsetmx))
      ALLOCATE(iemos0(nsetmx))
c
      ALLOCATE(emos(nsetmx))
      ALLOCATE(emos0(nsetmx))
c
      ALLOCATE(istack(nstmax))
      ALLOCATE(jstack(nstmax))
      ALLOCATE(jcsort(nstmax))
      ALLOCATE(jjsort(nstmax))
      ALLOCATE(jssort(nstmax))
c
      ALLOCATE(acflg(nstmax))
      ALLOCATE(acflgo(nstmax))
      ALLOCATE(acflg0(nstmax))
      ALLOCATE(act(nstmax))
      ALLOCATE(actlg(nstmax))
      ALLOCATE(affs(nstmax))
      ALLOCATE(affsd(nstmax))
      ALLOCATE(cdrtw(nstmax))
      ALLOCATE(cdrw(nstmax))
      ALLOCATE(cnufac(nstmax))
      ALLOCATE(conc(nstmax))
      ALLOCATE(conclg(nstmax))
      ALLOCATE(lsort(nstmax))
      ALLOCATE(mospg(nstmax))
      ALLOCATE(mospj(nstmax))
      ALLOCATE(mospt(nstmax))
      ALLOCATE(mosp0(nstmax))
      ALLOCATE(sidrsp(nstmax))
      ALLOCATE(vosp(nstmax))
      ALLOCATE(vospg(nstmax))
      ALLOCATE(vospj(nstmax))
      ALLOCATE(vospt(nstmax))
      ALLOCATE(weight(nstmax))
      ALLOCATE(wosp(nstmax))
      ALLOCATE(wospg(nstmax))
      ALLOCATE(wospj(nstmax))
      ALLOCATE(wospt(nstmax))
      ALLOCATE(xbar(nstmax))
      ALLOCATE(xbarlg(nstmax))
c
c-----------------------------------------------------------------------
c
c     Allocate some additional arrays associated with the higher-order
c     (stiff) ODE integrator.
c
      nrct1 = nrct + 1
c
      ALLOCATE(ipivtr(nrct1))
c
      ALLOCATE(alphar(nrct1))
      ALLOCATE(betar(nrct1))
      ALLOCATE(delvcr(nrct1))
      ALLOCATE(rhsvcr(nrct1))
      ALLOCATE(dvjdte(nrct))
c
      ALLOCATE(armatr(nrct1,nrct1))
      ALLOCATE(grmatr(nrct1,nrct1))
c
      ALLOCATE(aimatr(kmax,kmax))
      ALLOCATE(mmmatr(nrct,kmax))
      ALLOCATE(sgmatr(nrct,kmax))
      ALLOCATE(xxmatr(kmax,nrct))
      ALLOCATE(xymatr(nrct,nrct1))
c
      ALLOCATE(cdacb(nbt,imchmx,2,nrct))
      ALLOCATE(ndacb(nbt,imchmx,2,nrct))
      ALLOCATE(ndactb(imchmx,2,nrct))
c
      ALLOCATE(hhcvec(nordmx))
      ALLOCATE(xhcvec(nordmx))
c
c-----------------------------------------------------------------------
c
c     Allocate some arrays needed to assist in writing an EQ6 pickup
c     file. These arrays do not appear on that file itself.
c
      ALLOCATE(uesr1(nctmax))
      ALLOCATE(cesr1(nctmax))
      ALLOCATE(ubsr1(nbt1mx))
      ALLOCATE(cbsr1(nbt1mx))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the format ("W" or "D") for the pickup and backup files.
c
      if (iopr(17) .le. 0) then
        upkfor = uinfor
      elseif (iopr(17) .eq. 1) then
        upkfor = 'W'
      elseif (iopr(17) .ge. 2) then
        upkfor = 'D'
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the EQ6 calculational mode flag (.true. in EQ6).
c
      q6mode = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set counters for warnings of problems associated with pressure
c     corrections.
c
c       nwndpc = number of warnings of no data to support pressure
c                  corrections
c       nweope = number of warnings of excursions outside the
c                  recommended pressure envelope
c
      nwndpc = 0
      nweope = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set counter for the number of points of reaction progress at
c     which warnings are issued regarding fugacities not being fixed at
c     specified values.
c
      nwnffg = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set counters which control the writing of warnings that little
c     solvent water remains in the equilibrium system.
c
      iwdh2o = 0
      nwdh2o = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set some constants that depend on the molecular weight of
c     water.
c
      omega = 1000./mwtsp(narn1)
      omeglg = log10(omega)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize a value for the density of the aqueous solution.
c
      qrho = .false.
      rho = 0.0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the jflgi array so it contains the jflag values for
c     the basis species.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jflgi(nb) = jflag(ns)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the cdrw array. This provides a fast way to get the
c     reaction coefficient of H2O (Aqueous solution) in any reaction.
c
      call gcdrw(cdrs,cdrw,narn1,ndrs,ndrsmx,ndrsr,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the cdrtw array. This contains a stoichiometric sum of the
c     number of times H2O (Aqueous solution) is implied as a solvent
c     in any reaction.
c
      call gcdrtw(cdrs,cdrtw,narn1,narn2,ndrs,ndrsmx,ndrsr,
     $ nelect,no2gaq,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize concentration, activity coefficient, activity, etc.,
c     arrays.
c
      do ns = 1,nstmax
        acflg(ns) = 0.
        acflgo(ns) = 0.
        act(ns) = 0.
        conc(ns) = 0.
        mosp(ns) = 0.
        xbar(ns) = 0.
        affs(ns) = 0.
      enddo
c
      av = -99999.
      call initav(actlg,nstmax,av)
      call initav(conclg,nstmax,av)
      call initav(xbarlg,nstmax,av)
      call initav(loph,nptmax,av)
c
      nmax = nptmax
      call initaz(moph,nmax)
      call initaz(affp,nmax)
c
      nmax = nbtmax
      call initaz(amtb,nmax)
c
      nmax = 2*npetmx
      call initiz(ncmpe,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize (null) some other arrays.
c
      do ne = 1,netmax
        egexpa(ne) = 0.
        egexpc(ne) = 0.
      enddo
c
      nmax = jetmax*netmax
      call initaz(egexjc,nmax)
c
      nmax = ietmax*jetmax*netmax
      call initaz(egexs,nmax)
c
      nmax = ketmax*netmax
      call initaz(egexw,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the mole fractions and activities of pure solids and
c     liquids.
c
      do ns = nlrn1,nlrn2
        act(ns) = 1.
        actlg(ns) = 0.
        xbar(ns) = 1.
        xbarlg(ns) = 0.
      enddo
c
      do ns = nmrn1,nmrn2
        act(ns) = 1.
        actlg(ns) = 0.
        xbar(ns) = 1.
        xbarlg(ns) = 0.
      enddo
c
      do ns = nfrn1,nfrn2
        act(ns) = 1.
        actlg(ns) = 0.
        xbar(ns) = 1.
        xbarlg(ns) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the flag array which marks if compositions are known
c     which maximize the affinities of the phases. Here assume that
c     this is the case for all phases except solid solutions.
c
      do np = 1,npt
        qxknph(np) = .true.
      enddo
      do np = ixrn1,ixrn2
        qxknph(np) = .false.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Initialize the numbers of moles of exchanger phases in the
c       moph and loph arrays.
c
        do nb = 1,nbt
          ns = nbaspd(nb)
          if (ns.ge.nern1 .and. ns.le.nern2) then
            np = nphasx(ns)
            mx = mtb(nb)
            lx = tlg(mx)
            moph(np) = mx
            loph(np) = lx
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the jjsort, jssort, jcsort, and jgsort arrays by
c     setting each element equal to its index.
c
      call initii(jcsort,nst)
      call initii(jjsort,nst)
      call initii(jssort,nst)
      call initii(jgsort,ngt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Expand the system description from the data read from the input
c     file. This includes estimating the numbers of moles of all phases
c     and species present, the concentrations, activity coefficients,
c     and activities of all the species, the ionic strength, and the
c     sum of the molalities of all aqueous aqueous solute species.
c
      call exivar(abar,acflg,acflgo,act,actlg,actwlc,adh,
     $ adhh,adhv,al10,aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,
     $ bdoth,bdotv,cco2,cdrs,cegexs,cgexj,conc,conclg,cpgexs,
     $ egexjc,egexjf,egexs,eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,
     $ fugalg,fxi,fxio,ielam,iern1,iern2,ietmax,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,
     $ iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,
     $ ilrn2,ilzeta,imrn1,imrn2,insgf,iodb,iopg,ipbtmx,istack,
     $ ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jetmax,jflag,jgext,
     $ jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jssort,jstack,
     $ kbt,kdim,kelect,kmax,km1,ko2gaq,kwater,kxt,loph,losp,
     $ lsort,mgext,moph,mosp,mrgexs,mtb,napmax,narn1,narn2,natmax,
     $ nazmmx,nazpmx,nbasp,nbaspd,nbt,nbtmax,nchlor,ncmpr,ndrs,
     $ ndrsmx,ndrsr,nelect,nern1,nern2,net,netmax,ngexsa,ngext,
     $ ngrn1,ngrn2,ngt,ngtmax,nhydr,nmutmx,nmxmax,nodbmx,nopgmx,
     $ noutpt,no2gaq,nphasx,npt,nptmax,nsltmx,nst,nstmax,nsxmax,
     $ nttyo,omega,omeglg,press,qhawep,qpit75,q6mode,sigmam,sigmmo,
     $ tempk,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,xlks,zchar,zchcu6,zchsq2,zgexj,zvclg1,zvec1)
c
c     Set the composition known flag for solid solutions present
c     in the ES.
c
      do np = ixrn1,ixrn2
        if (moph(np) .gt. 0.) qxknph(np) = .true.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up to make the initial equilibrium calculation.
c
c       kord   = the largest possible order on a given step
c       kstep  = step counter
c       nord   = the actual order used
c       npts   = the number of points available; restricts the
c                  value of kord
c
      kstep = 0
      kord = 0
      nord = 0
      npts = 1
      ncorr = 0
c
      km10 = km1
      kmt0 = kmt
      kx10 = kx1
      kxt0 = kxt
      kdim0 = kdim
c
      call copyia(iindx1,iindx0,kmax)
      call copyia(ipndx1,ipndx0,kmax)
      call copyca(uzvec1,uzvec0,kmax)
      call copyaa(zvclg1,zvclg0,kmax)
      call copyaa(zvec1,zvec0,kmax)
c
      qstart = .true.
      nordsv = 0
c
      xim1 = xistrt
      xi0 = xistrt
      xi1 = xistrt
      xistsv = xistrt
c
      xidump = 0.
c
      qriinf = .false.
c
      time0 = tistrt
      time1 = tistrt
      tistsv = tistrt
c
      delxi = 0.
      deltim = 0.
c
      rirec0 = 0.
      rirec1 = 0.
c
      do n = 1,nrctmx
        afrc0(n) = 0.
        afrc1(n) = 0.
        rreac0(n) = 0.
        rreac1(n) = 0.
        rrelr0(n) = 0.
        rrelr1(n) = 0.
      enddo
c
      call copyia(jreac,jreac0,nrctmx)
      call copyaa(morr,morr0,nrctmx)
      call copyaa(modr,modr0,nrctmx)
      call copyaa(mtb,mtb0,nbtmax)
      call copyaa(sfcar,sfcar0,nrctmx)
c
      call initaz(xirct,nrctmx)
      call initaz(xirct0,nrctmx)
c
      iexrt = 0
      jexrt = 0
      jscat = 0
      jscrt = 0
c
      betamx = 0.
      ubacmx = 'None'
      ubgamx = 'None'
c
      avkdim = real(kdim)
      prminf = 1./prcinf
      screwd = sscrew(5)
c
      tolsar = 1.e-8
      tolsrr = 1.e-8
c
      tiprnt = prcinf
      tiprnl = prcinf
      tiplot = prcinf
      tiplol = prcinf
c
      qbye = .false.
      qconst = .false.
      qdump = .false.
      qftpr2 = .false.
      qmod = .false.
      qrapch = .false.
      qriinf = .false.
      qtvchk = .false.
      qtrch = .false.
      qzprnt = .false.
      qstopx = .false.
      qshoot = .false.
      qvlsow = .false.
      qvhfxi = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero various arrays pertaining to finite differences and
c     equivalent derivatives.
c
      do n = 1,nrd1mx
        dxsm00(n) = 0.
        dxsm10(n) = 0.
        dxsm11(n) = 0.
        fdrim1(n) = 0.
        fdri0(n) = 0.
        fdri1(n) = 0.
        drir0(n) = 0.
        drir0s(n) = 0.
      enddo
c
      nmax = nrd1mx*kmax
      call initaz(fdzv0,nmax)
      call initaz(fdzvm1,nmax)
      call initaz(dzvc0,nmax)
      call initaz(dzvc0s,nmax)
c
      do n = 1,nordmx
        fdawm1(n) = 0.
        fdaw0(n) = 0.
        daw0(n) = 0.
        fdehm1(n) = 0.
        fdeh0(n) = 0.
        deh0(n) = 0.
        fdo2m1(n) = 0.
        fdo20(n) = 0.
        do20(n) = 0.
        fdphm1(n) = 0.
        fdph0(n) = 0.
        dph0(n) = 0.
      enddo
c
      nmax = nordmx*nptmax
      call initaz(fdaf0,nmax)
      call initaz(fdafm1,nmax)
      call initaz(daffp0,nmax)
c
      nmax = nordmx*npetmx
      call initaz(fdpe0,nmax)
      call initaz(fdpem1,nmax)
      call initaz(demop0,nmax)
c
      nmax = 2*npetmx
      call initiz(ncmpe0,nmax)
c
      nmax = nordmx*nsetmx
      call initaz(fdse0,nmax)
      call initaz(fdsem1,nmax)
      call initaz(demos0,nmax)
c
      nmax = nordmx*nrctmx
      call initaz(fdarm1,nmax)
      call initaz(fdar0,nmax)
      call initaz(dafrc0,nmax)
      call initaz(fdrem1,nmax)
      call initaz(fdre0,nmax)
      call initaz(fdre1,nmax)
c
      nmax = nrd1mx*nrctmx
      call initaz(fdrrm1,nmax)
      call initaz(fdrr0,nmax)
      call initaz(fdrr1,nmax)
      call initaz(drer0,nmax)
      call initaz(drer0s,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the ixbasp and cjbasp arrays. The former is a flag
c     array, each member of which denotes whether the
c     thermodynamic activity of the corresponding basis species
c     is defined in terms of molality (= 0) or mole fraction (= 1).
c     The cjbasp array contains any site stoichiometric factors
c     associated with the operational basis species.
c
      call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $ jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $ netmax,nphasx,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the equilibrium calculation at the initial point of reaction
c     progress.
c
      call eqshel(aadh,aadhh,aadhv,aamatr,aaphi,abar,abdh,
     $ abdhh,abdhv,abdot,abdoth,abdotv,acflg,acflgo,act,actlg,
     $ adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,adh,adhh,adhv,
     $ afcnst,affp,affs,alpha,al10,amtb,aphi,apx,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,betao,bgamx,bneg,bpx,cbsr,cco2,cdac,cegexs,
     $ cesr,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,conc,
     $ conclg,cpgexs,cscale,csigma,csts,dadhh,dadhv,dbdhh,dbdhv,
     $ dbdth,dbdtv,deltim,delvco,delvec,delxi,dlogxw,dlxmin,
     $ drer0,drir0,dzvc0,d1zvc1,eact,egers,egexjc,egexjf,egexs,
     $ eh,ehfac,elecsr,eps100,farad,fje,fjeo,fkrc,fo2,fo2lg,
     $ fsort,fugac,fugalg,fxi,fxio,gmmatr,hact,iact,iapxt,ibpxt,
     $ ibswx,ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $ ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx0,iindx1,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,
     $ ilzeta,imech,imrn1,imrn2,insgf,iodb,iopg,iopt,ipch,
     $ ipivot,ipndx1,ipcv,istack,iter,itermx,ixbasp,ixrn1,ixrn2,
     $ izmax,jcode,jcsort,jflag,jgsort,jgstak,jjsort,jpflag,
     $ jpress,jptffl,jreac,jsflag,jsitex,jsol,jssort,jstack,
     $ jtemp,kbt,kction,kdim,kelect,khydr,khydx,km10,km1,kmt,
     $ kmt0,ko2gaq,kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt,kxt0,
     $ loph,losp,lsort,modr,modr0,moph,morr,morr0,mosp,mrgers,
     $ mrgexs,mtb,mtbaq,mtb0,mte,mteaq,mwtrc,narn1,narn2,narxt,
     $ nat,nbasp,nbaspd,nbaspx,nbt,nbtd,nbw,nchlor,ncmpr,ncorr,
     $ nct,ndac,ndact,ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,ndrsrx,nelect,
     $ nern1,nern2,ness,nessr,net,nfrn1,nfrn2,ngrn1,ngrn2,ngt,
     $ nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmt,nord,noutpt,
     $ no2gaq,npchk,nphasx,npslmx,npt,nrct,nrdxsp,nrk,nrndex,nsk,
     $ nsslmx,nst,nsts,nstsr,ntpr,ntrymx,ntprt,nttyo,nxridx,nxrn1,
     $ nxrn2,nxt,nweope,nwndpc,omega,omeglg,prcinf,press,pressb,
     $ pressd,ptk,qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,
     $ qoptmz,qpit75,qredox,qriinf,qscon,qshoot,qstart,qtrch,qtvchk,
     $ qxknph,q6mode,rcnstv,rconst,rkb,rhsvec,rirec0,rk,rreacn,
     $ rreac1,rrelr0,rrelr1,rtcnst,rxbar,screwd,sidrph,sidrsp,
     $ sigmam,sigmmo,smp100,tdays,tempc,tempcb,tempcd,tempcu,
     $ tempc0,tempk,timemx,time0,time1,tiplol,tiplot,tiprnl,tiprnt,
     $ tistsv,tolbt,toldl,tolsat,tolsst,tolxst,trkb,ttk,ubacmx,
     $ ubgamx,udac,ufixf,ugermo,ulbeta,uldel,uphase,ureac,uspec,
     $ uzvec0,uzvec1,vreac,weight,wfac,wodr,worr,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xgers,xirct,xirct0,xistsv,xi0,
     $ xi1,zchar,zchcu6,zchsq2,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     Note on ier codes returned by EQ6/eqshel.f:
c
c       =    0  Okay
c       =   10  Go back and take a smaller step size to avoid exceeding
c                 the supersaturation tolerance (tolsst)
c       =  170  Too much of a phase was destroyed under the flow-through
c                 open system model; go back and first move part of the
c                 mass of protected phases in the ES to the PRS
c       =  180  One of a number of problems occurred which may be
c                 resolvable, at least partially, by going back and
c                 cutting the step size
c       =  190  Need to slide over a region of computational
c                 instability, but sliding is inhibited; go back, but
c                 terminate work on the current problem
c
c     Note: EQ6/eqshel.f can't return ier = 10 or 170 when called at
c     the initial point of reaction progress.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 180) then
c
c       Normally this error code results in a reduction in the step
c       size. This can't be done at the initial point of reaction
c       progress.
c
        write (noutpt,1010)
        write (nttyo,1010)
 1010   format(/' * Error- (EQ6/path) The equilibrium calculation',
     $  ' failed at the initial value',/7x,'of reaction progress.',
     $   " Can't cut the step size to try to recover.",/7x,'See',
     $   ' previous notes and warnings for more information.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .gt. 0) then
c
c       Here ier should have a value of 190.
c
        write (noutpt,1020)
        write (nttyo,1020)
 1020   format(/' * Error - (EQ6/path) The equilibrium calculation',
     $  ' failed at the initial value',/7x,'of reaction progress.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the activity of water.
c
      actwlg = actlg(narn1)
      actw = texp(actwlg)
      awstrt = actw
      aw0 = actw
      aw1 = actw
c
c     Get the weights (masses) of solvent, total dissolved solutes,
c     and aqueous solution, and get the aqeuous solution density.
c
      call gwdenp(adwipp,bdwipp,jcsort,mlmrra,mosp,mrmlra,
     $ mwtsp,narn1,narn2,nstmax,qdwipp,rhoc,rhowc,tdsgks,tdsglw,
     $ tdspkc,tdsplc,tempc,vosol,wfh2o,wftds,wkgwi,woh2o,
     $ wosol,wotds)
c
      if (qdwipp) then
        qrho = .true.
        rho = rhoc
      else
        qrho = .false.
        rho = 0.0
      endif
c
c     Compute pH, Eh, and pe-, all with reference to appropriate
c     pH scales. Also compute the pHCl.
c
      call gpheh(acflg,actlg,actwlg,adh,ah,ahmes,ahnbs,conc,
     $ eh,ehfac,ehmes,ehnbs,farad,fo2lg,fxi,iopg,mrmlra,nchlor,nhydr,
     $ nopgmx,noutpt,nstmax,nttyo,pch,pe,pemes,penbs,ph,phcl,phmes,
     $ phnbs,qphcl,qredox,qrho,xlke)
c
      wkgh2o = 1.e-3*woh2o
      wkgsol = 1.e-3*wosol
      wwstrt = wkgh2o
      phstrt = ph
      ph0 = ph
      ph1 = ph
      ehstrt = eh
      eh0 = eh
      eh1 = eh
      o2strt = fo2lg
      fo2lg0 = fo2lg
      fo2lg1 = fo2lg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do automatic basis switching. Optimize the basis set so that
c     the basis species for each mass balance tends to be the species
c     which dominates that mass balance.
c
      kstpab = 0
      if (iopt(12) .gt. 0) then
        call absswb(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $  axhfsx,axlks,axlksx,axvfs,axvfsx,cdrs,cdrtw,cdrsx,cdrw,
     $  csts,dhfs,dvfs,eps100,ibswx,iindx1,iodb,ipch,ipchmx,ipcv,
     $  ipcvmx,jcsort,jflag,jsflag,kbt,kmax,mosp,mtb,narn1,narn2,
     $  narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,
     $  ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,noutpt,nst,
     $  nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,presg,
     $  press,qbassw,qbswx,tempc,uspec,uzvec1,weight,xhfs,xvfs,xlks)
c
        if (nswtch .gt. 0) then
c
c         It is not necessary here to set the qabswx flag, which
c         indicate that automatic basis switching has just been done.
c
          write (noutpt,1030) nswtch
 1030     format(/' ',i2,' basis switches were executed automatically',
     $    ' after solving',/'at the initial value of reaction',
     $    ' progress.')
c
c         Reset the ixbasp and cjbasp arrays. The former is a flag
c         array, each member of which denotes whether the
c         thermodynamic activity of the corresponding basis species
c         is defined in terms of molality (= 0) or mole fraction (= 1).
c         The cjbasp array contains any site stoichiometric factors
c         associated with the operational basis species.
c
          call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $    jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $    netmax,nphasx,nstmax)
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1100) kstep,iter
 1100 format(' Steps completed= ',i5,', iter= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save some data at the initial point, as it is after the
c     calculations at this point are complete. Note that the set of
c     matrix variables may have been changed due to mineral
c     precipitation, etc.
c
      call copyia(iindx1,iindx0,kdim)
      call copyia(ipndx1,ipndx0,kdim)
c
      km10 = km1
      kmt0 = kmt
      kx10 = kx1
      kxt0 = kxt
      kdim0 = kdim
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check gases for which the fugacity is supposed to be fixed.
c
      do n = 1,nffg
        ng = jffg(n)
        xlf = xlkffg(n)
        xf = texp(xlf)
        dx = fugalg(ng) - xlkffg(n)
        if (abs(dx) .gt. toldl) then
          j2 = ilnobl(uffg(n))
          write (noutpt,1150) uffg(n)(1:j2),fugac(ng),xf
          write (nttyo,1150) uffg(n)(1:j2),fugac(ng),xf
 1150     format(/' * Warning - (EQ6/eq6) The fugacity of ',a,' is',
     $    /7x,1pg12.5,' bars at the start of the run. It is supposed',
     $    /7x,'to be fixed at ',e12.5,' bars. There is an insufficient',
     $    /7x,'mass of the gas component present in the system to',
     $    /7x,'"saturate" it at the desired fugacity. You may wish to',
     $    /7x,'restart this run, adding such mass using the moffg',
     $    /7x,'parameter on the input file. Add only about 0.5 to 1.0',
     $    /7x,'mole at a time.')
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .gt. 0) then
c
c       Calculate the initial affinities and rates of the irreversible
c       reactions.
c
        call raff(acflg,actlg,afcnst,affp,afrc1,bpx,cdrs,cgexj,
     $  ibpxmx,ibpxt,iern1,ietmax,iktmax,ixrn1,ixrn2,jcode,jern1,jern2,
     $  jetmax,jflag,jgext,jpflag,jsflag,jsol,ncmpr,ndrs,ndrsmx,ndrsr,
     $  nertmx,net,netmax,ngext,noutpt,nptmax,nrct,nrctmx,nrndex,
     $  nstmax,nttyo,nxridx,nxrtmx,nxtmax,rxbar,uphase,uspec,wfac,
     $  xbar,xbarlg,xgers,xlks)
c
c       For each reactant, check the status flag against the affinity
c       and the number of moles present to ensure that any reactant
c       tagged as available to react, having an affinity favoring
c       dissolution, and having no moles remaining is retagged as
c       exhausted.
c
        do nrc = 1,nrct
          if (afrc1(nrc) .gt. -tolsar) then
            if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
              if (morr(nrc) .le. 0.) then
c
c               The following exception is intended to facilitate the
c               simulation of evaporation by declaring H2O as a
c               reactant with a negative relative rate and no initial
c               moles remaining. However, any reactant may be treated
c               analogously if desired.
c
                if (.not.(nrk(1,nrc).eq.1 .and. rk(1,1,nrc).lt.0.)) then
                  jreac(nrc) = 1
                endif
              endif
            endif
          endif
        enddo
c
c       Check the reactants for saturation.
c
        call rsatch(csts,egers,egexs,iern1,ietmax,iindx1,iktmax,
     $  iopt,ipndx1,jcode,jern1,jern2,jetmax,jgext,jpflag,jreac,kmax,
     $  km1,kmt,kx1,kxt,loph,losp,moph,morr,mosp,mrgers,mtb,mtb0,
     $  nbaspd,nbtmax,ncmpr,nern1,nern2,nert,nertmx,netmax,ngext,
     $  noptmx,noutpt,nptmax,nrct,nrctmx,nrk,nrndex,nstmax,nsts,nstsmx,
     $  nstsr,nttyo,nxridx,nxrt,nxrtmx,qreq,rxbar,tolxsf,uphase,ureac,
     $  uspec,xbar,xbarlg,zvclg1,zvec1)
c
c       Calculate rates at the initial point by evaluating the
c       rate laws.
c
        call rtcalc(act,afrc1,cdac,csigma,eps100,fkrc,idirec,
     $  imchmx,imech,iodb,iopt,jcode,jreac,morr,morr0,mwtrc,ndac,
     $  ndact,ndctmx,nodbmx,noptmx,nord,noutpt,nrk,nrct,nrctmx,nsk,
     $  nstmax,nttyo,prcinf,prminf,qriinf,rirec1,rk,rreac1,rrelr1,
     $  rtcnst,rrxfi1,sfcar,sfcar0,ssfcar,udac,ureac)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the total affinity (aft1).
c
      call caft1(afrc1,aft1,nrct,nrctmx,rrelr1)
      aft0 = aft1
      aftm1 = aft1
      qaft1 = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute apparent "whole-phase" equivalent fractions and mole
c     fractions of the exchange ions present in generic ion exchanger
c     phases. Cations and anions are treated separately in these
c     calculations.
c
      call gegexw(cegexs,egexpc,egexpa,egexw,iern1,iern2,
     $ ietmax,jern1,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $ mosp,netmax,ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,
     $ xgexw,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize arrays associated with finite-difference description
c     of the number of mole of phases and species in the Equilibrium
c     System (ES). Here the iemop and emop arrays respectively contain
c     the indices and numbers of moles of phases in the ES. The iemos
c     and emos array are the analogs for the species of these phases
c     (but for the aqueous solution phase, only the species H2O(l)
c     is tracked by this mechanism). The ncmpe array is a species range
c     pointer array for the phases, analogous to ncmpr. The fdpe0 and
c     fdse0 arrays contain the finite differences for the phases and
c     species, respectively. The demop and demos arrays contain the
c     corresponding derivatives.
c
c     Initialize the index arrays.
c
      call iiemop(iemop,iemos,iindx1,ipndx1,jsflag,kdim,kmax,
     $ ncmpe,ncmpr,noutpt,npet,npetmx,npt,nptmax,nset,nsetmx,nstmax,
     $ nttyo,uaqsln,uspec,uphase)
c
c     Load the corresponding numbers of moles.
c
      do npe = 1,npet
        np = iemop(npe)
        emop(npe) = moph(np)
        nr1 = ncmpe(1,npe)
        nr2 = ncmpe(2,npe)
        do nse = nr1,nr2
          ns = iemos(nse)
          emos(nse) = mosp(ns)
        enddo
      enddo
c
      npet0 = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate various secondary data at the initial point.
c
      call cdappl(acflg,acfw,acfwlg,actlg,actw,actwlg,adwipp,
     $ afcnst,affpd,affsd,ah,ahrc,alk,alk1,alk2,alki,atwt,bdwipp,
     $ cdrsd,cess,conc,csts,ctb,cteaq,dvoso,dwoso,eh,ehfac,ehrc,
     $ eps100,farad,fdpe0,fdse0,fjest,fo2lg,fo2lrc,fxist,iaqsln,
     $ iemop0,iemos0,iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,
     $ imrn2,iopt,ixrn1,ixrn2,jcode,jcsort,jern1,jflag,jflagd,
     $ jgext,jpflag,jsflag,jssort,modr,moph,mophg,mophj,mopht,morr,
     $ mosp,mospg,mospj,mospt,mprph,mprsp,mrgers,mrmlra,mtb,
     $ mtbaq,mte,mteaq,mwtges,mwtrc,mwtsp,narn1,narn2,nat,nbasp,
     $ nbaspd,nbt,nchlor,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,
     $ nern1,nern2,nert,ness,nessr,net,nfrn1,nfrn2,ngext,ngrn1,
     $ ngrn2,ngt,nhydr,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,no2gaq,
     $ npchk,npet,npet0,npt,npts,nrct,nrndex,nst,nsts,nstsr,ntf1,
     $ ntf1t,ntf2,ntf2t,nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,
     $ omega,pe,perc,ph,phmes,ppmwb,ppmwe,qriinf,qxknph,rreacn,
     $ rreac1,rxbar,sfcar,sidrsp,sidrph,sigmam,sigmst,tdays,tempc,
     $ tf1,tf2,thours,time1,tmins,tyears,uphase,uspec,vodrt,voph,
     $ vophg,vophj,vopht,vosoct,vosp,vospg,vospj,vospt,vosp0,
     $ vreac,wfh2o,wkgwi,wodr,wodrt,woph,wophg,wophj,wopht,
     $ worr,worrt,wosoct,wosp,wospg,wospj,wospt,xbar,xlke,
     $ xlksd,zchcu6,zchsq2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print results at the initial point.
c
      call scripz(abar,acflg,acfw,acfwlg,actlg,actw,actwlg,
     $ affpd,affsd,afrc1,aft1,ah,ahmes,ahnbs,ahrc,alki,alk1,
     $ alk2,awmax,awmin,a3bar,cbsr,cdrsd,cegexs,cesr,conc,conclg,csts,
     $ ctb,cteaq,dvoso,dwoso,egers,egexjc,egexjf,egexpa,egexpc,egexs,
     $ egexw,eh,ehmax,ehmes,ehmin,ehnbs,ehrc,elecsr,electr,fje,fjest,
     $ fo2,fo2lg,fo2lrc,fugac,fugalg,fxi,fxist,iaqsln,iemop,iemop0,
     $ iemos,iemos0,iern1,iern2,iexr,iexrt,ifrn1,ifrn2,ilrn1,ilrn2,
     $ imech,imrn1,imrn2,iopg,iopr,iopt,ipndx1,ixrn1,ixrn2,jcode,jcsort,
     $ jern1,jern2,jexr,jexrt,jflag,jflagd,jflgi,jgext,jgsort,jpflag,
     $ jreac,jsca,jscat,jscr,jscrt,jsflag,jsol,jssort,kbt,kern1,kern2,
     $ kgexsa,km1,kmt,kx1,kxt,kstep,kstpmx,loph,losp,mlmrra,modr,
     $ moph,mophg,mophj,mopht,morr,mosp,mospg,mospj,mospt,mprph,
     $ mprsp,mrgers,mrmlra,mwtrc,mwtsp,narn1,narn2,nat,nbasp,nbaspd,
     $ nbt,ncmpe,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,nern1,nern2,
     $ nert,net,nfrn1,nfrn2,ngext,ngexsa,ngrn1,ngrn2,ngt,nhydr,nhydx,
     $ nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,noutpt,no2gaq,npet,npet0,
     $ npt,npts,nrct,nrdxsp,nrk,nrndex,nst,nsts,nstsr,ntf1t,ntf2t,
     $ nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,omega,o2max,o2min,pch,pe,
     $ pemes,penbs,perc,ph,phcl,phmax,phmes,phmin,phnbs,ppmwe,presg,
     $ press,qaft1,qftpr2,qmod,qphcl,qredox,qrho,qriinf,qstopx,qvhfxi,
     $ qvlsow,qzprnt,rho,rhoc,rhowc,rk,rreacn,rreac1,rrelr1,rxbar,
     $ sfcar,sidrph,sidrsp,sigmst,sigmam,ssfcar,tdays,tdsglw,tdspkc,
     $ tdsplc,tempc,thours,time1,timemx,tmins,tolsat,tolxsf,tolxst,
     $ tolxsu,tyears,uelem,ugermo,ugexj,ugexmo,uphase,ureac,uspec,
     $ uxtype,vodrt,voph,vophg,vophj,vopht,vosoct,vosol,vosp,vospg,
     $ vospj,vospt,vreac,wfh2o,wftds,wkgwi,woh2o,wodr,wodrt,woph,
     $ wophg,wophj,wopht,worr,worrt,wosoct,wosol,wosp,wospg,wospj,
     $ wospt,wotds,xbar,xbarlg,xbarw,xbrwlg,xgers,xgexw,xi1,xidump,
     $ ximax,xistsv,xirct,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write results at the initial point on the tabx file. This file
c     is used to create the plot file tab.
c
      if (iopt(18) .ge. 0) then
        if (qtatxt) then
c
c         The TAB file is an ordinary text file.
c
          call wrtabx(actlg,afrc1,aft1,alk,cteaq,dvoso,dwoso,
     $    eh,fo2lg,iindx1,iktmax,iopt,ipndx1,kmax,km1,kmt,kstep,kx1,
     $    kxt,loph,ncmpr,modr,mopht,narn1,mosp,nct,nctmax,noptmx,
     $    nptmax,nrct,nrctmx,nstmax,ntabx,ntidmx,ntitl2,ntitld,ntitmx,
     $    nxtmax,pe,ph,ppmwe,prcinf,press,prminf,qbye,qmod,qriinf,
     $    tempc,time1,uelem,uphase,uplatm,ureac,uspec,usteq6,utitl2,
     $    utitld,uveeq6,vodrt,vosoct,wodrt,woh2o,wosoct,xbar,xi1)
        else
c
c         The TAB file is a .csv file.
c
          call wrtabc(acflg,actlg,actw,afrc1,aft1,alk,conclg,
     $    cteaq,ctb,dvoso,dwoso,eh,fje,fo2lg,fugac,fxi,iktmax,iopt,
     $    jflag,jsflag,kmax,kstep,kx1,kxt,mrmlra,modr,mosp,mospt,
     $    moph,mopht,narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ncmpr,nct,
     $    nctmax,nelect,ngrn1,ngrn2,ngtmax,nhydr,nhydx,nllnmx,
     $    no2gaq,noptmx,noutpt,npt,nptmax,nrct,nrctmx,nstmax,ntabx,
     $    ntidmx,ntitl2,ntitld,ntitmx,nttyo,nxrn1,nxrn2,nxtmax,pe,ph,
     $    phmes,ppmwb,ppmwe,prcinf,press,prminf,qrho,qriinf,rho,rhowc,
     $    sidrph,sigmam,tdsgks,tdsglw,tempc,time1,uelem,ulinex,
     $    uphase,uplatm,ureac,uspec,usteq6,utitl2,utitld,uveeq6,
     $    vodrt,vosoct,wkgh2o,wodrt,wosoct,xbar,xbarlg,xi1)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (nttyo,1200)
 1200 format(1x)
c
c     Write entertainment for the user, showing the progress
c     of the current run.
c
      call wrentu(actw,eh,fo2lg,iopg,iopt,kstep,nopgmx,noptmx,
     $ nttyo,ph,qredox,time1,xi1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(6) .gt. 0) then
c
c       Clear ES solids at the starting point. Fictive fugacity-fixing
c       minerals are not cleared.
c
        write (noutpt,1230)
        write (nttyo,1230)
 1230   format(/' * Note (EQ6/path) Clearing solid phases from the',
     $  ' equilibrium system (ES)',/7x,'at the starting point of',
     $  ' reaction progress.')
c
        call clress(csts,iindx1,ipndx1,jpflag,jsflag,kdim,kmax,
     $  km1,kmt,kx1,kxt,loph,losp,moph,mosp,mtb,mtbaq,nbt,nbtmax,
     $  nptmax,nstmax,nsts,nstsmx,nstsr,ufixf,uzvec1,zvec1,zvclg1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that there is something to define a reaction path
c     (reactants, changing temperature, changing pressure).
c
      if (nrct.le.0 .and. qcntmp .and. qcnpre) then
        write (noutpt,1250)
        write (nttyo,1250)
 1250   format(/' * Note - (EQ6/path) No reaction path has been',
     $  ' defined by on the input file.',/7x,'There are no specified',
     $  ' reactants (irreversible reactions), and',/7x,'the',
     $  ' temperature and pressure are fixed. No steps will be taken.')
        go to 990
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check stop conditions.
c
      call chkstc(actw,awmax,awmin,eh,ehmax,ehmin,fo2lg,iopt,
     $ jreac,kstep,kstpmx,noptmx,noutpt,nrct,nrctmx,nttyo,o2max,o2min,
     $ ph,phmax,phmin,prcinf,qaft1,qcnpre,qcntmp,qconst,qredox,qstop,
     $ qvhfxi,qvlsow,timemx,time1,tolxst,tolxsu,ximax,xi1)
c
      if (qstop) go to 990
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nbkupn = nbkupa
c
      if (iopt(16) .ge. 0) then
c
c       Prepare to write results at the initial point to the
c       backup file.
c
        call setpk6(actwlg,awmax,awmaxi,awmin,awmini,eh,ehmax,
     $  ehmaxi,ehmin,ehmini,fo2lg,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $  kprs,mprph,mprphi,mprsp,mprspi,mtb,mtbi,mtbaq,mtbaqi,nbasp,
     $  nbaspd,nbaspi,nbti,nbtmax,ncmpr,nobswt,noutpt,nprpmx,nprpti,
     $  nprsmx,nprsti,npt,nptmax,nttyo,nstmax,o2max,o2maxi,o2min,
     $  o2mini,ph,phmax,phmaxi,phmin,phmini,prcinf,press,pressi,
     $  tempc,tempci,time1,timemx,timmxi,tistti,ubmtbi,uobsw,uphase,
     $  uprphi,uprspi,uspec,uzveci,uzvec1,xi1,ximax,ximaxi,xistti,
     $  zvclgi,zvclg1)
c
c       Rewind the current backup file (BAKUPA or BAKUPB).
c
        rewind (nbkupn)
c
c       Write results at the initial point to the backup file.
c
        if (upkfor(1:1) .eq. 'W') then
c
c         Compact (W) format.
c
c         Calling sequence substitutions:
c           nbkupn for newin
c
          call wr6pkw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,nbkupn,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        else
c
c         Menu-style (D) format.
c
c         Calling sequence substitutions:
c           nbkupn for newin
c
          call wr6pkd(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,nbkupn,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        endif
c
        if (iopt(16) .eq. 0) then
c
c         Switch to write on the other backup file the next time.
c
          nbkupn = nbkupb
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize logical flags used in computing the reaction path.
c
c       qzdump = .true. if the last value of Xi was a point
c                  corresponding to the PRS transfer interval.
c       qdump  = .true. if a PRS transfer has just taken place.
c
      qzdump = .false.
      qzplot = .false.
      qskip = .false.
      qreq = .false.
      qreax = .false.
      qrpcfl = .false.
      qmod1 = .false.
      qmod2 = .false.
      qdmpr1 = .false.
      qdmpr2 = .false.
c
      qprntx = .false.
      qprntt = .false.
      qprnlx = .false.
      qprnlt = .false.
c
      qplotx = .false.
      qplott = .false.
      qplolx = .false.
      qplolt = .false.
c
      qprph0 = .false.
      qprph1 = .false.
      qpreh0 = .false.
      qpreh1 = .false.
      qpro20 = .false.
      qpro21 = .false.
      qpraw0 = .false.
      qpraw1 = .false.
c
      qplph0 = .false.
      qplph1 = .false.
      qpleh0 = .false.
      qpleh1 = .false.
      qplo20 = .false.
      qplo21 = .false.
      qplaw0 = .false.
      qplaw1 = .false.
c
      qhcon = .false.
      if (iopt(14) .eq. 2) qhcon = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set or initialize other variables used in computing the
c     reaction path.
c
      kstpze = 0
      kstpmn = 0
      lprcin = tlg(prcinf)
c
      dlxtmx = prcinf
      xilim = prcinf
c
      scalim = 1.0
      scnsti = texp(sscrew(6)) - 1.
      scnstd = texp(-sscrew(6)) - 1.
c
      i = irang - 8
      fdx = real(i)
      xx = 100.
      fdx = min(fdx,xx)
      fdlim = texp(fdx)
      if (iodb(1) .ge. 1) then
        write (noutpt,1300) fdlim
        write (nttyo,1300) fdlim
 1300   format(/' * Note - (EQ6/path) The magnitude of the finite',
     $  ' difference functions',/7x,'is bounded by ',1pe10.3,'.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Re-set the arrays associated with finite-difference description
c     of the number of mole of phases and species in the Equilibrium
c     System (ES).
c
c     Re-set the index arrays.
c
      call iiemop(iemop,iemos,iindx1,ipndx1,jsflag,kdim,kmax,
     $ ncmpe,ncmpr,noutpt,npet,npetmx,npt,nptmax,nset,nsetmx,nstmax,
     $ nttyo,uaqsln,uspec,uphase)
c
c     Re-load the corresponding numbers of moles.
c
      do npe = 1,npet
        np = iemop(npe)
        emop(npe) = moph(np)
        nr1 = ncmpe(1,npe)
        nr2 = ncmpe(2,npe)
        do nse = nr1,nr2
          ns = iemos(nse)
          emos(nse) = mosp(ns)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the akmat0 (F * B) and akmat1 (F * C) matrices. Each
c     relates finite differences to the equivalent derivatives in a
c     truncated Taylor's series. The akmat0 matrix is part of the
c     predictor function. the akmat1 matrix is part of the corrector.
c
      nmax = nrd1mx*nrd1mx
      call initaz(akmat0,nmax)
      call initaz(akmat1,nmax)
c
      do i = 1,nrd1mx
        akmat0(i,i) = fctrl(i)
        akmat1(i,i) = fctrl(i)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set remaining step counters and order parameters.
c
c       kordlm = the largest allowed value of kord (largest order
c                  considered for a given step), hence the largest
c                  allowed value of nord (the actual order used
c                  for a given step)
c       ndelay = the number of points that must be done before
c                  allowing the order to build up from zero
c       kly    = a counter used in restricting the growth of
c                   the step size; if it is >= 0, the scale limit
c                   (scalim) is set to a smaller value than it would be
c                   otherwise
c       kstppr = counter of steps since the last print point
c       kstppl = counter of steps since the last plot point
c
      kordlm = nordmx
      if (qecon) kordlm = min(2,nordmx)
      if (qscon) kordlm = 0
c
      ndelay = 1
c
      kstppr = 0
      kstppl = 0
c
      kly = 0
      delxi = dlxmx0
c
      naft1 = 0
      kaft1 = 0
c
      nsawth = 0
      jsawth = 0
      qsawth = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the first print, plot and dump points.
c
      call sippdp(actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,
     $ dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,dlxprl,
     $ dlxprn,eh,eh0plo,eh0prn,eh1plo,eh1prn,eps100,fo2lg,lprcin,
     $ o20plo,o20prn,o21plo,o21prn,ph,ph0plo,ph0prn,ph1plo,ph1prn,
     $ prcinf,qredox,tiplol,tiplot,tiprnl,tiprnt,tistsv,xidump,
     $ xiplol,xiplot,xiprnl,xiprnt,xistsv)
c
       qtplo = dltplo.lt.prcinf .or. dltpll.lt.prcinf
       qtprn = dltprn.lt.prcinf .or. dltprl.lt.prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make a new step in reaction progress.
c
  100 kstep = kstep + 1
      kstppr = kstppr + 1
      kstppl = kstppl + 1
      kstpab = kstpab + 1
      avkdim = (avkdim*kstep + real(kdim))/real(kstep + 1)
c
      kly = kly - 1
      jsawth = jsawth - 1
      qmod2 = qmod1
      qmod1 = qmod .or. qreax
      qrapch = .false.
c
      aftm1 = aft0
      aft0 = aft1
      ncorr = 0
      dlxode = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for instability (sawtoothing) in the ODE integration.
c
      if (iopt(2) .gt. 0) then
        rx0 = fdri0(1)
        rx1 = rirec1 - rirec0
        rxx = rx0*rx1
        if (rxx .lt. 0.) then
          nsawth = nsawth + 1
          if (nsawth .ge. 8) then
c
c           Have sawtoothing. Take special action the next jsawth steps.
c
            jsawth = 20
            write (noutpt,'(" Sawtoothing detected")')
            write (nttyo,'(" Sawtoothing detected")')
          endif
        else
          nsawth = 0
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pick the maximum allowed order for the current step (jordlm).
c
      if (jsawth .le. 0) then
        jordlm = kordlm
      else
        jordlm = min(jordlm,2)
      endif
      jordlm = min(kord,jordlm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save information at the current point of reaction progress
c     and update the finite differences for variables that are
c     tracked using such.
c
      call stepfd(acflg,acflg0,affp0,affp,afrc0,afrc1,aw0,aw1,
     $ delxi,dxsm00,eh0,eh1,emop,emop0,emos,emos0,fdafm1,fdaf0,
     $ fdarm1,fdar0,fdawm1,fdaw0,fdehm1,fdeh0,fdlim,fdo2m1,fdo20,
     $ fdpem1,fdpe0,fdphm1,fdph0,fdrem1,fdre0,fdrim1,fdri0,fdrrm1,
     $ fdrr0,fdsem1,fdse0,fdzvm1,fdzv0,fje,fje0,fo2lg0,fo2lg1,fxi,
     $ fxi0,iemop,iemop0,iemos,iemos0,iindx0,iindx1,iodb,iopt,ipndx0,
     $ ipndx1,jcode,jreac,jreac0,jpflag,kdim,kdim0,kmax,km1,km10,kmt,
     $ kmt0,kord,kx1,kx10,kxt,kxt0,modr,modr0,moph,moph0,morr,morr0,
     $ mosp,mosp0,mtb,mtb0,nbt,nbtmax,ncmpe,ncmpe0,nodbmx,noptmx,
     $ nordmx,noutpt,npet,npetmx,npet0,npt,nptmax,npts,nrct,nrctmx,
     $ nrd1mx,nrndex,nset,nsetmx,nset0,nstmax,ph0,ph1,qredox,rirec0,
     $ rirec1,rreac0,rreac1,rrelr0,rrelr1,sfcar,sfcar0,sigmam,sigmm0,
     $ tempc,tempc0,time0,time1,uzvec0,uzvec1,xi0,xi1,xim1,xirct,
     $ xirct0,zvclg0,zvclg1,zvec0,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1) .eq. 2) then
c
c       Doing the fluid-centered flow-through open system model.
c
        if (qdump) then
c
c         Make a general partial shift of mass of the minerals in
c         the ES to the PRS. This is part of the fluid-centered
c         flow-through open system model. A partial shift of a phase
c         leaves some of its mass in the ES.
c
          call pshfta(csts,emop,emop0,emos,emos0,fdpe0,fdpem1,
     $    fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,imrn1,
     $    imrn2,iodb,ipndx1,ixrn1,ixrn2,jcsort,jern1,jetmax,jgext,
     $    jpflag,jsflag,kbt,km1,kmax,kmt,kx1,kxt,loph,losp,moph,mosp,
     $    mprph,mprsp,mrgexs,mtb,mtb0,nbasp,nbaspd,nbt,nbtmax,ncmpe,
     $    ncmpr,netmax,ngext,nodbmx,nordmx,noutpt,npet,npetmx,npt,
     $    nptmax,nsetmx,nstmax,nsts,nstsmx,nstsr,nttyo,uaqsln,ufixf,
     $    uphase,uspec,xbar,xbarlg,zklgmn,zklogl,zvclg0,zvclg1,
     $    zvec0,zvec1)
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1) .eq. 2) then
c
c       Doing the fluid-centered flow-through open system model.
c
        qbye = .false.
        if (qmod2 .or. kstep.eq.2) then
c
c         On the previous step, a reactant became saturated or
c         exhausted, a new phase was added to the ES, or the previous
c         step was the first step of the run.
c
          if (kmt.ge.km1 .or. kxt.ge.kx1 .or. net.gt.0) then
c
c           Make a total PRS shift of any mineral which is disappearing
c           and purge it from the ES. The flag variable qbye is set
c           to true if any such shift is made here.
c
            call dumpdp(csts,demop0,demos0,emop,emop0,emos,
     $      emos0,fdpe0,fdpem1,fdse0,fdsem1,iemop,iemos,iern1,iern2,
     $      ietmax,iindx0,iindx1,imrn1,imrn2,iodb,ipndx0,ipndx1,ixrn1,
     $      ixrn2,jcsort,jern1,jetmax,jgext,jpflag,jsflag,kbt,kdim,
     $      kdim0,kmax,km1,km10,kmt,kmt0,kord,kstep,kx1,kx10,kxt,
     $      kxt0,loph,losp,moph,mosp,mprph,mprsp,mrgexs,mtb,mtb0,
     $      nbasp,nbaspd,nbt,nbtmax,ncmpe,ncmpr,ndelay,netmax,
     $      ngext,nodbmx,nordmx,noutpt,npet,npetmx,npet0,npt,nptmax,
     $      npts,nset,nsetmx,nset0,nstmax,nsts,nstsmx,nstsr,nttyo,
     $      qbye,uaqsln,ufixf,uspec,uphase,uzvec0,uzvec1,xbar,
     $      xbarlg,zklgmn,zklogl,zvclg0,zvclg1,zvec0,zvec1)
c
c           Note: if such a shift has been made here, the maximum
c           order of the finite-differences (kord) has been set
c           to zero.
c
            qmod2 = .false.
c
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the step size and the order for the next increment. The
c     order may be dropped if it appears that the high-order derivative
c     estimates are not numerically significant. In economy mode, this
c     algorithm is used to choose the order, but another algorithm (see
c     below) is used to choose the step size.
c
  110 if (qzdump) delxi = max(dlxis2,delxi)
c
      qzprnt = .false.
      qprntx = .false.
      qprntt = .false.
      qprnlx= .false.
      qprnlt= .false.
c
      qzplot = .false.
      qplotx = .false.
      qplott = .false.
      qplolx = .false.
      qplolt = .false.
c
      qprph0 = .false.
      qprph1 = .false.
      qpreh0 = .false.
      qpreh1 = .false.
      qpro20 = .false.
      qpro21 = .false.
      qpraw0 = .false.
      qpraw1 = .false.
c
      qplph0 = .false.
      qplph1 = .false.
      qpleh0 = .false.
      qpleh1 = .false.
      qplo20 = .false.
      qplo21 = .false.
      qplaw0 = .false.
      qplaw1 = .false.
c
      qzdump = .false.
      qstabl = .false.
      qsawth = .false.
      if (qskip) go to 120
      if (qshoot) go to 125
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qecon) then
c
c       Choose the step size and order when operating in economy
c       mode.
c
        call chdxec(delxi,dlxmx0,dzvc0,iodb,kdim,kmax,km1,kxt,
     $  nodbmx,nord,noutpt,nrd1mx,qmin,qscon,scale,scalim,scnstd,
     $  scnsti,uzvec1,zvec0)
c
      else
c
c       Choose the step size and order when operating in normal mode.
c       Here control is based on the Gear approach. An order greater
c       than zero is evaluated on the basis of the contributions
c       of terms of one higher order. A hidden order is carried
c       in the finite differences and derivatives of the z and r
c       vectors to facilitate this approach.
c
c       Get choices based on finite differences for the z vector.
c
        call chdxgz(delxi,dlxmx0,fdlim,fdzv0,iodb,iopt,jordlm,
     $  kdim,kmax,km1,kord,kxt,nodbmx,noptmx,nordmx,nordz,noutpt,
     $  nrd1mx,nsscmx,scalim,scfcz,sscrew,qmin,smp100,uzvec1,zklogu,
     $  zvec0,zvclg0)
c
c       Get choices based on finite differences for the r vector.
c
        call chdxgr(delxi,dlxmx0,fdri0,fdrr0,iodb,jordlm,jreac,
     $  kord,nodbmx,nordmx,nordr,noutpt,nrct,nrctmx,nrd1mx,nsscmx,
     $  scalim,scfcr,sscrew,qriinf,rirec0,rrelr0,ureac)
c
        qstabz = .false.
        qstabr = .false.
c
        if (iopt(2).gt.0 .and. qsawth) then
          if (kord .ge. 2) then
c
c           Compute derivatives for the z and r vectors from the
c           corresponding finite differences.
c
            kordp1 = kord + 1
c
c           First compute the matrix (akmat0 = F * B) used to
c           calculate derivatives for truncated Taylor's series,
c           given predictor-based finite differences.
c
c           Calling sequence substitutions:
c             kordp1 for nord
c
            call gakmat(akmat0,dxsm00,kordp1,nrd1mx)
c
c           Now compute the corresponding derivatives.
c
c           Calling sequence substitutions:
c             kordp1 for nord
c
            call zderiv(akmat0,dzvc0,fdzv0,kdim,kmax,kordp1,nrd1mx)
c
c           Calling sequence substitutions:
c             kordp1 for nord
c
            call rderiv(akmat0,drer0,drir0,fdri0,fdrr0,jreac,kordp1,
     $      nrct,nrctmx,nrd1mx)
c
c           Now compute the corresponding average derivatives.
c
            delxia = dxsm00(2)
c
c           Calling sequence substitutions:
c             kordp1 for nord
c
            call gsmdez(delxia,dzvc0,dzvc0s,kdim,kmax,kordp1,nrd1mx)
c
c           Calling sequence substitutions:
c             kordp1 for nord
c
            call gsmder(delxia,drer0,drer0s,drir0,drir0s,jreac,kordp1,
     $      nrct,nrctmx,nrd1mx)
c
c           Choose step sizes and orders.
c
            call chdxtz(delxi,dlxmx0,dzvc0,iodb,iopt,jordlm,kdim,
     $      kmax,km1,kord,kxt,nodbmx,noptmx,nordmx,nordzs,noutpt,
     $      nrd1mx,nsscmx,scalim,scfczs,sscrew,qmin,smp100,uzvec1,
     $      zklogu,zvec0,zvclg0)
c
            call chdxtr(delxi,dlxmx0,drer0,drir0,iodb,jordlm,jreac,
     $      kord,nodbmx,nordmx,nordrs,noutpt,nrct,nrctmx,nrd1mx,
     $      nsscmx,scalim,scfcrs,sscrew,qriinf,rirec0,rrelr0,ureac)
c
c           Resolve regular vs. "stable" results.
c
            if (scfczs .gt. scfcz) then
              scfcz = scfczs
              nordz = nordzs
              qstabz = .true.
            endif
c
            if (scfcrs .gt. scfcr) then
              scfcr = scfcrs
              nordr = nordrs
              qstabr = .true.
            endif
c
          endif
        endif
c
c       Resolve z vector vs. r vector results.
c
        scale = scfcz
        nord = nordz
        qstabl = qstabz
        if (scfcr .lt. scfcz) then
          scale = scfcr
          nord = nordr
          qstabl = qstabr
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate derivatives from finite differences. These are
c     consistent with the actual order to be used (nord).
c
      if (nord .gt. 0) then
c
c       First compute the matrix (akmat0 = F * B) used to calculate
c       derivatives for truncated Taylor's series, given predictor-
c       based finite differences.
c
        call gakmat(akmat0,dxsm00,nord,nrd1mx)
c
c       Now compute the derivatives.
c
        call zderiv(akmat0,dzvc0,fdzv0,kdim,kmax,nord,nrd1mx)
        if (iopt(2) .gt. 0) then
          call rderiv(akmat0,drer0,drir0,fdri0,fdrr0,jreac,nord,
     $    nrct,nrctmx,nrd1mx)
        endif
c
        call aderiv(akmat0,daffp0,fdaf0,nord,nordmx,npt,
     $  nptmax,nrd1mx)
        call bderiv(akmat0,dafrc0,fdar0,jreac,nord,nordmx,nrct,
     $  nrctmx,nrd1mx)
        call pderiv(akmat0,demop0,fdpe0,nord,nordmx,npet,
     $  npetmx,nrd1mx)
        call sderiv(akmat0,demos0,fdse0,nord,nordmx,nrd1mx,
     $  nset,nsetmx)
c
c       Calling sequence substitutions:
c         dph0 for dxx0
c         fdph0 for fdxx0
c
        call xderiv(akmat0,dph0,fdph0,nord,nordmx,nrd1mx)
c
        if (qredox) then
c
c         Calling sequence substitutions:
c           deh0 for dxx0
c           fdeh0 for fdxx0
c
          call xderiv(akmat0,deh0,fdeh0,nord,nordmx,nrd1mx)
c
c         Calling sequence substitutions:
c           do20 for dxx0
c           fdo20 for fdxx0
c
          call xderiv(akmat0,do20,fdo20,nord,nordmx,nrd1mx)
        endif
c
c       Calling sequence substitutions:
c         daw0 for dxx0
c         fdaw0 for fdxx0
c
        call xderiv(akmat0,daw0,fdaw0,nord,nordmx,nrd1mx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
        if (qstabl) then
          delxia = dxsm00(nord)
c
c         Compute average derivatives.
c
          call gsmdez(delxia,dzvc0,dzvc0s,kdim,kmax,nord,nrd1mx)
          call gsmder(delxia,drer0,drer0s,drir0,drir0s,jreac,nord,
     $    nrct,nrctmx,nrd1mx)
c
c         Replace the actual with the average derivatives.
c
          do kcol = 1,kdim
            do n = 1,nord
              dzvc0(n,kcol) = dzvc0s(n,kcol)
            enddo
          enddo
          do n = 1,nord
            drir0(n) = drir0s(n)
          enddo
          do nrc = 1,nrct
            do n = 1,nord
              drer0(n,nrc) = drer0s(n,nrc)
            enddo
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the new value of delxi.
c
      delxi = delxi*scale
c
c     If the step size was previously cut because a phase boundary
c     was overstepped by an unacceptable amount, limit delxi so that
c     the new value of Xi will be less than the value at the last
c     known point of overstep.
c
      dlxlim = 0.75*(xilim - xi0)
      if (dlxlim .lt. dlxmin) then
c
c       The calculation has has now gotten very close to the previously
c       determined overstep location. After the present step is
c       completed, the calculation will be within a minimum step size
c       distance of that location. Failure to detect either the
c       phase boundary or the overstep at this point means that the
c       overstep location previously calculated is not actually valid.
c       What this means is that as the calculation gets closer to the
c       phase boundary, its calculated position is moving to a greater
c       value of reaction progress. This can occur when the mass
c       transfer associated with a step must be calculated from an
c       approximate, not an exact integration. Such is the case for
c       kinetic mode calculations. When the calculation goes back
c       and cuts the step size, the resulting calculation of the
c       position of the phase boundary then becomes more accurate.
c
        dlxlim = dlxmin
        xilim = prcinf
      endif
      delxi = min(delxi,dlxlim)
c
c     Make sure that delxi is not less than the minimum normally
c     allowed value.
c
      delxi = max(delxi,dlxmin)
c
      if (iodb(5) .ge. 1) write (noutpt,1320) nord,delxi
 1320 format(/' --- Selection: nord= ',i2,', delxi= ',1pe11.4,
     $ ' ---')
c
  120 qskip = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set other simple limits on the step size.
c
      if (iopt(1) .eq. 2) then
        dlxis2 = delxi
        dxdmp = xidump - xi0
        if (delxi .gt. dxdmp) then
          dxdmp = max(dxdmp,dlxmin)
          delxi = dxdmp
          if (iodb(5) .ge. 2) write (noutpt,1330) delxi
 1330     format(' --- delxi cut to ',1pe11.4,' to match the Xi PRS',
     $    ' transfer interval ---')
        endif
      endif
c
      dlxisv = delxi
      dx1 = xiprnt - xi0
      dx2 = xiprnl - xi0
      dlxipr = min(dx1,dx2)
      if (delxi .gt. dlxipr) then
        delxi = dlxipr
        if (iodb(5) .ge. 2) write (noutpt,1340) delxi
 1340   format(' --- delxi cut to ',1pe11.4,' to match the Xi print',
     $  ' interval ---')
      endif
c
      dx1 = xiplot - xi0
      dx2 = xiplol - xi0
      dlxipl = min(dx1,dx2)
      if (delxi .gt. dlxipl) then
        delxi = dlxipl
        if (iodb(5) .ge. 2) write (noutpt,1350) delxi
 1350   format(' --- delxi cut to ',1pe11.4,' to match the Xi plot',
     $  ' interval ---')
      endif
c
      dlximx = ximax - xi0
      if (dlximx .lt. delxi) then
        delxi = dlximx
        if (iodb(5) .ge. 2) write (noutpt,1360) delxi
 1360   format(' --- delxi cut to  ',1pe11.4,' to match the maximum',
     $  ' value of Xi  ---')
      endif
c
      dlxilm = dlxmax
      if (nord .le. 0) dlxilm = dlxmx0
      if (dlxilm .lt. delxi) then
        delxi = dlxilm
        if (iodb(5) .ge. 2) write (noutpt,1370) delxi
 1370   format(' --- delxi cut to ',1pe11.4,' to match the upper limit',
     $  ' for any step ---')
      endif
c
  125 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nord.gt.0 .and. .not.qscon) then
c
c       Limit delxi when the variables corresponding to certain basis
c       species are changing rapidly. Such variables may include the pH
c       or the log fO2. This limit allows some minimum of information
c       density to be obtained in the neighborhood of the rapid
c       change.
c
        call ldlxrc(al10,delxi,dlxmin,dzvc0,iodb,iindx1,kbt,kdim,
     $  kelect,khydr,khydx,km1,kmax,ko2gaq,krdxsp,kwater,kxt,nbasp,
     $  nbtmax,nodbmx,nord,noutpt,nrd1mx,nstmax,nttyo,qrapch,uspec,
     $  zklogu,zvclg0,zvclg1,zvec0,zvec1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nord.gt.0 .and. .not.qscon .and. iopt(3).lt.1
     $  .and. kxt.ge.km1 .and. iopt(1).le.1) then
c
c       Limit delxi when a phase is rapidly disapparing from the
c       equilibrium system. This is mechanism is only designed to
c       help other mechanisms efficiently locate a phase disappearance
c       boundary. It is not designed to increase information density
c       near the boundary.
c
        call ldlxrd(delxi,dlxmin,dzvc0,fdzv0,iodb,ipndx1,kdim,
     $  km1,kmax,kxt,loph,nodbmx,nord,noutpt,nptmax,nrd1mx,nttyo,
     $  uphase,zklogu,zvec0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qdump = .false.
      if (iopt(1).eq.2 .and. nord.ge.1 .and. npet.gt.0) then
c
c       Limit delxi by approximate position of significant maxima
c       of mineral masses. Because the cost of restricting delxi to
c       keep high accuracy in the estimates of first derivatives is
c       prohibitive, control can not be based strictly on derivatives,
c       but must be based mainly on how much of a mineral mass would
c       be destroyed on a given step. This permits avoiding maxima
c       which are false (due to Taylor's series inaccuracy) or trivial
c       (if the mass of a mineral is very small). If the Taylor's
c       series fail to detect a phase whose mass is going over a maximum
c       and iopt(1) = 2, then go back instructions in EQ6/eqcalc.f will
c       prevent a skip over the maximum.
c
        call fpbflo(al10,delxi,demop0,dlxmin,dxval0,d1emp1,
     $  d2emp1,emop,emop0,eps100,fdpe0,iemop,ier,iodb,nodbmx,nord,
     $  nordmx,noutpt,npet,npetmx,nptmax,nrd1mx,nttyo,qdump,toldl,
     $  uaqsln,ufixf,uphase,xim1,xi0,xi1,xval0,zklogu)
c
        if (ier .gt. 0) then
c
c         A search for a maximum in subroutine fpbflo failed. Go back
c         to the base point, shift mass to the PRS, and drop back
c         to order zero.
c
          qdump = .true.
          kord = 0
          nord = 0
          npts = 1
          delxi = 0.
          xi1 = xi0
          do npe = 1,npet
            emop(npe) = emop0(npe)
          enddo
          do nse = 1,nset
            emos(nse) = emos0(nse)
          enddo
          do kcol = 1,kxt
            zvclg1(kcol) = zvclg0(kcol)
            zvec1(kcol) = zvec0(kcol)
          enddo
c
          call pshfta(csts,emop,emop0,emos,emos0,fdpe0,fdpem1,
     $    fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,imrn1,
     $    imrn2,iodb,ipndx1,ixrn1,ixrn2,jcsort,jern1,jetmax,jgext,
     $    jpflag,jsflag,kbt,km1,kmax,kmt,kx1,kxt,loph,losp,moph,mosp,
     $    mprph,mprsp,mrgexs,mtb,mtb0,nbasp,nbaspd,nbt,nbtmax,ncmpe,
     $    ncmpr,netmax,ngext,nodbmx,nordmx,noutpt,npet,npetmx,npt,
     $    nptmax,nsetmx,nstmax,nsts,nstsmx,nstsr,nttyo,uaqsln,ufixf,
     $    uphase,uspec,xbar,xbarlg,zklgmn,zklogl,zvclg0,zvclg1,
     $    zvec0,zvec1)
c
          delxi = dlxmx0
          go to 110
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nord.gt.0 .and. .not.qscon) then
c
c       Find the phase boundary for a newly appearing phase. This is
c       here defined as a point at which the affinity to precipitate
c       has a target value (aftarg) that is slightly greater than zero.
c       If the Taylor's series fail to detect the phase boundary at
c       which a new phase appears, this condition will be subsequently
c       detected by a test in EQLIB/newton.f. This subroutine will then
c       issue a go back instruction, which will prevent the boundary
c       from being skipped over.
c
        call fpbnpp(affp,affp0,aftarg,daffp0,delxi,dlxmin,dxval0,
     $  eps100,iodb,iopt,jpflag,nodbmx,noptmx,nord,nordmx,noutpt,npchk,
     $  npt,nptmax,nrd1mx,nttyo,tolaft,tolsat,uphase,xi0,xi1,xval0)
c
        if (iopt(1).ne.2 .and. npet.gt.0) then
c
c         Find the phase boundary for a disappearing phase in the ES.
c
          call fpbdpp(delxi,demop0,dlxmin,dxval0,emop,emop0,
     $    eps100,iemop,iodb,iopt,nodbmx,noptmx,nord,nordmx,noutpt,
     $    npet,nrd1mx,npetmx,nptmax,nttyo,uphase,xi0,xi1,xval0)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct.gt.0 .and. nord.gt.0) then
        if (aft0 .gt. 0.01) then
c
c         Check the signs of the predicted reactant affinities. If
c         necessary, reduce delxi so that none of the affinities
c         change sign. For the purposes of determining a crossover,
c         a reactant affinity is taken to be zero if its magnitude is
c         less than or equal to tolsar.
c
c         This check is made to help deal with rate expressions that
c         do not approach zero as the corresponding equilibria are
c         approached. For example, one might specify a constant rate
c         of dissolution that applies to any value of the corres-
c         ponding affinity as long as it implies undersaturation. It
c         is important not to extrapolate such a rate to any other
c         condition (in this example, saturation or supersaturation).
c
c         If close to overall equilibrium, this check is best avoided.
c         Here the rates of "badly behaving" reactions may tend to
c         oscillate about their equilibrium points. As long as the
c         magnitudes of the oscillations are small, it is better to
c         not try to pin down the cross-overs.
c
          call chksar(afrc0,afrcp,dafrc0,delxi,dlxmin,dxval0,
     $    eps100,iodb,jreac,nodbmx,noutpt,nord,nordmx,nrct,nrctmx,
     $    nrd1mx,nrk,nttyo,tolsar,ureac,xi0,xi1,xval0)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
        if (nrct.gt.0 .and. nord.gt.0) then
          if (aft0 .gt. 0.01) then
c
c           Check the sign of the predicted inverse rate. If necessary,
c           reduce delxi so that the inverse rate does not become
c           less than eps100. Physically, it makes no sense that
c           the inverse rate should approach zero or become negative,
c           but errors in finite differences that could cause a
c           predicted inverse rate to do this. If so, the step size
c           needs to be reduced.
c
            call chksir(delxi,dlxmin,drir0,dxval0,eps100,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,rirec0,rirecp,xi0,xi1,xval0)
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct.gt.0 .and. nord.gt.0) then
        if (aft0 .gt. 0.01) then
c
c         Check the signs of the predicted relative rates. If,
c         necessary reduce delxi so that none of the relative rates
c         change sign. For the purposes of determining a crossover,
c         a relative rate is taken to be zero if its magnitude is
c         less than tolsrr.
c
c         This check is best avoided near overall equilibrium. See
c         comments made above in regard to a similar check on sign
c         changes of reactant affinities.
c
          call chksrr(delxi,dlxmin,drer0,dxval0,eps100,iodb,jreac,
     $    nodbmx,noutpt,nord,nrct,nrctmx,nrd1mx,nttyo,rrelr0,rrelrp,
     $    tolsrr,ureac,xi0,xi1,xval0)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
        if (nrct .gt. 0) then
c
c         Make absolutely sure that the time increment is positive.
c         Errors in numerical integration have the potential to
c         produce a negative or zero result.
c
          call chksti(akmat0,drer0,drir0,deltim,delxi,dlxmin,
     $    fdri0,fdrr0,iodb,jreac,kly,kmax,nodbmx,kord,nord,noutpt,
     $    npts,nrct,nrctmx,nrd1mx,nttyo,prcinf,qriinf,rirec0,smp100,
     $    time0,time1,xi0,xi1)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .gt. 0) then
c
c       Limit delxi by exhaustion of reactants.
c
        call fpexrc(delxi,dlxmin,drer0,dxval0,eps100,iodb,
     $  jreac,morr,morr0,nodbmx,nord,noutpt,nrct,nrctmx,nrd1mx,
     $  nttyo,qdump,rrelr0,ureac,xi0,xi1,xval0)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Limit delxi so that the next time-based print point is not
c       exceeded.
c
        if (qtprn) then
          call chktpr(delxi,dlxmin,dlxtpr,drir0,dxval0,eps100,
     $    iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,prcinf,qdump,qriinf,
     $    rirec0,tiprnl,tiprnt,time0,time1,tolxst,xi0,xi1,xval0)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the next pH-based print point is not exceeded.
c
      if (dlhprn .lt. prcinf) then
        call ckphpr(delxi,dlxmin,dph0,dxh0pr,dxh1pr,dxval0,
     $  eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,ph0,ph1,
     $  ph0prn,ph1prn,prcinf,qdump,tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Limit delxi so that the next Eh-based print point is not
c       exceeded.
c
        if (dlhprn .lt. prcinf) then
          call ckehpr(delxi,dlxmin,deh0,dxe0pr,dxe1pr,dxval0,
     $    eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,eh0,eh1,
     $    eh0prn,eh1prn,prcinf,qdump,tolxsu,xi0,xi1,xval0)
        endif
c
c       Limit delxi so that the next log fO2-based print point is not
c       exceeded.
c
        if (dloprn .lt. prcinf) then
          call cko2pr(delxi,dlxmin,do20,dxo0pr,dxo1pr,dxval0,
     $    eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,fo2lg0,
     $    fo2lg1,o20prn,o21prn,prcinf,qdump,tolxsu,xi0,xi1,xval0)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the next aw-based print point is not exceeded.
c
      if (dlaprn .lt. prcinf) then
        call ckawpr(delxi,dlxmin,daw0,dxw0pr,dxw1pr,dxval0,
     $  eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,aw0,aw1,
     $  aw0prn,aw1prn,prcinf,qdump,tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Limit delxi so that the next time-based plot point is not
c       exceeded.
c
        if (qtplo) then
          call chktpl(delxi,dlxmin,dlxtpl,drir0,dxval0,eps100,
     $    iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,prcinf,qdump,qriinf,
     $    rirec0,tiplol,tiplot,time0,time1,tolxst,xi0,xi1,xval0)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the next pH-based plot point is not exceeded.
c
      if (dlhplo .lt. prcinf) then
        call ckphpl(delxi,dlxmin,dph0,dxh0pl,dxh1pl,dxval0,
     $  eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,ph0,ph1,
     $  ph0plo,ph1plo,prcinf,qdump,tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Limit delxi so that the next Eh-based plot point is not
c       exceeded.
c
        if (dlhplo .lt. prcinf) then
          call ckehpl(delxi,dlxmin,deh0,dxe0pl,dxe1pl,dxval0,
     $    eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,eh0,eh1,
     $    eh0plo,eh1plo,prcinf,qdump,tolxsu,xi0,xi1,xval0)
        endif
c
c       Limit delxi so that the next log fO2-based plot point is not
c       exceeded.
c
        if (dloplo .lt. prcinf) then
          call cko2pl(delxi,dlxmin,do20,dxo0pl,dxo1pl,dxval0,
     $    eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,fo2lg0,
     $    fo2lg1,o20plo,o21plo,prcinf,qdump,tolxsu,xi0,xi1,xval0)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the next aw-based plot point is not exceeded.
c
      if (dlaplo .lt. prcinf) then
        call ckawpl(delxi,dlxmin,daw0,dxw0pl,dxw1pl,dxval0,
     $  eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,aw0,aw1,
     $  aw0plo,aw1plo,prcinf,qdump,tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Limit delxi so that the requested maximum value of time
c       is not exceeded.
c
        if (timemx .lt. prcinf) then
          call chktmx(delxi,dlxmin,dlxtmx,drir0,dxval0,eps100,
     $    iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,prcinf,qdump,qriinf,
     $    rirec0,timemx,time0,time1,tolxst,xi0,xi1,xval0)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the requested minimum value of pH
c     is not exceeded.
c
      if (phmin .gt. -prcinf) then
        call ckphmn(delxi,dlxmin,dph0,dxh0mx,dxval0,eps100,iodb,
     $  nodbmx,nord,noutpt,nrd1mx,nttyo,ph0,ph1,phmin,prcinf,qdump,
     $  tolxsu,xi0,xi1,xval0)
      endif
c
c     Limit delxi so that the requested maximum value of pH
c     is not exceeded.
c
      if (phmax .lt. prcinf) then
        call ckphmx(delxi,dlxmin,dph0,dxh1mx,dxval0,eps100,iodb,
     $  nodbmx,nord,noutpt,nrd1mx,nttyo,ph0,ph1,phmax,prcinf,qdump,
     $  tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Limit delxi so that the requested minimum value of Eh
c       is not exceeded.
c
        if (ehmin .gt. -prcinf) then
          call ckehmn(delxi,dlxmin,deh0,dxe0mx,dxval0,eps100,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,eh0,eh1,ehmin,prcinf,qdump,
     $    tolxsu,xi0,xi1,xval0)
        endif
c
c       Limit delxi so that the requested maximum value of Eh
c       is not exceeded.
c
        if (ehmax .lt. prcinf) then
          call ckehmx(delxi,dlxmin,deh0,dxe1mx,dxval0,eps100,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,eh0,eh1,ehmax,prcinf,qdump,
     $    tolxsu,xi0,xi1,xval0)
        endif
c
c       Limit delxi so that the requested minimum value of log fO2
c       is not exceeded.
c
        if (o2min .gt. -prcinf) then
          call cko2mn(delxi,dlxmin,do20,dxo0mx,dxval0,eps100,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,fo2lg0,fo2lg1,o2min,prcinf,
     $    qdump,tolxsu,xi0,xi1,xval0)
        endif
c
c       Limit delxi so that the requested maximum value of log fO2
c       is not exceeded.
c
        if (o2max .lt. prcinf) then
          call cko2mx(delxi,dlxmin,do20,dxo1mx,dxval0,eps100,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,fo2lg0,fo2lg1,o2max,prcinf,
     $    qdump,tolxsu,xi0,xi1,xval0)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limit delxi so that the requested minimum value of the activity
c     of water is not exceeded.
c
      if (awmin .gt. -prcinf) then
        call ckawmn(delxi,dlxmin,daw0,dxw0mx,dxval0,eps100,iodb,
     $  nodbmx,nord,noutpt,nrd1mx,nttyo,aw0,aw1,awmin,prcinf,qdump,
     $  tolxsu,xi0,xi1,xval0)
      endif
c
c     Limit delxi so that the requested maximum value of the activity
c     of water is not exceeded.
c
      if (awmax .lt. prcinf) then
        call ckawmx(delxi,dlxmin,daw0,dxw1mx,dxval0,eps100,iodb,
     $  nodbmx,nord,noutpt,nrd1mx,nttyo,aw0,aw1,awmax,prcinf,qdump,
     $  tolxsu,xi0,xi1,xval0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that delxi is not less than dlxmin unless one of the
c     following special conditions is satisfied.
c
      if (abs(delxi - dlxipr).gt.0. .and. abs(delxi - dlxipl).gt.0.
     $ .and. abs(delxi - dlximx).gt.0. .and. abs(delxi - dlxtmx).gt.0.)
     $ delxi = max(delxi,dlxmin)
c
      ncut = 0
      jcut = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  130 xi1 = xi0 + delxi
c
      if (.not.qshoot) then
c
c       The following trap keeps the code from doing lengthy cycling
c       with delxi equal to zero.
c
        if (delxi .le. 0.) then
          kstpze = kstpze + 1
          qx = kstpze .ge. 2
          if (qx) then
            write (noutpt,1380) kstpze
            write (nttyo,1380) kstpze
 1380       format(/' * Error - (EQ6/path) The step size has been zero',
     $      ' now ',i2,' times in a row.')
            stop
          endif
        else
          kstpze = 0
        endif
c
c       The following trap keeps the code from doing lengthy cycling
c       with  delxi equal to dlxmin.
c
        if (delxi .le. dlxmin) then
          kstpmn = kstpmn + 1
          qx = kstpmn .ge. 100
          if (qx) then
            write (noutpt,1390) kstpmn
            write (nttyo,1390) kstpmn
 1390       format(/' * Error - (EQ6/path) The step size has not',
     $      ' exceeded the minimum',/7x,'value now ',i3,
     $      ' times in a row.')
            stop
          endif
        else
          kstpmn = 0
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a return point for doing an ODE corrector
c     iteration.
c
  140 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .gt. 0) then
c
c       Increment the irreversible reactions (those associated with
c       the "reactants"); update the ES mass balance totals accordingly.
c
        call reacts(cbsr,csts,delxi,drer0,iern1,ietmax,iktmax,
     $  iodb,jcode,jetmax,jgext,jreac,modr,modr0,morr,morr0,mrgers,
     $  mtb,mtb0,nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nern1,nern2,nertmx,
     $  netmax,ngext,nodbmx,nord,noutpt,nptmax,nrct,nrctmx,nrd1mx,
     $  nrndex,nsrtmx,nstmax,nsts,nstsmx,nstsr,nttyo,nxridx,nxrtmx,
     $  rrelr0,rxbar,ureac,xirct,xirct0)
      endif
c
      if (iopt(2) .gt. 0) then
c
        if (qshoot) then
          time1 = prcinf
          deltim = prcinf
        else
c
c         Increment the time and related functions.
c
          call timeca(deltim,delxi,drir0,iodb,nodbmx,nord,noutpt,
     $    nrd1mx,nttyo,prcinf,qriinf,rirec0,time0,time1)
        endif
c
        if (delxi .le. dlxmin) then
c
c         Make sure that the calculated time does not exceed any
c         any specified limits such as the maximum time just because
c         delxi is at the minimum value.
c
          call tivchk(deltim,delxi,qtvchk,time1,time0,timemx,
     $    tiplol,tiplot,tiprnl,tiprnt,tolxst)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.qcntmp .or. .not.qcnpre) then
c
c       Recompute the temperature and pressure. Then recompute the
c       thermodynamic and kinetic quantities which depend these
c       variables.
c
        ntpr0 = ntpr
        call tpadv(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $  abdoth,abdot,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $  adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $  al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,axhfs,
     $  axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,bdhv,
     $  bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dhfs,
     $  dhfsd,dvfe,dvfs,dvfsd,eact,ehfac,farad,hact,iact,iapxmx,iktmax,
     $  imchmx,imech,iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,
     $  ixrn2,jpfcmx,jpress,jptffl,jsol,jtemp,narxmx,narxt,narxth,nbasp,
     $  nbaspd,nbt,nbtd,nbtmax,ncmpr,ndrsr,ndrsrd,nmut,nmutmx,nopgmx,
     $  noptmx,noutpt,nptkmx,nptmax,nrct,nrctmx,nrk,nslt,nsltmx,nst,
     $  nstmax,ntpr,ntprmx,ntprt,nttkmx,nttyo,nweope,nwndpc,nxt,nxtmax,
     $  pmu,presg,presh,press,pressb,pressd,pslamn,ptk,rcnstv,rconst,rk,
     $  rkb,rtcnst,tempc,tempcb,tempcd,tempcu,tempk,time1,trkb,ttk,
     $  uphase,uspec,wfac,xhfe,xhfs,xhfsd,xi1,xlke,xlks,xlksd,xvfe,
     $  xvfs,xvfsd)
c
        qtrch = ntpr0 .ne. ntpr
        if (qtrch) nord = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .le. dlxmin) then
        nord = 0
        kord = 0
      endif
c
c     Make a Taylor's series expansion of the z vector, applying
c     change limits. It is important to make a protected expansion
c     here to clear out unrecoverable values in the zvclg1 and
c     zvec1 vectors that may have been generated in previous
c     order/step size adjustments for the current step. This is
c     true even if the current order is zero, as the order may
c     have been higher earlier in the current step.
c
      qztayl = .true.
      call ztaylr(delxi,dzvc0,kdim,kmax,km1,kxt,nord,nrd1mx,
     $ qztayl,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qstart = xi1 .le. xistsv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the equilibrium calculation at the current point of reaction
c     progress. Subroutine eqshel forms a shell around EQ6/eqphas.f.
c     It may make small advances in the value of the reaction progress
c     variable in order to step over a small region (commonly on the
c     order of 1 x 10-8 mol) in which the equilibrium state can not be
c     calculated satisfying the normal tolerances. One category of such
c     regions is associated with phase boundaries (where a phase such
c     as a mineral either appears or disappears). The problem is that
c     a calculation assuming the phase is present crashes, indicating
c     that the phase should be deleted. One the other hand, a
c     calculation assuming it is not present converges, but gives a
c     supersaturation in excess of the supersaturation tolerance (a
c     condition which normally instructs the code to add the phase to
c     the phase assemblage and try again). Another category of such
c     regions is associated with a rapid change in the value of a
c     variable associated with an aqueous basis species. Typically
c     this is the oxygen fugacity or equivalent redox variable. Such
c     a change is called a redox jump. A similar jump might occur for
c     some non-redox variable, such as pH. However, this is not likely
c     for any non-redox variable because of the general presence of
c     significant buffering effects of one kind or another (true
c     buffering, mass buffering).
c
      call eqshel(aadh,aadhh,aadhv,aamatr,aaphi,abar,abdh,
     $ abdhh,abdhv,abdot,abdoth,abdotv,acflg,acflgo,act,actlg,
     $ adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,adh,adhh,adhv,
     $ afcnst,affp,affs,alpha,al10,amtb,aphi,apx,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,betao,bgamx,bneg,bpx,cbsr,cco2,cdac,cegexs,
     $ cesr,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,conc,
     $ conclg,cpgexs,cscale,csigma,csts,dadhh,dadhv,dbdhh,dbdhv,
     $ dbdth,dbdtv,deltim,delvco,delvec,delxi,dlogxw,dlxmin,
     $ drer0,drir0,dzvc0,d1zvc1,eact,egers,egexjc,egexjf,egexs,
     $ eh,ehfac,elecsr,eps100,farad,fje,fjeo,fkrc,fo2,fo2lg,
     $ fsort,fugac,fugalg,fxi,fxio,gmmatr,hact,iact,iapxt,ibpxt,
     $ ibswx,ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $ ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx0,iindx1,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,
     $ ilzeta,imech,imrn1,imrn2,insgf,iodb,iopg,iopt,ipch,
     $ ipivot,ipndx1,ipcv,istack,iter,itermx,ixbasp,ixrn1,ixrn2,
     $ izmax,jcode,jcsort,jflag,jgsort,jgstak,jjsort,jpflag,
     $ jpress,jptffl,jreac,jsflag,jsitex,jsol,jssort,jstack,
     $ jtemp,kbt,kction,kdim,kelect,khydr,khydx,km10,km1,kmt,
     $ kmt0,ko2gaq,kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt,kxt0,
     $ loph,losp,lsort,modr,modr0,moph,morr,morr0,mosp,mrgers,
     $ mrgexs,mtb,mtbaq,mtb0,mte,mteaq,mwtrc,narn1,narn2,narxt,
     $ nat,nbasp,nbaspd,nbaspx,nbt,nbtd,nbw,nchlor,ncmpr,ncorr,
     $ nct,ndac,ndact,ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,ndrsrx,nelect,
     $ nern1,nern2,ness,nessr,net,nfrn1,nfrn2,ngrn1,ngrn2,ngt,
     $ nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmt,nord,noutpt,
     $ no2gaq,npchk,nphasx,npslmx,npt,nrct,nrdxsp,nrk,nrndex,nsk,
     $ nsslmx,nst,nsts,nstsr,ntpr,ntrymx,ntprt,nttyo,nxridx,nxrn1,
     $ nxrn2,nxt,nweope,nwndpc,omega,omeglg,prcinf,press,pressb,
     $ pressd,ptk,qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,
     $ qoptmz,qpit75,qredox,qriinf,qscon,qshoot,qstart,qtrch,qtvchk,
     $ qxknph,q6mode,rcnstv,rconst,rkb,rhsvec,rirec0,rk,rreacn,
     $ rreac1,rrelr0,rrelr1,rtcnst,rxbar,screwd,sidrph,sidrsp,
     $ sigmam,sigmmo,smp100,tdays,tempc,tempcb,tempcd,tempcu,
     $ tempc0,tempk,timemx,time0,time1,tiplol,tiplot,tiprnl,tiprnt,
     $ tistsv,tolbt,toldl,tolsat,tolsst,tolxst,trkb,ttk,ubacmx,
     $ ubgamx,udac,ufixf,ugermo,ulbeta,uldel,uphase,ureac,uspec,
     $ uzvec0,uzvec1,vreac,weight,wfac,wodr,worr,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xgers,xirct,xirct0,xistsv,xi0,
     $ xi1,zchar,zchcu6,zchsq2,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     Note on ier codes returned by EQ6/eqshel.f:
c
c       =    0  Okay
c       =   10  Go back and take a smaller step size to avoid exceeding
c                 the supersaturation tolerance (tolsst)
c       =  170  Too much of a phase was destroyed under the flow-through
c                 open system model; go back and first move part of the
c                 mass of protected phases in the ES to the PRS
c       =  180  One of a number of problems occurred which may be
c                 resolvable, at least partially, by going back and
c                 cutting the step size
c       =  190  Need to slide over a region of computational
c                 instability, but sliding is inhibited; go back, but
c                 terminate work on the current problem
c
      if (ier .le. 0) go to 200
c
c * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 10) then
c
c       An incoming phase boundary was stepped over by too much.
c       Go back and step forward again, using a smaller step size.
c       Note: this error code is not returned if the step size is less
c       than or equal to the minimum value.
c
        xilim = xi1
        kly = 6
        go to 150
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up to go back to the previous point. Try a smaller step
c     size or zero order Taylor's expansions, or write a pickup file
c     for the last good point and stop.
c
  150 continue
c
      call goback(acflg,acflg0,emop,emop0,emos,emos0,fje,
     $ fje0,fxi,fxi0,iemop,iemop0,iemos,iemos0,iindx0,iindx1,ipndx0,
     $ ipndx1,jpflag,jsflag,jreac,jreac0,kdim,kdim0,kmax,km1,km10,
     $ kmt,kmt0,kx1,kx10,kxt,kxt0,loph,losp,moph,moph0,mosp,mosp0,
     $ ncmpe,ncmpe0,npet,npetmx,npet0,npt,nptmax,nrct,nrctmx,nset,
     $ nsetmx,nset0,nst,nstmax,qreq,qriinf,sigmam,sigmm0,uzvec0,
     $ uzvec1,xi0,xi1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier.eq.180 .and. delxi.le.dlxmin) then
c
c       Normally this error code results in a reduction in the step
c       size. This can't be done if the step size is already at the
c       minimum value. Write a pickup file at the last good point
c       and terminate work on the current problem.
c
        write (ux16,'(g12.5)') xi1
        call lejust(ux16)
        j2 = ilnobl(ux16)
        write (noutpt,1400) ux16(1:j2)
        write (nttyo,1400) ux16(1:j2)
 1400   format(/' * Error- (EQ6/path) The equilibrium calculation',
     $  ' failed at Xi= ',a,'.',/7x,"Can't cut the step size to try",
     $  ' to recover. See previous notes',/7x,'and warnings for',
     $  ' suggestions.')
        go to 180
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If a slide forward in EQ6/eqshel.f failed to get over a region of
c     computational instability, write a pickup file at the last good
c     point and terminate work on the current problem.
c
      if (ier .eq. 190) go to 180
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 170) then
c
c       The equilibrium calculation was completed successfully, but too
c       much of a phase in the equilibrium system (ES) was destroyed to
c       satisfy the requirements of the fluid-centered flow-through open
c       system model. Go back and first transfer some of the phase's
c       mass to the physically removed system (PRS).
c
        km1 = km10
        kmt = kmt0
        kx1 = kx10
        kxt = kxt0
        kdim = kdim0
c
        call copyaa(zvclg0,zvclg1,kdim)
        call copyaa(zvec0,zvec1,kdim)
c
        do kcol = 1,kdim
          uzvec1(kcol) = uzvec0(kcol)
          iindx1(kcol) = iindx0(kcol)
          ipndx1(kcol) = ipndx0(kcol)
        enddo
c
        dxsave = 0.25*delxi
        kly = 6
        delxi = 0.
        deltim = 0.
        time1 = time0
c
c       Recompute the temperature and pressure. Then recompute the
c       thermodynamic and kinetic quantities which depend these
c       variables.
c
        call tpadv(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $  abdoth,abdot,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $  adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $  al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,axhfs,
     $  axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,bdhv,
     $  bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dhfs,
     $  dhfsd,dvfe,dvfs,dvfsd,eact,ehfac,farad,hact,iact,iapxmx,iktmax,
     $  imchmx,imech,iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,
     $  ixrn2,jpfcmx,jpress,jptffl,jsol,jtemp,narxmx,narxt,narxth,nbasp,
     $  nbaspd,nbt,nbtd,nbtmax,ncmpr,ndrsr,ndrsrd,nmut,nmutmx,nopgmx,
     $  noptmx,noutpt,nptkmx,nptmax,nrct,nrctmx,nrk,nslt,nsltmx,nst,
     $  nstmax,ntpr,ntprmx,ntprt,nttkmx,nttyo,nweope,nwndpc,nxt,nxtmax,
     $  pmu,presg,presh,press,pressb,pressd,pslamn,ptk,rcnstv,rconst,rk,
     $  rkb,rtcnst,tempc,tempcb,tempcd,tempcu,tempk,time1,trkb,ttk,
     $  uphase,uspec,wfac,xhfe,xhfs,xhfsd,xi1,xlke,xlks,xlksd,xvfe,
     $  xvfs,xvfsd)
c
        if (nrct .ge. 1) then
c
c         Increment the irreversible reactions (those associated with
c         the "reactants"); update the ES mass balance totals
c         accordingly.
c
          call reacts(cbsr,csts,delxi,drer0,iern1,ietmax,iktmax,
     $    iodb,jcode,jetmax,jgext,jreac,modr,modr0,morr,morr0,mrgers,
     $    mtb,mtb0,nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nern1,nern2,nertmx,
     $    netmax,ngext,nodbmx,nord,noutpt,nptmax,nrct,nrctmx,nrd1mx,
     $    nrndex,nsrtmx,nstmax,nsts,nstsmx,nstsr,nttyo,nxridx,nxrtmx,
     $    rrelr0,rxbar,ureac,xirct,xirct0)
        endif
c
c       Expand the system description.
c
        call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $  conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $  fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $  iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $  jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $  jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $  kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $  narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $  nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $  no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $  press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $  xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
        call pshfta(csts,emop,emop0,emos,emos0,fdpe0,fdpem1,
     $  fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,imrn1,
     $  imrn2,iodb,ipndx1,ixrn1,ixrn2,jcsort,jern1,jetmax,jgext,
     $  jpflag,jsflag,kbt,km1,kmax,kmt,kx1,kxt,loph,losp,moph,mosp,
     $  mprph,mprsp,mrgexs,mtb,mtb0,nbasp,nbaspd,nbt,nbtmax,ncmpe,
     $  ncmpr,netmax,ngext,nodbmx,nordmx,noutpt,npet,npetmx,npt,
     $  nptmax,nsetmx,nstmax,nsts,nstsmx,nstsr,nttyo,uaqsln,ufixf,
     $  uphase,uspec,xbar,xbarlg,zklgmn,zklogl,zvclg0,zvclg1,
     $  zvec0,zvec1)
c
        delxi = max(dxsave,dlxmin)
        nord = min(nord,kord)
        jcut = jcut + 1
        if (jcut .le. 10) go to 130
        go to 180
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Cut the step size or order and try again or terminate.
c
      iexrt = 0
      jexrt = 0
      jscat = 0
      jscrt = 0
      qdump = .false.
      kly = 6
c
      if (delxi .gt. dlxmin) then
        write (noutpt,1440)
 1440   format(' --- Cutting the step size and trying again ---')
        ncut = ncut + 1
        delxi = 0.25*delxi
        delxi = max(delxi,dlxmin)
        go to 130
      endif
c
      if (nord .gt. 0) then
        nord = 0
        write (noutpt,1430)
 1430   format(' --- Cutting to order zero and trying again ---')
        go to 130
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reaction path tracing has failed. Write a pickup file for the last
c     good point and stop.
c
  180 if (.not.qrpcfl .and. iopt(17).ge.0) then
        write (ux16,'(g12.5)') xi1
        call lejust(ux16)
        j2 = ilnobl(ux16)
        write (ux16a,'(g12.5)') xi0
        call lejust(ux16a)
        j3 = ilnobl(ux16a)
        write (noutpt,1450) ux16(1:j2),ux16a(1:j3)
        write (nttyo,1450)  ux16(1:j2),ux16a(1:j3)
 1450   format(/' * Error - (EQ6/path) Reaction path tracing has',
     $  ' failed',/7x,'at Xi= ',a,'. Will try to go back to',
     $  ' Xi= ',a,',',/7x,'the last point of reaction progress',
     $  ' at which the calculations',/7x,'were successful. If this',
     $  ' succeeds, will then stop and write a',/7x,'pickup file.',
     $  ' Try using this to restart the calculation.')
        qrpcfl = .true.
        iexrt = 0
        jexrt = 0
        jscat = 0
        jscrt = 0
        delxi = 0.
        qstopx = .true.
        go to 130
      else
        write (noutpt,1460)
        write (nttyo,1460)
 1460   format(/" * Error - (EQ6/path) Can't recover by going back",
     $  ' to the last point',/7x,'of reaction progress at which',
     $  ' calculations were successful.',/7x,"Can't write a pickup",
     $  ' file describing the system at that point.',/7x,'Try',
     $  ' re-running the problem, setting the maximum number',
     $  ' of steps',/7x,'(kstpmx) to the value which corresponds to',
     $  ' that point. Then try',/7x,'restarting the calculation',
     $  ' from that point.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The equilibrium calculation at the current point succeeded.
c
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the activity of water.
c
      actwlg = actlg(narn1)
      actw = texp(actwlg)
      aw1 = actw
c
c     Get the weights (masses) of solvent, total dissolved solutes,
c     and aqueous solution, and get the aqeuous solution density.
c
      call gwdenp(adwipp,bdwipp,jcsort,mlmrra,mosp,mrmlra,
     $ mwtsp,narn1,narn2,nstmax,qdwipp,rhoc,rhowc,tdsgks,tdsglw,
     $ tdspkc,tdsplc,tempc,vosol,wfh2o,wftds,wkgwi,woh2o,
     $ wosol,wotds)
c
      if (qdwipp) then
        qrho = .true.
        rho = rhoc
      else
        qrho = .false.
        rho = 0.0
      endif
c
c     Compute pH, Eh, and pe-, all with reference to appropriate
c     pH scales. Also compute the pHCl.
c
      call gpheh(acflg,actlg,actwlg,adh,ah,ahmes,ahnbs,conc,
     $ eh,ehfac,ehmes,ehnbs,farad,fo2lg,fxi,iopg,mrmlra,nchlor,nhydr,
     $ nopgmx,noutpt,nstmax,nttyo,pch,pe,pemes,penbs,ph,phcl,phmes,
     $ phnbs,qphcl,qredox,qrho,xlke)
c
      wkgh2o = 1.e-3*woh2o
      wkgsol = 1.e-3*wosol
      ph1 = ph
      eh1 = eh
      fo2lg1 = fo2lg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the new affinities and rates of the irreversible
c     reactions. Determine if the kinetic mode requires a corrector
c     step or a cut in the step size.
c
      if (nrct .le. 0) go to 300
c
c     Update the affinities of the irreversible reactions (afrc1).
c
      call raff(acflg,actlg,afcnst,affp,afrc1,bpx,cdrs,cgexj,
     $ ibpxmx,ibpxt,iern1,ietmax,iktmax,ixrn1,ixrn2,jcode,jern1,jern2,
     $ jetmax,jflag,jgext,jpflag,jsflag,jsol,ncmpr,ndrs,ndrsmx,ndrsr,
     $ nertmx,net,netmax,ngext,noutpt,nptmax,nrct,nrctmx,nrndex,
     $ nstmax,nttyo,nxridx,nxrtmx,nxtmax,rxbar,uphase,uspec,wfac,
     $ xbar,xbarlg,xgers,xlks)
c
c     Check the irreversible reactions for saturation.
c
      call rsatch(csts,egers,egexs,iern1,ietmax,iindx1,iktmax,
     $ iopt,ipndx1,jcode,jern1,jern2,jetmax,jgext,jpflag,jreac,kmax,
     $ km1,kmt,kx1,kxt,loph,losp,moph,morr,mosp,mrgers,mtb,mtb0,
     $ nbaspd,nbtmax,ncmpr,nern1,nern2,nert,nertmx,netmax,ngext,
     $ noptmx,noutpt,nptmax,nrct,nrctmx,nrk,nrndex,nstmax,nsts,nstsmx,
     $ nstsr,nttyo,nxridx,nxrt,nxrtmx,qreq,rxbar,tolxsf,uphase,ureac,
     $ uspec,xbar,xbarlg,zvclg1,zvec1)
c
c     Calculate rates of irreversible reactions at the new point by
c     evaluating the corresponding rate laws.
c
      call rtcalc(act,afrc1,cdac,csigma,eps100,fkrc,idirec,
     $ imchmx,imech,iodb,iopt,jcode,jreac,morr,morr0,mwtrc,ndac,
     $ ndact,ndctmx,nodbmx,noptmx,nord,noutpt,nrk,nrct,nrctmx,nsk,
     $ nstmax,nttyo,prcinf,prminf,qriinf,rirec1,rk,rreac1,rrelr1,
     $ rtcnst,rrxfi1,sfcar,sfcar0,ssfcar,udac,ureac)
c
      if (qshoot) go to 220
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .le. 0) go to 230
c
      if (qriinf) then
c
c       Trap an infinite time step.
c
        if (delxi .le. dlxmin) then
c
c         Provisionally, take an infinite time step.
c
          deltim = prcinf
          time1 = prcinf
c
c         Make sure that the calculated time does not exceed any
c         any specified limits such as the maximum time just because
c         delxi is at the minimum value.
c
          call tivchk(deltim,delxi,qtvchk,time1,time0,timemx,
     $    tiplol,tiplot,tiprnl,tiprnt,tolxst)
c
          if (qtvchk) then
            qriinf = .false.
          else
            write (noutpt,1490)
            write (nttyo,1490)
 1490       format(/' --- Infinite time step ---',/)
          endif
c
          go to 230
        else
c
c         Go back and cut the step size before taking an infinite
c         time step.
c
          ier = 0
          go to 150
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ncorr .le. 0) then
c
c       If using the predictor function, get predicted values for the
c       inverse rate and the relative rates to compare with values
c       obtained from rate law expressions. If using a corrector
c       function, these variables are already available.
c
        call rtaylr(delxi,drer0,drir0,jreac,nord,nrct,nrctmx,
     $  nrd1mx,rirec0,rirecp,rrelr0,rrelrp)
c
c       Zero the "old" values of btrmax and dlrmax, which are used
c       to estimate the convergence rate for the ODE integrator.
c
        btrmxo = 0.
        dlrmxo = 0.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(14).le.0 .and. .not.qhcon) then
c
c       If allowing both predictors, turn on the higher-order (stiff)
c       corrector if the simple predictor is currently on but not
c       rapidly converging.
c
        if (ncorr .ge. 4) then
          qhcon = .true.
          if (iodb(2) .gt. 1) then
            write (noutpt,1492)
            write (nttyo,1492)
 1492       format(' Switching to the higher-order (stiff) corrector')
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute residual functions for the ODE integrator.
c
      call betars(alphar,betar,btrfnc,btrmax,btrmxo,ibtrmx,
     $ nrct,nrct1,nrctmx,rirec1,rirecp,rrelr1,rrelrp)
c
      if (iodb(8) .ge. 2) then
        write (noutpt,1500)
 1500   format(/5x,'ODE residual functions:',
     $  //9x,'Reactant',22x,'betar',11x,'alphar',/)
        do nrc = 1,nrct
          write (noutpt,1510) ureac(nrc),betar(nrc),alphar(nrc)
 1510     format(7x,a24,5x,1pe11.4,5x,e11.4)
        enddo
        ux24 = 'Inverse rate'
        write (noutpt,1510) ux24,betar(nrct1),alphar(nrct1)
        write (noutpt,1512)
 1512   format(1x)
      endif
c
c     Test the accuracy of rate law integration. If the accuracy
c     is sufficient, qodeok will be returned with a value of .true.
c
      call tstari(afrc1,alphar,betar,delxi,iodb,modr,nodbmx,
     $ noutpt,nrct,nrctmx,nrct1,nsscmx,qodeok,rirec1,rirecp,rrelr1,
     $ rrelrp,sscrew,time1,tistrt,ureac)
c
      if (iodb(8) .ge. 1) then
        write(noutpt,1520) btrmax,btrfnc
 1520   format(5x,'btrmax= ',1pe10.3,5x,'btrfnc= ',e10.3)
      endif
c
c     Satisfying any of the following tests causes the current
c     results to be considered acceptable. Corrector iteration,
c     if begun, is terminated.
c
c     Force at a couple of corrector iterations.
c
      if (ncorr .lt. 2) then
        if (btrmax .gt. eps100) then
          qodeok = .false.
        endif
      endif
c
      if (qodeok) go to 220
      if (qmod .or. qbye) go to 220
      if (nord .le. 0) go to 220
c
c     Check for affinity sign flips.
c
      qaflip = .false.
      do j = 1,nrct
        if (afrc1(j).ge.0. .and. afrc0(j) .lt.0 .) then
          qaflip = .true.
          if (iodb(2) .gt. 1) then
            j2 = ilnobl(ureac(j))
            write (noutpt,1522) ureac(j)(1:j2)
            write (nttyo,1522) ureac(j)(1:j2)
 1522       format(' Affinity sign flip (',a,': - to 0/+)')
          endif
        elseif (afrc1(j).lt.0. .and. afrc0(j) .ge.0 .) then
          qaflip = .true.
          if (iodb(2) .gt. 1) then
            j2 = ilnobl(ureac(j))
            write (noutpt,1524) ureac(j)(1:j2)
            write (nttyo,1524) ureac(j)(1:j2)
 1524       format(' Affinity sign flip (',a,': 0/+ to -)')
          endif
        endif
      enddo
c
c     Satisfying any of the following tests causes ODE correction
c     to be terminated or foregone in favor of cutting the step
c     size.
c
      if (qaflip) go to 210
      if (iopt(14) .ge. 3) go to 210
      if (ncorr.ge.6 .and. delxi.gt.dlxmin) go to 210
      if (ncorr .ge. 8) go to 210
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up to make an ODE corrector iteration step.
c
      ncorr = ncorr + 1
c
      if (ncorr .eq. 1) then
        qwhcfa = .true.
      elseif (delxi .le. 0.) then
        qwhcfa = .true.
      else
        adx = abs(dlxode - delxi)
        qwhcfa = (adx/delxi) .gt. eps100
      endif
c
      if (qwhcfa) then
c
c       This if block is normally entered only when ncorr = 1. If
c       the step size is cut during ODE correction, the calculations
c       in this block must be redone. When ncorr = 1, dlxode should
c       be set to prcinf (practical infinity). This value is set at
c       the start of a new step.
c
c       Save the current step size.
c
        dlxode = delxi
c
c       Calculate the dxsm10 vector from the step size (delxi) and the
c       dxsm00 vector. Note that dxsm10(1) = delXi(0,-1) = -delxi, but
c       dxsm10(2) = delXi(0,1), dxsm10(3) = delXi(0,2), etc. More
c       simply put, dxsm10 is the vector of cumulative step sizes to
c       the new point, but centered at point 0. In constrast, dxsm00
c       is the vector of cumulative step sizes to point 0, centered
c       at point 0.
c
        do j = 1,kordlm
          dxsm10(j + 1) = dxsm00(j)
        enddo
        dxsm10(1) = -delxi
c
c       Now calclate dxsm11, the vector of cumulative step sizes to
c       the new point, centered at the new point.
c
        do n = 1,kordlm
          j = kordlm - n + 1
          dxsm11(j + 1) = dxsm00(j) + delxi
        enddo
        dxsm11(1) = delxi
c
c       Compute the matrix (akmat1 = FC) used to calculate derivatives
c       for truncated Taylor's series, given corrector-based finite
c       differences.
c
c       Calling sequence substitutions:
c         akmat1 for akmat0
c         dxsm10 for dxsm00
c
        call gakmat(akmat1,dxsm10,nord,nrd1mx)
c
        if (qhcon) then
c
c         Calculate the w factor (whcfac) needed for higher-order
c         (stiff) ODE corrections. This depends only on the recent
c         step size history, including the current step size.
c
          call gwhcfa(akmat1,delxi,dxsm11,hhcvec,nord,nordmx,
     $    nrd1mx,whcfac,xhcvec)
        endif
      endif
c
      if (.not. qhcon) then
c
c       Use the simple corrector. The rates (rrelr1 and rirec1)
c       calculated from the governing rate equations  will be used
c       below as the rates at the new point when constructing new
c       finite differences for the corrector. Here just record the
c       correction in the rates at the new point.
c
        do j = 1,nrct1
          delvcr(j) = alphar(j)
        enddo
      endif
c
      if (qhcon) then
c
c       Use the higher-order (stiff) ODE integrator. Adjust rrelr1
c       and rirec1 using this scheme. These new values will be used
c       to compute a new finite-difference-based Taylor's-series-
c       formatted corrector function. Basically, the current adjustment
c       represents an application of the Newton-Raphson method.
c
c       Set up the right-hand-size vector.
c
        do j = 1,nrct1
          rhsvcr(j) = -alphar(j)
        enddo
c
c       Recompute the cdacb, ndacb, and ndactb arrays prior to
c       calculating the Jacobian matrix J[r].
c
cXX - Note: this can be changed by basis switching. Am probably
cXX   recalculating these arrays many times unnecessarily.
c
        call gndacb(cdac,cdacb,cdrs,eps100,imech,imchmx,
     $  jflag,nbasp,nbt,nbtmax,ndac,ndacb,ndact,ndactb,ndctmx,
     $  ndrs,ndrsmx,ndrsr,nrct,nrctmx,nstmax)
c
c       Compute the Jacobian matrix J[r] (armatr).
c
        call garmat(act,afrc1,aimatr,al10,armatr,cdac,cdacb,
     $  cdrs,csigma,csts,delvec,dlogxw,dvjdte,eact,eps100,fkrc,gmmatr,
     $  hact,iact,idirec,iindx1,iktmax,imchmx,imech,ipivot,jcode,jreac,
     $  jtemp,kbt,kdim,kmax,mmmatr,morr,mwtrc,nbasp,nbt,nbtmax,ncmpr,
     $  ndac,ndacb,ndact,ndctmx,ndrs,ndrsmx,ndrsr,noutpt,nptmax,nrct,
     $  nrctmx,nrct1,nrk,nrndex,nsk,nstmax,nsts,nstsmx,nstsr,nttkmx,
     $  nttyo,nxridx,nxrtmx,rirec1,rk,rkb,rreac1,rrelr1,rrxfi1,rtcnst,
     $  rxbar,sfcar,sgmatr,ssfcar,tempc,tempcb,tempk,ttk,ureac,whcfac,
     $  xi1,xlks,xxmatr,xymatr)
c
c       Solve for the correction vector (delvcr). If EQLIBU/msolvr.f
c       can't solve the matrix, it is because the matrix is either
c       zero (ier = 1) or non-zero, but computationally singular
c       (ier = 2).
c
c       Calling sequence substitutions:
c         armatr for aamatr
c         delvcr for delvec
c         grmatr for gmmatr
c         ipivtr for ipivot
c         nrct1  for kdim
c         nrct1  for kmax
c         rhsvcr for rhsvec
c
        qpr = .false.
        call msolvr(armatr,delvcr,grmatr,ier,ipivtr,nrct1,nrct1,
     $  noutpt,nttyo,qpr,rhsvcr)
c
        if (ier .le. 0) then
c
c         Correct the predicted values. Note that the results are
c         stored in rrelr1 and rirec1, not rrelrp and rirecp.
c
          do j = 1,nrct
            rrelr1(j) = rrelrp(j) + delvcr(j)
          enddo
          rirec1 = rirecp + delvcr(nrct1)
        else
c
c         Higher-order (stiff) ODE correction failed on this corrector
c         iteration. Drop back to the simple corrector.
c
          do j = 1,nrct1
            delvcr(j) = alphar(j)
          enddo
        endif
      endif
c
      if (iodb(8) .ge. 2) then
        ux24 = 'Simple'
        if (qhcon) ux24 = 'Higher-order (stiff)'
        j2 = ilnobl(ux24)
        write (noutpt,1530) ux24(1:j2)
 1530   format(/5x,a,' ODE corrector:',
     $  //9x,'Reactant',22x,'delvcr',7x,'Corrected r',/)
        do nrc = 1,nrct
          write (noutpt,1540) ureac(nrc),delvcr(nrc),rrelr1(nrc)
 1540     format(7x,a24,5x,1pe11.4,5x,e11.4)
        enddo
        ux24 = 'Inverse rate'
        write (noutpt,1540) ux24,delvcr(nrct1),rirec1
        write (noutpt,1512)
      endif
c
c     Find the max norm of the correction vector (delvcr). In the limit
c     of the solution, the (unrelaxed) correction term bounds the error
c     in the variables being calculated.
c
      idlrmx = iarmxn(delvcr,nrct1)
      dlrmax = 0.
      if (idlrmx .gt. 0) dlrmax = abs(delvcr(idlrmx))
c
c     Calculate the delvcr improvement function (dlrfnc).
c
      dlrfnc = 0.
      if (dlrmxo .gt. 0.) dlrfnc = (dlrmxo -dlrmax)/dlrmxo
c
      dlrmxo = dlrmax
c
      if (iodb(8) .ge. 2) then
        write(noutpt,1550) dlrmax,dlrfnc
 1550   format(9x,'dlrmax= ',1pe10.3,5x,'dlrfnc= ',e10.3)
      endif
c
c     Compute the new set of finite differences for a corrector
c     step.
c
      call corrfd(delxi,dxsm11,fdlim,fdre0,fdre1,fdri0,
     $ fdri1,fdrr0,fdrr1,iodb,iopt,jreac,nodbmx,noptmx,nord,
     $ nordmx,noutpt,npts,nrct,nrctmx,nrd1mx,rirec0,rirec1,
     $ rreac0,rreac1,rrelr0,rrelr1)
c
c     Now recompute the corresponding set of derivatives for the
c     original base point.
c
c     Calling sequence substitutions:
c       akmat1 for akmat0
c       fdri1 for fdri0
c       fdrr1 for fdrr0
c
      call rderiv(akmat1,drer0,drir0,fdri1,fdrr1,jreac,nord,
     $ nrct,nrctmx,nrd1mx)
c
c     Save the current corrected rate values. They will be the
c     predicted rates for the next corrector iteration. This
c     saves the effort of recalculating them from finite
c     differences.
c
      do j = 1,nrct
        rrelrp(j) = rrelr1(j)
      enddo
      rirecp = rirec1
c
c     Go back to the base point and try again with the current
c     corrector function.
c
      go to 140
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  210 continue
c
c     The corrector algorithm has failed to satsify the specified
c     criteria at the current order and step size.
c
      if (delxi .gt. dlxmin) then
c
c       Go back and cut the step size to satisfy the ODE corrector
c       tolerance. When the step size is cut to the minimum value
c       (dlxmin), the order will be reduced to zero and the
c       ODE integration will be considered sufficiently accurate.
c
        ncorr = 0
        ier = 0
        go to 150
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  220 continue
c
c     The AE/ODE algorithms have succeeded for the current step.
c     However, it may be necessary to go back and cut the step size
c     if an event has not been sufficiently accurately located.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the currently targeted time-based print point
c     has not been exceeded.
c
      tiprxx = min(tiprnl,tiprnt)
      if (((time1 - tiprxx)/tiprxx) .gt. tolxst) then
        if (delxi .gt. dlxmin) then
c
c         Go back and cut the step size.
c
          ncorr = 0
          ier = 0
          go to 150
        else
c
c         Set the current time equal to the targeted time-based print
c         point
c
          time1 = tiprxx
          deltim = tiprxx - time0
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the currently targeted time-based plot point
c     has not been exceeded.
c
      tiplxx = min(tiplol,tiplot)
      if (((time1 - tiplxx)/tiplxx) .gt. tolxst) then
        if (delxi .gt. dlxmin) then
c
c         Go back and cut the step size.
c
          ncorr = 0
          ier = 0
          go to 150
        else
c
c         Set the current time equal to the targeted time-based plot
c         point
c
          time1 = tiplxx
          deltim = tiplxx - time0
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the maximum time has not been exceeded.
c
      if (((time1 - timemx)/timemx) .gt. tolxst) then
        if (delxi .gt. dlxmin) then
c
c         Go back and cut the step size.
c
          ncorr = 0
          ier = 0
          go to 150
        else
c
c         Set the current time equal to the maximum time.
c
          time1 = timemx
          deltim = timemx - time0
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(14).le.0 .and. qhcon) then
c
c       If allowing both predictors, turn on the simple corrector
c       if the higher-order (stiff)  predictor is currently on
c       and rapidly converging.
c
        if (ncorr .le. 2) then
          qhcon = .false.
          if (iodb(2) .gt. 1) then
            write (noutpt,1560)
            write (nttyo,1560)
 1560       format(' Switching to the low-order (simple) corrector')
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  230 continue
c
c     Check for reactants that are newly exhausted and for formerly
c     exhausted reactants that are starting to precipitate. Note
c     that iexrt is the number of newly exhausted reactants, not
c     the total number of currently exhausted reactants. Here
c     jexrt is the number of formerly exhausted reactants that
c     have been reactivated.
c
      iexrt = 0
      jexrt = 0
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
c
c         The reactant is active. See if there are any moles
c         remaining. If not, the reactant is exhausted if the
c         affinity is positive, the relative rate is positive,
c         or a finite amount was present at the previous point
c         of reaction progress (all three conditions should
c         agree).
c
          if (morr(nrc) .le. 0.) then
            if (afrc1(nrc).gt.eps100 .or. rrelr1(nrc).gt.eps100
     $        .or. morr0(nrc).gt.0.) then
              jreac(nrc) = 1
              iexrt = iexrt + 1
              iexr(iexrt) = nrc
            endif
          endif
        elseif (jreac(nrc) .eq. 1) then
c
c         The reactant is exhausted (has no moles remaining). See if
c         the affinity favors formation. If so, activate the reactant
c         so that this may proceed. Note that reactivation is not
c         appropriate for the case in which nrk(2,nrc) = 0. In that
c         case, precipitation is governed by partial equilibrium,
c         not a rate law.
c
          if (nrk(2,nrc) .ne. 0) then
            if (afrc0(nrc).gt.eps100 .and. afrc1(nrc).le.eps100) then
              jreac(nrc) = 0
              jexrt = jexrt + 1
              jexr(jexrt) = nrc
            endif
          endif
        endif
      enddo
c
c     Check to see that the point of reactivation of a formerly
c     exhausted reactant has been located sufficiently accurately.
c     A finite-difference based search does not guarantee this.
c
      jexrtx = 0
      do j = 1,jexrt
        nrc = jexr(j)
        if (abs(afrc1(nrc)) .gt. eps100) then
          jexrtx = jexrtx + 1
          if (iodb(1) .gt. 0) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1570) ureac(nrc)(1:j2),afrc1(nrc)
 1570       format(/3x,'The affinity of formerly exhausted reactant',
     $      ' ',a,/5x,'is ',1pe11.4,' kcal. This is outside the',
     $      ' initially permitted',/5x,'range for reactivation to',
     $      ' allow precipitation according to',/5x,'a rate law.',/)
          endif
        endif
      enddo
c
      if (jexrtx .gt. 0) then
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate an event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) then
          ier = 0
          go to 150
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for reactants that have affinities or reaction rates which
c     are about to change sign. Here jscat is the number of reactants
c     with affinities about to undergo a sign change, and jscrt is
c     the number with rates about to undergo a sign change. Note that
c     a reactant with an affinity undergoing a sign change may not have
c     reaction rate undergoing a sign change, as the rate may be
c     truncated to zero for a given sign of the affinity. Also, even
c     if theoretically both the affinity and the rate should undergo
c     a sign change simultaneously, the testing tolerances may be such
c     that a sign change for only one or the other condition is caught
c     and reported.
c
      jscat = 0
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
          if (nrk(2,nrc) .ne. 0) then
            if (afrc0(nrc).gt.tolsar .and. afrc1(nrc).le.tolsar) then
              jscat = jscat + 1
              jsca(jscat) = nrc
            elseif (afrc0(nrc).lt.-tolsar .and. afrc1(nrc).ge.-tolsar)
     $        then
              jscat = jscat + 1
              jsca(jscat) = nrc
            endif
          endif
        endif
      enddo
c
      jscrt = 0
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
          if (nrk(2,nrc) .ne. 0) then
            if (rrelr0(nrc).gt.tolsrr .and. rrelr1(nrc).le.tolsrr) then
              jscrt = jscrt + 1
              jscr(jscrt) = nrc
            elseif (rrelr0(nrc).lt.-tolsrr .and. rrelr1(nrc).ge.-tolsrr)
     $        then
              jscrt = jscrt + 1
              jscr(jscrt) = nrc
            endif
          endif
        endif
      enddo
c
c     Check for oversteps. The finite-difference based searches do
c     not guarantee sufficient accuracy.
c
      jscatx = 0
      do j = 1,jscat
        nrc = jsca(j)
        if (abs(afrc1(nrc)) .gt. tolsar) then
          jscatx = jscatx + 1
          if (iodb(1) .gt. 0) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1580) ureac(nrc)(1:j2),afrc1(nrc)
 1580       format(/3x,'The affinity of reactant ',a,' is ',1pe11.4,
     $      ' kcal. This is',/5x,'too much of an overstep past the',
     $      ' point at which the affinity of this',/5x,'reactant',
     $      ' changes sign.',/)
          endif
        endif
      enddo
c
      jscrtx = 0
      do j = 1,jscrt
        nrc = jscr(j)
        if (abs(rrelr1(nrc)) .gt. tolsrr) then
          jscrtx = jscrtx + 1
          if (iodb(1) .gt. 0) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1590) ureac(nrc)(1:j2),rrelr1(nrc)
 1590       format(/3x,'The relative rate of reactant ',a,' is ',
     $      1pe11.4,'. This is',/5x,'too much of an overstep past the',
     $      ' point at which the relative rate of',/5x,'this',
     $      ' reactant changes sign.',/)
          endif
        endif
      enddo
c
      if (jscatx.gt.0 .or. jscrtx.gt.0) then
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate an event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) then
          ier = 0
          go to 150
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  300 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for oversteps of the pH, Eh, log fO2, or aw with respect to
c     currently defined print point values.
c
      call cophpr(actw,aw0prn,aw1prn,delxi,dlxmin,eh,eh0prn,
     $ eh1prn,fo2lg,iodb,nodbmx,noutpt,o20prn,o21prn,ph,ph0prn,
     $ ph1prn,qadjdx,qredox,tolxsu)
      if (qadjdx) then
        ier = 0
        go to 150
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for oversteps of the pH, Eh, log fO2, or aw with respect to
c     currently defined plot point values.
c
      call cophpl(actw,aw0plo,aw1plo,delxi,dlxmin,eh,eh0plo,
     $ eh1plo,fo2lg,iodb,nodbmx,noutpt,o20plo,o21plo,ph,ph0plo,
     $ ph1plo,qadjdx,qredox,tolxsu)
      if (qadjdx) then
        ier = 0
        go to 150
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for oversteps of the pH, Eh, log fO2, or aw with respect to
c     requested minimum and maximum values.
c
      call cophlm(actw,awmax,awmin,delxi,dlxmin,eh,ehmax,
     $ ehmin,fo2lg,iodb,nodbmx,noutpt,o2max,o2min,ph,phmax,phmin,
     $ qadjdx,qredox,tolxsu)
      if (qadjdx) then
        ier = 0
        go to 150
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the iemop, emop, iemos, emos, etc., arrays.
c
      if (qmod) then
c
c       The ES phase assemblage has changed. Re-set the index arrays
c       associated with finite-difference description of the numbers of
c       mole of phases and species in the Equilibrium System (ES).
c
        call iiemop(iemop,iemos,iindx1,ipndx1,jsflag,kdim,kmax,
     $  ncmpe,ncmpr,noutpt,npet,npetmx,npt,nptmax,nset,nsetmx,nstmax,
     $  nttyo,uaqsln,uspec,uphase)
      endif
c
c     Update the numbers of moles variables for phases present in
c     the ES.
c
      do npe = 1,npet
        np = iemop(npe)
        emop(npe) = moph(np)
        nr1 = ncmpe(1,npe)
        nr2 = ncmpe(2,npe)
        do nse = nr1,nr2
          ns = iemos(nse)
          emos(nse) = mosp(ns)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recalculate the total affinity (aft1).
c
      call caft1(afrc1,aft1,nrct,nrctmx,rrelr1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write entertainment for the user, showing the progress
c     of the current run.
c
      call wrentu(actw,eh,fo2lg,iopg,iopt,kstep,nopgmx,noptmx,
     $ nttyo,ph,qredox,time1,xi1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qprntx = (xi1 + eps100) .ge. xiprnt
      qprntt = (time1 + eps100) .ge. tiprnt
      qprnlx = (xi1 + eps100) .ge. xiprnl
      qprnlt = (time1 + eps100) .ge. tiprnl
c
      qprph0 = abs(ph - ph0prn) .le. tolxsu
      qprph1 = abs(ph - ph1prn) .le. tolxsu
      qpreh0 = abs(eh - eh0prn) .le. tolxsu
      qpreh1 = abs(eh - eh1prn) .le. tolxsu
      qpro20 = abs(fo2lg - o20prn) .le. tolxsu
      qpro21 = abs(fo2lg - o21prn) .le. tolxsu
      qpraw0 = abs(actw - aw0prn) .le. tolxsu
      qpraw1 = abs(actw - aw1prn) .le. tolxsu
c
      qzprnt = qprntx .or. qprntt .or. qprnlx .or. qprnlt .or.
     $ qprph0 .or. qprph1 .or. qpreh0 .or. qpreh1 .or.
     $ qpro20 .or. qpro21 .or. qpraw0 .or. qpraw1 .or.
     $ kstppr.ge.ksppmx
c
      qplotx = (delxi + eps100) .ge. (xiplot - xi0)
      qplott = (deltim + eps100) .ge. (tiplot - time0)
      qplolx = (delxi + eps100) .ge. (xiplol - xi0)
      qplolt = (deltim + eps100) .ge. (tiplol - time0)
c
      qplph0 = abs(ph - ph0plo) .le. tolxsu
      qplph1 = abs(ph - ph1plo) .le. tolxsu
      qpleh0 = abs(eh - eh0plo) .le. tolxsu
      qpleh1 = abs(eh - eh1plo) .le. tolxsu
      qplo20 = abs(fo2lg - o20plo) .le. tolxsu
      qplo21 = abs(fo2lg - o21plo) .le. tolxsu
      qplaw0 = abs(actw - aw0plo) .le. tolxsu
      qplaw1 = abs(actw - aw1plo) .le. tolxsu
c
      qzplot = qplotx .or. qplott .or. qplolx .or. qplolt .or.
     $ qplph0 .or. qplph1 .or. qpleh0 .or. qpleh1 .or.
     $ qplo20 .or. qplo21 .or. qplaw0 .or. qplaw1 .or.
     $ kstppl.ge.ksplmx
c
      qzdump = (xi1 + eps100) .ge. xidump
c
      if (qzdump) qdump = .true.
      if (qrapch .and. .not.qmod .and. .not.qbye) kly = max(kly,6)
c
c     Check to see which variable is changing most rapidly.
c
      if (qmod .or. qbye) then
        write (noutpt,1900) kstep,iter,ncorr
 1900   format(' Steps completed= ',i5,', iter= ',i3,', ncorr= ',i1)
      else
        inmax = 0
        kzmax = 0
        adlzlg = 0.
        do kcol = 1,kdim
          adel = abs(zvclg1(kcol) - zvclg0(kcol))
          if (adel .gt. adlzlg) then
            inmax = iindx1(kcol)
            kzmax = kcol
            adlzlg = adel
          endif
        enddo
        adlzlg = 0.
        if (kzmax .le. 0) then
          write (noutpt,1900) kstep,iter,ncorr
        else
          adlzlg = zvclg1(kzmax)
          ustr24 = 'Error'
          if (kzmax .le. kbt) then
            ns = nbasp(inmax)
            ustr24 = uspec(ns)
          elseif (kzmax .le. kxt) then
            ustr24 = uspec(inmax)
          endif
          j2 = ilnobl(ustr24)
          write (noutpt,1910) kstep,iter,ncorr,ustr24(1:j2),adlzlg
 1910     format(' Steps completed= ',i5,', iter= ',i3,', ncorr= ',i1,
     $     /' Most rapidly changing is zvclg1(',a,')= ',f11.4)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check gases for which the fugacity is supposed to be fixed.
c
      iwnffg = 0
      do n = 1,nffg
        ng = jffg(n)
        xlf = xlkffg(n)
        xf = texp(xlf)
        dx = fugalg(ng) - xlkffg(n)
        if (abs(dx) .gt. toldl) then
          if (iwnffg .le. 0) nwnffg = nwnffg + 1
          iwnffg = iwnffg + 1
          if (nwnffg .le. nlwffg) then
            j2 = ilnobl(uffg(n))
            write (noutpt,2000) uffg(n)(1:j2),fugac(ng),xf,xi1
            write (nttyo,2000) uffg(n)(1:j2),fugac(ng),xf,xi1
 2000       format(/' * Warning - (EQ6/path) The fugacity of ',a,
     $      /7x,'is now ',1pg12.5,' bars. It is supposed to be fixed',
     $      /7x,'at ',e12.5,' bars. At the present value of reaction',
     $      /7x,'progress (Xi= ',e12.5,'), there is no longer a',
     $      /7x,'sufficient mass of the gas component in the system',
     $      /7x,'to "saturate" it at the desired fugacity value. If',
     $      /7x,'you restart the run, you can add such mass using the',
     $      /7x,'moffg parameter on the input file. Add only about',
     $      /7x,'0.5 to 1.0 mole at a time. You can also increase',
     $      /7x,'the amount of gas component present as the run',
     $      /7x,'progresses by specifying the gas as a reactant.')
          endif
        endif
      enddo
      if (nwnffg .eq. nlwffg) then
        write (noutpt,2010)
        write (nttyo,2010)
 2010   format(/' * Warning - (EQ6/path) No more warnings will be',
     $  /7x,'issued regarding gas fugacities not being at desired',
     $  /7x,'fixed values.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test for very little remaining solvent water.
c
      if (wkgh2o .lt. 1.e-10) then
        if (zvec1(1) .lt. zvec0(1)) then
          write (noutpt,2020) wkgh2o,wkgsol
          write (nttyo,2020) wkgh2o,wkgsol
 2020     format(/' * Note - (EQ6/path) The amount of remaining',
     $    ' solvent water',/7x,'is only ',1pe12.5,' kg and is',
     $    ' decreasing with reaction progress.',/7x,'The amount of',
     $    ' remaining aqueous solution is ',e12.5,' kg.',
     $    /7x,'This code is not designed to deal with fully dry',
     $    ' systems. This',/7x,'run will now be terminated.')
          qvlsow = .true.
        endif
      endif
c
      if (wkgh2o .lt. 1.e-8) then
        if (iwdh2o .ge. 0) then
          nwdh2o = nwdh2o + 1
          if (nwdh2o .le. 8) then
            if (zvec1(1) .lt. zvec0(1)) then
              write (noutpt,2030) wkgh2o,wkgsol
              write (nttyo,2030) wkgh2o,wkgsol
 2030         format(/' * Warning - (EQ6/path) The amount of remaining',
     $        ' solvent water',/7x,'is only ',1pe12.5,' kg and is',
     $        ' decreasing with reaction progress.',/7x,'The amount of',
     $        ' remaining aqueous solution is ',e12.5,' kg.',
     $        /7x,'This code is not designed to deal with fully dry',
     $        ' systems. This',/7x,"run can't continue much farther.")
            else
              write (noutpt,2040) wkgh2o,wkgsol
              write (nttyo,2040) wkgh2o,wkgsol
 2040         format(/' * Warning - (EQ6/path) The amount of remaining',
     $        ' solvent water',/7x,'is only ',1pe12.5,' kg. The amount',
     $        ' of remaining aqueous solution',/7x,'is only ',e12.5,
     $        ' kg. This code is not designed to deal with',/7x,
     $        ' fully dry systems. This run is near the limit of the',
     $        " code's capability.")
            endif
            iwdh2o = -10
          endif
        else
          iwdh2o = iwdh2o + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test for very high ionic strength.
c
      if (fxi .gt. 100.) then
        write (ux16,'(f10.3)') fxi
        call lejust(ux16)
        j2 = ilnobl(ux16)
        write (noutpt,2050) ux16(1:j2)
        write (nttyo,2050) ux16(1:j2)
 2050   format(/' * Note - (EQ6/path) The ionic strength is ',a,
     $  ' molal.',/7x,'This run will now be terminated.')
        qvhfxi = .true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do automatic basis switching. Optimize the basis set so that
c     the basis species for each mass balance tends to be the species
c     which dominates that mass balance.
c
      qabswx = .false.
      if (iopt(12).gt.0 .and. kstpab.ge.20) then
c
c       Automatic basis switching after solving at the current point
c       of reaction progress is turned on, and this is the 20th step
c       since the last time the need for this was checked.
c
        call absswb(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $  axhfsx,axlks,axlksx,axvfs,axvfsx,cdrs,cdrtw,cdrsx,cdrw,
     $  csts,dhfs,dvfs,eps100,ibswx,iindx1,iodb,ipch,ipchmx,ipcv,
     $  ipcvmx,jcsort,jflag,jsflag,kbt,kmax,mosp,mtb,narn1,narn2,
     $  narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,
     $  ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,noutpt,nst,
     $  nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,presg,
     $  press,qbassw,qbswx,tempc,uspec,uzvec1,weight,xhfs,xvfs,xlks)
c
        if (nswtch .gt. 0) then
c
c         Set a flag noting that automatic basis switching has just
c         been done.
c
          qabswx = .true.
c
          write (noutpt,2100) nswtch
 2100     format(/' ',i2,' basis switches were executed automatically',
     $    ' after solving',/'at the current value of reaction',
     $    ' progress.')
        endif
c
c       Reset the step counter which contains the number of steps since
c       the last time a check was made of the need for automatic basis
c       switching of this kind.
c
        kstpab = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the order parameters.
c
      nordsv = nord
      kordsv = kord
c
c     Check to see if it is necessary to drop the order of the
c     Taylor's series to zero because a point has been reached
c     at which the derivatives of the variables being described
c     by finite differences are not continuous.
c
      if (qmod .or. qbye .or. qabswx .or. iexrt.gt.0 .or.
     $  jexrt.gt.0 .or. jscat.gt.0 .or. jscrt.gt.0 .or.
     $  qtrch .or. qreq) then
c
c       Drop the order of the Taylor's series to zero. Zero all
c       finite-difference and derivative data.
c
        if (iopt(1) .eq. 2) then
c
c         Set flags for dump and to control special print for
c         the case of the fluid-centered flow-through open system.
c
          qdump = .true.
          qdmpr1 = .true.
          qdmpr2 = .true.
        endif
c
        xilim = prcinf
        delxi = dlxmx0
        npts = 0
c
        call initaz(dxsm00,nrd1mx)
        call initaz(dxsm10,nrd1mx)
        call initaz(dxsm11,nrd1mx)
c
        nmax = nrd1mx*kmax
        call initaz(dzvc0,nmax)
        call initaz(dzvc0s,nmax)
        call initaz(fdzv0,nmax)
        call initaz(fdzvm1,nmax)
c
        call initaz(fdri0,nrd1mx)
        call initaz(fdrim1,nrd1mx)
        call initaz(drir0,nrd1mx)
        call initaz(drir0s,nrd1mx)
c
        nmax = nordmx*nrctmx
        call initaz(fdar0,nmax)
        call initaz(fdarm1,nmax)
        call initaz(dafrc0,nmax)
c
        nmax = nrd1mx*nrctmx
        call initaz(fdrr0,nmax)
        call initaz(fdrrm1,nmax)
        call initaz(drer0,nmax)
        call initaz(drer0s,nmax)
      endif
c
      npts = npts + 1
      kord = npts - 1 - ndelay
      kord = min(kord,kordlm)
      kord = max(0,kord)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that the reaction path is not constant.
c
      qconst = .false.
      if (qcntmp .and. qcnpre) then
        if (nrct .gt. 0) then
          do nrc = 1,nrct
            if (rrelr1(nrc) .ne. 0.) go to 330
          enddo
        endif
        qconst = .true.
      endif
  330 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .le. 0) then
c
c       If the temperature and pressure are constant, check to see if
c       the total affinity is repeatedly nearly zero.
c
        if (qcntmp .and. qcnpre) then
          if (aft1 .le. tolsar) then
            naft1 = naft1 + 1
            qaft1 = naft1 .ge. 20
          else
            naft1 = 0
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
        if (qshoot) then
          jscat = 0
          jscrt = 0
        else
c
c         Check to see if the code is just making small oscillations
c         about the final equilibrium point.
c
          if (nord .le. 0) then
            if (aft1.gt.aft0 .and. aftm1.gt.aft0) then
              kaft1 = kaft1 + 1
              if (aft1 .le. 0.001) then
                jscat = 0
                jscrt = 0
              endif
            elseif (aft1.lt.aft0 .and. aftm1.lt.aft0) then
              kaft1 = kaft1 + 1
              if (aft1 .le. 0.001) then
                jscat = 0
                jscrt = 0
              endif
            else
              kaft1 = 0
            endif
          else
            kaft1 = 0
          endif
          if (kaft1 .ge. 6) then
            if (aft1 .le. 0.001) then
c
c             The total affinity is oscillating about some finite
c             value close to zero.
c
              time1 = min(timemx,tiprnt,tiprnl,tiplot,tiplol)
              deltim = time1 - time0
              qshoot = .true.
              qprntt = (time1 + eps100) .ge. tiprnt
              qprnlt = (time1 + eps100) .ge. tiprnl
              qzprnt = qzprnt .or. qprntt .or. qprnlt
              qplott = (time1 + eps100) .ge. tiplot
              qplolt = (time1 + eps100) .ge. tiplol
              qzplot = qzplot .or. qplott .or. qplolt
            endif
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If doing a fluid-centered flow-through system mode run, check
c     to see if a "short" print description is required after a transfer
c     to the PRS.
c
      if (iopt(1).eq.2 .and. nord.gt.0)
     $ qftpr2 = .not.qdmpr1 .and. qdmpr2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine if a print and/or plot of the system should
c     be made at the current point of reaction progress.
c
      if (xi1 .ge. ximax) go to 340
      if (iopt(2) .gt. 0) then
        if (time1 .ge. ((1. - tolxst)*timemx)) go to 340
      endif
      if (ph .le. (phmin + tolxsu)) go to 340
      if (ph .ge. (phmax - tolxsu)) go to 340
      if (qredox) then
        if (eh .le. (ehmin + tolxsu)) go to 340
        if (eh .ge. (ehmax - tolxsu)) go to 340
        if (fo2lg .le. (o2min + tolxsu)) go to 340
        if (fo2lg .ge. (o2max - tolxsu)) go to 340
      endif
      if (actw .le. (awmin + tolxsu)) go to 340
      if (actw .ge. (awmax - tolxsu)) go to 340
      if (kstep .ge. kstpmx) go to 340
c
      if (qstopx) go to 340
      if (iexrt.gt.0 .or. jexrt.gt.0) go to 340
      if (jscat.gt.0 .or. jscrt.gt.0) go to 340
      if (qconst .or. qmod .or. qbye .or. qreq .or. qtrch) go to 340
      if (qaft1) go to 340
      if (qvlsow .or. qvhfxi) go to 340
c
      if (qzprnt .or. qftpr2 .or. qdump) go to 350
c
      if (qzplot) go to 360
c
c     Set upper limits on the scale factor for the next step. Here
c     kly is a delay factor that comes into play when the step size
c     has been cut recently in connection with a search.
c
      scalim = 10.
      if (kly .gt. 0) scalim = 2.0
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  340 kly = 0
      if (qftpr2) qdmpr2 = .false.
      qftpr2 = .false.
c
  350 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute apparent "whole-phase" equivalent fractions and mole
c     fractions of the exchange ions present in generic ion exchanger
c     phases. Cations and anions are treated separately in these
c     calculations.
c
      call gegexw(cegexs,egexpc,egexpa,egexw,iern1,iern2,
     $ ietmax,jern1,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $ mosp,netmax,ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,
     $ xgexw,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute various secondary parameters at the current point of
c     reaction progress.
c
      call cdappl(acflg,acfw,acfwlg,actlg,actw,actwlg,adwipp,
     $ afcnst,affpd,affsd,ah,ahrc,alk,alk1,alk2,alki,atwt,bdwipp,
     $ cdrsd,cess,conc,csts,ctb,cteaq,dvoso,dwoso,eh,ehfac,ehrc,
     $ eps100,farad,fdpe0,fdse0,fjest,fo2lg,fo2lrc,fxist,iaqsln,
     $ iemop0,iemos0,iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,
     $ imrn2,iopt,ixrn1,ixrn2,jcode,jcsort,jern1,jflag,jflagd,
     $ jgext,jpflag,jsflag,jssort,modr,moph,mophg,mophj,mopht,morr,
     $ mosp,mospg,mospj,mospt,mprph,mprsp,mrgers,mrmlra,mtb,
     $ mtbaq,mte,mteaq,mwtges,mwtrc,mwtsp,narn1,narn2,nat,nbasp,
     $ nbaspd,nbt,nchlor,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,
     $ nern1,nern2,nert,ness,nessr,net,nfrn1,nfrn2,ngext,ngrn1,
     $ ngrn2,ngt,nhydr,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,no2gaq,
     $ npchk,npet,npet0,npt,npts,nrct,nrndex,nst,nsts,nstsr,ntf1,
     $ ntf1t,ntf2,ntf2t,nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,
     $ omega,pe,perc,ph,phmes,ppmwb,ppmwe,qriinf,qxknph,rreacn,
     $ rreac1,rxbar,sfcar,sidrsp,sidrph,sigmam,sigmst,tdays,tempc,
     $ tf1,tf2,thours,time1,tmins,tyears,uphase,uspec,vodrt,voph,
     $ vophg,vophj,vopht,vosoct,vosp,vospg,vospj,vospt,vosp0,
     $ vreac,wfh2o,wkgwi,wodr,wodrt,woph,wophg,wophj,wopht,
     $ worr,worrt,wosoct,wosp,wospg,wospj,wospt,xbar,xlke,
     $ xlksd,zchcu6,zchsq2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a description of the system at the current point of
c     reaction progress.
c
      call scripz(abar,acflg,acfw,acfwlg,actlg,actw,actwlg,
     $ affpd,affsd,afrc1,aft1,ah,ahmes,ahnbs,ahrc,alki,alk1,
     $ alk2,awmax,awmin,a3bar,cbsr,cdrsd,cegexs,cesr,conc,conclg,csts,
     $ ctb,cteaq,dvoso,dwoso,egers,egexjc,egexjf,egexpa,egexpc,egexs,
     $ egexw,eh,ehmax,ehmes,ehmin,ehnbs,ehrc,elecsr,electr,fje,fjest,
     $ fo2,fo2lg,fo2lrc,fugac,fugalg,fxi,fxist,iaqsln,iemop,iemop0,
     $ iemos,iemos0,iern1,iern2,iexr,iexrt,ifrn1,ifrn2,ilrn1,ilrn2,
     $ imech,imrn1,imrn2,iopg,iopr,iopt,ipndx1,ixrn1,ixrn2,jcode,jcsort,
     $ jern1,jern2,jexr,jexrt,jflag,jflagd,jflgi,jgext,jgsort,jpflag,
     $ jreac,jsca,jscat,jscr,jscrt,jsflag,jsol,jssort,kbt,kern1,kern2,
     $ kgexsa,km1,kmt,kx1,kxt,kstep,kstpmx,loph,losp,mlmrra,modr,
     $ moph,mophg,mophj,mopht,morr,mosp,mospg,mospj,mospt,mprph,
     $ mprsp,mrgers,mrmlra,mwtrc,mwtsp,narn1,narn2,nat,nbasp,nbaspd,
     $ nbt,ncmpe,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,nern1,nern2,
     $ nert,net,nfrn1,nfrn2,ngext,ngexsa,ngrn1,ngrn2,ngt,nhydr,nhydx,
     $ nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,noutpt,no2gaq,npet,npet0,
     $ npt,npts,nrct,nrdxsp,nrk,nrndex,nst,nsts,nstsr,ntf1t,ntf2t,
     $ nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,omega,o2max,o2min,pch,pe,
     $ pemes,penbs,perc,ph,phcl,phmax,phmes,phmin,phnbs,ppmwe,presg,
     $ press,qaft1,qftpr2,qmod,qphcl,qredox,qrho,qriinf,qstopx,qvhfxi,
     $ qvlsow,qzprnt,rho,rhoc,rhowc,rk,rreacn,rreac1,rrelr1,rxbar,
     $ sfcar,sidrph,sidrsp,sigmst,sigmam,ssfcar,tdays,tdsglw,tdspkc,
     $ tdsplc,tempc,thours,time1,timemx,tmins,tolsat,tolxsf,tolxst,
     $ tolxsu,tyears,uelem,ugermo,ugexj,ugexmo,uphase,ureac,uspec,
     $ uxtype,vodrt,voph,vophg,vophj,vopht,vosoct,vosol,vosp,vospg,
     $ vospj,vospt,vreac,wfh2o,wftds,wkgwi,woh2o,wodr,wodrt,woph,
     $ wophg,wophj,wopht,worr,worrt,wosoct,wosol,wosp,wospg,wospj,
     $ wospt,wotds,xbar,xbarlg,xbarw,xbrwlg,xgers,xgexw,xi1,xidump,
     $ ximax,xistsv,xirct,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write results at the current point of reaction progress on the
c     tabx file. This file is used to create the plot file tab.
c
 355  continue
      if (ximax.gt.xistsv .and. iopt(18).ge.0) then
        if (qtatxt) then
c
c         The TAB file is an ordinary text file.
c
          call wrtabx(actlg,afrc1,aft1,alk,cteaq,dvoso,dwoso,
     $    eh,fo2lg,iindx1,iktmax,iopt,ipndx1,kmax,km1,kmt,kstep,kx1,
     $    kxt,loph,ncmpr,modr,mopht,narn1,mosp,nct,nctmax,noptmx,
     $    nptmax,nrct,nrctmx,nstmax,ntabx,ntidmx,ntitl2,ntitld,ntitmx,
     $    nxtmax,pe,ph,ppmwe,prcinf,press,prminf,qbye,qmod,qriinf,
     $    tempc,time1,uelem,uphase,uplatm,ureac,uspec,usteq6,utitl2,
     $    utitld,uveeq6,vodrt,vosoct,wodrt,woh2o,wosoct,xbar,xi1)
        else
c
c         The TAB file is a .csv file.
c
          call wrtabc(acflg,actlg,actw,afrc1,aft1,alk,conclg,
     $    cteaq,ctb,dvoso,dwoso,eh,fje,fo2lg,fugac,fxi,iktmax,iopt,
     $    jflag,jsflag,kmax,kstep,kx1,kxt,mrmlra,modr,mosp,mospt,
     $    moph,mopht,narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ncmpr,nct,
     $    nctmax,nelect,ngrn1,ngrn2,ngtmax,nhydr,nhydx,nllnmx,
     $    no2gaq,noptmx,noutpt,npt,nptmax,nrct,nrctmx,nstmax,ntabx,
     $    ntidmx,ntitl2,ntitld,ntitmx,nttyo,nxrn1,nxrn2,nxtmax,pe,ph,
     $    phmes,ppmwb,ppmwe,prcinf,press,prminf,qrho,qriinf,rho,rhowc,
     $    sidrph,sigmam,tdsgks,tdsglw,tempc,time1,uelem,ulinex,
     $    uphase,uplatm,ureac,uspec,usteq6,utitl2,utitld,uveeq6,
     $    vodrt,vosoct,wkgh2o,wodrt,wosoct,xbar,xbarlg,xi1)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(16) .ge. 0) then
c
c       Prepare to write results at the current point to the
c       backup file.
c
        call setpk6(actwlg,awmax,awmaxi,awmin,awmini,eh,ehmax,
     $  ehmaxi,ehmin,ehmini,fo2lg,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $  kprs,mprph,mprphi,mprsp,mprspi,mtb,mtbi,mtbaq,mtbaqi,nbasp,
     $  nbaspd,nbaspi,nbti,nbtmax,ncmpr,nobswt,noutpt,nprpmx,nprpti,
     $  nprsmx,nprsti,npt,nptmax,nttyo,nstmax,o2max,o2maxi,o2min,
     $  o2mini,ph,phmax,phmaxi,phmin,phmini,prcinf,press,pressi,
     $  tempc,tempci,time1,timemx,timmxi,tistti,ubmtbi,uobsw,uphase,
     $  uprphi,uprspi,uspec,uzveci,uzvec1,xi1,ximax,ximaxi,xistti,
     $  zvclgi,zvclg1)
c
c       Rewind the current backup file (BAKUPA or BAKUPB).
c
        if (iopt(16) .eq. 0) rewind (nbkupn)
c
c       Write results at the current point to the backup file.
c
        if (upkfor(1:1) .eq. 'W') then
c
c         Compact (W) format.
c
c         Calling sequence substitutions:
c           nbkupn for newin
c
          call wr6pkw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,nbkupn,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        else
c
c         Menu-style (D) format.
c
c         Calling sequence substitutions:
c           nbkupn for newin
c
          call wr6pkd(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,nbkupn,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        endif
c
        if (iopt(16) .eq. 0) then
c
c         Switch to write on the other backup file the next time.
c
          if (nbkupn .eq. nbkupa) then
            nbkupn = nbkupb
          elseif (nbkupn .eq. nbkupb) then
            nbkupn = nbkupa
          endif
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qdmpr1 = .false.
      if (qftpr2) qdmpr2 = .false.
      kstppr = 0
c
c     Plot a description of the system at the current point of
c     reaction progress.
c
  360 continue
      kstppl = 0
c 360 if (iplot .ge. 1) then
c
c       Note: grafz has been removed from EQ6. Plotting is now done
c       via the tab file
c
c       call grafz
c       kstppl = 0
c     endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check stop conditions.
c
      call chkstc(actw,awmax,awmin,eh,ehmax,ehmin,fo2lg,iopt,
     $ jreac,kstep,kstpmx,noptmx,noutpt,nrct,nrctmx,nttyo,o2max,o2min,
     $ ph,phmax,phmin,prcinf,qaft1,qcnpre,qcntmp,qconst,qredox,qstop,
     $ qvhfxi,qvlsow,timemx,time1,tolxst,tolxsu,ximax,xi1)
c
      if (qstop .or. qstopx) go to 990
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset print, plot, and PRS transfer points as necessary.
c
      call adprpl(actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,
     $ dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxpll,dlxplo,dlxprl,dlxprn,dlxdmp,
     $ eh,eh0plo,eh0prn,eh1plo,eh1prn,fo2lg,fxprpl,o20plo,o20prn,
     $ o21plo,o21prn,ph,ph0plo,ph0prn,ph1plo,ph1prn,qplaw0,qplaw1,
     $ qpleh0,qpleh1,qplolt,qplolx,qplott,qplotx,qplo20,qplo21,
     $ qplph0,qplph1,qpraw0,qpraw1,qpreh0,qpreh1,qprnlx,qprnlt,
     $ qprntx,qprntt,qpro20,qpro21,qprph0,qprph1,qredox,time1,
     $ tiplol,tiplot,tiprnl,tiprnt,xidump,xiplol,xiplot,xiprnl,
     $ xiprnt,xi1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If shooting to the end, go do the next step.
c
      if (qshoot) then
        nord = 0
        delxi = dlxmin
        go to 100
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Continue the reaction path simulation. If the current point
c     was hit only because of a print or plot requirement, and delxi
c     is very small relative to the preceding step size, the current
c     point is dropped as the base point (the point about which the
c     Taylor's series expansion is made) in favor of the preceding
c     point. This is done to protect the integrity of the finite
c     difference functions, by avoiding the case in which two points
c     are nearly indistinguishable. Here qskip is a logical flag to
c     skip recalculating the finite differences and derivatives.
c
      qreax = iexrt.gt.0 .or. jexrt.gt.0 .or. jscat.gt.0 .or.
     $ jscrt.gt.0 .or. qreq
      qtrch = .false.
      iexrt = 0
      jexrt = 0
      jscat = 0
      jscrt = 0
      qskip = .false.
      if (qzprnt. or. qzplot) then
        if (qdump) go to 100
        if (kord .le. 0) go to 100
        if (delxi .ge. 0.01*(xi0 - xim1)) go to 100
      else
        go to 100
      endif
c
      qskip = .true.
      nord = nordsv
      kord = kordsv
      delxi = max(delxi,dlxisv)
      xi1 = xi0
      time1 = time0
c
      km1 = km10
      kmt = kmt0
      kx1 = kx10
      kxt = kxt0
      kdim = kdim0
c
      call copyaa(zvclg0,zvclg1,kdim)
      call copyaa(zvec0,zvec1,kdim)
c
      do kcol = 1,kdim
        uzvec1(kcol) = uzvec0(kcol)
        iindx1(kcol) = iindx0(kcol)
        ipndx1(kcol) = ipndx0(kcol)
      enddo
c
      if (iopt(2) .gt. 0) then
        rirec1 = rirec0
c
        call copyaa(rreac0,rreac1,nrct)
        call copyaa(rrelr0,rrelr1,nrct)
        call copyaa(sfcar0,sfcar,nrct)
      endif
c
      call copyaa(afrc0,afrc1,nrct)
c
      go to 110
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (kstpmx .le. 0) then
c
c       Normal termination at the initial point.
c
        write (noutpt,2200)
        write (nttyo,2200)
 2200   format(/,' ---  The reaction path terminated normally at',
     $  ' the initial point ---',//)
c
        write (noutpt,2210) xistrt
        write (nttyo,2210) xistrt
 2210   format(7x,'Xi is ',1pe12.5)
c
        write (noutpt,2220) kdim
        write (nttyo,2220) kdim
 2220   format(7x,'The matrix dimension is ',i4,/)
c
        if (iopt(2) .gt. 0) then
          tistrd = tistrt/86400.
          tistry = tistrd/365.25
          write (noutpt,2230) tistrt,tistrd,tistry
          write (nttyo,2230) tistrt,tistrd,tistry
 2230     format(7x,'The time is:',
     $      /14x,1pe12.5,' seconds',
     $      /14x,1pe12.5,' days',
     $      /14x,1pe12.5,' years',/)
          if (qriinf) then
            write (noutpt,2240)
            write (nttyo,2240)
 2240       format(7x,'The system is now indistinguishable from',
     $      /7x,'what it would be at time equals infinity.')
          endif
        endif
      else
c
        if (.not.qstopx) then
c
c         Normal termination of a reaction path calculation.
c
          write (noutpt,2300)
          write (nttyo,2300)
 2300     format(/,' ---  The reaction path has terminated',
     $    ' normally ---',//)
        else
c
c         Early termination of a reaction path calculation.
c
          write (noutpt,2310)
          write (nttyo,2310)
 2310     format(/,' ---  The reaction path has terminated',
     $    ' early ---',//)
        endif
c
        write (noutpt,2320) kstep,xistsv,xi1
        write (nttyo,2320) kstep,xistsv,xi1
 2320   format(7x,i5,' steps were taken',/7x,'Xi increased from ',
     $  /14x,1pe12.5,' to ',1pe12.5)
c
        avdlxi = 0.
        if (kstep .gt. 0) avdlxi = (xi1 - xistsv)/kstep
        iavkdm = nint(avkdim)
        write (noutpt,2330) avdlxi,iavkdm
        write (nttyo,2330) avdlxi,iavkdm
 2330   format(7x,'The average value of delxi was ',1pe12.5,
     $  /7x,'The average matrix dimension was ',i4,/)
c
        if (iopt(2) .gt. 0) then
          tistrd = tistrt/86400.
          tistry = tistrd/365.25
          if (qriinf) then
            write (noutpt,2340) tistrt,tistrd,tistry
            write (nttyo,2340) tistrt,tistrd,tistry
 2340       format(7x,'The time increased from ',
     $      /14x,1pe12.5,' seconds to infinity',
     $      /14x,1pe12.5,' days to infinity',
     $      /14x,1pe12.5,' years to infinity',/)
          else
            tdays = time1/86400.
            tyears = tdays/365.25
            write (noutpt,2350) tistrt,time1,tistrd,tdays,tistry,tyears
            write (nttyo,2350) tistrt,time1,tistrd,tdays,tistry,tyears
 2350       format(7x,'The time increased from ',
     $      /14x,1pe12.5,' to ',1pe12.5,' seconds',
     $      /14x,1pe12.5,' to ',1pe12.5,' days',
     $      /14x,1pe12.5,' to ',1pe12.5,' years',/)
          endif
        endif
      endif
c
      write (ux16a,'(f9.4)') phstrt
      call lejust(ux16a)
      j2 = ilnobl(ux16a)
      write (ux16b,'(f9.4)') ph
      call lejust(ux16b)
      j3 = ilnobl(ux16b)
      if (ph .gt. phstrt) then
        write (noutpt,2360) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2360) ux16a(1:j2),ux16b(1:j3)
 2360   format(7x,'The pH increased from ',a,' to ',a)
      elseif (ph .lt. phstrt) then
        write (noutpt,2362) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2362) ux16a(1:j2),ux16b(1:j3)
 2362   format(7x,'The pH decreased from ',a,' to ',a)
      endif
c
      if (qredox) then
        write (ux16a,'(f9.4)') ehstrt
        call lejust(ux16a)
        j2 = ilnobl(ux16a)
        write (ux16b,'(f9.4)') eh
        call lejust(ux16b)
        j3 = ilnobl(ux16b)
        if (eh .gt. ehstrt) then
          write (noutpt,2370) ux16a(1:j2),ux16b(1:j3)
          write (nttyo,2370) ux16a(1:j2),ux16b(1:j3)
 2370     format(7x,'The Eh increased from ',a,' to ',a,' v')
        elseif (eh .lt. ehstrt) then
          write (noutpt,2372) ux16a(1:j2),ux16b(1:j3)
          write (nttyo,2372) ux16a(1:j2),ux16b(1:j3)
 2372     format(7x,'The Eh decreased from ',a,' to ',a,' v')
        endif
c
        write (ux16a,'(f9.4)') o2strt
        call lejust(ux16a)
        j2 = ilnobl(ux16a)
        write (ux16b,'(f9.4)') fo2lg
        call lejust(ux16b)
        j3 = ilnobl(ux16b)
        if (fo2lg .gt. o2strt) then
          write (noutpt,2380) ux16a(1:j2),ux16b(1:j3)
          write (nttyo,2380) ux16a(1:j2),ux16b(1:j3)
 2380     format(7x,'The log fO2 increased from ',a,' to ',a)
        elseif (eh .lt. ehstrt) then
          write (noutpt,2382) ux16a(1:j2),ux16b(1:j3)
          write (nttyo,2382) ux16a(1:j2),ux16b(1:j3)
 2382     format(7x,'The log fO2 decreased from ',a,' to ',a)
        endif
      endif
c
      write (ux16a,'(f9.4)') awstrt
      call lejust(ux16a)
      j2 = ilnobl(ux16a)
      write (ux16b,'(f9.4)') actw
      call lejust(ux16b)
      j3 = ilnobl(ux16b)
      if (actw .gt. awstrt) then
        write (noutpt,2390) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2390) ux16a(1:j2),ux16b(1:j3)
 2390   format(7x,'The aw increased from ',a,' to ',a)
      elseif (actw .lt. awstrt) then
        write (noutpt,2392) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2392) ux16a(1:j2),ux16b(1:j3)
 2392   format(7x,'The aw decreased from ',a,' to ',a)
      endif
c
      write (ux16a,'(1pg12.5)') wwstrt
      call lejust(ux16a)
      j2 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') wkgh2o
      call lejust(ux16b)
      j3 = ilnobl(ux16b)
      if (wkgh2o .gt. wwstrt) then
        write (noutpt,2394) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2394) ux16a(1:j2),ux16b(1:j3)
 2394   format(7x,'The mass of solvent water increased from ',a,
     $  ' to ',a,' kg')
      elseif (wkgh2o .lt. wwstrt) then
        write (noutpt,2396) ux16a(1:j2),ux16b(1:j3)
        write (nttyo,2396) ux16a(1:j2),ux16b(1:j3)
 2396   format(7x,'The mass of solvent water decreased from ',a,
     $  ' to ',a,' kg')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.qstopx) then
        if (iopt(7).gt.0 .and. iopt(1).ne.2) then
c
c         Clear ES solids at the end of the run, unless the run
c         terminated early due to calculational problems.
c         Fictive fugacity-fixing minerals are not cleared.
c
          write (noutpt,2400)
          write (nttyo,2400)
 2400     format(/' * Note (EQ6/path) Clearing equilibrium system',
     $    ' (ES) solids',/7x,'at the end of the run.')
c
          call clress(csts,iindx1,ipndx1,jpflag,jsflag,kdim,kmax,
     $    km1,kmt,kx1,kxt,loph,losp,moph,mosp,mtb,mtbaq,nbt,nbtmax,
     $    nptmax,nstmax,nsts,nstsmx,nstsr,ufixf,uzvec1,zvec1,zvclg1)
        endif
c
        if (iopt(10) .gt. 0) then
c
c         Clear PRS solids at the end of the run, unless the run
c         terminated early due to calculational problems.
c
          write (noutpt,2410)
          write (nttyo,2410)
 2410     format(/' * Note (EQ6/path) Clearing physically removed',
     $    ' system (PRS) solids',/7x,'at the end of the run.')
          call initaz(mprsp,nstmax)
          call initaz(mprph,nptmax)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nprob .le. 1) then
c
c       Calculate data to describe the aqueous solution in the first
c       problem on the input file as a special reactant. This defines
c       the so-called "Fluid 2" to be described on the EQ6 pickup
c       file under the iopt(20) = 1 option.
c
        ureac1 = 'Fluid 2'
c
c       Scale the composition and reaction so that one "mole" of the
c       fluid contains 1 kg of solvent water.
c
        morrw1 = mosp(narn1)/omega
        wx = 1./morrw1
c
        do nc = 1,nct
          n = nc
          uesr1(n) = uelem(nc)
          cesr1(n) = wx*mteaq(nc)
        enddo
        iesrt1 = nct
c
        n = 1
        ubsr1(n) = ureac1
        cbsr1(n) = -1.0
        do nb = 1,nbt
          ns = nbaspd(nb)
          if (jflag(ns) .lt. 30) then
            n = n + 1
            ubsr1(n) = uspec(ns)
            cbsr1(n) = wx*mtbaq(nb)
          endif
        enddo
        ibsrt1 = n
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(17) .ge. 0) then
c
c       Prepare to write results at the final point to the
c       pickup file.
c
        call setpk6(actwlg,awmax,awmaxi,awmin,awmini,eh,ehmax,
     $  ehmaxi,ehmin,ehmini,fo2lg,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $  kprs,mprph,mprphi,mprsp,mprspi,mtb,mtbi,mtbaq,mtbaqi,nbasp,
     $  nbaspd,nbaspi,nbti,nbtmax,ncmpr,nobswt,noutpt,nprpmx,nprpti,
     $  nprsmx,nprsti,npt,nptmax,nttyo,nstmax,o2max,o2maxi,o2min,
     $  o2mini,ph,phmax,phmaxi,phmin,phmini,prcinf,press,pressi,
     $  tempc,tempci,time1,timemx,timmxi,tistti,ubmtbi,uobsw,uphase,
     $  uprphi,uprspi,uspec,uzveci,uzvec1,xi1,ximax,ximaxi,xistti,
     $  zvclgi,zvclg1)
c
        if (iopt(20) .gt. 0) then
c
c         Prepare to write an advanced EQ6 pickup file. There is
c         currently only one option. It is determined by the iopt(20)
c         option switch. See comments in EQ6/stpkmd.f.
c
          call stpkmd(cbsri,cbsr1,cdac,cesri,cesr1,csigma,eact,
     $    fkrc,hact,iact,ibsrti,ibsrt1,iesrti,iesrt1,iktmax,imchmx,
     $    imech,iopt,ixrti,jcode,jreac,modr,morr,morrw1,nbt1mx,nctmax,
     $    ndact,ndctmx,noptmx,noutpt,nprob,nrct,nrctmx,nrk,nsk,nsrt,
     $    nsrtmx,ntitl1,ntitmx,nttyo,nxrt,nxrtmx,rkb,rxbari,sfcar,
     $    ssfcar,trkb,ubsri,ubsr1,ucxri,udac,uesri,uesr1,ureac,ureac1,
     $    utitl1,vreac)
        endif
c
c       Write results at the final point to the pickup file.
c
        if (upkfor(1:1) .eq. 'W') then
c
          call wr6pkw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        else
c
c         Menu-style (D) format.
c
          call wr6pkd(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine setup(coval,eh,ehfac,ier,irdxc3,itdsf3,jflag,mwtsp,
     $ narn1,nbaspd,nbt,nbtmax,noutpt,nstmax,nttyo,pe,rho,tdspkg,
     $ tdspl,uspec)
c
c     This subroutine converts input coval data which are not on the
c     molal concentration scale to that scale.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),nbaspd(nbtmax)
c
      integer ier,irdxc3,itdsf3,narn1,nbt
c
      character(len=48) uspec(nstmax)
c
      real(8) coval(nbtmax),mwtsp(nstmax)
c
      real(8) eh,ehfac,pe,rho,tdspkg,tdspl
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jfl,jlen,nb,ns
c
      character(len=56) uspn56
c
      real(8) wfh2o
c
c-----------------------------------------------------------------------
c
      ier = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (itdsf3 .ge. 1) tdspkg = tdspl/rho
      wfh2o = (1000. - 0.001*tdspkg)/1000.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (irdxc3 .eq. -2) then
c
c       Convert input pe to Eh.
c
        eh = pe*ehfac
        irdxc3 = -1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nb = 1,nbt
        ns = nbaspd(nb)
        jfl = jflag(ns)
        if (ns .eq. narn1) go to 100
        if (jfl .eq. 0) go to 100
        if (jfl .eq. 30) go to 100
        if (jfl .eq. 7) go to 100
        if (jfl.eq.16 .or. jfl.eq.17 .or. jfl.eq.18) go to 100
        if (jfl.eq.19 .or. jfl.eq.20 .or. jfl.eq.21) go to 100
        if (jfl.eq.22 .or. jfl.eq.23) go to 100
        if (jfl.eq.25 .or. jfl.eq.27) go to 100
        if (jfl .eq.- 1) go to 100
c
        if (jfl .eq. 1) then
c
c         Convert molarity to molality.
c
          coval(nb) = coval(nb)/(rho*wfh2o)
          jflag(ns) = 0
        elseif (jfl .eq. 2) then
c
c         Convert mg/L to molality.
c
          coval(nb) = coval(nb)*1.e-3/(mwtsp(ns)*rho*wfh2o)
          jflag(ns) = 0
        elseif (jfl .eq. 3) then
c
c         Convert mg/kg.sol to molality.
c
          coval(nb) = coval(nb)*1.e-3/(mwtsp(ns)*wfh2o)
          jflag(ns) = 0
c
        elseif (jfl .eq. 8) then
c
c         Convert alkalinity in eq/L to eq/kg.H2O.
c
          coval(nb) = coval(nb)/(rho*wfh2o)
          jflag(ns) = 7
        elseif (jfl .eq. 9) then
c
c         Convert alkalinity in eq/kg.sol to eq/kg.H2O.
c
          coval(nb) = coval(nb)/wfh2o
          jflag(ns) = 7
        elseif (jfl .eq. 10) then
c
c         Convert alkalinity in mg/L CaCO3 to eq/kg.H2O.
c
          coval(nb) = coval(nb)/(50000.*rho*wfh2o)
          jflag(ns) = 7
        elseif (jfl .eq. 11) then
c
c         Convert alkalinity in mg/L HCO3- to eq/kg.H2O.
c
          coval(nb) = coval(nb)/(60960*rho*wfh2o)
          jflag(ns) = 7
        else
c
c         No match.
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1000) jfl,uspn56(1:jlen)
          write (nttyo,1000) jfl,uspn56(1:jlen)
 1000     format(/' * Error - (EQ3NR/setup) An undefined jflag value',
     $    ' of ',i3,/7x,'was specified on the input file for the',
     $    ' species',/7x,a,'.')
          ier = 1
        endif
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine lamgex(acflgc,cgexj,jern1,jern2,jetmax,jgext,net,
     $ netmax,nstmax,xbarlg)
c
c     This subroutine computes the activity coefficients of generic ion
c     exchanger species. The exchanger phase is taken to be ideal
c     in the site-mixing sense. The activity (a) and activity coefficent
c     (lambda) are related to the mole fraction (x) as follows:
c
c       log a = N log x + N log lambda
c
c     where N is the site stoichiometric factor. This ensures that the
c     activity in the ideal case is equal to x**N, a treatment that
c     generally works better in hybrid Newton-Raphson iteration than
c     a treatment based on:
c
c       log a = log x + log lambda
c
c     whcih, in the ideal case, requires that:
c
c       log lambda = (N - 1) log x
c
c     The treatment adopted here is also preferable in the the activity
c     coefficient is reserved for treating actual non-ideality, rather
c     than as a correction used to relate two different definitions of
c     ideality.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQ3NR/arrset.f
c       EQ6/exivar.f
c       EQ6/raff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cgexj  = array of site stoichiometry factors for site of generic
c                  ion exchange phases
c       jern1  = array giving the start of the range in the species
c                  list corresponding to species in the je-th site
c                  of the ne-th exchanger.
c       jern2  = array giving the end of the range in the species
c                  list corresponding to species in the je-th site
c                  of the ne-th exchanger.
c       jgext  = array giving the number of exchange sites in each of
c                  the ion exchange phases
c       xbarlg = array of mole fractions of species
c
c      Principal output:
c
c       acflgc = array of log activity coefficient values
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jetmax,netmax,nstmax
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax)
c
      integer net
c
      real*8 acflgc(nstmax),cgexj(jetmax,netmax),xbarlg(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer je,ne,nr1,nr2,ns
c
c-----------------------------------------------------------------------
c
c     Compute log lambda for generic exchanger species.
c
      do ne = 1,net
        do je = 1,jgext(ne)
          nr1 = jern1(je,ne)
          nr2 = jern2(je,ne)
          do ns = nr1,nr2
            acflgc(ns) = 0.
          enddo
        enddo
      enddo
c
      end

      subroutine setffg(csts,iindx1,iffg,ipndx1,jpflag,jsflag,kbt,
     $ kdim,kmax,km1,kmt,kx1,kxt,losp,moffg,mtb,mtbaq,nbaspd,nbt,
     $ nbtmax,ncmpr,nffg,nffgmx,noutpt,nphasx,npt,nptmax,nstmax,
     $ nsts,nstsmx,nstsr,nttyo,qloffg,uffg,uspec,uzvec1,zvclg1,zvec1)
c
c     This subroutine puts new fictive fugacity-fixing phases into the
c     matrix if the corresponding masses to add to the equilibrium
c     system (ES) are positive. It keep old such phases in if the
c     corresponding net masses are positive. It deletes any fictive
c     fugacity-fixing phases left over from a previous run for which
c     the corresponding fixed fugacity options no longer apply.
c     To carry out this last function, this subroutine must be called
c     even if nffg is zero. If necessary this subroutine recalculates
c     the mass balance totals.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nffgmx,nptmax,nstmax,nstsmx
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),iffg(nffgmx),ipndx1(kmax),jpflag(nptmax),
     $ jsflag(nstmax),nbaspd(nbtmax),ncmpr(2,nptmax),nphasx(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer kbt,kdim,km1,kmt,kx1,kxt,nbt,nffg,npt
c
      logical qloffg
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*24 uffg(nffgmx)
c
      real*8 csts(nstsmx),losp(nstmax),moffg(nffgmx),mtb(nbtmax),
     $ mtbaq(nbtmax),zvec1(kmax),zvclg1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,j2,kcol,n,nb,nerr,np,ns,nse
c
      integer ilnobl
c
      logical qreclc
c
      real*8 cx,mtbo,mtbx,mx,mz
c
      real*8 coefst,texp,tlg
c
c-----------------------------------------------------------------------
c
      qreclc = qloffg
      nerr = 0
c
      do kcol = km1,kxt
        ns = iindx1(kcol)
        losp(ns) = zvclg1(kcol)
      enddo
c
      do n = 1,nffg
        mx = moffg(n)
        ns = iffg(n)
        np = nphasx(ns)
        if (jpflag(np) .ne. -1) then
c
c         The fixed fugacity phase was not already in the matrix.
c
          losp(ns) = -99999.
          if (mx .gt. 0.) then
            qreclc = .true.
            jpflag(np) = -1
            jsflag(ns) = -1
            losp(ns) = tlg(mx)
          elseif (mx .lt. 0.) then
            j2 = ilnobl(uffg(n))
            write (noutpt,1000) uffg(n)(1:j2)
            write (nttyo,1000) uffg(n)(1:j2)
 1000       format(/' * Error - (EQ6/setffg) The new fixed fugacity',
     $      ' phase',
     $      /7x,a," can't have negative moles added.")
            nerr = nerr + 1
          endif
        elseif (mx .ne. 0.) then
c
c         The fixed fugacity phase was already in the matrix.
c
          qreclc = .true.
          mz = texp(losp(ns))
          mz = mz + mx
          if (mz .gt. 0.) then
            losp(ns) = tlg(mz)
          else
            j2 = ilnobl(uffg(n))
            write (noutpt,1010) uffg(n)(1:j2),mz
            write (nttyo,1010) uffg(n)(1:j2),mz
 1010       format(/' * Error - (EQ6/setffg) The adjusted number of',
     $      /7x,'moles of ',a,' is ',g12.5,'. A negative value is not',
     $      /7x,'permitted.')
            nerr = nerr + 1
          endif
        endif
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.qreclc) go to 200
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following may may combine any of three functions:
c
c       1. Add new fixed fugacity phases to the matrix.
c       2. Delete left over fixed fugacity phases from the matrix.
c       3. Reset the zvec1 and zvclg1 array elements for fixed
c          fugacity phases.
c
      call miidxz(ier,iindx1,ipndx1,jpflag,jsflag,kbt,kdim,
     $ kmax,km1,kmt,kx1,kxt,losp,ncmpr,noutpt,npt,nptmax,nstmax,
     $ nttyo,uspec,uzvec1,zvclg1,zvec1)
c
      if (ier .gt. 0) then
        write (noutpt,1020)
        write (nttyo,1020)
 1020   format(/" * Error - (EQ6/setffg) Can't recover from having",
     $  ' exceeded the maximum ',i4,/7x,'elements of the iindx1',
     $  ' array. Increase the dimensioning parameter kpar.')
        stop
      endif
c
c     Recalculate the mass balance totals. This is done by adding to
c     get the total, not by subtracting from the existing total.
c     This purges the masses of any left over fixed fugacity phases
c     from the mass balance totals and adds any new masses to these
c     totals.
c
      if (nffg .gt. 0) write (noutpt,1030)
 1030 format(//6x,' --- Adding Fictive Fugacity-Fixing Phases to the',
     $ ' ES ---',//13x,'Name',22x,'Moles Added',/)
c
      do n = 1,nffg
        ns = iffg(n)
        write (noutpt,1040) uspec(ns),moffg(n)
 1040   format(11x,a24,3x,1pe12.5)
      enddo
c
      write (noutpt,1050)
 1050 format(//11x,' --- Component Total Numbers of Moles ---',
     $ //35x,'Initial',7x,'Adjusted',/)
c
      do nb = 1,nbt
        nse = nbaspd(nb)
        mtbo = mtb(nb)
        mtbx = mtbaq(nb)
c
        do kcol = km1,kxt
          ns = iindx1(kcol)
          cx = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
          mtbx = mtbx + cx*zvec1(kcol)
        enddo
c
        mtb(nb) = mtbx
        write (noutpt,1060) uspec(nse),mtbo,mtbx
 1060   format(5x,a24,3x,1pe12.5,3x,e12.5)
      enddo
      write (noutpt,1070)
 1070 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  200 continue
c
      do n = 1,nffg
        moffg(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $ xdbval,zdbval)
c
c     This subroutine loads data on the temperature grid from the
c     one-dimensional holding array (xdbval) into the two-dimensional
c     proper data array (represented here by the dummy name zdbval).
c
c     This subroutine is called by:
c
c       EQPT/rdpar.f
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narxt  = array of numbers of coefficients in the temperature
c                  ranges
c       ntprt  = the number of temperature ranges on the standard
c                  temperature grid
c       xdbval = holding array (1-dimensional)
c
c     Principal output:
c
c       nacdpr = array containging the number of actual data points
c                  by range on the "log K" temperature grid; excludes
c                  cases of "no data"
c       zdbval = dummy name for the proper data array (2-dimensional)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ndbmax,ntprmx
c
      integer nacdpr(ntprmx),narxt(ntprmx)
c
      integer ntprt
c
      real*8 xdbval(ndbmax),zdbval(narxmx,ntprmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,k,n,ntpr
c
c-----------------------------------------------------------------------
c
c     Load the data from the xdbval array into the zdbval array.
c     Note that a point which comprises the boundary between two
c     ranges is a member of both ranges.
c
      ntpr = 1
      k = 0
      do n = 1,narxt(1)
        i = n
        zdbval(n,ntpr) = xdbval(i)
        if (xdbval(i) .lt. 9999999.) k = k + 1
      enddo
      nacdpr(ntpr) = k
c
      do ntpr = 2,ntprt
        k = 0
        zdbval(1,ntpr) = xdbval(i)
        if (xdbval(i) .lt. 9999999.) k = k + 1
        do n = 2,narxt(ntpr)
          i = i + 1
          zdbval(n,ntpr) = xdbval(i)
          if (xdbval(i) .lt. 9999999.) k = k + 1
        enddo
        nacdpr(ntpr) = k
      enddo
c
      end

      subroutine chksti(akmat0,drer0,drir0,deltim,delxi,dlxmin,
     $ fdri0,fdrr0,iodb,jreac,kly,kmax,nodbmx,kord,nord,noutpt,
     $ npts,nrct,nrctmx,nrd1mx,nttyo,prcinf,qriinf,rirec0,smp100,
     $ time0,time1,xi0,xi1)
c
c     This subroutine checks the sign of the time increment.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nodbmx,nrctmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),jreac(nrctmx)
c
      integer kly,kord,nord,npts,nrct
c
      logical qriinf
c
      real*8 akmat0(nrd1mx,nrd1mx),drer0(nrd1mx,nrctmx),
     $ drir0(nrd1mx),fdri0(nrd1mx),fdrr0(nrd1mx,nrctmx)
c
      real*8 deltim,delxi,dlxmin,rirec0,prcinf,smp100,time0,time1,
     $ xi0,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 dx,dxsv
c
c-----------------------------------------------------------------------
c
  100 xi1 = xi0 + delxi
      call timeca(deltim,delxi,drir0,iodb,nodbmx,nord,noutpt,
     $ nrd1mx,nttyo,prcinf,qriinf,rirec0,time0,time1)
      if (deltim .le. smp100) then
        dxsv = delxi
        dx = 0.25*delxi
        delxi = max(dx,dlxmin)
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000) deltim
          write (nttyo,1000) deltim
 1000     format(/' * Warning - (EQ6/chksti) The calculated time',
     $    /7x,"increment is ',1pe11.4. This increment can't be zero",
     $    /7x,"or negative, and shouldn't be too close to such a",
     $    /7x,'condition. The finite difference representation of',
     $    /7x,'the inverse rate may be losing accuracy.')
        endif
        if (dxsv .gt. dlxmin) then
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) dxsv,delxi
            write (nttyo,1010) dxsv,delxi
 1010       format(7x,'The step size will be cut from ',1pe11.4,' to ',
     $      1pe11.4,'.')
          endif
        else
          nord = nord - 1
          kord = nord
          npts = nord + 1
          kly = 6
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1020) nord
            write (nttyo,1020) nord
 1020       format(7x,'The step size is already at the  minimum value.',
     $      /7x,'Cutting the order to ',i2,'.')
          endif
          call rderiv(akmat0,drer0,drir0,fdri0,fdrr0,jreac,nord,
     $    nrct,nrctmx,nrd1mx)
        endif
        go to 100
      endif
c
      end

      subroutine ggridp(ipch_asv,ipcv_asv,itgenf,jpdblo,jpfc_asv,
     $ jptffl,narx_asv,ndat0s,ndb_asv,noutpt,ntid_asv,ntpr_asv,
     $ nttyo,q500fl,uakey)
c
c     This suboutine gets the necessary dimensioning parameters for the
c     temperature grid on which thermodynamic data are represented.
c     These parameters are presently embedded in the data file title,
c     in order to maintain maximum forward and backward compatibility
c     of data files between Versions 7 and 8 of EQ3/6. There is
c     compatibility if the temperature grid matches the old "standard"
c     form and if there are no data grids for volume and enthalpy data.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c       uakey  = string identifying the type of aqueous species
c                activity coefficient model ("SEDH" or "Pitzer")
c
c
c     Principal output:
c
c       ipch_asv = the maximum order of pressure corrections to the
c                    enthalpy functions; ipch_asv = min(1,ipch)
c       ipcv_asv = the maximum order of pressure corrections to the
c       itgenf   = temperature grid enforcement parameter:
c                    -1 = do nothing
c                     0 = warn if any sparsely filled ranges in
c                         "log K" temperature grid data
c                     1 = declare error condition if any sparsely
c                           filled ranges in "log K" temperature
c                           grid data
c       jpdblo   = Pitzer data block organization flag; -1 =
c                    "classical", 0 = new
c                    volume functions; ipcv_asv = min(1,ipcv)
c       jpfc_asv = the number of terms in the temperature function
c                    used to represent Pitzer interaction parameters;
c                    must be at least 1
c       jptffl   = integer flag denoting the temperature function
c                    used to represent Pitzer interaction parameters;
c                    -1 = classical truncated Taylor's series,
c                    0 = LLNL5TERM, 1 = Greenberg and Moller (1989)
c                    eight-term equation
c       narx_asv = the maximum number of points in any range of the
c                    temperature grid
c       ntid_asv = the number of lines in the data file title
c       ntpr_asv = the number of temperature ranges on the temperature
c                    grid (ntpr_asv = ntprt)
c       ndb_asv  = the maximum number of distinct points on the
c                    temperature grid;
c                    ndb_asv = ntpr_asv*(narx_asv - 1) + 1
c       q500fl   = logical flag; if .true., treat instances of "500."
c                    in "log K" temperature grids as a "no data"
c                    condition"
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndat0s,noutpt,nttyo
c
      integer ipch_asv,ipcv_asv,jpfc_asv,narx_asv,ndb_asv,ntid_asv,
     $ ntpr_asv
c
      integer itgenf,jpdblo,jptffl
c
      character(len=8) uakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,j2,k,n,narxti,narx_x,ntpr,ntpri
c
      integer ilnobl
c
      logical q500fl,qnarxr,qrderr
c
      character(len=80), dimension(:), allocatable :: ux80ar
c
      character(len=80) ulbufa,ulbufb,uline
      character(len=16) ustr16,uterm
      character(len=8) ustr
c
c-----------------------------------------------------------------------
c
      data uterm  /'+---------------'/
c
c-----------------------------------------------------------------------
c
c     Determine the number of lines in the data file title.
c     Count that first terminator line as the last line of the title.
c
      n = 0
  100 read (ndat0s,1000,end=990,err=995) uline
 1000 format(a)
      n = n + 1
      if (uline(1:16) .ne. uterm(1:16)) go to 100
c
      ntid_asv = n
      rewind(ndat0s)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate an array to hold the lines in the title.
c
      ALLOCATE(ux80ar(ntid_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the title into the holding array.
c
      do n = 1,ntid_asv
        read (ndat0s,1000,end=990,err=995) ux80ar(n)
      enddo
c
      rewind(ndat0s)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set parameters for the temperature grid used to represent log K
c     values and standard state enthalpy and volume functions.
c
c     Values corresponding to the "classical" EQ3/6 temperature grid
c     will be used as defaults. These are intended to support the use
c     of version 7 format data files by the version 8 and higher
c     software.
c
c       ntprt       = the number of temperature ranges
c       narxt(ntpr) = the number of points or coefficients in the
c                       ntpr-th temperature range
c
c     The old standard grid corresponds to:
c
c       ntprt = 2
c       narxt(1) = 4  (0, 25, 60 100 C)
c       narxt(2) = 5  (100, 150, 200, 250, 300 C)
c       ipch = -1   (no enthalpy function grids are present)
c       ipcv = -1   (no volume function grids are present)
c
c     Note that the last point of the ntpr-th temperature range
c     is also the first point of the following range, if any.
c     This insures continuity.
c
c     Hence the matching default dimensioning is as follows. Note
c     that if ipch < 1, ipch_asv must be set to one, as an array
c     can't have a null or negative dimension. The same applies to
c     ipcv and ipcv_asv.
c
      ntpr_asv = 2
      narx_asv = 5
      ipch_asv = 1
      ipcv_asv = 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the number of temperature ranges (ntpr_asv).
c
      do n = 1,ntid_asv
        ulbufa = ' '
        ulbufb = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(ux80ar(n),'NO. OF TEMPERATURE RANGES')
        if (i .gt. 0) then
          j = i + 25
        else
          i = index(ux80ar(n),'NUMBER OF TEMPERATURE RANGES')
          if (i .gt. 0) then
            j = i + 28
          else
            i = index(ux80ar(n),'NTPRT')
            if (i .gt. 0) j = i + 5
          endif
        endif
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = ux80ar(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a number matching the keystring.
c
          ulbufb = ulbufa(2:80)
          call lejust(ulbufb)
          ustr = ulbufb(1:8)
          call chrint(ntpr_asv,nttyo,qrderr,ustr)
          if (qrderr) go to 997
          go to 200
        endif
      enddo
c
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the maximum number of points in any temperature range
c     (narx_asv). Note that this is done by finding the number of
c     points in each range and determining the maximum. However, an
c     array to hold the actual values has not yet been allocated.
c     The actual values will be redetermined and stored by rdwttl.f.
c
      qnarxr = .false.
      narx_x = 0
      narxti = 0
      do ntpr = 1,ntpr_asv
        do n = 1,ntid_asv
          ulbufa = ' '
          ulbufb = ' '
          j = 0
c
c         Check for a keystring.
c
          i = index(ux80ar(n),'NO. OF POINTS IN RANGE')
          if (i .gt. 0) then
            j = i + 22
          else
             i = index(ux80ar(n),'NUMBER OF POINTS IN RANGE')
            if (i .gt. 0) then
              j = i + 25
            else
              i = index(ux80ar(n),'NARXT')
              if (i .gt. 0) j = i + 5
            endif
          endif
c
          if (j .gt. 0) then
c
c           Extract a number acting as a subscript to the keystring.
c
            ulbufb = ux80ar(n)(j:80)
            call lejust(ulbufb)
            j = index(ulbufb,' ')
            j = min(j,9)
            k = j - 1
            if (k .gt. 0) then
              ustr = ulbufb(1:k)
              call chrint(ntpri,nttyo,qrderr,ustr)
              if (qrderr) go to 997
              if (ntpri .ne. ntpr) j = 0
            else
              j = 0
            endif
          endif
c
          if (j .gt. 0) then
c
c           Check for an equal sign following the keystring.
c
            ulbufa = ulbufb(j:80)
            call lejust(ulbufa)
            i = index(ulbufa,'=')
            j = 2
            if (i .ne. 1) j = 0
          endif
c
          if (j .gt. 0) then
c
c           Extract a number matching the keystring.
c
            ulbufb = ulbufa(j:80)
            call lejust(ulbufb)
            ustr = ulbufb(1:8)
            call chrint(narxti,nttyo,qrderr,ustr)
            if (qrderr) go to 997
            qnarxr = .true.
            narx_x = max(narx_x,narxti)
            go to 220
          endif
        enddo
  220   continue
c
      enddo
c
c     If a value was read for any temperature range, use it. But
c     do not use a number less than 1, as an array can not have a
c     null or negative dimension.
c
      if (qnarxr) narx_asv = narx_x
      narx_asv = max(1,narx_asv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the maximum possible number of points on the temperature
c     grid for the current grid parameters.
c
      ndb_asv = ntpr_asv*(narx_asv - 1) + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set flag for dealing with sparsely filled ranges in the
c     "log K" temperature grids.
c       itgenf:
c         -1 = do nothing
c          0 = generate warnings for sparsely filled ranges
c          1 = generate errors for sparsely filled ranges
c
      itgenf = -1
      do n = 1,ntid_asv
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(ux80ar(n),'SPARSE GRID RANGE CONDITION')
        if (i .gt. 0) j = i + 27
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = ux80ar(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr16 = ulbufa(2:17)
          call lejust(ustr16)
          k = index(ustr16,'IGNORE')
          if (k .gt. 0) then
            itgenf = -1
          else
            k = index(ustr16,'WARN')
            if (k .gt. 0) then
              itgenf = 0
            else
              k = index(ustr16,'ERROR')
              if (k .gt. 0) then
                itgenf = 1
              endif
            endif
          endif
          go to 300
        endif
      enddo
  300 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set flag for dealing with values of "500." on the "log K"
c     temperature grids.
c       q500fl:
c         .false. = do nothing
c          .true. = treat values of 500. as "no data"
c
      q500fl = .true.
      do n = 1,ntid_asv
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(ux80ar(n),'INTERPRET 500 AS NO DATA')
        if (i .gt. 0) j = i + 24
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = ux80ar(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr16 = ulbufa(2:17)
          call lejust(ustr16)
          k = index(ustr16,'NO')
          if (k .le. 0) k = index(ustr16,'FALSE')
          if (k .gt. 0) then
            q500fl = .false.
          else
            k = index(ustr16,'YES')
            if (k .le. 0) k = index(ustr16,'TRUE')
            if (k .gt. 0) then
              q500fl = .true.
            endif
          endif
          go to 310
        endif
      enddo
  310 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the dimension corresponding to the order of the pressure
c     dependence of the enthalpy functions. An order of -1 means that
c     No enthalpy functions data are present on the data file. An order
c     of 0 means that enthalpy functions data are present, but no data
c     for the pressure dependence of the same are present. However,
c     the dimensioning variable ipch_asv must be set to a value of
c     at least one, as an array can not have a null or negative
c     dimension. Thus, it is necessary here to check only for data
c     corresponding to order 2 or higher.
c
      do n = 1,ntid_asv
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(ux80ar(n),'d2H/dP2')
        if (i .gt. 0) j = i + 7
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = ux80ar(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) ipch_asv = 2
          go to 320
        endif
      enddo
  320 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the dimension corresponding to the order of the pressure
c     dependence of the volume functions. This process and the dimension
c     itself are analogous to those described above for the pressure
c     dependence of the enthalpy functions.
c
      do n = 1,ntid_asv
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(ux80ar(n),'d2V/dP2')
        if (i .gt. 0) j = i + 7
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = ux80ar(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) ipcv_asv = 2
          go to 350
        endif
      enddo
  350 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set flag for Pitzer data block organization.
c       jpdblo:
c         = -1 Classical: two superblocks, one for pure aqueous
c              electrolytes, one for mixtures of two such electrolytes
c              having a common ion. A given theta parameter can appear
c              multiple times. Data for parameters involving electrically
c              neutral species are folded into this structure. Checks are
c              in place to sort things out.
c         =  0 New: multiple superblocks, each corresponding to a
c              charge-based type of species pair or triplet. This
c              structure is more rational. Theta parameters for example
c              have their own superblock.
c
      jpdblo = -1
      if (uakey(1:8) .eq. 'Pitzer  ') then
        do n = 1,ntid_asv
          ulbufa = ' '
          j = 0
c
c         Check for a keystring.
c
          i = index(ux80ar(n),'PITZER DATA BLOCK ORG.')
          if (i .gt. 0) j = i + 22
c
          if (j .gt. 0) then
c
c           Check for an equal sign following the keystring.
c
            ulbufa = ux80ar(n)(j:80)
            call lejust(ulbufa)
            i = index(ulbufa,'=')
            j = 2
            if (i .ne. 1) j = 0
          endif
c
          if (j .gt. 0) then
c
c           Extract a string input matching the keystring.
c
            ustr16 = ulbufa(2:17)
            call lejust(ustr16)
            k = index(ustr16,'NEW')
            if (k .le. 0) k = index(ustr16,'BYSPECIES')
            if (k .gt. 0) jpdblo = 0
            go to 400
          endif
        enddo
  400   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the identification of the temperature function used to
c     represent Pitzer interaction parameters. Note that the number
c     of terms or coefficients (jpfcmx) is a dimensioning parameter
c     that may also be set by an option embedded in the data file
c     title.
c
c     Temperature function flag.
c       jptffl:
c         = -1 Classic: a Taylor's series centered at 25C and
c              truncated at second order.
c
c                a1 = value at 25C
c                a2 = first derivative at 25C
c                a3 = second derivative at 25C
c
c              This is currently required if the Pitzer data block
c              organization flag is set to "Classical" (jpdblo = -1).
c              The number of terms used (jpfcmx) is fixed at 3.
c
c         =  0 The function:
c
c                x(T) = a1 + a2/(T - Tr) + a3*ln(T/Tr)
c                            a4(T - Tr) + a5(T**2 - Tr**2)
c
c              This is also 25C centric (Tr = 25C).
c              The number of terms used (jpfcmx) may vary from
c              1 to 5. This always refers to the first jpfcmx terms.
c
c         =  1 The Greenberg-Moller (1988) combination temperature
c              function. This is not 25C centric. The number of terms
c              used (mx) is fixed at 8.
c
      jptffl = -1
      if (uakey(1:8) .eq. 'Pitzer  ') then
        do n = 1,ntid_asv
          ulbufa = ' '
          j = 0
c
c         Check for a keystring.
c
          i = index(ux80ar(n),'PITZER TEMP FUNCTION')
          if (i .gt. 0) j = i + 20
c
          if (j .gt. 0) then
c
c           Check for an equal sign following the keystring.
c
            ulbufa = ux80ar(n)(j:80)
            call lejust(ulbufa)
            i = index(ulbufa,'=')
            j = 2
            if (i .ne. 1) j = 0
          endif
c
          if (j .gt. 0) then
c
c           Extract a string input matching the keystring.
c
            ustr16 = ulbufa(2:17)
            call lejust(ustr16)
            k = index(ustr16,'NEW')
            if (k .le. 0) k = index(ustr16,'Livermore')
            if (k .le. 0) k = index(ustr16,'LIVERMORE')
            if (k .le. 0) k = index(ustr16,'LLNL')
            if (k .le. 0) k = index(ustr16,'L5TERM')
            if (k .le. 0) k = index(ustr16,'5TERM')
            if (k .gt. 0) then
              jptffl = 0
              go to 410
            endif
            k = index(ustr16,'TEQUIL')
            if (k .le. 0) k = index(ustr16,'T8TERM')
            if (k .le. 0) k = index(ustr16,'GM8TERM')
            if (k .le. 0) k = index(ustr16,'8TERM')
            if (k .gt. 0) then
              jptffl = 1
              go to 410
            endif
          endif
        enddo
  410   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the number of terms or coefficients (jpfc_asv) in the
c     temperature function used to represent Pitzer parameters.
c
      jpfc_asv = 1
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Three is the default value for a Pitzer model.
c
        jpfc_asv = 3
        do n = 1,ntid_asv
          ulbufa = ' '
          j = 0
c
c         Check for a keystring.
c
          i = index(ux80ar(n),'NO. OF PITZER TEMP FUNC TERMS')
          if (i .gt. 0) j = i + 29
c
          if (j .gt. 0) then
c
c           Check for an equal sign following the keystring.
c
            ulbufa = ux80ar(n)(j:80)
            call lejust(ulbufa)
            i = index(ulbufa,'=')
            j = 2
            if (i .ne. 1) j = 0
          endif
c
          if (j .gt. 0) then
c
c           Extract a string input matching the keystring.
c
            ustr = ulbufa(2:9)
            call lejust(ustr)
            read (ustr,'(i8)') jpfc_asv
            go to 420
          endif
        enddo
  420   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate the array holding the data file title.
c
      DEALLOCATE(ux80ar)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write messages for errors associated with reading the DATA0
c     file.
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/ggridp) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the title of the DATA0 file.')
      if (n .le. 1) then
        write (noutpt,2010)
        write (nttyo,2010)
 2010   format(/7x,'This occurred while trying to read the first line',
     $  /7x,'of the title.')
      else
        ulbufa = ux80ar(n - 1)
        call lejust(ulbufa)
        j2 = ilnobl(ulbufa)
        j2 = min(j2,70)
        write (noutpt,2020) ulbufa(1:j2)
        write (nttyo,2020) ulbufa(1:j2)
 2020   format(/7x,'This occurred while trying to read the line',
     $  ' following',/7x,'the line:',/7x,'"',a,'"')
      endif
      stop
c
  995 write (noutpt,2030)
      write (nttyo,2030)
 2030 format(/' * Error - (EQPT/ggridp) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      if (n .le. 1) then
        write (noutpt,2010)
        write (nttyo,2010)
      else
        ulbufa = ux80ar(n - 1)
        call lejust(ulbufa)
        j2 = ilnobl(ulbufa)
        j2 = min(j2,70)
        write (noutpt,2020) ulbufa(1:j2)
      endif
      stop
c
  997 ulbufa = ux80ar(n)
      call lejust(ulbufa)
      j2 = ilnobl(ulbufa)
      j2 = min(j2,70)
      write (noutpt,2050) ulbufa(1:j2)
      write (nttyo,2050) ulbufa(1:j2)
 2050 format(/' * Error - (EQPT/ggridp) Encountered a read format',
     $ /7x,'error while reading data embedded in the title of the',
     $ /7x,'DATA0 file. This occurred while attempting to process',
     $ ' the line:',/7x,'"',a,'"')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine inttfx(narn1a,narn2a,noutpt,nsta_asv,ntfxa,ntfxmx,
     $ ntfxta,nttyo,tfxa,uspeca,utfxxd)
c
c     This subroutine sets up arrays for handling alkalinity
c     coefficients Species names used to tag alkalinity coefficients
c     are matched against the aqueous species names read from the data
c     file. If a match is not found, the corresponding alkalinity
c     coefficient is ignored.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       uspeca = array of names of species read from the data file
c       utfxxd = array of string entries containing the names of
c                  of species and corresponding alkalinity factors
c
c     Principal output:
c
c       ntfxa  = pointer array containing the indices of species
c                  corresponding to the titration factors in the
c                  tfxa array
c       ntfxta = number of species with alkalinity factors
c       tfxa   = array of titration factors
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer nsta_asv,ntfxmx
c
      integer ntfxa(ntfxmx)
      integer narn1a,narn2a,ntfxta
c
      character*48 uspeca(nsta_asv)
      character*32 utfxxd(ntfxmx)
c
      real*8 tfxa(ntfxmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,j2,n,nerr,nn,ns
c
      integer ilnobl
c
      real*8 tfx
c
      character*32 uentry,uscr1,uscr2
      character*24 unam
      character*8 ux8
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      ntfxta = 0
      do nn = 1,ntfxmx
c
c       Decode the current entry in the pseudo-data file. The
c       content of an entry is a string of the form: '"CaCO3(aq)", 2.0'.
c       Double-quote marks surround the name. A comma separates the
c       name from the number. All blanks are optional.
c
        uentry = utfxxd(nn)
        i = index(uentry,'"')
c
        if (i .le. 0) then
          j2 = ilnobl(uentry)
          write (noutpt,1000) uentry(1:j2)
          write (nttyo,1000) uentry(1:j2)
 1000     format(/' * Error - (EQ3NR/inttfx) Encountered an error',
     $    ' while reading a',/7x,'pseudo-data file of alkalinity',
     $    ' factors. The following entry does not',/7x,'contain an',
     $    ' initial double-quote mark:',/9x,"'",a,"'")
          nerr = nerr + 1
        endif
        if (nerr .gt. 4) stop
c
c       Okay, found the first double-quote mark.
c
        uscr1 = uentry(i + 1:32)
        call lejust(uscr1)
        j = index(uscr1,'"')
c
        if (j .le. 0) then
          j2 = ilnobl(uentry)
          write (noutpt,1010) uentry(1:j2)
          write (nttyo,1010) uentry(1:j2)
 1010     format(/' * Error - (EQ3NR/inttfx) Encountered an error',
     $    ' while reading a',/7x,'pseudo-data file of alkalinity',
     $    ' factors. The following entry does not',/7x,'contain a',
     $    ' second double-quote mark:',/9x,"'",a,"'")
          nerr = nerr + 1
        endif
        if (nerr .gt. 4) stop
c
c       Okay, found the second double-quote mark.
c
        if (j .eq. 1) then
          j2 = ilnobl(uentry)
          write (noutpt,1020) uentry(1:j2)
          write (nttyo,1020) uentry(1:j2)
 1020     format(/' * Error - (EQ3NR/inttfx) Encountered an error',
     $    ' while reading a',/7x,'pseudo-data file of alkalinity',
     $    ' factors. The following entry does not',/7x,'contain a',
     $    ' species name between the double-quote marks:',
     $     /9x,"'",a,"'")
          nerr = nerr + 1
        endif
        if (nerr .gt. 4) stop
c
        unam = uscr1(1:j - 1)
c
c       Test for the end of data.
c
        if (unam(1:6).eq.'endit.') go to 150
c
        uscr2 = uscr1(j:32)
        i = index(uscr2,',')
c
        if (i .le. 0) then
          j2 = ilnobl(uentry)
          write (noutpt,1030) uentry(1:j2)
          write (nttyo,1030) uentry(1:j2)
 1030     format(/' * Error - (EQ3NR/inttfx) Encountered an error',
     $    ' while reading a',/7x,'pseudo-data file of alkalinity',
     $    ' factors. The following entry does not',/7x,'contain a',
     $    ' comma after the species name:',/9x,"'",a,"'")
          nerr = nerr + 1
        endif
        if (nerr .gt. 4) stop
c
        uscr1 = uscr2(i + 1:32)
        call lejust(uscr1)
        ux8 = uscr1(1:8)
c
c       Read the titration factor.
c
        read (ux8,'(f5.1)',err=100,end=100) tfx
        go to 110
c
  100   j2 = ilnobl(uentry)
        write (noutpt,1040) uentry(1:j2)
        write (nttyo,1040) uentry(1:j2)
 1040   format(/' * Error - (EQ3NR/inttfx) Encountered a read error',
     $  ' while reading a',/7x,'pseudo-data file of alkalinity',
     $  ' factors. The following entry does not',/7x,'contain a',
     $  ' readable titration number:',/9x,"'",a,"'")
        nerr = nerr + 1
        if (nerr .gt. 4) stop
c
  110   continue
c
c       Search for a matching species name.
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam,uspeca)
c
        if (ns .gt. 0) then
c
c         If a previous match was found, skip.
c
          do n = 1,ntfxta
            if (ns .eq. ntfxa(n)) go to 140
          enddo
c
          ntfxta = ntfxta + 1
          ntfxa(ntfxta) = ns
          tfxa(ntfxta) = tfx
  140     continue
        endif
      enddo
  150 if (nerr .gt. 0) stop
c
      end

      subroutine pcorrm(adh,adhh,adhv,al10,aphi,avcnst,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,
     $ dvfe,iopg,ipch,ipchmx,ipcv,ipcvmx,nopgmx,presg,press,rcnstv,
     $ tempk,xhfe,xlke,xvfe)
c
c     This subroutine makes pressure corrections for miscellaneous
c     thermodynamic functions, such as Debye-Huckel parameters.
c     It normally corrects for pressures off the standard T-P grid
c     (e.g., from "presg" to "press"). However, it can be used to
c     correct from any pressure to another by substituting the value
c     of the former for "presg". This is done is EQ6 to correct for
c     changing pressure along an isothermal reaction path. In order
c     to do this, the pressure derivatives of the parameters in
c     question are also corrected to the pressure of interest. The
c     derivatives of highest order are necessarily treated as constants,
c     so there is no correction in this case.
c
c     Note the following technical references:
c
c       Ananthaswamy, J., and Atkinson, G., 1984, Thermodynamics of
c         concentrated electrolyte mixtures. 4. Pitzer-Debye-Huckel
c         limiting slopes for water from 0 to 100 C and from 1 atm
c         to 1 kbar, Journal of Chemical and Engineering Data,
c         v. 29, p. 81-87.
c
c       Bradley, D. J., and Pitzer, K. S., 1979, Thermodynamics of
c         electrolytes. 12. Dielectric properties of waer and
c         Debye-Huckel parameters to 350 C and 1 kbar, Journal
c         of Physical Chemistry, v. 83, p. 1599-1603.
c
c       Helgeson, H. C., and Kirkham, D. H., 1974b, Theoretical
c         prediction of the thermodynamic behavior of aqueous
c         electrolytes at high pressures and temperatures: II.
c         Debye-Huckel parameters for activity coefficients and
c         relative partial molal properties, American Journal
c         of Science, v. 274, p. 1199-1261.
c
c     EQLIB/pcorrx.f performs the same function for the standard state
c     thermodynamic functions, such as the equilibrium constants.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c      avcnst = 2.303 RT, with R in units of bar-cm3/mol-K
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,nopgmx
c
      integer iopg(nopgmx)
c
      integer ipch,ipcv
c
      real*8 dadhh(ipchmx),dadhv(ipcvmx),dbdhh(ipchmx),dbdhv(ipcvmx),
     $ dbdth(ipchmx),dbdtv(ipcvmx),dhfe(ipchmx),dvfe(ipcvmx)
c
      real*8 adh,adhh,adhv,al10,aphi,avcnst,bdh,bdhh,bdhv,bdot,bdoth,
     $ bdotv,presg,press,rcnstv,tempk,xhfe,xlke,xvfe
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,n
c
      real*8 a22rt,avrt,dp,xx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
c     a22rt  = 2(2.303)RT (R in P-V units)
c     avrt   = RT (R in P-V units)
c
      a22rt = 2*avcnst
      avrt = rcnstv*tempk
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the pressure difference.
c
      dp = press - presg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     This section addresses various parameters at the Gibbs energy
c     level (e.g., A(gamma,10), B(gamma)). It is divided into two
c     parts, one for first-order corrections only, the other for
c     corrections of order 2 or higher. This division is made for
c     speed, as often the data will only be available for first-order
c     corrections.
c
      if (ipcv .eq. 0) then
c
c       Make only first-order corrections.
c
c       The A(gamma,10) and A(phi) parameters. Note that A(V) (adhv)
c       is not dA(gamma,10)/dp nor dA(phi)/dp, though it does contain
c       these derivatives. Also, Helgeson and Kirkham's (1974b)
c       definition of A(V) is not identical to Bradley and Pitzer's
c       (1979). See the discussion of Ananthaswamy and Atkinson (1984).
c       Here if iopg(1) is less than or equal to 0, we follow Helgeson
c       and Kirkham's definition, otherwise, Bradley and Pitzer's.
c
        if (iopg(1) .le. 0) then
c
c         Helgeson and Kirkham (1974b), eq 48:
c
c           A(V) = -2(2.303)RT (dA(gamma,10)/dp)
c
c         Compare Ananthaswamy and Atkinson (1984), table 1:
c
c           A(V) = -6RT (dA(phi)/dp)
c
          xx = -adhv*dp/a22rt
          adh = adh + xx
          aphi = adh*al10/3.
        else
c
c         Ananthaswamy and Atkinson (1984), table 1:
c
c           A(V) = -4RT (dA(phi)/dp)
          xx = -adhv*dp/(4.*avrt)
          aphi = aphi + xx
          adh= 3.*aphi/al10
        endif
c
c       The B(gamma) parameter.
c
c         Helgeson and Kirkham (1974b), eq 49:
c
c           B(V) = 2(2.303)RT (dB(gamma)/dp)
c
c       Note that B(gamma) is carried multiplied by 10-8,
c       while B(V) is carried multiplied by 10-6.
c
        xx = 0.01*bdhv*dp/a22rt
        bdh = bdh + xx
c
c       The B-dot parameter.
c
c         by analogy to Helgeson and Kirkham (1974b), eq 49:
c
c           B-dot(V) = 2(2.303)RT (dB-dot/dp)
c
        xx = bdotv*dp/a22rt
        bdot = bdot + xx
c
c       The log K for the "Eh" reaction.
c
        xx = -xvfe*dp/avcnst
        xlke = xlke + xx
      endif
c
      if (ipcv .gt. 0) then
c
c       Make only corrections of order 2 or higher.
c
c       The A(gamma,10) and A(phi) parameters.
c
        xx = adhv*dp
        do ipc = 1,ipcv
          n = ipc + 1
          xx = xx - ( dadhv(ipc)*(dp**n) )/fctrl(n)
        enddo
        if (iopg(1) .le. 0) then
          xx = -xx/a22rt
          adh = adh + xx
          aphi = adh*al10/3.
        else
          xx = -xx/(4.*avrt)
          aphi = aphi + xx
          adh= 3.*aphi/al10
        endif
c
c       The B(gamma) parameter.
c
        xx = bdhv*dp
        do ipc = 1,ipcv
          n = ipc + 1
          xx = xx - ( dbdhv(ipc)*(dp**n) )/fctrl(n)
        enddo
        xx = 0.01*xx/a22rt
        bdh = bdh + xx
c
c       Correct B-dot to the current pressure, using a correction of
c       order 2 or higher.
c
        xx = bdotv*dp
        do ipc = 1,ipcv
          n = ipc + 1
          xx = xx - ( dbdtv(ipc)*(dp**n) )/fctrl(n)
        enddo
        xx = xx/a22rt
        bdot = bdot + xx
c
c       The log K for the "Eh" reaction.
c
        xx = -xvfe*dp
        do ipc = 1,ipcv
          n = ipc + 1
          xx = xx - ( dvfe(ipc)*(dp**n) )/fctrl(n)
        enddo
        xx = xx/avcnst
        xlke = xlke + xx
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     This section addresses enthalpy-related parameters.
c
      if (ipch .gt. 0) then
c
c       The A(H) parameter.
c
        xx = 0.
        do ipc = 1,ipch
          xx = xx  + ( dadhh(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        adhh = adhh + xx
c
        do ipc = 1,ipch - 1
c
c         The pressure derivatives of the A(H) parameter.
c
          xx = 0.
          do i = ipc + 1,ipch
            n = i - ipc
            xx = xx  + ( dadhh(i)*(dp**n) )/fctrl(n)
          enddo
          dadhh(ipc) = dadhh(ipc) + xx
        enddo
c
c       The B(H) parameter.
c
        xx = 0.
        do ipc = 1,ipch
          xx = xx  + ( dbdhh(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        bdhh = bdhh + xx
c
        do ipc = 1,ipch - 1
c
c         The pressure derivatives of the B(H) parameter.
c
          xx = 0.
          do i = ipc + 1,ipch
            n = i - ipc
            xx = xx  + ( dbdhh(i)*(dp**n) )/fctrl(n)
          enddo
          dbdhh(ipc) = dbdhh(ipc) + xx
        enddo
c
c       The B-dot(H) parameter.
c
        xx = 0.
        do ipc = 1,ipch
          xx = xx  + ( dbdth(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        bdoth = bdoth + xx
c
        do ipc = 1,ipch - 1
c
c         The pressure derivatives of the B-dot(H) parameter.
c
          xx = 0.
          do i = ipc + 1,ipch
            n = i - ipc
            xx = xx  + ( dbdth(i)*(dp**n) )/fctrl(n)
          enddo
          dbdth(ipc) = dbdth(ipc) + xx
        enddo
c
c       The enthalpy of the "Eh" reaction.
c
        xx = 0.
        do ipc = 1,ipch
          xx = xx  + ( dhfe(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        xhfe = xhfe + xx
c
        do ipc = 1,ipch - 1
c
c         The pressure derivatives of the enthalpy of the "Eh" reaction.
c
          xx = 0.
          do i = ipc + 1,ipch
            n = i - ipc
            xx = xx  + ( dhfe(i)*(dp**n) )/fctrl(n)
          enddo
          dhfe(ipc) = dhfe(ipc) + xx
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     This section addresses volume-related parameters.
c
      if (ipcv .gt. 0) then
c
c       The A(V) parameter.
c
        xx = 0.
        do ipc = 1,ipcv
          xx = xx  + ( dadhv(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        adhv = adhv + xx
c
        do ipc = 1,ipcv - 1
c
c         The pressure derivatives of the A(V) parameter.
c
          xx = 0.
          do i = ipc + 1,ipcv
            n = i - ipc
            xx = xx  + ( dadhv(i)*(dp**n) )/fctrl(n)
          enddo
          dadhv(ipc) = dadhv(ipc) + xx
        enddo
c
c       The B(V) parameter.
c
        xx = 0.
        do ipc = 1,ipcv
          xx = xx  + ( dbdhv(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        bdhv = bdhv + xx
c
        do ipc = 1,ipcv - 1
c
c         The pressure derivatives of the B(V) parameter.
c
          xx = 0.
          do i = ipc + 1,ipcv
            n = i - ipc
            xx = xx  + ( dbdhv(i)*(dp**n) )/fctrl(n)
          enddo
          dbdhv(ipc) = dbdhv(ipc) + xx
        enddo
c
c       The B-dot(V) parameter.
c
        xx = 0.
        do ipc = 1,ipcv
          xx = xx  + ( dbdtv(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        bdotv = bdotv + xx
c
        do ipc = 1,ipcv - 1
c
c         The pressure derivatives of the B-dot(V) parameter.
c
          xx = 0.
          do i = ipc + 1,ipcv
            n = i - ipc
            xx = xx  + ( dbdtv(i)*(dp**n) )/fctrl(n)
          enddo
          dbdtv(ipc) = dbdtv(ipc) + xx
        enddo
c
c       The volume of the "Eh" reaction.
c
        xx = 0.
        do ipc = 1,ipcv
          xx = xx  + ( dvfe(ipc)*(dp**ipc) )/fctrl(ipc)
        enddo
        xvfe = xvfe + xx
c
        do ipc = 1,ipcv - 1
c
c         The pressure derivatives of the volume of the "Eh" reaction.
c
          xx = 0.
          do i = ipc + 1,ipcv
            n = i - ipc
            xx = xx  + ( dvfe(i)*(dp**n) )/fctrl(n)
          enddo
          dvfe(ipc) = dvfe(ipc) + xx
        enddo
      endif
c
      end

      subroutine cnvndx(nlim1,nlim1a,nlim2,nlim2a,nsmap,nstmax,ntot)
c
c     This subroutine finds the first and last species in a reduced
c     range corresponding to an original set defined by the species
c     index limits nlim1a, nlim2a. Note that this is not a
c     straightforward mapping of such as "nlim1 = nsmap(nlim1a),"
c     because the species whose original index is nlim1a may have been
c     eliminated in the reduction.
c
c     This subroutine is called by:
c
c       EQLIB/cmpdat.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nlim1a = starting index of the range for the original set
c       nlim2a = ending index of the range for the original set
c       nsmap  = pointer array mapping species indices from the
c                  original set to the reduced set
c
c     Principal output:
c
c       nlim1  = starting index of the range for the reduced set
c       nlim2  = ending index of the range for the reduced set
c       ntot   = number of species in the range for the reduced set
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer nsmap(nstmax)
      integer nlim1,nlim1a,nlim2,nlim2a,ntot
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j
c
c-----------------------------------------------------------------------
c
c     Search for the first species that is in the list.
c
      do j = nlim1a,nlim2a,1
        if (nsmap(j) .ne. 0) go to 120
      enddo
c
c     None found, error.
c
      nlim1 = 0
      nlim2 = -1
      ntot = 0
      go to 999
c
 120  continue
c
c     Save the first species.
c
      nlim1 = nsmap(j)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search for last species that is in the list.
c
      do j = nlim2a,nlim1a,-1
         if (nsmap(j) .ne. 0) go to 140
      enddo
c
 140  continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the last species.
c
      nlim2 = nsmap(j)
      ntot = nlim2 - nlim1 + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine hdrchk(ndat0s,noutpt,nttyo)
c
c     This suboutine checks the first line of the DATA0 file to ensure
c     that the mandatory header ("data0" beginning in column 1) is
c     present.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndat0s,noutpt,nttyo
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
      character(len=80) uline
c
c-----------------------------------------------------------------------
c
c     Check the DATA0 file header. This insures that the file that
c     is supposed to be a DATA0 file really is one.
c
      read (ndat0s,1000,end=990,err=995) uline
 1000 format(a)
c
      if (uline(1:5).ne.'data0' .and. uline(1:5).ne.'Data0' .and.
     $  uline(1:5).ne.'DATA0') then
        j2 = ilnobl(uline)
        j2 = min(j2,50)
        write (noutpt,1010) uline(1:j2)
        write (nttyo,1010) uline(1:j2)
 1010   format(/' * Error - (EQPT/hdrchk) The DATA0 must have "data0"',
     $  ' beginning in',/7x,'column 1 of the first line. The first',
     $  ' line of this file begins',/7x,'instead with: "',a,'".')
        stop
      endif
c
      rewind(ndat0s)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a message for any read error.
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/hdrchk) The DATA0 file is an empty',
     $ ' file.')
      stop
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/hdrchk) Encountered a read format',
     $ ' error while',/7x,'checking for the mandatory header on the',
     $ ' first line of the',/7x,'DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine xderiv(akmat0,dxx0,fdxx0,nord,nordmx,nrd1mx)
c
c     This subroutine computes estimates of the derivatives (dxx0)
c     for some quantity (such as pH) from the corresponding finite
c     differences (fdxx0). Note that (dxx0) = (akmat0)(fdxx0).
c
c     Compare with:
c
c       EQ6/bderiv.f
c       EQ6/pderiv.f
c       EQ6/rderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nordmx,nrd1mx
c
      integer nord
c
      real*8 akmat0(nrd1mx,nrd1mx),dxx0(nordmx),fdxx0(nordmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
      do n = 1,nord
        dx = 0.
        do k = n,nord
          dx = dx + fdxx0(k)*akmat0(n,k)
        enddo
        dxx0(n) = dx
      enddo
c
      end

      subroutine ndiagx(delmax,delvec,eps100,idelmx,iebal,iindx1,
     $ irdxc3,jflag,kcarb,kebal,khydr,kmax,ko2gaq,nbasp,nbtmax,nhydr,
     $ noutpt,nstmax,nttyo,screwd,uspec)
c
c     This subroutine attempts to generate diagnostics if hybrid
c     Newton-Raphson iteration fails.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),jflag(nstmax),nbasp(nbtmax)
      integer idelmx,iebal,irdxc3,kcarb,kebal,khydr,ko2gaq,nhydr
c
      character(len=48) uspec(nstmax)
c
      real(8) delvec(kmax)
      real(8) delmax,eps100,screwd
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nb,ns
c
      integer ilnobl
c
      logical qadtst,qdltst
c
      real(8) adx,xx
c
c-----------------------------------------------------------------------
c
c     Check to see if idelmx is zero. If so, diagnostics can not be
c     generated.
c
      if (idelmx .eq. 0) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/' * Note - (EQ3NR/ndiagx) No crash diagnostics were',
     $  /7x,'generated. Look at the contents of the delvec and beta',
     $  /7x,'arrays in the iteration summary for clues.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if the ion being adjusted for electrical balance
c     was crashing to zero. This implies that an ion of opposite
c     charge must be used to achieve electrical balance.
c
      qdltst = (delvec(idelmx) + screwd) .le. eps100
      if (idelmx.eq.kebal .and. qdltst) then
        write (noutpt,1010)
        write (nttyo,1010)
 1010   format(/' * Note - (EQ3NR/ndiagx) the ion adjusted for',
     $  /7x,'electrical balance is crashing to zero. Electrical',
     $  /7x,'balancing requires an ion of opposite charge.')
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if the ion associated with alkalinity balance is
c     crashing to zero. This implies that non-carbonate alkalinity is
c     greater than or equal to carbonate alkalinity.
c
      if (idelmx.eq.kcarb .and. qdltst) then
        nb = iindx1(idelmx)
        ns = nbasp(nb)
        if (jflag(ns) .eq. 7) then
          j2 = ilnobl(uspec(ns)(1:24))
          write (noutpt,1020) uspec(ns)(1:j2)
          write (nttyo,1020) uspec(ns)(1:j2)
 1020     format(/' * Note - (EQ3NR/ndiagx) The basis species ',a,' is',
     $    /7x,'crashing to zero because the non-carbonate alkalinity',
     $    /7x,'exceeds the specified total alkalinity. The total',
     $    /7x,"alkalinity can't be used to constrain this species",
     $    /7x,'because of excessive interference from OH-, borate,',
     $    /7x,'phosphate, organic acids, metal hydroxy complexes, or',
     $    /7x,'the like. A total CO2 (IR) or ion chromatographic',
     $    /7x,'analysis is required instead.',/)
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if fO2 is crashing. This could be due to
c     a bad combination of constraining the redox state by a
c     non-fO2 option and divergence to zero of an associated
c     ion that is constrained by electrical balance.
c
      qadtst = (delmax - screwd) .le. eps100
      if (idelmx.eq.ko2gaq .and. qadtst .and. iebal.gt.0) then
        if (irdxc3.eq.-1 .and. nbasp(iebal).eq.nhydr) then
          xx = 0.1*screwd
          adx = abs(delvec(khydr))
          if (adx .ge. xx) then
            write (noutpt,1030)
            write (nttyo,1030)
 1030       format(/' * Note - (EQ3NR/ndiagx) The fO2 is crashing,',
     $      /7x,'probably because a bad electrical balance constraint',
     $      /7x,'on H+ is causing the concentration of that ion',
     $      /7x,'to crash to zero.',/)
            go to 999
          endif
        endif
c
        if (irdxc3 .eq. 1) then
          write (noutpt,1040)
          write (nttyo,1040)
 1040     format(/' * Note - (EQ3NR/ndiagx) The fO2 is crashing,',
     $    /7x,'probably because of a bad constraint on one of the',
     $    /7x,'aqueous species appearing in the redox reaction that',
     $    /7x,'is being used to constrain the fO2.',/)
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rtaylr(delxi,drer0,drir0,jreac,nord,nrct,nrctmx,
     $ nrd1mx,rirec0,rirecp,rrelr0,rrelrp)
c
c     This subroutine evaluates Taylor's series expansions for the
c     inverse rate and the relative rates of all irreversible reactions.
c
c     Compare with:
c
c       EQ6/ataylr.f
c       EQ6/ptaylr.f
c       EQ6/ztaylr.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       drer0  = the relative rate derivative vector at the base point
c       drir0  = the inverse rate derivative vector at the base point
c       nord   = the order of the truncated Taylor's series
c       nrd1mx = the maximum order of the truncated Taylor's series + 1
c       nrct   = the number of reactants
c       nrctmx = the maximum number of reactants
c       rirec0 = the inverse rate at the base point
c       rrelr0 = the relative rate vector at the base point
c
c     Principal output:
c
c       rirecp = the inverse rate at the new point
c       rrelrp = the relative rate vector at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx,nrd1mx
c
      integer jreac(nrctmx)
c
      integer nord,nrct
c
      real*8 drer0(nrd1mx,nrctmx),drir0(nrd1mx),rrelr0(nrctmx),
     $ rrelrp(nrctmx)
c
      real*8 delxi,rirecp,rirec0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nrc
c
      real*8 dxp,rx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      rirecp = rirec0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        rirecp = rirecp + ( drir0(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nrc = 1,nrct
        rx = 0.
        if (jreac(nrc) .eq. 0) then
          rx = rrelr0(nrc)
          dxp = 1.
          do n = 1,nord
            dxp = dxp*delxi
            rx = rx + ( drer0(n,nrc)/fctrl(n) )*dxp
          enddo
        endif
        rrelrp(nrc) = rx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine dscramc(ntabx,ntabs,nllnmx,ulinex)
c
c     This routine descrambles a file of tables whose lines are
c     interspersed, but which are marked by an id string that
c     apears first on any such line. The id string may contain up
c     to 8 characters and is followed by a comma.
c
c     The present routine is intended to support the creation of
c     .csv file to be opened in Excel or other spreadsheet or plotting
c     software, rather than a simple text file (such as the original
c     EQ6 TAB file).
c
c     The id string conceptually consists of eight characters.
c     Trailing blanks may be omitted on a line read by this
c     subroutine. The id string starts with a six-character tag
c     that identifies the corresponding table. The remaining two
c     characters may be used for other purposes. The string "vh'
c     identifies a variable header. The id string for a "Table A"
c     might be "A       ".
c
c     The contents of the scrambled file are copied to the descrambled
c     file as the descrambling takes place. The descrambled file must
c     already be open.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ntabx  = unit number of the scrambled file
c       ntabs  = unit number of the descrambled file (here the
c                TAB scratch file)
c       nllnmx = the maximum character length of a line on the
c                TABX, TABS, and TAB files
c       ulinex = variable holding a line, including the id string
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ntabx,ntabs
c
      integer nllnmx
c
      character(len=nllnmx) ulinex
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j1,j2,j,jc,n,ntable,ntablx
c
      integer, dimension(:), allocatable :: iftabl,iltabl
c
      logical qtablf,qvhfix
c
      character(len=nllnmx), dimension(:), allocatable :: ulvhtb
c
      character(len=8), dimension(:), allocatable :: utable,utablx
c
      character(len=8) uidstr,uidstx,utx,ux8
c
c-----------------------------------------------------------------------
c
c     Determine the six-character table identifiers (utable)
c     that are present on the scrambled file.
c
      ntablx = 10
      ALLOCATE(utable(ntablx))
      do n = 1,ntablx
        utable(n) = ' '
      enddo
c
      rewind ntabx
      ntable = 0
c
      uidstr = ' '
      read (ntabx,'(a8)',end=110) ux8
      jc = index(ux8,',')
      if (jc .gt. 0) then
        uidstr(1:jc - 1) = ux8(1:jc - 1)
      else
        uidstr(1:8) = ux8(1:8)
      endif
c
      ntable = 1
      utable(1)(1:6) = uidstr(1:6)
c
  100 uidstr = ' '
      read (ntabx,'(a8)',end=110) ux8
      jc = index(ux8,',')
      if (jc .gt. 0) then
        uidstr(1:jc - 1) = ux8(1:jc - 1)
      else
        uidstr(1:8) = ux8(1:8)
      endif
c
c     Is the current line's id string in the list?
c
      do n = 1,ntable
        if (uidstr(1:6) .eq. utable(n)(1:6)) go to 100
      enddo
c
c     Does the list of table identifiers need to be redimensioned?
c
      if (ntable .eq. ntablx) then
        ALLOCATE(utablx(ntablx))
        do n = 1,ntable
          utablx(n) = utable(n)
        enddo
        do n = ntable + 1,ntablx
          utablx(n) = ' '
        enddo
        DEALLOCATE(utable)
        ntablx = ntablx + 10
        ALLOCATE(utable(ntablx))
        do n = 1,ntable
          utable(n) = utablx(n)
        enddo
        do n = ntable + 1,ntablx
          utable(n) = ' '
        enddo
        DEALLOCATE(utablx)
      endif
c
c     Add the new table identifier to the list.
c
      ntable = ntable + 1
      utable(ntable)(1:6) = uidstr(1:6)
      go to 100
c
  110 continue
c
c     Organize the scrambled file so that all the lines belonging
c     to a table are contiguous. Descramble to a scratch file (TABS).
c     In the process, find the last instance of a variable header
c     in each table, if there is one. A variable header instance is
c     marked by the string 'vh' in the last two characters of the
c     id string.
c
      ALLOCATE(ulvhtb(ntable))
      do n = 1,ntable
        ulvhtb(n) = 'None'
      enddo
c
      rewind ntabs
      do n = 1,ntable
c
c       Loop over table designators.
c
        utx = utable(n)
        rewind ntabx
c
  140   uidstr = ' '
        read (ntabx,'(a)',end=150) ulinex
c
        jc = index(ulinex,',')
        if (jc .gt. 0) then
          uidstr(1:jc - 1) = ulinex(1:jc - 1)
        else
          uidstr(1:8) = ulinex(1:8)
        endif
c
        if (uidstr(1:6) .eq. utx(1:6)) then
          j2 = len_trim(ulinex)
          write (ntabs,'(a)') ulinex(1:j2)
c
          if (uidstr(7:8) .eq. 'vh') then
            ux8 = uidstr
            ux8(7:8) = '  '
            j1 = len_trim(ux8)
            jc = index(ulinex,",")
            ulvhtb(n)(1:j1) = ux8(1:j1)
            ulvhtb(n)(j1 + 1:nllnmx) = ulinex(jc:nllnmx)
          endif
c
        endif
        go to 140
  150   continue
      enddo
c
c     Copy the partially descrambled file back over the
c     original descrambled file. After this has been done,
c     the scrambled file will still be suitable for extension
c     in a possible subsequent EQ6 run.
c
      rewind ntabx
      rewind ntabs
c
  170 read (ntabs,'(a)',end=180) ulinex
      j2 = len_trim(ulinex)
      write (ntabx,'(a)') ulinex(1:j2)
      go to 170
c
  180 continue
c
c     The last instance of a possible variable header line
c     has already been found. It is the only instance that
c     is desired, and it will be placed in the relative position
c     of the first instance on the descrambled file.
c
c     A variable header line defines quantities associated with
c     some of the table columns, but whose contents are built up
c     during the run and cannot be known in advance. For example,
c     a table might give the number of moles of precipitated
c     minerals. The identities of these minerals cannot be known
c     until the run is complete. A first instance is written
c     in the desired relative position for the full variable header.
c     This will usually be incomplete. As more minerals are
c     precipitated, updated instances of the variable header will
c     be written. Only the last one is complete (as far as the
c     current run is concerned).
c
c     Loop over the tables.
c
      rewind ntabs
      do n = 1,ntable
c
c       Loop over table designators.
c
        qtablf = .false.
        qvhfix = .false.
        utx = utable(n)
        rewind ntabx
  240   uidstr = ' '
        read (ntabx,'(a)',end=250) ulinex
c
        jc = index(ulinex,',')
        if (jc .gt. 0) then
          uidstr(1:jc - 1) = ulinex(1:jc - 1)
        else
          uidstr(1:8) = ulinex(1:8)
        endif
c
        if (uidstr(1:6) .eq. utx(1:6)) then
          qtablf = .true.
          if (uidstr(7:8) .eq. 'vh') then
            if (.not.qvhfix) then
              qvhfix = .true.
              ulinex = ulvhtb(n)
            else
              go to 240
            endif
          endif
          j2 = len_trim(ulinex)
          write (ntabs,'(a)') ulinex(1:j2)
        elseif (qtablf) then
          go to 250
        endif
        go to 240
  250   continue
      enddo
c
      DEALLOCATE(utable)
      DEALLOCATE(ulvhtb)
c
      end

      subroutine dgesl(gmmatr,kmax,kdim,ipivot,delvec)
c
c     This subroutine solves the real*8 system (gmmatr)*(x) = (b),
c     where the matrix gmmatr has previously been factored by
c     EQLIBU/dgefa.f. It is expected that singularity of the matrix
c     has been trapped by that subroutine. Initially, the array delvec
c     contains the right-hand-side vector (b); this is replaced by
c     the solution vector (x). This subroutine is an adaptation of the
c     1979 Linpack subroutine of the same name. The size and order in
c     the original calling sequence has been preserved:
c     (a,lda,n,ipvt,b) = (gmmatr,kmax,kdim,ipivot,delvec)
c
c     This subroutine uses the following pseudo-Linpack BLAS (Basic
c     Linear Algebra Subsystem) subroutines:
c
c       EQLIBU/daxpy.f
c
c     This subroutine is called by:
c
c       EQLIBU/msolvr.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       gmmatr = the matrix
c       kmax   = the declared (maximum) dimension of the matrix
c       kdim   = the used dimension of the matrix
c       ipivot = the pivot vector (from EQLIBU/dgefa.f)
c       delvec = initially, the right hand side vector (b)
c
c     Output:
c
c       delvec = the solution vector (x).
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax
      integer kdim
c
      integer ipivot(kmax)
c
      real*8 gmmatr(kmax,kmax),delvec(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer il,k,kb
c
      real*8 tx
c
c----------------------------------------------------------------------
c
c     First solve (L)*(y) = (b).
c
      if (kdim .ge. 2) then
        do k = 1, kdim - 1
          il = ipivot(k)
          tx = delvec(il)
          if (il .ne. k) then
            delvec(il) = delvec(k)
            delvec(k) = tx
          endif
          call daxpy(kdim - k,tx,gmmatr(k + 1,k),1,delvec(k + 1),1)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now solve  (U)*(x) = (y).
c
      do kb = 1, kdim
        k = kdim + 1 - kb
        delvec(k) = delvec(k)/gmmatr(k,k)
        tx = -delvec(k)
        call daxpy(k - 1,tx,gmmatr(1,k),1,delvec(1),1)
      enddo
c
      end

      subroutine pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $ nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $ xlks,xvfs)
c
c     This subroutine makes pressure corrections for equilibrium
c     constants and related thermodynamic functions. It normally
c     corrects for pressures off the standard T-P grid (e.g., from
c     "presg" to "press"). However, it can be used to correct from
c     any pressure to another by substituting the value of the former
c     for "presg". This is done in EQ6 to correct for changing pressure
c     along an isothermal reaction path. In order to do this, the
c     pressure derivatives of enthalpy and volume functions (dhfs,dvfs)
c     are also corrected to the pressure of interest. The derivatives of
c     highest order are necessarily treated as constants, so there
c     is no correction in this case.
c
c     EQLIB/pcorrm.f performs the same function for some miscellaneous
c     thermodynamic functions, such as Debye-Huckel
c     parameters.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c       EQ3NR/eq3nr.f
c       EQ6/absswb.f
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c      avcnst = 2.303 RT, with R in units of bar-cm3/mol-K
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,nbtmax,nstmax
c
      integer ipch,ipcv,nbt,nst
c
      integer nbasp(nbtmax),ndrsr(2,nstmax)
c
      real*8 dhfs(ipchmx,nstmax),dvfs(ipcvmx,nstmax),xhfs(nstmax),
     $ xlks(nstmax),xvfs(nstmax)
c
      real*8 avcnst,presg,press
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,n,nb,ns,nt
c
      real*8 dp,xx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
c     Calculate the pressure difference.
c
      dp = press - presg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipcv .eq. 0) then
c
c       Correct the log K values to the current pressure, using
c       a first order (constant volume of reaction) correction.
c       This is expected to be the most common order for pressure
c       corrections, hence this special block has been written
c       for the sake of efficiency.
c
        do ns = 1,nst
          if (xlks(ns).gt.-9999999. .and. xlks(ns).lt.9999999.) then
            xx = -xvfs(ns)*dp/avcnst
            xlks(ns) = xlks(ns) + xx
          endif
        enddo
      endif
c
      if (ipcv .gt. 0) then
c
c       Correct the log K values to the current pressure, using
c       a correction of order 2 or higher. The coding in this block
c       could be used to handle the order 1 case. However, that
c       would not be quite as efficient as the above block.
c
        do ns = 1,nst
          if (xlks(ns).gt.-9999999. .and. xlks(ns).lt.9999999.) then
            xx = -xvfs(ns)*dp
            do ipc = 1,ipcv
              n = ipc + 1
              xx = xx - ( dvfs(ipc,ns)*(dp**n) )/fctrl(n)
            enddo
            xx = xx/avcnst
            xlks(ns) = xlks(ns) + xx
          endif
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Uncorrect the log K values for strict basis species,
c       as these are fixed at zero and the volume function array
c       contains the standard partial molar volume, not the
c       standard partial molar volume of reaction.
c
        do nb = 1,nbt
          ns = nbasp(nb)
          nt = ndrsr(2,ns) - ndrsr(1,ns) + 1
          if (nt .lt. 2) then
            xlks(ns) = 0.
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipch .gt. 0) then
c
c       Correct the enthalpy function values to the current pressure.
c
        do ns = 1,nst
c
          xx = 0.
          do ipc = 1,ipch
            xx = xx  + ( dhfs(ipc,ns)*(dp**ipc) )/fctrl(ipc)
          enddo
          xhfs(ns) = xhfs(ns) + xx
c
          do ipc = 1,ipch - 1
c
c           Correct the pressure derivatives of the enthalpy functions
c           to the current pressure.
c
            xx = 0.
            do i = ipc + 1,ipch
              n = i - ipc
              xx = xx  + ( dhfs(i,ns)*(dp**n) )/fctrl(n)
            enddo
            dhfs(ipc,ns) = dhfs(ipc,ns) + xx
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipcv .gt. 0) then
c
c       Correct the volume function values to the current pressure.
c
        do ns = 1,nst
c
          xx = 0.
          do ipc = 1,ipcv
            xx = xx  + ( dvfs(ipc,ns)*(dp**ipc) )/fctrl(ipc)
          enddo
          xvfs(ns) = xvfs(ns) + xx
c
          do ipc = 1,ipcv - 1
c
c           Correct the pressure derivatives of the volume functions
c           to the current pressure.
c
            xx = 0.
            do i = ipc + 1,ipcv
              n = i - ipc
              xx = xx  + ( dvfs(i,ns)*(dp**n) )/fctrl(n)
            enddo
            dvfs(ipc,ns) = dvfs(ipc,ns) + xx
          enddo
        enddo
      endif
c
      end

      subroutine eqphas(aamatr,abar,acflg,acflgo,act,actlg,
     $ adh,adhh,adhv,afcnst,affp,affs,alpha,al10,amtb,aphi,
     $ apx,avcnst,azero,a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,beta,betamx,betao,bgamx,bneg,bpx,cco2,
     $ cegexs,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,
     $ conc,conclg,cpgexs,cscale,csts,delvco,delvec,d1zvc1,dlogxw,
     $ egexjc,egexjf,egexs,eh,ehfac,eps100,farad,fje,fjeo,fo2,
     $ fo2lg,fsort,fugac,fugalg,fxi,fxio,gmmatr,iapxt,ibpxt,ibswx,
     $ ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,
     $ ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx0,iindx1,ilcphi1,
     $ ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,
     $ imrn2,insgf,iodb,iopg,iopt,ipch,ipivot,ipndx1,ipcv,istack,
     $ iter,itermx,ixbasp,ixrn1,ixrn2,izmax,jcsort,jflag,jgsort,
     $ jgstak,jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,khydx,km1,km10,kmt,kmt0,ko2gaq,
     $ kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt0,kxt,loph,losp,lsort,
     $ moph,mosp,mrgexs,mtb,mtbaq,narn1,narn2,narxt,nat,nbasp,nbaspd,
     $ nbaspx,nbt,nbtd,nbw,nchlor,ncmpr,nct,ndrs,ndrsd,ndrsx,ndrsr,
     $ ndrsrd,ndrsrx,nelect,nern1,nern2,ness,nessr,net,nfrn1,nfrn2,
     $ ngrn1,ngrn2,ngt,nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,
     $ nmt,nord,no2gaq,noutpt,npchk,nphasx,npt,nrdxsp,nst,nsts,
     $ nstsr,ntpr,ntrymx,nttyo,nxrn1,nxrn2,nxt,omega,omeglg,prcinf,
     $ press,qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,qoptmz,
     $ qpit75,qredox,qsspgb,qstart,qxknph,q6mode,rcnstv,rconst,
     $ rhsvec,rtcnst,screwd,sidrph,sidrsp,sigmam,sigmmo,smp100,tempc,
     $ tempk,tolbt,toldl,tolsat,tolsst,ubacmx,ubgamx,ulbeta,uldel,
     $ uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zvclg1,zvec1)
c
c     This subroutine attempts to calculate the equilibrium state of
c     the equilibrium system. As necessary, it makes repeated calls
c     to EQ6/eqcalc.f, which attempts to make this calculation for a
c     given specified phase assemblage. The present subroutine adjusts
c     this assemblage as needed.
c
c     This subroutine is called by:
c
c       EQ6/eqshel.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
c       qbye   = flag which is .true. if EQ6/path.f just changed the
c                  phase assemblage by deleting one or more phases.
c                  This condition instructs the present subroutine to
c                  print the index structure of the system of equations
c                  as it does on the starting call and whenever this
c                  subroutine itself adds or deletes a phase.
c
c       iter   = the number of hydrbid Newton-Raphson iterations
c                  done by EQLIB/newton.f
c
c       ier    = error flag:
c
c                  Values returned from EQ6/eqcalc.f:
c                    =    0  Okay
c                    =    1  Encountered a zero matrix
c                    =    2  Encountered a non-zero, computationally
c                              singular matrix
c                    =    3  Iteration was diverging
c                    =    4  Hit the maximum number of iterations
c                              (itermx)
c
c                  Values returned from EQ6/miidxz.f:
c                    =    0  Okay
c                    =    8  Exceeded the dimension of the iindx1
c                              array
c
c                  Values returned by the present subroutine:
c                    =    0  Okay
c                    =    8  Exceeded the dimension of the iindx1
c                              array; go back and cut the step size
c                              if possible
c                    =   10  Go back and take a smaller step size to
c                              avoid exceeding the supersaturation
c                              tolerance (tolsst). This is done only
c                              when an appropriate set of conditions
c                              is satisified. It isn't necessary for
c                              EQ6/path.f to analyze the situation
c                              when this value is returned to it by
c                              EQ6/ eqshel.f.
c                    =   20  Hit the maximum number of tries to find
c                              the correct phase assemblage
c                    =   30  Caught in a region of computational
c                              instability about the phase boundary for
c                              an appearing phase. Iteration fails when
c                              the phase is added to the phase
c                              assemblage.
c                    =   40  Caught in a region of computational
c                              instability about the phase boundary for
c                              a disappearing phase. The system is
c                              too supersaturated with respect to a
c                              phase if that phase is deleted from the
c                              phase assemblage.
c                    =   50  Caught in a region of computational
c                              instability associated with the
c                              master redox variable. This is probably
c                              associated with a redox jump.
c                    =   60  Caught in a region of computational
c                              instability associated with solvent
c                              water. The amount of water in the
c                              system is probably very low.
c                    =   70  Caught in a region of computational
c                              instability associated with the
c                              aqueous activity coefficient model.
c                    =  100  Detected out-of-range values for variables
c                              associated with the basis species before
c                              starting iteration.
c                    =  110  Detected out-of-range values for variables
c                              associated with the basis species after
c                              an iteration crash.
c                    =  150  Calculation failed, no diagnostics were
c                              generated.
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer iapxt(nxtmax),ibpxt(nxtmax),ibswx(nbtmax),
     $ igstak(ngtmax),iindx0(kmax),iindx1(kmax),ipivot(kmax),
     $ ipndx1(kmax),insgf(natmax),iodb(nodbmx),iopg(nopgmx),
     $ iopt(noptmx),istack(nstmax),ixbasp(nbtmax),jcsort(nstmax),
     $ jflag(nstmax),jgsort(ngtmax),jgstak(ngtmax),jjsort(nstmax),
     $ jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),jsol(nxtmax),
     $ jssort(nstmax),jstack(nstmax),kction(nbtmax)
c
      integer narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),
     $ ncmpr(2,nptmax),ness(nessmx),nessr(2,nstmax),ndrs(ndrsmx),
     $ ndrsd(ndrsmx),ndrsx(ndrsmx),ndrsr(2,nstmax),ndrsrd(2,nstmax),
     $ ndrsrx(2,nstmax),nfac(nbtmax),npchk(nptmax),nphasx(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer ielam,ier,igas,ipch,ipcv,iter,itermx,izmax,kbt,kdim,
     $ kelect,khydr,khydx,km1,km10,kmt,kmt0,ko2gaq,kpsat,kpsst,krdxsp,
     $ kwater,kx1,kx10,kxt,kxt0,nbtd,nbw,nchlor,nelect,nhydr,nhydx,
     $ nord,no2gaq,nrdxsp,ntpr,ntrymx
c
      logical qxknph(nptmax)
c
      logical qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,qoptmz,
     $ qpit75,qredox,qsspgb,qstart,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubacmx,ubgamx
      character*24 uphase(nptmax)
      character*8 ulbeta(kmax),uldel(kmax)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),
     $ act(nstmax),actlg(nstmax),affp(nptmax),affs(nstmax),
     $ alpha(kmax),amtb(nbtmax),apx(iapxmx,nxtmax),azero(natmax),
     $ a3bars(natmax),beta(kmax),betao(kmax),bpx(ibpxmx,nxtmax),
     $ cco2(5),cegexs(ietmax,jetmax,netmax),cess(nessmx),
     $ cdrs(ndrsmx),cdrsd(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),
     $ cdrw(nstmax),cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),
     $ conclg(nstmax),cpgexs(ietmax,jetmax,netmax),cscale(nstmax),
     $ csts(nstsmx),delvco(kmax),delvec(kmax),dlogxw(nbtmax),
     $ d1zvc1(kmax),egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax)
c
      real*8 fsort(ngtmax),fugac(ngtmax),fugalg(ngtmax),
     $ gmmatr(kmax,kmax),loph(nptmax),
     $ losp(nstmax),lsort(nstmax),moph(nptmax),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),mtbaq(nbtmax),
     $ rhsvec(kmax),sidrph(nptmax),sidrsp(nstmax),weight(nstmax),
     $ wfac(iktmax,nxtmax),xbar(nstmax),xbarlg(nstmax),
     $ zchar(nstmax),zchcu6(nstmax),zchsq2(nstmax),
     $ zvclg1(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,afcnst,al10,avcnst,a3bar,bacfmx,bbig,betamx,bgamx,
     $ bneg,eh,ehfac,eps100,farad,fje,fjeo,fo2,fo2lg,fxi,fxio,omega,
     $ omeglg,prcinf,press,rcnstv,rconst,rtcnst,screwd,sigmam,sigmmo,
     $ smp100,tempc,tempk,tolbt,toldl,tolsat,tolsst,xbarw,xbarwc,xbrwlc,
     $ xbrwlg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c
c     Variables for restoring the entering configuration, including
c     the entering phase assemblage.
c
      integer isv_kmax,isv_nbtmax,isv_nstmax
c
      SAVE isv_kmax,isv_nbtmax,isv_nstmax
c
      integer, dimension(:), allocatable :: iindxs,ipndxs,nbasps
c
      SAVE iindxs,ipndxs,nbasps
c
      real(8), dimension(:), allocatable :: acflgs,zvclgs
c
      SAVE acflgs,zvclgs
c
c     The following do not need to be SAVEd.
c
      integer kdims,km1s,kmts,kx1s,kxts
c
      real(8) xbarws,xbrwls
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with special dimensioning.
c
c     Data for the eight most supersaturated minerals.
c
      integer nssppa
      parameter (nssppa = 8)
c
      integer nsspmx
c
      integer nssp(nssppa)
c
      character*24 ussp(nssppa)
c
      real*8 afssp(nssppa),afssps(nssppa),msspmx(nssppa)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ibetmx,idelmx,ifail,inext,irow1,irow2,isave,isspt,j,
     $ jcol1,jcol2,jj,jkl,jlen,j2,j3,k,kcol,n,nb,nerr,nords,np,npadd,
     $ npaddi,npdel,npdeli,nrn1,nrn2,nr1,nr2,ns,nss,nsspt,nswtch,ns2,
     $ nt,ntry,ntryai,ntrydi,nxx
c
      integer ilnobl
c
      logical qadd,qbswok,qphruv
c
      character*56 uspn56
      character*8 ux8
c
      real*8 afscal,bfje,bfxi,bsigmm,cx,cxx,delmax,mophmx,mophn,mx,
     $ mxmadd,mpmxaq,mpmxes,msmxaq,msmxes
c
      real*8 tlg
c
c-----------------------------------------------------------------------
c
c     Local dimensioning variables.
c
      nsspmx = nssppa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(iindxs)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
        isv_nbtmax = 0
        isv_nstmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(iindxs,ipndxs)
          DEALLOCATE(zvclgs)
          isv_kmax = 0
        endif
c
        if (nbtmax .ne. isv_nbtmax) then
          DEALLOCATE(nbasps)
          isv_nbtmax = 0
        endif
c
        if (nstmax .ne. isv_nstmax) then
          DEALLOCATE(acflgs)
          isv_nstmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(iindxs(kmax),ipndxs(kmax))
        ALLOCATE(zvclgs(kmax))
        isv_kmax = kmax
      endif
c
      if (isv_nbtmax .eq. 0) then
        ALLOCATE(nbasps(nbtmax))
        isv_nbtmax = nbtmax
      endif
c
      if (isv_nstmax .eq. 0) then
        ALLOCATE(acflgs(nstmax))
        isv_nstmax = nstmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        iindxs(k) = 0
        ipndxs(k) = 0
      enddo
c
      do k = 1,kmax
        zvclgs(k) = -99999.
      enddo
c
      do n = 1,nbtmax
        nbasps(n) = 0
      enddo
c
      do n = 1,nstmax
        acflgs(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize some parameters.
c
      ier = 0
c
      qadd = .false.
      qmod = .false.
      qbseqc = .false.
c
      ifail = 0
c
      npadd = 0
      npaddi = 0
c
      npdel = 0
      npdeli = 0
c
      ntry = 1
      ntryai = 0
      ntrydi = 0
c
      kpsst = 0
      nsspt = 0
      call initiz(nssp,nsspmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here is a return point if the phase assemblage has been modified.
c
  100 bgamx = 0.
      bsigmm = 0.
      bfxi = 0.
      bfje = 0.
c
      if (ntry.gt.1 .or. qstart .or. qbye .or. iodb(1).ge.3) then
c
c       Print the current phase assemblage.
c
        write (noutpt,1000) ntry
 1000   format(/' Attempted phase assemblage number ',i3,/)
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1010) kcol,uspn56(1:jlen)
 1010     format(2x,i3,2x,a)
        enddo
        do kcol = km1,kxt
          ns = iindx1(kcol)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnm(jlen,uspec(ns),uspn56)
          write (noutpt,1010) kcol,uspn56(1:jlen)
        enddo
        write (noutpt,1020)
 1020   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the "kernel" description for the current equilibrium system.
c     This will be used to recover if an equilibrium calculation made
c     by EQ6/eqcalc.f fails for any reason. This kernel contains the
c     minimum of information required to calculate the fully expanded
c     description using EQLIB/ncmpex.f. Note that EQ6/eqshel.f, which
c     calls the present subroutine, has its own backup kernel.
c     EQ6/path.f, which calls EQ6/eqshel.f, also has its own backup
c     kernel, which is used to restore the equilibrium system at the
c     previous point of reaction progress.
c
c     Note that the present backup kernel is not a compact description
c     of the equilibrium system from the last call to EQ6/eqcalc.f.
c     Upon entry to the present subroutine, the backup kernel
c     corresponds to a description of the system either as read from
c     the input file (at the starting value of reaction progress) or
c     as obtained by finite-difference prediction in stepping to the
c     current point of reaction progress. Otherwise, it corresponds to
c     what resulted from the last successful call to EQ6/eqcalc.f from
c     the present subroutine, modified by the addition, deletion, or
c     replacement of one phase.
c
      km1s = km1
      kmts = kmt
      kx1s = kx1
      kxts = kxt
      kdims = kdim
c
      call copyia(nbasp,nbasps,nbt)
      call copyia(iindx1,iindxs,kdim)
      call copyia(ipndx1,ipndxs,kdim)
c
      call copyaa(zvclg1,zvclgs,kdim)
      call copyaa(acflg,acflgs,nst)
c
      xbarws = xbarwc
      xbrwls = xbrwlc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the order of the finite differences.
c
      nords = nord
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for aqueous basis species (or any other species switched
c     with such) for cases in which the log number of moles variable
c     is -99999. This implies a number of moles values which is zero,
c     which in turn implies that the species is not actually present in
c     the equilibrium system. Note that in this code -99999. is the
c     conventional value for log10(0). Conversely, 10**(-99999.) returns
c     a value of zero.
c
      nerr = 0
      do kcol = 1,kbt
        if (zvclg1(kcol) .le. -99999.) then
c
c         Calling sequence substitutions:
c           uzvec1 for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          if (kcol .ne. krdxsp) then
            write (noutpt,1050) uspn56(1:jlen),zvclg1(kcol)
            write (nttyo,1050) uspn56(1:jlen),zvclg1(kcol)
 1050       format(/' * Warning - (EQ6/eqphas) The log number of moles',
     $      ' variable for basis species',/7x,a,' has the out-of-range',
     $      ' value ',1pe12.5,'.')
          elseif (qredox) then
            if (krdxsp .eq. ko2gaq) then
              write (noutpt,1060) zvclg1(kcol)
              write (nttyo,1060) zvclg1(kcol)
 1060         format(/' * Warning - (EQ6/eqphas) The log oxygen',
     $        ' fugacity variable has the out-of-range',/7x,'value ',
     $        1pe12.5,'.')
            elseif (krdxsp .eq. kelect) then
              write (noutpt,1070) zvclg1(kcol)
              write (nttyo,1070) zvclg1(kcol)
 1070         format(/' * Warning - (EQ6/eqphas) The log electron',
     $        ' activity variable has the',/7x,'out-of-range value',
     $        ' ',1pe12.5,'.')
            else
              write (noutpt,1050) uspn56(1:jlen),zvclg1(kcol)
              write (nttyo,1050) uspn56(1:jlen),zvclg1(kcol)
            endif
          endif
          nerr = nerr + 1
        endif
      enddo
      if (nerr .gt. 0) then
        ier = 100
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the current phase assemblage for mineral species for which
c     the log number of moles variable is -99999. This implies that the
c     corresponding number of moles variable is zero, and in turn that
c     the species is not actually present in the equilibrium system.
c     In such a case, the corresponding phase must be deleted from the
c     current phase assemblage.
c
      do kcol = km1,kxt
        if (zvclg1(kcol) .le. -99999.) then
          npdel = ipndx1(kcol)
          go to 700
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      call eqcalc(aamatr,abar,acflg,acflgo,act,actlg,adh,
     $ adhh,adhv,afcnst,alpha,al10,amtb,aphi,apx,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,betao,bfje,bfxi,bgamx,bneg,bpx,bsigmm,cco2,
     $ cegexs,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,conc,
     $ conclg,cpgexs,cscale,csts,delmax,delvco,delvec,dlogxw,
     $ egexjc,egexjf,egexs,eh,ehfac,eps100,farad,fje,fjeo,fo2,
     $ fo2lg,fsort,fugac,fugalg,fxi,fxio,gmmatr,iapxt,ibetmx,ibpxt,
     $ ibswx,idelmx,ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,
     $ ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,
     $ ilzeta,imrn1,imrn2,insgf,iodb,iopg,iopt,ipch,ipcv,ipivot,
     $ ipndx1,istack,iter,itermx,ixbasp,ixrn1,ixrn2,izmax,jcsort,
     $ jflag,jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jsol,
     $ jssort,jstack,kbt,kction,kdim,kelect,khydr,khydx,km1,kmt,
     $ ko2gaq,krdxsp,kwater,kx1,kxt,loph,losp,lsort,moph,mosp,
     $ mrgexs,mtb,narn1,narn2,narxt,nat,nbasp,nbaspd,nbaspx,nbt,
     $ nbtd,nbw,nchlor,ncmpr,nct,ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,
     $ ndrsrx,nelect,nern1,nern2,ness,nessr,net,nfac,nfrn1,nfrn2,
     $ ngrn1,ngrn2,ngt,nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,
     $ nmt,noutpt,no2gaq,nphasx,npt,nrdxsp,nst,nsts,nstsr,ntpr,
     $ nttyo,nxrn1,nxrn2,nxt,omega,omeglg,press,qbassw,qhawep,
     $ qoptmz,qpit75,qredox,q6mode,rhsvec,screwd,sigmam,sigmmo,
     $ smp100,tempc,tempk,tolbt,toldl,ubacmx,ubgamx,ulbeta,uldel,
     $ uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Were any basis switches made by EQ6/optmzr.f?
c
      nswtch = 0
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns = nbasp(nb)
        ns2 = nbasps(nb)
        if (ns2 .ne. ns) then
          nswtch = nswtch + 1
        endif
      enddo
      qbseqc = nswtch .gt. 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qbseqc) then
c
c       Drop the order to zero. The finite difference data are tied
c       to the old basis set. The original order and the use of these
c       data can be restored later in the present subroutine if the
c       switches just made are undone.
c
        nord = nords
      endif
c
      if (ier .gt. 0) go to 500
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Hybrid Newton-Raphson iteration has converged. Check for super-
c     saturations (other than those which are permitted to exist
c     metastably).
c
      ifail = 0
      npadd = 0
      nsspt = 0
      call initiz(nssp,nsspmx)
c
c     Calculate the total number of moles of each basis species
c     present in the aqueous phase.
c
      call initaz(mtbaq,nbt)
c
      do nss = narn1,narn2
        ns = jcsort(nss)
        if (mosp(ns) .ne. 0.) then
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            mtbaq(nb) = mtbaq(nb) + csts(n)*mosp(ns)
          enddo
        endif
      enddo
c
c     Check for supersaturations.
c
      call satchk(acflg,act,actlg,afcnst,affp,affs,apx,bpx,
     $ cdrs,eps100,iindx1,iodb,iopt,iapxmx,ibpxmx,iktmax,ixrn1,jflag,
     $ jpflag,jsflag,jsol,kmax,km1,kpsat,kpsst,kxt,nbasp,nbt,nbtmax,
     $ ncmpr,ndrs,ndrsmx,ndrsr,nodbmx,noptmx,noutpt,npchk,npt,nptmax,
     $ nstmax,nttyo,nxrn1,nxrn2,nxtmax,qxknph,sidrph,sidrsp,tolsat,
     $ uphase,uspec,wfac,xbar,xbarlg,xlks)
c
      if (kpsst .gt. 0) then
        if (iodb(4) .le. 0) then
          ux8 = ' '
          write (ux8,'(i7)') iter
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1090) ux8
 1090     format(' iter= ',a)
        endif
c
        ux8 = ' '
        write (ux8,'(i7)') kpsst
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1100) ux8(1:j2)
 1100   format(/'   Have ',a,' supersaturated phases.')
      endif
c
      if (kpsst .le. 0) then
c
c       The last equilibrium calculation converged and there are no
c       supersaturations to eliminate. The calculation overseen by
c       the present subroutine has completed successfully.
c
        go to 990
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Have one or more supersaturations. Find a phase to add to the
c     current phase assemblage. To do this, scale the affinities of the
c     supersaturated phases according to the number of ions produced
c     and destroyed in the respective dissolution reactions. The
c     scaled affinity is arbitrarily reduced if the maximum possible
c     number of moles of the new phase as estimated from the aqueous
c     solution chemistry is very small. The supersaturated phases are
c     arranged in decreasing order of scaled affinity. The phase with
c     the greatest scaled affinity is added to the phase assemblage.
c     In general, this algorithm picks the correct phase about four
c     out of five times.
c
      call initcb(ussp,nsspmx)
      call initaz(afssp,nsspmx)
      call initaz(afssps,nsspmx)
      call initaz(msspmx,nsspmx)
c
      isspt = 0
      do np = 1,npt
        if (jpflag(np) .eq. -2) then
          jpflag(np) = 0
          isspt = isspt + 1
c
          cxx = 0.
          nxx = 0
          nrn1 = ncmpr(1,np)
          nrn2 = ncmpr(2,np)
          nt = nrn2 - nrn1 + 1
          mpmxaq = 0.
          mpmxes = 0.
c
          do ns = nrn1,nrn2
            if (jsflag(ns) .le. 0) then
              cxx = cxx + cscale(ns)
              nxx = nxx + 1
              msmxaq = 1.e+38
              msmxes = 1.e+38
              nr1 = nstsr(1,ns)
              nr2 = nstsr(2,ns)
              do n = nr1,nr2
                cx = csts(n)
                if (cx .ne. 0.) then
                  nb = nsts(n)
                  nss = nbaspd(nb)
                  if (nss.ne.nhydr .and. nss.ne.nhydx .and.
     $              nss.ne.no2gaq .and. nss.ne.nelect) then
c
c                   Note: the total number of moles of a basis species
c                   can not be used to bound the number of moles of
c                   the species currently being examined (and hence
c                   also the number of moles of the corresponding phase)
c                   if the current basis species is H+, OH-, O2(g,aq),
c                   or e-. The latter two species are fictive. More to
c                   the point, the total number of moles of such
c                   basis species may be zero or even a negative number.
c
                    if (cx .gt. 0.) then
                      if (mtbaq(nb) .gt. 0.) then
                        mx = mtbaq(nb)/cx
                        msmxaq = min(msmxaq,mx)
                      endif
                      if (mtb(nb) .gt. 0.) then
                        mx = mtb(nb)/cx
                        msmxes = min(msmxes,mx)
                      endif
                    endif
                  endif
                endif
              enddo
              if (msmxaq .ge. 1.e+38) msmxaq = 1.0
              if (msmxes .ge. 1.e+38) msmxes = 1.0
              mpmxaq = max(mpmxaq,msmxaq)
              mpmxes = max(mpmxes,msmxes)
            endif
          enddo
c
c         Pick a maximum number of moles for the current phase based
c         on the moles of components in the aqueous solution and in
c         the equilibrium system.
c
          mophmx = max(mpmxaq,(0.05*mpmxes))
c
c         If the phase consists of more than one species, compute and
c         use the average affinity scaling factor.
c
          cxx = cxx/nxx
          afscal = affp(np)/cxx
c
c         Reduce the scaled affinity if the maximum precipitable
c         number of moles is small.
c
          if (mpmxaq .le. 5.e-6) afscal = 0.01*afscal
c
          do jj = 1,nsspmx
            if (afscal .ge. afssps(jj)) then
              jkl = nsspmx - jj
c
              do j = 1,jkl
                k = nsspmx - j
                nssp(k + 1) = nssp(k)
                ussp(k + 1) = ussp(k)
                afssps(k + 1) = afssps(k)
                afssp(k + 1) = afssp(k)
                msspmx(k + 1) = msspmx(k)
              enddo
c
              nssp(jj) = np
              ussp(jj) = uphase(np)
              afssps(jj) = afscal
              afssp(jj) = affp(np)
              msspmx(jj) = mophmx
              go to 200
            endif
          enddo
  200     continue
        endif
      enddo
      nsspt = min(isspt,nsspmx)
c
      if (iodb(1) .ge. 2) then
        write (noutpt,1110)
 1110   format(//5x,'The most supersaturated phases:',
     $  //31x,'Scaled',6x,'Affinity,',5x,'Maximum',
     $  /3x,'Name',23x,'Affinity',6x,'kcal/mol',4x,'Precipitable',
     $  /59x,'Moles',/)
        do n = 1,nsspt
          write (noutpt,1120) ussp(n),afssps(n),afssp(n),
     $    msspmx(n)
 1120     format(1x,a24,2x,f12.7,2x,f12.7,2x,1pe12.5)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (afssp(1) .gt. tolsst) then
        if (qsspgb .and. ntry.le.1) then
c
c         Return a special error flag so that subroutine path will cut
c         the step size in order to be able to home in on the value of
c         reaction progress which corresponds to the target
c         supersaturation.
c
          write (noutpt,1150)
 1150     format(/' --- The extent of supersaturation exceeds the',
     $    ' normal tolerance ---')
          ier = 10
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      npadd = nssp(1)
      mxmadd = msspmx(1)
c
      if (npadd.eq.npaddi .and. ntry.eq.(ntryai + 2)) then
c
c       The phase chosen to add was added two steps previously and
c       removed on the previous step.
c
        if (iodb(1) .gt. 0) then
          write (noutpt,1160)
          write (nttyo,1160)
 1160     format(/' * Note - (EQ6/eqphas) Caught in a region of',
     $    /7x,'critical instability in the ES phase assemblage. A',
     $    /7x,"supersaturated phase can't be precipitated due to",
     $    /7x,'lack of convergence when it is included in the ES',
     $    /7x,'phase assemblage.')
        endif
c
        ier = 30
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a return point to add one new member to the
c     current phase assemblage and try again.
c
  300 j2 = ilnobl(uphase(npadd))
      write (ux8,'(i7)') npadd
      call lejust(ux8)
      j3 = ilnobl(ux8)
      write (noutpt,1180) uphase(npadd)(1:j2),ux8(1:j3)
 1180 format(/'   The phase to be added is ',a,1x,'(',a,')')
c
      qadd = .true.
      npaddi = npadd
      ntryai = ntry
c
      do kcol = 1,kmax
        delvec(kcol) = 0.
      enddo
c
c     The starting number of moles is set to some fraction of the
c     probable maximum value. Here it is set to 100% of that.
c
      mophn = mxmadd
      np = npadd
      jpflag(np) = -1
      loph(np) = tlg(mophn)
      nr1 = ncmpr(1,np)
      nr2 = ncmpr(2,np)
      nt = nr2 - nr1 + 1
      if (nt .eq. 1) then
        jsflag(nr1) = -1
        losp(nr1) = loph(np)
      else
        do ns = nr1,nr2
          if (jsflag(ns) .le. 0) then
            jsflag(ns) = -1
            losp(ns) = loph(np) + xbarlg(ns)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Modify the current phase assemblage.
c
  400 ntry = ntry + 1
c
      if (ntry .gt. ntrymx) then
        write (noutpt,1200) ntrymx
        write (nttyo,1200) ntrymx
 1200   format(/' * Note - (EQ6/eqphas) Have done the maximum ',i3,
     $  ' tries to find the',/7x,'correct phase assemblage without',
     $  ' succeeding. Suggest increasing the',/7x,'value of the ntrymx',
     $  ' variable on the input file.')
        ier = 20
        go to 999
      endif
c
      qmod = .true.
      kpsst = 0
c
c     Modify the indexing of the Jacobian.
c
      call miidxz(ier,iindx1,ipndx1,jpflag,jsflag,kbt,kdim,
     $ kmax,km1,kmt,kx1,kxt,losp,ncmpr,noutpt,npt,nptmax,nstmax,
     $ nttyo,uspec,uzvec1,zvclg1,zvec1)
      if (ier .gt. 0) then
        ier = 8
        go to 999
      endif
c
      write (noutpt,1020)
c
c     Go back and try to make the equilibrium calculation with the
c     new phase assemblage.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  500 continue
c
c     Iteration has terminated without achieving convergence. Attempt to
c     diagnose the cause. It may be that a phase must be removed from
c     the current phase assemblage.
c
      ifail = ifail + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If there are no mineral phases in the equilibrium system phase
c     assemblage to consider deleting, look for another cause for
c     the failure to converge.
c
      if (kxt .le. kbt) go to 980
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Try to find a phase do delete from the phase assemblage.
c
      npdel = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Trap out-of-range values for the variables associated with the
c     mineral species. An out-of-range value ("-99999.") is likely to
c     be encountered only as a result of having read it from the input
c     file.
c
      do kcol = km1,kxt
c
c       If a value of -99999. is found for the log number of moles
c       variable of any mineral species, go remove the associated
c       phase from the current phase assemblage and try again.
c
        if (zvclg1(kcol) .le. -99999.) then
          npdel = ipndx1(kcol)
          go to 700
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((qadd .or. qstart) .and. (kxt - km1 + 1).ge.2) then
c
c       Check for the possibility of a mineralogic phase rule violation.
c       The mineralogic phase rule is 'f = c - p', whereas the phase
c       rule of thermodynamics is 'f = c - p + 2'. The mineralogic
c       phase rule applies here because the present computations
c       are made for fixed temperature and pressure. A violation of
c       the mineralogic phase rule is equivalent to a condition of
c       linear dependence among the mineral mass action rows
c       (krow = km1,kxt).
c
        irow1 = km1
        irow2 = kmt
cXX     irow2 = kxt
        jcol1 = 1
        jcol2 = kmt
cXX     jcol2 = kxt
c
c       Calling sequence substitutions:
c         qphruv for qldep
c
        call lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,
     $  qphruv)
        if (qphruv) then
          write (noutpt,1400)
          write (nttyo,1400)
 1400     format(/' * Note - (EQ6/eqphas) The current phase assemblage',
     $    ' violates the',/7x,'mineralogic phase rule.')
c
          if (iopt(1).eq.2 .and. .not.qstart .and.
     $      .not.(qcntmp.and.qcnpre)) then
c
c           A mineralogic phase rule violation occurred while running
c           a non-isothermal fluid-centered flow-through open system
c           simulation. The violation may be due to crossing a
c           univariant curve.
c
            write (noutpt,1500)
 1500       format('   --- Possibly attempting to cross a univariant ',
     $      'curve ---',/)
          endif
c
c         Identify a phase which must be deleted in order to avoid the
c         violation. Ordinarily, there would only be one.
c
          call jgibbs(aamatr,afcnst,affp,cdrs,cscale,csts,delvec,
     $    eps100,gmmatr,iindx1,iodb,ipivot,ipndx1,jpflag,kbt,kdim,kmax,
     $    km1,kmt,kx1,kxt,mtb,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nodbmx,
     $    noutpt,npadd,npdel,nptmax,nstmax,nsts,nstsmx,nstsr,nttyo,
     $    rhsvec,uphase,uspec,xlks)
c
          if (npdel .gt. 0) then
c
c           Go delete the offending phase and try again.
c
            go to 700
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Try to find a phase to delete using the following two empirical
c     criteria:
c
c        1. The log number of moles of a phase was becoming very
c           negative (or was already very negative if iter .le. 1).
c
c        2. Its derivative with respect to Xi is very negative
c           (must have nord.ge.1 in order to apply this).
c
      call phsdrp(d1zvc1,iindx0,iindx1,iodb,ipndx1,iter,kmax,
     $ km1,km1s,kxt,kxts,nodbmx,nord,noutpt,npadd,npdel,nptmax,ntry,
     $ uphase,zvclgs,zvclg1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (npdel .le. 0) then
c
c       Couldn't find a phase to delete.
c
        go to 980
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  700 continue
c
c     Have found a phase to delete from the phase assemblage.
c
      if (npdel.eq.npdeli .and. ntry.eq.(ntrydi + 2)) then
c
c       The phase chosen to delete was deleted two steps previously and
c       then added on the previous step.
c
        if (iodb(1) .gt. 0) then
          write (noutpt,1510)
          write (nttyo,1510)
 1510     format(/' * Note - (EQ6/eqphas) Caught in a region of',
     $    /7x,'critical instability in the ES phase assemblage. A',
     $    /7x,"phase can't be deleted because when it is not included",
     $    /7x,'in the ES phase assemblage the system is supersaturated',
     $    /7x,'beyond the allowed tolerance.')
        endif
c
        ier = 40
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Delete a phase from the phase assemblage and try again.
c
      ier = 0
      npdeli = npdel
      ntrydi = ntry
c
      j2 = ilnobl(uphase(npdel))
      write (ux8,'(i7)') npdel
      call lejust(ux8)
      j3 = ilnobl(ux8)
      write (noutpt,1520) uphase(npdel)(1:j2),ux8(1:j3)
 1520 format(/'   The phase to be dropped is ',a,1x,'(',a,')')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qbseqc) then
c
c       If any basis switches were done by EQ6/optmzr.f, undo them.
c       Restore the kernel for the equilibrium sytem from the backup.
c
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          ns2 = nbasps(nb)
          if (ns2 .ne. ns) then
            call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $      nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $      ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
          endif
        enddo
c
        qbseqc = .false.
        nord = nords
c
        km1 = km1s
        kmt = kmts
        kx1 = kx1s
        kxt = kxts
        kdim = kdims
c
        call copyia(nbasps,nbasp,nbt)
        call copyia(iindxs,iindx1,kdim)
        call copyia(ipndxs,ipndx1,kdim)
c
        call copyaa(zvclgs,zvclg1,kdim)
        call copyaa(acflgs,acflg,nst)
c
        xbarwc = xbarws
        xbrwlc = xbrwls
c
c       Reset the ixbasp and cjbasp arrays. The former is a flag
c       array, each member of which denotes whether the
c       thermodynamic activity of the corresponding basis species
c       is defined in terms of molality (= 0) or mole fraction (= 1).
c       The cjbasp array contains any site stoichiometric factors
c       associated with the operational basis species.
c
        call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $  jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $  netmax,nphasx,nstmax)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the log number of moles variables (losp) for all mineral
c     species.
c
      do kcol = km1,kxt
        ns = iindx1(kcol)
        losp(ns) = zvclg1(kcol)
      enddo
c
c     Delete the desired phase.
c
      np = npdel
      jpflag(np) = 0
      loph(np) = -99999.
      moph(np) = 0.
      nr1 = ncmpr(1,np)
      nr2 = ncmpr(2,np)
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          jsflag(ns) = 0
          losp(ns) = -99999.
          mosp(ns) = 0.
        endif
      enddo
c
c     If the phase to be deleted was the last one added, it is replaced
c     by the phase which had the next highest scaled affinity (as long
c     as such can be found in the limited list maintained for this
c     purpose). Otherwise, the phase to be deleted is just removed.
c
      qadd = .false.
      if (npdel .eq. npaddi) then
        inext = ifail + 1
        if (inext .le. nsspt) then
          npadd = nssp(inext)
c
c         Replace the phase to be deleted with another.
c
          go to 300
        else
c
c         Just delete the phase.
c
c         Note: from here the calculation needs to slide forward
c         in delxi in order to get past a region of computational
c         instability associated with a phase appearance boundary.
c
          go to 400
        endif
      else
c
c       Just delete the phase.
c
        go to 400
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  980 continue
c
c     Test for critical redox instability.
c
      if (qredox) then
        if (idelmx.eq.krdxsp .or. abs(delvec(krdxsp)).ge.2.0) then
          write (noutpt,2000)
          write (nttyo,2000)
 2000     format(/' * Note - (EQ6/eqphas) Caught in a region of',
     $    ' critical redox instability.',/7x,'The value of the redox',
     $    ' master variable (log fO2, Eh, pe-, etc.)',/7x,'is',
     $    ' essentially indifferent to the constraints defining',
     $    ' the state',/7x,'of the ES.')
          ier = 50
          go to 999
        endif
      endif
c
c     Couldn't find a phase to delete from the current phase assemblage.
c     Look for other explanations for the failure to converge.
c
c     Test for critical instability associated with solvent water.
c
      if (kwater .gt. 0) then
        if (idelmx.eq.kwater .or. abs(delvec(kwater)).ge.2.0) then
          write (noutpt,2010)
          write (nttyo,2010)
 2010     format(/' * Note - (EQ6/eqphas) Caught in a region of',
     $    ' critical instability associated',/7x,'with solvent water.')
          if (zvclg1(kwater) .le. -14.0) then
            write (noutpt,2020)
            write (nttyo,2020)
 2020       format(/7x,'There is almost no solvent water present.')
          endif
          ier = 60
          go to 999
        endif
      endif
c
c     Test for instability that appears to be associated with the
c     aqueous activity coefficient model.
c
      if (bgamx.ge.1.0 .or. bfxi.ge.1.0 .or. bsigmm.ge.1.0) then
        write (noutpt,2050) bgamx,fxi,fxio,sigmam,sigmmo
        write (nttyo,2050) bgamx,fxi,fxio,sigmam,sigmmo
 2050   format(/' * Note - (EQ6/eqphas) Caught in a region of',
     $  ' instability that may be',/7x,'associated with the',
     $  ' aqueous activity coefficient model. The max',/7x,'norm of',
     $  ' the activity coefficients for the last change was ',1pe12.5,
     $  /7x,'The last value of the ionic strength in the iteration',
     $  ' was',/7x,e12.5,' molal, the immediately preceding value',
     $  ' was',/7x,e12.5,'. The last value of the sum of the solute',
     $  ' molalities in',/7x,'the iteration was ',e12.5,', the',
     $  ' immediately preceding value was',/7x,e12.5,'.')
        if (zvclg1(kwater) .le. -14.0) then
          write (noutpt,2060)
          write (nttyo,2060)
 2060     format(/7x,'There is almost no solvent water present.')
        endif
        ier = 80
        go to 999
      endif
c
c     Trap out-of-range values for the variables associated with the
c     basis species.
c
      nerr = 0
      do kcol = 1,kbt
        if (zvclg1(kcol) .le. -99999.) then
c
c         Calling sequence substitutions:
c           uzvec1 for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          if (kcol .ne. krdxsp) then
            write (noutpt,2100) uspn56(1:jlen),zvclg1(kcol)
            write (nttyo,2100) uspn56(1:jlen),zvclg1(kcol)
 2100       format(/' * Warning - (EQ6/eqphas) The log number of moles',
     $      ' variable for basis species',/7x,a,' has the out-of-range',
     $      ' value ',1pe12.5,/7x,'after an iteration crash.')
          elseif (qredox) then
            if (krdxsp .eq. ko2gaq) then
              write (noutpt,2110) zvclg1(kcol)
              write (nttyo,2110) zvclg1(kcol)
 2110         format(/' * Warning - (EQ6/eqphas) The log oxygen',
     $        ' fugacity variable has the out-of-range',/7x,'value ',
     $        1pe12.5,' after an iteration crash.')
            elseif (krdxsp .eq. kelect) then
              write (noutpt,2120) zvclg1(kcol)
              write (nttyo,2120) zvclg1(kcol)
 2120         format(/' * Warning - (EQ6/eqphas) The log electron',
     $        ' activity variable has the',/7x,'out-of-range value',
     $        ' ',1pe12.5,' after an iteration crash.')
            else
              write (noutpt,2100) uspn56(1:jlen),zvclg1(kcol)
              write (nttyo,2100) uspn56(1:jlen),zvclg1(kcol)
            endif
          endif
          nerr = nerr + 1
        endif
      enddo
      if (nerr .gt. 0) then
        ier = 110
        go to 999
      endif
c
c     Test simply for almost no solvent water present. This can
c     sometimes be the problem even if some of the other tests
c     applied above fail to detect it.
c
      if (kwater .gt. 0) then
        if (zvclg1(kwater) .le. -14.0) then
          write (noutpt,2030)
          write (nttyo,2030)
 2030     format(/' * Note - (EQ6/eqphas) There appears to be almost',
     $    ' no solvent water present.')
          ier = 70
          go to 999
        endif
      endif
c
c     Okay, can't diagnose what caused the iteration to crash.
c
      write (noutpt,2150)
      write (nttyo,2150)
 2150 format(/' * Note - (EQ6/eqphas) An equilibrium calculation',
     $  ' failed for reasons',/7x,"that couldn't be diagnosed. Will",
     $  ' try to recover.')
      ier = 150
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 continue
c
c     Check to see if the new phase assemblage is the same as the old
c     one. If qmod is true at this point, it only means that the
c     putative phase assemblage has changed in the course of the
c     equilibrium calculations. It may, however, have ended up being
c     the original assemblage.
c
      if (qmod) then
        if (km1.eq.km10 .and. kmt.eq.kmt0) then
          if (kx1.eq.kx10 .and. kxt.eq.kxt0) then
            do kcol = km1,kxt
              if (iindx1(kcol) .ne. iindx0(kcol)) go to 995
            enddo
            qmod = .false.
          endif
        endif
      endif
  995 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine indatd(arr,ipc,ipcx_asv,nad1,narxt,narx_asv,ntprt,
     $ ntpr_asv,ux24)
c
c     This subroutine reads from the unformatted data file (unit number
c     nad1) the 3D array arr, which contains coefficients of
c     interpolating polynomials representing a thermodynamic property
c     as a function of temperature. There are ntprt temperature
c     ranges, and a set of narxt(ntpr) coefficients for the ntpr-th
c     temperature range for the ipc-th entity. When this subroutine is
c     called, another array name is usually substituted for arr and
c     a corresponding dimensioning variable is substituted for ipcx_asv.
c
c     Compare with EQLIB/indatc.f, in which arr is a 2D array.
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nad1   = unit number of the data file
c
c     Principal output:
c
c       arr    = 3D array of polynomial coefficients
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipcx_asv,narx_asv,ntpr_asv
c
      integer nad1
c
      integer narxt(ntpr_asv)
c
      integer ipc,ntprt
c
      real*8 arr(narx_asv,ntpr_asv,ipcx_asv)
c
      character*24 ux24
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,ntpr
c
c-----------------------------------------------------------------------
c
c     The content of ux24 may be useful in debugging, but has no
c     other usage.
c
      read (nad1) ux24
      do ntpr = 1,ntprt
        read (nad1) (arr(n,ntpr,ipc), n = 1,narxt(ntpr))
      enddo
c
      end

      subroutine ldlxrd(delxi,dlxmin,dzvc0,fdzv0,iodb,ipndx1,kdim,
     $ km1,kmax,kxt,loph,nodbmx,nord,noutpt,nptmax,nrd1mx,nttyo,
     $ uphase,zklogu,zvec0)
c
c     This subroutine limits delxi when a phase is rapidly disappearing
c     from the equilibrium system. The particular mechanism here is
c     only designed to slow things down enough so that other mechanisms
c     can efficiently locate the phase disappearance boundary.
c     This mechanism is not employed to increase information density
c     around the boundary.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nodbmx,nptmax,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),ipndx1(kmax)
c
      integer kdim,km1,kxt,nord
c
      character*24 uphase(nptmax)
c
      real*8 dzvc0(nrd1mx,kmax),fdzv0(nrd1mx,kmax),loph(nptmax),
     $ zvec0(kmax)
c
      real*8 delxi,dlxmin,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,j2,kcol,np
c
      integer ilnobl
c
      character*24 unamph
c
      real*8 dlxic,dxsv
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
      unamph = 'Error                   '
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do kcol = km1,kxt
        if (fdzv0(1,kcol) .ge. 0.) go to 100
        do j = 1,nord
          if (dzvc0(j,kcol) .ge .0.) go to 100
        enddo
        np = ipndx1(kcol)
        if (loph(np) .le. zklogu) go to 100
c
c       Here dlxic is the value of delxi at which approximately
c       ninety per cent of the existing mass is destroyed.
c
        dlxic = -0.9*zvec0(kcol)/dzvc0(1,kcol)
        if (dlxic .lt. delxi) then
          delxi = dlxic
          delxi = max(delxi,dlxmin)
          unamph = uphase(np)
        endif
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(5) .gt. 0) then
        if (delxi .lt. dxsv) then
          j2 = ilnobl(unamph)
          write (noutpt,1000) dxsv,delxi,unamph(1:j2)
          write (nttyo,1000) dxsv,delxi,unamph(1:j2)
 1000     format(/' * Note - (EQ6/ldlxrd) The step size has been cut',
     $    ' from ',1pe12.5,/7x,'to ',e12.5,' to limit the dissolution',
     $    ' of ',a,'.')
        endif
      endif
c
      end

      subroutine sippdp(actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,
     $ dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,dlxprl,
     $ dlxprn,eh,eh0plo,eh0prn,eh1plo,eh1prn,eps100,fo2lg,lprcin,
     $ o20plo,o20prn,o21plo,o21prn,ph,ph0plo,ph0prn,ph1plo,ph1prn,
     $ prcinf,qredox,tiplol,tiplot,tiprnl,tiprnt,tistsv,xidump,
     $ xiplol,xiplot,xiprnl,xiprnt,xistsv)
c
c     This subroutine advances the print, plot, and dump points.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      logical qredox
c
      real*8 actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,dlaprn,dleplo,
     $ dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,
     $ dlxdmp,dlxmx0,dlxpll,dlxplo,dlxprl,dlxprn,eh,eh0plo,eh0prn,
     $ eh1plo,eh1prn,eps100,fo2lg,lprcin,o20plo,o20prn,o21plo,o21prn,
     $ ph,ph0plo,ph0prn,ph1plo,ph1prn,prcinf,tiplol,tiplot,tiprnl,
     $ tiprnt,tistsv,xidump,xiplol,xiplot,xiprnl,xiprnt,xistsv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n
c
      real*8 lloc,tsmall,t1day,xloc,yloc
c
cXX   real*8 t1sec,t1min,t1hr,t1year
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
      xiprnt = prcinf
      xiprnl = prcinf
      xiplot = prcinf
      xiplol = prcinf
c
      xidump = prcinf
c
      tiprnt = prcinf
      tiprnl = prcinf
      tiplot = prcinf
      tiplol = prcinf
c
      ph0prn = -prcinf
      eh0prn = -prcinf
      o20prn = -prcinf
      aw0prn = -prcinf
      ph0plo = -prcinf
      eh0plo = -prcinf
      o20plo = -prcinf
      aw0plo = -prcinf
c
      ph1prn = prcinf
      eh1prn = prcinf
      o21prn = prcinf
      aw1prn = prcinf
      ph1plo = prcinf
      eh1plo = prcinf
      o21plo = prcinf
      aw1plo = prcinf
c
cXX   t1sec= 1.0
cXX   t1min= 60.
cXX   t1hr = 3600.
      t1day = 86400.
cXX   t1year = t1day*365.25
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print point for the specified Xi interval.
c
      if (dlxprn .lt. prcinf) then
        n = int( xistsv/dlxprn ) + 1
        xiprnt = n*dlxprn
        if ((xiprnt + eps100) .le. xistsv) xiprnt = xiprnt + dlxprn
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print point for the specified log Xi
c     interval.
c
      if (dlxprl .lt. lprcin) then
        if (xistsv .lt. dlxmx0) then
          xloc = tlg(dlxmx0)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dlxprl )
          yloc = lloc + n*dlxprl
          if ((yloc + eps100) .le. xloc) yloc = yloc + dlxprl
        else
          xloc = tlg(xistsv)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dlxprl ) + 1
          yloc = lloc + n*dlxprl
          if ((yloc + eps100) .le. xloc) yloc = yloc + dlxprl
        endif
        xiprnl = texp(yloc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial plot point for the specified Xi interval.
c
      if (dlxplo .lt. prcinf) then
        n = int( xistsv/dlxplo ) + 1
        xiplot = n*dlxplo
        if ((xiplot + eps100) .le. xistsv) xiplot = xiplot + dlxplo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial plot point for the specified log Xi
c     interval.
c
      if (dlxpll .lt. lprcin) then
        if (xistsv .lt. dlxmx0) then
          xloc = tlg(dlxmx0)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dlxpll )
          yloc = lloc + n*dlxpll
          if ((yloc + eps100) .le. xloc) yloc = yloc + dlxpll
        else
          xloc = tlg(xistsv)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dlxpll ) + 1
          yloc = lloc + n*dlxpll
          if ((yloc + eps100) .le. xloc) yloc = yloc + dlxpll
        endif
        xiplol = texp(yloc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial dump point for the specified Xi
c     interval.
c
      if (dlxdmp. lt. prcinf) then
        n = int( xistsv/dlxdmp ) + 1
        xidump = n*dlxdmp
        if ((xidump + eps100) .le. xistsv) xidump = xidump + dlxdmp
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print point for the specified time interval.
c
      if (dltprn .lt. prcinf) then
        n = int( tistsv/dltprn ) + 1
        tiprnt = n*dltprn
        if ((tiprnt + eps100) .le. tistsv) tiprnt = tiprnt + dltprn
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print point for the specified log time
c     interval.
c
      if (dltprl .lt. lprcin) then
        tsmall = t1day
        if (tistsv .lt. tsmall) then
          xloc = tlg(tsmall)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dltprl )
          yloc = lloc + n*dltprl
          if ((yloc + eps100) .le. xloc) yloc = yloc + dltprl
        else
          xloc = tlg(tistsv)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dltprl ) + 1
          yloc = lloc + n*dltprl
          if ((yloc + eps100) .le. xloc) yloc = yloc + dltprl
        endif
        tiprnl = texp(yloc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial plot point for the specified time interval.
c
      if (dltplo .lt. prcinf) then
        n = int( tistsv/dltplo ) + 1
        tiplot = n*dltplo
        if ((tiplot + eps100) .le. tistsv) tiplot = tiplot + dltplo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial plot point for the specified log time
c     interval.
c
      if (dltpll .lt. lprcin) then
        tsmall = t1day
        if (tistsv .lt. tsmall) then
          xloc = tlg(tsmall)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dltpll )
          yloc = lloc + n*dltpll
          if ((yloc + eps100) .le. xloc) yloc = yloc + dltpll
        else
          xloc = tlg(tistsv)
          lloc = int(xloc)
          n = int( ( xloc - lloc )/dltpll ) + 1
          yloc = lloc + n*dltpll
          if ((yloc + eps100) .le. xloc) yloc = yloc + dltpll
        endif
        tiplol = texp(yloc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print points for the specified pH interval.
c     Note there are two such points, one lower and one higher than the
c     current value.
c
      if (dlhprn .lt. prcinf) then
        n = int( ph/dlhprn )
        ph0prn = n*dlhprn
        if ((ph0prn - eps100) .ge. ph) ph0prn = ph0prn - dlhprn
        ph1prn = (n + 1)*dlhprn
        if ((ph1prn + eps100) .le. ph) ph1prn = ph1prn + dlhprn
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the initial print points for the specified aw interval.
c     Note there are two such points, one lower and one higher than the
c     current value.
c
      if (dlaprn .lt. prcinf) then
        n = int( actw/dlaprn )
        aw0prn = n*dlaprn
        if ((aw0prn - eps100) .ge. actw) aw0prn = aw0prn - dlaprn
        aw1prn = (n + 1)*dlaprn
        if ((aw1prn + eps100) .le. actw) aw1prn = aw1prn + dlaprn
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rsetup(atwt,cbsr,cesr,iern1,ietmax,iindx1,iktmax,
     $ jcode,jern1,jern2,jetmax,jgext,kbt,kmax,mwtges,mwtrc,mwtsp,
     $ nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nct,nctmax,nertmx,netmax,ngext,
     $ noutpt,nptmax,nrct,nrctmx,nrndex,nsrtmx,nstmax,nsts,nstsmx,
     $ nstsr,nttyo,nxridx,nxrtmx,rxbar,ureac,uspec,vosp0,vreac,xgers)
c
c     This subroutine assigns the molecular weights and molar volumes
c     of the reactants. Volumes are treated only for solid reactants
c     for later comparison with the volume of solid products.
c
c        nrct = total number of reactants
c        ureac = name of reactant
c        mwtrc = molecular weight of reactant
c        vreac = molar volume of (solid) reactant
c        jcode = reactant type code
c                0   Mineral
c                1   Solid solution
c                2   Special reactant
c                3   Aqueous species
c                4   Gas
c                5   Generic ion exchanger
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,jetmax,kmax,nbtmax,nbt1mx,nctmax,nertmx,
     $ netmax,nptmax,nrctmx,nsrtmx,nstmax,nstsmx,nxrtmx
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),jcode(nrctmx),jern1(jetmax,netmax),
     $ jern2(jetmax,netmax),jgext(netmax),nbaspd(nbtmax),
     $ ncmpr(2,nptmax),ngext(jetmax,netmax),nrndex(nrctmx),
     $ nsts(nstsmx),nstsr(2,nstmax),nxridx(nrctmx)
c
      integer iern1,kbt,nbt,nct,nrct
c
      character*48 uspec(nstmax)
      character*24 ureac(nrctmx)
c
      real*8 atwt(nctmax),cbsr(nbt1mx,nsrtmx),cesr(nctmax,nsrtmx),
     $ mwtges(netmax),mwtrc(nrctmx),mwtsp(nstmax),
     $ rxbar(iktmax,nxrtmx),vosp0(nstmax),vreac(nrctmx),
     $ xgers(ietmax,jetmax,nertmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,ik,je,j2,jlen,kcol,n,nb,nbb,nc,ne,ner,np,nrc,nrn1,nrn2,
     $ nr1,nr2,ns,nsr,nss,nxr
c
      integer ilnobl
c
      logical qstop
c
      character*56 uspn56
c
c-----------------------------------------------------------------------
c
      qstop = .false.
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 0) then
c
c         Pure mineral reactants.
c
          np = nrndex(nrc)
          ns = ncmpr(1,np)
          mwtrc(nrc) = mwtsp(ns)
          vreac(nrc) = vosp0(ns)
c
          nr1 = nstsr(1,ns)
          nr2 = nstsr(1,ns)
          do n = nr1,nr2
            nb = nsts(n)
            do kcol = 1,kbt
              nbb = iindx1(kcol)
              if (nbb .eq. nb) go to 100
            enddo
c
            nss = nbaspd(nb)
            j2 = ilnobl(ureac(nrc))
c
c           Calling sequence substitutions:
c             uspec(nss) for unam48
c
            call fmspnx(jlen,uspec(nss),uspn56)
c
            write (noutpt,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
            write (nttyo,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
 2100       format(/' * Error - (EQ6/rsetup) The reactant ',a,' is',
     $      ' composed of',/7x,'the basis species ',a,', which',
     $      /7x,'is not in the active basis set.')
            qstop = .true.
  100       continue
          enddo
c
        elseif (jcode(nrc) .eq. 1) then
c
c         Solid solution reactants.
c
          np = nrndex(nrc)
          nrn1 = ncmpr(1,np)
          nrn2 = ncmpr(2,np)
          nxr = nxridx(nrc)
          mwtrc(nrc) = 0.
          vreac(nrc) = 0.
c
          ik = 0
          do ns = nrn1,nrn2
            ik = ik + 1
            mwtrc(nrc) = mwtrc(nrc) + rxbar(ik,nxr)*mwtsp(ns)
            vreac(nrc) = vreac(nrc) + rxbar(ik,nxr)*vosp0(ns)
c
            nr1 = nstsr(1,ns)
            nr2 = nstsr(1,ns)
            do n = nr1,nr2
              nb = nsts(n)
              do kcol = 1,kbt
                nbb = iindx1(kcol)
                if (nbb .eq. nb) go to 110
              enddo
c
              nss = nbaspd(nb)
              j2 = ilnobl(ureac(nrc))
c
c             Calling sequence substitutions:
c               uspec(nss) for unam48
c
              call fmspnx(jlen,uspec(nss),uspn56)
c
              write (noutpt,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
              write (nttyo,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
              qstop = .true.
  110         continue
            enddo
          enddo
c
        elseif (jcode(nrc) .eq. 2) then
c
c         Special reactants.
c
          mwtrc(nrc) = 0.
          nsr = nrndex(nrc)
          do nc = 1,nct
            if (cesr(nc,nsr) .ne. 0.)
     $      mwtrc(nrc) = mwtrc(nrc) + atwt(nc)*cesr(nc,nsr)
          enddo
          vreac(nrc) = 0.
c
          do nb = 1,nbt
            if (cbsr(nb,nsr) .ne. 0.) then
              do kcol = 1,kbt
                nbb = iindx1(kcol)
                if (nbb .eq. nb) go to 120
              enddo
c
              nss = nbaspd(nb)
              j2 = ilnobl(ureac(nrc))
c
c             Calling sequence substitutions:
c               uspec(nss) for unam48
c
              call fmspnx(jlen,uspec(nss),uspn56)
c
              write (noutpt,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
              write (nttyo,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
              qstop = .true.
            endif
  120       continue
          enddo
c
        elseif (jcode(nrc).eq.3 .or. jcode(nrc).eq.4) then
c
c         Aqueous species reactants and gas reactants.
c
          ns = nrndex(nrc)
          mwtrc(nrc) = mwtsp(ns)
          vreac(nrc) = 0.
c
          nr1 = nstsr(1,ns)
          nr2 = nstsr(1,ns)
          do n = nr1,nr2
            nb = nsts(n)
            do kcol = 1,kbt
              nbb = iindx1(kcol)
              if (nbb .eq. nb) go to 130
            enddo
c
            nss = nbaspd(nb)
            j2 = ilnobl(ureac(nrc))
c	
c           Calling sequence substitutions:
c             uspec(nss) for unam48
c
            call fmspnx(jlen,uspec(nss),uspn56)
c
            write (noutpt,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
            write (nttyo,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
            qstop = .true.
  130       continue
          enddo
c
        elseif (jcode(nrc) .eq. 5) then
c
c         Generic ion exchangers.
c
          np = nrndex(nrc)
          ner = nxridx(nrc)
          ne = np - iern1 + 1
c
          mwtrc(nrc) = mwtges(ne)
          vreac(nrc) = 0.
c
          do je = 1,jgext(ne)
            ns = jern1(je,ne) - 1
            do ie = 1,ngext(je,ne)
              ns = ns + 1
              mwtrc(nrc) = mwtrc(nrc) + xgers(ie,je,ner)*mwtsp(ns)
            enddo
          enddo
c
          do je = 1,jgext(ne)
            do ns = jern1(je,ne),jern2(je,ne)
              nr1 = nstsr(1,ns)
              nr2 = nstsr(1,ns)
              do n = nr1,nr2
                nb = nsts(n)
                do kcol = 1,kbt
                  nbb = iindx1(kcol)
                  if (nbb .eq. nb) go to 140
                enddo
c
                nss = nbaspd(nb)
                j2 = ilnobl(ureac(nrc))
c
c               Calling sequence substitutions:
c                 uspec(nss) for unam48
c
                call fmspnx(jlen,uspec(nss),uspn56)
c
                write (noutpt,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
                write (nttyo,2100) ureac(nrc)(1:j2),uspn56(1:jlen)
                qstop = .true.
c
  140           continue
              enddo
            enddo
          enddo
        endif
      enddo
c
      if (qstop) stop
c
      end

      subroutine indatp(apxa,axlksa,bpxa,cdrsa,cessa,iapxa_asv,iapxta,
     $ ibpxa_asv,ibpxta,ikta_asv,jsola,mwtspa,nad1,narx_asv,ncmpra,
     $ ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,nessn,
     $ nessra,nmrn1a,nmrn2a,noutpt,np,npta_asv,ns,nsta_asv,ntpr_asv,
     $ nttyo,nxta,nxta_asv,qclnsa,uendit,uspeca,uphasa,uptsld,
     $ uptypa,zchara)
c
c     This subroutine reads the solid solution superblock from the
c     supporting data file "data1".
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nad1   = unit number of the data file
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxa_asv,ibpxa_asv,ikta_asv,narx_asv,ndrsa_asv,nessa_asv,
     $ npta_asv,nsta_asv,ntpr_asv,nxta_asv
c
      integer noutpt,nttyo
c
      integer iapxta(nxta_asv),ibpxta(nxta_asv),jsola(nxta_asv),
     $ ncmpra(2,npta_asv),ndrsa(ndrsa_asv),ndrsra(2,nsta_asv),
     $ nessa(nessa_asv),nessra(2,nsta_asv)
c
      integer nad1,ndrsn,nerr,nessn,nmrn1a,nmrn2a,np,ns,nxta
c
      logical qclnsa(nsta_asv)
c
      character*24 uphasa(npta_asv),uptypa(npta_asv)
      character*24 uptsld
      character*48 uspeca(nsta_asv)
      character*8 uendit
c
      real*8 apxa(iapxa_asv,nxta_asv),
     $ axlksa(narx_asv,ntpr_asv,nsta_asv),
     $ bpxa(ibpxa_asv,nxta_asv),cdrsa(ndrsa_asv),cessa(nessa_asv),
     $ mwtspa(nsta_asv),zchara(nsta_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,jsolv,n,ncmptv,nsc,nx
c
      integer ilnobl
c
      character*24 uphasv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c     The following need not be SAVEd.
c
      character(len=24), dimension(:), allocatable :: ucompv
c
c-----------------------------------------------------------------------
c
c     Allocate  a scratch array for the names of the end-member
c     components.
c
      ALLOCATE(ucompv(ikta_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The label below defines a loop for reading the blocks in the
c     superblock.
c
  100 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read a species block.
c
c     uphasv  = name of solid solution
c     ncmptv  = number of component species
c     jsolv   = code for solid solution activity coefficients
c
      read (nad1) uphasv,ncmptv,jsolv
      j3 = ilnobl(uphasv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for end of this current superblock.
c
      if (uphasv(1:8) .eq. uendit(1:8)) go to 200
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      np = np + 1
      uphasa(np) = uphasv
      uptypa(np) = uptsld
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nxta = nxta + 1
      nx = nxta
      jsola(nx) = jsolv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ncmptv .gt. 0) then
c
c       Read the names of component species.
c
        read (nad1) (ucompv(n), n = 1,ncmptv)
      else
        write (noutpt,1020) uphasv(1:j3)
        write (noutpt,1020) uphasv(1:j3)
 1020   format(/' * Error - (EQLIB/indatp) The solid solution ',a,
     $  /7x,'has no components specified on the data file.')
       nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the activity coefficient parameters, first the ordinary
c     parameters (apx), then the site-mixing parameters (bpx).
c
      read (nad1) iapxta(nx)
      if (iapxta(nx) .gt. 0) read (nad1) (apxa(n,nx), n = 1,iapxta(nx))
      read (nad1) ibpxta(nx)
      if (ibpxta(nx) .gt. 0) read (nad1) (bpxa(n,nx), n = 1,ibpxta(nx))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Clone the component species.
c
      ncmpra(1,np) = ns + 1
      ncmpra(2,np) = ns + ncmptv
      do n = 1,ncmptv
        ns = ns + 1
        do nsc = nmrn1a,nmrn2a
          if (ucompv(n)(1:24) .eq. uspeca(nsc)(1:24)) then
            call clones(axlksa,cdrsa,cessa,mwtspa,narx_asv,
     $      ndrsa,ndrsa_asv,ndrsn,ndrsra,nessa,nessa_asv,nessn,
     $      nessra,np,npta_asv,ns,nsc,nsta_asv,ntpr_asv,uphasa,
     $      uspeca,zchara)
            qclnsa(ns) = .true.
            go to 130
          endif
        enddo
c
c       The listed component was not found as a pure mineral species.
c
        j2 = ilnobl(ucompv(n))
        write (noutpt,1040) ucompv(n)(1:j2),uphasv(1:j3)
        write (nttyo,1040) ucompv(n)(1:j2),uphasv(1:j3)
 1040   format(/" * Error - (EQLIB/indatp) Couldn't find the pure",
     $  ' phase equivalent',/7x,'of the species',/7x,a,' (',a,'),',
     $  ' therefore',/7x,'could not create it by cloning.')
        nerr = nerr + 1
  130   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop back to read another species block.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate  the scratch array.
c
  200 DEALLOCATE(ucompv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine echolk(axlks,cdrs,ilevel,jsflag,narxmx,ndrs,ndrsmx,
     $ ndrsr,nf,nst,ntprmx,nstmax,press,tempc,uspec,xlks)
c
c     This subroutine prints the species and reactions that are active
c     in the current problem, along with the log K values that
c     correspond to the reactions. Optionally, the coefficients
c     of the interpolating polynomials may also be printed.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/echoz.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ilevel = print level switch
c                  =  0  no print
c                  =  1  print species and reactions only
c                  =  2  also print equilibrium constants
c                  =  3  also print the coefficients of the
c                        interpolating polynomials
c       nf     = unit number of the file to write on
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ndrsmx,ntprmx,nstmax
c
      integer jsflag(nstmax),ndrs(ndrsmx),ndrsr(2,nstmax)
      integer ilevel,nf,nst
c
      character*48 uspec(nstmax)
c
      real*8 axlks(narxmx,ntprmx,nstmax),cdrs(ndrsmx),xlks(nstmax)
      real*8 press,tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,ns
c
c-----------------------------------------------------------------------
c
      if (ilevel .le. 0) go to 999
c
      write (nf,2005)
 2005 format(//' --- Listing of Species and Reactions ---',/)
      if (ilevel .ge. 2) write (nf,2040) tempc,press
 2040 format(7x,'temperature= ',f10.3,'C',
     $ /7x,'pressure= ',g13.6,' bars',/)
c
      do ns = 1,nst
      if (jsflag(ns) .le. 0) then
        write (nf,2050)
 2050   format(' --------------------------------------------------')
c
        call prreac(cdrs,ndrs,ndrsmx,ndrsr,nf,ns,nstmax,uspec)
        if (ilevel .ge. 2) write (nf,2060) xlks(ns)
 2060   format(/10x,'log K= ',f12.4,/)
        if (ilevel .ge. 3) then
          do j = 1,ntprmx
          write (nf,2070) j,(axlks(i,j,ns), i = 1,narxmx)
 2070     format(/3x,'Coefficients for range ',i2,':',/3x,3(2x,g13.6),
     $    /3x,3(2x,g13.6),/)
          enddo
        endif
      endif
      enddo
      write (nf,2050)
c
  999 continue
      end

      subroutine copyla(qarr1,qarr2,nmax)
c
c     This subroutine copies the first nmax elements of the logical
c     array qarr1 into the logical array qarr2. Normally, nmax would
c     be the dimension of both arrays. However, nmax could be less
c     than the true dimension. Also, the arrays could actually have
c     more than one dimension. For example, if qarr1 and qarr2
c     are really qa and qb, respectively, having common dimensions of
c     i1 and i2, this subroutine could be used by calling it in the
c     following manner: call copyla(qa,qb,(i1*i2)). Use this subroutine
c     with caution if the two arrays do not have identical dimensioning
c     or nmax is not the product of the actual (declared) dimensions.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       qarr1  = the first array
c       nmax   = dimension or pseudo-dimension of qarr1 and qarr2
c
c     Output:
c
c       qarr2  = the second array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      logical qarr1(nmax),qarr2(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
c-----------------------------------------------------------------------
c
c     Note that the loop is unrolled.
c
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        qarr2(i) = qarr1(i)
        qarr2(i + 1) = qarr1(i + 1)
        qarr2(i + 2) = qarr1(i + 2)
        qarr2(i + 3) = qarr1(i + 3)
        qarr2(i + 4) = qarr1(i + 4)
        qarr2(i + 5) = qarr1(i + 5)
        qarr2(i + 6) = qarr1(i + 6)
        qarr2(i + 7) = qarr1(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        qarr2(i) = qarr1(i)
      enddo
c
      end

      subroutine gsgsm(conc,dpslm,na,natmax,nsltmx,nstmax,nsxi,nsxmax,
     $ nsxx,pslm,slsum,slsump,uspec)
c
c     This subroutine computes the following first-order sums used
c     in Pitzer's equations:
c
c       SUM(j) S-lambda(ij)*m(j)
c       SUM(j) S-lambda'(ij)*m(j)
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       na     = aqueous species index (i refers to ns, where ns is
c                  the corresponding species index)
c       nsxi   = range pointer array into the nsxx array:
c                  nsxi(1,na) and nsxi(2,na) are the first and last
c                  values of the second subscript (nsx) of the nsxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nsxx   = pointer array:
c                  nsxx(1,nsx) = the species index of the second
c                  species in the nsl-th pair, where
c                  nsxx(2,nsx) = nsl
c       pslm   = array of S-lambda functions
c       dpslm  = array of ionic strength derivatives of the
c                  S-lambda functions
c
c     Principal input:
c
c       slsum  = the sum: SUM(j) S-lambda(ij)*m(j)
c       slsump = the sum: SUM(j) S-lambda'(ij)*m(j)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nsltmx,nstmax,nsxmax
c
      integer nsxi(2,natmax),nsxx(2,nsxmax)
      integer na
c
      character(len=48) uspec(nstmax)
c
      real(8) conc(nstmax),dpslm(2,nsltmx),pslm(nsltmx)
      real(8) slsum,slsump
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ixf,ixl,nsl,nsx,ns2
c
c-----------------------------------------------------------------------
c
      slsum = 0.
      slsump = 0.
      ixf = nsxi(1,na)
      ixl = nsxi(2,na)
c
      do nsx = ixf,ixl
        ns2 = nsxx(1,nsx)
        nsl = nsxx(2,nsx)
        slsum = slsum + pslm(nsl)*conc(ns2)
        slsump = slsump + dpslm(1,nsl)*conc(ns2)
      enddo
c
      end

      subroutine rdwele(atwt,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,
     $ nerr,noutpt,nslist,nttyo,uelem)
c
c     This suboutine reads the chemical elements block from the
c     DATA0 file.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nct    = the number of chemical elements
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       atwt   = array of atomic weghts
c       uelem  = array of chemical element names
c       nerr   = cumulative error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nctmax
c
      integer ndata1,ndat0s,ndat1f,nerr,noutpt,nslist,nttyo
c
      integer nch,nco,nct
c
      character(len=8) uelem(nctmax)
c
      real(8) atwt(nctmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4,nc
c
      integer ilnobl
c
      character(len=80) uline
      character(len=72) uterm,utermc
      character(len=24) ux24
      character(len=8) ux8a,ux8b
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     Skip to the 'elements' block.
c
  110 read(ndat0s,1000,end=120,err=120) uline
      if (uline(1:8) .ne. 'elements') go to 110
 1000 format(a)
      go to 130
c
  120 write(noutpt,1010)
      write(nttyo,1010)
 1010 format(/' * Error - (EQPT/eqpt) End-of-file hit or other read',
     $ /7x,'error occurred while searching for the elements block.')
      stop
c
  130 continue
c
c     Skip the delimiter line below the "elements" header.
c
      read (ndat0s,1000,end=990,err=995) uline
c
      ux24 = 'elements'
      j2 = ilnobl(ux24)
      write (ndata1) ux24
      write (ndat1f,1020) ux24(1:j2)
 1020 format(a)
      write (ndat1f,1020) utermc(1:72)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the chemical elements data.
c
      write (noutpt,1030)
      write (nslist,1030)
 1030 format(/)
      do nc = 1,nct
        read (ndat0s,1000,end=990,err=995) uline
        read (uline,1040,err=995) uelem(nc),atwt(nc)
 1040   format(a8,f10.5,5x,a8,5x,f10.5)
c
c       Check for a blank element name.
c
        j2 = ilnobl(uelem(nc))
        if (j2 .le. 0) then
          write (ux8a,'(i5)') nc
          call lejust(ux8a)
          j3 = ilnobl(ux8a)
          write (noutpt,1050) ux8a(1:j3)
          write (nttyo,1050) ux8a(1:j3)
 1050     format(/' * Error - (EQPT/rdwele) Have encountered a blank',
     $    ' name for chemical',/7x,'element number ',a,' in the list',
     $    ' of elements on the data file.')
          if (nc .gt. 1) then
            ux8b = uelem(nc - 1)
            if (ux8b(1:7) .ne. '<blank>') then
              j4 = ilnobl(ux8b)
              write (noutpt,1060) ux8b(1:j4)
              write (nttyo,1060) ux8b(1:j4)
 1060         format(7x,'This follows the element ',a,'.')
            endif
          endif
          stop
        endif
c
c       Check for a zero atomic weight.
c
        if (atwt(nc) .le. 0.) then
          j2 = ilnobl(uelem(nc))
          write (noutpt,1070) uelem(nc)(1:j2)
          write (nttyo,1070) uelem(nc)(1:j2)
 1070     format(/' * Error - (EQPT/rdwele) Have encountered a zero',
     $    ' atomic weight for ',a,/7x,'on the data file.')
          nerr = nerr + 1
        endif
c
        write (ndata1) uelem(nc),atwt(nc)
        write (ndat1f,1040) uelem(nc),atwt(nc)
        write (noutpt,1080) uelem(nc),atwt(nc)
        write (nslist,1080) uelem(nc),atwt(nc)
 1080   format(' element = ',a8,', atwt = ',f10.5)
      enddo
c
      write (ndat1f,1020) utermc(1:72)
c
c     Skip the ending delimiter.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the indices of O and H.
c
      nerr = 0
      nco = 0
      do nc = 1,nct
        if (uelem(nc)(1:2) .eq. 'O ') then
          nco = nc
          go to 140
        endif
      enddo
c
      write (noutpt,1140)
      write (nttyo,1140)
 1140 format(/' * Error - (EQPT/rdwele) The element O is not present',
     $ ' on the data file',/7x,'as is required.')
      nerr = nerr + 1
c
  140 continue
c
      nch = 0
      do nc = 1,nct
        if (uelem(nc)(1:2) .eq. 'H ') then
          nch = nc
          go to 150
        endif
      enddo
c
      write (noutpt,1150)
      write (nttyo,1150)
 1150 format(/' * Error - (EQPT/rdwele) The element H is not present',
     $ ' on the data file',/7x,'as is required.')
      nerr = nerr + 1
c
  150 continue
c
      if (nco .gt. 0) then
        if (nco .ne. 1) then
          j2 = ilnobl(uelem(1))
          write (noutpt,1160) uelem(1)(1:j2)
          write (nttyo,1160) uelem(1)(1:j2)
 1160     format(/' * Error - (EQPT/rdwele) The first chemical element',
     $    ' on the data file',/7x,'is ',a,'. The first chemical',
     $    ' element must be O. Note also that',/7x,'the corresponding',
     $    ' strict basis species must be H2O. This is an',
     $    /7x,'idiosyncrasy of EQ3/6.')
          nerr = nerr + 1
        endif
      endif
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdwele) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
c
      write (noutpt,2010) nc
      write (nttyo,2010) nc
 2010 format(7x,'The value of the local block line counter is ',i3,'.')
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
 2030   format(7x,'The last line read was the following:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 write (noutpt,2040)
      write (nttyo,2040)
 2040 format(/' * Error - (EQPT/rdwele) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      write (noutpt,2010) nc
      write (nttyo,2010) nc
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine mincsp(cdrsd,jpflag,jsflag,nbaspd,nbtd,nbtmax,ncmpra,
     $ ndrsd,ndrsmx,ndrsrd,nmrn1a,nmrn2a,noutpt,npta,nptmax,nstmax,
     $ nttyo,nxopex,nxopmx,nxopt,nxpemx,uspeca,uxcat,uxopex,uxopt)
c
c     This subroutine executes the mineral subset-selection suppression
c     (nxopt) options.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nptmax,nstmax,nxopmx,nxpemx
c
      integer jpflag(nptmax),jsflag(nstmax),ncmpra(2,nptmax),
     $ nbaspd(nbtmax),ndrsd(ndrsmx),ndrsrd(2,nstmax)
c
      integer nbtd,nmrn1a,nmrn2a,noutpt,npta,nttyo,nxopex,nxopt
c
      character(len=48) uspeca(nstmax)
      character(len=24) uxcat(nxopmx),uxopex(nxpemx)
      character(len=8) uxopt(nxopmx)
c
      real*8 cdrsd(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,jlen,j2,j3,n,nb,nerr,np,np1m1,ns,nse
c
      integer ilnobl,nphase
c
      character(len=56) uspn56
      character(len=24) ux24
      character(len=8) ux8
c
      real*8 cx
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      if (nxopt .le. 0) go to 999
c
      nerr = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      i = 0
      do n = 1,nxopt
        ux8 = uxopt(n)
        call locase(ux8)
        if (ux8(1:4) .eq. 'all ') i = i + 1
      enddo
c
      if (i .gt. 1) then
        write (noutpt,1010)
        write (nttyo,1010)
 1010   format(/' * Error - (EQ6/mincsp) The "all" mineral subset-',
     $  'selection suppression',/7x,'option has been specified more',
     $  ' than once.')
        nerr = nerr + 1
      endif
c
      do n = 1,nxopt
        ux8 = uxopt(n)
        call locase(ux8)
        if (ux8(1:4) .eq. 'all ') then
          j2 = ilnobl(uxcat(n))
          if (j2 .gt. 0) then
            write (noutpt,1020) uxcat(n)(1:j2)
            write (nttyo,1020) uxcat(n)(1:j2)
 1020       format(/' * Error - (EQ6/mincsp) A category may not be',
     $      ' specified for an',/7x,'"all" mineral subset-selection',
     $      ' suppression option. Here "',a,'"',/7x,'is specified',
     $      ' as defining a category.')
            nerr = nerr + 1
          endif
        endif
      enddo
c
      do n = 1,nxopt
        ux8 = uxopt(n)
        call locase(ux8)
        if (ux8(1:8).eq.'alwith ' .or. ux8(1:8).eq.'allwith') then
          ux24 = uxcat(n)
          j2 = ilnobl(ux24)
          if (j2 .le. 0) then
            write (noutpt,1030)
            write (nttyo,1030)
 1030       format(/' * Error - (EQ6/mincsp) A category must be',
     $      ' specified for each',/7x,'"allwith" mineral subset-',
     $      'selection suppression option. Have an',/7x,'instance',
     $      ' where this is lacking.')
            nerr = nerr + 1
          else
            do j = n + 1,nxopt
              ux8 = uxopt(j)
              call locase(ux8)
              if (ux8(1:8).eq.'alwith ' .or. ux8(1:8).eq.'allwith') then
                if (uxcat(j)(1:24) .eq. ux24(1:24)) then
                  write (noutpt,1040) ux24(1:j2)
                  write (nttyo,1040) ux24(1:j2)
 1040             format(/' * Error - (EQ6/mincsp) The string "',a,'"',
     $            ' is repeated in defining',/7x,'a category for an',
     $            ' "allwith" mineral subset-selection suppression',
     $            /7x,'option. It may only be so used once.')
                  nerr = nerr + 1
                endif
              endif
            enddo
          endif
        endif
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      ns = nmrn1a
c
c     Calling sequence substitutions:
c       ncmpra for ncmpr
c       npta for npt
c
      np1m1 = nphase(ncmpra,npta,nptmax,ns) - 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do n = 1,nxopt
        ux8 = uxopt(n)
        call locase(ux8)
        if (ux8(1:4) .eq. 'all ') then
          write (noutpt,1110)
          write (nttyo,1110)
 1110     format(/' * Note - (EQ6/mincsp) Executing the "all" mineral',
     $    ' subset-selection',/7x,'suppression option.')
c
          if (nxopex .gt. 0) then
            write (noutpt,1120)
            write (nttyo,1120)
 1120       format(/9x,'Minerals that are exceptions are:',/)
          endif
c
          np = np1m1
          do ns = nmrn1a,nmrn2a
            np = np + 1
            if (jsflag(ns) .le. 0) then
              do i = 1,nxopex
                if (uspeca(ns)(1:24) .eq. uxopex(i)(1:24)) then
c
c                 Calling sequence substitutions:
c                   uspeca(ns) for unam48
c
                  call fmspnm(jlen,uspeca(ns),uspn56)
                  write (noutpt,1130) uspn56(1:jlen)
                  write (nttyo,1130) uspn56(1:jlen)
 1130             format(11x,a)
                  go to 200
                endif
              enddo
              jsflag(ns) = 1
              jpflag(np) = 1
            endif
  200       continue
          enddo
c
        elseif (ux8(1:8).eq.'alwith ' .or. ux8(1:8).eq.'allwith') then
          do nb = 1,nbtd
            nse = nbaspd(nb)
            if (uspeca(nse)(1:24) .eq. uxcat(n)(1:24)) then
              j3 = ilnobl(uxcat(n))
              write (noutpt,1140) uxcat(n)(1:j3)
              write (nttyo,1140) uxcat(n)(1:j3)
 1140         format(/' * Note - (EQ6/mincsp) Executing the "alwith ',
     $        a,'" mineral',/7x,'subset-selection suppression option.')
c
              if (nxopex .gt. 0) then
                write (noutpt,1120)
                write (nttyo,1120)
              endif
c
              np = np1m1
              do ns = nmrn1a,nmrn2a
                np = np + 1
                if (jsflag(ns) .le. 0) then
c
c                 Calling sequence substitutions:
c                   cdrsd for cdrs
c                   ndrsd for ndrs
c                   ndrsrd for ndrsr
c
                  cx =  coefdr(cdrsd,ndrsd,ndrsmx,ndrsrd,nse,ns,nstmax)
                  if (cx .ne. 0.) then
                    if (nxopex .gt. 0) then
                      do i = 1,nxopex
                        if (uspeca(ns)(1:24) .eq. uxopex(i)(1:24)) then
c
c                         Calling sequence substitutions:
c                           uspeca(ns) for unam48
c
                          call fmspnm(jlen,uspeca(ns),uspn56)
                          write (noutpt,1130) uspn56(1:jlen)
                          write (nttyo,1130) uspn56(1:jlen)
                          go to 210
                        endif
                      enddo
                    endif
                    jsflag(ns) = 1
                    jpflag(np) = 1
                  endif
                endif
  210           continue
              enddo
              go to 220
            endif
          enddo
c
          j3 = ilnobl(uxcat(n))
          write (noutpt,1150) uxcat(n)(1:j3)
          write (nttyo,1150) uxcat(n)(1:j3)
 1150     format(" * Error - (EQ6/mincsp) Don't recognize",
     $    ' "',a,'" as',/7x,'an argument to the "alwith" mineral',
     $    ' subset-selection',/7x,'suppression option.')
          nerr = nerr + 1
c
  220     continue
        else
c
          j2 = ilnobl(uxopt(n))
          j3 = ilnobl(uxcat(n))
          write (noutpt,1160) uxopt(n)(1:j2),uxcat(n)(1:j3)
          write (nttyo,1160) uxopt(n)(1:j2),uxcat(n)(1:j3)
 1160     format(/" * Error - (EQ6/mincsp) Don't recognize",
     $    ' "',a,1x,a,'"',/7x,'as a mineral subset-selection ',
     $    ' suppression option.')
          nerr = nerr + 1
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1170)
      write (nttyo,1170)
 1170 format(1x)
c
      if (nerr .gt. 0) stop
c
cr * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
c
c     This subroutine determines whether or not delxi can be reduced
c     to satisfy some criterion, such as the pH not exceeding the
c     requested maximum value.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nodbmx
c
      integer noutpt
c
      integer iodb(nodbmx)
c
      logical qadjdx
c
      real*8 delxi,dlxmin
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      qadjdx = .false.
      if (delxi .le. dlxmin) then
c
c       The step size is already at the minimum value.
c       Do not cut it.
c
        if (iodb(1) .gt. 0) write (noutpt,1100)
 1100    format(3x,'The step size will not be cut because it is',
     $   ' already at the',/5x,'minimum value.',/)
      else
c
c       Set up to go back and cut the step size to satisfy the
c       accuracy criterion for calculating the point at which the
c       event of concern occurs.
c
        qadjdx = .true.
      endif
c
      end

      subroutine gafsir(actlg,afcnst,affsd,cdrsd,jflagd,ndrsd,ndrsmx,
     $ ndrsrd,nst,nstmax,sidrsp,uspec,xlksd)
c
c     This subroutine computes the saturation indices of the reactions
c     for the destruction of all species. The saturation index is
c     defined as SI = log Q/K, where Q is the activity product and K is
c     the equilibrium constant of the reaction.
c
c     This subroutine is very similar in function to EQLIB/afcalc.f.
c     They both compute affinties and saturation indices. However, the
c     present subroutine does this for all species; the other subroutine
c     does it for a single specified reaction. The former could be
c     written so that it calls the latter inside a loop; however, this
c     is not done for the sake of avoiding the overhead of repeatedly
c     making such a call.
c
c     This subroutine is called by:
c
c       EQLIB/gaffsd.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       actlg  = array of logarithms of thermodynamic activities of
c                  species
c       cdrsd  = coefficients of reactions in the 'd' set
c       ndrsd  = indices of species appearing in reactions in the
c                  'd' set
c       ndrsrd = range pointer array for the ndrsd array
c       xbar   = mole fraction of a species in the phase to which
c                  it belongs
c       xlksd  = logarithms of equilibrium constants for reactions
c                in the 'd' set
c
c     Principal output:
c
c       affsd  = affinities of reactions in the 'd' set for the
c                  dissociation or dissolution of species
c       sidrsp = saturation indices (log Q/K) of reactions in the 'd'
c                  set for the dissociation or dissolution of species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer jflagd(nstmax),ndrsd(ndrsmx),ndrsrd(2,nstmax)
      integer nst
c
      character(len=48) uspec(nstmax)
c
      real(8) actlg(nstmax),affsd(nstmax),cdrsd(ndrsmx),sidrsp(nstmax),
     $ xlksd(nstmax)
      real(8) afcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nr1,nr2,ns,nse,nt
c
      real(8) sx
c
c-----------------------------------------------------------------------
c
c     Zero the sidrsp and affsd arrays. This sets the correct values
c     for species which have jflagd values of 30 and for species whose
c     reactions are identity reactions.
c
      do ns = 1,nst
        sidrsp(ns) = 0.
        affsd(ns) = 0.
      enddo
c
      do ns = 1,nst
        if (jflagd(ns).ne.30 .and. jflagd(ns).ne.27) then
c
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          nt = nr2 - nr1 + 1
          if (nt .lt. 2) go to 120
c
          if (xlksd(ns) .le. -9999999.) then
            sidrsp(ns) = 9999999.
            affsd(ns) = 9999999.
          elseif (xlksd(ns) .ge. 9999999.) then
            sidrsp(ns) = -9999999.
            affsd(ns) = -9999999.
          else
            sx = -xlksd(ns)
            do n = nr1,nr2
              nse = ndrsd(n)
              if (actlg(nse) .gt. -99999.) then
                sx = sx + cdrsd(n)*actlg(nse)
              else
                sx = -9999999.
                go to 110
              endif
            enddo
  110       continue
            sidrsp(ns) = sx
            affsd(ns) = afcnst*sx
          endif
c
        endif
c
  120   continue
      enddo
c
      end

      subroutine gselm(conc,delam,dselm,elam,izmax,narn1,narn2,nazmmx,
     $ nazpmx,nstmax,selm,zchar)
c
c     This subroutine computes the following first order sums used
c     in Pitzer's equations:
c
c       selm(i):  SUM(j) E-lambda(ij)*m(j)
c       dselm(1,i): SUM(j) E-lambda'(ij)*m(j)
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of concentrations
c       elam   = array of E-lambda functions
c       delam  = array of ionic strength derivatives of E-lambda
c                  functions
c       narn1  = start of species range for aqueous solution
c       narn2  = end of species range for aqueous solution
c       zchar  = array of charges
c
c     Principal output:
c
c       selm   = array of sums: 2 SUM(j) E-lambda(ij)*m(j)
c       dselm  = array of the corresponding derivatives with respect
c                  to ionic strength
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nazmmx,nazpmx,nstmax
c
      integer izmax,narn1,narn2
c
      real*8 delam(2,nazpmx,nazpmx),dselm(2,nazmmx:nazpmx),
     $ conc(nstmax),elam(nazpmx,nazpmx),selm(nazmmx:nazpmx),
     $ zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iajz,iz,j,jz
c
      real*8 sum1,sum1p,sum2,sum2p,zj
c
c-----------------------------------------------------------------------
c
c     Note: nazmmx = -nazpmx.
c
      do iz = nazmmx,nazpmx
        selm(iz) = 0.
        dselm(1,iz) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Looping over iz from 1 to izmax, get the quantities for charges
c     iz and -iz simultaneously.
c
      do iz = 1,izmax
        sum1 = 0.
        sum1p = 0.
        sum2 = 0.
        sum2p = 0.
c
        do j = narn1 + 1,narn2
          zj = zchar(j)
          jz = nint(zj)
          iajz = abs(jz)
          if (jz .gt. 0) then
            sum1 = sum1 + elam(iz,iajz)*conc(j)
            sum1p = sum1p + delam(1,iz,iajz)*conc(j)
          elseif (jz .lt. 0) then
            sum2 = sum2 + elam(iz,iajz)*conc(j)
            sum2p = sum2p + delam(1,iz,iajz)*conc(j)
          endif
        enddo
c
        selm(iz) = sum1
        dselm(1,iz) = sum1p
        selm(-iz) = sum2
        dselm(1,-iz) = sum2p
      enddo
c
      end

      subroutine intnsp(coval,covali,ier,jflag,narn1,narn2,nbasp,nbt,
     $ nbti,nbtmax,nchlor,ncosp,ndecsp,nhydr,noutpt,nst,nstmax,nttyo,
     $ ucospi,uspec)
c
c     This subroutine finds the indices of species required to evaluate
c     certain types of constraints, such as a mean activity or a
c     heterogeneous equilibrium.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),nbasp(nbtmax),ncosp(nbtmax),ndecsp(nbtmax)
c
      integer ier,narn1,narn2,nbt,nbti,nchlor,nhydr,nst
c
      character(len=48) ucospi(nbtmax),uspec(nstmax)
c
      real(8) coval(nbtmax),covali(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jfl,jlen,j2,n,nbi,nb1,nb2,ns1,ns2
c
      character(len=56) uspn56
      character(len=24) ublk24
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
c
c-----------------------------------------------------------------------
c
      ier = 0
c
      do nbi = 1,nbti
        nb1 = ndecsp(nbi)
        if (nb1 .le. 0) go to 300
        ns1 = nbasp(nb1)
        jfl = jflag(ns1)
        coval(nb1) = covali(nbi)
        if (jfl.eq.17 .or. jfl.eq.18) then
c
c         Find the species index of the counterion for a mean log
c         activity or neutral log activity combination.
c
          do nb2 = 1,nbt
            ns2 = nbasp(nb2)
            if (ucospi(nbi)(1:24) .eq. uspec(ns2)(1:24)) then
              ncosp(nb1) = ns2
              go to 300
            endif
          enddo
c
          ier = ier + 1
c
c         Calling sequence substitutions:
c           ucospi(nbi) for unam48
c
          call fmspnx(jlen,ucospi(nbi),uspn56)
          if (jfl .eq. 17) then
            write (noutpt,1000) uspn56(1:jlen)
            write (nttyo,1000) uspn56(1:jlen)
 1000       format(/' * Error - (EQ3NR/intnsp) The species ',a,
     $      /7x,'is required for an abs(zj)*log ai + abs(zi)*log aj',
     $      /7x,"constraint (jflag= 17), but it isn't otherwise",
     $      ' present in the',/7x,'current system.')
          elseif (jfl .eq. 18) then
            write (noutpt,1010) uspn56(1:jlen)
            write (nttyo,1010) uspn56(1:jlen)
 1010       format(/' * Error - (EQ3NR/intnsp) The species ',a,
     $      /7x,'is required for a log a(+/-,ij) constraint',
     $      ' (jflag= 18),',/7x,"but it isn't otherwise present",
     $      ' in the current system.')
          endif
c
        elseif (jfl .eq. 21) then
c
c         Find the counterion for the pHCl constraint. Here the
c         constraint may be applied to either H+ or Cl-.
c
          if (ns1 .eq. nhydr) then
            ucospi(nbi) = 'Cl-'
            j2 = 3
            if (nchlor .gt. 0) then
              ncosp(nb1) = nchlor
            else
              ier = ier + 1
              write (noutpt,1020) ucospi(nbi)(1:j2)
              write (nttyo,1020) ucospi(nbi)(1:j2)
 1020         format(/' * Error - (EQ3NR/intnsp) The species ',a,
     $        /7x,'is required for a pHCl constraint (jflag= 21), but',
     $        /7x,"it isn't otherwise present in the current system.")
            endif
          elseif (ns1 .eq. nchlor) then
            ucospi(nbi) = 'H+'
            j2 = 2
            if (nhydr .gt. 0) then
              ncosp(nb1) = nhydr
            else
              ier = ier + 1
              write (noutpt,1020) ucospi(nbi)(1:j2)
              write (nttyo,1020) ucospi(nbi)(1:j2)
            endif
          else
            ier = ier + 1
c
c           Calling sequence substitutions:
c             uspec(ns1) for unam48
c
            call fmspnx(jlen,uspec(ns1),uspn56)
            write (noutpt,1040) uspn56(1:jlen)
            write (nttyo,1040) uspn56(1:jlen)
 1040       format(/' * Error - (EQ3NR/intnsp) The pHCl constraint',
     $      ' (jflag= 21)',/7x,"can't be applied to the species ",a,
     $      '.',/7x,'It can only be applied to H+ or Cl-.')
          endif
c
        elseif (jfl .eq. 25) then
c
c         Find the species index of the species whose heterogeneous
c         reaction is used to define an equilibrium constraint.
c
          n = narn1 - 1
          if (n .ge. 1) then
            do ns2 = 1,n
              if ( ucospi(nbi)(1:24) .eq. uspec(ns2)(1:24) .and.
     $           ( ucospi(nbi)(25:48) .eq. uspec(ns2)(25:48) .or.
     $             ucospi(nbi)(25:48) .eq. ublk24(1:24) ) ) then
                ncosp(nb1) = ns2
                go to 300
              endif
            enddo
          endif
c
          n = narn2 + 1
          if (nst .ge. n) then
            do ns2 = n,nst
              if ( ucospi(nbi)(1:24) .eq. uspec(ns2)(1:24) .and.
     $           ( ucospi(nbi)(25:48) .eq. uspec(ns2)(25:48) .or.
     $             ucospi(nbi)(25:48) .eq. ublk24(1:24) ) ) then
                ncosp(nb1) = ns2
                go to 300
              endif
            enddo
          endif
c
          ier = ier + 1
c
c         Calling sequence substitutions:
c           ucospi(nbi) for unam48
c
          call fmspnx(jlen,ucospi(nbi),uspn56)
          write (noutpt,1050) uspn56(1:jlen)
          write (nttyo,1050) uspn56(1:jlen)
 1050     format(/' * Error - (EQ3NR/intnsp) The species ',a,
     $    /7x,'is required for a heterogeneous equilibrium',
     $    ' constraint',/7x,"(jflag= 25), but it isn't otherwise",
     $    ' present in the current system.')
        endif
  300   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,ndrsmx,
     $ ndrsr,ns,nstmax,si,xlks)
c
c     This subroutine computes the affinity function:
c
c       A = 2.303 RT log Q/K
c
c     and the saturation index:
c
c       SI = RT log Q/K
c
c     for the ns-th reaction. Note that this affinity is the affinity
c     for the forward direction (A(+)), hence it has the same sign as
c     the saturation index (SI).
c
c     EQLIB/gafsir.f makes the same calculations for all reactions.
c
c     This subroutine is called by:
c
c       EQLIB/betas.f
c       EQLIB/hpsat.f
c       EQ6/raff.f
c       EQ6/satchk.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       actlg  = array of log activities of species
c       afcnst = the factor 2.303 RT
c       cdrs   = array of reaction coefficients
c       jflag  = flag array denoting whether species are in the active
c                  basis set (jflag is not 30) or out of it (jflag = 30)
c       ndrs   = array of indices of species whose reaction coefficients
c                  are in the cdrs array
c       ndrsr  = pointer array for the cdrs/ndrs arrays, denoting the
c                  range of entries corresponding to a given reaction
c       ns     = index of the species for whose associated reaction
c                  the affinity and saturation index are to be
c                  calculated
c       xlks   = array of equilibrium constants
c
c     Principal output:
c
c       af     = affinity
c       si     = saturation index (SI)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer jflag(nstmax),jsflag(nstmax),ndrs(ndrsmx),ndrsr(2,nstmax)
      integer ns
c
      real*8 actlg(nstmax),cdrs(ndrsmx),xlks(nstmax)
      real*8 af,afcnst,si
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nr1,nr2,nse,nt
c
c-----------------------------------------------------------------------
c
      if (jsflag(ns) .eq. 2) then
c
c       Species is suppressed.
c
        si = -9999999.
        af = -9999999.
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (jflag(ns) .eq. 30) then
c
c       Species is active, but is required to satisfy equilibrium.
c
        si = 0.
        af = 0.
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nr1 = ndrsr(1,ns)
      nr2 = ndrsr(2,ns)
      nt = nr2 - nr1 + 1
      if (nt .lt. 2) then
c
c       Species has no reaction. Take it to be in equilibrium with
c       itself.
c
        si = 0.
        af = 0.
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (xlks(ns) .ge. 9999999.) then
c
c       The equilibrium constant is unknown (set to pseudo-infinity).
c       Set the SI and affinity to negative pseudo-infinity.
c
        si = -9999999.
        af = -9999999.
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the SI and affinity in the normal way.
c
      si = -xlks(ns)
      do n = nr1,nr2
        nse = ndrs(n)
        if (nse .eq. 0) go to 200
        si = si + cdrs(n)*actlg(nse)
      enddo
      af = afcnst*si
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  200 continue
c
c     The species has no valid reaction. It is a detached auxiliary
c     basis species. Take it to be in equilibrium with itself.
c
      si = 0.
      af = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      program xcon3
c
c     This is the main program of the XCON3 code. Configuration
c     identification, the copyright statement, legal disclaimers,
c     and similar statements are contained in XCON3/aaaxc3.f, the
c     lead-off subroutine in the XCON3 source code. A short description
c     of this program is also contained in that subroutine.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'xcon3/x3op7.h'
c
      include 'eqlib/eqlj8.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
      integer ietpar,iktpar,jetpar,nbtpar,netpar,nodbpa,nopgpa,noprpa,
     $ noptpa,nsqpar,ntitpa,nxicpa,nxmdpa,nxtipa,nxtpar
c
      parameter(ietpar = 10,iktpar = 20,jetpar = 3,nbtpar = 250)
      parameter(netpar = 12,ntitpa = 100,nxmdpa = 40,nxtpar = 50)
      parameter(nodbpa = 20,nopgpa = 20,noprpa = 20,noptpa = 20)
c
      parameter(nsqpar = nbtpar,nxtipa = nxtpar,nxicpa = iktpar*nxtpar)
c
      integer ietmax,iktmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,
     $ noptmx,nsqmax,ntitmx,nxicmx,nxmdmx,nxtimx,nxtmax
c
c-----------------------------------------------------------------------
c
      integer newin,ninpt,ninpts,noutpt,nttyo
c
      integer iodb(nodbpa),iopg(nopgpa),iopr(noprpa),iopt(noptpa),
     $ jflagb(nsqpar),jflgi(nbtpar),jgext(netpar),jgexti(netpar),
     $ jxmod(nxmdpa),kxmod(nxmdpa),ncmpri(2,nxtipa),ncompb(nxtpar),
     $ ngexrt(jetpar,netpar),ngexti(jetpar,netpar)
c
      integer itermx,jpres3,net,neti,nprob,ntitl,nxcon,nxmod
      integer nsq,nxtb
      integer nbti,nobswt,nsbswt,nxti
c
      integer i,icount,iebal3,irdxc3,itdsf3,j,jfli,j2,ik,iktb,k,kl,n,
     $ nb,nerr,nmax,nn,nobsw,nr1,nr2,ns,ntest,nx,nxi,nxic
c
      integer ilnobl
c
      logical qend,qex,qgexsh,qrderr,qxcon,q8bchk,q8beta
c
      character*80 utitl(ntitpa)
      character*56 ugexr(ietpar,jetpar,netpar)
      character*48 uxmod(nxmdpa)
      character*48 ucospi(nbtpar),uobsw(2,nbtpar),usbsw(2,nbtpar),
     $ uspeci(nbtpar)
      character*24 ugexmo(netpar),ugexp(netpar),ugexpi(netpar),
     $ ugexsi(ietpar,jetpar,netpar),usoli(nxtipa),umemi(nxicpa)
      character*24 ubasis(nsqpar),umemb(iktpar,nxtpar),uphas1(nsqpar),
     $ uphas2(nsqpar),usolb(nxtpar),uspecb(nsqpar),uxmd24(nxmdpa)
      character*8 ugexj(jetpar,netpar),ugexji(jetpar,netpar),
     $ uhfgex(ietpar,jetpar,netpar),uvfgex(ietpar,jetpar,netpar),
     $ uxkgex(ietpar,jetpar,netpar)
c
      character*80 uline
      character*24 uacion,ublk24,uebal,uredox,ustr,ustr1,ux24
      character*8 uplatc,uplatm,ustelu,ustxc3,uveelu,uvexc3
      character*8 uv
      character*3 uoldv,uoldvd,unewv
      character*1 uoldf,unewf,ux1
c
      real*8 apresh(5,2)
      real*8 cspb(nsqpar),xbarb(iktpar,nxtpar)
      real*8 covali(nbtpar),xbari(nxicpa)
      real*8 cgexj(jetpar,netpar),cgexpi(netpar),
     $ egexsi(ietpar,jetpar,netpar),mwtges(netpar),
     $ tgexp(netpar),xgexsi(ietpar,jetpar,netpar),
     $ xhfgex(ietpar,jetpar,netpar),xlkgex(ietpar,jetpar,netpar),
     $ xvfgex(ietpar,jetpar,netpar),xlkmod(nxmdpa),zgexj(jetpar,netpar)
c
      real*8 ehi,epstst,fep,fo2lgi,pei,presh,press,rho,scamas,tempc,
     $ tdspkg,tdspl,tolbt,toldl,tolsat,tolspf
c
      real*8 verold,vernew
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       On some systems, a BLOCK DATA subroutine must be declared in an
c       EXTERNAL statement to assure proper loading. On some other
c       systems, this is not necessary, but neither it is not harmful.
c       On yet some other systems, the EXTERNAL statement below may
c       cause a problem. If so, try commenting it out. If you still
c       have trouble, consult your local system documentation or
c       experiment to find out how to correctly handle a BLOCK DATA
c       subroutine on your system. The EXTERNAL statement below should
c       not cause a problem if you are using a compiler which is fully
c       compliant with the Fortran 90 standard. However, there is
c       no guarantee that it will be adequate to assure correct loading
c       of the BLOCK DATA subroutine.
c
        external bkdxc3
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
      data noutpt /0/
c
      data ublk24 /'                        '/
c
      data apresh(1,1) / 1.013200000E+00/,
     $     apresh(2,1) / 0./,apresh(3,1) / 0./,
     $     apresh(4,1) / 0./,apresh(5,1) / 0./,
     $     apresh(1,2) /-4.345000000E-01/,
     $     apresh(2,2) / 7.632333333E-03/,
     $     apresh(3,2) / 5.514000000E-05/,
     $     apresh(4,2) /-1.263733333E-06/,
     $     apresh(5,2) / 1.396800000E-08/
c
      data epstst /1.e-12/
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       Define the console device number.
c
c       The following works on UNIX, PC, and VAX machines.
c
        data nttyo  /6/
c
c       BEGIN_MAC_DEPENDENT_CODE
c
c         data nttyo  /9/
c
c       END_MAC_DEPENDENT_CODE
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
      data ninpt  /9/,ninpts /10/,newin /11/,nxcon /12/
c
c-----------------------------------------------------------------------
c
c     Get configuration identification data.
c
      call aaaxc3(ustxc3,uvexc3)
      call aaaelu(ustelu,uveelu)
      call platfd(uplatc,uplatm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set dimensioning variables.
c
      ietmax = ietpar
      iktmax = iktpar
      jetmax = jetpar
      nbtmax = nbtpar
      netmax = netpar
      nodbmx = nodbpa
      nopgmx = nopgpa
      noprmx = noprpa
      noptmx = noptpa
      nsqmax = nsqpar
      ntitmx = ntitpa
      nxicmx = nxicpa
      nxmdmx = nxmdpa
      nxtimx = nxtipa
      nxtmax = nxtpar
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the INPUT file (the old input file) exist?
c
      inquire(file="input",exist=qex)
      if (.not.qex) then
        write (nttyo,1000)
 1000   format(' * Error- (XCON3/xcon3) The INPUT file (the old input',
     $  ' file).',/7x,"doesn't exist. Check the name that was",
     $  ' specified.')
        go to 999
      endif
c
c     Open the old input file.
c
      open(ninpt,file='input',status='old',err=700)
      go to 710
c
  700 write (nttyo,1010)
 1010 format(" * Error - (XCON3/xcon3) Can't open the INPUT file (the",
     $ ' old input file).')
      go to 999
c
  710 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the old input file format.
c       W = compact
c       D = menu-style
c
      k = 0
      kl = 0
      ntest = 10
      uoldf = 'W'
      do n = 1,100
        read (ninpt,1060) ux1
 1060   format(a1)
        if (ux1(1:1) .ne. 'c') kl = kl + 1
        if (ux1(1:1) .eq. '|') k = k + 1
        if (kl .ge. ntest) then
          if (k .ge. ntest) uoldf = 'D'
          go to 810
        endif
      enddo
  810 continue
      rewind(ninpt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the INPUTS file (the stripped input file) exist?
c     If so, kill it. This file will be used to contain a copy of the
c     old input file, stripped of comment lines.
c
      inquire(file="inputs",exist=qex)
      if (qex) then
        open(ninpts,file='inputs',status='old',err=720)
        close(ninpts,status='delete')
      endif
c
c     Open the INPUTS file.
c
      open(ninpts,file='inputs',status='new',err=720)
      go to 730
c
  720 write (nttyo,1020)
 1020 format(" * Error - (XCON3/xcon3) Can't open the INPUTS file",
     $ /7x,'(the stripped old input file).')
      close(ninpt)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Strip comment lines from the input file. Also strip any blank
c     lines from a "D" format file.
c
  730 if (uoldf(1:1) .eq. 'W') then
        do n = 1,10000
          read (ninpt,1030,end=750) uline
 1030     format(a80)
          if (uline(1:1) .ne. '*') write (ninpts,1030) uline
        enddo
c
        write (nttyo,1040)
 1040   format(" * Error - (XCON3/xcon3) The old input file is too
     $  ' long.")
        close(ninpt)
        close(ninpts,status='delete')
        go to 999
c
  750   continue
      elseif (uoldf(1:1) .eq. 'D') then
        do n = 1,10000
          read (ninpt,1030,end=757) uline
          j2 = ilnobl(uline)
          if (j2 .gt. 0) then
            if (uline(1:1).ne.'*' .and. uline(1:1).ne.'c')
     $      write (ninpts,1030) uline
          endif
        enddo
c
        write (nttyo,1040)
        close(ninpt)
        close(ninpts,status='delete')
        go to 999
c
  757   continue
      endif
c
c     Rewind the stripped input file.
c
      rewind(ninpts)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the NEWIN file (to be the new input file) exist?
c     If so, kill it.
c
      inquire(file="newin",exist=qex)
      if (qex) then
        open(newin,file='newin',status='old',err=760)
        close(newin,status='delete')
      endif
c
c     Open the new input file.
c
      open(newin,file='newin',status='new',err=760)
      go to 770
c
  760 write (nttyo,1050)
 1050 format(" * Error - (XCON3/xcon3) Can't open the NEWIN file",
     $ ' (to be the',/7x,'new input file.)')
      close(ninpt)
      close(ninpts,status='delete')
      go to 999
c
  770 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Input file formats:
c
c       W = compact
c       D = menu-style
c
c        uoldf  = format of the old file
c        unewf  = format of the new file
c
      unewf = ' '
c
c     Input file version levels.
c       '6.0' = version 6.0 (including version 6.1)
c       '7.0' = version 7.0 (including versions 7.0x and 7.1)
c       '7.2' = version 7.2 (including versions 7.2a and 7.2b)
c       '8.0' = version 8.0
c
c         uoldv  = version level of the old file
c         uoldvd = default version level of the old file
c         unewv  = version level of the new file
c
      uoldv = '   '
      uoldvd = '   '
      unewv = '   '
c
c     Set ultimate default values.
c
      uoldvd = '7.0'
      unewv = '7.2'
      unewf = 'W'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does an options file exist?
c
      inquire(file="ixcon",exist=qxcon)
      if (qxcon) then
        open(nxcon,file='ixcon',status='old',err=780)
        go to 790
c
  780   write (nttyo,1055)
 1055   format(/" * Error - (XCON3/xcon3) Can't open the IXCON options",
     $  ' file.')
        close(ninpt)
        close(ninpts,status='delete')
        close(newin)
        go to 999
c
c       Read the IXCON options file.
c
  790  call rddixc(nxcon,uoldvd,unewf,unewv)
      else
        write (nttyo,1057)
 1057   format(/' * Error - (XCON3/xcon3) The IXCON options file',
     $  " doesn't exist.")
        close(ninpt)
        close(ninpts,status='delete')
        close(newin)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the old input file version level.
c       '6.0' = version 6.0 (including version 6.1)
c       '7.0' = version 7.0 (including versions 7.0x and 7.1)
c       '7.2' = version 7.2 (including versions 7.2a and 7.2b)
c       '8.0' = version 8.0
c
      i = 0
      do n = 1,ntitmx + 4
        read (ninpts,1030) uline
        if (uoldf(1:1) .eq. 'W') then
          if (uline(1:8) .eq. 'endit.  ') go to 825
        elseif (uoldf(1:1) .eq. 'D') then
          if (uline(1:8) .eq. '|-------') i = i + 1
          if (i .ge. 3) go to 825
        endif
        j = index(uline,'Version level=')
        if (j .le. 0) j = index(uline,'version level=')
        if (j .gt. 0) then
          uv = uline(j + 14:j + 21)
          go to 840
        endif
      enddo
  825 continue
c
      i = 0
      rewind(ninpts)
      do n = 1,ntitmx
        read (ninpts,1030) uline
        if (uoldf(1:1) .eq. 'W') then
          if (uline(1:8) .eq. 'endit.  ') go to 835
        elseif (uoldf(1:1) .eq. 'D') then
          if (uline(1:8) .eq. '|-------') i = i + 1
          if (i .ge. 3) go to 835
        endif
        j = index(uline,'Version number=')
        if (j .le. 0) j = index(uline,'version number=')
        if (j .gt. 0) then
          uv = uline(j + 15:j + 22)
          go to 840
        endif
      enddo
  835 continue
c
      write (nttyo,1070)
 1070 format(/' * Warning - (XCON3/xcon3) The title on the old input',
     $ /7x,"file doesn't contain a version level tag. If this code is",
     $ /7x,'unable to determine the correct version level by other',
     $ /7x,'means, add a version tag by putting "Version level= X.X",',
     $ /7x,'where "X.X" is the version level, in the title, preferably',
     $ /7x,'on line 3. If there is more than problem on a single input',
     $ /7x,'file, the tag need be put only in the title of the first',
     $ ' problem.')
      go to 880
c
  840 call lejust(uv)
c
      if (uv(1:3) .eq. '6.0') then
        uoldv = '6.0'
      elseif (uv(1:1) .eq. '6') then
        uoldv = '6.0'
      elseif (uv(1:3) .eq. '7.0') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '7.1') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '7.2') then
        uoldv = '7.2'
      elseif (uv(1:1) .eq. '7') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '8.0') then
        uoldv = '8.0'
      elseif (uv(1:1) .eq. '8') then
        uoldv = '8.0'
      else
        j2 = ilnobl(uv)
        write (nttyo,1080) uv(1:j2)
 1080   format(/" * Warning - (XCON3/xcon3) Can't determine the",
     $  /7x,'version level of the old input file. The version level',
     $  /7x,'is specified by a tag in the title of the first problem',
     $  /7x,'on the file as "',a,'". This is not a valid version',
     $  /7x,'level descriptor. Valid descriptors include "6.0", "7.0",',
     $  /7x,'"7.2", and "8.0". If the code is unable to determine the',
     $  /7x,'correct version level, replace the invalid descriptor.')
      endif
c
  880 if (uoldv(1:3) .eq. '   ') then
        rewind(ninpts)
        do n = 1,1000
          read (ninpts,1030,end=838) uline
          j = index(uline,'uacion= ')
          if (j .gt. 0) then
            uoldv = '6.0'
            go to 838
          endif
        enddo
  838   continue
      endif
c
c     If necessary, use the default for the version level of the old
c     input file.
c
      if (uoldv(1:3) .eq. '   ') then
        uoldv = uoldvd
        write (nttyo,1090) uoldvd
 1090   format(/' * Warning - (XCON3/xcon3) Taking the default',
     $  /7x,'value of "',a3,'" for the version level of the old',
     $  /7x,'input file.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the old input file, working from the stripped copy.
c
      rewind(ninpts)
      q8bchk = .false.
      q8beta = .false.
      nprob = 0
  100 nprob = nprob + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero or null various variables.
c
      call initcb(utitl,ntitmx)
c
      call initiz(iopt,noptmx)
      call initiz(iopg,nopgmx)
      call initiz(iopr,noprmx)
      call initiz(iodb,nodbmx)
c
      call initcb(uxmod,nxmdmx)
      call initcb(uxmd24,nxmdmx)
      call initiz(jxmod,nxmdmx)
      call initiz(kxmod,nxmdmx)
      call initaz(xlkmod,nxmdmx)
c
      call initcb(uspecb,nsqmax)
      call initcb(ubasis,nsqmax)
      call initiz(jflagb,nsqmax)
      call initaz(cspb,nsqmax)
      call initcb(uphas1,nsqmax)
      call initcb(uphas2,nsqmax)
c
      call initcb(usolb,nxtmax)
c
      nmax = iktmax*nxtmax
      call initcb(umemb,nmax)
      call initaz(xbarb,nmax)
c
      call initcb(uspeci,nbtmax)
      call initiz(jflgi,nbtmax)
      call initaz(covali,nbtmax)
      call initcb(ucospi,nbtmax)
c
      nmax = 2*nbtmax
      call initcb(usbsw,nmax)
      call initcb(uobsw,nmax)
c
      call initcb(usoli,nxtimx)
c
      call initcb(umemi,nxicmx)
      call initaz(xbari,nxicmx)
c
      nmax = 2*nxtimx
      call initiz(ncmpri,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The uacion variable only appears on version level '6.0' input
c     files. Provide a blank default value.
c
      uacion = ' '
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the current problem on the stripped input file.
c
      if (uoldf(1:1) .eq. 'W') then
        if (uoldv(1:3) .eq. '6.0') then
c
          call rd3w6(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $    qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,uacion,
     $    ubasis,uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,
     $    xbarb,uxmd24,xlkmod)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.0') then
c
          call rd3w7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $    qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $    uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.2') then
c
c         Note: version level 7.2 is identical to version level 7.0
c         for this format.
c
          call rd3w7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $    qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $    uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '8.0') then
c
          call rd3w8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $    ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $    jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $    netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $    noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $    nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $    tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $    ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $    uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $    xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
          if (qrderr) go to 990
c
        else
c
          write (nttyo,1200) uoldv
 1200     format(/' * Error - (XCON3/xcon3) Coding to implement',
     $    /7x,'reading an input file in "W" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      elseif (uoldf(1:1) .eq. 'D') then
c
        if (uoldv(1:3).eq.'8.0' .and. .not.q8bchk) then
c
c         Distinguish 8.0 from 8.0 beta. 8.0 will include the
c         "Advisory:" and the "Option: on further procesing" strings,
c         which 8.0 beta will not. Search for these only between
c         the "Default redox constraint (irdxc3):" line and the
c         "Alter/Suppress Options  | (nxmod)" line.
c
          icount = 0
  120     read(ninpts,1030,end=140) uline
          j2 = index(uline(2:80),'|') - 1
          i = index(uline(2:j2),'Default redox constraint (irdxc3):')                                            |
          if (i .le. 0) go to 120
c
  130     read(ninpts,1030,end=140) uline
          j2 = index(uline(2:80),'|') - 1
          i = index(uline(2:j2),'Advisory:')
          if (i .gt. 0) icount = icount + 1
          i = index(uline(2:j2),'Option: on further processing')
          if (i .gt. 0) icount = icount + 1
          i = index(uline(2:j2),'Alter/Suppress Options  | (nxmod)')
          if (i .gt. 0) go to 140
          if (icount .lt. 2) go to 130
  140     q8beta = icount.lt.2
          q8bchk = .true.
          rewind(ninpts)
        endif
c
        if (uoldv(1:3) .eq. '6.0') then
c
          write (nttyo,1205) uoldv
 1205     format(/' * Error - (XCON3/xcon3) There is no "D" format',
     $    /7x,'for version level "6.0", hence',"can't read an input",
     $    /7x,'file in this format for this version level.')
          go to 990
c
        elseif (uoldv(1:3) .eq. '7.0') then
c
          call rd3d7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $    qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $    uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.2') then
c
c         Note: XCON3/rd3d7.f can read a "D" format input file at
c         version level '7.2' as well as at version level '7.0'.
c
          call rd3d7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $    qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $    uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3).eq.'8.0' .and. q8beta) then
c
          call rd3d8b(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $    ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $    jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $    netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $    noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $    nxmod,nxti,nxtimx,pei,press,qend,qrderr,rho,scamas,tdspkg,
     $    tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,ugexj,
     $    ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,uredox,
     $    usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,xbari,
     $    xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '8.0') then
c
          call rd3d8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $    ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $    jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $    netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $    noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $    nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $    tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $    ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $    uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $    xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
          if (qrderr) go to 990
c
        else
c
          write (nttyo,1210) uoldv
 1210     format(/' * Error - (XCON3/xcon3) Coding to implement',
     $    /7x,'reading an input file in "D" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      else
c
        write (nttyo,1110) uoldf
 1110   format(/' * Error - (XCON3/xcon3) Have unknown format',
     $  /7x,'specifier "',a1,'" for the old input file.')
        go to 990
c
      endif
c
      if (qend) then
        close(ninpt)
        close(ninpts,status='delete')
        close(newin)
        close(nxcon)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make changes in the content of the input file problem.
c
c     Look for the string "Version level= " or Version number= " in the
c     title. This identifies the version level of the input file.
c     If present, change it. If not, insert a new line containing
c     this at the beginning of the title.
c
      do n = 1,ntitl
        j = index(utitl(n),'Version level=')
        if (j .eq. 0) j = index(utitl(n),'version level=')
        if (j .gt. 0) then
          utitl(n)(j + 14:j + 14) = ' '
          utitl(n)(j + 15:j + 17) = unewv
          utitl(n)(j + 18:80) = ' '
          go to 220
        endif
        j = index(utitl(n),'Version number=')
        if (j .eq. 0) j = index(utitl(n),'version number=')
        if (j .gt. 0) then
          utitl(n)(j + 8:j + 14) = 'level= '
          utitl(n)(j + 15:j + 17) = unewv
          utitl(n)(j + 18:80) = ' '
          go to 220
        endif
      enddo
c
      if ((ntitl + 1) .gt. ntitmx) then
        write (nttyo,1115) nprob,ntitmx
 1115   format(/" * Error - (XCON3/xcon3) Can't add a version",
     $  /7x,'level marker to the first input file title of,'
     $  /7x,'problem ',i2,' because this title already has the',
     $  /7x,'maximum length of ',i3,' lines.')
        go to 990
      endif
c
      do n = ntitl,1,-1
        utitl(n + 1) = utitl(n)
      enddo
      ntitl = ntitl + 1
c
      utitl(1)(1:40) = '                                        '
      utitl(1)(41:80) = '                                        '
      utitl(1)(1:15)  = 'Version level= '
      utitl(1)(16:18) = unewv
      utitl(1)(21:27) = '(XCON3)'
c
  220 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get version levels in floating point format.
c
c     Calling sequence substitutions:
c       uoldv for ustr
c       verold for var
c
      call chreal(nttyo,qrderr,uoldv,verold)
c
c     Calling sequence substitutions:
c       unewv for ustr
c       vernew for var
c
      call chreal(nttyo,qrderr,unewv,vernew)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Patch up possible incompatibilities between "D" and "W" formats.
c     The relevant variables here do not appear on EQ6 input files.
c
      if (vernew .lt. 8.0) then
        if (unewf(1:1) .eq. 'D') then
          if (uebal(1:5) .eq. 'none ') uebal = ' '
          if (uebal(1:5) .eq. 'None ') uebal = ' '
          if (uredox(1:5) .eq. 'none ') uredox = ' '
          if (uredox(1:5) .eq. 'None ') uredox = ' '
        elseif (unewf(1:1) .eq. 'W') then
          if (uebal(1:5) .eq. 'None ') uebal = 'none'
          if (uebal(1:1) .eq. ' ') uebal = 'none'
          if (uredox(1:5) .eq. 'None ') uredox = 'none'
          if (uredox(1:1) .eq. ' ') uredox = 'none'
        endif
      else
        if (uebal(1:5) .eq. 'none ') uebal = 'None'
        if (uebal(1:1) .eq. ' ') uebal = 'None'
        if (uredox(1:5) .eq. 'none ') uredox = 'None'
        if (uredox(1:1) .eq. ' ') uredox = 'None'
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (verold.lt.8.0 .and. vernew.ge.8.0) then
c
c       Make translations from pre-Version 8.0 structures to Version 8.0
c       and up structures. All pre-Version 8.0 basis switching is mapped
c       to ordinary basis switching in Version 8.0 and up (none is
c       mapped to special basis switching).
c
        nerr = 0
c
        jpres3 = 0
c
        if (tdspkg .gt. 0.) then
          itdsf3 = 0
        elseif (tdspl .gt. 0.) then
          itdsf3 = 1
        else
          itdsf3 = 0
        endif
c
        j2 = ilnobl(uebal)
        if (j2 .eq. 0) then
          iebal3 = 0
        elseif (uebal(1:j2) .eq. 'None') then
          iebal3 = 0
        elseif (uebal(1:j2) .eq. 'none') then
          iebal3 = 0
        elseif (uebal(1:j2) .ne. 'pick1.') then
          iebal3 = 1
        else
          write (nttyo,1608)
 1608     format(/" * Error - (XCON3/xcon3) Can't translate this",
     $    /7x,'pre-version level 8.0 input file to version level',
     $    /7x,'8.0 or higher because it specifies the option that',
     $    /7x,'the code is to pick a species for electrical balancing',
     $    /7x,'(uebal= "pick1."). This option does not exist in',
     $    /7x,'version level 8.0 or higher. Change the uebal input',
     $    /7x,'on the old input file to blank or the name of a species',
     $    /7x,'to balance on.')
          nerr = nerr + 1
        endif
c
        scamas = 1.
        net = 0
c
        iopt(11) = iopt(2)
        iopt(2) = 0
        iopt(17) = iopt(3)
        iopt(3) = 0
        irdxc3 = iopt(1)
        iopt(1) = 0
        if (iopt(4) .ge. 2) iopt(4) = 1
c
        iopr(10) = iopr(9)
        iopr(9) = iopr(6)
        iopr(6) = iopr(5)
        iopr(5) = 0
        iopr(3) = iopr(8)
        iopr(8) = 0
c
        iodb(3) = iodb(2)
        iodb(2) = 0
c
        nbti = nsq
        nsbswt = 0
        nobswt = 0
c
        if (irdxc3 .eq. -2) then
          pei = fep
        elseif (irdxc3 .eq. -1) then
          ehi = fep
        elseif (irdxc3 .eq. 0) then
          fo2lgi = fep
        endif
c
        j2 = ilnobl(uredox)
        if (j2 .le. 0) uredox = 'None'
        j2 = ilnobl(uebal)
        if (j2 .le. 0) uebal = 'None'
c
        do n = 1,nxmod
          uxmod(n)(1:24) = uxmd24(n)
        enddo
c
        do ns = 1,nsq
c
c         Basis species and basis switching.
c
          nb = ns
          uspeci(nb) = uspecb(ns)
          jflgi(nb) = jflagb(ns)
          covali(nb) = cspb(ns)
          if (uphas2(ns)(1:3) .eq. '   ') then
            ucospi(nb)(1:24) = uphas1(ns)
            ucospi(nb)(25:48) = uphas2(ns)
          else
            ucospi(nb)(1:24) = uphas2(ns)
            ucospi(nb)(25:48) = uphas1(ns)
          endif
          if (ubasis(ns)(1:3) .ne. '   ') then
            nobswt = nobswt + 1
            uobsw(1,nobswt) = uspecb(ns)
            uobsw(2,nobswt) = ubasis(ns)
          endif
        enddo
c
        do nb = 1,nbti
          jfli = jflgi(nb)
          if (jfli.eq.19 .or. jfli.eq.20 .or. jfli.eq.21)
     $    jflgi(nb) = 25
        enddo
c
        do nb = 1,nbti
          jfli = jflgi(nb)
          if (jfli .eq. 31) jflgi(nb) = 20
          if (jfli .eq. 32) jflgi(nb) = 21
        enddo
c
        do nb = 1,nbti
          jfli = jflgi(nb)
          if (jfli.ge.4 .and. jfli.le.8) then
            j2 = ilnobl(uspeci(nb)(1:24))
            write (nttyo,1610) jfli,uspeci(nb)(1:j2)
 1610       format(/" * Error - (XCON3/xcon3) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version level',
     $      /7x,'8.0 or higher because it employs a jflag value of',
     $      /7x,i3,' for ',a,'. This jflag option for specifying',
     $      /7x,'a "free" concentration" is obsolete at the higher',
     $      /7x,'version level.')
            nerr = nerr + 1
          endif
        enddo
c
        qgexsh = .false.
c
        nxti = nxtb
        nxic = 0
        do nx = 1,nxtb
          nxi = nx
          usoli(nxi) = usolb(nx)
          iktb = ncompb(nx)
          ncmpri(1,nxi) = nxic + 1
          ncmpri(2,nxi) = nxic + iktb
          do ik = 1,iktb
            nxic = nxic + 1
            umemi(nxic) = umemb(ik,nx)
            xbari(nxic) = xbarb(ik,nx)
          enddo
        enddo
c
        tolspf = tolsat
c
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((abs(verold - 8.0).le.epstst .and. q8beta)
     $ .and. vernew.ge.8.0) then
c
c       Make additions if converting from Version 8.0 beta to
c       Version 8.0 and up.
c
        qgexsh = .false.
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (verold.ge.8.0 .and. vernew.lt.8.0) then
c
c       Make translations from Version 8.0 and up structures to
c       pre-Version 8.0 structures, and vice versa. Special basis
c       switching in Version 8.0 and up can't be mapped to any
c       pre-Version 8.0 structure.
c
        nerr = 0
c
        if (tempc .le. 100.) then
          presh = apresh(1,1)
        else
          presh = 0.
          do nn = 1,5
            n = 6 - nn
            presh = apresh(n,2) + tempc*presh
          enddo
        endif
c
        if (jpres3 .le. 0) then
          press = 0.
        elseif (jpres3 .eq. 1) then
          write (nttyo,1692)
 1692     format(/' * Note - (XCON3/xcon3) This version level 8.0',
     $    /7x,'or higher input file specifies the option to compute',
     $    /7x,'the pressure from the temperature according to the',
     $    /7x,'1.013-bar/steam-saturation curve (jpres3 = 1). This',
     $    /7x,'option does not directly translate to pre-Version 8.0.',
     $    /7x,'level The pressure at that level implicitly lies on the',
     $    /7x,'data file reference pressure curve, which may or may',
     $    /7x,'not coincide with the 1.013-bar/steam-saturation curve.',
     $    /7x,'To avoid getting this message, change the option on the',
     $    /7x,'old input file to specify computing the pressure',
     $    /7x,'according to the data file reference pressure curve',
     $    /7x,'(jpres3 = 0).')
          press = 0.
        elseif (jpres3 .eq. 2) then
          if (press.gt.0 .and. abs(press - presh).gt.1.e-4) then
            write (nttyo,1700) press,presh
 1700       format(/" * Error - (XCON3/xcon3) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to a lower',
     $      /7x,'version level because it specifies a pressure of',
     $      /7x,f9.4,' bars, which differs from the pre-Version 8',
     $      /7x,'standard grid pressure of ',f9.4,' bars. To convert',
     $      /7x,'this input file, set press = 0., which defaults to',
     $      /7x,'the standard grid pressure.')
            nerr = nerr + 1
          endif
        else
          write (nttyo,1702) jpres3
 1702     format(/" * Error - (XCON3/xcon3) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it specifies an unknown',
     $    /7x,'pressure option (jpres3= ',i2,'.')
          nerr = nerr + 1
        endif
c
        if (itdsf3 .le. 0) then
          continue
        elseif (itdsf3 .ge. 1) then
          continue
        endif
c
        if (iebal3 .le. 0) then
          uebal = ' '
        else
          continue
        endif
c
        if (abs(scamas - 1.0) .gt. 1.e-6) then
          write (nttyo,1710) scamas
 1710     format(/" * Error - (XCON3/xcon3) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it specifies a  scale factor',
     $    /7x,'of ',1pe11.4,' for the mass of aqueous solution to',
     $    /7x,'write on the PICKUP file. Pre-version 8 input files',
     $    /7x,'lack this parameter, effectively assuming a value of',
     $    ' 1.0.',/7x,'To convert this input file, set scamas = 1.0.')
          nerr = nerr + 1
        endif
c
        if (net .gt. 0) then
          write (nttyo,1720) net
 1720     format(/" * Error - (XCON3/xcon3) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it defines ',i2,' generic',
     $    /7x,'ion exchangers.Pre-version 8 input files lack the',
     $    /7x,'generic ion exchange capability.')
          nerr = nerr + 1
        endif
c
        iopt(2) = iopt(11)
        iopt(11) = 0
        iopt(3) = iopt(17)
        iopt(17) = 0
        iopt(1) = irdxc3
        if (iopt(4).ge.1 .and. nxti.gt.0) iopt(4) = 2
c
        if (iopt(19) .gt. 0) then
          write (nttyo,1730)
 1730     format(/" * Warning - (XCON3/xcon3) Can't translate the",
     $    /7x,'"Advanced EQ3NR PICKUP File Options" (iopt(19)) option',
     $    /7x,'specified on this version level 8.0 or higher input',
     $    /7x,'file to a lower version level because this option does',
     $    /7x,'not exist at the lower version level.')
        endif
c
        iopr(5) = iopr(6)
        iopr(6) = iopr(9)
        iopr(9) = iopr(10)
        iopr(10) = 0
        iopr(8) = iopr(3)
        iopr(3) = 0
c
        iodb(2) = iodb(3)
        iodb(3) = 0
c
        if (iopt(1) .eq. -2) then
          fep = pei
        elseif (iopt(1) .eq. -1) then
          fep = ehi
        elseif (iopt(1) .eq. 0) then
          fep = fo2lgi
        endif
c
cXX
        do nb = 1,nbti
          if (jflgi(nb) .eq. 22) then
c
c           Translate the pmH option to a pH option.
c           This is done at the version 8 level. Additional
c           translation may follow.
c
            jflgi(nb) = 20
            iopg(2) = 1
          endif
        enddo
c
        do nb = 1,nbti
          if (jflgi(nb) .eq. 23) then
c
c           The pmX option is not translatable.
c
            j2 = ilnobl(uspeci(nb))
            write (nttyo,1732) uspeci(nb)(1:j2)
 1732       format(/" * Error - (XCON3/xcon3) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to a lower',
     $      /7x,'version level because it contains a pmX input for',
     $      /7x,a,'. The pmX option does not exist at a lower',
     $      /7x,'version level.')
            nerr = nerr + 1
          endif
        enddo
cXX
c
        nsq = nbti
c
        do nb = 1,nbti
c
c         Basis species.
c
          ns = nb
          uspecb(ns) = uspeci(nb)(1:24)
          jflagb(ns) = jflgi(nb)
          cspb(ns) = covali(nb)
          if (ucospi(nb)(25:27) .eq. '   ') then
            uphas1(ns) = ucospi(nb)(1:24)
            uphas2(ns) = ' '
          elseif (ucospi(nb)(25:33) .eq. 'Aqueous solution ') then
            uphas1(ns) = ucospi(nb)(1:24)
            uphas2(ns) = ' '
          elseif (ucospi(nb)(25:28) .eq. 'Gas ') then
            uphas1(ns) = ucospi(nb)(1:24)
            uphas2(ns) = ' '
          else
            uphas2(ns) = ucospi(nb)(1:24)
            uphas1(ns) = ucospi(nb)(25:48)
          endif
        enddo
c
        do ns = 1,nsq
          if (jflagb(ns) .eq. 19) then
            jflagb(ns) = 16
            cspb(ns) = -cspb(ns)
          endif
        enddo
c
        if (unewf(1:1) .eq. 'W') then
          do ns = 1,nsq
            if (jflagb(ns) .eq. 20) then
              jflagb(ns) = 16
              cspb(ns) = -cspb(ns)
            elseif (jflagb(ns) .eq. 21) then
              uphas1(ns) = 'Cl-'
              jflagb(ns) = 17
              cspb(ns) = -cspb(ns)
            endif
          enddo
        else
          do ns = 1,nsq
            if (jflagb(ns) .eq. 20) then
              jflagb(ns) = 31
            elseif (jflagb(ns) .eq. 21) then
              jflagb(ns) = 32
            endif
          enddo
        endif
c
        do ns = 1,nsq
          if (jflagb(ns) .eq. 25) then
            jflagb(ns) = 19
            if (uphas2(ns)(1:24).ne.ublk24(1:24) .and.
     $      uphas2(ns)(1:24).ne.uphas1(ns)(1:24)) jflagb(ns) = 20
            j = index(uphas1(ns),'(g)')
            if (j .gt. 0) jflagb(ns) = 21
          endif
        enddo
c
        if (nsbswt .gt. 0) then
          write (nttyo,1740) nsbswt
 1740     format(/" * Error - (XCON3/xcon3) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it contains ',i3,' directives',
     $    /7x'for special basis switching.')
          nerr = nerr + 1
        endif
c
        do nobsw = 1,nobswt
c
c         Basis switching.
c
          do nb = 1,nbti
            if (uobsw(1,nobsw)(1:48) .eq. uspeci(nb)(1:48)) then
              ns = nb
              ubasis(ns) = uobsw(2,nobsw)
              go to 244
            endif
          enddo
  244     continue
        enddo
c
        do n = 1,nxmod
c
          uxmd24(n) = uxmod(n)(1:24)
c
c         Set the jxmod value. This is a flag for the type of species:
c
c           0 = aqueous species
c           1 = pure mineral
c           2 = gas
c           3 = solid solution
c
c         The jxmod array is not used in Version 8.0 and up. It is
c         not possible to design a perfect logic for determining the
c         correct value. Here there may be a problem in determining
c         whether a species is a pure mineral or a solid solution.
c         Also, in some cases, the Version 8.0 and up option may not
c         map back to the pre-Version 8.0 format.
c
          if (uxmod(n)(25:40) .eq. 'Aqueous solution') then
            jxmod(n) = 0
            go to 250
          endif
c
          if (uxmod(n)(25:28) .eq. 'Gas ') then
            jxmod(n) = 2
            go to 250
          endif
c
          if (uxmod(n)(25:48).ne.uxmod(n)(1:24) .and.
     $      uxmod(n)(25:27).ne.'   ') then
            nerr = nerr + 1
            j2 = ilnobl(uxmod(n))
            write (nttyo,1117) uxmod(n)(1:j2)
 1117       format(/" * Error - (XCON3/xcon3) Can't translate a",
     $      ' suppress/alter option',/7x,'for "',a,'"',
     $      /7x,'to pre-Version 8.0 format.')
            go to 250
          endif
c
          i = index(uxmod(n),'(aq)')
          if (i .gt. 0) then
            jxmod(n) = 0
            go to 250
          endif
c
          ux24 = uxmod(n)(1:24)
          j2 = ilnobl(ux24)
          if (j2 .gt. 0) then
            if (ux24(j2:j2).eq.'+' .or. ux24(j2:j2).eq.'-') then
              jxmod(n) = 0
              go to 250
            endif
          endif
c
          i = index(uxmod(n),'(g)')
          if (i .le. 0) i = index(uxmod(n),'Hydrogen')
          if (i .le. 0) i = index(uxmod(n),'Oxygen')
          if (i .le. 0) i = index(uxmod(n),'Nitrogen')
          if (i .le. 0) i = index(uxmod(n),'Steam')
          if (i .gt. 0) then
            jxmod(n) = 2
            go to 250
          endif
c
          i = index(uxmod(n),'(ss)')
          if (i .le. 0) i = index(uxmod(n),'-ss')
          if (i .le. 0) i = index(uxmod(n),'Carbonate-Calcite')
          if (i .le. 0) i = index(uxmod(n),'Biotite')
          if (i .le. 0) i = index(uxmod(n),'Olivine')
          if (i .le. 0) i = index(uxmod(n),'Plagioclase')
          if (i .le. 0) i = index(uxmod(n),'Orthopyroxene')
          if (i .le. 0) i = index(uxmod(n),'Smectite-di')
          if (i .le. 0) i = index(uxmod(n),'Saponite-tri')
          if (i .gt. 0) then
            jxmod(n) = 3
            go to 250
          endif
c
          i = index(uxmod(n),'ite ')
          if (i .le. 0) i = index(uxmod(n),'ime ')
          if (i .le. 0) i = index(uxmod(n),'ine ')
          if (i .le. 0) i = index(uxmod(n),'Quartz')
          if (i .gt. 0) then
            jxmod(n) = 1
            go to 250
          endif
c
          j2 = ilnobl(uxmod(n))
          write (nttyo,1119) uxmod(n)(1:j2)
 1119     format(/" * Warning - (XCON3/xcon3) Can't unambiguously",
     $    /7x,'determine what kind of species in an alter/suppress',
     $    /7x,'option is "',a,'".',
     $    /7x,'Setting jxmod to 1. Check to see that this is correct',
     $    /7x,'(0 = aqueous species, 1 = pure mineral,',
     $    ' 3 = gas species',
     $    /7x,'3 = solid solution).')
          jxmod(n) = 1
  250    continue
       enddo
c
        nxtb = nxti
        do nxi = 1,nxti
          nx = nxi
          usolb(nx) = usoli(nxi)
          nr1 = ncmpri(1,nxi)
          nr2 = ncmpri(2,nxi)
          ncompb(nx) =  nr2 - nr1 + 1
          ik = 0
          do nxic = nr1,nr2
            ik = ik + 1
            umemb(ik,nx) = umemi(nxic)
            xbarb(ik,nx) = xbari(nxic)
          enddo
        enddo
c
        tolsat = tolspf
c
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (vernew.lt.8.0 .and. unewf(1:1).eq."D") then
c
c       Map any inputs equivalent to pH to pH, and any inputs equivalent
c       to pHCl to pHCl, but only if the new input file is to be in "D"
c       format. Use the hidden jflag values 31 (pH) and 32 (pHCl), which
c       do not exist in the case of "W" format.
c
        do ns = 1,nsq
          ustr = uspecb(ns)
          if (ustr(1:3).eq.'h+ ' .or. ustr(1:3).eq.'H+ ') then
            if (jflagb(ns) .eq. 16) then
              jflagb(ns) = 31
              cspb(ns) = -cspb(ns)
            elseif (jflagb(ns) .eq. 17) then
              ustr1 = uphas1(ns)
              if (ustr1(1:4).eq.'cl- ' .or. ustr1(1:4).eq.'Cl- ')
     $          then
                uphas1(ns) = ' '
                jflagb(ns) = 32
                cspb(ns) = -cspb(ns)
              endif
            endif
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (vernew .ge. 8.0) then
c
c       Map any inputs equivalent to pH to pH, and any inputs equivalent
c       to pHCl to pHCl.
c
        do nb = 1,nbti
          ustr = uspeci(nb)
          if (ustr(1:3) .eq. 'H+ ') then
            jfli = jflgi(nb)
            if (jfli .eq. 16) then
              jflgi(nb) = 20
              covali(nb) = -covali(nb)
            elseif (jfli .eq. 19) then
              jflgi(nb) = 20
            elseif (jfli .eq. 17) then
              ustr1 = ucospi(nb)
              if (ustr1(1:4).eq.'Cl- ') then
                ucospi(nb) = ' '
                jflgi(nb) = 21
                covali(nb) = -covali(nb)
              endif
            endif
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the current problem on the new input file.
c
      if (unewf(1:1) .eq. 'W') then
        if (unewv(1:3) .eq. '6.0') then
c
          call wr3w6(cspb,fep,iktmax,iodb,iopg,iopr,iopt,
     $    itermx,jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,
     $    noprmx,noptmx,nsq,nsqmax,ntitl,ntitmx,nxmdmx,nxmod,
     $    nxtb,nxtmax,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,
     $    uacion,ubasis,uebal,umemb,uphas1,uphas2,uredox,usolb,
     $    uspecb,utitl,xbarb,uxmd24,xlkmod)
c
        elseif (unewv(1:3) .eq. '7.0') then
c
          call wr3w7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,
     $    itermx,jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,
     $    noprmx,noptmx,nsq,nsqmax,ntitl,ntitmx,nxmdmx,nxmod,
     $    nxtb,nxtmax,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,
     $    ubasis,uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,
     $    utitl,xbarb,uxmd24,xlkmod)
c
        elseif (unewv(1:3) .eq. '7.2') then
c
c         Note: version level 7.2 is identical to version level 7.0
c         for this format.
c
          call wr3w7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,
     $    itermx,jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,
     $    noprmx,noptmx,nsq,nsqmax,ntitl,ntitmx,nxmdmx,nxmod,
     $    nxtb,nxtmax,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,
     $    ubasis,uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,
     $    utitl,xbarb,uxmd24,xlkmod)
c
        elseif (unewv(1:3) .eq. '8.0') then
c
          call wr3w8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $    ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $    jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $    netmax,newin,ngexti,ngexrt,nobswt,nodbmx,nopgmx,noprmx,noptmx,
     $    nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,nxmod,nxti,nxtimx,pei,
     $    press,qgexsh,rho,scamas,tdspkg,tdspl,tempc,tgexp,tolbt,toldl,
     $    tolspf,ucospi,uebal,ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,
     $    ugexsi,umemi,uobsw,uredox,usbsw,usoli,uspeci,utitl,uhfgex,
     $    uvfgex,uxkgex,uxmod,xbari,xgexsi,xhfgex,xlkgex,xvfgex,
     $    xlkmod,zgexj)
c
        else
c
          write (nttyo,1220) unewv
 1220     format(/' * Error - (XCON3/xcon3) Coding to implement',
     $    /7x,'writing an input file in "W" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      elseif (unewf(1:1) .eq. 'D') then
        if (unewv(1:3) .eq. '6.0') then
c
          write (nttyo,1230) unewv
 1230     format(/' * Error - (XCON3/xcon3) There is no "D" format',
     $    /7x,'for version level "6.0", hence',"can't write an input",
     $    /7x,'file in this format for this version level.')
          go to 990
c
        elseif (unewv(1:3) .eq. '7.0') then
c
          call wr3d7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,
     $    rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,uebal,
     $    umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
c
        elseif (unewv(1:3) .eq. '7.2') then
c
          call wr3d72(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $    jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,noprmx,noptmx,
     $    nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,
     $    rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,uebal,
     $    umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $    uxmd24,xlkmod)
c
        elseif (unewv(1:3) .eq. '8.0') then
c
          call wr3d8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $    ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $    jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $    netmax,newin,ngexti,ngexrt,nobswt,nodbmx,nopgmx,noprmx,noptmx,
     $    nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,nxmod,nxti,nxtimx,pei,
     $    press,qgexsh,rho,scamas,tdspkg,tdspl,tempc,tgexp,tolbt,toldl,
     $    tolspf,ucospi,uebal,ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,
     $    ugexsi,umemi,uobsw,uredox,usbsw,usoli,uspeci,utitl,uhfgex,
     $    uvfgex,uxkgex,uxmod,xbari,xgexsi,xhfgex,xlkgex,xvfgex,
     $    xlkmod,zgexj)
c
        else
c
          write (nttyo,1240) unewv
 1240     format(/' * Error - (XCON3/xcon3) Coding to implement',
     $    /7x,'writing an input file in "D" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      else
c
        write (nttyo,1130) unewf
 1130   format(/' * Error - (XCON3/xcon3) Have unknown format',
     $  /7x,'specifier "',a1,'" for the new input file.')
        go to 990
c
      endif
c
c     Go back to do another problem on the same input file.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (nttyo,1140) uoldv
 1140 format(/' * Error - (XCON3/xcon3) Have encountered a read',
     $ /7x,'error while reading the old input file. First check the',
     $ /7x,'version level. The version level was taken to be "',a3,'".',
     $ /7x,'If the version level is marked incorrectly in the primary',
     $ /7x,'title of the first problem, correct this, as the default',
     $ /7x,'value read from the IXCON file or set in the code itself',
     $ /7x,'does not override this. If the problem is not due to an',
     $ /7x,'error in the assumed version level, there is probably a',
     $ /7x,'format error on the old input file. Check the stripped',
     $ /7x,'copy of the old input file (INPUTS).')
c
c     Close all files. Don't delete the inputs file. Delete the NEWIN
c     file, which is not valid.
c
      close(ninpt)
      close(ninpts)
      close(newin,status='delete')
      close(nxcon)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine raff(acflg,actlg,afcnst,affp,afrc1,bpx,cdrs,cgexj,
     $ ibpxmx,ibpxt,iern1,ietmax,iktmax,ixrn1,ixrn2,jcode,jern1,jern2,
     $ jetmax,jflag,jgext,jpflag,jsflag,jsol,ncmpr,ndrs,ndrsmx,ndrsr,
     $ nertmx,net,netmax,ngext,noutpt,nptmax,nrct,nrctmx,nrndex,
     $ nstmax,nttyo,nxridx,nxrtmx,nxtmax,rxbar,uphase,uspec,wfac,
     $ xbar,xbarlg,xgers,xlks)
c
c     This subroutine calculates the affinities of irreversible
c     reactions (afrc1).
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ibpxmx,ietmax,iktmax,jetmax,ndrsmx,nertmx,netmax,nptmax,
     $ nrctmx,nstmax,nxrtmx,nxtmax
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),jcode(nrctmx),jern1(jetmax,netmax),
     $ jern2(jetmax,netmax),jflag(nstmax),jgext(netmax),jpflag(nptmax),
     $ jsflag(nstmax),jsol(nxtmax),ncmpr(2,nptmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax),ngext(jetmax,netmax),nrndex(nrctmx),
     $ nxridx(nrctmx)
c
      integer iern1,ixrn1,ixrn2,net,nrct
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 acflg(nstmax),actlg(nstmax),affp(nptmax),afrc1(nrctmx),
     $ bpx(ibpxmx,nxtmax),cdrs(ndrsmx),cgexj(jetmax,netmax),
     $ rxbar(iktmax,nxrtmx),wfac(iktmax,nxtmax),xbar(nstmax),
     $ xbarlg(nstmax),xgers(ietmax,jetmax,nertmx),xlks(nstmax)
c
      real*8 afcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with fixed global dimensioning.
c
      integer jflgx(iet_par,net_par),jsflgx(iet_par,net_par)
c
      real(8) acflge(iet_par,jet_par),actlge(iet_par,jet_par),
     $ xbarle(iet_par,jet_par),xbare(iet_par,jet_par)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with variable global dimensioning.
c
      integer isv_iktmax
c
      SAVE isv_iktmax
c
      real(8), dimension(:), allocatable :: acflgs,actlgs,xbarls,xbars
c
      SAVE acflgs,actlgs,xbarls,xbars
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,ik,je,jpflgx,k,ne,ner,np,nrc,nr1,nr2,ns,nxr
c
      real*8 af,affpr,si,xx
c
      real*8 tlg
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(acflgs)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_iktmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (iktmax .ne. isv_iktmax) then
          DEALLOCATE(acflgs,actlgs,xbarls,xbars)
          isv_iktmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_iktmax .eq. 0) then
        ALLOCATE(acflgs(iktmax),actlgs(iktmax))
        ALLOCATE(xbarls(iktmax),xbars(iktmax))
        isv_iktmax = iktmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,iktmax
        acflgs(k) = 0.
        actlgs(k) = -99999.
        xbars(k) = 0.
        xbarls(k) = -99999.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recall the following jreac reactant status flag conventions:
c
c       jreac =  0: set to react
c       jreac =  1: exhausted
c       jreac = -1: saturated, but the remaining reactant mass
c                     continues to react irreversibly
c       jreac =  2: saturated; the status of any remaining reactant
c                     mass is changed to that of a product phase
c
c     When jreac = -1 or 2, the affinity is zero by definition.
c     However, the corresponding computed affinities returned from the
c     present subroutine may be non-zero, owing to finite convergence
c     tolerances. Avoid calculating finite differences from such
c     computed affinity values in EQ6/stepfd.f. However, do not set
c     the corresponding afrc1 values to zero in the present subroutine.
c
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 0) then
c
c          Pure minerals.
c
           np = nrndex(nrc)
           afrc1(nrc) = -affp(np)
c
        elseif (jcode(nrc) .eq. 1) then
c
c         Solid solutions.
c
          np = nrndex(nrc)
          nxr = nxridx(nrc)
c
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
c
          ik = 0
          do ns = nr1,nr2
            ik = ik + 1
            acflgs(ik) = acflg(ns)
            actlgs(ik) = actlg(ns)
            xbarls(ik) = xbarlg(ns)
            xbars(ik) = xbar(ns)
            xx = rxbar(ik,nxr)
            xbar(ns) = xx
            xbarlg(ns) = tlg(xx)
          enddo
c
c         Calling sequence substitutions:
c           acflg for acflgc
c
          call lambda(acflg,afcnst,bpx,ibpxmx,ibpxt,iktmax,ixrn1,
     $    ixrn2,jsol,ncmpr,noutpt,np,nptmax,nstmax,nttyo,nxtmax,wfac,
     $    xbar,xbarlg,uphase,uspec)
c
          do ns = nr1,nr2
            actlg(ns) = xbarlg(ns) + acflg(ns)
          enddo
c
          affpr = 0.
          ik = 0
          do ns = nr1,nr2
            ik = ik + 1
            xx = xbar(ns)
            if (xx .gt. 0.) then
              call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,ndrsmx,
     $        ndrsr,ns,nstmax,si,xlks)
              if (af .gt. -9999999.) then
                affpr = affpr + xx*af
              else
                affpr = -9999999.
                go to 100
              endif
            endif
          enddo
  100     continue
          afrc1(nrc) = -affpr
c
          ik = 0
          do ns = nr1,nr2
            ik = ik + 1
            acflg(ns) = acflgs(ik)
            actlg(ns) = actlgs(ik)
            xbarlg(ns) = xbarls(ik)
            xbar(ns) = xbars(ik)
          enddo
c
        elseif (jcode(nrc) .eq. 2) then
c
c         Special reactants.
c
          afrc1(nrc) = 9999999.
c
        elseif (jcode(nrc) .eq. 3) then
c
c         Aqueous species.
c
          afrc1(nrc) = 9999999.
c
        elseif (jcode(nrc) .eq. 4) then
c
c         Gases.
c
          afrc1(nrc) = 9999999.
c
        elseif (jcode(nrc) .eq. 5) then
c
c         Generic ion exchangers.
c
          np = nrndex(nrc)
          ner = nxridx(nrc)
          ne = np - iern1 + 1
c
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
c
          jpflgx = jpflag(np)
          jpflag(np) = 0
c
          do je = 1,jgext(ne)
            ns = jern1(je,ne) - 1
            do ie = 1,ngext(je,ne)
              ns = ns + 1
              jsflgx(ie,je) = jsflag(ns)
              jsflag(ns) = 0
              jflgx(ie,je) = jflag(ns)
              jflag(ns) = 0
              acflge(ie,je) = acflg(ns)
              actlge(ie,je) = actlg(ns)
              xbarle(ie,je) = xbarlg(ns)
              xbare(ie,je) = xbar(ns)
              xx = xgers(ie,je,ner)
              xbar(ns) = xx
              xbarlg(ns) = tlg(xx)
            enddo
          enddo
c
c         Calculate activity coefficients. Recall that these may
c         non-zero even in the case of ideal exchangers, due to
c         site-mixing.
c
c         Calling sequence substitutions:
c           acflg for acflgc
c
          call lamgex(acflg,cgexj,jern1,jern2,jetmax,jgext,net,
     $    netmax,nstmax,xbarlg)
c
          do ns = nr1,nr2
            actlg(ns) = xbarlg(ns) + acflg(ns)
          enddo
c
          affpr = 0.
          do je = 1,jgext(ne)
            ns = jern1(je,ne) - 1
            do ie = 1,ngext(je,ne)
              ns = ns + 1
              xx = xbar(ns)
              if (xx .gt. 0.) then
                call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,
     $          ndrsmx,ndrsr,ns,nstmax,si,xlks)
                if (af .gt. -9999999.) then
                  affpr = affpr + xx*af
                else
                  affpr = -9999999.
                  go to 110
                endif
              endif
            enddo
          enddo
  110     continue
          afrc1(nrc) = -affpr
c
          jpflag(np) = jpflgx
c
          do je = 1,jgext(ne)
            ns = jern1(je,ne) - 1
            do ie = 1,ngext(je,ne)
              ns = ns + 1
              jsflag(ns) = jsflgx(ie,je)
              jflag(ns) = jflgx(ie,je)
              acflg(ns) = acflge(ie,je)
              actlg(ns) = actlge(ie,je)
              xbarlg(ns) = xbarle(ie,je)
              xbar(ns) = xbare(ie,je)
            enddo
          enddo
        endif
c
      enddo
c
      end

      real*8 function arrmxn(array,nmax)
c
c     This subroutine finds the max norm of the real*8 array "array".
c     Note that array could actually have more than one dimension. For
c     example, if the array is really "a", which has dimensions of i1
c     and i2, this subroutine could be used by calling it in the
c     following manner: call arrmxn(a,(i1*i2)). Use this subroutine
c     with caution if nmax is not the product of the true (declared)
c     dimensions.
c
c     To find the index of the first element corresponding to the max
c     norm, call EQLIBU/iarmxn.f instead. Then just use the index to
c     get the max norm if this is also desired.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array  = the array
c       nmax   = the dimension or pseudo-dimension of the array
c
c     Output:
c
c       arrmxn = the max norm of the array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 aax,ax
c
c-----------------------------------------------------------------------
c
      arrmxn = 0.
      if (nmax .le. 0) go to 999
c
c     Note the use of a local variable (ax) within the loop.
c     Note also that the loop is unrolled.
c
      ax = 0.
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        aax = abs(array(i))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 1))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 2))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 3))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 4))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 5))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 6))
        if (aax .gt. ax) ax = aax
        aax = abs(array(i + 7))
        if (aax .gt. ax) ax = aax
      enddo
c
      do i = ileft + 1,nmax
        aax = abs(array(i))
        if (aax .gt. ax) ax = aax
      enddo
c
      arrmxn = ax
c
  999 continue
      end

      subroutine rderiv(akmat0,drer0,drir0,fdri0,fdrr0,jreac,nord,
     $ nrct,nrctmx,nrd1mx)
c
c     This subroutine transforms finite differences of the rates of
c     irreversible reactions into the corresponding derivatives.
c     Note that (drer0) = (akmat0)(fdrr0). The inverse rate is treated
c     similarly; i.e., (drir0) = (akmat0)(fdri0).
c
c     Compare with:
c
c       EQ6/aderiv.f
c       EQ6/bderiv.f
c       EQ6/pderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/chksti.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx,nrd1mx
c
      integer jreac(nrctmx)
c
      integer nord,nrct
c
      real*8 akmat0(nrd1mx,nrd1mx),drer0(nrd1mx,nrctmx),
     $ drir0(nrd1mx),fdri0(nrd1mx),fdrr0(nrd1mx,nrctmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,nrc
c
      real*8 dxx
c
c-----------------------------------------------------------------------
c
c     Calculate the derivatives of the inverse rate.
c
      do n = 1,nord
        dxx = 0.
        do k = n,nord
          dxx = dxx + fdri0(k)*akmat0(n,k)
        enddo
        drir0(n) = dxx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the derivatives of the rates of irreversible reactions.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1)  then
          do n = 1,nord
            dxx = 0.
            do k = n,nord
              dxx = dxx + fdrr0(k,nrc)*akmat0(n,k)
            enddo
            drer0(n,nrc) = dxx
          enddo
        endif
      enddo
c
      end

      subroutine zderiv(akmat0,dzvc0,fdzv0,kdim,kmax,nord,nrd1mx)
c
c     This subroutine computes estimates of the derivatives of the
c     master algebraic variables (z vector) from the corresponding
c     finite differences. Note that (dzvc0) = (akmat0)(fdzv0).
c
c     Compare with:
c       EQ6/aderiv.f
c       EQ6/bderiv.f
c       EQ6/pderiv.f
c       EQ6/rderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer kmax,nrd1mx
c
      integer kdim,nord
c
      real*8 akmat0(nrd1mx,nrd1mx),dzvc0(nrd1mx,kmax),fdzv0(nrd1mx,kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,kcol,n
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
      do kcol = 1,kdim
        do n = 1,nord
          dx = 0.
          do k = n,nord
            dx = dx + fdzv0(k,kcol)*akmat0(n,k)
          enddo
          dzvc0(n,kcol) = dx
        enddo
      enddo
c
      end

      subroutine swtchk(cdrs,jflag,jsflag,nbaspx,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,noutpt,ns1,ns2,nstmax,nttyo,uspec)
c
c     This subroutine checks a proposed basis switch for EQLIB/switch.f
c     to see if doing the switch is ok or not.
c
c     This subroutine is called by:
c
c       EQLIB/switch.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),jsflag(nstmax),nbaspx(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax)
      integer nbt,ns1,ns2
c
      character*48 uspec(nstmax)
c
      real*8 cdrs(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen1,jlen2,nb2,ncmpt2,nerr
c
      integer nbasis
c
      character*56 usp156,usp256
c
      real*8 cx12
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
c     Calling sequence substitutions:
c       jlen1 for jlen
c       uspec(ns1) for unam48
c       usp156 for uspn56
c
      call fmspnx(jlen1,uspec(ns1),usp156)
c
c     Calling sequence substitutions:
c       jlen2 for jlen
c       uspec(ns2) for unam48
c       usp256 for uspn56
c
      call fmspnx(jlen2,uspec(ns2),usp256)
c
      if (ns1 .eq. ns2) then
        write (noutpt,1000) usp156(1:jlen1)
        write (nttyo,1000) usp156(1:jlen1)
 1000   format(/" * Error - (EQLIB/swtchk) Can't replace the species ",
     $  a,/7x,'with itself in the basis set.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the first species is not suppressed
c
      if (jsflag(ns1) .gt. 0) then
        write (noutpt,1010) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1010) usp156(1:jlen1),usp256(1:jlen2)
 1010   format(/" * Error - (EQLIB/swtchk) Can't replace the species ",
     $  a,/7x,'in the basis set with ',a,', because the former is',
     $  ' suppressed.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the second species is not suppressed
c
      if (jsflag(ns2) .gt. 0) then
        write (noutpt,1020) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1020) usp156(1:jlen1),usp256(1:jlen2)
 1020   format(/" * Error - (EQLIB/swtchk) Can't replace the species ",
     $  a,/7x,'in the basis set with ',a,', because the latter is',
     $  ' suppressed.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the linking reaction.
c
      ncmpt2 = ndrsr(2,ns2) - ndrsr(1,ns2) + 1
      if (ncmpt2 .lt. 2) then
c
c       The second species must not be in the strict basis, because
c       there is then no possibility of a linking reaction.
c
        write (noutpt,1030) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1030) usp156(1:jlen1),usp256(1:jlen2)
 1030   format(/" * Error - (EQLIB/swtchk) Can't replace the species ",
     $  a,/7x,'in the basis set with ',a,', because the latter is',
     $  ' already in',/7x,'the strict basis set, so there is no',
     $  ' possibility of a valid',/7x,'linking reaction.')
      else
c
c       Make sure that the first species appears as a product in the
c       reaction belonging to the second species.
c
c       Calling sequence substitutions:
c         ns1 for nse
c         ns2 for ns
c
        cx12 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns2,nstmax)
        if (cx12 .eq. 0.) then
        write (noutpt,1040) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1040) usp156(1:jlen1),usp256(1:jlen2)
 1040   format(/" * Error - (EQLIB/swtchk) Can't replace the species ",
     $  a,/7x,'in the basis set with ',a,', because the former does',
     $  ' not appear',/7x,'in the linking reaction.')
c
c         Calling sequence substitutions:
c           noutpt for nf
c           ns2 for ns
c
          call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns2,nstmax,uspec)
          nerr = nerr + 1
        endif
      endif
c
      if (jflag(ns2) .ne. 30) then
c
c       Calling sequence substitutions:
c         nbaspx for nbasp
c         ns2 for ns
c
        nb2 = nbasis(nbaspx,nbt,nbtmax,ns2)
        if (nb2 .gt. 0) then
          write (noutpt,1050) usp156(1:jlen1),usp256(1:jlen2)
          write (nttyo,1050) usp156(1:jlen1),usp256(1:jlen2)
 1050     format(/" * Error - (EQLIB/swtchk) Can't replace the",
     $    ' species ',a,/7x,'in the basis set with ',a,', because',
     $    ' the latter is already in',/7x,'the active basis set.')
          nerr = nerr + 1
        endif
      endif
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine wr6pkw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $ dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $ dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $ dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $ ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $ iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $ jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $ mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $ nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $ nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $ nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $ ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $ nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $ pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $ tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $ ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $ ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $ usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $ uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $ xlkmod,xvfgex,zgexj,zvclgi)
c
c     This subroutine writes the EQ6 pickup file in compact ("W") format
c     for version 8.0.
c
c     This subroutine is a near-clone of XCON6/wr6w8.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQLIB/wr6pkd.f, XCON6/wr6d8.f, and XCON6.wr6w8.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ6/rd6ind.f, EQ6/rd6inw.f, XCON6/rd6d8.f, and XCON6/rd6w8.f,
c     except that newin is added and ninpts, nprob, noutpt, qend,
c     and qrderr are deleted.
c
c     To correctly perform the write function in EQ6, certain variables
c     and arrays must first be updated by calling EQ6/setpk6.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,imchmx,jetmax,kmax,nbtmax,nbt1mx,nctmax,
     $ ndctmx,nertmx,netmax,nffgmx,nodbmx,nopgmx,noprmx,noptmx,nordmx,
     $ nprpmx,nprsmx,nptkmx,nrctmx,nsrtmx,ntitmx,nttkmx,nxmdmx,nxopmx,
     $ nxpemx,nxrtmx
c
      integer newin
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),iesrti(nsrtmx),
     $ igerti(jetmax,nertmx),imech(2,nrctmx),iodb(nodbmx),iopg(nopgmx),
     $ iopr(noprmx),iopt(noptmx),ixrti(nxrtmx),jcode(nrctmx),
     $ jflgi(nbtmax),jgerti(nertmx),jgext(netmax),jreac(nrctmx),
     $ kxmod(nxmdmx),ndact(imchmx,2,nrctmx),ngexrt(jetmax,netmax),
     $ nrk(2,nrctmx),nsk(nrctmx)
c
      integer itermx,jpress,jtemp,kbt,kct,kdim,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxt,nbti,nffg,nert,net,nobswt,nprpti,nprsti,nrct,nsbswt,
     $ nsrt,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt,nxrt
c
      logical qgexsh
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ubmtbi(nbtmax),uobsw(2,nbtmax),uprspi(nprsmx),
     $ usbsw(2,nbtmax),uxmod(nxmdmx),uzveci(kmax)
      character*24 ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),ugermo(nertmx),
     $ ugersi(ietmax,jetmax,nertmx),ugexmo(netmax),ugexp(netmax),
     $ uprphi(nprpmx),ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character*8 uesri(nctmax,nsrtmx),ugerji(jetmax,nertmx),
     $ ugexj(jetmax,netmax),uhfgex(ietmax,jetmax,netmax),
     $ uvfgex(ietmax,jetmax,netmax),uxkgex(ietmax,jetmax,netmax),
     $ uxopt(nxopmx)
c
      real*8 cbsri(nbt1mx,nsrtmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ cesri(nctmax,nsrtmx),cgexj(jetmax,netmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),
     $ egersi(ietmax,jetmax,nertmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprphi(nprpmx),mprspi(nprsmx),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),ptk(nptkmx),rkb(imchmx,2,nrctmx),
     $ rxbari(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),
     $ tgexp(netmax),trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),
     $ xgersi(ietmax,jetmax,nertmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkffg(nffgmx),xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zvclgi(kmax),zgexj(jetmax,netmax)
c
      real*8 awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,electr,o2maxi,o2mini,phmaxi,
     $ phmini,pressb,pressi,tempcb,tempci,timmxi,tistti,tolbt,toldl,
     $ tolsat,tolxsf,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,iki,je,jei,j2,j3,j4,kcol,krow,n,nbi,nci,ne,ner,npi,
     $ nrc,nsi,nsr,nxr
c
      integer ilnobl
c
      logical qx
c
      character*8 uendit
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     Main title.
c
      do n = 1,ntitl1
        j2 = ilnobl(utitl1(n))
        write (newin,1020) utitl1(n)(1:j2)
 1020   format(a)
      enddo
      j3 = ilnobl(uendit)
      if (ntitl1 .lt. ntitmx) write (newin,1020) uendit(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature parameters.
c     Note: ttk(1) = ttk1, etc.
c
      write (newin,1130) jtemp,tempcb,ttk(1),ttk(2)
 1130 format(5x,'jtemp= ',i2,/4x,'tempcb= ',1pe12.5,
     $ /6x,'ttk1= ',1pe12.5,6x,'ttk2= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure parameters.
c     Note: ptk(1) = ptk1, etc.
c
      write (newin,1140) jpress,pressb,ptk(1),ptk(2)
 1140 format(4x,'jpress= ',i2,/4x,'pressb= ',1pe12.5,
     $ /6x,'ptk1= ',1pe12.5,6x,'ptk2= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of reactants.
c
      write (newin,1490) nrct
 1490 format(6x,'nrct= ',i2)
c
      write (newin,1500)
 1500 format('*-------------------------------------------------',
     $ '----------------------------')
c
c     Reactants.
c
      nxr = 0
      nsr = 0
      ner = 0
c
      do nrc = 1,nrct
c
c       Name, flags, and masses.
c
        j2 = ilnobl(ureac(nrc))
        write (newin,1540) ureac(nrc)(1:j2),jcode(nrc),jreac(nrc),
     $  morr(nrc),modr(nrc)
 1540   format(2x,'reactant= ',a,/5x,'jcode= ',i2,15x,'jreac= ',i2,
     $  /6x,'morr= ',1pe12.5,6x,'modr= ',e12.5)
c
        if (jcode(nrc) .eq. 1) then
c
c         Solid solution compositions.
c
          nxr = nxr + 1
          do iki = 1,ixrti(nxr)
            write (newin,1580) ucxri(iki,nxr),rxbari(iki,nxr)
 1580       format(3x,a24,3x,1pe12.5)
          enddo
          j3 = ilnobl(uendit)
          write (newin,1570) uendit(1:j3)
 1570     format(3x,a)
c
        elseif (jcode(nrc) .eq. 2) then
c
c         Special reactant compositions.
c
          nsr = nsr + 1
          write (newin,1620) vreac(nrc)
 1620     format(5x,'vreac= ',e12.5)
c
          write (newin,1640)
 1640     format ('* Elemental composition')
          do nci = 1,iesrti(nsr)
            write (newin,1650) uesri(nci,nsr),cesri(nci,nsr)
 1650       format(3x,a8,3x,1pe22.15)
          enddo
          j3 = ilnobl(uendit)
          write (newin,1570) uendit(1:j3)
c
          write (newin,1680)
 1680     format ('* Reaction')
          do nbi = 1,ibsrti(nsr)
            write (newin,1690) ubsri(nbi,nsr)(1:24),cbsri(nbi,nsr)
 1690       format(3x,a24,3x,1pe22.15)
          enddo
          write (newin,1570) uendit(1:j3)
c
        elseif (jcode(nrc) .eq. 5) then
c
c         Generic ion exchanger phase compositions.
c
          ner = ner + 1
c
          j3 = ilnobl(ugermo(ner))
          write (newin,1692) ugermo(ner)(1:j3)
 1692     format(4x,'ugermo= ',a)
c
          j4 = ilnobl(uendit)
          do jei = 1,jgerti(ner)
            j3 = ilnobl(ugerji(jei,ner))
            write (newin,1700) ugerji(jei,ner)(1:j3)
 1700       format(3x,a)
            do iei = 1,igerti(jei,ner)
              write (newin,1710) ugersi(iei,jei,ner),egersi(iei,jei,ner)
 1710         format(6x,a24,3x,1pe12.5)
            enddo
            write (newin,1720) uendit(1:j4)
 1720       format(6x,a)
          enddo
          write (newin,1570) uendit(1:j4)
c
        endif
c
c       Surface area parameters.
c
        write (newin,1750) nsk(nrc),sfcar(nrc),ssfcar(nrc),fkrc(nrc)
 1750   format(7x,'nsk= ',i2,15x,'sfcar= ',1pe12.5,4x,'ssfcar= ',e12.5,
     $  /6x,'fkrc= ',e12.5)
c
c       Kinetic rate laws.
c
        write (newin,1770) nrk(1,nrc),nrk(2,nrc)
 1770   format(6x,'nrk1= ',i2,16x,'nrk2= ',i2)
c
c       Rate law parameters, forward direction (destruction).
c
        if (nrk(1,nrc) .eq. 1) then
c
c         Arbitrary kinetics.
c
          write (newin,1800) (rkb(i,1,nrc), i = 1,3)
 1800     format(6x,'rkb1= ',1pe12.5,6x,'rkb2= ',e12.5,
     $    6x,'rkb3= ',e12.5)
c
        elseif (nrk(1,nrc) .eq. 2) then
c
c         Transition state theory.
c
          write (newin,1820) imech(1,nrc)
 1820     format(5x,'imech= ',i2)
          do i = 1,imech(1,nrc)
            write (newin,1840) rkb(i,1,nrc),trkb(i,1,nrc),
     $      iact(i,1,nrc)
 1840       format(7x,'rkb= ',1pe12.5,6x,'trkb= ',1pe12.5,6x,
     $      'iact= ',i2)
c
            write (newin,1860) eact(i,1,nrc),hact(i,1,nrc)
 1860       format(6x,'eact= ',1pe12.5,6x,'hact= ',e12.5)
c
            write (newin,1880) ndact(i,1,nrc),csigma(i,1,nrc)
 1880       format(5x,'ndact= ',i2,14x,'csigma= ',1pe12.5)
c
            do n = 1,ndact(i,1,nrc)
              write (newin,1920) udac(n,i,1,nrc),cdac(n,i,1,nrc)
 1920         format(6x,'udac= ',a24,6x,'cdac= ',1pe12.5)
            enddo
          enddo
c
        elseif (nrk(1,nrc) .eq. 3) then
c
c         Linear rate law.
c
          i = imech(1,nrc)
          write (newin,1840) rkb(i,1,nrc),trkb(i,1,nrc),
     $    iact(i,1,nrc)
          write (newin,1860) eact(i,1,nrc),hact(i,1,nrc)
c
        endif
c
c       Rate law parameters, backward direction (formation).
c
        if (nrk(2,nrc) .eq. 1) then
c
c         Arbitrary kinetics.
c
          write (newin,1800) (rkb(i,2,nrc), i = 1,3)
c
        elseif (nrk(2,nrc) .eq. 2) then
c
c         Transition state theory.
c
          write (newin,1820) imech(2,nrc)
          do i = 1,imech(2,nrc)
            write (newin,1840) rkb(i,2,nrc),trkb(i,2,nrc),
     $      iact(i,2,nrc)
c
            write (newin,1860) eact(i,2,nrc),hact(i,2,nrc)
c
            write (newin,1880) ndact(i,2,nrc),csigma(i,2,nrc)
c
            do n = 1,ndact(i,2,nrc)
               write (newin,1920) udac(n,i,2,nrc),cdac(n,i,2,nrc)
             enddo
          enddo
c
        elseif (nrk(2,nrc) .eq. 3) then
c
c         Linear rate law.
c
          i = imech(2,nrc)
          write (newin,1840) rkb(i,2,nrc),trkb(i,2,nrc),
     $    iact(i,1,nrc)
          write (newin,1860) eact(i,2,nrc),hact(i,2,nrc)
c
        endif
c
        write (newin,1500)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting, minimum, and maximum values of key run parameters.
c
      write (newin,1150) xistti,ximaxi,tistti,timmxi
 1150 format(4x,'xistti= ',1pe12.5,4x,'ximaxi= ',e12.5,
     $ /4x,'tistti= ',1pe12.5,4x,'timmxi= ',e12.5)
c
      write (newin,1160) phmini,phmaxi,ehmini,ehmaxi,o2mini,o2maxi,
     $ awmini,awmaxi,kstpmx
 1160 format(4x,'phmini= ',1pe12.5,4x,'phmaxi= ',e12.5,
     $ /4x,'ehmini= ',1pe12.5,4x,'ehmaxi= ',e12.5,
     $ /4x,'o2mini= ',1pe12.5,4x,'o2maxi= ',e12.5,
     $ /4x,'awmini= ',1pe12.5,4x,'awmaxi= ',e12.5,
     $ /4x,'kstpmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval parameters.
c
      write (newin,1170) dlxprn,dlxprl,dltprn,dltprl
 1170 format(4x,'dlxprn= ',1pe12.5,4x,'dlxprl= ',e12.5,
     $ /4x,'dltprn= ',e12.5,4x,'dltprl= ',e12.5)
c
      write (newin,1180) dlhprn,dleprn,dloprn,dlaprn,ksppmx
 1180 format(4x,'dlhprn= ',1pe12.5,4x,'dleprn= ',e12.5,
     $ /4x,'dloprn= ',e12.5,4x,'dlaprn= ',e12.5,/4x,'ksppmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval parameters.
c
      write (newin,1190) dlxplo,dlxpll,dltplo,dltpll
 1190 format(4x,'dlxplo= ',1pe12.5,4x,'dlxpll= ',e12.5,
     $ /4x,'dltplo= ',e12.5,4x,'dltpll= ',e12.5)
c
      write (newin,1195) dlhplo,dleplo,dloplo,dlaplo,ksplmx
 1195 format(4x,'dlhplo= ',1pe12.5,4x,'dleplo= ',e12.5,
     $ /4x,'dloplo= ',e12.5,4x,'dlaplo= ',e12.5,/4x,'ksplmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Comment header for iopt, iopr, iodb, and iopg option switches.
c
      write (newin,1200)
 1200 format('*',15x,'1    2    3    4    5    6    7    8    9   10')
c
c     Iopt option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1220) (iopt(i), i = 1,20)
 1220 format(2x,'iopt1-10= ',10i5,/1x,'iopt11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr option switches.
c     Note: iopr(1) = iopr1, etc.
c
      write (newin,1240) (iopr(i), i = 1,20)
 1240 format(2x,'iopr1-10= ',10i5,/1x,'iopr11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1260) (iodb(i), i = 1,20)
 1260 format(2x,'iodb1-10= ',10i5,/1x,'iodb11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxopt options.
c
      write (newin,1310) nxopt
 1310 format(5x,'nxopt= ',i2)
c
c     Nxopt options.
c
      if (nxopt .gt. 0) then
        do n = 1,nxopt
          j2 = ilnobl(uxcat(n))
          write (newin,1340) uxopt(n),uxcat(n)(1:j2)
 1340     format(4x,'option= ',a6,1x,a)
        enddo
        write (newin,1360) nxopex
 1360   format(4x,'nxopex= ',i2)
        if (nxopex .gt. 0) then
          do n = 1,nxopex
            j2 = ilnobl(uxopex(n))
            write (newin,1390) uxopex(n)(1:j2)
 1390       format(' exception= ',a)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nffg options.
c
      write (newin,1400) nffg
 1400 format(6x,'nffg= ',i2)
c
c     Nffg options.
c
      if (nffg .gt. 0) then
        do n = 1,nffg
          j2 = ilnobl(uffg(n))
          write (newin,1440) uffg(n)(1:j2),moffg(n),xlkffg(n)
 1440     format (3x,'species= ',a,/5x,'moffg= ',1pe12.5,4x,
     $    'xlkffg= ',e12.5)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum finite-difference order.
c
      write (newin,2020) nordmx
 2020 format(4x,'nordmx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Newton-Raphson convergence tolerances.
c
      write (newin,2030) tolbt,toldl
 2030 format(5x,'tolbt= ',1pe12.5,5x,'toldl= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of Newton-Raphson iterations.
c
      write (newin,2110) itermx
 2110 format(4x,'itermx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search/find tolerance.
c
      write (newin,2032) tolxsf
 2032 format(4x,'tolxsf= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation tolerance.
c
      write (newin,2034) tolsat
 2034 format(4x,'tolsat= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of phase assemblage tries.
c
      write (newin,2112) ntrymx
 2112 format(4x,'ntrymx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero-order step size (in Xi).
c
      write (newin,2090) dlxmx0
 2090 format(4x,'dlxmx0= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     PRS transfer interval in Xi.
c
      write (newin,2010) dlxdmp
 2010 format(4x,'dlxdmp= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (newin,1500)
c
c     Write the bottom half of the pickup file.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Old title.
c
      do n = 1,ntitl2
        j2 = ilnobl(utitl2(n))
        write (newin,1020) utitl2(n)(1:j2)
      enddo
      j3 = ilnobl(uendit)
      if (ntitl1 .lt. ntitmx) write (newin,1020) uendit(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,2610)
 2610 format('*   Special basis switches')
      write (newin,2630) nsbswt
 2630 format(4x,'nsbswt= ',i3)
c
      do n = 1,nsbswt
        j2 = ilnobl(usbsw(1,n))
        write (newin,2650) usbsw(1,n)(1:j2)
 2650   format('species= ',a)
        j2 = ilnobl(usbsw(2,n))
        write (newin,2670) usbsw(2,n)(1:j2)
 2670   format(2x,'switch with= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      write (newin,2690) tempci
 2690 format(4x,'tempci= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      write (newin,2710) pressi
 2710 format(4x,'pressi= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,2790)
 2790 format('* Ion exchanger creation')
c
      write (newin,2795) qgexsh
 2795 format(4x,'qgexsh= ',l8)
c
      write (newin,2810) net
 2810 format(7x,'net= ',i3)
c
      do ne = 1,net
        j2 = ilnobl(ugexp(ne))
        write (newin,2840) ugexp(ne)(1:j2)
 2840   format(5x,'ugexp= ',a)
c
        write (newin,2860) mwtges(ne)
 2860   format(4x,'mwtges= ',1pe12.5)
c
        j3 = ilnobl(ugexmo(ne))
        write (newin,2870) ugexmo(ne)(1:j3)
 2870   format(4x,'ugexmo= ',a)
c
        write (newin,2880) tgexp(ne)
 2880   format(5x,'tgexp= ',1pe12.5)
c
        write (newin,2900) jgext(ne)
 2900   format(5x,'jgext= ',i3)
c
        do je = 1,jgext(ne)
          j3 = ilnobl(ugexj(je,ne))
          write (newin,2940) ugexj(je,ne)(1:j3)
 2940     format(5x,'ugexj= ',a)
c
          write (newin,2960) cgexj(je,ne),zgexj(je,ne)
 2960     format(5x,'cgexj= ',1pe12.5,5x,'zgexj= ',e12.5)
c
          write (newin,3010) ngexrt(je,ne)
 3010     format(4x,'ngexrt= ',i3)
c
          do n = 1,ngexrt(je,ne)
            j2 = ilnobl(ugexr(n,je,ne))
            write (newin,3040) ugexr(n,je,ne)(1:j2)
 3040       format(5x,'ugexr= ',a)
            j4 = ilnobl(uxkgex(n,je,ne))
            write (newin,3060) xlkgex(n,je,ne),uxkgex(n,je,ne)(1:j4)
 3060       format(4x,'xlkgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uhfgex(n,je,ne))
            write (newin,3070) xhfgex(n,je,ne),uhfgex(n,je,ne)(1:j4)
 3070       format(4x,'xhfgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uvfgex(n,je,ne))
            write (newin,3080) xvfgex(n,je,ne),uvfgex(n,je,ne)(1:j4)
 3080       format(4x,'xvfgex= ',1pe12.5,5x,'units= ',a)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
      write (newin,3130) nxmod
 3130 format(5x,'nxmod= ',i2)
c
c     Nxmod options.
c
      do n = 1,nxmod
        j2 = ilnobl(uxmod(n))
        write (newin,3160) uxmod(n)(1:j2),kxmod(n),xlkmod(n)
 3160   format(3x,'species= ',a,
     $  /4x,'option= ',i2,14x,'xlkmod= ',1pe12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,1200)
      write (newin,3180) (iopg(i), i = 1,20)
 3180 format(2x,'iopg1-10= ',10i5,/1x,'iopg11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      write (newin,3230) kct,kbt,kmt,kxt,kdim,kprs
 3230 format(7x,'kct= ',i2,17x,'kbt= ',i2,17x,'kmt= ',i2,/
     $ 7x,'kxt= ',i2,16x,'kdim= ',i2,16x,'kprs= ',i2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
      write (newin,3330)
 3330 format('* Data file basis species and jflgi values')
c
      do nbi = 1,nbti
        write (newin,3350) ubmtbi(nbi),jflgi(nbi)
 3350   format(3x,a48,3x,i2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
      write (newin,3400)
 3400 format('*',7x,
     $ 'Mass balance totals     Aqueous mass balance totals')
c
      do nbi = 1,nbti
        write (newin,3420) mtbi(nbi),mtbaqi(nbi)
 3420   format(6x,1pe22.15,6x,e22.15)
      enddo
c
      write (newin,3440) electr
 3440 format(9x,'Electrical imbalance= ',3x,1pe22.15)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,3450)
 3450 format('*   Ordinary basis switches')
      write (newin,3460) nobswt
 3460 format(4x,'nobswt= ',i3)
c
      do n = 1,nobswt
        j2 = ilnobl(uobsw(1,n))
        write (newin,2650) uobsw(1,n)(1:j2)
        j2 = ilnobl(uobsw(2,n))
        write (newin,2670) uobsw(2,n)(1:j2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables.
c
      write (newin,3470)
 3470 format('* Matrix species or entities')
c
      do krow = 1,kdim
        j2 = ilnobl(uzveci(krow))
        write (newin,3490) uzveci(krow)(1:j2)
 3490   format(3x,a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix variable values.
c
      write (newin,3510)
 3510 format('*   Values of matrix variables')
      do kcol = 1,kdim
        write (newin,3530) zvclgi(kcol)
 3530   format(3x,1pe22.15)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qx = kprs.gt.0 .and. nprpti.gt.0 .and. nprsti.gt.0
      if (qx) then
        write (newin,3600)
 3600   format('*  Phases and species in the PRS')
        nsi = 0
        do npi = 1,nprpti
          write (newin,3630) uprphi(npi),mprphi(npi)
 3630     format(1x,a24,6x,1pe22.15)
          do iki = 1,iktmax
            if (uprspi(nsi + 1)(25:48) .eq. uprphi(npi)(1:24)) then
              nsi = nsi + 1
              write (newin,3670) uprspi(nsi)(1:24),mprspi(nsi)
 3670         format(3x,a24,6x,1pe22.15)
            else
              j3 = ilnobl(uendit)
              write (newin,3660) uendit(1:j3)
 3660         format(3x,a)
              go to 300
            endif
          enddo
  300     continue
        enddo
        j3 = ilnobl(uendit)
        write (newin,3620) uendit(1:j3)
 3620   format(1x,a)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine absswa(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $ axhfsx,axlks,axlksx,axvfs,axvfsx,beta,cdrs,cdrsx,cdrtw,cdrw,
     $ csts,dhfs,dvfs,efac,eps100,ibswx,iebal,iindx1,iodb,ipch,ipchmx,
     $ ipcv,ipcvmx,jcsort,jflag,jsflag,jssort,kbt,kmax,mosp,narn1,
     $ narn2,narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ncosp,
     $ ndrs,ndrsmx,ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,
     $ noutpt,nst,nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,
     $ presg,press,qbassw,qbswx,q6mode,tempc,uspec,uzvec1,weight,
     $ xvfs,xlks,xhfs)
c
c     This subroutine carries out automatic basis switching as a
c     pre-Newton-Raphson optimization technique (to reduce the
c     magnitude of very large mass balance residuals). It is similar
c     to EQ6/absswb.f, which carries out automatic basis switching to
c     optimize the basis set after the system has been solved at the
c     latest point of reaction progress.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,kmax,narxmx,nbtmax,ndrsmx,nodbmx,nstmax,
     $ nstsmx,ntprmx
c
      integer noutpt,nttyo
c
      integer ibswx(nbtmax),iindx1(kmax),iodb(nodbmx),jcsort(nstmax),
     $ jflag(nstmax),jsflag(nstmax),jssort(nstmax),narxt(ntprmx),
     $ nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),ncosp(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),ndrsrx(2,nstmax),ndrsx(ndrsmx),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer iebal,ipch,ipcv,kbt,narn1,narn2,nbt,nbw,nelect,nhydr,
     $ no2gaq,nst,nswtch,ntpr
c
      logical qbassw,qbswx,q6mode
c
      character(len=48) uspec(nstmax),uzvec1(kmax)
c
      real(8) adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ csts(nstsmx),beta(kmax),dhfs(ipchmx,nstmax),dvfs(ipcvmx,nstmax),
     $ efac(nbtmax),mosp(nstmax),weight(nstmax),xhfs(nstmax),
     $ xlks(nstmax),xvfs(nstmax)
c
      real(8) avcnst,presg,press,tempc
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jfl,jlen1,jlen2,jlen3,j2,nb,nb1,nb2,ncount,
     $ nse,nsi,nsj,nss,ns2
c
      integer ilnobl,nbasis
c
      character(len=56) usp156,usp256,usp356
      character(len=8) ux8
c
c-----------------------------------------------------------------------
c
c     Initialize the number of basis switches made.
c
      nswtch = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pick candidates for automatic basis switching. This involves
c     a search similar to the one above, but with a variety of special
c     constraints. The indices of candidates are stored in the array
c     ibswx.
c
      call abswpk(beta,cdrs,csts,efac,ibswx,iebal,iindx1,
     $ jcsort,jflag,jssort,kbt,kmax,mosp,narn1,narn2,nbasp,nbaspd,
     $ nbt,nbtmax,ndrs,ndrsmx,ndrsr,nelect,nhydr,no2gaq,nstmax,
     $ nsts,nstsmx,nstsr,qbswx,q6mode,weight)
c
      if (.not.qbswx) then
        nswtch = 0
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1000)
 1000   format(/5x,'--- Candidate Basis Switches ---')
        do nb = 1,nbt
          nse = nbaspd(nb)
          nsj = nbasp(nb)
          nsi = ibswx(nb)
          if (nsi .gt. 0) then
c
c           Calling sequence substitutions:
c             jlen1 for jlen
c             uspec(nsj) for unam48
c             usp156 for uspn56
c
            call fmspnx(jlen1,uspec(nsj),usp156)
c
c           Calling sequence substitutions:
c             jlen2 for jlen
c             uspec(nsi) for unam48
c             usp256 for uspn56
c
            call fmspnx(jlen2,uspec(nsi),usp256)
c
c           Calling sequence substitutions:
c             jlen3 for jlen
c             uspec(nse) for unam48
c             usp356 for uspn56
c
            call fmspnx(jlen3,uspec(nse),usp356)
c
            write (noutpt,1010) usp156(1:jlen1),usp256(1:jlen2),
     $      usp356(1:jlen3)
 1010       format(/3x,'Could replace ',a,' in the active basis set',
     $      ' with',/3x,a,' as the species associated with the mass',
     $      ' balance',/3x,'of ',a,'.')
          endif
        enddo
        write (noutpt,1020)
 1020   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.q6mode) then
c
c       Running EQ3NR. Wipe out any proposed basis switches in which
c       the species to be switched out is the other species involved
c       in a jflag = 17 18, or 21 option.
c
        ncount = 0
        do nb1 = 1,nbt
          nse = nbaspd(nb1)
          nsj = nbasp(nb1)
          jfl = jflag(nse)
          if (jfl.eq.17 .or. jfl.eq.18 .or. jfl.eq.21) then
            ns2 = ncosp(nb1)
            do nb2 = 1,nbt
              nss = nbasp(nb2)
              if (ns2 .eq. nss) then
                if (ibswx(nb2) .ne. 0) then
                  if (iodb(3) .ge. 2) then
c
c                   Calling sequence substitutions:
c                     jlen2 for jlen
c                     uspec(ns2) for unam48
c                     usp256 for uspn56
c
                    call fmspnx(jlen2,uspec(ns2),usp256)
c
c                   Calling sequence substitutions:
c                     jlen3 for jlen
c                     uspec(nse) for unam48
c                     usp356 for uspn56
c
                    call fmspnx(jlen3,uspec(nse),usp356)
c
                    write (ux8,'(i5)') jfl
                    call lejust(ux8)
                    j2 = ilnobl(ux8)
c
                    write (noutpt,1050) usp256(1:jlen2),ux8(1:j2),
     $              usp356(1:jlen3)
                    write (nttyo,1050) usp256(1:jlen2),ux8(1:j2),
     $              usp356(1:jlen3)
 1050               format(/" * Note - (EQLIB/absswa) Can't switch ",
     $              ' the species ',a,/7x,'out of the active basis set',
     $              ' because it is tied up in a jflag = ',a,' option',
     $              /7x,'for ',a,'.')
                    ncount = ncount + 1
                  endif
                  ibswx(nb2) = 0
                endif
                go to 100
              endif
            enddo
  100       continue
          endif
        enddo
        if (ncount .gt. 0) write (noutpt,1020)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Resolve any conflicts in candidate basis switches.
c
      call gabswx(beta,ibswx,iindx1,kbt,kmax,nbt,nbtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Count the number of switches to make.
c
      nswtch = 0
      do nb = 1,nbt
        nsi = ibswx(nb)
        if (nsi .gt. 0) nswtch = nswtch + 1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nswtch .le. 0) then
        if (iodb(3) .ge. 1) write (noutpt,1070)
 1070   format(/10x,'No switches will be made.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1100)
 1100   format(/5x,'--- Automatic Basis Switches ---',/)
        do nb = 1,nbt
          nse = nbaspd(nb)
          nsj = nbasp(nb)
          nsi = ibswx(nb)
          if (nsi .gt. 0) then
c
c           Calling sequence substitutions:
c             jlen1 for jlen
c             uspec(nsj) for unam48
c             usp156 for uspn56
c
            call fmspnx(jlen1,uspec(nsj),usp156)
c
c           Calling sequence substitutions:
c             jlen2 for jlen
c             uspec(nsi) for unam48
c             usp256 for uspn56
c
            call fmspnx(jlen2,uspec(nsi),usp256)
c
c           Calling sequence substitutions:
c             jlen3 for jlen
c             uspec(nse) for unam48
c             usp356 for uspn56
c
            call fmspnx(jlen3,uspec(nse),usp356)
c
            write (noutpt,1110) usp156(1:jlen1),usp256(1:jlen2),
     $      usp356(1:jlen3)
 1110       format(/3x,'Will replace ',a,' in the active basis set',
     $      ' with',/3x,a,' as the species associated with the mass',
     $      ' balance',/3x,'of ',a,'.')
          endif
        enddo
        write (noutpt,1020)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      call autosw(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $ axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ibswx,iindx1,
     $ ipch,ipchmx,ipcv,ipcvmx,jflag,jsflag,kbt,kmax,narn1,narxmx,
     $ nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,
     $ ndrsrx,noutpt,nst,nstmax,ntprmx,nttyo,qbassw,uspec,uzvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the cdrw array.
c
      call gcdrw(cdrs,cdrw,narn1,ndrs,ndrsmx,ndrsr,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the cdrtw array.
c
      call gcdrtw(cdrs,cdrtw,narn1,narn2,ndrs,ndrsmx,ndrsr,
     $ nelect,no2gaq,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update the thermodynamic data to correspond to the new
c     active basis set. First, recompute the log K, etc., data for
c     the various reactions.
c
      call evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $ ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $ tempc,xhfs,xlks,xvfs)
c
c     Then make pressure corrections to these thermodynamic data.
c
      if (ipcv .ge. 0) then
        call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $  nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $  xlks,xvfs)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine rxnchk(cdrs,cess,mtotr,nbt,nbtmx1,nbtmx2,nco,
     $ nct,nctmax,nerr,noutpt,ns,nsb,nttyo,uelem,uspec,zchar)
c
c     This suboutine checks the reaction associated with the ns-th
c     species for mass and charge balance. If an imbalance is found,
c     a message is written to the screen and output files.
c
c     This suboutine is called by:
c
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrs   = array of reaction coefficients
c       cess   = array of elemental composition coefficients
c       nbt    = the number of basis species
c       nct    = the number of chemical elements
c       nerr   = cumulative error counter
c       uelem  = array of chemical element names
c       uspec  = array of species names
c       zchar  = array of electrical charge numbers
c
c     Principal output:
c
c       nerr   = cumulative error counter
c
c     Workspace:
c
c       mtotr  = array of mass balance residuals
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmx1,nbtmx2
c
      integer noutpt,nttyo
c
      integer nbt,nco,nct,nctmax,nerr,ns,nsb
c
      character*24 uspec(nbtmx1)
      character*8 uelem(nctmax)
      character*8 ux8
c
      real*8 cdrs(nbtmx2,nbtmx1),cess(nctmax,nbtmx1),mtotr(nctmax),
     $ zchar(nbtmx1)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      logical qbadr,qo2gx
c
      integer j2,j3,nbt1,nc,nfile,nlim,nse
c
      integer ilnobl
c
      real*8 mx,rxntol,ztotr
c
c-----------------------------------------------------------------------
c
      data rxntol /1.e-6/
c
c-----------------------------------------------------------------------
c
      qbadr = .false.
c
      qo2gx = uspec(nsb) .eq. 'O2(g)'
      if (qo2gx) cess(nco,nsb) = 2.
c
      nlim = ns - 1
      nlim = min(nlim,nbt)
      nbt1 = nbt + 1
c
      ztotr = cdrs(nbt1,ns)*zchar(ns)
      do nse = 1,nlim
        ztotr = ztotr + cdrs(nse,ns)*zchar(nse)
      enddo
      if (abs(ztotr) .gt. rxntol) qbadr = .true.
c
      do nc = 1,nct
        mx = cdrs(nbt1,ns)*cess(nc,ns)
        do nse = 1,nlim
          mx = mx + cdrs(nse,ns)*cess(nc,nse)
        enddo
        mtotr(nc) = mx
        if (abs(mx) .gt. rxntol) qbadr = .true.
      enddo
c
      if (qo2gx) cess(nco,nsb) = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qbadr) then
c
c       Have a reaction with one or more imbalances.
c
        j2 = ilnobl(uspec(ns))
        write (noutpt,1000) uspec(ns)(1:j2)
        write (nttyo,1000) uspec(ns)(1:j2)
 1000   format(/' * Error - (EQPT/rxnchk) The reaction for the',
     $  ' destruction of',/7x,a,' has the following imbalances:',/)
        if (abs(ztotr) .gt. rxntol) then
          ux8 = 'charge'
          j3 = ilnobl(ux8)
          write (noutpt,1010) ztotr,ux8(1:j3)
          write (nttyo,1010) ztotr,ux8(1:j3)
 1010     format(9x,1pe12.5,' in ',a)
        endif
        do nc = 1,nct
          if (abs(mtotr(nc)) .gt. rxntol) then
            ux8 = uelem(nc)
            j3 = ilnobl(ux8)
            write (noutpt,1010) mtotr(nc),ux8(1:j3)
            write (nttyo,1010) mtotr(nc),ux8(1:j3)
          endif
        enddo
        write (noutpt,1020)
        write (nttyo,1020)
 1020   format(/9x,'The reaction is:')
        nfile = noutpt
        call prrecy(cdrs,nbtmx1,nbtmx2,nbt,ns,nfile,uspec)
        nfile = nttyo
        call prrecy(cdrs,nbtmx1,nbtmx2,nbt,ns,nfile,uspec)
        nerr = nerr + 1
      endif
c
      end

      subroutine echox(azero,cdrs,covali,eh,fo2lg,iebal3,iodb,iopg,
     $ iopr,iopt,irdxc3,itdsf3,itermx,ixrn1,ixrn2,jflag,jflgi,jpres3,
     $ narn1,narn2,nat,nata,natmax,nbt,nbta,nbti,nbtmax,nct,ncta,
     $ nctmax,ncmpr,ncosp,ndecsp,ndrs,ndrsmx,ndrsr,nelect,ngt,ngta,
     $ ngtmax,nhydr,nhydx,njfmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,
     $ nodbmx,nopgmx,noprmx,noptmx,noutpt,no2gaq,npt,npta,nptmax,
     $ nredox,nst,nsta,nstmax,nxt,nxta,nxti,nxtmax,pe,presg,press,
     $ rho,scamas,tdspkg,tdspl,tempc,tolbt,toldl,tolspf,uactop,
     $ ucospi,uebal,ujflls,uphase,uredox,uspec,uspeci,xbar)
c
c     This subroutine echoes the problem input defining the
c     compositional constraints on the aqueous solution being modeled
c     and the options and tolerances selected.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nbtmax,nctmax,ndrsmx,ngtmax,njfmax,nltmax,
     $ nmtmax,nodbmx,nopgmx,noprmx,noptmx,nptmax,nstmax,nxtmax
c
      integer noutpt
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jflag(nstmax),jflgi(nbtmax),ncmpr(2,nptmax),ncosp(nbtmax),
     $ ndecsp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,ixrn1,ixrn2,jpres3,narn1,
     $ narn2,nat,nata,nbt,nbta,nbti,nct,ncta,nelect,ngt,ngta,nhydr,
     $ nhydx,nlt,nlta,nmt,nmta,no2gaq,npt,npta,nredox,nst,nsta,nxt,
     $ nxta,nxti
c
      character*48 ucospi(nbtmax),uspec(nstmax),uspeci(nbtmax)
      character*32 ujflls(0:njfmax)
      character*32 uactop
      character*24 uphase(nptmax)
      character*24 uebal,uredox
c
      real(8) azero(natmax),cdrs(ndrsmx),covali(nbtmax),xbar(nstmax)
c
      real(8) dp,eh,fo2lg,pe,presg,press,rho,scamas,tdspkg,tdspl,tempc,
     $ tolbt,toldl,tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jfl,j2,j3,j4,n,na,nbi,nb1,np,nr1,nr2,ns,nss
c
      integer ilnobl
c
      character*24 ux24
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(uactop)
      write (noutpt,1000) uactop(1:j2)
 1000 format(/' The activity coefficients of aqueous species will be',
     $ /' calculated using ',a,'.'/)
c
      if (iopr(3) .gt. 1) then
        write (noutpt,1010)
 1010   format(/7x,'Species',17x,'HC Diameter',/)
        do ns = narn1 + 1,narn2
          na = ns - narn1 + 1
          write (noutpt,1020) uspec(ns),azero(na)
 1020     format(5x,a24,3x,f7.3)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1030) tempc
 1030 format(/' Temperature= ',f6.2,' C',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1032) jpres3
 1032 format(/' jpres3=  ',i3,' (Pressure option switch)')
      if (jpres3 .eq. 0) then
        write (noutpt,1034) press
 1034   format(/'   Pressure= ',1pg12.5,' bars (data file reference',
     $  ' curve value)',/)
      elseif (jpres3 .eq. 1) then
        dp = press - presg
        write (noutpt,1036) press,presg,dp
 1036   format(/'   Pressure= ',1pg12.5,' bars (1.013-bar/steam-',
     $  'saturation curve value)',
     $  /'   Data file reference curve pressure= ',g12.5,' bars',
     $  /'   Pressure difference= ',g12.5,' bars',/)
      elseif (jpres3 .eq. 2) then
        dp = press - presg
        write (noutpt,1038) press,presg,dp
 1038   format(/'   Pressure= ',1pg12.5,' bars (specified value)',
     $  /'   Data file reference curve pressure= ',g12.5,' bars',
     $  /'   Pressure difference= ',g12.5,' bars',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table showing for phases, species, and groups thereof,
c     the number of each of entity on the data base, the number the
c     software is dimensioned for, and the number appearing in the
c     current problem.
c
      call prtntt(nat,nata,natmax,nbt,nbta,nbtmax,nct,ncta,
     $ nctmax,ngt,ngta,ngtmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,noutpt,
     $ npt,npta,nptmax,nst,nsta,nstmax,nxt,nxta,nxtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1040) (iopt(n), n = 1,10)
 1040 format(/' iopt(1)=  ',i2,' (Used only by EQ6)',
     $ /' iopt(2)=  ',i2,' (Used only by EQ6)',
     $ /' iopt(3)=  ',i2,' (Used only by EQ6)',
     $ /' iopt(4)=  ',i2,' (Solid solutions)',
     $ /' iopt(5)=  ',i2,' (Used only by EQ6)',
     $ /' iopt(6)=  ',i2,' (Used only by EQ6)',
     $ /' iopt(7)=  ',i2,' (Not used)',
     $ /' iopt(8)=  ',i2,' (Not used)',
     $ /' iopt(9)=  ',i2,' (Not used)',
     $ /' iopt(10)= ',i2,' (Not used)')
      write (noutpt,1045) (iopt(n), n = 11,18)
 1045 format(' iopt(11)= ',i2,' (Auto basis switching, in',
     $ ' pre-Newton-Raphson optimization)',
     $ /' iopt(12)= ',i2,' (Used only by EQ6)',
     $ /' iopt(13)= ',i2,' (Not used)',
     $ /' iopt(14)= ',i2,' (Not used)',
     $ /' iopt(15)= ',i2,' (Used only by EQ6)',
     $ /' iopt(16)= ',i2,' (Not used)',
     $ /' iopt(17)= ',i2,' (pickup file options)',
     $ /' iopt(18)= ',i2,' (Used only by EQ6)',
     $ /' iopt(19)= ',i2,' (Advanced EQ3NR pickup file options)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1050) (iopg(n), n = 1,2)
 1050 format(/'   iopg(1)=  ',i2,' (Aqueous species activity',
     $ ' coefficient model)',
     $ /'   iopg(2)=  ',i2,' (pH scale)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1060) (iopr(n), n = 1,17)
 1060 format(/' iopr(1)=  ',i2,' (List all species)',
     $ /' iopr(2)=  ',i2,' (List all reactions)',
     $ /' iopr(3)=  ',i2,' (List HC diameters)',
     $ /' iopr(4)=  ',i2,' (Aqueous species concentration print',
     $ ' cut-off)',
     $ /' iopr(5)=  ',i2,' (Ion/H+ activity ratios)',
     $ /' iopr(6)=  ',i2,' (Mass balance percentages)',
     $ /' iopr(7)=  ',i2,' (Affinity print cut-off)',
     $ /' iopr(8)=  ',i2,' (Fugacities)',
     $ /' iopr(9)=  ',i2,' (Mean molal activity coefficients)',
     $ /' iopr(10)= ',i2,' (Pitzer coefficients tabulation)',
     $ /' iopr(11)= ',i2,' (Not used)',
     $ /' iopr(12)= ',i2,' (Not used)',
     $ /' iopr(13)= ',i2,' (Not used)',
     $ /' iopr(14)= ',i2,' (Not used)',
     $ /' iopr(15)= ',i2,' (Not used)',
     $ /' iopr(16)= ',i2,' (Not used)',
     $ /' iopr(17)= ',i2,' (pickup file format)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1070) (iodb(n), n = 1,7)
 1070 format(/'   iodb(1)=  ',i2,' (General diagnostics)',
     $ /'   iodb(2)=  ',i2,' (Used only by EQ6)',
     $ /'   iodb(3)=  ',i2,' (pre-Newton-Raphson optimization',
     $ ' iterations)',
     $ /'   iodb(4)=  ',i2,' (Newton-Raphson iterations)',
     $ /'   iodb(5)=  ',i2,' (Used only by EQ6)',
     $ /'   iodb(6)=  ',i2,' (Hypothetical affinity iterations)',
     $ /'   iodb(7)=  ',i2,' (Used only by EQ6)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      jfl = jflag(no2gaq)
      write (noutpt,1080) irdxc3
 1080 format(/' irdxc3=  ',i3,' (Default redox constraint switch)')
      if (irdxc3 .eq. 1) then
        if (uredox(1:7).ne.'O2(aq) ' .and.
     $    uredox(1:7).ne.'H2(aq) ') then
          nr1 = ndrsr(1,nredox)
          nr2 = ndrsr(2,nredox)
          do n = nr1,nr2
            nss = ndrs(n)
            if (nss.ne.nredox .and. nss.ne.narn1 .and. nss.ne.nhydr
     $      .and. nss.ne.nhydx .and. nss.ne.no2gaq .and. nss.ne.nelect)
     $      go to 100
          enddo
  100     continue
        else
          nss = narn1
        endif
        j2 = ilnobl(uredox)
        j3 = ilnobl(uspec(nss)(1:24))
        write (noutpt,1100) uredox(1:j2),uspec(nss)(1:j3)
 1100   format(/'   The default redox state is constrained by the',
     $   /'   ',a,'/',a,' couple.',/)
      elseif (irdxc3 .eq. 0) then
        write (noutpt,1110) fo2lg
 1110   format(/'   The default redox state is constrained by',
     $   ' Log fO2 = ',g12.5,' (log bars).',/)
      elseif (irdxc3 .eq. -1) then
        write (noutpt,1120) eh
 1120   format(/'   The default redox state is constrained by',
     $  ' Eh = ',f8.5,' volts.',/)
      elseif (irdxc3 .eq. -2) then
        write (noutpt,1130) pe
 1130   format(/'   The default redox state is constrained by',
     $  ' pe- = ',1pe12.5,'.',/)
      elseif (irdxc3 .eq. -3) then
        write (noutpt,1140)
 1140   format(/'   The default redox state is controlled by a',
     $  /' heterogeneous reaction (see below).',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1142) iebal3
 1142 format(/' iebal3=  ',i3,' (Electrical balancing option switch)')
      if (iebal3 .le. 0) then
        write (noutpt,1144)
 1144   format(/'   No electrical balancing adjustment will be made.',
     $  /'   The imbalance will be calculated.',/)
      elseif (iebal3 .eq. 1) then
        j2 = ilnobl(uebal)
        write (noutpt,1146) uebal(1:j2)
 1146   format(/'   The species ',a,' will be adjusted to',
     $  /'   achieve electrical balance.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1200) rho
 1200 format(/' Solution density = ',f8.5,' g/ml',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1202) itdsf3
 1202 format(/' itdsf3=  ',i3,' (Total dissolved solutes option',
     $ ' switch)')
      if (itdsf3 .le. 0) then
        write (noutpt,1204) tdspkg
 1204   format( /'   Total dissolved salts = ',f10.2,' mg/kg.sol',/)
      else
        write (noutpt,1206) tdspl
 1206  format(/'   Total dissolved salts = ',f10.2,' mg/L',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1210) tolbt,toldl,tolspf
 1210 format(/' tolbt  = ',1pe12.5,' (convergence tolerance on',
     $ ' residual functions)',/' toldl  = ',e12.5,' (convergence',
     $ ' tolerance on correction terms)',/' tolspf = ',e12.5,
     $ ' (saturation print flag tolerance, does not affect',/25x,
     $ 'convergence)',/)
c
      write (noutpt,1220) itermx
 1220 format(/' itermx = ',i3,' (maximum number of iterations)',/)
c
      write (noutpt,1230) scamas
 1230 format(/' scamas = ',1pe12.5,' (scale factor for aqueous',
     $ ' solution',/25x,'mass written on the pickup file)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1300)
 1300 format(/21x,'--- Original Input Constraints ---',
     $ //5x,'Species',20x,'coval   jflag   Type of Input',/)
c
      do nbi = 1,nbti
        jfl = jflgi(nbi)
        nb1 = ndecsp(nbi)
        if (nb1 .gt. 0) then
          j2 = ilnobl(ujflls(jfl))
c
          if (jfl.eq.17 .or. jfl.eq.18) then
            write (noutpt,1310) uspeci(nbi),covali(nbi),jfl,
     $      ujflls(jfl)(1:j2)
 1310       format(2x,a24,2x,1pe12.5,2x,i2,2x,a)
            j3 = ilnobl(ucospi(nbi)(1:24))
            write (noutpt,1315) ucospi(nbi)(1:j3)
 1315       format(39x,'Counterion= ',a)
          elseif (jfl .eq. 21) then
            write (noutpt,1310) uspeci(nbi),covali(nbi),jfl,
     $      ujflls(jfl)(1:j2)
          elseif (jfl .eq. 25) then
            write (noutpt,1310) uspeci(nbi),covali(nbi),jfl,
     $      ujflls(jfl)(1:j2)
            ns = ncosp(nb1)
            j3 = ilnobl(ucospi(nbi)(1:24))
            ux24 = ucospi(nbi)(25:48)
            j4 = ilnobl(ux24)
            if (j4 .le. 0) then
              ux24 = ucospi(nbi)(1:24)
              j4 = j3
            endif
            write (noutpt,1320) ucospi(nbi)(1:j3),ux24(1:j4)
 1320       format(46x,'Species= ',a,/48x,'Phase= ',a)
c
c           Calling sequence substitutions:
c             noutpt for nf
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns,nstmax,uspec)
            write (noutpt,1322)
 1322       format(1x)
          elseif (jfl.eq.27 .or. jfl.eq.30) then
            write (noutpt,1323) uspeci(nbi),jfl,ujflls(jfl)(1:j2)
 1323       format(2x,a24,16x,i2,2x,a)
          elseif (uspeci(nbi)(1:6) .eq. 'O2(g) ') then
            write (noutpt,1325) uspeci(nbi),covali(nbi),jfl
 1325       format(2x,a24,2x,1pe12.5,2x,i2,2x,'Log fO2')
          else
            if (jfl .ge. 0) then
              write (noutpt,1310) uspeci(nbi),covali(nbi),jfl,
     $        ujflls(jfl)(1:j2)
            else
              write (noutpt,1327) uspeci(nbi)
 1327         format(2x,a24,16x,'Not present in the model')
            endif
          endif
c
        endif
      enddo
c
      write (noutpt,1340)
 1340 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nxti .gt. 0) then
        write (noutpt,1600)
 1600   format(/21x,'--- Input Solid Solution Compositions ---',/)
        do np = ixrn1,ixrn2
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          do ns = nr1,nr2
            if (xbar(ns) .ne. 0.) go to 200
          enddo
          go to 190
c
  200     j2 = ilnobl(uphase(np))
          write (noutpt,1610) uphase(np)(1:j2)
 1610     format(/6x,a,/)
          write (noutpt,1620)
 1620     format(30x,'Mole Fraction')
          do ns = nr1,nr2
            write (noutpt,1630) uspec(ns),xbar(ns)
 1630       format(12x,a24,3x,f6.4)
          enddo
  190     continue
        enddo
        write (noutpt,1340)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1900)
 1900 format(/' - - - - - - - - - - - - - - - - - - - - - - - - ',
     $ '- - - - - - ',/)
      end

      subroutine cfje(conc,fjec,jcsort,narn1,narn2,nstmax,zchcu6)
c
c     This subroutine calculates the ionic asymmetry (the 3-rd order
c     electrostatic moment function J). This is defined as:
c
c       J = 1/6 SUM(i) m(i)z(i)**3
c
c     This is a higher order analogue of the ionic strength, I, which
c     is the 2nd-order electrostatic moment function. For comparison,
c     the ionic strength is defined as:
c
c       I = 1/2 SUM(i) m(i)z(i)**2
c
c     This J is not to be confused with the functions J0(x), J1(x), and
c     J2(x), which are also involved in higher-order electrostatic
c     contributions to activity coefficients (see EQLIBG/ghj0.f).
c     Note that a sorted summation is used.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQ3NR/arrset.f
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c       zchcu6 = array of one-sixth the electrical charge cubed
c
c     Principal output:
c
c       fjec   = the ionic asymmetry (the 3rd-order electrostatic
c                  moment function J)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 conc(nstmax),zchcu6(nstmax)
      real*8 fjec
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,ns,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,ns7,nval
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
c     Logically, this could be represented by:
c
c       fjec = 0.
c       do ns = narn1 + 1,narn2
c         fjec = fjec + conc(ns)*zchcu6(ns)
c       enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     In doing a sorted summation, a complication arises in that
c     water (ns = narn1) must be included in the range of the
c     loop, because the jcsort array is organized to contain the
c     species indices sorted according to increasing concentration
c     within phase ranges. There is no available sorting among
c     aqueous solute species only. Because the electrical charge
c     of water is zero, the calculation can be made looping from
c     narn1 to narn2. It is not necessary to temporarily set the
c     concentration of water (conc(narn1)) to zero. Note the use
c     of a local variable (xx) within the loop. Note also that the
c     loop is unrolled.
c
      xx = 0.
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        ns1 = jcsort(nss + 1)
        ns2 = jcsort(nss + 2)
        ns3 = jcsort(nss + 3)
        ns4 = jcsort(nss + 4)
        ns5 = jcsort(nss + 5)
        ns6 = jcsort(nss + 6)
        ns7 = jcsort(nss + 7)
        xx = xx + conc(ns0)*zchcu6(ns0) + conc(ns1)*zchcu6(ns1)
     $          + conc(ns2)*zchcu6(ns2) + conc(ns3)*zchcu6(ns3)
     $          + conc(ns4)*zchcu6(ns4) + conc(ns5)*zchcu6(ns5)
     $          + conc(ns6)*zchcu6(ns6) + conc(ns7)*zchcu6(ns7)
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        xx = xx + conc(ns)*zchcu6(ns)
      enddo
c
      fjec = xx
c
      end

      subroutine wr3d72(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $ jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,noprmx,noptmx,
     $ nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,
     $ rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,uebal,
     $ umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $ uxmd24,xlkmod)
c
c     This subroutine writes the EQ3NR input file in menu-style ("D")
c     format for version 7.0-7.1.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,nodbmx,nopgmx,noprmx,noptmx,nsqmax,ntitmx,nxmdmx,
     $ nxtmax
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jflagb(nsqmax),jxmod(nxmdmx),kxmod(nxmdmx),ncompb(nxtmax)
c
      integer itermx,newin,nsq,ntitl,nttyo,nxmod,nxtb
c
      character*80 utitl(ntitmx)
      character*24 ubasis(nsqmax),umemb(iktmax,nxtmax),uphas1(nsqmax),
     $ uphas2(nsqmax),usolb(nxtmax),uspecb(nsqmax),uxmd24(nxmdmx)
      character*24 uebal,uredox
c
      real*8 cspb(nsqmax),xbarb(iktmax,nxtmax),xlkmod(nxmdmx)
c
      real*8 fep,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat
c
c-----------------------------------------------------------------------
c
      include 'xcon3/x3op7.h'
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,idesc,idescx,ik,iktb,j,jfl,jj,j2,j3,n,ncount,nredox,
     $ ns,nx
      integer ilnobl
c
      logical qlcase
c
      character*24 unone,ux24
      character*16 udef(nto3pa),ujx(0:3)
      character*16 ux16
      character*8 usup(-1:2)
      character*1 ux1(3)
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
      data unone  /'none                    '/
c
      data udef(1)  / '1.0e-10  tolbt  '/
      data udef(2)  / '1.0e-10  toldl  '/
      data udef(3)  / '0.5      tolsat '/
      data udef(4)  / '30       itermx '/
c
      data ujx(0)   / 'aqueous         '/
      data ujx(1)   / 'mineral         '/
      data ujx(2)   / 'gas             '/
      data ujx(3)   / 'solid solution  '/
c
      data usup(-1) / 'suppress'/
      data usup(0)  / 'replace '/
      data usup(1)  / 'augmentk'/
      data usup(2)  / 'augmentg'/
c
c-----------------------------------------------------------------------
c
c     Write the new input file.
c
c     Title.
c
      write (newin,1090)
 1090 format('|',70('-'),'|')
      do 110 n = 1,ntitl
        write (newin,1100) utitl(n)
 1100   format('|',a70,'|')
  110 continue
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Temperature and density.
c
      write (newin,1050) tempc,rho
 1050 format('|Temperature (C)         |',f6.2,8x,'|Density(gm/cm3)|',
     $ f9.5,t72,'|')
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Total dissolved salts.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      if (tdspkg .gt. 0.) then
        ux1(1) = '*'
        xx = tdspkg
      elseif (tdspl .gt. 0.) then
        ux1(2) = '*'
        xx = tdspl
      else
        ux1(3) = '*'
        xx = 0.
      endif
c
      if (xx .gt. 0.) then
        write (newin,1060) xx,(ux1(i), i = 1,3)
 1060   format('|Total Dissolved Salts   | ',g12.5,t41,'|',a1,'mg/kg',
     $  t49,'|',a1,'mg/l',t57,'|',a1,'not used',t72,'|')
      else
        write (newin,1070) (ux1(i), i = 1,3)
 1070   format('|Total Dissolved Salts   | ',t41,'|',a1,'mg/kg',
     $  t49,'|',a1,'mg/l',t57,'|',a1,'not used',t72,'|')
      endif
      write (newin,1095)
 1095 format('|',78('-'),'|')
c
c-----------------------------------------------------------------------
c
c     Species for electrical balancing.
c
      ux1(1) = ' '
      ux1(2) = ' '
      if (uebal(1:8) .eq. 'pick1.  ') then
        ux1(1) = '*'
        uebal = ' '
      elseif (uebal(1:8) .eq. '        ') then
        ux1(2) = '*'
      endif
c
      write (newin,1080) uebal,ux1(1),ux1(2)
 1080 format('|Electrical Balancing on |',a24,'|',a1,'code selects|',
     $ a1,'not performed|')
      write (newin,1095)
c
c-----------------------------------------------------------------------
c
c     Basis species and associated constraints.
c
      write (newin,1110)
 1110 format('| SPECIES',16x,'| BASIS SWITCH/CONSTRAINT|',
     $ ' CONC/ETC  | UNITS OR TYPE  |')
      write (newin,1095)
c
      if (nsq .le. 0) then
        write (newin,1120)
 1120   format('| none',t26,'|',t51,'|',t63,'|',t80,'|')
        write (newin,1095)
      endif
c
      ux16 = ' '
      if (iopt(1) .eq. -2) then
        ux16 = 'pe'
      elseif (iopt(1) .eq. -1) then
        ux16 = 'Eh'
      elseif (iopt(1) .eq. 0) then
        ux16 = 'LogfO2'
      endif
c
      if (ux16(1:8) .ne. '        ') then
        write (newin,1130) fep,ux16
 1130   format('|redox',t26,'|',t51,'|',g11.5,'|',a16,'|')
      endif
c
      if (iopt(1) .eq. -3) then
        qlcase = .true.
        do 115 ns = 1, nsq
          ux24 = uspecb(ns)
          call locase(ux24)
          if (ux24(1:24). ne. uspecb(ns)(1:24)) then
            qlcase = .false.
            go to 117
          endif
  115   continue
  117   if (qlcase) then
          uredox = 'o2(g)'
        else
          uredox = 'O2(g)'
        endif
      endif
c
      nredox = 0
      if (iopt(1).eq.1 .or. iopt(1).eq.-3) then
        write (newin,1140)
1140    format('|redox',t26,'| Defined by next species',t51,'|',t63,
     $  '|Redox couple',t80,'|')
        do 120 ns = 1,nsq
          if (uredox(1:24) .eq. uspecb(ns)(1:24)) then
            nredox = ns
            go to 130
          endif
  120   continue
c
        j2 = ilnobl(uredox)
        write (nttyo,1145) uredox(1:j2)
        write (newin,1145) uredox(1:j2)
 1145   format(" * Error - (XCON3/wr3d72) Can't find the redox",
     $  /7x,'couple-defining  species "',a,'" in the set of',
     $  /7x,'basis species.')
        go to 999
c
  130   if (nredox .ne. 1) then
          ux24 = uspecb(1)
          uspecb(1) = uspecb(nredox)
          uspecb(nredox) = ux24
c
          xx = cspb(1)
          cspb(1) = cspb(nredox)
          cspb(nredox) = xx
c
          jfl = jflagb(1)
          jflagb(1) = jflagb(nredox)
          jflagb(nredox) = jfl
c
          ux24 = ubasis(1)
          ubasis(1) = ubasis(nredox)
          ubasis(nredox) = ux24
c
          ux24 = uphas1(1)
          uphas1(1) = uphas1(nredox)
          uphas1(nredox) = ux24
c
          ux24 = uphas2(1)
          uphas2(1) = uphas2(nredox)
          uphas2(nredox) = ux24
c
          nredox = 1
        endif
      endif
c
      do 180 ns = 1,nsq
        if (uphas1(ns)(1:8) .ne. '        ') then
          ux24 = uphas1(ns)
        else
          ux24 = ubasis(ns)
        endif
        jfl = jflagb(ns)
        write (newin,1150) uspecb(ns),ux24,cspb(ns),ujflg7(jfl)
 1150   format('|',a24,'|',a24,'|',g11.5,'|',a16,'|')
c
        if (jfl .eq. 20) then
          do 140 nx = 1,nxtb
            if (uphas1(ns)(1:24) .eq. usolb(nx)(1:24)) go to 150
  140     continue
c
          j2 = ilnobl(uphas1(ns))
          write (nttyo,1160) uphas1(ns)(1:j2)
          write (newin,1160) uphas1(ns)(1:j2)
 1160     format(" * Error - (XCON3/wr3d72) Can't find the solid",
     $    /7x,'solution "',a,'" in the set of solid solutions',
     $    /7x,'for which compositions are defined.')
          go to 999
c
  150     continue
          iktb = ncompb(nx)
          do 160 ik = 1,iktb
            if (uphas2(ns)(1:24) .eq. umemb(ik,nx)(1:24)) go to 170
  160     continue
c
          j3 = ilnobl(uphas2(ns))
          write (nttyo,1170) uphas2(ns)(1:j3),uphas1(ns)(1:j2)
          write (newin,1170) uphas2(ns)(1:j3),uphas1(ns)(1:j2)
 1170     format(" * Error - (XCON3/wr3d72) Can't find the end-member",
     $    /7x,'"',a,'" in the set of components used to,'
     $    /7x,'specify the composition of solid solution "',a,'".')
          go to 999
c
  170     write (newin,1180) umemb(ik,nx),xbarb(ik,nx)
 1180     format('|',24x,'|',a24,'|',g11.5,'|Mole fraction',t80,'|')
c
          do 175 i = 1,iktb
            if (i .ne. ik) write (newin,1180) umemb(i,nx),xbarb(i,nx)
  175     continue
        endif
  180 continue
c
  190 write (newin,1095)
c
c-----------------------------------------------------------------------
c
c     Input solid solutions, excluding those defined as part of
c     solubility equilibrium constraints.
c
      write (newin,1800)
 1800 format('|Input Solid Solutions',t80,'|')
      write (newin,1095)
c
      ncount = 0
      if (nxtb .gt. 0) then
        do 210 nx = 1,nxtb
          do 200 ns = 1,nsq
            if (jflagb(ns) .eq. 20) then
              if (usolb(nx)(1:24) .ne. uphas1(ns)(1:24)) then
                ncount = ncount + 1
                write (newin,1810) usolb(nx)
 1810           format('|',a24,'|',t51,'|',t63,'|',t80,'|')
                iktb = ncompb(nx)
                do 195 i = 1,iktb
                  write (newin,1815) umemb(i,nx),xbarb(i,nx)
 1815             format('|',t26,'|',a24,'|',g11.5,'|Mole fraction',
     $            t80,'|')
  195           continue
              endif
            endif
  200     continue
  210   continue
      endif
c
      if (ncount .le. 0) then
        write (newin,1820)
 1820   format('| none',t26,'|',t51,'|',t63,'|',t80,'|')
      endif
c
      write (newin,1095)
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      write (newin,3080)
 3080 format('|SUPPRESSED SPECIES',3x,
     $ '(suppress,replace,augmentk,augmentg)    value',t72,'|')
      write (newin,1090)
      if (nxmod .gt. 0) then
        do 520 n = 1,nxmod
          write (newin,3090) uxmd24(n),ujx(jxmod(n)),usup(kxmod(n)),
     $    xlkmod(n)
 3090     format('| ',a24,t26,'| ',a14,' | ',a8,' | ',g12.5,t72,'|')
  520   continue
      else
        write(newin,3095) unone
 3095     format('| ',a8,t26,'|',t43,'|',t54,'|',t72,'|')
      endif
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Options. Iopt, iopg, and iopr option switches, but not iodb
c     option switches. Skip any of the above which happen to be
c     development options.
c
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1460)
 1460 format('|OPTIONS',t72,'|')
      write (newin,1090)
c
      do 410 idescx = 1,nop3pa
        if (uvar3(idescx)(1:4) .ne. 'iodb') then
          j = ilnobl(uopt3(idescx))
          write (newin,1465) uopt3(idescx)(1:j)
 1465     format('| - ',a,' -',t72,'|')
c
          do 400 idesc = 1,nod3pa
            if (iopti3(idesc) .eq. idescx) then
              if (uvar3(idescx)(1:4) .eq. 'iopt') then
                if (iopt(index3(idescx)) .eq. ivalu3(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              elseif (uvar3(idescx)(1:4) .eq. 'iopg') then
                if (iopg(index3(idescx)) .eq. ivalu3(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              elseif (uvar3(idescx)(1:4) .eq. 'iopr') then
                if (iopr(index3(idescx)) .eq. ivalu3(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              else
                ux1(1) = ' '
              endif
              j = ilnobl(udesc3(idesc))
              write (newin,1470) ux1(1),udesc3(idesc)(1:j)
 1470         format('|',t5,a1,t7,a,t72,'|')
            endif
  400     continue
        endif
  410 continue
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Iodb switches.
c
      write (newin,1480)
 1480 format('|DEBUGGING SWITCHES (0 = off, 1,2 = on',t72,'|')
      write (newin,1090)
c
      do 420 idescx = 1,ndb3pa
        i = idbugi(idescx)
        j2 = ilnobl(udebug(idescx))
        j = index(udebug(idescx),'generic debugging')
        if (j .eq. 0) j = index(udebug(idescx),'pre-Newton-Raphson')
        if (j .eq. 0) then
          j = index(udebug(idescx),'stoichiometric factors')
          if (j .gt. 0) then
            jj = index(udebug(idescx),'factors calculation')
            if (jj .gt. 0) j = 0
          endif
        endif
        if (j .eq. 0) then
          write (newin,1490) iodb(i),udebug(idescx)(1:j2)
 1490     format('|',i1,2x,a,t72,'|')
        else
          write (newin,1495) iodb(i),udebug(idescx)(1:j2)
 1495     format('|',i1,2x,a,t72,'|2')
        endif
  420 continue
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Development options (there are none).
c
      write (newin,1700)
 1700 format('|DEVELOPMENT OPTIONS  (used for code development)',
     $ t72,'|')
      write (newin,1090)
      write (newin,1710)
 1710 format('| none',t72,'|')
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Tolerances.
c
      write (newin,1500)
 1500 format('|TOLERANCES',19x,'(desired values)',8x,'(defaults)',
     $ 7x,'|')
      write (newin,1090)
c
      if (tolbt .eq. 0) then
        write (newin,1510) utol3(1),udef(1)
 1510   format('|',a27,t28,'|',t51,'|',a16,t72,'|')
      else
        write (newin,1520) utol3(1),tolbt,udef(1)
 1520   format('|',a27,t28,'|',i10,t51,'|',a16,t72,'|')
      endif
c
      if (toldl .eq. 0) then
        write (newin,1510) utol3(2),udef(2)
      else
        write (newin,1520) utol3(2),toldl,udef(2)
      endif
c
      if (tolsat .eq. 0) then
        write (newin,1510) utol3(3),udef(3)
      else
        write (newin,1520) utol3(3),tolsat,udef(3)
      endif
c
      if (itermx .eq. 0) then
        write (newin,1510) utol3(4),udef(4)
      else
        write (newin,1520) utol3(4),itermx,udef(4)
      endif
c
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
  999 continue
      end

      subroutine rc3ocf(amu,jpfcmx,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $ ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,
     $ ilpsi2,ilzeta,iodb,nmux,nmut,nmutmx,nodbmx,noutpt,nstmax,
     $ nttyo,uspec,zchar)
c
c     This subroutine recalculates the original coefficients for
c     the third-order Cphi, psi, and zeta parameters. Coefficients
c     for parameters originally in mu form are are unchanged.
c
c     After all the third-order data are calculated and otherwise
c     processed, the Cphi data are transformed into the equivalent
c     C data.
c
c     This routine supports the default option to us C, psi,
c     and zeta directly in the calculation of activity
c     coefficients. This can be changed to the former treatment
c     using the USEOLDPITZERMU option string in the input file
c     title (this changes qhawep from .true. to .false.).
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       amu    = array of coefficients for computing mu interaction
c                parameters
c       nmux   = array containing the indices of the species
c                  corresponding to data in the amu array
c       uspec  = array of species names
c       zchar  = array of charge numbers
c
c     Principal output:
c
c       amu    = modified, array of coefficients for computing
c                Cphi, psi, zeta, and some remaining mu parameters
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer jpfcmx,nmutmx,nodbmx,nstmax
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nmut
c
      integer nmux(3,nmutmx),iodb(nodbmx)
c
      character(len=48) uspec(nstmax)
c
      real(8) amu(jpfcmx,nmutmx),zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ilnobl
c
      integer iz1,iz3,inote,na,j,j1,j2,j3,n,nmu,nmu1,nmu2,nnote,
     $ ns1,ns2,ns3
c
      real(8) az1,az2,az3,cx,cx1,cx2,z1,z2,z3
c
c-----------------------------------------------------------------------
c
c     Recalculate the original coefficients for the Cphi, psi, and
c     zeta interaction parameters from the derived set of coefficients
c     for conventional mu interaction parameters.
c
c     Take advantage of the expected structure of the data for the
c     mu parameters. These occur in the following order:
c
c       cca data (obtained from Cphi data)
c       aac data (obtained from the same set of Cphi data)
c       cc'a data (obtained from the psi(cc'a) data)
c       aa'c data (obtained from the psi(aa'c) data)
c       nnn data (mu data, stays the same)
c       nnn' data (mu data, stays the same)
c       nca data (obtained from zeta data)
c
c     The species within a triplet follow the above pattern.
c     Thus, so see if one species appears twice, it is only
c     necessary to see if the first and second species are
c     identical. Thus, cca data will always be stored as
c     "cca", never as "cac" or "acc".
c
c     The strategy here is as follows: store all converted data
c     in the original amu array, as originally indexed. The nmxi
c     "pointer" array can retain its structure as well.
c
c     The first step is to convert the mu(cca) back to Cphi(ca)
c     data. The mu(aac) are likewise converted back to Cphi(ac) data.
c     This is the same set of Cphi data, just available with different
c     indexing (Cphi(ac) = Cphi(ca)). This duplication allows the amu
c     array to be used without changing its structure.
c
c     The mu(cc'a) data are converted back to psi(cc'a) data,
c     and the mu(aa'c) data are likewise converted back to
c     psi(aa'c) data. The two psi data sets here are separate. Note
c     that the conversion back to psi data uses the recalculated
c     Cphi data. Each psi datum has two "cognate" Cphi data.
c     These cognate Cphi data are for the constituent binary
c     pairs (e.g., the cognates for psi(cc'a) are Cphi(ca) and
c     Cphi(c'a). If the data for a cognate Cphi are zero, the
c     corresponding mu data may not be loaded for use during the
c     run. In that case, the data will not be found among the
c     recalculated Cphi data. Zero values will then be assumed.
c
c     The mu(nnn) and mu(nnn') data were originally in the same form
c     and remain that way.
c
c     The mu(nca) data are converted back to zeta(nca) data. This is
c     a simple conversion, as the potential cognate parameters
c     (mu(ncc) and mu(naa)) are not used in the standard Pitzer model
c     incorporated into EQ3/6 and other geochemical modeling codes.
c
      inote = 0
      nnote = 0
c
c     Make the mu(cca) to Cphi(ca) conversions.
c
      ifcphi1 = 1
      ilcphi1 = 0
c
      do nmu = ifcphi1,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az3 = abs(z3)
c
        if ((ns1.eq.ns2 .and. ns2.ne.ns3) .and.
     $    (z1.gt.0 .and. z3.lt.0.)) then
c
c         Have an instance of mu(cca) data. Convert the coefficients
c         for mu(cca) to those for Cphi(ca).
c
          cx = 6.*sqrt(az3/az1)
          do j = 1,jpfcmx
            amu(j,nmu) = cx*amu(j,nmu)
          enddo
c
          ilcphi1 = nmu
c
        else
c
c         Have finished finding and processing all mu(cca) data.
c
          go to 110
c
        endif
      enddo
  110 continue
c
c     Make the mu(aac) to Cphi(ac) conversions.
c
      ifcphi2 = ilcphi1 + 1
      ilcphi2 = ilcphi1
c
      do nmu = ifcphi2,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az3 = abs(z3)
c
        if ((ns1.eq.ns2 .and. ns2.ne.ns3) .and.
     $    (z1.lt.0 .and. z3.gt.0.)) then
c
c         Have an instance of mu(aac) data. Convert the coefficients
c         for mu(aac) to those for Cphi(ac).
c
          cx = 6.*sqrt(az3/az1)
          do j = 1,jpfcmx
            amu(j,nmu) = cx*amu(j,nmu)
          enddo
c
          ilcphi2 = nmu
c
        else
c
c         Have finished finding and processing all mu(aac) data.
c
          go to 120
c
        endif
      enddo
  120 continue
c
c     Make the mu(cc'a) to psi(cc'a) conversions.
c
      ifpsi1 = ilcphi2 + 1
      ilpsi1 = ilcphi2
c
      do nmu = ifpsi1,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z2 = zchar(ns2)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az2 = abs(z2)
        az3 = abs(z3)
c
        if ((ns1.ne.ns2 .and. ns2.ne.ns3) .and.
     $    (z1.gt.0. .and. z2.gt.0. .and. z3.lt.0.)) then
c
c         Have an instance of mu(cc'a) data. Convert the coefficients
c         for mu(cc'a) to those for psi(cc'a).
c
c         First find the indices of the cognate mu(cca) and
c         mu(c'c'a) data.
c
          inote = 0
c
          nmu1 = 0
          do n = ifcphi1,ilcphi1
            if (nmux(1,n).eq.ns1 .and. nmux(3,n).eq.ns3) then
              nmu1 = n
              go to 130
            endif
          enddo
c
          if (iodb(1) .gt. 0) then
            j1 = ilnobl(uspec(ns1)(1:24))
            j2 = ilnobl(uspec(ns2)(1:24))
            j3 = ilnobl(uspec(ns3)(1:24))
            write (noutpt,1000) uspec(ns1)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            write (nttyo,1000) uspec(ns1)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
 1000       format(/' * Note - (EQLIBG/rc3ocf) Could not find the',
     $      ' Cphi data for',/7x,a,', ',a,'. They are needed to',
     $      ' recalculate',/7x,'the psi data for ',a,', ',a,', ',a,'.',
     $      /7x,'Zero values will be assumed.')
            inote = inote + 1
            nnote = nnote + 1
          endif
c
  130     continue
c
          nmu2 = 0
          do n = ifcphi1,ilcphi1
            if (nmux(1,n).eq.ns2 .and. nmux(3,n).eq.ns3) then
              nmu2 = n
              go to 140
            endif
          enddo
c
          if (iodb(1) .gt. 0) then
            j1 = ilnobl(uspec(ns1)(1:24))
            j2 = ilnobl(uspec(ns2)(1:24))
            j3 = ilnobl(uspec(ns3)(1:24))
            write (noutpt,1000) uspec(ns2)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            write (nttyo,1000) uspec(ns2)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            inote = inote + 1
            nnote = nnote + 1
          endif
c
  140     continue
c
          do j = 1,jpfcmx
            amu(j,nmu) = 6.*amu(j,nmu)
          enddo
          if (nmu1 .gt. 0) then
            cx1 = 0.5*az2/sqrt(az1*az3)
            do j = 1,jpfcmx
              amu(j,nmu) = amu(j,nmu) - cx1*amu(j,nmu1)
            enddo
          endif
          if (nmu2 .gt. 0) then
            cx2 = 0.5*az1/sqrt(az2*az3)
            do j = 1,jpfcmx
              amu(j,nmu) = amu(j,nmu) - cx2*amu(j,nmu2)
            enddo
          endif
c
          ilpsi1 = nmu
c
        else
c
c         Have finished finding and processing all mu(aac) data.
c
          go to 150
c
        endif
      enddo
  150 continue
c
c     Make the mu(aa'c) to psi(aa'c) conversions.
c
      ifpsi2 = ilpsi1 + 1
      ilpsi2 = ilpsi1
c
      do nmu = ifpsi2,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z2 = zchar(ns2)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az2 = abs(z2)
        az3 = abs(z3)
c
        if ((ns1.ne.ns2 .and. ns2.ne.ns3) .and.
     $    (z1.lt.0. .and. z2.lt.0. .and. z3.gt.0.)) then
c
c         Have an instance of mu(aa'c) data. Convert the coefficients
c         for mu(aa'c) to those for psi(aa'c).
c
c         First find the indices of the cognate mu(aac) and
c         mu(a'a'c) data.
c
          inote = 0
c
          nmu1 = 0
          do n = ifcphi2,ilcphi2
            if (nmux(1,n).eq.ns1 .and. nmux(3,n).eq.ns3) then
              nmu1 = n
              go to 160
            endif
          enddo
c
          if (iodb(1) .gt. 0) then
            j1 = ilnobl(uspec(ns1)(1:24))
            j2 = ilnobl(uspec(ns2)(1:24))
            j3 = ilnobl(uspec(ns3)(1:24))
            write (noutpt,1000) uspec(ns1)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            write (nttyo,1000) uspec(ns1)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            inote = inote + 1
            nnote = nnote + 1
          endif
c
  160     continue
c
          nmu2 = 0
          do n = ifcphi2,ilcphi2
            if (nmux(1,n).eq.ns2 .and. nmux(3,n).eq.ns3) then
              nmu2 = n
              go to 170
            endif
          enddo
c
          if (iodb(1) .gt. 0) then
            j1 = ilnobl(uspec(ns1)(1:24))
            j2 = ilnobl(uspec(ns2)(1:24))
            j3 = ilnobl(uspec(ns3)(1:24))
            write (noutpt,1000) uspec(ns2)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            write (nttyo,1000) uspec(ns2)(1:j1),uspec(ns3)(1:j3),
     $      uspec(ns1)(1:j1),uspec(ns2)(1:j2),uspec(ns3)(1:j3)
            inote = inote + 1
            nnote = nnote + 1
          endif
c
  170     continue
c
          do j = 1,jpfcmx
            amu(j,nmu) = 6.*amu(j,nmu)
          enddo
          if (nmu1 .gt. 0) then
            cx1 = 0.5*az2/sqrt(az3*az1)
            do j = 1,jpfcmx
              amu(j,nmu) = amu(j,nmu) - cx1*amu(j,nmu1)
            enddo
          endif
          if (nmu2 .gt. 0) then
            cx2 = 0.5*az1/sqrt(az3*az2)
            do j = 1,jpfcmx
              amu(j,nmu) = amu(j,nmu) - cx2*amu(j,nmu2)
            enddo
          endif
c
          ilpsi2 = nmu
c
        else
c
c         Have finished finding and processing all mu(aac) data.
c
          go to 180
        endif
      enddo
  180 continue
c
c     Skip past the mu(nnn) data.
c
      ifnnn = ilpsi2 + 1
      ilnnn = ilpsi2
c
      do nmu = ifnnn,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        iz1 = nint(z1)
c
        if ((ns1.eq.ns2 .and. ns2.eq.ns3) .and. iz1.eq.0) then
c
c         Have an instance of mu(nnn) data.
c
          ilnnn = nmu
c
        else
c
c         Have finished finding all mu(nnn) data.
c
          go to 190
c
        endif
      enddo
  190 continue
c
c     Skip past the mu(nnn') data.
c
      ifn2n = ilnnn + 1
      iln2n = ilnnn
c
      do nmu = ifn2n,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        iz1 = nint(z1)
        iz3 = nint(z3)
c
        if ((ns1.eq.ns2 .and. ns1.ne.ns3) .and.
     $    (iz1.eq.0 .and. iz3.eq.0)) then
c
c         Have an instance of mu(nnn') data.
c
          iln2n = nmu
c
        else
c
c         Have finished finding all mu(nnn') data.
c
          go to 200
c
        endif
      enddo
  200 continue
c
      ifzeta = iln2n + 1
      ilzeta = iln2n
c
c     Make the mu(nca) to zeta(nca) conversions.
c
      do nmu = ifzeta,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az3 = abs(z3)
c
        if ((ns1.ne.ns2 .and. ns2.ne.ns3) .and.
     $    (iz1.eq.0 .and. z2.gt.0. .and. z3.lt.0.)) then
c
c         Have an instance of mu(nca) data. Convert the coefficients
c         for mu(nca) to those for zeta(nca).
c
          do j = 1,jpfcmx
            amu(j,nmu) = 6.*amu(j,nmu)
          enddo
c
          ilzeta = nmu
c
        else
c
c         Have finished finding and processing all mu(nca) data.
c
          go to 210
c
        endif
      enddo
  210 continue
c
      if (iodb(1) .gt. 0) then
c
c       Check results.
c
        write (noutpt,1100)
 1100   format(/1x,"Recalculated third-order Pitzer coefficients")
c
        write (noutpt,1110)
 1110   format(/1x,"Cphi(ca) data")
        do n = ifcphi1,ilcphi1
          ns1 = nmux(1,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1120) uspec(ns1),uspec(ns3)(1:j3)
 1120     format(/1x,a24,2x,a)
          write (noutpt,1130)
 1130     format(3x,"Cphi:")
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
 1150       format (5x,"a",i1," = ",f10.6)
          enddo
        enddo
c
        write (noutpt,1200)
 1200   format(/1x,"Cphi(ac) data")
        do n = ifcphi2,ilcphi2
          ns1 = nmux(1,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1120) uspec(ns1),uspec(ns3)(1:j3)
          write (noutpt,1130)
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
        write (noutpt,1310)
 1310   format(/1x,"psi(cc'a) data")
        do n = ifpsi1,ilpsi1
          ns1 = nmux(1,n)
          ns2 = nmux(2,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1320) uspec(ns1),uspec(ns2),uspec(ns3)(1:j3)
 1320     format(/1x,a24,2x,a24,2x,a)
          write (noutpt,1330)
 1330     format(3x,"psi:")
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
        write (noutpt,1410)
 1410   format(/1x,"psi(aa'c) data")
        do n = ifpsi2,ilpsi2
          ns1 = nmux(1,n)
          ns2 = nmux(2,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1320) uspec(ns1),uspec(ns2),uspec(ns3)(1:j3)
          write (noutpt,1330)
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
        write (noutpt,1510)
 1510   format(/1x,"mu(nnn) data")
        do n = ifnnn,ilnnn
          ns1 = nmux(1,n)
          ns2 = nmux(2,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1320) uspec(ns1),uspec(ns2),uspec(ns3)(1:j3)
          write (noutpt,1520)
 1520     format(3x,"mu:")
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
        write (noutpt,1610)
 1610   format(/1x,"mu(nnn') data")
        do n = ifn2n,iln2n
          ns1 = nmux(1,n)
          ns2 = nmux(2,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1320) uspec(ns1),uspec(ns1),uspec(ns3)(1:j3)
          write (noutpt,1520)
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
        write (noutpt,1710)
 1710   format(/1x,"zeta(nca) data")
        do n = ifzeta,ilzeta
          ns1 = nmux(1,n)
          ns2 = nmux(2,n)
          ns3 = nmux(3,n)
          j3 = ilnobl(uspec(ns3)(1:24))
          write (noutpt,1320) uspec(ns1),uspec(ns2),uspec(ns3)(1:j3)
          write (noutpt,1720)
 1720     format(3x,"zeta:")
          do j = 1,jpfcmx
            write (noutpt,1150) j,amu(j,n)
          enddo
        enddo
c
      endif
c
c     Transform the Cphi data into the equivalent C data.
c
      do n = ifcphi1,ilcphi1
        ns1 = nmux(1,n)
        ns3 = nmux(3,n)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az3 = abs(z3)
        cx = 1./(2.*sqrt(az1*az3))
        do j = 1,jpfcmx
          amu(j,n) = cx*amu(j,n)
        enddo
      enddo
c
      do n = ifcphi2,ilcphi2
        ns1 = nmux(1,n)
        ns3 = nmux(3,n)
        z1 = zchar(ns1)
        z3 = zchar(ns3)
        az1 = abs(z1)
        az3 = abs(z3)
        cx = 1./(2.*sqrt(az1*az3))
        do j = 1,jpfcmx
          amu(j,n) = cx*amu(j,n)
        enddo
      enddo
c
  999 continue
      end

      subroutine zsrt(izmax,narn1,narn2,nstmax,zchar)
c
c     This subroutine finds the largest absolute value of the electrical
c     charge of any aqueous species (izmax). It is used as a limit in
c     calculating higher-order electrostatic terms in Pitzer's
c     equations.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       zchar  = array of electrical charge numbers
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c
c     Principal output:
c
c       izmax  = max norm of the electrical charges of the
c                aqueous species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer izmax,narn1,narn2
c
      real*8 zchar(nstmax)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,jzmax,jzmin,ns,nval
c
      real*8 zmax,zmin,zx,zx0,zx1,zx2,zx3,zx4,zx5,zx6,zx7
c
c----------------------------------------------------------------------
c
c     Find the extreme values of electrical charge among the aqueous
c     species. Note that the loop is unrolled.
c
      zmax = 0.
      zmin = 0.
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do ns = narn1,ileft,8
        zx0 = zchar(ns)
        zx1 = zchar(ns + 1)
        zx2 = zchar(ns + 2)
        zx3 = zchar(ns + 3)
        zx4 = zchar(ns + 4)
        zx5 = zchar(ns + 5)
        zx6 = zchar(ns + 6)
        zx7 = zchar(ns + 7)
        zmin = min(zx0,zx1,zx2,zx3,zx4,zx5,zx6,zx7,zmin)
        zmax = max(zx0,zx1,zx2,zx3,zx4,zx5,zx6,zx7,zmax)
      enddo
c
      do ns = ileft + 1,narn2
        zx = zchar(ns)
        zmin = min(zx,zmin)
        zmax = max(zx,zmax)
      enddo
c
c     Find the largest absolute value of electrical charge.
c
      jzmin = nint(zmin)
      jzmax = nint(zmax)
      izmax = max(-jzmin,jzmax)
c
      end

      subroutine daxpy(nmax,scfact,array1,incx,array2,incy)
c
c     This subroutine multiplies the real*8 array "array1" by the
c     real*8 constant scfact and adds that to the real*8 array "array2".
c     The result is returned in "array2". The relevant equation is
c     (y) = a*(x) + (y). This subroutine is an adaptation of the 1979
c     Linpack subroutine of the same name. The size and order in the
c     original calling sequence has been preserved:
c     (n,da,dx,incx,dy,incy) == (nmax,scfact,array1,incx,array2,incy).
c     The increments incx and incy are not used here (each is taken
c     as having a value of 1; input of any other value constitutes
c     an error). This is a pseudo-Linpack BLAS (Basic Linear Algebra
c     Subsystem) subroutine.
c
c     This subroutine is called by:
c
c       EQLIBU/dgefa.f
c       EQLIBU/dgesl.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nmax   = dimension or pseudo-dimension of array
c       scfact = the scale factor
c       array1 = the first array (x)
c       array2 = the second array (y)
c       incx   = the x increment (must have a value of 1)
c       incy   = the y increment (must have a value of 1)
c
c     Output:
c
c       array2 = the original array multiplied by the scale factor.
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
      integer incx,incy
c
      real*8 array1(nmax),array2(nmax)
c
      real*8 scfact
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 scx
c
c-----------------------------------------------------------------------
c
c     Trap illegal values of incx and incy.
c
      if (incx .ne. 1) then
        write (6,1000) incx
 1000   format(/' * Error - (EQLIBU/daxpy) The argument incx has a',
     $  /7x,'value of ',i5,'. This version of daxpy only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
      if (incy .ne. 1) then
        write (6,1010) incy
 1010   format(/' * Error - (EQLIBU/daxpy) The argument incy has a',
     $  /7x,'value of ',i5,'. This version of daxpy only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
c     Note that the loop is unrolled.
c
      scx = scfact
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        array2(i) = array2(i) + scx*array1(i)
        array2(i + 1) = array2(i + 1) + scx*array1(i + 1)
        array2(i + 2) = array2(i + 2) + scx*array1(i + 2)
        array2(i + 3) = array2(i + 3) + scx*array1(i + 3)
        array2(i + 4) = array2(i + 4) + scx*array1(i + 4)
        array2(i + 5) = array2(i + 5) + scx*array1(i + 5)
        array2(i + 6) = array2(i + 6) + scx*array1(i + 6)
        array2(i + 7) = array2(i + 7) + scx*array1(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        array2(i) = array2(i) + scx*array1(i)
      enddo
c
      end

      subroutine thetck(athetx,jpfcmx,na,nc,nerr,nn,noutpt,nttyo,
     $ n1,n2,n3,unam1,unam2,unam3)
c
c     This suboutine checks data that were read from the S-theta
c     fields of the DATA0 file.
c
c     This suboutine is called by:
c
c       EQPT/rdpz3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       na     = number of anions in a species triplet
c       nc     = number of cations in a species triplet
c       nn     = number of neutral species in a species triplet
c       n1     = index of the first species in a triplet
c       n2     = index of the second species in a triplet
c       n3     = index of the third species in a triplet
c       unam1  = first name in a species triplet
c       unam2  = second name in a species triplet
c       unam3  = third name in a species triplet
c
c     Principal output:
c
c       nerr   = error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jpfcmx
c
      integer noutpt,nttyo
c
      integer na,nc,nn,nerr,n1,n2,n3
c
      character*24 unam1,unam2,unam3
c
      real*8 athetx(jpfcmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,j2,j3,j4
c
      integer ilnobl
c
      logical qzethx
c
c-----------------------------------------------------------------------
c
c     Check for erroneous data in the thetax data.
c
c
      qzethx = .true.
      do j = 1,jpfcmx
        if (athetx(j) .ne. 0.) qzethx = .false.
      enddo
c
      if (.not.qzethx) then
c
        if (nn .eq. 3) then
c
c         Note: the unique neutral is assumed to be the third
c         species in the triplet.
c
          if (n1.eq.n2 .and. n3.ne.n1) then
c
c           Have an nnn' combination.
c
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            j4 = ilnobl(unam3)
            write (noutpt,1400) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1400) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1400       format(/' * Error - (EQPT/thetck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,
     $      ', ',a,' among the blocks for',/7x,'"mixture parameters".',
     $      ' Have non-zero input for lambda data in the',
     $      /7x,'"theta" field. Only mu data may be specified (in',
     $      ' the "psi" field)',/7x,'in a block of this type. This',
     $      " is an nnn' combination. Enter the",/7x,'corresponding',
     $      " lambda(nn') data",' in a "single-salt parameters" block,',
     $      /7x,'using the "beta0" field. Leave the'," mu(nnn') data",
     $      ' in the present',/7x,'"mixture parameters" block (in the',
     $      ' "psi" field). Enter the',/7x,"corresponding mu(n'n'n)",
     $      ' data in a second "mixture parameters" block',
     $      /7x,'(in the "psi" field).')
            nerr = nerr + 1
          endif
        endif
c
        if (nn.eq.1 .and. nc.eq.1 .and. na.eq.1) then
c
c         Have an nca combination.
c
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          j4 = ilnobl(unam3)
          write (noutpt,1410) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1410) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1410     format(/' * Error - (EQPT/thetck) Have found an illegal',
     $    ' data block for the',/7x,'species triplet ',a,', ',a,
     $    ', ',a,' among the blocks for',/7x,'"mixture parameters".',
     $    ' Have non-zero input for lambda data in the',/7x,'"theta"',
     $    ' field. Only zeta data may be specified (in the "psi"',
     $    ' field)',/7x,'in a block of this type. This is an nca',
     $    ' combination. Enter the',/7x,'corresponding lambda(nc)',
     $    ' and lambda(na) data in separate',/7x,'"single-salt',
     $    ' parameters" blocks, using the "beta0" fields.',
     $    /7x,'Leave the zeta(nca) data in the present "mixture',
     $    ' parameters"',/7x,'block (in the "psi" field).')
          nerr = nerr + 1
        endif
c
      endif
c
      end

      subroutine tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $ ntprt,nttyo,nwarn,ustrgr)
c
c     This subroutine tests the contents of a "log K" temperature
c     grid for sparse contents in any range. The response to an
c     instance of sparseness is determined by the variable
c     itgenf (-1 = ignore, 0 = warn, 1 = error). This subroutine
c     need not be called if itgenf = -1.
c
c     This suboutine is called by:
c
c       EQPT/rdpar.f
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       itgenf = integer flag controlling the response to a detected
c                  incidence of sparseness (-1 = ignore, 0 = warn,
c                  1 = error)
c       nacdpr = array giving the number of points containing actual
c                  data in a temperature range for the "log K" grid
c                  currently being examined
c       narxt  = array giving the number of points (actual data plus
c                  no data) in that range
c       ntprt  = the number of ranges in the current "log K" grid
c       ustrgr = string describing what the grid represents
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ntprmx
c
      integer noutpt,nttyo
c
      integer itgenf,nerr,ntprt,nwarn
c
      integer nacdpr(ntprmx),narxt(ntprmx)
c
      character(len=56) ustrgr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4,ntpr
c
      logical qx
c
      integer ilnobl
c
      character(len=8) ux8a,ux8b
c
c-----------------------------------------------------------------------
c
      do ntpr = 1,ntprt
c
        if (narxt(ntpr) .le. 3) then
c
c         For a range with up to three grid points, at least two
c         must contain actual data. Note that a range can not
c         be composed of fewer than two grid points.
c
          qx = nacdpr(ntpr) .lt. 2
        else
c
c         Otherwise, at least three points containing actual data
c         are required.
c
          qx = nacdpr(ntpr) .lt. 3
        endif
c
        if (qx .and. itgenf.ge.0) then
          write (ux8a,'(i5)') nacdpr(ntpr)
          call lejust(ux8a)
          j2 = ilnobl(ux8a)
          write (ux8b,'(i5)') ntpr
          call lejust(ux8b)
          j3 = ilnobl(ux8b)
          call lejust(ustrgr)
          j4 = ilnobl(ustrgr)
          if (itgenf .eq. 0) then
            nwarn = nwarn + 1
            if (nacdpr(ntpr) .gt. 0) then
              write (noutpt,1000) ux8a(1:j2),ux8b(1:j3),ustrgr(1:j4)
              write (nttyo,1000) ux8a(1:j2),ux8b(1:j3),ustrgr(1:j4)
 1000         format(/' * Warning - (EQPT/tegrid) The number of grid',
     $        ' points containing actual',/7x,'data is only ',a,' in',
     $        ' range ',a,' of the temperature grid representing',
     $        /7x,a,'.')
            else
              write (noutpt,1010) ux8b(1:j3),ustrgr(1:j4)
              write (nttyo,1010) ux8b(1:j3),ustrgr(1:j4)
 1010         format(/' * Warning - (EQPT/tegrid) There are no grid',
     $        ' points containing actual',/7x,'data in range ',a,
     $        ' of the temperature grid representing',/7x,a,'.')
            endif
          else
            nerr = nerr + 1
            if (nacdpr(ntpr) .gt. 0) then
              write (noutpt,1030) ux8a(1:j2),ux8b(1:j3),ustrgr(1:j4)
              write (nttyo,1030) ux8a(1:j2),ux8b(1:j3),ustrgr(1:j4)
 1030         format(/' * Error - (EQPT/tegrid) The number of grid',
     $        ' points containing actual',/7x,'data is only ',a,' in',
     $        ' range ',a,' of the temperature grid representing',
     $        /7x,a,'.')
            else
              write (noutpt,1040) ux8b(1:j3),ustrgr(1:j4)
              write (nttyo,1040) ux8b(1:j3),ustrgr(1:j4)
 1040         format(/' * Error - (EQPT/tegrid) There are no grid',
     $        ' points containing actual',/7x,'data in range ',a,
     $        ' of the temperature grid representing',/7x,a,'.')
            endif
          endif
        endif
      enddo
c
  999 continue
      end

      subroutine wrhdr(ikt_asv,ipch_asv,ipcv_asv,jpfc_asv,nap_asv,
     $ narx_asv,nat_asv,nbt_asv,nct_asv,ndata1,ndat1f,ngt_asv,
     $ nlat_asv,nlt_asv,nmt_asv,nmut_asv,npt_asv,nst_asv,ntid_asv,
     $ ntpr_asv,nxt_asv,uakey)
c
c     This suboutine writes a header on the DATA1 and DATA1F files.
c     The header includes the string "data1', followed by the keystring
c     for the type of aqueous species activity coefficient model, and
c     the dimensioning parameters required to read the rest of the data
c     on the DATA1 file. The dimensioning parameters are used by EQ3NR
c     and EQ6.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndata1    = the unit number of the DATA1 file
c       ndat1f    = the unit number of the DATA1F file
c       uakey     = the keystring identifying the type of model for the
c                     aqueous species activity coefficients
c       ikt_asv  = the maximum number of end-member component species
c                    in any solid solution on the data file
c       jpfc_asv = the number of terms (coefficients) in the
c                    temperature function used to represent Pitzer
c                    interaction parameters
c       nap_asv  = maximum number of distinct sets of Pitzer alpha
c                    parameters
c       nat_asv  = the number of aqueous species on the data file
c       nbt_asv  = the number of basis species on the data file
c       nct_asv  = the number of chemical elements on the data file
c       ngt_asv  = the number of gas species on the data file
c       nlt_asv  = the number of pure liquid species on the data file
c       nmt_asv  = the number of gas species on the data file
c       npt_asv  = The number of phases of all types on the data file
c       nlat_asv = the number of members in the set of Pitzer lambda
c                    coefficients
c       nmut_asv = the number of members in the set of Pitzer mu
c                    coefficients
c       nst_asv  = the number of species of all types on the data file
c       ntid_asv = the number of lines in the data file title
c       nxt_asv  = the number of solid-solution phases on the data file
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndata1,ndat1f
c
      integer ikt_asv,ipch_asv,ipcv_asv,jpfc_asv,nap_asv,narx_asv,
     $ nat_asv,nbt_asv,nct_asv,ngt_asv,nlat_asv,nlt_asv,nmt_asv,
     $ nmut_asv,npt_asv,nst_asv,ntid_asv,ntpr_asv,nxt_asv
c
      character(len=8) uakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3
c
      integer ilnobl
c
      character(len=72) uterm,utermc
      character(len=56) ux56
      character(len=8) udat1
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     Write 'data1' at the top of the DATA1 and DATA1F files.
c
      udat1 = 'data1'
      j2 = ilnobl(udat1)
c
      write (ndata1) udat1
      write (ndat1f,1000) udat1(1:j2)
 1000 format(a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Next write the keystring for the type of model for the activity
c     coefficients of the aqueous species.
c
      j3 = ilnobl(uakey)
c
      write (ndata1) uakey
      write (ndat1f,1000) uakey(1:j3)
      write (ndat1f,1000) utermc(1:72)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the minimum dimensioning parameters required by the current
c     data file. This will be used by EQ3NR and EQ6 to allocate array
c     sizes for arrays which will contain the data read from this data
c     file.
c
c     Write the standard grid parameters on the output files.
c
      ux56 = 'Dim: chemical elements'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nct_asv
      write (ndat1f,1010) nct_asv
 1010 format(i5)
c
      ux56 = 'Dim: basis species'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nbt_asv
      write (ndat1f,1010) nbt_asv
c
      ux56 = 'Dim: total species of all types'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nst_asv
      write (ndat1f,1010) nst_asv
c
      ux56 = 'Dim: total phases'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) npt_asv
      write (ndat1f,1010) npt_asv
c
      ux56 = 'Dim: aqueous species'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nat_asv
      write (ndat1f,1010) nat_asv
c
      ux56 = 'Dim: pure minerals'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nmt_asv
      write (ndat1f,1010) nmt_asv
c
      ux56 = 'Dim: pure liquids'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nlt_asv
      write (ndat1f,1010) nlt_asv
c
      ux56 = 'Dim: gas species'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ngt_asv
      write (ndat1f,1010) ngt_asv
c
      ux56 = 'Dim: solid solutions'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) nxt_asv
      write (ndat1f,1010) nxt_asv
c
      ux56 = 'Dim: max. components in a solid solution'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ikt_asv
      write (ndat1f,1010) ikt_asv
c
      ux56 = 'Dim: lines in the data file title'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ntid_asv
      write (ndat1f,1010) ntid_asv
c
      ux56 = 'Dim: ranges in the logK temperature grid'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ntpr_asv
      write (ndat1f,1010) ntpr_asv
c
      ux56 = 'Dim: max. points in a logK temperature grid range'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) narx_asv
      write (ndat1f,1010) narx_asv
c
      ux56 = 'Dim: dH/dP order'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ipch_asv
      write (ndat1f,1010) ipch_asv
c
      ux56 = 'Dim: dV/dP order'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1000) ux56(1:j2)
      write (ndata1) ipcv_asv
      write (ndat1f,1010) ipcv_asv
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
        ux56 = 'Dim: distinct sets of Pitzer alpha parameters'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1000) ux56(1:j2)
        write (ndata1) nap_asv
        write (ndat1f,1010) nap_asv
c
        ux56 = 'Dim: Pitzer lambda parameters'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1000) ux56(1:j2)
        write (ndata1) nlat_asv
        write (ndat1f,1010) nlat_asv
c
        ux56 = 'Dim: Pitzer mu parameters'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1000) ux56(1:j2)
        write (ndata1) nmut_asv
        write (ndat1f,1010) nmut_asv
c
        ux56 = 'Dim: coefficients in the Pitzer parameter'
     $  // ' temp. function'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1000) ux56(1:j2)
        write (ndata1) jpfc_asv
        write (ndat1f,1010) jpfc_asv
      endif
c
      write (ndat1f,1000) utermc(1:72)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gdlgxw(cdrs,cjbasp,cnufac,conc,dlogxw,eps100,
     $ ixbasp,jcsort,jflag,narn1,narn2,nbasp,nbt,nbtmax,nbw,
     $ ndrs,ndrsmx,ndrsr,nern1,nern2,noutpt,nstmax,nttyo,omega,
     $ xbar,xbarw)
c
c     This subroutine computes the array dlogxw, which contains the
c     partial derivatives:
c
c       d log x(w)/d log m(s')
c
c     where s' denotes a basis species other than water. Allowed
c     basis species may be aqueous or generic ion exchanger species.
c
c     This subroutine is called by:
c
c       EQLIB/matrix.f
c       EQ3NR/arrsim.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt,nttyo
c
      integer ixbasp(nbtmax),jcsort(nstmax),jflag(nstmax),nbasp(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax)
      integer narn1,narn2,nbt,nbw,nern1,nern2
c
      real*8 cdrs(ndrsmx),cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),
     $ dlogxw(nbtmax),xbar(nstmax)
      real*8 eps100,omega,xbarw
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,nsc,nse,nss
c
      real*8 cw,cxec,dx,sumw,xx
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      if (nbw .eq. 0) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/' * Error - (EQLIB/dxlgxw) Programming error trap:',
     $  /7x,'Water is not in the basis set, so the dlogxw array',
     $  /7x,'should not be calculated.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the "conc" of water is zero. This will be restored
c     at the end of this subroutine. This practice allows avoiding "if"
c     testing in the following loops. Note that there is no actual
c     element of the dlogxw array for water (basis index nbw). However,
c     there is a sum used in the denominator of the other array elements
c     that is based on water, and this resembles the sums accumulated
c     for the other elements. Therefore, dlogxw(nbw) will be used here
c     to accumulate that sum. It will be reset to zero after the sum
c     is used.
c
      cw = conc(narn1)
      conc(narn1) = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the sums needed to calculate the dlogxw array.
c     Store them in this array.
c
      do nb = 1,nbt
        nse = nbasp(nb)
        dlogxw(nb) = conc(nse)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nss = narn1,narn2
        nsc = jcsort(nss)
        if (jflag(nsc) .eq. 30) then
c
          do nb = 1,nbt
            nse = nbasp(nb)
c
c           Calling sequence substitutions:
c             nsc for ns
c
            cxec = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,nsc,nstmax)
c
c           Here cnufac(nsc) = -conc(nsc)/cdrs(ndrsr(1,nsc)), or
c           the negative of the molality of a dependent species
c           divided by its (intrinsically negative) reaction
c           coefficient in its associated reaction.
c
            dlogxw(nb) = dlogxw(nb) + cxec*cnufac(nsc)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the dlogxw array from the sums. The common denominator
c     (dx) for the elements corresponding to basis species other than
c     water is computed from the sum for water.
c
c     Do not protect here against a value of xbarw that is ridiculously
c     small, say on the order of 1.e-30. Such a value seems to be
c     necessary to obtaining good results in pre-Newton-Raphson
c     optimization. Only protect against a zero divide below, where
c     dx (derived from xbarw) appears in a denominator.
c
      xx = xbarw/omega
      sumw = dlogxw(nbw)
      dlogxw(nbw) = 0.
      dx = 1. + xx*sumw
c
c     Protect against the case in which dx is zero. This is designed
c     to prevent a fatal floating point exception in pre-Newton-Raphson
c     optimization.
c
      if (dx.ge.0. .and.  dx.lt.eps100) dx = eps100
      if (dx.lt.0. .and.  dx.gt.-eps100) dx = -eps100
c
      do nb = 1,nbt
        if (nb .ne. nbw) then
          dlogxw(nb) = -xx*dlogxw(nb)/dx
          if (ixbasp(nb) .ge. 1) then
c
c           Here nb refers to a basis species whose thermodynamic
c           activity is defined by its mole fraction.
c
            nse = nbasp(nb)
            dlogxw(nb) = dlogxw(nb)*cjbasp(nb)*(1.0 - xbar(nse))
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Restore the "conc" of water.
c
      conc(narn1) = cw
c
      end

      subroutine initlv(qarray,nmax,qvalue)
c
c     This subroutine initializes the logical array qarray to qvalue
c     over the first nmax positions. Normally, nmax would be the
c     dimension of the 1D qarray. However, nmax could be less than the
c     true dimension. Also, qarray could actually have more than one
c     dimension. For example, if the array is really qa, having
c     dimensions of i1 and i2, this subroutine could be used by calling
c     it in the following manner: call initlv(qa,(i1*i2),qvalue).
c     Use this subroutine with caution if nmax is not the product of the
c     true (declared) dimensions.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       qarray = the array
c       nmax   = dimension or pseudo-dimension of array
c       qvalue = the initialization value (.true. or .false.)
c
c     Output:
c
c       qarray = qarray, with the first nmax positions set to the
c                initialization value
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      logical qarray(nmax),qvalue
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      logical qv
c
c-----------------------------------------------------------------------
c
c     Note the assignment of the value to a local variable.
c     Note that the loop is unrolled.
c
      qv = qvalue
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        qarray(i) = qv
        qarray(i + 1) = qv
        qarray(i + 2) = qv
        qarray(i + 3) = qv
        qarray(i + 4) = qv
        qarray(i + 5) = qv
        qarray(i + 6) = qv
        qarray(i + 7) = qv
      enddo
c
      do i = ileft + 1,nmax
        qarray(i) = qv
      enddo
c
      end

      subroutine prtaqs(acflg,actlg,conc,conclg,iopr,jcsort,narn1,
     $ narn2,noprmx,noutpt,nstmax,uspec)
c
c     This subroutine prints a table of the concentrations, activities,
c     and activity coefficients of the aqueous solute species. The
c     species are listed in decreasing order of concentration. The
c     level of printing is controlled by the print control flag
c     iopr(4):
c
c       -3  = Omit species with molalities < 1.e-8
c       -2 =  Omit species with molalities < 1.e-12
c       -1 =  Omit species with molalities < 1.e-20
c        0 =  Omit species with molalities < 1.e-100
c        1 =  Include all species
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of species activity coefficients
c       act    = array of species activities
c       actlg  = array of species log activities
c       conc   = array of species concentrations
c       conclg = array of species log concentrations
c       iopr   = array of print control options
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c       uspec  = array of names of species
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noprmx,nstmax
c
      integer noutpt
c
      integer iopr(noprmx),jcsort(nstmax)
      integer narn1,narn2
c
      character*48 uspec(nstmax)
c
      real*8 acflg(nstmax),actlg(nstmax),conc(nstmax),conclg(nstmax)
c
      real*8 texp
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ipr,n,ns,nss
c
      real*8 ltrunc(-3:0)
      real*8 mx
c
c-----------------------------------------------------------------------
c
      data (ltrunc(n), n = -3,0)/-8.,-12.,-20.,-100./
c
c-----------------------------------------------------------------------
c
      ipr = iopr(4)
c
      write (noutpt,1000)
 1000 format(//16x,'--- Distribution of Aqueous Solute Species ---',/)
c
      write (noutpt,1010)
 1010 format(4x,'Species',18x,'Molality',4x,'Log Molality',
     $ 3x,'Log Gamma',2x,'Log Activity',/)
c
      if (iopr(4) .ge. 1) then
        do nss = narn1 + 1,narn2
          n = narn2 - nss + narn1
          ns = jcsort(n)
          write (noutpt,1020) uspec(ns),conc(ns),conclg(ns),
     $    acflg(ns),actlg(ns)
 1020     format(1x,a24,2x,1pe11.4,2x,0pf11.4,2x,f11.4,2x,f11.4)
        enddo
      else
        do nss = narn1 + 1,narn2
          n = narn2 - nss + narn1
          ns = jcsort(n)
          if (conclg(ns) .lt. ltrunc(ipr)) go to 110
          write (noutpt,1020) uspec(ns),conc(ns),conclg(ns),
     $    acflg(ns),actlg(ns)
        enddo
        go to 999
  110   mx = texp(ltrunc(ipr))
        write (noutpt,1030) mx
 1030   format(/4x,'Species with molalities less than ',1pe10.3,' are',
     $  ' not listed.')
      endif
      write (noutpt,1040)
 1040 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine eqshel(aadh,aadhh,aadhv,aamatr,aaphi,abar,abdh,
     $ abdhh,abdhv,abdot,abdoth,abdotv,acflg,acflgo,act,actlg,
     $ adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,adh,adhh,adhv,
     $ afcnst,affp,affs,alpha,al10,amtb,aphi,apx,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,betao,bgamx,bneg,bpx,cbsr,cco2,cdac,cegexs,
     $ cesr,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,conc,
     $ conclg,cpgexs,cscale,csigma,csts,dadhh,dadhv,dbdhh,dbdhv,
     $ dbdth,dbdtv,deltim,delvco,delvec,delxi,dlogxw,dlxmin,
     $ drer0,drir0,dzvc0,d1zvc1,eact,egers,egexjc,egexjf,egexs,
     $ eh,ehfac,elecsr,eps100,farad,fje,fjeo,fkrc,fo2,fo2lg,
     $ fsort,fugac,fugalg,fxi,fxio,gmmatr,hact,iact,iapxt,ibpxt,
     $ ibswx,ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $ ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx0,iindx1,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,
     $ ilzeta,imech,imrn1,imrn2,insgf,iodb,iopg,iopt,ipch,
     $ ipivot,ipndx1,ipcv,istack,iter,itermx,ixbasp,ixrn1,ixrn2,
     $ izmax,jcode,jcsort,jflag,jgsort,jgstak,jjsort,jpflag,
     $ jpress,jptffl,jreac,jsflag,jsitex,jsol,jssort,jstack,
     $ jtemp,kbt,kction,kdim,kelect,khydr,khydx,km10,km1,kmt,
     $ kmt0,ko2gaq,kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt,kxt0,
     $ loph,losp,lsort,modr,modr0,moph,morr,morr0,mosp,mrgers,
     $ mrgexs,mtb,mtbaq,mtb0,mte,mteaq,mwtrc,narn1,narn2,narxt,
     $ nat,nbasp,nbaspd,nbaspx,nbt,nbtd,nbw,nchlor,ncmpr,ncorr,
     $ nct,ndac,ndact,ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,ndrsrx,nelect,
     $ nern1,nern2,ness,nessr,net,nfrn1,nfrn2,ngrn1,ngrn2,ngt,
     $ nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmt,nord,noutpt,
     $ no2gaq,npchk,nphasx,npslmx,npt,nrct,nrdxsp,nrk,nrndex,nsk,
     $ nsslmx,nst,nsts,nstsr,ntpr,ntrymx,ntprt,nttyo,nxridx,nxrn1,
     $ nxrn2,nxt,nweope,nwndpc,omega,omeglg,prcinf,press,pressb,
     $ pressd,ptk,qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,
     $ qoptmz,qpit75,qredox,qriinf,qscon,qshoot,qstart,qtrch,qtvchk,
     $ qxknph,q6mode,rcnstv,rconst,rkb,rhsvec,rirec0,rk,rreacn,
     $ rreac1,rrelr0,rrelr1,rtcnst,rxbar,screwd,sidrph,sidrsp,
     $ sigmam,sigmmo,smp100,tdays,tempc,tempcb,tempcd,tempcu,
     $ tempc0,tempk,timemx,time0,time1,tiplol,tiplot,tiprnl,tiprnt,
     $ tistsv,tolbt,toldl,tolsat,tolsst,tolxst,trkb,ttk,ubacmx,
     $ ubgamx,udac,ufixf,ugermo,ulbeta,uldel,uphase,ureac,uspec,
     $ uzvec0,uzvec1,vreac,weight,wfac,wodr,worr,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xgers,xirct,xirct0,xistsv,xi0,
     $ xi1,zchar,zchcu6,zchsq2,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine provides a shell around EQ6/eqcalc.f that allows
c     fine adjustments to the value of reaction progress in order to
c     step over fine singularities, such as may exist in the middle of
c     a major jump in the oxygen fugacity.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
c       qbye comes in .true. if EQ6/path.f just changed the phase
c         assemblage by deleting one or more minerals. This
c         instructs this subroutine to print the index (iindx1)
c         structure of the system of equations as it does on the
c         starting call and whenever this subroutine itself adds or
c         deletes a phase.
c
c       iter is the number of Newton-Raphson iterations that
c         EQLIB/newton.f performed.
c
c       ier is an error parameter which is returned as 0 if the
c         calculations in this subroutine converged successfully and
c         there were no violations of possible open system constraints.
c
c       ier    = error flag:
c
c                  Values returned from EQ6/eqphas.f:
c                    =    0  Okay
c                    =   10  Go back and take a smaller step size to
c                              avoid exceeding the supersaturation
c                              tolerance (tolsst). This is done only
c                              when an appropriate set of conditions
c                              is satisified. It isn't necessary for
c                              EQ6/path.f to analyze the situation
c                              when this value is returned to it by
c                              EQ6/eqshel.f.
c                    =   20  Hit the maximum number of tries to find
c                              the correct phase assemblage
c                    =   30  Caught in a region of computational
c                              instability about the phase boundary for
c                              an appearing phase. Iteration fails when
c                              the phase is added to the phase
c                              assemblage.
c                    =   40  Caught in a region of computational
c                              instability about the phase boundary for
c                              a disappearing phase. The system is
c                              too supersaturated with respect to a
c                              phase if that phase is deleted from the
c                              phase assemblage.
c                    =   50  Caught in a region of computational
c                              instability associated with solvent
c                              water. The amount of water in the
c                              system is probably very low.
c                    =   60  Caught in a region of computational
c                              instability associated with the
c                              master redox variable. This is probably
c                              associated with a redox jump.
c                    =   90  Caught in a region of computational
c                              instability associated with the
c                              aqueous activity coefficient model.
c                    =  100  Detected out-of-range values for variables
c                              associated with the basis species before
c                              starting iteration.
c                    =  110  Detected out-of-range values for variables
c                              associated with the basis species after
c                              an iteration crash.
c                    =  150  Calculation failed, no diagnostics were
c                              generated.
c
c                  Values returned by the present subroutine:
c                    =    0  Okay
c                    =   10  Go back and take a smaller step size to
c                              avoid exceeding the supersaturation
c                              tolerance (tolsst)
c                    =  170  Too much of a phase was destroyed under
c                              the flow-through open system model;
c                              go back and first move part of the
c                              mass of protected phases in the ES to
c                              the PRS
c                    =  180  One of a number of problems occurred which
c                              may be resolvable, at least partially,
c                              by going back and cutting the step size
c                    =  190  Need to slide over a region of
c                              computational instability, but sliding
c                              is inhibited; go back, but terminate
c                              work on the current problem
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
      include 'eqlib/eql1s.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),imech(2,nrctmx),ixbasp(nbtmax),
     $ ndac(ndctmx,imchmx,2,nrctmx),ndact(imchmx,2,nrctmx),
     $ nrk(2,nrctmx),nsk(nrctmx)
c
      integer jcode(nrctmx),jreac(nrctmx),nrndex(nrctmx),nxridx(nrctmx)
c
      integer iapxt(nxtmax),ibpxt(nxtmax),ibswx(nbtmax),igstak(ngtmax),
     $ iindx0(kmax),iindx1(kmax),ipivot(kmax),ipndx1(kmax),
     $ insgf(natmax),iodb(nodbmx),iopg(nopgmx),iopt(noptmx),
     $ istack(nstmax),jcsort(nstmax),jflag(nstmax),jgsort(ngtmax),
     $ jgstak(ngtmax),jjsort(nstmax),jpflag(nptmax),jsflag(nstmax),
     $ jsitex(nstmax),jsol(nxtmax),jssort(nstmax),jstack(nstmax),
     $ kction(nbtmax)
c
      integer narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),
     $ ncmpr(2,nptmax),ness(nessmx),nessr(2,nstmax),ndrs(ndrsmx),
     $ ndrsd(ndrsmx),ndrsx(ndrsmx),ndrsr(2,nstmax),ndrsrd(2,nstmax),
     $ ndrsrx(2,nstmax),npchk(nptmax),nphasx(nstmax),nsts(nstsmx),
     $ nstsr(2,nstmax)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer ielam,ier,igas,ipch,ipcv,iter,itermx,izmax,jpress,jptffl,
     $ jtemp,kbt,kdim,kelect,khydr,khydx,km1,km10,kmt,kmt0,ko2gaq,
     $ kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt,kxt0,nbtd,nbw,nchlor,
     $ ncorr,nelect,nhydr,nhydx,nord,no2gaq,npslmx,nrct,nrdxsp,nsslmx,
     $ ntpr,ntprt,ntrymx,nweope,nwndpc
c
      logical qxknph(nptmax)
c
      logical qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,qoptmz,
     $ qpit75,qredox,qriinf,qshoot,qscon,qstart,qtrch,qtvchk,q6mode
c
      character*48 uspec(nstmax),uzvec0(kmax),uzvec1(kmax)
      character*48 ubacmx,ubgamx
      character*24 ugermo(nertmx),ureac(nrctmx)
      character*24 udac(ndctmx,imchmx,2,nrctmx)
      character*24 uphase(nptmax)
      character*8 ulbeta(kmax),uldel(kmax)
      character*8 ufixf
c
      real*8 aadh(narxmx,ntprmx),aadhh(narxmx,ntprmx),
     $ aadhv(narxmx,ntprmx),aaphi(narxmx,ntprmx),
     $ abdh(narxmx,ntprmx),abdhh(narxmx,ntprmx),
     $ abdhv(narxmx,ntprmx),abdot(narxmx,ntprmx),
     $ abdoth(narxmx,ntprmx),abdotv(narxmx,ntprmx)
c
      real*8 dadhh(ipchmx),dadhv(ipcvmx),dbdhh(ipchmx),dbdhv(ipcvmx),
     $ dbdth(ipchmx),dbdtv(ipcvmx)
c
      real*8 adadhh(narxmx,ntprmx,ipchmx),
     $ adadhv(narxmx,ntprmx,ipcvmx),adbdhh(narxmx,ntprmx,ipchmx),
     $ adbdhv(narxmx,ntprmx,ipcvmx),adbdth(narxmx,ntprmx,ipchmx),
     $ adbdtv(narxmx,ntprmx,ipcvmx)
c
       real*8 cdac(ndctmx,imchmx,2,nrctmx),csigma(imchmx,2,nrctmx),
     $ eact(imchmx,2,nrctmx),fkrc(nrctmx),hact(imchmx,2,nrctmx),
     $ rkb(imchmx,2,nrctmx),trkb(imchmx,2,nrctmx)
c
      real*8 cbsr(nbt1mx,nsrtmx),cesr(nctmax,nsrtmx),
     $ egers(ietmax,jetmax,nertmx),elecsr(nsrtmx),modr(nrctmx),
     $ mrgers(ietmax,jetmax,nertmx),morr(nrctmx),mwtrc(nrctmx),
     $ rreacn(nrctmx),rreac1(nrctmx),rrelr1(nrctmx),
     $ rxbar(iktmax,nxrtmx),vreac(nrctmx),wodr(nrctmx),
     $ worr(nrctmx),xgers(ietmax,jetmax,nertmx)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),
     $ act(nstmax),actlg(nstmax),affp(nptmax),affs(nstmax),
     $ alpha(kmax),amtb(nbtmax),apx(iapxmx,nxtmax),azero(natmax),
     $ a3bars(natmax),beta(kmax),betao(kmax),bpx(ibpxmx,nxtmax),
     $ cco2(5),cegexs(ietmax,jetmax,netmax),cess(nessmx),
     $ cdrs(ndrsmx),cdrsd(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),
     $ cdrw(nstmax),cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),
     $ conclg(nstmax),cpgexs(ietmax,jetmax,netmax),cscale(nstmax),
     $ csts(nstsmx),drer0(nrd1mx,nrctmx),delvco(kmax),delvec(kmax),
     $ dlogxw(nbtmax),drir0(nrd1mx),dzvc0(nrd1mx,kmax),d1zvc1(kmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax)
c
      real*8 fsort(ngtmax),fugac(ngtmax),fugalg(ngtmax),
     $ gmmatr(kmax,kmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ modr0(nrctmx),moph(nptmax),morr0(nrctmx),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),mtbaq(nbtmax),
     $ mtb0(nbtmax),mte(nctmax),mteaq(nctmax),ptk(nttkmx),
     $ rhsvec(kmax),rk(imchmx,2,nrctmx),rrelr0(nrctmx),sidrph(nptmax),
     $ sidrsp(nstmax),tempcu(ntprmx),ttk(nttkmx),weight(nstmax),
     $ wfac(iktmax,nxtmax),xbar(nstmax),xbarlg(nstmax),xirct(nrctmx),
     $ xirct0(nrctmx),zchar(nstmax),zchcu6(nstmax),zchsq2(nstmax),
     $ zvclg0(kmax),zvclg1(kmax),zvec0(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,afcnst,al10,avcnst,a3bar,bacfmx,bbig,betamx,bgamx,
     $ bneg,deltim,delxi,dlxmin,eh,ehfac,eps100,farad,fje,fjeo,fo2,
     $ fo2lg,fxi,fxio,omega,omeglg,prcinf,press,pressb,pressd,rcnstv,
     $ rconst,rirec0,rtcnst,screwd,sigmam,sigmmo,smp100,tdays,tempc,
     $ tempcb,tempcd,tempk,tempc0,timemx,time0,time1,tiplol,tiplot,
     $ tiprnl,tiprnt,tistsv,tolbt,toldl,tolsat,tolsst,tolxst,xbarw,
     $ xbarwc,xbrwlc,xbrwlg,xistsv,xi0,xi1,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c
c     Variables for restoring the entering configuration, including
c     the entering phase assemblage.
c
      integer isv_kmax,isv_nbtmax,isv_nstmax
c
      SAVE isv_kmax,isv_nbtmax,isv_nstmax
c
      integer, dimension(:), allocatable :: iindxs,ipndxs,nbasps
c
      SAVE iindxs,ipndxs,nbasps
c
      real(8), dimension(:), allocatable :: acflgs,zvclgs
c
      SAVE acflgs,zvclgs
c
c     The following do not need to be SAVEd.
c
      integer kdims,km1s,kmts,kx1s,kxts
c
      real(8) xbarws,xbrwls
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,j2,k,kcol,krow,n,nb,nords,np,nphasl,nplast,np1,
     $ nrdxsl,ns,ns2,ntpr0
c
      integer ilnobl
c
      logical qbswok,qslmod,qsspgb,qztayl
c
      character*56 uspn56
c
      real*8 dlmoph,dltimd,lold,lxx,mold,mxx0
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(iindxs)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
        isv_nbtmax = 0
        isv_nstmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(iindxs,ipndxs)
          DEALLOCATE(zvclgs)
          isv_kmax = 0
        endif
c
        if (nbtmax .ne. isv_nbtmax) then
          DEALLOCATE(nbasps)
          isv_nbtmax = 0
        endif
c
        if (nstmax .ne. isv_nstmax) then
          DEALLOCATE(acflgs)
          isv_nstmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(iindxs(kmax),ipndxs(kmax))
        ALLOCATE(zvclgs(kmax))
        isv_kmax = kmax
      endif
c
      if (isv_nbtmax .eq. 0) then
        ALLOCATE(nbasps(nbtmax))
        isv_nbtmax = nbtmax
      endif
c
      if (isv_nstmax .eq. 0) then
        ALLOCATE(acflgs(nstmax))
        isv_nstmax = nstmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        iindxs(k) = 0
        ipndxs(k) = 0
      enddo
c
      do k = 1,kmax
        zvclgs(k) = -99999.
      enddo
c
      do n = 1,nbtmax
        nbasps(n) = 0
      enddo
c
      do n = 1,nstmax
        acflgs(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize some parameters.
c
      qslmod = .false.
      qmod = .false.
      qbseqc = .false.
c
      ier = 0
      nrdxsl = 0
      nphasl = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the "kernel" description for the current equilibrium system.
c     This will be used to recover if the equilibrium calculation
c     overseen by EQ6/eqphas.f fails for any reason. This kernel
c     contains the minimum of information required to calculate the
c     fully expanded description using EQLIB/ncmpex.f. Note that
c     EQ6/eqphas.f (which the present subroutine calls) and EQ6/path.f
c     (which calls the present subroutine) have their own distinct
c     backup kernels.
c
      km1s = km1
      kmts = kmt
      kx1s = kx1
      kxts = kxt
      kdims = kdim
c
      call copyia(nbasp,nbasps,nbt)
      call copyia(iindx1,iindxs,kdim)
      call copyia(ipndx1,ipndxs,kdim)
c
      call copyaa(zvclg1,zvclgs,kdim)
      call copyaa(acflg,acflgs,nst)
c
      xbarws = xbarwc
      xbrwls = xbrwlc
c
c     Save the order of the finite differences.
c
      nords = nord
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  100 continue
c
c     This is a return point if the step size is changed within
c     the present subroutine. There are two cases:
c
c        1. Advance the step size through a region of critical
c           redox instability (redox jump) from the last nonsingular
c           point of reaction progress. Move the simulation over
c           the region of singularity by using only predictor functions
c           expanded from that last good point.
c
c        2. Advance the step size across a region of singularity
c           that is associated with the presence or absence of a phase.
c           There are two cases. first, the calculations may fail to
c           converge upon adding a newly supersaturated phase because
c           the number of moles of the phase that would be produced is
c           so small that the Jacobian matrix becomes effectively
c           singular. Second, when a phase is disappearing, its number
c           of moles may become so small that the above singlularity
c           occurs. This is a normal mode for dropping a phase.
c           Sometimes, the affinity of the phase exceeds the
c           supersaturation tolerance when the system is solved for
c           the case of the phase not present. In each case, the step
c           size must be advanced across the region of apparent
c           singularity.
c
      if (ncorr .le. 0) then
        write (noutpt,1000) xi1,delxi,nord
 1000   format(/' Stepping to Xi= ',1pe11.4,', delxi= ',1pe11.4,
     $  ', nord= ',i1)
      endif
c
      if (iopt(2) .gt. 0) then
        if (xi1 .gt. xistsv) then
          if (.not.qshoot) then
            call timeca(deltim,delxi,drir0,iodb,nodbmx,nord,noutpt,
     $      nrd1mx,nttyo,prcinf,qriinf,rirec0,time0,time1)
c
            if (delxi .le. dlxmin) then
c
c             Make sure that the calculated time does not exceed any
c             any specified limits such as the maximum time just because
c             delxi is at the minimum value.
c
              call tivchk(deltim,delxi,qtvchk,time1,time0,timemx,
     $        tiplol,tiplot,tiprnl,tiprnt,tolxst)
            endif
          endif
        else
          time1 = tistsv
          deltim = 0.
        endif
c
        tdays = time1/86400.
        dltimd = deltim/86400.
c
        write (noutpt,1010) ncorr,tdays,dltimd
 1010   format(3x,'ncorr= ',i2,', time= ',1pe11.4,' d, deltim= ',
     $  e11.4,' d')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nord .gt. 0) then
c
c       Make a Taylor's series expansion of the dz/d(xi) vector.
c       This information is used to track how the reacting system
c       is changing.
c
        call d1ztay(delxi,dzvc0,d1zvc1,kdim,kmax,nord,nrd1mx)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .ge. 1) then
c
c       Increment the irreversible reactions (those associated with
c       the "reactants"); update the ES mass balance totals accordingly.
c
        call reacts(cbsr,csts,delxi,drer0,iern1,ietmax,iktmax,
     $  iodb,jcode,jetmax,jgext,jreac,modr,modr0,morr,morr0,mrgers,
     $  mtb,mtb0,nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nern1,nern2,nertmx,
     $  netmax,ngext,nodbmx,nord,noutpt,nptmax,nrct,nrctmx,nrd1mx,
     $  nrndex,nsrtmx,nstmax,nsts,nstsmx,nstsr,nttyo,nxridx,nxrtmx,
     $  rrelr0,rxbar,ureac,xirct,xirct0)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set a flag for a go back followed by a step size reduction when
c     the equilibrium calculation indicates a supersaturation that
c     exceeds the tolerance value used in locating the phase boundary
c     for a newly appearing phase.
c
      qsspgb = iopt(3).le.1 .and. .not.qslmod .and.(.not.qscon)
     $ .and. delxi.gt.dlxmin .and. .not.qstart
c
c     Make the equilibrium calculation. Basis switching may occur.
c     Also, the phase assemblage may be changed.
c
      call eqphas(aamatr,abar,acflg,acflgo,act,actlg,
     $ adh,adhh,adhv,afcnst,affp,affs,alpha,al10,amtb,aphi,
     $ apx,avcnst,azero,a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,beta,betamx,betao,bgamx,bneg,bpx,cco2,
     $ cegexs,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,
     $ conc,conclg,cpgexs,cscale,csts,delvco,delvec,d1zvc1,dlogxw,
     $ egexjc,egexjf,egexs,eh,ehfac,eps100,farad,fje,fjeo,fo2,
     $ fo2lg,fsort,fugac,fugalg,fxi,fxio,gmmatr,iapxt,ibpxt,ibswx,
     $ ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,
     $ ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx0,iindx1,ilcphi1,
     $ ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,
     $ imrn2,insgf,iodb,iopg,iopt,ipch,ipivot,ipndx1,ipcv,istack,
     $ iter,itermx,ixbasp,ixrn1,ixrn2,izmax,jcsort,jflag,jgsort,
     $ jgstak,jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,khydx,km1,km10,kmt,kmt0,ko2gaq,
     $ kpsat,kpsst,krdxsp,kwater,kx1,kx10,kxt0,kxt,loph,losp,lsort,
     $ moph,mosp,mrgexs,mtb,mtbaq,narn1,narn2,narxt,nat,nbasp,nbaspd,
     $ nbaspx,nbt,nbtd,nbw,nchlor,ncmpr,nct,ndrs,ndrsd,ndrsx,ndrsr,
     $ ndrsrd,ndrsrx,nelect,nern1,nern2,ness,nessr,net,nfrn1,nfrn2,
     $ ngrn1,ngrn2,ngt,nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,
     $ nmt,nord,no2gaq,noutpt,npchk,nphasx,npt,nrdxsp,nst,nsts,
     $ nstsr,ntpr,ntrymx,nttyo,nxrn1,nxrn2,nxt,omega,omeglg,prcinf,
     $ press,qbassw,qbseqc,qbye,qcnpre,qcntmp,qhawep,qmod,qoptmz,
     $ qpit75,qredox,qsspgb,qstart,qxknph,q6mode,rcnstv,rconst,
     $ rhsvec,rtcnst,screwd,sidrph,sidrsp,sigmam,sigmmo,smp100,tempc,
     $ tempk,tolbt,toldl,tolsat,tolsst,ubacmx,ubgamx,ulbeta,uldel,
     $ uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 8) then
c
c       Go back and reduce the step size to avoid exceeding the
c       dimensioned limit on the iindx1 array (this also corresponds to
c       the dimensions of the Jacobian matrix). EQ6/path.f will go back
c       and cut the step size, if this is possible.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 10) then
c
c       Go back and reduce the step size to avoid exceeding the
c       supersaturation tolerance (tolsst). This is only done under
c       an appropriate set of conditions, so no further analysis
c       is required. EQ6/path.f will go back and cut the step size.
c
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 20) then
c
c       EQ6/eqphas.f hit the maximum number of tries to find the correct
c       phase without succeeding. Go back and let EQ6/path.f deal with
c       the situation. It may be able to resolve the problem by reducing
c       the step size.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier.eq.30 .or. ier.eq.40) then
c
c       The calculation appears to be in a region of critical
c       instability in the ES phase assemblage (can't solve to within
c       specified tolerances with a certain phase or phases in or out
c       of the assemblage). Try to slide over it.
c
        if (nphasl .le. 0) then
c
c         Am not currently engaged in such a slide. Need to start
c         the process.
c
          if (npslmx .le. 0) then
c
c           This kind of sliding is inhibited.
c
            write (noutpt,1100)
            write (nttyo,1100)
 1100       format(/' * Warning - (EQ6/eqshel) Need to slide Xi',
     $      ' forward to get over a region of',/7x,'critical',
     $      ' instability in the ES phase assemblage. However, the',
     $      ' maximum',/7x,'number of steps for this process (npslmx)',
     $      ' is zero. Sliding of this kind',/7x,'is therefore',
     $      ' inhibited.')
            ier = 190
            go to 999
          else
c
c           Set up to start sliding.
c
            write (noutpt,1110)
 1110       format(/' Setting up to slide Xi forward to get over a',
     $      ' region of critical'/3x,'instability in the ES phase',
     $      ' assemblage.')
            qslmod = .true.
          endif
        endif
c
        if (nphasl .ge. npslmx) then
c
c         Check for the maximum number of tries sliding forward.
c
          write (noutpt,1120)
          write (nttyo,1120)
 1120     format(/' * Warning - (EQ6/eqshel) Have done the maximum',
     $    ' number of tries to',/7x,'slide over a region of critical',
     $    ' instability in the ES phase assemblage.')
          ier = 190
          go to 999
        endif
c
c       Slide Xi forward one increment. The increment gets progressively
c       larger with the number of tries.
c
        nphasl = nphasl + 1
        delxi = delxi + 3.**(nphasl - 1)*dlxmin
        write (noutpt,1130)
 1130   format(/' Trying to slide over a region of critical',
     $  ' instability',/7x,'in the ES phase assemblage:')
        write (noutpt,1140) nphasl,delxi
 1140   format(/3x,'Try ',i2,': delxi= ',1pe12.5,/)
        go to 300
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 50) then
c
c       The calculation appears to be in a region of critical redox
c       instability. Try to slide over it.
c
        if (nrdxsl .le. 0) then
c
c         Am not currently engaged in such a slide. Need to start
c         the process.
c
          if (nsslmx .le. 0) then
c
c           This kind of sliding is inhibited.
c
            write (noutpt,1200)
            write (nttyo,1200)
 1200       format(/' * Warning - (EQ6/eqshel) Need to slide Xi',
     $      ' forward to get over a region of',/7x,'critical redox',
     $      ' instability. However, the maximum number of steps',
     $      /7x,'for this process (nsslmx) is zero. Sliding of this',
     $      ' kind is',/7x,'therefore inhibited.')
            ier = 190
            go to 999
          else
c
c           Set up to start sliding.
c
            write (noutpt,1210)
 1210       format(/' Setting up to slide Xi forward to get over a',
     $      ' region of critical'/3x,'redox instability.')
            qslmod = .true.
          endif
        endif
c
        if (nrdxsl .ge. nsslmx) then
c
c         Check for the maximum number of tries sliding forward.
c
          write (noutpt,1220)
          write (nttyo,1220)
 1220     format(/' * Warning - (EQ6/eqshel) Have done the maximum',
     $    ' number of tries',/7x,'to slide over a region of critical',
     $    ' redox instability.')
          ier = 190
          go to 999
        endif
c
c       Slide Xi forward one increment. The increment gets progressively
c       larger with the number of tries.
c
        nrdxsl = nrdxsl + 1
        delxi = delxi + 3.**(nrdxsl - 1)*dlxmin
        write (noutpt,1230)
 1230   format(/' Trying to slide over a region of critical redox',
     $  ' instability:')
        write (noutpt,1240) nrdxsl,delxi
 1240   format(/3x,'Try ',i2,': delxi= ',1pe12.5,/)
        go to 300
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier.eq.60 .or. ier.eq.70) then
c
c       The calculation appears to be in a region of critical
c       instability associated with solvent water. Go back and let
c       EQ6/path.f deal with the situation. It may be able to resolve
c       the problem by reducing the step size.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 80) then
c
c       EQ6/eqphas.f detected critical instability associated with the
c       aqueous activity coefficient model. Go back and let EQ6/path.f
c       deal with the situation. It may be able to at least partially
c       resolve the problem by reducing the step size. However, it is
c       likely that the reaction path is causing the activity
c       coefficient model to be extrapolated outside its range of
c       validity.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 100) then
c
c       The calculation was about to start with out-of-range values
c       for the iteration variables associated with the aqueous basis
c       species. Go back and let EQ6/path.f deal with the situation.
c       It may be able to resolve the problem by reducing the step size.
c       Alternatively, there may be some kind of programming error.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 110) then
c
c       The iteration ended with out-of-range values for the iteration
c       variables associated with the aqueous basis species. Go back and
c       let EQ6/path.f deal with the situation. It may be able to
c       resolve the problem by reducing the step size. Alternatively,
c       there may be some kind of programming error.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 150) then
c
c       The iteration ended without any useful diagnostics being
c       produced. Go back and let EQ6/path.f deal with the situation.
c       It may be able to resolve the problem by reducing the step size.
c       Alternatively, there may be some kind of programming error.
c
        ier = 180
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .eq. 0) then
        if (iopt(1) .eq. 2) then
c
c         Check to see that no significant numbers of moles of solids
c         were destroyed unexpectedly if computing a fluid-centered
c         flow-through open system model.
c
          do kcol = km1s,kmts
            if ( uzvec0(kcol)(1:5) .ne. ufixf(1:5) ) then
              if (zvclg0(kcol) .le. zklogu) then
                ns = iindxs(kcol)
                lxx = losp(ns)
                dlmoph = zvec0(kcol) - texp(lxx)
                if (dlmoph .gt. 0.) then
                  if (tlg(dlmoph) .gt. zklogu) then
                    ier = 170
                    mxx0 = zvec0(kcol)
c
c                   Calling sequence substitutions:
c                     uspec(ns) for unam48
c
                    call fmspnm(jlen,uspec(ns),uspn56)
                    write (noutpt,1300) uspn56(1:jlen),mxx0,mosp(ns),
     $              dlmoph
 1300               format(' Some of ',a,' was unexpectedly destroyed.',
     $              /5x,'Previous number of moles was ',1pe12.5,
     $              /5x,'Current number of moles is   ',e12.5,
     $              /5x,'Amount destroyed was ',e12.5,/21x,
     $              /3x,"That's too much. Will go back and first",
     $              ' transfer some of the current',/3x,'amount to the',
     $              ' physically removed system (PRS).')
                  endif
                endif
              endif
            endif
          enddo
c
          nplast = 0
c
          do kcol = kx1s,kxts
            ns = iindxs(kcol)
            np = ipndxs(kcol)
            if (np .ne. nplast) then
              nplast = np
              mold = 0.
c
              do krow = kcol,kxts
                np1 = ipndxs(krow)
                if (np1 .ne. np) go to 200
                mxx0 = zvec0(krow)
                mold = mold + mxx0
              enddo
  200         continue
c
              lold = tlg(mold)
              if (lold .gt. zklogu) then
                dlmoph = mold - moph(np)
                if (dlmoph .gt. 0.) then
                  if (tlg(dlmoph) .gt. zklogu) then
                    ier = 170
                    j2 = ilnobl(uphase(np))
                    write (noutpt,1300) uphase(np)(1:j2),mold,moph(np),
     $              dlmoph
                  endif
                endif
              endif
            endif
          enddo
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The calculation finished with no problems.
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  300 continue
c
c     Restore the kernel for the equilibrium sytem from the backup.
c     Undo any basis switches that may have been made by EQ6/optmzr.f.
c
c     Note: some aspects of the backup kernel are not needed here.
c     For example, the zvclg1 array will be recomputed further below
c     by the call to EQ6/ztaylr.f, overwriting the values restored from
c     the zvclgs array. However, a full restoration is done here for the
c     sake of completeness.
c
      if (qbseqc) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          ns2 = nbasps(nb)
          if (ns2 .ne. ns) then
            call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $      nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $      ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
          endif
        enddo
        qbseqc = .false.
        nord = nords
      endif
c
      km1 = km1s
      kmt = kmts
      kx1 = kx1s
      kxt = kxts
      kdim = kdims
c
      call copyia(nbasps,nbasp,nbt)
      call copyia(iindxs,iindx1,kdim)
      call copyia(ipndxs,ipndx1,kdim)
c
      call copyaa(zvclgs,zvclg1,kdim)
      call copyaa(acflgs,acflg,nst)
c
      xbarwc = xbarws
      xbrwlc = xbrwls
c
c     Reset the ixbasp and cjbasp arrays. The former is a flag
c     array, each member of which denotes whether the
c     thermodynamic activity of the corresponding basis species
c     is defined in terms of molality (= 0) or mole fraction (= 1).
c     The cjbasp array contains any site stoichiometric factors
c     associated with the operational basis species.
c
      call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $ jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $ netmax,nphasx,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Slightly increase the value of reaction progress to try to slide
c     over a region of critical instability.
c
      xi1 = xi0 + delxi
c
c     Make a Taylor's series expansion of the z vector, applying
c     change limits. This provides a protected set of values for
c     the AE solver; i.e., a set not containing any values that
c     will cause the solver to fail in an unrecoverable fashion.
c
      qztayl = .true.
      call ztaylr(delxi,dzvc0,kdim,kmax,km1,kxt,nord,nrd1mx,
     $ qztayl,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     Save the new z vector expansion.
c
      call copyaa(zvclg1,zvclgs,kdim)
c
      if (.not.qcntmp .or. .not.qcnpre) then
c
c       Recompute the temperature and pressure. Then recompute the
c       thermodynamic and kinetic quantities which depend these
c       variables.
c
        ntpr0 = ntpr
        call tpadv(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $  abdoth,abdot,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $  adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $  al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,axhfs,
     $  axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,bdhv,
     $  bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dhfs,
     $  dhfsd,dvfe,dvfs,dvfsd,eact,ehfac,farad,hact,iact,iapxmx,iktmax,
     $  imchmx,imech,iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,
     $  ixrn2,jpfcmx,jpress,jptffl,jsol,jtemp,narxmx,narxt,narxth,nbasp,
     $  nbaspd,nbt,nbtd,nbtmax,ncmpr,ndrsr,ndrsrd,nmut,nmutmx,nopgmx,
     $  noptmx,noutpt,nptkmx,nptmax,nrct,nrctmx,nrk,nslt,nsltmx,nst,
     $  nstmax,ntpr,ntprmx,ntprt,nttkmx,nttyo,nweope,nwndpc,nxt,nxtmax,
     $  pmu,presg,presh,press,pressb,pressd,pslamn,ptk,rcnstv,rconst,rk,
     $  rkb,rtcnst,tempc,tempcb,tempcd,tempcu,tempk,time1,trkb,ttk,
     $  uphase,uspec,wfac,xhfe,xhfs,xhfsd,xi1,xlke,xlks,xlksd,xvfe,
     $  xvfs,xvfsd)
c
        qtrch = ntpr .ne. ntpr0
      endif
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine wr3d8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $ ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $ jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $ netmax,newin,ngexti,ngexrt,nobswt,nodbmx,nopgmx,noprmx,noptmx,
     $ nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,nxmod,nxti,nxtimx,pei,
     $ press,qgexsh,rho,scamas,tdspkg,tdspl,tempc,tgexp,tolbt,toldl,
     $ tolspf,ucospi,uebal,ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,
     $ ugexsi,umemi,uobsw,uredox,usbsw,usoli,uspeci,utitl,uhfgex,
     $ uvfgex,uxkgex,uxmod,xbari,xgexsi,xhfgex,xlkgex,xvfgex,
     $ xlkmod,zgexj)
c
c     This subroutine writes the EQ3NR input file in menu-style ("D")
c     format for version 8.0.
c
c     The calling sequence of this subroutine is identical to that of
c     XCON3/wr3w8.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/rd3inw.f, EQ3NR/rd3ind.f, XCON3/rd3w8.f, and XCON3/rd3d8.f,
c     except that newin is added and ninpts, nprob, noutpt, qend, and
c     qrderr are deleted.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,noptmx,
     $ ntitmx,nxmdmx,nxicmx,nxtimx
c
      integer newin,nttyo
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jgext(netmax),jgexti(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ncmpri(2,nxtimx),ngexrt(jetmax,netmax),ngexti(jetmax,netmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,jpres3,nbti,net,neti,nobswt,
     $ nsbswt,ntitl,nxmod,nxti
c
      logical qgexsh
c
      character*80 utitl(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ucospi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uspeci(nbtmax),uxmod(nxmdmx)
      character*24 ugexmo(netmax),ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),umemi(nxicmx),usoli(nxtimx)
      character*24 uebal,uredox
      character*8 ugexj(jetmax,netmax),ugexji(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real*8 cgexj(jetmax,netmax),cgexpi(netmax),covali(nbtmax),
     $ egexsi(ietmax,jetmax,netmax),mwtges(netmax),tgexp(netmax),
     $ xbari(nxicmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xvfgex(ietmax,jetmax,netmax),
     $ xlkmod(nxmdmx),zgexj(jetmax,netmax),xgexsi(ietmax,jetmax,netmax)
c
      real*8 ehi,fo2lgi,pei,press,rho,scamas,tdspkg,tdspl,tempc,tolbt,
     $ toldl,tolspf
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlj8.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,ij,j,je,jei,jfl,jj,j2,j3,j4,j5,j6,k,kxmd,n,nb,ne,
     $ nei,nr1,nr2,nxi,nxic
c
      integer ilnobl
c
      logical qgexbf,qgexef,qstop
c
      character*80 ux80
      character*48 ux48,ux48a,ux48b
      character*24 ux24
      character*16 ux16
      character*8 uxn,uxo,ux8
      character*1 ux1(5)
      character*1 uxs
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
c     Check some dimensioning parameters.
c
      qstop = .false.
c
      if (ndbxpa .ne. nodbmx) then
        write (nttyo,3000) ndbxpa,nodbmx
 3000   format(/' * Error - (XCON3/wr3d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iodb debugging print option switches',
     $  ' with string definitions',/7x,'(ndbxpa) has a value of ',i3,
     $  ', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (nodbpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (npgxpa .ne. nopgmx) then
        write (nttyo,3010) npgxpa,nopgmx
 3010   format(/' * Error - (XCON3/wr3d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopg activity coefficient option',
     $  ' switches with string definitions',/7x,'(npgxpa) has a value',
     $  ' of ' ,i3,', but the dimensioning',/7x,'parameter for the',
     $  ' number of such switches (nopgpa) has a',/7x,'value of ',i3,
     $  '.')
        qstop = .true.
      endif
c
      if (nprxpa .ne. noprmx) then
        write (nttyo,3020) nprxpa,noprmx
 3020   format(/' * Error - (XCON3/wr3d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopr print option switches',
     $  ' with string definitions',/7x,'(nprxpa) has a value of ',i3,
     $  ', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noprpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (nptxpa .ne. noptmx) then
        write (nttyo,3030) nptxpa,noptmx
 3030   format(/' * Error - (XCON3/wr3d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopt model option switches',
     $  ' with string definitions',/7x,'(nptxpa) has a value of ',i3,
     $  ', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noptpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (qstop) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Title.
c
      write (newin,2050)
 2050 format('|',78('-'),'|')
      write (newin,2040)
 2040 format('| Title',18x,'| (utitl(n))',42x,'|')
      write (newin,2050)
      do n = 1,ntitl
        write (newin,2070) utitl(n)
 2070   format('|',a78,'|')
      enddo
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,2100)
 2100 format('|Special Basis Switches (for model definition only)',
     $ 7x,'| (nsbswt)',11x,'|')
      write (newin,2050)
c
      do n = 1,nsbswt
        write (newin,2120) usbsw(1,n),usbsw(2,n)
 2120   format('|Replace |',a48,'| (usbsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (usbsw(2,n))',7x,'|')
        write (newin,2050)
      enddo
c
      if (nsbswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,2120) ux48a,ux48b
        write (newin,2050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
      write (newin,2140) tempc
 2140 format('|Temperature (C)         |',1pe12.5,'| (tempc)',t80,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      if (jpres3 .le. 0) then
        press = 0.
        ux1(1) = 'x'
      elseif (jpres3 .eq. 1) then
        press = 0.
        ux1(2) = 'x'
      elseif (jpres3 .ge. 2) then
        ux1(3) = 'x'
      endif
      write (newin,2160) ux1(1),ux1(2),ux1(3),press
 2160 format('|Pressure option (jpres3):',t80,'|',
     $ /'|  [',a1,'] ( 0) Data file reference curve value',t80,'|',
     $ /'|  [',a1,'] ( 1) 1.013-bar/steam-saturation curve value',t80,
     $ '|',/'|  [',a1,'] ( 2) Value (bars) |',1pe12.5,'| (press)',
     $ t80,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Density.
c
      write (newin,2180) rho
 2180 format('|Density (g/cm3)         |',1pe12.5,'| (rho)',34x,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Total dissolved solutes (TDS).
c
      ux1(1) = ' '
      ux1(2) = ' '
      if (itdsf3 .le. 0) then
        ux1(1) = 'x'
      elseif (itdsf3 .ge. 1) then
        ux1(2) = 'x'
      endif
      write (newin,2200) ux1(1),tdspkg,ux1(2),tdspl
 2200 format('|Total dissolved solutes option (itdsf3):',t80,'|',
     $ /'|  [',a1,'] ( 0) Value (mg/kg.sol) |',1pe12.5,'| (tdspkg)',
     $ t80,'|',/'|  [',a1,'] ( 1) Value (mg/L)      |',e12.5,
     $ '| (tdspl)',t80,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species to adjust for electrical balancing.
c
      ux1(1) = ' '
      ux1(2) = ' '
      if (iebal3 .le. 0) then
        ux1(1) = 'x'
      else
        ux1(2) = 'x'
      endif
c
      write (newin,2220) ux1(1),ux1(2),uebal
 2220 format('|Electrical balancing option (iebal3):',t80,'|',
     $ /'|  [',a1,'] ( 0) No balancing is done',t80,'|',
     $ /'|  [',a1,'] ( 1) Balance on species |',a24,'| (uebal)',t80,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Default redox constraint.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      ux1(4) = ' '
      ux1(5) = ' '
      if (irdxc3 .le. -3) then
        ux1(1) = 'x'
      elseif (irdxc3 .eq. -2) then
        ux1(2) = 'x'
      elseif (irdxc3 .eq. -1) then
        ux1(3) = 'x'
      elseif (irdxc3 .eq. 0) then
        ux1(4) = 'x'
      elseif (irdxc3 .ge. 1) then
        ux1(5) = 'x'
      endif
      write (newin,2250) ux1(1),ux1(2),pei,ux1(3),ehi,ux1(4),fo2lgi,
     $ ux1(5),uredox
 2250 format('|Default redox constraint (irdxc3):',t80,'|',
     $ /'|  [',a1,'] (-3) Use O2(g) line in the aqueous basis species',
     $ ' block',t80,'|',
     $ /'|  [',a1,'] (-2) pe (pe units)      |',1pe12.5,'| (pei)',t80,
     $ '|',/'|  [',a1,'] (-1) Eh (volts)         |',e12.5,'| (ehi)',t80,
     $ '|',/'|  [',a1,'] ( 0) Log fO2 (log bars) |',e12.5,'| (fo2lgi)',
     $ t80,'|',/'|  [',a1,'] ( 1) Couple (aux. sp.)  |',a24,
     $ '| (uredox)',t80,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous basis species and associated constraints.
c
      write (newin,2300)
 2300 format('|Aqueous Basis Species/Constraint Species',8x,
     $ '|Conc., etc. |Units/Constraint|',/'| (uspeci(n)/ucospi(n))',26x,
     $ '| (covali(n))|(ujf3(jflgi(n)))|')
      write (newin,2050)
c
      qstop = .false.
      do nb = 1,nbti
        jfl = jflgi(nb)
c
        if (jfl .gt. njfxpa) then
          j2 = ilnobl(uspeci(nb))
          write (nttyo,3050) jfl,uspeci(nb)(1:j2),njfxpa
 3050     format(/' * Error - (XCON3/wr3d8) The jflgi value of ',i3,
     $    ' for',/7x,'the species ',a,' exceeds the value of ',i3,
     $    ' for the dimensioning',/7x,'parameter (njfxpa) of the',
     $    ' associated string array.')
          qstop = .true.
        endif
c
        write (newin,1130) uspeci(nb),covali(nb),ujf3(jfl)
 1130   format('|',a48,'|',1pe12.5,'|',a16,'|')
        if (jfl.eq.17 .or. jfl.eq.18 .or. jfl.eq.25) then
          write (newin,1160) ucospi(nb)
 1160     format('|->|',a48,'| (ucospi(n))',14x,'|')
        endif
      enddo
      if (qstop) stop
c
      if (nbti .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,1130) ux48,xx,ux16
      endif
c
      write (newin,2050)
c
      write (newin,1162)
 1162 format('* Valid jflag strings (ujf3(jflgi(n))) are:',t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do jfl = -1,njfxpa
        if (ujf3(jfl)(1:6) .ne. 'ERROR ') then
          jj = j3 + 19
          ux80(j3:jj) = ujf3(jfl)
          j3 = jj + 1
          k = k + 1
          if (k .ge. 3) then
            write (newin,1164) ux80(1:80)
 1164       format(a)
            ux80(2:79) = ' '
            j3 = 6
            k = 0
          endif
        endif
      enddo
      if (k .gt. 0) write (newin,1164) ux80(1:80)
c
      write (newin,2052)
 2052 format('*',78('-'),'*')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,1600)
 1600 format('|Create Ion Exchangers',2x,'| (net)',48x,'|')
      write (newin,2050)
c
c     Set the advisory for exchanger creation blocks to follow or not.
c
      qgexbf = qgexsh .or. net.gt.0
      if (qgexbf) then
        write (newin,1603)
 1603   format('|Advisory: at least one exchanger creation block',
     $  ' follows on this file.',t80,'|')
      else
        write (newin,1605)
 1605   format('|Advisory: no exchanger creation blocks follow',
     $  ' on this file.',t80,'|')
      endif
c
c     Flag: on further processing, show at least one such block.
c
      ux1(1) = ' '
      if (qgexsh) ux1(1) = 'x'
      write (newin,1607) ux1(1)
 1607 format('|Option: on further processing (writing a PICKUP file',
     $ ' or running XCON3 on the',t80,'|',/'|present file), force the',
     $ ' inclusion of at least one such block (qgexsh):',t80,'|',
     $ /'|  [',a1,'] (.true.)',t80,'|')
      write (newin,2050)
c
      do ne = 1,net
        write (newin,1610) ugexp(ne)
 1610   format('|Exchanger phase |',a24,'| (ugexp(n))',
     $  25x,'|')
        write (newin,2050)
        write (newin,1620) mwtges(ne)
 1620   format('|->|Mol. wt. (Z)    |',1pg12.5,'| (mwtges(n))',
     $  33x,'|')
        write (newin,2050)
        write (newin,1630) ugexmo(ne)
 1630   format('|->|Exchange model  |',a24,'| (ugexmo(n))',
     $  21x,'|')
        write (newin,2050)
        write (newin,1640) tgexp(ne)
 1640   format('|->|Ref. temp. (C)  |',1pg12.5,'| (tgexp(n))',
     $  34x,'|')
        write (newin,2050)
        do je = 1,jgext(ne)
          write (newin,1650) ugexj(je,ne)
 1650     format('|->|Exchange site   |',a8,'| (ugexj(j,n))',
     $    36x,'|')
          write (newin,2050)
          write (newin,1660) cgexj(je,ne)
 1660     format('|--->|Stoich. number  |',1pg12.5,'| (cgexj(j,n))',
     $    30x,'|')
          write (newin,2050)
          write (newin,1670) zgexj(je,ne)
 1670     format('|--->|Electr. charge  |',1pg12.5,'| (zgexj(j,n))',
     $    30x,'|')
          write (newin,2050)
          do n = 1,ngexrt(je,ne)
            write (newin,1680) ugexr(n,je,ne)
 1680       format('|--->|Reaction        |',a24,'| (ugexr(i,j,n)',
     $      17x,'|')
            write (newin,2050)
            write (newin,1862)
 1862       format('|----->|Parameter |Value',7x,'|Units   | (this',
     $      ' is a table header)',13x,'|')
            write (newin,2050)
            write (newin,1684) xlkgex(n,je,ne),uxkgex(n,je,ne)
 1684       format('|----->|K func.   |',1pe12.5,'|',a8,
     $      '| (xlkgex(i,j,n), uxkgex(i,j,n))',7x,'|')
            write (newin,1686) xhfgex(n,je,ne),uhfgex(n,je,ne)
 1686       format('|----->|DelH0r    |',1pe12.5,'|',a8,
     $      '| (xhfgex(i,j,n), uhfgex(i,j,n))',7x,'|')
            write (newin,1688) xvfgex(n,je,ne),uvfgex(n,je,ne)
 1688       format('|----->|DelV0r    |',1pe12.5,'|',a8,
     $      '| (xvfgex(i,j,n), uvfgex(i,j,n))',7x,'|')
            write (newin,2050)
          enddo
        enddo
      enddo
c
      if (net.le.0 .and. qgexsh) then
        ux24 = 'None'
        ux8 = 'None'
        xx = 0.
        write (newin,1610) ux24
        write (newin,2050)
        write (newin,1620) xx
        write (newin,2050)
        write (newin,1630) ux24
        write (newin,2050)
        write (newin,1640) xx
        write (newin,2050)
        write (newin,1650) ux8
        write (newin,2050)
        write (newin,1660) xx
        write (newin,2050)
        write (newin,1670) xx
        write (newin,2050)
        write (newin,1680) ux24
        write (newin,2050)
        write (newin,1862)
        write (newin,2050)
        write (newin,1684) xx,ux8
        write (newin,1686) xx,ux8
        write (newin,1688) xx,ux8
        write (newin,2050)
      endif
c
      if (net.gt.0 .or. qgexsh) then
        write (newin,1694)
 1694   format('* Valid exchange model strings (ugexmo(n)) are:',t80,
     $  '*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,nvet_par
          if (ugexmv(n)(1:6) .ne. 'ERROR ') then
            jj = j3 + 27
            ux80(j3:jj) = ugexmv(n)
            j3 = jj + 1
            k = k + 1
            if (k .ge. 2) then
              write (newin,1696) ux80(1:80)
 1696         format(a)
              ux80(2:79) = ' '
              j3 = 6
              k = 0
            endif
          endif
        enddo
        if (k .gt. 0) write (newin,1696) ux80(1:80)
c
        write (newin,2052)
c
        write (newin,1690)
 1690   format('* Valid units strings (uxkgex(i,j,n)/uhfgex(i,j,n)/',
     $  'uvfgex(i,j,n)) are:',t80,'*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,4
          jj = j3 + 19
          ux80(j3:jj) = uxfuni(n)
          j3 = jj + 1
          k = k + 1
          if (k .ge. 3) then
            write (newin,1692) ux80(1:80)
 1692       format(a)
            ux80(2:79) = ' '
            j3 = 6
            k = 0
          endif
        enddo
        if (k .gt. 0) write (newin,1692) ux80(1:80)
c
        write (newin,2052)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified generic ion exchanger compositions.
c
      write (newin,1700)
 1700 format('|Ion Exchanger Compositions      | (neti)',38x,'|')
      write (newin,2050)
c
      do nei = 1,neti
c
c       Find the corresponding ne index.
c
        qgexef = .true.
        do ne = 1,net
          j2 = ilnobl(ugexp(ne))
          j3 = ilnobl(ugexpi(nei))
          if (ugexp(nei)(1:j3) .eq. ugexp(ne)(1:j2)) then
            j2 = ilnobl(ugexmo(ne))
            if (ugexmo(ne)(1:j2) .eq. 'Gapon' .or.
     $        ugexmo(ne)(1:6) .eq. 'Gapon-' .or.
     $        ugexmo(ne)(1:j2) .eq. 'Vanselow' .or.
     $        ugexmo(ne)(1:9) .eq. 'Vanselow-') then
c
c             Input composition is described in terms of equivalent
c             fractions on the sites.
c
              qgexef = .true.
            else
c
c             Input composition is described in terms of mole fractions
c             on the sites.
c
              qgexef = .false.
            endif
            go to 240
          endif
        enddo
  240   continue
c
        write (newin,1710) ugexpi(nei)
 1710   format('|Exchanger phase |',a24,'| (ugexpi(n))',
     $  24x,'|')
        write (newin,2050)
        write (newin,1720) cgexpi(nei)
 1720   format('|->|Moles/kg.H2O    |',1pg12.5,'| (cgexpi(n))',
     $  33x,'|')
        write (newin,2050)
        do jei = 1,jgexti(nei)
          write (newin,1730) ugexji(jei,nei)
 1730     format('|->|Exchange site   |',a8,'| (ugexji(j,n))',
     $    35x,'|')
          write (newin,2050)
          if (qgexef) then
            write (newin,1740)
 1740       format('|--->|Exchange species',8x,
     $      '|Eq. frac.   | (this is a table header)',10x,'|')
            write (newin,2050)
            do iei = 1,ngexti(jei,nei)
              write (newin,1750) ugexsi(iei,jei,nei),egexsi(iei,jei,nei)
 1750         format('|--->|',a24,'|',1pe12.5,
     $        '| (ugexsi(i,j,n), egexsi(i,j,n))',4x,'|')
            enddo
          else
            write (newin,1760)
 1760       format('|--->|Exchange species',8x,
     $      '|Mole frac.  | (this is a table header)',10x,'|')
            write (newin,2050)
            do iei = 1,ngexti(jei,nei)
              write (newin,1770) ugexsi(iei,jei,nei),xgexsi(iei,jei,nei)
 1770         format('|--->|',a24,'|',1pe12.5,
     $        '| (ugexsi(i,j,n), xgexsi(i,j,n))',4x,'|')
            enddo
          endif
          write (newin,2050)
        enddo
      enddo
c
      if (neti .le. 0) then
        ux24 = 'None'
        ux8 = 'None'
        xx = 0.
        write (newin,1710) ux24
        write (newin,2050)
        write (newin,1720) xx
        write (newin,2050)
        write (newin,1730) ux8
        write (newin,2050)
        write (newin,1740)
        write (newin,2050)
        write (newin,1750) ux24,xx
        write (newin,2050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Solid solutions.
c
      write (newin,1800)
 1800 format('|Solid Solution Compositions     | (nxti)',38x,'|')
      write (newin,2050)
c
      do nxi = 1,nxti
        write (newin,1810) usoli(nxi)
 1810   format('|Solid Solution',10x,'|',a24,'| (usoli(n))',17x,'|')
        write (newin,2050)
        nr1 = ncmpri(1,nxi)
        nr2 = ncmpri(2,nxi)
        write (newin,1812)
 1812   format('|->|Component',15x,'|Mole frac.  | (this is a',
     $  ' table header)',12x,'|')
        write (newin,2050)
        do nxic = nr1,nr2
          write (newin,1815) umemi(nxic),xbari(nxic)
 1815     format('|->|',a24,'|',1pe12.5,'| (umemi(i,n), xbari(i,n))',
     $    12x,'|')
        enddo
        write (newin,2050)
      enddo
c
      if (nxti .le. 0) then
        ux24 = 'None'
        xx = 0.
        write (newin,1810) ux24
        write (newin,2050)
        write (newin,1812)
        write (newin,2050)
        write (newin,1815) ux24,xx
        write (newin,2050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nxmod options.
c
      write (newin,3080)
 3080 format('|Alter/Suppress Options  | (nxmod)',45x,'|')
      write (newin,2050)
      write (newin,3082)
 3082 format('|Species',41x,'|Option',10x,'|Alter value |',
     $ /'| (uxmod(n))',37x,'|(ukxm(kxmod(n)))| (xlkmod(n))|')
      write (newin,2050)
c
      do n = 1,nxmod
        write (newin,3090) uxmod(n),ukxm(kxmod(n)),xlkmod(n)
 3090   format('|',a48,'|',a16,'|',1pe12.5,'|')
      enddo
c
      if (nxmod .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,3090) ux48,ux16,xx
      endif
c
      write (newin,2050)
c
      write (newin,3092)
 3092 format('* Valid alter/suppress strings (ukxm(kxmod(n))) are:',
     $ t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do kxmd = -1,2
        jj = j3 + 19
        ux80(j3:jj) = ukxm(kxmd)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 3) then
          write (newin,3094) ux80(1:80)
 3094       format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,3094) ux80(1:80)
c
      write (newin,2052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1460)
 1460 format('|Iopt Model Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,2050)
c
      uxo = 'iopt('
      do n = 1,noptmx
        j6 = index(uoptcx(n),'EQ3NR')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uopttx(n))
          write (newin,1465) uxo(1:j4),uopttx(n)(1:j3)
 1465     format('|',a,' - ',a,':'t80,'|')
          i = iopt(n)
          do j = 1,jptxpa
            ij = ioptox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uoptox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uoptox(j,n)(1:j2)
 1470         format('|  [',a1,'] (',i2,') ',a,t80,'|')
            endif
          enddo
          write (newin,2050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,1480)
 1480 format('|Iopg Activity Coefficient Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,2050)
c
      uxo = 'iopg('
      do n = 1,nopgmx
        j6 = index(uopgcx(n),'EQ3NR')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uopgtx(n))
          write (newin,1465) uxo(1:j4),uopgtx(n)(1:j3)
          i = iopg(n)
          do j = 1,jpgxpa
            ij = iopgox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uopgox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uopgox(j,n)(1:j2)
            endif
          enddo
          write (newin,2050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
      write (newin,1490)
 1490 format('|Iopr Print Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,2050)
c
      uxo = 'iopr('
      do n = 1,noprmx
        j6 = index(uoprcx(n),'EQ3NR')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uoprtx(n))
          write (newin,1465) uxo(1:j4),uoprtx(n)(1:j3)
          i = iopr(n)
          do j = 1,jprxpa
            ij = ioprox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uoprox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uoprox(j,n)(1:j2)
            endif
          enddo
          write (newin,2050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1495)
 1495 format('|Iodb Debugging Print Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,2050)
c
      uxo = 'iodb('
      do n = 1,nodbmx
        j6 = index(uodbcx(n),'EQ3NR')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uodbtx(n))
          write (newin,1465) uxo(1:j4),uodbtx(n)(1:j3)
          i = iodb(n)
          do j = 1,jdbxpa
            ij = iodbox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uodbox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uodbox(j,n)(1:j2)
            endif
          enddo
          write (newin,2050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical Parameters.
c
      write (newin,1500)
 1500 format('|Numerical Parameters',t80,'|')
      write (newin,2050)
c
      write (newin,1510) tolbt
 1510 format('| Beta convergence tolerance',t35,'|',1pe12.5,
     $ '| (tolbt)',t80,'|')
c
      write (newin,1520) toldl
 1520 format('| Del convergence tolerance',t35,'|',1pe12.5,
     $ '| (toldl)',t80,'|')
c
      write (newin,1524) itermx
 1524 format('| Max. Number of N-R Iterations',t35,'|',1x,i3,8x,
     $ '| (itermx)',t80,'|')
c
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,2700)
 2700 format('|Ordinary Basis Switches (for numerical purposes only)',
     $ 4x,'| (nobswt)',11x,'|')
      write (newin,2050)
c
      do n = 1,nobswt
        write (newin,2710) uobsw(1,n),uobsw(2,n)
 2710   format('|Replace |',a48,'| (uobsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (uobsw(2,n))',7x,'|')
        write (newin,2050)
      enddo
c
      if (nobswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,2710) ux48a,ux48b
        write (newin,2050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation flag tolerance.
c
      write (newin,2720) tolspf
 2720 format('|Sat. flag tolerance     |',1pe12.5,'| (tolspf)',31x,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale factor for the mass of aqueous solution to write
c     on the PICKUP file.
c
      write (newin,2790) scamas
 2790 format('|Aq. Phase Scale Factor  |',1pe12.5,'| (scamas)',31x,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     End of problem.
c
      write (newin,2900)
 2900 format('|End of problem',64x,'|')
      write (newin,2050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine aaaeq3(usteq3,uveeq3)
c
c     EQ3NR: EQ3NR Speciation-Solubility Code
c     EQ3/6 version 8.0a R43a (Patched 10/01/2009)
c
c     Last revised 04/24/02 by TJW
c
c     Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The Regents of
c     the University of California, Lawrence Livermore National
c     Laboratory. All rights reserved.
c
c     This work was produced at the University of California,
c     Lawrence Livermore National Laboratory (UC LLNL) under
c     contract no. W-7405-ENG-48 between the U.S. Department of
c     Energy (DOE) and The Regents of the University of California
c     (University) for the operation of UC LLNL. Copyright is
c     reserved to the University for purposes of controlled
c     dissemination, commercialization through formal licensing,
c     or other disposition under terms of Contract 48; DOE
c     policies, regulations, and orders; and U.S. statutes.
c
c
c                            DISCLAIMER
c
c     This computer code was prepared as an account of work
c     sponsored by an agency of the United States Government.
c     Neither the United States Government nor the University of
c     California nor any of their employees, makes any warranty,
c     express or implied, or assumes any liability or responsibility
c     for the accuracy, completeness, or usefulness of any
c     information, apparatus, product, or process disclosed, or
c     represents that its use would not infringe privately-owned
c     rights. Reference herein to any specific commercial products,
c     process, or service by trade name, trademark, manufacturer,
c     or otherwise, does not necessarily constitute or imply its
c     endorsement, recommendation, or favoring by the United States
c     Government or the University of California. The views and
c     opinions of authors expressed herein do not necessarily state
c     or reflect those of the United States government or the
c     University of California, and shall not be used for
c     advertising or product endorsement purposes.
c
c
c-----------------------------------------------------------------------
c
c     See the readme.txt file that came with this software for further
c     information, including contact information and references.
c
c
c-----------------------------------------------------------------------
c
c     This code computes chemical models of aqueous solutions. Problems
c     are composed using mostly analytical data. Thermodynamic data
c     are used in the calculations. This code is similar in function
c     to the codes in the WATEQ series. It can be used by itself to
c     determine aqueous speciation and solution-mineral saturation
c     relations. It can also be used to initialize EQ6 calculations.
c
c     The user defines the run parameters on the file called input.
c     The file called data1 provides the basic supporting thermodynamic,
c     etc., data. EQ3NR writes a pickup file and an output file called
c     output. The pickup file is used to pass data to EQ6. This file
c     is the second half of an EQ6 input file.
c
c     This code requires subroutines from the following EQ3/6 libraries:
c
c       EQLIB
c       EQLIBG
c       EQLIBU
c
c
c-----------------------------------------------------------------------
c
c     This subroutine is designed to ensure that the copyright statement
c     and legal and other disclaimers appear at the beginning of the
c     concatenated source code for EQ3NR. Concatenation is normally
c     alphabetical, hence the form of the name. This subroutine returns
c     the stage and version numbers of this computer code.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       None
c
c     Principal output:
c
c       usteq3 = EQ3NR stage number
c       uveeq3 = EQ3NR version number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character(len=8) usteq3,uveeq3
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character(len=8) ust,uve
c
c-----------------------------------------------------------------------
c
      data ust /'R43a    '/
      data uve /'8.0a    '/
c
c-----------------------------------------------------------------------
c
      usteq3 = ust
      uveeq3 = uve
c
      end

      subroutine exivar(abar,acflg,acflgo,act,actlg,actwlc,adh,
     $ adhh,adhv,al10,aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,
     $ bdoth,bdotv,cco2,cdrs,cegexs,cgexj,conc,conclg,cpgexs,
     $ egexjc,egexjf,egexs,eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,
     $ fugalg,fxi,fxio,ielam,iern1,iern2,ietmax,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,
     $ iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,
     $ ilrn2,ilzeta,imrn1,imrn2,insgf,iodb,iopg,ipbtmx,istack,
     $ ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jetmax,jflag,jgext,
     $ jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jssort,jstack,
     $ kbt,kdim,kelect,kmax,km1,ko2gaq,kwater,kxt,loph,losp,
     $ lsort,mgext,moph,mosp,mrgexs,mtb,napmax,narn1,narn2,natmax,
     $ nazmmx,nazpmx,nbasp,nbaspd,nbt,nbtmax,nchlor,ncmpr,ndrs,
     $ ndrsmx,ndrsr,nelect,nern1,nern2,net,netmax,ngexsa,ngext,
     $ ngrn1,ngrn2,ngt,ngtmax,nhydr,nmutmx,nmxmax,nodbmx,nopgmx,
     $ noutpt,no2gaq,nphasx,npt,nptmax,nsltmx,nst,nstmax,nsxmax,
     $ nttyo,omega,omeglg,press,qhawep,qpit75,q6mode,sigmam,sigmmo,
     $ tempk,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,xlks,zchar,zchcu6,zchsq2,zgexj,zvclg1,zvec1)
c
c     This subroutine expands the system description from the data
c     read from the input file. This includes estimating the numbers
c     of moles of all phases and species present, the concentrations,
c     activity coefficients, and activities of all the species, the
c     ionic strength, and the sum of the molalities of all aqueous
c     aqueous solute species.
c
c     Only a minimum expansion is carried out by the present
c     subroutine. Further refinements, if any, are made by EQ6/optmzr.
c     The iodb(3) debug print option switch is used in this subroutine
c     to control certain prints that are analogous to those in
c     EQ6/optmzr.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       aphi   = Debye-Huckel A(phi) parameter
c       azero  = array of hard core diameters of aqueous species
c       bdh    = Debye-Huckel B(gamma) parameter
c       bdot   = B-dot parameter
c       cco2   = coefficients of the Drummond (1981) equation
c       cdrs   = array of reaction coefficients
c       ielam  = flag to not use (-1) or use (0) higher order
c                  electrostatic terms in relevant activity coefficient
c                  models
c       insgf  = array of activity coefficient flags for aqueous
c                  species, used in the case of neutral solute
c                  species when using the B-dot model
c       iopg   = array of activity coefficient option switches
c       izmax  = max norm of the electrical charges of the aqueous
c                  species
c       nbt    = the number of basis species
c       nchlor = index of the aqueous chloride ion
c       ncmpr  = array giving the range in arrays corresponding to
c                  species of those species which belong to a given
c                  phase
c       ndrs   = array parallel to cdrs giving the index of the
c                  corresponding species
c       ndrsr  = array giving the range in the cdrs/ndrs arrays
c                  corresonding to the reaction associated with a
c                  given species
c       nhydr  = index of the aqueous hydrogen ion
c       press  = pressure, bars
c       tempk  = temperature, K
c       uphase = array of phase names
c       uspec  = array of species names
c       xlks   = array of equilibrium constants
c       zchar  = array of electrical charge numbers for the various
c                  species
c       zchsq2 = array of (z**2)/2 values
c       zchcu6 = array of (z**3/)6 values
c       zvec1  = array of master variables
c       zvclg1 = array of logarithms of master variables
c
c     Principal output:
c
c       abar   = average ion size
c       acflg  = array of logarithms of activity coefficients
c       acflgo = array of old values of the activity coefficients of
c                  the various species
c       act    = array of species activities
c       actlg  = array of logarithms of species activities
c       actwlc = log activity of water (calculated)
c       a3bar    average cube of distance of closest apporach
c       a3bars   characteristic average cube of distance of closest
c                  apporach for each solute species
c       conc   = array of species concentrations
c       conclg = array of logarithms of species concentrations
c       fo2    = the oxygen fugacity
c       fo2lg  = logarithm of the oxygen fugacity
c       fugac  = array of gas fugacities
c       fugalg = array of logarithms of gas fugacities
c       fxi    = the ionic strength
c       fxio   = old value of the ionic strength
c       moph   = array of numbers of moles of phases
c       loph   = array of logarithms of numbers of moles of phases
c       mosp   = array of numbers of moles of species
c       losp   = array of logarithms of numbers of moles of species
c       sigmam = the sum of solute molalities
c       sigmmo = old value of sigmam
c       xbar   = array of mole fractions of species
c       xbarlg = array of logarithms of mole fractions of species
c       xbarw  = mole fraction of water
c       xbarwc = mole fraction of water (calculated)
c       xbrwlc = log mole fraction of water (calculated)
c       xbrwlg = log mole fraction of water
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations. Only a subset of these data is required here.
c
      use mod6pt
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,ipbtmx,jetmax,kmax,napmax,natmax,nazmmx,nazpmx,
     $ nbtmax,ndrsmx,netmax,ngtmax,nmutmx,nmxmax,nodbmx,nopgmx,nptmax,
     $ nsltmx,nstmax,nsxmax
c
      integer noutpt,nttyo
c
      integer igstak(ngtmax),iindx1(kmax),insgf(natmax),iodb(nodbmx),
     $ iopg(nopgmx),istack(nstmax),jcsort(nstmax),jern1(jetmax,netmax),
     $ jern2(jetmax,netmax),jflag(nstmax),jgext(netmax),
     $ jgsort(ngtmax),jgstak(ngtmax),jjsort(nstmax),jpflag(nptmax),
     $ jsflag(nstmax),jsitex(nstmax),jssort(nstmax),jstack(nstmax),
     $ nbasp(nbtmax),nbaspd(nbtmax),ncmpr(2,nptmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax),ngexsa(ietmax,jetmax,netmax),
     $ ngext(jetmax,netmax),nphasx(nstmax)
c
      integer ielam,iern1,iern2,ifrn1,ifrn2,igas,ilrn1,ilrn2,imrn1,
     $ imrn2,ixrn1,ixrn2,izmax,kbt,kdim,kelect,km1,ko2gaq,kwater,kxt,
     $ narn1,narn2,nbt,nchlor,nelect,nern1,nern2,net,ngrn1,ngrn2,ngt,
     $ nhydr,no2gaq,npt,nst
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      logical qhawep,qpit75,q6mode
c
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 acflg(nstmax),acflgo(nstmax),act(nstmax),actlg(nstmax),
     $ azero(natmax),a3bars(natmax),cco2(5),cdrs(ndrsmx),
     $ cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),conc(nstmax),
     $ conclg(nstmax),cpgexs(ietmax,jetmax,netmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),fsort(ngtmax),fugac(ngtmax),
     $ fugalg(ngtmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ mgext(jetmax,netmax),moph(nptmax),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),xbar(nstmax),
     $ xbarlg(nstmax),xlks(nstmax),zchar(nstmax),zchcu6(nstmax),
     $ zchsq2(nstmax),zgexj(jetmax,netmax),zvclg1(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,actwlc,al10,a3bar,eps100,fje,fjeo,fo2,fo2lg,fxi,
     $ fxio,omega,omeglg,press,sigmam,sigmmo,tempk,xbarw,xbarwc,
     $ xbrwlc,xbrwlg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,kcol,nb,ns
c
      logical qxbarw
c
      character*56 uspn56
c
      real*8 zx1,zx2
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
      data qxbarw/.false./
c
c-----------------------------------------------------------------------
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1000)
 1000   format(/11x,' --- Starting initializing calculations ---',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize log mole fraction of water in aqueous solution,
c     using a plausible value. This will later be corrected as needed.
c
      xbarwc = 1.0
      xbrwlc = 0.
      xbar(narn1) = xbarwc
      xbarlg(narn1) = xbrwlc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the concentrations, etc., of basis and non-basis
c     species. Here the activity coefficients are all zero.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
c     Clamp estimates of concentrations and numbers of moles of
c     dependent aqueous species.
c
      do ns = narn1,narn2
        if (jflag(ns) .ge. 30) then
          conc(ns) = 0.
          mosp(ns) = 0.
          conclg(ns) = -99999.
          losp(ns) = -99999.
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the first estimates of SIGMA m, ionic strength, and J taking
c     into account the concentrations of only data file basis species.
c     This generally provides a set of safe values, as the computed
c     concentrations of non-basis species at this point could be
c     extremely large.
c
      sigmam = 0.
      fxi = 0.
      fje = 0.
      do nb = 1,nbt
        ns = nbaspd(nb)
        if (ns.gt.narn1 .and. ns.le.narn2) then
          sigmam = sigmam + conc(ns)
          fxi = fxi + conc(ns)*zchsq2(ns)
          fje = fje + conc(ns)*zchcu6(ns)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the first real estimate of the mole fraction of water in
c     aqueous solution.
c
      xbarwc = omega/(omega + sigmam)
      xbrwlc = tlg(xbarwc)
      xbarw = xbarwc
      xbrwlg = xbrwlc
      xbar(narn1) = xbarwc
      xbarlg(narn1) = xbrwlc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the first estimates of the aqueous species activity
c     coefficients.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call gcoeff(abar,acflg,actwlc,adh,adhh,adhv,al10,
     $ aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ cco2,conc,delam,dgpit,dpelm,dpslm,dselm,elam,fje,fxi,gpit,
     $ ielam,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta,insgf,
     $ iopg,ipbtmx,izmax,jcsort,nalpha,napmax,napt,narn1,narn2,
     $ natmax,nazmmx,nazpmx,nchlor,nhydr,nmut,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,nopgmx,noutpt,nslt,nsltmx,nslx,nstmax,nsxi,
     $ nsxmax,nsxx,nttyo,omega,palpha,pelm,pmu,press,pslamn,
     $ pslm,qhawep,qpit75,selm,sigmam,tempk,uspec,xbarwc,xbrwlc,
     $ zchar,zchsq2,zchcu6)
c
c     Make the first estimates of the exchanger species activity
c     coefficients.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call lamgex(acflg,cgexj,jern1,jern2,jetmax,jgext,net,
     $ netmax,nstmax,xbarlg)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
c
c       Print the attempted phase assemblage.
c
        write (noutpt,1010)
 1010   format(/' Initial phase assemblage:',/)
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1020) kcol,uspn56(1:jlen)
 1020     format(2x,i3,2x,a)
        enddo
        do kcol = km1,kxt
          ns = iindx1(kcol)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnm(jlen,uspec(ns),uspn56)
          write (noutpt,1020) kcol,uspn56(1:jlen)
        enddo
        write (noutpt,1030)
 1030   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 2) then
        write (noutpt,1050)
 1050   format(/16x,'--- Initialization Summary ---',
     $  //2x,'kcol   Name',32x,'zvclg1      zvec1',/)
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          zx1 = zvclg1(kcol)
          zx2 = texp(zx1)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1060) kcol,uspn56,zx1,zx2
 1060     format(1x,i4,2x,a32,2x,f10.4,2x,1pe12.5)
        enddo
        do kcol = km1,kxt
          ns = iindx1(kcol)
          zx1 = zvclg1(kcol)
          zx2 = texp(zx1)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnm(jlen,uspec(ns),uspn56)
          write (noutpt,1060) kcol,uspn56,zx1,zx2
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1120) sigmam,fxi,fje
 1120   format(/8x,'sigmam= ',1pe12.5,/11x,'fxi= ',e12.5,
     $  /11x,'fje= ',e12.5,/)
      endif
c
      if (iodb(3) .ge. 4) then
        write (noutpt,1130)
 1130   format(/7x,'Species',20x,'gamma',/)
        do ns = narn1,narn2
          write (noutpt,1140) uspec(ns),acflg(ns)
 1140     format(5x,a24,3x,1pe12.5)
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      sigmmo = sigmam
      fxio = fxi
      fjeo = fje
      do ns = narn1,narn2
        acflgo(ns) = acflg(ns)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1200)
 1200   format(/11x,' --- Finished initializing calculations ---',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gcdrw(cdrs,cdrw,narn1,ndrs,ndrsmx,ndrsr,nst,nstmax)
c
c     This subroutine computes the cdrw array. Each element of this
c     array contains the reaction coefficient for liquid water in the
c     corresponding reaction.
c
c     Do not confuse this array with the cdrtw array computed by
c     EQLIB/gcdrtw.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/path.f
c       EQ6/absswb.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer narn1,nst
c
      real*8 cdrs(ndrsmx),cdrw(nstmax)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nn,nr1,nr2,ns
c
c----------------------------------------------------------------------
c
      do ns = 1,nst
        cdrw(ns) = 0.
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        do n = nr1,nr2
          nn = ndrs(n)
          if (nn .eq. narn1) then
            cdrw(ns) = cdrs(n)
            go to 100
          endif
        enddo
  100   continue
      enddo
c
      end

      subroutine scalx1(avx,avxmax,avxs,ier,nmax)
c
c     This subroutine scales the elements in the avx array to the
c     interval (-1,1). The results are placed in the avxs array. This
c     subroutine is normally used in conjunction with EQLIBU/rscaly.f
c     and EQLIBU/polfit.f to fitting interpolating polynomials to
c     data in which avx contains values of the independent variable.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       avx    = array whose contents are to be scaled
c       avxmax = the max norm of avx
c       n      = the number of elements in avx
c
c     Output:
c
c       avxs   = array whose contents are to be scaled
c       ier    = error flag
c                  = 0  okay
c                  = 1  all the elements of avx are zero
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ier,nmax
c
      real*8 avx(nmax),avxs(nmax)
      real*8 avxmax
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i
c
      real*8 ax
c
c-----------------------------------------------------------------------
c
c     Initialize error flag.
c
      ier = 0
c
c     Note- nmax is expected to be relatively small. Therefore, loop
c     unrolling or calling of subroutines which employ loop unrolling
c     is not used here.
c
c     Find the max norm of avx.
c
      avxmax = 0.
      do i = 1,nmax
        ax = abs(avx(i))
        if (ax .gt. avxmax) avxmax = ax
      enddo
c
      if (avxmax .le. 0.) then
        ier = 1
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale the array.
c
      do i = 1,nmax
        avxs(i) = avx(i)/avxmax
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
c
c     This subroutine parses the input string uline1, based on the
c     delimiter '|'. Character strings found between delimiters are
c     copied into the output array ufield. The elements of this array
c     are not justified. EQLIBU/parslj.f can be used to call this
c     subroutine and follow up the parsing with left-justification.
c
c     The scheme is exemplified as follows:
c
c     |  field 1  |  field 2   |  field3  |
c
c     where the first '|' is in column 1 or
c
c        field 1  |  field 2   |  field3  |
c
c     The first field may or may not have a delimiter to its left.
c     Each field must have a delimiter to its right. A field to
c     the right of the last delimiter, if any, is ignored.
c
c     This subroutine is called by:
c
c       EQLIBU/parslj.f
c       XCON3/rd3d7.f
c       XCON6/rd6d7.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nfldmx = maximum number of fields
c       nlchmx = the dimension of the ufield array
c       uline1 = the line to be parsed
c       ulscr  = scratch character variable
c
c     Output:
c
c       nfldt  = actual number of fields
c       ufield = array of fields
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
c     Note: the character length of the variables uline1, ulstr, and
c     ufield is actually nlchmx. The Sun Fortran compiler does not
c     allow this to be directly specified.
c
      integer nfldmx,nlchmx
c
      integer nfldt
c
      character*(*) uline1,ulscr
      character*(*) ufield(nfldmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,icht,i2,nfld
c
c-----------------------------------------------------------------------
c
      icht = 0
      nfldt = 0
c
      do i = 1,nfldmx
        ufield(i) = ' '
      enddo
c
c     Find the first delimiter. This is normally expected to appear in
c     column 1. The first field then begins in column 2. If the first
c     delimiter appears in a column beyond the first, the first
c     field begins in column 1.
c
      i  = index(uline1,'|')
      if (i .eq. 1) then
        icht = 1
      else
        icht = 0
      endif
c
      do nfld = 1,nfldmx
        ulscr = uline1(icht + 1:nlchmx)
        i = index(ulscr,'|')
        if (i .eq. 0) then
c
c         Have a last field with no delimiter to its right. Ignore it.
c
          go to 999
        else
          i2 = i - 1
        endif
        nfldt = nfldt + 1
        if (nfldt .le. nfldmx) then
          if (i2 .gt. 0) then
            ufield(nfld)(1:i2) = ulscr(1:i2)
          endif
        endif
        icht = icht + i2 + 1
        if (icht .ge. nlchmx) go to 999
      enddo
c
  999 continue
c
      end

      subroutine chdxec(delxi,dlxmx0,dzvc0,iodb,kdim,kmax,km1,kxt,
     $ nodbmx,nord,noutpt,nrd1mx,qmin,qscon,scale,scalim,scnstd,
     $ scnsti,uzvec1,zvec0)
c
c     This subroutine chooses the step size (delxi) for economy and
c     super economy modes.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nodbmx,nrd1mx
c
      integer noutpt
c
      integer iodb(nodbmx)
c
      integer kdim,km1,kxt,nord
c
      logical qmin,qscon
c
      character*48 uzvec1(kmax)
c
      real*8 dzvc0(nrd1mx,kmax),zvec0(kmax)
c
      real*8 delxi,dlxmx0,scale,scalim,scnstd,scnsti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,kcol,kcolcn
c
      integer ilnobl
c
      character*24 ubas,uzt,uzn
c
      real*8 aterm,d1,d2,d1sq,mxx0,rd1,rd2,ri1,ri2,rx,scfac,scnst,sx,
     $ termd,termi,thetad,thetai
c
c-----------------------------------------------------------------------
c
      data ubas /'basis variable          '/
c
c-----------------------------------------------------------------------
c
      if (qscon) then
c
c       Choose the step size for super economy mode.
c
        nord = 0
        scale = dlxmx0/delxi
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Choose step size for ordinary economy mode.
c
      if (nord .le. 0) then
        scale = dlxmx0/delxi
        go to 999
      endif
c
      uzt = 'None'
      uzn = ' '
      kcolcn = 0
      scfac = scale
c
      do kcol = 1,kdim
        qmin = kcol.ge.km1 .and. kcol.le.kxt
        d1 = dzvc0(1,kcol)
        d2 = dzvc0(2,kcol)
        mxx0 = zvec0(kcol)
        if (nord.le.1 .or. d2.eq.0.) then
c
c         First order bound.
c
          if (d1 .eq. 0.) go to 100
          if (d1 .gt. 0.) then
            scnst = scnsti
          else
            scnst = scnstd
          endif
          sx = (mxx0*scnst) / (d1*delxi)
          if (iodb(5) .ge. 2) then
            if (sx .lt. scale) then
              rx = sx*delxi
              write (noutpt,1000) uzvec1(kcol),rx
 1000         format(3x,'Element= ',a,/7x,'Root= ',1pe12.5)
              write (noutpt,1010) dzvc0(1,kcol)
 1010         format(7x,'Derivatives= ',4(1pe12.5,2x))
            endif
          endif
        else
c
c         Second order bound. There are two quadratic equations to be
c         solved, each of which has two roots. Only the smallest
c         positive root is of interest. If one root of an equation is
c         complex, the other will also be complex. If both roots are
c         real, they could be positive and negative, both positive, or
c         both negative.
c
          d1sq = d1*d1
          thetai = mxx0*scnsti
          thetad = mxx0*scnstd
          termi = 2.*d2*thetai
          termd = 2.*d2*thetad
c
c         Here ri1, ri2, rd1, and rd2 are values of Xi which are roots
c         of the equations.
c
          aterm = d1sq - termi
          if (aterm .ge. 0.) then
            ri1 = (d1 + sqrt(aterm))/d2
            if (ri1.le.0.) ri1 = 1.e+30
            ri2 = (d1 - sqrt(aterm))/d2
            if (ri2.le.0.) ri2=1.e+30
          else
            ri1 = 1.e+30
            ri2 = 1.e+30
          endif
c
          aterm = d1sq - termd
          if (aterm .ge. 0.) then
            rd1 = (d1 + sqrt(aterm))/d2
            if (rd1.le.0.) rd1 = 1.e+30
            rd2 = (d1 - sqrt(aterm))/d2
            if (rd2.le.0.) rd2 = 1.e+30
          else
            rd1 = 1.e+30
            rd2 = 1.e+30
          endif
c
          rx = min(ri1,ri2,rd1,rd2)
          if (rx .lt. 1.e+30) then
            sx = rx/delxi
          else
            sx = 1.e+30
          endif
c
          if (iodb(5) .ge. 2) then
            if (sx .lt. scale) then
              j2 = ilnobl(uzvec1(kcol))
              write (noutpt,1000) uzvec1(kcol)(1:j2),rx
              write (noutpt,1010) dzvc0(1,kcol),dzvc0(2,kcol)
            endif
          endif
        endif
c
        if (sx .lt. scfac) then
          scfac = sx
          kcolcn = kcol
          uzt(1:24) = ubas(1:24)
        endif
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kcolcn .gt. 0) uzn(1:24) = uzvec1(kcolcn)(1:24)
      if (iodb(5) .ge. 1) then
        write (noutpt,1020) scfac
 1020   format('   Economy mode: scale= ',f10.5)
        j2 = ilnobl(uzt)
        j3 = ilnobl(uzn)
        if (j3 .gt. 0) then
          write (noutpt,1030) scfac,uzt(1:j2),uzn(1:j3)
 1030     format(5x,'Constrained by ',a,1x,a)
        else
          write (noutpt,1040) uzt(1:j2)
 1040     format(5x,'Constrained by ',a)
        endif
      endif
      scale = min(scalim,scfac)
c
  999 continue
      end

      subroutine clress(csts,iindx1,ipndx1,jpflag,jsflag,kdim,kmax,
     $ km1,kmt,kx1,kxt,loph,losp,moph,mosp,mtb,mtbaq,nbt,nbtmax,
     $ nptmax,nstmax,nsts,nstsmx,nstsr,ufixf,uzvec1,zvec1,zvclg1)
c
c     This subroutine clears equilibrium system (ES) solids. These
c     solids include pure minerals and solid solutions, but not fictive
c     fugacity-fixing minerals.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       csts   = array of stoichiometric coefficients for mass
c                  balance expressions
c       losp   = array of log number of moles of species variables
c       mosp   = array of number of moles of species
c       mtb    = array of total numbers of moles of basis species
c       mtbaq  = array of total numbers of moles of basis species
c                  in the aqueous solution
c       uzvec1 = array of master variable names
c       zvec1  = array of master variables
c       zvclg1 = array of log master variables
c
c     Principal output:
c
c       losp   = array of log number of moles of species variables
c                  (modified)
c       mosp   = array of number of moles of species (modified)
c       mtb    = array of total numbers of moles of basis species
c                  (modified)
c       zvec1  = array of master variables (modified)
c       zvclg1 = array of log master variables (modified)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nptmax,nstmax,nstsmx
c
      integer iindx1(kmax),ipndx1(kmax),jpflag(nptmax),jsflag(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
      integer kdim,km1,kmt,kx1,kxt,nbt
c
      character*48 uzvec1(kmax)
      character*8 ufixf
c
      real*8 csts(nstsmx),loph(nptmax),losp(nstmax),moph(nptmax),
     $ mosp(nstmax),mtb(nbtmax),mtbaq(nbtmax),zvec1(kmax),zvclg1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,kcol,n,nb,nr1,nr2,np,ns
c
c-----------------------------------------------------------------------
c
c     Clear the phase and species status flags for the items to be
c     cleared from the ES.
c
      do kcol = km1,kmt
        if (uzvec1(kcol)(1:5) .ne. ufixf(1:5)) then
c
c         Do not have a fictive fugacity-fixing mineral.
c
          np = ipndx1(kcol)
          ns = iindx1(kcol)
          jpflag(np) = 0
          jsflag(ns) = 0
          moph(np) = 0.
          loph(np) = -99999.
          mosp(ns) = 0.
          losp(ns) = -99999.
        endif
      enddo
c
      do kcol = kx1,kxt
        np = ipndx1(kcol)
        ns = iindx1(kcol)
        jpflag(np) = 0
        jsflag(ns) = 0
        moph(np) = 0.
        loph(np) = -99999.
        mosp(ns) = 0.
        losp(ns) = -99999.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the mass balance totals to account for the cleared
c     phases.
c
      do nb = 1,nbt
        mtb(nb) = mtbaq(nb)
      enddo
c
      do kcol = km1,kmt
        if (uzvec1(kcol)(1:5) .eq. ufixf(1:5)) then
c
c         Have a fictive fugacity-fixing mineral. Adjust the
c         mass balances to retain it in the system.
c         Retain it.
c
          ns = iindx1(kcol)
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            mtb(nb) = mtb(nb) + csts(n)*zvec1(kcol)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      k = km1 - 1
      do kcol = km1,kmt
        if (uzvec1(kcol)(1:5) .eq. ufixf(1:5)) then
c
c         Have a fictive fugacity-fixing mineral. Retain it in
c         the indexing scheme for the cleared system.
c
          k = k + 1
          zvec1(k) = zvec1(kcol)
          zvclg1(k) = zvclg1(kcol)
          ipndx1(k) = ipndx1(kcol)
          iindx1(k) = iindx1(kcol)
        endif
      enddo
c
      kmt = k
      kx1 = kmt + 1
c
      do kcol = kx1,kxt
c
c       Clear all other minerals, both pure minerals and solid
c       solutions.
c
        zvec1(kcol) = 0.
        zvclg1(kcol) = -99999.
        iindx1(kcol) = 0
        ipndx1(kcol) = 0
      enddo
c
      kxt = kmt
      kdim = kmt
c
      end

      subroutine scripx(abar,acflg,act,actlg,adh,afcnst,affpd,
     $ affsd,ahrc,alki,apx,atwt,a3bar,a3bars,bpx,cdrsd,cegexs,
     $ cess,conc,conclg,coval,csts,ctb,cteaq,egexjc,egexjf,egexpa,
     $ egexpc,egexs,egexw,ehfac,ehrc,eps100,eh,farad,fje,fo2,fo2lg,
     $ fo2lrc,fugac,fugalg,fxi,iapxmx,ibpxmx,iebal,iern1,iern2,ietmax,
     $ igas,iktmax,iopg,iopr,iopt,ilrn1,ilrn2,imrn1,imrn2,ixrn1,
     $ ixrn2,jcsort,jern1,jern2,jetmax,jflag,jflagd,jflgi,jfleba,jgext,
     $ jgsort,jpflag,jsflag,jsol,jsomax,kern1,kern2,ketmax,kgexsa,
     $ mlmrra,mrmlra,moph,mosp,mte,mteaq,mwtsp,narn1,narn2,natmax,
     $ nbasp,nbaspd,nbt,nbtmax,nchlor,ncmpr,nct,nctmax,ndrsd,ndrsmx,
     $ ndrsrd,nelect,ness,nessmx,nessr,net,neti,netmax,ngexpi,ngexsa,
     $ ngext,ngrn1,ngrn2,ngt,ngtmax,nhydr,nhydx,nopgmx,noprmx,noptmx,
     $ noutpt,no2gaq,npnxp,npt,nptmax,nrdxsp,nst,nstmax,nsts,nstsmx,
     $ nstsr,ntf1,ntf1mx,ntf1t,ntf2,ntf2mx,ntf2t,nttyo,nxrn1,nxrn2,
     $ nxt,nxti,nxtimx,nxtmax,omega,pe,perc,ppmwe,qrho,qxknph,rho,
     $ rhoc,rhowc,sidrph,sidrsp,sigmam,sigzi,tdsglw,tdspkc,tdspkg,
     $ tdspl,tdsplc,tempc,tf1,tf2,tolspf,uelem,ugexj,ugexmo,uphase,
     $ uspec,uxtype,vosol,wfac,wfh2o,wftds,wkgwi,woh2o,wosol,wotds,
     $ xbar,xbarlg,xbarw,xbrwlg,xgexw,xlke,xlksd,zchar,zchcu6,zchsq2)
c
c     This subroutine writes a description of the computed aqueous
c     solution model on the output file.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,ibpxmx,ietmax,iktmax,jetmax,jsomax,ketmax,natmax,
     $ nbtmax,nctmax,ndrsmx,nessmx,netmax,ngtmax,nopgmx,noprmx,noptmx,
     $ nptmax,nstmax,nstsmx,ntf1mx,ntf2mx,nxtimx,nxtmax
c
      integer noutpt,nttyo
c
      integer iopg(nopgmx),iopr(noprmx),iopt(noptmx),jcsort(nstmax),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jgsort(ngtmax),
     $ jflag(nstmax),jflagd(nstmax),jflgi(nbtmax),jgext(netmax),
     $ jpflag(nptmax),jsflag(nstmax),jsol(nxtmax),kern1(netmax),
     $ kern2(netmax),kgexsa(ketmax,netmax),nbasp(nbtmax),nbaspd(nbtmax),
     $ ncmpr(2,nptmax),ndrsd(ndrsmx),ndrsrd(2,nstmax),ness(nessmx),
     $ nessr(2,nstmax),ngexpi(netmax),ngexsa(ietmax,jetmax,netmax),
     $ ngext(jetmax,netmax),npnxp(nxtimx),nsts(nstsmx),nstsr(2,nstmax),
     $ ntf1(ntf1mx),ntf2(ntf2mx)
c
      integer iebal,iern1,iern2,igas,ilrn1,ilrn2,imrn1,imrn2,ixrn1,
     $ ixrn2,jfleba,narn1,narn2,nbt,nchlor,nct,nelect,net,neti,ngrn1,
     $ ngrn2,ngt,nhydr,nhydx,no2gaq,npt,nrdxsp,nst,ntf1t,ntf2t,nxrn1,
     $ nxrn2,nxt,nxti
c
      logical qxknph(nptmax)
c
      logical qrho
c
      character(len=48) uspec(nstmax)
      character(len=32) uxtype(jsomax)
      character(len=24) ugexmo(netmax),uphase(nptmax)
      character(len=8) uelem(nctmax),ugexj(jetmax,netmax)
c
      real(8) acflg(nstmax),act(nstmax),actlg(nstmax),ahrc(nbtmax),
     $ atwt(nctmax),a3bars(natmax),affpd(nptmax),affsd(nstmax),
     $ apx(iapxmx,nxtmax),bpx(ibpxmx,nxtmax),cdrsd(ndrsmx),
     $ cegexs(ietmax,jetmax,netmax),cess(nessmx),conc(nstmax),
     $ conclg(nstmax),coval(nbtmax),csts(nstsmx),ctb(nbtmax),
     $ cteaq(nctmax),egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexpa(netmax),egexpc(netmax),egexs(ietmax,jetmax,netmax),
     $ egexw(ketmax,netmax),ehrc(nbtmax),fo2lrc(nbtmax),
     $ fugac(ngtmax),fugalg(ngtmax)
c
      real(8) moph(nptmax),mosp(nstmax),mte(nctmax),mteaq(nctmax),
     $ mwtsp(nstmax),perc(nbtmax),ppmwe(nctmax),sidrph(nptmax),
     $ sidrsp(nstmax),tf1(ntf1mx),tf2(ntf2mx),wfac(iktmax,nxtmax),
     $ xbar(nstmax),xbarlg(nstmax),xgexw(ketmax,netmax),xlksd(nstmax),
     $ zchar(nstmax),zchcu6(nstmax),zchsq2(nstmax)
c
      real(8) abar,adh,afcnst,alki,a3bar,ehfac,eps100,eh,farad,
     $ fje,fo2,fo2lg,fxi,omega,pe,rho,sigmam,sigzi,tdspkg,tdspl,
     $ tempc,tolspf,vosol,wfh2o,wftds,wkgwi,woh2o,wosol,wotds,
     $ xbarw,xbrwlg,xlke
c
      real(8) mlmrra,mrmlra,rhoc,rhowc,tdsglw,tdspkc,tdsplc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,j2,nb,ncount,nei,np,nr1,nr2,ns,nss,ns1,ns2,nt,nx,nxi
c
      integer ilnobl
c
      logical qphcl,qredox
c
      character(len=8) uadj,ufinal,uinput,ux1,ux2,ux3
c
      real(8) acfw,acfwlg,alk1,alk2,actw,actwlg,ah,ahmes,ahnbs,axc,axd,
     $ axx,cte,ctebal,cx,cxv,cxw,ehmes,ehnbs,fjest,fxist,msigzm,osc,
     $ oscst,osfac,pch,pemes,penbs,ph,phc,phcl,phd,phnbs,phmes,phx,
     $ ppmv,ppmw,pxc,pxd,pxx,pzmean,pztot,sanion,sigmst,sigza,sigzc,
     $ sigzm,sx
c
      real(8) coefst,texp,tlg
c
c-----------------------------------------------------------------------
c
      data uinput /'Input   '/,ufinal /'Final   '/,uadj   /'Adj     '/
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(/' - - - - - - - - - - - - - - - - - - - - - - - - - - -',
     $ ' - - - - - - - - - - - -',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
cXX   Begin jsol values with 0 or 1? Need to work something out with
cXX   the data base group as to which. Wait until solid solutions are
cXX   redone.
c
      do nx = 1,nxt
        if (jsol(nx) .eq. 0) jsol(nx) = 1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table of the elemental composition of the aqueous
c     solution.
c
      call prteca(cteaq,mrmlra,nct,nctmax,noutpt,ppmwe,
     $ qrho,rho,uelem)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and save the calculated total concentration of the
c     species adjusted for electrical balance.
c
      if (iebal .gt. 0) then
        ctebal = 0.
        nb = iebal
        do nss = narn1,narn2
          ns = jcsort(nss)
          if (jsflag(ns) .le. 0) then
            cx = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            ctebal = ctebal + cx*conc(ns)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table of the numerical composition of the aqueous
c     solution.
c
      call prtnca(ctb,jflag,jsflag,mrmlra,mwtsp,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,noutpt,nstmax,qrho,rho,uspec,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print a table of the sensible composition of the
c     aqueous solution.
c
      call prtsca(ctb,jflag,jsflag,mrmlra,mwtsp,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,nelect,nhydr,nhydx,noutpt,no2gaq,
     $ nstmax,qrho,rho,uspec,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print various aqueous solution parameters.
c
      actwlg = actlg(narn1)
      actw = texp(actwlg)
c
      acfwlg = acflg(narn1)
      acfw = texp(acfwlg)
c
c     Compute the sum of the stoichiometric molalities.
c
      sigmst = 0.
      do nb = 1,nbt
        ns = nbaspd(nb)
c
c       The 'abs' comes into play below only when ns = nhydr or nhydx
c       and the value is negative (e.g., a negative ctb for H+ is
c       interpreted as a positive value for OH-).
c
        if (ns.ne.no2gaq .and. ns.ne.narn1)
     $  sigmst = sigmst + abs(ctb(nb))
      enddo
c
c     Compute the true and stoichiometric osmotic coefficients.
c
      osfac = -omega * log(actw)
      osc = 0.
      if (sigmam .gt. eps100) osc = osfac/sigmam
      oscst = 0.
      if (sigmst .gt. eps100) oscst = osfac/sigmst
c
c     Compute the stoichiometric ionic strength.
c
c     Calling sequence substitution:
c       fxist for fxistc
c
      call cfxist(ctb,fxist,nbaspd,nbt,nbtmax,nstmax,zchsq2)
c
c     Compute the stoichiometric ionic asymmetry.
c
c     Calling sequence substitution:
c       fjest for fjestc
c
      call cfjest(ctb,fjest,nbaspd,nbt,nbtmax,nstmax,zchcu6)
c
      call prtvpa(abar,acfw,acfwlg,actw,actwlg,a3bar,fje,
     $ fjest,fo2,fo2lg,fxi,fxist,iopg,mlmrra,mrmlra,nopgmx,noutpt,
     $ osc,oscst,qrho,rhoc,rhowc,sigmam,sigmst,tdsglw,tdspkc,
     $ tdsplc,vosol,wfh2o,wftds,woh2o,wosol,wotds,xbarw,xbrwlg)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print pH, Eh, and pe-, all with reference to
c     appropriate pH scales. Also compute and print the pHCl.
c
      qredox = .true.
c
      call gpheh(acflg,actlg,actwlg,adh,ah,ahmes,ahnbs,conc,
     $ eh,ehfac,ehmes,ehnbs,farad,fo2lg,fxi,iopg,mrmlra,nchlor,nhydr,
     $ nopgmx,noutpt,nstmax,nttyo,pch,pe,pemes,penbs,ph,phcl,phmes,
     $ phnbs,qphcl,qredox,qrho,xlke)
c
      call prpheh(ah,ahmes,ahnbs,eh,ehmes,ehnbs,iopg,
     $ nopgmx,noutpt,pch,pe,pemes,penbs,ph,phcl,phmes,phnbs,
     $ qphcl,qredox,qrho)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table of computed alkalinity parameters.
c
c     Compute the HCO3-CO3-OH total alkalinity.
c
c     Calling sequence substitutions:
c       alk1 for alkc
c       ntf1 for ntfx
c       ntf1mx for ntfxmx
c       ntf1t for ntfxt
c       tf1 for tfx
c
      call calk(alk1,conc,nstmax,ntf1,ntf1mx,ntf1t,tf1)
c
c     Compute the extended total alkalinity.
c
c     Calling sequence substitutions:
c       alk2 for alkc
c       ntf2 for ntfx
c       ntf2mx for ntfxmx
c       ntf2t for ntfxt
c       tf2 for tfx
c
      call calk(alk2,conc,nstmax,ntf2,ntf2mx,ntf2t,tf2)
c
      call prtalk(alki,alk1,alk2,mrmlra,noutpt,ntf1t,ntf2t,
     $ qrho,rho,tempc,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate and print the electrical balance and the cation and
c     anion contributions.
c
      call gszm(conc,jcsort,narn1,narn2,nstmax,sigza,sigzc,
     $ sigzi,sigzm,zchar)
c
      msigzm = 0.5*sigzm
      sanion = -sigza
c
      write (noutpt,1250)
 1250 format(/11x,'--- Electrical Balance Totals ---',//
     $ 34x,'eq/kg.H2O',/)
      write (noutpt,1260) sigzc,sanion,sigzm,msigzm,sigzi
 1260 format(8x,'Sigma(mz) cations= ',3x,1pe17.10,
     $ /9x,'Sigma(mz) anions= ',3x,1pe17.10,
     $ /13x,'Total charge= ',3x,1pe17.10,
     $ /14x,'Mean charge= ',3x,1pe17.10,
     $ /9x,'Charge imbalance= ',3x,1pe17.10)
      sx = 100.*sigzi
      pztot = sx/sigzm
      pzmean = sx/msigzm
      write (noutpt,1270) pztot,pzmean
 1270 format(//9x,'The electrical imbalance is:',
     $ //11x,f9.4,' per cent of the total charge',
     $ /11x,f9.4,' per cent of the mean charge',/)
c
c     Print results of electrical balancing.
c
      if (iebal .gt. 0) then
        ns = nbaspd(iebal)
        j2 = ilnobl(uspec(ns)(1:24))
        write (noutpt,1280) uspec(ns)(1:j2)
 1280   format(/6x,'--- Electrical Balancing on ',a,' ---')
        ux1 = uinput
        ux2 = ufinal
        ux3 = uadj
        if (jfleba .eq. 0) then
          write (noutpt,1290)
 1290     format(/17x,'mg/L',10x,'mg/kg.sol',7x,'Molality',/)
          cte = coval(iebal)
          cxw = 1000.*cte*mwtsp(ns)*wfh2o
          cxv = cxw*rho
          write (noutpt,1300) ux1,cxv,cxw,cte
 1300     format(5x,a6,f13.4,3x,f13.4,3x,1pe17.10)
          cte = ctebal
          cxw = 1000.*cte*mwtsp(ns)*wfh2o
          cxv = cxw*rho
          write (noutpt,1300) ux2,cxv,cxw,cte
          cte = ctebal - coval(iebal)
          cxw = 1000.*cte*mwtsp(ns)*wfh2o
          cxv = cxw*rho
          write (noutpt,1300) ux3,cxv,cxw,cte
        elseif (jfleba .eq. 16) then
          write (noutpt,1310)
 1310     format(/3x,'        Log Activity',/)
          axx = coval(iebal)
          axc = actlg(ns)
          write (noutpt,1320) ux1,axx
          write (noutpt,1320) ux2,axc
 1320     format(5x,a6,f13.4)
          axd = axc - axx
          write (noutpt,1320) ux3,axd
        elseif (jfleba .eq. 19) then
          write (noutpt,1312)
 1312     format(/3x,'            pX',/)
          pxx = coval(iebal)
          pxc = -actlg(ns)
          write (noutpt,1320) ux1,pxx
          write (noutpt,1320) ux2,pxc
          pxd = pxc - pxx
          write (noutpt,1320) ux3,pxd
        elseif (jfleba .eq. 20) then
          write (noutpt,1314)
 1314     format(/3x,'            pH',/)
          phx = coval(iebal)
          phc = -actlg(ns)
          write (noutpt,1320) ux1,phx
          write (noutpt,1320) ux2,phc
          phd = phc - phx
          write (noutpt,1320) ux3,phd
        elseif (jfleba .eq. 21) then
          write (noutpt,1315)
 1315     format(/3x,'            pHCl',/)
          phx = coval(iebal)
          phc = -actlg(nhydr)-actlg(nchlor)
          write (noutpt,1320) ux1,phx
          write (noutpt,1320) ux2,phc
          phd = phc - phx
          write (noutpt,1320) ux3,phd
        elseif (jfleba .eq. 22) then
          write (noutpt,1316)
 1316     format(/3x,'            pmH',/)
          phx = coval(iebal)
          phc = -conclg(ns)
          write (noutpt,1320) ux1,phx
          write (noutpt,1320) ux2,phc
          phd = phc - phx
          write (noutpt,1320) ux3,phd
        elseif (jfleba .eq. 23) then
          write (noutpt,1318)
 1318     format(/3x,'            pxH',/)
          pxx = coval(iebal)
          pxc = -conclg(ns)
          write (noutpt,1320) ux1,pxx
          write (noutpt,1320) ux2,pxc
          pxd = pxc - pxx
          write (noutpt,1320) ux3,pxd
        endif
        write (noutpt,1322)
 1322   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(5) .gt. 0) then
c
c       Compute and print activity ratios of aqueous species.
c
        call prtacr(actlg,iopr,jsflag,nbaspd,nbt,nbtmax,nelect,
     $  nhydr,noprmx,no2gaq,noutpt,nstmax,uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the aqueous species distribution.
c
      call prtaqs(acflg,actlg,conc,conclg,iopr,jcsort,narn1,
     $ narn2,noprmx,noutpt,nstmax,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(9) .gt. 0) then
c
c       Compute and print the mean ionic activities and activity
c       coefficients.
c
        call prtmip(acflg,actlg,conclg,ctb,nbaspd,nbt,nbtmax,
     $  nelect,nhydr,nhydx,noutpt,nstmax,uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the contributions of aqueous species to each mass balance.
c
      call prtpct(conc,csts,ctb,iopr,jcsort,jflag,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,nelect,nhydr,noprmx,no2gaq,noutpt,
     $ nstmax,nsts,nstsmx,nstsr,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print the state of redox reactions that are not
c     constrained to be at equilibrium.
c
      call cdardx(actlg,actwlg,ah,ahrc,cdrsd,eh,ehfac,ehrc,
     $ farad,fo2lg,fo2lrc,jsflag,mosp,nbasp,nbaspd,nbt,nbtmax,ndrsd,
     $ ndrsmx,ndrsrd,no2gaq,nstmax,pe,perc,ph,xlke,xlksd)
c
      call prtrdx(ah,ahrc,cdrsd,eh,ehrc,fo2lg,fo2lrc,jflgi,
     $ jsflag,narn1,nbasp,nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $ nelect,nhydr,no2gaq,noutpt,nstmax,pe,perc,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the saturation index for the reaction associated to
c     each species. Do this for the reactions as they were written
c     on the data file.
c
      if (nxrn1 .gt. 0) then
        do ns = nxrn1,nxrn2
          if (actlg(ns) .le. -99999.) actlg(ns) = 0.0
        enddo
      endif
c
c     Calculate affinities and saturation indices using the 'd' set
c     of reactions.
c
      call gaffsd(actlg,afcnst,affpd,affsd,cdrsd,jflagd,jpflag,
     $ ncmpr,ndrsd,ndrsmx,ndrsrd,npt,nptmax,nst,nstmax,qxknph,sidrph,
     $ sidrsp,uphase,uspec,xbar,xlksd)
c
c     Compute and print saturation index and affinity tables for
c     reactions in the aqueous phase not constrained to be at
c     equilibrium.
c
      call prtsia(affsd,jflagd,jflgi,jsflag,narn1,narn2,nbasp,
     $ nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,nhydr,noutpt,nrdxsp,
     $ nstmax,sidrsp,uspec)
c
      if (iopr(7) .ge. 0) then
c
c       Print saturation index and affinity tables for the
c       various non-aqueous phases.
c
        call prtsat(affpd,iern1,iern2,ilrn1,ilrn2,imrn1,imrn2,
     $  iopr,iopt,ixrn1,ixrn2,jpflag,noutpt,noprmx,noptmx,nptmax,
     $  sidrph,tolspf,uphase)
      endif
c
      if (iopt(4).ge.1 .and. nxti.gt.0) then
c
c       Print affinities and saturation indices for solid solutions
c       for which compositions were entered on the input file.
c
        write (noutpt,1600)
 1600   format(//16x,'--- Saturation States of Input Solid Solutions',
     $   ' ---',/)
c
        ncount = 0
        do nxi = 1,nxti
          np = npnxp(nxi)
          ncount = ncount + 1
          call prtsso(acflg,actlg,affpd,affsd,ixrn1,ixrn2,
     $    jsol,jsomax,ncmpr,noutpt,np,nptmax,nstmax,nxtmax,sidrph,
     $    sidrsp,tolspf,uspec,uphase,uxtype,xbar,xbarlg)
        enddo
        if (ncount .le. 0) write (noutpt,1710)
 1710   format(1x,'None')
      endif
c
      if (iopt(4).ge.1 .and. ixrn2.ge.ixrn1) then
c
c       Compute hypothetical saturation states for solid solutions.
c
        write (noutpt,1720)
 1720   format(/16x,'--- Saturation States of Hypothetical Solid',
     $  ' Solutions ---',/)
c
        ncount = 0
        do np = ixrn1,ixrn2
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .gt. 1) then
c
            ier = 0
            ncount = ncount + 1
c
c           Calling sequence substitutions:
c             affpd for affp
c             affsd for affs
c             cdrsd for cdrs
c             ndrsd for ndrs
c             ndrsrd for ndrsr
c             xlksd for xlks
c
            call hpsat(acflg,act,actlg,afcnst,affpd,affsd,apx,bpx,
     $      cdrsd,eps100,iapxmx,ibpxmx,ier,iktmax,ixrn1,jflag,jpflag,
     $      jsflag,jsol,ncmpr,ndrsd,ndrsmx,ndrsrd,noutpt,np,nptmax,
     $      nstmax,nttyo,nxrn1,nxrn2,nxtmax,sidrsp,sidrph,uphase,
     $      uspec,wfac,xbar,xbarlg,xlksd)
c
c           Check to see if the hypothetical affinity calculation
c           converged.
c
            if (ier .le. 0) then
              qxknph(np) = .true.
            else
              qxknph(np) = .false.
              j2 = ilnobl(uphase(np))
              write (noutpt,1730) uphase(np)(1:j2)
              write (nttyo,1730) uphase(np)(1:j2)
 1730         format(/' * Warning - (EQ3NR/scripz) The hypothetical',
     $        /7x,'affinity calculation failed for ',a,'.')
              go to 310
            endif
c
            call prtsso(acflg,actlg,affpd,affsd,ixrn1,ixrn2,
     $      jsol,jsomax,ncmpr,noutpt,np,nptmax,nstmax,nxtmax,sidrph,
     $      sidrsp,tolspf,uspec,uphase,uxtype,xbar,xbarlg)
          endif
  310    continue
        enddo
        if (ncount .le. 0) write (noutpt,1740)
 1740   format(1x,'None')
      endif
c
cXX   Temporarily suppress these tables by setting neti = 0.
cXX   Maybe reactivate them in the future.
      neti = 0
cXX
      if (neti .gt. 0) then
c
c       Print affinities and saturation indices for generic ion
c       exchangers for which compositions were entered on the input
c       file.
c
        write (noutpt,1750)
 1750   format(//11x,'--- Saturation States of Input Generic Ion',
     $   ' Exchangers ---',/)
c
        ncount = 0
        do nei = 1,neti
          np = ngexpi(nei)
          ncount = ncount + 1
c
          call prtgex(acflg,actlg,affpd,affsd,cegexs,conc,
     $    egexjc,egexjf,egexpa,egexpc,egexs,egexw,iern1,iern2,ietmax,
     $    jern1,jern2,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $    mosp,netmax,ngexsa,ngext,noutpt,np,nptmax,nstmax,sidrph,
     $    sidrsp,tolspf,ugexj,ugexmo,uspec,uphase,xbar,xbarlg,xgexw,
     $    wkgwi)
c
        enddo
        if (ncount .le. 0) write (noutpt,1760)
 1760   format(1x,'None')
      endif
c
      if (net .gt. 0) then
c
c       Print compositions of generic ion exchangers.
c
        write (noutpt,1770)
 1770   format(/11x,'--- Generic Ion Exchangers ---',/)
c
        ncount = 0
        do np = iern1,iern2
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .gt. 1) then
c
            ier = 0
            ncount = ncount + 1
c
            call prtgex(acflg,actlg,affpd,affsd,cegexs,conc,
     $      egexjc,egexjf,egexpa,egexpc,egexs,egexw,iern1,iern2,ietmax,
     $      jern1,jern2,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $      mosp,netmax,ngexsa,ngext,noutpt,np,nptmax,nstmax,sidrph,
     $      sidrsp,tolspf,ugexj,ugexmo,uspec,uphase,xbar,xbarlg,xgexw,
     $      wkgwi)
c
          endif
        enddo
        if (ncount .le. 0) write (noutpt,1790)
 1790   format(1x,'None')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(8) .ge. 0) then
c
c       Print a table of equilibrium fugacities.
c
        call prtfug(jgsort,fugac,fugalg,jsflag,ngrn1,ngt,ngtmax,
     $  noutpt,nstmax,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,2000)
 2000 format(/' - - - - - - - - - - - - - - - - - - - - - - - - - - -',
     $ ' - - - - - - - - - - - -',/)
c
      end

      subroutine minvrt(aamatr,aimatr,delvec,gmmatr,ier,ipivot,
     $ kdim,kmax,noutpt,nttyo,qpr)
c
c     This subroutine inverts the matrix aamatr. The inverted matrix
c     is returned in aimatr. Thus
c
c       [aamatr][aimatr] = I
c
c     where I is the unit matrix (1's on the diagonal, 0's elsewhere).
c
c     The method is L-U decomposition of the matrix, in combination
c     with the subsequent solution of a series of matrix equations,
c     each using the same decomposed matrix but with a different unit
c     vector as the right hand side. The original aamatr matrix is
c     preserved. The workspace vector gmmatr holds the L-U
c     decomposition.
c
c     A companion subroutine ginvrt.f has the same function as the
c     present routine. However, it assumes that aamatr has already
c     been factored into gmmatr.
c
c     This subroutine uses the following subroutines, which are
c     adaptations of 1979 Linpack subroutines of the same names:
c
c       EQLIBU/dgefa.f
c       EQLIBU/dgesl.f
c
c     The calling sequences have been preserved to facilitate
c     substituting equivalents optimized for specific platforms,
c     for anyone desiring to do so.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       aamatr = the matrix
c       kdim   = the actual dimention of the matrix
c       kmax   = the maximum dimension of the matrix
c       noutpt = the unit number of the output file
c       nttyo  = the unit number of the screen file
c       qpr    = logical switch to print messages from this subroutine
c
c     Workspace:
c
c       delvec = at one point, the right-hand-side vector; at another,
c                  the solution vector
c       gmmatr = work space for a copy of the matrix; holds the
c                  L-U decomposition
c       ipivot = the pivot vector
c
c     Output:
c
c       aimatr = the inverted matrix
c       ier    = error flag:
c                  =  1  Encountered a zero matrix
c                  =  2  Encountered a non-zero, computationally
c                          singular matrix
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax
c
      integer noutpt,nttyo
c
      integer ipivot(kmax)
      integer ier,kdim
c
      logical qpr
c
      real*8 aamatr(kmax,kmax),aimatr(kmax,kmax),gmmatr(kmax,kmax),
     $ delvec(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer info,j,k
c
c-----------------------------------------------------------------------
c
c     Copy aamatr to gmmatr.
c
      do k = 1,kdim
        do j = 1,kdim
          gmmatr(j,k) = aamatr(j,k)
        enddo
      enddo
c
c     OR
c
c     do k = 1,kdim
c       call copyaa(aamatr(1,k),gmmatr(1,k),kdim)
c     enddo
c
c     OR
c
c     integer nmax
c     nmax = kmax*kdim
c     call copyaa(aamatr,gmmatr,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Avoid trying to decompose a zero matrix.
c
      do k = 1,kdim
        do j = 1,kdim
          if (gmmatr(j,k) .ne. 0.) go to 100
        enddo
      enddo
      ier = 1
      if (qpr) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/' * Note - (EQLIBU/minvrt) Have a zero matrix to',
     $  ' invert.')
      endif
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Factor the matrix (make the L-U decomposition).
c
  100 call dgefa(gmmatr,kmax,kdim,ipivot,info)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test info.
c
      if (info .ne. 0) then
        ier = 2
        if (qpr) then
          write (noutpt,1010)
          write (nttyo,1010)
 1010     format(/' * Note - (EQLIBU/minvrt) Have a computationally',
     $    ' singular matrix.')
        endif
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Complete the inversion. Loop over columns for the inverted
c     matrix (aimatr).
c
      do k = 1,kdim
c
c       Put the corresponding unit vector in delvec. This serves to
c       set the right-hand-side vector.
c
        do j = 1,kdim
          delvec(j) = 0.
        enddo
        delvec(k) = 1.
c
c       Solve for the unknown vector (delvec). Note that delvec
c       initially contains the right-hand-side vector. Normally
c       separate arrays would be used for the two vectors. This
c       example of bad programming is made here to retain consistency
c       with the original Linpack routine.
c
        call dgesl(gmmatr,kmax,kdim,ipivot,delvec)
c
c       Load the result in the inverted matrix.
c
        do j = 1,kdim
          aimatr(j,k) = delvec(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gmdsm(conc,musum,na,natmax,nmutmx,nmxi,nmxmax,
     $ nmxx,ns,nstmax,pmu,uspec)
c
c     This subroutine computes the following second order sum used
c     in Pitzer's equations:
c
c       SUM(jk) mu(ijk)*m(j)*m(k)
c
c     where i is represented by the aqueous species index na and
c     overall species index ns.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of concentration values
c       na     = aqueous species index (i refers to ns, where ns is
c                  the corresponding species index)
c       nmxi   = range pointer array into the nmxx array:
c                  nmxi(1,na) and nmxi(2,na) are the first and last
c                  values of the second subscript (nmx) of the nmxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nmxx   = pointer array:
c                  nmxx(1,nmx) = the species index of the second
c                  species in the nmu-th triplet, nmxx(2,nmx) is the
c                  species index of the third species, and
c                  nmxx(3,nmx) = nmu
c       ns     = species index corresponding to the aqueous species
c                  index na
c       pmu    = array of mu values
c       uspec  = array of species names
c
c     Principal output:
c
c       musum  = the sum: SUM(jk) mu(ijk)*m(j)*m(k)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nmutmx,nmxmax,nstmax
c
      integer nmxi(2,natmax),nmxx(3,nmxmax)
      integer na,ns
c
      character(len=48) uspec(nstmax)
c
      real(8) conc(nstmax),pmu(nmutmx)
      real(8) musum
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ifx,ilx,nmu,nmx,ns2,ns3
c
      real(8) cx
c
c-----------------------------------------------------------------------
c
      musum = 0.
      ifx = nmxi(1,na)
      ilx = nmxi(2,na)
      if (ilx .ge. ifx) then
        do nmx = ifx,ilx
          ns2 = nmxx(1,nmx)
          ns3 = nmxx(2,nmx)
          nmu = nmxx(3,nmx)
          cx = 2.
          if (ns2 .eq. ns3) cx = 1.
          musum = musum + cx*pmu(nmu)*conc(ns2)*conc(ns3)
        enddo
      endif
c
      end

      subroutine prreac(cdrs,ndrs,ndrsmx,ndrsr,nf,ns,nstmax,uspec)
c
c     This subroutine writes the n-th reaction in a set on the file
c     whose unit number isf nf.
c
c     This subroutine is called by:
c
c       EQLIB/alters.f
c       EQLIB/echolk.f
c       EQLIB/switch.f
c       EQLIB/swtchb.f
c       EQLIB/swtchk.f
c       EQ3NR/arrsim.f
c       EQ3NR/dawfix.f
c       EQ3NR/echox.f
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrs   = the array of reaction coefficients
c       ndrs   = the array of corresponding species indices
c       ndrsmx = dimension of the cdrs and ndrs arrays
c       ndrsr  = aray giving the range in the cdrs and ndrs arrays
c                  corresponding to the reaction for a given species
c       nf     = the unit number of the file to write on
c       ns     = the index of the species whose reaction is to
c                  be written
c       uspec  = array of species names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer ndrs(ndrsmx),ndrsr(2,nstmax)
      integer nf,ns
c
      character*48 uspec(nstmax)
c
      real*8 cdrs(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,n,nr1,nr2,nss,nt
c
      logical qdtach,qfirst
c
      character*56 uspn56
c
      real*8 cx
c
c-----------------------------------------------------------------------
c
      write (nf,1000)
 1000 format(1x)
c
      nr1 = ndrsr(1,ns)
      nr2 = ndrsr(2,ns)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nt = nr2 - nr1 + 1
      if (nt .lt. 2) then
c
c       Calling sequence substitutions:
c         uspec(ns) for unam48
c
        call fmspnx(jlen,uspec(ns),uspn56)
c
        write (nf,1010) uspn56(1:jlen)
 1010   format(3x,a,' is a strict basis species and has no reaction.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qdtach = .false.
      do n = nr1 + 1,nr2
        nss = ndrs(n)
        if (nss .eq. 0) then
          qdtach = .true.
          go to 100
        endif
      enddo
  100 continue
c
      if (qdtach) then
c
c       Calling sequence substitutions:
c         uspec(ns) for unam48
c
        call fmspnx(jlen,uspec(ns),uspn56)
c
        write (nf,1020) uspn56(1:jlen)
 1020   format(3x,a,' is a detached auxiliary basis species and',
     $  ' in effect',/3x,'has no reaction.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the coefficients and names of the reactants.
c
      qfirst = .true.
      do n = nr1,nr2
        cx = -cdrs(n)
        nss = ndrs(n)
        if (cx .gt. 0.) then
c
c         Calling sequence substitutions:
c           uspec(nss) for unam48
c
          call fmspnx(jlen,uspec(nss),uspn56)
c
          if (qfirst) then
            write (nf,1030) cx,uspn56(1:jlen)
 1030       format(4x,f7.3,2x,a)
            qfirst = .false.
          else
            write (nf,1050) cx,uspn56(1:jlen)
 1050       format(2x,'+ ',f7.3,2x,a)
          endif
        endif
      enddo
c
      write (nf,1070)
 1070 format(10x,'==')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the coefficients and names of the products.
c
      qfirst = .true.
      do n = nr1,nr2
        cx = cdrs(n)
        nss = ndrs(n)
        if (cx .gt. 0.) then
c
c         Calling sequence substitutions:
c           uspec(nss) for unam48
c
          call fmspnx(jlen,uspec(nss),uspn56)
c
          if (qfirst) then
            write (nf,1030) cx,uspn56(1:jlen)
            qfirst = .false.
          else
            write (nf,1050) cx,uspn56(1:jlen)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine integr(delxi,dlxrct,drer0,nord,nrc,nrctmx,
     $ nrd1mx,rrelr0)
c
c     This subroutine integrates a Taylor's series for the relative
c     rate of a reaction to calculate the advancement in the
c     corresponding reaction progress variable (dlxrct).
c
c     This subroutine is called by:
c
c       EQ6/reacts.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = overall reaction progress variable
c       drer0  = array of derivatives of relative rates for individual
c                  irreversible reactions
c       nord   = order of the finite difference approximation
c
c     Principal output:
c
c       dlxrct = array of increments of reaction progress for
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx,nrd1mx
c
      integer nord,nrc
c
      real*8 drer0(nrd1mx,nrctmx),rrelr0(nrctmx)
      real*8 delxi,dlxrct
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n
c
      real*8 dxp
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      dlxrct = rrelr0(nrc)*delxi
      if (nord .gt. 0) then
        dxp = delxi
        do n = 1,nord
          dxp = dxp*delxi
          dlxrct = dlxrct + ( drer0(n,nrc)/fctrl(n + 1) )*dxp
        enddo
      endif
c
      end

      subroutine ldlxrc(al10,delxi,dlxmin,dzvc0,iodb,iindx1,kbt,kdim,
     $ kelect,khydr,khydx,km1,kmax,ko2gaq,krdxsp,kwater,kxt,nbasp,
     $ nbtmax,nodbmx,nord,noutpt,nrd1mx,nstmax,nttyo,qrapch,uspec,
     $ zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine limits delxi when a variable corresponding to a
c     basis species is rapidly changing. Special forms of this
c     constraint apply to the following species:
c
c       H2O
c       H+ (or OH- if that is in the basis set instead of H+)
c       O2(g,aq) (or any other auxiliary basis species such as e-,
c                 HS-, or Fe+++, which might be used as the redox
c                 defining basis species)
c
c     In tracing a reaction path, it is undesirable, for example,
c     to suddenly run out of solvent water, or to skip over a redox
c     jump, without obtaining some level of resolution. This subroutine
c     forces smaller steps to be taken to avoid such problems. Also,
c     it insures that some level of descriptive detail is obtained
c     when a signficant, abrupt change is occurring in the system.
c
c     It is not the purpose of this subroutine to produce step size
c     values that correspond exactly to the specified constraints.
c     The methodology here is rather approximate. Changes in activity
c     coefficients along the reaction path are not accounted for.
c
c     In reducing delxi, the basic approach is based only on the
c     value at the base point and the first derivative. The full power
c     of the finite difference representations is therefore not
c     brought to bear.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nodbmx,nrd1mx,nstmax
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),iindx1(kmax),nbasp(nbtmax)
c
      integer kbt,kdim,kelect,khydr,khydx,km1,ko2gaq,krdxsp,kwater,kxt,
     $ nord
c
      logical qrapch
c
      character*48 uspec(nstmax)
c
      real*8 dzvc0(nrd1mx,kmax),zvclg0(kmax),zvclg1(kmax),zvec0(kmax),
     $ zvec1(kmax)
c
      real*8 al10,delxi,dlxmin,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,kcol,nb,ns,nstep,nstepl
c
      integer ilnobl
c
      logical qztayl
c
      character*24 unamsp
c
      real*8 lobasp,lelect,lhydr,lo2gaq,lwater,lrdxsp
c
      real*8 dlxic,dlxsv,zdif,zdzid,zdzspi,zdzwa,zdzwai,zx
c
c-----------------------------------------------------------------------
c
c     Maximum number of cycles cutting the step size in this subroutine.
c
      data nstepl /20/
c
c     Change limit values.
c
      data lelect /8.0/,lhydr /0.5/,lo2gaq /8.0/,lobasp /8.0/,
     $ lrdxsp /8.0/,lwater /0.50/
c
c-----------------------------------------------------------------------
c
      qrapch = .false.
      dlxsv = delxi
      unamsp = 'Error'
      nstep = -1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here is a return point if the value of delxi has been reduced by
c     this subroutine. This provides an additional check, as the
c     step-size reduction algorithms are only approximate.
c
  100 nstep = nstep + 1
c
      if (nstep .ge. nstepl) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000) nstepl
          write (nttyo,1000) nstepl
 1000     format(/' * Note - (EQ6/ldlxrc) The step size has been cut',
     $    ' the maximum ',i2,' times',/7x,'to limit rapid change in',
     $    ' one or more of the variables associated with the',
     $    /7x,'aqueous basis species. Cutting the step size to the',
     $    ' minimum value.')
        endif
        delxi = dlxmin
        go to 990
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make a Taylor's series expansion of the z vector, without applying
c     change limits.
c
      qztayl = .false.
      call ztaylr(delxi,dzvc0,kdim,kmax,km1,kxt,nord,nrd1mx,
     $ qztayl,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kwater .gt. 0) then
c
c       Number of moles of H2O. The limit is +/- lwater %.
c
        nb = iindx1(kwater)
        ns = nbasp(nb)
        dlxic = delxi
        zdif = zvec0(kwater) - zvec1(kwater)
        zx = zdif/zvec0(kwater)
        if (abs(zx) .gt. lwater) then
c
c         The predicted change is too big. Reduce the step size.
c
          if (dzvc0(1,kwater) .ne. 0.) then
c
c           Estimate the new step size from the finite-difference
c           data.
c
            zdzwa = zvec0(kwater)/dzvc0(1,kwater)
            dlxic = lwater*abs(zdzwa)
            if (dlxic .ge. delxi) dlxic = 0.5*delxi
          else
c
c           Just cut the step size.
c
            dlxic = 0.5*delxi
          endif
          dlxic = max(dlxic,dlxmin)
          if (dlxic .lt. delxi) then
            delxi = dlxic
            unamsp = uspec(ns)
            go to 100
          endif
        endif
      endif
c
      zdzwai = dzvc0(1,kwater)/zvec0(kwater)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kwater .gt. 0) then
        if (khydr .gt. 0) then
c
c         The pH, if H+ is in the basis set. The limit is +/- lhydr
c         pH unit.
c
          nb = iindx1(khydr)
          ns = nbasp(nb)
          dlxic = delxi
          zdif = zvclg0(khydr) - zvclg1(khydr)
          if (abs(zdif) .gt. lhydr) then
c
c           The predicted change is too big. Reduce the step size.
c
            zdzspi = dzvc0(1,khydr)/zvec0(khydr)
            zdzid  = zdzspi - zdzwai
            if (zdzid .ne. 0.) then
c
c             Estimate the new step size from the finite-difference
c             data.
c
              dlxic = al10*lhydr/abs(zdzid)
              if (dlxic .ge. delxi) dlxic = 0.5*delxi
            else
c
c             Just cut the step size.
c
              dlxic = 0.5*delxi
            endif
            dlxic = max(dlxic,dlxmin)
            if (dlxic .lt. delxi) then
              delxi = dlxic
              unamsp = uspec(ns)
              go to 100
            endif
          endif
        elseif (khydx .gt. 0) then
c
c         The pH, if OH- is in the basis set instead of H+.
c         The limit is +/- lhydr pH unit.
c
          nb = iindx1(khydx)
          ns = nbasp(nb)
          dlxic = delxi
          zdif = zvclg0(khydx) - zvclg1(khydx)
          if (abs(zdif) .gt. lhydr) then
c
c           The predicted change is too big. Reduce the step size.
c
            zdzspi = dzvc0(1,khydx)/zvec0(khydx)
            zdzid  = zdzspi - zdzwai
            if (zdzid .ne. 0.) then
c
c             Estimate the new step size from the finite-difference
c             data.
c
              dlxic = al10*lhydr/abs(zdzid)
              if (dlxic .ge. delxi) dlxic = 0.5*delxi
            else
c
c             Just cut the step size.
c
              dlxic = 0.5*delxi
            endif
            dlxic = max(dlxic,dlxmin)
            if (dlxic .lt. delxi) then
              delxi = dlxic
              unamsp = uspec(ns)
              go to 100
            endif
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ko2gaq .gt. 0) then
c
c       The log fO2. The limit is +/- lo2gaq log units.
c
        nb = iindx1(ko2gaq)
        ns = nbasp(nb)
        dlxic = delxi
        zdif = zvclg0(ko2gaq) - zvclg1(ko2gaq)
        if (abs(zdif) .gt. lo2gaq) then
          if (dzvc0(1,ko2gaq) .ne. 0.) then
c
c           Estimate the new step size from the finite-difference
c           data.
c
            dlxic = al10*lo2gaq*abs(zvec0(ko2gaq)/dzvc0(1,ko2gaq))
            if (dlxic .ge. delxi) dlxic = 0.5*delxi
          else
c
c           Just cut the step size.
c
            dlxic = 0.5*delxi
          endif
          dlxic = max(dlxic,dlxmin)
          if (dlxic .lt. delxi) then
            delxi = dlxic
            unamsp = uspec(ns)
            go to 100
          endif
        endif
      endif
c
      if (kelect .gt. 0) then
c
c       The pe. The limit is +/- lelect log units.
c
        nb = iindx1(kelect)
        ns = nbasp(nb)
        dlxic = delxi
        zdif = zvclg0(kelect) - zvclg1(kelect)
        if (abs(zdif) .gt. lelect) then
          if (dzvc0(1,kelect) .ne. 0.) then
c
c           Estimate the new step size from the finite-difference
c           data.
c
            dlxic = al10*lelect*abs(zvec0(kelect)/dzvc0(1,kelect))
            if (dlxic .ge. delxi) dlxic = 0.5*delxi
          else
c
c           Just cut the step size.
c
            dlxic = 0.5*delxi
          endif
          dlxic = max(dlxic,dlxmin)
          if (dlxic .lt. delxi) then
            delxi = dlxic
            unamsp = uspec(ns)
            go to 100
          endif
        endif
      endif
c
      if (krdxsp.gt.0 .and. kwater.gt.0) then
        if (krdxsp.ne.ko2gaq .and. krdxsp.ne.kelect) then
c
c         The log molality of an auxiliary basis species. The limit is
c         +/- lrdxsp log units.
c
          nb = iindx1(krdxsp)
          ns = nbasp(nb)
          dlxic = delxi
          zdif = zvclg0(krdxsp) - zvclg1(krdxsp)
          if (abs(zdif) .gt. lrdxsp) then
            zdzspi = dzvc0(1,krdxsp)/zvec0(krdxsp)
            zdzid  = zdzspi - zdzwai
            if (zdzid .ne. 0.) then
c
c             Estimate the new step size from the finite-difference
c             data.
c
              dlxic = al10*lrdxsp/abs(zdzid)
              if (dlxic .ge. delxi) dlxic = 0.5*delxi
            else
c
c             Just cut the step size.
c
              dlxic = 0.5*delxi
            endif
            dlxic = max(dlxic,dlxmin)
            if (dlxic .lt. delxi) then
              if (dlxic .gt. dlxmin) then
                delxi = dlxic
                unamsp = uspec(ns)
                go to 100
              endif
            endif
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do kcol = 1,kbt
        if (kcol.ne.kwater .and. kcol.ne.khydr .and. kcol.ne.khydx
     $    .and. kcol.ne.krdxsp) then
c
c         The log molality of any other basis species. The limit is
c         +/- lobasp log units.
c
          nb = iindx1(kcol)
          ns = nbasp(nb)
          dlxic = delxi
          zdif = zvclg0(kcol) - zvclg1(kcol)
          if (abs(zdif) .gt. lobasp) then
            zdif = zvclg0(kcol) - zvclg1(kcol)
            if (abs(zdif) .gt. lobasp) then
              zdzspi = dzvc0(1,kcol)/zvec0(kcol)
              zdzid  = zdzspi - zdzwai
              if (zdzid .ne. 0.) then
c
c               Estimate the new step size from the finite-difference
c               data.
c
                dlxic = al10*lobasp/abs(zdzid)
                if (dlxic .ge. delxi) dlxic = 0.5*delxi
              else
c
c               Just cut the step size.
c
                dlxic = 0.5*delxi
              endif
              dlxic = max(dlxic,dlxmin)
              if (dlxic .lt. delxi) then
                delxi = dlxic
                unamsp = uspec(ns)
                go to 100
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrapch = delxi .lt. dlxsv
      if (qrapch) then
        if (iodb(5) .gt. 0) then
          j2 = ilnobl(unamsp)
          write (noutpt,1010) dlxsv,delxi,unamsp(1:j2)
          write (nttyo,1010) dlxsv,delxi,unamsp(1:j2)
 1010     format(/' * Note - (EQ6/ldlxrc) The step size has been cut',
     $    ' from ',1pe12.5,/7x,'to ',e12.5,' to limit rapid change',
     $    ' associated with ',a,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine prtfug(jgsort,fugac,fugalg,jsflag,ngrn1,ngt,ngtmax,
     $ noutpt,nstmax,uspec)
c
c     This subroutine prints a table giving the equilibrium fugacities
c     of gas species.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       fugac  = gas fugacity array
c       fugalg = gas log fugacity array
c       jsflag = species status flag array
c       ngrn1  = start of gas species range
c       ngt    = number of gas species
c       uspec  = species name array
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ngtmax,nstmax
c
      integer noutpt
c
      integer jgsort(ngtmax),jsflag(nstmax)
      integer ngrn1,ngt
c
      character*48 uspec(nstmax)
c
      real*8 fugac(ngtmax),fugalg(ngtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ncount,ng,ngg,ns
c
c-----------------------------------------------------------------------
c
      write(noutpt,1000)
 1000 format(/21x,'--- Fugacities ---',
     $ //5x,'Gas ',20x,'Log Fugacity',4x,'Fugacity',/)
c
      ncount = 0
      do ngg= ngt,1,-1
        ng = jgsort(ngg)
        ns = ngrn1 + ng - 1
        if (jsflag(ns) .lt. 2) then
          ncount = ncount + 1
          write (noutpt,1020) uspec(ns),fugalg(ng),fugac(ng)
 1020     format(3x,a24,3x,f10.5,3x,1pe12.5)
        endif
      enddo
      if (ncount .le. 0) write (noutpt,1030)
 1030 format(3x,'None')
c
      write (noutpt,1040)
 1040 format(1x)
c
      end

      subroutine chkinx(cdrs,coval,ier,irdxc3,jflag,jsflag,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,nhydr,
     $ nhydx,noutpt,no2gaq,nredox,nstmax,nttyo,tempc,ucospi,uredox,
     $ uspec,zchar)
c
c     This subroutine checks the code input for various kinds of
c     errors and inconsistencies. Here ier accumulates the
c     number of errors caught.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),jsflag(nstmax)
c
      integer nbasp(nbtmax),ncosp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer ier,irdxc3,narn1,narn2,nbt,nelect,nhydr,nhydx,no2gaq,
     $ nredox
c
      character*48 ucospi(nbtmax),uspec(nstmax)
      character*24 uredox
c
      real(8) cdrs(ndrsmx),coval(nbtmax),zchar(nstmax)
c
      real(8) tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iredox,jfl,jfl2,jlen,j2,j3,j4,n,nalk,nb,nbb,nb1,nb2,
     $ nr1,nr2,ns,nss,ns1,ns2,nt
c
      integer ilnobl,nbasis
c
      character*56 uspn56
      character*24 ux24
      character*16 ux16
c
      real(8) cx,zp
c
      real(8) coefdr
c
c-----------------------------------------------------------------------
c
      ier = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the log activity combination (jflag= 17) and
c     mean log activity (jflag= 18) options.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl.eq.17 .or. jfl.eq.18) then
          ns1 = ncosp(nb)
          if (jsflag(ns) .ne. 0) then
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
 1000       format(/" * Error - (EQ3NR/chkinx) Can't apply the jflag= ",
     $      i3,' option to',/7x,a,', because this species is',
     $      ' suppressed.')
          endif
          if (zchar(ns) .eq. 0.) then
            ier = ier + 1
            write (noutpt,1010) jfl,uspec(ns)(1:j2)
            write (nttyo,1010) jfl,uspec(ns)(1:j2)
 1010       format(/" * Error - (EQ3NR/chkinx) Can't apply the jflag= ",
     $      i3,' option to',/7x,a,', because this species has',
     $      ' zero charge.')
          endif
c
c         Calling sequence substitutions:
c           ns1 for ns
c
          nb1 = nbasis(nbasp,nbt,nbtmax,ns1)
          if (nb1 .le. 0) then
            ier = ier + 1
            j3 = ilnobl(ucospi(nb)(1:24))
            write (noutpt,1020) jfl,uspec(ns)(1:j2),ucospi(nb)(1:j3)
            write (nttyo,1020) jfl,uspec(ns)(1:j2),ucospi(nb)(1:j3)
 1020       format(/" * Error - (EQ3NR/chkinx) Can't apply the jflag= ",
     $      i3,' option to',/7x,a,", because this species isn't",
     $      ' in the basis set.')
          else
            if (jflag(ns1).le.15 .and. coval(nb1).le.0.) then
              ier = ier + 1
              j3 = ilnobl(uspec(ns1)(1:24))
              write (noutpt,1030) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
              write (nttyo,1030) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
 1030         format(/" * Error - (EQ3NR/chkinx) Can't apply the",
     $        ' jflag= ',i3,' option to',/7x,a,', because the',
     $        ' specified counter-ion ',a,/7x,"isn't present.")
            elseif (jsflag(ns1) .gt. 0) then
              ier = ier + 1
              j3 = ilnobl(uspec(ns1)(1:24))
              write (noutpt,1040) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
              write (nttyo,1040) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
 1040         format(/" * Error - (EQ3NR/chkinx) Can't apply the",
     $        ' jflag= ',i3,' option to',/7x,a,', because the',
     $        ' specified counter-ion ',a,/7x,'is suppressed.')
            endif
            if (zchar(ns1) .eq. 0.) then
              ier = ier + 1
              j3 = ilnobl(uspec(ns1)(1:24))
              write (noutpt,1050) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
              write (nttyo,1050) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
 1050         format(/" * Error - (EQ3NR/chkinx) Can't apply the",
     $        ' jflag= ',i3,' option to',/7x,a,', because the',
     $        ' specified counter-ion ',a,/7x,'has zero charge.')
            endif
            if (jfl .eq. 18) then
              zp = zchar(ns)*zchar(ns1)
              if (zp .gt. 0.) then
                ier = ier + 1
                j3 = ilnobl(uspec(ns1)(1:24))
                write (noutpt,1060) uspec(ns1)(1:j3),uspec(ns)(1:j2)
                write (nttyo,1060) jfl,uspec(ns1)(1:j3),uspec(ns)(1:j2)
 1060           format(/" * Error - (EQ3NR/chkinx) Can't apply the",
     $          ' jflag= ',i3,' option',/7x,'to the species ',a,
     $          ' because the specified counter-ion ',a,/7x,'has',
     $          ' the same charge sign.')
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the pHCl (jflag= 21) option. Note that other checks
c     have been made previously in EQ3NR/intnsp.f, where the counter-ion
c     has been identified (Cl- for H+, and vice versa).
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl .eq. 21) then
          ns1 = ncosp(nb)
          if (jsflag(ns) .ne. 0) then
c
c           The species is suppressed.
c
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
          endif
c
c         Calling sequence substitutions:
c           ns1 for ns
c
          if (jsflag(ns1) .gt. 0) then
c
c           The counter-ion is suppressed.
c
            ier = ier + 1
            j3 = ilnobl(uspec(ns1)(1:24))
            write (noutpt,1040) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
            write (nttyo,1040) jfl,uspec(ns)(1:j2),uspec(ns1)(1:j3)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the log activity (jflag= 16) and pX (jflag= 19)
c     options.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl.eq.16 .or. jfl.eq.19) then
          if (jsflag(ns) .ne. 0) then
c
c           The species is suppressed.
c
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
          endif
          if (jfl .eq. 16) then
            if (coval(nb) .gt. 3.0) then
              ier = ier + 1
              write (ux16,'(1pg12.5)') coval(nb)
              call lejust(ux16)
              j4 = ilnobl(ux16)
              write (noutpt,1120) uspec(ns)(1:j2),ux16(1:j4)
              write (nttyo,1120) uspec(ns)(1:j2),ux16(1:j4)
 1120         format(/' * Error - (EQ3NR/chkinx) The log activity of ',
     $        a,' is specified as ',/7x,a,' on the input file. This',
     $        ' is unrealistically high.',/7x,'Is the sign correct?')
            endif
          elseif (jfl .eq. 19) then
            if (coval(nb) .lt. -3.0) then
              ier = ier + 1
              write (ux16,'(1pg12.5)') coval(nb)
              call lejust(ux16)
              j4 = ilnobl(ux16)
              write (noutpt,1130) uspec(ns)(1:j2),ux16(1:j4)
              write (nttyo,1130) uspec(ns)(1:j2),ux16(1:j4)
 1130         format(/' * Error - (EQ3NR/chkinx) The pX of ',
     $        a,' is specified as ',/7x,a,' on the input file. This',
     $        ' is unrealistically low.',/7x,'Is the sign correct?')
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the pH (jflag= 20) option.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl .eq. 20) then
          if (jsflag(ns) .ne. 0) then
c
c           The species is suppressed.
c
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
          endif
          if (ns .ne. nhydr) then
            ier = ier + 1
            write (noutpt,1150) uspec(ns)(1:j2)
            write (nttyo,1150) uspec(ns)(1:j2)
 1150       format(/' * Error - (EQ3NR/chkinx) A pH value has been',
     $      ' entered on the input file',/7x,'for ',a,'. A pH value',
     $      ' can be used as a constaint only for H+.',/7x,'Use the',
     $      ' pX option (jflag= 19) to enter analogous values for',
     $      ' other species.')
          endif
          if (coval(nb) .gt. 17.0) then
            ier = ier + 1
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1160) ux16(1:j4)
            write (nttyo,1160) ux16(1:j4)
 1160       format(/' * Error - (EQ3NR/chkinx) The pH value of ',a,
     $      ' entered on the',/7x,'input file is unrealistically high.')
          elseif (coval(nb) .lt. -3.0) then
            ier = ier + 1
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1170) ux16(1:j4)
            write (nttyo,1170) ux16(1:j4)
 1170       format(/' * Error - (EQ3NR/chkinx) The pH value of ',a,
     $      ' entered on the',/7x,'input file is unrealistically low.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the pmH (jflag= 22) option.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl .eq. 22) then
          if (jsflag(ns) .ne. 0) then
c
c           The species is suppressed.
c
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
          endif
          if (ns .ne. nhydr) then
            ier = ier + 1
            write (noutpt,1250) uspec(ns)(1:j2)
            write (nttyo,1250) uspec(ns)(1:j2)
 1250       format(/' * Error - (EQ3NR/chkinx) A pmH value has been',
     $      ' entered on the input file',/7x,'for ',a,'. A pmH value',
     $      ' can be used as a constaint only for H+.',/7x,'Use the',
     $      ' pmX option (jflag= 23) to enter analogous values for',
     $      ' other species.')
          endif
          if (coval(nb) .gt. 17.0) then
            ier = ier + 1
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1260) ux16(1:j4)
            write (nttyo,1260) ux16(1:j4)
 1260       format(/' * Error - (EQ3NR/chkinx) The pmH value of ',a,
     $      ' entered on the',/7x,'input file is unrealistically high.')
          elseif (coval(nb) .lt. -3.0) then
            ier = ier + 1
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1270) ux16(1:j4)
            write (nttyo,1270) ux16(1:j4)
 1270       format(/' * Error - (EQ3NR/chkinx) The pmH value of ',a,
     $      ' entered on the',/7x,'input file is unrealistically low.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check usage of the pmX (jflag= 23) option.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        j2 = ilnobl(uspec(ns)(1:24))
        if (jfl .eq. 23) then
          if (jsflag(ns) .ne. 0) then
c
c           The species is suppressed.
c
            ier = ier + 1
            write (noutpt,1000) jfl,uspec(ns)(1:j2)
            write (nttyo,1000) jfl,uspec(ns)(1:j2)
          endif
          if (coval(nb) .lt. -3.0) then
            ier = ier + 1
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1290) uspec(ns)(1:j2),ux16(1:j4)
            write (nttyo,1290) uspec(ns)(1:j2),ux16(1:j4)
 1290       format(/' * Error - (EQ3NR/chkinx) The pmX of ',
     $      a,' is specified as ',/7x,a,' on the input file. This',
     $      ' is unrealistically low.',/7x,'Is the sign correct?')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the irdxc3 .eq. -3 option for the needed input constraints.
c
      if (irdxc3 .eq. -3) then
        if (jflag(no2gaq) .ne. 25) then
          ier = ier + 1
          write (noutpt,1540)
          write (nttyo,1540)
 1540     format(/' * Error - (EQ3NR/chkinx) The value of irdxc3 on',
     $    ' the input file',/7x,'is -3, but the jflag value for O2(g)',
     $    ' is not 25, as is required.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the irdxc3 .eq. 1 option to make sure it implies a redox
c     reaction.
c
      if (irdxc3 .ne. 1) go to 110
c
c     Calling sequence substitutions:
c       no2gaq for nse
c       nredox for ns
c
      cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,no2gaq,nredox,nstmax)
      if (cx .eq. 0.) then
        ier = ier + 1
        j2 = ilnobl(uredox)
        write (noutpt,1570) uredox(1:j2)
        write (nttyo,1570) uredox(1:j2)
 1570   format(/' * Error - (EQ3NR/chkinx) The reaction for the',
     $  ' species ',a,/7x,'is specified on the input file to',
     $  ' define the default redox condition.',/7x,'However, this',
     $  ' is not a redox reaction.')
c
c       Calling sequence substitutions:
c         noutpt for nf
c         nredox for ns
c
        call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,nredox,nstmax,uspec)
c
c       Calling sequence substitutions:
c         nttyo for nf
c         nredox for ns
c
        call prreac(cdrs,ndrs,ndrsmx,ndrsr,nttyo,nredox,nstmax,uspec)
      endif
c
c     Check for the needed input constraints on the irdxc3 .eq. 1
c     option.
c
      jfl = jflag(nredox)
      if (jfl .le. 15) then
c
c       Calling sequence substitutions:
c         nredox for ns
c
        iredox = nbasis(nbasp,nbt,nbtmax,nredox)
        if (coval(iredox) .le. 0.) then
          ier = ier + 1
          j2 = ilnobl(uredox)
          write (noutpt,1580) uredox(1:j2)
          write (nttyo,1580) uredox(1:j2)
 1580     format(/' * Error - (EQ3NR/chkinx) The species ',a," can't",
     $    /7x,'be used to define a redox couple because this species',
     $    "isn't present.")
        endif
      elseif (jfl.eq.27 .or. jfl.eq.30) then
        ier = ier + 1
        write (noutpt,1590) uredox,jfl
        write (nttyo,1590) uredox,jfl
 1590   format(/' * Error - (EQ3NR/chkinx) The reaction for the',
     $  ' species ',a,/7x,'is specified on the input file to',
     $  ' define the default redox condition.',/7x,'However, this',
     $  ' species has an illegal jflag value of ',i3,'.')
      endif
c
      nr1 = ndrsr(1,nredox)
      nr2 = ndrsr(2,nredox)
      do n = nr1,nr2
        nss = ndrs(n)
        if (nss.ne.nredox .and. nss.ne.narn1 .and. nss.ne.nhydr
     $  .and. nss.ne.nhydx .and. nss.ne.no2gaq .and. nss.ne.nelect)
     $  go to 100
      enddo
      go to 110
c
c     Calling sequence substitutions:
c       nss for ns
c
  100 nbb = nbasis(nbasp,nbt,nbtmax,nss)
      if (jflag(nss).le.15 .and. coval(nbb).le.0.) then
        ier = ier + 1
        j2 = ilnobl(uspec(nss))
        write (noutpt,1580) uspec(nss)(1:j2)
        write (nttyo,1580) uspec(nss)(1:j2)
      endif
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for negative values for non-negative coval quantities.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl .le. 15) then
          if (coval(nb).lt.0. .and. ns.ne.no2gaq) then
            ier = ier + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (ux16,'(1pg12.5)') coval(nb)
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1610) ux16(1:j4),uspec(ns)(1:j2)
            write (nttyo,1610) ux16(1:j4),uspec(ns)(1:j2)
 1610       format(/' * Error - (EQ3NR/chkinx) Have read an illegal',
     $      ' negative concentration',/7x,'(coval) value of ',a,
     $      ' from the input file for ',a,'.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for the alkalinity constraint on a species other than HCO3-
c     or CO3--.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl.ge.7 .and. jfl.le.11) then
          if (uspec(ns)(1:6).ne.'HCO3- ' .and.
     $      uspec(ns)(1:6).ne.'CO3-- ') then
            ier = ier + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1620) uspec(ns)(1:j2)
            write (nttyo,1620) uspec(ns)(1:j2)
 1620       format(/' * Error - (EQ3NR/chkinx) An illegal alkalinity',
     $      /7x,'constraint on the species ',a,' was read from the',
     $      /7x,'input file. This constraint can only be placed on',
     $      /7x,'HCO3- or CO3--.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for an alkalinity constraint on more than one species.
c
      nalk = 0
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl.ge.7 .and. jfl.le.11) then
          nalk = nalk + 1
          if (nalk .eq. 1) then
            ux24 = uspec(ns)(1:24)
          else
            ier = ier + 1
            j2 = ilnobl(ux24)
            j3 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1630) ux24(1:j2),uspec(ns)(1:j3)
            write (nttyo,1630) ux24(1:j2),uspec(ns)(1:j3)
 1630       format(/' * Error - (EQ3NR/chkinx) An alkalinity',
     $      ' constraint may only',/7x,'be applied to one species in',
     $      ' in a given problem. One was applied to',/7x,a,
     $      ', another to ',a,'. This code only accepts as input',
     $      /7x,'the total alkalinity, not partitioned forms, such',
     $      ' as the HCO3,',/7x,'CO3, and OH alkalinities.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (tempc.lt.0. .or. tempc.gt.50.) then
        do nb = 1,nbt
          ns = nbasp(nb)
          jfl = jflag(ns)
          if (jfl.ge.7 .and. jfl.le.11) then
            ier = ier + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (ux16,'(1pg8.3)') tempc
            call lejust(ux16)
            j4 = ilnobl(ux16)
            write (noutpt,1650) uspec(ns)(1:j2),ux16(1:j4)
            write (nttyo,1650) uspec(ns)(1:j2),ux16(1:j4)
 1650       format(/' * Error - (EQ3NR/chkinx) An alkalinity',
     $      ' constraint may not',/7x,'be applied to the species ',a,
     $      ' at ',a,' C. Alkalinity is',/7x,'defined in EQ3/6 only',
     $      ' in the range 0-50 C.',/)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the ncosp values for heterogeneous reaction constraints.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl .eq. 25) then
          ns1 = ncosp(nb)
c
c         Calling sequence substitutions:
c           ns for nse
c           ns1 for ns
c
          cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns,ns1,nstmax)
          if (cx.eq.0. .or. jsflag(ns1).gt.0) then
            ier = ier + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1670) uspec(ns)(1:j2)
            write (nttyo,1670) uspec(ns)(1:j2)
 1670       format(/' * Error - (EQ3NR/chkinx) The species ',a,
     $      " can't be constrained by",/7x,'the following reaction:',/)
c
c           Calling sequence substitutions:
c             noutpt for nf
c             ns1 for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns1,nstmax,uspec)
c
c           Calling sequence substitutions:
c             nttyo for nf
c             ns1 for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,nttyo,ns1,nstmax,uspec)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for illegal jflag value of 27 or 30 for any species in the
c     strict basis set.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl.eq.27 .or. jfl.eq.30) then
          nt = ndrsr(2,ns) - ndrsr(1,ns) + 1
          if (nt .lt. 2) then
            ier = ier + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1700) jfl,uspec(ns)(1:j2)
            write (nttyo,1700) jfl,uspec(ns)(1:j2)
 1700       format(/' * Error - (EQ3NR/chkinx) Have an illegal jflag',
     $      ' value of ',i3,/7x,'for ',a,'.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that no heterogeneous reaction constraint has
c     been applied more than once.
c
      do nb1 = 1,nbt
        ns1 = nbasp(nb1)
        jfl = jflag(ns1)
        if (jfl .eq. 25) then
          do nb2 = 1,nbt
            if (nb2 .ne. nb1) then
              ns2 = nbasp(nb2)
              jfl2 = jflag(ns2)
              if (jfl2 .eq. 25) then
                if (ncosp(nb1) .eq. ncosp(nb2)) then
                  ier = ier + 1
                  write (noutpt,1720)
                  write (nttyo,1720)
 1720             format(/' * Error - (EQ3NR/chkinx) The following',
     $            ' heterogeneous reaction constraint',/7x,'has been',
     $            ' used more than once:')
                endif
              endif
            endif
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that jflag(no2gaq) .ne. 25 unless irdxc3 .eq. -3.
c
      if (irdxc3 .ne. -3) then
        jfl = jflag(no2gaq)
        if (jfl .eq. 25) then
          ier = ier + 1
          write (noutpt,1750) jfl
          write (nttyo,1750) jfl
 1750     format(/' * Error - (EQ3NR/chkinx) Have a jflag value of ',i3,
     $    ' on the input file',/7x,'for "aqueous" O2(g), but irdxc3',
     $    ' is not -3 as is required.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that only legal jflag values are applied to species
c     other than aqueous species.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        if (ns.lt.narn1 .or. ns.gt.narn2) then
          jfl = jflag(ns)
          if (jfl.ne.0 .and. jfl.ne.30) then
            ier = ier + 1
c
c           Calling sequence substitutions:
c             uspec(ns) for unam48
c
            call fmspnm(jlen,uspec(ns),uspn56)
            write (noutpt,1800) jfl,uspn56(1:jlen)
            write (nttyo,1800) jfl,uspn56(1:jlen)
 1800       format(/' * Error - (EQ3NR/chkinx) An jflag value of ',i3,
     $      ' has been specified',/7x,'for ',a,'. This value may not',
     $      ' be applied to non-aqueous species.')
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      real*8 function coefel(cess,ness,nessmx,nessr,nc,ns,nstmax)
c
c     This subroutine finds the coefficient of the nc-th element
c     in the composition of the ns-th species.
c
c     This subroutine is called by:
c
c       None
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nessmx,nstmax
c
      integer ness(nessmx),nessr(2,nstmax)
      integer nc,ns
c
      real*8 cess(nessmx)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,n1,n2
c
c-----------------------------------------------------------------------
c
      coefel = 0.
      n1 = nessr(1,ns)
      n2 = nessr(2,ns)
      do n = n1,n2
        if (nc .eq. ness(n)) then
          coefel = cess(n)
          go to 999
        endif
      enddo
c
  999 continue
      end

      subroutine chksrr(delxi,dlxmin,drer0,dxval0,eps100,iodb,jreac,
     $ nodbmx,noutpt,nord,nrct,nrctmx,nrd1mx,nttyo,rrelr0,rrelrp,
     $ tolsrr,ureac,xi0,xi1,xval0)
c
c     This subroutine checks the signs of the relative rates. It finds
c     the point of reaction progress at which any relative rate of an
c     irreversible reaction becomes zero. The relative rates are
c     tracked using finite differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrctmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),jreac(nrctmx)
c
      integer nord,nrct
c
      character*24 ureac(nrctmx)
c
      real*8 drer0(nrd1mx,nrctmx),dxval0(nrd1mx),rrelr0(nrctmx),
     $ rrelrp(nrctmx)
c
      real*8 delxi,dlxmin,eps100,tolsrr,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,j2,krzero,n,nrc,nrzero
c
      integer ilnobl
c
      character*48 usearch
      character*24 unam24
c
      real*8 arrxp,atgsrr,dxp,rrx,rrx0,rrxp,tolsx,xtargv,xval
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'a relative rate changes sign                    '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is not where a relative rate is zero. The
c     magnitude of the search target is atgsrr = 0.5*tolsrr. The search
c     tolerance has the same value. Thus, in the case of a relative rate
c     going from positive to negative values, the search target is
c     -atgsrr and the interval for convergence is (-tolsrr,0.). In the
c     case of a relative rate going from negative to positive values,
c     the search target is atgsrr, and the interval for convergence is
c     (0.,tolsrr).
c
      atgsrr = 0.5*tolsrr
      tolsx = atgsrr
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for reactant relative rates changing sign',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Estimate the relative rates from Taylor's series expansions.
c
      do nrc = 1,nrct
        rrx = 0.
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
          rrx = rrelr0(nrc)
          dxp = 1.
          do n = 1,nord
            dxp = dxp*delxi
            rrx = rrx + ( drer0(n,nrc)/fctrl(n) )*dxp
          enddo
        endif
        rrelrp(nrc) = rrx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any cross-overs. Note that there are two kinds, positive to
c     negative, and negative to positive.
c
      xval = 0.
      nrzero = 0
      krzero = 0
      unam24 = ' '
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
          rrx0 = rrelr0(nrc)
          rrxp = rrelrp(nrc)
          if (rrx0 .gt. 0.) then
            if (rrxp .lt. -tolsrr) then
c
c             A case has been found in which the cross over tolerance
c             is exceeded for the positive to negative case.
c
              krzero = krzero + 1
              arrxp = -rrxp
              if (arrxp .gt. xval) then
                xval = arrxp
                nrzero = nrc
                unam24 = ureac(nrc)
                ilsign = 1
                xtargv = -atgsrr
              endif
            endif
          elseif (rrx0 .lt. 0.) then
            if (rrxp .gt. tolsrr) then
c
c             A case has been found in which the cross over tolerance
c             is exceeded for the negative to positive case.
c
              krzero = krzero + 1
              arrxp = rrxp
              if (arrxp .gt. xval) then
                xval = arrxp
                nrzero = nrc
                unam24 = ureac(nrc)
                ilsign = -1
                xtargv = atgsrr
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (krzero .gt. 0) then
        if (delxi .gt. dlxmin) then
          if (abs(xval - xtargv) .gt. tolsx) then
c
            xval0 = rrelr0(nrzero)
            do n = 1,nord
              dxval0(n) = drer0(n,nrzero)
            enddo
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 999
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (krzero .gt. 0) then
          if (abs(xval - xtargv) .le. tolsx) then
            j2 = ilnobl(unam24)
            write (noutpt,1010) unam24(1:j2),xi1,delxi
 1010       format(/" --- Taylor's series predict a zero relative",
     $      /7x,'rate for ',a,' at Xi= ',1pe11.4,',',
     $      /7x,'delxi= ',1pe11.4,' ---')
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chreal(nttyo,qrderr,ustr,var)
c
c     This subroutine reads the real*8 var from the character string
c     ustr. The string may contain non-blank characters other than the
c     real*8 number. If there is more than one real*8 number in the
c     string, only the first is read. If the string is completely blank,
c     the real*8 number is returned with a value of zero. If no real*8
c     number is present and at least one blank is present, the
c     real*8 number is returned with a value of zero.
c
c     The length of the string variable is unknown. A buffer variable
c     which is employed has a character length of ichpar. This limits
c     the size of the substring for the real*8 number.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nttyo  = unit number of the screen file
c       ustr   = the input string variable
c
c     Output:
c
c       var    = the output real*8 number
c       qrderr = logical flag, .true. if a read format error occurred
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nttyo
c
      logical qrderr
c
      character*(*) ustr
c
      real*8 var
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
      integer ichpar
c
      parameter (ichpar = 24)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iexpf,ifirst,ilettr,inum1,ipoint,ipos1,istr,
     $ ichars,j2,nchars
c
      integer ifnobl,ilnobl
c
      character*(ichpar) ux
      character*1 uc
c
      logical qsign
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c     Find the position of the first non-blank character in the
c     buffer variable.
c
      ipos1 = ifnobl(ustr)
c
      if (ipos1 .le. 0) then
        var = 0.
        go to 999
      endif
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Find the first real*8 substring. This must begin with one of the
c     following characters: .+-0123456789. The substring is considered
c     found when a number is found. If the substring begins with a
c     "+" or "-" sign, intervening blanks are permitted.
c
      ifirst = 0
      do i = ipos1,nchars
        uc(1:1) = ustr(i:i)
        if (uc.ge.'0' .and. uc.le.'9') then
          if (ifirst .eq. 0) ifirst = i
          go to 100
        elseif (uc .eq. '-') then
          ifirst = i
        elseif (uc .eq. '+') then
          ifirst = i
        elseif (uc .eq. '.') then
          if (ifirst .eq. 0) ifirst = i
        elseif (uc .ne. ' ') then
          ifirst = 0
        endif
      enddo
c
c     No real*8 number is present in the string. See if there is at
c     least one blank present.
c
      i = index(ustr,' ')
      if (i .gt. 0) then
        var = 0.
        go to 999
      endif
c
      j2 = ilnobl(ustr)
      write (nttyo,1000) ustr(1:j2)
 1000 format(/" * Error - (EQLIBU/chreal) Can't find a real*8 number",
     $ /7x,'to read from the string "',a,'".')
      qrderr = .true.
      go to 999
c
c     Copy the real*8 field into the buffer string.
c
c       ipoint = original string position containing '.'
c       iexpf  = original string position of the first character
c                  in the exponent field, normally 'e','E', 'd',
c                  or 'D', but possibly '-' or '+'
c       ilettr = original string position containing 'e','E',
c                  'd', or 'D'
c       inum1  = number of number characters in the non-exponent
c                  field
c       ichars = length of the substring containing the real*8
c                  number
c       qsign  = logical flag denoting the reading of a substring
c                containing an initial '-' or '+' sign followed
c                by zero or more blanks
c
  100 ipoint = 0
      iexpf = 0
      ilettr = 0
      inum1 = 0
      ichars = 0
      qsign = .false.
c
      do istr = ifirst,nchars
        uc(1:1) = ustr(istr:istr)
        if (uc.ge.'0' .and. uc.le.'9') then
c
c         Have encountered a number character in either the non-exponent
c         or exponent field.
c
          ichars = ichars + 1
          ux(ichars:ichars) = uc
          if (iexpf .eq. 0) inum1 = inum1 + 1
          qsign = .false.
        elseif (uc.eq.'-' .or. uc.eq.'+') then
          if (iexpf .eq. 0) then
            if (inum1 .eq. 0) then
c
c             Have encountered a '-' or '+' sign which begins the
c             non-exponent field.
c
              ichars = ichars + 1
              ux(ichars:ichars) = uc
              qsign = .true.
            else
c
c             Have encountered a '-' or '+' sign which starts
c             the exponent field.
c
              ichars = ichars + 1
              ux(ichars:ichars) = uc
              iexpf = istr
              qsign = .false.
            endif
          else
            if (istr .eq. (ilettr + 1)) then
c
c             Have a '-' or '+' sign following an 'e', 'E',
c             'd', or 'D' (in the exponent field).
c
              ichars = ichars + 1
              ux(ichars:ichars) = uc
              qsign = .false.
            else
c
c             Have encountered a second '-' or '+' sign in the
c             exponent field. Terminate the substring without it.
c
              go to 110
            endif
          endif
        elseif (uc.eq.' ') then
          if (qsign) then
c
c           Have encountered a blank between the initial '-' or
c           '+' sign and the first non-blank character in the
c           substring. Allow it in the substring.
c
            ichars = ichars + 1
            ux(ichars:ichars) = uc
          else
c
c           Have encountered an illegal blank. Terminate the
c           substring without it.
c
            go to 110
          endif
        elseif (uc .eq. '.') then
          if (iexpf .eq. 0) then
            if (ipoint .eq. 0) then
              ichars = ichars + 1
              ux(ichars:ichars) = uc
              ipoint = istr
              qsign = .false.
            else
c
c             Have encountered a second '.' in the non-exponent
c             field. Terminate the substring without it.
c
              go to 110
            endif
          else
c
c           Have encountered a '.' in the exponent field.
c           Terminate the substring without it.
c
            go to 110
          endif
        elseif (uc.eq.'e' .or. uc.eq.'E' .or. uc.eq.'d'
     $    .or. uc.eq.'D') then
          if (iexpf .eq. 0) then
c
c           Have encountered an exponent character.
c
            ichars = ichars + 1
            ux(ichars:ichars) = uc
            ilettr = istr
            iexpf = istr
            qsign = .false.
          else
c
c           Have encountered a second 'e', 'E', 'd', or 'D' in
c           the exponent field. Terminate the substring without it.
c
            go to 110
          endif
        else
c
c         Have encountered an illegal character. Terminate the
c         substring without it.
c
          go to 110
        endif
      enddo
c
c     Load blank fill.
c
  110 do i = ichars + 1,ichpar
        ux(i:i) = ' '
      enddo
c
      if (inum1 .le. 0) then
        j2 = ilnobl(ux)
        write (nttyo,1010) ux(1:j2)
 1010   format(/" * Warning - (EQLIBU/chreal) The real*8 number in",
     $  /7x,'the buffer string "',a,'" has no numbers in the',
     $  /7x,'non-exponent part.')
      endif
c
c     Read the real*8 from the string buffer.
c
      read (ux,1030,err=995) var
c
c     The format below should specify a real*8 field which matches
c     the character length of the buffer variable (ichpar).
c
 1030 format(g24.0)
      go to 999
c
  995 j2 = ilnobl(ux)
      write (nttyo,1040) ux(1:j2)
 1040 format(/" * Error - (EQLIBU/chreal) Can't read a real*8 number",
     $ /7x,'from the buffer string "',a,'" due to a formatted read',
     $ ' error.')
      qrderr = .true.
c
  999 continue
      end

      subroutine gszm(conc,jcsort,narn1,narn2,nstmax,sigza,sigzc,
     $ sigzi,sigzm,zchar)
c
c     This subroutine calculates the sums of equivalent concentrations
c     and the charge imbalance. Note that a sorted summation is
c     used.
c
c     This subroutine is called by:
c
c       EQLIB/betas.f
c       EQ3NR/arrset.f
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqeuous species; also
c                  the species index of solvent water
c       narn2  = end of the range of aqeuous species
c       zchar  = array of electrical charge numbers
c
c     Principal output:
c
c       sigza  = the sum of equivalent concentrations of aqueous
c                  anions, SUM(i) abs(z(i))m(i), for z(i) < 0
c       sigzc  = the sum of equivalent concentrations of aqueous
c                  cations, SUM(i) z(i)m(i), for z(i) > 0
c       sigzi  = the calculated charge imbalance, sigzc - sigza
c       sigzm  = the sum of equivalent concentrations of aqueous
c                  ions, sigzc + sigza
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 conc(nstmax),zchar(nstmax)
      real*8 sigza,sigzc,sigzi,sigzm
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,nnn,ns,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,ns7,nval
c
      real*8 ec,sxa,sxc,sxi,sxm
c
c-----------------------------------------------------------------------
c
c     Logically, this could be represented by:
c
c       sigzc = 0.
c       sigza = 0.
c       do ns = narn1,narn2
c         if (zchar(ns) .gt. 0.) then
c           sigzc = sigzc + conc(ns)*zchar(ns)
c         elseif (zchar(ns) .lt. 0.) then
c           sigza = sigza + abs(conc(ns)*zchar(ns))
c         endif
c       enddo
c       sigzi = sigzc - sigza
c       sigzm = sigzc + sigza
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      sigzc = 0.
      sigza = 0.
      sigzm = 0.
      sigzi = 0.
c
c     Note the use of local variables (sxc, sxa, sxi, and sxm) within
c     the loop. Note also that the loop is unrolled.
c
      sxc = 0.
      sxa = 0.
      sxi = 0.
      sxm = 0.
      nnn = narn1 - 1
      nval = narn2 - nnn
      ileft = (nval/8)*8 + nnn
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        if (zchar(ns0) .gt. 0.) then
          ec = zchar(ns0)*conc(ns0)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns0) .lt. 0.) then
          ec = - zchar(ns0)*conc(ns0)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns1 = jcsort(nss + 1)
        if (zchar(ns1) .gt. 0.) then
          ec = zchar(ns1)*conc(ns1)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns1) .lt. 0.) then
          ec = - zchar(ns1)*conc(ns1)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns2 = jcsort(nss + 2)
        if (zchar(ns2) .gt. 0.) then
          ec = zchar(ns2)*conc(ns2)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns2) .lt. 0.) then
          ec = - zchar(ns2)*conc(ns2)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns3 = jcsort(nss + 3)
        if (zchar(ns3) .gt. 0.) then
          ec = zchar(ns3)*conc(ns3)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns3) .lt. 0.) then
          ec = - zchar(ns3)*conc(ns3)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns4 = jcsort(nss + 4)
        if (zchar(ns4) .gt. 0.) then
          ec = zchar(ns4)*conc(ns4)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns4) .lt. 0.) then
          ec = - zchar(ns4)*conc(ns4)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns5 = jcsort(nss + 5)
        if (zchar(ns5) .gt. 0.) then
          ec = zchar(ns5)*conc(ns5)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns5) .lt. 0.) then
          ec = - zchar(ns5)*conc(ns5)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns6 = jcsort(nss + 6)
        if (zchar(ns6) .gt. 0.) then
          ec = zchar(ns6)*conc(ns6)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns6) .lt. 0.) then
          ec = - zchar(ns6)*conc(ns6)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
        ns7 = jcsort(nss + 7)
        if (zchar(ns7) .gt. 0.) then
          ec = zchar(ns7)*conc(ns7)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns7) .lt. 0.) then
          ec = - zchar(ns7)*conc(ns7)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        if (zchar(ns) .gt. 0.) then
          ec = zchar(ns)*conc(ns)
          sxc = sxc + ec
          sxi = sxi + ec
          sxm = sxm + ec
        elseif (zchar(ns) .lt. 0.) then
          ec = - zchar(ns)*conc(ns)
          sxa = sxa + ec
          sxi = sxi - ec
          sxm = sxm + ec
        endif
      enddo
c
      sigzc = sxc
      sigza = sxa
      sigzi = sxi
      sigzm = sxm
c
      end

      subroutine tpraz(nat,natmax,nazt,naztmx,ncvaz,nerr,noutpt,nttyo,
     $ pcvaz,qpdaz,uaqsp,uazp)
c
c     Test and process the hard core diameter (azero) and neutral
c     activity coefficient flag (insgf) data (i.e., the 'bdot' data)
c     read from the DATA0 file. Find and flag errors, such as duplication
c     of data (e.g., two entries for the same aqueous species).
c
c     Check the coverage of entered data against all aqueous solute
c     species present on the data file.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       nazt   = the number of specified hard core diameters
c       uaqsp  = array of names of aqueous species
c       uazp   = array of aqueous species names used to specify
c                  hard core diamters on the data file
c
c     Principal output:
c
c       nerr   = error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,naztmx
c
      integer noutpt,nttyo
c
      integer nat,nazt,ncvaz,nerr
c
      logical qpdaz(natmax)
c
      character*24 uaqsp(natmax),uazp(naztmx)
c
      real*8 pcvaz
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jaz,j2,j3,j4,j5,na,naz,ncount,ndupl,nlistl,nn,nodatc
c
      integer ilnobl
c
      character*24 unam
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Limit on the list of aqueous species for which no data
c     were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the qpdaz array. A value of .false. for a species
c     means that no azero or insgf data for this species were read
c     from the data file. Solvent water (the first aqueous species)
c     does not have such data, so set the flag to .true. for this
c     species.
c
      qpdaz(1) = .true.
      do na = 2,nat
        qpdaz(na) = .false.
      enddo
c
c     Check the entered azero and insgf data for aqueous species.
c
      nodatc = 0
c
      do na = 2,nat
c
c       Search for uaqsp(na) in the uazp array. That array contains
c       the aqueous species names for which azero and insgf data
c       were read from the data file.
c
        unam = uaqsp(na)
        do naz = 1,nazt
          if (unam(1:24) .eq. uazp(naz)(1:24)) go to 100
        enddo
        naz = 0
  100   continue
c
        if (naz .gt. 0) then
c
c         Have found an entry.
c
          qpdaz(na) = .true.
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jaz = naz + 1,nazt
            if (unam(1:24) .eq. uazp(jaz)(1:24)) then
              ndupl = ndupl + 1
            endif
          enddo
c
          if (ndupl .gt. 0) then
            j2 = ilnobl(unam)
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam(1:j2)
              write (nttyo,1010) unam(1:j2)
 1010         format(/' * Error - (EQPT/tpraz) Have found a duplicate',
     $        ' entry on the DATA0 file',/7x,'for the hard core',
     $        ' diameter of ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j5 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j5),unam(1:j2)
              write (nttyo,1020) ux8(1:j5),unam(1:j2)
 1020         format(/' * Error - (EQPT/tpraz) Have found ',a,
     $        ' duplicate entries on the DATA0 file',
     $        /7x,'for the hard core diameter of ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
        else
c
c         No data entry was found on the DATA0 file.
c         Note that qpdaz(na) is left with a value of .false.
c
          nodatc = nodatc + 1
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1040)
        write (nttyo,1040)
 1040   format(/' * Warning - (EQPT/tpraz) Did not find a hard core',
     $  ' diameter entry on the',/7x,'DATA0 file for any of the',
     $  ' following aqueous species:',/)
c
        ncount = 0
        do na = 1,nat
          if (.not.qpdaz(na)) then
            ncount = ncount + 1
            unam = uaqsp(na)
            j4 = ilnobl(unam)
            write (noutpt,1050) unam(1:j4)
            write (nttyo,1050) unam(1:j4)
 1050       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1060) ux8(1:j3)
          write (nttyo,1060) ux8(1:j3)
 1060     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1070)
        write (nttyo,1070)
 1070   format(1x)
      endif
c
      ncvaz = nat - nodatc - 1
      pcvaz = (100.*ncvaz)/float(nat - 1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gesum(conc,delam,elam,elsump,elsums,elsumw,
     $ fxi,narn1,narn2,nazpmx,nstmax,zchar)
c
c     This subroutine calculates three second order sums involving the
c     E-lambda function (elam) and its ionic strength derivatives
c     (delam). These are used in Pitzer's equations. These
c     sums are:
c
c       elsumw: SUM(ij) [E-lambda(ij) + I*E-lambda'(ij)]*m(i)*m(j)
c
c       elsums: SUM(ij) E-lambda'(ij)*m(i)*m(j)
c
c       elsump: SUM(ij) E-lambda''(ij)*m(i)*m(j) [Not used]
c
c     Here ij refers to any species pair, but non-zero
c     contributions only arise from cc' and aa' pairs. Note that:
c
c       elsumw = 2*
c             [SUM(c'>c) {E-theta(cc') + I*E-theta'(cc')}m(c)m(c')
c            + SUM(a'>a) {E-theta(aa') + I*E-theta'(aa')}m(a)m(a')]
c
c       elsums = 2*[SUM(c'>c) E-theta'(cc')m(c)m(c')
c                 + SUM(a'>a) E-theta'(aa')m(a)m(a')]
c
c       elsump = 2*[SUM(c'>c) E-theta''(cc')m(c)m(c')
c                 + SUM(a'>a) E-theta''(aa')m(a)m(a')] [Not used]
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of concentrations
c       elam   = array of E-lambda functions
c       delam  = array of ionic strength derivatives of E-lambda
c                  functions
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       narn1  = start of species range for aqueous solution
c       narn2  = end of species range for aqueous solution
c       zchar  = array of charges
c
c     Principal output:
c
c       elsumw = sum: SUM(ij) [ E-lambda(ij) + I*E-lambda'(ij) ]*mi*mj
c       elsums = sum: SUM(ij) E-lambda'(ij)*mi*mj
c       elsump = sum: SUM(ij) E-lambda''(ij)*mi*mj
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nazpmx,nstmax
c
      integer narn1,narn2
c
      real*8 conc(nstmax),delam(2,nazpmx,nazpmx),elam(nazpmx,nazpmx),
     $ zchar(nstmax)
      real*8 elsump,elsums,elsumw,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ijz,iz,jz,nsi,nsj
c
      real*8 cij,el,elp,elpp,zi,zj
c
c-----------------------------------------------------------------------
c
      elsumw = 0.
      elsums = 0.
      elsump = 0.
c
      do nsi = narn1,narn2
        zi = zchar(nsi)
        iz = nint(abs(zi))
        if (iz .ne. 0) then
          do nsj = narn1,narn2
            if (nsi .ne. nsj) then
              zj = zchar(nsj)
              jz = nint(abs(zj))
              if (jz .ne. 0) then
                ijz = nint(zchar(nsi)*zchar(nsj))
                if ((ijz) .gt. 0) then
                  el = elam(iz,jz)
                  elp = delam(1,iz,jz)
                  elpp = delam(2,iz,jz)
                  cij = conc(nsi)*conc(nsj)
                  elsumw = elsumw + (el + fxi*elp)*cij
                  elsums = elsums + elp*cij
                  elsump = elsump + elpp*cij
                endif
              endif
            endif
          enddo
        endif
      enddo
c
      end

      subroutine aaaeqt(usteqt,uveeqt)
c
c     EQPT: EQ3/6 Data File Preprocessor Code
c     EQ3/6 version 8.0a R43a (Patched 10/01/2009)
c
c     Last revised 04/24/02 by TJW
c
c
c     Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The Regents of
c     the University of California, Lawrence Livermore National
c     Laboratory. All rights reserved.
c
c     This work was produced at the University of California,
c     Lawrence Livermore National Laboratory (UC LLNL) under
c     contract no. W-7405-ENG-48 between the U.S. Department of
c     Energy (DOE) and The Regents of the University of California
c     (University) for the operation of UC LLNL. Copyright is
c     reserved to the University for purposes of controlled
c     dissemination, commercialization through formal licensing,
c     or other disposition under terms of Contract 48; DOE
c     policies, regulations, and orders; and U.S. statutes.
c
c
c                            DISCLAIMER
c
c     This computer code was prepared as an account of work
c     sponsored by an agency of the United States Government.
c     Neither the United States Government nor the University of
c     California nor any of their employees, makes any warranty,
c     express or implied, or assumes any liability or responsibility
c     for the accuracy, completeness, or usefulness of any
c     information, apparatus, product, or process disclosed, or
c     represents that its use would not infringe privately-owned
c     rights. Reference herein to any specific commercial products,
c     process, or service by trade name, trademark, manufacturer,
c     or otherwise, does not necessarily constitute or imply its
c     endorsement, recommendation, or favoring by the United States
c     Government or the University of California. The views and
c     opinions of authors expressed herein do not necessarily state
c     or reflect those of the United States government or the
c     University of California, and shall not be used for
c     advertising or product endorsement purposes.
c
c
c-----------------------------------------------------------------------
c
c     See the readme.txt file that came with this software for further
c     information, including contact information and references.
c
c
c-----------------------------------------------------------------------
c
c     This code is a data file preprocessor for EQ3/6. It reads a
c     primary data file (a DATA0 file) and writes a secondary,
c     unformatted data file (a DATA1 file), which can be read by
c     EQ3NR and EQ6. EQPT conducts a number of checks on the data as
c     it processes it. For example, it checks reactions for mass
c     balance and electrical balance. The code also fits interpolating
c     polynomials to temperature-dependent data that are represented
c     on a DATA0 file by values on a temperature grid. The coefficients
c     of these polynomials are written on the DATA1 file in place of
c     the original gridded data.
c
c     This code requires subroutines from the following EQ3/6 libraries:
c
c       EQLIBU
c
c
c-----------------------------------------------------------------------
c
c     This subroutine is designed to ensure that the copyright statement
c     and legal and other disclaimers appear at the beginning of the
c     concatenated source code for EQPT. Concatenation is normally
c     alphabetical, hence the form of the name. This subroutine returns
c     the stage and version numbers of this computer code.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       usteqt = EQPT stage number
c       uveeqt = EQPT version number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*8 usteqt,uveeqt
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*8 ust,uve
c
c-----------------------------------------------------------------------
c
      data ust /'R43a    '/
      data uve /'8.0a    '/
c
c-----------------------------------------------------------------------
c
      usteqt = ust
      uveeqt = uve
c
      end

      subroutine betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
c     This subroutine computes the Newton-Raphson residual functions.
c
c     This subroutine is called by:
c
c       EQLIB/newton.f
c       EQLIB/nrstep.f
c       EQ3NR/arrset.f
c       EQ6/eqcalc.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of log activity coefficients
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6NR
c
c     Principal output:
c
c       alpha  = array of raw Newton-Raphson residual functions
c       beta   = array of normalized Newton-Raphson residual functions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nstmax,nstsmx,ntfxmx
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),jcsort(nstmax),jflag(nstmax),
     $ jsflag(nstmax),jssort(nstmax),nbasp(nbtmax),ncosp(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),nsts(nstsmx),nstsr(2,nstmax),
     $ ntfx(ntfxmx)
c
      integer ibetmx,iebal,irdxc3,kbt,kdim,kelect,khydr,km1,ko2gaq,
     $ kwater,kxt,narn1,narn2,nelect,nern1,nern2,nhydr,no2gaq,nredox,
     $ nst,ntfxt
c
      logical qredox,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubbig,ubneg,ubetmx
c
      real*8 acflg(nstmax),actlg(nstmax),alpha(kmax),amtb(nbtmax),
     $ beta(kmax),cdrs(ndrsmx),conc(nstmax),conclg(nstmax),
     $ coval(nbtmax),csts(nstsmx),mtb(nbtmax),mosp(nstmax),
     $ tfx(ntfxmx),weight(nstmax),xlks(nstmax),zchar(nstmax)
c
      real*8 afcnst,bbig,betamx,bneg,eh,ehfac,fo2lg,omega,
     $ xbrwlg,xlke
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jfl,jlen,kcol,krow,n,nb,nr1,nr2,ns,nsc,nse,nss,ns1
c
      character*56 uspn56
      character*8 unone,uptgas
c
      real*8 abeta,af,alkc,atot,atx,ax,aznse,azns1,azsum,belect,bo2gaq,
     $ bx,bwater,cde,ctot,cx,c1,dx,fx,si,sigmmc,sigza,sigzc,sigzi,
     $ sigzm,sx,tx,xbarwc,xbrwlc,zp
c
      real*8 coefst,tlg
c
c-----------------------------------------------------------------------
c
      data unone  /'None    '/
      data uptgas /'Gas     '/
c
c-----------------------------------------------------------------------
c
      do krow = 1,kdim
        alpha(krow) = 0.
        beta(krow) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) go to 210
c
c     Compute residuals for EQ3NR.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        nse = nbasp(nb)
        jfl = jflag(nse)
        if (nse.ge.narn1 .and. nse.le.narn2) then
c
c         Aqueous species.
c
          if (krow.eq.kwater .and. jfl.eq.0) then
c
c           The residual for water is based on the equation which
c           defines the mole fraction of water.
c
            call csigm(conc,jcsort,narn1,narn2,nstmax,sigmmc)
            xbarwc = omega/(omega + sigmmc)
            xbrwlc = tlg(xbarwc)
            ax = xbrwlc - xbrwlg
            alpha(krow) = ax
            beta(krow) = ax
c
          elseif (nb .eq. iebal) then
c
c           Charge balance.
c
            call gszm(conc,jcsort,narn1,narn2,nstmax,sigza,sigzc,
     $      sigzi,sigzm,zchar)
            alpha(krow) = sigzi
            if (sigzm .gt. 0.) beta(krow) = sigzi/sigzm
c
          elseif (jfl .eq. 17) then
c
c           Log activity combination.
c
            ns1 = ncosp(nb)
            aznse = abs(zchar(nse))
            azns1 = abs(zchar(ns1))
            ax = coval(nb)/azns1
            zp = zchar(nse)*zchar(ns1)
            if (zp .lt. 0.) then
              ax = ax - ( aznse/azns1 )*actlg(ns1)
              else
              ax = ax + ( aznse/azns1 )*actlg(ns1)
            endif
            dx = ax - actlg(nse)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl .eq. 18) then
c
c           Mean log activity.
c
            ns1 = ncosp(nb)
            aznse = abs(zchar(nse))
            azns1 = abs(zchar(ns1))
            azsum = aznse + azns1
            ax = ( azsum*coval(nb) - aznse*actlg(ns1) )/azns1
            dx = ax/azns1 - actlg(nse)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl .eq. 21) then
c
c           pHCl.
c
            ns1 = ncosp(nb)
            aznse = abs(zchar(nse))
            azns1 = abs(zchar(ns1))
            ax = -coval(nb)/azns1
            zp = zchar(nse)*zchar(ns1)
            if (zp .lt. 0.) then
              ax = ax - ( aznse/azns1 )*actlg(ns1)
              else
              ax = ax + ( aznse/azns1 )*actlg(ns1)
            endif
            dx = ax - actlg(nse)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl.eq.25 .or. jfl.eq.27) then
c
c           Heterogeneous or homogeneous equilibrium with a specified
c           species (computing fO2 from an aqueous redox couple is not
c           done here).
c
            if (jfl .eq. 25) then
              nsc = ncosp(nb)
            else
              nsc = nse
            endif
            cx = xlks(nsc)
            nr1 = ndrsr(1,nsc)
            nr2 = ndrsr(2,nsc)
c
            do n = nr1,nr2
              nss = ndrs(n)
              if (nss .eq. nse) then
                cde = cdrs(n)
                if (nse .ne. no2gaq) cx = cx - cde*acflg(nse)
              elseif (nss .eq. nsc) then
                if (uspec(nsc)(25:32) .eq. uptgas(1:8)) then
                  cx = cx - cdrs(n)*coval(nb)
                endif
              elseif (nss .eq. no2gaq) then
                cx = cx - cdrs(n)*fo2lg
              else
                cx = cx - cdrs(n)*actlg(nss)
              endif
            enddo
c
            cx = cx/cde
            c1 = conclg(nse)
            if (nse .eq. no2gaq) c1 = fo2lg
            dx = cx - c1
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (nse .eq. no2gaq) then
c
c           log fO2.
c
            if (irdxc3 .eq. -1) then
c
c             Eh residual (Note- if a pe- value was input, it has been
c             converted to an Eh value by EQLIB/setup.f). Here it is
c             assumed that water is the first species in the aqueous
c             phase (has the index narn1).
c
              fx = 4.*eh/ehfac  + xlke + 2.*actlg(narn1)
     $        - 4.*actlg(nhydr)
              dx = fx - fo2lg
              alpha(krow) = dx
              beta(krow) = dx
c
            elseif (irdxc3 .eq. 1) then
c
c             Cross-linking (homogeneous aqueous redox) equilibrium.
c
              cx = xlks(nredox)
              nr1 = ndrsr(1,nredox)
              nr2 = ndrsr(2,nredox)
              do n = nr1,nr2
                nss = ndrs(n)
                if (nss .eq. no2gaq) then
                  cde = cdrs(n)
                else
                  cx = cx - cdrs(n)*actlg(nss)
                endif
              enddo
              cx = cx/cde
              dx = cx - fo2lg
              alpha(krow) = dx
              beta(krow) = dx
c
            else
c
c             Log fO2 is directly specified (irdxc3 = 0).
c
              alpha(krow) = 0.
              beta(krow) = 0.
            endif
          elseif (jfl.ge.7 .and. jfl.le.11) then
c
c           Alkalinity balance.
c
            call calk(alkc,conc,nstmax,ntfx,ntfxmx,ntfxt,tfx)
            atot = coval(nb)
            dx = alkc - atot
            alpha(krow) = dx
            beta(krow) = dx/atot
c
          elseif (jfl .eq. 16) then
c
c           Log activity.
c
            dx = conclg(nse) + acflg(nse) - coval(nb)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl.eq.19 .or. jfl.eq.20) then
c
c           pX (including pH).
c
            dx = conclg(nse) + acflg(nse) + coval(nb)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl.eq.22 .or. jfl.eq.23) then
c
c           pmX (including pmH).
c
            dx = conclg(nse) + coval(nb)
            alpha(krow) = dx
            beta(krow) = dx
c
          elseif (jfl.ge.0 .and. jfl.le.3) then
c
c           Mass balance.
c
            sx = 0.
            do nss = narn1,narn2
              ns = jcsort(nss)
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
              sx = sx + weight(ns)*conc(ns)
            enddo
c           do nss = nern1,nern2
c             ns = jcsort(nss)
c             weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
c             sx = sx + weight(ns)*conc(ns)
c           enddo
            ctot = coval(nb)
            dx = sx - ctot
            alpha(krow) = dx
            beta(krow) = dx/ctot
c
          else
c
c           Have found a bad jflag value.
c
c           Calling sequence substitutions:
c             uzvec1(krow) for unam48
c
            call fmspnm(jlen,uzvec1(krow),uspn56)
            write (noutpt,1000) jfl,uspn56(1:jlen)
            write (nttyo,1000) jfl,uspn56(1:jlen)
 1000       format(/' * Error - (EQLIB/betas) Programming error trap:',
     $      /7x,'Have encountered a bad jflag value of ',i3,' for',
     $      /7x,'the species ',a,'.')
            stop
          endif
c
        elseif (nse.ge.nern1 .and. nse.le.nern2) then
c
c         Generic ion exchange species.
c
          if (jfl .eq. 0) then
c
c           Mass balance.
c
            sx = 0.
c           do nss = narn1,narn2
c             ns = jcsort(nss)
c             weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
c             sx = sx + weight(ns)*conc(ns)
c           enddo
            do nss = nern1,nern2
              ns = jcsort(nss)
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
              sx = sx + weight(ns)*conc(ns)
            enddo
            ctot = coval(nb)
            dx = sx - ctot
            alpha(krow) = dx
            beta(krow) = dx/ctot
c
          else
c
c           Have found a bad jflag value.
c
c           Calling sequence substitutions:
c             uzvec1(krow) for unam48
c
            call fmspnm(jlen,uzvec1(krow),uspn56)
            write (noutpt,1000) jfl,uspn56(1:jlen)
            write (nttyo,1000) jfl,uspn56(1:jlen)
          endif
        endif
      enddo
      go to 300
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  210 continue
c
c     Compute residuals for EQ6.
c
c     Compute mass balance elements.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        nse = nbasp(nb)
c
        if ((nse.ne.no2gaq .and. nse.ne.nelect) .or. qredox) then
c
c         Note: this calculation is not made if the current basis
c         species is O2(g) or e-, and the current problem has no redox
c         aspect. In the absence of a redox aspect, the log fO2 or the
c         log a(e-) is treated as a "dead" iteration variable.
c
          sx = 0.
          do nss = 1,nst
            ns = jssort(nss)
            weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            if (weight(ns) .ne. 0.) then
              if (mosp(ns) .gt. 0.) then
                tx = weight(ns)*mosp(ns)
                sx = sx + tx
              endif
            endif
          enddo
          sx = sx - mtb(nb)
          alpha(krow) = sx
          amtb(nb) = mtb(nb)
c
          if (krow.eq.kwater .or. krow.eq.khydr .or.
     $      krow.eq.ko2gaq .or. krow.eq.kelect) then
c
c           For the species H2O, H+, OH-, O2(g,aq), and e-, compute
c           "absolute" mass balance totals defined as:
c
c             sum of positive terms + abs(sum of negative terms)
c
c           Use this to calculate the corresponding beta residuals.
c
            sx = 0.
            do nss = 1,nst
              ns = jssort(nss)
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
              tx = weight(ns)*mosp(ns)
              atx = abs(tx)
              sx = sx + atx
            enddo
            amtb(nb) = sx
          endif
c
          beta(krow) = alpha(krow)/amtb(nb)
        endif
      enddo
c
c     Compute mass action elements.
c
      do krow = km1,kxt
        ns = iindx1(krow)
        call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,ndrsmx,
     $  ndrsr,ns,nstmax,si,xlks)
        alpha(krow) = si
        beta(krow) = si
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get characteristic residual parameters.
c
c       betamx = max norm of beta
c       ubetmx = name of the corresponding species
c       bbig   = value of largest (positive) mass balance residual
c       ubbig  = name of the corresponding species
c       bneg   = value of largest (negative) mass balance residual
c       ubneg  = name of the corresponding species
c
  300 betamx = 0.
      ibetmx = 0
      ubetmx = unone
      do kcol = 1,kdim
        abeta = abs(beta(kcol))
        if (abeta .gt. betamx) then
          betamx = abeta
          ibetmx = kcol
          ubetmx = uzvec1(kcol)
        endif
      enddo
c
      bbig = 0.
      bneg = 0.
      ubbig = unone
      ubneg = unone
c
      if (.not.q6mode) then
        if (kwater .gt. 0) then
          bwater = beta(kwater)
          beta(kwater) = 0.
        endif
        if (kelect .gt. 0) then
          belect = beta(kelect)
          beta(kelect) = 0.
        endif
        if (ko2gaq .gt. 0) then
          bo2gaq = beta(ko2gaq)
          beta(ko2gaq) = 0.
        endif
      endif
c
      do kcol = 1,kbt
        nb = iindx1(kcol)
        nse = nbasp(nb)
        if (jflag(nse) .le. 15) then
          bx = beta(kcol)
          if (bx .lt. bneg) then
            bneg = bx
            ubneg = uzvec1(kcol)
          elseif (bx .gt. bbig) then
            bbig = bx
            ubbig = uzvec1(kcol)
          endif
        endif
      enddo
c
      if (.not.q6mode) then
        if (kwater .gt. 0) then
          beta(kwater) = bwater
        endif
        if (kelect .gt. 0) then
          beta(kelect) = belect
        endif
        if (ko2gaq .gt. 0) then
          beta(ko2gaq) = bo2gaq
        endif
      endif
c
      end

      subroutine wrpz23(alphca,alamaa,alamca,alamcc,alamna,alamnc,
     $ alamnn,alamn2,amuaac,amua2c,amucca,amuc2a,amunca,amun2n,
     $ amun3,ipbtmx,iaapr,icapr,iccpr,inapr,incpr,innpr,in2pr,
     $ iaactr,ia2ctr,iccatr,ic2atr,incatr,in2ntr,in3tr,jpdblo,
     $ jpfcmx,natmax,naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr,
     $ naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr,ndata1,
     $ ndat1f,noutpt,nttyo,uaqsp,uethfl)
c
c     This subroutine writes the processed Pitzer parameters (in
c     conventional lambda and mu form) on the DATA1 and DATA1F files.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       alamaa  = array of coefficients for computing lamda parameters
c                   for aa' pairs
c       alamca  = array of coefficients for computing lamda parameters
c                   for ca pairs
c       alamcc  = array of coefficients for computing lamda parameters
c                   for cc' pairs
c       alamna  = array of coefficients for computing lamda parameters
c                   for na pairs
c       alamnc  = array of coefficients for computing lamda parameters
c                   for nc pairs
c       alamnn  = array of coefficients for computing lamda parameters
c                   for nn' pairs
c       alamn2  = array of coefficients for computing lamda parameters
c                   for nn pairs
c
c       amuaac  = array of coefficients for computing mu parameters
c                   for aa'c triplets
c       amua2c  = array of coefficients for computing mu parameters
c                   for aac triplets
c       amucca  = array of coefficients for computing mu parameters
c                   for cc'a triplets
c       amuc2a  = array of coefficients for computing mu parameters
c                   for cca triplets
c       amunca  = array of coefficients for computing mu parameters
c                   for nca triplets
c       amun2n  = array of coefficients for computing mu parameters
c                   for nnn' triplets
c       amun3   = array of coefficients for computing mu parameters
c                   for nnn triplets
c
c       iaapr   = species index array for aa' pairs
c       icapr   = species index array for ca pairs
c       iccpr   = species index array for cc' pairs
c       inapr   = species index array for na pairs
c       incpr   = species index array for nc pairs
c       innpr   = species index array for nn' pairs
c       in2pr   = species index array for nn pairs
c
c       iaactr  = species index array for aa'c triplets
c       ia2ctr  = species index array for aac triplets
c       iccatr  = species index array for cc'a triplets
c       ic2atr  = species index array for cca triplets
c       incatr  = species index array for nca triplets
c       in2ntr  = species index array for nn'n triplets
c
c       naapr   = number of aa' pairs
c       ncapr   = number of ca pairs
c       nccpr   = number of cc' pairs
c       nnapr   = number of na pairs
c       nncpr   = number of nc pairs
c       nnnpr   = number of nn' pairs
c       nn2pr   = number of nn pairs
c
c       naactr  = number of aa'c triplets
c       na2ctr  = number of aac triplets
c       nccatr  = number of cc'a triplets
c       nc2atr  = number of cca triplets
c       nncatr  = number of nca triplets
c       nn2ntr  = number of nn'n triplets
c
c       ndata1 = unit number of the DATA1 file
c       ndat1f = unit number of the DATA1F file
c
c       uethfl = E-theta flag string
c       upair  = array of names in species pairs
c       utripl = array of names in species triplets
c
c     Principal output:
c
c       none
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax
c
      integer ndata1,ndat1f,noutpt,nttyo
c
      integer jpdblo
      integer naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr
      integer naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr
c
      integer iaapr(2,naapr),icapr(2,ncapr),iccpr(2,nccpr),
     $ inapr(2,nnapr),incpr(2,nncpr),innpr(2,nnnpr),in2pr(nn2pr)
      integer iaactr(3,naactr),ia2ctr(2,na2ctr),iccatr(3,nccatr),
     $ ic2atr(2,nc2atr),incatr(3,nncatr),in2ntr(2,nn2ntr),in3tr(nn3tr)
c
      character*24 uaqsp(natmax)
      character*8 uethfl
c
      real*8 alphca(ipbtmx,ncapr)
c
      real*8 alamaa(jpfcmx,0:ipbtmx,naapr),
     $ alamca(jpfcmx,0:ipbtmx,ncapr),alamcc(jpfcmx,0:ipbtmx,nccpr),
     $ alamna(jpfcmx,0:ipbtmx,nnapr),alamnc(jpfcmx,0:ipbtmx,nncpr),
     $ alamnn(jpfcmx,0:ipbtmx,nnnpr),alamn2(jpfcmx,0:ipbtmx,nn2pr)
c
      real*8 amuaac(jpfcmx,naactr),amua2c(jpfcmx,na2ctr),
     $ amucca(jpfcmx,nccatr),amuc2a(jpfcmx,nc2atr),
     $ amunca(jpfcmx,nncatr),amun2n(jpfcmx,nn2ntr),amun3(jpfcmx,nn3tr)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,jpfc,j2,j3,j4,k,n
c
      integer ilnobl
c
      character(len=16) ux16
c
      logical qnzdat
c
      character*80 ustr
      character*24 ublk24,ustp24,uend24,unam1,unam2,unam3
      character*72 uterm,utermc
c
      real*8 zero
c
c-----------------------------------------------------------------------
c
      data uend24 / 'endit.                  '  /
      data ublk24 / '                        '  /
      data ustp24 / 'stop.                   '  /
      data zero   /    0.0    /
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
      j3 = ilnobl(uend24)
      j4 = ilnobl(ustp24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (jpdblo .eq. -1) then
c
c       Old Pitzer data block organization.
c
c       Write the E-lambda flag.
c
        ustr = 'E-lambda flag = ' // uethfl
        write (ndata1) ustr
        j2 = ilnobl(ustr)
        write (ndat1f,1010) ustr(1:j2)
 1010   format('*',/a,/'*')
      else
c
c       New Pitzer data block organization.
c
c       Do not write the E-lambda flag. It is implicitly "on" in the
c       case of the new Pitzer data block organization.
c
        continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for ca pairs.
c
      write (ndat1f,1100)
 1100 format("* Coefficients for lamda(ca) parameters")
      write (ndat1f,1110) utermc
 1110 format(a72)
c
      do n = 1,ncapr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamca(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 120
            endif
          enddo
        enddo
 120    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = icapr(1,n)
          j = icapr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
 1120     format(a24,2x,a)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamca(1,0,n),alamca(1,1,n),alamca(1,2,n)
            write (ndat1f,1130) alamca(1,0,n),alamca(1,1,n),
     $      alamca(1,2,n)
 1130       format(3x,'lambda0 = ',f9.5,3x,'lambda1 = ',f9.5,
     $      3x,'lambda2 = ',f9.5)
c
            write (ndata1) alphca(1,n),alphca(2,n)
            write (ndat1f,1140) alphca(1,n),alphca(2,n)
 1140       format(25x,'alpha1 = ',f5.1,7x,'alpha2 = ',f5.1)
c
            write (ndata1) alamca(2,0,n),alamca(3,0,n)
            write (ndat1f,1150) alamca(2,0,n),alamca(3,0,n)
 1150       format(4x,'dl0/dt = ',1pe10.3,2x,'d2l0/dt2 = ',1pe10.3)
c
            write (ndata1) alamca(2,1,n),alamca(3,1,n)
            write (ndat1f,1160) alamca(2,1,n),alamca(3,1,n)
 1160       format(4x,'dl1/dt = ',1pe10.3,2x,'d2l1/dt2 = ',1pe10.3)
c
            write (ndata1) alamca(2,2,n),alamca(3,2,n)
            write (ndat1f,1170) alamca(2,2,n),alamca(3,2,n)
 1170       format(4x,'dl2/dt = ',1pe10.3,2x,'d2l2/dt2 = ',1pe10.3)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'alpha( )'
            j2 = 8
            do i = 1,ipbtmx
              write (ux16(7:7),'(i1)') i
              write (ndata1) ux16,alphca(i,n)
              write (ndat1f,'(2x,a," = ",1pe12.5)')
     $        ux16(1:j2),alphca(i,n)
            enddo
c
            ux16 = 'lambda( )'
            j2 = 9
            do i = 0,ipbtmx
              write (ux16(8:8),'(i1)') i
              write (ndata1) ux16
              write (ndat1f,'(2x,a,":")') ux16(1:j2)
              do j = 1,jpfcmx
                write (ndata1) alamca(j,i,n)
                write (ndat1f,'(4x,"a",i1," = ",1pe15.8)')
     $          j,alamca(j,i,n)
              enddo
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
 1180     format(a72)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for nn pairs.
c
      write (ndat1f,1200)
 1200 format("* Coefficients for lamda(nn) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nn2pr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamn2(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 130
            endif
          enddo
        enddo
 130    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = in2pr(n)
          unam1 = uaqsp(i)
          unam2 = unam1
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamn2(1,0,n),alamn2(1,1,n),alamn2(1,2,n)
            write (ndat1f,1130) alamn2(1,0,n),alamn2(1,1,n),
     $      alamn2(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamn2(2,0,n),alamn2(3,0,n)
            write (ndat1f,1150) alamn2(2,0,n),alamn2(3,0,n)
c
            write (ndata1) alamn2(2,1,n),alamn2(3,1,n)
            write (ndat1f,1160) alamn2(2,1,n),alamn2(3,1,n)
c
            write (ndata1) alamn2(2,2,n),alamn2(3,2,n)
            write (ndat1f,1170) alamn2(2,2,n),alamn2(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamn2(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamn2(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for nc pairs.
c
      write (ndat1f,1210)
 1210 format("* Coefficients for lamda(nc) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nncpr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamnc(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 140
            endif
          enddo
        enddo
 140    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = incpr(1,n)
          j = incpr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamnc(1,0,n),alamnc(1,1,n),alamnc(1,2,n)
            write (ndat1f,1130) alamnc(1,0,n),alamnc(1,1,n),
     $      alamnc(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamnc(2,0,n),alamnc(3,0,n)
            write (ndat1f,1150) alamnc(2,0,n),alamnc(3,0,n)
c
            write (ndata1) alamnc(2,1,n),alamnc(3,1,n)
            write (ndat1f,1160) alamnc(2,1,n),alamnc(3,1,n)
c
            write (ndata1) alamnc(2,2,n),alamnc(3,2,n)
            write (ndat1f,1170) alamnc(2,2,n),alamnc(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamnc(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamnc(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for na pairs.
c
      write (ndat1f,1220)
 1220 format("* Coefficients for lamda(na) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nnapr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamna(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 150
            endif
          enddo
        enddo
 150    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = inapr(1,n)
          j = inapr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamna(1,0,n),alamna(1,1,n),alamna(1,2,n)
            write (ndat1f,1130) alamna(1,0,n),alamna(1,1,n),
     $      alamna(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamna(2,0,n),alamna(3,0,n)
            write (ndat1f,1150) alamna(2,0,n),alamna(3,0,n)
c
            write (ndata1) alamna(2,1,n),alamna(3,1,n)
            write (ndat1f,1160) alamna(2,1,n),alamna(3,1,n)
c
            write (ndata1) alamna(2,2,n),alamna(3,2,n)
            write (ndat1f,1170) alamna(2,2,n),alamna(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamna(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamna(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for nn' pairs.
c
      write (ndat1f,1230)
 1230 format("* Coefficients for lamda(nn') parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nnnpr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamnn(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 160
            endif
          enddo
        enddo
 160    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = innpr(1,n)
          j = innpr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamnn(1,0,n),alamnn(1,1,n),alamnn(1,2,n)
            write (ndat1f,1130) alamnn(1,0,n),alamnn(1,1,n),
     $      alamnn(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamnn(2,0,n),alamnn(3,0,n)
            write (ndat1f,1150) alamnn(2,0,n),alamnn(3,0,n)
c
            write (ndata1) alamnn(2,1,n),alamnn(3,1,n)
            write (ndat1f,1160) alamnn(2,1,n),alamnn(3,1,n)
c
            write (ndata1) alamnn(2,2,n),alamnn(3,2,n)
            write (ndat1f,1170) alamnn(2,2,n),alamnn(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamnn(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamnn(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) uend24,ublk24,ublk24
      write (ndat1f,1270) uend24(1:j3)
 1270 format(a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for cc' pairs.
c
      write (ndat1f,1320)
 1320 format("* Coefficients for lamda(cc') parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nccpr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamcc(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 170
            endif
          enddo
        enddo
 170    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = iccpr(1,n)
          j = iccpr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamcc(1,0,n),alamcc(1,1,n),alamcc(1,2,n)
            write (ndat1f,1130) alamcc(1,0,n),alamcc(1,1,n),
     $      alamcc(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamcc(2,0,n),alamcc(3,0,n)
            write (ndat1f,1150) alamcc(2,0,n),alamcc(3,0,n)
c
            write (ndata1) alamcc(2,1,n),alamcc(3,1,n)
            write (ndat1f,1160) alamcc(2,1,n),alamcc(3,1,n)
c
            write (ndata1) alamcc(2,2,n),alamcc(3,2,n)
            write (ndat1f,1170) alamcc(2,2,n),alamcc(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamcc(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamcc(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the lambda set for aa' pairs.
c
      write (ndat1f,1330)
 1330 format("* Coefficients for lamda(aa') parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,naapr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do i = 0,ipbtmx
          do jpfc = 1,jpfcmx
            if (alamaa(jpfc,i,n) .ne. 0.) then
              qnzdat = .true.
              go to 180
            endif
          enddo
        enddo
 180    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = iaapr(1,n)
          j = iaapr(2,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
c
          write (ndata1) unam1,unam2
          j2 = ilnobl(unam2)
          write (ndat1f,1120) unam1,unam2(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) alamaa(1,0,n),alamaa(1,1,n),alamaa(1,2,n)
            write (ndat1f,1130) alamaa(1,0,n),alamaa(1,1,n),
     $      alamaa(1,2,n)
c
c           No alpha parameters for this kind of pair.
c
            write (ndata1) zero,zero
            write (ndat1f,1140) zero, zero
c
            write (ndata1) alamaa(2,0,n),alamaa(3,0,n)
            write (ndat1f,1150) alamaa(2,0,n),alamaa(3,0,n)
c
            write (ndata1) alamaa(2,1,n),alamaa(3,1,n)
            write (ndat1f,1160) alamaa(2,1,n),alamaa(3,1,n)
c
            write (ndata1) alamaa(2,2,n),alamaa(3,2,n)
            write (ndat1f,1170) alamaa(2,2,n),alamaa(3,2,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'lambda(0)'
            j2 = 9
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) alamaa(j,0,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,alamaa(j,0,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) uend24,ublk24,ublk24
      write (ndat1f,1270) uend24(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for cca triplets.
c
      write (ndat1f,1340)
 1340 format("* Coefficients for mu(cca) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nc2atr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amuc2a(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 220
          endif
        enddo
 220    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = ic2atr(1,n)
          k = ic2atr(2,n)
          unam1 = uaqsp(i)
          unam2 = unam1
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
 1370     format(a24,2x,a24,2x,a)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amuc2a(1,n),amuc2a(2,n),amuc2a(3,n)
            write (ndat1f,1380) amuc2a(1,n),amuc2a(2,n),amuc2a(3,n)
 1380       format(5x,'mummx = ',f9.5,2x,'dmummx/dt = ',1pe10.3,
     $      2x,'d2mummx/dt2 = ',1pe10.3)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amuc2a(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amuc2a(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for aac triplets.
c
      write (ndat1f,1430)
 1430 format("* Coefficients for mu(aac) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,na2ctr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amua2c(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 230
          endif
        enddo
 230    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = ia2ctr(1,n)
          k = ia2ctr(2,n)
          unam1 = uaqsp(i)
          unam2 = unam1
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amua2c(1,n),amua2c(2,n),amua2c(3,n)
            write (ndat1f,1380) amua2c(1,n),amua2c(2,n),amua2c(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amua2c(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amua2c(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
       endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) uend24,ublk24,ublk24
      write (ndat1f,1270) uend24(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for cc'a triplets.
c
      write (ndat1f,1470)
 1470 format("* Coefficients for mu(cc'a) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nccatr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amucca(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 240
          endif
        enddo
 240    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = iccatr(1,n)
          j = iccatr(2,n)
          k = iccatr(3,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amucca(1,n),amucca(2,n),amucca(3,n)
            write (ndat1f,1380) amucca(1,n),amucca(2,n),amucca(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amucca(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amucca(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for aa'c triplets.
c
      write (ndat1f,1490)
 1490 format("* Coefficients for mu(aa'c) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,naactr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amuaac(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 260
          endif
        enddo
 260    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = iaactr(1,n)
          j = iaactr(2,n)
          k = iaactr(3,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amuaac(1,n),amuaac(2,n),amuaac(3,n)
            write (ndat1f,1380) amuaac(1,n),amuaac(2,n),amuaac(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amuaac(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amuaac(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for nnn triplets.
c
      write (ndat1f,1510)
 1510 format("* Coefficients for mu(nnn) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nn3tr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amun3(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 270
          endif
        enddo
 270    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = in3tr(n)
          unam1 = uaqsp(i)
          unam2 = unam1
          unam3 = unam1
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amun3(1,n),amun3(2,n),amun3(3,n)
            write (ndat1f,1380) amun3(1,n),amun3(2,n),amun3(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amun3(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amun3(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for nnn' triplets.
c
      write (ndat1f,1520)
 1520 format("* Coefficients for mu(nnn') parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nn2ntr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amun2n(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 280
          endif
        enddo
 280    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = in2ntr(1,n)
          k = in2ntr(2,n)
          unam1 = uaqsp(i)
          unam2 = unam1
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amun2n(1,n),amun2n(2,n),amun2n(3,n)
            write (ndat1f,1380) amun2n(1,n),amun2n(2,n),amun2n(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amun2n(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amun2n(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the mu set for nca triplets.
c
      write (ndat1f,1530)
 1530 format("* Coefficients for mu(nca) parameters")
      write (ndat1f,1110) utermc
c
      do n = 1,nncatr
c
c       Are there any non-zero data?
c
        qnzdat = .false.
        do jpfc = 1,jpfcmx
          if (amunca(jpfc,n) .ne. 0.) then
            qnzdat = .true.
            go to 290
          endif
        enddo
 290    continue
c
        if (qnzdat) then
c
c         Write a block.
c
          i = incatr(1,n)
          j = incatr(2,n)
          k = incatr(3,n)
          unam1 = uaqsp(i)
          unam2 = uaqsp(j)
          unam3 = uaqsp(k)
c
          write (ndata1) unam1,unam2,unam3
          j2 = ilnobl(unam3)
          write (ndat1f,1370) unam1,unam2,unam3(1:j2)
c
          if (jpdblo .eq. -1) then
c
c           Old Pitzer data block organization.
c
            write (ndata1) amunca(1,n),amunca(2,n),amunca(3,n)
            write (ndat1f,1380) amunca(1,n),amunca(2,n),amunca(3,n)
          else
c
c           New Pitzer data block organization.
c
            ux16 = 'mu'
            j2 = 2
            write (ndata1) ux16
            write (ndat1f,'(2x,a,":")') ux16(1:j2)
            do j = 1,jpfcmx
              write (ndata1) amunca(j,n)
              write (ndat1f,'(4x,"a",i1," = ",1pe15.8)') j,amunca(j,n)
            enddo
          endif
c
c         Write the block terminator.
c
          write (ndata1) uterm
          write (ndat1f,1180) uterm
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) uend24,ublk24,ublk24
      write (ndat1f,1270) uend24(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) ustp24,ublk24,ublk24
      write (ndat1f,1270) ustp24(1:j4)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine rd3d8b(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $ ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $ jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $ netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $ noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $ nxmod,nxti,nxtimx,pei,press,qend,qrderr,rho,scamas,tdspkg,
     $ tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,ugexj,
     $ ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,uredox,
     $ usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,xbari,
     $ xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
c
c     This subroutine reads the EQ3NR input file in menu-style ("D")
c     format for version 8.0.
c
c     This subroutine is a near-clone of EQ3NR/rd3ind.f. However, the
c     present subroutine embodies only a pure read function (it does
c     only minimal checking of what is read, to ensure that what
c     follows is readable). EQ3NR/rd3ind.f differs in that it also
c     writes an instant echo of what is read to the EQ3NR output file.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/rd3inw.f, EQ3NR/rd3ind.f, and XCON3/rd3w8.f.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ninpts = unit number of the stripped input file
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       qrderr = flag denoting a read error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,noptmx,
     $ ntitmx,nxmdmx,nxicmx,nxtimx
c
      integer ninpts,noutpt,nttyo
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jgext(netmax),jgexti(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ncmpri(2,nxtimx),ngexrt(jetmax,netmax),ngexti(jetmax,netmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,jpres3,nbti,net,neti,nobswt,
     $ nprob,nsbswt,ntitl,nxmod,nxti
c
      logical qend,qrderr
c
      character*80 utitl(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ucospi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uspeci(nbtmax),uxmod(nxmdmx)
      character*24 ugexmo(netmax),ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),umemi(nxicmx),usoli(nxtimx)
      character*24 uebal,uredox
      character*8 ugexj(jetmax,netmax),ugexji(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real*8 cgexj(jetmax,netmax),cgexpi(netmax),covali(nbtmax),
     $ egexsi(ietmax,jetmax,netmax),mwtges(netmax),tgexp(netmax),
     $ xbari(nxicmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xvfgex(ietmax,jetmax,netmax),
     $ xlkmod(nxmdmx),zgexj(jetmax,netmax),xgexsi(ietmax,jetmax,netmax)
c
      real*8 ehi,fo2lgi,pei,press,rho,scamas,tdspkg,tdspl,tempc,tolbt,
     $ toldl,tolspf
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlj8.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
c       nfldpa = maximum number of fields per line
c       nlchpa = character length of a line
c
      integer nfldpa,nlchpa
c
      parameter (nfldpa = 8,nlchpa = 80)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,iei,ii,ival,ivar,j,je,jei,jj,jlast,j2,j3,j4,j5,
     $ k1,k2,k3,k4,kxmd,n,nbi,ne,nei,nfldmx,nfldt,nfldtx,nlchmx,nmark,
     $ nn,nnn,nobsw,nsbsw,nxi,nxic
c
      integer ilnobl
c
      logical qgexef,qmark,qnone,qnonei,qnonep,qnones,qnoner,
     $ qokay,qstop
c
      character*(nlchpa) ufield(nfldpa)
      character*(nlchpa) uline1,uline2,ulscr
      character*(nlchpa) uheadr,uheadx
c
      character*80 ustr
      character*48 ux48
      character*24 ustr24,ustrn
      character*1 ux1
c
      real*8 var
c
c-----------------------------------------------------------------------
c
c     The following is a bit of nonsense so compiler warnings will
c     not be generated saying that nprob is not used.
c
      n = nprob
      nprob = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nfldmx = nfldpa
      nlchmx = nlchpa
c
      qrderr = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check some dimensioning parameters.
c
      qstop = .false.
c
      if (ndbxpa .ne. nodbmx) then
        write (nttyo,3000) ndbxpa,nodbmx
 3000   format(/' * Error - (XCON3/rd3d8b) The dimensioning parameter',
     $  ' for the',/7x,'number of iodb debugging print option switches',
     $  ' with string definitions',/7x,'(ndbxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (nodbpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (npgxpa .ne. nopgmx) then
        write (nttyo,3010) npgxpa,nopgmx
 3010   format(/' * Error - (XCON3/rd3d8b) The dimensioning parameter',
     $  ' for the',/7x,'number of iopg activity coefficient option',
     $  ' switches with string definitions',/7x,'(npgxpa) has a value',
     $  ' of ' ,i3,', but the dimensioning',/7x,'parameter for the',
     $  ' number of such switches (nopgpa) has a',/7x,'value of ',i3,
     $  '.')
        qstop = .true.
      endif
c
      if (nprxpa .ne. noprmx) then
        write (nttyo,3020) nprxpa,noprmx
 3020   format(/' * Error - (XCON3/rd3d8b) The dimensioning parameter',
     $  ' for the',/7x,'number of iopr print option switches',
     $  ' with string definitions',/7x,'(nprxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noprpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (nptxpa .ne. noptmx) then
        write (nttyo,3030) nptxpa,noptmx
 3030   format(/' * Error - (XCON3/rd3d8b) The dimensioning parameter',
     $  ' for the',/7x,'number of iopt model option switches',
     $  ' with string definitions',/7x,'(nptxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noptpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (qstop) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Title.
c
      qend = .false.
c
c     Read the first line of the file. This must be a separator line
c     ("|----- ... -----|").
c
      read (ninpts,1000,end=100,err=990) uline1
 1000 format(a80)
      if (uline1(1:8) .ne. '|-------') then
        j2 = ilnobl(uline1)
        j2 = min(j2,70)
        write (nttyo,1010) uline1(1:j2)
 1010   format(/' * Error - (XCON3/rd3d8b) The first line of a "D"',
     $  ' format input file',/7x,'should be a separator line;',
     $  ' therefore, it should begin with',/7x,'"|-------". The first',
     $  ' line begins instead with',/7x,'"',a,'".')
        go to 990
      endif
      go to 105
c
  100 qend = .true.
      go to 999
c
  105 continue
c
c     Read the block title ("Title") from a two-line header.
c
      uheadx = 'Title'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Now read the title itself.
c
      n = 0
      do nn = 1,ntitmx + 1
        read (ninpts,1000,err=990) uline1
        call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
        ustr = ufield(1)
c
c       A separator line terminates the this block. It is not part
c       of the title itself.
c
        if (ustr(1:8) .eq. '--------') go to 120
c
        n = n + 1
c
        if (n .gt. ntitmx) then
          write (nttyo,1015) ntitmx
 1015     format(/' * Error - (XCON3/rd3d8b) Have too many lines in',
     $    /7x,'the title. The code is only dimensioned for ',i4,
     $    /7x,'lines. Reduce the size of the title or increase the',
     $    /7x,'dimensioning parameter ntitpa.')
          go to 990
        endif
c
        utitl(n) = ufield(1)
      enddo
c
  120 ntitl = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
c     Read the block title from a two-line header.
c
      uheadx = 'Special Basis Switches'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nsbsw = 0
      do n = 1,nbtmax + 1
c
c       Read a line. If the block has not been completely read,
c       this contains the name of a species to "Replace", and a
c       sub-block for that species follows. Otherwise, this line is
c       the first line of the next block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        uheadx = 'Replace'
        call locase(ustr)
        call locase(uheadx)
        j2 = ilnobl(ustr)
        j3 = ilnobl(uheadx)
c
        if (ustr(1:j2) .ne. uheadx(1:j3)) then
c
c         Back up.
c
          backspace ninpts
          go to 125
        endif
c
        ustr = ufield(2)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        qnone = ustr(1:5).eq.'None '
c
        if (.not.qnone) then
          nsbsw = nsbsw + 1
          usbsw(1,nsbsw) = ufield(2)
        endif
c
c       Read the name of the "with" species from a two-line header.
c
        uheadx = 'with'
        nfldtx = 3
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        if (.not.qnone) usbsw(2,nsbsw) = ufield(2)
      enddo
  125 nsbswt = nsbsw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
      tempc = 0.
c
c     Read the data from a two-line header.
c
      uheadx = 'Temperature (C)'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      tempc = var
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
      jpres3 = 0
      press = 0.
      icount = 0
c
c     Read a one-line header.
c
      uheadx = 'Pressure option (jpres3):'
      nfldtx = 1
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the first option from a data line.
c
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 0) Data file reference'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
 1020   format(/' * Error - (XCON3/rd3d8b) Was expecting to find a',
     $  ' line beginning with',/7x,'"',a,'", instead found one',
     $  ' beginning with',/7x,'"',a,'".')
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
 1022   format(/' * Error - (XCON3/rd3d8b) Was expecting to find an',
     $  /7x,'option check box "[ ]" in the line beginning with',
     $  /7x,'"',a,'".')
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        jpres3 = 0
        press = 0.
        icount = icount + 1
      endif
c
c     Read the second option from a data line.
c
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 1) 1.013-bar/steam-sat'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        jpres3 = 1
        press = 0.
        icount = icount + 1
      endif
c
c     Read the third (last) option from a two-line combination
c     (a data line plus a separator line).
c
      nfldtx = 3
      call rdd2l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 2) Value (bars)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        jpres3 = 2
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        press = var
        icount = icount + 1
      endif
c
      if (icount .eq. 0) then
        write (nttyo,1024)
 1024   format(/' * Note - (XCON3/rd3d8b) No option was selected for',
     $  ' the pressure.',/7x,'The pressure will be set to be in',
     $  ' accord with the',/7x,'data file reference pressure curve.')
        jpres3 = 0
        press = 0.
      elseif (icount .gt. 1) then
        write (nttyo,1026)
 1026   format(/' * Warning - (XCON3/rd3d8b) Multiple options were',
     $  ' selected for',/7x,'the pressure. The pressure will be set',
     $  ' to be in accord with the',/7x,'data file reference pressure',
     $  ' curve.')
        jpres3 = 0
        press = 0.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Density.
c
      rho = 0.
c
c     Read the data from a two-line header.
c
      uheadx = 'Density'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      rho = var
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Total dissolved solutes.
c
      itdsf3 = 0
      tdspkg = 0.
      tdspl = 0.
      icount = 0
c
c     Read the data from a two-line header.
c
      uheadx = 'Total dissolved solutes option (itdsf3):'
      nfldtx = 1
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the first option from a data line.
c
      nfldtx = 3
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 0) Value (mg/kg.sol)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        itdsf3 = 0
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tdspkg = var
        icount = icount + 1
      endif
c
c     Read the second (last) option from a two-line combination
c     (a data line plus a separator line).
c
      nfldtx = 3
      call rdd2l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 1) Value (mg/L)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        itdsf3 = 1
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tdspl = var
        icount = icount + 1
      endif
c
      if (icount .eq. 0) then
        write (nttyo,1034)
 1034   format(/' * Note - (XCON3/rd3d8b) No option was selected',
     $  ' for the total',/7x,'dissolved solutes (TDS). The TDS will',
     $  ' be set to 0 mg/kg.sol.')
        itdsf3 = 0
        tdspl = 0.
        tdspkg = 0.
      elseif (icount .gt. 1) then
        write (nttyo,1036) tdspkg
 1036   format(/' * Warning - (XCON3/rd3d8b) Multiple options were',
     $  ' selected for the',/7x,'total dissolved solutes (TDS).',
     $  ' The TDS will be set to',/7x,g12.5,' mg/kg.sol.')
        itdsf3 = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Electrical balancing species.
c
      iebal3 = 0
      uebal = ' '
      icount = 0
c
c     Read a one-line header.
c
      uheadx = 'Electrical balancing option (iebal3):'
      nfldtx = 1
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the first option from a data line.
c
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 0) No balancing is don'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        iebal3 = 0
        uebal = 'None'
        icount = icount + 1
      endif
c
c     Read the second (last) option from a two-line combination
c     (a data line plus a separator line).
c
      nfldtx = 3
      call rdd2l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 1) Balance on species'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        iebal3 = 1
        ustr = ufield(2)
        uebal = ustr
        icount = icount + 1
      endif
c
      if (icount .eq. 0) then
        write (nttyo,1044)
 1044   format(/' * Note - (XCON3/rd3d8b) No electrical balancing',
     $  ' option was',/7x,'selected. No balancing will be done.')
        iebal3 = 0
        uebal = 'None'
      elseif (icount .gt. 1) then
        write (nttyo,1046)
 1046   format(/' * Warning - (XCON3/rd3d8b) Multiple electrical',
     $  ' balancing options.',/7x,'were selected. No balancing',
     $  ' will be done.')
        iebal3 = 0
        uebal = 'None'
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Default redox constraint.
c
      irdxc3 = 0
      fo2lgi = 0.
      ehi = 0.
      pei = 0.
      uredox = ' '
      icount = 0
c
c     Read a one-line header.
c
      uheadx = 'Default redox constraint (irdxc3):'
      nfldtx = 1
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the first option from a data line.
c
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '(-3) Use O2(g) line in t'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        irdxc3 = -3
        icount = icount + 1
      endif
c
c     Read the second option from a data line.
c
      nfldtx = 3
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '(-2) pe (pe units)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        irdxc3 = -2
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        pei = var
        icount = icount + 1
      endif
c
c     Read the third option from a data line.
c
      nfldtx = 3
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '(-1) Eh (volts)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        irdxc3 = -1
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        ehi = var
        icount = icount + 1
      endif
c
c     Read the fourth option from a data line.
c
      nfldtx = 3
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 0) Log fO2 (log bars)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        irdxc3 = 0
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        fo2lgi = var
        icount = icount + 1
      endif
c
c     Read the fifth (last) option from a two-line combination
c     (a data line plus a separator line).
c
      nfldtx = 3
      call rdd2l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      ustr24 = ustr(5:29)
      uheadx = '( 1) Couple (aux. sp.)'
      call locase(ustr24)
      call locase(uheadx)
      j2 = ilnobl(ustr24)
      j3 = ilnobl(uheadx)
      if (ustr24(1:j2) .ne. uheadx(1:j3)) then
        write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
        qrderr = .true.
        go to 999
      endif
      if (ustr(1:1).ne.'[' .or. ustr(3:3).ne.']') then
        j2 = ilnobl(ustr)
        j2 = min(j2,70)
        write (nttyo,1022) ustr(1:j2)
        qrderr = .true.
        go to 999
      endif
      ux1 = ustr(2:2)
      if (ux1.eq.'*' .or. ux1.eq.'x' .or. ux1.eq.'X') then
        irdxc3 = 1
        ustr = ufield(2)
        uredox = ustr
        icount = icount + 1
      endif
c
      if (icount .eq. 0) then
        write (nttyo,1047) fo2lgi
 1047   format(/' * Note - (XCON3/rd3d8b) No default redox constraint',
     $  ' option was',/7x,'selected. A default condition of log fO2= ',
     $  g12.5,' (log bars) will be used.')
        irdxc3 = 0
      elseif (icount .gt. 1) then
        write (nttyo,1048)
 1048   format(/' * Warning - (XCON3/rd3d8b) Multiple default redox',
     $  ' constraint options.',/7x,'were selected. The last option',
     $  ' that was selected will be used.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous basis species and associated constraints.
c
c     Read the first part of the block title from a one-line header.
c
      uheadx = 'Aqueous Basis Species/Constraint Species'
      nfldtx = 3
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the second part of the block title from a two-line header.
c
      uheadx = '(uspeci(n)/ucospi(n))'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nbi = 0
c
c     Read the first data line.
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
c     The label below marks a return point for processing subsequent
c     lines in the current data block.
c
  130 ustr = ufield(1)
c
c     There are no data remaining in the current block if a
c     separator line has been encountered.
c
      if (ustr(1:8) .eq. '--------') go to 180
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) then
        j2 = ilnobl(uline1)
        j2 = min(j2,70)
        write (nttyo,1030) nfldt,nfldtx,uline1(1:j2)
 1030   format(/' * Warning - (XCON3/rd3d8b) Found ',i2,' fields',
     $  ' where ',i2,/7x,'were expected on the line which begins with',
     $  /7x,'"',a,'".')
      endif
      ux48 = ufield(1)
c
      nbi = nbi + 1
c
      if (nbi .gt. nbtmax) then
        j2 = ilnobl(ux48)
        write (nttyo,1050) nbtmax,ux48(1:j2)
 1050   format(/' * Error - (XCON3/rd3d8b) The number of basis',
     $  ' species read',/7x,'from the input file exceeded the',
     $  ' maximum of ',i3,' while',/7x,'trying to read data for',
     $  ' the species ',a,'.',/7x,'Increase the dimensioning',
     $  ' parameter nbtpar.')
        go to 990
      endif
c
      uspeci(nbi) = ux48
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      covali(nbi) = var
c
      ustr = ufield(3)
      call locase(ustr)
c
      do n = -1,njfxpa
        uheadx = ujf3(n)
        call locase(uheadx)
        if (ustr(1:16) .eq. uheadx(1:16)) then
          jflgi(nbi) = n
          go to 150
        endif
      enddo
c
      j2 = ilnobl(ustr)
      write (nttyo,1060) ustr(1:j2)
 1060 format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $ ' jflag option string',/7x,' "',a,'". This should',
     $ ' be one of the strings defined in the',/7x,'ujf3 array.')
      go to 990
c
  150 if (jflgi(nbi).eq.17 .or. jflgi(nbi).eq.18 .or.
     $ jflgi(nbi).eq.25) then
c
c       Have an option that requires a second line of data to
c       complete the constraint.
c
        nfldtx = 3
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(1)
        uheadx = '->'
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
        ustr = ufield(2)
        ucospi(nbi)(1:48) = ustr
      endif
c
c     Read the next data line. Go back to process it.
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      go to 130
c
  180 continue
      nbti = nbi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation. This section reads the directives for
c     creating ion exchange phases and species and their associated
c     intrinsic (including thermodynamic) properties. The data is
c     essentially that which might be read from a supporting data file.
c     Scenario-specific data (e.g., a specified amount of exchanger or
c     a specific composition for an exchanger phase) are not included
c     in this section.
c
      net = 0
      qnonep = .false.
c
c     Read a two-line header for the block.
c
      uheadx = 'Create Ion Exchangers'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on exchanger phases.
c
      ne = 0
      do nn = 1,netmax + 1
c
c       Read a line. If the block has not been completely read,
c       this contains the name of an exchanger phase, and a sub-block
c       for that phase follows. Otherwise, this line is the first line
c       of the next block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        uheadx = 'Exchanger phase'
        call locase(ustr)
        call locase(uheadx)
        j2 = ilnobl(ustr)
        j3 = ilnobl(uheadx)
c
        if (ustr(1:j2) .ne. uheadx(1:j3)) then
c
c         Back up.
c
          backspace ninpts
          go to 240
        endif
c
        ustr = ufield(2)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        qnonep = ustr(1:5).eq.'None '
c
        if (.not.qnonep) then
          net = net + 1
          ne = ne + 1
c
          if (ne .gt. netmax) then
            write (nttyo,1620) netmax,ne
 1620       format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'generic ion exchange phases',
     $      ' while reading the data to create',/7x,'such phases.',
     $      ' Increase the dimensioning parameter netpar',/7x,'to at',
     $      ' least ',i3,'.')
            go to 990
          endif
c
          ugexp(ne) = ustr
          jgext(ne) = 0
        endif
c
c       Read the separator line following the data line containing
c       the name of an exchanger phase.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(1)
        uheadx = '--------'
        if (ustr24(1:8) .ne. uheadx(1:8)) then
          j2 = ilnobl(uline1)
          j2 = min(j2,70)
          write (nttyo,1070) uline1(1:j2)
 1070     format(/' * Error - (XCON3/rd3d8b) Read the following line',
     $    ' where a separator line',/7x,'("|------- ... -------|")',
     $    ' was expected:',/7x,'"',a,'".')
          qrderr = .true.
          go to 999
        endif
c
c       Read the molecular weight of the bare exchange ligand (Z)
c       from a two-line header.
c
        uheadx = '->'
        nfldtx = 4
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $   nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(2)
        uheadx = 'Mol. Wt. (Z)'
        call locase(ustr24)
        call locase(uheadx)
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
        ustr = ufield(3)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        if (.not.qnonep) mwtges(ne) = var
c
c       Read the exchange model name from a two-line header.
c
        uheadx = '->'
        nfldtx = 4
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $   nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(2)
        uheadx = 'Exchange model'
        call locase(ustr24)
        call locase(uheadx)
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
        if (.not.qnonep) ugexmo(ne) = ufield(3)
c
c       Read the reference temperature (C) for the thermodynamic
c       data from a two-line header.
c
        uheadx = '->'
        nfldtx = 4
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $   nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        ustr = ufield(3)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        ustr24 = ufield(2)
        uheadx = 'Ref. Temp. (C)'
        call locase(ustr24)
        call locase(uheadx)
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
        if (.not.qnonep) tgexp(ne) = var
c
c       Loop on exchange sites.
c
        je = 0
        do jj = 1,jetmax + 1
c
c         Read a line. If the sub-block (for the current exchanger
c         phase) has not been completely read, this contains the name
c         of an exchange site, and a sub-sub-block for that site
c         follows. Otherwise, this line is the first line of the next
c         sub-block (for the next exchanger phase).
c
          nfldtx = 0
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
          ustr = ufield(1)
          uheadx = '->'
          call locase(ustr)
          call locase(uheadx)
          j2 = ilnobl(ustr)
          j3 = ilnobl(uheadx)
          if (ustr(1:j2) .eq. uheadx(1:j3)) then
            ustr24 = ufield(2)
            uheadx = 'Exchange site'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
c
            ustr = ufield(3)
            ustrn = ustr
            call locase(ustrn)
            if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ')
     $      ustr = 'None'
            qnones = ustr(1:5).eq.'None '
c
            qokay = .not.qnones .and. .not.qnonep
            if (qokay) then
c
c             Have found another exchange site sub-sub-block.
c
              jgext(ne) = jgext(ne) + 1
              je = je + 1
c
              if (je .gt. jetmax) then
                j2 = ilnobl(ugexp(ne))
                write (nttyo,1710) jetmax,ugexp(ne)(1:j2),je
 1710           format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $          ' maximum number of ',i3,/7x,'exchange sites on a',
     $          ' generic ion exchange phase while reading',/7x,'the',
     $          ' data to create ',a,'. Increase the',
     $          /7x,'dimensioning parameter jetpar to at least ',i3,'.')
                go to 990
              endif
c
              ugexj(je,ne) = ufield(3)
              ngexrt(je,ne) = 0
            endif
          else
c
c           Back up.
c
            backspace ninpts
c
            ustr = ufield(1)
            uheadx = 'Exchanger phase'
            call locase(ustr)
            call locase(uheadx)
            j2 = ilnobl(ustr)
            j3 = ilnobl(uheadx)
            if (ustr(1:j2) .eq. uheadx(1:j3)) then
c
c             Have found another exchanger phase.
c
              go to 230
            endif
c
c           Have found the end of the current block.
c
            go to 240
          endif
c
c         Read the separator line following the data line containing
c         the name of an exchange site.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
          ustr24 = ufield(1)
          uheadx = '--------'
          if (ustr24(1:8) .ne. uheadx(1:8)) then
            j2 = ilnobl(uline1)
            j2 = min(j2,70)
            write (nttyo,1070) uline1(1:j2)
            qrderr = .true.
            go to 999
          endif
c
c         Read the site stoichiometric number (moles of site per mole
c         of bare exchange ligand) from a two-line header.
c
          uheadx = '--->'
          nfldtx = 4
          call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
          if (qrderr) go to 999
          ustr24 = ufield(2)
          uheadx = 'Stoich. number'
          call locase(ustr24)
          call locase(uheadx)
          j2 = ilnobl(ustr24)
          j3 = ilnobl(uheadx)
          if (ustr24(1:j2) .ne. uheadx(1:j3)) then
            write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
            qrderr = .true.
            go to 999
          endif
          ustr = ufield(3)
          call chreal(nttyo,qrderr,ustr,var)
          if (qrderr) go to 999
          if (qokay) cgexj(je,ne) = var
c
c         Read the intrinsic electrical charge of the site (charge
c         number for one mole of site) from a two-line header.
c
          uheadx = '--->'
          nfldtx = 4
          call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
          if (qrderr) go to 999
          ustr24 = ufield(2)
          uheadx = 'Electr. charge'
          call locase(ustr24)
          call locase(uheadx)
          j2 = ilnobl(ustr24)
          j3 = ilnobl(uheadx)
          if (ustr24(1:j2) .ne. uheadx(1:j3)) then
            write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
            qrderr = .true.
            go to 999
          endif
          ustr = ufield(3)
          call chreal(nttyo,qrderr,ustr,var)
          if (qrderr) go to 999
          if (qokay) zgexj(je,ne) = var
c
c         Loop on exchange reactions.
c
          n = 0
          do nnn = 1,ietmax + 1
c
c           Read a line. If the sub-sub-block (for the current
c           exchange site) has not been completely read, this contains
c           a string denoting an exchange reaction in condensed format,
c           and a sub-sub-sub-block for that reaction follows.
c           Otherwise, this line is the first line of the next
c           sub-sub-block (for the next site) or the first line of the
c           next sub-block for the next exchanger phase).
c
            nfldtx = 0
            call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uline1,ulscr)
            if (qrderr) go to 999
            ustr = ufield(1)
            uheadx = '--->'
            call locase(ustr)
            call locase(uheadx)
            j2 = ilnobl(ustr)
            j3 = ilnobl(uheadx)
            if (ustr(1:j2) .eq. uheadx(1:j3)) then
              ustr24 = ufield(2)
              uheadx = 'Reaction'
              call locase(ustr24)
              call locase(uheadx)
              j2 = ilnobl(ustr24)
              j3 = ilnobl(uheadx)
              if (ustr24(1:j2) .ne. uheadx(1:j3)) then
                write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
                qrderr = .true.
                go to 999
              endif
c
              ustr = ufield(3)
              ustrn = ustr
              call locase(ustrn)
              if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ')
     $        ustr = 'None'
              qnoner = ustr(1:5).eq.'None '
c
              qokay = .not.qnoner .and. .not.qnones .and. .not.qnonep
              if (qokay) then
c
c               Have found another exchange reaction sub-sub-sub-block.
c
                ngexrt(je,ne) = ngexrt(je,ne) + 1
                n = n + 1
c
                if (n .gt. ietmax) then
                  j2 = ilnobl(ugexp(ne))
                  j3 = ilnobl(ugexj(ne,ne))
                  write (nttyo,1820) netmax,ugexj(je,ne)(1:j3),
     $            ugexp(ne)(1:j2),n
 1820             format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $            ' maximum number of ',i3,/7x,'reactions for a site',
     $            ' belonging to a generic ion exchange',/7x,'phase',
     $            ' while reading the data for site ',a,' of exchange'
     $            ' phase',/7x,a,'. Increase the dimensioning',
     $            ' parameter',/7x,'ietpar to at least ',i3,'.')
                  go to 990
                endif
c
                ugexr(n,je,ne) = ufield(3)
              endif
            else
c
c             Back up.
c
              backspace ninpts
c
              ustr = ufield(1)
              uheadx = '->'
              call locase(ustr)
              call locase(uheadx)
              j2 = ilnobl(ustr)
              j3 = ilnobl(uheadx)
              if (ustr(1:j2) .eq. uheadx(1:j3)) then
                ustr = ufield(2)
                uheadx = 'Exchange site'
                call locase(ustr)
                call locase(uheadx)
                j2 = ilnobl(ustr)
                j3 = ilnobl(uheadx)
                if (ustr(1:j2) .eq. uheadx(1:j3)) then
c
c                 Have found another exchanger site.
c
                  go to 220
                endif
              endif
              ustr = ufield(1)
              uheadx = 'Exchanger phase'
              call locase(ustr)
              call locase(uheadx)
              j2 = ilnobl(ustr)
              j3 = ilnobl(uheadx)
              if (ustr(1:j2) .eq. uheadx(1:j3)) then
c
c               Have found another exchanger phase.
c
                go to 230
              endif
c
c             Have found the end of the current block.
c
              go to 240
            endif
c
c           Read the separator line following the data line containing
c           the string containing an exchange reaction in condensed
c           format.
c
            nfldtx = 1
            call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uline1,ulscr)
            if (qrderr) go to 999
            ustr24 = ufield(1)
            uheadx = '--------'
            if (ustr24(1:8) .ne. uheadx(1:8)) then
              j2 = ilnobl(uline1)
              j2 = min(j2,70)
              write (nttyo,1070) uline1(1:j2)
              qrderr = .true.
              go to 999
            endif
c
c           Read the table header for the thermodynamic data for the
c           current exchange reaction from a two-line header.
c
            uheadx = '----->'
            nfldtx = 5
            call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
            if (qrderr) go to 999
            ustr24 = ufield(2)
            uheadx = 'Parameter'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
c
c           Read the log K/Delta G data for the reaction from a
c           one-line header.
c
            uheadx = '----->'
            nfldtx = 5
            call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uline1,ulscr)
            if (qrderr) go to 999
            ustr24 = ufield(2)
            uheadx = 'K func.'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
            ustr = ufield(3)
            call chreal(nttyo,qrderr,ustr,var)
            if (qrderr) go to 999
            if (qokay) then
              xlkgex(n,je,ne) = var
              uxkgex(n,je,ne) = ufield(4)
            endif
c
c           Read the Delta H data for the reaction from a one-line
c           header.
c
            uheadx = '----->'
            nfldtx = 5
            call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uline1,ulscr)
            if (qrderr) go to 999
            ustr24 = ufield(2)
            uheadx = 'DelH0r'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
            ustr = ufield(3)
            call chreal(nttyo,qrderr,ustr,var)
            if (qrderr) go to 999
            if (qokay) then
              xhfgex(n,je,ne) = var
              uhfgex(n,je,ne) = ufield(4)
            endif
c
c           Read the Delta V data for the reaction from a two-line
c           header. The separator line completes the sub-sub-sub-block.
c
            uheadx = '----->'
            nfldtx = 5
            call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
            if (qrderr) go to 999
            ustr24 = ufield(2)
            uheadx = 'DelV0r'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
            ustr = ufield(3)
            call chreal(nttyo,qrderr,ustr,var)
            if (qrderr) go to 999
            if (qokay) then
              xvfgex(n,je,ne) = var
              uvfgex(n,je,ne) = ufield(4)
            endif
c
          enddo
  220     continue
        enddo
  230   continue
      enddo
  240 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified generic ion exchanger compositions.
c
      neti = 0
      qnonep = .false.
c
c     Read a two-line header for the block.
c
      uheadx = 'Ion Exchanger Compositions'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on exchanger phases.
c
      nei = 0
      do nn = 1,netmax + 1
c
c       Read a line. If the block has not been completely read,
c       this contains the name of an exchanger phase, and a sub-block
c       for that phase follows. Otherwise, this line is the first line
c       of the next block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        ustr = ufield(1)
        uheadx = 'Exchanger phase'
        call locase(ustr)
        call locase(uheadx)
        j2 = ilnobl(ustr)
        j3 = ilnobl(uheadx)
c
        if (ustr(1:j2) .ne. uheadx(1:j3)) then
c
c         Back up.
c
          backspace ninpts
          go to 340
        endif
c
        ustr = ufield(2)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        qnonep = ustr(1:5).eq.'None '
c
        if (qnonep) then
          qgexef = .true.
        else
          neti = neti + 1
          nei = nei + 1
c
          if (nei .gt. netmax) then
            write (nttyo,1930) netmax,nei
 1930       format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'generic ion exchange phases',
     $      ' while reading the data for concentrations',7x,'and',
     $      ' compositions of such phases. Increase the dimensioning',
     $      /7x,'parameter netpar to at least ',i3,'.')
            go to 990
          endif
c
          ugexpi(nei) = ustr
          j3 = ilnobl(ugexpi(nei))
          jgexti(nei) = 0
c
c         Find the corresponding ne index.
c
          do ne = 1,net
            j2 = ilnobl(ugexp(ne))
            if (ugexp(nei)(1:j3) .eq. ugexp(ne)(1:j2)) go to 250
          enddo
c
          write (nttyo,1932) ugexpi(nei)(1:j3)
 1932     format(/' * Error - (XCON3/rd3d8b) Data are present on the',
     $    ' input file for the',/7x,'generic ion exchange phase "',a,
     $    '", but this phase',/7x,"hasn't been previously defined.",
     $    " Can't determine the requisite model,",/7x,"therefore can't",
     $    ' finish reading the current data for this phase.')
          qrderr = .true.
          stop
c
  250     j2 = ilnobl(ugexmo(ne))
          if (ugexmo(ne)(1:j2) .eq. 'Gapon' .or.
     $      ugexmo(ne)(1:6) .eq. 'Gapon-' .or.
     $      ugexmo(ne)(1:j2) .eq. 'Vanselow' .or.
     $      ugexmo(ne)(1:9) .eq. 'Vanselow-') then
c
c           Input composition is described in terms of equivalent
c           fractions on the sites.
c
            qgexef = .true.
          else
c
c           Input composition is described in terms of mole fractions
c           on the sites.
c
            qgexef = .false.
          endif
        endif
c
c       Read the separator line following the data line containing
c       the name of an exchanger phase.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(1)
        uheadx = '--------'
        if (ustr24(1:8) .ne. uheadx(1:8)) then
          j2 = ilnobl(uline1)
          j2 = min(j2,70)
          write (nttyo,1070) uline1(1:j2)
          qrderr = .true.
          go to 999
        endif
c
c       Read the concentration of the exchanger phase (moles/kg.H2O)
c       from a two-line header.
c
        uheadx = '->'
        nfldtx = 4
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $   nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(2)
        uheadx = 'Moles/kg.H2O'
        call locase(ustr24)
        call locase(uheadx)
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
        ustr = ufield(3)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        if (.not.qnonep) cgexpi(nei) = var
c
c       Loop on exchange sites.
c
        jei = 0
        do jj = 1,jetmax + 1
c
c         Read a line. If the sub-block (for the current exchanger
c         phase) has not been completely read, this contains the name
c         of an exchange site, and a sub-sub-block for that site
c         follows. Otherwise, this line is the first line of the next
c         sub-block (for the next exchanger phase).
c
          nfldtx = 0
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          ustr = ufield(1)
          uheadx = '->'
          call locase(ustr)
          call locase(uheadx)
          j2 = ilnobl(ustr)
          j3 = ilnobl(uheadx)
          if (ustr(1:j2) .eq. uheadx(1:j3)) then
            ustr24 = ufield(2)
            uheadx = 'Exchange site'
            call locase(ustr24)
            call locase(uheadx)
            j2 = ilnobl(ustr24)
            j3 = ilnobl(uheadx)
            if (ustr24(1:j2) .ne. uheadx(1:j3)) then
              write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
              qrderr = .true.
              go to 999
            endif
c
            ustr = ufield(3)
            ustrn = ustr
            call locase(ustrn)
            if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ')
     $      ustr = 'None'
            qnones = ustr(1:5).eq.'None '
c
            qokay = .not.qnones .and. .not.qnonep
            if (qokay) then
c
c             Have found another exchange site sub-sub-block.
c
              jgexti(ne) = jgexti(ne) + 1
              jei = jei + 1
c
              if (jei .gt. jetmax) then
                j2 = ilnobl(ugexpi(nei))
                write (nttyo,2000) jetmax,ugexpi(nei)(1:j2),jei
 2000           format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $          ' maximum number of ',i3,/7x,'exchange sites on a',
     $          ' generic ion exchange phase while reading',/7x,'the',
     $          ' data for the concentration and composition of',
     $          /7x,a,'. Increase the dimensioning parameter jetpar',
     $          /7x,'to at least ',i3,'.')
                go to 990
              endif
c
              ugexji(jei,nei) = ufield(3)
              ngexti(jei,nei) = 0
            endif
          else
c
c           Back up.
c
            backspace ninpts
c
            ustr = ufield(1)
            uheadx = 'Exchanger phase'
            call locase(ustr)
            call locase(uheadx)
            j2 = ilnobl(ustr)
            j3 = ilnobl(uheadx)
            if (ustr(1:j2) .eq. uheadx(1:j3)) then
c
c             Have found another exchanger phase.
c
              go to 330
            endif
c
c           Have found the end of the current block.
c
            go to 340
          endif
c
c         Read the separator line following the data line containing
c         the name of an exchange site.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
          ustr24 = ufield(1)
          uheadx = '--------'
          if (ustr24(1:8) .ne. uheadx(1:8)) then
            j2 = ilnobl(uline1)
            j2 = min(j2,70)
            write (nttyo,1070) uline1(1:j2)
            qrderr = .true.
            go to 999
          endif
c
c         Read a table header for the exchange site composition from
c         from a two-line header.
c
          uheadx = '--->'
          nfldtx = 4
          call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
          if (qrderr) go to 999
          ustr24 = ufield(2)
          uheadx = 'Exchange species'
          call locase(ustr24)
          call locase(uheadx)
          j2 = ilnobl(ustr24)
          j3 = ilnobl(uheadx)
          if (ustr24(1:j2) .ne. uheadx(1:j3)) then
            write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
            qrderr = .true.
            go to 999
          endif
c
c         Check the measure of concentration: equivalent fraction
c         versus mole fraction.
c
          ustr24 = ufield(3)
c
          if (qnonep) then
            if (ustr24(1:10) .eq. 'Mole frac.') then
              ustr24 = 'Eq. frac.'
            endif
          endif
c
          if (qgexef) then
            uheadx = 'Eq. frac.'
          else
            uheadx = 'Mole frac.'
          endif
          j2 = ilnobl(ustr24)
          j3 = ilnobl(uheadx)
          if (ustr24(1:j2) .ne. uheadx(1:j3)) then
            write (nttyo,2010) uheadx(1:j3),ustr24(1:j2)
 2010       format(/' * Error - (XCON3/rd3d8b) Was expecting to find',
     $      ' a line containing',/7x,'"',a,'", instead found one',
     $      ' containing "',a,'".')
            if (.not.qnonep) then
              j4 = ilnobl(ugexmo(ne))
              j5 = ilnobl(ugexpi(nei))
              write (nttyo,2012) ugexmo(ne)(1:j4),ugexpi(nei)(1:j5)
 2012         format(7x,'The former is required for the ',a,
     $        ' exchange model,',/7x,'which was specified for',
     $        ' the generic ion exchange phase',/7x,a,'.')
            endif
            qrderr = .true.
            go to 999
          endif
c
c         Loop on exchange species.
c
          iei = 0
          do ii = 1,ietmax + 1
c
c           Read a line. If the sub-sub-block (for the current
c           exchange site) has not been completely read, this contains
c           the name of the exchange species and its mole fraction.
c           Otherwise, this line is the first line of the next
c           sub-sub-block (for the next site) or the first line of the
c           next sub-block for the next exchanger phase).
c
            nfldtx = 0
            call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $      nttyo,qrderr,ufield,uline1,ulscr)
            if (qrderr) go to 999
            ustr = ufield(1)
            uheadx = '--->'
            call locase(ustr)
            call locase(uheadx)
            j2 = ilnobl(ustr)
            j3 = ilnobl(uheadx)
c
            if (ustr(1:j2) .eq. uheadx(1:j3)) then
              ustr = ufield(2)
              ustrn = ustr
              call locase(ustrn)
              if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ')
     $        ustr = 'None'
              qnonei = ustr(1:5).eq.'None '
c
              qokay = .not.qnonei .and. .not.qnones .and. .not.qnonep
              if (qokay) then
c
c               Have found another exchange species line.
c
                ngexti(jei,nei) = ngexti(jei,nei) + 1
                iei = iei + 1
c
                if (iei .gt. ietmax) then
                  write (nttyo,2040) ietmax,ugexji(jei,nei),
     $            ugexpi(nei),iei
 2040             format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $            ' maximum number of ',i3,/7x,'species on an exchange',
     $            ' site of a generic ion exchange phase',/7x,'while',
     $            ' reading',/7x,'the data for the composition of',
     $            ' site ',a,' of',/7x,'exchange phase ',a,'. Increase',
     $            ' the dimensioning parameter ietpar to at least ',
     $            i3,'.')
                  go to 990
                endif
c
                ugexsi(iei,jei,nei) = ufield(2)
                ustr = ufield(3)
                call chreal(nttyo,qrderr,ustr,var)
                if (qrderr) go to 999
c
c               Check the array name noted: egexsi versus xgexsi.
c
                ustr24 = ' '
                k2 = index(uline1,'egexsi')
                k3 = index(uline1,'xgexsi')
                if (k2 .gt. 0) ustr24 = 'egexsi'
                if (k3 .gt. 0) ustr24 = 'xgexsi'
                if (qgexef) then
                  uheadx = 'egexsi'
                else
                  uheadx = 'xgexsi'
                endif
                j2 = ilnobl(ustr24)
                j3 = ilnobl(uheadx)
                j4 = ilnobl(ugexmo(ne))
                j5 = ilnobl(ugexpi(nei))
                if (ustr24(1:j2) .ne. uheadx(1:j3)) then
                  write (nttyo,2014) uheadx(1:j3),ustr24(1:j2),
     $            ugexmo(ne)(1:j4),ugexpi(nei)(1:j5)
 2014             format(/' * Warning - (XCON3/rd3d8b) Was expecting',
     $            ' to find a line containing',/7x,'"',a,'", instead',
     $            ' found one containing "',a,'".',/7x,'The former',
     $            ' matches the ',a,' exchange model, which was',
     $            /7x,'specified for the generic ion exchange phase ',
     $            a,'.')
                endif
c
                if (qgexef) then
                  egexsi(iei,jei,nei) = var
                else
                  xgexsi(iei,jei,nei) = var
                endif
              endif
            else
              uheadx = '--------'
              if (ustr(1:8) .eq. uheadx(1:8)) then
c
c               Have found the end of the sub-sub-block for the
c               composition of the current exchange site
c
                go to 320
              else
c
c               Have unrecognized input.
c
                j3 = ilnobl(ugexji(jei,nei))
                j4 = ilnobl(ugexpi(nei))
                write (nttyo,1360) ustr(1:j2),ugexji(jei,nei)(1:j3),
     $          ugexpi(nei)(1:j4)
 1360           format(/' * Error - (XCON3/rd3d8b) Have unrecognized',
     $          ' input on the line',/7x,'beginning with "',a,'".',
     $          ' This line should contain the',/7x,'name of an',
     $          ' exchanger species and corresponding mole fraction',
     $          /7x,'for site ',a,' of exchanger phase ',a,', else it',
     $          /7x,'should be a separator line terminating a sequence',
     $          ' of such lines.')
c
              endif
            endif
c
          enddo
  320     continue
        enddo
  330   continue
      enddo
  340 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified solid solution compositions.
c
      nxti = 0
      nxic = 0
      qnonep = .false.
c
c     Read a two-line header for the block.
c
      uheadx = 'Solid Solution Compositions'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on solid solution phases.
c
      nxi = 0
      do nn = 1,nxtimx + 1
c
c       Read a line. If the block has not been completely read,
c       this contains the name of a solid solution, and a sub-block
c       for that phase follows. Otherwise, this line is the first line
c       of the next block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        ustr = ufield(1)
        uheadx = 'Solid Solution'
        call locase(ustr)
        call locase(uheadx)
        j2 = ilnobl(ustr)
        j3 = ilnobl(uheadx)
c
        if (ustr(1:j2) .ne. uheadx(1:j3)) then
c
c         Back up.
c
          backspace ninpts
          go to 440
        endif
c
        ustr = ufield(2)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        qnonep = ustr(1:5).eq.'None '
c
        if (.not.qnonep) then
          nxti = nxti + 1
          nxi = nxi + 1
c
          if (nxi .gt. nxtimx) then
            write (nttyo,1430) nxtimx,ustr(1:j2)
 1430       format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $      ' maximum',/7x,'number of ',i5,' solid solutions for which',
     $      /7x,'compositions may be specified on the input file. This',
     $      /7x,'occurred while reading data for ',a,'.',
     $      /7x,'Increase the dimensioning parameter nxtipa.')
            go to 990
          endif
c
          usoli(nxi) = ustr
          ncmpri(1,nxi) = nxic + 1
        endif
c
c       Read the separator line following the data line containing
c       the name of a solid solution.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(1)
        uheadx = '--------'
        if (ustr24(1:8) .ne. uheadx(1:8)) then
          j2 = ilnobl(uline1)
          j2 = min(j2,70)
          write (nttyo,1070) uline1(1:j2)
          qrderr = .true.
          go to 999
        endif
c
c       Read a table header for the solid solution composition from
c       from a two-line header.
c
        uheadx = '->'
        nfldtx = 4
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        ustr24 = ufield(2)
        uheadx = 'Component'
        call locase(ustr24)
        call locase(uheadx)
        j2 = ilnobl(ustr24)
        j3 = ilnobl(uheadx)
        if (ustr24(1:j2) .ne. uheadx(1:j3)) then
          write (nttyo,1020) uheadx(1:j3),ustr24(1:j2)
          qrderr = .true.
          go to 999
        endif
c
c       Loop on component species.
c
        do nnn = 1,nxicmx + 1
c
c         Read a line. If the sub-block (for the current
c         solid solution) has not been completely read, this contains
c         the name of the component species and its mole fraction.
c         Otherwise, this line is the first line of the next
c         sub-block (for the next solid solution).
c
          nfldtx = 0
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          ustr = ufield(1)
          uheadx = '->'
          call locase(ustr)
          call locase(uheadx)
          j2 = ilnobl(ustr)
          j3 = ilnobl(uheadx)
          if (ustr(1:j2) .eq. uheadx(1:j3)) then
            ustr = ufield(2)
            ustrn = ustr
            call locase(ustrn)
            if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ')
     $      ustr = 'None'
            qnonei = ustr(1:5).eq.'None '
c
            qokay = .not.qnonep .and. .not.qnonei
            if (qokay) then
c
c             Have found another component species line.
c
              nxic = nxic + 1
c
              if (nxic .gt. nxicmx) then
                j2 = ilnobl(ustr)
                j3 = ilnobl(usoli(nxi))
                write (nttyo,1460) nxicmx,ustr(1:j2),usoli(nxi)(1:j3)
 1460           format(/' * Error - (XCON3/rd3d8b) Have exceeded the',
     $          ' maximum number',/7x,'of ',i5,' solid solution',
     $          ' species for which mole fractions',/7x,'are specified',
     $          ' on the input file. This occurred while reading',
     $          /7x,'data for the species ',a,'(',a,').',
     $          /7x,'Increase the dimensioning parameter nxipar.')
                go to 990
              endif
c
              umemi(nxic) = ufield(2)
              ustr = ufield(3)
              call chreal(nttyo,qrderr,ustr,var)
              if (qrderr) go to 999
              xbari(nxic) = var
            endif
          else
            uheadx = '--------'
            if (ustr(1:8) .eq. uheadx(1:8)) then
c
c             Have found the end of the sub-block for the
c             composition of the current solid solution.
c
              go to 420
            else
c
c             Have unrecognized input.
c
              j3 = ilnobl(usoli(nxi))
              write (nttyo,1470) ustr(1:j2),usoli(nxi)(1:j3)
 1470         format(/' * Error - (XCON3/rd3d8b) Have unrecognized',
     $        ' input on the line',/7x,'beginning with "',a,'".',
     $        ' This line should contain the',/7x,'name of a',
     $        ' component species and corresponding mole fraction',
     $        /7x,'for solid solution ',a,', else it should be a',
     $        ' separator line terminating a sequence of such lines.')
c
            endif
          endif
c
        enddo
  420   if (.not.qnonep) ncmpri(2,nxi) = nxic
      enddo
  440 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nxmod options.
c
      uheadx = 'Alter/Suppress options'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Read the first part of a table header from a one-line header.
c
      uheadx = 'Species'
      nfldtx = 3
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
c     Read the second part of the table header from a two-line header.
c
      uheadx = '(uxmod(n))'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      n = 0
c
c     Loop on the number of alter/suppress options.
c
      do nn = 1,nxmdmx + 1
c
c       Read a line. This contains an alter/suppress option, else it is
c       a separator line marking the end of the current block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
c
        ustr = ufield(1)
        if (ustr(1:8) .eq. '--------') go to 570
c
        call locase(ustr)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        if (ustr(1:5) .eq. 'None ') go to 560
c
        n = n + 1
c
        if (n .gt. nxmdmx) then
          write (nttyo,1500) nxmdmx
 1500     format(/' * Error - (XCON3/rd3d8b) Have too many nxmod',
     $    /7x,'alter/suppress options. The code is only dimensioned',
     $    /7x,'for ',i3,' such options. Reduce the number of such',
     $    /7x,'options or increase the dimensioning parameter nxmdpa.')
          go to 990
        endif
c
        uxmod(n) = ufield(1)
c
        ustr = ufield(2)
        call locase(ustr)
        do kxmd = -1,2
          uheadx = ukxm(kxmd)
          call locase(uheadx)
          if (ustr(1:16) .eq. uheadx(1:16)) then
            kxmod(n) = kxmd
            go to 152
          endif
        enddo
c
        j2 = ilnobl(ustr)
        write (nttyo,1510) ustr(1:j2)
 1510   format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $  ' alter/suppress option',/7x,'string "',a,'". This should',
     $  ' be one of the strings',/7x,'defined in the ukxm array.',
     $  ' The valid strings are:',/)
        do kxmd = -1,2
          j3 = ilnobl(ukxm(kxmd))
          write (nttyo,1514) ukxm(kxmd)(1:j3)
 1514     format(9x,a)
        enddo
        go to 990
c
  152   ustr = ufield(3)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        xlkmod(n) = var
c
  560   continue
      enddo
c
  570 nxmod = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt Model Option Switches.
c     Note: iopt(1) = iopt1, etc.
c
      uheadx = 'Iopt Model Option Switches ("( 0)" marks default choices
     $)'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on option switches.
c
      do nn = 1,noptmx
c
c       Read the option title string from a one-line header.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadx = ufield(1)
        j2 = ilnobl(uheadx)
c
c       Check for the end of the block.
c
        if (uheadx(1:4) .ne. 'iopt') then
c
c         Back up.
c
          backspace ninpts
          go to 650
        endif
c
        k1 = index(uheadx,'(')
        k2 = index(uheadx,')')
        k3 = index(uheadx,'- ')
c
        if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or. k3.le.0 .or.
     $  k3.le.k2) then
          write (nttyo,1600) uheadx(1:j2)
 1600     format(/' * Error - (XCON3/rd3d8b) The iopt option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    " input file isn't in the required format.")
          go to 990
        endif
c
c       Get the index of the option.
c
        ustr = uheadx(k1 + 1:k2 - 1)
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        n = ivar
c
        if (n.lt.1 .or. n.gt.nptxpa) then
          write (nttyo,1610) uheadx(1:j2),n
 1610     format(/' * Error - (XCON3/rd3d8b) The iopt option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    ' input file references an option switch index',
     $    /7x,'of ',i3,', which is out of range.')
          go to 990
        endif
c
c       Check the full title string.
c
        ustr = uopttx(n)
        j3 = ilnobl(ustr)
        if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
          write (nttyo,1612) uheadx(1:j2),ustr(1:j3)
 1612     format(/' * Error - (XCON3/rd3d8b) The iopt option switch',
     $    ' title string',/7x,'"',a,'"',
     $    /7x,"read from the input file doesn't contain the",
     $    ' matching defined string',/7x,'"',a,'".')
          go to 990
        endif
c
        iopt(n) = 0
        nmark = 0
c
c       Loop on option choices.
c
        do jj = 1,jptxpa + 1
c
c         Read a line. This contains an option choice line, else it
c         is a separator line marking the end of the option choice
c         lines for the current option.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
c
          uheadx = ufield(1)
          j2 = ilnobl(uheadx)
          if (uheadx(1:8) .eq. '--------') go to 620
c
          if (jj .gt. jptxpa) then
            j3 = ilnobl(uopttx(n))
            write (nttyo,1630) uopttx(n)(1:j3),jptxpa
 1630       format(/' * Error - (XCON3/rd3d8b) Have too many option',
     $      /7x,'choice lines for the iopt option switch whose title',
     $      ' string is',/7x,'"',a,'".',/7x,' The code is only',
     $      ' dimensioned for ',i3,' such lines. Reduce the',
     $      /7x,'number of such lines or increase the dimensioning',
     $      ' parameter jptxpa.')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          k3 = index(uheadx,'(')
          k4 = index(uheadx,')')
c
          if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or.
     $    k3.le.0 .or. k4.le.0 .or. k4.lt.(k3 + 2)) then
            write (nttyo,1640) uheadx(1:j2)
 1640       format(/' * Error - (XCON3/rd3d8b) The following iopt',
     $      /7x,'option switch choice line read from the input file',
     $      /7x,"isn't in the required format:",/7x,'"',a,'"')
            go to 990
          endif
c
c         Get the index of the option choice.
c
          ustr = uheadx(k3 + 1:k4 - 1)
          call chrint(ivar,nttyo,qrderr,ustr)
          if (qrderr) go to 999
          ival = ivar
c
          do j = 1,jptxpa
            ii = ioptox(j,n)
            if (ival .eq. ii) go to 600
          enddo
c
          write (nttyo,1650) uheadx(1:j2)
 1650     format(/' * Error - (XCON3/rd3d8b) The iopt option switch',
     $    /7x,'choice line',/7x,'"',a,'"',
     $    /7x,'read from the input file references an out-of-range',
     $    ' option',/7x,'choice index.')
          go to 990
c
  600     continue
c
c         Check the full option choice string.
c
          ustr = uoptox(j,n)
          j3 = ilnobl(ustr)
          j4 = ilnobl(uopttx(n))
          if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
            write (nttyo,1660) uheadx(1:j2),ustr(1:j3),uopttx(n)(1:j4)
 1660       format(/' * Error - (XCON3/rd3d8b) The iopt option switch',
     $      ' choice line',/7x,'"',a,'"',
     $      /7x," read from the input file doesn't contain the",
     $      ' matching defined string',/7x,'"',a,'".',
     $      /7x,'This line belongs to the option switch whose title',
     $      ' string is',/7x,'"',a,'".')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          ustr24 = uheadx(k1 + 1:k2 -1)
          call lejust(ustr24)
          j3 = ilnobl(ustr24)
          qmark = .false.
          if (j3 .gt. 0) then
            if (index(ustr24,'*') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'x') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'X') .ge. 1) then
              qmark = .true.
            else
              j4 = ilnobl(uopttx(n))
              write (nttyo,1670) ustr24(1:j3),uheadx(1:j2),
     $        uopttx(n)(1:j4)
 1670         format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $        ' string "',a,'"',/7x,'that appears on the iopt',
     $        ' option switch choice line',/7x,'"',a,'"',
     $        /7x,'read from the input file. An option choice should',
     $        ' be chosen by',/7x,'placing a "*", "x", or "X" in the',
     $        ' checkbox ("[ ]"). This',/7x,'choice line belongs to',
     $        ' the option switch whose title string is',/7x,'"',a,'".')
              go to 990
            endif
          endif
c
          if (qmark) then
            nmark = nmark + 1
            iopt(n) = ival
            jlast = j
          endif
c
        enddo
  620   continue
c
        if (nmark .le. 0) then
          j2 = ilnobl(uopttx(n))
          write (nttyo,1680) uopttx(n)(1:j2)
 1680     format(/' * Warning - (XCON3/rd3d8b) No option choice was',
     $    ' checked on the input file',/7x,'for the iopt option',
     $    ' switch whose title string is',/7x,'"',a,'".')
c
          do j = 1,jptxpa
            ival = ioptox(j,n)
            if (ival .eq. 0) go to 630
          enddo
c
          write (nttyo,1690)
 1690     format(/7x,'A default value of 0 has been applied, but no',
     $    /7x,'matching option choice string is defined.')
          go to 640
c
  630     j3 = ilnobl(uoptox(j,n))
          write (nttyo,1692) uoptox(j,n)(1:j3)
 1692     format(/7x,'A default value of 0 has been applied. The',
     $    ' matching string is',/7x,'"',a,'".')
  640     continue
        endif
c
        if (nmark .gt. 1) then
          j2 = ilnobl(uopttx(n))
          j = jlast
          j3 = ilnobl(uoptox(j,n))
           write (nttyo,1694) uopttx(n)(1:j2),uoptox(j,n)(1:j3)
 1694     format(/' * Warning - (XCON3/rd3d8b) More than one option',
     $    ' choice was checked',/7x,'on the input file for the iopt',
     $    ' option switch whose title string is',/7x,'"',a,'".',
     $    /7x,'The last choice checked will be used. The',
     $    ' matching string is',/7x,'"',a,'".')
        endif
c
      enddo
  650 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg Print Option Switches.
c     Note: iopg(1) = iopg1, etc.
c
      uheadx = 'Iopg Activity Coefficient Option Switches ("( 0)" marks
     $default choices)'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on option switches.
c
      do nn = 1,nopgmx
c
c       Read the option title string from a one-line header.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadx = ufield(1)
        j2 = ilnobl(uheadx)
c
c       Check for the end of the block.
c
        if (uheadx(1:4) .ne. 'iopg') then
c
c         Back up.
c
          backspace ninpts
          go to 750
        endif
c
        k1 = index(uheadx,'(')
        k2 = index(uheadx,')')
        k3 = index(uheadx,'- ')
c
        if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or. k3.le.0 .or.
     $  k3.le.k2) then
          write (nttyo,1700) uheadx(1:j2)
 1700     format(/' * Error - (XCON3/rd3d8b) The iopg option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    " input file isn't in the required format.")
          go to 990
        endif
c
c       Get the index of the option.
c
        ustr = uheadx(k1 + 1:k2 - 1)
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        n = ivar
c
        if (n.lt.1 .or. n.gt.npgxpa) then
          write (nttyo,1712) uheadx(1:j2),n
 1712     format(/' * Error - (XCON3/rd3d8b) The iopg option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    ' input file references an option switch index',
     $    /7x,'of ',i3,', which is out of range.')
          go to 990
        endif
c
c       Check the full title string.
c
        ustr = uopgtx(n)
        j3 = ilnobl(ustr)
        if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
          write (nttyo,1720) uheadx(1:j2),ustr(1:j3)
 1720     format(/' * Error - (XCON3/rd3d8b) The iopg option switch',
     $    ' title string',/7x,'"',a,'"',
     $    /7x,"read from the input file doesn't contain the",
     $    ' matching defined string',/7x,'"',a,'".')
          go to 990
        endif
c
        iopg(n) = 0
        nmark = 0
c
c       Loop on option choices.
c
        do jj = 1,jpgxpa + 1
c
c         Read a line. This contains an option choice line, else it
c         is a separator line marking the end of the option choice
c         lines for the current option.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
c
          uheadx = ufield(1)
          j2 = ilnobl(uheadx)
          if (uheadx(1:8) .eq. '--------') go to 720
c
          if (jj .gt. jpgxpa) then
            j3 = ilnobl(uopgtx(n))
            write (nttyo,1730) uopgtx(n)(1:j3),jpgxpa
 1730       format(/' * Error - (XCON3/rd3d8b) Have too many option',
     $      /7x,'choice lines for the iopg option switch whose title',
     $      ' string is',/7x,'"',a,'".',/7x,' The code is only',
     $      ' dimensioned for ',i3,' such lines. Reduce the',
     $      /7x,'number of such lines or increase the dimensioning',
     $      ' parameter jpgxpa.')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          k3 = index(uheadx,'(')
          k4 = index(uheadx,')')
c
          if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or.
     $    k3.le.0 .or. k4.le.0 .or. k4.lt.(k3 + 2)) then
            write (nttyo,1740) uheadx(1:j2)
 1740       format(/' * Error - (XCON3/rd3d8b) The following iopg',
     $      /7x,'option switch choice line read from the input file',
     $      /7x,"isn't in the required format:",/7x,'"',a,'"')
            go to 990
          endif
c
c         Get the index of the option choice.
c
          ustr = uheadx(k3 + 1:k4 - 1)
          call chrint(ivar,nttyo,qrderr,ustr)
          if (qrderr) go to 999
          ival = ivar
c
          do j = 1,jpgxpa
            ii = iopgox(j,n)
            if (ival .eq. ii) go to 700
          enddo
c
          write (nttyo,1750) uheadx(1:j2)
 1750     format(/' * Error - (XCON3/rd3d8b) The iopg option switch',
     $    /7x,'choice line',/7x,'"',a,'"',
     $    /7x,'read from the input file references an out-of-range',
     $    ' option',/7x,'choice index.')
          go to 990
c
  700     continue
c
c         Check the full option choice string.
c
          ustr = uopgox(j,n)
          j3 = ilnobl(ustr)
          j4 = ilnobl(uopgtx(n))
          if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
            write (nttyo,1760) uheadx(1:j2),ustr(1:j3),uopgtx(n)(1:j4)
 1760       format(/' * Error - (XCON3/rd3d8b) The iopg option switch',
     $      ' choice line',/7x,'"',a,'"',
     $      /7x," read from the input file doesn't contain the",
     $      ' matching defined string',/7x,'"',a,'".',
     $      /7x,'This line belongs to the option switch whose title',
     $      ' string is',/7x,'"',a,'".')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          ustr24 = uheadx(k1 + 1:k2 -1)
          call lejust(ustr24)
          j3 = ilnobl(ustr24)
          qmark = .false.
          if (j3 .gt. 0) then
            if (index(ustr24,'*') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'x') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'X') .ge. 1) then
              qmark = .true.
            else
              j4 = ilnobl(uopgtx(n))
              write (nttyo,1770) ustr24(1:j3),uheadx(1:j2),
     $        uopgtx(n)(1:j4)
 1770         format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $        ' string "',a,'"',/7x,'that appears on the iopg',
     $        ' option switch choice line',/7x,'"',a,'"',
     $        /7x,'read from the input file. An option choice should',
     $        ' be chosen by',/7x,'placing a "*", "x", or "X" in the',
     $        ' checkbox ("[ ]"). This',/7x,'choice line belongs to',
     $        ' the option switch whose title string is',/7x,'"',a,'".')
              go to 990
            endif
          endif
c
          if (qmark) then
            nmark = nmark + 1
            iopg(n) = ival
            jlast = j
          endif
c
        enddo
  720   continue
c
        if (nmark .le. 0) then
          j2 = ilnobl(uopgtx(n))
          write (nttyo,1780) uopgtx(n)(1:j2)
 1780     format(/' * Warning - (XCON3/rd3d8b) No option choice was',
     $    ' checked on the input file',/7x,'for the iopg option',
     $    ' switch whose title string is',/7x,'"',a,'".')
c
          do j = 1,jpgxpa
            ival = iopgox(j,n)
            if (ival .eq. 0) go to 730
          enddo
c
          write (nttyo,1790)
 1790     format(/7x,'A default value of 0 has been applied, but no',
     $    /7x,'matching option choice string is defined.')
          go to 740
c
  730     j3 = ilnobl(uopgox(j,n))
          write (nttyo,1792) uopgox(j,n)(1:j3)
 1792     format(/7x,'A default value of 0 has been applied. The',
     $    ' matching string is',/7x,'"',a,'".')
  740     continue
        endif
c
        if (nmark .gt. 1) then
          j2 = ilnobl(uopgtx(n))
          j = jlast
          j3 = ilnobl(uopgox(j,n))
           write (nttyo,1794) uopgtx(n)(1:j2),uopgox(j,n)(1:j3)
 1794     format(/' * Warning - (XCON3/rd3d8b) More than one option',
     $    ' choice was checked',/7x,'on the input file for the iopg',
     $    ' option switch whose title string is',/7x,'"',a,'".',
     $    /7x,'The last choice checked will be used. The',
     $    ' matching string is',/7x,'"',a,'".')
        endif
c
      enddo
  750 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr Print Option Switches.
c     Note: iopr(1) = iopt1, etc.
c
      uheadx = 'Iopr Print Option Switches ("( 0)" marks default choices
     $)'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on option switches.
c
      do nn = 1,noprmx
c
c       Read the option title string from a one-line header.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadx = ufield(1)
        j2 = ilnobl(uheadx)
c
c       Check for the end of the block.
c
        if (uheadx(1:4) .ne. 'iopr') then
c
c         Back up.
c
          backspace ninpts
          go to 850
        endif
c
        k1 = index(uheadx,'(')
        k2 = index(uheadx,')')
        k3 = index(uheadx,'- ')
c
        if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or. k3.le.0 .or.
     $  k3.le.k2) then
          write (nttyo,1800) uheadx(1:j2)
 1800     format(/' * Error - (XCON3/rd3d8b) The iopr option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    " input file isn't in the required format.")
          go to 990
        endif
c
c       Get the index of the option.
c
        ustr = uheadx(k1 + 1:k2 - 1)
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        n = ivar
c
        if (n.lt.1 .or. n.gt.nprxpa) then
          write (nttyo,1810) uheadx(1:j2),n
 1810     format(/' * Error - (XCON3/rd3d8b) The iopr option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    ' input file references an option switch index',
     $    /7x,'of ',i3,', which is out of range.')
          go to 990
        endif
c
c       Check the full title string.
c
        ustr = uoprtx(n)
        j3 = ilnobl(ustr)
        if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
          write (nttyo,1812) uheadx(1:j2),ustr(1:j3)
 1812     format(/' * Error - (XCON3/rd3d8b) The iopr option switch',
     $    ' title string',/7x,'"',a,'"',
     $    /7x,"read from the input file doesn't contain the",
     $    ' matching defined string',/7x,'"',a,'".')
          go to 990
        endif
c
        iopr(n) = 0
        nmark = 0
c
c       Loop on option choices.
c
        do jj = 1,jprxpa + 1
c
c         Read a line. This contains an option choice line, else it
c         is a separator line marking the end of the option choice
c         lines for the current option.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
c
          uheadx = ufield(1)
          j2 = ilnobl(uheadx)
          if (uheadx(1:8) .eq. '--------') go to 820
c
          if (jj .gt. jprxpa) then
            j3 = ilnobl(uoprtx(n))
            write (nttyo,1830) uoprtx(n)(1:j3),jprxpa
 1830       format(/' * Error - (XCON3/rd3d8b) Have too many option',
     $      /7x,'choice lines for the iopr option switch whose title',
     $      ' string is',/7x,'"',a,'".',/7x,' The code is only',
     $      ' dimensioned for ',i3,' such lines. Reduce the',
     $      /7x,'number of such lines or increase the dimensioning',
     $      ' parameter jprxpa.')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          k3 = index(uheadx,'(')
          k4 = index(uheadx,')')
c
          if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or.
     $    k3.le.0 .or. k4.le.0 .or. k4.lt.(k3 + 2)) then
            write (nttyo,1840) uheadx(1:j2)
 1840       format(/' * Error - (XCON3/rd3d8b) The following iopr',
     $      /7x,'option switch choice line read from the input file',
     $      /7x,"isn't in the required format:",/7x,'"',a,'"')
            go to 990
          endif
c
c         Get the index of the option choice.
c
          ustr = uheadx(k3 + 1:k4 - 1)
          call chrint(ivar,nttyo,qrderr,ustr)
          if (qrderr) go to 999
          ival = ivar
c
          do j = 1,jprxpa
            ii = ioprox(j,n)
            if (ival .eq. ii) go to 800
          enddo
c
          write (nttyo,1850) uheadx(1:j2)
 1850     format(/' * Error - (XCON3/rd3d8b) The iopr option switch',
     $    /7x,'choice line',/7x,'"',a,'"',
     $    /7x,'read from the input file references an out-of-range',
     $    ' option',/7x,'choice index.')
          go to 990
c
  800     continue
c
c         Check the full option choice string.
c
          ustr = uoprox(j,n)
          j3 = ilnobl(ustr)
          j4 = ilnobl(uoprtx(n))
          if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
            write (nttyo,1860) uheadx(1:j2),ustr(1:j3),uoprtx(n)(1:j4)
 1860       format(/' * Error - (XCON3/rd3d8b) The iopr option switch',
     $      ' choice line',/7x,'"',a,'"',
     $      /7x," read from the input file doesn't contain the",
     $      ' matching defined string',/7x,'"',a,'".',
     $      /7x,'This line belongs to the option switch whose title',
     $      ' string is',/7x,'"',a,'".')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          ustr24 = uheadx(k1 + 1:k2 -1)
          call lejust(ustr24)
          j3 = ilnobl(ustr24)
          qmark = .false.
          if (j3 .gt. 0) then
            if (index(ustr24,'*') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'x') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'X') .ge. 1) then
              qmark = .true.
            else
              j4 = ilnobl(uoprtx(n))
              write (nttyo,1870) ustr24(1:j3),uheadx(1:j2),
     $        uoprtx(n)(1:j4)
 1870         format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $        ' string "',a,'"',/7x,'that appears on the iopr',
     $        ' option switch choice line',/7x,'"',a,'"',
     $        /7x,'read from the input file. An option choice should',
     $        ' be chosen by',/7x,'placing a "*", "x", or "X" in the',
     $        ' checkbox ("[ ]"). This',/7x,'choice line belongs to',
     $        ' the option switch whose title string is',/7x,'"',a,'".')
              go to 990
            endif
          endif
c
          if (qmark) then
            nmark = nmark + 1
            iopr(n) = ival
            jlast = j
          endif
c
        enddo
  820   continue
c
        if (nmark .le. 0) then
          j2 = ilnobl(uoprtx(n))
          write (nttyo,1880) uoprtx(n)(1:j2)
 1880     format(/' * Warning - (XCON3/rd3d8b) No option choice was',
     $    ' checked on the input file',/7x,'for the iopr option',
     $    ' switch whose title string is',/7x,'"',a,'".')
c
          do j = 1,jprxpa
            ival = ioprox(j,n)
            if (ival .eq. 0) go to 830
          enddo
c
          write (nttyo,1890)
 1890     format(/7x,'A default value of 0 has been applied, but no',
     $    /7x,'matching option choice string is defined.')
          go to 840
c
  830     j3 = ilnobl(uoprox(j,n))
          write (nttyo,1892) uoprox(j,n)(1:j3)
 1892     format(/7x,'A default value of 0 has been applied. The',
     $    ' matching string is',/7x,'"',a,'".')
  840     continue
        endif
c
        if (nmark .gt. 1) then
          j2 = ilnobl(uoprtx(n))
          j = jlast
          j3 = ilnobl(uoprox(j,n))
           write (nttyo,1894) uoprtx(n)(1:j2),uoprox(j,n)(1:j3)
 1894     format(/' * Warning - (XCON3/rd3d8b) More than one option',
     $    ' choice was checked',/7x,'on the input file for the iopr',
     $    ' option switch whose title string is',/7x,'"',a,'".',
     $    /7x,'The last choice checked will be used. The',
     $    ' matching string is',/7x,'"',a,'".')
        endif
c
      enddo
  850 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      uheadx = 'Iodb Debugging Print Option Switches ("( 0)" marks defau
     $lt choices)'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Loop on option switches.
c
      do nn = 1,nodbmx
c
c       Read the option title string from a one-line header.
c
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadx = ufield(1)
        j2 = ilnobl(uheadx)
c
c       Check for the end of the block.
c
        if (uheadx(1:4) .ne. 'iodb') then
c
c         Back up.
c
          backspace ninpts
          go to 950
        endif
c
        k1 = index(uheadx,'(')
        k2 = index(uheadx,')')
        k3 = index(uheadx,'- ')
c
        if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or. k3.le.0 .or.
     $  k3.le.k2) then
          write (nttyo,1900) uheadx(1:j2)
 1900     format(/' * Error - (XCON3/rd3d8b) The iodb option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    " input file isn't in the required format.")
          go to 990
        endif
c
c       Get the index of the option.
c
        ustr = uheadx(k1 + 1:k2 - 1)
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        n = ivar
c
        if (n.lt.1 .or. n.gt.ndbxpa) then
          write (nttyo,1910) uheadx(1:j2),n
 1910     format(/' * Error - (XCON3/rd3d8b) The iodb option switch',
     $    ' title line',/7x,'"',a,'"',/7x,'read from the',
     $    ' input file references an option switch index',
     $    /7x,'of ',i3,', which is out of range.')
          go to 990
        endif
c
c       Check the full title string.
c
        ustr = uodbtx(n)
        j3 = ilnobl(ustr)
        if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
          write (nttyo,1920) uheadx(1:j2),ustr(1:j3)
 1920     format(/' * Error - (XCON3/rd3d8b) The iodb option switch',
     $    ' title string',/7x,'"',a,'"',
     $    /7x,"read from the input file doesn't contain the",
     $    ' matching defined string',/7x,'"',a,'".')
          go to 990
        endif
c
        iodb(n) = 0
        nmark = 0
c
c       Loop on option choices.
c
        do jj = 1,jdbxpa + 1
c
c         Read a line. This contains an option choice line, else it
c         is a separator line marking the end of the option choice
c         lines for the current option.
c
          nfldtx = 1
          call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $    nttyo,qrderr,ufield,uline1,ulscr)
          if (qrderr) go to 999
c
          uheadx = ufield(1)
          j2 = ilnobl(uheadx)
          if (uheadx(1:8) .eq. '--------') go to 920
c
          if (jj .gt. jdbxpa) then
            j3 = ilnobl(uodbtx(n))
            write (nttyo,1922) uodbtx(n)(1:j3),jdbxpa
 1922       format(/' * Error - (XCON3/rd3d8b) Have too many option',
     $      /7x,'choice lines for the iodb option switch whose title',
     $      ' string is',/7x,'"',a,'".',/7x,' The code is only',
     $      ' dimensioned for ',i3,' such lines. Reduce the',
     $      /7x,'number of such lines or increase the dimensioning',
     $      ' parameter jdbxpa.')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          k3 = index(uheadx,'(')
          k4 = index(uheadx,')')
c
          if (k1.le.0 .or. k2.le.0 .or. k2.lt.(k1 + 2) .or.
     $    k3.le.0 .or. k4.le.0 .or. k4.lt.(k3 + 2)) then
            write (nttyo,1940) uheadx(1:j2)
 1940       format(/' * Error - (XCON3/rd3d8b) The following iodb',
     $      /7x,'option switch choice line read from the input file',
     $      /7x,"isn't in the required format:",/7x,'"',a,'"')
            go to 990
          endif
c
c         Get the index of the option choice.
c
          ustr = uheadx(k3 + 1:k4 - 1)
          call chrint(ivar,nttyo,qrderr,ustr)
          if (qrderr) go to 999
          ival = ivar
c
          do j = 1,jdbxpa
            ii = iodbox(j,n)
            if (ival .eq. ii) go to 900
          enddo
c
          write (nttyo,1950) uheadx(1:j2)
 1950     format(/' * Error - (XCON3/rd3d8b) The iodb option switch',
     $    /7x,'choice line',/7x,'"',a,'"',
     $    /7x,'read from the input file references an out-of-range',
     $    ' option',/7x,'choice index.')
          go to 990
c
  900     continue
c
c         Check the full option choice string.
c
          ustr = uodbox(j,n)
          j3 = ilnobl(ustr)
          j4 = ilnobl(uodbtx(n))
          if (index(uheadx(1:j2),ustr(1:j3)) .le. 0) then
            write (nttyo,1960) uheadx(1:j2),ustr(1:j3),uodbtx(n)(1:j4)
 1960       format(/' * Error - (XCON3/rd3d8b) The iodb option switch',
     $      ' choice line',/7x,'"',a,'"',
     $      /7x," read from the input file doesn't contain the",
     $      ' matching defined string',/7x,'"',a,'".',
     $      /7x,'This line belongs to the option switch whose title',
     $      ' string is',/7x,'"',a,'".')
            go to 990
          endif
c
          k1 = index(uheadx,'[')
          k2 = index(uheadx,']')
          ustr24 = uheadx(k1 + 1:k2 -1)
          call lejust(ustr24)
          j3 = ilnobl(ustr24)
          qmark = .false.
          if (j3 .gt. 0) then
            if (index(ustr24,'*') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'x') .ge. 1) then
              qmark = .true.
            elseif (index(ustr24,'X') .ge. 1) then
              qmark = .true.
            else
              j4 = ilnobl(uodbtx(n))
              write (nttyo,1970) ustr24(1:j3),uheadx(1:j2),
     $        uodbtx(n)(1:j4)
 1970         format(/" * Error - (XCON3/rd3d8b) Don't recognize the",
     $        ' string "',a,'"',/7x,'that appears on the iodb',
     $        ' option switch choice line',/7x,'"',a,'"',
     $        /7x,'read from the input file. An option choice should',
     $        ' be chosen by',/7x,'placing a "*", "x", or "X" in the',
     $        ' checkbox ("[ ]"). This',/7x,'choice line belongs to',
     $        ' the option switch whose title string is',/7x,'"',a,'".')
              go to 990
            endif
          endif
c
          if (qmark) then
            nmark = nmark + 1
            iodb(n) = ival
            jlast = j
          endif
c
        enddo
  920   continue
c
        if (nmark .le. 0) then
          j2 = ilnobl(uodbtx(n))
          write (nttyo,1980) uodbtx(n)(1:j2)
 1980     format(/' * Warning - (XCON3/rd3d8b) No option choice was',
     $    ' checked on the input file',/7x,'for the iodb option',
     $    ' switch whose title string is',/7x,'"',a,'".')
c
          do j = 1,jdbxpa
            ival = iodbox(j,n)
            if (ival .eq. 0) go to 930
          enddo
c
          write (nttyo,1990)
 1990     format(/7x,'A default value of 0 has been applied, but no',
     $    /7x,'matching option choice string is defined.')
          go to 940
c
  930     j3 = ilnobl(uodbox(j,n))
          write (nttyo,1992) uodbox(j,n)(1:j3)
 1992     format(/7x,'A default value of 0 has been applied. The',
     $    ' matching string is',/7x,'"',a,'".')
  940     continue
        endif
c
        if (nmark .gt. 1) then
          j2 = ilnobl(uodbtx(n))
          j = jlast
          j3 = ilnobl(uodbox(j,n))
           write (nttyo,1994) uodbtx(n)(1:j2),uodbox(j,n)(1:j3)
 1994     format(/' * Warning - (XCON3/rd3d8b) More than one option',
     $    ' choice was checked',/7x,'on the input file for the iodb',
     $    ' option switch whose title string is',/7x,'"',a,'".',
     $    /7x,'The last choice checked will be used. The',
     $    ' matching string is',/7x,'"',a,'".')
        endif
c
      enddo
  950 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical parameters.
c
c     Read the block title from a two-line header.
c
      uheadx = 'Numerical parameters'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c     Read the beta convergence tolerance (tolbt) from a one-line
c     header.
c
      uheadx = 'Beta convergence tolerance'
      nfldtx = 3
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      tolbt = var
c
c     Read the del convergence tolerance (toldl) from a one-line header.
c
      uheadx = 'Del convergence tolerance'
      nfldtx = 3
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      toldl = var
c
c     Read the maximum number of Newton-Raphson iterations (itermx)
c     from a two-line header (the separator line is the end of the
c     current block).
c
      uheadx = 'Max. Number of N-R Iterations'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 999
      itermx = ivar
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
c     Read the block title from a two-line header.
c
      uheadx = 'Ordinary Basis Switches'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nobsw = 0
      do n = 1,nbtmax + 1
c
c       Read a line. If the block has not been completely read,
c       this contains the name of a species to "Replace", and a
c       sub-block for that species follows. Otherwise, this line is
c       the first line of the next block.
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        uheadx = 'Replace'
        call locase(ustr)
        call locase(uheadx)
        j2 = ilnobl(ustr)
        j3 = ilnobl(uheadx)
c
        if (ustr(1:j2) .ne. uheadx(1:j3)) then
c
c         Back up.
c
          backspace ninpts
          go to 525
        endif
c
        ustr = ufield(2)
        ustrn = ustr
        call locase(ustrn)
        if (ustrn(1:5).eq.'none ' .or. ustr(1:1).eq.' ') ustr = 'None'
        qnone = ustr(1:5).eq.'None '
c
        if (.not.qnone) then
          nobsw = nobsw + 1
          uobsw(1,nobsw) = ufield(2)
        endif
c
c       Read the name of the "with" species from a two-line header.
c
        uheadx = 'with'
        nfldtx = 3
        call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
        if (qrderr) go to 999
        if (.not.qnone) uobsw(2,nobsw) = ufield(2)
      enddo
  525 nobswt = nobsw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation flag tolerance (tolspf).
c
      tolspf = 0.
c
c     Read the data from a two-line header.
c
      uheadx = 'Sat. flag tolerance'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      tolspf = var
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale factor for the mass of aqueous solution to write
c     on the pickup file.
c
      scamas = 0.
c
c     Read the data from a two-line header.
c
      uheadx = 'Aq. Phase Scale Factor'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      scamas = var
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read a two-line header marking the end of the current problem
c     input.
c
      uheadx = 'End of problem'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrderr = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine supprs(kxmod,jpflag,jsflag,ncmpra,noutpt,npta,nptmax,
     $ nsta,nstmax,nttyo,nxmdmx,nxmod,uphasa,uspeca,uxmod)
c
c     This subroutine suppresses phases/species as directed by what is
c     on the input file. Here uxmod is the name of the associated
c     species and kxmod = -1. EQLIB/alters.f handles the log K alter
c     function (kxmod = 0, 1, or 2). Suppression of a phase results in
c     suppression of all of its component species.
c
c     The string uxmod is 48 characters in length. This can contain
c     a phase-specific species name in which the first 24 characters
c     contain the species name proper and the second 24 characters
c     contain the phase name. If the second 24 characters are blank,
c     then every species or phase whose name matches what is in the
c     first 24 characters will be suppressed. Note that it is not
c     possible to specify a name in the second 24 character field
c     with nothing in the first such field, as the contents of the
c     uxmod field read from the input file is automatically left-
c     adjusted when its contents are read. To specify a phase name
c     only, put the string 'Phase_name_only:' in the first 24
c     characters, where a species name proper would ordinarily
c     appear, and put the phase name in the second 24 characters.
c     In practice, this should not be necessary, as phase names
c     should be unique from species names, save for the case of
c     a pure phase, for which the species name and the phase
c     name are identical.
c
c     This subroutine is called by:
c
c       EQLIB/flgset.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nptmax,nstmax,nxmdmx
c
      integer noutpt,nttyo
c
      integer kxmod(nxmdmx),jsflag(nstmax),jpflag(nptmax),
     $ ncmpra(2,nptmax)
      integer npta,nsta,nxmod
c
      character(len=24) uphasa(nptmax)
      character(len=48) uspeca(nstmax)
      character(len=48) uxmod(nxmdmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer, parameter :: nlpmax = 25,nlsmax = 25
c
      integer jlen,jlenx,j2,n,nchar,nerr,nhitp,nhitpl,nhits,
     $ nhitsl,nlist,nn,np,nr1,nr2,ns
c
      integer ilnobl
c
      logical qponly
c
      character(len=24), dimension(:), allocatable :: uusupp
      character(len=56), dimension(:), allocatable :: uusups
c
      character(len=56) uspn56,ux56
      character(len=48) unam48,ux48
      character(len=24) ublk24
      character(len=8) ufix,ux8
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data ufix   /'fix     '/
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      if (nxmod .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays for lists of user-suppressed phases and species.
c
      ALLOCATE (uusupp(nlpmax))
      ALLOCATE (uusups(nlsmax))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nhitpl = 0
      nhitsl = 0
c
      do n = 1,nxmod
        if (kxmod(n) .ge. 0) go to 150
        unam48 = uxmod(n)
        nchar = 48
c
        qponly = .false.
        if (unam48(1:16) .eq. 'Phase_name_only:') then
          qponly = .true.
          ux48 = unam48(17:48)
          call lejust(ux48)
          j2 = ilnobl(ux48)
          if (j2 .gt. 24) then
            write (noutpt,1010) ux48(1:j2)
            write (nttyo,1010) ux48(1:j2)
 1010       format(/' * Error - (EQLIB/supprs) Have encountered ',
     $      ' an input file directive',/7x,'to suppress the phase',
     $      ' "',a,'".',/7x,'This name exceeds the allowed',
     $      ' 24 characters.')
            nerr = nerr + 1
            go to 150
          endif
          unam48(1:24) = ux48(1:24)
          unam48(25:48) = ublk24(1:24)
        endif
c
        j2 = ilnobl(unam48(1:24))
        call fmspnm(jlen,unam48,uspn56)
c
        if (unam48(25:48) .eq. ublk24(1:24)) nchar = nchar - 24
        if (unam48(1:24) .eq. ublk24(1:24)) nchar = nchar - 24
c
        if (nchar .eq. 48) then
          if (unam48(1:24) .eq. unam48(25:48)) then
c
c           Have specified a pure phase species like Albite (Albite).
c           Set up to suppress this as the pure phase.
c
            unam48(25:48) = ublk24(1:24)
            qponly = .true.
            nchar = 24
          endif
        endif
c
        if (nchar .eq. 0) then
          write (noutpt,1020)
          write (nttyo,1020)
 1020     format(/' * Error - (EQLIB/supprs) Have encountered a blank',
     $    ' uxmod input for an',/7x,'nxmod suppress option.')
          nerr = nerr + 1
          go to 150
        endif
c
        nhitp = 0
c
        if (nchar .eq. 24) then
c
c         Look in the list of phases.
c
          do np = 1,npta
            if (unam48(1:24) .eq. uphasa(np)) then
              nhitp = nhitp + 1
              nhitpl = nhitpl + 1
              if (nhitp .le. nlpmax) uusupp(nhitpl) = uphasa(np)
              if (jpflag(np) .le. 0) jpflag(np) = 1
              nr1 = ncmpra(1,np)
              nr2 = ncmpra(2,np)
              do ns = nr1,nr2
                if (jsflag(ns) .le. 0) jsflag(ns) = 1
              enddo
              if (qponly) go to 150
              go to 110
            endif
          enddo
        endif
c
        if (qponly) then
c
c         Was only looking to suppress a phase, and did not find it.
c
          write (noutpt,1050) unam48(1:j2)
          write (nttyo,1050) unam48(1:j2)
 1050     format(/" * Warning - (EQLIB/supprs) Can't find the phase ",
     $    '"',a,'",',/7x,'which is specified in an nxmod suppress',
     $    ' option. Check to make sure',/7x,'that a phase of this',
     $    ' name appears on the supporting data file.')
          go to 150
        endif
c
  110   continue
c
c       Look in the list of species.
c
        nhits = 0
c
        do ns = 1,nsta
          if (unam48(1:nchar) .eq. uspeca(ns)(1:nchar)) then
            nhits = nhits + 1
            if (jsflag(ns) .lt. 1) jsflag(ns) = 1
            if (uspeca(ns)(1:24).ne.uspeca(ns)(25:48)) then
              call fmspnm(jlenx,uspeca(ns),ux56)
              nhitsl = nhitsl + 1
              if (nhitsl .le. nlsmax) uusups(nhitsl) = ux56
            endif
          endif
        enddo
        if (nhits .gt. 0) go to 150
c
c       The species to be suppressed was not found.
c
        if (nchar.eq.48) then
          write (noutpt,1120) uspn56(1:jlen)
          write (nttyo,1120) uspn56(1:jlen)
 1120     format(/" * Warning - (EQLIB/supprs) Can't find the",
     $    ' species "',a,'"',/7x,'which is specified in an nxmod',
     $    ' suppress option. Check to make sure',/7x,'that a',
     $    ' species of this name appears on the supporting',
     $    ' data file.')
        elseif (nhitp .le. 0) then
c
c         The name could also have referred to a phase, but no
c         such phase was found.
c
          write (noutpt,1130) uspn56(1:jlen)
          write (nttyo,1130) uspn56(1:jlen)
 1130     format(/" * Warning - (EQLIB/supprs) Can't find an",
     $    ' entity "',a,'"',/7x,'which is specified in an nxmod',
     $    ' suppress option. Check to make sure',/7x,'that a',
     $    ' phase or species of this name appears on the supporting',
     $    ' data file.')
        endif
c
c       See if an attempt was made to suppress a fictive fugacity
c       fixing phase.
c
        if (unam48(1:8) .eq. ufix(1:8)) then
          write (noutpt,1150) unam48(1:j2)
          write (nttyo,1150) unam48(1:j2)
 1150     format(/' * Note - (EQLIB/supprs) The phase "',a,
     $    '" specified',/7x,'in an nxmod suppress option is a',
     $    ' fictive fugacity-fixing phase.',/7x,"Such a phase can't",
     $    ' be suppressed.')
        endif
c
  150   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write lists of user-suppressed phases and species.
c
      nlist = min(nhitpl,nlpmax)
      if (nlist .gt. 0) then
        if (nlist .eq. 1) then
          write (noutpt,1200)
          write (nttyo,1200)
 1200     format(/' The following phase has been user-suppressed:',/)
        else
          write (noutpt,1210)
          write (nttyo,1210)
 1210     format(/' The following phases have been user-suppressed:',/)
        endif
c
        do n = 1,nlist
          j2 = ilnobl(uusupp(n))
          write (noutpt,1220) uusupp(n)(1:j2)
          write (nttyo,1220) uusupp(n)(1:j2)
 1220     format(4x,a)
        enddo
c
        if (nhitpl .gt. nlist) then
          nn = nhitpl - nlist
          write (ux8,'(i8)') nn
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1230) ux8(1:j2)
          write (nttyo,1230) ux8(1:j2)
 1230     format(6x,'plus ',a,' others')
        endif
      endif
c
      nlist = min(nhitsl,nlsmax)
      if (nlist .gt. 0) then
        if (nlist .eq. 1) then
          write (noutpt,1250)
          write (nttyo,1250)
 1250     format(/' The following species has been user-suppressed:',/)
        else
          write (noutpt,1260)
          write (nttyo,1260)
 1260     format(/' The following species have been user-suppressed:',/)
        endif
c
        do n = 1,nlist
          j2 = ilnobl(uusups(n))
          write (noutpt,1220) uusups(n)(1:j2)
          write (nttyo,1220) uusups(n)(1:j2)
        enddo
c
        if (nhitsl .gt. nlist) then
          nn = nhitsl - nlist
          write (ux8,'(i8)') nn
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1230) ux8(1:j2)
          write (nttyo,1230) ux8(1:j2)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate arrays for lists of user-suppressed phases and species.
c
      DEALLOCATE (uusupp)
      DEALLOCATE (uusups)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine dscram(nf1,nf2)
c
c     This subroutine unscrambles a file of tables whose lines are
c     interspersed, but which are marked 'a', 'b', 'c', etc., in
c     column one. The contents of the scrambled file are copied to
c     the unscrambled file as the unscrambling takes place. The
c     unscrambled file must already be open. The record length of
c     this file will is set at 128 characters.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nf1    = unit number of the scrambled file
c       nf2   = unit number of the unscrambled file
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nf1,nf2
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,i1,i2,j
c
      character*128 uline
      character*1 uc,ux
c
c-----------------------------------------------------------------------
c
      i1 = ichar('a')
      i2 = ichar('Z')
      if (i2 .lt. i1) then
        i1 = ichar('A')
        i2 = ichar('z')
      endif
c
      rewind nf2
      do i = i1,i2
        uc = char(i)
        rewind nf1
        do j = 1,10000
          read (nf1,1000,end=100) ux,uline
 1000     format(a1,a128)
          if (ux .eq. uc) write (nf2,1005) uline
 1005     format(a128)
        enddo
  100   continue
      enddo
c
      end

      subroutine gssum(conc,dpslm,fxi,nslt,nsltmx,nslx,nstmax,pslm,
     $ ssumw,uspec)
c
c     This subroutine computes the following second order sum used
c     in Pitzer's equations:
c
c       SUM(ij) [ S-lambda(ij) + I*S-lambda'(ij) ]*m(i)*m(j)
c
c     This sum is used to calculate the activity coefficient
c     of water.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       nslt   = number of S-lambda functions
c       nslx   = array of S-lambda species index pairs
c       pslm   = array of S-lambda functions
c       dpslm  = array of ionic strength derivatives of S-lambda
c                functions
c
c     Principal output:
c
c       ssumw  = the sum:
c                  SUM(ij) [ S-lambda(ij) + I*S-lambda'(ij) ]*m(i)*m(j)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nsltmx,nstmax
c
      integer nslx(2,nsltmx)
      integer nslt
c
      character(len=48) uspec(nstmax)
c
      real(8) conc(nstmax),dpslm(2,nsltmx),pslm(nsltmx)
      real(8) fxi,ssumw
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nsl,ns1,ns2
c
      real(8) cx
c
c-----------------------------------------------------------------------
c
      ssumw = 0.
      do nsl = 1,nslt
        ns1 = nslx(1,nsl)
        ns2 = nslx(2,nsl)
        cx = 2.
        if (ns1 .eq. ns2) cx = 1.
        ssumw = ssumw
     $  + cx*(pslm(nsl) + fxi*dpslm(1,nsl))*conc(ns1)*conc(ns2)
      enddo
c
      end

      integer function iarmxn(array,nmax)
c
c     This subroutine finds the index of the element corresponding to
c     the max norm of the real*8 array "array". If there is more than
c     one such element, the index returned corresponds to the first one.
c     Note that array could actually have more than one dimension. For
c     example, if the array is really "a", which has dimensions of i1
c     and i2, this subroutine could be used by calling it in the
c     following manner: call iarmxn(a,(i1*i2)). Use this subroutine
c     with caution if nmax is not the product of the true (declared)
c     dimensions.
c
c     To just find the max norm itself, use EQLIBU/arrmxn.f instead.
c
c     This subroutine is nearly identical to EQLIBU/idamax.f, for which
c     the calling sequence arguments are reversed.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array  = the array
c       nmax   = dimension or pseudo-dimension of the array
c
c     Output:
c
c       iarmxn = index of the element corresponding to the max norm
c                  (zero if nmax .le. 0)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft,ix,j
c
      real*8 aax,arrmxn
c
c-----------------------------------------------------------------------
c
      iarmxn = 0
      arrmxn = 0.
      if (nmax .le. 0) go to 999
c
c     Note the use of a local variable (ix) within the loop.
c     Note also that the loop is unrolled.
c
      ix = 0
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        aax = abs(array(i))
        if (aax .gt. arrmxn) then
          ix = i
          arrmxn = aax
        endif
        j = i + 1
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 2
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 3
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 4
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 5
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 6
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 7
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
      enddo
c
      do i = ileft + 1,nmax
        aax = abs(array(i))
        if (aax .gt. arrmxn) then
          ix = i
          arrmxn = aax
        endif
      enddo
c
      iarmxn = ix
c
  999 continue
      end

      subroutine rdazp(azero,insgf,nazt,naztmx,ndat0s,nerr,noutpt,
     $ nttyo,uazp)
c
c     This subroutine reads hard core diamaters and related parameters
c     used in the B-dot equation from the DATA0 file. This data
c     consists of aqueous species names, hard core diameter
c     values, and an integer flag to indicate whether a species that
c     is electrically neutral should be considered polar (set log
c     gamma = 0) or non-polar (log gamma = log gamma for CO2(aq)).
c     The data are returned in the uazp, azero, and insgf arrays. They
c     are later written on the DATA1 and DATA1F files by EQPT/wrazp.f.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       nazt   = the number of specified hard core diameters
c       uazp   = array of aqueous species names used to specify
c                  hard core diamters on the data file
c       azero  = array of corresponding hard core diameters
c       insgf  = array of corresponding neutral species
c                  activity coefficient flags
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer naztmx
c
      integer ndat0s,noutpt,nttyo
c
      integer nazt,nerr
c
      integer insgf(naztmx)
c
      character*24 uazp(naztmx)
c
      real*8 azero(naztmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4
c
      integer ilnobl
c
      character*80 uline
      character*24 ux24
      character*8 ubdot,uterm,ux8
c
c-----------------------------------------------------------------------
c
      data ubdot / 'bdot par' /
      data uterm / '+-------' /
c
c-----------------------------------------------------------------------
c
      nazt = 0
c
c     Advance to bdot header.
c
  100 continue
      read (ndat0s,1000,end=990,err=995) uline
 1000 format(a)
      ux8 = uline(1:8)
      if (ux8(1:8) .ne. ubdot(1:8)) go to 100
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Read in the azero ('bdot') data.
c
  110 continue
      read (ndat0s,1000,end=990,err=995) uline
      ux8 = uline(1:8)
c
      if (ux8(1:8) .eq. uterm(1:8)) then
c
c       Have found the block terminator. Skip past the element
c       header.
c
        read (ndat0s,1000,end=990,err=995) uline
c
        go to 999
      endif
c
c     Found another entry. Read the data from the line.
c
      nazt = nazt + 1
      read(uline,1010,err=998) uazp(nazt),azero(nazt),insgf(nazt)
 1010 format(a24,7x,f7.1,4x,i2)
c
      j2 = ilnobl(uazp(nazt))
      if (j2 .le. 0) then
        write (ux8,'(i5)') nazt
        call lejust(ux8)
        j3 = ilnobl(ux8)
        write (noutpt,1030) ux8(1:j3)
        write (nttyo,1030) ux8(1:j3)
 1030   format(/' * Error - (EQPT/rdazp) Have encountered a blank',
     $  ' species name on line ',a,/7x,'of the block of hard core',
     $  ' diameter values for aqueous species.')
        if (nazt .gt. 1) then
          ux24 = uazp(nazt - 1)
          if (ux24(1:7) .ne. '<blank>') then
            j4 = ilnobl(ux24)
            write (noutpt,1040) ux24(1:j4)
            write (nttyo,1040) ux24(1:j4)
 1040       format(7x,'This line follows the one for ',a,'.')
          endif
        endif
        uazp(nazt) = '<blank>'
        nerr = nerr + 1
      endif
c
      go to 110
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdazp) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
c
      write (noutpt,2010) nazt
      write (nttyo,2010) nazt
 2010 format(7x,'The value of the local block line counter is ',i4,'.')
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
 2030   format(7x,'The last line read was the following:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 write (noutpt,2040)
      write (nttyo,2040)
 2040 format(/' * Error - (EQPT/rdazp) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
c
      write (noutpt,2010) nazt
      write (nttyo,2010) nazt
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  998 write (noutpt,2050)
      write (nttyo,2050)
 2050 format(/' * Error - (EQPT/rdazp) Encountered a read format error',
     $ /7x,'while reading data from lines read from the DATA0 file.')
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2060) uline(1:j2)
        write (nttyo,2060) uline(1:j2)
 2060   format(7x,'The line with the problem is:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $ axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $ ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $ nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $ ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
c
c     This subroutine executes an ordinary basis switch. The ns2-th
c     species (not in the current active basis set) is exchanged into
c     that set for the ns1-th species. All reactions are rewritten where
c     necessary for consistency. Here nbaspx is the unmodified copy of
c     the nbasp array. It contains a record of the basis set prior to
c     basis switching.
c
c     Basis switching is subject to the following rules:
c
c        1. Neither species may be suppressed.
c
c        2. The species switched in must have reaction that gives the
c           species to be switched out as a product.
c
c        3. The species to be switched into the active basis set must
c           not already occupy a position of its own in that set (e.g.,
c           be an active auxiliary basis species). To switch an active
c           auxiliary basis species into the strict basis set (e.g.,
c           make a special basis switch), use EQLIB/swtchb.f.
c
c     The species indices are not interchanged by the switch. If both
c     species are basis species, however, their basis indices are
c     interchanged.
c
c     This subroutine is called by:
c
c       EQLIB/autosw.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c       EQ6/eqcalc.f
c       EQ6/eqphas.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       qbassw = logical flag:
c                  = .true. if the basis set after the current switch
c                    is not identical to the data file basis set
c       qbswok = logical flag:
c                  = .true. if the current switch was completed okay
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),jsflag(nstmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),nbaspx(nbtmax),ndrs(ndrsmx),ndrsx(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrx(2,nstmax)
c
      integer ipch,ipcv,narn1,nb,nbt,nbw,nst,ns2
c
      logical qbassw
c
      character(len=48) uspec(nstmax)
c
      real(8) adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx)
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j,jlen,jlen1,jlen2,jfl,j2,n,nbb,nb2,nmax,nrf1,nrf2,
     $ nrl1,nrl2,nr1,nr2,ns,nse,nsi,ns1,ntf,nx
c
      integer ilnobl,nbasis
c
      logical qbswok
c
      character(len=56) uspn56,usp156,usp256
      character(len=8) ux8
c
      real(8) axx,cx,cxes,cxe1,cxe2,cx1s,cx11,cx12,stofac
c
      real(8) coefdr
c
c-----------------------------------------------------------------------
c
c     Zero scratch arrays.
c
      nmax = narxmx*ntprmx*ipchmx*nstmax
      call initaz(adhfsx,nmax)
c
      nmax = narxmx*ntprmx*ipcvmx*nstmax
      call initaz(advfsx,nmax)
c
      nmax = narxmx*ntprmx*nstmax
      call initaz(axhfsx,nmax)
      call initaz(axlksx,nmax)
      call initaz(axvfsx,nmax)
c
      nmax = 2*nstmax
      call initiz(ndrsrx,nmax)
c
      nmax = ndrsmx
      call initaz(cdrsx,nmax)
      call initiz(ndrsx,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qbswok = .false.
c
      ns1 = nbaspx(nb)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if the switch is okay.
c
      call swtchk(cdrs,jflag,jsflag,nbaspx,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,noutpt,ns1,ns2,nstmax,nttyo,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calling sequence substitutions:
c       jlen1 for jlen
c       uspec(ns1) for unam48
c       usp156 for uspn56
c
      call fmspnx(jlen1,uspec(ns1),usp156)
c
c     Calling sequence substitutions:
c       jlen2 for jlen
c       uspec(ns2) for unam48
c       usp256 for uspn56
c
      call fmspnx(jlen2,uspec(ns2),usp256)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check whether or not the species being switched in is not already
c     in the active basis set (associated with some other mass balance).
c     This is necessary to ensure that the switch to be made is an
c     ordinary basis switch (the only type allowed in the present
c     subroutine).
c
c     Calling sequence substitutions:
c       nbaspx for nbasp
c       ns2 for ns
c
      nb2 = nbasis(nbaspx,nbt,nbtmax,ns2)
c
      if (nb2.gt.0 .and. jflag(ns2).ne.30) then
        write (noutpt,1000) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1000) usp156(1:jlen1),usp256(1:jlen2)
 1000   format(/' * Error - (EQLIB/switch) Programming error trap:',
     $  " Can't replace",/7x,'the species ', a,' in the basis set with',
     $  ' ',a,',',/7x,'doing an ordinary basis switch, because the',
     $  ' former is already',/7x,'in the active basis set.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1010) usp156(1:jlen1),usp256(1:jlen2)
      write (nttyo,1010) usp156(1:jlen1),usp256(1:jlen2)
 1010 format(/' Making an ordinary basis switch: replacing ',a,
     $ /1x,'in the active basis set with ',a,'.',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nb .eq. nbw) then
c
c       Switching solvent water out of the basis set. Write a warning.
c
        write (noutpt,1020) usp156(1:jlen1)
        write (nttyo,1020) usp156(1:jlen1)
 1020   format(/' * Warning - (EQLIB/switch) Making an ordinary',
     $  ' basis switch',/7x,'which moves ',a,' out of the active',
     $  ' basis set.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1040)
 1040 format(/'  Before the switch:',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the existing reaction for the ns1-th species, if any.
c
c     Calling sequence substitutions:
c       noutpt for nf
c       ns1 for ns
c
      call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns1,nstmax,uspec)
c
c     Print the existing linking reaction.
c
c     Calling sequence substitutions:
c       noutpt for nf
c       ns2 for ns
c
      call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns2,nstmax,uspec)
c
      write (noutpt,1050)
 1050 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calling sequence substitutions:
c       ns1 for nse
c       ns2 for ns
c
      cx12 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns2,nstmax)
      nrl1 = ndrsr(1,ns2)
      nrl2 = ndrsr(2,ns2)
c
      nrf1 = ndrsr(1,ns1)
      nrf2 = ndrsr(2,ns1)
      cx11 = cdrs(nrf1)
c
      write (ux8,'(i5)') ndrsmx
      call lejust(ux8)
      j2 = ilnobl(ux8)
c
      nx = 0
      do ns = 1,nst
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        ndrsrx(1,ns) = nx + 1
        if (ns .eq. ns1) then
c
c         Invert the linking reaction. Put the coefficient for the
c         ns1-th species first in the range.
c
          nx = nx + 1
          if (nx .gt. ndrsmx) then
            write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $      usp156(1:jlen1),usp156(1:jlen1)
            write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $      usp156(1:jlen1),usp156(1:jlen1)
 1070       format(/' * Error - (EQLIB/switch) The maximum ',a,
     $      ' entries in the cdrs and ndrs',/7x,'arrays has been',
     $      ' exceeded in trying to switch ',a,/7x,'into the active',
     $      ' basis set for ',a,' while writing',/7x,'the reaction',
     $      ' for ',a,'. Increase the value of the',/7x,
     $      ' dimensioning parameter ndrspa.')
            stop
          endif
          cdrsx(nx) = -cx12
          ndrsx(nx) = ns
          do n = nrl1,nrl2
            if (ndrs(n) .ne. ns) then
              nx = nx + 1
              if (nx .gt. ndrsmx) then
                write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $          usp156(1:jlen1),usp156(1:jlen1)
                write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $          usp156(1:jlen1),usp156(1:jlen1)
                stop
              endif
              cdrsx(nx) = -cdrs(n)
              ndrsx(nx) = ndrs(n)
            endif
          enddo
c
c         Log K coefficients.
c
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = -axlks(i,j,ns2)
            enddo
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axhfsx(i,j,ns) = -axhfs(i,j,ns2)
              enddo
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = -adhfs(i,j,ipc,ns2)
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axvfsx(i,j,ns) = -axvfs(i,j,ns2)
              enddo
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = -advfs(i,j,ipc,ns2)
                enddo
              enddo
            enddo
          endif
c
        elseif (ns .eq. ns2) then
c
          ntf = nrf2 - nrf1 + 1
          if (ntf .lt. 2) then
c
c           If the ns1-th species was a strict basis species, make
c           the ns2-th species into one. Write a null reaction.
c
            nx = nx + 1
            if (nx .gt. ndrsmx) then
              write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $        usp156(1:jlen1),usp256(1:jlen2)
              write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $        usp156(1:jlen1),usp256(1:jlen2)
              stop
            endif
            cdrsx(nx) = 0.
            ndrsx(nx) = 0
c
c           Log K coefficients. Log K = 0 for a strict basis species.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axlksx(i,j,ns) = 0.
              enddo
            enddo
c
            if (ipch .ge. 0) then
c
c             Enthalpy function coefficients. This function is the
c             partial molar enthalpy of formation for a strict
c             basis species.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axx = axhfs(i,j,ns)
                  do n = nr1 + 1,nr2
                    nsi = ndrs(n)
                    cx = cdrs(n)
                    axx = axx - cx*axhfs(i,j,nsi)
                  enddo
                  cx = cdrs(nr1)
                  axhfsx(i,j,ns) = axx/cx
                enddo
              enddo
              do ipc = 1,ipch
                do j = 1,ntprmx
                  do i = 1,narxmx
                    axx = adhfs(i,j,ipc,ns)
                    do n = nr1 + 1,nr2
                      nsi = ndrs(n)
                      cx = cdrs(n)
                      axx = axx - cx*adhfs(i,j,ipc,nsi)
                    enddo
                    cx = cdrs(nr1)
                    adhfsx(i,j,ipc,ns) = axx/cx
                  enddo
                enddo
              enddo
            endif
c
            if (ipcv .ge. 0) then
c
c             Volume function coefficients. This function is the
c             partial molar volume for a strict basis species.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axx = axvfs(i,j,ns)
                  do n = nr1 + 1,nr2
                    nsi = ndrs(n)
                    cx = cdrs(n)
                    axx = axx - cx*axvfs(i,j,nsi)
                  enddo
                  cx = cdrs(nr1)
                  axvfsx(i,j,ns) = axx/cx
                enddo
              enddo
              do ipc = 1,ipcv
                do j = 1,ntprmx
                  do i = 1,narxmx
                    axx = advfs(i,j,ipc,ns)
                    do n = nr1 + 1,nr2
                      nsi = ndrs(n)
                      cx = cdrs(n)
                      axx = axx - cx*advfs(i,j,ipc,nsi)
                    enddo
                    cx = cdrs(nr1)
                    advfsx(i,j,ipc,ns) = axx/cx
                  enddo
                enddo
              enddo
            endif
c
          else
c
c           If the ns1-th species was an auxiliary basis species, make
c           the ns2-th species into one. Write a reaction which is the
c           original reaction for the breakdown of the the ns1-th
c           species, but using the original reaction for the ns1-th
c           species instead of the linking reaction to eliminate the
c           ns1-th species.
c
            stofac = -cx12/cx11
c
c           Go through the species of the existing reaction for the
c           ns2-th species (this is the linking reaction).
c
            do n = nr1,nr2
              nse = ndrs(n)
c
c             Calling sequence substitutions:
c               ns1 for ns
c
              cxe1 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns1,nstmax)
              cx = cdrs(n) + stofac*cxe1
              if (abs(cx) .gt. eps100) then
                nx = nx + 1
                if (nx .gt. ndrsmx) then
                  write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),usp256(1:jlen2)
                  write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),usp256(1:jlen2)
                  stop
                endif
                cdrsx(nx) = cx
                ndrsx(nx) = nse
              endif
            enddo
c
c           Add to the new reaction any species in the original
c           reaction for the breakdown of the ns1-th species.
c
            do n = nrf1,nrf2
              nse = ndrs(n)
              cxes = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
              if (cxes .eq. 0.) then
                cx = stofac*cdrs(n)
                nx = nx + 1
                if (nx .gt. ndrsmx) then
                  write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),usp256(1:jlen2)
                  write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),usp256(1:jlen2)
                  stop
                endif
                cdrsx(nx) = cx
                ndrsx(nx) = nse
              endif
            enddo
c
c           Log K coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axlksx(i,j,ns) = axlks(i,j,ns) + stofac*axlks(i,j,ns1)
              enddo
            enddo
c
            if (ipch .ge. 0) then
c
c             Enthalpy function coefficients.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axhfsx(i,j,ns) = axhfs(i,j,ns) + stofac*axhfs(i,j,ns1)
                enddo
              enddo
              do ipc = 1,ipch
                do j = 1,ntprmx
                  do i = 1,narxmx
                    adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
     $              + stofac*adhfs(i,j,ipc,ns1)
                  enddo
                enddo
              enddo
            endif
c
            if (ipcv .ge. 0) then
c
c             Volume function coefficients.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axvfsx(i,j,ns) = axvfs(i,j,ns)
     $            + stofac*axvfs(i,j,ns1)
                enddo
              enddo
              do ipc = 1,ipcv
                do j = 1,ntprmx
                  do i = 1,narxmx
                    advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
     $              + stofac*advfs(i,j,ipc,ns1)
                  enddo
                enddo
              enddo
            endif
          endif
c
        else
c
c         Do reactions for all other species.
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
c
c         Calling sequence substitutions:
c           ns1 for nse
c
          cx1s = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns,nstmax)
          if (cx1s .eq. 0.) then
c
c           Have a reaction which is not connected. Copy as is.
c
            do n = nr1,nr2
              nx = nx + 1
              if (nx .gt. ndrsmx) then
              write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $          usp156(1:jlen1),uspn56(1:jlen)
                write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $          usp156(1:jlen1),uspn56(1:jlen)
                stop
              endif
              cdrsx(nx) = cdrs(n)
              ndrsx(nx) = ndrs(n)
            enddo
c
c           Log K coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axlksx(i,j,ns) = axlks(i,j,ns)
              enddo
            enddo
c
            if (ipch .ge. 0) then
c
c             Enthalpy function coefficients.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axhfsx(i,j,ns) = axhfs(i,j,ns)
                enddo
              enddo
              do ipc = 1,ipch
                do j = 1,ntprmx
                  do i = 1,narxmx
                    adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
                  enddo
                enddo
              enddo
            endif
c
            if (ipcv .ge. 0) then
c
c             Volume function coefficients.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axvfsx(i,j,ns) = axvfs(i,j,ns)
                enddo
              enddo
              do ipc = 1,ipcv
                do j = 1,ntprmx
                  do i = 1,narxmx
                    advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
                  enddo
                enddo
              enddo
            endif
c
          else
c
c           Have a reaction which is connected.
c
            stofac = -cx1s/cx12
c
c           Go through the species of the existing reaction for the
c           ns-th species.
c
            do n = nr1,nr2
              nse = ndrs(n)
c
c             Calling sequence substitutions:
c               ns2 for ns
c
              cxe2 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns2,nstmax)
              cx = cdrs(n) + stofac*cxe2
              if (abs(cx) .gt. eps100) then
                nx = nx + 1
                if (nx .gt. ndrsmx) then
                  write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),uspn56(1:jlen)
                  write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),uspn56(1:jlen)
                  stop
                endif
                cdrsx(nx) = cx
                ndrsx(nx) = nse
              endif
            enddo
c
c           Add to the new reaction any species in the linking reaction
c           that were not in the original reaction for the breakdown of
c           the ns-th species.
c
            do n = nrl1,nrl2
              nse = ndrs(n)
              cxes = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
              if (cxes .eq. 0.) then
                cx = stofac*cdrs(n)
                nx = nx + 1
                if (nx .gt. ndrsmx) then
                  write (noutpt,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),uspn56(1:jlen)
                  write (nttyo,1070) ux8(1:j2),usp256(1:jlen2),
     $            usp156(1:jlen1),uspn56(1:jlen)
                  stop
                endif
                cdrsx(nx) = cx
                ndrsx(nx) = nse
              endif
            enddo
c
c           Log K coefficients.
c
            do j = 1,ntprmx
              if (axlks(1,j,ns) .lt. 9999999.) then
                do i = 1,narxmx
                  axlksx(i,j,ns) = axlks(i,j,ns) + stofac*axlks(i,j,ns2)
                enddo
              endif
            enddo
c
            if (ipch .ge. 0) then
c
c             Enthalpy function coefficients.
c
              do j = 1,ntprmx
                if (axhfs(1,j,ns) .lt. 9999999.) then
                  do i = 1,narxmx
                    axhfsx(i,j,ns) = axhfs(i,j,ns)
     $              + stofac*axhfs(i,j,ns2)
                  enddo
                endif
              enddo
              do ipc = 1,ipch
                do j = 1,ntprmx
                  do i = 1,narxmx
                    adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
     $              + stofac*adhfs(i,j,ipc,ns2)
                  enddo
                enddo
              enddo
            endif
c
            if (ipcv .ge. 0) then
c
c             Enthalpy function coefficients.
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  if (axvfs(1,j,ns) .lt. 9999999.) then
                    axvfsx(i,j,ns) = axvfs(i,j,ns)
     $              + stofac*axvfs(i,j,ns2)
                  endif
                enddo
              enddo
              do ipc = 1,ipcv
                do j = 1,ntprmx
                  do i = 1,narxmx
                    advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
     $              + stofac*advfs(i,j,ipc,ns2)
                  enddo
                enddo
              enddo
            endif
c
          endif
c
        endif
        ndrsrx(2,ns) = nx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the new reactions from the 'x' arrays into the standard
c     arrays.
c
      call cdrscx(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,axlks,
     $ axlksx,axvfs,axvfsx,cdrs,cdrsx,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,nstmax,ntprmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1090)
 1090 format(/'  After the switch:',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the new linking reaction.
c
c     Calling sequence substitutions:
c       noutpt for nf
c       ns1 for ns
c
      call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns1,nstmax,uspec)
c
c     Print the new reaction for the ns2-th species.
c
c     Calling sequence substitutions:
c       noutpt for nf
c       ns2 for ns
c
      call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns2,nstmax,uspec)
c
      write (noutpt,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Exchange jflag values.
c
      jfl = jflag(ns1)
      jflag(ns1) = jflag(ns2)
      jflag(ns2) = jfl
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Clear the content in the nbasp and nbaspx arrays which constitutes
c     the instruction to make the current switch. Change the nbaspx
c     entry to clear the instruction for the current switch.
c
      nbaspx(nb) = ns2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If necessary, reset the basis index of water (nbw).
c
      if (ns1 .eq. narn1) then
        nbw = 0
      elseif (ns2 .eq. narn1) then
        nbw = nb
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the flag indicating that the switch completed successfully.
c
      qbswok = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the value of the qbassw flag. Set it to .true. if
c     the basis set is not identical to the corresponding data file
c     basis set.
c
      qbassw = .false.
      do nbb = 1,nbt
        ns1 = nbaspd(nbb)
        ns2 = nbasp(nbb)
        if (ns2 .ne. ns1) go to 200
      enddo
      qbassw = .true.
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine bldspc(iaapr,icapr,iccpr,inapr,incpr,innpr,
     $ in2pr,iaactr,ia2ctr,iccatr,ic2atr,incatr,in2ntr,in3tr,
     $ jassan,jassca,jassne,nat,natmax,naapr,ncapr,nccpr,nnapr,
     $ nncpr,nnnpr,nn2pr,naactr,na2ctr,nncatr,nccatr,nc2atr,
     $ nn2ntr,nn3tr,uaqsp,zaqsp)
c
c     Build index arrays for the pair and triplet combinations of
c     aqueous solute species for use with Pitzer parameters.
c
c     All pairs and triplets are distinct in the sense that the
c     ordering of the members is not relevant; e.g., ca = ac,
c     cc' = c'c, nca = anc = can = cna = acn = nac.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       naapr  = number of aa' pairs
c       ncapr  = number of ca pairs
c       nccpr  = number of cc' pairs
c       nnapr  = number of na pairs
c       nncpr  = number of nc pairs
c       nnnpr  = number of nn' pairs
c       nn2pr  = number of nn pairs
c
c       naactr = number of aa'c triplets
c       na2ctr = number of aac triplets
c       nccatr = number of cc'a triplets
c       nc2atr = number of cca triplets
c       nncatr = number of nca triplets
c       nn3tr = number of nnn triplets
c       nn2ntr = number of nnn' triplets
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c       zaqsp  = array of electrical charages of aqueous species
c
c     Principal output:
c
c       iaapr  = array of indices of species in aa' pairs
c       icapr  = array of indices of species in ca pairs
c       iccpr  = array of indices of species in cc' pairs
c       inapr  = array of indices of species in na pairs
c       incpr  = array of indices of species in nc pairs
c       innpr  = array of indices of species in nn' pairs
c       in2pr  = array of indices of species in nn pairs
c
c       iaactr = array of indices of species in aa'c triplets
c       ia2ctr = array of indices of species in aac triplets
c       iccatr = array of indices of species in cc'a triplets
c       ic2atr = array of indices of species in cca triplets
c       incatr = array of indices of species in nca triplets
c       in3tr = array of indices of species in nnn triplets
c       in2ntr = array of indices of species in nnn' triplets
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax
c
      integer naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr,
     $ naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr
c
      integer iaapr(2,naapr),icapr(2,ncapr),iccpr(2,nccpr),
     $ inapr(2,nnapr),incpr(2,nncpr),innpr(2,nnnpr),in2pr(nn2pr)
c
      integer iaactr(3,naactr),ia2ctr(2,na2ctr),iccatr(3,nccatr),
     $ ic2atr(2,nc2atr),incatr(3,nncatr),in2ntr(2,nn2ntr),in3tr(nn3tr)
c
      integer jassan,jassca,jassne,nat
c
      character(len=24) uaqsp(natmax)
c
      real*8 zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer, dimension(:), allocatable :: iworka,iworkc,iworkn
c
      character(len=24), dimension(:), allocatable :: uworka,uworkc,
     $ uworkn
c
      integer i,j,k,jn,jc,ja,n,npr
c
c-----------------------------------------------------------------------
c
c     Allocate work arrays.
c
      ALLOCATE(iworkn(jassne))
      ALLOCATE(iworkc(jassca))
      ALLOCATE(iworka(jassan))
c
      ALLOCATE(uworkn(jassne))
      ALLOCATE(uworkc(jassca))
      ALLOCATE(uworka(jassan))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build scratch lists for cations, anions, and neutrals.
c     Do not include solvent water or O2(g) in the neutrals list.
c     Do not include e- on the anions list.
c
      jn = 0
      jc = 0
      ja = 0
      do n = 2,nat
        if (zaqsp(n) .eq. 0.) then
          if (uaqsp(n)(1:6) .ne. 'O2(g) ') then
            jn = jn + 1
            uworkn(jn) = uaqsp(n)
            iworkn(jn) = n
          endif
        elseif (zaqsp(n) .gt. 0.) then
          jc = jc + 1
          uworkc(jc) = uaqsp(n)
          iworkc(jc) = n
        else
          if (uaqsp(n)(1:3) .ne. 'e- ') then
            ja = ja + 1
            uworka(ja) = uaqsp(n)
            iworka(ja) = n
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Construct the index array for ca pairs.
c
      n = 0
      do i = 1,jc
        do j = 1,ja
          n = n + 1
          icapr(1,n) = iworkc(i)
          icapr(2,n) = iworka(j)
        enddo
      enddo
c
c     Construct the index array for cc' pairs (c' != c).
c
      n = 0
      do i = 1,jc
        do j = i + 1,jc
          n = n + 1
c
c         Store the pair in alphabetical order.
c
          if (uworkc(i) .lt. uworkc(j)) then
            iccpr(1,n) = iworkc(i)
            iccpr(2,n) = iworkc(j)
          else
            iccpr(1,n) = iworkc(j)
            iccpr(2,n) = iworkc(i)
          endif
        enddo
      enddo
c
c     Construct the index array for anion-distinct anion pairs.
c     Ignore pairs where an anion is paired with itself, such as
c     Cl-, Cl-, because the associated Pitzer coefficients are
c     either implicitly undefined or explicitly set to zero.
c     Ignore pairs where an anion is paired with itself.
c
      n = 0
      do i = 1,ja
        do j = i + 1,ja
          n = n + 1
c
c         Store the pair in alphabetical order.
c
          if (uworka(i) .lt. uworka(j)) then
            iaapr(1,n) = iworka(i)
            iaapr(2,n) = iworka(j)
          else
            iaapr(1,n) = iworka(j)
            iaapr(2,n) = iworka(i)
          endif
        enddo
      enddo
c
c     Construct the index array for nn pairs.
c
      n = 0
      do i = 1,jn
        n = n + 1
c
c       Store the "pair."
c
        in2pr(n) = iworkn(i)
      enddo
c
c     Construct the index array for nn' pairs.
c
      n = 0
      do i = 1,jn
        do j = i + 1,jn
          n = n + 1
c
c         Store the pair in alphabetical order.
c
          if (uworkn(i) .le. uworkn(j)) then
            innpr(1,n) = iworkn(i)
            innpr(2,n) = iworkn(j)
          else
            innpr(1,n) = iworkn(j)
            innpr(2,n) = iworkn(i)
          endif
        enddo
      enddo
c
c     Construct the index array for nc pairs.
c
      n = 0
      do i = 1,jn
        do j = 1,jc
          n = n + 1
          incpr(1,n) = iworkn(i)
          incpr(2,n) = iworkc(j)
        enddo
      enddo
c
c     Construct the index array for na pairs.
c
      n = 0
      do i = 1,jn
        do j = 1,ja
          n = n + 1
          inapr(1,n) = iworkn(i)
          inapr(2,n) = iworka(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Construct the index array for cca triplets. Note that we will
c     generally just use the icapr array whenever the ic2atr array
c     is required.
c
      do n = 1,nc2atr
        ic2atr(1,n) = icapr(1,n)
        ic2atr(2,n) = icapr(2,n)
      enddo
c
c     Construct the index array for aac triplets. Note that we will
c     generally just use the icapr array whenever the ia2ctr array
c     is required.
c
      do n = 1,na2ctr
        ia2ctr(1,n) = icapr(2,n)
        ia2ctr(2,n) = icapr(1,n)
      enddo
c
c     Construct the index array for nnn triplets. Note that we will
c     generally just use the in2pr array whenever the ic2atr array
c     is required.
c
      do n = 1,nn3tr
        in3tr(n) = in2pr(n)
      enddo
c
c     Construct the index array for nnn' triplets. Note that we could
c     just use the innpr array (with some manipulation to account for
c     the fact that there are two triplets nnn' and n'n'n for each pair
c     nn') whenever the in2ntr array is required. See comments above
c     for the ic2atr array. Also note that nn2ntr = 2*nn2pr.
c
      n = 0
      do npr = 1,nn2pr
c
c       Store the two triplet combinations corresponding to a given
c       pair together.
c
        n = n + 1
        in2ntr(1,n) = innpr(1,npr)
        in2ntr(2,n) = innpr(2,npr)
        n = n + 1
        in2ntr(1,n) = innpr(2,npr)
        in2ntr(2,n) = innpr(1,npr)
      enddo
c
c     Construct the index array for cc'a triplets.
c
      n = 0
      do i = 1,jc
        do j = i + 1,jc
          do k = 1,ja
            n = n + 1
c
c           Store the two cations in alphabetical order.
c
            if (uworkc(i) .le. uworkc(j)) then
              iccatr(1,n) = iworkc(i)
              iccatr(2,n) = iworkc(j)
            else
              iccatr(1,n) = iworkc(j)
              iccatr(2,n) = iworkc(i)
            endif
            iccatr(3,n) = iworka(k)
          enddo
        enddo
      enddo
c
c     Construct the index array for aac triplets.
c
      n = 0
      do i = 1,ja
        do j = i + 1,ja
          do k = 1,jc
            n = n + 1
c
c           Store the two anions in alphabetical order.
c
            if (uworka(i) .le. uworka(j)) then
              iaactr(1,n) = iworka(i)
              iaactr(2,n) = iworka(j)
            else
              iaactr(1,n) = iworka(j)
              iaactr(2,n) = iworka(i)
            endif
            iaactr(3,n) = iworkc(k)
          enddo
        enddo
      enddo
c
c     Construct the index array for nca triplets.
c
      n = 0
      do i = 1,jn
        do j = 1,jc
          do k = 1,ja
            n = n + 1
            incatr(1,n) = iworkn(i)
            incatr(2,n) = iworkc(j)
            incatr(3,n) = iworka(k)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate work arrays.
c
      DEALLOCATE(iworka)
      DEALLOCATE(iworkc)
      DEALLOCATE(iworkn)
c
      DEALLOCATE(uworka)
      DEALLOCATE(uworkc)
      DEALLOCATE(uworkn)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gtemp(afcnst,al10,iopt,jtemp,noptmx,noutpt,nttkmx,
     $ nttyo,rconst,rtcnst,tempc,tempcb,tempk,time1,ttk,xi1)
c
c     This subroutine computes the temperature (tempc) as a function of
c     reaction progress (xi1) or time (time1).
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jtemp  = temperature tracking flag
c       ttk    = temperature tracking coefficients
c       time1  = time variable
c       xi1    = reaction progress variable
c
c     Principal output:
c
c       tempc  = temperature, C
c       tempk  = temperature, K
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noptmx,nttkmx
c
      integer iopt(noptmx)
      integer jtemp,noutpt,nttyo
c
      real(8) ttk(nttkmx)
      real(8) afcnst,al10,rconst,rtcnst,tempc,tempcb,tempk,time1,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real(8) tmpmin,tmpmax
c
c-----------------------------------------------------------------------
c
c     Allowed range of the temperature (C):
c
      data tmpmin,tmpmax /-273.15,1400./
c
c-----------------------------------------------------------------------
c
      if (jtemp .eq. 0) then
c
c       Constant temperature.
c
        tempc = tempcb
      elseif (jtemp .eq. 1) then
c
c       Linear tracking in Xi.
c
        tempc = tempcb + ttk(1)*xi1
      elseif (jtemp .eq. 2) then
c
c       Linear tracking in time.
c
        tempc = tempcb + ttk(1)*time1
      elseif (jtemp .eq. 3) then
c
c       Fluid mixing tracking.
c
        tempc = ( tempcb*ttk(1) + xi1*ttk(2) )/( xi1 + ttk(1) )
      endif
c
      tempk = tempc + 273.15
      rtcnst = 0.001*rconst*tempk
      afcnst = al10*rtcnst
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Stop if tempc is less than tmpmin or greater than tmpmax.
c
      if (tempc.lt.tmpmin .or. tempc.gt.tmpmax) then
        write (noutpt,1010) tempc,tmpmin,tmpmax,xi1
        write (nttyo,1010) tempc,tmpmin,tmpmax,xi1
 1010   format(/' * Error - (EQ6/gtemp) The calculated temperature',
     $  /7x,'is ',g10.3," C, outside the code's built-in allowed",
     $  /7x,'range of ',g10.3,'-',g10.3,' C. Other limits associated',
     $  /7x,'with the supporting data file may also apply.',
     $  /7x,'The current value of reaction progress is ',
     $  g12.5,' moles.')
        if (iopt(2) .gt. 0) then
          write (noutpt,1020) time1
          write (nttyo,1020) time1
 1020     format(7x,'The current time value is ',g10.3,' seconds.')
        endif
        stop
      endif
c
  999 continue
      end

      subroutine satchk(acflg,act,actlg,afcnst,affp,affs,apx,bpx,
     $ cdrs,eps100,iindx1,iodb,iopt,iapxmx,ibpxmx,iktmax,ixrn1,jflag,
     $ jpflag,jsflag,jsol,kmax,km1,kpsat,kpsst,kxt,nbasp,nbt,nbtmax,
     $ ncmpr,ndrs,ndrsmx,ndrsr,nodbmx,noptmx,noutpt,npchk,npt,nptmax,
     $ nstmax,nttyo,nxrn1,nxrn2,nxtmax,qxknph,sidrph,sidrsp,tolsat,
     $ uphase,uspec,wfac,xbar,xbarlg,xlks)
c
c     This subroutine checks for newly saturated phases and
c     supersaturated phases.
c
c     This subroutine is called by:
c
c       EQ6/eqphas.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       affp   = array of affinities associated with phases
c       affs   = array of affinities associated with species
c       jpflag = status flag array for phases
c       kpsat  = number of newly saturated phases
c       kpsst  = number of supersaturated phases
c       sidrph = array of saturation indices (log Q/K) associated
c                  with phases
c       sidrsp = array of saturation indices (log Q/K) associated
c                  with species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,ibpxmx,iktmax,kmax,nbtmax,ndrsmx,nodbmx,noptmx,
     $ nptmax,nstmax,nxtmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),iodb(nodbmx),iopt(noptmx),jflag(nstmax),
     $ jpflag(nptmax),jsflag(nstmax),jsol(nxtmax),nbasp(nbtmax),
     $ ncmpr(2,nptmax),ndrs(ndrsmx),ndrsr(2,nstmax),npchk(nptmax)
c
      integer ixrn1,km1,kpsat,kpsst,kxt,nbt,npt,nxrn1,nxrn2
c
      logical qxknph(nptmax)
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 acflg(nstmax),act(nstmax),actlg(nstmax),affp(nptmax),
     $ affs(nstmax),apx(iapxmx,nxtmax),bpx(ibpxmx,nxtmax),cdrs(ndrsmx),
     $ sidrph(nptmax),sidrsp(nstmax),wfac(iktmax,nxtmax),xbar(nstmax),
     $ xbarlg(nstmax),xlks(nstmax)
c
      real*8 afcnst,eps100,tolsat
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,j2,kcol,nb,np,nr1,nr2,ns,nt
c
      integer ilnobl
c
      logical qtest
c
      character*24 uaqsln,ugas
c
      real*8 af,si
c
c-----------------------------------------------------------------------
c
      data uaqsln /'Aqueous solution        '/
     $     ugas   /'Gas                     '/
c
c-----------------------------------------------------------------------
c
cXX   This double-checking of the jsflag and jpflag arrays shouldn't be
cXX   necessary.
c     Double-check flags on status of non-aqueous phases which are
c     in the matrix.
c
      do np = 1,npt
        if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
          if (jpflag(np) .le. 0) then
            jpflag(np) = 0
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do ns = nr1,nr2
              if (jsflag(ns) .le. 0) then
                jsflag(ns) = 0
                do kcol = km1,kxt
                  if (ns .eq. iindx1(kcol)) then
                    jsflag(ns) = -1
                    jpflag(np) = -1
                    go to 30
                  endif
                enddo
              endif
   30       continue
            enddo
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kpsat = 0
      kpsst = 0
c
c     Compute affinities.
c
      do np = 1,npt
        nr1 = ncmpr(1,np)
        nr2 = ncmpr(2,np)
        nt = nr2 - nr1 + 1
c
        if (uphase(np)(1:24) .eq. ugas(1:24)) then
c
c         Case of a gas phase.
c
          affp(np) = -9999999.
          sidrph(np) = -9999999.
          do ns = nr1,nr2
            affs(ns) = -9999999.
            sidrsp(ns) = -9999999.
          enddo
c
        elseif (nt .eq. 1) then
c
c         Case of a pure phase.
c
          ns = nr1
          if (jpflag(np) .le. 1) then
            call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,ndrsmx,
     $      ndrsr,ns,nstmax,si,xlks)
            affs(ns) = af
            affp(np) = af
          else
            af = -9999999.
            si = -9999999.
          endif
          affs(ns) = af
          affp(np) = af
          sidrsp(ns) = si
          sidrph(np) = si
c
        elseif (uphase(np)(1:24) .eq. uaqsln(1:24)) then
c
c         Case of an aqueous solution.
c
          if (jpflag(np) .le. 1) then
            affp(np) = 0.
            sidrph(np) = 0.
            do nb = 1,nbt
              ns = nbasp(nb)
              if (jsflag(ns) .le. 1) then
                call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,
     $          ndrsmx,ndrsr,ns,nstmax,si,xlks)
                affs(ns) = af
                sidrsp(ns) = si
                affp(np) = affp(np) + xbar(ns)*affs(ns)
                sidrph(np) = sidrph(np) + xbar(ns)*sidrsp(ns)
              else
                affs(ns) = -9999999.
                sidrsp(ns) = -9999999.
              endif
            enddo
          else
            affp(np) = -9999999.
            sidrph(np) = -9999999.
          endif
c
        elseif (iopt(4) .ge. 1) then
c
c         If not doing non-aqueous solutions, skip.
c
          if (jpflag(np) .eq. -1) then
c
c           Case of non-aqueous solutions in the ES.
c
            qxknph(np) = .true.
            affp(np) = 0.
            sidrph(np) = 0.
            qtest = .false.
            do ns = nr1,nr2
              if (jsflag(ns) .le. 1) then
                call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,
     $          ndrsmx,ndrsr,ns,nstmax,si,xlks)
                affs(ns) = af
                sidrsp(ns) = si
                affp(np) = affp(np) + xbar(ns)*affs(ns)
                sidrph(np) = sidrph(np) + xbar(ns)*sidrsp(ns)
                qtest = .true.
              else
                affs(ns) = -9999999.
                sidrsp(ns) = -9999999.
              endif
            enddo
            if (.not.qtest) then
              affp(np) = -9999999.
              sidrph(np) = -9999999.
            endif
          elseif (jpflag(np) .le. 1) then
c
c           Case of non-aqueous solutions not in the ES.
c
            call hpsat(acflg,act,actlg,afcnst,affp,affs,apx,bpx,
     $      cdrs,eps100,iapxmx,ibpxmx,ier,iktmax,ixrn1,jflag,jpflag,
     $      jsflag,jsol,ncmpr,ndrs,ndrsmx,ndrsr,noutpt,np,nptmax,
     $      nstmax,nttyo,nxrn1,nxrn2,nxtmax,sidrsp,sidrph,uphase,
     $      uspec,wfac,xbar,xbarlg,xlks)
c
            if (ier .le. 0) then
              qxknph(np) = .true.
            else
              qxknph(np) = .false.
              j2 = ilnobl(uphase(np))
              write (noutpt,2005) uphase(np)(1:j2)
              write (nttyo,2005) uphase(np)(1:j2)
 2005         format(/' * Warning - (EQ6/satchk) A hypothetical',
     $        ' affinity calculation',/7x,'failed for solid',
     $        ' solution ',a,'.')
              affp(np) = -9999999.
              sidrph(np) = -9999999.
              do ns = nr1,nr2
                affs(ns) = -9999999.
                sidrsp(ns) = -9999999.
              enddo
            endif
          endif
        endif
c
c       Set the jpflag array to mark supersaturated and newly saturated
c       phases.
c
        if (jpflag(np).le.0 .and. jpflag(np).ne.-1 .and.
     $    npchk(np) .ne. 1) then
          if (abs(affp(np)) .le. tolsat) then
            jpflag(np) = -10
            kpsat = kpsat + 1
          elseif (affp(np) .gt. tolsat) then
            jpflag(np) = -2
            kpsst = kpsst + 1
          endif
        endif
c
c       Set the jsflag array to mark the corresponding species.
c
        if (uphase(np)(1:24) .eq. uaqsln(1:24)) then
          do nb = 1,nbt
            ns = nbasp(nb)
            if (jsflag(ns).le.0 .and. jsflag(ns).ne.-1) then
              if (abs(affs(ns)) .le. tolsat) then
                jsflag(ns) = -10
              elseif (affs(ns) .gt. tolsat) then
                jsflag(ns) = -2
              endif
            endif
          enddo
        else
          do ns = nr1,nr2
            if (jsflag(ns).le.0 .and. jsflag(ns).ne.-1) then
              if (abs(affs(ns)) .le. tolsat) then
                jsflag(ns) = -10
              elseif (affs(ns) .gt. tolsat) then
                jsflag(ns) = -2
              endif
            endif
          enddo
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine tprn2n(amun2n,apsi,innpr,in2pr,in2ntr,ipbtmx,
     $ jpfcmx,natmax,ncvn2n,nerr,nnnpr,nn2pr,nn2ntr,noutpt,npx3mx,
     $ npx3t,nttyo,nwarn,pcvn2n,qpdnn,qpdn2,qpdn2n,uaqsp,utripl)
c
c     Test and process the Pitzer data for nnn' (neutral, same neutral,
c     different neutral) triplets read from the DATA0 file. Find and
c     flag errors, such as duplication of data (e.g., two data blocks
c     for the same repeated neutral-distinct neutral triplet). The
c     conventional primitive Pitzer parameters are identical to the
c     observable parameters read from the data file:
c
c       mu(nnn') -> mu(nnn')
c
c     Note that there are two mu parameters mu(nnn') and mu(n'n'n)
c     for each corresponding lambda parameter lambda(nn'). Both are
c     handled in one set.
c
c     Check the coverage of entered Pitzer data against all possible
c     nnn' triplets that can be composed of the neutral species present
c     on the data file.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,nnnpr,nn2ntr,nn2pr,npx3mx
c
      integer noutpt,nttyo
c
      integer innpr(2,nnnpr),in2pr(nn2pr),in2ntr(2,nn2ntr)
c
      integer ncvn2n,nerr,npx3t,nwarn
c
      logical qpdnn(nnnpr),qpdn2(nn2pr),qpdn2n(nn2ntr)
c
      character(len=24) uaqsp(natmax),utripl(3,npx3mx)
c
      real*8 amun2n(jpfcmx,nn2ntr),apsi(jpfcmx,npx3mx)
c
      real*8 pcvn2n
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,j,jj,jt,jtripl,j2,j3,j4,j5,j6,k,n,ncount,ndupl,
     $ nlistl,nn,nodatc
c
      integer ilnobl
c
      logical qfound1,qfound2,qfound3
c
      character*80 ustr80
      character*24 unam1,unam2,unam3
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Limit on the list of triplets for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the data arrays.
c
      do n = 1,nn2ntr
        qpdn2n(n) = .false.
        do j = 1,jpfcmx
          amun2n(j,n) = 0.
        enddo
      enddo
c
c     Check the entered data for nnn' triplets.
c
      nodatc = 0
c
      do n = 1,nn2ntr
        i = in2ntr(1,n)
        j = in2ntr(1,n)
        k = in2ntr(2,n)
        unam1 = uaqsp(i)
        unam2 = uaqsp(j)
        unam3 = uaqsp(k)
        j2 = ilnobl(unam1)
        j3 = ilnobl(unam2)
        j4 = ilnobl(unam3)
c
c       Search for unam1, unam2, unam3 in the utripl array.
c       That array corresponds to the species triplets blocks.
c
        call srch33(jtripl,unam1,unam2,unam3,utripl,npx3mx,npx3t)
c
        if (jtripl .le. 0) then
c
c
c         No data block was found on the DATA0 file.
c         Note that qpdn2n(n) is left with a value of .false.
c
          nodatc = nodatc + 1
        else
c
c         Have found an entry.
c
          qpdn2n(n) = .true.
c
c         Store the data.
c
          do j = 1,jpfcmx
            amun2n(j,n) = apsi(j,jtripl)
          enddo
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jt = jtripl + 1,npx3t
            if (unam1(1:24) .eq. utripl(1,jt)(1:24)) then
              if (unam2(1:24) .eq. utripl(2,jt)(1:24)) then
                if (unam3(1:24) .eq. utripl(3,jt)(1:24)) then
                  ndupl = ndupl + 1
                endif
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam2(1:j3),unam3(1:j4)
              write (nttyo,1010) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1010         format(/' * Error - (EQPT/tprn2n) Have found a',
     $        ' duplicate data block on the DATA0 file',
     $        /7x,"for the nnn' triplet ",a,', ',a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j6 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j6),unam1(1:j2),unam2(1:j3),
     $        unam3(1:j4)
              write (nttyo,1020) ux8(1:j6),unam1(1:j2),unam2(1:j3),
     $        unam3(1:j4)
 1020         format(/' * Error - (EQPT/tprn2n) Have found ',a,
     $        ' duplicate data blocks on the DATA0 file',
     $        /7x,"for the nnn' triplet ",a,', ',a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
c         Check for the presence of the corresponding lamda(nn),
c         lambda(n'n'), and lambda(nn')  data. The presence of these
c         data on the data file is required.
c
          qfound1 = .false.
c
          do nn = 1,nn2pr
            ii = in2pr(nn)
            if (uaqsp(ii)(1:24) .eq. unam1(1:24)) then
              if (qpdn2(nn)) then
                qfound1 = .true.
                go to 130
              endif
            endif
          enddo
  130     continue
c
          qfound2 = .false.
c
          do nn = 1,nn2pr
            ii = in2pr(nn)
            if (uaqsp(ii)(1:24) .eq. unam3(1:24)) then
              if (qpdn2(nn)) then
                qfound2 = .true.
                go to 140
              endif
            endif
          enddo
  140     continue
c
          qfound3 = .false.
c
          if (unam1 .lt. unam3) then
            do nn = 1,nnnpr
              ii = innpr(1,nn)
              if (uaqsp(ii)(1:24) .eq. unam1(1:24)) then
                jj = innpr(2,nn)
                if (uaqsp(jj)(1:24) .eq. unam3(1:24)) then
                  if (qpdnn(nn)) then
                    qfound3 = .true.
                    go to 150
                  endif
                endif
              endif
            enddo
  150       continue
          else
            do nn = 1,nnnpr
              ii = innpr(1,nn)
              if (uaqsp(ii)(1:24) .eq. unam3(1:24)) then
                jj = innpr(2,nn)
                if (uaqsp(jj)(1:24) .eq. unam1(1:24)) then
                  if (qpdnn(nn)) then
                    qfound3 = .true.
                    go to 160
                  endif
                endif
              endif
            enddo
  160       continue
          endif
c
          if (.not.(qfound1 .and. qfound2 .and. qfound3)) then
c
c           Certain required data were not found on the DATA0 file.
c
            write (noutpt,1030) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1030) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1030       format(/' * Error - (EQPT/tprn2n) Have data on the DATA0',
     $      " file for the nnn'",/7x,'triplet ',a,', ',a,', ',a,', but',
     $      " don't have the",/7x,'required data for the following',
     $      ' neutral-neutral pair(s):',/)
c
            if (.not.qfound1) then
              write (noutpt,1040) unam1(1:j2),unam1(1:j2)
              write (nttyo,1040) unam1(1:j2),unam1(1:j2)
 1040         format(9x,a,', ',a)
            endif
c
            if (.not.qfound2) then
              write (noutpt,1040) unam3(1:j4),unam3(1:j4)
              write (nttyo,1040) unam3(1:j4),unam3(1:j4)
            endif
c
            if (.not.qfound3) then
              write (noutpt,1040) unam1(1:j2),unam3(1:j4)
              write (nttyo,1040) unam1(1:j2),unam3(1:j4)
            endif
c
            nerr = nerr + 1
          endif
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1050)
        write (nttyo,1050)
 1050   format(/' * Warning - (EQPT/tprn2n) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  " nnn' triplets:",/)
c
        ncount = 0
        do n = 1,nn2ntr
          if (.not.qpdn2n(n)) then
            ncount = ncount + 1
            i = in2ntr(1,n)
            j = in2ntr(1,n)
            k = in2ntr(2,n)
            unam1 = uaqsp(i)
            unam2 = uaqsp(j)
            unam3 = uaqsp(k)
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            j4 = ilnobl(unam3)
            ustr80 = unam1(1:j2) // ', ' // unam2(1:j3) //
     $      ', ' // unam3(1:j4)
            j5 = ilnobl(ustr80)
            write (noutpt,1060) ustr80(1:j5)
            write (nttyo,1060) ustr80(1:j5)
 1060       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1070) ux8(1:j3)
          write (nttyo,1070) ux8(1:j3)
 1070     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1080)
        write (nttyo,1080)
 1080   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvn2n = nn2ntr - nodatc
      pcvn2n = (100.*ncvn2n)/float(nn2ntr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine timeca(deltim,delxi,drir0,iodb,nodbmx,nord,noutpt,
     $ nrd1mx,nttyo,prcinf,qriinf,rirec0,time0,time1)
c
c     This subroutine calculates the interval (deltim) of model time
c     that corresponds to the reaction progress interval (delxi).
c
c     This subroutine is called by:
c
c       EQ6/chksti.f
c       EQ6/eqshel.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
      integer nord
c
      logical qriinf
c
      real*8 drir0(nrd1mx)
      real*8 deltim,delxi,prcinf,rirec0,time0,time1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,n
c
      real*8 dxp
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      if (qriinf) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/' * Note - (EQ6/timeca) Have encountered an infinite',
     $  /7x,'time interval.')
        time1 = prcinf
        deltim = prcinf
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      deltim = rirec0*delxi
      if (nord .gt. 0) then
        dxp = delxi
        do n = 1,nord
          i = n + 1
          dxp = dxp*delxi
          deltim = deltim + ( drir0(n)*dxp )/fctrl(i)
        enddo
      endif
      time1 = time0 + deltim
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (deltim.le.0. .and. delxi.gt.0.) then
        if (iodb(2) .gt. 0) then
          write (noutpt,1010) deltim,nord
          write (nttyo,1010) deltim,nord
 1010     format(/' * Note - (EQ6/timeca) Have encountered a',
     $    /7x,'time increment of ',1pe12.5,' seconds calculated for',
     $    /7x,'order ',i2,'.')
          write (noutpt,1020) delxi,rirec0
 1020     format(7x,'delxi= ',1pe12.5,/7x,'rirec0= ',e12.5)
          if (nord .gt. 0) write (noutpt,1030) (drir0(n), n = 1,nord)
 1030     format(7x,'drir0: ',/12x,1pe12.5,3x,e12.5,3x,e12.5,
     $    /12x,e12.5,3x,e12.5,3x,e12.5)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine dscrax(nf1,nf2,nllnmx,ulinex)
c
c     This subroutine descrambles a file of tables whose lines are
c     interspersed, but which are marked 'a', 'b', 'c', etc., in
c     column one. The contents of the scrambled file are copied to
c     the descrambled file as the descrambling takes place. The
c     descrambled file must already be open. The maximum line length
c     of this file is nllnmx characters.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nf1    = unit number of the scrambled file
c       nf2    = unit number of the descrambled file
c       nllnmx = the maximum character length of a line on the
c                descrambled files; the maximum character length
c                for the scrambled file is nllnmx + 1
c       ulinex = variable holding a line
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nf1,nf2
c
      integer nllnmx
c
      character(len=nllnmx) ulinex
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,i1,i2,j1
c
      character(len=1) uc,ux
c
c-----------------------------------------------------------------------
c
      i1 = ichar('a')
      i2 = ichar('Z')
      if (i2 .lt. i1) then
        i1 = ichar('A')
        i2 = ichar('z')
      endif
c
      rewind nf2
      do i = i1,i2
        uc = char(i)
        rewind nf1
  100   read (nf1,'(a1,a)',end=110) ux,ulinex
        if (ux .eq. uc) then
          j1 = len_trim(ulinex)
          write (nf2,'(a)') ulinex(1:j1)
        endif
        go to 100
c
  110   continue
      enddo
c
      end

      subroutine intmtb(mtb,mtbaq,mtbaqi,mtbi,nbasp,nbt,nbti,nbtmax,
     $ noutpt,nstmax,nttyo,ubmtbi,uspec)
c
c     This subroutine interprets the mass balance totals read from the
c     input file. It constructs the mtb and mtbaq arrays.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       mtbi   = total number of moles of basis species in the
c                  equilibrium system
c       mtbaqi = total number of moles of basis species in the
c                  aqueous phase
c       ubmtbi = array of names of the corresponding species
c
c     Principal output:
c
c       mtb    = total number of moles of basis species in the
c                  equilibrium system
c       mtbaq  = total number of moles of basis species in the
c                  aqueous phase
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer nbasp(nbtmax)
c
      integer nbt,nbti
c
      character(len=48) ubmtbi(nbtmax),uspec(nstmax)
c
      real(8) mtb(nbtmax),mtbaq(nbtmax),mtbaqi(nbtmax),mtbi(nbtmax)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen2,nb,nbi,nerr,ns
c
      character(len=56) uspn56
c
c----------------------------------------------------------------------
c
      nerr = 0
c
      do nbi = 1,nbti
        do nb = 1,nbt
          ns = nbasp(nb)
          if (ubmtbi(nbi)(1:48) .eq. uspec(ns)(1:48)) then
            mtb(nb) = mtbi(nbi)
            mtbaq(nb) = mtbaqi(nbi)
            go to 100
          endif
        enddo
c
        call fmspnm(jlen2,ubmtbi(nbi),uspn56)
        write (noutpt,1000) uspn56(1:jlen2)
        write (nttyo,1000) uspn56(1:jlen2)
 1000   format(/' * Error - (EQ6/intmtb) A mass balance is defined',
     $  ' on the input',/7x,'file for ',a,", but this species isn't",
     $  ' in the',/7x,"currently active basis set. Either it isn't",
     $  ' on the current data file',/7x,'or it has been suppressed',
     $  ' as by an nxmod or iopt(15) option.')
        nerr = nerr + 1
  100   continue
      enddo
c
      if (nerr .gt. 0) stop
c
      end

      subroutine gafscl(cdrsd,cscale,ndrsmx,ndrsrd,nst,nstmax)
c
c     This subroutine calculates the cscale array of affinity scaling
c     factors. Affinity scaling is used to help make decisions on
c     which phases are the best choices to precipitate when there
c     are multiple supersaturations.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrsd  = array of reaction coefficients ('d' set)
c
c     Principal output:
c
c       cscale = array of affinity scaling factors
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer ndrsrd(2,nstmax)
      integer nst
c
      real*8 cdrsd(ndrsmx),cscale(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,ns,nr1,nr2
c
      real*8 cx
c
c-----------------------------------------------------------------------
c
      do ns = 1,nst
        cx = 0.
        nr1 = ndrsrd(1,ns)
        nr2 = ndrsrd(2,ns)
        do n = nr1 + 1,nr2
          cx = cx + abs(cdrsd(n))
        enddo
        if (cx .le. 0.) cx = 1.0
        cscale(ns) = cx
      enddo
c
      end

      subroutine ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
c     This subroutine computes all parameters necessary to write the
c     Jacobian matrix from the zvclg1 array. It thus "expands" the
c     basis set variable data.
c
c     This subroutine is called by:
c
c       EQLIB/newton.f
c       EQLIB/nrstep.f
c       EQ3NR/arrset.f
c       EQ6/eqcalc.f
c       EQ6/exivar.f
c       EQ6/optmzr.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of logarithms of activity coefficients
c       cdrs   = array of reaction coefficients
c       ncmpr  = array giving the range in arrays corresponding to
c                  species of those species which belong to a given
c                  phase
c       ndrs   = array parallel to cdrs giving the index of the
c                  corresponding species
c       ndrsr  = array giving the range in the cdrs/ndrs arrays
c                  corresonding to the reaction associated with a
c                  given species
c       press  = pressure, bars
c       qxbarw = flag controlling iterative improvement of xbarw in
c                  the present subroutine:
c                  .false. = no iterative improvement
c                  .true.  = iterative improvement (relevant to EQ6 only)
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6NR
c       xbarlg = array of logarithms of mole fractions of species;
c                this is primarily an output of this subroutine, but
c                xbarlg(narn1), the mole fraction of water, is used
c                as an input if q6mode is .false.
c       xlks   = array of equilibrium constants
c       zvec1  = array of master variables
c       zvclg1 = array of logarithms of master variables
c
c     Principal output:
c
c       act    = array of species activities
c       actlg  = array of logarithms of species activities
c       conc   = array of species concentrations
c       conclg = array of logarithms of species concentrations
c       fo2    = the oxygen fugacity
c       fo2lg  = logarithm of the oxygen fugacity
c       fugac  = array of gas fugacities
c       fugalg = array of logarithms of gas fugacities
c       moph   = array of numbers of moles of phases
c       loph   = array of logarithms of numbers of moles of phases
c       mosp   = array of numbers of moles of species
c       losp   = array of logarithms of numbers of moles of species
c       xbar   = array of mole fractions of species
c       xbarlg = array of logarithms of mole fractions of species
c                  (but see above under 'principal input")
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,ndrsmx,netmax,ngtmax,nptmax,
     $ nstmax
c
      integer noutpt,nttyo
c
      integer igstak(ngtmax),iindx1(kmax),istack(nstmax),
     $ jcsort(nstmax),jern1(jetmax,netmax),jern2(jetmax,netmax),
     $ jflag(nstmax),jgext(netmax),jgsort(ngtmax),jgstak(ngtmax),
     $ jjsort(nstmax),jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),
     $ jssort(nstmax),jstack(nstmax),nbasp(nbtmax),ncmpr(2,nptmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),ngexsa(ietmax,jetmax,netmax),
     $ ngext(jetmax,netmax),nphasx(nstmax)
c
      integer iern1,iern2,ifrn1,ifrn2,igas,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2,kbt,kdim,kelect,km1,ko2gaq,kwater,kxt,narn1,narn2,
     $ nbt,nelect,nern1,nern2,ngrn1,ngrn2,ngt,no2gaq,npt,nst
c
      logical qxbarw,q6mode
c
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 acflg(nstmax),act(nstmax),actlg(nstmax),cdrs(ndrsmx),
     $ cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),conc(nstmax),
     $ conclg(nstmax),cpgexs(ietmax,jetmax,netmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),fsort(ngtmax),fugac(ngtmax),
     $ fugalg(ngtmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ mgext(jetmax,netmax),mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),
     $ moph(nptmax),mosp(nstmax),xbar(nstmax),xbarlg(nstmax),
     $ xlks(nstmax),zchar(nstmax),zgexj(jetmax,netmax),zvclg1(kmax),
     $ zvec1(kmax)
c
      real*8 eps100,fo2,fo2lg,omega,omeglg,press,xbarw,xbarwc,
     $ xbrwlc,xbrwlg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ix,iy,je,k,kcol,n,nb,ne,ng,np,nrr1,nrr2,nr1,nr2,ns,nss,
     $ nt,nxbarw
c
      character*48 ux48,uy48
      character*24 ux24,uy24
c
      real*8 ajx,ax,axw,axwfnc,axwmax,axwmxo,cx,cxs,cxw,cxx,dxw,fx,
     $ lcx,lx,mw,mx,sigmmc,sx,wconst,wcnstl,xx,xy,zx
c
      real*8 coefdr,texp,tlg
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that igas, uspec, uphase, and
c     press are not used.
c
      ix = igas
      iy = ix
      igas = iy
c
      ux48 = uspec(1)
      uy48 = ux48
      uspec(1) = uy48
c
      ux24 = uphase(1)
      uy24 = ux24
      uphase(1) = uy24
c
      xx = press
      xy = xx
      press = xy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the master variables from their logarithms.
c
c     Clear the concentrations, activities, and numbers of moles
c     of the aqueous species.
c
      do ns = narn1,narn2
        conc(ns) = 0.
        act(ns) = 0.
        mosp(ns) = 0.
        xbar(ns) = 0.
      enddo
c
      do ns = narn1,narn2
        conclg(ns) = -99999.
        actlg(ns) = -99999.
        losp(ns) = -99999.
        xbarlg(ns) = -99999.
      enddo
c
c     Clear the concentrations, activities, etc., of the generic ion
c     exchange species. However, do not clear the number of moles
c     variables (mosp). These will be used to initiate the expansion.
c
      do ns = nern1,nern2
        conc(ns) = 0.
        act(ns) = 0.
        xbar(ns) = 0.
      enddo
c
      do ns = nern1,nern2
        conclg(ns) = -99999.
        actlg(ns) = -99999.
        losp(ns) = -99999.
        xbarlg(ns) = -99999.
      enddo
c
c     Clear the concentrations, activities, fugacities, and numbers
c     of moles of the gas species.
c
      do ns = ngrn1,ngrn2
        conc(ns) = 0.
        act(ns) = 0.
        mosp(ns) = 0.
        xbar(ns) = 0.
      enddo
c
      do ng = 1,ngt
        fugac(ng) = 0.
      enddo
c
      do ns = ngrn1,ngrn2
        conclg(ns) = -99999.
        actlg(ns) = -99999.
        losp(ns) = -99999.
        xbarlg(ns) = -99999.
      enddo
c
      do ng = 1,ngt
        fugalg(ng) = -99999.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do k = 1,kdim
        zx = zvclg1(k)
        zvec1(k) = texp(zx)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kwater .le. 0) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/' * Error - (EQLIB/ncmpex) Programming error trap:',
     $  ' Have not yet',/7x,'implemented coding for the case of water',
     $  ' not in the basis set.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       In EQ6, the mass of solvent water varies.
c
        wconst = omega/zvec1(kwater)
        wcnstl = tlg(wconst)
      else
c
c       In EQ3NR, the mass of solvent water is fixed at 1.0 kg.
c
        wconst = 1.0
        wcnstl = 0.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the number of moles, concentrations, and activities of
c     the basis species. The following loop assumes that all such
c     species are normal aqueous solute species. Corrections must
c     be made after this loop for the species water, aqueous O2(g),
c     and aqueous e-, if they are in the basis set.
c
      do k = 1,kbt
        nb = iindx1(k)
        ns = nbasp(nb)
        lx = zvclg1(k)
        mx = zvec1(k)
        losp(ns) = lx
        mosp(ns) = mx
c
        if (ns.ge.narn1 .and. ns.le.narn2) then
          conclg(ns) = wcnstl + lx
          conc(ns) = wconst*mx
          ax = conclg(ns) + acflg(ns)
          actlg(ns) = ax
          act(ns) = texp(ax)
        elseif (ns.ge.nern1 .and. ns.le.nern2) then
c
          conclg(ns) = wcnstl + lx
          conc(ns) = wconst*mx
c
c         Mole fractions and activities of generic ion exchange species
c         will be calculated later. For some exchange models (e.g.,
c         Gapon), these quantities could be calculated here. However,
c         for others (e.g., Vanselow), that is not possible, at least
c         in the general case.
c
        else
          write (noutpt,1010)
          write (nttyo,1010)
 1010     format(/' * Error - (EQLIB/ncmpex) Programming error trap:',
     $    ' Have not yet',/7x,'implemented coding for the case of a',
     $    ' basis species which is neither',/7x,'an aqueous species',
     $    ' nor an ion-exchanger species.')
          stop
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a return point for correcting the mole fraction
c     of water in EQ6. Here nxbarw is an iteration counter.
c
      nxbarw = 0
      xbarw = xbarwc
      xbrwlg= xbrwlc
      axwmxo = 0.
  200 continue
c
c     Make corrections for water if it is a basis species. The
c     following coding assumes that water is the first species in the
c     aqueous solution (i.e., it has species index narn1).
c
      if (kwater .gt. 0) then
        if (q6mode) then
          xbarlg(narn1) = xbrwlg
          xbar(narn1) = xbarw
        else
          xbrwlg = zvclg1(kwater)
          xbarlg(narn1) = xbrwlg
          xbarw = texp(xbrwlg)
        endif
c
        ax = xbarlg(narn1) + acflg(narn1)
        actlg(narn1) = ax
        act(narn1) = texp(ax)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous O2(g), if it is a basis species.
c
      if (ko2gaq .gt. 0) then
        fo2lg = zvclg1(ko2gaq)
        fo2 = zvec1(ko2gaq)
c
c       Note- act(no2gaq) and actlg(no2gaq) will contain the oxygen
c       fugacity and its logarithm to simplify looping over mass action
c       expressions. Technically, the aqueous O2(g) species has no
c       activity.
c
        actlg(no2gaq) = fo2lg
        act(no2gaq) = fo2
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous e-, if it is a basis species.
c
      if (kelect .gt. 0) then
        actlg(nelect) = zvclg1(kelect)
        act(nelect) = zvec1(kelect)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the mole fraction and activity of water, if this
c     species is not a basis species.
c
      if (kwater .le. 0) then
        nr1 = ndrsr(1,narn1)
        nr2 = ndrsr(2,narn1)
        cxs = cdrs(nr1)
        cxx = -xlks(narn1) + cxs*acflg(narn1)
        do n = nr1 + 1,nr2
          nss = ndrs(n)
          cxx = cxx + cdrs(n)*actlg(narn1)
        enddo
        cxx = -cxx/cxs
        xbarlg(narn1) = cxx
        xbar(narn1) = texp(cxx)
        ax = cxx + acflg(narn1)
        actlg(narn1) = ax
        act(narn1) = texp(ax)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute concentrations and activities of the non-basis
c     aqueous solute species.
c
      do ns = narn1 + 1,narn2
        if (jflag(ns) .eq. 30) then
          if (jsflag(ns) .le. 0) then
            nr1 = ndrsr(1,ns)
            nr2 = ndrsr(2,ns)
            cxs = cdrs(nr1)
            cxx = -xlks(ns) + cxs*acflg(ns)
            do n = nr1 + 1,nr2
              nss = ndrs(n)
              cxx = cxx + cdrs(n)*actlg(nss)
            enddo
            cxx = -cxx/cxs
            conclg(ns) = cxx
            conc(ns) = texp(cxx)
            ax = cxx + acflg(ns)
            actlg(ns) = ax
            act(ns) = texp(ax)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kwater.gt.0 .and. q6mode .and. qxbarw) then
c
c       In EQ6 mode, check to see that the mole fraction of water is
c       sufficiently well determined. If not, iteratively improve it.
c       This is done using a 1-variable Newton-Raphson method. This
c       is sometimes necessary because (1) to calculate the
c       concentrations of the dependent aqueous species, one may have
c       to have the mole fraction of water (xbarw) and (2) vice
c       versa. The process is initiated by using an "old" value
c       of the mole fraction of water (that of xbarwc on entering
c       the present subroutine).
c
c       Recalculate the mole fraction of water using the
c       updated concentrations of all dependent aqueous species.
c       The new value is stored as "xbarwc".
c
c       Note: here the jcsort array, which provides for a sorted
c       summation to calculate Sigma m (sigmmc), has not been updated.
c       This is extremely unlikely to cause a problem here. An unsorted
c       calculation would almost certainly be adequate.
c
        call csigm(conc,jcsort,narn1,narn2,nstmax,sigmmc)
        xbarwc = omega/(omega + sigmmc)
c
c       Calculate the alpha residual (axw) and the max norm (axwmax).
c
        axw = xbarwc - xbarw
        axwmax = abs(axw)
c
c       Calculate the improvement function (axwfnc).
c
        axwfnc = 0.
        if (axwmxo .gt. 0.) axwfnc = (axwmxo -axwmax)/axwmxo
c
        axwmxo = axwmax
c
        if (nxbarw .le. 0) write (noutpt,1200)
 1200   format(/1x)
        write (noutpt,1210) nxbarw,xbarw,axwmax,axwfnc
 1210   format(2x,'iter= ',i3,2x,'xbarw= ',f12.10,2x,
     $  'axwmax= ',1pe10.3,2x,'axwfnc= ',e10.3)
c
        if (axwmax .gt. eps100) then
          if (nxbarw .le. 20) then
c
c           Calculate an improved value of xbarw.
c
            nxbarw = nxbarw + 1
            sx = 0.
            do ns = narn1 + 1,narn2
              if (jflag(ns) .eq. 30) then
                if (jsflag(ns) .le. 0) then
                  nr1 = ndrsr(1,ns)
                  nr2 = ndrsr(2,ns)
                  cxs = cdrs(nr1)
c
c                 Calling sequence substitutions:
c                   narn1 for nse
c
                  cxw = coefdr(cdrs,ndrs,ndrsmx,ndrsr,narn1,ns,nstmax)
                  sx = sx + cxw*conc(ns)/cxs
                endif
              endif
            enddo
c
c           Here ajx is the 1 x 1 Jacobian, and dxw is (initially) the
c           raw correction term.
c
            ajx = (xbarwc/omega)*sx - 1.0
            dxw = -axw/ajx
c
c           Apply limits to the correction.
c
            xx = xbarw + dxw
            if (xx .gt. 1.0) dxw = 0.5*(1.0 - xbarw)
            if (xx .le. 0.0) dxw = -0.5*xbarw
            dxw = min(dxw,0.05)
            dxw = max(dxw,-0.05)
c
c           Make the correction and try again.
c
            xbarw = xbarw + dxw
            xbrwlg = tlg(xbarw)
            go to 200
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for water. The following coding assumes that
c     water is the first species in the aqueous solution (i.e., it
c     has species index narn1).
c
      conc(narn1) = omega
      conclg(narn1) = omeglg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous O2(g).
c
      if (no2gaq .gt. 0) then
        conc(no2gaq) = 0.
        conclg(no2gaq) = -99999.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous e-.
c
      if (nelect .gt. 0) then
        conc(nelect) = 0.
        conclg(nelect) = -99999.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the numbers of moles of the non-basis aqueous solute
c     species.
c
      do ns = narn1 + 1,narn2
        if (jflag(ns).eq.30 .and. jsflag(ns).le.0) then
          losp(ns) = conclg(ns) - wcnstl
          mosp(ns) = conc(ns)/wconst
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for water. The following coding assumes that
c     water is the first species in the aqueous solution (i.e., it
c     has species index narn1).
c
      if (.not.q6mode) then
        mosp(narn1) = omega
        losp(narn1) = omeglg
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous O2(g).
c
      if (no2gaq .gt. 0) then
        mosp(no2gaq) = 0.
        losp(no2gaq) = -99999.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make corrections for aqueous e-.
c
      if (nelect .gt. 0) then
        mosp(nelect) = 0.
        losp(nelect) = -99999.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the mole fractions and activities of the basis and
c     non-basis ion-exchanger species, and the numbers of moles
c     of the non-basis species.
c
      call ncmpve(acflg,act,actlg,cdrs,cgexj,eps100,iern1,
     $ iern2,ietmax,jern1,jern2,jetmax,jflag,jgext,jsflag,losp,
     $ mgext,moph,mosp,nbasp,nbt,nbtmax,ndrs,ndrsmx,ndrsr,netmax,
     $ noutpt,nptmax,nstmax,nttyo,ugexj,uphase,uspec,xbar,
     $ xbarlg,xlks)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the concentrations (mol/kg.H2O) and numbers of moles of
c     the non-basis ion-exchanger species.
c
      do np = iern1,iern2
        if (moph(np) .gt. 0.) then
          ne = np - iern1 + 1
          do je = 1,jgext(ne)
            nrr1 = jern1(je,ne)
            nrr2 = jern2(je,ne)
            do ns = nrr1,nrr2
              if (jflag(ns).eq.30 .and. jsflag(ns).le.0) then
                lcx = wcnstl + losp(ns)
                cx = wconst*mosp(ns)
                conclg(ns) = lcx
                conc(ns) = cx
              endif
            enddo
          enddo
c
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the equivalent fractions (egexs) and mole ratios (mrgexs)
c     of exchanger species of generic ion exchanger phases.
c
      call gegexs(cegexs,cgexj,egexjc,egexjf,egexs,iern1,
     $ iern2,ietmax,jern1,jetmax,jgext,moph,mosp,mrgexs,netmax,
     $ ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,zchar,zgexj)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Compute the numbers of moles and concentrations of the
c       species belonging to non-aqueous phases present in the
c       equilibrium sytem (ES).
c
        if (kxt .ge. km1) then
          do kcol = km1,kxt
            ns = iindx1(kcol)
            losp(ns) = zvclg1(kcol)
            mosp(ns) = zvec1(kcol)
            conclg(ns) = wcnstl + losp(ns)
            conc(ns) = wconst*mosp(ns)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Sort species according to log masses.
c
      call sortsp(iern1,iern2,istack,jcsort,jern1,jern2,
     $ jgext,jsitex,jetmax,jjsort,jssort,jstack,losp,lsort,ncmpr,
     $ nern1,nern2,netmax,noutpt,nphasx,npt,nptmax,nst,nstmax,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the number of moles of water. The following coding
c     assumes that the aqueous solution is the first phase (i.e.,
c     has phase index 1).
c
      moph(1) = 0.
      loph(1) = -99999.
      mw = 0
      do nss = narn1,narn2
        ns = jcsort(nss)
        mw = mw + mosp(ns)
      enddo
      moph(1) = mw
      loph(1) = tlg(mw)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Compute the mole fractions of the aqueous species. The following
c       coding assumes that water is the first species in the aqueous
c       solution (i.e., has species index narn1).
c
        if (mw .gt. 0.) then
          do ns = narn1,narn2
            xx = mosp(ns)/mw
            xbar(ns) = xx
            xbarlg(ns) = tlg(xx)
          enddo
          xbarw = xbar(narn1)
          xbrwlg = xbarlg(narn1)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Compute the number of moles of non-aqueous phases. The following
c       coding assumes that the aqueous solution is the first phase
c       (i.e., has phase index 1).
c
c       Skip the exchanger phases. Start with the pure liquid phases.
c
        do np = ilrn1,ilrn2
          moph(np) = 0.
          loph(np) = -99999.
          if (jpflag(np) .le. 0) then
            ns = ncmpr(1,np)
            mx = mosp(ns)
            moph(np) = mx
            loph(np) = tlg(mx)
          endif
        enddo
c
c       Pure mineral phases.
c
        do np = imrn1,imrn2
          moph(np) = 0.
          loph(np) = -99999.
          if (jpflag(np) .le. 0) then
            ns = ncmpr(1,np)
            mx = mosp(ns)
            moph(np) = mx
            loph(np) = tlg(mx)
          endif
        enddo
c
c       Fixed fugacity phases.
c
        do np = ifrn1,ifrn2
          moph(np) = 0.
          loph(np) = -99999.
          if (jpflag(np) .le. 0) then
            ns = ncmpr(1,np)
            mx = mosp(ns)
            moph(np) = mx
            loph(np) = tlg(mx)
          endif
        enddo
c
c       Solid solutions.
c
        do np = ixrn1,ixrn2
          moph(np) = 0.
          loph(np) = -99999.
          if (jpflag(np) .le. 0) then
            mx = 0
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do nss = nr1,nr2
              ns = jcsort(nss)
              mx = mx + mosp(ns)
            enddo
            moph(np) = mx
            loph(np) = tlg(mx)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Clear the activities of species belonging to non-aqueous
c       solution phases. The following coding assumes that the aqueous
c       solution is the first phase (i.e., has the phase index 1).
c
        do np = ixrn1,ixrn2
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          do ns = nr1,nr2
            act(ns) = 0.
            actlg(ns) = -99999.
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Compute the mole fractions and activities of the species which
c       belong to non-aqueous solution phases in the equilibrium system.
c
        do np = ixrn1,ixrn2
          mx = moph(np)
          if (mx .gt. 0.) then
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do ns = nr1,nr2
              xx = mosp(ns)/mx
              xbar(ns) = xx
              xbarlg(ns) = tlg(xx)
              ax = xbarlg(ns) + acflg(ns)
              actlg(ns) = ax
              act(ns) = texp(ax)
            enddo
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the fugacities of the gas species.
c
      do ns = ngrn1,ngrn2
        ng = ns - ngrn1 + 1
        if (jsflag(ns) .lt. 2) then
          nr1 = ndrsr(1,ns)
          nr2 = ndrsr(2,ns)
          nt = nr2 - nr1 + 1
          if (nt .ge. 2) then
            cxs = cdrs(nr1)
            fx = -xlks(ns)
            do n = nr1 + 1,nr2
              nss = ndrs(n)
              cxx = cdrs(n)
              fx = fx + cxx*actlg(nss)
            enddo
            fx = -fx/cxs
            fugalg(ng) = fx
            fugac(ng) = texp(fx)
          else
            fugalg(ng) = actlg(ns)
            fugac(ng) = act(ns)
          endif
        endif
      enddo
c
c     Sort all gas species according to equilibrium fugacities.
c     Put their indices in sorted order in the jgsort array.
c
c     Calling sequence substitutions:
c       fsort for asort
c       fugac for aval
c       jgsort for jsort
c       igstak for istack
c       jgstak for jstack
c       ngtmax for nmax
c       ngt for nval
c
c     Caution: the jgsort array from the last call is recycled as a
c     good starting point. Set jgsort(1) to 0 to make a sort starting
c     from scratch.
c
      call qsortw(fsort,fugac,igstak,jgsort,jgstak,ngtmax,noutpt,
     $ nttyo,ngt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine getlu(nlu,nerr)
c
c     This subroutine finds a currently unused unit number.
c
c     This subroutine is called by:
c
c       EQLIBU/openin.f
c       EQLIBU/openou.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       nlu    = first currently unused unit number
c       nerr   = error flag:
c                  = 0   Okay
c                  = 1   Error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nlu,nerr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iumax,iumin
c
      logical qopen
c
c-----------------------------------------------------------------------
c
      data iumax,iumin /40,0/
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
c     Loop through all valid file numbers, beginning with the largest.
c
      do nlu = iumax,iumin,-1
        inquire(unit=nlu,opened=qopen)
        if (.not.qopen) go to 999
      enddo
c
      nerr = 1
c
  999 continue
      end

      subroutine ncmpve(acflg,act,actlg,cdrs,cgexj,eps100,iern1,
     $ iern2,ietmax,jern1,jern2,jetmax,jflag,jgext,jsflag,losp,
     $ mgext,moph,mosp,nbasp,nbt,nbtmax,ndrs,ndrsmx,ndrsr,netmax,
     $ noutpt,nptmax,nstmax,nttyo,ugexj,uphase,uspec,xbar,
     $ xbarlg,xlks)
c
c     This subroutine computes part of the "expansion" of the
c     basis set variable data that yields the "total" system
c     description. This part is the expansion giving the mole
c     fractions and number of moles of components of generic ion
c     exchangers, for all exchange models. This part of the expansion
c     is necessarily iterative in the general case. The overall
c     expansion is conducted by EQLIB/ncmpex.f.
c
c     This subroutine is called by:
c
c       EQLIB/ncmpex.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of logarithms of activity coefficients
c       actlg  = array of logarithms of species activities
c                  (input consists of valid results for aqueous
c                  basis species; output consists of the same
c                  for generic ion exchanger species)
c       cdrs   = array of reaction coefficients
c       mosp   = array of numbers of moles of species
c                  (input contains valid results for basis species
c                  and carry-over values for non-basis species)
c       moph   = array of numbers of moles of phases
c       ndrs   = array parallel to cdrs giving the index of the
c                  corresponding species
c       ndrsr  = array giving the range in the cdrs/ndrs arrays
c                  corresonding to the reaction associated with a
c                  given species
c       xlks   = array of equilibrium constants
c
c     Principal output:
c
c       act    = array of species activities
c                  (output consists of the subset for generic exchanger
c                  species)
c       actlg  = array of logarithms of species activities
c       mgext  = array of the sum of the number of moles of exchanger
c                  species in given sites of generic ion exchange
c                  phases
c       mosp   = array of numbers of moles of species
c                  (output consists of valid results for non-basis
c                  species; valid results for basis species were
c                  input and are retained)
c       losp   = array of logarithms of numbers of moles of species
c       xbar   = array of mole fractions of species
c       xbarlg = array of logarithms of mole fractions of species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,ndrsmx,netmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jgext(netmax),jsflag(nstmax),nbasp(nbtmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax)
c
      integer iern1,iern2,nbt
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 acflg(nstmax),act(nstmax),actlg(nstmax),cdrs(ndrsmx),
     $ cgexj(jetmax,netmax),losp(nstmax),mgext(jetmax,netmax),
     $ moph(nptmax),mosp(nstmax),xbar(nstmax),xbarlg(nstmax),
     $ xlks(nstmax)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icycle,icycmx,iterve,itvemx,je,j2,j3,j4,n,nb,ndlxfc,ne,
     $ np,nrr1,nrr2,nrsxfc,nr1,nr2,ns,nse,nsi,nss
c
      integer ilnobl,nbasis
c
      logical qprint
c
      character*8 ux8
c
      real*8 aajx,ardlx,ardlxo,aresx,aresxo,cgxj,delx,delxl,delxu,
     $ dlxfnc,dm,cxs,lax,lxx,mtxj,mtxjc,resx,rhsx,rsxfnc,resxo,xbarmx,
     $ xbarsm,xx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Data statements.
c
      data icycmx /10/
      data itvemx /100/
c
c-----------------------------------------------------------------------
c
      qprint = .false.
c
c     Loop over all generic ion exchanger phases.
c
      do np = iern1,iern2
        ne = np - iern1 + 1
        if (moph(np) .gt. 0.) then
c
c         Have found an exchanger phase present in the system.
c         Loop over all sites.
c
          do je = 1,jgext(ne)
            nrr1 = jern1(je,ne)
            nrr2 = jern2(je,ne)
            cgxj = cgexj(je,ne)
c
c           Determine which species is the basis species for the
c           current site of the current exchanger phase.
c
            nse = 0.
            do ns = nrr1,nrr2
              nb = nbasis(nbasp,nbt,nbtmax,ns)
              if (nb.gt.0 .and. jsflag(ns).le.0) then
                nse = ns
              endif
            enddo
c
c           Here mtxj (saved as mgext(je,ne)) is the sum of the
c           numbers of moles of the exchanger species for the current
c           site. This is equivalent to the sum of the numbers of
c           moles of the corresponding exchange ions. Depending on
c           the ion exchange model in question, this sum may not be
c           simply proportional to the number of moles of the exchanger
c           phase. More generally, it may be a complex function of
c           the site composition. In this case, the value of mtxj
c           must be calculated using an iterative process.
c
c           Calculate an initial estimate from mostly inherited
c           values (use number of moles variables for all exchanger
c           species for the current site). Only the value for the
c           species in the basis set is actually current.
c
            mtxj = 0.
            do ns = nrr1,nrr2
              mtxj = mtxj + mosp(ns)
            enddo
c
c           Optional output.
c
            if (qprint) then
              j2 = ilnobl(ugexj(je,ne))
              j3 = ilnobl(uphase(np))
              write (noutpt,1040) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
 1040         format(/' Pre-Newton-Raphson expansion for site ',a,
     $        /' of phase ',a,':',/)
            endif
c
            icycle = -1
            resx = 0.
c
c           Loop back here for another cycle of pre-Newton-Raphson
c           correction.
c
  110       icycle = icycle + 1
c
c           Make a tentative expansion to estimate the mole fractions,
c           activities, and numbers of moles of all species belonging
c           to the current site.
c
            call ncmpvh(acflg,act,actlg,cdrs,cgxj,jflag,
     $      jsflag,losp,mosp,mtxj,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $      ndrsr,nrr1,nrr2,nstmax,xbar,xbarlg,xlks)
c
c           Check the sum of the mole fractions.
c
            xbarsm = 0.
            do ns = nrr1,nrr2
              xbarsm = xbarsm + xbar(ns)
            enddo
c
c           Calculate the residual function.
c
            resxo = resx
            resx = xbarsm - 1.0
c
c           Calculate the improvement functions.
c
            aresxo = abs(resxo)
            aresx = abs(resx)
            if (aresxo .gt. 0.) then
              rsxfnc = (aresxo - aresx)/aresxo
            else
              rsxfnc = 0.
            endif
c
c           Optional output.
c
            if (qprint) then
              if (icycle .ge. 0) then
                write (noutpt,1080) icycle,mtxj,resx,rsxfnc
 1080           format(2x,'iter= ',i2,', mtxj= ',1pe10.3,
     $          ', resx= ',1e10.3,', rsxfnc= ',e10.3)
              endif
            endif
c
            if (resx.gt.0.2 .or. resx.lt.-0.2) then
              if (icycle .lt. icycmx) then
c
c               Make a new estimate of mtxj to use in a new
c               expansion calculation.
c
c               Normalize the mole fractions and recompute the
c               activities.
c
                do ns = nrr1,nrr2
                  xx = xbar(ns)/xbarsm
                  xbar(ns) = xx
                  xbarlg(ns) = tlg(xx)
                  actlg(ns) = cgxj*(xbarlg(ns) + acflg(ns))
                enddo
c
c               Find the species with the largest mole fraction.
c
                xbarmx = 0.
                nsi = 0
                do ns = nrr1,nrr2
                  if (xbar(ns) .gt. xbarmx) then
                    xbarmx = xbar(ns)
                    nsi = ns
                  endif
                enddo
c
c               Assume that mole fraction is correct. If the species
c               with the largest mole fraction is the basis species,
c               use its mole fraction to re-estimate mtxj. If it is
c               not the basis species, use the mass action relation
c               to calculate the mole fraction of the basis species,
c               and use that in turn to re-estimate mtxj.
c
                if (nsi .eq. nse) then
                  xx = xbar(nse)
                else
                  nr1 = ndrsr(1,nsi)
                  nr2 = ndrsr(2,nsi)
                  lax = xlks(nsi)
                  do n = nr1,nr2
                    nss = ndrs(n)
                    if (nss .eq. nse) then
                      cxs = cdrs(n)
                    else
                      lax = lax - cdrs(n)*actlg(nss)
                    endif
                  enddo
                  lax = lax/cxs
                  lxx = (lax/cgxj) - acflg(nse)
                  xx = texp(lxx)
                endif
                mtxjc = mosp(nse)/xx
                if (mtxjc .lt. mosp(nse)) then
c
c                 The value of mtxjc is less than the theoretical
c                 minimum of mosp(nse) (the calculated mole fraction
c                 xx is greater than 1.0). Move mtxj halfway to its
c                 theoretical lower limit.
c
                  dm = mosp(nse) - mtxj
                  mtxj = mtxj + 0.5*dm
                else
c
c                 The value of mtxjc is okay. Use it.
c
                  mtxj = mtxjc
                endif
                go to 110
              endif
            endif
c
c           Optional output.
c
            if (qprint) then
              write (noutpt,1090)
 1090         format(1x)
            endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c           Begin Newton-Raphson iteration. This presumes that a
c           starting value of mtxj is already provided. The initial
c           residual is calculated, even if it is already known.
c           This is intended to make the N-R block as independent
c           as possible from the above pre-N-R block.
c
c           Optional output.
c
            if (qprint) then
              j2 = ilnobl(ugexj(je,ne))
              j3 = ilnobl(uphase(np))
              write (noutpt,1140) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
 1140         format(/' Newton-Raphson expansion for site ',a,
     $        /' of phase ',a,':',/)
            endif
c
            iterve = 0
            resx = 0.
            delx = 0.
            resxo = 0.
            rsxfnc = 0.
            ardlx = 0.
            ardlxo = 0.
            dlxfnc = 0.
            nrsxfc = 0
            ndlxfc = 0
c
c           Loop back here to continue more Newton-Raphson
c           iterations.
c
  120       continue
c
c           Make a tentative expansion to estimate the mole fractions,
c           activities, and numbers of moles of all species belonging
c           to the current site.
c
            call ncmpvh(acflg,act,actlg,cdrs,cgxj,jflag,
     $      jsflag,losp,mosp,mtxj,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $      ndrsr,nrr1,nrr2,nstmax,xbar,xbarlg,xlks)
c
c           Estimate the mole fractions and activities of the
c           basis species for the current site.
c
c           Check the sum of the mole fractions.
c
            xbarsm = 0.
            do ns = nrr1,nrr2
              xbarsm = xbarsm + xbar(ns)
            enddo
c
c           Calculate the residual function.
c
            resxo = resx
            resx = xbarsm - 1.0
c
c           Calculate the improvement functions.
c
            aresxo = abs(resxo)
            aresx = abs(resx)
            if (aresxo .gt. 0.) then
              rsxfnc = (aresxo - aresx)/aresxo
            else
              rsxfnc = 0.
            endif
c
            ardlxo = ardlx
            ardlx = abs(delx/mtxj)
            if (ardlxo .gt. 0.) then
              dlxfnc = (ardlxo - ardlx)/ardlxo
            else
              dlxfnc = 0.
            endif
c
            if (rsxfnc .ge. 0.) then
              nrsxfc = 0
            else
              nrsxfc = nrsxfc + 1
            endif
c
            if (dlxfnc .ge. 0.) then
              ndlxfc = 0
            else
              ndlxfc = ndlxfc + 1
            endif
c
c           Optional output.
c
            if (qprint) then
              if (iterve .ge. 0) then
                write (noutpt,1150) iterve,mtxj,resx,rsxfnc
 1150           format(2x,'iter= ',i2,', mtxj= ',1pe10.3,
     $          ', resx= ',1e10.3,', rsxfnc= ',e10.3)
              endif
            endif
c
c           Test for convergence.
c
            if (aresx .le. eps100) go to 170
c
c           Test for the maximum number of iterations.
c
            if (iterve .eq. itvemx) then
              j2 = ilnobl(ugexj(je,ne))
              j3 = ilnobl(uphase(np))
              write (ux8,'(i5)') itvemx
              call lejust(ux8)
              j4 = ilnobl(ux8)
              write (noutpt,1170) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3),ux8(1:j4)
              write (nttyo,1170) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3),ux8(1:j4)
 1170         format(/' * Warning - (EQLIB/ncmpve) Newton-Raphson',
     $        ' iteration failed to'/7x,'converge during an attempt',
     $        ' to expand the system description',/7x,'for site ',a,
     $        ' of phase ',a,'. It reached',/7x,'the limit of ',a,
     $        ' iterations.')
              write (nttyo,1172) aresx
              write (noutpt,1172) aresx
 1172         format(/9x,'abs. residual= ',1pe12.5)
              go to 170
            endif
c
c           Test for non-convergent behavior.
c
            if ((nrsxfc.ge.10 .and. ndlxfc.ge.10) .or.
     $        nrsxfc.ge.20 .or. ndlxfc.ge.20) then
              j2 = ilnobl(ugexj(je,ne))
              j3 = ilnobl(uphase(np))
              write (noutpt,1180) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
              write (nttyo,1180) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
 1180         format(/' * Warning - (EQLIB/ncmpve) Newton-Raphson',
     $        ' iteration failed to'/7x,'converge during an attempt',
     $        ' to expand the system description',/7x,'for site ',a,
     $        ' of phase ',a,'. Non-convergent',/7x,'behavior was',
     $        ' detected.')
              go to 170
            endif
c
c           Do another iteration.
c
            iterve = iterve + 1
c
c           Set the right-hand-side.
c
            rhsx = -resx
c
c           Calculate the derivative (1 x 1 Jacobian) of the
c           residual function.
c
            aajx = 0.
            do ns = nrr1,nrr2
              if (ns .eq. nse) then
                aajx = aajx + xbar(ns)
              else
                nr1 = ndrsr(1,ns)
                nr2 = ndrsr(2,ns)
                do n = nr1,nr2
                  nss = ndrs(n)
                  if (nss .eq. nse) then
                    aajx = aajx - cdrs(n)*xbar(ns)/cdrs(nr1)
                    go to 150
                  endif
                enddo
  150           continue
              endif
            enddo
            aajx = -aajx/mtxj
c
            if (aajx .eq. 0.) then
              j2 = ilnobl(ugexj(je,ne))
              j3 = ilnobl(uphase(np))
              write (noutpt,1190) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
              write (nttyo,1190) ugexj(je,ne)(1:j2),
     $        uphase(np)(1:j3)
 1190         format(/' * Error - (EQLIB/ncmpve) Have encountered',
     $        ' a zero 1 x 1 Jacobian'/7x,'during Newton-Raphson',
     $        ' iteration to expand the description of',/7x,'site ',
     $        a,' of phase ',a,'.')
              stop
            endif
c
c           Solve for the Newton-Raphson correction term.
c
            delx = rhsx/aajx
c
c           Apply under-relaxation limits.
c
            delxu = 9999.*mtxj
            delxl = -0.9999*mtxj
            delx = min(delx,delxu)
            delx = max(delx,delxl)
c
c           Apply a special under-relaxation limit.
c
            mtxjc = mtxj + delx
            if (mtxjc .lt. mosp(nse)) then
c
c             The value of mtxjc is less than the theoretical
c             minimum of mosp(nse).  Set up to move mtxj halfway
c             to its theoretical lower limit.
c
              delx = 0.5*(mosp(nse) - mtxj)
            endif
c
c           Apply the correction term.
c
            mtxj = mtxj + delx
            go to 120
c
c           Save the sum of the number of moles of exchanger species
c           for the current site of the current exchanger phase.
c
  170       mgext(je,ne) = mtxj
c
c           Optional output.
c
            if (qprint) then
              write (noutpt,1200)
 1200         format(1x)
            endif
c
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      real*8 function dotpra(array1,array2,nmax)
c
c     This subroutine computes the dot product of two real*8 arrays
c     array1 and array2.
c
c     This subroutine is nearly identical to EQLIBU/ddot.f, which has
c     the same function, but a different calling sequence.
c
c     This subroutine is called by:
c
c       EQLIBU/sgeco.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array1 =  real*8 vector with nmax elements
c       array2 =  real*8 vector with nmax elements
c
c     Output:
c
c       dotpra = the dot product
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array1(nmax),array2(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
c     Note the use of a local variable (ax) within the loop.
c     Note also that the loop is unrolled.
c
      dx = 0.
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        dx = dx + array1(i)*array2(i) + array1(i + 1)*array2(i + 1)
     $  + array1(i + 2)*array2(i + 2) + array1(i + 3)*array2(i + 3)
     $  + array1(i + 4)*array2(i + 4) + array1(i + 5)*array2(i + 5)
     $  + array1(i + 6)*array2(i + 6) + array1(i + 7)*array2(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        dx = dx + array1(i)*array2(i)
      enddo
c
      dotpra = dx
c
      end

      subroutine ztaylr(delxi,dzvc0,kdim,kmax,km1,kxt,nord,nrd1mx,
     $ qztayl,zklogu,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine calculates new values for algebraic master
c     variables (the z vector elements) from the finite-difference-
c     based truncated Taylor's series. If qztayl = .true., change
c     limits are applied to the results. The purpose of these limits
c     is to assist the hybrid Newton-Raphson iteration either to
c     converge or to generate useful divergence diagnostics.
c
c     Compare with:
c
c       EQ6/ataylr.f
c       EQ6/ptaylr.f
c       EQ6/rtaylr.f
c
c      See also:
c
c       EQ6/d1ztay.f
c       EQ6/d2ztay.f
c
c     This subroutine is called by:
c
c       EQ6/eqshel.f
c       EQ6/ldlxrc.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       dzvc0  = the dz/d(xi) vector at the base point
c       kdim   = the number of elements in the z vector
c       kmax   = the maximum number of elements in the z vector
c       nord   = the order of the truncated Taylor's series
c       nrd1mx = the maximum order of the truncated Taylor's series + 1
c       qztayl = flag to apply change limits
c       zvclg0 = the log z vector at the base point
c       zvec0  = the z vector at the base point
c
c     Principal output:
c
c       zvec1  = the z vector at the new point
c       zvclg1 = the log z vector at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nrd1mx
c
      integer kdim,km1,kxt,nord
c
      logical qztayl
c
      real*8 dzvc0(nrd1mx,kmax),zvclg0(kmax),zvclg1(kmax),zvec0(kmax),
     $ zvec1(kmax)
c
      real*8 delxi,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer kcol,n
c
      real*8 dxp,zx,zx0,zxl,zxu
c
      real*8 fctrl,tlg
c
c-----------------------------------------------------------------------
c
c
c     Compute the expansions from the Taylor's series.
c
      do kcol = 1,kdim
        zx = zvec0(kcol)
        dxp = 1.
        do n = 1,nord
          dxp = dxp*delxi
          zx = zx + ( dzvc0(n,kcol)/fctrl(n) )*dxp
        enddo
        zvec1(kcol) = zx
c
c       Compute the corresponding logarithmic variable. Provide
c       protection if zx is negative. If this is the case, the
c       logarithmic variable won't be used.
c
        if (zx .lt. 0) then
          zx = 0.
        endif
        zvclg1(kcol) = tlg(zx)
      enddo
c
      if (qztayl) then
c
c       Apply change limits.
c
        do kcol = 1,kdim
          zx0 = zvec0(kcol)
          zxl = 1.e-20*zx0
          zxu = 1.e+20*zx0
          zx = zvec1(kcol)
          zx = max(zx,zxl)
          zx = min(zx,zxu)
          if (zx .lt. 0.) then
            zx = 0.
          endif
          zvec1(kcol) = zx
          zvclg1(kcol) = tlg(zx)
        enddo
c
        do kcol = km1,kxt
          if (zvclg0(kcol) .lt. zklogu) then
            zvclg1(kcol) = zvclg0(kcol)
            zvec1(kcol) = zvec0(kcol)
          endif
        enddo
      endif
c
      end

      subroutine fdomsp(jssort,mosp,nsi,nst,nstmax,weight,wsi)
c
c     This subroutine finds the species that dominates a mass balance.
c     The primary purpose of this subroutine is to support the
c     pre-Newton-Raphson optimization algorithm. This subroutine is not
c     intended to support optimizing the basis set.
c
c     Note - to save time, it is assumed that the ratio of the
c     largest value of weight to the smallest non-zero value is
c     no greater than 100.
c
c     This subroutine is called by:
c
c       EQLIB/cfracf.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jssort = array of species indices in order of increasing
c                  mass
c       weight = array of stoichiometric weighting factors
c       mosp   = array of moles of species
c       nst    = number of species
c
c     Principal output:
c
c       nsi    = index of the dominant species
c       wsi    = weight(nsi)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jssort(nstmax)
      integer nsi,nst
c
      real*8 mosp(nstmax),weight(nstmax)
      real*8 wsi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nsc,nss,ns
c
      real*8 ap0,ap1,m0,m1,w0,w1,p1,rx
c
c-----------------------------------------------------------------------
c
      m0 = 0.
      w0 = 1.
      ap0 = 0.
      nsi = 0
c
      do nsc = 1,nst
        nss = nst + 1 - nsc
        ns = jssort(nss)
        w1 = weight(ns)
        m1 = mosp(ns)
        if (m1 .le. 0.) go to 20
        if (w1 .ne. 0.) then
          p1 = w1*m1
          ap1 = abs(p1)
          if (ap1 .gt. ap0) then
            m0 = m1
            w0 = w1
            ap0 = ap1
            nsi = ns
            go to 15
          endif
        endif
        rx = m0/m1
        if (rx .gt. 100.) go to 20
   15   continue
      enddo
c
   20 continue
      wsi = w0
      end

      subroutine prtmip(acflg,actlg,conclg,ctb,nbaspd,nbt,nbtmax,
     $ nelect,nhydr,nhydx,noutpt,nstmax,uspec,zchar)
c
c     This subroutine prints  tables of the mean ionic activities and
c     activity coefficients.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of log activity coefficients of species
c       actlg  = array of log activities of species
c       conclg = array of log concentrations of species
c       ctb    = array of total molalities of basis species
c       nbt    = the number of species in the basis set
c       nelect = index of the fictive species aqueous e-
c       nhydr  = index of the species aqueous H+
c       nhydx  = index of the species aqueous OH-
c       uspec  = array of species names
c       zchar  = array of species electrical charge numbers
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt
c
      integer nbaspd(nbtmax)
      integer nbt,nelect,nhydr,nhydx
c
      character*48 uspec(nstmax)
c
      real*8 acflg(nstmax),actlg(nstmax),conclg(nstmax),ctb(nbtmax),
     $ zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,nb1,nb2,ns1,ns2
c
      integer ilnobl
c
      real*8 apmlg,cpmlg,cpmslg,ctb1,ctb2,gpm,gpmlg,gpms,gpmslg,zxa,
     $ zx1,zx2
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Compute and print a table of stoichiometric ionic properties.
c
      write (noutpt,1000)
 1000 format(//16x,'--- Stoichiometric Mean Ionic Properties ---')
      write (noutpt,1010)
 1010 format(/3x,'Species',18x,'Log a(+/-)',2x,'Log m(+/-)',2x,
     $ 'Log gamma(+/-)',2x,'gamma(+/-)',/)
c
      do nb1 = 1,nbt
        ns1 = nbaspd(nb1)
        zx1 = zchar(ns1)
c
        ctb1 = ctb(nb1)
        if (ctb1 .lt. 0.) then
          if (ns1 .eq. nhydx) then
            ns1 = nhydr
            zx1 = zchar(nhydr)
            ctb1 = -ctb1
          endif
        endif
c
        if (zx1 .le. 0.) go to 120
        if (ctb1 .le. 0.) go to 120
c
        do nb2 = 1,nbt
          ns2 = nbaspd(nb2)
          zx2 = zchar(ns2)
c
          ctb2 = ctb(nb2)
          if (ctb2 .lt. 0.) then
            if (ns2 .eq. nhydr) then
              ns2 = nhydx
              zx2 = zchar(nhydx)
              ctb2 = -ctb2
            endif
          endif
c
          if (zx2 .ge. 0.) go to 110
          if (ctb2 .le. 0.) go to 110
          if (ns2 .eq. nelect) go to 110
c
          zxa = zx1 - zx2
          apmlg = (zx1*actlg(ns2) - zx2*actlg(ns1))/zxa
c
          cpmslg = (zx1*tlg(ctb2) - zx2*tlg(ctb1))/zxa
c
          gpmslg = apmlg - cpmslg
          gpms = texp(gpmslg)
c
          j2 = ilnobl(uspec(ns1)(1:24))
          j3 = ilnobl(uspec(ns2)(1:24))
c
  100     if ((j2 + j3) .gt. 24) then
            if (j2 .gt. j3) then
              j2 = j2 - 1
            else
              j3 = j3 - 1
            endif
            go to 100
          endif
c
          write (noutpt,1020) uspec(ns1)(1:j2),uspec(ns2)(1:j3),
     $    apmlg,cpmslg,gpmslg,gpms
 1020     format(1x,a,'/',a,t29,f9.4,3x,f9.4,4x,f9.4,5x,1pe11.4)
  110     continue
        enddo
c
  120   continue
      enddo
c
      write (noutpt,1030)
 1030 format(/3x,'The stoichiometric mean molalities and activity',
     $ ' coefficients given',/3x,'above are consistent with the',
     $ ' sensible composition of the',/3x,'aqueous solution.')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print a table of ionic properties.
c
      write (noutpt,1100)
 1100 format(//21x,'--- Mean Ionic Properties ---')
      write (noutpt,1010)
c
      do nb1 = 1,nbt
        ns1 = nbaspd(nb1)
        zx1 = zchar(ns1)
c
        if (zx1 .le. 0.) go to 220
        if (conclg(ns1) .le. -99999.) go to 220
c
        do nb2 = 1,nbt
          ns2 = nbaspd(nb2)
          zx2 = zchar(ns2)
c
          if (zx2 .ge. 0.) go to 210
          if (conclg(ns2) .le. -99999.) go to 210
          if (ns2 .eq. nelect) go to 210
c
          zxa = zx1 - zx2
          apmlg = (zx1*actlg(ns2) - zx2*actlg(ns1))/zxa
c
          cpmlg = (zx1*conclg(ns2) - zx2*conclg(ns1))/zxa
c
          gpmlg = (zx1*acflg(ns2) - zx2*acflg(ns1))/zxa
          gpm = texp(gpmlg)
c
          j2 = ilnobl(uspec(ns1)(1:24))
          j3 = ilnobl(uspec(ns2)(1:24))
c
  200     if ((j2 + j3) .gt. 32) then
            if (j2 .gt. j3) then
              j2 = j2 - 1
            else
              j3 = j3 - 1
            endif
            go to 200
          endif
c
          write (noutpt,1020) uspec(ns1)(1:j2),uspec(ns2)(1:j3),
     $    apmlg,cpmlg,gpmlg,gpm
  210     continue
        enddo
c
  220   continue
      enddo
c
      write (noutpt,1110)
 1110 format(/3x,'The mean molalities and activity coefficients given',
     $ ' above are',/3x,'consistent with the speciation in the model',
     $ ' employed.',/)
c
      end

      subroutine gmarko(nfldmx,nfldt,nmark,nttyo,ufield,uline1)
c
c     This subroutine determines the choice for an option. This choice
c     is marked with an asterisk on a line containing a field for
c     each choice.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nfldmx = the maximum number of fields on line uline1
c       nfldt  = the number of fields on line uline1
c       nttyo  = the unit number of the screen file
c       ufield = the array of field contents in uline1
c       uline1 = the line containing the option being examined
c
c     Output:
c
c       nmark  = index of the first marked field on line uline1
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nfldmx
c
      integer nfldt,nmark,nttyo
c
      character*(*) ufield(nfldmx)
      character*(*) uline1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,j2,n,ncount
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Find the first option marked with an asterisk.
c
      ncount = 0
      nmark = 0
      do n = 2,nfldt
        j = index(ufield(n),'*')
        if (j .gt. 0) then
          ncount = ncount + 1
          if (ncount .eq. 1) nmark = n
        endif
      enddo
c
      j2 = ilnobl(uline1)
      j2 = min(j2,70)
c
      if (ncount .eq. 0) then
        write (nttyo,1030) uline1(1:j2)
 1030   format(/' * Warning - (EQLIBU/gmarko) None of the options'
     $  /7x,'is marked with an asterisk on the line beginning with',
     $  /7x,'"',a,'".')
      endif
c
      if (ncount .gt. 1) then
        write (nttyo,1040) uline1(1:j2)
 1040   format(/' * Warning - (EQLIBU/gmarko) More than one of the'
     $  /7x,'options is marked with an asterisk on the line',
     $  ' beginning with',
     $  /7x,'"',a,'".')
      endif
c
      end

      subroutine csigm(conc,jcsort,narn1,narn2,nstmax,sigmmc)
c
c     This subroutine calculates the sum of the molalities of aqueous
c     solute species (sigmmc):
c
c       Sigma(i) m(i)
c
c     Note that a sorted summation is used.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQLIB/ncmpex.f
c       EQ3NR/arrset.f
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqueous species; this is
c                  also the index of the solvent, water
c       narn2  = end of the range of aqueous species
c
c     Principal output:
c
c       sigmmc = the sum of the molalities of the aqueous solute
c                  species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 conc(nstmax)
      real*8 sigmmc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,nss,nval
c
      real*8 cw,sx
c
c----------------------------------------------------------------------
c
c     Logically, this could be represented by:
c
c       sigmmc = 0.
c       do ns = narn1 + 1,narn2
c         sigmmc = sigmmc + conc(ns)
c       enddo
c
c     In doing a sorted summation, a complication arises in that
c     water (ns = narn1) must be included in the range of the
c     loop, because the jcsort array is organized to contain the
c     species indices sorted according to increasing concentration
c     within phase ranges. There is no available sorting among
c     aqueous solute species only. This complication is dealt with
c     by temporarily setting the concentration of water (conc(narn1))
c     to zero. Note the use of a local variable (sx) within the loop.
c     Note also that the loop is unrolled.
c
      sx = 0.
      cw = conc(narn1)
      conc(narn1) = 0.
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do nss = narn1,ileft,8
        sx = sx + conc(jcsort(nss))      + conc(jcsort(nss + 1))
     $          + conc(jcsort(nss + 2))  + conc(jcsort(nss + 3))
     $          + conc(jcsort(nss + 4))  + conc(jcsort(nss + 5))
     $          + conc(jcsort(nss + 6))  + conc(jcsort(nss + 7))
      enddo
c
      do nss = ileft + 1,narn2
        sx = sx + conc(jcsort(nss))
      enddo
c
      sigmmc = sx
      conc(narn1) = cw
c
      end

      subroutine wr6w6(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,
     $ dlzidp,dzpllg,dzplot,dzprlg,dzprnt,electr,fk,ifile,iktbt,
     $ iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $ jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $ kstpmx,kxmod,kxt,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $ ndact,ndctmx,nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,
     $ nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $ nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $ ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $ rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,
     $ tolsst,tolx,tstrt,ttk,uacion,ucode,udac,uelemb,uendb,ueqlrn,
     $ ueqlst,uesrb,uffg,undms,unrms,uprs,ureac,urelno,ustage,
     $ utitl1,utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,
     $ zimax,zistrt,zkfac,zklogl,zklogu,zvclgi)
c
c     This subroutine writes the EQ6 input file in compact ("W") format
c     for version 6 (versions 6.0-6.1).
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nctmax,ndctmx,nffgmx,nodbmx,nopgmx,
     $ noprmx,noptmx,nprsmx,nrctmx,nsrtmx,nsscmx,ntitmx,nttkmx,nxmdmx,
     $ nxopmx,nxpemx,nxrtmx
c
      integer iktbt(nxrtmx),imech(2,nrctmx),iodb(nodbmx),iopg(nopgmx),
     $ iopr(noprmx),iopt(noptmx),jcode(nrctmx),jreac(nrctmx),
     $ jxmod(nxmdmx),kxmod(nxmdmx),ndact(imchmx,2,nrctmx),
     $ nesrbt(nsrtmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ifile,ioscan,itermx,jtemp,kct,kdim,ksq,kmt,kprs,ksplmx,
     $ ksppmx,kstpmx,kxt,newin,nffg,nmodl1,nmodl2,nordlm,npslmx,nprmn,
     $ nprmx,nrct,nsslmx,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*48 uprs(nprsmx)
      character*24 udac(ndctmx,imchmx,2,nrctmx),uendb(iktmax,nxrtmx),
     $ uffg(nffgmx),undms(kmax),unrms(kmax),ureac(nrctmx),
     $ uxmd24(nxmdmx),uxopex(nxpemx)
      character*24 uacion
      character*16 uxct16(nxopmx)
      character*8 uelemb(nctmax),uesrb(nctmax,nsrtmx),uxopt(nxopmx)
      character*8 ucode,urelno,ustage,ueqlrn,ueqlst
c
      real*8 cdac(ndctmx,imchmx,2,nrctmx),cesrb(nctmax,nsrtmx),
     $ csigma(imchmx,2,nrctmx),fk(nrctmx),modr(nrctmx),moffg(nffgmx),
     $ morr(nrctmx),mprs(nprsmx),mteaqb(nctmax),mteb(nctmax),
     $ rk0(imchmx,2,nrctmx),rxbarb(iktmax,nxrtmx),sscrew(nsscmx),
     $ sk(nrctmx),ttk(nttkmx),vreac(nrctmx),xlkffg(nffgmx),
     $ xlkmod(nxmdmx),zvclgi(kmax)
c
      real*8 cplim,dlzmx1,dlzmx2,dlzidp,dzpllg,dzplot,dzprlg,dzprnt,
     $ electr,tempci,tempc0,timemx,tolbt,toldl,tolsat,tolsst,tolx,
     $ tstrt,zkfac,zklogl,zklogu,zimax,zistrt
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iktb,j,kc,kcol,n,ncb,npr,nrc,
     $ nsrt,nxrt
c
      character*24 uxx
      character*8 uendit
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     Write the new input file.
c
c     Title.
c
      do 110 n = 1,ntitl1
        write (newin,1100) utitl1(n)
 1100   format(a80)
  110 continue
      if (ntitl1 .lt. ntitmx) write (newin,1110)
 1110 format('endit.')
c
c-----------------------------------------------------------------------
c
c     Nmodl option switches.
c
      write (newin,1120) nmodl1,nmodl2
 1120 format(4x,'nmodl1= ',i2,14x,'nmodl2= ',i2)
c
c     Temperature parameters.
c     Note: ttk(1) = tk1, etc.
c
      write (newin,1140) tempc0,jtemp,(ttk(i), i = 1,3)
 1140 format(4x,'tempc0= ',1pe12.5,5x,'jtemp= ',i2,
     $/7x,'tk1= ',1pe12.5,7x,'tk2= ',1pe12.5,7x,'tk3= ',1pe12.5)
c
c      Zi and time parameters.
c
      write (newin,1160) zistrt,zimax,tstrt,timemx,kstpmx,cplim
 1160 format(4x,'zistrt= ',1pe12.5,5x,'zimax= ',1pe12.5,
     $ /5x,'tstrt= ',1pe12.5,4x,'timemx= ',1pe12.5,
     $ /4x,'kstpmx= ',i12,5x,'cplim= ',1pe12.5)
c
c     Print interval parameters.
c
      write (newin,1180) dzprnt,dzprlg,ksppmx
 1180 format(4x,'dzprnt= ',1pe12.5,4x,'dzprlg= ',1pe12.5,4x,
     $ 'ksppmx= ',i5)
c
c     Plot interval parameters.
c
      write (newin,1200) dzplot,dzpllg,ksplmx
 1200 format (4x,'dzplot= ',1pe12.5,4x,'dzpllg= ',1pe12.5,4x,
     $ 'ksplmx= ',i5)
c
c     Ifile.
c
      write (newin,1220) ifile
 1220 format(5x,'ifile= ',i2)
c
c-----------------------------------------------------------------------
c
c     Comment header for iopt, iopr, and iodb option switches.
c
      write (newin,1230)
 1230 format('*',15x,'1    2    3    4    5    6    7    8    9   10')
c
c     Iopt option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1250) (iopt(i), i = 1,20)
 1250 format(2x,'iopt1-10= ',10i5,/1x,'iopt11-20= ',10i5)
c
c     Iopr option switches.
c     Note: iopr(1) = iopY1, etc.
c
      write (newin,1270) (iopr(i), i = 1,20)
 1270 format(2x,'iopr1-10= ',10i5,/1x,'iopr11-20= ',10i5)
c
c     Iodb option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1290) (iodb(i), i = 1,20)
 1290 format(2x,'iodb1-10= ',10i5,/1x,'iodb11-20= ',10i5)
c
c-----------------------------------------------------------------------
c
c     Number of nxopt options.
c
      write (newin,1310) nxopt
 1310 format(5x,'nxopt= ',i2)
c
c     Nxopt options.
c
      if (nxopt .gt. 0) then
        do 140 n = 1,nxopt
          write (newin,1330) uxopt(n),uxct16(n)
 1330     format(4x,'option= ',a6,1x,a8)
  140   continue
        write (newin,1350) nxopex
 1350   format(4x,'nxopex= ',i2)
        if (nxopex .gt. 0) then
          do 150 n = 1,nxopex
            write (newin,1370) uxopex(n)
 1370       format(1x,'exception= ',a8)
  150     continue
        endif
      endif
c
c-----------------------------------------------------------------------
c
c     Number of nffg options.
c
      write (newin,1390) nffg
 1390 format(6x,'nffg= ',i2)
c
c     Nffg options.
c
      if (nffg .gt. 0) then
      do 160 n = 1,nffg
        write (newin,1410) uffg(n),moffg(n),xlkffg(n)
 1410   format(3x,'species= ',a12,5x,'moffg= ',1pe12.5,4x,
     $  'xlkffg= ',1pe12.5)
  160   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Number of reactants.
c
      write (newin,1430) nrct
 1430 format(6x,'nrct= ',i2)
      write (newin,1435)
 1435 format('*-------------------------------------------------',
     $ '----------------------------')
c
c     Reactants.
c
      nsrt = 0
      nxrt = 0
      if (nrct .gt. 0) then
        do 390 nrc = 1,nrct
c
c         Name, flags, and masses.
c
          write (newin,1450) ureac(nrc),jcode(nrc),jreac(nrc),
     $    morr(nrc),modr(nrc)
 1450     format(2x,'reactant= ',a24,/5x,'jcode= ',i2,15x,'jreac= ',i2,
     $    /6x,'morr= ',1pe12.5,6x,'modr= ',1pe12.5)
c
          if (jcode(nrc) .eq. 1) then
c
c           Solid solution compositions.
c
            nxrt = nxrt + 1
            do 170 iktb = 1,iktbt(nxrt)
              write (newin,1470) uendb(iktb,nxrt),rxbarb(iktb,nxrt)
 1470         format(3x,a18,3x,1pe12.5)
  170       continue
            write (newin,1475) uendit
 1475       format(3x,a8)
          elseif (jcode(nrc) .eq. 2) then
c
c           Special reactant compositions.
c
            nsrt = nsrt + 1
            write (newin,1490) vreac(nrc)
 1490       format(5x,'vreac= ',1pe12.5)
c
            do 190 ncb = 1,nesrbt(nsrt)
              write (newin,1510) uesrb(ncb,nsrt),cesrb(ncb,nsrt)
 1510         format(3x,a8,1x,1pe25.15)
  190       continue
            write (newin,1475) uendit
          endif
c
c         Surface area parameters.
c
          write (newin,1530) nsk(nrc),sk(nrc),fk(nrc)
 1530     format(7x,'nsk= ',i2,18x,'sk= ',1pe12.5,8x,'fk= ',1pe12.5)
c
          write (newin,1550) nrk(1,nrc),nrk(2,nrc)
 1550     format(7x,'nrk= ',i2,16x,'nrpk= ',i2)
c
c         Rate law parameters, forward direction.
c
          if (nrk(1,nrc) .eq. 1) then
            i = imech(1,nrc)
            write (newin,1570) (rk0(j,1,nrc), j = 1,i)
 1570       format(7x,'rk1= ',1pe12.5,7x,'rk2= ',1pe12.5,7x,'rk3= ',
     $      1pe12.5)
          elseif (nrk(1,nrc) .eq. 2) then
            write (newin,1590) imech(1,nrc)
 1590       format(5x,'imech= ',i2)
            do 220 i = 1,imech(1,nrc)
              write (newin,1610) rk0(i,1,nrc),ndact(i,1,nrc),
     $        csigma(i,1,nrc)
 1610         format(7x,'rk0= ',1pe12.5,5x,'ndact= ',i2,14x,
     $        'csigma= ',1pe12.5)
              if (ndact(i,1,nrc) .gt. 0) then
                do 210 n = 1,ndact(i,1,nrc)
                  write (newin,1680) udac(n,i,1,nrc),cdac(n,i,1,nrc)
 1680             format(6x,'udac= ',a8,10x,'cdac= ',1pe12.5)
  210           continue
              endif
  220       continue
          elseif (nrk(1,nrc) .eq. 3) then
            write (newin,1570) (rk0(j,1,nrc), j = 1,3)
          elseif (nrk(1,nrc) .eq. 4) then
            write (newin,1590) imech(1,nrc)
            do 240 i = 1,imech(1,nrc)
              write (newin,1690) rk0(i,1,nrc),ndact(i,1,nrc)
 1690         format(7x,'rk0= ',1pe12.5,5x,'ndact= ',i2)
 1800         format(5x,'ndact= ',i2)
              if (ndact(i,1,nrc) .gt. 0) then
                do 230 n = 1,ndact(i,1,nrc)
                  write (newin,1680) udac(n,i,1,nrc),cdac(n,i,1,nrc)
  230           continue
              endif
  240       continue
          elseif (nrk(1,nrc) .eq. 5) then
            write (newin,1810) (rk0(j,1,nrc), j = 1,2)
 1810       format(7x,'rk1= ',1pe12.5,7x,'rk2= ',1pe12.5)
          endif
c
c         Rate law parameters, backward direction.
c
          if (nrk(2,nrc) .eq. 1) then
            i = imech(2,nrc)
            write (newin,1830) (rk0(j,2,nrc), j = 1,i)
 1830       format(6x,'rpk1= ',1pe12.5,6x,'rpk2= ',1pe12.5,6x,'rpk3= ',
     $      1pe12.5)
          elseif (nrk(2,nrc) .eq. 2) then
            write (newin,1840) imech(2,nrc)
 1840       format(4x,'ipmech= ',i2)
            do 260 i = 1,imech(2,nrc)
              write (newin,1850) rk0(i,2,nrc),ndact(i,2,nrc),
     $        csigma(i,2,nrc)
 1850         format(7x,'rpk= ',1pe12.5,4x,'npdact= ',i2,13x,
     $        'cpsigma= ',1pe12.5)
              if (ndact(i,2,nrc) .gt. 0) then
                do 250 n = 1,ndact(i,2,nrc)
                  write (newin,1880) udac(n,i,2,nrc),cdac(n,i,2,nrc)
 1880             format(5x,'updac= ',a8,9x,'cpdac= ',1pe12.5)
  250           continue
              endif
  260       continue
          elseif (nrk(2,nrc) .eq. 3) then
            write (newin,1830) rk0(1,2,nrc)
 1920       format(6x,'rpk1= ',1pe12.5)
          elseif (nrk(2,nrc) .eq. 4) then
            write (newin,1840) imech(2,nrc)
            do 280 i = 1,imech(2,nrc)
              write (newin,1930) rk0(i,2,nrc),ndact(i,2,nrc)
 1930         format(7x,'rpk= ',1pe12.5,4x,'npdact= ',i2)
 1940         format(4x,'npdact= ',i2)
              if (ndact(i,2,nrc) .gt. 0) then
                do 270 n = 1,ndact(i,2,nrc)
                  write (newin,1880) udac(n,i,2,nrc),cdac(n,i,2,nrc)
  270           continue
              endif
  280       continue
          elseif (nrk(2,nrc) .eq. 5) then
            write (newin,1810) (rk0(j,2,nrc), j = 1,2)
          endif
c
          write (newin,1435)
  390   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Dump interval.
c
      write (newin,2010) dlzidp
 2010 format(4x,'dlzidp= ',1pe12.5)
c
c     Tolerances.
c
      write (newin,2030) tolbt,toldl,tolx,tolsat,tolsst
 2030 format(5x,'tolbt= ',1pe12.5,5x,'toldl= ',1pe12.5,6x,'tolx= ',
     $ 1pe12.5,/4x,'tolsat= ',1pe12.5,4x,'tolsst= ',1pe12.5)
c
c     Setscrew parameters.
c     Note: sscrew(1) = screw1, etc.
c
      write (newin,2050) (sscrew(i), i = 1,6)
 2050 format(4x,'screw1= ',1pe12.5,4x,'screw2= ',1pe12.5,4x,'screw3= ',
     $ 1pe12.5,/4x,'screw4= ',1pe12.5,4x,'screw5= ',1pe12.5,
     $ 4x,'screw6= ',1pe12.5)
c
c     Z parameters.
c
      write (newin,2070) zklogu,zklogl,zkfac
 2070 format(4x,'zklogu= ',f12.3,4x,'zklogl= ',f12.3,5x,'zkfac= ',f12.3)
c
c     Step size limits and maximum order.
c
      write (newin,2090) dlzmx1,dlzmx2,nordlm
 2090 format(4x,'dlzmx1= ',1pe12.5,4x,'dlzmx2= ',1pe12.5,
     $ 4x,'nordlm= ',i2)
c
c     Maximum number of iterations and maximum number of phase
c     assemblage tries.
c
      write (newin,2110) itermx,ntrymx
 2110 format(4x,'itermx= ',i2,14x,'ntrymx= ',i2)
c
c     Slide and scan control parameters.
c
      write (newin,2130) npslmx,nsslmx,ioscan
 2130 format(4x,'npslmx= ',i2,14x,'nsslmx= ',i2,14x,'ioscan= ',i2)
c
      write (newin,1435)
c
c-----------------------------------------------------------------------
c
c     Process the bottom half of the current output file.
c
c     Write recaptured data in comments on the originating code, if
c     known.
c
      if (ucode(1:3).eq.'EQ6' .or. ucode(1:3).eq.'eq6') then
        write (newin,2180) urelno,ustage,ueqlrn,ueqlst
 2180   format('* pickup file written by eq6.',a4,a6,
     $  /'*  supported by eqlib.',a4,a6)
      endif
c
      if (ucode(1:5).eq.'EQ3NR' .or. ucode(1:5).eq.'eq3nr') then
        write (newin,2190) urelno,ustage,ueqlrn,ueqlst
 2190   format('* pickup file written by eq3nr.',a4,a6,
     $  /'*  supported by eqlib.',a4,a6)
      endif
c
c-----------------------------------------------------------------------
c
c     Title.
c
      do 400 n = 1,ntitl2
        write (newin,3000) utitl2(n)
 3000   format(a80)
  400 continue
      if (ntitl2 .lt. ntitmx) write (newin,1110)
c
c-----------------------------------------------------------------------
c
c     Ion that defines the equivalent stoichiometric ionic strength.
c
      write (newin,3015) uacion
 3015 format(4x,'uacion= ',a24)
c
c     Original temperature.
c
      write (newin,3020) tempci
 3020 format(4x,'tempci= ',1pe12.5)
c
c-----------------------------------------------------------------------
c
c     Number of nxmod options.
c
      write (newin,3040) nxmod
 3040 format(5x,'nxmod= ',i2)
c
c     Nxmod options.
c
      if (nxmod .gt. 0) then
        do 420 n = 1,nxmod
          write (newin,3060) uxmd24(n),jxmod(n),kxmod(n),xlkmod(n)
 3060     format(3x,'species= ',a24,/6x,'type= ',i2,14x,'option= ',i2,
     $    14x,'xlkmod= ',1pe12.5)
  420   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      write(newin,3080) (iopg(i), i = 1,10)
 3080 format(5x,'iopg1= ',i2,15x,'iopg2= ',i2,15x,'iopg3= ',i2,
     $       /5x,'iopg4= ',i2,15x,'iopg5= ',i2,15x,'iopg6= ',i2,
     $       /5x,'iopg7= ',i2,15x,'iopg8= ',i2,15x,'iopg9= ',i2,
     $       /4x,'iopg10= ',i2)
c
c-----------------------------------------------------------------------
c
c     Index limits.
c
      write (newin,3100) kct,ksq,kmt,kxt,kdim,kprs
 3100 format(7x,'kct= ',i2,17x,'ksq= ',i2,17x,'kmt= ',i2,
     $ /7x,'kxt= ',i2,16x,'kdim= ',i2,16x,'kprs= ',i2)
c
c-----------------------------------------------------------------------
c
c     Balance totals.
c
      write (newin,3110)
 3110 format('*  Component',13x,'Moles Total',17x,'Moles Aqueous')
      do 430 kc = 1,kct
        write (newin,3130) uelemb(kc),mteb(kc),mteaqb(kc)
 3130   format(3x,a8,7x,1pe25.15,3x,1pe25.15)
  430 continue
      write (newin,3150) electr
 3150 format(3x,'electr  ',7x,1pe25.15)
c
c-----------------------------------------------------------------------
c
c     Basis variable data.
c
      do 440 kcol = 1,kdim
        write (newin,3170) unrms(kcol),undms(kcol),zvclgi(kcol)
 3170   format(3x,a18,1x,a18,1x,1pe25.15)
  440 continue
c
c-----------------------------------------------------------------------
c
c     Physically removed system data.
c
      if (kprs .gt. 0) then
c
        do 450 npr = 1,nprmn
          write (newin,3190) uprs(npr)(1:24),mprs(npr)
 3190     format(3x,a18,1x,1pe25.15)
  450   continue
        write (newin,3200) uendit
 3200   format(3x,a8)
c
        uxx  = '        '
        do 480 npr = nprmn + 1,nprmx
          if (uprs(npr)(1:8) .eq. '        ') go to 490
          if (uprs(npr)(1:24) .eq. uxx(1:24)) then
            write (newin,3200) uendit
            write (newin,3210) uprs(npr)(1:24)
 3210       format(3x,a24)
          endif
          write (newin,3230) uprs(npr)(25:48),mprs(npr)
 3230     format(3x,a18,1x,1pe25.15)
  480   continue
  490   continue
        write (newin,3200) uendit
        write (newin,3200) uendit
      endif
c
  999 continue
      end

      subroutine goback(acflg,acflg0,emop,emop0,emos,emos0,fje,
     $ fje0,fxi,fxi0,iemop,iemop0,iemos,iemos0,iindx0,iindx1,ipndx0,
     $ ipndx1,jpflag,jsflag,jreac,jreac0,kdim,kdim0,kmax,km1,km10,
     $ kmt,kmt0,kx1,kx10,kxt,kxt0,loph,losp,moph,moph0,mosp,mosp0,
     $ ncmpe,ncmpe0,npet,npetmx,npet0,npt,nptmax,nrct,nrctmx,nset,
     $ nsetmx,nset0,nst,nstmax,qreq,qriinf,sigmam,sigmm0,uzvec0,
     $ uzvec1,xi0,xi1)
c
c     This subroutine sets up to go back to the previous point of
c     reaction progress.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,npetmx,nptmax,nrctmx,nsetmx,nstmax
c
      integer iemop(npetmx),iemop0(npetmx),iemos(nsetmx),iemos0(nsetmx),
     $ iindx0(kmax),iindx1(kmax),ipndx0(kmax),ipndx1(kmax),
     $ jreac(nrctmx),jreac0(nrctmx),jpflag(nptmax),jsflag(nstmax),
     $ ncmpe(2,npetmx),ncmpe0(2,npetmx)
c
      integer kdim,kdim0,km1,km10,kmt,kmt0,kx1,kx10,kxt,kxt0,npet,npet0,
     $ npt,nrct,nset,nset0,nst
c
      logical qreq,qriinf
c
      character(len=48) uzvec0(kmax),uzvec1(kmax)
c
      real(8) acflg(nstmax),acflg0(nstmax),emop(npetmx),emop0(npetmx),
     $ emos(nsetmx),emos0(nsetmx),loph(nptmax),losp(nstmax),
     $ moph(nptmax),moph0(nptmax),mosp(nstmax),mosp0(nstmax)
c
      real(8) fje,fje0,fxi,fxi0,sigmam,sigmm0,xi0,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,kcol,np,npe,nrc,ns,nse
c
c-----------------------------------------------------------------------
c
      xi1 = xi0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qreq = .false.
      qriinf = .false.
c
      kdim = kdim0
      kxt = kxt0
      kmt = kmt0
      km1 = km10
      kx1 = kx10
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do kcol = 1,kdim
        uzvec1(kcol) = uzvec0(kcol)
        iindx1(kcol) = iindx0(kcol)
        ipndx1(kcol) = ipndx0(kcol)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do np = 1,npt
        moph(np) = moph0(np)
      enddo
c
c     Note that the loop is unrolled.
c
      ileft = (npt/8)*8
      do np = 1,ileft,8
        loph(np) = -99999.
        loph(np + 1) = -99999.
        loph(np + 2) = -99999.
        loph(np + 3) = -99999.
        loph(np + 4) = -99999.
        loph(np + 5) = -99999.
        loph(np + 6) = -99999.
        loph(np + 7) = -99999.
        jpflag(np) = max(jpflag(np),0)
        jpflag(np + 1) = max(jpflag(np + 1),0)
        jpflag(np + 2) = max(jpflag(np + 2),0)
        jpflag(np + 3) = max(jpflag(np + 3),0)
        jpflag(np + 4) = max(jpflag(np + 4),0)
        jpflag(np + 5) = max(jpflag(np + 5),0)
        jpflag(np + 6) = max(jpflag(np + 6),0)
        jpflag(np + 7) = max(jpflag(np + 7),0)
      enddo
c
      do np = ileft + 1,npt
        loph(np) = -99999.
        jpflag(np) = max(jpflag(np),0)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      fje = fje0
      fxi = fxi0
      sigmam = sigmm0
c
      do ns = 1,nst
        mosp(ns) = mosp0(ns)
        acflg(ns) = acflg0(ns)
      enddo
c
c     Note that the loop is unrolled.
c
      ileft = (nst/8)*8
      do ns = 1,ileft,8
        losp(ns) = -99999.
        losp(ns + 1) = -99999.
        losp(ns + 2) = -99999.
        losp(ns + 3) = -99999.
        losp(ns + 4) = -99999.
        losp(ns + 5) = -99999.
        losp(ns + 6) = -99999.
        losp(ns + 7) = -99999.
        jsflag(ns) = max(jsflag(ns),0)
        jsflag(ns + 1) = max(jsflag(ns + 1),0)
        jsflag(ns + 2) = max(jsflag(ns + 2),0)
        jsflag(ns + 3) = max(jsflag(ns + 3),0)
        jsflag(ns + 4) = max(jsflag(ns + 4),0)
        jsflag(ns + 5) = max(jsflag(ns + 5),0)
        jsflag(ns + 6) = max(jsflag(ns + 6),0)
        jsflag(ns + 7) = max(jsflag(ns + 7),0)
      enddo
c
      do ns = ileft + 1,nst
        losp(ns) = -99999.
        jsflag(ns) = max(jsflag(ns),0)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kxt .ge. km1) then
        do kcol = km1,kxt
          ns = iindx1(kcol)
          np = ipndx1(kcol)
          jpflag(np) = -1
          jsflag(ns) = -1
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do npe = 1,npet0
        iemop(npe) = iemop0(npe)
        emop(npe) = emop0(npe)
        ncmpe(1,npe) = ncmpe0(1,npe)
        ncmpe(2,npe) = ncmpe0(2,npe)
      enddo
      npet = npet0
c
      do nse = 1,nset0
        iemos(nse) = iemos0(nse)
        emos(nse) = emos0(nse)
      enddo
      nset = nset0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nrc = 1,nrct
        jreac(nrc) = jreac0(nrc)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine nbsgam(acfnbs,adh,fxi,nchlor,noutpt,nttyo)
c
c     This subroutine calculates the log activity coefficient of the
c     chloride ion according to the NBS pH convention (e.g., Covington,
c     Bates, and Durst, 1985). The convention itself may be extended
c     outside the specified limit of 0.1 molal on the ionic strength.
c
c     Reference:
c
c       Covington, A.K., Bates, R.G., and Durst, R.A., 1985,
c       Definition of pH scales, standard reference values, measure-
c       ment of pH and related terminology (recommendations, 1984):
c       Pure and Applied Chemistry, v. 57, p. 533-542.
c
c     This subroutine is called by:
c
c       EQLIB/gpheh.f
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       nchlor = the species index of the chloride ion
c
c     Principal output:
c
c       acfnbs = log gamma(Cl-), according to the Bates-Guggenheim
c                convention
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nchlor,noutpt,nttyo
c
      real*8 acfnbs,adh,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 fxisqt
c
c-----------------------------------------------------------------------
c
c     Test the species index of the chloride ion.
c
      if (nchlor .le. 0) then
        write (noutpt,1000)
        write (nttyo ,1000)
 1000   format(/' * Error - (EQLIBG/nbsgam) Have no index for the',
     $  /7x,"chloride ion. Can't use the extended NBS pH scale.")
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Evaluate the NBS expression for the molal activity coefficient
c     of the chloride ion.
c
      fxisqt = sqrt(fxi)
      acfnbs = - ( adh * fxisqt ) / ( 1.0 + ( 1.5 * fxisqt ) )
c
      end

      subroutine vxspck(iktmax,issot,nerr,nmt,nmtmax,noutpt,nttyo,
     $ nxt,nxtmax,uminsp,ussoph,ussosp)
c
c     Validate the names of solid solution end-members. Make sure that
c     these names appear on the list of pure minerals.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nxt    = the number of solid solutions
c       issot  = array of numbers of end-members of solid solutions
c       ussoph = array of names of solid solutions
c       ussosp = array of names of end-members of solid solutions
c       uminsp = array of pure mineral names
c
c     Principal output:
c
c       nerr   = error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,nmtmax,nxtmax
c
      integer noutpt,nttyo
c
      integer nerr,nmt,nxt
c
      integer issot(nxtmax)
c
      character(len=24) uminsp(nmtmax),ussoph(nxtmax),
     $ ussosp(iktmax,nxtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 unam
c
      integer i,ikt,j2,j3,kerr,nm,nx
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Loop over all solid solution phases.
c
      do nx = 1,nxt
c
        ikt = issot(nx)
        kerr = 0
c
c       Check that each end-member appears on the list of pure minerals.
c
        do i = 1,ikt
          unam = ussosp(i,nx)
          if (unam(1:7) .ne. '<blank>') then
c
c           Check that each end-member appears on the list of
c           pure minerals.
c
            do nm = 1,nmt
              if (unam(1:24) .eq. uminsp(nm)(1:24)) go to 100
            enddo
c
c           Did not find this end-member on the list of pure minerals.
c
            kerr = kerr + 1
            nerr = nerr + 1
c
            if (kerr .eq. 1) then
c
c             Write a header for the solid solution.
c
              j2 = ilnobl(ussoph(nx))
              write (noutpt,1000) ussoph(nx)(1:j2)
              write (nttyo,1000) ussoph(nx)(1:j2)
 1000         format(/' * Error - (EQPT/vxspck) The following',
     $        ' end-members of solid solution',/7x,a,' are not present',
     $        ' on the data file as pure minerals:',/)
            endif
c
            j3 = ilnobl(unam)
            write (noutpt,1010) unam(1:j3)
            write (nttyo,1010) unam(1:j3)
 1010       format(9x,a)
c
  100       continue
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine tstrdx(cdrs,iodb,iopt,jflag,jsflag,narn1,narn2,
     $ ndrs,ndrsmx,ndrsr,nodbmx,noptmx,noutpt,nrdxsp,nstmax,
     $ qredox,uspec)
c
c     This subroutine determines if the chemical model to be
c     computed has a redox aspect. This will be determined to be
c     so if a species in the model has an associated reaction
c     that is a redox reaction and the species is not in the
c     active basis set.
c
c     An auxiliary basis species (say Oxalate-) that is in the
c     model but is included in the active basis set is effectively.
c     treated as detached from a corresponding strict basis species
c     (e.g., the concentration/activity of Oxalate- is not determined
c     by the assumption of equilibrium for its associated reaction,
c     which would link it to HCO3-). In effect, Oxalate- is treated
c     as being composed of a pseudo-element, and its presence in the
c     model does not require a redox variable.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nodbmx,noptmx,nstmax
c
      integer noutpt
c
      integer iodb(nodbmx),iopt(noptmx),jflag(nstmax),jsflag(nstmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer narn1,narn2,nrdxsp
c
      logical qredox
c
      character(len=48) uspec(nstmax)
c
      real(8) cdrs(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,ns
c
      character(len=56) uspn56
c
      real(8) cx
c
      real(8) coefdr
c
c-----------------------------------------------------------------------
c
      qredox = .false.
c
      if (iopt(15) .le. 0) then
        do ns = narn1,narn2
c
          if (jflag(ns) .eq. 30) then
c
c           The species is not in the active basis set. It is a
c           "dependent" species whose concentration/activity is
c           computed assuming its associated reaction is in a state
c           of equilibrium.
c
            if (jsflag(ns) .lt. 2) then
c
c             The species not hard suppressed.
c
c             Calling sequence substitutions:
c               nrdxsp for nse
c
              cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nrdxsp,ns,nstmax)
              if (cx .ne. 0.) then
                qredox = .true.
                if (iodb(1) .ge. 1) then
c
c                 Calling sequence substitutions:
c                   uspec(ns) for unam48
c
                  call fmspnm(jlen,uspec(ns),uspn56)
                  write (noutpt,1000) uspn56(1:jlen)
 1000             format(/' * Note - (EQ6/tstrdx) The reaction',
     $            ' associated with the species',/7x,a,' is a redox',
     $            ' reaction.')
                  go to 999
                endif
              endif
            endif
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gbfac(beta,bfac,efac,iindx1,kbt,kmax,nbt,nbtmax,nfac)
c
c     This subroutine calculates the bfac array, which is used in making
c     continued fraction corrections. It resolves conflicts when the
c     same aqueous species dominates more than one mass balance (the
c     species dominating a given mass balance is determined by
c     EQLIB/fdomsp). The continued fraction algorithm can be applied
c     to the master species associated with only one mass balance in
c     such a set, otherwise, oscillatory behavior will occur. In each
c     set of mass balances with a common dominant species, this
c     subroutine finds the mass balance with the greatest residual and
c     completes the calculation of its bfac factor by doing the
c     appropriate exponentiation. It sets bfac to unity for the others
c     in the set.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nfac   = array of indices of dominant aqueous species
c       beta   = array of normalized Newton-Raphson residual functions
c       efac   = array of corresponding reciprocal stoichiometric
c                  weights
c       kbt    = the number of active basis species
c       nbt    = the number of active basis species
c
c     Principal output:
c
c       bfac   = array (in terms of matrix indexing) of the quantity
c                  used in making a continued fraction correction
c                  (e.g., conc (new) = conc (old) / bfac ); in general,
c                  bfac = ( beta + 1. )**efac, but bfac may be set to
c                  unity for a species in resolving a conflict
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax
c
      integer iindx1(kmax),nfac(nbtmax)
      integer kbt,nbt
c
      real*8 beta(kmax),bfac(nbtmax),efac(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer krow,nb,nb1,nb2
c
      real*8 bpx1
c
c-----------------------------------------------------------------------
c
c     Calculate the bfac correction factors: bfac = (beta + 1)**efac.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        bpx1 = beta(krow) + 1.
        if (bpx1 .le. 0.) then
c
c         Protect against a singularity in case (beta + 1) is not
c         a positive number. The value set in such a case allows a
c         generous enough one-step increase in the value of the
c         corrected concentration, number of moles, etc. (20 orders
c         of magnitude). A more restrictive limit may be applied
c         later when the actual correction is made.
c
          bfac(nb) = 1.e-20
        else
c
c         Calculate bfac from the usual formula.
c
          bfac(nb) = bpx1**efac(nb)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Eliminate conflicts.
c
      do nb1 = 1,nbt - 1
        if (nfac(nb1) .gt. 0) then
          do nb2 = nb1 + 1,nbt
            if (nfac(nb2) .eq. nfac(nb1)) then
              if (bfac(nb1) .gt. bfac(nb2)) then
                nfac(nb2) = 0
                bfac(nb2) = 1.
              else
                nfac(nb1) = 0
                bfac(nb1) = 1.
                go to 15
              endif
            endif
          enddo
        endif
   15   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine flpars(eps100,irang,noutpt,nttyo,smp100)
c
c     This subroutine obtains the following real*8 parameters: the
c     real*8 machine epsilon (eps), the smallest positive real*8
c     number (smpos), and the exponent range (irang). It returns
c     eps100 = 100*eps and smp100 = 100*smpos, not of eps and smpos.
c     This subroutine calls EQLIBU/chump.f to test the adequacy of the
c     machine epsilon and the exponent range. If inadequacies are
c     noted, warnings will be written to the output and screen files.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Output:
c
c       eps100 = 100*eps
c       smp100 = 100*smpos
c       irang  = the real*8 exponent range, int( -log10(smpos ))
c
c     Local:
c
c       eps    = the real*8 machine epsilon
c       smpos  = the smallest positive real*8 number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer irang
c
      real(8) eps100,smp100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real(8) eps,smpos,x
c
c-----------------------------------------------------------------------
c
      data x / 1.0 /
c
c-----------------------------------------------------------------------
c
c     Get eps (real*8 machine epsilon).
c
      eps = epsilon(x)
c
c     Get smpos(real*8 smallest positive number).
c
      smpos = tiny(x)
c
      eps100 = 100*eps
      smp100 = 100*smpos
c
c     Compute the exponent range.
c
      irang = int(-log10(smpos))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Clear the IEEE flag for floating-point underflow, if such a
c     flag is present, to avoid getting an unnecessary system
c     warning message. Underflow is a normal condition in EQ3/6.
c     Make any porting changes in the EQLIBU subroutine cliefu.
c     Do not make the porting changes here.
c
c     Note: the calculation of smpos above involves forcing an
c     underflow.
c
      call cliefu()
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the adequacy of the machine epsilon and the exponent range.
c
      call chump(eps,irang,noutpt,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine polfit(aamatr,cof,gmmatr,ier,ipivot,npfmax,npft,
     $ noutpt,nttyo,xvec,yvec)
c
c     This subroutine fits an exact polynomial through npft points.
c     Each point is an x,y pair, where the values of x are in the
c     xvec array, those of y in the yvec array. The method is to solve
c     the matrix equation (A)(c) = (y) where:
c
c               | 1  x(1)  x(1)**2  ... |
c               | 1  x(2)  x(2)**2  ... |
c       A =     | 1  x(3)  x(3)**2  ... |
c               | ...                   |
c               | 1  x(n)  x(n)**2  ... |
c
c      and solve for the coefficients (c), which give the
c      representation:
c
c        y = c(1) + c(2)*x + c(3)*x**2 + ... + c(n)*x**n-1
c
c     It is assumed that the xvec array contains distinct values
c     (i.e., there are no duplicates). The matrix A is the
c     array aamatr, the matrix dimension n is npft, and the
c     vector c is the array cof.
c
c     If the xvec array was scaled using EQLIBU/scalx1.f, the resulting
c     yvec array should be rescaled using EQLIBU/rscaly.f.
c
c     This subroutine is called by:
c
c       EQPT/intrp.f
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       xvec   = the x vector
c       yvec   = the y vector
c       npft   = number of x,y points
c
c     Output:
c
c       cof    = the array of coefficients fo the fitted polynomial
c       ier    = error flag (returned by EQLIBU/msolvr.f):
c                  =  0  Okay
c                  =  1  Encountered a zero matrix
c                  =  2  Encountered a non-zero, computationally
c                          singular matrix
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer npfmax
c
      integer ipivot(npfmax)
      integer ier,noutpt,npft,nttyo
c
      real*8 aamatr(npfmax,npfmax),gmmatr(npfmax,npfmax)
      real*8 cof(npfmax),xvec(npfmax),yvec(npfmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j
c
      logical qpr
c
      real*8 aax
c
c-----------------------------------------------------------------------
c
      data qpr    /.false./
c
c-----------------------------------------------------------------------
c
c     Initialize error flag.
c
      ier = 0
c
c     Set up a matrix equation.
c
      do j = 1,npft
        cof(j) = 0.
        aax = 1.
        aamatr(j,1) = 1.
        do i = 2,npft
          aax = aax*xvec(j)
          aamatr(j,i) = aax
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Solve the matrix equation.
c
c     Calling sequence substitutions:
c       cof for delvec
c       npft for kdim
c       npfmax for kmax
c       yvec for rhsvec
c
      call msolvr(aamatr,cof,gmmatr,ier,ipivot,npft,npfmax,
     $ noutpt,nttyo,qpr,yvec)
c
      end

      subroutine prtpct(conc,csts,ctb,iopr,jcsort,jflag,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,nelect,nhydr,noprmx,no2gaq,noutpt,
     $ nstmax,nsts,nstsmx,nstsr,uspec)
c
c     This subroutine prints tables giving the percentages of species
c     making up solute mass totals in the aqueous solution. The
c     level of printing is controlled by the print control flag
c     iopr(6):
c
c        0 = Don't print any tables
c        1 = Print tables including 99% of all contributing species
c        2 = Print tables including all contributing species
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       csts   = array of stoichiometric mass balance factors
c       ctb    = array of total molalities of data file basis
c                  species
c       iopr   = array of print control options
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c       nbasp  = array of the species indices in the active basis set
c       nbaspd = array of the species indices in the data file basis
c                  set
c       nbt    = number of species in the basis set
c       nelect = index of the fictive species aqueous e-
c       nhydr  = index of the species aqueous H+
c       no2gaq = index of the fictive species aqueous O2(g)
c       nsts   = array of indices of species corresponding to the
c                  coefficients in the csts array
c       nstsr  = array giving the range in the csts and nsts arrays
c                  corresponding to a given species
c       nwater = index of the species liquid water
c       uspec  = array of species names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nbtmax,noprmx,nstmax,nstsmx
c
      integer noutpt
c
      integer iopr(noprmx),jcsort(nstmax),jflag(nstmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),nsts(nstsmx),nstsr(2,nstmax)
      integer narn1,narn2,nbt,nelect,nhydr,no2gaq
c
      character*(48) uspec(nstmax)
c
      real*8 conc(nstmax),csts(nstsmx),ctb(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nb,ns,ns1,ns2,nss,nssi
c
      integer ilnobl
c
      real*8 apct,cx,cxn,cxs,cxt,fx,px,pxs,pxt
      real*8 coefst
c
c-----------------------------------------------------------------------
c
      if (iopr(6) .le. -1) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(6) .le. 0) then
        write (noutpt,1000)
 1000   format(//6x,'--- Major Species by Contribution to Aqueous',
     $  ' Mass Balances ---',/)
      else
        write (noutpt,1010)
 1010   format(//6x,'--- Species by Contribution to Aqueous Mass',
     $  ' Balances ---',/)
      endif
c
      do nb = 1,nbt
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (ns1.lt.narn1 .or. ns1.gt.narn2) go to 110
        if (conc(ns2).le.0. .or. jflag(ns2).eq.30) go to 110
        if (ns1.eq.no2gaq .or. ns1.eq.nelect) go to 110
        if (ns1.eq.narn1 .or. ns1.eq.nhydr) go to 110
c
        j2 = ilnobl(uspec(ns1)(1:24))
        if (iopr(6) .eq. 0) then
          write (noutpt,1020) uspec(ns1)(1:j2)
 1020     format(/' Species Accounting for 99% or More of Aqueous ',a,
     $    //5x,'Species',19x,'Factor',4x,'Molality',5x,'Per Cent',/)
        else
          write (noutpt,1030) uspec(ns1)(1:j2)
 1030     format(/' Species Accounting for Total Aqueous ',a,
     $    //5x,'Species',19x,'Factor',4x,'Molality',5x,'Per Cent',/)
        endif
c
        cxt = ctb(nb)
        pxt = 100.
        if (cxt .gt. 0.) then
          cxn = pxt/cxt
        else
          cxn = 0.
        endif
        cxs = 0.
        pxs = 0.
c
        do nss = narn1,narn2
          nssi = narn2 - nss + narn1
          ns = jcsort(nssi)
          if (conc(ns) .gt. 0.) then
            fx = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            if (fx .gt. 0.) then
              cx = fx*conc(ns)
              cxs = cxs + cx
              px = cx*cxn
              pxs = pxs + px
              apct = abs(px)
c
              if (apct .gt. 999.99) then
                write (noutpt,1040) uspec(ns),fx,conc(ns),px
 1040           format(3x,a24,3x,f6.2,3x,1pe11.4,3x,e10.3)
              elseif (apct .lt. 1.00) then
                write (noutpt,1040) uspec(ns),fx,conc(ns),px
              else
                write (noutpt,1050) uspec(ns),fx,conc(ns),px
 1050           format(3x,a24,3x,f6.2,3x,1pe11.4,3x,0pf7.2)
              endif
c
              if (iopr(6).le.0 .and. pxs.ge.99.) go to 105
            endif
          endif
        enddo
c
  105   write (noutpt,1060)
 1060   format(' - - - - - - - - - - - - - - - - - - - - - - - - - - -',
     $  ' - - - - -')
        if (iopr(6) .eq. 0) then
          write (noutpt,1070) cxs,pxs
 1070     format(3x,'Subtotal',28x,1pe11.4,3x,0pf7.2,/)
        else
          write (noutpt,1080) cxt,pxt
 1080     format(3x,'Total',31x,1pe11.4,3x,0pf7.2,/)
        endif
  110   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rdpzet(apsi,jpfcmx,nat,natmax,ndat0s,nerr,noutpt,
     $ npxzet,npx3mx,npx3t,nttyo,nwarn,uaqsp,utripl,zaqsp)
c
c     This subroutine reads from the DATA1 file the coefficients
c     required to compute those Pitzer interaction parameters
c     associated with neutral-cation-anion (nca) triplets. This
c     particular set of interaction coefficients includes the
c     following:
c
c       1. zeta(nca)
c
c     Coefficients required to compute Pitzer interaction coefficients
c     associated with other triplet types or with pairs are not read
c     by this subroutine. This subroutine is one of several that
c     replace rdpz2.f and rdpz3.f.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c
c     Principal output:
c
c       apsi   = array of coefficients for computing psi parameters
c       nerr   = cumulative error counter
c       npxzet = the number of nca triplets for which Pitzer parameters
c                 were read from the data file
c       npx3t  = the number of triplets of all species types for which
c                  Pitzer parameters were read from the data file.
c       nwarn  = cumulative warning counter
c       uaqsp  = array of names of aqueous species
c       utripl = array of species names for species triplets
c       uaqsp  = array of electrical charge numbers of aqueous species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jpfcmx,natmax,npx3mx
c
      integer ndat0s,noutpt,nttyo
c
      integer nat,nerr,npxzet,npx3t,nwarn
c
      character(len=24) uaqsp(natmax),utripl(3,npx3mx)
c
      real(8) apsi(jpfcmx,npx3mx),zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,iz1,iz2,iz3,j,j2,j3,j4,j5,j6,j7,j8,j9,
     $ na,nc,nn,npx3,npx3te,n1,n2,n3
c
      integer ilnobl
c
      logical qdupan,qdup12,qdup13,qdup23
c
      character(len=80) udastr,uline,ux80
      character(len=24) unam1,unam2,unam3,ux24a,ux24b,ux24c,u1,u2,u3
      character(len=24) uhdzet,uhdnxt
      character(len=16) ustr16
      character(len=8) uterm,ux8
c
      real(8) var,z1,z2,z3
c
c-----------------------------------------------------------------------
c
      data uterm  /'+-------'/
      data uhdzet /"nca combinations: zeta(n"/
      data uhdnxt /"nnn' combinations: mu(nn"/
c
c-----------------------------------------------------------------------
c
      npx3te = npx3t
      npx3 = npx3te
      j2 = 0
      j3 = 0
      j4 = 0
c
c     Advance to the start of the superblock for these parameters.
c
  100 read (ndat0s,1000,end=990,err=995) uline
 1000 format(a80)
      if (uline(1:24) .ne. uhdzet(1:24)) go to 100
c
c     Skip the terminator.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the names of the species comprising a triplet.
c
  110 read (ndat0s,1010,end=990,err=995) unam1,unam2,unam3
 1010 format(a24,2x,a24,2x,a24)
c
      if (unam1(1:24) .eq. uhdnxt(1:24)) then
c
c       Found the header for the next superblock of Pitzer parameters.
c       Back up one line and terminate reading the current superblock.
c
        npxzet = npx3 - npx3te
        npx3t = npx3
        backspace(ndat0s)
        go to 999
      endif
c
      npx3 = npx3 + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up some string data for error messages.
c
      j2 = ilnobl(unam1)
      if (j2 .le. 0) then
        unam1 = '<blank>'
        j2 = ilnobl(unam1)
      endif
c
      j3 = ilnobl(unam2)
      if (j3 .le. 0) then
        unam2 = '<blank>'
        j3 = ilnobl(unam2)
      endif
c
      j4 = ilnobl(unam3)
      if (j4 .le. 0) then
        unam3 = '<blank>'
        j4 = ilnobl(unam3)
      endif
c
      write (ux8,'(i5)') npx3
      call lejust(ux8)
      j5 = ilnobl(ux8)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for blank names.
c
      if (j2.le.0 .or. j3.le.0 .or. j4.le.0) then
        write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j3)
        write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j3)
 1020   format(/' * Error - (EQPT/rdpzet) Have encountered a blank',
     $  ' species name',/7x,'in the species triplet for block ',a,
     $  ' of the superblock for',/7x,"Pitzer nca parameter data.",
     $  ' The offending triplet shows as',/7x,a,', ',a,', ',a,'.')
c
        if (npx3 .gt. (npx3te + 1)) then
          ux24a = utripl(1,npx3 - 1)
          ux24b = utripl(2,npx3 - 1)
          ux24c = utripl(3,npx3 - 1)
          if (ux24a(1:7).ne.'<blank>' .or.
     $      ux24b(1:7).ne.'<blank>' .or. ux24c(1:7).ne.'<blank>') then
            j7 = ilnobl(ux24a)
            j8 = ilnobl(ux24b)
            j9 = ilnobl(ux24c)
            write (noutpt,1030) ux24a(1:j7),ux24b(1:j8),ux24c(1:j9)
            write (nttyo,1030) ux24a(1:j7),ux24b(1:j8),ux24c(1:j9)
 1030       format(7x,'This block follows the one for ',a,
     $      ', ',a,', ',a,'.')
          endif
        endif
        nerr = nerr + 1
      endif
c
cXXXXXXXXX
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of the three species (n1, n2, n3). These
c     indices point to the data read from the previously read
c     species blocks.
c
c     Calling sequence substitutions:
c       n1 for na
c       unam1 for unams
c
      call gspidx(ier,n1,nat,natmax,uaqsp,unam1)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
          write (noutpt,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          write (nttyo,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
 1100     format(/' * Error - (EQPT/rdpzet) The aqueous species ',
     $    a,' appearing in',/7x,"the Pitzer nca parameter data",
     $    ' block for the species triplet',/7x,a,', ',a,', ',a,
     $    ' does not appear in an',/7x,'aqueous species data block.')
          nerr = nerr + 1
        endif
      endif
c
c     Calling sequence substitutions:
c       n2 for na
c       unam2 for unams
c
      call gspidx(ier,n2,nat,natmax,uaqsp,unam2)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
          write (noutpt,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          write (nttyo,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          nerr = nerr + 1
        endif
      endif
c
c     Calling sequence substitutions:
c       n3 for na
c       unam3 for unams
c
      call gspidx(ier,n3,nat,natmax,uaqsp,unam3)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
          write (noutpt,1100) unam3(1:j3),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          write (nttyo,1100) unam3(1:j3),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          nerr = nerr + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for illegal appearance of solvent water.
c
      if (unam1(1:4) .eq.'H2O ' .or. unam2(1:4) .eq.'H2O ' .or.
     $  unam3(1:4).eq.'H2O ' .or. n1.eq.1 .or. n2.eq.1 .or.
     $  n3.eq.1) then
        write (noutpt,1200) unam1(1:j2),unam2(1:j3),unam3(1:j4)
        write (nttyo,1200) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1200   format(/' * Error - (EQPT/rdpzet) Have found an illegal data',
     $  ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $  ' in the superblock',/7x,"of Pitzer data for nca triplets.",
     $  ' Solvent water may not',/7x,'appear in such a triplet.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the electrical charges of the species.
c
      z1 = 0.
      z2 = 0.
      z3 = 0.
      iz1 = 0
      iz2 = 0
      iz3 = 0
      if (n1 .gt. 0) then
        z1 = zaqsp(n1)
        iz1 = nint(z1)
      endif
      if (n2 .gt. 0) then
        z2 = zaqsp(n2)
        iz2 = nint(z2)
      endif
      if (n3 .gt. 0) then
        z3 = zaqsp(n3)
        iz3 = nint(z3)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (n1.ne.0 .and. n2.ne.0 .and. n3.ne.0) then
c
c       Make sure that the species triplet is appropriate for the
c       current superblock. It must be of type nca. Other triplet
c       types such as cc'a, aa'c, nnn, nnn', and nn'n' are not
c       permitted here.
c
c       Count the neutral species.
c
        nn = 0
        if (iz1 .eq. 0) nn = 1
        if (iz2 .eq. 0) nn = nn + 1
        if (iz3 .eq. 0) nn = nn + 1
c
c       Count the cations.
c
        nc = 0
        if (iz1 .gt. 0) nc = 1
        if (iz2 .gt. 0) nc = nc + 1
        if (iz3 .gt. 0) nc = nc + 1
c
c       Count the anions.
c
        na = 0
        if (iz1 .lt. 0) na = 1
        if (iz2 .lt. 0) na = na + 1
        if (iz3 .lt. 0) na = na + 1
c
c       Check for duplications.
c
        qdup12 = unam1(1:24) .eq. unam2(1:24)
        qdup13 = unam1(1:24) .eq. unam3(1:24)
        qdup23 = unam2(1:24) .eq. unam3(1:24)
        qdupan = qdup12 .or. qdup23 .or. qdup13
c
        if (nc.eq.3 .or. na.eq.3
     $    .or. (nc.eq.2 .and. nn.eq.1)
     $    .or. (na.eq.2 .and. nn.eq.1)
     $    .or. (nn.eq.2 .and. nc.eq.1)
     $    .or. (nn.eq.2 .and. na.eq.1)
     $    .or. (nc.eq.2 .and. na.eq.1 .and. qdupan)
     $    .or. (na.eq.2 .and. nc.eq.1 .and. qdupan)) then
c
c         The current data block refers to a triplet combination
c         that is not valid in the Pitzer framework.
c
          write (noutpt,1220) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1220) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1220     format(/' * Error - (EQPT/rdpzet Have found an',
     $    ' illegal data block for the',/7x,'species triplet ',
     $    a,', ',a,', ',a,' in the',/7x,'superblock of Pitzer',
     $    " data for nca triplets.",/7x,'The present triplet',
     $    ' type is not valid in the Pitzer framework.')
          nerr = nerr + 1
        elseif (.not.(nn.eq.1 .and. nc.eq.1 .and. na.eq.1)) then
c
c         The current data block is in the wrong superblock.
c
          write (noutpt,1230) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1230) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1230     format(/' * Error - (EQPT/rdpzet Have found an',
     $    ' illegal data block for the',/7x,'species triplet ',
     $    a,', ',a,', ',a,' in the',/7x,'superblock of Pitzer',
     $    " data nca triplets. The present",/7x,'triplet type',
     $    ' may not appear in the current superblock.')
          nerr = nerr + 1
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species triplet storage rules:
c
c       nnn : neutral, neutral, neutral
c       nnn': neutral 1, neutral1, neutral 2
c       nca : neutral, cation, anion
c       cc'a: cation 1, cation 2, anion
c       aa'c: anion 1, anion 2, cation
c
c       A duplicated species appears first.
c
c       Otherwise, if two species are of the same charge type,
c       store alphabetically.
c
c     Here: neutral, cation, anion.
c
c     Copy the names before rearranging for storage.
c
      u1 = unam1
      u2 = unam2
      u3 = unam3
c
c     Rearrange according to the storage rules. Note that
c     n1, n2, n3, z1, z2, z3, iz1, iz2, iz3 are all changed
c     in addtion to u1, u2, u3. Note that unam1, unam2, and
c     unam3 are not changed.
c
      call artrip(iz1,iz2,iz3,na,nc,nn,n1,n2,n3,
     $ u1,u2,u3,z1,z2,z3)
c
c     Store the triplet names in the order required by the
c     storage rules. The triplet in the original order is
c     preserved in unam1, unam2, unam3 for use in error messages
c     and such.
c
      utripl(1,npx3) = u1
      utripl(2,npx3) = u2
      utripl(3,npx3) = u3
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the coefficients for the zeta(nca) parameters. Store the
c     zeta data as psi data.
c
c     Check the required parameter header.
c
      read (ndat0s,1000,end=990,err=995) uline
      j5 = ilnobl(uline)
      j5 = min(j5,70)
      ux80 = uline
      call lejust(ux80)
      ustr16 = 'zeta'
      j6 = 4
      if (ux80(1:j6) .ne. ustr16(1:j6)) then
        write (noutpt,1330) uline(1:j5),ustr16(1:j6),unam1(1:j2),
     $  unam2(1:j3),unam3(1:j4)
        write (nttyo,1330) uline(1:j5),ustr16(1:j6),unam1(1:j2),
     $  unam2(1:j3),unam3(1:j4)
 1330   format(/' * Error - (EQPT/rdpzet) Have found a line',
     $  ' starting with:',/7x,'"',a,'"',/7x,'where "',a,'" was',
     $  ' expected in the block for the species',/7x,'triplet ',
     $  a,', ',a,', ',a,' in the superblock of Pitzer data',
     $  /7x,"for nca triplets.")
        nerr = nerr + 1
        go to 999
      endif
c
c     Read the coefficients for the associated temperature function.
c
      do j = 1,jpfcmx
        read (ndat0s,1000,end=990,err=995) uline
        j5 = ilnobl(uline)
        j5 = min(j5,70)
        ux80 = uline
        call lejust(ux80)
        ustr16 = 'a  ='
        j6 = 4
        write (ustr16(2:2),'(i1)') j
        if (ux80(1:j6) .eq. ustr16(1:j6)) then
          udastr = ux80
          udastr(1:j6) = ' '
          call g1dat(ier,noutpt,nttyo,udastr,var)
          if (ier .gt. 0) then
            write (noutpt,1320) uline(1:j5),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
            write (nttyo,1320) uline(1:j5),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
 1320       format(/' * Error - (EQPT/rdpzet) Have found a line',
     $      ' starting with:',/7x,'"',a,'"',/7x,'containing an',
     $      ' expected numerical field that could not be read.',
     $      /7x,'This occurred in the block for the species triplet',
     $      /7x,a,', ',a,', ',a,' in the superblock of Pitzer data',
     $      /7x,"for nca triplets.")
            nerr = nerr + 1
            go to 999
          endif
          apsi(j,npx3) = var
        else
          write (noutpt,1330) uline(1:j5),ustr16(1:j6),unam1(1:j2),
     $    unam2(1:j3),unam3(1:j4)
          write (nttyo,1330) uline(1:j5),ustr16(1:j6),unam1(1:j2),
     $    unam2(1:j3),unam3(1:j4)
          nerr = nerr + 1
          go to 999
        endif
      enddo
c
c     Skip past the block delimiter line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
      if (uline(1:8) .ne. uterm(1:8)) then
        j5 = ilnobl(uline)
        j5 = min(j5,70)
        write (noutpt,1470) uline(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j4)
        write (nttyo,1470) uline(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j4)
 1470   format(/' * Error - (EQPT/rdpzet) Have found a line starting',
     $  ' with:',/7x,'"',a,'"',/7x,' in the data block for the species',
     $  ' triplet ',a,', ',a,', ',a,/7x,'in the superblock of',
     $  " Pitzer data for nca triplets. Should have",
     $  /7x,'found the delimiter line marking the end of the block.')
        nerr = nerr + 1
        go to 999
      endif
c
c     Process the next data block.
c
      go to 110
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/rdpzet) Unexpectedly encountered',
     $ /7x,"an end-of-file error while reading the nca (zeta)",
     $ /7x,'superblock of the DATA0 file.')
      stop
c
  995 write (noutpt,2020)
      write (nttyo,2020)
 2020 format(/' * Error - (EQPT/rdpzet) Encountered a read format',
     $ /7x,"error while reading the nca (zeta) superblock of",
     $ /7x,'the DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine lejust(ustr)
c
c     This subroutine left-justifies the non-blank portion of the string
c     ustr.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ustr   = the input string variable
c
c     Output:
c
c       ustr   = the output string variable
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jj,jbl,j1,nchars
c
      integer ifnobl
c
c-----------------------------------------------------------------------
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Get the position of the first non-blank character and the number
c     of blanks on the left-hand-side.
c
      j1 = ifnobl(ustr)
      jbl = j1 - 1
c
      if (jbl .gt. 0) then
        do jj = j1,nchars
          j = jj - jbl
          ustr(j:j) = ustr(jj:jj)
        enddo
        do j = nchars - jbl + 1,nchars
          ustr(j:j) = ' '
        enddo
      endif
c
      end

      subroutine intrct(cbsr,cbsri,cesr,cesri,egers,egersi,ibsrti,
     $ iern1,iern2,iesrti,ietmax,igerti,iktmax,imrn1,imrn2,ixrn1,
     $ ixrn2,ixrti,jcode,jetmax,jgerti,jgext,narn1,narn2,nbaspd,
     $ nbt,nbtmax,nbt1mx,ncmpr,nct,nctmax,nertmx,netmax,ngexsa,
     $ ngext,ngrn1,ngrn2,noutpt,nptmax,nrct,nrctmx,nrndex,nsrtmx,
     $ nstmax,nttyo,nxridx,nxrtmx,rxbar,rxbari,ubsri,ucxri,uelem,
     $ uesri,ugerji,ugermo,ugersi,ugexj,ugexmo,uphase,ureac,uspec,
     $ xgers,xgersi)
c
c     This subroutine assigns phase or species indices corresponding to
c     reactants.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c       jcode  = flag which determines the type of reactant:
c
c                  0 =  Mineral
c                  1 =  Solid solution
c                  2 =  Special reactant
c                  3 =  Aqueous species
c                  4 =  Gas
c                  5 =  Generic ion exchanger
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,jetmax,nbtmax,nbt1mx,nctmax,nertmx,netmax,
     $ nptmax,nrctmx,nsrtmx,nstmax,nxrtmx
c
      integer ibsrti(nsrtmx),iesrti(nsrtmx),igerti(jetmax,nertmx),
     $ ixrti(nxrtmx),jcode(nrctmx),jgerti(nertmx),jgext(netmax),
     $ ncmpr(2,nptmax),nbaspd(nbtmax),ngexsa(ietmax,jetmax,netmax),
     $ ngext(jetmax,netmax),nrndex(nrctmx),nxridx(nrctmx)
c
      integer iern1,iern2,imrn1,imrn2,ixrn1,ixrn2,narn1,narn2,nbt,nct,
     $ ngrn1,ngrn2,noutpt,nrct,nttyo
c
      character*48 uspec(nstmax)
      character*24 ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ ugermo(nertmx),ugersi(ietmax,jetmax,nertmx),ugexmo(netmax),
     $ uphase(nptmax),ureac(nrctmx)
      character*8 uelem(nctmax),uesri(nctmax,nsrtmx),
     $ ugerji(jetmax,nertmx),ugexj(jetmax,netmax)
c
      real*8 cesr(nctmax,nsrtmx),cesri(nctmax,nsrtmx),
     $ cbsr(nbt1mx,nsrtmx),cbsri(nbt1mx,nsrtmx),
     $ egers(ietmax,jetmax,netmax),egersi(ietmax,jetmax,nertmx),
     $ rxbar(iktmax,nxrtmx),rxbari(iktmax,nxrtmx),
     $ xgers(ietmax,jetmax,netmax),xgersi(ietmax,jetmax,nertmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,iei,ik,iki,je,jei,j2,j3,j4,j5,j6,nb,nbi,nc,nci,ne,ner,
     $ nerr,np,nrc,nr1,nr2,ns,nsr,nss,nt,nxr
c
      integer ilnobl
c
      character*24 urn,ux
      character*24 uaq,umn,ugs,uss,uge
      character*16 ux16
      character*8 uxd,ux8a,ux8b
c
      real*8 ex,exc,exo,rx,rxo,rxsum
c
c-----------------------------------------------------------------------
c
      data uaq    /'aqueous species         '/,
     $     umn    /'minerals                '/,
     $     ugs    /'gases                   '/,
     $     uss    /'solid solutions         '/,
     $     uge    /'generic ion exchangers  '/
c
c-----------------------------------------------------------------------
c
      if (nrct .eq. 0) go to 999
c
      nerr = 0
      nsr = 0
      nxr = 0
      ner = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nrc = 1,nrct
        urn = ureac(nrc)
c
        if (jcode(nrc) .eq. 0) then
c
c         Pure minerals.
c
          do np = imrn1,imrn2
           if (urn(1:24) .eq. uphase(np)(1:24)) then
             nrndex(nrc) = np
             go to 200
           endif
          enddo
c
          j2 = ilnobl(urn)
          j3 = ilnobl(umn)
          write (noutpt,1000) urn(1:j2),umn(1:j3)
          write (nttyo,1000) urn(1:j2),umn(1:j3)
 1000     format(/' * Error - (EQ6/intrct) The reactant ',a,
     $    " isn't among",/7x,'the loaded ',a,'.')
          nerr = nerr + 1
c
        elseif (jcode(nrc) .eq. 1) then
c
c         Solid solutions.
c
          nxr = nxr + 1
          do np = ixrn1,ixrn2
            if (urn(1:24) .eq. uphase(np)(1:24)) then
              nrndex(nrc) = np
              nxridx(nrc) = nxr
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              nt = nr2 - nr1 + 1
c
c             Make sure that the mole fractions sum to unity.
c
              rxsum = 0.
              do iki = 1,ixrti(nxr)
                rxsum = rxsum + rxbari(iki,nxr)
              enddo
c
              if (abs(rxsum - 1.0) .gt. 1.e-3) then
                j3 = ilnobl(urn)
                write (ux16,'(g11.4)') rxsum
                call lejust(ux16)
                j4 = ilnobl(ux16)
                write (noutpt,1002) urn(1:j3),ux16(1:j4)
                write (nttyo,1002) urn(1:j3),ux16(1:j4)
 1002           format(/' * Warning - (EQ6/intrct) The mole fractions',
     $          ' given for the composition',/7x,'of the solid',
     $          ' solution reactant ',a,' sum to',/7x,a,', not unity.',
     $          ' They will be renormalized.')
c
c               Renormalize the mole fractions.
c
                write (noutpt,1004)
                write (nttyo,1004)
 1004           format(/5x,'Renormalizing the Input Mole Fractions',
     $          //9x,'Component',19x,'Old x',9x,'New x',/)
                do iki = 1,ixrti(nxr)
                  rxo = rxbari(iki,nxr)
                  rx = rxo/rxsum
                  write (noutpt,1006) ucxri(iki,nxr),rxo,rx
                  write (nttyo,1006) ucxri(iki,nxr),rxo,rx
 1006             format(7x,a24,3x,1pe11.4,3x,e11.4)
                  rxbari(iki,nxr) = rx
                enddo
              endif
c
c             Decode the solid solution composition.
c
              do iki = 1,ixrti(nxr)
                ux = ucxri(iki,nxr)
                ns = nr1 - 1
                do ik = 1,nt
                  ns = ns + 1
                  if (uspec(ns)(1:24) .eq. ux(1:24)) then
                    rxbar(ik,nxr) = rxbari(iki,nxr)
                    go to 100
                  endif
                enddo
c
                j2 = ilnobl(ux)
                j3 = ilnobl(urn)
                write (noutpt,1010) ux(1:j2),urn(1:j3)
                write (nttyo,1010) ux(1:j2),urn(1:j3)
 1010           format(/' * Error - (EQ6/intrct) The species ',a,
     $          " doesn't appear",/7x,'on the data file as a',
     $          ' component of ',a,'.')
                nerr = nerr + 1
c
  100           continue
              enddo
              go to 200
            endif
          enddo
c
          j2 = ilnobl(urn)
          j3 = ilnobl(uss)
          write (noutpt,1000) urn(1:j2),uss(1:j3)
          write (nttyo,1000) urn(1:j2),uss(1:j3)
          nerr = nerr + 1
c
        elseif (jcode(nrc) .eq. 2) then
c
c         Special reactants.
c
          nsr = nsr + 1
          nrndex(nrc) = nsr
          nxridx(nrc) = nsr
c
c         Decode the chemical composition.
c
          do nci = 1,iesrti(nsr)
            uxd = uesri(nci,nsr)
c
            do nc = 1,nct
              if (uelem(nc)(1:8) .eq. uxd(1:8)) then
                cesr(nc,nsr) = cesri(nci,nsr)
                go to 110
              endif
            enddo
c
            j2 = ilnobl(uxd)
            j3 = ilnobl(urn)
            write (noutpt,1020) uxd(1:j2),urn(1:j3)
            write (nttyo,1020) uxd(1:j2),urn(1:j3)
 1020       format(/' * Error - (EQ6/intrct) The element ',a,
     $      ' in special reactant',/7x,a," isn't on the data file.")
            nerr = nerr + 1
c
  110       continue
          enddo
c
c         Decode the chemical reaction.
c
          ux = ubsri(1,nsr)
          if (ux(1:24) .eq. ureac(nrc)(1:24)) then
            cbsr(nbt1mx,nsr) = cbsri(1,nsr)
          else
            j2 = ilnobl(ux)
            j3 = ilnobl(urn)
            write (noutpt,1030) ux(1:j2),urn(1:j3)
            write (nttyo,1030) ux(1:j2),urn(1:j3)
 1030       format(' * Error - (EQ6/intrct) The species ',a,' appears',
     $      ' first',/7x,'in the reaction associated with the special',
     $      ' reactant',/7x,a,'. The special reactant itself must',
     $      ' appear first.')
            nerr = nerr + 1
          endif
c
          do nbi = 2,ibsrti(nsr)
            ux = ubsri(nbi,nsr)
c
            do nb = 1,nbt
              ns = nbaspd(nb)
              if (uspec(ns)(1:24) .eq. ux(1:24)) then
                cbsr(nb,nsr) = cbsri(nbi,nsr)
                go to 120
              endif
            enddo
c
            j2 = ilnobl(ux)
            j3 = ilnobl(urn)
            write (noutpt,1040) ux(1:j2),urn(1:j3)
            write (nttyo,1040) ux(1:j2),urn(1:j3)
 1040       format(' * Error - (EQ6/intrct) The species ',a,' which',
     $      ' appears',/7x,'in the reaction associated with the',
     $      ' special reactant',/7x,a," isn't in the data file',
     $      ' basis set.")
            nerr = nerr + 1
  120       continue
          enddo
c
        elseif (jcode(nrc) .eq. 3) then
c
c         Aqueous species.
c
          do ns = narn1,narn2
            if (urn(1:24) .eq. uspec(ns)(1:24)) then
              nrndex(nrc) = ns
              go to 200
            endif
          enddo
c
          j2 = ilnobl(urn)
          j3 = ilnobl(uaq)
          write (noutpt,1000) urn(1:j2),uaq(1:j3)
          write (nttyo,1000) urn(1:j2),uaq(1:j3)
          nerr = nerr + 1
c
        elseif (jcode(nrc) .eq. 4) then
c
c         Gases.
c
          do ns = ngrn1,ngrn2
            if (urn(1:24) .eq. uspec(ns)(1:24)) then
              nrndex(nrc) = ns
              go to 200
            endif
          enddo
c
          j2 = ilnobl(urn)
          j3 = ilnobl(ugs)
          write (noutpt,1000) urn(1:j2),ugs(1:j3)
          write (nttyo,1000) urn(1:j2),ugs(1:j3)
          nerr = nerr + 1
c
        elseif (jcode(nrc) .eq. 5) then
c
c         Generic ion exchangers.
c
          ner = ner + 1
          do np = iern1,iern2
            if (urn(1:24) .eq. uphase(np)(1:24)) then
              nxridx(nrc) = ner
              nrndex(nrc) = np
              ne = np - iern1 + 1
c
              if (ugermo(ner)(1:24) .ne. ugexmo(ne)(1:24)) then
                j2 = ilnobl(urn)
                j5 = ilnobl(ugermo(ner))
                j6 = ilnobl(ugexmo(ne))
                write (noutpt,1042) urn(1:j2),ugermo(ner)(1:j5),
     $          ugexmo(ne)(1:j6)
                write (nttyo,1042) urn(1:j2),ugermo(ner)(1:j5),
     $          ugexmo(ne)(1:j6)
 1042           format(/' * Error - (EQ6/intrct) The generic exchanger',
     $          ' phase reactant',/7x,a,' has the specified exchange',
     $          ' model',/7x,'"',a,'", but the defined exchange model',
     $          ' for this',/7x,'exchanger phase is "',a,'".')
                nerr = nerr + 1
              endif
c
              if (jgerti(ner) .ne. jgext(ne)) then
                j2 = ilnobl(urn)
                write (ux8a,'(i5)') jgerti(ner)
                call lejust(ux8a)
                j5 = ilnobl(ux8a)
                write (ux8b,'(i5)') jgext(ne)
                call lejust(ux8b)
                j6 = ilnobl(ux8b)
                write (noutpt,1044) urn(1:j2),ux8a(1:j5),ux8b(1:j6)
                write (nttyo,1044) urn(1:j2),ux8a(1:j5),ux8b(1:j6)
 1044           format(/' * Error - (EQ6/intrct) The generic exchanger',
     $          ' phase reactant',/7x,a,' has a specified composition',
     $          ' including',/7x,a,' exchange site(s), but this phase',
     $          ' actually has ',a,' exchange',/7x,'site(s). The',
     $          ' number of such sites must match.')
                nerr = nerr + 1
              endif
c
              do jei = 1,jgerti(ner)
c
c               Make sure that the exchange fractions on the current
c               site sum to unity.
c
                exc = 0.
                do iei = 1,igerti(jei,ner)
                  exc = exc + egersi(iei,jei,ner)
                enddo
c
                if (abs(exc - 1.0) .gt. 1.e-3) then
                  j3 = ilnobl(urn)
                  j4 = ilnobl(ugerji(jei,ner))
                  write (ux16,'(g11.4)') exc
                  call lejust(ux16)
                  j5 = ilnobl(ux16)
                  write (noutpt,1050) ugerji(1,j5),urn(1:j3),ux16(1:j5)
                  write (nttyo,1050) ugerji(1,j5),urn(1:j3),ux16(1:j5)
 1050             format(/' * Warning - (EQ6/intrct) The exchange',
     $            ' fractions given for the composition',/7x,'of',
     $            ' exchange site ',a,' of the generic ion exchanger',
     $            /7x,'reactant ',a,' sum to ',a,', not unity.',
     $            /7x,'They will be renormalized.')
c
c                 Renormalize the exchange fractions.
c
                  write (noutpt,1060)
                  write (nttyo,1060)
 1060             format(/5x,'Renormalizing the Input Exchange',
     $            ' Fractions',//9x,'Component',19x,'Old e',9x,
     $            'New e',/)
                  do iei = 1,igerti(jei,ner)
                    exo = egersi(iei,jei,ner)
                    ex = exo/exc
                    write (noutpt,1006) ugersi(iei,jei,ner),exo,ex
                    write (nttyo,1006) ugersi(iei,jei,ner),exo,ex
                    egersi(iei,jei,ner) = ex
                  enddo
                endif
c
c               Decode the composition of the current exchange site.
c
                do je = 1,jgext(ne)
                  if (ugexj(je,ne)(1:8) .eq. ugerji(jei,ner)(1:8))
     $            go to 150
                enddo
c
                j4 = ilnobl(ugerji(jei,ner))
                write (noutpt,1070) ugerji(jei,ner)(1:j4),urn(1:j3)
                write (nttyo,1070) ugerji(jei,ner)(1:j4),urn(1:j3)
 1070           format(/' * Error - (EQ6/intrct) The exchange site ',
     $          a,' specified for',/7x,'the generic ion exchanger',
     $          ' reactant ',a,'does not',/7x,'match any site',
     $          ' defined for that exchanger.')
                nerr = nerr + 1
                go to 170
c
  150           do iei = 1,igerti(jei,ner)
                  ux = ugersi(iei,jei,ner)
c
c                 Match with the exchange species name. This contains
c                 the site name.
c
                  ns = ncmpr(1,np)
                  do je = 1,jgext(ne)
                    do ie = 1,ngext(je,ne)
                      ns = ns + 1
                      if (uspec(ns)(1:24) .eq. ux(1:24)) then
                        egers(ie,je,ne) = egersi(iei,jei,ner)
                        go to 160
                      endif
                    enddo
                  enddo
c
c                 No match was found above. Match with the name of
c                 the aqueous species which exchanges. This does
c                 not contain the site name.
c
                  do je = 1,jgext(ne)
                    do ie = 1,ngext(je,ne)
                      nss = ngexsa(ie,je,ne)
                      if (nss .gt. 0) then
                        if (uspec(nss)(1:24) .eq. ux(1:24)) then
                          egers(ie,je,ne) = egersi(iei,jei,ner)
                          go to 160
                        endif
                      endif
                    enddo
                  enddo
c
                  j2 = ilnobl(ux)
                  j3 = ilnobl(urn)
                  write (noutpt,1080) ux(1:j2),urn(1:j3)
                  write (nttyo,1080) ux(1:j2),urn(1:j3)
 1080             format(/' * Error - (EQ6/intrct) The species ',
     $            a,' specified for',/7x,'the generic ion exchanger',
     $            ' reactant ',a,' does not',/7x,'match any species',
     $            ' defined for that exchanger.')
                  nerr = nerr + 1
c
  160             continue
                enddo
  170           continue
              enddo
              go to 200
            endif
          enddo
c
          j2 = ilnobl(urn)
          j3 = ilnobl(uge)
          write (noutpt,1000) urn(1:j2),uge(1:j3)
          write (nttyo,1000) urn(1:j2),uge(1:j3)
          nerr = nerr + 1
c
        endif
c
  200   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine hpsat(acflg,act,actlg,afcnst,affp,affs,apx,bpx,
     $ cdrs,eps100,iapxmx,ibpxmx,ier,iktmax,ixrn1,jflag,jpflag,
     $ jsflag,jsol,ncmpr,ndrs,ndrsmx,ndrsr,noutpt,np,nptmax,
     $ nstmax,nttyo,nxrn1,nxrn2,nxtmax,sidrsp,sidrph,uphase,
     $ uspec,wfac,xbar,xbarlg,xlks)
c
c     This subroutine calculates the most stable (least soluble)
c     composition of a given solid solution, given the composition
c     of the aqueous phase it is in equilibrium with.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/satchk.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       apx    = array of temperature-independent coefficients for
c                  solid solution activity coefficients
c       bpx    = array of site-mixing parameters for solid solution
c                  activity coefficients
c       ixrn1  = start of solid solution phases in the list of phases
c       ixrn2  = end of solid solution phases in the list of phases
c       jsol   = array of activity coefficient model indices for solid
c                  solutions
c       ncmpr  = species range pointer array for phases
c       uphase = array of phase names
c       uspec  = array of species names
c       wterm  = array of temperature-dependent coefficients for
c                  solid solution activity coefficients
c
c     Principal output:
c
c       acflg  = array of activity coefficients
c       act    = array of activities
c       actlg  = array of log activity values
c       affp   = array of affinities for phases
c       affs   = array of affinities for species
c       sidrph = array of saturation indices for phases
c       sidrsp = array of saturation indices for species
c       xbar   = array of mole fractions
c       xbarlg = array of log mole fraction values
c
c     Local:
c
c       sisppu = saturation index of a pure end-member, normalized
c                  so that one mole of end-member is destroyed in the
c                  corresponding reaction
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,ibpxmx,iktmax,ndrsmx,nptmax,nstmax,nxtmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),jpflag(nptmax),jsflag(nstmax),jsol(nxtmax),
     $ ncmpr(2,nptmax),ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer ier,ixrn1,np,nxrn1,nxrn2
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 acflg(nstmax),actlg(nstmax),act(nstmax),affp(nptmax),
     $ affs(nstmax),apx(iapxmx,nxtmax),bpx(ibpxmx,nxtmax),
     $ cdrs(ndrsmx),sidrsp(nstmax),sidrph(nptmax),wfac(iktmax,nxtmax),
     $ xbar(nstmax),xbarlg(nstmax),xlks(nstmax)
c
      real*8 afcnst,eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nactc,nrn1,nr1,nr2,ns,nx
c
      real*8 af,cx,si,siph,sisp,sisppu,stx,stxi,stxm1,xl,xqk,xqks,
     $ xqksum,xx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
      ier = 0
      nx = np - ixrn1 + 1
c
      nr1 = ncmpr(1,np)
      nr2 = ncmpr(2,np)
c
      affp(np) = -9999999.
      sidrph(np) = -9999999.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the affinities and saturation indices of the pure
c     end-members.
c
      do ns = nr1,nr2
        xbar(ns) = 1.0
        xbarlg(ns) = 0.
        acflg(ns) = 0.
        act(ns) = 1.0
        actlg(ns) = 0.
c
        call afcalc(actlg,af,afcnst,cdrs,jflag,jsflag,ndrs,ndrsmx,
     $  ndrsr,ns,nstmax,si,xlks)
        affs(ns) = af
        sidrsp(ns) = si
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Count the number of active components.
c
      nactc = 0
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nactc = nactc + 1
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the value of the site-mixing parameter.
c
      if (bpx(1,nx) .le. 0.) bpx(1,nx) = 1.0
      stx = bpx(1,nx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (abs(stx - 1.0) .gt. eps100) go to 200
c
c     Calculate the mole fractions for the case of an ideal molecular
c     mixing solution.
c
      xqksum = 0.
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xqk = texp(sisppu)
          xqksum = xqksum + xqk
        endif
      enddo
c
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xqk = texp(sisppu)
          xx = xqk/xqksum
          xbar(ns) = xx
          xbarlg(ns) = tlg(xx)
        endif
      enddo
c
c     Calculate the activities, activity coefficients, affinities,
c     and saturation indices for the case of an ideal molecular
c     mixing solution.
c
      siph = 0.
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xx = xbar(ns)
          xl = xbarlg(ns)
          sisp = sisppu - xl
          acflg(ns) = 0.
          act(ns) = xx
          actlg(ns) = xl
          sisp = sisp/cx
          sidrsp(ns) = sisp
          affs(ns) = afcnst*sisp
          siph = siph + xx*sisp
        endif
      enddo
      sidrph(np) = siph
      affp(np) = afcnst*siph
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  200 continue
c
c     Calculate the mole fractions for the case of an ideal site-mxing
c     solution.
c
      stxi = 1./bpx(1,nx)
      stxm1 = stx - 1.0
c
      xqksum = 0.
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xqk = texp(sisppu)
          xqks = xqk**stxi
          xqksum = xqksum + xqks
        endif
      enddo
c
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xqk = texp(sisppu)
          xqks = xqk**stxi
          xx = xqks/xqksum
          xbar(ns) = xx
          xbarlg(ns) = tlg(xx)
        endif
      enddo
c
c     Calculate the activities, activity coefficients, affinities,
c     and saturation indices for the case of an ideal site-mixing
c     solution.
c
      siph = 0.
      do ns = nr1,nr2
        if (jsflag(ns) .le. 0) then
          nrn1 = ndrsr(1,ns)
          cx = (-1.0/cdrs(nrn1))
          sisppu = cx*sidrsp(ns)
          xx = xbar(ns)
          xl = xbarlg(ns)
          sisp = sisppu - stx*xl
          acflg(ns) = stxm1*xl
          act(ns) = xx**stx
          actlg(ns) = stx*xl
          sisp = sisp/cx
          sidrsp(ns) = sisp
          affs(ns) = afcnst*sisp
          siph = siph + xx*sisp
        endif
      enddo
      sidrph(np) = siph
      affp(np) = afcnst*siph
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine absswb(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $ axhfsx,axlks,axlksx,axvfs,axvfsx,cdrs,cdrtw,cdrsx,cdrw,
     $ csts,dhfs,dvfs,eps100,ibswx,iindx1,iodb,ipch,ipchmx,ipcv,
     $ ipcvmx,jcsort,jflag,jsflag,kbt,kmax,mosp,mtb,narn1,narn2,
     $ narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,
     $ ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,noutpt,nst,
     $ nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,presg,
     $ press,qbassw,qbswx,tempc,uspec,uzvec1,weight,xhfs,xvfs,xlks)
c
c     This subroutine carries out automatic basis switching to optimize
c     optimize the basis set after Newton-Raphson iteration has
c     converged at the current point of reaction progress. Such
c     optimization tends to improve the code numerics (finite
c     difference stability, matrix conditioning, etc.) This subroutine
c     is similar to EQLIB/absswa.f, which carries out automatic basis
c     switching as a pre-Newton-Raphson optimization technique.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,kmax,narxmx,nbtmax,ndrsmx,nodbmx,nstmax,
     $ nstsmx,ntprmx
c
      integer noutpt,nttyo
c
      integer ibswx(nbtmax),iindx1(kmax),iodb(nodbmx),jcsort(nstmax),
     $ jflag(nstmax),jsflag(nstmax),narxt(ntprmx),nbasp(nbtmax),
     $ nbaspd(nbtmax),nbaspx(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ ndrsrx(2,nstmax),ndrsx(ndrsmx),nsts(nstsmx),nstsr(2,nstmax)
c
      integer ipch,ipcv,kbt,narn1,narn2,nbt,nbw,nelect,nhydr,no2gaq,
     $ nst,nswtch,ntpr
c
      logical qbassw,qbswx
c
      character*48 uspec(nstmax),uzvec1(kmax)
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ csts(nstsmx),dhfs(ipchmx,nstmax),dvfs(ipcvmx,nstmax),
     $ mosp(nstmax),mtb(nbtmax),weight(nstmax),xhfs(nstmax),
     $ xlks(nstmax),xvfs(nstmax)
c
      real*8 avcnst,presg,press,tempc
c
      real*8  eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen1,jlen2,jlen3,krow,nb,nb1,nb2,ns,nse,nsi,nsj,ns1,ns2
c
      character*56 usp156,usp256,usp356
c
      real*8 api,apj,cx,fx1,fx2,rx,wb1,wb2,wsi
c
      real*8 coefdr,coefst
c
c-----------------------------------------------------------------------
c
c     Initialize the number of basis switches made.
c
      nswtch = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pick candidates for automatic basis switching. The indices of
c     candidates are stored in the array ibswx. Note that the method
c     employed here is similar to that in EQLIB/abswpk.f. However,
c     there are some differences. Here, basis switching is not being
c     used as a method of pre-Newton-Raphson optimization. Hence, there
c     are no residual functions used in defining criteria for making
c     a switch. the relative contributions to mass balances are used
c     instead.
c
      qbswx = .false.
      do nb = 1,nbt
        ibswx(nb) = 0
        nse = nbaspd(nb)
        nsj = nbasp(nb)
        if (nse.ne.narn1 .and. nse.ne.nhydr .and. nse.ne.no2gaq
     $    .and.nse.ne.nelect) then
c
c         If the current species is not H2O, H+, O2(g,aq), or e-,
c         consider a switch.
c
c         Get weights for the current mass balance.
c
          do ns = narn1,narn2
            weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
          enddo
c
c         Screen out species in the mass balance that are not linked
c         by the current reaction with the current basis species.
c         Do this by seting the corresponding weights to zero.
c
          do ns = narn1,narn2
            if (jflag(ns) .eq. 30) then
c
c             Calling sequence substitutions:
c               nsj for nse
c
              cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,ns,nstmax)
              if (cx .eq. 0.) weight(ns) = 0.
            endif
          enddo
c
c         Find a candidate.
c
          call fbassw(jcsort,jflag,mosp,narn1,narn2,nse,nsi,nsj,
     $    nstmax,weight,wsi)
c
c         If a candidate was found, apply a filter.
c
          if (nsi .gt. 0) then
c
c           Use the current candidate species if its contribution
c           to the mass balance exceeds that of the current basis
c           species by a reasonable factor, here 10.
c
            api = weight(nsi)*mosp(nsi)
            apj = weight(nsj)*mosp(nsj)
            rx = api/apj
            if (rx .gt. 10.) then
              ibswx(nb) = nsi
              qbswx = .true.
            endif
          endif
        endif
      enddo
c
c     If there are no candidates for basis switching, exit the
c     present subroutine.
c
      if (.not.qbswx) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .ge. 2) then
        write (noutpt,1000)
 1000   format(/5x,'--- Candidate Basis Switches ---',/)
        do nb = 1,nbt
          nse = nbaspd(nb)
          nsj = nbasp(nb)
          nsi = ibswx(nb)
          if (nsi .gt. 0) then
c
c           Calling sequence substitutions:
c             jlen1 for jlen
c             uspec(nsj) for unam48
c             usp156 for uspn56
c
            call fmspnx(jlen1,uspec(nsj),usp156)
c
c           Calling sequence substitutions:
c             jlen2 for jlen
c             uspec(nsi) for unam48
c             usp256 for uspn56
c
            call fmspnx(jlen2,uspec(nsi),usp256)
c
c           Calling sequence substitutions:
c             jlen3 for jlen
c             uspec(nse) for unam48
c             usp356 for uspn56
c
            call fmspnx(jlen3,uspec(nse),usp356)
c
            write (noutpt,1010) usp156(1:jlen1),usp256(1:jlen2),
     $      usp356(1:jlen3)
 1010       format(/3x,'Could replace ',a,' in the active basis set',
     $      ' with',/3x,a,' as the species associated with the mass',
     $      ' balance',/3x,'of ',a,'.')
          endif
        enddo
        write (noutpt,1020)
 1020   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Resolve any conflicts in candidate basis switches. The algorithm
c     used here is similar to but not identical to that employed by
c     EQLIB/gabswx.f, which resolves conflicts in the context of using
c     automatic basis switching as a form of pre-Newton-Raphson
c     optimization.
c
      do nb1 = 1,nbt - 1
        ns1 = ibswx(nb1)
        if (ns1 .gt. 0) then
          do nb2 = nb1 + 1,nbt
            ns2 = ibswx(nb2)
            if (ns2 .eq. ns1) then
c
c             Calling sequence substitutions:
c               nb1 for nb
c
              wb1 = coefst(csts,nsts,nstsmx,nstsr,nb1,ns,nstmax)
              fx1 = wb1*mosp(ns1)/mtb(nb1)
c
c             Calling sequence substitutions:
c               nb2 for nb
c
              wb2 = coefst(csts,nsts,nstsmx,nstsr,nb2,ns,nstmax)
              fx2 = wb2*mosp(ns2)/mtb(nb2)
              if (fx1 .gt. fx2) then
                ibswx(nb2) = 0
              else
                ibswx(nb1) = 0
                go to 100
              endif
            endif
          enddo
        endif
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nswtch = 0
      do nb = 1,nbt
        nsi = ibswx(nb)
        if (nsi .gt. 0) nswtch = nswtch + 1
      enddo
c
      if (nswtch .le. 0) then
        if (iodb(1) .ge. 2) write (noutpt,1070)
 1070   format(/10x,'No switches will be made.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .ge. 2) then
        write (noutpt,1100)
 1100   format(/5x,'--- Automatic Basis Switches ---',/)
        do nb = 1,nbt
          nse = nbaspd(nb)
          nsj = nbasp(nb)
          nsi = ibswx(nb)
          if (nsi .gt. 0) then
c
c           Calling sequence substitutions:
c             jlen1 for jlen
c             uspec(nsj) for unam48
c             usp156 for uspn56
c
            call fmspnx(jlen1,uspec(nsj),usp156)
c
c           Calling sequence substitutions:
c             jlen2 for jlen
c             uspec(nsi) for unam48
c             usp256 for uspn56
c
            call fmspnx(jlen2,uspec(nsi),usp256)
c
c           Calling sequence substitutions:
c             jlen3 for jlen
c             uspec(nse) for unam48
c             usp356 for uspn56
c
            call fmspnx(jlen3,uspec(nse),usp356)
c
            write (noutpt,1110) usp156(1:jlen1),usp256(1:jlen2),
     $      usp356(1:jlen3)
 1110       format(/3x,'Will replace ',a,' in the active basis set',
     $      ' with',/3x,a,' as the species associated with the mass',
     $      ' balance',/3x,'of ',a,'.')
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      call autosw(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $ axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ibswx,iindx1,
     $ ipch,ipchmx,ipcv,ipcvmx,jflag,jsflag,kbt,kmax,narn1,narxmx,
     $ nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,
     $ ndrsrx,noutpt,nst,nstmax,ntprmx,nttyo,qbassw,uspec,uzvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the cdrw array.
c
      call gcdrw(cdrs,cdrw,narn1,ndrs,ndrsmx,ndrsr,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the cdrtw array.
c
      call gcdrtw(cdrs,cdrtw,narn1,narn2,ndrs,ndrsmx,ndrsr,
     $ nelect,no2gaq,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update the thermodynamic data to correspond to the new
c     active basis set. First, recompute the log K, etc., data for
c     the various reactions.
c
      call evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $ ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $ tempc,xhfs,xlks,xvfs)
c
c     Then make pressure corrections to these thermodynamic data.
c
      if (ipcv .ge. 0) then
        call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $  nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $  xlks,xvfs)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine calk(alkc,conc,nstmax,ntfx,ntfxmx,ntfxt,tfx)
c
c     This subroutine calculates the alkalinity (eq/kg H2O). A sorted
c     summation is not done here, because relatively few species
c     contribute to alkalinity. Also, the structure of the titration
c     factor arrays (tfx, ntfx) is not amenable to an efficient
c     calculation of that sort.
c
c     This subroutine is called by:
c
c       EQLIB/betas.f
c       EQLIB/prtalk.f
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       ntfx   = array of species indices corresponding to the
c                  alkalinity factors in the tfx array
c       ntfxt  = the number of species contributing to alkalinity
c       tfx    = array of alkalinity factors
c
c     Principal output:
c
c       alkc   = the calculated alkalinity (eq/kg H20)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax,ntfxmx
c
      integer ntfx(ntfxmx)
      integer ntfxt
c
      real*8 conc(nstmax),tfx(ntfxmx)
      real*8 alkc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,n
c
      real*8 ax
c
c-----------------------------------------------------------------------
c
c     Note that the loop is unrolled.
c
      ax = 0.
      ileft = (ntfxt/8)*8
c
      do n = 1,ileft,8
        ax = ax + tfx(n)*conc(ntfx(n))
     $          + tfx(n + 1)*conc(ntfx(n + 1))
     $          + tfx(n + 2)*conc(ntfx(n + 2))
     $          + tfx(n + 3)*conc(ntfx(n + 3))
     $          + tfx(n + 4)*conc(ntfx(n + 4))
     $          + tfx(n + 5)*conc(ntfx(n + 5))
     $          + tfx(n + 6)*conc(ntfx(n + 6))
     $          + tfx(n + 7)*conc(ntfx(n + 7))
      enddo
c
      do n = ileft + 1,ntfxt
        ax = ax + tfx(n)*conc(ntfx(n))
      enddo
c
      alkc = ax
c
      end

      subroutine intbsw(nbasp,nbaspx,nbt,nbtmax,nobswt,noutpt,nst,
     $ nstmax,nttyo,uobsw,uspec)
c
c     This subroutine interprets ordinary basis switching directives
c     specified on the input file.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nbasp  = the indices of the species in the basis set
c                  (modified by this subroutine)
c       nbt    = the number of species in the basis set
c       nobswt = the number of basis switches to make
c       uobsw  = the name pairs for the species to be switched
c       uspec  = array of species names
c
c     Principal output:
c
c       nbasp  = the indices of the species in the basis set
c                  (modified by this subroutine)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer nbasp(nbtmax),nbaspx(nbtmax)
      integer nobswt,nbt,nst
c
      character(len=48) uobsw(2,nbtmax),uspec(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,n,nb,nerr,ns1,ns2
c
      character(len=56) uspn56
      character(len=48) unam48
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      do n = 1,nobswt
c
c       Find the first species.
c
        do nb = 1,nbt
          ns1 = nbaspx(nb)
          if (uspec(ns1)(1:48) .eq. uobsw(1,n)(1:48)) go to 110
        enddo
c
        nerr = nerr + 1
c
        unam48 = uobsw(1,n)
        call fmspnx(jlen,unam48,uspn56)
        write (noutpt,1000) uspn56(1:jlen)
        write (nttyo,1000) uspn56(1:jlen)
 1000   format(/' * Error - (EQLIB/intbsw) The species ',a,
     $  /7x,'is specified to be replaced in an ordinary basis switch,',
     $  /7x,'but it is not in the active basis set.')
        go to 150
c
  110   continue
c
c       Find the second species.
c
        do ns2 = 1,nst
          if (uspec(ns2)(1:48) .eq. uobsw(2,n)(1:48)) go to 130
        enddo
c
        nerr = nerr + 1
c
        unam48 = uobsw(2,n)
        call fmspnx(jlen,unam48,uspn56)
        write (noutpt,1010) uspn56(1:jlen)
        write (nttyo,1010) uspn56(1:jlen)
 1010   format(/' * Error - (EQLIB/intbsw) The species ',a,
     $  /7x,'is specified to be put into the basis set by an ordinary',
     $  /7x,'basis switch but it is not in the set of active',
     $  ' species.')
        go to 150
c
  130   continue
c
c       Mark to switch.
c
        nbasp(nb) = ns2
c
  150   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Stop if name match errors have been encountered.
c
      if (nerr .gt. 0) then
        write (noutpt,1020) nerr
        write (nttyo,1020) nerr
 1020   format(/' * Error - (EQLIB/intbsw) ',i4,' errors were',
     $  /7x,'encountered interpreting ordinary basis switches that',
     $  /7x,'were directed on the input file.')
        stop
      endif
c
      end

      subroutine rijust(ustr)
c
c     This subroutine right-justifies the non-blank portion of the
c     string ustr.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ustr   = the input string variable
c
c     Output:
c
c       ustr   = the output string variable
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jj,jbl,j2,nchars
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Get the position of the last non-blank character and the number
c     of blanks on the right-hand-side.
c
      j2 = ilnobl(ustr)
      jbl = nchars - j2
c
      if (jbl .gt. 0) then
        do jj = j2,1,-1
          j = jj + jbl
          ustr(j:j) = ustr(jj:jj)
        enddo
        do j = 1,jbl
          ustr(j:j) = ' '
        enddo
      endif
c
      end

      subroutine wterm(apx,iapxmx,iktmax,ixrn1,ixrn2,jsol,ncmpr,
     $ noutpt,nptmax,nstmax,nttyo,nxt,nxtmax,press,tempk,uphase,
     $ uspec,wfac)
c
c     This subroutine computes the wfac(i,nx) array, which contains
c     the coefficients for the excess free energy function of
c     solid solutions. If non-zero coefficients are lacking, the
c     solid solution reduces to an ideal solution and the jsol value
c     is changed to zero to reflect this.
c
c     This subroutine is called by:
c
c       EQLIB/evdata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       apx    = array of non-ideal mixing parameters
c       jsol   = array of non-ideal mixing law flags
c       press  = pressure, bars
c       tempk  = temperature, K
c       uphase = array of phase names
c
c     Principal input:
c
c       wfac   = array of non-ideal mixing parameters calculated from
c                  the apx array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,iktmax,nptmax,nstmax,nxtmax
c
      integer jsol(nxtmax),ncmpr(2,nptmax)
      integer ixrn1,ixrn2,noutpt,nttyo,nxt
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 apx(iapxmx,nxtmax),wfac(iktmax,nxtmax)
      real*8 press,tempk
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ix,iy,j2,k,np,nx
c
      integer ilnobl
c
      character*48 ux48,uy48
c
      real*8 sum
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that uspec, ncmpr, and ixrn2
c     are not used.
c
      ux48 = uspec(1)
      uy48 = ux48
      uspec(1) = uy48
c
      ix = ncmpr(1,1)
      iy = ix
      ncmpr(1,1) = iy
c
      ix = ixrn2
      iy = ix
      ixrn2 = iy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      np = ixrn1 - 1
      do nx = 1,nxt
        np = np + 1
        sum = 0.
        do i = 1,iapxmx
          sum = sum + apx(i,nx)*apx(i,nx)
        enddo
c
        if (jsol(nx).eq.1 .and. sum.gt. 0.) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1735) uphase(np)(1:j2)
          write (nttyo,1735) uphase(np)(1:j2)
1735      format(/' * Note - (EQLIBG/wterm) The phase ',a,' is',
     $    /7x,'listed as ideal. This is inconsistent with the',
     $    /7x,'presence of non-zero data in the apx array. These',
     $    /7x,'data will be ignored.')
          do i = 1,iapxmx
            apx(i,nx) = 0.
          enddo
        endif
c
        if (jsol(nx).ne.1 .and. sum.eq.0.) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1736) uphase(np)(1:j2)
          write (nttyo,1736) uphase(np)(1:j2)
1736      format(/' * Note - (EQLIBG/wterm) The phase ',a,' is',
     $    /7x,'listed as non-ideal, but no non-zero data are present'
     $    /7x,'in the apx array. This phase will be treated as ideal.')
          jsol(nx) = 1
        endif
c
c       Initialize wfac values to zero
c
        do i = 1,iktmax
          wfac(i,nx) = 0.
        enddo
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      np = ixrn1 - 1
      do nx = 1,nxt
        np = np + 1
        k = jsol(nx)
        if (k .eq. 1) then
c
c         Ideal solution.
c
          continue
        elseif (k.eq.2) then
c
c         binary solution, third-order maclaurin expansion
c         original pathi solid solution model.
c
          wfac(1,nx) = apx(1,nx)
          wfac(2,nx) = apx(2,nx)
          wfac(3,nx) = apx(3,nx)
          wfac(1,nx) = -wfac(2,nx)/2. - wfac(3,nx)/6.
c
        elseif (k.eq.3) then
c
c       binary solution, parabolic maclaurin expansion
c
          wfac(1,nx) = apx(1,nx)
c
        elseif (k.eq.4) then
c
c         binary solution, cubic maclaurin (p,t dependent)
c
          wfac(1,nx) = apx(1,nx) + apx(2,nx)*tempk + apx(3,nx)*press
          wfac(2,nx) = apx(4,nx) + apx(5,nx)*tempk + apx(6,nx)*press
c
        elseif (k.eq.5) then
c
c         binary solution, guggenheim polynomial (t dependent)
c
          wfac(1,nx) = apx(1,nx) + apx(2,nx)*tempk
     $    + apx(3,nx)*tempk*tempk
          wfac(2,nx) = apx(4,nx) + apx(5,nx)*tempk
     $    + apx(6,nx)*tempk*tempk
          wfac(3,nx) = apx(7,nx) + apx(8,nx)*tempk
     $    + apx(9,nx)*tempk*tempk
c
        elseif (k.eq.6) then
c
c         ternary regular solution (see prigogine and defay, p. 257)
c
          wfac(1,nx) = apx(1,nx)
          wfac(2,nx) = apx(2,nx)
          wfac(3,nx) = apx(3,nx)
c
        elseif (k.eq.7) then
c
c         newton et al plagioclase model (gca vol 44 p. 933, 1980)
c         1 - albite; 2 - anorthite
c
          wfac(1,nx) = apx(1,nx)
          wfac(2,nx) = apx(2,nx)
        else
          j2 = ilnobl(uphase(np))
          write (noutpt,100) jsol(nx),uphase(np)(1:j2)
          write (nttyo,100) jsol(nx),uphase(np)(1:j2)
 100      format(/' * Error - (EQLIBG/wterm) Have an Illegal jsol',
     $    /7x,'value of ',i2,' for solid solution ',a,'.')
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine undflw
c
c     This subroutine disables underflow trapping. This is not
c     necessary on most modern platform/OS/compiler combinations, as
c     they do not engage in underflow trapping by default at the
c     system level. More commonly, underflow trapping is now a compiler
c     option (which should be turned off in the case of EQ3/6).
c
c     On some (mainly older) systems, underflow trapping is built into
c     the system in a way that can only be overridden for a given
c     program by putting a platform-dependent system subroutine call
c     in that program. If such a call is necessary, it should be made
c     in the present subroutine. If it appears that such a call is
c     necessary, consult your local system documentation, compiler
c     documentation, compiler vendor, or local computer support person
c     to find out what this call should be. Do not call LLNL to find
c     out.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
com   BEGIN_MACHINE_DEPENDENT_CODE
com
com     If a system subroutine call is necessary to disable underflow
com     trapping, add it here.
com
com
com   END_MACHINE_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine jflaux(jflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,
     $ ndrsrd,nstmax)
c
c     This subroutine sets jflag to -1 for auxiliary basis species that
c     can not appear in the model.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jflag  = array of species control flags
c       nbaspd = array of indices of species in the data file basis
c                  set
c       nbtd   = number of species in the data file basis set
c
c
c     Principal output:
c
c       jflag  = array of species control flags
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer jflag(nstmax),nbaspd(nbtmax),ndrsd(ndrsmx),
     $ ndrsrd(2,nstmax)
      integer nbtd
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nb,ncount,nr1,nr2,ns,nse
c
c-----------------------------------------------------------------------
c
c     Note that looping is required to accommodate multi-level
c     dependencies in the auxiliary basis set. If jflag is set
c     to -1 for any auxiliary basis species, another pass is required
c     to insure that jflag is also set to -1 for any higher-level
c     auxiliary basis species.
c
  100 ncount = 0
      do nb = 1,nbtd
        ns = nbaspd(nb)
        nr1 = ndrsrd(1,ns)
        nr2 = ndrsrd(2,ns)
        if (jflag(ns) .eq. 30) then
          do n = nr1 + 1,nr2
            nse = ndrsd(n)
            if (jflag(nse) .eq. -1) then
              jflag(ns) = -1
              ncount = ncount + 1
              go to 110
            endif
          enddo
        endif
  110   continue
      enddo
      if (ncount .gt. 0) go to 100
c
      end

      subroutine pcraq(aamatr,apr,atwt,avgrid,cdrs,cdrsi,cess,cessi,
     $ cof,dhfe,dhfs,dvfe,dvfs,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,
     $ ipivot,itgenf,mtotr,nacdpr,narxmx,narxt,nat,natmax,nbt,nbtmx1,
     $ nbtmx2,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,ndbmax,ndbptg,
     $ ndbptl,nentei,nentri,nerr,nmodwr,noutpt,nsb,nslist,ntprmx,ntprt,
     $ nttyo,nwarn,qelect,q500fl,tempc,tempcs,tmpcmx,uaqsp,udbfmt,
     $ udbval,udrsi,uelem,uessi,uspec,xdbval,xhfe,xhfs,xlke,xlks,xvfe,
     $ xvfs,xvec,yvec,zaqsp,zchar)
c
c     This subroutine reads data on aqueous species from the stripped
c     DATA0 file, processes this data, and writes the results on the
c     DATA1 and DATA1F files. The counter nerr is incremented by
c     one for each error encountered. The counter nwarn is incremented
c     similarly for each warning.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narxt  = array of numbers of coefficients in the temperature
c                  ranges
c       nbt    = the number of basis species
c       nct    = the number of chemical elements
c       ndata1 = unit number of the DATA1 file
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c       ndbptg = the number of distinct points on the temperature grid
c       ndbptl = the maximum number of points on the temperature grid
c                  per line
c       ntprt  = the number of temperature ranges on the standard
c                  temperature grid
c       qelect = flag denoting the use of "e-" instead of "O2(g)"
c                  in writing chemical reactions
c       tempc  = array of temperatures (on the temperature grid)
c       tempcs = array of scaled temperatures (on the temperature grid)
c       tmpcmx = the max norm of the tempeatures on the temperature grid
c       udbfmt = the format for reading a line of data on the
c                  temperature grid
c
c
c     Principal output:
c
c       atwt   = array of atomic weights
c       cdrs   = array of reaction coefficients
c       cess   = array of elemental composition coefficients
c       nat    = the number of aqueous species
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c       uaqsp  = array of aqueous species names
c       uelem  = array of names of chemical elements
c       uspec  = array of names of species
c       xlke   = array of log K values for the "Eh" reaction (on the
c                  temperature grid)
c       xlks   = array of log K values for reactions
c       zaqsp  = array of charge numbers of aqueous species
c       zchar  = array of electrical charge numbers of species
c
c     Workspace:
c
c       aamatr = matrix used to calculate the polynomial coefficients
c       apr    = array of polynomial coefficients (for all ranges)
c       avgrid = array containing the data on the temperature grid
c       cof    = array of fitted polynomial coefficients (for a
c                  single temperature range)
c       gmmatr = a copy of the amatr matrix
c       ipivot = the pivot vector, used in solving matrix equations
c       nacdpr = array containging the number of actual data points
c                  by range on the "log K" temperature grid; excludes
c       udbval = string array for reading data on the temperature grid
c       xdbval = holding space array for data on the temperature grid
c       xvec   = array of scaled temperatures corresponding to the
c                  data in the yvec array
c       yvec   = array of data to be fitted (for a single temperature
c                  range)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,natmax,nbtmx1,nbtmx2,nctmax,
     $ ndbmax,ntprmx
c
      integer ndata1,ndat0s,ndat1f,noutpt,nslist,nttyo
c
      integer ipivot(narxmx),nacdpr(ntprmx),narxt(ntprmx),
     $ nentei(nctmax),nentri(nbtmx1)
c
      integer ipch,ipcv,itgenf,nat,nbt,nch,nco,nct,ndbptg,ndbptl,nerr,
     $ nmodwr,nsb,ntprt,nwarn
c
      logical qelect,q500fl
c
      character(len=24) uaqsp(natmax),udrsi(nbtmx1),uspec(nbtmx1)
      character(len=16) udbval(ndbmax)
      character(len=8) uelem(nctmax),uessi(nctmax)
c
      character(len=16) udbfmt
c
      real(8) atwt(nctmax),cdrs(nbtmx2,nbtmx1),cdrsi(nbtmx1),
     $ cess(nctmax,nbtmx1),cessi(nctmax),dhfe(narxmx,ntprmx,ipchmx),
     $ dhfs(narxmx,ntprmx,ipchmx,nbtmx1),dvfe(narxmx,ntprmx,ipcvmx),
     $ dvfs(narxmx,ntprmx,ipcvmx,nbtmx1),xhfe(narxmx,ntprmx),
     $ xhfs(narxmx,ntprmx,nbtmx1),xlke(narxmx,ntprmx),
     $ xlks(narxmx,ntprmx,nbtmx1),xvfe(narxmx,ntprmx),
     $ xvfs(narxmx,ntprmx,nbtmx1),zchar(nbtmx1),zaqsp(natmax)
c
      real(8) apr(narxmx,ntprmx),avgrid(narxmx,ntprmx)
      real(8) tempc(narxmx,ntprmx),tempcs(narxmx,ntprmx),tmpcmx(ntprmx)
      real(8) aamatr(narxmx,narxmx),gmmatr(narxmx,narxmx)
      real(8) cof(narxmx),xvec(narxmx),yvec(narxmx)
      real(8) xdbval(ndbmax),mtotr(nctmax)
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,ipc,j,j2,j3,j4,j5,k,n,nbt1,nbw,nc,ncount,ncts,ndrsts,
     $ nmodx,nn,nnx,ns,nse,nsm1,nspnx,nt,ntpr,nxm
c
      integer ilnobl
c
      logical qblkes,qblkrs,qend,qerr,qnofes,qnofrs,qzeres,qzerrs,
     $ q500nd
c
      character(len=24) uspn(2)
c
      character(len=80) ulbufa,ulbufb,uline,ux80
      character(len=72) uterm,utermc
      character(len=56) ustrgr
      character(len=24) uaq24,uend24,ublk24,unone,usblkf,ux24
      character(len=16) ux16
      character(len=8) uaqu,uaux,ux8,ux8a,ux8b,ux8c,uendit,usol
c
      real(8) mwtss,zx
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data uaq24 /'aqueous                 '/
      data unone /'none                    '/
      data uendit /'endit.  '/
      data uaux /'auxiliar'/
      data uaqu /'aqueous '/
      data usol /'solids  '/
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     The variable nn must be set to zero here to provide a proper
c     diagnostic if an early end-of-file or read format error occurs.
c
      nn = 0
c
      q500nd = q500fl
c
c     Set the expected index of H2O.
c
      nbw = 1
c
c     Skip 2 lines to the 'basis species' delimiter.
c
      read (ndat0s,1000,end=990,err=995) uline
      read (ndat0s,1000,end=990,err=995) uline
 1000 format(a)
c
c     Write label.
c
      usblkf = uaq24
      j3 = ilnobl(uaq24)
      write (ndata1) uaq24
      write (ndat1f,1010) uaq24(1:j3)
 1010 format(a)
      write (ndat1f,1010) utermc(1:72)
      write (noutpt,1020) uaq24(1:j3)
      write (nttyo,1020) uaq24(1:j3)
      write (nslist,1020) uaq24(1:j3)
 1020 format(//1x,a,/)
c
c     Initialize some variables.
c
      qelect = .false.
      uend24(1:8) = uendit(1:8)
      uend24(9:24) = ublk24(9:24)
      uspn(1) = unone
      uspn(2) = ublk24
      nspnx = 1
      nnx = -1
      nn = 1
      nmodx = 0
      nbt1 = nbt + 1
      nat = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note: the main loop returns here.
c
  100 ns = min(nn,nbt1)
      ncts = 0
      ndrsts = 0
c
      do nc = 1,nct
        cess(nc,ns) = 0.
        cessi(nc) = 0.
      enddo
c
      do nse = 1,nbt1
        cdrs(nse,ns) = 0.
        cdrsi(nse) = 0.
      enddo
      cdrs(nbt + 2,ns) = 0.
c
      call initcv(uessi,nct,' ')
      call initcv(udrsi,nbt1,' ')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the first line of the block.
c
  110 continue
      read (ndat0s,1000,end=990,err=995) uline
      ux24 = uline(1:24)
      ux8 = ux24(1:8)
c
      if (ux8(1:8).eq.uaux(1:8) .or. ux8(1:8).eq.uaqu(1:8)) then
c
c       Skip the terminator line, read the next line.
c
        read (ndat0s,1000,end=990,err=995) uline
        go to 110
c
      elseif (ux8(1:8) .eq. usol(1:8)) then
c
c       Skip the terminator line.
c
        read (ndat0s,1000,end=990,err=995) uline
c
c       Finish and exit here.
c
        if (uspn(1)(1:24) .eq. unone(1:24)) then
          nnx = 0
          nn = 0
          write (nttyo,1140) nnx,unone(1:4)
          write (nslist,1140) nnx,unone(1:4)
 1140     format(1x,i5,2x,a)
          write (noutpt,1150) nn,unone(1:4)
 1150     format(1x,i5,1x,a)
        else
          nxm = nspnx - 1
          if (nxm .ge. 1) then
            nnx = nnx + 2
            if (nxm .eq. 1) then
              j3 = ilnobl(uspn(1))
              write (nttyo,1140) nnx,uspn(1)(1:j3)
              write (nslist,1140) nnx,uspn(1)(1:j3)
            else
              j3 = ilnobl(uspn(2))
              write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
              write (nslist,1160) nnx,uspn(1),uspn(2)(1:j3)
 1160         format(1x,i5,2x,a24,2x,a)
            endif
          elseif (nmodx .ne. 1) then
            j3 = ilnobl(uspn(2))
            write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
          endif
        endif
        write (ndata1) uend24,ublk24,ublk24
        j3 = ilnobl(uend24)
        write (ndat1f,1010) uend24(1:j3)
        write (ndat1f,1010) utermc(1:72)
        if (nerr .gt. 0) stop
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Have a species block.
c
      nat = nat + 1
c
      j2 = ilnobl(ux24)
      if (j2 .le. 0) then
        write (ux8a,'(i5)') nat
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        j4 = ilnobl(usblkf)
        write (noutpt,1240) ux8a(1:j3),usblkf(1:j4)
        write (nttyo,1240) ux8a(1:j3),usblkf(1:j4)
 1240   format(/' * Error - (EQPT/pcraq) Have encountered a blank',
     $  ' species name',/7x,'for species block ',a,' of the ',a,
     $  ' superblock.')
        if (nat .gt. 1) then
          ux24 = uaqsp(nat - 1)
          j5 = ilnobl(ux24)
          if (j5 .gt. 0) then
            write (noutpt,1250) ux24(1:j5)
            write (nttyo,1250) ux24(1:j5)
 1250       format(7x,'This block follows the one for ',a,'.')
          endif
        endif
        ux24 = '<blank>'
        nerr = nerr + 1
      endif
c
      uaqsp(nat) = ux24
      uspec(ns) = ux24
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the species name for screen and SLIST output.
c
      uspn(nspnx) = uspec(ns)
c
c     Write the species name on the OUTPUT file.
c
      j2 = ilnobl(uspec(ns))
      write (noutpt,1150) nn,uspec(ns)(1:j2)
c
c     Write species names two per line on the SLIST file.
c
      nspnx = nspnx + 1
      if (nspnx .gt. 2) then
        nspnx = 1
        nnx = nnx + 2
        nmodx = mod(nnx,nmodwr)
        if (nmodwr .eq. 1) nmodx = 1
        j3 = ilnobl(uspn(2))
        if (nmodx .eq. 1) write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
        write (nslist,1160) nnx,uspn(1),uspn(2)(1:j3)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip the obsolete 'sp.type =' and 'revised =' lines.
c     Read the electrical charge.
c
  130 read (ndat0s,1000,end=990,err=995) uline
      ii = index(uline,'charge')
      if (ii .eq. 0) go to 130
c
      ux80 = uline(ii + 6:80)
      ii = index(ux80,'=')
      ux16 = ux80(ii + 1:80)
      call lejust(ux16)
      read (ux16,'(f5.1)',err=995) zx
c1280 format(14x,f5.1)
      zaqsp(nat) = zx
      zchar(ns) = zx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the number of chemical elements composing the species.
c
      read (ndat0s,1000,end=990,err=995) uline
      ux80 = uline
      call lejust(ux80)
      ii = index(ux80,'element(s)')
      if (ii .gt. 1) then
        ux16 = ux80(1:ii - 1)
        read (ux16,'(i5)',err=995) ncts
c1330   format(4x,i2)
      else
        ii = index(ux80,' ')
        if (ii .gt. 1) then
          ux16 = ux80(1:ii - 1)
          read (ux16,'(i5)',err=995) ncts
        else
          ncts = 0
        endif
      endif
c
      if (ncts .gt. nct) then
        j2 = ilnobl(uspec(ns))
        write (ux8a,'(i5)') ncts
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        write (ux8c,'(i5)') nct
        call lejust(ux8c)
        j5 = ilnobl(ux8c)
        write (noutpt,1350) uspec(ns)(1:j2),ux8a(1:j3),ux8c(1:j5)
        write (nttyo,1350) uspec(ns)(1:j2),ux8a(1:j3),ux8c(1:j5)
 1350   format(/' * Error - (EQPT/pcraq) Species "',a,'" is',
     $  ' composed of ',a,/7x,'chemical elements, but there',
     $  ' are only ',a,' elements on the data file.')
        nerr = nerr + 1
      endif
c
      if (ncts .le. 0) then
        if (uspec(ns)(1:3).ne.'e- ' .and. uspec(ns)(1:3).ne.'E- ') then
          j2 = ilnobl(uspec(ns))
          write (noutpt,1360) uspec(ns)(1:j2)
          write (nttyo,1360) uspec(ns)(1:j2)
 1360     format(/' * Error - (EQPT/pcraq) Species "',a,'" is not',
     $    ' composed of',/7x,'any chemical elements.')
          nerr = nerr + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the names of the elements and the corresponding
c     compositional coefficients.
c
      n = 0
      do i = 1,ncts/3
        read (ndat0s,1000,end=990,err=995) uline
        ulbufa = uline
        do k = 1,3
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            read (ux16,'(f8.4)',err=995) cessi(n + k)
          else
            cessi(n + k) = 0.
          endif
          ulbufb = ulbufa(ii + 1:80)
          call lejust(ulbufb)
          uessi(n + k) = ulbufb(1:8)
          if (k .lt. 3) ulbufa = ulbufb(9:80)
        enddo
c       read (uline,1370,err=995) (cessi(n + k),uessi(n + k), k = 1,3)
c1370   format((4x,3(f8.4,1x,a8,5x)))
        n = n + 3
      enddo
c
      j = mod(ncts,3)
      if (j .gt. 0) then
        read (ndat0s,1000,end=990,err=995) uline
        ulbufa = uline
        do k = 1,j
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            read (ux16,'(f8.4)',err=995) cessi(n + k)
          else
            cessi(n + k) = 0.
          endif
          ulbufb = ulbufa(ii + 1:80)
          call lejust(ulbufb)
          uessi(n + k) = ulbufb(1:8)
          if (k .lt. j) ulbufa = ulbufb(9:80)
        enddo
c       read (uline,1370,err=995) (cessi(n + k),uessi(n + k), k = 1,j)
        n = n + j
      endif
c
c     Check for blank element names, duplicate element names, and
c     zero-valued stoichiometric coefficients.
c
      call elesck(cessi,nbtmx1,nctmax,ncts,nentei,nerr,noutpt,
     $ ns,nttyo,qblkes,qzeres,uessi,usblkf,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ns .eq. nbw) then
c
c       Make sure that H2O is the first aqueous species.
c
        if (uspec(nbw)(1:4) .ne. 'H2O ') then
          j2 = ilnobl(uspec(nbw))
          write (noutpt,1420) uspec(nbw)(1:j2)
          write (nttyo,1420) uspec(nbw)(1:j2)
 1420     format(/' * Error - (EQPT/pcraq) The first strict basis',
     $    ' species on the data file',/7x,'is ',a,'. The first',
     $    ' strict basis species must be H2O.',/7x,'This is an',
     $    ' idiosyncrasy of EQ3/6.')
          nerr = nerr + 1
        endif
      endif
c
      if (ns .le. nsb) then
c
c       A strict basis species may be composed of only one chemical
c       element other than O or H.
c
        ncount = 0
        do i = 1,ncts
          if (cessi(i) .gt. 0.) then
            if (uessi(i)(1:2).ne.'O ' .and. uessi(i)(1:2).ne.'H ' .and.
     $      uessi(i)(1:7).ne.'<blank>') ncount = ncount + 1
          endif
        enddo
c
        if (ncount .gt. 1) then
          j2 = ilnobl(uspec(ns))
          write (noutpt,1430) uspec(ns)(1:j2)
          write (nttyo,1430) uspec(ns)(1:j2)
 1430     format(/' * Error - (EQPT/pcraq) The strict basis species ',
     $    a,' is composed',/7x,'of more than one chemical element',
     $    ' other than O and H.')
          nerr = nerr + 1
        endif
      endif
c
      if (ns .le. nct) then
c
c       Make sure that there is a 1:1 mapping to the chemical elements
c       for the first nct members of the strict basis set.
c
c       H2O (solvent water) is a special case. H2O always maps to O.
c       Since the first chemical element is required to be O, the first
c       aqueous species is required to  be H2O. Here it is sufficient
c       to make sure that that indeed is the case.
c
        if (ns .eq. 1) then
          if (uspec(ns)(1:4) .ne. 'H2O ') then
            j2 = ilnobl(uspec(ns))
            write (noutpt,1440) uspec(ns)(1:j2)
            write (nttyo,1440) uspec(ns)(1:j2)
 1440       format(/' * Error - (EQPT/pcraq) The first aqueous species',
     $      ' is ',a,'.',/7x,'The first aqueous species must be H2O.')
            nerr = nerr + 1
          endif
        endif
c
c       The hydrogen ion is also a special case. H+ always maps to H.
c
        if (uspec(ns)(1:3) .eq. 'H+ ') then
          nc = ns
          if (uelem(nc)(1:2) .ne. 'H ') then
            j2 = ilnobl(uspec(ns))
            write (noutpt,1450)
            write (nttyo,1450)
 1450       format(/' * Error - (EQPT/pcraq) The species H+ is',
     $      ' required to match',/7x,'the chemical element H. If the',
     $      ' species is the n-th member of',/7x,'the strict',
     $      ' basis set, the corresponding chemical element must be',
     $      /7x,'the n-th chemical element (there is one exception',
     $      ' to this rule,',/7x,"the redox species, which doesn't",
     $      ' correspond to any chemical element).')
            nerr = nerr + 1
          endif
        endif
c
c       Any strict basis species, other than the redox species,
c       must be composed of the chemical element to which it
c       formally corresponds.
c
        nc = ns
        do i = 1,ncts
          if (uessi(i)(1:8) .eq. uelem(nc)(1:8)) then
            if (cessi(i) .gt. 0.) go to 120
          endif
        enddo
c
        j2 = ilnobl(uspec(ns))
        j3 = ilnobl(uelem(nc))
        write (noutpt,1460) uspec(ns)(1:j2),uelem(nc)(1:j3)
        write (nttyo,1460) uspec(ns)(1:j2),uelem(nc)(1:j3)
 1460   format(/' * Error - (EQPT/pcraq) The strict basis',
     $  ' species ',a,' is not',/7x,'composed of the chemical',
     $  ' element ',a,' to which it must correspond.',
     $  /7x,'If the species is the n-th member of the strict',
     $  ' basis set,',/7x,'the, corresponding chemical',
     $  ' element must be the n-th chemical element.',
     $  /7x,'There is one exception to this rule, the',
     $  ' redox species. It must be',/7x,'the last strict',
     $  " basis species, if present. It doesn't correspond",
     $  /7x,'to any chemical element.')
        nerr = nerr + 1
  120   continue
      endif
c
c     Check out the redox species.
c
      if (ns .eq. nsb) then
        if (uspec(ns)(1:6).ne.'O2(g) ' .and.
     $    uspec(ns)(1:3).ne.'e- ' .and.
     $    uspec(ns)(1:3).ne.'E- ') then
          j2 = ilnobl(uspec(ns))
          write (noutpt,1470) uspec(ns)(1:j2)
          write (nttyo,1470) uspec(ns)(1:j2)
 1470     format(/' * Error - (EQPT/pcraq) The redox species is ',a,
     $    '. This must',/7x,'be either O2(g) or e-.')
          nerr = nerr + 1
        endif
      endif
c
      if (ns .eq. nsb) then
        if (nerr .gt. 0) stop
      endif
c
      if (ns .eq. nbt) then
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ns .gt. nsb) then
c
c       Read number of species in the associated reaction.
c
        read (ndat0s,1000,end=990,err=995) uline
        ux80 = uline
        call lejust(ux80)
        ii = index(ux80,'species')
        if (ii .gt. 1) then
          ux16 = ux80(1:ii - 1)
          read (ux16,'(i5)',err=995) ndrsts
c1500   format(4x,i2)
        else
          ii = index(ux80,' ')
          if (ii .gt. 1) then
            ux16 = ux80(1:ii - 1)
            read (ux16,'(i5)',err=995) ndrsts
          else
            ndrsts = 0
          endif
        endif
c
        if (ndrsts .gt. nbt1) then
          j2 = ilnobl(uspec(ns))
          write (ux8a,'(i5)') ndrsts
          call lejust(ux8a)
          j3 = ilnobl(ux8a)
          write (ux8b,'(i5)') nbt
          call lejust(ux8b)
          j4 = ilnobl(ux8b)
          write (ux8c,'(i5)') nbt1
          call lejust(ux8c)
          j5 = ilnobl(ux8c)
          write (noutpt,1520) uspec(ns)(1:j2),ux8a(1:j3),ux8b(1:j4),
     $    ux8c(1:j5)
          write (nttyo,1520) uspec(ns)(1:j2),ux8a(1:j3),ux8b(1:j4),
     $    ux8c(1:j5)
 1520     format(/' * Error - (EQPT/pcraq) The reaction for the',
     $    /7x,'destruction of species "',a,'" includes ',a,
     $    /7x,'species, but there are only ',a,' basis species on the',
     $    /7x,'data file, so only ',a,' species may appear in the ',
     $    'reaction.')
          nerr = nerr + 1
        endif
c
        if (ndrsts .lt. 2) then
          j2 = ilnobl(uspec(ns))
          j4 = ilnobl(usblkf)
          write (noutpt,1530) uspec(ns)(1:j2),usblkf(1:j4)
          write (nttyo,1530) uspec(ns)(1:j2),usblkf(1:j4)
 1530     format(/' * Error - (EQPT/pcraq) The species ',a,
     $    ' appearing',/7x,'on the data file in the ',a,' superblock',
     $    ' has fewer than',/7x,'two species in its associated',
     $    ' reaction. This is not a',/7x,'valid reaction.')
          nerr = nerr + 1
        endif
c
c       Read the names of the species in the reaction and the
c       corresponding reaction coefficients.
c
        n = 0
        do i = 1,ndrsts/2
          read (ndat0s,1000,end=990,err=995) uline
          ulbufa = uline
          do k = 1,2
            call lejust(ulbufa)
            ii = index(ulbufa,' ')
            if (ii .gt. 1) then
              ux16 = ulbufa(1:ii - 1)
              read (ux16,'(f10.4)',err=995) cdrsi(n + k)
            else
              cdrsi(n + k) = 0.
            endif
            ulbufb = ulbufa(ii + 1:80)
            call lejust(ulbufb)
            udrsi(n + k) = ulbufb(1:24)
            if (k .lt. 2) ulbufa = ulbufb(25:80)
          enddo
c         read (uline,1540,err=995) (cdrsi(n + k),udrsi(n + k), k = 1,2)
c1540     format((2(1x,f10.4,2x,a24)))
          n = n + 2
        enddo
c
        j = mod(ndrsts,2)
        if (j .gt. 0) then
          read (ndat0s,1000,end=990,err=995) uline
          ulbufa = uline
          do k = 1,j
            call lejust(ulbufa)
            ii = index(ulbufa,' ')
            if (ii .gt. 1) then
              ux16 = ulbufa(1:ii - 1)
              read (ux16,'(f10.4)',err=995) cdrsi(n + k)
            else
              cdrsi(n + k) = 0.
            endif
            ulbufb = ulbufa(ii + 1:80)
            call lejust(ulbufb)
            udrsi(n + k) = ulbufb(1:24)
            if (k .lt. j) ulbufa = ulbufb(25:80)
          enddo
c         read (uline,1540,err=995) (cdrsi(n + k),udrsi(n + k), k = 1,j)
          n = n + j
        endif
c
c       Check for blank species names, duplicate species names, and
c       zero-valued reaction coefficients. Check that the reaction
c       coefficient of the species with which the reaction is
c       associated has a negative value.
c
        call rxnsck(nbtmx1,cdrsi,nct,ndrsts,nentri,nerr,noutpt,
     $  ns,nsb,nttyo,qblkrs,qzerrs,udrsi,usblkf,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Read the log K grid for the current species.
c       Return the data in the xdbval holding array.
c
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xlks array.
c
c       Calling sequence substitutions:
c         ns for ipc
c         nbtmx1 for ipcmax
c         xlks for zdbval
c
        call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $  ntprmx,ntprt,xdbval,xlks)
c
        if (itgenf .ge. 0) then
c
c         Test the grid ranges for sparseness of actual data.
c
          ustrgr = 'the log K for ' // uspec(ns)
          call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $    ntprt,nttyo,nwarn,ustrgr)
        endif
      endif
c
c     In the case of a strict basis species (a species which has no
c     real associated reaction), xhfs is the partial molar enthalpy
c     of formation and xvfs is the partial molar volume. In the case
c     of all other species, there is a real associated reaction and
c     xhfs is then the partial molar enthalpy of reaction and xvfs
c     is the partial molar volume of reaction.
c
      if (ipch .ge. 0) then
c
c       Read the enthalpy function grid for the current species.
c       Return the data in the xdbval holding array.
c
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xhfs array.
c
c       Calling sequence substitutions:
c         ns for ipc
c         nbtmx1 for ipcmax
c         xhfs for zdbval
c
        call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $  ntprmx,ntprt,xdbval,xhfs)
c
        if (itgenf .ge. 0) then
c
c         Test the grid ranges for sparseness of actual data.
c
          ustrgr = 'the enthalpy function for ' // uspec(ns)
          call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $    ntprt,nttyo,nwarn,ustrgr)
        endif
c
        do ipc = 1,ipch
c
c         Read the enthalpy function derivative grid for the current
c         species. Return the data in the xdbval holding array.
c
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the dhfs array.
c
c         Calling sequence substitutions:
c           ipchmx for ipcmax
c           dhfs for zdbval
c
          call ldbar4(ipc,ipchmx,nacdpr,narxmx,narxt,nbtmx1,
     $    ndbmax,ns,ntprmx,ntprt,xdbval,dhfs)
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Read the volume function grid for the current species.
c       Return the data in the xdbval holding array.
c
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xvfs array.
c
c       Calling sequence substitutions:
c         ns for ipc
c         nbtmx1 for ipcmax
c         xvfs for zdbval
c
        call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $  ntprmx,ntprt,xdbval,xvfs)
c
        if (itgenf .ge. 0) then
c
c         Test the grid ranges for sparseness of actual data.
c
          ustrgr = 'the volume function for ' // uspec(ns)
          call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $    ntprt,nttyo,nwarn,ustrgr)
        endif
c
        do ipc = 1,ipcv
c
c         Read the volume function derivative grid for the current
c         species. Return the data in the xdbval holding array.
c
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the dvfs array.
c
c         Calling sequence substitutions:
c           ipcvmx for ipcmax
c           dvfs for zdbval
c
          call ldbar4(ipc,ipcvmx,nacdpr,narxmx,narxt,nbtmx1,
     $    ndbmax,ns,ntprmx,ntprt,xdbval,dvfs)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the redox species in the strict basis set. Set the
c     appropriate flags.
c
      if (ns .eq. nsb) then
        qelect = uspec(ns)(1:3).eq.'e- '
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If the strict basis redox species is e-, change it to O2(g).
c
      if (ns .eq. nsb) then
        if (qelect) then
          uspec(ns) = 'O2(g)'
          ncts = 1
          uessi(1) = 'O'
          cessi(1) = 2
          zchar(ns) = 0.
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If the reaction is written in terms of e-, rewrite it in terms
c     of O2(g).
c
      if (qelect) then
        if (ns .gt. nsb) then
          call etoo2(cdrsi,dhfe,dhfs,dvfe,dvfs,ipch,ipchmx,ipcv,
     $    ipcvmx,narxmx,narxt,nbtmx1,ndrsts,ns,ntprmx,ntprt,udrsi,
     $    xhfe,xhfs,xlke,xlks,xvfe,xvfs)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the species data.
c
      mwtss = 0.
      qnofes = .false.
      do n = 1,ncts
c
c       Search for element name in the uelem array.
c
        ux8 = uessi(n)(1:8)
        if (ux8(1:7) .ne. '<blank>') then
c
          do nc = 1,nct
            if (ux8(1:8) .eq. uelem(nc)(1:8)) then
              cess(nc,ns) = cess(nc,ns) + cessi(n)
              mwtss = mwtss + atwt(nc)*cessi(n)
              go to 220
            endif
          enddo
c
c         Error, not found.
c
          if (ns .gt. nsb) then
            j2 = ilnobl(uspec(ns))
            j3 = ilnobl(ux8)
            write (noutpt,1760) ux8(1:j3),uspec(ns)(1:j2)
            write (nttyo,1760) ux8(1:j3),uspec(ns)(1:j2)
 1760       format(/' * Error - (EQPT/pcraq) Unrecognized chemical',
     $      ' element "',a,'" is listed',/7x,'in the composition of',
     $      ' the species ',a,'.')
            nerr = nerr + 1
            qnofes = .true.
          endif
        endif
  220   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndata1) uspec(ns),ncts,ndrsts
      write (ndat1f,1800) uspec(ns),ncts,ndrsts
 1800 format(a24,2x,2i5)
c
      write (ndata1) mwtss,zchar(ns)
      write (ndat1f,1810) mwtss,zchar(ns)
 1810 format(5x,f10.3,f5.0)
c
      if (ncts .gt. 0) then
        write (ndata1) (cessi(n),uessi(n), n = 1,ncts)
        n = 1
  230   continue
        if (n .eq. ncts) then
          j4 = ilnobl(uessi(n))
          write (ndat1f,1820) cessi(n),uessi(n)(1:j4)
 1820     format(1x,f10.4,2x,a)
          n = n + 1
        else
          j4 = ilnobl(uessi(n + 1))
          write (ndat1f,1830) cessi(n),uessi(n),
     $    cessi(n + 1),uessi(n + 1)(1:j4)
 1830     format(1x,f10.4,2x,a8,1x,f10.4,2x,a)
          n = n + 2
        endif
        if (n .le. ncts) go to 230
      endif
c
      if (ns .le. nsb) go to 270
c
      write (ndata1) (cdrsi(n),udrsi(n), n = 1,ndrsts)
      n = 1
c
  240 continue
      if (n .eq. ndrsts) then
        j4 = ilnobl(udrsi(n))
        write (ndat1f,1860) cdrsi(n),udrsi(n)(1:j4)
 1860   format(1x,f10.4,2x,a)
        n = n + 1
      else
        j4 = ilnobl(udrsi(n + 1))
        write (ndat1f,1870) cdrsi(n),udrsi(n),
     $  cdrsi(n + 1),udrsi(n + 1)(1:j4)
 1870   format(1x,f10.4,2x,a24,1x,f10.4,2x,a)
        n = n + 2
      endif
      if (n .le. ndrsts) go to 240
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qnofrs = .false.
      cdrs(nbt1,ns) = cdrsi(1)
      do n = 2,ndrsts
c
c       Search for species name in the uspec array.
c
        ux24 = udrsi(n)
        if (ux24(1:7) .ne. '<blank>') then
c
          do nse = 1,nbt
            if (ux24 .eq. uspec(nse)) then
              cdrs(nse,ns) = cdrs(nse,ns) + cdrsi(n)
              go to 250
            endif
          enddo
c
c         Error, not found.
c
          j2 = ilnobl(uspec(ns))
          j3 = ilnobl(ux24)
          write (noutpt,1880) uspec(ns)(1:j2),ux24(1:j3)
          write (nttyo,1880) uspec(ns)(1:j2),ux24(1:j3)
 1880     format(/' * Error - (EQPT/pcraq) The reaction which destroys',
     $    /7x,'non-basis species ',a,' is written in terms of an',
     $     /7x,'unrecognized basis species "',a,'".')
          nerr = nerr + 1
          qnofrs = .true.
  250     continue
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the reaction for mass and charge balance.
c     Skip if there are already obvious problems.
c
      if (ndrsts .ge. 2) then
        if (.not.qblkes .and. .not.qnofes) then
          if (.not.qblkrs .and. .not.qnofrs) then
            call rxnchk(cdrs,cess,mtotr,nbt,nbtmx1,nbtmx2,nco,
     $      nct,nctmax,nerr,noutpt,ns,nsb,nttyo,uelem,uspec,zchar)
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Fit interpolating polynomials to the log K grid.
c
      do ntpr = 1,ntprt
        do n = 1,narxt(ntpr)
          avgrid(n,ntpr) = xlks(n,ntpr,ns)
        enddo
      enddo
c
      call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $ narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $ xvec,yvec)
c
      ux24 = 'Log K'
      j2 = ilnobl(ux24)
      write (ndata1) ux24
      write (ndat1f,1010) ux24(1:j2)
c
      do ntpr = 1,ntprt
        nt = narxt(ntpr)
        write (ndata1) (apr(i,ntpr), i = 1,nt)
        write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
 1890   format( 5(1pe16.9) )
      enddo
c
  270 continue
c
      if (ipch .ge. 0) then
c
c       Fit interpolating polynomials to the enthalpy function grid.
c
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            avgrid(n,ntpr) = xhfs(n,ntpr,ns)
          enddo
        enddo
c
        call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'Enthalpy'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
        enddo
c
c       Fit interpolating polynomials to the grids for its
c       pressure derivatives.
c
        do ipc = 1,ipch
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dhfs(n,ntpr,ipc,ns)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dhfs( )'
          write (ux24(6:6),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
          enddo
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Fit interpolating polynomials to the volume function grid.
c
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            avgrid(n,ntpr) = xvfs(n,ntpr,ns)
          enddo
        enddo
c
        call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'Volume'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
        enddo
c
c       Fit interpolating polynomials to the grids for its
c       pressure derivatives.
c
        do ipc = 1,ipcv
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dvfs(n,ntpr,ipc,ns)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dvfs( )'
          write (ux24(6:6),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
          enddo
        enddo
      endif
c
      write (ndat1f,1010) utermc(1:72)
c
c     Look for another species block or terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
      nn = nn + 1
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/pcraq) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
c
      write (noutpt,2010) nn
      write (nttyo,2010) nn
 2010 format(7x,'The value of the species block counter is ',i3,'.')
      if (ns .gt. 0) then
        j2 = ilnobl(uspec(ns))
        if (j2 .gt. 0) then
          write (noutpt,2020) uspec(ns)(1:j2)
          write (nttyo,2020) uspec(ns)(1:j2)
 2020     format(7x,'The last species name read was "',a,'".')
        else
          nsm1 = ns - 1
          if ((nsm1) .gt. 0) then
            j2 = ilnobl(uspec(nsm1))
            if (j2 .gt. 0) then
              write (noutpt,2020) uspec(nsm1)(1:j2)
              write (nttyo,2020) uspec(nsm1)(1:j2)
            endif
          endif
        endif
      endif
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
 2030   format(7x,'The last line read was the following:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 write (noutpt,2040)
      write (nttyo,2040)
 2040 format(/' * Error - (EQPT/pcraq) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
c
      write (noutpt,2010) nn
      write (nttyo,2010) nn
      if (ns .gt. 0) then
        j2 = ilnobl(uspec(ns))
        if (j2 .gt. 0) then
          write (noutpt,2020) uspec(ns)(1:j2)
          write (nttyo,2020) uspec(ns)(1:j2)
        else
          nsm1 = ns - 1
          if ((nsm1) .gt. 0) then
            j2 = ilnobl(uspec(nsm1))
            if (j2 .gt. 0) then
              write (noutpt,2020) uspec(nsm1)(1:j2)
              write (nttyo,2020) uspec(nsm1)(1:j2)
            endif
          endif
        endif
      endif
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,67)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine sfncge(delxi,xval0,xtargv,dxval0,nord,nrd1mx,resx)
c
c     This subroutine computes a general search function for
c     EQ6/search.f. This search function is a residual defined as the
c     difference between the calculated value of a function (xvalc)
c     described by a truncated Taylor's series and a target value
c     (xtargv).
c
c     This subroutine is called by:
c
c       EQ6/search.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = step size
c       xtargv = target value
c       xval0  = the function value at delxi = 0
c       dxval0 = the derivatives of this function at delxi = 0
c       nord   = the order of the truncated Taylor's series
c
c     Principal output:
c
c       resx   = value of residual function
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrd1mx
c
      integer nord
c
      real*8 dxval0(nrd1mx)
c
      real*8 delxi,resx,xtargv,xval0
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n
c
      real*8 dxp,xvalc
c
c-----------------------------------------------------------------------
c
      xvalc = xval0
      if (nord .gt. 0) then
        dxp = 1.
        do n = 1,nord
          dxp = dxp*delxi
          xvalc = xvalc + ( dxval0(n)/fctrl(n) )*dxp
        enddo
      endif
      resx = xvalc - xtargv
c
      end

      subroutine wrentu(actw,eh,fo2lg,iopg,iopt,kstep,nopgmx,noptmx,
     $ nttyo,ph,qredox,time1,xi1)
c
c     This subroutine writes entertainment for the user while the
c     run is underway. This output gives an idea of how the
c     calculation is progressing. In that respect, it is somewhat
c     like a progress bar.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nopgmx,noptmx
c
      integer nttyo
c
      integer iopg(nopgmx),iopt(noptmx)
c
      integer kstep
c
      logical qredox
c
      real*8 actw,eh,fo2lg,ph,time1,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      if (iopt(2) .le. 0) then
        if (qredox) then
          if (iopg(1) .gt. 0) then
            write (nttyo,1000) kstep,xi1,ph,actw,fo2lg
 1000       format(3x,'step=',i5,', Xi=',1pe10.3,', pH=',0pf7.3,
     $      ', aw=',f6.3,', log fO2= ',f7.3)
          else
            write (nttyo,1010) kstep,xi1,ph,fo2lg
 1010       format(3x,'step=',i5,', Xi=',1pe10.3,', pH=',0pf7.3,
     $      ', log fO2= ',f7.3)
          endif
        else
          if (iopg(1) .gt. 0) then
            write (nttyo,1020) kstep,xi1,ph,actw
 1020       format(3x,'step=',i5,', Xi=',1pe10.3,', pH=',0pf7.3,
     $      ', aw=',f6.3)
          else
            write (nttyo,1030) kstep,xi1,ph
 1030       format(3x,'step=',i5,', Xi=',1pe10.3,', pH=',0pf7.3)
          endif
        endif
      else
        if (qredox) then
          if (iopg(1) .gt. 0) then
            write (nttyo,1100) kstep,time1,ph,actw,fo2lg
 1100       format(3x,'step=',i5,', time=',1pe10.3,' s, pH=',
     $      0pf7.3,', aw=',f6.3,', log fO2= ',f7.3)
          else
            write (nttyo,1110) kstep,time1,ph,fo2lg
 1110       format(3x,'step=',i5,', time=',1pe10.3,' s, pH=',
     $      0pf7.3,', log fO2= ',f7.3)
          endif
        else
          if (iopg(1) .gt. 0) then
            write (nttyo,1120) kstep,time1,ph,actw
 1120       format(3x,'step=',i5,', time=',1pe10.3,' s, pH=',
     $      0pf7.3,', aw=',f6.3)
          else
            write (nttyo,1130) kstep,time1,ph
 1130       format(3x,'step=',i5,', time=',1pe10.3,' s, pH=',
     $      0pf7.3)
          endif
        endif
      endif
c
      end

      subroutine wrtabc(acflg,actlg,actw,afrc1,aft1,alk,conclg,
     $ cteaq,ctb,dvoso,dwoso,eh,fje,fo2lg,fugac,fxi,iktmax,iopt,
     $ jflag,jsflag,kmax,kstep,kx1,kxt,mrmlra,modr,mosp,mospt,
     $ moph,mopht,narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ncmpr,nct,
     $ nctmax,nelect,ngrn1,ngrn2,ngtmax,nhydr,nhydx,nllnmx,
     $ no2gaq,noptmx,noutpt,npt,nptmax,nrct,nrctmx,nstmax,ntabx,
     $ ntidmx,ntitl2,ntitld,ntitmx,nttyo,nxrn1,nxrn2,nxtmax,pe,ph,
     $ phmes,ppmwb,ppmwe,prcinf,press,prminf,qrho,qriinf,rho,rhowc,
     $ sidrph,sigmam,tdsgks,tdsglw,tempc,time1,uelem,ulinex,
     $ uphase,uplatm,ureac,uspec,usteq6,utitl2,utitld,uveeq6,
     $ vodrt,vosoct,wkgh2o,wodrt,wosoct,xbar,xbarlg,xi1)
c
c     This subroutine writes to TABX (the scrambled TAB file) using
c     a csv (comma separated value) format. A .csv file can be opened
c     by spreadsheets and other software that support data analysis
c     and plotting.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,kmax,nbtmax,nctmax,ngtmax,nllnmx,noptmx,nptmax,
     $ nrctmx,nstmax,ntidmx,ntitmx,nxtmax
c
      integer noutpt,ntabx,nttyo
c
      integer iopt(noptmx),jflag(nstmax),jsflag(nstmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),ncmpr(2,nptmax)
c
      integer kstep,kx1,kxt,narn1,narn2,nbt,nct,nelect,ngrn1,ngrn2,
     $ nhydr,nhydx,no2gaq,npt,nrct,ntitl2,ntitld,nxrn1,nxrn2
c
      logical qrho,qriinf
c
      character(len=nllnmx) ulinex
      character(len=80) utitl2(ntitmx),utitld(ntidmx)
      character(len=48) uspec(nstmax)
      character(len=24) uphase(nptmax),ureac(nrctmx)
      character(len=8) uelem(nctmax)
      character(len=8) uplatm,usteq6,uveeq6
c
      real(8) acflg(nstmax),actlg(nstmax),afrc1(nrctmx),
     $ conclg(nstmax),ctb(nbtmax),cteaq(nctmax),fugac(ngtmax),
     $ modr(nrctmx),moph(nptmax),mopht(nptmax),mosp(nstmax),
     $ mospt(nstmax),ppmwb(nbtmax),ppmwe(nctmax),sidrph(nptmax),
     $ xbar(nstmax),xbarlg(nstmax)
c
      real(8) actw,aft1,alk,dvoso,dwoso,eh,fje,fo2lg,fxi,mrmlra,
     $ pe,ph,phmes,prcinf,press,prminf,rho,rhowc,sigmam,tdsgks,
     $ tdsglw,tempc,time1,vodrt,vosoct,wkgh2o,wodrt,wosoct,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with variable global dimensioning.
c
      integer ngfmax,npmmax,npsmax,nxcmax
c
      SAVE ngfmax,npmmax,npsmax,nxcmax
c
      integer, dimension(:), allocatable :: ngasfx
c
      SAVE ngasfx
c
      character(len=24), dimension(:,:), allocatable :: ussphx
      character(len=24), dimension(:), allocatable :: ubaspx,
     $ ubasqx,usidrx,uphasx
      character(len=8), dimension(:), allocatable :: uelacx
c
      SAVE ubaspx,ubasqx,uelacx,uphasx,usidrx,ussphx
c
      real(8), dimension(:), allocatable :: acflbx,actlbx,afrcx,
     $ conlbx,ctbaqx,cteaqx,molrbx,molrex,mophx,ppmvbx,ppmvex,ppmwbx,
     $ ppmwex,sidrx,xfrac
c
      SAVE acflbx,actlbx,afrcx,conlbx,ctbaqx,cteaqx,molrbx,molrex,
     $ mophx,ppmvbx,ppmvex,ppmwbx,ppmwex,sidrx,xfrac
c
c-----------------------------------------------------------------------
c
c     Local variable declarations required to be saved between calls.
c
      integer ngft,npmt,npst,nxct
      integer nbtpr,nctpr,nqtpr
c
      SAVE ngft,npmt,npst,nxct
      SAVE nbtpr,nctpr,nqtpr
c
      integer ilstmx
c
      SAVE ilstmx
c
      logical qgftag,qpstag
c
      SAVE qgftag,qpstag
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,jj,j1,j2,j3,j4,jc,jlead,jline,jq,jsum,jt1,jt2,jt3,
     $ jthv1,jthv2,jthv3,jts,n,nb,nc,ng,ngt,nlim,np,nrc,nr1,nr2,ns,
     $ ns1,ns2
c
      integer ilnobl
c
      logical qnewph,qnewss,qpsext,qwrthd
c
      character(len=48) ux48
      character(len=16) ux16
      character(len=8) ux8,ux8a,ux8b,ultag1,ultag2,ultag3,ultags,
     $ ultgv1,ultgv2,ultgv3,unotav
c
      real(8) mx,sidrcv,tdays
c
      real(8) tlg
c
c-----------------------------------------------------------------------
c
      data unotav/'N/A'/
c
      data sidrcv/-10./
c
c-----------------------------------------------------------------------
c
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(uphasx)) then
c
c       Local work arrays are not allocated. Note that only one array
c       is tested to see if all are allocated or not.
c
        ilstmx = (nllnmx/25) - 3
c
        npsmax = min(ilstmx,nptmax)
c
        ngfmax = min(ilstmx,ngtmax)
c
        nxcmax = nxtmax*iktmax
        nxcmax = min(ilstmx,nxcmax)
c
        npmmax = 8*kmax
        npmmax = min(ilstmx,npmmax)
c
        npmt = 0
        npst = 0
        ngft = 0
        nxct = 0
c
        qgftag = .false.
        qpstag = .false.
c
        nctpr = 0
        nqtpr = 0
        nbtpr = 0
c
        ALLOCATE(uphasx(npmmax))
        ALLOCATE(mophx(npmmax))
c
        ALLOCATE(uelacx(nctmax))
        ALLOCATE(cteaqx(nctmax),ppmwex(nctmax))
c
        ALLOCATE(ubasqx(nbtmax))
        ALLOCATE(ctbaqx(nbtmax),ppmwbx(nbtmax))
c
        if (qrho) then
          ALLOCATE(molrex(nctmax),ppmvex(nctmax))
          ALLOCATE(molrbx(nbtmax),ppmvbx(nbtmax))
        endif
c
        ALLOCATE(ubaspx(nbtmax))
        ALLOCATE(acflbx(nbtmax),actlbx(nbtmax),conlbx(nbtmax))
c
        ALLOCATE(afrcx(nrctmx))
c
        ALLOCATE(usidrx(npsmax))
        ALLOCATE(sidrx(npsmax))
c
        ALLOCATE(ngasfx(ngfmax))
c
        ALLOCATE(ussphx(2,nxcmax))
        ALLOCATE(xfrac(nxcmax))
c
c       Zero the contents of the local work arrays.
c
        do n = 1,nctmax
          uelacx(n) = ' '
          cteaqx(n) = 0.
          ppmwex(n) = 0.
        enddo
c
        do n = 1,nbtmax
          ubasqx(n) = ' '
          ctbaqx(n) = 0.
          ppmwbx(n) = 0.
        enddo
c
        if (qrho) then
          do n = 1,nctmax
            molrex(n) = 0.
            ppmvex(n) = 0.
          enddo
          do n = 1,nbtmax
            molrbx(n) = 0.
            ppmvbx(n) = 0.
          enddo
        endif
c
        do n = 1,nbtmax
          ubaspx(n) = ' '
          acflbx(n) = 0.
          actlbx(n) = 0.
          conlbx(n) = 0.
        enddo
c
        do n = 1,nrctmx
          afrcx(n) = 0.
        enddo
c
        do n = 1,npmmax
          uphasx(n) = ' '
          mophx(n) = 0.
        enddo
c
        do n = 1,npsmax
          usidrx(n) = ' '
          sidrx(n) = 0.
        enddo
c
        do n = 1,ngfmax
          ngasfx(n) = 0
        enddo
c
        do n = 1,nxcmax
          ussphx(1,n) = ' '
          ussphx(2,n) = ' '
          xfrac(n) = 0.
        enddo
c
c       Construct the local element list.
c
        nctpr = 0
        do nc = 1,nct
          if (uelem(nc)(1:2).ne.'H ' .and. uelem(nc)(1:2) .ne. 'O ')
     $      then
            nctpr = nctpr + 1
            uelacx(nctpr) = uelem(nc)
          endif
        enddo
c
c       Construct the local solute basis species list.
c
        nqtpr = 0
        do nb = 1,nbt
          ns1 = nbaspd(nb)
          ns2 = nbasp(nb)
          if (ns1.ge.narn1 .and. ns1.le.narn2) then
            if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
              if (ns1.ne.narn1 .and. ns1.ne.nelect .and.
     $          ns1.ne.no2gaq) then
                nqtpr = nqtpr + 1
                ubasqx(nqtpr) = uspec(ns1)
              endif
            endif
          endif
        enddo
c
c       Construct the local complete basis species list.
c
        nbtpr = 0
        do nb = 1,nbt
          ns1 = nbaspd(nb)
          ns2 = nbasp(nb)
          if (ns1.ge.narn1 .and. ns1.le.narn2) then
            if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
              nbtpr = nbtpr + 1
              ubaspx(nbtpr) = uspec(ns1)
            endif
          endif
        enddo
c
c       Construct the local gas species index map list.
c
        ngft = 0
        do ns = ngrn1,ngrn2
          if (jsflag(ns) .lt. 2) then
            if (ngft .ge. ngfmax) then
c
c             Prepare to write a "More omitted" label
c
              qgftag = .true.
              go to 100
            endif
            ngft = ngft + 1
            ngasfx(ngft) = ns
          endif
        enddo
  100   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write output tables of some selected parameters. These are
c     identified by short strings, commonly letters or letters and
c     numbers. They are written on the TABX file in scrambled order
c     (i.e., the lines of any given tables are interspersed with those
c     of the other tables). Each line is marked at the beginning with
c     an id string marking the table to which it belongs. The lines
c     will later be descrambled so that all lines belonging to a given
c     table are contiguous.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table A:
c
c       Run title (first 15 lines max)
c       Code version identification
c       Data file title (first 10 lines max)
c
c     Note: the original primary title (utitl1) has already been rolled
c     over to the current secondary title (utitl2).
c
      qwrthd = .false.
      if (kstep.eq.0 .and. iopt(18).eq.0) then
c
        ultag1 = 'A       '
        jt1 = len_trim(ultag1)
        ultags = ultag1
        jts = jt1
c
c       Write the table header.
c
        write (ntabx,1000) ultag1(1:jt1)
 1000   format(a,',Table A,Title information (filtered),')
c
        qwrthd = .true.
c
        write (ntabx,'(a,",")') ultag1(1:jt1)
        j2 = ilnobl(uveeq6)
        j3 = ilnobl(usteq6)
        j4 = ilnobl(uplatm)
        write (ntabx,1020) ultag1(1:jt1),uveeq6(1:j2),usteq6(1:j3),
     $  uplatm(1:j4)
 1020   format(a,',Running EQ6 from EQ3/6-V',a,' (',a,') for ',a,',')
        write (ntabx,'(a,",---,")') ultag1(1:jt1)
        write (ntabx,'(a,",")') ultag1(1:jt1)
c
c       Write the table data.
c
        nlim = min(ntitl2,15)
        do n = 1,nlim
          jj = min(80,nllnmx)
          ulinex = utitl2(n)(1:jj)
          j1 = len_trim(ulinex)
c
c         Check for double quotes and commas.
c
          jq = index(ulinex,'"')
          jc = index(ulinex,',')
          jsum = jq + jc
          if (jsum .gt. 0) then
c
c           Replace any double quotes in the title text by
c           single quotes.
c
            if (jq .gt. 0) then
c
  110         ulinex(jq:jq) = "'"
              jq = index(ulinex,'"')
              if (jq .gt. 0) go to 110
c
            endif
c
c           Replace any commas in the title text by semicolons.
c
            jc = index(ulinex,',')
            if (jc .gt. 0) then
c
  120         ulinex(jc:jc) = ";"
              jc = index(ulinex,',')
              if (jc .gt. 0) go to 120
c
            endif
          endif
c
          write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        enddo
        write (ntabx,'(a,",---,")') ultag1(1:jt1)
        write (ntabx,'(a,",")') ultag1(1:jt1)
c
        nlim = min(ntitld,10)
        do n = 1,nlim
          jj = min(80,nllnmx)
          ulinex = utitld(n)(1:jj)
          j1 = len_trim(ulinex)
c
c         Check for double quotes and commas.
c
          jq = index(ulinex,'"')
          jc = index(ulinex,',')
          jsum = jq + jc
          if (jsum .gt. 0) then
c
c           Replace any double quotes in the title text by
c           single quotes.
c
            if (jq .gt. 0) then
c
  130         ulinex(jq:jq) = "'"
              jq = index(ulinex,'"')
              if (jq .gt. 0) go to 130
c
            endif
c
c           Replace any commas in the title text by semicolons.
c
            jc = index(ulinex,',')
            if (jc .gt. 0) then
c
  140         ulinex(jc:jc) = ";"
              jc = index(ulinex,',')
              if (jc .gt. 0) go to 140
c
            endif
          endif
c
          write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        enddo
        write (ntabx,'(a,",---,")') ultag1(1:jt1)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table B1:
c
c       Xi
c       t(days)
c       Temperature(C)
c       Pressure(bars)
c       pH
c       pmH
c       log fO2
c       Eh(v)
c       pe
c       Activity of water
c
c     Prepare the data.
c
      if (.not.qriinf) then
        tdays = time1/86400.
      endif
c
      if (eh .le. -99999.) eh = -99999.
      if (pe .le. -99999.) pe = -99999.
      if (aft1 .ge. 99999.) aft1 = 99999.
c
      ultag1 = 'B1      '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1040) ultag1(1:jt1)
 1040   format(a,',Table B1,Miscellaneous parameters I,')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days),Temp(C),Press(bars),pH,pmH,'
        j1 = len_trim(ulinex)
        ux48 = 'log fO2,Eh(v),pe,aw'
        j2 = len_trim(ux48)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux48(1:j2)
        j1 = jsum
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') tempc
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') press
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') ph
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') phmes
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') fo2lg
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') eh
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') pe
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') actw
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table B2:
c
c       Xi
c       t(days)
c       Mass of solvent H2O, kg
c       Alkalinity(eq/kg H2O)
c       Sigma m
c       Ionic strength
c       Ionic asymmetry
c       TDS, g/kg.sol
c       TDS, g/L
c       Aqueous solution density, g/L
c       Molarity/molality ratio
c
c     Prepare the data. None to prepare.
c
      ultag1 = 'B2      '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1060) ultag1(1:jt1)
 1060   format(a,',Table B2,Miscellaneous parameters II,')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days),H2O(kg),Alk(eq/kg.H2O),Signam(m),I(m),'
        j1 = len_trim(ulinex)
        ux48 = 'J(m),TDS(g/kg.sol),TDS(g/L),density(g/L),M/m'
        j2 = len_trim(ux48)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux48(1:j2)
        j1 = jsum
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') wkgh2o
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') alk
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') sigmam
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') fxi
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') fje
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') tdsgks
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') tdsglw
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') rhowc
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') mrmlra
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table C1:
c
c       Xi
c       t(days)
c       Molalities of dissolved elements
c
c     and Table C2:
c
c       Xi
c       t(days)
c       ppm (mg/kg.sol) of dissolved elements
c
c     Prepare the data.
c
      nctpr = 0
      do nc = 1,nct
        if (uelem(nc)(1:2).ne.'H ' .and. uelem(nc)(1:2) .ne. 'O ') then
          nctpr = nctpr + 1
          uelacx(nctpr) = uelem(nc)
          cteaqx(nctpr) = cteaq(nc)
          ppmwex(nctpr) = ppmwe(nc)
        endif
      enddo
c
      ultag1 = 'C1      '
      ultag2 = 'C2      '
      jt1 = len_trim(ultag1)
      jt2 = len_trim(ultag2)
c
      if (qwrthd) then
c
c       Write an end marker for the table previous to C1.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write an end marker for the table previous to C2.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag2(1:jt2),ultags(1:jts)
        ultags = ultag2
        jts = jt2
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
          write (ntabx,'(a,",")') ultag2(1:jt2)
        enddo
c
c       Write the table header.
c
        write (ntabx,1100) ultag1(1:jt1)
 1100   format(a,',Table C1,Dissolved elements(molality),')
        write (ntabx,1110) ultag2(1:jt2)
 1110   format(a,',Table C2,Dissolved elements(ppm: mg/kg.sol),')
c
c       Write the column headers.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,nctpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(uelacx(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = uelacx(n)(1:j2)
          j1 = jsum
        enddo
c
        jline = j1
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
      endif
c
c     Write the table data. First, the common data (Xi, t( days)).
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
      jlead = j1
c
c     Write the data specific to Table C1.
c
      do n = 1,nctpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') cteaqx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c     Write the data specific to Table C2.
c
      ulinex(jlead + 1:j1) = ' '
      j1 = jlead
      do n = 1,nctpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') ppmwex(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qrho) then
c
c       Write Table C3:
c
c         Xi
c         t(days)
c         Molarities of dissolved elements
c
c       and Table C4:
c
c         Xi
c         t(days)
c         ppm (mg/L) of dissolved elements
c
c       Prepare the data.
c
        nctpr = 0
        do nc = 1,nct
          if (uelem(nc)(1:2).ne.'H ' .and. uelem(nc)(1:2) .ne. 'O ')
     $      then
            nctpr = nctpr + 1
            uelacx(nctpr) = uelem(nc)
            molrex(nctpr) = cteaq(nc)*mrmlra
            ppmvex(nctpr) = ppmwe(nc)*rho
          endif
        enddo
c
        ultag1 = 'C3       '
        ultag2 = 'C4       '
        jt1 = len_trim(ultag1)
        jt2 = len_trim(ultag2)
c
        if (qwrthd) then
c
c         Write an end marker for the table previous to C3.
c
          write (ntabx,'(a,",EndTable:,",a,",")')
     $    ultag1(1:jt1),ultags(1:jts)
          ultags = ultag1
          jts = jt1
c
c         Write an end marker for the table previous to C4.
c
          write (ntabx,'(a,",EndTable:,",a,",")')
     $    ultag2(1:jt2),ultags(1:jts)
          ultags = ultag2
          jts = jt2
c
c         Write two empty lines before the table header.
c
          do i = 1,2
            write (ntabx,'(a,",")') ultag1(1:jt1)
            write (ntabx,'(a,",")') ultag2(1:jt2)
          enddo
c
c         Write the table header.
c
          write (ntabx,1120) ultag1(1:jt1)
 1120     format(a,',Table C3,Dissolved elements(molarity),')
          write (ntabx,1130) ultag2(1:jt2)
 1130     format(a,',Table C4,Dissolved elements(ppm: mg/L),')
c
c         Write the column headers.
c
          ulinex = 'Xi,t(days)'
          j1 = len_trim(ulinex)
          do n = 1,nctpr
            j1 = j1 + 1
            ulinex(j1:j1) = ","
            j2 = len_trim(uelacx(n))
            jsum = j1 + j2
            ulinex(j1 + 1:jsum) = uelacx(n)(1:j2)
            j1 = jsum
          enddo
c
          jline = j1
          write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
          write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
        endif
c
c       Write the table data. First, the common data (Xi, t( days)).
c
        ulinex = ''
        j1 = 0
c
        write (ux16,'(1pg11.4)') xi1
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        jsum = jsum + 1
        ulinex(jsum:jsum) = ','
        j1 = jsum
c
        write (ux16,'(1pg11.4)') tdays
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
        jlead = j1
c
c       Write the data specific to Table C3.
c
        do n = 1,nctpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          write (ux16,'(1pg11.4)') molrex(n)
          call lejust(ux16)
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c       Write the data specific to Table C4.
c
        ulinex(jlead + 1:j1) = ' '
        j1 = jlead
        do n = 1,nctpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          write (ux16,'(1pg11.4)') ppmvex(n)
          call lejust(ux16)
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table D1:
c
c       Xi
c       t(days)
c       Total molalities of solute basis species
c
c     and Table D2:
c
c       Xi
c       t(days)
c       Total ppm (mg/kg.sol) of solute basis species
c
c     Prepare the data.
c
      n = 0
      do nb = 1,nbt
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (ns1.ge.narn1 .and. ns1.le.narn2) then
          if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
            if (ns1.ne.narn1 .and. ns1.ne.nelect .and.
     $        ns1.ne.no2gaq) then
              n = n + 1
              ctbaqx(n) = ctb(nb)
              ppmwbx(n) = ppmwb(nb)
            endif
          endif
        endif
      enddo
      if (n .ne. nqtpr) then
c
c       Programming error trap.
c
        write (ux8a,'(i8)') n
        write (ux8b,'(i8)') nqtpr
        call lejust(ux8a)
        call lejust(ux8b)
        j1 = len_trim(ux8a)
        j2 = len_trim(ux8b)
        write (noutpt,1140) ux8a(1:j1),ux8b(1:j2)
        write (nttyo,1140) ux8a(1:j1),ux8b(1:j2)
 1140   format(/' * Error - (EQ6/wrtabc) Programming error trap: ',
     $  'The solute',/7x,'basis species counts for Tables D1 and D2',
     $  ' do not match',/7x,'(',a,' versus ',a,').')
        stop
      endif
c
      ultag1 = 'D1      '
      ultag2 = 'D2      '
      jt1 = len_trim(ultag1)
      jt2 = len_trim(ultag2)
c
      if (qwrthd) then
c
c       Write an end marker for the table previous to D1.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write an end marker for the table previous to D2.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag2(1:jt2),ultags(1:jts)
        ultags = ultag2
        jts = jt2
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
          write (ntabx,'(a,",")') ultag2(1:jt2)
        enddo
c
c       Write the table header.
c
        write (ntabx,1220) ultag1(1:jt1)
 1220   format(a,',Table D1,Solute basis species(total molality),')
        write (ntabx,1230) ultag2(1:jt2)
 1230   format(a,',Table D2,Solute basis species',
     $  '(total ppm: mg/kg.sol),')
c
c       Write the column headers.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,nqtpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(ubasqx(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ubasqx(n)(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
      endif
c
c     Write the table data. First, the common data (Xi, t( days)).
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
      jlead = j1
c
c     Write the data specific to Table D1.
c
      do n = 1,nqtpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') ctbaqx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c     Write the data specific to Table D2.
c
      ulinex(jlead + 1:j1) = ' '
      j1 = jlead
      do n = 1,nqtpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(f11.4)') ppmwbx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qrho) then
c
c       Write Table D3:
c
c         Xi
c         t(days)
c         Total molarities of solute basis species
c
c       and Table D4:
c
c         Xi
c         t(days)
c         Total ppm (mg/L) solute file basis species
c
c       Prepare the data.
c
        n = 0
        do nb = 1,nbt
          ns1 = nbaspd(nb)
          ns2 = nbasp(nb)
          if (ns1.ge.narn1 .and. ns1.le.narn2) then
            if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
              if (ns1.ne.narn1 .and. ns1.ne.nelect .and.
     $          ns1.ne.no2gaq) then
                n = n + 1
                molrbx(n) = ctb(nb)*mrmlra
                ppmvbx(n) = ppmwb(nb)*rho
              endif
            endif
          endif
        enddo
        if (n .ne. nqtpr) then
c
c         Programming error trap.
c
          write (ux8a,'(i8)') n
          write (ux8b,'(i8)') nqtpr
          call lejust(ux8a)
          call lejust(ux8b)
          j1 = len_trim(ux8a)
          j2 = len_trim(ux8b)
          write (noutpt,1235) ux8a(1:j1),ux8b(1:j2)
          write (nttyo,1235) ux8a(1:j1),ux8b(1:j2)
 1235     format(/' * Error - (EQ6/wrtabc) Programming error trap: ',
     $    'The solute',/7x,'basis species counts for Tables D3 and D4',
     $    ' do not match',/7x,'(',a,' versus ',a,').')
          stop
        endif
c
        ultag1 = 'D3      '
        ultag2 = 'D4      '
        jt1 = len_trim(ultag1)
        jt2 = len_trim(ultag2)
c
        if (qwrthd) then
c
c         Write an end marker for the table previous to D3.
c
          write (ntabx,'(a,",EndTable:,",a,",")')
     $    ultag1(1:jt1),ultags(1:jts)
          ultags = ultag1
          jts = jt1
c
c         Write an end marker for the table previous to D4.
c
          write (ntabx,'(a,",EndTable:,",a,",")')
     $    ultag2(1:jt2),ultags(1:jts)
          ultags = ultag2
          jts = jt2
c
c         Write two empty lines before the table header.
c
          do i = 1,2
            write (ntabx,'(a,",")') ultag1(1:jt1)
            write (ntabx,'(a,",")') ultag2(1:jt2)
          enddo
c
c         Write the table header.
c
          write (ntabx,1240) ultag1(1:jt1)
 1240     format(a,',Table D3,Solute basis species(total molarity),')
          write (ntabx,1250) ultag2(1:jt2)
 1250     format(a,',Table D4,Solute basis species(total ppm: mg/L),')
c
c         Write the column headers.
c
          ulinex = 'Xi,t(days)'
          j1 = len_trim(ulinex)
          do n = 1,nqtpr
            j1 = j1 + 1
            ulinex(j1:j1) = ","
            j2 = len_trim(ubasqx(n))
            jsum = j1 + j2
            ulinex(j1 + 1:jsum) = ubasqx(n)(1:j2)
            j1 = jsum
          enddo
c
          write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
          write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
        endif
c
c       Write the table data. First, the common data (Xi, t( days)).
c
        ulinex = ''
        j1 = 0
c
        write (ux16,'(1pg11.4)') xi1
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        jsum = jsum + 1
        ulinex(jsum:jsum) = ','
        j1 = jsum
c
        write (ux16,'(1pg11.4)') tdays
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
        jlead = j1
c
c       Write the data specific to Table D3.
c
        do n = 1,nqtpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          write (ux16,'(1pg11.4)') molrbx(n)
          call lejust(ux16)
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c       Write the data specific to Table D4.
c
        ulinex(jlead + 1:j1) = ' '
        j1 = jlead
        do n = 1,nqtpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          write (ux16,'(f11.4)') ppmvbx(n)
          call lejust(ux16)
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table E1:
c
c       Xi
c       t(days)
c       Log true molalities of basis species (log mole fraction for H2O,
c       (log fugacity for aqueous O2(g))
c
c     Table E2:
c
c       Xi
c       t(days)
c       Log activities of basis species (log fugacity for aqueous O2(g))
c
c     and Table E3:
c
c       Xi
c       t(days)
c       Log true activity coefficients of basis species
c
c     Prepare the data.
c
      n = 0
      do nb = 1,nbt
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (ns1.ge.narn1 .and. ns1.le.narn2) then
          if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
            n = n + 1
            if (ns1 .eq. narn1) then
              conlbx(n) = xbarlg(ns1)
              actlbx(n) = actlg(ns1)
              acflbx(n) = acflg(ns1)
            elseif (ns1 .eq. no2gaq) then
              conlbx(n) = fo2lg
              actlbx(n) = fo2lg
              acflbx(n) = acflg(ns1)
            else
              conlbx(n) = conclg(ns1)
              actlbx(n) = actlg(ns1)
              acflbx(n) = acflg(ns1)
            endif
          endif
        endif
      enddo
      if (n .ne. nbtpr) then
c
c       Programming error trap.
c
        write (ux8a,'(i8)') n
        write (ux8b,'(i8)') nbtpr
        call lejust(ux8a)
        call lejust(ux8b)
        j1 = len_trim(ux8a)
        j2 = len_trim(ux8b)
        write (noutpt,1260) ux8a(1:j1),ux8b(1:j2)
        write (nttyo,1260) ux8a(1:j1),ux8b(1:j2)
 1260   format(/' * Error - (EQ6/wrtabc) Programming error trap: ',
     $  'The local complete',/7x,'basis species counts for Tables E1,',
     $  ' E2, and E3 do not match',/7x,'(',a,' versus ',a,').')
        stop
      endif
c
      ultag1 = 'E1      '
      ultag2 = 'E2      '
      ultag3 = 'E3      '
      jt1 = len_trim(ultag1)
      jt2 = len_trim(ultag2)
      jt3 = len_trim(ultag3)
c
      if (qwrthd) then
c
c       Write an end marker for the table previous to E1.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write an end marker for the table previous to E2.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag2(1:jt2),ultags(1:jts)
        ultags = ultag2
        jts = jt2
c
c       Write an end marker for the table previous to E3.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag3(1:jt3),ultags(1:jts)
        ultags = ultag3
        jts = jt3
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
          write (ntabx,'(a,",")') ultag2(1:jt2)
          write (ntabx,'(a,",")') ultag3(1:jt3)
        enddo
c
c       Write the table header.
c
        write (ntabx,1270) ultag1(1:jt1)
 1270   format(a,',Table E1,Basis species(log true molality;',
     $  ' log mole fraction for H2O, log fugacity for O2(g)),')
        write (ntabx,1280) ultag2(1:jt2)
 1280   format(a,',Table E2,Basis species(log activity;',
     $  ' log fugacity for O2(g)),')
        write (ntabx,1290) ultag3(1:jt3)
 1290   format(a,
     $  ',Table E3,Basis species(log activity coefficient),')
c
c       Write the column headers.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,nbtpr
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(ubaspx(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ubaspx(n)(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
        write (ntabx,'(a,",",a,",")') ultag3(1:jt3),ulinex(1:j1)
      endif
c
c     Write the table data. First, the common data (Xi, t( days)).
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
      jlead = j1
c
c     Write the data specific to Table E1.
c
      do n = 1,nbtpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') conlbx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c     Write the data specific to Table E2.
c
      ulinex(jlead + 1:j1) = ' '
      j1 = jlead
      do n = 1,nbtpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(f11.4)') actlbx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag2(1:jt2),ulinex(1:j1)
c
c     Write the data specific to Table E3.
c
      ulinex(jlead + 1:j1) = ' '
      j1 = jlead
      do n = 1,nbtpr
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(f11.4)') acflbx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag3(1:jt3),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table J:
c
c       Xi
c       t(days)
c       Moles of reactants destroyed/created
c
c     Prepare the data. None to prepare.
c
      ultag1 = 'J       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1340) ultag1(1:jt1)
 1340   format(a,',Table J,Moles of reactants destroyed/created,')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,nrct
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(ureac(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ureac(n)(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      do n = 1,nrct
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') modr(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table K:
c
c       Xi
c       t(days)
c       Total Affinity, kcal
c       Affinities of reactants, kcal
c
c     Prepare the data.
c
      do n = 1,nrct
        afrcx(n) = min(99999.,afrc1(n))
      enddo
c
      ultag1 = 'K       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1360) ultag1(1:jt1)
 1360   format(a,',Table K,Affinities of reactants (kcal),')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        ux48 = ',Total'
        j2 = len_trim(ux48)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux48(1:j2)
        j1 = jsum
        do n = 1,nrct
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(ureac(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ureac(n)(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(f11.4)') aft1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      do n = 1,nrct
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(f11.4)') afrcx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table P:
c
c       Xi
c       t(days)
c       Moles of product phases
c
c     Note: in these tables, moles of product phase refers to what
c     is present in the Equilibrium System for Titration and Closed
c     system models, and to cumulative totals for the Fluid-Centered
c     Flow-Through system.
c
c     Prepare the data.
c
      do n = 1,npmt
        mophx(n) = 0.
      enddo
c
      qnewph = .false.
      if (iopt(1) .ne. 2) then
c
c       Closed or titration system.
c
        do np = 2,npt
c**       if (moph(np).gt.0. .and. uphase(np)(1:5).ne."fix_f") then
          if (moph(np) .gt. 0.) then
            do n = 1,npmt
              if (uphase(np) .eq. uphasx(n)) then
c
c               Have found a product mineral in the existing list.
c
                mophx(n) = moph(np)
                go to 310
              endif
            enddo
c
c           Did not find a current product mineral in the existing
c           list. Add it to the list.
c
            qnewph = .true.
            npmt = npmt + 1
            n = npmt
            uphasx(n) = uphase(np)
            mophx(n) = moph(np)
          endif
  310     continue
        enddo
      else
c
c       Fluid-centered flow-through system.
c
        do np = 2,npt
c**       if (moph(np).gt.0. .and. uphase(np)(1:5).ne."fix_f") then
          if (moph(np) .gt. 0.) then
            do n = 1,npmt
              if (uphase(np) .eq. uphasx(n)) then
c
c               Have found a product mineral in the existing list.
c
                mophx(n) = mopht(np)
                go to 320
              endif
            enddo
c
c           Did not find a current product mineral in the existing
c           list. Add it to the list.
c
            qnewph = .true.
            npmt = npmt + 1
            n = npmt
            uphasx(n) = uphase(np)
            mophx(n) = mopht(np)
          endif
  320     continue
        enddo
      endif
c
      ultag1 = 'P       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        if (iopt(1) .ne. 2) then
          write (ntabx,1370) ultag1(1:jt1)
 1370     format(a,',Table P,Moles of product minerals,')
        else
          write (ntabx,1380) ultag1(1:jt1)
 1380     format(a,',Table P,Moles of product minerals (cumulative),')
        endif
      endif
c
      if (qnewph .or. kstep.le.0) then
c
c       Write the column header. This is an example of a variable
c       header.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,npmt
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(uphasx(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = uphasx(n)(1:j2)
          j1 = jsum
        enddo
c
        ultgv1(1:6) = ultag1(1:6)
        ultgv1(7:8) = 'vh'
        jthv1 = len_trim(ultgv1)
        write (ntabx,'(a,",",a,",")') ultgv1(1:jthv1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      do n = 1,npmt
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(1pg11.4)') mophx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table Q:
c
c       Xi
c       t(days)
c       Saturation indices of potential product phases
c
c     Note: in these tables, the saturation index (SI) is represented
c     by the function log(Q/K). Values are contained in the sidrph
c     array. A potential product phase is considered to be one which
c     at some point in the run has a saturation index above a certain
c     threshhold (sidrcv).
c
c     Prepare the data.
c
      do n = 1,npst
        sidrx(n) = 0.
      enddo
c
      qpsext = .false.
c
      do np = 2,npt
        if (uphase(np)(1:5).ne."fix_f") then
          do n = 1,npst
            if (uphase(np) .eq. usidrx(n)) then
c
c             Have found a potential product phase in the existing list.
c
              sidrx(n) = sidrph(np)
              go to 350
            endif
          enddo
c
          if (sidrph(np).gt.sidrcv) then
c
c           Did not find a potential product phase in the existing
c           list. Add a phase, write a "More omitted" tag, or skip if
c           a tag has been previously written.
c
            if (qpstag) then
c
c             The list has previously maxed out and a "More omitted"
c             tag has been written. Do nothing.
c
              continue
c
            elseif (npst .eq. npsmax) then
c
c             The list has previously maxed out, but a tag has
c             not been written. Prepare to write a tag.
c
              qpsext = .true.
              qpstag = .true.
c
            else
c
c             Add a new potential product phase to the list.
c
              qpsext = .true.
              npst = npst + 1
              n = npst
              usidrx(n) = uphase(np)
              sidrx(n) = sidrph(np)
            endif
          endif
        endif
  350   continue
      enddo
c
      ultag1 = 'Q       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1392) ultag1(1:jt1)
 1392   format(a,',Table Q,Saturation indices of potential',
     $  ' product phases,')
      endif
c
      if (qpsext .or. kstep.le.0) then
c
c       Write the column header. This is an example of a variable
c       header.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,npst
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          j2 = len_trim(usidrx(n))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = usidrx(n)(1:j2)
          j1 = jsum
        enddo
        if (qpstag) then
c
c         Have more phases than can fit.
c
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          ux16 = 'More omitted'
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        endif
c
        ultgv1(1:6) = ultag1(1:6)
        ultgv1(7:8) = 'vh'
        jthv1 = len_trim(ultgv1)
        write (ntabx,'(a,",",a,",")') ultgv1(1:jthv1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      do n = 1,npst
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        write (ux16,'(f11.4)') sidrx(n)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table T:
c
c       Xi
c       t(days)
c       Fugacities of gases, bars
c
c     Prepare the data. Nothing to prepare.
c
      ultag1 = 'T       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1400) ultag1(1:jt1)
 1400   format(a,',Table T,Fugacities (bars),')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days)'
        j1 = len_trim(ulinex)
        do n = 1,ngft
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          ns = ngasfx(n)
          j2 = len_trim(uspec(ns)(1:24))
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = uspec(ns)(1:j2)
          j1 = jsum
        enddo
        if (qgftag) then
c
c         Have more gas species than can fit.
c
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          ux16 = 'More omitted'
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        endif
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      do n = 1,ngft
        j1 = j1 + 1
        ulinex(j1:j1) = ","
        ns = ngasfx(n)
        ng = ns - ngrn1 + 1
        write (ux16,'(1pg11.4)') fugac(ng)
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
      enddo
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table W:
c
c       Xi
c       t(days)
c       Total mass of solids destroyed, grams
c       Total mass of solids created, grams
c       Net mass of solids created, grams
c       Total volume of solids destroyed, cc
c       Total volume of solids created, cc
c       Net volume of solids created, cc
c
      ultag1 = 'W       '
      jt1 = len_trim(ultag1)
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'(a,",EndTable:,",a,",")')
     $  ultag1(1:jt1),ultags(1:jts)
        ultags = ultag1
        jts = jt1
c
c       Write two empty lines before the table header.
c
        do i = 1,2
          write (ntabx,'(a,",")') ultag1(1:jt1)
        enddo
c
c       Write the table header.
c
        write (ntabx,1410) ultag1(1:jt1)
 1410   format(a,',Table W,Overall mass and volume changes,')
c
c       Write the column header.
c
        ulinex = 'Xi,t(days),g destroyed,g created,g net,'
        j1 = len_trim(ulinex)
        ux48 = 'cc destroyed,cc created,cc net'
        j2 = len_trim(ux48)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux48(1:j2)
        j1 = jsum
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c     Write the table data.
c
      ulinex = ''
      j1 = 0
c
      write (ux16,'(1pg11.4)') xi1
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') tdays
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') wodrt
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') wosoct
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') dwoso
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') vodrt
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') vosoct
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      jsum = jsum + 1
      ulinex(jsum:jsum) = ','
      j1 = jsum
c
      write (ux16,'(1pg11.4)') dvoso
      call lejust(ux16)
      j2 = len_trim(ux16)
      jsum = j1 + j2
      ulinex(j1 + 1:jsum) = ux16(1:j2)
      j1 = jsum
c
      write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(4) .ge. 1) then
c
c       Write Table X:
c
c         Xi
c         t(days)
c         Mole fractions of solid solutions.
c
c       Note: cumulative averages are presented for the case of the
c       Fluid-Centered Flow-Through system.
c
c       Prepare the data.
c
        do n = 1,nxct
          xfrac(n) = 0.
        enddo
c
        qnewss = .false.
        if (iopt(1) .ne. 2) then
c
c         Closed or titration system.
c
          do np = nxrn1,nxrn2
            if (moph(np) .gt. 0.) then
              do n = 1,nxct
                if (uphase(np) .eq. ussphx(1,n)) then
c
c                 Have found a solid solution in the existing list.
c
                  nr1 = ncmpr(1,np)
                  nr2 = ncmpr(2,np)
                  do ns = nr1,nr2
                    if (uspec(ns) .eq. ussphx(2,n)) then
                      xfrac(n) = xbar(ns)
                      go to 410
                    endif
                  enddo
                endif
              enddo
c
c             Did not find a current solid solution in the existing
c             list. Add it to the list.
c
              qnewss = .true.
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              do ns = nr1,nr2
                nxct = nxct + 1
                n = nxct
                ussphx(1,n) = uphase(np)
                ussphx(2,n) = uspec(ns)
                xfrac(n) = xbar(ns)
              enddo
            endif
  410       continue
          enddo
        else
c
c         Fluid-centered flow-through system.
c
          do np = nxrn1,nxrn2
            if (mopht(np) .gt. 0.) then
              do n = 1,nxct
                if (uphase(np) .eq. ussphx(1,n)) then
c
c                 Have found a solid solution in the existing list.
c
                  nr1 = ncmpr(1,np)
                  nr2 = ncmpr(2,np)
                  do ns = nr1,nr2
                    if (uspec(ns) .eq. ussphx(2,n)) then
                      xfrac(n) = mospt(ns)/mopht(np)
                      go to 420
                    endif
                  enddo
                endif
              enddo
c
c             Did not find a current solid solution in the existing
c             list. Add it to the list.
c
              qnewss = .true.
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              do ns = nr1,nr2
                nxct = nxct + 1
                n = nxct
                ussphx(1,n) = uphase(np)
                ussphx(2,n) = uspec(ns)
                xfrac(n) = mospt(ns)/mopht(np)
              enddo
            endif
  420       continue
          enddo
        endif
c
        ultag1 = 'X       '
        jt1 = len_trim(ultag1)
c
        if (qwrthd) then
c
c         Write an end marker for the previous table.
c
          write (ntabx,'(a,",EndTable:,",a,",")')
     $    ultag1(1:jt1),ultags(1:jts)
          ultags = ultag1
          jts = jt1
c
c         Write two empty lines before the table header.
c
          do i = 1,2
            write (ntabx,'(a,",")') ultag1(1:jt1)
          enddo
c
c         Write the table header.
c
          write (ntabx,1440) ultag1(1:jt1)
 1440     format(a,',Table X,Solid solution mole fractions,')
        endif
c
        if (qnewss .or. kstep.le.0) then
c
c         Write the column header.
c
          ulinex = 'Xi,t(days)'
          j1 = len_trim(ulinex)
          do n = 1,nxct
            j1 = j1 + 1
            ulinex(j1:j1) = ","
            j2 = len_trim(ussphx(1,n))
            jsum = j1 + j2
            ulinex(j1 + 1:jsum) = ussphx(1,n)(1:j2)
            j1 = jsum
          enddo
c
          write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
        endif
c
c       Write the table data.
c
        ulinex = ''
        j1 = 0
c
        write (ux16,'(1pg11.4)') xi1
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        jsum = jsum + 1
        ulinex(jsum:jsum) = ','
        j1 = jsum
c
        write (ux16,'(1pg11.4)') tdays
        call lejust(ux16)
        j2 = len_trim(ux16)
        jsum = j1 + j2
        ulinex(j1 + 1:jsum) = ux16(1:j2)
        j1 = jsum
c
        do n = 1,nxct
          j1 = j1 + 1
          ulinex(j1:j1) = ","
          write (ux16,'(1pg11.4)') xfrac(n)
          call lejust(ux16)
          j2 = len_trim(ux16)
          jsum = j1 + j2
          ulinex(j1 + 1:jsum) = ux16(1:j2)
          j1 = jsum
        enddo
c
        write (ntabx,'(a,",",a,",")') ultag1(1:jt1),ulinex(1:j1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write Table Z:
c
c       End of data marker
c
      if (qwrthd) then
c
c       Write an end marker for the previous table.
c
        write (ntabx,'("Z,EndTable:,",a,",")') ultags(1:jts)
c
        write (ntabx,'("Z,")')
        write (ntabx,'("Z,")')
c
c       Write the table header.
c
        write (ntabx,'("Z,Table Z,Endfile,")')
c
        write (ntabx,'("Z,Endtable:,Z,")')
c
      endif
c
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine etoo2(cdrsi,dhfe,dhfs,dvfe,dvfs,ipch,ipchmx,ipcv,
     $ ipcvmx,narxmx,narxt,nbtmx1,ndrsts,ns,ntprmx,ntprt,udrsi,
     $ xhfe,xhfs,xlke,xlks,xvfe,xvfs)
c
c     This subroutine converts the reaction for the ns-th species from
c     one written in terms of e- to one written in terms of O2(g).
c     The "Eh" reaction is used to do this.
c
c     This subroutine is called by:
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       cdrsi  = array of coefficients for the original reaction
c                  associated with the ns-th species
c       nbtmx1 = the maximum number of basis species plus 1
c       ndrsts = number of species in the reaction
c       ns     = index of the species whose reaction is to be rewritten
c       udrsi  = names of species in the original reaction
c       xlke   = the array of log K values for the "Eh reaction"
c       xlks   = the array of log K values for the original reaction
c
c     Output:
c
c       cdrsi  = array of coefficients for a reaction, rewritten
c                  in terms of e- instead of O2(g)
c       udrsi  = names of species in the rewritten reaction
c       xlks   = the array of log K values for the rewritten reaction
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nbtmx1,ntprmx
c
      integer narxt(ntprmx)
c
      integer ipch,ipcv,ndrsts,ns,ntprt
c
      character*24 udrsi(nbtmx1)
c
      real*8 cdrsi(nbtmx1),dhfe(narxmx,ntprmx,ipchmx),
     $ dhfs(narxmx,ntprmx,ipchmx,nbtmx1),dvfe(narxmx,ntprmx,ipcvmx),
     $ dvfs(narxmx,ntprmx,ipcvmx,nbtmx1),xhfe(narxmx,ntprmx),
     $ xhfs(narxmx,ntprmx,nbtmx1),xlke(narxmx,ntprmx),
     $ xlks(narxmx,ntprmx,nbtmx1),xvfe(narxmx,ntprmx),
     $ xvfs(narxmx,ntprmx,nbtmx1)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,kdrsts,n,nelect,nhydr,ntpr,nwater
c
      real*8 factor
c
c-----------------------------------------------------------------------
c
c     Search for e-, H+, and H2O in the reaction.
c
      nelect = 0
      nhydr = 0
      nwater = 0
c
      do n = 2,ndrsts
        if (udrsi(n)(1:3) .eq. 'e- ') nelect = n
        if (udrsi(n)(1:3) .eq. 'H+ ') nhydr = n
        if (udrsi(n)(1:4) .eq. 'H2O ') nwater = n
      enddo
c
      if (nelect .eq. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Re-write the reaction, using the Eh reaction:
c
c       H2O = 4H+ + 4e- + O2(g)
c
      factor = -cdrsi(nelect)/4.
c
      udrsi(nelect) = 'O2(g)'
      cdrsi(nelect) = factor
c
      if (nhydr .gt. 0) then
        cdrsi(nhydr) = cdrsi(nhydr) + 4.*factor
      else
        ndrsts = ndrsts + 1
        nhydr = ndrsts
        udrsi(nhydr) = 'H+'
        cdrsi(nhydr) = 4.*factor
      endif
c
      if (nwater .gt. 0) then
        cdrsi(nwater) = cdrsi(nwater) - 2.*factor
      else
        ndrsts = ndrsts + 1
        nwater = ndrsts
        udrsi(nwater) = 'H2O'
        cdrsi(nwater) = -2.*factor
      endif
c
c     Clear any zeroes in the reaction coefficients.
c
      kdrsts = ndrsts
      do n = 1,ndrsts
        if (abs(cdrsi(n)) .le. 1.e-6) then
          if (n .le. kdrsts - 1) then
            do i = n,kdrsts - 1
              cdrsi(i) = cdrsi(i + 1)
              udrsi(i) = udrsi(i + 1)
            enddo
          endif
          kdrsts = kdrsts - 1
        endif
        if (n .ge. kdrsts) go to 150
      enddo
  150 ndrsts = kdrsts
c
c     Modify the log K values.
c
      do ntpr = 1,ntprt
        do n = 1,narxt(ntpr)
          if (xlks(n,ntpr,ns).lt.9999999. .and.
     $      xlke(n,ntpr).lt.9999999.) then
            xlks(n,ntpr,ns) = xlks(n,ntpr,ns) + factor*xlke(n,ntpr)
          else
            xlks(n,ntpr,ns) = 9999999.
          endif
        enddo
      enddo
c
      if (ipch .ge. 0) then
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            if (xhfs(n,ntpr,ns).lt.9999999. .and.
     $        xhfe(n,ntpr).lt.9999999.) then
              xhfs(n,ntpr,ns) = xhfs(n,ntpr,ns) + factor*xhfe(n,ntpr)
            else
              xhfs(n,ntpr,ns) = 9999999.
            endif
          enddo
        enddo
c
        do ipc = 1,ipch
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              if (dhfs(n,ntpr,ipc,ns).lt.9999999. .and.
     $          dhfe(n,ntpr,ipc).lt.9999999.) then
                dhfs(n,ntpr,ipc,ns) = dhfs(n,ntpr,ipc,ns)
     $          + factor*dhfe(n,ntpr,ipc)
              else
                dhfs(n,ntpr,ipc,ns) = 9999999.
              endif
            enddo
          enddo
        enddo
      endif
c
      if (ipcv .ge. 0) then
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            if (xvfs(n,ntpr,ns).lt.9999999. .and.
     $        xvfe(n,ntpr).lt.9999999.) then
              xvfs(n,ntpr,ns) = xvfs(n,ntpr,ns) + factor*xvfe(n,ntpr)
            else
              xvfs(n,ntpr,ns) = 9999999.
            endif
          enddo
        enddo
c
        do ipc = 1,ipcv
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              if (dvfs(n,ntpr,ipc,ns).lt.9999999. .and.
     $          dvfe(n,ntpr,ipc).lt.9999999.) then
                dvfs(n,ntpr,ipc,ns) = dvfs(n,ntpr,ipc,ns)
     $          + factor*dvfe(n,ntpr,ipc)
              else
                dvfs(n,ntpr,ipc,ns) = 9999999.
              endif
            enddo
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine fpexrc(delxi,dlxmin,drer0,dxval0,eps100,iodb,
     $ jreac,morr,morr0,nodbmx,nord,noutpt,nrct,nrctmx,nrd1mx,
     $ nttyo,qdump,rrelr0,ureac,xi0,xi1,xval0)
c
c     This subroutine finds the point of reaction progress at which a
c     reactant becomes exhausted.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrctmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),jreac(nrctmx)
c
      integer nord,nrct
c
      logical qdump
c
      character*24 ureac(nrctmx)
c
      real*8 drer0(nrd1mx,nrctmx),dxval0(nrd1mx),morr(nrctmx),
     $ morr0(nrctmx),rrelr0(nrctmx)
c
      real*8 delxi,dlxmin,dlxrct,dxp,eps100,mxx,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,j2,kexrc,n,nexrc,nordp1,nrc
c
      integer ilnobl
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxsv,tolsx,xtargv,xval
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'a reactant is exhausted                         '/
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
c
c     The search target is not where the number of moles remaining is
c     zero, but -eps100. The interval for convergence is (-2*eps100,0).
c
      nordp1 = nord + 1
      ilsign = 1
      xtargv = -eps100
      tolsx = eps100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for reactant masses becoming exhausted',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 990
      endif
c
c     Estimate the number of moles remaining of each reactant from
c     Taylor's series expansions.
c
      do nrc = 1,nrct
        dlxrct = 0.
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
          dlxrct = rrelr0(nrc)*delxi
          dxp = delxi
          do n = 1,nord
            dxp = dxp*delxi
            dlxrct = dlxrct + ( drer0(n,nrc)/fctrl(n + 1) )*dxp
          enddo
        endif
c
cXX     The following assumes that each reactant has a reaction
cXX     coefficient of 1.
c
        morr(nrc) = morr0(nrc) - dlxrct
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any cases of exhausted reactants.
c
      xval = 1.0
      nexrc = 0
      kexrc = 0
      unam24 = ' '
      do nrc = 1,nrct
        mxx = morr(nrc)
        if (mxx .le. 0.) then
          if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
            kexrc = kexrc + 1
            if (mxx .lt. xval) then
              xval = morr(nrc)
              nexrc = nrc
              unam24 = ureac(nrc)
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kexrc .gt. 0) then
        if (delxi .gt. dlxmin) then
          if (abs(xval - xtargv) .gt. tolsx) then
c
            xval0 = morr0(nexrc)
c
cXX         The following assumes that each reactant has a reaction
cXX         coefficient of 1.
c
            dxval0(1) = -rrelr0(nexrc)
            do n = 2,nordp1
              dxval0(n) = -drer0(n - 1,nexrc)
            enddo
c
c           Calling sequence substitutions:
c             nordp1 for nord
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nordp1,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 990
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (kexrc .gt. 0) then
          write (noutpt,1010) xi1,delxi
 1010     format(/3x,"Taylor's series predict exhaustion of the",
     $    ' following',/3x,'reactants at Xi= ',1pe11.4,
     $    ', delxi= ',e11.4,':',/)
c
          do nrc = 1,nrct
            mxx = morr(nrc)
            if (abs(mxx - xtargv) .le. tolsx) then
              if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
                j2 = ilnobl(ureac(nexrc))
                write (noutpt,1020) ureac(nexrc)(1:j2)
 1020           format(5x,a)
              endif
            endif
          enddo
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (dxsv .gt. delxi) qdump = .false.
c
  999 continue
      end

      subroutine stripl(nin,nout)
c
c     This subroutine copies the file whose unit number is "nin" to
c     that whose unit number is "nout". Lines beginning with an asterix
c     are not copied. Lines exceeding a length of 80 characters are
c     truncated.
c
c     This subroutine is called by:
c
c       EQPT/ofiles.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nin    = unit number of the file to be stripped
c       nout   = unit number of the stripped file
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nin,nout
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
      character*80 uibuf
      character*1 ustar,ux
c
c-----------------------------------------------------------------------
c
      data ustar  /'*'/
c
c-----------------------------------------------------------------------
c
   10 read (nin,1000,end=999) uibuf
 1000 format(a80)
c
c     Skip lines with an asterisk in column 1.
c
      ux = uibuf(1:1)
      if (ux .eq. ustar) go to 10
c
      j2 = ilnobl(uibuf)
      if (j2 .le. 0) j2 = 1
      write (nout,1010) uibuf(1:j2)
 1010 format(a)
      go to 10
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine scripz(abar,acflg,acfw,acfwlg,actlg,actw,actwlg,
     $ affpd,affsd,afrc1,aft1,ah,ahmes,ahnbs,ahrc,alki,alk1,
     $ alk2,awmax,awmin,a3bar,cbsr,cdrsd,cegexs,cesr,conc,conclg,csts,
     $ ctb,cteaq,dvoso,dwoso,egers,egexjc,egexjf,egexpa,egexpc,egexs,
     $ egexw,eh,ehmax,ehmes,ehmin,ehnbs,ehrc,elecsr,electr,fje,fjest,
     $ fo2,fo2lg,fo2lrc,fugac,fugalg,fxi,fxist,iaqsln,iemop,iemop0,
     $ iemos,iemos0,iern1,iern2,iexr,iexrt,ifrn1,ifrn2,ilrn1,ilrn2,
     $ imech,imrn1,imrn2,iopg,iopr,iopt,ipndx1,ixrn1,ixrn2,jcode,jcsort,
     $ jern1,jern2,jexr,jexrt,jflag,jflagd,jflgi,jgext,jgsort,jpflag,
     $ jreac,jsca,jscat,jscr,jscrt,jsflag,jsol,jssort,kbt,kern1,kern2,
     $ kgexsa,km1,kmt,kx1,kxt,kstep,kstpmx,loph,losp,mlmrra,modr,
     $ moph,mophg,mophj,mopht,morr,mosp,mospg,mospj,mospt,mprph,
     $ mprsp,mrgers,mrmlra,mwtrc,mwtsp,narn1,narn2,nat,nbasp,nbaspd,
     $ nbt,ncmpe,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,nern1,nern2,
     $ nert,net,nfrn1,nfrn2,ngext,ngexsa,ngrn1,ngrn2,ngt,nhydr,nhydx,
     $ nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,noutpt,no2gaq,npet,npet0,
     $ npt,npts,nrct,nrdxsp,nrk,nrndex,nst,nsts,nstsr,ntf1t,ntf2t,
     $ nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,omega,o2max,o2min,pch,pe,
     $ pemes,penbs,perc,ph,phcl,phmax,phmes,phmin,phnbs,ppmwe,presg,
     $ press,qaft1,qftpr2,qmod,qphcl,qredox,qrho,qriinf,qstopx,qvhfxi,
     $ qvlsow,qzprnt,rho,rhoc,rhowc,rk,rreacn,rreac1,rrelr1,rxbar,
     $ sfcar,sidrph,sidrsp,sigmst,sigmam,ssfcar,tdays,tdsglw,tdspkc,
     $ tdsplc,tempc,thours,time1,timemx,tmins,tolsat,tolxsf,tolxst,
     $ tolxsu,tyears,uelem,ugermo,ugexj,ugexmo,uphase,ureac,uspec,
     $ uxtype,vodrt,voph,vophg,vophj,vopht,vosoct,vosol,vosp,vospg,
     $ vospj,vospt,vreac,wfh2o,wftds,wkgwi,woh2o,wodr,wodrt,woph,
     $ wophg,wophj,wopht,worr,worrt,wosoct,wosol,wosp,wospg,wospj,
     $ wospt,wotds,xbar,xbarlg,xbarw,xbrwlg,xgers,xgexw,xi1,xidump,
     $ ximax,xistsv,xirct,zchar)
c
c     This subroutine writes a detailed description on the output file
c     of the modeled system at the current value of reaction progress
c     (xi1).
c
c     NOTE: This subroutine is designed to carry out a largely pure
c     write function. Very few things to be printed by this subroutine
c     should be computed within it. Unless the data are already
c     available in EQ6/path.f, they should be calculated in
c     EQ6/cdappl.f, which is called by EQ6/path.f prior to printing or
c     plotting. This practice should be followed so that data needed for
c     printing are also available for plotting. It is acceptable to make
c     certain simple calculations in this subroutine, such as taking
c     logarithms or converting units. If need be, these can be repeated
c     elsewhere for plotting.
c
c     Note that qftpr2 is a logical flag denoting a print being made
c     only for a special fluid-centered flow-through open system just
c     after a discontinuity in the derivatives along the reaction
c     path.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt
c
      integer jcode(nrctmx),jreac(nrctmx),nrndex(nrctmx),nxridx(nrctmx)
c
      integer iemop(npetmx),iemop0(npetmx),iemos(nsetmx),iemos0(nsetmx),
     $ iexr(nrctmx),imech(2,nrctmx),iopg(nopgmx),iopr(noprmx),
     $ iopt(noptmx),ipndx1(kmax),jcsort(nstmax),jern1(jetmax,netmax),
     $ jern2(jetmax,netmax),jexr(nrctmx),jflag(nstmax),jflagd(nstmax),
     $ jflgi(nbtmax),jgext(netmax),jgsort(ngtmax),jpflag(nptmax),
     $ jsca(nrctmx),jscr(nrctmx),jsflag(nstmax),jsol(nxtmax),
     $ jssort(nstmax),kern1(netmax),kern2(netmax),kgexsa(ketmax,netmax),
     $ nbasp(nbtmax),nbaspd(nbtmax),ncmpe(2,npetmx),ncmpe0(2,npetmx),
     $ ncmpr(2,nptmax),ndrsd(ndrsmx),ndrsrd(2,nstmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax),nrk(2,nrctmx),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer iaqsln,iexrt,jexrt,jscat,jscrt,kbt,km1,kmt,kx1,kxt,kstep,
     $ kstpmx,nelect,nert,nhydr,nhydx,nmrt,no2gaq,npet,npet0,npts,nrct,
     $ nrdxsp,ntf1t,ntf2t,nxrt
c
      logical qaft1,qftpr2,qmod,qphcl,qredox,qrho,qriinf,qstopx,
     $ qvhfxi,qvlsow,qzprnt
c
      character*48 uspec(nstmax)
      character*32 uxtype(jsomax)
      character*24 ugermo(nertmx),ureac(nrctmx)
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 uelem(nctmax),ugexj(jetmax,netmax)
c
      real*8 cbsr(nbt1mx,nsrtmx),cesr(nctmax,nsrtmx),
     $ egers(ietmax,jetmax,nertmx),elecsr(nsrtmx),modr(nrctmx),
     $ mrgers(ietmax,jetmax,nertmx),morr(nrctmx),mwtrc(nrctmx),
     $ rreacn(nrctmx),rreac1(nrctmx),rrelr1(nrctmx),
     $ rxbar(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),vreac(nrctmx),
     $ wodr(nrctmx),worr(nrctmx),xgers(ietmax,jetmax,nertmx)
c
      real*8 acflg(nstmax),actlg(nstmax),affpd(nptmax),affsd(nstmax),
     $ afrc1(nrctmx),ahrc(nbtmax),cdrsd(ndrsmx),
     $ cegexs(ietmax,jetmax,netmax),conc(nstmax),conclg(nstmax),
     $ csts(nstsmx),ctb(nbtmax),cteaq(nctmax),egexjc(jetmax,netmax),
     $ egexjf(jetmax,netmax),egexpa(netmax),egexpc(netmax),
     $ egexs(ietmax,jetmax,netmax),egexw(ketmax,netmax),ehrc(nbtmax),
     $ fo2lrc(nbtmax),fugac(ngtmax),fugalg(ngtmax),loph(nptmax),
     $ losp(nstmax),moph(nptmax),mophg(nptmax),mophj(nptmax),
     $ mopht(nptmax),mosp(nstmax),mospg(nstmax),mospj(nstmax),
     $ mospt(nstmax),mprph(nptmax),mprsp(nstmax),mwtsp(nstmax)
c
      real*8 perc(nbtmax),ppmwe(nctmax),rk(imchmx,2,nrctmx),
     $ sidrph(nptmax),sidrsp(nstmax),voph(nptmax),vophg(nptmax),
     $ vophj(nptmax),vopht(nptmax),vosp(nstmax),vospg(nstmax),
     $ vospj(nstmax),vospt(nstmax),woph(nptmax),wophg(nptmax),
     $ wophj(nptmax),wopht(nptmax),wosp(nstmax),wospg(nstmax),
     $ wospj(nstmax),wospt(nstmax),xbar(nstmax),xbarlg(nstmax),
     $ xgexw(ketmax,netmax),xirct(nrctmx),zchar(nstmax)
c
      real*8 abar,acfw,acfwlg,actw,actwlg,aft1,ah,ahmes,ahnbs,
     $ alki,alk1,alk2,awmax,awmin,a3bar,dvoso,dwoso,eh,ehmax,ehmin,
     $ ehmes,ehnbs,electr,fje,fjest,fo2,fo2lg,fxi,fxist,osc,oscst,omega,
     $ o2max,o2min,pch,pe,penbs,pemes,ph,phcl,phmax,phmes,phmin,phnbs,
     $ presg,press,rho,sigmam,sigmst,tdays,tempc,thours,time1,timemx,
     $ tmins,tolsat,tolxsf,tolxst,tolxsu,tyears,vodrt,vosoct,vosol,
     $ wfh2o,wftds,wkgwi,wodrt,woh2o,worrt,wosoct,wosol,wotds,xbarw,
     $ xbrwlg,xi1,xidump,ximax,xistsv
c
      real(8) mlmrra,mrmlra,rhoc,rhowc,tdsglw,tdspkc,tdsplc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ie,j,je,j1,j2,j3,kcol,ncount,ne,np,npe,nplast,np1,ns,
     $ nsr,nrc,nr1,nr2,nse,nt
c
      integer ilnobl
c
      logical qrct,qtimmx
c
      character(len=16) ux16a,ux16b,ux16c
c
      real*8 betchb,chdrft,chdrfs,dp,elects,lxx,mxx,sigza,sigzc,sigzi,
     $ sigzia,sigzis,sigzm,sigzma,sigzms,tolspf,wconst,xilg
c
      real*8 tlg
c
c-----------------------------------------------------------------------
c
      wconst = omega/mosp(narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1000)
 1000 format(/' - - - - - - - - - - - - - - - - - - - - - - - - -',
     $ ' - - - - - - -',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      xilg = -99999.
      if (xi1 .gt. 0.) xilg = tlg(xi1)
c
      write (noutpt,1010) xi1,xilg
 1010 format(/20x,'Xi= ',1pe12.5,/16x,'Log Xi= ',0pf12.5,/)
c
      if (iopt(2) .ge. 1) then
        if (qriinf) then
          write (noutpt,1020)
 1020     format(/12x,'Time= infinity',/)
        else
          write (noutpt,1030) time1,tmins,thours,tdays,tyears
 1030     format(/12x,'Time= ',1pe10.3,' seconds',
     $    /16x,'= ',1pe10.3,' minutes',/16x,'= ',1pe10.3,' hours',
     $    /16x,'= ',1pe10.3,' days',/16x,'= ',1pe10.3,' years',/)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1050) tempc
 1050 format(/' Temperature= ',f6.2,' C')
c
      dp = press - presg
      if (abs(dp) .le. 1.e-4) then
        write (noutpt,1060) press
 1060   format(/' Pressure= ',1pg12.5,' bars',/)
      else
        write (noutpt,1070) press,presg,dp
 1070   format(/' Pressure= ',1pg12.5,' bars',
     $  /' Data file reference curve pressure= ',g12.5,' bars',
     $  /' Pressure difference= ',g12.5,' bars',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qftpr2) then
        write(noutpt,1090)
 1090   format(/' Fluid-centered flow-through open system print',
     $  /' following a discontinuity.')
c
c       If this path is taken, only a partial description of
c       the system is printed.
c
        go to 200
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qzprnt) write (noutpt,1100)
 1100 format(/' Required print point.')
c
      if (xi1.ge.xidump .and. xi1.gt.xistsv) write (noutpt,1110)
 1110 format(/' Required PRS shift.')
c
      if (qaft1) write (noutpt,1120)
 1120 format(/' The total affinity is repeatedly nearly zero.')
c
      if (iexrt .gt. 0) then
        write (noutpt,1130)
 1130   format(/' Exhaustion of the following reactant(s):')
        do i = 1,iexrt
          nrc = iexr(i)
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1140) ureac(nrc)(1:j2)
 1140     format(5x,a)
        enddo
      endif
c
      if (jexrt .gt. 0) then
        write (noutpt,1150)
 1150   format(/' Step size is limited by the reactivation of',
     $  ' the following formerly',/1x,'exhausted reactant(s):',/)
        do j = 1,jexrt
          nrc = jexr(j)
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1140) ureac(nrc)
        enddo
      endif
c
      if (jscat .gt. 0) then
        write (noutpt,1160)
 1160   format(/' Step size is limited by the sign change of',
     $  ' the affinity of the',/1x,'following reactant(s):',/)
        do j = 1,jscat
          nrc = jsca(j)
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1140) ureac(nrc)
        enddo
      endif
c
      if (jscrt .gt. 0) then
        write (noutpt,1170)
 1170   format(/,' Step size is limited by the sign change of',
     $  ' the relative rate of the',/1x,'following reactant(s):',/)
        do j = 1,jscrt
          nrc = jscr(j)
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1140) ureac(nrc)
        enddo
      endif
c
      if (xi1 .le. xistsv) write (noutpt,1200)
 1200 format(/' Start or restart of the run.')
c
      if (qmod) write (noutpt,1210)
 1210 format(/' Have a change in the ES phase assemblage.')
c
      if (xi1 .ge. ximax) write (noutpt,1220)
 1220 format(/' Maximum value of Xi.')
c
      qtimmx = iopt(2) .ge. 1 .and. time1.ge.( (1. - tolxst)*timemx )
      if (qtimmx) write (noutpt,1230)
 1230 format(/' Maximum value of time.')
c
      if (abs(ph - phmin) .le. tolxsu) then
        write (noutpt,1240)
 1240   format(/' Minimum value of pH.')
      elseif (ph. lt. phmin) then
        write (noutpt,1250)
 1250   format(/' pH is less than the minimum value.')
      endif
c
      if (abs(ph - phmax) .le. tolxsu) then
        write (noutpt,1260)
 1260   format(/' Maximum value of pH.')
      elseif (ph. gt. phmax) then
        write (noutpt,1270)
 1270   format(/' pH is greater than the maximum value.')
      endif
c
      if (qredox) then
        if (abs(eh - ehmin) .le. tolxsu) then
          write (noutpt,1280)
 1280     format(/' Minimum value of Eh (v).')
        elseif (eh. lt. ehmin) then
          write (noutpt,1290)
 1290     format(/' Eh (v) is less than the minimum value.')
        endif
c
        if (abs(eh - ehmax) .le. tolxsu) then
          write (noutpt,1300)
 1300     format(/' Maximum value of Eh (v).')
        elseif (eh. gt. ehmax) then
          write (noutpt,1310)
 1310     format(/' Eh (v) is greater than the maximum value.')
        endif
      endif
c
      if (qredox) then
        if (abs(fo2lg - o2min) .le. tolxsu) then
          write (noutpt,1320)
 1320     format(/' Minimum value of log fO2.')
        elseif (fo2lg. lt. o2min) then
          write (noutpt,1330)
 1330     format(/' Log fO2 is less than the minimum value.')
        endif
c
        if (abs(fo2lg - o2max) .le. tolxsu) then
          write (noutpt,1340)
 1340     format(/' Maximum value of log fO2.')
        elseif (fo2lg. gt. o2max) then
          write (noutpt,1350)
 1350     format(/' log fO2 is greater than the maximum value.')
        endif
      endif
c
      if (abs(actw - awmin) .le. tolxsu) then
        write (noutpt,1360)
 1360   format(/' Minimum value of the activity of water.')
      elseif (actw. lt. awmin) then
        write (noutpt,1370)
 1370   format(/' The activity of water is less than the minimum',
     $  ' value.')
      endif
c
      if (abs(actw - awmax) .le. tolxsu) then
        write (noutpt,1380)
 1380   format(/' Maximum value of the activity of water.')
      elseif (actw. gt. awmax) then
        write (noutpt,1390)
 1390   format(/' The activity of water is greater than the maximum',
     $  ' value.')
      endif
c
      if (kstep .ge. kstpmx) write (noutpt,1450)
 1450 format(/' Maximum number of steps.')
c
      if (qvlsow) write (noutpt,1460)
 1460 format(/' Have very nearly exhausted solvent water.')
c
      if (qvlsow) write (noutpt,1470)
 1470 format(/' Have extremely high ionic strength.')
c
      if (qstopx) write (noutpt,1480)
 1480 format(/' Early termination.')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print tables of data for reactants and reaction rates.
c
      call prtrct(afrc1,aft1,imchmx,imech,iopt,modr,morr,
     $ noptmx,noutpt,nrct,nrctmx,nrk,rk,rreacn,rreac1,rrelr1,sfcar,
     $ ureac,wodr,wodrt,worr,worrt,xi1,xistsv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table of the elemental composition of the aqueous
c     solution.
c
      call prteca(cteaq,mrmlra,nct,nctmax,noutpt,ppmwe,
     $ qrho,rho,uelem)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print a table of the numerical compostion of the
c     aqueous solution.
c
      call prtnca(ctb,jflag,jsflag,mrmlra,mwtsp,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,noutpt,nstmax,qrho,rho,uspec,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print a table of the sensible compostion of the
c     aqueous solution.
c
      call prtsca(ctb,jflag,jsflag,mrmlra,mwtsp,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,nelect,nhydr,nhydx,noutpt,no2gaq,
     $ nstmax,qrho,rho,uspec,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print pH, Eh, and pe-, all with reference to appropriate
c     pH scales. Also print the pHCl.
c
      call prpheh(ah,ahmes,ahnbs,eh,ehmes,ehnbs,iopg,
     $ nopgmx,noutpt,pch,pe,pemes,penbs,ph,phcl,phmes,phnbs,
     $ qphcl,qredox,qrho)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print various aqueous phase parameters.
c
      call prtvpa(abar,acfw,acfwlg,actw,actwlg,a3bar,fje,
     $ fjest,fo2,fo2lg,fxi,fxist,iopg,mlmrra,mrmlra,nopgmx,noutpt,
     $ osc,oscst,qrho,rhoc,rhowc,sigmam,sigmst,tdsglw,tdspkc,
     $ tdsplc,vosol,wfh2o,wftds,woh2o,wosol,wotds,xbarw,xbrwlg)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print more precise mass results for the aqueous phase.
c
      write (ux16a,'(1pg15.8)') woh2o
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg15.8)') wotds
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (ux16c,'(1pg15.8)') wosol
      call lejust(ux16c)
      j3 = ilnobl(ux16c)
      write (noutpt,1500) ux16a(1:j1),ux16b(1:j2),ux16c(1:j3)
 1500 format(//11x,'--- More Precise Aqueous Phase Masses ---',
     $ //23x,'Solvent mass= ',a,' g',
     $ /17x,'Solutes (TDS) mass= ',a,' g',
     $ /14x,'Aqueous solution mass= ',a,' g',//)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table of computed alkalinity parameters.
c
      call prtalk(alki,alk1,alk2,mrmlra,noutpt,ntf1t,ntf2t,
     $ qrho,rho,tempc,wfh2o)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print a table describing the aqueous phase charge
c     balance.
c
      call gszm(conc,jcsort,narn1,narn2,nstmax,sigza,sigzc,
     $ sigzi,sigzm,zchar)
c
      sigzia = sigzi/wconst
      sigzma = sigzm/wconst
c
      chdrft = sigzia - electr
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 2) then
          nsr = nrndex(nrc)
          chdrft = chdrft - elecsr(nsr)*xirct(nrc)
        endif
      enddo
c
      betchb = chdrft/sigzma
      sigzis = wfh2o*sigzi
      elects = wfh2o*electr
      chdrfs = wfh2o*chdrft
      sigzms = wfh2o*sigzma
c
      write (noutpt,1510) sigzia,electr,chdrft,sigzma,sigzis,elects,
     $ chdrfs,sigzms,betchb
 1510 format(//7x,' --- Aqueous Solution Charge Balance ---',
     $ //6x,'    Actual Charge imbalance= ',1pe11.4,' eq',
     $  /6x,'  Expected Charge imbalance= ',e11.4,' eq',
     $  /6x,'         Charge discrepancy= ',e11.4,' eq',
     $  /6x,'        Sigma |equivalents|= ',e11.4,' eq',
     $ //6x,'    Actual Charge imbalance= ',e11.4,' eq/kg.solu',
     $  /6x,'  Expected Charge imbalance= ',e11.4,' eq/kg.solu',
     $  /6x,'         Charge discrepancy= ',e11.4,' eq/kg.solu',
     $  /6x,'        Sigma |equivalents|= ',e11.4,' eq/kg.solu',
     $ //6x,'Relative charge discrepancy= ',e11.4)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print detailed listing of aqueous species.
c
      call prtaqs(acflg,actlg,conc,conclg,iopr,jcsort,narn1,
     $ narn2,noprmx,noutpt,nstmax,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the contributions of species to each aqueous mass total.
c
      call prtpct(conc,csts,ctb,iopr,jcsort,jflag,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,nelect,nhydr,noprmx,no2gaq,noutpt,
     $ nstmax,nsts,nstsmx,nstsr,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(9) .gt. 0) then
c
c       Compute and print the mean ionic activities and activity
c       coefficients.
c
        call prtmip(acflg,actlg,conclg,ctb,nbaspd,nbt,nbtmax,
     $  nelect,nhydr,nhydx,noutpt,nstmax,uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(5) .gt. 0) then
c
c       Compute and print activity ratios of aqueous species.
c
        call prtacr(actlg,iopr,jsflag,nbaspd,nbt,nbtmax,nelect,
     $  nhydr,noprmx,no2gaq,noutpt,nstmax,uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Print data for redox reactions that are not constrained to be
c       at equilibrium.
c
        call prtrdx(ah,ahrc,cdrsd,eh,ehrc,fo2lg,fo2lrc,jflag,
     $  jsflag,narn1,nbasp,nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $  nelect,nhydr,no2gaq,noutpt,nstmax,pe,perc,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1).eq.0 .or. iopt(1).eq.1) then
c
c       List the solid phases in the equilibrium system (ES).
c
        write (noutpt,1600)
 1600   format(//21x,'--- Summary of Solid Phases (ES) ---')
        write (noutpt,1610)
 1610   format(/'   Phase/End-member',12x,'Log moles',5x,'Moles',8x,
     $  'Grams',5x,'Volume, cm3',/)
c
        ncount = 0
c
        do kcol = km1,kmt
          ncount = ncount + 1
          np = ipndx1(kcol)
          write (noutpt,1620) uphase(np),loph(np),moph(np),woph(np),
     $    voph(np)
 1620     format(1x,a24,4x,f11.4,3(2x,1pe11.4))
        enddo
c
        nplast = 0
        do kcol = kx1,kxt
          np = ipndx1(kcol)
          if (np .ne. nplast) then
            if (ncount .gt. 0) write (noutpt,1630)
 1630       format(1x)
            ncount = ncount + 1
            write (noutpt,1620) uphase(np),loph(np),moph(np),woph(np),
     $      voph(np)
c
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            nt = nr2 - nr1 + 1
            if (nt .ge. 2) then
              do ns = nr1,nr2
                if (jsflag(ns) .le. 0) then
                  write (noutpt,1640) uspec(ns),losp(ns),mosp(ns),
     $            wosp(ns),vosp(ns)
 1640             format(3x,a24,2x,f11.4,3(2x,1pe11.4))
                endif
              enddo
            endif
            nplast = np
          endif
        enddo
c
        nplast = 0
        do np = iern1,iern2
          if (moph(np) .gt. 0.) then
            if (np .ne. nplast) then
              if (ncount .gt. 0) write (noutpt,1630)
              ncount = ncount + 1
              write (noutpt,1620) uphase(np),loph(np),moph(np),
     $        woph(np),voph(np)
c
              ne = np - iern1 + 1
              do je = 1,jgext(ne)
                if (je .gt. 1) write (noutpt,1642)
 1642           format(1x)
                ns = jern1(je,ne) - 1
                do ie = 1,ngext(je,ne)
                  ns = ns + 1
                  if (jsflag(ns) .le. 0) then
                    write (noutpt,1640) uspec(ns),losp(ns),mosp(ns),
     $              wosp(ns),vosp(ns)
                  endif
                enddo
              enddo
              nplast = np
            endif
          endif
        enddo
c
        if (ncount .le. 0) write (noutpt,1650)
 1650   format(1x,'None')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  200 continue
c
      if (iopt(1) .eq. 2) then
c
c       List the mineral assemblage which is forming instantaneously
c       with respect to Xi (on a per unit Xi basis). When this is
c       calculated at a phase boundary, the assemblage given is the one
c       to the left of the boundary. When this is calculated just
c       after the boundary, it is the one to the right of the boundary.
c
        if (npts .gt. 0) then
          write (noutpt,1700)
 1700     format(//3x,'--- Summary of Solid Phases (ES, Instantaneous',
     $    ' Basis) ---',/19x,'(defined by derivatives)')
          write (noutpt,1710)
 1710     format(//3x,'Phase/End-member',11x,'d mol/d Xi',2x,
     $    'd grams/d Xi',2x,'d V(cm3)/d Xi',/)
c
          ncount = 0
c
          do npe = 2,npet0
            np = iemop0(npe)
            ncount = ncount + 1
            if (np.ge.imrn1 .and. np.le.imrn2) then
c
c             Have a pure mineral.
c
              write (noutpt,1720) uphase(np),mophj(np),wophj(np),
     $        vophj(np)
 1720         format(1x,a24,2x,2(2x,1pe11.4),2x,1pe12.5,2x,1pe11.4)
            endif
          enddo
c
          do npe = 2,npet0
            np = iemop0(npe)
            ncount = ncount + 1
            if (np.ge.ixrn1 .and. np.le.ixrn2) then
c
c             Have a solid solution.
c
              write (noutpt,1730) uphase(np),mophj(np),wophj(np),
     $        vophj(np)
 1730         format(/1x,a24,2x,2(2x,1pe11.4),2x,1pe12.5,2x,1pe11.4)
              nr1 = ncmpe0(1,npe)
              nr2 = ncmpe0(2,npe)
              do nse = nr1,nr2
                ns = iemos0(nse)
                write (noutpt,1740) uspec(ns),mospj(ns),wospj(ns),
     $          vospj(ns)
 1740           format(3x,a24,2(2x,1pe11.4),2x,1pe12.5,2x,1pe11.4)
              enddo
            endif
          enddo
c
          do npe = 2,npet0
            np = iemop0(npe)
            ncount = ncount + 1
            if (np.ge.iern1 .and. np.le.iern2) then
c
c             Have a generic ion exchange phase.
c
              write (noutpt,1730) uphase(np),mophj(np),wophj(np),
     $        vophj(np)
              nr1 = ncmpe0(1,npe)
              nr2 = ncmpe0(2,npe)
              do nse = nr1,nr2
                ns = iemos0(nse)
                write (noutpt,1740) uspec(ns),mospj(ns),wospj(ns),
     $          vospj(ns)
              enddo
            endif
          enddo
c
          if (ncount .le. 0) write (noutpt,1650)
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1) .eq. 2) then
c
c       Print a summary of the solid phases in the ES and the PRS.
c
        write (noutpt,1800)
 1800   format(//12x,'--- Summary of Solid Phases (ES + PRS) ---')
        write (noutpt,1610)
c
        ncount = 0
        do np = 1,npt
          if (np .ne. iaqsln) then
            if (jpflag(np) .lt. 2) then
              if (mopht(np) .gt. 0.) then
                nr1 = ncmpr(1,np)
                nr2 = ncmpr(2,np)
                nt = nr2 - nr1 + 1
                mxx = mopht(np)
                lxx = tlg(mxx)
c
                if (nt .lt. 2) then
                  ncount = ncount + 1
                  write (noutpt,1620) uphase(np),lxx,mxx,wopht(np),
     $            vopht(np)
                else
                  if (ncount .gt. 0) write (noutpt,1630)
                  ncount = ncount + 1
                  write (noutpt,1620) uphase(np),lxx,mxx,
     $            wopht(np),vopht(np)
                  do ns = nr1,nr2
                    if (mospt(ns) .gt. 0.) then
                      mxx = mospt(ns)
                      lxx = tlg(mxx)
                      write (noutpt,1640) uspec(ns),lxx,mxx,wospt(ns),
     $                vospt(ns)
                    endif
                  enddo
                endif
c
              endif
            endif
          endif
        enddo
c
        if (ncount .le. 0) write (noutpt,1650)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((nmrt + nxrt + nert) .gt. 0) then
c
        write (noutpt,1810)
 1810   format(//12x,'--- Grand Summary of Solid Phases (ES + PRS',
     $  ' + Reactants) ---')
        write (noutpt,1610)
c
        ncount = 0
        do np = imrn1,imrn2
          qrct = .false.
          if (nmrt .gt. 0) then
            do nrc = 1,nrct
              if (jcode(nrc) .eq. 0) then
                np1 = nrndex(nrc)
                if (np1 .eq. np) then
                  qrct = .true.
                  go to 300
                endif
              endif
            enddo
          endif
c
  300     if (mophg(np).gt.0. .or. qrct) then
            ncount = ncount + 1
            ns = ncmpr(1,np)
            mxx = mophg(np)
            lxx = tlg(abs(mxx))
            write (noutpt,1620) uphase(np),lxx,mxx,wophg(np),
     $      vophg(np)
          endif
        enddo
c
        do np = ifrn1,ifrn2
          qrct = .false.
          if (nmrt .gt. 0) then
            do nrc = 1,nrct
              if (jcode(nrc) .eq. 0) then
                np1 = nrndex(nrc)
                if (np1 .eq. np) then
                  qrct = .true.
                  go to 310
                endif
              endif
            enddo
          endif
c
  310     if (mophg(np).gt.0. .or. qrct) then
            ncount = ncount + 1
            ns = ncmpr(1,np)
            mxx = mophg(np)
            lxx = tlg(abs(mxx))
            write (noutpt,1620) uphase(np),lxx,mxx,wophg(np),
     $      vophg(np)
          endif
        enddo
c
        if (iopt(4) .gt. 0) then
          do np = ixrn1,ixrn2
            if (jpflag(np) .lt. 2) then
              qrct = .false.
c
              if (nxrt .gt. 0) then
                do nrc = 1,nrct
                  if (jcode(nrc) .eq. 1) then
                    np1 = nrndex(nrc)
                    if (np1 .eq. np) then
                      qrct = .true.
                      go to 320
                    endif
                  endif
                enddo
              endif
c
  320         if (mophg(np).gt.0. .or. qrct) then
                if (ncount .gt. 0) write (noutpt,1630)
                ncount = ncount + 1
                mxx = mophg(np)
                lxx = tlg(abs(mxx))
                write (noutpt,1620) uphase(np),lxx,mxx,wophg(np),
     $          vophg(np)
                nr1 = ncmpr(1,np)
                nr2 = ncmpr(2,np)
                do ns = nr1,nr2
                  mxx = mospg(ns)
                  lxx = tlg(abs(mxx))
                  write (noutpt,1640) uspec(ns),lxx,mxx,
     $            wospg(ns),vospg(ns)
                enddo
              endif
c
            endif
          enddo
        endif
c
        do np = iern1,iern2
          if (jpflag(np) .lt. 2) then
            qrct = .false.
c
            if (nert .gt. 0) then
              do nrc = 1,nrct
                if (jcode(nrc) .eq. 5) then
                  np1 = nrndex(nrc)
                  if (np1 .eq. np) then
                    qrct = .true.
                    go to 330
                  endif
                endif
              enddo
            endif
c
  330       if (mophg(np).gt.0. .or. qrct) then
              if (ncount .gt. 0) write (noutpt,1630)
              ncount = ncount + 1
              mxx = mophg(np)
              lxx = tlg(abs(mxx))
              write (noutpt,1620) uphase(np),lxx,mxx,wophg(np),
     $        vophg(np)
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              do ns = nr1,nr2
                mxx = mospg(ns)
                if (mxx .gt. 0.) then
                  lxx = tlg(abs(mxx))
                  write (noutpt,1640) uspec(ns),lxx,mxx,
     $            wospg(ns),vospg(ns)
                endif
              enddo
            endif
c
          endif
        enddo
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1820) wosoct,vosoct,wodrt,vodrt,dwoso,dvoso
 1820 format(//26x,'Mass, grams',7x,'Volume, cm3',
     $ //11x,'Created  ',6x,1pe12.5,6x,e12.5,
     $ /11x,'Destroyed',6x,e12.5,6x,e12.5,
     $ /11x,'Net      ',6x,e12.5,6x,e12.5,
     $ //10x,'These volume totals may be incomplete because of missing',
     $ /10x,'partial molar volume data in the data base.',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qftpr2) then
        write (noutpt,1000)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print saturation index and affinity tables for reactions in
c     the aqueous phase not constrained to be at equilibrium. The
c     data correspond to the reactions and thermodynamic data in
c     the 'd' set.
c
      call prtsia(affsd,jflagd,jflgi,jsflag,narn1,narn2,nbasp,
     $ nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,nhydr,noutpt,nrdxsp,
     $ nstmax,sidrsp,uspec)
c
      if (iopr(7) .ge. 0) then
c
c       Print saturation index and affinity tables for the
c       various non-aqueous phases.
c
        call prtsat(affpd,iern1,iern2,ilrn1,ilrn2,imrn1,imrn2,
     $  iopr,iopt,ixrn1,ixrn2,jpflag,noutpt,noprmx,noptmx,nptmax,
     $  sidrph,tolsat,uphase)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(4) .gt. 0) then
c
c       Print tables of the compositions and affinities of solid
c       solution phases present in the equilbrium system (ES).
c
        write (noutpt,1900)
 1900   format(//11x,'--- Solid Solution Product Phases ---',/)
c
        ncount = 0
        do np = ixrn1,ixrn2
          if (jpflag(np) .eq. -1) then
            ncount = ncount + 1
            call prtsso(acflg,actlg,affpd,affsd,ixrn1,ixrn2,
     $      jsol,jsomax,ncmpr,noutpt,np,nptmax,nstmax,nxtmax,sidrph,
     $      sidrsp,tolsat,uspec,uphase,uxtype,xbar,xbarlg)
          endif
        enddo
        if (ncount .le. 0) write (noutpt,1910)
 1910   format(1x,'None')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Print tables of the compositions and affinities of generic
c       ion exchange phases present in the equilbrium system (ES).
c
        write (noutpt,1930)
 1930   format(//11x,'--- Generic Ion Exchange Phases ---',/)
c
        tolspf = tolsat
        ncount = 0
        do np = iern1,iern2
          ncount = ncount + 1
c
          call prtgex(acflg,actlg,affpd,affsd,cegexs,conc,
     $    egexjc,egexjf,egexpa,egexpc,egexs,egexw,iern1,iern2,ietmax,
     $    jern1,jern2,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $    mosp,netmax,ngexsa,ngext,noutpt,np,nptmax,nstmax,sidrph,
     $    sidrsp,tolspf,ugexj,ugexmo,uspec,uphase,xbar,xbarlg,xgexw,
     $    wkgwi)
c
        enddo
        if (ncount .le. 0) write (noutpt,1940)
 1940   format(1x,'None')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(8) .ge. 0) then
c
c       Print table of equilibrium fugacities.
c
        call prtfug(jgsort,fugac,fugalg,jsflag,ngrn1,ngt,ngtmax,
     $  noutpt,nstmax,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,2000)
 2000 format(/' - - - - - - - - - - - - - - - - - - - - - - - - -',
     $ ' - - - - - - -',//)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cabar(abar,azero,conc,jcsort,fxi,narn1,narn2,natmax,
     $ nstmax,zchsq2)
c
c     This subroutine calculates the average hard core diameter of
c     aqueous ionic species (abar). This average is defined
c     using "ionic strength weighting"; that is, the weighting factor
c     for each species is 1/2 the square of its electrical charge.
c     This thus excludes contributions from electrically neutral
c     solute species. This "abar" is used in empirical ion size
c     mixing models of the first-order Debye-Huckel contribution to
c     aqueous species activity coefficients.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       azero  = array of hard core diameters
c       conc   = array of species concentrations
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c       zchsq2 = array of z(i)**2/2 values
c
c     Principal output:
c
c       abar  = average ionic hard core diameter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nstmax
c
      integer jcsort(nstmax)
c
      integer narn1,narn2
c
      real*8 azero(natmax),conc(nstmax),zchsq2(nstmax)
      real*8 abar,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,nnn,ns,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,ns7,nval
c
      real*8 sx
c
c-----------------------------------------------------------------------
c
      abar = 0.
      if (fxi .le. 0.) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Logically, this could be represented by:
c
c       sx = 0.
c       do ns = narn1 + 1,narn2
c         na = ns - narn1 + 1
c         sx = sx + conc(ns)*zchsq2(ns)*azero(na)
c       enddo
c       abar = sx/fxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     In doing a sorted summation, a complication arises in that
c     water (ns = narn1) must be included in the range of the
c     loop, because the jcsort array is organized to contain the
c     species indices sorted according to increasing concentration
c     within phase ranges. There is no available sorting among
c     aqueous solute species only. Because the electrical charge
c     of water is zero, the calculation can be made looping from
c     narn1 to narn2. It is not necessary to temporarily set the
c     concentration of water (conc(narn1)) to zero. Note the use
c     of a local variable (sx) within the loop. Note also that the
c     loop is unrolled.
c
      sx = 0.
      nnn = narn1 - 1
      nval = narn2 - nnn
      ileft = (nval/8)*8 + nnn
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        ns1 = jcsort(nss + 1)
        ns2 = jcsort(nss + 2)
        ns3 = jcsort(nss + 3)
        ns4 = jcsort(nss + 4)
        ns5 = jcsort(nss + 5)
        ns6 = jcsort(nss + 6)
        ns7 = jcsort(nss + 7)
        sx = sx + conc(ns0)*zchsq2(ns0)*azero(ns0 - nnn)
     $          + conc(ns1)*zchsq2(ns1)*azero(ns1 - nnn)
     $          + conc(ns2)*zchsq2(ns2)*azero(ns2 - nnn)
     $          + conc(ns3)*zchsq2(ns3)*azero(ns3 - nnn)
     $          + conc(ns4)*zchsq2(ns4)*azero(ns4 - nnn)
     $          + conc(ns5)*zchsq2(ns5)*azero(ns5 - nnn)
     $          + conc(ns6)*zchsq2(ns6)*azero(ns6 - nnn)
     $          + conc(ns7)*zchsq2(ns7)*azero(ns7 - nnn)
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        sx = sx + conc(ns)*zchsq2(ns)*azero(ns - nnn)
      enddo
c
      abar = sx/fxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine indata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,
     $ adbdtv,adhfe,adhfsa,advfe,advfsa,amua,aprehw,apresg,
     $ apxa,aslma,atwta,axhfe,axhfsa,axlke,axlksa,axvfe,axvfsa,
     $ azeroa,bpxa,cco2,cdrsa,cessa,eps100,iapxa_asv,iapxta,
     $ iaqsla,ibpxa_asv,ibpxta,ielam,igas,ikta_asv,insgfa,ipbt_asv,
     $ ipch,ipch_asv,ipcv,ipcv_asv,ixrn1a,ixrn2a,jpdblo,jpfc_asv,
     $ jptffl,jsola,mwtspa,nad1,nalpaa,napa_asv,napta,narn1a,narn2a,
     $ narx_asv,narxt,nata,nata_asv,nbaspa,nbta,nbta_asv,nbtafd,
     $ nbta1_asv,ncmpra,ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsra,nessa,
     $ nessa_asv,nessra,ngrn1a,ngrn2a,ngta,ngta_asv,nlrn1a,nlrn2a,
     $ nlta,nlta_asv,nmrn1a,nmrn2a,nmta,nmta_asv,nmuta,nmuta_asv,
     $ nmuxa,noutpt,npta,npta_asv,nslta,nslta_asv,nslxa,nsta,
     $ nsta_asv,ntid_asv,ntitld,ntpr_asv,ntprt,nttyo,nxrn1a,nxrn2a,
     $ nxta,nxta_asv,qclnsa,palpaa,tdamax,tdamin,tempcu,ubasp,
     $ udakey,udatfi,uelema,uspeca,uphasa,uptypa,utitld,vosp0a,
     $ zchara)
c
c     This subroutine reads the supporting data file DATA1, starting
c     with its title. This subroutine should be called after subroutine
c     indath.f has been called to read the header section (which
c     mostly contains array size allocation data required to allocate
c     sufficient array space to store the data read by the present
c     subroutine.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       aadh   = array of polynomial coefficients for computing
c                  the Debye-Huckel A(gamma,10) parameter
c       aadhh  = array of polynomial coefficients for computing
c                  the Debye-Huckel A(H) parameter
c       aadhv  = array of polynomial coefficients for computing
c                  the Debye-Huckel A(V) parameter
c       aaphi  = array of polynomial coefficients for computing
c                  the Debye-Huckel A(phi) parameter
c       abdh   = array of polynomial coefficients for computing
c                  the Debye-Huckel B parameter
c       abdhh  = array of polynomial coefficients for computing
c                  the Debye-Huckel B(H) parameter
c       abdhv  = array of polynomial coefficients for computing
c                  the Debye-Huckel B(V) parameter
c       abdot  = array of polynomial coefficients for computing
c                  the Helgeson (1969) B-dot parameter
c       abdoth = array of polynomial coefficients for computing
c                  the B-dot(H) parameter
c       abdotv = array of polynomial coefficients for computing
c                  the B-dot(V) parameter
c       adadhh = array of polynomial coefficients for computing
c                  the the pressure derivatives of the Debye-Huckel
c                  A(H) parameter
c       adadhv = array of polynomial coefficients for computing
c                  the the pressure derivatives of the Debye-Huckel
c                  A(V) parameter
c       adbdhh = array of polynomial coefficients for computing
c                  the the pressure derivatives of the Debye-Huckel
c                  B(H) parameter
c       adbdhv = array of polynomial coefficients for computing
c                  the the pressure derivatives of the Debye-Huckel
c                  B(V) parameter
c       adbdth = array of polynomial coefficients for computing
c                  the the pressure derivatives of the B-dot(H)
c                  parameter
c       adbdtv = array of polynomial coefficients for computing
c                  the the pressure derivatives of the B-dot(V)
c                  parameter
c       adhfsa = array of polynomial coefficients for computing
c                  the pressure derivatives of the enthalpy of reaction
c                  for reactions read from the data file
c       adhfe  = array of polynomial coefficients for computing
c                  the pressure derivatives of the enthalpy of
c                  reaction for the "Eh" reaction
c       advfe  = array of polynomial coefficients for computing
c                  the pressure derivatives of the volume of
c                  reaction for the "Eh" reaction
c       advfsa = array of polynomial coefficients for computing
c                  the pressure derivatives of the volume of reaction
c                  for reactions read from the data file
c       amua   = coefficients for calculating Pitzer mu parameters
c                  as a function of temperature, read from the
c                  data file
c       aprehw = array of polynomial coefficients for computing
c                  the recommended pressure envelope half-width (bars)
c       apresg = array of polynomial coefficients for computing
c                  the pressure (bars) on the 1-atm:steam saturation
c                  curve
c       apxa   = array of interaction coefficients for computing
c                   activity coefficients in solid solutions
c       aslm   = coefficients for calculating Pitzer S-lambda(n)
c                  parameters as a function of temperature, read
c                  read from the data file
c       atwta  = array of atomic weights of the elements read from
c                  the data file
c       axhfe  = array of polynomial coefficients for computing
c                  the enthalpy of reaction for the "Eh" reaction
c       axhfsa = array of polynomial coefficients for computing
c                  the enthalpy of reaction for reactions read
c                  from the data file
c       axlke  = array of polynomial coefficients for computing
c                  the log K for the "Eh" reaction
c       axlksa = array of polynomial coefficients for computing
c                  the log K functions of reactions read from the
c                  data file
c       axvfe  = array of polynomial coefficients for computing
c                  the volume of reaction for the "Eh" reaction
c       axvfsa = array of polynomial coefficients for computing
c                  the volume of reaction for reactions read
c                  from the data file
c       azeroa = array of hard core diameters of the species read
c                  from the data file
c       bpxa   = array of site-mixing parameters for computing activity
c                  coefficients in solid solutions
c       cco2   = array of coefficients for computing the activity
c                  coefficient of CO2(aq) from the Drummond (1981)
c                  equation
c       cdrsa  = array of reaction coefficients for the reactions
c                  read from the data file
c       cessa  = array of elemental composition coefficients for the
c                  species read from the data file
c       iapxta = array of the numbers of non-zero interaction
c                  coefficients for computing activity coefficients in
c                  solid solutions
c       iaqsla = index of the aqueous solution phase, as read from
c                  the data file
c       ibpxta = array of the numbers of non-zero site-mixing
c                  paramters for computing activity coefficients in
c                  solid solutions
c       ielam  = flag indicating no use or use of E-lambda terms
c       igas   = index of the gas phase
c       insgfa = array of flags for treating the activity coefficients
c                  of species that happen to be electrically neutral,
c                  as read from the data file
c       ixrn1a = index of the first non-aqueous solution phase,
c                  as read from the data file
c       ixrn2a = index of the last non-aqueous solution phase,
c                  as read from the data file
c       jpdblo = Pitzer data block organization flag
c       jptffl = Pitzer parameter temperature function flag
c       jsola  = array of flags for the activity coefficient models
c                  to use for solid solutions, as read from the
c                  data file
c       mwtspa = array of the molecular weights of the species read
c                  from the data file
c       nalpaa = pointer array giving the index of the set of alpha
c                  coeffcients for a given set of S-lambda
c                  coefficients, as read from the data file
c       narn1a = start of the range of aqueous species, as read from
c                  the data file
c       narn1a = end of the range of aqueous species, as read from
c                  the data file
c       nbaspa = array of indices of species in basis set, as read
c                  from the data file
c       ncmpra = array giving the start and the end of the range of the
c                  species belonging to a given phase, as read from the
c                  data file
c       ndrsa  = array of indices of the species corresponding to
c                  the reaction coefficients in the cdrsa array
c       ndrsra = array giving the start and end of the range in the
c                  cdrsa and ndrsa arrays of the species in the reaction
c                  which belongs to a given species
c       nessa  = array of indices of the chemical elements
c                  corresponding to the composition coefficients in
c                  the cessa array
c       nessra = array giving the start and end of the range in the
c                  cessa and nessa arrays of the chemical elements
c                  comprising a given species
c       ngrn1a = index of the first species in the gas range, as read
c                  from the data file
c       ngrn2a = index of the last species in the gas range, as read
c                  from the data file
c       nlrn1a = index of the first species in the pure liquid range,
c                  as read from the data file
c       nlrn2a = index of the last species in the pure liquid range,
c                  as read from the data file
c       nmrn1a = index of the first species in the pure mineral range,
c                  as read from the data file
c       nmrn2a = index of the last species in the pure mineral range,
c                  as read from the data file
c       nmuta  = the number of species triplets for which mu
c                  coefficients are defined, as read from the data file
c       nmuxa  = indices of species in triplets for which mu
c                  coefficients are defined, as read from the data file
c       nslta  = number of species pairs for which S-lambda
c                  coefficients are defined, as read from the data file
c       nslxa  = indices of species in pairs for which S-lambda
c                  coefficients are defined, as read from the data file
c       nxrn1a = index of the first species in the solid solution range,
c                  as read from the data file
c       nxrn2a = index of the last species in the solid solution range,
c                  as read from the data file
c       palpaa = array of sets of alpha coefficients read from the
c                  data file
c       qclnsa = array of flags indicating if a species was created
c                  by cloning
c       tdamax = the nominal upper temperature limit of the data file
c       tdamin = the nominal lower temperature limit of the data file
c       ubasp  = array of names of the species in the basis set
c       uelema = array of names of the chemical elements read from
c                  the data file
c       uphasa = array of names of phases read from the data file
c       uptypa = array giving the type of a given phase (e.g.,
c                  liquid, solid, gas) read from the data file
c       uspeca = array of names of species read from the data file
c       utitld = the title read from the data file
c       vosp0a = array of standard state molar volumes of the species
c                  read from the data file
c       zchara = array of electrical charge numbers of the species
c                  read from the data file
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxa_asv,ibpxa_asv,ikta_asv,ipbt_asv,ipch_asv,ipcv_asv,
     $ jpfc_asv,napa_asv,narx_asv,nata_asv,nbta_asv,nbta1_asv,ncta_asv,
     $ ndrsa_asv,nessa_asv,ngta_asv,nlta_asv,nmta_asv,nmuta_asv,
     $ npta_asv,nslta_asv,nsta_asv,ntid_asv,ntpr_asv,nxta_asv
c
      integer nad1,noutpt,nttyo
c
      integer iapxta(nxta_asv),ibpxta(nxta_asv),insgfa(nata_asv),
     $ jsola(nxta_asv),nalpaa(nslta_asv),narxt(ntpr_asv),
     $ nbaspa(nbta_asv),ncmpra(2,npta_asv),ndrsa(ndrsa_asv),
     $ ndrsra(2,nsta_asv),nessa(nessa_asv),nessra(2,nsta_asv),
     $ nmuxa(3,nmuta_asv),nslxa(2,nslta_asv)
c
      integer iaqsla,ielam,igas,ipch,ipcv,ixrn1a,ixrn2a,jpdblo,jptffl,
     $ napta,narn1a,narn2a,nata,nbta,nbtafd,ncta,ngrn1a,ngrn2a,ngta,
     $ nlrn1a,nlrn2a,nlta,nmrn1a,nmrn2a,nmta,nmuta,npta,nslta,nsta,
     $ ntitld,ntprt,nxrn1a,nxrn2a,nxta
c
      logical qclnsa(nsta_asv)
c
      character(len=8) uelema(ncta_asv)
      character(len=24) uphasa(npta_asv),uptypa(npta_asv)
      character(len=48) ubasp(nbta_asv),uspeca(nsta_asv)
      character(len=80) utitld(ntid_asv)
c
      character(len=8) udakey,udatfi
c
      real(8) tempcu(ntpr_asv)
c
      real(8) aadh(narx_asv,ntpr_asv),aadhh(narx_asv,ntpr_asv),
     $ aadhv(narx_asv,ntpr_asv),aaphi(narx_asv,ntpr_asv),
     $ abdh(narx_asv,ntpr_asv),abdhh(narx_asv,ntpr_asv),
     $ abdhv(narx_asv,ntpr_asv),abdot(narx_asv,ntpr_asv),
     $ abdoth(narx_asv,ntpr_asv),abdotv(narx_asv,ntpr_asv),
     $ adadhh(narx_asv,ntpr_asv,ipch_asv),
     $ adadhv(narx_asv,ntpr_asv,ipcv_asv),
     $ adbdhh(narx_asv,ntpr_asv,ipch_asv),
     $ adbdhv(narx_asv,ntpr_asv,ipcv_asv),
     $ adbdth(narx_asv,ntpr_asv,ipch_asv),
     $ adbdtv(narx_asv,ntpr_asv,ipcv_asv),
     $ adhfe(narx_asv,ntpr_asv,ipch_asv),
     $ advfe(narx_asv,ntpr_asv,ipcv_asv),
     $ adhfsa(narx_asv,ntpr_asv,ipch_asv,nsta_asv),
     $ advfsa(narx_asv,ntpr_asv,ipcv_asv,nsta_asv),
     $ aprehw(narx_asv,ntpr_asv),apresg(narx_asv,ntpr_asv),
     $ apxa(iapxa_asv,nxta_asv),atwta(ncta_asv),
     $ axhfe(narx_asv,ntpr_asv),axhfsa(narx_asv,ntpr_asv,nsta_asv),
     $ axlke(narx_asv,ntpr_asv),axlksa(narx_asv,ntpr_asv,nsta_asv),
     $ axvfe(narx_asv,ntpr_asv),axvfsa(narx_asv,ntpr_asv,nsta_asv)
c
      real(8) amua(jpfc_asv,nmuta_asv),
     $ aslma(jpfc_asv,0:ipbt_asv,nslta_asv),azeroa(nata_asv),
     $ bpxa(ibpxa_asv,nxta_asv),cco2(5),cdrsa(ndrsa_asv),
     $ cessa(nessa_asv),mwtspa(nsta_asv),palpaa(ipbt_asv,napa_asv),
     $ vosp0a(nsta_asv),zchara(nsta_asv)
c
      real(8) eps100
c
      real(8) tdamax,tdamin
c
c-----------------------------------------------------------------------
c
c     Local variables with global dimensioning.
c     None of these variables need to be SAVEd.
c
      character(len=24), dimension(:), allocatable :: udrsv
      character(len=8), dimension(:), allocatable :: uessv
c
      real(8), dimension(:), allocatable :: cdrsv,cessv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ipc,j2,j3,n,nc,ndrsn,nerr,nessn,nmax,nn,np,ns,nsc,
     $ ntpr,nwatra
c
      integer ilnobl
c
      logical qx
c
      character(len=80) ux80
      character(len=56) ux56
      character(len=24) uphasv,uwater,uaqsln,uptsld,uptliq,uptgas,
     $ usblkf,ux24
      character(len=8) uendit,usedh,upitz,ustr,ustr2,ustr3,uterm
c
c-----------------------------------------------------------------------
c
      data uwater /'H2O                     '/
      data uaqsln /'Aqueous solution        '/
      data uptsld /'Solid                   '/
      data uptliq /'Liquid                  '/
      data uptgas /'Gas                     '/
c
      data uendit /'endit.  '/,uterm  /'+-------'/,
     $     usedh  /'SEDH    '/,upitz  /'Pitzer  '/
c
c-----------------------------------------------------------------------
c
c     Allocate scratch arrays.
c
      ALLOCATE(cessv(ncta_asv))
      ALLOCATE(uessv(ncta_asv))
c
      ALLOCATE(cdrsv(nbta1_asv))
      ALLOCATE(udrsv(nbta1_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero some arrays.
c
      nmax = nbta_asv
      call initiz(nbaspa,nmax)
c
      nmax = ndrsa_asv
      call initiz(ndrsa,nmax)
      call initaz(cdrsa,nmax)
c
      nmax = nsta_asv
      call initaz(vosp0a,nmax)
c
      nmax = 2*nsta_asv
      call initiz(ndrsra,nmax)
c
      nmax = narx_asv*ntpr_asv*nsta_asv
      call initaz(axhfsa,nmax)
      call initaz(axlksa,nmax)
      call initaz(axvfsa,nmax)
c
c     SEDH arrays.
c
      nmax = nata_asv
      call initaz(azeroa,nmax)
      call initiz(insgfa,nmax)
c
c     Pitzer arrays.
c
      nmax = ipbt_asv*napa_asv
      call initaz(palpaa,nmax)
      nmax = jpfc_asv*(ipbt_asv + 1)*nslta_asv
      call initaz(aslma,nmax)
      nmax = jpfc_asv*nmuta_asv
      call initaz(amua,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Don't rewind the DATA1 file (nad1). It should be positioned
c     properly by the preceding call to subroutine indath.f.
c
      write (noutpt,1000)
      write (nttyo,1000)
 1000 format(/' Reading the rest of the DATA1 file ...')
c
c     Initialize the error counter.
c
      nerr = 0
c
c     Set the number of elements on the data file. This equal to
c     the dimensioned limit. Note that nbta, the number of basis
c     species, is determined in this subroutine as it is not usually
c     equal to the corresponding dimensioned limit nbta_asv.
c     In fact, nbta as returned by the subroutine may be subsequently
c     increased due to "promotions" implied by the contents of the
c     input file.
c
      ncta = ncta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the data file title.
c
      ntitld = 0
      do n = 1,ntid_asv
        read (nad1) utitld(n)
        ntitld = ntitld + 1
        if (utitld(n)(1:8) .eq. uterm(1:8)) go to 140
      enddo
  140 continue
c
c     Write the first 5 lines of the data file title to the screen
c     file.
c
      write (nttyo,1060)
 1060 format(/3x,'The data file title is (first 5 lines maximum):',/)
c
      nn = min(ntitld,5)
      do n = 1,nn
        if (utitld(n)(1:8) .eq. uterm(1:8)) go to 150
        j2 = ilnobl(utitld(n))
        j2 = min(j2,74)
        write (nttyo,1070) utitld(n)(1:j2)
 1070   format(5x,a)
      enddo
  150 continue
c
c     Write the complete data file title, less terminator, if any,
c     to the output file.
c
      write (noutpt,1080)
 1080 format(/3x,'The data file title is:',/)
c
      do n = 1,ntitld
        if (utitld(n)(1:8) .eq. uterm(1:8)) go to 160
        j2 = ilnobl(utitld(n))
        j2 = min(j2,74)
        write (noutpt,1070) utitld(n)(1:j2)
      enddo
  160 continue
c
c     Search the data file title for the usual identifying three-letter
c     keystring (e.g., com, hmw, etc.).
c
      udatfi = 'current'
      do n = 1,ntitld
        ux80 = utitld(n)
        call lejust(ux80)
        if (ux80(1:6) .eq. 'data0.') then
          udatfi = ux80(7:9)
          go to 170
        endif
      enddo
  170 continue
c
      write (noutpt,1090)
      write (nttyo,1090)
 1090 format(/3x,'Continuing to read the DATA1 file ...')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the actual number of temperature ranges in the temperature
c     grid.
c
      read (nad1) ux56
      read (nad1) ntprt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the actual number of coefficients in each range.
c
      do ntpr = 1,ntprt
        read (nad1) ux56
        read (nad1) narxt(ntpr)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read a flag indicating the degree of representation of enthalpy
c     functions.
c
      read (nad1) ux56
      read (nad1) ipch
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read a flag indicating the degree of representation of volume
c     functions.
c
      read (nad1) ux56
      read (nad1) ipcv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .eq. upitz(1:8)) then
c
c       Read the Pitzer data block organization flag.
c
        read (nad1) ux56
        read (nad1) jpdblo
c
c       Read the Pitzer parameter temperature function flag.
c
        read (nad1) ux56
        read (nad1) jptffl
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read chemical elements data.
c
      read (nad1) ux24
c
      do nc = 1,ncta
        read (nad1) uelema(nc),atwta(nc)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read nominal temperature limits (Celsius) for the data file.
c
      read (nad1) ux56
      read (nad1) tdamin,tdamax
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the maximum temperatures (tempcu) of the temperature ranges.
c     These are used to find the temperature range flag (ntpr) for any
c     specified temperature (see EQLIB/gntpr.f).
c
      read (nad1) ux56
      do n = 1,ntprt
        read (nad1) tempcu(n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read interpolating polynomial coefficients for computing the
c     standard grid pressure (bars) as a function of temperature
c     (Celsius). Often this grid corresponds to 1.013 bar up to 100C
c     and the steam-liquid water saturation pressure at higher
c     temperatures.
c
c     Calling sequence substitutions:
c       apresg for arr
c
      call indatc(apresg,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipcv .ge. 0) then
c
c       Read interpolating polynomial coefficients for computing the
c       recommended pressure envelope half width (bars).
c
c       Calling sequence substitutions:
c         aprehw for arr
c
       call indatc(aprehw,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .eq. usedh(1:8)) then
c
c       The aqeuous species activity coefficient formalism is
c       consistent with the B-dot equation, the Davies equation,
c       or similar equations.
c
c       Read interpolating polynomial coefficients for the Debye-Huckel
c       A(gamma,10) parameter and related parameters.
c
c       Calling sequence substitutions:
c         aadh for arr
c
        call indatc(aadh,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        if (ipch .ge. 0) then
c
c         Calling sequence substitutions:
c           aadhh for arr
c
          call indatc(aadhh,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipch
c
c           Calling sequence substitutions:
c             adadhh for arr
c             ipch_asv for ipcx_asv
c
            call indatd(adadhh,ipc,ipch_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Calling sequence substitutions:
c           aadhv for arr
c
          call indatc(aadhv,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipcv
c
c           Calling sequence substitutions:
c             adadhv for arr
c             ipcv_asv for ipcx_asv
c
            call indatd(adadhv,ipc,ipcv_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
c       Read interpolating polynomial coefficients for the Debye-Huckel
c       B(gamma) and related parameters.
c
c       Calling sequence substitutions:
c         abdh for arr
c
        call indatc(abdh,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        if (ipch .ge. 0) then
c
c         Calling sequence substitutions:
c           abdhh for arr
c
          call indatc(abdhh,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipch
c
c           Calling sequence substitutions:
c             adbdhh for arr
c             ipch_asv for ipcx_asv
c
            call indatd(adbdhh,ipc,ipch_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Calling sequence substitutions:
c           abdhv for arr
c
          call indatc(abdhv,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipcv
c
c           Calling sequence substitutions:
c             adbdhv for arr
c             ipcv_asv for ipcx_asv
c
            call indatd(adbdhv,ipc,ipcv_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
c       Read interpolating polynomial coefficients for the B-dot
c       parameter and related parameters.
c
c       Calling sequence substitutions:
c         abdot for arr
c
        call indatc(abdot,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        if (ipch .ge. 0) then
c
c         Calling sequence substitutions:
c           abdoth for arr
c
          call indatc(abdoth,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipch
c
c           Calling sequence substitutions:
c             adbdth for arr
c             ipch_asv for ipcx_asv
c
            call indatd(adbdth,ipc,ipch_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Calling sequence substitutions:
c           abdotv for arr
c
          call indatc(abdotv,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipcv
c
c           Calling sequence substitutions:
c             adbdtv for arr
c             ipcv_asv for ipcx_asv
c
            call indatd(adbdtv,ipc,ipcv_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
c       Read coefficients for the Drummond (1981) equation.
c       This equation represents the activity coeficient
c       of CO2(aq) as a function of temperature and ionic
c       strength in sodium chloride solutions.
c
        read (nad1) ux24
        read (nad1) (cco2(n), n = 1,5)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .eq. upitz(1:8)) then
c
c       The aqeuous species activity coefficient formalism is
c       consistent with Pitzer's equations. Read interpolating
c       polynomial coefficients for Debye-Huckel A(phi) and
c       related parameters.
c
c       Calling sequence substitutions:
c         aaphi for arr
c
        call indatc(aaphi,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        if (ipch .ge. 0) then
c
c         Calling sequence substitutions:
c           aadhh for arr
c
          call indatc(aadhh,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipch
c
c           Calling sequence substitutions:
c             adadhh for arr
c             ipch_asv for ipcx_asv
c
            call indatd(adadhh,ipc,ipch_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Calling sequence substitutions:
c           aadhv for arr
c
          call indatc(aadhv,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
          do ipc = 1,ipcv
c
c           Calling sequence substitutions:
c             adadhv for arr
c             ipcv_asv for ipcx_asv
c
            call indatd(adadhv,ipc,ipcv_asv,nad1,narxt,narx_asv,ntprt,
     $      ntpr_asv,ux24)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read interpolating polynomial coefficients for the log K of
c     the "Eh" reaction:
c
c       2 H2O(l) = 2 O2(g) + 4 H+ + 4 e-
c
c     Calling sequence substitutions:
c       axlke for arr
c
      call indatc(axlke,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
      if (ipch .ge. 0) then
c
c       Calling sequence substitutions:
c         axhfe for arr
c
        call indatc(axhfe,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        do ipc = 1,ipch
c
c         Calling sequence substitutions:
c           adhfe for arr
c           ipch_asv for ipcx_asv
c
          call indatd(adhfe,ipc,ipch_asv,nad1,narxt,narx_asv,ntprt,
     $    ntpr_asv,ux24)
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Calling sequence substitutions:
c         axvfe for arr
c
        call indatc(axvfe,nad1,narx_asv,narxt,ntpr_asv,ntprt,ux24)
c
        do ipc = 1,ipcv
c
c         Calling sequence substitutions:
c           advfe for arr
c           ipcv_asv for ipcx_asv
c
          call indatd(advfe,ipc,ipcv_asv,nad1,narxt,narx_asv,ntprt,
     $    ntpr_asv,ux24)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the phases and species and assocated data from the
c     data file. The following variables are used as counters:
c
c       np     = phase index
c       ns     = species index
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the qclnsa array to .false.
c
      qx = .false.
c
      call initlv(qclnsa,nsta_asv,qx)
c
c     Initialize the following variables, all of which are used
c     below as counters.
c
c       nessn  = counter for the cessa and nessa arrays
c       ndrsn  = counter for the cdrsa and ndrsa arrays
c       ns     = species index
c       nbta   = number of basis species
c       nata   = number of aqueous species
c       ngta   = number of gas species
c       nmta   = number of pure mineral species
c       nlta   = number of pure liquid species
c       nxta   = number of solid solution phases
c
      nessn = 0
      ndrsn = 0
      ns = 0
      nbta = 0
      nata = 0
      ngta = 0
      nmta = 0
      nlta = 0
      nxta = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the aqueous species superblock. Set up the aqueous
c     solution as the first phase.
c
      np = 1
      uphasv(1:24) = uaqsln(1:24)
      iaqsla = np
      uphasa(np)(1:24) = uphasv(1:24)
      uptypa(np)(1:24) = uaqsln(1:24)
      usblkf(1:24) = uaqsln(1:24)
      ncmpra(1,1) = 1
      narn1a = 1
c
c     Read the superblock header.
c
      read (nad1) ustr,ustr2,ustr3
c
c     Read the blocks in the current superblock.
c
      call indats(adhfsa,advfsa,axhfsa,axlksa,axvfsa,cdrsa,cdrsv,
     $ cessa,cessv,ipch,ipch_asv,ipcv,ipcv_asv,mwtspa,nad1,narxt,
     $ narx_asv,nata,nata_asv,nbta,nbta_asv,nbta1_asv,nbtafd,ncmpra,
     $ ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,
     $ nessn,nessra,ngta,ngta_asv,nlta,nlta_asv,nmta,nmta_asv,noutpt,
     $ np,npta_asv,ns,nsta_asv,ntprt,ntpr_asv,nttyo,uaqsln,ubasp,udrsv,
     $ uelema,uendit,uessv,uphasa,uphasv,uptgas,uptliq,uptsld,uptypa,
     $ usblkf,uspeca,vosp0a,zchara)
c
      ncmpra(2,np) = ns
      narn2a = ns
c
c     Check to see that water is the first species in the phase
c     "aqueous solution". This is required so that all solute species
c     can be cleanly referenced in simple loop; that is, in a loop of
c     the form "do ns = narn1a + 1,narn2a".
c
      nwatra = 0
      if (uspeca(narn1a)(1:24) .eq. uwater(1:24)) nwatra = 1
c
      if (nwatra .eq. 0) then
        j3 = ilnobl(uwater)
        write (noutpt,1150) uwater(1:j3),uaqsln(1:j2)
        write (nttyo,1150) uwater(1:j3),uaqsln(1:j2)
 1150   format(/' * Error - (EQLIB/indata) The species ',
     $  /7x,a,' (',a,') must be listed on the',
     $  /7x,'data file as the first species in its phase.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the pure minerals superblock. Each pure mineral is both
c     a species and a phase. The phase name variable uphasv will be set
c     to the name of each mineral as its block is read.
c
      usblkf(1:24) = uptsld(1:24)
      nmrn1a = ns + 1
c
c     Read the superblock header.
c
      read (nad1) ustr,ustr2,ustr3
c
c     Read the blocks in the current superblock.
c
      call indats(adhfsa,advfsa,axhfsa,axlksa,axvfsa,cdrsa,cdrsv,
     $ cessa,cessv,ipch,ipch_asv,ipcv,ipcv_asv,mwtspa,nad1,narxt,
     $ narx_asv,nata,nata_asv,nbta,nbta_asv,nbta1_asv,nbtafd,ncmpra,
     $ ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,
     $ nessn,nessra,ngta,ngta_asv,nlta,nlta_asv,nmta,nmta_asv,noutpt,
     $ np,npta_asv,ns,nsta_asv,ntprt,ntpr_asv,nttyo,uaqsln,ubasp,udrsv,
     $ uelema,uendit,uessv,uphasa,uphasv,uptgas,uptliq,uptsld,uptypa,
     $ usblkf,uspeca,vosp0a,zchara)
c
      nmrn2a = ns
      if (nmrn2a .le. narn2a) nmrn1a = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     There is presently no superblock corresponding to pure liquids.
c     Set up water as a pure liquid.
c
      usblkf(1:24) = uptliq(1:24)
      nlrn1a = 0
      nlrn2a = 0
      nlta = 0
c
      if (nwatra .gt. 0) then
        np = np + 1
        ns = ns + 1
        uphasv(1:24) = uspeca(nwatra)(1:24)
        uphasa(np)(1:24) = uphasv(1:24)
        uptypa(np)(1:24) = uptliq(1:24)
        ncmpra(1,np) = ns
        ncmpra(2,np) = ns
        nsc = 1
        call clones(axlksa,cdrsa,cessa,mwtspa,narx_asv,
     $  ndrsa,ndrsa_asv,ndrsn,ndrsra,nessa,nessa_asv,nessn,
     $  nessra,np,npta_asv,ns,nsc,nsta_asv,ntpr_asv,uphasa,
     $  uspeca,zchara)
        qclnsa(ns) = .true.
        nlrn1a = ns
        nlrn2a = ns
        nlta = 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the gas species superblock. Set up the gas phase
c     as the next phase.
c
      uphasv(1:24) = uptgas(1:24)
      usblkf(1:24) = uptgas(1:24)
      np = np + 1
      igas = np
      uphasa(np)(1:24) = uphasv(1:24)
      uptypa(np)(1:24) = uptgas(1:24)
      ncmpra(1,np) = ns + 1
      ngrn1a = ns + 1
c
c     Read the superblock header.
c
      read (nad1) ustr,ustr2,ustr3
c
c     Read the blocks in the current superblock.
c
      call indats(adhfsa,advfsa,axhfsa,axlksa,axvfsa,cdrsa,cdrsv,
     $ cessa,cessv,ipch,ipch_asv,ipcv,ipcv_asv,mwtspa,nad1,narxt,
     $ narx_asv,nata,nata_asv,nbta,nbta_asv,nbta1_asv,nbtafd,ncmpra,
     $ ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,
     $ nessn,nessra,ngta,ngta_asv,nlta,nlta_asv,nmta,nmta_asv,noutpt,
     $ np,npta_asv,ns,nsta_asv,ntprt,ntpr_asv,nttyo,uaqsln,ubasp,udrsv,
     $ uelema,uendit,uessv,uphasa,uphasv,uptgas,uptliq,uptsld,uptypa,
     $ usblkf,uspeca,vosp0a,zchara)
c
      ngrn2a = ns
      if (ngrn2a .le. nlrn2a) ngrn1a = 0
      ncmpra(2,np) = ns
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the solid solution superblock.
c
      read (nad1) ustr,ustr2,ustr3
      nxrn1a = ns + 1
      ixrn1a = np + 1
c
      call indatp(apxa,axlksa,bpxa,cdrsa,cessa,iapxa_asv,iapxta,
     $ ibpxa_asv,ibpxta,ikta_asv,jsola,mwtspa,nad1,narx_asv,ncmpra,
     $ ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,nessn,
     $ nessra,nmrn1a,nmrn2a,noutpt,np,npta_asv,ns,nsta_asv,ntpr_asv,
     $ nttyo,nxta,nxta_asv,qclnsa,uendit,uspeca,uphasa,uptsld,
     $ uptypa,zchara)
c
      npta = np
      nsta = ns
      nxrn2a = ns
      ixrn2a = np
      if (nxrn2a .le. nlrn2a) then
        nxrn1a = 0
        nxrn2a = 0
        ixrn1a = 0
        ixrn2a = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the nbaspa array and expand the elements of the ubasp array
c     to the full 48 characters. Convert basis species indices in the
c     ndrsa array to species indices.
c
      call dfbasp(nbaspa,nbta,nbta_asv,ndrsa,ndrsa_asv,ndrsra,
     $ nerr,noutpt,nsta,nsta_asv,nttyo,ubasp,uspeca)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .eq. usedh(1:8)) then
c
c       The aqeuous species activity coefficient formalism is
c       consistent with the B-dot equation, the Davies equation,
c       or similar equations. Read the appropriate data for
c       this formalism.
c
        call inbdot(azeroa,insgfa,nad1,narn1a,narn2a,nata,
     $  nata_asv,nerr,noutpt,nsta_asv,nttyo,uspeca)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .eq. upitz(1:8)) then
c
c       The aqeuous species activity coefficient formalism is
c       consistent with Pitzer's equations. Read the appropriate
c       data for this formalism.
c
        call inupt(amua,aslma,ielam,ipbt_asv,jpdblo,jpfc_asv,
     $  nad1,nalpaa,napa_asv,napta,narn1a,narn2a,nerr,nmuta,
     $  nmuta_asv,nmuxa,noutpt,nslta,nslta_asv,nslxa,nsta_asv,
     $  nttyo,palpaa,uspeca,zchara)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a bit of nonsense so compiler warnings will
c     not be generated saying that ux80, ustr, ustr2, and ustr3 are
c     not used (they are all used to read unused data).
c
      ux80(1:56) = ux56
      ustr3 = ux80(1:8)
      ustr = ustr2
      ustr2 = ustr3
      ustr3 = ustr
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate the scratch arrays used by calls to EQLIB/indats.f.
c
      DEALLOCATE(cessv)
      DEALLOCATE(uessv)
c
      DEALLOCATE(cdrsv)
      DEALLOCATE(udrsv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
      write (noutpt,1200)
      write (nttyo,1200)
 1200 format(/'   Done reading the DATA1 file.')
c
      end

      subroutine rd6inw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $ csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $ dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $ iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $ iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $ jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $ ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $ mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $ nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $ nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $ nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $ nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $ nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $ phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $ rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $ toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $ uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $ uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $ uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $ xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
c
c     This subroutine reads the EQ6 input file in compact ("W") format.
c
c     This subroutine is a near-clone of XCON6/rd6w8.f. The present
c     subroutine differs from the latter, in that in addition to the
c     pure read function, it writes an instant echo of what is read to
c     the output file, and sandwiches this between prefatory and
c     ending messages. To maintain close consistency with XCON6/rd6w8.f,
c     this subroutine assigns no default values and only performs such
c     checking of what is read to ensure that what follows is readable.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ6/rd6ind.f, XCON6/rd6w8.f, and XCON6/rd6d8.f.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ninpts = unit number of the stripped input file
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       qrderr = flag denoting a read error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,imchmx,jetmax,kmax,nbtmax,nbt1mx,nctmax,
     $ ndctmx,nertmx,netmax,nffgmx,nodbmx,nopgmx,noprmx,noptmx,nordmx,
     $ nprpmx,nprsmx,nptkmx,nrctmx,nsrtmx,ntitmx,nttkmx,nxmdmx,nxopmx,
     $ nxpemx,nxrtmx
c
      integer ninpts,noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),
     $ igerti(jetmax,nertmx),iesrti(nsrtmx),imech(2,nrctmx),
     $ iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ ixrti(nxrtmx),jcode(nrctmx),jflgi(nbtmax),jgerti(nertmx),
     $ jgext(netmax),jreac(nrctmx),kxmod(nxmdmx),ndact(imchmx,2,nrctmx),
     $ ngexrt(jetmax,netmax),nrk(2,nrctmx),nsk(nrctmx)
c
      integer itermx,jpress,jtemp,kbt,kct,kdim,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxt,nbti,nffg,nert,net,nobswt,nprob,nprpti,nprsti,nrct,
     $ nsbswt,nsrt,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt,nxrt
c
      logical qend,qgexsh,qrderr
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ubmtbi(nbtmax),uobsw(2,nbtmax),uprspi(nprsmx),
     $ usbsw(2,nbtmax),uxmod(nxmdmx),uzveci(kmax)
      character*24 ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),ugermo(nertmx),
     $ ugersi(ietmax,jetmax,nertmx),ugexmo(netmax),ugexp(netmax),
     $ uprphi(nprpmx),ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character*8 uesri(nctmax,nsrtmx),ugerji(jetmax,nertmx),
     $ ugexj(jetmax,netmax),uhfgex(ietmax,jetmax,netmax),
     $ uvfgex(ietmax,jetmax,netmax),uxkgex(ietmax,jetmax,netmax),
     $ uxopt(nxopmx)
c
      real*8 cbsri(nbt1mx,nsrtmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ cesri(nctmax,nsrtmx),cgexj(jetmax,netmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),
     $ egersi(ietmax,jetmax,nertmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprphi(nprpmx),mprspi(nprsmx),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),ptk(nptkmx),rkb(imchmx,2,nrctmx),
     $ rxbari(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),tgexp(netmax),
     $ trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),
     $ xgersi(ietmax,jetmax,nertmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkffg(nffgmx),xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zvclgi(kmax),zgexj(jetmax,netmax)
c
      real*8 awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,electr,o2maxi,o2mini,phmaxi,
     $ phmini,pressb,pressi,tempcb,tempci,timmxi,tistti,tolbt,toldl,
     $ tolsat,tolxsf,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iki,ikti,je,jei,jeti,jj,j2,j3,j4,kcol,krow,n,nbi,nci,
     $ ne,nei,ner,neti,nn,npi,nrc
c
      integer ilnobl
c
      character*80 uline
      character*24 uxf,uxg,uxs
      character*8 uendit,uxe,ux8
c
      real*8 mx,xx
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     qend   = .true if the end of the input file has been encountered
c     qrderr = .true if the current problem can't be read because of
c                a read format error or a dimensional overflow
c
      qend = .false.
      qrderr = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Main title.
c
c       utitl1 = main title
c       ntitl1 = number of lines in the main title
c
c     Note: if there are exactly ntitpa lines in the title, the title
c     need not be terminated by an 'endit.'. The 'endit.' if present
c     is here not considered to be part of the title.
c
      ntitl1 = 0
      read (ninpts,1000,end=100,err=990) uline
 1000 format(a80)
      go to 110
c
  100 qend = .true.
      go to 999
c
  110 write (noutpt,1010) nprob
      write (nttyo,1010) nprob
 1010 format(//' Reading problem ',i3,' from the input file ...',/)
c
      j2 = ilnobl(uline)
      j2 = min(j2,79)
      write (noutpt,1020) uline
 1020 format(1x,a)
c
      if (uline(1:8) .ne. uendit(1:8)) then
        ntitl1 = 1
        utitl1(1) = uline
      endif
c
      if (ntitl1 .gt. 0) then
        do n = 2,ntitmx
          read (ninpts,1000,err=990) uline
          j2 = ilnobl(uline)
          j2 = min(j2,79)
          write (noutpt,1020) uline(1:j2)
          if (uline(1:8) .eq. uendit(1:8)) go to 120
          ntitl1 = n
          utitl1(n) = uline
        enddo
  120   continue
c
c       Write the first 5 lines of the input problem title to the
c       screen file.
c
        write (nttyo,1040)
 1040   format(3x,'The input problem title is (first 5 lines',
     $   ' maximum):',/)
c
        i = min(ntitl1,5)
        do n = 1,i
          j2 = ilnobl(utitl1(n))
          j2 = min(j2,74)
          write (nttyo,1050) utitl1(n)(1:j2)
 1050     format(5x,a)
        enddo
      endif
c
      write (nttyo,1060)
 1060 format(/3x,'Continuing to read the problem input ...')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature parameters.
c     Note: ttk(1) = ttk1, etc.
c
c       jtemp  = temperature tracking code:
c
c         0 = Constant temperature:
c               tempc = tempcb
c
c         1 = Linear tracking in Xi:
c               tempc = tempcb + ttk(1)*xi1
c
c         2 = Linear tracking in time (iopt(2) must be 1):
c               tempc = tempcb + ttk(1)*time1
c
c         3 = Fluid mixing tracking:
c               tempc= (tempcb*ttk(1) + xi*ttk(2))/(xi + ttk(1)), where:
c                 ttk(1) = ratio of the mass of the starting aqueous
c                   to that of the aqueous solution being treated as a
c                   reactant; usually the mass of each will be close to
c                   1 kilogram, hence the value of ttk(1) will then be
c                   about 1.0.
c                 ttk(2) = temperature of the fluid being treated as a
c                   reactant ("Fluid 2")
c
c       tempcb = the base temperature, C
c
c       ttk    = temperature tracking coefficients
c
      read (ninpts,1100,err=990) jtemp,tempcb,ttk(1),ttk(2)
 1100 format(12x,i2,/12x,e12.5,/2(12x,e12.5))
      write (noutpt,1110) jtemp,tempcb,ttk(1),ttk(2)
 1110 format(6x,'jtemp= ',i2,/5x,'tempcb= ',1pe12.5,
     $ /7x,'ttk1= ',e12.5,6x,'ttk2= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure parameters.
c     Note: ptk(1) = ptk1, etc.
c
c       jpress = pressure tracking code:
c
c         0 = Follow the data file's reference pressure curve:
c               press = func(data file, T)
c
c         1 = Follow the 1.013-bar/steam-saturation curve:
c               press = built-in func(T)
c
c         2 = Constant pressure:
c               press = pressb
c
c         3 = Linear tracking in Xi:
c               press = pressb + ptk(1)*xi1
c
c         4 = Linear tracking in time (iopt(2) must be 1):
c               press = pressb + ptk(1)*time1
c
c       pressb = the base pressure, bars
c
c       ptk    = pressure tracking coefficients
c
      read (ninpts,1120,err=990) jpress,pressb,ptk(1),ptk(2)
 1120 format(12x,i2,/12x,e12.5,/2(12x,e12.5))
      write (noutpt,1130) jpress,pressb,ptk(1),ptk(2)
 1130 format(4x,'jpress= ',i2,/5x,'pressb= ',1pe12.5,
     $ /7x,'ptk1= ',e12.5,6x,'ptk2= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of reactants.
c
c       nrct   = number of reactants
c
      read (ninpts,1480,err=990) nrct
 1480 format(12x,i2)
      write (noutpt,1490) nrct
 1490 format(7x,'nrct= ',i2)
c
      write (noutpt,1500)
 1500 format(' *-------------------------------------------------',
     $ '----------------------------')
c
      if (nrct .gt. nrctmx) then
        write (noutpt,1520) nrctmx
        write (nttyo,1520) nrctmx
 1520   format(/' * Error - (EQ6/rd6inw) Have too many reactants',
     $  /7x,'The code is only dimensioned for ',i4,' reactants.',
     $  /7x,'Reduce the number of reactants or increase the',
     $  /7x,'dimensioning parameter nrctpa.')
        go to 990
      endif
c
c     Reactants.
c
c       nxrt  = number of solid solution reactants
c       nsrt  = number of special reactants
c       nert  = number of ion exchanger reactants
c       ureac = name of reactant
c       morr  = moles of reactant remaining when Xi = xistti
c                 (the starting number of moles for the process
c                 corresponds to Xi = 0)
c       modr  = moles of reactant irreversibly destroyed when
c                 Xi = xistti (usually zero at Xi = 0)
c       jcode = reactant type flag:
c                 0 = mineral
c                 1 = solid solution
c                 2 = special reactant
c                 3 = aqueous species
c                 4 = gas
c       jreac = reactant status flag:
c                  0 = set to react (this is the only value a user
c                        should set; the code will write other values
c                        on pickup files)
c                 -1 = saturated, but the remaining reactant mass
c                        continues to react irreversibly; there is
c                        usually also a secondary product mass of the
c                        same species, so that the net rate of reaction
c                        is zero and the solution does not saturate
c                  1 = exhausted
c                  2 = saturated; the status of any remaining reactant
c                        mass is changed to that of a product phase;
c                        this only happens if iopt(1) = 0
c
      nxrt = 0
      nsrt = 0
      nert = 0
c
      do nrc = 1,nrct
c
c       Name, flags, and masses.
c
        read (ninpts,1530,err=990) ureac(nrc),jcode(nrc),jreac(nrc),
     $  morr(nrc),modr(nrc)
 1530   format(12x,a24,/12x,i2,22x,i2,/2(12x,e12.5))
        j2 = ilnobl(ureac(nrc))
        write (noutpt,1540) ureac(nrc)(1:j2),jcode(nrc),jreac(nrc),
     $  morr(nrc),modr(nrc)
 1540   format(3x,'reactant= ',a,/6x,'jcode= ',i2,15x,'jreac= ',i2,
     $  /7x,'morr= ',1pe12.5,6x,'modr= ',e12.5)
c
        if (jcode(nrc) .eq. 1) then
c
c         Have a solid solution reactant.
c
c           ucxri  = name of end-member of a solid solution reactant
c           rxbari = mole fraction of end-member of a solid solution
c                      reactant
c
          nxrt = nxrt + 1
c
          if (nxrt .gt. nxrtmx) then
            write (noutpt,1550) nxrtmx
            write (nttyo,1550) nxrtmx
 1550       format(/' * Error - (EQ6/rd6inw) Have too many solid',
     $      /7x,'solution reactants. The code is only dimensioned',
     $      /7x,'for ',i4,' such reactants. Reduce the number of',
     $      /7x,'such reactants or increase the dimensioning',
     $      ' parameter nxrtpa.')
            go to 990
          endif
c
          ikti = 0
          do i = 1,iktmax + 1
            read (ninpts,1560,err=990) uxs,xx
 1560       format(3x,a24,3x,e12.5)
c
            if (uxs(1:8) .eq. uendit(1:8)) then
              j3 = ilnobl(uxs)
              write (noutpt,1570) uxs(1:j3)
 1570         format(4x,a)
              go to 150
            endif
            write (noutpt,1580) uxs,xx
 1580       format(4x,a24,3x,1pe12.5)
c
            ikti = ikti + 1
c
            if (ikti .gt. iktmax) then
              write (noutpt,1590) ureac(nrc)(1:j2),iktmax
              write (nttyo,1590) ureac(nrc)(1:j2),iktmax
 1590         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        ' end-members',/7x,'in the solid solution reactant ',
     $        a,'.',/7x,'The code is only dimensioned for ',
     $        i4,' end-members per',/7x,'solid solution. Reduce',
     $        ' the number of end-members or',
     $        /7x,'increase the dimensioning parameter iktpar.')
              go to 990
            endif
c
            ucxri(ikti,nxrt) = uxs
            rxbari(ikti,nxrt) = xx
          enddo
  150     ixrti(nxrt) = ikti
        elseif (jcode(nrc) .eq. 2) then
c
c         Have a special reactant.
c
c           vreac  = volume, cc/mol
c           uesri  = name of element
c           cesri  =  moles chemical element per mole reactant
c           ubsri  = name of basis species in the chemical reaction
c           cbsri =  corresponding reaction coefficient
c
          nsrt = nsrt + 1
c
          if (nsrt .gt. nsrtmx) then
            write (noutpt,1600) nsrtmx
            write (nttyo,1600) nsrtmx
 1600       format(/' * Error - (EQ6/rd6inw) Have too many special',
     $      /7x,'reactants. The code is only dimensioned for ',i4,
     $      /7x,'such reactants. Reduce the number of such reactants',
     $      /7x,'or increase the dimensioning parameter nsrtpa.')
            go to 990
          endif
c
          read (ninpts,1610,err=990) vreac(nrc)
 1610     format(12x,e12.5)
          write (noutpt,1620) vreac(nrc)
 1620     format(6x,'vreac= ',1pe12.5)
c
          write (noutpt,1622)
 1622     format (' * Elemental composition')
c
          nci = 0
          do n = 1,nctmax + 1
            read (ninpts,1630,err=990) uxe,xx
 1630       format(3x,a8,3x,e22.15)
            if (uxe(1:8) .eq. uendit(1:8)) then
              j3 = ilnobl(uxe)
              write (noutpt,1640) uxe(1:j3)
 1640         format(4x,a)
              go to 160
            endif
            write (noutpt,1650) uxe,xx
 1650       format(4x,a8,3x,1pe22.15)
c
            nci = nci + 1
c
            if (nci .gt. nctmax) then
              write (noutpt,1660) ureac(nrc)(1:j2),nctmax
              write (nttyo,1660) ureac(nrc)(1:j2),nctmax
 1660         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        ' chemical',/7x,'elements in the special reactant ',a,
     $        '.',/7x,'The code is only dimensioned for ',i4,
     $        ' elements.',/7x,'Reduce the number of elements or',
     $        ' increase the',/7x,'dimensioning parameter nctpar.')
              go to 990
            endif
c
            uesri(nci,nsrt) = uxe
            cesri(nci,nsrt) = xx
          enddo
  160     iesrti(nsrt) = nci
c
          write (noutpt,1662)
 1662     format (' * Reaction')
c
c         Note: the special reactant itself should appear first in
c         the associated chemical reaction. Ordinarily, its reaction
c         coefficient should be -1.0.
c
          nbi = 0
          do n = 1,nbt1mx + 1
            read (ninpts,1670,err=990) uxs,xx
 1670       format(3x,a24,3x,e22.15)
            if (uxs(1:8) .eq. uendit(1:8)) then
              j3 = ilnobl(uxs)
              write (noutpt,1680) uxs(1:j3)
 1680         format(4x,a)
              go to 170
            endif
            write (noutpt,1690) uxs,xx
 1690       format(4x,a24,3x,1pe22.15)
c
            nbi = nbi + 1
c
            if (nbi .gt. nbt1mx) then
              write (noutpt,1700) ureac(nrc)(1:j2),nbtmax
              write (nttyo,1700) ureac(nrc)(1:j2),nbtmax
 1700         format(/' * Error - (EQ6/rd6inw) Have too many basis',
     $        ' basis species in the',/7x,'in the reaction for the',
     $        ' special reactant ',a,'.',/7x,'The code is only',
     $        ' dimensioned for ',i4,' basis species. Increase',
     $        /7x,'the dimensioning parameter nbtpar.')
              go to 990
            endif
c
            ubsri(nbi,nsrt) = uxs
            cbsri(nbi,nsrt) = xx
          enddo
  170     ibsrti(nsrt) = nbi
        elseif (jcode(nrc) .eq. 5) then
c
c         Have a generic ion exchanger reactant.
c
          nert = nert + 1
          ner = nert
c
          if (nert .gt. nertmx) then
            write (noutpt,1710) nertmx
            write (nttyo,1710) nertmx
 1710       format(/' * Error - (EQ6/rd6inw) Have too many generic',
     $      ' ion exchanger',/7x,'reactants. The code is only',
     $      ' dimensioned for ',i4,' such reactants.',/7x,'Reduce',
     $      ' the number of such reactants or increase the',
     $      /7x,'dimensioning parameter nertpa.')
            go to 990
          endif
c
          read (ninpts,1712,err=990) ugermo(ner)
 1712     format(12x,a24)
          j3 = ilnobl(ugermo(ner))
          write (noutpt,1714) ugermo(ner)(1:j3)
 1714     format(5x,'ugermo= ',a)
c
          jeti = 0
          do jj = 1,jetmax + 1
            read (ninpts,1716,err=990) uxs
 1716       format(3x,a24)
            if (uxs(1:8) .eq. uendit(1:8)) go to 154
c
            jeti = jeti + 1
            jei = jeti
c
            if (jeti .gt. jetmax) then
              write (noutpt,1718) ureac(nrc)(1:j2),jetmax
              write (nttyo,1718) ureac(nrc)(1:j2),jetmax
 1718         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        ' exchange sites',/7x,'in the generic ion exchanger',
     $        ' reactant ',a,'.',/7x,'The code is only dimensioned',
     $        ' for ',i4,' exchange sites per',/7x,'generic ion',
     $        ' exchanger. Reduce the number of exchange sites or',
     $        /7x,'increase the dimensioning parameter jetpar.')
              go to 990
            endif
c
            ugerji(jei,ner) = uxs
c
            neti = 0
            do nn = 1,netmax + 1
              read (ninpts,1720,err=990) uxs,xx
 1720         format(6x,a24,3x,e12.5)
              if (uxs(1:8) .eq. uendit(1:8)) go to 152
c
              neti = neti + 1
              nei = neti
c
              if (neti .gt. netmax) then
                j3 = ilnobl(ugerji(jei,nert))
                write (noutpt,1724) ureac(nrc)(1:j2),
     $          ugerji(jei,ner)(1:j3),netmax
                write (nttyo,1724) ureac(nrc)(1:j2),
     $          ugerji(jei,ner)(1:j3),netmax
 1724           format(/' * Error - (EQ6/rd6inw) Have too many',
     $          ' species on exchange',/7x,'site ',a,' of the generic',
     $          ' ion exchanger reactant',/7x,a,'. The code is only',
     $          ' dimensioned for species per',/7x,'exchange site.',
     $          ' Reduce the number of end-members or increase',
     $          /7x,'the dimensioning parameter netpar.')
                go to 990
              endif
c
              ugersi(nei,jei,ner) = uxs
              egersi(nei,jei,ner) = xx
              xgersi(nei,jei,ner) = xx
            enddo
  152       igerti(jei,ner) = neti
          enddo
  154     jgerti(ner) = jeti
        endif
c
c       Surface area parameters.
c
c         nsk    = surface area flag
c           0 = fixed surface area
c           1 = fixed specific surface area
c           2 = n**2/3 growth law- current surface area
c         sfcar  = surface area, cm2
c         ssfcar = specific surface area, cm2/mol
c         fkrc   = ratio of effective surface area to total surface
c                    area of a reactant; this parameter can also be
c                    used as a generalized correction factor for the
c                    rate constant
c
        read (ninpts,1740,err=990) nsk(nrc),sfcar(nrc),ssfcar(nrc),
     $  fkrc(nrc)
 1740   format(12x,i2,22x,e12.5,12x,e12.5,/12x,e12.5)
        write (noutpt,1750) nsk(nrc),sfcar(nrc),fkrc(nrc)
 1750   format(8x,'nsk= ',i2,15x,'sfcar= ',1pe12.5,4x,'ssfcar= ',e12.5,
     $  /7x,'fkrc= ',e12.5)
c
c
c       Rate law codes: nrk(1,nrc) = forward rate law code,
c       nrk(2,nrc) = backward rate law code.
c
c         Forward rate law codes:
c
c           -1 = Use the backward rate law form (legal only if
c                  nrk(2,nrc) = 2)
c            0 = Illegal value
c            1 = Relative rate
c            2 = Transition state theory net rate
c            3 = Linear rate
c
c         For the case nrk(1,nrc) = 2, the reactant must be
c         either a pure mineral (jcode = 0) or a solid solution
c         (jcode = 1).
c
c         Backward rate law codes:
c
c           -1 = Use the forward rate law form (legal only if
c                  nrk(1,nrc) = 2)
c            0 = No rate law specified; the reaction may be controlled
c                  by partial equilibrium
c            1 = Relative rate
c            2 = Transition state theory net rate
c            3 = Linear rate
c
c         For the case nrk(2,nrc) = 2, the reactant must be
c         either a pure mineral (jcode = 0) or a solid solution
c         (jcode = 1)
c
        read (ninpts,1760,err=990) nrk(1,nrc),nrk(2,nrc)
 1760   format(12x,i2,22x,i2)
        write (noutpt,1770) nrk(1,nrc),nrk(2,nrc)
 1770   format(7x,'nrk1= ',i2,16x,'nrk2= ',i2)
c
c       Read forward (dissolution, dissociation) rate data.
c
        if (nrk(1,nrc) .eq. -1) then
c
c         Use the backward rate law.
c
          continue
        elseif (nrk(1,nrc) .eq. 0) then
c
c         Illegal value.
c
          write (noutpt,1775) ureac(nrc)(1:j2)
          write (nttyo,1775) ureac(nrc)(1:j2)
 1775     format(/' * Error - (EQ6/rd6inw) The forward rate law code',
     $    /7x,'has an illegal value of 0 for ',a,'.')
          go to 990
        elseif (nrk(1,nrc) .eq. 1) then
c
c         Arbitrary kinetics (relative rates, indifferent to time).
c
c           relative rate = rkb(1,1,nrc) + rkb(2,1,nrc)*xi1
c                             + (rkb(3,1,nrc)/2.)*xi1**2
c
c         where
c
c           rkb    = relative rate constants
c           xi1    = the reaction progress variable
c
          imech(1,nrc) = 3
c
          if (imech(1,nrc) .gt. imchmx) then
            write (noutpt,1780) ureac(nrc)(1:j2),imchmx
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
 1780       format(/' * Error - (EQ6/rd6inw) Have too many rate',
     $      /7x,'constants or corresponding mechanisms in the forward',
     $      /7x,'rate law for reactant ',a,'. The code is only',
     $      /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $      /7x,'Reduce the number of rate constants or increase the',
     $      /7x,'dimensioning parameter imchpa.')
            go to 990
          endif
c
          read (ninpts,1790,err=990) (rkb(i,1,nrc), i = 1,3)
 1790     format(3(12x,e12.5))
          write (noutpt,1800) (rkb(i,1,nrc), i = 1,3)
 1800     format(7x,'rkb1= ',1pe12.5,6x,'rkb2= ',e12.5,
     $    6x,'rkb3= ',e12.5)
        elseif (nrk(1,nrc) .eq. 2) then
c
c         Transition state rate law. Up to imchmx parallel mechanisms
c         are allowed.
c
c           imech  = number of parallel transition state mechanisms
c           rkb    = rate constants, one for each rate law term
c           ndact  = number of aqueous species that appear in each
c                      rate law term
c           udac   = the name of such an aqueous species
c           cdac   = the power the activity of such a species is raised
c                      to in the rate law term
c           csigma = ratio of affinity of a macroscopic reaction to the
c                      affinity of the microcopic reaction for
c                      destruction of an activated complex
c
          read (ninpts,1810,err=990) imech(1,nrc)
 1810     format(12x,i2)
          write (noutpt,1820) imech(1,nrc)
 1820     format(6x,'imech= ',i2)
c
          if (imech(1,nrc) .gt. imchmx) then
            write (noutpt,1780) ureac(nrc)(1:j2),imchmx
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          do i = 1,imech(1,nrc)
            read (ninpts,1830,err=990) rkb(i,1,nrc),trkb(i,1,nrc),
     $      iact(i,1,nrc)
 1830       format(12x,e12.5,12x,e12.5,12x,i2)
            write (noutpt,1840) rkb(i,1,nrc),trkb(i,1,nrc),
     $      iact(i,1,nrc)
 1840       format(8x,'rkb= ',1pe12.5,6x,'trkb= ',e12.5,
     $      6x,'iact= ',i2)
c
            read (ninpts,1850,err=990) eact(i,1,nrc),hact(i,1,nrc)
 1850       format(12x,e12.5,12x,e12.5)
            write (noutpt,1860) eact(i,1,nrc),hact(i,1,nrc)
 1860       format(7x,'eact= ',1pe12.5,6x,'hact= ',e12.5)
c
            read (ninpts,1870,err=990) ndact(i,1,nrc),csigma(i,1,nrc)
 1870       format(12x,i2,22x,e12.5)
            write (noutpt,1880) ndact(i,1,nrc),csigma(i,1,nrc)
 1880       format(6x,'ndact= ',i2,14x,'csigma= ',1pe12.5)
c
            if (ndact(i,1,nrc) .gt. ndctmx) then
              write (noutpt,1890) i,ureac(nrc)(1:j2),ndctmx
              write (nttyo,1890) i,ureac(nrc)(1:j2),ndctmx
 1890         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        /7x,'species in the activity product in term ',i2,
     $        /7x,'of the forward direction rate law for reactant',
     $        /7x,a,'. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter ndctpa.')
              go to 990
            endif
c
            do n = 1,ndact(i,1,nrc)
              read (ninpts,1910,err=990) udac(n,i,1,nrc),
     $        cdac(n,i,1,nrc)
 1910         format(12x,a24,12x,e12.5)
              write (noutpt,1920) udac(n,i,1,nrc),cdac(n,i,1,nrc)
 1920         format(7x,'udac= ',a24,6x,'cdac= ',1pe12.5)
            enddo
          enddo
        elseif (nrk(1,nrc) .eq. 3) then
c
c         Linear rate law.
c
c           Rate = fkrc(nrc)*sfcar(nrc)*rkb(1,1,nrc)
c
          imech(1,nrc) = 1
c
          if (imech(1,nrc) .gt. imchmx) then
            write (noutpt,1780) ureac(nrc)(1:j2),imchmx
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          i = 1
          read (ninpts,1830,err=990) rkb(i,1,nrc),trkb(i,1,nrc),
     $    iact(i,1,nrc)
          write (noutpt,1840) rkb(i,1,nrc),trkb(i,1,nrc),
     $    iact(i,1,nrc)
          read (ninpts,1850,err=990) eact(i,1,nrc),hact(i,1,nrc)
          write (noutpt,1860) eact(i,1,nrc),hact(i,1,nrc)
        else
c
          write (noutpt,1950) nrk(1,nrc),ureac(nrc)(1:j2)
          write (nttyo,1950) nrk(1,nrc),ureac(nrc)(1:j2)
 1950     format(/' * Error - (EQ6/rd6inw) The forward rate law code',
     $    /7x,'has an unrecognized value of ',i2,' for ',a,'.')
          go to 990
c
        endif
c
c       Read backward (precipitation, formation) rate data.
c
c         If nrk(2,nrc) = 0, then the backward may be governed by
c         instantaneous partial equilibrium.
c
c         If nrk(2,nrc) = -1, then the forward rate law will be used.
c         This is legal only for the cases of nrk(1,nrc) = 2
c         (transition state theory net rate).
c
c         If nrk(2,nrc) <= 0, don't enter any additional backward
c         rate law data.
c
        if (nrk(2,nrc) .eq. -1) then
c
c         Use the forward rate law.
c
          continue
        elseif (nrk(2,nrc) .eq. 0) then
c
c         Use instantaneous partial equilibrium.
c
          continue
        elseif (nrk(2,nrc) .eq. 1) then
c
c         Arbitrary kinetics.
c
          imech(2,nrc) = 3
c
          if (imech(2,nrc) .gt. imchmx) then
            write (noutpt,1960) ureac(nrc)(1:j2),imchmx
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
 1960       format(/' * Error - (EQ6/rd6inw) Have too many rate',
     $      /7x,'constants or corresponding mechanisms in the backward',
     $      /7x,'rate law for reactant ',a,'. The code is only',
     $      /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $      /7x,'Reduce the number of rate constants or increase the',
     $      /7x,'dimensioning parameter imchpa.')
            go to 990
          endif
c
          read (ninpts,1790,err=990) (rkb(i,2,nrc), i = 1,3)
          write (noutpt,1800) (rkb(i,2,nrc), i = 1,3)
        elseif (nrk(2,nrc) .eq. 2) then
c
c         Transition state rate law.
c
          read (ninpts,1810,err=990) imech(2,nrc)
          write (noutpt,1820) imech(2,nrc)
c
          if (imech(2,nrc) .gt. imchmx) then
            write (noutpt,1960) ureac(nrc)(1:j2),imchmx
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          do i = 1,imech(2,nrc)
            read (ninpts,1830,err=990) rkb(i,2,nrc),trkb(i,2,nrc),
     $      iact(i,2,nrc)
            write (noutpt,1840) rkb(i,2,nrc),trkb(i,2,nrc),
     $      iact(i,2,nrc)
c
            read (ninpts,1850,err=990) eact(i,2,nrc),hact(i,2,nrc)
            write (noutpt,1860) eact(i,2,nrc),hact(i,2,nrc)
c
            read (ninpts,1870,err=990) ndact(i,2,nrc),csigma(i,2,nrc)
            write (noutpt,1880) ndact(i,2,nrc),csigma(i,2,nrc)
c
            if (ndact(i,2,nrc) .gt. ndctmx) then
              write (noutpt,1970) i,ureac(nrc)(1:j2),ndctmx
              write (nttyo,1970) i,ureac(nrc)(1:j2),ndctmx
 1970         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        /7x,'species in the activity product in term ',i2,
     $        /7x,'of the backward direction rate law for reactant',
     $        /7x,a,'. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter ndctpa.')
              go to 990
            endif
c
            do n = 1,ndact(i,2,nrc)
              read (ninpts,1910,err=990) udac(n,i,2,nrc),
     $        cdac(n,i,2,nrc)
              write (noutpt,1920) udac(n,i,2,nrc),cdac(n,i,2,nrc)
            enddo
          enddo
        elseif (nrk(2,nrc) .eq. 3) then
c
c         Linear rate law.
c
          imech(2,nrc) = 1
c
          if (imech(2,nrc) .gt. imchmx) then
            write (noutpt,1960) ureac(nrc)(1:j2),imchmx
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          i = 1
          read (ninpts,1830,err=990) rkb(i,2,nrc),trkb(i,2,nrc),
     $    iact(i,2,nrc)
          write (noutpt,1840) rkb(i,2,nrc),trkb(i,2,nrc),
     $    iact(i,2,nrc)
          read (ninpts,1850,err=990) eact(i,2,nrc),hact(i,2,nrc)
          write (noutpt,1860) eact(i,2,nrc),hact(i,2,nrc)
        else
c
          write (noutpt,1980) nrk(2,nrc),ureac(nrc)(1:j2)
          write (nttyo,1980) nrk(2,nrc),ureac(nrc)(1:j2)
 1980     format(/' * Error - (EQ6/rd6inw) The backward rate law code',
     $    /7x,'has an unrecognized value of ',i2,' for ',a,'.')
          go to 990
c
        endif
c
        write (noutpt,1500)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting, minimum, and maximum values of key run parameters.
c
c       xistti  = starting value of reaction progress for this run
c       ximaxi  = maximum value of Xi for this run
c       tistti  = time at Xi = xistti (sec)
c       timmxi  = maximum time (sec) for this run
c
      read (ninpts,1150,err=990) xistti,ximaxi,tistti,timmxi
 1150 format(2(12x,e12.5),/2(12x,e12.5))
      write (noutpt,1155) xistti,ximaxi,tistti,timmxi
 1155 format(5x,'xistti= ',1pe12.5,4x,'ximaxi= ',e12.5,/
     $ 5x,'tistti= ',1pe12.5,4x,'timmxi= ',e12.5)
c
c       phmini  = minimum pH for this run
c       phmaxi  = maximum pH for this run
c       ehmini  = minimum Eh (v) for this run
c       ehmaxi  = maximum Eh (v) for this run
c       o2mini  = minimum log fO2 for this run
c       o2maxi  = maximum log fO2 for this run
c       awmini  = minimum aw for this run
c       awmaxi  = maximum aw for this run
c       kstpmx  = maximum number of steps for this run
c
      read (ninpts,1160,err=990) phmini,phmaxi,ehmini,ehmaxi,o2mini,
     $ o2maxi,awmini,awmaxi,kstpmx
 1160 format(2(12x,e12.5),/2(12x,e12.5),/2(12x,e12.5),/2(12x,e12.5),
     $ /12x,i12)
      write (noutpt,1165) phmini,phmaxi,ehmini,ehmaxi,o2mini,o2maxi,
     $ awmini,awmaxi,kstpmx
 1165 format(5x,'phmini= ',1pe12.5,4x,'phmaxi= ',e12.5,/
     $ 5x,'ehmini= ',1pe12.5,4x,'ehmaxi= ',e12.5,/
     $ 5x,'o2mini= ',1pe12.5,4x,'o2maxi= ',e12.5,/
     $ 5x,'awmini= ',1pe12.5,4x,'awmaxi= ',e12.5,/
     $ 5x,'kstpmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval parameters.
c
c       dlxprn = print increment in terms of Xi
c       dlxprl = log Xi print interval
c       dltprn = print increment in terms of time (seconds)
c       dltprl = log time print interval
c
      read (ninpts,1170,err=990) dlxprn,dlxprl,dltprn,dltprl
 1170 format(2(12x,e12.5),12x,/2(12x,e12.5))
      write (noutpt,1175) dlxprn,dlxprl,dltprn,dltprl
 1175 format(5x,'dlxprn= ',1pe12.5,4x,'dlxprl= ',e12.5,
     $ /5x,'dltprn= ',e12.5,4x,'dltprl= ',e12.5)
c
c       dlhprn = print increment in terms of pH
c       dleprn = print increment in terms of Eh (v)
c       dloprn = print increment in terms of log fO2
c       dlaprn = print increment in terms of aw
c       ksppmx = limit on number of steps from the last print point
c                  at which a print will be made
c
      read (ninpts,1180,err=990) dlhprn,dleprn,dloprn,dlaprn,ksppmx
 1180 format(2(12x,e12.5),12x,/2(12x,e12.5),/12x,i12)
      write (noutpt,1185) dlhprn,dleprn,dloprn,dlaprn,ksppmx
 1185 format(5x,'dlhprn= ',1pe12.5,4x,'dleprn= ',e12.5,
     $ /5x,'dloprn= ',e12.5,4x,'dlaprn= ',e12.5,/5x,'ksppmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval parameters.
c
c       dlxplo = plot increment in terms of Xi
c       dlxpll = log Xi plot interval
c       dltplo = plot increment in terms of time (seconds)
c       dltpll = log time plot interval
c
      read (ninpts,1190,err=990) dlxplo,dlxpll,dltplo,dltpll
 1190 format(2(12x,e12.5),/2(12x,e12.5))
      write (noutpt,1192) dlxplo,dlxpll,dltplo,dltpll
 1192 format(5x,'dlxplo= ',1pe12.5,4x,'dlxpll= ',e12.5,
     $ /5x,'dltplo= ',e12.5,4x,'dltpll= ',e12.5)
c
c       dlhplo = plot increment in terms of pH
c       dleplo = plot increment in terms of Eh (v)
c       dloplo = plot increment in terms of log fO2
c       dlaplo = plot increment in terms of aw
c       ksplmx = limit on number of steps from the last plot point
c                  at which a plot will be made
c
      read (ninpts,1195,err=990) dlhplo,dleplo,dloplo,dlaplo,ksplmx
 1195 format(2(12x,e12.5),/2(12x,e12.5),/12x,i12)
      write (noutpt,1197) dlhplo,dleplo,dloplo,dlaplo,ksplmx
 1197 format(5x,'dlhplo= ',1pe12.5,4x,'dleplo= ',e12.5,
     $ /5x,'dloplo= ',e12.5,4x,'dlaplo= ',e12.5,/5x,'ksplmx= ',i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
c       iopt(1) = Switch to choose the physical model:
c          0 = Closed system
c          1 = Titration system
c          2 = Fluid-centered flow-through open system
c
c       iopt(2) = Kinetic mode:
c          0 = Reaction progress mode (arbitrary kinetics)
c          1 = Reaction progress/time mode (true kinetics)
c
c       iopt(3) = Phase boundary searches:
c          0 =  The step size is constrained by the locations of
c                 the predicted phase boundaries (iopt(3) is reset
c                 to 0 if other options require this)
c          1 =  The location of phase boundaries is estimated from
c                 Taylor's series and printed, but the step size is
c                 unconstrained
c          2  = The locations of phase boundaries are ignored
c
c       iopt(4) = Solid solution products:
c          0 = Solid solutions are ignored
c          1 = Solid solutions are permitted
c
c       iopt(5) = Clear the ES solids read from the input file:
c          0 = Don't do it
c          1 = Do it
c
c       iopt(6) = Clear the ES solids at the initial value of reaction
c                   progress; this is done after calculating the state
c                   of the system at this point:
c          0 = Don't do it
c          1 = Do it
c
c       iopt(7) = Clear the ES solids at the end of the run:
c          0 = Don't do it
c          1 = Do it, unless the run terminates early due to
c                calculational difficulties
c
c       iopt(8) = Not used
c
c       iopt(9) = Clear the PRS solids read from the input file:
c          0 = Don't do it
c          1 = Do it
c
c       iopt(10) = Clear the PRS solids at the end of the run:
c          0 = Don't do it
c          1 = Do it, unless the run terminates early due to
c                calculational difficulties
c
c       iopt(11) = Auto basis switching, in pre-N-R optimization:
c          0 = Off
c          1 = On
c
c       iopt(12) = Auto basis switching, after N-R iteration:
c          0 = Off
c          1 = On
c
c       iopt(13) = Switch to choose calculational mode:
c          0 = Normal path tracing
c          1 = Economy mode (if permissible)
c          2 = Super economy mode (if permissible)
c
c       iopt(14) = ODE integrator corrector mode:
c          0 = Allow stiff and simple correctors
c          1 = Allow only the simple corrector
c          2 = Allow only the stiff corrector
c          3 = Allow no correctors
c
c       iopt(15) = Force suppression of all redox reactions:
c          0 = Don't do it
c          1 = Do it (this is potentially dangerous)
c
c       iopt(16) = Backup file options:
c         -1 = Don't write backup files
c          0 = Write backup files
c          1 = Write a sequential backup file
c
c       iopt(17) = Pickup file options:
c         -1 = Don't write a pickup file
c          0 = Write a pickup file
c
c       iopt(18) = Tab file options:
c         -1 = Don't write the tab file
c          0 = Write the tab file
c          1 = The tab file output is appended to the tabx file from a
c                 previous run; if more than one problem is stacked on
c                 the input file, this option applies to only the first
c                 problem, for any subsequent any subsequent problems,
c                 iopt(18) is reset to 0
c
c       iopt(19) = Used only by EQ3NR
c
c       iopt(20) = Advanced EQ6 pickup file options:
c          0 = Write a normal EQ6 pickup file
c          1 = Write an EQ6 input file with "Fluid 2" set up as a
c                special reactant for mixing with another fluid or
c                reaction with a more generalized equilibrium system
c
      write (noutpt,1200)
 1200 format(' *',15x,'1    2    3    4    5    6    7    8    9   10')
c
      read (ninpts,1210,err=990) (iopt(i), i = 1,20)
 1210 format(12x,10i5)
      write (noutpt,1220) (iopt(i), i = 1,20)
 1220 format(3x,'iopt1-10= ',10i5,/2x,'iopt11-20= ',10i5)
c
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
c       iopr(1) = List the names of all species read from the
c                   supporting data file:
c          0 = Don't list
c          1 = List
c
c       iopr(2) = List all reactions:
c          0 = Don't list
c          1 = List all reactions (this can be quite lengthy)
c          2 = Also print the log K values
c          3 = Also print the coefficients of the interpolating
c                polynomials
c
c       iopr(3) = List the hard core diameters of the aqueous species:
c          0 = Don't list
c          1 = List
c
c       iopr(4) = Print a table at each print point of the
c                   concentrations, activities, and activity
c                   coefficients of the aqueous species:
c         -3  = Omit species with molalities < 1.e-8
c         -2 =  Omit species with molalities < 1.e-12
c         -1 =  Omit species with molalities < 1.e-20
c          0 =  Omit species with molalities < 1.e-100
c          1 =  Include all species
c
c       iopr(5) = Print a table at each print point of the cation/H+
c                   activity ratios, anion-H+ activity products, and
c                   neutral species activities:
c          0 = Don't print
c          1 = Print cation/H+ activity ratios only
c          2 = Print cation/H+ activity ratios and anion-H+ activity
c                products only
c          3 = Print cation/H+ activity ratios, anion-H+ activity
c                products, and neutral species activities
c
c       iopr(6) = At each print point, print a table of the percentage
c                    contributions for each aqueous mass balance total:
c         -1 = Don't print any tables
c          0 = Print tables including 99% of all contributing species
c          1 = Print tables including all contributing species
c
c       iopr(7) = Print a table at each print point of the saturation
c                   indices and affinities of the various non-aqueous
c                   phases:
c         -1 = Don't print
c          0 = Print for those phases not undersaturated by
c                more than 10 kcal
c          1 = Print for all phases
c
c       iopr(8) = Print a table at each print point of the fugacities
c                   of the gas species:
c         -1 = Don't print
c          0 = Print
c          1 = Print
c
c       iopr(9) = Print a table at each print of the mean molal
c                   activity coefficients:
c         -1 = Don't print
c          0 = Don't print
c          1 = Print
c
c       iopr(10) = Print a tabulation at the start of running the
c                    current problem of the Pitzer interaction
c                    coefficients:
c          0 = Don't print
c          1 = Print a summary of the names of the species present and
c                the number of Pitzer interaction coefficients
c          2 = Print a summary of the names of the species present and
c                the number of Pitzer interaction coefficients
c
c       iopr(11) - iopr(16) = Not used
c
c       iopr(17) = Pickup file format:
c          0 = Use the same format ("D" or "W") as the input file
c          1 = Use "W" format
c          2 = Use "D" format
c
c       iopr(18) - iopr(20) = Not used
c
      read (ninpts,1230,err=990) (iopr(i), i = 1,20)
 1230 format(12x,10i5)
      write (noutpt,1240) (iopr(i), i = 1,20)
 1240 format(3x,'iopr1-10= ',10i5,/2x,'iopr11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
c       iodb(1) = General diagnostic messages:
c          0 = Don't print
c          1 = Print Level 1 diagnostic messages
c          2 = Print Level 1 and Level 2 diagnostic messages
c
c       iodb(2) = Kinetics-related diagnostic messages:
c          0 = Don't print
c          1 = Print Level 1 kinetics diagnostic messages
c          2 = Print Level 1 and Level 2 kinetics diagnostic messages
c
c       iodb(3) = Pre-Newton-Raphson optimization:
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information
c          3 = Print more detailed information
c          4 = Also print changes to activity coefficients
c
c       iodb(4) = Information describing Newton-Raphson iteration:
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information including the residual and
c                correction vectors
c          3 = Also print the Jacobian matrix
c          4 = Also print changes to activity coefficients
c
c       iodb(5) = Step size/order selection:
c          0 = Don't print
c          1 = Print the chosen scale factor
c          2 = Print the orders under consideration and their respective
c                step size scaling factors
c
c       iodb(6) = Hypothetical affinity calculations (for solid
c                   solutions, etc.):
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information
c
c       iodb(7) = Search iterations (for phase boundaries, etc.):
c          0 = Don't print
c          1 = Print summary information
c
c       iodb(8) = Information describing ODE corrector iteration:
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information
c
c       iodb(9) - iodb(20) = Not used
c
      read (ninpts,1250,err=990) (iodb(i), i = 1,20)
 1250 format(12x,10i5)
      write (noutpt,1260) (iodb(i), i = 1,20)
 1260 format(3x,'iodb1-10= ',10i5,/2x,'iodb11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxopt options.
c
c       nxopt = number of mineral subset-selection suppression options
c
      read (ninpts,1300,err=990) nxopt
 1300 format(12x,i2)
      write (noutpt,1310) nxopt
 1310 format(6x,'nxopt= ',i2)
c
      if (nxopt .gt. nxopmx) then
        write (noutpt,1320) nxopmx
        write (nttyo,1320) nxopmx
 1320   format(/' * Error - (EQ6/rd6inw) Have too many mineral',
     $  /7x,'subset-selection suppression options. The code is',
     $  /7x,'only dimensioned for ',i3,' such options. Reduce the',
     $  /7x,'number of options or increase the dimensioning',
     $  /7x,'parameter nxoppa.')
        go to 990
      endif
c
c     Nxopt options.
c
c       uxopt  = 'all' or 'alwith'
c       uxcat  = name of a chemical element
c       nxopex = number of exceptions
c       uxopex = name of the minerals that are the exceptions
c
      do n = 1,nxopt
        read (ninpts,1330,err=990) uxopt(n),uxcat(n)
 1330   format(12x,a6,1x,a24)
        j2 = ilnobl(uxcat(n))
        write (noutpt,1340) uxopt(n),uxcat(n)(1:j2)
 1340   format(5x,'option= ',a6,1x,a)
      enddo
c
      if (nxopt .gt. 0) then
        read (ninpts,1350,err=990) nxopex
 1350   format(12x,i2)
        write (noutpt,1360) nxopex
 1360   format(5x,'nxopex= ',i2)
c
        if (nxopex .gt. nxpemx) then
          write (noutpt,1370) nxpemx
          write (nttyo,1370) nxpemx
 1370     format(/' * Error - (EQ6/rd6inw) Have too many',
     $    /7x,'exceptions specified to the mineral subset-selection',
     $    /7x,'suppression options. The code is only dimensioned',
     $    /7x,'for ',i3,'exceptions. Reduce the number of exceptions',
     $    /7x,'or increase the dimensioning parameter nxpepa.')
          go to 990
        endif
c
        do n = 1,nxopex
          read (ninpts,1380,err=990) uxopex(n)
 1380     format(12x,a24)
          j2 = ilnobl(uxopex(n))
          write (noutpt,1390) uxopex(n)(1:j2)
 1390     format(2x,'exception= ',a)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nffg options.
c
c       nffg   = number of gases with fixed fugacities
c
      read (ninpts,1400,err=990) nffg
 1400 format(12x,i2)
      write (noutpt,1410) nffg
 1410 format(7x,'nffg= ',i2)
c
      if (nffg .gt. nffgmx) then
        write (noutpt,1420) nffgmx
        write (nttyo,1420) nffgmx
 1420   format(/' * Error - (EQ6/rd6inw) Have too many gases whose',
     $  /7x,'fugacities are to be fixed. The code is only dimensioned',
     $  /7x,'for ',i4,' such gases. Reduce the number of gases or',
     $  /7x,'increase the dimensioning parameter nffgpa.')
        go to 990
      endif
c
c     Nffg options.
c
c       uffg   = name of species
c       moffg  = moles of gas species
c       xlkffg = log fugacity
c
      do n = 1,nffg
        read (ninpts,1430,err=990) uffg(n),moffg(n),xlkffg(n)
 1430   format(12x,a24,/12x,e12.5,12x,e12.5)
        write (noutpt,1440) uffg(n),moffg(n),xlkffg(n)
 1440   format(4x,'species= ',a24,/6x,'moffg= ',1pe12.5,4x,
     $  'xlkffg= ',e12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Under normal circumstances, users should enter zeros and take
c     the code default values for dlxdmp, tolbt, toldl, tolxsf, tolsat,
c     dlxmx0, itermx, and ntrymx.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum finite-difference order.
c
      read (ninpts,2010,err=990) nordmx
 2010 format(12x,i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Newton-Raphson convergence tolerances.
c
c       tolbt = convergence tolerance on residual magnitude
c                 (in Newton-Raphson iteration)
c       toldl = convergence tolerance on correction magnitude
c                 (in Newton-Raphson iteration)
c
      read (ninpts,2020,err=990) tolbt,toldl
 2020 format(2(12x,e12.5))
      write (noutpt,2030) tolbt,toldl
 2030 format(6x,'tolbt= ',1pe12.5,5x,'toldl= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of Newton-Raphson iterations.
c
c       itermx = limit on the number of Newton-Raphson iterations.
c                  Recommended values lie in the range 50 to 200.
c
      read (ninpts,2100,err=990) itermx
 2100 format(12x,i3)
      write (noutpt,2110) itermx
 2110 format(5x,'itermx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search/find tolerance.
c
c       tolxsf = search/find tolerance
c
      read (ninpts,2022,err=990) tolxsf
 2022 format(12x,e12.5)
      write (noutpt,2032) tolxsf
 2032 format(5x,'tolxsf= ', 1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation tolerance.
c
c       tolsat = supersaturation tolerance below which no attempt
c                  is made to precipitate a phase. A good value is
c                  0.0001 kcal. Don't make it too small.
c
      read (ninpts,2024,err=990) tolsat
 2024 format(12x,e12.5)
      write (noutpt,2034) tolsat
 2034 format(5x,'tolxsf= ', 1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of phase assemblage tries.
c
c       ntrymx = limit on the number of attempted phase assemblages
c                  at a point of reaction progress. Recommended
c                  values lie in the range of 50 to 100.
c
      read (ninpts,2102,err=990) ntrymx
 2102 format(12x,i3)
      write (noutpt,2112) ntrymx
 2112 format(5x,'ntrymx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero-order step size (in Xi).
c
c       dlxmx0 = the normal step size for order zero; this is not the
c                  minimum step size (dlxmin). Recommended values lie
c                  in the range 1.e-10 to 1.e-6.
c
      read (ninpts,2080,err=990) dlxmx0
 2080 format(12x,e12.5)
      write (noutpt,2090) dlxmx0
 2090 format(5x,'dlxmx0= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     PRS transfer interval in Xi.
c
c       dlxdmp = fixed reaction progress interval for the transfer of
c                  phases from the equilibrium system (ES) to the
c                  physically removed system (PRS); this only works
c                  in conjunction with the fluid-centered flow-through
c                  open system model (iopt(1) = 2)
c
      read (ninpts,2000,err=990) dlxdmp
 2000 format(12x,e12.5)
      write (noutpt,2005) dlxdmp
 2005 format(5x,'dlxdmp= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1500)
c
c     Process the bottom half of the current input file.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Secondary title.
c
c     utitl2 = secondary title
c     ntitl2 = number of lines in the secondary title.
c
      ntitl2 = 0
      read (ninpts,1000,err=990) uline
c
      j2 = ilnobl(uline)
      j2 = min(j2,79)
      write (noutpt,1020) uline
c
      if (uline(1:8) .ne. uendit(1:8)) then
        ntitl2 = 1
        utitl2(1) = uline
        do n = 2,ntitmx
          read (ninpts,1000,err=990) uline
          j2 = ilnobl(uline)
          j2 = min(j2,79)
          write (noutpt,1020) uline(1:j2)
          if (uline(1:8) .eq. uendit(1:8)) go to 220
          utitl2(n) = uline
          ntitl2 = n
        enddo
  220   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
c       nsbswt = the number of special basis switches
c       usbsw(1,n) = the species to be switched from the strict
c                      basis to the auxiliary basis set in the
c                      in the n-th switch
c       usbsw(2,n) = the species to be switched from the auxiliary
c                      basis set to the strict basis set in the
c                      n-th switch
c
      write (noutpt,2610)
 2610 format(' *   Special basis switches')
c
      read (ninpts,2620,err=990) nsbswt
 2620 format(12x,i3)
      write (noutpt,2630) nsbswt
 2630 format(5x,'nsbswt= ',i3)
c
      do n = 1,nsbswt
        read (ninpts,2640,err=990) usbsw(1,n)
 2640   format(9x,a48)
        j2 = ilnobl(usbsw(1,n))
        write (noutpt,2650) usbsw(1,n)(1:j2)
 2650   format(1x,'species= ',a)
c
        read (ninpts,2660,err=990) usbsw(2,n)
 2660   format(15x,a48)
        j2 = ilnobl(usbsw(2,n))
        write (noutpt,2670) usbsw(2,n)(1:j2)
 2670   format(3x,'switch with= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
c       tempci = temperature, C, at the end of the previous
c                  EQ3NR or EQ6 run
c
      read (ninpts,2680,err=990) tempci
 2680 format(12x,e12.5)
      write (noutpt,2690) tempci
 2690 format(5x,'tempci= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
c       pressi = pressure, bars, at the end of the previous
c                  EQ3NR or EQ6 run
c
      read (ninpts,2700,err=990) pressi
 2700 format(12x,e12.5)
      write (noutpt,2710) pressi
 2710 format(5x,'pressi= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation. This section reads the directives for
c     creating ion exchange phases and species and their associated
c     intrinsic (including thermodynamic) properties. The data is
c     essentially that which might be read from a supporting data file.
c
c       qgexsh = logical flag. If .true., force the writing of at
c                  least one exchanger block on a "D" format input
c                  file (when running XCON6) or pickup file.
c       net    = the number of ion exchangers
c       ugexp  = array of ion exchange phase names
c       mwtges = array of molecular weights of substrates of ion
c                  exchange phases
c       ugexmo = array of strings identifying models for composing
c                  exact ion exchange species and corresponding
c                  reactions; examples include:
c                    'Vanselow' = Vanselow model
c                    'Gapon'    = Gapon model
c                    'Site-mixing' = the general site-mixing model
c       tgexp  = array of reference temperatures (C)  for the
c                  thermodynamic data for the reactions specified
c                  for the exchanger phases
c       jgext  = array of numbers of exchange sites in ion exchange
c                  phases
c       ugexj  = array of names specified for the sites on the various
c                 exchangers
c       cgexj  = array of numbers of moles of exchange sites per mole
c                  of substrate in ion exchange phases
c       zgexj  = array of electrical charges of exchange sites
c                  in ion exchange phases. The total charge number
c                  for a site is the product of this charge and
c                  and the number of moles of the site per mole
c                  of exchanger. The sign of the charge on a site
c                  is generally the opposite of that of the ions
c                  which exchange on it.
c       ngexrt = array of numbers of ion exchange reactions specified
c                  for a given site and exchanger
c       ugexr  = array of strings containing compact representations
c                  of the exchange reactions; e.g., 'Na+ = Ca++' for a
c                  reaction in which Na+ on the exchanger is replaced
c                  by Ca++. One may make specifications such as
c                  'Na+ = ' in which case the ion goes into solution
c                  leaving a bare substrate. All reactions are
c                  normalized to the exchange (or loss) of one
c                  equivalent. The exact form of the reaction is
c                  otherwise dependent on the mixing law specifed in
c                  the element of the ugexmo array for the current
c                  exchanger.
c       xlkgex = array of equilibrium constants or related data for
c                  the reaction specified in the above string
c       uxkgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xlkgex array:
c                    ' '       = log K per equivalent
c                    'LogK/eq' = log K per equivalent
c                    'kcal/eq' = DeltaG0r, kcal, per equivalent
c                    'kJ/eq'   = DeltaG0r, kJ, per equivalent
c       xhfgex = array of enthalpy of reaction data for the reaction
c                  specified in the above string
c       uhfgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xhfgex array:
c                    ' '       = DeltaG0r, kcal, per equivalent
c                    'kcal/eq' = DeltaG0r, kcal, per equivalent
c                    'kJ/eq'   = DeltaG0r, kJ, per equivalent
c       xvfgex = array of volume of reaction data for the reaction
c                  specified in the above string
c       uvfgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xhfgex array:
c                    ' '      = cm3 per equivalent
c                    'cm3/eq' = cm3 per equivalent
c
      write (noutpt,2790)
 2790 format(' * Ion exchanger creation')
c
      read (ninpts,2795) ux8
 2795 format(12x,a8)
      call lejust(ux8)
      call locase(ux8)
      qgexsh = ux8(1:2).eq.'.t' .or. ux8(1:1).eq. 't'
      write (noutpt,2797) qgexsh
 2797 format(5x,'qgexsh= ',l8)
c
      read (ninpts,2800,err=990) net
 2800 format(12x,i3)
      write (noutpt,2810) net
 2810 format(8x,'net= ',i3)
c
      if (net .gt. netmax) then
        write (noutpt,2820) netmax,net
        write (nttyo,2820) netmax,net
 2820   format(/' * Error - (EQ6/rd6inw) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data to create',/7x,'such phases. Increase',
     $  ' the dimensioning parameter netpar',/7x,'to at least ',i3,'.')
        go to 990
      endif
c
      do ne = 1,net
        read (ninpts,2830,err=990) ugexp(ne)
 2830   format(12x,a24)
        j2 = ilnobl(ugexp(ne))
        write (noutpt,2840) ugexp(ne)(1:j2)
 2840   format(6x,'ugexp= ',a)
c
        read (ninpts,2850,err=990) mwtges(ne)
 2850   format(12x,e12.5)
        write (noutpt,2860) mwtges(ne)
 2860   format(5x,'mwtges= ',1pe12.5)
c
        read (ninpts,2830,err=990) ugexmo(ne)
        j3 = ilnobl(ugexmo(ne))
        write (noutpt,2870) ugexmo(ne)(1:j3)
 2870   format(5x,'ugexmo= ',a)
c
        read (ninpts,2850,err=990) tgexp(ne)
        write (noutpt,2880) tgexp(ne)
 2880   format(6x,'tgexp= ',1pe12.5)
c
        read (ninpts,2890,err=990) jgext(ne)
 2890   format(12x,i3)
        write (noutpt,2900) jgext(ne)
 2900   format(6x,'jgext= ',i3)
c
        if (jgext(ne) .gt. jetmax) then
          write (noutpt,2910) jetmax,ugexp(ne)(1:j2),jgext(ne)
          write (nttyo,2910) jetmax,ugexp(ne)(1:j2),jgext(ne)
 2910     format(/' * Error - (EQ6/rd6inw) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data to create',
     $    a,'. Increase the',/7x,'dimensioning parameter jetpar to',
     $    ' at least ',i3,'.')
          go to 990
        endif
c
        do je = 1,jgext(ne)
          read (ninpts,2930,err=990) ugexj(je,ne)
 2930     format(12x,a8)
          j3 = ilnobl(ugexj(je,ne))
          write (noutpt,2940) ugexj(je,ne)(1:j3)
 2940     format(6x,'ugexj= ',a)
c
          read (ninpts,2950,err=990) cgexj(je,ne),zgexj(je,ne)
 2950     format(12x,e12.5,12x,e12.5)
          write (noutpt,2960) cgexj(je,ne),zgexj(je,ne)
 2960     format(6x,'cgexj= ',1pe12.5,5x,'zgexj= ',e12.5)
c
          read (ninpts,2890,err=990) ngexrt(je,ne)
          write (noutpt,3010) ngexrt(je,ne)
 3010     format(5x,'ngexrt= ',i3)
c
          if (ngexrt(je,ne) .gt. ietmax) then
            write (noutpt,3020) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
            write (nttyo,3020) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
 3020       format(/' * Error - (EQ6/rd6inw) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'reactions for a site',
     $      ' belonging to a generic ion exchange',/7x,'phase while',
     $      ' reading the data for site ',a,' of exchange phase'
     $      /7x,a,'. Increase the dimensioning parameter',
     $      /7x,'ietpar to at least ',i3,'.')
            go to 990
          endif
c
          do n = 1,ngexrt(je,ne)
            read (ninpts,3030,err=990) ugexr(n,je,ne)
 3030       format(12x,a56)
            j2 = ilnobl(ugexr(n,je,ne))
            write (noutpt,3040) ugexr(n,je,ne)(1:j2)
 3040       format(6x,'ugexr= ',a)
            read (ninpts,3050,err=990) xlkgex(n,je,ne),uxkgex(n,je,ne)
 3050       format(12x,e12.5,12x,a8)
            j4 = ilnobl(uxkgex(n,je,ne))
            write (noutpt,3060) xlkgex(n,je,ne),uxkgex(n,je,ne)(1:j4)
 3060       format(5x,'xlkgex= ',1pe12.5,5x,'units= ',a)
            read (ninpts,3050,err=990) xhfgex(n,je,ne),uhfgex(n,je,ne)
            j4 = ilnobl(uhfgex(n,je,ne))
            write (noutpt,3070) xhfgex(n,je,ne),uhfgex(n,je,ne)(1:j4)
 3070       format(5x,'xhfgex= ',1pe12.5,5x,'units= ',a)
            read (ninpts,3050,err=990) xvfgex(n,je,ne),uvfgex(n,je,ne)
            j4 = ilnobl(uvfgex(n,je,ne))
            write (noutpt,3080) xvfgex(n,je,ne),uvfgex(n,je,ne)(1:j4)
 3080       format(5x,'xvfgex= ',1pe12.5,5x,'units= ',a)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
c       nxmod = the number of suppressed/altered species/reactions
c
      read (ninpts,3120,err=990) nxmod
 3120 format(12x,i2)
      write (noutpt,3130) nxmod
 3130 format(6x,'nxmod= ',i2)
c
      if (nxmod .gt. nxmdmx) then
        write (noutpt,3140) nxmdmx
        write (nttyo,3140) nxmdmx
 3140   format(/' * Error - (EQ6/rd6inw) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i2,' such options. Reduce the number of such',
     $  /7x,'options or increase the dimensioning parameter nxmdpa.')
        go to 990
      endif
c
c     Nxmod options.
c
c       uxmod = the name (all 48 letters) of the species. If the
c                 phase part is not given, the option is applied to
c                 every species for which the species part of its name
c                 generates a match.
c       kxmod  = alter/suppress code
c         -1 = the species is suppressed
c          0 = the log K is replaced by xlkmod
c          1 = the log K is augmented by xlkmod
c          2 = same as kxmod=1, but xlkmod is input in units of kcal
c                per mole of the associated species
c       xlkmod = log K value alteration function as defined above
c
      do n = 1,nxmod
        read (ninpts,3150,err=990) uxmod(n),kxmod(n),xlkmod(n)
 3150   format(12x,a48,/12x,i2,22x,e12.5)
        j2 = ilnobl(uxmod(n))
        write (noutpt,3160) uxmod(n)(1:j2),kxmod(n),xlkmod(n)
 3160   format(4x,'species= ',a,
     $  /5x,'option= ',i2,14x,'xlkmod= ',1pe12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
c       iopg(1) = Model for aqueous species activity coefficients:
c         -1 = The  Davies equation
c          0 = The B-dot equation
c          1 = Pitzer's  equations
c          2 = HC + DH equations
c
c       iopg(2) = Rescaling of aqueous ionic activity coefficients for
c                   consistency with a desired pH scale:
c         -1 = "Internal" pH scale; no scaling (e.g., the "Davies"
c                scale if iopg(1) = -1, the "B-dot" scale if
c                iopg(1) = 0, or the Pitzer scale if iopg(1) = 1)
c          0 = The NBS pH scale (log gamma(Cl-) is defined by the
c                Bates-Guggenheim equation)
c          1 = The Mesmer pH scale (log gamma(H+) = 0)
c
c       iopg(3) = iopg(10) = Not used
c
      read (ninpts,3170,err=990) (iopg(i), i = 1,20)
 3170 format(12x,10i5)
      write (noutpt,1200)
      write (noutpt,3180) (iopg(i), i = 1,20)
 3180 format(3x,'iopg1-10= ',10i5,/2x,'iopg11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
c       kct    = the number of elements in the matrix
c       kbt    = the number of basis species in the matrix
c       kmt    = position of last pure mineral in the matrix
c       kxt    = position of last solid solution in the matrix
c       kdim   = size of the matrix
c       kprs   = flag to read input for initializing the physically
c                  removed system (PRS)
c
      read (ninpts,3220,err=990) kct,kbt,kmt,kxt,kdim,kprs
 3220 format(3(12x,i2,10x),/3(12x,i2,10x))
      write (noutpt,3230) kct,kbt,kmt,kxt,kdim,kprs
 3230 format(8x,'kct= ',i2,17x,'kbt= ',i2,17x,'kmt= ',i2,/
     $ 8x,'kxt= ',i2,16x,'kdim= ',i2,16x,'kprs= ',i2)
c
      nbti = kbt
c
      if (kct .gt. nctmax) then
        write (noutpt,3240) nctmax
        write (nttyo,3240) nctmax
 3240   format(/' * Error - (EQ6/rd6inw) Have too many chemical',
     $  /7x,'elements present. The code is only dimensioned',
     $  /7x,'for ',i3,' elements. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      if (kbt .gt. nbtmax) then
        write (noutpt,3250) nbtmax
        write (nttyo,3250) nbtmax
 3250   format(/' * Error - (EQ6/rd6inw) Have too many basis',
     $  /7x,'species present. The code is only dimensioned',
     $  /7x,'for ',i3,' basis species. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      if (kdim .gt. kmax) then
        write (noutpt,3260) kmax
        write (nttyo,3260) kmax
 3260   format(/' * Error - (EQ6/rd6inw) Have too many matrix',
     $  /7x,'variables. The code is only dimensioned for ',i3,
     $  /7x,'matrix variables. Reduce the number of such variables',
     $  /7x,'or increase the dimensioning parameter kpar.')
        go to 990
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
c       ubmtbi = names of the data file basis species for which mass
c                  balances are defined
c       jflgi  = jflag input for basis species
c          0 = Retain as an active basis species
c         30 = Convert to a dependent species; fold the mass balance
c                total for this species into the mass balance totals
c                of basis species which remain active
c
      write (noutpt,3330)
 3330 format(' * Data file basis species and jflag values')
c
      do nbi = 1,nbti
        read (ninpts,3340,err=990) ubmtbi(nbi),jflgi(nbi)
 3340   format(3x,a48,3x,i2)
        write (noutpt,3350) ubmtbi(nbi),jflgi(nbi)
 3350   format(4x,a48,3x,i2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
c       mtbi   = total number of moles of basis species in the
c                  equilibrium system (ES)
c       mtbaqi = total number of moles of basis species in the
c                  aqueous solution
c       electr = electrical imbalance
c
      write (noutpt,3400)
 3400 format(' *',7x,
     $ 'Mass balance totals     Aqueous mass balance totals')
c
      do nbi = 1,nbti
        read (ninpts,3410,err=990) mtbi(nbi),mtbaqi(nbi)
 3410   format(6x,e22.15,6x,e22.15)
        write (noutpt,3420) mtbi(nbi),mtbaqi(nbi)
 3420   format(7x,1pe22.15,6x,e22.15)
      enddo
      read (ninpts,3430,err=990) electr
 3430 format(34x,e22.15)
      write (noutpt,3440) electr
 3440 format(10x,'Electrical imbalance= ',3x,1pe22.15)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
c       nobswt = the number of ordinary basis switches
c       uobsw(1,n) = the species to be switched from the basis
c                      set in the n-th switch
c       uobsw(2,n) = the species to be switched into the basis
c                      set in the n-th switch
c
      write (noutpt,3450)
 3450 format(' *   Ordinary basis switches')
c
      read (ninpts,2620,err=990) nobswt
      write (noutpt,3460) nobswt
 3460 format(5x,'nobswt= ',i3)
c
      do n = 1,nobswt
        read (ninpts,2640,err=990) uobsw(1,n)
        j2 = ilnobl(uobsw(1,n))
        write (noutpt,2650) uobsw(1,n)(1:j2)
c
        read (ninpts,2660,err=990) uobsw(2,n)
        j2 = ilnobl(uobsw(2,n))
        write (noutpt,2670) uobsw(2,n)(1:j2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables.
c
c       uzveci = names of species or properties associated with the
c                  matrix column variables
c
      write (noutpt,3470)
 3470 format(' * Matrix species or entities')
c
      do krow = 1,kdim
        read (ninpts,3480,err=990) uzveci(krow)
 3480   format(3x,a48)
        j2 = ilnobl(uzveci(krow))
        write (noutpt,3490) uzveci(krow)(1:j2)
 3490   format(4x,a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix variable values.
c
c       zvclg1 = values of matrix variables
c
      write (noutpt,3510)
 3510 format(' *   Values of matrix variables')
      do kcol = 1,kdim
        read (ninpts,3520,err=990) zvclgi(kcol)
 3520   format(3x,e22.15)
        write (noutpt,3530) zvclgi(kcol)
 3530   format(4x,1pe22.15)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize any non-zero values for the physically removed
c     system. Here mprphi and mprspi are arrays for the number of
c     moles of phases and species, respectively, in the PRS.
c
      nprpti = 0
      nprsti = 0
      if (kprs .gt. 0) then
        write (noutpt,3600)
 3600   format(' *  Phases and species in the PRS')
        j3 = ilnobl(uendit)
        do npi = 1,nprpmx + 1
          read (ninpts,3610,err=990) uxf,mx
 3610     format(1x,a24,6x,e22.15)
          if (uxf(1:8) .eq. uendit(1:8)) then
            write (noutpt,3620) uendit(1:j3)
 3620       format(2x,a)
            go to 310
          else
            write (noutpt,3630) uxf,mx
 3630       format(2x,a24,6x,1pe22.15)
          endif
          nprpti = nprpti + 1
c
          if (nprpti .gt. nprpmx) then
            write (noutpt,3640) nprpmx
            write (nttyo,3640) nprpmx
 3640       format(/' * Error - (EQ6/rd6inw) Have too many phases',
     $      /7x,'in the physically removed system (PRS) on the',
     $      /7x,'input file. The code is only dimensioned for ',i3,
     $      /7x,'such phases. Reduce the number of such phases',
     $      /7x,'or increase the dimensioning parameter nprppa.')
            go to 990
          endif
c
          uprphi(nprpti)(1:24) = uxf
          mprphi(nprpti) = mx
c
          do iki = 1,iktmax + 1
            read (ninpts,3650,err=990) uxg,mx
 3650       format(3x,a24,6x,e22.15)
            if (uxg(1:8) .eq. uendit(1:8)) then
              write (noutpt,3660) uendit(1:j3)
 3660         format(4x,a)
              go to 300
            else
              write (noutpt,3670) uxg,mx
 3670         format(4x,a24,6x,1pe22.15)
            endif
c
            if (iki .gt. iktmax) then
              j2 = ilnobl(uxf)
              write (noutpt,3680) uxf(1:j2),iktmax
              write (nttyo,3680) uxf(1:j2),iktmax
 3680         format(/' * Error - (EQ6/rd6inw) Have too many',
     $        ' end-members',/7x,'in the PRS solid solution ',a,'.',
     $        /7x,'The code is only dimensioned for ',
     $        i4,' end-members per',/7x,'solid solution. Reduce',
     $        ' the number of end-members or',
     $        /7x,'increase the dimensioning parameter iktpar.')
              go to 990
            endif
c
            nprsti = nprsti + 1
c
            if (nprsti .gt. nprsmx) then
              write (noutpt,3690) nprsmx
              write (nttyo,3690) nprsmx
 3690         format(/' * Error - (EQ6/rd6inw) Have too many species',
     $        /7x,'in the physically removed system (PRS) on the',
     $        /7x,'input file. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter nprspa.')
              go to 990
            endif
c
            uprspi(nprsti)(1:24) = uxg
            uprspi(nprsti)(25:48) = uxf
            mprspi(nprsti) = mx
          enddo
  300     continue
        enddo
c
  310   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,4000) nprob
      write (nttyo,4000) nprob
 4000 format(/'   Done reading problem ',i3,'.',/)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrderr = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      integer function idamax(nmax,array,incx)
c
c     This subroutine finds the index of the element corresponding to
c     the max norm of the real*8 array "array". If there is more than
c     one such element, the index returned corresponds to the first one.
c     This subroutine is an adaptation of the 1979 Linpack subroutine of
c     the same name. The size and order in the original calling sequence
c     has been preserved: (n,dx,incx) == (nmax,array,incx).
c     The increment incx is not used here (it is taken as having
c     a value of 1; input of any other value constitutes an error).
c     This is a pseudo-Linpack BLAS (Basic Linear Algebra Subsystem)
c     subroutine.
c
c     This subroutine is nearly identical to EQLIBU/iarmnx.f, for which
c     the calling sequence arguments are reversed.
c
c     This subroutine is called by:
c
c       EQLIBU/dgefa.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nmax   = dimension or pseudo-dimension of array
c       array  = the array
c       incx   = the increment (must have a value of 1)
c
c     Output:
c
c       idamax = index of the element corresponding to the max norm
c                  (zero if nmax .le. 0)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
      integer incx
c
      real*8 array(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft,ix,j
c
      real*8 aax,arrmxn
c
c-----------------------------------------------------------------------
c
c     Trap illegal value of incx.
c
      if (incx .ne. 1) then
        write (6,1000) incx
 1000   format(/' * Error - (EQLIBU/idamax) The argument incx has a',
     $  /7x,'value of ',i5,'. This version of idamax only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
      idamax = 0
      arrmxn = 0.
      if (nmax .le. 0) go to 999
c
c     Note the use of a local variable (ix) within the loop.
c     Note also that the loop is unrolled.
c
      ix = 0
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        aax = abs(array(i))
        if (aax .gt. arrmxn) then
          ix = i
          arrmxn = aax
        endif
        j = i + 1
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 2
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 3
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 4
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 5
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 6
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
        j = i + 7
        aax = abs(array(j))
        if (aax .gt. arrmxn) then
          ix = j
          arrmxn = aax
        endif
      enddo
c
      do i = ileft + 1,nmax
        aax = abs(array(i))
        if (aax .gt. arrmxn) then
          ix = i
          arrmxn = aax
        endif
      enddo
c
      idamax = ix
c
  999 continue
      end

      subroutine cliefu()
c
c     This subroutine clears the IEEE flag for floating-point underflow,
c     if such a flag is present, to avoid getting an unnecessary system
c     warning message. Underflow is a normal condition in EQ3/6.
c
c     The presence of an IEEE flag for underflow is platform and
c     compiler dependent. If the flag is present, the need to clear
c     it may also depend on the platform and compiler. Currently,
c     the flag is present and needs to be cleared on Sun SPARCstations
c     in the case of Sun's Fortran 77 compiler. This is not the case
c     with any Fortran 90 compiler that has been seen to date,
c     including Sun's.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
com   BEGIN_SPARC_DEPENDENT_CODE
com     BEGIN_F77_DEPENDENT_CODE
com
com       Here cieeef() is a C subroutine that is distributed with
com       EQ3/6. The object file is usually attached to the library
com       (.a) file for the EQLIBU library, for convenience in linking.
com
c         call cieeef()
c         go to 999
com
com     END_F77_DEPENDENT_CODE
com   END_SPARC_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $ nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $ ureac,uspec)
c
c     This subroutine writes the reaction for the nsr-th special
c     reactant on the file whose unit number is nf.
c
c     This subroutine is similar in function to EQLIB/prreac.f, which
c     writes an ordinary reaction.
c
c     This subroutine is called by:
c
c       EQ6/chzrsr.f
c       EQ6/ckfrsr.f
c       EQ6/echoz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cbsr   = array of coefficients for reactions for special
c                  reactants
c       nbtmax = the maximum number of basis species
c       nbt1mx = the maximum number of basis species plus 1
c       nf     = the unit number of the file on which to write the
c                  reaction
c       nrc    = the reactant index of the special reactant whose
c                  reaction is to be printed
c       nsrtmx = the maximum number of special reactants
c       ureac  = array of names of reactants
c       uspec  = array of names of species
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nf,noutpt,nttyo
c
      integer nbtmax,nbt1mx,nrctmx,nsrtmx,nstmax
c
      integer jcode(nrctmx),nbaspd(nbtmax),nrndex(nrctmx)
c
      integer nbtd,nrc
c
      character*48 uspec(nstmax)
      character*24 ureac(nrctmx)
c
      real*8 cbsr(nbt1mx,nsrtmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,j2,nb,ns,nsr
c
      integer ilnobl
c
      logical qfirst
c
      character*56 uspn56
c
      real*8 cx
c
c-----------------------------------------------------------------------
c
c     Make sure that the reactant is a special reactant.
c
      if (jcode(nrc) .ne. 2) then
        j2 = ilnobl(ureac(nrc))
        write (noutpt,1000) ureac(nrc)(1:j2)
        write (nttyo,1000) ureac(nrc)(1:j2)
 1000   format(/' * Error - (EQ6/prrsr.f) Programming error trap: this',
     $  ' subroutine was called',/7x,'to print the reaction for the',
     $  ' special reactant ',a,'. However,',/7x,'this reactant is not',
     $  ' a special reactant.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the special reactant index.
c
      nsr = nrndex(nrc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (nf,1020)
 1020 format(1x)
c
c     The reactant.
c
      cx = -cbsr(nbt1mx,nsr)
      j2 = ilnobl(ureac(nrc))
      write (nf,1030) cx,ureac(nrc)(1:j2)
 1030 format(6x,1pe22.15,2x,a)
c
c     Reactants exclusive of the special reactant.
c
      do nb = 1,nbtd
        cx = cbsr(nb,nsr)
        if (cx .lt. 0.) then
          cx = -cx
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (nf,1040) cx,uspn56(1:jlen)
 1040     format(4x,'+ ',1pe22.15,2x,a)
        endif
      enddo
c
      write (nf,1050)
 1050 format(18x,'==')
c
c     Products.
c
      qfirst = .true.
      do nb = 1,nbtd
        cx = cbsr(nb,nsr)
        if (cx .gt. 0.) then
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          if (qfirst) then
            write (nf,1030) cx,uspn56(1:jlen)
            qfirst = .false.
          else
            write (nf,1040) cx,uspn56(1:jlen)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine intbs6(jflag,jflgi,kmax,narn1a,narn2a,nbaspd,nbtd,
     $ nbti,nbtmax,ndrsrd,ndecsp,noutpt,nsta,nstmax,nttyo,uspeca,
     $ ubmtbi)
c
c     This subroutine interprets the data file basis species read from
c     the input file. "Data file" species to be created according to
c     directives read from the input file are ignored. This subroutine
c     also sets up the jflag array.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nstmax
c
      integer jflag(nstmax),jflgi(nbtmax),nbaspd(nbtmax),
     $ ndecsp(nbtmax),ndrsrd(2,nstmax)
c
      integer narn1a,narn2a,nbtd,nbti,noutpt,nsta,nttyo
c
      character*56 uspn56
      character*48 uspeca(nstmax),ubmtbi(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,j2,nb,nbi,nerr,ns,nt
c
      integer ilnobl,nbasis
c
      character*8 ux8
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      do ns = 1,nsta
        jflag(ns) = 0
      enddo
c
      do ns = narn1a,narn2a
        jflag(ns) = 30
      enddo
c
      do nb = 1,nbtd
        ns = nbaspd(nb)
        nt = ndrsrd(2,ns) - ndrsrd(1,ns) + 1
        if (nt .lt. 2) jflag(ns) = -1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nbi = 1,nbti
        do ns = 1,nsta
          if (uspeca(ns)(1:48) .eq. ubmtbi(nbi)(1:48)) then
            if (jflgi(nbi).ne.0 .and. jflgi(nbi).ne.30) then
c
c             Calling sequence substitutions:
c               ubmtbi(nbi) for unam48
c
              call fmspnx(jlen,ubmtbi(nbi),uspn56)
              write (ux8,'(i5)') jflgi(nbi)
              call lejust(ux8)
              j2 = ilnobl(ux8)
              write (noutpt,1000) uspn56(1:jlen),ux8(1:j2)
              write (nttyo,1000) uspn56(1:jlen),ux8(1:j2)
 1000         format(/' * Error - (EQ6/intbs6) The species ',a,
     $        /7x,'has an has illegal jflag value of ',a,' on the',
     $        ' input file',/7x,'(the only legal values are 0 and 30).')
              nerr = nerr + 1
            endif
            jflag(ns) = jflgi(nbi)
c
c           Calling sequence substitutions:
c             nbaspd for nbasp
c             nbtd for nbt
c
            nb = nbasis(nbaspd,nbtd,nbtmax,ns)
            if (nb .eq. 0) then
c
c             Add a species to the working basis set.
c
              nbtd = nbtd + 1
              if (nbtd .gt. nbtmax) then
c
c               Calling sequence substitutions:
c                 ubmtbi(nbi) for unam48
c
                call fmspnx(jlen,ubmtbi(nbi),uspn56)
                write (ux8,'(i5)') nbtmax
                call lejust(ux8)
                j2 = ilnobl(ux8)
                write (noutpt,1005) ux8(1:j2),uspn56(1:jlen)
                write (nttyo,1005) ux8(1:j2),uspn56(1:jlen)
 1005           format(/' * Error - (EQ6/intbs6) The maximum ',a,
     $          /7x,'basis species have been exceeded in',
     $          ' interpreting the',/7x,'input file while processing',
     $          ' data file basis species',/7x,a,'. Increase the',
     $          ' dimensioning parameter nbtpar.')
                nerr = nerr + 1
                go to 115
              endif
              nb = nbtd
              nbaspd(nb) = ns
            endif
            ndecsp(nbi) = nb
            go to 115
          endif
        enddo
c
c       Calling sequence substitutions:
c         ubmtbi(nbi) for unam48
c
        call fmspnx(jlen,ubmtbi(nbi),uspn56)
        write (noutpt,1010) uspn56(1:jlen)
        write (nttyo,1010) uspn56(1:jlen)
 1010   format(/' * Note - (EQ6/intbs6) The species "',a,'"',
     $  /7x,'appears as a basis species on the input file, but it',
     $  " wasn't",/7x,'read from the data file. If it is a species',
     $  ' to be created by the code,',/7x,'such as a generic ion',
     $  ' exchanger species, there is no problem.')
c
  115   continue
      enddo
c
      if (nerr .gt. 0) stop
c
      end

      subroutine prtacr(actlg,iopr,jsflag,nbaspd,nbt,nbtmax,nelect,
     $ nhydr,noprmx,no2gaq,noutpt,nstmax,uspec,zchar)
c
c     This subroutine prints a table of cation/H+ activity ratios,
c     anion-H+ activity products, and neutral species activities.
c     Only aqueous basis species are involved. The level of printing
c     is controlled by the print control flag iopr(5):
c
c        0 = Don't print
c        1 = Print cation/H+ activity ratios only
c        2 = Print cation/H+ activity ratios and anion-H+ activity
c              products
c        3 = Print cation/H+ activity ratios, anion-H+ activity
c              products, and neutral species activities
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       actlg  = array of log activities of species
c       iopr   = array of print control options
c       jsflag = array of species status flags
c       nbt    = the number of species in the basis set
c       nelect = index of the fictive species aqueous e-
c       nhydr  = index of the species aqueous H+
c       no2gaq = index of the fictive species aqueous O2(g)
c       uspec  = array of species names
c       zchar  = array of species electrical charge numbers
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,noprmx,nstmax
c
      integer noutpt
c
      integer iopr(noprmx),jsflag(nstmax),nbaspd(nbtmax)
      integer nbt,nelect,nhydr,no2gaq
c
      character*48 uspec(nstmax)
c
      real*8 actlg(nstmax),zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iz,j2,nb,ns
c
      integer ilnobl
c
      real*8 actlh,actrat,zx
c
c-----------------------------------------------------------------------
c
      if (iopr(5) .le. 0) go to 999
      if (iopr(5) .eq. 1) then
        write (noutpt,1000)
 1000   format(/16x,'--- Cation/H+ Activity Ratios ---',/)
      elseif (iopr(5) .eq. 2) then
        write (noutpt,1010)
 1010   format(/16x,'--- Ion-H+ Activity Ratios ---',/)
      elseif (iopr(5) .eq. 3) then
        write (noutpt,1020)
 1020   format(/6x,'--- Ion-H+ Activity Ratios and',
     $  ' Neutral Species Activities ---',/)
      endif
c
      actlh = actlg(nhydr)
c
      do nb = 1,nbt
        ns = nbaspd(nb)
        if (ns .eq. nhydr) go to 100
        if (ns .eq. no2gaq) go to 100
        if (ns .eq. nelect) go to 100
        if (jsflag(ns) .ge. 2) go to 100
        zx = zchar(ns)
        actrat = actlg(ns)
        if (zx .eq. 0.) then
          if (iopr(5) .ge. 3) then
            j2 = ilnobl(uspec(ns)(1:16))
            write (noutpt,1040) uspec(ns)(1:j2),actrat
 1040       format(3x,'Log ( a(',a,') )',t44,'= ',f10.5)
          endif
        else
          actrat = actrat - zx*actlh
          j2 = ilnobl(uspec(ns)(1:16))
          iz = nint(abs(zx))
          if (zx .lt. 0.) then
            if (iopr(5) .ge. 2) then
              write (noutpt,1050) uspec(ns)(1:j2),iz,actrat
 1050         format(3x,'Log ( a(',a,') x a(H+)xx',i2,' )',t44,'= ',
     $        f10.5)
            endif
          else
            write (noutpt,1060) uspec(ns)(1:j2),iz,actrat
 1060       format(3x,'Log ( a(',a,') / a(H+)xx',i2,' )',t44,'= ',
     $      f10.5)
          endif
        endif
  100   continue
      enddo
      write (noutpt,1070)
 1070 format(1x)
c
  999 continue
      end

      subroutine setpk6(actwlg,awmax,awmaxi,awmin,awmini,eh,ehmax,
     $ ehmaxi,ehmin,ehmini,fo2lg,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $ kprs,mprph,mprphi,mprsp,mprspi,mtb,mtbi,mtbaq,mtbaqi,nbasp,
     $ nbaspd,nbaspi,nbti,nbtmax,ncmpr,nobswt,noutpt,nprpmx,nprpti,
     $ nprsmx,nprsti,npt,nptmax,nttyo,nstmax,o2max,o2maxi,o2min,
     $ o2mini,ph,phmax,phmaxi,phmin,phmini,prcinf,press,pressi,
     $ tempc,tempci,time1,timemx,timmxi,tistti,ubmtbi,uobsw,uphase,
     $ uprphi,uprspi,uspec,uzveci,uzvec1,xi1,ximax,ximaxi,xistti,
     $ zvclgi,zvclg1)
c
c     This subroutine sets up certain variables and arrays for writing
c     on the pickup file. This subroutine must be called prior to
c     writing a pickup file.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nprpmx,nprsmx,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),jflag(nstmax),jflgi(nbtmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),nbaspi(nbtmax),ncmpr(2,nptmax)
c
      integer kbt,kdim,kprs,nbti,nobswt,nprpti,nprsti,npt
c
      character*48 ubmtbi(nbtmax),uobsw(2,nbtmax),uprspi(nprsmx),
     $ uspec(nstmax),uzveci(kmax),uzvec1(kmax)
      character*24 uphase(nptmax),uprphi(nprpmx)
c
      real*8 mprph(nptmax),mprphi(nprpmx),mprsp(nstmax),mprspi(nprsmx),
     $ mtb(nbtmax),mtbi(nbtmax),mtbaq(nbtmax),mtbaqi(nbtmax),
     $ zvclgi(kmax),zvclg1(kmax)
c
      real*8 actwlg,awmax,awmaxi,awmin,awmini,eh,ehmax,ehmaxi,ehmin,
     $ ehmini,fo2lg,o2max,o2maxi,o2min,o2mini,ph,phmax,phmaxi,phmin,
     $ phmini,prcinf,press,pressi,tempc,tempci,time1,timemx,timmxi,
     $ tistti,xi1,ximax,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,kcol,krow,n,nb,nbi,nerr,nmax,np,nr1,nr2,ns,nsi,ns1,ns2
c
      integer ilnobl
c
      character*8 ux8
      character*24 uaqsln
c
c-----------------------------------------------------------------------
c
      data uaqsln /'Aqueous solution        '/
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting values of reaction progress and time.
c
      xistti = xi1
      tistti = time1
c
c     Maximum values of reaction progress and time.
c
      if (xi1 .ge. ximax) ximaxi = prcinf
      if (time1 .ge. timemx) timmxi = prcinf
c
c     Minimum and maximum values of other quantities.
c
      if (pH .le. phmin) phmini = -prcinf
      if (pH .ge. phmax) phmaxi = prcinf
      if (eh .le. ehmin) ehmini = -prcinf
      if (eh .ge. ehmax) ehmaxi = prcinf
      if (fo2lg .le. o2min) o2mini = -prcinf
      if (fo2lg .ge. o2max) o2maxi = prcinf
      if (actwlg .le. awmin) awmini = -prcinf
      if (actwlg .ge. awmax) awmaxi = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      tempci = tempc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      pressi = press
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals and jflag values.
c
      call initaz(mtbi,nbtmax)
      call initaz(mtbaqi,nbtmax)
      call initiz(jflgi,nbtmax)
c
      do krow = 1,kbt
        nb = iindx1(krow)
        ns = nbaspd(nb)
        nsi = nbaspi(nb)
        nbi = krow
        ubmtbi(nbi) = uspec(nsi)
        mtbi(nbi) = mtb(nb)
        mtbaqi(nbi) = mtbaq(nb)
        jflgi(nbi) = jflag(ns)
      enddo
      nbti = kbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switching directives.
c
      nmax = 2*nbtmax
      call initcb(uobsw,nmax)
c
      n = 0
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (ns1 .ne. ns2) then
          n = n + 1
          uobsw(1,n) = uspec(ns1)
          uobsw(2,n) = uspec(ns2)
        endif
      enddo
      nobswt = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables and corresponding values.
c
      call initcb(uzveci,kmax)
      call initaz(zvclgi,kmax)
c
      do kcol = 1,kdim
        uzveci(kcol) = uzvec1(kcol)
        zvclgi(kcol) = zvclg1(kcol)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Phases and species in the PRS.
c
      kprs = 0
      nprpti = 0
      nprsti = 0
c
      call initcb(uprphi,nprpmx)
      call initcb(uprspi,nprsmx)
      call initaz(mprphi,nprpmx)
      call initaz(mprspi,nprsmx)
c
      do np = 1,npt
        if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
          if (mprph(np) .gt. 0.) then
            nprpti = nprpti + 1
c
            if (nprpti .gt. nprpmx) then
              write (ux8,'(i5)') nprpmx
              call lejust(ux8)
              j2 = ilnobl(ux8)
              write (noutpt,1000) ux8(1:j2)
              write (nttyo,1000) ux8(1:j2)
 1000         format(/' * Error - (EQ6/setpk6) Have too many phases',
     $        ' in the physically removed system',/7x,'(PRS) to write',
     $        ' them all on the pickup file. The code is only',
     $        ' dimensioned',/7x,'to allow ',a,' such phases on the',
     $        ' input and pickup files. Increase',/7x,'the',
     $        ' dimensioning parameter nprppa.')
              nerr = nerr + 1
            endif
c
            uprphi(nprpti) = uphase(np)
            mprphi(nprpti) = mprph(np)
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do ns = nr1,nr2
              if (mprsp(ns) .gt. 0.) then
                nprsti = nprsti + 1
c
                if (nprsti .gt. nprsmx) then
                  write (ux8,'(i5)') nprsmx
                  call lejust(ux8)
                  j2 = ilnobl(ux8)
                  write (noutpt,1010) ux8
                  write (nttyo,1010) ux8
 1010             format(/' * Error - (EQ6/setpk6) Have too many',
     $            ' species in the physically removed system',
     $            /7x,'(PRS) to write them all on the pickup file.',
     $            ' The code is only dimensioned',/7x,'to allow ',a,
     $            ' such species on the input and pickup files.',
     $            ' Increase',/7x,'the dimensioning parameter nprspa.')
                  nerr = nerr + 1
                endif
c
                uprspi(nprsti) = uspec(ns)
                mprspi(nprsti) = mprsp(ns)
              endif
            enddo
          endif
        endif
      enddo
      if (nprpti .gt. 0) kprs = 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine dfaltz(dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltplo,dltpll,dltprl,dltprn,dlxdmp,dlxmx0,
     $ dlxplo,dlxpll,dlxprl,dlxprn,iopt,itermx,ksplmx,ksppmx,kstpmx,
     $ net,noptmx,nordmx,nrct,noutpt,ntrymx,nttyo,prcinf,qecon,qscon,
     $ timmxi,tistti,tolbt,toldl,tolsat,tolxsf,tolxst,tolxsu,
     $ ximaxi,xistti)
c
c     This subroutine sets the defaults for various run parameters read
c     from the input file. In some cases, it forces the parameters to
c     take on certain values, or to fall in certain ranges.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noptmx
c
      integer noutpt,nttyo
c
      integer iopt(noptmx)
c
      integer itermx,ksplmx,ksppmx,kstpmx,net,nordmx,nrct,ntrymx
c
      logical qecon,qscon
c
      real*8 dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $ dltplo,dltpll,dltprl,dltprn,dlxdmp,dlxmx0,dlxplo,dlxpll,
     $ dlxprl,dlxprn,prcinf,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,
     $ tolxst,tolxsu,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
c     Iopt(1): Physical system model option.
c
      if (iopt(1) .lt. 0) then
        write (noutpt,1000) iopt(1)
        write (nttyo,1000) iopt(1)
 1000   format(/' * Note - (EQ6/dfaltz) The value of iopt(1) is ',i3,
     $  ',',/7x,'which is out of range. Resetting iopt(1) to 0.')
        iopt(1) = 0
      endif
c
      if (iopt(1) .gt. 2) then
        write (noutpt,1010) iopt(1)
        write (nttyo,1010) iopt(1)
 1010   format(/' * Note - (EQ6/dfaltz) The value of iopt(1) is ',i3,
     $  ',',/7x,'which is out of range. Resetting iopt(1) to 2.')
        iopt(1) = 2
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt(3): Phase boundary search option.
c
      if (iopt(3).gt.0 .and. iopt(1).ge.2) then
        write (noutpt,1020) iopt(3),iopt(1)
        write (nttyo,1020) iopt(3),iopt(1)
 1020   format(/' * Note - (EQ6/dfaltz) The value of iopt(3) is ',i3,
     $  ',',/7x,'which is not valid because iopt(1) is ',i3,'.',
     $  /7x,'Resetting iopt(3) = 0.')
        iopt(3) = 0
      endif
c
      if (iopt(3).gt.0 .and. iopt(2).ge.1) then
        write (noutpt,1030) iopt(3),iopt(2)
        write (nttyo,1030) iopt(3),iopt(2)
 1030   format(/' * Note - (EQ6/dfaltz) The value of iopt(3) is ',i3,
     $  ',',/7x,'which is not valid because iopt(2) is ',i3,'.',
     $  /7x,'Resetting iopt(3) = 0.')
        iopt(3) = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum value of Xi.
c
      if (ximaxi .lt. xistti) then
        write (noutpt,1040)
        write (nttyo,1040)
 1040   format(/' * Note - (EQ6/dfaltz) The maximum value of reaction',
     $  /7x,'progress (ximaxi) is less than the starting value',
     $  ' (xistti).',/7x,'The maximum value is being reset to',
     $  ' infinity.')
        ximaxi = prcinf
      endif
      if (ximaxi .gt. prcinf) ximaxi = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum value of time.
c
      if (timmxi .lt. tistti) then
        write (noutpt,1050)
        write (nttyo,1050)
 1050   format(/' * Note - (EQ6/dfaltz) The maximum value of time',
     $  /7x,'(timmxi) is less than the starting value (tistti).',
     $  /7x,'The maximum value is being reset to infinity.')
        timmxi = prcinf
      endif
      if (timmxi .gt. prcinf) timmxi = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of steps.
c
      if (kstpmx .lt. 0) kstpmx = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Newton-Raphson beta tolerance.
c
      if (iopt(2) .le. 0) then
        if (tolbt .le. 0.) tolbt = 1.e-6
        if (tolbt .lt. 1.e-10) tolbt = 1.e-10
        if (tolbt .gt. 1.e-4) tolbt = 1.e-4
      else
        if (tolbt .le. 0.) tolbt = 1.e-8
        if (tolbt .lt. 1.e-10) tolbt = 1.e-10
        if (tolbt .gt. 1.e-6) tolbt = 1.e-6
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Newton-Raphson del tolerance.
c
      if (iopt(2) .le. 0) then
        if (toldl .le. 0.) toldl = 1.e-6
        if (toldl .lt. 1.e-10) toldl = 1.e-10
        if (toldl .gt. 1.e-4) toldl = 1.e-4
      else
        if (toldl .le. 0.) toldl = 1.e-8
        if (toldl .lt. 1.e-10) toldl = 1.e-10
        if (toldl .gt. 1.e-6) toldl = 1.e-6
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum finite-difference order.
c
      if (nordmx .eq. 0) nordmx = 6
      if (nordmx .lt. 1) nordmx = 1
      if (nordmx .gt. 8) nordmx = 8
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of Newton-Raphson iterations.
c
      if (itermx .le. 0) itermx = 200
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of tries to find the correct phase assemblage.
c
      if (ntrymx .le. 0) ntrymx = 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary search/find tolerance.
c
      if (tolxsf .le. 0.) tolxsf = 1.e-6
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search tolerance on time (relative).
c
      if (tolxst .le. 0.) tolxst = 1.e-8
      if (tolxst .lt. 1.e-12) tolxst = 1.e-12
      if (tolxst .gt. 1.e-4) tolxst = 1.e-4
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search tolerance on pH, Eh, log fO2, and activity of water
c     (linear).
c
      if (tolxsu .le. 0.) tolxsu = 1.e-5
      if (tolxsu .lt. 1.e-8) tolxsu = 1.e-8
      if (tolxsu .gt. 1.e-4) tolxsu = 1.e-4
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation tolerance.
c
      if (tolsat .le. 0.) tolsat = 0.0005
      if (tolsat .lt. 0.00005) tolsat = 0.00005
      if (tolsat .gt. 0.05) tolsat = 0.05
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Limits on Newton-Raphson delta tolerance.
c
      if (tolxsf .lt. 1.e-10) toldl = 1.e-10
      if (tolxsf .gt. 1.e-2) toldl = 1.e-2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero-order step size.
c
      if (dlxmx0 .le. 0.) then
        dlxmx0 = 1.e-8
        if (iopt(2) .ge. 1) dlxmx0 = 1.e-9
        if (iopt(1) .ge. 2) dlxmx0 = 1.e-9
        if (qecon) dlxmx0 = 1.e-6
        if (nrct .le. 0) dlxmx0 = 1.e-2
        if (qscon) then
          if (dlxprn.gt.0.) then
            dlxmx0 = dlxprn
          elseif (ximaxi .gt. xistti) then
            dlxmx0 = 0.1*(ximaxi - xistti)
          endif
        endif
      endif
c
      if (dlxmx0 .lt. 1.e-12) dlxmx0 = 1.e-12
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in Xi.
c
      if (dlxprn .le. 0.) dlxprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in log Xi.
c
      if (dlxprl .le. 0.) dlxprl = 0.5
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in time (seconds).
c
      if (dltprn .le. 0.) dltprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in log time.
c
      if (dltprl .le. 0.) dltprl = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in pH.
c
      if (dlhprn .le. 0.) dlhprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in Eh (v).
c
      if (dleprn .le. 0.) dleprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in log fO2.
c
      if (dloprn .le. 0.) dloprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in activity of water.
c
      if (dlaprn .le. 0.) dlaprn = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval in steps.
c
      if (ksppmx .le. 0) ksppmx = 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in Xi.
c
      if (dlxplo .le. 0.) dlxplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in log Xi.
c
      if (dlxpll .le. 0.) dlxpll = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in pH.
c
      if (dlhplo .le. 0.) dlhplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in Eh (v).
c
      if (dleplo .le. 0.) dleplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in log fO2.
c
      if (dloplo .le. 0.) dloplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in activity of water.
c
      if (dlaplo .le. 0.) dlaplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in time (seconds).
c
      if (dltplo .le. 0.) dltplo = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in log time.
c
      if (dltpll .le. 0.) dltpll = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval in steps.
c
      if (ksplmx .le. 0.) ksplmx = 10000
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     PRS transfer interval in Xi.
c
      if (dlxdmp .le. 0.) then
        if (iopt(1) .le. 1) then
c
c         Have the titration model or the closed system model.
c
          dlxdmp = prcinf
        elseif (iopt(1) .eq. 2) then
c
c         Have the fluid-centered, flow-through open system model.
c
          dlxdmp = prcinf
          if (iopt(4).ge.1 .or. net.gt.0) then
            if (ximaxi .gt. 0.) then
              dlxdmp = ximaxi/25.
            else
              dlxdmp = 1.e-6
            endif
          endif
        endif
      endif
c
      if (iopt(1) .eq. 2) then
        if (iopt(4).ge.1 .or. net.gt.0) then
c
c         Have solid solutions or generic ion exchangers, or both.
c         Make sure the PRS transfer interval is no greater then the
c         linear plot interval.
c
          if (dlxdmp .gt. dlxplo) dlxdmp = dlxplo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gbdot(acflgc,actwlc,adh,al10,azero,bdh,bdot,cco2,
     $ fxi,insgf,narn1,narn2,natmax,nstmax,omega,sigmam,tempk,
     $ xbrwlc,zchar,zchsq2)
c
c     This subroutine computes activity coefficients of aqueous species
c     using the B-dot equation and a set of related approximations.
c     This model is suitable only for relatively dilute solutions
c     (ionic strength no greater than one molal, though demonstrable
c     inaccuracy appears at much lower values).
c
c     The B-dot equation is an extended Debye-Huckel equation (Helgeson,
c     1969). It is applied only to electrically charged species. The
c     activity coefficients of electrically neutral solute species are
c     treated according to the value of the insgf flag. If it is -1,
c     the activity coefficient is computed from the Drummond (1981)
c     equation. This is a fit of the log activity coefficient of
c     CO2(aq) as a function of temperature and ionic strength (ignoring
c     ion pairing) in pure aqueous sodium chloride solutions. This is
c     an appropriate treatment for neutral species that are nonpolar.
c     If insgf is 0, the log activity coefficient is set to zero.
c     The activity of water is computed from an equation which was
c     derived from the B-dot equation using thermodynamic consistency
c     relations, though it is actually consistent with that equation
c     only for the case of all ions having the same size and an
c     electrical charge of +1 or -1.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       azero  = hard core diameter array
c       bdh    = Debye-Huckel B parameter
c       bdot   = B-dot parameter
c       cco2   = coefficients of the Drummond (1981) equation
c       insgf  = flag array for electrically neutral solute species
c       omega  = water constant; ~55.51.
c       sigmam = sum of solute molalities
c       xbrwlc = log mole fraction of water
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       zchar  = electrical charge array
c       zchsq2 = one-half the charge squared array
c
c      Principal output:
c
c       acflgc = log activity coefficient array
c       actwlc = log activity of water
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nstmax
c
      integer insgf(natmax)
      integer narn1,narn2
c
      real*8 acflgc(nstmax),azero(natmax),cco2(5),zchar(nstmax),
     $ zchsq2(nstmax)
      real*8 actwlc,adh,al10,bdh,bdot,fxi,omega,sigmam,tempk,xbrwlc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer na,ns
c
      real*8 acfco2,art,bdtfxi,brt,fxisqt,sga,sgx,xx,xxp1
c
c-----------------------------------------------------------------------
c
      fxisqt = sqrt(fxi)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute log lambda(w).
c
      xx = 4.0*bdh*fxisqt
      xxp1 = xx + 1.
      sgx = (3./(xx**3)) * ( xxp1 - (1./xxp1) - 2.*log(xxp1) )
      sga = sigmam/al10
      actwlc = ( -sga + 2.*adh*(fxi**1.5)*sgx/3. - bdot*fxi*fxi )/omega
      acflgc(narn1) = actwlc - xbrwlc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute log gamma(i).
c
c     Compute the log activity coefficient of CO2(aq), using the
c     equation proposed by Drummond (1981, thesis, Penn State
c     University).
c
      acfco2 = ( cco2(1) + cco2(2)*tempk + cco2(3)/tempk )*fxi
     $ - ( cco2(4) + cco2(5)*tempk )*(fxi/(fxi + 1.))
      acfco2 = acfco2/al10
c
      art = 2*adh*fxisqt
      brt = bdh*fxisqt
      bdtfxi = bdot*fxi
c
      do ns = narn1 + 1,narn2
        na = ns - narn1 + 1
        if (zchar(ns) .ne. 0.) then
c
c         Have an ion. Use the B-dot equation.
c
          acflgc(ns)  = -( (art*zchsq2(ns)) / (1.0 + brt*azero(na)) )
     $    + bdtfxi
        else
c
c         Have a neutral species.
c
          if (insgf(na) .le. -1) then
c
c           For nonpolar species, using the result for CO2(aq) from
c           the Drummond (1981) equation.
c
            acflgc(ns) = acfco2
          else
c
c           For polar species, assign a log gamma value of zero.
c
            acflgc(ns) = 0.
          endif
        endif
      enddo
c
      end

      subroutine ngcadv(abar,acflg,acflgo,actwlc,adh,adhh,adhv,
     $ afcnst,al10,aphi,azero,a3bar,a3bars,bacfmx,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,bgamx,bpx,bsigmm,bfje,bfxi,cco2,cgexj,
     $ chfacf,chfsgm,conc,delam,dgpit,dpelm,dpslm,dselm,elam,
     $ eps100,fje,fjeo,fxi,fxio,gpit,ibpxt,ielam,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilzeta,insgf,iopg,iter,ipndx1,ixrn1,
     $ ixrn2,izmax,jcsort,jern1,jern2,jgext,jsol,kx1,kxt,nalpha,
     $ napt,narn1,narn2,nchlor,ncmpr,net,nhydr,nmut,nmux,nmxi,
     $ nmxx,noutpt,nslt,nslx,nst,nsxi,nsxx,nttyo,omega,palpha,
     $ pelm,pmu,press,pslamn,pslm,qhawep,qpit75,qpracf,q6mode,
     $ rlxgam,selm,sigmam,sigmmo,tempk,ubacmx,ubgamx,uphase,
     $ uspec,wfac,xbar,xbarlg,xbarwc,xbrwlc,zchar,zchcu6,zchsq2)
c
c     This subroutine recalculates the ionic strength, etc., and the
c     activity of water and the molal activity coefficients of aqueous
c     species. If necessary, it also recalculates the mole fraction
c     activity coefficients of solid solution components. The
c     values for the above parameters returned by this subroutine are
c     subject to under-relaxation controls intended to aid convergence,
c     particularly in the case of concentrated aqueous solutions.
c     Associated residual functions such as bsigmm, bfxi, and bgamx
c     are not affected by this under-relaxation.
c
c     This subroutine no longer recalculates the concentrations and
c     other properties of dependent species.
c
c     This subroutine is called by:
c
c       EQLIB/newton.f
c       EQ3NR/arrset.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       acflgo = array of old values of the activity coefficients of
c                  the various species
c       aphi   = Debye-Huckel A(phi) parameter
c       azero  = array of hard core diameters of aqueous species
c       bdh    = Debye-Huckel B(gamma) parameter
c       bdot   = B-dot parameter
c       cco2   = coefficients of the Drummond (1981) equation
c       conc   = array of species concentrations
c       fjeo   = old value of the ionic asymmetry (J)
c       fxio   = old value of the ionic strength (I)
c       ibpxt  = array of the numbers of non-zero site-mixing
c                  paramters for computing activity coefficients in
c                  solid solutions
c       ielam  = flag to not use (-1) or use (0) "higher order"
c                  (higher than 2nd order) electrostatic terms in
c                  those activity coefficient models which contain
c                  provision for such terms
c       insgf  = array of activity coefficient flags for aqueous
c                  species, used in the case of neutral solute
c                  species when using the B-dot model
c       iopg   = array of activity coefficient option switches
c       iter = Newton-Raphson iteration number
c       izmax  = max norm of the electrical charges of the aqueous
c                  species
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       jsol   = array of identifiers for solid solution activity
c                  coefficient models
c       narn1  = index of the first aqueous species; this is also
c                  the index of the solvent, water
c       narn2  = index of the last aqueous species
c       nchlor = index of the aqueous chloride ion
c       ncmpr  = array giving the range of species belonging to a given
c                  phase: ncmpr(1,np) is the first such species for the
c                  np-th phase, and ncmpr(2,np) is the last such species
c       nhydr  = index of the aqueous hydrogen ion
c       omega  = water constant; ~55.51
c       press  = pressure, bars
c       qpracf = debugging print flag, causes print of activity
c                  coefficient update
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6NR
c       rlxgam = reported under-relaxation factor applied to corrections
c                  in the activity coefficients of aqueous species
c       sigmmo = old value of sigmam
c       tempk  = temperature, K
c       uphase = array of phase names
c       uspec  = array of species names
c       wfac   = array of non-ideality parameters for solid solutions
c       xbarwc = mole fraction of water (calculated)
c       xbrwlc = log mole fraction of water (calculated)
c       zchar  = array of electrical charge numbers for the various
c                  species
c       zchsq2 = array of (z**2)/2 values
c       zchcu6 = array of (z**3/)6 values
c
c     Principal output:
c
c       abar     average ion size
c       acflg  = array of log activity coefficients of the various
c                  species
c       actwlc = log activity of water (calculated)
c       a3bar    average cube of distance of closest apporach
c       a3bars   characteristic average cube of distance of closest
c                  apporach for each solute species
c       fje    = the ionic asymmetry (the 3rd-order electrostatic
c                  moment function J)
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       sigmam = the sum of solute molalities
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),insgf(natmax),iopg(nopgmx),ipndx1(kmax),
     $ jcsort(nstmax),jern1(jetmax,netmax),jern2(jetmax,netmax),
     $ jgext(netmax),jsol(nxtmax),ncmpr(2,nptmax)
c
      integer nalpha(nsltmx),nmux(3,nmutmx),nmxi(2,natmax),
     $ nmxx(3,nmxmax),nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
c
      integer napt,nmut,nslt
c
      integer ielam,iter,ixrn1,ixrn2,izmax,kx1,kxt,narn1,narn2,nchlor,
     $ net,nhydr,nst
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      logical qhawep,qpit75,qpracf,q6mode
c
      character*48 uspec(nstmax)
      character*48 ubacmx,ubgamx
      character*24 uphase(nptmax)
c
      real*8 dgpit(2,ipbtmx,napmax),dpslm(2,nsltmx),
     $ gpit(ipbtmx,napmax),palpha(ipbtmx,napmax),pmu(nmutmx),
     $ pslamn(0:ipbtmx,nsltmx),pslm(nsltmx)
c
      real*8 delam(2,nazpmx,nazpmx),dpelm(2,nazpmx,nazpmx),
     $ dselm(2,nazmmx:nazpmx),elam(nazpmx,nazpmx),pelm(nazpmx,nazpmx),
     $ selm(nazmmx:nazpmx)
c
      real*8 acflg(nstmax),acflgo(nstmax),azero(natmax),a3bars(natmax),
     $ bpx(ibpxmx,nxtmax),cco2(5),cgexj(jetmax,netmax),conc(nstmax),
     $ wfac(iktmax,nxtmax),xbar(nstmax),xbarlg(nstmax),zchar(nstmax),
     $ zchsq2(nstmax),zchcu6(nstmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,actwlc,afcnst,al10,a3bar,bacfmx,bgamx,bsigmm,bfje,
     $ bfxi,chfacf,chfsgm,eps100,fje,fjeo,fxi,fxio,omega,press,rlxgam,
     $ sigmam,sigmmo,tempk,xbarwc,xbrwlc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer itgfix,j2,kcol,np,ns
c
      integer ilnobl
c
      logical qconc1,qconc2,qconc3
c
      real*8 adfx,adfxmx,afjea,ax,bgamxo,chfsmi,dfje,dfx,fjec,fxic,
     $ rlxgcf,rlxgmo,rlxgml,sigmmc,sxl,sxu
c
c-----------------------------------------------------------------------
c
c     Compute the inverse change limit on "Sigma m" (the sum of solute
c     molalities), the ionic strength, and the like.
c
      chfsmi = 1./chfsgm
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute sigma m and compute the associated residual.
c
      call csigm(conc,jcsort,narn1,narn2,nstmax,sigmmc)
      bsigmm = 0.
      if (sigmmo .gt. 0.) bsigmm = (sigmmc - sigmmo)/sigmmo
      sxu = chfsgm*sigmmo
      if (sigmmo .le. 0.) sxu = sigmmc
      sigmam = min(sxu,sigmmc)
      sxl = chfsmi*sigmmo
      sigmam = max(sxl,sigmam)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the ionic strength (the 2nd-order electrostatic
c     moment function I) and compute the associated residual.
c
      call cfxi(conc,fxic,jcsort,narn1,narn2,nstmax,zchsq2)
      bfxi = 0.
      if (fxio .gt. 0.) bfxi = (fxic - fxio)/fxio
      sxu = chfsgm*fxio
      if (fxio .le. 0.) sxu = fxic
      fxi = min(sxu,fxic)
      sxl = chfsmi*fxio
      fxi = max(sxl,fxi)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute the 3rd-order electrostatic moment function J and
c     the associated residual. Unlike sigma m and I, J can be zero
c     or negative, so the treatment is slightly different.
c
      call cfje(conc,fjec,jcsort,narn1,narn2,nstmax,zchcu6)
      afjea = 0.5*(abs(fjeo) + abs(fjec))
      dfje = fjec - fjeo
      bfje = 0.
      if (afjea .gt. 0.) bfje = dfje/afjea
      if (fjec.gt.0. .and. fjeo.gt.0.) then
        sxu = chfsgm*fjeo
        if (fjeo .le. 0.) sxu = fjec
        fje = min(sxu,fjec)
        sxl = 0.
        fje = max(sxl,fje)
      elseif (fjec.lt.0. .and. fjeo.lt.0.) then
        sxl = chfsgm*fjeo
        if (fjeo .le. 0.) sxl = fjec
        fje = max(sxl,fjec)
        sxu = 0.
        fje = min(sxu,fje)
      elseif (fjec.lt.0. .and. fjeo.gt.0.) then
        fje = 0.
      elseif (fjec.gt.0. .and. fjeo.lt.0.) then
        fje = 0.
      else
        fje = fjec
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the activity coefficients of aqueous species.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call gcoeff(abar,acflg,actwlc,adh,adhh,adhv,al10,
     $ aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ cco2,conc,delam,dgpit,dpelm,dpslm,dselm,elam,fje,fxi,gpit,
     $ ielam,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta,insgf,
     $ iopg,ipbtmx,izmax,jcsort,nalpha,napmax,napt,narn1,narn2,
     $ natmax,nazmmx,nazpmx,nchlor,nhydr,nmut,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,nopgmx,noutpt,nslt,nsltmx,nslx,nstmax,nsxi,
     $ nsxmax,nsxx,nttyo,omega,palpha,pelm,pmu,press,pslamn,
     $ pslm,qhawep,qpit75,selm,sigmam,tempk,uspec,xbarwc,xbrwlc,
     $ zchar,zchsq2,zchcu6)
c
c     Calculate the activity coefficients of exchanger species.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call lamgex(acflg,cgexj,jern1,jern2,jetmax,jgext,net,
     $ netmax,nstmax,xbarlg)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute activity coefficient residual norms.
c
      bgamxo = bgamx
c
cXX   The call to EQLIB/betacf.f is below. Reconcile the usage of
cXX   EQLIB/betgam.f and EQLIB/betacf.f when the activity coefficients
cXX   of species in non-aqueous phases are updated numerically the same
cXX   as those of aqueous species.
      call betgam(acflg,acflgo,bgamx,narn1,narn2,nstmax,
     $ ubgamx,uspec)
c
      ubacmx = ubgamx
      bacfmx = bgamx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Algorithm for under-relaxing changes to the activity coefficients
c     of aqueous species in concentrated solutions. This is designed to
c     damp out oscillation in activity coefficient corrections. Here
c     rlxgam is the under-relaxation factor. Note that activity
c     coefficients may kept fixed for the first few iterations.
c
c     Save the previous value of the under-relaxation factor.
c
      rlxgmo = rlxgam
      rlxgam = 1.0
c
c     Compute a limit (rlxgml)on the under-relaxation factor which
c     is intended to slow its growth from small values, especially
c     in the case where the activity coefficients have been fixed
c     (rlxgam = 0.)
c
      rlxgml = rlxgmo
      if (rlxgml .lt. 0.10) then
        rlxgml = 0.10
      else
        rlxgml = rlxgml + 0.10
      endif
      sxu = 1.0
      rlxgml = min(sxu,rlxgml)
c
c     Determine the course of action according to how concentrated
c     the solution is, based on the sum of solute molalities
c     parameter (Sigma m).
c
      qconc1 = sigmam.ge.2.0 .or. sigmmo.ge.2.0
      qconc2 = sigmam.ge.8.0 .or. sigmmo.ge.8.0
      qconc3 = sigmam.ge.12.0 .or. sigmmo.ge.12.0
c
c     Here itgfix is the number of iterations to hold the activity
c     coefficients constant.
c
      itgfix = 0
      if (qconc1) itgfix = 6
      if (qconc2) itgfix = 8
      if (qconc3) itgfix = 10
c
      if (iter .le. itgfix) then
c
c       Fix the activity coefficients.
c
        rlxgam = 0.
      else
c
c       Apply other under-relaxation controls if called for.
c
        if (bgamxo .gt. 0.) then
c
c         Apply the limit based on the analysis of residual
c         function behavior.
c
          ax = -bgamx/bgamxo
          if (ax .ge. -0.5) then
            rlxgam = rlxgmo*(1./(1. + ax))
            sxl = 0.05
            rlxgam = max(sxl,rlxgam)
          endif
        endif
c
c       Apply the growth from small values limit.
c
        rlxgam = min(rlxgml,rlxgam)
c
c       If the under-relaxation factor is close to one, make it one.
c
        if (abs(rlxgam - 1.0) .le. 0.05) rlxgam = 1.0
c
        if (qconc2) then
c
c         Force some minimum under-relaxation for more concentrated
c         solutions.
c
          if (iter .le. 30) then
            sxu = 0.50
            rlxgam = min(sxu,rlxgam)
          endif
        endif
c
        if (qconc3) then
c
c         Force some minimum under-relaxation for highly concentrated
c         solutions.
c
          if (iter .le. 60) then
            sxu = 0.25
            rlxgam = min(sxu,rlxgam)
          endif
        endif
      endif
c
      if (abs(rlxgam) .gt. eps100) then
c
c       Apply a limit to the change in the activity coefficients.
c       This is yet another form of under-relaxation.
c
        adfx = abs(acflg(narn1) - acflgo(narn1))
        adfxmx = adfx
        do ns = narn1 + 1,narn2
          adfx = abs(acflg(ns) - acflgo(ns))
          adfxmx = max(adfxmx,adfx)
        enddo
        if (adfxmx .gt. chfacf) then
          rlxgcf = chfacf/adfxmx
          rlxgam = min(rlxgcf,rlxgam)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Apply under-relaxation, if any, to the activity coefficients.
c
      if (abs(rlxgam) .le. eps100) then
c
c       Keep activity coefficients fixed.
c
        do ns = narn1,narn2
          acflg(ns) = acflgo(ns)
        enddo
      elseif (abs(rlxgam - 1.0) .gt. eps100) then
c
c       Apply under-relaxation to activity coefficients.
c
        do ns = narn1,narn2
          dfx = acflg(ns) - acflgo(ns)
          acflg(ns) = acflgo(ns) + rlxgam*dfx
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qpracf) then
        write (noutpt,2300) sigmam,fxi,fje,xbrwlc,xbarwc
 2300   format(/3x,'sigmam= ',1pe12.5,/6x,'fxi= ',e12.5,
     $  /6x,'fje= ',e12.5,
     $  /3x,'xbrwlc= ',0pf10.5,/3x,'xbarwc= ',1pe12.5)
c
        write (noutpt,1005)
 1005   format(//11x,'Activity Coefficients of Aqueous Species',
     $  //7x,'Species',23x,'New',11x,'Old',/)
        do ns = narn1,narn2
          write (noutpt,1010) ns,uspec(ns),acflg(ns),acflgo(ns)
 1010     format(1x,i3,2x,a24,2x,1pe12.5,2x,e12.5)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) then
c
c       Recalculate the activity coefficients of any solid solution
c       components present in the ES.
c
        do kcol = kx1,kxt
          np = ipndx1(kcol)
c
c         Calling sequence substitutions:
c           acflg for acflgc
c
          call lambda(acflg,afcnst,bpx,ibpxmx,ibpxt,iktmax,ixrn1,
     $    ixrn2,jsol,ncmpr,noutpt,np,nptmax,nstmax,nttyo,nxtmax,wfac,
     $    xbar,xbarlg,uphase,uspec)
c
          if (qpracf) then
            j2 = ilnobl(uphase(np))
            write (noutpt,1020) uphase(np)(1:j2)
 1020       format(/6x,'Activity Coefficients of Species in ',a,
     $      //7x,'Species',23x,'New',11x,'Old',/)
            do ns = narn1,narn2
              write (noutpt,1010) ns,uspec(ns),acflg(ns),acflgo(ns)
            enddo
          endif
        enddo
c
        call betacf(acflg,acflgo,bacfmx,nst,nstmax,ubacmx,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
c
c     This subroutine reads a "2 line" block containing an expected
c     header or tag string from an EQ3/6 input in menu-style ("D")
c     format. The first line contains the header and data. The second
c     line is a separator line containing a single field of dashes.
c
c     EQLIBU/rdd2l.f is very similar to this subroutine. It differs in
c     that the header is not expected to be known in advance.
c
c     This subroutine is called by:
c
c       XCON3/rd3d7.f
c       XCON6/rd6d7.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nfldmx = the maximum number of fields on line uline1 or
c                  line uline2
c       nfldtx = the expected number of fields on a line
c       nlchmx = the maximum number of characters on a line
c       ninpts = the unit number of the stripped input file
c       nttyo  = the unit number of the screen file
c       uheadx = the expected header (the expected contents of the
c                  first of the two lines)
c       ulscr  = scratch character variable
c
c     Output:
c
c       nfldt  = the number of fields on line uline1 or line uline2
c       qrderr = logical flag, true if an error was encountered
c       ufield = the array of fields on a line
c       uheadr = the header (contents of the first of the two lines)
c       uline1 = the first line to be read
c       uline2 = the second line to be read
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nttyo
c
      integer nfldmx,nfldt,nfldtx,ninpts,nlchmx
c
      logical qrderr
c
      character*(*) ufield(nfldmx)
      character*(*) uline1,uline2,ulscr
      character*(*) uheadr,uheadx
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,j2,j3
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c     Read and parse the first line.
c
      read (ninpts,1000,err=990) uline1
 1000 format(a80)
c
      call parslj(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
c
c     Compare the number of fields found with that expected.
c
      if (nfldtx .gt. 0) then
        if (nfldt .ne. nfldtx) then
          j3 = ilnobl(uline1(1:70))
          write (nttyo,1010) nfldt,nfldtx,uline1(1:j3)
 1010     format(/' * Warning - (EQLIBU/rdd2lh) Found ',i2,' fields',
     $    /7x,'where ',i2,' were expected on the line beginning with',
     $    /7x,'"',a,'".')
        endif
      endif
c
c     Compare the header with that expected.
c
      uheadr = ufield(1)
      call locase(uheadr)
      call locase(uheadx)
c
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        qrderr = .true.
        j3 = ilnobl(uline1(1:70))
        j2 = ilnobl(uheadx(1:70))
        write (nttyo,1020) uheadx(1:j2),uline1(1:j3)
 1020   format(/' * Error - (EQLIBU/rdd1lh) Was expecting to find the',
     $  /7x,'header beginning with"',/7x,'"',a,'"',
     $  /7x,'on the line beginning with',/7x,'"',a,'".')
        go to 999
      endif
c
c     Read the second line.
c
      read (ninpts,1000,err=990) uline2
      if (uline2(2:9) .eq. '--------') go to 999
c
      qrderr = .true.
      j3 = ilnobl(uline2(1:70))
      write (nttyo,1030) uline2(1:j3)
 1030 format(/' * Error - (EQLIBU/rdd2lh) Found the line beginning',
     $ ' with',/7x,'"',a,'"',
     $ /7x,'where a dashed separator line was expected.')
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine rsatch(csts,egers,egexs,iern1,ietmax,iindx1,iktmax,
     $ iopt,ipndx1,jcode,jern1,jern2,jetmax,jgext,jpflag,jreac,kmax,
     $ km1,kmt,kx1,kxt,loph,losp,moph,morr,mosp,mrgers,mtb,mtb0,
     $ nbaspd,nbtmax,ncmpr,nern1,nern2,nert,nertmx,netmax,ngext,
     $ noptmx,noutpt,nptmax,nrct,nrctmx,nrk,nrndex,nstmax,nsts,nstsmx,
     $ nstsr,nttyo,nxridx,nxrt,nxrtmx,qreq,rxbar,tolxsf,uphase,ureac,
     $ uspec,xbar,xbarlg,zvclg1,zvec1)
c
c     This subroutine tests reactants for saturation.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,jetmax,kmax,nbtmax,nertmx,netmax,noptmx,
     $ nptmax,nrctmx,nstmax,nstsmx,nxrtmx
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),iopt(noptmx),ipndx1(kmax),jcode(nrctmx),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax),
     $ jpflag(nptmax),jreac(nrctmx),nbaspd(nbtmax),ncmpr(2,nptmax),
     $ ngext(jetmax,netmax),nrk(2,nrctmx),nrndex(nrctmx),nsts(nstsmx),
     $ nstsr(2,nstmax),nxridx(nrctmx)
c
      integer iern1,km1,kmt,kx1,kxt,nern1,nern2,nert,nrct,nxrt
c
      logical qreq
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax),ureac(nrctmx)
c
      real*8 csts(nstsmx),egexs(ietmax,jetmax,netmax),loph(nptmax),
     $ egers(ietmax,jetmax,netmax),losp(nstmax),moph(nptmax),
     $ morr(nrctmx),mosp(nstmax),mrgers(ietmax,jetmax,nertmx),
     $ mtb(nbtmax),mtb0(nbtmax),rxbar(iktmax,nxrtmx),xbar(nstmax),
     $ xbarlg(nstmax),zvclg1(kmax),zvec1(kmax)
c
      real*8 tolxsf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,ik,je,jlen,j2,kcol,kount,n,nb,ne,ner,np,npp,nrc,nrn1,
     $ nrn2,nr1,nr2,ns,nss,nt,nxr
c
      integer ilnobl
c
      character*56 uspn56
c
      real*8 dce,dm,dmx,dx,ecomp,ed,lx,lxx,mx,mxx,xcomp,xd
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
      qreq = .false.
c
c     Pure minerals.
c
      do nrc = 1,nrct
        if (jcode(nrc).eq.0 .and. nrk(2,nrc).eq.0) then
          if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
            np = nrndex(nrc)
            if (jpflag(np) .gt. 0) go to 230
            jreac(nrc) = 0
            if (jpflag(np) .ne. -1) go to 230
            jreac(nrc) = -1
            if (iopt(1) .eq. 0) then
              jreac(nrc) = 2
              qreq = .true.
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1000) ureac(nrc)(1:j2)
 1000         format(/' Reactant ',a,' has become saturated and any',
     $        ' remaining',/' unreacted mass has been transferred to',
     $        ' the ES.',/)
              dm = morr(nrc)
              morr(nrc) = 0.
              mx = moph(np) + dm
              lx = tlg(mx)
              moph(np) = mx
              loph(np) = lx
              ns = ncmpr(1,np)
              mosp(ns) = mx
              losp(ns) = lx
              do kcol = km1,kmt
                if (ns .eq. iindx1(kcol)) then
                  zvclg1(kcol) = losp(ns)
                  zvec1(kcol) = mx
                  nr1 = nstsr(1,ns)
                  nr2 = nstsr(2,ns)
                  do n = nr1,nr2
                    nb = nsts(n)
                    dce = csts(n)*dm
                    mtb(nb) = mtb(nb) + dce
                    mtb0(nb) = mtb0(nb) + dce
                    enddo
                  go to 230
                endif
              enddo
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1010) ureac(nrc)(1:j2)
              write (nttyo,1010) ureac(nrc)(1:j2)
 1010         format(/' * Error - (EQ6/rsatch) The reactant ',a,
     $        'is saturated,',/7x,"but it isn't in the ES.")
              stop
            endif
          endif
        endif
  230   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Solid solutions.
c
      if (nxrt .le. 0) go to 340
c
      do nrc = 1,nrct
        if (jcode(nrc).eq.1 .and. nrk(2,nrc).eq.0) then
            if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
            np = nrndex(nrc)
            if (jpflag(np) .ge. 2) go to 330
            jreac(nrc) = 0
            if (jpflag(np) .ne. -1) go to 330
            jreac(nrc) = -1
            if (iopt(1) .ne. 0) go to 330
c
            xcomp = 0.
            nrn1 = ncmpr(1,np)
            nrn2 = ncmpr(2,np)
            nt = nrn2 - nrn1 + 1
            nxr = nxridx(nrc)
            ik = 0
              do ns = nrn1,nrn2
              ik = ik + 1
              xd = xbar(ns) - rxbar(ik,nxr)
              xcomp = xd*xd + xcomp
            enddo
            xcomp = sqrt(xcomp/nt)
            if (xcomp .gt. tolxsf) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1020) uphase(np)(1:j2)
              write (nttyo,1020) uphase(np)(1:j2)
 1020         format(/' * Note - (EQ6/rsatch) The solid solution',
     $        ' reactant ',a,/7x,'has become saturated, but it',
     $        ' differs in composition from the',/7x,'corresponding',
     $        " product phase. It can't be moved into the ES.")
              go to 330
            endif
c
            jreac(nrc) = 2
            qreq = .true.
            write (noutpt,1000) ureac(nrc)
            dm = morr(nrc)
            morr(nrc) = 0.
            mx = moph(np) + dm
            moph(np) = mx
            loph(np) = tlg(mx)
c
            kount = 0
            do kcol = kx1,kxt
              ns = iindx1(kcol)
              npp = ipndx1(kcol)
              if (npp .eq. np) then
                kount = kount + 1
                lxx = loph(np) + xbarlg(ns)
                losp(ns) = lxx
                mxx = texp(lxx)
                mosp(ns) = mxx
                zvclg1(kcol) = lxx
                zvec1(kcol) = texp(lxx)
                dmx = dm*xbar(ns)
                nr1 = nstsr(1,ns)
                nr2 = nstsr(2,ns)
                do n = nr1,nr2
                  nb = nsts(n)
                  dce = csts(n)*dmx
                  mtb(nb) = mtb(nb) + dce
                  mtb0(nb) = mtb0(nb) + dce
                enddo
              endif
            enddo
c
            if (kount .le. 0) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1010) ureac(nrc)(1:j2)
              write (nttyo,1010) ureac(nrc)(1:j2)
              stop
            endif
c
          endif
        endif
  330   continue
      enddo
c
  340 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Generic ion exchangers.
c
      if (nert .le. 0) go to 440
c
      do nrc = 1,nrct
        if (jcode(nrc).eq.5 .and. nrk(2,nrc).eq.0) then
            if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
            np = nrndex(nrc)
            if (jpflag(np) .ge. 2) go to 430
            jreac(nrc) = 0
            if (jpflag(np) .ne. -1) go to 430
            jreac(nrc) = -1
c
            ne = np - iern1 + 1
            ner = nxridx(nrc)
c
            ecomp = 0.
            do je = 1,jgext(ne)
              do ie = 1,ngext(je,ne)
                ed = egexs(ie,je,ne) - egers(ie,je,ner)
                ecomp = ed*ed + ecomp
              enddo
            enddo
            ecomp = sqrt(ecomp/nt)
            if (ecomp .gt. tolxsf) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1040) uphase(np)(1:j2)
              write (nttyo,1040) uphase(np)(1:j2)
 1040         format(/' * Note - (EQ6/rsatch) The generic ion',
     $        ' exchanger reactant'/7x,a,' has become saturated, but',
     $        ' it differs in composition',/7x,'from the corresponding',
     $        " product phase. It can't be moved into the ES.")
              go to 440
            endif
c
            jreac(nrc) = 2
            qreq = .true.
            write (noutpt,1000) ureac(nrc)
            dm = morr(nrc)
            morr(nrc) = 0.
            mx = moph(np) + dm
            moph(np) = mx
            loph(np) = tlg(mx)
c
            kount = 0
c
c           Create matrix index range markers for exchange species.
c
            do kcol = 2,km1 - 1
              npp = ipndx1(kcol)
              if (npp .eq. np) then
                kount = kount + 1
                ns = iindx1(kcol)
                do je = 1,jgext(ne)
                  if (ns.ge.jern1(je,ne) .and. ns.le.jern2(je,ne))
     $            go to 410
                enddo
c
c               Calling sequence substitutions:
c                 uspec(ns) for unam48
c
                call fmspnm(jlen,uspec(ns),uspn56)
                write (noutpt,1050) uspn56(1:jlen)
                write (nttyo,1050) uspn56(1:jlen)
 1050           format(/' * Error - (EQ6/rsatch) Programming error',
     $          " trap: Can't determine",/7x,'the exchange site index',
     $          ' je for the species',/7x,a,'.')
                stop
c
  410           do ie = 1,ngext(je,ne)
                  nss = ie + jern1(je,ne) -1
                  if (ns .eq. nss) go to 420
                enddo
c
c               Calling sequence substitutions:
c                 uspec(ns) for unam48
c
                call fmspnm(jlen,uspec(ns),uspn56)
                write (noutpt,1060) uspn56(1:jlen)
                write (nttyo,1060) uspn56(1:jlen)
 1060           format(/' * Error - (EQ6/rsatch) Programming error',
     $          " trap: Can't determine",/7x,'the exchange species',
     $          ' index ie of the species',/7x,a,'.')
                stop
c
  420           dx = dm*mrgers(ie,je,ner)
                mxx = mosp(ns) + dx
                mosp(ns) = mxx
                lxx = tlg(mxx)
                losp(ns) = lxx
                zvclg1(kcol) = lxx
                zvec1(kcol) = mxx
                nr1 = nstsr(1,ns)
                nr2 = nstsr(2,ns)
                if (je .le. 1) then
c
c                 Have the first site. Increment the mass balance
c                 totals in a straightforward manner.
c
                  do n = nr1,nr2
                    nb = nsts(n)
                    dce = dx*csts(n)
                    mtb(nb) = mtb(nb) + dce
                    mtb0(nb) = mtb0(nb) + dce
                  enddo
                else
c
c                 Have a site beyond the first. Increment the mass
c                 balance totals in the usual manner, except do not
c                 increment here the total for the exchanger
c                 substrate. The complete increment for the substrate
c                 is obtained by considering only one site.
c
                  do n = nr1,nr2
                    nb = nsts(n)
                    ns = nbaspd(nb)
                    if (ns.lt.nern1 .or. ns.gt.nern2) then
                      dce = dx*csts(n)
                      mtb(nb) = mtb(nb) + dce
                      mtb0(nb) = mtb0(nb) + dce
                    endif
                  enddo
                endif
              endif
            enddo
c
            if (kount .le. 0) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1010) ureac(nrc)(1:j2)
              write (nttyo,1010) ureac(nrc)(1:j2)
              stop
            endif
c
          endif
        endif
  430   continue
      enddo
c
  440 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine indath(ikta_asv,ipbt_asv,ipch_asv,ipcv_asv,
     $ jpfc_asv,nad1,napa_asv,narx_asv,nata_asv,nbta_asv,
     $ ncta_asv,ngta_asv,nlta_asv,nmta_asv,npta_asv,nmuta_asv,
     $ noutpt,nslta_asv,nsta_asv,ntid_asv,ntpr_asv,nttyo,
     $ nxta_asv,udakey)
c
c     This subroutine reads the header section of the data1 file. This
c     section consists of a record containing the string 'data1' (to
c     ensure that the file is indeed a data1 file), a record containing
c     the keystring for the activity coefficient model for aqueous
c     species to which this data file corresponds, and the array
c     allocation size variables required to allocate sufficient array
c     space to store the rest of the data on this data file.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nad1   = unit number of the data1 file
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       nbta_asv  = the number of basis species on the data file
c       ncta_asv  = the number of chemical elements on the data file
c       ntid_asv  = the number of lines in the data file title
c
c       ikta_asv  = the maximum number of end-member component species
c                     in any solid solution on the data file
c       nata_asv  = the number of aqueous species on the data file
c       ngta_asv  = the number of gas species on the data file
c       nlta_asv  = the number of pure liquids on the data file
c       nmta_asv  = the number of pure minerals on the data file
c       npta_asv  = The number of phases of all types on the data file
c       nsta_asv  = the number of species of all types on the data file
c       nxta_asv  = the number of solid-solution phases on the data
c                     file
c
c       napa_asv  = the number of distinct sets of Pitzer alpha values
c       nmuta_asv = the number of triplets of ions on the data file
c                     for which distinct Pitzer mu coefficients
c                     are defined
c       nslta_asv = the number of pairs of ions on the data file
c                     for which distinct Pitzer S-lambda coefficients
c                     are defined
c
c       ipch_asv = the maximum order for pressure corrections to
c                    enthalpy functions
c       ipcv_asv = the maximum order for pressure corrections to
c                    volume functions; the maximum order for pressure
c                    corrections to log K and other Gibbs-energy-based
c                    functions is one greater than this
c       ipbt_asv  = the maximum number of Pitzer alpha parameters
c                     for any species pair
c       jpfc_asv  = the number of coefficients in the Pitzer parameter
c                    temperature function
c       narx_asv = maximum number of coefficients per temperature range
c       ntpr_asv = number of temperature ranges
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nad1,noutpt,nttyo
c
      integer ikta_asv,ipbt_asv,napa_asv,nata_asv,nbta_asv,ncta_asv,
     $ ngta_asv,nlta_asv,nmta_asv,npta_asv,nmuta_asv,nslta_asv,nsta_asv,
     $ ntid_asv,nxta_asv
c
      integer ipch_asv,ipcv_asv,jpfc_asv,narx_asv,ntpr_asv
c
      character(len=8) udakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character(len=56) ux56
      character(len=8) ux8
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
      write (nttyo,1000)
 1000 format(/' Reading the data1 file header section ...')
c
c     Rewind the data file. The unit number is nad1.
c
      rewind nad1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the file header string.
c
      read (nad1) ux8
c
      if (ux8(1:5) .ne. 'data1') then
        write (noutpt,1010) ux8
        write (nttyo,1010) ux8
 1010   format(/' * Error - (EQLIB/indath) Have wrong file header',
     $  ' "',a5,'"',/7x,'on the data1 file. The first five characters',
     $  ' must be "data1".')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read key string indicating the type of option supported by the
c     data file for treating activity coefficients of aqueous species.
c     This will be used to test the model specified on the input file
c     for consistency with the data file. That test is made in
c     EQLIB/cdakey.f.
c
      read (nad1) udakey
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for chemical elements.
c
      read (nad1) ux56
      read (nad1) ncta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for basis species.
c
      read (nad1) ux56
      read (nad1) nbta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for total species.
c
      read (nad1) ux56
      read (nad1) nsta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for total phases.
c
      read (nad1) ux56
      read (nad1) npta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for aqueous species.
c
      read (nad1) ux56
      read (nad1) nata_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for pure minerals.
c
      read (nad1) ux56
      read (nad1) nmta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for pure liquids.
c
      read (nad1) ux56
      read (nad1) nlta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for gas species.
c
      read (nad1) ux56
      read (nad1) ngta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for solid-solution phases.
c
      read (nad1) ux56
      read (nad1) nxta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for solid-solution components
c     (maximum number per solid solution).
c
      read (nad1) ux56
      read (nad1) ikta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for the data file title.
c
      read (nad1) ux56
      read (nad1) ntid_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for the temperature ranges in
c     the logK temperature grid.
c
      read (nad1) ux56
      read (nad1) ntpr_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for the points in a temperature
c     range on the logK temperature grid.
c
      read (nad1) ux56
      read (nad1) narx_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for the dH/dP order represented
c     on the data file.
c
      read (nad1) ux56
      read (nad1) ipch_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimension required for the dV/dP order represented
c     on the data file.
c
      read (nad1) ux56
      read (nad1) ipcv_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the array dimensions for parameters needed for activity
c     coefficient models.
c
      if (udakey(1:8) .eq. 'Pitzer  ') then
c
c       Read the array dimension required for the sets of Pitzer
c       alpha coefficients.
c
        read (nad1) ux56
        read (nad1) napa_asv
c
c       Read the array dimension required for the set of Pitzer
c       S-lambda coefficients.
c
        read (nad1) ux56
        read (nad1) nslta_asv
c
c       Read the array dimension required for the set of Pitzer mu
c       coefficients.
c
        read (nad1) ux56
        read (nad1) nmuta_asv
c
c       Read the number of coefficients for the Pitzer parameter
c       temperature function.
c
        read (nad1) ux56
        read (nad1) jpfc_asv
      else
c
c       Minimum values.
c
        napa_asv = 1
        nslta_asv = 1
        nmuta_asv = 1
        jpfc_asv = 1
      endif
c
c     Set the number of parameters in a Pitzer alpha set.
c
      if (udakey(1:8) .eq. 'Pitzer  ') then
        ipbt_asv = 2
      else
        ipbt_asv = 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following is a bit of nonsense so compiler warninings will
c     not be generated that ux56 is not used.
c
      ux8 = ux56(1:8)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine prtsat(affpd,iern1,iern2,ilrn1,ilrn2,imrn1,imrn2,
     $ iopr,iopt,ixrn1,ixrn2,jpflag,noutpt,noprmx,noptmx,nptmax,
     $ sidrph,tolspf,uphase)
c
c     This subroutine prints tables of saturation indices and affinities
c     for the various non-aqueous phases. The level of printing is
c     controlled by the print control flag iopr(7):
c
c       -1 = Don't print
c        0 = Print for those phases not undersaturated by
c              more than 10 kcal
c        1 = Print for all phases
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       affpd  = array of affinities of phases to form (precipitate),
c                  computed from the reactions read from the data file
c       iern1  = start of the range of generic ion exchangers
c       iern2  = end of the range of generic ion exchangers
c       ilrn1  = start of the range of pure liquid phases
c       ilrn2  = end of the range of pure liquid phases
c       imrn1  = start of the range of pure mineral phases
c       imrn2  = end of the range of pure mineral phases
c       iopt   = array of model option switches
c       iopr   = array of print control options
c       ixrn1  = start of the range of solid solution phases
c       ixrn2  = end of the range of solid solution phases
c       jpflag = array of phase status flags
c       sidrph = array of saturation indices of the various phases,
c                  computed from the reactions read from the data file
c       tolspf = saturation print flag tolerance, used to flag those
c                  phases which are close to saturation
c       uphase = array of phase names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noprmx,noptmx,nptmax
c
      integer noutpt
c
      integer iopr(noprmx),iopt(noptmx),jpflag(nptmax)
      integer iern1,iern2,ilrn1,ilrn2,imrn1,imrn2,ixrn1,ixrn2
c
      character*24 uphase(nptmax)
c
      real*8 affpd(nptmax),sidrph(nptmax)
      real*8 tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ir1,ir2,kpsat,kpsst
c
      character*24 ugroup,upusol,upuliq,usosol,usoliq,ugexch,ux24,uy24
c
c-----------------------------------------------------------------------
c
      data upusol /'Pure Solids             '/,
     $     upuliq /'Pure Liquids            '/,
     $     usosol /'Solid Solutions         '/,
     $     usoliq /'Liquid Solutions        '/,
     $     ugexch /'Generic Ion Exchangers  '/
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that usoliq is not used.
c
      ux24 = usoliq
      uy24 = ux24
      usoliq = uy24
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(7) .le. -1) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute and print phase saturation states. these refer to
c     the dissolution reactions as they are written in the
c     'd' set.
c
c       kpsat = the number of saturated phases
c       kpsst = the number of supersaturated phases
c
      kpsat = 0
      kpsst = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table for the pure solids.
c
      ugroup = upusol
      ir1 = imrn1
      ir2 = imrn2
      call prtsip(affpd,iopr,ir1,ir2,jpflag,kpsat,kpsst,
     $ noprmx,noutpt,nptmax,sidrph,tolspf,ugroup,uphase)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table for the pure liquids.
c
      ugroup = upuliq
      ir1 = ilrn1
      ir2 = ilrn2
      call prtsip(affpd,iopr,ir1,ir2,jpflag,kpsat,kpsst,
     $ noprmx,noutpt,nptmax,sidrph,tolspf,ugroup,uphase)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(4) .ge. 1) then
c
c       Print a table for the solid solutions.
c
        ugroup = usosol
        ir1 = ixrn1
        ir2 = ixrn2
        call prtsip(affpd,iopr,ir1,ir2,jpflag,kpsat,kpsst,
     $  noprmx,noutpt,nptmax,sidrph,tolspf,ugroup,uphase)
c
c       No table is presently printed for non-aqueous liquid
c       solutions.
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iern2 .ge. iern1) then
c
c       Print a table for the generic ion exchangers.
c
        ugroup = ugexch
        ir1 = iern1
        ir2 = iern2
        call prtsip(affpd,iopr,ir1,ir2,jpflag,kpsat,kpsst,
     $  noprmx,noutpt,nptmax,sidrph,tolspf,ugroup,uphase)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1150)
 1150 format(/11x,'--- Summary of Saturated and Supersaturated',
     $ ' Phases ---',/)
c
      if (kpsat .le. 0) then
        write (noutpt,1160)
 1160   format(16x,'There are no saturated phases.')
      elseif (kpsat .eq. 1) then
        write (noutpt,1170)
 1170   format(16x,'There is 1 saturated phase.')
      else
        write (noutpt,1180) kpsat
 1180   format(16x,'There are ',i4,' saturated phases.')
      endif
c
      if (kpsst .le. 0) then
        write (noutpt,1200)
 1200   format(16x,'There are no supersaturated phases.')
      elseif (kpsst .eq. 1) then
        write (noutpt,1210)
 1210   format(16x,'There is 1 supersaturated phase.')
      else
        write (noutpt,1220) kpsst
 1220   format(16x,'There are ',i4,' supersaturated phases.')
      endif
      write (noutpt,1230)
 1230 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine jfloha(jflgi,nbtd,nbti,nbtmax,noutpt,nttyo,
     $ nxmdmx,nxmod,ubasp,uspeci,uxmod)
c
c     This subroutine modifies the jflgi array to insure that jflag
c     defaults to 27, not 30, for the species H2(aq) and O2(aq).
c     These defaults are desirable because they provide some
c     poising (buffering of the fO2 or Eh) in EQ6 mode calculations.
c     However, the jflag is defaulted to -1 if a species is on the
c     suppression list (nxmod option).
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nxmdmx
c
      integer noutpt,nttyo
c
      integer jflgi(nbtmax)
      integer nbtd,nbti,nxmod
c
      character(len=48) ubasp(nbtmax),uspeci(nbtmax),uxmod(nxmdmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nb,nbi
c
      character(len=24) ux24
c
c-----------------------------------------------------------------------
c
c     Process H2(aq).
c
      ux24 = 'H2(aq)'
c
c     Is it on the input file?
c
      do nbi = 1,nbti
        if (uspeci(nbi)(1:24) .eq. ux24(1:24)) go to 110
      enddo
c
c     Is it on the data file?
c
      do nb = 1,nbtd
        if (ubasp(nb)(1:24) .eq. ux24(1:24)) go to 100
      enddo
      go to 110
c
c     See if the input can be extended.
c
  100 if (nbti .ge. nbtmax) then
        write (noutpt,1000) nbtmax,ux24(1:6)
        write (nttyo,1000) nbtmax,ux24(1:6)
 1000   format(/' * Error - (EQ3NR/jfloha) Have exceeded the maximum',
     $  /7x,i4,' basis species trying to add ',a,
     $  /7x,'to the species read from the input file.',
     $  /7x,'Increase the dimensioning parameter nbtpar.')
        stop
      endif
c
c     Extend the input with the desired default.
c
      nbti = nbti + 1
      uspeci(nbti) = ux24
c
c     Is it on the suppression list?
c
      do n = 1,nxmod
        if (uxmod(n)(1:24) .eq. ux24(1:24)) then
          jflgi(nbti) = -1
          go to 110
        endif
      enddo
c
      jflgi(nbti) = 27
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process O2(aq).
c
      ux24 = 'O2(aq)'
c
c     Is it on the input file?
c
      do nbi = 1,nbti
        if (uspeci(nbi)(1:24) .eq. ux24(1:24)) go to 210
      enddo
c
c     Is it on the data file?
c
      do nb = 1,nbtd
        if (ubasp(nb)(1:24) .eq. ux24(1:24)) go to 200
      enddo
      go to 210
c
c     See if the input can be extended.
c
  200 if (nbti .ge. nbtmax) then
        write (noutpt,1000) nbtmax,ux24(1:6)
        write (nttyo,1000) nbtmax,ux24(1:6)
        stop
      endif
c
c     Extend the input with the desired default.
c
      nbti = nbti + 1
      uspeci(nbti) = ux24
c
c     Is it on the suppression list?
c
      do n = 1,nxmod
        if (uxmod(n)(1:24) .eq. ux24(1:24)) then
          jflgi(nbti) = -1
          go to 210
        endif
      enddo
c
      jflgi(nbti) = 27
c
  210 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      integer function jesite(jern1,jern2,jetmax,jgext,ne,netmax,ns)
c
c     This subroutine returns the index of the site which contains
c     the ns-th species, a species of the ne-th generic ion exchanger
c     phase. If a match is not found, a zero value is returned.
c
c     This subroutine is called by:
c
c       None
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       jern1  = array giving the starts of the species ranges of sites
c                of generic ion exchanger phases
c       jern2  = array giving the ends of the species ranges of sites
c                of generic ion exchanger phases
c       jgext  = array of the number of sites in generic ion exchanger
c                  phases
c       ne     = the index of the desired generic ion exchanger phase
c       ns     = the index of the desired species
c
c     Output:
c
c       jesite = the index of the site containing the species whose
c                  index is ns, and which is a species in the ne-th
c                  generic ion exchanger phase
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jetmax,netmax
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax)
      integer ne,ns
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer je,nrr1,nrr2
c
c-----------------------------------------------------------------------
c
      jesite = 0
      do je = 1,jgext(ne)
        nrr1 = jern1(je,ne)
        nrr2 = jern2(je,ne)
        if (ns .le. nrr2) then
          if (ns .ge. nrr1) then
            jesite = je
            go to 999
          endif
        endif
      enddo
c
  999 continue
      end

      subroutine ptaylr(delxi,demop0,emop0,emop,nord,nordmx,npet,npetmx)
c
c     This subroutine evaluates Taylor's series expansions for the
c     number of moles of phases in the ES. These expansions are used
c     to find phase boundaries at which phases disappear from the ES.
c
c     Compare with:
c
c       EQ6/ataylr.f
c       EQ6/rtaylr.f
c       EQ6/ztaylr.f
c
c     See also:
c
c       EQ6/d1ptay.f
c       EQ6/d2ptay.f
c
c     This subroutine is called by:
c
c       EQ6/fpbdpp.f
c       EQ6/fpbflo.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       demop0 = the number of moles derivative vector for phases in
c                  the ES at the base point
c       nord   = the order of the truncated Taylor's series
c       nordmx = the maximum order of the truncated Taylor's series
c       npet   = the number of phases in the ES
c       npetmx = the maximum number of phases in the ES
c       emop0  = the number of moles vector for phases in the ES at
c                  at the base point
c
c     Principal output:
c
c       emop   = the number of moles vector for phases in the ES at
c                  at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nordmx,npetmx
c
      integer nord,npet
c
      real*8 emop(npetmx),emop0(npetmx),demop0(nordmx,npetmx)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,npe
c
      real*8 dxp,ex
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      do npe = 1,npet
        ex = emop0(npe)
        dxp = 1.
        do n = 1,nord
          dxp = dxp*delxi
          ex = ex + ( demop0(n,npe)/fctrl(n) )*dxp
        enddo
        emop(npe) = ex
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine evdata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $ adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $ al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,
     $ axhfs,axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,
     $ bdhv,bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,
     $ dhfe,dhfs,dhfsd,dvfe,dvfs,dvfsd,ehfac,farad,iapxmx,iktmax,
     $ iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,ixrn2,jpfcmx,
     $ jptffl,jsol,narxmx,narxt,narxth,ncmpr,nmut,nmutmx,nopgmx,
     $ noptmx,noutpt,nptmax,nslt,nsltmx,nst,nstmax,ntpr,ntprmx,nttyo,
     $ nxt,nxtmax,pmu,prehw,presg,presh,press,pslamn,rconst,rcnstv,
     $ rtcnst,tempc,tempk,uphase,uspec,wfac,xhfe,xhfs,xhfsd,xlke,xlks,
     $ xlksd,xvfe,xvfs,xvfsd)
c
c     This subroutine evaluates thermodynamic properties as a function
c     of temperature and the standard grid pressure. Pressure
c     corrections are made by EQLIB/pcorrx.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,iktmax,ipbtmx,ipchmx,ipcvmx,jpfcmx,narxmx,nmutmx,
     $ nopgmx,noptmx,nptmax,nsltmx,nstmax,ntprmx,nxtmax
c
      integer noutpt,nttyo
c
      integer iopg(nopgmx),iopt(noptmx),jsol(nxtmax),narxt(ntprmx),
     $ narxth(2),ncmpr(2,nptmax)
c
      integer ipch,ipcv,ixrn1,ixrn2,jptffl,nmut,nslt,nst,ntpr,nxt
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 aadh(narxmx,ntprmx),aadhh(narxmx,ntprmx),
     $ aadhv(narxmx,ntprmx),aaphi(narxmx,ntprmx),
     $ abdh(narxmx,ntprmx),abdhh(narxmx,ntprmx),abdhv(narxmx,ntprmx),
     $ abdot(narxmx,ntprmx),abdoth(narxmx,ntprmx),abdotv(narxmx,ntprmx),
     $ adadhh(narxmx,ntprmx,ipchmx),adadhv(narxmx,ntprmx,ipcvmx),
     $ adbdhh(narxmx,ntprmx,ipchmx),adbdhv(narxmx,ntprmx,ipcvmx),
     $ adbdth(narxmx,ntprmx,ipchmx),adbdtv(narxmx,ntprmx,ipcvmx),
     $ adhfe(narxmx,ntprmx,ipchmx),adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),advfe(narxmx,ntprmx,ipcvmx),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ aprehw(narxmx,ntprmx),apresg(narxmx,ntprmx),apresh(5,2),
     $ axhfe(narxmx,ntprmx),axhfs(narxmx,ntprmx,nstmax),
     $ axhfsd(narxmx,ntprmx,nstmax),axlke(narxmx,ntprmx),
     $ axlks(narxmx,ntprmx,nstmax),axlksd(narxmx,ntprmx,nstmax),
     $ axvfe(narxmx,ntprmx),axvfs(narxmx,ntprmx,nstmax),
     $ axvfsd(narxmx,ntprmx,nstmax)
c
      real*8 dadhh(ipchmx),dadhv(ipcvmx),dbdhh(ipchmx),dbdhv(ipcvmx),
     $ dbdth(ipchmx),dbdtv(ipcvmx),dhfe(ipchmx),dhfs(ipchmx,nstmax),
     $ dhfsd(ipchmx,nstmax),dvfe(ipcvmx),dvfs(ipcvmx,nstmax),
     $ dvfsd(ipcvmx,nstmax),xhfs(nstmax),xhfsd(nstmax),xlks(nstmax),
     $ xlksd(nstmax),xvfs(nstmax),xvfsd(nstmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ prehw,presg,presh,press,xhfe,xlke,xvfe
c
      real*8 amu(jpfcmx,nmutmx),aslm(jpfcmx,0:ipbtmx,nsltmx),
     $ pmu(nmutmx),pslamn(0:ipbtmx,nsltmx)
c
      real*8 apx(iapxmx,nxtmax),wfac(iktmax,nxtmax)
c
      real*8 afcnst,al10,avcnst,ehfac,farad,rconst,rcnstv,rtcnst,
     $ tempc,tempk
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ipc,ntprh
c
      real*8 prop
c
c-----------------------------------------------------------------------
c
c     Compute temperature dependent constants.
c
      rtcnst = 0.001*rconst*tempk
      afcnst = al10*rtcnst
      avcnst = al10*rcnstv*tempk
      ehfac = (al10*rconst*tempk)/farad
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the standard grid pressure.
c
c     Calling sequence substitutions:
c       apresg for arr
c       presg for prop
c
      call evdat2(apresg,narxmx,narxt,ntpr,ntprmx,presg,tempc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the 1.013-bar/steam-saturation curve pressure at the
c     initial temperature.
c
      if (tempc .le. 100.) then
        ntprh = 1
      else
        ntprh = 2
      endif
c
c     Calling sequence substitutions:
c       apresh for arr
c       5 for narxmx
c       narxth for narxt
c       ntprh for ntpr
c       2 for ntprmx
c       presh for prop
c
      call evdat2(apresh,5,narxth,ntprh,2,presh,tempc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipcv .ge. 0) then
c
c       Compute the half-width of the recommended pressure envelope.
c
c       Calling sequence substitutions:
c         aprehw for arr
c         prehw for prop
c
        call evdat2(aprehw,narxmx,narxt,ntpr,ntprmx,prehw,tempc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .le. 0) then
c
c       Davies equation or B-dot equation.
c
c       Compute the Debye-Huckel A(gamma,10) parameter.
c
c       Calling sequence substitutions:
c         aadh for arr
c         adh for prop
c
        call evdat2(aadh,narxmx,narxt,ntpr,ntprmx,adh,tempc)
c
        aphi = adh*al10/3.
      endif
c
      if (iopg(1) .eq. 1) then
c
c       Pitzer's equations.
c
c       Compute the Debye-Huckel A(phi) parameter.
c
c       Calling sequence substitutions:
c         aaphi for arr
c         aphi for prop
c
        call evdat2(aaphi,narxmx,narxt,ntpr,ntprmx,aphi,tempc)
        adh= 3.*aphi/al10
      endif
c
      if (iopg(1) .eq. 2) then
c
c       HC + DH equations.
c
c       Compute the Debye-Huckel A(gamma,10) parameter.
c
c       Calling sequence substitutions:
c         aadh for arr
c         adh for prop
c
        call evdat2(aadh,narxmx,narxt,ntpr,ntprmx,adh,tempc)
c
        aphi = adh*al10/3.
      endif
c
      if (ipch .ge. 0) then
c
c       Compute the Debye-Huckel A(H) parameter.
c
c       Calling sequence substitutions:
c         aadhh for arr
c         adhh for prop
c
        call evdat2(aadhh,narxmx,narxt,ntpr,ntprmx,adhh,tempc)
c
        do ipc = 1,ipch
c
c         Compute the pressure derivatives of the Debye-Huckel A(H)
c         parameter.
c
c         Calling sequence substitutions:
c           adadhh for arr
c           ipc for k
c           ipchmx for nmax
c
          call evdat3(adadhh,ipc,ipchmx,narxmx,narxt,ntpr,ntprmx,
     $    prop,tempc)
          dadhh(ipc) = prop
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Compute the Debye-Huckel A(V) parameter.
c
c       Calling sequence substitutions:
c         aadhv for arr
c         adhv for prop
c
        call evdat2(aadhv,narxmx,narxt,ntpr,ntprmx,adhv,tempc)
c
        do ipc = 1,ipcv
c
c         Compute the pressure derivatives of the Debye-Huckel A(V)
c         parameter.
c
c         Calling sequence substitutions:
c           adadhv for arr
c           ipc for k
c           ipcvmx for nmax
c
          call evdat3(adadhv,ipc,ipcvmx,narxmx,narxt,ntpr,ntprmx,
     $    prop,tempc)
          dadhv(ipc) = prop
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1).eq.0 .or. iopg(1).eq.2) then
c
c       B-dot equation or HC + DH equations.
c
c       Compute the Debye-Huckel B(gamma) parameter.
c
c       Calling sequence substitutions:
c         abdh for arr
c         bdh for prop
c
        call evdat2(abdh,narxmx,narxt,ntpr,ntprmx,bdh,tempc)
c
        if (ipch .ge. 0) then
c
c         Compute the Debye-Huckel B(H) parameter.
c
c         Calling sequence substitutions:
c           abdhh for arr
c           bdhh for prop
c
          call evdat2(abdhh,narxmx,narxt,ntpr,ntprmx,bdhh,tempc)
c
          do ipc = 1,ipch
c
c           Compute the pressure derivatives of the Debye-Huckel B(H)
c           parameter.
c
c           Calling sequence substitutions:
c             adbdhh for arr
c             ipc for k
c             ipchmx for nmax
c
            call evdat3(adbdhh,ipc,ipchmx,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            dbdhh(ipc) = prop
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Compute the Debye-Huckel B(V) parameter.
c
c         Calling sequence substitutions:
c           abdhv for arr
c           bdhv for prop
c
          call evdat2(abdhv,narxmx,narxt,ntpr,ntprmx,bdhv,tempc)
c
          do ipc = 1,ipcv
c
c           Compute the pressure derivatives of the Debye-Huckel B(V)
c           parameter.
c
c           Calling sequence substitutions:
c             adbdhv for arr
c             ipc for k
c             ipcvmx for nmax
c
            call evdat3(adbdhv,ipc,ipcvmx,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            dbdhv(ipc) = prop
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 0) then
c
c       B-dot equation.
c
c       Compute the Helgeson (1969) B-dot parameter.
c
c       Calling sequence substitutions:
c         abdot for arr
c         bdot for prop
c
        call evdat2(abdot,narxmx,narxt,ntpr,ntprmx,bdot,tempc)
c
        if (ipch .ge. 0) then
c
c         Compute the Debye-Huckel B-dot(H) parameter.
c
c         Calling sequence substitutions:
c           abdoth for arr
c           bdoth for prop
c
          call evdat2(abdoth,narxmx,narxt,ntpr,ntprmx,bdoth,tempc)
c
          do ipc = 1,ipch
c
c           Compute the pressure derivatives of the Debye-Huckel
c           B-dot(H) parameter.
c
c           Calling sequence substitutions:
c             adbdth for arr
c             ipc for k
c             ipchmx for nmax
c
            call evdat3(adbdth,ipc,ipchmx,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            dbdth(ipc) = prop
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Compute the Debye-Huckel B-dot(V) parameter.
c
c         Calling sequence substitutions:
c           abdotv for arr
c           bdotv for prop
c
          call evdat2(abdotv,narxmx,narxt,ntpr,ntprmx,bdotv,tempc)
c
          do ipc = 1,ipcv
c
c           Compute the pressure derivatives of the Debye-Huckel
c           B-dot(V) parameter.
c
c           Calling sequence substitutions:
c             adbdtv for arr
c             ipc for k
c             ipcvmx for nmax
c
            call evdat3(adbdtv,ipc,ipcvmx,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            dbdtv(ipc) = prop
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the log K for the 'Eh' reaction.
c
      if (axlke(1,ntpr) .lt. 9999999.) then
c
c       Calling sequence substitutions:
c         axlke for arr
c         xlke for prop
c
        call evdat2(axlke,narxmx,narxt,ntpr,ntprmx,xlke,tempc)
      else
        xlke = 9999999.
      endif
c
      if (ipch .ge. 0) then
c
c       Compute the enthalpy of reaction for the 'Eh' reaction.
c
        if (axhfe(1,ntpr) .lt. 9999999.) then
c
c         Calling sequence substitutions:
c           axhfe for arr
c           xhfe for prop
c
          call evdat2(axhfe,narxmx,narxt,ntpr,ntprmx,xhfe,tempc)
        else
          xhfe = 9999999.
        endif
c
        do ipc = 1,ipch
c
c         Compute the pressure derivatives of the enthalpy of
c         reaction for the 'Eh' reaction.
c
c         Calling sequence substitutions:
c           adhfe for arr
c           ipc for k
c           ipchmx for nmax
c
          call evdat3(adhfe,ipc,ipchmx,narxmx,narxt,ntpr,ntprmx,
     $    prop,tempc)
          dhfe(ipc) = prop
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Compute the volume of reaction for the 'Eh' reaction.
c
        if (axvfe(1,ntpr) .lt. 9999999.) then
c
c         Calling sequence substitutions:
c           axvfe for arr
c           xvfe for prop
c
          call evdat2(axvfe,narxmx,narxt,ntpr,ntprmx,xvfe,tempc)
        else
          xvfe = 9999999.
        endif
c
        do ipc = 1,ipcv
c
c         Compute the pressure derivatives of the volume of
c         reaction for the 'Eh' reaction.
c
c         Calling sequence substitutions:
c           advfe for arr
c           ipc for k
c           ipcvmx for nmax
c
          call evdat3(advfe,ipc,ipcvmx,narxmx,narxt,ntpr,ntprmx,
     $    prop,tempc)
          dvfe(ipc) = prop
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the log K values for all reactions as they are
c     currently written.
c
      call evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $ ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $ tempc,xhfs,xlks,xvfs)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the log K values for all reactions as they were
c     written on the data file.
c
c     Calling sequence substitutions:
c       adhfsd for adhfs
c       advfsd for advfs
c       axhfsd for axhfs
c       axlksd for axlks
c       axvfsd for avhfs
c       dhfsd for dhfs
c       dvfsd for dvfs
c       xhfsd for xhfs
c       xlksd for xlks
c       xvfsd for xvfs
c
      call evdatr(adhfsd,advfsd,axhfsd,axlksd,axvfsd,dhfsd,dvfsd,
     $ ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $ tempc,xhfsd,xlksd,xvfsd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute remaining temperature-dependent aqueous species activity
c     coefficient parameters.
c
      if (iopg(1) .eq. 1) then
c
c       Computer the S-lambda(n) and mu coefficients for Pitzer's
c       equations.
c
        call evptzc(amu,aslm,ipbtmx,jpfcmx,jptffl,nmut,nmutmx,
     $  noutpt,nttyo,nslt,nsltmx,pmu,pslamn,tempc)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute temperature dependent solid solution activity
c     coefficient parameters.
c
      if (iopt(4) .ge. 1) then
        call wterm(apx,iapxmx,iktmax,ixrn1,ixrn2,jsol,ncmpr,
     $  noutpt,nptmax,nstmax,nttyo,nxt,nxtmax,press,tempk,uphase,
     $  uspec,wfac)
      endif
c
      end

      subroutine d2ztay(delxi,dzvc0,d2zvc1,kcol,kmax,nord,nrd1mx)
c
c     This subroutine computes the Taylor's series expansion for the
c     second derivative of the kcol-th master variables. This second
c     derivative is used to test whether or not a critical point
c     corresponds to a maximum.
c
c     See also:
c
c       EQ6/d1ztay.f
c       EQ6/ztaylr.f
c
c     This subroutine is called by:
c
c       None
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       dzvc0  = the dz/d(xi) vector at the base point
c       kcol   = the index of the master variable whose second
c                  derivative is to be calculated
c       kmax   = the maximum number of elements in the z vector
c       nord   = the order of the truncated Taylor's series
c       nrd1mx = the maximum order of the truncated Taylor's series + 1
c
c     Principal output:
c
c       d2zvc1 = the d2z/d(xi)2 element for the kcol-th master
c                  variable
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nrd1mx
c
      integer kcol,nord
c
      real*8 dzvc0(nrd1mx,kmax)
c
      real*8 delxi,d2zvc1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jk
c
      real*8 dxp,d2z
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      d2zvc1 = 0.
      if (nord .gt. 1) then
        d2z = dzvc0(2,kcol)
        if (nord .gt. 2) then
          jk = nord - 2
          dxp = 1.
          do j = 1,jk
            dxp = dxp*delxi
            d2z = d2z + ( dzvc0(j + 2,kcol )/fctrl(j) )*dxp
          enddo
        endif
        d2zvc1 = d2z
      endif
c
      end

      subroutine fcopya(nf1,nf2)
c
c     This subroutine appends the contents of the file whose unit number
c     is nf1 to the file whose unit number is nf2. The line length
c     is assumed to be 128 characters. The second file  must already
c     be open and correctly positioned.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nf1    = unit number of the first file
c       nf2    = unit number of the second file
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nf1,nf2
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j
c
      character*128 uline
c
c----------------------------------------------------------------------
c
      rewind nf1
      do j = 1,10000
        read (nf1,1000,end=999) uline
 1000   format(a128)
        write (nf2,1000) uline
      enddo
c
  999 continue
      end

      subroutine prpheh(ah,ahmes,ahnbs,eh,ehmes,ehnbs,iopg,
     $ nopgmx,noutpt,pch,pe,pemes,penbs,ph,phcl,phmes,phnbs,
     $ qphcl,qredox,qrho)
c
c     This subroutine prints the pH, Eh (redox potential), and pe
c     (log electron activity function) on the following pH scales:
c
c       1. The scale corresponding to the activity coefficient
c          model equations, unless these are rescaled to be
c          consistent with the NBS pH scale or the Mesmer pH scale
c          (see iopg(2), discussed below).
c
c       2. The NBS pH scale.
c
c       3. The Mesmer pH scale (pH is numerically equal to -log m(H+)).
c
c     Note the following options for the unscaled model pH scale,
c     which are chosen by the option switch iopg(2):
c
c       = -1   The internal scale is defined for the activity
c              coefficient model defined by iopg(1)
c
c       =  0   The modified NBS pH scale (log gamma Cl-
c              is defined by the Bates-Guggenheim expression)
c
c       =  2   The Mesmer pH (pmH) scale
c
c     This subroutine also prints the pHCl, which is equivalent to
c     pH + pCl and independent of the choice of pH scale.
c
c     The quantities printed by this subroutine are computed by
c     EQLIB/gpheh.f.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ah     = Ah corresponding to the pH used in the computation
c       ahmes  = Ah corresponding to the phmes
c       ahnbs  = Ah corresponding to the phnbs
c       pch    = pcH, pH based on the molarity of the hydrogen ion
c       ph     = pH on scale used in computation
c       phcl   = pHCl
c       phmes  = pH on the Mesmer scale (same as the pmH)
c       phnbs  = pH on the modified NBS scale
c       eh     = Eh corresponding to the pH used in the computation
c       ehmes  = Eh corresponding to the phmes
c       ehnbs  = Eh corresponding to the phnbs
c       pe     = pe function corresonding to Eh
c       pemes  = pe function corresonding to ehmes
c       penbs  = pe function corresonding to ehnbs
c       iopg   = array of activity coefficient option switches
c       noutpt = the unit number of the output file
c       qrho   = .true. if a solution density value is available
c       qpchl  = logical flag, = .true. if pHCl is defined
c       qredox = logical flag, = .true. if there is oxidation-reduction
c                  in the modeled system
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nopgmx
c
      integer noutpt
c
      integer iopg(nopgmx)
c
      logical qphcl,qredox,qrho
c
      real(8) ah,ahmes,ahnbs,eh,ehmes,ehnbs,pch,pe,pemes,penbs,ph,
     $ phcl,phmes,phnbs
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,isc
c
      integer ilnobl
c
      character*24 uphscs(6)
c
c-----------------------------------------------------------------------
c
      data (uphscs(isc), isc = 1,6)  /'Internal pH scale       ',
     $     'NBS pH scale            ','Mesmer pH (pmH) scale   ',
     $     'Pitzer pH scale         ','B-dot pH scale          ',
     $     'Davies pH scale         '/
c
c-----------------------------------------------------------------------
c
      isc = 1
      if (iopg(2) .ge. 0) then
        isc = iopg(2) + 2
      else
        if (iopg(1) .eq. 1) then
          isc = 4
        elseif (iopg(1) .eq. 0) then
          isc = 5
        elseif (iopg(1) .eq. -1) then
          isc = 6
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
        write (noutpt,1000)
 1000   format(/11x,'--- The pH, Eh, pe-, and Ah on various pH',
     $  ' scales ---')
        write (noutpt,1010)
 1010   format(/31x,'pH',5x,'Eh, volts',8x,'pe-',7x,'Ah, kcal',/)
c
        if (isc.ne.2 .and. isc.ne.3) then
          write (noutpt,1020) uphscs(isc),ph,eh,pe,ah
 1020     format(1x,a24,2x,f8.4,3x,f8.4,4x,1pe11.4,2x,0pf10.4)
        endif
c
        write (noutpt,1020) uphscs(2),phnbs,ehnbs,penbs,ahnbs
        write (noutpt,1020) uphscs(3),phmes,ehmes,pemes,ahmes
      else
        write (noutpt,1030)
 1030   format(/11x,'--- The pH on various pH scales ---')
        write (noutpt,1040)
 1040   format(/40x,'pH',/)
        if (isc.ne.2 .and. isc.ne.3) then
          write (noutpt,1050) uphscs(isc),ph
 1050     format(6x,a24,3x,f11.4)
        endif
c
        write (noutpt,1050) uphscs(2),phnbs
        write (noutpt,1050) uphscs(3),phmes
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1100)
 1100 format(/1x)
c
      if (qrho) then
        write (noutpt,1110) pch
 1110   format(6x,'pcH= ',f11.4)
      endif
c
      if (qphcl) then
        write (noutpt,1140) phcl
 1140   format(5x,'pHCl= ',f11.4)
      else
        write (noutpt,1150)
 1150   format(5x,'The pHCl is undefined because no Cl- is present.')
      endif
c
      write (noutpt,1160)
 1160 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      j2 = ilnobl(uphscs(isc))
      write (noutpt,1190) uphscs(isc)(1:j2)
 1190 format(/3x,'The single ion activities and activity coefficients',
     $ ' listed below',/3x,'are consistent with the ',a,'.',/)
c
      end

      subroutine cpcomb(jassan,jassca,jassne,naapr,nat,ncapr,nccpr,
     $ nnapr,nncpr,nnnpr,nn2pr,naactr,na2ctr,nncatr,nccatr,nc2atr,
     $ nn2ntr,nn3tr)
c
c     Compute all the pair and triplet combinations of aqueous
c     solute species for use with Pitzer's equations. parameters.
c
c     All pairs and triplets are distinct in the sense that the
c     ordering of the members is not relevant; e.g., ca = ac,
c     cc' = c'c, nca = anc = can = cna = acn = nac.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jassca = number of aqueous cation species
c       jassan = number of aqueous anion species (excluding aqueous e-)
c       jassne = number of aqueous neutral species (excluding solvent
c                  water and aqeuous O2(g))
c       nat    = the number of aqueous species
c
c     Principal output:
c
c       naapr  = number of aa' pairs
c       ncapr  = number of ca pairs
c       nccpr  = number of cc' pairs
c       nnapr  = number of na pairs
c       nncpr  = number of nc pairs
c       nnnpr  = number of nn' pairs
c       nn2pr  = number of nn pairs
c
c       naactr = number of aa'c triplets
c       na2ctr = number of aac triplets
c       nccatr = number of cc'a triplets
c       nc2atr = number of cca triplets
c       nncatr = number of nca triplets
c       nn3tr  = number of nnn triplets
c       nn2ntr = number of nnn' triplets
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jassan,jassca,jassne,nat
c
      integer naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr,
     $ naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jn,jc,ja
c
c-----------------------------------------------------------------------
c
      jn = jassne
      jc = jassca
      ja = jassan
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pair combinations.
c
c     Get the number of ca pairs.
c
      ncapr = jc*ja
c
c     Get the number of cc' pairs.
c
      nccpr = jc*(jc -1)/2
c
c     Get the number of aa' pairs.
c
      naapr = ja*(ja -1)/2
c
c     Get the number of nn pairs.
c
      nn2pr = jn
c
c     Get the number of nn' pairs.
c
      nnnpr = jn*(jn -1)/2
c
c     Get the number of nc pairs.
c
      nncpr = jn*jc
c
c     Get the number of na pairs.
c
      nnapr = jn*ja
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Triplet combinations.
c
c     Get the number of cca triplets.
c
      nc2atr = ncapr
c
c     Get the number of aac triplets.
c
      na2ctr = ncapr
c
c     Get the number of nnn triplets.
c
      nn3tr = nn2pr
c
c     Get the number of nnn' triplets.
c
      nn2ntr = 2*nn2pr
c
c     Get the number of cc'a triplets.
c
      nccatr = nccpr*ja
c
c     Get the number of aa'c triplets.
c
      naactr = naapr*jc
c
c     Get the number of nca triplets.
c
      nncatr = jn*jc*ja
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine prtalk(alki,alk1,alk2,mrmlra,noutpt,ntf1t,ntf2t,
     $ qrho,rho,tempc,wfh2o)
c
c     This subroutine writes a table of computed alkalinity parameters.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt
c
      integer ntf1t,ntf2t
c
      real(8) alki,alk1,alk2,mrmlra,rho,tempc,wfh2o
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
      logical qrho
c
      character(len=16) ux16
c
      real(8) alkicv,alkicw,alkihv,alkihw,alkipl,alk1cv,alk1cw,alk1hv,
     $ alk1hw,alk1pl,alk2cv,alk2cw,alk2hv,alk2hw,alk2pl
c
c-----------------------------------------------------------------------
c
c     Check the temperature. Alkalinity of any kind is only defined
c     in the temperature range 0-50 C.
c
      if (tempc.lt.0. .or. tempc.gt.50.) then
        write (ux16,'(f12.3)') tempc
        call lejust(ux16)
        j2 = ilnobl(ux16)
        write (noutpt,1000) ux16(1:j2)
 1000   format(//6x,'Alkalinity is not defined at ',a,' C.',
     $  /6x,'It is only defined in the temperature range 0-50 C.',/)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a table of the HCO3-CO3-OH total alkalinity.
c
      write (noutpt,1010)
 1010 format(/11x,'--- HCO3-CO3-OH Total Alkalinity ---',/)
c
c     Test for the required coefficients.
c
      if (ntf1t .le. 0) then
        write (noutpt,1020)
 1020   format(6x,'Coefficients to compute this alkalinity',
     $  ' are not available.',/)
        go to 110
      endif
c
      alk1cw = 50000*wfh2o*alk1
      alk1hw = 1.2192*alk1cw
c
      if (qrho) then
c
c       Have density data, include volumetric measures.
c
        alk1pl = alk1*mrmlra
        alk1cv = alk1cw*rho
        alk1hv = 1.2192*alk1cv
c
        write (noutpt,1030) alk1,alk1pl,alk1cw,alk1hw,alk1cv,alk1hv
 1030   format(16x,1pg12.5,' eq/kg.H2O',/16x,1pg12.5,' eq/L',
     $  /16x,1pg12.5,' mg/kg.sol CaCO3',/16x,1pg12.5,' mg/kg.sol HCO3-',
     $  /16x,1pg12.5,' mg/L CaCO3',/16x,1pg12.5,' mg/L HCO3-',/)
      else
c
c       Have no density data, do not include volumetric measures.
c
        write (noutpt,1040) alk1,alk1cw,alk1hw
 1040   format(16x,1pg12.5,' eq/kg.H2O',/16x,1pg12.5,' mg/kg.sol CaCO3',
     $  /16x,1pg12.5,' mg/kg.sol HCO3-',/)
      endif
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a table of the extended total alkalinity.
c
      write (noutpt,1050)
 1050 format(/11x,'--- Extended Total Alkalinity ---',/)
c
c     Test for the required coefficients.
c
      if (ntf2t .le. 0) then
        write (noutpt,1020)
        go to 120
      endif
c
      alk2cw = 50000*wfh2o*alk2
      alk2hw = 1.2192*alk2cw
c
      if (qrho) then
c
c       Have density data, include volumetric measures.
c
        alk2pl = alk2*mrmlra
        alk2cv = alk2cw*rho
        alk2hv = 1.2192*alk2cv
c
        write (noutpt,1030) alk2,alk2pl,alk2cw,alk2hw,alk2cv,alk2hv
      else
c
c       Have no density data, do not include volumetric measures.
c
        write (noutpt,1040) alk2,alk2cw,alk2hw
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  120 if (alki .gt. 0.) then
c
c       Write a table of the input alkalinity. This is relevant in
c       EQ3NR, but not in EQ6.
c
        write (noutpt,1060)
 1060   format(/11x,'--- Input Total Alkalinity ---',/)
c
        alkicw = 50000*wfh2o*alki
        alkihw = 1.2192*alkicw
c
        if (qrho) then
c
c         Have density data, include volumetric measures.
c
          alkipl = alki*mrmlra
          alkicv = alkicw*rho
          alkihv = 1.2192*alkicv
          write (noutpt,1030) alki,alkipl,alkicw,alkihw,alkicv,alkihv
        else
c
c         Have no density data, do not include volumetric measures.
c
          write (noutpt,1040) alki,alkicw,alkihw
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine ptztab(iopr,narn1,narn2,natmax,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,noprmx,noutpt,nsltmx,nslx,nstmax,nsxi,nsxmax,
     $ nsxx,uspec)
c
c     This subroutine tabulates the species combinations corresponding
c     to coefficients for Pitzer's equations. The tabulation is
c     controlled by iopr(10):
c
c        0 = Don't print
c        1 = Print a summary of the names of the species present and
c              the number of Pitzer interaction coefficients
c        2 = Print a summary of the names of the species present and
c              the number of Pitzer interaction coefficients
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       iopr   = array of print option switches
c       narn1  = start of aqueous species range
c       narn2  = end of aqueous species range
c       nmux   = array of aqueous species indices defining triplets
c                  of species for which mu data are present
c       nmutmx = the maximum number of triplets of aqueous species
c                  for which Pitzer interaction parameters are
c                  defined; the second dimension of the nmux array
c       nmxi   = range pointer array into the nmxx array:
c                  nmxi(1,na) and nmxi(2,na) are the first and last
c                  values of the second subscript (nmx) of the nmxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nmxx   = pointer array:
c                  nmxx(1,nmx) = the species index of the second
c                  species in the nmu-th triplet, nmxx(2,nmx) is the
c                  species index of the third species, and
c                  nmxx(3,nmx) = nmu
c       nslx   = array of aqueous species indices defining pairs
c                  of species for which S-lambda data are present
c       nsltmx = the maximum number of pairs of aqueous species
c                  for which Pitzer interaction parameters are
c                  defined; the second dimension of the nslx array
c       nsxi   = range pointer array into the nsxx array:
c                  nsxi(1,na) and nsxi(2,na) are the first and last
c                  values of the second subscript (nsx) of the nsxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nsxx   = pointer array:
c                  nsxx(1,nsx) = the species index of the second
c                  species in the nsl-th pair, and nsxx(2,nsx) = nsl
c       uspec  = names of species
c
c     Principal output:
c
c        None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nmutmx,nmxmax,noprmx,nsltmx,nstmax,nsxmax
c
      integer noutpt
c
      integer iopr(noprmx),nmux(3,nmutmx),nmxi(2,natmax),nmxx(3,nmxmax),
     $ nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
      integer narn1,narn2
c
      character*48 uspec(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4,islt,imut,ixf,ixl,na,nmu,nmx,ns,nsl,nsx,ns1,
     $ ns2,ns3
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
      if (iopr(10) .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The following loop assumes that water is the narn1-th species.
c
      if (iopr(10) .eq. 1) then
c
c       Write a table giving the S-lambda and mu tallies for each
c       aqueous species in the current model.
c
        write (noutpt,1000)
 1000   format(/11x,'--- Pitzer Interaction Coefficient Summary ---',
     $  /4x,'Species',15x,'S-lambda Sets',3x,'Mu Sets',/)
c
c       The following loop assumes that water is the narn1-th species.
c
        do ns = narn1 + 1, narn2
          if (uspec(ns)(1:6).ne.'O2(g) ' .and.
     $      uspec(ns)(1:3).ne.'e- ') then
            na = ns - narn1 + 1
            islt = nsxi(2,na) - nsxi(1,na) + 1
            imut = nmxi(2,na) - nmxi(1,na) + 1
            write (noutpt,1010) uspec(ns),islt,imut
 1010       format(2x,a24,2x,i4,7x,i4)
          endif
        enddo
        write (noutpt,1020)
 1020   format(/1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(10) .ge. 2) then
c
c       Write a table giving the S-lambda and mu tallies for eachi
c       aqueous species in the current model. Also list the other
c       species involved in the S-lambda and mu combinations.
c
        write (noutpt,1100)
 1100   format(/15x,'--- Pitzer Interaction Coefficient Sets ---')
c
c       The following loop assumes that water is the narn1-th species.
c
        do ns = narn1 + 1, narn2
          if (uspec(ns)(1:6).ne.'O2(g) ' .and.
     $      uspec(ns)(1:3).ne.'e- ') then
            na = ns - narn1 + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1110) uspec(ns)(1:j2)
 1110       format(//' Coefficients for ',a,':',/)
c
            ixf = nsxi(1,na)
            ixl = nsxi(2,na)
            islt = ixl - ixf + 1
            write (noutpt, 1120) islt
 1120       format(3x,'No. of S-lambda sets= ',i4,':',/)
            if (islt .gt. 0) then
              do nsx = ixf,ixl
                nsl = nsxx(2,nsx)
                ns1 = nslx(1,nsl)
                ns2 = nslx(2,nsl)
                j2 = ilnobl(uspec(ns1)(1:24))
                j3 = ilnobl(uspec(ns2)(1:24))
                write (noutpt,1130) uspec(ns1)(1:j2),uspec(ns2)(1:j3)
 1130           format(5x,a,', ',a)
              enddo
            endif
c
            ixf = nmxi(1,na)
            ixl = nmxi(2,na)
            imut = ixl - ixf + 1
            write (noutpt, 2530) imut
 2530       format(/3x,'No. of mu sets= ',i4,':',/)
            if (imut .gt. 0) then
              do nmx = ixf,ixl
                nmu = nmxx(3,nmx)
                ns1 = nmux(1,nmu)
                ns2 = nmux(2,nmu)
                ns3 = nmux(3,nmu)
                j2 = ilnobl(uspec(ns1)(1:24))
                j3 = ilnobl(uspec(ns2)(1:24))
                j4 = ilnobl(uspec(ns3)(1:24))
                write (noutpt,2540) uspec(ns1)(1:j2),uspec(ns2)(1:j3),
     $          uspec(ns3)(1:j4)
 2540           format(5x,a,', ',a,', ',a)
              enddo
            endif
c
          endif
        enddo
        write (noutpt,1020)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gwhcfa(akmat1,delxi,dxsm11,hhcvec,nord,nordmx,
     $ nrd1mx,whcfac,xhcvec)
c
c     This subroutine computes the w factor (whcfac), which is
c     required for higher-order (stiff) ODE corrections. Logically,
c     w = g dot FCh where g and h are vectors, and (FC) is the matrix
c     required to convert finite differences utilizing the new point
c     of reaction progress to derivatives at the base point. This
c     factor depends only on the recent step size history, including
c     the current step size (delxi).
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       akmat1 = the (FC) matrix
c       delxi  = the current step size
c       dxsm11 = the array of cumulative step sizes going back from
c                  new point, centered on the new point
c       nord   = the order of the finite difference method
c       nordmx = the maximum order of the finite difference method
c       nrd1mx = nordmx + 1
c       hhcvec = the h vector, here effectively work space
c       xhcvec = the FCh vector, here effectively work space
c
c     Principal output:
c
c       whcfac = the w factor
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nordmx,nrd1mx
c
      integer nord
c
      real*8 akmat1(nrd1mx,nrd1mx),dxsm11(nrd1mx),hhcvec(nordmx),
     $ xhcvec(nordmx)
c
      real*8 delxi,whcfac
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j
c
      real(8) gx
c
c----------------------------------------------------------------------
c
c     First calculate h (hhcvec).
c
      hhcvec(1) = 1./delxi
      do j = 2,nord
        hhcvec(j) = hhcvec(j - 1)/dxsm11(j)
      enddo
c
c     Now calculate the (FCh) vector (xhcvec).
c
      do i = 1,nord
        xhcvec(i) = 0.
        do j = 1,nord
          xhcvec(i) = xhcvec(i) + akmat1(i,j)*hhcvec(j)
        enddo
      enddo
c
c     Finally, emulate w = g dot (FCh).
c
      whcfac = 0.
      gx = delxi
      do j = 1,nord
        gx = gx*delxi/(j + 1)
        whcfac = whcfac + gx*xhcvec(j)
      enddo
c
      end

      subroutine shftph(emop,emop0,emos,emos0,fdpe0,fdpem1,
     $ fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,
     $ imrn1,imrn2,ipndx1,ixrn1,ixrn2,jern1,jetmax,jgext,
     $ jpflag,jsflag,kbt,kmax,km1,kmt,kx1,kxt,loph,losp,moph,
     $ mosp,mprph,mprsp,mrgexs,nbtmax,ncmpe,ncmpr,netmax,
     $ ngext,nordmx,noutpt,np,npet,npetmx,nptmax,nsetmx,
     $ nstmax,nttyo,qshftd,qtotsh,uphase,xbar,xbarlg,zklgmn,
     $ zklogl,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine shifts mass of a single phase from the equilibrium
c     system (ES) to the physically removed subsystem (PRS), which is
c     a system conceptually out of contact with the aqueous solution.
c     Here np is the index of the desired phase.
c
c     Presently, the following kinds of phases may be shifted:
c
c       Generic ion exchange phases
c       Pure minerals
c       Solid solutions
c
c     A shift may be total or partial. If qtotsh = .true., the shift
c     is total and the entire mineral phase is transferred. Otherwise,
c     the shift is partial and the shift transfers only some of the
c     mass. At least 10**zklgmn moles of mass will remain in the ES.
c     If the mass is less than that to start with, no shift takes
c     place. Otherwise, the ES mass is reduced by multiplying the
c     existing mass by a factor of 10**-zklogl.
c
c     This subroutine decrements the ES mass of the phase and
c     correspondingly increments its PRS mass. However, it does
c     not recalculate the component total masses for the ES. After
c     this subroutine has been called, once or in a sequence, a call
c     must be made to EQ6/escalc.f, which recalculates the component
c     mass balance totals.
c
c     If a total shift is made, it will subsequently be necessary to
c     update the iemop indexing array and associated arrays used in
c     tracking the masses of phases in the ES.
c
c     If a shift is made, qshftd is returned as .true.; otherwise,
c     it is returned as .false.
c
c     The way the shift is made presumes that the calculation is
c     currently at the "zero" point, the value of Xi from which the
c     calculation will then step out.
c
c     This subroutine is called by:
c
c       EQ6/dumpdp.f
c       EQ6/pshfta.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,netmax,nordmx,npetmx,nptmax,
     $ nsetmx,nstmax
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iemos(nsetmx),iindx1(kmax),ipndx1(kmax),
     $ jern1(jetmax,netmax),jgext(netmax),jpflag(nptmax),jsflag(nstmax),
     $ ncmpe(2,npetmx),ncmpr(2,nptmax),
     $ ngext(jetmax,netmax)
c
      integer iern1,iern2,imrn1,imrn2,ixrn1,ixrn2,kbt,km1,kmt,
     $ kx1,kxt,np,npet
c
      logical qshftd,qtotsh
c
      character*24 uphase(nptmax)
c
      real*8 emop(npetmx),emop0(npetmx),emos(nsetmx),emos0(nsetmx),
     $ fdpe0(nordmx,npetmx),fdpem1(nordmx,npetmx),
     $ fdse0(nordmx,nsetmx),fdsem1(nordmx,nsetmx),
     $ loph(nptmax),losp(nstmax),mrgexs(ietmax,jetmax,netmax),
     $ moph(nptmax),mosp(nstmax),mprph(nptmax),mprsp(nstmax),
     $ xbar(nstmax),xbarlg(nstmax),zvclg0(kmax),zvclg1(kmax),
     $ zvec0(kmax),zvec1(kmax)
c
      real*8 zklgmn,zklogl
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,iptype,je,j2,kcol,kstart,kend,n,ne,npe,nr1,nr2,ns,nse
c
      integer ilnobl
c
      real*8 delmp,delms,lgexpl,lnew,lnew1,lold,lrx,mgexpl,mnew,mnew1,
     $ mold,mrx,zx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
      qshftd = .false.
c
c     Set the minimum mass of an exchanger phase that must remain in
c     the ES.
c
      lgexpl = -14.0
      mgexpl = texp(lgexpl)
c
c     Get the type of phase.
c
      iptype = 0
      if (np.ge.imrn1 .and. np.le.imrn2) then
c
c       Have a pure mineral.
c
        iptype = 1
      elseif (np.ge.ixrn1 .and. np.le.ixrn2) then
c
c       Have a solid solution.
c
        iptype = 2
      elseif (np.ge.iern1 .and. np.le.iern2) then
c
c       Have a generic ion exchange phase.
c
        iptype = 3
      endif
c
      if (iptype .le. 0) then
        j2 = ilnobl(uphase(np))
        write (noutpt,1000) np,uphase(np)(1:j2)
        write (nttyo,1000) np,uphase(np)(1:j2)
 1000   format(/' * Error - (EQ6/shftph) Programming error trap: The',
     $  ' phase',/7x,a," is not of a recognized type and can't have",
     $  ' mass shifted',/7x,'from the ES to the PRS.')
        stop
      endif
c
c     Save the current numbers of moles values.
c
      lold = loph(np)
      mold = moph(np)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the shift increment.
c
      if (qtotsh) then
c
c       Do a total shift.
c
        if (iptype .eq. 3) then
c
c         Have a generic ion exchanger phase.
c
cXX       Presently a generic ion exchange phase can not be
cXX       totally shifted.
c
          if (mold .le. mgexpl) then
            write (noutpt,1010) uphase(np)(1:j2),mold
 1010       format(3x,'Not shifted: ',a,/15x,'Mass= ',1pe12.5,' moles')
            go to 999
          endif
c
          lnew = lgexpl
          mnew = mgexpl
          delmp = mold - mgexpl
          jpflag(np) = 0
          j2 = ilnobl(uphase(np))
          write (noutpt,1020) uphase(np)(1:j2),mold,mnew
 1020     format(7x,'Shifted: ',a,/
     $    15x,'Old mass= ',1pe12.5,' moles, new mass= ',1pe12.5,
     $    ' moles')
        else
c
c         Have a pure mineral or a solid solution.
c
          lnew = -99999.
          mnew = 0.
          delmp = mold
          jpflag(np) = 0
          j2 = ilnobl(uphase(np))
          write (noutpt,1020) uphase(np)(1:j2),mold,mnew
        endif
      else
c
c       Do a partial shift.
c
        if (lold .le. zklgmn) then
c
c         Do not shift if the mass is already small.
c
          j2 = ilnobl(uphase(np))
          write (noutpt,1010) uphase(np)(1:j2),mold
          go to 999
        endif
c
        zx = lold - zklogl
        lnew = max(zx,zklgmn)
        mnew = texp(lnew)
        delmp = mold - mnew
        j2 = ilnobl(uphase(np))
        write (noutpt,1020) uphase(np)(1:j2),mold,mnew
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Complete the shift calculations.
c
      qshftd = .true.
c
c     Reset the primary mass variables.
c
      loph(np) = lnew
      moph(np) = mnew
c
c     Increment the PRS mass.
c
      mprph(np) = mprph(np) + delmp
c
      if (iptype.eq.1 .or. iptype.eq.2) then
c
c       Have a pure mineral or a solid solution.
c
        nr1 = ncmpr(1,np)
        nr2 = ncmpr(2,np)
        do ns = nr1,nr2
          delms = delmp*xbar(ns)
          mprsp(ns) = mprsp(ns) + delms
          if (qtotsh) then
c
c           Do a total shift.
c
            lnew1 = -99999.
            jsflag(ns) = 0
          else
c
c           Do a partial shift.
c
            lnew1 = lnew + xbarlg(ns)
          endif
          mnew1 = texp(lnew1)
          losp(ns) = lnew1
          mosp(ns) = mnew1
        enddo
      elseif (iptype .eq. 3) then
c
c       Have a generic ion exchange phase.
c
        ne = np - iern1 + 1
        do je = 1,jgext(ne)
          ns = jern1(je,ne) - 1
          do ie = 1,ngext(je,ne)
            ns = ns + 1
            mrx = mrgexs(ie,je,ne)
            lrx = tlg(mrx)
            delms = delmp*mrx
            mprsp(ns) = mprsp(ns) + delms
            if (qtotsh) then
c
c             Do a total shift of the component species.
c
cXX           Presently a generic ion exchange phase can not be
cXX           totally shifted; hence, neither can the component
cXX           species.
c
              lnew1 = lgexpl
            else
c
c             Do a partial shift.
c
              lnew1 = lnew + lrx
            endif
            mnew1 = texp(lnew1)
            losp(ns) = lnew1
            mosp(ns) = mnew1
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the variables used for tracking mole numbers. If a phase
c     is totally purged from the ES, it will subsequently be necessary
c     to update the associated index arrays and reload the
c     corresponding data.
c
      do npe = 1,npet
        if (np .eq. iemop(npe)) go to 110
      enddo
      npe = 0
  110 continue
c
      if (npe .gt. 0) then
        mnew = moph(np)
        emop(npe) = mnew
        emop0(npe) = mnew
c
c       Zero the associated finite differences as they are
c       no longer valid. The derivatives (demop0) previously
c       derived from them remain valid and are not zeroed here.
c       Zeroing the finite differences here will effectively
c       drop the order for the mole number tracking of the
c       affected phase.
c
        do n = 1,nordmx
          fdpe0(n,npe) = 0.
          fdpem1(n,npe) = 0.
        enddo
c
        nr1 = ncmpe(1,npe)
        nr2 = ncmpe(2,npe)
        do nse = nr1,nr2
          ns = iemos(nse)
          mnew1 = mosp(ns)
          emos(nse) = mnew1
          emos0(nse) = mnew1
c
c         Zero the associated finite differences as they are
c         no longer valid. The derivatives (demos0) previously
c         derived from them remain valid and are not zeroed here.
c         Zeroing the finite differences here will effectively
c         drop the order for the mole number tracking of the
c         affected species.
c
          do n = 1,nordmx
            fdse0(n,nse) = 0.
            fdsem1(n,nse) = 0.
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the corresponding matrix positions. As coded here, there
c     need not be any such.
c
      kstart = 0
      kend  = -1
c
      if (iptype .eq. 1) then
c
c       Have a pure mineral.
c
        do kcol = km1,kmt
          if (ipndx1(kcol) .eq. np) then
            kstart = kcol
            go to 130
          endif
        enddo
  130   if (kstart .gt. 0) kend = kstart
      elseif (iptype .eq. 2) then
c
c       Have a solid solution.
c
        do kcol = kx1,kxt
          if (ipndx1(kcol) .eq. np) then
            kstart = kcol
            go to 150
          endif
        enddo
  150   if (kstart .gt. 0) then
          do kcol = kxt,kstart,-1
            if (ipndx1(kcol) .eq. np) then
              kend = kcol
              go to 160
            endif
          enddo
  160     continue
        endif
      elseif (iptype .eq. 3) then
c
c       Have a generic ion exchange phase.
c
        do kcol = 1,kbt
          if (ipndx1(kcol) .eq. np) then
            kstart = kcol
            go to 170
          endif
        enddo
  170   if (kstart .gt. 0) then
          do kcol = kbt,kstart,-1
            if (ipndx1(kcol) .eq. np) then
              kend = kcol
              go to 180
            endif
          enddo
  180     continue
        endif
      endif
c
      do kcol = kstart,kend
        ns = iindx1(kcol)
        lnew1 = losp(ns)
        mnew1 = mosp(ns)
        zvclg0(kcol) = lnew1
        zvclg1(kcol) = lnew1
        zvec0(kcol) = mnew1
        zvec1(kcol) = mnew1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine crrate(act,afrc1,cdac,csigma,eps100,fkrc,idirec,
     $ imchmx,imech,iodb,jreac,morr,ndac,ndact,ndctmx,nodbmx,noutpt,
     $ nrc,nrctmx,nrk,nstmax,nttyo,rk,rreac1,rrelr1,rrxfi1,rtcnst,
     $ sfcar,udac,ureac)
c
c     This subroutine calculates the rate (relative or absolute) from
c     the specified rate law for the nrc-th irreversible reaction.
c
c     This subroutine is called by:
c
c       EQ6/rtcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,ndctmx,nodbmx,nrctmx,nstmax
c
      integer noutpt,nttyo
c
      integer nrc
c
      integer idirec(nrctmx),imech(2,nrctmx),iodb(nodbmx),jreac(nrctmx),
     $ ndac(ndctmx,imchmx,2,nrctmx),ndact(imchmx,2,nrctmx),nrk(2,nrctmx)
c
      character*24 udac(ndctmx,imchmx,2,nrctmx),ureac(nrctmx)
c
      real(8) act(nstmax),afrc1(nrctmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ csigma(imchmx,2,nrctmx),fkrc(nrctmx),morr(nrctmx),
     $ rk(imchmx,2,nrctmx),rreac1(nrctmx),rrelr1(nrctmx),
     $ rrxfi1(imchmx,nrctmx),sfcar(nrctmx)
c
      real(8) eps100,rtcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j2,j3,n,ns
c
      integer ilnobl
c
      logical qovstp
c
      character(len=8) ux8
c
      real(8) affr,aprod,efx,fs,rx
c
c-----------------------------------------------------------------------
c
c     Calculate the net rate (relative or absolute) for each
c     kinetically-governed reaction. Use either a forward rate constant
c     plus affinity form or a backward rate constant plus affinity form.
c     This subroutine does not use a form involving a forward rate
c     constant plus backward rate constant.
c
      rreac1(nrc) = 0.
      rrelr1(nrc) = 0.
      do i = 1,imchmx
        rrxfi1(i,nrc) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for exhausted or saturated reactant.
c
      if (jreac(nrc) .gt. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the sign of the affinity. For minerals, the affinity
c     here is the affinity to dissolve, so:
c
c       Negative value -> precipitation
c       Positive value -> dissolution
c
c     Some reactants (special reactants, aqeuous species, and
c     gases) currently do not have actual affinities associated
c     with them. For these, the affinity is currently taken as
c     +9999999.
c
      affr = afrc1(nrc)
      qovstp = affr.lt.0. .and. nrk(2,nrc).eq.0 .and. jreac(nrc).le.0
c
      if ( iodb(2) .ge. 2 ) then
        j2 = ilnobl(ureac(nrc))
        if (affr.gt.0. .or. qovstp) then
          write (noutpt,1010) ureac(nrc)(1:j2)
 1010     format(/' --- Rate calculations for destruction of ',a,
     $    ' ---',/)
        elseif (affr .lt. 0.) then
          write (noutpt,1020) ureac(nrc)(1:j2)
 1020     format(/' --- Rate calculations for formation of ',a,
     $    ' ---',/)
        else
          write (noutpt,1030) sfcar(nrc)
 1030     format(/5x,'Surface area= ',e12.5,' cm2.',/)
        endif
      endif
c
      fs = fkrc(nrc)*sfcar(nrc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (idirec(nrc) .eq. 1) then
c
c       Calculate the net rate using the forward (dissolution) form
c       of rate law.
c
        if (nrk(1,nrc) .eq. 0) then
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1100) ureac(nrc)(1:j2)
          write (nttyo,1100) ureac(nrc)(1:j2)
 1100     format(/' * Error - (EQ6/crrate) Programming error trap:',
     $    /7x,'The forward rate law code (nrk(1,nrc)) is zero for',
     $    /7x,'reactant ',a,'.')
          stop
        elseif (nrk(1,nrc) .eq. 1) then
c
c         Specified relative rate (arbitrary kinetics).
c
          rrelr1(nrc) = rk(1,1,nrc)
          rrxfi1(1,nrc) = rrelr1(nrc)
c
        elseif (nrk(1,nrc) .eq. 2) then
c
c         Transition state theory (more properly, the TST-like form).
c         The net rate is equal to an absolute forward rate minus an
c         absolute backward rate. However, that is obvious only in the
c         equivalent two rate constant form.
c
          rreac1(nrc) = 0.
          do i = 1,imech(1,nrc)
            efx = affr/(csigma(i,1,nrc)*rtcnst)
            aprod = 1.
            do n = 1,ndact(i,1,nrc)
              ns = ndac(n,i,1,nrc)
              aprod = aprod*act(ns)**cdac(n,i,1,nrc)
            enddo
            rx = rk(i,1,nrc)*fs*aprod*(1.0 - exp(-efx))
            rreac1(nrc) = rreac1(nrc) + rx
            rrxfi1(i,nrc) = rx
          enddo
c
        elseif (nrk(1,nrc) .eq. 3) then
c
c         Specified rate (no affinity dependence).
c
          rreac1(nrc) = fs*rk(1,1,nrc)
          rrxfi1(1,nrc) = rreac1(nrc)
c
        else
c
c         Unrecognized rate law code.
c
          j2 = ilnobl(ureac(nrc))
          write (ux8,'(i5)') nrk(1,nrc)
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1110) ureac(nrc)(1:j2),ux8(1:j3)
          write (nttyo,1110) ureac(nrc)(1:j2),ux8(1:j3)
 1110     format(/' * Error - (EQ6/crrate) The reaction for the',
     $    /7x,'destruction of reactant ',a,' has an unrecognized',
     $    /7x,'forward rate law code of ',a,'.')
          stop
        endif
      else
c
c       Calculate the net rate using the backward (formation) form
c       of rate law.
c
c       Note: All rates are expressed in this code as the net of
c       forward minus backward rates, so a postive formation rate
c       is expressed as a negative number.
c
        if (nrk(2,nrc). eq. 0) then
c
c         Instantaneous equilibrium. Escape for case of a
c         supersaturated reactant that is not in the matrix.
c
        elseif (nrk(2,nrc) .eq. 1) then
c
c         Specified relative rate (aribitrary kinetics).
c
          rrelr1(nrc) = -rk(1,2,nrc)
          rrxfi1(1,nrc) = rrelr1(nrc)
c
        elseif (nrk(2,nrc) .eq. 2) then
c
c         Transition state theory (more properly, the TST-like form).
c
          rreac1(nrc) = 0.
          do i = 1,imech(2,nrc)
c
c           Note: if affr < 0, then efx < 0, affac < 0, and rreac1 < 0.
c
            efx = affr/(csigma(i,2,nrc)*rtcnst)
            aprod = 1.
            do n = 1,ndact(i,2,nrc)
              ns = ndac(n,i,2,nrc)
              aprod = aprod*act(ns)**cdac(n,i,2,nrc)
            enddo
            rx = rk(i,2,nrc)*fs*aprod*(1.0 - exp(-efx))
            rreac1(nrc) = rreac1(nrc) + rx
            rrxfi1(i,nrc) = rx
          enddo
c
        elseif (nrk(2,nrc) .eq. 3) then
c
c         Linear rate law.
c
          rreac1(nrc) = -fs*rk(1,2,nrc)
          rrxfi1(1,nrc) = rreac1(nrc)
c
        else
c
          j2 = ilnobl(ureac(nrc))
          write (ux8,'(i5)') nrk(2,nrc)
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,250) ureac(nrc)(1:j2),ux8(1:j3)
          write (nttyo,250) ureac(nrc)(1:j2),ux8(1:j3)
  250     format(/' * Error - (EQ6/crrate) The reaction for the',
     $    /7x,'destruction of reactant ',a,' has an unrecognized',
     $    /7x,'backward rate law code of ',a,'.')
          stop
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine nxspck(iktmax,issot,nerr,noutpt,nttyo,nxt,nxtmax,
     $ ussoph,ussosp)
c
c     Check the names of solid solution end-members for uniqueness
c     within each solid solution.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ussoph = array containing the names of solid solutions
c       ussosp = array containing the names of solid solution
c                  end-members
c
c     Principal output:
c
c       nerr   = incremented error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer iktmax,nxtmax
c
      integer nxt,nerr
c
      integer issot(nxtmax)
c
      character(len=24) ussoph(nxtmax)
      character(len=24) ussosp(iktmax,nxtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 unam
      character*8 ux8
c
      integer i,ikt,ilist,j,j2,j3,j4,k,nx,ncount
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Loop over all solid solution phases.
c
      do nx = 1,nxt
c
        ikt = issot(nx)
c
c       Note: ilist = the number of end-members that are duplicated
c       for a given solid solution.
c
        ilist = 0
c
c       Check each name for uniqueness.
c
        do i = 1,ikt
          unam = ussosp(i,nx)
          ncount = 1
          if (unam(1:7) .ne. '<blank>') then
            do j = i + 1,ikt
              if (unam(1:24) .eq. ussosp(j,nx)(1:24)) then
c
c               Have found a duplicate entry moving down the list from
c               the entry now being tested for uniqueness. For the first
c               such duplicate entry only, make sure that there is not a
c               duplicate entry moving up the list from the entry now
c               being tested. If there is such a entry, then the
c               duplication in question has been noted previously and
c               should not be noted again.
c
                if (ncount .eq. 1) then
                  do k = 1,i - 1
                    if (unam(1:24) .eq. ussosp(k,nx)(1:24)) then
c
c                     Have found a duplicate entry preceding the entry
c                     now being tested for uniqueness.
c
                      go to 100
                    endif
                  enddo
                endif
c
c               Have found a duplication that has not been previously
c               noted.
c
                ncount = ncount + 1
              endif
            enddo
  100       continue
          endif
c
          if (ncount .gt. 1) then
c
c           Have a duplicate entry or entries.
c
            ilist = ilist + 1
c
            if (ilist .eq. 1) then
c
c             Write error message header.
c
              j2 = ilnobl(ussoph(nx))
              write (noutpt,1000) ussoph(nx)(1:j2)
              write (nttyo,1000) ussoph(nx)(1:j2)
 1000         format(/' * Error - (EQPT/nxspck) The following',
     $        ' end-members are listed more than',/7x,'once for solid',
     $        ' solution ',a,':',/)
            endif
c
            write (ux8,'(i5)') ncount
            call lejust(ux8)
            j4 = ilnobl(ux8)
            j3 = ilnobl(unam)
            write (noutpt,1010) unam(1:j3),ux8(1:j4)
            write (nttyo,1010) unam(1:j3),ux8(1:j4)
 1010       format(9x,a,' has ',a,' entries')
          endif
        enddo
c
        nerr = nerr + ilist
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine ssortw(asort,aval,jsort,nmax,noutpt,nttyo,nval)
c
c     This subroutine sorts the first "nval" elements of the array
c     "aval," using the shell sort method as taken from the "Numerical
c     Recipes" book.
c
c     The sorted elements of "aval" are placed in the array "asort,"
c     and the corresponding indices are placed in the array "jsort."
c
c     If jsort(1) is 0, the sort starts from scratch. Otherwise,
c     the "jsort" array is presumed to contain a prior result which
c     should be a good starting point for the present sorting.
c     All the arrays are dimensioned 1:nmax.
c
c     EQLIBU/qsortw.f is a possible alternative to this subroutine. It
c     uses the "quicksort" method.
c
c     Caution: to be safe, set the first element of the actual array
c     referenced here as jsort to 0 before calling this routine. If
c     this is not done, be sure that nothing has changed the actual
c     array since the previous call for this array. In particular,
c     the length of the array (here represented as nmax should be the
c     same. If it has changed, there is a very good possibility that
c     one or more of the elements of this array are invalid. The present
c     subroutine does only minimal validity checking. Note that with
c     regard to previous calls, include calls to either qsortw.f or
c     ssortw.f, as they are interchangeable in function. Note that
c     even if only one of these subroutines is employed, it is generally
c     used to sort various arrays. Thus, it is not a useful check to
c     save the previous value of nmax for comparison.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       aval   = array of values to be sorted
c       nmax   = dimension of the asort, aval, istack, jsort, and
c                jstack arrays
c       nval   = the number of elements in the aval array to be sorted,
c                beginning with the first element
c
c     Output:
c
c       asort  = array of sorted values, corresponding to the range
c                composed of the first nval elements fo the aval array
c       jsort  = array of sorted indices, corresponding to the values
c                in the asort array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      integer noutpt,nttyo
c
      integer jsort(nmax)
      integer nval
c
      real*8 asort(nmax),aval(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,ileft,ilognp,j,jj,jpt,j2,j3,k,nn,n1
c
      integer ilnobl,jiarmn,jiarmx
c
      logical qx
c
      character*8 ux8,ux8a
c
      real*8 aln2i
c
c-----------------------------------------------------------------------
c
      parameter (aln2i = 1.0/0.63147185)
c
c-----------------------------------------------------------------------
c
      if (jsort(1) .ne. 0) then
c
c       Perform minimal checking of the incoming jsort array.
c
        qx = .false.
        i = jiarmn(jsort,nval)
        if (i .ne. 1) then
          write (ux8,'(i5)') i
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1000) ux8(1:j2)
          write (nttyo,1000) ux8(1:j2)
 1000     format(/' * Warning - (EQLIBU/ssortw) Programming error',
     $    ' trap: The minimum',/7x,'element of the incoming jsort',
     $    ' array is ',a,', not 1 as is required.',/7x,'Will ignore',
     $    ' this jsort array and create a new one from scratch.')
          qx = .true.
        endif
c
        i = jiarmx(jsort,nval)
        if (i .ne. nval) then
          write (ux8,'(i5)') i
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (ux8a,'(i5)') nval
          call lejust(ux8a)
          j3 = ilnobl(ux8a)
          write (noutpt,1010) ux8(1:j2),ux8a(1:j3)
          write (nttyo,1010) ux8(1:j2),ux8a(1:j3)
 1010     format(/' * Warning - (EQLIBU/ssortw) Programming error',
     $    ' trap: The maximum',/7x,'element of the incoming jsort',
     $    ' array is ',a,', not nval (',a,'),',/7x,'as is required.',
     $    ' Will ignore this jsort array and create a new one',
     $    /7x,'from scratch.')
          qx = .true.
        endif
c
        if (qx) jsort(1) = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      ileft = (nval/8)*8
      if (jsort(1) .eq. 0) then
c
c       Start from scratch. Note that the loop is unrolled.
c
        do jpt = 1,ileft,8
          jsort(jpt) = jpt
          asort(jpt) = aval(jpt)
          jsort(jpt + 1) = jpt + 1
          asort(jpt + 1) = aval(jpt + 1)
          jsort(jpt + 2) = jpt + 2
          asort(jpt + 2) = aval(jpt + 2)
          jsort(jpt + 3) = jpt + 3
          asort(jpt + 3) = aval(jpt + 3)
          jsort(jpt + 4) = jpt + 4
          asort(jpt + 4) = aval(jpt + 4)
          jsort(jpt + 5) = jpt + 5
          asort(jpt + 5) = aval(jpt + 5)
          jsort(jpt + 6) = jpt + 6
          asort(jpt + 6) = aval(jpt + 6)
          jsort(jpt + 7) = jpt + 7
          asort(jpt + 7) = aval(jpt + 7)
        enddo
c
        do jpt = ileft + 1,nval
          jsort(jpt) = jpt
          asort(jpt) = aval(jpt)
        enddo
c
      else
c
c       Use the pre-existing jsort array as a starting point.
c       Note that the loop is unrolled.
c
        do jpt = 1,ileft,8
          asort(jpt) = aval(jsort(jpt))
          asort(jpt + 1) = aval(jsort(jpt + 1))
          asort(jpt + 2) = aval(jsort(jpt + 2))
          asort(jpt + 3) = aval(jsort(jpt + 3))
          asort(jpt + 4) = aval(jsort(jpt + 4))
          asort(jpt + 5) = aval(jsort(jpt + 5))
          asort(jpt + 6) = aval(jsort(jpt + 6))
          asort(jpt + 7) = aval(jsort(jpt + 7))
        enddo
c
        do jpt = ileft + 1,nval
          asort(jpt) = aval(jsort(jpt))
        enddo
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nn = nval
      ilognp = int(log(real(nval))*aln2i + 1.e-5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do n1 = 1,ilognp
        nn = nn/2
        k = nval - nn
        do j = 1,k
          i = j
c
c         The label below is the return point for a loop which
c         is run through until no out-of-order elements are found.
c
  120     continue
          jj = i + nn
          if (aval(jsort(jj)) .lt. aval(jsort(i))) then
c
c           Have found an out of order element. Exchange elements.
c
            ii = jsort(i)
            jsort(i) = jsort(jj)
            jsort(jj) = ii
            i = i - nn
            if (i .eq. 1) go to 120
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Load the asort array. Note that the loop is unrolled.
c
      do jpt = 1,ileft,8
        asort(jpt) = aval(jsort(jpt))
        asort(jpt + 1) = aval(jsort(jpt + 1))
        asort(jpt + 2) = aval(jsort(jpt + 2))
        asort(jpt + 3) = aval(jsort(jpt + 3))
        asort(jpt + 4) = aval(jsort(jpt + 4))
        asort(jpt + 5) = aval(jsort(jpt + 5))
        asort(jpt + 6) = aval(jsort(jpt + 6))
        asort(jpt + 7) = aval(jsort(jpt + 7))
      enddo
c
      do jpt = ileft + 1,nval
        asort(jpt) = aval(jsort(jpt))
      enddo
c
      end

      subroutine gakey(ndat0s,noutpt,nttyo,uakey)
c
c     This suboutine scans the DATA0 file to determine the aqueous
c     species activity coefficient model (e.g., Pitzer, Simple
c     Extended Debye-Huckel) associated with this file.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       uakey  = the type of data file ("SEDH" or "Pitzer")
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndat0s,noutpt,nttyo
c
      character(len=8) uakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,icount,n
c
      character(len=80) uline
c
c-----------------------------------------------------------------------
c
c     Determine whether or not this is a Pitzer-type data file.
c     Look for patterns indicating the presence of Pitzer interaction
c     coefficients.
c
      icount = 0
      do n = 1,500
        read (ndat0s,1000,end=100,err=995) uline
 1000   format(a)
        i = index(uline,'beta0 =')
        icount = icount + i
        i = index(uline,'beta1 =')
        icount = icount + i
        i = index(uline,'beta2 =')
        icount = icount + i
        i = index(uline,'cphi =')
        icount = icount + i
        i = index(uline,'Beta0 =')
        icount = icount + i
        i = index(uline,'Beta1 =')
        icount = icount + i
        i = index(uline,'Beta2 =')
        icount = icount + i
        i = index(uline,'Cphi =')
        icount = icount + i
        i = index(uline,'beta(0)')
        icount = icount + i
        i = index(uline,'beta(1)')
        icount = icount + i
        i = index(uline,'beta(2)')
        icount = icount + i
        i = index(uline,'Cphi')
        icount = icount + i
        i = index(uline,'C(phi)')
        icount = icount + i
        if (icount .ge. 24) go to 100
      enddo
  100 continue
c
      if (icount .ge. 8) then
        uakey = 'Pitzer'
      else
        uakey = 'SEDH'
      endif
c
      rewind(ndat0s)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a message for any read error other than end-of-file.
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/gakey) Encountered a read format',
     $ ' error while',/7x,'scanning the DATA0 file to determine',
     $ ' the associated aqueous',/7x,'activity coefficient model.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gelam(aphi,delam,dpelm,elam,fxi,izmax,nazpmx,
     $ pelm,qpit75)
c
c     This subroutine calculates the E-lambda function (elam(i,j)) and
c     its first two ionic strength derivatives (delam(1,i,j) and
c     delam(2,i,j)). Here i, j refers to the charge pair zi, zj or
c     -zi, -zj, where zi and zj are both positive. The E-lambda
c     function and its derivatives are used in Pitzer's equations
c     to represent higher-order electrical interactions. Here izmax
c     is the max norm of the electrical charges of the aqueous species
c     and aphi is the Debye-Huckel A(phi) parameter. The array
c     pelm(i,j) contains a set of "primitive" E-lambda functions
c     corresponding to those in elam(i,j). The arrays dpelm(1,i,j)
c     and dpelm(2,i,j) similarly parallel delam(1,i,j) and delam(2,i,j).
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       aphi   = the Debye-Huckel A(phi) parameter
c       izmax  = the max norm of the electrical charge numbers of
c                  the aqueous species
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c
c     Principal output:
c
c       elam   = array of values of the E-lambda functions
c       delam  = array of values of the ionic strength derivatives
c                  of the E-lambda functions
c
c     Work space:
c
c       pelm   = array of values of primitive E-lambda functions
c       dpelm  = array of values of the ionic strength derivatives
c                  of the primitive E-lambda functions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nazpmx
c
      integer izmax
c
      logical qpit75
c
      real*8 delam(2,nazpmx,nazpmx),dpelm(2,nazpmx,nazpmx),
     $ elam(nazpmx,nazpmx),pelm(nazpmx,nazpmx)
      real*8 aphi,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ijz,iz,jz
c
      real*8 el,elp,elpp,wi,wj
c
c-----------------------------------------------------------------------
c
c     First calculate "primitive" E-lambdas (pelm) and their
c     derivatives (dpelm) for the various charge pairs. These depend
c     only on the product of the electrical charges.
c
      do jz = 1,izmax
        do iz = jz,izmax
          ijz = iz*jz
c
c         Get the primitive E-lambda and its derivatives for
c         this current charge pair.
c
          call elmdd(aphi,el,elp,elpp,fxi,ijz,qpit75)
          pelm(iz,jz) = el
          dpelm(1,iz,jz) = elp
          dpelm(2,iz,jz) = elpp
          if (jz .ne. iz) then
            pelm(jz,iz) = el
            dpelm(1,jz,iz) = elp
            dpelm(2,jz,iz) = elpp
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now calculate conventional E-lambdas (elam) and their derivatives
c     (delam) for the various charge pairs.
c
      do jz = 1,izmax
        do iz = 1,izmax
          wj = 0.5*iz/jz
          wi = 0.5*jz/iz
          elam(iz,jz) = pelm(iz,jz) - wj*pelm(jz,jz) - wi*pelm(iz,iz)
          delam(1,iz,jz) = dpelm(1,iz,jz) - wj*dpelm(1,jz,jz)
     $    - wi*dpelm(1,iz,iz)
          delam(2,iz,jz) = dpelm(2,iz,jz) - wj*dpelm(2,jz,jz)
     $    - wi*dpelm(2,iz,iz)
        enddo
      enddo
c
c     Set the diagonal elements to zero.
c
      do i = 1,izmax
        elam(i,i) = 0.
        delam(1,i,i) = 0.
        delam(2,i,i) = 0.
      enddo
c
      end

      subroutine wrpar(aamatr,adh,adhh,adhv,aphi,apr,avgrid,bdh,bdhh,
     $ bdhv,bdot,bdoth,bdotv,cco2,cof,dadhh,dadhv,dbdhh,dbdhv,dbdth,
     $ dbdtv,dhfe,dvfe,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,ipivot,
     $ narxmx,narxt,ndata1,ndat1f,noutpt,ntprmx,ntprt,nttyo,presg,
     $ prehw,tdamax,tdamin,tempc,tempcs,tmpcmx,uakey,xhfe,xlke,xvfe,
     $ xvec,yvec)
c
c     This subroutine takes the data read from the DATA0 file by the
c     EQPT/rdpar.f, processes it by converting data on a temperature
c     grid to the equivalent set of coefficients of interpolating
c     polynomials, and writes this data on the DATA1 and DATA1F files.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = array of A(gamma,10) values on the standard temperature
c                  grid
c       aphi   = array of A(phi) values on the standard temperature grid
c       bdh    = array of B(gamma) values on the standard temperature
c                  grid
c       bdot   = array of B-dot values on the standard temperature
c                  grid
c       cco2   = array of coefficients for the Drummond (1981)
c                  equation
c       ndata1 = unit number of the DATA1 file
c       ndat1f = unit number of the DATA1F file
c       presg  = array of pressures on the standard temperature grid
c       tempc  = array of temperatures defining the standard
c                  temperature grid
c       uakey  = string specifying the type of data file ("SEDH" or
c                  "Pitzer") being processed
c       xlke   = array of log K values for the special "Eh" reaction
c                  on the standard temperature grid
c
c     Principal output:
c
c       apr    = array of polynomial coefficients (combined, for all
c                  temperature ranges)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,ntprmx
c
      integer ipivot(narxmx),narxt(ntprmx)
c
      integer ndata1,ndat1f,noutpt,nttyo
c
      integer ipch,ipcv,ntprt
c
      character(len=8) uakey
c
      real(8) tdamax,tdamin
      real(8) cco2(5)
c
      real(8) adh(narxmx,ntprmx),adhh(narxmx,ntprmx),
     $ adhv(narxmx,ntprmx),aphi(narxmx,ntprmx),bdh(narxmx,ntprmx),
     $ bdhh(narxmx,ntprmx),bdhv(narxmx,ntprmx),bdot(narxmx,ntprmx),
     $ bdoth(narxmx,ntprmx),bdotv(narxmx,ntprmx),
     $ dadhh(narxmx,ntprmx,ipchmx),dadhv(narxmx,ntprmx,ipcvmx),
     $ dbdhh(narxmx,ntprmx,ipchmx),dbdhv(narxmx,ntprmx,ipcvmx),
     $ dbdth(narxmx,ntprmx,ipchmx),dbdtv(narxmx,ntprmx,ipcvmx),
     $ dhfe(narxmx,ntprmx,ipchmx),dvfe(narxmx,ntprmx,ipcvmx),
     $ prehw(narxmx,ntprmx),presg(narxmx,ntprmx),xhfe(narxmx,ntprmx),
     $ xlke(narxmx,ntprmx),xvfe(narxmx,ntprmx)
c
      real(8) apr(narxmx,ntprmx),avgrid(narxmx,ntprmx)
      real(8) tempc(narxmx,ntprmx),tempcs(narxmx,ntprmx),tmpcmx(ntprmx)
      real(8) aamatr(narxmx,narxmx),gmmatr(narxmx,narxmx)
      real(8) cof(narxmx),xvec(narxmx),yvec(narxmx)
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j2,j3,n,nt,ntpr
c
      integer ilnobl
c
      character(len=10) ux10
      character(len=72) uterm,utermc
      character(len=56) ux56
      character(len=24) ux24,ux24a,ux24b
c
      real(8) adtxmn,adtx11,p01_8,txmn,tx11
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the temperature limits on the output files.
c
      ux56 = 'Data file maximum and minimum temperatures (C)'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1100) ux56(1:j2)
 1100 format(a)
      write (ndata1) tdamin,tdamax
      write (ndat1f,1110) tdamin,tdamax
 1110 format(2f10.3)
c
      write (noutpt,1120) tdamin
      write (nttyo,1120) tdamin
 1120 format(//' The minimum temperature is ',f10.3,'C')
      write (noutpt,1130) tdamax
      write (nttyo,1130) tdamax
 1130 format(' The maximum temperature is ',f10.3,'C')
c
      ux56 = 'Maximum temperature (C) by range'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1140) ux56(1:j2)
 1140 format(a)
      do ntpr = 1,ntprt
        n = narxt(ntpr)
        write (ndata1) tempc(n,ntpr)
        write (ndat1f,1150) tempc(n,ntpr)
 1150   format(f10.3)
      enddo
c
      write (ndat1f,1010) utermc(1:72)
c
      write (noutpt,1160)
      write (nttyo,1160)
 1160 format(/' The maximum temperatures (C) by range are:')
      do ntpr = 1,ntprt
        n = narxt(ntpr)
        write (noutpt,1170) tempc(n,ntpr)
        write (nttyo,1170) tempc(n,ntpr)
 1170   format(3x,f10.3)
      enddo
c
      write (noutpt,1000)
 1000 format(/)
c
c
      tx11 = tempc(1,1)
      txmn = tdamin
c
c     Note: on some data files, 0.01C is used as an approximation
c     to 0C in order to avoid some equation-of-state difficulties.
c     In such cases, consider 0.01C to be the same as 0C for the
c     purpose of the following test.
c
      ux10 = '0.01      '
      read (ux10,'(f10.3)') p01_8
      adtx11 = abs(tx11 - p01_8)
      adtxmn = abs(txmn - p01_8)
      if (adtx11 .le. 1.e-6) tx11 = 0.
      if (adtxmn .le. 1.e-6) txmn = 0.
c
      if ((tx11 - tdamin) .gt. 0.001) then
        write (ux24a,"(f10.3)") tdamin
        call lejust(ux24a)
        j2 = ilnobl(ux24a)
        write (ux24b,"(f10.3)") tempc(1,1)
        call lejust(ux24b)
        j3 = ilnobl(ux24b)
        write (noutpt,1200) ux24a(1:j2),ux24b(1:j3)
        write (nttyo,1200) ux24a(1:j2),ux24b(1:j3)
 1200   format(/' * Warning - (EQPT/rdpar) The minimum temperature for',
     $  ' this data file',/7x,'is less than the lowest temperature in',
     $  ' the first temperature',/7x,'range. If EQ3NR and EQ6 are',
     $  ' required to make any calculations',/7x,'between ',a,'C',
     $  ' and ',a,'C, they will do so by extrapolating',/7x,'the',
     $  ' data from the first range.')
      endif
c
      n = narxt(ntprt)
      if ((tdamax - tempc(n,ntprt)) .gt. 0.001) then
        write (ux24a,"(f10.3)") tempc(n,ntprt)
        call lejust(ux24a)
        j2 = ilnobl(ux24a)
        write (ux24b,"(f10.3)") tdamax
        call lejust(ux24b)
        j3 = ilnobl(ux24b)
        write (noutpt,1210) ux24a(1:j2),ux24b(1:j3)
        write (nttyo,1210) ux24a(1:j2),ux24b(1:j3)
 1210   format(/' * Warning - (EQPT/rdpar) The maximum temperature for',
     $  ' this data file',/7x,'is greater than the highest temperature',
     $  ' in the last temperature',/7x,'range. If EQ3NR and EQ6 are',
     $  ' required to make any calculations',/7x,'between ',a,'C',
     $  ' and ',a,'C, they will do so by extrapolating',/7x,'the',
     $  ' data from the last range.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process and write the data for the standard pressure grid.
c
c     Calling sequence substitutions:
c       presg for avgrid
c
      call intrp(aamatr,apr,presg,cof,eps100,gmmatr,ipivot,
     $ narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $ xvec,yvec)
c
      ux24 = 'presg'
      j2 = ilnobl(ux24)
      write (ndata1) ux24
      write (ndat1f,1010) ux24(1:j2)
 1010 format(a)
      write (noutpt,1020) ux24(1:j2)
 1020 format(7x,a)
c
      do ntpr = 1,ntprt
        nt = narxt(ntpr)
        write (ndata1) (apr(i,ntpr), i = 1,nt)
        write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
 1030   format( 5(1pe16.9) )
      enddo
c
      write (ndat1f,1010) utermc(1:72)
c
      if (ipcv .ge. 0) then
c
c       Process and write the data for the half-width of the standard
c       pressure envelope.
c
c       Calling sequence substitutions:
c         prehw for avgrid
c
        call intrp(aamatr,apr,prehw,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'prehw'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process and write the next parameters only if processing a
c     "SEDH" type data file.
c
      if (uakey(1:8) .eq. 'SEDH    ') then
c
c       Process and write the A(gamma,10) data.
c
c       Calling sequence substitutions:
c         adh for avgrid
c
        call intrp(aamatr,apr,adh,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'adh'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
        if (ipch .ge. 0) then
c
c         Process and write the A(H) data.
c
c         Calling sequence substitutions:
c           adhh for avgrid
c
          call intrp(aamatr,apr,adhh,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'adhh'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnA(H)/dPn data.
c
          do ipc = 1,ipch
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dadhh(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dadhh( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Process and write the A(V) data.
c
c         Calling sequence substitutions:
c           adhv for avgrid
c
          call intrp(aamatr,apr,adhv,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'adhv'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnA(V)/dPn data.
c
          do ipc = 1,ipcv
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dadhv(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dadhv( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
c       Process and write the B(gamma) data.
c
c       Calling sequence substitutions:
c         bdh for avgrid
c
        call intrp(aamatr,apr,bdh,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'bdh'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
        if (ipch .ge. 0) then
c
c         Process and write the B(H) data.
c
c         Calling sequence substitutions:
c           bdhh for avgrid
c
          call intrp(aamatr,apr,bdhh,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'bdhh'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnB(H)/dPn data.
c
          do ipc = 1,ipch
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dbdhh(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dbdhh( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Process and write the B(V) data.
c
c         Calling sequence substitutions:
c           bdhv for avgrid
c
          call intrp(aamatr,apr,bdhv,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'bdhv'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnB(V)/dPn data.
c
          do ipc = 1,ipcv
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dbdhv(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dbdhv( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
c       Process and write the B-dot data.
c       interpolate and write the polynomial coefficients for bdot
c
c       Calling sequence substitutions:
c         bdot for avgrid
c
        call intrp(aamatr,apr,bdot,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'bdot'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
        if (ipch .ge. 0) then
c
c         Process and write the B-dot(H) data.
c
c         Calling sequence substitutions:
c           bdoth for avgrid
c
          call intrp(aamatr,apr,bdoth,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'bdoth'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnB-dot(H)/dPn data.
c
          do ipc = 1,ipch
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dbdth(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dbdth( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Process and write the B-dot(V) data.
c
c         Calling sequence substitutions:
c           bdotv for avgrid
c
          call intrp(aamatr,apr,bdotv,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'bdotv'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnB-dot(V)/dPn data.
c
          do ipc = 1,ipcv
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dbdtv(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dbdtv( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
c       Write the CCO2 coefficients.
c
        ux24 = 'cco2'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        write (ndata1) (cco2(i), i = 1,5)
        write (ndat1f,1030) (cco2(i), i = 1,5)
        write (ndat1f,1010) utermc(1:72)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process and write the next parameter only if processing a
c     "Pitzer" type data file.
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Process and write the A(phi) data.
c
c       Calling sequence substitutions:
c         aphi for avgrid
c
        call intrp(aamatr,apr,aphi,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'aphi'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
        if (ipch .ge. 0) then
c
c         Process and write the A(H) data.
c
c         Calling sequence substitutions:
c           adhh for avgrid
c
          call intrp(aamatr,apr,adhh,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'adhh'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnA(H)/dPn data.
c
          do ipc = 1,ipch
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dadhh(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dadhh( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Process and write the A(V) data.
c
c         Calling sequence substitutions:
c           adhv for avgrid
c
          call intrp(aamatr,apr,adhv,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'adhv'
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
c
c         Process and write the dnA(V)/dPn data.
c
          do ipc = 1,ipcv
c
            do ntpr = 1,ntprt
              do n = 1,narxt(ntpr)
                avgrid(n,ntpr) = dadhv(n,ntpr,ipc)
              enddo
            enddo
c
            call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $      narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $      xvec,yvec)
c
            ux24 = 'dadhv( )'
            write (ux24(7:7),'(i1)') ipc
            j2 = ilnobl(ux24)
            write (ndata1) ux24
            write (ndat1f,1010) ux24(1:j2)
            write (noutpt,1020) ux24(1:j2)
c
            do ntpr = 1,ntprt
              nt = narxt(ntpr)
              write (ndata1) (apr(i,ntpr), i = 1,nt)
              write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
            enddo
c
            write (ndat1f,1010) utermc(1:72)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process and write the thermodynamic data for the "Eh" reaction.
c
c     Begin with the log K data.
c
c     Calling sequence substitutions:
c       xlke for avgrid
c
      call intrp(aamatr,apr,xlke,cof,eps100,gmmatr,ipivot,
     $ narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $ xvec,yvec)
c
      ux24 = 'xlke'
      j2 = ilnobl(ux24)
      write (ndata1) ux24
      write (ndat1f,1010) ux24(1:j2)
      write (noutpt,1020) ux24(1:j2)
c
      do ntpr = 1,ntprt
        nt = narxt(ntpr)
        write (ndata1) (apr(i,ntpr), i = 1,nt)
        write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
      enddo
c
      write (ndat1f,1010) utermc(1:72)
c
      if (ipch .ge. 0) then
c
c       Process and write the enthalpy of reaction data.
c
c       Calling sequence substitutions:
c         xhfe for avgrid
c
        call intrp(aamatr,apr,xhfe,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'xhfe'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
c       Process and write the pressure derivatives of the enthalpy
c       of reaction.
c
        do ipc = 1,ipch
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dhfe(n,ntpr,ipc)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dhfe( )'
          write (ux24(7:7),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Process and write the volume of reaction data.
c
c       Calling sequence substitutions:
c         xvfe for avgrid
c
        call intrp(aamatr,apr,xvfe,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'xvfe'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
        write (noutpt,1020) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
        enddo
c
        write (ndat1f,1010) utermc(1:72)
c
c       Process and write the pressure derivatives of the volume
c       of reaction.
c
        do ipc = 1,ipcv
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dvfe(n,ntpr,ipc)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dvfe( )'
          write (ux24(7:7),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
          write (noutpt,1020) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1030) (apr(i,ntpr), i = 1,nt)
          enddo
c
          write (ndat1f,1010) utermc(1:72)
        enddo
      endif
c
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine bsplkp(axlks,narxmx,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,nstmax,ntprmx)
c
c     This subroutine looks at each active auxiliary basis species.
c     It changes the corresponding log K polynomial coefficients so
c     that log K is fixed at a value of -9999999. if any other species
c     in the corresponding dissociation reaction is not in the model.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nbasp  = array of indices of species in the active basis set
c
c     Principal output:
c
c       axlks  = array of coefficients for computing equilbrium
c                  constants as a function of temperature
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer nbasp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax)
      integer nbt
c
      real*8 axlks(narxmx,ntprmx,nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,n,nb,ns,nr1,nr2,nt1,nse
c
c-----------------------------------------------------------------------
c
      do nb = 1,nbt
        ns = nbasp(nb)
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        nt1 = nr2 - nr1 + 1
        if (nt1 .ge. 2) then
          do n = nr1,nr2
            nse = ndrs(n)
            if (nse .eq. 0) then
              do j = 1,ntprmx
                do i = 2,narxmx
                  axlks(i,j,ns) = 0.
                enddo
                axlks(1,j,ns) = -9999999.
              enddo
              go to 130
            endif
          enddo
        endif
  130   continue
      enddo
c
      end

      subroutine gspion(narn1,narn2,nchlor,nelect,nhydr,nhydx,noutpt,
     $ no2gaq,nstmax,nttyo,uspec)
c
c     This subroutine finds the species indices of H+, OH-, Cl-,
c     aqueous O2(g), and aqueous e-.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c      Principal input:
c
c        narn1  = start of the range of aqueous species; also the
c                   species index of solvent water
c        narn2  = end of the range of aqueous species
c        uspec  = array of species names
c
c      Principal output:
c
c        nchlor = species index of the Cl- ion
c        nhydr  = species index of the H+ ion
c        nhydx  = species index of the OH- ion
c        no2gaq = species index of the fictive species, aqueous O2(g)
c        nelect = species index of the fictive species, aqueous e-
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer noutpt,nttyo
c
      integer narn1,narn2,nchlor,nelect,nhydr,nhydx,no2gaq
c
      character(len=48) uspec(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nerr,ns
c
      integer ilnobl
c
      character(len=8) uhydr,uhydx,uchlor,uo2gaq,uelect
c
c-----------------------------------------------------------------------
c
      data uhydr  /'H+      '/,uhydx  /'OH-     '/,
     $     uchlor /'Cl-     '/,uo2gaq /'O2(g)   '/,
     $     uelect /'e-      '/
c
c-----------------------------------------------------------------------
c
      nhydr = 0
      nchlor = 0
      nhydx = 0
      no2gaq = 0
      nelect = 0
      nerr = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find H+.
c
      do ns = narn1,narn2
        if (uspec(ns)(1:8) .eq. uhydr(1:8)) then
          nhydr = ns
          go to 100
        endif
      enddo
      j2 = ilnobl(uhydr)
      write (noutpt,1000) uhydr(1:j2)
      write (nttyo,1000) uhydr(1:j2)
 1000 format(/' * Error - (EQLIB/gspion) The species ',a," isn't",
     $ ' present in the model',/7x,'system, as is required. Check to',
     $ ' see that this species is not missing',/7x,'from the',
     $ ' supporting data file. If it is there, and the present input',
     $ /7x,'file is an EQ6 input file, check to see that this file',
     $ ' was created',/7x,'by a previous EQ3NR or EQ6 run using the',
     $ ' same data file.',/7x,'Otherwise,the input file may have been',
     $ ' corrupted.')
      nerr = nerr + 1
c
  100 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find OH-.
c
      do ns = narn1,narn2
        if (uspec(ns)(1:8) .eq. uhydx(1:8)) then
          nhydx = ns
          go to 110
        endif
      enddo
      j2 = ilnobl(uhydx)
      write (noutpt,1000) uhydx(1:j2)
      write (nttyo,1000) uhydx(1:j2)
      nerr = nerr + 1
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find Cl-.
c
      do ns = narn1,narn2
        if (uspec(ns)(1:8) .eq. uchlor(1:8)) then
          nchlor = ns
          go to 120
        endif
      enddo
      j2 = ilnobl(uchlor)
      write (noutpt,1000) uchlor(1:j2)
      write (nttyo,1000) uchlor(1:j2)
      nerr = nerr + 1
c
  120 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the fictive, aqueous O2(g).
c
      do ns = narn1,narn2
        if (uspec(ns)(1:5) .eq. uo2gaq(1:5)) then
          no2gaq = ns
          go to 130
        endif
      enddo
      j2 = ilnobl(uo2gaq)
      write (noutpt,1000) uo2gaq(1:j2)
      write (nttyo,1000) uo2gaq(1:j2)
      write (noutpt,1010)
      write (nttyo,1010)
 1010 format(/7x,'Note- The species O2(g) (the fictive aqueous',
     $ ' species, not',/7x,'the real gas species) is required to be',
     $ ' present even if a problem',/7x,'has no redox aspect. The',
     $ ' species is then inactive.')
      nerr = nerr + 1
c
  130 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the fictive, aqueous e-.
c
      do ns = narn1,narn2
        if (uspec(ns)(1:2) .eq. uelect(1:2)) then
          nelect = ns
          go to 140
        endif
      enddo
c
c     Note: it is currently not an error for this species to not be
c     present. In future development, it may serve as an alternative
c     to the fictive, aqueous O2(g).
c
  140 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
      end

      subroutine rddixc(nxcon,uoldvd,unewf,unewv)
c
c     This subroutine reads user input from the IXCON control file used
c     by XCON3 and XCON6. The IXCON file should look as follows:
c
c     1 (Column 1) (This line is not part of the IXCON file.)
c     IXCON
c
c       This file contains the user-controlled options for
c       the EQ3/6 input file converters XCON3 and XCON6.
c       The code will scan the old input file to determine
c       its format. It will also try to determine its
c       version level. If it can't do so, the version level
c       must be set using the default in this control file.
c
c     OLD INPUT FILE VERSION LEVEL (DEFAULT ONLY)
c      | | 6.0 (versions 6.0-6.1)
c      |X| 7.0 (versions 7.0-7.1)
c      | | 7.2 (version 7.2)
c      | | 8.0 (version 8.0)
c     NEW INPUT FILE FORMAT
c      | | W   (compact)
c      |X| D   (menu-style)
c     NEW INPUT FILE VERSION LEVEL
c      | | 6.0 (versions 6.0-6.1)
c      | | 7.0 (versions 7.0-7.1)
c      |X| 7.2 (version 7.2)
c      | | 8.0 (version 8.0)
c     END
c     1 (Column 1) (This line is not part of the IXCON file.)
c
c
c     Note that the '|' characters defining the checkboxes must be
c     in columns 2 and 4. Select a choice with a non-blank character.
c     The first choice will be selected. Secondary choices will be
c     ignored.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nxcon  = the unit number of the IXCON file
c
c     Output:
c
c       uoldvd = the default version level of the old input file
c       unewf  = the desired format ("W" or "D") of the new input file
c       unewvd = the desired version level of the new input file
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nxcon
c
      character*3 uoldvd,unewv
      character*1 unewf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,j
c
      character*80 uline
c
c-----------------------------------------------------------------------
c
      rewind(nxcon)
      do i = 1,1000
        read (nxcon,1000,end=999) uline
 1000   format(a80)
        j = index(uline,'OLD INPUT FILE VERSION LEVEL')
        if (j .gt. 0) then
          do ii = 1,20
            read (nxcon,1000,end=999) uline
            if (uline(2:2).ne.'|' .or. uline(4:4).ne.'|') go to 120
            if (uline(3:3) .ne. ' ') then
              uoldvd = uline(6:8)
              go to 120
            endif
          enddo
          go to 120
        endif
      enddo
  120 continue
c
      rewind(nxcon)
      do i = 1,1000
        read (nxcon,1000,end=999) uline
        j = index(uline,'NEW INPUT FILE FORMAT')
        if (j .gt. 0) then
          do ii = 1,20
            read (nxcon,1000,end=999) uline
            if (uline(2:2).ne.'|' .or. uline(4:4).ne.'|') go to 150
            if (uline(3:3) .ne. ' ') then
              unewf = uline(6:6)
              go to 150
            endif
          enddo
          go to 150
        endif
      enddo
  150 continue
c
      rewind(nxcon)
      do i = 1,1000
        read (nxcon,1000,end=999) uline
        j = index(uline,'NEW INPUT FILE VERSION LEVEL')
        if (j .gt. 0) then
          do ii = 1,20
            read (nxcon,1000,end=999) uline
            if (uline(2:2).ne.'|' .or. uline(4:4).ne.'|') go to 180
            if (uline(3:3) .ne. ' ') then
              unewv = uline(6:8)
              go to 180
            endif
          enddo
          go to 180
        endif
      enddo
  180 continue
c
  999 continue
      end

      subroutine evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $ ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $ tempc,xhfs,xlks,xvfs)
c
c     This subroutine evaluates equilibrium constants and related
c     thermodynamic functions as functions of temperature and
c     standard grid pressure. To make pressure corrections off the
c     standard T-P grid for these data, use EQLIB/pcorrx.f.
c
c     This subroutine is called by:
c
c       EQLIB/absswa.f
c       EQLIB/evdata.f
c       EQ3NR/eq3nr.f
c       EQ6/absswb.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nstmax,ntprmx
c
      integer narxt(ntprmx)
c
      integer ipch,ipcv,nst,ntpr
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),axhfs(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axvfs(narxmx,ntprmx,nstmax),
     $ dhfs(ipchmx,nstmax),dvfs(ipcvmx,nstmax),xhfs(nstmax),
     $ xlks(nstmax),xvfs(nstmax)
c
      real*8 tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ipc,ns
c
      real*8 prop
c
c-----------------------------------------------------------------------
c
c     Compute the log K values for all reactions.
c
      do ns = 1,nst
c
c       Compute the log K values on the standard grid.
c
        if (axlks(1,ntpr,ns) .lt. 9999999.) then
c
c         Calling sequence substitutions:
c           axlks for arr
c           ns for k
c           nstmax for nmax
c
          call evdat3(axlks,ns,nstmax,narxmx,narxt,ntpr,ntprmx,prop,
     $    tempc)
          xlks(ns) = prop
        else
          xlks(ns) = 9999999.
        endif
c
        if (ipch .ge. 0) then
c
c         Compute the enthalpy function values on the standard grid.
c
          if (axhfs(1,ntpr,ns) .lt. 9999999.) then
c
c           Calling sequence substitutions:
c             axhfs for arr
c             ns for k
c             nstmax for nmax
c
            call evdat3(axhfs,ns,nstmax,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            xhfs(ns) = prop
          else
            xhfs(ns) = 9999999.
          endif
c
          do ipc = 1,ipch
c
c           Compute the pressure derivatives of the enthalpy function
c           values on the standard grid.
c
c           Calling sequence substitutions:
c             adhfs for arr
c             ipchmx for ipcxmx
c             ns for k
c             nstmax for nmax
c
            call evdat4(adhfs,ipc,ipchmx,ns,nstmax,narxmx,narxt,ntpr,
     $      ntprmx,prop,tempc)
            dhfs(ipc,ns) = prop
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Compute the volume function values on the standard grid.
c
          if (axvfs(1,ntpr,ns) .lt. 9999999.) then
c
c           Calling sequence substitutions:
c             axvfs for arr
c             ns for k
c             nstmax for nmax
c
            call evdat3(axvfs,ns,nstmax,narxmx,narxt,ntpr,ntprmx,
     $      prop,tempc)
            xvfs(ns) = prop
          else
            xvfs(ns) = 9999999.
          endif
c
          do ipc = 1,ipcv
c
c           Compute the pressure derivatives of the volume function
c           values on the standard grid.
c
c           Calling sequence substitutions:
c             advfs for arr
c             ipcvmx for ipcxmx
c             ns for k
c             nstmax for nmax
c
            call evdat4(advfs,ipc,ipcvmx,ns,nstmax,narxmx,narxt,ntpr,
     $      ntprmx,prop,tempc)
            dvfs(ipc,ns) = prop
          enddo
        endif
c
      enddo
c
      end

      subroutine cdrscx(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,axlks,
     $ axlksx,axvfs,axvfsx,cdrs,cdrsx,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,nstmax,ntprmx)
c
c     This subroutine copies the scratch arrays for reactions and
c     reaction properties into the standard arrays.
c
c     This subroutine is called by:
c
c       EQLIB/elim.f
c       EQLIB/mdrgex.f
c       EQLIB/switch.f
c       EQLIB/swtchb.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adhfsx = scratch array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfsx = scratch array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfsx = scratch array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlksx = scratch array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfsx = scratch array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrsx  = scratch array of reaction coefficients
c       narxmx = number of coefficient elements of axlks per species
c                  per temperature range
c       ndrsx  = scratch array of indices of species corresponding to
c                  reaction coefficients
c       ndrsrx = scratch pointer array for indices of species appearing
c                  in reactions
c       nstmax = maximum number of species
c       ntprmx = maximum number of temperature ranges
c
c     Principal output:
c
c       adhfs  = standard array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfs  = standard array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfs  = standard array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlks  = standard array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfs  = standard array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrs   = standard array of reaction coefficients
c       ndrs   = standard  array of indices of species corresponding to
c                  reaction coefficients
c       ndrsr  = standard pointer array for indices of species
c                  appearing in reactions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,ndrsmx,nstmax,ntprmx
c
      integer ndrs(ndrsmx),ndrsx(ndrsmx),ndrsr(2,nstmax),
     $ ndrsrx(2,nstmax)
      integer ipch,ipcv
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jhmax,jvmax,nmax
c
c-----------------------------------------------------------------------
c
      nmax = narxmx*ntprmx*nstmax
      jhmax = narxmx*ntprmx*ipchmx*nstmax
      jvmax = narxmx*ntprmx*ipcvmx*nstmax
c
      call copyaa(axlksx,axlks,nmax)
c
      if (ipch .ge. 0) then
        call copyaa(axhfsx,axhfs,nmax)
        if (ipch .ge. 1) call copyaa(adhfsx,adhfs,jhmax)
      endif
c
      if (ipcv .ge. 0) then
        call copyaa(axvfsx,axvfs,nmax)
        if (ipcv .ge. 1) call copyaa(advfsx,advfs,jvmax)
      endif
c
      nmax = 2*nstmax
      call copyia(ndrsrx,ndrsr,nmax)
c
      call copyaa(cdrsx,cdrs,ndrsmx)
      call copyia(ndrsx,ndrs,ndrsmx)
c
      end

      real*8 function coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
c
c     This subroutine finds the stoichiometric coefficient of the nb-th
c     basis species for the ns-th species. Note that 'nb' denotes
c     position in the list of basis species, not the general list of
c     species. The corresponding index on the latter list would be
c     given by nbasp(nb).
c
c     This subroutine is called by:
c
c       EQLIB/prtpct.f
c       EQ3NR/betas.f
c       EQ3NR/matrix.f
c       EQ3NR/scripx.f
c       EQ6/betaz.f
c       EQ6/matrxz.f
c       EQ6/pabssw.f
c       EQ6/setffg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstsmx,nstmax
c
      integer nsts(nstsmx),nstsr(2,nstmax)
      integer nb,ns
c
      real*8 csts(nstsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,n1,n2
c
c-----------------------------------------------------------------------
c
      coefst = 0.
      n1 = nstsr(1,ns)
      n2 = nstsr(2,ns)
      do n = n1,n2
        if (nb .eq. nsts(n)) then
          coefst = csts(n)
          go to 999
        endif
      enddo
c
  999 continue
      end

      subroutine intge3(cgexp,cgexpi,ier,iern1,iern2,ietmax,jern1,
     $ jern2,jetmax,jgext,jgexti,net,neti,netmax,ngexpi,ngexti,
     $ noutpt,nptmax,nstmax,nttyo,ugexj,ugexji,ugexp,ugexpi,ugexsi,
     $ uphase,uspec,xbar,xbarlg,xgexsi)
c
c     This subroutine interprets any concentrations and compositions
c     of generic exchange phases read from the EQ3NR input file. Here
c     concentration means moles of exchanger phase per kg H2O, and
c     composition means a set of mole fractions of the component
c     species on each site of the exchanger phase.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,netmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax),
     $ jgexti(netmax),ngexpi(netmax),ngexti(jetmax,netmax)
      integer ier,iern1,iern2,net,neti
c
      character*48 uspec(nstmax)
      character*24 ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax),ugexji(jetmax,netmax)
c
      real(8) cgexp(netmax),cgexpi(netmax),xbar(nstmax),xbarlg(nstmax),
     $ xgexsi(ietmax,jetmax,netmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iei,je,jeei,jei,jj,jj2,jj3,j2,j3,j4,j5,j6,nd2,ne,neei,
     $ nei,np,nr1,nr2,ns
c
      integer ilnobl
c
      character*24 ugexpd,ustr,uxp,uxs
      character*8 ugexjd,uxj
      character*8 ux8a,ux8b
c
      real(8) xsum,xx
c
      real(8) tlg
c
c-----------------------------------------------------------------------
c
      ier = 0
      if (neti .le. 0) go to 999
c
      if (net .le. 0) then
        call lejust(ugexpi(1))
        j4 = ilnobl(ugexpi(1))
        if (neti .eq. 1) then
          nei = 1
          write (noutpt,1000) ugexpi(nei)(1:j4)
          write (nttyo,1000) ugexpi(nei)(1:j4)
 1000     format(/' * Error - (EQ3NR/intge3) No generic exchanger',
     $    ' phases were declared',/7x,'on the input file, but a ',
     $    ' concentration and composition are',/7x,'specified for',
     $    ' the generic exchanger phase ',a,'.',/7x,'Specifying a',
     $    ' concentration and  composition does not',
     $    /7x,'automatically create such a phase.',/7x,'Other input',
     $    ' file directives are required.')
          ier = ier + 1
        else
          nei = 1
          write (noutpt,1010) neti,ugexpi(nei)(1:j4)
          write (nttyo,1010) neti,ugexpi(nei)(1:j4)
 1010     format(/' * Error - (EQ3NR/intge3) No generic exchanger',
     $    ' phases were declared',/7x,'on the input file, but',
     $    ' concentrations and compositions are specified',/7x,'for ',
     $    i3,' such phases, including ',a,'.',/7x,'Specifying a',
     $    ' concentration and  composition does not',
     $    /7x,'automatically create such a phase.',/7x,'Other input',
     $    ' file directives are required.')
          ier = ier + 1
        endif
      endif
c
      if (ier .gt. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Left-justify all input exchanger phase names and site names. Make
c     sure that no such names are blank. Assign defaults if necessary.
c
      do nei = 1,neti
        call lejust(ugexpi(nei))
        j4 = ilnobl(ugexpi(nei))
        if (j4 .le. 0) then
c
c         Calling sequence substitutions:
c           nei for ne
c
          call adgexp(nei,noutpt,nttyo,ugexpd)
          ugexpi(nei) = ugexpd
        endif
        do jei = 1,jgexti(nei)
          call lejust(ugexji(jei,nei))
          j3 = ilnobl(ugexji(jei,nei))
          if (j3 .le. 0) then
c
c           Calling sequence substitutions:
c             jei for je
c
            call adgexj(jei,noutpt,nttyo,ugexjd)
            ugexji(jei,nei) = ugexjd
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the names of exchanger phases for which
c     concentrations and compositions are specified are unique.
c     Make sure that the names of the sites of these phases are
c     unique for each such phase.
c
      do nei = 1,neti
        j4 = ilnobl(ugexpi(nei))
        if (nei .gt. 1) then
          do neei = 1,nei - 1
            if (ugexpi(nei)(1:24) .eq. ugexpi(neei)(1:24)) then
              write (noutpt,1030) ugexpi(nei)(1:j4),nei,neei
              write (nttyo,1030) ugexp(nei)(1:j4),nei,neei
 1030         format (/' * Error - (EQ3NR/intge3) "',a,'" is the name',
     $        ' specified',/7x,'for exchanger phases ',i3,' and ',i3,
     $        ' on the list of such phases',/7x,'whose concentrations',
     $        ' and compositions are given on the input file.',
     $        /7x,'Only one concentration and composition may be',
     $        ' entered per',/7x,'exchanger phase.')
             ier = ier + 1
            endif
          enddo
        endif
c
        do jei = 1,jgexti(nei)
          j3 = ilnobl(ugexji(jei,nei))
          if (jei .gt. 1) then
            do jeei = 1,jei - 1
              if (ugexji(jei,nei)(1:8) .eq. ugexji(jeei,nei)(1:8)) then
                write (noutpt,1040) ugexji(jei,nei)(1:j3),jei,jeei,
     $          ugexpi(nei)(1:j4)
                write (nttyo,1040) ugexji(jei,nei)(1:j3),jei,jeei,
     $          ugexpi(nei)(1:j4)
 1040           format (/' * Error - (EQ3NR/intge3) "',a,'" is the',
     $          ' name specified',/7x,'for sites ',i3,' and ',i3,' of',
     $          ' exchanger phase ',a,/7x,', whose composition is',
     $          ' given on the input file.',/7x,'A site name must be',
     $          ' unique for a given exchanger phase.')
                ier = ier + 1
              endif
            enddo
          endif
        enddo
      enddo
c
      if (ier .gt. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret the input data.
c
      do nei = 1,neti
        uxp = ugexpi(nei)
        j4 = ilnobl(uxp)
        ne = 0
c
        do np = iern1,iern2
          if (uxp(1:24) .eq. uphase(np)(1:24)) go to 100
        enddo
c
        write (noutpt,1070) uxp(1:j4)
        write (nttyo,1070) uxp(1:j4)
 1070   format(/' * Error - (EQ3NR/intge3) The generic exchanger',
     $  ' phase',/7x,a,', whose composition is specified on the input',
     $  /7x,"file, doesn't match the name of any such phase declared",
     $  /7x,'on the input file.')
        ier = ier + 1
        go to 200
c
  100   ne = np - iern1 + 1
        ngexpi(nei) = np
        cgexp(ne) = cgexpi(nei)
c
        if (jgexti(nei) .ne. jgext(ne)) then
          write (ux8a,'(i5)') jgexti(nei)
          call lejust(ux8a)
          j5 = ilnobl(ux8a)
          write (ux8b,'(i5)') jgext(ne)
          call lejust(ux8b)
          j6 = ilnobl(ux8b)
          write (noutpt,1080) uxp(1:j4),ux8a(1:j5),ux8b(1:j6)
          write (nttyo,1080) uxp(1:j4),ux8a(1:j5),ux8b(1:j6)
 1080     format(/' * Error - (EQ3NR/intge3) The generic exchanger',
     $  ' phase ',a,/7x,'has a specified composition including ',a,
     $  ' exchange site(s), but',/7x,'this phase actually has ',a,
     $  ' exchange site(s). The number of such',/7x,'sites much match.')
          ier = ier + 1
          go to 200
        endif
c
        do jei = 1,jgexti(nei)
          uxj = ugexji(jei,nei)
          j3 = ilnobl(uxj)
c
          do je = 1,jgext(ne)
            if (uxj(1:8) .eq. ugexj(je,ne)(1:8)) go to 110
          enddo
c
          write (noutpt,1110) uxj(1:j3),uxp(1:j4)
          write (nttyo,1110) uxj(1:j3),uxp(1:j4)
 1110     format(/' * Error - (EQ3NR/intge3) Site ',a,' of generic',
     $    ' exchanger phase',/7x,a,', whose composition is specified',
     $    ' on',/7x,"the input file, doesn't match the name of any",
     $    ' site',/7x,'of this phase as declared on the input file.')
          ier = ier + 1
          go to 190
c
  110     xsum = 0.
          do iei = 1,ngexti(jei,nei)
            uxs = ugexsi(iei,jei,nei)
            j2 = ilnobl(uxs)
c
c           Compose the exchanger species name, by combining the
c           name of the exchangeable species (the aqueous species)
c           with the site name. The algorithm for this follows that
c           used in EQLIB/intexi.f, except that the phase part of the
c           name is not employed here.
c
            jj2 = j2
            jj3 = j3
            nd2 = 0
  250       jj = jj2 + jj3 + 1
            if (jj .gt. 24) then
              if (nd2 .lt. 2) then
                jj2 = jj2 - 1
                nd2 = nd2 + 1
                go to 250
              else
                jj3 = jj3 - 1
                nd2 = 0
                go to 250
              endif
            endif
            ustr = ' '
            ustr(1:jj2) = ugexsi(iei,jei,nei)(1:jj2)
            ustr(jj2 + 1:jj2 + 1) = ' '
            ustr(jj2 + 2:jj) = ugexji(jei,nei)(1:jj3)
c
            nr1 = jern1(je,ne)
            nr2 = jern2(je,ne)
c
            do ns = nr1,nr2
              if (ustr(1:24) .eq. uspec(ns)(1:24)) go to 130
            enddo
c
            write (noutpt,1120) uxs(1:j2),uxj(1:j3),uxp(1:j4)
            write (nttyo,1120) uxs(1:j2),uxj(1:j3),uxp(1:j4)
 1120       format(/' * Error - (EQ3NR/intge3) The species ',a,' for',
     $      /7x,'site ',a,' of generic exchanger phase ',a,',',
     $      /7x,'whose composition is specified on the input file,',
     $      " doesn't match",/7x,'the name of any species for this',
     $      ' site of this phase',/7x,'as declared on the input file.')
            ier = ier + 1
            go to 180
c
  130       xx = xgexsi(iei,jei,nei)
            if (xx .ge. 0.) then
              xsum = xsum + xx
              xbar(ns) = xx
              xbarlg(ns) = tlg(xx)
            else
              write (noutpt,1130) uxs(1:j2),uxj(1:j3),uxp(1:j4),xx
              write (nttyo,1130) uxs(1:j2),uxj(1:j3),uxp(1:j4),xx
 1130         format(/' * Error - (EQ3NR/intge3) The species ',a,
     $        ' for ',/7x,'site ',a,' of generic exchanger phase ',a,
     $        /7x,'has an illegal negative mole fraction of ',1pe12.5,
     $        ' specified',/7x,'on the input file.')
              ier = ier + 1
            endif
  180       continue
          enddo
c
c         Normalize the mole fractions on the current site.
c
          nr1 = jern1(je,ne)
          nr2 = jern2(je,ne)
          if (xsum .gt. 0.) then
            do ns = nr1,nr2
              xx = xbar(ns)/xsum
              xbar(ns) = xx
              xbarlg(ns) = tlg(xx)
            enddo
          endif
c
  190     continue
        enddo
  200   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine evptzc(amu,aslm,ipbtmx,jpfcmx,jptffl,nmut,nmutmx,
     $ noutpt,nttyo,nslt,nsltmx,pmu,pslamn,tempc)
c
c     This subroutine computes the S-lambda(n) (pslamn) and mu (pmu)
c     coefficients of Pitzer's equations at the temperature tempc.
c
c     This subroutine is called by:
c
c       EQLIB/evdata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       amu    = array of coefficients for calculating Pitzer mu
c                coefficients (pmu) as a function of temperature
c       aslm   = array of coefficients for calculating Pitzer
c                  S-lambda(n) coefficients (pslamn) as a function
c                  of temperature
c       jptffl = Pitzer parameter temperature coefficient flag:
c                  -1 = 25C centric Taylor's series truncated at
c                         second order
c                   0 = 25C centric LLNL 5TERM function
c                         (maximal 5th order)
c                   1 = non-25C centric eight-term Greenberg and
c                         Moller (1989) function
c       nmut   = the number of species triples for which there are
c                  mu coefficients
c       nslt   = the number of species pairs for which there are
c                  S-lambda(n) coefficients
c       tempc  = the temperature (C)
c
c     Principal output:
c
c       pmu    = array of Pitzer mu coefficients
c       pslamn = array of Pitzer S-lambda(n) coefficients
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,nmutmx,nsltmx
c
      integer noutpt,nttyo
c
      integer jptffl,nmut,nslt
c
      real(8) amu(jpfcmx,nmutmx),aslm(jpfcmx,0:ipbtmx,nsltmx),
     $ pmu(nmutmx),pslamn(0:ipbtmx,nsltmx)
c
      real(8) tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jpfclm,j2,k,nmu,nsl
c
      integer ilnobl
c
      character(len=8) ux8
c
      real(8) px,t,tr
c
c     Note: the dimension of dtf must match the maximum number of terms
c     in any programmed temperature function.
c
      real(8) dtf(2:8)
c
c-----------------------------------------------------------------------
c
      t = tempc + 273.15
      tr = 298.15
c
      if (jptffl .eq. -1) then
c
c       Classical 25C-centric Taylor's series truncated at second order.
c
        dtf(2) = t - tr
        dtf(3) = 0.5*dtf(2)*dtf(2)
        jpfclm = min(jpfcmx,3)
c
      elseif (jptffl .eq. 0) then
c
c       LLNL maximal 5-term equation.
c
        dtf(2) = (1./t) - (1./tr)
        dtf(3) = log(t/tr)
        dtf(4) = t - tr
        dtf(5) = t**2 - tr**2
        jpfclm = min(jpfcmx,5)
c
      elseif (jptffl .eq. 1) then
c
c       Greenberg and Moller (1989) eight-term equation.
c
        if ((abs(t - 227.) .le. 1.e-3)
     $    .or. (abs(t - 263.) .le. 1.e-3)
     $    .or. (abs(t - 680.) .le. 1.e-3)) then
          write (noutpt,1000) t,tempc
          write (nttyo,1000) t,tempc
 1000     format(/' * Error - (EQLIBG/evptzc) The temperature of ',
     $    f7.4,'K (',f7.4,'C) is',/7x,'too close to a singularity',
     $    ' in the TEQUIL eight-parameter Pitzer',/7x,'parameter',
     $    ' temperature function.')
          stop
        endif
c
        dtf(2) = t
        dtf(3) = 1./t
        dtf(4) = log(t)
        dtf(5) = 1./(t - 263.)
        dtf(6) = t*t
        dtf(7) = 1./(680. - t)
        dtf(8) = 1./(t - 227.)
        jpfclm = min(jpfcmx,8)
c
      else
        write (ux8,'(i5)') jptffl
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1010) ux8(1:j2)
        write (nttyo,1010) ux8(1:j2)
 1010   format(/' * Error - (EQLIBG/evptzc) Programming error trap:',
     $  ' Have an',/7x,'illegal value of ',a,' for the variable',
     $  ' jptffl, which determines',/7x,'the Pitzer parameter',
     $  ' temperature function. Do not have such a',/7x,'function',
     $  ' programmed that matches this value.')
        stop
      endif
c
      do nsl = 1,nslt
        do k = 0,2
          px = aslm(1,k,nsl)
          do j = 2,jpfclm
            px = px + aslm(j,k,nsl)*dtf(j)
          enddo
          pslamn(k,nsl) = px
        enddo
      enddo
c
      do nmu = 1,nmut
        px = amu(1,nmu)
        do j = 2,jpfclm
          px = px + amu(j,nmu)*dtf(j)
        enddo
        pmu(nmu) = px
      enddo
c
      end

      subroutine wr6d8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $ dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $ dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $ dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $ ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $ iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $ jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $ mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $ nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $ nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $ nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $ ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $ nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $ pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $ tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $ ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $ ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $ usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $ uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $ xlkmod,xvfgex,zgexj,zvclgi)
c
c     This subroutine writes the EQ6 INPUT file in menu-style ("D")
c     format for version 8.0.
c
c     This subroutine is a near-clone of EQLIB/wr6pkd.f.
c
c     The calling sequence of this subroutine is identical to that of
c     XCON6/wr6w8.f, EQLIB/wr6pkd.f, and EQLIB/wr6pkw.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ6/rd6ind.f, EQ6/rd6inw.f, XCON6/rd6d8.f, and XCON6/rd6w8.f,
c     except that newin is added and ninpts, nprob, noutpt, qend,
c     and qrderr are deleted.
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,imchmx,jetmax,kmax,nbtmax,nbt1mx,nctmax,
     $ ndctmx,nertmx,netmax,nffgmx,nodbmx,nopgmx,noprmx,noptmx,nordmx,
     $ nprpmx,nprsmx,nptkmx,nrctmx,nsrtmx,ntitmx,nttkmx,nxmdmx,nxopmx,
     $ nxpemx,nxrtmx
c
      integer newin
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),iesrti(nsrtmx),
     $ igerti(jetmax,nertmx),imech(2,nrctmx),iodb(nodbmx),iopg(nopgmx),
     $ iopr(noprmx),iopt(noptmx),ixrti(nxrtmx),jcode(nrctmx),
     $ jflgi(nbtmax),jgerti(nertmx),jgext(netmax),jreac(nrctmx),
     $ kxmod(nxmdmx),ndact(imchmx,2,nrctmx),ngexrt(jetmax,netmax),
     $ nrk(2,nrctmx),nsk(nrctmx)
c
      integer itermx,jpress,jtemp,kbt,kct,kdim,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxt,nbti,nffg,nert,net,nobswt,nprpti,nprsti,nrct,nsbswt,
     $ nsrt,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt,nxrt
c
      logical qgexsh
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ubmtbi(nbtmax),uobsw(2,nbtmax),uprspi(nprsmx),
     $ usbsw(2,nbtmax),uxmod(nxmdmx),uzveci(kmax)
      character*24 ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),ugermo(nertmx),
     $ ugersi(ietmax,jetmax,nertmx),ugexmo(netmax),ugexp(netmax),
     $ uprphi(nprpmx),ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character*8 uesri(nctmax,nsrtmx),ugerji(jetmax,nertmx),
     $ ugexj(jetmax,netmax),uhfgex(ietmax,jetmax,netmax),
     $ uvfgex(ietmax,jetmax,netmax),uxkgex(ietmax,jetmax,netmax),
     $ uxopt(nxopmx)
c
      real*8 cbsri(nbt1mx,nsrtmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ cesri(nctmax,nsrtmx),cgexj(jetmax,netmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),
     $ egersi(ietmax,jetmax,nertmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprphi(nprpmx),mprspi(nprsmx),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),ptk(nptkmx),rkb(imchmx,2,nrctmx),
     $ rxbari(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),
     $ tgexp(netmax),trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),
     $ xgersi(ietmax,jetmax,nertmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkffg(nffgmx),xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zvclgi(kmax),zgexj(jetmax,netmax)
c
      real*8 awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,electr,o2maxi,o2mini,phmaxi,
     $ phmini,pressb,pressi,tempcb,tempci,timmxi,tistti,tolbt,toldl,
     $ tolsat,tolxsf,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlk8.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,ij,iki,j,jcox,jd,je,jei,jfl,jfli,jj,jnrk,jrex,j2,
     $ j3,j4,j5,j6,k,krow,kxmd,n,nbi,nci,ne,ner,npi,nrc,nr1,nsi,nsr,nxr
c
      integer nttyo
c
      integer ilnobl
c
      logical qgexbf,qstop,qx
c
      character*80 ux80
      character*48 ux48,ux48a,ux48b
      character*24 ux24
      character*16 ux16
      character*8 ux1(5)
      character*8 uxn,uxo,uxs,ux8
c
      real*8 px3,px4,px5,ptk14,ptk15,sx1,sx2,sx3,tx1,tx2,tx3,tx4,
     $ ttk12,ttk22,ttk14,ttk24,xx
c
c-----------------------------------------------------------------------
c
      data nttyo  /6/
c
c-----------------------------------------------------------------------
c
c     Check some dimensioning parameters.
c
      qstop = .false.
c
      if (ndbxpa .ne. nodbmx) then
        write (nttyo,1000) ndbxpa,nodbmx
 1000   format(/' * Error - (XCON6/wr6d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iodb debugging print option switches',
     $  ' with string definitions',/7x,'(ndbxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (nodbpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (npgxpa .ne. nopgmx) then
        write (nttyo,1010) npgxpa,nopgmx
 1010   format(/' * Error - (XCON6/wr6d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopg activity coefficient option',
     $  ' switches with string definitions',/7x,'(npgxpa) has a value',
     $  ' of ' ,i3,', but the dimensioning',/7x,'parameter for the',
     $  ' number of such switches (nopgpa) has a',/7x,'value of ',i3,
     $  '.')
        qstop = .true.
      endif
c
      if (nprxpa .ne. noprmx) then
        write (nttyo,1020) nprxpa,noprmx
 1020   format(/' * Error - (XCON6/wr6d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopr print option switches',
     $  ' with string definitions',/7x,'(nprxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noprpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (nptxpa .ne. noptmx) then
        write (nttyo,1030) nptxpa,noptmx
 1030   format(/' * Error - (XCON6/wr6d8) The dimensioning parameter',
     $  ' for the',/7x,'number of iopt model option switches',
     $  ' with string definitions',/7x,'(nptxpa) has a value of ',
     $  i3,', but the dimensioning',/7x,'parameter for the number',
     $  ' of such switches (noptpa) has a',/7x,'value of ',i3,'.')
        qstop = .true.
      endif
c
      if (qstop) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Main title.
c
      write (newin,1050)
 1050 format('|',78('-'),'|')
      write (newin,1070)
 1070 format('| Main Title',13x,'| (utitl1(n))',41x,'|')
      write (newin,1050)
      do n = 1,ntitl1
        write (newin,1090) utitl1(n)
 1090   format('|',a78,'|')
      enddo
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      ux1(4) = ' '
      tx1 = 0.
      tx2 = 0.
      tx3 = 0.
      tx4 = 0.
      ttk12 = 0.
      ttk22 = 0.
      ttk14 = 0.
      ttk24 = 0.
      if (jtemp .eq. 0) then
        ux1(1) = 'x'
        tx1 = tempcb
      elseif (jtemp .eq. 1) then
        ux1(2) = 'x'
        tx2 = tempcb
        ttk12 = ttk(1)
      elseif (jtemp .eq. 2) then
        ux1(3) = 'x'
        tx3 = tempcb
        ttk22 = ttk(1)
      elseif (jtemp .eq. 3) then
        ux1(4) = 'x'
        tx4 = tempcb
        ttk14 = ttk(1)
        ttk24 = ttk(2)
      endif
      write (newin,1130) ux1(1),tx1,ux1(2),tx2,ttk12,ux1(3),tx3,ttk22,
     $ ux1(4),tx4,ttk24,ttk14
 1130 format('|Temperature option (jtemp):',51x,'|',
     $ /'|  [',a1,'] ( 0) Constant temperature:',46x,'|',
     $ /'|             Value (C)         |',1pe12.5,'| (tempcb)',24x,
     $ '|',/'|  [',a1,'] ( 1) Linear tracking in Xi:',t80,'|',
     $ /'|             Base Value (C)    |',e12.5,'| (tempcb)',24x,'|',
     $ /'|             Derivative        |',e12.5,'| (ttk(1))',24x,'|',
     $ /'|  [',a1,'] ( 2) Linear tracking in time:',t80,'|',
     $ /'|             Base Value (C)    |',e12.5,'| (tempcb)',24x,'|',
     $ /'|             Derivative        |',e12.5,'| (ttk(1))',24x,'|',
     $ /'|  [',a1,'] ( 3) Fluid mixing tracking (fluid 2 = special',
     $ ' reactant):',t80,'|',
     $ /'|             T of fluid 1 (C)  |',e12.5,'| (tempcb)',24x,'|',
     $ /'|             T of fluid 2 (C)  |',e12.5,'| (ttk(2))',24x,'|',
     $ /'|             Mass ratio factor |',e12.5,'| (ttk(1))',24x,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      ux1(4) = ' '
      ux1(5) = ' '
      px3 = 0.
      px4 = 0.
      px5 = 0.
      ptk14 = 0.
      ptk15 = 0.
      if (jpress .eq. 0) then
        ux1(1) = 'x'
      elseif (jpress .eq. 1) then
        ux1(2) = 'x'
      elseif (jpress .eq. 2) then
        ux1(3) = 'x'
        px3 = pressb
      elseif (jpress .eq. 3) then
        ux1(4) = 'x'
        px4 = pressb
        ptk14 = ptk(1)
      elseif (jpress .eq. 4) then
        ux1(5) = 'x'
        px5 = pressb
        ptk15 = ptk(1)
      endif
      write (newin,1150) ux1(1),ux1(2),ux1(3),px3,ux1(4),px4,ptk14,
     $ ux1(5),px5,ptk15
 1150 format('|Pressure option (jpress):',53x,'|',
     $ /'|  [',a1,'] ( 0) Follow the data file reference pressure',
     $ ' curve',t80,'|',
     $ /'|  [',a1,'] ( 1) Follow the 1.013-bar/steam-saturation curve',
     $ t80,'|',
     $ /'|  [',a1,'] ( 2) Constant pressure:',49x,'|',
     $ /'|             Value (bars)      |',1pe12.5,'| (pressb)',24x,
     $ '|',/'|  [',a1,'] ( 3) Linear tracking in Xi:',t80,'|',
     $ /'|             Base Value (bars) |',e12.5,'| (pressb)',24x,'|',
     $ /'|             Derivative        |',e12.5,'| (ptk(1))',24x,'|',
     $ /'|  [',a1,'] ( 4) Linear tracking in time:',t80,'|',
     $ /'|             Base Value (bars) |',e12.5,'| (pressb)',24x,'|',
     $ /'|             Derivative        |',e12.5,'| (ptk(1))',24x,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reactants.
c
      write (newin,2010)
 2010 format('|Reactants (Irreversible Reactions) | (nrct)',t80,'|')
      write (newin,1050)
c
      nxr = 0
      nsr = 0
      ner = 0
c
      do nrc = 1,nrct
        write (newin,2030) ureac(nrc)
 2030   format('|Reactant        |',a24,'| (ureac(n))',t80,'|')
        write (newin,1050)
        write (newin,2050) urcjco(jcode(nrc))
 2050   format('|->|Type         |',a24,'| (urcjco(jcode(n)))',t80,'|')
        write (newin,1050)
        write (newin,2070) urcjre(jreac(nrc))
 2070   format('|->|Status       |',a24,'| (urcjre(jreac(n)))',t80,'|')
        write (newin,1050)
        write (newin,2090) morr(nrc)
 2090   format('|->|Amount remaining (moles) |',1pe12.5,
     $  '| (morr(n))',t80,'|')
        write (newin,1050)
        write (newin,2110) modr(nrc)
 2110   format('|->|Amount destroyed (moles) |',1pe12.5,
     $  '| (modr(n))',t80,'|')
        write (newin,1050)
c
        if (jcode(nrc) .eq. 1) then
c
c         Have a solid solution. Write its composition.
c
          nxr = nxr + 1
          write (newin,2210)
 2210     format('|->|Composition',t80,'|')
          write (newin,1050)
          write (newin,2230)
 2230     format('|--->|Component',15x,'|Mole frac.  | (this is a',
     $    ' table header)',10x,'|')
          write (newin,1050)
          do iki = 1,ixrti(nxr)
            write (newin,2250) ucxri(iki,nxr),rxbari(iki,nxr)
 2250       format('|--->|',a24,'|',1pe12.5,
     $      '| (ucxri(i,n), rxbari(i,n))',9x,'|')
          enddo
          write (newin,1050)
        endif
c
        if (jcode(nrc) .eq. 2) then
c
c         Have a special reactant. Write its molar volume, composition,
c         and reaction.
c
          nsr = nsr + 1
          write (newin,2310) vreac(nsr)
 2310     format('|->|Molar volume (cm3/mol)   |',1pe12.5,
     $    '| (vreac(n))',t80,'|')
          write (newin,1050)
c
          write (newin,2330)
 2330     format('|->|Composition',t80,'|')
          write (newin,1050)
          write (newin,2350)
 2350     format('|--->|Element |Stoich. Number',8x,'| (this is a',
     $    ' table header)',t80,'|')
          write (newin,1050)
          do nci = 1,iesrti(nsr)
            write (newin,2370) uesri(nci,nsr),cesri(nci,nsr)
 2370       format('|--->|',a8,'|',1pe22.15,
     $      '| (uesri(i,n), cesri(i,n))',16x,'|')
          enddo
          write (newin,1050)
c
          write (newin,2390)
 2390     format('|->|Reaction',t80,'|')
          write (newin,1050)
          write (newin,2410)
 2410     format('|--->|Species',17x,'|Reaction Coefficient',2x,
     $    '| (this is a table header)|')
          write (newin,1050)
          do nbi = 1,ibsrti(nsr)
            write (newin,2430) ubsri(nbi,nsr),cbsri(nbi,nsr)
 2430       format('|--->|',a24,'|',1pe22.15,
     $      '| (ubsri(i,n), cbsri(i,n))|')
          enddo
          write (newin,1050)
        endif
c
        if (jcode(nrc) .eq. 5) then
c
c         Have a generic ion exchanger. Write its exchange model
c         and composition.
c
          ner = ner + 1
c
          write (newin,2431) ugermo(ner)
 2431     format('|->|Exchange model  |',a24,'| (ugermo(n))',
     $    21x,'|')
          write (newin,1050)
c
          write (newin,2432)
 2432     format('|->|Composition',t80,'|')
          write (newin,1050)
          do jei = 1,jgerti(ner)
            write (newin,2440) ugerji(jei,ner)
 2440       format('|--->|Exchange site',3x,'|',a8,'| (ugerji(j,n))',
     $      33x,'|')
            write (newin,1050)
            write (newin,2450)
 2450       format('|----->|Component',15x,'|Eq. frac.   | (this is a',
     $      ' table header)',8x,'|')
            write (newin,1050)
            do iei = 1,igerti(jei,ner)
              write (newin,2460) ugersi(iei,jei,ner),egersi(iei,jei,ner)
 2460         format('|----->|',a24,'|',1pe12.5,
     $        '| (ugersi(i,j,n), egersi(i,j,n))',2x,'|')
            enddo
          enddo
          write (newin,1050)
        endif
c
        ux1(1) = ' '
        ux1(2) = ' '
        ux1(3) = ' '
        sx1 = 0.
        sx2 = 0.
        sx3 = 0.
        if (nsk(nrc) .le. 0) then
          ux1(1) = 'x'
          sx1 = sfcar(nrc)
        elseif (nsk(nrc) .eq. 1) then
          ux1(2) = 'x'
          sx2 = ssfcar(nrc)
        elseif (nsk(nrc) .eq. 2) then
          ux1(3) = 'x'
          sx3 = sfcar(nrc)
        endif
c
        write (newin,2610) ux1(1),sx1,ux1(2),sx2,ux1(3),sx3
 2610   format('|->|Surface area option (nsk(n)):',t80,'|',
     $  /'|->|  [',a1,'] ( 0) Constant surface area:',t80,'|',
     $  /'|->|             Value (cm2)       |',1pe12.5,
     $  '| (sfcar(n))',t80,'|',
     $  /'|->|  [',a1,'] ( 1) Constant specific surface area:',t80,
     $  '|',/'|->|             Value (cm2/g)     |',1pe12.5,
     $ '| (ssfcar(n))',t80,'|',
     $  /'|->|  [',a1,'] ( 2) n**2/3 growth law- current surface',
     $  ' area:',t80,'|',
     $  /'|->|             Value (cm2)       |',1pe12.5,
     $  '| (sfcar(n))',t80,'|')
        write (newin,1050)
c
        write (newin,2630) fkrc(nrc)
 2630   format('|->|Surface area factor      |',1pe12.5,
     $  '| (fkrc(n))',t80,'|')
        write (newin,1050)
c
c       Loop over the forward and backward directions.
c
        do jd = 1,2
          write (newin,2640) urcrld(jd),urcnrk(nrk(jd,nrc),jd),jd
 2640     format('|->|',a24,2x,'|',a24,
     $    '| (urcnrk(nrk(',i1,',n)))',t80,'|')
          write (newin,1050)
c
          if (nrk(jd,nrc) .eq. 1) then
c
c           Relative rate law.
c
            do i = 1,3
              write (newin,2730) urcrel(i,jd),rkb(i,jd,nrc),i,jd
 2730         format('|--->|',a24,2x,'|',1pe12.5,
     $        '| (rkb(',i1,',',i1,',n))',t80,'|')
              write (newin,1050)
            enddo
          endif
c
          if (nrk(jd,nrc) .eq. 2) then
c
c           TST rate law.
c
            do i = 1,imech(jd,nrc)
              ux8 = ' '
              write (ux8,'(i2)') i
              j2 = ilnobl(ux8)
              write (newin,2830) ux8(1:j2)
 2830         format('|--->|Mechanism ',a,t80,'|')
              write (newin,1050)
              write (newin,2850) urcrls(jd),csigma(i,jd,nrc),jd
 2850         format('|----->|sigma(i,',a1,',n)            |',1pe12.5,
     $        '| csigma(i,',i1,',n)',t80,'|')
              write (newin,1050)
              write (newin,2870) urcrls(jd),rkb(i,jd,nrc),jd
 2870         format('|----->|k(i,',a1,',n) (mol/cm2/sec)  |',1pe12.5,
     $        '| rkb(i,',i1,',n)',t80,'|')
              write (newin,1050)
              write (newin,2890) trkb(i,jd,nrc),jd
 2890         format('|----->|Ref. Temperature (C)    |',1pe12.5,
     $        '| trkb(i,',i1,',n)',t80,'|')
              write (newin,1050)
c
              ux1(1) = ' '
              ux1(2) = ' '
              ux1(3) = ' '
              sx1 = 0.
              sx2 = 0.
              sx3 = 0.
              if (iact(i,jd,nrc) .le. 0) then
                ux1(1) = 'x'
              elseif (iact(i,jd,nrc) .eq. 1) then
                ux1(2) = 'x'
                sx2 = eact(i,jd,nrc)
              else
                ux1(3) = 'x'
                sx3 = hact(i,jd,nrc)
              endif
              write (newin,2910) jd,ux1(1),ux1(2),sx2,jd,ux1(3),sx3,jd
 2910         format('|----->|Temperature dependence option (iact(i,',
     $        i1,',n)):',27x,'|',/'|----->|  [',a1,'] ( 0) No',
     $        ' temperature dependence',t80,'|',/'|----->|  [',a1,
     $        '] ( 1) Constant activation energy:',t80,'|',
     $        /'|----->|             Value (kcal/mol)  |',1pe12.5,
     $        '| (eact(i,',i1,',n))',t80,'|',/'|----->|  [',a1,
     $        '] ( 2) Constant activation enthalpy:',t80,'|',
     $        /'|----->|             Value (kcal/mol)  |',1pe12.5,
     $        '| (hact(i,',i1,',n))',t80,'|')
              write (newin,1050)
c
              write (newin,2930) jd
 2930         format('|----->|Kinetic activity product species',
     $        ' (ndact(i,',i1,',n))',t80,'|')
              write (newin,1050)
c
              write (newin,2950) urcrls(jd),jd,jd
 2950         format('|------->|Species',41x,'|-N(j,i,',a1,',n)',9x,'|',
     $        /'|------->| (udac(j,i,',i1,',n))',32x,
     $        '| (cdac(j,i,',i1,',n))',t80,'|')
              write (newin,1050)
c
              do j = 1,ndact(i,jd,nrc)
                write (newin,2970) udac(j,i,jd,nrc),cdac(j,i,jd,nrc)
 2970           format('|------->|',a48,'|',1pe12.5,t80,'|')
                write (newin,1050)
              enddo
c
              if (ndact(i,jd,nrc) .le. 0) then
                ux48 = 'None'
                xx = 0.
                write (newin,2970) ux48,xx
                write (newin,1050)
              endif
            enddo
          endif
c
          if (nrk(jd,nrc) .eq. 3) then
c
c           Linear rate law.
c
            i = 1
            ux8 = ' '
            write (ux8,'(i2)') i
            j2 = ilnobl(ux8)
            write (newin,2830) ux8(1:j2)
            write (newin,1050)
            write (newin,2870) urcrls(jd),rkb(i,jd,nrc),jd
            write (newin,1050)
            write (newin,2890) trkb(i,jd,nrc),jd
            write (newin,1050)
c
            ux1(1) = ' '
            ux1(2) = ' '
            ux1(3) = ' '
            sx1 = 0.
            sx2 = 0.
            sx3 = 0.
            if (iact(i,jd,nrc) .le. 0) then
              ux1(1) = 'x'
            elseif (iact(i,jd,nrc) .eq. 1) then
              ux1(2) = 'x'
              sx2 = eact(i,jd,nrc)
            else
              ux1(3) = 'x'
              sx3 = hact(i,jd,nrc)
            endif
            write (newin,2910) jd,ux1(1),ux1(2),sx2,jd,ux1(3),sx3,jd
            write (newin,1050)
          endif
        enddo
      enddo
c
      if (nrct .le. 0) then
        ux24 = 'None'
        xx = 0.
        write (newin,2030) ux24
        write (newin,1050)
        write (newin,2050) ux24
        write (newin,1050)
        write (newin,2070) ux24
        write (newin,1050)
        write (newin,2090) xx
        write (newin,1050)
        write (newin,2110) xx
        write (newin,1050)
      endif
c
      write (newin,3110)
 3110 format('* Valid reactant type strings (urcjco(jcode(n))) are:',
     $ t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do jcox = 0,5
        jj = j3 + 27
        ux80(j3:jj) = urcjco(jcox)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 2) then
          write (newin,3130) ux80(1:80)
 3130     format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,3130) ux80(1:80)
c
      write (newin,1052)
 1052 format('*',78('-'),'*')
c
      write (newin,3150)
 3150 format('* Valid reactant status strings (urcjre(jreac(n))) are:',
     $ t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do jrex = -1,2
        jj = j3 + 27
        ux80(j3:jj) = urcjre(jrex)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 2) then
          write (newin,3170) ux80(1:80)
 3170     format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,3130) ux80(1:80)
c
      write (newin,1052)
c
      do jd = 1,2
        ux24 = urcrld(jd)
        call locase(ux24)
        j2 = ilnobl(ux24)
        write (newin,3190) ux24(1:j2),jd
 3190   format('* Valid ',a,' strings (urcnrk(nrk(',i1,',n))) are:',
     $  t80,'*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do jnrk = -1,3
          ux24 = urcnrk(jnrk,jd)
          j4 = ilnobl(ux24)
          if (ux24(1:j4) .ne. 'Illegal value') then
            jj = j3 + 27
            ux80(j3:jj) = ux24
            j3 = jj + 1
            k = k + 1
            if (k .ge. 2) then
              write (newin,3210) ux80(1:80)
 3210         format(a)
              ux80(2:79) = ' '
              j3 = 6
              k = 0
            endif
          endif
        enddo
        if (k .gt. 0) write (newin,3130) ux80(1:80)
c
        write (newin,1052)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting, minimum, and maximum values of key run parameters.
c
      write (newin,1200)
 1200 format('|Starting, minimum, and maximum values of key run',
     $ ' parameters.',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting value of Xi.
c
      write (newin,1210) xistti
 1210 format('|Starting Xi value        |',1pe12.5,'| (xistti)',t80,'|')
      write (newin,1050)
c
c     Maximum value of Xi.
c
      write (newin,1215) ximaxi
 1215 format('|Maximum Xi value         |',1pe12.5,'| (ximaxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting value of time.
c
      write (newin,1220) tistti
 1220 format('|Starting time (seconds)  |',1pe12.5,'| (tistti)',t80,'|')
      write (newin,1050)
c
c     Maximum value of time.
c
      write (newin,1225) timmxi
 1225 format('|Maximum time (seconds)   |',1pe12.5,'| (timmxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Minimum value of pH.
c
      write (newin,1230) phmini
 1230 format('|Minimum value of pH      |',1pe12.5,'| (phmini)',t80,'|')
      write (newin,1050)
c
c     Maximum value of pH.
c
      write (newin,1235) phmaxi
 1235 format('|Maximum value of pH      |',1pe12.5,'| (phmaxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Minimum value of Eh (v).
c
      write (newin,1240) ehmini
 1240 format('|Minimum value of Eh (v)  |',1pe12.5,'| (ehmini)',t80,'|')
      write (newin,1050)
c
c     Maximum value of Eh (v).
c
      write (newin,1245) phmaxi
 1245 format('|Maximum value of Eh (v)  |',1pe12.5,'| (ehmaxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Minimum value of log fO2.
c
      write (newin,1250) o2mini
 1250 format('|Minimum value of log fO2 |',1pe12.5,'| (o2mini)',t80,'|')
      write (newin,1050)
c
c     Maximum value of log fO2.
c
      write (newin,1255) o2maxi
 1255 format('|Maximum value of log fO2 |',1pe12.5,'| (o2maxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Minimum value of the activity of water.
c
      write (newin,1260) awmini
 1260 format('|Minimum value of aw      |',1pe12.5,'| (awmini)',t80,'|')
      write (newin,1050)
c
c     Maximum value of the activity of water.
c
      write (newin,1265) awmaxi
 1265 format('|Maximum value of aw      |',1pe12.5,'| (awmaxi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of steps.
c
      write (newin,1270) kstpmx
 1270 format('|Maximum number of steps  |',i12,'| (kstpmx)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval parameters.
c
      write (newin,1300)
 1300 format('|Print interval parameters.',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Xi print interval.
c
      write (newin,1310) dlxprn
 1310 format('|Xi print interval        |',1pe12.5,'| (dlxprn)',t80,'|')
      write (newin,1050)
c
c     Log Xi print interval.
c
      write (newin,1315) dlxprl
 1315 format('|Log Xi print interval    |',1pe12.5,'| (dlxprl)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Time print interval.
c
      write (newin,1320) dltprn
 1320 format('|Time print interval      |',1pe12.5,'| (dltprn)',t80,'|')
      write (newin,1050)
c
c     Log time print interval.
c
      write (newin,1325) dltprl
 1325 format('|Log time print interval  |',1pe12.5,'| (dltprl)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     pH print interval.
c
      write (newin,1330) dlhprn
 1330 format('|pH print interval        |',1pe12.5,'| (dlhprn)',t80,'|')
      write (newin,1050)
c
c     Eh (v) print interval.
c
      write (newin,1335) dleprn
 1335 format('|Eh (v) print interval    |',1pe12.5,'| (dleprn)',t80,'|')
      write (newin,1050)
c
c     Log fO2 print interval.
c
      write (newin,1340) dloprn
 1340 format('|Log fO2 print interval   |',1pe12.5,'| (dloprn)',t80,'|')
      write (newin,1050)
c
c     Activity of water print interval.
c
      write (newin,1345) dlaprn
 1345 format('|aw print interval        |',1pe12.5,'| (dlaprn)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Steps print interval.
c
      write (newin,1380) ksppmx
 1380 format('|Steps print interval     |',i12,'| (ksppmx)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval parameters.
c
      write (newin,1400)
 1400 format('|Plot interval parameters.',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Xi plot interval.
c
      write (newin,1410) dlxplo
 1410 format('|Xi plot interval         |',1pe12.5,'| (dlxplo)',t80,'|')
      write (newin,1050)
c
c     Log Xi plot interval.
c
      write (newin,1415) dlxpll
 1415 format('|Log Xi plot interval     |',1pe12.5,'| (dlxpll)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Time plot interval.
c
      write (newin,1420) dltplo
 1420 format('|Time plot interval       |',1pe12.5,'| (dltplo)',t80,
     $ '|')
      write (newin,1050)
c
c     Log time plot interval.
c
      write (newin,1425) dltpll
 1425 format('|Log time plot interval   |',1pe12.5,'| (dltpll)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     pH plot interval.
c
      write (newin,1430) dlhplo
 1430 format('|pH plot interval         |',1pe12.5,'| (dlhplo)',t80,'|')
      write (newin,1050)
c
c     Eh (v) plot interval.
c
      write (newin,1435) dleplo
 1435 format('|Eh (v) plot interval     |',1pe12.5,'| (dleplo)',t80,'|')
      write (newin,1050)
c
c     Log fO2 plot interval.
c
      write (newin,1440) dloplo
 1440 format('|Log fO2 plot interval    |',1pe12.5,'| (dloplo)',t80,'|')
      write (newin,1050)
c
c     Activity of water plot interval.
c
      write (newin,1445) dlaplo
 1445 format('|aw plot interval         |',1pe12.5,'| (dlaplo)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Steps plot interval.
c
      write (newin,1450) ksplmx
 1450 format('|Steps plot interval      |',i12,'| (ksplmx)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1460)
 1460 format('|Iopt Model Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,1050)
c
      uxo = 'iopt('
      do n = 1,noptmx
        j6 = index(uoptcx(n),'EQ6')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uopttx(n))
          write (newin,1465) uxo(1:j4),uopttx(n)(1:j3)
 1465     format('|',a,' - ',a,':',t80,'|')
          i = iopt(n)
          do j = 1,jptxpa
            ij = ioptox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uoptox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uoptox(j,n)(1:j2)
 1470         format('|  [',a1,'] (',i2,') ',a,t80,'|')
            endif
          enddo
          write (newin,1050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
      write (newin,1490)
 1490 format('|Iopr Print Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,1050)
c
      uxo = 'iopr('
      do n = 1,noprmx
        j6 = index(uoprcx(n),'EQ6')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uoprtx(n))
          write (newin,1465) uxo(1:j4),uoprtx(n)(1:j3)
          i = iopr(n)
          do j = 1,jprxpa
            ij = ioprox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uoprox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uoprox(j,n)(1:j2)
            endif
          enddo
          write (newin,1050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1495)
 1495 format('|Iodb Debugging Print Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,1050)
c
      uxo = 'iodb('
      do n = 1,nodbmx
        j6 = index(uodbcx(n),'EQ6')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uodbtx(n))
          write (newin,1465) uxo(1:j4),uodbtx(n)(1:j3)
          i = iodb(n)
          do j = 1,jdbxpa
            ij = iodbox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uodbox(j,n))
            if (j2 .gt. 0) then
              write (newin,1470) uxs,ij,uodbox(j,n)(1:j2)
            endif
          enddo
          write (newin,1050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nxopt options.
c
      write (newin,2510)
 2510 format('|Mineral Sub-Set Selection Suppression Options |',
     $ ' (nxopt)',t80,'|')
      write (newin,1050)
c
        write (newin,2530)
 2530 format('|Option  |Sub-Set Defining Species|',
     $ ' (this is a table header)',t80,'|')
      write (newin,1050)
c
      if (nxopt .gt. 0) then
        do n = 1,nxopt
          write (newin,2550) uxopt(n),uxcat(n)
 2550     format('|',a8,'|',a24,'| (uxopt(n), uxcat(n))',t80,'|')
        enddo
      else
        ux8 = 'None'
        ux24 = 'None'
        write (newin,2550) ux8,ux24
      endif
      write (newin,1050)
c
      write (newin,2552)
 2552 format('* Valid mineral sub-set selection suppression option',
     $ ' strings (uxopt(n)) are:',t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do n = 1,4
        jj = j3 + 11
        ux80(j3:jj) = uxopti(n)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 6) then
          write (newin,2554) ux80(1:80)
 2554       format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,2554) ux80(1:80)
c
      write (newin,1052)
c
      write (newin,2570)
 2570 format('|Exceptions to the Mineral Sub-Set Selection Suppression',
     $ ' Options | (nxopex)',t80,'|')
      write (newin,1050)
c
        write (newin,2580)
 2580 format('|Mineral',17x,'| (this is a table header)',t80,'|')
      write (newin,1050)
c
      if (nxopex .gt. 0) then
        do n = 1,nxopex
          write (newin,2590) uxopex(n)
 2590     format('|',a24,'| (uxopex(n))',t80,'|')
        enddo
      else
        ux24 = 'None'
        write (newin,2590) ux24
      endif
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nffg options.
c
      write (newin,4110)
 4110 format('|Fixed Fugacity Options | (nffg)',t80,'|')
      write (newin,1050)
c
        write (newin,4130)
 4130 format('|Gas',21x,'|Moles to Add |Log Fugacity | --',t80,'|',
     $ /'| (uffg(n))',14x,'| (moffg(n))  | (xlkffg(n)) | --',t80,'|')
      write (newin,1050)
c
      if (nffg .gt. 0) then
        do n = 1,nffg
          write (newin,4150) uffg(n),moffg(n),xlkffg(n)
 4150     format('|',a24,'| ',1pe12.5,'| ',e12.5,'| --',t80,'|')
        enddo
      else
        ux24 = 'None'
        xx = 0.
        write (newin,4150) ux24,xx,xx
      endif
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical Parameters.
c
      write (newin,1510)
 1510 format('|Numerical Parameters',t80,'|')
      write (newin,1050)
c
      write (newin,1520) nordmx
 1520 format('|Max. finite-difference order',t45,'|',1x,i3,8x,
     $ '| (nordmx)',t80,'|')
c
      write (newin,1530) tolbt
 1530 format('|Beta convergence tolerance',t45,'|',1pe12.5,
     $ '| (tolbt)',t80,'|')
c
      write (newin,1550) toldl
 1550 format('|Del convergence tolerance',t45,'|',1pe12.5,
     $ '| (toldl)',t80,'|')
c
      write (newin,1570) itermx
 1570 format('|Max. No. of N-R iterations',t45,'|',1x,i3,8x,
     $ '| (itermx)',t80,'|')
c
      write (newin,1590) tolxsf
 1590 format('|Search/find convergence tolerance',t45,'|',1pe12.5,
     $ '| (tolxsf)',t80,'|')
c
      write (newin,1720) tolsat
 1720 format('|Saturation tolerance',t45,'|',1pe12.5,
     $ '| (tolsat)',t80,'|')
c
      write (newin,1730) ntrymx
 1730 format('|Max. No. of Phase Assemblage Tries',t45,'|',
     $ 1x,i3,8x,'| (ntrymx)',t80,'|')
c
      write (newin,1750) dlxmx0
 1750 format('|Zero order step size (in Xi)',t45,'|',1pe12.5,
     $ '| (dlxmx0)',t80,'|')
c
      write (newin,1770) dlxdmp
 1770 format('|Max. interval in Xi between PRS transfers',t45,'|',
     $ 1pe12.5,'| (dlxdmp)',t80,'|')
c
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mark the start of the bottom half of the file.
c
      write (newin,7170)
 7170 format('* Start of the bottom half of the INPUT file',t80,'*')
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Secondary title.
c
      write (newin,7190)
 7190 format('| Secondary Title',8x,'| (utitl2(n))',41x,'|')
      write (newin,1050)
      do n = 1,ntitl2
        write (newin,1090) utitl2(n)
      enddo
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,7210)
 7210 format('|Special Basis Switches (for model definition only)',
     $ 7x,'| (nsbswt)',11x,'|')
      write (newin,1050)
c
      do n = 1,nsbswt
        write (newin,7230) usbsw(1,n),usbsw(2,n)
 7230   format('|Replace |',a48,'| (usbsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (usbsw(2,n))',7x,'|')
        write (newin,1050)
      enddo
c
      if (nsbswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,7230) ux48a,ux48b
        write (newin,1050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      write (newin,7310) tempci
 7310 format('|Original temperature (C) |',1pe12.5,'| (tempci)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      write (newin,7330) pressi
 7330 format('|Original pressure (bars) |',1pe12.5,'| (pressi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,1600)
 1600 format('|Create Ion Exchangers',2x,'| (net)',48x,'|')
      write (newin,1050)
c
c     Set the advisory for exchanger creation blocks to follow or not.
c
      qgexbf = qgexsh .or. net.gt.0
      if (qgexbf) then
        write (newin,1603)
 1603   format('|Advisory: at least one exchanger creation block',
     $  ' follows on this file.',t80,'|')
      else
        write (newin,1605)
 1605   format('|Advisory: no exchanger creation blocks follow on',
     $  ' this file.',t80,'|')
      endif
c
c     Flag: on further processing, show at least one such block.
c
      ux1(1) = ' '
      if (qgexsh) ux1(1) = 'x'
      write (newin,1607) ux1(1)
 1607 format('|Option: on further processing (writing a PICKUP file',
     $ ' or running XCON6 on the',t80,'|',/'|present file), force the',
     $ ' inclusion of at least one such block (qgexsh):',t80,'|',
     $ /'|  [',a1,'] (.true.)',t80,'|')
      write (newin,1050)
c
      do ne = 1,net
        write (newin,1610) ugexp(ne)
 1610   format('|Exchanger phase |',a24,'| (ugexp(n))',
     $  25x,'|')
        write (newin,1050)
        write (newin,1620) mwtges(ne)
 1620   format('|->|Mol. wt. (Z)    |',1pg12.5,'| (mwtges(n))',
     $  33x,'|')
        write (newin,1050)
        write (newin,1630) ugexmo(ne)
 1630   format('|->|Exchange model  |',a24,'| (ugexmo(n))',
     $  21x,'|')
        write (newin,1050)
        write (newin,1640) tgexp(ne)
 1640   format('|->|Ref. temp. (C)  |',1pg12.5,'| (tgexp(n))',
     $  34x,'|')
        write (newin,1050)
        do je = 1,jgext(ne)
          write (newin,1650) ugexj(je,ne)
 1650     format('|->|Exchange site   |',a8,'| (ugexj(j,n))',
     $    36x,'|')
          write (newin,1050)
          write (newin,1660) cgexj(je,ne)
 1660     format('|--->|Stoich. number  |',1pg12.5,'| (cgexj(j,n))',
     $    30x,'|')
          write (newin,1050)
          write (newin,1670) zgexj(je,ne)
 1670     format('|--->|Electr. charge  |',1pg12.5,'| (zgexj(j,n))',
     $    30x,'|')
          write (newin,1050)
          do n = 1,ngexrt(je,ne)
            write (newin,1680) ugexr(n,je,ne)
 1680       format('|--->|Reaction        |',a24,'| (ugexr(i,j,n)',
     $      17x,'|')
            write (newin,1050)
            write (newin,1682)
 1682       format('|----->|Parameter |Value',7x,'|Units   | (this',
     $      ' is a table header)',13x,'|')
            write (newin,1050)
            write (newin,1684) xlkgex(n,je,ne),uxkgex(n,je,ne)
 1684       format('|----->|K func.   |',1pe12.5,'|',a8,
     $      '| (xlkgex(i,j,n), uxkgex(i,j,n))',7x,'|')
            write (newin,1686) xhfgex(n,je,ne),uhfgex(n,je,ne)
 1686       format('|----->|DelH0r    |',1pe12.5,'|',a8,
     $      '| (xhfgex(i,j,n), uhfgex(i,j,n))',7x,'|')
            write (newin,1688) xvfgex(n,je,ne),uvfgex(n,je,ne)
 1688       format('|----->|DelV0r    |',1pe12.5,'|',a8,
     $      '| (xvfgex(i,j,n), uvfgex(i,j,n))',7x,'|')
            write (newin,1050)
          enddo
        enddo
      enddo
c
      if (net.le.0 .and. qgexsh) then
        ux24 = 'None'
        ux8 = 'None'
        xx = 0.
        write (newin,1610) ux24
        write (newin,1050)
        write (newin,1620) xx
        write (newin,1050)
        write (newin,1630) ux24
        write (newin,1050)
        write (newin,1640) xx
        write (newin,1050)
        write (newin,1650) ux8
        write (newin,1050)
        write (newin,1660) xx
        write (newin,1050)
        write (newin,1670) xx
        write (newin,1050)
        write (newin,1680) ux24
        write (newin,1050)
        write (newin,1682)
        write (newin,1050)
        write (newin,1684) xx,ux8
        write (newin,1686) xx,ux8
        write (newin,1688) xx,ux8
        write (newin,1050)
      endif
c
      if (net.gt.0 .or. qgexsh) then
        write (newin,1694)
 1694   format('* Valid exchange model strings (ugexmo(n)) are:',t80,
     $  '*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,nvet_par
          if (ugexmv(n)(1:6) .ne. 'ERROR ') then
            jj = j3 + 27
            ux80(j3:jj) = ugexmv(n)
            j3 = jj + 1
            k = k + 1
            if (k .ge. 2) then
              write (newin,1696) ux80(1:80)
 1696         format(a)
              ux80(2:79) = ' '
              j3 = 6
              k = 0
            endif
          endif
        enddo
        if (k .gt. 0) write (newin,1696) ux80(1:80)
c
        write (newin,1052)
c
        write (newin,1690)
 1690   format('* Valid units strings (uxkgex(i,j,n)/uhfgex(i,j,n)/',
     $  'uvfgex(i,j,n)) are:',t80,'*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,4
          jj = j3 + 19
          ux80(j3:jj) = uxfuni(n)
          j3 = jj + 1
          k = k + 1
          if (k .ge. 3) then
            write (newin,1692) ux80(1:80)
 1692         format(a)
            ux80(2:79) = ' '
            j3 = 6
            k = 0
          endif
        enddo
        if (k .gt. 0) write (newin,1692) ux80(1:80)
c
        write (newin,1052)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nxmod options.
c
      write (newin,5080)
 5080 format('|Alter/Suppress Options  | (nxmod)',45x,'|')
      write (newin,1050)
      write (newin,5082)
 5082 format('|Species',41x,'|Option',10x,'|Alter value |',
     $ /'| (uxmod(n))',37x,'|(ukxm(kxmod(n)))| (xlkmod(n))|')
      write (newin,1050)
c
      do n = 1,nxmod
        write (newin,5090) uxmod(n),ukxm(kxmod(n)),xlkmod(n)
 5090   format('|',a48,'|',a16,'|',1pe12.5,'|')
      enddo
c
      if (nxmod .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,5090) ux48,ux16,xx
      endif
c
      write (newin,1050)
c
      write (newin,5092)
 5092 format('* Valid alter/suppress strings (ukxm(kxmod(n))) are:',
     $ t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do kxmd = -1,2
        jj = j3 + 19
        ux80(j3:jj) = ukxm(kxmd)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 3) then
          write (newin,5094) ux80(1:80)
 5094       format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,5094) ux80(1:80)
c
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,7510)
 7510 format('|Iopg Activity Coefficient Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,1050)
c
      uxo = 'iopg('
      do n = 1,nopgmx
        j6 = index(uopgcx(n),'EQ6')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uopgtx(n))
          write (newin,7530) uxo(1:j4),uopgtx(n)(1:j3)
 7530     format('|',a,' - ',a,':',t80,'|')
          i = iopg(n)
          do j = 1,jpgxpa
            ij = iopgox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uopgox(j,n))
            if (j2 .gt. 0) then
              write (newin,7550) uxs,ij,uopgox(j,n)(1:j2)
 7550         format('|  [',a1,'] (',i2,') ',a,t80,'|')
            endif
          enddo
          write (newin,1050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      write (newin,7610)
 7610 format('|Matrix Index Limits',t80,'|')
      write (newin,1050)
      write (newin,7630) kct
 7630 format('|No. of chem. elements   |',i5,'| (kct)',t80,'|')
      write (newin,7650) kbt
 7650 format('|No. of basis species    |',i5,'| (kbt)',t80,'|')
      write (newin,7670) kmt
 7670 format('|Index of last pure min. |',i5,'| (kmt)',t80,'|')
      write (newin,7690) kxt
 7690 format('|Index of last sol-sol.  |',i5,'| (kxt)',t80,'|')
      write (newin,7710) kdim
 7710 format('|Matrix size             |',i5,'| (kdim)',t80,'|')
      write (newin,7730) kprs
 7730 format('|PRS data flag           |',i5,'| (kprs)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
      write (newin,7750)
 7750 format('|Mass Balance Species (Matrix Row Variables)',5x,
     $ '|Units/Constraint| --',9x,'|',
     $ /'| (ubmtbi(n))',36x,'|(ujf6(jflgi(n)))| --',9x,'|')
      write (newin,1050)
c
      qstop = .false.
      do nbi = 1,nbti
        jfl = jflgi(nbi)
        jfli = 1
        if (jfl .eq. 30) jfli = 2
c
        write (newin,7790) ubmtbi(nbi),ujf6(jfli)
 7790   format('|',a48,'|',a16,'| --',9x,'|')
      enddo
      if (qstop) stop
c
      if (nbti .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,7790) ux48,xx,ux16
      endif
c
      write (newin,1050)
c
      write (newin,7810)
 7810 format('* Valid jflag strings (ujf6(jflgi(n))) are:',t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do jfli = 1,2
        jj = j3 + 19
        ux80(j3:jj) = ujf6(jfli)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 3) then
          write (newin,7830) ux80(1:80)
 7830     format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,7830) ux80(1:80)
c
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
      write (newin,7850)
 7850 format('|Mass Balance Totals (moles)',51x,'|')
      write (newin,1050)
c
      write (newin,7870)
 7870 format('|Basis species (info. only)',6x,'|Equilibrium System',4x,
     $ '|Aqueous Solution',6x,'|',
     $ /'| (ubmtbi(n))',20x,'| (mtbi(n))',12x,'| (mtbaqi(n))',10x,'|')
      write (newin,1050)
c
      do nbi = 1,nbti
        write (newin,7890) ubmtbi(nbi),mtbi(nbi),mtbaqi(nbi)
 7890   format('|',a32,'|',1pe22.15,'|',e22.15,'|')
      enddo
c
      ux48 = 'Electrical imbalance'
      write (newin,7890) ux48,electr,electr
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,7970)
 7970 format('|Ordinary Basis Switches (for numerical purposes only)',
     $ 4x,'| (nobswt)',11x,'|')
      write (newin,1050)
c
      do n = 1,nobswt
        write (newin,7990) uobsw(1,n),uobsw(2,n)
 7990   format('|Replace |',a48,'| (uobsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (uobsw(2,n))',7x,'|')
        write (newin,1050)
      enddo
c
      if (nobswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,7990) ux48a,ux48b
        write (newin,1050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables and values.
c
      write (newin,7910)
 7910 format('|Matrix Column Variables and Values',44x,'|')
      write (newin,1050)
c
      write (newin,7930)
 7930 format('|Basis species (uzveci(n))',23x,
     $ '|Log moles (zvclgi(n)) | --   |')
      write (newin,1050)
c
      do krow = 1,kdim
        write (newin,7950) uzveci(krow),zvclgi(krow)
 7950   format('|',a48,'|',1pe22.15,'| --   |')
      enddo
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Phases and species in the PRS.
c
      write (newin,8110)
 8110 format('|Phases and Species in the PRS',49x,'|')
      write (newin,1050)
c
      qx = kprs.gt.0 .and. nprpti.gt.0 .and. nprsti.gt.0
      if (qx) then
        nr1 = 1
        do npi = 1,nprpti
          write (newin,8130) uprphi(npi)
 8130     format('|Phase',11x,'|',a24,'| (uprphi(n))',t80,'|')
          write (newin,1050)
          write (newin,8150) mprphi(npi)
 8150     format('|->|No. of Moles',4x,'|',1pe22.15,'| (mprphi(n))',
     $    t80,'|')
          write (newin,1050)
          write (newin,8170)
 8170     format('|--->|Species',17x,'|No. of Moles',10x,
     $    '| --',t80,'|',/'|--->| (uprspi(i,n))',10x,
     $    '| (mprspi(i,n))',8x,'| --',t80,'|')
          write (newin,1050)
c
          do nsi = nr1,nprsti
            if (uprspi(nsi)(25:48) .ne. uprphi(npi)(1:24)) then
              nr1 = nsi
              go to 700
            endif
            write (newin,8190) uprspi(nsi),mprspi(nsi)
 8190       format('|--->|',a24,'|',1pe22.15,'| --',t80,'|')
          enddo
  700     write (newin,1050)
        enddo
      endif
c
      if (.not.qx) then
        ux24 = 'None'
        xx = 0.
        write (newin,8130) ux24
        write (newin,1050)
        write (newin,8150) xx
        write (newin,1050)
        write (newin,8170)
        write (newin,1050)
        write (newin,8190) ux24,xx
        write (newin,1050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     End of problem.
c
      write (newin,8310)
 8310 format('|End of problem',64x,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine initav(array,nmax,value)
c
c     This subroutine initializes the real*8 array "array" to the value
c     of "value" over the first nmax positions. Normally, nmax would
c     be the dimension of the 1D "array". However, nmax could be less
c     than the true dimension. Also, array could actually have more
c     than one dimension. For example, if the array is really "a",
c     having dimensions of i1 and i2, this subroutine could be used by
c     calling it in the following manner: call initar(a,(i1*i2),value).
c     Use this subroutine with caution if the two arrays do not have
c     identical dimensioning or nmax is not the product of the true
c     (declared) dimensions.
c
c     To initialize a real*8 array to a zero value, use EQLIBU/initaz.f
c     instead.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array  = the array
c       nmax   = dimension or pseudo-dimension of array
c       value  = the initialization value
c
c     Output:
c
c       array  = array, with the first nmax positions set to the
c                initialization value
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array(nmax),value
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 vx
c
c-----------------------------------------------------------------------
c
c     Note the assignment of the value to a local variable.
c     Note that the loop is unrolled.
c
      vx = value
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        array(i) = vx
        array(i + 1) = vx
        array(i + 2) = vx
        array(i + 3) = vx
        array(i + 4) = vx
        array(i + 5) = vx
        array(i + 6) = vx
        array(i + 7) = vx
      enddo
c
      do i = ileft + 1,nmax
        array(i) = vx
      enddo
c
      end

      subroutine setrcp(aftarg,dlxmax,dlxmin,dlxmx0,npslmx,nsscmx,
     $ nsslmx,prcinf,sscrew,tolaft,tolsat,tolsst,zkfac,zklgmn,
     $ zklogl,zklogu)
c
c     This subroutine sets the values of various run control parameters
c     which are not read from the input file.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nsscmx
c
      integer npslmx,nsslmx
c
      real*8 sscrew(nsscmx)
c
      real*8 aftarg,dlxmax,dlxmin,dlxmx0,prcinf,tolaft,tolsat,tolsst,
     $ zkfac,zklgmn,zklogl,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n
c
      real*8 tlg
c
c-----------------------------------------------------------------------
c
c     Supersaturation tolerance (if phase boundary searches are being
c     made and this is exceeded, the step size is cut). Note that tolsst
c     must be greater than tolsat (see aftarg and tolaft below).
c
      tolsst = 2.*tolsat
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Affinity target (the target for a search for a phase appearance
c     boundary).
c
      aftarg = 0.5*(tolsst + tolsat)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Affinity tolerance (the tolerance about the affinity target).
c     This requires the affinity at the located phase appearnce
c     boundary to lie between tolsat and tolsst.
c
      tolaft = tolsst - aftarg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setscrew parameters.
c
c       sscrew(1) = Step size control parameter, bounds the absolute
c                     value of the estimated error in any Taylor's
c                     series for a basis species variable. This is used
c                     to choose the order and the step size in normal
c                     reaction path computational mode. It is used to
c                     choose only the order in economy mode.
c
c       sscrew(2) = Not used.
c
c       sscrew(3) = Step size control parameter, bounds the absolute
c                     value of the estimated error in Taylor's
c                     series for rate functions (kinetic mode only).
c                     It also serves a function similar to that of
c                     sscrew(4) in testing the estimated error in the
c                     absolute time or the reaction progress of any
c                     individual irreversible reaction. If either of
c                     the sscrew(3) or sscrew(4) tests for corrector
c                     iteration or step size cuts is satisfied, no
c                     corrective action is taken.
c
c       sscrew(4) = Tolerance for corrector iteration or step size
c                     cut for differences between actual and predicted
c                     rate function values (kinetic mode only).
c
c       sscrew(5) = Maximum magnitude of Newton-Raphson correction
c                     term per iteration.
c
c       sscrew(6) = Step size parameter for economy mode; this bounds
c                     the change in a basis variable.
c
      do n = 1,nsscmx
        sscrew(n) = 0.
      enddo
c
      sscrew(1) = 1.e-4
c     if (sscrew(1) .lt. 1.e-6) sscrew(1) = 1.e-6
c     if (sscrew(1) .gt. 1.e-4) sscrew(1) = 1.e-4
c
      sscrew(3) = 1.e-4
c     if (sscrew(3) .lt. 1.e-6) sscrew(3) = 1.e-6
c     if (sscrew(3) .gt. 1.e-4) sscrew(3) = 1.e-4
c
      sscrew(4) = 1.e-6
c     if (sscrew(4) .lt. 1.e-8) sscrew(4) = 1.e-8
c     if (sscrew(4) .gt. 1.e-4) sscrew(4) = 1.e-4
c
      sscrew(5) = 4.0
c     if (sscrew(5) .lt. 1.0) sscrew(5) = 1.0
c     if (sscrew(5) .gt. 6.0) sscrew(5) = 6.0
c
      sscrew(6) = 4.0
c     if (sscrew(6) .lt. 0.5) sscrew(6) = 0.5
c     if (sscrew(6) .gt. 1.e+38) sscrew(6) = 1.e+38
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Z parameters.
c
c       zklogu = Threshhold and/or target value for the log number
c                  of moles of a phase; it is used in the following
c                  ways:
c
c                  (1) When the log number of moles of a phase is less
c                  than this value, EQ6 no longer tries to limit the
c                  step size to force the corresponding Taylor's
c                  series to meet the sscrew(1) accuracy criterion.
c                  try to keep the corresponding taylor's series
c                  accurate according to the sscrew(1) criterion.
c
c                  (2) This is the target value employed for the
c                  log number of moles when using Taylor's series
c                  to predict a phase disappearance boundary.
c
c                  (3) In the fluid-centered, flow-through open
c                  system model (iopt(1) = 2), this also determines
c                  (in conjunction with the zkfac parameter, see
c                  below) the maximum number of moles of a phase which
c                  is permitted to re-dissolve. It limits the number
c                  of moles which can be moved from the ES to the PRS
c                  (see zkfac below).
c
c                  Recommended values lie in the range -4.0 to -10.0.
c
c       zklogl = The amount by which the log number of moles of a phase
c                  is decremented by a transfer from the ES to the PRS
c                  in the fluid-centered, flow-through open system
c                  model (iopt(1) = 2). A value of 2.0 means that 99%
c                  of the number of moles is transferred, a value of
c                  3.0, 99.9%. Recommended that values lie in the range
c                  of 2.0 to 4.0.
c
c       zkfac  = Parameter which determines the minimum number of moles
c                  of a phase left in the ES after a shift to the PRS
c                  in the fluid-centered, flow-through open system
c                  model (iopt(1) = 2). This minimum value is calculated
c                  as zkfac*10**zklogu (equivalent to 10**zklgmn, see
c                  below). Recommended values lie in the range 0.9
c                  to 0.98.
c
c       zklgmn = Secondary parameter equivalent to the minimum log
c                  number of moles of a phase left in the ES after a
c                  shift to the PRS in the fluid-centered, flow-through
c                  open system.
c
      zklogu = -7.0
      zklogl = 2.0
      zkfac = 0.98
      zklgmn = tlg(zkfac) + zklogu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The minimum step size. No mechanism for cutting the step size will
c     reduce it to less than this value. Typically, the minimum step
c     size is less than the zero-order step size. It is undesirable to
c     let the minimum step size get too big, as this determines the
c     resolution of certain events of interest (such as hitting a
c     desired pH value at the end of the run). The resolution of events
c     in reaction progress space and time space is not limited by this
c     parameter.
c
      dlxmin = 0.01*dlxmx0
      dlxmin = min(dlxmin,1.e-14)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Upper limit on the step size.
c
      dlxmax = prcinf
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of attempts to slide over a phase boundary.
c
      npslmx = 8
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of attempts to slide over a redox jump.
c
      nsslmx = 8
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine aderiv(akmat0,daffp0,fdaf0,nord,nordmx,npt,
     $ nptmax,nrd1mx)
c
c     This subroutine computes estimates of the derivatives of the phase
c     affinities (affp) from the corresponding finite differences.
c     Note that (daffp0) = (akmat0)(fdaf0).
c
c     Compare with:
c
c       EQ6/bderiv.f
c       EQ6/pderiv.f
c       EQ6/rderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nordmx,nptmax,nrd1mx
c
      integer nord,npt
c
      real*8 akmat0(nrd1mx,nrd1mx),daffp0(nordmx,nptmax),
     $ fdaf0(nordmx,nptmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,np
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
      do np = 1,npt
        do n = 1,nord
          dx = 0.
          do k = n,nord
            dx = dx + fdaf0(k,np)*akmat0(n,k)
          enddo
          daffp0(n,np) = dx
        enddo
      enddo
c
      end

      subroutine gslam(dgpit,dpslm,gpit,ipbtmx,nalpha,napmax,nslt,
     $ nsltmx,pslamn,pslm)
c
c     This subroutine computes the S-lambda coefficients and their
c     ionic strength derivatives. These coefficients are used
c     in Pitzer's equations.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       gpit   = array of values for the g(x) function
c       dgpit  = array of values of the ionic strength derivatives
c                  of g(x)
c       nslt   = number of S-lambda coeffcient parameter sets
c       pslamn = array of S-lambda(n) coefficient parameters
c       nalpha = array that gives the index in the palpha array
c                  corresponding to a given set of S-lambda coefficient
c                  parameters.
c
c     Principal output:
c
c       pslm   = array of the S-lambda functions
c       dpslm  = array of ionic strength derivatives of the
c                  S-lambda functions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,napmax,nsltmx
c
      integer nalpha(nsltmx)
      integer nslt
c
      real(8) dgpit(2,ipbtmx,napmax),dpslm(2,nsltmx),
     $ gpit(ipbtmx,napmax),pslamn(0:ipbtmx,nsltmx),pslm(nsltmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,k,nap,nsl
c
      real(8) dpx,px
c
c----------------------------------------------------------------------
c
      do nsl = 1,nslt
c
        nap = nalpha(nsl)
c
        px = pslamn(0,nsl)
        do i = 1,ipbtmx
          px = px + gpit(i,nap)*pslamn(i,nsl)
        enddo
        pslm(nsl) = px
c
        do k = 1,2
          dpx = 0.
          do i = 1,ipbtmx
            dpx = dpx + dgpit(k,i,nap)*pslamn(i,nsl)
          enddo
          dpslm(k,nsl) = dpx
        enddo
      enddo
c
      end

      subroutine copyaa(array1,array2,nmax)
c
c     This subroutine copies the first nmax elements of the real*8
c     array array1 into the real*8 array array2. Normally, nmax would
c     be the dimension of both arrays. However, nmax could be less
c     than the true dimension. Also, the arrays could actually have
c     more than one dimension. For example, if array1 and array2
c     are really a and b, respectively, having common dimensions of
c     i1 and i2, this subroutine could be used by calling it in the
c     following manner: call copyaa(a,b,(i1*i2)). Use this subroutine
c     with caution if the two arrays do not have identical dimensioning
c     or nmax is not the product of the true (declared) dimensions.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array1 = the first array
c       nmax   = dimension or pseudo-dimension of array1 and array2
c
c     Output:
c
c       array2 = the second array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array1(nmax),array2(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
c-----------------------------------------------------------------------
c
c     Note that the loop is unrolled.
c
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        array2(i) = array1(i)
        array2(i + 1) = array1(i + 1)
        array2(i + 2) = array1(i + 2)
        array2(i + 3) = array1(i + 3)
        array2(i + 4) = array1(i + 4)
        array2(i + 5) = array1(i + 5)
        array2(i + 6) = array1(i + 6)
        array2(i + 7) = array1(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        array2(i) = array1(i)
      enddo
c
      end

      subroutine fpbdpp(delxi,demop0,dlxmin,dxval0,emop,emop0,
     $ eps100,iemop,iodb,iopt,nodbmx,noptmx,nord,nordmx,noutpt,
     $ npet,nrd1mx,npetmx,nptmax,nttyo,uphase,xi0,xi1,xval0)
c
c     This subroutine finds the boundary at which a phase or phases
c     disappear from the equilibrium system (ES). The numbers of moles
c     of phases in the ES are tracked using finite differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,noptmx,nordmx,npetmx,nptmax,nrd1mx
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iodb(nodbmx),iopt(noptmx)
c
      integer nord,npet
c
      character*24 uphase(nptmax)
c
      real*8 demop0(nordmx,npetmx),dxval0(nrd1mx),emop(npetmx),
     $ emop0(npetmx)
c
      real*8 delxi,dlxmin,eps100,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,j2,kpdis,n,np,npe,npedis
c
      integer ilnobl
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxsv,mxx,mxx0,tolsx,xtargv,xval
c
c-----------------------------------------------------------------------
c
      data usearch /'a product phase vanishes                        '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is not where the number of moles is
c     zero, but -eps100. The interval for convergence is (-2*eps100,0.).
c
      ilsign = 1
      xtargv = -eps100
      tolsx = eps100
      dxsv = delxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for product phases vanishing',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Make a Taylor's series expansion of the number of moles of the
c     phases in the ES.
c
      call ptaylr(delxi,demop0,emop0,emop,nord,nordmx,npet,npetmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any disappearing phases. Note that these count only if the
c     predicted number of moles is less than or equal to zero.
c
      xval = 1.0
      npedis = 0
      kpdis = 0
      unam24 = ' '
      do npe = 1,npet
        mxx = emop(npe)
        if (mxx .le. 0) then
          mxx0 = emop0(npe)
          if (mxx.lt.mxx0 .and. mxx0.gt.eps100) then
            kpdis = kpdis + 1
            if (mxx .lt. xval) then
              xval = mxx
              npedis = npe
              np = iemop(npe)
              unam24 = uphase(np)
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kpdis .gt. 0) then
        if (delxi .gt. dlxmin) then
          if (abs(xval - xtargv) .gt. tolsx) then
c
            xval0 = emop0(npedis)
            do n = 1,nord
              dxval0(n) = demop0(n,npedis)
            enddo
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 999
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0 .or. iopt(3).ge.1) then
        if (kpdis .gt. 0) then
          write (noutpt,1010) xi1,delxi
 1010     format(/3x,"Taylor's series predict disappearance of the",
     $    ' following',/3x,'ES phases at Xi= ',1pe11.4,', delxi= ',
     $    e11.4,':',/)
c
          do npe = 1,npet
            mxx = emop(npe)
            if (abs(mxx - xtargv) .le. tolsx) then
              mxx0 = emop0(npe)
              if (mxx.lt.mxx0 .and. mxx0.gt.eps100) then
                np = iemop(npe)
                j2 = ilnobl(uphase(np))
                write (noutpt,1020) uphase(np)(1:j2)
 1020           format(5x,a)
              endif
            endif
          enddo
c
        endif
      endif
c
      if (iopt(3) .ge. 1) delxi = dxsv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine reacts(cbsr,csts,delxi,drer0,iern1,ietmax,iktmax,
     $ iodb,jcode,jetmax,jgext,jreac,modr,modr0,morr,morr0,mrgers,
     $ mtb,mtb0,nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nern1,nern2,nertmx,
     $ netmax,ngext,nodbmx,nord,noutpt,nptmax,nrct,nrctmx,nrd1mx,
     $ nrndex,nsrtmx,nstmax,nsts,nstsmx,nstsr,nttyo,nxridx,nxrtmx,
     $ rrelr0,rxbar,ureac,xirct,xirct0)
c
c     This subroutine computes the destroyed and current masses of the
c     reactants and the current mass balance totals for the equilibrium
c     system.
c
c        morr   = moles of reactant remaining
c        modr   = moles of irreversibly destroyed reactant
c        jreac  = reactant control switch
c           = -1  The reactant has saturated but continues to
c                 be available for irreversible reaction
c           =  0  The reactant is currently reacting
c           =  1  The reactant has been exhausted
c           =  2  The reactant has saturated and any remaining mass
c                 has been transferred to the equilibrium system
c                 (This occurs only if iopt(1) = 0)
c
c     This subroutine is called by:
c
c       EQ6/eqshel.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,jetmax,nbtmax,nbt1mx,nertmx,netmax,nodbmx,
     $ nptmax,nrctmx,nrd1mx,nsrtmx,nstmax,nstsmx,nxrtmx
c
      integer iodb(nodbmx),jcode(nrctmx),jgext(netmax),jreac(nrctmx),
     $ nbaspd(nbtmax),ncmpr(2,nptmax),ngext(jetmax,netmax),
     $ nrndex(nrctmx),nsts(nstsmx),nstsr(2,nstmax),nxridx(nrctmx)
c
      integer iern1,nbt,nern1,nern2,nord,noutpt,nrct,nttyo
c
      character*24 ureac(nrctmx)
c
      real*8 cbsr(nbt1mx,nsrtmx),csts(nstsmx),drer0(nrd1mx,nrctmx),
     $ modr(nrctmx),modr0(nrctmx),morr(nrctmx),morr0(nrctmx),
     $ mrgers(ietmax,jetmax,nertmx),mtb(nbtmax),mtb0(nbtmax),
     $ rrelr0(nrctmx),rxbar(iktmax,nxrtmx),xirct(nrctmx),
     $ xirct0(nrctmx)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,ik,je,j2,n,nb,ne,ner,np,nsr,nrc,nrn1,nrn2,nr1,nr2,
     $ ns,nxr
c
      integer ilnobl
c
      real*8 dlxrct,dmodr,dx
c
c-----------------------------------------------------------------------
c
c     Reset morr, modr, xirct, and mtb to values at the previous step.
c
      do nb = 1,nbt
        mtb(nb) = mtb0(nb)
      enddo
c
      do nrc = 1,nrct
        morr(nrc) = morr0(nrc)
        modr(nrc) = modr0(nrc)
        xirct(nrc) = xirct0(nrc)
      enddo
c
      if (delxi .le. 0.) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Increment morr, modr, xirct, and mtb to correspond to the
c     advance in reaction progress.
c
      if (iodb(1) .ge. 3) write (noutpt,1000)
 1000 format(' --- Advancement of Irreversible Reactions ---',
     $ /7x,'Reaction',14x,'dlxrct',7x,'dmodr')
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1) then
c
          call integr(delxi,dlxrct,drer0,nord,nrc,nrctmx,
     $    nrd1mx,rrelr0)
c
cXX       It is assumed that each reactant has a reaction coefficient
cXX       of -1. Below it is implied that dlxrct is multiplied by -(-1).
c
          dmodr = dlxrct
          if (dmodr .gt. morr(nrc)) then
c
c           The amount destroyed in the current step slightly exceeds
c           the amount remaining.
            dmodr = morr(nrc)
c
cXX         It is assumed that each reactant has a reaction coefficient
cXX         of -1. Below it is implied that dlxrct is multiplied
cXX         by -(-1).
c
            dlxrct = dmodr
          endif
c
          if (iodb(1) .ge. 3) write (noutpt,1010) ureac(nrc),dlxrct,
     $    dmodr
 1010     format(3x,a24,2(3x,1pe12.5))
          if (dlxrct .ne. 0.) then
            xirct(nrc) = xirct(nrc) + dlxrct
            modr(nrc) = modr(nrc) + dmodr
            morr(nrc) = morr(nrc) - dmodr
c
            if (jcode(nrc) .eq. 0) then
c
c             Pure mineral.
c
              np = nrndex(nrc)
              ns = ncmpr(1,np)
              nr1 = nstsr(1,ns)
              nr2 = nstsr(2,ns)
              do n = nr1,nr2
                nb = nsts(n)
                mtb(nb) = mtb(nb) + dmodr*csts(n)
              enddo
c
            elseif (jcode(nrc) .eq. 1) then
c
c             Solid solution.
c
              nxr = nxridx(nrc)
              np = nrndex(nrc)
              nrn1 = ncmpr(1,np)
              nrn2 = ncmpr(2,np)
              ik = 0
              do ns = nrn1,nrn2
                ik = ik + 1
                nr1 = nstsr(1,ns)
                nr2 = nstsr(2,ns)
                dx = dmodr*rxbar(ik,nxr)
                do n = nr1,nr2
                  nb = nsts(n)
                  mtb(nb) = mtb(nb) + dx*csts(n)
                enddo
              enddo
c
            elseif (jcode(nrc) .eq. 2) then
c
c             Special reactant.
c
              nsr = nrndex(nrc)
              do nb = 1,nbt
                mtb(nb) = mtb(nb) + dmodr*cbsr(nb,nsr)
              enddo
c
            elseif (jcode(nrc).eq.3 .or. jcode(nrc).eq.4) then
c
c             Aqueous species or gas.
c
              ns = nrndex(nrc)
              nr1 = nstsr(1,ns)
              nr2 = nstsr(2,ns)
              do n = nr1,nr2
                nb = nsts(n)
                mtb(nb) = mtb(nb) + dmodr*csts(n)
              enddo
c
            elseif (jcode(nrc) .eq. 5) then
c
c             Generic ion exchanger.
c
              ner = nxridx(nrc)
              np = nrndex(nrc)
              ne = np - iern1 + 1
              ns = ncmpr(1,np) - 1
              do je = 1,jgext(ne)
                do ie = 1,ngext(je,ne)
                  dx = dmodr*mrgers(ie,je,ner)
                  ns = ns + 1
                  nr1 = nstsr(1,ns)
                  nr2 = nstsr(2,ns)
                  if (je .le. 1) then
c
c                   Have the first site. Increment the mass balance
c                   totals in a straightforward manner.
c
                    do n = nr1,nr2
                      nb = nsts(n)
                      mtb(nb) = mtb(nb) + dx*csts(n)
                    enddo
                  else
c
c                   Have a site beyond the first. Increment the mass
c                   balance totals in the usual manner, except do not
c                   increment here the total for the exchanger
c                   substrate. The complete increment for the substrate
c                   is obtained by considering only one site.
c
                    do n = nr1,nr2
                      nb = nsts(n)
                      ns = nbaspd(nb)
                      if (ns.lt.nern1 .or. ns.gt.nern2) then
                        mtb(nb) = mtb(nb) + dx*csts(n)
                      endif
                    enddo
                  endif
                enddo
              enddo
            else
              j2 = ilnobl(ureac(nrc))
              write (noutpt,64) jcode(nrc),ureac(nrc)(1:j2)
              write (nttyo,64) jcode(nrc),ureac(nrc)(1:j2)
   64         format(/' * Error - (EQ6/reacts) Programming error',
     $        ' trap: Have unknown',/7x,'reactant type code (jcode)',
     $        ' value of ',i5,' for reactant ',/7x,a,'.')
              stop
            endif
c
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine eqcalc(aamatr,abar,acflg,acflgo,act,actlg,adh,
     $ adhh,adhv,afcnst,alpha,al10,amtb,aphi,apx,avcnst,azero,
     $ a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ beta,betamx,betao,bfje,bfxi,bgamx,bneg,bpx,bsigmm,cco2,
     $ cegexs,cess,cdrs,cdrsd,cdrsx,cdrtw,cdrw,cjbasp,cnufac,conc,
     $ conclg,cpgexs,cscale,csts,delmax,delvco,delvec,dlogxw,
     $ egexjc,egexjf,egexs,eh,ehfac,eps100,farad,fje,fjeo,fo2,
     $ fo2lg,fsort,fugac,fugalg,fxi,fxio,gmmatr,iapxt,ibetmx,ibpxt,
     $ ibswx,idelmx,ielam,ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,
     $ ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,
     $ ilzeta,imrn1,imrn2,insgf,iodb,iopg,iopt,ipch,ipcv,ipivot,
     $ ipndx1,istack,iter,itermx,ixbasp,ixrn1,ixrn2,izmax,jcsort,
     $ jflag,jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jsol,
     $ jssort,jstack,kbt,kction,kdim,kelect,khydr,khydx,km1,kmt,
     $ ko2gaq,krdxsp,kwater,kx1,kxt,loph,losp,lsort,moph,mosp,
     $ mrgexs,mtb,narn1,narn2,narxt,nat,nbasp,nbaspd,nbaspx,nbt,
     $ nbtd,nbw,nchlor,ncmpr,nct,ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,
     $ ndrsrx,nelect,nern1,nern2,ness,nessr,net,nfac,nfrn1,nfrn2,
     $ ngrn1,ngrn2,ngt,nhydr,nhydx,nlrn1,nlrn2,nlt,nmrn1,nmrn2,
     $ nmt,noutpt,no2gaq,nphasx,npt,nrdxsp,nst,nsts,nstsr,ntpr,
     $ nttyo,nxrn1,nxrn2,nxt,omega,omeglg,press,qbassw,qhawep,
     $ qoptmz,qpit75,qredox,q6mode,rhsvec,screwd,sigmam,sigmmo,
     $ smp100,tempc,tempk,tolbt,toldl,ubacmx,ubgamx,ulbeta,uldel,
     $ uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $ xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zvclg1,zvec1)
c
c     This subroutine attempts to calculate the chemical equilibrium
c     state of a system for a pre-defined phase assemblage. Unlike in
c     previous versions of EQ6, this subroutine no longer has the
c     function of determining the actual or most stable phase
c     assemblage. Adjustments to the phase assemblage are now carried
c     out by EQ6/eqphas.f, which as necessary makes repeated calls to
c     the present subroutine. The present subroutine drives
c     EQ6/optmzr.f and EQLIB/newton.f, which respectively carry out
c     pre-Newton-Raphson optimization of starting estimates and hybrid
c     Newton-Raphson iteration.
c
c     Note that there are no attempts in this subroutine to diagnose
c     the cause of any failure to converge. Such a failure might occur,
c     for example, because a phase needs to be deleted from the phase
c     assemblage. It is intended that this subroutine normally be
c     called by EQ6/eqphas.f, which does perform such diagnostics.
c
c     This subroutine is called by:
c
c       EQ6/eqphas.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
c       iter   = the number of hydrbid Newton-Raphson iterations
c                  done by EQLIB/newton.f
c
c       ier    = error flag (returned from EQLIB/newton.f):
c                  =  0  Okay
c                  =  1  Encountered a zero matrix
c                  =  2  Encountered a non-zero, computationally
c                          singular matrix
c                  =  3  Iteration was diverging
c                  =  4  Hit the maximum number of iterations (itermx)
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer nfac(nbtmax)
c
      integer iapxt(nxtmax),ibpxt(nxtmax),ibswx(nbtmax),igstak(ngtmax),
     $ iindx1(kmax),ipndx1(kmax),insgf(natmax),iodb(nodbmx),
     $ iopg(nopgmx),iopt(noptmx),ipivot(kmax),istack(nstmax),
     $ ixbasp(nbtmax),jcsort(nstmax),jflag(nstmax),jgsort(ngtmax),
     $ jgstak(ngtmax),jjsort(nstmax),jpflag(nptmax),jsflag(nstmax),
     $ jsitex(nstmax),jsol(nxtmax),jssort(nstmax),jstack(nstmax),
     $ kction(nbtmax)
c
      integer narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),
     $ ncmpr(2,nptmax),ndrs(ndrsmx),ndrsd(ndrsmx),ndrsx(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrd(2,nstmax),ndrsrx(2,nstmax),ness(nessmx),
     $ nessr(2,nstmax),nphasx(nstmax),nsts(nstsmx),nstsr(2,nstmax)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer ibetmx,idelmx,ielam,ier,igas,ipch,ipcv,iter,itermx,izmax,
     $ kbt,kdim,kelect,khydr,khydx,km1,kmt,ko2gaq,krdxsp,kwater,kx1,
     $ kxt,nbtd,nbw,nchlor,nelect,nhydr,nhydx,no2gaq,nrdxsp,ntpr
c
      logical qbassw,qhawep,qoptmz,qpit75,qredox,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubacmx,ubgamx
      character*24 uphase(nptmax)
      character*8 ulbeta(kmax),uldel(kmax)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),
     $ act(nstmax),actlg(nstmax),alpha(kmax),amtb(nbtmax),
     $ apx(iapxmx,nxtmax),azero(natmax),a3bars(natmax),
     $ beta(kmax),betao(kmax),bpx(ibpxmx,nxtmax),cco2(5),
     $ cegexs(ietmax,jetmax,netmax),cess(nessmx),cdrs(ndrsmx),
     $ cdrsd(ndrsmx),cdrsx(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),conclg(nstmax),
     $ cpgexs(ietmax,jetmax,netmax),cscale(nstmax),
     $ csts(nstsmx),delvco(kmax),delvec(kmax),dlogxw(nbtmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax)
c
      real*8 fsort(ngtmax),fugac(ngtmax),fugalg(ngtmax),
     $ gmmatr(kmax,kmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ moph(nptmax),mosp(nstmax),mrgexs(ietmax,jetmax,netmax),
     $ mtb(nbtmax),rhsvec(kmax),weight(nstmax),wfac(iktmax,nxtmax),
     $ xbar(nstmax),xbarlg(nstmax),zchar(nstmax),zchcu6(nstmax),
     $ zchsq2(nstmax),zvclg1(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,afcnst,al10,avcnst,a3bar,bacfmx,bbig,betamx,bfje,
     $ bfxi,bgamx,bneg,bsigmm,delmax,eh,ehfac,eps100,farad,fje,fjeo,
     $ fo2,fo2lg,fxi,fxio,omega,omeglg,press,screwd,sigmam,sigmmo,
     $ smp100,tempc,tempk,tolbt,toldl,xbarw,xbarwc,xbrwlc,xbrwlg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c
c     Note: the following variables are not used by EQ6 except to
c     satisfy calls to the following subroutines shared with EQ3NR:
c
c       EQLIB/betas.f
c       EQLIB/newton.f
c
c     These subroutines are called directly in this subroutine, and
c     indirectly through EQ6/optmzr.f. Some of these variables are
c     not arrays.
c
      integer isv_nbtmax,isv_ntfxmx
c
      SAVE isv_nbtmax,isv_ntfxmx
c
      integer, dimension(:), allocatable :: ncosp
      integer, dimension(:), allocatable :: ntfx
c
      SAVE ncosp,ntfx
c
      real(8), dimension(:), allocatable :: coval
      real(8), dimension(:), allocatable :: tfx
c
      SAVE coval,tfx
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,kcol,n
c
      integer iebal,irdxc3,nredox,ntfxt
c
      integer ilnobl
c
      logical qblamx,qxbarw
c
      character*48 ubbig,ubetmx,ubneg
      character*8 uaff,umoles,ux8,ux8a,ux8b
c
      real*8 actwlc,screwn,tolxpt,tolbig,tolneg
c
c-----------------------------------------------------------------------
c
      data iebal  /0/
      data irdxc3 /0/
      data nredox /0/
      data ntfxt  /0/
c
      data qxbarw/.false./
c
c-----------------------------------------------------------------------
c
c     Set the screwn parameter.
c
      data screwn /0.10/
c
c-----------------------------------------------------------------------
c
c     The following are tolerance parameters for the optimization
c     carried out by EQ6/optmzr.f. These are convergence tolerances
c     within that subroutine; however, they are used in the present
c     subroutine to determine if pre-Newton-Raphson iteration is
c     necessary.
c
      data tolbig /10.0/,tolneg /-0.9/
      data tolxpt /10.0/
c
c-----------------------------------------------------------------------
c
      data uaff /'aff     '/,umoles /'moles   '/
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(ncosp)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_nbtmax = 0
        isv_ntfxmx = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (nbtmax .ne. isv_nbtmax) then
          DEALLOCATE(ncosp)
          DEALLOCATE(coval)
          isv_nbtmax = 0
        endif
c
        if (ntfxmx .ne. isv_ntfxmx) then
          DEALLOCATE(ntfx)
          DEALLOCATE(tfx)
          isv_ntfxmx = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_nbtmax .eq. 0) then
        ALLOCATE(ncosp(nbtmax))
        ALLOCATE(coval(nbtmax))
        isv_nbtmax = nbtmax
      endif
c
      if (isv_ntfxmx .eq. 0) then
        ALLOCATE(ntfx(ntfxmx))
        ALLOCATE(tfx(ntfxmx))
        isv_ntfxmx = ntfxmx
      endif
c
c     Zero the contents of the local work arrays.
c
      do n = 1,nbtmax
        ncosp(n) = 0
      enddo
c
      do n = 1,nbtmax
        dlogxw(n) = 0.
        coval(n) = 0.
      enddo
c
      do n = 1,ntfxmx
        ntfx(n) = 0
      enddo
c
      do n = 1,ntfxmx
        tfx(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the ulbeta and uldel arrays.
c
      call initcv(ulbeta,kbt,umoles)
      call initcv(uldel,kbt,umoles)
c
      do kcol = km1,kxt
        ulbeta(kcol) = uaff
        uldel(kcol) = umoles
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the qblamx flag, which indicates the presence of solid
c     solutions in the currently specified phase assemblage.
c
      qblamx = kxt .ge. kx1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Expand the system description.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
c     Compute the residual functions prior to iteration.
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qoptmz) then
        if (betamx.gt.tolxpt .or. bbig.gt.tolbig .or. bneg.lt.tolneg)
     $    then
cXXX
c         write (noutpt,3000) betamx,tolxpt
c         write (nttyo,3000) betamx,tolxpt
c3000     format(//' ***** betamx= ',1pe11.4,' and tolxpt= ',1pe11.4,
c    $    ' ****')
c         j2 = ilnobl(ubetmx)
c         write (noutpt,3005) ubetmx(1:j2)
c         write (nttyo,3005) ubetmx(1:j2)
c3005     format('   ***** ubetmx= ',a,' *****',/)
c         write (noutpt,3010) bbig,tolbig
c         write (nttyo,3010) bbig,tolbig
c3010     format(/' ***** bbig= ',1pe11.4,' and tolbig= ',1pe11.4,
c    $    ' ****')
c         j2 = ilnobl(ubbig)
c         write (noutpt,3015) ubbig(1:j2)
c         write (nttyo,3015) ubbig(1:j2)
c3015     format('   ***** ubbig= ',a,' *****',/)
c         write (noutpt,3020) bneg,tolneg
c         write (nttyo,3020) bneg,tolneg
c3020     format(/' ***** bneg= ',1pe11.4,' and tolneg= ',1pe11.4,
c    $    ' ****')
c         j2 = ilnobl(ubneg)
c         write (noutpt,3025) ubneg(1:j2)
c         write (nttyo,3025) ubneg(1:j2)
c3025     format('   ***** ubbneg= ',a,' *****',/)
cXXX
c
c         Optimize the iteration variables before starting hybrid
c         Newton-Raphson iteration. The phase assemblage is fixed
c         in this process.
c
          call optmzr(aamatr,abar,acflg,acflgo,act,actlg,
     $    adh,adhh,adhv,afcnst,al10,alpha,amtb,aphi,avcnst,azero,
     $    a3bar,a3bars,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $    beta,betamx,bgamx,bneg,bpx,cco2,cdrs,cdrsx,cdrtw,cdrw,
     $    cegexs,cgexj,cjbasp,cnufac,conc,conclg,cpgexs,cscale,
     $    csts,coval,delvec,dlogxw,egexjc,egexjf,egexs,ehfac,
     $    eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,fugalg,fxi,fxio,
     $    gmmatr,ibetmx,ibpxt,ibswx,ielam,iern1,iern2,ifcphi1,
     $    ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,
     $    igas,igstak,iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,
     $    ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,insgf,iodb,iopg,
     $    iopt,ipch,ipcv,ipivot,ipndx1,irdxc3,istack,ixbasp,ixrn1,
     $    ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,jgsort,jgstak,
     $    jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,kction,
     $    kdim,kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,loph,losp,
     $    lsort,mgext,moph,mosp,mrgexs,mtb,narn1,narn2,narxt,nat,
     $    nbasp,nbaspd,nbaspx,nbw,nbt,nbtd,nchlor,ncmpr,ncosp,ndrs,
     $    ndrsx,ndrsr,ndrsrd,ndrsrx,nelect,nern1,nern2,net,ngexsa,
     $    nfac,ngext,nhydr,nhydx,ngrn1,ngrn2,ngt,noutpt,no2gaq,
     $    nphasx,npt,nst,nsts,nstsr,ntfx,ntfxt,ntpr,nttyo,omega,
     $    omeglg,press,qbassw,qblamx,qhawep,qpit75,qredox,q6mode,
     $    rhsvec,sigmam,sigmmo,smp100,tempc,tempk,tfx,tolbig,tolneg,
     $    tolxpt,ubacmx,ubbig,ubetmx,ubgamx,ubneg,ugexj,ugexmo,
     $    uphase,uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,
     $    xbrwlc,xbrwlg,zchar,zchcu6,zchsq2,zgexj,zvclg1,zvec1)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do hybrid Newton-Raphson iteration for a given phase assemblage.
c
      if (iodb(4) .ge. 1) then
        write (noutpt,1600)
 1600   format(/,' Starting hybrid Newton-Raphson iteration.',/)
      endif
c
      call newton(aamatr,abar,acflg,acflgo,act,actlg,actwlc,
     $ adh,adhh,adhv,afcnst,alpha,al10,amtb,aphi,azero,a3bar,a3bars,
     $ bacfmx,bbig,beta,betamx,betao,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ bfje,bfxi,bgamx,bneg,bpx,bsigmm,cco2,cdrs,cdrtw,cdrw,cegexs,
     $ cgexj,cjbasp,cnufac,conc,conclg,coval,cpgexs,csts,delam,
     $ delmax,delvco,delvec,dgpit,dlogxw,dpelm,dpslm,dselm,egexjc,
     $ egexjf,egexs,eh,ehfac,elam,eps100,fje,fjeo,fo2,fo2lg,fsort,
     $ fugac,fugalg,fxi,fxio,gmmatr,gpit,ibpxt,idelmx,iebal,ielam,
     $ ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,
     $ ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,insgf,
     $ iodb,iopg,ipivot,ipndx1,irdxc3,istack,iter,itermx,ixbasp,
     $ ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,jgsort,
     $ jgstak,jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,loph,
     $ losp,lsort,mgext,moph,mosp,mrgexs,mtb,nalpha,napt,narn1,
     $ narn2,nbasp,nbt,nbw,nchlor,ncmpr,ncosp,ndrs,ndrsr,nelect,
     $ nern1,nern2,net,ngexsa,ngext,ngrn1,ngrn2,ngt,nhydr,nmut,nmux,
     $ nmxi,nmxx,noutpt,no2gaq,nphasx,npt,nredox,nslt,nslx,nst,nsts,
     $ nstsr,nsxi,nsxx,ntfx,ntfxt,nttyo,omega,omeglg,palpha,pelm,
     $ pmu,press,pslamn,pslm,qhawep,qpit75,qredox,q6mode,rhsvec,
     $ screwd,screwn,selm,sigmam,sigmmo,tempk,tfx,tolbt,toldl,ubacmx,
     $ ubbig,ubetmx,ubgamx,ubneg,ugexj,ugexmo,ulbeta,uldel,uphase,
     $ uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,xbrwlc,
     $ xbrwlg,xlke,xlks,zchar,zchsq2,zchcu6,zgexj,zvclg1,zvec1)
c
      if (ier .gt. 0) then
        if (iodb(4) .gt. 0) then
          write (noutpt,1610)
 1610     format(/' * Note - (EQ6/eqcalc) Hybrid Newton-Raphson',
     $    ' iteration failed.')
          ux8a = ' '
          write (ux8a,'(i7)') iter
          call lejust(ux8a)
          j2 = ilnobl(ux8a)
          if (ier. eq. 1) then
            write (noutpt,1630) ux8a(1:j2)
 1630       format(7x,'after ',a,' iterations because a zero matrix',
     $      ' was encountered. This is',/7x,'probably due to a',
     $      ' programming error.')
          elseif (ier .eq. 2) then
            write (noutpt,1640) ux8a(1:j2)
 1640       format(7x,'after ',a,' iterations because a non-zero,',
     $      ' computationally singular',/7x,'matrix was encountered.')
          elseif (ier .eq. 3) then
            write (noutpt,1650) ux8a(1:j2)
 1650       format(7x,'after ',a,' iterations because the code',
     $      ' detected that',/7x,'iteration was diverging.')
          elseif (ier .eq. 4) then
            write (noutpt,1660) ux8a(1:j2)
 1660       format(7x,'after ',a,' iterations because the maximum',
     $      ' number of iterations',/7x,'was done.')
          else
            ux8b = ' '
            write (ux8b,'(i7)') ier
            call lejust(ux8b)
            j3 = ilnobl(ux8b)
            write (noutpt,1670) ux8a(1:j2),ux8b(1:j3)
 1670       format(7x,'after ',a,' iterations because an unknown event',
     $      ' occurred. The ier',/7x,'error code has the unknown value',
     $      ' ',a,'. This condition is a',/7x,'programming error.')
          endif
        endif
        go to 999
      endif
c
      if (iodb(4) .ge. 1) then
        ux8 = ' '
        write (ux8,'(i7)') iter
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1690) ux8(1:j2)
 1690   format('   Done. Hybrid Newton-Raphson iteration converged in ',
     $  a,' iterations.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine evdat2(arr,narxmx,narxt,ntpr,ntprmx,prop,tempc)
c
c     This subroutine evaluates a thermodynamic property as a function
c     of temperature, using an interpolating polynomial whose
c     coefficients are stored in a 2D array arr. The second dimension
c     of this array corresponds to a temperature range.
c
c     Compare with EQLIB/evdat3.f, in which arr is a 3D array, and
c     EQLIB/evdat4.f, in which this is a 4D array.
c
c     This subroutine is called by:
c
c       EQLIB/alters.f
c       EQLIB/evdata.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       arr    = two dimensional array of polynomial coefficients
c                  describing some thermodynamic function
c       tempc  = temperature, C
c       ntpr   = temperature range flag
c       narxmx = first dimension of the arr array, the maximum number
c                  of coefficients per temperature range
c       narxt  = array of numbers of coefficients in temperature
c                  ranges
c       ntprmx = second dimension of the arr array, the number
c                  of temperature ranges.
c
c     Principal output:
c
c       prop   = the calculated property
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ntprmx
c
      integer narxt(ntprmx)
c
      integer ntpr
c
      real*8 arr(narxmx,ntprmx)
      real*8 prop,tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nn,nt
c
c-----------------------------------------------------------------------
c
c     Evaluate the polynomial.
c
      prop = 0.
      nt = narxt(ntpr)
      do nn = 1,nt
        n = nt + 1 - nn
        prop = arr(n,ntpr) + tempc*prop
      enddo
c
      end

      subroutine mdrgex(adhfs,adhfsd,adhfsx,advfs,advfsd,advfsx,
     $ axhfs,axhfsd,axhfsx,axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx,
     $ cdrs,cdrsd,cdrsx,ipch,ipchmx,ipcv,ipcvmx,narxmx,nbasp,nbaspd,
     $ nbtmax,ndrs,ndrsd,ndrsx,ndrsmx,ndrsr,ndrsrd,ndrsrx,nern1,
     $ nern2,noutpt,nst,nstmax,ntprmx,nttyo)
c
c     This subroutine folds the reactions and reaction properties for
c     generic ion exchangers into the 'd' set. This is generally done
c     after those reactions and properties have been manipulated.
c
c     Note that the modified arrays must first be written into a set
c     of scratch arrays. This is because the ion exchanger sections
c     must generally go in the middle of the new arrays, and their
c     lengths are generally such that the positioning of the start of
c     the terminal "unmodified" sections is modified.
c
c     This subroutine is called by:
c
c       EQLIB/chsgex.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adhfs  = standard array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfs  = standard array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfs  = standard array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlks  = standard array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfs  = standard array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrs   = standard array of reaction coefficients
c       narxmx = number of coefficient elements of axlks per species
c                  per temperature range
c       nbtmax = maximum number of basis species
c       ndrs   = standard  array of indices of species corresponding to
c                  reaction coefficients
c       ndrsr  = standard pointer array for indices of species appearing
c                  in reactions
c       nstmax = maximum number of species
c       ntprmx = maximum number of temperature ranges
c
c     Principal output:
c
c       adhfsd = 'data file' array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfsd = 'data file' array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfsd = 'data file' array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlksd = 'data file' array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfsd = 'data file' array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrsd  = 'data file' array of reaction coefficients
c       ndrsd  = 'data file'  array of indices of species corresponding
c                  to reaction coefficients
c       ndrsrd = 'data file' pointer array for indices of species
c                  appearing in reactions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer noutpt,nttyo
c
      integer nbasp(nbtmax),nbaspd(nbtmax),ndrs(ndrsmx),ndrsd(ndrsmx),
     $ ndrsx(ndrsmx),ndrsr(2,nstmax),ndrsrd(2,nstmax),ndrsrx(2,nstmax)
c
      integer ipch,ipcv,nern1,nern2,nst
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsd(narxmx,ntprmx,nstmax),
     $ axhfsx(narxmx,ntprmx,nstmax),axlks(narxmx,ntprmx,nstmax),
     $ axlksd(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsd(narxmx,ntprmx,nstmax),
     $ axvfsx(narxmx,ntprmx,nstmax),cdrs(ndrsmx),cdrsd(ndrsmx),
     $ cdrsx(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j,jhmax,jvmax,j2,j3,n,nmax,nb,nn,nr1,nr2,ns,nt
c
      integer ilnobl
c
      character*8 ux8a,ux8b
c
c-----------------------------------------------------------------------
c
      nmax = narxmx*ntprmx*(nern1 -1)
      jhmax = narxmx*ntprmx*ipchmx*(nern1 -1)
      jvmax = narxmx*ntprmx*ipcvmx*(nern1 -1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Coefficients for equilibrium constants.
c
      if (nern1 .gt. 1) call copyaa(axlksd,axlksx,nmax)
c
      do ns = nern1,nern2
        do j = 1,ntprmx
          do i = 1,narxmx
            axlksx(i,j,ns) = axlks(i,j,ns)
          enddo
        enddo
      enddo
c
      if (nern2 .lt. nst) then
        do ns = nern2 + 1,nst
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = axlksd(i,j,ns)
            enddo
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Coefficients related to enthalpy.
c
      if (ipch .ge. 0) then
c
c       Coefficients for enthalpy functions.
c
        if (nern1 .gt. 1) call copyaa(axhfsd,axhfsx,nmax)
c
        do ns = nern1,nern2
          do j = 1,ntprmx
            do i = 1,narxmx
              axhfsx(i,j,ns) = axhfs(i,j,ns)
            enddo
          enddo
        enddo
c
        if (nern2 .lt. nst) then
          do ns = nern2 + 1,nst
            do j = 1,ntprmx
              do i = 1,narxmx
                axhfsx(i,j,ns) = axhfsd(i,j,ns)
              enddo
            enddo
          enddo
        endif
c
        if (ipch .ge. 1) then
c
c         Coefficients for derivatives of enthalpy functions.
c
          if (nern1 .gt. 1) call copyaa(adhfsd,adhfsx,jhmax)
c
          do ns = nern1,nern2
            do ipc = 1,ipchmx
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
                enddo
              enddo
            enddo
          enddo
c
          if (nern2 .lt. nst) then
            do ns = nern2 + 1,nst
              do ipc = 1,ipchmx
                do j = 1,ntprmx
                  do i = 1,narxmx
                    adhfsx(i,j,ipc,ns) = adhfsd(i,j,ipc,ns)
                  enddo
                enddo
              enddo
            enddo
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Coefficients related to volume.
c
      if (ipcv .ge. 0) then
c
c         Coefficients for volume functions.
c
        if (nern1 .gt. 1) call copyaa(axvfsd,axvfsx,nmax)
c
        do ns = nern1,nern2
          do j = 1,ntprmx
            do i = 1,narxmx
              axvfsx(i,j,ns) = axvfs(i,j,ns)
            enddo
          enddo
        enddo
c
        if (nern2 .lt. nst) then
          do ns = nern2 + 1,nst
            do j = 1,ntprmx
              do i = 1,narxmx
                axvfsx(i,j,ns) = axvfsd(i,j,ns)
              enddo
            enddo
          enddo
        endif
c
        if (ipcv .ge. 1) then
c
c         Coefficients for derivatives of volume functions.
c
          if (nern1 .gt. 1) call copyaa(advfsd,advfsx,jvmax)
c
          do ns = nern1,nern2
            do ipc = 1,ipcvmx
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
                enddo
              enddo
            enddo
          enddo
c
          if (nern2 .lt. nst) then
            do ns = nern2 + 1,nst
              do ipc = 1,ipcvmx
                do j = 1,ntprmx
                  do i = 1,narxmx
                    advfsx(i,j,ipc,ns) = advfsd(i,j,ipc,ns)
                  enddo
                enddo
              enddo
            enddo
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index range pointers for reactions.
c
      if (nern1 .gt. 1) then
        nmax = 2*(nern1 - 1)
        call copyia(ndrsrd,ndrsrx,nmax)
      endif
c
      do ns = nern1,nern2
        ndrsrx(1,ns) = ndrsr(1,ns)
        ndrsrx(1,ns) = ndrsr(1,ns)
      enddo
c
      if (nern2 .lt. nst) then
        do ns = nern2 + 1,nst
          ndrsrx(1,ns) = ndrsrd(1,ns)
          ndrsrx(1,ns) = ndrsrd(1,ns)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reaction coefficients and indices of associated species.
c
      nt = 0
      if (nern1 .gt. 1) nt = ndrsrd(2,nern1 - 1)
      if (nern2 .ge. nern1)
     $  nt = nt + ndrsr(2,nern2) - ndrsr(1,nern1) + 1
      if (nst .gt. nern2)
     $ nt = nt + ndrsrd(2,nst) - ndrsrd(1,nern2 + 1) + 1
c
      if (nt .gt. ndrsmx) then
        write (ux8a,'(i5)') ndrsmx
        write (ux8b,'(i5)') nt
        j2 = ilnobl(ux8a)
        j3 = ilnobl(ux8b)
        write (noutpt,1000) ux8a(1:j2),ux8b(1:j3)
        write (nttyo,1000)  ux8a(1:j2),ux8b(1:j3)
 1000   format(/' * Error - (EQLIB/mdrgex.f) Have insufficient array',
     $  ' space to expand the',/7x,'reaction coefficient arrays to',
     $  ' accommodate changes to the',/7x,'ion exchanger section',
     $  " of the 'd' set of reaction data. Increase",/7x,'the',
     $  ' dimensioning parameter ndrspa from ',a,' to at least ',
     $  a,'.')
        stop
      endif
c
      if (nern1 .gt. 1) then
        nmax = ndrsrd(2,nern1 - 1)
        call copyaa(cdrsd,cdrsx,nmax)
        call copyia(ndrsd,ndrsx,nmax)
      endif
c
      if (nern1 .gt. 1) then
        nn = ndrsrd(2,nern1 - 1)
      else
        nn = 0
      endif
      do ns = nern1,nern2
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        do n = nr1,nr2
          nn = nn + 1
          ndrsx(nn) = ndrs(n)
          cdrsx(nn) = cdrs(n)
        enddo
      enddo
c
      nn = ndrsrx(2,nern2)
      do ns = nern2 + 1,nst
        nr1 = ndrsrd(1,ns)
        nr2 = ndrsrd(2,ns)
        do n = nr1,nr2
          nn = nn + 1
          ndrsx(nn) = ndrsd(n)
          cdrsx(nn) = cdrsd(n)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nb = 1,nbtmax
        ns = nbasp(nb)
        if (ns.ge.nern1 .and. ns.le.nern2) nbaspd(nb) = nbasp(nb)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the scratch arrays into the corresponding 'd' set arrays.
c
c     Copy the new reactions in the 'x' set into the standard arrays
c     in the 'd' set.
c
c     Calling sequence substitutions:
c       adhfsd for adhfs
c       advfsd for advfs
c       axhfsd for axhfs
c       axlksd for axlks
c       axvfsd for avhfs
c       cdrsd for cdrs
c       ndrsd for ndrs
c       ndrsrd for ndrsr
c
      call cdrscx(adhfsd,adhfsx,advfsd,advfsx,axhfsd,axhfsx,axlksd,
     $ axlksx,axvfsd,axvfsx,cdrsd,cdrsx,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,ndrsd,ndrsmx,ndrsx,ndrsrd,ndrsrx,nstmax,ntprmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine combmb(cdrs,iindx1,ipndx1,jflag,kbt,kdim,km1,kmax,
     $ kmt,kx1,kxt,mtb,mtbaq,ndrsmx,nbasp,nbt,nbtmax,ndrs,ndrsr,
     $ noutpt,nstmax,nttyo,uspec,uzvec1,zvclg1,zvec1)
c
c     This subroutine combines mass balances totals so that the total
c     mass of an active auxiliary basis species whose jflag value
c     is 30 is combined into the total masses of the other basis
c     species which appear in its reaction. This species is then
c     removed from the active basis set.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,ndrsmx,nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),ipndx1(kmax),jflag(nstmax),nbasp(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer kbt,kdim,km1,kmt,kx1,kxt,nbt
c
      character*48 uspec(nstmax),uzvec1(kmax)
c
      real*8 cdrs(ndrsmx),mtb(nbtmax),mtbaq(nbtmax),zvclg1(kmax),
     $ zvec1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensions.
c
      integer isv_kmax
c
      SAVE isv_kmax
c
      integer, dimension(:), allocatable :: iindxs,ipndxs
c
      SAVE iindxs,ipndxs
c
      real(8), dimension(:), allocatable :: zvclgs
c
      SAVE zvclgs
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,k,kbts,km1s,kmts,krow,kx1s,kxts,n,nb,nbb,nerr,np,
     $ nr1,nr2,ns,nss,nt
c
      integer nbasis
c
      character*56 uspn56
c
      real*8 cx,mx,lx
c
      real*8 texp
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(iindxs)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(iindxs,ipndxs,zvclgs)
          isv_kmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(iindxs(kmax),ipndxs(kmax))
        ALLOCATE(zvclgs(kmax))
        isv_kmax = kmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        iindxs(k) = 0
        ipndxs(k) = 0
      enddo
c
      do k = 1,kmax
        zvclgs(k) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nerr = 0
      kbts = kbt
      km1s = km1
      kmts = kmt
      kx1s = kx1
      kxts = kxt
c
      do krow = 1,kdim
        iindxs(krow) = iindx1(krow)
        ipndxs(krow) = ipndx1(krow)
        zvclgs(krow) = zvclg1(krow)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kbt = 0
      do krow = 1,kbts
        nb = iindxs(krow)
        np = ipndxs(krow)
        ns = nbasp(nb)
        if (jflag(ns) .eq. 0) then
          kbt = kbt + 1
          uzvec1(kbt) = uspec(ns)
          iindx1(kbt) = nb
          ipndx1(kbt) = np
          zvclg1(kbt) = zvclgs(krow)
        else
          nr1 = ndrsr(1,ns)
          nr2 = ndrsr(2,ns)
          nt = nr2 - nr1 + 1
          if (nt .lt. 2) then
c
c           Calling sequence substitutions:
c             uspec(ns) for unam48
c
            call fmspnm(jlen,uspec(ns),uspn56)
            write (noutpt,1000) uspn56(1:jlen),jflag(ns)
            write (nttyo,1000) uspn56(1:jlen),jflag(ns)
 1000       format(/' * Error- (combmb) The species ',a,
     $      /7x,'has jflag value of ',i2,", but it's a strict basis",
     $      ' species.',/7x,"Its mass balance can't be combined into",
     $      ' that of another basis species.')
            nerr = nerr + 1
            go to 100
          endif
          do n = nr1 + 1,nr2
            cx = -cdrs(n)/cdrs(nr1)
            nss = ndrs(n)
c
c           Calling sequence substitutions:
c             nss for ns
c
            nbb = nbasis(nbasp,nbt,nbtmax,nss)
            mtb(nbb) = mtb(nbb) + cx*mtb(nb)
            mtbaq(nbb) = mtbaq(nbb) + cx*mtbaq(nb)
          enddo
          mtb(nb) = 0.
          mtbaq(nb) = 0.
        endif
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kdim = kbt
      km1 = kdim + 1
      kmt = kdim
      if (kmts .ge. km1s) then
        do krow = km1s,kmts
          kmt = kmt + 1
          ns = iindxs(krow)
          uzvec1(kmt) = uspec(ns)
          iindx1(kmt) = ns
          ipndx1(kmt) = ipndxs(krow)
          zvclg1(kmt) = zvclgs(krow)
        enddo
        kdim = kmt
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kx1 = kdim + 1
      kxt = kdim
      if (kxts .ge. kx1s) then
        do krow = kx1s,kxts
          kxt = kxt + 1
          ns = iindxs(krow)
          uzvec1(kxt) = uspec(ns)
          iindx1(kxt) = ns
          ipndx1(kxt) = ipndxs(krow)
          zvclg1(kxt) = zvclgs(krow)
        enddo
        kdim = kxt
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do krow = 1,kdim
        lx = zvclg1(krow)
        mx = texp(lx)
        zvec1(krow) = mx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
      end

      subroutine dfbasp(nbaspa,nbta,nbta_asv,ndrsa,ndrsa_asv,ndrsra,
     $ nerr,noutpt,nsta,nsta_asv,nttyo,ubasp,uspeca)
c
c     This subroutine decodes the ubasp array (list of basis species
c     names built while reading the data file). It puts their
c     species indices in the nbaspa array. The basis indices that
c     were put in the ndrsa array are replaced by the corresponding
c     species indices. The working basis set may be subsequently
c     expanded when the input file is interpreted, as any species
c     on the input file that is referenced as a basis species is
c     added to that set if not already in it.
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbta_asv,ndrsa_asv,nsta_asv
c
      integer nbaspa(nbta_asv),ndrsa(ndrsa_asv),ndrsra(2,nsta_asv)
      integer nbta,nerr,noutpt,nsta,nttyo
c
      character*48 ubasp(nbta_asv),uspeca(nsta_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,n,nb,ns,nr1,nr1p1,nr2,nt
c
      character*56 uspn56
c
c-----------------------------------------------------------------------
c
c     Set up the nbaspa array and expand the elements of the ubasp array
c     to the full 48 characters.
c
      do nb = 1,nbta
        do ns = 1,nsta
          if (uspeca(ns)(1:24) .eq. ubasp(nb)(1:24)) then
            nbaspa(nb) = ns
            ubasp(nb)(1:48) = uspeca(ns)(1:48)
            go to 105
          endif
        enddo
c
        nbaspa(nb) = 0
c
c       Calling sequence substitutions:
c         ubasp(nb) for unam48
c
        call fmspnm(jlen,ubasp(nb),uspn56)
        write (noutpt,1000) uspn56(1:jlen)
        write (nttyo,1000) uspn56(1:jlen)
 1000   format(/" * Error - (EQLIB/dfbasp) Couldn't find a basis",
     $  ' species named',/7x,a,' among the species read from the',
     $  ' data file.',/7x,'It must be referenced erroneously in',
     $  ' the associated reaction',/7x,'for another species.')
        nerr = nerr + 1
  105   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Convert basis species indices in the ndrsa array to species
c     indices.
c
      do ns = 1,nsta
        nt = ndrsra(2,ns) - ndrsra(1,ns) + 1
        if (nt .ge. 2) then
          nr1 = ndrsra(1,ns)
          nr1p1 = nr1 + 1
          nr2 = ndrsra(2,ns)
          do n = nr1p1,nr2
            nb = ndrsa(n)
            ndrsa(n) = nbaspa(nb)
          enddo
        endif
      enddo
c
      end

      subroutine adprpl(actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,
     $ dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxpll,dlxplo,dlxprl,dlxprn,dlxdmp,
     $ eh,eh0plo,eh0prn,eh1plo,eh1prn,fo2lg,fxprpl,o20plo,o20prn,
     $ o21plo,o21prn,ph,ph0plo,ph0prn,ph1plo,ph1prn,qplaw0,qplaw1,
     $ qpleh0,qpleh1,qplolt,qplolx,qplott,qplotx,qplo20,qplo21,
     $ qplph0,qplph1,qpraw0,qpraw1,qpreh0,qpreh1,qprnlx,qprnlt,
     $ qprntx,qprntt,qpro20,qpro21,qprph0,qprph1,qredox,time1,
     $ tiplol,tiplot,tiprnl,tiprnt,xidump,xiplol,xiplot,xiprnl,
     $ xiprnt,xi1)
c
c     This subroutine adjusts print, plot, and PRS transfer points
c     as needed for the next step along the reaction path.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      logical qplaw0,qplaw1,qpleh0,qpleh1,qplolt,qplolx,qplott,qplotx,
     $ qplo20,qplo21,qplph0,qplph1,qpraw0,qpraw1,qpreh0,qpreh1,qprnlx,
     $ qprnlt,qprntx,qprntt,qpro20,qpro21,qprph0,qprph1,qredox
c
      real*8 actw,aw0plo,aw0prn,aw1plo,aw1prn,dlaplo,dlaprn,dleplo,
     $ dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,
     $ dlxpll,dlxplo,dlxprl,dlxprn,dlxdmp,eh,eh0plo,eh0prn,eh1plo,
     $ eh1prn,fo2lg,fxprpl,o20plo,o20prn,o21plo,o21prn,ph,ph0plo,
     $ ph0prn,ph1plo,ph1prn,time1,tiplol,tiplot,tiprnl,tiprnt,xidump,
     $ xiplol,xiplot,xiprnl,xiprnt,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 tolx,tx,xx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Reset print points as necessary.
c
      if (qprntx) then
        tolx = fxprpl*dlxprn
  100   xiprnt = xiprnt + dlxprn
        if ((xi1 + tolx) .ge. xiprnt) go to 100
      endif
c
      if (qprntt) then
        tolx = fxprpl*dlxprn
  110   tiprnt = tiprnt + dltprn
        if ((time1 + tolx) .ge. tiprnt) go to 110
      endif
c
      if (qprnlx) then
        tolx = fxprpl*dlxprl
  120   xiprnl = texp(tlg(xiprnl) + dlxprl)
        xx = texp(tlg(xi1) + tolx)
        if (xx .ge. xiprnl) go to 120
      endif
c
      if (qprnlt) then
        tolx = fxprpl*dltprl
  130   tiprnl = texp(tlg(tiprnl) + dltprl)
        tx = texp(tlg(time1) + tolx)
        if (tx .ge. tiprnl) go to 130
      endif
c
      if (qprph0) then
        tolx = fxprpl*dlhprn
  140   ph0prn = ph0prn - dlhprn
        if ((ph - tolx) .le. ph0prn) go to 140
        ph1prn = ph0prn
  150   ph1prn = ph1prn + dlhprn
        if ((ph + tolx) .ge. ph1prn) go to 150
      endif
c
      if (qprph1) then
        tolx = fxprpl*dlhprn
  160   ph1prn = ph1prn + dlhprn
        if ((ph + tolx) .ge. ph1prn) go to 160
        ph0prn = ph1prn
  170   ph0prn = ph0prn - dlhprn
        if ((ph - tolx) .le. ph0prn) go to 170
      endif
c
      if (qredox) then
        if (qpreh0) then
          tolx = fxprpl*dleprn
  180     eh0prn = eh0prn - dleprn
          if ((eh - tolx) .le. eh0prn) go to 180
          eh1prn = eh0prn
  190     eh1prn = eh1prn + dleprn
          if ((eh + tolx) .ge. eh1prn) go to 190
        endif
c
        if (qpreh1) then
          tolx = fxprpl*dleprn
  200     eh1prn = eh1prn + dleprn
          if ((eh + tolx) .ge. eh1prn) go to 200
          eh0prn = eh1prn
  210     eh0prn = eh0prn - dleprn
          if ((eh - tolx) .le. eh0prn) go to 210
        endif
c
        if (qpro20) then
          tolx = fxprpl*dloprn
  220     o20prn = o20prn - dloprn
          if ((fo2lg - tolx) .le. o20prn) go to 220
          o21prn = o20prn
  230     o21prn = o21prn + dloprn
          if ((fo2lg + tolx) .ge. o21prn) go to 230
        endif
c
        if (qpro21) then
          tolx = fxprpl*dloprn
  240     o21prn = o21prn + dloprn
          if ((fo2lg + tolx) .ge. o21prn) go to 240
          o20prn = o21prn
  250     o20prn = o20prn - dloprn
          if ((fo2lg - tolx) .le. o20prn) go to 250
        endif
c
      endif
c
      if (qpraw0) then
        tolx = fxprpl*dlaprn
  260   aw0prn = aw0prn - dlaprn
        if ((actw - tolx) .le. aw0prn) go to 260
        aw1prn = aw0prn
  270   aw1prn = aw1prn + dlaprn
        if ((actw + tolx) .ge. aw1prn) go to 270
      endif
c
      if (qpraw1) then
        tolx = fxprpl*dlaprn
  280   aw1prn = aw1prn + dlaprn
        if ((actw + tolx) .ge. aw1prn) go to 280
        aw0prn = aw1prn
  290   aw0prn = aw0prn - dlaprn
        if ((actw - tolx) .le. aw0prn) go to 290
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset plot points as necessary.
c
      if (qplotx) then
        tolx = fxprpl*dlxplo
  400   xiplot = xiplot + dlxplo
        if ((xi1 + tolx)  .ge. xiplot) go to 400
      endif
c
      if (qplott) then
        tolx = fxprpl*dltplo
  410   tiplot = tiplot + dltplo
        if ((time1 + tolx)  .ge. tiplot) go to 410
      endif
c
      if (qplolx) then
        tolx = fxprpl*dlxpll
  420   xiplol = texp(tlg(xiplol) + dlxpll)
        xx = texp(tlg(xi1) + tolx)
        if (xx  .ge. xiplol) go to 420
      endif
c
      if (qplolt) then
        tolx = fxprpl*dltpll
  430   tiplol = texp(tlg(tiplol) + dltpll)
        tx = texp(tlg(time1) + tolx)
        if (tx .ge. tiplol) go to 430
      endif
c
      if (qplph0) then
        tolx = fxprpl*dlhplo
  440   ph0plo = ph0plo - dlhplo
        if ((ph - tolx) .le. ph0plo) go to 440
        ph1plo = ph0plo
  450   ph1plo = ph1plo + dlhplo
        if ((ph + tolx) .ge. ph1plo) go to 450
      endif
c
      if (qplph1) then
        tolx = fxprpl*dlhplo
  460   ph1plo = ph1plo + dlhplo
        if ((ph + tolx) .ge. ph1plo) go to 460
        ph0plo = ph1plo
  470   ph0plo = ph0plo - dlhplo
        if ((ph - tolx) .le. ph0plo) go to 470
      endif
c
      if (qredox) then
        if (qpleh0) then
          tolx = fxprpl*dleplo
  480     eh0plo = eh0plo - dleplo
          if ((eh - tolx) .le. eh0plo) go to 480
          eh1plo = eh0plo
  490     eh1plo = eh1plo + dleplo
          if ((eh + tolx) .ge. eh1plo) go to 490
        endif
c
        if (qpleh1) then
          tolx = fxprpl*dleplo
  500     eh1plo = eh1plo + dleplo
          if ((eh + tolx) .ge. eh1plo) go to 500
          eh0plo = eh1plo
  510     eh0plo = eh0plo - dleplo
          if ((eh - tolx) .le. eh0plo) go to 510
        endif
c
        if (qplo20) then
          tolx = fxprpl*dloplo
  520     o20plo = o20plo - dloplo
          if ((fo2lg - tolx) .le. o20plo) go to 520
          o21plo = o20plo
  530     o21plo = o21plo + dloplo
          if ((fo2lg + tolx) .ge. o21plo) go to 530
        endif
c
        if (qplo21) then
          tolx = fxprpl*dloplo
  540     o21plo = o21plo + dloplo
          if ((fo2lg + tolx) .ge. o21plo) go to 540
          o20plo = o21plo
  550     o20plo = o20plo - dloplo
          if ((fo2lg - tolx) .le. o20plo) go to 550
        endif
c
      endif
c
      if (qplaw0) then
        tolx = fxprpl*dlaplo
  560   aw0plo = aw0plo - dlaplo
        if ((actw - tolx) .le. aw0plo) go to 560
        aw1plo = aw0plo
  570   aw1plo = aw1plo + dlaplo
        if ((actw + tolx) .ge. aw1plo) go to 570
      endif
c
      if (qplaw1) then
        tolx = fxprpl*dlaplo
  580   aw1plo = aw1plo + dlaplo
        if ((actw + tolx) .ge. aw1plo) go to 580
        aw0plo = aw1plo
  590   aw0plo = aw0plo - dlaplo
        if ((actw - tolx) .le. aw0plo) go to 590
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the PRS transfer point as necessary.
c
      if (xidump. le. xi1) then
        tolx = fxprpl*dlxdmp
  700   xidump = xidump + dlxdmp
        if ((xi1 + tolx)  .ge. xidump) go to 700
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine aaaelg(ustelg,uveelg)
c
c     EQLIBG: EQ3/6 Library - Activity Coefficients
c     EQ3/6 version 8.0a R43a (Patched 10/01/2009)
c
c     Last revised 04/24/02 by TJW
c
c
c     Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The Regents of
c     the University of California, Lawrence Livermore National
c     Laboratory. All rights reserved.
c
c     This work was produced at the University of California,
c     Lawrence Livermore National Laboratory (UC LLNL) under
c     contract no. W-7405-ENG-48 between the U.S. Department of
c     Energy (DOE) and The Regents of the University of California
c     (University) for the operation of UC LLNL. Copyright is
c     reserved to the University for purposes of controlled
c     dissemination, commercialization through formal licensing,
c     or other disposition under terms of Contract 48; DOE
c     policies, regulations, and orders; and U.S. statutes.
c
c
c                            DISCLAIMER
c
c     This computer code was prepared as an account of work
c     sponsored by an agency of the United States Government.
c     Neither the United States Government nor the University of
c     California nor any of their employees, makes any warranty,
c     express or implied, or assumes any liability or responsibility
c     for the accuracy, completeness, or usefulness of any
c     information, apparatus, product, or process disclosed, or
c     represents that its use would not infringe privately-owned
c     rights. Reference herein to any specific commercial products,
c     process, or service by trade name, trademark, manufacturer,
c     or otherwise, does not necessarily constitute or imply its
c     endorsement, recommendation, or favoring by the United States
c     Government or the University of California. The views and
c     opinions of authors expressed herein do not necessarily state
c     or reflect those of the United States government or the
c     University of California, and shall not be used for
c     advertising or product endorsement purposes.
c
c
c-----------------------------------------------------------------------
c
c     See the readme.txt file that came with this software for further
c     information, including contact information and references.
c
c
c-----------------------------------------------------------------------
c
c     This library supports the EQ3NR and EQ6 codes. It contains
c     subroutines that deal with calculations specific to activity
c     coefficient models. The EQLIB library contains all other
c     subroutines that address elements of geochemical modeling
c     calculations that are common to EQ3NR and EQ6. The EQLIBU
c     library contains subroutines with generic utility and
c     mathematical functions.
c
c-----------------------------------------------------------------------
c
c     This subroutine is designed to ensure that the copyright statement
c     and legal and other disclaimers appear at the beginning of the
c     concatenated source code for EQLIBG. Concatenation is normally
c     alphabetical, hence the form of the name. This subroutine is
c     generally called by the main program of any code that utilizes
c     subroutines from this library. It returns the stage and version
c     numbers of this library.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       ustelg = EQLIBG stage number
c       uveelg = EQLIBG version number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*8 ustelg,uveelg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*8 ust,uve
c
c-----------------------------------------------------------------------
c
      data ust /'R43a    '/
      data uve /'8.0a    '/
c
c-----------------------------------------------------------------------
c
      ustelg = ust
      uveelg = uve
c
      end

      subroutine rdpni(abeta,ipbtmx,jpfcmx,nat,natmax,ndat0s,nerr,
     $ noutpt,npxni,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,zaqsp)
c
c     This subroutine reads from the DATA1 file the coefficients
c     required to compute those Pitzer interaction parameters
c     associated with neutral-cation (nc) and neutral-anion (na)
c     pairs. This particular set of interaction coefficients
c     includes the following:
c
c       1. lambda(nc), lambda(na)
c
c     Coefficients required to compute Pitzer interaction coefficients
c     associated with other pair types or with triplets are not read
c     by this subroutine. This subroutine is one of several that
c     replace rdpz2.f and rdpz3.f.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c
c     Principal output:
c
c       abeta  = array of coefficients for computing beta parameters
c       nerr   = cumulative error counter
c       npxni  = the number of nc and na pairs for which Pitzer
c                  parameters were read from the data file
c       npx2t  = the number of pairs of all species types for which
c                  Pitzer parameters were read from the data file.
c       nwarn  = cumulative warning counter
c       uaqsp  = array of names of aqueous species
c       upair  = array of species names for species pairs
c       uaqsp  = array of electrical charge numbers of aqueous species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,npx2mx
c
      integer ndat0s,noutpt,nttyo
c
      integer nat,nerr,npxni,npx2t,nwarn
c
      character(len=24) uaqsp(natmax),upair(2,npx2mx)
c
      real(8) abeta(jpfcmx,0:ipbtmx,npx2mx),zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,iz1,iz2,j,j2,j3,j4,j5,j6,npx2,npx2te,n1,n2
c
      integer ilnobl
c
      character(len=80) udastr,uline,ux80
      character(len=24) unam1,unam2,ux24a,ux24b
      character(len=24) uhdni,uhdnxt
      character(len=16) ustr16
      character(len=8) uterm,ux8
c
      real(8) var,z1,z2
c
c-----------------------------------------------------------------------
c
      data uterm  /'+-------'/
      data uhdni  /"nc and na combinations: "/
      data uhdnxt /"nn combinations: lambda("/
c
c-----------------------------------------------------------------------
c
      npx2te = npx2t
      npx2 = npx2te
      j2 = 0
      j3 = 0
c
c     Advance to the start of the superblock for these parameters.
c
  100 read (ndat0s,1000,end=990,err=995) uline
 1000 format(a80)
      if (uline(1:24) .ne. uhdni(1:24)) go to 100
c
c     Skip the terminator.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the names of the species comprising a pair.
c
  110 read (ndat0s,1010,end=990,err=995) unam1,unam2
 1010 format(a24,2x,a24)
c
      if (unam1(1:24) .eq. uhdnxt(1:24)) then
c
c       Found the header for the next superblock of Pitzer parameters.
c       Back up one line and terminate reading the current superblock.
c
        npxni = npx2 - npx2t
        npx2t = npx2
        backspace(ndat0s)
        go to 999
      endif
c
      npx2 = npx2 + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up some string data for error messages.
c
      j2 = ilnobl(unam1)
      if (j2 .le. 0) then
        unam1 = '<blank>'
        j2 = ilnobl(unam1)
      endif
c
      j3 = ilnobl(unam2)
      if (j3 .le. 0) then
        unam2 = '<blank>'
        j3 = ilnobl(unam2)
      endif
c
      write (ux8,'(i5)') npx2
      call lejust(ux8)
      j4 = ilnobl(ux8)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for blank names.
c
      if (j2.le.0 .or. j3.le.0) then
        write (noutpt,1020) ux8(1:j4),unam1(1:j2),unam2(1:j3)
        write (nttyo,1020) ux8(1:j4),unam1(1:j2),unam2(1:j3)
 1020   format(/' * Error - (EQPT/rdpni) Have encountered a blank',
     $  ' species name',/7x,'in the species pair for block ',a,
     $  ' of the superblock for',/7x,'Pitzer nc and na parameter data.',
     $  ' The offending pair shows as ',a,', ',a,'.')
c
        if (npx2 .gt. (npx2te + 1)) then
          ux24a = upair(1,npx2 - 1)
          ux24b = upair(2,npx2 - 1)
          if (ux24a(1:7).ne.'<blank>' .or.
     $      ux24b(1:7).ne.'<blank>') then
            j5 = ilnobl(ux24a)
            j6 = ilnobl(ux24b)
            write (noutpt,1030) ux24a(1:j5),ux24b(1:j6)
            write (nttyo,1030) ux24a(1:j5),ux24b(1:j6)
 1030       format(7x,'This block follows the one for ',a,
     $      ', ',a,'.')
          endif
        endif
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of the two species (n1, n2). These
c     indices point to the data read from the previously
c     read species blocks.
c
c     Calling sequence substitutions:
c       n1 for na
c       unam1 for unams
c
      call gspidx(ier,n1,nat,natmax,uaqsp,unam1)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>') then
          write (noutpt,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3)
          write (nttyo,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3)
 1100     format(/' * Error - (EQPT/rdpni) The aqueous species ',
     $    a,' appearing in',/7x,'the Pitzer nc and na parameter data',
     $    ' block for the species pair',/7x,a,', ',a,' does not',
     $    ' appear in an aqueous species',/7x,'data block.')
          nerr = nerr + 1
        endif
      endif
c
c     Calling sequence substitutions:
c       n2 for na
c       unam2 for unams
c
      call gspidx(ier,n2,nat,natmax,uaqsp,unam2)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>') then
          write (noutpt,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3)
          write (nttyo,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3)
          nerr = nerr + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for illegal appearance of solvent water.
c
      if (unam1(1:4).eq.'H2O ' .or. unam2(1:4).eq.'H2O ' .or.
     $  n1.eq.1 .or. n2.eq.1) then
        write (noutpt,1200) unam1(1:j2),unam2(1:j3)
        write (nttyo,1200) unam1(1:j2),unam2(1:j3)
 1200   format(/' * Error - (EQPT/rdpni) Have found an illegal',
     $  ' data block for the',/7x,'species pair ',a,', ',a,
     $  ' in the superblock of Pitzer data',/7x,"for nc and na",
     $  ' pairs. Solvent water may not appear in such a pair.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the electrical charges of the species.
c
      z1 = 0.
      z2 = 0.
      iz1 = 0
      iz2 = 0
      if (n1 .gt. 0) then
        z1 = zaqsp(n1)
        iz1 = nint(z1)
      endif
      if (n2 .gt. 0) then
        z2 = zaqsp(n2)
        iz2 = nint(z2)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (n1.gt.0 .and. n2.gt.0) then
c
c       Make sure that the species pair is appropriate for the
c       current superblock. It must be of type nc or na. Other
c       pair types such as ca, cc', aa', nn, and nn' are not
c       permitted here.
c
        if ((iz1.eq.0 .and. iz2.eq.0) .or.
     $    (iz1.ne.0 .and. iz2.ne.0)) then
c
c         The current data block is in the wrong superblock.
c
          write (noutpt,1230) unam1(1:j2),unam2(1:j3)
          write (nttyo,1230) unam1(1:j2),unam2(1:j3)
 1230     format(/' * Error - (EQPT/rdpni) Have found an',
     $    ' illegal data block for the',/7x,'species pair ',
     $    a,', ',a,' in the',/7x,'superblock of Pitzer data for',
     $    " nc and na pairs.",/7x,'The present pair',
     $    ' type may not appear in the current superblock.')
          nerr = nerr + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species pair storage rules:
c
c       1. neutral < cation < anion
c
c       2. If both species are of the same charge type,
c          store alphabetically.
c
c     Here: the neutral comes first.
c
      if (iz1 .eq. 0) then
c
c       The first species is the neutral.
c
        upair(1,npx2) = unam1
        upair(2,npx2) = unam2
      else
c
c       The second species is the neutral.
c
        upair(1,npx2) = unam2
        upair(2,npx2) = unam1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the coefficients for the lambda(nc) and lambda(na)
c     parameters. Store the lambda data as beta(0) data.
c
c     Check the required parameter header.
c
      read (ndat0s,1000,end=990,err=995) uline
      j4 = ilnobl(uline)
      j4 = min(j4,70)
      ux80 = uline
      call lejust(ux80)
      ustr16 = 'lambda'
      j5 = 6
      if (ux80(1:j5) .ne. ustr16(1:j5)) then
        write (noutpt,1330) uline(1:j4),ustr16(1:j5),unam1(1:j2),
     $  unam2(1:j3)
        write (nttyo,1330) uline(1:j4),ustr16(1:j5),unam1(1:j2),
     $  unam2(1:j3)
 1330   format(/' * Error - (EQPT/rdpni) Have found a line',
     $  ' starting with:',/7x,'"',a,'"',/7x,'where "',a,'" was',
     $  ' expected in the block for the species',/7x,'pair ',
     $  a,', ',a,' in the superblock of Pitzer data',
     $  /7x,"for nc and na pairs.")
        nerr = nerr + 1
        go to 999
      endif
c
c     Read the coefficients for the associated temperature function.
c
      do j = 1,jpfcmx
        read (ndat0s,1000,end=990,err=995) uline
        j4 = ilnobl(uline)
        j4 = min(j4,70)
        ux80 = uline
        call lejust(ux80)
        ustr16 = 'a  ='
        j5 = 4
        write (ustr16(2:2),'(i1)') j
        if (ux80(1:j5) .eq. ustr16(1:j5)) then
          udastr = ux80
          udastr(1:j5) = ' '
          call g1dat(ier,noutpt,nttyo,udastr,var)
          if (ier .gt. 0) then
            write (noutpt,1320) uline(1:j4),unam1(1:j2),unam2(1:j3)
            write (nttyo,1320) uline(1:j4),unam1(1:j2),unam2(1:j3)
 1320       format(/' * Error - (EQPT/rdpni) Have found a line',
     $      ' starting with:',/7x,'"',a,'"',/7x,'containing an',
     $      ' expected numerical field that could not be read.',
     $      /7x,'This occurred in the block for the species pair',
     $      /7x,a,', ',a,' in the superblock of Pitzer data',
     $      /7x,"for nc and na pairs.")
            nerr = nerr + 1
            go to 999
          endif
          abeta(j,0,npx2) = var
        else
          write (noutpt,1330) uline(1:j4),ustr16(1:j5),unam1(1:j2),
     $    unam2(1:j3)
          write (nttyo,1330) uline(1:j4),ustr16(1:j5),unam1(1:j2),
     $    unam2(1:j3)
          nerr = nerr + 1
          go to 999
        endif
      enddo
c
c     Skip past the block delimiter line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
      if (uline(1:8) .ne. uterm(1:8)) then
        j4 = ilnobl(uline)
        j4 = min(j4,70)
        write (noutpt,1470) uline(1:j4),unam1(1:j2),unam2(1:j3)
        write (nttyo,1470) uline(1:j4),unam1(1:j2),unam2(1:j3)
 1470   format(/' * Error - (EQPT/rdpni) Have found a line starting',
     $  ' with:',/7x,'"',a,'"',/7x,' in the data block for the species',
     $  ' pair ',a,', ',a,' in the',/7x,'superblock of Pitzer data for',
     $  " nc and na pairs. Should have",/7x,'found the',
     $  ' delimiter line marking the end of the block.')
        nerr = nerr + 1
        go to 999
      endif
c
c     Process the next data block.
c
      go to 110
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/rdpni) Unexpectedly encountered',
     $ /7x,"an end-of-file error while reading the nc and na",
     $ /7x,'(lambda) superblock of the DATA0 file.')
      stop
c
  995 write (noutpt,2020)
      write (nttyo,2020)
 2020 format(/' * Error - (EQPT/rdpni) Encountered a read format',
     $ /7x,"error while reading the nc and na (lambda) superblock",
     $ /7x,'of the DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine realch(noutpt,nttyo,ustr,var)
c
c     This subroutine converts writes the real*8 variable var into the
c     string ustr, employing left justification and blank fill. If
c     right justification is desired, one should just write the
c     real*8 variable into the string.
c
c     The length of the string variable is unknown. A buffer variable
c     which is employed has a character length of ichpar. This limits
c     the size of the substring available for the input real*8 number.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c       var   = the input real*8 number
c
c     Output:
c
c       ustr   = the string variable in which the integer is to
c                  be written
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      character*(*) ustr
c
      real*8 var
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
      integer ichpar
c
      parameter (ichpar = 24)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ilen,j2
c
      integer ilnobl
c
      character*(ichpar) ux
c
c-----------------------------------------------------------------------
c
c     Write the real*8 number into a character variable buffer.
c
      write (ux,1000,err = 100) var
c
c     The format below should specify a real*8 field which matches
c     the character length of the buffer variable (ichpar).
c
 1000 format(g24.4)
      go to 110
c
  100 write (noutpt,1010) var
      write (nttyo ,1010) var
 1010 format(/" * Error - (EQLIBU/realch) Can't write the real*8",
     $ /7x,'number ",g24.4," into a character string due to formatted',
     $ /7x,'write error.')
      stop
c
c     Left justify.
c
  110 call lejust(ux)
c
c     Get the length of the real*8 string.
c
      j2 = ilnobl(ux)
c
c     Get the length of the string variable.
c
      ilen = len(ustr)
c
      if (j2 .gt. ilen) then
        write (noutpt,1020) var,j2,ilen
        write (nttyo ,1020) var,j2,ilen
 1020   format(/" * Error - (EQLIBU/realch) Can't write the real*8",
     $ /7x,'number "',g24.4,'" into a string because the number',
     $ /7x,'requires',i3,' characters. The string variable',
     $ ' has only ',i3,' characters.')
        stop
      endif
c
c     Load the string.
c
      ustr = ux(1:j2)
c
      end

      subroutine wr3pkw(electr,cgexj,ietmax,iopg,jetmax,jflgi,
     $ jgext,kbt,kct,kdim,kmax,kmt,kxmod,kxt,mtbi,mtbaqi,mwtges,
     $ nbti,nbtmax,net,netmax,newin,ngexrt,nobswt,nopgmx,nsbswt,
     $ ntitl2,ntitmx,nxmdmx,nxmod,qgexsh,pressi,tempci,tgexp,
     $ ubmtbi,ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,usbsw,utitl2,
     $ uvfgex,uxkgex,uxmod,uzveci,xhfgex,xlkgex,xlkmod,xvfgex,
     $ zgexj,zvclgi)
c
c     This subroutine writes the pickup file in compact ("W") format.
c     This file is used to communicate data from EQ3NR to EQ6 (it
c     comprises the bottom half of an EQ6 input file).
c
c     This subroutine is a near clone of parts of XCON6/wr6w8.f and
c     EQ6/wr6pkw.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/wr3pkd.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,netmax,nopgmx,ntitmx,nxmdmx
c
      integer newin
c
      integer iopg(nopgmx),jgext(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ngexrt(jetmax,netmax)
c
      integer kbt,kct,kdim,kmt,kxt,nbti,net,nobswt,nsbswt,ntitl2,nxmod
c
      logical qgexsh
c
      character(len=80) utitl2(ntitmx)
      character(len=56) ugexr(ietmax,jetmax,netmax)
      character(len=48) ubmtbi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uxmod(nxmdmx),uzveci(kmax)
      character(len=24) ugexmo(netmax),ugexp(netmax)
      character(len=8) ugexj(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real(8) cgexj(jetmax,netmax),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),tgexp(netmax),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zgexj(jetmax,netmax),zvclgi(kmax)
c
      real(8) electr,pressi,tempci
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,je,j2,j3,j4,kcol,kprs,krow,n,nbi,ne
c
      integer ilnobl
c
      character(len=8) uendit
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     The items in this block correspond to things defined in the
c     first part of XCON6/wr6w8.f or EQ6/wr6pkw.f.
c
      j3 = ilnobl(uendit)
c
c     Comment header for iopt, iopr, iodb, and iopg option switches.
c
 1200 format('*',15x,'1    2    3    4    5    6    7    8    9   10')
c
 1020 format(a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Old title.
c
      write (newin,2590)
 2590 format('* Title of previous run')
c
      do n = 1,ntitl2
        j2 = ilnobl(utitl2(n))
        write (newin,1020) utitl2(n)(1:j2)
      enddo
      if (ntitl2 .lt. ntitmx) write (newin,1020) uendit(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,2610)
 2610 format('* Special basis switches')
c
      write (newin,2630) nsbswt
 2630 format(4x,'nsbswt= ',i3)
c
      do n = 1,nsbswt
        j2 = ilnobl(usbsw(1,n))
        write (newin,2650) usbsw(1,n)(1:j2)
 2650   format('species= ',a)
        j2 = ilnobl(usbsw(2,n))
        write (newin,2670) usbsw(2,n)(1:j2)
 2670   format(2x,'switch with= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      write (newin,2680)
 2680 format('* Original temperature and pressure')
      write (newin,2690) tempci
 2690 format(4x,'tempci= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      write (newin,2710) pressi
 2710 format(4x,'pressi= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,2790)
 2790 format('* Ion exchangers')
c
      write (newin,2810) net
 2810 format(7x,'net= ',i3)
c
      do ne = 1,net
        j2 = ilnobl(ugexp(ne))
        write (newin,2840) ugexp(ne)(1:j2)
 2840   format(5x,'ugexp= ',a)
c
        write (newin,2860) mwtges(ne)
 2860   format(4x,'mwtges= ',1pe12.5)
c
        j3 = ilnobl(ugexmo(ne))
        write (newin,2870) ugexmo(ne)(1:j3)
 2870   format(4x,'ugexmo= ',a)
c
        write (newin,2880) tgexp(ne)
 2880   format(5x,'tgexp= ',1pe12.5)
c
        write (newin,2900) jgext(ne)
 2900   format(5x,'jgext= ',i3)
c
        do je = 1,jgext(ne)
          j3 = ilnobl(ugexj(je,ne))
          write (newin,2940) ugexj(je,ne)(1:j3)
 2940     format(5x,'ugexj= ',a)
c
          write (newin,2960) cgexj(je,ne),zgexj(je,ne)
 2960     format(5x,'cgexj= ',1pe12.5,5x,'zgexj= ',e12.5)
c
          write (newin,3010) ngexrt(je,ne)
 3010     format(4x,'ngexrt= ',i3)
c
          do n = 1,ngexrt(je,ne)
            j2 = ilnobl(ugexr(n,je,ne))
            write (newin,3040) ugexr(n,je,ne)(1:j2)
 3040       format(5x,'ugexr= ',a)
            j4 = ilnobl(uxkgex(n,je,ne))
            write (newin,3060) xlkgex(n,je,ne),uxkgex(n,je,ne)(1:j4)
 3060       format(4x,'xlkgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uhfgex(n,je,ne))
            write (newin,3070) xhfgex(n,je,ne),uhfgex(n,je,ne)(1:j4)
 3070       format(4x,'xhfgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uvfgex(n,je,ne))
            write (newin,3080) xvfgex(n,je,ne),uvfgex(n,je,ne)(1:j4)
 3080       format(4x,'xvfgex= ',1pe12.5,5x,'units= ',a)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
      write (newin,3110)
 3110 format('* Alter/suppress options')
c
      write (newin,3130) nxmod
 3130 format(5x,'nxmod= ',i2)
c
c     Nxmod options.
c
      do n = 1,nxmod
        j2 = ilnobl(uxmod(n))
        write (newin,3160) uxmod(n)(1:j2),kxmod(n),xlkmod(n)
 3160   format(3x,'species= ',a,
     $  /4x,'option= ',i2,14x,'xlkmod= ',1pe12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,3172)
 3172 format('* Iopg options')
      write (newin,1200)
c
      write (newin,3180) (iopg(i), i = 1,20)
 3180 format(2x,'iopg1-10= ',10i5,/1x,'iopg11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      write (newin,3210)
 3210 format('* Matrix index limits')
c
      kprs = 0
      write (newin,3230) kct,kbt,kmt,kxt,kdim,kprs
 3230 format(7x,'kct= ',i2,17x,'kbt= ',i2,17x,'kmt= ',i2,/
     $ 7x,'kxt= ',i2,16x,'kdim= ',i2,16x,'kprs= ',i2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
c       ubmtbi = names of the data file basis species for which mass
c                  balances are defined
c       jflgi  = jflag input for basis species
c          0 = Retain as an active basis species
c         30 = Convert to a dependent species; fold the mass balance
c                total for this species into the mass balance totals
c                of basis species which remain active
c
      write (newin,3330)
 3330 format('* Data file basis species and jflgi values')
c
      do nbi = 1,nbti
        write (newin,3350) ubmtbi(nbi),jflgi(nbi)
 3350   format(3x,a48,3x,i2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
      write (newin,3400)
 3400 format('* Mass balance totals (ES and aqueous solution)')
c
      do nbi = 1,nbti
        write (newin,3420) mtbi(nbi),mtbaqi(nbi)
 3420   format(3x,1pe25.15,3x,e25.15)
      enddo
c
      write (newin,3440) electr
 3440 format(9x,'Electrical imbalance= ',1pe25.15)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,3450)
 3450 format('* Ordinary basis switches')
c
      write (newin,3460) nobswt
 3460 format(4x,'nobswt= ',i3)
c
      do n = 1,nobswt
        j2 = ilnobl(uobsw(1,n))
        write (newin,2650) uobsw(1,n)(1:j2)
        j2 = ilnobl(uobsw(2,n))
        write (newin,2670) uobsw(2,n)(1:j2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables.
c
      write (newin,3470)
 3470 format('* Matrix species or entities')
c
      do krow = 1,kdim
        j2 = ilnobl(uzveci(krow))
        write (newin,3490) uzveci(krow)(1:j2)
 3490   format(3x,a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix variable values.
c
      write (newin,3510)
 3510 format('* Values of matrix variables')
c
      do kcol = 1,kdim
        write (newin,3530) zvclgi(kcol)
 3530   format(3x,1pe22.15)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The is no PRS in EQ3NR, so the block of data for phases and
c     species in the PRS is not written here.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gntpr(ntpr,ntprmx,ntprt,tempc,tempcu)
c
c     This subroutine finds the value of ntpr, the temperature range
c     flag.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ntprt  = the number of temperature ranges
c       tempc  = temperature, C
c       tempcu = array of temperatures, C, defining the upper boundaries
c                  of the temperature ranges
c
c     Principal output:
c
c       ntpr   = temperature range flag
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ntprmx
c
      integer ntpr,ntprt
c
      real*8 tempcu(ntprmx)
c
      real*8 tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
c     Determine the temperature range flag (ntpr).
c
      do ntpr = 1,ntprt
        if (tempc .le. tempcu(ntpr)) go to 100
      enddo
      ntpr = ntprt
  100 continue
c
      end

      subroutine tprnn(abeta,acphi,alamnn,innpr,in2pr,ipbtmx,
     $ jpfcmx,natmax,ncvnn,nerr,nnnpr,nn2pr,noutpt,npx2mx,npx2t,
     $ nttyo,nwarn,pcvnn,qpdnn,qpdn2,uaqsp,upair)
c
c     Test and process the Pitzer data for nn' (neutral, different
c     neutral) pairs read from the DATA0 file. Find and flag errors,
c     such as duplication of data (e.g., two data blocks for the same
c     nn' pair). The conventional primitive Pitzer parameters are
c     identical to the observable parameters read from the data file:
c
c       lambda(nn') -> lambda(nn')
c
c     Check the coverage of entered Pitzer data against all possible
c     nn' pairs that can be composed of the neutral species present
c     on the data file.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,nnnpr,nn2pr,npx2mx
c
      integer noutpt,nttyo
c
      integer innpr(2,nnnpr),in2pr(nn2pr)
c
      integer ncvnn,nerr,npx2t,nwarn
c
      logical qfound1,qfound2
c
      logical qpdnn(nnnpr),qpdn2(nn2pr)
c
      character(len=24) uaqsp(natmax),upair(2,npx2mx)
c
      real*8 abeta(jpfcmx,0:ipbtmx,npx2mx),acphi(jpfcmx,npx2mx),
     $ alamnn(jpfcmx,0:ipbtmx,nnnpr)
c
      real*8 pcvnn
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c-----------------------------------------------------------------------
c
      integer i,ii,j,jp,jpair,j2,j3,j4,j5,n,ncount,ndupl,nlistl,
     $ nn,nodatc
c
      integer ilnobl
c
      character*56 ustr56
      character*24 unam1,unam2
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Limit on the list of pairs for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the data arrays.
c
      do n = 1,nnnpr
        qpdnn(n) = .false.
        do j = 1,jpfcmx
          do i = 0,ipbtmx
            alamnn(j,i,n) = 0.
          enddo
        enddo
      enddo
c
c     Check the entered data for nn' pairs.
c
      nodatc = 0
c
      do n = 1,nnnpr
        i = innpr(1,n)
        j = innpr(2,n)
        unam1 = uaqsp(i)
        unam2 = uaqsp(j)
        j2 = ilnobl(unam1)
        j3 = ilnobl(unam2)
c
c       Search for unam1, unam2 in the upair array.
c       That array corresponds to the species pairs blocks.
c
        call srch22(jpair,unam1,unam2,upair,npx2mx,npx2t)
c
        if (jpair .gt. 0) then
c
c         Have found an entry.
c
          qpdnn(n) = .true.
c
c         Store the data.
c
          do j = 1,jpfcmx
            do i = 0,ipbtmx
              alamnn(j,i,n) = abeta(j,i,jpair)
            enddo
          enddo
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jp = jpair + 1,npx2t
            if (unam1(1:24) .eq. upair(1,jp)(1:24)) then
              if (unam2(1:24) .eq. upair(2,jp)(1:24)) then
                ndupl = ndupl + 1
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam2(1:j3)
              write (nttyo,1010) unam1(1:j2),unam2(1:j3)
 1010         format(/' * Error - (EQPT/tprnn) Have found a',
     $        ' duplicate data block on the DATA0 file',
     $        /7x,"for the nn' pair ",a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j5 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
              write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
 1020         format(/' * Error - (EQPT/tprnn) Have found ',a,
     $        ' duplicate data blocks on the DATA0 file',
     $        /7x,"for the nn' pair ",a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
        else
c
c         No data block was found on the DATA0 file.
c         Note that qpdnn(n) is left with a value of .false.
c
          nodatc = nodatc + 1
        endif
c
c       Check for the presence of the corresponding lamda(nn),
c       and lambda(n'n') data. The presence of these data on
c       the  data file is required.
c
        qfound1 = .false.
c
        do nn = 1,nn2pr
          ii = in2pr(nn)
          if (uaqsp(ii)(1:24) .eq. unam1(1:24)) then
            if (qpdn2(nn)) then
              qfound1 = .true.
              go to 130
            endif
          endif
        enddo
  130   continue
c
        qfound2 = .false.
c
        do nn = 1,nn2pr
          ii = in2pr(nn)
          if (uaqsp(ii)(1:24) .eq. unam2(1:24)) then
            if (qpdn2(nn)) then
              qfound2 = .true.
              go to 140
            endif
          endif
        enddo
  140   continue
c
        if (qpdnn(n) .and. .not.(qfound1 .and. qfound2)) then
c
c         Certain required data were not found on the DATA0 file.
c
          write (noutpt,1030) unam1(1:j2),unam2(1:j3)
          write (nttyo,1030) unam1(1:j2),unam2(1:j3)
 1030     format(/' * Error - (EQPT/tprnn) Have data on the DATA0',
     $    " file for the nn'",/7x,'pair ',a,', ',a,', but',
     $    " don't have the",/7x,'required data for the following',
     $    ' neutral-neutral pair(s):',/)
c
          if (.not.qfound1) then
            write (noutpt,1040) unam1(1:j2),unam1(1:j2)
            write (nttyo,1040) unam1(1:j2),unam1(1:j2)
 1040       format(9x,a,', ',a)
          endif
c
          if (.not.qfound2) then
            write (noutpt,1040) unam2(1:j3),unam2(1:j3)
            write (nttyo,1040) unam2(1:j3),unam2(1:j3)
          endif
c
          nerr = nerr + 1
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1050)
        write (nttyo,1050)
 1050   format(/' * Warning - (EQPT/tprnn) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  " nn' pairs:",/)
c
        ncount = 0
        do n = 1,nnnpr
          if (.not.qpdnn(n)) then
            ncount = ncount + 1
            i = innpr(1,n)
            j = innpr(2,n)
            unam1 = uaqsp(i)
            unam2 = uaqsp(j)
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            ustr56 = unam1(1:j2) // ', ' // unam2(1:j3)
            j4 = ilnobl(ustr56)
            write (noutpt,1060) ustr56(1:j4)
            write (nttyo,1060) ustr56(1:j4)
 1060       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1070) ux8(1:j3)
          write (nttyo,1070) ux8(1:j3)
 1070     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1080)
        write (nttyo,1080)
 1080   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvnn = nnnpr - nodatc
      pcvnn = (100.*ncvnn)/float(nnnpr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine betacf(acflg,acflgo,bacfmx,nst,nstmax,ubacmx,uspec)
c
c     This subroutine finds the activity coefficient residual with
c     the largest magnitude (bacfmx). The range of activity coefficient
c     residuals covers all species.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       uspec  = name array for aqueous species
c       acflg  = array of current values of the log activity
c                  coefficients
c       acflgo = array of the previous values of the log activity
c                  coefficients
c
c     Principal output:
c
c       bacfmx = the largest activity coefficient residual
c       ubacmx = the name of the species with the largest activity
c                  coefficient residual is bacfmx
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer nst
c
      character*48 uspec(nstmax),ubacmx
c
      real*8 acflg(nstmax),acflgo(nstmax)
      real*8 bacfmx
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,ns
c
      character*48 ux48
c
      real*8 adacfl,bx
c
c-----------------------------------------------------------------------
c
c     Note the use of local variables (bx and ux48) within the loop.
c     Note also that the loop is unrolled.
c
      bacfmx = 0.
      ubacmx = 'None'
      bx = 0.
      ux48 = 'None'
      ileft = (nst/8)*8
c
      do ns = 1,ileft,8
        adacfl = abs(acflg(ns) - acflgo(ns))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns)
        endif
        adacfl = abs(acflg(ns + 1) - acflgo(ns + 1))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 1)
        endif
        adacfl = abs(acflg(ns + 2) - acflgo(ns + 2))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 2)
        endif
        adacfl = abs(acflg(ns + 3) - acflgo(ns + 3))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 3)
        endif
        adacfl = abs(acflg(ns + 4) - acflgo(ns + 4))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 4)
        endif
        adacfl = abs(acflg(ns + 5) - acflgo(ns + 5))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 5)
        endif
        adacfl = abs(acflg(ns + 6) - acflgo(ns + 6))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 6)
        endif
        adacfl = abs(acflg(ns + 7) - acflgo(ns + 7))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns + 7)
        endif
      enddo
c
      do ns = ileft + 1,nst
        adacfl = abs(acflg(ns) - acflgo(ns))
        if (adacfl .gt. bx) then
          bx = adacfl
          ux48 = uspec(ns)
        endif
      enddo
c
      bacfmx = bx
      ubacmx = ux48
c
      end

      module mod6pt
c
c     This module contains data required to evaluate Pitzer's
c     equations. It excludes the variables and arrays that belong
c     to the 'a' set, which includes all the Pitzer data as read
c     from the data file. Included here are the "compressed"
c     equivalents.
c
c     Integer scalars.
c
      integer napt,nmut,nslt
c
cxx    integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
cxx  $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
c     Integer arrays. This are basically index arrays that allow
c     for efficient storage of the data.
c
      integer, dimension(:), allocatable :: nalpha
      integer, dimension(:,:), allocatable :: nmux,nmxi,nmxx,nslx,
     $ nsxi,nsxx
c
c     Coefficients for calculating empirical interaction coefficients
c     as functions of temperature and pressure.
c
      real(8), dimension(:,:), allocatable :: amu
      real(8), dimension(:,:,:), allocatable :: aslm
c
c     Empirical interaction coefficients and related functions at
c     temperature and pressure.
c
      real(8), dimension(:), allocatable :: pmu,pslm
      real(8), dimension(:,:), allocatable :: dpslm,gpit,palpha,pslamn
      real(8), dimension(:,:,:), allocatable :: dgpit
c
c     Theoretical higher-order electrostatic interaction coefficients
c     and related functions at temperature and pressure.
c
      real(8), dimension(:,:), allocatable :: elam,pelm
      real(8), dimension(:,:,:), allocatable :: delam,dpelm
c
      real(8), dimension(:), allocatable :: selm
      real(8), dimension(:,:), allocatable :: dselm
c
      end module mod6pt

      subroutine gcdrtw(cdrs,cdrtw,narn1,narn2,ndrs,ndrsmx,ndrsr,
     $ nelect,no2gaq,nst,nstmax)
c
c     This subroutine computes the cdrtw array. Each element of this
c     array contains the sum of the reaction coefficients of the
c     aqueous solute species in the corresponding reaction. The sum
c     represents the number of times that the number of moles of
c     solvent water is implicitly represented in the reaction via
c     solute molalities. Note that generic ion exchanger species do
c     not count in these calculations, even though molalities can
c     be calculated for such species. That is because their
c     thermodynamic activities are defined by mole fractions.
c
c     Do not confuse this array with the cdrw array computed by
c     EQLIB/gcdrw.f. The present array is really only used by
c     EQ6. It presently exists in EQ3NR only for the sake of
c     consistency.
c
c     This subroutine is called by:
c
c       EQLIB/absswa.f
c       EQ3NR/eq3nr.f
c       EQ6/path.f
c       EQ6/absswb.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer narn1,narn2,nelect,no2gaq,nst
c
      real*8 cdrs(ndrsmx),cdrtw(nstmax)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nn,nr1,nr2,ns
c
      real*8 cx
c
c----------------------------------------------------------------------
c
      do ns = 1,nst
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        cx = 0.
        do n = nr1,nr2
          nn = ndrs(n)
          if (nn.gt.narn1 .and. nn.le.narn2) then
            if (nn.ne.no2gaq .and. nn.ne.nelect) cx = cx + cdrs(n)
          endif
        enddo
        cdrtw(ns) = cx
      enddo
c
      end

      subroutine autosw(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $ axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ibswx,iindx1,
     $ ipch,ipchmx,ipcv,ipcvmx,jflag,jsflag,kbt,kmax,narn1,narxmx,
     $ nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,
     $ ndrsrx,noutpt,nst,nstmax,ntprmx,nttyo,qbassw,uspec,uzvec1)
c
c     This subroutine executes automatic basis switching for the purpose
c     of reducing mass balance residuals. EQLIB/fbassw.f finds
c     candidates for basis switching, and EQLIB/gabswx.f resolves any
c     conflicts.
c
c     This subroutine is called by:
c
c       EQLIB/absswa.f
c       EQ6/absswb.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       axlks  = array of polynomial coefficients for computing log K
c                  values (altered by this subroutine)
c       ibswx  = array defining switches to be made
c       nbasp  = array defining the species in the basis set
c                  (altered by this subroutine)
c       nbaspd = array defining the species in the data file basis set
c
c     Principal output:
c
c       axlks  = array of polynomial coefficients for computing log K
c                  values
c       cdrs   = array of reaction coefficients
c       nbasp  = array defining the species in the basis set
c       ndrs   = array of species indices corresponding to the reaction
c                  coefficients in the cdrs array
c       ndrsr  = array defining the range in the cdrs and ndrs arrays
c                  corresponding to the reaction for a given species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,kmax,narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer noutpt,nttyo
c
      integer ibswx(nbtmax),iindx1(kmax),jflag(nstmax),jsflag(nstmax),
     $ nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),ndrs(ndrsmx),
     $ ndrsx(ndrsmx),ndrsr(2,nstmax),ndrsrx(2,nstmax)
c
      integer ipch,ipcv,kbt,narn1,nbt,nbw,nst
c
      logical qbassw
c
      character*48 uspec(nstmax),uzvec1(kmax)
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,nsd,ns1,ns2,krow
c
      logical qbswok
c
c-----------------------------------------------------------------------
c
c     Save the nbasp array.
c
      call copyia(nbasp,nbaspx,nbt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do krow = 1,kbt
        nb = iindx1(krow)
        ns2 = ibswx(nb)
        if (ns2 .gt. 0) then
          ns1 = nbaspx(nb)
          nsd = nbaspd(nb)
c
c         If the ns1-th species has not previously been switched with
c         the nsd-th species, go make the currently requested switch.
c         If it has been switched, first undo that switch. Take care
c         not to undo it twice.
c
          if (nsd .ne. ns2) then
            if (ns1 .ne. nsd) then
c
c             First undo the existing switch.
c
              nbasp(nb) = nsd
c
c             Calling sequence substitutions:
c               nsd for ns2
c
              call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $        axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $        ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $        nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $        nsd,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
            endif
          endif
c
          nbasp(nb) = ns2
c
          call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $    axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $    ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $    nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $    ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
c
c         Update the names in the uzvec1 array.
c
          uzvec1(krow) = uspec(ns2)
        endif
      enddo
c
      end

      subroutine gegexs(cegexs,cgexj,egexjc,egexjf,egexs,iern1,
     $ iern2,ietmax,jern1,jetmax,jgext,moph,mosp,mrgexs,netmax,
     $ ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,zchar,zgexj)
c
c     This subroutine computes the equivalent fractions (egexs) and
c     mole ratios (mrgexs) of exchanger species belonging to generic
c     ion exchange phases.
c
c     The equivalent fractions for the exchanger species are the same
c     as those for the corresponding exchange ions. The mole ratios
c     are the number of moles of exchanger species per mole of
c     the exchange phase. The number of moles of an exchanger species
c     may or may not equal the number of moles of the corresponding
c     exchange ion. Thus, these mole ratios do not necessarily give
c     the number of moles of the exchange ions per mole of the exchange
c     phase.
c
c     The calculated equivalent fractions are based on formally
c     declared exchange capacities (egexjf). Thus, they need not sum
c     to unity, though they will do so for some models (e.g., Gapon,
c     Vanselow). If an anion should exchange onto a negatively charged
c     site, it will have a negative equivalent fraction.
c
c     Subroutine EQLIB/gegexw.f computes the apparent "whole-phase"
c     equivalent fractions (egexw) of cations and anions on generic ion
c     exchangers.
c
c     This subroutine is called by:
c
c       EQLIB/ncmpex.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       moph   = array of numbers of moles of phases
c       mosp   = array of numbers of moles of species
c
c     Principal output:
c
c       egexs  = array of equivalent fractions, by site, based on
c                  formally declared exchange capacities
c       mrgexs = array of mole ratios
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,netmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jgext(netmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax)
c
      integer iern1,iern2
c
      real*8 cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),mrgexs(ietmax,jetmax,netmax),
     $ moph(nptmax),mosp(nstmax),zchar(nstmax),zgexj(jetmax,netmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,je,ne,np,ns,nss
c
      real*8 ex,exf,exsc
c
c-----------------------------------------------------------------------
c
c     Compute the equivalent fractions (egexs) for the sites of
c     the generic ion exchangers. Note that these fractions are
c     based on the formal declared exchange capacities (egexjf) of
c     these sites. These equivalent fractions will only sum to unity
c     for certain models, such as the Vanselow and Gapon models,
c     which require the actual capacity (egexjc) to equal the
c     corresponding formal capacity.
c
      do np = iern1,iern2
        ne = np - iern1 + 1
c
        do je = 1,jgext(ne)
c
c         First calculate the number of equivalents for each
c         component species from the corresponding number of moles.
c         Also calculate the total number of equivalents (egexjc)
c         actually on the current site of the current exchanger. This
c         may or may not equal the formal exchange capacity of the site
c         egexjf), depending on the exchange model. It will equal it in
c         the case of simple exchange models which allow exchange of
c         ions of only one charge sign on a given site. The Vanselow
c         and Gapon models satisfy this condition.
c
          exsc = 0.
          ns = jern1(je,ne) - 1
          do ie = 1,ngext(je,ne)
            ns = ns + 1
            ex = mosp(ns)*cegexs(ie,je,ne)
            egexs(ie,je,ne) = ex
            exsc = exsc + ex
          enddo
c
c         Note that the sign of the capacity is the opposite of that
c         of the charge on the site itself.
c
          egexjc(je,ne) = exsc/moph(np)
c
          if (egexjf(je,ne) .ne. 0.) then
c
c           Calculate the equivalent fractions.
c
            exf = egexjf(je,ne)*moph(np)
            do ie = 1,ngext(je,ne)
              egexs(ie,je,ne) = egexs(ie,je,ne)/exf
            enddo
          else
c
c           If the declared formal capacity is zero (not permitted
c           for the Vanselow and Gapon models), do not calculate
c           equivalent fractions. Set the corresponding elements of
c           the egexs array to zero.
c
            do ie = 1,ngext(je,ne)
              egexs(ie,je,ne) = 0.
            enddo
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the mole ratios (mrgexs) for exchanger species of
c     of generic ion exchanger reactants. The mole ratio is the
c     moles of exchanger species (specific to a site) per mole of
c     exchanger substrate.
c
      do np = iern1,iern2
        ne = np - iern1 + 1
        do je = 1,jgext(ne)
          ex = zgexj(je,ne)*cgexj(je,ne)
          do ie = 1,ngext(je,ne)
            nss = ngexsa(ie,je,ne)
            if (nss .gt. 0) then
              mrgexs(ie,je,ne) = -ex*egexs(ie,je,ne)/zchar(nss)
            endif
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gnenb(ipbt_asv,ikt_asv,jpdblo,jpfc_asv,nap_asv,
     $ nat_asv,nazt_asv,nbt_asv,nct_asv,ndat0s,ngt_asv,nlt_asv,
     4 nmt_asv,noutpt,npt_asv,npx2_asv,npx3_asv,nsb,nst_asv,nttyo,
     $ nxt_asv,uakey)
c
c     This subroutine makes a first pass through the DATA0 file to
c     determine the necessary dimensioning of arrays. The arrays are
c     then allocated back in the main program, and the data file is
c     then processed.
c
c     The returned array allocation size variables generally end
c     in "_asv." For example, the number of chemical elements is
c     normally nct. The associated allocation size variable is
c     nct_asv.
c
c     Note: although for example nxt_asv is described as the number
c     of solid solution phases on the data file, it is actually an
c     array allocation size variable which might have to be utilized
c     in allocating an array, even if the number of items in the set
c     is zero. Thus, the minimum value of one is generally imposed
c     on any allocation size variable.
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ipbt_asv = the number of parameters in a Pitzer alpha set
c       ndat0s   = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       nap_asv  = maximum number of distinct sets of Pitzer alpha
c                    parameters
c       nazt_asv = the number of aqueous species on the data file
c                    for which hard core diameters are specified
c       nbt_asv  = the number of basis species on the data file
c       nct_asv  = the number of chemical elements on the data file
c       ikt_asv  = the maximum number of end-member component species
c                    in any solid solution on the data file
c       jpdblo   = integer flag denoting the Pitzer data block
c                    organization; -1 = classical, 0 = newlockile
c       jpfc_asv = the number of terms in the temperature function
c                    used to represent Pitzer interaction parameters
c       nat_asv  = the number of aqueous species on the data file
c       ngt_asv  = the number of gas species on the data file
c       nlt_asv  = the number of pure liquid species on the data file
c       nmt_asv  = the number of gas species on the data file
c       npt_asv  = the number of phases of all types on the data file
c       npx2_asv = the number of pairs of species not of the same
c                    charge sign for which Pitzer parameters are
c                    defined; typically, one of the pair is a cation
c                    and the other is an anion, but one or both
c                    species may also be electrically neutral
c       npx3_asv = the number of triplets of species corresponding to
c                    aqueous electrolyte mixtures for which Pitzer
c                    parameters are defined; generally, no more than
c                    two of these may have an electrical charge number
c                    that is postive, negative, or zero
c       nst_asv  = the number of species of all types on the data file
c       nxt_asv  = the number of solid-solution phases on the data file
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbt_asv,ikt_asv,jpfc_asv,nap_asv,nat_asv,nazt_asv,
     $ nbt_asv,nct_asv,ngt_asv,nlt_asv,nmt_asv,npt_asv,npx2_asv,
     $ npx3_asv,nst_asv,nxt_asv
c
      integer ndat0s,noutpt,nttyo
c
      integer jpdblo,nsb
c
      character(len=8) uakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer, parameter :: nap_par = 500
c
      integer i,ier,j,ja,j2,j3,j4,j5,ikt_sum,ikt_x,n,nmax
c
      integer ilnobl
c
      logical qalpha
c
      character(len=80) udastr,uline,ux80
      character(len=16) uaqu,uaux,uele,ubas,ubdot,ugas,uliq,umin,
     $ uref,usso,uterm
      character(len=16) ustr16
      character(len=8) ux8
c
      real(8) palpha(ipbt_asv,nap_par),palphi(ipbt_asv)
c
      real(8) aax,var
c
c-----------------------------------------------------------------------
c
      data uaqu   /'aqueous species '/
      data uaux   /'auxiliary basis '/
      data ubas   /'basis species   '/
      data ubdot  /'bdot parameters '/
      data uele   /'elements        '/
      data ugas   /'gases           '/
      data uliq   /'liquids         '/
      data umin   /'solids          '/
      data uref   /'references      '/
      data usso   /'solid solutions '/
      data uterm  /'+---------------'/
c
c-----------------------------------------------------------------------
c
c     Initialize some variables to zero.
c
      ikt_asv = 0
      nazt_asv = 0
      nap_asv = 0
      npx2_asv = 0
      npx3_asv = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq. 'SEDH    ') then
c
c       Have a Simple Extended Debye-Huckel model for the activity
c       coefficients of aqueous species. Determine the number of aqueous
c       species for which hard core diameters are specified.
c
  120   read (ndat0s,1000,end=990,err=995) uline
 1000   format(a)
        if (uline(1:16) .ne. ubdot(1:16)) go to 120
c
c       Skip the terminator line.
c
        read (ndat0s,1000,end=990,err=995) uline
c
c       Tally lines until next terminator.
c
        n = 0
  130   read (ndat0s,1000,end=990,err=995) uline
        if (uline(1:16) .eq. uterm(1:16)) go to 140
        n = n + 1
        go to 130
c
  140   nazt_asv = n
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Have a Pitzer model for the activity coefficients of aqueous
c       species.
c
        if (jpdblo .eq. -1) then
c
c         Have the "classical" Pitzer data block organization.
c         Determine the number of pairs of ions corresponding to pure
c         aqueous electrolytes for which Pitzer parameters are defined
c         ('single-salt parameters').
c
  150     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:16) .ne. 'single-salt para') go to 150
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
c         Determine the number of such pairs of ions (npx2_asv) by
c         counting the number of terminator lines prior to encountering
c         the 'mixture term parameters' line.
c
c         Also determine the number of distinct sets of Pitzer alpha
c         parameters (nap_asv).
c
          n = 0
          ja = 0
  160     read (ndat0s,1000,end=990,err=995) uline
c
          if (uline(1:16) .eq. 'mixture term par') then
            backspace(ndat0s)
            go to 180
          endif
c
          i = index(uline,'alpha1')
          if (i .gt. 0) then
c
c           Found the line with the alpha parameters.
c
            read (uline,1020,end=990,err=995) palphi(1),palphi(2)
 1020       format(18x,2(16x,f5.1))
c
            if (ja .gt. 1) then
              do j = 1,ja
                if (abs(palpha(1,j) - palphi(1)).le.1.e-12
     $            .and. abs(palpha(2,j) - palphi(2)).le.1.e-12) then
                  go to 170
                endif
              enddo
            endif
c
c           Not in the set; add it.
c
            ja = ja + 1
            if (ja .gt. nap_par) then
              write (ux8,'(i5)') nap_par
              call lejust(ux8)
              j2 = ilnobl(ux8)
              write (noutpt,1030) ux8(1:j2)
              write (nttyo,1030) ux8(1:j2)
 1030         format(/' * Error - (EQPT/gnenb) Have overflowed the',
     $        ' palpha array while',/7x,'attempting to find the number',
     $        ' of distinct sets of Pitzer alpha',/7x,'parameters.',
     $        ' Increase the dimensioning parameter nap_par in this',
     $        /7x,'subroutine from its present value of ',a,'.')
              stop
            endif
c
            palpha(1,ja) = palphi(1)
            palpha(2,ja) = palphi(2)
          endif
  170     continue
c
          if (uline(1:16) .eq. uterm(1:16)) n = n + 1
          go to 160
c
  180     npx2_asv = n
          nap_asv = ja
c
c         Determine the number of triplets of ions corresponding to
c         aqueous electrolyte mixtures for which Pitzer parameters are
c         defined ('mixture term parameters').
c
  190     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:16) .ne. 'mixture term par') go to 190
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
c         Skip the E-theta flag line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
c         Determine the number such triplets of by counting the number
c         of terminator lines prior to encountering the 'elements' line.
c
          n = 0
  200     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:16) .eq. uele(1:16)) then
            backspace(ndat0s)
            go to 210
          endif
          if (uline(1:16) .eq. uterm(1:16)) n = n + 1
          go to 200
c
  210     npx3_asv = n
c
        elseif (jpdblo .eq. 0) then
c
c         Have the "new" Pitzer data block organization.
c
c         First determine the number of distinct sets of Pitzer alpha
c         parameters (nap_asv). It is possible that no values are
c         input here, in which case only the default set holds.
c
c         Load the default set into the palpha array.
c
          nmax = ipbt_asv*nap_par
          call initaz(palpha,nmax)
          palpha(1,1) = 2.0
          palpha(2,1) = 12.0
          palpha(1,2) = 1.4
          palpha(2,2) = 12.0
          ja = 2
          nap_asv = ja
c
c         Skip down to the "ca combinations" superblock. This is
c
  220     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:15) .ne. 'ca combinations') go to 220
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
  230     read (ndat0s,1000,end=990,err=995) uline
          j3 = ilnobl(uline)
c
          if (uline(1:26) .eq. "cc'a and aa'c combinations") then
            backspace(ndat0s)
            go to 250
          endif
c
          qalpha = .false.
          ux80 = uline
          call lejust(ux80)
c
c         Find the next set of alpha lines. Look for "alpha(1)".
c         That marks the start of a set.
c
          ustr16 = 'alpha(1) ='
          j4 = 10
          if (ux80(1:j4) .eq. ustr16(1:j4)) then
c
c           Found a line with the alpha(1) parameter.
c
            j5 = index(ux80,'=')
            udastr = ux80(j5 + 1:80)
            call g1dat(ier,noutpt,nttyo,udastr,var)
            if (ier .gt. 0) then
              write (noutpt,1110) uline(1:j3)
              write (nttyo,1110) uline(1:j3)
 1110         format(/' * Error - (EQPT/gnenb) Have found a line',
     $        ' starting with:',/7x,'"',a,'"',/7x,'containing an',
     $        ' expected numerical field that could not be read.',
     $        /7x,'This occurred while scanning the data file to',
     $        ' determine the number',/7x,'of distinct sets of',
     $        ' Pitzer alpha parameters.')
              stop
            endif
            palphi(1) = var
            qalpha = .true.
c
            do i = 2,ipbt_asv
              read (ndat0s,1000,end=990,err=995) uline
              j3 = ilnobl(uline)
              ux80 = uline
              call lejust(ux80)
              ustr16 = 'alpha( ) ='
              j4 = 10
              write (ustr16(7:7),'(i1)') i
              if (ux80(1:j4) .eq. ustr16(1:j4)) then
c
c               Found a line with the expected alpha(i) parameter.
c
                j5 = index(ux80,'=')
                udastr = ux80(j5 + 1:80)
                call g1dat(ier,noutpt,nttyo,udastr,var)
                if (ier .le. 0) then
                  palphi(i) = var
                else
                  write (noutpt,1110) uline(1:j3)
                  write (nttyo,1110) uline(1:j3)
                  stop
                endif
              else
c
c               Did not find a line with the expected alpha(i)
c               parameter.
c
                ustr16 = 'beta(0) ='
                j4 = 9
                if (ux80(1:j4) .ne. ustr16(1:j4)) then
c
c                 Did not find a beta(0) line either. This
c                 condition is invalid.
c
                  write (ux8,'(i1)') i
                  write (noutpt,1120) uline(1:j3),ux8(1:1)
                  write (nttyo,1120) uline(1:j3),ux8(1:1)
 1120             format(/' * Error - (EQPT/gnenb) Have found a line',
     $            ' starting with:',/7x,'"',a,'"',/7x,'that contains',
     $            ' neither the expected alpha(',a,') data nor the',
     $            /7x,'possible beta(0) data that could mark the end',
     $            ' of an abbreviated',/7x,'alpha set. This occurred',
     $            ' while scanning the data file',/7x,'to determine',
     $            ' the number of distinct sets of Pitzer',
     $            /7x,'alpha parameters.')
                  stop
                endif
              endif
            enddo
          endif
c
          if (qalpha) then
            do j = 1,ja
              do i = 1,ipbt_asv
                aax = abs(palpha(i,j) - palphi(i))
                if (aax .gt. 1.e-12) go to 240
              enddo
c
c             The current alpha combination is already in
c             the known set.
c
              go to 230
  240         continue
            enddo
c
c           The current alpha set is not in the set; add it.
c
            ja = ja + 1
            if (ja .gt. nap_par) then
c
c             Have overflowed the palpha array, which was statically
c             dimensioned.
c
              write (ux8,'(i5)') nap_par
              call lejust(ux8)
              j2 = ilnobl(ux8)
              write (noutpt,1030) ux8(1:j2)
              write (nttyo,1030) ux8(1:j2)
              stop
            endif
            do i = 1,ipbt_asv
              palpha(i,ja) = palphi(i)
            enddo
          endif
          go to 230
c
  250     nap_asv = ja
c
          rewind(ndat0s)
c
c         Skip back down to the "ca combinations" superblock.
c
  260     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:15) .ne. 'ca combinations') go to 260
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
c         Determine the number of pair combinations (npx2_asv) by
c         counting the number of terminator lines prior to
c         encountering the "cc'a and aa'c combinations" line.
c         Correct this estimate for other pair superblock
c         headers.
c
          n = 0
  270     read (ndat0s,1000,end=990,err=995) uline
c
          if (uline(1:26) .eq. "cc'a and aa'c combinations") then
            backspace(ndat0s)
            go to 280
          endif
c
          if (uline(1:24) .eq. "cc' and aa' combinations") n = n - 1
          if (uline(1:22) .eq. "nc and na combinations") n = n - 1
          if (uline(1:15) .eq. "nn combinations") n = n - 1
          if (uline(1:16) .eq. "nn' combinations") n = n - 1
          if (uline(1:16) .eq. uterm(1:16)) n = n + 1
          go to 270
c
  280     npx2_asv = n
c
c         Skip down to the "cc'a and aa'c combinations" superblock.
c
  290     read (ndat0s,1000,end=990,err=995) uline
          if (uline(1:26) .ne. "cc'a and aa'c combinations") go to 290
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
c
c         Determine the number of triplet combinations (npx3_asv) by
c         counting the number of terminator lines prior to
c         encountering the "cc'a and aa'c combinations" line.
c         Correct this estimate for other triplet superblock
c         headers.
c
          n = 0
  300     read (ndat0s,1000,end=990,err=995) uline
c
          if (uline(1:16) .eq. uele(1:16)) then
            backspace(ndat0s)
            go to 310
          endif
c
          if (uline(1:16) .eq. "nca combinations") n = n - 1
          if (uline(1:16) .eq. "nnn' combination") n = n - 1
          if (uline(1:16) .eq. uterm(1:16)) n = n + 1
          go to 300
c
  310     npx3_asv = n
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the 'elements' line.
c
  350 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. uele(1:16)) go to 350
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Tally lines until next terminator.
c
      n = 0
  360 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. uterm(1:16)) go to 370
      n = n + 1
      go to 360
c
  370 nct_asv = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'basis species' line.
c
  400 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. ubas(1:16)) go to 400
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of basis species by counting the number
c     of terminator lines prior to encountering the 'aqueous species'
c     line. In this count, note that an "extra" terminator line
c     is encountered after the "auxiliary basis species" line.
c     The number of strict basis species is also determined, by
c     noting the number of basis species prior to encountering the
c     "auxiliary basis species" line.
c
      n = 0
  410 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. uaux(1:16)) nsb = n
      if (uline(1:16) .eq. uaqu(1:16)) then
        backspace(ndat0s)
        go to 420
      endif
      if (uline(1:16) .eq. uterm(1:16)) n = n + 1
      go to 410
c
  420 nbt_asv = n - 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'aqueous species' line.
c
  450 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. uaqu(1:16)) go to 450
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of non-basis aqueous species by counting the
c     number of terminator lines prior to encountering the 'solids'
c     line. The total number of aqueous species is the sum of the
c     basis and non-basis aqueous species.
c
      n = 0
  460 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. umin(1:16)) then
        backspace(ndat0s)
        go to 470
      endif
      if (uline(1:16) .eq. uterm(1:16)) n = n + 1
      go to 460
c
  470 nat_asv = nbt_asv + n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'solids' line.
c
  500 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. umin(1:16)) go to 500
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of pure mineral species by counting the
c     number of terminator lines prior to encountering the 'liquids'
c     line.
c
      n = 0
  510 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. uliq(1:16)) then
        backspace(ndat0s)
        go to 520
      endif
      if (uline(1:16) .eq. uterm(1:16)) n = n + 1
      go to 510
c
  520 nmt_asv = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'liquids' line.
c
  550 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. uliq(1:16)) go to 550
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of pure liquid species by counting the
c     number of terminator lines prior to encountering the 'gases'
c     line.
c
      n = 0
  560 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. ugas(1:16)) then
        backspace(ndat0s)
        go to 570
      endif
      if (uline(1:16) .eq. uterm(1:16)) n = n + 1
      go to 560
c
c     Note: water as a pure liquid phase is not explicitly on the
c     DATA0 file. It is added by EQ3NR or EQ6 by cloning the liquid
c     water species belonging to the aqueous solution phase. The pure
c     liquid water phase must be accounted for in nlt_asv, so the
c     actual count of pure liquid phases explicitly on the data file
c     is incremented by one.
c
  570 nlt_asv = n + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'gases' line.
c
  600 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. ugas(1:16)) go to 600
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of gas species by counting the number of
c     terminator lines prior to encountering the 'solid solutions'
c     line.
c
      n = 0
  610 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. usso(1:16)) then
        backspace(ndat0s)
        go to 620
      endif
      if (uline(1:16) .eq. uterm(1:16)) n = n + 1
      go to 610
c
  620 ngt_asv = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip to the 'solid solutions' line.
c
  650 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .ne. usso(1:16)) go to 650
c
c     Skip the terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c     Determine the number of solid solution phases by counting the
c     number of terminator lines prior to encountering the 'references'
c     line.
c
c       ikt_x   = the number of components in the current solid
c                   solution
c       ikt_sum = the total number of components in all solid solutions
c
      n = 0
      ikt_x = 0
      ikt_sum = 0
c
  660 read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:16) .eq. uref(1:16)) then
        backspace(ndat0s)
        go to 670
      endif
c
      if (ikt_x .le. 0) then
c
c       Have not yet found a 'component' line.
c
        i = index(uline,'component')
        if (i .eq. 5) then
c
c         Have found the line with the number of components.
c         Note that there is a two-component minimum here.
c
          read (uline,'(1x,i2)',err=995) ikt_x
          ikt_x = max(2,ikt_x)
          ikt_asv = max(ikt_asv,ikt_x)
          ikt_sum = ikt_sum + ikt_x
        endif
      endif
c
      if (uline(1:16) .eq. uterm(1:16)) then
c
c       Have found the end of the current solid solution block.
c
        n = n + 1
        if (ikt_x .le. 0) then
c
c         No line defining the number of components was found.
c
          ikt_x = 2
          ikt_asv = max(ikt_asv,ikt_x)
          ikt_sum = ikt_sum + ikt_x
        endif
        ikt_x = 0
      endif
      go to 660
c
  670 nxt_asv = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the total number of phases. Be sure to account for the
c     aqueous solution and the gas phase. Water as a pure liquid
c     phase has been implicitly added to nlt_asv.
c
      npt_asv = 2 + nmt_asv + nlt_asv + nxt_asv
c
c     Get the total number of species.
c
      nst_asv = nat_asv + nmt_asv + nlt_asv + ngt_asv + ikt_sum
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Each dimensioning parameter should have a minimum value of 1,
c     even if the corresponding number of items is 0.
c
      ikt_asv = max(1,ikt_asv)
      nap_asv = max(1,nap_asv)
      nat_asv = max(1,nat_asv)
      nazt_asv = max(1,nazt_asv)
      nbt_asv = max(1,nbt_asv)
      nct_asv = max(1,nct_asv)
      ngt_asv = max(1,ngt_asv)
      nlt_asv = max(1,nlt_asv)
      nmt_asv = max(1,nmt_asv)
      npt_asv = max(1,npt_asv)
      npx2_asv = max(1,npx2_asv)
      npx3_asv = max(1,npx3_asv)
      nst_asv = max(1,nst_asv)
      nxt_asv = max(1,nxt_asv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Rewind the DATA0 file and exit.
c
      rewind(ndat0s)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a message for any read error.
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/gnenb) Unexpectedly encountered',
     $ ' end-of-file',/7x,'while scanning the DATA0 file to determine',
     $ ' the necessary array',/7x,'dimensions.')
      stop
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/gnenb) Encountered a read format',
     $ ' error while',/7x,'scanning the DATA0 file to determine',
     $ ' the necessary array dimensions.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine ckawmx(delxi,dlxmin,daw0,dxw1mx,dxval0,eps100,iodb,
     $ nodbmx,nord,noutpt,nrd1mx,nttyo,aw0,aw1,awmax,prcinf,qdump,
     $ tolxsu,xi0,xi1,xval0)
c
c     This subroutine checks to see that the requested maximum value of
c     activity of water (aw) is not exceeded.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer nord
c
      logical qdump
c
      real*8 daw0(nrd1mx),dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,dxw1mx,eps100,prcinf,awmax,aw0,aw1,tolxsu,
     $ xi0,xi1,xval0,xtargv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,n
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxp,dxsv,tolsx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'aw reaches the requested maximum value          '/
      data unam24  /'                       '/
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
c
      dxw1mx = prcinf
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is the requested limit on the aw.
c
      ilsign = -1
      xtargv = awmax
      tolsx = tolxsu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for where the aw reaches the requested',
     $    ' maximum value',/3x,'has failed. Dropping to the minimum',
     $    ' step size.')
        endif
        delxi = dlxmin
        go to 990
      endif
c
c     Estimate the aw from a Taylor's series expansion.
c
      aw1 = aw0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        aw1 = aw1 + ( daw0(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (aw0 .ge. (1. - tolxsu)*awmax) then
c
c         The aw at the base point is too close to the requested
c         maximum value.
c
          delxi = dlxmin
          dxw1mx = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) aw0,awmax,xi0,delxi
 1010       format(/3x,'The base point aw of ',1pe11.4,' is already',
     $      ' very close',/3x,'to the requested value of ',
     $      e11.4,/3x,'at Xi= ',e11.4,'. Have set delxi',
     $      ' equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 100
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((aw1 - awmax) .gt. tolsx) then
c
          xval0 = aw0
          do n = 1,nord
            dxval0(n) = daw0(n)
          enddo
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dxw1mx = delxi
          if (ier .le. 0) go to 100
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dxw1mx = delxi
          go to 990
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(aw1 - awmax) .le. tolsx) then
          write (noutpt,1020) awmax,xi1,delxi
 1020     format(/3x,"Taylor's series predict that the aw is",
     $    ' at the requested',/3x,'maximum value of ',1pe11.4,
     $    ' at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (dxsv .gt. delxi) qdump = .false.
c
  999 continue
      end

      subroutine cfxist(ctb,fxistc,nbaspd,nbt,nbtmax,nstmax,zchsq2)
c
c     This subroutine calculates the stoichiometric ionic strength
c     (fxistc). Note that a negative value of total concentration
c     (ctb) for H+ is treated as a positive value for OH- (and vice
c     versa).
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ctb    = array of total concentrations of the basis species in
c                  the 'd' set
c       nbaspd = array containing the indices of the species in the 'd'
c                  basis set
c       nbt    = the number of active basis species
c       zchsq2 =  array of one-half the charge squared
c
c     Principal output:
c
c       fxistc = the stoichiometric ionic strength, defined in terms
c                  of the total molalities of the basis species in the
c                  'd' set
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer nbaspd(nbtmax)
      integer nbt
c
      real*8 ctb(nbtmax),zchsq2(nstmax)
      real*8 fxistc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,ns
c
c-----------------------------------------------------------------------
c
c     Note: the relatively small likely value of nbt does not justify
c     the use of an unrolled loop.
c
      fxistc = 0.
      do nb = 1,nbt
        ns = nbaspd(nb)
        fxistc = fxistc + zchsq2(ns)*abs(ctb(nb))
      enddo
c
      end

      subroutine lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,
     $ qldep)
c
c     This subroutine determines whether the rows of a submatrix of
c     matrix aamatr are linearly dependent or not. The submatrix runs
c     from rows irow1 to irow2 and columns jcol1 to jcol2. If there is
c     linear dependence, qldep is returned with a value of ".true.".
c     This subroutine factors all rows if possible. It is assumed that
c     the calling subroutine may use these rows if qldep is returned
c     with a value of ".true.".
c
c     This subroutine is called by:
c
c       EQ3NR/dawfix.f
c       EQ6/eqcalc.f
c       EQ6/jgibbs.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       aamatr = the matrix to be tested
c       eps100 = 100 times the real*8 machine epsilon
c       irow1  = start of range of rows to examine
c       irow2  = end of range of rows to examine
c       jcol1  = start of range of columns to examine
c       jcol2  = end of range of columns to examine
c       kmax   = dimension of aamatr
c
c     Output:
c
c       qldep  = flag variable
c                  .true.  = linear dependence
c                  .false. = no linear dependence
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax
c
      integer irow1,irow2,jcol1,jcol2
c
      logical qldep
c
      real*8 aamatr(kmax,kmax)
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,idim,ipiv,irow,j,jcol,jdim,nrowi,nrowp
c
      real*8 aax,avmax,av,factor
c
c-----------------------------------------------------------------------
c
      idim = irow2 - irow1 + 1
      jdim = jcol2 - jcol1 + 1
c
      do i = irow1,irow2
        avmax = 0.
        do j = jcol1,jcol2
          av = abs(aamatr(i,j))
          if (av .gt. avmax) avmax = av
        enddo
        if (avmax .eq. 0.) then
c
c         Have a row containing all zeros.
c
          qldep = .true.
          go to 999
        endif
      enddo
c
      if (idim .gt. jdim) then
c
c       Have linear dependence because the number of rows is greater
c       than the number of columns.
c
        qldep = .true.
        go to 999
      endif
c
c     Note: nrowp is the number of rows processed; irow is the
c     index of the row currently being tested.
c
      nrowp = 0
c
      do jcol = jcol1,jcol2
        irow = irow1 + nrowp
        avmax = 0.
        ipiv = irow
c
        do i = irow,irow2
          av = abs(aamatr(i,jcol))
          if (av .gt. avmax) then
            avmax = av
            ipiv = i
          endif
        enddo
c
        if (avmax .gt. 0.) then
c
c         The present column is non-empty for the present and following
c         rows. This suffices to establish the existence of another
c         independent row.
c
          nrowp = nrowp + 1
c
          if (ipiv .ne. irow) then
c
c           Pivot- exchange rows irow and ipiv.
c
            do j = jcol,jcol2
              aax = aamatr(irow,j)
              aamatr(irow,j) = aamatr(ipiv,j)
              aamatr(ipiv,j) = aax
            enddo
          endif
c
c         Move down the present column from the current row to the last
c         row. If a non-zero entry is found, multiply the row by the
c         factor necessary to set this entry to unity. Note that
c         entries in any preceding columns of the submatrix are zero
c         at this point.
c
          do i = irow,irow2
            if (aamatr(i,jcol) .ne. 0.) then
              factor = 1./aamatr(i,jcol)
              do j = jcol,jcol2
                aamatr(i,j) = factor*aamatr(i,j)
              enddo
            endif
          enddo
c
          do i = irow + 1,irow2
            if (aamatr(i,jcol) .ne. 0.) then
c
c             Have a following row whose entry in the current column is
c             not zero (hence it has a value of unity). Make it zero by
c             subtracting the irow-th row (whose entry in the current
c             column is also unity) from the following row now under
c             consideration.
c
              do j = jcol,jcol2
                aamatr(i,j) = aamatr(i,j) - aamatr(irow,j)
                if (abs(aamatr(i,j)) .le. eps100) aamatr(i,j) = 0.
              enddo
            endif
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Count the number of independent rows.
c
      nrowi = 0
      do i = irow1,irow2
        do j = jcol1,jcol2
          if (aamatr(i,j) .ne. 0.) then
            nrowi = nrowi + 1
            go to 100
          endif
        enddo
  100   continue
      enddo
c
      qldep = nrowi .lt. idim
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine arrset(aamatr,abar,acflg,acflgo,act,actlg,adh,
     $ adhh,adhv,adhfs,adhfsx,advfs,advfsx,afcnst,alpha,al10,
     $ amtb,aphi,avcnst,azero,a3bar,a3bars,axhfs,axhfsx,axlks,
     $ axlksx,axvfs,axvfsx,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,
     $ bdotv,beta,betamx,bfac,bgamx,bneg,bpx,bsigmm,bfje,bfxi,
     $ cco2,cdrs,cdrsx,cdrtw,cdrw,cegexs,cgexj,cjbasp,cnufac,
     $ conc,conclg,coval,cpgexs,csts,delam,delvec,dgpit,dhfs,
     $ dlogxw,dpelm,dpslm,dselm,dvfs,efac,egexjc,egexjf,egexs,
     $ eh,ehfac,elam,eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,fugalg,
     $ fxi,fxio,gmmatr,gpit,ibetmx,ibpxt,ibswx,iction,iebal,ielam,
     $ iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,
     $ ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,ilcphi1,ilcphi2,
     $ ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,
     $ insgf,iopg,iodb,iopt,ipch,ipcv,ipivot,ipndx1,irdxc3,istack,
     $ ixbasp,ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,
     $ jgsort,jgstak,jjndex,jjsort,jpflag,jsflag,jsitex,jsol,
     $ jssort,jstack,ka1,kat,kbt,kct,kction,kdim,kebal,kelect,
     $ ker,ke1,ket,khydr,kkndex,km1,ko2gaq,kwater,kx1,kxt,loph,
     $ losp,lsort,mgext,moph,mosp,mrgexs,mtb,nalpha,napt,narn1,
     $ narn2,narxt,nbasp,nbaspd,nbaspx,nbt,nbtd,nbti,nbw,nchlor,
     $ ncmpr,ncosp,nct,ndecsp,ndrs,ndrsx,ndrsr,ndrsrd,ndrsrx,
     $ nelect,nern1,nern2,net,nfac,ngexsa,ngext,ngrn1,ngrn2,ngt,
     $ nhydr,nhydx,nmut,nmux,nmxi,nmxx,noutpt,no2gaq,nphasx,npt,
     $ nredox,nslt,nslx,nst,nsts,nstsr,nsxi,nsxx,ntfx,ntfxt,ntpr,
     $ nttyo,omega,omeglg,palpha,pe,pelm,pmu,presg,press,pslamn,
     $ pslm,qbassw,qchlor,qhawep,qpit75,qredox,q6mode,rhsvec,selm,
     $ sigmam,sigmmo,smp100,tempc,tempk,tfx,ubacmx,ubbig,ubgamx,
     $ ubneg,ubetmx,ucospi,ugexj,ugexmo,ujflls,uphase,uspec,
     $ uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,xbrwlc,xbrwlg,
     $ xhfs,xlke,xlks,xvfs,zchar,zchsq2,zchcu6,zgexj,zvclg1,zvec1)
c
c     This subroutine builds the iindx1 array. It sets up the matrix
c     structure for hybrid Newton-Raphson iteration and computes
c     initial values for the iteration variables. It optimizes these
c     in preparation for hybrid Newton-Raphson iteration. The variable
c     ker is returned as 0 if all went well, as 1 if the input
c     constraints look suspiciously poor, and as 2 if they look
c     really bad.
c
c     This subroutine is somewhat analogous to EQ6/optmzr.f, which also
c     performs optimization of iteration variables prior to hybrid
c     Newton-Raphson iteration.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narn1  = start of the range of aqueous species; this is
c                  also the index of the solvent, water
c       narn2  = end of the range of aqueous species
c
c     Principal output:
c
c       conc   = array of species concentrations
c       iindx1 = array of indices of components appearing as
c                  matrix variables
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),ibswx(nbtmax),iction(nbtmax),
     $ igstak(ngtmax),iindx1(kmax),ipndx1(kmax),insgf(natmax),
     $ iodb(nodbmx),iopg(nopgmx),iopt(noptmx),ipivot(kmax),
     $ istack(nstmax),ixbasp(nbtmax),jcsort(nstmax),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jgext(netmax),jgsort(ngtmax),jgstak(ngtmax),
     $ jjndex(nbtmax),jjsort(nstmax),jsflag(nstmax),jsitex(nstmax),
     $ jsol(nxtmax),jpflag(nptmax),jssort(nstmax),jstack(nstmax),
     $ kction(nbtmax),kkndex(nbtmax)
c
      integer narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),nbaspx(nbtmax),
     $ ncmpr(2,nptmax),ncosp(nbtmax),ndecsp(nbtmax),ndrs(ndrsmx),
     $ ndrsx(ndrsmx),ndrsr(2,nstmax),ndrsrd(2,nstmax),ndrsrx(2,nstmax),
     $ nfac(nbtmax),ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax),
     $ nphasx(nstmax),nsts(nstsmx),nstsr(2,nstmax),ntfx(ntfxmx)
c
      integer nalpha(nsltmx),nmux(3,nmutmx),nmxi(2,natmax),
     $ nmxx(3,nmxmax),nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
c
      integer napt,nmut,nslt
c
      integer ibetmx,iebal,ielam,iern1,iern2,ifrn1,ifrn2,igas,ilrn1,
     $ ilrn2,imrn1,imrn2,ipch,ipcv,irdxc3,ixrn1,ixrn2,izmax,ka1,kat,kbt,
     $ kct,kdim,kebal,kelect,ker,ke1,ket,khydr,km1,ko2gaq,kwater,kx1,
     $ kxt,narn1,narn2,nbt,nbtd,nbti,nbw,nchlor,nct,nelect,nern1,
     $ nern2,net,ngrn1,ngrn2,ngt,nhydr,nhydx,no2gaq,npt,nredox,nst,
     $ ntfxt,ntpr
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      logical qbassw,qchlor,qhawep,qpit75,qredox,q6mode
c
      character(len=48) ucospi(nbtmax),uspec(nstmax),uzvec1(kmax)
      character(len=48) ubacmx,ubbig,ubetmx,ubgamx,ubneg
      character(len=32) ujflls(0:njfmax)
      character(len=24) ugexmo(netmax),uphase(nptmax)
      character(len=8) ugexj(jetmax,netmax)
c
      real(8) dgpit(2,ipbtmx,napmax),dpslm(2,nsltmx),
     $ gpit(ipbtmx,napmax),palpha(ipbtmx,napmax),pmu(nmutmx),
     $ pslamn(0:ipbtmx,nsltmx),pslm(nsltmx)
c
      real(8) delam(2,nazpmx,nazpmx),dpelm(2,nazpmx,nazpmx),
     $ dselm(2,nazmmx:nazpmx),elam(nazpmx,nazpmx),pelm(nazpmx,nazpmx),
     $ selm(nazmmx:nazpmx)
c
      real(8) xhfs(nstmax),xlks(nstmax),xvfs(nstmax)
c
      real(8) dhfs(ipchmx,nstmax),dvfs(ipcvmx,nstmax)
c
      real(8) axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax)
c
      real(8) adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax)
c
      real(8) aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),
     $ act(nstmax),actlg(nstmax),alpha(kmax),amtb(nbtmax),
     $ azero(natmax),a3bars(natmax),beta(kmax),bfac(nbtmax),
     $ bpx(ibpxmx,nxtmax),cco2(5),cdrs(ndrsmx),cdrsx(ndrsmx),
     $ cdrtw(nstmax),cdrw(nstmax),cegexs(ietmax,jetmax,netmax),
     $ cgexj(jetmax,netmax),cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),
     $ conclg(nstmax),coval(nbtmax),cpgexs(ietmax,jetmax,netmax),
     $ csts(nstsmx),delvec(kmax),dlogxw(nbtmax),efac(nbtmax),
     $ egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),fsort(ngtmax),fugac(ngtmax),
     $ fugalg(ngtmax),gmmatr(kmax,kmax),loph(nptmax),losp(nstmax),
     $ lsort(nstmax)
c
      real(8) mgext(jetmax,netmax),moph(nptmax),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),rhsvec(kmax),
     $ tfx(ntfxmx),weight(nstmax),wfac(iktmax,nxtmax),xbar(nstmax),
     $ xbarlg(nstmax),zchar(nstmax),zchsq2(nstmax),zchcu6(nstmax),
     $ zgexj(jetmax,netmax),zvclg1(kmax),zvec1(kmax)
c
      real(8) adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real(8) abar,actwlc,afcnst,al10,avcnst,a3bar,bacfmx,bbig,betamx,
     $ bfje,bfxi,bgamx,bneg,bsigmm,btmxoe,btmxoo,eh,ehfac,eps100,fje,
     $ fjeo,fo2,fo2lg,fxi,fxio,omega,omeglg,pe,press,sigmam,sigmmo,
     $ smp100,tempc,tempk,xbarw,xbarwc,xbrwlc,xbrwlg
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iter,jfl,jlen,jlen1,jlen2,j2,kb,kc,kcol,kount,krow,nb,
     $ nb2,ncycle,ncylim,negbfc,nloop,nlopmx,npass,nplim,nr1,ns,nse,
     $ nswtch,ns1,ns2
c
      integer ilnobl
c
      logical qabsw,qawfix,qbswx,qcfxi,qcgam,qcsigm,qloop,qpracf,
     $ qtestc,qtestp,qxbarw
c
      character(len=56) uspn56,usp156,usp256
      character(len=32) ujtp
      character(len=24) ux24
c
      real(8) presg,xlke
c
      real(8) av,azdel,betfnc,bxecor,bxp1,cecorr,chfacf,chfsgm,cx,cxl,
     $ cxn,cxo,dx,fjec,fxic,lx,rlxgam,sigmmc,sigza,sigzc,sigzi,sigzm,
     $ stx,tfxc,tolbig,tolbtf,tolgpt,tolneg,tolxpt,tolzpt,xecorr,
     $ zdel,zx1,zx2
c
      real(8) coefdr,texp,tlg
c
c-----------------------------------------------------------------------
c
c     The following are iteration limits:
c
c       nlopmx = the maximum number of auto basis switching loops
c       nplim  = the maximum number of passes
c       ncylim = the maximum number of cycles
c
c     Passes refine estimates of the ionic strength, etc., the
c     activity of water, and activity coefficients of aqueous species.
c     Cycles are embedded in passes. They refine estimates of species
c     concentrations before new estimates of ionic strength, etc.,
c     are made.
c
      data nlopmx /12/,nplim  /7/,ncylim /15/
c
c     The following are tolerance parameters for the optimization:
c
      data tolbtf /0.1/
      data tolzpt /0.25/
      data tolbig /0.5/,tolneg /-0.1/
      data tolxpt /0.5/,tolgpt /0.1/
c
c     The following is needed for ncmpex.f, but is only relevant to EQ6.
c
      data qxbarw/.false./
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
      write (nttyo,1000)
 1000 format(/' Starting Pre-Newton-Raphson Optimization.',/)
c
      qbswx = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nb = 1,nbtmax
        kkndex(nb) = 0
        kction(nb) = 0
      enddo
c
      bbig = 0.
      bneg = 0.
      ubbig = 'None'
      ubneg = 'None'
c
      bgamx = 0.
      ubgamx = 'None'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the structure of the iteration matrix. Its contents may be
c     altered subsequently by automatic basis switching.
c
c     Build the iindx1 array.
c
      kebal = 0
      kwater = 0
      khydr = 0
      kelect = 0
      ko2gaq = 0
c
      ka1 = 0
      kat = 0
      ke1 = 0
      ket = 0
c
      kb = 0
      kc = 0
      do nb = 1,nbt
        ns = nbasp(nb)
        jfl = jflag(ns)
        if (jfl.ne.-1 .and. jfl.ne.30) then
          kb = kb + 1
          iindx1(kb) = nb
          uzvec1(kb) = uspec(ns)
          if (nb .eq. iebal) kebal = kb
          if (ns .eq. narn1) kwater = kb
          if (ns .eq. nhydr) khydr = kb
          if (ns .eq. nelect) kelect = kb
          if (ns .eq. no2gaq) ko2gaq = kb
        endif
      enddo
      kbt = kb
      kdim = kbt
cXXX
      if (qchlor) then
        kct = nct -1
      else
        kct = nct
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Fill the kction array. This array is used to mark the columns
c     belonging to basis species which are involved in constraints
c     placed on other basis species.
c
      do nb = 1,nbt
        ns1 = ncosp(nb)
        do kcol = 1,kbt
          nb2 = iindx1(kcol)
          ns2 = nbasp(nb2)
          if (ns2 .eq. ns1) then
            kction(nb) = kcol
            go to 100
          endif
        enddo
  100   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 2) then
c
c       Print the active data file basis set.
c
        write (noutpt,1010)
 1010   format(/16x,'--- Active Data File Basis Set ---',
     $  //2x,'krow   Name',30x,'Constraint',/)
c
        do krow = 1,kdim
          nb = iindx1(krow)
          ns = nbaspd(nb)
          ujtp = 'Defining equation'
          if (nb .eq. iebal) then
              ujtp = 'Electrical balance'
            elseif (ns .eq. no2gaq) then
              if ((irdxc3 .eq. -1) .or. (irdxc3 .eq. -2)) then
                ujtp = 'Eh'
              elseif (irdxc3 .eq. 1) then
                ujtp = 'Aqueous redox reaction'
              endif
            else
              jfl = jflag(ns)
              ujtp = ujflls(jfl)
          endif
          j2 = ilnobl(ujtp)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uzvec1(krow),uspn56)
          write (noutpt,1020) krow,uspn56,ujtp(1:j2)
 1020     format(1x,i4,2x,a32,2x,a)
        enddo
c
        write (noutpt,1030)
 1030   format(/1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The label below is a return point after an automatic basis switch.
c     Here nloop is the loop counter for auto basis switching.
c
      nloop = -1
c
      qloop = .true.
  200 nloop = nloop + 1
      if (iodb(3) .ge. 1) write (noutpt,1040) nloop
 1040 format(6x,'nloop= ',i2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 2) then
        if (qbassw) then
c
c       Print the computational basis set.
c
          write (noutpt,1050)
 1050     format(16x,'--- Basis Set Changes ---',
     $    //2x,'krow   Data File',25x,'Current',/)
c
          do krow = 1,kbt
            nb = iindx1(krow)
            ns1 = nbaspd(nb)
            ns2 = nbasp(nb)
            if (ns1 .ne. ns2) then
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(ns1) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(ns1),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(ns2) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(ns2),usp256)
              jlen2 = min(jlen2,32)
              write (noutpt,1060) krow,usp156,usp256(1:jlen2)
 1060         format(1x,i4,2x,a32,2x,a)
            endif
          enddo
          write (noutpt,1030)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize concentrations and masses of the active basis species.
c
      do kcol = 1,kbt
        nb = iindx1(kcol)
        nse = nbasp(nb)
        jfl = jflag(nse)
        if (jfl .eq. -1) then
          conc(nse) = 0.
        elseif (jfl.ge.0 .and. jfl.le.3) then
c
c         Concentrations.
c
          ns = nbaspd(nb)
          if (nse .eq. ns) then
            conc(nse) = coval(nb)
          else
            cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
            nr1 = ndrsr(1,ns)
            stx = -cx/cdrs(nr1)
            conc(nse) = stx*coval(nb)
          endif
        elseif (jfl.ge.7 .and. jfl.le.11) then
c
c         Alkalinity.
c
          ux24 = uspec(nse)(1:24)
          tfxc = 1.
          if (ux24(1:6) .eq. 'HCO3- ') tfxc = 1.
          if (ux24(1:6) .eq. 'CO3-- ') tfxc = 2.
          conc(nse) = coval(nb)/tfxc
        elseif (jfl .eq. 16) then
c
c         Activity.
c
          cx = coval(nb)
          conc(nse) = texp(cx)
        elseif (jfl.eq.19 .or. jfl.eq.20) then
c
c         pX and pH.
c
          cx = -coval(nb)
          conc(nse) = texp(cx)
        elseif (jfl.eq.22 .or. jfl.eq.23) then
c
c         pmX and pmH.
c
          cx = -coval(nb)
          conc(nse) = texp(cx)
        else
c
c         All other cases.
c
          conc(nse) = 1.e-7
        endif
      enddo
c
      conc(narn1) = 0.
      if (nelect .gt. 0) conc(nelect) = 0.
      if (no2gaq .gt. 0) conc(no2gaq) = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the charge imbalance.
c
      zdel = 0.
      do nb = 1,nbt
        ns = nbasp(nb)
        if (ns.ge.narn1 .and. ns.le.narn2) then
          zdel = zdel + zchar(ns)*conc(ns)
        endif
      enddo
      azdel = abs(zdel)
c
c     Calculate a starting value for the SUM(i) m(i) function
c     (sigmam). Treat the calculated charge imbalance among the
c     basis species as the equivalent of a monovalent ion.
c
      call csigm(conc,jcsort,narn1,narn2,nstmax,sigmmc)
      sigmam = sigmmc + azdel
c
c     Calculate a starting value for the ionic strength (fxi).
c     Treat the calculated charge imbalance among the basis species
c     as the equivalent of a monovalent ion.
c
      call cfxi(conc,fxic,jcsort,narn1,narn2,nstmax,zchsq2)
      fxi = fxic + 0.5*azdel
c
c     Calculate a starting value for the J electrostatic moment
c     function (fje). Treat the calculated charge imbalance among
c     the basis species as the equivalent of a monovalent ion.
c
      call cfje(conc,fjec,jcsort,narn1,narn2,nstmax,zchcu6)
      fje = fjec + (-zdel/6.)
c
c     Calculate the activity coefficients of aqueous species.
c     Note that this also gets the starting value for the mole
c     fraction of water.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call gcoeff(abar,acflg,actwlc,adh,adhh,adhv,al10,
     $ aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ cco2,conc,delam,dgpit,dpelm,dpslm,dselm,elam,fje,fxi,gpit,
     $ ielam,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta,insgf,
     $ iopg,ipbtmx,izmax,jcsort,nalpha,napmax,napt,narn1,narn2,
     $ natmax,nazmmx,nazpmx,nchlor,nhydr,nmut,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,nopgmx,noutpt,nslt,nsltmx,nslx,nstmax,nsxi,
     $ nsxmax,nsxx,nttyo,omega,palpha,pelm,pmu,press,pslamn,
     $ pslm,qhawep,qpit75,selm,sigmam,tempk,uspec,xbarwc,xbrwlc,
     $ zchar,zchsq2,zchcu6)
c
c     Calculate the activity coefficients of exchanger species.
c
c     Calling sequence substitutions:
c       acflg for acflgc
c
      call lamgex(acflg,cgexj,jern1,jern2,jetmax,jgext,net,
     $ netmax,nstmax,xbarlg)
c
c     Initialize the mole fraction of water.
c
      xbrwlg = xbrwlc
      xbarw = xbarwc
c
c     Copy the ionic strength, etc., and the activity coefficients.
c
      sigmmo = sigmam
      fxio = fxi
      fjeo = fje
      do ns = narn1,narn2
        acflgo(ns) = acflg(ns)
      enddo
c
c     Load the entries of the conclg array corresponding
c     to active basis species.
c
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns = nbasp(nb)
        cx = conc(ns)
        conclg(ns) = tlg(cx)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine whether the constraints fix the activity of water.
c     If so, the variable qawfix is set to .true.
c
      call dawfix(aamatr,cdrs,eps100,gmmatr,iindx1,iodb,
     $ irdxc3,jflag,jjndex,kbt,kkndex,kmax,narn1,nbasp,nbtmax,ncosp,
     $ ndrs,ndrsmx,ndrsr,nelect,nhydr,nodbmx,no2gaq,noutpt,nstmax,
     $ qawfix,uspec)
c
cXX   Need new coding to deal with phases assemblages that fix a(w).
cXX   Such assemblages are now merely trapped.
c
c     Coding to deal with phase assemablages that fix the activity of
c     water has not yet been implemented. Stop if this condition has
c     been detected. The needed new coding is in EQ3NR/arrset.f and
c     EQ3NR/ arrsim.f. If the following trap were not in place, the
c     matrix constructed below in this subroutine would be singular.
c     There should be no problem, however, in the coding for the hybrid
c     Newton-Raphson method.
c
      if (qawfix) then
        write (noutpt,1100)
        write (nttyo,1100)
 1100   format(/' * Error - (EQ3NR/arrset) The phase assemblage',
     $  /7x,'corresponding to the specified solubility constraints',
     $  /7x,'fixes the activity of water. This code is presently',
     $  /7x,'unable to solve problems of this type.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here npass is the pass counter.
c
      npass = 0
c
c     The label below is a return point for subsequent passes. A pass
c     is an adjustment for the ionic strength, etc., the activity of
c     water, and the activity coefficients of the solute species.
c
  210 npass = npass + 1
c
c     Note:
c
c       betfnc = convergence function
c       negbfc = the number of successive iterations that the
c                convergence function betfnc has been zero or negative
c
      betfnc = 0.
      negbfc = 0
      btmxoe = 0.
      btmxoo = 0.
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1110) npass
 1110   format(/11x,'npass= ',i2)
        write (noutpt,1120) sigmam,fxi,fje,xbrwlc,xbarwc
 1120   format(/13x,'sigmam= ',1pe12.5,/13x,'fxi= ',1pe12.5,
     $  /13x,'fje= ',1pe12.5,
     $  //13x,'xbrwlc= ',0pf9.5,/13x,'xbarwc= ',1pe12.5,/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Here ncycle is the cycle counter.
c
      ncycle = 0
c
c     The label below is a return point for beginning a new cycle.
c     A cycle is an structure within a pass in which the concentrations
c     of the basis species are adjusted, while the ionic strength, etc.,
c     and the activity coefficients are held constant.
c
  220 ncycle = ncycle + 1
      if (iodb(3) .ge. 1) write (noutpt,1200) ncycle
 1200 format(16x,'ncycle= ',i2)
      ker = 0
      qabsw = iopt(11).ge.1 .and. npass.eq.1 .and. ncycle.eq.1
c
c     Set up the zvclg1 and actlg array entries for the basis species
c     whose concentrations do not have to be estimated simultaneously.
c
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns = nbasp(nb)
        if (ns.ge.narn1 .and. ns.le.narn2) then
          jfl = jflag(ns)
          if (kcol .eq. kwater) then
            zvclg1(kcol) = xbrwlg
            actlg(narn1) = xbrwlg + acflg(narn1)
          elseif (jfl .le. 15) then
            zvclg1(kcol) = conclg(ns)
            actlg(ns) = conclg(ns) + acflg(ns)
          elseif (jfl .eq. 16) then
            zvclg1(kcol) = coval(ns) - acflg(ns)
            conclg(ns) = zvclg1(kcol)
            actlg(ns) = conclg(ns) + acflg(ns)
          elseif (jfl.eq.19 .or. jfl.eq.20) then
            zvclg1(kcol) = -coval(ns) - acflg(ns)
            conclg(ns) = zvclg1(kcol)
            actlg(ns) = conclg(ns) + acflg(ns)
          elseif (jfl.eq.22 .or. jfl.eq.23) then
            zvclg1(kcol) = -coval(ns)
            conclg(ns) = zvclg1(kcol)
            actlg(ns) = conclg(ns) + acflg(ns)
          endif
        elseif (ns.ge.nern1 .and. ns.le.nern2) then
          zvclg1(kcol) = conclg(ns)
          actlg(ns) = cjbasp(nb)*(xbarlg(ns) + acflg(ns))
        else
          zvclg1(kcol) = tlg(coval(nb)) + xbarlg(ns)
          actlg(ns) = xbarlg(ns) + acflg(ns)
        endif
      enddo
c
      if (irdxc3 .eq. 0) then
        if (ko2gaq .gt. 0) then
          zvclg1(ko2gaq) = fo2lg
          actlg(no2gaq) = fo2lg
        endif
        if (kelect .gt. 0) then
          zvclg1(kelect) = -pe
          actlg(nelect) = -pe
        endif
      endif
c
c     Make starting estimates that must be evaluated simultaneously.
c     These include all cases of equilibrium constraints and compount
c     activity constraints (e.g. pHCl) and any case in which log fO2
c     log fO2 is constrained by Eh, pe-, or a redox couple.
c
      call arrsim(aamatr,acflg,actlg,bbig,cdrs,cjbasp,cnufac,
     $ conc,conclg,coval,delvec,dlogxw,eh,ehfac,eps100,gmmatr,iction,
     $ iindx1,iodb,ipivot,irdxc3,ixbasp,jcsort,jflag,jjndex,kbt,ker,
     $ khydr,kkndex,kmax,kwater,narn1,narn2,nbasp,nbt,nbti,nbtmax,
     $ nbw,ncosp,ndecsp,ndrs,ndrsmx,ndrsr,nelect,nern1,nern2,nhydr,
     $ nodbmx,no2gaq,noutpt,npass,nredox,nstmax,nttyo,omega,qawfix,
     $ rhsvec,ucospi,uspec,xbar,xbarlg,xbarw,xbrwlg,xlke,xlks,
     $ zchar,zvclg1)
c
c     Recalculate the concentrations, etc., of dependent species.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
      xbarw = xbar(narn1)
      xbrwlg = xbarlg(narn1)
c
c     Compute the residuals.
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
c     Calculate the beta convergence function.
c
      betfnc = 0.
      if (mod(ncycle,2) .eq. 0) then
        if (btmxoe .ge. smp100) betfnc = (btmxoe - betamx)/btmxoe
        btmxoe = betamx
      else
        if (btmxoo .ge. smp100) betfnc = (btmxoo - betamx)/btmxoo
        btmxoo = betamx
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print values of master iteration variables.
c
      if (iodb(3) .ge. 2) then
        write (noutpt,1230)
 1230   format(//10x,'--- Pre-Newton-Raphson Optimization Summary ---',
     $  //2x,'kcol   Name',32x,'zvclg1      zvec1',/)
        do kcol = 1,kdim
          nb = iindx1(kcol)
          ns = nbasp(nb)
          zx1 = zvclg1(kcol)
          zx2 = texp(zx1)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1240) kcol,uspn56,zx1,zx2
 1240     format(1x,i4,2x,a32,2x,f10.4,2x,1pe12.5)
        enddo
c
        write (noutpt,1250)
 1250   format(/2x,'krow   Name',32x,'Beta',/)
        do krow = 1,kdim
          nb = iindx1(krow)
          ns = nbaspd(nb)
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1260) krow,uspn56,beta(krow)
 1260     format(1x,i4,2x,a32,2x,1pe12.5)
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Identify the dominant species in each mass balance and
c     compute the corresponding exponent for a continued
c     fraction correction.
c
      call cfracf(cdrs,csts,efac,jcsort,jflag,jssort,kmax,mosp,
     $ narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $ nern2,nfac,nst,nstmax,nsts,nstsmx,nstsr,q6mode,weight)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Filter the data obtained from EQLIB/cfracf. The following
c     filters are specific to EQ3NR.
c
      if (iebal .gt. 0) then
c
c       For this species, a charge balance constraint is used instead
c       of a mass balance constraint.
c
        nfac(iebal) = 0
        efac(iebal) = 1.0
      endif
c
      if (nbw .gt. 0) then
c
c       For water, a mole fraction equation is used instead of a mass
c       balance constraint.
c
        nfac(nbw) = 0
        efac(nbw) = 1.0
      endif
c
      do nb = 1,nbt
        ns = nbasp(nb)
        if (ns.eq.nhydr .or. ns.eq.nhydx) then
c
c         For H+ or OH-, mass balance constraints are rarely used.
c
          if (jflag(ns) .gt. 15) then
c
c           In the present case, a mass balance constraint is not
c           being used.
c
            nfac(nb) = 0
            efac(nb) = 1.0
          endif
        elseif (ns.eq.no2gaq .or. ns.eq.nelect) then
c
c         For O2(g,aq) or e-, mass balance contraints are not used.
c
          nfac(nb) = 0
          efac(nb) = 1.0
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
c
c       Write a table containing the preliminary results.
c
        kount = 0
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          ns2 = nfac(nb)
          if (ns2.ne.0 .and. ns2.ne.ns) kount = kount + 1
        enddo
c
        if (kount .gt. 0) then
          write (noutpt,1300)
 1300     format(16x,'--- Mass Balance Dominants ---',/)
          write (noutpt,1310)
 1310     format(4x,'Master Species',21x,'Dominant Species',/)
          do kcol = 1,kbt
            nb = iindx1(kcol)
            ns = nbasp(nb)
            ns2 = nfac(nb)
            if (ns2.ne.0 .and. ns2.ne.ns) then
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(ns) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(ns),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(ns2) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(ns2),usp256)
              jlen2 = min(jlen2,32)
              write (noutpt,1320) usp156,usp256(1:jlen2)
 1320         format(2x,a32,3x,a)
            endif
          enddo
          write (noutpt,1030)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the bfac correction factor array. In the continued fraction
c     method, m(new) = m(old)/bfac, where bfac = (beta + 1)**efac.
c     If the same species dominates more than one mass balance,
c     then this algorithm can be applied to only one of the associated
c     basis species. Otherwise, oscillatory behavior will occur. In each
c     set of mass balances with a common dominating species, find the
c     mass balance with the greatest bfac factor. This is usually nearly
c     equivalent to finding the mass balance with the greater beta
c     residual, as efac often has a value of unity.
c
      call gbfac(beta,bfac,efac,iindx1,kbt,kmax,nbt,nbtmax,nfac)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3).ge.3 .and. .not.qbswx) then
c
c       Write a table containing the modified results.
c
        write (noutpt,1330)
 1330   format(/16x,'--- Factors for Continued Fraction',
     $  ' Corrections ---',/)
        write (noutpt,1340)
 1340   format(4x,'Master Species',22x,'bfac',10x,'efac',/)
        do nb = 1,nbt
          if (bfac(nb) .gt. 0.) then
            ns = nbasp(nb)
c
c           Calling sequence substitutions:
c             uspec(ns) for unam48
c
            call fmspnx(jlen,uspec(ns),uspn56)
            write (noutpt,1350) uspn56,bfac(nb),efac(nb)
 1350       format(2x,a32,3x,1pe12.5,3x,1pe12.5)
          endif
        enddo
        write (noutpt,1030)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qabsw .and. qloop .and. nloop.lt.nlopmx) then
c
c       In automatic basis switching mode (iopt(11) .ge. 1), try to
c       first reduce the magntiude of large positive mass balance
c       residuals by making one or more basis switches.
c
        call absswa(adhfs,adhfsx,advfs,advfsx,avcnst,axhfs,
     $  axhfsx,axlks,axlksx,axvfs,axvfsx,beta,cdrs,cdrsx,cdrtw,cdrw,
     $  csts,dhfs,dvfs,efac,eps100,ibswx,iebal,iindx1,iodb,ipch,ipchmx,
     $  ipcv,ipcvmx,jcsort,jflag,jsflag,jssort,kbt,kmax,mosp,narn1,
     $  narn2,narxmx,narxt,nbasp,nbaspd,nbaspx,nbt,nbtmax,nbw,ncosp,
     $  ndrs,ndrsmx,ndrsr,ndrsrx,ndrsx,nelect,nhydr,nodbmx,no2gaq,
     $  noutpt,nst,nstmax,nsts,nstsmx,nstsr,nswtch,ntpr,ntprmx,nttyo,
     $  presg,press,qbassw,qbswx,q6mode,tempc,uspec,uzvec1,weight,
     $  xvfs,xlks,xhfs)
c
        if (nswtch .le. 0) then
c
c         No switches were made.
c
          qloop = .false.
          go to 250
        endif
c
c       Reset the ixbasp and cjbasp arrays. The former is a flag
c       array, each member of which denotes whether the
c       thermodynamic activity of the corresponding basis species
c       is defined in terms of molality (= 0) or mole fraction (= 1).
c       The cjbasp array contains any site stoichiometric factors
c       associated with the operational basis species.
c
        call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $  jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $  netmax,nphasx,nstmax)
c
c       Null some arrays.
c
        do ns = 1,nstmax
          conc(ns) = 0.
        enddo
c
        av = -99999.
        call initav(conclg,nstmax,av)
c
        write (noutpt,1370) nloop,nswtch
        write (nttyo,1370) nloop,nswtch
 1370   format(8x,'Completed loop ',i3,' after making ',i3,
     $  ' basis switches.')
c
c       Go back for another loop.
c
        go to 200
      endif
  250 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the electrical balance residual.
c
      bxecor = 0.
      xecorr = 0.
      if (kebal .gt. 0) then
        ns = nbaspd(iebal)
        cecorr = -alpha(kebal)/zchar(ns)
        xecorr = zchsq2(ns)*cecorr
        call gszm(conc,jcsort,narn1,narn2,nstmax,sigza,sigzc,
     $  sigzi,sigzm,zchar)
        bxecor = abs(xecorr)/sigzm
      endif
c
      if (iodb(3) .ge. 1) then
c
c       Calling sequence substitutions:
c         jlen1 for jlen
c         ubbig for unam48
c         usp156 for uspn56
c
        call fmspnx(jlen1,ubbig,usp156)
c
c       Calling sequence substitutions:
c         jlen2 for jlen
c         ubneg for unam48
c         usp256 for uspn56
c
        call fmspnx(jlen2,ubneg,usp256)
c
        write (noutpt,1500) betamx,betfnc,bbig,usp156(1:jlen1),
     $  bneg,usp256(1:jlen2)
 1500   format(18x,'betamx= ',1pe12.5,', betfnc= ',1pe12.5,
     $  /18x,'  bbig= ',1pe12.5,', ubbig= ',a,
     $  /18x,'  bneg= ',1pe12.5,', ubneg= ',a,/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the balance residuals for mass and alkalinity to see if
c     another cycle should be made before attempting to make an improved
c     estimate of the ionic strength.
c
      qtestc = bbig.le.tolbig .and. bneg.ge.tolneg .and.
     $  betamx.le.tolxpt .and. bxecor.le.tolzpt
c
c     Quit doing cycles if:
c
c       1. The cycle convergence criteria are met.
c       2. The maximum number of cycles have been done.
c       3. The convergence function betfnc indicates that
c          the cycles are not converging.
c
      if (qtestc) go to 300
      if (ncycle .ge. ncylim) go to 300
      if (ncycle.gt.2 .and. betfnc.le.tolbtf) then
        negbfc = negbfc + 1
        if (negbfc .ge. 3) go to 300
      else
        negbfc = 0
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make improvements in concentration estimates and go back for
c     another cycle. The algorithm employed here is the modified
c     continued fraction method. Note that some constraints are placed
c     on the use of the bfac correction factors. One is to avoid a
c     blow-out in taking the base ten logarithm of such a factor, which
c     would occur if the factor had a zero or negative value. Another
c     limits the magnitude of the change in one step.
c
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns = nbasp(nb)
        if (nb.ne.iebal .and. ns.ne.narn1) then
          jfl = jflag(ns)
          bxp1 = beta(kcol) + 1.
          if (jfl.ge.0 .and. jfl.le.3) then
            dx = bfac(nb)
            lx = tlg(dx)
            if (lx .gt. 20.) lx = 20.
            conclg(ns) = conclg(ns) - lx
          elseif (jfl.ge.7 .and. jfl.le.11) then
            if (bxp1 .le. 0.) bxp1 = 1.e-20
            lx = tlg(bxp1)
            if (lx .gt. 20.) lx = 20.
            conclg(ns) = conclg(ns) - lx
          endif
        endif
      enddo
c
      if (iebal .gt. 0) then
c
c       Electrical balance correction. Skip if mass balance
c       residuals are way off.
c
        if (bbig.le.0.25 .and. bneg.ge.-0.25) then
          ns = nbasp(iebal)
          cxo = conclg(ns)
          cxn = conc(ns) + cecorr
          if (cecorr .ge. 0.) then
            cx = tlg(cxn)
            cxl = cxo + 2.0
            conclg(ns) = min(cx,cxl)
          else
            if (cxn .lt. 0.) cxn = 0.
            cx = tlg(cxn)
            cxl = cxo - 2.0
            conclg(ns) = max(cx,cxl)
          endif
        endif
      endif
c
c     Go back for another cycle.
c
      go to 220
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The cycles for the current pass have been completed. Test to
c     see if another pass should be made.
c
  300 write (noutpt,1620) npass,ncycle
      write (nttyo,1620) npass,ncycle
 1620 format(13x,'Completed pass ',i3,' in ',i3,' cycles.')
c
c     Save the current values of the ionic strength, etc., and of the
c     the ativity coefficients.
c
      sigmmo = sigmam
      fxio = fxi
      fjeo = fje
      do ns = narn1,narn2
        acflgo(ns)=acflg(ns)
      enddo
c
c     Determine the maximum allowed change factors for "Sigma m",
c     etc. (chfsgm) and the log activity coefficients for aqueous
c     species (chfacf).
c
      chfsgm = 1.3
      if (sigmam .le. 2.e-1) chfsgm = 5.
      if (sigmam .le. 1.e-2) chfsgm = 10.
      if (sigmam .le. 1.e-3) chfsgm = 100.
      if (qtestc .and. chfsgm.lt.100.) chfsgm = 100.
      chfacf = 0.05
c
c     Note: setting iter = 0 would fix the activity coefficients
c     in concentrated solutions. Setting it to a high value (here
c     99999) insures that the activity coefficients are recalculated
c     as desired.
c
      iter = 99999
      rlxgam = 1.0
      qpracf = iodb(3) .ge. 4
c
      call ngcadv(abar,acflg,acflgo,actwlc,adh,adhh,adhv,
     $ afcnst,al10,aphi,azero,a3bar,a3bars,bacfmx,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,bgamx,bpx,bsigmm,bfje,bfxi,cco2,cgexj,
     $ chfacf,chfsgm,conc,delam,dgpit,dpelm,dpslm,dselm,elam,
     $ eps100,fje,fjeo,fxi,fxio,gpit,ibpxt,ielam,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilzeta,insgf,iopg,iter,ipndx1,ixrn1,
     $ ixrn2,izmax,jcsort,jern1,jern2,jgext,jsol,kx1,kxt,nalpha,
     $ napt,narn1,narn2,nchlor,ncmpr,net,nhydr,nmut,nmux,nmxi,
     $ nmxx,noutpt,nslt,nslx,nst,nsxi,nsxx,nttyo,omega,palpha,
     $ pelm,pmu,press,pslamn,pslm,qhawep,qpit75,qpracf,q6mode,
     $ rlxgam,selm,sigmam,sigmmo,tempk,ubacmx,ubgamx,uphase,
     $ uspec,wfac,xbar,xbarlg,xbarwc,xbrwlc,zchar,zchcu6,zchsq2)
c
c     Recalculate the concentrations, etc., of dependent species.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
      xbarw = xbar(narn1)
      xbrwlg = xbarlg(narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 1) then
        write (noutpt,1510) bsigmm
 1510   format(/13x,'bsigmm= ',1pe12.5)
        write (noutpt,1520) bfxi
 1520   format(13x,'bfxi= ',1pe12.5)
        write (noutpt,1522) bfje
 1522   format(13x,'bfje= ',1pe12.5)
        j2 = ilnobl(ubgamx(1:24))
        write (noutpt,1530) bgamx,ubgamx(1:j2)
 1530   format(13x,'bgamx= ',1pe12.5,', ubgamx= ',a)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qcsigm =abs(bsigmm) .le. tolgpt
      qcfxi = abs(bfxi) .le. tolgpt
      qcgam = bgamx .le. tolgpt
c
      qtestp = qcsigm .and. qcfxi .and. qcgam
c
c     Are pass criteria satisfied?
c
      if (.not.qtestp) then
c
c       Pass criteria are not satisfied. Test for maximum number
c       of passes.
c
        if (npass .ge. nplim) then
c
c         Quit. Optimization ended outside requested limits
c         because the pass requirements were not satisfied.
c
          if (ker .lt. 2) then
            write (noutpt,1600)
            write (nttyo,1600)
 1600       format(/'   Done. Optimization ended outside requested',
     $      ' limits.',/)
          else
            write (noutpt,1610)
            write (nttyo,1610)
 1610       format(/'   Done. Optimization ended outside allowable',
     $      ' limits.',/)
          endif
          go to 999
        endif
c
c       Do another pass.
c
        go to 210
      endif
c
c     Are cycle criteria satisfied?
c
      if (qtestc) then
c
c       Yes, optimization succeeded.
c
        write (noutpt,1630)
        write (nttyo,1630)
 1630   format(/'   Done. Optimization ended within requested',
     $  ' limits.',/)
        go to 999
c
      elseif (npass .le. 2) then
c
c       The pass convergence criteria are satisfied, but the cycle
c       convergence criteria are not. Try another pass.
c
        go to 210
      else
c
c       Quit. Optimization ended outside requested limits
c       because cycle requirements were not met.
c
        if (ker .lt. 2) then
          write (noutpt,1600)
          write (nttyo,1600)
        else
          write (noutpt,1610)
          write (nttyo,1610)
        endif
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      module mod6xf
c
c     This module contains standard state thermodynamic data and
c     standard grid pressure data. This excludes interpolating
c     polynomial coefficient arrays belonging to the 'a' set (e.g.,
c     axhfsa, axlksa, axvfsa) which includes all such data read
c     from the data file. Included here are the "compressed"
c     equivalents.,
c
c     Pressure parameters.
c
      real(8) prehw,presg
c
      real(8), dimension(:,:), allocatable :: aprehw,apresg
c
c     "Eh reaction" parameters.
c
      real(8) xhfe,xlke,xvfe
c
      real(8), dimension(:), allocatable :: dhfe,dvfe
      real(8), dimension(:,:), allocatable :: axlke,axhfe,axvfe
      real(8), dimension(:,:,:), allocatable :: adhfe,advfe
c
c     Regular reaction parameters.
c
      real(8), dimension(:), allocatable :: xhfs,xhfsd,xlks,xlksd,
     $ xvfs,xvfsd
c
      real(8), dimension(:,:), allocatable :: dhfs,dhfsd,dvfs,dvfsd
c
      real(8), dimension(:,:,:), allocatable :: axhfs,axhfsd,axhfsx,
     $ axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx
c
      real(8), dimension(:,:,:,:), allocatable :: adhfs,adhfsd,adhfsx,
     $ advfs,advfsd,advfsx
c
      end module mod6xf

      subroutine nactop(iopg,nopgmx,noutpt,nttyo,uactop)
c
c     This subroutine sets the name of the option ("uactop") for
c     computing the activity coefficients of aqueous species. It
c     also sets associated logical flags concerning the generic type
c     of activity coefficient option. The variable "iopg(1)" determines
c     the exact activity coefficient model.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       iopg   = array of activity coefficient option switches
c
c     Principal output:
c
c       uactop = string describing the activity coefficient model
c                  corresponding to iopg(1)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nopgmx
c
      integer iopg(nopgmx)
      integer noutpt,nttyo
c
      character*32 uactop
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
      if (iopg(1) .eq. -1) then
c
c       The Davies equation.
c
        uactop = 'the Davies equation'
      elseif (iopg(1) .eq. 0) then
c
c       The B-dot equation.
c
        uactop = 'the B-dot equation'
      elseif (iopg(1) .eq. 1) then
c
c       Pitzer's equations.
c
        uactop = "Pitzer's equations"
      elseif (iopg(1) .eq. 2) then
c
c       The HC + DHC equations.
c
        uactop = 'the HC + DH equations'
      else
c
c       Have an error.
c
        write (noutpt,1000) iopg(1)
        write (nttyo,1000) iopg(1)
 1000   format(/' * Error - (EQLIBG/nactop) Have iopg(1) = ',i3,'.',
     $  /7x,'This does not correspond to a valid option for computing',
     $  /7x,'the activity coefficients of aqueous species.')
          stop
      endif
c
      end

      subroutine rd6d7(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $ dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $ imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $ jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $ hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $ nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,nopgmx,
     $ noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,
     $ nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,
     $ nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $ qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,
     $ toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,uendb,
     $ uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,uxmd24,
     $ uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,zklogl,
     $ zklogu,zvclgi)
c
c     This subroutine reads the EQ6 input file in menu-style ("D")
c     format for versions 7.0-7.2. It thus encompasses two version
c     levels, '7.0' and '7.2'. The input file in this format is not
c     identical for these two version levels. However, the line
c     parsing capability can handle the differences, which consist
c     only of differences in field sizes.
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nctmax,ndctmx,nffgmx,nodbmx,
     $ nopgmx,noprmx,noptmx,nprsmx,nrctmx,nsrtmx,nsscmx,ntitmx,
     $ nttkmx,nxmdmx,nxopmx,nxpemx,nxrtmx
c
      integer iact(imchmx,2,nrctmx),iktbt(nxrtmx),imech(2,nrctmx),
     $ iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jcode(nrctmx),jreac(nrctmx),jxmod(nxmdmx),kxmod(nxmdmx),
     $ ndact(imchmx,2,nrctmx),nesrbt(nsrtmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ioscan,itermx,jtemp,kct,kdim,ksq,kmt,kprs,ksppmx,kstpmx,
     $ kxt,nffg,ninpts,nmodl1,nmodl2,nordlm,npslmx,nprmn,nprmx,nrct,
     $ nsslmx,ntitl1,ntitl2,ntrymx,nttyo,nxmod,nxopex,nxopt
c
      logical qend,qrderr
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*48 uprs(nprsmx)
      character*24 udac(ndctmx,imchmx,2,nrctmx),uendb(iktmax,nxrtmx),
     $ uffg(nffgmx),undms(kmax),unrms(kmax),ureac(nrctmx),
     $ uxmd24(nxmdmx),uxopex(nxpemx)
      character*16 uxct16(nxopmx)
      character*8 uelemb(nctmax),uesrb(nctmax,nsrtmx),uxopt(nxopmx)
c
      real*8 cdac(ndctmx,imchmx,2,nrctmx),cesrb(nctmax,nsrtmx),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),fk(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprs(nprsmx),mteaqb(nctmax),mteb(nctmax),rk0(imchmx,2,nrctmx),
     $ rxbarb(iktmax,nxrtmx),sscrew(nsscmx),sk(nrctmx),ttk(nttkmx),
     $ trk0(imchmx,2,nrctmx),vreac(nrctmx),xlkffg(nffgmx),
     $ xlkmod(nxmdmx),zvclgi(kmax)
c
      real*8 dlzmx1,dlzmx2,dlzidp,dzprlg,dzprnt,electr,tempci,tempc0,
     $ timemx,tolbt,toldl,tolsat,tolsst,tolx,tstrt,zkfac,zklogl,zklogu,
     $ zimax,zistrt
c
c-----------------------------------------------------------------------
c
      include 'xcon6/x6op7.h'
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
c       nfldpa = maximum number of fields per line
c       nlchpa = character length of a line
c
      integer nfldpa,nlchpa
c
      parameter (nfldpa = 8,nlchpa = 80)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,im,idesc,idescx,iktb,ivar,j,jdesc,j1,j2,ksb,
     $ n,ncb,nfldmx,nfldt,nfldtx,nlchmx,nmark,nmarks,nrc,
     $ nsrt,nxrt
c
      integer ilnobl
c
      character*(nlchpa) ufield(nfldpa)
      character*(nlchpa) uline1,uline2,ulscr
      character*(nlchpa) uheadr,uheadx
c
      character*80 ustr
      character*24 ux
      character*1 ux1
c
      real*8 var
c
c-----------------------------------------------------------------------
c
      nfldmx = nfldpa
      nlchmx = nlchpa
c
      qrderr = .false.
c
c-----------------------------------------------------------------------
c
c     Title.
c
      qend = .false.
      read (ninpts,1000,end=100,err=990) uline1
 1000 format(a80)
      call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
      ustr = ufield(1)
      if (ustr(1:8) .ne. '--------') then
        write (nttyo,1010) uline1
 1010   format(/' * Error - (XCON6/rd6d7) The first line of a "D"',
     $  /7x,'format input file must begin with "|--------".',
     $  /7x,'The first line read from the old input file begins with-',
     $  /7x,'"',a70,'".')
        go to 990
      endif
      go to 105
c
  100 qend = .true.
      go to 999
c
  105 do 110 n = 1,ntitmx + 1
        read (ninpts,1000,err=990) uline1
        call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
        ustr = ufield(1)
        if (ustr(1:8) .eq. '--------') go to 120
        utitl1(n) = ufield(1)
  110 continue
c
      write (nttyo,1015) ntitmx
 1015 format(/' * Error - (XCON6/rd6d7) Have too many lines in the',
     $ /7x,'main title. The code is only dimensioned for ',i4,
     $ /7x,'lines. Reduce the size of the title or increase the',
     $ /7x,'dimensioning parameter ntitpa.')
      go to 990
c
  120 ntitl1 = n - 1
c
c-----------------------------------------------------------------------
c
c     Nmodl option switches.
c
      nmodl2 = 0
      nmodl1 = 0
c
      uheadx = 'calculational mode'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      call gmarko(nfldmx,nfldt,nmark,nttyo,ufield,uline1)
      if (nmark .gt. 0) nmodl2 = nmark - 2
c
      uheadx = 'model type'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      call gmarko(nfldmx,nfldt,nmark,nttyo,ufield,uline1)
      if (nmark .gt. 0) nmodl1 = nmark - 1
c
c-----------------------------------------------------------------------
c
c     Temperature parameters.
c     Note: ttk(1) = tk1, etc.
c
      jtemp = 0
c
      uheadx = 'temperature model'
      nfldtx = 3
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      call gmarko(nfldmx,nfldt,nmark,nttyo,ufield,uline1)
      if (nmark .gt. 0) jtemp = nmark - 2
c
      uheadx = 'tstart(c)'
      nfldtx = 8
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      tempc0 = var
      do 130 i = 1,3
        ustr = ufield(2*i + 2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        ttk(i) = var
  130 continue
c
c-----------------------------------------------------------------------
c
c     Zi and time parameters.
c
c     Note: cplim does not appear on the "D" format input file.
c
      uheadx = 'starting value of zi'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      zistrt = var
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      zimax = var
c
      uheadx = 'starting time (sec)'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      tstrt = var
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      timemx = var
c
      uheadx = 'max. steps'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      kstpmx = ivar
      ustr = ufield(4)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      ksppmx = ivar
c
c-----------------------------------------------------------------------
c
c     Print interval parameters.
c
      uheadx = 'linear print interval'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      dzprnt = var
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      dzprlg = var
c
c-----------------------------------------------------------------------
c
c     Plot interval parameters.
c
c     Note: dzplot, dzpllg, and ksplmx currently do not appear on the
c     "D" format input file.
c
c-----------------------------------------------------------------------
c
c     Ifile.
c
c     Note: ifile does not appear on the "D" format input file.
c
c-----------------------------------------------------------------------
c
c     Nxopt mineral subset selection suppression options.
c
      nxopt = 0
c
      uheadx = 'suppress mineral phases'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      uheadx = 'phases w/ elements'
      nfldtx = 3
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
c
  140 do 150 n = 2,3
        ustr = ufield(n)
        call locase(ustr)
        if (ustr(1:8) .ne. '        ') then
          nxopt = nxopt + 1
c
          if (nxopt .gt. nxopmx) then
            write (nttyo,1025) nxopmx
 1025       format(/' * Error - (XCON6/rd6d7) Have too many mineral',
     $      /7x,'subset-selection suppression options. The code is',
     $      /7x,'only dimensioned for ',i3,' such options. Reduce the',
     $      /7x,'number of options or increase the dimensioning',
     $      /7x,'parameter nxoppa.')
            go to 990
          endif
c
          if (ustr(1:8) .eq. 'all     ') then
            uxopt(nxopt) = 'all'
            uxct16(nxopt) = '        '
          else
            uxopt(nxopt) = 'alwith'
            uxct16(nxopt) = ustr
          endif
        endif
  150 continue
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 175
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        nfldtx = 3
        if (nfldt .ne. nfldtx) then
          write (nttyo,1030) nfldt,nfldtx,uline1
 1030     format(/' * Warning - (XCON6/rd6d7) Found ',i2,' fields',
     $    /7x,'where ',i2,' were expected on the line beginning with-',
     $    /7x,'"',a70,'".')
        endif
        go to 140
      endif
c
      nxopex = 0
c
      uheadx = 'phases except'
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
 1020   format(/' * Error - (XCON6/rd6d7) Was expecting to find the',
     $  /7x,'header beginning with-',/7x,'"',a70,'"',
     $  /7x,'on the line beginning with-',/7x,'"',a70,'".')
        go to 990
      endif
c
  160 do 170 n = 2,3
        ustr = ufield(n)
        if (ustr(1:8) .ne. '        ') then
          nxopex = nxopex + 1
c
          if (nxopex .gt. nxpemx) then
            write (nttyo,1027) nxpemx
 1027       format(/' * Error - (XCON6/rd6d7) Have too many',
     $      /7x,'exceptions specified to the mineral subset-selection',
     $      /7x,'suppression options. The code is only dimensioned',
     $      /7x,'for ',i3,'exceptions. Reduce the number of exceptions',
     $      /7x,'or increase the dimensioning parameter nxoppa.')
            go to 990
          endif
c
          uxopex(nxopex) = ustr
        endif
  170 continue
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        nfldtx = 3
        if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
        go to 160
      endif
c
      ustr = ufield(1)
      if (ustr(1:8) .ne. '--------') then
        write (nttyo,1040) uline1
 1040   format(/' * Error - (XCON6/rd6d7) Found the line beginning',
     $  ' with-',/7x,'"',a70,'"',
     $  /7x,'where a dashed separator line was expected.')
        go to 990
      endif
c
  175 continue
c
c-----------------------------------------------------------------------
c
c     Nffg options.
c
      nffg = 0
c
      uheadx = 'fixed fugacity phases- species, '
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:4) .eq. 'none') go to 190
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
  180 nffg = nffg + 1
c
      if (nffg .gt. nffgmx) then
        write (nttyo,1035) nffgmx
 1035   format(/' * Error - (XCON6/rd6d7) Have too many gases whose',
     $  /7x,'fugacities are to be fixed. The code is only dimensioned',
     $  /7x,'for ',i4,' such gases. Reduce the number of gases or',
     $  /7x,'increase the dimensioning parameter nffgpa.')
        go to 990
      endif
c
      uffg(nffg) = ufield(1)
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      moffg(nffg) = var
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      xlkffg(nffg) = var
c
  190 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 200
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
      go to 180
c
c     Read a second dashed separator line.
c
  200 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .ne. '--------') then
        write (nttyo,1040) uline1
        go to 990
      endif
c
c-----------------------------------------------------------------------
c
c     Reactants.
c
      nrct = 0
      nsrt = 0
      nxrt = 0
c
      uheadx = 'reactants'
      nfldtx = 1
      call rdd2l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
  210 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      ustr = ufield(1)
      if (ustr(1:8).eq.'--------') go to 330
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      uheadx = 'REACTANT '
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      ustr = ufield(2)
      call locase(ustr)
      if (ustr(1:4) .eq. 'none') then
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        if (ustr(1:8) .ne. '--------') then
          write (nttyo,1040) uline1
          go to 990
        endif
        go to 330
      endif
c
  215 nrc = nrc + 1
c
      if (nrc .gt. nrctmx) then
        write (nttyo,1037) nrctmx
 1037   format(/' * Error - (XCON6/rd6d7) Have too many reactants',
     $  /7x,'The code is only dimensioned for ',i4,' reactants.',
     $  /7x,'Reduce the number of reactants or increase the',
     $  /7x,'dimensioning parameter nrctpa.')
        go to 990
      endif
c
      nrct = nrc
      ureac(nrc) = ufield(2)
      ustr = ufield(4)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      jreac(nrc) = ivar
c
      uheadx = 'moles remaining'
      nfldtx = 4
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      morr(nrc) = var
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      modr(nrc) = var
c
      uheadx = 'reactant type'
      nfldtx = 4
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      if (ustr(1:7) .eq. 'mineral') then
        jcode(nrc) = 0
      elseif (ustr(1:14) .eq. 'solid solution') then
        jcode(nrc) = 1
      elseif (ustr(1:7) .eq. 'special') then
        jcode(nrc) = 2
      elseif (ustr(1:7) .eq. 'aqueous') then
        jcode(nrc) = 3
      elseif (ustr(1:3) .eq. 'gas') then
        jcode(nrc) = 4
      else
        jcode(nrc) = 0
      endif
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      sk(nrc) = var
c
      uheadx = 'surface type'
      nfldtx = 4
      call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      nsk(nrc) = ivar
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      fk(nrc) = var
c
      if (jcode(nrc) .eq. 1) then
        nxrt = nxrt + 1
c
        if (nxrt .gt. nxrtmx) then
          write (nttyo,1038) nxrtmx
 1038     format(/' * Error - (XCON6/rd6d7) Have too many solid',
     $    /7x,'solution reactants. The code is only dimensioned',
     $    /7x,'for ',i4,' such reactants. Reduce the number of such',
     $    /7x,'reactants or increase the dimensioning parameter',
     $    ' nxrtpa.')
          go to 990
        endif
c
        uheadx = 'end-member'
        nfldtx = 4
        call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
        if (qrderr) go to 999
c
        iktb = 0
  220   iktb = iktb + 1
c
        if (iktb .gt. iktmax) then
          write (nttyo,1039) ureac(nrc),iktmax
 1039     format(/' * Error - (XCON6/rd6d7) Have too many end-members',
     $    /7x,'in the solid solution reactant "',a24,'".',
     $    /7x,'The code is only dimensioned for ',i4,' end-members per',
     $    /7x,'solid solution. Reduce the number of end-members or',
     $    /7x,'increase the dimensioning parameter iktpar.')
          go to 990
        endif
c
        uendb(iktb,nxrt) = ufield(2)
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        rxbarb(iktb,nxrt) = var
c
        nfldtx = 4
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadr = ufield(1)
        call locase(uheadr)
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
        if (j .gt. 0) go to 220
        iktbt(nxrt) = iktb
      else
        uheadx = 'end-member'
        nfldtx = 4
  230   call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadr = ufield(1)
        call locase(uheadr)
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
        if (j .gt. 0) go to 230
      endif
c
      if (jcode(nrc) .eq. 2) then
        nsrt = nsrt + 1
c
        if (nsrt .gt. nsrtmx) then
          write (nttyo,1042) nsrtmx
 1042     format(/' * Error - (XCON6/rd6d7) Have too many special',
     $    /7x,'reactants. The code is only dimensioned for ',i4,
     $    /7x,'such reactants. Reduce the number of such reactants',
     $    /7x,'or increase the dimensioning parameter nsrtpa.')
          go to 990
        endif
c
        nrct = nrc
        uheadx = 'volume'
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
        if (j .eq. 0) then
          write (nttyo,1020) uheadx,uline1
          go to 990
        endif
        ustr = ufield(2)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        vreac(nsrt) = var
c
        uheadx = 'element'
        nfldtx = 4
        call rdd1lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uheadr,uheadx,uline1,ulscr)
        if (qrderr) go to 999
c
        ncb = 0
  240   ncb = ncb + 1
c
        if (ncb .gt. nctmax) then
          write (nttyo,1044) ureac(nrc),nctmax
 1044     format(/' * Error - (XCON6/rd6d7) Have too many chemical',
     $    /7x,'elements in the special  reactant "',a24,'".',
     $    /7x,'The code is only dimensioned for ',i4,' elements.',
     $    /7x,'Reduce the number of elements or increase the',
     $    /7x,'dimensioning parameter nctpar.')
          go to 990
        endif
c
        uesrb(ncb,nsrt) = ufield(2)
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        cesrb(ncb,nsrt) = var
c
        nfldtx = 4
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadr = ufield(1)
        call locase(uheadr)
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
        if (j .gt. 0) go to 240
        nesrbt(nsrt) = ncb
      else
        uheadx = 'volume'
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
c
        uheadx = 'element'
        nfldtx = 4
  250   call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        uheadr = ufield(1)
        call locase(uheadr)
        j2 = ilnobl(uheadx)
        j = index(uheadr,uheadx(1:j2))
        if (j .gt. 0) go to 250
      endif
c
      uheadx = 'DISSOLUTION LAW'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      nrk(1,nrc) = ivar
c
c     Rate law parameters, forward direction.
c
      nfldtx = 4
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      if (nrk(1,nrc) .le. 0) then
        imech(1,nrc) = 0
        go to 290
      endif
c
      im = 0
  260 im = im + 1
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      uheadx = 'PRECIPITATION LAW'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        im = im - 1
        go to 290
      endif
c
      if (nrk(1,nrc) .le. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      uheadx = 'rate constant rk'
      write (ux1,'(i1)') im
      uheadx(17:17) = ux1(1:1)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      if (im .gt. imchmx) then
        write (nttyo,1045) ureac(nrc),imchmx
 1045   format(/' * Error - (XCON6/rd6d7) Have too many rate',
     $  /7x,'constants in the forward direction rate law for',
     $  /7x,'reactant "',a24,'". The code is only',
     $  /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $  /7x,'Reduce the number of rate constants or increase the',
     $  /7x,'dimensioning parameter imchpa.')
        go to 990
      endif
c
      i = im
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      rk0(i,1,nrc) = var
      if (nrk(1,nrc) .eq. 2) then
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        csigma(i,1,nrc) = var
      endif
c
      if (nrk(1,nrc) .eq. 1) go to 280
c
      n = 0
      uheadx = 'aqueous species'
      nfldtx = 4
  270 call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        n = n + 1
c
        if (n .gt. ndctmx) then
          write (nttyo,1046) ureac(nrc),i,ndctmx
 1046     format(/' * Error - (XCON6/rd6d7) Have too many species',
     $    /7x,'in the activity product in term ',i2,' of the',
     $    /7x,'forward direction rate law for reactant',
     $    /7x,'"',a24,'". The code is only dimensioned for ',i3,
     $    /7x,'such species. Reduce the number of such species',
     $    /7x,'or increase the dimensioning parameter ndctpa.')
        go to 990
        endif
c
        udac(n,i,1,nrc) = ufield(2)
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        cdac(n,i,1,nrc) = var
        go to 270
      endif
      ndact(i,1,nrc) = n
c
      uheadx = 'PRECIPITATION LAW'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) go to 290
c
      uheadx = 'temperature (c)'
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      trk0(i,1,nrc) = var
c
      iact(i,1,nrc) = 0
c
      nfldtx = 4
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
c
      uheadx = 'PRECIPITATION LAW'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) go to 290
c
      uheadx = 'rate constant rk'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) go to 260
c
      uheadx = 'act. energy-kcal'
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      eact(i,1,nrc) = var
      if (var .gt. 0.) iact(i,1,nrc) = 1
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      hact(i,1,nrc) = var
      if (var .gt. 0.) iact(i,1,nrc) = 2
c
  280 nfldtx = 4
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      go to 260
c
  290 imech(1,nrc) = im
c
c     Rate law parameters, backward direction.
c
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      nrk(2,nrc) = ivar
c
      if (nrk(2,nrc) .le. 0) then
        imech(2,nrc) = 0
        go to 210
      endif
c
      im = 0
 300  im = im + 1
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') then
        imech(2,nrc) = 0
        go to 330
      endif
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      uheadx = 'REACTANT'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        im = im - 1
        imech(2,nrc) = im
        go to 215
      endif
c
      uheadx = 'rate constant rk'
      write (ux1,'(i1)') im
      uheadx(17:17) = ux1(1:1)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      if (im .gt. imchmx) then
        write (nttyo,1047) ureac(nrc),imchmx
 1047   format(/' * Error - (XCON6/rd6d7) Have too many rate',
     $  /7x,'constants in the backward direction rate law for',
     $  /7x,'reactant "',a24,'". The code is only',
     $  /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $  /7x,'Reduce the number of rate constants or increase the',
     $  /7x,'dimensioning parameter imchpa.')
        go to 990
      endif
c
      i = im
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      rk0(i,2,nrc) = var
      if (nrk(2,nrc) .eq. 2) then
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        csigma(i,2,nrc) = var
      endif
c
      if (nrk(2,nrc) .eq. 1) go to 210
c
      n = 0
      uheadx = 'aqueous species'
      nfldtx = 4
  310 call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        n = n + 1
c
        if (n .gt. ndctmx) then
          write (nttyo,1048) ureac(nrc),i,ndctmx
 1048     format(/' * Error - (XCON6/rd6d7) Have too many species',
     $    /7x,'in the activity product in term ',i2,' of the',
     $    /7x,'forward direction rate law for reactant',
     $    /7x,'"',a24,'". The code is only dimensioned for ',i3,
     $    /7x,'such species. Reduce the number of such species',
     $    /7x,'or increase the dimensioning parameter ndctpa.')
          go to 990
        endif
c
        udac(n,i,2,nrc) = ufield(2)
        ustr = ufield(4)
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 990
        cdac(n,i,2,nrc) = var
        go to 310
      endif
      ndact(i,2,nrc) = n
c
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') then
        imech(2,nrc) = im
        go to 330
      endif
c
      uheadx = 'temperature (c)'
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      trk0(i,2,nrc) = var
c
      iact(i,2,nrc) = 0
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') then
        imech(2,nrc) = im
        go to 330
      endif
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      uheadx = 'REACTANT'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) then
        imech(2,nrc) = im
        go to 215
      endif
c
      uheadx = 'rate constant rk'
      call locase(uheadx)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .gt. 0) go to 300
c
      uheadx = 'act. energy-kcal'
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      eact(i,2,nrc) = var
      if (var .gt. 0.) iact(i,2,nrc) = 1
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      hact(i,2,nrc) = var
      if (var .gt. 0.) iact(i,2,nrc) = 2
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      go to 300
c
  330 continue
c
c-----------------------------------------------------------------------
c
c     Options. These are iopt, iopr, and iodb option switches,
c     skipping ones which may be classified as development options.
c     The development options are read below, in a somewhat different
c     manner. The iopg option switches are read still further below,
c     in a manner similar to that employed here.
c
c     Note: iopt(1) = iopt1, etc.
c
      nfldtx = 1
      uheadx = 'options'
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      i = 0
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 420
c
      ulscr = ufield(1)
      if (ulscr(1:2) .ne. '- ') then
        write (nttyo,1050) uline1
 1050   format(/' * Error - (XCON6/rd6d7) Found the line beginning',
     $  ' with-',/7x,'"',a70,'"',
     $  /7x,'where an iopt, iopg, iopr, or iodb option switch header',
     $  /7x,'was expected.')
        go to 990
      endif
c
c     Have found an option header.
c
  340 i = i + 1
      nmark = 0
      nmarks = 0
c
c     Put the option header string minus the preceding "- " string
c     into the variable uheadr.
c
      uheadr = ulscr(3:nlchmx)
      call locase(uheadr)
c
c     Remove the succeeding " -" string, if any.
c
      j = ilnobl(uheadr)
      if (uheadr(j - 1:j) .eq. ' -') uheadr(j:j) = ' '
c
c     Identify the corresponding option.
c
      do 370 idescx = 1,nop6pa
        uheadx = uopt6(idescx)
        call locase(uheadx)
        if (uheadr(1:40) .eq. uheadx(1:40)) then
          if (idescx .ne. i) then
            write (nttyo,1060) uopt6(idescx),uvar6(idescx),
     $      index6(idescx),i,idescx
 1060       format(/' * Warning - (XCON6/rd6d7) The input for the',
     $      /7x,'option whose identifying string which begins with-',
     $      /7x,'"',a70,'"',
     $      /7x,'(',a4,'(',i2,')) is out of order, in place ',i3,
     $      ' instead of place ',i3,'.')
          endif
          go to 380
        endif
  370 continue
c
      write (nttyo,1070) uheadr
 1070 format(/" * Error - (XCON6/rd6d7) Can't identify the following",
     $ /7x,'iopt, iopg, iopr, or iodb option header-',
     $ /7x,'"',a70,'".')
      go to 990
c
  380 continue
c
c     Read the first line after an option  header.
c
      jdesc = 0
  390 jdesc = jdesc + 1
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') then
        if (nmarks .gt. 1) then
          write (nttyo,1080) uopt6(idescx),uvar6(idescx),index6(idescx)
 1080     format(/' * Error - (XCON6/rd6d7) More than one choice',
     $    /7x,'was marked for the following option-',
     $    /7x,'"',a70,'"',/9x,a4,'(',i2,').')
          go to 990
        endif
        go to 420
      endif
c
c     Is the current line a new option header?
c
      if (ulscr(1:2) .eq. '- ') then
        if (nmarks .gt. 1) then
          write (nttyo,1080) uopt6(idescx),uvar6(idescx),index6(idescx)
          go to 990
        endif
        go to 340
      endif
c
      j = 1
      nmark = 0
      if (ulscr(1:1) .eq. '*') then
        j = 2
        nmark = 1
        nmarks = nmarks + 1
      endif
      uheadr = ulscr(j:nlchmx)
      call locase(uheadr)
      call lejust(uheadr)
c
      do 400 idesc = 1,nod6pa
        if (iopti6(idesc) .eq. idescx) then
          uheadx = udesc6(idesc)
          call locase(uheadx)
          if (uheadr(1:40) .eq. uheadx(1:40)) go to 410
        endif
  400 continue
c
      write (nttyo,1090) uheadr,uopt6(idescx),uvar6(idescx),
     $ index6(idescx)
 1090 format(/" * Error - (XCON6/rd6d7) Can't identify the following",
     $ /7x,'option string-',/7x,'"',a70,'".',
     $ /7x,'It was given for the following option-',
     $ /7x,'"',a70,'"',/9x,a4,'(',i2,').')
      go to 990
c
  410 if (nmark .eq. 1) then
        ustr = uvar6(idescx)
        call locase(ustr)
        if (ustr(1:4) .eq. 'iopt') then
          iopt(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iopg') then
          iopg(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iopr') then
          iopr(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iodb') then
          iodb(index6(idescx)) = ivalu6(idesc)
        else
          write (nttyo,1100) uheadr,uvar6(idescx)
 1100     format(/" * Error - (XCON6/rd6d7) Don't recognize the",
     $    /7x,'option type string "',a4,'", which was given for',
     $    /7x,'the following option-',/7x,'"',a70,'".')
          go to 990
        endif
      endif
c
      go to 390
c
  420 continue
c
c     Get the time frame flag (iopt(1)).
c
      iopt(1) = 0
      if (nrct. gt. 0) then
        do 430 nrc = 1,nrct
          if (nrk(1,nrc) .ge. 2) then
            iopt(1) = 1
            go to 435
          endif
          if (nrk(2,nrc) .ge. 2) then
            iopt(1) = 1
            go to 435
          endif
  430   continue
  435   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Development options.
c
      uheadx = 'development options'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      i = 0
  440 i = i + 1
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') go to 470
c
      j = index(ulscr,' ')
      j2 = j - 1
      if (j2 .eq. 0) j2 = 1
      ustr = ulscr(1:j2)
      j1 = j + 1
      if (j1 .gt. nlchmx) j1 = nlchmx
      uheadr = ulscr(j1:nlchmx)
      call locase(uheadr)
      call lejust(uheadr)
      do 450 idescx = 1,ndv6pa
        uheadx = udevl6(idescx)
        call locase(uheadx)
        if (uheadr(1:40) .eq. uheadx(1:40)) go to 460
  450 continue
c
      write (nttyo,1110) uheadr
 1110 format(/" * Error - (XCON6/rd6d7) Can't identify the following",
     $ /7x,'development option header-',
     $ /7x,'"',a70,'".')
      go to 990
c
  460 call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      ustr = udv6vr(idescx)
      call locase(ustr)
      if (ustr(1:4) .eq. 'iopt') then
        iopt(index6(idescx)) = ivar
      elseif (ustr(1:4) .eq. 'iopr') then
        iopr(index6(idescx)) = ivar
      elseif (ustr(1:4) .eq. 'iodb') then
        iodb(index6(idescx)) = ivar
      elseif (ustr(1:4) .eq. 'iopg') then
        iopg(index6(idescx)) = ivar
      else
        write (nttyo,1120) uheadr,udv6vr(idescx)
 1120   format(/" * Error - (XCON6/rd6d7) Don't recognize the",
     $  /7x,'option type string "',a4,'", which was  given for',
     $  /7x,'the following option-',/7x,'"',a70,'".')
        go to 990
      endif
      go to 440
c
  470 continue
c
c-----------------------------------------------------------------------
c
c     Tolerances.
c
      uheadx = 'tolerances'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      i = 0
  510 i = i + 1
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 520
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      do 515 idescx = 1,nto6pa
        uheadx = utol6(idescx)
        call locase(uheadx)
        if (uheadr(1:32) .eq. uheadx(1:32)) go to 517
  515 continue
c
      write (nttyo,1130) uheadr
 1130 format(/" * Error - (XCON6/rd6d7) Can't identify the following",
     $ /7x,'tolerance parameter header-',
     $ /7x,'"',a70,'".')
      go to 990
c
  517 ustr = ufield(2)
      if (idescx .eq. 1) then
c
c       Itermx.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        itermx = ivar
      elseif (idescx .eq. 2) then
c
c       Dlzidp.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        dlzidp = var
      elseif (idescx .eq. 3) then
c
c       Tolbt.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolbt = var
      elseif (idescx .eq. 4) then
c
c       Toldl.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        toldl = var
      elseif (idescx .eq. 5) then
c
c       Tolx.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolx = var
      elseif (idescx .eq. 6) then
c
c       Tolsat.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolsat = var
      elseif (idescx .eq. 7) then
c
c       Tolsst.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolsst = var
      elseif (idescx .eq. 8) then
c
c       Sscrew1.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(1) = var
      elseif (idescx .eq. 9) then
c
c       Sscrew2.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(2) = var
      elseif (idescx .eq. 10) then
c
c       Sscrew3.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(3) = var
      elseif (idescx .eq. 11) then
c
c       Sscrew4.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(4) = var
      elseif (idescx .eq. 12) then
c
c       Sscrew5.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(5) = var
      elseif (idescx .eq. 13) then
c
c       Sscrew6.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        sscrew(6) = var
      elseif (idescx .eq. 14) then
c
c       Zklogu.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        zklogu = var
      elseif (idescx .eq. 15) then
c
c       Zklogl.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        zklogl = var
      elseif (idescx .eq. 16) then
c
c       Zkfac.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        zkfac = var
      elseif (idescx .eq. 17) then
c
c       Dlzmx1.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        dlzmx1 = var
      elseif (idescx .eq. 18) then
c
c       Dlzmx2.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        dlzmx2 = var
      elseif (idescx .eq. 19) then
c
c       Nordlm.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        nordlm = ivar
      elseif (idescx .eq. 20) then
c
c       Ntrymx.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        ntrymx = ivar
      elseif (idescx .eq. 21) then
c
c       Npslmx.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        npslmx = ivar
      elseif (idescx .eq. 22) then
c
c       Nsslmx.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        nsslmx = ivar
      elseif (idescx .eq. 23) then
c
c       Ioscan.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        ioscan = ivar
      endif
c
      go to 510
c
  520 continue
c
c-----------------------------------------------------------------------
c
c     Process the bottom half of the current output file.
c
c     Title.
c
      n = 1
      do 530 n = 1,ntitmx + 1
        read (ninpts,1000,err=990) uline1
        call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
        ustr = ufield(1)
        if (ustr(1:8) .eq. '--------') go to 540
        utitl2(n) = ufield(1)
  530 continue
c
        write (nttyo,1115) ntitmx
 1115   format(/' * Error - (XCON6/rd6d7) Have too many lines in the',
     $  /7x,'secondary title. The code is only dimensioned for ',i4,
     $  /7x,'lines. Reduce the size of the title or increase the',
     $  /7x,'dimensioning parameter ntitpa.')
        go to 990
c
  540 ntitl2 = n - 1
c
c-----------------------------------------------------------------------
c
c     Original temperature.
c
      uheadx = 'temperature (c)'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      tempci = var
c
c-----------------------------------------------------------------------
c
c     Electrical imbalance.
c
      uheadx = 'electrical imbalance'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      electr = var
c
c-----------------------------------------------------------------------
c
c     Number of aqueous basis species.
c
      uheadx = 'number of aqueous master species'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      ksb = ivar
c
      ksq = ksb
      kct = ksb - 1
c
c-----------------------------------------------------------------------
c
c     Postion of last pure mineral.
c
      uheadx = 'position of last pure mineral'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      kmt = ivar
c
c-----------------------------------------------------------------------
c
c     Postion of last solid solution.
c
      uheadx = 'position of last solid solution'
      nfldtx = 2
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      ustr = ufield(2)
      call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 990
      kxt = ivar
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      uheadx = 'suppressed species'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      n = 0
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .eq. '--------') go to 570
c
      if (ustr(1:8) .eq. 'none') go to 560
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
  550 n = n + 1
c
      if (n .gt. nxmdmx) then
        write (nttyo,1132) nxmdmx
 1132   format(/' * Error - (XCON6/rd6d7) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  ' options',/7x,'or increase the dimensioning parameter',
     $  ' nxmdpa.')
        go to 990
      endif
c
      uxmd24(n) = ufield(1)
c
      ustr = ufield(2)
      call locase(ustr)
      if (ustr(1:7) .eq. 'aqueous') then
        jxmod(n) = 0
      elseif (ustr(1:7) .eq. 'mineral') then
        jxmod(n) = 1
      elseif (ustr(1:3) .eq. 'gas') then
        jxmod(n) = 2
      elseif (ustr(1:14) .eq. 'solid solution') then
        jxmod(n) = 3
      else
        j2 = ilnobl(ustr)
        write (nttyo,1135) ustr(1:j2)
 1135   format(/" * Error - (XCON6/rd6d7) Can't identify the",
     $  /7x,'following alter/suppress species type string- "',a,'".',
     $  /7x,'This must be one of "aqueous", "mineral", "gas",',
     $  /7x,' or "solid solution".')
        go to 990
      endif
c
      ustr = ufield(3)
      call locase(ustr)
      if (ustr(1:8) .eq. 'suppress') then
        kxmod(n) = -1
      elseif (ustr(1:7) .eq. 'replace') then
        kxmod(n) = 0
      elseif (ustr(1:8) .eq. 'augmentk') then
        kxmod(n) = 1
      elseif (ustr(1:8) .eq. 'augmentg') then
        kxmod(n) = 2
      else
        j2 = ilnobl(ustr)
        write (nttyo,1140) ustr(1:j2)
 1140   format(/" * Error - (XCON6/rd6d7) Can't identify the",
     $  /7x,'following alter/suppress option string- "',a,'".',
     $  /7x,'This must be one of "suppress", "replace", "augmentk",',
     $  /7x,' or "augmentg".')
        go to 990
      endif
c
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      xlkmod(n) = var
c
  560 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .eq. '--------') go to 570
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      go to 550
c
  570 nxmod = n
c
c-----------------------------------------------------------------------
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      uheadx = 'iopg options'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      i = 0
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') go to 720
c
      if (ulscr(1:2) .ne. '- ') then
        write (nttyo,1050) uline1
        go to 990
      endif
c
c     Have found an option header.
c
  640 i = i + 1
      nmark = 0
      nmarks = 0
c
c     Put the option header string minus the preceding "- " string
c     into the variable uheadr.
c
      uheadr = ulscr(3:nlchmx)
      call locase(uheadr)
c
c     Remove the succeeding " -" string, if any.
c
      j = ilnobl(uheadr)
      if (uheadr(j - 1:j) .eq. ' -') uheadr(j:j) = ' '
c
c     Identify the corresponding option.
c
      do 670 idescx = 1,nop6pa
        uheadx = uopt6(idescx)
        call locase(uheadx)
        if (uheadr(1:40) .eq. uheadx(1:40)) then
c
c         This warning test is commented out.  The warning doesn't
c         really apply as the version 7 options are structured
c         (the strings and such for the iopg options are mixed in
c         with those of the iopt, iopr, and iodb options).
c
c         if (idescx .ne. i) then
c           write (nttyo,1060) uopt6(idescx),uvar6(idescx),
c    $      index6(idescx),i,idescx
c         endif
          go to 680
        endif
  670 continue
c
      write (nttyo,1070) uheadr
      go to 990
c
  680 continue
c
c     Read the first line after an option  header.
c
      jdesc = 0
  690 jdesc = jdesc + 1
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') then
        if (nmarks .gt. 1) then
          write (nttyo,1080) uopt6(idescx),uvar6(idescx),index6(idescx)
        endif
        go to 720
      endif
c
c     Is the current line a new option header?
c
      if (ulscr(1:2) .eq. '- ') then
        if (nmarks .gt. 1) then
          write (nttyo,1080) uopt6(idescx),uvar6(idescx),index6(idescx)
          go to 990
        endif
        go to 640
      endif
c
      j = 1
      nmark = 0
      if (ulscr(1:1) .eq. '*') then
        j = 2
        nmark = 1
        nmarks = nmarks + 1
      endif
      uheadr = ulscr(j:nlchmx)
      call locase(uheadr)
      call lejust(uheadr)
c
      do 700 idesc = 1,nod6pa
        if (iopti6(idesc) .eq. idescx) then
          uheadx = udesc6(idesc)
          call locase(uheadx)
          if (uheadr(1:40) .eq. uheadx(1:40)) go to 710
        endif
  700 continue
c
      write (nttyo,1090) uheadr,uopt6(idescx),uvar6(idescx),
     $ index6(idescx)
      go to 990
c
  710 if (nmark .eq. 1) then
        ustr = uvar6(idescx)
        call locase(ustr)
        if (ustr(1:4) .eq. 'iopt') then
          iopt(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iopg') then
          iopg(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iopr') then
          iopr(index6(idescx)) = ivalu6(idesc)
        elseif (ustr(1:4) .eq. 'iodb') then
          iodb(index6(idescx)) = ivalu6(idesc)
        else
          write (nttyo,1100) uheadr,uvar6(idescx)
          go to 990
        endif
      endif
c
      go to 690
c
  720 continue
c
c-----------------------------------------------------------------------
c
c     Balance totals.
c
      uheadx = 'elements, moles and moles aqueous'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      i = 0
  730 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') go to 750
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      i = i + 1
c
      if (i .gt. nctmax) then
        write (nttyo,1134) nctmax
 1134   format(/' * Error - (XCON6/rd6d7) Have too many chemical',
     $  /7x,'elements present. The code is only dimensioned',
     $  /7x,'for ',i3,' elements. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      uelemb(i) = ufield(1)
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      mteb(i) = var
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      mteaqb(i) = var
      go to 730
c
  750 continue
c
c-----------------------------------------------------------------------
c
c     Basis variable data.
c
      uheadx = 'master species and logarithmic basis variables'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      i = 0
  760 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') go to 770
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      i = i + 1
c
      if (i .gt. kmax) then
        write (nttyo,1137) kmax
 1137   format(/' * Error - (XCON6/rd6d7) Have too many master',
     $  /7x,'variables. The code is only dimensioned for ',i3,
     $  /7x,'master variables. Reduce the number of such variables',
     $  /7x,'or increase the dimensioning parameter kpar.')
        go to 990
      endif
c
      unrms(i) = ufield(1)
      undms(i) = ufield(2)
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      zvclgi(i) = var
      go to 760
c
  770 kdim = i
c
c-----------------------------------------------------------------------
c
c     Physically removed system data.
c
      uheadx = 'physically removed subsystem'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nprmn = 0
      nprmx = 0
      kprs = 0
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 820
c
      if (ustr(1:4) .eq. 'none') then
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        if (ustr(1:8) .ne. '--------') then
          write (nttyo,1040) uline1
          go to 990
        endif
        go to 820
      endif
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
      ulscr = ufield(1)
      call locase(ulscr)
c
c     Pure minerals.
c
  780 ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 820
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
      ulscr = ufield(1)
      if (ulscr(1:8) .ne. '        ') go to 790
      nprmn = nprmn + 1
c
      if (nprmn .gt. nprsmx) then
        write (nttyo,1150) nprsmx
 1150   format(/' * Error - (XCON6/rd6d7) Have too many mineral',
     $  /7x,'species in the physically removed system. The code is',
     $  /7x,'only dimensioned for ',i3,' such species. Reduce the',
     $  /7x,'number of such species or increase the dimensioning',
     $  /7x,'parameter nprspa.')
        go to 990
      endif
c
      uprs(nprmn)(1:24) = ufield(2)
      uprs(nprmn)(25:48) = ufield(2)
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      mprs(nprmn) = var
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      go to 780
c
c     Solid solutions.
c
  790 nprmx = nprmn
c
  800 ux = ufield(1)
c
  810 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 820
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
      ulscr = ufield(1)
      if (ulscr(1:8) .ne. '        ') go to 800
c
      nprmx = nprmx + 1
c
      if (nprmn .gt. nprsmx) then
        write (nttyo,1150) nprsmx
        go to 990
      endif
c
      uprs(nprmx)(1:24) = ux
      uprs(nprmx)(25:48) = ufield(2)
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 990
      mprs(nprmx) = var
      go to 810
c
  820 n = nprmn + nprmx
      if (n .gt. 0) kprs = 1
c
c-----------------------------------------------------------------------
c
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine d1ptay(delxi,demop0,d1emp1,nord,nordmx,npet,npetmx)
c
c     This subroutine evaluates the first derivative of Taylor's series
c     expansions for the number of moles of phases in the ES. These
c     expansions are used to find points of reaction progress at which
c     such variables maximize. At such points, for example in the
c     fluid-centered flow-through open system model,it may be necessary
c     to transfer mass of a corresponding phase from the ES to the PRS.
c
c     See also:
c
c       EQ6/d2ptay.f
c       EQ6/ztaylr.f
c
c     This subroutine is called by:
c
c       EQ6/fpbflo.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       demop0 = the number of moles derivative vector for phases in
c                  the ES at the base point
c       nord   = the order of the truncated Taylor's series
c       nordmx = the maximum order of the truncated Taylor's series
c       npet   = the number of phases in the ES
c       npetmx = the maximum number of phases in the ES
c
c     Principal output:
c
c       d1emp1 = the first derivative of the number of moles vector
c                  for phases in the ES at at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nordmx,npetmx
c
      integer nord,npet
c
      real*8 demop0(nordmx,npetmx),d1emp1(npetmx)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jk,npe
c
      real*8 dxp,d1p
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      if (nord .gt. 0) then
        do npe = 1,npet
          d1p = demop0(1,npe)
          if (nord .gt. 1) then
            jk = nord - 1
            dxp = 1.
            do j = 1,jk
              dxp = dxp*delxi
              d1p = d1p + ( demop0(j + 1,npe)/fctrl(j) )*dxp
            enddo
          endif
          d1emp1(npe) = d1p
        enddo
      endif
c
      end

      subroutine ckehpl(delxi,dlxmin,deh0,dxe0pl,dxe1pl,dxval0,
     $ eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,eh0,eh1,
     $ eh0plo,eh1plo,prcinf,qdump,tolxsu,xi0,xi1,xval0)
c
c     This subroutine checks to see that the next Eh-based plot
c     point is not exceeded. Because the Eh might be decreasing or
c     increasing, two potential target points (eh0plo and eh1plo)
c     must be addressed.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer nord
c
      logical qdump
c
      real*8 deh0(nrd1mx),dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,dxe0pl,dxe1pl,eps100,prcinf,eh0,eh0plo,eh1,
     $ eh1plo,tolxsu,xi0,xi1,xval0,xtargv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,n
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxp,dxsv,tolsx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'Eh reaches a plot point value                   '/
      data unam24  /'                       '/
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
c
      dxe0pl = prcinf
      dxe1pl = prcinf
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The first search target is the currently defined Eh-based plot
c     point associated with the lesser Eh value.
c
      ilsign = +1
      xtargv = eh0plo
      tolsx = tolxsu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for where the Eh reaches the lesser of',
     $    ' two plot point values',/3x,'has failed. Dropping to the',
     $    ' minimum step size.')
        endif
        delxi = dlxmin
        go to 110
      endif
c
c     Estimate the Eh from a Taylor's series expansion.
c
      eh1 = eh0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        eh1 = eh1 + ( deh0(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (eh0 .le. (1. + tolxsu)*eh0plo) then
c
c         The Eh at the base point is too close to the requested
c         lesser plot point value.
c
          delxi = dlxmin
          dxe0pl = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) eh0,eh0plo,xi0,delxi
 1010       format(/3x,'The base point Eh of ',1pe11.4,' v is already',
     $      ' very close',/3x,'to the requested lesser plot point',
     $      ' value of',e11.4,/3x,'at Xi= ',e11.4,'. Have set delxi',
     $      ' equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 100
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((eh1 - eh0plo) .lt. -tolsx) then
c
          xval0 = eh0
          do n = 1,nord
            dxval0(n) = deh0(n)
          enddo
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dxe0pl = delxi
          if (ier .le. 0) go to 100
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dxe0pl = delxi
          go to 110
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(eh1 - eh0plo) .le. tolsx) then
          write (noutpt,1020) eh0plo,xi1,delxi
 1020     format(/3x,"Taylor's series predict that the Eh is",
     $    ' at the requested',/3x,'lesser plot point value of ',
     $    1pe11.4,' v at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The second search target is the currently defined Eh-based plot
c     point associated with the greater Eh value.
c
      ilsign = -1
      xtargv = eh1plo
      tolsx = tolxsu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  200 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1100)
 1100     format(/3x,'A scan for where the Eh reaches the greater of',
     $    ' two plot point values',/3x,'has failed. Dropping to the',
     $    ' minimum step size.')
        endif
        delxi = dlxmin
        go to 210
      endif
c
c     Estimate the Eh from a Taylor's series expansion.
c
      eh1 = eh0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        eh1 = eh1 + ( deh0(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (eh0 .ge. (1. - tolxsu)*eh1plo) then
c
c         The Eh at the base point is too close to the requested
c         greater plot point value.
c
          delxi = dlxmin
          dxe1pl = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1110) eh0,eh1plo,xi0,delxi
 1110       format(/3x,'The base point Eh of ',1pe11.4,' v is already',
     $      ' very close',/3x,'to the requested greater plot point',
     $      ' value of',e11.4,/3x,'at Xi= ',e11.4,'. Have set delxi',
     $      ' equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 200
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((eh1 - eh1plo) .gt. tolsx) then
c
          xval0 = eh0
          do n = 1,nord
            dxval0(n) = deh0(n)
          enddo
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dxe1pl = delxi
          if (ier .le. 0) go to 200
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dxe1pl = delxi
          go to 210
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(eh1 - eh1plo) .le. tolsx) then
          write (noutpt,1120) eh1plo,xi1,delxi
 1120     format(/3x,"Taylor's series predict that the Eh is",
     $    ' at the requested',/3x,'greater plot point value of ',
     $    1pe11.4,' v at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  210 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (dxsv .gt. delxi) qdump = .false.
c
  999 continue
      end

      subroutine rdpz2(abeta,alpha,acphi,ipbtmx,jpfcmx,nat,natmax,
     $ ndat0s,nerr,noutpt,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,
     $ zaqsp)
c
c     This subroutine reads coefficients for computing the following
c     Pitzer interaction parameters from the DATA0 file:
c
c       beta(MX)(0), beta(MX)(1), beta(MX)(2), and their
c         temperature derivatives
c       Cphi(MX) and its temperature derivatives
c
c     (Here M = a cation and X = an anion). The alpha(1) and alpha(2)
c     coefficients which go with the beta parameters are also read.
c
c     The beta parameters map to conventional lambda parameters for
c     cation-anion pairs. Conventional lambda coefficients for MN
c     and NX pairs, where N = a neutral species may be entered in
c     place of beta parameters. The same is true for the observable
c     lambda coefficients of NN and NN' pairs (here N' is a second
c     neutral species).
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c
c     Principal output:
c
c       alpha  = array of Pitzer alpha constants
c       acphi  = array of coefficients for computing Cphi parameters
c       abeta  = array of coefficients for computing beta parameters
c       nerr   = cumulative error counter
c       npx2t  = the number of pairs of species for which Pitzer
c                  interaction parameters are defined
c       nwarn  = cumulative warning counter
c       uaqsp  = array of names of aqueous species
c       upair  = array of species names for species pairs
c       uaqsp  = array of electrical charge numbers of aqueous species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,npx2mx
c
      integer ndat0s,noutpt,nttyo
c
      integer nat,nerr,npx2t,nwarn
c
      character(len=24) uaqsp(natmax),upair(2,npx2mx)
c
      real(8) abeta(jpfcmx,0:ipbtmx,npx2mx),alpha(ipbtmx,npx2mx),
     $ acphi(jpfcmx,npx2mx),zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ier,iz1,iz1x,iz2,iz2x,j,j2,j3,j4,j5,j6,j7,npx2,n1,n2
c
      integer ilnobl
c
      logical qzepfc
c
      character(len=80) uline
      character(len=24) unam1,unam2,ux24a,ux24b
      character(len=8) umixt,usingl,uterm,ux8,ux8a
c
      real(8) z1,z2
c
c-----------------------------------------------------------------------
c
      data uterm  /'+-------'/
      data usingl /'single-s'/
      data umixt  / 'mixture'/
c
c-----------------------------------------------------------------------
c
      npx2 = 0
c
c     Advance to the start of the superblock for these parameters.
c
  100 read (ndat0s,1000,end=990,err=995) uline
 1000 format(a80)
      if (uline(1:8) .ne. usingl(1:8)) go to 100
c
c     Skip the terminator.
c
      read (ndat0s,1000,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the names of the species comprising a pair.
c
  110 read (ndat0s,1010,end=990,err=995) unam1,unam2
 1010 format(a24,2x,a24)
c
      if (unam1(1:8) .eq. umixt(1:8)) then
c
c       Found the header for the mixture parameters superblock.
c
        npx2t = npx2
        go to 999
      endif
c
      npx2 = npx2 + 1
c
c     Check for blank names.
c
      j2 = ilnobl(unam1)
      j3 = ilnobl(unam2)
      if (j2.le.0 .or. j3.le.0) then
        write (ux8,'(i5)') npx2
        call lejust(ux8)
        j5 = ilnobl(ux8)
        if (j2 .le. 0) then
          unam1 = '<blank>'
          j2 = ilnobl(unam1)
        endif
        if (j3 .le. 0) then
          unam2 = '<blank>'
          j3 = ilnobl(unam2)
        endif
        write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
        write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
 1020   format(/' * Error - (EQPT/rdpz2) Have encountered a blank',
     $  ' species name',/7x,'in the species pair for block ',a,
     $  ' of the superblock for',/7x,'Pitzer parameter data',
     $  ' corresponding to species pairs.',/7x,'The offending',
     $  ' pair shows as ',a,', ',a,'.')
        if (npx2 .gt. 1) then
          ux24a = upair(1,npx2 - 1)
          ux24b = upair(2,npx2 - 1)
          if (ux24a(1:7).ne.'<blank>' .or.
     $      ux24b(1:7).ne.'<blank>') then
            j6 = ilnobl(ux24a)
            j7 = ilnobl(ux24b)
            write (noutpt,1030) ux24a(1:j6),ux24b(1:j7)
            write (nttyo,1030) ux24a(1:j6),ux24b(1:j7)
 1030       format(7x,'This block follows the one for ',a,
     $      ', ',a,'.')
          endif
        endif
        nerr = nerr + 1
      endif
c
c     Read the electrical charges.
c
      read (ndat0s,1050,end=990,err=995) z1,z2
 1050 format(f3.0,t15,f3.0)
c
      n1 = 0
      n2 = 0
      iz1 = 0
      iz2 = 0
c
c     Get the indices of the two species (n1, n2). These
c     indices point to the data read from the previously
c     read species blocks.
c
c     Calling sequence substitutions:
c       n1 for na
c       unam1 for unams
c
      call gspidx(ier,n1,nat,natmax,uaqsp,unam1)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>') then
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          write (noutpt,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3)
          write (nttyo,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3)
 1100     format(/' * Error - (EQPT/rdpz2) The aqueous species ',
     $    a,' appearing in',/7x,'the Pitzer parameter data block',
     $    ' for the species pair',/7x,a,', ',a,' does not appear',
     $    ' in an aqueous species',/7x,'data block.')
          nerr = nerr + 1
        endif
      else
c
        iz1x = nint(z1)
        z1 = zaqsp(n1)
        iz1 = nint(z1)
c
        if (iz1 .ne. iz1x) then
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          write (ux8a,'(i5)') iz1x
          call lejust(ux8a)
          j4 = ilnobl(ux8a)
          write (ux8,'(i5)') iz1
          call lejust(ux8)
          j5 = ilnobl(ux8)
          write (noutpt,1110) ux8a(1:j4),unam1(1:j2),
     $    unam1(1:j2),unam2(1:j3),ux8(1:j5)
          write (nttyo,1110) ux8a(1:j4),unam1(1:j2),
     $    unam1(1:j2),unam2(1:j3),ux8(1:j5)
 1110     format(/' * Note - (EQPT/rdpz2) A charge of ',a,
     $    ' was incorrectly',/7x,'specifed for ',a,' in the'
     $    ' data block for the pair',/7x,a,', ',a,'. The',
     $    ' correct charge is ',a,'.',/7x,'The incorrect',
     $    ' charge will be ignored.')
        endif
      endif
c
c     Calling sequence substitutions:
c       n2 for na
c       unam2 for unams
c
      call gspidx(ier,n2,nat,natmax,uaqsp,unam2)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>') then
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          write (noutpt,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3)
          write (nttyo,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3)
          nerr = nerr + 1
        endif
      else
c
        iz2x = nint(z2)
        z2 = zaqsp(n2)
        iz2 = nint(z2)
c
        if (iz2 .ne. iz2x) then
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          write (ux8a,'(i5)') iz2x
          call lejust(ux8a)
          j4 = ilnobl(ux8a)
          write (ux8,'(i5)') iz2
          call lejust(ux8)
          j5 = ilnobl(ux8)
          write (noutpt,1110) ux8a(1:j4),unam2(1:j3),
     $    unam1(1:j2),unam2(1:j3),ux8(1:j5)
          write (nttyo,1110) ux8a(1:j4),unam2(1:j3),
     $    unam1(1:j2),unam2(1:j3),ux8(1:j5)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for illegal appearance of solvent water.
c
      if (unam1(1:4).eq.'H2O ' .or. unam2(1:4).eq.'H2O ' .or.
     $  n1.eq.1 .or. n2.eq.1) then
        j2 = ilnobl(unam1)
        j3 = ilnobl(unam2)
        write (noutpt,1200) unam1(1:j2),unam2(1:j3)
        write (nttyo,1200) unam1(1:j2),unam2(1:j3)
 1200   format(/' * Error - (EQPT/rdpz2) Have found an illegal',
     $  ' data block for the',/7x,'species pair ',a,', ',a,
     $  ' among the blocks for "single-salt',/7x,'parameters".',
     $  ' Solvent water may not appear in such a pair in the',
     $  /7x,'normal Pitzer treatment of electrolyte solutions.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (n1.gt.0 .and. n2.gt.0) then
c
c       Check for illegal combinations (cc, aa, cc', and aa').
c       Note that nc, na, and nn' combinations are allowed here
c       under restricted circumstances (see further below), even
c       though they technically correspond to mixtures.
c
        if ((iz1*iz2) .gt. 0) then
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          if (n1 .ne. n2) then
            ux8 = 'cations'
            if (iz1 .lt. 0) ux8 = 'anions'
            j5 = ilnobl(ux8)
            write (noutpt,1220) unam1(1:j2),unam2(1:j3),ux8(1:j5)
            write (nttyo,1220) unam1(1:j2),unam2(1:j3),ux8(1:j5)
 1220       format(/' * Error - (EQPT/rdpz2) Have found an',
     $      ' illegal data block for the',/7x,'species pair ',
     $      a,', ',a,' among the blocks for "single-salt',
     $      /7x,'parameters". Both species are ',a,'. This is',
     $      ' not a valid',/7x,'combination for the present kind',
     $      ' of block. Enter these',/7x,'data in a block for',
     $      '"mixture parameters".')
          else
            write (noutpt,1230) unam1(1:j2),unam2(1:j3)
            write (nttyo,1230) unam1(1:j2),unam2(1:j3)
 1230       format(/' * Error - (EQPT/rdpz2) Have found an',
     $      ' illegal data block for the',/7x,'species pair ',
     $      a,', ',a,' among the blocks for "single-salt',
     $      /7x,'parameters". The same ion appears twice.',
     $      ' This is not',/7x,'a valid combination, as the',
     $      ' corresponding lambda and mu',/7x,'data are',
     $      ' defined to be zero by convention in the normal',
     $      ' Pitzer',/7x,'treatment of electrolyte solutions.')
          endif
          nerr = nerr + 1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species pair storage rules:
c
c       neutral < cation < anion
c       if both species are of the same charge type,
c       store alphabetically.
c
      if (iz1.eq.0 .and. iz2.ne.0) then
c
c       The first species is a neutral and the second species
c       isn't.
c
        upair(1,npx2) = unam1
        upair(2,npx2) = unam2
      elseif (iz2.eq.0 .and. iz1.ne.0) then
c
c       The second species is a neutral and the first species
c       isn't.
c
        upair(1,npx2) = unam2
        upair(2,npx2) = unam1
      elseif (iz1.gt.0 .and. iz2.lt.0) then
c
c       The first species is a cation and the second species
c       is an anion.
c
        upair(1,npx2) = unam1
        upair(2,npx2) = unam2
      elseif (iz2.gt.0 .and. iz1.lt.0) then
c
c       The second species is a cation and the first species
c       is an anion.
c
        upair(1,npx2) = unam2
        upair(2,npx2) = unam1
      else
c
c       Both species have the same charge type.
c
        if (unam1 .le. unam2) then
          upair(1,npx2) = unam1
          upair(2,npx2) = unam2
        else
          upair(1,npx2) = unam2
          upair(2,npx2) = unam1
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the beta (lambda) coefficients.
c
      read (ndat0s,1300,end=990,err=995) abeta(1,0,npx2),
     $ abeta(1,1,npx2),abeta(1,2,npx2)
 1300 format(13x,f9.5,11x,f9.5,11x,f9.5)
c
c     Read the alpha parameters.
c
      read (ndat0s,1310,end=990,err=995) alpha(1,npx2),alpha(2,npx2)
 1310 format(18x,2(16x,f5.1))
c
c     Read the Cphi parameter.
c
      read (ndat0s,1320,end=990,err=995) acphi(1,npx2)
 1320 format(13x,f9.5,12x,f5.1)
c
c     Read source 1.
c
      read (ndat0s,1330,end=990,err=995) uline
 1330 format(13x,a24)
c
c     Read the beta (lambda) derivatives.
c
      read (ndat0s,1340,end=990,err=995) abeta(2,0,npx2),
     $ abeta(3,0,npx2)
      read (ndat0s,1340,end=990,err=995) abeta(2,1,npx2),
     $ abeta(3,1,npx2)
      read (ndat0s,1340,end=990,err=995) abeta(2,2,npx2),
     $ abeta(3,2,npx2)
 1340 format(13x,e10.3,13x,e10.3)
c
c     Read the Cphi derivatives.
c
      read (ndat0s,1340,end=990,err=995) acphi(2,npx2),
     $ acphi(3,npx2)
c
c     Read source 2.
c
      read (ndat0s,1330,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (n1.gt.0 .and. n2.gt.0) then
c
        if ((iz1.eq.0 .and. iz2.eq.0) .and. (n1 .ne. n2)) then
c
c         Have an nn' combination. This is really a mixture
c         mixture parameter combination. Only lambda coefficients
c         (as "beta0") are permitted in a "single-salt parameters"
c         block. The coresponding two mu coefficients (as "psi")
c         must be entered in separate blocks under "mixture
c         parameters". The lambda data must be entered in a
c         block under "single-salt parameters" in order to
c         preserve current block formatting and to avoid the
c         problem that a given lambda of this type corresponds to
c         two distinct mu values. If such a lambda were to be
c         entered in the "theta" field of the blocks for the
c         corresponding mu values, then the same parameter would
c         be entered in two places.
c
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          qzepfc = .true.
          do j = 1,jpfcmx
            if (acphi(j,npx2) .ne. 0.) qzepfc = .false.
          enddo
          if (.not. qzepfc) then
            write (noutpt,1400) unam1(1:j2),unam2(1:j3)
            write (nttyo,1400) unam1(1:j2),unam2(1:j3)
 1400       format(/' * Error - (EQPT/rdpz2) Have found an',
     $      ' illegal data block for the',/7x,'species pair ',
     $      a,', ',a,' among the blocks for "single-salt',
     $      /7x,'parameters". Have non-zero input for mu',
     $      ' data in the "Cphi" field.',/7x,'Only lambda data',
     $      ' may be specified (in the "beta0" field) in',
     $      /7x,'a block of this type. To specify mu data,',
     $      ' enter each of the',/7x,'two corresponding mu',
     $      " values [mu(nnn') and mu(n'n'n)] in separate",
     $      /7x,'"mixture parameters" blocks, using the "psi"',
     $      ' fields. The',/7x,'corresponding lambda data must',
     $      ' remain in a "single-salt parameters"',/7x,'block',
     $      ' (in the "beta0" field).')
            nerr = nerr + 1
          endif
        endif
c
        if ((iz1.ne.0 .and. iz2.eq.0) .or.
     $    (iz1.eq.0 .and. iz2.ne.0)) then
c
c         Have an nc or na combination. This is also really a
c         mixture parameter combination. Only lambda coefficients
c         (as "beta0") are permitted in a "single-salt parameters"
c         block. The coresponding zeta coefficient (as "psi")
c         must be entered in a block under "mixture parameters".
c         Note that there is a lambda(nc) and a lambda(na) for
c         each zeta(nca). The lambda data must be entered in
c         separate blocks under "single-salt parameters" because
c         a given lambda of this type is shared by various nca-
c         type mixtures and duplicate values would occur
c         if the lambdas were put into blocks under "mixture
c         parameters". For example, lambda(Na+, CO2(aq)) pertains
c         to mixtures involving various anions.
c
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          qzepfc = .true.
          do j = 1,jpfcmx
            if (acphi(j,npx2) .ne. 0.) qzepfc = .false.
          enddo
          if (.not. qzepfc) then
            write (noutpt,1410) unam1(1:j2),unam2(1:j3)
            write (nttyo,1410) unam1(1:j2),unam2(1:j3)
 1410       format(/' * Error - (EQPT/rdpz2) Have found an',
     $      ' illegal data block for the',/7x,'species pair ',
     $      a,', ',a,' among the blocks for "single-salt',
     $      /7x,'parameters". Have non-zero input for zeta',
     $      ' data in the "Cphi"',/7x,'field. Only lambda data',
     $      ' may be specified in a block of this type,',
     $      /7x,'(in the "beta0" field). To specify zeta data,',
     $      ' enter it in',/7x,'a "mixture parameters"',
     $      ' block in the "psi" field. The',/7x,'corresponding',
     $      ' lambda data must remain in a "single-salt',
     $      /7x,'parameters" block (in the "beta0" field).')
            nerr = nerr + 1
          endif
        endif
c
        if (iz1*iz2 .ge. 0) then
c
c         Have a combination other than a ca combination.
c         The "beta1" and "beta2" parameters are ordinarily used
c         only for ca combinations. Issue a warning if they
c         are used for any other combinations, such as nc, na,
c         nn, or nn'.
c
          j2 = ilnobl(unam1)
          j3 = ilnobl(unam2)
          qzepfc = .true.
          do i = 1,ipbtmx
            do j = 1,jpfcmx
              if (abeta(j,i,npx2) .ne. 0.) qzepfc = .false.
            enddo
          enddo
          if (.not. qzepfc) then
            write (noutpt,1420) unam1(1:j2),unam2(1:j3)
            write (nttyo,1420) unam1(1:j2),unam2(1:j3)
 1420       format(/' * Warning - (EQPT/rdpz2) Have found a',
     $      ' data block for the',/7x,'species pair ',
     $      a,', ',a,' among the blocks for "single-salt',
     $      /7x,'parameters" that has non-zero input in the',
     $      ' "beta1" and/or "beta2"',/7x,'fields. The "beta1"',
     $      ' and "beta2" parameters are ordinarily used',
     $      /7x,'only for cation-anion pairs.')
            nwarn = nwarn + 1
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip past the block delimiter line.
c
  120 read (ndat0s,1500,end=990,err=995) uline
 1500 format(a8)
      if (uline(1:8) .eq. uterm(1:8)) then
c
c       Process the next data block.
c
        go to 110
      endif
      go to 120
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdpz2) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
      stop
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/rdpz2) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cophlm(actw,awmax,awmin,delxi,dlxmin,eh,ehmax,
     $ ehmin,fo2lg,iodb,nodbmx,noutpt,o2max,o2min,ph,phmax,phmin,
     $ qadjdx,qredox,tolxsu)
c
c     This subroutine checks for oversteps with regard to specified
c     minimum and maximum values for the pH, Eh, log fO2, and
c     activity of water.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx
c
      integer noutpt
c
      integer iodb(nodbmx)
c
      logical qadjdx,qredox
c
      real*8 actw,awmax,awmin,delxi,dlxmin,eh,ehmax,ehmin,fo2lg,
     $ o2max,o2min,ph,phmax,phmin,tolxsu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      qadjdx = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Is the pH less than the requested minimum value?
c
      if ((ph - phmin) .lt. -tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1000) ph,phmin
 1000      format(/3x,'The pH is ',f7.4,', which is less than the',
     $     ' minimum value',/5x,'of ',f7.4,'. This overstep exceeds',
     $     ' the specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c     Is the pH greater than the requested maximum value?
c
      if ((ph - phmax) .gt. tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1010) ph,phmax
 1010     format(/3x,'The pH is ',f7.4,', which is more than the',
     $    ' maximum value',/5x,'of ',f7.4,'. This overstep exceeds',
     $    ' the specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Is the Eh less than the requested minimum value?
c
        if ((eh - ehmin) .lt. -tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1020) eh,ehmin
 1020       format(/3x,'The Eh is ',f9.4,' v, which is less than the',
     $      ' minimum value',/5x,'of ',f9.4,'. This overstep exceeds',
     $      ' the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the Eh greater than the requested maximum value?
c
        if ((eh - ehmax) .gt. tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1040) eh,ehmax
 1040       format(/3x,'The Eh is ',f9.4,' v, which is more than the',
     $      ' maximum value',/5x,'of ',f9.4,'. This overstep exceeds',
     $      ' the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the log fO2 less than the requested minimum value?
c
        if ((fo2lg - o2min) .lt. -tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1050) fo2lg,o2min
 1050       format(/3x,'The log fO2 is ',f9.4,', which is less than',
     $      ' the minimum value',/5x,'of ',f9.4,'. This overstep',
     $      ' exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the Eh greater than the requested maximum value?
c
        if ((fo2lg - o2max) .gt. tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1060) fo2lg,o2max
 1060       format(/3x,'The log fO2 is ',f9.4,', which is more than',
     $      ' the maximum value',/5x,'of ',f9.4,'. This overstep',
     $      ' exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Is the activity of water less than the requested minimum value?
c
      if ((actw - awmin) .lt. -tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1070) actw,awmin
 1070     format(/3x,'The activity of water is ',f6.4,', which is',
     $    ' less than the',/5x,'minimum value of ',f6.4,'. This',
     $    ' overstep exceeds the',/5x,'specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c     Is the activity of water greater than the requested maximum
c     value?
c
      if ((actw - awmax) .gt. tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1080) actw,awmax
 1080     format(/3x,'The activity of water is ',f6.4,', which is',
     $    ' greater than the',/5x,'maximum value of ',f6.4,'. This',
     $    ' overstep exceeds the',/5x,'specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine pcrsg(aamatr,apr,atwt,avgrid,cdrs,cdrsi,cess,cessi,
     $ cof,dhfe,dhfs,dvfe,dvfs,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,
     $ ipivot,itgenf,mtotr,nacdpr,narxmx,narxt,nat,natmax,nbt,nbtmx1,
     $ nbtmx2,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,ndbmax,ndbptg,
     $ ndbptl,nentei,nentri,nerr,ngt,ngtmax,nlt,nltmax,nmodwr,nmt,
     $ nmtmax,noutpt,nsb,nslist,ntprmx,ntprt,nttyo,nwarn,qelect,
     $ q500fl,tempc,tempcs,tmpcmx,udbfmt,udbval,udrsi,uelem,uessi,
     $ ugassp,uliqsp,uminsp,uspec,xdbval,xhfe,xhfs,xlke,xlks,xvfe,
     $ xvfs,xvec,yvec,zchar)
c
c     This subroutine reads data on solid and gas species from the
c     stripped DATA0 file, processes this data, and writes the results
c     on the DATA1 and DATA1F files. The counter nerr is incremented
c     by one for each error encountered. The counter nwarn is similarly
c     incremented for each warning.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narxt  = array of numbers of coefficients in the temperature
c                  ranges
c       nbt    = the number of basis species
c       nct    = the number of chemical elements
c       ndata1 = unit number of the DATA1 file
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c       ndbptg = the number of distinct points on the temperature grid
c       ndbptl = the maximum number of points on the temperature grid
c                  per line
c       ntprt  = the number of temperature ranges on the standard
c                  temperature grid
c       qelect = flag denoting the use of "e-" instead of "O2(g)"
c                  in writing chemical reactions
c       tempc  = array of temperatures (on the temperature grid)
c       tempcs = array of scaled temperatures (on the temperature grid)
c       tmpcmx = the max norm of the tempeatures on the temperature grid
c       udbfmt = the format for reading a line of data on the
c                  temperature grid
c
c     Principal output:
c
c       atwt   = array of atomic weights
c       cdrs   = array of reaction coefficients
c       cess   = array of elemental composition coefficients
c       nerr   = cumulative error counter
c       ngt    = the number of gas species
c       nlt    = the number of pure liquid species
c       nmt    = the number of pure mineral species
c       nwarn  = cumulative warning counter
c       uelem  = array of names of chemical elements
c       ugassp = array of names of gas species
c       uliqsp = array of names of pure liquids
c       uminsp = array of names of pure minerals
c       uspec  = array of names of species
c       xlke   = array of log K values for the "Eh" reaction (on the
c                  temperature grid)
c       xlks   = array of log K values for reactions
c       zchar  = array of electrical charge numbers
c
c     Workspace:
c
c       aamatr = matrix used to calculate the polynomial coefficients
c       apr    = array of polynomial coefficients (for all ranges)
c       avgrid = array containing the data on the temperature grid
c       cof    = array of fitted polynomial coefficients (for a
c                  single temperature range)
c       gmmatr = a copy of the amatr matrix
c       ipivot = the pivot vector, used in solving matrix equations
c       nacdpr = array containging the number of actual data points
c                  by range on the "log K" temperature grid; excludes
c       udbval = string array for reading data on the temperature grid
c       xdbval = holding space array for data on the temperature grid
c       xvec   = array of scaled temperatures corresponding to the
c                  data in the yvec array
c       yvec   = array of data to be fitted (for a single temperature
c                  range)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,natmax,nbtmx1,nbtmx2,nctmax,ndbmax,
     $ ngtmax,nltmax,nmtmax,ntprmx
c
      integer ndata1,ndat0s,ndat1f,noutpt,nslist,nttyo
c
      integer ipivot(narxmx),nacdpr(ntprmx),narxt(ntprmx),
     $ nentei(nctmax),nentri(nbtmx1)
c
      integer ipch,ipcv,itgenf,nat,nbt,nch,nco,nct,ndbptg,ndbptl,nerr,
     $ ngt,nlt,nmodwr,nmt,nsb,ntprt,nwarn
c
      logical qelect,q500fl
c
      character(len=24) udrsi(nbtmx1),uspec(nbtmx1)
      character(len=24) ugassp(ngtmax),uliqsp(nltmax),uminsp(nmtmax)
      character(len=16) udbval(ndbmax)
      character(len=8) uelem(nctmax),uessi(nctmax)
c
      character(len=16) udbfmt
c
      real(8) atwt(nctmax),cdrs(nbtmx2,nbtmx1),cdrsi(nbtmx1),
     $ cess(nctmax,nbtmx1),cessi(nctmax),dhfe(narxmx,ntprmx,ipchmx),
     $ dhfs(narxmx,ntprmx,ipchmx,nbtmx1),dvfe(narxmx,ntprmx,ipcvmx),
     $ dvfs(narxmx,ntprmx,ipcvmx,nbtmx1),xhfe(narxmx,ntprmx),
     $ xhfs(narxmx,ntprmx,nbtmx1),xlke(narxmx,ntprmx),
     $ xlks(narxmx,ntprmx,nbtmx1),xvfe(narxmx,ntprmx),
     $ xvfs(narxmx,ntprmx,nbtmx1),zchar(nbtmx1)
c
      real(8) apr(narxmx,ntprmx),avgrid(narxmx,ntprmx)
      real(8) tempc(narxmx,ntprmx),tempcs(narxmx,ntprmx),tmpcmx(ntprmx)
      real(8) aamatr(narxmx,narxmx),gmmatr(narxmx,narxmx)
      real(8) cof(narxmx),xvec(narxmx),yvec(narxmx)
      real(8) xdbval(ndbmax),mtotr(nctmax)
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,ipc,j,j2,j3,j4,j5,k,n,nbt1,nblk,nc,ncts,ndrsts,
     $ nmodx,nn,nnx,ns,nsm1,nse,nspnx,nt,ntpr,nxm
c
      integer ilnobl
c
      logical qblkes,qblkrs,qend,qerr,qliq,qnofes,qnofrs,qzeres,
     $ qzerrs,q500nd
c
      character(len=24) uspn(2)
c
      character(len=80) ulbufa,ulbufb,uline,ux80
      character(len=72) uterm,utermc
      character(len=56) ustrgr
      character(len=24) uend24,ublk24,uliq24,ugas24,umin24,unone,
     $ usblkf,ux24
      character(len=16) ux16
      character(len=8) uendit,uliq,ugas,uss,ux8,ux8a,ux8b,ux8c
c
      real(8) mwtss,vol
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
      data ugas24 /'gases                   '/
      data umin24 /'minerals                '/
      data uliq24 /'liquids                 '/
      data ublk24 /'                        '/
      data unone  /'none                    '/
      data uliq   /'liquids '/
      data ugas   /'gases   '/
      data uss    /'solid so'/
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     Write label for minerals.
c
      usblkf = umin24
      j3 = ilnobl(umin24)
      write (ndata1) umin24
      write (ndat1f,1010) umin24(1:j3)
 1010 format(a)
      write (ndat1f,1010) utermc(1:72)
      write (noutpt,1020) umin24(1:j3)
      write (nttyo,1020) umin24(1:j3)
      write (nslist,1020) umin24(1:j3)
 1020 format(//1x,a,/)
c
c     Initialize some variables.
c
      uend24(1:8) = uendit(1:8)
      uend24(9:24)=ublk24(9:24)
      uspn(1) = unone
      uspn(2) = ublk24
      nspnx = 1
      nnx = -1
      nn = 1
      nmodx = 0
      nbt1 = nbt + 1
      ns = nbt1
      zchar(ns) = 0.
      qliq = .false.
      nmt = 0
      nblk = 0
      q500nd = q500fl
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note: the main loop returns here.
c
  100 mwtss = 0.
      ncts = 0
      ndrsts = 0
c
      do nc = 1,nct
        cess(nc,ns) = 0.
        cessi(nc) = 0.
      enddo
c
      do nse = 1,nbt1
        cdrs(nse,ns) = 0.
        cdrsi(nse) = 0.
      enddo
      cdrs(nbt + 2,ns) = 0.
c
      call initcv(uessi,nct,' ')
      call initcv(udrsi,nbt1,' ')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c      Read the first line of the block.
c
  110 continue
      read (ndat0s,1000,end=990,err=995) uline
 1000 format(a)
      ux24 = uline(1:24)
      ux8 = ux24(1:8)
c
      if (ux8(1:8).eq.uliq(1:8) .or. ux8(1:8).eq.ugas(1:8)
     $ .or. ux8(1:8).eq.uss(1:8)) then
c
c       Finish with the current set of species blocks.
c
        if (uspn(1)(1:24) .eq. unone(1:24)) then
          nnx = 0
          nn = 0
          write (nttyo,1140) nnx,unone(1:4)
          write (nslist,1140) nnx,unone(1:4)
 1140     format(1x,i5,2x,a)
          write (noutpt,1150) nn,unone(1:4)
 1150     format(1x,i5,1x,a)
        else
          nxm = nspnx - 1
          if (nxm .ge. 1) then
            nnx = nnx + 2
            if (nxm .eq. 1) then
              j3 = ilnobl(uspn(1))
              write (nttyo,1140) nnx,uspn(1)(1:j3)
              write (nslist,1140) nnx,uspn(1)(1:j3)
            else
              j3 = ilnobl(uspn(2))
              write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
              write (nslist,1160) nnx,uspn(1),uspn(2)(1:j3)
 1160         format(1x,i5,2x,a24,2x,a)
            endif
          elseif (nmodx .ne. 1) then
            j3 = ilnobl(uspn(2))
            write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
          endif
        endif
c
        if (qliq) then
          qliq = .false.
          write (nttyo,1170)
          write (nslist,1170)
          write (noutpt,1170)
 1170     format(/' * Note - (EQPT/pcrsg) The pure liquids block has',
     $    /7x,'not been written on the DATA1 and DATA1F files,',
     $    /7x,'because the EQ3NR and EQ6 codes presently do not',
     $    /7x,'treat non-aqeuous liquids.')
        else
          write (ndata1) uend24,ublk24,ublk24
          j3 = ilnobl(uend24)
          write (ndat1f,1010) uend24(1:j3)
          write (ndat1f,1010) utermc(1:72)
        endif
c
        if (ux8(1:8) .eq. uss(1:8)) then
c
c         Skip the terminator line.
c
          read (ndat0s,1000,end=990,err=995) uline
          go to 999
        else
          read (ndat0s,1000,end=990,err=995) uline
          if (ux8(1:8) .eq. ugas(1:8)) then
c
c           Have found the gas species superblock.
c
            ngt = 0
            nblk = 0
            usblkf = ugas24
            j3 = ilnobl(ugas24)
            write (ndata1) ugas24
            write (ndat1f,1010) ugas24(1:j3)
            write (ndat1f,1010) utermc(1:72)
            write (noutpt,1020) ugas24(1:j3)
            write (nttyo,1020) ugas24(1:j3)
            write (nslist,1020) ugas24(1:j3)
          elseif (ux8 .eq. uliq) then
c
c           Have found the pure liquid superblock.
c
c           Note- EQ3NR and EQ6 presently do not treat non-aqueous
c           liquids.  Do not write liquid data on DATA1 and DATA1F.
c           Set 'qliq' flag to avoid writing such data on these files.
c
            nlt = 0
            nblk = 0
            usblkf = uliq24
            j3 = ilnobl(uliq24)
c           write (ndata1) uliq24
c           write (ndat1f,1010) uliq24
c           write (ndat1f,1010) utermc(1:72)
            qliq = .true.
c
            write (noutpt,1020) uliq24(1:j3)
            write (nttyo,1020) uliq24(1:j3)
            write (nslist,1020) uliq24(1:j3)
          endif
          uspn(1) = unone
          uspn(2) = ublk24
          nspnx = 1
          nnx = -1
          nn = 1
          nmodx = 0
          go to 110
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Have a species block.
c
      nblk = nblk + 1
c
      j2 = ilnobl(ux24)
      if (j2 .le. 0) then
        write (ux8a,'(i5)') nblk
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        j4 = ilnobl(usblkf)
        write (noutpt,1240) ux8a(1:j3),usblkf(1:j4)
        write (nttyo,1240) ux8a(1:j3),usblkf(1:j4)
 1240   format(/' * Error - (EQPT/pcraq) Have encountered a blank',
     $  ' species name',/7x,'for species block ',a,' of the ',a,
     $  ' superblock.')
        if (nblk .gt. 1) then
          if (usblkf(1:24) .eq. umin24(1:24)) then
            ux24 = uminsp(nmt - 1)
          elseif (usblkf(1:24) .eq. uliq24(1:24)) then
            ux24 = uliqsp(nlt - 1)
          elseif (usblkf(1:24) .eq. ugas24(1:24)) then
            ux24 = ugassp(ngt - 1)
          endif
          j5 = ilnobl(ux24)
          if (j5 .gt. 0) then
            write (noutpt,1250) ux24(1:j5)
            write (nttyo,1250) ux24(1:j5)
 1250       format(7x,'This block follows the one for ',a,'.')
          endif
        endif
        ux24 = '<blank>'
        nerr = nerr + 1
      endif
c
      if (usblkf(1:24) .eq. umin24(1:24)) then
        nmt = nmt + 1
        uminsp(nmt) = ux24
      elseif (usblkf(1:24) .eq. uliq24(1:24)) then
        nlt = nlt + 1
        uliqsp(nlt) = ux24
      elseif (usblkf(1:24) .eq. ugas24(1:24)) then
        ngt = ngt + 1
        ugassp(ngt) = ux24
      endif
c
      uspec(ns) = ux24
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the species name for screen and SLIST output.
c
      uspn(nspnx) = uspec(ns)
c
c     Write the species name on the output file.
c
      j2 = ilnobl(uspec(ns))
      write (noutpt,1150) nn,uspec(ns)(1:j2)
c
c     Write species names two per line on the SLIST file.
c
      nspnx = nspnx + 1
      if (nspnx .gt. 2) then
        nspnx = 1
        nnx = nnx + 2
        nmodx = mod(nnx,nmodwr)
        if (nmodwr .eq. 1) nmodx = 1
        j3 = ilnobl(uspn(2))
        if (nmodx .eq. 1) write (nttyo,1160) nnx,uspn(1),uspn(2)(1:j3)
        write (nslist,1160) nnx,uspn(1),uspn(2)(1:j3)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Skip the obsolete 'sp.type =' and 'revised =' lines.
c     Read the molar volume. The electrical charge is zero
c     for all species types read by this subroutine.
c
  130 read (ndat0s,1000,end=990,err=995) uline
      ii = index(uline,'V0PrTr')
      if (ii .eq. 0) go to 130
c
      ux80 = uline(ii + 6:80)
      ii = index(ux80,'=')
      ux16 = ux80(ii + 1:80)
      call lejust(ux16)
      ii = index(ux16,' ')
      if (ii .gt. 0) ux16(ii:16) = ' '
      read (ux16,'(f9.3)',err=995) vol
c1280 format(16x,f9.3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the number of chemical elements composing the species.
c
      read (ndat0s,1000,end=990,err=995) uline
      ux80 = uline
      call lejust(ux80)
      ii = index(ux80,'element(s)')
      if (ii .gt. 1) then
        ux16 = ux80(1:ii - 1)
        read (ux16,'(i5)',err=995) ncts
c1330   format(4x,i2)
      else
        ii = index(ux80,' ')
        if (ii .gt. 1) then
          ux16 = ux80(1:ii - 1)
          read (ux16,'(i5)',err=995) ncts
        else
          ncts = 0
        endif
      endif
c
      if (ncts .gt. nct) then
        j2 = ilnobl(uspec(ns))
        write (ux8a,'(i5)') ncts
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        write (ux8c,'(i5)') nct
        call lejust(ux8c)
        j5 = ilnobl(ux8c)
        write (noutpt,1350) uspec(ns)(1:j2),ux8a(1:j3),ux8c(1:j5)
        write (nttyo,1350) uspec(ns)(1:j2),ux8a(1:j3),ux8c(1:j5)
 1350   format(/' * Error - (EQPT/pcrsg) Species "',a,'" is',
     $  ' composed of ',a,/7x,'chemical elements, but there',
     $  ' are only ',a,' elements on the data file.')
        nerr = nerr + 1
      endif
c
      if (ncts .le. 0) then
        if (uspec(ns)(1:3).ne.'e- ' .and. uspec(ns)(1:3).ne.'E- ') then
          j2 = ilnobl(uspec(ns))
          write (noutpt,1360) uspec(ns)(1:j2)
          write (nttyo,1360) uspec(ns)(1:j2)
 1360     format(/' * Error - (EQPT/pcrsg) Species "',a,'" is not',
     $    ' composed of',/7x,'any chemical elements.')
          nerr = nerr + 1
        endif
      endif
c
c     Read the names of the elements and the corresponding
c     compositional coefficients.
c
      n = 0
      do i = 1,ncts/3
        read (ndat0s,1000,end=990,err=995) uline
        ulbufa = uline
        do k = 1,3
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            read (ux16,'(f8.4)',err=995) cessi(n + k)
          else
            cessi(n + k) = 0.
          endif
          ulbufb = ulbufa(ii + 1:80)
          call lejust(ulbufb)
          uessi(n + k) = ulbufb(1:8)
          if (k .lt. 3) ulbufa = ulbufb(9:80)
        enddo
c       read (uline,1370,err=995) (cessi(n + k),uessi(n + k), k = 1,3)
c1370   format((4x,3(f8.4,1x,a8,5x)))
        n = n + 3
      enddo
c
      j = mod(ncts,3)
      if (j .gt. 0) then
        read (ndat0s,1000,end=990,err=995) uline
        ulbufa = uline
        do k = 1,j
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            read (ux16,'(f8.4)',err=995) cessi(n + k)
          else
            cessi(n + k) = 0.
          endif
          ulbufb = ulbufa(ii + 1:80)
          call lejust(ulbufb)
          uessi(n + k) = ulbufb(1:8)
          if (k .lt. j) ulbufa = ulbufb(9:80)
        enddo
c       read (uline,1370,err=995) (cessi(n + k),uessi(n + k), k = 1,3)
c1370   format((4x,3(f8.4,1x,a8,5x)))
        n = n + j
      endif
c
c     Check for blank element names, duplicate element names, and
c     zero-valued stoichiometric coefficients.
c
      call elesck(cessi,nbtmx1,nctmax,ncts,nentei,nerr,noutpt,
     $ ns,nttyo,qblkes,qzeres,uessi,usblkf,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ns .gt. nsb) then
c
c       Read the number of species in the associated reaction.
c
        read (ndat0s,1000,end=990,err=995) uline
        ux80 = uline
        call lejust(ux80)
        ii = index(ux80,'species')
        if (ii .gt. 1) then
          ux16 = ux80(1:ii - 1)
          read (ux16,'(i5)',err=995) ndrsts
c1500   format(4x,i2)
        else
          ii = index(ux80,' ')
          if (ii .gt. 1) then
            ux16 = ux80(1:ii - 1)
            read (ux16,'(i5)',err=995) ndrsts
          else
            ndrsts = 0
          endif
        endif
c
        if (ndrsts .gt. nbt1) then
          j2 = ilnobl(uspec(ns))
          write (ux8a,'(i5)') ndrsts
          call lejust(ux8a)
          j3 = ilnobl(ux8a)
          write (ux8b,'(i5)') nbt
          call lejust(ux8b)
          j4 = ilnobl(ux8b)
          write (ux8c,'(i5)') nbt1
          call lejust(ux8c)
          j5 = ilnobl(ux8c)
          write (noutpt,1520) uspec(ns)(1:j2),ux8a(1:j3),ux8b(1:j4),
     $    ux8c(1:j5)
          write (nttyo,1520) uspec(ns)(1:j2),ux8a(1:j3),ux8b(1:j4),
     $    ux8c(1:j5)
 1520     format(/' * Error - (EQPT/pcrsg) The reaction for the',
     $    /7x,'destruction of species "',a,'" includes ',a,
     $    /7x,'species, but there are only ',a,' basis species on the',
     $    /7x,'data file, so only ',a,' species may appear in the ',
     $    'reaction.')
          nerr = nerr + 1
        endif
c
        if (ndrsts .lt. 2) then
          j2 = ilnobl(uspec(ns))
          j4 = ilnobl(usblkf)
          write (noutpt,1530) uspec(ns)(1:j2),usblkf(1:j4)
          write (nttyo,1530) uspec(ns)(1:j2),usblkf(1:j4)
 1530     format(/' * Error - (EQPT/pcrsg) The species ',a,
     $    ' appearing',/7x,'on the data file in the ',a,' superblock',
     $    ' has fewer than',/7x,'two species in its associated',
     $    ' reaction. This is not a',/7x,'valid reaction.')
          nerr = nerr + 1
        endif
c
c       Read the names of the species in the reaction and the
c       corresponding reaction coefficients.
c
        n = 0
        do i = 1,ndrsts/2
          read (ndat0s,1000,end=990,err=995) uline
          ulbufa = uline
          do k = 1,2
            call lejust(ulbufa)
            ii = index(ulbufa,' ')
            if (ii .gt. 1) then
              ux16 = ulbufa(1:ii - 1)
              read (ux16,'(f10.4)',err=995) cdrsi(n + k)
            else
              cdrsi(n + k) = 0.
            endif
            ulbufb = ulbufa(ii + 1:80)
            call lejust(ulbufb)
            udrsi(n + k) = ulbufb(1:24)
            if (k .lt. 2) ulbufa = ulbufb(25:80)
          enddo
c         read (uline,1540,err=995) (cdrsi(n + k),udrsi(n + k), k = 1,2)
c1540     format((2(1x,f10.4,2x,a24)))
          n = n + 2
        enddo
c
        j = mod(ndrsts,2)
        if (j .gt. 0) then
          read (ndat0s,1000,end=990,err=995) uline
          ulbufa = uline
          do k = 1,j
            call lejust(ulbufa)
            ii = index(ulbufa,' ')
            if (ii .gt. 1) then
              ux16 = ulbufa(1:ii - 1)
              read (ux16,'(f10.4)',err=995) cdrsi(n + k)
            else
              cdrsi(n + k) = 0.
            endif
            ulbufb = ulbufa(ii + 1:80)
            call lejust(ulbufb)
            udrsi(n + k) = ulbufb(1:24)
            if (k .lt. j) ulbufa = ulbufb(25:80)
          enddo
c         read (uline,1540,err=995) (cdrsi(n + k),udrsi(n + k), k = 1,j)
          n = n + j
        endif
c
c       Check for blank species names, duplicate species names, and
c       zero-valued reaction coefficients. Check that the reaction
c       coefficient of the species with which the reaction is
c       associated has a negative value.
c
        call rxnsck(nbtmx1,cdrsi,nct,ndrsts,nentri,nerr,noutpt,
     $  ns,nsb,nttyo,qblkrs,qzerrs,udrsi,usblkf,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Read the log K grid for the current species.
c       Return the data in the xdbval holding array.
c
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xlks array.
c
c       Calling sequence substitutions:
c         ns for ipc
c         nbtmx1 for ipcmax
c         xlks for zdbval
c
        call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $  ntprmx,ntprt,xdbval,xlks)
c
        if (itgenf .ge. 0) then
c
c         Test the grid ranges for sparseness of actual data.
c
          ustrgr = 'the log K for ' // uspec(ns)
          call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $    ntprt,nttyo,nwarn,ustrgr)
        endif
c
        if (ipch .ge. 0) then
c
c         Read the enthalpy function grid for the current species.
c         Return the data in the xdbval holding array.
c
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the xhfs array.
c
c         Calling sequence substitutions:
c           ns for ipc
c           nbtmx1 for ipcmax
c           xhfs for zdbval
c
          call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $    ntprmx,ntprt,xdbval,xhfs)
c
          if (itgenf .ge. 0) then
c
c           Test the grid ranges for sparseness of actual data.
c
            ustrgr = 'the enthalpy function for ' // uspec(ns)
            call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $      ntprt,nttyo,nwarn,ustrgr)
          endif
c
          do ipc = 1,ipch
c
c           Read the enthalpy function derivative grid for the current
c           species. Return the data in the xdbval holding array.
c
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dhfs array.
c
c           Calling sequence substitutions:
c             ipchmx for ipcmax
c             dhfs for zdbval
c
            call ldbar4(ipc,ipchmx,nacdpr,narxmx,narxt,nbtmx1,
     $      ndbmax,ns,ntprmx,ntprt,xdbval,dhfs)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Read the volume function grid for the current species.
c         Return the data in the xdbval holding array.
c
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the xvfs array.
c
c         Calling sequence substitutions:
c           ns for ipc
c           nbtmx1 for ipcmax
c           xvfs for zdbval
c
          call ldbar3(ns,nbtmx1,nacdpr,narxmx,narxt,ndbmax,
     $    ntprmx,ntprt,xdbval,xvfs)
c
          if (itgenf .ge. 0) then
c
c           Test the grid ranges for sparseness of actual data.
c
            ustrgr = 'the volume function for ' // uspec(ns)
            call tegrid(itgenf,nacdpr,narxt,nerr,noutpt,ntprmx,
     $      ntprt,nttyo,nwarn,ustrgr)
          endif
c
          do ipc = 1,ipcv
c
c           Read the volume function derivative grid for the current
c           species. Return the data in the xdbval holding array.
c
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dvfs array.
c
c           Calling sequence substitutions:
c             ipcvmx for ipcmax
c             dvfs for zdbval
c
            call ldbar4(ipc,ipcvmx,nacdpr,narxmx,narxt,nbtmx1,
     $      ndbmax,ns,ntprmx,ntprt,xdbval,dvfs)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If the reaction is written in terms of e-, rewrite it in terms
c     of O2(g).
c
      if (qelect) then
        call etoo2(cdrsi,dhfe,dhfs,dvfe,dvfs,ipch,ipchmx,ipcv,
     $  ipcvmx,narxmx,narxt,nbtmx1,ndrsts,ns,ntprmx,ntprt,udrsi,
     $  xhfe,xhfs,xlke,xlks,xvfe,xvfs)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the species data.
c
      mwtss = 0.
      qnofes = .false.
      do n = 1,ncts
c
c       Search for element name in the uelem array.
c
        ux8 = uessi(n)(1:8)
        if (ux8(1:7) .ne. '<blank>') then
c
          do nc = 1,nct
            if (ux8(1:8) .eq. uelem(nc)(1:8)) then
              mwtss = mwtss + atwt(nc)*cessi(n)
              cess(nc,ns) = cess(nc,ns) + cessi(n)
              go to 220
            endif
          enddo
c
c         Error, not found.
c
          j3 = ilnobl(ux8)
          write (noutpt,1760) ux8(1:j3),uspec(ns)(1:j2)
          write (nttyo,1760) ux8(1:j3),uspec(ns)(1:j2)
 1760     format(/' * Error - (EQPT/pcrsg) Unrecognized chemical',
     $    ' element "',a,'" is listed',/7x,'in the composition of',
     $    ' the species ',a,'.')
          nerr = nerr + 1
          qnofes = .true.
c
  220     continue
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.qliq) then
        write (ndata1) uspec(ns),ncts,ndrsts
        write (ndat1f,1800) uspec(ns),ncts,ndrsts
 1800   format(a24,2x,2i5)
c
        write (ndata1) mwtss,zchar(ns),vol
        write (ndat1f,1810) mwtss,zchar(ns),vol
 1810   format(5x,f10.3,f5.0,f9.3)
c
        if (ncts .gt. 0) then
          write (ndata1) (cessi(n),uessi(n), n = 1,ncts)
          n = 1
  230     continue
          if (n .eq. ncts) then
            j4 = ilnobl(uessi(n))
            write (ndat1f,1820) cessi(n),uessi(n)(1:j4)
 1820       format(1x,f10.4,2x,a)
            n = n + 1
          else
            j4 = ilnobl(uessi(n + 1))
            write (ndat1f,1830) cessi(n),uessi(n),
     $      cessi(n + 1),uessi(n + 1)(1:j4)
 1830       format(1x,f10.4,2x,a8,1x,f10.4,2x,a)
            n = n + 2
          endif
          if (n .le. ncts) go to 230
        endif
      endif
c
      if (.not.qliq) then
        write (ndata1) (cdrsi(n),udrsi(n), n = 1,ndrsts)
        n = 1
  240   continue
        if (n .eq. ndrsts) then
          j4 = ilnobl(udrsi(n))
          write (ndat1f,1860) cdrsi(n),udrsi(n)(1:j4)
 1860     format(1x,f10.4,2x,a)
          n = n + 1
        else
          j4 = ilnobl(udrsi(n + 1))
          write (ndat1f,1870) cdrsi(n),udrsi(n),
     $    cdrsi(n + 1),udrsi(n + 1)(1:j4)
 1870     format(1x,f10.4,2x,a24,1x,f10.4,2x,a)
          n = n + 2
        endif
        if (n .le. ndrsts) go to 240
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      qnofrs = .false.
      cdrs(nbt1,ns) = cdrsi(1)
      do n = 2,ndrsts
c
c       Search for species name in the uspec array.
c
        ux24 = udrsi(n)
        if (ux24(1:7) .ne. '<blank>') then
c
          do nse = 1,nbt
            if (ux24 .eq. uspec(nse)) then
              cdrs(nse,ns) = cdrs(nse,ns) + cdrsi(n)
              go to 250
            endif
          enddo
c
c         Error, not found.
c
          j3 = ilnobl(ux24)
          write (noutpt,1880) uspec(ns)(1:j2),ux24(1:j3)
          write (nttyo,1880) uspec(ns)(1:j2),ux24(1:j3)
 1880     format(/' * Error - (EQPT/pcrsg) The reaction which destroys',
     $     /7x,'non-basis species ',a,' is written in terms of an',
     $     /7x,'unrecognized basis species "',a,'".')
          nerr = nerr + 1
          qnofrs = .true.
  250     continue
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the reaction for mass and charge balance.
c     Skip if there are already obvious problems.
c
      if (ndrsts .ge. 2) then
        if (.not.qblkes .and. .not.qnofes) then
          if (.not.qblkrs .and. .not.qnofrs) then
            call rxnchk(cdrs,cess,mtotr,nbt,nbtmx1,nbtmx2,nco,
     $      nct,nctmax,nerr,noutpt,ns,nsb,nttyo,uelem,uspec,zchar)
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qliq) go to 300
c
c     Fit interpolating polynomials to the log K grid.
c
      do ntpr = 1,ntprt
        do n = 1,narxt(ntpr)
          avgrid(n,ntpr) = xlks(n,ntpr,ns)
        enddo
      enddo
c
      call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $ narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $ xvec,yvec)
c
      ux24 = 'Log K'
      j2 = ilnobl(ux24)
      write (ndata1) ux24
      write (ndat1f,1010) ux24(1:j2)
c
      do ntpr = 1,ntprt
        nt = narxt(ntpr)
        write (ndata1) (apr(i,ntpr), i = 1,nt)
        write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
 1890   format( 5(1pe16.9) )
      enddo
c
      if (ipch .ge. 0) then
c
c       Fit interpolating polynomials to the enthalpy function grid.
c
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            avgrid(n,ntpr) = xhfs(n,ntpr,ns)
          enddo
        enddo
c
        call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'Enthalpy'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
        enddo
c
        do ipc = 1,ipch
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dhfs(n,ntpr,ipc,ns)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dhfs( )'
          write (ux24(6:6),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
          enddo
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Fit interpolating polynomials to the volume function grid.
c
        do ntpr = 1,ntprt
          do n = 1,narxt(ntpr)
            avgrid(n,ntpr) = xvfs(n,ntpr,ns)
          enddo
        enddo
c
        call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $  narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $  xvec,yvec)
c
        ux24 = 'Volume'
        j2 = ilnobl(ux24)
        write (ndata1) ux24
        write (ndat1f,1010) ux24(1:j2)
c
        do ntpr = 1,ntprt
          nt = narxt(ntpr)
          write (ndata1) (apr(i,ntpr), i = 1,nt)
          write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
        enddo
c
        do ipc = 1,ipcv
c
          do ntpr = 1,ntprt
            do n = 1,narxt(ntpr)
              avgrid(n,ntpr) = dvfs(n,ntpr,ipc,ns)
            enddo
          enddo
c
          call intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $    narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $    xvec,yvec)
c
          ux24 = 'dvfs( )'
          write (ux24(6:6),'(i1)') ipc
          j2 = ilnobl(ux24)
          write (ndata1) ux24
          write (ndat1f,1010) ux24(1:j2)
c
          do ntpr = 1,ntprt
            nt = narxt(ntpr)
            write (ndata1) (apr(i,ntpr), i = 1,nt)
            write (ndat1f,1890) (apr(i,ntpr), i = 1,nt)
          enddo
        enddo
      endif
c
      write (ndat1f,1010) utermc(1:72)
  300 continue
c
c     Look for another species block or terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
      nn = nn + 1
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/pcrsg) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
c
      write (noutpt,2010) nn
      write (nttyo,2010) nn
 2010 format(7x,'The value of the species block counter is ',i3,'.')
      if (ns .gt. 0) then
        j2 = ilnobl(uspec(ns))
        if (j2 .gt. 0) then
          write (noutpt,2020) uspec(ns)(1:j2)
          write (nttyo,2020) uspec(ns)(1:j2)
 2020     format(7x,'The last species name read was "',a,'".')
        else
          nsm1 = ns - 1
          if ((nsm1) .gt. 0) then
            j2 = ilnobl(uspec(nsm1))
            if (j2 .gt. 0) then
              write (noutpt,2020) uspec(nsm1)(1:j2)
              write (nttyo,2020) uspec(nsm1)(1:j2)
            endif
          endif
        endif
      endif
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
 2030   format(7x,'The last line read was the following:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 write (noutpt,2040)
      write (nttyo,2040)
 2040 format(/' * Error - (EQPT/pcrsg) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
c
      write (noutpt,2010) nn
      write (nttyo,2010) nn
      if (ns .gt. 0) then
        j2 = ilnobl(uspec(ns))
        if (j2 .gt. 0) then
          write (noutpt,2020) uspec(ns)(1:j2)
          write (nttyo,2020) uspec(ns)(1:j2)
        else
          nsm1 = ns - 1
          if ((nsm1) .gt. 0) then
            j2 = ilnobl(uspec(nsm1))
            if (j2 .gt. 0) then
              write (noutpt,2020) uspec(nsm1)(1:j2)
              write (nttyo,2020) uspec(nsm1)(1:j2)
            endif
          endif
        endif
      endif
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,67)
        write (noutpt,2030) uline(1:j2)
        write (nttyo,2030) uline(1:j2)
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine tivchk(deltim,delxi,qtvchk,time1,time0,timemx,
     $ tiplol,tiplot,tiprnl,tiprnt,tolxst)
c
c     This subroutine checks to make sure that the calculated
c     time does not exceed any specified limits such as the maximum
c     time. This routine should be called only if delxi is less than
c     or equal to the minimum step size, dlxmin.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c       EQ6/eqshel.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      logical qtvchk
c
      real(8) deltim,delxi,time1,time0,timemx,tiplol,tiplot,tiprnl,
     $ tiprnt,tolxst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      qtvchk = .false.
c
c     Check the next print point in time.
c
      if (((time1 - tiprnt)/tiprnt) .gt. tolxst) then
        time1 = tiprnt
        deltim = tiprnt - time0
        qtvchk = .true.
      endif
c
c     Check the next print point in log time.
c
      if (((time1 - tiprnl)/tiprnl) .gt. tolxst) then
        time1 = tiprnl
        deltim = tiprnl - time0
        qtvchk = .true.
      endif
c
c     Check the next plot point in time.
c
      if (((time1 - tiplot)/tiplot) .gt. tolxst) then
        time1 = tiplot
        deltim = tiplot - time0
        qtvchk = .true.
      endif
c
c     Check the next plot point in log time.
c
      if (((time1 - tiplol)/tiplol) .gt. tolxst) then
        time1 = tiplol
        deltim = tiplol - time0
        qtvchk = .true.
      endif
c
c     Check the maximum time.
c
      if (((time1 - timemx)/timemx) .gt. tolxst) then
        time1 = timemx
        deltim = timemx - time0
        qtvchk = .true.
      endif
c
      end

      subroutine gsmder(delxia,drer0,drer0s,drir0,drir0s,jreac,nord,
     $ nrct,nrctmx,nrd1mx)
c
c     This subroutine computes smoothed or averaged derivatives of the
c     elements of the r vector. The actual derivatives (of various
c     orders) are averaged over the interval (-delxia,+delxia). The
c     base point (point 0) is at the center of this interval.
c
c     Subroutine gsmdez.f performs the same function for elements of
c     the z vector.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx,nrd1mx
c
      integer jreac(nrctmx)
c
      integer nord,nrct
c
      real(8) drer0(nrd1mx,nrctmx),drer0s(nrd1mx,nrctmx),drir0(nrd1mx),
     $ drir0s(nrd1mx)
c
      real(8) delxia
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,nmax,nrc
c
      real(8) drx,dx
c
c-----------------------------------------------------------------------
c
c     Zero the averaged derivative arrays.
c
      do n = 1,nrd1mx
        drir0s(n) = 0.
      enddo
c
      nmax = nrd1mx*nrctmx
      call initaz(drer0s,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The averaged derivatives are calculated over the interval
c     (-delxia,+delxia), about the base point (point 0).
c
      dx = 2.*delxia
c
c     Calculate average derivatives for the inverse rate.
c
      do n = 1,nord
        drx = drir0(nord)
        do k = nord - 1,n,-1
          drx = drir0(k) + (drx*dx/(nord - n + 1))
        enddo
        drir0s(n) = drx
      enddo
c
c     Calculate average derivatives for relative rates.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1)  then
          do n = 1,nord
            drx = drer0(nord,nrc)
            do k = nord - 1,n,-1
              drx = drer0(k,nrc) + (drx*dx/(nord - n + 1))
            enddo
            drer0s(n,nrc) = drx
          enddo
        endif
      enddo
c
  999 continue
      end

      subroutine wr6d7(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $ dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $ imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $ jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $ hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $ nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,nopgmx,noprmx,
     $ noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,nrk,
     $ nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,
     $ nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,rk0,rxbarb,
     $ sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,tolsst,
     $ tolx,trk0,tstrt,ttk,ucode,udac,uelemb,uendb,uesrb,ueqlrn,
     $ ueqlst,uffg,undms,unrms,uprs,ureac,urelno,ustage,utitl1,
     $ utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,
     $ zistrt,zkfac,zklogl,zklogu,zvclgi)
c
c     This subroutine writes the EQ6 input file in menu-style ("D")
c     format for versions 7.0-7.1.
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nctmax,ndctmx,nffgmx,nodbmx,nopgmx,
     $ noprmx,noptmx,nprsmx,nrctmx,nsrtmx,nsscmx,ntitmx,nttkmx,nxmdmx,
     $ nxopmx,nxpemx,nxrtmx
c
      integer iact(imchmx,2,nrctmx),iktbt(nxrtmx),imech(2,nrctmx),
     $ iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jcode(nrctmx),jreac(nrctmx),jxmod(nxmdmx),kxmod(nxmdmx),
     $ ndact(imchmx,2,nrctmx),nesrbt(nsrtmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ioscan,itermx,jtemp,kct,kdim,ksq,kmt,kprs,ksppmx,
     $ kstpmx,kxt,newin,nffg,nmodl1,nmodl2,nordlm,npslmx,nprmn,nprmx,
     $ nrct,nsslmx,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*48 uprs(nprsmx)
      character*24 udac(ndctmx,imchmx,2,nrctmx),uendb(iktmax,nxrtmx),
     $ uffg(nffgmx),undms(kmax),unrms(kmax),ureac(nrctmx),
     $ uxmd24(nxmdmx),uxopex(nxpemx)
      character*16 uxct16(nxopmx)
      character*8 uelemb(nctmax),uesrb(nctmax,nsrtmx),uxopt(nxopmx)
      character*8 ucode,urelno,ustage,ueqlrn,ueqlst
c
      real*8 cdac(ndctmx,imchmx,2,nrctmx),cesrb(nctmax,nsrtmx),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),fk(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprs(nprsmx),mteaqb(nctmax),mteb(nctmax),rk0(imchmx,2,nrctmx),
     $ rxbarb(iktmax,nxrtmx),sscrew(nsscmx),sk(nrctmx),ttk(nttkmx),
     $ trk0(imchmx,2,nrctmx),vreac(nrctmx),xlkffg(nffgmx),
     $ xlkmod(nxmdmx),zvclgi(kmax)
c
      real*8 dlzmx1,dlzmx2,dlzidp,dzprlg,dzprnt,electr,tempci,tempc0,
     $ timemx,tolbt,toldl,tolsat,tolsst,tolx,tstrt,zkfac,zklogl,
     $ zklogu,zimax,zistrt
c
c-----------------------------------------------------------------------
c
      include 'xcon6/x6op7.h'
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,idesc,idescx,iktb,ival,j2,k,kc,kcol,n,ncb,npr,nrc,
     $ nsrt,nxrt
c
      integer ilnobl
c
      character*24 ux24(3)
      character*24 ublk24,unone,uxx
      character*16 udef(nto6pa),ujx(0:3),umint(0:4)
      character*8 usup(-1:2),ux8(3)
      character*8 ublk8
      character*1 ux1(3)
c
      real*8 zero
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data unone  /'none                    '/
c
      data udef(1)  / '40      itermx  '/
      data udef(2)  / 'varies  dlzidp  '/
      data udef(3)  / '1.0e-06 tolbt   '/
      data udef(4)  / '1.0e-06 toldl   '/
      data udef(5)  / 'varies  tolx    '/
      data udef(6)  / 'varies  tolsat  '/
      data udef(7)  / 'varies  tolsst  '/
      data udef(8)  / '1.0e-04 screw1  '/
      data udef(9)  / 'n/a     screw2  '/
      data udef(10) / '1.0e-04 screw3  '/
      data udef(11) / '1.0e-04 screw4  '/
      data udef(12) / '4.0     screw5  '/
      data udef(13) / '4.0     screw6  '/
      data udef(14) / 'varies  zklogu  '/
      data udef(15) / '2.0     zklogl  '/
      data udef(16) / '.98     zkfac   '/
      data udef(17) / 'varies  dlzmx1  '/
      data udef(18) / 'varies  dlzmx2  '/
      data udef(19) / '6       nordlm  '/
      data udef(20) / '25      ntrymx  '/
      data udef(21) / '8       npslmx  '/
      data udef(22) / '3       nsslmx  '/
      data udef(23) / 'none    ioscan  '/
c
      data ujx(0)   / 'aqueous         '/
      data ujx(1)   / 'mineral         '/
      data ujx(2)   / 'gas             '/
      data ujx(3)   / 'solid solution  '/
c
      data umint(0) / 'mineral         '/
      data umint(1) / 'solid solution  '/
      data umint(2) / 'special         '/
      data umint(3) / 'aqueous         '/
      data umint(4) / 'gas             '/
c
      data usup(-1) / 'suppress'/
      data usup(0)  / 'replace '/
      data usup(1)  / 'augmentk'/
      data usup(2)  / 'augmentg'/
c
      data ublk8  /'        '/
c
      data zero   /0./
c
c-----------------------------------------------------------------------
c
c     Write the new input file.
c
c     Title.
c
      write (newin,1090)
 1090 format('|',70('-'),'|')
      do 110 n = 1,ntitl1
        write (newin,1100) utitl1(n)
 1100   format('|',a70,'|')
  110 continue
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Nmodl option switches.
c
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      if (nmodl2 .eq. 0) then
        ux1(1) = '*'
      elseif (nmodl2 .eq. 1) then
        ux1(2) = '*'
      elseif (nmodl2.eq.2) then
        ux1(3) = '*'
      else
        ux1(1) = '*'
      endif
      write (newin,1120) ux1(1),ux1(2),ux1(3)
 1120 format('| calculational mode   |',a1,'normal',t37,'|',a1,
     $ 'economy',t57,'|',a1,'super economy',t72,'|')
c
      write (newin,1090)
      ux1(1) = ' '
      ux1(2) = ' '
      ux1(3) = ' '
      if (nmodl1 .eq. 1) then
        ux1(1) = '*'
      elseif (nmodl1.eq.2 .or. nmodl1.eq.0) then
        ux1(2) = '*'
      elseif (nmodl1 .eq. 3) then
        ux1(3) = '*'
      else
        ux1(1) = '*'
      endif
      write (newin,1130) ux1(1),ux1(2),ux1(3)
 1130 format('| model type',t24,'|',a1,'titration',t37,'|',a1,'closed',
     $ t57,'|',a1,'open',t72,'|')
c
c-----------------------------------------------------------------------
c
c     Temperature parameters.
c     Note: ttk(1) = tk1, etc.
c
      write (newin,1090)
      ux1(1) = ' '
      ux1(2) = ' '
      if (jtemp .eq. 0) then
         ux1(1) = '*'
      elseif (jtemp .eq. 1) then
         ux1(2) = '*'
      else
         ux1(1) = '*'
      endif
      write (newin,1140) ux1(1),ux1(2)
 1140 format('| temperature model',t24,'|',a1,'power',t37,'|',a1,
     $ 'fluid mixing',t72,'|')
c
      write (newin,1090)
      write (newin,1150)
 1150 format('c power model  -->   temp = tstart + tk1*zi +',
     $ ' tk2*zi**2 + tk3*zi**3',t72,'|',
     $ /'c mixing model -->   temp = (tstart * tk1 + zi*tk2) /',
     $ ' (zi + tk1)',t72,'|',/'c',70('-'),'|')
      write (newin,1155) tempc0,(ttk(i), i = 1,3)
 1155 format('| tstart(c)|',1pg11.4,'|tk1|',1pg11.4,'|tk2|',1pg11.4,
     $ '|tk3|',1pg11.4,t72,'|')
c
c-----------------------------------------------------------------------
c
c      Zi and time parameters.
c
      write (newin,1090)
      write (newin,1160) zistrt,zimax
 1160 format('| starting value of zi |',1pg12.5,'|max. value of zi',
     $ t58,'|',1pg12.5,t72,'|')
c
      write (newin,1090)
      write (newin,1170) tstrt,timemx
 1170 format('| starting time (sec)  |',1pg12.5,'|max. time (sec)',
     $ t58,'|',1pg12.5,t72,'|')
c
      write (newin,1090)
      write (newin,1175) kstpmx,ksppmx
 1175 format('| max. steps',t24,'|',i10,2x,'|max. steps w/o print|',
     $ i10,t72,'|')
c
c     Note: cplim does not appear on the "D" format input file.
c
c     Print interval parameters.
c
      write (newin,1090)
      write (newin,1180) dzprnt,dzprlg
 1180 format('| linear print interval|',1pg12.5,
     $ '|log print interval  |',1pg12.5,t72,'|')
c
c     Plot interval parameters.
c
c     Note: dzplot, dzpllg, and ksplmx do not appear on the "D"
c     format input file.
c
c     Note: ifile does not appear on the "D" format input file.
c
c-----------------------------------------------------------------------
c
c     Nxopt options.
c
      write (newin,1090)
      write (newin,1190)
 1190 format('| suppress mineral phases',t72,'|')
      write (newin,1090)
c
      ux8(1) = ublk8
      ux8(2) = ublk8
      if (nxopt .gt. 0) then
        k = 0
        do 140 n = 1,nxopt
          k = k + 1
          if (uxopt(n)(1:8) .eq. 'all     ') then
            ux8(k) = uxopt(n)
          elseif (uxopt(n)(1:8) .eq. 'alwith  ') then
            ux8(k) = uxct16(n)
          else
            ux8(k) = uxct16(n)
          endif
          if (k .eq. 2) then
            write (newin,1200)  ux8(1),ux8(2)
 1200       format('| phases w/ elements|  ',a8,t46,'|  ',a8,t72,'|n')
            k = 0
            ux8(1) = ublk8
            ux8(2) = ublk8
          endif
  140   continue
        if (k .eq. 1) write (newin,1200)  ux8(1),ux8(2)
      else
        write (newin,1200)  ux8(1),ux8(2)
      endif
c
      ux24(1) = ublk24
      ux24(2) = ublk24
      if (nxopex .gt. 0) then
        k = 0
        do 150 n = 1,nxopex
          k = k + 1
          ux24(k) = uxopex(n)
          if (k .eq. 2) then
            write (newin,1210)  ux24(1),ux24(2)
 1210       format('| phases except',t21,'|  ',a22,t46,'|  ',a23,
     $      t72,'|n')
            k = 0
            ux24(1) = ublk24
            ux24(2) = ublk24
          endif
  150   continue
        if (k .eq. 1) write (newin,1210)  ux24(1),ux24(2)
      else
        write (newin,1210)  ux24(1),ux24(2)
      endif
c
c-----------------------------------------------------------------------
c
c     Nffg options.
c
      write (newin,1090)
      write (newin,1220)
 1220 format('| fixed fugacity phases- species, moles(per kg h2o), ',
     $ 'log fugacity(bars)',t72,'|')
      write (newin,1090)
      if (nffg .gt. 0) then
        write (newin,1230) (uffg(i),moffg(i),xlkffg(i), i = 1,nffg)
 1230 format('| ',a24,t38,'|',1pg12.5,t55,'|',1pg12.5,t72,'|n')
      else
        write (newin,1240)
 1240 format('| none',t38,'|',t55,'|',t72,'|n')
      endif
c
c-----------------------------------------------------------------------
c
c     Reactants and rate laws.
c
      write (newin,1090)
      write (newin,1250)
 1250 format('c',t20,'R A T E     L A W S',/,
     $ 'c 1 = relative',t33,'rate = rk1 + rk2*zi + (1/2)rk3*zi*zi',
     $ /'c 2 = transition state theory',t33,
     $ 'rate = CHECK DOCUMENTATION',
     $ /'c 3 = specified rate',
     $ /'c 4 = activity term rate',t33,'rate = CHECK DOCUMENTATION',
     $ /'c',/'c ',t20,'R E A C T A N T     T Y P E S',
     $ /'c mineral     solid solution     special    aqueous    gas',
     $ /'c',/'c ',t20,'S U R F A C E    T Y P E',
     $ /'c 0 = fixed surface area     1 = fixed specific surface area',
     $ /'c',/,'c',t20,'N O T E S',
     $ /'c status and jreac are normally not set by the user')
      write (newin,1090)
      write (newin,1260)
 1260 format('| reactants   (ss) solid solution only',
     $       5x,'(sp) special reactant only  |')
      write (newin,1090)
c
      if (nrct .eq. 0) then
        write (newin,1270)
 1270   format('| REACTANT',t20,'| none',t45,'|status',t55,'|',t72,'|')
      else
        nsrt = 0
        nxrt = 0
        do 390 nrc = 1,nrct
          if (nrc .gt. 1) write (newin,1280)
 1280     format('c',70('-'),'|')
c
c         Name, flags, and masses.
c
          write (newin,1290) ureac(nrc),jreac(nrc)
 1290     format('| REACTANT',t20,'|  ',a22,t45,'|status',t55,'|',i2,
     $    t72,'|')
          write (newin,1300) morr(nrc),modr(nrc)
 1300     format('| moles remaining',t20,'|',1pg12.5,t45,'|destroyed',
     $    t55,'|',1pg12.5,t72,'|')
          write (newin,1310) umint(jcode(nrc)),sk(nrc)
 1310     format('| reactant type',t20,'|',2x,a14,t45,'|sk',t55,'|',
     $    1pg12.5,t72,'|')
          write (newin,1320) nsk(nrc),fk(nrc)
 1320     format('| surface type',t20,'|',2x,i2,t45,'|fk',t55,
     $    '|',1pg12.5,t72,'|')
c
          if (jcode(nrc) .eq. 1) then
c
c           Solid solution compositions.
c
            nxrt = nxrt + 1
            do 170 iktb = 1,iktbt(nxrt)
              write (newin,1330) uendb(iktb,nxrt),rxbarb(iktb,nxrt)
 1330         format('| end-member',t20,'|',a24,t45,
     $        '|mole fr',t55,'| ',1pg14.6,t72,'|ss,n')
  170       continue
  180       if (iktbt(nxrt) .eq. 0) write (newin,1330) unone,zero
          else
            write (newin,1340)
 1340       format('| end-member',t20,'|',t45,'|mole fr',t55,'|',
     $       t72,'|ss,n')
          endif
c
         if (jcode(nrc) .eq. 2) then
c
c           Special reactant compositions.
c
            nsrt = nsrt + 1
            write (newin,1350) vreac(nrc)
 1350       format('| volume',t20,'|',1pg12.5,t45,'|',t55,'|',t72,'|sp')
c
            do 190 ncb = 1,nesrbt(nsrt)
              write (newin,1360) uesrb(ncb,nsrt),cesrb(ncb,nsrt)
 1360         format('| element',t20,'|  ',a8,t35,'|moles',t45,'|',
     $        1x,1pe25.15,t72,'|sp,n')
  190       continue
  200       if (nesrbt(nsrt) .eq. 0) write (newin,1360) unone(1:8),zero
          else
            write (newin,1370)
 1370       format('| volume',t20,'|',t45,'|',t55,'|',t72,'|sp',
     $      /'| element',t20,'|',t45,'|moles',t55,'|',t72,'|sp,n')
          endif
c
c         Rate law parameters, forward direction.
c
          write (newin,1380) nrk(1,nrc)
 1380     format('| DISSOLUTION LAW  |',i5,t45,'|',t55,'|',t72,'|')
c
          if (nrk(1,nrc) .eq. 1) then
            do 210 i = 1,imech(1,nrc)
              write (newin,1390) i,rk0(i,1,nrc),i
 1390         format('| rate constant rk',i1,t20,'|',1pg12.5,t45,
     $        '|csigma',i1,t55,'|',t72,'|')
  210       continue
          elseif (nrk(1,nrc) .eq. 2) then
            do 230 i = 1,imech(1,nrc)
              write (newin,1395) i,rk0(i,1,nrc),i,csigma(i,1,nrc)
 1395         format('| rate constant rk',i1,t20,'|',1pg12.5,t45,
     $        '|csigma',i1,t55,'| ',1pg14.6,t72,'|')
              do 220 n = 1,ndact(i,1,nrc)
                write (newin,1400) udac(n,i,1,nrc),cdac(n,i,1,nrc)
 1400           format('| aqueous species  | ',a23,t45,'|cdac',t55,
     $          '| ',1pg14.5,t72,'|n')
  220         continue
              write (newin,1410) trk0(i,1,nrc)
 1410         format('| temperature (c)  | ',1pg12.5,t45,'|',t55,'|',
     $        t72,'|234')
              if (iact(i,1,nrc) .eq. 1) then
                write (newin,1420) eact(i,1,nrc)
 1420           format('| act. energy-kcal | ',1pg12.5,t45,'|enthalpy',
     $          t55,'|',t72,'|234')
              elseif (iact(i,1,nrc) .eq. 2) then
                write (newin,1430) hact(i,1,nrc)
 1430           format('| act. energy-kcal | ',t45,'|enthalpy',
     $          t55,'| ',1pg12.5,t72,'|234')
              endif
  230       continue
          elseif (nrk(1,nrc) .eq. 3) then
            do 250 i = 1,imech(1,nrc)
              write (newin,1390) i,rk0(i,1,nrc),i
              do 240 n = 1,ndact(i,1,nrc)
                write (newin,1400) udac(n,i,1,nrc),cdac(n,i,1,nrc)
  240         continue
              write (newin,1410) trk0(i,1,nrc)
              if (iact(i,1,nrc) .eq. 1) then
                write (newin,1420) eact(i,1,nrc)
              elseif (iact(i,1,nrc) .eq. 2) then
                write (newin,1430) hact(i,1,nrc)
              endif
  250       continue
          elseif (nrk(1,nrc) .eq. 4) then
            do 270 i = 1,imech(1,nrc)
              write (newin,1390) i,rk0(i,1,nrc),i
              do 260 n = 1,ndact(i,1,nrc)
                write (newin,1400) udac(n,i,1,nrc),cdac(n,i,1,nrc)
  260         continue
              write (newin,1410) trk0(i,1,nrc)
              if (iact(i,1,nrc) .eq. 1) then
                write (newin,1420) eact(i,1,nrc)
              elseif (iact(i,1,nrc) .eq. 2) then
                write (newin,1430) hact(i,1,nrc)
              endif
  270       continue
          endif
c
c         Rate law parameters, backward direction.
c
          write (newin,1440) nrk(2,nrc)
 1440     format('| PRECIPITATION LAW|',i5,t45,'|',t55,'|',t72,'|')
c
          if (nrk(2,nrc) .eq. 1) then
            do 280 i = 1,imech(2,nrc)
              write (newin,1390) i,rk0(i,2,nrc),i
  280       continue
          elseif (nrk(2,nrc) .eq. 2) then
            do 300 i = 1,imech(2,nrc)
              write (newin,1395) i,rk0(i,2,nrc),i,csigma(i,2,nrc)
              do 290 n = 1,ndact(i,2,nrc)
                write (newin,1400) udac(n,i,2,nrc),cdac(n,i,2,nrc)
  290         continue
              write (newin,1410) trk0(i,2,nrc)
              if (iact(i,2,nrc) .eq. 1) then
                write (newin,1420) eact(i,2,nrc)
              elseif (iact(i,2,nrc) .eq. 2) then
                write (newin,1430) hact(i,2,nrc)
              endif
  300       continue
          elseif (nrk(2,nrc) .eq. 3) then
            do 320 i = 1,imech(2,nrc)
              write (newin,1390) i,rk0(i,2,nrc),i
              do 310 n = 1,ndact(i,2,nrc)
                write (newin,1400) udac(n,i,2,nrc),cdac(n,i,2,nrc)
  310         continue
              write (newin,1410) trk0(i,2,nrc)
              if (iact(i,2,nrc) .eq. 1) then
                write (newin,1420) eact(i,2,nrc)
              elseif (iact(i,2,nrc) .eq. 2) then
                write (newin,1430) hact(i,2,nrc)
              endif
  320       continue
          elseif (nrk(2,nrc) .eq. 4) then
            do 340 i = 1,imech(2,nrc)
              write (newin,1390) i,rk0(i,2,nrc),i
              do 330 n = 1,ndact(i,2,nrc)
                write (newin,1400) udac(n,i,2,nrc),cdac(n,i,2,nrc)
  330         continue
              write (newin,1410) trk0(i,2,nrc)
              if (iact(i,2,nrc) .eq. 1) then
                write (newin,1420) eact(i,2,nrc)
              elseif (iact(i,2,nrc) .eq. 2) then
                write (newin,1430) hact(i,2,nrc)
              endif
  340       continue
          endif
c
  390   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Options. Iopt, iopr, and iodb option switches, but not iopg
c     option switches. Skip any of the above which happen to be
c     development options.
c
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1090)
      write (newin,1460)
 1460 format('| options',t72,'|')
      write (newin,1090)
c
      do 410 idescx = 1,nop6pa
        if (uvar6(idescx)(1:4) .ne. 'iopg') then
          j2 = ilnobl(uopt6(idescx))
          write (newin,1465) uopt6(idescx)(1:j2)
 1465     format('| - ',a,' -',t72,'|')
c
          do 400 idesc = 1,nod6pa
            if (iopti6(idesc) .eq. idescx) then
              if (uvar6(idescx)(1:4) .eq. 'iopt') then
                if (iopt(index6(idescx)) .eq. ivalu6(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              elseif (uvar6(idescx)(1:4) .eq. 'iopr') then
                if (iopr(index6(idescx)) .eq. ivalu6(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              elseif (uvar6(idescx)(1:4) .eq. 'iodb') then
                if (iodb(index6(idescx)) .eq. ivalu6(idesc)) then
                  ux1(1) = '*'
                else
                  ux1(1) = ' '
                endif
              else
                ux1(1) = ' '
              endif
              j2 = ilnobl(udesc6(idesc))
              write (newin,1470) ux1(1),udesc6(idesc)(1:j2)
 1470         format('|',t5,a1,t7,a,t72,'|')
            endif
  400     continue
        endif
  410 continue
c
c-----------------------------------------------------------------------
c
c     Development options.
c
      write (newin,1090)
      write (newin,1480)
 1480 format('| development options  (used for code development)',
     $ t72,'|')
      write (newin,1090)
c
      do 420 idescx = 1,ndv6pa
        ival = 0
        if (udv6vr(idescx)(1:4) .eq. 'iopt') then
          ival = iopt(idev6i(idescx))
        elseif (udv6vr(idescx)(1:4) .eq. 'iopr') then
          ival = iopr(idev6i(idescx))
        elseif (udv6vr(idescx)(1:4) .eq. 'iodb') then
          ival = iodb(idev6i(idescx))
        elseif (udv6vr(idescx)(1:4) .eq. 'iopg') then
          ival = iopg(idev6i(idescx))
        endif
        j2 = ilnobl(udevl6(idescx))
        write (newin,1490) ival,udevl6(idescx)(1:j2)
 1490   format('|',i5,1x,a,t72,'|')
  420 continue
c
c-----------------------------------------------------------------------
c
c     Tolerances.
c
      write (newin,1090)
      write (newin,1500)
 1500 format('| tolerances',t36,'desired values - defaults info-only |')
      write (newin,1090)
c
c     Maximum number of iterations.
c
      if (itermx .eq. 0) then
        write (newin,1510) utol6(1),udef(1)
 1510   format('| ',a32,'|',t54,'|',2x,a14,t72,'|')
      else
        write (newin,1520) utol6(1),itermx,udef(1)
 1520   format('| ',a32,'|',i10,t54,'|',2x,a14,t72,'|')
      endif
c
c     Dump interval.
c
      if (dlzidp .eq. 0) then
        write (newin,1510) utol6(2),udef(2)
      else
        write (newin,1530) utol6(2),dlzidp,udef(2)
 1530   format('| ',a32,'|',1pg12.5,t54,'|',2x,a14,t72,'|')
      endif
c
c     True tolerances.
c
      if (tolbt .eq. 0) then
        write (newin,1510) utol6(3),udef(3)
      else
        write (newin,1530) utol6(3),tolbt,udef(3)
      endif
      if (toldl .eq. 0) then
        write (newin,1510) utol6(4),udef(4)
      else
        write (newin,1530) utol6(4),toldl,udef(4)
      endif
      if (tolx .eq. 0) then
        write (newin,1510) utol6(5),udef(5)
      else
        write (newin,1530) utol6(5),tolx,udef(5)
      endif
      if (tolsat .eq. 0) then
        write (newin,1510) utol6(6),udef(6)
      else
        write (newin,1530) utol6(6),tolsat,udef(6)
      endif
      if (tolsst .eq. 0) then
        write (newin,1510) utol6(7),udef(7)
      else
        write (newin,1530) utol6(7),tolsst,udef(7)
      endif
c
c     Setscrew parameters.
c     Note: sscrew(1) = screw1, etc.
c
      if (sscrew(1) .eq. 0) then
        write (newin,1510) utol6(8),udef(8)
      else
        write (newin,1530) utol6(8),sscrew(1),udef(8)
      endif
      if (sscrew(2) .eq. 0) then
        write (newin,1510) utol6(9),udef(9)
      else
        write (newin,1530) utol6(9),sscrew(2),udef(9)
      endif
      if (sscrew(3) .eq. 0) then
        write (newin,1510) utol6(10),udef(10)
      else
        write (newin,1530) utol6(10),sscrew(3),udef(10)
      endif
      if (sscrew(4) .eq. 0) then
        write (newin,1510) utol6(11),udef(11)
      else
        write (newin,1530) utol6(11),sscrew(4),udef(11)
      endif
      if (sscrew(5) .eq. 0) then
        write (newin,1510) utol6(12),udef(12)
      else
        write (newin,1530) utol6(12),sscrew(5),udef(12)
      endif
      if (sscrew(6) .eq. 0) then
        write (newin,1510) utol6(13),udef(13)
      else
        write (newin,1530) utol6(13),sscrew(6),udef(13)
      endif
c
c     Z parameters.
c
      if (zklogu .eq. 0) then
        write (newin,1510) utol6(14),udef(14)
      else
        write (newin,1530) utol6(14),zklogu,udef(14)
      endif
      if (zklogl .eq. 0) then
        write (newin,1510) utol6(15),udef(15)
      else
        write (newin,1530) utol6(15),zklogl,udef(15)
      endif
      if (zkfac .eq. 0) then
        write (newin,1510) utol6(16),udef(16)
      else
        write (newin,1530) utol6(16),zkfac,udef(16)
      endif
c
c     Step size limits and maximum order.
c
      if (dlzmx1 .eq. 0) then
        write (newin,1510) utol6(17),udef(17)
      else
        write (newin,1530) utol6(17),dlzmx1,udef(17)
      endif
      if (dlzmx2 .eq. 0) then
        write (newin,1510) utol6(18),udef(18)
      else
        write (newin,1530) utol6(18),dlzmx2,udef(18)
      endif
      if (nordlm .eq. 0) then
        write (newin,1510) utol6(19),udef(19)
      else
        write (newin,1520) utol6(19),nordlm,udef(19)
      endif
c
c     Maximum number of phase assemblage tries.
c
      if (ntrymx .eq. 0) then
        write (newin,1510) utol6(20),udef(20)
      else
        write (newin,1520) utol6(20),ntrymx,udef(20)
      endif
c
c     Slide and scan control parameters.
c
      if (npslmx .eq. 0) then
        write (newin,1510) utol6(21),udef(21)
      else
        write (newin,1520) utol6(21),npslmx,udef(21)
      endif
      if (nsslmx .eq. 0) then
        write (newin,1510) utol6(22),udef(22)
      else
        write (newin,1520) utol6(22),nsslmx,udef(22)
      endif
      if (ioscan .eq. 0) then
        write (newin,1510) utol6(23),udef(23)
      else
        write (newin,1520) utol6(23),ioscan,udef(23)
      endif
      write (newin,1090)
c
c-----------------------------------------------------------------------
c
c     Bottom half of the current output file.
c
c     Write recaptured data in comments on the originating code, if
c     known.
c
      if (ucode(1:3).eq.'EQ6' .or. ucode(1:3).eq.'eq6') then
        write (newin,2180) urelno,ustage,ueqlrn,ueqlst
 2180   format('c pickup file written by eq6.',a4,a6,t72,'|',
     $  /'c  supported by eqlib.',a4,a6,t72,'|')
      endif
c
      if (ucode(1:5).eq.'EQ3NR' .or. ucode(1:5).eq.'eq3nr') then
        write (newin,2190) urelno,ustage,ueqlrn,ueqlst
 2190   format('c pickup file written by eq3nr.',a4,a6,t72,'|',
     $  /'c  supported by eqlib.',a4,a6,t72,'|')
      endif
c
c-----------------------------------------------------------------------
c
c     Title.
c
      do 500 n = 1,ntitl2
        write (newin,3010) utitl2(n)
 3010   format('|',a70,'|')
  500 continue
      write (newin,3020)
 3020 format('|',70('-'),'|')
c
c-----------------------------------------------------------------------
c
c     Original temperature.
c
      write (newin,3030) tempci
 3030 format('| temperature (C)',t38,'|',3x,1pg12.5,t72,'|')
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Electrical imbalance
c
      write (newin,3040) electr
 3040 format('| electrical imbalance',t38,'|',2x,1pe25.15,t72,'|')
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Number of aqueous basis species.
c
      write (newin,3050) ksq
 3050 format('| number of aqueous master species',t38,'|',2x,i5,t72,
     $ '|')
      write (newin,3020)
c
c     Index of the last pure mineral.
c
      write (newin,3060) kmt
 3060 format('| position of last pure mineral',t38,'|',2x,i5,t72,'|')
      write (newin,3020)
c
c     Index of the last solid solution.
c
      write (newin,3070) kxt
 3070 format('| position of last solid solution',t38,'|',2x,i5,t72,'|')
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      write (newin,3080)
 3080 format('| suppressed species',5x,
     $ '(suppress,replace,augmentk,augmentg)  value',t72,'|')
      write (newin,3020)
      if (nxmod .gt. 0) then
        do 520 n = 1,nxmod
          write (newin,3090) uxmd24(n),ujx(jxmod(n)),usup(kxmod(n)),
     $    xlkmod(n)
 3090     format('| ',a24,t26,'| ',a14,' | ',a8,' | ',1pg12.5,t72,'|')
  520   continue
      else
        write(newin,3095) unone
 3095     format('| ',a8,t26,'|',t43,'|',t54,'|',t72,'|')
      endif
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,3100)
 3100 format('| iopg options',t72,'|')
c
      write (newin,3020)
      do 540 idescx = 1,nop6pa
        if (uvar6(idescx)(1:4) .eq. 'iopg') then
          j2 = ilnobl(uopt6(idescx))
          write (newin,3110) uopt6(idescx)(1:j2)
 3110     format('| - ',a,' -',t72,'|')
          do 530 idesc = 1,nod6pa
            if (iopti6(idesc) .eq. idescx) then
              if (iopg(index6(idescx)) .eq. ivalu6(idesc)) then
                ux1(1) = '*'
              else
                ux1(1) = ' '
              endif
              j2 = ilnobl(udesc6(idesc))
              write (newin,3120) ux1(1),udesc6(idesc)(1:j2)
 3120         format('|    ',a1,1x,a,t72,'|')
            endif
  530     continue
        endif
  540 continue
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Balance totals.
c
      write (newin,3130)
 3130 format('| elements, moles and moles aqueous',t72,'|')
      write (newin,3020)
c
      do 550 kc = 1,kct
        write (newin,3140) uelemb(kc),mteb(kc),mteaqb(kc)
 3140   format('|',10x,a8,t20,'|',1pe25.15,'|',1pe25.15,'|')
  550 continue
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Basis variable data.
c
      write (newin,3150)
 3150 format('| master species and logarithmic basis variables',t72,'|')
      write (newin,3020)
c
      do 560 kcol = 1,kdim
        write (newin,3160) unrms(kcol),undms(kcol),zvclgi(kcol)
 3160   format('|',a19,'|',a24,t46,'|',1pe25.15,t72,'|')
  560 continue
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
c     Physically removed system data.
c
      write (newin,3170)
 3170 format('| physically removed subsystem ',
     $ ' (solid solution, mineral, moles)',t72,'|')
      write (newin,3020)
c
      if (kprs .gt. 0) then
        do 570 npr = 1,nprmn
          write (newin,3180) uprs(npr),mprs(npr)
 3180     format('|',t21,'|',a24,'|',1pe25.15,'|')
  570   continue
c
        uxx = '        '
        do 590 npr = nprmn + 1,nprmx
          if (uprs(npr)(1:24) .ne. uxx(1:24)) then
            write (newin,3190) uprs(npr)(1:24)
 3190       format('|',a24,'|',t46,'|',t72,'|')
            uxx = uprs(npr)(1:24)
          endif
          write (newin,3200) uprs(npr)(25:48),mprs(npr)
 3200     format('|',t21,'|',a24,'|',1pe25.15,'|')
  590   continue
      else
        write (newin,3210) unone
 3210     format('| ',a8,t21,'|',t46,'|',t72,'|')
      endif
      write (newin,3020)
c
c-----------------------------------------------------------------------
c
  999 continue
      end

      subroutine cejust(ustr)
c
c     This subroutine centers the non-blank portion of the string ustr.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ustr   = the input string variable
c
c     Output:
c
c       ustr   = the output string variable
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jj,jbl,jbll,jblr,jshl,jshr,j1,j2,nchars
c
      integer ifnobl,ilnobl
c
c-----------------------------------------------------------------------
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Get the position of the first non-blank character and the number
c     of blanks on the left-hand-side.
c
      j1 = ifnobl(ustr)
      jbll = j1 - 1
c
c     Get the position of the last non-blank character and the number
c     of blanks on the right-hand-side.
c
      j2 = ilnobl(ustr)
      jblr = nchars - j2
c
      jbl = (jbll + jblr)/2
      jshl = jbll - jbl
c
      if (jshl .gt. 0) then
c
c       Shift left.
c
        do jj = j1,nchars
          j = jj - jshl
          ustr(j:j) = ustr(jj:jj)
        enddo
        do j = nchars - jshl,nchars
          ustr(j:j) = ' '
        enddo
      endif
c
      jshr = - jshl
      if (jshr .gt. 1) then
        do jj = j2,1,-1
          j = jj + jshr
          ustr(j:j) = ustr(jj:jj)
        enddo
        do j = 1,jshr
          ustr(j:j) = ' '
        enddo
      endif
c
      end

      subroutine matrix(aamatr,al10,bpx,cdrs,cdrtw,cdrw,cjbasp,
     $ cnufac,conc,csts,dlogxw,eps100,ibpxmx,iebal,iern1,ietmax,
     $ iindx1,ipndx1,irdxc3,ixbasp,ixrn1,jcsort,jern1,jern2,jetmax,
     $ jflag,jjsort,jsitex,kbt,kction,kdim,kelect,khydr,kmax,kmt,
     $ km1,ko2gaq,kwater,kxt,kx1,mosp,narn1,narn2,nbasp,nbt,nbtmax,
     $ nbw,ncosp,ndrs,ndrsmx,ndrsr,nelect,nern1,nern2,netmax,
     $ noutpt,no2gaq,nphasx,nredox,nst,nstmax,nsts,nstsmx,nstsr,
     $ ntfx,ntfxmx,ntfxt,nttyo,nxtmax,omega,qredox,q6mode,tfx,
     $ ugexmo,uspec,weight,xbar,xbarw,xbarwc,zchar)
c
c     This subroutine computes the Jacobian matrix J[z] (aamatr).
c     This matrix is used by the algebraic equation solver.
c
c     This subroutine is called by:
c
c       EQLIB/nrstep.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ibpxmx,ietmax,jetmax,kmax,nbtmax,ndrsmx,netmax,nstmax,
     $ nstsmx,ntfxmx,nxtmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),ipndx1(kmax),ixbasp(nbtmax),jcsort(nstmax),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jjsort(nstmax),jsitex(nstmax),kction(nbtmax),nbasp(nbtmax),
     $ ncosp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),nphasx(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax),ntfx(ntfxmx)
c
      integer iebal,iern1,irdxc3,ixrn1,kbt,kdim,kelect,khydr,kmt,km1,
     $ ko2gaq,kwater,kxt,kx1,narn1,narn2,nbt,nbw,nelect,nern1,nern2,
     $ no2gaq,nredox,nst,ntfxt
c
      logical qredox,qvansc,q6mode
c
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax)
c
      real*8 aamatr(kmax,kmax),bpx(ibpxmx,nxtmax),cdrs(ndrsmx),
     $ cdrtw(nstmax),cdrw(nstmax),cjbasp(nbtmax),cnufac(nstmax),
     $ conc(nstmax),csts(nstsmx),dlogxw(nbtmax),mosp(nstmax),
     $ tfx(ntfxmx),weight(nstmax),xbar(nstmax),zchar(nstmax)
c
      real*8 al10,eps100,omega,xbarw,xbarwc
c
c-----------------------------------------------------------------------
c
c     Local pseudo-module.
c
c     This group contains scratch arrays for computing data (the
c     quantities 1/2.3026 d m(A)/d m(B), where A is a non-basis
c     generic ion exchanger species and B is a basis species. Here
c     x(B) replaces m(B) if B represents solvent water. These
c     quantities are required to compute the Jacobian matrix. The
c     quantities for all A sharing the same site of an exchanger
c     must be determined simultaneously. To do this, it is necessary
c     to solve a (usually small) matrix equation for each site.
c     If there are n non-basis exchanger species for a given site,
c     the matrix is n x n.
c
      integer isv_ietmax
c
      SAVE isv_ietmax
c
      integer, dimension(:), allocatable :: iimgex,ipvgex
c
      SAVE iimgex,ipvgex
c
      real(8), dimension(:), allocatable :: dmlge,rhsgex
c
      SAVE dmlge,rhsgex
c
      real(8), dimension(:,:), allocatable :: aamgex,ggmgex
c
      SAVE aamgex,ggmgex
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ix,iy,j,jlen,jfl,j2,kcol,krow,n,nb,nbb,nb2,ne,nmax,np,
     $ np1,nr1,ns,nsc,nsi,nsj,nss,ns1,ns2,nx
c
      integer ilnobl
c
      character*56 uspn56
c
      real*8 aax,aznsi,azns1,cvansf,cxcc,cxf,cxi1,cxjc,cxji,cxor,
     $ cx2r,cx21,stx,sumx,xx,zp
c
      real*8 coefdr,coefst
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that kelect is not used.
c
      ix = kelect
      iy = ix
      kelect = iy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (netmax .gt. 0) then
c
c       Have one or more generic ion exchange phases in the current
c       model. Allocate or reallocate scratch arrays as needed.
c
        if (.not.ALLOCATED(dmlge)) then
c
c         The arrays are not allocated. Zero the saved array size
c         variable. Note that only one array is tested to see if it
c         is allocated. It is assumed that all arrays in the set are
c         either allocated or not.
c
          isv_ietmax = 0
        else
c
c         The arrays are allocated. Check to see if the array size
c         variable hs changed. If so, deallocate the corresponding
c         arrays and zero the corresponding saved size variable.
c
          if (ietmax .ne. isv_ietmax) then
            DEALLOCATE (dmlge)
            DEALLOCATE (rhsgex)
            DEALLOCATE (aamgex,ggmgex)
            DEALLOCATE (iimgex,ipvgex)
            isv_ietmax = 0
          endif
        endif
c
c       At this point, the saved array size value is zero if the
c       corresponding arrays need to be allocated.
c
        if (isv_ietmax .eq. 0) then
          ALLOCATE (dmlge(ietmax))
          ALLOCATE (rhsgex(ietmax))
          ALLOCATE (aamgex(ietmax,ietmax),ggmgex(ietmax,ietmax))
          ALLOCATE (iimgex(ietmax),ipvgex(ietmax))
          isv_ietmax = ietmax
        endif
c
c       Zero these arrays.
c
        call initaz(dmlge,ietmax)
        call initaz(rhsgex,ietmax)
        nmax = ietmax*ietmax
        call initaz(aamgex,nmax)
        call initaz(ggmgex,nmax)
        call initiz(iimgex,ietmax)
        call initiz(ipvgex,ietmax)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the matrix aamatr.
c
      do i = 1,kdim
        do j = 1,kdim
          aamatr(i,j) = 0.
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the cnufac array.
c
      do ns = 1,nst
        cnufac(ns) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the cnufac array.
c
      do ns = narn1,narn2
        nr1 = ndrsr(1,ns)
        if (jflag(ns) .eq. 30) cnufac(ns) = -conc(ns)/cdrs(nr1)
      enddo
c
      do ns = nern1,nern2
        nr1 = ndrsr(1,ns)
        if (jflag(ns) .eq. 30) cnufac(ns) = -conc(ns)/cdrs(nr1)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (q6mode) go to 210
c
c     Write the matrix for EQ3NR.
c
c     Write rows 1 through kbt.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        nsi = nbasp(nb)
        jfl = jflag(nsi)
        if (nsi.ge.narn1 .and. nsi.le.narn2) then
c
          if (krow.eq.kwater .and. jfl.eq.0) then
c
c           Water, mole fraction equation. Note that if this
c           block is executed, solvent water is a basis species,
c           log x(w) is a primary iteration variable, and that
c           cnufac(narn1) = 0.
c
            xx = xbarwc/omega
            do kcol = 1,kbt
              if (kcol .eq. kwater) then
c
c               Have the column for water itself.
c
                sumx = 0.
                do nss = narn1,narn2
                  nsc = jcsort(nss)
                  sumx = sumx + cdrw(nsc)*cnufac(nsc)
                enddo
                aamatr(krow,kcol) = -xx*sumx - 1.0
              else
                nbb = iindx1(kcol)
                nsj = nbasp(nbb)
                if (nsj.gt.narn1 .and. nsj.le.narn2) then
c
c                 Have a column for an aqueous solute basis species.
c
                  sumx = 0.
                  do nss = narn1,narn2
                    nsc = jcsort(nss)
c
c                   Calling sequence substitutions:
c                     nsc for ns
c                     nsj for nse
c
                    cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,
     $              nstmax)
                    sumx = sumx + cxjc*cnufac(nsc)
                  enddo
                  aamatr(krow,kcol) = -xx*(conc(nsj) + sumx)
                endif
              endif
            enddo
c
          elseif (nb .eq. iebal) then
c
c           Charge balance (charge adjustment).
c
            do ns = narn1,narn2
              weight(ns) = zchar(ns)
            enddo
c
            do ns = nern1,nern2
              weight(ns) = zchar(ns)
            enddo
c
            call balcon(aamatr,aamgex,al10,cdrs,cjbasp,cnufac,
     $      conc,dmlge,eps100,ggmgex,iern1,ietmax,iimgex,iindx1,
     $      ixbasp,jcsort,jern1,jern2,jetmax,jjsort,jsitex,kbt,kmax,
     $      krow,narn1,narn2,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $      nern2,netmax,noutpt,nphasx,nstmax,nttyo,rhsgex,uspec,
     $      weight,xbar)
c
          elseif (jfl .eq. 17) then
c
c           Log activity combination.
c
            ns1 = ncosp(nb)
            kcol = kction(nb)
            aamatr(krow,krow) = -1.
            aznsi = abs(zchar(nsi))
            azns1 = abs(zchar(ns1))
            zp = zchar(nsi)*zchar(ns1)
            if (zp .lt. 0.) then
              aamatr(krow,kcol) = -aznsi/azns1
            else
              aamatr(krow,kcol) = aznsi/azns1
            endif
c
          elseif (jfl .eq. 18) then
c
c           Log mean activity.
c
            ns1 = ncosp(nb)
            kcol = kction(nb)
            aamatr(krow,krow) = -1.
            aznsi = abs(zchar(nsi))
            azns1 = abs(zchar(ns1))
            aamatr(krow,kcol) = -aznsi/azns1
c
          elseif (jfl .eq. 21) then
c
c           pHCl.
c
            ns1 = ncosp(nb)
            kcol = kction(nb)
            aamatr(krow,krow) = -1.
            aznsi = abs(zchar(nsi))
            azns1 = abs(zchar(ns1))
            zp = zchar(nsi)*zchar(ns1)
            if (zp .lt. 0.) then
              aamatr(krow,kcol) = -aznsi/azns1
            else
              aamatr(krow,kcol) = aznsi/azns1
            endif
c
          elseif (jfl .eq. 25) then
c
c           Heterogeneous equilibrium.
c
            ns1 = ncosp(nb)
c
c           Calling sequence substitutions:
c             nsi for nse
c             ns1 for ns
c
            cxi1 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsi,ns1,nstmax)
c
            do kcol = 1,kbt
              if (kcol.ne.krow .and. kcol.ne.kwater) then
                nb2 = iindx1(kcol)
                ns2 = nbasp(nb2)
c
c               Calling sequence substitutions:
c                 ns2 for nse
c
                cx21 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns2,ns1,nstmax)
                aamatr(krow,kcol) = -cx21/cxi1
              endif
            enddo
            aamatr(krow,krow) = -1.0
c
          elseif (nsi .eq. no2gaq) then
c
c           Log fO2.
c
            if (irdxc3 .eq. 0) then
c
c             Identity.
c
              aamatr(krow,ko2gaq) = 1.
c
            elseif (irdxc3  .eq. -1) then
c
c             Eh residual (Note- if a pe- value was input, it has been
c             converted to an Eh value by EQ3NR/setup.f).
c
              aamatr(krow,kwater) = 2.0
              aamatr(krow,khydr) = aamatr(krow,khydr) - 4.0
              aamatr(krow,krow) = aamatr(krow,krow) - 1.0
c
            elseif (irdxc3  .eq. 1) then
c
c             Cross-linking (homogeneous aqueous redox) equilibrium.
c
              aamatr(krow,ko2gaq) = -1.
c
c             Calling sequence substitutions:
c               no2gaq for nse
c               nredox for ns
c
              cxor = coefdr(cdrs,ndrs,ndrsmx,ndrsr,no2gaq,nredox,nstmax)
              do kcol = 1,kbt
                if (kcol.ne.ko2gaq .and. kcol.ne.kwater) then
                  nb2 = iindx1(kcol)
                  ns2 = nbasp(nb2)
c
c                 Calling sequence substitutions:
c                   ns2 for nse
c                   nredox for ns
c
                  cx2r = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns2,nredox,
     $            nstmax)
                  aamatr(krow,kcol) = -cx2r/cxor
                endif
              enddo
            else
c
c             Error.
c
              write (noutpt,1000) irdxc3
              write (nttyo,1000) irdxc3
 1000         format(/' * Error - (EQLIB/matrix) Programming error',
     $        ' trap:',/7x,'Have encountered illegal irdxc3 value = ',
     $        i5,'.')
              stop
            endif
c
          elseif (jfl.ge.0 .and. jfl.le.3) then
c
c           Mass balance.
c
            do ns = narn1,narn2
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            enddo
c
            do ns = nern1,nern2
              weight(ns) = 0.
            enddo
c
            call balcon(aamatr,aamgex,al10,cdrs,cjbasp,cnufac,
     $      conc,dmlge,eps100,ggmgex,iern1,ietmax,iimgex,iindx1,
     $      ixbasp,jcsort,jern1,jern2,jetmax,jjsort,jsitex,kbt,kmax,
     $      krow,narn1,narn2,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $      nern2,netmax,noutpt,nphasx,nstmax,nttyo,rhsgex,uspec,
     $      weight,xbar)
c
          elseif (jfl.ge.7 .and. jfl.le.11) then
c
c           Alkalinity balance.
c
c           Calling sequence substitutions.
c             weight for array
c             nstmax for nmax
c
            do ns = 1,nst
              weight(ns) = 0.
            enddo
c
            do n = 1,ntfxt
              ns = ntfx(n)
              weight(ns) = tfx(n)
            enddo
c
            call balcon(aamatr,aamgex,al10,cdrs,cjbasp,cnufac,
     $      conc,dmlge,eps100,ggmgex,iern1,ietmax,iimgex,iindx1,
     $      ixbasp,jcsort,jern1,jern2,jetmax,jjsort,jsitex,kbt,kmax,
     $      krow,narn1,narn2,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $      nern2,netmax,noutpt,nphasx,nstmax,nttyo,rhsgex,uspec,
     $      weight,xbar)
c
          elseif (jfl .eq. 16) then
c
c           Log activity.
c
            aamatr(krow,krow) = 1.0
c
          elseif (jfl.eq.19 .or. jfl.eq.20) then
c
c           pX (including pH).
c
            aamatr(krow,krow) = 1.0
c
          elseif (jfl.eq.22 .or. jfl.eq.23) then
c
c           pmX (including pmH).
c
            aamatr(krow,krow) = 1.0
c
          elseif (jfl .eq. 27) then
c
c           Aqueous homogeneous equilibrium.
c
            ns1 = nsi
c
c           Calling sequence substitutions:
c             nsi for nse
c             ns1 for ns
c
            cxi1 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsi,ns1,nstmax)
            do kcol = 1,kbt
              if (kcol.ne.krow .and. kcol.ne.kwater) then
                nb2 = iindx1(kcol)
                ns2 = nbasp(nb2)
c
c               Calling sequence substitutions:
c                 ns2 for nse
c                 ns1 for ns
c
                cx21 = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns2,ns1,nstmax)
                aamatr(krow,kcol) = -cx21/cxi1
              endif
            enddo
            aamatr(krow,krow) = -1.0
c
          else
c
c           Have found a bad jflag value.
c
c           Calling sequence substitutions:
c             uspec(nsi) for unam48
c
            call fmspnx(jlen,uspec(nsi),uspn56)
            write (noutpt,1010) jfl,uspn56(1:jlen)
            write (nttyo,1010) jfl,uspn56(1:jlen)
 1010       format(/' * Error - (EQLIB/matrix) Programming error trap:',
     $      /7x,'Have encountered a bad jflag value of ',i4,' for',
     $      /7x,a,'.')
            stop
          endif
c
        elseif (nsi.ge.nern1 .and. nsi.le.nern2) then
c
c         Generic ion exchange species.
c
          if (jfl .eq. 0) then
c
c           Mass balance.
c
            do ns = narn1,narn2
              weight(ns) = 0.
            enddo
c
            do ns = nern1,nern2
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            enddo
c
            call balcon(aamatr,aamgex,al10,cdrs,cjbasp,cnufac,
     $      conc,dmlge,eps100,ggmgex,iern1,ietmax,iimgex,iindx1,
     $      ixbasp,jcsort,jern1,jern2,jetmax,jjsort,jsitex,kbt,kmax,
     $      krow,narn1,narn2,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $      nern2,netmax,noutpt,nphasx,nstmax,nttyo,rhsgex,uspec,
     $      weight,xbar)
c
          else
c
c           Have found a bad jflag value.
c
c           Calling sequence substitutions:
c             uspec(nsi) for unam48
c
            call fmspnx(jlen,uspec(nsi),uspn56)
            write (noutpt,1010) jfl,uspn56(1:jlen)
            write (nttyo,1010) jfl,uspn56(1:jlen)
          endif
        endif
      enddo
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  210 continue
c
c     Write the matrix for EQ6.
c
c     Compute the dlogxw array (d log x(w)/d log m(s')).
c
      call gdlgxw(cdrs,cjbasp,cnufac,conc,dlogxw,eps100,
     $ ixbasp,jcsort,jflag,narn1,narn2,nbasp,nbt,nbtmax,nbw,
     $ ndrs,ndrsmx,ndrsr,nern1,nern2,noutpt,nstmax,nttyo,omega,
     $ xbar,xbarw)
c
c     Change the dlogxw array from derivatives with respect to
c     molalities to ones with respect to numbers of moles.
c     Currently, the definition is:
c
c       dlogxw = d log x(w)/d log m(s'), s' != w
c
c     The new definition will be:
c
c       dlogxw = d log x(w)/d log n(s'), s' includes w
c
c     There is now a derivative with respect to n(w). There was
c     none with respect to m(w).
c
c     Compute dlogxw(w) (d log x(w)/d log n(w)). For basis species
c     which are aqueous solute species, it happens that:
c
c       d log x(w)/d log n(s') = d log x(w)/d log m(s')
c
      sumx = 0.
      do nb = 1,nbt
        if (nb .ne. nbw) then
          ns = nbasp(nb)
          sumx = sumx + dlogxw(nb)
        endif
      enddo
      dlogxw(nbw) = -sumx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Redefine the cnufac array in terms of numbers of moles in place of
c     concentrations.
c
      do ns = narn1,narn2
        nr1 = ndrsr(1,ns)
        if (jflag(ns) .eq. 30) cnufac(ns) = -mosp(ns)/cdrs(nr1)
      enddo
c
      do ns = nern1,narn2
        nr1 = ndrsr(1,ns)
        if (jflag(ns) .eq. 30) cnufac(ns) = -mosp(ns)/cdrs(nr1)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build the rows corresponding to mass balance expressions for
c     the active basis species in the 'd' set.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        nsi = nbasp(nb)
c
        if (nsi.eq.no2gaq .or. nsi.eq.nelect) then
          if (.not.qredox) then
            aamatr(krow,krow) = 1.0
            go to 250
          endif
        endif
c
        do ns = 1,nst
          weight(ns) = 0.
        enddo
c
c       Mass balance.
c
        do ns = narn1,narn2
          weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
        enddo
c
        do ns = nern1,nern2
          weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
        enddo
c
        do kcol = km1,kxt
          ns = iindx1(kcol)
          weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
        enddo
c
c       Build column kwater.
c
        aax = 0.
c
        do nss = narn1,narn2
          nsc = jcsort(nss)
          aax = aax - weight(nsc)*cnufac(nsc)
     $    *(cdrtw(nsc) + cdrw(nsc)*dlogxw(nbw))
        enddo
c
        aax = aax + weight(narn1)*mosp(narn1)
        aamatr(krow,kwater) = al10*aax
c
c       Build columns 1 to kbt, except kwater.
c
        do kcol = 1,kbt
          if (kcol .ne. kwater) then
            nbb = iindx1(kcol)
            nsj = nbasp(nbb)
c
c           Does the operational basis species associated with the
c           current column belong to a Vanselow ion exchange phase?
c
            qvansc = .false.
            if (nsj.ge.nern1 .and. nsj.le.nern2) then
              np = nphasx(nsj)
              ne = np - iern1 + 1
              j2 = ilnobl(ugexmo(ne))
              qvansc = ugexmo(ne)(1:j2).eq.'Vanselow' .or.
     $        ugexmo(ne)(1:9).eq.'Vanselow-'
            endif
c
            aax = 0.
c
            do nss = narn1,narn2
              nsc = jcsort(nss)
c
c             Calling sequence substitutions:
c               nsc for ns
c               nsj for nse
c
              cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,nstmax)
              aax = aax + weight(nsc)*cnufac(nsc)
     $        *(cxjc + cdrw(nsc)*dlogxw(nbb))
            enddo
c
cKK
            do nss = nern1,nern2
              nsc = jcsort(nss)
c
c             Calling sequence substitutions:
c               nsc for ns
c               nsj for nse
c
              cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,nstmax)
cKKKKKKKKK
c
              cxf = cxjc
              if (qvansc) then
c
c               The "Vanselow factor" cvansf calculated below is
c               a measure of the extent to which the mole fractions
c               of two exchanger species (the one, non-basis, the
c               other, basis) in a mass action equation for the
c               Vanselow ion exchange model can not be simply
c               replaced by corresponding molalities. This factor
c               is non-zero if the two exchanging ions have different
c               charges.
c
                nr1 = ndrsr(1,nsc)
                cxcc = cdrs(nr1)
                cvansf = -cxcc + (cxjc + cxcc)*xbar(nsj)
                cxf = cvansf
              endif
cKKKKKKKKK
              aax = aax + weight(nsc)*cnufac(nsc)
     $        *(cxf + cdrw(nsc)*dlogxw(nbb))
cOld          aax = aax + weight(nsc)*cnufac(nsc)
cOld $        *(cxjc + cdrw(nsc)*dlogxw(nbb))
            enddo
c
            aax = aax + weight(nsj)*mosp(nsj)
            aamatr(krow,kcol) = al10*aax
          endif
        enddo
c
c       Build the mineral columns, including those for solid solution
c       species.
c
        do kcol = km1,kxt
          nsj = iindx1(kcol)
          aamatr(krow,kcol) = al10*weight(nsj)*mosp(nsj)
        enddo
c
  250   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build the rows corresponding to mass action expressions
c     for pure minerals.
c
      do krow = km1,kmt
        nsi = iindx1(krow)
        do kcol = 1,kbt
          nbb = iindx1(kcol)
          nsj = nbasp(nbb)
          if (nsj .eq. narn1) then
            aamatr(krow,kcol) = -cdrtw(nsi) + cdrw(nsi)*dlogxw(nbb)
          else
c
c           Calling sequence substitutions:
c             nsi for ns
c             nsj for nse
c
            cxji = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsi,nstmax)
            aamatr(krow,kcol) = cxji + cdrw(nsi)*dlogxw(nbb)
          endif
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build the rows corresponding to mass action expressions
c     for species belonging to solid solutions.
c
      if (kxt. ge. kx1) then
        do krow = kx1,kxt
          nsi = iindx1(krow)
          np = ipndx1(krow)
          nx = np - ixrn1 + 1
          stx = bpx(1,nx)
c
c         Build columns 1 through kbt.
c
          do kcol = 1,kbt
            nbb = iindx1(kcol)
            nsj = nbasp(nbb)
            if (nsj .eq. narn1) then
              aamatr(krow,kcol) = -cdrtw(nsi) + cdrw(nsi)*dlogxw(nbb)
            else
c
c           Calling sequence substitutions:
c             nsi for ns
c             nsj for nse
c
              cxji = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsi,nstmax)
              aamatr(krow,kcol) = cxji + cdrw(nsi)*dlogxw(nbb)
            endif
          enddo
c
c         Build columns kx1 through kxt.
c
          nr1 = ndrsr(1,nsi)
          cxcc = cdrs(nr1)
          do kcol = kx1,kxt
            ns1 = iindx1(kcol)
            np1 = ipndx1(kcol)
            if (np1 .eq. np) then
              if (ns1 .eq. nsi) then
                aamatr(krow,kcol) = cxcc*stx*( 1. - xbar(nsi) )
              else
                aamatr(krow,kcol) = - cxcc*stx*xbar(ns1)
              endif
            endif
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      program eq3nr
c
c     This is the main program of the EQ3NR code. Configuration
c     identification, the copyright statement, legal disclaimers, and
c     similar statements are contained in EQ3NR/aaaeq3.f, the lead-off
c     subroutine in the EQ3NR source code. A short description of this
c     program is also contained in that subroutine.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqldef.h'
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
      include 'eqlib/eql1s.h'
      include 'eqlib/eqlwd.h'
c
      include 'eqlib/eqlj8.h'
      include 'eqlib/eqlk8.h'
      include 'eqlib/eqlo8.h'

c-----------------------------------------------------------------------
c     File path parameters
c-----------------------------------------------------------------------
      integer :: numargs
      character(1024) :: temppath
      character(:), allocatable :: data1path
      character(:), allocatable :: threeipath
      integer :: pathindices(2)
      character(:), allocatable :: basename
      character(:), allocatable :: ofile
      character(:), allocatable :: ifile
      character(:), allocatable :: pfile
c
c-----------------------------------------------------------------
c
c
c     Array allocation size variables used in EQ3NR.
c
c       General size variables:
c
c         ntid_asv  = the number of lines in the data file title
c         ntit_asv  = the number of lines in any title appearing
c                       on an input or pickup file
c
c
c       Size variables associated with the description of thermodynamic
c       data:
c
c         ipch_asv  = the order for pressure corrections to enthalpy
c                       functions
c         ipcv_asv  = the order for pressure corrections to volume
c                       functions; the maximum order for pressure
c                       corrections to log K and other Gibbs-energy-
c                       based functions is one greater than this
c         ipbt_asv  = the maximum number of Pitzer alpha parameters
c                       for any species pair
c         jpfc_asv  = the number of coefficients in the Pitzer parameter
c                       temperature function
c         narx_asv  = maximum number of coefficients per temperature
c                       range
c         ntpr_asv  = number of temperature ranges
c
c
c       Size variables required to read other data from the
c       supporting data file:
c
c         ikta_asv  = the maximum number of end-member components
c                       of any solid solution on the data file
c         nata_asv  = the number of aqueous species on the data file
c         nbta_asv  = the number of basis species on the data file
c         ncta_asv  = the number of chemical elements on the data file
c         ngta_asv  = the number of gas species on the data file
c         nlta_asv  = the number of pure liquids on the data file
c         nmta_asv  = the number of pure minerals on the data file
c
c         napa_asv  = number of distinct sets of Pitzer alpha
c                       parameters on the data file
c         nmuta_asv = the number of triplets of ions on the data file
c                       for which distinct Pitzer mu coefficients
c                       are defined
c         nslta_asv = the number of pairs of ions on the data file
c                       for which distinct Pitzer lambda coefficients
c                       are defined
c
c
c       Size variables required to hold the compressed set of such
c       data:
c
c         ikt_asv   = the maximum number of end-member components
c                       of any solid solution in the compressed set
c         nat_asv   = the number of aqueous species in the compressed
c                       set
c         nbt_asv   = the number of basis species in the compressed set
c         nct_asv   = the number of chemical elements in the compressed
c                       set
c         ngt_asv   = the number of gas species in the compressed set
c         nlt_asv   = the number of pure liquids in the compressed set
c         nmt_asv   = the number of pure minerals in the compressed set
c
c         nap_asv   = the number of distinct sets of Pitzer alpha
c                       parameters in the compressed set
c         nmut_asv  = the number of triplets of ions in the compressed
c                       set for which distinct Pitzer mu coefficients
c                       are defined
c         nslt_asv  = the number of pairs of ions in the compressed set
c                       for which distinct Pitzer lambda coefficients
c                       are defined
c
c
      integer ntid_asv
c
      integer ipch_asv,ipcv_asv,ipbt_asv,jpfc_asv,narx_asv,ntpr_asv
c
      integer nazm_asv,nazp_asv
c
      integer ikta_asv,napa_asv,nata_asv,nbta_asv,ncta_asv,ndrsa_asv,
     $ nessa_asv,ngta_asv,nlta_asv,nmta_asv,nmuta_asv,nslta_asv,
     $ npta_asv,nsta_asv,nxta_asv
c
      integer iapxa_asv,ibpxa_asv
c
      integer nbta1_asv
c
      integer ntf1a_asv,ntf2a_asv
c
      integer ikt_asv,nap_asv,nat_asv,nbt_asv,nct_asv,ndrs_asv,
     $ ness_asv,ngt_asv,nlt_asv,nmt_asv,nmut_asv,nslt_asv,npt_asv,
     $ nst_asv,nxt_asv
c
      integer iapx_asv,ibpx_asv
c
      integer ntit_asv,nxmd_asv
c
      integer nbt1_asv,nmx_asv,nsts_asv,nsx_asv,nxic_asv
c
      integer ntf1_asv,ntf2_asv,ntfx_asv
c
      integer k_asv
c
      integer nxti_asv
c
      integer imch_asv,ndct_asv,nert_asv,nffg_asv,nprp_asv,nprs_asv,
     $ nptk_asv,nrct_asv,nsrt_asv,nttk_asv,nxop_asv,nxpe_asv,nxrt_asv
c
c-----------------------------------------------------------------------
c
      integer newin,ninpt,ninpts,noutpt,nttyo
c
      integer iodb(nodb_par),iopg(nopg_par),iopr(nopr_par),
     $ iopt(nopt_par)
c
      integer jgexti(net_par),ngexpi(net_par),ngexti(jet_par,net_par)
c
      integer, dimension(:), allocatable :: iapxt,ibpxt,ibswx,iction,
     $ igstak,iindx1,insgf,ipivot,ipndx1,istack,ixbasp,jcsort,jflag,
     $ jflagd,jgsort,jgstak,jjndex,jjsort,jpflag,jsflag,jsitex,jsol,
     $ jssort,jstack,kction,kkndex,kxmod
c
      integer, dimension(:), allocatable :: jflgi
c
      integer, dimension(:), allocatable :: narxt,nbasp,nbaspd,nbaspx,
     $ nbmap,ncmap,ncosp,ndecsp,ndrs,ndrsd,ndrsx,ness,nfac,nphasx,
     $ npnxp,nsmap,nsts,ntfx,ntf1,ntf2
c
      integer, dimension(:), allocatable :: nbaspi
c
      integer, dimension(:,:), allocatable :: ncmpr,ndrsr,ndrsrd,
     $ ndrsrx,nessr,nstsr
c
      integer, dimension(:,:), allocatable :: ncmpri
c
      integer, dimension(:), allocatable :: nalpha
c
      integer, dimension(:,:), allocatable :: nmux,nmxi,nmxx,nslx,
     $ nsxi,nsxx
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer i,iaqsla,iaqsln,ibetmx,icarb,idelmx,ie,iebal,iebal3,ielam,
     $ ier,iern1,iern2,iexec0,ifrn1,ifrn2,igas,ilevel,ilrn1,ilrn2,imrn1,
     $ imrn2,io2gaq,ipch,ipcv,irang,irdxc3,itdsf3,iter,itermx,itmxsv,
     $ ixrn1,ixrn2,ixrn1a,ixrn2a,izmax,j,je,jexec0,jfl,jfleba,jlen,
     $ jpdblo,jpres3,jptffl,j1,j2,j3,j4,k,ka1,kat,kbt,kcarb,kcol,kct,
     $ kdim,kebal,kelect,ker,ke1,ket,khydr,km1,kmt,kobswt,ko2gaq,kprs,
     $ kwater,kx1,kxt
c
      integer n,nad1,napt,napta,narn1,narn2,narn1a,narn2a,nat,nata,
     $ nb,nbi,nbt,nbta,nbtafd,nbtd,nbti,nbw,nbwa,nb1,nb2,nc,ncarb,
     $ nchloa,nchlor,nct,ncta,ne,neleca,nelect,nern1,nern2,nerr,net,
     $ neti,ngrn1,ngrn1a,ngrn2a,ngrn2,ngt,ngta,nhydr,nhydra,nhydx,
     $ nhydxa,nlrn1,nlrn2,nlrn1a,nlrn2a,nlt,nlta,nmax,nmrn1,nmrn2,
     $ nmrn1a,nmrn2a,nmt,nmta,nmut,nmuta,nobswt,no2gaa,no2gai,no2gaq,
     $ np,npt,npta,nprob,nrecl,nrdxsa,nrdxsp,nredox,nrr1,nrr2,nr1,nr2,
     $ ns,nsbsw,nsbswt,nse,nslt,nslta,nss,nst,nsta,ns1,ns2,nt,ntfxt,
     $ ntf1t,ntf1ta,ntf2t,ntf2ta,ntitl,ntitl2,ntitld,ntpr,ntprt,nxi,
     $ nxic,nxmod,nxrn1,nxrn2,nxrn1a,nxrn2a,nxt,nxta,nxti
c
      integer ilnobl,nbasis
c
      logical, dimension(:), allocatable :: qxknph
c
      logical qbassw,qchlor,qbswok,qcwrpj,qdwipp,qelim,qend,qhawep,qop,
     $ qpit75,qredox,qrderr,qrho,q6mode
c
      character(len=80), dimension(:), allocatable :: utitl,utitl2
      character(len=48), dimension(:), allocatable :: ubasp,ubmtbi,
     $ ucospi,uspec,uspeci,uxmod,uzveci,uzvec1
      character(len=48), dimension(:,:), allocatable :: uobsw,usbsw
      character(len=24), dimension(:), allocatable :: umemi,usoli
      character(len=24), dimension(:), allocatable :: uphase,uptype
      character(len=8), dimension(:), allocatable :: uelem,uldel,ulbeta
c
      character(len=32) ujflls(0:njf_par),uxtype(jso_par)
      character(len=24) ugexpi(net_par),ugexsi(iet_par,jet_par,net_par)
      character(len=8) ugexji(jet_par,net_par)
c
      character(len=56) uspn56
      character(len=48) ubacmx,ubbig,ubetmx,ubgamx,ubneg
      character(len=32) uactop
      character(len=24) uaqsln,ublk24,uebal,uredox,ux24
      character(len=16) ux16a,ux16b
      character(len=11) utime0,utime1
      character(len=9) udate0,udate1
      character(len=8) udatfi,udakey,uinfor,upkfor,uplatc,uplatm,ustelg,
     $ ustelu,usteql,usteq3,uveelg,uveelu,uveeql,uveeq3
c
      character(len=8) uv,ux8,ux8a,ux8b
      character(len=80) ux80
c
      real(8), dimension(:), allocatable :: covali
c
      real(8), dimension(:), allocatable :: acflg,acflgo,act,actlg,
     $ affpd,affsd,ahrc,alpha,amtb,atwt,azero,a3bars,beta,betao,bfac,
     $ cdrs,cdrsd,cdrsx,cdrtw,cdrw,cess,cjbasp,cnufac,conc,conclg,coval,
     $ csts,ctb,cteaq,delvco,delvec,dlogxw,efac,ehrc,fo2lrc,fsort,fugac,
     $ fugalg,loph,losp,lsort,moph,mosp,mtb,mtbaq,mtbaqi,mtbi,mte,
     $ mteaq,mwtsp,perc,ppmwe,rhsvec,sidrph,sidrsp,tempcu,tfx,tf1,tf2,
     $ vosp0,weight,xbar,xbari,xbarlg,xlkmod,zchar,zchcu6,zchsq2,
     $ zvclgi,zvclg1,zvec1
c
      real(8), dimension(:,:), allocatable :: amu
      real(8), dimension(:,:,:), allocatable :: aslm
c
      real(8), dimension(:), allocatable :: pmu,pslm
      real(8), dimension(:,:), allocatable :: dpslm,gpit,palpha,pslamn
      real(8), dimension(:,:,:), allocatable :: dgpit
c
      real(8), dimension(:,:), allocatable :: elam,pelm
      real(8), dimension(:,:,:), allocatable :: delam,dpelm
c
      real(8), dimension(:), allocatable :: selm
      real(8), dimension(:,:), allocatable :: dselm
c
      real(8), dimension(:,:), allocatable :: aprehw,apresg
c
      real(8), dimension(:), allocatable :: dadhh,dadhv,dbdhh,dbdhv,
     $ dbdth,dbdtv
c
      real(8), dimension(:), allocatable :: xhfs,xhfsd,xlks,xlksd,
     $ xvfs,xvfsd
      real(8), dimension(:), allocatable :: dhfe,dvfe
      real(8), dimension(:,:), allocatable :: axhfe,axlke,axvfe
      real(8), dimension(:,:,:), allocatable :: adhfe,advfe
c
      real(8), dimension(:,:), allocatable :: dhfs,dhfsd,dvfs,dvfsd
      real(8), dimension(:,:,:), allocatable :: axhfs,axhfsd,axhfsx,
     $ axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx
      real(8), dimension(:,:,:,:), allocatable :: adhfs,adhfsd,adhfsx,
     $ advfs,advfsd,advfsx
c
      real(8), dimension(:,:), allocatable :: apx,bpx,wfac
      real(8), dimension(:,:), allocatable :: aamatr,gmmatr
c
      real(8), dimension(:,:), allocatable :: aadh,aadhh,aadhv,aaphi,
     $ abdh,abdhh,abdhv,abdot,abdoth,abdotv
c
      real(8), dimension(:,:,:), allocatable :: adadhh,adadhv,adbdhh,
     $ adbdhv,adbdth,adbdtv
c
      real(8) cco2(5)
      real(8) cegexs(iet_par,jet_par,net_par),cgexpi(net_par),
     $ cgexp(net_par),cpgexs(iet_par,jet_par,net_par),
     $ egexjc(jet_par,net_par),egexjf(jet_par,net_par),
     $ egexpa(net_par),egexpc(net_par),egexs(iet_par,jet_par,net_par),
     $ egexsi(iet_par,jet_par,net_par),egexw(ket_par,net_par),
     $ mrgexs(iet_par,jet_par,net_par),
     $ xgexsi(iet_par,jet_par,net_par),xgexw(ket_par,net_par)
c
      real(8) adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real(8) prehw,presg,xhfe,xlke,xvfe
c
      real(8) abar,actwlc,afcnst,alki,al10,avcnst,a3bar,azch,azchmx,
     $ bacfmx,bbig,betamx,bfje,bgamx,bneg,bsigmm,bfxi,delmax,eh,
     $ ehfac,ehi,electr,eps100,farad,fje,fjeo,fo2,fo2lg,fo2lgi,fxi,
     $ fxio,omega,omeglg,pe,pei,presmx,press,pressi,rconst,rcnstv,
     $ rho,rtcnst,scamas,screwd,screwn,sigmam,sigmmo,sigzi,smp100,
     $ tcpu,tdamax,tdamin,tdspkg,tdspl,tempc,tempci,tempk,texec0,
     $ tolbt,toldl,tolspf,trun,tuser,vosol,wfh2o,wftds,wkgwi,woh2o,
     $ wosol,wotds,xbarw,xbarwc,xbrwlc,xbrwlg,x10,zx
cXX   real(8) vpgstp
c
      real(8) mlmrra,mrmlra,rhoc,rhowc,tdsgks,tdsglw,tdspkc,tdsplc
c
      real(8) axx,av,dp,pxl,pxu,xx
c
      real(8) texp,tlg
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Data file original contents. These
c     variables and arrays remain unchanged after being filled by
c     reading the data file. These data comprise the 'a' set.
c
      integer, dimension(:), allocatable :: iapxta,ibpxta,insgfa,jsola,
     $ nbaspa,ndrsa,nessa
c
      integer, dimension(:,:), allocatable :: ncmpra,ndrsra,nessra
c
      real(8), dimension(:,:,:), allocatable :: axhfsa,axlksa,axvfsa
c
      real(8), dimension(:,:,:,:), allocatable :: adhfsa,advfsa
c
      real(8), dimension(:), allocatable :: atwta,azeroa,cdrsa,cessa,
     $ mwtspa,vosp0a,zchara
c
      real(8), dimension(:,:), allocatable :: apxa,bpxa
c
      character(len=80), dimension(:), allocatable :: utitld
      character(len=48), dimension(:), allocatable :: uspeca
      character(len=24), dimension(:), allocatable :: uphasa,uptypa
      character(len=8), dimension(:), allocatable :: uelema
c
c     Pitzer's equations subset.
c
      integer, dimension(:), allocatable :: nalpaa
      integer, dimension(:,:), allocatable :: nmuxa,nslxa
c
      real(8) , dimension(:,:), allocatable :: amua,palpaa
      real(8) , dimension(:,:,:), allocatable :: aslma
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Variables closely associated with the
c     'a' set.
c
      logical, dimension(:), allocatable :: qclnsa
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Pseudo-data file original contents.
c
      integer, dimension(:), allocatable :: ntf1a,ntf2a
c
      real(8), dimension(:), allocatable :: tf1a,tf2a
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Data needed to write a complete EQ6 input
c     file as the EQ3NR pickup file.
c
      integer igerti(jet_par,nert_par),jgerti(nert_par)
c
      integer, dimension(:), allocatable :: ibsrti,iesrti,ixrti,
     $ jcode,jreac,nsk
c
      integer, dimension(:,:), allocatable :: imech,nrk
c
      integer, dimension(:,:,:), allocatable :: iact,ndact
c
      integer jpress,jtemp,ksplmx,ksppmx,kstpmx,nert,nffg,nprpti,nprsti,
     $ nrct,nsrt,ntitl1,ntrymx,nxopex,nxopt,nxrt
c
      logical qgexsh
c
      character(len=24) ugersi(iet_par,jet_par,nert_par),
     $ ugermo(nert_par)
      character(len=8) ugerji(jet_par,nert_par)
c
      character(len=80), dimension(:), allocatable :: utitl1
      character(len=48), dimension(:), allocatable :: uprspi
      character(len=24), dimension(:), allocatable :: uffg,uprphi,ureac,
     $ uxcat,uxopex
      character(len=8), dimension(:), allocatable :: uxopt
c
      character(len=24), dimension(:,:), allocatable :: ubsri,ucxri
      character(len=8), dimension(:,:), allocatable :: uesri
c
      character(len=24), dimension(:,:,:,:), allocatable :: udac
c
      real(8), dimension(:), allocatable ::  fkrc,modr,moffg,morr,
     $ mprphi,mprspi,ptk,sfcar,ssfcar,ttk,vreac,xlkffg
      real(8), dimension(:,:), allocatable :: cbsri,cesri,rxbari
      real(8), dimension(:,:,:), allocatable :: csigma,eact,hact,
     $ rkb,trkb
      real(8), dimension(:,:,:,:), allocatable :: cdac
c
      real(8) egersi(iet_par,jet_par,nert_par),
     $ xgersi(iet_par,jet_par,nert_par)
c
      real(8) awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,o2maxi,o2mini,phmaxi,phmini,
     $ pressb,tempcb,tempc1,timmxi,tistti,tolsat,tolxsf,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Local data needed to assist in writing a
c     complete EQ6 input file as the EQ3NR pickup file. These variables
c     do not appear on that file itself.
c
      integer ibsrt1,iesrt1
c
      character(len=24), dimension(:), allocatable :: ubsr1
      character(len=8), dimension(:), allocatable :: uesr1
c
      character(len=24) ureac1
c
      real(8), dimension(:), allocatable :: cbsr1,cesr1
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       On some systems, a BLOCK DATA subroutine must be declared in an
c       EXTERNAL statement to assure proper loading. On some other
c       systems, this is not necessary, but neither it is not harmful.
c       On yet some other systems, the EXTERNAL statement below may
c       cause a problem. If so, try commenting it out. If you still
c       have trouble, consult your local system documentation or
c       experiment to find out how to correctly handle a BLOCK DATA
c       subroutine on your system. The EXTERNAL statement below should
c       not cause a problem if you are using a compiler which is fully
c       compliant with the Fortran 90 standard. However, there is
c       no guarantee that it will be adequate to assure correct loading
c       of the BLOCK DATA subroutine.
c
        external bkdeq3
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     Special data base of coefficients for the HCO3-CO3-OH total
c     alkalinity.
c
      include 'eqlib/eqltf1.h'
c
c     Special data base of coefficients for the extended total
c     alkalinity.
c
      include 'eqlib/eqltf2.h'
c
c-----------------------------------------------------------------------
c
c     Other data statements.
c
      data uaqsln /'Aqueous solution        '/
      data ublk24 /'                        '/
c
      data ujflls(0)  /'Total molality                  '/
      data ujflls(1)  /'Total molarity                  '/
      data ujflls(2)  /'Total mg/L                      '/
      data ujflls(3)  /'Total mg/kg.sol                 '/
      data ujflls(4)  /'ERROR                           '/
      data ujflls(5)  /'ERROR                           '/
      data ujflls(6)  /'ERROR                           '/
      data ujflls(7)  /'Total alkalinity, eq/kg.H2O     '/
      data ujflls(8)  /'Total alkalinity, eq/L          '/
      data ujflls(9)  /'Total alkalinity, eq/kg.sol     '/
      data ujflls(10) /'Total alkalinity, mg/L CaCO3    '/
      data ujflls(11) /'Total alkalinity, mg/L HCO3-    '/
      data ujflls(12) /'ERROR                           '/
      data ujflls(13) /'ERROR                           '/
      data ujflls(14) /'ERROR                           '/
      data ujflls(15) /'ERROR                           '/
      data ujflls(16) /'Log activity                    '/
      data ujflls(17) /'|zj| log ai +/- |zi| log aj     '/
      data ujflls(18) /'Log a(+/-,ij)                   '/
      data ujflls(19) /'pX                              '/
      data ujflls(20) /'pH                              '/
      data ujflls(21) /'pHCl                            '/
      data ujflls(22) /'pmH                             '/
      data ujflls(23) /'pmX                             '/
      data ujflls(24) /'ERROR                           '/
      data ujflls(25) /'Heterogenous equilibrium        '/
      data ujflls(26) /'ERROR                           '/
      data ujflls(27) /'Homogenous equilibrium          '/
      data ujflls(28) /'ERROR                           '/
      data ujflls(29) /'ERROR                           '/
      data ujflls(30) /'Make non-basis                  '/
c
      data uxtype(1)  /'Ideal solution                  '/
      data uxtype(2)  /'Binary, third-order Maclaurin   '/
      data uxtype(3)  /'Binary, parabolic Maclaurin     '/
      data uxtype(4)  /'Binary, cubic Maclaurin (P,T)   '/
      data uxtype(5)  /'Binary, Guggenheim  (T)         '/
      data uxtype(6)  /'Ternary, regular                '/
c
      data nrecl /0/
c
c     Under-relaxation control parameters:
c
c       screwd = bound on max norm of applied part of the delvec vector
c       screwn = factor bounding the increase in the max norm of the
c                beta vector
c
      data screwd/2.0/,screwn/0.50/
c
c-----------------------------------------------------------------------
c
c     Fixed fugacity phase range delimiters (not currently used
c     by EQ3NR):
c
      data ifrn1,ifrn2 /0,0/
c
c-----------------------------------------------------------------------
c
c     Maximum allowed pressure (bars):
c
      data presmx /90000./
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       Define the console output device number. A value of 6 applies
c       in most cases.
c
        data nttyo  /6/
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     Get time and date at the start of execution. This information
c     will be used for time and date stamping.
c
      call initim(iexec0,jexec0,texec0,noutpt,nttyo,
     $ udate0,utime0)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Disable underflow trapping, if any.
c
       call undflw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set file unit numbers to zero.
c
      noutpt = 0
      nad1 = 0
      ninpt = 0
      ninpts = 0
      newin = 0
c
c     Open all files execpt pickup.
c
      numargs = COMMAND_ARGUMENT_COUNT()
      if (numargs.eq.2) then
          call GET_COMMAND_ARGUMENT(1,temppath)
          data1path = TRIM(temppath)
          temppath(:)='\0'
          call GET_COMMAND_ARGUMENT(2,temppath)
          threeipath = TRIM(temppath)
      else
          write (0, *) 'usage: eq3nr <data1> <3i>'
          stop
      end if

      call getbasename(threeipath, pathindices)
      basename = threeipath(pathindices(1):pathindices(2))

      ofile = basename // '.3o'
      ifile = basename // '.3ib'
      pfile = basename // '.3p'

      call openin(noutpt,nttyo,data1path,'unformatted',nad1)
      call openin(noutpt,nttyo,threeipath,'formatted',ninpt)

      call openou(noutpt,nttyo,ofile,'formatted',nrecl,noutpt)
      call openou(noutpt,nttyo,ifile,'formatted',nrecl,ninpts)
c
c     Make a copy of the input file, stripped of comments.
c
      call stripl(ninpt,ninpts)
      close (ninpt)
      ninpt = 0
      rewind ninpts
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get configuration identification data.
c
      call aaaeq3(usteq3,uveeq3)
      call aaaeql(usteql,uveeql)
      call aaaelg(ustelg,uveelg)
      call aaaelu(ustelu,uveelu)
      call platfd(uplatc,uplatm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write configuration identification data, the copyright statement,
c     and any remaining statements or disclaimers.
c
      i = index(uveeq3,' ') - 1
      j = index(uveeq3,'.') - 1
      k = index(uplatc,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1000) uveeq3(1:i),uveeq3(1:j),uveeq3(1:i),
     $ uplatc(1:k)
      write (noutpt,1000) uveeq3(1:i),uveeq3(1:j),uveeq3(1:i),
     $ uplatc(1:k)
 1000 format(/' EQ3/6, Version ',a,' (EQ3/6-V',a,'-REL-V',a,'-',a,')')
c
      i = j
      j = index(usteq3,' ') - 1
      k = index(uplatm,' ') - 1
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1001) uveeq3(1:i),usteq3(1:j),uplatm(1:k)
      write (noutpt,1001) uveeq3(1:i),usteq3(1:j),uplatm(1:k)
 1001 format(' EQ3NR Speciation-Solubility Code (EQ3/6-V',a,
     $ '-EQ3NR-EXE-',a,'-',a,')')
c
      write (noutpt,1002)
      write (nttyo,1002)
 1002 format(' Supported by the following EQ3/6 libraries:')
c
      i = index(uveeql,'.') - 1
      j = index(usteql,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1003) uveeql(1:i),usteql(1:j),uplatm(1:k)
      write (noutpt,1003) uveeql(1:i),usteql(1:j),uplatm(1:k)
 1003 format('   EQLIB (EQ3/6-V',a,'-EQLIB-LIB-',a,'-',a,')')
c
      i = index(uveelg,'.') - 1
      j = index(ustelg,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1004) uveelg(1:i),ustelg(1:j),uplatm(1:k)
      write (noutpt,1004) uveelg(1:i),ustelg(1:j),uplatm(1:k)
 1004 format('   EQLIBG (EQ3/6-V',a,'-EQLIBG-LIB-',a,'-',a,')')
c
      i = index(uveelu,'.') - 1
      j = index(ustelu,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1005) uveelu(1:i),ustelu(1:j),uplatm(1:k)
      write (noutpt,1005) uveelu(1:i),ustelu(1:j),uplatm(1:k)
 1005 format('   EQLIBU (EQ3/6-V',a,'-EQLIBU-LIB-',a,'-',a,')',/)
c
      write (nttyo,1010)
      write (noutpt,1010)
 1010 format(' Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The',
     $ ' Regents of the',/' University of California, Lawrence',
     $ ' Livermore National Laboratory.',/' All rights reserved.',/)
c
c     Write additional statements and disclaimers.
c
      call prcndi(noutpt,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the time and date on the output.
c
      j2 = ilnobl(udate0)
      write (noutpt,1080) utime0,udate0(1:j2)
      write (nttyo,1080) utime0,udate0(1:j2)
 1080 format(' Run',2x,a8,2x,a,/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the platform's real(8) floating-point parameters.
c
      call flpars(eps100,irang,noutpt,nttyo,smp100)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize array dimension variables corresponding to fixed
c     parameters.
c
c     The following are common with EQ6.
c
      ietmax = iet_par
      jetmax = jet_par
      ketmax = ket_par
      netmax = net_par
c
      jsomax = jso_par
      nodbmx = nodb_par
      nopgmx = nopg_par
      noprmx = nopr_par
      noptmx = nopt_par
      nvetmx = nvet_par
c
      nxmd_asv = nxmd_par
      nxmdmx = nxmd_asv
c
      ntit_asv = ntit_par
      ntitmx = ntit_asv
c
      iapxa_asv = iapxa_par
      ibpxa_asv = ibpxa_par
c
c     The following are common with EQ6, but are only needed to write
c     a full EQ6 input file as the EQ3NR pickup file.
c
      nrct_asv = nrct_par
      nert_asv = nert_par
      nsrt_asv = nsrt_par
      nxrt_asv = nxrt_par
      imch_asv = imch_par
      ndct_asv = ndct_par
      nffg_asv = nffg_par
      nprp_asv = nprp_par
      nprs_asv = nprs_par
      nptk_asv = nptk_par
      nttk_asv = nttk_par
      nxop_asv = nxop_par
      nxpe_asv = nxpe_par
c
c     Special over-rides for EQ3NR.
c
      nrct_asv = 2
      nsrt_asv = 1
      nxrt_asv = 1
      nprp_asv = 1
      nprs_asv = 1
      nxop_asv = 1
      nxpe_asv = 1
c
      nrctmx = nrct_asv
      nertmx = nert_asv
      nsrtmx = nsrt_asv
      nxrtmx = nxrt_asv
      imchmx = imch_asv
      ndctmx = ndct_asv
      nffgmx = nffg_asv
      nprpmx = nprp_asv
      nprsmx = nprs_asv
      nptkmx = nptk_asv
      nttkmx = nttk_asv
      nxopmx = nxop_asv
      nxpemx = nxpe_asv
c
c     The following are unique to EQ3NR.
c
      nxti_asv = nxti_par
c
      njfmax = njf_par
c
      nxtimx = nxti_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the following floating-point constants:
c
c       rconst = the gas constant: 1.98726 cal/mol-K
c       rcnstv = the gas constant: 83.14510 bar-cm3/mol-K
c       vpgstp = the molar volume of a perfect gas at STP:
c                  22413.6 cm3/mol
c       farad  = the Faraday constant: 23062.3 cal/equiv-volt
c       al10   = ln 10; =~ 2.3026
c
      rconst = 1.98726
      rcnstv = 83.14510
cXX   vpgstp = 22413.6
      farad = 23062.3
      x10 = 10.
      al10 = log(x10)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the EQ6 calculational mode flag (.false. in EQ3NR).
c
      q6mode = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the header section of the data1 file. This section consists
c     of a record containing the string 'data1' (to ensure that the file
c     is indeed a data1 file), a record containing the keystring for the
c     activity coefficient model for aqueous species to which this data
c     file corresponds, and the array allocation size variables required
c     to allocate sufficient array space to store the rest of the data
c     on this data file.
c
      call indath(ikta_asv,ipbt_asv,ipch_asv,ipcv_asv,
     $ jpfc_asv,nad1,napa_asv,narx_asv,nata_asv,nbta_asv,
     $ ncta_asv,ngta_asv,nlta_asv,nmta_asv,npta_asv,nmuta_asv,
     $ noutpt,nslta_asv,nsta_asv,ntid_asv,ntpr_asv,nttyo,
     $ nxta_asv,udakey)
c
c     The value of nbta_asv at this point matches the number of
c     formally declared basis species on the data file. That is
c     the number of species in the "strict" and "auxiliary" basis
c     set sections of the aqueous species superblock. Save this
c     as nbtafd. Other species can be added to the basis set in
c     this version of EQ3/6. Thus, nbta_asv at this point is not
c     the "final answer."
c
      nbtafd = nbta_asv
c
c     Bump up the values of some allocation size variables to allow
c     for some species, phases, etc., to created by this software.
c     Examples: generic ion exchanger phases and species.
c
      nbta_asv = nbta_asv + 10
      npta_asv = npta_asv + net_par + 10
      nsta_asv = nsta_asv + iet_par*jet_par*net_par + 10
c
c     Set the values of some secondary allocation size variables.
c
      nbta1_asv = nbta_asv + 1
      ndrsa_asv = 7*nsta_asv
      nessa_asv = 5*nsta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data read from the rest of the data1
c     file.
c
      ALLOCATE(iapxta(nxta_asv))
      ALLOCATE(ibpxta(nxta_asv))
      ALLOCATE(jsola(nxta_asv))
      ALLOCATE(narxt(ntpr_asv))
      ALLOCATE(nbaspa(nbta_asv))
      ALLOCATE(ndrsa(ndrsa_asv))
      ALLOCATE(nessa(nessa_asv))
c
      ALLOCATE(ncmpra(2,npta_asv))
      ALLOCATE(ndrsra(2,nsta_asv))
      ALLOCATE(nessra(2,nsta_asv))
c
      ALLOCATE(qclnsa(nsta_asv))
c
      ALLOCATE(utitld(ntid_asv))
      ALLOCATE(uspeca(nsta_asv))
      ALLOCATE(uphasa(npta_asv))
      ALLOCATE(uptypa(npta_asv))
      ALLOCATE(uelema(ncta_asv))
      ALLOCATE(ubasp(nbta_asv))
c
      ALLOCATE(tempcu(ntpr_asv))
c
      ALLOCATE(aprehw(narx_asv,ntpr_asv))
      ALLOCATE(apresg(narx_asv,ntpr_asv))
c
      ALLOCATE(axhfe(narx_asv,ntpr_asv))
      ALLOCATE(axlke(narx_asv,ntpr_asv))
      ALLOCATE(axvfe(narx_asv,ntpr_asv))
c
      ALLOCATE(aadh(narx_asv,ntpr_asv))
      ALLOCATE(aadhh(narx_asv,ntpr_asv))
      ALLOCATE(aadhv(narx_asv,ntpr_asv))
      ALLOCATE(aaphi(narx_asv,ntpr_asv))
      ALLOCATE(abdh(narx_asv,ntpr_asv))
      ALLOCATE(abdhh(narx_asv,ntpr_asv))
      ALLOCATE(abdhv(narx_asv,ntpr_asv))
      ALLOCATE(abdot(narx_asv,ntpr_asv))
      ALLOCATE(abdoth(narx_asv,ntpr_asv))
      ALLOCATE(abdotv(narx_asv,ntpr_asv))
c
      ALLOCATE(adadhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adadhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adbdhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adbdhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adbdth(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adbdtv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adhfe(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(advfe(narx_asv,ntpr_asv,ipcv_asv))
c
      ALLOCATE(axhfsa(narx_asv,ntpr_asv,nsta_asv))
      ALLOCATE(axlksa(narx_asv,ntpr_asv,nsta_asv))
      ALLOCATE(axvfsa(narx_asv,ntpr_asv,nsta_asv))
c
      ALLOCATE(adhfsa(narx_asv,ntpr_asv,ipch_asv,nsta_asv))
      ALLOCATE(advfsa(narx_asv,ntpr_asv,ipcv_asv,nsta_asv))
c
      ALLOCATE(atwta(ncta_asv))
      ALLOCATE(cdrsa(ndrsa_asv))
      ALLOCATE(cessa(nessa_asv))
      ALLOCATE(mwtspa(nsta_asv))
      ALLOCATE(vosp0a(nsta_asv))
      ALLOCATE(zchara(nsta_asv))
c
      ALLOCATE(apxa(iapxa_asv,nxta_asv))
      ALLOCATE(bpxa(ibpxa_asv,nxta_asv))
c
c     SEDH data.
c
      ALLOCATE(azeroa(nata_asv))
      ALLOCATE(insgfa(nata_asv))
c
c     Pitzer data.
c
      ALLOCATE(nalpaa(nslta_asv))
      ALLOCATE(nmuxa(3,nmuta_asv))
      ALLOCATE(nslxa(2,nslta_asv))
c
      ALLOCATE(amua(jpfc_asv,nmuta_asv))
c
      ALLOCATE(aslma(jpfc_asv,0:ipbt_asv,nslta_asv))
      ALLOCATE(palpaa(ipbt_asv,napa_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the remainder of the data1 file. The image of the data file
c     is stored in arrays and variables that typically end in 'a.'
c     A subset of this is the reaction data. The variable nbta and
c     the arrays nbaspa, cdrsa, ndrsa, ndrsra, and axlksa comprise
c     what is called the 'a' set of reaction data. These are not
c     modified by any code manipulations.
c
      call indata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,
     $ adbdtv,adhfe,adhfsa,advfe,advfsa,amua,aprehw,apresg,
     $ apxa,aslma,atwta,axhfe,axhfsa,axlke,axlksa,axvfe,axvfsa,
     $ azeroa,bpxa,cco2,cdrsa,cessa,eps100,iapxa_asv,iapxta,
     $ iaqsla,ibpxa_asv,ibpxta,ielam,igas,ikta_asv,insgfa,ipbt_asv,
     $ ipch,ipch_asv,ipcv,ipcv_asv,ixrn1a,ixrn2a,jpdblo,jpfc_asv,
     $ jptffl,jsola,mwtspa,nad1,nalpaa,napa_asv,napta,narn1a,narn2a,
     $ narx_asv,narxt,nata,nata_asv,nbaspa,nbta,nbta_asv,nbtafd,
     $ nbta1_asv,ncmpra,ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsra,nessa,
     $ nessa_asv,nessra,ngrn1a,ngrn2a,ngta,ngta_asv,nlrn1a,nlrn2a,
     $ nlta,nlta_asv,nmrn1a,nmrn2a,nmta,nmta_asv,nmuta,nmuta_asv,
     $ nmuxa,noutpt,npta,npta_asv,nslta,nslta_asv,nslxa,nsta,
     $ nsta_asv,ntid_asv,ntitld,ntpr_asv,ntprt,nttyo,nxrn1a,nxrn2a,
     $ nxta,nxta_asv,qclnsa,palpaa,tdamax,tdamin,tempcu,ubasp,
     $ udakey,udatfi,uelema,uspeca,uphasa,uptypa,utitld,vosp0a,
     $ zchara)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data extracted from the pseudo-data
c     files.
c
      ntf1a_asv = ntf1a_par
      ALLOCATE(ntf1a(ntf1a_asv))
      ALLOCATE(tf1a(ntf1a_asv))
c
      ntf2a_asv = ntf2a_par
      ALLOCATE(ntf2a(ntf2a_asv))
      ALLOCATE(tf2a(ntf2a_asv))
c
      ntf1mx = ntf1a_asv
      ntf2mx = ntf2a_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the coefficients for calculating the HCO3-CO3-OH total
c     alkalinity. These are actually set in a pseudo-data file in the
c     EQLIB INCLUDE file eqltf1.h. The subroutine called here assigns
c     the coefficients to the species read from the data file.
c
c     Calling sequence substitutions:
c       ntf1a for ntfxa
c       ntf1mx for ntfxmx
c       ntf1ta for ntfxta
c       tf1a for tfxa
c       utf1xd for utfxxd
c
      call inttfx(narn1a,narn2a,noutpt,nsta_asv,ntf1a,ntf1mx,
     $ ntf1ta,nttyo,tf1a,uspeca,utf1xd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the coefficients for calculating the extended total
c     alkalinity. These are actually set in a pseudo-data file in the
c     EQLIB INCLUDE file eqltf2.h. The subroutine called here assigns
c     the coefficients to the species read from the data file.
c
c     Calling sequence substitutions:
c       ntf2a for ntfxa
c       ntf2mx for ntfxmx
c       ntf2ta for ntfxta
c       tf2a for tfxa
c       utf2xd for utfxxd
c
      call inttfx(narn1a,narn2a,noutpt,nsta_asv,ntf2a,ntf2mx,
     $ ntf2ta,nttyo,tf2a,uspeca,utf2xd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of H+, OH-, Cl-, aqueous O2(g), and aqueous e-.
c     This will be repeated after data compression.
c
c     Calling sequence substitutions:
c       narn1a for narn1
c       narn2a for narn2
c       nchloa for nchlor
c       nhydra for nhydr
c       neleca for nelect
c       nhydxa for nhydx
c       no2gaa for no2gaq
c       nsta_asv for nstmax
c       uspeca for uspec
c
      call gspion(narn1a,narn2a,nchloa,neleca,nhydra,nhydxa,noutpt,
     $ no2gaa,nsta_asv,nttyo,uspeca)
c
c     Calling sequence substitutions:
c       nbaspa for nbasp
c       nbta_asv for nbtmax
c       nbta for nbt
c       ncta for nct
c       ndrsra for ndrsr
c       nrdxsa for nrdxsp
c       nsta_asv for nstmax
c       uspeca for uspec
c
      call grdxsp(nbaspa,nbta,nbta_asv,ncta,ndrsra,noutpt,
     $ nrdxsa,nsta_asv,nttyo,uspeca)
c
c     Get the basis index of water.
c
c     Calling sequence substitutions:
c       nbaspa for nbasp
c       nbta for nbt
c       nbta_asv for nbtmax
c       narn1a for ns
c
      nbwa = nbasis(nbaspa,nbta,nbta_asv,narn1a)
c
c     Get some constants that depend on the molecular weight of
c     water.
c
      omega = 1000./mwtspa(narn1a)
      omeglg = log10(omega)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up the remaining array allocation variables required to
c     allocate variables needed to store the dta to be read from the
c     input file.
c
c     The following value of k_asv is special to EQ3NR.
c     A larger value is necessary for EQ6.
c
      k_asv = nbta_asv + 5
c
c     The following is unique to EQ3NR.
c
      nxic_asv = ikta_asv*nxti_asv
      nxicmx = nxic_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data to be read from the input
c     file.
c
      ALLOCATE(jflgi(nbta_asv))
      ALLOCATE(nbaspi(nbta_asv))
c
      ALLOCATE(npnxp(nxti_asv))
c
      ALLOCATE(ncmpri(2,nxti_asv))
c
      ALLOCATE(uspeci(nbta_asv))
      ALLOCATE(umemi(nxic_asv))
      ALLOCATE(usoli(nxti_asv))
c
      ALLOCATE(covali(nbta_asv))
c
      ALLOCATE(mtbaqi(nbta_asv))
      ALLOCATE(mtbi(nbta_asv))
      ALLOCATE(xbari(nxic_asv))
      ALLOCATE(zvclgi(k_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up the remaining required array allocation variables.
c     At the present time, just set the regular variables which
c     correspond to specific variables required for the 'a' set
c     of data (e.g., nbt_asv to nbta_asv) to the values of the
c     corresponding 'a' set variables.
c
c     Primary allocation variables.
c
      nat_asv = nata_asv
      nbt_asv = nbta_asv
      nct_asv = ncta_asv
      ngt_asv = ngta_asv
      nlt_asv = nlta_asv
      nmt_asv = nmta_asv
      npt_asv = npta_asv
      nst_asv = nsta_asv
      nxt_asv = nxta_asv
c
      nap_asv = napa_asv
      nslt_asv = nslta_asv
      nmut_asv = nmuta_asv
c
      ikt_asv = ikta_asv
      iapx_asv = iapxa_asv
      ibpx_asv = ibpxa_asv
c
      ntf1_asv = ntf1a_asv
      ntf2_asv = ntf2a_asv
c
c     Secondary allocation variables.
c
      nbt1_asv = nbt_asv + 1
      ndrs_asv = 7*nst_asv
      ness_asv = 5*nst_asv
      ntfx_asv = max(ntf1_asv,ntf2_asv)
      nmx_asv = 3*nmut_asv
      nsx_asv = 2*nslt_asv
c
c     Note: nazp_asv and nazm_asv could be better calculated after
c     compression of the set of aqueous species.
c
      azchmx = 0.
      do ns = narn1a,narn2a
        azch = abs(zchara(ns))
        azchmx = max(azch,azchmx)
      enddo
      nazp_asv = nint(azchmx)
      nazm_asv = -nazp_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize array dimension variables corresponding to allocation
c     size variables associated with run-time dimensioning.
c
      iapxmx = iapx_asv
      ibpxmx = ibpx_asv
      iktmax = ikt_asv
      ipchmx = ipch_asv
      ipcvmx = ipcv_asv
      ipbtmx = ipbt_asv
      jpfcmx = jpfc_asv
c
      kmax = k_asv
c
      napmax = nap_asv
      narxmx = narx_asv
      natmax = nat_asv
      nazpmx = nazp_asv
      nazmmx = nazm_asv
      nbtmax = nbt_asv
      nbt1mx = nbt1_asv
      nctmax = nct_asv
      ndrsmx = ndrs_asv
      nessmx = ness_asv
      ngtmax = ngt_asv
      nltmax = nlt_asv
      nmtmax = nmt_asv
      nmutmx = nmut_asv
      nptmax = npt_asv
      nsltmx = nslt_asv
      nstmax = nst_asv
      ntidmx = ntid_asv
      ntprmx = ntpr_asv
      nxtmax = nxt_asv
c
      nmxmax = nmx_asv
      nsxmax = nsx_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate the rest of the necessary arrays.
c
      ALLOCATE(iindx1(k_asv))
      ALLOCATE(ipndx1(k_asv))
      ALLOCATE(ipivot(k_asv))
c
      ALLOCATE(insgf(nat_asv))
c
      ALLOCATE(ibswx(nbt_asv))
      ALLOCATE(ixbasp(nbt_asv))
      ALLOCATE(nbasp(nbt_asv))
      ALLOCATE(nbaspd(nbt_asv))
      ALLOCATE(nbaspx(nbt_asv))
      ALLOCATE(nbmap(nbt_asv))
      ALLOCATE(ncosp(nbt_asv))
      ALLOCATE(ndecsp(nbt_asv))
      ALLOCATE(nfac(nbt_asv))
c
      ALLOCATE(ncmap(nct_asv))
c
      ALLOCATE(iction(nbt_asv))
      ALLOCATE(kction(nbt_asv))
      ALLOCATE(jjndex(nbt_asv))
      ALLOCATE(kkndex(nbt_asv))
c
      ALLOCATE(ndrs(ndrs_asv))
      ALLOCATE(ndrsd(ndrs_asv))
      ALLOCATE(ndrsx(ndrs_asv))
c
      ALLOCATE(ness(ness_asv))
c
      ALLOCATE(igstak(ngt_asv))
      ALLOCATE(jgstak(ngt_asv))
      ALLOCATE(jgsort(ngt_asv))
c
      ALLOCATE(jpflag(npt_asv))
      ALLOCATE(ncmpr(2,npt_asv))
c
      ALLOCATE(istack(nst_asv))
      ALLOCATE(jstack(nst_asv))
      ALLOCATE(jcsort(nst_asv))
      ALLOCATE(jjsort(nst_asv))
      ALLOCATE(jssort(nst_asv))
      ALLOCATE(jflag(nst_asv))
      ALLOCATE(jflagd(nst_asv))
      ALLOCATE(jsflag(nst_asv))
      ALLOCATE(jsitex(nst_asv))
      ALLOCATE(nphasx(nst_asv))
      ALLOCATE(nsmap(nst_asv))
c
      ALLOCATE(ntfx(ntfx_asv))
      ALLOCATE(ntf1(ntf1_asv))
      ALLOCATE(ntf2(ntf2_asv))
c
      ALLOCATE(kxmod(nxmd_asv))
c
      ALLOCATE(iapxt(nxt_asv))
      ALLOCATE(ibpxt(nxt_asv))
      ALLOCATE(jsol(nxt_asv))
c
      ALLOCATE(ndrsr(2,nst_asv))
      ALLOCATE(ndrsrd(2,nst_asv))
      ALLOCATE(ndrsrx(2,nst_asv))
      ALLOCATE(nessr(2,nst_asv))
c
      ALLOCATE(qxknph(npt_asv))
c
      ALLOCATE(utitl(ntit_asv))
      ALLOCATE(utitl2(ntit_asv))
c
      ALLOCATE(ubmtbi(nbt_asv))
      ALLOCATE(ucospi(nbt_asv))
c
      ALLOCATE(uobsw(2,nbt_asv))
      ALLOCATE(usbsw(2,nbt_asv))
c
      ALLOCATE(uspec(nst_asv))
      ALLOCATE(uxmod(nxmd_asv))
      ALLOCATE(uzveci(k_asv))
      ALLOCATE(uzvec1(k_asv))
c
      ALLOCATE(uphase(npt_asv))
      ALLOCATE(uptype(npt_asv))
c
      ALLOCATE(uelem(nct_asv))
c
      ALLOCATE(uldel(k_asv))
      ALLOCATE(ulbeta(k_asv))
c
      ALLOCATE(apx(iapx_asv,nxt_asv))
      ALLOCATE(bpx(ibpx_asv,nxt_asv))
      ALLOCATE(wfac(ikt_asv,nxt_asv))
c
      ALLOCATE(aamatr(k_asv,k_asv))
      ALLOCATE(gmmatr(k_asv,k_asv))
c
      ALLOCATE(acflg(nst_asv))
      ALLOCATE(acflgo(nst_asv))
      ALLOCATE(act(nst_asv))
      ALLOCATE(actlg(nst_asv))
      ALLOCATE(affsd(nst_asv))
c
      ALLOCATE(affpd(npt_asv))
      ALLOCATE(loph(npt_asv))
      ALLOCATE(moph(npt_asv))
      ALLOCATE(sidrph(npt_asv))
c
      ALLOCATE(azero(nat_asv))
      ALLOCATE(a3bars(nat_asv))
c
      ALLOCATE(ahrc(nbt_asv))
      ALLOCATE(amtb(nbt_asv))
      ALLOCATE(cjbasp(nbt_asv))
c
      ALLOCATE(atwt(nct_asv))
      ALLOCATE(cteaq(nct_asv))
      ALLOCATE(mte(nct_asv))
      ALLOCATE(mteaq(nct_asv))
      ALLOCATE(ppmwe(nct_asv))
c
      ALLOCATE(alpha(k_asv))
      ALLOCATE(beta(k_asv))
      ALLOCATE(betao(k_asv))
      ALLOCATE(delvco(k_asv))
      ALLOCATE(delvec(k_asv))
      ALLOCATE(rhsvec(k_asv))
      ALLOCATE(zvclg1(k_asv))
      ALLOCATE(zvec1(k_asv))
c
      ALLOCATE(bfac(nbt_asv))
      ALLOCATE(coval(nbt_asv))
      ALLOCATE(ctb(nbt_asv))
      ALLOCATE(dlogxw(nbt_asv))
      ALLOCATE(efac(nbt_asv))
      ALLOCATE(ehrc(nbt_asv))
      ALLOCATE(fo2lrc(nbt_asv))
      ALLOCATE(mtb(nbt_asv))
      ALLOCATE(mtbaq(nbt_asv))
      ALLOCATE(perc(nbt_asv))
c
      ALLOCATE(cdrs(ndrs_asv))
      ALLOCATE(cdrsd(ndrs_asv))
      ALLOCATE(cdrsx(ndrs_asv))
      ALLOCATE(cdrtw(nst_asv))
      ALLOCATE(cdrw(nst_asv))
      ALLOCATE(cnufac(nst_asv))
      ALLOCATE(conc(nst_asv))
      ALLOCATE(conclg(nst_asv))
      ALLOCATE(losp(nst_asv))
      ALLOCATE(lsort(nst_asv))
      ALLOCATE(mosp(nst_asv))
      ALLOCATE(mwtsp(nst_asv))
      ALLOCATE(sidrsp(nst_asv))
      ALLOCATE(vosp0(nst_asv))
      ALLOCATE(weight(nst_asv))
      ALLOCATE(xbar(nst_asv))
      ALLOCATE(xbarlg(nst_asv))
      ALLOCATE(zchar(nst_asv))
      ALLOCATE(zchcu6(nst_asv))
      ALLOCATE(zchsq2(nst_asv))
c
      ALLOCATE(cess(ness_asv))
      ALLOCATE(tfx(ntfx_asv))
      ALLOCATE(tf1(ntf1_asv))
      ALLOCATE(tf2(ntf2_asv))
      ALLOCATE(xlkmod(nxmd_asv))
c
      ALLOCATE(fsort(ngt_asv))
      ALLOCATE(fugac(ngt_asv))
      ALLOCATE(fugalg(ngt_asv))
c
      ALLOCATE(xhfs(nst_asv))
      ALLOCATE(xhfsd(nst_asv))
      ALLOCATE(xlks(nst_asv))
      ALLOCATE(xlksd(nst_asv))
      ALLOCATE(xvfs(nst_asv))
      ALLOCATE(xvfsd(nst_asv))
c
      ALLOCATE(dhfe(ipch_asv))
      ALLOCATE(dvfe(ipcv_asv))
c
      ALLOCATE(dadhh(ipch_asv))
      ALLOCATE(dadhv(ipcv_asv))
      ALLOCATE(dbdhh(ipch_asv))
      ALLOCATE(dbdhv(ipcv_asv))
      ALLOCATE(dbdth(ipch_asv))
      ALLOCATE(dbdtv(ipcv_asv))
c
      ALLOCATE(dhfs(ipch_asv,nst_asv))
      ALLOCATE(dhfsd(ipch_asv,nst_asv))
      ALLOCATE(dvfs(ipcv_asv,nst_asv))
      ALLOCATE(dvfsd(ipcv_asv,nst_asv))
c
      ALLOCATE(axhfs(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axhfsd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axhfsx(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlks(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlksd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlksx(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfs(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfsd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfsx(narx_asv,ntpr_asv,nst_asv))
c
      ALLOCATE(adhfs(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(adhfsd(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(adhfsx(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(advfs(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
      ALLOCATE(advfsd(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
      ALLOCATE(advfsx(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
c
c     Pitzer data.
c
      ALLOCATE(nalpha(nslt_asv))
c
      ALLOCATE(nmux(3,nmut_asv))
      ALLOCATE(nmxi(2,nat_asv))
      ALLOCATE(nmxx(3,nmx_asv))
      ALLOCATE(nslx(2,nslt_asv))
      ALLOCATE(nsxi(2,nat_asv))
      ALLOCATE(nsxx(2,nsx_asv))
c
      ALLOCATE(amu(jpfc_asv,nmut_asv))
      ALLOCATE(pmu(nmut_asv))
c
      ALLOCATE(aslm(jpfc_asv,0:ipbtmx,nslt_asv))
      ALLOCATE(pslm(nslt_asv))
      ALLOCATE(dpslm(2,nslt_asv))
      ALLOCATE(pslamn(0:ipbtmx,nslt_asv))
c
      ALLOCATE(gpit(ipbtmx,nap_asv))
      ALLOCATE(dgpit(2,ipbtmx,nap_asv))
      ALLOCATE(palpha(ipbtmx,nap_asv))
c
      ALLOCATE(elam(nazp_asv,nazp_asv))
      ALLOCATE(delam(2,nazp_asv,nazp_asv))
      ALLOCATE(pelm(nazp_asv,nazp_asv))
      ALLOCATE(dpelm(2,nazp_asv,nazp_asv))
      ALLOCATE(selm(nazm_asv:nazp_asv))
      ALLOCATE(dselm(2,nazm_asv:nazp_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays needed to write a complete EQ6 input file as
c     the EQ3NR pickup file.
c
      ALLOCATE(jcode(nrct_asv))
      ALLOCATE(jreac(nrct_asv))
      ALLOCATE(nsk(nrct_asv))
c
      ALLOCATE(imech(2,nrct_asv))
      ALLOCATE(nrk(2,nrct_asv))
c
      ALLOCATE(iact(imch_asv,2,nrct_asv))
      ALLOCATE(ndact(imch_asv,2,nrct_asv))
c
      ALLOCATE(ibsrti(nsrt_asv))
      ALLOCATE(iesrti(nsrt_asv))
c
      ALLOCATE(ixrti(nxrt_asv))
c
      ALLOCATE(utitl1(ntit_asv))
c
      ALLOCATE(uprspi(nprs_asv))
c
      ALLOCATE(uprphi(nprp_asv))
      ALLOCATE(ubsri(nbt1_asv,nsrt_asv))
      ALLOCATE(ucxri(ikt_asv,nxrt_asv))
      ALLOCATE(udac(ndct_asv,imch_asv,2,nrct_asv))
      ALLOCATE(uffg(nffg_asv))
      ALLOCATE(ureac(nrct_asv))
      ALLOCATE(uxcat(nxop_asv))
      ALLOCATE(uxopt(nxop_asv))
      ALLOCATE(uxopex(nxpe_asv))
      ALLOCATE(uesri(nct_asv,nsrt_asv))
c
      ALLOCATE(cbsri(nbt1_asv,nsrt_asv))
      ALLOCATE(cdac(ndct_asv,imch_asv,2,nrct_asv))
      ALLOCATE(cesri(nct_asv,nsrt_asv))
      ALLOCATE(csigma(imch_asv,2,nrct_asv))
      ALLOCATE(eact(imch_asv,2,nrct_asv))
      ALLOCATE(hact(imch_asv,2,nrct_asv))
      ALLOCATE(rkb(imch_asv,2,nrct_asv))
      ALLOCATE(trkb(imch_asv,2,nrct_asv))
      ALLOCATE(fkrc(nrct_asv))
      ALLOCATE(modr(nrct_asv))
      ALLOCATE(morr(nrct_asv))
      ALLOCATE(sfcar(nrct_asv))
      ALLOCATE(ssfcar(nrct_asv))
      ALLOCATE(vreac(nrct_asv))
      ALLOCATE(moffg(nffg_asv))
      ALLOCATE(xlkffg(nffg_asv))
      ALLOCATE(mprphi(nprp_asv))
      ALLOCATE(mprspi(nprs_asv))
      ALLOCATE(ptk(nptk_asv))
      ALLOCATE(ttk(nttk_asv))
      ALLOCATE(rxbari(ikt_asv,nxrt_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate some arrays needed to assist in writing a complete
c     EQ6 input file as the EQ3NR pickup file. These arrays do not
c     appear on that file itself.
c
      ALLOCATE(uesr1(nct_asv))
      ALLOCATE(cesr1(nct_asv))
      ALLOCATE(cbsr1(nbt1_asv))
      ALLOCATE(ubsr1(nbt1_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to handle mass balance coefficients.
c
      nsts_asv = 10*nst_asv
      nstsmx = nsts_asv
c
      ALLOCATE(nsts(nsts_asv))
      ALLOCATE(nstsr(2,nst_asv))
      ALLOCATE(csts(nsts_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the problem counter.
c
      nprob = 0
c
c     The label below is a return point for processing an additional
c     problem specifed on the input file.
c
   20 nprob = nprob + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set special species indices.
c
      nchlor = nchloa
      nhydr = nhydra
      nhydx = nhydxa
      no2gaq = no2gaa
      nelect = neleca
      nrdxsp = nrdxsa
      nbw = nbwa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize certain arrays to zeros, blanks, etc.
c
      qbassw = .false.
c
      call initiz(iopt,noptmx)
      call initiz(iopg,nopgmx)
      call initiz(iopr,noprmx)
      call initiz(iodb,nodbmx)
c
      call initiz(jflgi,nbtmax)
      call initaz(covali,nbtmax)
c
      call initcb(uspeci,nbtmax)
      call initcb(ucospi,nbtmax)
c
      nmax = 2*nbtmax
      call initcb(uobsw,nmax)
      call initcb(usbsw,nmax)
c
      call initiz(ncosp,nbtmax)
      call initiz(ndecsp,nbtmax)
      call initaz(coval,nbtmax)
c
      call initiz(nbasp,nbtmax)
c
      call initiz(jflag,nstmax)
      call initiz(jflagd,nstmax)
      call initcb(uspec,nstmax)
      call initaz(xlks,nstmax)
      call initaz(zchar,nstmax)
      call initaz(zchsq2,nstmax)
      call initaz(zchcu6,nstmax)
c
cxxxxxxxxxxx
      call initaz(cdrs,ndrsmx)
      call initaz(cdrsx,ndrsmx)
      call initiz(ndrs,ndrsmx)
      call initiz(ndrsx,ndrsmx)
c
cxxxxxxxxxxx
      nmax = 2*nstmax
      call initiz(ndrsr,nmax)
      call initiz(ndrsrx,nmax)
c
      nmax = narxmx*ntprmx*nstmax
      call initaz(axlks,nmax)
      call initaz(axhfs,nmax)
      call initaz(axvfs,nmax)
cxxxxxxxxxxx
      call initaz(axlksx,nmax)
      call initaz(axhfsx,nmax)
      call initaz(axvfsx,nmax)
c
      nmax = narxmx*ntprmx*ipchmx*nstmax
      call initaz(adhfs,nmax)
      call initaz(adhfsx,nmax)
c
      nmax = narxmx*ntprmx*ipcvmx*nstmax
      call initaz(advfs,nmax)
      call initaz(advfsx,nmax)
cxxxxxxxxxxx
c
      call initcb(ugexp,netmax)
      call initaz(cgexpi,netmax)
      call initiz(jgext,netmax)
c
      nmax = jetmax*netmax
      call initiz(ngexrt,nmax)
c
      nmax = ietmax*jetmax*netmax
      call initaz(xgexsi,nmax)
c
      nmax = iapxmx*nxtmax
      call initaz(apx,nmax)
c
      nmax = ibpxmx*nxtmax
      call initaz(bpx,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the problem input format.
c
      read (ninpts,1030,end=105,err=107) ux8
 1030 format(a8)
      backspace ninpts
      uinfor = 'W'
      if (ux8(1:8) .eq. '|-------') uinfor = 'D'
c
c     Read the problem input.
c
      if (uinfor(1:1) .eq. 'W') then
c
c       Compact (W) format.
c
        call rd3inw(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $  ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $  jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $  netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $  noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $  nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $  tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $  ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $  uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $  xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
      else
c
c       Menu-style (D) format.
c
        call rd3ind(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $  ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $  jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $  netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $  noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $  nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $  tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $  ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $  uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $  xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
      endif
c
      go to 109
  105 qend = .true.
      go to 109
  107 qrderr = .true.
  109 continue
c
      if (qrderr) then
        write (noutpt,1203)
        write (nttyo,1203)
 1203   format(/' * Error - (EQ3NR/eq3nr) Encountered an error while',
     $  ' reading the input file.',/7x,'The line associated with',
     $  ' the problem should be the last one',/7x,'echoed on the',
     $  ' output file or the first line immediately thereafter.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qend) then
c
        write (noutpt,1205)
        write (nttyo,1205)
 1205   format(/' No further input found.',/)
c
c       Get end time and date. Also get the run, user, and cpu times.
c
        call runtim(iexec0,jexec0,texec0,noutpt,nttyo,trun,
     $  tuser,tcpu,udate1,utime1)
c
        j2 = ilnobl(udate0)
        j3 = ilnobl(udate1)
        write (noutpt,1208) utime0,udate0(1:j2),utime1,udate1(1:j3)
        write (nttyo,1208) utime0,udate0(1:j2),utime1,udate1(1:j3)
 1208   format(/10x,'Start time = ',a8,2x,a,/12x,
     $  'End time = ',a8,2x,a)
c
c       Print the run, user, and cpu times.
c
        write (noutpt,1020) trun
        write (nttyo,1020)  trun
 1020   format(/10x,' Run time = ',g10.3,' seconds')
        if (tuser .gt. 0.) then
          write (noutpt,1022) tuser
          write (nttyo,1022)  tuser
 1022     format(10x,'User time = ',g10.3,' seconds')
        endif
        if (tcpu .gt. 0.) then
          write (noutpt,1024) tcpu
          write (nttyo,1024)  tcpu
 1024     format(10x,' Cpu time = ',g10.3,' seconds')
        endif
c
        write (noutpt,1090)
        write (nttyo,1090)
 1090   format(/' Normal exit')
c
c       Clear the IEEE flag for floating-point underflow, if such a
c       flag is present, to avoid getting an unnecessary system
c       warning message. Underflow is a normal condition in EQ3/6.
c       Make porting changes in the EQLIBU subroutine that is called
c       in this section. Do not make the porting changes here.
c
        call cliefu()
c
c       Close and delete the stripped input file.
c
        close (ninpts,status='delete')
c
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scan the input file title for option strings.
c
c     Scan the input file title for the USEOLDPITZERMU string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), set up
c     set to calculate activity coefficients using recalculated
c     observable third-order parameters (Cphi, psi, zeta) instead
c     of their conventional mu equivalents.
c
      qhawep = .true.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl
          ux80 = utitl(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzermu')
          if (i .gt. 0) then
            qhawep = .false.
            go to 106
          endif
        enddo
  106   continue
      endif
c
      if (.not.qhawep) then
        write (noutpt,1190)
        write (nttyo,1190)
 1190   format(/' * Note - (EQ3NR/eq3nr) Found the USEOLDPITZERMU',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will evaluate the Pitzer',/7x,'equations using the',
     $  ' lambda-mu format. Implied psi coefficients',/7x,'not',
     $  ' on the supporting data file will not be effectively',
     $  ' treated',/7x,'as having zero values. Rather, the',
     $  ' corresponding mu coefficients',/7x,'will be treated as',
     $  ' having zero values. In effect, an implied',/7x,'psi',
     $  ' coefficient value will include contributions from',
     $  ' the',/7x,'two cognate Cphi coefficients that appear',
     $  ' in the psi-mu',/7x,'breakdown equation.')
      endif
c
c     Scan the input file title for the USEOLDPITZER75 string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), use
c     the older approximation given by Pitzer (1975) for calculating
c     the higher-order electrostatic terms.
c
      qpit75 = .false.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl
          ux80 = utitl(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzer75')
          if (i .gt. 0) then
            qpit75 = .true.
            go to 170
          endif
        enddo
  170   continue
      endif
c
      if (qpit75) then
        write (noutpt,1193)
        write (nttyo,1193)
 1193   format(/' * Warning - (EQ3NR/eq3nr) Found the USEOLDPITZER75',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will evaluate the Pitzer',/7x,'equations using the',
     $  ' old Pitzer (1975) approximation for',/7x,'higher order',
     $  ' electrostatic terms, not the later Harvie (1981)',
     $  /7x,'approximation that is now used nearly universally',
     $  ' to evaluate',/7x,'the Pitzer equations.')
      endif
c
c     Scan the input file title for the WRITEPITZERJTABLES string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), calculate
c     and output tables of the J(x) and J'(x) functions. This is a
c     one-time only option. It is not carried forward on the PICKUP
c     file.
c
      qcwrpj = .false.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl
          ux80 = utitl(n)
          call locase(ux80)
          i = index(ux80,'writepitzerjtables')
          if (i .gt. 0) then
            qcwrpj = .true.
            go to 180
          endif
        enddo
  180   continue
      endif
c
      if (qcwrpj) then
        write (noutpt,1194)
        write (nttyo,1194)
 1194   format(/' * Note - (EQ3NR/eq3nr) Found the WRITEPITZERJTABLES',
     $  ' option string',/7x,'in the input file title.',
     $  ' Will calculate the Pitzer',/7x,"J(x) and J'(x) functions",
     $  ' for higher order electrostatic terms and',/7x,'write output',
     $  ' tables for both the Pitzer (1975) and Harvie (1981)',/7x,
     $  'approximations.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If the phase part of certain species names read from the
c     input file is blank, make this part 'Aqueous solution'.
c
      do n = 1,nsbswt
        if (usbsw(1,n)(25:48) .eq. ublk24(1:24))
     $  usbsw(1,n)(25:48) = uaqsln(1:24)
        if (usbsw(2,n)(25:48) .eq. ublk24(1:24))
     $  usbsw(2,n)(25:48) = uaqsln(1:24)
      enddo
c
      do nbi = 1,nbti
        if (uspeci(nbi)(25:48) .eq. ublk24(1:24))
     $  uspeci(nbi)(25:48) = uaqsln(1:24)
      enddo
c
      do n = 1,nobswt
        if (uobsw(1,n)(25:48) .eq. ublk24(1:24))
     $  uobsw(1,n)(25:48) = uaqsln(1:24)
        if (uobsw(2,n)(25:48) .eq. ublk24(1:24))
     $  uobsw(2,n)(25:48) = uaqsln(1:24)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the redox variables.
c
      qredox = .true.
c
      if (irdxc3 .ne. -3) then
        do nbi = 1,nbti
          if (uspeci(nbi)(1:6).eq.'O2(g) ' .and.
     $      uspeci(nbi)(25:48).eq.uaqsln(1:24)) then
            write (noutpt,1100)
            write (nttyo,1100)
 1100       format(/' * Note - (EQ3NR/eq3nr) The input line for O2(g)',
     $      /7x,'will be ignored because irdxc3 is not equal to -3.')
            jflgi(nbi) = 0
            covali(nbi) = 0.
            go to 102
          endif
        enddo
  102   continue
      endif
c
      fo2lg = -99999.
      fo2 = 0.
      if (irdxc3 .eq. 0) then
        fo2lg = fo2lgi
        fo2 = texp(fo2lg)
      elseif (irdxc3 .eq. -1) then
        eh = ehi
      elseif (irdxc3 .eq. -2) then
        pe = pei
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Normalize the mole fractions of any solid solution components.
c
      nerr = 0
      do nxi = 1,nxti
        nr1 = ncmpri(1,nxi)
        nr2 = ncmpri(2,nxi)
c
        xx = 0.
        do nxic = nr1,nr2
          xx = xx + xbari(nxic)
        enddo
c
        if (xx .le. 0.) then
          j2 = ilnobl(usoli(nxi))
          write (noutpt,1110) usoli(nxi)(1:j2)
          write (nttyo,1110) usoli(nxi)(1:j2)
 1110     format(/' * Error - (EQ3NR/eq3nr) The solid solution',
     $    a,/7x,'was given on the input file with a null composition.')
          nerr = nerr + 1
          go to 104
        endif
c
        do nxic = nr1,nr2
          xbari(nxic) = xbari(nxic)/xx
        enddo
  104   continue
      enddo
      if (nerr .gt. 0) go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check consistency between the activity coefficient option and the
c     data1 file.
c
      call cdakey(iopg,nopgmx,noutpt,nttyo,udakey,udatfi)
c
c     Get the name of the option for calculating the activity
c     coefficients of aqueous species.
c
      call nactop(iopg,nopgmx,noutpt,nttyo,uactop)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Open the pickup file if this is to be used.
c
      if (iopt(17) .ne. -1) then
        inquire(file=pfile,opened=qop)
        if (.not.qop) call openou(noutpt,nttyo,pfile,'formatted',
     $  nrecl,newin)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the 'a' set of reaction data into the 'd' set. The 'a'
c     set remains a faithful image of the data file. The 'd' set
c     at this stage is subject to modification. The number of basis
c     species may be increased in response to input file directives.
c     Thus, nbtd may become greater than nbta, and the basis species
c     pointer array nbaspd lengthened with respect to nbaspa. The
c     'd' set at this stage may also be modified by directives on the
c     input file to execute special basis switching. This redefines
c     which of the basis species are the strict basis species, and
c     according causes reactions and attendant thermodynamic data to
c     be rewritten. Modifications of the 'd' set at this stage
c     support options affecting problem definition. After the data
c     have been compressed to eliminate unnecessary species, the 'd'
c     set will be redefined. This second stage form is equivalent to
c     a compressed version of the first stage form with additional
c     input file directed modifications.
c
c     Calling sequence substitutions:
c       adhfsa for adhfs
c       advfsa for advfs
c       axhfsa for axhfs
c       axlksa for axlks
c       axvfsa for axvfs
c       cdrsa for cdrs
c       nbaspa for nbasp
c       ndrsa for ndrs
c       ndrsra for ndrsr
c
      call cdrssd(adhfsa,adhfsd,advfsa,advfsd,axhfsa,axhfsd,
     $ axlksa,axlksd,axvfsa,axvfsd,cdrsa,cdrsd,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,nbaspa,nbaspd,nbtmax,ndrsa,ndrsd,ndrsmx,ndrsra,ndrsrd,
     $ nstmax,ntprmx)
      nbtd = nbta
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute special basis switching to redefine which basis species
c     are the strict basis species in the 'd' set of reaction data
c     (nbtd/nbaspd/cdrsd/ndrsd/ndrsrd/axlksd). This type of basis
c     switching is executed to assist in problem definition. Ordinary
c     basis switching, executed later in this code, is done only
c     for numerical purposes.
c
      if (nsbswt .gt. 0) then
c
        do nsbsw = 1,nsbswt
c
c         Interpret the directive for the nsbsw-th switch.
c
          call intsbs(nb1,nb2,nbaspd,nbtd,nbtmax,noutpt,ns1,ns2,
     $    nsbsw,nstmax,nttyo,usbsw,uspeca)
c
c         Execute the switch.
c
          call swtchb(adhfsd,adhfsx,advfsd,advfsx,axhfsd,axhfsx,
     $    axlksd,axlksx,axvfsd,axvfsx,cdrsd,cdrsx,ipch,ipchmx,ipcv,
     $    ipcvmx,narxmx,nbaspd,nbtmax,nbw,nb1,nb2,ndrsd,ndrsmx,ndrsx,
     $    ndrsrd,ndrsrx,noutpt,ns1,ns2,nsta,nstmax,ntprmx,nttyo,uspeca)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Force jflag to default to 27 instead of 30 for the species
c     O2(aq) and H2(aq).
c
      call jfloha(jflgi,nbtd,nbti,nbtmax,noutpt,nttyo,
     $ nxmdmx,nxmod,ubasp,uspeci,uxmod)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret the basis species information listed on the input file.
c
      call intbs3(covali,ier,jflag,jflgi,narn1a,narn2a,nbaspd,
     $ nbtd,nbti,nbtmax,ndrsrd,ndecsp,noutpt,nrdxsp,nsta,nstmax,
     $ nttyo,uspeca,uspeci)
c
      if (ier .gt. 0) go to 20
c
c     Set jflag to -1 for species that can't appear in the system.
c
      call jflaux(jflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,
     $ ndrsrd,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up temperature variables.
c
      tempk = tempc + 273.15
      call gntpr(ntpr,ntprmx,ntprt,tempc,tempcu)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set species status flags.
c
      call flgset(axlksd,iopt,jflag,jpflag,jsflag,kxmod,narn1a,
     $ narn2a,narxmx,nbaspd,nbtd,nbtmax,ncmpra,ncta,ndrsd,ndrsmx,
     $ ndrsrd,noptmx,noutpt,npta,nptmax,nrdxsp,nsta,nstmax,ntpr,
     $ ntprmx,nttyo,nxmdmx,nxmod,uphasa,uptypa,uspeca,uxmod)
c
c     Check the jpflag array to make sure it is consistent with the
c     jsflag array.
c
      call flgchk(jpflag,jsflag,ncmpra,npta,nptmax,nstmax,qclnsa)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Look at each active auxiliary basis species. Write a warning if
c     any other species in the corresponding dissociation reaction is
c     not present in the model.
c
      call bspchk(jsflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $ noutpt,nrdxsp,nstmax,nttyo,uspeca)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do data array compression. Write working data arrays that
c     do not include phases and species that are not necessary
c     for the current problem.
c
      call cmpdat(adhfs,adhfsd,advfs,advfsd,amu,amua,apx,
     $ apxa,aslm,aslma,atwt,atwta,axhfs,axhfsd,axlks,axlksd,axvfs,
     $ axvfsd,azero,azeroa,bpx,bpxa,cdrs,cdrsd,cess,cessa,iapxmx,
     $ iapxt,iapxta,iaqsla,iaqsln,ibpxmx,ibpxt,ibpxta,ilrn1,ilrn2,
     $ imrn1,imrn2,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,insgf,insgfa,
     $ iopg,ixrn1,ixrn1a,ixrn2,ixrn2a,jflag,jpfcmx,jpflag,jsflag,
     $ jsitex,jsol,jsola,mwtsp,mwtspa,nalpaa,nalpha,napmax,napt,
     $ napta,narn1,narn1a,narn2,narn2a,narxmx,nat,natmax,nbasp,
     $ nbaspd,nbmap,nbt,nbtd,nbti,nbtmax,nchlor,ncmap,ncmpr,ncmpra,
     $ nct,ncta,nctmax,ndecsp,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ness,
     $ nessa,nessmx,nessr,nessra,ngrn1,ngrn1a,ngrn2,ngrn2a,ngt,
     $ nlrn1,nlrn1a,nlrn2,nlrn2a,nlt,nmrn1,nmrn1a,nmrn2,nmrn2a,nmt,
     $ nmut,nmuta,nmutmx,nmux,nmuxa,nopgmx,nslt,nsltmx,nslta,nslx,
     $ nslxa,nphasx,npt,npta,nptmax,nsmap,nsta,nst,nstmax,ntf1,ntf1a,
     $ ntf1mx,ntf1t,ntf1ta,ntf2,ntf2a,ntf2mx,ntf2t,ntf2ta,ntprmx,
     $ nxrn1,nxrn1a,nxrn2,nxrn2a,nxt,nxtmax,palpaa,palpha,qchlor,
     $ tf1,tf1a,tf2,tf2a,uelem,uelema,uphasa,uphase,uptypa,uptype,
     $ uspec,uspeca,vosp0,vosp0a,zchar,zchara)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do ne = 1,netmax
        cgexp(ne) = 0.
      enddo
c
      do ns = 1,nstmax
        acflg(ns) = 0.
        acflgo(ns) = 0.
        act(ns) = 0.
        conc(ns) = 0.
        mosp(ns) = 0.
        xbar(ns) = 0.
        zchsq2(ns) = 0.
        zchcu6(ns) = 0.
      enddo
c
      av = -99999.
      call initav(conclg,nstmax,av)
      call initav(losp,nstmax,av)
      call initav(actlg,nstmax,av)
      call initav(xbarlg,nstmax,av)
c
      do np = 1,nptmax
        moph(np) = 0.
      enddo
c
      av = -99999.
      call initav(loph,nptmax,av)
c
      do kcol = 1,kmax
        zvec1(kcol) = 0.
      enddo
c
      av = -99999.
      call initav(zvclg1,kmax,av)
c
      uv = 'conc'
      call initcv(ulbeta,kmax,uv)
      call initcv(uldel,kmax,uv)
c
      do ne = 1,netmax
        kern1(ne) = 0
        kern2(ne) = 0
      enddo
c
      do ne = 1,netmax
        egexpa(ne) = 0.
        egexpc(ne) = 0.
      enddo
c
      nmax = jetmax*netmax
      call initiz(jern1,nmax)
      call initiz(jern2,nmax)
      call initiz(ngext,nmax)
      call initaz(egexjc,nmax)
      call initaz(egexjf,nmax)
      call initaz(mgext,nmax)
c
      nmax = ietmax*jetmax*netmax
      call initaz(cegexs,nmax)
      call initaz(cpgexs,nmax)
      call initaz(mrgexs,nmax)
      call initiz(ngexro,nmax)
      call initiz(ngexso,nmax)
      call initiz(ngexsa,nmax)
      call initaz(egexs,nmax)
c
      nmax = ietmax*jetmax*nertmx
      call initaz(egersi,nmax)
      call initaz(xgersi,nmax)
c
      nmax = ketmax*netmax
      call initiz(kgexsa,nmax)
      call initaz(egexw,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of special species after compression.
c
c     Get the indices of H+, OH-, Cl-, fictive aqueous O2(g), and
c     fictive aqueous e-.
c
      call gspion(narn1,narn2,nchlor,nelect,nhydr,nhydx,noutpt,
     $ no2gaq,nstmax,nttyo,uspec)
c
c     Get the index of the redox basis species.
c
c     Calling sequence substitutions:
c       nbaspd for nbasp
c       nbtd for nbt
c       ndrsrd for ndrsr
c
      call grdxsp(nbaspd,nbtd,nbtmax,nct,ndrsrd,noutpt,
     $ nrdxsp,nstmax,nttyo,uspec)
c
c     Get the basis index of water (nbw).
c
c     Calling sequence substitutions:
c       nbaspd for nbasp
c       nbtd for nbt
c       narn1 for ns
c
      nbw = nbasis(nbaspd,nbtd,nbtmax,narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Look at each active auxiliary basis species. Change the
c     corresponding log K polynomial coefficients so that log K is
c     fixed at a value of -9999999. if any other species in the
c     corresponding dissociation reaction is not in the model.
c
      call bsplkp(axlks,narxmx,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,nstmax,ntprmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the mole fractions and activities of pure solids and
c     liquids.
c
      do ns = nlrn1,nlrn2
        act(ns) = 1.
        actlg(ns) = 0.
        xbar(ns) = 1.
        xbarlg(ns) = 0.
      enddo
c
      do ns = nmrn1,nmrn2
        act(ns) = 1.
        actlg(ns) = 0.
        xbar(ns) = 1.
        xbarlg(ns) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Load coefficients for interpreting the input alkalinity, if any.
c
      ntfxt = ntf1t
      ntfxmx = ntf1mx
      do n = 1,ntf1t
        ntfx(n) = ntf1(n)
        tfx(n) = tf1(n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret input file directives to create generic ion-exchange
c     phases and species.
c
      call intexi(al10,axhfs,axlks,axvfs,cegexs,cess,cdrs,
     $ cgexj,cpgexs,egexjf,iern1,iern2,ietmax,jern1,jern2,jetmax,
     $ jflag,jgext,jpflag,jsflag,jsitex,kern1,kern2,ketmax,kgexsa,
     $ mwtges,mwtsp,narn1,narn2,narxmx,narxt,nbasp,nbt,nbtmax,ncmpr,
     $ ndrs,ndrsmx,ndrsr,ness,nessmx,nessr,netmax,net,nern1,nern2,
     $ ngexro,ngexrt,ngexsa,ngexso,ngext,noutpt,nphasx,npt,nptmax,
     $ nst,nstmax,ntprt,ntprmx,nttyo,nvetmx,rconst,tgexp,ugexj,
     $ ugexmo,ugexmv,ugexp,ugexr,ugexs,ugexsr,uhfgex,uphase,uspec,
     $ uvfgex,uxkgex,xhfgex,xlkgex,xvfgex,zchar,zgexj)
c
      if (ier .gt. 0) go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Set jflag values for the exchanger species.
c
        do ne = 1,net
          do je = 1,jgext(ne)
            nrr1 = jern1(je,ne)
            nrr2 = jern2(je,ne)
            do ns = nrr1,nrr2
c
c             Calling sequence substitutions:
c               nbaspd for nbasp
c
              nb = nbasis(nbasp,nbt,nbtmax,ns)
              if (nb .eq. 0) jflag(ns) = 30
            enddo
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Alter any log K values as directed by the input file.
c
      if (nxmod .gt. 0) then
        rtcnst = 0.001*rconst*tempk
        afcnst = al10*rtcnst
        call alters(afcnst,apresg,axlks,cdrs,kxmod,narxmx,narxt,
     $  ndrs,ndrsmx,ndrsr,noutpt,npt,nptmax,nst,nstmax,ntpr,ntprmx,
     $  nttyo,nxmdmx,nxmod,tempc,uphase,uspec,uxmod,xlkmod)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make up (z**2)/2 and (z**3)/6 for later use.
c
      do ns = 1,nst
        zx = 0.5*zchar(ns)*zchar(ns)
        zchsq2(ns) = zx
        zchcu6(ns) = (zx*zchar(ns))/3.
      enddo
c
c     Get the max norm of the electrical charges of the aqueous
c     species (izmax).
c
      call zsrt(izmax,narn1,narn2,nstmax,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret input file data which defines the indices of species
c     required to evaluate such constraints as a mean activity or a
c     heterogeneous equilibrium placed on a basis species.
c
      call intnsp(coval,covali,ier,jflag,narn1,narn2,nbasp,nbt,
     $ nbti,nbtmax,nchlor,ncosp,ndecsp,nhydr,noutpt,nst,nstmax,nttyo,
     $ ucospi,uspec)
c
      if (ier .gt. 0) go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (neti .gt. 0) then
c
c       Interpret input file data for concentrations and compositions
c       of generic ion exchange phases.
c
        call intge3(cgexp,cgexpi,ier,iern1,iern2,ietmax,jern1,
     $  jern2,jetmax,jgext,jgexti,net,neti,netmax,ngexpi,ngexti,
     $  noutpt,nptmax,nstmax,nttyo,ugexj,ugexji,ugexp,ugexpi,ugexsi,
     $  uphase,uspec,xbar,xbarlg,xgexsi)
c
        if (ier .gt. 0) go to 20
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Set default values for the concentrations (mol/kg.H2O) of
c       generic exchange phases. These values represent trace amounts.
c       Currently, the default concentration of an exchanger phase
c       is 1.e-12 molal.
c
        do ne = 1,net
          if (cgexp(ne) .le. 0.) cgexp(ne) = 1.e-12
        enddo
c
c       Map the concentrations of generic exchange phases into the
c       coval array. Set correpsonding values in the mtb, moph, and
c       loph arrays.
c
        do nb = 1,nbt
          ns = nbasp(nb)
          if (ns.ge.nern1 .and. ns.le.nern2) then
            np = nphasx(ns)
            ne = np - iern1 + 1
            coval(nb) = cgexp(ne)
            mtb(nb) = cgexp(ne)
            moph(np) = cgexp(ne)
            loph(np) = tlg(moph(np))
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret input file data for compositions of solid solutions.
c     file.
c
      if (iopt(4).ge.1 .and. nxti.gt.0) then
        call intinx(ier,ixrn1,ixrn2,ncmpr,ncmpri,noutpt,npnxp,
     $  nptmax,nstmax,nttyo,nxicmx,nxti,nxtimx,umemi,uphase,usoli,
     $  uspec,xbar,xbari,xbarlg)
c
        if (ier .gt. 0) go to 20
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that no species in the strict basis has a jflag
c     value of 30 at this point.
c
      nerr = 0
      do nb = 1,nbt
        ns = nbasp(nb)
        nt = ndrsr(2,ns) - ndrsr(1,ns) + 1
        if (nt .lt. 2) then
          if (jflag(ns) .eq. 30) then
c
c           Calling sequence substitutions:
c             uspec(ns) for unam48
c
            call fmspnm(jlen,uspec(ns),uspn56)
            write (noutpt,1240) uspn56(1:jlen)
            write (nttyo,1240) uspn56(1:jlen)
 1240       format(/' * Error - (EQ3NR/eq3nr) The strict basis species'
     $      /7x,a,' has a jflag value of 30. This implies',
     $      /7x,'that this species is to be treated as a dependent',
     $      ' species. However,',/7x,"a strict basis species can't",
     $      ' be treated in this manner.')
            nerr = nerr + 1
          endif
        endif
      enddo
c
      if (nerr .gt. 0) go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Redefine the 'd' set of reactions and attendant data to
c     match the ordinary set as it presently exists. The ordinary
c     set will be futher subjected to eliminations from the active
c     basis set and ordinary basis switching.
c
      call cdrssd(adhfs,adhfsd,advfs,advfsd,axhfs,axhfsd,
     $ axlks,axlksd,axvfs,axvfsd,cdrs,cdrsd,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,nbasp,nbaspd,nbtmax,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,
     $ nstmax,ntprmx)
      nbtd = nbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 1) then
c
c       Build the S-lambda index arrays nsxi and nsxx.
c
        call bdslx(narn1,narn2,natmax,noutpt,nslt,nsltmx,
     $  nslx,nsxi,nsxx,nsxmax,nttyo)
c
c       Build the mu index arrays nmxi and nmxx.
c
        call bdmlx(narn1,narn2,natmax,nmut,nmutmx,nmux,nmxi,
     $  nmxmax,nmxx,noutpt,nttyo)
c
        if (iopr(10) .gt. 0) then
c
c         Write tables concerning Pitzer coefficients.
c
          call ptztab(iopr,narn1,narn2,natmax,nmutmx,nmux,nmxi,
     $    nmxmax,nmxx,noprmx,noutpt,nsltmx,nslx,nstmax,nsxi,nsxmax,
     $    nsxx,uspec)
        endif
c
c       Write warnings for species lacking Pitzer coefficients.
c
        call ptzchk(narn1,narn2,natmax,nmxi,noutpt,nstmax,nsxi,
     $  nttyo,uspec)
c
c       Transform conventional mu data to corresponding C, psi,
c       and zeta data (data originally defined in mu form is
c       not affected).
c
        if (qhawep) then
          call rc3ocf(amu,jpfcmx,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $    ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,
     $    ilpsi2,ilzeta,iodb,nmux,nmut,nmutmx,nodbmx,noutpt,nstmax,
     $    nttyo,uspec,zchar)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the thermodynamic parameters that are functions of
c     temperature and pressure.
c
      call evdata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $ adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $ al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,
     $ axhfs,axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,
     $ bdhv,bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,
     $ dhfe,dhfs,dhfsd,dvfe,dvfs,dvfsd,ehfac,farad,iapxmx,iktmax,
     $ iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,ixrn2,jpfcmx,
     $ jptffl,jsol,narxmx,narxt,narxth,ncmpr,nmut,nmutmx,nopgmx,
     $ noptmx,noutpt,nptmax,nslt,nsltmx,nst,nstmax,ntpr,ntprmx,nttyo,
     $ nxt,nxtmax,pmu,prehw,presg,presh,press,pslamn,rconst,rcnstv,
     $ rtcnst,tempc,tempk,uphase,uspec,wfac,xhfe,xhfs,xhfsd,xlke,xlks,
     $ xlksd,xvfe,xvfs,xvfsd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (jpres3 .eq. 0) then
c
c       The pressure corresponds to the data file reference presssure
c       curve.
c
        press = presg
      elseif (jpres3 .eq. 1) then
c
c       The pressure corresponds to the 1.013-bar/steam-saturation
c       presssure curve.
c
        press = presh
      elseif (jpres3 .eq. 2) then
c
c       Constant pressure.
c
        continue
      else
c
c       Error.
c
        write (noutpt,1242) jpres3
        write (nttyo,1242) jpres3
 1242   format(/' * Error - (EQ3NR/eq3nr) The pressure option flag',
     $  ' (jpres3)',/7x,'has an unknown value of ',i2,'.')
      endif
c
c     Stop if the pressure isn't greater than 0.
c
      if (press .le. 0) then
        write (noutpt,1244) press
        write (nttyo,1244) press
 1244   format(/' * Error - (EQ3NR/eq3nr) The pressure must be',
     $  ' greater than zero.',/7x,'The current pressure is ',1pg12.5,
     $  ' bars.')
        stop
      endif
c
c     Stop if press is greater than presmx.
c
      if (press .gt. presmx) then
        write (noutpt,1246) press,presmx
        write (nttyo,1246) press,presmx
 1246   format(/' * Error - (EQ3NR/eq3nr) The calculated pressure is',
     $  ' ',1pg12.5,' bars,',/7x,"greater than the code's built-in",
     $  ' maximum value of ',1pg12.5,' bars.',/7x,'Other limits',
     $  ' associated with the supporting data file may also apply.')
        stop
      endif
c
c     Note if press is less than the 1.013-bar/steam-saturation curve
c     value.
c
      if ((press - presh) .lt. -1.e-4) then
        write (noutpt,1248) press,presh
        write (nttyo,1248) press,presh
 1248   format(/' * Note - (EQ3NR/eq3nr) The calculated pressure is',
     $  ' ',1pg12.5,' bars,',/7x,'less than the 1.013-bar',
     $  ' steam-saturation curve value',/7x,'of ',g12.5,' bars.')
      endif
c
c     If the pressure is nearly identical to the data file reference
c     pressure curve value, set it equal to that value.
c
      if (abs(press - presg) .le. 1.e-4) press = presg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for thermodynamic pressure corrections.
c
      dp = press - presg
      if (abs(dp) .ge. 1.e-4) then
        if (ipcv .lt. 0) then
c
c         There are no data to support needed pressure corrections.
c
          write (noutpt,1250) press,presg,dp
          write (nttyo,1250) press,presg,dp
 1250     format(/' * Warning - (EQ3NR/eq3nr) The supporting data file',
     $    /7x,'contains no data to support making thermodynamic',
     $    /7x,'pressure corrections. No such corrections will be made.',
     $    /7x,'The current pressure is ',1pg12.5,' bars, the standard',
     $    /7x,'grid pressure is ',g12.5,' bars, and the pressure',
     $    /7x,'difference is ',g12.5,' bars.')
        else
          if (press .le. 0.) then
c
c           The pressure is zero or negative.
c
            write (noutpt,1260) press
            write (nttyo,1260) press
 1260       format(/' * Error - (EQ3NR/eq3nr) The pressure must be',
     $      /7x,'greater than zero. The current pressure is ',1pg12.5,
     $      ' bars.')
            stop
          endif
          if (abs(dp) .gt. prehw) then
c
c           The pressure is outside the recommended envelope.
c
            pxu = presg + prehw
            pxl = presg - prehw
            if (pxl .le. 0.) pxl = 0.
            write (noutpt,1270) press,pxl,pxu,tempc
            write (nttyo,1270) press,pxl,pxu,tempc
 1270       format(/' * Warning - (EQ3NR/eq3nr) The current pressure',
     $      /7x,'of ',1pg12.5,' bars is outside the recommended',
     $      /7x,'pressure envelope of ',g12.5,' to ',g12.5,' bars',
     $      /7x,'at ',0pf6.2,' C.')
          endif
c
c         Make pressure corrections to the thermodynamic data.
c
          call pcorrm(adh,adhh,adhv,al10,aphi,avcnst,bdh,bdhh,bdhv,
     $    bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,
     $    dvfe,iopg,ipch,ipchmx,ipcv,ipcvmx,nopgmx,presg,press,rcnstv,
     $    tempk,xhfe,xlke,xvfe)
c
          call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $    nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $    xlks,xvfs)
c
c         Calling sequence substitutions:
c           dhfsd for dhfs
c           dvfsd for dvfs
c           nbaspd for nbasp
c           nbtd for nbt
c           ndrsrd for ndrsr
c           xhfsd for xhfs
c           xlksd for xlks
c           xvfsd for xvfs
c
          call pcorrx(avcnst,dhfsd,dvfsd,ipch,ipchmx,ipcv,ipcvmx,
     $    nbaspd,nbtd,nbtmax,ndrsrd,nst,nstmax,presg,press,xhfsd,
     $    xlksd,xvfsd)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check default redox constraints.
c
      if (irdxc3 .eq. -3) then
        continue
      elseif (irdxc3 .eq. -2) then
        continue
      elseif (irdxc3 .eq. -1) then
        continue
      elseif (irdxc3 .eq. 0) then
        continue
      elseif (irdxc3 .eq. 1) then
        continue
      else
c
c       Error.
c
        write (noutpt,1280) irdxc3
        write (nttyo,1280) irdxc3
 1280   format(/' * Error - (EQ3NR/eq3nr) The default redox option',
     $  /7x,'flag (irdxc3) has an unknown value of ',i2,'.')
        go to 20
      endif
c
c     Make sure that aqueous O2(g) was included in the list of active
c     basis species on the data file.
c
      no2gai = 0
      do nbi = 1,nbti
        nb = ndecsp(nbi)
        if (nb .gt. 0) then
          ns = nbaspd(nb)
          if (ns .eq. no2gaq) then
            no2gai = nbi
            go to 110
          endif
        endif
      enddo
  110 continue
c
      if (irdxc3 .ne.-3 .and. jflag(no2gaq).ne.0) then
        write (noutpt,1300)
 1300   format(/' * Note - (EQ3NR/eq3nr) Have conflicting redox',
     $  ' options:')
        write (noutpt,1310) irdxc3,jflag(no2gaq)
 1310   format(9x,'irdxc3 = ',i2,' overrides jflag(O2(g)) = ',i2,/)
        jflag(no2gaq) = 0
c
c       Calling sequence substitutions:
c         no2gaq for ns
c
        io2gaq = nbasis(nbasp,nbt,nbtmax,no2gaq)
        coval(io2gaq) = -99999.
        ncosp(io2gaq) = 0
        if (no2gai .gt. 0) then
          jflgi(no2gai) = 0
          covali(no2gai) = -99999.
          ucospi(no2gai)(1:48) = ' '
        endif
      endif
c
      j2 = ilnobl(uredox)
      if (irdxc3.ne.1 .and. uredox(1:5).ne.'None ' .and. j2.gt.0) then
        write (noutpt,1300)
        write (noutpt,1320) irdxc3,uredox(1:j2)
 1320   format(9x,'irdxc3 = ',i2,' overrides uredox = ',a,/)
        uredox(1:24) = 'None'
      endif
c
c     If irdxc3 .ge. 1, find the index of the species whose name is
c     uredox.
c
      nredox = 0
      if (irdxc3 .eq. 1) then
        j2 = ilnobl(uredox)
        if (j2.le.0 .or. uspec(ns)(1:4).eq.'None') then
          write (noutpt,1330)
          write (nttyo,1330)
 1330     format(/' * Error - (EQ3NR/eq3nr) The default redox state is',
     $    /7x,'controlled by a couple, but the auxiliary basis species',
     $    /7x,"which defines the couple (uredox) isn't specified on",
     $    /7x,'the input file.')
          go to 20
        else
          do nb = 1,nbt
            ns = nbasp(nb)
            if (uspec(ns)(1:24) .eq. uredox(1:24)) then
              nredox  = ns
              go to 120
            endif
          enddo
c
          write (noutpt,1340) uredox(1:j2)
          write (nttyo,1340) uredox(1:j2)
 1340     format(/' * Error - (EQ3NR/eq3nr) The default redox state is',
     $    /7x,'controlled by a couple, but the species ',a,', whose',
     $    /7x,"associated reaction defines this couple, isn't",
     $    /7x,'in the basis set, as is required.')
          go to 20
        endif
      endif
c
  120 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the total dissolved solutes option.
c
      if (itdsf3 .eq. 0) then
        continue
      elseif (itdsf3 .eq. 1) then
        continue
      else
c
c       Error.
c
        write (noutpt,1342) itdsf3
        write (nttyo,1342) itdsf3
 1342   format(/' * Error - (EQ3NR/eq3nr) The total dissolved solutes',
     $  /7x,'option flag (itdsf3) has an unknown value of ',i2,'.')
        go to 20
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the electrical balancing option.
c
      if (iebal3 .eq. 0) then
        continue
      elseif (iebal3 .eq. 1) then
        continue
      else
c
c       Error.
c
        write (noutpt,1344) iebal3
        write (nttyo,1344) iebal3
 1344   format(/' * Error - (EQ3NR/eq3nr) The electrical balancing',
     $  /7x,'option flag (iebal3) has an unknown value of ',i2,'.')
        go to 20
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set default values.
c
      qrho = rho .gt. 0.
      call dfaltx(itermx,rho,scamas,tdspkg,tdspl,tolbt,
     $ toldl,tolspf)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Echo a table for the generic ion exchangers, describing the
c       setup of species, reactions, and corresponding thermodynamic
c       data.
c
        call echgex(axlks,cdrs,cgexj,iern1,iern2,jern1,jern2,
     $  jetmax,jgext,jpflag,jsflag,narxmx,narxt,ndrs,ndrsmx,ndrsr,
     $  netmax,noutpt,nptmax,ntprmx,ntprt,nstmax,press,tempc,ugexj,
     $  ugexmo,uphase,uspec,xlks)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print an echo of the processed input.
c
      call echox(azero,cdrs,covali,eh,fo2lg,iebal3,iodb,iopg,
     $ iopr,iopt,irdxc3,itdsf3,itermx,ixrn1,ixrn2,jflag,jflgi,jpres3,
     $ narn1,narn2,nat,nata,natmax,nbt,nbta,nbti,nbtmax,nct,ncta,
     $ nctmax,ncmpr,ncosp,ndecsp,ndrs,ndrsmx,ndrsr,nelect,ngt,ngta,
     $ ngtmax,nhydr,nhydx,njfmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,
     $ nodbmx,nopgmx,noprmx,noptmx,noutpt,no2gaq,npt,npta,nptmax,
     $ nredox,nst,nsta,nstmax,nxt,nxta,nxti,nxtmax,pe,presg,press,
     $ rho,scamas,tdspkg,tdspl,tempc,tolbt,toldl,tolspf,uactop,
     $ ucospi,uebal,ujflls,uphase,uredox,uspec,uspeci,xbar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qcwrpj) then
c
c       Write tables of the Pitzer J(x) and J'(x) functions.
c
        call cwrpjt(noutpt)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Convert input concentration data not on the molal scale to
c     that scale. Convert pe, if input, to Eh.
c
      call setup(coval,eh,ehfac,ier,irdxc3,itdsf3,jflag,mwtsp,
     $ narn1,nbaspd,nbt,nbtmax,noutpt,nstmax,nttyo,pe,rho,tdspkg,
     $ tdspl,uspec)
c
      if (ier .gt. 0) go to 20
c
c     Echo input data after modification.
c
      write (noutpt,1400)
 1400 format(/21x,'--- Modified Input Constraints ---',
     $ //5x,'Species',20x,'coval   jflag   Type of Input',/)
      do nb = 1,nbt
        ns1 = nbasp(nb)
        if (jsflag(ns1) .le. 0) then
          jfl = jflag(ns1)
          j2 = ilnobl(ujflls(jfl))
c
          if (jfl.eq.17 .or. jfl.eq.18) then
            nse = ncosp(nb)
            write (noutpt,1410) uspec(ns1),coval(nb),jfl,
     $      ujflls(jfl)(1:j2)
 1410       format(2x,a24,2x,1pe12.5,2x,i2,2x,a)
            j3 = ilnobl(uspec(nse)(1:24))
            write (noutpt,1420) uspec(nse)(1:j3)
 1420       format(39x,'Counterion= ',a)
          elseif (jfl .eq. 25) then
            nse = ncosp(nb)
            write (noutpt,1422) uspec(ns1),jfl,ujflls(jfl)(1:j2)
 1422       format(2x,a24,16x,i2,2x,a)
            j3 = ilnobl(uspec(nse)(1:24))
            ux24 = uspec(nse)(25:48)
            j4 = ilnobl(ux24)
            write (noutpt,1425) uspec(nse)(1:j3),ux24(1:j4)
 1425       format(46x,'Species= ',a,/48x,'Phase= ',a)
c
c           Calling sequence substitutions:
c             noutpt for nf
c             nse for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,nse,nstmax,uspec)
            write (noutpt,1426)
 1426       format(1x)
c
          elseif (jfl.eq.27 .or. jfl.eq.30) then
            write (noutpt,1422) uspec(ns1),jfl,ujflls(jfl)(1:j2)
          elseif (ns1 .eq. no2gaq) then
            write (noutpt,1427) uspec(ns1),coval(nb),jfl
 1427       format(2x,a24,2x,1pe12.5,2x,i2,2x,'Log fO2')
          else
            if (jfl .ge. 0) then
              write (noutpt,1410) uspec(ns1),coval(nb),jfl,
     $        ujflls(jfl)(1:j2)
            else
              write (noutpt,1430) uspec(ns1)
 1430         format(2x,a24,16x,'Not present in the model')
            endif
          endif
        endif
      enddo
c
      write (noutpt,1440)
 1440 format(1x)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the index of the species to be adjusted for electrical
c     balance, if any.
c
      call intieb(iebal,iebal3,ier,jsflag,nbasp,nbt,nbtmax,noutpt,
     $ nstmax,nttyo,uebal,uspec,zchar)
c
      if (ier .gt. 0) go to 20
c
      if (uebal(1:5) .ne. 'None ') then
        j2 = ilnobl(uebal)
        write (noutpt,1450) uebal(1:j2)
 1450   format(/' Electrical balance will be achieved by adjusting',
     $  /'   the concentration of ',a,'.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write a list of inactive species.
c
      write (noutpt,1470)
 1470  format(/21x,'--- Inactive Species ---',/)
c
      k = 0
      do ns = 1,nst
        if (jsflag(ns) .eq. 1) then
          if (ns .ne. no2gaq) then
            k = k + 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1480) uspec(ns)(1:j2)
 1480       format(4x,a)
          endif
        endif
      enddo
c
      if (k .le. 0) write (noutpt,1490)
 1490 format(4x,'None',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Call EQLIB/elim.f to rewrite the reaction equations (cdrs/ndrs/
c     ndrsr arrays) so that auxiliary basis variables with jflag = 30
c     are eliminated from the active basis set.
c
      qelim = .false.
      do nb = 1,nbt
        nse = nbasp(nb)
        nt = ndrsr(2,nse) - ndrsr(1,nse) + 1
        if (nt.ge.2 .and. jflag(nse).eq.30) then
          if (jsflag(nse) .gt. 0) then
            coval(nb) = 0.
          else
            qelim = .true.
            call elim(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jsflag,narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,
     $      nse,nst,nstmax,ntprmx,noutpt,nttyo,uspec)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute mass balance coefficients using the active part of the
c     original basis set.
c
      call gcsts(cdrs,csts,jflag,nbaspd,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,noutpt,nsts,nstsmx,nstsr,nst,nstmax,nttyo,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the existing nbasp array into the nbaspi array. The
c     main purpose of this is to recall what the basis set was
c     when mass balance relationships were defined. In particular,
c     this array holds the basis set as it was prior to the switching
c     out of bare exchangerspecies. This information will be used
c     in describing mass balance totals. In particular, it will be
c     needed to write the pickup file.
c
      do nb = 1,nbt
        nbaspi(nb) = nbasp(nb)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Switch bare site species of generic ion exchange phases with
c       certain models such as Gapon and Vanselow out of the basis set.
c       Then suppress these bare site species so that they appear in the
c       model only in association with corresponding mass balances.
c       Changes are made here to the ion exchanger sections of both the
c       ordinary and the 'd' sets of reactions and associated data.
c
        call chsgex(adhfs,adhfsd,adhfsx,advfs,advfsd,advfsx,
     $  axhfs,axhfsd,axhfsx,axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx,
     $  cdrs,cdrsd,cdrsx,eps100,iern1,ipch,ipchmx,ipcv,ipcvmx,jern1,
     $  jetmax,jflag,jgext,jsflag,narn1,narxmx,narxt,nbasp,nbaspd,
     $  nbaspx,nbt,nbtmax,nbw,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ndrsrx,
     $  ndrsx,nern1,nern2,net,netmax,ngext,noutpt,nphasx,nst,nstmax,
     $  ntprmx,ntprt,nttyo,qbassw,qbswok,ugexmo,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the present configuration of the jflag array. This will
c     be used to support calculation of saturation indices and
c     affinities for the 'd' set of reactions.
c
      call copyia(jflag,jflagd,nbtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute any ordinary basis switching directives from the input
c     file.
c
      kobswt = 0
      if (nobswt .gt. 0) then
c
c       Copy the existing nbasp set into the nbaspx array.
c
        call copyia(nbasp,nbaspx,nbt)
c
c       Interpret the switches.
c
        call intbsw(nbasp,nbaspx,nbt,nbtmax,nobswt,noutpt,nst,
     $  nstmax,nttyo,uobsw,uspec)
c
c       Execute the switches.
c
        do nb = 1,nbt
          ns1 = nbaspx(nb)
          ns2 = nbasp(nb)
          if (ns1 .ne. ns2) then
            call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $      nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $      ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
            kobswt = kobswt + 1
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the ixbasp and cjbasp arrays. The former is a flag
c     array, each member of which denotes whether the
c     thermodynamic activity of the corresponding basis species
c     is defined in terms of molality (= 0) or mole fraction (= 1).
c     The cjbasp array contains any site stoichiometric factors
c     associated with the operational basis species.
c
      call gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $ jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $ netmax,nphasx,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Call lambda to compute activity coefficients for components of
c     solid solutions for which compositions were specified on the
c     input file.
c
      if (iopt(4).ge.1 .and. nxti.gt.0) then
        do np = ixrn1,ixrn2
c
c         Calling sequence substitutions:
c           acflg for acflgc
c
          call lambda(acflg,afcnst,bpx,ibpxmx,ibpxt,iktmax,ixrn1,
     $    ixrn2,jsol,ncmpr,noutpt,np,nptmax,nstmax,nttyo,nxtmax,wfac,
     $    xbar,xbarlg,uphase,uspec)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find which of HCO3- and CO3-- is in the basis set. If both are
c     in the basis set (potentially a bad situation), take the first.
c
      ncarb = 0
      do nb = 1,nbt
        ns = nbasp(nb)
        if (uspec(ns)(1:6).eq.'HCO3- ' .or.
     $    uspec(ns)(1:6).eq.'CO3-- ') then
          icarb = nb
          ncarb = ns
          go to 210
        endif
      enddo
  210 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the input file for inconsistencies and errors.
c     Here ier accumulates the number of errors caught.
c
      call chkinx(cdrs,coval,ier,irdxc3,jflag,jsflag,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,nhydr,
     $ nhydx,noutpt,no2gaq,nredox,nstmax,nttyo,tempc,ucospi,uredox,
     $ uspec,zchar)
c
      if (ier .ge. 1) then
        write (noutpt,1510) ier
        write (nttyo,1510) ier
 1510   format(/' * Error - (EQ3NR/eq3nr) The input has failed ',i4,
     $  ' checks.')
        go to 20
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the input value of the alkalinity, if any.
c
      alki = 0.
      if (ncarb .gt. 0) then
        jfl = jflag(ncarb)
        if (jfl .eq. 7) alki = coval(icarb)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute equilibrium constants, etc., for the ordinary set
c     if the reactions have been modified by elimination of
c     auxiliary basis species or by basis switching. The presence
c     of generic ion exchangers (net > 0) implies intrinsic or
c     hidden basis switching.
c
      if (qelim .or. kobswt.gt.0 .or. net.gt.0) then
c
        call evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $  ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $  tempc,xhfs,xlks,xvfs)
c
        if (ipcv .ge. 0) then
          call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $    nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $    xlks,xvfs)
        endif
      endif
      kobswt = 0
c
c     Recompute equilibrium constants, etc., for the 'd' set
c     if generic ion exchangers are present. If so, the subset
c     of the 'd' set reactions dealing with such exchangers
c     was modified above by the call to EQLIB/chsgex.f.
c
      if (net .gt. 0) then
c
c       Calling sequence substitutions:
c         adhfsd for adhfs
c         advfsd for advfs
c         axhfsd for axhfs
c         axlksd for axlks
c         axvfsd for avhfs
c         dhfsd for dhfs
c         dvfsd for dvfs
c         xhfsd for xhfs
c         xlksd for xlks
c         xvfsd for xvfs
c
        call evdatr(adhfsd,advfsd,axhfsd,axlksd,axvfsd,dhfsd,dvfsd,
     $  ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $  tempc,xhfsd,xlksd,xvfsd)
c
c       Calling sequence substitutions:
c         dhfsd for dhfs
c         dvfsd for dvfs
c         nbaspd for nbasp
c         nbtd for nbt
c         ndrsrd for ndrsr
c         xhfsd for xhfs
c         xlksd for xlks
c         xvfsd for xvfs
c
        if (ipcv .ge. 0) then
          call pcorrx(avcnst,dhfsd,dvfsd,ipch,ipchmx,ipcv,ipcvmx,
     $    nbaspd,nbtd,nbtmax,ndrsrd,nst,nstmax,presg,press,xhfsd,
     $    xlksd,xvfsd)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(2) .ge. 1) then
        ilevel = iopr(2)
c
c     Calling sequence substitutions:
c       noutpt for nf
c
        call echolk(axlks,cdrs,ilevel,jsflag,narxmx,ndrs,ndrsmx,
     $  ndrsr,noutpt,nst,ntprmx,nstmax,presg,tempc,uspec,xlks)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the jcsort, jjsort, jssort, and jgsort arrays by
c     setting each element equal to its index.
c
      call initii(jcsort,nst)
      call initii(jjsort,nst)
      call initii(jssort,nst)
      call initii(jgsort,ngt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the cdrw array. This provides a fast way to get the
c     reaction coefficient of H2O (Aqueous solution) in any reaction.
c
      call gcdrw(cdrs,cdrw,narn1,ndrs,ndrsmx,ndrsr,nst,nstmax)
c
c     The cdrtw array is not actually used by EQ3NR, only EQ6.
c     It is included here for the sake of consistency.
c
      call gcdrtw(cdrs,cdrtw,narn1,narn2,ndrs,ndrsmx,ndrsr,
     $ nelect,no2gaq,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1520)
 1520 format(/' - - BEGIN ITERATIVE CALCULATIONS  - - - - - - - - - -',
     $ ' - - - - - - - - - - - -',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the matrix structure (key index array iindx1) for hybrid
c     Newton-Raphson iteration and compute starting values of the matrix
c     variables.
c
      call arrset(aamatr,abar,acflg,acflgo,act,actlg,adh,
     $ adhh,adhv,adhfs,adhfsx,advfs,advfsx,afcnst,alpha,al10,
     $ amtb,aphi,avcnst,azero,a3bar,a3bars,axhfs,axhfsx,axlks,
     $ axlksx,axvfs,axvfsx,bacfmx,bbig,bdh,bdhh,bdhv,bdot,bdoth,
     $ bdotv,beta,betamx,bfac,bgamx,bneg,bpx,bsigmm,bfje,bfxi,
     $ cco2,cdrs,cdrsx,cdrtw,cdrw,cegexs,cgexj,cjbasp,cnufac,
     $ conc,conclg,coval,cpgexs,csts,delam,delvec,dgpit,dhfs,
     $ dlogxw,dpelm,dpslm,dselm,dvfs,efac,egexjc,egexjf,egexs,
     $ eh,ehfac,elam,eps100,fje,fjeo,fo2,fo2lg,fsort,fugac,fugalg,
     $ fxi,fxio,gmmatr,gpit,ibetmx,ibpxt,ibswx,iction,iebal,ielam,
     $ iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,
     $ ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,ilcphi1,ilcphi2,
     $ ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,
     $ insgf,iopg,iodb,iopt,ipch,ipcv,ipivot,ipndx1,irdxc3,istack,
     $ ixbasp,ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,
     $ jgsort,jgstak,jjndex,jjsort,jpflag,jsflag,jsitex,jsol,
     $ jssort,jstack,ka1,kat,kbt,kct,kction,kdim,kebal,kelect,
     $ ker,ke1,ket,khydr,kkndex,km1,ko2gaq,kwater,kx1,kxt,loph,
     $ losp,lsort,mgext,moph,mosp,mrgexs,mtb,nalpha,napt,narn1,
     $ narn2,narxt,nbasp,nbaspd,nbaspx,nbt,nbtd,nbti,nbw,nchlor,
     $ ncmpr,ncosp,nct,ndecsp,ndrs,ndrsx,ndrsr,ndrsrd,ndrsrx,
     $ nelect,nern1,nern2,net,nfac,ngexsa,ngext,ngrn1,ngrn2,ngt,
     $ nhydr,nhydx,nmut,nmux,nmxi,nmxx,noutpt,no2gaq,nphasx,npt,
     $ nredox,nslt,nslx,nst,nsts,nstsr,nsxi,nsxx,ntfx,ntfxt,ntpr,
     $ nttyo,omega,omeglg,palpha,pe,pelm,pmu,presg,press,pslamn,
     $ pslm,qbassw,qchlor,qhawep,qpit75,qredox,q6mode,rhsvec,selm,
     $ sigmam,sigmmo,smp100,tempc,tempk,tfx,ubacmx,ubbig,ubgamx,
     $ ubneg,ubetmx,ucospi,ugexj,ugexmo,ujflls,uphase,uspec,
     $ uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,xbrwlc,xbrwlg,
     $ xhfs,xlke,xlks,xvfs,zchar,zchsq2,zchcu6,zgexj,zvclg1,zvec1)
c
      if (ker .ge. 2) go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the matrix position of HCO3- or CO3--, if any.
c
      kcarb = 0
      if (ncarb .gt. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. ncarb) then
            kcarb = kcol
            go to 220
          endif
        enddo
  220   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the speciation-solubility model.
c
      write (noutpt,1600)
      write (nttyo,1600)
 1600 format(/,' Starting hybrid Newton-Raphson iteration.',/)
c
      call newton(aamatr,abar,acflg,acflgo,act,actlg,actwlc,
     $ adh,adhh,adhv,afcnst,alpha,al10,amtb,aphi,azero,a3bar,a3bars,
     $ bacfmx,bbig,beta,betamx,betao,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ bfje,bfxi,bgamx,bneg,bpx,bsigmm,cco2,cdrs,cdrtw,cdrw,cegexs,
     $ cgexj,cjbasp,cnufac,conc,conclg,coval,cpgexs,csts,delam,
     $ delmax,delvco,delvec,dgpit,dlogxw,dpelm,dpslm,dselm,egexjc,
     $ egexjf,egexs,eh,ehfac,elam,eps100,fje,fjeo,fo2,fo2lg,fsort,
     $ fugac,fugalg,fxi,fxio,gmmatr,gpit,ibpxt,idelmx,iebal,ielam,
     $ ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,
     $ ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,insgf,
     $ iodb,iopg,ipivot,ipndx1,irdxc3,istack,iter,itermx,ixbasp,
     $ ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,jgsort,
     $ jgstak,jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,loph,
     $ losp,lsort,mgext,moph,mosp,mrgexs,mtb,nalpha,napt,narn1,
     $ narn2,nbasp,nbt,nbw,nchlor,ncmpr,ncosp,ndrs,ndrsr,nelect,
     $ nern1,nern2,net,ngexsa,ngext,ngrn1,ngrn2,ngt,nhydr,nmut,nmux,
     $ nmxi,nmxx,noutpt,no2gaq,nphasx,npt,nredox,nslt,nslx,nst,nsts,
     $ nstsr,nsxi,nsxx,ntfx,ntfxt,nttyo,omega,omeglg,palpha,pelm,
     $ pmu,press,pslamn,pslm,qhawep,qpit75,qredox,q6mode,rhsvec,
     $ screwd,screwn,selm,sigmam,sigmmo,tempk,tfx,tolbt,toldl,ubacmx,
     $ ubbig,ubetmx,ubgamx,ubneg,ugexj,ugexmo,ulbeta,uldel,uphase,
     $ uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,xbrwlc,
     $ xbrwlg,xlke,xlks,zchar,zchsq2,zchcu6,zgexj,zvclg1,zvec1)
c
      if (ier .gt. 0) then
        write (noutpt,1610)
        write (nttyo,1610)
 1610   format(/' * Error - (EQ3NR/eq3nr) Hybrid Newton-Raphson',
     $  ' iteration failed')
        ux8a = ' '
        write (ux8a,1620) iter
 1620   format(i7)
        call lejust(ux8a)
        j2 = ilnobl(ux8a)
        if (ier. eq. 1) then
          write (noutpt,1630) ux8a(1:j2)
          write (nttyo,1630) ux8a(1:j2)
 1630     format(7x,'after ',a,' iterations because a zero matrix',
     $    ' was encountered. This is',/7x,'probably due to a',
     $    ' programming error.')
        elseif (ier .eq. 2) then
          write (noutpt,1640) ux8a(1:j2)
          write (nttyo,1640) ux8a(1:j2)
 1640     format(7x,'after ',a,' iterations because a non-zero,',
     $    ' computationally singular',/7x,'matrix was encountered.')
        elseif (ier .eq. 3) then
          write (noutpt,1650) ux8a(1:j2)
          write (nttyo,1650) ux8a(1:j2)
 1650     format(7x,'after ',a,' iterations because the code',
     $    ' detected that',/7x,'iteration was diverging.')
        elseif (ier .eq. 4) then
          write (noutpt,1660) ux8a(1:j2)
          write (nttyo,1660) ux8a(1:j2)
 1660     format(7x,'after ',a,' iterations because the maximum',
     $    ' number of iterations',/7x,'was done.')
        else
          ux8b = ' '
          write (ux8b,1620) ier
          call lejust(ux8b)
          j3 = ilnobl(ux8b)
          write (noutpt,1670) ux8a(1:j2),ux8b(1:j3)
          write (nttyo,1670) ux8a(1:j2),ux8b(1:j3)
 1670     format(7x,'after ',a,' iterations because an unknown event',
     $    ' occurred. The ier',/7x,'error code has the unknown value',
     $    ' ',a,'. This condition is a',/7x,'programming error.')
        endif
c
        call ndiagx(delmax,delvec,eps100,idelmx,iebal,iindx1,
     $  irdxc3,jflag,kcarb,kebal,khydr,kmax,ko2gaq,nbasp,nbtmax,nhydr,
     $  noutpt,nstmax,nttyo,screwd,uspec)
        go to 20
      endif
c
      write (noutpt,1690) iter
      write (nttyo,1690) iter
 1690 format('   Done. Hybrid Newton-Raphson iteration converged in ',
     $ i3,' iterations.',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the jflag value of the species being adjusted for electrical
c     balance.
c
      jfleba = 0
      if (iebal .gt. 0) then
        ns = nbaspd(iebal)
        jfleba = jflag(ns)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset jflag values which are not 0 or 30 to one of these values.
c     Species for which jflag will be set to 0 now have associated
c     mass balance totals, those for which jflag will be set to 30
c     do not.
c
      if (nredox .ge. 1) jflag(nredox) = 0
c
      do nb = 1,nbt
        ns = nbasp(nb)
        jflgi(nb) = jflag(ns)
        if (jflgi(nb) .eq. 27) jflgi(nb) = 30
        if (jflag(ns) .ne. 30) jflag(ns) = 0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the weights (actually, the masses) of total dissolved
c     solutes, the solvent, and the solution, and also some related
c     quantities. Also get the solution density (rhowc) from the
c     WIPP brine density model if the temperature lies in the range
c     20-30 C. This model is a fit to NaCl solution data having
c     the form:
c
c       density (g/L) = a + b x TDS (g/L)
c
c     where a = 1000.96 and b = 0.639963. Also get the molarity/
c     molality conversion ratio (mrmlra, molarity = mrmlra x molality)
c     and its inverse.
c
      call gwdenp(adwipp,bdwipp,jcsort,mlmrra,mosp,mrmlra,
     $ mwtsp,narn1,narn2,nstmax,qdwipp,rhoc,rhowc,tdsgks,tdsglw,
     $ tdspkc,tdsplc,tempc,vosol,wfh2o,wftds,wkgwi,woh2o,
     $ wosol,wotds)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check potential difference between input and calculated
c     densities.
c
      if (rho.gt.0. .and. rhoc.gt.0.) then
        axx = abs((rhoc - rho)/rho)
        if (axx .gt. 0.01) then
          write (ux16a,'(1pg12.5)') rhoc
          call lejust(ux16a)
          j1 = ilnobl(ux16a)
          write (ux16b,'(1pg12.5)') rho
          call lejust(ux16b)
          j2 = ilnobl(ux16b)
          write (noutpt,1720) ux16a(1:j1),ux16b(1:j2)
          write (nttyo,1720) ux16a(1:j1),ux16b(1:j2)
 1720     format(/' * Warning - (EQ3NR/eq3nr) The calculated density',
     $    ' of ',a,' g/mL',/7x,'differs from the input file/default',
     $    ' value of ',a,' g/mL',/7x,'by more than 1%.',
     $    ' The calculated value will be used',/7x,'in subsequent',
     $    ' calculations.')
        endif
      endif
c
c     Check potential difference between input and calculated
c     TDS values.
c
      if (itdsf3 .le. 0) then
        if (tdspkg.gt.0. .and. tdspkc.gt.0.) then
          axx = abs((tdspkg - tdspkc)/tdspkc)
          if (axx .gt. 0.01) then
            write (ux16a,'(1pg12.5)') tdspkc
            call lejust(ux16a)
            j1 = ilnobl(ux16a)
            write (ux16b,'(1pg12.5)') tdspkg
            call lejust(ux16b)
            j2 = ilnobl(ux16b)
            write (noutpt,1730) ux16a(1:j1),ux16b(1:j2)
            write (nttyo,1730) ux16a(1:j1),ux16b(1:j2)
 1730       format(/' * Warning - (EQ3NR/eq3nr) The calculated TDS',
     $      ' of ',a,' mg/kg.sol',/7x,'differs from the input',
     $      ' file/default value of ',a,' mg/kg.sol',/7x,'by more',
     $      ' than 1%. The calculated value will be used in',
     $      /7x,'subsequent calculations.')
          endif
        elseif (tdspkg.le.0. .and. tdspkc.gt.0.) then
          write (ux16a,'(1pg12.5)') tdspkc
          call lejust(ux16a)
          j1 = ilnobl(ux16a)
          write (ux16b,'(1pg12.5)') tdspkg
          call lejust(ux16b)
          j2 = ilnobl(ux16b)
          write (noutpt,1732) ux16a(1:j1),ux16b(1:j2)
          write (nttyo,1732) ux16a(1:j1),ux16b(1:j2)
 1732     format(/' * Warning - (EQ3NR/eq3nr) The calculated TDS',
     $    ' of ',a,' mg/kg.sol',/7x,'differs from the input',
     $    ' file/default value of ',a,' mg/kg.sol.',/7x,
     $    'The calculated value will be used in subsequent',
     $    ' calculations.')
        endif
      else
        if (tdspl.gt.0. .and. tdsplc.gt.0.) then
          axx = abs((tdspl - tdsplc)/tdsplc)
          if (axx .gt. 0.01) then
            write (ux16a,'(1pg12.5)') tdsplc
            call lejust(ux16a)
            j1 = ilnobl(ux16a)
            write (ux16b,'(1pg12.5)') tdspl
            call lejust(ux16b)
            j2 = ilnobl(ux16b)
            write (noutpt,1740) ux16a(1:j1),ux16b(1:j2)
            write (nttyo,1740) ux16a(1:j1),ux16b(1:j2)
 1740       format(/' * Warning - (EQ3NR/eq3nr) The calculated TDS',
     $      ' of ',a,' mg/L',/7x,'differs from the input',
     $      ' file value of ',a,' mg/L',/7x,'by more',
     $      ' than 1%. The calculated value will be used in',
     $      /7x,'subsequent calculations.')
          endif
        elseif (tdspl.le.0. .and. tdsplc.gt.0.) then
          write (ux16a,'(1pg12.5)') tdsplc
          call lejust(ux16a)
          j1 = ilnobl(ux16a)
          write (ux16b,'(1pg12.5)') tdspl
          call lejust(ux16b)
          j2 = ilnobl(ux16b)
          write (noutpt,1742) ux16a(1:j1),ux16b(1:j2)
          write (nttyo,1742) ux16a(1:j1),ux16b(1:j2)
 1742     format(/' * Warning - (EQ3NR/eq3nr) The calculated TDS',
     $    ' of ',a,' mg/L',/7x,'differs from the input',
     $    ' file/default value of ',a,' mg/L.',/7x,
     $    'The calculated value will be used in subsequent',
     $    ' calculations.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If there is a density calculated from the WIPP brine density
c     model, use it as the density in subsequent calculations. If not
c     and a density value greater than zero was entered on the
c     input file, use the input value.
c
      if (qdwipp) then
        qrho = .true.
        rho = rhoc
        tdspkg = tdspkc
        tdspl = tdsplc
      elseif (qrho) then
        mrmlra = 0.001*wfh2o*rho
        mlmrra = 1./mrmlra
      endif
      if (.not.qrho) rho = 0.0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute mass balance totals for chemical elements.
c
      do nc = 1,nctmax
        mte(nc) = 0.
        mteaq(nc) = 0.
        cteaq(nc) = 0.
      enddo
c
      do nss = narn1,narn2
        ns = jcsort(nss)
        if (jsflag(ns) .le. 0) then
          nr1 = nessr(1,ns)
          nr2 = nessr(2,ns)
          do n = nr1,nr2
            nc = ness(n)
            mteaq(nc) = mteaq(nc) + cess(n)*mosp(ns)
          enddo
        endif
      enddo
c
      do nc = 1,nct
        mte(nc) = mteaq(nc)
        cteaq(nc) = wkgwi*mteaq(nc)
        ppmwe(nc) = 1000.*cteaq(nc)*atwt(nc)*wfh2o
      enddo
c
      do nss = nern1,nern2
        ns = jcsort(nss)
        if (jsflag(ns) .le. 0) then
          nr1 = nessr(1,ns)
          nr2 = nessr(2,ns)
          do n = nr1,nr2
            nc = ness(n)
            if (nc .gt. 0) mte(nc) = mte(nc) + cess(n)*mosp(ns)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute mass balance totals for active basis species.
c
      do nb = 1,nbtmax
        mtb(nb) = 0.
        mtbaq(nb) = 0.
        ctb(nb) = 0.
      enddo
c
      do nss = narn1,narn2
        ns = jcsort(nss)
        if (jsflag(ns) .le. 0) then
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            mtbaq(nb) = mtbaq(nb) + csts(n)*mosp(ns)
          enddo
        endif
      enddo
c
      do nb = 1,nbt
        mtb(nb) = mtbaq(nb)
        ctb(nb) = wkgwi*mtbaq(nb)
      enddo
c
      do nss = nern1,nern2
        ns = jcsort(nss)
        if (jsflag(ns) .le. 0) then
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            mtb(nb) = mtb(nb) + csts(n)*mosp(ns)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute apparent "whole-phase" equivalent fractions and mole
c     fractions of the exchange ions present in generic ion exchanger
c     phases. Cations and anions are treated separately in these
c     calculations.
c
      call gegexw(cegexs,egexpc,egexpa,egexw,iern1,iern2,
     $ ietmax,jern1,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $ mosp,netmax,ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,
     $ xgexw,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the flag array which marks if compositions are known
c     which maximize the affinities of the phases. Here assume that
c     this is the case for all phases except solid solutions. The
c     compositions for these phases will be determined by EQLIB/hpsat.f,
c     which will be called below by scripx.f. Note that input solid
c     solution compositions do not in general maximize the affinities.
c     Thus, they don't count here.
c
      do np = 1, npt
        qxknph(np) = .true.
      enddo
      do np = ixrn1,ixrn2
        qxknph(np) = .false.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the computed description of the aqueous solution.
c
      call scripx(abar,acflg,act,actlg,adh,afcnst,affpd,
     $ affsd,ahrc,alki,apx,atwt,a3bar,a3bars,bpx,cdrsd,cegexs,
     $ cess,conc,conclg,coval,csts,ctb,cteaq,egexjc,egexjf,egexpa,
     $ egexpc,egexs,egexw,ehfac,ehrc,eps100,eh,farad,fje,fo2,fo2lg,
     $ fo2lrc,fugac,fugalg,fxi,iapxmx,ibpxmx,iebal,iern1,iern2,ietmax,
     $ igas,iktmax,iopg,iopr,iopt,ilrn1,ilrn2,imrn1,imrn2,ixrn1,
     $ ixrn2,jcsort,jern1,jern2,jetmax,jflag,jflagd,jflgi,jfleba,jgext,
     $ jgsort,jpflag,jsflag,jsol,jsomax,kern1,kern2,ketmax,kgexsa,
     $ mlmrra,mrmlra,moph,mosp,mte,mteaq,mwtsp,narn1,narn2,natmax,
     $ nbasp,nbaspd,nbt,nbtmax,nchlor,ncmpr,nct,nctmax,ndrsd,ndrsmx,
     $ ndrsrd,nelect,ness,nessmx,nessr,net,neti,netmax,ngexpi,ngexsa,
     $ ngext,ngrn1,ngrn2,ngt,ngtmax,nhydr,nhydx,nopgmx,noprmx,noptmx,
     $ noutpt,no2gaq,npnxp,npt,nptmax,nrdxsp,nst,nstmax,nsts,nstsmx,
     $ nstsr,ntf1,ntf1mx,ntf1t,ntf2,ntf2mx,ntf2t,nttyo,nxrn1,nxrn2,
     $ nxt,nxti,nxtimx,nxtmax,omega,pe,perc,ppmwe,qrho,qxknph,rho,
     $ rhoc,rhowc,sidrph,sidrsp,sigmam,sigzi,tdsglw,tdspkc,tdspkg,
     $ tdspl,tdsplc,tempc,tf1,tf2,tolspf,uelem,ugexj,ugexmo,uphase,
     $ uspec,uxtype,vosol,wfac,wfh2o,wftds,wkgwi,woh2o,wosol,wotds,
     $ xbar,xbarlg,xbarw,xbrwlg,xgexw,xlke,xlksd,zchar,zchcu6,zchsq2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nprob .le. 1) then
c
c       Calculate data to describe the aqueous solution in the first
c       problem on the input file as a special reactant. This defines
c       the so-called 'Fluid 2' to be described on the EQ3NR pickup
c       file under the iopt(19) = 3 option.
c
        ureac1 = 'Fluid 2'
        tempc1 = tempc
c
        do nc = 1,nct
          n = nc
          uesr1(n) = uelem(nc)
          cesr1(n) = mteaq(nc)
        enddo
        iesrt1 = nct
c
        n = 1
        ubsr1(n) = ureac1
        cbsr1(n) = -1.0
        do nb = 1,nbt
          ns = nbaspd(nb)
          if (jflag(ns) .lt. 30) then
            n = n + 1
            ubsr1(n) = uspec(ns)
            cbsr1(n) = mtbaq(nb)
          endif
        enddo
        ibsrt1 = n
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(17) .ge. 0) then
c
c       Write the pickup file.
c
c       First set up some needed data.
c
        call setpk3(electr,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $  kmt,kprs,kwater,kxt,mtb,mtbi,mtbaq,mtbaqi,narn1,narn2,nbasp,
     $  nbaspd,nbaspi,nbti,nbtmax,ndrsrd,nern1,nern2,nobswt,nstmax,
     $  ntitl,ntitl2,ntitmx,omeglg,press,pressi,scamas,sigzi,tempc,
     $  tempci,ubmtbi,uobsw,uspec,utitl,utitl2,uzveci,uzvec1,
     $  zvclgi,zvclg1)
c
        if (iopr(17) .le. 0) then
          upkfor = uinfor
        elseif (iopr(17) .eq. 1) then
          upkfor = 'W'
        elseif (iopr(17) .ge. 2) then
          upkfor = 'D'
        endif
c
        if (iopt(19) .le. 0) then
c
c         Write a normal EQ3NR pickup file. This corresponds to the
c         bottom half of a full EQ6 input file. To use this pickup
c         file in an EQ6 input file, you must concatenate it with the
c         top half. Usually this top half is extracted from an
c         existing EQ6 input file and edited as necessary.
c
          if (upkfor(1:1) .eq. 'W') then
c
c           Compact (W) format.
c
            call wr3pkw(electr,cgexj,ietmax,iopg,jetmax,jflgi,
     $      jgext,kbt,kct,kdim,kmax,kmt,kxmod,kxt,mtbi,mtbaqi,mwtges,
     $      nbti,nbtmax,net,netmax,newin,ngexrt,nobswt,nopgmx,nsbswt,
     $      ntitl2,ntitmx,nxmdmx,nxmod,qgexsh,pressi,tempci,tgexp,
     $      ubmtbi,ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,usbsw,utitl2,
     $      uvfgex,uxkgex,uxmod,uzveci,xhfgex,xlkgex,xlkmod,xvfgex,
     $      zgexj,zvclgi)
          else
c
c           Menu-style (D) format.
c
            call wr3pkd(electr,cgexj,ietmax,iopg,jetmax,jflgi,
     $      jgext,kbt,kct,kdim,kmax,kmt,kxmod,kxt,mtbi,mtbaqi,mwtges,
     $      nbti,nbtmax,net,netmax,newin,ngexrt,nobswt,nopgmx,nsbswt,
     $      ntitl2,ntitmx,nxmdmx,nxmod,qgexsh,pressi,tempci,tgexp,
     $      ubmtbi,ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,usbsw,utitl2,
     $      uvfgex,uxkgex,uxmod,uzveci,xhfgex,xlkgex,xlkmod,xvfgex,
     $      zgexj,zvclgi)
          endif
        else
c
c         Write an advanced EQ3NR pickup file. This corresponds to
c         a full EQ6 input file. There are currently three options
c         for the form and content of the top half of this file.
c         These are determined by the iopt(19) option switch. See
c         comments in EQ3NR/stpk36.f.
c
          itmxsv = itermx
c
          call stpk36(awmaxi,awmini,cbsri,cbsr1,cdac,cesri,cesr1,
     $    csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $    dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $    dlxplo,dlxprl,dlxprn,eact,ehmaxi,ehmini,fkrc,hact,iact,
     $    ibsrti,ibsrt1,iesrti,iesrt1,iktmax,imchmx,imech,iopt,itermx,
     $    ixrti,jcode,jpress,jreac,jtemp,ksplmx,ksppmx,kstpmx,modr,
     $    moffg,morr,mprphi,mprspi,nbt1mx,nctmax,ndact,ndctmx,nffg,
     $    nffgmx,noptmx,nordmx,noutpt,nprob,nprpmx,nprpti,nprsmx,
     $    nprsti,nptkmx,nrct,nrctmx,nrk,nsk,nsrt,nsrtmx,ntitl1,ntitmx,
     $    ntrymx,nttkmx,nttyo,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,
     $    o2maxi,o2mini,phmaxi,phmini,ptk,press,pressb,rkb,rxbari,
     $    sfcar,ssfcar,tempc,tempcb,tempc1,timmxi,tistti,tolsat,
     $    tolxsf,trkb,ttk,ubsri,ubsr1,ucxri,udac,uesri,uesr1,uffg,
     $    uprphi,uprspi,ureac,ureac1,utitl1,uxcat,uxopex,uxopt,vreac,
     $    ximaxi,xistti,xlkffg)
c
          itermx = itmxsv
c
          if (upkfor(1:1) .eq. 'W') then
c
c           Compact (W) format.
c
            call wr6pkw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $      dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $      dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $      dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $      ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $      iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $      jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $      kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $      mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $      nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $      nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $      nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $      ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $      nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $      pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $      tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $      ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $      ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $      usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $      uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $      xlkmod,xvfgex,zgexj,zvclgi)
          else
c
c           Menu-style (D) format.
c
            call wr6pkd(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $      dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $      dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $      dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $      ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $      iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $      jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $      kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $      mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $      nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $      nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $      nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $      ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $      nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $      pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $      tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $      ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $      ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $      usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $      uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $      xlkmod,xvfgex,zgexj,zvclgi)
          endif
c
        endif
c
        write (noutpt,1800)
        write (nttyo,1800)
 1800   format(/' The pickup file has been written.')
      else
c
        write (noutpt,1810)
        write (nttyo,1810)
 1810   format(/' No pickup file was written.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Go look for another problem on the input file.
c
      go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gsmdez(delxia,dzvc0,dzvc0s,kdim,kmax,nord,nrd1mx)
c
c     This subroutine computes smoothed or averaged derivatives of the
c     elements of the z vector. The actual derivatives (of various
c     orders) are averaged over the interval (-delxia,+delxia). The
c     base point (point 0) is at the center of this interval.
c
c     Subroutine gsmder.f performs the same function for elements of
c     the r vector.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nrd1mx
c
      integer nord,kdim
c
      real(8) dzvc0(nrd1mx,kmax),dzvc0s(nrd1mx,kmax)
c
      real(8) delxia
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,kcol,n,nmax
c
      real(8) dx,dzx
c
c-----------------------------------------------------------------------
c
c     Zero the averaged derivative arrays.
c
      nmax = nrd1mx*kmax
      call initaz(dzvc0s,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The averaged derivatives are calculated over the interval
c     (-delxia,+delxia), about the base point (point 0).
c
      dx = 2.*delxia
c
c     Calculate average derivatives for elements of the z vector.
c
      do kcol = 1,kdim
        do n = 1,nord
          dzx = dzvc0(nord,kcol)
          do k = nord - 1,n,-1
            dzx = dzvc0(k,kcol) + (dzx*dx/(nord - n + 1))
          enddo
          dzvc0s(n,kcol) = dzx
        enddo
      enddo
c
  999 continue
      end

      subroutine gaffsd(actlg,afcnst,affpd,affsd,cdrsd,jflagd,jpflag,
     $ ncmpr,ndrsd,ndrsmx,ndrsrd,npt,nptmax,nst,nstmax,qxknph,sidrph,
     $ sidrsp,uphase,uspec,xbar,xlksd)
c
c     This subroutine computes affinities and saturation indices based
c     on reactions in the 'd' set (cdrsd/ndrsd/ndrsrd arrays).
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/cdappl.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       actlg  = array of logarithms of thermodynamic activities of
c                  species
c       cdrsd  = coefficients of reactions in the 'd' set
c       ndrsd  = indices of species appearing in reactions in the
c                  'd' set
c       ndrsrd = range pointer array for the ndrsd array
c       xbar   = mole fraction of a species in the phase to which
c                  it belongs
c       xlksd  = logarithms of equilibrium constants for reactions
c                  in the 'd' set
c       qxknph = flag indicating if the composition of the phase is
c                  known; this is the composition which maximizes the
c                  affinity (the actual composition if the phase is
c                  in equilibrium with the aqueous solution)
c
c     Principal output:
c
c       affsd  = affinities of reactions in the 'd' set for the
c                  dissociation or dissolution of species
c       affpd  = affinities for the dissolution of phases, based on
c                  reactions in the 'd' set
c       sidrsp = saturation indices (log Q/K) of reactions in the 'd'
c                  set for the dissociation or dissolution of species
c       sidrph = saturation indices of phases, based on reactions in
c                  the 'd' set
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nptmax,nstmax
c
      integer jflagd(nstmax),jpflag(nptmax),
     $ ncmpr(2,nptmax),ndrsd(ndrsmx),ndrsrd(2,nstmax)
      integer npt,nst
c
      logical qxknph(nptmax)
c
      character(len=48) uspec(nstmax)
      character(len=24) uphase(nptmax)
c
      real(8) actlg(nstmax),affpd(nptmax),affsd(nstmax),cdrsd(ndrsmx),
     $ sidrph(nptmax),sidrsp(nstmax),xbar(nstmax),xlksd(nstmax)
      real(8) afcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer np,nr1,nr2,ns,nt
c
c-----------------------------------------------------------------------
c
c     Compute affinities and saturation indices for reactions in the
c     'd' set.
c
      call gafsir(actlg,afcnst,affsd,cdrsd,jflagd,ndrsd,ndrsmx,
     $ ndrsrd,nst,nstmax,sidrsp,uspec,xlksd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute affinities and saturation indices for phases.
c
      do np = 1,npt
        affpd(np) = 0.
        sidrph(np) = 0.
        if (jpflag(np) .lt. 2) then
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .eq. 1) then
            affpd(np) = affsd(nr1)
            sidrph(np) = sidrsp(nr1)
          else
            if (qxknph(np)) then
c
c             The composition of the phase is known.
c
              do ns = nr1,nr2
                sidrph(np) = sidrph(np) + xbar(ns)*sidrsp(ns)
              enddo
              affpd(np) = afcnst*sidrph(np)
            else
c
c             The composition of the phase is not known.
c
              affpd(np) = -9999999.
              sidrph(np) = -9999999.
            endif
          endif
        endif
      enddo
c
      end

      subroutine corrfd(delxi,dxsm11,fdlim,fdre0,fdre1,fdri0,
     $ fdri1,fdrr0,fdrr1,iodb,iopt,jreac,nodbmx,noptmx,nord,
     $ nordmx,noutpt,npts,nrct,nrctmx,nrd1mx,rirec0,rirec1,
     $ rreac0,rreac1,rrelr0,rrelr1)
c
c     This subroutine computes finite differences for use in ODE
c     corrector iteration. These finite differences are based at the
c     new point stepped to, as opposed to the point stepped from.
c     Finite differences based on the point stepped from are used to
c     generate predictor functions. Those finite differences are
c     computed by EQ6/stepfd.f and comprise a larger set. Here finite
c     differences are computed only for rate functions.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,noptmx,nordmx,nrctmx,nrd1mx
c
      integer noutpt
c
      integer iodb(nodbmx),iopt(noptmx),jreac(nrctmx)
c
      integer nord,npts,nrct
c
      real*8 dxsm11(nrd1mx),fdre0(nordmx,nrctmx),fdre1(nordmx,nrctmx),
     $ fdri0(nrd1mx),fdri1(nrd1mx),fdrr0(nrd1mx,nrctmx),
     $ fdrr1(nrd1mx,nrctmx)
c
      real*8 rreac0(nrctmx),rreac1(nrctmx),rrelr0(nrctmx),rrelr1(nrctmx)
c
      real*8 delxi,fdlim,rirec0,rirec1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer itrunc,j,k,nmax,nrc
c
      real*8 dfx,dfxl,dfxu
c
c-----------------------------------------------------------------------
c
      if (npts .eq. 1) then
c
c       Zero all finite differences.
c
        nmax = nrd1mx*nrctmx
        call initaz(fdrr1,nmax)
c
        if (iopt(2) .gt. 0) then
          call initaz(fdri1,nrd1mx)
c
          nmax = nrd1mx*nrctmx
          call initaz(fdre1,nmax)
        endif
c
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Overflow protection is automatically activated in the code blocks
c     below in order to run on VAX machines with a small exponent range
c     (+/- 38) for real*8.
c
      itrunc = nord
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for relative rates.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.1 .or. jreac(nrc).eq.2) then
c
c         The relative rate must be a constant zero, because no
c         reactant mass remains:
c
c           jreac =  1: exhausted
c           jreac =  2: saturated; any remaining reactant mass is
c                         converted to the corresponding product
c                         phase, so the "reactant" is effectively
c                         exhausted.
c
c         Hence the corresponding finite differences must also be
c         zero. Avoid calculating finite differences from relative
c         rate values that may by non-zero owing to convergence
c         tolerances and the like.
c
          do j = 1,nord + 1
            fdrr1(j,nrc) = 0.
          enddo
        else
c
c         The relative rate is calculated for the reactant, which
c         is actively reacting according to a rate law:
c
c           jreac =  0: set to react
c           jreac = -1: saturated, but the remaining reactant mass
c                         continues to react irreversibly
c
c         Hence calculate the finite differences.
c
          fdrr1(1,nrc) = (rrelr1(nrc) - rrelr0(nrc))/delxi
          do j = 2,nord + 1
            dfxu = fdlim*dxsm11(j)
            dfxl = -dfxu
            k = j - 1
            dfx = fdrr1(k,nrc) - fdrr0(k,nrc)
            dfx = min(dfxu,dfx)
            dfx = max(dfxl,dfx)
            if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
            fdrr1(j,nrc) = dfx/dxsm11(j)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Compute finite differences for the inverse rate.
c
        fdri1(1) = (rirec1 - rirec0)/delxi
        do j = 2,nord + 1
          dfxu = fdlim*dxsm11(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdri1(k) - fdri0(k)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdri1(j) = dfx/dxsm11(j)
        enddo
c
c       Compute finite differences for reaction rates.
c
        do nrc = 1,nrct
          if (jreac(nrc).eq.1 .or. jreac(nrc).eq.2) then
c
c           The reaction rate must be a constant zero, because no
c           reactant mass remains:
c
c             jreac =  1: exhausted
c             jreac =  2: saturated; any remaining reactant mass is
c                           converted to the corresponding product
c                           phase, so the "reactant" is effectively
c                           exhausted.
c
c           Hence the corresponding finite differences must also be
c           zero. Avoid calculating finite differences from reaction
c           rate values that may by non-zero owing to convergence
c           tolerances and the like.
c
            do j = 1,nord + 1
              fdre1(j,nrc) = 0.
            enddo
          else
c
c           The reaction rate is calculated for the reactant, which
c           is actively reacting according to a rate law:
c
c             jreac =  0: set to react
c             jreac = -1: saturated, but the remaining reactant mass
c                           continues to react irreversibly
c
c           Hence calculate the finite differences.
c
            fdre1(1,nrc) = (rreac1(nrc) - rreac0(nrc))/delxi
            do j = 2,nord + 1
              dfxu = fdlim*dxsm11(j)
              dfxl = -dfxu
              k = j - 1
              dfx = fdre1(k,nrc) - fdre0(k,nrc)
              dfx = min(dfxu,dfx)
              dfx = max(dfxl,dfx)
              if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
              if (j .le. nord) fdre1(j,nrc) = dfx/dxsm11(j)
            enddo
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (itrunc .lt. nord) then
        if (iodb(1) .ge. 1) write (noutpt,1000) itrunc
 1000   format(/' * Note - (EQ6/corrfd) Cutting the order to ',i2,
     $  /7x,'to stay within the finite difference limit.')
        nord = itrunc
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine inupt(amua,aslma,ielam,ipbt_asv,jpdblo,jpfc_asv,
     $ nad1,nalpaa,napa_asv,napta,narn1a,narn2a,nerr,nmuta,
     $ nmuta_asv,nmuxa,noutpt,nslta,nslta_asv,nslxa,nsta_asv,
     $ nttyo,palpaa,uspeca,zchara)
c
c     This subroutine reads the parameters for Pitzer's equations from
c     the data file.
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nad1      = unit number of the data1 file
c       ipbt_asv  = dimensioning variable, the number of Pitzer
c                     alpha coefficients for any cation-anion pairnts
c       jpdblo    = the Pitzer data block organization flag:
c                     -1 = classical (pre-version 8)
c                      0 = new
c       jpfc_asv  = dimensioning variable, the number of coefficients
c                     in a Pitzer parameter temperature functionientsies
c       nmuta_asv = dimensioning variable, the maximum number of species
c                     triplets for which mu coefficients are defined
c       nslta_asv = dimensioning variable, the maximum number of species
c                     pairs for which S-lambda coefficients are defined
c       zchara    = array of electrical charge numbers of the species
c                     read from the data file
c
c     Principal output:
c
c       amua   = coefficients for calculating Pitzer mu parameters
c                  as a function of temperature
c       aslma  = coefficients for calculating Pitzer S-lamnda(n)
c                  parameters as a function of temperature
c       nalpaa = pointer array giving the index of the set of alpha
c                  coeffcients for a given set of S-lambda coefficients
c       nmuta  = number of species triplets for which mu
c                  coefficients are defined
c       nmuxa  = indices of species in triplets for which mu
c                  coefficients are defined
c       nslta  = number of species pairs for which S-lambda
c                  coefficients are defined
c       nslxa  = indices of species in pairs for which S-lambda
c                  coefficients are defined
c       palpaa = array of sets of alpha coefficients
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbt_asv,jpfc_asv,napa_asv,nmuta_asv,nslta_asv,nsta_asv
c
      integer noutpt,nttyo
c
      integer nalpaa(nslta_asv),nmuxa(3,nmuta_asv),nslxa(2,nslta_asv)
c
      integer ielam,jpdblo,nad1,napta,narn1a,narn2a,nerr,nmuta,nslta
c
      character(len=48) uspeca(nsta_asv)
c
      real(8) amua(jpfc_asv,nmuta_asv),
     $ aslma(jpfc_asv,0:ipbt_asv,nslta_asv),palpaa(ipbt_asv,napa_asv),
     $ zchara(nsta_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,ja,j2,nblock,nmu,ns,nsl
c
      integer ilnobl
c
      logical qx
c
      character(len=80) uline
      character(len=24) unam1,unam2,unam3
      character(len=16) ux16
      character(len=8) uelam,uendit,ux8
c
      real(8) aax,z1,z2
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c     These need not be SAVEd.
c
      real(8), dimension(:), allocatable :: alphai
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
      ALLOCATE(alphai(ipbt_asv))
c
c-----------------------------------------------------------------------
c
      if (jpdblo .eq. -1) then
c
        if (ipbt_asv .ne. 2) then
          write (ux8,'(i5)') ipbt_asv
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1000) ux8(1:j2)
          write (nttyo,1000) ux8(1:j2)
 1000     format(/' * Error - (EQLIB/inupt) Have an illegal value',
     $    ' of ',a,' for the array',/7x,'allocation size variable',
     $    ' ipbt_asv (number of Pitzer alpha parameters',/7x,'for ',
     $    ' any cation-anion or like pair. For the classical Pitzer',
     $    /7x,'data block organization present here, this variable',
     $    ' must have',/7x,'a value of 2.')
          stop
        endif
      endif
c
c-----------------------------------------------------------------------
c
      if (jpdblo .eq. -1) then
c
c       In the "classical" Pitzer data block organization, the E-lambda
c       (E-theta) flag may be "on" or "off", as specified on the data
c       file. Read and decode this flag.
c
        uelam = ' '
        read (nad1) uline
        uelam(1:8) = uline(17:24)
        if (uelam(1:3) .eq. 'off') then
          ielam = -1
        elseif (uelam(1:3) .eq. 'on ') then
          ielam = 0
        else
          j2 = ilnobl(uelam)
          write (noutpt,1010) uelam(1:j2)
          write (nttyo,1010) uelam(1:j2)
 1010     format(/' * Error - (EQLIB/inupt) Have read an unrecognized',
     $    /7x,'value of "',a,'" for the E-lambda (E-theta) flag from',
     $    /7x,'the data file. Allowed values are "on" and "off".')
          stop
        endif
      else
c
c       In the "new" Pitzer data block organization, the E-lambda
c       flag is always "on".
c
        ielam = 0
      endif
c
c-----------------------------------------------------------------------
c
c     Read the species pairs for which S-lambda coefficients are
c     defined. These data are comprised in two superblocks.
c
      ja = 0
      nsl = 0
      do nblock = 1,2
c
c       Read a block.
c       Read the names of the species in a pair.
c
   15   read (nad1) unam1,unam2
c
c       Test for end of superblock.
c
        if (unam1(1:6) .eq. uendit(1:6)) go to 130
c
c       Increment the S-lambda species pair counter.
c
        nsl = nsl + 1
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c         unam1 for unam
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam1,uspeca)
        nslxa(1,nsl) = ns
        z1 = zchara(ns)
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c         unam2 for unam
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam2,uspeca)
        nslxa(2,nsl) = ns
        z2 = zchara(ns)
c
c       Read the temperature function coefficients for calculating
c       Pitzer S-lambda(n) parameters. Read also the associated
c       Pitzer alpha parameters.
c
        if (jpdblo .eq. -1) then
c
c         Classical Pitzer data block organization.
c
c         Read the lowest-order coefficients, which are here
c         the 25C values of the corresponding interaction
c         coefficients.
c
          read (nad1) (aslma(1,i,nsl), i = 0,2)
c
c         Read the associated alpha coefficients.
c
          read (nad1) (alphai(i), i = 1,2)
c
c         Read the higher-order coefficients, which here are
c         first and second-order temperature derivatives.
c
          do i = 0,2
            read (nad1) aslma(2,i,nsl),aslma(3,i,nsl)
          enddo
        else
c
c         New Pitzer data block organization.
c
c         Read the associated alpha coefficients.
c
          if ((z1*z2) .lt. 0.) then
c
c           Read a larger set of data for cation-anion pairs.
c
            do i = 1,ipbt_asv
              read (nad1) ux16,alphai(i)
            enddo
c
            do i = 0,ipbt_asv
              read (nad1) ux16
              do j = 1,jpfc_asv
                read (nad1) aslma(j,i,nsl)
              enddo
            enddo
          else
c
c           Read a more limited set of data for all other pair types.
c
            read (nad1) ux16
            do j = 1,jpfc_asv
              read (nad1) aslma(j,0,nsl)
            enddo
          endif
        endif
c
c       Read the block terminator.
c
        read (nad1) uline(1:72)
c
c       Test for alpha coefficient set already in the palpaa array.
c
        do j = 1,ja
          qx = .true.
          do i = 1,ipbt_asv
            aax = abs(palpaa(i,j) - alphai(i))
            if (aax .gt. 1.e-12) then
              qx = .false.
              go to 110
            endif
          enddo
  110     continue
c
          if (qx) then
c
c           Found the index to an existing alpha pair. Store this
c           index, then go process the data for another species pair.
c
            nalpaa(nsl) = j
            go to 15
          endif
        enddo
c
c       Not in the set; add it and store the index for this species
c       pair.
c
        ja = ja + 1
c
        do i = 1,ipbt_asv
          palpaa(i,ja) = alphai(i)
        enddo
        nalpaa(nsl) = ja
c
c       Go process the data for another species pair.
c
        go to 15
c
  130   continue
      enddo
c
      nslta = nsl
      napta = ja
c
      DEALLOCATE(alphai)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the species triplets for which mu coefficients are
c     defined. These data are comprised in two superblocks.
c
      nmu = 0
      do nblock = 1,2
c
c       Read a block.
c       Read the names of the species in a triplet.
c
  150   read (nad1) unam1,unam2,unam3
c
c       Test for end of superblock.
c
        if (unam1(1:6) .eq. uendit(1:6)) go to 200
c
c       Increment the mu species triplet counter.
c
        nmu = nmu + 1
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c         unam1 for unam
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam1,uspeca)
        nmuxa(1,nmu) = ns
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c         unam2 for unam
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam2,uspeca)
        nmuxa(2,nmu) = ns
c
c       Calling sequence substitutions:
c         narn1a for nrn1a
c         narn2a for nrn2a
c         unam3 for unam
c
        call srchn(narn1a,narn2a,ns,nsta_asv,unam3,uspeca)
        nmuxa(3,nmu) = ns
c
c       Read the coefficients for calculating Pitzer mu
c       parameters as a function of temperature.
c
        if (jpdblo .eq. -1) then
c
c         Classical Pitzer data block organization.
c
          read (nad1) amua(1,nmu),amua(2,nmu),amua(3,nmu)
        else
c
c         New Pitzer data block organization.
c
          read (nad1) ux16
          do j = 1,jpfc_asv
            read (nad1) amua(j,nmu)
          enddo
        endif
c
c       Read the block terminator.
c
        read (nad1) uline(1:72)
c
        go to 150
c
  200   continue
      enddo
c
      nmuta = nmu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine srchn(nrn1a,nrn2a,ns,nstmax,unam,uspeca)
c
c     This subroutine matches the species name unam with the
c     corresponding entry in the nrn1a-th through nrn2a-th range of
c     the species name array uspeca. Only the first 24 characters are
c     compared (uspeca has 48 characters, unam only 24). This
c     subroutine returns the species index ns. If there is no match,
c     ns is returned with a value of 0.
c
c     This subroutine is called by:
c
c       EQLIB/inbdot.f
c       EQLIB/inupt.f
c       EQLIB/srchne.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nrn1a  = start of the range of species to search
c       nrn2a  = end of the range of species to search
c       unam   = name of the species whose index is to be found
c       uspeca = array of species names
c
c     Principal output:
c
c       ns     = index of the species whose name is unam
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer nrn1a,nrn2a,ns
c
      character*48 uspeca(nstmax)
      character*24 unam
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
c
c----------------------------------------------------------------------
c
      do ns = nrn1a,nrn2a
        if (uspeca(ns)(1:24) .eq. unam(1:24)) go to 999
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     No match was found.
c
      ns = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine balcon(aamatr,aamgex,al10,cdrs,cjbasp,cnufac,
     $ conc,dmlge,eps100,ggmgex,iern1,ietmax,iimgex,iindx1,
     $ ixbasp,jcsort,jern1,jern2,jetmax,jjsort,jsitex,kbt,kmax,
     $ krow,narn1,narn2,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $ nern2,netmax,noutpt,nphasx,nstmax,nttyo,rhsgex,uspec,
     $ weight,xbar)
c
c     This subroutine computes a row of the EQ3NR Jacobian matrix
c     for one of the following:
c
c       Mass balance constraint
c       Charge balance (charge adjustment) constraint
c       Alkalinity balance constraint
c
c     This subroutine is not used to compute any part of the EQ6
c     Jacobian matrix.
c
c     This subroutine is called by:
c
c       EQLIB/matrix.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       conc   = array of species concentrations
c
c     Output:
c
c       aamatr = the Jacobian matrix
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ietmax,jetmax,kmax,nbtmax,ndrsmx,netmax,nstmax
c
      integer iimgex(ietmax),iindx1(kmax),ipvgex(ietmax),ixbasp(nbtmax),
     $ jcsort(nstmax),jern1(jetmax,netmax),jern2(jetmax,netmax),
     $ jjsort(nstmax),jsitex(nstmax),nbasp(nbtmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax),nphasx(nstmax)
c
      integer iern1,kbt,krow,narn1,narn2,nern1,nern2
c
      character*48 uspec(nstmax)
c
      real*8 aamatr(kmax,kmax),aamgex(ietmax,ietmax),cdrs(ndrsmx),
     $ cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),dmlge(ietmax),
     $ ggmgex(ietmax,ietmax),rhsgex(ietmax),weight(nstmax),xbar(nstmax)
c
      real*8 al10,eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icol,idim,ier,irow,je,jlen1,jlen2,kcol,nb,nbb,
     $ ne,np,nrr1,nrr2,nr1,nsc,nsi,nsj,nss
c
      logical qej,qmj,qpr,qrhsgz,qwj
c
      character*56 usp156,usp256
c
      real*8 axfc,cgxj,cxcc,cxjc,dmlgej,sumx
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      data qpr    /.false./
c
c-----------------------------------------------------------------------
c
      nb = iindx1(krow)
      nsi = nbasp(nb)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nsi.gt.narn1 .and. nsi.le.narn2) then
c
c       Have an aqueous species mass balance.
c
c       Build columns 1 through kbt.
c
        do kcol = 1,kbt
          nbb = iindx1(kcol)
          nsj = nbasp(nbb)
          sumx = 0.
c
c         First loop over aqueous species.
c
          do nss = narn1,narn2
            nsc = jcsort(nss)
            if (weight(nsc) .ne. 0.) then
              if (cnufac(nsc) .ne. 0.) then
c
c               Calling sequence substitutions:
c                 nsj for nse
c                 nsc for ns
c
                cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,nstmax)
                sumx = sumx + weight(nsc)*cxjc*cnufac(nsc)
              endif
            endif
          enddo
c
c         Do not loop over generic ion exchanger species here.
c         They do not contribute to non-exchanger mass balances
c         in EQ3NR. This is by design. The situation is different
c         in EQ6.
c
c         Complete the calculation of the current matrix element.
c
          if (nsj .eq. narn1) then
            aamatr(krow,kcol) = al10*sumx
          else
            aamatr(krow,kcol) = al10*(weight(nsj)*conc(nsj) + sumx)
          endif
        enddo
c
      elseif (nsi.ge.nern1 .and. nsi.le.nern2) then
c
c       Have a generic ion exchanger species mass balance corresponding
c       to a given exchanger phase and site.
c
        cgxj = cjbasp(nb)
c
        je = jsitex(nsi)
        np = nphasx(nsi)
        ne = np - iern1 + 1
c
c       Build columns 1 through kbt.
c
        do kcol = 1,kbt
          nbb = iindx1(kcol)
          nsj = nbasp(nbb)
          qej = nsj.ge.nern1 .and. nsj.le.nern2
          qwj = nsj .eq. narn1
          qmj = nsj.gt.narn1 .and. nsj.le.narn2
c
c         Calculate the dmlge vector for the current site/exchanger
c         phase and the current basis species. In essence,
c
c           dmlge(i,j) is partial m(i)/partial log m(j),
c
c         where i denotes a non-basis species for the current site/
c         exchanger phase and j denotes the basis species for the
c         current column index kcol. Theoretically, dmlge(j,j) could
c         also be included, but it can be obtained from a
c         straightforward calculation (as dmlgej below), in contrast
c         to the others, which must be obtained simultaneously.
c
c         Do not loop over aqueous species as non-basis species.
c         They can not contribute to this kind of mass balance,
c         because they do not contain the exchanger ligand.
c
c         Loop over all relevant generic ion exchanger species.
c         Generate an entry only for an active non-basis species.
c         In the present context of EQ3NR, this includes only
c         those exchanger species belonging to the site and phase
c         associated with the current row. The do loop immediately
c         below is over all species in the current exchanger phase
c         (e.g., runs over all species on all sites). That is done
c         to permit the use of the jcsort array. The sorting in that
c         array is over the entire phase, not by individual site.
c         The weight array filters out contributions from species
c         not in the current site in all calculations except those
c         involving the idim variable and the iimgex array. There,
c         it is necessary to check the site to which a species
c         belongs.
c
          idim = 0
          nrr1 = jern1(je,ne)
          nrr2 = jern2(je,ne)
          do nss = nrr1,nrr2
            nsc = jjsort(nss)
            if (weight(nsc) .ne. 0.) then
              if (cnufac(nsc) .ne. 0.) then
c
c               Calling sequence substitutions:
c                 nsj for nse
c                 nsc for ns
c
                cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,nstmax)
                if (cxjc .ne. 0.) then
                  idim = idim + 1
                  iimgex(idim) = nsc
                endif
              endif
            endif
          enddo
c
          do irow = 1,idim
            nsc = iimgex(irow)
            nr1 = ndrsr(1,nsc)
            cxcc = cdrs(nr1)
c
c           Calling sequence substitutions:
c             nsj for nse
c             nsc for ns
c
            cxjc = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,nsc,nstmax)
c
            if (qej) then
c
c             The current column is for a generic ion exchanger
c             species.
c
              axfc = xbar(nsc)*(1.0 + (cxjc/cxcc))
              do icol = 1,idim
                aamgex(irow,icol) = -axfc
              enddo
              aamgex(irow,irow) = 1.0 + aamgex(irow,irow)
              rhsgex(irow) = al10*(-(cxjc/cxcc)*conc(nsc)
     $        + axfc*conc(nsj))
            elseif (qwj) then
c
c             The current column is for solvent water.
c
              axfc = xbar(nsc)
              do icol = 1,idim
                aamgex(irow,icol) = -axfc
              enddo
              aamgex(irow,irow) = 1.0 + aamgex(irow,irow)
              rhsgex(irow) = -al10*(cxjc/cxcc)*conc(nsc)
            elseif (qmj) then
c
c             The current column is for an aqueous solute species.
c
              axfc = xbar(nsc)*(1.0 + (cxjc/cxcc))
              do icol = 1,idim
                aamgex(irow,icol) = -axfc
              enddo
              aamgex(irow,irow) = 1.0 + aamgex(irow,irow)
              rhsgex(irow) = -al10*(cxjc/(cxcc*cgxj))*conc(nsc)
            else
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(nsi) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(nsi),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(nsj) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(nsj),usp256)
c
              write (noutpt,1110) usp156(1:jlen1),usp256(1:jlen2)
              write (nttyo,1110) usp156(1:jlen1),usp256(1:jlen2)
 1110         format(/' * Error - (EQLIB/balcon) Programming',
     $        ' error trap: In calculating',/7x,'the Jacobian',
     $        ' matrix entry for the ',a,' row',/7x,' and the ',
     $        a,' column, the type of the column',/7x,' species',
     $        ' does not correspond to a programmed possibility.')
              stop
            endif
          enddo
c
c         Check for a zero rhsgex vector. Note that if idim is zero,
c         qrhsgz will remain set to .true.
c
          qrhsgz = .true.
          do irow = 1,idim
            if (rhsgex(irow) .ne. 0.) then
              qrhsgz = .false.
              go to 300
            endif
          enddo
  300     continue
c
          if (qrhsgz) then
c
c           Have a zero right-hand-side vector. Set all dmlge elements
c           to zero.
c
            do irow = 1,idim
              dmlge(irow) = 0.
            enddo
          else
c
c           Solve the matrix equation. If EQLIBU/msolvr.f can't solve
c           the matrix, it is because the matrix is either zero
c           (ier = 1) or non-zero, but computationally singular
c           (ier = 2).
c
c           Calling sequence substitutions:
c             aamgex for aamatr
c             dmlge for delvec
c             ggmgex for ggmatr
c             ipvgex for ipivot
c             idim for kdim
c             ietmax for kmax
c             rhsgex for rhsvec
c
            call msolvr(aamgex,dmlge,ggmgex,ier,ipvgex,idim,ietmax,
     $      noutpt,nttyo,qpr,rhsgex)
c
            if (ier .ne. 0) then
c
c             The matrix is zero or it is computationally singular.
c
c             Calling sequence substitutions:
c               jlen1 for jlen
c               uspec(nsi) for unam48
c               usp156 for uspn56
c
              call fmspnx(jlen1,uspec(nsi),usp156)
c
c             Calling sequence substitutions:
c               jlen2 for jlen
c               uspec(nsj) for unam48
c               usp256 for uspn56
c
              call fmspnx(jlen2,uspec(nsj),usp256)
c
              write (noutpt,1120) usp156(1:jlen1),usp256(1:jlen2)
              write (nttyo,1120) usp156(1:jlen1),usp256(1:jlen2)
 1120         format(/' * Error - (EQLIB/balcon) Have encountered a',
     $        ' zero or computationally',/7x,'singular matrix while',
     $        ' trying to calculate the Jacobian matrix entry',
     $        /7x,'for the ',a,' row and the ',a,' column.')
              stop
            endif
          endif
c
          if (qrhsgz) then
            sumx = 0.
          else
            sumx = 0.
            do irow = 1,idim
              nsc = iimgex(irow)
              sumx = sumx + weight(nsc)*dmlge(irow)
            enddo
          endif
c
          if (nsj .ne. narn1) then
            dmlgej = al10*conc(nsj)
            sumx = sumx + weight(nsj)*dmlgej
          endif
c
          aamatr(krow,kcol) = sumx
c
        enddo
      endif
c
      end

      subroutine fmspnx(jlen,unam48,uspn56)
c
c     This subroutine formats a 48-character species name (unam48) into
c     a 56-character string (uspn56) so that the phase part of the
c     name (in the field composed of the second 24 characters) appears
c     in parentheses following the actual species part (in the field
c     composed of the first 24 characters). For example, ignoring
c     trailing blanks, "Albite                  Plagioclase     " is
c     reformatted as "Albite (Plagioclase)". However, the phase
c     part (including the surrounding parentheses) is omitted from
c     the formatted string if the phase name is not present in the
c     48-character string, if the phase name is identical to the
c     species name, or if the phase name is 'Aqueous solution'.
c     Thus, the returned string for pure Albite is 'Albite', not
c     'Albite (Albite)', and that for the aqueous sulfate ion is
c     'SO4--', not 'SO4-- (Aqueous solution)'.
c
c     The formatted string is used mostly in error, warning, and note
c     messages written by EQ3NR and EQ6.
c
c     This subroutine is similar to fmspnm.f. However, that subroutine
c     includes the phase part if the phase name is 'Aqueous solution'.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       unam48 = the species name (unformatted)
c
c     Principal output:
c
c       jlen   = the length of the formatted species name
c       uspn56 = the formatted species name
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jlen
c
      character*48 unam48
      character*56 uspn56
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
      character*24 uphnam
c
c-----------------------------------------------------------------------
c
      uspn56 = unam48(1:24)
      jlen = ilnobl(uspn56)
c
      uphnam = unam48(25:48)
      j2 = ilnobl(uphnam)
      if (uphnam(1:24) .ne. unam48(1:24)) then
        if (uphnam(1:24) .ne. 'Aqueous solution        ') then
          if (j2 .gt. 0) then
            uspn56(jlen + 1:jlen + 2) = ' ('
            uspn56(jlen + 3:jlen + 2 + j2) = uphnam(1:j2)
            jlen = jlen + 3 + j2
            uspn56(jlen:jlen) = ')'
          endif
        endif
      endif
c
c
      end

      real*8 function coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
c
c     This subroutine finds the coefficient of the nse-th species
c     in the reaction for the destruction of the ns-th species.
c
c     This subroutine is called by:
c
c       EQLIB/elim.f
c       EQLIB/ncmpex.f
c       EQLIB/switch.f
c       EQLIB/swtchb.f
c       EQLIB/swtchk.f
c       EQ3NR/arrset.f
c       EQ3NR/arrsim.f
c       EQ3NR/dawfix.f
c       EQ3NR/balcon.f
c       EQ3NR/betas.f
c       EQ3NR/eq3nr.f
c       EQ3NR/matrix.f
c       EQ3NR/scripx.f
c       EQ6/balcmz.f
c       EQ6/jgibbs.f
c       EQ6/matrxz.f
c       EQ6/mincsp.f
c       EQ6/scanlm.f
c       EQ6/tstrdx.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrs   = array of reaction coefficients
c       ndrs   = array of indices of the species corresponding to the
c                  coefficients in the cdrs array
c       ndrsr  = array giving the range in the cdrs and ndrs arrays
c                  containing the reaction for a given species
c
c     Principal output:
c
c       coefdr = the reaction coefficient of the nse-th species in
c                  the reaction for the ns-th species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer ndrs(ndrsmx),ndrsr(2,nstmax)
      integer nse,ns
c
      real*8 cdrs(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,n1,n2
c
c-----------------------------------------------------------------------
c
      coefdr = 0.
c
      n1 = ndrsr(1,ns)
      n2 = ndrsr(2,ns)
      do n = n1,n2
        if (nse .eq. ndrs(n)) then
          coefdr = cdrs(n)
          go to 999
        endif
      enddo
c
  999 continue
      end

      subroutine gcsts(cdrs,csts,jflag,nbaspd,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,noutpt,nsts,nstsmx,nstsr,nst,nstmax,nttyo,uspec)
c
c     This subroutine computes the stoichiometric factors which relate
c     each aqueous species to the nb-th member of the data file
c     basis set. These stoichiometric factors permit calculation of
c     sums which correspond to physically meaningful 'total' masses
c     or concentrations of the basis species, except for three of
c     these species. It is not possible to define physically
c     meaningful mass balances for for water, hydrogen ion, and the
c     aqueous species oxygen gas. The reactions input to this subroutine
c     may be rewritten from the data file forms to reflect the
c     elmination of one or more auxiliary basis species from the
c     active basis set. They may not be rewritten to reflect basis
c     switching, except for a switch which exchanges a strict basis
c     species with an auxiliary basis species.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrs   = array of reaction coefficients
c       nbaspd = indices of the species in the 'd' basis set
c       ndrs   = array of indices of the species corresponding to the
c                  coefficients in the cdrs array
c       ndrsr  = array giving the range in the cdrs and ndrs arrays
c                  corresponding to the reaction for a given species
c       uspec  = array of species names
c
c     Principal output:
c
c       csts   = array of stoichiometric coefficients appearing in
c                  mass balance relations
c       nsts   = array of indices of the basis species corresponding
c                  to the coefficients in the csts array
c       nstsr  = array giving the range in the csts and nsts arrays
c                  corresponding to a given species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstsmx,nstmax
c
      integer noutpt,nttyo
c
      integer jflag(nstmax),nbaspd(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
      integer nbt,nst
c
      character*48 uspec(nstmax)
c
      real*8 cdrs(ndrsmx),csts(nstsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,jlene,n,nb,nbb,nerr,nj,nn,nr1,nr2,ns,nse,nt,nts
c
      integer nbasis
c
      logical qbasis
c
      character*56 uspe56,uspn56
c
      real*8 cxs
c
c-----------------------------------------------------------------------
c
      nerr = 0
      n = 0
c
      do ns = 1,nst
c
c       Set first element of the range pointer array.
c
        nstsr(1,ns) = n + 1
c
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        nt = nr2 - nr1 + 1
        nts = nt - 1
c
c       Check to see if the current species is a member of the active
c       basis set. If so, set qbasis to .true. and nts to 1.
c
c       Calling sequence substitutions:
c         nbaspd for nbasp
c
        nb = nbasis(nbaspd,nbt,nbtmax,ns)
c
        qbasis = .false.
        if (nb.gt.0 .and. jflag(ns).ne.30) then
          qbasis = .true.
          nts = 1
        endif
c
c       Check to see if the csts/nsts array size is sufficient.
c
        nj = n + nts
        if (nj .gt. nstsmx) then
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnx(jlen,uspec(ns),uspn56)
          write (noutpt,1000) nstsmx,uspn56(1:jlen)
          write (nttyo,1000) nstsmx,uspn56(1:jlen)
 1000     format(/' * Error - (EQLIB/gcsts) The maximum ',i7,
     $    ' entries have been exceeded',/7x,'computing the csts',
     $    ' array of stoichiometric coefficients. The last',
     $    /7x,'species for which the coefficients were being computed',
     $    /7x,'was ',a,'. Increase the dimensioning',/7x,
     $    'parameter nstspa')
          stop
        endif
c
        if (qbasis) then
c
c         Set mass balance coefficient for the ns-th species if it is
c         in the active basis set.
c
          n = n + 1
          nsts(n) = nb
          csts(n) = 1.
        else
c
c         Set mass balance coefficients for other species appearing in
c         the reaction for the ns-th species if the ns-th species is
c         not in the active basis set.
c
          if (nt .lt. 2) then
c           Calling sequence substitutions:
c             uspec(ns) for unam48
c
            call fmspnx(jlen,uspec(ns),uspn56)
            write (noutpt,1005) uspn56(1:jlen)
            write (nttyo,1005) uspn56(1:jlen)
 1005       format(/' * Error - (EQLIB/gcsts) The species ',a,
     $      /7x,'has no associated reaction on the data file, but it',
     $      /7x,'is not a strict basis species.')
            nerr = nerr + 1
c
c           Make a single null entry.
c
            n = n + 1
            nsts(n) = 0
            csts(n) = 0.
          else
            cxs = -cdrs(nr1)
            do nn = nr1 + 1,nr2
              n = n + 1
              nse = ndrs(nn)
c
c             Calling sequence substitutions:
c               nbaspd for nbasp
c               nse for ns
c
              nbb = nbasis(nbaspd,nbt,nbtmax,nse)
              if (nbb .le. 0) then
c               Calling sequence substitutions:
c                 uspec(ns) for unam48
c
                call fmspnx(jlen,uspec(ns),uspn56)
c
c               Calling sequence substitutions:
c                 jlene for jlen
c                 uspec(nse) for unam48
c                 uspe56 for uspn56
c
                call fmspnx(jlene,uspec(nse),uspe56)
                write (noutpt,1010) uspe56(1:jlene),uspn56(1:jlen)
                write (nttyo,1010) uspe56(1:jlene),uspn56(1:jlen)
 1010           format(/' * Error - (EQLIB/gcsts) The species ',a,
     $          /7x,'appears in the data file reaction for ',a,',',
     $          /7x,'but it is not in the data file basis set.')
                nerr = nerr + 1
              endif
              nsts(n) = nbb
              csts(n) = cdrs(nn)/cxs
            enddo
          endif
        endif
c
c       Set the second element of the range pointer array.
c
        nstsr(2,ns) = n
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) then
        write (noutpt,1015)
        write (nttyo,1015)
 1015   format(/' * Error - (EQLIB/gcsts) One or more reactions',
     $  /7x,'on the data file are not consistent with the data file',
     $  /7x,'basis set.')
        stop
      endif
c
      end

      subroutine gakmat(akmat0,dxsm00,nord,nrd1mx)
c
c     This subroutine computes the akmat0 matrix, which allows
c     calculation of estimates of derivatives from corresponding finite
c     differences. Note: this subroutine presumes that the diagonal
c     elements have been previously set to factorials and that the
c     lower triangle elements have previously been set to zero. These
c     parts of the matrix are invariant.
c
c     This routine can also be used to calculate the akmat1 matrix from
c     the dlxsm1 array, provided that in the calling sequence akmat1
c     is substituted for akmat0 and dlxsm1 for dxsm00. The akmat0 matrix
c     and the dxsm00 array are used with finite differences employed
c     to generate predictor functions, while akmat1 and dlxsm1 are used
c     are used with finite differences employed to generate corrector
c     functions.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrd1mx
c
      integer nord
c
      real*8 akmat0(nrd1mx,nrd1mx),dxsm00(nrd1mx)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,im1,ip1,j,jm1
c
c----------------------------------------------------------------------
c
      if (nord .ge. 2) then
c
        i = 1
        ip1 = i + 1
        do j = ip1,nord
          jm1 = j - 1
          akmat0(i,j) = akmat0(i,jm1)*dxsm00(jm1)
        enddo
c
        do i = 2,nord - 1
          ip1 = i + 1
          im1 = i - 1
          do j = ip1,nord
            jm1 = j - 1
            akmat0(i,j) = akmat0(i,jm1)*dxsm00(jm1) + akmat0(im1,jm1)*i
          enddo
        enddo
      endif
c
      end

      subroutine fpbflo(al10,delxi,demop0,dlxmin,dxval0,d1emp1,
     $ d2emp1,emop,emop0,eps100,fdpe0,iemop,ier,iodb,nodbmx,nord,
     $ nordmx,noutpt,npet,npetmx,nptmax,nrd1mx,nttyo,qdump,toldl,
     $ uaqsln,ufixf,uphase,xim1,xi0,xi1,xval0,zklogu)
c
c     This subroutine limits delxi by approximate position of
c     significant maxima in the masses of non-aqeuous species that are
c     in partial equilibrium with the aqueous solution. The numbers of
c     moles of such phases are tracked using finite differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f.
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nordmx,npetmx,nptmax,nrd1mx
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iodb(nodbmx)
c
      integer ier,nord,npet
c
      logical qdump
c
      character*24 uphase(nptmax)
      character*24 uaqsln
      character*8 ufixf
c
      real*8 demop0(nordmx,npetmx),dxval0(nrd1mx),d1emp1(npetmx),
     $ d2emp1(npetmx),emop(npetmx),emop0(npetmx),fdpe0(nordmx,npetmx)
c
      real*8 al10,delxi,dlxmin,eps100,toldl,xim1,xi0,xi1,xval0,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ilsign,j2,n,np,npe,npej,npj
c
      integer ilnobl
c
      character*48 usearch
      character*24 unam24
c
      real*8 dfmrxx,dfmxx,dfmxxj,dpx,dpx0,mxx,mxxu,mxx0,tolsx,xtargv
c
      real*8 texp
c
c-----------------------------------------------------------------------
c
      data usearch /'a product phase maximizes                       '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 1) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is not where the first derivative is zero, but
c     -eps100. The interval for convergence is (-2*eps100,0.).
c
      ilsign = 1
      xtargv = -eps100
      tolsx = eps100
      mxxu = texp(zklogu)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for product phase masses maximizing',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Make a Taylor's series expansion of the first derivatives of the
c     numbers of moles of the phases in the ES.
c
      call d1ptay(delxi,demop0,d1emp1,nord,nordmx,npet,npetmx)
c
c     Make a Taylor's series expansion of the numbers of moles of the
c     phases in the ES.
c
      call ptaylr(delxi,demop0,emop0,emop,nord,nordmx,npet,npetmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any phases whose mole numbers are decreasing. Pick the
c     one whose mole number would be decreased the most at the
c     current step size. Some phase types including the aqueous
c     solution phase and any fictive fugacity-fixing phases are
c     exempt. Phases whose mole numbers are already sufficiently
c     small (.le. 10^zklogu at the base point) point are ignored.
c
      dfmxxj = 0.
      npej = 0
      npj = 0
      unam24 = ' '
      do npe = 1,npet
        np = iemop(npe)
        if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
          if (uphase(np)(1:5) .ne. ufixf(1:5)) then
c
c           Not an excluded phase type.
c
            mxx0 = emop0(npe)
            if (mxx0 .gt. mxxu) then
c
c             The base point mole number is sufficiently large
c             to consider.
c
                mxx = emop(npe)
                dfmxx = mxx - mxx0
                if (dfmxx .lt. 0.) then
c
c                 A decrease in the mole number is predicted.
c
                  dfmrxx = dfmxx/mxx0
                  if (dfmrxx .lt. -0.0001) then
c
c                   The predicted decrease in mole number exceeds
c                   a small relative amount.
c
                    dpx0 = demop0(1,npe)
                    dpx = d1emp1(npe)
c
                    if (dpx0.ge.eps100 .and. dpx.le.-eps100) then
c
c                   The derivative of the mole number changes
c                   from positive at the based point to negative
c                   at the new point.
c
                    if (fdpe0(1,npe) .lt. -eps100) then
c
c                     The derivative is confirmed by the first
c                     finite difference.
c
                      if (dfmxx .lt. dfmxxj) then
c
c                       Choose the phase with the largest predicted
c                       decrease in mole number.
c
                        dfmxxj = dfmxx
                        npej = npe
                        npj = np
                      endif
                    endif
                  endif
                endif
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (npej .gt. 0) then
        qdump = .true.
        if (delxi .gt. dlxmin) then
          dpx = d1emp1(npej)
          if (abs(dpx + eps100) .gt. eps100) then
c
            unam24 = uphase(npj)
            xval0 = demop0(1,npej)
            do n = 1,nord - 1
              dxval0(n) = demop0(n + 1,npej)
            enddo
            if (nord .gt. 0) dxval0(nord) = 0.
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 999
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qdump) then
        if (iodb(1).gt.0 .or.iodb(5).gt.0) then
          write (noutpt,1010) xi1,delxi
 1010     format(/3x,"Taylor's series predict maxima for the number of",
     $    ' moles of',/3x,'the following phases at Xi= ',1pe11.4,
     $    ', delxi= ',e11.4,':',/)
c
          do npe = 1,npet
            mxx0 = emop0(npe)
            dpx = d1emp1(npe)
            np = iemop(npe)
c
            if (mxx0 .gt. mxxu) then
              if (abs(dpx + eps100) .gt. eps100) then
                if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
                  if (uphase(np)(1:5) .ne. ufixf(1:5)) then
                    j2 = ilnobl(uphase(np))
                    write (noutpt,1020) uphase(np)(1:j2)
 1020               format(5x,a)
                  endif
                endif
              endif
            endif
          enddo
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gfdho(aphi,bt,f,fp,fpp,fxi)
c
c     This subroutine computes the Debye-Huckel function f and its
c     derivatives with respect to ionic strength for the case of
c     the Debye-Huckel-osmotic (DHO) model. This is the Debye-Huckel
c     model in Pitzer's (1973, 1975) equations.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       aphi   = the Debye-Huckel A(phi) parameter
c       bt     = product of Debye-Huckel B and the hard core diameter,
c                usually taken as a constant (1.2)
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c
c     Output:
c
c       f      = Debye-Huckel function f
c       fp     = f' (df/dI)
c       fpp    = f'' (d2f/dI2)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      real*8 aphi,bt,f,fp,fpp,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 alvxp1,fc,fxisqt,vx,vxp1,vxp1sq
c
c-----------------------------------------------------------------------
c
      fxisqt = sqrt(fxi)
      vx = bt*fxisqt
      vxp1 = vx + 1.
      vxp1sq = vxp1*vxp1
      alvxp1 = log(vxp1)
c
      fc = -4.*aphi/bt
      f = fc*fxi*alvxp1
      fp = fc*((vx / (2.*vxp1)) + alvxp1)
      fpp = (-aphi/fxisqt)*((1. + 2.*vxp1) / vxp1sq)
c
      end

      subroutine evdat4(arr,ipc,ipcxmx,k,nmax,narxmx,narxt,ntpr,
     $ ntprmx,prop,tempc)
c
c     This subroutine evaluates a thermodynamic property as a function
c     of temperature, using an interpolating polynomial whose
c     coefficients are stored in a 4D array arr. The second dimension
c     of this array corresponds to a temperature range. The third
c     dimension of this array usually corresponds to an order parameter,
c     as for pressure correction.
c
c     Compare with EQLIB/evdat3.f, in which arr is a 3D array, and
c     EQLIB/evdat3.f, in which this is a 3D array.
c
c     This subroutine is called by:
c
c       EQLIB/evdatr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       k      = the index for the fourth dimension of the arr array
c       arr    = two dimensional array of polynomial coefficients
c                  describing some thermodynamic function
c       ipcxmx = the third dimension of the arr array
c       ipc    = the index for the third dimension of the arr array
c       tempc  = temperature, C
c       ntpr   = temperature range flag
c       narxmx = first dimension of the arr array, the number
c                  of coefficients per temperature range
c       narxt  = array of numbers of coefficients in temperature
c                  ranges
c       ntprmx = second dimension of the arr array, the number
c                  of temperature ranges.
c       nmax   = third dimension of the arr array (can be ngtmax,
c                  nmtmax, or ngtmax)
c
c     Prinicpal output:
c
c       prop   = the calculated property array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipcxmx,nmax,narxmx,ntprmx
c
      integer narxt(ntprmx)
c
      integer ipc,k,ntpr
c
      real*8 arr(narxmx,ntprmx,ipcxmx,nmax),prop
      real*8 tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nn,nt
c
c-----------------------------------------------------------------------
c
c     Evaluate the polynomial.
c
      prop = 0.
      nt = narxt(ntpr)
      do nn = 1,nt
        n = nt + 1 - nn
        prop = arr(n,ntpr,ipc,k) + tempc*prop
      enddo
c
      end

      subroutine rtcalc(act,afrc1,cdac,csigma,eps100,fkrc,idirec,
     $ imchmx,imech,iodb,iopt,jcode,jreac,morr,morr0,mwtrc,ndac,
     $ ndact,ndctmx,nodbmx,noptmx,nord,noutpt,nrk,nrct,nrctmx,nsk,
     $ nstmax,nttyo,prcinf,prminf,qriinf,rirec1,rk,rreac1,rrelr1,
     $ rtcnst,rrxfi1,sfcar,sfcar0,ssfcar,udac,ureac)
c
c     This subroutine calculates the relative and absolute rates of
c     the nrc-th irreversible reaction. This rate is computed from the
c     specified rate expression.
c
c     Under iopt(2) = 1, xi1 is now defined as the sum of the absolute
c     values of the progress variables for all kinetically governed
c     (nrk(1,nrc).gt.1 or nrk(2,nrc).gt.1) reactions. The inverse rate
c     is the inverse of the sum of the absolute values of the rates of
c     these reactions.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,ndctmx,nodbmx,noptmx,nrctmx,nstmax
c
      integer idirec(nrctmx),imech(2,nrctmx),iodb(nodbmx),iopt(noptmx),
     $ jcode(nrctmx),jreac(nrctmx),ndac(ndctmx,imchmx,2,nrctmx),
     $ ndact(imchmx,2,nrctmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer noutpt,nttyo
c
      integer nord,nrct
c
      logical qriinf
c
      character*24 udac(ndctmx,imchmx,2,nrctmx),ureac(nrctmx)
c
      real(8) act(nstmax),afrc1(nrctmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ csigma(imchmx,2,nrctmx),fkrc(nrctmx),morr(nrctmx),morr0(nrctmx),
     $ mwtrc(nrctmx),rk(imchmx,2,nrctmx),rreac1(nrctmx),rrelr1(nrctmx),
     $ rrxfi1(imchmx,nrctmx),sfcar(nrctmx),sfcar0(nrctmx),
     $ ssfcar(nrctmx)
c
      real*8 eps100,prcinf,prminf,rirec1,rtcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer id,j2,nrc
c
      integer ilnobl
c
      logical qovstp
c
      real*8 affr,trate
c
c-----------------------------------------------------------------------
c
c     Loop over all kinetically-governed reactions. Calculate the
c     relevant surface areas for surface-area-controlled reactions.
c
      do nrc = 1,nrct
        call csfar(afrc1,morr,morr0,mwtrc,noutpt,nrc,nrctmx,
     $  nsk,nttyo,prcinf,sfcar,sfcar0,ssfcar,ureac)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the rate law form (forward or backward) to use for
c     each reactant.
c
      do nrc = 1,nrct
        affr = afrc1(nrc)
        qovstp = affr.lt.0. .and. nrk(2,nrc).eq.0 .and. jreac(nrc).le.0
        if (affr .ge. 0.) then
c
c         The affinity favors the forward direction.
c
          idirec(nrc) = 1
          if (nrk(1,nrc) .eq. -1) idirec(nrc) = 2
        else
c
c         The affinity favors the backward direction.
c
          idirec(nrc) = 2
          if (nrk(2,nrc).eq.-1 .or. qovstp) idirec(nrc) = 1
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop over all kinetically-governed reactions. Calculate the
c     net rate (relative or absolute) for each one.
c
      do nrc = 1,nrct
        call crrate(act,afrc1,cdac,csigma,eps100,fkrc,idirec,
     $  imchmx,imech,iodb,jreac,morr,ndac,ndact,ndctmx,nodbmx,noutpt,
     $  nrc,nrctmx,nrk,nstmax,nttyo,rk,rreac1,rrelr1,rrxfi1,rtcnst,
     $  sfcar,udac,ureac)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If in time mode, calculate the inverse rate. Calculate relative
c     rates from the corresponding absolute rates. If any primary
c     calculated rates were relative rates, calculate the corresponding
c     absolute rates.
c
      if (iopt(2) .gt. 0) then
c
c       Compute the total rate.
c
        trate = 0.
        do nrc = 1,nrct
          id = idirec(nrc)
          if (nrk(id,nrc) .gt. 1) trate = trate + abs(rreac1(nrc))
        enddo
c
c       Compute absolute rates for reactants constrained by
c       relative rates.
c
        do nrc = 1,nrct
          id = idirec(nrc)
          if (nrk(id,nrc) .eq. 1) rreac1(nrc) = rrelr1(nrc)*trate
        enddo
c
c       Compute the inverse rate.
c
        qriinf = .false.
        if (trate .le. prminf) then
          qriinf = .true.
          nord = 0
          rirec1 = prcinf
        else
          rirec1 = 1./trate
        endif
c
c       Compute relative rates for reactants constrained by
c       absolute rates.
c
        do nrc = 1,nrct
          id = idirec(nrc)
          if (nrk(id,nrc) .gt. 1) rrelr1(nrc) = rreac1(nrc)*rirec1
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check if the rate and the affinity are compatible.
c
      do nrc = 1,nrct
        if (jreac(nrc).le.0 .and. jcode(nrc) .le. 1) then
          affr = afrc1(nrc)
          if (affr.gt.0. .and. rrelr1(nrc).lt.0.) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1000) ureac(nrc)(1:j2)
            write (nttyo,1000) ureac(nrc)(1:j2)
 1000       format(/' * Warning - (EQ6/rtcalc) The calculated rate',
     $      ' for reactant',/7x,a,' is less than zero, but the',
     $      ' affinity',/7x,'is greater than zero:')
            write (noutpt,1010) rreac1(nrc),rrelr1(nrc),affr
            write (nttyo,1010) rreac1(nrc),rrelr1(nrc),affr
 1010       format(/9x,'Rate = ',1pe12.5,' mol/d',
     $      /9x,'Relative rate= ',e12.5,' mol/mol',
     $      /9x,'Affinity= ',e12.5,' kcal')
            write (noutpt,1020)
            write (nttyo,1020)
 1020       format(/7x,'Check the signs of the rate constants.',/)
          endif
c
          qovstp = affr.lt.0. .and. nrk(2,nrc).eq.0 .and.
     $    jreac(nrc).le.0
          if (affr.lt.0. .and. .not.qovstp .and.
     $      rrelr1(nrc).gt.0.) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1050) ureac(nrc)(1:j2)
            write (nttyo,1050) ureac(nrc)(1:j2)
 1050       format(/' * Warning - (EQ6/rtcalc) The calculated rate',
     $      ' for reactant',/7x,a,' is greater than zero, but the',
     $      ' affinity',/7x,'is less than zero:')
            write (noutpt,1010) rreac1(nrc),rrelr1(nrc),affr
            write (nttyo,1010) rreac1(nrc),rrelr1(nrc),affr
            write (noutpt,1020)
            write (nttyo,1020)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(2) .gt. 1) then
c
c       Write a summary of calculated rate information on the
c       output file.
c
        do nrc = 1,nrct
          if (jreac(nrc) .le. 0) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1070) ureac(nrc)(1:j2),rreac1(nrc),
     $      rrelr1(nrc),affr
 1070       format(/5x,'Calculated Rate Summary',
     $      /5x,a,/7x,'Rate = ',1pe12.5,' mol/d',
     $      /7x,'Relative rate= ',e12.5,' mol/mol',
     $      /7x,'Affinity= ',e12.5,' kcal')
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine ptzchk(narn1,narn2,natmax,nmxi,noutpt,nstmax,nsxi,
     $ nttyo,uspec)
c
c     This subroutine checks each aqueous species in the current model
c     to see if it has any S-lambda or mu Pitzer coefficients. If
c     not, a warning is printed. If a species has at least one
c     coefficient of either type but no S-lambda coefficients (i.e.,
c     has only one or more mu coefficients), a warning is printed.
c     No warning is printed if a species has one or more S-lambda
c     coefficients but no mu coefficients.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narn1  = start of aqueous species range
c       narn2  = end of aqueous species range
c       uspec  = names of all species
c       nmxi   = range pointer array into the nmxx array:
c                  nmxi(1,na) and nmxi(2,na) are the first and last
c                  values of the second subscript (nmx) of the nmxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nsxi   = range pointer array into the nsxx array:
c                  nsxi(1,na) and nsxi(2,na) are the first and last
c                  values of the second subscript (nsx) of the nsxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c
c     Principal output:
c
c        None
c
c     Not used here, but referenced above:
c
c       nmxx   = pointer array:
c                  nmxx(1,nmx) = the species index of the second
c                  species in the nmu-th triplet, nmxx(2,nmx) is the
c                  species index of the third species, and
c                  nmxx(3,nmx) = nmu
c       nsxx   = pointer array:
c                  nsxx(1,nsx) = the species index of the second
c                  species in the nsl-th pair, where
c                  nsxx(2,nsx) = nsl
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nstmax
c
      integer nmxi(2,natmax),nsxi(2,natmax)
      integer narn1,narn2,noutpt,nttyo
c
      character*48 uspec(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,islt,imut,na,ns
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     The following loop assumes that water is the narn1-th species.
c
      do ns = narn1 + 1,narn2
        na = ns - narn1 + 1
c
        islt = nsxi(2,na) - nsxi(1,na) + 1
        imut = nmxi(2,na) - nmxi(1,na) + 1
c
        if (islt.eq.0 .and. imut.eq.0) then
          if (uspec(ns)(1:6).ne.'O2(g) ' .and.
     $      uspec(ns)(1:3).ne.'e- ') then
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,2000) uspec(ns)(1:j2)
            write (nttyo ,2000) uspec(ns)(1:j2)
 2000       format(/' * Warning - (EQLIBG/ptzchk) The species ',a,
     $      /7x,"has no Pitzer interaction coefficients.")
          endif
        elseif (islt .eq. 0) then
          j2 = ilnobl(uspec(ns)(1:24))
          write (noutpt,2010) uspec(ns)(1:j2)
          write (nttyo ,2010) uspec(ns)(1:j2)
 2010     format(/' * Warning - (EQLIBG/ptzchk) The species ',a,
     $    /7x,"has no Pitzer S-lambda interaction coefficients.")
        endif
c
      enddo
c
      end

      subroutine dgefa(gmmatr,kmax,kdim,ipivot,info)
c
c     This subroutine factors the real*8 array gmmatr, using the method
c     of L-U decomposition. It is an adaptation of the 1979 Linpack
c     subroutine of the same name. The size and order of the original
c     calling sequence has been preserved:
c     (a,lda,n,ipvt,info) = (gmmatr,kmax,kdim,ipivot,info)
c
c     Note: detection of singularity using the test corresponding to
c     the condition info = -1 was not implemented in the original
c     Linpack version of the subroutine and may be missing from other
c     modern equivalents.
c
c     This subroutine uses the following pseudo-Linpack BLAS (Basic
c     Linear Algebra Subsystem) subroutines:
c
c       EQLIBU/idamax.f
c       EQLIBU/daxpy.f
c       EQLIBU/dscal.f
c
c     This subroutine is called by:
c
c       EQLIBU/msolvr.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       gmmatr = the matrix (unfactored)
c       kmax   = the declared (maximum) dimension of the matrix
c       kdim   = the used dimension of the matrix
c       ipivot = the pivot vector (used by EQLIBU/dgesl.f)
c
c     Output:
c
c       gmmatr = the matrix, factored
c       info   = error flag:
c                  = -1      singularity
c                  =  0      no singularity
c                  =  k > 0  singularity
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax
      integer info,kdim
c
      integer ipivot(kmax)
c
      real*8 gmmatr(kmax,kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,k,kp1,il
      integer idamax
c
      real*8 adiv,div,tx
c
c-----------------------------------------------------------------------
c
c     Gaussian elimination with partial pivoting.
c
      info = 0
      if (kdim .ge. 2) then
        do k = 1,kdim - 1
        kp1 = k + 1
c
c       Find il = pivot index.
c
        il = idamax(kdim - k + 1,gmmatr(k,k),1) + k - 1
        ipivot(k) = il
c
c       Zero pivot implies this column already triangularized.
c
        if (gmmatr(il,k) .ne. 0.) then
c
c         Interchange if necessary.
c
          if (il .ne. k) then
            tx = gmmatr(il,k)
            gmmatr(il,k) = gmmatr(k,k)
            gmmatr(k,k) = tx
          endif
c
c         Compute multipliers.
c
          div = gmmatr(k,k)
c
c         Test for potential zero divide.
c
          adiv=abs(div)
          if (adiv.le.0.) then
            info = -1
            go to 999
          endif
          tx = -1./div
          call dscal(kdim - k,tx,gmmatr(k + 1,k),1)
c
c         Row elimination with column indexing.
c
          do j = kp1,kdim
            tx = gmmatr(il,j)
            if (il .ne. k) then
              gmmatr(il,j) = gmmatr(k,j)
              gmmatr(k,j) = tx
            endif
            call daxpy(kdim - k,tx,gmmatr(k + 1,k),1,gmmatr(k + 1,j),1)
          enddo
          go to 100
        endif
        info = k
  100   continue
      enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      ipivot(kdim) = kdim
      if (gmmatr(kdim,kdim) .eq. 0.) info = kdim
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chksir(delxi,dlxmin,drir0,dxval0,eps100,iodb,
     $ nodbmx,nord,noutpt,nrd1mx,nttyo,rirec0,rirecp,xi0,xi1,xval0)
c
c     This subroutine checks the sign of the inverse rate. It finds the
c     point of reaction progress at which the inverse rate becomes
c     zero. Technically, this should never happen. The inverse rate
c     should start with a positive value and increase toward infinity.
c     The inverse rate is tracked using finite differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer nord
c
      real*8 drir0(nrd1mx),dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,eps100,rirec0,rirecp,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,n
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxp,tolsx,xtargv
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'the inverse rate becomes zero                   '/
      data unam24 /'                        '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note that the search target is not where the inverse rate is zero,
c     but eps100. The interval for convergence is (0,2*eps100).
c
      ilsign = 1
      xtargv = eps100
      tolsx = eps100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for the inverse rate becoming zero',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Estimate the inverse rate from a Taylor's series expansion.
c
      rirecp = rirec0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        rirecp = rirecp + ( drir0(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
        if (rirecp .ge. 0.) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (rirec0 .le. (2.*eps100)) then
c
c         The inverse rate is too small at the base point.
c
          delxi = dlxmin
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) xi0,delxi
 1010       format(/' --- The inverse rate is already very close to',
     $      /7x,'zero at Xi= ',1pe11.4,'. Have set delxi equal to the',
     $      /7x,'minimum value of ',e11.4,'.')
            go to 100
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
c
        xval0 = rirec0
        do n = 1,nord
          dxval0(n) = drir0(n)
        enddo
c
        call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $  nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $  xtargv,xval0)
c
        if (ier .le. 0) go to 100
        if (ier .ge. 2) then
c
c         Note: if ier = 1, the returned "safe" value of delxi
c         is used.
c
          delxi = dlxmin
        endif
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(rirecp - xtargv) .le. tolsx) then
          write (noutpt,1020) xi1,delxi
 1020     format(/3x,"Taylor's series predict that the inverse rate",
     $    /3x,'is zero at Xi= ',1pe11.4,', delxi= ',1pe11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine gndacb(cdac,cdacb,cdrs,eps100,imech,imchmx,
     $ jflag,nbasp,nbt,nbtmax,ndac,ndacb,ndact,ndactb,ndctmx,
     $ ndrs,ndrsmx,ndrsr,nrct,nrctmx,nstmax)
c
c     This subroutine computes the ndacb, ndactb, and cdacb arrays,
c     which are used to support the higher-order stiff ODE corrector.
c     Basically, these are the respective analogs of the ndac, ndact,
c     and cdac arrays. The latter arrays partially describe the
c     kinetic activity products of terms in rate expressions. The
c     ndac array contains the species indices of the species whose
c     activities appear in an activity product, the ndact array
c     contains the total numbers of such species for the kinetic
c     activity products, and the cdac array contains the respective
c     exponents for the species whose indices are given in the
c     ndac array. The species whose indices appear in the ndac
c     array need not be basis species. The ndacb, ndactb, and
c     cdacb arrays are transforms in which the species in ndacb
c     are all members of the active basis set. These arrays must
c     be adjusted if this set is changed by basis switching.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,nbtmax,ndctmx,ndrsmx,nrctmx,nstmax
c
      integer nbt,nrct
c
      integer imech(2,nrctmx),jflag(nstmax),nbasp(nbtmax),
     $ ndac(ndctmx,imchmx,2,nrctmx),ndacb(nbt,imchmx,2,nrct),
     $ ndact(imchmx,2,nrctmx),ndactb(imchmx,2,nrct),ndrs(ndrsmx),
     $ ndrsr(2,nstmax)
c
      real(8) cdac(ndctmx,imchmx,2,nrctmx),cdacb(nbt,imchmx,2,nrct),
     $ cdrs(ndrsmx)
      real(8) eps100
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,k,n,nb,nn,nnn,ns,nse,nr1,nr2,nsi
c
      real(8) cxe
c
c----------------------------------------------------------------------
c
      do k = 1,nrct
        do j = 1,2
          do i = 1,imech(j,k)
c
c           Process the current kinetic activity product.
c
            nn = 0
            do nb = 1,nbt
              nse = nbasp(nb)
              if (jflag(nse) .eq. 0) then
                cxe = 0.
                do n = 1,ndact(i,j,k)
                  ns = ndac(n,i,j,k)
                  if (ns .eq. nse) then
c
c                   The current species in the kinetic activity product
c                   is the basis species presently being examined.
c
                    cxe = cxe + cdac(n,i,j,k)
                  elseif (jflag(ns) .eq. 30) then
c
c                   The current species in the activity product
c                   is a dependent species. Look for a dependence
c                   on the basis species presently being examined.
c
                    nr1 = ndrsr(1,ns)
                    nr2 = ndrsr(2,ns)
                    do nnn = nr1 + 1,nr2
                      nsi = ndrs(nnn)
                      if (nsi .eq. nse) then
                        cxe = cxe - cdac(n,i,j,k)*(cdrs(nnn)/cdrs(nr1))
                      endif
                    enddo
                  endif
c
                  if (abs(cxe) .ge. eps100) then
c
c                   The basis species presently being examined
c                   belongs in the current transformed kinetic
c                   activity product.
c
                    nn = nn + 1
                    ndacb(nn,i,j,k) = nse
                    cdacb(nn,i,j,k) = cxe
                  endif
                enddo
              endif
            enddo
            ndactb(i,j,k) = nn
            do nn = ndactb(i,j,k) + 1,nbt
              ndacb(nn,i,j,k) = 0
              cdacb(nn,i,j,k) = 0.
            enddo
c
          enddo
        enddo
      enddo
c
      end

      subroutine dscal(nmax,scfact,array,incx)
c
c     This subroutine multiplies the real*8 array "array" by the real*8
c     constant scfact. The result is returned in "array". This
c     subroutine is an adaptation of the 1979 Linpack subroutine of the
c     same name. The size and order in the original calling sequence has
c     been preserved: (n,da,dx,incx) == (nmax,scfact,array,incx).
c     The increment incx is not used here (it is taken as having
c     a value of 1; input of any other value constitutes an error).
c     This is a pseudo-Linpack BLAS (Basic Linear Algebra Subsystem)
c     subroutine.
c
c     This subroutine is called by:
c
c       EQLIBU/dgefa.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nmax   = dimension or pseudo-dimension of array
c       scfact = the scale factor
c       array  = the array
c       incx   = the increment (must have a value of 1)
c
c     Output:
c
c       array  = the original array multiplied by the scale factor.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
      integer incx
c
      real*8 array(nmax)
      real*8 scfact
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 scx
c
c-----------------------------------------------------------------------
c
c     Trap illegal value of incx.
c
      if (incx .ne. 1) then
        write (6,1000) incx
 1000   format(/' * Error - (EQLIBU/dscal) The argument incx has a',
     $  /7x,'value of ',i5,'. This version of dscal only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
c     Note that the loop is unrolled.
c
      ileft = (nmax/8)*8
      scx = scfact
c
      do i = 1,ileft,8
        array(i) = scx*array(i)
        array(i + 1) = scx*array(i + 1)
        array(i + 2) = scx*array(i + 2)
        array(i + 3) = scx*array(i + 3)
        array(i + 4) = scx*array(i + 4)
        array(i + 5) = scx*array(i + 5)
        array(i + 6) = scx*array(i + 6)
        array(i + 7) = scx*array(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        array(i) = scx*array(i)
      enddo
c
      end

      subroutine wr3w8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $ ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $ jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $ netmax,newin,ngexti,ngexrt,nobswt,nodbmx,nopgmx,noprmx,noptmx,
     $ nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,nxmod,nxti,nxtimx,pei,
     $ press,qgexsh,rho,scamas,tdspkg,tdspl,tempc,tgexp,tolbt,toldl,
     $ tolspf,ucospi,uebal,ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,
     $ ugexsi,umemi,uobsw,uredox,usbsw,usoli,uspeci,utitl,uhfgex,
     $ uvfgex,uxkgex,uxmod,xbari,xgexsi,xhfgex,xlkgex,xvfgex,
     $ xlkmod,zgexj)
c
c     This subroutine writes the EQ3NR input file in compact ("W")
c     format for version 8.0.
c
c     The calling sequence of this subroutine is identical to that of
c     XCON3/wr3d8.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/rd3inw.f, EQ3NR/rd3ind.f, XCON3/rd3w8.f, and XCON3/rd3d8.f,
c     except that newin is added and ninpts, nprob, noutpt, qend, and
c     qrderr are deleted.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,noptmx,
     $ ntitmx,nxmdmx,nxicmx,nxtimx
c
      integer newin,nttyo
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jgext(netmax),jgexti(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ncmpri(2,nxtimx),ngexrt(jetmax,netmax),ngexti(jetmax,netmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,jpres3,nbti,net,neti,nobswt,
     $ nsbswt,ntitl,nxmod,nxti
c
      logical qgexsh
c
      character*80 utitl(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ucospi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uspeci(nbtmax),uxmod(nxmdmx)
      character*24 ugexmo(netmax),ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),umemi(nxicmx),usoli(nxtimx)
      character*24 uebal,uredox
      character*8 ugexj(jetmax,netmax),ugexji(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real*8 cgexj(jetmax,netmax),cgexpi(netmax),covali(nbtmax),
     $ egexsi(ietmax,jetmax,netmax),mwtges(netmax),tgexp(netmax),
     $ xbari(nxicmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xvfgex(ietmax,jetmax,netmax),
     $ xlkmod(nxmdmx),zgexj(jetmax,netmax),xgexsi(ietmax,jetmax,netmax)
c
      real*8 ehi,fo2lgi,pei,press,rho,scamas,tdspkg,tdspl,tempc,tolbt,
     $ toldl,tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,je,jei,j2,j3,j4,n,nbi,ne,nei,nr1,nr2,nssoti,nxi,
     $ nxic
c
      integer ilnobl
c
      logical qgexef
c
      character*8 uendit
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     The following is a bit of nonsense so compiler warnings will
c     not be generated saying that nttyo is not used.
c
      n = nttyo
      nttyo = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Title.
c
      do n = 1,ntitl
        j2 = ilnobl(utitl(n))
        write (newin,1020) utitl(n)(1:j2)
 1020   format(a)
      enddo
      j3 = ilnobl(uendit)
      if (ntitl .lt. ntitmx) write (newin,1020) uendit(1:j3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,1100)
 1100 format('* Special basis switches')
c
      write (newin,1120) nsbswt
 1120 format(4x,'nsbswt= ',i3)
c
      do n = 1,nsbswt
        j2 = ilnobl(usbsw(1,n))
        write (newin,1140) usbsw(1,n)(1:j2)
 1140   format('species= ',a)
        j2 = ilnobl(usbsw(2,n))
        write (newin,1160) usbsw(2,n)(1:j2)
 1160   format(2x,'switch with= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
      write (newin,1165)
 1165 format('* General')
c
      write (newin,1180) tempc
 1180 format(5x,'tempc= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
      write (newin,1200) jpres3,press
 1200 format(4x,'jpres3= ',i3,/5x,'press= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Density.
c
      write (newin,1222) rho
 1222 format(7x,'rho= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Total dissolved solutes.
c
      write (newin,1227) itdsf3,tdspkg,tdspl
 1227 format(4x,'itdsf3= ',i3,/4x,'tdspkg= ',1pe12.5,5x,'tdspl= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species to adjust for electrical balancing.
c
      j2 = ilnobl(uebal)
      write (newin,1510) iebal3,uebal(1:j2)
 1510 format(4x,'iebal3= 'i3,/5x,'uebal= ',a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Default redox parameters.
c
      write (newin,1234) irdxc3
 1234 format(4x,'irdxc3= ',i3)
      write (newin,1242) fo2lgi,ehi
 1242 format(4x,'fo2lgi= ',1pe12.5,7x,'ehi= ',e12.5)
      j2 = ilnobl(uredox)
      write (newin,1252) pei,uredox(1:j2)
 1252 format(7x,'pei= ',1pe12.5,4x,'uredox= ',a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous basis species and associated constraints.
c
      write (newin,2490)
 2490 format('* Aqueous basis species')
c
      do nbi = 1,nbti
        j2 = ilnobl(uspeci(nbi))
        write (newin,2530) uspeci(nbi)(1:j2)
 2530   format('species= ',a)
        write (newin,2550) jflgi(nbi),covali(nbi)
 2550   format(3x,'jflgi= ',i2,4x,'covali= ',1pg12.5)
        if (jflgi(nbi).eq.17 .or. jflgi(nbi).eq.18 .or.
     $  jflgi(nbi).eq.25) then
          j2 = ilnobl(ucospi(nbi))
          write (newin,2580) ucospi(nbi)(1:j2)
 2580     format(2x,'ucospi= ',a)
        endif
      enddo
      j3 = ilnobl(uendit)
      write (newin,2510) uendit(1:j3)
 2510 format(a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,1590)
 1590 format('* Ion exchangers')
c
      write (newin,1600) qgexsh
 1600 format(4x,'qgexsh= ',l8)
c
      write (newin,1610) net
 1610 format(7x,'net= ',i3)
c
      do ne = 1,net
        j2 = ilnobl(ugexp(ne))
        write (newin,1630) ugexp(ne)(1:j2)
 1630   format(5x,'ugexp= ',a)
c
        write (newin,1660) mwtges(ne)
 1660   format(4x,'mwtges= ',1pe12.5)
c
        j3 = ilnobl(ugexmo(ne))
        write (newin,1670) ugexmo(ne)(1:j3)
 1670   format(4x,'ugexmo= ',a)
c
        write (newin,1680) tgexp(ne)
 1680   format(5x,'tgexp= ',1pe12.5)
c
        write (newin,1700) jgext(ne)
 1700   format(5x,'jgext= ',i3)
c
        do je = 1,jgext(ne)
          j3 = ilnobl(ugexj(je,ne))
          write (newin,1740) ugexj(je,ne)(1:j3)
 1740     format(5x,'ugexj= ',a)
c
          write (newin,1760) cgexj(je,ne),zgexj(je,ne)
 1760     format(5x,'cgexj= '1pe12.5,5x,'zgexj= ',e12.5)
c
          write (newin,1810) ngexrt(je,ne)
 1810     format(4x,'ngexrt= ',i3)
c
          do n = 1,ngexrt(je,ne)
            j2 = ilnobl(ugexr(n,je,ne))
            write (newin,1840) ugexr(n,je,ne)(1:j2)
 1840       format(5x,'ugexr= ',a)
            j4 = ilnobl(uxkgex(n,je,ne))
            write (newin,1860) xlkgex(n,je,ne),uxkgex(n,je,ne)(1:j4)
 1860       format(4x,'xlkgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uhfgex(n,je,ne))
            write (newin,1870) xhfgex(n,je,ne),uhfgex(n,je,ne)(1:j4)
 1870       format(4x,'xhfgex= ',1pe12.5,5x,'units= ',a)
            j4 = ilnobl(uvfgex(n,je,ne))
            write (newin,1880) xvfgex(n,je,ne),uvfgex(n,je,ne)(1:j4)
 1880       format(4x,'xvfgex= ',1pe12.5,5x,'units= ',a)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified generic ion exchanger compositions.
c
      write (newin,1900)
 1900 format('* Ion exchanger compositions')
c
      write (newin,1920) neti
 1920 format(6x,'neti= ',i3)
      if (neti .le. 0) go to 250
c
      do nei = 1,neti
c
c       Find the corresponding ne index.
c
        qgexef = .true.
        do ne = 1,net
          j2 = ilnobl(ugexp(ne))
          j3 = ilnobl(ugexpi(nei))
          if (ugexp(nei)(1:j3) .eq. ugexp(ne)(1:j2)) then
            j2 = ilnobl(ugexmo(ne))
            if (ugexmo(ne)(1:j2) .eq. 'Gapon' .or.
     $        ugexmo(ne)(1:6) .eq. 'Gapon-' .or.
     $        ugexmo(ne)(1:j2) .eq. 'Vanselow' .or.
     $        ugexmo(ne)(1:9) .eq. 'Vanselow-') then
c
c             Input composition is described in terms of equivalent
c             fractions on the sites.
c
              qgexef = .true.
            else
c
c             Input composition is described in terms of mole fractions
c             on the sites.
c
              qgexef = .false.
            endif
            go to 240
          endif
        enddo
  240   continue
c
        j2 = ilnobl(ugexpi(nei))
        write (newin,1950) ugexpi(nei)(1:j2)
 1950   format(4x,'ugexpi= ',a)
c
        write (newin,1970) cgexpi(nei)
 1970   format(4x,'cgexpi= ',1pe12.5)
c
        write (newin,1990) jgexti(nei)
 1990   format(4x,'jgexti= ',i3)
c
        do jei = 1,jgexti(nei)
          j3 = ilnobl(ugexji(jei,nei))
          write (newin,2020) ugexji(jei,nei)(1:j3)
 2020     format(4x,'ugexji= ',a)
c
          write (newin,2030) ngexti(jei,nei)
 2030     format(4x,'ngexti= ',i3)
c
          do iei = 1,ngexti(jei,nei)
            if (qgexef) then
              write (newin,2060) ugexsi(iei,jei,nei),
     $        egexsi(iei,jei,nei)
 2060         format(4x,'ugexsi= ',a24,2x,'egexsi= ',1pe12.5)
            else
              write (newin,2070) ugexsi(iei,jei,nei),
     $        xgexsi(iei,jei,nei)
 2070         format(4x,'ugexsi= ',a24,2x,'xgexsi= ',1pe12.5)
            endif
          enddo
        enddo
      enddo
c
  250 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (newin,2100)
 2100 format('* Solid solution compositions')
c
      write (newin,2104) nxti
 2104 format(6x,'nxti= ',i3)
c
      do nxi = 1,nxti
        j2 = ilnobl(usoli(nxi))
        write (newin,2130) usoli(nxi)(1:j2)
 2130   format(5x,'usoli= ',a)
c
        nr1 = ncmpri(1,nxi)
        nr2 = ncmpri(2,nxi)
        nssoti = nr2 - nr1 + 1
c
        write (newin,2142) nssoti
 2142   format(4x,'nssoti= ',i3)
c
        do nxic = nr1,nr2
          write (newin,2170) umemi(nxic),xbari(nxic)
 2170     format(5x,'umemi= ',a24,5x,'xbari= ',1pe12.5)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
      write (newin,2330)
 2330 format('* Alter/suppress options')
c
      write (newin,2340) nxmod
 2340 format(5x,'nxmod= ',i3)
c
c     Nxmod options.
c
      do n = 1,nxmod
        j2 = ilnobl(uxmod(n))
        write (newin,2380) uxmod(n)(1:j2),kxmod(n),xlkmod(n)
 2380   format(3x,'species= ',a,
     $  /4x,'option= ',i2,14x,'xlkmod= ',1pe12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1365)
 1365 format('* Iopt, iopg, iopr, and iodb options')
c
      write (newin,1370)
 1370 format('*',15x,'1    2    3    4    5    6    7    8    9   10')
c
      write (newin,1390) (iopt(i), i = 1,20)
 1390 format(2x,'iopt1-10= ',10i5,/1x,'iopt11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,1420) (iopg(i), i = 1,20)
 1420 format(2x,'iopg1-10= ',10i5,/1x,'iopg11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
      write (newin,1440) (iopr(i), i = 1,20)
 1440 format(2x,'iopr1-10= ',10i5,/1x,'iopr11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1480) (iodb(i), i = 1,20)
 1480 format(2x,'iodb1-10= ',10i5,/1x,'iodb11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical parameters. Convergence tolerances (tolbt and toldl)
c     and maximum number of Newton-Raphson iterations (itermx).
c
      write (newin,1270)
 1270 format('* Numerical parameters')
c
      write (newin,1290) tolbt,toldl
 1290 format (5x,'tolbt= ',1pe12.5,5x,'toldl= ',e12.5)
c
      write (newin,1310) itermx
 1310 format (4x,'itermx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,2700)
 2700 format('* Ordinary basis switches')
c
      write (newin,2710) nobswt
 2710 format(4x,'nobswt= ',i3)
c
      do n = 1,nobswt
        j2 = ilnobl(uobsw(1,n))
        write (newin,1140) uobsw(1,n)(1:j2)
        j2 = ilnobl(uobsw(2,n))
        write (newin,1160) uobsw(2,n)(1:j2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation flag tolerance (tolspf).
c
      write (newin,1292)
 1292 format('* Saturation flag tolerance')
c
      write (newin,1296) tolspf
 1296 format (4x,'tolspf= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale factor for the mass of aqueous solution to write
c     on the PICKUP file.
c
      write (newin,1315)
 1315 format('* Aqueous phase scale factor')
c
      write (newin,1330) scamas
 1330 format (4x,'scamas= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      real*8 function ddot(nmax,array1,incx,array2,incy)
c
c     This subroutine computes the dot product (ddot) of the two real*8
c     arrays "array1" and "array2". This subroutine is an adaptation of
c     the 1979 Linpack subroutine of the same name. The size and order
c     in the original calling sequence has been preserved:
c     (n,dx,incx,dy,incy) = (nmax,array1,incx,array2,incy).
c     The increments incx and incy are not used here (each is taken
c     as having a value of 1; input of any other value constitutes
c     an error). This is a pseudo-Linpack BLAS (Basic Linear Algebra
c     Subsystem) subroutine.
c
c     This subroutine is nearly identical to EQLIBU/dotpra.f, which has
c     the same function, but a different calling sequence.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nmax   = dimension or pseudo-dimension of array
c       array1 = the first array
c       incx   = the x increment (must have a value of 1)
c       array2 = the second array
c       incy   = the y increment (must have a value of 1)
c
c     Output:
c
c       ddot   = the dot product
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
      integer incx,incy
c
      real*8 array1(nmax),array2(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
c     Trap illegal values of incx and inc6.
c
      if (incx .ne. 1) then
        write (6,1000) incx
 1000   format(/' * Error - (EQLIBU/ddot) The argument incx has a',
     $  /7x,'value of ',i5,'. This version of ddot only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
      if (incy .ne. 1) then
        write (6,1010) incy
 1010   format(/' * Error - (EQLIBU/ddot) The argument incy has a',
     $  /7x,'value of ',i5,'. This version of ddot only allows this',
     $  /7x,'argument to have a value of 1. This is a programming',
     $  /7x,'error or a linking error.')
        stop
      endif
c
c     Note the use of a local variable (dx) within the loop.
c     Note also that the loop is unrolled.
c
      dx = 0.
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        dx = dx + array1(i)*array2(i) + array1(i + 1)*array2(i + 1)
     $  + array1(i + 2)*array2(i + 2) + array1(i + 3)*array2(i + 3)
     $  + array1(i + 4)*array2(i + 4) + array1(i + 5)*array2(i + 5)
     $  + array1(i + 6)*array2(i + 6) + array1(i + 7)*array2(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        dx = dx + array1(i)*array2(i)
      enddo
      ddot = dx
c
      end

      integer function nphase(ncmpr,npt,nptmax,ns)
c
c     This subroutine returns the index of the phase which contains
c     the ns-th species. If a match is not found, a zero value is
c     returned.
c
c     This subroutine is called by:
c
c       EQ6/mincsp.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ncmpr  = array giving the start and the end of the range of the
c                species belonging to a given phase
c       npt    = the number of phases
c       ns     = the index of the desired species
c
c     Output:
c
c       nphase = the index of the phase containing the ns-th species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nptmax
c
      integer ncmpr(2,nptmax)
      integer npt,ns
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer np,nr1,nr2
c
c-----------------------------------------------------------------------
c
      nphase = 0
      do np = 1,npt
        nr1 = ncmpr(1,np)
        nr2 = ncmpr(2,np)
        if (ns .le. nr2) then
          if (ns .ge. nr1) then
            nphase = np
            go to 999
          endif
        endif
      enddo
c
  999 continue
      end

      subroutine tprca(abeta,acphi,alamca,alpha,alphca,amua2c,amuc2a,
     $ icapr,ipbtmx,jpfcmx,natmax,na2ctr,ncapr,ncvca,nc2atr,nerr,
     $ noutpt,npx2mx,npx2t,nttyo,nwarn,pcvca,qpdca,uaqsp,upair,zaqsp)
c
c     Test and process the Pitzer data for ca (cation, anion) pairs
c     read from the DATA0 file. Find and flag errors, such as duplication
c     of data (e.g., two data blocks for the same ca pair). Calculate
c     the conventional primitive Pitzer parameters from the observable
c     compound parameters read from the data file:
c
c       beta(n)(ca) -> lambda(n)(ca)   (n = 0,2)
c       Cphi(ca)    -> mu(cca) and mu(aac)
c
c     Check the coverage of entered Pitzer data against all possible
c     ca pairs that can be composed of the aqueous cations and anions
c     present on the data file.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,na2ctr,ncapr,nc2atr,npx2mx
c
      integer noutpt,nttyo
c
      integer icapr(2,ncapr)
c
      integer ncvca,nerr,npx2t,nwarn
c
      logical qpdca(ncapr)
c
      character(len=24) uaqsp(natmax),upair(2,npx2mx)
c
      real*8 abeta(jpfcmx,0:ipbtmx,npx2mx),acphi(jpfcmx,npx2mx),
     $ alamca(jpfcmx,0:ipbtmx,ncapr),alphca(ipbtmx,ncapr),
     $ alpha(2,npx2mx),amua2c(jpfcmx,na2ctr),amuc2a(jpfcmx,nc2atr),
     $ zaqsp(natmax)
c
      real*8 pcvca
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,jp,jpair,j2,j3,j4,j5,n,ncount,ndupl,nlistl,nn,
     $ nodatc
c
      integer ilnobl
c
      character*56 ustr56
      character*24 unam1,unam2
      character*8 ux8
c
      real*8 fmuc2a,fmua2c,z1,z2
c
c-----------------------------------------------------------------------
c
c     Limit on the list of pairs for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Initialize the data arrays.
c
      do n = 1,ncapr
        qpdca(n) = .false.
        do i = 1,ipbtmx
          alphca(i,n) = 0.
        enddo
      enddo
c
      do n = 1,ncapr
        do i = 0,ipbtmx
          do j = 1,jpfcmx
            alamca(j,i,n) = 0.
          enddo
        enddo
      enddo
c
      do n = 1,ncapr
        do j = 1,jpfcmx
          amuc2a(j,n) = 0.
          amua2c(j,n) = 0.
        enddo
      enddo
c
c     Check the entered data for ca pairs.
c
      nodatc = 0
c
      do n = 1,ncapr
        i = icapr(1,n)
        j = icapr(2,n)
        unam1 = uaqsp(i)
        unam2 = uaqsp(j)
        z1 = zaqsp(i)
        z2 = zaqsp(j)
c
c       Search for unam1, unam2 in the upair array.
c       That array corresponds to the species pairs blocks.
c
        call srch22(jpair,unam1,unam2,upair,npx2mx,npx2t)
c
        if (jpair .gt. 0) then
c
c         Have found an entry.
c
          qpdca(n) = .true.
c
c         Store the data.
c
          do i = 1,ipbtmx
            alphca(i,n) = alpha(i,jpair)
          enddo
c
          do i = 0,ipbtmx
            do j = 1,jpfcmx
              alamca(j,i,n) = abeta(j,i,jpair)
            enddo
          enddo
c
          fmuc2a = sqrt(-z1/z2)/6.
          fmua2c = sqrt(-z2/z1)/6.
c
          do j = 1,jpfcmx
            amuc2a(j,n)   = acphi(j,jpair)*fmuc2a
            amua2c(j,n)   = acphi(j,jpair)*fmua2c
          enddo
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jp = jpair + 1,npx2t
            if (unam1(1:24) .eq. upair(1,jp)(1:24)) then
              if (unam2(1:24) .eq. upair(2,jp)(1:24)) then
                ndupl = ndupl + 1
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam2(1:j3)
              write (nttyo,1010) unam1(1:j2),unam2(1:j3)
 1010         format(/' * Error - (EQPT/tprca) Have found a duplicate',
     $        ' data block on the DATA0 file',/7x,'for the ca pair ',
     $        a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j5 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
              write (nttyo,1020) ux8(1:j5),unam1(1:j2),unam2(1:j3)
 1020         format(/' * Error - (EQPT/tprca) Have found ',a,
     $        ' duplicate data blocks on the DATA0 file',
     $        /7x,'for the ca pair ',a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
        else
c
c         No data block was found on the DATA0 file.
c         Note that qpdca(n) is left with a value of .false.
c
          nodatc = nodatc + 1
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1040)
        write (nttyo,1040)
 1040   format(/' * Warning - (EQPT/tprca) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  ' ca pairs:',/)
c
        ncount = 0
        do n = 1,ncapr
          if (.not.qpdca(n)) then
            ncount = ncount + 1
            i = icapr(1,n)
            j = icapr(2,n)
            unam1 = uaqsp(i)
            unam2 = uaqsp(j)
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            ustr56 = unam1(1:j2) // ', ' // unam2(1:j3)
            j4 = ilnobl(ustr56)
            write (noutpt,1050) ustr56(1:j4)
            write (nttyo,1050) ustr56(1:j4)
 1050       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1060) ux8(1:j3)
          write (nttyo,1060) ux8(1:j3)
 1060     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1070)
        write (nttyo,1070)
 1070   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvca = ncapr - nodatc
      pcvca = (100.*ncvca)/float(ncapr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine rd6dvz(ninpt,ucode,urelno,ustage,ueqlrn,ueqlst)
c
c     This subroutine looks at the comments on the old EQ6 INPUT file
c     in menu-style ("D") format, and tries to recover the code and
c     version number data normally written on the bottom half of the
c     PICKUP file to identify the code and version which wrote this
c     part of that file.
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ninpt
c
      character*8 ucode,urelno,ustage,ueqlrn,ueqlst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j
c
      character*80 uline
c
c-----------------------------------------------------------------------
c
      ucode  = ' '
      urelno = ' '
      ustage = ' '
      ueqlrn = ' '
      ueqlst = ' '
      rewind(ninpt)
c
      do 100 i = 1,10000
        read (ninpt,'(a)',end=999) uline
        if (uline(1:1).eq.'c' .or. uline(1:1).eq.'*') then
          j = index(uline,'pickup file written by')
          if (j .le. 0) j = index(uline,'Pickup file written by')
          if (j .gt. 0) go to 110
        endif
  100 continue
      go to 999
c
  110 j = index(uline,'eq3nr.')
      if (j .eq. 0) j = index(uline,'EQ3NR.')
      if (j .gt. 0) then
        ucode = 'eq3nr'
        urelno= uline(j + 6:j + 9)
        ustage= uline(j + 10:j+ 13)
        go to 120
      endif
      j = index(uline,'EQ3NR, version ')
      if (j .gt. 0) then
        ucode = 'EQ3NR'
        urelno= uline(j + 15:j + 18)
        ustage= uline(j + 21:j+ 28)
        go to 120
      endif
      j = index(uline,'eq6.')
      if (j .eq. 0) j = index(uline,'EQ6.')
      if (j .gt. 0) then
        ucode = 'eq6'
        urelno= uline(j + 4:j + 7)
        ustage= uline(j + 8:j + 11)
        go to 120
      endif
      j = index(uline,'EQ6, version ')
      if (j .gt. 0) then
        ucode = 'EQ6'
        urelno= uline(j + 13:j + 16)
        ustage= uline(j + 19:j + 26)
        go to 120
      endif
c
  120 read (ninpt,'(a)',end=999) uline
      j = index(uline,'supported by eqlib.')
      if (j .eq. 0) j = index(uline,'supported by EQLIB.')
      if (j .gt. 0) then
        ueqlrn = uline(j + 19:j + 22)
        ueqlst = uline(j + 23:j + 26)
        go to 999
      endif
      j = index(uline,'supported by EQLIB, version ')
      if (j .gt. 0) then
        ueqlrn = uline(j + 28:j + 31)
        ueqlst = uline(j + 34:j + 41)
        go to 999
      endif
      j = index(uline,'Supported by EQLIB, version ')
      if (j .gt. 0) then
        ueqlrn = uline(j + 28:j + 31)
        ueqlst = uline(j + 34:j + 41)
        go to 999
      endif
c
  999 continue
      end

      subroutine csfar(afrc1,morr,morr0,mwtrc,noutpt,nrc,nrctmx,
     $ nsk,nttyo,prcinf,sfcar,sfcar0,ssfcar,ureac)
c
c     This subroutine calculates the surface area required to calculate
c     the rate for the nrc-th irreversible reaction.
c
c     This subroutine is called by:
c
c       EQ6/rtcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx
c
      integer noutpt,nttyo
c
      integer nsk(nrctmx)
c
      integer nrc
c
      character(len=24) ureac(nrctmx)
c
      real(8) afrc1(nrctmx),morr(nrctmx),morr0(nrctmx),mwtrc(nrctmx),
     $ sfcar(nrctmx),sfcar0(nrctmx),ssfcar(nrctmx)
c
      real(8) prcinf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
      real(8) gx
c
c-----------------------------------------------------------------------
c
c     Compute surface area.
c
      gx = morr(nrc)*mwtrc(nrc)
      if (nsk(nrc) .eq. 0) then
c
c       Constant surface area (cm2).
c       Compute the specific surface area (cm2/g).
c
        ssfcar(nrc) = 0.
        if (gx .gt. 0.) ssfcar(nrc) = sfcar(nrc)/gx
      elseif (nsk(nrc) .eq. 1) then
c
c       Constant specific surface area (cm2/g).
c       Compute the surface area (cm2).
c
        if (morr(nrc) .gt. 0.) then
          sfcar(nrc) = ssfcar(nrc)*gx
        elseif (afrc1(nrc) .le. 0.) then
          sfcar(nrc) = 1.e+5
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1000) ureac(nrc)(1:j2),sfcar(nrc)
          write (nttyo,1000) ureac(nrc)(1:j2),sfcar(nrc)
 1000     format(/' * Note - (EQ6/csfar) The surface area of',
     $    ' reactant ',a,/7x,'has been temporarily set to ',1pe11.4,
     $    ' cm2 to permit this phase',/7x,'to begin precipitating.',
     $    ' This is necessary because the surface area',/7x,
     $    ' model requires the phase to have a mass, which it',
     $    /7x,'presently lacks.')
        else
          sfcar(nrc) = 0.
        endif
      elseif (nsk(nrc) .eq. 2) then
c
c       Constant particle number surface area growth law.
c       Compute the surface area (cm2).
c       Compute the specific surface area (cm2/g).
c
        if (morr0(nrc) .gt. 0.) then
          sfcar(nrc) = sfcar0(nrc)*(morr(nrc)/morr0(nrc))**(2./3.)
          ssfcar(nrc) = 0.
          if (gx .gt. 0) ssfcar(nrc) = sfcar(nrc)/gx
        elseif (afrc1(nrc) .le. 0.) then
          sfcar(nrc) = 1.e+5
          ssfcar(nrc) = prcinf
          j2 = ilnobl(ureac(nrc))
          write (noutpt,1010) ureac(nrc)(1:j2),sfcar(nrc)
          write (nttyo,1010) ureac(nrc)(1:j2),sfcar(nrc)
 1010     format(/' * Note - (EQ6/csfar) The surface area of',
     $    ' reactant ',a,/7x,'has been temporarily set to ',1pe11.4,
     $    ' cm2 to permit this phase',/7x,'to begin precipitating.',
     $    ' This is necessary because the surface area',/7x,
     $    ' model requires the phase to have a mass at the',
     $    /7x,'previous point, which it lacks.')
        else
          sfcar(nrc) = 0.
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine prteca(cteaq,mrmlra,nct,nctmax,noutpt,ppmwe,
     $ qrho,rho,uelem)
c
c     This subroutine prints a table of the elemental composition of the
c     aqueous solution.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cteaq  = array of molalities of the chemical elements
c       ppmwe  = array of ppms by weight of the chemical elements
c       rho    = the density of the aqueous solution
c       uelem  = array of names of chemical elements
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nctmax
c
      integer noutpt
c
      integer nct
c
      logical qrho
c
      character(len=8) uelem(nctmax)
c
      real(8) cteaq(nctmax),ppmwe(nctmax)
      real(8) mrmlra,rho
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nc
c
      real(8) molrex,ppmve
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(/11x,'--- Elemental Composition of the Aqueous Solution',
     $ ' ---')
c
      if (qrho) then
c
c       Have density data, include mg/L and Molarity.
c
        write (noutpt,1010)
 1010   format(/3x,'Element',8x,'mg/L',7x,'mg/kg.sol',4x,
     $  'Molarity',5x,'Molality',/)
c
        do nc = 1,nct
          ppmve = ppmwe(nc)*rho
          molrex = cteaq(nc)*mrmlra
          write (noutpt,1020) uelem(nc),ppmve,ppmwe(nc),molrex,cteaq(nc)
 1020     format(5x,a8,1x,1pe12.5,1x,1pe12.5,1x,1pe12.5,1x,1pe12.5)
        enddo
      else
c
c       Have no density data, so do not include mg/L and Molarity.
c
        write (noutpt,1030)
 1030   format(/3x,'Element',6x,'mg/kg.sol',4x,'Molality',/)
c
        do nc = 1,nct
          write (noutpt,1040) uelem(nc),ppmwe(nc),cteaq(nc)
 1040     format(5x,a8,1x,1pe12.5,1x,1pe12.5)
        enddo
      endif
c
      write (noutpt,1050)
 1050 format(1x)
c
      end

      subroutine pshfta(csts,emop,emop0,emos,emos0,fdpe0,fdpem1,
     $ fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,imrn1,
     $ imrn2,iodb,ipndx1,ixrn1,ixrn2,jcsort,jern1,jetmax,jgext,
     $ jpflag,jsflag,kbt,km1,kmax,kmt,kx1,kxt,loph,losp,moph,mosp,
     $ mprph,mprsp,mrgexs,mtb,mtb0,nbasp,nbaspd,nbt,nbtmax,ncmpe,
     $ ncmpr,netmax,ngext,nodbmx,nordmx,noutpt,npet,npetmx,npt,
     $ nptmax,nsetmx,nstmax,nsts,nstsmx,nstsr,nttyo,uaqsln,ufixf,
     $ uphase,uspec,xbar,xbarlg,zklgmn,zklogl,zvclg0,zvclg1,
     $ zvec0,zvec1)
c
c     This subroutine oversees the partial transfer of eligible phases
c     (as a group) from the Equilibrium System (ES) to the Physically
c     Removed System (PRS). The eligible phases exclude the aqueous
c     solution phase and any fictive fugacity-fixing phases. Partial
c     transfer means that some mass of each phase transferred remains
c     in the ES.
c
c     This subroutine is called by:
c
c       EQ6/dumpdp.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,netmax,nodbmx,nordmx,npetmx,
     $ nptmax,nsetmx,nstmax,nstsmx
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iemos(nsetmx),iindx1(kmax),iodb(nodbmx),
     $ ipndx1(kmax),jcsort(nstmax),jern1(jetmax,netmax),jgext(netmax),
     $ jpflag(nptmax),jsflag(nstmax),nbasp(nbtmax),nbaspd(nbtmax),
     $ ncmpe(2,npetmx),ncmpr(2,nptmax),ngext(jetmax,netmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer iern1,iern2,imrn1,imrn2,ixrn1,ixrn2,kbt,km1,kmt,
     $ kx1,kxt,nbt,npet,npt
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
      character*24 uaqsln
      character*8 ufixf
c
      real*8 csts(nstsmx),emop(npetmx),emop0(npetmx),emos(nsetmx),
     $ emos0(nsetmx),fdpe0(nordmx,npetmx),fdpem1(nordmx,npetmx),
     $ fdse0(nordmx,nsetmx),fdsem1(nordmx,nsetmx),loph(nptmax),
     $ losp(nstmax),moph(nptmax),mosp(nstmax),mprph(nptmax),
     $ mprsp(nstmax),mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),
     $ mtb0(nbtmax),zvclg0(kmax),zvclg1(kmax),zvec0(kmax),
     $ zvec1(kmax),xbar(nstmax),xbarlg(nstmax)
c
      real*8 zklgmn,zklogl
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      logical qprflg,qshftd,qtotsh
c
      integer np,npe,nshftd
c
c----------------------------------------------------------------------
c
      nshftd = 0
      qtotsh = .false.
c
      write (noutpt,1000)
 1000 format(' --- Shifting (partial) ES solid(s) to the PRS ---',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Shift all ES phases except the aqueous solution phase and
c     any fictive fugacity-fixing phases.
c
      do npe = 1,npet
        np = iemop(npe)
        if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
          if (uphase(np)(1:5) .ne. ufixf(1:5)) then
c
            call shftph(emop,emop0,emos,emos0,fdpe0,fdpem1,
     $      fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,
     $      imrn1,imrn2,ipndx1,ixrn1,ixrn2,jern1,jetmax,jgext,
     $      jpflag,jsflag,kbt,kmax,km1,kmt,kx1,kxt,loph,losp,moph,
     $      mosp,mprph,mprsp,mrgexs,nbtmax,ncmpe,ncmpr,netmax,
     $      ngext,nordmx,noutpt,np,npet,npetmx,nptmax,nsetmx,
     $      nstmax,nttyo,qshftd,qtotsh,uphase,xbar,xbarlg,zklgmn,
     $      zklogl,zvclg0,zvclg1,zvec0,zvec1)
c
            if (qshftd) nshftd = nshftd + 1
          endif
        endif
      enddo
c
      if (nshftd .gt. 0) then
c
c       Recompute the composition of the ES.
c
        qprflg = iodb(10) .ge. 1
        call escalc(csts,iindx1,jcsort,kbt,kmax,moph,mosp,mtb,
     $  mtb0,nbaspd,nbt,nbtmax,ncmpr,noutpt,npt,nptmax,nstmax,nsts,
     $  nstsmx,nstsr,qprflg,uspec)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine bderiv(akmat0,dafrc0,fdar0,jreac,nord,nordmx,nrct,
     $ nrctmx,nrd1mx)
c
c     This subroutine computes estimates of the derivatives of the
c     affinities of reactants (afrc1) from the corresponding finite
c     differences. Note that (dafrc0) = (akmat0)(fdar0).
c
c     Compare with:
c
c       EQ6/aderiv.f
c       EQ6/pderiv.f
c       EQ6/rderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nordmx,nrctmx,nrd1mx
c
      integer nord,nrct
c
      integer jreac(nrctmx)
c
      real*8 akmat0(nrd1mx,nrd1mx),dafrc0(nordmx,nrctmx),
     $ fdar0(nordmx,nrctmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,nrc
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
c     Recall the following jreac reactant status flag
c     conventions:
c
c       jreac =  0: set to react
c       jreac =  1: exhausted
c       jreac = -1: saturated, but the remaining reactant mass
c                     continues to react irreversibly
c       jreac =  2: saturated; the status of any remaining reactant
c                     mass is changed to that of a product phase
c
c     For jreac(nrc) = -1 or 2, the affinity is fixed at zero.
c     However, the actual calculated affinity values may be non-zero
c     owing to convergence tolerances. In EQ6/stepfd.f, the
c     corresponding finite differences are set to zero. In the present
c     subroutine, the corresponding derivatives are set to zero.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.-1 .or. jreac(nrc).eq.2) then
          do n = 1,nord
            dafrc0(n,nrc) = 0.
          enddo
        else
          do n = 1,nord
            dx = 0.
            do k = n,nord
              dx = dx + fdar0(k,nrc)*akmat0(n,k)
            enddo
            dafrc0(n,nrc) = dx
          enddo
        endif
      enddo
c
      end

      subroutine rxnsck(nbtmx1,cdrsi,nct,ndrsts,nentri,nerr,noutpt,
     $ ns,nsb,nttyo,qblkrs,qzerrs,udrsi,usblkf,uspec)
c
c     This subroutine conducts tests on the associated reaction
c     specified for a species. It detects any blank and duplicate
c     species names in the reaction and any zero-valued reaction
c     coefficients. It checks to see if the first species in the
c     reaction is the one formally associated with it, and that
c     The corresponding coefficient is negative.
c
c     Note: any blank names are replaced by the string '<blank>'.
c
c     This subroutine is called by:
c
c       eqpt/pcraq.f
c       eqpt/pcrsg.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmx1
c
      integer noutpt,nttyo
c
      integer nentri(nbtmx1)
c
      integer nct,ndrsts,nerr,ns,nsb
c
      logical qblkrs,qzerrs
c
      character(len=24) udrsi(nbtmx1),uspec(nbtmx1)
      character(len=24) usblkf
c
      real(8) cdrsi(nbtmx1)
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer j2,j3,j4,n,ncount
c
      integer ilnobl
c
      logical qduprs
c
      character*24 ux24
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Check for blank element names.
c
      qblkrs = .false.
      ncount = 0
      do n = 1,ndrsts
        j3 = ilnobl(udrsi(n))
        if (j3 .le. 0) then
          ncount = ncount + 1
          udrsi(n) = '<blank>'
        endif
      enddo
c
      if (ncount .gt. 0) then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1000) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1000) uspec(ns)(1:j2),usblkf(1:j4)
 1000   format(/' * Error - (eqpt/rxnsck) The species ',a,
     $  ' appearing',/7x,'on the data file in the ',a,' superblock',
     $  ' has a specified',/7x,'reaction with blank species names',
     $  ' in the following positions:',/)
        do n = 1,ndrsts
          if (udrsi(n)(1:7) .eq. '<blank>') then
            write (ux8,'(i5)') n
            call lejust(ux8)
            j4 = ilnobl(ux8)
            write (noutpt,1010) ux8(1:j4)
            write (nttyo,1010) ux8(1:j4)
 1010       format(9x,a)
          endif
        enddo
        qblkrs = .true.
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for a species appearing more than once in the reaction
c
      call nrxnck(nbtmx1,ndrsts,nentri,nerr,qduprs,udrsi)
c
      if (qduprs) then
c
c       Make an exception for the reaction O2(g) = O2(g) when
c       in the gases superblock and O2(g) is the redox species.
c       Here the O2(g) on the left-hand side is an actual gas
c       species, while that on the right is actually the
c       fictive aqueous species.
c
        if (usblkf(1:5) .eq. 'gases') then
          if (uspec(ns)(1:6) .eq. 'O2(g) ') then
            if (nsb .eq. (nct + 1)) then
              if (uspec(nsb)(1:6) .eq. 'O2(g) ') then
                if (ndrsts .eq. 2) then
                  if (udrsi(1)(1:6) .eq. 'O2(g) ') then
                    if (udrsi(2)(1:6) .eq. 'O2(g) ') then
                      qduprs = .false.
                      nentri(1) = 1
                      nentri(2) = 1
                    endif
                  endif
                endif
              endif
            endif
          endif
        endif
      endif
c
      if (qduprs)  then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1040) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1040) uspec(ns)(1:j2),usblkf(1:j4)
 1040   format(/' * Error - (eqpt/rxnsck) The species ',a,
     $  ' appearing',/7x,'on the data file in the ',a,' superblock',
     $  ' has a specified',/7x,'reaction for which there is more',
     $  ' than one entry for the following',/7x,'species(s):',/)
        do n = 1,ndrsts
          if (nentri(n) .gt. 1) then
            write (ux8,'(i5)') nentri(n)
            call lejust(ux8)
            j3 = ilnobl(ux8)
            j4 = ilnobl(udrsi(n))
            write (noutpt,1050) udrsi(n)(1:j4),ux8(1:j3)
            write (nttyo,1050) udrsi(n)(1:j4),ux8(1:j3)
 1050       format(9x,a,' (',a,' entries)')
          endif
        enddo
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for zero-valued stoichiometric coefficients.
c
      qzerrs = .false.
      do n = 1,ndrsts
        if (cdrsi(n) .eq. 0.) qzerrs = .true.
      enddo
c
      if (qzerrs) then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1080) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1080) uspec(ns)(1:j2),usblkf(1:j4)
 1080     format(/' * Error - (eqpt/rxnsck) The species ',a,
     $    ' appearing',/7x,'on the data file in the ',a,' superblock',
     $    ' has an associated',/7x,'reaction with zero-valued',
     $    ' coefficients for the following species:',/)
        do n = 1,ndrsts
          if (cdrsi(n) .eq. 0.) then
            ux24 = udrsi(n)
            j3 = ilnobl(ux24)
            write (noutpt,1090) ux24(1:j3)
            write (nttyo,1090) ux24(1:j3)
 1090       format(9x,a)
          endif
        enddo
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Check the name of the species as it appears in the associated
c       reaction. A species must appear first in its associated
c       reaction.
c
        if (ndrsts .ge. 2) then
          if (uspec(ns)(1:24) .ne. udrsi(1)(1:24)) then
            j2 = ilnobl(uspec(ns))
            j4 = ilnobl(usblkf)
            ux24 = udrsi(1)
            j3 = ilnobl(ux24)
            write (noutpt,1210) uspec(ns)(1:j2),usblkf(1:j4),
     $      ux24(1:j3),uspec(ns)(1:j2)
            write (nttyo,1210) uspec(ns)(1:j2),usblkf(1:j4),
     $      ux24(1:j3),uspec(ns)(1:j2)
 1210       format(/' * Error - (eqpt/rxnsck) The species ',a,
     $      ' appearing',/7x,'on the data file in the ',a,' superblock',
     $      ' does not appear',/7x,'in its associated reaction.',
     $      ' Should "',a,'" in the',/7x,'reaction be "',a,'", or',
     $      ' vice versa?')
            nerr = nerr + 1
          else
c
c           Check to see that the associated reaction coefficient is
c           negative.
c
            if (cdrsi(1) .ge. 0.) then
              j2 = ilnobl(uspec(ns))
              j4 = ilnobl(usblkf)
              write (noutpt,1220) uspec(ns)(1:j2),usblkf(1:j4),cdrsi(1)
              write (nttyo,1220) uspec(ns)(1:j2),usblkf(1:j4),cdrsi(1)
 1220         format(/' * Error - (eqpt/rxnsck) The species ',a,
     $        ' appearing',/7x,'on the data file in the ',a,
     $        ' superblock does not have a',/7x,'negative reaction',
     $        ' coefficient, as is required. The coefficient',
     $        /7x,'has a value of ',1pe12.5,'.')
              nerr = nerr + 1
            endif
          endif
        endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 return
      end

      subroutine gcoeff(abar,acflgc,actwlc,adh,adhh,adhv,al10,
     $ aphi,azero,a3bar,a3bars,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ cco2,conc,delam,dgpit,dpelm,dpslm,dselm,elam,fje,fxi,gpit,
     $ ielam,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta,insgf,
     $ iopg,ipbtmx,izmax,jcsort,nalpha,napmax,napt,narn1,narn2,
     $ natmax,nazmmx,nazpmx,nchlor,nhydr,nmut,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,nopgmx,noutpt,nslt,nsltmx,nslx,nstmax,nsxi,
     $ nsxmax,nsxx,nttyo,omega,palpha,pelm,pmu,press,pslamn,
     $ pslm,qhawep,qpit75,selm,sigmam,tempk,uspec,xbarwc,xbrwlc,
     $ zchar,zchsq2,zchcu6)
c
c     This subroutine computes activity coefficients of aqueous species
c     using various models. The model used is determined by the option
c     flag iopg(1):
c
c        -1  Davies equation
c         0  B-dot equation plus others
c         1  Pitzer's equations. The use or non-use of higher order
c            electrostatic terms is determined by the E-theta flag
c            on the supporting data file.
c         2  HC + DHC
c
c     The computed activity coefficients may be normalized to make
c     them consistent with a given pH convention. This is determined
c     by the option flag iopg(2):
c
c        -1  No normalization
c         0  Normalization to the NBS pH scale
c         1  Normalization to the Mesmer pH scale (pH is numerically
c            equal to -log m(H+))
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQ3NR/arrset.f
c       EQ6/exivar.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       azero  = array of hard core diameters of aqueous species
c       bdh    = Debye-Huckel B parameter
c       bdot   = B-dot parameter
c       cco2   = coefficients of the Drummond (1981) equation
c       conc   = array of species concentrations
c       fje    = the 3rd-order electrostatic moment function J
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       ielam  = flag to not use (-1) or use (0) "higher order"
c                  (higher than 2nd order) electrostatic terms in
c                  those activity coefficient models which contain
c                  provision for such terms
c       insgf  = array of activity coefficient flags for aqueous
c                  species, used in the case of neutral solute
c                  species when using the B-dot model
c       iopg   = array of activity coefficient option switches
c       izmax  = max norm of the electrical charges of the aqueous
c                  species
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = index of the first aqueous species; this is also
c                  the index of the solvent, water
c       narn2  = index of the last aqueous species
c       nchlor = index of the aqueous chloride ion
c       nhydr  = index of the aqueous hydrogen ion
c       omega  = water constant; ~55.51
c       press  = pressure, bars
c       sigmam = sum of solute molalities
c       tempk  = temperature, K
c       xbarwc = mole fraction of water (calculated)
c       xbrwlc = log mole fraction of water (calculated)
c       zchar  = array of electrical charge numbers for the various
c                  species
c       zchsq2 = array of z**2/2 values
c       zchcu6 = array of z**3/6 values
c
c     Principal Output:
c
c       acflgc = array of log activity coefficients (calculated)
c                  of the various species
c       actwlc = log activity of water (calculated)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations, for all variables except
c     those intimately related to Pitzer's equations.
c
      integer ipbtmx,natmax,nopgmx,nstmax
c
      integer insgf(natmax),iopg(nopgmx),jcsort(nstmax)
c
      integer ielam,izmax,narn1,narn2,nchlor,nhydr,noutpt,nttyo
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      real(8) acflgc(nstmax),azero(natmax),a3bars(natmax),conc(nstmax),
     $ cco2(5),zchar(nstmax),zchsq2(nstmax),zchcu6(nstmax)
c
      character(len=48) uspec(nstmax)
c
      real(8) adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real(8) abar,actwlc,al10,a3bar,fje,fxi,omega,press,sigmam,tempk,
     $ xbarwc,xbrwlc
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations, for all variables
c     intimately related to Pitzer's equations.
c
c     Integer variables and arrays.
c
      integer napmax,nazmmx,nazpmx,nmutmx,nmxmax,nsltmx,nsxmax
c
      integer napt,nmut,nslt
c
      logical qhawep,qpit75
c
      integer nalpha(nsltmx),nmux(3,nmutmx),nmxi(2,natmax),
     $ nmxx(3,nmxmax),nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
c
c     Empirical interaction coefficients and related functions at
c     temperature and pressure.
c
      real(8) dgpit(2,ipbtmx,napmax),dpslm(2,nsltmx),
     $ gpit(ipbtmx,napmax),palpha(ipbtmx,napmax),pmu(nmutmx),
     $ pslamn(0:ipbtmx,nsltmx),pslm(nsltmx)
c
c     Theoretical higher-order electrostatic interaction coefficients
c     and related functions at temperature and pressure.
c
      real(8) delam(2,nazpmx,nazpmx),dpelm(2,nazpmx,nazpmx),
     $ dselm(2,nazmmx:nazpmx),elam(nazpmx,nazpmx),pelm(nazpmx,nazpmx),
     $ selm(nazmmx:nazpmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iz,j2,n,na,nref,ns,nss,ns1,ns2,ns3
c
      integer ilnobl
c
      character(len=8) ux8
c
      real(8) acfnbs,afac,alm,bt,btp,chc,delacf,elsum,elsump,elsums,
     $ elsumw,f,fa,flsum,fp,fpp,lnaw,lngam,muterm,musum,musumw,slsum,
     $ slsump,spsum,spsump,ssumw,xx,xy,zchtot
c
      real(8) csum,csumca,csum1,csum2,psum1,psum2,zesum
c
      real(8) tlg
c
c-----------------------------------------------------------------------
c
c     Here btp is the effective product of Debye-Huckel B and the hard
c     core diameter used in Pitzer's equations.
c
      data btp /1.2/
c
c     Here chc is the hard core repulsion constant.
c
      data chc /1.2577e-3/
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't actually do anything except
c     cause the compiler not to complain that fje, press, and zchcu6
c     are not used.
c
      xx = fje
      xy = xx
      fje = xy
c
      xx = press
      xy = xx
      press = xy
c
      xx = zchcu6(1)
      xy = xx
      zchcu6(1) = xy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the mole fraction of water from sigmam. Note that
c     this value is subject to under-relaxation truncation constraints
c     placed on sigmam.
c
      xbarwc = omega/(omega + sigmam)
      xbrwlc = tlg(xbarwc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the total charge per kg H2O (Z in Pitzer's equations).
c     Note that this is a sorted summation. It is not necessary to
c     exclude water, because it has zero charge.
c
      zchtot = 0.
      do nss = narn1,narn2
        ns = jcsort(nss)
        zchtot = zchtot + conc(ns)*abs(zchar(ns))
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. -1) then
c
c       Use the Davies equation.
c
        call gdavie(acflgc,actwlc,adh,al10,fxi,narn1,narn2,nstmax,
     $  omega,sigmam,xbrwlc,zchsq2)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 0) then
c
c       Use the B-dot equation and associated approximations.
c
        call gbdot(acflgc,actwlc,adh,al10,azero,bdh,bdot,cco2,
     $  fxi,insgf,narn1,narn2,natmax,nstmax,omega,sigmam,tempk,
     $  xbrwlc,zchar,zchsq2)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 1) then
c
c       Use Pitzer's equations.
c
c       Compute the Debye-Huckel function f and its ionic strength
c       derivatives.
c
        bt = btp
        call gfdho(aphi,bt,f,fp,fpp,fxi)
c
        elsumw = 0.
        elsums = 0.
        elsump = 0.
        if (ielam .ge. 0) then
c
c         Get E-lambda (elam) and its derivatives (delam) for the
c         various charge combinations.
c
          call gelam(aphi,delam,dpelm,elam,fxi,izmax,nazpmx,
     $    pelm,qpit75)
c
c         Compute the following second order sums in E-lambda and its
c         ionic strength derivatives:
c
c           elsumw: SUM(ij) [E-lambda(ij) + I*E-lambda'(ij)]*m(i)*m(j)
c
c           elsums: SUM(ij) E-lambda'(ij)*m(i)*m(j)
c
c           elsump: SUM(ij) E-lambda''(ij)*m(i)*m(j) [Not used]
c
c         Here ij refers to any species pair, but non-zero
c         contributions only arise from cc' and aa' pairs. Note that:
c
c           elsumw = 2*
c                 [SUM(c'>c) {E-theta(cc') + I*E-theta'(cc')}m(c)m(c')
c                + SUM(a'>a) {E-theta(aa') + I*E-theta'(aa')}m(a)m(a')]
c
c           elsums = 2*[SUM(c'>c) E-theta'(cc')m(c)m(c')
c                     + SUM(a'>a) E-theta'(aa')m(a)m(a')]
c
c           elsump = 2*[SUM(c'>c) E-theta''(cc')m(c)m(c')
c                     + SUM(a'>a) E-theta''(aa')m(a)m(a')] [Not used]
c
c         Note also that "flim" in EQ3/6 is 2 * F, as F is commonly
c         defined in the Pitzer literature. This is because
c         flim will be multipled by z(i)^2/2 instead of z(i)^2.
c
          call gesum(conc,delam,elam,elsump,elsums,elsumw,
     $    fxi,narn1,narn2,nazpmx,nstmax,zchar)
c
c         Compute the following first order sum arrays in E-lambda
c         and its ionic strength derivative:
c
c           selm(i):  SUM(j) E-lambda(ij)*m(j)
c           dselm(1,i): SUM(j) E-lambda'(ij)*m(j) [Not used]
c
          call gselm(conc,delam,dselm,elam,izmax,narn1,narn2,nazmmx,
     $    nazpmx,nstmax,selm,zchar)
        endif
c
c       Compute the g(x) function (gpit) and its derivatives (dgpit)
c       for pairs of alpha coefficients.
c
        call gdd(dgpit,fxi,gpit,ipbtmx,napmax,napt,palpha)
c
c       Compute the S-lambda functions and their ionic strength
c       derivatives.
c
        call gslam(dgpit,dpslm,gpit,ipbtmx,nalpha,napmax,nslt,
     $  nsltmx,pslamn,pslm)
c
c       Compute the following second order sum in S-lambda and its
c       ionic strength derivatives:
c
c         ssumw: SUM(ij) [ S-lambda(ij) + I*S-lambda'(ij) ]*m(i)*m(j)
c
        call gssum(conc,dpslm,fxi,nslt,nsltmx,nslx,nstmax,pslm,
     $  ssumw,uspec)
c
        if (qhawep) then
c
c         Use the form corresponding to C (from Cphi), psi, zeta,
c         and any mu not derived from Cphi, psi, or zeta.
c         Calculate the following sum that appears in the activity
c         coefficients of both water and solutes:
c
c           csumca:  SUM(ca) m(c)m(a)C(ca)
c
c         This sum is technically a double sum, but it is evaluated
c         here as an equivalent single sum over all ca combinations.
c
          csumca = 0.
          do n = ifcphi1,ilcphi1
            ns1 = nmux(1,n)
            ns3 = nmux(3,n)
            csumca = csumca + pmu(n)*conc(ns1)*conc(ns3)
          enddo
        endif
c
c       Compute the contributions to the activity coefficient of
c       water from third-order terms.
c
        muterm = 0.
c
        if (qhawep) then
c
c         Use the form corresponding to C (from Cphi), psi, zeta,
c         and any mu not derived from Cphi, psi, or zeta.
c
          csum = zchtot*csumca
c
          psum1 = 0.
c
c         This sum is technically a triple sum, but is evaluated
c         as a single sum over all cc'a combinations.
c
          do n = ifpsi1,ilpsi1
            ns1 = nmux(1,n)
            ns2 = nmux(2,n)
            ns3 = nmux(3,n)
            psum1 = psum1 + pmu(n)*conc(ns1)*conc(ns2)*conc(ns3)
          enddo
c
          psum2 = 0.
c
c         This sum is technically a triple sum, but is evaluated
c         as a single sum over all aa'c combinations.
c
          do n = ifpsi2,ilpsi2
            ns1 = nmux(1,n)
            ns2 = nmux(2,n)
            ns3 = nmux(3,n)
            psum2 = psum2 + pmu(n)*conc(ns1)*conc(ns2)*conc(ns3)
          enddo
c
          zesum = 0.
c
c         This sum is technically a triple sum, but is evaluated
c         as a single sum over all nca combinations.
c
          do n = ifzeta,ilzeta
            ns1 = nmux(1,n)
            ns2 = nmux(2,n)
            ns3 = nmux(3,n)
            zesum = zesum + pmu(n)*conc(ns1)*conc(ns2)*conc(ns3)
          enddo
c
          musum = 0.
c
c         The following involves sums in mu(nnn) and mu(nnn').
c
          do n = ifnnn,ilnnn
            musum = musum + 2.*pmu(n)*conc(ns1)*conc(ns1)*conc(ns1)
          enddo
c
          do n = ifn2n,iln2n
            ns1 = nmux(1,n)
            ns2 = nmux(2,n)
            ns3 = nmux(3,n)
c
c           Note that it doesn't matter here whether ns1 = ns2 or
c           ns2 = ns3.
c
            musum = musum + 6.*pmu(n)*conc(ns1)*conc(ns2)*conc(ns3)
          enddo
c
          muterm = csum + psum1 + psum2 + zesum + musum
c
c         Multiply muterm by 2 for use in calculating the activity
c         of water directly.
c
          muterm = 2.*muterm
c
        else
c
c         Use the original pure mu form.
c
c         Compute the following third order sum in mu:
c
c           musumw: SUM(ijk) mu(ijk)*m(i)*m(j)*m(k)
c
          call gmsum(conc,musumw,nmut,nmutmx,nmux,nstmax,pmu,uspec)
          muterm = 2.*musumw
c
        endif
c
c       Compute the activity of water.
c
        actwlc = -(1./(al10*omega)) *
     $  (sigmam + fxi*fp - f + elsumw + ssumw + muterm)
c
c       Compute the activity coefficient of water. Note that this
c       is mole-fraction based.
c
        acflgc(narn1) = actwlc - xbrwlc
c
c       Compute the following second order sums in the first and
c       second ionic strength derivatives of S-lambda:
c
c         spsum:  SUM(jk) S-lambda'(jk)*m(j)*m(k)
c         spsump: SUM(jk) S-lambda''(jk)*m(j)*m(k) [Not used]
c
c       Here jk always refers to a cation-ion pair. Note that:
c
c         spsum = 2 * SUM(ca) B'(ca)m(a)m(c)
c         spsump = 2 * SUM(ca) B''(ca)m(a)m(c)
c
c       Note also that "flim" in EQ3/6 is 2 * F, as F is commonly
c       defined in the Pitzer literature. This is because
c       flim will be multipled by z(i)^2/2 instead of z(i)^2.
c
        call gsdsm(conc,dpslm,nslt,nsltmx,nslx,nstmax,
     $  spsum,spsump,uspec)
c
        flsum = fp + elsums + spsum
c
c       Compute the activity coefficients of the aqueous
c       solute species.
c
        do ns = narn1 + 1,narn2
          na = ns - narn1 + 1
c
c         Logically, na (or ns) denotes aqueous species i.
c
          acflgc(ns) = 0.
          iz = nint(zchar(ns))
c
          elsum = 0.
          if (ielam .ge. 0) then
c
c           Get the E-lambda sum (this only depends on the
c           magnitude of the charge number):
c
c             selm(i): SUM(j) E-lambda(ij)*m(j)
c
            elsum = selm(iz)
          endif
c
c         Compute the following first order sums in S-lambda
c         and its ionic strength derivative:
c
c           slsum(i):  SUM(j) S-lambda(ij)*m(j)
c           slsump(i): SUM(j) S-lambda'(ij)*m(j)
c
          call gsgsm(conc,dpslm,na,natmax,nsltmx,nstmax,nsxi,nsxmax,
     $    nsxx,pslm,slsum,slsump,uspec)
c
c         Compute the contributions from third-order terms.
c
          muterm = 0.
c
          if (qhawep) then
c
c           Use the form corresponding to C (from Cphi), psi, zeta,
c           and any mu not derived from Cphi, psi, or zeta.
c
            csum1 = 0.
            if (zchar(ns) .gt. 0.) then
c
c             Have a cation. Loop over C(ca).
c
              do n = ifcphi1,ilcphi1
                ns1 = nmux(1,n)
                if (ns .eq. ns1) then
                  ns3 = nmux(3,n)
                  csum1 = csum1 + pmu(n)*conc(ns3)
                endif
              enddo
            elseif (zchar(ns) .lt. 0.) then
c
c             Have an anion. Loop over C(ac).
c
              do n = ifcphi2,ilcphi2
                ns1 = nmux(1,n)
                if (ns .eq. ns1) then
                  ns3 = nmux(3,n)
                  csum1 = csum1 + pmu(n)*conc(ns3)
                endif
              enddo
            endif
            csum1 = zchtot*csum1
c
            psum1 = 0.
            if (zchar(ns) .gt. 0.) then
c
c             Have a cation. Loop over psi(cc'a).
c
              do n = ifpsi1,ilpsi1
                ns1 = nmux(1,n)
                ns2 = nmux(2,n)
                ns3 = nmux(3,n)
                if (ns .eq. ns1) then
                  psum1 = psum1 + pmu(n)*conc(ns2)*conc(ns3)
                elseif (ns .eq. ns2) then
                  psum1 = psum1 + pmu(n)*conc(ns1)*conc(ns3)
                endif
              enddo
            elseif (zchar(ns) .lt. 0.) then
c
c             Have an anion. Loop over psi(aa'c).
c
              do n = ifpsi2,ilpsi2
                ns1 = nmux(1,n)
                ns2 = nmux(2,n)
                ns3 = nmux(3,n)
                if (ns .eq. ns1) then
                  psum1 = psum1 + pmu(n)*conc(ns2)*conc(ns3)
                elseif (ns .eq. ns2) then
                  psum1 = psum1 + pmu(n)*conc(ns1)*conc(ns3)
                endif
              enddo
            endif
c
            psum2 = 0.
c
c           This sum is technically a double sum, but is evaluated
c           as a single sum over all distinct values of psi(aa'c)
c           or psi(cc'a).
c
            if (zchar(ns) .gt. 0.) then
c
c             Have a cation. Loop over psi(aa'c).
c
              do n = ifpsi2,ilpsi2
                ns1 = nmux(1,n)
                ns2 = nmux(2,n)
                ns3 = nmux(3,n)
                if (ns .eq. ns3) then
                  psum2 = psum2 + pmu(n)*conc(ns1)*conc(ns2)
                endif
              enddo
            elseif (zchar(ns) .lt. 0.) then
c
c             Have an anion. Loop over psi(cc'a).
c
              do n = ifpsi1,ilpsi1
                ns1 = nmux(1,n)
                ns2 = nmux(2,n)
                ns3 = nmux(3,n)
                if (ns .eq. ns3) then
                  psum2 = psum2 + pmu(n)*conc(ns1)*conc(ns2)
                endif
              enddo
            endif
c
            csum2 = abs(zchar(ns))*csumca
c
            zesum = 0.
c
c           This sum is technically a double sum, but is evaluated
c           as a single sum over all distinct values of zeta(nca).
c
c           Have a cation, an anion, or a neutral. Loop over zeta(nca).
c
            do n = ifzeta,ilzeta
              ns1 = nmux(1,n)
              ns2 = nmux(2,n)
              ns3 = nmux(3,n)
              if (ns .eq. ns1) then
                zesum = zesum + pmu(n)*conc(ns2)*conc(ns3)
              elseif (ns .eq. ns2) then
                zesum = zesum + pmu(n)*conc(ns1)*conc(ns3)
              elseif (ns .eq. ns3) then
                zesum = zesum + pmu(n)*conc(ns1)*conc(ns2)
              endif
            enddo
c
            musum = 0.
c
            if (iz .eq. 0) then
c
c             The following involves sums in mu(nnn) and mu(nnn').
c
              do n = ifnnn,ilnnn
                ns1 = nmux(1,n)
                if (ns .eq. ns1) then
                  musum = musum + 3.*pmu(n)*conc(ns1)*conc(ns1)
                endif
              enddo
c
              do n = ifn2n,iln2n
                ns1 = nmux(1,n)
                ns2 = nmux(2,n)
                ns3 = nmux(3,n)
                if (ns .eq. ns1) then
                  if (ns1 .eq. ns2) then
                    musum = musum + 6.*pmu(n)*conc(ns1)*conc(ns3)
                  else
                    musum = musum + 3.*pmu(n)*conc(ns3)*conc(ns3)
                  endif
                elseif (ns .eq. ns3) then
                  if (ns2 .eq. ns3) then
                    musum = musum + 6.*pmu(n)*conc(ns1)*conc(ns3)
                  else
                    musum = musum + 3.*pmu(n)*conc(ns1)*conc(ns1)
                  endif
                endif
              enddo
            endif
c
            muterm = csum1 + psum1 + psum2 + csum2 + zesum + musum
c
          else
c
c           Use the original pure mu form.
c
c           Compute the following second order sum in mu:
c
c             musum(i): SUM(jk) mu(ijk)*m(j)*m(k)
c
            call gmdsm(conc,musum,na,natmax,nmutmx,nmxi,nmxmax,
     $      nmxx,ns,nstmax,pmu,uspec)
c
            muterm = 3.*musum
          endif
c
c         Note that zchsq2(ns) is z(i)^2/2.
c
          acflgc(ns) = (zchsq2(ns)*flsum + 2.0*elsum + 2.0*slsum
     $    + muterm) / al10
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 2) then
c
c       Use the HC + DHC equations
c
c       Get the average ion size (abar), the characteristic average
c       cube of the distance of closest approach (a3bars), and the
c       average cube of the distance of closest approach (a3bar).
c
        call cabar(abar,azero,conc,jcsort,fxi,narn1,narn2,natmax,
     $  nstmax,zchsq2)
c
        call ca3bar(azero,a3bar,a3bars,conc,jcsort,narn1,
     $  narn2,natmax,nstmax,sigmam)
c
c       Get the Debye-Huckel function f and its ionic strength
c       derivatives.
c
        bt = bdh*abar
        call gfdhc(adh,bt,f,fp,fpp,fxi)
c
c       Compute the activity of water.
c
        xx = 1. + (sigmam/omega)
        alm = log(xx)
        lnaw = - alm - (fxi*fp - f)/omega
     $  - (chc*a3bar*(sigmam**2))/(omega)
        actwlc = lnaw/al10
        acflgc(narn1) = actwlc - xbrwlc
c
c       Compute the activity coefficients of the aqueous
c       solute species.
c
        fa = 3.*fxi*fp - 2.*f
        do ns = narn1 + 1,narn2
          acflgc(ns) = 0.
          na = ns - narn1 + 1
          afac = (azero(na) - abar)/abar
          lngam = -alm + zchsq2(ns)*fp + (zchsq2(ns)*fa*afac)/fxi
     $    + 2.*chc*sigmam**a3bars(na)
          acflgc(ns) = lngam/al10
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1).le.-2 .or. iopg(1).ge.3) then
        write (ux8,'(i5)') iopg(1)
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1000) ux8(1:j2)
        write (nttyo,1000) ux8(1:j2)
 1000   format(/' * Error - (EQLIBG/gcoeff) Programming error trap:',
     $  ' Have an',/7x,'illegal value of ',a,' for the option switch',
     $  ' iopg(1), which determines',/7x,'the model to use for the',
     $  ' activity coefficients of aqueous species.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make activity coefficients consistent with a specified pH
c     scale.
c
c       iopg(2) = -1   Use activity coefficients as is
c                = 0   Make consistent with NBS pH scale
c                = 1   Make consistent with the Mesmer pH scale
c                      (log gamma H+ = 0)
c
      if (iopg(2) .eq. 0)  then
        call nbsgam(acfnbs,adh,fxi,nchlor,noutpt,nttyo)
        delacf = acfnbs - acflgc(nchlor)
        nref = nchlor
        call gcscal(acflgc,delacf,narn1,narn2,nref,nstmax,zchar)
      endif
c
      if (iopg(2) .eq. 1) then
        delacf = -acflgc(nhydr)
        nref = nhydr
        call gcscal(acflgc,delacf,narn1,narn2,nref,nstmax,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rdwttl(ipch,ipcv,jpdblo,jpfcmx,jptffl,narxt,ndata1,
     $ ndat0s,ndat1f,noutpt,nslist,ntitld,ntidmx,ntprmx,ntprt,nttyo,
     $ uakey,utitld)
c
c     This suboutine reads the title on the DATA0 file and writes it
c     on the DATA1 and DATA1F files. It checks the DATA0 file
c     header for validity. It also searches the title for embedded
c     flags and data indicating special treatment.
c
c     Possible embedded flags and data deal with the following:
c
c       1. Defining the temperature grid used on the data file.
c          By default, the classic eight-temperature grid is used.
c       2. Indicating the presence of data grids for enthalpy
c          and volume functions. By default, these data grids
c          are assumed to be absent.
c       3. Defining the temperature function used to describe
c          Pitzer interaction parameters. By default, this function
c          is the classic second-order Taylor's series centered
c          at 25C.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       ipch   = enthalpy functions data grid flag:
c                  -1 = no enthalpy grids
c                   0 = enthalpy grids present
c                   1 = grids present for the enthalpy and its first
c                         pressure derivative
c                   2 = grids present for the enthalpy and its first
c                         and second pressure derivatives
c       ipcv   = volume functions data flag:
c                  -1 = no volume grids
c                   0 = volume grids present
c                   1 = grids present for the volume and its first
c                         pressure derivative
c                   2 = grids present for the volume and its first
c                         and second pressure derivatives
c       ntitld = the number of lines in the title
c       utitld = array of title lines
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jpfcmx,ntidmx,ntprmx
c
      integer narxt(ntprmx)
c
      integer ndata1,ndat0s,ndat1f,noutpt,nslist,ntitld,nttyo
c
      integer ipch,ipcv,jpdblo,jptffl,ntprt
c
      character(len=80) utitld(ntidmx)
      character(len=8) uakey
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,j2,j3,j4,k,n,narxti,nerr,ntpr,ntpri
c
      integer ilnobl
c
      logical qrderr
c
      character(len=56) ux56
c
      character(len=80) ulbufa,ulbufb
      character(len=72) uterm,utermc
      character(len=32) upchst,upcvst
      character(len=8) ustr,ux8a,ux8b
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     Read the data file title.
c
      ntitld = ntidmx
      do n = 1,ntitld
        read (ndat0s,1000,end=990,err=995) utitld(n)
 1000   format(a)
        if (utitld(n)(1:8) .eq. uterm(1:8)) go to 110
      enddo
  110 continue
c
c     Write title information.
c
      do n = 1,ntitld
         j2 = ilnobl(utitld(n))
         j2 = min(j2,79)
         write (ndata1) utitld(n)
         write (ndat1f,1000) utitld(n)(1:j2)
         write (nttyo,1140) utitld(n)(1:j2)
         write (noutpt,1140) utitld(n)(1:j2)
         write (nslist,1140) utitld(n)(1:j2)
 1140    format(' ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the parameters for the temperature grid used for log K values
c     and standard state enthalpy and volume functions.
c
c       ntprt       = the number of temperature ranges
c       narxt(ntpr) = the number of points or coefficients in the
c                       ntpr-th temperature range
c
c     The last point of the ntpr-th temperature range is also the first
c     point of the following range, if any. This insures continuity.
c     The default values correspond to the original EQ3/6 data grid:
c
c       ntprt = 2
c       narxt(1) = 4  (0, 25, 60 100 C)
c       narxt(2) = 5  (100, 150, 200, 250, 300 C)
c
c     Note: the number of temperature ranges (ntprt) is equal to
c     the dimensioned limit (ntpr_asv), which has been determined
c     by a prior scan. The prior scan has also provided narx_asv,
c     the dimenionsed limit on the number of values in a temperature
c     range. This was found as the greatest value of any range.
c     Now, it is necessary to get the actual value for each range.
c
      ntprt = ntprmx
      call initiz(narxt,ntprmx)
      if (ntprt .eq. 2) then
        narxt(1) = 4
        narxt(2) = 5
      endif
c
      do ntpr = 1,ntprt
        do n = 1,ntitld
          ulbufa = ' '
          ulbufb = ' '
          j = 0
c
c         Check for a keystring.
c
          i = index(utitld(n),'NO. OF POINTS IN RANGE')
          if (i .gt. 0) then
            j = i + 22
          else
             i = index(utitld(n),'NUMBER OF POINTS IN RANGE')
            if (i .gt. 0) then
              j = i + 25
            else
              i = index(utitld(n),'NARXT')
              if (i .gt. 0) j = i + 5
            endif
          endif
c
          if (j .gt. 0) then
c
c           Extract a number acting as a subscript to the keystring.
c
            ulbufb = utitld(n)(j:80)
            call lejust(ulbufb)
            j = index(ulbufb,' ')
            j = min(j,9)
            k = j - 1
            if (k .gt. 0) then
              ustr = ulbufb(1:k)
              call chrint(ntpri,nttyo,qrderr,ustr)
              if (qrderr) go to 997
              if (ntpri .ne. ntpr) j = 0
            else
              j = 0
            endif
          endif
c
          if (j .gt. 0) then
c
c           Check for an equal sign following the keystring.
c
            ulbufa = ulbufb(j:80)
            call lejust(ulbufa)
            i = index(ulbufa,'=')
            j = 2
            if (i .ne. 1) j = 0
          endif
c
          if (j .gt. 0) then
c
c           Extract a number matching the keystring.
c
            ulbufb = ulbufa(j:80)
            call lejust(ulbufb)
            ustr = ulbufb(1:8)
            call chrint(narxti,nttyo,qrderr,ustr)
            if (qrderr) go to 997
            narxt(ntpr) = narxti
            go to 220
          endif
        enddo
  220   continue
c
      enddo
c
      nerr = 0
      ntpr = 1
      if (narxt(ntpr) .lt. 2) then
        write (ux8a,'(i5)') ntpr
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        write (ux8b,'(i5)') narxt(ntpr)
        call lejust(ux8b)
        j4 = ilnobl(ux8b)
        write (noutpt,1320) ux8a(1:j3),ux8b(1:j4)
        write (nttyo,1320) ux8a(1:j3),ux8b(1:j4)
 1320   format(/' * Error - (EQPT/rdwttl) The number of points in',
     $  /7x,'temperature range ',a,' is ',a,'. The number of',
     $  /7x,'points in the first or last temperature range must be',
     $  /7x,'at least 2.')
        nerr = nerr + 1
      endif
c
      do ntpr = 2,ntprt - 1
        if (narxt(ntpr) .lt. 3) then
          write (ux8a,'(i5)') ntpr
          call lejust(ux8a)
          j3 = ilnobl(ux8a)
          write (ux8b,'(i5)') narxt(ntpr)
          call lejust(ux8b)
          j4 = ilnobl(ux8b)
          write (noutpt,1330) ux8a(1:j3),ux8b(1:j4)
          write (nttyo,1330) ux8a(1:j3),ux8b(1:j4)
 1330     format(/' * Error - (EQPT/rdwttl) The number of points in',
     $    /7x,'temperature range ',a,' is ',a,'. The number of',
     $    /7x,'points in an interior temperature range must be at',
     $    /7x,'least 3.')
          nerr = nerr + 1
        endif
      enddo
c
      ntpr = ntprt
      if (ntpr.gt.1 .and. narxt(ntpr).lt.2) then
        write (ux8a,'(i5)') ntpr
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        write (ux8b,'(i5)') narxt(ntpr)
        call lejust(ux8b)
        j4 = ilnobl(ux8b)
        write (noutpt,1320) ux8a(1:j3),ux8b(1:j4)
        write (nttyo,1320) ux8a(1:j3),ux8b(1:j4)
        nerr = nerr + 1
      endif
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the grid parameters.
c
      ux56 = 'Number of ranges in the logK temperature grid'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1350) ux56(1:j2)
 1350 format(a)
c
      write (ndata1) ntprt
      write (ndat1f,1360) ntprt
 1360 format(i5)
c
      do ntpr = 1,ntprt
        ux56 = 'Number of points in range '
        j2 = ilnobl(ux56)
        write (ux8a,'(i5)') ntpr
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        ux56(j2 + 2: j2 + 1 + j3) = ux8a(1:j3)
c
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1350) ux56(1:j2)
c
        n = narxt(ntpr)
        write (ndata1) n
        write (ndat1f,1360) n
      enddo
c
      write (ux8a,'(i5)') ntprt
      call lejust(ux8a)
      j3 = ilnobl(ux8a)
      write (noutpt,1380) ux8a(1:j3)
      write (nttyo,1380) ux8a(1:j3)
 1380 format(/' Number of logK temperature grid ranges= ',a)
      do ntpr = 1,ntprt
        write (ux8a,'(i5)') ntpr
        call lejust(ux8a)
        j2 = ilnobl(ux8a)
        n = narxt(ntpr)
        write (ux8b,'(i5)') n
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
 1390   format('   Number of points in range ',a,'= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set flags for enthalpy and volume functions data grids.
c
      ipch = -1
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'ENTHALPY')
        if (i .gt. 0) j = i + 8
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) ipch = 0
          go to 300
        endif
      enddo
  300 continue
c
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'dH/dP')
        if (i .gt. 0) j = i + 5
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) then
            if (ipch .eq. 0) then
              ipch = 1
            else
              write (noutpt,1400)
              write (nttyo,1400)
 1400         format(/" * Error - (EQPT/rdwttl) Can't use dH/dP data",
     $        ' without',/7x,'enthalpy (H) data.')
              stop
            endif
          endif
          go to 310
        endif
      enddo
  310 continue
c
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'d2H/dP2')
        if (i .gt. 0) j = i + 7
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) then
            if (ipch .eq. 1) then
              ipch = 2
            else
              write (noutpt,1410)
              write (nttyo,1410)
 1410         format(/" * Error - (EQPT/rdwttl) Can't use d2H/dP2",
     $        ' data without',/7x,'enthalpy (H) and dH/dP data.')
              stop
            endif
          endif
          go to 320
        endif
      enddo
  320 continue
c
      ipcv = -1
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'VOLUME')
        if (i .gt. 0) j = i + 6
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) ipcv = 0
          go to 330
        endif
      enddo
  330 continue
c
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'dV/dP')
        if (i .gt. 0) j = i + 5
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) then
            if (ipcv .eq. 0) then
              ipcv = 1
            else
              write (noutpt,1420)
              write (nttyo,1420)
 1420         format(/" * Error - (EQPT/rdwttl) Can't use dV/dP data",
     $        ' without',/7x,'volume (V) data.')
              stop
            endif
          endif
          go to 340
        endif
      enddo
  340 continue
c
      do n = 1,ntitld
        ulbufa = ' '
        j = 0
c
c       Check for a keystring.
c
        i = index(utitld(n),'d2V/dP2')
        if (i .gt. 0) j = i + 7
c
        if (j .gt. 0) then
c
c         Check for an equal sign following the keystring.
c
          ulbufa = utitld(n)(j:80)
          call lejust(ulbufa)
          i = index(ulbufa,'=')
          j = 2
          if (i .ne. 1) j = 0
        endif
c
        if (j .gt. 0) then
c
c         Extract a string input matching the keystring.
c
          ustr = ulbufa(2:9)
          call lejust(ustr)
          k = index(ustr,'ON')
          if (k .le. 0) k = index(ustr,'PRESENT')
          if (k .le. 0) k = index(ustr,'ACTIVE')
          if (k .gt. 0) then
            if (ipcv .eq. 1) then
              ipcv = 2
            else
              write (noutpt,1430)
              write (nttyo,1430)
 1430         format(/" * Error - (EQPT/rdwttl) Can't use d2V/dP2",
     $        ' data without',/7x,'volume (V) and dV/dP data.')
              nerr = nerr + 1
            endif
          endif
          go to 350
        endif
      enddo
  350 continue
c
      if (ipch.gt.0 .and. ipcv.lt.0) then
        write (noutpt,1440)
        write (nttyo,1440)
 1440   format(/" * Error - (EQPT/rdwttl) Can't have pressure",
     $  ' corrections',
     $  /7x,'for enthalpy functions without having such corrections',
     $  /7x,'for log K functions. At a minimum, volume functions',
     $  /7x,'must be present.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write flags for enthalpy and volume functions grids.
c
      ux56 = 'Enthalpy functions flag'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1450) ux56(1:j2)
 1450 format(a)
c
      write (ndata1) ipch
      write (ndat1f,1460) ipch
 1460 format(i5)
c
      upchst = 'Not present'
      if (ipch .eq. 0) then
        upchst = 'Present, no dH/dP data'
      elseif (ipch .eq. 1) then
        upchst = 'Present, with dH/dP data'
      elseif (ipch .ge. 2) then
        upchst = 'Present, with dH/dP-dnH/dPn data'
        write (upchst,'(21x,i1,4x,i1)') ipch
      endif
      j2 = ilnobl(upchst)
c
      write (noutpt,1470) ipch,upchst(1:j2)
      write (nttyo,1470) ipch,upchst(1:j2)
 1470 format(/' Enthalpy functions flag= ',i2,' (',a,')')
c
      ux56 = 'Volume functions flag'
      write (ndata1) ux56
      j2 = ilnobl(ux56)
      write (ndat1f,1450) ux56(1:j2)
c
      write (ndata1) ipcv
      write (ndat1f,1460) ipcv
c
      upcvst = 'Not present'
      if (ipcv .eq. 0) then
        upcvst = 'Present, no dV/dP data'
      elseif (ipcv .eq. 1) then
        upcvst = 'Present, with dV/dP data'
      elseif (ipcv .ge. 2) then
        upcvst = 'Present, with dV/dP-dnV/dPn data'
        write (upcvst,'(21x,i1,4x,i1)') ipcv
      endif
      j2 = ilnobl(upcvst)
c
      write (noutpt,1480) ipcv,upcvst(1:j2)
      write (nttyo,1480) ipcv,upcvst(1:j2)
 1480 format(' Volume functions flag  = ',i2,' (',a,')')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Write the flag for Pitzer data block organization.
c
        ux56 = 'Pitzer data block organization flag'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1450) ux56(1:j2)
c
        write (ndata1) jpdblo
        write (ndat1f,1460) jpdblo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the temperature function used to represent Pitzer
c     interaction parameters. This is determined by the value
c     of jptffl, which was read previously by ggridp.f.
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
        if (jpdblo .eq. -1) then
          if (jptffl .ne. -1) then
            write (noutpt,1510)
            write (nttyo,1510)
 1510       format(/' * Note - (EQPT/rdwttl) Resetting the jptffl',
     $      ' Pitzer data',/7x,'temperature function flag to -1',
     $      " (classic 25C-centric Taylor's series",/7x,'truncated',
     $      ' at second order), because the Pitzer data block',
     $      /7x,'organization flag (jpdblo) is set to -1',
     $      ' ("Classical").',/7x,'Other Pitzer data temperature',
     $      ' functions are not permitted.')
            jptffl = -1
          endif
        endif
c
        if (jptffl .eq. -1) then
          if (jpfcmx .ne. 3) then
            write (noutpt,1520)
            write (nttyo,1520)
 1520       format(/' * Error - (EQPT/rdwttl) The number of terms',
     $      ' (jpfcmx) used in',/7x,'the Pitzer data temperature',
     $      ' function is not 3, as is required',/7x,'in the case',
     $      " of the classical 25C-centric Taylor's series",
     $      /7x,'truncated at second order (jptffl = -1).')
            nerr = nerr + 1
          endif
        endif
c
        if (jptffl .eq. 1) then
          if (jpfcmx .ne. 8) then
            write (noutpt,1530)
            write (nttyo,1530)
 1530       format(/' * Error - (EQPT/rdwttl) The number of terms',
     $      ' (jpfcmx) used in',/7x,'the Pitzer data temperature',
     $      ' function is not 8, as is required',/7x,'in the case',
     $      ' of the case of the Greenberg-Moller combination',
     $      /7x,'temperature function (jptffl = 1).')
            nerr = nerr + 1
          endif
        endif
c
        if (jptffl .eq. 0) then
          if (jpfcmx.lt.1 .or. jpfcmx.gt.5) then
            write (noutpt,1540)
            write (nttyo,1540)
 1540       format(/' * Error - (EQPT/rdwttl) The number of terms',
     $      ' terms (jpfcmx)',/7x,'used in the LLNL maximal five-term',
     $      ' temperature equation (jptffl = 0)',/7x,'is not in the',
     $      ' allowed range of of 1-5. ')
            nerr = nerr + 1
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Write the flag for the temperature function used to represent
c       Pitzer interaction coefficients.
c
        ux56 = 'Pitzer parameter temperature function'
        write (ndata1) ux56
        j2 = ilnobl(ux56)
        write (ndat1f,1450) ux56(1:j2)
c
        write (ndata1) jptffl
        write (ndat1f,1460) jptffl
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (ndat1f,1220) utermc(1:72)
 1220 format(a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdwttl) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the title of the DATA0 file.')
      if (n .le. 1) then
        write (noutpt,2010)
        write (nttyo,2010)
 2010   format(/7x,'This occurred while trying to read the first line',
     $  /7x,'of the title.')
      else
        ulbufa = utitld(n - 1)
        call lejust(ulbufa)
        j2 = ilnobl(ulbufa)
        j2 = min(j2,70)
        write (noutpt,2020) ulbufa(1:j2)
        write (nttyo,2020) ulbufa(1:j2)
 2020   format(/7x,'This occurred while trying to read the line',
     $  ' following',/7x,'the line:',/7x,'"',a,'"')
      endif
      stop
c
  995 write (noutpt,2030)
      write (nttyo,2030)
 2030 format(/' * Error - (EQPT/rdwttl) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      if (n .le. 1) then
        write (noutpt,2010)
        write (nttyo,2010)
      else
        ulbufa = utitld(n - 1)
        call lejust(ulbufa)
        j2 = ilnobl(ulbufa)
        j2 = min(j2,70)
        write (noutpt,2020) ulbufa(1:j2)
      endif
      stop
c
  997 ulbufa = utitld(n)
      call lejust(ulbufa)
      j2 = ilnobl(ulbufa)
      j2 = min(j2,70)
      write (noutpt,2050) ulbufa(1:j2)
      write (nttyo,2050) ulbufa(1:j2)
 2050 format(/' * Error - (EQPT/rdwttl) Encountered a read format',
     $ /7x,'error while reading data embedded in the title of the',
     $ /7x,'DATA0 file. This occurred while attempting to process',
     $ ' the line:',/7x,'"',a,'"')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chdxgr(delxi,dlxmx0,fdri0,fdrr0,iodb,jordlm,jreac,
     $ kord,nodbmx,nordmx,nordr,noutpt,nrct,nrctmx,nrd1mx,nsscmx,
     $ scalim,scfcr,sscrew,qriinf,rirec0,rrelr0,ureac)
c
c     This subroutine chooses a step size and order according to the
c     Gear accuracy criterion, examining the r vector and its
c     associated finite differences. Subroutine chdxgz.f performs
c     the same function for the z vector and its associated finite
c     differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrctmx,nordmx,nrd1mx,nsscmx
c
      integer noutpt
c
      integer iodb(nodbmx),jreac(nrctmx)
c
      integer jordlm,kord,nordr,nrct
c
      logical qriinf
c
      character(len=24) ureac(nrctmx)
c
      real(8) fdri0(nrd1mx),fdrr0(nrd1mx,nrctmx),rrelr0(nrctmx),
     $ sscrew(nsscmx)
c
      real(8) delxi,dlxmx0,rirec0,scalim,scfcr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensions.
c
      integer isv_nordmx
c
      SAVE isv_nordmx
c
      integer, dimension(:), allocatable :: kkk
c
      SAVE kkk
c
      character(len=24), dimension(:), allocatable :: uscal
c
      SAVE uscal
c
      real(8), dimension(:), allocatable :: scmax,scraw
c
      SAVE scmax,scraw
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ip1,j2,j3,k,nrc
c
      integer ilnobl
c
      character*24 uinv,urel,uzt,uzn
c
      real(8) adx,delchg,dlxii,fctr,fctrmn,relchg,rxx0,xip1
c
c-----------------------------------------------------------------------
c
      data uinv /'Inverse rate            '/,
     $     urel /'Relative rate           '/
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(kkk)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_nordmx = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (nordmx .ne. isv_nordmx) then
          DEALLOCATE(kkk,uscal,scmax,scraw)
          isv_nordmx = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_nordmx .eq. 0) then
        ALLOCATE(kkk(0:nordmx))
        ALLOCATE(uscal(0:nordmx))
        ALLOCATE(scmax(0:nordmx),scraw(0:nordmx))
        isv_nordmx = nordmx
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the contents of the local work arrays.
c
      do k = 1,nordmx
        kkk(k) = 0
      enddo
c
      do k = 1,nordmx
        uscal(k) = ' '
      enddo
c
      do k = 1,nordmx
        scmax(k) = 0.
        scraw(k) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kord .le. 0) then
        nordr = 0
        scfcr= dlxmx0/delxi
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the regular choice of orders. Here i is the order, which
c     technically runs from 0 to jordlm. Here jordlm + 1 is the hidden
c     extra order, which is used to constrain the error in using order
c     jordlm.
c
      do i = 0,jordlm
        scmax(i) = 0.
        scraw(i) = 0.
      enddo
c
c     For i = 0, take delxi = dlxmx0. This keeps delxi greater
c     than or equal to dlxmx0, except within searches, as for phase
c     boundaries.
c
      scmax(0) = dlxmx0/delxi
      scraw(0) = scmax(0)
      kkk(0) = 0
      uscal(0) = 'None'
c
c     Process the higher orders.
c
      do i = 1,jordlm
        ip1 = i + 1
        dlxii = delxi**(ip1)
        fctrmn = 1.e+38
        kkk(i) = 0
        uscal(i) = 'None'
c
c       Get results based on the inverse rate.
c
        if (.not.qriinf) then
          rxx0 = rirec0
          if (rxx0 .ne. 0.) then
            adx = abs(fdri0(ip1))
            delchg = adx*dlxii
            relchg = delchg/rxx0
            if (relchg .ne. 0.) then
              fctr = sscrew(3)/relchg
              if (fctr .lt. fctrmn) then
                fctrmn = fctr
                uscal(i)(1:24) = uinv(1:24)
                kkk(i) = 0
              endif
            endif
          endif
        endif
c
c       Get results based on relative rates.
c
        do nrc = 1,nrct
          if (jreac(nrc).eq.0 .or. jreac(nrc).eq.-1)  then
            rxx0 = abs(rrelr0(nrc))
            if (rxx0 .ne. 0.) then
              adx = abs(fdrr0(ip1,nrc))
              delchg = adx*dlxii
              if (delchg .ne. 0.) then
                fctr = sscrew(3)/delchg
                if (fctr .lt. fctrmn) then
                  fctrmn = fctr
                  uscal(i)(1:24) = urel(1:24)
                  kkk(i) = nrc
                endif
              endif
            endif
          endif
        enddo
c
        xip1 = ip1
        scmax(i) = fctrmn**(1./xip1)
        scraw(i) = scmax(i)
        if (scmax(i) .gt. scalim) scmax(i) = scalim
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(5) .ge. 2) then
        write (noutpt,1000)
 1000   format(/' --- Order and Scale Factor Data (chdxgr) ---',/)
        do i = 0,jordlm
          uzt = uscal(i)
          nrc = kkk(i)
          if (uzt(1:24) .eq. urel(1:24)) then
            uzn = ureac(nrc)
          else
            uzn = ' '
          endif
c
          write (noutpt,1010) i,scmax(i),scraw(i)
 1010     format('   Order= ',i2,', scale= ',f10.5,', raw scale= ',
     $    f10.5)
          j2 = ilnobl(uzt)
          j3 = ilnobl(uzn)
          if (j3 .gt. 0) then
            write (noutpt,1020) uzt(1:j2),uzn(1:j3)
 1020       format(5x,'Constrained by ',a,1x,a)
          else
            write (noutpt,1030) uzt(1:j2)
 1030       format(5x,'Constrained by ',a)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Choose the order that gives the highest scale factor.
c
      scfcr = scmax(0)
      nordr = 0
      do i = 1,jordlm
        if (scmax(i) .gt. scfcr) then
          scfcr = scmax(i)
          nordr = i
        endif
      enddo
c
  999 continue
      end

      subroutine rd3w7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $ jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $ nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $ qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $ uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $ uxmd24,xlkmod)
c
c     This suboutine reads the EQ3NR input file in compact ("W") format
c     for versions 7.0-7.2. It thus encompasses two version levels.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,nodbmx,nopgmx,noprmx,noptmx,nsqmax,ntitmx,
     $ nxmdmx,nxtmax
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jflagb(nsqmax),jxmod(nxmdmx),kxmod(nxmdmx),ncompb(nxtmax)
c
      integer itermx,ninpts,nsq,ntitl,nttyo,nxmod,nxtb
c
      logical qend,qrderr
c
      character*80 utitl(ntitmx)
      character*24 ubasis(nsqmax),umemb(iktmax,nxtmax),uphas1(nsqmax),
     $ uphas2(nsqmax),usolb(nxtmax),uspecb(nsqmax),uxmd24(nxmdmx)
      character*24 uebal,uredox
c
      real*8 cspb(nsqmax),xbarb(iktmax,nxtmax),xlkmod(nxmdmx)
c
      real*8 fep,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iktb,j,j2,n
      integer ilnobl
c
      character*80 uline
      character*24 ux24
      character*8 uendit,ux8
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c-----------------------------------------------------------------------
c
c     Main title.
c
c     Note: if there are exactly ntitpa lines in the title, the title
c     need not be terminated by an 'endit.'. The 'endit.' if present
c     is here not considered to be part of the title. The secondary
c     title is treated in the same manner.
c
      qend = .false.
      read (ninpts,1000,end=100,err=990) uline
 1000 format(a80)
      go to 105
c
  100 qend = .true.
      go to 999
c
  105 n = 1
      if (uline(1:8) .eq. uendit(1:8)) go to 120
      utitl(1) = uline
c
      do 110 n = 2,ntitmx
        read (ninpts,1000,err=990) uline
        if (uline(1:8) .eq. uendit(1:8)) go to 120
        utitl(n) = uline
  110 continue
      n = n + 1
c
      read (ninpts,1000,err=990) uline
      call locase(uline)
      j = index(uline,'tempc=')
      if (j .gt. 0) then
        backspace(ninpts)
      else
        write (nttyo,1030) ntitmx
 1030   format(/' * Error - (XCON3/rd3w7) Have too many lines in the',
     $  /7x,'secondary title. The code is only dimensioned for ',i4,
     $  /7x,'lines. Reduce the size of the title or increase the',
     $  /7x,'dimensioning parameter ntitpa.')
        go to 990
      endif
c
  120 ntitl = n - 1
c
c-----------------------------------------------------------------------
c
c     Temperature.
c
      read (ninpts,1040,err=990) tempc
 1040 format(12x,e12.5)
c
c     Density, total dissolved salts (per kg), and total dissolved
c     salts (per liter).
c
      read (ninpts,1050,err=990) rho,tdspkg,tdspl
 1050 format (3(12x,e12.5))
c
c     Redox parameter and name of redox species defining a controlling
c     couple, if any.
c
      read (ninpts,1060,err=990) fep,uredox
 1060 format (12x,e12.5,12x,a24)
c
c     Convergence tolerances (tolbt and toldl) and saturation
c     tolerance (tolsat).
c
      read (ninpts,1070,err=990) tolbt,toldl,tolsat
 1070 format (3(12x,e12.5))
c
c     Maximum number of iterations.
c
      read (ninpts,1080,err=990) itermx
 1080 format (12x,i2)
c
c-----------------------------------------------------------------------
c
c     Iopt option switches.
c     Note: iopt(1) = iopt1, etc.
c
      read (ninpts,1100,err=990) (iopt(i), i = 1,10)
 1100 format(12x,10i5)
c
c     Iopg option switches.
c     Note: iopg(1) = iopg1, etc.
c
      read (ninpts,1110,err=990) (iopg(i), i = 1,10)
 1110 format(12x,10i5)
c
c     Iopr option switches.
c     Note: iopr(1) = iopr1, etc.
c
      read (ninpts,1120,err=990) (iopr(i), i = 1,20)
 1120 format(12x,10i5)
c
c     Iodb option switches.
c     Note: iodb(1) = iodb1, etc.
c
      read (ninpts,1130,err=990) (iodb(i), i = 1,10)
 1130 format(12x,10i5)
c
c-----------------------------------------------------------------------
c
c     Species for electrical balancing.
c
      read (ninpts,1150,err=990) uebal
 1150 format(12x,a24)
c
c-----------------------------------------------------------------------
c
c     Number of nxmod options.
c
      read (ninpts,1200,err=990) nxmod
 1200 format(12x,i2)
c
      if (nxmod .gt. nxmdmx) then
        write (nttyo,1210) nxmdmx
 1210   format(/' * Error - (XCON3/rd3w7) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  ' options',/7x,'or increase the dimensioning parameter',
     $  ' nxmdpa.')
        go to 990
      endif
c
c     Nxmod options.
c
      if (nxmod .gt. 0) then
        do 420 n = 1,nxmod
          read (ninpts,1220,err=990) uxmd24(n),jxmod(n),kxmod(n),
     $    xlkmod(n)
 1220     format(12x,a24,/12x,i2,22x,i2,22x,e12.5)
  420   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Basis species and associated constraints.
c
      nsq = 0
c
  430 read (ninpts,1250,err=990) ux8,ux24
 1250 format(a8,18x,a24)
      if (ux8(1:8) .eq. uendit(1:8)) go to 440
c
      nsq = nsq + 1
c
      if (nsq .gt. nsqmax) then
        write (nttyo,1260) nsqmax
 1260   format(/' * Error - (XCON3/rd3w7) Have too many basis',
     $  /7x,'species present. The code is only dimensioned',
     $  /7x,'for ',i3,' basis species. Reduce the number of such',
     $  /7x,'species or increase the dimensioning parameter nsqpar.')
        go to 990
      endif
c
      uspecb(nsq) = ux24
c
      read (ninpts,1270,err=990) ubasis(nsq)
 1270 format(24x,a24)
c
      read (ninpts,1280,err=990) jflagb(nsq),cspb(nsq)
 1280 format(10x,i2,8x,e12.5)
c
      if (jflagb(nsq).ge.17 .and. jflagb(nsq).le.21) then
        read (ninpts,1290,err=990) uphas1(nsq),uphas2(nsq)
 1290   format(10x,a24,11x,a24)
      endif
      go to 430
c
  440 continue
c
c-----------------------------------------------------------------------
c
c     Mole fractions of solid solutions.
c
      nxtb = 0
      if (iopt(4) .ge. 2) then
c
  450   read (ninpts,1300,err=990) ux24
 1300   format(3x,a24)
        if (ux24(1:8) .eq. uendit(1:8)) go to 470
c
        nxtb = nxtb + 1
c
        if (nxtb .gt. nxtmax) then
          write (nttyo,1310) nxtmax
 1310     format(/' * Error - (XCON3/rd3w7) Have too many solid',
     $    /7x,'solutions present. The code is only dimensioned',
     $    /7x,'for ',i3,' solid solutions. Reduce the number of such',
     $    /7x,'phases or increase the dimensioning parameter nxtpar.')
          go to 990
        endif
c
        usolb(nxtb) = ux24
        iktb = 0
c
  460   read (ninpts,1320,err=990) ux24,xx
 1320   format(6x,a24,3x,f10.4)
        if (ux24(1:8) .eq. uendit(1:8)) then
          ncompb(nxtb) = iktb
          go to 450
        endif
c
        iktb = iktb + 1
c
        if (iktb .gt. iktmax) then
          j2 = ilnobl(usolb(nxtb))
          write (nttyo,1330) usolb(nxtb)(1:j2),iktmax
 1330     format(/' * Error - (XCON3/rd3w7) Solid solution',
     $    /7x,'"',a,'" has too many end-members present.',
     $    /7x,'This code is only dimensioned for ',i3,' end-members',
     $    /7x,'per solid solution. Reduce the number of end-members',
     $    /7x,'or increase the dimensioning parameter iktpar.')
          go to 990
        endif
c
        umemb(iktb,nxtb) = ux24
        xbarb(iktb,nxtb) = xx
        go to 460
c
      endif
c
  470 continue
c
c-----------------------------------------------------------------------
c
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine indats(adhfsa,advfsa,axhfsa,axlksa,axvfsa,cdrsa,cdrsv,
     $ cessa,cessv,ipch,ipch_asv,ipcv,ipcv_asv,mwtspa,nad1,narxt,
     $ narx_asv,nata,nata_asv,nbta,nbta_asv,nbta1_asv,nbtafd,ncmpra,
     $ ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsn,ndrsra,nerr,nessa,nessa_asv,
     $ nessn,nessra,ngta,ngta_asv,nlta,nlta_asv,nmta,nmta_asv,noutpt,
     $ np,npta_asv,ns,nsta_asv,ntprt,ntpr_asv,nttyo,uaqsln,ubasp,udrsv,
     $ uelema,uendit,uessv,uphasa,uphasv,uptgas,uptliq,uptsld,uptypa,
     $ usblkf,uspeca,vosp0a,zchara)
c
c     This subroutine reads a superblock of species blocks from the
c     supporting data file "data1".
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nad1   = unit number of the data file
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipch_asv,ipcv_asv,narx_asv,nata_asv,nbta_asv,nbta1_asv,
     $ ncta_asv,ndrsa_asv,nessa_asv,ngta_asv,nlta_asv,nmta_asv,npta_asv,
     $ nsta_asv,ntpr_asv
c
      integer noutpt,nttyo
c
      integer narxt(ntpr_asv),ncmpra(2,npta_asv),ndrsa(ndrsa_asv),
     $ ndrsra(2,nsta_asv),nessa(nessa_asv),nessra(2,nsta_asv)
c
      integer ipch,ipcv,nad1,nata,nbta,nbtafd,ncta,ndrsn,nerr,
     $ nessn,ngta,nlta,nmta,np,ns,ntprt
c
      character*48 ubasp(nbta_asv),uspeca(nsta_asv)
      character*24 udrsv(nbta1_asv),uphasa(npta_asv),uptypa(npta_asv)
      character*24 uphasv,uaqsln,uptsld,uptliq,uptgas,usblkf
      character*8 uelema(ncta_asv),uessv(ncta_asv)
      character*8 uendit
c
c
      real*8 adhfsa(narx_asv,ntpr_asv,ipch_asv,nsta_asv),
     $ advfsa(narx_asv,ntpr_asv,ipcv_asv,nsta_asv),
     $ axhfsa(narx_asv,ntpr_asv,nsta_asv),
     $ axlksa(narx_asv,ntpr_asv,nsta_asv),
     $ axvfsa(narx_asv,ntpr_asv,nsta_asv),cdrsa(ndrsa_asv),
     $ cdrsv(nbta1_asv),cessa(nessa_asv),cessv(ncta_asv),
     $ mwtspa(nsta_asv),vosp0a(nsta_asv),zchara(nsta_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ipc,j2,j3,j4,j5,j6,j7,n,nb,nc,nctsv,ndrstv,nf,ntpr
c
      integer ilnobl
c
      character*24 uelect,uhx,uspecv,ux24
c
c-----------------------------------------------------------------------
c
      data uelect /'e-                      '/
c
c-----------------------------------------------------------------------
c
c     The label below defines a loop for reading the blocks in the
c     superblock.
c
  100 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read a species block.
c
c     uspecv = species name
c     nctsv  = number of chemical elements comprising the species
c     ndrstv = number of reaction coefficients in the reaction
c              associated with the species
c
      read (nad1) uspecv,nctsv,ndrstv
      j2 = ilnobl(uspecv)
      j5 = ilnobl(usblkf)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for the end of the current superblock.
c
      if (uspecv(1:8) .eq. uendit(1:8)) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     If the species is a pure mineral or pure liquid, set the phase
c     name to match the species name.
c
      if (usblkf(1:24).eq.uptsld(1:24) .or.
     $ usblkf(1:24).eq.uptliq(1:24)) uphasv(1:24) = uspecv(1:24)
      j3 = ilnobl(uphasv)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Have another species.
c
      ns = ns + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Load the species name array. Note that the last 24 characters
c     contain the name of the associated phase.
c
      uspeca(ns)(1:24) = uspecv(1:24)
      uspeca(ns)(25:48) = uphasv(1:24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     mwtspa = molecular weight
c     zchara = electrical charge
c     vosp0a = molar volume (not read).
c
      read (nad1) mwtspa(ns),zchara(ns)
c
      vosp0a(ns) = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     cessv  = chemical element stoichiometric coefficient
c     uessv  = name of corresponding chemical element.
c
      if (nctsv .gt. 0) read (nad1) (cessv(n),uessv(n), n = 1,nctsv)
c
c     Decode the elemental composition.
c
      nessra(1,ns) = nessn + 1
      if (nctsv .gt. 0) then
        do n = 1,nctsv
          do nc = 1,ncta
            if (uessv(n)(1:8) .eq. uelema(nc)(1:8)) then
              nessn = nessn + 1
              cessa(nessn) = cessv(n)
              nessa(nessn) = nc
              go to 120
            endif
          enddo
          j4 = ilnobl(uessv(n))
          write (noutpt,1010) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5),
     $    uessv(n)(1:j4)
          write (nttyo,1010) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5),
     $    uessv(n)(1:j4)
 1010     format(/' * Error - (EQLIB/indats) The species',
     $    /7x,a,' (',a,')',
     $    /7x,'appearing on the data file in the ',a,' superblock',
     $    /7x,'is listed as being composed of an unrecognized',
     $    /7x,'chemical element ',a,'.')
          nerr = nerr + 1
  120     continue
        enddo
        nessra(2,ns) = nessn
      else
c
c       Have a species comprised of no chemical elements. This is
c       permitted only for the following:
c         O2(g) in a phase other than "gas"
c         e-    in any phase
c
        if (uspecv(1:5) .eq. 'O2(g)') then
          if (usblkf(1:24) .eq. uptgas(1:24)) then
            write (noutpt,1020) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
            write (nttyo,1020) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
 1020       format(/' * Error - (EQLIB/indats) The species',
     $      /7x,a,' (',a,')',
     $      /7x,'appearing on the data file in the ',a,' superblock',
     $      /7x,'is comprised of no chemical elements.')
            nerr = nerr + 1
          endif
        elseif (uspecv(1:2) .eq. uelect(1:2)) then
          continue
        else
          write (noutpt,1020) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
          write (nttyo,1020) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
          nerr = nerr + 1
        endif
c
c       A species with no elements is treated as being comprised of
c       one "null" element.
c
  125   nessn = nessn + 1
        cessa(nessn) = 0.
        nessa(nessn) = 0
        nessra(2,ns) = nessn
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the associated reaction data, if any.
c
c     Read the reaction, if any.
c
      if (ndrstv .gt. 0) then
        read (nad1) (cdrsv(n),udrsv(n), n = 1,ndrstv)
      endif
c
c     Decode the associated reaction into a temporary format. The
c     species associated with the reaction is moved if necessary so
c     that it is the first species to appear in the reaction. Its
c     species index is stored in the ndrsa array. The other species
c     are presumed to be basis species. If one of these species has
c     not been already loaded into the ubasp array, it is loaded at
c     this time. The basis number of the species is stored in the
c     ndrsa array. It will be converted to the corresponding species
c     number after all species are loaded. This scheme permits the
c     loading of a reaction which is written in terms of a basis
c     species which itself has not yet been loaded.
c
      ndrsra(1,ns) = ndrsn + 1
      if (ndrstv .le. 0) then
c
c       A species with no reaction listed on the data file is treated
c       as a basis species. An associated reaction with one "null"
c       species is created. The actual reaction is formally treated
c       as one in which one mole of the associated species is destroyed
c       and one mole of the same species is created. This is termed
c       an "identity reaction." However, the reaction stored is not
c       the identity reaction but the one with the "null" species as
c       the only species.
c
        nbta = nbta + 1
        ubasp(nbta) = uspeca(ns)
        ndrsn = ndrsn + 1
        cdrsa(ndrsn) = 0.
        ndrsa(ndrsn) = 0
        ndrsra(2,ns) = ndrsn
        do ntpr = 1,ntpr_asv
          do n = 1,narx_asv
            axlksa(n,ntpr,ns) = 0.
          enddo
        enddo
      elseif (ndrstv .eq. 1) then
        write (noutpt,1030) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
        write (nttyo,1030) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
 1030   format(/' * Error - (EQLIB/indats) The species'
     $  /7x,a,' (',a,')',
     $  /7x,'appearing on the data file in the ',a,' superblock',
     $  /7x,'has a reaction with only one species in it.')
        nerr = nerr + 1
      else
c
c       Make sure that the species associated with the reaction is
c       the first species in the reaction.
c
        do n = 1,ndrstv
          if (udrsv(n)(1:24) .eq. uspecv(1:24)) then
            ndrsn = ndrsn + 1
            cdrsa(ndrsn) = cdrsv(n)
            ndrsa(ndrsn) = ns
            go to 160
          endif
        enddo
c
        write (noutpt,1040) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
        write (nttyo,1040) uspecv(1:j2),uphasv(1:j3),usblkf(1:j5)
 1040   format(/' * Error - (EQLIB/indats) The species',
     $  /7x,a,' (',a,')',
     $  /7x,'appearing on the data file in the ',a,' superblock',
     $  /7x,'does not appear in its associated reaction.')
        j4 = ilnobl(udrsv(1))
        write (noutpt,1050) udrsv(1)(1:j4),uphasv(1:j3),uspecv(1:j2),
     $  uphasv(1:j3)
        write (nttyo,1050) udrsv(1)(1:j4),uphasv(1:j3),uspecv(1:j2),
     $  uphasv(1:j3)
 1050   format(/9x,'Is ',a,' (',a,') a doppelganger of',
     $  /12x,a,' (',a,')?')
        udrsv(1) = uspecv
        nerr = nerr + 1
c
  160   nf = 0
        do n = 1,ndrstv
          if (udrsv(n)(1:24).eq.uspecv(1:24) .and. nf.eq.0) then
            nf = 1
            if (ns .le. nbtafd) then
c
c             The species is in the range of aqueous species that are
c             intended to be basis species. Add it to the basis set.
c
              nbta = nbta + 1
              ubasp(nbta) = udrsv(n)
            endif
          else
            ndrsn = ndrsn + 1
            cdrsa(ndrsn) = cdrsv(n)
            do nb = 1,nbta
              if (ubasp(nb)(1:24) .eq. udrsv(n)(1:24)) then
                ndrsa(ndrsn) = nb
                go to 180
              endif
            enddo
c
c           The reaction is written in terms of another species that
c           is not yet in the basis set. Add it to that set.
c
            nbta = nbta + 1
            ubasp(nbta) = udrsv(n)
            ndrsa(ndrsn) = nbta
          endif
  180     continue
        enddo
        ndrsra(2,ns) = ndrsn
c
c       Read the interpolating polynomial coefficients for the log K
c       of the reaction.
c
        read (nad1) ux24
        j6 = ilnobl(ux24)
        uhx = 'Log K'
        j7 = ilnobl(uhx)
        if (uhx(1:j7) .ne. ux24(1:j6)) then
          write (noutpt,1052) ux24(1:j6),uhx(1:j7)
          write (nttyo,1052) ux24(1:j6),uhx(1:j7)
 1052     format(/' * Error - (EQLIB/indats) Have read the tag',
     $    ' string "',a,'"',/7x,'where "',a,'" was expected.')
        endif
        do ntpr = 1,ntprt
          read (nad1) (axlksa(n,ntpr,ns), n = 1,narxt(ntpr))
        enddo
      endif
c
      if (ipch .ge. 0) then
c
c       Read the interpolating polynomial coefficients for the enthalpy
c       function and its pressure derivatives. For a basis species, the
c       enthalpy function is the standard partial molar enthalpy of
c       formation; for all other species, the enthalpy function is
c       the standard partial molar enthalpy of reaction.
c
        read (nad1) ux24
        j6 = ilnobl(ux24)
        uhx = 'Enthalpy'
        j7 = ilnobl(uhx)
        if (uhx(1:j7) .ne. ux24(1:j6)) then
          write (noutpt,1052) ux24(1:j6),uhx(1:j7)
          write (nttyo,1052) ux24(1:j6),uhx(1:j7)
        endif
        do ntpr = 1,ntprt
          read (nad1) (axhfsa(n,ntpr,ns), n = 1,narxt(ntpr))
        enddo
        do ipc = 1,ipch
          read (nad1) ux24
          j6 = ilnobl(ux24)
          if (ipc .eq. 1) then
            uhx = 'dEnthalpy/dP'
          else
            uhx = 'd( )Enthalpy/dP( )'
            write (uhx(3:3),'(i1)') ipc,ipc
            write (uhx(17:17),'(i1)') ipc,ipc
          endif
          j7 = ilnobl(uhx)
          if (uhx(1:j7) .ne. ux24(1:j6)) then
            write (noutpt,1052) ux24(1:j6),uhx(1:j7)
            write (nttyo,1052) ux24(1:j6),uhx(1:j7)
          endif
          do ntpr = 1,ntprt
            read (nad1) (adhfsa(n,ntpr,ipc,ns), n = 1,narxt(ntpr))
          enddo
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Read the interpolating polynomial coefficients for the volume
c       function and its pressure derivatives. For a basis species, the
c       volume function is the standard partial molar enthalpy of
c       formation; for all other species, the volume function is
c       the standard partial molar volume of reaction.
c
        read (nad1) ux24
        j6 = ilnobl(ux24)
        uhx = 'Volume'
        j7 = ilnobl(uhx)
        if (uhx(1:j7) .ne. ux24(1:j6)) then
          write (noutpt,1052) ux24(1:j6),uhx(1:j7)
          write (nttyo,1052) ux24(1:j6),uhx(1:j7)
        endif
        do ntpr = 1,ntprt
          read (nad1) (axvfsa(n,ntpr,ns), n = 1,narxt(ntpr))
        enddo
        do ipc = 1,ipcv
          read (nad1) ux24
          j6 = ilnobl(ux24)
          if (ipc .eq. 1) then
            uhx = 'dVolume/dP'
          else
            uhx = 'd( )Volume/dP( )'
            write (uhx(3:3),'(i1)') ipc,ipc
            write (uhx(15:15),'(i1)') ipc,ipc
          endif
          j7 = ilnobl(uhx)
          if (uhx(1:j7) .ne. ux24(1:j6)) then
            write (noutpt,1052) ux24(1:j6),uhx(1:j7)
            write (nttyo,1052) ux24(1:j6),uhx(1:j7)
          endif
          do ntpr = 1,ntprt
            read (nad1) (advfsa(n,ntpr,ipc,ns), n = 1,narxt(ntpr))
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (usblkf(1:24) .eq. uaqsln(1:24)) nata = nata + 1
c
      if (usblkf(1:24) .eq. uptsld(1:24)) then
        nmta = nmta + 1
        np = np + 1
        uphasa(np) = uspecv
        uptypa(np) = uptsld
        ncmpra(1,np) = ns
        ncmpra(2,np) = ns
      endif
c
      if (usblkf(1:24) .eq. uptliq(1:24)) then
        nlta = nlta + 1
        np = np + 1
        uphasa(np) = uspecv
        uptypa(np) = uptliq
        ncmpra(1,np) = ns
        ncmpra(2,np) = ns
      endif
c
      if (usblkf(1:24) .eq. uptgas(1:24)) ngta = ngta + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop back to read another species block.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
c
c     This subroutine reads single line containing an unknown header
c     or tag string from an EQ3/6 input in menu-style ("D")
c     format. The line generally contains both the header and data.
c
c     EQLIBU/rdd2l.f is much like the present subroutine, but also reads
c     a second line, which is a separator containing a field of dashes
c     between two separators. EQLIBU/rdd1lh.f is also much like the
c     present subroutine. It differs in that it has an expected header.
c
c     This subroutine is called by:
c
c       XCON3/rd3d7.f
c       XCON6/rd6d7.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ninpts = the unit number of the stripped input file
c       nfldmx = the maximum number of fields on line uline1
c       nfldtx = the expected number of fields on line uline1
c       nlchmx = the maximum number of characters on line uline1
c       nttyo  = the unit number of the screen file
c       ulscr  = scratch character variable
c
c
c     Output:
c
c       nfldt  = the number of fields on line uline1
c       qrderr = logical flag, true if an error was encountered
c       ufield = the array of fields on line uline1
c       uline1 = the line to be read
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nfldmx,nlchmx
c
      integer nttyo
c
      integer nfldt,nfldtx,ninpts
c
      logical qrderr
c
      character*(*) ufield(nfldmx)
      character*(*) uline1,ulscr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c     Read and parse the first line.
c
      read (ninpts,1000,err=990) uline1
 1000 format(a80)
      call parslj(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
c
c     Compare the number of fields found with that expected.
c
      if (nfldtx .gt. 0) then
        if (nfldt .ne. nfldtx) then
          j2 = ilnobl(uline1(1:70))
          write (nttyo,1010) nfldt,nfldtx,uline1(1:j2)
 1010     format(/' * Warning - (EQLIBU/rdd1l) Found ',i2,' fields',
     $    /7x,'where ',i2,' were expected on the line beginning with',
     $    /7x,'"',a,'".')
        endif
      endif
c
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine parslj(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
c
c     This subroutine parses the input string uline1, based on the
c     delimiter '|'. Character strings found between delimiters are
c     copied into the output array ufield. The elements of this
c     array are then left-justified.
c
c     The scheme is exemplified as follows:
c
c     |  field 1  |  field 2   |  field3  |
c
c     where the first '|' is in column 1 or
c
c        field 1  |  field 2   |  field3  |
c
c     The first field may or may not have a delimiter to its left.
c     Each field must have a delimiter to its right. A field to
c     the right of the last delimiter, if any, is ignored.
c
c     This subroutine is called by:
c
c       EQLIBU/rdd1l.f
c       EQLIBU/rdd1lh.f
c       EQLIBU/rdd2l.f
c       EQLIBU/rdd2lh.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nfldmx = maximum number of fields
c       nlchmx = the dimension of the ufield array
c       uline1 = the line to be parsed
c       ulscr  = scratch character variable
c
c     Output:
c
c       nfldt  = actual number of fields
c       ufield = array of fields
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
c     Note: the character length of the variables uline1, ulstr, and
c     ufield is actually nlchmx. The Sun Fortran compiler does not
c     allow this to be directly specified.
c
      integer nfldmx,nlchmx
c
      integer nfldt
c
      character*(*) uline1,ulscr
      character*(*) ufield(nfldmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i
c
c-----------------------------------------------------------------------
c
c     Do a simple parse.
c
      call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
c
c     Left-justify the elements of the ufield array.
c
      do i = 1,nfldt
        call lejust(ufield(i))
      enddo
c
      end

      program xcon6
c
c     This is the main program of the XCON6 code. Configuration
c     identification, the copyright statement, legal disclaimers,
c     and similar statements are contained in XCON6/aaaxc6.f, the
c     lead-off subroutine in the XCON6 source code. A short description
c     of this program is also contained in that subroutine.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'xcon6/x6op7.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
      integer ietpar,iktpar,imapar,imchpa,jetpar,kpar,nbtpar,nbt1pa,
     $ nctpar,ndctpa,nertpa,netpar,nffgpa,nodbpa,nopgpa,noprpa,noptpa,
     $ nordmx,nprppa,nprspa,nptkpa,nrctpa,nsscpa,nsrtpa,ntitpa,nttkpa,
     $ nxmdpa,nxoppa,nxpepa,nxrtpa
c
      parameter(ietpar = 10,iktpar = 20,imapar = 3,imchpa = 4)
      parameter(jetpar = 3,nertpa = 5,netpar = 12,ntitpa = 100)
      parameter(nctpar = 110,ndctpa = 4,nffgpa = 10)
      parameter(nprppa = 100,nrctpa = 25,nbtpar = 250)
      parameter(nptkpa = 3,nsrtpa = 5,nxmdpa = 40,nsscpa = 6)
      parameter(nxoppa = 20,nxpepa = 40,nxrtpa = 20,nttkpa  =  3)
      parameter(nodbpa = 20,nopgpa = 20,noprpa = 20,noptpa = 20)
      parameter(nbt1pa = nbtpar + 1,nprspa = 3*nprppa)
      parameter(kpar = 2*nbtpar)
c
      integer ietmax,iktmax,imamax,imchmx,jetmax,kmax,nbtmax,nbt1mx,
     $ nctmax,ndctmx,nertmx,netmax,nffgmx,nodbmx,nopgmx,noprmx,noptmx,
     $ nprpmx,nprsmx,nptkmx,nrctmx,nsscmx,nsrtmx,ntitmx,nttkmx,nxmdmx,
     $ nxopmx,nxpemx,nxrtmx
c
c-----------------------------------------------------------------------
c
      integer newin,ninpt,ninpts,noutpt,nttyo,nxcon
c
      integer iact(imchpa,2,nrctpa),ibsrti(nsrtpa),iesrti(nsrtpa),
     $ igerti(jetpar,nertpa),iktbt(nxrtpa),imech(2,nrctpa),iodb(nodbpa),
     $ iopg(nopgpa),iopr(noprpa),iopt(noptpa),ipivot(imapar),
     $ ixrti(nxrtpa),jcode(nrctpa),jflgi(nbtpar),jgerti(nertpa),
     $ jgext(netpar),jreac(nrctpa),jxmod(nxmdpa),kxmod(nxmdpa),
     $ ndact(imchpa,2,nrctpa),nelptr(nbtpar),nesrbt(nsrtpa),
     $ ngexrt(jetpar,netpar),nrk(2,nrctpa),nsk(nrctpa)
c
      integer ifile,ioscan,itermx,jpress,jtemp,kbt,kct,kdim,km1,kmt,
     $ kprs,ksq,ksplmx,ksppmx,kstpmx,kx1,kxt,nbti,nffg,nmodl1,nmodl2,
     $ nobswt,nordlm,npslmx,nprmn,nprmx,nrct,nsbswt,nsslmx,ntitl1,
     $ ntitl2,ntrymx,nxmod,nxopex,nxopt
c
      integer i,icount,ier,j,j2,j3,k,kl,ko2,krow,n,nbb,nn,nobsw,nbbh,
     $ nbbo,ncb,ncbh,ncbo,ncbt,nce,nceh,nceo,nelspt,nerr,nert,net,nmax,
     $ no2,nprob,nprpti,nprsti,nrc,nsr,nsrt,nxrt,ntest
c
      integer ilnobl
c
      logical qcntmp,qcnpre,qend,qex,qgexsh,qpr,qrderr,qxcon,q8bchk,
     $ q8beta
c
      character*80 utitl1(ntitpa),utitl2(ntitpa)
      character*56 ugexr(ietpar,jetpar,netpar)
      character*48 ubmtbi(nbtpar),uobsw(2,nbtpar),uprs(nprspa),
     $ uprspi(nprspa),usbsw(2,nbtpar),uxmod(nxmdpa),uzveci(kpar)
      character*24 ubsri(nbt1pa,nsrtpa),ucxri(iktpar,nxrtpa),
     $ udac(ndctpa,imchpa,2,nrctpa),uelspn(nctpar),
     $ uendb(iktpar,nxrtpa),uffg(nffgpa),ugermo(nertpa),
     $ ugersi(ietpar,jetpar,nertpa),ugexmo(netpar),ugexp(netpar),
     $ undms(kpar),unrms(kpar),uprphi(nprppa),ureac(nrctpa),
     $ uxcat(nxoppa),uxmd24(nxmdpa),uxopex(nxpepa)
      character*16 uxct16(nxoppa)
      character*8 uelemb(nctpar),uelnam(nctpar),uelnlc(nctpar),
     $ uesrb(nctpar,nsrtpa),uesri(nctpar,nsrtpa),ugerji(jetpar,nertpa),
     $ ugexj(jetpar,netpar),uhfgex(ietpar,jetpar,netpar),
     $ uvfgex(ietpar,jetpar,netpar),uxkgex(ietpar,jetpar,netpar),
     $ uxopt(nxoppa)
c
      character*80 uline
      character*24 uacion,uaqsln,unamph,ux24
      character*8 uplatc,uplatm,ustelu,ustxc6,uveelu,uvexc6
      character*8 ucode,urelno,ustage,ueqlrn,ueqlst,uv,ux
      character*3 uoldv,uoldvd,unewv
      character*1 uoldf,unewf,ux1
c
      real*8 apresh(5,2)
c
      real*8 aamatr(imapar,imapar),cdac(ndctpa,imchpa,2,nrctpa),
     $ cbsri(nbt1pa,nsrtpa),celspe(nctpar),celsph(nctpar),
     $ celspo(nctpar),cesrb(nctpar,nsrtpa),cesri(nctpar,nsrtpa),
     $ cgexj(jetpar,netpar),csigma(imchpa,2,nrctpa),
     $ eact(imchpa,2,nrctpa),egersi(ietpar,jetpar,nertpa),fk(nrctpa),
     $ fkrc(nrctpa),gmmatr(imapar,imapar),hact(imchpa,2,nrctpa),
     $ modr(nrctpa),moffg(nffgpa),morr(nrctpa),mprphi(nprppa),
     $ mprs(nprspa),mprspi(nprspa),mtbaqi(nbtpar),mtbi(nbtpar),
     $ mteaqb(nctpar),mteb(nctpar),mwtges(netpar)
c
      real*8 ptk(nptkpa),rkb(imchpa,2,nrctpa),rk0(imchpa,2,nrctpa),
     $ rxbarb(iktpar,nxrtpa),rxbari(iktpar,nxrtpa),sfcar(nrctpa),
     $ sscrew(nsscpa),sk(nrctpa),ssfcar(nrctpa),tgexp(netpar),
     $ ttk(nttkpa),trkb(imchpa,2,nrctpa),trk0(imchpa,2,nrctpa),
     $ vreac(nrctpa),xgersi(ietpar,jetpar,nertpa),
     $ xhfgex(ietpar,jetpar,netpar),xlkgex(ietpar,jetpar,netpar),
     $ xlkffg(nffgpa),xlkmod(nxmdpa),xvec(imapar),
     $ xvfgex(ietpar,jetpar,netpar),yvec(imapar),zvclgi(kpar),
     $ zelsp(nctpar),zgexj(jetpar,netpar)
c
      real*8 awmaxi,awmini,cplim,dlaplo,dlaprn,dleplo,dleprn,dlhplo,
     $ dlhprn,dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,
     $ dlxpll,dlxplo,dlxprl,dlxprn,dlzmx1,dlzmx2,dlzidp,dzpllg,dzplot,
     $ dzprlg, dzprnt,ehmaxi,ehmini,electr,o2maxi,o2mini,phmaxi,phmini,
     $ tempci,tempc0,timemx,timmxi,presh,preshi,pressb,pressi,tempcb,
     $ tistti,tolbt,toldl,tolsat,tolsst,tolx,tolxsf,tstrt,ximaxi,
     $ xistti,zimax,zistrt,zkfac,zklogl,zklogu
c
      real*8 ctxh,ctxo,cx,electc,epstst,mtaqsm,mxc,verold,vernew,ztx
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       On some systems, a BLOCK DATA routine must be declared in an
c       EXTERNAL statement to assure proper loading. On some other
c       systems, this is not necessary, but neither it is not harmful.
c       On yet some other systems, the EXTERNAL statement below may
c       cause a problem. If so, try commenting it out. If you still
c       have trouble, consult your local system documentation or
c       experiment to find out how to correctly handle a BLOCK DATA
c       routine on your system. The EXTERNAL statement below should not
c       cause a problem if you are using a compiler which is fully
c       compliant with the Fortran 90 standard. However, there is
c       no guarantee that it will be adequate to assure correct loading
c       of the BLOCK DATA routine.
c
        external bkdxc6
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
      data noutpt /0/
c
      data uaqsln /'Aqueous solution        '/
c
      data apresh(1,1) / 1.013200000E+00/,
     $     apresh(2,1) / 0./,apresh(3,1) / 0./,
     $     apresh(4,1) / 0./,apresh(5,1) / 0./,
     $     apresh(1,2) /-4.345000000E-01/,
     $     apresh(2,2) / 7.632333333E-03/,
     $     apresh(3,2) / 5.514000000E-05/,
     $     apresh(4,2) /-1.263733333E-06/,
     $     apresh(5,2) / 1.396800000E-08/
c
      data epstst /1.e-12/
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       Define the console device number.
c
c       The following works on UNIX, PC, and VAX machines.
c
        data nttyo  /6/
c
c       BEGIN_MAC_DEPENDENT_CODE
c
c         data nttyo  /9/
c
c       END_MAC_DEPENDENT_CODE
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
      include 'xcon6/x6sbsp.h'
c
      data ninpt  /9/,ninpts /10/,newin /11/,nxcon /12/
c
c-----------------------------------------------------------------------
c
c     Get configuration identification data.
c
      call aaaxc6(ustxc6,uvexc6)
      call aaaelu(ustelu,uveelu)
      call platfd(uplatc,uplatm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set dimensioning variables.
c
      ietmax = ietpar
      iktmax = iktpar
      imamax = imapar
      imchmx = imchpa
      jetmax = jetpar
      kmax = kpar
      nbtmax = nbtpar
      nbt1mx = nbt1pa
      nctmax = nctpar
      ndctmx = ndctpa
      nertmx = nertpa
      netmax = netpar
      nffgmx = nffgpa
      nodbmx = nodbpa
      nopgmx = nopgpa
      noprmx = noprpa
      noptmx = noptpa
      nprpmx = nprppa
      nprsmx = nprspa
      nptkmx = nptkpa
      nrctmx = nrctpa
      nsrtmx = nsrtpa
      nsscmx = nsscpa
      ntitmx = ntitpa
      nttkmx = nttkpa
      nxmdmx = nxmdpa
      nxopmx = nxoppa
      nxpemx = nxpepa
      nxrtmx = nxrtpa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the old input file exist?
c
      inquire(file="input",exist=qex)
      if (.not.qex) then
        write (nttyo,1000)
 1000   format(' * Error- (XCON6/xcon6) The INPUT file (the old input',
     $  ' file).',/7x,"doesn't exist. Check the name that was",
     $  ' specified.')
        go to 999
      endif
c
c     Open the old input file.
c
      open(ninpt,file='input',status='old',err=700)
      go to 710
c
  700 write (nttyo,1010)
 1010 format(" * Error - (XCON6/xcon6) Can't open the INPUT file (the",
     $ ' old input file).')
      go to 999
c
  710 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the old input file format.
c       W = compact
c       D = menu-style
c
      k = 0
      kl = 0
      ntest = 10
      uoldf = 'W'
      do 800 n = 1,100
        read (ninpt,1060) ux1
 1060   format(a1)
        if (ux1(1:1) .ne. 'c') kl = kl + 1
        if (ux1(1:1) .eq. '|') k = k + 1
        if (kl .ge. ntest) then
          if (k .ge. ntest) uoldf = 'D'
          go to 810
        endif
  800 continue
  810 continue
      rewind(ninpt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the INPUTS file (the stripped input file) exist?
c     If so, kill it. This file will be used to contain a copy of the
c     old input file, stripped of comment lines.
c
      inquire(file="inputs",exist=qex)
      if (qex) then
        open(ninpts,file='inputs',status='old',err=720)
        close(ninpts,status='delete')
      endif
c
c     Open the INPUTS file.
c
      open(ninpts,file='inputs',status='new',err=720)
      go to 730
c
  720 write (nttyo,1020)
 1020 format(" * Error - (XCON6/xcon6) Can't open the INPUTS file",
     $ /7x,'(the stripped old input file).')
      close(ninpt)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Strip comment lines from the input file. Also strip any blank
c     lines from a file in "D" format.
c
  730 if (uoldf(1:1) .eq. 'W') then
  740   read (ninpt,1030,end=750) uline
 1030   format(a80)
        if (uline(1:1) .ne. '*') write (ninpts,1030) uline
        go to 740
  750   continue
      elseif (uoldf(1:1) .eq. 'D') then
  755   read (ninpt,1030,end=757) uline
        j2 = ilnobl(uline)
        if (j2 .gt. 0) then
          if (uline(1:1).ne.'*' .and. uline(1:1).ne.'c')
     $    write (ninpts,1030) uline
        endif
        go to 755
  757   continue
      endif
c
c     Rewind the stripped input file.
c
      rewind(ninpts)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does the NEWIN file (to be the new input file) exist?
c     If so, kill it.
c
      inquire(file="newin",exist=qex)
      if (qex) then
        open(newin,file='newin',status='old',err=760)
        close(newin,status='delete')
      endif
c
c     Open the new input file.
c
      open(newin,file='newin',status='new',err=760)
      go to 770
c
  760 write (nttyo,1050)
 1050 format(" * Error - (XCON6/xcon6) Can't open the NEWIN file",
     $ ' (to be the',/7x,'new input file.)')
      close(ninpt)
      close(ninpts,status='delete')
      go to 999
c
  770 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Input file formats:
c
c       W = compact
c       D = menu-style
c
c        uoldf  = format of the old file
c        unewf  = format of the new file
c
      unewf = ' '
c
c     Input file version levels.
c       '6.0' = version 6.0 (including version 6.1)
c       '7.0' = version 7.0 (including versions 7.0x and 7.1)
c       '7.2' = version 7.2
c       '8.0' = version 8.0
c
c         uoldv  = version level of the old file
c         uoldvd = default version level of the old file
c         unewv  = version level of the new file
c
      uoldv = ' '
      uoldvd = ' '
      unewv = ' '
c
c     Set ultimate default values.
c
      uoldvd = '7.2'
      unewv = '8.0'
      unewf = 'D'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Does an options file exist?
c
      inquire(file="ixcon",exist=qxcon)
      if (qxcon) then
        open(nxcon,file='ixcon',status='old',err=780)
        go to 790
c
  780   write (nttyo,1055)
 1055   format(/" * Error - (XCON6/xcon6) Can't open the IXCON options",
     $  ' file.')
        close(ninpts,status='delete')
        close(ninpt)
        close(newin)
        go to 999
c
c       Read the IXCON options file.
c
  790  call rddixc(nxcon,uoldvd,unewf,unewv)
      else
        write (nttyo,1057)
 1057   format(/' * Error - (XCON6/xcon6) The IXCON options file',
     $  " doesn't exist.")
        close(ninpt)
        close(ninpts,status='delete')
        close(newin)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the old input file version level.
c       '6.0' = version 6.0 (including version 6.1)
c       '7.0' = version 7.0 (including versions 7.0x and 7.1)
c       '7.2' = version 7.2
c       '8.0' = version 8.0
c
      i = 0
      do 820 n = 1,ntitmx
        read (ninpts,1030) uline
        if (uoldf(1:1) .eq. 'W') then
          if (uline(1:8) .eq. 'endit.  ') go to 825
        elseif (uoldf(1:1) .eq. 'D') then
          if (uline(1:8) .eq. '|-------') i = i + 1
          if (i .ge. 3) go to 825
        endif
        j = index(uline,'Version level=')
        if (j .le. 0) j = index(uline,'version level=')
        if (j .gt. 0) then
          uv = uline(j + 14:j + 21)
          go to 840
        endif
  820 continue
  825 continue
c
      i = 0
      rewind(ninpts)
      do 830 n = 1,ntitmx
        read (ninpts,1030) uline
        if (uoldf(1:1) .eq. 'W') then
          if (uline(1:8) .eq. 'endit.  ') go to 835
        elseif (uoldf(1:1) .eq. 'D') then
          if (uline(1:8) .eq. '|-------') i = i + 1
          if (i .ge. 3) go to 835
        endif
        j = index(uline,'Version number=')
        if (j .le. 0) j = index(uline,'version number=')
        if (j .gt. 0) then
          uv = uline(j + 15:j + 22)
          go to 840
        endif
  830 continue
  835 continue
c
      write (nttyo,1070)
 1070 format(/' * Warning - (XCON6/xcon6) The title on the old input',
     $ /7x,"file doesn't contain a version level tag. If this code is",
     $ /7x,'unable to determine the correct version level by other',
     $ /7x,'means, add a version tag by putting "Version level= X.X",',
     $ /7x,'where "X.X" is the version level, in the title, preferably',
     $ /7x,'on line 3. If there is more than problem on a single input',
     $ /7x,'file, the tag need be put only in the title of the first',
     $ ' problem.')
      go to 880
c
  840 call lejust(uv)
c
      if (uv(1:3) .eq. '6.0') then
        uoldv = '6.0'
      elseif (uv(1:1) .eq. '6') then
        uoldv = '6.0'
      elseif (uv(1:3) .eq. '7.0') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '7.1') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '7.2') then
        uoldv = '7.2'
      elseif (uv(1:1) .eq. '7') then
        uoldv = '7.0'
      elseif (uv(1:3) .eq. '8.0') then
        uoldv = '8.0'
      elseif (uv(1:1) .eq. '8') then
        uoldv = '8.0'
      else
        j2 = ilnobl(uv)
        write (nttyo,1080) uv(1:j2)
 1080   format(/" * Warning - (XCON6/xcon6) Can't determine the",
     $  /7x,'version level of the old input file. The version level',
     $  /7x,'is specified by a tag in the title of the first problem',
     $  /7x,'on the file as "',a,'". This is not a valid version',
     $  /7x,'level descriptor. Valid descriptors include "6.0", "7.0",',
     $  /7x,'"7.2", and "8.0". If the code is unable to determine the',
     $  /7x,'correct version level, replace the invalid descriptor.')
      endif
c
  880 if (uoldv(1:3) .eq. '   ') then
        rewind(ninpts)
        do 837 n = 1,1000
          read (ninpts,1030,end=838) uline
          j = index(uline,'uacion= ')
          if (j .gt. 0) then
            uoldv = '6.0'
            go to 838
          endif
  837   continue
  838   continue
      endif
c
c     If necessary, use the default for the version level of the old
c     input file.
c
      if (uoldv(1:3) .eq. '   ') then
        uoldv = uoldvd
        write (nttyo,1090) uoldvd
 1090   format(/' * Warning - (XCON6/xcon6) Taking the default',
     $  /7x,'value of "',a3,'" for the version level of the old',
     $  /7x,'input file.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Count the number of chemical elements which can be mapped to
c     basis species. These are listed on the pseudo-data file
c     in x6sbsp.h.
c
      nelspt = 0
      do nce = 1,nctmax
        if (uelnam(nce)(1:8) .eq. 'endit.  ') go to 240
        nelspt = nelspt + 1
      enddo
  240 continue
c
c     Create a copy of the uelnam array in lower case.
c
      do nce = 1,nelspt
        ux = uelnam(nce)
        call locase(ux)
        uelnlc(nce) = ux
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the positions of O and H in the pseudo-data file in x6sbsp.h.
c
      nceo = 0
      do nce = 1,nelspt
        if (uelnam(nce)(1:2).eq.'O ' .or.
     $    uelnam(nce)(1:2).eq.'o ') then
          nceo = nce
          go to 300
        endif
      enddo
      ux = 'O'
      write (nttyo,1740) ux(1:1)
 1740 format(/" * Error - (XCON6/xcon6) Can't find the chemical",
     $ /7x,'element ',a,' listed in the pseudo-data file in x6sbsp.h.')
      stop
  300 continue
c
      nceh = 0
      do nce = 1,nelspt
        if (uelnam(nce)(1:2).eq.'H ' .or.
     $    uelnam(nce)(1:2).eq.'h ') then
          nceh = nce
          go to 310
        endif
      enddo
      ux = 'H'
      write (nttyo,1740) ux(1:1)
      stop
  310 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the old input file, working from the stripped copy.
c
      rewind(ninpts)
      q8bchk = .false.
      q8beta = .false.
      nprob = 0
  100 nprob = nprob + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero or null various variables.
c
      call initcb(utitl1,ntitmx)
      call initcb(utitl2,ntitmx)
c
      call initiz(iopt,noptmx)
      call initiz(iopg,nopgmx)
      call initiz(iopr,noprmx)
      call initiz(iodb,nodbmx)
c
      call initaz(ptk,nptkmx)
      call initaz(ttk,nttkmx)
c
      call initcb(uxopt,nxopmx)
      call initcb(uxcat,nxopmx)
      call initcb(uxct16,nxopmx)
      call initcb(uxopex,nxpemx)
c
      call initcb(uxmod,nxmdmx)
      call initcb(uxmd24,nxmdmx)
      call initiz(jxmod,nxmdmx)
      call initiz(kxmod,nxmdmx)
      call initaz(xlkmod,nxmdmx)
c
      call initcb(uffg,nffgmx)
      call initaz(xlkffg,nffgmx)
      call initaz(moffg,nffgmx)
c
      call initaz(sscrew,nsscmx)
c
      call initcb(ureac,nrctmx)
      call initiz(jcode,nrctmx)
      call initiz(jreac,nrctmx)
      call initaz(morr,nrctmx)
      call initaz(modr,nrctmx)
      call initiz(nsk,nrctmx)
      call initaz(sk,nrctmx)
      call initaz(sfcar,nrctmx)
      call initaz(ssfcar,nrctmx)
      call initaz(fk,nrctmx)
      call initaz(fkrc,nrctmx)
      call initiz(imech,nrctmx)
c
      nmax = nrctmx*2
      call initiz(nrk,nmax)
c
      nmax = nrctmx*2*imchmx
      call initiz(ndact,nmax)
      call initiz(iact,nmax)
      call initaz(rkb,nmax)
      call initaz(rk0,nmax)
      call initaz(csigma,nmax)
      call initaz(trkb,nmax)
      call initaz(trk0,nmax)
      call initaz(eact,nmax)
      call initaz(hact,nmax)
c
      nmax = nrctmx*2*imchmx*ndctmx
      call initcb(udac,nmax)
      call initaz(cdac,nmax)
c
      call initiz(iktbt,nxrtmx)
c
      nmax = iktmax*nxrtmx
      call initcb(uendb,nmax)
      call initcb(ucxri,nmax)
      call initaz(rxbarb,nmax)
      call initaz(rxbari,nmax)
c
      call initiz(iesrti,nsrtmx)
      call initiz(nesrbt,nsrtmx)
c
      nmax = nctmax*nsrtmx
      call initcb(uesrb,nmax)
      call initcb(uesri,nmax)
      call initaz(cesrb,nmax)
      call initaz(cesri,nmax)
c
      nmax = nbt1mx*nsrtmx
      call initcb(ubsri,nmax)
      call initaz(cbsri,nmax)
c
      call initcb(uelemb,nctmax)
      call initaz(mteb,nctmax)
      call initaz(mteaqb,nctmax)
c
      call initcb(unrms,kmax)
      call initcb(undms,kmax)
      call initaz(zvclgi,kmax)
c
      call initcb(uzveci,kmax)
c
      nmax = 2*nbtmax
      call initcb(uobsw,nmax)
      call initcb(usbsw,nmax)
c
      call initcb(ubmtbi,nbtmax)
      call initaz(mtbi,nbtmax)
      call initaz(mtbaqi,nbtmax)
      call initiz(jflgi,nbtmax)
c
      call initcb(uprs,nprsmx)
      call initaz(mprs,nprsmx)
c
      call initcb(uprphi,nprpmx)
      call initaz(mprphi,nprpmx)
      call initcb(uprspi,nprsmx)
      call initaz(mprspi,nprsmx)
c
      dlzmx1 = 0.
      dlxmx0 = 0.
      tolx = 0.
      tolxsf = 0.
c
      dlzmx2 = 0.
      zkfac = 0.
      zklogl = 0.
      zklogu = 0.
      tolsst = 0.
      npslmx = 0
      nsslmx = 0
      nordlm = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The uacion variable only appears on version level '6.0' input
c     files. Provide a blank default value.
c
      uacion = ' '
c
c     The following parameters appear on 'W' format input files,
c     but not on 'D' format files. Provide the usual default values.
c
      dzplot = 1.e+38
      dzpllg = 1.e+38
      ksplmx = 10000
      ifile = 60
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The uacion variable only appears on version level '6.0' input
c     files. Provide a blank default value.
c
      uacion = ' '
c
c     The following parameters appear on 'W' format input files,
c     but not on 'D' format files. Provide the usual default values.
c
      dzplot = 1.e+38
      dzpllg = 1.e+38
      ksplmx = 10000
      ifile = 60
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the current problem on the stripped input file.
c
      if (uoldf(1:1) .eq. 'W') then
        if (uoldv(1:3) .eq. '6.0') then
c
          call rd6w6(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzpllg,dzplot,dzprlg,dzprnt,electr,fk,ifile,iktbt,iktmax,
     $    imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,
     $    jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,kstpmx,
     $    kxmod,kxt,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,
     $    ndctmx,nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,nopgmx,
     $    noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,
     $    nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,
     $    nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,
     $    toldl,tolsat,tolsst,tolx,tstrt,ttk,uacion,udac,uelemb,uendb,
     $    uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,uxmd24,
     $    uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,zklogl,
     $    zklogu,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.0') then
c
          call rd6w7(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzpllg,dzplot,dzprlg,dzprnt,eact,electr,fk,iact,ifile,iktbt,
     $    iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $    jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $    ndact,ndctmx,nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,
     $    nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $    nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $    ntrymx,nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,
     $    nxrtmx,qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,
     $    tolbt,toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,
     $    uendb,uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,
     $    uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,
     $    zklogl,zklogu,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.2') then
c
          call rd6w72(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzpllg,dzplot,dzprlg,dzprnt,eact,electr,fk,iact,ifile,iktbt,
     $    iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $    jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $    ndact,ndctmx,nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,
     $    nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $    nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $    ntrymx,nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,
     $    nxrtmx,qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,
     $    tolbt,toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,
     $    uendb,uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,
     $    uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,
     $    zklogl,zklogu,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '8.0') then
c
          call rd6w8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $    csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $    dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $    dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $    iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $    jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $    ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $    mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $    nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $    nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $    nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $    nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $    nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $    phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $    rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $    toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $    uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $    uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $    uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $    xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
          if (qrderr) go to 990
c
        else
c
          write (nttyo,1200) uoldv
 1200     format(/' * Error - (XCON6/xcon6) Coding to implement',
     $    /7x,'reading an input file in "W" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
c
c       Try to recover the code and version data embedded in comments
c       on the old input file.
c
        call rd6wvz(ninpt,ucode,urelno,ustage,ueqlrn,ueqlst)
c
      elseif (uoldf(1:1) .eq. 'D') then
c
        if (uoldv(1:3).eq.'8.0' .and. .not.q8bchk) then
c
c         Distinguish 8.0 from 8.0 beta. 8.0 will include the
c         "Time print interval" and the "Log time print interval",
c         which 8.0 beta will not. Search for these only between
c         the "Temperature option" line and the "Steps print interval"
c         line.
c
          icount = 0
  120     read(ninpts,1030,end=140) uline
          j2 = index(uline(2:80),'|') - 1
          i = index(uline(2:j2),'Temperature option (jtemp)')
          if (i .le. 0) go to 120
c
  130     read(ninpts,1030,end=140) uline
          j2 = index(uline(2:80),'|') - 1
          i = index(uline(2:j2),'Time print interval')
          if (i .gt. 0) icount = icount + 1
          i = index(uline(2:j2),'Log time print interval')
          if (i .gt. 0) icount = icount + 1
          i = index(uline(2:j2),'Steps print interval')
          if (i .gt. 0) go to 140
          if (icount .lt. 2) go to 130
  140     q8beta = icount.lt.2
          q8bchk = .true.
          rewind(ninpts)
        endif
c
        if (uoldv(1:3) .eq. '6.0') then
c
          write (nttyo,1205)
 1205     format(/' * Error - (XCON6/xcon6) There is no "D" format',
     $    /7x,'for version level "6.0", hence',"can't read an input",
     $    /7x,'file in this format for this version level.')
          go to 990
c
        elseif (uoldv(1:3) .eq. '7.0') then
c
          call rd6d7(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $    imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $    jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $    hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $    nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,nopgmx,
     $    noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,
     $    nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,
     $    nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,
     $    toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,uendb,
     $    uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,uxmd24,
     $    uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,zklogl,
     $    zklogu,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '7.2') then
c
c         Note: version level '7.2" is not identical to version level
c         '7.0' for this format. However, the line parsing capability
c         used to handle this format allows this subroutine to read an
c         input file in this format for either version level.
c
          call rd6d7(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $    imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $    jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $    hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $    nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,nopgmx,
     $    noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,
     $    nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,
     $    nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,
     $    toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,uendb,
     $    uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,uxmd24,
     $    uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,zklogl,
     $    zklogu,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3).eq.'8.0' .and. q8beta) then
c
          call rd6d8b(cbsri,cdac,cesri,cgexj,csigma,dlxdmp,dlxmx0,
     $    dlxpll,dlxplo,dlxprl,dlxprn,eact,egersi,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,iopr,iopt,
     $    igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,jgext,jpress,
     $    jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,kstpmx,
     $    kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,mtbi,
     $    mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,nertmx,net,
     $    netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,nodbmx,nopgmx,noprmx,
     $    noptmx,noutpt,nprob,nprpmx,nprpti,nprsmx,nprsti,nptkmx,nrct,
     $    nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,
     $    nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,
     $    nxrtmx,pressb,pressi,ptk,qend,qrderr,rkb,rxbari,sfcar,ssfcar,
     $    tempcb,tempci,tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,
     $    trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,
     $    ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,
     $    ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,
     $    uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
          if (qrderr) go to 990
c
        elseif (uoldv(1:3) .eq. '8.0') then
c
          call rd6d8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $    csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $    dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $    dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $    iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $    jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $    ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $    mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $    nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $    nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $    nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $    nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $    nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $    phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $    rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $    toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $    uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $    uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $    uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $    xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
          if (qrderr) go to 990
c
        else
c
          write (nttyo,1210) uoldv
 1210     format(/' * Error - (XCON6/xcon6) Coding to implement',
     $    /7x,'reading an input file in "D" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
c
c       Try to recover the code and version data embedded in comments
c       on the old input file.
c
        call rd6dvz(ninpt,ucode,urelno,ustage,ueqlrn,ueqlst)
c
      else
c
        write (nttyo,1110) uoldf
 1110   format(/' * Error - (XCON6/xcon6) Have unknown format',
     $  /7x,'specifier "',a1,'" for the old input file.')
        go to 990
c
      endif
c
      if (qend) then
        close(ninpt)
        close(ninpts,status='delete')
        close(newin)
        close(nxcon)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make changes in the content of the input file problem.
c
c     Look for the string "Version level= " or Version number= " in the
c     title. This identifies the version level of the input file.
c     If present, change it. If not, insert a new line containing
c     this at the beginning of the title.
c
      do 200 n = 1,ntitl1
        j = index(utitl1(n),'Version level=')
        if (j .eq. 0) j = index(utitl1(n),'version level=')
        if (j .gt. 0) then
          utitl1(n)(j + 14:j + 14) = ' '
          utitl1(n)(j + 15:j + 17) = unewv
          utitl1(n)(j + 18:80) = ' '
          go to 220
        endif
        j = index(utitl1(n),'Version number=')
        if (j .eq. 0) j = index(utitl1(n),'version number=')
        if (j .gt. 0) then
          utitl1(n)(j + 8:j + 14) = 'level= '
          utitl1(n)(j + 15:j + 17) = unewv
          utitl1(n)(j + 18:j + 18) = ' '
          go to 220
        endif
  200 continue
c
      if ((ntitl1 + 1) .gt. ntitmx) then
        write (nttyo,1115) nprob,ntitmx
 1115   format(/" * Error - (XCON6/xcon6) Can't add a version",
     $  /7x,'level marker to the first input file title of,'
     $  /7x,'problem ',i2,' because this title already has the',
     $  /7x,'maximum length of ',i3,' lines.')
        go to 990
      endif
c
      do 210 n = ntitl1,1,-1
        utitl1(n + 1) = utitl1(n)
  210 continue
      ntitl1 = ntitl1 + 1
c
      utitl1(1)(1:40) = '                                        '
      utitl1(1)(41:80) = '                                        '
      utitl1(1)(1:15)  = 'Version level= '
      utitl1(1)(16:18) = unewv
      utitl1(1)(21:27) = '(XCON6)'
c
  220 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get version levels in floating point format.
c
c     Calling sequence substitutions:
c       uoldv for ustr
c       verold for var
c
      call chreal(nttyo,qrderr,uoldv,verold)
c
c     Calling sequence substitutions:
c       unewv for ustr
c       vernew for var
c
      call chreal(nttyo,qrderr,unewv,vernew)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (verold.lt.8.0 .and. vernew.lt.8.0) then
c
        mtaqsm = 0.
        ncbt = kct
        do ncb = 1,ncbt
          mtaqsm = mtaqsm + mteaqb(ncb)
        enddo
c
        if (mtaqsm .le. 0.) then
          do ncb = 1,ncbt
            mteaqb(ncb) = mteb(ncb)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (verold.lt.8.0 .and. vernew.ge.8.0) then
c
c       Make translations from pre-Version 8.0 structures to Version 8.0
c       and up structures. All pre-Version 8.0 basis switching is mapped
c       to ordinary basis switching in Version 8.0 and up (none is
c       mapped to special basis switching).
c
        nerr = 0
c
        if (jtemp .le. 0) then
          if (ttk(1).eq.0. .and. ttk(2).eq.0. .and. ttk(3).eq.0.) then
c
c           Constant temperature.
c
            jtemp = 0
          elseif (ttk(2).eq.0. .and. ttk(3).eq.0.) then
            if (iopt(1) .le. 0) then
c
c             Linear tracking in Xi.
c
              jtemp = 1
            else
c
c             Linear tracking in time.
c
              jtemp = 2
            endif
          else
            write (nttyo,1505)
 1505       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version 8.0 or',
     $      /7x,'higher because it uses a power series of order',
     $      /7x,'greater than one to track the temperature. At',
     $      /7x,'version level 8.0 or higher, only first order',
     $      /7x,'(linear) tracking is currently supported. Change',
     $      /7x,'the option on the old input file to a linear form',
     $      /7x,'by setting both ttk(2) and ttk(3) to zero.')
            nerr = nerr + 1
          endif
        else
c
c         Fluid mixing tracking.
c
          jtemp = 3
        endif
c
        jpress = 0
        pressb = 0.
        do n = 1,nptkmx
          ptk(n) = 0
        enddo
c
        if (tempci .le. 100.) then
          preshi = apresh(1,1)
        else
          preshi = 0.
          do nn = 1,5
            n = 6 - nn
            preshi = apresh(n,2) + tempci*preshi
          enddo
        endif
        pressi = preshi
c
        net = 0
        qgexsh = .false.
c
        iopt(17) = iopt(3)
        iopt(3) = iopt(2)
        iopt(2) = iopt(1)
        iopt(15) = iopt(11)
        iopt(11) = 0
        iopt(12) = iopt(7)
        iopt(7) = 0
        iopt(18) = iopt(13)
        iopt(9) = iopt(6)
        iopt(6) = iopt(5)
        if (iopt(6) .ge. 2) iopt(6) = 1
        iopt(5) = 0
c
        iopr(6) = iopr(11)
        iopr(11) = 0
        iopr(2) = iopr(3)
        iopr(3) = 0
        if (iopr(8) .ge. 1) then
          iopr(8) = 0
        else
          iopr(8) = -1
        endif
c
        iodb(7) = iodb(5)
        iodb(5) = iodb(3)
        iodb(3) = iodb(2)
        iodb(2) = iodb(9)
        iodb(9) = 0
c
        if (nmodl1 .ge. 3) then
          iopt(1) = 2
        elseif (nmodl1 .eq. 1) then
          iopt(1) = 1
        else
          iopt(1) = 0
        endif
c
        if (nmodl2 .le. 0) then
          iopt(13) = 0
        elseif (nmodl2 .eq. 1) then
          iopt(13) = 1
        else
          iopt(13) = 2
        endif
c
        nsbswt = 0
        nobswt = 0
c
        tempcb = tempc0
        tistti = tstrt
        timmxi = timemx
        xistti = zistrt
        ximaxi = zimax
        dlxprn = dzprnt
        dlxprl = dzprlg
        dlxplo = dzplot
        dlxpll = dzpllg
        dlxmx0 = dlzmx1
        dlxdmp = dlzidp
c
        dltprn = 1.e+38
        dltprl = 1.e+38
        dltplo = 1.e+38
        dltpll = 1.e+38
c
        dlaprn = 1.e+38
        dleprn = 1.e+38
        dlhprn = 1.e+38
        dloprn = 1.e+38
        dlaplo = 1.e+38
        dleplo = 1.e+38
        dlhplo = 1.e+38
        dloplo = 1.e+38
c
        awmini = -1.e+38
        awmaxi = 1.e+38
        ehmini = -1.e+38
        ehmaxi = 1.e+38
        o2mini = -1.e+38
        o2maxi = 1.e+38
        phmini = -1.e+38
        phmaxi = 1.e+38
c
        nordmx = nordlm
        if (nordmx .le. 0) nordmx = 6
c
        tolxsf = tolx
c
        do n = 1,nxopt
          if (uxopt(n)(1:1) .eq. ' ') uxopt(n) = 'None'
          if (uxopt(n)(1:5) .eq. 'none ') uxopt(n) = 'None'
          if (uxopt(n)(1:4) .eq. 'all ') uxopt(n) = 'All'
          if (uxopt(n)(1:7) .eq. 'alwith ') uxopt(n) = 'Allwith'
c
          if (uxct16(n)(1:5) .eq. 'none ') then
            uxcat(n) = 'None'
          else
c
c           Matching up other uxct16 strings is complicated
c           by the fact that the original inputs were converted
c           to lower case by the read subroutines.
c
            uxcat(n)(1:16) = uxct16(n)(1:16)
            do nn = 1,nctmax
              if (uxct16(n)(1:8) .eq. uelnlc(nn)(1:8)) then
                uxcat(n) = uelspn(nn)
                go to 225
              endif
            enddo
  225       continue
          endif
c
          if (unewf(1:1) .eq. 'W') then
            if (uxopt(n)(1:7) .ne. 'Allwith') then
              if (uxcat(n)(1:5) .eq. 'None ') uxcat(n) = ' '
            endif
          endif
        enddo
c
        do n = 1,nxopex
          if (uxopex(n)(1:1) .eq. ' ') uxopex(n) = 'None'
          if (uxopex(n)(1:5) .eq. 'none ') uxopex(n) = 'None'
        enddo
c
        do nrc = 1,nrct
          if (nsk(nrc) .eq. 0) then
            sfcar(nrc) = sk(nrc)
          elseif (nsk(nrc) .eq. 1) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1510) ureac(nrc)(1:j2)
 1510       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version 8.0 or',
     $      /7x,'higher because it has a reactant surface area flag',
     $      /7x,'(nsk) of 1 for the reactant ',a,'. This',
     $      /7x,'option fixes the specific surface area (cm2/g) of',
     $      /7x,'the reactant for both types of input files, but the',
     $      /7x,'corresponding input data for pre-version level 8.0',
     $      /7x,'is the total surface area (sk) in cm2, whereas that',
     $      /7x,'in version 8.0 or higher is the specific surface',
     $      /7x,"area in cm2/g. XCON6 can't calculate the latter from",
     $      /7x,"the former because it doesn't have the molecular",
     $      /7x,'weight of the reactant. Change the nsk option on',
     $      /7x,'the old input file to 0, convert the file, then',
     $      /7x,'change the surface area flag and data on the new',
     $      /7x,'file to the correct values.')
            nerr = nerr + 1
          else
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1514) nsk(nrc),ureac(nrc)(1:j2)
 1514       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version 8.0 or',
     $      /7x,'higher because it has an unknown reactant surface',
     $      /7x,'area flag (nsk) of ',i2,' for the reactant ',a,'.',
     $      /7x,'The only legal values are 0 and 1.')
            nerr = nerr + 1
          endif
        enddo
c
        do nrc = 1,nrct
          if (nrk(1,nrc) .ge. 4) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1542) ureac(nrc)(1:j2),nrk(1,nrc)
 1542       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version 8.0 or',
     $      /7x,'higher because the reactant ',a,' has a forward',
     $      /7x,'direction rate law code (nrk(1,nrc)) value of ',i3,'.',
     $      /7x,'This was defined at pre-version 8.0 levels as the',
     $      /7x,'activity-term rate law (e.g., the Plummer et al.',
     $      /7x,'(1978) rate law for carbonate mineral dissolution',
     $      /7x,"and precipitation). This isn't supported at version",
     $      /7x,'level 8.0 or higher because it is difficult to',
     $      /7x,'guarantee consistency between the rate constant',
     $      /7x,'data and the thermodynamic data. Use a TST-like',
     $      /7x,'formulation (nrk(1,nrc) = 2) instead.')
            nerr = nerr + 1
          endif
          if (nrk(2,nrc) .ge. 4) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1544) ureac(nrc)(1:j2),nrk(2,nrc)
 1544       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'pre-version level 8.0 input file to version 8.0 or',
     $      /7x,'higher because the reactant ',a,' has a backward',
     $      /7x,'direction rate law code (nrk(2,nrc)) value of ',i3,'.',
     $      /7x,'This was defined at pre-version 8.0 levels as the',
     $      /7x,'activity-term rate law (e.g., the Plummer et al.',
     $      /7x,'(1978) rate law for carbonate mineral dissolution',
     $      /7x,"and precipitation). This isn't supported at version",
     $      /7x,'level 8.0 or higher because it is difficult to',
     $      /7x,'guarantee consistency between the rate constant',
     $      /7x,'data and the thermodynamic data. Use a TST-like',
     $      /7x,'formulation (nrk(2,nrc) = 2) instead.')
            nerr = nerr + 1
          endif
        enddo
c
        call copyaa(fk,fkrc,nrctmx)
c
        nmax = imchmx*2*nrctmx
        call copyaa(rk0,rkb,nmax)
        call copyaa(trk0,trkb,nmax)
c
        call copyia(nesrbt,iesrti,nsrtmx)
c
        nmax = nctmax*nsrtmx
        call copyaa(cesrb,cesri,nmax)
        call copyca(uesrb,uesri,nmax)
c
        call copyia(iktbt,ixrti,nxrtmx)
c
        nmax = iktmax*nxrtmx
        call copyaa(rxbarb,rxbari,nmax)
        call copyca(uendb,ucxri,nmax)
c
c       Set the number of generic ion exchanger reactants.
c       There is no provision for these prior to Version 8.0,
c       so here this number must be zero.
c
        nert = 0
c
c       Count the number of special reactants.
c
        nsrt = 0
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 2) then
            nsrt = nsrt + 1
          endif
        enddo
c
        if (nsrt .gt. 0) then
c
c         Create a reaction for each special reactant.
c
          nsr = 0
          do nrc = 1,nrct
            if (jcode(nrc) .eq. 2) then
              nsr = nsr + 1
              cbsri(1,nsr) = -1.0
              ubsri(1,nsr) = ureac(nrc)
              n = 1
c
              ncbo = 0
              do ncb = 1,nesrbt(nsr)
                if (uesrb(ncb,nsr)(1:2).eq.'O ' .or.
     $            uesrb(ncb,nsr)(1:2).eq.'o ') then
                  ncbo = ncb
                  go to 242
                endif
              enddo
  242         continue
c
              ncbh = 0
              do ncb = 1,nesrbt(nsr)
                if (uesrb(ncb,nsr)(1:2) .eq. 'H ' .or.
     $            uesrb(ncb,nsr)(1:2).eq.'h ') then
                  ncbh = ncb
                  go to 320
                endif
              enddo
  320         continue
c
              ctxo = 0.
              ctxh = 0.
              if (ncbo .gt. 0) ctxo = -cesri(ncbo,nsr)
              if (ncbh .gt. 0) ctxh = -cesri(ncbh,nsr)
              ztx = 0.
c
c             Map all chemical elements except H and O.
c
              do ncb = 1,nesrbt(nsr)
                if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
                  do nce = 1,nelspt
                    if (uesrb(ncb,nsr)(1:8) .eq. uelnam(nce)(1:8)) then
                      n = n + 1
                      cx = cesri(ncb,nsr)/celspe(nce)
                      cbsri(n,nsr) = cx
                      ubsri(n,nsr) = uelspn(nce)
                      ctxo = ctxo + celspo(nce)*cx
                      ctxh = ctxh + celsph(nce)*cx
                      ztx = ztx + zelsp(nce)*cx
                      go to 243
                    endif
                  enddo
                  j2 = ilnobl(uesrb(ncb,nsr))
                  j3 = ilnobl(ureac(nrc))
                  write (nttyo,1126) uesrb(ncb,nsr)(1:j2),
     $            ureac(nrc)(1:j3)
 1126             format(/" * Error - (XCON6/xcon6) Can't map the",
     $            /7x,'chemical element ',a,', which appears in the'
     $            /7x,'composition for the special reactant ',a,',',
     $            /7x,'into a corresponding basis species to use in',
     $            /7x,'composing reaction for that reactant.')
                  nerr = nerr + 1
  243             continue
                endif
              enddo
c
c             Get H+ from charge balance.
c
              if (abs(ztx) .gt. 1.e-12) then
                n = n + 1
                cx = -ztx
                cbsri(n,nsr) = cx
                ubsri(n,nsr) = 'H+ '
                ztx = ztx + cx
                ctxh = ctxh + cx
              endif
c
c             Get H2O from H balance.
c
              if (abs(ctxh) .gt. 1.e-12) then
                n = n + 1
                cx = -0.5*ctxh
                cbsri(n,nsr) = cx
                ubsri(n,nsr) = 'H2O '
                ctxo = ctxo + cx
                ctxh = ctxh + 2.*cx
              endif
c
c             Get O2(g) from O balance.
c
              if (abs(ctxo) .gt. 1.e-12) then
                n = n + 1
                cx = -0.5*ctxo
                cbsri(n,nsr) = cx
                ubsri(n,nsr) = 'O2(g)'
                ctxo = ctxo + 2.*cx
              endif
c
c             Check the balances on H, O, and charge.
c
              if (abs(ctxh).gt.1.e-12 .or. abs(ctxo).gt.1.e-12 .or.
     $          abs(ztx).gt.1.e-12) then
                j2 = ilnobl(ureac(nrc))
                write (nttyo,1128) ureac(nrc)(1:j2)
 1128           format(/' * Error - (XCON6/xcon6) The reaction which',
     $          /7x,'was composed for the special reactant "',a,'"',
     $          /7x,'fails to satisfy all balance conditions.')
                nerr = nerr + 1
              endif
c
              ibsrti(nsr) = n
            endif
          enddo
        endif
c
        do n = 1,nxmod
          uxmod(n)(1:24) = uxmd24(n)
        enddo
c
        kbt = ksq
        km1 = kbt + 1
        kx1 = kmt + 1
        nbti = ksq
        nsbswt = 0
c
        do krow = 1,ksq
          nbb = krow
          ubmtbi(nbb)(1:24) = unrms(krow)
          ubmtbi(nbb)(25:48) = uaqsln(1:24)
        enddo
c
        nobsw = 0
        do krow = 1,ksq
          if (undms(krow)(1:24) .ne. unrms(krow)(1:24)) then
            nobsw = nobsw + 1
            uobsw(1,nobsw)(1:24) = undms(krow)(1:24)
            uobsw(1,nobsw)(25:48) = uaqsln(1:24)
            uobsw(2,nobsw)(1:24) = unrms(krow)(1:24)
            uobsw(2,nobsw)(25:48) = uaqsln(1:24)
          endif
        enddo
        nobswt = nobsw
c
        ncbt = kct
        ko2 = kct + 1
        no2 = ko2
c
        ncbo = 0
        do ncb = 1,ncbt
          if (uelemb(ncb)(1:2).eq.'O ' .or.
     $      uelemb(ncb)(1:2).eq.'o ') then
            ncbo = ncb
            go to 246
          endif
        enddo
  246   continue
c
        ncbh = 0
        do ncb = 1,ncbt
          if (uelemb(ncb)(1:2).eq.'H ' .or.
     $      uelemb(ncb)(1:2).eq.'h ') then
            ncbh = ncb
            go to 252
          endif
        enddo
  252   continue
c
        nbbo = ncbo
        nbbh = ncbh
c
        do ncb = 1,ncbt
          do nce = 1,nelspt
            if (uelemb(ncb)(1:8) .eq. uelnam(nce)(1:8)) then
              nelptr(ncb) = nce
              go to 247
            endif
          enddo
          j2 = ilnobl(uelemb(ncb))
          write (nttyo,1720) uelemb(ncb)(1:j2)
 1720     format(/" * Error - (XCON6/xcon6) Can't map the mass",
     $    /7x,'balance total for chemical element ',a,' to a',
     $    /7x,'mass balance total for the corresponding strict',
     $    /7x,"basis species because it doesn't match any element",
     $    /7x,'listed in the pseudo-data file in x6sbsp.h.')
          nerr = nerr + 1
  247     continue
        enddo
c
        do ncb = 1,ncbt
          if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
            nbb = ncb
            nce = nelptr(ncb)
            mtbi(nbb) = mteb(ncb)/celspe(nce)
            mtbaqi(nbb) = mteaqb(ncb)/celspe(nce)
          endif
        enddo
c
        mtaqsm = 0.
        do ncb = 1,ncbt
          mtaqsm = mtaqsm + mteaqb(ncb)
        enddo
c
        if (mtaqsm .le. 0.) then
          do ncb = 1,ncbt
            if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
              nbb = ncb
              mtbaqi(nbb) = mtbi(nbb)
            endif
          enddo
        endif
c
        yvec(1) = mteb(ncbo)
        yvec(2) = mteb(ncbh)
        yvec(3) = electr
        do ncb = 1,ncbt
          if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
            nce = nelptr(ncb)
            mxc = mteb(ncb)/celspe(nce)
            yvec(1) = yvec(1) - celspo(nce)*mxc
            yvec(2) = yvec(2) - celsph(nce)*mxc
            yvec(3) = yvec(3) - zelsp(nce)*mxc
          endif
        enddo
c
        aamatr(1,1) = celspe(nceo)
        aamatr(1,2) = celspo(nceh)
        aamatr(1,3) = 2.0
        aamatr(2,1) = celsph(nceo)
        aamatr(2,2) = celspe(nceh)
        aamatr(2,3) = 0.0
        aamatr(3,1) = zelsp(nceo)
        aamatr(3,2) = zelsp(nceh)
        aamatr(3,3) = 0.0
        qpr = .false.
c
c       Calling sequence substitutions:
c         xvec for delvec
c         3 for kdim
c         imamax for kmax
c         0 for noutpt
c         yvec for rhsvec
c
        call msolvr(aamatr,xvec,gmmatr,ier,ipivot,3,imamax,
     $  0,nttyo,qpr,yvec)
c
        mtbi(nbbo) = xvec(1)
        mtbi(nbbh) = xvec(2)
        mtbi(no2) = xvec(3)
c
        if (mtaqsm .gt. 0.) then
          yvec(1) = mteaqb(ncbo)
          yvec(2) = mteaqb(ncbh)
          yvec(3) = electr
          do ncb = 1,ncbt
            if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
              nce = nelptr(ncb)
              mxc = mteaqb(ncb)/celspe(nce)
              yvec(1) = yvec(1) - celspo(nce)*mxc
              yvec(2) = yvec(2) - celsph(nce)*mxc
              yvec(3) = yvec(3) - zelsp(nce)*mxc
            endif
          enddo
c
c         Calling sequence substitutions:
c           xvec for delvec
c           3 for kdim
c           imamax for kmax
c           0 for noutpt
c           yvec for rhsvec
c
          call msolvr(aamatr,xvec,gmmatr,ier,ipivot,3,imamax,
     $    0,nttyo,qpr,yvec)
c
          mtbaqi(nbbo) = xvec(1)
          mtbaqi(nbbh) = xvec(2)
          mtbaqi(no2) = xvec(3)
        else
          mtbaqi(nbbo) = mtbi(nbbo)
          mtbaqi(nbbh) = mtbi(nbbh)
          mtbaqi(no2) = mtbi(no2)
        endif
c
        do ncb = 1,ncbt
          nbb = ncb
          nce = nelptr(ncb)
          ubmtbi(nbb)(1:24) = uelspn(nce)
          ubmtbi(nbb)(25:48) = uaqsln
        enddo
        ubmtbi(no2)(1:24) = 'O2(g) '
        ubmtbi(no2)(25:48) = uaqsln
c
        do krow = 1,ksq
          uzveci(krow)(1:24) = unrms(krow)(1:24)
          uzveci(krow)(25:48) = uaqsln(1:24)
        enddo
c
        do krow = km1,kmt
          ux24 = undms(krow)
          if (undms(krow)(1:4) .eq. 'fix ') then
            ux24(1:5) = 'fix_f'
            ux24(6:24) = undms(krow)(9:24)
          endif
          uzveci(krow)(1:24) = ux24
          uzveci(krow)(25:48) = ux24
        enddo
c
        do krow = kx1,kxt
          uzveci(krow)(1:24) = unrms(krow)(1:24)
          uzveci(krow)(25:48) = undms(krow)(1:24)
        enddo
c
        nprpti = 0
        nprsti = 0
        if (kprs .gt. 0) then
          do n = 1,nprmn
            nprpti = nprpti + 1
            nprsti = nprsti + 1
            uprphi(nprpti) = uprs(n)(1:24)
            uprspi(nprsti)(1:24) = uprs(n)(1:24)
            uprspi(nprsti)(25:48) = uprs(n)(1:24)
            mprphi(nprpti) = mprs(n)
            mprspi(nprsti) = mprs(n)
          enddo
          unamph(1:24) = ' '
          do n = 1,nprmx
            if (uprs(n)(25:48) .ne. unamph(1:24)) then
              nprpti = nprpti + 1
              uprphi(nprpti) = uprs(n)(25:48)
              unamph(1:24) = uprs(n)(25:48)
            endif
            nprsti = nprsti + 1
            uprphi(nprpti) = uprs(n)(1:24)
            uprspi(nprsti)(1:24) = uprs(n)(1:24)
            uprspi(nprsti)(25:48) = uprs(n)(1:24)
            mprspi(nprsti) = mprs(n)
            mprphi(nprpti) = mprphi(nprpti) + mprs(n)
          enddo
        endif
c
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((abs(verold - 8.0).le.epstst .and. q8beta)
     $ .and. vernew.ge.8.0) then
c
c       Make additions if converting from Version 8.0 beta to
c       Version 8.0 and up.
c
        dltprn = 1.e+38
        dltprl = 1.e+38
        dltplo = 1.e+38
        dltpll = 1.e+38
c
        dlaprn = 1.e+38
        dleprn = 1.e+38
        dlhprn = 1.e+38
        dloprn = 1.e+38
        dlaplo = 1.e+38
        dleplo = 1.e+38
        dlhplo = 1.e+38
        dloplo = 1.e+38
c
        awmini = -1.e+38
        awmaxi = 1.e+38
        ehmini = -1.e+38
        ehmaxi = 1.e+38
        o2mini = -1.e+38
        o2maxi = 1.e+38
        phmini = -1.e+38
        phmaxi = 1.e+38
c
        nordmx = 6
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((abs(verold - 8.0).le.epstst .and. q8beta)
     $ .and. vernew.lt.8.0) then
c
c       Make additions if converting from Version 8.0 beta to
c       pre-Version 8.0.
c
        nordlm = 6
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (verold.ge.8.0 .and. vernew.lt.8.0) then
c
c       Make translations from Version 8.0 and up structures to
c       pre-Version 8.0 structures, and vice versa. Special basis
c       switching in Version 8.0 and up can't be mapped to any
c       pre-Version 8.0 structure.
c
        nerr = 0
c
        if (jtemp .eq. 0) then
c
c         Constant temperature.
c
           jtemp = 0
        elseif (jtemp .eq. 1) then
c
c         Linear tracking in Xi.
c
          jtemp = 0
          if (iopt(2) .gt. 0) then
            write (nttyo,1522)
 1522       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to a lower',
     $      /7x,'version level because the temperature is set to',
     $      /7x,'track as a linear function of Xi (jtemp = 1), while',
     $      /7x,'kinetic mode is selected (iopt(2) = 1). This',
     $      /7x,"combination can't be mapped to the lower version",
     $      /7x,'level, because temperature tracking in time instead',
     $      /7x,'of Xi is forced by selection of kinetic mode.')
            nerr = nerr + 1
          endif
        elseif (jtemp .eq. 2) then
c
c         Linear tracking in time.
c
          jtemp = 0
          if (iopt(2) .le. 0) then
            write (nttyo,1524)
 1524       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to a lower',
     $      /7x,'version level because the temperature is set to',
     $      /7x,'track as a linear function of time (jtemp = 2),',
     $      /7x,'while reaction progress mode is selected (iopt(2)',
     $      ' = 0).',/7x,"This combination can't be mapped to the",
     $      ' lower version',/7x,'level, because temperature tracking',
     $      ' in Xi instead',/7x,'of time is forced by selection of',
     $      ' reaction progress mode.')
            nerr = nerr + 1
          endif
        elseif (jtemp .eq. 3) then
c
c         Fluid mixing tracking.
c
          jtemp = 1
        else
          write (nttyo,1526) jtemp
 1526     format(/" * Error - (XCON6/xcon6) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because the temperature tracing flag',
     $    /7x,'(jtemp) has an unkown value of ',i2,'.')
          nerr = nerr + 1
        endif
c
        if (jpress .ge. 1) then
          qcntmp = ttk(1).eq.0. .and. ttk(2).eq.0. .and. ttk(3).eq. 0.
          qcnpre = ptk(1).eq.0. .and. ptk(2).eq.0. .and. ptk(3).eq. 0.
          if (qcntmp .and. qcnpre) then
            if (tempcb .le. 100.) then
              presh = apresh(1,1)
            else
              presh = 0.
              do nn = 1,5
                n = 6 - nn
                presh = apresh(n,2) + tempcb*presh
              enddo
            endif
            if (abs(pressb - presh) .gt. 1.e-4) then
              write (nttyo,1700) pressb,presh
 1700         format(/" * Error - (XCON6/xcon6) Can't translate this",
     $        /7x,'version level 8.0 or higher input file to a lower',
     $        /7x,'version level because it specifies a pressure of',
     $        /7x,f9.4,' bars, which differs from the pre-Version 8',
     $        /7x,'standard grid pressure of ',f9.4,' bars. To convert',
     $        /7x,'this input file, set jpress = 0, which sets the',
     $        /7x,'pressure equal to the standard grid pressure.')
              nerr = nerr + 1
            endif
          else
              write (nttyo,1705) jpress
 1705         format(/" * Error - (XCON6/xcon6) Can't translate this",
     $        /7x,'version level 8.0 or higher input file to a lower',
     $        /7x,'version level because it specifies a pressure',
     $        /7x,'tracking option (jpress = ',i2,') which differs',
     $        /7x,'from the pre-Version 8 requirement that the',
     $        ' pressure',/7x,'be equal to the standard grid pressure',
     $        ' at any',/7x,'temperature. To convert this input file,',
     $        ' set jpress = 0.')
              nerr = nerr + 1
            endif
        endif
c
        if (net .gt. 0) then
          write (nttyo,1707) net
 1707     format(/" * Error - (XCON6/xcon6) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it defines ',i2,' generic',
     $    /7x,'ion exchangers. Pre-version 8 input files lack the',
     $    /7x,'generic ion exchange capability.')
          nerr = nerr + 1
        endif
c
        if (iopt(1) .eq. 2) then
          nmodl1 = 3
        elseif (iopt(1) .eq. 1) then
          nmodl1 = 1
        else
          nmodl1 = 2
        endif
c
        if (iopt(13) .le. 0) then
          nmodl2 = 0
        elseif (iopt(13) .eq. 1) then
          nmodl2 = 1
        else
          nmodl2 = 2
        endif
c
        iopt(1) = iopt(2)
        iopt(2) = iopt(3)
        iopt(3) = iopt(17)
        iopt(11) = iopt(15)
        iopt(15) = 0
        iopt(7) = iopt(12)
        iopt(12) = 0
        iopt(13) = iopt(18)
        iopt(18) = 0
        iopt(5) = iopt(6)
        if (iopt(5) .eq. 1) iopt(5) = 2
        iopt(6) = iopt(9)
        iopt(9) = 0
c
        if (iopt(20) .gt. 0) then
          write (nttyo,1520)
 1520     format(/" * Warning - (XCON6/xcon6) Can't translate the",
     $    /7x,'"Advanced EQ6 PICKUP File Options" (iopt(20)) option',
     $    /7x,'specified on this version level 8.0 or higher input',
     $    /7x,'file to a lower version level because this option does',
     $    /7x,'not exist at the lower version level.')
        endif
c
        iopr(11) = iopr(6)
        iopr(6) = 0
        iopr(3) = iopr(2)
        iopr(2) = 0
        if (iopr(8) .ge. 0) then
          iopr(8) = 1
        else
          iopr(8) = 0
        endif
c
        iodb(9) = iodb(2)
        iodb(2) = iodb(3)
        iodb(3) = iodb(5)
        iodb(5) = iodb(7)
        iodb(7) = 0
c
        tempc0 = tempcb
        tstrt = tistti
        timemx = timmxi
        zistrt = xistti
        zimax = ximaxi
        dzprnt = dlxprn
        dzprlg = dlxprl
        dzplot = dlxplo
        dzpllg = dlxpll
        dlzmx1 = dlxmx0
        cplim = 0.
        dlzidp = dlxdmp
        ioscan = 0
c
        tolx = tolxsf
c
        do n = 1,nxopt
          if (uxopt(n)(1:5) .eq. 'None ') uxopt(n) = ' '
          if (uxopt(n)(1:5) .eq. 'none ') uxopt(n) = ' '
          if (uxopt(n)(1:4) .eq. 'All ') uxopt(n) = 'all'
          if (uxopt(n)(1:7) .eq. 'Alwith ') uxopt(n) = 'alwith'
          if (uxopt(n)(1:8) .eq. 'Allwith ') uxopt(n) = 'alwith'
c
          if (uxcat(n)(1:5) .eq. 'none ') then
            uxct16(n) = ' '
          elseif (uxcat(n)(1:5) .eq. 'None ') then
            uxct16(n) = ' '
          else
            uxct16(n)(1:16) = uxcat(n)(1:16)
            do nn = 1,nctmax
              if (uxcat(n)(1:24) .eq. uelspn(nn)(1:24)) then
                if (vernew .ge. 7.0) then
                  uxct16(n) = uelnam(nn)
                else
                  uxct16(n) = uelnlc(nn)
                endif
                go to 257
              endif
            enddo
  257       continue
          endif
        enddo
c
        do n = 1,nxopex
          if (uxopex(n)(1:5) .eq. 'none ') uxopex(n) = ' '
          if (uxopex(n)(1:5) .eq. 'None ') uxopex(n) = ' '
        enddo
c
c       Count the number of generic ion exchanger reactants.
c       There is no provision for these prior to Version 8.0,
c       so it is not possible to translate a Version 8.0 or
c       greater input file to a pre-Version 8.0 format.
c
        nert = 0
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 5) then
            nert = nert + 1
          endif
        enddo
c
        if (nert .gt. 0) then
          write (nttyo,1709) nert
 1709     format(/" * Error - (XCON6/xcon6) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it defines ',i2,' generic',
     $    /7x,'ion exchanger reactants. Pre-version 8 input files',
     $    /7x,'lack the generic ion exchange capability.')
          nerr = nerr + 1
        endif
c
        do nrc = 1,nrct
c
          if (nsk(nrc) .eq. 0) then
            sk(nrc) = sfcar(nrc)
          elseif (nsk(nrc) .eq. 1) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1530) ureac(nrc)(1:j2)
 1530       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to pre-version',
     $      /7x,' 8.0 level because it has a reactant surface area',
     $      /7x,'flag (nsk) of 1 for the reactant ',a,'. This',
     $      /7x,'option fixes the specific surface area (cm2/g) of',
     $      /7x,'the reactant for both types of input files, but the',
     $      /7x,'corresponding input data for version level 8.0 or',
     $      /7x,'higher is the specific surface area in cm2/g,',
     $      /7x,'whereas that in pre-version 8.0 is the total surface'
     $      /7x,"area in cm2. XCON6 can't calculate the latter from",
     $      /7x,"the former because it doesn't have the molecular",
     $      /7x,'weight of the reactant. Change the nsk option on the',
     $      /7x,'old input file to 0, convert the file, then change',
     $      /7x,'the surface area flag and data on the new file to',
     $      /7x,'the correct values.')
            nerr = nerr + 1
          elseif (nsk(nrc) .eq. 2) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1535) ureac(nrc)(1:j2)
 1535       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to pre-version',
     $      /7x,' 8.0 level because it has a reactant surface area',
     $      /7x,'flag (nsk) of 2 for the reactant ',a,'. This',
     $      /7x,'option provides for geometric growth or reduction',
     $      /7x,'in surface area for constant particle number. This',
     $      /7x,'option does not exist for versions earlier than',
     $      /7x,'version 8.0. Change the nsk option on the old input',
     $      /7x,'file to 0, convert the file, then change the surface',
     $      /7x,'area flag and data on the new file to the desired',
     $      ' values.')
            nerr = nerr + 1
          else
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1540) nsk(nrc),ureac(nrc)(1:j2)
 1540       format(/" * Error - (XCON6/xcon6) Can't translate this",
     $      /7x,'version level 8.0 or higher input file to a lower',
     $      /7x,'version level because it has a reactant surface',
     $      /7x,'area flag (nsk) with a value of ',i2,' for the',
     $      /7x,'reactant ',a,'. This corresponds to an option that',
     $      /7x,"doesn't exist for pre-version level 8.0 files.",
     $      /7x,'The only legal values are such files are 0 and 1.')
            nerr = nerr + 1
          endif
        enddo
c
        call copyaa(fkrc,fk,nrctmx)
c
        nmax = imchmx*2*nrctmx
        call copyaa(rkb,rk0,nmax)
        call copyaa(trkb,trk0,nmax)
c
        call copyia(iesrti,nesrbt,nsrtmx)
c
        nmax = nctmax*nsrtmx
        call copyaa(cesri,cesrb,nmax)
        call copyca(uesri,uesrb,nmax)
c
        call copyia(ixrti,iktbt,nxrtmx)
c
        nmax = iktmax*nxrtmx
        call copyaa(rxbari,rxbarb,nmax)
        call copyca(ucxri,uendb,nmax)
c
        do 250 n = 1,nxmod
c
          uxmd24(n) = uxmod(n)(1:24)
c
c         Set the jxmod value. This is a flag for the type of species:
c
c           0 = aqueous species
c           1 = pure mineral
c           2 = gas
c           3 = solid solution
c
c         The jxmod array is not used in Version 8.0 and up. It is
c         not possible to design a perfect logic for determining the
c         correct value. Here there may be a problem in determining
c         whether a species is a pure mineral or a solid solution.
c         Also, in some cases, the Version 8.0 and up option may not
c         map back to the pre-Version 8.0 format.
c
          if (uxmod(n)(25:48) .eq. uaqsln(1:24)) then
            jxmod(n) = 0
            go to 250
          endif
c
          if (uxmod(n)(25:28) .eq. 'Gas ') then
            jxmod(n) = 2
            go to 250
          endif
c
          if (uxmod(n)(25:48).ne.uxmod(n)(1:24) .and.
     $      uxmod(n)(25:27).ne.'   ') then
            nerr = nerr + 1
            j2 = ilnobl(uxmod(n))
            write (nttyo,1120) uxmod(n)(1:j2)
 1120       format(/" * Error - (XCON6/xcon6) Can't translate a",
     $      ' suppress/alter option',/7x,'for "',a,'"',
     $      /7x,'to pre-Version 8.0 format.')
            go to 250
          endif
c
          i = index(uxmod(n),'(aq)')
          if (i .gt. 0) then
            jxmod(n) = 0
            go to 250
          endif
c
          ux24 = uxmod(n)(1:24)
          j2 = ilnobl(ux24)
          if (j2 .gt. 0) then
            if (ux24(j2:j2).eq.'+' .or. ux24(j2:j2).eq.'-') then
              jxmod(n) = 0
              go to 250
            endif
          endif
c
          i = index(uxmod(n),'(g)')
          if (i .le. 0) i = index(uxmod(n),'Hydrogen')
          if (i .le. 0) i = index(uxmod(n),'Oxygen')
          if (i .le. 0) i = index(uxmod(n),'Nitrogen')
          if (i .le. 0) i = index(uxmod(n),'Steam')
          if (i .gt. 0) then
            jxmod(n) = 2
            go to 250
          endif
c
          i = index(uxmod(n),'(ss)')
          if (i .le. 0) i = index(uxmod(n),'-ss')
          if (i .le. 0) i = index(uxmod(n),'Carbonate-Calcite')
          if (i .le. 0) i = index(uxmod(n),'Biotite')
          if (i .le. 0) i = index(uxmod(n),'Olivine')
          if (i .le. 0) i = index(uxmod(n),'Plagioclase')
          if (i .le. 0) i = index(uxmod(n),'Orthopyroxene')
          if (i .le. 0) i = index(uxmod(n),'Smectite-di')
          if (i .le. 0) i = index(uxmod(n),'Saponite-tri')
          if (i .gt. 0) then
            jxmod(n) = 3
            go to 250
          endif
c
          i = index(uxmod(n),'ite ')
          if (i .le. 0) i = index(uxmod(n),'ime ')
          if (i .le. 0) i = index(uxmod(n),'ine ')
          if (i .le. 0) i = index(uxmod(n),'Quartz')
          if (i .gt. 0) then
            jxmod(n) = 1
            go to 250
          endif
c
          j2 = ilnobl(uxmod(n))
          write (nttyo,1119) uxmod(n)(1:j2)
 1119     format(/" * Warning - (XCON6/xcon6) Can't unambiguously",
     $    /7x,'determine what kind of species in an alter/suppress',
     $    /7x,'option is "',a,'".',
     $    /7x,'Setting jxmod to 1. Check to see that this is correct',
     $    /7x,'(0 = aqueous species, 1 = pure mineral,',
     $    ' 3 = gas species',
     $    /7x,'3 = solid solution).')
          jxmod(n) = 1
  250  continue
c
        ksq = kbt
        km1 = ksq + 1
        kx1 = kmt + 1
c
        if (nsbswt .gt. 0) then
          write (nttyo,1710) nsbswt
 1710     format(/" * Error - (XCON6/xcon6) Can't translate this",
     $    /7x,'version level 8.0 or higher input file to a lower',
     $    /7x,'version level because it contains ',i3,' directives',
     $    /7x'for special basis switching.')
          nerr = nerr + 1
        endif
c
        ncbt = kct
        ko2 = kct + 1
        no2 = ko2
c
        nbbo = 0
        do nbb = 1,nbti
          if (ubmtbi(nbb)(1:24) .eq. uelspn(nceo)(1:24)) then
            nbbo = nbb
            go to 248
          endif
        enddo
  248   continue
c
        nbbh = 0
        do nbb = 1,nbti
          if (ubmtbi(nbb)(1:24) .eq. uelspn(nceh)(1:24)) then
            nbbh = nbb
            go to 249
          endif
        enddo
  249   continue
c
        ncbo = nbbo
        ncbh = nbbh
c
        do nbb = 1,nbti
          if (nbb .eq. no2) go to 253
          ncb = nbb
          do nce = 1,nelspt
            if (ubmtbi(nbb)(1:24) .eq. uelspn(nce)(1:24)) then
              nelptr(ncb) = nce
              go to 253
            endif
          enddo
          j2 = ilnobl(ubmtbi(nbb)(1:24))
          write (nttyo,1730) ubmtbi(nbb)(1:j2)
 1730     format(/" * Error - (XCON6/xcon6) Can't map the mass",
     $    /7x,'balance total for the strict basis species',
     $    /7x,a,' to a mass balance total for the corresponding',
     $    /7x,"chemical element because it doesn't match any strict",
     $    /7x,'basis species listed in the pseudo-data file in',
     $    ' x6sbsp.h.')
          nerr = nerr + 1
  253     continue
        enddo
c
        mteb(ncbo) = celspe(nceo)*mtbi(nbbo) + 2.*mtbi(no2)
        mteaqb(ncbo) = celspe(nceo)*mtbaqi(nbbo) + 2.*mtbaqi(no2)
        do nbb = 1,ncbt
          if (nbb.ne.nbbo .and. nbb.ne.nbbh) then
            nce = nelptr(nbb)
            mteb(ncbo) = mteb(ncbo) + celspo(nce)*mtbi(nbb)
            mteaqb(ncbo) = mteaqb(ncbo) + celspo(nce)*mtbaqi(nbb)
          endif
        enddo
c
        mteb(ncbh) = celspe(nceh)*mtbi(nbbh) + 2.*mtbi(nbbo)
        mteaqb(ncbh) = celspe(nceh)*mtbaqi(nbbh) + 2.*mtbaqi(nbbo)
        do nbb = 1,ncbt
          if (nbb.ne.nbbo .and. nbb.ne.nbbh) then
            nce = nelptr(nbb)
            mteb(ncbh) = mteb(ncbh) + celsph(nce)*mtbi(nbb)
            mteaqb(ncbh) = mteaqb(ncbh) + celsph(nce)*mtbaqi(nbb)
          endif
        enddo
c
        do ncb = 1,ncbt
          if (ncb.ne.ncbo .and. ncb.ne.ncbh) then
            nbb = ncb
            nce = nelptr(nbb)
            mteb(ncb) = mteb(ncb) + celspe(nce)*mtbi(nbb)
            mteaqb(ncb) = mteaqb(ncb) + celspe(nce)*mtbaqi(nbb)
          endif
        enddo
c
        electc = 0.
        do nbb = 1,ncbt
          nce = nelptr(nbb)
          electc = electc + zelsp(nce)*mtbaqi(nbb)
        enddo
c
        if (abs(electc - electr) .gt. 1.e-12) then
          write (nttyo,1735) electc,electr
 1735     format(/' * Warning - (XCON6/xcon6) The calculated',
     $    ' electrical balance',/7x,"doesn't match the input",
     $    ' electrical imbalance:',//9x,'Calculated= ',1pe22.15,
     $    /14x,'Input= ',e22.15)
        endif
c
        do ncb = 1,ncbt
          nbb = ncb
          nce = nelptr(ncb)
          uelemb(ncb) = uelnam(nce)
        enddo
c
        do krow = 1,ksq
          unrms(krow)(1:24) = uzveci(krow)(1:24)
          undms(krow)(1:24) = uzveci(krow)(1:24)
          do nobsw = 1,nobswt
            if (uobsw(1,nobsw)(1:24) .eq. undms(krow)(1:24)) then
              unrms(krow)(1:24) = uobsw(2,nobsw)(1:24)
              go to 255
            endif
          enddo
  255     continue
        enddo
c
        do krow = km1,kmt
          unrms(krow)(1:24) = ' '
          ux24 = uzveci(krow)(1:24)
          if (uzveci(krow)(1:5) .eq. 'fix_f') then
            ux24(1:8) = 'fix     '
            ux24(9:24) = uzveci(krow)(6:21)
          endif
          undms(krow)(1:24) = ux24
        enddo
c
        do krow = kx1,kxt
          unrms(krow)(1:24) = uzveci(krow)(25:48)
          undms(krow)(1:24) = uzveci(krow)(1:24)
        enddo
c
        nprmn = 0
        nprmx = 0
        if (kprs .gt. 0) then
          do n = 1,nprsti
            uprs(n)(1:48) = uprspi(n)(1:48)
            mprs(n) = mprspi(n)
            if (uprs(n)(1:24) .eq. uprs(n)(25:48)) then
              nprmn = nprmn + 1
            else
              nprmx = nprmx + 1
            endif
          enddo
        endif
c
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Trap incompatibilities between version level 6.0 and higher
c     version levels.
c
      if (abs(verold - 6.0).le.epstst  .and.
     $  vernew .gt. 6.0) then
c
c       Version level 6.0 contains a rate law code of 5 which does
c       not map to subsequent version levels.
c
        nerr = 0
        do nrc = 1,nrct
          if (nrk(1,nrc) .ge. 5) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1117) ureac(nrc)(1:j2),nrk(1,nrc)
 1117       format(/' * Error - (XCON6/xcon6) Reactant ',a,
     $      /7x,'has a forward direction rate law code value',
     $      /7x,'of ',i3,'. This was defined at version level',
     $      /7x,"6.0. It can't be mapped to version level 7.0",
     $      /7x,'or higher.')
            nerr = nerr + 1
          endif
          if (nrk(2,nrc) .ge. 5) then
            j2 = ilnobl(ureac(nrc))
            write (nttyo,1118) ureac(nrc)(1:j2),nrk(2,nrc)
 1118       format(/' * Error - (XCON6/xcon6) Reactant ',a,
     $      /7x,'has a backward direction rate law code value',
     $      /7x,'of ',i3,'. This was defined at version level',
     $      /7x,"6.0. It can't be mapped to version level 7.0",
     $      /7x,'or higher.')
            nerr = nerr + 1
          endif
        enddo
        if (nerr .gt. 0) stop
      endif
c
      if (verold.gt.6.0 .and. abs(vernew - 6.0).le.epstst) then
c
c       Version level 6.0 has no treatment of the temperature dependence
c       of rate constants.
c
        nerr = 0
        do nrc = 1,nrct
          do i = 1,imech(1,nrc)
            if (iact(i,1,nrc).ne.0 .or. trk0(i,1,nrc).ne.0. .or.
     $        eact(i,1,nrc).ne.0. .or. hact(i,1,nrc).ne.0.) then
              j2 = ilnobl(ureac(nrc))
              write (nttyo,1122) ureac(nrc)(1:j2),i
 1122         format(/' * Error - (XCON6/xcon6) Reactant ',a,
     $        /7x,'has a temperature-dependent rate constant in',
     $        /7x,'term ',i2," of the forward rate law. This can't",
     $        /7x,"be mapped to version level 6.0.")
              nerr = nerr + 1
            endif
          enddo
          do i = 1,imech(2,nrc)
            if (iact(i,2,nrc).ne.0 .or. trk0(i,2,nrc).ne.0. .or.
     $        eact(i,2,nrc).ne.0. .or. hact(i,2,nrc).ne.0.) then
              j2 = ilnobl(ureac(nrc))
              write (nttyo,1124) ureac(nrc)(1:j2),i
 1124         format(/' * Error - (XCON6/xcon6) Reactant ',a,
     $        /7x,'has a temperature-dependent rate constant in',
     $        /7x,'term ',i2," of the backward rate law. This can't",
     $        /7x,'be mapped to version level 6.0.')
              nerr = nerr + 1
            endif
          enddo
        enddo
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the current problem on the new input file.
c
      if (unewf(1:1) .eq. 'W') then
        if (unewv(1:3) .eq. '6.0') then
c
          call wr6w6(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,
     $    dlzidp,dzpllg,dzplot,dzprlg,dzprnt,electr,fk,ifile,iktbt,
     $    iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $    jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $    ndact,ndctmx,nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,
     $    nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $    nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $    ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,
     $    tolsst,tolx,tstrt,ttk,uacion,ucode,udac,uelemb,uendb,ueqlrn,
     $    ueqlst,uesrb,uffg,undms,unrms,uprs,ureac,urelno,ustage,
     $    utitl1,utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,
     $    zimax,zistrt,zkfac,zklogl,zklogu,zvclgi)
c
        elseif (unewv(1:3) .eq. '7.0') then
c
          call wr6w7(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzpllg,dzplot,dzprlg,dzprnt,eact,electr,fk,iact,ifile,iktbt,
     $    iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $    jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $    ndact,ndctmx,nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,
     $    nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $    nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $    ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,
     $    tolsst,tolx,trk0,tstrt,ttk,ucode,udac,uelemb,uendb,ueqlrn,
     $    ueqlst,uesrb,uffg,undms,unrms,uprs,ureac,urelno,ustage,utitl1,
     $    utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,
     $    zistrt,zkfac,zklogl,zklogu,zvclgi)
c
        elseif (unewv(1:3) .eq. '7.2') then
c
          call wr6w72(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzpllg,dzplot,dzprlg,dzprnt,eact,electr,fk,iact,ifile,iktbt,
     $    iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $    jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $    ndact,ndctmx,nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,
     $    nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $    nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $    ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,
     $    rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,
     $    tolsst,tolx,trk0,tstrt,ttk,ucode,udac,uelemb,uendb,ueqlrn,
     $    ueqlst,uesrb,uffg,undms,unrms,uprs,ureac,urelno,ustage,utitl1,
     $    utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,
     $    zistrt,zkfac,zklogl,zklogu,zvclgi)
c
        elseif (unewv(1:3) .eq. '8.0') then
c
          call wr6w8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
c
        else
          write (nttyo,1220) unewv
 1220     format(/' * Error - (XCON6/xcon6) Coding to implement',
     $    /7x,'writing an input file in "W" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      elseif (unewf(1:1) .eq. 'D') then
        if (unewv(1:3) .eq. '6.0') then
c
          write (nttyo,1230)
 1230     format(/' * Error - (XCON6/xcon6) There is no "D" format',
     $    /7x,'for version level "6.0", hence',"can't write an input",
     $    /7x,'file in this format for this version level.')
          go to 990
c
        elseif (unewv(1:3) .eq. '7.0') then
c
          call wr6d7(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $    imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $    jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $    hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $    nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,nopgmx,noprmx,
     $    noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,nrk,
     $    nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,
     $    nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,rk0,rxbarb,
     $    sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,tolsst,
     $    tolx,trk0,tstrt,ttk,ucode,udac,uelemb,uendb,uesrb,ueqlrn,
     $    ueqlst,uffg,undms,unrms,uprs,ureac,urelno,ustage,utitl1,
     $    utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,
     $    zistrt,zkfac,zklogl,zklogu,zvclgi)
c
        elseif (unewv(1:3) .eq. '7.2') then
c
          call wr6d72(cdac,cesrb,csigma,dlzmx1,dlzmx2,dlzidp,
     $    dzprlg,dzprnt,eact,electr,fk,iact,iktbt,iktmax,imchmx,
     $    imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,jreac,jtemp,
     $    jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksppmx,kstpmx,kxmod,kxt,
     $    hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,ndact,ndctmx,
     $    nesrbt,newin,nffg,nffgmx,nmodl1,nmodl2,nodbmx,nopgmx,noprmx,
     $    noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,nrctmx,nrk,
     $    nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,
     $    nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrtmx,rk0,rxbarb,
     $    sscrew,sk,tempci,tempc0,timemx,tolbt,toldl,tolsat,tolsst,
     $    tolx,trk0,tstrt,ttk,ucode,udac,uelemb,uendb,uesrb,ueqlrn,
     $    ueqlst,uffg,undms,unrms,uprs,ureac,urelno,ustage,utitl1,
     $    utitl2,uxct16,uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,
     $    zistrt,zkfac,zklogl,zklogu,zvclgi)
c
        elseif (unewv(1:3) .eq. '8.0') then
c
          call wr6d8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,csigma,
     $    dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,
     $    dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,dlxplo,
     $    dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,iact,
     $    ibsrti,iesrti,ietmax,igerti,iktmax,imchmx,imech,iodb,iopg,
     $    iopr,iopt,itermx,ixrti,jcode,jetmax,jflgi,jgerti,jgext,
     $    jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,ksppmx,
     $    kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,mtbaqi,
     $    mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,nert,
     $    nertmx,net,netmax,newin,nffg,nffgmx,ngexrt,nobswt,nodbmx,
     $    nopgmx,noprmx,noptmx,nordmx,nprpmx,nprpti,nprsmx,nprsti,
     $    nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,nsrt,nsrtmx,ntitl1,ntitl2,
     $    ntitmx,ntrymx,nttkmx,nxmdmx,nxmod,nxopex,nxopmx,nxopt,
     $    nxpemx,nxrt,nxrtmx,o2maxi,o2mini,phmaxi,phmini,pressb,
     $    pressi,ptk,qgexsh,rkb,rxbari,sfcar,ssfcar,tempcb,tempci,
     $    tgexp,timmxi,tistti,tolbt,toldl,tolsat,tolxsf,trkb,ttk,
     $    ubmtbi,ubsri,ucxri,udac,uesri,uffg,ugerji,ugermo,ugersi,
     $    ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,uprphi,uprspi,ureac,
     $    usbsw,utitl1,utitl2,uvfgex,uxcat,uxkgex,uxmod,uxopex,uxopt,
     $    uzveci,vreac,xgersi,xhfgex,ximaxi,xistti,xlkffg,xlkgex,
     $    xlkmod,xvfgex,zgexj,zvclgi)
c
        else
c
          write (nttyo,1240) unewv
 1240     format(/' * Error - (XCON6/xcon6) Coding to implement',
     $    /7x,'writing an input file in "D" format has not been',
     $    /7x,'implemented for version level "',a3,'."')
          go to 990
c
        endif
      else
c
        write (nttyo,1130) unewf
 1130   format(/' * Error - (XCON6/xcon6) Have unknown format',
     $  /7x,'specifier "',a1,'" for the new input file.')
        go to 990
c
      endif
c
c     Go back to do another problem on the same input file.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (nttyo,1140) uoldv
 1140 format(/' * Error - (XCON6/xcon6) Have encountered a read',
     $ /7x,'error while reading the old input file. First check the',
     $ /7x,'version level. The version level was taken to be "',a3,'".',
     $ /7x,'If the version level is marked incorrectly in the primary',
     $ /7x,'title of the first problem, correct this, as the default',
     $ /7x,'value read from the IXCON file or set in the code itself',
     $ /7x,'does not override this. If the problem is not due to an',
     $ /7x,'error in the assumed version level, there is probably a',
     $ /7x,'format error on the old input file. Check the stripped',
     $ /7x,'copy of the old input file (INPUTS).')
c
c     Close all files. Don't delete the inputs file. Delete the NEWIN
c     file, which is not valid.
c
      close(ninpt)
      close(ninpts)
      close(newin,status='delete')
      close(nxcon)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rd3inw(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $ ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $ jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $ netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $ noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $ nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $ tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $ ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $ uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $ xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
c
c     This subroutine reads the EQ3NR input file in compact ("W")
c     format.
c
c     This subroutine is a near-clone of XCON3/rd3w8.f. The present
c     subroutine differs from the latter, in that in addition to the
c     pure read function, it writes an instant echo of what is read to
c     the output file. To maintain close consistency with XCON3/rd3w8.f,
c     this subroutine assigns no default values and only performs such
c     checking of what is read to ensure that what follows is readable.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/rd3ind.f, XCON3/rd3w8.f, and XCON3/rd3d8.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ninpts = unit number of the stripped input file
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       qrderr = flag denoting a read error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,noptmx,
     $ ntitmx,nxmdmx,nxicmx,nxtimx
c
      integer ninpts,noutpt,nttyo
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jgext(netmax),jgexti(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ncmpri(2,nxtimx),ngexrt(jetmax,netmax),ngexti(jetmax,netmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,jpres3,nbti,net,neti,nobswt,
     $ nprob,nsbswt,ntitl,nxmod,nxti
c
      logical qend,qgexsh,qrderr
c
      character(len=80) utitl(ntitmx)
      character(len=56) ugexr(ietmax,jetmax,netmax)
      character(len=48) ucospi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uspeci(nbtmax),uxmod(nxmdmx)
      character(len=24) ugexmo(netmax),ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),umemi(nxicmx),usoli(nxtimx)
      character(len=24) uebal,uredox
      character(len=8) ugexj(jetmax,netmax),ugexji(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real(8) cgexj(jetmax,netmax),cgexpi(netmax),covali(nbtmax),
     $ egexsi(ietmax,jetmax,netmax),mwtges(netmax),tgexp(netmax),
     $ xbari(nxicmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xvfgex(ietmax,jetmax,netmax),
     $ xlkmod(nxmdmx),zgexj(jetmax,netmax),xgexsi(ietmax,jetmax,netmax)
c
      real(8) ehi,fo2lgi,pei,press,rho,scamas,tdspkg,tdspl,tempc,tolbt,
     $ toldl,tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,je,jei,j2,j3,j4,n,nbi,ne,nei,nn,nr1,nr2,nssoti,nxi,
     $ nxic
c
      integer ilnobl
c
      logical qgexef
c
      character(len=80) uline
      character(len=48) ux48
      character(len=8) uendit,ux8
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     qend   = .true if the end of the input file has been encountered
c     qrderr = .true if the current problem can't be read because of
c                a read format error or a dimensional overflow
c
      qend = .false.
      qrderr = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Title.
c
c       utitl1 = Title
c       ntitl1 = number of lines in the title
c
c     Note: if there are exactly ntitpa lines in the title, the title
c     need not be terminated by an 'endit.'. The 'endit.' if present
c     is here not considered to be part of the title.
c
      n = 0
      read (ninpts,1000,end=100,err=990) uline
 1000 format(a80)
      go to 110
c
  100 qend = .true.
      go to 999
c
  110 write (noutpt,1010) nprob
      write (nttyo,1010) nprob
 1010 format(//' Reading problem ',i3,' from the input file ...',/)
c
      j2 = ilnobl(uline)
      j2 = min(j2,79)
      write (noutpt,1020) uline
 1020 format(1x,a)
c
      if (uline(1:8) .eq. uendit(1:8)) then
        write (noutpt,1030)
        write (nttyo,1030)
 1030   format(3x,'This input file has no title.')
        go to 120
      else
        n = 1
        utitl(n) = uline
      endif
c
      do nn = 2,ntitmx + 1
        read (ninpts,1000,err=990) uline
        j2 = ilnobl(uline)
        j2 = min(j2,79)
        write (noutpt,1020) uline(1:j2)
        if (uline(1:8) .eq. uendit(1:8)) go to 120
c
        n = n + 1
c
        if (n .gt. ntitmx) then
          write (nttyo,1015) ntitmx
 1015     format(/' * Error - (EQ3NR/rd3inw) Have too many lines in',
     $    /7x,'the title. The code is only dimensioned for ',i4,
     $    /7x,'lines. Reduce the size of the title or increase the',
     $    /7x,'dimensioning parameter ntitpa.')
          go to 990
        endif
c
        utitl(n) = uline
      enddo
  120 ntitl = n
c
      if (ntitl .gt. 0) then
c
c       Write the first 5 lines of the input problem title to the
c       screen file.
c
        write (nttyo,1040)
 1040   format(3x,'The input problem title is (first 5 lines',
     $   ' maximum):',/)
c
        i = min(ntitl,5)
        do n = 1,i
          j2 = ilnobl(utitl(n))
          j2 = min(j2,74)
          write (nttyo,1050) utitl(n)(1:j2)
 1050     format(5x,a)
        enddo
      endif
c
      write (nttyo,1060)
 1060 format(/3x,'Continuing to read the problem input ...')
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
c       nsbswt = the number of special basis switches
c       usbsw(1,n) = the species to be switched from the strict
c                      basis to the auxiliary basis set in the
c                      in the n-th switch
c       usbsw(2,n) = the species to be switched from the auxiliary
c                      basis set to the strict basis set in the
c                      n-th switch
c
      write (noutpt,1100)
 1100 format(' * Special basis switches')
c
      read (ninpts,1110,err=990) nsbswt
 1110 format(12x,i3)
      write (noutpt,1120) nsbswt
 1120 format(5x,'nsbswt= ',i3)
c
      do n = 1,nsbswt
        read (ninpts,1130,err=990) usbsw(1,n)
 1130   format(9x,a48)
        j2 = ilnobl(usbsw(1,n))
        write (noutpt,1140) usbsw(1,n)(1:j2)
 1140   format(1x,'species= ',a)
c
        read (ninpts,1150,err=990) usbsw(2,n)
 1150   format(15x,a48)
        j2 = ilnobl(usbsw(2,n))
        write (noutpt,1160) usbsw(2,n)(1:j2)
 1160   format(3x,'switch with= ',a)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
c       tempc  = temperature, C
c
      write (noutpt,1165)
 1165 format(' * General')
c
      read (ninpts,1170,err=990) tempc
 1170 format(12x,e12.5)
      write (noutpt,1180) tempc
 1180 format(6x,'tempc= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
c       jpres3 = pressure code:
c
c         0 = Compute the pressure from the temperauture, using the
c             data file's reference pressure curve:
c               press = func(data file, T)
c
c         1 = Compute the pressure from the temperature, using the
c             1.013-bar/steam-saturation curve:
c               press = built-in func(T)
c
c         2 = Constant pressure:
c               press = pressb
c
c       press  = pressure, bars
c
      read (ninpts,1190,err=990) jpres3,press
 1190 format(12x,i3,/12x,e12.5)
      write (noutpt,1200) jpres3,press
 1200 format(5x,'jpres3= ',i3,/6x,'press= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Density.
c
c       rho    = density of aqueous solution in g/ml
c
      read (ninpts,1220,err=990) rho
 1220 format(12x,e12.5)
      write (noutpt,1222) rho
 1222 format(8x,'rho= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Total dissolved solutes.
c
c       itdsf3 = TDS code:
c
c         0 = Use the input value in mg/kg.sol (tdspkg)
c         1 = Use the input value in mg/L (tdspl)
c
c       tdspkg = total dissolved solutes, mg/kg.sol
c       tdspl  = total dissolved solutes, mg/L
c
      read (ninpts,1224,err=990) itdsf3,tdspkg,tdspl
 1224 format(12x,i3,/12x,e12.5,12x,e12.5)
      write (noutpt,1227) itdsf3,tdspkg,tdspl
 1227 format(5x,'itdsf3= ',i3,/5x,'tdspkg= ',1pe12.5,5x,'tdspl= ',e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species to adjust for electrical balance.
c
c       iebal3 = electrical balancing code:
c
c         0 = No balancing
c         1 = Balance on the species whose name is entered as uredox
c
c       uebal = name of a basis species whose concentration is to be
c                 adjusted to achieve electrical balance
c
      read (ninpts,1500,err=990) iebal3,uebal
 1500 format(12x,i3,/12x,a24)
      j2 = ilnobl(uebal)
      write (noutpt,1510) iebal3,uebal(1:j2)
 1510 format(5x,'iebal3= ',i3/6x,'uebal= ',a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Default redox constraint.
c
c       irdxc3 = default redox option switch:
c         -3 = Read a constraint on aqueous "O2(g)" in the regular
c                basis species constraint block
c         -2 = The pe is fixed at the value entered as "pei"
c         -1 = The Eh (V) is fixed at the value entered as "ehi"
c          0 = The log fO2 is fixed at the value entered as "fo2lgi"
c          1 = The log Fo2, Eh, pe, etc., is determined by a redox
c                couple, one member of which is defined by the name
c                of an auxiliary basis species entered as "uredox",
c                the member other of which is defined by its appearance
c                in the reaction for the former. Usually Fe++ is a
c                strict basis species, and Fe++ is in the auxiliary
c                basis set, so entering uredox = "Fe+++" specifies
c                the Fe+++/Fe++ couple. Concentration or other data
c                must be entered below for both members of the couple.
c                Couples involving non-aqueous phases can be defined
c                indirectly, using the jflgi = 25 option described
c                below. For example, to use the Hematite/Magnetite
c                couple, enter uredox = "Fe+++". In the basis species
c                constraint block, for Fe++, enter jflgi = 25 and
c                ucospi = "Magnetite", and for Fe+++, enter jflgi = 25
c                and ucospi = "Hematite".
c
c       fo2lgi = log fO2
c       ehi    = Eh, oxidation-reduction parameter
c       pei    = pe, electron activity
c       uredox = name (all 24 letters) of an auxiliary basis species
c                  that is part of a redox couple that will be used
c                  to  distribute other redox couples
c
c       Note: heterogeneous equilibria can be used also by setting
c         irdxc3 = 0, fep = 0., and jflgi(O2(g)) = 25
c
      read (ninpts,1232,err=990) irdxc3
 1232 format(12x,i3)
      write (noutpt,1234) irdxc3
 1234 format(5x,'irdxc3= ',i3)
      read (ninpts,1240,err=990) fo2lgi,ehi
 1240 format(12x,e12.5,12x,e12.5)
      write (noutpt,1242) fo2lgi,ehi
 1242 format(5x,'fo2lgi= ',1pe12.5,7x,'ehi= ',e12.5)
      read (ninpts,1250,err=990) pei,uredox
 1250 format(12x,e12.5,12x,a24)
      j2 = ilnobl(uredox)
      write (noutpt,1252) pei,uredox(1:j2)
 1252 format(8x,'pei= ',1pe12.5,4x,'uredox= ',a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous basis species and associated constraints.
c
c       uspeci = name of an aqueous species in the basis set. If
c                  the species is not defined as a basis species on
c                  the input file, it will be treated as a basis species
c                  in the current run. The name is constructed in
c                  species/phase format (the first 24 characters
c                  comprise the species part,the second 24 characters,
c                  the name of the corresponding phase). Only the
c                  species part is input; the code provides the
c                  phase part.
c
c       jflgi  = flag variable defining the type of constraint placed
c                  on a basis species. It determines the meaning of the
c                  "covali" parameter.
c
c       covali = a floating point datum (concentration, activity, etc.)
c                  whose meaning is specified by the jflgi parameter.
c
c       ucospi = the name of a species/phase which must be designated
c                  to complete a specification for the jflgi = 17, 18,
c                  or 25 options. For jflgi = 17 or 18, the species is
c                  an aqueous ion. For jflgi = 25, the species
c                  specified must belong to a phase other than the
c                  aqueous solution. The name is constructed in
c                  species/phase format. For the jflgi = 17 or 18
c                  options, the phase part may be left blank, as the
c                  phase by implication is 'aqueous solution.'
c                  For the jflgi = 25 option, the phase part may also
c                  be left blank. The phase will then be taken as that
c                  which first produces a name match on the species
c                  part. If the phase is intended to be a solid or
c                  liquid solution, failure to specify the phase part
c                  will result in matching the pure component phase
c                  instead.
c
c       Summary of the jflgi conventions:
c
c         -1 = Not present in the system. This value is assigned
c                as a default to strict basis species.
c
c          0 = Total concentration, molal ("covali")
c                Note: enter jflgi = 0 for water and O2(g). The
c                "covali" parameter for O2(g) is always log fugacity.
c                A line for O2(g) is not entered here unless
c                irdxc3 = -3.
c
c          1 = Total concentration, molar ("covali")
c
c          2 = Total concentration, mg/L ("covali")
c
c          3 = Total concentration, mg/kg.sol ("covali")
c
c          7 = Total alkalinity, eq/kg.H2O ("covali")
c
c          8 = Total alkalinity, eq/L ("covali")
c
c          9 = Total alkalinity, eq/kg.sol ("covali")
c
c         10 = Total alkalinity, mg/L CaCO3 ("covali")
c
c         11 = Total alkalinity, mg/L HCO3- ("covali")
c
c         16 = Log activity (molal scale) ("covali")
c
c         17 = The function abs(zj) log ai +/- abs(zi) log aj,
c                where i and j are the ions specified by "uspeci"
c                and "ucospi". The sign of the second term is positive
c                for cation-anion and anion-cation combinations,
c                negative for like-charge combinations. To input the
c                pHCl defined as pH + pCl, enter H+ as "uspeci", -pHCl
c                for "covali", and Cl- for uphas1.
c
c         18 = Log mean activity of the neutral electrolyte composed
c                of the ions specified by "uspeci" and "ucospi".
c
c         19 = pX, or -log activity. This is very similar to the
c                jflgi= 16 option, except that the "covali" input
c                has the opposite sign. This can be used to enter
c                pH, but see jflag= 20 below.
c
c         20 = pH. This is very similar to the jflgi= 19 (pX) option.
c                It can only be applied to H+, however.
c
c         21 = pHCl. This is very similar to the jflgi= 17 (log
c                activity combination) option. It can only be applied
c                to H+ or Cl-, however. The other ion is then the
c                counterion. Note that the counterion is not specified
c                in the "ucospi" input.
c
c         25 = Heterogeneous equilibrium. Here "usp" contains the name
c                of the relevant species (first 24 characters) and
c                phase (last 24 characters). If the relevant species
c                is a gas species, its fugacity is specified by the
c                "covali" input. This is a dangerous option.
c
c         27 = Homogeneous equilibrium - the species must be in the
c                auxiliary basis when the calculation commences;
c                it and its own dependent species are treated as
c                depenent species of the corresponding species in the
c                strict basis, but are not limited by the total
c                concentration, if one is specified, for that
c                corresponding species. No "covali" input is required.
c                This is a dangerous option.
c
c                For example, suppose you have a sulfate analysis
c                of a water and you expect that sulfide species
c                may be significant and possibly in equilibrium with
c                sulfate. If you think the sulfate analysis
c                measured both sulfate and sulfide, enter the
c                analytical value as the total concentration of
c                sulfate and specify jflgi(HS-) = 30. If you think
c                the analysis measured only sulfate proper, then
c                enter jflgi(HS-) = 27 instead. If the redox state of
c                the water is very reducing you may get an infinite
c                or near-infinite amount of calculated sulfide.
c
c         16 = Log activity (molal scale) ("covali")
c
c         30 = Make non-basis. The species is treated as above,
c                but it and its own dependent species are constrained
c                by the total concentration entered for the
c                corresponding strict basis species. No "covali" input
c                is required.
c
      write (noutpt,2490)
 2490 format(' * Aqueous basis species')
c
      nbi = 0
c
      do nn = 1,nbtmax + 1
        read (ninpts,2500,err=990) ux8,ux48
 2500   format(a8,1x,a48)
        j2 = ilnobl(ux48)
c
        if (ux8(1:8) .eq. uendit(1:8)) then
          j3 = ilnobl(uendit)
          write (noutpt,2510) uendit(1:j3)
 2510     format(1x,a)
          go to 400
        endif
c
        nbi = nbi + 1
c
        if (nbi .gt. nbtmax) then
          write (noutpt,2520) nbtmax,ux48(1:j2)
          write (nttyo,2520) nbtmax,ux48(1:j2)
 2520     format(/' * Error - (EQ3NR/rd3inw) The number of basis',
     $    ' species read',/7x,'from the input file exceeded the',
     $    ' maximum of ',i3,' while',/7x,'trying to read data for',
     $    ' the species ',a,'.',/7x,'Increase the dimensioning',
     $    ' parameter nbtpar.')
          go to 990
        endif
c
        write (noutpt,2530) ux48(1:j2)
 2530   format(1x,'species= ',a)
        uspeci(nbi) = ux48
c
        read (ninpts,2540,err=990) jflgi(nbi),covali(nbi)
 2540   format(10x,i2,12x,e12.5)
        write (noutpt,2550) jflgi(nbi),covali(nbi)
 2550   format(4x,'jflgi= ',i2,4x,'covali= ',1pe12.5)
c
        if (jflgi(nbi).eq.17 .or. jflgi(nbi).eq.18
     $  .or. jflgi(nbi).eq.25) then
          read (ninpts,2570,err=990) ucospi(nbi)
 2570     format(10x,a48)
          j3 = ilnobl(ucospi(nbi))
          write (noutpt,2580) ucospi(nbi)(1:j3)
 2580     format(3x,'ucospi= ',a)
        endif
      enddo
c
  400 nbti = nbi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation. This section reads the directives for
c     creating ion exchange phases and species and their associated
c     intrinsic (including thermodynamic) properties. The data is
c     essentially that which might be read from a supporting data file.
c     Scenario-specific data (e.g., a specified amount of exchanger or
c     a specific composition for an exchanger phase) are not included
c     in this section.
c
c       net    = the number of ion exchangers
c       ugexp  = array of ion exchange phase names
c       mwtges = array of molecular weights of substrates of ion
c                  exchange phases
c       ugexmo = array of strings identifying models for composing
c                  exact ion exchange species and corresponding
c                  reactions; examples include:
c                    'Vanselow' = Vanselow model
c                    'Gapon'    = Gapon model
c                    'Site-mixing' = the general site-mixing model
c       tgexp  = array of reference temperatures (C)  for the
c                  thermodynamic data for the reactions specified
c                  for the exchanger phases
c       jgext  = array of numbers of exchange sites in ion exchange
c                  phases
c       ugexj  = array of names specified for the sites on the various
c                 exchangers
c       cgexj  = array of numbers of moles of exchange sites per mole
c                  of substrate in ion exchange phases
c       zgexj  = array of electrical charges of exchange sites
c                  in ion exchange phases. The total charge number
c                  for a site is the product of this charge and
c                  and the number of moles of the site per mole
c                  of exchanger. The sign of the charge on a site
c                  is generally the opposite of that of the ions
c                  which exchange on it.
c       ngexrt = array of numbers of ion exchange reactions specified
c                  for a given site and exchanger
c       ugexr  = array of strings containing compact representations
c                  of the exchange reactions; e.g., 'Na+ = Ca++' for a
c                  reaction in which Na+ on the exchanger is replaced
c                  by Ca++. One may make specifications such as
c                  'Na+ = ' in which case the ion goes into solution
c                  leaving a bare substrate. All reactions are
c                  normalized to the exchange (or loss) of one
c                  equivalent. The exact form of the reaction is
c                  otherwise dependent on the mixing law specifed in
c                  the element of the ugexmo array for the current
c                  exchanger.
c       xlkgex = array of equilibrium constants or related data for
c                  the reaction specified in the above string
c       uxkgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xlkgex array:
c                    ' '       = log K per equivalent
c                    'LogK/eq' = log K per equivalent
c                    'kcal/eq' = DeltaG0r, kcal, per equivalent
c                    'kJ/eq'   = DeltaG0r, kJ, per equivalent
c       xhfgex = array of enthalpy of reaction data for the reaction
c                  specified in the above string
c       uhfgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xhfgex array:
c                    ' '       = DeltaH0r, kcal, per equivalent
c                    'kcal/eq' = DeltaH0r, kcal, per equivalent
c                    'kJ/eq'   = DeltaH0r, kJ, per equivalent
c       xvfgex = array of volume of reaction data for the reaction
c                  specified in the above string
c       uvfgex = array of strings denoting the kind of data in the
c                  corresponding entry of the xhfgex array:
c                    ' '      = DeltaV0r, cm3 per equivalent
c                    'cm3/eq' = DeltaV0r, cm3 per equivalent
c
      write (noutpt,1590)
 1590 format(' * Ion exchangers')
c
      read (ninpts,1595) ux8
 1595 format(12x,a8)
      call lejust(ux8)
      call locase(ux8)
      qgexsh = ux8(1:2).eq.'.t' .or. ux8(1:1).eq. 't'
      write (noutpt,1597)
 1597 format(5x,'qgexsh= ',l8)
c
      read (ninpts,1600,err=990) net
 1600 format(12x,i3)
      write (noutpt,1610) net
 1610 format(8x,'net= ',i3)
c
      if (net .gt. netmax) then
        write (noutpt,1620) netmax,net
        write (nttyo,1620) netmax,net
 1620   format(/' * Error - (EQ3NR/rd3inw) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data to create',/7x,'such phases. Increase',
     $  ' the dimensioning parameter netpar',/7x,'to at least ',i3,'.')
        go to 990
      endif
c
      do ne = 1,net
        read (ninpts,1630,err=990) ugexp(ne)
 1630   format(12x,a24)
        j2 = ilnobl(ugexp(ne))
        write (noutpt,1640) ugexp(ne)(1:j2)
 1640   format(6x,'ugexp= ',a)
c
        read (ninpts,1650,err=990) mwtges(ne)
 1650   format(12x,e12.5)
        write (noutpt,1660) mwtges(ne)
 1660   format(5x,'mwtges= ',1pe12.5)
c
        read (ninpts,1630,err=990) ugexmo(ne)
        j3 = ilnobl(ugexmo(ne))
        write (noutpt,1670) ugexmo(ne)(1:j3)
 1670   format(5x,'ugexmo= ',a)
c
        read (ninpts,1650,err=990) tgexp(ne)
        write (noutpt,1680) tgexp(ne)
 1680   format(6x,'tgexp= ',1pe12.5)
c
        read (ninpts,1690,err=990) jgext(ne)
 1690   format(12x,i3)
        write (noutpt,1700) jgext(ne)
 1700   format(6x,'jgext= ',i3)
c
        if (jgext(ne) .gt. jetmax) then
          write (noutpt,1710) jetmax,ugexp(ne)(1:j2),jgext(ne)
          write (nttyo,1710) jetmax,ugexp(ne)(1:j2),jgext(ne)
 1710     format(/' * Error - (EQ3NR/rd3inw) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data to create',
     $    a,'. Increase the',/7x,'dimensioning parameter jetpar to',
     $    ' at least ',i3,'.')
          go to 990
        endif
c
        do je = 1,jgext(ne)
          read (ninpts,1730,err=990) ugexj(je,ne)
 1730     format(12x,a8)
          j3 = ilnobl(ugexj(je,ne))
          write (noutpt,1740) ugexj(je,ne)(1:j3)
 1740     format(6x,'ugexj= ',a)
c
          read (ninpts,1750,err=990) cgexj(je,ne),zgexj(je,ne)
 1750     format(12x,e12.5,12x,e12.5)
          write (noutpt,1760) cgexj(je,ne),zgexj(je,ne)
 1760     format(6x,'cgexj= ',1pe12.5,5x,'zgexj= ',e12.5)
c
          read (ninpts,1690,err=990) ngexrt(je,ne)
          write (noutpt,1810) ngexrt(je,ne)
 1810     format(5x,'ngexrt= ',i3)
c
          if (ngexrt(je,ne) .gt. ietmax) then
            write (noutpt,1820) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
            write (nttyo,1820) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
 1820       format(/' * Error - (EQ3NR/rd3inw) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'reactions for a site',
     $      ' belonging to a generic ion exchange',/7x,'phase while',
     $      ' reading the data for site ',a,' of exchange phase',
     $      /7x,a,'. Increase the dimensioning parameter',
     $      /7x,'ietpar to at least ',i3,'.')
            go to 990
          endif
c
          do n = 1,ngexrt(je,ne)
            read (ninpts,1830,err=990) ugexr(n,je,ne)
 1830       format(12x,a56)
            j2 = ilnobl(ugexr(n,je,ne))
            write (noutpt,1840) ugexr(n,je,ne)(1:j2)
 1840       format(6x,'ugexr= ',a)
            read (ninpts,1850,err=990) xlkgex(n,je,ne),uxkgex(n,je,ne)
 1850       format(12x,e12.5,12x,a8)
            j4 = ilnobl(uxkgex(n,je,ne))
            write (noutpt,1860) xlkgex(n,je,ne),uxkgex(n,je,ne)(1:j4)
 1860       format(5x,'xlkgex= ',1pe12.5,5x,'units= ',a)
            read (ninpts,1850,err=990) xhfgex(n,je,ne),uhfgex(n,je,ne)
            j4 = ilnobl(uhfgex(n,je,ne))
            write (noutpt,1870) xhfgex(n,je,ne),uhfgex(n,je,ne)(1:j4)
 1870       format(5x,'xhfgex= ',1pe12.5,5x,'units= ',a)
            read (ninpts,1850,err=990) xvfgex(n,je,ne),uvfgex(n,je,ne)
            j4 = ilnobl(uvfgex(n,je,ne))
            write (noutpt,1880) xvfgex(n,je,ne),uvfgex(n,je,ne)(1:j4)
 1880       format(5x,'xvfgex= ',1pe12.5,5x,'units= ',a)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified generic ion exchanger compositions.
c
c       neti   = the number of generic exchangers for which compositions
c                  are entered
c       ugexpi = array of names of generic ion exchange phases for
c                  which compositions are entered
c       cgexpi = concentration (moles/kg H2O) of generic ion exchange
c                  phases for which compositions are entered
c       jgexti  = array of numbers of sites for the various generic
c                  exchanger phases
c       ugexji = array of names of exchange sites of generic ion
c                  exchange phases
c       ngexti  = array of numbers of exchange species for sites of
c                   the various generic exchanger phasess
c       ugexsi = array of names of species for sites of generic ion
c                  exchange phases
c       egexsi = array of equivalent fractions of ions on exchange sites
c                  in an ion exchange phase
c       xgexsi = array of moles fractions of ions on exchange sites
c                  in an ion exchange phase
c
      write (noutpt,1900)
 1900 format(' * Ion exchanger compositions')
c
      read (ninpts,1910,err=990) neti
 1910 format(12x,i3)
      write (noutpt,1920) neti
 1920 format(7x,'neti= ',i3)
      if (neti .le. 0) go to 250
c
      if (neti .gt. netmax) then
        write (noutpt,1930) netmax,neti
        write (nttyo,1930) netmax,neti
 1930   format(/' * Error - (EQ3NR/rd3inw) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data for concentrations',7x,'and compositions',
     $  ' of such phases. Increase the dimensioning',/7x,'parameter',
     $  ' netpar to at least ',i3,'.')
        go to 990
      endif
c
      do nei = 1,neti
        read (ninpts,1940,err=990) ugexpi(nei)
 1940   format(12x,a24)
        j2 = ilnobl(ugexpi(nei))
        write (noutpt,1950) ugexpi(nei)(1:j2)
 1950   format(5x,'ugexpi= ',a)
c
        read (ninpts,1960,err=990) cgexpi(nei)
 1960   format(12x,e12.5)
        write (noutpt,1970) cgexpi(nei)
 1970   format(5x,'cgexpi= ',1pe12.5)
c
        read (ninpts,1910,err=990) jgexti(nei)
        write (noutpt,1990) jgexti(nei)
 1990   format(5x,'jgexti= ',i3)
c
        if (jgexti(nei) .gt. jetmax) then
          write (noutpt,2000) jetmax,ugexpi(nei)(1:j2),jgexti(nei)
          write (nttyo,2000) jetmax,ugexpi(nei)(1:j2),jgexti(nei)
 2000     format(/' * Error - (EQ3NR/rd3inw) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data for the',
     $    ' concentration and composition of',/7x,a,'. Increase the',
     $    ' dimensioning parameter jetpar',/7x,'to at least ',i3,'.')
          go to 990
        endif
c
c       Find the corresponding ne index.
c
        do ne = 1,net
          j2 = ilnobl(ugexp(ne))
          j3 = ilnobl(ugexpi(nei))
          if (ugexp(nei)(1:j3) .eq. ugexp(ne)(1:j2)) go to 240
        enddo
c
        write (noutpt,2002) ugexpi(nei)(1:j3)
        write (nttyo,2002) ugexpi(nei)(1:j3)
 2002   format(/' * Error - (EQ3NR/rd3inw) Data are present on the',
     $  ' input file for the',/7x,'generic ion exchange phase "',a,
     $  ', but this phase',/7x,"hasn't been previously defined.",
     $  " Can't determine the requisite model,",/7x,"therefore can't",
     $  ' finish reading the current data for this phase.')
        stop
c
  240   j2 = ilnobl(ugexmo(ne))
        if (ugexmo(ne)(1:j2) .eq. 'Gapon' .or.
     $    ugexmo(ne)(1:6) .eq. 'Gapon-' .or.
     $    ugexmo(ne)(1:j2) .eq. 'Vanselow' .or.
     $    ugexmo(ne)(1:9) .eq. 'Vanselow-') then
c
c         Input composition is described in terms of equivalent
c         fractions on the sites.
c
          qgexef = .true.
        else
c
c         Input composition is described in terms of mole fractions
c         on the sites.
c
          qgexef = .false.
        endif
c
        do jei = 1,jgexti(nei)
          read (ninpts,2010,err=990) ugexji(jei,nei)
 2010     format(12x,a8)
          j3 = ilnobl(ugexji(jei,nei))
          write (noutpt,2020) ugexji(jei,nei)(1:j3)
 2020     format(5x,'ugexji= ',a)
c
          read (ninpts,1910,err=990) ngexti(jei,nei)
          write (noutpt,2030) ngexti(jei,nei)
 2030     format(5x,'ngexti= ',i3)
c
          if (ngexti(jei,nei) .gt. ietmax) then
            write (noutpt,2040) ietmax,ugexji(jei,nei),ugexpi(nei),
     $      ngexti(jei,nei)
            write (nttyo,2040) ietmax,ugexji(jei,nei),ugexpi(nei),
     $      ngexti(jei,nei)
 2040       format(/' * Error - (EQ3NR/rd3inw) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'species on an exchange',
     $      ' site of a generic ion exchange phase',/7x,'while reading',
     $      /7x,'the data for the composition of site ',a,' of',
     $      /7x,'exchange phase ',a,'. Increase the dimensioning',
     $      ' parameter ietpar to at least ',i3,'.')
            go to 990
          endif
c
          if (qgexef) then
c
c           The data are in equivalent fractions.
c
            do iei = 1,ngexti(jei,nei)
              read (ninpts,2050,err=990) ugexsi(iei,jei,nei),
     $        egexsi(iei,jei,nei)
 2050         format(12x,a24,10x,e12.5)
              write (noutpt,2052) ugexsi(iei,jei,nei),
     $        egexsi(iei,jei,nei)
 2052         format(5x,'ugexsi= ',a24,2x,'egexsi= ',1pe12.5)
            enddo
          else
c
c           The data are in mole fractions.
c
            do iei = 1,ngexti(jei,nei)
              read (ninpts,2050,err=990) ugexsi(iei,jei,nei),
     $        xgexsi(iei,jei,nei)
              write (noutpt,2060) ugexsi(iei,jei,nei),
     $        xgexsi(iei,jei,nei)
 2060         format(5x,'ugexsi= ',a24,2x,'xgexsi= ',1pe12.5)
            enddo
          endif
        enddo
      enddo
c
  250 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified solid solution compositions.
c
c       nxti   = the number of solid solutions for which compositions
c                  are entered
c       usoli  = array of names of solid solutions for which
c                  compositions are entered
c       ncmpri = range pointer array for solid solutions for which
c                  compositions are entered; defines the range in
c                  the umemi and xbari arrays which corresponds to the
c                  end-member components of a given solid solution
c       nssoti = number of end-member components in a given solid
c                  solution
c       umemi  = array of names of end-member components of solid
c                  solutions for which compositions are entered
c       xbari  = array of moles fractions of end-member components
c                  of solid solutions for which compositions are entered
c
      write (noutpt,2100)
 2100 format(' * Solid solution compositions')
c
      read (ninpts,2102,err=990) nxti
 2102 format(12x,i3)
      write (noutpt,2104) nxti
 2104 format(7x,'nxti= ',i3)
c
      if (nxti .gt. nxtimx) then
        write (noutpt,2107) nxtimx,nxti
        write (nttyo,2107) nxtimx,nxti
 2107   format(/' * Error - (EQ3NR/rd3inw) Have exceeded the maximum',
     $  /7x,'number of ',i5,' solid solutions for which',
     $  ' compositions',/7x,'may be specified on the input file.',
     $  ' Increase the dimensioning',/7x,'parameter nxtipa to at',
     $  ' least ',i3,'.')
        go to 990
      endif
c
      nxic = 0
c
      do nxi = 1,nxti
        read (ninpts,2120,err=990) usoli(nxi)
 2120   format(12x,a24)
        j2 = ilnobl(usoli(nxi))
        write (noutpt,2130) usoli(nxi)(1:j2)
 2130   format(6x,'usoli= ',a24)
c
        read (ninpts,2140,err=990) nssoti
 2140   format(12x,i3)
        write (noutpt,2142) nssoti
 2142   format(5x,'nssoti= ',i3)
c
        ncmpri(1,nxi) = nxic + 1
        ncmpri(2,nxi) = nxic + nssoti
        nr1 = ncmpri(1,nxi)
        nr2 = ncmpri(2,nxi)
c
        if (nr2 .gt. nxicmx) then
          write (noutpt,2150) nxicmx,usoli(nxi)(1:j2),nr2
          write (nttyo,2150) nxicmx,usoli(nxi)(1:j2),nr2
 2150     format(/' * Error - (EQ3NR/rd3inw) Have exceeded the',
     $    ' maximum number',/7x,'of ',i5,' solid solution species',
     $    ' for which mole fractions',/7x,'are specified on the',
     $    ' input file. This occurred while reading ',/7x,'data',
     $    ' for the solid solution ',a,'. Increase',/7x,'the',
     $    ' dimensioning parameter nxicpa to at least ',i3,'.')
          go to 990
        endif
c
        do nxic = nr1,nr2
          read (ninpts,2160,err=990) umemi(nxic),xbari(nxic)
 2160     format(12x,a24,12x,e12.5)
          write (noutpt,2170) umemi(nxic),xbari(nxic)
 2170     format(6x,'umemi= ',a24,5x,'xbari= ',1pe12.5)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
c       nxmod = the number of suppressed/altered species/reactions
c
      write (noutpt,2330)
 2330 format(' * Alter/suppress options')
c
      read (ninpts,2340,err=990) nxmod
 2340 format(12x,i3)
      write (noutpt,2350) nxmod
 2350 format(6x,'nxmod= ',i3)
c
      if (nxmod .gt. nxmdmx) then
        write (noutpt,2360) nxmdmx
        write (nttyo,2360) nxmdmx
 2360   format(/' * Error - (EQ3NR/rd3inw) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  /7x,'options or increase the dimensioning parameter nxmdpa.')
        go to 990
      endif
c
c     Nxmod options.
c
c       uxmod = the name (all 48 letters) of the species. If the
c                 phase part is not given, the option is applied to
c                 every species for which the species part of its name
c                 generates a match.
c       kxmod  = alter/suppress code
c         -1 = the species is suppressed
c          0 = the log K is replaced by xlkmod
c          1 = the log K is augmented by xlkmod
c          2 = same as kxmod=1, but xlkmod is input in units of kcal
c                per mole of the associated species
c       xlkmod = log K value alteration function as defined above
c
      do n = 1,nxmod
        read (ninpts,2370,err=990) uxmod(n),kxmod(n),xlkmod(n)
 2370   format(12x,a48,/12x,i2,22x,e12.5)
        j2 = ilnobl(uxmod(n))
        write (noutpt,2380) uxmod(n)(1:j2),kxmod(n),xlkmod(n)
 2380   format(4x,'species= ',a,/5x,'option= ',i2,14x,
     $  'xlkmod= ',1pe12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
c       iopt(1) - iopt(3) = Used only by EQ6
c
c       iopt(4) = Solid solution products:
c          0 = Solid solutions are ignored
c          1 = Solid solutions are permitted
c          2 = Solid solutions are permitted and compositions to
c                use in computing saturation indices are read
c
c       iopt(5) - iopt(7) = Used only by EQ6
c
c       iopt(8) = Not used
c
c       iopt(9) - iopt(10) = Used only by EQ6
c
c       iopt(11) = Auto basis switching, in pre-N-R optimization:
c          0 = Off
c          1 = On
c
c       iopt(12) - iopt(13) Used only by EQ6
c
c       iopt(14) = Not used
c
c       iopt(15) - iopt(16) = Used only by EQ6
c
c       iopt(17) = pickup file options:
c         -1 = Don't write a pickup file
c          0 = Write a pickup file at the end of the run
c
c       iopt(18) = Used only by EQ6
c
c       iopt(19) = Advanced EQ3NR pickup file options:
c          0 = Write a normal EQ3NR pickup file
c          1 = Write an EQ6 input file with Quartz dissolving, using
c                a relative rate law
c          2 = Write an EQ6 input file with Albite dissolving, using
c                a TST rate law
c          3 = Write an EQ6 input file to mix two fluids appearing
c                on a single EQ3NR input file; the first fluid on that
c                file is set up as a special reactant called "Fluid 2"
c                that will be added to the second fluid on that
c                file, which in effect becomes "Fluid 1". Set iopt(19)
c                to 3 only for the second fluid.
c
c       iopt(20) = Used only by EQ6
c
      write (noutpt,1365)
 1365 format(' * Iopt, iopg, iopr, and iodb options')
c
      write (noutpt,1370)
 1370 format(' *',15x,'1    2    3    4    5    6    7    8    9   10')
      read (ninpts,1380,err=990) (iopt(i), i = 1,20)
 1380 format(12x,10i5)
      write (noutpt,1390) (iopt(i), i = 1,20)
 1390 format(3x,'iopt1-10= ',10i5,/2x,'iopt11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
c       iopg(1) = Model for aqueous species activity coefficients:
c         -1 = The  Davies equation
c          0 = The B-dot equation
c          1 = Pitzer's  equations
c          2 = HC + DH equations
c
c       iopg(2) = Rescaling of aqueous ionic activity coefficients for
c                   consistency with a desired pH scale:
c         -1 = "Internal" pH scale; no scaling (e.g., the "Davies"
c                scale if iopg(1) = -1, the "B-dot" scale if
c                iopg(1) = 0, or the Pitzer scale if iopg(1) = 1)
c          0 = The NBS pH scale (log gamma(Cl-) is defined by the
c                Bates-Guggenheim equation)
c          1 = The Mesmer pH scale (log gamma(H+) = 0)
c
c       iopg(3) = iopg(20) = Not used
c
      read (ninpts,1410,err=990) (iopg(i), i = 1,20)
 1410 format(12x,10i5)
      write (noutpt,1420) (iopg(i), i = 1,20)
 1420 format(3x,'iopg1-10= ',10i5,/2x,'iopg11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
c       iopr(1) = List the names of all species read from the
c                   supporting data file:
c          0 = Don't list
c          1 = List
c
c       iopr(2) = List all reactions:
c          0 = Don't list
c          1 = List all reactions (this can be quite lengthy)
c          2 = Also print the log K values
c          3 = Also print the coefficients of the interpolating
c                polynomials
c
c       iopr(3) = List the hard core diameters of the aqueous species:
c          0 = Don't list
c          1 = List
c
c       iopr(4) = Print a table at each print point of the
c                   concentrations, activities, and activity
c                   coefficients of the aqueous species:
c         -3  = Omit species with molalities < 1.e-8
c         -2 =  Omit species with molalities < 1.e-12
c         -1 =  Omit species with molalities < 1.e-20
c          0 =  Omit species with molalities < 1.e-100
c          1 =  Include all species
c
c       iopr(5) = Print a table at each print point of the cation/H+
c                   activity ratios, anion-H+ activity products, and
c                   neutral species activities:
c          0 = Don't print
c          1 = Print cation/H+ activity ratios only
c          2 = Print cation/H+ activity ratios and anion-H+ activity
c                products only
c          3 = Print cation/H+ activity ratios, anion-H+ activity
c                products, and neutral species activities
c
c       iopr(6) = At each print point, print a table of the percentage
c                    contributions for each aqueous mass balance total:
c         -1 = Don't print any tables
c          0 = Print tables including 99% of all contributing species
c          1 = Print tables including all contributing species
c
c       iopr(7) = Print a table at each print point of the saturation
c                   indices and affinities of the various non-aqueous
c                   phases:
c         -1 = Don't print
c          0 = Print for those phases not undersaturated by
c                more than 10 kcal
c          1 = Print for all phases
c
c       iopr(8) = Print a table at each print point of the fugacities
c                   of the gas species:
c         -1 = Don't print
c          0 = Print
c          1 = Print
c
c       iopr(9) = Print a table at each print of the mean molal
c                   activity coefficients:
c         -1 = Don't print
c          0 = Don't print
c          1 = Print
c
c       iopr(10) = Print a tabulation at the start of running the
c                    current problem of the Pitzer interaction
c                    coefficients:
c          0 = Don't print
c          1 = Print a summary of the names of the species present and
c                the number of Pitzer interaction coefficients
c          2 = Print a summary of the names of the species present and
c                the number of Pitzer interaction coefficients
c
c       iopr(11) - iopr(16) = Not used
c
c       iopr(17) = pickup file format:
c          0 = Use the same format ("D" or "W") as the input file
c          1 = Use "W" format
c          2 = Use "D" format
c
c       iopr(18) - iopr(20) = Not used
c
      read (ninpts,1430,err=990) (iopr(i), i = 1,20)
 1430 format(12x,10i5)
      write (noutpt,1440) (iopr(i), i = 1,20)
 1440 format(3x,'iopr1-10= ',10i5,/2x,'iopr11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
c       iodb(1) = General diagnostic messages:
c          0 = Don't print
c          1 = Print Level 1 diagnostic messages
c          2 = Print Level 1 and Level 2 diagnostic messages
c
c       iodb(2)  = Used only by EQ6
c
c       iodb(3) = Pre-Newton-Raphson optimization:
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information
c          3 = Print more detailed information
c          4 = Also print changes to activity coefficients
c
c       iodb(4) = Newton-Raphson iteration:
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information including the residual and
c                correction vectors
c          3 = Also print the Jacobian matrix
c          4 = Also print changes to activity coefficients
c
c       iodb(5)  = Used only by EQ6
c
c       iodb(6) = Hypothetical affinity calculations (for solid
c                   solutions, etc.):
c          0 = Don't print
c          1 = Print summary information
c          2 = Print detailed information
c
c       iodb(7)  = Used only by EQ6
c
c       iodb(8) -iodb(20) = Not used
c
      read (ninpts,1470,err=990) (iodb(i), i = 1,20)
 1470 format(12x,10i5)
      write (noutpt,1480) (iodb(i), i = 1,20)
 1480 format(3x,'iodb1-10= ',10i5,/2x,'iodb11-20= ',10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical parameters.
c
c       tolbt = convergence tolerance on residual magnitude
c                 (in Newton-Raphson iteration)
c       toldl = convergence tolerance on correction magnitude
c                 (in Newton-Raphson iteration)
c       itermx = maximum number of Newton-Raphson iterations
c
      write (noutpt,1270)
 1270 format(' * Numerical parameters')
c
      read (ninpts,1280,err=990) tolbt,toldl
 1280 format(12x,e12.5,12x,e12.5)
      write (noutpt,1290) tolbt,toldl
 1290 format(6x,'tolbt= ',1pe12.5,5x,'toldl= ',e12.5)
c
      read (ninpts,1300,err=990) itermx
 1300 format(12x,i3)
      write (noutpt,1310) itermx
 1310 format(5x,'itermx= ',i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
c       nobswt = the number of ordinary basis switches
c       uobsw(1,n) = the species to be switched from the basis
c                      set in the n-th switch
c       uobsw(2,n) = the species to be switched into the basis
c                      set in the n-th switch
c
      write (noutpt,2700)
 2700 format(' * Ordinary basis switches')
c
      read (ninpts,1110,err=990) nobswt
      write (noutpt,2710) nobswt
 2710 format(5x,'nobswt= ',i3)
c
      do n = 1,nobswt
        read (ninpts,1130,err=990) uobsw(1,n)
        j2 = ilnobl(uobsw(1,n))
        write (noutpt,1140) uobsw(1,n)(1:j2)
        read (ninpts,1150,err=990) uobsw(2,n)
        j2 = ilnobl(uobsw(2,n))
        write (noutpt,1160) uobsw(2,n)(1:j2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation flag tolerance.
c
c       tolspf = saturation flag tolerance for minerals and
c                  various other phases, in kcal. This parameter
c                  controls the printing of the "SATD" and "SSATD"
c                  flags in the saturation state tables. It does not
c                  have any other effect in EQ3NR.
c
      write (noutpt,1292)
 1292 format(' * Saturation flag tolerance')
c
      read (ninpts,1294,err=990) tolspf
 1294 format(12x,e12.5)
      write (noutpt,1296) tolspf
 1296 format(5x,'tolspf= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale factor for the mass of aqueous solution to write
c     on the pickup file.
c
c       scamas = scale factor (the default is 1.0, which corresponds
c                  to a mass of aqueous solution containing 1 kg
c                  of solvent water)
c
      write (noutpt,1315)
 1315 format(' * Aqueous phase scale factor')
c
      read (ninpts,1320,err=990) scamas
 1320 format(12x,e12.5)
      write (noutpt,1330) scamas
 1330 format(5x,'scamas= ',1pe12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,3000) nprob
      write (nttyo,3000) nprob
 3000 format(/'   Done reading problem ',i3,'.',/)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrderr = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine fbassw(jcsort,jflag,mosp,narn1,narn2,nse,nsi,nsj,
     $ nstmax,weight,wsi)
c
c     This subroutine attempts to find a candidate species to switch
c     switch into the active basis set. The function here is similar
c     to that EQLIB/fdomsp.f, which finds the species that dominates
c     a mass balance.
c
c     As presently contructed, this routine considers switches only
c     among the set of aqueous species. This condition may be relaxed
c     in the future.
c
c     This subroutine is called by:
c
c       EQLIB/abswpk.f
c       EQ6/absswb.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jcsort = array of aqueous species indices in order of
c                  increasing concentration
c       jflag  = jflag array defining constraint types imposed on
c                  aqueous species
c       mosp   = array of numbers of moles of species
c       narn1  = index of the first aqueous species
c       narn2  = index of the last aqueous species
c       nse    = the data file basis species defining the current
c                mass balance
c       nsj    = the active basis species for the same mass balance;
c                nsj may be nse
c       weight = stoichiometric weighting factor
c
c     Principal output:
c
c       nsi    = index of the aqeuous species that would represent the
c                  optimal basis switch
c       wsi    = weight(nsi)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax),jflag(nstmax)
c
      integer narn1,narn2,nse,nsi,nsj
c
      real(8) mosp(nstmax),weight(nstmax)
c
      real(8) wsi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ns,nsc,nss
c
      real(8) ap0,ap1,m0,m1,p0,p1,rx,w0,w1
c
c-----------------------------------------------------------------------
c
c     Note that nsi = 0 is equivalent to nsi = nsj (the current
c     active basis species associated with the present mass balance).
c     Returning no candidate means keeping the existing basis species.
c
      nsi = 0
      wsi = 0.
c
c     Make sure that the nse-th species is an aqueous species.
c
      if (nse.lt.narn1 .or. nse.gt.narn2) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Start by testing against the current active basis species.
c
      m0 = mosp(nsj)
      w0 = weight(nsj)
      p0 = w0*m0
      ap0 = abs(p0)
c
c     Loop over all aqueous species, testing in order of decreasing
c     number of moles. The current active basis species is not tested
c     against itself in this loop because jflag(nsj) is not 30.
c     Therefore, the following code cannot return nsi equal to nsj. If
c     the corresponding data file basis species is not the current
c     active basis species for the present mass balance, then jflag(nse)
c     will be 30, and this species will be tested as a potential
c     candidate.
c
      do nsc = narn1,narn2
        nss = narn2 + narn1 - nsc
        ns = jcsort(nss)
        w1 = weight(ns)
        m1 = mosp(ns)
        if (m1 .le. 0.) go to 110
        if (w1 .ne. 0.) then
          if (jflag(ns) .eq. 30) then
            p1 = w1*m1
            ap1 = abs(p1)
            if (ap1 .gt. ap0) then
c
c             Have found a new leading candidate.
c
              m0 = m1
              w0 = w1
              p0 = p1
              ap0 = ap1
              nsi = ns
              go to 100
            endif
          endif
        endif
c
c       Stop the search if the mole number ratio is now so high that
c       it becomes unreasonable to expect the ratio of the weighting
c       factors to possibly overcome this so as to yield ap1 > ap0.
c       Note that the possibility of m1 being zero has been tested
c       above, so the ratio calculation below should be safe.
c
        rx = m0/m1
        if (rx .gt. 100.) go to 110
  100   continue
      enddo
c
  110 wsi = w0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine nrxnck(nbtmx1,ndrsts,nentri,nerr,qduprs,udrsi)
c
c     Check the associated raection of a species to ensure that
c     each species name appearing in the reaction is unique.
c
c     This subroutine is called by:
c
c       EQPT/rxnsck.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmx1
c
      integer nentri(nbtmx1)
c
      integer ndrsts,nerr
c
      logical qduprs
c
      character(len=24) udrsi(nbtmx1)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 unam
c
      integer i,j,k,ncount
c
c-----------------------------------------------------------------------
c
      qduprs = .false.
c
c     Check each name for uniqueness.
c
      do i = 1,ndrsts
        unam = udrsi(i)
        ncount = 1
        if (unam(1:7) .ne. '<blank>') then
          do j = i + 1,ndrsts
            if (unam(1:24) .eq. udrsi(j)(1:24)) then
c
c             Have found a duplicate entry moving down the list from
c             the entry now being tested for uniqueness. For the first
c             such duplicate entry only, make sure that there is not a
c             duplicate entry moving up the list from the entry now
c             being tested. If there is such a entry, then the
c             duplication in question has been noted previously and
c             should not be noted again.
c
              if (ncount .eq. 1) then
                do k = 1,i - 1
                  if (unam(1:24) .eq. udrsi(k)(1:24)) then
c
c                   Have found a duplicate entry preceding the entry
c                   now being tested for uniqueness.
c
                    go to 100
                  endif
                enddo
              endif
c
c             Have found a duplication that has not been previously
c             noted.
c
              ncount = ncount + 1
            endif
          enddo
  100     continue
        endif
c
        nentri(i) = ncount
        if (ncount .gt. 1) qduprs = .true.
      enddo
c
      end

      subroutine tripck(na,nc,nerr,nn,noutpt,nttyo,n1,n2,n3,
     $ qdup12,qdup13,qdup23,unam1,unam2,unam3)
c
c     This suboutine checks the species triplets that were read
c     from the DATA0 file for illegal combinations.
c
c     The only legal combinations here correspond to ternary
c     systems and maximal third order in the expansion of the
c     Gibbs energy. These are:
c
c       nnn'      mu(nnn') maps to itself
c       nca       zeta(nca) maps to mu(nca)
c       cc'a      psi(cc'a) maps to mu(cc'a)
c       aa'c      psi(aa'c) maps to mu(aa'c)
c
c     Here n = neutral, n' a different neutral, c = cation, c' = a
c     different cation, a = anion, and a' = a different anion.
c     Solvent water (w) may not appear in any combination in the
c     normal Pitzer treatment of electrolyte solutions.
c
c     Other possible combinations are not allowed because of one or
c     more of the following reasons:
c
c       1. The combination corresponds to systems of higher order
c          (e.g., cc'c'')
c       2. The combination corresponds to systems of lesser order
c          (e.g., nnn and cca)
c       3. The combination corresponds to parameters that are defined
c          by convention to be zero (i.e., to unused parameters).
c          Examples include ccc and ncc.
c
c     This suboutine is called by:
c
c       EQPT/rdpz3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       na     = number of anions in a species triplet
c       nc     = number of cations in a species triplet
c       nn     = number of neutral species in a species triplet
c       n1     = index of the first species in a triplet
c       n2     = index of the second species in a triplet
c       n3     = index of the third species in a triplet
c       unam1  = first name in a species triplet
c       unam2  = second name in a species triplet
c       unam3  = third name in a species triplet
c
c     Principal output:
c
c       nerr   = error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer na,nc,nn,nerr,n1,n2,n3
c
      logical qdup12,qdup13,qdup23
c
      character*24 unam1,unam2,unam3
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(unam1)
      j3 = ilnobl(unam2)
      j4 = ilnobl(unam3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for illegal appearance of solvent water.
c
      if (unam1(1:4) .eq.'H2O ' .or. unam2(1:4) .eq.'H2O ' .or.
     $  unam3(1:4).eq.'H2O ' .or. n1.eq.1 .or. n2.eq.1 .or.
     $  n3.eq.1) then
        write (noutpt,1430) unam1(1:j2),unam2(1:j3),unam3(1:j4)
        write (nttyo,1430) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1430   format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $  ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $  ' among the blocks for',/7x,'"mixture parameters".',
     $  ' Solvent water may not appear in such a',/7x,'triplet in',
     $  ' the normal Pitzer treatment of electrolyte',
     $  /7x,'solutions.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qdup12 .and. qdup13) then
c
c       The same species appears three times.
c
        if (nc.gt.0 .or. na.gt.0) then
c
c         The same cation or anion appears three times.(ccc or aaa).
c
          write (noutpt,1110) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1110) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1110     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". The same',
     $    ' ion appears three times.',/7x,'This is not a valid',
     $    ' combination, as the corrresponding lambda and mu',
     $    /7x,'data are defined to be zero by convention in the normal',
     $    ' Pitzer',/7x,'treatment of electrolyte solutions.')
        endif
c
        if (nn .gt. 0) then
c
c         The same neutral appears three times (nnn).
c
          write (noutpt,1112) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1112) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1112     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". The',
     $    ' same neutral appears three times.',/7x,'This is not',
     $    ' a valid combination for the present kind of block.',
     $    /7x,'Enter these data in a block for "single-salt',
     $    ' parameters".')
        endif
c
        nerr = nerr + 1
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for other illegal combinations involving two or more
c     neutrals.
c
      if (nn .eq. 3) then
        if (.not.(qdup12 .or. qdup13 .or. qdup23)) then
c
c         Have three distinct neutrals (nn'n'').
c
          write (noutpt,1130) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1130) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1130     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". Three',
     $    ' distinct neutrals appear. This is not',/7x,'a valid',
     $    ' combination in the context of the normal Pitzer',
     $    /7x,'treatment of electrolyte solutions as it corresponds',
     $    ' to a',/7x,'quaternary system.')
          nerr = nerr + 1
          go to 999
        endif
      endif
c
      if (nn .eq. 2) then
        if (nc.eq.1 .or. na.eq.1) then
c
          if (qdup12 .or. qdup23 .or. qdup13) then
c
c           Have one of the following combinations: nnc or nna.
c
            write (noutpt,1132) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1132) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1132       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". One',
     $      ' neutral appears twice with an ion.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions. The corresponding',
     $      ' parameters',/7x,'are not used.')
          else
c
c           Have one of the following combinations: nn'c or nn'a.
c
            write (noutpt,1136) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1136) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1136       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". Two',
     $      ' neutrals appear with an ion.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions as it corresponds',
     $      ' to a',/7x,'quaternary system.')
          endif
          nerr = nerr + 1
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for other illegal combinations involving two or more
c     cations.
c
      if (nc .eq. 3) then
        if (.not.(qdup12 .or. qdup13 .or. qdup23)) then
c
c         Have three distinct cations (cc'c'').
c
          write (noutpt,1140) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1140) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1140     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". Three',
     $    ' distinct cations appear. This is',/7x,'not a valid',
     $    ' combination in the context of the normal Pitzer',
     $    /7x,'treatment of electrolyte solutions as it corresponds',
     $    ' to a',/7x,'quaternary system.')
          nerr = nerr + 1
          go to 999
        endif
c
        if (qdup12 .and. qdup13) then
c
c         Have one cation appearing three times (ccc).
c
          write (noutpt,1142) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1142) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1142     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". A single',
     $    ' cation appears three times. This',/7x,'is not a valid',
     $    ' combination in the context of the normal Pitzer',
     $    /7x,'treatment of electrolyte solutions. The corresponding',
     $    ' parameters are',/7x,'zero by convention.')
          nerr = nerr + 1
          go to 999
        endif
c
        if (qdup12 .or. qdup13 .or. qdup23) then
c
c         Have one cation appearing two times (ccc').
c
          write (noutpt,1144) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1144) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1144     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". A single',
     $    ' cation appears twice with another',/7x,'cation. This is',
     $    ' not a valid combination in the context of the normal',
     $    /7x,'Pitzer treatment of electrolyte solutions. The',
     $    ' corresponding',/7x,'parameters are not used.')
          nerr = nerr + 1
          go to 999
        endif
      endif
c
      if (nc .eq. 2) then
c
        if (qdup12 .or. qdup23 .or. qdup13) then
c
          if (nn .eq. 1) then
c
c           Have a repeated cation and a neutral (ccn).
c
            write (noutpt,1150) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1150) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1150       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". One',
     $      ' cation appears twice with a neutral.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions. The',
     $      ' corresponding parameters',/7x,'are not used.')
          elseif (na .eq. 1) then
c
c           Have a repeated cation and an anion (cca).
c
            write (noutpt,1152) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1152) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1152       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". One',
     $      ' cation appears twice with an anion.',/7x,'This is not a',
     $      ' valid combination for the present type of block. The',
     $      /7x,'corresponding parameters properly appear in a block',
     $      ' under',/7x,'"single-salt parameters".')
          endif
          nerr = nerr + 1
          go to 999
        else
c
          if (nn .eq. 1) then
c
c           Have two cations and a neutral (c'cn).
c
            write (noutpt,1154) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1154) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1154       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". Two',
     $      ' cations appear with a neutral.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions as it corresponds',
     $      ' to a',/7x,'quaternary system.')
            nerr = nerr + 1
            go to 999
          endif
c
c         Have two cations and an anion (cc'a). That is a legal
c         combination.
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for other illegal combinations involving two or more
c     anions.
c
      if (na .eq. 3) then
        if (.not.(qdup12 .or. qdup13 .or. qdup23)) then
c
c         Have three distinct anions (aa'a'').
c
          write (noutpt,1160) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1160) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1160     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". Three',
     $    ' distinct anions appear. This is',/7x,'not a valid',
     $    ' combination in the context of the normal Pitzer',
     $    /7x,'treatment of electrolyte solutions as it corresponds',
     $    ' to a',/7x,'quaternary system.')
          nerr = nerr + 1
          go to 999
        endif
c
        if (qdup12 .and. qdup13) then
c
c         Have one anion appearing three times (aaa).
c
          write (noutpt,1162) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1162) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1162     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". A single',
     $    ' anion appears three times. This',/7x,'is not a valid',
     $    ' combination in the context of the normal Pitzer',
     $    /7x,'treatment of electrolyte solutions. The corresponding',
     $    ' parameters are',/7x,'zero by convention.')
          nerr = nerr + 1
          go to 999
        endif
c
        if (qdup12 .or. qdup13 .or. qdup23) then
c
c         Have one anion appearing two times (aaa').
c
          write (noutpt,1164) unam1(1:j2),unam2(1:j3),unam3(1:j4)
          write (nttyo,1164) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1164     format(/' * Error - (EQPT/tripck) Have found an illegal data',
     $    ' block for the',/7x,'species triplet ',a,', ',a,', ',a,
     $    ' among the blocks',/7x,'for "mixture parameters". A single',
     $    ' anion appears twice with another',/7x,'anion. This is',
     $    ' not a valid combination in the context of the normal',
     $    /7x,'Pitzer treatment of electrolyte solutions. The',
     $    ' corresponding',/7x,'parameters are not used.')
          nerr = nerr + 1
          go to 999
        endif
      endif
c
      if (na .eq. 2) then
c
        if (qdup12 .or. qdup23 .or. qdup13) then
c
          if (nn .eq. 1) then
c
c           Have a repeated anion and a neutral (aan).
c
            write (noutpt,1170) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1170) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1170       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". One',
     $      ' anion appears twice with a neutral.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions. The',
     $      ' corresponding parameters',/7x,'are not used.')
          elseif (nc .eq. 1) then
c
c           Have a repeated anion and a cation (aac).
c
            write (noutpt,1173) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1173) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1173       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". One',
     $      ' anion appears twice with a cation.',/7x,'This is not a',
     $      ' valid combination for the present type of block. The',
     $      /7x,'corresponding parameters properly appear in a block',
     $      ' under',/7x,'"single-salt parameters".')
          endif
          nerr = nerr + 1
          go to 999
        else
c
          if (nn .eq. 1) then
c
c           Have two anions and a neutral (a'an).
c
            write (noutpt,1174) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1174) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1174       format(/' * Error - (EQPT/tripck) Have found an illegal',
     $      ' data block for the',/7x,'species triplet ',a,', ',a,', ',
     $      a,' among the blocks',/7x,'for "mixture parameters". Two',
     $      ' anions appear with a neutral.',/7x,'This is not a',
     $      ' valid combination in the context of the normal Pitzer',
     $      /7x,'treatment of electrolyte solutions as it corresponds',
     $      ' to a',/7x,'quaternary system.')
            nerr = nerr + 1
            go to 999
          endif
c
c         Have two anions and a cation (aa'c). That is a legal
c         combination.
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine rd3w8(cgexj,cgexpi,covali,ehi,egexsi,fo2lgi,iebal3,
     $ ietmax,iodb,iopg,iopr,iopt,irdxc3,itdsf3,itermx,jgext,jetmax,
     $ jflgi,jgexti,jpres3,kxmod,mwtges,nbti,nbtmax,ncmpri,net,neti,
     $ netmax,ngexti,ninpts,ngexrt,nobswt,nodbmx,nopgmx,noprmx,
     $ noptmx,noutpt,nprob,nsbswt,ntitl,ntitmx,nttyo,nxicmx,nxmdmx,
     $ nxmod,nxti,nxtimx,pei,press,qend,qgexsh,qrderr,rho,scamas,
     $ tdspkg,tdspl,tempc,tgexp,tolbt,toldl,tolspf,ucospi,uebal,
     $ ugexj,ugexji,ugexmo,ugexp,ugexpi,ugexr,ugexsi,umemi,uobsw,
     $ uredox,usbsw,usoli,uspeci,utitl,uhfgex,uvfgex,uxkgex,uxmod,
     $ xbari,xgexsi,xhfgex,xlkgex,xvfgex,xlkmod,zgexj)
c
c     This suboutine reads the EQ3NR INPUT file in compact ("W") format
c     for version 8.0.
c
c     This suboutine is a near-clone of EQ3NR/rd3inw.f. However, the
c     present suboutine embodies only a pure read function (it does
c     only mimimal checking of what is read, to ensure that what
c     follows is readable). EQ3NR/rd3inw.f differs in that it also
c     writes an instant echo of what is read to the EQ3NR output file.
c
c     The calling sequence of this suboutine is identical to that of
c     EQ3NR/rd3inw.f, EQ3NR/rd3ind.f, and XCON3/rd3d8.f.
c
c     This suboutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ninpts = unit number of the stripped INPUT file
c       noutpt = unit number of the OUTPUT file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       qrderr = flag denoting a read error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,nbtmax,netmax,nodbmx,nopgmx,noprmx,noptmx,
     $ ntitmx,nxmdmx,nxicmx,nxtimx
c
      integer ninpts,noutpt,nttyo
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jgext(netmax),jgexti(netmax),jflgi(nbtmax),kxmod(nxmdmx),
     $ ncmpri(2,nxtimx),ngexrt(jetmax,netmax),ngexti(jetmax,netmax)
c
      integer iebal3,irdxc3,itdsf3,itermx,jpres3,nbti,net,neti,nobswt,
     $ nprob,nsbswt,ntitl,nxmod,nxti
c
      logical qend,qgexsh,qrderr
c
      character*80 utitl(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ucospi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uspeci(nbtmax),uxmod(nxmdmx)
      character*24 ugexmo(netmax),ugexp(netmax),ugexpi(netmax),
     $ ugexsi(ietmax,jetmax,netmax),umemi(nxicmx),usoli(nxtimx)
      character*24 uebal,uredox
      character*8 ugexj(jetmax,netmax),ugexji(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real*8 cgexj(jetmax,netmax),cgexpi(netmax),covali(nbtmax),
     $ egexsi(ietmax,jetmax,netmax),mwtges(netmax),tgexp(netmax),
     $ xbari(nxicmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xvfgex(ietmax,jetmax,netmax),
     $ xlkmod(nxmdmx),zgexj(jetmax,netmax),xgexsi(ietmax,jetmax,netmax)
c
      real*8 ehi,fo2lgi,pei,press,rho,scamas,tdspkg,tdspl,tempc,tolbt,
     $ toldl,tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iei,je,jei,j2,j3,n,nbi,ne,nei,nn,nr1,nr2,nssoti,nxi,
     $ nxic
c
      integer ilnobl
c
      logical qgexef
c
      character*80 uline
      character*48 ux48
      character*8 uendit,ux8
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     The following is nonsense to avoid compiler "unused variable"
c     warnings. Here noutpt and nprob are not actually used. They are
c     included in the calling sequence to allow it to match that of
c     EQ3NR/rd3inw.f.
c
      noutpt = nttyo
      n = nprob
      nprob = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     qend   = .true if the end of the INPUT file has been encountered
c     qrderr = .true if the current problem can't be read because of
c                a read format error or a dimensional overflow
c
      qend = .false.
      qrderr = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Title.
c
      n = 0
      read (ninpts,1000,end=100,err=990) uline
 1000 format(a80)
      go to 110
c
  100 qend = .true.
      go to 999
c
  110 if (uline(1:8) .eq. uendit(1:8)) go to 120
c
      n = 1
      utitl(n) = uline
c
      do nn = 2,ntitmx + 1
        read (ninpts,1000,err=990) uline
        if (uline(1:8) .eq. uendit(1:8)) go to 120
c
        n = n + 1
c
        if (n .gt. ntitmx) then
          write (nttyo,1015) ntitmx
 1015     format(/' * Error - (XCON3/rd3w8) Have too many lines in',
     $    /7x,'the title. The code is only dimensioned for ',i4,
     $    /7x,'lines. Reduce the size of the title or increase the',
     $    /7x,'dimensioning parameter ntitpa.')
          go to 990
        endif
c
        utitl(n) = uline
      enddo
  120 ntitl = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      read (ninpts,1110,err=990) nsbswt
 1110 format(12x,i3)
c
      do n = 1,nsbswt
        read (ninpts,1130,err=990) usbsw(1,n)
 1130   format(9x,a48)
        read (ninpts,1150,err=990) usbsw(2,n)
 1150   format(15x,a48)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature.
c
      read (ninpts,1170,err=990) tempc
 1170 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure.
c
      read (ninpts,1190,err=990) jpres3,press
 1190 format(12x,i3,/12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Density.
c
      read (ninpts,1220,err=990) rho
 1220 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Total dissolved solutes.
c
      read (ninpts,1224,err=990) itdsf3,tdspkg,tdspl
 1224 format(12x,i3,/12x,e12.5,12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species to adjust for electrical balance.
c
      read (ninpts,1500,err=990) iebal3,uebal
 1500 format(12x,i3,/12x,a24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Default redox constraint.
c
      read (ninpts,1232,err=990) irdxc3
 1232 format(12x,i3)
      read (ninpts,1240,err=990) fo2lgi,ehi
 1240 format(12x,e12.5,12x,e12.5)
      read (ninpts,1250,err=990) pei,uredox
 1250 format(12x,e12.5,12x,a24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous basis species and associated constraints.
c
      nbi = 0
c
      do nn = 1,nbtmax + 1
        read (ninpts,2500,err=990) ux8,ux48
 2500   format(a8,1x,a48)
        j2 = ilnobl(ux48)
c
        if (ux8(1:8) .eq. uendit(1:8)) then
          go to 400
        endif
c
        nbi = nbi + 1
c
        if (nbi .gt. nbtmax) then
          write (nttyo,2520) nbtmax,ux48(1:j2)
 2520     format(/' * Error - (XCON3/rd3w8) The number of basis',
     $    ' species read',/7x,'from the INPUT file exceeded the',
     $    ' maximum of ',i3,' while',/7x,'trying to read data for',
     $    ' the species ',a,'.',/7x,'Increase the dimensioning',
     $    ' parameter nbtpar.')
          go to 990
        endif
c
        uspeci(nbi) = ux48
c
        read (ninpts,2540,err=990) jflgi(nbi),covali(nbi)
 2540   format(10x,i2,12x,e12.5)
c
        if (jflgi(nbi).eq.17 .or. jflgi(nbi).eq.18
     $  .or. jflgi(nbi).eq.25) then
          read (ninpts,2570,err=990) ucospi(nbi)
 2570     format(10x,a48)
        endif
      enddo
c
  400 nbti = nbi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      read (ninpts,1600,err=990) net
 1600 format(12x,i3)
c
      read (ninpts,1610) ux8
 1610 format(12x,a8)
      call lejust(ux8)
      call locase(ux8)
      qgexsh = ux8(1:2).eq.'.t' .or. ux8(1:1).eq. 't'
c
      if (net .gt. netmax) then
        write (nttyo,1620) netmax,net
 1620   format(/' * Error - (XCON3/rd3w8) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data to create',/7x,'such phases. Increase',
     $  ' the dimensioning parameter netpar',/7x,'to at least ',i3,'.')
        go to 990
      endif
c
      do ne = 1,net
        read (ninpts,1630,err=990) ugexp(ne)
 1630   format(12x,a24)
        j2 = ilnobl(ugexp(ne))
c
        read (ninpts,1650,err=990) mwtges(ne)
 1650   format(12x,e12.5)
c
        read (ninpts,1630,err=990) ugexmo(ne)
c
        read (ninpts,1650,err=990) tgexp(ne)
c
        read (ninpts,1690,err=990) jgext(ne)
 1690   format(12x,i3)
c
        if (jgext(ne) .gt. jetmax) then
          write (nttyo,1710) jetmax,ugexp(ne)(1:j2),jgext(ne)
 1710     format(/' * Error - (XCON3/rd3w8) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data to create',
     $    a,'. Increase the',/7x,'dimensioning parameter jetpar to',
     $    ' at least ',i3,'.')
          go to 990
        endif
c
        do je = 1,jgext(ne)
          read (ninpts,1730,err=990) ugexj(je,ne)
 1730     format(12x,a8)
          j3 = ilnobl(ugexj(je,ne))
c
          read (ninpts,1750,err=990) cgexj(je,ne),zgexj(je,ne)
 1750     format(12x,e12.5,12x,e12.5)
c
          read (ninpts,1690,err=990) ngexrt(je,ne)
c
          if (ngexrt(je,ne) .gt. ietmax) then
            write (nttyo,1820) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
 1820       format(/' * Error - (XCON3/rd3w8) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'reactions for a site',
     $      ' belonging to a generic ion exchange',/7x,'phase while',
     $      ' reading the data for site ',a,' of exchange phase',
     $      /7x,a,'. Increase the dimensioning parameter',
     $      /7x,'ietpar to at least ',i3,'.')
            go to 990
          endif
c
          do n = 1,ngexrt(je,ne)
            read (ninpts,1830,err=990) ugexr(n,je,ne)
 1830       format(12x,a56)
            read (ninpts,1850,err=990) xlkgex(n,je,ne),uxkgex(n,je,ne)
 1850       format(12x,e12.5,12x,a8)
            read (ninpts,1850,err=990) xhfgex(n,je,ne),uhfgex(n,je,ne)
            read (ninpts,1850,err=990) xvfgex(n,je,ne),uvfgex(n,je,ne)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified generic ion exchanger compositions.
c
      read (ninpts,1910,err=990) neti
 1910 format(12x,i3)
      if (neti .le. 0) go to 250
c
      if (neti .gt. netmax) then
        write (nttyo,1930) netmax,neti
 1930   format(/' * Error - (XCON3/rd3w8) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data for concentrations',7x,'and compositions',
     $  ' of such phases. Increase the dimensioning',/7x,'parameter',
     $  ' netpar to at least ',i3,'.')
        go to 990
      endif
c
      do nei = 1,neti
        read (ninpts,1940,err=990) ugexpi(nei)
 1940   format(12x,a24)
        j2 = ilnobl(ugexpi(nei))
c
        read (ninpts,1960,err=990) cgexpi(nei)
 1960   format(12x,e12.5)
c
        read (ninpts,1910,err=990) jgexti(nei)
c
        if (jgexti(nei) .gt. jetmax) then
          write (nttyo,2000) jetmax,ugexpi(nei)(1:j2),jgexti(nei)
 2000     format(/' * Error - (XCON3/rd3w8) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data for the',
     $    ' concentration and composition of',/7x,a,'. Increase the',
     $    ' dimensioning parameter jetpar',/7x,'to at least ',i3,'.')
          go to 990
        endif
c
c       Find the corresponding ne index.
c
        do ne = 1,net
          j2 = ilnobl(ugexp(ne))
          j3 = ilnobl(ugexpi(nei))
          if (ugexp(nei)(1:j3) .eq. ugexp(ne)(1:j2)) go to 240
        enddo
c
        write (nttyo,2002) ugexpi(nei)(1:j3)
 2002   format(/' * Error - (XCON3/rd3w8) Data are present on the',
     $  ' input file for the',/7x,'generic ion exchange phase "',a,
     $  ', but this phase',/7x,"hasn't been previously defined.",
     $  " Can't determine the requisite model,",/7x,"therefore can't",
     $  ' finish reading the current data for this phase.')
        stop
c
  240   j2 = ilnobl(ugexmo(ne))
        if (ugexmo(ne)(1:j2) .eq. 'Gapon' .or.
     $    ugexmo(ne)(1:6) .eq. 'Gapon-' .or.
     $    ugexmo(ne)(1:j2) .eq. 'Vanselow' .or.
     $    ugexmo(ne)(1:9) .eq. 'Vanselow-') then
c
c         Input composition is described in terms of equivalent
c         fractions on the sites.
c
          qgexef = .true.
        else
c
c         Input composition is described in terms of mole fractions
c         on the sites.
c
          qgexef = .false.
        endif
c
        do jei = 1,jgexti(nei)
          read (ninpts,2010,err=990) ugexji(jei,nei)
 2010     format(12x,a8)
          j3 = ilnobl(ugexji(jei,nei))
c
          read (ninpts,1910,err=990) ngexti(jei,nei)
c
          if (ngexti(jei,nei) .gt. ietmax) then
            write (nttyo,2040) ietmax,ugexji(jei,nei),ugexpi(nei),
     $      ngexti(jei,nei)
 2040       format(/' * Error - (XCON3/rd3w8) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'species on an exchange',
     $      ' site of a generic ion exchange phase',/7x,'while reading',
     $      /7x,'the data for the composition of site ',a,' of',
     $      /7x,'exchange phase ',a,'. Increase the dimensioning',
     $      ' parameter ietpar to at least ',i3,'.')
            go to 990
          endif
c
          if (qgexef) then
c
c           The data are in equivalent fractions.
c
            do iei = 1,ngexti(jei,nei)
              read (ninpts,2050,err=990) ugexsi(iei,jei,nei),
     $        egexsi(iei,jei,nei)
 2050         format(12x,a24,10x,e12.5)
            enddo
          else
c
c           The data are in mole fractions.
c
            do iei = 1,ngexti(jei,nei)
              read (ninpts,2050,err=990) ugexsi(iei,jei,nei),
     $        xgexsi(iei,jei,nei)
            enddo
          endif
        enddo
      enddo
c
  250 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Specified solid solution compositions.
c
      read (ninpts,2102,err=990) nxti
 2102 format(12x,i3)
c
      if (nxti .gt. nxtimx) then
        write (nttyo,2107) nxtimx,nxti
 2107   format(/' * Error - (EQ3NR/rd3w8) Have exceeded the maximum',
     $  /7x,'number of ',i5,' solid solutions for which',
     $  ' compositions',/7x,'may be specified on the INPUT file.',
     $  ' Increase the dimensioning',/7x,'parameter nxtipa to at',
     $  ' least ',i3,'.')
        go to 990
      endif
c
      nxic = 0
c
      do nxi = 1,nxti
        read (ninpts,2120,err=990) usoli(nxi)
 2120   format(12x,a24)
        j2 = ilnobl(usoli(nxi))
c
        read (ninpts,2140,err=990) nssoti
 2140   format(12x,i3)
c
        ncmpri(1,nxi) = nxic + 1
        ncmpri(2,nxi) = nxic + nssoti
        nr1 = ncmpri(1,nxi)
        nr2 = ncmpri(2,nxi)
c
        if (nr2 .gt. nxicmx) then
          write (nttyo,2150) nxicmx,usoli(nxi)(1:j2),nr2
 2150     format(/' * Error - (EQ3NR/rd3w8) Have exceeded the',
     $    ' maximum number',/7x,'of ',i5,' solid solution species',
     $    ' for which mole fractions',/7x,'are specified on the',
     $    ' INPUT file. This occurred while reading ',/7x,'data',
     $    ' for the solid solution ',a,'. Increase',/7x,'the',
     $    ' dimensioning parameter nxicpa to at least ',i3,'.')
          go to 990
        endif
c
        do nxic = nr1,nr2
          read (ninpts,2160,err=990) umemi(nxic),xbari(nxic)
 2160     format(12x,a24,12x,e12.5)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
      read (ninpts,2340,err=990) nxmod
 2340 format(12x,i3)
c
      if (nxmod .gt. nxmdmx) then
        write (nttyo,2360) nxmdmx
 2360   format(/' * Error - (XCON3/rd3w8) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  /7x,'options or increase the dimensioning parameter nxmdpa.')
        go to 990
      endif
c
c     Nxmod options.
c
      do n = 1,nxmod
        read (ninpts,2370,err=990) uxmod(n),kxmod(n),xlkmod(n)
 2370   format(12x,a48,/12x,i2,22x,e12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
      read (ninpts,1380,err=990) (iopt(i), i = 1,20)
 1380 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
      read (ninpts,1410,err=990) (iopg(i), i = 1,20)
 1410 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
      read (ninpts,1430,err=990) (iopr(i), i = 1,20)
 1430 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      read (ninpts,1470,err=990) (iodb(i), i = 1,20)
 1470 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Numerical parameters.
c
      read (ninpts,1280,err=990) tolbt,toldl
 1280 format(12x,e12.5,12x,e12.5)
c
      read (ninpts,1300,err=990) itermx
 1300 format(12x,i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      read (ninpts,1110,err=990) nobswt
c
      do n = 1,nobswt
        read (ninpts,1130,err=990) uobsw(1,n)
        read (ninpts,1150,err=990) uobsw(2,n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation flag tolerance.
c
      read (ninpts,1294,err=990) tolspf
 1294 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale factor for the mass of aqueous solution to write
c     on the PICKUP file.
c
      read (ninpts,1320,err=990) scamas
 1320 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     End of input for one problem.
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrderr = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine pcrss(apx,bpx,iapxmx,ibpxmx,iktmax,issot,nbtmx1,
     $ ndata1,ndat0s,ndat1f,nerr,nmodwr,nmt,nmtmax,noutpt,nslist,
     $ nttyo,nxt,nxtmax,uminsp,ussosp,ussoph)
c
c     This subroutine reads data on solid solutions from the stripped
c     DATA0 file, processes this data, and writes the results
c     on the DATA1 and DATA1F files. The counter "nerr" is incremented
c     by one for each error encountered.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndata1 = unit number of the DATA1 file
c       ndat0s = unit number of the stripped DATA0 file
c       ndat1f = unit number of the DATA1F file
c       nerr   = cumulative error counter
c
c     Principal output:
c
c       apx    = array of interaction coefficients for computing
c                  activity coefficients in solid solutions
c       bpx    = array of site-mixing parameters for computing
c                  activity coefficients in solid solutions
c       nerr   = cumulative error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,ibpxmx,iktmax,nbtmx1,nmtmax,nxtmax
c
      integer ndata1,ndat0s,ndat1f,noutpt,nslist,nttyo,nxt
c
      integer nerr,nmodwr,nmt
c
      integer issot(nxtmax)
c
      character*24 uminsp(nmtmax),ussosp(iktmax,nxtmax),ussoph(nxtmax)
c
      real*8 apx(iapxmx),bpx(ibpxmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iapxt,ibpxt,ii,ikt,j,jsol,j2,j3,j4,j5,k,n,nmodx
c
      integer ilnobl
c
      character*80 uline
      character*72 uterm,utermc
      character*24 usolid,ux24,ux24a
      character*24 uend24,ublk24,unone
      character*8 uendit,uref,ux8,ux8a
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data usolid /'solid solutions         '/
      data unone  /'none                    '/
      data uendit /'endit.  '/
      data uref  /'referenc'/
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
      uend24(1:8) = uendit(1:8)
      uend24(9:24) = ublk24(9:24)
      nxt = 0
      ikt = 0
      nmodx = 0
c
      j2 =ilnobl(usolid)
      write (ndata1) usolid
      write (ndat1f,1000) usolid(1:j2)
 1000 format(a)
      write (ndat1f,1000) utermc(1:72)
      write (noutpt,1010) usolid(1:j2)
      write (nttyo,1010) usolid(1:j2)
      write (nslist,1010) usolid(1:j2)
 1010 format(//1x,a,/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note: the main loop returns here.
c
  100 read (ndat0s,1020,end=990,err=995) uline
 1020 format(a)
      ux24 = uline(1:24)
      ux8 = uline(1:8)
      call locase(ux8)
      if (ux8(1:8) .eq. uref(1:8)) then
c
c       Found the 'references' superblock header. Finish and exit here.
c
        if (nxt .le. 0) then
c
c         No solid solutions were found on the data file.
c
          write (nttyo,1030) nxt,unone(1:4)
          write (nslist,1030) nxt,unone(1:4)
          write (noutpt,1030) nxt,unone(1:4)
 1030     format(1x,i5,2x,a)
        endif
c
        if (nxt.gt.0 .and. nmodx.ne.1) then
c
c         The last solid solution was not previously echoed
c         to the screen. Do this now. The echo consists of the
c         name of the solid solution and the names of its
c         end-member components.
c
          j2 = ilnobl(ussoph(nxt))
          write (nttyo,1030) nxt,ussoph(nxt)(1:j2)
c
          i = 1
  120     continue
          if (i .eq. ikt) then
            j2 = ilnobl(ussosp(i,nxt))
            write (nttyo,1040) ussosp(i,nxt)
 1040       format(12x,a)
            i = i + 1
          else
            j2 = ilnobl(ussosp(i + 1,nxt))
            write (nttyo,1050) ussosp(i,nxt),ussosp(i + 1,nxt)(1:j2)
 1050       format(12x,a24,2x,a)
            i = i + 2
          endif
          if (i .le. ikt) go to 120
        endif
c
        write (ndata1) uend24,ublk24,ublk24
        j2 = ilnobl(uend24)
        write (ndat1f,1000) uend24(1:j2)
        write (ndat1f,1000) utermc(1:72)
c
c       Skip the terminator line.
c
        read (ndat0s,1020,end=990,err=995) uline
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nxt = nxt + 1
c
c     Check for a blank solid solution name.
c
      j2 = ilnobl(ux24)
      if (j2 .le. 0) then
        write (ux8a,'(i5)') nxt
        call lejust(ux8a)
        j3 = ilnobl(ux8a)
        j4 = ilnobl(usolid)
        write (noutpt,1080) ux8a(1:j3),usolid(1:j4)
        write (nttyo,1080) ux8a(1:j3),usolid(1:j4)
 1080   format(/' * Error - (EQPT/pcrss) Have encountered a blank',
     $  ' phase name',/7x,'for phase block ',a,' of the ',a,
     $  ' superblock.')
        if (nxt .gt. 1) then
          ux24a = ussoph(nxt - 1)
          if (ux24a(1:7) .ne. '<blank>') then
            j5 = ilnobl(ux24a)
            write (noutpt,1090) ux24a(1:j5)
            write (nttyo,1090) ux24a(1:j5)
 1090       format(7x,'This block follows the one for ',a,'.')
          endif
        endif
        ux24 = '<blank>'
        nerr = nerr + 1
      endif
c
      ussoph(nxt) = uline(1:24)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nmodx = mod(nxt,nmodwr)
      if (nmodwr .eq. 1) nmodx = 1
      j2 = ilnobl(ussoph(nxt))
      if (nmodx .eq. 1) write (nttyo,1030) nxt,ussoph(nxt)(1:j2)
      write (nslist,1030) nxt,ussoph(nxt)(1:j2)
c
c     Skip the 'entered by' and 'keys' lines.
c
      read (ndat0s,1020,end=990,err=995) uline
      read (ndat0s,1020,end=990,err=995) uline
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read number of end members.
c
      read (ndat0s,1020,end=990,err=995) uline
      read (uline,1150,err=995) ikt
 1150 format(i3)
c
      if (ikt .le. 0) then
        j2 = ilnobl(ussoph(nxt))
        write (noutpt,1160) ussoph(nxt)(1:j2)
        write (nttyo,1160) ussoph(nxt)(1:j2)
 1160   format(/' * Error - (EQPT/pcrss) Solid solution "',a,'" is',
     $  ' not',/7x,'comprised of any end-members.')
        nerr = nerr + 1
      endif
c
      if (ikt .eq. 1) then
        j2 = ilnobl(ussoph(nxt))
        write (noutpt,1170) ussoph(nxt)(1:j2)
        write (nttyo,1170) ussoph(nxt)(1:j2)
 1170   format(/' * Error - (EQPT/pcrss) Solid solution "',a,'" is',
     $  ' comprised',/7x,'of only one end-member. Two or more',
     $  ' end-members are required.')
        nerr = nerr + 1
      endif
c
      if (ikt. gt. iktmax) then
        j2 = ilnobl(ussoph(nxt))
        write (noutpt,1180) ussoph(nxt)(1:j2),ikt,iktmax
        write (nttyo,1180) ussoph(nxt)(1:j2),ikt,iktmax
 1180   format(/' * Error - (EQPT/pcrss) Solid solution ',a,
     $  /7x,'is composed of ',i3,' end-members, which exceeds the',
     $  /7x,'maximum dimension (iktpar) of ',i3,'.')
        nerr = nerr + 1
      endif
c
      issot(nxt) = ikt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ikt .gt. 0) then
        n = 0
        do ii = 1,ikt/2
          read (ndat0s,1020,end=990,err=995) uline
          read (uline,1190,err=995) (ussosp(n + k,nxt), k = 1,2)
 1190     format((13x,a24,13x,a24))
          n = n + 2
        enddo
        j = mod(ikt,2)
        if (j .gt. 0) then
        read (ndat0s,1020,end=990,err=995) uline
        read (uline,1190,err=995) (ussosp(n + k,nxt), k = 1,j)
        n = n + j
        endif
c
        i = 1
  130   continue
        if (i .eq. ikt) then
          j2 = ilnobl(ussosp(i,nxt))
          if (nmodx .eq. 1) write (nttyo,1040) ussosp(i,nxt)(1:j2)
          write (nslist,1040) ussosp(i,nxt)(1:j2)
          i = i + 1
        else
          j2 = ilnobl(ussosp(i + 1,nxt))
          if (nmodx .eq. 1)
     $    write (nttyo,1050) ussosp(i,nxt),ussosp(i + 1,nxt)(1:j2)
          write (nslist,1050) ussosp(i,nxt),ussosp(i + 1,nxt)(1:j2)
          i = i + 2
        endif
        if (i .le. ikt) go to 130
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the end-member names for blanks.
c
      do i = 1,ikt
        ux24 = ussosp(i,nxt)
        j3 = ilnobl(ux24)
        if (j3 .le. 0) then
          j2 = ilnobl(ussoph(nxt))
          write (ux8,'(i5)') i
          call lejust(ux8)
          j4 = ilnobl(ux8)
          write (noutpt,1210) ussoph(nxt)(1:j2),ux8(1:j4)
          write (nttyo,1210) ussoph(nxt)(1:j2),ux8(1:j4)
 1210     format(/' * Error - (EQPT/pcrss) Solid solution "',a,'"',
     $    /7x,'has a blank name for end-member number ',a,'.')
          if (i .gt. 1) then
            ux24a = ussosp(i - 1,nxt)
            if (ux24a(1:7) .ne. '<blank>') then
              j5 = ilnobl(ux24a)
              write (noutpt,1220) ux24a(1:j5)
              write (nttyo,1220) ux24a(1:j5)
 1220         format(7x,'This follows the end-member ',a,'.')
            endif
          endif
          ussosp(i,nxt) = '<blank>'
          nerr = nerr + 1
        endif
      enddo
c
c     Note: the end-members names are checked for duplicates by
c     nxspck.f, and validated against pure mineral names by vxspck.f.
c     These subroutines are called by eqpt.f.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the activity coefficient code.
c
      read (ndat0s,1020,end=990,err=995) uline
      read (uline,1250,err=995) jsol
 1250 format(10x,i1)
c
      call initaz(apx,iapxmx)
      call initaz(bpx,ibpxmx)
c
c     Read the number of interaction coefficients for computing
c     activity coefficients in this solid solution.
c
      read (ndat0s,1020,end=990,err=995) uline
      read (uline,1270,err=995) iapxt
 1270 format(i3)
c
      if (iapxt .gt. 0) then
        n = 0
        do ii = 1,iapxt/6
          read (ndat0s,1020,end=990,err=995) uline
          read (uline,1280,err=995) (apx(n + k), k = 1,6)
 1280     format(6f6.3)
          n = n + 6
        enddo
        j = mod(ikt,6)
        if (j .gt. 0) then
          read (ndat0s,1020,end=990,err=995) uline
          read (uline,1280,err=995) (apx(n + k), k = 1,j)
          n = n + j
        endif
      endif
c
c     Read the number of site-mixing parameters for computing
c     activity coefficients in this solid solution.
c
      read (ndat0s,1270,end=990,err=995) ibpxt
c
      if (ibpxt .gt. 0) then
        n = 0
        do ii = 1,ibpxt/6
          read (ndat0s,1020,end=990,err=995) uline
          read (uline,1280,err=995) (bpx(n + k), k = 1,6)
          n = n + 6
        enddo
        j = mod(ikt,6)
        if (j .gt. 0) then
          read (ndat0s,1020,end=990,err=995) uline
          read (uline,1280,err=995) (bpx(n + k), k = 1,j)
          n = n + j
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write block on the DATA1 and DATA1F files.
c
      write (ndata1) ussoph(nxt),ikt,jsol
      write (ndata1) (ussosp(i,nxt), i = 1,ikt)
      write (ndata1) iapxt
      if (iapxt .gt. 0) write (ndata1) (apx(i), i = 1,iapxt)
      write (ndata1) ibpxt
      if (ibpxt .gt. 0) write (ndata1) (bpx(i), i = 1,ibpxt)
c
      write (ndat1f,1330) ussoph(nxt),ikt,jsol
 1330 format(a24,2x,2i5)
c
      i = 1
  250 continue
      if (i .eq. ikt) then
        j2 = ilnobl(ussosp(i,nxt))
        write (ndat1f,1340) ussosp(i,nxt)(1:j2)
 1340   format(5x,a)
        i = i + 1
      else
        j2 = ilnobl(ussosp(i + 1,nxt))
        write (ndat1f,1350) ussosp(i,nxt),ussosp(i + 1,nxt)(1:j2)
 1350   format(5x,a24,5x,a)
        i = i + 2
      endif
      if (i .le. ikt) go to 250
c
      write (ndat1f,1360) iapxt
 1360 format(i3)
      if (iapxt .gt. 0) write (ndat1f,1370) (apx(i), i = 1,iapxt)
 1370   format(6f6.3)
      write (ndat1f,1360) ibpxt
      if (ibpxt .gt. 0) write (ndat1f,1370) (bpx(i), i = 1,ibpxt)
c
      j2 = ilnobl(ussoph(nxt))
      write (noutpt,1380) ussoph(nxt)(1:j2),ikt,jsol
 1380 format(1x,a,/5x,'Number of components= ',i3,2x,
     $ 'Activity coefficient code= ',i3)
c
      i = 1
  260 continue
      if (i .eq. ikt) then
        j2 = ilnobl(ussosp(i,nxt))
        write (noutpt,1040) ussosp(i,nxt)(1:j2)
        i = i + 1
      else
        j2 = ilnobl(ussosp(i + 1,nxt))
        write (noutpt,1050) ussosp(i,nxt),ussosp(i + 1,nxt)(1:j2)
        i = i + 2
      endif
      if (i .le. ikt) go to 260
c
      write (ndat1f,1000) utermc(1:72)
c
c     Skip to the terminator.
c
  170 continue
      read (ndat0s,1020,end=990,err=995) uline
      ux8 = uline(1:8)
      if(ux8(1:8) .ne. uterm(1:8)) go to 170
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/pcrss) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
c
      write (noutpt,2010) nxt
      write (nttyo,2010) nxt
 2010 format(7x,'The value of the solid solution block counter is ',
     $ i3,'.')
c
      if (nxt .gt. 0) then
        j2 = ilnobl(ussoph(nxt))
        write (noutpt,2020) ussoph(nxt)(1:j2)
        write (nttyo,2020) ussoph(nxt)(1:j2)
 2020   format(7x,'The last solid solution name read was "',a,'".')
      else
        write (noutpt,2030) unone(1:j2)
        write (nttyo,2030) unone(1:j2)
 2030   format(7x,'No solid solutions were read.')
      endif
c
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2040) uline(1:j2)
        write (nttyo,2040) uline(1:j2)
 2040   format(7x,'The last line read was the following:',
     $  /7x,'"',a,'"')
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 write (noutpt,2050)
      write (nttyo,2050)
 2050 format(/' * Error - (EQPT/pcrss) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
c
      write (noutpt,2010) nxt
      write (nttyo,2010) nxt
      if (nxt .gt. 0) then
        j2 = ilnobl(ussoph(nxt))
        write (noutpt,2020) ussoph(nxt)(1:j2)
        write (nttyo,2020) ussoph(nxt)(1:j2)
      else
        write (noutpt,2030)
        write (nttyo,2030)
      endif
c
      j2 = ilnobl(uline)
      if (j2 .gt. 0) then
        j2 = min(j2,70)
        write (noutpt,2040) uline(1:j2)
        write (nttyo,2040) uline(1:j2)
      endif
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine prtsia(affsd,jflagd,jflgi,jsflag,narn1,narn2,nbasp,
     $ nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,nhydr,noutpt,nrdxsp,
     $ nstmax,sidrsp,uspec)
c
c     This subroutine prints tables of saturation indices and affinities
c     for reactions among aqueous species which are not constrained
c     to be at equilibrium.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       affsd  = array of affinities for reactions corresponding to
c                  the various species, as these reactions were read
c                  from the data file
c       jflagd = array of species control flags, used with the 'd'
c                  set of reactions
c       jsflag = array of status flags for species
c       nbasp  = array of the indices of the species in the active
c                  basis set
c       nbaspd = array of the indices of the species in the data file
c                  basis set
c       nbt    = the number of species in the basis set
c       ndrsd  = array of the indices of the species corresponding to
c                  the reaction coefficients in the cdrsd array
c       ndrsrd = array giving the range in the cdrsd and ndrsd arrays
c                  corresponding to the reaction for a given species
c       nhydr  = index of the species aqueous H+
c       nrdxsp = index of the redox basis species
c       sidrsp = array of saturation indices for reactions
c                  corresponding to the various species, as these
c                  reactions were read from the data file
c       uspec  = array of species names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt
c
      integer jflagd(nstmax),jflgi(nbtmax),jsflag(nstmax),
     $ nbasp(nbtmax),nbaspd(nbtmax),ndrsd(ndrsmx),ndrsrd(2,nstmax)
      integer narn1,narn2,nbt,nhydr,nrdxsp
c
      character(len=48) uspec(nstmax)
c
      real(8) affsd(nstmax),sidrsp(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,kount,n,nb,nbb,nr1,nr2,nse,ns1,ns2,nt
c
      integer ilnobl
c
      character(len=24) ux24
c
      character(len=16) ux16a,ux16b
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(//6x,'--- Saturation States of Aqueous Reactions Not',
     $ ' Fixed at Equilibrium ---')
      write (noutpt,1010)
 1010   format(/3x,'Reaction',27x,'Log Q/K',4x,'Affinity, kcal',/)
c
      kount = 0
      do nb = 1,nbt
        ns1 = nbaspd(nb)
        if (ns1.lt.narn1 .or. ns1.gt.narn2) go to 250
        if (jflagd(ns1) .eq. 27) go to 250
        if (jflagd(ns1) .eq. 30) go to 250
        if (jsflag(ns1) .gt. 0) go to 250
c
        nr1 = ndrsrd(1,ns1)
        nr2 = ndrsrd(2,ns1)
        nt = nr2 - nr1 + 1
        if (nt .lt. 2) go to 250
c
c       Find the appropriate matching species to complete the
c       description of the reaction.
c
        ns2 = 0
        do n = nr1,nr2
          nse = ndrsd(n)
          if (nse.ne.ns1 .and. nse.ne.nrdxsp
     $      .and. nse.ne.narn1 .and. nse.ne.nhydr) then
            ns2 = nse
            go to 130
          endif
        enddo
  130   continue
c
        if (ns2 .eq. 0) then
          do n = nr1,nr2
            nse = ndrsd(n)
            if (nse.ne.ns1 .and. nse.eq.narn1) then
              ns2 = narn1
              go to 140
            endif
          enddo
  140     continue
        endif
c
        if (ns2 .eq. 0) then
          do n = nr1,nr2
            nse = ndrsd(n)
            if (nse.ne.ns1 .and. nse.eq.nhydr) then
              ns2 = nhydr
              go to 150
            endif
          enddo
  150     continue
        endif
c
        if (ns2 .eq. 0) then
          do n = nr1,nr2
            nse = ndrsd(n)
            if (nse.ne.ns1 .and. nse.eq.nrdxsp) then
              ns2 = nrdxsp
              go to 160
            endif
          enddo
  160     continue
        endif
c
c       At this point, ns2 should not be zero.
c
        if (ns2 .eq. 0) then
          go to 250
        endif
c
        if (jsflag(ns2) .gt. 0) go to 250
        ux24 = uspec(ns2)
c
        kount = kount + 1
c
        j2 = ilnobl(uspec(ns1)(1:24))
        j3 = ilnobl(ux24)
c
  240   if ((j2 + j3) .gt. 32) then
          if (j2 .gt. j3) then
            j2 = j2 - 1
          else
            j3 = j3 - 1
          endif
          go to 240
        endif
c
        if (sidrsp(ns1).gt.-9999999.
     $   .and. sidrsp(ns1).lt.9999999.) then
          write (ux16a,'(f10.5)') sidrsp(ns1)
          write (ux16b,'(f10.5)') affsd(ns1)
        else
          ux16a = '    N/A   '
          ux16b = '    N/A   '
        endif
c
        write (noutpt,1020) uspec(ns1)(1:j2),ux24(1:j3),ux16a(1:10),
     $  ux16b(1:10)
 1020   format(1x,a,'/',a,t37,a,3x,a)
  250   continue
      enddo
c
      if (kount.le.0) write (noutpt,1030)
 1030 format(1x,'None')
c
      write (noutpt,1040)
 1040 format(1x)
c
      end

      integer function ilnobl(ustr)
c
c     This subroutine finds the position of the last non-blank character
c     in the string ustr.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ustr   = the input string variable
c
c     Output:
c
c       ilnobl = the position of the first non-blank character
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,nchars
c
c-----------------------------------------------------------------------
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Find the first non-blank character.
c
      ilnobl = 0
      do j = nchars,1,-1
        if (ustr(j:j) .ne. ' ') then
          ilnobl = j
          go to 999
        endif
      enddo
c
  999 continue
      end

      subroutine clones(axlksa,cdrsa,cessa,mwtspa,narx_asv,
     $ ndrsa,ndrsa_asv,ndrsn,ndrsra,nessa,nessa_asv,nessn,
     $ nessra,np,npta_asv,ns,nsc,nsta_asv,ntpr_asv,uphasa,
     $ uspeca,zchara)
c
c     This subroutine clones the nsc-th species into the ns-th. The
c     ns-th species belongs to the np-th phase. Typically, the nsc-th
c     species is a pure mineral or liquid and the ns-th species is the
c     corresponding component species of a solid or liquid solution.
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c       EQLIB/indatp.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narx_asv,ndrsa_asv,nessa_asv,npta_asv,nsta_asv,ntpr_asv
c
      integer ndrsa(ndrsa_asv),ndrsra(2,nsta_asv),nessa(nessa_asv),
     $ nessra(2,nsta_asv)
c
      integer ndrsn,nessn,np,ns,nsc
c
      character*24 uphasa(npta_asv)
      character*48 uspeca(nsta_asv)
c
      real*8 axlksa(narx_asv,ntpr_asv,nsta_asv),cessa(nessa_asv),
     $ cdrsa(ndrsa_asv),mwtspa(nsta_asv),zchara(nsta_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,ndrsn1,nessn1,nr1,nr2,nse,nt
c
c----------------------------------------------------------------------
c
c     Copy the name, molecular weight, and electrical charge.
c     Note that the phase part of the name is different.
c
      uspeca(ns)(1:24) = uspeca(nsc)(1:24)
      uspeca(ns)(25:48) = uphasa(np)(1:24)
      mwtspa(ns) = mwtspa(nsc)
      zchara(ns) = zchara(nsc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the elemental composition.
c
      nessra(1,ns) = nessn + 1
      nr1 = nessra(1,nsc)
      nr2 = nessra(2,nsc)
      do nessn1 = nr1,nr2
        nessn = nessn + 1
        cessa(nessn) = cessa(nessn1)
        nessa(nessn) = nessa(nessn1)
      enddo
      nessra(2,ns) = nessn
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the associated reaction.
c
      ndrsra(1,ns) = ndrsn + 1
      nr1 = ndrsra(1,nsc)
      nr2 = ndrsra(2,nsc)
      nt = nr2 - nr1 + 1
      if (nt .lt. 2) then
c
c       The nsc-th species is a data file basis species that
c       has only an identity reaction. Write a linking reaction.
c
        ndrsn = ndrsn + 1
        cdrsa(ndrsn) = -1.
        ndrsa(ndrsn) = ns
        ndrsn = ndrsn + 1
        cdrsa(ndrsn) = 1.
        ndrsa(ndrsn) = nsc
      else
c
c       The nsc-th species has a reaction which can be copied.
c
        do ndrsn1 = nr1,nr2
          ndrsn = ndrsn + 1
          cdrsa(ndrsn) = cdrsa(ndrsn1)
          nse = ndrsa(ndrsn1)
          if (nse .eq. nsc) nse = ns
          ndrsa(ndrsn) = nse
        enddo
      endif
      ndrsra(2,ns) = ndrsn
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the coefficients of the polynomials which represent
c     the thermodynamic functions of the reaction. Note that
c     this is valid whether the reaction is an identity reaction
c     or a real one.
c
      do j = 1,ntpr_asv
        do i = 1,narx_asv
          axlksa(i,j,ns) = axlksa(i,j,nsc)
        enddo
      enddo
c
      end

      integer function nbasis(nbasp,nbt,nbtmax,ns)
c
c     This subroutine finds the position of the ns-th species in the
c     array nbasp, which defines the basis set. If the species
c     is not in the basis set, nbasis is returned as zero.
c
c     This subroutine is called by:
c
c       EQLIB/flgset.f
c       EQLIB/gcsts.f
c       EQLIB/switch.f
c       EQLIB/swtchk.f
c       EQ3NR/arrsim.f
c       EQ3NR/chkinx.f
c       EQ3NR/eq3nr.f
c       EQ3NR/intbs3.f
c       EQ6/combmb.f
c       EQ6/intbs6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nbasp  = array of indices of species in the basis set
c       nbt    = the number of species in the basis set
c       ns     = the index of a species
c
c     Principal output:
c
c       nbasis = the basis index of the ns-th species, if this species
c                  is in the basis set
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax
c
      integer nbasp(nbtmax)
      integer nbt,ns
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,nss
c
c-----------------------------------------------------------------------
c
      nbasis = 0
      do nb = 1,nbt
        nss = nbasp(nb)
        if (ns .eq. nss) then
          nbasis = nb
          go to 999
        endif
      enddo
c
  999 continue
      end

      subroutine openou(noutpt,nttyo,ufiln,uform,nrecl,ilu)
c
c     This subroutine opens an output type file. If a file of the
c     same name already exists, it is first destroyed. An unused
c     logical unit number is obtained.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = the unit number of the output file
c       nttyo  = the unit number of the screen file
c       ufiln  = the name of the file to open
c       uform  = the file format, 'formatted' or 'unformatted'
c       nrecl  = the record length (number of characters per line)
c
c     Output:
c
c       ilu     = the logical unit number of opened file
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ilu,nrecl
c
c     Note- the character length for the variables ufiln and uform
c     can not be exactly specified.
c
      character*(*) ufiln,uform
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nerr
c
      integer ilnobl
c
      logical qex
c
      character*8 ustat
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(ufiln)
c
c     See if a file of the same name already exists. If so,
c     destroy it. This makes the logical unit number available.
c     If a file of the same name does not exist, get the next
c     available logical unit number.
c
      inquire(file=ufiln,exist=qex)
      if (qex) then
        ustat = 'old'
        call getlu(ilu,nerr)
        if (nerr .ne. 0) then
          if (noutpt .gt. 0) write (noutpt,1000) ustat,ufiln(1:j2)
          write (nttyo,1000) ustat,ufiln(1:j2)
 1000     format(/' * Error - (EQLIBU/openou) No logical unit number',
     $    /7x,'is available to open the ',a3,' file "',a,'".')
          stop
        endif
        open(ilu,file=ufiln,status=ustat,err=10)
        close(ilu,status='delete',err=15)
      else
        ustat = 'new'
        call getlu(ilu,nerr)
        if (nerr .ne. 0) then
          if (noutpt .gt. 0) write (noutpt,1000) ustat,ufiln(1:j2)
          write (nttyo,1000) ustat,ufiln(1:j2)
          stop
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Open the new file.
c
      if (nrecl .gt. 0) then
c
c       Use the specified record length.
c
        open(ilu,file=ufiln,form=uform,status='new',recl=nrecl,err=10)
      else
c
c       The record length is not specified. Open the file at the
c       default record length.
c
        open(ilu,file=ufiln,form=uform,status='new',err=10)
      endif
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
   10 if (noutpt .gt. 0) write (noutpt,1010) ustat,ufiln(1:j2)
      write (nttyo ,1010) ustat,ufiln(1:j2)
 1010 format(/" * Error - (EQLIBU/openou) Can't open the ",a3,' copy',
     $ /7x,'of the file "',a,'".')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
   15 if (noutpt .gt. 0) write (noutpt,1020) ufiln(1:j2)
      write (nttyo,1020) ufiln(1:j2)
 1020 format(/" * Error - (EQLIBU/openou) Can't delete the old copy",
     $ /7x,'of the file "',a,'".')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine intmat(iaqsln,iindx1,ipndx1,kbt,kdim,kelect,khydr,
     $ khydx,kmax,km1,kmt,ko2gaq,kwater,kx1,kxt,narn1,narn2,nbasp,
     $ nbt,nbti,nbtmax,ncmpr,nelect,nern1,nern2,nhydr,nhydx,nobswt,
     $ noutpt,no2gaq,nphasx,npt,nptmax,nstmax,nttyo,qloffg,ubmtbi,
     $ ufixf,uobsw,uphase,uspec,uzveci,uzvec1,zvclgi,zvclg1,zvec1)
c
c     This routine interprets matrix variables read from the input
c     file. It constructs the master variable array zvclgi and
c     builds iindx1, the master variable index array, deleting any
c     left over fixed fugacity phases. Note that iindx1(kcol) gives
c     the basis index for kcol = 1,kbt. For kcol = km1,kxt, it gives
c     the species index. this subroutine also constructs the ipndx1
c     array. Note that ipndx1(kcol) gives the phase index for
c     kcol = 1,kxt.
c
c     This routine also resolves any issues between the matrix variable
c     input (which may imply instances of ordinary basis switching) and
c     the ordinary basis switching input.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       qloffg = logical flag, = .true. if left over fixed fugacity
c                  phases are in the system
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),ipndx1(kmax),nbasp(nbtmax),ncmpr(2,nptmax),
     $ nphasx(nstmax)
c
      integer iaqsln,kbt,kdim,kelect,khydr,khydx,km1,kmt,ko2gaq,
     $ kwater,kx1,kxt,narn1,narn2,nbt,nbti,nelect,nern1,nern2,nhydr,
     $ nhydx,nobswt,no2gaq,npt
c
      logical qloffg
c
      character(len=48) ubmtbi(nbtmax),uobsw(2,nbtmax),uspec(nstmax),
     $ uzveci(kmax),uzvec1(kmax)
      character(len=24) uphase(nptmax)
      character(len=8) ufixf
c
      real(8) zvclgi(kmax),zvclg1(kmax),zvec1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlena,jlenb,jlenc,jlend,jlen2,j2,kbts,kcol,km1s,kmts,
     $ krow,kx1s,kxts,n,nb,nbi,nerr,nn,np,nr1,nr2,ns,ns1,ns2,nt
c
      integer ilnobl
c
      character(len=56) uspa56,uspb56,uspc56,uspd56,uspn56
      character(len=24) ux24
      character(len=8) ux8
c
      real(8) lxx
c
      real(8) texp
c
c-----------------------------------------------------------------------
c
      nerr = 0
      qloffg = .false.
      km1s = km1
      kmts = kmt
      kx1s = kx1
      kxts = kxt
      kbts = kbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Aqueous species and generic ion exchanger species.
c
      kcol = 0
      do krow = 1,kbts
        do nb = 1,nbt
          ns = nbasp(nb)
c
          if (ns.ge.nern1 .and. ns.le.nern2) ns = ns + 1
c
          if (uzveci(krow)(1:48) .eq. uspec(ns)(1:48)) then
            kcol = kcol + 1
            iindx1(kcol) = nb
            if (ns.ge.narn1 .and. ns.le.narn2) then
c
c             Have an aqueous species.
c
              ipndx1(kcol) = iaqsln
            elseif (ns.ge.nern1 .and. ns.le.nern2) then
c
c             Have a generic ion exchanger species.
c
              ipndx1(kcol) = nphasx(ns)
            endif
            uzvec1(kcol) = uspec(ns)
            lxx = zvclgi(krow)
            zvclg1(kcol) = lxx
            zvec1(kcol) = texp(lxx)
            go to 100
          endif
        enddo
c
c       Did not find the listed active basis species in the
c       "data file" set. It may be a species that is to be
c       switched in by an ordinary basis switch.
c
        if (krow .le. nbti) then
          nbi = krow
          do ns2 = narn1,narn2
            if (uzveci(krow)(1:48) .eq. uspec(ns2)(1:48)) then
c
c             Calling sequence substitutions:
c               jlenb for jlen2
c               uspb56 for uspn56
c
                call fmspnx(jlenb,uzveci(krow),uspb56)
c
              do nb = 1,nbt
                ns1 = nbasp(nb)
                if (ubmtbi(nbi)(1:48) .eq. uspec(ns1)(1:48)) then
c
c                 A basis switch is implied, with the species whose
c                 index is ns2 being switched in for the one whose
c                 index is ns1. The actual switch will be made later.
c                 For the moment, put the name of the species to be
c                 switched out (the "data file" basis species) in the
c                 current position in the uzvec1 array.
c
c                 Calling sequence substitutions:
c                   jlena for jlen2
c                   uspa56 for uspn56
c
                  call fmspnx(jlena,ubmtbi(nbi),uspa56)
c
                  kcol = kcol + 1
                  iindx1(kcol) = nb
                  ipndx1(kcol) = iaqsln
                  uzvec1(kcol) = uspec(ns1)
                  lxx = zvclgi(krow)
                  zvclg1(kcol) = lxx
                  zvec1(kcol) = texp(lxx)
c
c                 Check for explicit basis switch directive.
c
                  do n = 1,nobswt
                    if (uobsw(1,n)(1:48) .eq. uspec(ns1)(1:48)) then
                      if (uobsw(2,n)(1:48) .eq. uspec(ns2)(1:48)) then
c
c                       The n-th ordinary basis switching directive
c                       covers this pair. This is the normally expected
c                       case.
c
                        go to 100
                      else
c
c                       The first species is set to be switched with
c                       a different second species.
c
c                       Calling sequence substitutions:
c                         jlend for jlen2
c                         uspd56 for uspn56
c
                        call fmspnx(jlend,uobsw(2,n),uspd56)
c
                        write (noutpt,1010) uspb56(1:jlenb),
     $                  uspa56(1:jlena),uspd56(1:jlend)
                        write (nttyo,1010) uspb56(1:jlenb),
     $                  uspa56(1:jlena),uspd56(1:jlend)
 1010                   format(/' * Error - (EQ6/intmat) The species ',
     $                  a,' must be in',/7x,'the active basis set for',
     $                  ' the system described on the input',
     $                  /7x,'file. This implies it should replace the',
     $                  ' "data file" basis',/7x,'species ',a,
     $                  '. However, an explicit replacement by',
     $                  ' the species',/7x,a,' is called for by an',
     $                  ' ordinary basis switch specified',
     $                  /7x,'on the input file.')
                        nerr = nerr + 1
                        go to 100
c
                      endif
                    elseif (uobsw(2,n)(1:48) .eq. uspec(ns2)(1:48)) then
c
c                     The second species is set to be switched with a
c                     different first species.
c
c                       Calling sequence substitutions:
c                         jlenc for jlen2
c                         uspc56 for uspn56
c
                        call fmspnx(jlenc,uobsw(1,n),uspc56)
c
                        write (noutpt,1020) uspb56(1:jlenb),
     $                  uspa56(1:jlena),uspc56(1:jlenc)
                        write (nttyo,1020) uspb56(1:jlenb),
     $                  uspa56(1:jlena),uspc56(1:jlenc)
 1020                   format(/' * Error - (EQ6/intmat) The species ',
     $                  a,' must be in',/7x,'the active basis set for',
     $                  ' the system described on the input',
     $                  /7x,'file. This implies it should replace the',
     $                  ' "data file" basis',/7x,'species ',a,
     $                  '. However, an explicit replacing of',
     $                  ' the species',/7x,a,' is called for by an',
     $                  ' ordinary basis switch specified',
     $                  /7x,'on the input file.')
                        nerr = nerr + 1
                        go to 100
c
                    endif
                  enddo
c
c                 The implied ordinary basis switch does not match
c                 any specified switch. Create one.
c
                  write (noutpt,1030) uspa56(1:jlena),
     $            uspb56(1:jlenb)
                  write (nttyo,1030) uspa56(1:jlena),
     $            uspb56(1:jlenb)
 1030             format(/' * Note - (EQ6/intmat) An implied',
     $            ' ordinary basis switch',/7x,'replacing ',a,
     $            ' with ',a,' was found.',/7x,'An explicit switch'
     $            ' will be constructed.')
c
                  nn = nobswt + 1
c
                  if (nn .gt. nbtmax) then
                    write (ux8,'(i8)') nbtmax
                    call lejust(ux8)
                    j2 = ilnobl(ux8)
                    write (noutpt,1040) ux8(1:j2)
                    write (nttyo,1040) ux8(1:j2)
 1040               format(/' * Error - (EQ6/intmat) Cannot construct',
     $              ' an explicit ordinary',/7x,'basis switch because',
     $              ' this would exceed the limit of ',a,' switches',
     $              /7x,'(which is equal to the dimensioned limit',
     $              ' for basis species).')
                    nerr = nerr + 1
                  endif
c
                  nobswt = nn
                  uobsw(1,nn) = uspec(ns1)
                  uobsw(2,nn) = uspec(ns2)
                  go to 100
c
                endif
              enddo
            endif
          enddo
        endif
c
c       Cannot identify the active basis species specified in the
c       uzveci array on the input file.
c
        write (noutpt,1060) uspb56(1:jlenb)
        write (nttyo,1060) uspb56(1:jlenb)
 1060   format(/' * Error - (EQ6/intmat) The species ',a,' is in the',
     $  /7x,'active basis set for the system described on the input',
     $  ' file,',/7x,"but it isn't on the data file and wasn't created",
     $  ' by',/7x,'an input file directive.')
        nerr = nerr + 1
c
  100   continue
      enddo
      kbt = kcol
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pure phases.
c
      km1 = kcol + 1
      if (kmts .lt. km1s) go to 120
      qloffg = .false.
c
      do krow = km1s,kmts
c
        do np = 1,npt
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .eq. 1) then
            ns = nr1
            if (uzveci(krow)(1:48) .eq. uspec(ns)(1:48)) then
              kcol = kcol + 1
              iindx1(kcol) = ns
              ipndx1(kcol) = np
              uzvec1(kcol) = uspec(ns)
              lxx = zvclgi(krow)
              zvclg1(kcol) = lxx
              zvec1(kcol) = texp(lxx)
              go to 110
            endif
          endif
        enddo
c
        if (uzveci(krow)(1:5) .eq. ufixf(1:5)) then
          ux24 = uzveci(krow)(6:24)
          j2 = ilnobl(ux24)
          write (noutpt,1070) ux24(1:j2)
          write (nttyo,1070) ux24(1:j2)
 1070     format(/' * Note - (EQ6/intmat) A left over fixed fugacity',
     $    ' phase for ',a,/7x,'is in the system described on the',
     $    ' input file. It will be purged.')
          qloffg = .true.
        else
          call fmspnm(jlen2,uzveci(krow),uspn56)
          write (noutpt,1080) uspn56(1:jlen2)
          write (nttyo,1080) uspn56(1:jlen2)
 1080     format(/' * Error - (EQ6/intmat) The species ',a,
     $    /7x,'is in the system described on the input file, but it',
     $    " isn't",/7x,"on the data file and wasn't created",
     $  ' following an input file directive.')
          nerr = nerr + 1
        endif
c
  110   continue
      enddo
c
  120 kmt = kcol
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Non-aqueous solutions.
c
      kx1 = kcol + 1
c
      do krow = kx1s,kxts
c
        do np = 1,npt
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt.gt.1 .and.
     $     uzveci(krow)(25:48).eq.uphase(np)(1:24)) go to 130
        enddo
c
        call fmspnm(jlen2,uzveci(krow),uspn56)
        write (noutpt,1080) uspn56(1:jlen2)
        write (nttyo,1080) uspn56(1:jlen2)
        nerr = nerr + 1
        go to 140
c
  130   do ns = nr1,nr2
          if (uzveci(krow)(1:24) .eq. uspec(ns)(1:24)) then
            kcol = kcol + 1
            iindx1(kcol) = ns
            ipndx1(kcol) = np
            uzvec1(kcol) = uspec(ns)
            lxx = zvclgi(krow)
            zvclg1(kcol) = lxx
            zvec1(kcol) = texp(lxx)
            go to 140
          endif
        enddo
c
        call fmspnm(jlen2,uzveci(krow),uspn56)
        write (noutpt,1080) uspn56(1:jlen2)
        write (nttyo,1080) uspn56(1:jlen2)
        nerr = nerr + 1
c
  140   continue
      enddo
c
      kxt = kcol
      kdim = kxt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kwater = 0
      if (narn1 .ne. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. narn1) then
            kwater = kcol
            go to 160
          endif
        enddo
c
        call fmspnx(jlen2,uspec(narn1),uspn56)
        write (noutpt,1200) uspn56(1:jlen2)
        write (nttyo,1200) uspn56(1:jlen2)
 1200   format(/' * Error - (EQ6/intmat) The species ',a," isn't",
     $  /7x,'on the input file, as is required.')
        nerr = nerr + 1
      endif
c
  160 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      khydr = 0
      if (nhydr .ne. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. nhydr) then
            khydr = kcol
            go to 170
          endif
        enddo
c
        if (nhydx .eq. 0) then
          call fmspnx(jlen2,uspec(nhydr),uspn56)
          write (noutpt,1200) uspn56(1:jlen2)
          write (nttyo,1200) uspn56(1:jlen2)
          nerr = nerr + 1
        endif
      endif
c
  170 continue
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      khydx = 0
      if (nhydx .ne. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. nhydx) then
            khydx = kcol
            go to 180
          endif
        enddo
c
        if (nhydr .eq. 0) then
          call fmspnx(jlen2,uspec(nhydx),uspn56)
          write (noutpt,1200) uspn56(1:jlen2)
          write (nttyo,1200) uspn56(1:jlen2)
          nerr = nerr + 1
        endif
      endif
c
  180 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      ko2gaq = 0
      if (no2gaq .ne. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. no2gaq) then
            ko2gaq = kcol
            go to 190
          endif
        enddo
c
        if (nelect .eq. 0) then
          call fmspnm(jlen2,uspec(no2gaq),uspn56)
          write (noutpt,1200) uspn56(1:jlen2)
          write (nttyo,1200) uspn56(1:jlen2)
          nerr = nerr + 1
        endif
      endif
c
  190 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      kelect = 0
      if (nelect .ne. 0) then
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns .eq. nelect) then
            kelect = kcol
            go to 200
          endif
        enddo
c
        if (no2gaq .eq. 0) then
          call fmspnm(jlen2,uspec(nelect),uspn56)
          write (noutpt,1200) uspn56(1:jlen2)
          write (nttyo,1200) uspn56(1:jlen2)
          nerr = nerr + 1
        endif
      endif
c
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine aaaxc3(ustxc3,uvexc3)
c
c     XCON3: EQ3NR Input File Converter
c     EQ3/6 version 8.0 R43a (Patched 10/01/2009)
c
c     Last revised 04/24/02 by TJW
c
c
c     Copyright (c) 1993, 1995, 1997, 2002 The Regents of the University
c     of California, Lawrence Livermore National Laboratory. All rights
c     reserved.
c
c     This work was produced at the University of California,
c     Lawrence Livermore National Laboratory (UC LLNL) under
c     contract no. W-7405-ENG-48 between the U.S. Department of
c     Energy (DOE) and The Regents of the University of California
c     (University) for the operation of UC LLNL.  Copyright is
c     reserved to the University for purposes of controlled
c     dissemination, commercialization through formal licensing,
c     or other disposition under terms of Contract 48; DOE
c     policies, regulations, and orders; and U.S. statutes.
c
c
c                            DISCLAIMER
c
c     This computer code was prepared as an account of work
c     sponsored by an agency of the United States Government.
c     Neither the United States Government nor the University of
c     California nor any of their employees, makes any warranty,
c     express or implied, or assumes any liability or responsibility
c     for the accuracy, completeness, or usefulness of any
c     information, apparatus, product, or process disclosed, or
c     represents that its use would not infringe privately-owned
c     rights.  Reference herein to any specific commercial products,
c     process, or service by trade name, trademark, manufacturer,
c     or otherwise, does not necessarily constitute or imply its
c     endorsement, recommendation, or favoring by the United States
c     Government or the University of California.  The views and
c     opinions of authors expressed herein do not necessarily state
c     or reflect those of the United States government or the
c     University of California, and shall not be used for
c     advertising or product endorsement purposes.
c
c
c-----------------------------------------------------------------------
c
c     See the readme.txt file that came with this software for further
c     information, including contact information and references.
c
c
c-----------------------------------------------------------------------
c
c     This is a utility program to convert EQ3NR input files from
c     one version level to another and from one format to another.
c     This program is most conveniently run using the XCIF3 utility
c     discussed below. It may also be run directly.
c
c     The old input file is known as 'input'. It is preserved in the
c     conversion. The new input file is known as 'newin'. The version
c     levels are:
c
c       '6.0' = versions 6.0-6.1 (3245.0288, 3245.0888)
c       '7.0' = versions 7.0-7.1
c       '7.2' = version 7.2
c       '8.0' = version 8.0
c
c     The formats are:
c
c       'W' = compact
c       'D' = menu-style
c
c     'D' format does not exist for version level '6.0'.
c
c     To specify the choice of version level and format of the new
c     input file, use the control file IXCON. The same control file
c     also governs the EQ6 input file converter XCON6. A copy of the
c     contents of this file can be found in the comments in
c     EQLIBU/rddixc.f.
c
c     This code automatically determines the format of the old input
c     file. It may have trouble determining the version level, however.
c     It will first look for a string of the form 'Version level= X.X'
c     or 'Version number= X.X' in the first title of the first problem
c     on this file. Here 'X.X' denotes the version level. If none is
c     found, the code will use a default value specified on the IXCON
c     file. If no IXCON file is present, the code will use a default
c     specified in the main program.
c
c     If a version level marker as described above exists on the old
c     input file, it will be modified on the new input file to give
c     its correct version level. If no version level marker is on the
c     old input file, one will be added to the new input file.
c
c     The version level and format of the new input file may match
c     those of the old input file. The new input file may be identical
c     to the old one, or made somewhat more pretty.
c
c     As noted above, it is more convenient to run XCON3 using the
c     interface software XCIF3 than to run XCON3 directly. On a UNIX
c     system, XCIF3 is a symbolic link to the shell script xcif36RXX,
c     where RXX is a revision number (R01, R02, R03, etc.). On a
c     PC system, XCIF3 is a Fortran program (XCIF3.EXE; the source
c     code file is XCIF3.FOR) containing DOS system calls. XCIF3
c     replaces the specified input files. XCIF3 also creates the
c     IXCON control file used by XCON3, and deletes it prior to
c     completing execution. To convert a set of EQ3NR input files from
c     version level 7.2 ('W' or 'D' format) to version level 8.0,
c     'W' format, enter:
c
c       xcif3 7.2 8.0 W *.3i
c
c     To convert the same files to 'D' format instead, enter:
c
c       xcif3 7.2 8.0 D *.3i
c
c     XCON6 and XCIF6 are analogues of XCON3 and XCIF3, respectively.
c     They perform the analogous conversions of EQ6 input files.
c
c     This code requires subroutines from the following EQ3/6 libraries:
c
c       EQLIBU
c
c
c-----------------------------------------------------------------------
c
c     This subroutine is designed to ensure that the copyright statement
c     and legal and other disclaimers appear at the beginning of the
c     concatenated source code for XCON3. Concatenation is normally
c     alphabetical, hence the form of the name. This subroutine returns
c     the stage and version numbers of this computer code.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       None
c
c     Principal output:
c
c       ustxc3 = XCON3 stage number
c       uvexc3 = XCON3 version number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*8 ustxc3,uvexc3
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*8 ust,uve
c
c-----------------------------------------------------------------------
c
      data ust /'R43a    '/
      data uve /'8.0     '/
c
c-----------------------------------------------------------------------
c
      ustxc3 = ust
      uvexc3 = uve
c
      end

      subroutine stepfd(acflg,acflg0,affp0,affp,afrc0,afrc1,aw0,aw1,
     $ delxi,dxsm00,eh0,eh1,emop,emop0,emos,emos0,fdafm1,fdaf0,
     $ fdarm1,fdar0,fdawm1,fdaw0,fdehm1,fdeh0,fdlim,fdo2m1,fdo20,
     $ fdpem1,fdpe0,fdphm1,fdph0,fdrem1,fdre0,fdrim1,fdri0,fdrrm1,
     $ fdrr0,fdsem1,fdse0,fdzvm1,fdzv0,fje,fje0,fo2lg0,fo2lg1,fxi,
     $ fxi0,iemop,iemop0,iemos,iemos0,iindx0,iindx1,iodb,iopt,ipndx0,
     $ ipndx1,jcode,jreac,jreac0,jpflag,kdim,kdim0,kmax,km1,km10,kmt,
     $ kmt0,kord,kx1,kx10,kxt,kxt0,modr,modr0,moph,moph0,morr,morr0,
     $ mosp,mosp0,mtb,mtb0,nbt,nbtmax,ncmpe,ncmpe0,nodbmx,noptmx,
     $ nordmx,noutpt,npet,npetmx,npet0,npt,nptmax,npts,nrct,nrctmx,
     $ nrd1mx,nrndex,nset,nsetmx,nset0,nstmax,ph0,ph1,qredox,rirec0,
     $ rirec1,rreac0,rreac1,rrelr0,rrelr1,sfcar,sfcar0,sigmam,sigmm0,
     $ tempc,tempc0,time0,time1,uzvec0,uzvec1,xi0,xi1,xim1,xirct,
     $ xirct0,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine saves information at the current point and
c     computes finite differences at the current point of reaction
c     progress.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nodbmx,noptmx,nordmx,npetmx,nptmax,nrctmx,
     $ nrd1mx,nsetmx,nstmax
c
      integer noutpt
c
      integer iemop(npetmx),iemop0(npetmx),iemos(nsetmx),iemos0(nsetmx),
     $ iindx0(kmax),iindx1(kmax),iodb(nodbmx),iopt(noptmx),ipndx0(kmax),
     $ ipndx1(kmax),jcode(nrctmx),jreac(nrctmx),jreac0(nrctmx),
     $ jpflag(nptmax),ncmpe(2,npetmx),ncmpe0(2,npetmx),nrndex(nrctmx)
c
      integer kdim,kdim0,km1,km10,kmt,kmt0,kord,kx1,kx10,kxt,kxt0,
     $ nbt,npet,npet0,npt,npts,nrct,nset,nset0
c
      logical qredox
c
      character*48 uzvec0(kmax),uzvec1(kmax)
c
      real*8 acflg(nstmax),acflg0(nstmax),affp(nptmax),affp0(nptmax),
     $ afrc0(nrctmx),afrc1(nrctmx),dxsm00(nrd1mx),emop(npetmx),
     $ emop0(npetmx),emos(nsetmx),emos0(nsetmx),fdafm1(nordmx,nptmax),
     $ fdaf0(nordmx,nptmax),fdarm1(nordmx,nrctmx),fdar0(nordmx,nrctmx),
     $ fdawm1(nordmx),fdaw0(nordmx),fdehm1(nordmx),fdeh0(nordmx),
     $ fdo2m1(nordmx),fdo20(nordmx),fdpem1(nordmx,npetmx),
     $ fdpe0(nordmx,npetmx),fdphm1(nordmx),fdph0(nordmx),
     $ fdrem1(nordmx,nrctmx),fdre0(nordmx,nrctmx),fdrim1(nrd1mx),
     $ fdri0(nrd1mx),fdrrm1(nrd1mx,nrctmx),fdrr0(nrd1mx,nrctmx),
     $ fdsem1(nordmx,nsetmx),fdse0(nordmx,nsetmx),fdzvm1(nrd1mx,kmax),
     $ fdzv0(nrd1mx,kmax)
c
      real*8 modr(nrctmx),modr0(nrctmx),moph(nptmax),moph0(nptmax),
     $ morr(nrctmx),morr0(nrctmx),mosp(nstmax),mosp0(nstmax),
     $ mtb(nbtmax),mtb0(nbtmax),rreac0(nrctmx),rreac1(nrctmx),
     $ rrelr0(nrctmx),rrelr1(nrctmx),sfcar(nrctmx),sfcar0(nrctmx),
     $ xirct(nrctmx),xirct0(nrctmx),zvclg0(kmax),zvclg1(kmax),
     $ zvec0(kmax),zvec1(kmax)
c
      real*8 aw0,aw1,delxi,eh0,eh1,fdlim,fje,fje0,fo2lg0,fo2lg1,fxi,
     $ fxi0,ph0,ph1,rirec0,rirec1,sigmam,sigmm0,tempc,tempc0,time0,
     $ time1,xi0,xi1,xim1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer itrunc,j,k,kcol,n,nmax,np,npe,nrc,nse
c
      real*8 dfx,dfxl,dfxu
c
c-----------------------------------------------------------------------
c
      if (npts .eq. 1) then
c
c       Zero all finite differences.
c
        nmax = nrd1mx*kmax
        call initaz(fdzvm1,nmax)
        call initaz(fdzv0,nmax)
c
        nmax = nrd1mx*nrctmx
        call initaz(fdrrm1,nmax)
        call initaz(fdrr0,nmax)
c
        if (iopt(2) .gt. 0) then
          call initaz(fdrim1,nrd1mx)
          call initaz(fdri0,nrd1mx)
        endif
c
        call initaz(fdawm1,nordmx)
        call initaz(fdaw0,nordmx)
        call initaz(fdehm1,nordmx)
        call initaz(fdeh0,nordmx)
        call initaz(fdo2m1,nordmx)
        call initaz(fdo20,nordmx)
        call initaz(fdphm1,nordmx)
        call initaz(fdph0,nordmx)
c
        if (iopt(2) .gt. 0) then
          nmax = nordmx*nrctmx
          call initaz(fdrem1,nmax)
          call initaz(fdre0,nmax)
        endif
c
        nmax = nordmx*nptmax
        call initaz(fdafm1,nmax)
        call initaz(fdaf0,nmax)
c
        nmax = nordmx*npetmx
        call initaz(fdpem1,nmax)
        call initaz(fdpe0,nmax)
c
        nmax = nordmx*nsetmx
        call initaz(fdsem1,nmax)
        call initaz(fdse0,nmax)
c
        nmax = nordmx*nrctmx
        call initaz(fdarm1,nmax)
        call initaz(fdar0,nmax)
c
        go to 200
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the dxsm00 vector.
c
      do n = 1,kord
        j = kord - n + 1
        dxsm00(j + 1) = dxsm00(j) + delxi
      enddo
      dxsm00(1) = delxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Overflow protection is automatically activated in the code blocks
c     below in order to run on VAX machines with a small exponent range
c     (+/- 38) for real*8.
c
      itrunc = kord
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the elements of the z vector.
c     These are mostly the number of moles of basis species.
c
      do kcol = 1,kdim
        fdzv0(1,kcol) = (zvec1(kcol) - zvec0(kcol))/delxi
        do j = 2,kord + 1
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdzv0(k,kcol) - fdzvm1(k,kcol)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdzv0(j,kcol) = dfx/dxsm00(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for relative rates.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.1 .or. jreac(nrc).eq.2) then
c
c         The relative rate must be a constant zero, because no
c         reactant mass remains:
c
c           jreac =  1: exhausted
c           jreac =  2: saturated; any remaining reactant mass is
c                         converted to the corresponding product
c                         phase, so the "reactant" is effectively
c                         exhausted.
c
c         Hence the corresponding finite differences must also be
c         zero. Avoid calculating finite differences from relative
c         rate values that may by non-zero owing to convergence
c         tolerances and the like.
c
          do j = 1,kord + 1
            fdrr0(j,nrc) = 0.
          enddo
        else
c
c         The relative rate is calculated for the reactant, which
c         is actively reacting according to a rate law:
c
c           jreac =  0: set to react
c           jreac = -1: saturated, but the remaining reactant mass
c                         continues to react irreversibly
c
c         Hence calculate the finite differences.
c
          fdrr0(1,nrc) = (rrelr1(nrc) - rrelr0(nrc))/delxi
          do j = 2,kord + 1
            dfxu = fdlim*dxsm00(j)
            dfxl = -dfxu
            k = j - 1
            dfx = fdrr0(k,nrc) - fdrrm1(k,nrc)
            dfx = min(dfxu,dfx)
            dfx = max(dfxl,dfx)
            if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
            fdrr0(j,nrc) = dfx/dxsm00(j)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Compute finite differences for the inverse rate.
c
        fdri0(1) = (rirec1 - rirec0)/delxi
        do j = 2,kord + 1
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdri0(k) - fdrim1(k)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdri0(j) = dfx/dxsm00(j)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the pH.
c
      fdph0(1) = (ph1 - ph0)/delxi
      do j = 2,kord
        dfxu = fdlim*dxsm00(j)
        dfxl = -dfxu
        k = j - 1
        dfx = fdph0(k) - fdphm1(k)
        dfx = min(dfxu,dfx)
        dfx = max(dfxl,dfx)
        if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
        fdph0(j) = dfx/dxsm00(j)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the Eh.
c
      if (qredox) then
        fdeh0(1) = (eh1 - eh0)/delxi
        do j = 2,kord
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdeh0(k) - fdehm1(k)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdeh0(j) = dfx/dxsm00(j)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the log fO2.
c
      if (qredox) then
        fdo20(1) = (fo2lg1 - fo2lg0)/delxi
        do j = 2,kord
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdo20(k) - fdo2m1(k)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdo20(j) = dfx/dxsm00(j)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the activity of water.
c
      fdaw0(1) = (aw1 - aw0)/delxi
      do j = 2,kord
        dfxu = fdlim*dxsm00(j)
        dfxl = -dfxu
        k = j - 1
        dfx = fdaw0(k) - fdawm1(k)
        dfx = min(dfxu,dfx)
        dfx = max(dfxl,dfx)
        if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
        fdaw0(j) = dfx/dxsm00(j)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the affinities of the
c     various phases.
c
      do np = 1,npt
        fdaf0(1,np) = (affp(np) - affp0(np))/delxi
        do j = 2,kord
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdaf0(k,np) - fdafm1(k,np)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdaf0(j,np) = dfx/dxsm00(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the number of moles of phases
c     present in the equilibrium system.
c
      do npe = 1,npet
        fdpe0(1,npe) = (emop(npe) - emop0(npe))/delxi
        do j = 2,kord
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdpe0(k,npe) - fdpem1(k,npe)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdpe0(j,npe) = dfx/dxsm00(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the number of moles of
c     selected species present in the equilibrium system. These
c     species include H2O(l) only for the aqueous phase and
c     all species of the non-aqueous phases.
c
      do nse = 1,nset
        fdse0(1,nse) = (emos(nse) - emos0(nse))/delxi
        do j = 2,kord
          dfxu = fdlim*dxsm00(j)
          dfxl = -dfxu
          k = j - 1
          dfx = fdse0(k,nse) - fdsem1(k,nse)
          dfx = min(dfxu,dfx)
          dfx = max(dfxl,dfx)
          if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
          fdse0(j,nse) = dfx/dxsm00(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Compute finite differences for reaction rates.
c
        do nrc = 1,nrct
          if (jreac(nrc).eq.1 .or. jreac(nrc).eq.2) then
c
c           The reaction rate must be a constant zero, because no
c           reactant mass remains:
c
c             jreac =  1: exhausted
c             jreac =  2: saturated; any remaining reactant mass is
c                           converted to the corresponding product
c                           phase, so the "reactant" is effectively
c                           exhausted.
c
c           Hence the corresponding finite differences must also be
c           zero. Avoid calculating finite differences from reaction
c           rate values that may by non-zero owing to convergence
c           tolerances and the like.
c
            do j = 1,kord
              fdre0(j,nrc) = 0.
            enddo
          else
c
c           The reaction rate is calculated for the reactant, which
c           is actively reacting according to a rate law:
c
c             jreac =  0: set to react
c             jreac = -1: saturated, but the remaining reactant mass
c                           continues to react irreversibly
c
c           Hence calculate the finite differences.
c
            fdre0(1,nrc) = (rreac1(nrc) - rreac0(nrc))/delxi
            do j = 2,kord
              dfxu = fdlim*dxsm00(j)
              dfxl = -dfxu
              k = j - 1
              dfx = fdre0(k,nrc) - fdrem1(k,nrc)
              dfx = min(dfxu,dfx)
              dfx = max(dfxl,dfx)
              if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
              fdre0(j,nrc) = dfx/dxsm00(j)
            enddo
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute finite differences for the affinities of irreversible
c     reactions.
c
c     Zero the affinities of exhausted reactants which correspond
c     to product minerals present in the ES. This will prevent
c     non-zero values due to convergence tolerances, etc., from
c     adversely affecting the corresponding finite differences for
c     these reactants.
c
      do nrc = 1,nrct
        if (jreac(nrc) .eq. 1) then
          if (jcode(nrc).eq.0 .or. jcode(nrc) .eq. 1) then
c
c           Note that this is done only for reactants which are
c           pure minerals or solid solutions.
c
            np = nrndex(nrc)
            if (jpflag(np) .eq. -1) then
              afrc0(nrc) = 0.
              afrc1(nrc) = 0.
            endif
          endif
        endif
      enddo
c
c     Now compute the finite differences.
c
      do nrc = 1,nrct
        if (jreac(nrc).eq.-1 .or. jreac(nrc).eq.2) then
c
c         The affinity is zero by definition:
c
c           jreac = -1: saturated, but the remaining reactant mass
c                         continues to react irreversibly
c           jreac =  2: saturated; any remaining reactant mass is
c                         converted to the corresponding product phase,
c                         so the "reactant" is effectively exhausted.
c
c         Hence the corresponding finite differences must also be zero.
c         The corresponding computed affinities may be non-zero, owing
c         to finite convergence tolerances. Avoid calculating finite
c         differences from such computed affinity values.
c
          do j = 1,kord
            fdar0(j,nrc) = 0.
          enddo
        else
c
c         The affinity is generally a non-zero value calculated from
c         a rate law:
c
c           jreac =  0: set to react
c           jreac =  1: exhausted
c
c         Hence calculate the finite differences.
c
          fdar0(1,nrc) = (afrc1(nrc) - afrc0(nrc))/delxi
          do j = 2,kord
            dfxu = fdlim*dxsm00(j)
            dfxl = -dfxu
            k = j - 1
            dfx = fdar0(k,nrc) - fdarm1(k,nrc)
            dfx = min(dfxu,dfx)
            dfx = max(dfxl,dfx)
            if (abs(dfx) .ge. dfxu) itrunc = min(itrunc,k)
            fdar0(j,nrc) = dfx/dxsm00(j)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (itrunc .lt. kord) then
        if (iodb(1) .ge. 1) write (noutpt,1000) itrunc
 1000   format(/' * Note - (EQ6/stepfd) Cutting the order to ',i2,
     $  /7x,'to stay within the finite difference limit.')
        kord = itrunc
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the current point the new base point.
c
  200 km10 = km1
      kmt0 = kmt
      kx10 = kx1
      kxt0 = kxt
      kdim0 = kdim
c
      xim1 = xi0
      xi0 = xi1
c
      time0 = time1
      tempc0 = tempc
c
      ph0 = ph1
      eh0 = eh1
      fo2lg0 = fo2lg1
      aw0 = aw1
c
      fje0 = fje
      fxi0 = fxi
      sigmm0 = sigmam
c
      call copyia(iindx1,iindx0,kdim)
      call copyia(ipndx1,ipndx0,kdim)
      call copyca(uzvec1,uzvec0,kdim)
c
      call copyaa(zvclg1,zvclg0,kdim)
      call copyaa(zvec1,zvec0,kdim)
c
      call copyaa(moph,moph0,nptmax)
      call copyaa(mosp,mosp0,nstmax)
      call copyaa(acflg,acflg0,nstmax)
c
      call copyaa(sfcar,sfcar0,nrct)
      call copyia(jreac,jreac0,nrct)
      call copyaa(xirct,xirct0,nrct)
      call copyaa(morr,morr0,nrct)
      call copyaa(modr,modr0,nrct)
c
      call copyaa(mtb,mtb0,nbt)
c
      call copyaa(affp,affp0,npt)
c
      npet0 = npet
      nset0 = nset
c
      call copyia(iemop,iemop0,npet)
      call copyaa(emop,emop0,npet)
c
      nmax = 2*npetmx
      call copyia(ncmpe,ncmpe0,nmax)
c
      call copyia(iemos,iemos0,nset)
      call copyaa(emos,emos0,nset)
c
      call copyaa(afrc1,afrc0,nrct)
c
      call copyaa(rrelr1,rrelr0,nrct)
c
      if (iopt(2) .gt. 0) then
        rirec0 = rirec1
        call copyaa(rreac1,rreac0,nrct)
      endif
c
      if (npts .gt. 2) then
c
c       Save the old finite differences.
c
        nmax = nrd1mx*kmax
        call copyaa(fdzv0,fdzvm1,nmax)
c
        nmax = nrd1mx*nrctmx
        call copyaa(fdrr0,fdrrm1,nmax)
c
        if (iopt(2) .gt. 0) then
          call copyaa(fdri0,fdrim1,nrd1mx)
        endif
c
        call copyaa(fdaw0,fdawm1,nordmx)
        call copyaa(fdeh0,fdehm1,nordmx)
        call copyaa(fdo20,fdo2m1,nordmx)
        call copyaa(fdph0,fdphm1,nordmx)
c
        nmax = nordmx*nptmax
        call copyaa(fdaf0,fdafm1,nmax)
c
        nmax = nordmx*npetmx
        call copyaa(fdpe0,fdpem1,nmax)
c
        nmax = nordmx*nsetmx
        call copyaa(fdse0,fdsem1,nmax)
c
        nmax = nordmx*nrctmx
        call copyaa(fdar0,fdarm1,nmax)
c
        if (iopt(2) .gt. 0) then
          nmax = nordmx*nrctmx
          call copyaa(fdre0,fdrem1,nmax)
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine phsdrp(d1zvc1,iindx0,iindx1,iodb,ipndx1,iter,kmax,
     $ km1,km1s,kxt,kxts,nodbmx,nord,noutpt,npadd,npdel,nptmax,ntry,
     $ uphase,zvclgs,zvclg1)
c
c     This subroutine picks a phase to drop from the equilibrium
c     system. Two independent algorithms are used to find candidates,
c     and a final choice is made from these.
c
c     This subroutine is called by:
c
c       EQ6/eqcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nodbmx,nptmax
c
      integer noutpt
c
      integer iindx0(kmax),iindx1(kmax),ipndx1(kmax),iodb(nodbmx)
c
      integer iter,km1,km1s,kxt,kxts,nord,npadd,npdel,ntry
c
      character*24 uphase(nptmax)
c
      real*8 d1zvc1(kmax),zvclgs(kmax),zvclg1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,kcol,kj,krow,npdc1,npdc1a,npdc2,np,ns
c
      integer ilnobl
c
      character*24 updc1,updc1a,updc2
c
      real*8 crit1,crit1a,crit2,criter,zx
c
c-----------------------------------------------------------------------
c
      npdc1 = 0
      npdc2 = 0
      crit1 = 0.
      crit2 = 0.
      updc1 = 'None'
      updc2 = 'None'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search for a candidate solid according to the first criterion
c     (rapid decrease in mass).
c
      npdc1a = 0
      updc1a = 'None'
      crit1a = 0.
c
      do kcol = km1,kxt
        zx = zvclg1(kcol) - zvclgs(kcol)
        if (zx .ge. -1.0) zx = 0.
        if (iter .le. 1) zx = zvclgs(kcol) + 10.
        if (zvclgs(kcol) .le. -100.) zx = zvclgs(kcol)
        if (zx .lt. crit1) then
          ns = iindx1(kcol)
          np = ipndx1(kcol)
          crit1a = zx
          npdc1a = np
          updc1a = uphase(np)
          if (np .ne. npadd) then
            crit1 = zx
            npdc1 = np
            updc1 = uphase(np)
          endif
        endif
      enddo
c
      if (npdc1.le.0) crit1 = 0.
      if (npdc1a.gt.0 .and. ntry.eq.2) then
        if (crit1a. lt. (crit1 -1.)) then
          npdc1 = npdc1a
          updc1 = updc1a
          crit1 = crit1a
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search for a candidate solid according to the second criterion
c     (negative derivative of mass).
c
      if (nord.gt.0 .and. ntry.le.0) then
        crit2 = -100.
        if (kxt.ge.km1 .and. kxts.ge.km1) then
          do kcol = km1,kxt
            kj = 0
            ns = iindx1(kcol)
            np = ipndx1(kcol)
            do krow = km1s,kxts
              if (iindx0(krow) .eq. ns) then
                kj = krow
                go to 100
              endif
            enddo
  100       if (kj .gt. 0) then
              zx = d1zvc1(kj)
              if (zx .lt. crit2) then
                if (np .ne. npadd) then
                  crit2 = zx
                  npdc2 = np
                  updc2 = uphase(np)
                endif
              endif
            endif
          enddo
        endif
      endif
      if (npdc2.le.0) crit2 = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .ge. 1) then
        j2 = ilnobl(updc1)
        j3 = ilnobl(updc2)
        write (noutpt,1000) crit1,updc1(1:j2),crit2,updc2(1:j3)
 1000   format(/'   --- Phase Drop Search ---',
     $  /7x,'Criterion 1. Negative divergence of log mass variable',
     $  /11x,'Value= ',e12.5,4x,/11x,'Name= ',a,
     $  /7x,'Criterion 2. Negative derivative of log mass variable',
     $  /11x,'Value= ',e12.5,4x,/11x,'Name= ',a,/)
      endif
c
      criter = 0.
      npdel = 0
      if (crit1 .lt. criter) then
        criter = crit1
        npdel = npdc1
      endif
      if (crit2 .lt. criter) then
        criter = crit2
        npdel = npdc2
      endif
c
      end

      subroutine rd6w7(cdac,cesrb,cplim,csigma,dlzmx1,dlzmx2,dlzidp,
     $ dzpllg,dzplot,dzprlg,dzprnt,eact,electr,fk,iact,ifile,iktbt,
     $ iktmax,imchmx,imech,iodb,iopg,iopr,iopt,ioscan,itermx,jcode,
     $ jreac,jtemp,jxmod,kct,kdim,kmax,kmt,kprs,ksq,ksplmx,ksppmx,
     $ kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprs,mteaqb,mteb,nctmax,
     $ ndact,ndctmx,nesrbt,nffg,nffgmx,ninpts,nmodl1,nmodl2,nodbmx,
     $ nopgmx,noprmx,noptmx,nordlm,npslmx,nprmn,nprmx,nprsmx,nrct,
     $ nrctmx,nrk,nsk,nsrtmx,nsscmx,nsslmx,ntitl1,ntitl2,ntitmx,
     $ ntrymx,nttkmx,nttyo,nxmdmx,nxmod,nxopex,nxopmx,nxopt,nxpemx,
     $ nxrtmx,qend,qrderr,rk0,rxbarb,sscrew,sk,tempci,tempc0,timemx,
     $ tolbt,toldl,tolsat,tolsst,tolx,trk0,tstrt,ttk,udac,uelemb,
     $ uendb,uesrb,uffg,undms,unrms,uprs,ureac,utitl1,utitl2,uxct16,
     $ uxmd24,uxopex,uxopt,vreac,xlkffg,xlkmod,zimax,zistrt,zkfac,
     $ zklogl,zklogu,zvclgi)
c
c     This subroutine reads the EQ6 input file in compact ("W") format
c     for version 7 (versions 7.0-7.1).
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nctmax,ndctmx,nffgmx,nodbmx,nopgmx,
     $ noprmx,noptmx,nprsmx,nrctmx,nsrtmx,nsscmx,ntitmx,nttkmx,nxmdmx,
     $ nxopmx,nxpemx,nxrtmx
c
      integer iact(imchmx,2,nrctmx),iktbt(nxrtmx),imech(2,nrctmx),
     $ iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jcode(nrctmx),jreac(nrctmx),jxmod(nxmdmx),kxmod(nxmdmx),
     $ ndact(imchmx,2,nrctmx),nesrbt(nsrtmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ifile,ioscan,itermx,jtemp,kct,kdim,ksq,kmt,kprs,ksplmx,
     $ ksppmx,kstpmx,kxt,nffg,ninpts,nmodl1,nmodl2,nordlm,npslmx,nprmn,
     $ nprmx,nrct,nsslmx,ntitl1,ntitl2,ntrymx,nttyo,nxmod,nxopex,nxopt
c
      logical qend,qrderr
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*48 uprs(nprsmx)
      character*24 udac(ndctmx,imchmx,2,nrctmx),uendb(iktmax,nxrtmx),
     $ uffg(nffgmx),undms(kmax),unrms(kmax),ureac(nrctmx),
     $ uxmd24(nxmdmx),uxopex(nxpemx)
      character*16 uxct16(nxopmx)
      character*8 uelemb(nctmax),uesrb(nctmax,nsrtmx),uxopt(nxopmx)
c
      real*8 cdac(ndctmx,imchmx,2,nrctmx),cesrb(nctmax,nsrtmx),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),fk(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprs(nprsmx),mteaqb(nctmax),mteb(nctmax),rk0(imchmx,2,nrctmx),
     $ rxbarb(iktmax,nxrtmx),sscrew(nsscmx),sk(nrctmx),ttk(nttkmx),
     $ trk0(imchmx,2,nrctmx),vreac(nrctmx),xlkffg(nffgmx),
     $ xlkmod(nxmdmx),zvclgi(kmax)
c
      real*8 cplim,dlzmx1,dlzmx2,dlzidp,dzpllg,dzplot,dzprlg,dzprnt,
     $ electr,tempci,tempc0,timemx,tolbt,toldl,tolsat,tolsst,tolx,
     $ tstrt,zkfac,zklogl,zklogu,zimax,zistrt
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iktb,j,kc,kcol,n,ncb,nrc,nsrt,nxrt
c
      character*80 uline
      character*24 ux,uxx
      character*8 uendit
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c-----------------------------------------------------------------------
c
c     Main title.
c
c     Note: if there are exactly ntitpa lines in the title, the title
c     need not be terminated by an 'endit.'. The 'endit.' if present
c     is here not considered to be part of the title. The secondary
c     title is treated in the same manner.
c
      qend = .false.
      read (ninpts,1100,end=100,err=990) uline
 1100 format(a80)
      go to 105
c
  100 qend = .true.
      go to 999
c
  105 n = 1
      if (uline(1:8) .eq. uendit(1:8)) go to 120
      utitl1(1) = uline
c
      do 110 n = 2,ntitmx
        read (ninpts,1100,err=990) uline
        if (uline(1:8) .eq. uendit(1:8)) go to 120
        utitl1(n) = uline
  110 continue
      n = n + 1
c
      read (ninpts,1100,err=990) uline
      call locase(uline)
      j = index(uline,'nmodl1=')
      if (j .gt. 0) then
        backspace(ninpts)
      else
        write (nttyo,1015) ntitmx
 1015   format(/' * Error - (XCON6/rd6w7) Have too many lines in the',
     $  /7x,'main title. The code is only dimensioned for ',i4,
     $  /7x,'lines. Reduce the size of the title or increase the',
     $  /7x,'dimensioning parameter ntitpa.')
        go to 990
      endif
c
  120 ntitl1 = n - 1
c
c-----------------------------------------------------------------------
c
c     Nmodl option switches.
c
      read (ninpts,1110,err=990) nmodl1,nmodl2
 1110 format(12x,i2,22x,i2)
c
c     Temperature parameters.
c     Note: ttk(1) = tk1, etc.
c
      read (ninpts,1130,err=990) tempc0,jtemp,(ttk(i), i = 1,3)
 1130 format(12x,e12.5,12x,i2,/3(12x,e12.5))
c
c      Zi and time parameters.
c
      read (ninpts,1150,err=990) zistrt,zimax,tstrt,timemx,kstpmx,cplim
 1150 format(2(12x,e12.5),/2(12x,e12.5),/12x,i12,12x,e12.5)
c
c     Print interval parameters.
c
      read (ninpts,1170,err=990) dzprnt,dzprlg,ksppmx
 1170 format (2(12x,e12.5),12x,i5)
c
c     Plot interval parameters.
c
      read (ninpts,1190,err=990) dzplot,dzpllg,ksplmx
 1190 format (2(12x,e12.5),12x,i5)
c
c     Ifile.
c
      read (ninpts,1210,err=990) ifile
 1210 format(12x,i2,22x,i2)
c
c-----------------------------------------------------------------------
c
c     Iopt option switches.
c     Note: iopt(1) = iopt1, etc.
c
      read (ninpts,1240,err=990) (iopt(i), i = 1,20)
 1240 format(12x,10i5)
c
c     Iopr option switches.
c     Note: iopr(1) = iopr1, etc.
c
      read (ninpts,1260,err=990) (iopr(i), i = 1,20)
 1260 format(12x,10i5)
c
c     Iodb option switches.
c     Note: iodb(1) = iodb1, etc.
c
      read (ninpts,1280,err=990) (iodb(i), i = 1,20)
 1280 format(12x,10i5)
c
c-----------------------------------------------------------------------
c
c     Number of nxopt options.
c
      read (ninpts,1300,err=990) nxopt
 1300 format(12x,i2)
c
      if (nxopt .gt. nxopmx) then
        write (nttyo,1315) nxopmx
 1315   format(/' * Error - (XCON6/rd6w7) Have too many mineral',
     $  /7x,'subset-selection suppression options. The code is',
     $  /7x,'only dimensioned for ',i3,' such options. Reduce the',
     $  /7x,'number of options or increase the dimensioning',
     $  /7x,'parameter nxoppa.')
        go to 990
      endif
c
c     Nxopt options.
c
      if (nxopt .gt. 0) then
        do 140 n = 1,nxopt
          read (ninpts,1320,err=990) uxopt(n),uxct16(n)
 1320     format(12x,a6,1x,a8)
  140   continue
        read (ninpts,1340,err=990) nxopex
 1340   format(12x,i2)
c
        if (nxopex .gt. nxpemx) then
          write (nttyo,1345) nxpemx
 1345     format(/' * Error - (XCON6/rd6w7) Have too many',
     $    /7x,'exceptions specified to the mineral subset-selection',
     $    /7x,'suppression options. The code is only dimensioned',
     $    /7x,'for ',i3,'exceptions. Reduce the number of exceptions',
     $    /7x,'or increase the dimensioning parameter nxoppa.')
          go to 990
        endif
c
        if (nxopex .gt. 0) then
          do 150 n = 1,nxopex
            read (ninpts,1360,err=990) uxopex(n)
 1360       format(12x,a24)
  150     continue
        endif
      endif
c
c-----------------------------------------------------------------------
c
c     Number of nffg options.
c
      read (ninpts,1380,err=990) nffg
 1380 format(12x,i2)
c
      if (nffg .gt. nffgmx) then
        write (nttyo,1385) nffgmx
 1385   format(/' * Error - (XCON6/rd6w7) Have too many gases whose',
     $  /7x,'fugacities are to be fixed. The code is only dimensioned',
     $  /7x,'for ',i4,' such gases. Reduce the number of gases or',
     $  /7x,'increase the dimensioning parameter nffgpa.')
        go to 990
      endif
c
c     Nffg options.
c
      if (nffg .gt. 0) then
      do 160 n = 1,nffg
        read (ninpts,1400,err=990) uffg(n),moffg(n),xlkffg(n)
 1400   format(12x,a12,12x,e12.5,12x,e12.5)
  160   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Number of reactants.
c
      read (ninpts,1420,err=990) nrct
 1420 format(12x,i2)
c
      if (nrct .gt. nrctmx) then
        write (nttyo,1425) nrctmx
 1425   format(/' * Error - (XCON6/rd6w7) Have too many reactants',
     $  /7x,'The code is only dimensioned for ',i4,' reactants.',
     $  /7x,'Reduce the number of reactants or increase the',
     $  /7x,'dimensioning parameter nrctpa.')
        go to 990
      endif
c
c     Reactants.
c
      nsrt = 0
      nxrt = 0
      if (nrct .gt. 0) then
        do 390 nrc = 1,nrct
c
c         Name, flags, and masses.
c
          read (ninpts,1440,err=990) ureac(nrc),jcode(nrc),jreac(nrc),
     $    morr(nrc),modr(nrc)
 1440     format(12x,a24,/12x,i2,22x,i2,/2(12x,e12.5))
c
          if (jcode(nrc) .eq. 1) then
c
c           Solid solution compositions.
c
            nxrt = nxrt + 1
c
            if (nxrt .gt. nxrtmx) then
              write (nttyo,1445) nxrtmx
 1445         format(/' * Error - (XCON6/rd6w7) Have too many solid',
     $        /7x,'solution reactants. The code is only dimensioned',
     $        /7x,'for ',i4,' such reactants. Reduce the number of',
     $        /7x,'such reactants or increase the dimensioning',
     $        ' parameter nxrtpa.')
              go to 990
            endif
c
            iktb = 0
            do 170 i = 1,iktmax + 1
              read (ninpts,1460,err=990) ux,xx
 1460         format(3x,a24,3x,e12.5)
              if (ux(1:8) .eq. uendit(1:8)) go to 180
c
              iktb = iktb + 1
c
              if (iktb .gt. iktmax) then
                write (nttyo,1446) ureac(nrc),iktmax
 1446           format(/' * Error - (XCON6/rd6w7) Have too many',
     $          ' end-members',/7x,'in the solid solution reactant',
     $          ' "',a24,'".',/7x,'The code is only dimensioned for ',
     $          i4,' end-members per',/7x,'solid solution. Reduce',
     $          ' the number of end-members or',
     $          /7x,'increase the dimensioning parameter iktpar.')
                go to 990
              endif
c
              uendb(iktb,nxrt) = ux
              rxbarb(iktb,nxrt) = xx
  170       continue
  180       iktbt(nxrt) = iktb
          elseif (jcode(nrc) .eq. 2) then
c
c           Special reactant compositions.
c
            nsrt = nsrt + 1
c
            if (nsrt .gt. nsrtmx) then
              write (nttyo,1447) nsrtmx
 1447         format(/' * Error - (XCON6/rd6w7) Have too many special',
     $        /7x,'reactants. The code is only dimensioned for ',i4,
     $        /7x,'such reactants. Reduce the number of such reactants',
     $        /7x,'or increase the dimensioning parameter nsrtpa.')
              go to 990
            endif
c
            read (ninpts,1480,err=990) vreac(nrc)
 1480       format(12x,e12.5)
c
            ncb = 0
            do 190 n = 1,nctmax + 1
              read (ninpts,1500,err=990) ux,xx
 1500         format(3x,a8,1x,e25.15)
              if (ux(1:8) .eq. uendit(1:8)) go to 200
c
              ncb = ncb + 1
c
              if (ncb .gt. nctmax) then
                write (nttyo,1510) ureac(nrc),nctmax
 1510           format(/' * Error - (XCON6/rd6w7) Have too many',
     $          '  chemical',
     $          /7x,'elements in the special  reactant "',a24,'".',
     $          /7x,'The code is only dimensioned for ',i4,' elements.',
     $          /7x,'Reduce the number of elements or increase the',
     $          /7x,'dimensioning parameter nctpar.')
                go to 990
              endif
c
              uesrb(ncb,nsrt) = ux
              cesrb(ncb,nsrt) = xx
  190       continue
  200       nesrbt(nsrt) = ncb
          endif
c
c         Surface area parameters.
c
          read (ninpts,1520,err=990) nsk(nrc),sk(nrc),fk(nrc)
 1520     format(12x,i2,22x,e12.5,12x,e12.5)
c
c         Rate law codes.
c
          read (ninpts,1540,err=990) nrk(1,nrc),nrk(2,nrc)
 1540     format(12x,i2,22x,i2)
c
c         Rate law parameters, forward direction.
c
          if (nrk(1,nrc) .eq. 1) then
            imech(1,nrc) = 3
c
            if (imech(1,nrc) .gt. imchmx) then
              write (nttyo,1550) ureac(nrc),imchmx
 1550         format(/' * Error - (XCON6/rd6w7) Have too many rate',
     $        /7x,'constants in the forward direction rate law for',
     $        /7x,'reactant "',a24,'". The code is only',
     $        /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $        /7x,'Reduce the number of rate constants or increase the',
     $        /7x,'dimensioning parameter imchpa.')
              go to 990
            endif
c
            read (ninpts,1560,err=990) (rk0(j,1,nrc), j = 1,3)
 1560       format (3(12x,e12.5))
          elseif (nrk(1,nrc) .eq. 2) then
            read (ninpts,1580,err=990) imech(1,nrc)
 1580       format(12x,i2)
c
            if (imech(1,nrc) .gt. imchmx) then
              write (nttyo,1550) ureac(nrc),imchmx
              go to 990
            endif
c
            do 220 i = 1,imech(1,nrc)
              read (ninpts,1600,err=990) rk0(i,1,nrc),trk0(i,1,nrc),
     $        iact(i,1,nrc)
 1600         format(12x,e12.5,12x,e12.5,12x,i2)
              read (ninpts,1620,err=990) eact(i,1,nrc),hact(i,1,nrc)
 1620         format(12x,e12.5,12x,e12.5)
              read (ninpts,1650,err=990) ndact(i,1,nrc),
     $        csigma(i,1,nrc)
 1650         format(12x,i2,22x,e12.5)
c
              if (ndact(i,1,nrc) .gt. ndctmx) then
                write (nttyo,1655) ureac(nrc),i,ndctmx
 1655           format(/' * Error - (XCON6/rd6w7) Have too many',
     $          /7x,'species in the activity product in term ',i2,
     $          /7x,'of the forward direction rate law for reactant',
     $          /7x,'"',a24,'". The code is only dimensioned for ',i3,
     $          /7x,'such species. Reduce the number of such species',
     $          /7x,'or increase the dimensioning parameter ndctpa.')
                go to 990
              endif
c
              if (ndact(i,1,nrc) .gt. 0) then
                do 210 n = 1,ndact(i,1,nrc)
                  read (ninpts,1670,err=990) udac(n,i,1,nrc),
     $            cdac(n,i,1,nrc)
 1670             format(12x,a8,16x,e12.5)
  210           continue
              endif
  220       continue
          elseif (nrk(1,nrc) .eq. 3) then
            imech(1,nrc) = 1
            if (imech(1,nrc) .gt. imchmx) then
              write (nttyo,1550) ureac(nrc),imchmx
              go to 990
            endif
c
            i = 1
            read (ninpts,1600,err=990) rk0(i,1,nrc),trk0(i,1,nrc),
     $      iact(i,1,nrc)
            read (ninpts,1620,err=990) eact(i,1,nrc),hact(i,1,nrc)
          elseif (nrk(1,nrc) .eq. 4) then
            read (ninpts,1580,err=990) imech(1,nrc)
c
            if (imech(1,nrc) .gt. imchmx) then
              write (nttyo,1550) ureac(nrc),imchmx
              go to 990
            endif
c
            do 240 i = 1,imech(1,nrc)
              read (ninpts,1600,err=990) rk0(i,1,nrc),trk0(i,1,nrc),
     $        iact(i,1,nrc)
              read (ninpts,1620,err=990) eact(i,1,nrc),hact(i,1,nrc)
              read (ninpts,1650,err=990) ndact(i,1,nrc)
c
              if (ndact(i,1,nrc) .gt. ndctmx) then
                write (nttyo,1655) ureac(nrc),i,ndctmx
                go to 990
              endif
c
              if (ndact(i,1,nrc) .gt. 0) then
                do 230 n = 1,ndact(i,1,nrc)
                  read (ninpts,1670,err=990) udac(n,i,1,nrc),
     $            cdac(n,i,1,nrc)
  230           continue
              endif
  240       continue
          endif
c
c         Rate law parameters, backward direction.
c
          if (nrk(2,nrc) .eq. 1) then
            imech(2,nrc) = 3
c
            if (imech(2,nrc) .gt. imchmx) then
              write (nttyo,1673) ureac(nrc),imchmx
 1673         format(/' * Error - (XCON6/rd6w7) Have too many rate',
     $        /7x,'constants in the backward direction rate law for',
     $        /7x,'reactant "',a24,'". The code is only',
     $        /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $        /7x,'Reduce the number of rate constants or increase the',
     $        /7x,'dimensioning parameter imchpa.')
              go to 990
            endif
c
            read (ninpts,1560,err=990) (rk0(j,2,nrc), j = 1,3)
          elseif (nrk(2,nrc) .eq. 2) then
            read (ninpts,1580,err=990) imech(2,nrc)
c
            if (imech(2,nrc) .gt. imchmx) then
              write (nttyo,1673) ureac(nrc),imchmx
              go to 990
            endif
c
            do 260 i = 1,imech(2,nrc)
              read (ninpts,1600,err=990) rk0(i,2,nrc),trk0(i,2,nrc),
     $        iact(i,2,nrc)
              read (ninpts,1620,err=990) eact(i,2,nrc),hact(i,2,nrc)
              read (ninpts,1650,err=990) ndact(i,2,nrc),csigma(i,2,nrc)
c
              if (ndact(i,2,nrc) .gt. ndctmx) then
                write (nttyo,1675) ureac(nrc),i,ndctmx
 1675           format(/' * Error - (XCON6/rd6w7) Have too many',
     $          /7x,'species in the activity product in term ',i2,
     $          /7x,'of the backward direction rate law for reactant',
     $          /7x,'"',a24,'". The code is only dimensioned for ',i3,
     $          /7x,'such species. Reduce the number of such species',
     $          /7x,'or increase the dimensioning parameter ndctpa.')
                go to 990
              endif
c
              if (ndact(i,2,nrc) .gt. 0) then
                do 250 n = 1,ndact(i,2,nrc)
                  read (ninpts,1670,err=990) udac(n,i,2,nrc),
     $            cdac(n,i,2,nrc)
  250           continue
              endif
  260       continue
          elseif (nrk(2,nrc) .eq. 3) then
            imech(2,nrc) = 1
            if (imech(2,nrc) .gt. imchmx) then
              write (nttyo,1673) ureac(nrc),imchmx
              go to 990
            endif
c
            i = 1
            read (ninpts,1600,err=990) rk0(i,2,nrc),trk0(i,2,nrc),
     $      iact(i,2,nrc)
            read (ninpts,1620,err=990) eact(i,2,nrc),hact(i,2,nrc)
          elseif (nrk(2,nrc) .eq. 4) then
            read (ninpts,1580,err=990) imech(2,nrc)
c
            if (imech(2,nrc) .gt. imchmx) then
              write (nttyo,1673) ureac(nrc),imchmx
              go to 990
            endif
c
            do 280 i = 1,imech(2,nrc)
              read (ninpts,1600,err=990) rk0(i,2,nrc),trk0(i,2,nrc),
     $        iact(i,2,nrc)
              read (ninpts,1620,err=990) eact(i,2,nrc),hact(i,2,nrc)
              read (ninpts,1650,err=990) ndact(i,2,nrc)
c
              if (ndact(i,2,nrc) .gt. ndctmx) then
                write (nttyo,1675) ureac(nrc),i,ndctmx
                go to 990
              endif
c
              if (ndact(i,2,nrc) .gt. 0) then
                do 270 n = 1,ndact(i,2,nrc)
                  read (ninpts,1670,err=990) udac(n,i,2,nrc),
     $            cdac(n,i,2,nrc)
  270           continue
              endif
  280       continue
          endif
  390   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Dump interval.
c
      read (ninpts,2000,err=990) dlzidp
 2000 format(3(12x,e12.5))
c
c     Tolerances.
c
      read (ninpts,2020,err=990) tolbt,toldl,tolx,tolsat,tolsst
 2020 format(3(12x,e12.5))
c
c     Setscrew parameters.
c     Note: sscrew(1) = screw1, etc.
c
      read (ninpts,2040,err=990) (sscrew(i), i = 1,6)
 2040 format(3(12x,e12.5))
c
c     Z parameters.
c
      read (ninpts,2060,err=990) zklogu,zklogl,zkfac
 2060 format(3(12x,e12.5))
c
c     Step size limits and maximum order.
c
      read (ninpts,2080,err=990) dlzmx1,dlzmx2,nordlm
 2080 format (2(12x,e12.5),12x,i2)
c
c     Maximum number of iterations and maximum number of phase
c     assemblage tries.
c
      read (ninpts,2100,err=990) itermx,ntrymx
 2100 format(12x,i2,22x,i2)
c
c     Slide and scan control parameters.
c
      read (ninpts,2120,err=990) npslmx,nsslmx,ioscan
 2120 format(12x,i2,22x,i2,22x,i2)
c
c-----------------------------------------------------------------------
c
c     Process the bottom half of the current output file.
c
c     Secondary title.
c
      do 400 n = 1,ntitmx
        read (ninpts,3000,err=990) uline
 3000   format(a80)
        if (uline(1:8) .eq. uendit(1:8)) go to 410
        utitl2(n) = uline
  400 continue
      n = n + 1
c
      read (ninpts,1100,err=990) uline
      call locase(uline)
      j = index(uline,'tempci=')
      if (j .gt. 0) then
        backspace(ninpts)
      else
        write (nttyo,3002) ntitmx
 3002   format(/' * Error - (XCON6/rd6w7) Have too many lines in the',
     $  /7x,'secondary title. The code is only dimensioned for ',i4,
     $  /7x,'lines. Reduce the size of the title or increase the',
     $  /7x,'dimensioning parameter ntitpa.')
        go to 990
      endif
c
  410 ntitl2 = n - 1
c
c-----------------------------------------------------------------------
c
c     Original temperature.
c
      read (ninpts,3010,err=990) tempci
 3010 format(12x,e12.5)
c
c-----------------------------------------------------------------------
c
c     Number of nxmod options.
c
      read (ninpts,3030,err=990) nxmod
 3030 format(12x,i2)
c
      if (nxmod .gt. nxmdmx) then
        write (nttyo,3035) nxmdmx
 3035   format(/' * Error - (XCON6/rd6w7) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  ' options',/7x,'or increase the dimensioning parameter',
     $  ' nxmdpa.')
        go to 990
      endif
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      if (nxmod .gt. 0) then
        do 420 n = 1,nxmod
          read (ninpts,3050,err=990) uxmd24(n),jxmod(n),kxmod(n),
     $    xlkmod(n)
 3050     format(12x,a24,/12x,i2,22x,i2,22x,e12.5)
  420   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      read (ninpts,3070,err=990) (iopg(i), i = 1,10)
 3070 format (12x,i2,22x,i2,22x,i2)
c
c-----------------------------------------------------------------------
c
c     Index limits.
c
      read (ninpts,3090,err=990) kct,ksq,kmt,kxt,kdim,kprs
 3090 format(3(12x,i2,10x),/3(12x,i2,10x))
c
      if (kct .gt. nctmax) then
        write (nttyo,3095) nctmax
 3095   format(/' * Error - (XCON6/rd6w7) Have too many chemical',
     $  /7x,'elements present. The code is only dimensioned',
     $  /7x,'for ',i3,' elements. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      if (kdim .gt. kmax) then
        write (nttyo,3100) kmax
 3100   format(/' * Error - (XCON6/rd6w7) Have too many master',
     $  /7x,'variables. The code is only dimensioned for ',i3,
     $  /7x,'master variables. Reduce the number of such variables',
     $  /7x,'or increase the dimensioning parameter kpar.')
        go to 990
      endif
c
c-----------------------------------------------------------------------
c
c     Balance totals.
c
      do 430 kc = 1,kct
        read (ninpts,3120,err=990) uelemb(kc),mteb(kc),mteaqb(kc)
 3120   format(3x,a8,7x,e25.15,3x,e25.15)
  430 continue
      read (ninpts,3140,err=990) ux,electr
 3140 format(3x,a8,7x,e25.15)
c
c-----------------------------------------------------------------------
c
c     Basis variable data.
c
      do 440 kcol = 1,kdim
        read (ninpts,3160,err=990) unrms(kcol),undms(kcol),zvclgi(kcol)
 3160   format(3x,a18,1x,a18,1x,e25.15)
  440 continue
c
c-----------------------------------------------------------------------
c
c     Physically removed system data.
c
      nprmn = 0
      nprmx = 0
      if (kprs .gt. 0) then
c
        do 450 n = 1,nprsmx
          read (ninpts,3180,err=990) ux,xx
 3180     format(3x,a18,1x,e25.15)
          if (ux(1:8) .eq. uendit(1:8)) go to 460
          nprmn = nprmn + 1
c
          if (nprmn .gt. nprsmx) then
            write (nttyo,3190) nprsmx
 3190       format(/' * Error - (XCON6/rd6w7) Have too many mineral',
     $      /7x,'species in the physically removed system. The code is',
     $      /7x,'only dimensioned for ',i3,' such species. Reduce the',
     $      /7x,'number of such species or increase the dimensioning',
     $      /7x,'parameter nprspa.')
            go to 990
          endif
c
          uprs(nprmn)(1:24) = ux
          uprs(nprmn)(25:48) = ux
          mprs(nprmn) = xx
  450   continue
  460   continue
c
        nprmx = nprmn
        do 480 n = 1,nprsmx
          read (ninpts,3200,err=990) ux
 3200     format(3x,a24)
          if (ux(1:8) .eq. uendit(1:8)) go to 490
          do 470 i = 1,iktmax + 1
            read (ninpts,3220,err=990) uxx,xx
 3220       format(3x,a18,1x,e25.15)
            if (uxx(1:8) .eq. uendit(1:8)) go to 480
            nprmx = nprmx + 1
c
            if (nprmn .gt. nprsmx) then
              write (nttyo,3190) nprsmx
              go to 990
            endif
c
            uprs(nprmx)(1:24) = ux
            uprs(nprmx)(25:48) = uxx
            mprs(nprmx) = xx
  470     continue
  480   continue
  490   continue
      endif
c
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine ncmpvh(acflg,act,actlg,cdrs,cgxj,jflag,
     $ jsflag,losp,mosp,mtxj,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,nrr1,nrr2,nstmax,xbar,xbarlg,xlks)
c
c     This subroutine calculates part of the "expansion" of the basis
c     set description regarding a site of a generic ion exchange
c     phase. It assists EQLIB/ncmpve.h. The part of the expansion
c     performed here does not take into account the need for an
c     iterative process to complete the actual expansion; rather, it
c     calculates a tentative part of the expansion. The iterative
c     process is required (at least in the general case, for example
c     Na+ for Ca++ following the Vanselow exchange model) because
c     mtxj (the sum of the number of moles of the species on the site)
c     is known only approximately at the start of the expansion process.
c     This subroutine uses a tentative value of mtxj as an input.
c
c     This subroutine is called by:
c
c       EQLIB/ncmpvh.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of logarithms of activity coefficients
c       actlg  = array of logarithms of species activities
c                  (input consists of valid results for aqueous
c                  basis species; output consists of the same
c                  for exchanger species belonging to Vanselow
c                  exchanger phases)
c       cdrs   = array of reaction coefficients
c       mosp   = array of numbers of moles of species
c                  (input contains valid results for basis species
c                  and carry-over values for non-basis species)
c       mtxj   = the sum of the number of moles of exchanger species
c                  in the current site of the current generic ion
c                  exchange phase
c       ndrs   = array parallel to cdrs giving the index of the
c                  corresponding species
c       ndrsr  = array giving the range in the cdrs/ndrs arrays
c                  corresonding to the reaction associated with a
c                  given species
c       nrr1   = the start of the species index range for the
c                  current site of the current ion exchange phase
c       nrr2   = the end of the species index range for the
c                  current site of the current ion exchange phase
c       xlks   = array of equilibrium constants
c
c     Principal output:
c
c       act    = array of species activities
c                  (output consists of the subset for exchanger
c                  species belonging to Vanselow exchanger phases)
c       actlg  = array of logarithms of species activities
c       mosp   = array of numbers of moles of species
c                  (output consists of valid results for non-basis
c                  species; valid results for basis species were
c                  input and are retained)
c       losp   = array of logarithms of numbers of moles of species
c       xbar   = array of mole fractions of species
c       xbarlg = array of logarithms of mole fractions of species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer jflag(nstmax),jsflag(nstmax),nbasp(nbtmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax)
c
      integer nbt,nrr1,nrr2
c
      real*8 acflg(nstmax),act(nstmax),actlg(nstmax),cdrs(ndrsmx),
     $ losp(nstmax),mosp(nstmax),xbar(nstmax),xbarlg(nstmax),
     $ xlks(nstmax)
c
      real*8 cgxj,mtxj
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nb,nr1,nr2,ns,nss
c
      integer nbasis
c
      real*8 cxs,lax,lx,lxx,mx,xx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Estimate the mole fractions and activities of the
c     basis species for the current site.
c
      do ns = nrr1,nrr2
        nb = nbasis(nbasp,nbt,nbtmax,ns)
        if (nb.gt.0 .and. jsflag(ns).le.0) then
          xx = mosp(ns)/mtxj
          xbar(ns) = xx
          lxx = tlg(xx)
          xbarlg(ns) = lxx
          lax = cgxj*(lxx + acflg(ns))
          actlg(ns) = lax
          act(ns) = texp(lax)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Estimate the mole fractions and activities of the
c     non-basis species for the current site.
c
      do ns = nrr1,nrr2
        if (jflag(ns).eq.30 .and. jsflag(ns).le.0) then
c
c         Calculate the activities and mole fractions for
c         the exchanger species not in the basis set.
c
          nr1 = ndrsr(1,ns)
          nr2 = ndrsr(2,ns)
          cxs = cdrs(nr1)
          lax = -xlks(ns)
          do n = nr1 + 1,nr2
            nss = ndrs(n)
            lax = lax + cdrs(n)*actlg(nss)
          enddo
          lax = -lax/cxs
          actlg(ns) = lax
          act(ns) = texp(lax)
          lxx = (lax/cgxj) - acflg(ns)
          xbarlg(ns) = lxx
          xx = texp(lxx)
          xbar(ns) = xx
c
c         Also calculate the corresponding numbers of moles.
c
          mx = xx*mtxj
          lx = tlg(mx)
          mosp(ns) = mx
          losp(ns) = lx
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine chzrsr(cbsr,elecsr,eps100,jcode,nbasp,nbt,nbtmax,
     $ nbt1mx,noutpt,nrct,nrctmx,nrndex,nsrtmx,nstmax,nttyo,ureac,
     $ uspec,zchar)
c
c     This subroutine checks the reactions for special reactants to
c     ensure that they satisfy charge balance. Reactions made by
c     EQ6/makrsr.f should satisfy this condition, but reactions
c     composed by the user may not. All reactions are checked by this
c     subroutine. All special reactants are presumed to be uncharged.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jcode  = flag array denoting the types of reactants
c       nbasp  = array of indices of species in the basis set
c       nbt    = the number of basis species
c       nbtmax = the maximum number of basis species
c       nbt1mx = the maximum number of basis species plus 1
c       nrctmx = the maximum number of reactants
c       nsrtmx = the maximum number of special reactants
c       ureac  = array of names of reactants
c       uspec  = array of names of species
c       zchar  = array of electrical charges of species
c
c     Principal output:
c
c       cbsr   = array of coefficients for reactions for special
c                  reactants
c       elecsr = array of electrical imbalances of reactions for
c                  special reactants
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nbt1mx,nrctmx,nsrtmx,nstmax
c
      integer noutpt,nttyo
c
      integer jcode(nrctmx),nbasp(nbtmax),nrndex(nrctmx)
      integer nbt,nrct
c
      character*48 uspec(nstmax)
      character*24 ureac(nrctmx)
c
      real*8 cbsr(nbt1mx,nsrtmx),elecsr(nsrtmx),zchar(nstmax)
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nf
c
      integer j2,nb,nrc,ns,nsr
c
      integer ilnobl
c
      logical qprrsr
c
      character*24 ux24
c
      real*8 acx,aztx,tlersr,ztx
c
c-----------------------------------------------------------------------
c
      tlersr = nbt*eps100
c
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 2) then
          nsr = nrndex(nrc)
          ztx = 0.
          aztx = 0.
          do nb = 1,nbt
            ns = nbasp(nb)
            ztx = ztx + cbsr(nb,nsr)*zchar(ns)
            aztx = aztx + cbsr(nb,nsr)*abs(zchar(ns))
          enddo
          elecsr(nsr) = ztx
c
          qprrsr = .false.
          if (abs(ztx) .gt. tlersr) then
            acx = abs(ztx/aztx)
            if (acx .gt. 1.e-6) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1000) ureac(nrc)(1:j2)
              write (nttyo,1000) ureac(nrc)(1:j2)
 1000         format(/' * Warning - (EQ6/chzrsr) The reaction for the',
     $        ' special reactant',/7x,a," isn't well charge balanced.",
     $        /7x,'The reaction is:',/)
              qprrsr = .true.
            elseif (acx .gt. 1.e-10) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1010) ureac(nrc)(1:j2)
              write (nttyo,1010) ureac(nrc)(1:j2)
 1010         format(/' * Warning - (EQ6/chzrsr) The reaction for the',
     $        ' special reactant',/7x,a," isn't charge balanced to",
     $        ' high precision.',/7x,'The reaction is:',/)
              qprrsr = .true.
            endif
          endif
c
          if (qprrsr) then
            nf = noutpt
c
c           Calling sequence substitutions:
c             nbasp for nbaspd
c             nbt for nbtd
c
            call prrsr(cbsr,jcode,nbasp,nbt,nbtmax,nbt1mx,
     $      nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $      ureac,uspec)
c
c           Calling sequence substitutions:
c             nbasp for nbaspd
c             nbt for nbtd
c
            nf = nttyo
            call prrsr(cbsr,jcode,nbasp,nbt,nbtmax,nbt1mx,
     $      nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $      ureac,uspec)
c
            ux24 = ' '
            write (ux24,'(1pe12.5)') ztx
            j2 = ilnobl(ux24)
            write (noutpt,1050) ux24(1:j2)
            write (nttyo,1050) ux24(1:j2)
 1050       format(/7x,'The imbalance is ',a,'. This will be factored',
     $      ' into the computed',/7x,'charge balance a a compensating',
     $      ' offset. The offset at any point',/7x,'will be',
     $      ' proportional to the extent of reaction. The pH and',
     $      /7x,'redox will be properly calculated, as they are',
     $      ' computed entirely',/7x,'from mass balance relations for',
     $      ' the data file basis species.',/7x,'This version of EQ6',
     $      ' does not compute any of these properties using',
     $      /7x,'the charge balance equation.')
          endif
        endif
      enddo
c
      end

      subroutine gfdhc(adh,bt,fdhc,fdhcp,fdhcpp,fxi)
c
c     This subroutine computes the Debye-Huckel function f and its
c     derivatives with respect to ionic strength for the case of the
c     Debye-Huckel-charging (DHC) model.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       adh    = the Debye-Huckel A(gamma) parameter
c       bt     = product of Debye-Huckel B and the hard core diameter
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c
c     Output:
c
c       fdhc   = Debye-Huckel function f (DHC model)
c       fdhcp  = f' (df/dI)
c       fdhcpp = f'' (d2f/dI2)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      real*8 adh,bt,fdhc,fdhcp,fdhcpp,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 fxisqt,vx,vxp1
c
c-----------------------------------------------------------------------
c
      fxisqt = sqrt(fxi)
      vx = bt*fxisqt
      vxp1 = vx + 1.
c
      fdhc = -6.*adh*(vx*(vx-2.) + 2.*log(vxp1))/(bt**3)
      fdhcp = -6.*adh*fxisqt/vxp1
      fdhcpp = -3.*adh/(fxisqt*vxp1*vxp1)
c
      end

      subroutine gibasp(cgexj,cjbasp,iern1,ixbasp,jern1,jern2,
     $ jetmax,jgext,narn1,narn2,nbasp,nbt,nbtmax,nern1,nern2,
     $ netmax,nphasx,nstmax)
c
c     This subroutine sets up the ixbasp and cjbasp arrays. The former
c     is a flag array, each member of which denotes whether the
c     thermodynamic activity of the corresponding basis species is
c     defined in terms of molality (= 0) or mole fraction (= 1). The
c     cjbasp array contains any site stoichiometric factor associated
c     with a given basis species. If there is no such factor, then
c     an element of cjbasp may be assigned a value of unity.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ3NR/arrset.f
c       EQ6/eqphas.f
c       EQ6/eqshel.f
c       EQ6/optmzr.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cgexj  = array of site stoichiometric factors for generic ion
c                  exchanger species
c       jgext  = array giving the number of sites for a generic ion
c                  exchanger species.
c       nbasp  = array containing the species indices of the basis
c                  species
c       nbt    = the number of basis species
c       nphasx = array giving the phase to which a species belongs
c
c     Principal output:
c
c       cjbasp = array of site stoichiometric factors corresponding to
c                  sites occupied by basis species, if any
c       ixbasp = array of flag switches indicating whether the
c                  thermodynamic activity of a basis species is based
c                  on molality (= 0) or mole fraction (= 1)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jetmax,nbtmax,netmax,nstmax
c
      integer ixbasp(nbtmax),jern1(jetmax,netmax),jern2(jetmax,netmax),
     $ jgext(netmax),nbasp(nbtmax),nphasx(nstmax)
c
      integer iern1,narn1,narn2,nbt,nern1,nern2
c
      real*8 cjbasp(nbtmax),cgexj(jetmax,netmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer je,nb,ne,np,nrr1,nrr2,ns,nss
c
c-----------------------------------------------------------------------
c
      do nb = 1,nbt
        ixbasp(nb) = 0
        cjbasp(nb) = 1.0
c
        ns = nbasp(nb)
        if (ns .eq. narn1) then
          ixbasp(nb) = 1
        elseif (ns.ge.nern1 .and. ns.le.nern2) then
          np = nphasx(ns)
          ne = np - iern1 + 1
          ixbasp(nb) = 1
          do je = 1,jgext(ne)
            nrr1 = jern1(je,ne)
            nrr2 = jern2(je,ne)
            do nss = nrr1,nrr2
              if (ns .eq. nss) then
                cjbasp(nb) = cgexj(je,ne)
              endif
            enddo
          enddo
        endif
      enddo
c
  999 continue
      end

      subroutine multav(array1,nmax,avalue,array2)
c
c     This subroutine multiplies the first nmax elements of the real*8
c     array array1 by the real*8 value avalue. The result is placed
c     in the real*8 array array2. Normally, nmax would be the dimension
c     of both arrays. However, nmax could be less than the true
c     dimension. Also, the arrays could actually have more than one
c     dimension. For example, if array1 and array2 are really a and b,
c     respectively, having common dimensions of i1 and i2, this
c     subroutine could be used by calling it in the following manner:
c     call multav(a,(i1*i2),avalue,b). Use this subroutine with caution
c     if the two arrays do not have identical dimensioning or nmax is
c     not the product of the true (declared) dimensions.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array1 = the first array
c       nmax   = dimension or pseudo-dimension of array1 and array2
c       avalue = the value by which to multipy array1
c
c     Output:
c
c       array2 = the second array, the product of avalue and array1
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array1(nmax),array2(nmax)
c
      real*8 avalue
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      real*8 av
c
c-----------------------------------------------------------------------
c
c     Note the assignment of the value to a local variable.
c     Note also that the loop is unrolled.
c
      av = avalue
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        array2(i) = av*array1(i)
        array2(i + 1) = av*array1(i + 1)
        array2(i + 2) = av*array1(i + 2)
        array2(i + 3) = av*array1(i + 3)
        array2(i + 4) = av*array1(i + 4)
        array2(i + 5) = av*array1(i + 5)
        array2(i + 6) = av*array1(i + 6)
        array2(i + 7) = av*array1(i + 7)
      enddo
c
      do i = ileft + 1,nmax
        array2(i) = av*array1(i)
      enddo
c
      end

      subroutine initaz(array,nmax)
c
c     This subroutine initializes the real*8 array "array" to zero over
c     the first nmax positions. Normally, nmax would be the dimension
c     of the 1D "array". However, nmax could be less than the true
c     dimension. Also, array could actually have more than one
c     dimension. For example, if the array is really b, which has
c     dimensions of i1 and i2, this subroutine could be used by calling
c     it in the following manner: call initaz(b,(i1*i2)). Use this
c     subroutine with caution if the two arrays do not have identical
c     dimensioning or nmax is not the product of the true (declared)
c     dimensions.
c
c     To initialize a real*8 array to a non-zero value, use
c     EQLIBU/initav.f instead.
c
c     NOTE: It may be more efficient to just initialize the array
c     to zero in a DO loop in the calling subroutine.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       array  = the array
c       nmax   = dimension or pseudo-dimension of array
c
c     Output:
c
c       array  = array, with the first nmax positions set to zero
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 array(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i
c
c-----------------------------------------------------------------------
c
c     Caution: efficiency may be best served by not unrolling the
c     following loop.
c
      do i = 1,nmax
        array(i) = 0.0
      enddo
c
      end

      subroutine flgset(axlksd,iopt,jflag,jpflag,jsflag,kxmod,narn1a,
     $ narn2a,narxmx,nbaspd,nbtd,nbtmax,ncmpra,ncta,ndrsd,ndrsmx,
     $ ndrsrd,noptmx,noutpt,npta,nptmax,nrdxsp,nsta,nstmax,ntpr,
     $ ntprmx,nttyo,nxmdmx,nxmod,uphasa,uptypa,uspeca,uxmod)
c
c     This subroutine sets up the status arrays jpflag and jsflag.
c     These flags denote the statuses, respectively, of phases
c     and species. The relevant values and their meanings are
c     as follows:
c
c        jpflag:
c          = 0   The species is present or potentially present
c          = 1   The physical presence of the phase in the model
c                  is suppressed; associated variables, such as a
c                  reaction affinity, may be calculated
c          = 2   The phase is completely ignored by the code
c
c        jsflag:
c          = 0   The species is present or potentially present
c          = 1   The physical presence of the species in the model
c                  is suppressed; associated variables, such as a
c                  reaction affinity, may be calculated
c          = 2   The species is completely ignored by the code
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       jpflag = phase status flag array
c       jsflag = species status flag array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,nbtmax,ndrsmx,noptmx,nptmax,nstmax,ntprmx,nxmdmx
c
      integer noutpt,nttyo
c
      integer iopt(noptmx),jflag(nstmax),jpflag(nptmax),
     $ jsflag(nstmax),kxmod(nxmdmx),nbaspd(nbtmax),ncmpra(2,nptmax),
     $ ndrsd(ndrsmx),ndrsrd(2,nstmax)
c
      integer narn1a,narn2a,nbtd,ncta,npta,nrdxsp,nsta,ntpr,nxmod
c
      character(len=48) uspeca(nstmax),uxmod(nxmdmx)
      character(len=24) uphasa(nptmax),uptypa(nptmax)
c
      real(8) axlksd(narxmx,ntprmx,nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,n,nb,ncount,nn,np,nr1,nr2,ns,nse,nss,nt
c
      integer nbasis
c
      logical qheadr
c
      character(len=56) uspn56
      character(len=24) uptsld,uptliq,ux24,uy24
c
c-----------------------------------------------------------------------
c
      data uptsld /'Solid                   '/
      data uptliq /'Liquid                  '/
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that uptliq is not used.
c     are not used.
c
      ux24 = uptliq
      uy24 = ux24
      uptliq = uy24
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the jsflag and jpflag arrays.
c
      do ns = 1,nsta
        jsflag(ns) = 0
      enddo
      do np = 1,npta
        jpflag(np) = 0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set jsflag to 2 if jflag = -1 for a species. If not, if the
c     species is an active dependent species, set jsflag to 2 if
c     jsflag = -1 for any other species appearing in its reaction.
c
      do ns = 1,nsta
        nr1 = ndrsrd(1,ns)
        nr2 = ndrsrd(2,ns)
        nt = nr2 - nr1 + 1
        if (jflag(ns) .eq. -1) then
          jsflag(ns) = 2
        elseif (ns.lt.narn1a .or. ns.gt.narn2a
     $    .or. jflag(ns) .eq. 30) then
          if (nt .ge. 2) then
            do n = nr1,nr2
              nss = ndrsd(n)
              if (jflag(nss) .eq. -1) then
                jsflag(ns) = 2
                go to 130
              endif
            enddo
          endif
        endif
  130   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now provide an exception to the above. Scan auxiliary basis
c     species with jflag .le. 1 and ensure that any basis species that
c     they are linked to do not have jsflag = 2. If so, reset jsflag
c     to 1. Do this recursively, to ensure that no species is skipped.
c     The idea here is to keep these strict basis species in the
c     compressed species set produced by EQLIB\cmpdat.f, so that the
c     one-to-one association with a chemical element is preserved.
c
      nn = max(ncta + 1,nrdxsp + 1)
      qheadr = .true.
  140 ncount = 0
      do nb = nn,nbtd
        ns = nbaspd(nb)
        if (jsflag(ns) .le. 1) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          do n = nr1,nr2
            nse = ndrsd(n)
            if (jsflag(nse) .ge. 2) then
              jsflag(nse) = 1
              ncount = ncount + 1
              if (qheadr) then
                write (noutpt,1000)
                write (nttyo,1000)
 1000           format(/' Preserving the following basis species',
     $          ' in the model',/' to maintain linkage to strict',
     $          ' basis species associated',/' one-to-one with',
     $          ' active chemical elements:',/)
              endif
              qheadr = .false.
c
c             Calling sequence substitutions:
c               uspeca(nse) for unam48
c
              call fmspnx(jlen,uspeca(nse),uspn56)
c
              write (noutpt,1010) uspn56(1:jlen)
              write (nttyo,1010) uspn56(1:jlen)
 1010         format('   ',a)
            endif
          enddo
        endif
      enddo
      if (ncount .gt. 0) go to 140
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set jsflag to 2 if there exist no log K data in the current
c     temperature range, unless the species happens to be in the
c     basis set.
c
      do ns = 1,nsta
        if (axlksd(1,ntpr,ns) .ge. 9999999.) then
c
c         Calling sequence substitutions:
c           nbaspd for nbasp
c           nbtd for nbt
c
          nb = nbasis(nbaspd,nbtd,nbtmax,ns)
          if (nb .eq. 0) jsflag(ns) = 2
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute the nxmod suppression options.
c
      call supprs(kxmod,jpflag,jsflag,ncmpra,noutpt,npta,nptmax,
     $ nsta,nstmax,nttyo,nxmdmx,nxmod,uphasa,uspeca,uxmod)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Suppress any phase with zero species.
c
      do np = 1,npta
        nt = ncmpra(2,np) - ncmpra(1,np) + 1
        if (nt .le. 0) jpflag(np) = 2
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Exercise the option to hard suppress all solid solutions.
c
      if (iopt(4) .le. 0) then
        do np = 1,npta
          if (uptypa(np)(1:24) .eq. uptsld(1:24)) then
            nr1 = ncmpra(1,np)
            nr2 = ncmpra(2,np)
            nt = nr2 - nr1 + 1
            if (nt .ge. 2) then
              jpflag(np) = 2
              do ns = nr1,nr2
                jsflag(ns) = 2
              enddo
            endif
          endif
        enddo
      endif
c
      end

      subroutine timdat(udate,utime)
c
c     This subroutine gets the date and clock time in ASCII for time and
c     date stamping on output files. The variable "udate" is returned in
c     the form "ddMmmccyy" (e.g., 23Sep1997) under Fortran 90, in the
c     form 'ddMmmyy" (e.g., 23Sep97) under Fortran 77. The variable
c     "utime" is returned in the form "hh:mm:ss:hs", though in some
c     cases the hundred-th second part ("hs") may be blank.
c
c     See also EQLIBU/initim.f and EQLIBU/runtim.f.
c
c     This subroutine is called by:
c
c       EQLIBU/initim.f
c       EQLIBU/runtim.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       udate  = string containing the date
c       utime  = string containing the clock time
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*11 utime
      character*9 udate
c
c-----------------------------------------------------------------------
c
        integer values(8)
c
        character*8 date
        character*10 time
        character*6 zone
        character*8 ux
        character*8 umonth(12)
c
        integer mo,mm
c
        data (umonth(mo), mo = 1,12) /'Jan','Feb','Mar','Apr','May',
     $  'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/
c
c-----------------------------------------------------------------------
c
c       Note: date_and_time is a Fortran 90 intrinsic subroutine.
c
        call date_and_time(date,time,zone,values)
c
c       Note: date has the form ccyymmdd; udate has the form ddMmmccyy.
c
        udate(1:2) = date(7:8)
        ux = date(5:6)
        read (ux,'(i5)') mm
        udate(3:5) = umonth(mm)(1:3)
        udate(6:9) = date(1:4)
c
c       Note: time has the form hhmmss.sss (sss = milliseconds);
c       utime has the form hh:mm:ss:hs.
c
        utime(1:2) = time(1:2)
        utime(3:3) = ':'
        utime(4:5) = time(3:4)
        utime(6:6) = ':'
        utime(7:8) = time(5:6)
        utime(9:9) = ':'
        utime(10:11) = time(8:9)
c
c       The following is nonsense intended to keep the compiler from
c       complaining that zone and values are not used.
c
        ux = zone
        mm = values(1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine prcndi(noutpt,nttyo)
c
c     This subroutine writes legal statements and disclaimers to the
c     output and screen files.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = the unit number of the output file
c       nttyo  = the unit number of the screen file
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
c     Write notice of applicable statements and disclaimers.
c
      write (noutpt,1000)
      write (nttyo,1000)
 1000 format(' This work is subject to additional statements and',
     $ /' disclaimers which may be found in the README.txt file',
     $ /' included in the EQ3/6 software transmittal package.',//)
c
c     Write additional copyright notice paragraph.
c
c     write (noutpt,1010)
c     write (nttyo,1010)
c
 1010 format(' This work was produced at the University of California,',
     $ /' Lawrence Livermore National Laboratory (UC LLNL) under',
     $ /' contract no. W-7405-ENG-48 between the U.S. Department of',
     $ /' Energy (DOE) and The Regents of the University of California',
     $ /' (University) for the operation of UC LLNL. Copyright is',
     $ /' reserved to the University for purposes of controlled',
     $ /' dissemination, commercialization through formal licensing,',
     $ /' or other disposition under terms of Contract 48; DOE',
     $ /' policies, regulations, and orders; and U.S. statutes.',//)
c
c     Write standard LLNL disclaimer.
c
c     write (noutpt,1020)
c     write (nttyo,1020)
c
 1020 format(24x,'DISCLAIMER',//
     $ ' This computer code was prepared as an account of work',
     $ /' sponsored by an agency of the United States Government.',
     $ /' Neither the United States Government nor the University of',
     $ /' California nor any of their employees, makes any warranty,',
     $ /' express or implied, or assumes any liability or responsi-',
     $ /' bility for the accuracy, completeness, or usefulness of any',
     $ /' information, apparatus, product, or process disclosed, or',
     $ /' represents that its use would not infringe privately-owned',
     $ /' rights. Reference herein to any specific commercial,',
     $ /' product, process, or service by trade name, trademark,',
     $ /' manufacturer, or otherwise, does not necessarily constitute',
     $ /' or imply its endorsement, recommendation, or favoring by the',
     $ /' United States Government or the University of California.',
     $ /' The views and opinions of authors expressed herein do not',
     $ /' necessarily state or reflect those of the United States',
     $ /' government or the University of California, and shall not',
     $ /' be used for advertising or product endorsement purposes.'//)
c
      end

      subroutine gegexw(cegexs,egexpc,egexpa,egexw,iern1,iern2,
     $ ietmax,jern1,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $ mosp,netmax,ngexsa,ngext,noutpt,nptmax,nstmax,nttyo,
     $ xgexw,zchar)
c
c     This subroutine computes the apparent "whole-phase" equivalent
c     fractions (egexw) and mole fractions (xgexw) of the exchange
c     ions present in generic ion exchanger phases. The exchange
c     fractions are calculated separately for cations and anions.
c     For example, the exchange fraction of a cation is the number
c     of equivalents of that cation divided by the sum of the
c     equivalents of all cations in the same exchange phase. The
c     mole fractions are calculated in similar fashion.
c
c     Subroutine EQLIB/gegexs.f computes the equivalent fractions
c     (egexs) and mole ratios (mrgexs) of exchanger species (moles
c     of exchanger species per mole of exchanger phase). Those
c     equivalent fractions are defined for individual sites.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       moph   = array of numbers of moles of phases
c       mosp   = array of numbers of moles of species
c
c     Principal output:
c
c       egexw  = array of apparent "whole-phase" equivalent fractions,
c                  for exchange ions
c       egexpc = array of apparent cationic exchange capacities
c       egexpa = array of apparent anionic exchange capacities
c       xgexw  = array of apparent "whole-phase" mole fractions,
c                  for exchange ions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,ketmax,netmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jgext(netmax),kern1(netmax),
     $ kern2(netmax),kgexsa(ketmax,netmax),ngext(jetmax,netmax),
     $ ngexsa(ietmax,jetmax,netmax)
c
      integer iern1,iern2
c
      real*8 cegexs(ietmax,jetmax,netmax),egexpa(netmax),
     $ egexpc(netmax),egexw(ketmax,netmax),moph(nptmax),mosp(nstmax),
     $ xgexw(ketmax,netmax),zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,je,ke,ne,np,ns,nss
c
      real*8 ex,expac,expcc,mx,mxpac,mxpcc,zx
c
c-----------------------------------------------------------------------
c
c     Compute the apparent "whole-phase" equivalent fractions (egexw)
c     and mole fractions (xgexw) for the exchange species in generic
c     ion exchangers. Note that for a cationic exchange species
c     (e.g., Na+), this equivalent fraction is defined as the total
c     number of equivalents of the species on the exchanger (in all
c     sites, regardless of charge) divided by the sum of the total
c     number of equivalents of all such cationic species (expcc).
c     For an anionic species, this equivalent fraction is defined
c     analogously (expac being analogous to expcc). The formally
c     declared exchange capacities for the sites and the phases are
c     not used here.
c
      do np = iern1,iern2
        ne = np - iern1 + 1
c
c       Loop on exchanging species (e.g., Na+). Get the total
c       number of equivalents of each such species on the phase
c       by summing over contributions from all sites.
c
        do ke = kern1(ne),kern2(ne)
          egexw(ke,ne) = 0.
          nss = kgexsa(ke,ne)
          if (nss .gt. 0) then
c
c           Loop on sites.
c
            do je = 1,jgext(ne)
              ns = jern1(je,ne) - 1
c
c             Loop on exchanger species (e.g., Na-Z).
c
              do ie = 1,ngext(je,ne)
                ns = ns + 1
                if (nss .eq. ngexsa(ie,je,ne)) then
c
c                 The current exchanger species (e.g., Na-Z) is
c                 comprised of the current exchanging species
c                 (e.g., Na+).
c
                  ex = mosp(ns)*cegexs(ie,je,ne)
                  egexw(ke,ne) = egexw(ke,ne) + ex
                endif
              enddo
            enddo
          endif
        enddo
c
c       Get the apparent cationic and anionic "whole-phase" exchange
c       capacities (egexpc and egexpa, respectively).
c
        expcc = 0.
        expac= 0.
c
        do ke = kern1(ne),kern2(ne)
          nss = kgexsa(ke,ne)
          if (nss .gt. 0) then
            ex = egexw(ke,ne)
            if (ex .gt. 0.) then
              expcc = expcc + ex
            elseif (ex .lt. 0.) then
              expac = expac + ex
            endif
          endif
        enddo
        egexpc(ne) = expcc/moph(np)
        egexpa(ne) = expac/moph(np)
c
c       Calculate the number of moles of exchange ions in the exchange
c       phase from the corresponding number of equivalents. Get the
c       total number of moles of exchange cations (mxpcc) and of
c       exchange anions (mxpac).
c
        mxpcc = 0.
        mxpac= 0.
c
        do ke = kern1(ne),kern2(ne)
          nss = kgexsa(ke,ne)
          if (nss .gt. 0) then
            zx = zchar(nss)
            if (zx .ne. 0.) then
              mx = egexw(ke,ne)/zx
            else
              mx = 0.
            endif
            xgexw(ke,ne) = mx
            if (ex .gt. 0.) then
              mxpcc = mxpcc + mx
            elseif (ex .lt. 0.) then
              mxpac = mxpac + mx
            endif
          endif
        enddo
c
c       Loop on exchanging species (e.g., Na+). This time calculate
c       the apparent "whole-phase" equivalent fractions.
c
        do ke = kern1(ne),kern2(ne)
          nss = kgexsa(ke,ne)
          if (nss .gt. 0) then
            ex = egexw(ke,ne)
            if (ex .gt. 0.) then
              egexw(ke,ne) = ex/expcc
            elseif (ex .lt. 0.) then
              egexw(ke,ne) = ex/expac
            endif
          endif
        enddo
c
c       Loop on exchanging species (e.g., Na+). This time calculate
c       the apparent "whole-phase" mole fractions.
c
        do ke = kern1(ne),kern2(ne)
          nss = kgexsa(ke,ne)
          if (nss .gt. 0) then
            zx = zchar(nss)
            mx = xgexw(ke,ne)
            if (zx .gt. 0.) then
              xgexw(ke,ne) = mx/mxpcc
            elseif (zx .lt. 0.) then
              xgexw(ke,ne) = mx/mxpac
            endif
          endif
        enddo
c
      enddo
c
      end

      subroutine intieb(iebal,iebal3,ier,jsflag,nbasp,nbt,nbtmax,noutpt,
     $ nstmax,nttyo,uebal,uspec,zchar)
c
c     This subroutine finds the basis index (iebal) of the species to be
c     adjusted for electrical balance, if any.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer jsflag(nstmax),nbasp(nbtmax)
      integer iebal,iebal3,ier,nbt,noutpt,nttyo
c
      character*48 uspec(nstmax)
      character*24 uebal
c
      real(8) zchar(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nb,nebal,ns
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     if iebal3 is 0 or iebal = 1 but uebal is 'none' or blank, do no
c     electrical balancing.
c
      iebal = 0
      if (iebal3 .le. 0) uebal(1:24) = 'None'
      if (uebal(1:8) .eq. '        ') uebal(1:24) = 'None'
      if (uebal(1:8) .eq. 'none    ') uebal(1:24) = 'None'
      if (uebal(1:8) .eq. 'NONE    ') uebal(1:24) = 'None'
      if (uebal(1:5) .eq. 'None ') go to 999
c
      j2 = ilnobl(uebal)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the basis index of the species specified on the input file.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        if (uebal(1:24).eq.uspec(ns)(1:24)) then
          iebal = nb
          nebal = ns
          go to 100
        endif
      enddo
c
      write (noutpt,1000) uebal(1:j2)
      write (nttyo,1000) uebal(1:j2)
 1000 format(/' * Error - (EQ3NR/intieb) The input file specifies',
     $ /7x,'that the concentration of ',a,' is to be adjusted',
     $ /7x,'to achieve electrical balance. However, this species',
     $ /7x,"isn't in the basis set.")
      ier = 1
  100 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the specified ion to see if it is okay.
c
c     Does the ion selected for electrical balancing have charge?
c
      if (zchar(nebal) .eq. 0.) then
        write (noutpt,1010) uebal(1:j2)
        write (nttyo,1010) uebal(1:j2)
 1010   format(/' * Warning - (EQ3NR/intieb) The input file specifies',
     $  /7x,'that the concentration of ',a,' is to be adjusted',
     $  /7x,'to achieve electrical balance. However, this species',
     $  /7x,"doesn't have an electrical charge. The success of this",
     $  /7x,'calculation will depend on the concentration adjustment',
     $  /7x,'influencing the concentration of one or more charged',
     $  /7x,'dependent species.')
      endif
c
c     Is the ion selected for electrical balancing in the model?
c
      if (jsflag(nebal) .gt. 0) then
        write (noutpt,1020) uebal(1:j2)
        write (nttyo,1020) uebal(1:j2)
 1020   format(/' * Error - (EQ3NR/intieb) The input file specifies',
     $  /7x,'that the concentration of ',a,' is to be adjusted',
     $  /7x,'to achieve electrical balance. However, this species',
     $  /7x,"is effectively suppressed and thus can't be present",
     $  /7x,'in the model.')
        ier = 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine runtim(iexec0,jexec0,texec0,noutpt,nttyo,trun,
     $ tuser,tcpu,udate1,utime1)
c
c     This subroutine gets the time and date at the end of execution,
c     and also the run, user, and cpu times. The user and cpu times
c     are not defined on all machines. In such cases, zero values are
c     returned. In order to use this subroutine, EQLIBU/initim.f must
c     be called at the start of execution to get values for iexec0,
c     jexec0, and texec0. This routine should be called at the end of
c     execution.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       iexec0 = day of the year at the start of execution
c       jexec0 = the last two digits of the year at the start of
c                  execution
c       texec0 = time at the start of execution, since midnight,
c                in seconds
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Output:
c
c       tcpu   = cpu time, in seconds
c       trun   = run time, in seconds
c       tuser  = user time, in seconds
c       udate1 = the date at the end of execution
c       utime1 = the time at the end of execution
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer iexec0,jexec0
c
      character*11 utime1
      character*9 udate1
c
      real*8 texec0,trun,tuser,tcpu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ndays(12)
c
      integer idays,iexec1,iy,jexec1,mo,mm,dd,yy,hr,hs,mi,se
      integer j2,j3
c
      integer ilnobl
c
      logical qleapy
c
      character*8 umonth(12)
      character*8 ux
      character*3 um
c
      real*8 texec1
c
c-----------------------------------------------------------------------
c
com   BEGIN_UNIX_DEPENDENT_CODE (Optional)
com
c       real*4 timear(2),tx
com
c       real*8 etime
com
c       external etime
com
com   END_UNIX_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
      data (umonth(mo), mo = 1,12) /'Jan','Feb','Mar','Apr','May',
     $ 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/
c
      data ndays(1) /31/
      data (ndays(mo), mo = 3,12) /31,30,31,30,31,31,30,31,30,31/
c
c-----------------------------------------------------------------------
c
c     Get the time and date.
c
c     Calling sequence substitutions:
c       udate1 for udate
c       utime1 for utime
c
      call timdat(udate1,utime1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the data needed to calculate the actual run time.
c
      ux = udate1(1:2)
      read (ux,1000,err=900) dd
 1000 format(i2)
c
      um = udate1(3:5)
      do mo = 1,12
        if (umonth(mo)(1:3) .eq. um(1:3)) then
          mm = mo
          go to 110
        endif
      enddo
c
      j2 = ilnobl(um)
      j3 = ilnobl(udate1)
      write (noutpt,1010) um(1:j2),udate1(1:j3)
      write (nttyo,1010) um(1:j2),udate1(1:j3)
 1010 format(/' * Error - (EQLIBU/runtim) The string "',a,'"',
     $ " doesn't match the standard",/7x,'abbreviation for any',
     $ ' month. This was extracted from the string "',a,'",',
     $ /7x,'which should contain the date at the end of',
     $ ' execution. Check',/7x,'porting modifications in',
     $ ' EQLIBU/timdat.f.')
      stop
c
  110 if (udate1(8:9) .ne. '  ') then
        ux = udate1(6:9)
        read (ux,1020,err=900) yy
 1020   format(i4)
      else
        ux = udate1(6:7)
        read (ux,1000,err=900) yy
      endif
c
      ux = utime1(1:2)
      read (ux,1000,err=910) hr
c
      ux = utime1(4:5)
      read (ux,1000,err=910) mi
c
      ux = utime1(7:8)
      read (ux,1000,err=910) se
c
      ux = utime1(10:11)
      read (ux,1000,err=910) hs
c
      texec1 = hr*3600. + mi*60. + se*1. + hs*0.01
c
c     Get the number of days in February of the current year.
c
      ndays(2) = 28
      call tleapy(yy,qleapy)
      if (qleapy) ndays(2) = 29
c
      iexec1 = dd
      if (mm .gt. 1) then
        do mo = 1, mm - 1
          iexec1 = iexec1 + ndays(mo)
        enddo
      endif
      jexec1 = yy
c
      idays = iexec1 - iexec0
      if (jexec1 .gt. jexec0) then
        do iy = jexec0, jexec1 - 1
          idays = idays + 365
          if (mod(iy,4) .eq. 4) then
            if (mod(iy,100) .ne. 0) then
              idays = idays + 1
            endif
          endif
        enddo
      endif
      trun = idays*86400. + (texec1 - texec0)
c
c     Normally, actual values are not returned for the user and cpu
c     times. These times are not defined on all systems. The user time
c     is usually not useful. The cpu time gives an idea of how much
c     time a code is actually carrying out calculations, as opposed to
c     executing other functions such as I/O.
c
      tuser = 0.
      tcpu = 0.
c
com   BEGIN_UNIX_DEPENDENT_CODE (Optional)
com
com     Activate this block only if you have a UNIX system and want
com     to obtain the user and cpu times on the output files.
com
com     Note: the variable declarations in the corresponding block
com     above must be activated in order to successfully activate
com     the present block.
com
com     The subroutine ETIME called below is a UNIX subroutine that
com     gets the elapsed user and cpu times, returning the former in
com     TIMEAR(1), the latter in TIMEAR(2). The array TIMEAR is real*4.
com     On some systems, the name of this subroutine may be "ETIME_"
com     instead of "ETIME".
com
c       tx = etime(timear)
c       tuser = timear(1)
c       tcpu = timear(2)
com
com     Note: the following statement doesn't really do anything except
com     cause the compiler not to complain that tx is not used.
com
c       timear(1) = tx
com
com   END_UNIX_DEPENDENT_CODE
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  900 j3 = ilnobl(udate1)
      write (noutpt,1030) udate1(1:j3)
      write (nttyo,1030) udate1(1:j3)
 1030 format(/' * Error - (EQLIBU/runtim) The date at the end of',
     $ ' execution (udate1)'/7x,'must be a string in the format "',
     $ 'ddMmmccyy" (e.g., 23Sep1997) or',/7x,'"ddmmyy", (e.g.,',
     $ ' 23Sep97). The actual string "',a,'"'," isn't",/7x,'in',
     $ ' compliance with this requirement. Check porting',
     $ ' modifications.',/7x,'in EQLIBU/timdat.f.')
      stop
c
  910 j3 = ilnobl(utime1)
      write (noutpt,1040) utime1(1:j3)
      write (nttyo,1040) utime1(1:j3)
 1040 format(/' * Error - (EQLIBU/runtim) The time at the end of',
     $ ' execution (utime1)'/7x,'must be a string in the format "',
     $ 'hh:mm:ss:hs" (e.g., 15:32:19:28).',7x,'The actual string "',
     $ a,'"'," isn't in compliance with this requirement.",
     $ /7x, 'Check porting modifications in EQLIBU/timdat.f.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine nssock(nerr,noutpt,nttyo,nxt,nxtmax,ussoph)
c
c     Check the names of solid solutions for uniqueness.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ussoph = array containing the names of solid solutions
c
c     Principal output:
c
c       nerr   = incremented error counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer nxtmax
c
      integer nxt,nerr
c
      character(len=24) ussoph(nxtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 unam
      character*8 ux8
c
      integer i,ilist,j,j2,j3,k,ncount
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Note: ilist = the number of solid solutions with duplicate
c     phase blocks present on the data file.
c
      ilist = 0
c
c     Check each name for uniqueness.
c
      do i = 1,nxt
        unam = ussoph(i)
        ncount = 1
        if (unam(1:7) .ne. '<blank>') then
          do j = i + 1,nxt
            if (unam(1:24) .eq. ussoph(j)(1:24)) then
c
c             Have found a duplicate block moving down the list from
c             the block now being tested for uniqueness. For the first
c             such duplicate block only, make sure that there is not a
c             duplicate block moving up the list from the block now
c             being tested. If there is such a block, then the
c             duplication in question has been noted previously and
c             should not be noted again.
c
              if (ncount .eq. 1) then
                do k = 1,i - 1
                  if (unam(1:24) .eq. ussoph(k)(1:24)) then
c
c                   Have found a duplicate block preceding the block
c                   now being tested for uniqueness.
c
                    go to 100
                  endif
                enddo
              endif
c
c             Have found a duplication that has not been previously
c             noted.
c
              ncount = ncount + 1
            endif
          enddo
  100     continue
        endif
c
        if (ncount .gt. 1) then
c
c         Have a duplicate block or blocks.
c
          ilist = ilist + 1
c
          if (ilist .eq. 1) then
c
c           Write error message header.
c
            write (noutpt,1000)
            write (nttyo,1000)
 1000       format(/' * Error - (EQPT/nssock) The following solid',
     $      ' solutions have multiple',/7x,'phase blocks:',/)
          endif
c
          write (ux8,'(i5)') ncount
          call lejust(ux8)
          j3 = ilnobl(ux8)
          j2 = ilnobl(unam)
          write (noutpt,1010) unam(1:j2),ux8(1:j3)
          write (nttyo,1010) unam(1:j2),ux8(1:j3)
 1010     format(9x,a,' has ',a,' blocks')
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nerr = nerr + ilist
c
      end

      subroutine flgchk(jpflag,jsflag,ncmpra,npta,nptmax,nstmax,qclnsa)
c
c     This subroutine recalculates the jpflag array to insure
c     consistency with the jsflag array. The jpflag value of a phase
c     can't be lower than the lowest value of any of the species which
c     comprise that phase. For example, if all of the species of
c     a phase are not present (jsflag = 2), the phase can not be
c     present (jpflag = 2). Also, if a solution phase (one with more
c     than one component species) has only one species that is active
c     (jsflag .lt. 2) and that species was created by cloning, the
c     solution phase is purged (jpflag is set to 2). This subroutine
c     should be called after calling other subroutines which may purge
c     or suppress species. EQLIB/flgset.f is an example of such.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jpflag = array of status flags for phases
c       jsflag = array of status flags for species
c       ncmpra = array giving the range of indices of species
c                  belonging to a given phase ('a' data set)
c       npta   = the number of phaes in the 'a' data set.
c       qclnsa = array of logical flags indicating if a species was
c                  created by cloning.
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nptmax,nstmax
c
      integer jpflag(nptmax),jsflag(nstmax),ncmpra(2,nptmax)
      integer npta
c
      logical qclnsa(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ijs0,ijs1,jsflmn,njs0,npa,nr1,nr2,nsa,nt
c
c-----------------------------------------------------------------------
c
      do npa = 1,npta
      if (jpflag(npa) .lt. 2) then
        nr1 = ncmpra(1,npa)
        nr2 = ncmpra(2,npa)
        jsflmn = 2
        do nsa = nr1,nr2
          jsflmn = min(jsflag(nsa),jsflmn)
        enddo
        jpflag(npa) = max(jpflag(npa),jsflmn)
      endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do npa = 1,npta
        if (jpflag(npa) .lt. 2) then
          nr1 = ncmpra(1,npa)
          nr2 = ncmpra(2,npa)
          nt = nr2 - nr1 + 1
          if (nt .ge. 2) then
c
c           Note the following local variables:
c
c             njs0 = counter for non-cloned species with jsflag = 0
c             ijs0 = counter for cloned and non-cloned species with
c                    jsflag = 0
c             ijs1 = counter for cloned and non-cloned species with
c                    jsflag = 1
c
            njs0 = 0
            ijs1 = 0
            ijs0 = 0
            do nsa = nr1,nr2
              if (jsflag(nsa) .eq. 0) then
                ijs0 = ijs0 + 1
                if (.not.qclnsa(nsa)) njs0 = njs0 + 1
              elseif (jsflag(nsa) .eq. 1) then
                ijs1 = ijs1 + 1
              endif
            enddo
            if (njs0.le.0 .and. ijs0.lt.2) then
              jpflag(npa) = 1
              if (ijs1 .le. 0) jpflag(npa) = 2
            endif
          endif
        endif
      enddo
c
      end

      subroutine echgex(axlks,cdrs,cgexj,iern1,iern2,jern1,jern2,
     $ jetmax,jgext,jpflag,jsflag,narxmx,narxt,ndrs,ndrsmx,ndrsr,
     $ netmax,noutpt,nptmax,ntprmx,ntprt,nstmax,press,tempc,ugexj,
     $ ugexmo,uphase,uspec,xlks)
c
c     This subroutine echoes a table for the generic ion exchangers,
c     describing the setup of species, reactions, and corresponding
c     thermodynamic data.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       noutpt = unit number of the output file
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jetmax,narxmx,ndrsmx,netmax,nptmax,ntprmx,nstmax
c
      integer noutpt
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax),
     $ jpflag(nptmax),jsflag(nstmax),narxt(ntprmx),ndrs(ndrsmx),
     $ ndrsr(2,nstmax)
c
      integer iern1,iern2,ntprt
c
      integer ilnobl
c
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 axlks(narxmx,ntprmx,nstmax),cdrs(ndrsmx),
     $ cgexj(jetmax,netmax),xlks(nstmax)
c
      real*8 press,tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,je,j3,j4,j5,ne,np,nr1,nr2,ns,nt
c
c-----------------------------------------------------------------------
c
      if (iern2 .lt. iern1) go to 999
c
      write (noutpt,1000)
 1000 format(/11x,' --- Generic Ion Exchange Phase Setup ---',/)
      write (noutpt,1010) tempc,press
 1010 format(6x,'Log K data, etc., are for ',f10.3,'C and ',g12.5,
     $ ' bars',/)
c
      do np = iern1,iern2
        ne = np - iern1 + 1
        j5 = ilnobl(ugexmo(ne))
        j4 = ilnobl(uphase(np))
        if (jpflag(np) .le. 0) then
          write (noutpt,1020) uphase(np)(1:j4)
 1020     format(/16x,'--- ',a,' ---')
        else
          write (noutpt,1030) uphase(np)(1:j4)
 1030     format(/16x,'--- ',a,' (Suppressed) ---')
        endif
        write (noutpt,1040) ugexmo(ne)(1:j5)
 1040   format(/11x,'Model type= ',a)
        do je = 1,jgext(ne)
          j3 = ilnobl(ugexj(je,ne))
          write (noutpt,1050) ugexj(je,ne)(1:j3)
 1050     format(/11x,'--- ',a,' ---',/)
          write (noutpt,1060) cgexj(je,ne)
 1060     format(6x,'Site stoichiometric factor N= ',1pg12.5,/)
          do ns = jern1(je,ne),jern2(je,ne)
c
c           Calling sequence substitutions:
c             noutpt for nf
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns,nstmax,uspec)
c
            nr1 = ndrsr(1,ns)
            nr2 = ndrsr(2,ns)
            nt = nr2 - nr1 + 1
            if (nt .gt. 1) then
              if (jsflag(ns) .le. 0) then
                write (noutpt,1070) xlks(ns)
 1070           format(/5x,'Log K= ',f12.4)
                do j = 1,ntprt
                  write (noutpt,1100) j
 1100             format(/7x,'Coefficients for temperature range ',i2,
     $            ':')
                  write (noutpt,1110) (axlks(i,j,ns), i = 1,narxt(j))
 1110             format( (4x,5(2x,g13.6)) )
                enddo
                write (noutpt,1150)
 1150           format(1x)
              else
                write (noutpt,1170)
 1170           format(2x,'Suppressed',/)
              endif
            endif
          enddo
        enddo
      enddo
c
  999 continue
      end

      subroutine rscaly(avxmax,avy,avys,eps100,nmax)
c
c     This subroutine rescales the elements in the avys array. The
c     results are placed in the avy array. This subroutine is normally
c     used in conjunction with EQLIBU/scalx1.f and EQLIBU/polfit.f
c     to fitting interpolating polynomials to data in which avx
c     contains values of the independent variable, avxs contains
c     values of the independent variable scaled to the interval
c     (-1,1), avys contains values of the dependent variable as
c     fit with the independent variable scaled, and avy contains
c     values of the dependent variable corrected (rescaled) for
c     scaling of the in dependent variable.
c
c     This subroutine is called by:
c
c       EQPT/intrp.f
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       avys   = array whose contents are to be rescaled
c       avxmax = the max norm of avx
c       n      = the number of elements in avys
c
c     Output:
c
c       avy    = array whose contents are rescaled
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      real*8 avy(nmax),avys(nmax)
      real*8 avxmax,eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i
c
      real*8 ax,ay
c
c-----------------------------------------------------------------------
c
c     Note- nmax is expected to be relatively small. Therefore, loop
c     unrolling or calling of subroutines which employ loop unrolling
c     is not used here.
c
c     Test avxmax.
c
      ax = avxmax - 1.0
      if (abs(ax) .le. eps100) then
        do i = 1,nmax
          avy(i) = avys(i)
        enddo
        go to 999
      endif
c
c     Rescale the array.
c
      ay = 1.
      avy(1) = avys(1)
      do i = 2,nmax
        ay = ay/avxmax
        avy(i) = avys(i)*ay
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine srch22(jpair,unam1,unam2,upair,npx2mx,npx2t)
c
c     This subroutine searches for the species pair corresponding
c     to unam1, unam2 or unam2, unam1 in the upair array, and returns
c     the index jpair of that pair in that aray. The variable jpair
c     is returned as 0 if no match is found.
c
c     This suboutine is called by:
c
c       EQPT/tprca.f
c       EQPT/tprn2.f
c       EQPT/tprnn.f
c       EQPT/tprnc.f
c       EQPT/tprna.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       npx2t  = number of species pairs in the upair array
c       unam1  = the name of the first aqueous species in a pair
c       unam2  = the name of the second aqueous species in a pair
c       upair  = array containing the names of species in a pair
c
c     Principal output:
c
c       jpair  = the index of the pair unam1, unam2 or unam2, unam1 in
c                  the upair array, if that pair is present; else 0
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer npx2mx
c
      integer jpair,npx2t
c
      character*24 unam1,unam2
      character*24 upair(2,npx2mx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j
c
c-----------------------------------------------------------------------
c
c     Search the upair array for an element matching (unam1, unam2).
c
      do j = 1,npx2t
        if (unam1(1:24) .eq. upair(1,j)(1:24)) then
c
c         Look for unam2 in the matching position in the upair array.
c
          if (unam2(1:24) .eq. upair(2,j)(1:24)) then
            jpair = j
            go to 999
          endif
        endif
      enddo
c
c     Search the upair array for an element matching (unam2, unam1).
c
      do j = 1,npx2t
        if (unam2(1:24) .eq. upair(1,j)(1:24)) then
c
c         Look for unam1 in the matching position in the upair array.
c
          if (unam1(1:24) .eq. upair(2,j)(1:24)) then
            jpair = j
            go to 999
          endif
        endif
      enddo
c
c     Did not find the pair in the upair array.
c
      jpair = 0
c
  999 continue
      end

      subroutine cdappl(acflg,acfw,acfwlg,actlg,actw,actwlg,adwipp,
     $ afcnst,affpd,affsd,ah,ahrc,alk,alk1,alk2,alki,atwt,bdwipp,
     $ cdrsd,cess,conc,csts,ctb,cteaq,dvoso,dwoso,eh,ehfac,ehrc,
     $ eps100,farad,fdpe0,fdse0,fjest,fo2lg,fo2lrc,fxist,iaqsln,
     $ iemop0,iemos0,iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,
     $ imrn2,iopt,ixrn1,ixrn2,jcode,jcsort,jern1,jflag,jflagd,
     $ jgext,jpflag,jsflag,jssort,modr,moph,mophg,mophj,mopht,morr,
     $ mosp,mospg,mospj,mospt,mprph,mprsp,mrgers,mrmlra,mtb,
     $ mtbaq,mte,mteaq,mwtges,mwtrc,mwtsp,narn1,narn2,nat,nbasp,
     $ nbaspd,nbt,nchlor,ncmpe0,ncmpr,nct,ndrsd,ndrsrd,nelect,
     $ nern1,nern2,nert,ness,nessr,net,nfrn1,nfrn2,ngext,ngrn1,
     $ ngrn2,ngt,nhydr,nlrn1,nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,no2gaq,
     $ npchk,npet,npet0,npt,npts,nrct,nrndex,nst,nsts,nstsr,ntf1,
     $ ntf1t,ntf2,ntf2t,nxridx,nxrn1,nxrn2,nxrt,nxt,osc,oscst,
     $ omega,pe,perc,ph,phmes,ppmwb,ppmwe,qriinf,qxknph,rreacn,
     $ rreac1,rxbar,sfcar,sidrsp,sidrph,sigmam,sigmst,tdays,tempc,
     $ tf1,tf2,thours,time1,tmins,tyears,uphase,uspec,vodrt,voph,
     $ vophg,vophj,vopht,vosoct,vosp,vospg,vospj,vospt,vosp0,
     $ vreac,wfh2o,wkgwi,wodr,wodrt,woph,wophg,wophj,wopht,
     $ worr,worrt,wosoct,wosp,wospg,wospj,wospt,xbar,xlke,
     $ xlksd,zchcu6,zchsq2)
c
c     This subroutine computes various data pertaining to the modeled
c     system for printing and plotting at the current point of
c     reaction progress (xi1).
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iemop0(npetmx),iemos0(nsetmx),iopt(noptmx),
     $ jcode(nrctmx),jcsort(nstmax),jern1(jetmax,netmax),
     $ jflag(nstmax),jflagd(nstmax),jgext(netmax),jpflag(nptmax),
     $ jsflag(nstmax),jssort(nstmax),nbasp(nbtmax),nbaspd(nbtmax),
     $ ncmpe0(2,npetmx),ncmpr(2,nptmax),ndrsd(ndrsmx),ndrsrd(2,nstmax),
     $ ness(nessmx),nessr(2,nstmax),ngext(jetmax,netmax),npchk(nptmax),
     $ nrndex(nrctmx),nsts(nstsmx),nstsr(2,nstmax),ntf1(ntf1mx),
     $ ntf2(ntf2mx),nxridx(nrctmx)
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer nat,nbt,nct,net,nlt,nmt,nst,npt,ngt,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer iaqsln,nchlor,nelect,nert,nhydr,nmrt,no2gaq,npet,npet0,
     $ npts,nrct,ntf1t,ntf2t,nxrt
c
      logical qxknph(nptmax)
c
      logical qriinf
c
      character(len=48) uspec(nstmax)
      character(len=24) uphase(nptmax)
c
      real*8 acflg(nstmax),actlg(nstmax),affpd(nptmax),affsd(nstmax),
     $ ahrc(nbtmax),atwt(nctmax),cdrsd(ndrsmx),cess(nessmx),
     $ conc(nstmax),csts(nstsmx),ctb(nbtmax),cteaq(nctmax),ehrc(nbtmax),
     $ fdpe0(nordmx,npetmx),fdse0(nordmx,nsetmx),fo2lrc(nbtmax)
c
      real*8 modr(nrctmx),moph(nptmax),mophg(nptmax),mophj(nptmax),
     $ mopht(nptmax),morr(nrctmx),mosp(nstmax),mospg(nstmax),
     $ mospj(nstmax),mospt(nstmax),mprph(nptmax),mprsp(nstmax),
     $ mrgers(ietmax,jetmax,nertmx),mtb(nbtmax),mtbaq(nbtmax),
     $ mte(nctmax),mteaq(nctmax),mwtges(netmax),mwtrc(nrctmx),
     $ mwtsp(nstmax)
c
      real*8 perc(nbtmax),ppmwb(nbtmax),ppmwe(nctmax),
     $ rreacn(nrctmx),rreac1(nrctmx),rxbar(iktmax,nxrtmx),
     $ sfcar(nrctmx),sidrph(nptmax),sidrsp(nstmax),tf1(ntf1mx),
     $ tf2(ntf2mx),voph(nptmax),vophg(nptmax),vophj(nptmax),
     $ vopht(nptmax),vosp(nstmax),vospg(nstmax),vospj(nstmax),
     $ vospt(nstmax),vosp0(nstmax),vreac(nrctmx),wodr(nrctmx),
     $ woph(nptmax),wophg(nptmax),wophj(nptmax),wopht(nptmax),
     $ worr(nrctmx),wosp(nstmax),wospg(nstmax),wospj(nstmax),
     $ wospt(nstmax),xbar(nstmax),xlksd(nstmax),zchcu6(nstmax),
     $ zchsq2(nstmax)
c
      real*8 acfw,acfwlg,actw,actwlg,adwipp,afcnst,ah,alk,alki,
     $ alk1,alk2,bdwipp,dvoso,dwoso,eh,ehfac,eps100,farad,fjest,
     $ fo2lg,fxist,mrmlra,osc,oscst,omega,pe,ph,phmes,sigmam,
     $ sigmst,tdays,tempc,thours,time1,tmins,tyears,vosoct,vodrt,
     $ wfh2o,wkgwi,wosoct,wodrt,worrt,xlke
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,je,ik,n,nb,nc,ne,ner,np,npe,np1,ns,nse,nrc,nr1,nr2,
     $ nss,nxr
c
      logical qrct
c
      real*8 mophx,mospx,osfac,vophx,vospx,wophx,wospx
c
      real*8 texp,tlg
c
c-----------------------------------------------------------------------
c
c     Compute the model time in various units.
c
      if (iopt(2) .ge. 1) then
        if (qriinf) then
          tmins = 1.e+38
          thours = 1.e+38
          tdays = 1.e+38
          tyears = 1.e+38
        else
          tmins = time1/60.
          thours = tmins/60.
          tdays = thours/24.
          tyears = tdays/365.25
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute some data for reactants and corresponding reactions.
c
      vodrt = 0.
      wodrt = 0.
      worrt = 0.
c
      do nrc = 1,nrct
        worr(nrc) = mwtrc(nrc)*morr(nrc)
        wodr(nrc) = mwtrc(nrc)*modr(nrc)
        worrt = worrt + worr(nrc)
        wodrt = wodrt + wodr(nrc)
        vodrt = vodrt + modr(nrc)*vreac(nrc)
      enddo
c
      if (iopt(2) .ge. 1) then
        do nrc = 1,nrct
          rreacn(nrc) = 0.
          if (sfcar(nrc) .gt. 0.) rreacn(nrc) = rreac1(nrc)/sfcar(nrc)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute data for a summary of the elemental composition of the
c     aqueous phase.
c
      call initaz(mte,nctmax)
      call initaz(mteaq,nctmax)
c
      do nss = 1,nst
        ns = jssort(nss)
        if (mosp(ns) .gt. 0.) then
          nr1 = nessr(1,ns)
          nr2 = nessr(2,ns)
          do n = nr1,nr2
            nc = ness(n)
            if (nc .gt. 0) mte(nc) = mte(nc) + cess(n)*mosp(ns)
          enddo
        endif
      enddo
c
      do nss = narn1,narn2
        ns = jcsort(nss)
        if (ns .ne. no2gaq) then
          nr1 = nessr(1,ns)
          nr2 = nessr(2,ns)
          do n = nr1,nr2
            nc = ness(n)
            if (nc .gt. 0) mteaq(nc) = mteaq(nc) + cess(n)*mosp(ns)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the elemental composition of the aqueous solution
c     (molalities and ppm: mg/kg.sol).
c
      call initaz(cteaq,nctmax)
      call initaz(ppmwe,nctmax)
c
      do nc = 1,nct
        cteaq(nc) = wkgwi*mteaq(nc)
        ppmwe(nc) = 1000.*cteaq(nc)*atwt(nc)*wfh2o
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the mass and concentration totals in the aqueous phase
c     in terms of data file basis species.
c
      call initaz(mtbaq,nbtmax)
      call initaz(ctb,nbtmax)
      call initaz(ppmwb,nbtmax)
c
      do nss = narn1,narn2
        ns = jcsort(nss)
        if (mosp(ns) .ne. 0.) then
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            mtbaq(nb) = mtbaq(nb) + csts(n)*mosp(ns)
          enddo
        endif
      enddo
c
      do nb = 1,nbt
        ctb(nb) = wkgwi*mtbaq(nb)
        ns = nbaspd(nb)
        ppmwb(nb) = 1000.*ctb(nb)*mwtsp(ns)*wfh2o
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute various aqueous phase parameters.
c
      acfwlg = acflg(narn1)
      acfw = texp(acfwlg)
c
c     Compute the sum of the stoichiometric molalities.
c
      sigmst = 0.
      do nb = 1,nbt
        ns = nbaspd(nb)
c
c       The 'abs' comes into play below only when ns = nhydr or nhydx
c       and the value is negative (e.g., a negative ctb for H+ is
c       interpreted as a positive value for OH-).
c
        if (ns.ne.no2gaq .and. ns.ne.narn1)
     $  sigmst = sigmst + abs(ctb(nb))
      enddo
c
c     Compute the true and stoichiometric osmotic coefficients.
c
      osfac = -omega * log(actw)
      osc = 0.
      if (sigmam .gt. eps100) osc = osfac/sigmam
      oscst = 0.
      if (sigmst .gt. eps100) oscst = osfac/sigmst
c
c     Compute the stoichiometric ionic strength.
c
c     Calling sequence substitution:
c       fxist for fxistc
c
      call cfxist(ctb,fxist,nbaspd,nbt,nbtmax,nstmax,zchsq2)
c
c     Compute the stoichiometric ionic asymmetry.
c
c     Calling sequence substitution:
c       fjest for fjestc
c
      call cfjest(ctb,fjest,nbaspd,nbt,nbtmax,nstmax,zchcu6)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute alkalinity parameters.
c
c     Compute the HCO3-CO3-OH total alkalinity.
c
c     Calling sequence substitutions:
c       alk1 for alkc
c       ntf1 for ntfx
c       ntf1mx for ntfxmx
c       ntf1t for ntfxt
c       tf1 for tfx
c
      call calk(alk1,conc,nstmax,ntf1,ntf1mx,ntf1t,tf1)
c
c     Compute the extended total alkalinity.
c
c     Calling sequence substitutions:
c       alk2 for alkc
c       ntf2 for ntfx
c       ntf2mx for ntfxmx
c       ntf2t for ntfxt
c       tf2 for tfx
c
      call calk(alk2,conc,nstmax,ntf2,ntf2mx,ntf2t,tf2)
c
      alki = 0.
      alk = alk2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute data for redox reactions that are not constrained to be
c     at equilibrium.
c
      call cdardx(actlg,actwlg,ah,ahrc,cdrsd,eh,ehfac,ehrc,
     $ farad,fo2lg,fo2lrc,jsflag,mosp,nbasp,nbaspd,nbt,nbtmax,ndrsd,
     $ ndrsmx,ndrsrd,no2gaq,nstmax,pe,perc,ph,xlke,xlksd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate affinities and saturation indices using the 'd' set
c     of reactions.
c
      call gaffsd(actlg,afcnst,affpd,affsd,cdrsd,jflagd,jpflag,
     $ ncmpr,ndrsd,ndrsmx,ndrsrd,npt,nptmax,nst,nstmax,qxknph,sidrph,
     $ sidrsp,uphase,uspec,xbar,xlksd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      vosoct = 0.
      wosoct = 0.
c
      call initaz(voph,nptmax)
      call initaz(woph,nptmax)
      call initaz(vosp,nstmax)
      call initaz(wosp,nstmax)
c
      call initaz(mopht,nptmax)
      call initaz(vopht,nptmax)
      call initaz(wopht,nptmax)
      call initaz(mospt,nstmax)
      call initaz(vospt,nstmax)
      call initaz(wospt,nstmax)
c
      call initaz(mophg,nptmax)
      call initaz(vophg,nptmax)
      call initaz(wophg,nptmax)
      call initaz(mospg,nstmax)
      call initaz(vospg,nstmax)
      call initaz(wospg,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1).eq.0 .or. iopt(1).eq.1) then
c
c       Compute data which describe the solid phases in the ES.
c
        if (npet .gt. 1) then
          do np = 1,npt
            if (np .ne. iaqsln) then
              if (npchk(np).eq.0 .and. jpflag(np).eq.-1) then
                nr1 = ncmpr(1,np)
                nr2 = ncmpr(2,np)
                vophx = 0.
                wophx = 0.
                do ns = nr1,nr2
                  wospx = mosp(ns)*mwtsp(ns)
                  wosp(ns) = wospx
                  wophx = wophx + wospx
                  vospx = mosp(ns)*vosp0(ns)
                  vosp(ns) = vospx
                  vophx = vophx + vospx
                enddo
                if (np.ge.iern1 .and. np.le.iern2) then
                  ne = np - iern1 + 1
                  wophx = wophx + moph(np)*mwtges(ne)
                endif
                woph(np) = wophx
                voph(np) = vophx
                wosoct = wosoct + wophx
                vosoct = vosoct + vophx
              endif
            endif
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1) .eq. 2) then
c
c       Compute the product mineral assemblage which is instantaneous
c       with respect to Xi (for the fluid-centered flow-through system
c       only).
c
        call initaz(mophj,nptmax)
        call initaz(vophj,nptmax)
        call initaz(wophj,nptmax)
        call initaz(mospj,nstmax)
        call initaz(vospj,nstmax)
        call initaz(wospj,nstmax)
c
        if (npts .gt. 0) then
c
c         Use the two-point derivative.
c
          do npe = 1,npet0
            np = iemop0(npe)
            mophj(np) = fdpe0(1,npe)
            if (mophj(np) .lt. 0.) mophj(np) = 0.
            wophx = 0.
            vophx = 0.
c
            nr1 = ncmpe0(1,npe)
            nr2 = ncmpe0(2,npe)
            do nse = nr1,nr2
              ns = iemos0(nse)
              mospx = fdse0(1,nse)
              mospj(ns) = mospx
              wospx = mospx*mwtsp(ns)
              wospj(ns) = wospx
              wophx = wophx + wospx
              vospx = mospx*vosp0(ns)
              vospj(ns) = vospx
              vophx = vophx + vospx
            enddo
            if (np.ge.iern1 .and. np.le.iern2) then
              ne = np - iern1 + 1
              wophx = wophx + mophj(np)*mwtges(ne)
            endif
            wophj(np) = wophx
            vophj(np) = vophx
          enddo
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(1) .eq. 2) then
c
c       Compute data which describe the solid phases in the system
c       ES + PRS.
c
        do np = 1,npt
          if (np .ne. iaqsln) then
            if (jpflag(np) .lt. 2) then
              mopht(np) = moph(np) + mprph(np)
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              vophx = 0.
              wophx = 0.
              do ns = nr1,nr2
                mospx = mosp(ns) + mprsp(ns)
                mospt(ns) = mospx
                wospx = mospx*mwtsp(ns)
                wospt(ns) = wospx
                wophx = wophx + wospx
                vospx = mospx*vosp0(ns)
                vospt(ns) = vospx
                vophx = vophx + vospx
              enddo
              if (np.ge.iern1 .and. np.le.iern2) then
                ne = np - iern1 + 1
                wophx = wophx + mopht(np)*mwtges(ne)
              endif
              wopht(np) = wophx
              vopht(np) = vophx
              wosoct = wosoct + wophx
              vosoct = vosoct + vophx
            endif
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((nmrt + nxrt + nert) .gt. 0) then
c
c       Print a grand summary of the solid phases in the system
c       ES + PRS + reactants.
c
        do np = imrn1,imrn2
          mophx = moph(np) + mprph(np)
          qrct = .false.
          if (nmrt .gt. 0) then
            do nrc = 1,nrct
              if (jcode(nrc) .eq. 0) then
                np1 = nrndex(nrc)
                if (np1 .eq. np) then
                  mophx = mophx + morr(nrc)
                  qrct = .true.
                  go to 607
                endif
              endif
            enddo
          endif
c
  607     if (mophx.ne.0. .or. qrct) then
            mophg(np) = mophx
c
            ns = ncmpr(1,np)
            mospx = mophx
            mospg(ns) = mospx
            wospx = mospx*mwtsp(ns)
            wospg(ns) = wospx
            vospx = mospx*vosp0(ns)
            vospg(ns) = vospx
c
            wophx = wospx
            vophx = vospx
            wophg(np) = wophx
            vophg(np) = vophx
          endif
        enddo
c
        do np = ifrn1,ifrn2
          mophx = moph(np) + mprph(np)
          qrct = .false.
          if (nmrt .gt. 0) then
            do nrc = 1,nrct
              if (jcode(nrc) .eq. 0) then
                np1 = nrndex(nrc)
                if (np1 .eq. np) then
                  mophx = mophx + morr(nrc)
                  qrct = .true.
                  go to 609
                endif
              endif
            enddo
          endif
c
  609     if (mophx.ne.0. .or. qrct) then
            mophg(np) = mophx
c
            ns = ncmpr(1,np)
            mospx = mophx
            mospg(ns) = mospx
            wospx = mospx*mwtsp(ns)
            wospg(ns) = wospx
            vospx = mospx*vosp0(ns)
            vospg(ns) = vospx
c
            wophx = wospx
            vophx = vospx
            wophg(np) = wophx
            vophg(np) = vophx
          endif
        enddo
c
        if (iopt(4) .gt. 0) then
          do np = ixrn1,ixrn2
            if (jpflag(np) .lt. 2) then
              mophx = moph(np) + mprph(np)
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              qrct = .false.
              nrc = 0
c
              if (nxrt .gt. 0) then
                do nrc = 1,nrct
                  if (jcode(nrc) .eq. 1) then
                    np1 = nrndex(nrc)
                    if (np1 .eq. np) then
                      mophx = mophx + morr(nrc)
                      qrct = .true.
                      go to 612
                    endif
                  endif
                enddo
              endif
c
  612         if (mophx.ne.0. .or. qrct) then
                mophg(np) = mophx
                if (qrct) nxr = nxridx(nrc)
                ik = 0
                vophx = 0.
                wophx = 0.
                do ns = nr1,nr2
                  mospx = mosp(ns) + mprsp(ns)
                  ik = ik + 1
                  if (qrct) mospx = mospx + morr(nrc)*rxbar(ik,nxr)
                  mospg(ns) = mospx
                  wospx = mospx*mwtsp(ns)
                  wospg(ns) = wospx
                  wophx = wophx + wospx
                  vospx = mospx*vosp0(ns)
                  vospg(ns) = vospx
                  vophx = vophx + vospx
                enddo
                vophg(np) = vophx
                wophg(np) = wophx
              endif
            endif
          enddo
        endif
c
        do np = iern1,iern2
          if (jpflag(np) .lt. 2) then
            mophx = moph(np) + mprph(np)
            qrct = .false.
            nrc = 0
c
            if (nert .gt. 0) then
              do nrc = 1,nrct
                if (jcode(nrc) .eq. 5) then
                  np1 = nrndex(nrc)
                  if (np1 .eq. np) then
                    mophx = mophx + morr(nrc)
                    qrct = .true.
                    go to 614
                  endif
                endif
              enddo
            endif
c
  614       if (mophx.ne.0. .or. qrct) then
              mophg(np) = mophx
              if (qrct) ner = nxridx(nrc)
              vophx = 0.
              wophx = 0.
              ne = np - iern1 + 1
              do je = 1,jgext(ne)
                ns = jern1(je,ne) - 1
                do ie = 1,ngext(je,ne)
                  ns = ns + 1
                  mospx = mosp(ns) + mprsp(ns)
                  if (qrct) mospx = mospx + morr(nrc)*mrgers(ie,je,ner)
                  mospg(ns) = mospx
                  wospx = mospx*mwtsp(ns)
                  wospg(ns) = wospx
                  wophx = wophx + wospx
                  vospx = mospx*vosp0(ns)
                  vospg(ns) = vospx
                  vophx = vophx + vospx
                enddo
              enddo
              wophx = wophx + mophg(np)*mwtges(ne)
c
              vophg(np) = vophx
              wophg(np) = wophx
            endif
          endif
        enddo
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      dvoso = vosoct - vodrt
      dwoso = wosoct - wodrt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine vazpck(nat,natmax,nazt,naztmx,noutpt,nttyo,
     $ uaqsp,uazp)
c
c     Validate the aqueous species names used to specify hard core
c     diameters. Write a note if such a name does not appear on the
c     main list of aqueous species.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       nazt   = the number of specified hard core diameters
c       uaqsp  = array of names of aqueous species
c       uazp   = array of aqueous species names used to specify
c                  hard core diamters on the data file
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,naztmx
c
      integer noutpt,nttyo
c
      integer nat,nazt
c
      character*24 uaqsp(natmax),uazp(naztmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 unam
c
      integer j2,na,naz
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Loop over all aqueous species names used to specify hard core
c     diameters.
c
      do naz = 1,nazt
        unam = uazp(naz)
        if (unam(1:7) .ne. '<blank>') then
c
c         Check that each such name appears on the main list of
c         aqueous species.
c
          do na = 1,nat
            if (unam(1:24) .eq. uaqsp(na)(1:24)) go to 100
          enddo
c
c         Did not find this name on the main list of aqueous species.
c
          j2 = ilnobl(unam)
          write (noutpt,1000) unam(1:j2)
          write (nttyo,1000) unam(1:j2)
 1000     format(/' * Note - (EQPT/vazpck) A hard core diameter is',
     $    ' specified on the',/7x,'data file for ',a,', but there is',
     $    ' no species block for this',/7x,'in the aqueous species',
     $    ' superblock. Therefore, this species will',/7x,'not appear',
     $    ' in any computed model and the hard core diameter value',
     $    /7x,'will not be used. It is suggested to remove the',
     $    ' hard core diameter',/7x,'in question or to add the',
     $    ' corresponding species block.')
c
  100     continue
        endif
      enddo
c
      end

      subroutine platfd(uplatc,uplatm)
c
c     This subroutine sets the platform designator strings that are
c     written on the output and screen files of various codes.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       uplatc = platform category (e.g., UNIX, PC, MAC)
c       uplatm = platform machine (e.g., SPARC, SGI, Pentium, 486PC)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*8 uplatc,uplatm
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
com   BEGIN_UNIX_DEPENDENT_CODE
com
c       uplatc = 'UNIX'
com
c       uplatm = 'SPARC'
cxx     uplatm = 'SGI'
cxx     uplatm = 'HP-UX'
cxx     uplatm = 'AIX'
cxx     uplatm = 'Ultrix'
com
com   END_UNIX_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
com   BEGIN_PC_DEPENDENT_CODE
com
        uplatc = 'PC'
com
cxx     uplatm = 'Pentium II'
cxx     uplatm = 'K6'
cxx     uplatm = 'K6-2'
        uplatm = 'PC'
cxx     uplatm = 'Pentium Pro'
cxx     uplatm = 'P5'
cxx     uplatm = 'Pentium'
cxx     uplatm = '486PC'
cxx     uplatm = '386PC'
com
com   END_PC_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
com   BEGIN_MAC_DEPENDENT_CODE
com
c       uplatc = 'MAC'
com
c       uplatm = 'MAC'
com
com   END_MAC_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
com   BEGIN_VAX_DEPENDENT_CODE
com
c       uplatc = 'VAX/VMS'
com
c       uplatm = 'VAX'
com
com   END_VAX_DEPENDENT_CODE
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $ udbval,xdbval)
c
c     This subroutine reads data from the standard log K temperature
c     grid. Other kinds of data are read from such grids.
c
c     This suboutine is called by:
c
c       EQPT/rdpar.f
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndbptg = the number of points on the grid
c       ndbptl = the maximum number of points on a single line
c
c     Principal output:
c
c       qend   = logical flag, = .true. if end-of-file was encountered
c       qerr   = logical flag, = .true. if a read format error was
c                  encountered
c       udbval = string array, the equivalent of xdbval
c       xdbval = array containing the data read from the grid
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndbmax
c
      integer ndat0s
c
      integer ndbptg,ndbptl
c
      logical qend,qerr,q500nd
c
      character(len=16) udbval(ndbmax)
c
      real(8) xdbval(ndbmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,j,jj,k,n
c
      character(len=80) uline,ulbufa,ulbufb
      character(len=16) ux16
c
c-----------------------------------------------------------------------
c
      qend = .false.
      qerr = .false.
c
c     Note: the following coding generally assumes that a blank
c     space trails all but the last number on a line. If a blank
c     space is not found, it is assumed that a number ends after
c     four decimal places.
c
      n = 0
      do i = 1,ndbptg/ndbptl
        read (ndat0s,'(a)',end=990,err=995) uline
        ulbufa = uline
        do k = 1,ndbptl
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          jj = index(ulbufa,'.')
          if (jj .eq. 0) then
            jj = 80
          else
            jj = jj + 5
          endif
          ii = min(ii,jj)
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            call locase(ux16)
            udbval(n + k) = ux16
            if (ux16(1:7) .eq. 'no_data') then
              xdbval(n + k) = 9999999.
            else
              read (ux16,'(f10.4)',err=995) xdbval(n + k)
            endif
          else
            udbval(n + k) = ' '
            xdbval(n + k) = 0.
          endif
          if (k .lt. ndbptl) then
            ulbufb = ulbufa(ii:80)
            ulbufa = ulbufb
          endif
        enddo
c       read (uline,udbfmt,err=995) (xdbval(n + k), k = 1,ndbptl)
c       Note: udbfmt = '( (5x,6f10.4) )' with the "6" repeat
c       count replaced by ndbptl.
        n = n + ndbptl
      enddo
c
      j = mod(ndbptg,ndbptl)
      if (j .gt. 0) then
        read (ndat0s,'(a)',end=990,err=995) uline
        ulbufa = uline
        do k = 1,j
          call lejust(ulbufa)
          ii = index(ulbufa,' ')
          jj = index(ulbufa,'.')
          if (jj .eq. 0) then
            jj = 80
          else
            jj = jj + 5
          endif
          ii = min(ii,jj)
          if (ii .gt. 1) then
            ux16 = ulbufa(1:ii - 1)
            call locase(ux16)
            udbval(n + k) = ux16
            if (ux16(1:7) .eq. 'no_data') then
              xdbval(n + k) = 9999999.
            else
              read (ux16,'(f10.4)',err=995) xdbval(n + k)
            endif
          else
            udbval(n + k) = ' '
            xdbval(n + k) = 0.
          endif
          if (k .lt. j) then
            ulbufb = ulbufa(ii:80)
            ulbufa = ulbufb
          endif
        enddo
c       read (uline,udbfmt,err=995) (xdbval(n + k), k = 1,j)
        n = n + j
      endif
c
      if (q500nd) then
c
c       Apply the following filter. Treat values of "500.0000" as
c       "no data". This accommodates older EQ3/6 data files which
c       use "500.0000" to mean no data.
c
        do i = 1,ndbptg
          if (xdbval(i).gt.499.9999 .and. xdbval(i).lt.500.0001) then
            udbval(i) = 'no_data'
            xdbval(i) = 9999999.
          endif
        enddo
      endif
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qend = .true.
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  995 qerr = .true.
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine coasst(jassan,jassca,jassne,nat,natmax,uaqsp,zaqsp)
c
c     Get the numbers of aqueous solute cations, anions, and neutral
c     species. These will be used to generate lists of species pairs
c     and triplets for use with Pitzer's equations.
c
c     The fictive redox species aqueous e- and aqueous O2(g), if
c     present, are excluded in computing these totals. So is solvent
c     water.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c       zaqsp  = array of electrical charages of aqueous species
c
c     Principal output:
c
c       jassca = number of aqueous cation species
c       jassan = number of aqueous anion species (excluding aqueous e-)
c       jassne = number of aqueous neutral species (excluding solvent
c                  water and aqeuous O2(g))
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax
c
      integer jassan,jassca,jassne,nat
c
      character(len=24) uaqsp(natmax)
c
      real*8 zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n
c
c-----------------------------------------------------------------------
c
c     Count the aqueous solute cations, anions, and neutrals. Include
c     in the counts only real solute species.
c
      jassne = 0
      jassca = 0
      jassan = 0
      do n = 2,nat
        if (zaqsp(n) .eq. 0.) then
          if (uaqsp(n)(1:6) .ne. 'O2(g) ') then
            jassne = jassne + 1
          endif
        elseif (zaqsp(n) .gt. 0.) then
          jassca = jassca + 1
        else
          if (uaqsp(n)(1:3) .ne. 'e- ') then
            jassan = jassan + 1
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine prrecy(cdrs,nbtmx1,nbtmx2,nbt,ns,nfile,uspec)
c
c     This subroutine writes the reaction associated with the ns-th
c     species on the file whose unit number is nfile. This subroutine
c     is virtually identical in function to EQLIB/prreac.f, but
c     deals with data that is structured somewhat differently.
c
c     This subroutine is called by:
c
c       EQPT/rxnchk.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cdrs   = array of reaction coefficients
c       ns     = species whose reaction is to be printed
c       nfile  = unit number of the file to write on
c       uspec  = array of species names
c
c     Principal input:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmx1,nbtmx2
c
      integer nbt,nfile,ns
c
      character*24 uspec(nbtmx1)
c
      real*8 cdrs(nbtmx2,nbtmx1)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nj,nb,nbt1
c
      integer ilnobl
c
      real*8 cx
c
c-----------------------------------------------------------------------
c
      nbt1 = nbt + 1
      cx = -cdrs(nbt1,ns)
      j2 = ilnobl(uspec(ns))
      write (nfile,1000) cx,uspec(ns)(1:j2)
 1000 format(/21x,f10.5,2x,a)
c
      do nb = 1,nbt
        cx = -cdrs(nb,ns)
        if (cx .gt. 0.) then
          j2 = ilnobl(uspec(nb))
          write (nfile,1010) cx,uspec(nb)(1:j2)
 1010     format(18x,' + ',f10.5,2x,a)
        endif
      enddo
c
      write (nfile,1020)
 1020 format(/31x,'='/)
c
      nj = 0
      do nb = 1,nbt
        cx = cdrs(nb,ns)
        if (cx .gt. 0.) then
          j2 = ilnobl(uspec(nb))
          if (nj .le. 0) then
            write (nfile,1030) cx,uspec(nb)(1:j2)
 1030       format(21x,f10.5,2x,a)
            nj = 1
          else
            write (nfile,1010) cx,uspec(nb)(1:j2)
          endif
        endif
      enddo
c
      end

      subroutine prtrdx(ah,ahrc,cdrsd,eh,ehrc,fo2lg,fo2lrc,jflgi,
     $ jsflag,narn1,nbasp,nbaspd,nbt,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $ nelect,nhydr,no2gaq,noutpt,nstmax,pe,perc,uspec)
c
c     This subroutine prints a table of the Eh, pe-, log fO2, and Ah for
c     the default redox constraint and each aqueous redox couple which
c     is not required to satisfy the default redox constraint.
c
c     Most of the data printed by this subroutine are calculated by
c     EQLIB/cdardx.f.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ah     = Default Ah, kcal
c       ahrc   = array of couple-specific Ah values, kcal
c       cdrsd  = coefficients of reactions in the 'd' set
c       eh     = Default Eh, volts
c       ehrc   = array of couple-specific Eh values, volts
c       fo2lg  = Default log fO2
c       fo2lrc = array of couple-specific log fO2 values
c       jsflag = array of species status flags
c       nbt    = the number of species in the basis set
c       ndrsd  = array of the indices of the species corresponding to
c                  the reaction coefficients in the cdrsd array
c       ndrsrd = array giving the range in the cdrsd and ndrsd arrays
c                  corresponding to the reaction for a given species
c       nelect = index of the fictive species aqueous e-
c       no2gaq = index of the fictive species aqueous O2(g)
c       pe     = Default pe-
c       perc   = array of couple-specific pe- values
c       uspec  = array of species names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt
c
      integer jflgi(nbtmax),jsflag(nstmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),ndrsd(ndrsmx),ndrsrd(2,nstmax)
      integer narn1,nbt,nelect,nhydr,no2gaq
c
      character*48 uspec(nstmax)
c
      real*8 ahrc(nbtmax),cdrsd(ndrsmx),ehrc(nbtmax),
     $ fo2lrc(nbtmax),perc(nbtmax)
      real*8 ah,eh,fo2lg,pe
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,n,nb,nr1,nr2,ns1,ns2,nse,nt
c
      integer ilnobl
c
      character*24 ux24
c
      real*8 cx1
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(//16x,'--- Aqueous Redox Reactions ---',
     $ //3x,'Couple',27x,'Eh, volts',6x,'pe-',6x,'log fO2',3x,
     $ 'Ah, kcal',/)
      write (noutpt,1010) eh,pe,fo2lg,ah
 1010 format(1x,'DEFAULT',t37,f7.3,3x,1pe11.4,2x,0pf8.3,2x,f8.3)
c
      do nb = 1,nbt
        if (jflgi(nb) .eq. 30) go to 110
        if (jflgi(nb) .eq. 27) go to 110
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (jsflag(ns1) .ne. 0) go to 110
        if (jsflag(ns2) .ne. 0) go to 110
        nt = ndrsrd(2,ns1) - ndrsrd(1,ns1) + 1
        if (nt .lt. 2) go to 110
c
c       Test the reaction read from the data file to see if it contains
c       an entry for O2(g).
c
c       Calling sequence substitutions:
c         cdrsd for cdrs
c         ndrsd for ndrs
c         ndrsrd for ndrsr
c         no2gaq for nse
c         ns1 for ns
c
        cx1 = coefdr(cdrsd,ndrsd,ndrsmx,ndrsrd,no2gaq,ns1,nstmax)
        if (cx1 .ne. 0.) then
          ux24 = uspec(narn1)
          nr1 = ndrsrd(1,ns1)
          nr2 = ndrsrd(2,ns1)
          do n = nr1,nr2
            nse = ndrsd(n)
            if (nse .eq. 0) go to 110
            if (nse.ne.ns1 .and. nse.ne.no2gaq .and. nse.ne.nelect
     $      .and. nse.ne.narn1 .and. nse.ne.nhydr) ux24 = uspec(nse)
          enddo
c
          j2 = ilnobl(uspec(ns1)(1:24))
          j3 = ilnobl(ux24)
c
  100     if ((j2 + j3) .gt. 32) then
            if (j2 .gt. j3) then
              j2 = j2 - 1
            else
              j3 = j3 - 1
            endif
            go to 100
          endif
c
          write (noutpt,1020) uspec(ns1)(1:j2),ux24(1:j3),ehrc(nb),
     $    perc(nb),fo2lrc(nb),ahrc(nb)
 1020     format(1x,a,'/',a,t37,f7.3,3x,1pe11.4,2x,0pf8.3,2x,f8.3)
        endif
  110   continue
      enddo
      write (noutpt,1030)
 1030 format(/4x,'Couples required to satisfy the default redox',
     $ ' constraint are not listed.',/)
c
      end

      subroutine ginvrt(aimatr,delvec,gmmatr,ipivot,kdim,kmax)
c
c     This subroutine inverts the matrix aamatr. The inverted matrix
c     is returned in aimatr. Thus
c
c       [aamatr][aimatr] = I
c
c     where I is the unit matrix (1's on the diagonal, 0's elsewhere).
c
c     This subroutine assumes that aamatr has already been factored
c     into its L-U decomposition, gmmatr. The inverse matrix aimatr
c     is obtained by solving a series of matrix equations, each using
c     the same decomposed matrix but with a different unit vector as
c     the right hand side. The original aamatr matrix itself is not
c     used here.
c
c     A companion subroutine minvrt.f has the same function as the
c     present routine. However, it does its own factoring of aamatr
c     to obtain gmmatr.
c
c     This subroutine uses the following subroutines, which are
c     adaptations of 1979 Linpack subroutines of the same names:
c
c       EQLIBU/dgesl.f
c
c     The calling sequences have been preserved to facilitate
c     substituting equivalents optimized for specific platforms,
c     for anyone desiring to do so.
c
c     This subroutine is called by:
c
c       EQ6/garmat.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       gmmatr = the L-U decomposition of the matrix to be inverted
c       kdim   = the actual dimention of the matrix
c       kmax   = the maximum dimension of the matrix
c
c     Workspace:
c
c       delvec = at one point, the right-hand-side vector; at another,
c                  the solution vector
c       ipivot = the pivot vector
c
c     Output:
c
c       aimatr = the inverted matrix
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax
c
      integer ipivot(kmax)
      integer kdim
c
      real*8 aimatr(kmax,kmax),gmmatr(kmax,kmax),delvec(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,k
c
c-----------------------------------------------------------------------
c
c     Invert the matrix aamatr by looping over columns for the inverted
c     matrix (aimatr).
c
      do k = 1,kdim
c
c       Put the corresponding unit vector in delvec. This serves to
c       set the right-hand-side vector.
c
        do j = 1,kdim
          delvec(j) = 0.
        enddo
        delvec(k) = 1.
c
c       Solve for the unknown vector (delvec). Note that delvec
c       initially contains the right-hand-side vector. Normally
c       separate arrays would be used for the two vectors. This
c       example of bad programming is made here to retain consistency
c       with the original Linpack routine.
c
        call dgesl(gmmatr,kmax,kdim,ipivot,delvec)
c
c       Load the result in the inverted matrix.
c
        do j = 1,kdim
          aimatr(j,k) = delvec(j)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine intrp(aamatr,apr,avgrid,cof,eps100,gmmatr,ipivot,
     $ narxmx,narxt,noutpt,ntprmx,ntprt,nttyo,tempc,tempcs,tmpcmx,
     $ xvec,yvec)
c
c     This subroutine fits interpolating polynomials to data (avgrid)
c     on a temperature grid (tempc). The grid is divided into ranges.
c     A separate polynomial is fitted to the data in each range.
c     Its coefficients are obtained in the cof array. The coefficients
c     for all ranges are returned in the apr array.
c
c     This subroutine is called by:
c
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c       EQPT/wrpar.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       avgrid = array containing the data on the temperature grid
c
c     Principal output:
c
c       apr    = array of polynomial coefficients (for all ranges)
c       avgrid = array containing the data on the temperature grid
c       narxmx = the maximum number of points or coefficients per
c                  temperature range
c       narxt  = the actual number of points or coefficients per
c                  temperature range
c       nptrmx = the maximum number of temperature ranges
c       nptrt  = the actual number of temperature ranges
c
c     Workspace:
c
c       aamatr = matrix used to calculate the polynomial coefficients
c       cof    = array of fitted polynomial coefficients (for a
c                  single temperature range)
c       xvec   = array of scaled temperatures corresponding to the
c                  data in the yvec array
c       yvec   = array of data to be fitted (for a single temperature
c                  range)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ntprmx
c
      integer noutpt,nttyo
c
      integer ntprt
c
      integer ipivot(narxmx),narxt(ntprmx)
c
      real*8 apr(narxmx,ntprmx),avgrid(narxmx,ntprmx)
      real*8 tempc(narxmx,ntprmx),tempcs(narxmx,ntprmx),tmpcmx(ntprmx)
      real*8 aamatr(narxmx,narxmx),gmmatr(narxmx,narxmx)
      real*8 cof(narxmx),xvec(narxmx),yvec(narxmx)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,n,nmax,npft,ntpr
c
      real*8 tvecmx
c
c-----------------------------------------------------------------------
c
c     Initialize apr to 0.
c
      nmax = narxmx*ntprmx
      call initaz(apr,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop on temperature ranges.
c
      do ntpr = 1,ntprt
c
c       Put all real values (9999999. indicates no data) in the yvec
c       array. Put the corresponding scaled temperature values in
c       the xvec array.
c
        npft = 0
c
        do n = 1,narxt(ntpr)
          if (avgrid(n,ntpr) .lt. 9999999.) then
            npft = npft + 1
            xvec(npft) = tempcs(n,ntpr)
            yvec(npft) = avgrid(n,ntpr)
          endif
        enddo
c
c       Here npft is the number of usable values.
c
        if (npft .le. 0) then
c
c         There are no usable values.
c
          apr(1,ntpr) = 9999999.
          go to 110
        endif
c
        if (npft .gt. 1) then
c
c         Check for constant yvec.
c
          do n = 2,npft
            if(abs(yvec(n) -yvec(1)) .gt. eps100) go to 100
          enddo
          npft = 1
  100     continue
        endif
c
        if (npft .le. 1) then
          apr(1,ntpr) = yvec(1)
          go to 110
        endif
c
c       Fit the polynomial.
c
        call polfit(aamatr,cof,gmmatr,ier,ipivot,narxmx,npft,
     $  noutpt,nttyo,xvec,yvec)
c
        if (ier .gt. 0) then
          write (noutpt,1010) ntpr,tempc(1,ntpr),tempc(narxt(ntpr),ntpr)
          write (nttyo,1010) ntpr,tempc(1,ntpr),tempc(narxt(ntpr),ntpr)
 1010     format(/' * Error - (EQPT/intrp) Could not compute the',
     $    /7x,'coefficients of an interpolating polynomial in',
     $    /7x,'temperature range ',i2,' (',f6.2,' - ',f6.2,' C.')
          stop
        endif
c
c       Rescale the coefficients.
c
        tvecmx = tmpcmx(ntpr)
c
c       Calling sequence substitutions:
c         tvecmx for avxmax
c         cof for avy
c         cof for avys
c         npft for nmax
c
        call rscaly(tvecmx,cof,cof,eps100,npft)
c
c       Store the fitted coefficients for this range in the apr array.
c
        do n = 1,npft
          apr(n,ntpr) = cof(n)
        enddo
c
  110   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine wrtabx(actlg,afrc1,aft1,alk,cteaq,dvoso,dwoso,
     $ eh,fo2lg,iindx1,iktmax,iopt,ipndx1,kmax,km1,kmt,kstep,kx1,
     $ kxt,loph,ncmpr,modr,mopht,narn1,mosp,nct,nctmax,noptmx,
     $ nptmax,nrct,nrctmx,nstmax,ntabx,ntidmx,ntitl2,ntitld,ntitmx,
     $ nxtmax,pe,ph,ppmwe,prcinf,press,prminf,qbye,qmod,qriinf,
     $ tempc,time1,uelem,uphase,uplatm,ureac,uspec,usteq6,utitl2,
     $ utitld,uveeq6,vodrt,vosoct,wodrt,woh2o,wosoct,xbar,xi1)
c
c     This subroutine writes the scratch tab file tabx. The length of
c     any line should not exceed 129 characters.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,kmax,nctmax,noptmx,nptmax,nrctmx,nstmax,
     $ ntidmx,ntitmx,nxtmax
c
      integer ntabx
c
      integer iindx1(kmax),iopt(noptmx),ipndx1(kmax),ncmpr(2,nptmax)
c
      integer km1,kmt,kstep,kx1,kxt,narn1,nct,nrct,ntitl2,ntitld
c
      logical qbye,qmod,qriinf
c
      character*80 utitl2(ntitmx),utitld(ntidmx)
      character*48 uspec(nstmax)
      character*24 uphase(nptmax),ureac(nrctmx)
      character*8 uelem(nctmax)
      character*8 uplatm,usteq6,uveeq6
c
      real*8 actlg(nstmax),afrc1(nrctmx),cteaq(nctmax),loph(nptmax),
     $ modr(nrctmx),mopht(nptmax),mosp(nstmax),ppmwe(nctmax),
     $ xbar(nstmax)
c
      real*8 aft1,alk,dvoso,dwoso,eh,fo2lg,wodrt,wosoct,pe,ph,
     $ prcinf,press,prminf,tempc,time1,vodrt,vosoct,woh2o,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensioning.
c
      character(len=16), dimension(:,:), allocatable :: uprss
      character(len=8), dimension(:,:), allocatable :: uprmn
      character(len=8), dimension(:), allocatable :: uelac
c
      real(8), dimension(:), allocatable :: lcteaq,ppmaq,xfrac,zvclgx
c
c     Saved values of local array sizes.
c
      integer isv_kmax,isv_nctmax,isv_nxcmax
c
      SAVE isv_kmax,isv_nctmax,isv_nxcmax
c
      SAVE lcteaq,ppmaq,uelac,uprmn,uprss,xfrac,zvclgx
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nxcmax
c
      integer i,j2,j3,j4,k,kcol,ktot,ktotlm,n,nc,nctpr,nlim,nlim1,nlim2,
     $ np,np1,nrc,ns
c
      integer ilnobl
c
      logical qphasc,qstart,qtitl
c
      character*1 ua,ub,uc,ud,ue,uf,ug,uh,uj,uk,ul,um,un,uo,up,uq,ur,
     $ us,ut,uu,uv,ux,uy
c
      real*8 cx,dx1,dx2,dx3,lalk,mx,tdays,tlogd,wkgh2o,xilog
c
      real*8 tlg
c
c-----------------------------------------------------------------------
c
      data ua,ub,uc,ud,ue,uf,ug,uh,uj,uk,ul,um,un,uo,up,uq,ur,us,
     $ ut,uu,uv,ux,uy/'a','b','c','d','e','f','g','h','j',
     $ 'k','l','m','n','o','p','q','r','s','t','u','v','x','y'/
c
c-----------------------------------------------------------------------
c
      nxcmax = nxtmax*iktmax
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(uprss)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
        isv_nctmax = 0
        isv_nxcmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(uprmn)
          DEALLOCATE(uprss)
          DEALLOCATE(zvclgx)
          isv_kmax = 0
        endif
c
        if (nctmax .ne. isv_nctmax) then
          DEALLOCATE(uelac)
          DEALLOCATE(lcteaq,ppmaq)
          isv_nctmax = 0
        endif
c
        if (nxcmax .ne. isv_nxcmax) then
          DEALLOCATE(xfrac)
          isv_nxcmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(uprmn(3,kmax))
        ALLOCATE(uprss(2,kmax))
        ALLOCATE(zvclgx(kmax))
        isv_kmax = kmax
      endif
c
      if (isv_nctmax .eq. 0) then
        ALLOCATE(uelac(nctmax))
        ALLOCATE(lcteaq(nctmax),ppmaq(nctmax))
        isv_nctmax = nctmax
      endif
c
      if (isv_nxcmax .eq. 0) then
        ALLOCATE(xfrac(nxcmax))
        isv_nxcmax = nxcmax
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        uprmn(1,k) = ' '
        uprmn(2,k) = ' '
        uprmn(3,k) = ' '
        uprss(1,k) = ' '
        uprss(2,k) = ' '
      enddo
c
      do k = 1,kmax
        zvclgx(k) = -99999.
      enddo
c
      do n = 1,nctmax
        uelac(n) = ' '
      enddo
c
      do n = 1,nctmax
        lcteaq(n) = -99999.
        ppmaq(n) = 0.
      enddo
c
      do n = 1,nxcmax
        xfrac(n) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write output tables of some selected parameters. These are
c     identified by the letters a, b, c, etc. They are written on
c     the file tabx in scrambled order (i.e., the lines of any given
c     tables are interspersed with those of the other tables). Each
c     line is marked in column one with the letter of the table to
c     which it belongs. When the run is complete, EQLIBU/dscram.f
c     writes the lines in descrambled form on file tab. File tabx
c     is preserved. The maximum line length for the tabx file is 129
c     characters. The maximum line length for the tab file is 128
c     characters.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c      Write table a. Header data.
c
c               Run title
c               Code version identification
c               Data file title
c
c     Note: the original primary title (utitl1) has been rolled over
c     to the current secondary title (utitl2).
c
      qstart = kstep .eq. 0
      if (qstart) then
        do i = 1,3
          write (ntabx,1000) ua
 1000     format(a1,1x)
        enddo
c
        do n = 1,ntitl2
          j2 = ilnobl(utitl2(n))
          write (ntabx,1005) ua,utitl2(n)(1:j2)
 1005     format(a1,1x,a)
        enddo
c
        write (ntabx,1000) ua
        j2 = ilnobl(uveeq6)
        j3 = ilnobl(usteq6)
        j4 = ilnobl(uplatm)
        write (ntabx,1010) ua,uveeq6(1:j2),usteq6(1:j3),uplatm(1:j4)
 1010   format(a1,1x,'Running EQ3/6-V',a,'-EQ6-EXE-',a,'-',a)
        write (ntabx,1015) ua
 1015   format(a1)
        write (ntabx,1000) ua
c
        do n = 1,ntitld
          j2 = ilnobl(utitld(n))
          write (ntabx,1005) ua,utitld(n)(1:j2)
        enddo
      endif
c
      qtitl = qstart
      if (iopt(18) .ge. 1) qtitl = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write table b. Major run parameters.
c
c               Overall reaction progress
c               Log of overall reaction progress
c               Time, days
c               Log days
c               Temperature, C
c               Pressure, bars
c               pH
c               log fO2
c               Eh, volts
c               pe
c               Mass of solvent, kg
c               Total affinity, kcal
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ub
        enddo
c
        write (ntabx,1020) ub
 1020   format(a1,'       xi     log xi    time, d  log days',
     $  '    tempc  ','   press       ph     log fo2      eh',
     $  '        pe      kg h2o   tot aff')
        write (ntabx,1000) ub
      endif
c
cXX  Will eventually have to revise the tab file (-99999. vs. -999.).
cXX   xilog = -99999.
      xilog = -999.
      if (xi1 .gt. 0.) xilog = tlg(xi1)
      wkgh2o = 0.001*woh2o
      if (qriinf) then
        tdays = prcinf
cXX     tlogd = +99999.
        tlogd = +999.
      else
        tdays = time1/86400.
        if (time1 .gt. prminf) then
          tlogd = tlg(tdays)
        else
cXX       tlogd = -99999.
          tlogd = -999.
        endif
      endif
c
cXX
      if (eh .le. -99999.) eh = -999.
      if (pe .le. -99999.) pe = -999.
      if (aft1 .ge. 99999.) aft1 = 999.
cXX
c
      write (ntabx,1025) ub,xi1,xilog,tdays,tlogd,tempc,press,ph,fo2lg,
     $ eh,pe,wkgh2o,aft1
 1025 format(a1,1x,1pe10.3,0pf10.4,1pe10.3,9(0pf10.4))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write table c. Miscellaneous aqueous solution composition
c     parameters.
c
c               Log of activity of water
c               Alkalinity, eq/kg.H2O (not defined for
c                 temperatures greater than 50 C)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uc
        enddo
c
        write (ntabx,1030) uc
 1030   format(a1,1x,'   log xi   time, d   log days  log alk',
     $  '  log tot   log tot   log tot   log a h2o')
        write (ntabx,1035) uc
 1035   format(a1,41x,'  co3--     so4--     s--')
        write (ntabx,1000) uc
      endif
c
cXX   lalk = -99999.
      lalk = -999.
      if (alk .gt. 0.) lalk = tlg(alk)
      dx1 = 0.
      dx2 = 0.
      dx3 = 0.
      write (ntabx,1040) uc,xilog,tdays,tlogd,lalk,dx1,dx2,dx3,
     $ actlg(narn1)
 1040 format(a1,1x,0pf10.4,1pe10.3,10(0pf10.4))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write tables d, e, f, g, and h. Aqueous solution composition
c     in terms of molalities of chemical elements. Write
c     corresponding tables j, k, l, m, and n (aqueous solution
c     composition in terms of ppm of chemical elements).
c
      nctpr = 0
      do nc = 1,nct
        if (uelem(nc)(1:2).ne.'H ' .and. uelem(nc)(1:2) .ne. 'O ') then
          nctpr = nctpr + 1
          uelac(nctpr) = uelem(nc)
          cx = cteaq(nc)
          lcteaq(nctpr) = tlg(cx)
cXX  Will eventually have to revise the tab file (-99999. vs. -999.).
          if (lcteaq(nctpr) .lt. -999.) lcteaq(nctpr) = -999.
          ppmaq(nctpr) = ppmwe(nc)
        endif
      enddo
c
      if (nctpr .le. 0) go to 100
      nlim2 = min(9,nctpr)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ud
          write (ntabx,1000) uj
        enddo
c
        write (ntabx,1045) ud
 1045   format(a1,20x,'log molality of dissolved elements')
        write (ntabx,1050) uj
 1050   format(a1,17x,'ppm (mg/kg.sol) of dissolved elements')
        write (ntabx,1000) ud
        write (ntabx,1000) uj
        write (ntabx,1055) ud,(uelac(n), n = 1,nlim2)
        write (ntabx,1055) uj,(uelac(n), n = 1,nlim2)
 1055   format(a1,1x,'   log xi   time, d   log days ',10(4x,a3,3x))
        write (ntabx,1000) ud
        write (ntabx,1000) uj
      endif
c
      write (ntabx,1040) ud,xilog,tdays,tlogd,(lcteaq(n), n = 1,nlim2)
      write (ntabx,1065) uj,xilog,tdays,tlogd,(ppmaq(n), n = 1,nlim2)
 1065 format(a1,1x,0pf10.4,1pe10.3,0pf10.4,9(1x,g8.3,1x))
c
      if (nctpr .le. nlim2) go to 100
      nlim1 = nlim2 + 1
      nlim2 = min(18,nctpr)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ue
          write (ntabx,1000) uk
        enddo
c
        write (ntabx,1055) ue,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1055) uk,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1000) ue
        write (ntabx,1000) uk
      endif
c
      write (ntabx,1040) ue,xilog,tdays,tlogd,
     $ (lcteaq(n), n = nlim1,nlim2)
      write (ntabx,1065) uk,xilog,tdays,tlogd,
     $ (ppmaq(n), n = nlim1,nlim2)
c
      if (nctpr .le. nlim2) go to  100
      nlim1 = nlim2 + 1
      nlim2 = min(27,nctpr)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uf
          write (ntabx,1000) ul
        enddo
c
        write (ntabx,1055) uf,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1055) ul,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1000) uf
        write (ntabx,1000) ul
      endif
c
      write (ntabx,1040) uf,xilog,tdays,tlogd,
     $ (lcteaq(n), n = nlim1,nlim2)
      write (ntabx,1065) ul,xilog,tdays,tlogd,
     $ (ppmaq(n), n = nlim1,nlim2)
c
      if (nctpr .le. nlim2) go to  100
      nlim1 = nlim2 + 1
      nlim2 = min(36,nctpr)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ug
          write (ntabx,1000) um
        enddo
c
        write (ntabx,1055) ug,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1055) um,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1000) ug
        write (ntabx,1000) um
      endif
c
      write (ntabx,1040) ug,xilog,tdays,tlogd,
     $ (lcteaq(n), n = nlim1,nlim2)
      write (ntabx,1065) um,xilog,tdays,tlogd,
     $ (ppmaq(n), n = nlim1,nlim2)
c
      if (nctpr .le. nlim2) go to  100
      nlim1 = nlim2 + 1
      nlim2 = min(45,nctpr)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uh
          write (ntabx,1000) un
        enddo
c
        write (ntabx,1055) uh,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1055) un,(uelac(n), n = nlim1,nlim2)
        write (ntabx,1000) uh
        write (ntabx,1000) un
      endif
c
      write (ntabx,1040) uh,xilog,tdays,tlogd,
     $ (lcteaq(n), n = nlim1,nlim2)
      write (ntabx,1065) un,xilog,tdays,tlogd,
     $ (ppmaq(n), n = nlim1,nlim2)
c
  100 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write table o. Product solid solution compositions.
c
c                  Endmember compositions of product phases.
c
c     Write header on first pass through.
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uo
        enddo
c
        write (ntabx,2100) uo
 2100 format(a1,20x,'solid solution product compositions')
        write (ntabx,1000) uo
      endif
c
c     First check if solid solution phases are present in matrix.
c
      ktot = kxt - kx1 + 1
c
      if (ktot .le. 0) go to 400
c
c     Go through solid solutions in matrix.
c
      n = 0
      do kcol = kx1,kxt
        ns = iindx1(kcol)
        np = ipndx1(kcol)
        n = n + 1
        uprss(1,n) = uspec(ns)(1:10)
        uprss(2,n) = uspec(ns)(11:20)
        xfrac(n) = xbar(ns)
      enddo
c
c     Write out solid solution name and composition.
c
      nlim = min(6,n)
      write (ntabx,2006) uo,(uprss(1,i),i = 1,nlim)
      write (ntabx,2011) uo,(uprss(2,i),i = 1,nlim)
 2006 format(a1,1x,'   log xi ',8x,6(1x,a10,1x))
 2011 format(a1,19x,6(1x,a10,1x))
      write (ntabx,2007) uo,xilog,(xfrac(i),i = 1,nlim)
 2007 format(a1,4x,f9.4,6x,6(1x,f10.8,1x))
      if (n .gt. nlim) then
        nlim = min(12,n)
        write (ntabx,2008) uo,(uprss(1,i),i = 7,nlim)
        write (ntabx,2008) uo,(uprss(2,i),i = 7,nlim)
        write (ntabx,2009) uo,(xfrac(i),i = 7,nlim)
 2008   format(/,a1,19x,5(1x,a10,1x),1x,a10)
 2009   format(a1,19x,6(1x,f10.8,1x))
      endif
      if (n .gt. nlim) then
        nlim = min(18,n)
        write (ntabx,2008) uo,(uprss(1,i),i = 13,nlim)
        write (ntabx,2008) uo,(uprss(2,i),i = 13,nlim)
        write (ntabx,2009) uo,(xfrac(i),i = 13,nlim)
      endif
      if (n .gt. nlim) then
        nlim = min(24,n)
        write (ntabx,2008) uo,(uprss(1,i),i = 19,nlim)
        write (ntabx,2008) uo,(uprss(2,i),i = 19,nlim)
        write (ntabx,2009) uo,(xfrac(i),i = 19,nlim)
      endif
      if (n .gt. 24) write (ntabx,2051) uo
 2051 format(a1,1x,'number of solid solution product phases > 24')
  400 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write tables p, q, r, and s. Product minerals.
c
c               Log of mass (moles) for closed system
c               Log of cumulative mass (moles) for flow-through
c                  system
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) up
        enddo
c
        if (iopt(1) .eq. 2) then
          write (ntabx,2000) up
 2000     format(a1,20x,'log of moles of product minerals (cumulative)')
        else
          write (ntabx,2002) up
 2002     format(a1,20x,'log of moles of product minerals')
        endif
        write (ntabx,1000) up
      endif
c
      ktot = kxt - km1 + 1
c
      if (ktot .le. 0) go to 200
c
c     ktotlm = no. of minerals that can be printed in the tables.
c
      ktotlm = 36
c
      if (kmt .ge. km1) then
        do kcol = km1,kmt
          n = kcol - km1 + 1
          if (n .gt. ktotlm) go to 125
          np = ipndx1(kcol)
          uprmn(1,n) = uphase(np)(1:8)
          uprmn(2,n) = uphase(np)(9:16)
          uprmn(3,n) = uphase(np)(17:24)
          if (iopt(1) .eq. 2) then
            zvclgx(n) = tlg(mopht(np))
          else
            zvclgx(n) = loph(np)
          endif
cXX  Will eventually have to revise the tab file (-99999. vs. -999.).
          if (zvclgx(n) .lt. -999.) zvclgx(n) = -999.
        enddo
      else
c
c     If all products present are solid solutions, reset counter to 0.
c
        n = 0
      endif
c
      if (kxt .ge. kx1) then
        np1 = 0
        do kcol = kx1,kxt
          ns = iindx1(kcol)
          np = ipndx1(kcol)
c
c         The values of kx1 - kxt correspond to all the endmembers of
c         solid solutions in the PRS. The following line checks to
c         see if the next solid solution phase has been reached.
c
          if (np .ne. np1) then
            np1 = np
            n = n + 1
            if (n .gt. ktotlm) go to 125
            uprmn(1,n) = uphase(np)(1:8)
            uprmn(2,n) = uphase(np)(9:16)
            uprmn(3,n) = uphase(np)(17:24)
            if (iopt(1) .eq. 2) then
              zvclgx(n) = tlg(mopht(np))
            else
              zvclgx(n) = loph(np)
            endif
            if (zvclgx(n) .lt. -999.) zvclgx(n) = -999.
          endif
        enddo
      endif
  125 ktot = n
c
      nlim2 = min(9,ktot)
c
      qphasc = qmod .or. qbye .or. qtitl
      if (qphasc) then
c
        do i = 1,3
          write (ntabx,1000) up
        enddo
c
        write (ntabx,2005) up,(uprmn(1,n), n = 1,nlim2)
 2005   format(a1,1x,'   log xi   time, d   log days ',9(1x,a8,1x))
        write (ntabx,2010) up,(uprmn(2,n), n = 1,nlim2)
 2010   format(a1,32x,9(1x,a8,1x),1x,a8)
        write (ntabx,2010) up,(uprmn(3,n), n = 1,nlim2)
        write (ntabx,1000) up
      endif
c
      write (ntabx,1040) up,xilog,tdays,tlogd,(zvclgx(n), n = 1,nlim2)
c
      if (ktot .le. nlim2) go to 200
      nlim1 = nlim2 + 1
      nlim2 = min(18,ktot)
c
      if (qphasc) then
        do i = 1,3
          write (ntabx,1000) uq
        enddo
c
        write (ntabx,2005) uq,(uprmn(1,n), n = nlim1,nlim2)
        write (ntabx,2010) uq,(uprmn(2,n), n = nlim1,nlim2)
        write (ntabx,2010) uq,(uprmn(3,n), n = nlim1,nlim2)
        write (ntabx,1000) uq
      endif
c
      write (ntabx,1040) uq,xilog,tdays,tlogd,
     $ (zvclgx(n), n = nlim1,nlim2)
c
      if (ktot .le. nlim2) go to 200
      nlim1 = nlim2 + 1
      nlim2 = min(27,ktot)
c
      if (qphasc) then
        do i = 1,3
          write (ntabx,1000) ur
        enddo
c
        write (ntabx,2005) ur,(uprmn(1,n), n = nlim1,nlim2)
        write (ntabx,2010) ur,(uprmn(2,n), n = nlim1,nlim2)
        write (ntabx,2010) ur,(uprmn(3,n), n = nlim1,nlim2)
        write (ntabx,1000) ur
      endif
c
      write (ntabx,1040) ur,xilog,tdays,tlogd,
     $ (zvclgx(n), n = nlim1,nlim2)
c
      if (ktot .le. nlim2) go to 200
      nlim1 = nlim2 + 1
      nlim2 = min(36,ktot)
c
      if (qphasc) then
        do i = 1,3
          write (ntabx,1000) us
        enddo
c
        write (ntabx,2005) us,(uprmn(1,n), n = nlim1,nlim2)
        write (ntabx,2010) us,(uprmn(2,n), n = nlim1,nlim2)
        write (ntabx,2010) us,(uprmn(3,n), n = nlim1,nlim2)
        write (ntabx,1000) us
      endif
c
      write (ntabx,1040) us,xilog,tdays,tlogd,
     $ (zvclgx(n), n = nlim1,nlim2)
c
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write tables t and u. Reactants.
c
c               Log of mass (moles) of reactant destroyed.
c
      if (nrct .le. 0) go to 215
c
      do nrc = 1,nrct
        mx = abs(modr(nrc))
cXX     zvclgx(nrc) = -99999.
        zvclgx(nrc) = -999.
        if (mx .gt. 0.) zvclgx(nrc) = tlg(mx)
      enddo
c
      nlim2 = min(9,nrct)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ut
        enddo
c
        write (ntabx,2020) ut
 2020 format(a1,20x,'log of destroyed moles of reactants')
        write (ntabx,1000) ut
        write (ntabx,2005) ut,(ureac(nrc)(1:8), nrc = 1,nlim2)
        write (ntabx,2010) ut,(ureac(nrc)(9:16), nrc = 1,nlim2)
        write (ntabx,2010) ut,(ureac(nrc)(17:24), nrc = 1,nlim2)
        write (ntabx,1000) ut
      endif
c
      write (ntabx,1040) ut,xilog,tdays,tlogd,
     $ (zvclgx(nrc), nrc = 1,nlim2)
c
      if (nrct .le. nlim2) go to 215
      nlim1 = nlim2 + 1
      nlim2 = min(18,nrct)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uu
        enddo
c
        write (ntabx,2005) uu,(ureac(nrc)(1:8), nrc = nlim1,nlim2)
        write (ntabx,2010) uu,(ureac(nrc)(9:16), nrc = nlim1,nlim2)
        write (ntabx,2010) uu,(ureac(nrc)(17:24), nrc = nlim1,nlim2)
        write (ntabx,1000) uu
      endif
c
      write (ntabx,1040) uu,xilog,tdays,tlogd,
     $ (zvclgx(nrc), nrc = nlim1,nlim2)
c
  215 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write table v. Overall masses and volumes.
c
c               Total mass of solids destroyed, grams
c               Total mass of solids created, grams
c               Net mass of solids created, grams
c               Total volume of solids destroyed, cc
c               Total volume of solids created, cc
c               Net volume of solids created, cc
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uv
        enddo
c
        write (ntabx,2030) uv
 2030   format(a1,1x,'      xi     log xi   time, d   log days   g des',
     $  '     g cre     g net     cc des    cc cre    cc net')
        write (ntabx,1000) uv
      endif
c
      write (ntabx,2035) uv,xi1,xilog,tdays,tlogd,wodrt,wosoct,dwoso,
     $ vodrt,vosoct,dvoso
 2035 format(a1,1x,1pe10.3,0pf10.4,1pe10.3,0pf10.4,8(1pe10.3))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write tables x and y. Affinities of irreversible reactions.
c
c               Affinities of individual reactants, kcal.
c
      if (nrct .le. 0) go to 300
      nlim2 = min(9,nrct)
c
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) ux
        enddo
c
        write (ntabx,2040) ux
 2040   format(a1,20x,'affinities of irreversible reactions')
        write (ntabx,1000) ux
        write (ntabx,2005) ux,(ureac(nrc)(1:8), nrc = 1,nlim2)
        write (ntabx,2010) ux,(ureac(nrc)(9:16), nrc = 1,nlim2)
        write (ntabx,2010) ux,(ureac(nrc)(17:24), nrc = 1,nlim2)
        write (ntabx,1000) ux
      endif
c
      write (ntabx,1040) ux,xilog,tdays,tlogd,
     $ (afrc1(nrc), nrc = 1,nlim2)
c
      if (nrct .le. nlim2) go to 300
      nlim1 = nlim2 + 1
      nlim2 = min(18,nrct)
      if (qtitl) then
        do i = 1,3
          write (ntabx,1000) uy
        enddo
c
        write (ntabx,2005) uy,(ureac(nrc)(1:8), nrc = nlim1,nlim2)
        write (ntabx,2010) uy,(ureac(nrc)(9:16), nrc = nlim1,nlim2)
        write (ntabx,2010) uy,(ureac(nrc)(17:24), nrc = nlim1,nlim2)
        write (ntabx,1000) uy
      endif
c
      write (ntabx,1040) uy,xilog,tdays,tlogd,
     $ (afrc1(nrc), nrc = nlim1,nlim2)
c
  300 continue
c
      end

      subroutine fcopyx(nf1,nf2,nllnmx,ulinex)
c
c     This subroutine appends the contents of the file whose unit
c     number is nf1 to the file whose unit number is nf2. The line
c     length is assumed to be nllnmx characters. The second file
c     must already be open and correctly positioned.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nf1    = unit number of the first file
c       nf2    = unit number of the second file
c       nllnmx = the maximum character length of a line on the
c                scrambled and descrambled files
c       ulinex = variable holding a line
c
c     Output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nf1,nf2
c
      integer nllnmx
c
      integer j1
c
      character(len=nllnmx) ulinex
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j
c
c----------------------------------------------------------------------
c
      rewind nf1
  100 read (nf1,'(a)',end=110) ulinex
      j1 = len_trim(ulinex)
      write (nf2,'(a)') ulinex(1:j1)
      go to 100
c
  110 continue
c
      end

      subroutine tstari(afrc1,alphar,betar,delxi,iodb,modr,nodbmx,
     $ noutpt,nrct,nrctmx,nrct1,nsscmx,qodeok,rirec1,rirecp,rrelr1,
     $ rrelrp,sscrew,time1,tistrt,ureac)
c
c     This subroutine tests the accuracy of the rate law integration
c     by comparing computed rates with predicted values.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       qodeok = logical flag, .true. if the rate law integration
c                  tolerances have been satisfied.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrctmx,nsscmx
c
      integer noutpt
c
      integer iodb(nodbmx)
c
      integer nrct,nrct1
c
      logical qodeok
c
      character*24 ureac(nrctmx)
c
      real(8) afrc1(nrctmx),alphar(nrct1),betar(nrct1),modr(nrctmx),
     $ rrelr1(nrctmx),rrelrp(nrctmx),sscrew(nsscmx)
c
      real(8) delxi,rirec1,rirecp,time1,tistrt
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nrc
c
      integer ilnobl
c
      logical qbad
c
      real(8) atx,etx,rdelmd,rdelti,ss4
c
c-----------------------------------------------------------------------
c
      qodeok = .true.
      qbad = .false.
      ss4 = sscrew(4)**2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nrc = 1,nrct
c
c       The error in a relative rate is acceptable is any of three
c       tests is satisfied.
c
        qbad = .false.
c
c       Test the fractional error in the relative rate.
c
        if (abs(betar(nrc)) .gt. sscrew(4)) then
c
c         Test the absolute error in the relative rate.
c
          if (abs(alphar(nrc)) .gt. ss4) then
            if (abs(modr(nrc)) .le. 0.) then
              qbad = .true.
            else
c
c             Test the error in the moles destroyed for this step
c             against the total moles destroyed.
c
              rdelmd = (alphar(nrc)*delxi)/abs(modr(nrc))
c
              if (abs(rdelmd) .gt. sscrew(3)) qbad = .true.
            endif
          endif
        endif
c
        if (qbad) then
          qodeok = .false.
          if (iodb(2) .ge. 1) then
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1010) ureac(nrc)(1:j2),rrelr1(nrc),
     $      rrelrp(nrc),betar(nrc),afrc1(nrc)
 1010       format(/3x,'Relative rate for ',a,':',
     $      /5x,'Calculated value= ',1pe12.5,
     $      /5x,' Predicted value= ',e12.5,
     $      /5x,'Fractional error= ',e12.5,
     $      /5x,'Affinity= ',e12.5,/)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The error in the inverse rate is acceptable is either of two
c     tests is satisfied.
c
      qbad = .false.
c
c     Test the fractional error in the inverse rate.
c
      if (abs(betar(nrct1)) .gt. sscrew(4)) then
c
c       Test the absolute error in the time.
c
        atx = alphar(nrct1)*delxi
cXX
        if (abs(atx) .gt. 0.) then
          etx = time1 - tistrt
          if (etx.eq. 0.) then
            qbad = .true.
          else
c
            rdelti = atx/etx
c
c           Test the error in the time against the elapsed time.
c
            if (abs(rdelti) .gt. sscrew(3)) qbad = .true.
          endif
        endif
      endif
c
      if (qbad) then
        qodeok = .false.
        if (iodb(2) .ge. 1) then
          write (noutpt,1000) rirec1,rirecp,betar(nrct1),rdelti
 1000     format(/3x,'Inverse rate:',
     $    /5x,'Calculated value= ',1pe12.5,
     $    /5x,' Predicted value= ',e12.5,
     $    /5x,'Fractional error= ',e12.5,
     $    /5x,'Fractional error in time= ',e12.5,/)
        endif
      endif
c
      end

      subroutine cwrpjt(noutpt)
c
c     This subroutine calculates and writes tables of the higher-order
c     electrostatic term functions J(x) and J'(x). These functions may
c     be computed from two different approximate formulations. The
c     first is one given by Pitzer (1975, eq. 47). The second is given
c     by Harvie (1981). Almost all modern application of the Pitzer
c     equations for aqueous electrolyte thermodynamics uses the more
c     recent Harvie formulation. These formulations are all
c     approximate in nature.
c
c     It is important to note that the tabulation in Table II of
c     Pitzer (1975) is not for the formulation represented by
c     eq. 47. Therefore, the results given here for the eq. 47
c     approximation will not precisely match the results given in
c     that table. Pitzer (1975) does not provide such a table for
c     the eq. 47 formulation.
c
c                            References
c
c     Harvie, C. E. 1981. Theoretical Investigations in Geochemistry
c       and Atom Surface Scattering. Ph.D. dissertation, University
c       of California, San Diego (Available as #8203026 from
c       University Microfilms International, Ann Arbor, Michigan).
c
c     Pitzer, K.S. 1975. Thermodynamics of electrolytes. V. Effects
c       of higher-order electrostatic terms. Journal of Solution
c       Chemistry, v. 4, p. 249-265.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       noutpt = unit number of the output file
c
c     Principal output:
c
c       None returned
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ktable,n
c
      logical qpit75
c
      real(8) dhj0,d2hj0,hj0,hj1,hj2,x
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(/1x,"Tables of J(x) and J'(x) (used with Pitzer's",
     $ ' equations)')
c
c     Tables using the Pitzer (1975) table format.
c
      write (noutpt,1010)
 1010 format(//3x,'Tables in the format of Pitzer (1975, Table II)',
     $ /3x,'(Note: that table was for a different approximation than',
     $ /3x,'than Pitzer, 1975, eq. 47, so results for eq. 47 will',
     $ /3x,'not precisely match those in Table II)')
c
      ktable = 1
      qpit75 = .true.
  100 continue
c
      if (qpit75) then
        write (noutpt,1020)
 1020   format(//5x,'Pitzer (1975, eq. 47) formulation')
      else
        write (noutpt,1030)
 1030   format(//5x,'Harvie (1981, Appendix B) formulation')
      endif
c
      write (noutpt,1040)
 1040 format(/7x,"x           J(x)        J'(x)",/)
c
      x = 0.
      do n = 1,10
        x = x + 0.01
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
 1050   format(1x,f9.3,3x,f13.8,3x,f7.4)
      enddo
c
c     x should now be 0.1
c
      do n = 1,5
        x = x + 0.02
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 0.2
c
      do n = 1,10
        x = x + 0.04
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 0.6
c
      do n = 1,7
        x = x + 0.2
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 2.0
c
      do n = 1,8
        x = x + 1.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 10.0
c
      x = x + 2.0
      if (.not.qpit75) then
        call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
      else
        call gpj0(dhj0,d2hj0,hj0,x)
      endif
      write (noutpt,1050) x,hj0,dhj0
c
c     x should now be 12.0
c
      do n = 1,7
        x = x + 4.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 40.0
c
      do n = 1,6
        x = x + 10.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 100.0
c
      x = x + 100.0
      if (.not.qpit75) then
        call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
      else
        call gpj0(dhj0,d2hj0,hj0,x)
      endif
      write (noutpt,1050) x,hj0,dhj0
c
c     x should now be 200.0
c
      do n = 1,4
        x = x + 200.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 1000.0
c
      x = x + 1000.0
      if (.not.qpit75) then
        call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
      else
        call gpj0(dhj0,d2hj0,hj0,x)
      endif
      write (noutpt,1050) x,hj0,dhj0
c
c     x should now be 2000.0
c
      do n = 1,4
        x = x + 2000.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1050) x,hj0,dhj0
      enddo
c
c     x should now be 10000.0
c
      if (ktable .le. 1) then
        qpit75 = .false.
        ktable = ktable + 1
        go to 100
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Tables using the Harvie (1981) table format (extended).
c
      write (noutpt,1060)
 1060 format(//3x,'Tables in the format of Harvie (1981, Appendix B)',
     $ /3x,'(extended format)')
c
      ktable = 1
      qpit75 = .true.
  120 continue
c
      if (qpit75) then
        write (noutpt,1020)
      else
        write (noutpt,1030)
      endif
c
      write (noutpt,1040)
c
      x = 0.
      do n = 1,10
        x = x + 0.001
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
 1070   format(1x,f9.3,3x,f12.7,4x,f10.7)
      enddo
c
c     x should now be 0.01
c
      do n = 1,9
        x = x + 0.01
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 0.1
c
      do n = 1,9
        x = x + 0.1
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 1.0
c
      do n = 1,9
        x = x + 1.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 10.0
c
      do n = 1,9
        x = x + 10.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 100.0
c
      do n = 1,9
        x = x + 100.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 1000.0
c
      do n = 1,9
        x = x + 1000.0
        if (.not.qpit75) then
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
        write (noutpt,1070) x,hj0,dhj0
      enddo
c
c     x should now be 10000.0
c
      if (ktable .le. 1) then
        qpit75 = .false.
        ktable = ktable + 1
        go to 120
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,2000)
 2000 format(/' - - - - - - - - - - - - - - - - - - - - - - - - ',
     $ '- - - - - - ',/)
      end

      subroutine intinx(ier,ixrn1,ixrn2,ncmpr,ncmpri,noutpt,npnxp,
     $ nptmax,nstmax,nttyo,nxicmx,nxti,nxtimx,umemi,uphase,usoli,
     $ uspec,xbar,xbari,xbarlg)
c
c     This subroutine interpets the solid solution compositions
c     specified on the input file.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nptmax,nstmax,nxicmx,nxtimx
c
      integer noutpt,nttyo
c
      integer ncmpr(2,nptmax),ncmpri(2,nxtimx),npnxp(nxtimx)
      integer ier,ixrn1,ixrn2,nxti
c
      character*48 uspec(nstmax)
      character*24 umemi(nxicmx),uphase(nptmax),usoli(nxtimx)
c
      real(8) xbar(nstmax),xbari(nxicmx),xbarlg(nstmax)
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,np,nr1,nr1i,nr2,nr2i,ns,nxi,nxic
c
      integer ilnobl
c
      character*24 uxp,uxs
c
      real(8) xx
c
      real(8) tlg
c
c----------------------------------------------------------------------
c
      ier = 0
      if (nxti .le. 0) go to 999
c
      do nxi = 1,nxti
        npnxp(nxi) = 0
        uxp = usoli(nxi)
c
        do np = ixrn1,ixrn2
          if (uxp(1:24) .eq. uphase(np)(1:24)) go to 100
        enddo
c
        ier = ier + 1
        j2 = ilnobl(uxp)
        write (noutpt,1000) uxp(1:j2)
        write (nttyo,1000) uxp(1:j2)
 1000   format(/' * Error - (EQ3NR/intinx) The solid solution ',a,
     $   /7x,'is on the input file, but not on the data file.')
        go to 130
c
  100   npnxp(nxi) = np
        nr1i = ncmpri(1,nxi)
        nr2i = ncmpri(2,nxi)
        nr1 = ncmpr(1,np)
        nr2 = ncmpr(2,np)
c
        do nxic = nr1i,nr2i
          uxs = umemi(nxic)
c
          do ns = nr1,nr2
            if (uxs(1:24) .eq. uspec(ns)(1:24)) go to 110
          enddo
c
          ier = ier + 1
          j2 = ilnobl(uxs)
          j3 = ilnobl(uxp)
          write (noutpt,1010) uxs(1:j2),uxp(1:j3)
          write (nttyo,1010) uxs(1:j2),uxp(1:j3)
 1010     format(/' * Error - (EQ3NR/intinx) The solid solution',
     $    /7x,'species ',a,' (',a,') is on the'
     $    /7x,'input file, but not on the data file.')
          go to 120
c
  110     continue
          xx = xbari(nxic)
          xbar(ns) = xx
          xbarlg(ns) = tlg(xx)
  120     continue
        enddo
      enddo
c
  130 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine ataylr(delxi,daffp0,nord,nordmx,npt,nptmax,affp0,affp)
c
c     This subroutine evaluates Taylor's series expansions for phase
c     affinities. These expansions are used to find phase boundaries
c     at which new phases appear in the ES.
c
c     Compare with:
c
c       EQ6/ptaylr.f
c       EQ6/rtaylr.f
c       EQ6/ztaylr.f
c
c     This subroutine is called by:
c
c       EQ6/fpbnpp.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       daffp0 = the phase affinity derivative vector at the base point
c       nord   = the order of the truncated Taylor's series
c       nordmx = the maximum order of the truncated Taylor's series
c       npt    = the number of phases
c       nptmax = the maximum number of phases
c       affp0  = the phase affinity vector at the base point
c
c     Principal output:
c
c       affp   = the phase affinity vector at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nordmx,nptmax
c
      integer nord,npt
c
      real*8 affp(nptmax),affp0(nptmax),daffp0(nordmx,nptmax)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,np
c
      real*8 ax,dxp
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      do np = 1,npt
        ax = affp0(np)
        dxp = 1.
        do n = 1,nord
          dxp = dxp*delxi
          ax = ax + ( daffp0(n,np)/fctrl(n) )*dxp
        enddo
        affp(np) = ax
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine chrint(ivar,nttyo,qrderr,ustr)
c
c     This subroutine reads the integer ivar from the character string
c     ustr. The string may contain non-blank characters other than the
c     integer. If there is more than one integer in the string, only the
c     first is read. If the string is completely blank, the integer is
c     returned with a value of zero. If no integer is present and at
c     least one blank is present, the integer is returned with a value
c     of zero.
c
c     The length of the string variable is unknown. A buffer variable
c     which is employed has a character length of ichpar. This limits
c     the size of the substring for the integer.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       nttyo  = unit number of the screen file
c       ustr   = the input string variable
c
c     Output:
c
c       ivar   = the output integer
c       qrderr = logical flag, .true. if a read format error occurred
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nttyo,ivar
c
      logical qrderr
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
      integer ichpar
c
      parameter (ichpar = 16)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ifirst,ipos1,istr,ichars,j2,nchars
c
      integer ifnobl,ilnobl
c
      character*(ichpar) ux
      character*1 uc
c
      logical qsign
c
c-----------------------------------------------------------------------
c
      qrderr = .false.
c
c     Find the position of the first non-blank character in the
c     buffer variable.
c
      ipos1 = ifnobl(ustr)
c
      if (ipos1 .le. 0) then
        ivar = 0
        go to 999
      endif
c
c     Get the length of the string variable.
c
      nchars = len(ustr)
c
c     Find the first integer substring. This must begin with one of the
c     following characters: +-0123456789. The substring is considered
c     found when a number is found. If the substring begins with a
c     "+" or "-" sign, intervening blanks are permitted.
c
      ifirst = 0
      do i = ipos1,nchars
        uc(1:1) = ustr(i:i)
        if (uc.ge.'0' .and. uc.le.'9') then
          if (ifirst .eq. 0) ifirst = i
          go to 100
        elseif (uc .eq. '-') then
          ifirst = i
        elseif (uc .eq. '+') then
          ifirst = i
        elseif (uc .ne. ' ') then
          ifirst = 0
        endif
      enddo
c
c     No integer is present in the string. See if there is at
c     least one blank present.
c
      i = index(ustr,' ')
      if (i .gt. 0) then
        ivar = 0
        go to 999
      endif
c
      j2 = ilnobl(ustr)
      write (nttyo ,1000) ustr(1:j2)
 1000 format(/" * Error - (EQLIBU/chrint) Can't find an integer",
     $ /7x,'to read from the string "',a,'".')
      qrderr = .true.
      go to 999
c
c     Copy the integer field into the buffer string.
c
c       ichars = length of the substring containing the integer
c       qsign  = logical flag denoting the reading of a substring
c                containing an initial '-' or '+' sign followed
c                by zero or more blanks
c
  100 ichars = 0
      qsign = .false.
c
      do istr = ifirst,nchars
        uc(1:1) = ustr(istr:istr)
        if (uc.ge.'0' .and. uc.le.'9') then
c
c         Have encountered a number character in the integer substring.
c
          ichars = ichars + 1
          ux(ichars:ichars) = uc
          qsign = .false.
        elseif (uc.eq.'-' .or. uc.eq.'+') then
c
c         Have encountered a '-' or '+' sign which begins the
c         integer substring.
c
          ichars = ichars + 1
          ux(ichars:ichars) = uc
          qsign = .true.
        elseif (qsign .and. uc.eq.' ') then
c
c         Have encountered a blank between the '-' or '+' sign and
c         the first non-blank character and the integer string.
c         Allow it in the substring.
c
          ichars = ichars + 1
          ux(ichars:ichars) = uc
        else
          go to 110
        endif
      enddo
c
c     Load blank fill.
c
  110 do i = ichars + 1,ichpar
        ux(i:i) = ' '
      enddo
c
c     Read the integer from the string buffer.
c
      read (ux,1010,err=995) ivar
c
c     The format below should specify an integer field which matches
c     the character length of the buffer variable (ichpar).
c
 1010 format(i16)
      go to 999
c
  995 j2 = ilnobl(ux)
      write (nttyo ,1020) ux(1:j2)
 1020 format(/" * Error - (EQLIBU/chrint) Can't read an integer from",
     $ /7x,'the buffer string "',a,'" due to a formatted read error.')
      qrderr = .true.
c
  999 continue
      end

      subroutine arrsim(aamatr,acflg,actlg,bbig,cdrs,cjbasp,cnufac,
     $ conc,conclg,coval,delvec,dlogxw,eh,ehfac,eps100,gmmatr,iction,
     $ iindx1,iodb,ipivot,irdxc3,ixbasp,jcsort,jflag,jjndex,kbt,ker,
     $ khydr,kkndex,kmax,kwater,narn1,narn2,nbasp,nbt,nbti,nbtmax,
     $ nbw,ncosp,ndecsp,ndrs,ndrsmx,ndrsr,nelect,nern1,nern2,nhydr,
     $ nodbmx,no2gaq,noutpt,npass,nredox,nstmax,nttyo,omega,qawfix,
     $ rhsvec,ucospi,uspec,xbar,xbarlg,xbarw,xbrwlg,xlke,xlks,
     $ zchar,zvclg1)
c
c     This subroutine computes starting estimates of species
c     concentrations that must be evaluated simultaneously. These
c     include cases of mean activity constraints, cases of equilibrium
c     constraints, and cases in which the log fO2 is constrained by Eh,
c     pe, or a redox couple.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nodbmx,nstmax
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),iodb(nodbmx),iction(nbtmax),ipivot(kmax),
     $ ixbasp(nbtmax),jcsort(nstmax),jjndex(nbtmax),jflag(nstmax),
     $ kkndex(nbtmax),nbasp(nbtmax),ncosp(nbtmax),ndecsp(nbtmax),
     $ ndrs(ndrsmx),ndrsr(2,nstmax)
c
      integer kbt,ker,khydr,kwater,narn1,narn2,nbt,nbti,nbw,nelect,
     $ nern1,nern2,nhydr,no2gaq,npass,nredox
c
      logical qawfix
c
      character(len=48) ucospi(nbtmax),uspec(nstmax)
c
      real(8) aamatr(kmax,kmax),acflg(nstmax),actlg(nstmax),
     $ cdrs(ndrsmx),cjbasp(nbtmax),cnufac(nstmax),conc(nstmax),
     $ conclg(nstmax),coval(nbtmax),delvec(kmax),dlogxw(nbtmax),
     $ gmmatr(kmax,kmax),rhsvec(kmax),xbar(nstmax),xbarlg(nstmax),
     $ xlks(nstmax),zchar(nstmax),zvclg1(kmax)
c
      real(8) bbig,eh,ehfac,eps100,omega,xbarw,xbrwlg,xlke
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ib,ibt,icol,ielect,ier,ihydr,io2gaq,irdxc3,irow,jfl,
     $ j2,j3,krow,n,nb,nbh,nb1,nb2,nerr,nr1,nr2,ns,nsc,ns1,ns2
c
      integer ilnobl,nbasis
c
      logical qpr,qx
c
      character(len=24) uaqeq,ublk24,ueh,umolfr,ured,ust1,ust2,ust3
      character(len=8) uptgas
c
      real(8) azns,azns1,azsum,cx,cxx,dzx,rx,xbrwlo,zp,zx,zxo
c
      real(8) coefdr,texp
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data umolfr /'Mole fraction           '/
      data ueh    /'Eh                      '/
      data ured   /'Aqueous redox reaction  '/
      data uaqeq  /'Aqueous equilibrium     '/
      data uptgas /'Gas     '/
c
      data qpr    /.false./
c
c-----------------------------------------------------------------------
c
c     Save the current value of the mole fraction of water.
c
      xbrwlo = xbrwlg
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build a structure for a matrix equation. Note that water
c     and its mole fraction relation may or may not be included
c     in this structure. Consequently, the kkndex array is redefined
c     from that built by EQ3NR/dawfix.f.
c
      ihydr = 0
      ielect = 0
      io2gaq = 0
c
      ib = 0
      do krow = 1,kbt
        nb = iindx1(krow)
        kkndex(nb) = 0
        ns = nbasp(nb)
        jfl = jflag(ns)
        qx = .false.
        if (ns .eq. narn1) then
          qx = jfl.eq.0 .and. npass.gt.1 .and. bbig.le.0.1
          qx = qx .or. qawfix
        elseif (ns.eq.nelect .or. ns.eq.no2gaq) then
          qx = irdxc3 .ne. 0
        else
          qx = jfl.eq.17 .or. jfl.eq.18 .or. jfl.eq.21 .or.
     $    jfl.eq.25 .or. jfl.eq.27
        endif
        if (qx) then
          ib = ib + 1
          jjndex(ib) = nb
          kkndex(nb) = 1
          if (ns .eq. nhydr) ihydr = ib
          if (ns .eq. nelect) ielect = ib
          if (ns .eq. no2gaq) io2gaq = ib
        endif
      enddo
      ibt = ib
c
c     Quit if no species concentrations are to be solved simultaneously.
c
      if (ibt. le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the iction array, which supports the jflag = 17, 18, and 21
c     options.
c
      do nb = 1,nbt
        iction(nb) = 0
      enddo
c
      do irow = 1,ibt
        nb = jjndex(irow)
        ns = nbasp(nb)
        jfl = jflag(ns)
        ns1 = 0
        if (jfl.eq.17 .or. jfl.eq.18 .or. jfl.eq.21) then
          ns1 = ncosp(nb)
c
c         Calling sequence substitutions:
c           ns1 for ns
c
          nb1 = nbasis(nbasp,nbt,nbtmax,ns1)
          if (nb1 .eq. 0) then
            j3 = ilnobl(uspec(ns)(1:24))
            j2 = ilnobl(uspec(ns1)(1:24))
            write (noutpt,1000) uspec(ns1)(1:j2),uspec(ns)(1:j3)
            write (nttyo,1000) uspec(ns1)(1:j2),uspec(ns)(1:j3)
 1000       format(/' * Error - (EQ3NR/arrsim) The specified',
     $      ' counterion',/7x,a,' in the',/7x,'jflag = 17, 18, or',
     $      ' 21 option  for the basis species',/7x,a," isn't in",
     $      ' the basis set.')
            stop
          endif
          if (kkndex(nb1) .ge. 1) then
            do icol = 1,ibt
              nb2 = jjndex(icol)
              if (nb2 .eq. nb1) then
                iction(nb) = icol
                go to 110
              endif
            enddo
          endif
        endif
  110   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Optional print of the matrix structure.
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1020)
 1020   format(/7x,'--- Structure for Simultaneous Evaluation of',
     $  ' Starting Estimates ---',/)
c
        do irow = 1,ibt
          nb1 = jjndex(irow)
          ns1 = nbasp(nb1)
          jfl = jflag(ns1)
          ust1 = uspec(ns1)
          ust3 = ublk24
c
          if (ns1 .eq. narn1) ust2 = umolfr
c
          if (ns1.eq.nelect .or. ns1.eq.no2gaq) then
            if (ncosp(nb1) .eq. 0) then
              if (irdxc3 .lt. 0) then
                ust2 = ueh
              else
                ust2 = ured
              endif
              go to 120
            endif
          endif
c
          if (jfl .eq. 17) then
            ns = ncosp(nb1)
            ust2 = 'Log activity combination'
            ust3 = uspec(ns)
          elseif (jfl .eq. 18) then
            ns = ncosp(nb1)
            ust2 = 'Mean log activity'
            ust3 = uspec(ns)
          elseif (jfl .eq. 21) then
            ns = ncosp(nb1)
            ust2 = 'pHCl'
            ust3 = uspec(ns)
          elseif (jfl .eq. 27) then
            ust2 = uaqeq
          else
            do nb = 1,nbti
              nb2 = ndecsp(nb)
              if (nb1 .eq. nb2) then
                ust2 = ucospi(nb)(1:24)
                ust3 = ucospi(nb)(25:48)
                go to 120
              endif
            enddo
          endif
c
  120     j2 = ilnobl(ust2)
          write (noutpt,1030) irow,ust1,ust2(1:j2)
 1030     format(2x,i5,2x,a24,2x,a)
          j3 = ilnobl(ust3)
          if (ust3(1:24) .ne. ublk24(1:24))
     $    write (noutpt,1040) ust3(1:j3)
 1040     format(37x,'Constraint species= ',a)
        enddo
c
        write (noutpt,1050)
 1050   format(//10x,'--- The zvclg1 and acflg Values ---',/)
c
        do krow = 1,kbt
          nb = iindx1(krow)
          ns = nbasp(nb)
          if (kkndex(nb) .le. 0) then
            write (noutpt,1060) krow,uspec(ns),zvclg1(krow),acflg(ns)
 1060       format(2x,i5,2x,a24,2x,f10.4,2x,f10.4)
          endif
        enddo
c
        write (noutpt,1070)
 1070   format(/1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the cnufac array.
c
      do nsc = narn1,narn2
        cnufac(nsc) = 0.
      enddo
c
      nr1 = ndrsr(1,narn1)
      if (jflag(narn1) .eq. 30) cnufac(narn1) = xbarlg(narn1)/cdrs(nr1)
c
      do nsc = narn1 + 1,narn2
        nr1 = ndrsr(1,nsc)
        if (jflag(nsc) .eq. 30) cnufac(nsc) = conc(nsc)/cdrs(nr1)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build the matrix.
c
      do icol = 1,ibt
        do irow = 1,ibt
          aamatr(irow,icol) = 0.
        enddo
      enddo
c
      do irow = 1,ibt
        nb = jjndex(irow)
        ns = nbasp(nb)
        jfl = jflag(ns)
c
        if (ns .eq. narn1) then
c
c         Mole fraction of water, based on a first-order expansion:
c           log x(w)(new) = log x(w)(old)
c             + sum over s' in irow (d log x(w)/d log m(s'))
c               * (log m(s')(new) - log m(s')(old))
c
c         Compute the dlogxw array (d log xw/d log ms').
c
          call gdlgxw(cdrs,cjbasp,cnufac,conc,dlogxw,eps100,
     $    ixbasp,jcsort,jflag,narn1,narn2,nbasp,nbt,nbtmax,nbw,
     $    ndrs,ndrsmx,ndrsr,nern1,nern2,noutpt,nstmax,nttyo,omega,
     $    xbar,xbarw)
c
          do icol = 1,ibt
            nb1 = jjndex(icol)
            aamatr(irow,icol) = -dlogxw(nb1)
          enddo
          aamatr(irow,irow) = 1.0
        elseif (jfl .eq. 17) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          aamatr(irow,irow) = azns1
          icol = iction(nb)
          if (icol .gt. 0) then
            zp = zchar(ns)*zchar(ns1)
            if (zp .lt. 0) then
              aamatr(irow,icol) = azns
            else
              aamatr(irow,icol) = -azns
            endif
          endif
        elseif (jfl .eq. 18) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          azsum = azns + azns1
          aamatr(irow,irow) = azns1/azsum
          icol = iction(nb)
          if (icol .gt. 0) aamatr(irow,icol) = azns/azsum
        elseif (jfl .eq. 21) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          aamatr(irow,irow) = -azns1
          icol = iction(nb)
          if (icol .gt. 0) then
            zp = zchar(ns)*zchar(ns1)
            if (zp .lt. 0) then
              aamatr(irow,icol) = -azns
            else
              aamatr(irow,icol) = azns
            endif
          endif
        elseif (jfl .eq. 27) then
          do icol = 1,ibt
            nb1 = jjndex(icol)
            ns1 = nbasp(nb1)
c
c           Calling sequence substitutions:
c             ns1 for nse
c
            aamatr(irow,icol) =
     $      coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns,nstmax)
          enddo
c
c         Calling sequence substitutions:
c           ns for nse
c
          aamatr(irow,irow)
     $    = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns,ns,nstmax)
        elseif (jfl .eq. 25) then
          ns1 = ncosp(nb)
          do icol = 1,ibt
            nb2 = jjndex(icol)
            ns2 = nbasp(nb2)
c
c           Calling sequence substitutions:
c             ns2 for nse
c             ns1 for ns
c
            aamatr(irow,icol)
     $      = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns2,ns1,nstmax)
          enddo
        elseif (irdxc3 .lt. 0) then
          aamatr(irow,io2gaq) = 1.
          if (ihydr .gt. 0) aamatr(irow,ihydr) = 4.
        else
          do icol = 1,ibt
            nb1 = jjndex(icol)
            ns1 = nbasp(nb1)
            if (kkndex(nb1).gt.0) then
c
c             Calling sequence substitutions:
c               ns1 for nse
c               nredox for ns
c
              aamatr(irow,icol)
     $        = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,nredox,nstmax)
c
            endif
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1100)
 1100   format(/10x,'--- Matrix ---',/)
        do irow = 1,ibt
          write (noutpt,1110) (aamatr(irow,icol), icol = 1,ibt)
 1110     format(2x,10(f7.2,2x))
        enddo
        write (noutpt,1070)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build the right-hand-side vector.
c
      do irow = 1,ibt
        nb = jjndex(irow)
        ns = nbasp(nb)
        jfl = jflag(ns)
c
        if (ns .eq. narn1) then
c
c         Mole fraction of water, based on a first-order expansion:
c           log x(w)(new) = log x(w)(old)
c             + sum over s' in irow (d log x(w)/d log m(s'))
c               * (log m(s')(new) - log m(s')(old))
c
          rx = xbrwlo
          do krow = 1,kbt
            if (krow .ne. kwater) then
              nb1 = iindx1(krow)
              if (kkndex(nb1) .ge. 1)
     $        rx = rx - dlogxw(nb1)*zvclg1(krow)
            endif
          enddo
          rhsvec(irow) = rx
        elseif (jfl .eq. 17) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          rx = coval(nb) - azns1*acflg(ns)
          zp = zchar(ns)*zchar(ns1)
          if (zp .lt. 0.) then
            rx = rx - azns*acflg(ns1)
          else
            rx = rx + azns*acflg(ns1)
          endif
          icol = iction(nb)
          if (icol .eq. 0) then
            if (zp .lt. 0.) then
              rx = rx - azns*conclg(ns1)
            else
              rx = rx + azns*conclg(ns1)
            endif
          endif
          rhsvec(irow) = rx
        elseif (jfl .eq. 18) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          azsum = azns + azns1
          rx = coval(nb) - ( azns1/azsum )*acflg(ns)
     $    - ( azns/azsum )*acflg(ns1)
          icol = iction(nb)
          if (icol .eq. 0) rx = rx - ( azns/azsum )*conclg(ns1)
          rhsvec(irow) = rx
        elseif (jfl .eq. 21) then
          ns1 = ncosp(nb)
          azns = abs(zchar(ns))
          azns1 = abs(zchar(ns1))
          rx = coval(nb) + azns1*acflg(ns)
          zp = zchar(ns)*zchar(ns1)
          if (zp .lt. 0.) then
            rx = rx + azns*acflg(ns1)
          else
            rx = rx - azns*acflg(ns1)
          endif
          icol = iction(nb)
          if (icol .eq. 0) then
            if (zp .lt. 0.) then
              rx = rx + azns*conclg(ns1)
            else
              rx = rx - azns*conclg(ns1)
            endif
          endif
          rhsvec(irow) = rx
        elseif (jfl .eq. 27) then
          if (iodb(3) .ge. 3) then
c
c           Calling sequence substitutions:
c             noutpt for nf
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns,nstmax,uspec)
          endif
          rx = xlks(ns)
          nr1 = ndrsr(1,ns)
          nr2 = ndrsr(2,ns)
          do n = nr1,nr2
            ns2 = ndrs(n)
            cx = cdrs(n)
            if (ns2 .eq. narn1) then
              rx = rx - cx*actlg(narn1)
            else
c
c             Calling sequence substitutions:
c               ns2 for ns
c
              nb2 = nbasis(nbasp,nbt,nbtmax,ns2)
              if (kkndex(nb2) .le. 0) then
                rx = rx - cx*actlg(ns2)
              else
                rx = rx - cx*acflg(ns2)
              endif
            endif
          enddo
          rhsvec(irow) = rx
        elseif (jfl .eq. 25) then
          ns1 = ncosp(nb)
          if (iodb(3) .ge. 3) then
c
c           Calling sequence substitutions:
c             noutpt for nf
c             ns1 for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns1,nstmax,uspec)
          endif
          rx = xlks(ns1)
          nr1 = ndrsr(1,ns1)
          nr2 = ndrsr(2,ns1)
          do n = nr1,nr2
            ns2 = ndrs(n)
            cx = cdrs(n)
            if (ns2 .eq. ns1) then
              if (uspec(ns1)(25:32) .eq. uptgas(1:8)) then
                rx = rx - cx*coval(nb)
              else
                rx = rx - cx*actlg(ns1)
              endif
            elseif (ns2 .eq. narn1) then
              rx = rx - cx*actlg(narn1)
            else
c
c             Calling sequence substitutions:
c               ns2 for ns
c
              nb2 = nbasis(nbasp,nbt,nbtmax,ns2)
              if (kkndex(nb2) .le. 0) then
                rx = rx - cx*actlg(ns2)
              else
                rx = rx - cx*acflg(ns2)
              endif
            endif
          enddo
          rhsvec(irow) = rx
        elseif (irdxc3 .lt. 0) then
          rx = 4.*eh/ehfac
          rx = rx + xlke + 2.*actlg(narn1)
          rx = rx - 4.*acflg(nhydr)
          nbh = iindx1(khydr)
          if (kkndex(nbh) .le. 0) rx = rx - 4.*conclg(nhydr)
          rhsvec(irow) = rx
        elseif (irdxc3 .gt. 0) then
          rx = xlks(nredox)
          nr1 = ndrsr(1,nredox)
          nr2 = ndrsr(2,nredox)
          do n = nr1,nr2
            ns2 = ndrs(n)
            cx = cdrs(n)
            if (ns2 .eq. narn1) then
              rx = rx - cx*actlg(narn1)
            else
c
c             Calling sequence substitutions:
c               ns2 for ns
c
              nb2 = nbasis(nbasp,nbt,nbtmax,ns2)
              if (kkndex(nb2) .le. 0) then
                rx = rx - cx*actlg(ns2)
              else
                rx = rx - cx*acflg(ns2)
              endif
            endif
          enddo
          rhsvec(irow) = rx
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1200)
 1200   format(/10x,'--- Right-Hand-Side Vector ---',/)
        do irow = 1,ibt
          nb = jjndex(irow)
          ns = nbasp(nb)
          write (noutpt,1210) irow,uspec(ns),rhsvec(irow)
 1210     format(1x,i5,2x,a24,2x,g12.5)
        enddo
        write (noutpt,1070)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Solve the matrix equation.
c
c     Calling sequence substitutions:
c       ibt for kdim
c
      call msolvr(aamatr,delvec,gmmatr,ier,ipivot,ibt,kmax,
     $ noutpt,nttyo,qpr,rhsvec)
c
      if (ier .gt. 0) then
        write (noutpt,1220)
        write (nttyo,1220)
 1220   format(/' * Error - (EQ3NR/arrsim) The matrix equation',
     $  /7x,'required by the speciation model appears to be',
     $  /7x,'singular. Check the solubility and other constraints',
     $  /7x,'on the input file for a violation of the mineralogic',
     $  /7x,'phase rule.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Apply change limits and range limits. Then load the results.
c
      irow = 0
      do krow = 1,kbt
        nb = iindx1(krow)
        if (kkndex(nb) .ge. 1) then
          irow = irow + 1
          zx = delvec(irow)
          zxo = zvclg1(krow)
          if (zxo .gt. -99999.) then
            dzx = zx - zxo
            if (ns1 .eq. narn1) then
              if (dzx .gt. 0.2) dzx = 0.2
              if (dzx .lt. -0.2) dzx = -0.2
            else
              if (dzx .gt. 2.0) dzx = 2.0
              if (dzx .lt. -2.0) dzx = -2.0
            endif
            zx = zxo + dzx
          endif
          if (ns1.eq.narn1 .and. zx.gt.0.) zx = 0.
          if (zx .gt. 2.0) zx = 2.0
          if (zx .lt. -100.) zx = -100.
          zvclg1(krow) = zx
          ns = nbasp(nb)
          conclg(ns) = zx
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1050)
        do krow = 1,kbt
          nb = iindx1(krow)
          ns = nbasp(nb)
          if (kkndex(nb) .ge. 1)
     $    write (noutpt,1060) krow,uspec(ns),zvclg1(krow),acflg(ns)
        enddo
        write (noutpt,1070)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check possible effects of large concentrations resulting from
c     equilibrium constraints.
c
      i = ibt
      if (ielect.gt.0 .or. io2gaq.gt.0) i = i - 1
      if (i .le. 0) go to 999
      nerr = 0
c
      do krow = 1,kbt
        nb = iindx1(krow)
        ns = nbasp(nb)
        if (kkndex(nb).ge.1 .and. ns.ne.nelect .and. ns.ne.no2gaq) then
          cx = conclg(ns)
          cxx = texp(cx)
          if (cxx .gt. 20.) then
            ker = 1
            j2 = ilnobl(uspec(ns)(1:24))
            write (noutpt,1230) uspec(ns)(1:j2),cxx
            write (nttyo,1230) uspec(ns)(1:j2),cxx
 1230       format(/' * Note - (EQ3NR/arrsim) The species ',a,
     $      /7x,'appears to have a required molality near ',g12.5)
            if (npass.gt.1 .and. cxx.gt.100.) nerr = nerr + 1
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) then
        write (noutpt,1240)
        write (nttyo,1240)
 1240   format(/' * Error - (EQ3NR/arrsim) Reconsider your choice ',
     $  /7x,'of input constraints.')
        ker = 2
        go to 999
      endif
c
      if (ker .eq. 1) then
        write (noutpt,1250)
        write (nttyo,1250)
 1250   format(/' * Warning - (EQ3NR/arrsim) This run may crash',
     $  /7x,'because of poor choice of input constraints.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine sortsp(iern1,iern2,istack,jcsort,jern1,jern2,
     $ jgext,jsitex,jetmax,jjsort,jssort,jstack,losp,lsort,ncmpr,
     $ nern1,nern2,netmax,noutpt,nphasx,npt,nptmax,nst,nstmax,nttyo)
c
c     This subroutine sorts the species in order of increasing mass.
c
c     This subroutine is called by:
c
c       EQLIB/ncmpex.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jern1  = array marking the start of a site range for a
c                  generic ion exchange phase
c       jern2  = array marking the end of a site range for a
c                  generic ion exchange phase
c       iern1  = start of the phase range for generic ion exchange
c                  phases
c       iern2  = end of the phase range for generic ion exchange
c                  phases
c       jgext  = array giving the number of sites in generic
c                  generic ion exchange phases
c       jsitex = site index array, gives the site to which a
c                  species belongs
c       losp   = array of logarithms of numbers of moles of species
c       ncmpr  = species index array, gives the first and last
c                  species in a given phase
c       nern1  = start of the species range for generic ion exchange
c                  phases
c       nern2  = end of the species range for generic ion exchange
c                  phases
c       nphasx = phase index array, gives the phase to which a
c                  species belongs
c       nst    = number of species
c
c     Principal output:
c
c       jcsort = species index array, arranged in order of increasing
c                  mass, but arranged according to phase
c       jjsort = species index array, arranged in order of increasing
c                  mass, but arranged according to site and phase
c       jssort = species index array, arranged in order of increasing
c                  mass
c
c     Scratch arrays:
c
c       lsort, istack, and jstack
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations:
c
      integer jetmax,netmax,nptmax,nstmax
c
      integer noutpt,nttyo
c
      integer iern1,iern2,nern1,nern2
c
      integer istack(nstmax),jcsort(nstmax),jern1(jetmax,netmax),
     $ jern2(jetmax,netmax),jgext(netmax),jjsort(nstmax),
     $ jsitex(nstmax),jssort(nstmax),jstack(nstmax),ncmpr(2,nptmax),
     $ nphasx(nstmax)
c
      integer npt,nst
c
      real*8 losp(nstmax),lsort(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer je,ne,np,nrr1,nrr2,ns,nss,nsi
c
c-----------------------------------------------------------------------
c
c     Sort all species according to numbers of moles. There indices
c     in sorted order in the jssort array. Species belonging to
c     different phases are mixed together in this sort.
c
c     Calling sequence substitutions:
c       lsort for asort
c       losp for aval
c       jssort for jsort
c       nstmax for nmax
c       nst for nval
c
c     Caution: the jssort array from the last call is recycled as a
c     good starting point. Set jssort(1) to 0 to make a sort starting
c     from scratch.
c
      call qsortw(lsort,losp,istack,jssort,jstack,nstmax,noutpt,
     $ nttyo,nst)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the jcsort array using the jssort array already computed.
c     In this array, the species belonging to a given phase are grouped
c     together within the specified phase limits. The scratch array
c     istack is used here to represent the next available species
c     position within the range for any given phase. Note that istack
c     is dimensioned 1:nstmax. Here it must be of length at least
c     nptmax, which is necessarily no greater than nstmax.
c
      do np = 1,npt
        istack(np) = ncmpr(1,np)
      enddo
c
      do nss = 1,nst
        ns = jssort(nss)
        np = nphasx(ns)
        nsi = istack(np)
        jcsort(nsi) = ns
        istack(np) = istack(np) + 1
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the jjsort array using the jcsort array already computed.
c     In this array, the species belonging to a given phase are grouped
c     together within the specified site limits. Presently only generic
c     ion exchange phases have sites in the present context. In the
c     future, other types of phases with distinct sites may be added
c     to the list. Phases without distinct sites are treated as having
c     "one" site.
c
c     The scratch array istack is used here to represent the next
c     available species position within the range for any given site
c     of the phase currently being processed. any given phase. Note
c     that istack is dimensioned 1:nstmax. Here it must have a length
c     of at least the maximum number of species in any possible phase,
c     which is necessarily no greater than nstmax.
c
      do ns = 1,nst
        jjsort(ns) = jcsort(ns)
      enddo
c
      do ns = nern1,nern2
        jjsort(ns) = 0
      enddo
c
      do np = iern1,iern2
        ne = np - iern1 + 1
        do je = 1,jgext(ne)
          istack(je) = jern1(je,ne)
        enddo
c
        nrr1 = ncmpr(1,np)
        nrr2 = ncmpr(2,np)
        do nss = nrr1,nrr2
          ns = jcsort(nss)
          je = jsitex(ns)
          nsi = istack(je)
          jjsort(nsi) = ns
          istack(je) = istack(je) + 1
        enddo
      enddo
c
      end

      subroutine dumpdp(csts,demop0,demos0,emop,emop0,emos,
     $ emos0,fdpe0,fdpem1,fdse0,fdsem1,iemop,iemos,iern1,iern2,
     $ ietmax,iindx0,iindx1,imrn1,imrn2,iodb,ipndx0,ipndx1,ixrn1,
     $ ixrn2,jcsort,jern1,jetmax,jgext,jpflag,jsflag,kbt,kdim,
     $ kdim0,kmax,km1,km10,kmt,kmt0,kord,kstep,kx1,kx10,kxt,
     $ kxt0,loph,losp,moph,mosp,mprph,mprsp,mrgexs,mtb,mtb0,
     $ nbasp,nbaspd,nbt,nbtmax,ncmpe,ncmpr,ndelay,netmax,
     $ ngext,nodbmx,nordmx,noutpt,npet,npetmx,npet0,npt,nptmax,
     $ npts,nset,nsetmx,nset0,nstmax,nsts,nstsmx,nstsr,nttyo,
     $ qbye,uaqsln,ufixf,uspec,uphase,uzvec0,uzvec1,xbar,
     $ xbarlg,zklgmn,zklogl,zvclg0,zvclg1,zvec0,zvec1)
c
c     This subroutine transfers the entire mass of eligible phases
c     in the Equilibrium System (ES) to the Physically Removed System
c     (PRS). The eligible phases exclude the aqueous solution phase
c     and any fictive fugacity-fixing phases. The ES phase membership
c     and the corresponding finite-difference representations are
c     changed accordingly.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,netmax,nodbmx,nordmx,npetmx,
     $ nptmax,nsetmx,nstmax,nstsmx
c
      integer noutpt,nttyo
c
      integer iemop(npetmx),iemos(nsetmx),iindx0(kmax),iindx1(kmax),
     $ iodb(nodbmx),ipndx0(kmax),ipndx1(kmax),jcsort(nstmax),
     $ jern1(jetmax,netmax),jgext(netmax),jpflag(nptmax),jsflag(nstmax),
     $ nbasp(nbtmax),nbaspd(nbtmax),ncmpe(2,npetmx),ncmpr(2,nptmax),
     $ ngext(jetmax,netmax),nsts(nstsmx),nstsr(2,nstmax)
c
      integer iern1,iern2,imrn1,imrn2,ixrn1,ixrn2,kbt,kdim,kdim0,
     $ km1,km10,kmt,kmt0,kord,kstep,kx1,kx10,kxt,kxt0,nbt,ndelay,
     $ npet,npet0,npt,npts,nset,nset0
c
      logical qbye
c
      character*48 uspec(nstmax),uzvec0(kmax),uzvec1(kmax)
      character*24 uphase(nptmax)
      character*24 uaqsln
      character*8 ufixf
c
      real*8 csts(nstsmx),demop0(nordmx,npetmx),demos0(nordmx,nsetmx),
     $ emop(npetmx),emop0(npetmx),emos(nsetmx),emos0(nsetmx),
     $ fdpe0(nordmx,npetmx),fdpem1(nordmx,npetmx),
     $ fdse0(nordmx,nsetmx),fdsem1(nordmx,nsetmx),loph(nptmax),
     $ losp(nstmax),moph(nptmax),mosp(nstmax),mprph(nptmax),
     $ mprsp(nstmax),mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),
     $ mtb0(nbtmax),xbar(nstmax),xbarlg(nstmax),zvclg0(kmax),
     $ zvclg1(kmax),zvec0(kmax),zvec1(kmax)
c
      real*8 zklgmn,zklogl
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ier,j2,kcol,nmax,np,npe,nr1,nr2,ns,nse
c
      integer ilnobl
c
      logical qprflg,qshftd,qtotsh
c
c-----------------------------------------------------------------------
c
c     Do a total shift of any eligible ES phase whose mass has begun
c     to decrease.
c
      qtotsh = .true.
      qshftd = .false.
c
      do npe = 1,npet
        if (fdpe0(1,npe) .lt. 0.) then
          np = iemop(npe)
          if (uphase(np)(1:24) .ne. uaqsln(1:24)) then
            if (uphase(np)(1:5) .ne. ufixf(1:5)) then
              j2 = ilnobl(uphase(np))
              write (noutpt,1000) uphase(np)(1:j2)
 1000         format(/' --- ',a,' is no longer precipitating ---')
              if (iodb(1) .ge. 1) then
                write (noutpt,1010) emos(npe),fdpe0(1,npe)
 1010           format(/'   Mass= ',1pe12.5,' moles',
     $          /'   Two-point relative rate= ',1pe12.5,' mol/mol',/)
              endif
c
              call shftph(emop,emop0,emos,emos0,fdpe0,fdpem1,
     $        fdse0,fdsem1,iemop,iemos,iern1,iern2,ietmax,iindx1,
     $        imrn1,imrn2,ipndx1,ixrn1,ixrn2,jern1,jetmax,jgext,
     $        jpflag,jsflag,kbt,kmax,km1,kmt,kx1,kxt,loph,losp,moph,
     $        mosp,mprph,mprsp,mrgexs,nbtmax,ncmpe,ncmpr,netmax,
     $        ngext,nordmx,noutpt,np,npet,npetmx,nptmax,nsetmx,
     $        nstmax,nttyo,qshftd,qtotsh,uphase,xbar,xbarlg,zklgmn,
     $        zklogl,zvclg0,zvclg1,zvec0,zvec1)
c
              jpflag(np) = 0
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              do ns = nr1,nr2
                if (jsflag(ns) .eq. -10) jsflag(ns) = 0
              enddo
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qshftd) then
        qbye = .true.
        kord = 0
        ndelay = 1
        npts = 1
        qprflg = iodb(10) .ge. 1
c
        call escalc(csts,iindx1,jcsort,kbt,kmax,moph,mosp,mtb,
     $  mtb0,nbaspd,nbt,nbtmax,ncmpr,noutpt,npt,nptmax,nstmax,nsts,
     $  nstsmx,nstsr,qprflg,uspec)
c
        call miidxz(ier,iindx1,ipndx1,jpflag,jsflag,kbt,kdim,
     $  kmax,km1,kmt,kx1,kxt,losp,ncmpr,noutpt,npt,nptmax,nstmax,
     $  nttyo,uspec,uzvec1,zvclg1,zvec1)
c
        if (ier .gt. 0) then
          write (noutpt,1020)
          write (nttyo,1020)
 1020     format(/' * Error - (EQ6/dumpdp) Programming error trap:',
     $    "Can't recover from",/7x,'having exceeded the maximum ',i4,
     $    ' elements of the iindx1 array. This should',/7x,'not be',
     $    ' possible in the present subroutine.')
          stop
        endif
c
        kdim0 = kdim
        kxt0 = kxt
        kmt0 = kmt
        km10 = km1
        kx10 = kx1
        do kcol = 1,kdim
          iindx0(kcol) = iindx1(kcol)
          ipndx0(kcol) = ipndx1(kcol)
          uzvec0(kcol) = uzvec1(kcol)
          zvclg0(kcol) = zvclg1(kcol)
          zvec0(kcol) = zvec1(kcol)
        enddo
c
c       The ES phase assemblage has changed. Re-set the index arrays
c       associated with finite-difference description of the numbers
c       of mole of phases and species in the Equilibrium System (ES).
c
        call iiemop(iemop,iemos,iindx1,ipndx1,jsflag,kdim,kmax,
     $  ncmpe,ncmpr,noutpt,npet,npetmx,npt,nptmax,nset,nsetmx,nstmax,
     $  nttyo,uaqsln,uspec,uphase)
c
        npet0 = npet
        nset0 = nset
c
        nmax = nordmx*npetmx
        call initaz(fdpe0,nmax)
        call initaz(fdpem1,nmax)
        call initaz(demop0,nmax)
c
        nmax = nordmx*nsetmx
        call initaz(fdse0,nmax)
        call initaz(fdsem1,nmax)
        call initaz(demos0,nmax)
c
        do npe = 1,npet
          np = iemop(npe)
          emop0(npe) = moph(np)
          emop(npe) = moph(np)
          nr1 = ncmpe(1,npe)
          nr2 = ncmpe(2,npe)
          do nse = nr1,nr2
            ns = iemos(nse)
            emos0(nse) = mosp(ns)
            emos(nse) = mosp(ns)
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine gspidx(ier,n,nat,natmax,uaqsp,unams)
c
c     Get the index (n) of the aqueous species whose name is unams.
c
c     This subroutine is called by:
c
c       EQPT/rdpz2.f
c       EQPT/rdpz3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c       unams  = the name of an aqueous species whose index n is
c                  desired
c
c     Principal output:
c
c       ier    = error flag
c       n      = the index of the species unams in the uaqsp array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax
c
      integer ier,n,nat
c
      character*24 uaqsp(natmax)
      character*24 unams
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c
c-----------------------------------------------------------------------
c
      ier = 0
      do n = 1,nat
        if (unams(1:24) .eq. uaqsp(n)(1:24)) then
          go to 100
        endif
      enddo
c
c     The species was not found. Set the error flag.
c
      ier = 1
      n = 0
c
  100 continue
c
      end

      subroutine nrstep(aamatr,acflg,act,actlg,afcnst,alpha,al10,amtb,
     $ bbig,beta,betamx,betao,betfnc,betmxo,bneg,bpx,btfcnr,cdrs,cdrtw,
     $ cdrw,cegexs,cgexj,cjbasp,cnufac,conc,conclg,cpgexs,csts,coval,
     $ delfnc,delmax,delvco,delvec,dlogxw,egexjc,egexjf,egexs,eh,ehfac,
     $ eps100,fo2,fo2lg,fsort,fugac,fugalg,gmmatr,ibetmx,ibpxmx,idelmx,
     $ iebal,ier,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,iindx1,
     $ ilrn1,ilrn2,imrn1,imrn2,iodb,ipivot,ipndx1,irdxc3,istack,iter,
     $ itermx,ixbasp,ixrn1,ixrn2,jcsort,jern1,jern2,jetmax,jflag,jgext,
     $ jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,kmax,kmt,km1,ko2gaq,kwater,kxt,kx1,
     $ loph,losp,lsort,mgext,moph,mosp,mrgexs,mtb,narn1,narn2,nbasp,
     $ nbt,nbtmax,nbw,ncmpr,ncosp,ndrs,ndrsmx,ndrsr,negbfc,negdfc,
     $ negxfc,nelect,nern1,nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,
     $ ngtmax,nhydr,nodbmx,noibfc,noutpt,no2gaq,npconv,nphasx,npobfc,
     $ npodfc,npt,nptmax,nredox,nst,nstmax,nsts,nstsmx,nstsr,ntfx,
     $ ntfxmx,ntfxt,nttyo,nxtmax,omega,omeglg,press,qcacf,qcbeta,
     $ qredox,qxbarw,q6mode,rhsvec,rlxfac,screwd,screwn,sigmam,sigmmo,
     $ tfx,ubetmx,ubbig,ubneg,ugexj,ugexmo,uphase,uspec,uzvec1,weight,
     $ xbar,xbarlg,xbarw,xbarwc,xbrwlc,xbrwlg,xlke,xlks,zchar,zgexj,
     $ zvclg1,zvec1)
c
c     This subroutine performs one Newton-Raphson step.
c
c     This subroutine is called by:
c
c       EQLIB/newton.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       iodb   = array of debugging print options
c       ipivot = the pivot vector
c       screwd = under-relaxation control parameter. It is used to
c                  reduce the magnitude of the delvec vector, if
c                  necessary, so that the magnitude of the largest
c                  element of that vector does not exceed screwd
c       screwn = under-relaxation control parameter
c       itermx = maximum number of iterations
c       kdim   = dimension of aamatr
c       kmax   = maximum dimension of aamatr
c       qcbeta = true if the convergence criterion on betamx was met
c       qcacf  = true if the convergence criterion on activity
c                  coefficients was met
c
c     Principal output:
c
c       aamatr = Jacobian matrix
c       gmmatr = copy of aamatr
c       rhsvec = right hand side vector
c       alpha  = residual function array
c       idelmx = kcol index corresponding to delmax
c       delfnc = convergence function, defined by reference to delmax
c       betfnc = convergence function, defined by reference to betamx
c       uzvec1 = name array corresponding to zvclg1
c       ier    = error flag:
c                  =  0  Okay
c                  =  1  Encountered a zero matrix
c                  =  2  Encountered a non-zero, computationally
c                          singular matrix
c                  =  3  Iteration was diverging
c                  =  4  Hit the maximum number of iterations (itermx)
c
c     Principal input/output:
c
c       iter   = the number of Newton-Raphson iterations
c       negdfc = the number of successive iterations that delmax
c                  has been greater than zero and the corresponding
c                  convergence function delfnc has been less than
c                  or equal to zero
c       negbfc = the number of successive iterations that betamx
c                  has been greater than zero and the corresponding
c                  convergence function betfnc has been less than
c                  or equal to zero
c       negxfc = the number of successive iterations that either
c                  delmax has been greater than zero while delfnc
c                  has been less than or equal to zero, or betamx
c                  has been greater than zero while betfnc has
c                  been less than or equal to zero
c       noibfc = the number of successive iterations that betamx
c                  has been greater than zero and the corresponding
c                  convergence function betfnc has been less than
c                  1.e-6
c       npconv = number of successive steps in which the convergence
c                  criteria on the residual norm has been satisfied
c       npodfc = the number of successive iterations that the
c                  convergence function delfnc has been greater
c                  than zero
c       npobfc = the number of successive iterations that the
c                  convergence function betfnc has been greater
c                  than zero
c       zvclg1 = the 'log z' array, the array corrected by
c                  Newton-Raphson iteration
c       beta   = normalized residual function array
c       delvec = correction array
c       betao  = old beta array
c       delvco = old delvec array
c       betamx = max norm of the beta array
c       delmax = max norm of the delvec array
c       rlxfac = under-relaxation factor
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ibpxmx,ietmax,jetmax,kmax,nbtmax,ndrsmx,netmax,ngtmax,
     $ nodbmx,nptmax,nstmax,nstsmx,ntfxmx,nxtmax
c
      integer noutpt,nttyo
c
      integer igstak(ngtmax),iindx1(kmax),iodb(nodbmx),ipivot(kmax),
     $ ipndx1(kmax),istack(nstmax),ixbasp(nbtmax),jcsort(nstmax),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jgext(netmax),jgsort(ngtmax),jgstak(ngtmax),jjsort(nstmax),
     $ jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),jssort(nstmax),
     $ jstack(nstmax),kction(nbtmax),nbasp(nbtmax),ncmpr(2,nptmax),
     $ ncosp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax),
     $ nphasx(nstmax),nsts(nstsmx),nstsr(2,nstmax),ntfx(ntfxmx)
c
      integer ibetmx,idelmx,iebal,ier,iern1,iern2,ifrn1,ifrn2,igas,
     $ ilrn1,ilrn2,imrn1,imrn2,irdxc3,iter,itermx,ixrn1,ixrn2,kbt,kdim,
     $ kelect,khydr,kmt,km1,ko2gaq,kwater,kxt,kx1,narn1,narn2,nbt,nbw,
     $ negbfc,negdfc,negxfc,nelect,nern1,nern2,ngrn1,ngrn2,ngt,nhydr,
     $ noibfc,no2gaq,npconv,npobfc,npodfc,npt,nredox,nst,ntfxt
c
      logical qcacf,qcbeta,qredox,qxbarw,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubbig,ubneg,ubetmx
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),act(nstmax),actlg(nstmax),
     $ alpha(kmax),amtb(nbtmax),beta(kmax),betao(kmax),
     $ bpx(ibpxmx,nxtmax),cdrs(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),cjbasp(nbtmax),
     $ conc(nstmax),conclg(nstmax),cnufac(nstmax),coval(nbtmax),
     $ cpgexs(ietmax,jetmax,netmax),csts(nstsmx),delvco(kmax),
     $ delvec(kmax),dlogxw(nbtmax)
c
      real*8 egexjc(jetmax,netmax),egexjf(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),fsort(ngtmax),fugac(ngtmax),
     $ fugalg(ngtmax),gmmatr(kmax,kmax),loph(nptmax),losp(nstmax),
     $ lsort(nstmax),mgext(jetmax,netmax),moph(nptmax),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),rhsvec(kmax),
     $ tfx(ntfxmx),weight(nstmax),xbar(nstmax),xbarlg(nstmax),
     $ xlks(nstmax),zchar(nstmax),zgexj(jetmax,netmax),zvclg1(kmax),
     $ zvec1(kmax)
c
      real*8 afcnst,al10,bbig,betamx,betfnc,betmxo,bneg,btfcnr,
     $ delfnc,delmax,eh,ehfac,eps100,fo2,fo2lg,omega,omeglg,press,
     $ rlxfac,screwd,screwn,sigmam,sigmmo,xbarw,xbarwc,xbrwlc,
     $ xbrwlg,xlke
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,jlen,kcol,krow,ncut
c
      integer iarmxn
c
      logical qconc1,qconc2,qconc3,qpr
c
      character*56 uspn56
c
      real*8 delmxo,divfmx,divfnc,fx,rdx,sxu
c
c-----------------------------------------------------------------------
c
      data qpr    /.false./
c
c-----------------------------------------------------------------------
c
c     Save the current values of the beta and delvec arrays for use in
c     under-relaxation schemes.
c
      call copyaa(beta,betao,kdim)
      call copyaa(delvec,delvco,kdim)
      delmxo = delmax
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if iteration should be stopped because there is
c     little probability of further improvement. If any of the
c     following conditions cause iteration to stop, the result is
c     considered acceptable if it satisfies the convergence criteria
c     on residual functions, but not on the delvec vector.
c
c     Note: betfnc is the convergence function based on the beta
c     residual vector, and delfnc is that based on the delvec
c     correction vector. If convergence is occurring, each function
c     should approach unity (the maximum possible value).
c
c     Update counters. These all count the number of times in a row
c     that a condition has been satisfied.
c
      if (qcbeta .and. qcacf) then
        npconv = npconv + 1
      else
        npconv = 0
      endif
c
      if (delmax.gt.0. .and. delfnc.le.0.) then
        negdfc = negdfc + 1
      else
        negdfc = 0
      endif
c
      if (betamx.gt.0. .and. betfnc.le.0.) then
        negbfc = negbfc + 1
      else
        negbfc = 0
      endif
c
      if ((betamx.gt.0. .and. betfnc.le.0.) .or.
     $  (delmax.gt.0. .and. delfnc.le.0.)) then
        negxfc = negxfc + 1
      else
        negxfc = 0
      endif
c
      if (delfnc .gt. 0.) then
        npodfc = npodfc + 1
      else
        npodfc = 0
      endif
c
      if (betfnc .gt. 0.) then
        npobfc = npobfc + 1
      else
        npobfc = 0
      endif
c
      if (betamx.gt.0. .and. betfnc.le.1.e-6) then
        noibfc = noibfc + 1
      else
        noibfc = 0
      endif
c
c     Stop iteration if the convergence criteria on residual functions
c     (derived from the beta vector) have been satisfied for four
c     consecutive iterations.
c
      if (npconv .ge. 4) go to 300
c
c     Stop iteration if the behavior of delfnc indicates that the
c     iteration is diverging, and this indication is not contradicted
c     by the behavior of betfnc. Technically, delfnc is negative or
c     zero for twelve consecutive iterations and betfnc has not been
c     positive for three or more consecutive iterations.
c
      if (negdfc.ge.12 .and. npobfc.lt.3) go to 300
c
c     Stop iteration if the behavior of betfnc indicates that the
c     iteration is diverging, and this indication is not contradicted
c     by the behavior of delfnc. Technically, betfnc is negative or
c     zero for twelve consecutive iterations and delfnc has not been
c     positive for three or more consecutive iterations.
c
      if (negbfc.ge.12 .and. npodfc.lt.3) go to 300
c
c     Stop iteration if the behavior of delfnc and betfnc together
c     suggests that the iteration is diverging. Technically, either
c     delfnc or betfnc is negative or zero for twelve consecutive
c     iterations, and iter is greater than or equal to 40.
c
      if (negxfc.ge.12 .and. iter.ge.40) go to 300
c
c     Stop iteration if the behavior of betfnc indicates that no
c     significant improvement is occurring. Technically, betfnc is
c     less than or equal to 1.e-6 for twelve consecutive iterations,
c     and iter is greater than or equal to 20.
c
      if (noibfc.ge.12 .and. iter.ge.20) go to 300
c
c     Stop iteration if the maximum number of iterations have
c     been done.
c
      if (iter .ge. itermx) then
        write (noutpt,1000) itermx
        write (nttyo,1000) itermx
 1000   format(/' * Note - (EQLIB/nrstep) Have completed ',i4,' hybrid',
     $  /7x,'Newton-Raphson iterations. This is the maximum number',
     $  ' permitted.')
        ier = 4
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do another Newton-Raphson iteration.
c
      iter = iter + 1
c
c     Calculate the Jacobian matrix (aamatr).
c
      call matrix(aamatr,al10,bpx,cdrs,cdrtw,cdrw,cjbasp,
     $ cnufac,conc,csts,dlogxw,eps100,ibpxmx,iebal,iern1,ietmax,
     $ iindx1,ipndx1,irdxc3,ixbasp,ixrn1,jcsort,jern1,jern2,jetmax,
     $ jflag,jjsort,jsitex,kbt,kction,kdim,kelect,khydr,kmax,kmt,
     $ km1,ko2gaq,kwater,kxt,kx1,mosp,narn1,narn2,nbasp,nbt,nbtmax,
     $ nbw,ncosp,ndrs,ndrsmx,ndrsr,nelect,nern1,nern2,netmax,
     $ noutpt,no2gaq,nphasx,nredox,nst,nstmax,nsts,nstsmx,nstsr,
     $ ntfx,ntfxmx,ntfxt,nttyo,nxtmax,omega,qredox,q6mode,tfx,
     $ ugexmo,uspec,weight,xbar,xbarw,xbarwc,zchar)
c
c      Get the right-hand-side vector (rhsvec = -alpha).
c
       do krow = 1,kdim
         rhsvec(krow) = -alpha(krow)
       enddo
c
      if (iodb(4) .ge. 3) then
        write (noutpt,1010)
 1010   format(/16x,'--- The aamatr array, with rhsvec ---',/)
        do krow = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(krow) for unam48
c
          call fmspnx(jlen,uzvec1(krow),uspn56)
          write (noutpt,1020) krow,uspn56(1:jlen)
 1020     format(1x,i3,2x,a)
          write (noutpt,1030) (aamatr(krow,i),i = 1,kdim),rhsvec(krow)
 1030     format(( 6(2x,g10.3)) )
          write(noutpt,1040)
 1040     format(' ')
        enddo
      endif
c
c     Solve the Jacobian system. If EQLIBU/msolvr.f can't solve the
c     matrix, it is because the matrix is either zero (ier = 1) or
c     non-zero, but computationally singular (ier = 2).
c
      call msolvr(aamatr,delvec,gmmatr,ier,ipivot,kdim,kmax,
     $ noutpt,nttyo,qpr,rhsvec)
c
      if (ier .gt. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the max norm of the correction vector (delvec).
c     In the limit of the solution, the (unrelaxed) correction
c     term bounds the error in the variables being calculated.
c
      idelmx = iarmxn(delvec,kdim)
      delmax = 0.
      if (idelmx .gt. 0) delmax = abs(delvec(idelmx))
c
c     Calculate the delvec improvement function (delfnc).
c
      delfnc = 0.
      if (delmxo .gt. 0.) delfnc = (delmxo -delmax)/delmxo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Apply under-relaxation according to some simple criteria.
c     The under-relaxation at this point is done before recomputing
c     the residual functions. A subsequent under-relaxation
c     will be done to insure that the residual functions do not
c     increase too much.
c
      rlxfac = 1.0
c
c     Limit the magnitude of change per iteration.
c
      if (delmax .gt. screwd) rlxfac = screwd/delmax
c
c     If within the first eight iterations and the residual norm
c     (betamx) is large, go slow.
c
      if (iter.le.8 .and. betamx.gt.screwn) then
        rlxfac = 0.5*rlxfac
      endif
c
      qconc1 = sigmam.ge.2.0 .or. sigmmo.ge.2.0
      qconc2 = sigmam.ge.8.0 .or. sigmmo.ge.8.0
      qconc3 = sigmam.ge.12.0 .or. sigmmo.ge.12.0
c
      if (qconc1) then
c
c       Force some minimum under-relaxation for modestly concentrated
c       solutions.
c
        if (iter .le. 15) then
          sxu = 0.50
          rlxfac = min(sxu,rlxfac)
        endif
      endif
c
      if (qconc2) then
c
c       Force some minimum under-relaxation for more concentrated
c       solutions.
c
        if (iter .le. 15) then
          sxu = 0.35
          rlxfac = min(sxu,rlxfac)
        endif
      endif
c
      if (qconc3) then
c
c       Force some minimum under-relaxation for highly concentrated
c       solutions.
c
        if (iter .le. 15) then
          sxu = 0.25
          rlxfac = min(sxu,rlxfac)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Apply correction terms. The label below is a return point
c     under-relaxation which restricts the growth of the residual
c     functions.
c
      ncut = 0
  140 continue
c
      if (iodb(4) .ge. 2) write (noutpt,1050) ncut
 1050 format(/3x,'ncut= ',i3,/)
c
      do kcol = 1,kdim
        zvclg1(kcol) = zvclg1(kcol) + rlxfac*delvec(kcol)
      enddo
c
      if (iodb(4) .ge. 2) then
        write (noutpt,1060)
 1060   format(/8x,'Name',38x,'del',9x,'zvclg1'/)
        do kcol = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(kcol) for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          jlen = min(jlen,38)
          rdx = rlxfac*delvec(kcol)
          write (noutpt,1062) kcol,uspn56(1:jlen),rdx,zvclg1(kcol)
 1062     format(1x,i3,2x,a,t46,1pe12.5,2x,e12.5)
        enddo
        write (noutpt,1064)
 1064   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Expand the system and recalculate the Newton-Raphson residual
c     functions. It is important here to keep the activity coefficients
c     constant,that is, not to update them until all under-relaxation
c     has been completed.
c
c     Recalculate the concentrations, etc., of dependent species.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
      if (iodb(4) .ge. 2) then
        write (noutpt,1080)
 1080   format(/8x,'Name',37x,'Beta',/)
        do kcol = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(kcol) for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          jlen = min(jlen,38)
          write (noutpt,1085) kcol,uspn56(1:jlen),beta(kcol)
 1085     format(1x,i3,2x,a,t46,1pe12.5)
        enddo
        write (noutpt,1090)
 1090   format(/1x)
      endif
c
      btfcnr = 0.
      if (betmxo .gt. 0.) btfcnr = (betmxo - betamx)/betmxo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Use under-relaxation to control residual growth, if any.
c     Terminate iteration if residual tracking indicates that the
c     iteration is diverging.
c
      if (iter .le. 12) then
        divfmx = 0.
        do kcol = 1,kdim
          divfnc = abs(beta(kcol)) - betao(kcol)
          if (divfmx .gt. divfnc) divfmx = divfnc
        enddo
        if (divfmx .gt. 0.10) then
c
          if (ncut .le. 7) then
            ncut = ncut + 1
            if (iodb(4) .ge. 2) write (noutpt,1100)
 1100       format('  Residual tracking requires under-relaxation.')
            fx = 1./rlxfac
            do kcol = 1,kdim
              zvclg1(kcol) = zvclg1(kcol) - fx*delvec(kcol)
            enddo
            rlxfac = 0.25*rlxfac
            go to 140
          elseif (iter .ge. 8) then
            write (noutpt,1110)
 1110       format('  Residual tracking indicates that iteration',
     $      ' is diverging.')
            go to 300
          endif
c
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(4) .ge. 2) write (noutpt,1120)
 1120 format(' A Newton-Raphson correction has been completed.',/)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  300 continue
c
c     The code detected that iteration was diverging.
c
      ier = 3
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine d2ptay(delxi,demop0,d2emp1,nord,nordmx,npet,npetmx)
c
c     This subroutine computes the Taylor's series expansion for the
c     second derivative of the number of moles of the npe-th phase
c     in the ES. This second derivative is used to test whether or not
c     a critical point corresponds to a maximum.
c
c     See also:
c
c       EQ6/d1ptay.f
c       EQ6/ptaylr.f
c
c     This subroutine is called by:
c
c       EQ6/fpbflo.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       demop0 = the number of moles derivative vector for phases in
c                  the ES at the base point
c       nord   = the order of the truncated Taylor's series
c       nordmx = the maximum order of the truncated Taylor's series
c       npe    = the ES index of the phase for which the second
c                  derivative of the number of moles is to be computed
c       npetmx = the maximum number of phases in the ES
c
c     Principal output:
c
c       d2emp1 = the second derivative of the number of moles vector
c                  for phases in the ES at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nordmx,npetmx
c
      integer nord,npet
c
      real*8 demop0(nordmx,npetmx),d2emp1(npetmx)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jk,npe
c
      real*8 dxp,d2p
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      do npe = 1,npet
        d2emp1(npe) = 0.
        if (nord .gt. 1) then
          d2p = demop0(2,npe)
          if (nord .gt. 2) then
            jk = nord - 2
            dxp = 1.
            do j = 1,jk
              dxp = dxp*delxi
              d2p = d2p + ( demop0(j + 2,npe )/fctrl(j) )*dxp
            enddo
          endif
          d2emp1(npe) = d2p
        endif
      enddo
c
      end

      subroutine wr3pkd(electr,cgexj,ietmax,iopg,jetmax,jflgi,
     $ jgext,kbt,kct,kdim,kmax,kmt,kxmod,kxt,mtbi,mtbaqi,mwtges,
     $ nbti,nbtmax,net,netmax,newin,ngexrt,nobswt,nopgmx,nsbswt,
     $ ntitl2,ntitmx,nxmdmx,nxmod,qgexsh,pressi,tempci,tgexp,
     $ ubmtbi,ugexj,ugexmo,ugexp,ugexr,uhfgex,uobsw,usbsw,utitl2,
     $ uvfgex,uxkgex,uxmod,uzveci,xhfgex,xlkgex,xlkmod,xvfgex,
     $ zgexj,zvclgi)
c
c     This subroutine writes the pickup file in menu-style ("D") format.
c     This file is used to communicate data from EQ3NR to EQ6 (it
c     comprises the bottom half of an EQ6 input file).
c
c     This subroutine is a near clone of parts of XCON6/wr6d8.f and
c     EQ6/wr6pkd.f.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ3NR/wr3pkw.f.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,kmax,nbtmax,netmax,nopgmx,ntitmx,nxmdmx
c
      integer newin
c
      integer iopg(nopgmx),jgext(netmax),jflgi(nbtmax),
     $ kxmod(nxmdmx),ngexrt(jetmax,netmax)
c
      integer kbt,kct,kdim,kmt,kxt,nbti,net,nobswt,nsbswt,ntitl2,nxmod
c
      logical qgexsh
c
      character(len=80) utitl2(ntitmx)
      character(len=56) ugexr(ietmax,jetmax,netmax)
      character(len=48) ubmtbi(nbtmax),uobsw(2,nbtmax),usbsw(2,nbtmax),
     $ uxmod(nxmdmx),uzveci(kmax)
      character(len=24) ugexmo(netmax),ugexp(netmax)
      character(len=8) ugexj(jetmax,netmax),
     $ uhfgex(ietmax,jetmax,netmax),uvfgex(ietmax,jetmax,netmax),
     $ uxkgex(ietmax,jetmax,netmax)
c
      real(8) cgexj(jetmax,netmax),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),tgexp(netmax),xhfgex(ietmax,jetmax,netmax),
     $ xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zgexj(jetmax,netmax),zvclgi(kmax)
c
      real(8) electr,pressi,tempci
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlk8.h'
      include 'eqlib/eqlo8.h'
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ij,j,je,jfl,jfli,jj,j2,j3,j4,j5,j6,k,kprs,krow,kxmd,
     $ n,nbi,ne
c
      integer ilnobl
c
      logical qgexbf,qstop
c
      character(len=80) ux80
      character(len=48) ux48,ux48a,ux48b
      character(len=24) ux24
      character(len=16) ux16
      character(len=8) uxn,uxo,uxs,ux8
      character(len=1) ux1(5)
c
      real(8) xx
c
c-----------------------------------------------------------------------
c
c     Mark the start of the bottom half of the file.
c
      write (newin,7170)
 7170 format('* Start of the bottom half of the input file',t80,'*')
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Secondary title.
c
      write (newin,7190)
 7190 format('| Secondary Title',8x,'| (utitl2(n))',41x,'|')
      write (newin,1050)
 1050 format('|',78('-'),'|')
      do n = 1,ntitl2
        write (newin,1090) utitl2(n)
 1090   format('|',a78,'|')
      enddo
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      write (newin,7210)
 7210 format('|Special Basis Switches (for model definition only)',
     $ 7x,'| (nsbswt)',11x,'|')
      write (newin,1050)
c
      do n = 1,nsbswt
        write (newin,7230) usbsw(1,n),usbsw(2,n)
 7230   format('|Replace |',a48,'| (usbsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (usbsw(2,n))',7x,'|')
        write (newin,1050)
      enddo
c
      if (nsbswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,7230) ux48a,ux48b
        write (newin,1050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      write (newin,7310) tempci
 7310 format('|Original temperature (C) |',1pe12.5,'| (tempci)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      write (newin,7330) pressi
 7330 format('|Original pressure (bars) |',1pe12.5,'| (pressi)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation.
c
      write (newin,1600)
 1600 format('|Create Ion Exchangers',2x,'| (net)',48x,'|')
      write (newin,1050)
c
c     Set the advisory for exchanger creation blocks to follow or not.
c
      qgexbf = qgexsh .or. net.gt.0
      if (qgexbf) then
        write (newin,1603)
 1603   format('|Advisory: at least one exchanger creation block'
     $ ' follows on this file.',t80,'|')
      else
        write (newin,1605)
 1605   format('|Advisory: no exchanger creation blocks follow on',
     $  ' this file.',
     $  t80,'|')
      endif
c
c     Flag: on further processing, show at least one such block.
c
      ux1(1) = ' '
      if (qgexsh) ux1(1) = 'x'
      write (newin,1607) ux1(1)
 1607 format('|Option: on further processing (writing a pickup file',
     $ ' or running XCON6 on the',t80,'|',/'|present file), force the',
     $ ' inclusion of at least one such block (qgexsh):',t80,'|',
     $ /'|  [',a1,'] (.true.)',t80,'|')
      write (newin,1050)
c
      do ne = 1,net
        write (newin,1610) ugexp(ne)
 1610   format('|Exchanger phase |',a24,'| (ugexp(n))',
     $  25x,'|')
        write (newin,1050)
        write (newin,1620) mwtges(ne)
 1620   format('|->|Mol. wt. (Z)    |',1pg12.5,'| (mwtges(n))',
     $  33x,'|')
        write (newin,1050)
        write (newin,1630) ugexmo(ne)
 1630   format('|->|Exchange model  |',a24,'| (ugexmo(n))',
     $  21x,'|')
        write (newin,1050)
        write (newin,1640) tgexp(ne)
 1640   format('|->|Ref. temp. (C)  |',1pg12.5,'| (tgexp(n))',
     $  34x,'|')
        write (newin,1050)
        do je = 1,jgext(ne)
          write (newin,1650) ugexj(je,ne)
 1650     format('|->|Exchange site   |',a8,'| (ugexj(j,n))',
     $    36x,'|')
          write (newin,1050)
          write (newin,1660) cgexj(je,ne)
 1660     format('|--->|Stoich. number  |',1pg12.5,'| (cgexj(j,n))',
     $    30x,'|')
          write (newin,1050)
          write (newin,1670) zgexj(je,ne)
 1670     format('|--->|Electr. charge  |',1pg12.5,'| (zgexj(j,n))',
     $    30x,'|')
          write (newin,1050)
          do n = 1,ngexrt(je,ne)
            write (newin,1680) ugexr(n,je,ne)
 1680       format('|--->|Reaction        |',a24,'| (ugexr(i,j,n)',
     $      17x,'|')
            write (newin,1050)
            write (newin,1682)
 1682       format('|----->|Parameter |Value',7x,'|Units   | (this',
     $      ' is a table header)',13x,'|')
            write (newin,1050)
            write (newin,1684) xlkgex(n,je,ne),uxkgex(n,je,ne)
 1684       format('|----->|K func.   |',1pe12.5,'|',a8,
     $      '| (xlkgex(i,j,n), uxkgex(i,j,n))',7x,'|')
            write (newin,1686) xhfgex(n,je,ne),uhfgex(n,je,ne)
 1686       format('|----->|DelH0r    |',1pe12.5,'|',a8,
     $      '| (xhfgex(i,j,n), uhfgex(i,j,n))',7x,'|')
            write (newin,1688) xvfgex(n,je,ne),uvfgex(n,je,ne)
 1688       format('|----->|DelV0r    |',1pe12.5,'|',a8,
     $      '| (xvfgex(i,j,n), uvfgex(i,j,n))',7x,'|')
            write (newin,1050)
          enddo
        enddo
      enddo
c
      if (net.le.0 .and. qgexsh) then
        ux24 = 'None'
        ux8 = 'None'
        xx = 0.
        write (newin,1610) ux24
        write (newin,1050)
        write (newin,1620) xx
        write (newin,1050)
        write (newin,1630) ux24
        write (newin,1050)
        write (newin,1640) xx
        write (newin,1050)
        write (newin,1650) ux8
        write (newin,1050)
        write (newin,1660) xx
        write (newin,1050)
        write (newin,1670) xx
        write (newin,1050)
        write (newin,1680) ux24
        write (newin,1050)
        write (newin,1682)
        write (newin,1050)
        write (newin,1684) xx,ux8
        write (newin,1686) xx,ux8
        write (newin,1688) xx,ux8
        write (newin,1050)
      endif
c
      if (net.gt.0 .or. qgexsh) then
 1694   format('* Valid exchange model strings (ugexmo(n)) are:',t80,
     $  '*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,nvet_par
          if (ugexmv(n)(1:6) .ne. 'ERROR ') then
            jj = j3 + 27
            ux80(j3:jj) = ugexmv(n)
            j3 = jj + 1
            k = k + 1
            if (k .ge. 2) then
              write (newin,1696) ux80(1:80)
 1696         format(a)
              ux80(2:79) = ' '
              j3 = 6
              k = 0
            endif
          endif
        enddo
        if (k .gt. 0) write (newin,1696) ux80(1:80)
c
        write (newin,1052)
 1052   format('*',78('-'),'*')
c
        write (newin,1690)
 1690   format('* Valid units strings (uxkgex(i,j,n)/uhfgex(i,j,n)/',
     $  'uvfgex(i,j,n)) are:',t80,'*')
        ux80(1:1) = '*'
        ux80(2:79) = ' '
        ux80(80:80) = '*'
        j3 = 6
        k = 0
        do n = 1,4
          jj = j3 + 19
          ux80(j3:jj) = uxfuni(n)
          j3 = jj + 1
          k = k + 1
          if (k .ge. 3) then
            write (newin,1692) ux80(1:80)
 1692         format(a)
            ux80(2:79) = ' '
            j3 = 6
            k = 0
          endif
        enddo
        if (k .gt. 0) write (newin,1692) ux80(1:80)
c
        write (newin,1052)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Nxmod options.
c
      write (newin,5080)
 5080 format('|Alter/Suppress Options  | (nxmod)',45x,'|')
      write (newin,1050)
      write (newin,5082)
 5082 format('|Species',41x,'|Option',10x,'|Alter value |',
     $ /'| (uxmod(n))',37x,'|(ukxm(kxmod(n)))| (xlkmod(n))|')
      write (newin,1050)
c
      do n = 1,nxmod
        write (newin,5090) uxmod(n),ukxm(kxmod(n)),xlkmod(n)
 5090   format('|',a48,'|',a16,'|',1pe12.5,'|')
      enddo
c
      if (nxmod .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,5090) ux48,ux16,xx
      endif
c
      write (newin,1050)
c
      write (newin,5092)
 5092 format('* Valid alter/suppress strings (ukxm(kxmod(n))) are:',
     $ t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do kxmd = -1,2
        jj = j3 + 19
        ux80(j3:jj) = ukxm(kxmd)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 3) then
          write (newin,5094) ux80(1:80)
 5094       format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,5094) ux80(1:80)
c
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg activity coefficient option switches.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,7510)
 7510 format('|Iopg Activity Coefficient Option Switches',
     $ ' ("( 0)" marks default choices)',t80,'|')
      write (newin,1050)
c
      uxo = 'iopg('
      do n = 1,nopgmx
        j6 = index(uopgcx(n),'EQ6')
        if (j6 .gt. 0) then
          uxn = ' '
          write (uxn,'(i2)') n
          call lejust(uxn)
          j5 = ilnobl(uxn)
          uxo(6:8) = uxn(1:j5)
          j4 = ilnobl(uxo) + 1
          uxo(j4:j4) = ')'
          j3 = ilnobl(uopgtx(n))
          write (newin,7530) uxo(1:j4),uopgtx(n)(1:j3)
 7530     format('|',a,' - ',a,':',t80,'|')
          i = iopg(n)
          do j = 1,jpgxpa
            ij = iopgox(j,n)
            uxs = ' '
            if (ij .eq. i) uxs = 'x'
            j2 = ilnobl(uopgox(j,n))
            if (j2 .gt. 0) then
              write (newin,7550) uxs,ij,uopgox(j,n)(1:j2)
 7550         format('|  [',a1,'] (',i2,') ',a,t80,'|')
            endif
          enddo
          write (newin,1050)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      write (newin,7610)
 7610 format('|Matrix Index Limits',t80,'|')
      write (newin,1050)
      write (newin,7630) kct
 7630 format('|No. of chem. elements   |',i5,'| (kct)',t80,'|')
      write (newin,7650) kbt
 7650 format('|No. of basis species    |',i5,'| (kbt)',t80,'|')
      write (newin,7670) kmt
 7670 format('|Index of last pure min. |',i5,'| (kmt)',t80,'|')
      write (newin,7690) kxt
 7690 format('|Index of last sol-sol.  |',i5,'| (kxt)',t80,'|')
      write (newin,7710) kdim
 7710 format('|Matrix size             |',i5,'| (kdim)',t80,'|')
      kprs = 0
      write (newin,7730) kprs
 7730 format('|PRS data flag           |',i5,'| (kprs)',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
      write (newin,7750)
 7750 format('|Mass Balance Species (Matrix Row Variables)',5x,
     $ '|Units/Constraint| --',9x,'|',
     $ /'| (ubmtbi(n))',36x,'|(ujf6(jflgi(n)))| --',9x,'|')
      write (newin,1050)
c
      qstop = .false.
      do nbi = 1,nbti
        jfl = jflgi(nbi)
        jfli = 1
        if (jfl .eq. 30) jfli = 2
c
        write (newin,7790) ubmtbi(nbi),ujf6(jfli)
 7790   format('|',a48,'|',a16,'| --',9x,'|')
      enddo
      if (qstop) stop
c
      if (nbti .le. 0) then
        ux48 = 'None'
        ux16 = 'None'
        xx = 0.
        write (newin,7790) ux48,xx,ux16
      endif
c
      write (newin,1050)
c
      write (newin,7810)
 7810 format('* Valid jflag strings (ujf6(jflgi(n))) are:',t80,'*')
      ux80(1:1) = '*'
      ux80(2:79) = ' '
      ux80(80:80) = '*'
      j3 = 6
      k = 0
      do jfli = 1,2
        jj = j3 + 19
        ux80(j3:jj) = ujf6(jfli)
        j3 = jj + 1
        k = k + 1
        if (k .ge. 3) then
          write (newin,7830) ux80(1:80)
 7830     format(a)
          ux80(2:79) = ' '
          j3 = 6
          k = 0
        endif
      enddo
      if (k .gt. 0) write (newin,7830) ux80(1:80)
c
      write (newin,1052)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
      write (newin,7850)
 7850 format('|Mass Balance Totals (moles)',51x,'|')
      write (newin,1050)
c
      write (newin,7870)
 7870 format('|Basis species (info. only)',6x,'|Equilibrium System',4x,
     $ '|Aqueous Solution',6x,'|',
     $ /'| (ubmtbi(n))',20x,'| (mtbi(n))',12x,'| (mtbaqi(n))',10x,'|')
      write (newin,1050)
c
      do nbi = 1,nbti
        write (newin,7890) ubmtbi(nbi),mtbi(nbi),mtbaqi(nbi)
 7890   format('|',a32,'|',1pe22.15,'|',e22.15,'|')
      enddo
c
      ux48 = 'Electrical imbalance'
      write (newin,7890) ux48,electr,electr
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      write (newin,7970)
 7970 format('|Ordinary Basis Switches (for numerical purposes only)',
     $ 4x,'| (nobswt)',11x,'|')
      write (newin,1050)
c
      do n = 1,nobswt
        write (newin,7990) uobsw(1,n),uobsw(2,n)
 7990   format('|Replace |',a48,'| (uobsw(1,n))',7x,'|',
     $  /'|   with |',a48,'| (uobsw(2,n))',7x,'|')
        write (newin,1050)
      enddo
c
      if (nobswt .le. 0) then
        ux48a = 'None'
        ux48b = 'None'
        write (newin,7990) ux48a,ux48b
        write (newin,1050)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables and values.
c
      write (newin,7910)
 7910 format('|Matrix Column Variables and Values',44x,'|')
      write (newin,1050)
c
      write (newin,7930)
 7930 format('|Basis species (uzveci(n))',23x,
     $ '|Log moles (zvclgi(n)) | --   |')
      write (newin,1050)
c
      do krow = 1,kdim
        write (newin,7950) uzveci(krow),zvclgi(krow)
 7950   format('|',a48,'|',1pe22.15,'| --   |')
      enddo
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Phases and species in the PRS (there are none in the context of
c     EQ3NR models).
c
      write (newin,8110)
 8110 format('|Phases and Species in the PRS',49x,'|')
      write (newin,1050)
c
      ux24 = 'None'
      xx = 0.
      write (newin,8130) ux24
 8130 format('|Phase',11x,'|',a24,'| (uprphi(n))',t80,'|')
      write (newin,1050)
      write (newin,8150) xx
 8150 format('|->|No. of Moles',4x,'|',1pe22.15,'| (mprphi(n))',
     $ t80,'|')
      write (newin,1050)
      write (newin,8170)
 8170 format('|--->|Species',17x,'|No. of Moles',10x,
     $ '| --',t80,'|',/'|--->| (uprspi(i,n))',10x,
     $ '| (mprspi(i,n))',8x,'| --',t80,'|')
      write (newin,1050)
      write (newin,8190) ux24,xx
 8190 format('|--->|',a24,'|',1pe22.15,'| --',t80,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     End of problem.
c
      write (newin,8310)
 8310 format('|End of problem',64x,'|')
      write (newin,1050)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cophpr(actw,aw0prn,aw1prn,delxi,dlxmin,eh,eh0prn,
     $ eh1prn,fo2lg,iodb,nodbmx,noutpt,o20prn,o21prn,ph,ph0prn,
     $ ph1prn,qadjdx,qredox,tolxsu)
c
c     This subroutine checks for oversteps with regard to currently
c     defined lesser and greater print point values for the pH, Eh,
c     log fO2, and activity of water.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx
c
      integer noutpt
c
      integer iodb(nodbmx)
c
      logical qadjdx,qredox
c
      real*8 actw,aw0prn,aw1prn,delxi,dlxmin,eh,eh0prn,eh1prn,fo2lg,
     $ o20prn,o21prn,ph,ph0prn,ph1prn,tolxsu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
      qadjdx = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Is the pH less than the current lesser print point value?
c
      if ((ph - ph0prn) .lt. -tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1000) ph,ph0prn
 1000     format(/3x,'The pH is ',f7.4,', which is less than the',
     $    ' current lesser print point',/5x,'value of ',f7.4,'. This',
     $    ' overstep exceeds the specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c     Is the pH greater than the current greater print point value?
c
      if ((ph - ph1prn) .gt. tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1010) ph,ph1prn
 1010     format(/3x,'The pH is ',f7.4,', which is greater than the',
     $    ' current greater print point',/5x,'value of ',f7.4,'. This',
     $    ' overstep exceeds the specified tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
c
c       Is the Eh less than the current lesser print point value?
c
        if ((eh - eh0prn) .lt. -tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1020) eh,eh0prn
 1020       format(/3x,'The Eh is ',f7.4,' v, which is less than the',
     $      ' current lesser print point',/5x,'value of ',f7.4,' v.',
     $      ' This overstep exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the Eh greater than the current greater print point value?
c
        if ((eh - eh1prn) .gt. tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1030) eh,eh1prn
 1030        format(/3x,'The Eh is ',f7.4,' v, which is greater than',
     $       ' the current greater print point',/5x,'value of ',f7.4,
     $       ' v. This overstep exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the log fO2 less than the current lesser print point value?
c
        if ((fo2lg - o20prn) .lt. -tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1040) fo2lg,o20prn
 1040       format(/3x,'The log fO2 is ',f7.4,', which is less than',
     $      ' the current lesser print point',/5x,'value of ',f7.4,
     $      '. This overstep exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
c       Is the log fO2 greater than the current greater print point
c       value?
c
        if ((fo2lg - o21prn) .gt. tolxsu) then
          if (iodb(1) .gt. 0) then
            write (noutpt,1050) fo2lg,o21prn
 1050        format(/3x,'The log fO2 is ',f7.4,', which is greater',
     $       ' than the current greater print',/5x,'point value of ',
     $       f7.4,'. This overstep exceeds the specified tolerance.',/)
          endif
c
c         Determine whether or not to reduce delxi and go back and try
c         again to better locate the event in question.
c
          call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
          if (qadjdx) go to 999
        endif
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Is the activity of water less than the current lesser print
c     point value?
c
      if ((actw - aw0prn) .lt. -tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1060) actw,aw0prn
 1060     format(/3x,'The activity of water is ',f7.4,', which is less',
     $    ' than the current lesser',/5x,'print point value of ',f7.4,
     $    '. This overstep exceeds the specified',/5x,'tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c     Is the activity of water greater than the current greater print
c     point value?
c
      if ((actw - aw1prn) .gt. tolxsu) then
        if (iodb(1) .gt. 0) then
          write (noutpt,1070) actw,aw1prn
 1070     format(/3x,'The activity of water is ',f7.4,', which is',
     $    ' greater than the current',/5x,'greater print point value',
     $    ' of ',f7.4,'. This overstep exceeds the',/5x,'specified',
     $    ' tolerance.',/)
        endif
c
c       Determine whether or not to reduce delxi and go back and try
c       again to better locate the event in question.
c
        call dadjdx(delxi,dlxmin,iodb,nodbmx,noutpt,qadjdx)
        if (qadjdx) go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine ctds(jcsort,mosp,mwtsp,narn1,narn2,nstmax,wotds)
c
c     This subroutine calculates the total dissolved solute mass
c     (wotds, g). Note that a sorted summation is used.
c
c     This subroutine is called by:
c
c       EQLIB/gwdenp.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       mosp   = array of numbers of moles of species
c       jcsort = array of species indices, in order of increasing
c                  concentration/number of moles, but with sorting
c                  restricted to within phase ranges
c       mwtsp  = array of molecular weights of species
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c
c     Principal output:
c
c       wotds  = the total dissolved solute mass (g)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 mosp(nstmax),mwtsp(nstmax)
      real*8 wotds
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,ns,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,ns7,nval
c
      real*8 mxw,wx
c
c-----------------------------------------------------------------------
c
c     Logically, this could be represented by:
c
c       wotds = 0.
c       do ns = narn1 + 1,narn2
c         wotds = wotds + mosp(ns)*mwtsp(ns)
c       enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     In doing a sorted summation, a complication arises in that
c     water (ns = narn1) must be included in the range of the
c     loop, because the jcsort array is organized to contain the
c     species indices sorted according to increasing concentration
c     within phase ranges. There is no available sorting among
c     aqueous solute species only. Thus, the concentration of water
c     (conc(nanrn1)) is temporarily set to zero. Note the use
c     of a local variable (wx) within the loop. Note also that the
c     loop is unrolled.
c
      wx = 0.
      mxw = mosp(narn1)
      mosp(narn1) = 0.
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        ns1 = jcsort(nss + 1)
        ns2 = jcsort(nss + 2)
        ns3 = jcsort(nss + 3)
        ns4 = jcsort(nss + 4)
        ns5 = jcsort(nss + 5)
        ns6 = jcsort(nss + 6)
        ns7 = jcsort(nss + 7)
        wx = wx + mosp(ns0)*mwtsp(ns0) + mosp(ns1)*mwtsp(ns1)
     $          + mosp(ns2)*mwtsp(ns2) + mosp(ns3)*mwtsp(ns3)
     $          + mosp(ns4)*mwtsp(ns4) + mosp(ns5)*mwtsp(ns5)
     $          + mosp(ns6)*mwtsp(ns6) + mosp(ns7)*mwtsp(ns7)
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        wx = wx + mosp(ns)*mwtsp(ns)
      enddo
c
      wotds = wx
      mosp(narn1) = mxw
c
      end

      subroutine echoz(axlks,awmaxi,awmini,azero,cbsr,cdac,cdrs,
     $ cesr,csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmax,
     $ dlxmx0,dlxpll,dlxplo,dlxprl,dlxprn,eact,ehmaxi,ehmini,iktmax,
     $ imchmx,imech,iodb,iopg,iopr,iopt,itermx,jcode,jpress,jtemp,
     $ jsflag,ksplmx,ksppmx,kstpmx,kxmod,mwtrc,narn1,narn2,narxmx,
     $ nat,nata,natmax,nbaspd,nbt,nbta,nbtd,nbtmax,nbt1mx,ncmpr,nct,
     $ ncta,nctmax,ndact,ndctmx,ndrs,ndrsmx,ndrsr,nffgmx,ngt,ngta,
     $ ngtmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,nodbmx,nopgmx,noprmx,
     $ noptmx,nordmx,noutpt,npslmx,npt,npta,nptkmx,nptmax,nrct,nrctmx,
     $ nrk,nrndex,nsk,nsrt,nsrtmx,nsscmx,nsslmx,nst,nsta,nstmax,ntprmx,
     $ ntrymx,nttkmx,nttyo,nxmdmx,nxmod,nxopmx,nxopex,nxopt,nxpemx,
     $ nxridx,nxrt,nxrtmx,nxt,nxta,nxtmax,o2maxi,o2mini,phmaxi,
     $ phmini,press,pressb,ptk,qredox,rkb,rxbar,sscrew,tempc,tempcb,
     $ tempk,timmxi,tistti,tolbt,toldl,tolsat,tolsst,tolxsf,tolxst,
     $ tolxsu,trkb,ttk,uactop,udac,uelem,uffg,ureac,uspec,uxcat,uxmod,
     $ uxopex,uxopt,vreac,xistti,ximaxi,xlkmod,xlks,zkfac,zklgmn,
     $ zklogl,zklogu)
c
c     This subroutine writes an echo of various parameters after any
c     default values or range corrections have been applied.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,narxmx,natmax,nbtmax,nbt1mx,nctmax,ndctmx,
     $ ndrsmx,nffgmx,ngtmax,nltmax,nmtmax,nodbmx,nopgmx,noprmx,noptmx,
     $ nordmx,nptkmx,nptmax,nrctmx,nsrtmx,nsscmx,nstmax,ntprmx,nttkmx,
     $ nxmdmx,nxopmx,nxpemx,nxrtmx,nxtmax
c
      integer noutpt,nttyo
c
      integer imech(2,nrctmx),iodb(nodbmx),iopg(nopgmx),iopr(noprmx),
     $ iopt(noptmx),jcode(nrctmx),jsflag(nstmax),kxmod(nxmdmx),
     $ nbaspd(nbtmax),ncmpr(2,nptmax),ndact(imchmx,2,nrctmx),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),nrk(2,nrctmx),nrndex(nrctmx),
     $ nsk(nrctmx),nxridx(nrctmx)
c
      integer itermx,jpress,jtemp,ksplmx,ksppmx,kstpmx,narn1,narn2,nat,
     $ nata,nbt,nbta,nbtd,nct,ncta,ngt,ngta,nlt,nlta,nmt,nmta,
     $ npslmx,npt,npta,nrct,nsrt,nsslmx,nst,nsta,ntrymx,nxmod,nxopex,
     $ nxopt,nxrt,nxt,nxta
c
      logical qredox
c
      character*48 uspec(nstmax),uxmod(nxmdmx)
      character*32 uactop
      character*24 udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),
     $ ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character*8 uelem(nctmax),uxopt(nxopmx)
c
      real*8 axlks(narxmx,ntprmx,nstmax),azero(natmax),
     $ cbsr(nbt1mx,nsrtmx),cdac(ndctmx,imchmx,2,nrctmx),cdrs(ndrsmx),
     $ cesr(nctmax,nsrtmx),csigma(imchmx,2,nrctmx),
     $ eact(imchmx,2,nrctmx),mwtrc(nrctmx),ptk(nptkmx),
     $ rkb(imchmx,2,nrctmx),rxbar(iktmax,nxrtmx),sscrew(nsscmx),
     $ trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),xlkmod(nxmdmx),
     $ xlks(nstmax)
c
      real*8 awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmax,dlxmx0,
     $ dlxpll,dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,o2maxi,o2mini,phmaxi,
     $ phmini,press,pressb,tempc,tempcb,tempk,timmxi,tistti,tolbt,
     $ toldl,tolsat,tolsst,tolxsf,tolxst,tolxsu,ximaxi,xistti,zkfac,
     $ zklgmn,zklogl,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nf
c
      integer i,ik,ilevel,j,j2,n,na,nb,nc,np,nrc,nr1,nr2,ns,nsr,nxr
c
      integer ilnobl
c
      real*8 cx,cxx
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(uactop)
      write (noutpt,1000) uactop(1:j2)
 1000 format(/' The activity coefficients of aqueous species will be',
     $ ' calculated using'/3x,a,'.'/)
c
      if (iopr(3) .gt. 1) then
        write (noutpt,1010)
 1010   format(/7x,'Species',17x,'HC Diameter',/)
        do ns = narn1 + 1,narn2
          na = ns - narn1 + 1
          write (noutpt,1020) uspec(ns),azero(na)
 1020     format(5x,a24,3x,f7.3)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print a table showing for phases, species, and groups thereof,
c     the number of each of entity on the data base, the number the
c     software is dimensioned for, and the number appearing in the
c     current problem.
c
      call prtntt(nat,nata,natmax,nbt,nbta,nbtmax,nct,ncta,
     $ nctmax,ngt,ngta,ngtmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,noutpt,
     $ npt,npta,nptmax,nst,nsta,nstmax,nxt,nxta,nxtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (jtemp .eq. 0) then
        write (noutpt,1030) tempcb
 1030   format(/'   Temperature= ',f10.4,' C')
      elseif (jtemp .eq. 1) then
        write (noutpt,1040) tempcb,ttk(1)
 1040   format(/'   Temperature= ',f10.4,' + ',1pe12.5,' * Xi C')
      elseif (jtemp .eq. 2) then
        write (noutpt,1050) tempcb,ttk(1)
 1050   format(/'   Temperature= ',f10.4,' + ',1pe12.5,' * time C')
      elseif (jtemp .eq. 3) then
        write (noutpt,1060) tempcb,ttk(1),ttk(2),ttk(1)
 1060   format(/'   Temperature= (',f10.4,' * ',f10.4,' + Xi * ',
     $  f10.4,')',/20x,'/(Xi + ',f10.4,') C')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (jpress .eq. 0) then
        write (noutpt,1100)
 1100   format(/'   Pressure= the data file reference curve value at',
     $  ' any temperature',/)
      elseif (jpress .eq. 1) then
        write (noutpt,1102)
 1102   format(/'   Pressure= the 1.013-bar/steam-saturation curve',
     $  ' value at any temperature',/)
      elseif (jpress .eq. 2) then
        write (noutpt,1110) pressb
 1110   format(/'   Pressure= ',1pg12.5,' bars',/)
      elseif (jpress .eq. 3) then
        write (noutpt,1120) pressb,ptk(1)
 1120   format(/'   Pressure= ',1pg12.5,' + (',g12.5,' * Xi) bars',/)
      elseif (jpress .eq. 4) then
        write (noutpt,1130) pressb,ptk(1)
 1130   format(/'   Pressure= ',1pg12.5,' + (',g12.5,' * time) bars',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(2) .ge. 1) then
        ilevel = 2
        nf = noutpt
        call echolk(axlks,cdrs,ilevel,jsflag,narxmx,ndrs,ndrsmx,
     $  ndrsr,nf,nst,ntprmx,nstmax,press,tempc,uspec,xlks)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1200) xistti,ximaxi,tistti,timmxi,phmini,phmaxi,
     $ ehmini,ehmaxi,o2mini,o2maxi,awmini,awmaxi,kstpmx
 1200 format(/' xistti= ',1pe12.5,' (Initial value of Xi)',
     $ /' ximaxi= ',e12.5,' (Maximum value of Xi)',
     $ /' tistti= ',e12.5,' (Initial value of time, sec)',
     $ /' timmxi= ',e12.5,' (Maximum value of time, sec)',
     $ /' phmini= ',e12.5,' (Minimum value of pH)',
     $ /' phmaxi= ',e12.5,' (Maximum value of pH)',
     $ /' ehmini= ',e12.5,' (Minimum value of Eh, v)',
     $ /' ehmaxi= ',e12.5,' (Maximum value of Eh, v)',
     $ /' o2mini= ',e12.5,' (Minimum value of log fO2)',
     $ /' o2maxi= ',e12.5,' (Maximum value of log fO2)',
     $ /' awmini= ',e12.5,' (Minimum value of aw)',
     $ /' awmaxi= ',e12.5,' (Maximum value of aw)',
     $ /' kstpmx= ',4x,i8,' (Maximum number of steps this run)',//)
      write (noutpt,1210) dlxprn,dlxprl,dltprn,dltprl,dlhprn,dleprn,
     $ dloprn,dlaprn,ksppmx
 1210 format('   dlxprn= ',1pe12.5,' (Print interval in Xi)',
     $ /'   dlxprl= ',e12.5,' (Print interval in log Xi)',
     $ /'   dltprn= ',e12.5,' (Print interval in time, sec)',
     $ /'   dltprl= ',e12.5,' (Print interval in log time)',
     $ /'   dlhprn= ',e12.5,' (Print interval in pH units)',
     $ /'   dleprn= ',e12.5,' (Print interval in Eh, v)',
     $ /'   dloprn= ',e12.5,' (Print interval in log fO2)',
     $ /'   dlaprn= ',e12.5,' (Print interval in aw)',
     $ /'   ksppmx= ',4x,i8,' (Print interval in steps)',//)
      write (noutpt,1220) dlxplo,dlxpll,dltplo,dltpll,dlhplo,dleplo,
     $ dloplo,dlaplo,ksplmx
 1220 format('     dlxplo= ',1pe12.5,' (Plot interval in Xi)',
     $ /'     dlxpll= ',e12.5,' (Plot interval in log Xi)',
     $ /'     dltplo= ',e12.5,' (Plot interval in time)',
     $ /'     dltpll= ',e12.5,' (Plot interval in log time)',
     $ /'     dlhplo= ',e12.5,' (Plot interval in pH units)',
     $ /'     dleplo= ',e12.5,' (Plot interval in Eh, v)',
     $ /'     dloplo= ',e12.5,' (Plot interval in log fO2)',
     $ /'     dlaplo= ',e12.5,' (Plot interval in aw)',
     $ /'     ksplmx= ',4x,i8,' (Plot interval in steps)',//)
      write (noutpt,1230) dlxdmp
 1230 format('   dlxdmp= ',1pe12.5,' (PRS transfer interval in Xi)',/)
      write (noutpt,1240) dlxmx0,dlxmax
 1240 format(/'     dlxmx0= ',1pe12.5,' (Zero-order step size in Xi)',
     $ /'     dlxmax= ',e12.5,' (Maximum step size)',/)
      write (noutpt,1250) nordmx
 1250 format(/' nordmx= ',i2,' (Maximum dimensioned order)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1300) (iopt(i), i = 1,10)
 1300 format(/1x,'iopt(1)=  ',i2,' (Physical system model)',
     $ /1x,'iopt(2)=  ',i2,' (Kinetic mode)',
     $ /1x,'iopt(3)=  ',i2,' (Suppress phase boundary searches)',
     $ /1x,'iopt(4)=  ',i2,' (Solid solutions)',
     $ /1x,'iopt(5)=  ',i2,' (Clear ES solids read from the input',
     $ ' file)',
     $ /1x,'iopt(6)=  ',i2,' (Clear ES solids at the starting point)',
     $ /1x,'iopt(7)=  ',i2,' (Clear ES solids at the end of the run)',
     $ /1x,'iopt(8)=  ',i2,' (Not used)',
     $ /1x,'iopt(9)=  ',i2,' (Clear PRS solids read from the input',
     $ ' file)',
     $ /1x,'iopt(10)= ',i2,' (Clear PRS solids at the end of the run)')
      write (noutpt,1310) (iopt(i), i = 11,18)
 1310 format(1x,'iopt(11)= ',i2,' (Auto basis switching, in',
     $ ' pre-Newton-Raphson optimization)',
     $ /1x,'iopt(12)= ',i2,' (Auto basis switching, after',
     $ ' Newton-Raphson iteration)',
     $ /1x,'iopt(13)= ',i2,' (Calculational mode)',
     $ /1x,'iopt(14)= ',i2,' (ODE integrator corrector mode)',
     $ /1x,'iopt(15)= ',i2,' (Force global redox suppression)',
     $ /1x,'iopt(16)= ',i2,' (Backup file options)',
     $ /1x,'iopt(17)= ',i2,' (Pickup file options)',
     $ /1x,'iopt(18)= ',i2,' (Tab file options)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1320) (iopg(i), i = 1,2)
 1320 format(/3x,'iopg(1)=  ',i2,' (Aqueous species activity',
     $ ' coefficient model)',
     $ /3x,'iopg(2)=  ',i2,' (pH scale)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1330) (iopr(i), i = 1,11)
 1330 format(/1x,'iopr(1)=  ',i2,' (List all species)',
     $ /1x,'iopr(2)=  ',i2,' (List all reactions)',
     $ /1x,'iopr(3)=  ',i2,' (List HC diamaters)',
     $ /1x,'iopr 4)=  ',i2,' (Aqueous species concentration print',
     $ ' cut-off)',
     $ /1x,'iopr(5)=  ',i2,' (Ion/H+ activity ratios)',
     $ /1x,'iopr(6)=  ',i2,' (Mass balance percentages)',
     $ /1x,'iopr(7)=  ',i2,' (Affinity print cut-off)',
     $ /1x,'iopr(8)=  ',i2,' (Fugacities)',
     $ /1x,'iopr(9)=  ',i2,' (Mean molal activity coefficient)',
     $ /1x,'iopr(10)= ',i2,' (Pitzer coefficients tabulation)',
     $ /1x,'iopr(17)= ',i2,' (Pickup file format)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1340) (iodb(i), i = 1,8)
 1340 format(/3x,'iodb(1)=  ',i2,' (General diagnostics)',
     $ /3x,'iodb(2)=  ',i2,' (Kinetics diagnostics)',
     $ /3x,'iodb(3)=  ',i2,' (Pre-Newton-Raphson optimization)',
     $ /3x,'iodb(4)=  ',i2,' (Newton-Raphson iterations)',
     $ /3x,'iodb(5)=  ',i2,' (Order/scaling calculations)',
     $ /3x,'iodb(6)=  ',i2,' (Hypothetical affinity iterations)',
     $ /3x,'iodb(7)=  ',i2,' (Search iterations)',
     $ /3x,'iodb(8)=  ',i2,' (ODE corrector iterations)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1370) tolbt,toldl,tolxsf,tolxst,tolxsu,
     $ tolsat,tolsst
 1370 format(/' tolbt = ',1pe12.5,' (Residual function convergence',
     $ ' tolerance)',
     $ /' toldl = ',e12.5,' (Correction term convergence tolerance)',
     $ /' tolxsf= ',e12.5,' (Search/find tolerance (general,',
     $ ' relative))',
     $ /' tolxst= ',e12.5,' (Search/find tolerance on time (relative))',
     $ /' tolxsu= ',e12.5,' (Search/find tolerance on pH, Eh, etc.',
     $ ' (absolute))',
     $ /' tolsat= ',e12.5,' (Saturation tolerance)',
     $ /' tolsst= ',e12.5,' (Supersaturation tolerance)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1380) (sscrew(i), i = 1,6)
 1380 format(/'   sscrew(1)= ',1pe10.3,
     $ ' (Matrix variable step size parameter)',
     $ /'   sscrew(2)= ',0pf10.5,' (Not used)',
     $ /'   sscrew(3)= ',1pe10.3,
     $ ' (Rate function step size parameter)',
     $ /'   sscrew(4)= ',1pe10.3,
     $ ' (Rate function corrector parameter)',
     $ /'   sscrew(5)= ',0pf10.5,
     $ ' (Under-relaxation parameter (Newton-Raphson))',
     $ /'   sscrew(6)= ',0pf10.5,' (economy mode step size)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1400) zklogu,zklogl,zkfac,zklgmn
 1400 format(/' zklogu= ',f10.3,' (threshhold log mass for solids)',
     $ /' zklogl= ',f10.3,' (Log mass decrement for PRS shift)',
     $ /' zkfac = ',f10.3,' (Shift adjustment factor)',
     $ /' zklgmn= ',f10.3,' (Minimum log mass after a shift)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1410) itermx,ntrymx,npslmx,nsslmx
 1410 format(/'   itermx= ',i3,' (Newton-Raphson iteration limit)',
     $ /'   ntrymx= ',i3,' (Phase assemblage try limit)',
     $ /'   npslmx= ',i3,' (Critical phase instability slide limit)',
     $ /'   nsslmx= ',i3,' (Critical redox instability slide limit)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (.not.qredox) write (noutpt,1420)
 1420 format(/' There is no redox balance constraint; hence, the fO2,',
     $ /' Eh, pe, and Ah are all undefined.',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nsrt .gt. 0) then
        write (noutpt,1500)
 1500   format(//14x,'--- Special Reactants ---',/)
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 2) then
            j2 = ilnobl(ureac(nrc))
            nsr = nrndex(nrc)
            write (noutpt,1510) ureac(nrc)(1:j2),mwtrc(nrc),vreac(nrc)
 1510       format(/3x,a,//5x,'Mol. wt. = ',f12.3,'g/mol',
     $      /5x,'Molar volume = ',f12.3,' cc',/)
c
            write (noutpt,1520)
 1520       format(/5x,'Elemental Composition:',
     $      //9x,'Element',5x,'mol/mol',/)
            do nc = 1,nct
              cx = cesr(nc,nsr)
              if (cx .ne. 0.) write (noutpt,1530) uelem(nc),cx
 1530         format(7x,a8,3x,1pe12.5)
            enddo
c
            write (noutpt,1540)
 1540       format(//5x,'Numerical Composition:',
     $      //9x,'Species',26x,'mol/mol',/)
            cxx = -cbsr(nbt1mx,nsr)
            do nb = 1,nbtd
              ns = nbaspd(nb)
              cx = cbsr(nb,nsr)/cxx
              if (cx .ne. 0.) write (noutpt,1550) uspec(ns),cx
 1550         format(7x,a24,3x,1pe22.15)
            enddo
c
            write (noutpt,1580)
 1580       format(//5x,'Reaction:')
c
            nf = noutpt
            call prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $      nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $      ureac,uspec)
c
            write (noutpt,1590)
 1590       format(1x)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nxrt .gt. 0) then
        write (noutpt,1600)
 1600   format(/11x,'--- Solid Solution Reactants ---',/)
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 1) then
            np = nrndex(nrc)
            j2 = ilnobl(ureac(nrc))
            write (noutpt,1610) ureac(nrc)(1:j2),mwtrc(nrc),vreac(nrc)
 1610       format(/3x,a,
     $      //5x,'Molecular weight = ',f12.3,' g/mol',
     $      /5x,'    Molar volume = ',f12.3,' cc',
     $      //9x,'Composition',16x,'Mole Fraction',/)
            nxr = nxridx(nrc)
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do ns = nr1,nr2
              ik = ns - nr1 + 1
              if (rxbar(ik,nxr) .ne. 0.)
     $        write (noutpt,1620) uspec(ns),rxbar(ik,nxr)
 1620         format(7x,a24,3x,1pe12.5)
            enddo
          endif
        enddo
        write (noutpt,1630)
 1630   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c                 Rate laws and rate coefficients
c
      if (nrct .le. 0) go to 200
      write (noutpt,1700)
 1700 format(/21x,'--- Reactants/Rate Laws ---',/)
c
c     Forward direction.
c
      write (noutpt,1710)
 1710 format(/3x,'Forward direction')
c
      do nrc = 1,nrct
        if (nrk(1,nrc) .eq. -1) then
c
c         Use the backward net rate law form.
c
          write(noutpt,1720) ureac(nrc)
 1720     format(/1x,a24,3x,'Use backward net rate law ')
        elseif (nrk(1,nrc).eq.1) then
c
c         Specified relative rate.
c
          write (noutpt,1730) ureac(nrc),(rkb(j,1,nrc), j = 1,3)
 1730     format(/1x,a24,3x,'Specified relative rate',
     $    //23x,'rkb1= ',1pe12.5,/23x,'rkb2= ',e12.5,
     $    /23x,'rkb3= ',e12.5)
          write (noutpt,1740)
 1740   format(1x)
        elseif (nrk(1,nrc).eq.2) then
c
c         Transition state theory (TST) form.
c
          write (noutpt,1750) ureac(nrc)
 1750     format(/1x,a24,3x,'Transition state theory')
          do i = 1,imech(1,nrc)
            write (noutpt,1760) i,rkb(i,1,nrc),ndact(i,1,nrc),
     $      csigma(i,1,nrc)
 1760       format(/21x,'term= ',i2,
     $      //23x,'rkb= ',1pe12.5,3x,'ndact= ',i2,
     $      /23x,'csigma= ',1pe12.5)
            if (ndact(i,1,nrc).gt.0) then
              do n = 1,ndact(i,1,nrc)
                write (noutpt,1770) udac(n,i,1,nrc),cdac(n,i,1,nrc)
 1770           format(25x,'udac= ',a24,3x,'cdac= ',1pe12.5)
              enddo
            endif
          enddo
          write (noutpt,1740)
        elseif (nrk(1,nrc).eq.3) then
c
c         Linear form.
c
          write (noutpt,1780) ureac(nrc),rkb(1,1,nrc)
 1780     format(/1x,a24,3x,'Linear rate',//23x,'rkb= ',1pe12.5)
          write (noutpt,1740)
        endif
      enddo
c
c     Backward direction.
c
      write (noutpt,1810)
 1810 format(//3x,'Backward direction')
      do nrc = 1,nrct
        if (nrk(2,nrc).eq.-1) then
          write (noutpt,1820) ureac(nrc)
 1820     format(/1x,a24,3x,'Use forward net rate law ')
        elseif (nrk(2,nrc).eq.0) then
          write(noutpt,1830) ureac(nrc)
 1830     format(/1x,a24,3x,'Instantaneous equilibrium')
        elseif (nrk(2,nrc).eq.1) then
c
c         Specified relative rate.
c
          write (noutpt,1730) ureac(nrc),(rkb(j,2,nrc), j = 1,3)
        elseif (nrk(2,nrc).eq.2) then
c
c         Transition state theory (TST) form.
c
          write (noutpt,1750) ureac(nrc)
          do i = 1,imech(2,nrc)
            write (noutpt,1760) i,rkb(i,2,nrc),ndact(i,2,nrc),
     $      csigma(i,2,nrc)
            if (ndact(i,2,nrc).gt.0) then
              do n = 1,ndact(i,2,nrc)
                write (noutpt,1770) udac(n,i,2,nrc),cdac(n,i,2,nrc)
              enddo
            endif
          enddo
          write (noutpt,1740)
        elseif (nrk(2,nrc).eq.3) then
c
c         Linear form.
c
          write (noutpt,1780) ureac(nrc),rkb(1,2,nrc)
          write (noutpt,1740)
        endif
      enddo
c
  200 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1900)
 1900 format(/' - - - - - - - - - - - - - - - - - - - - - - - - ',
     $ '- - - - - - ',/)
      end

      integer function jiarmn(iarray,nmax)
c
c     This subroutine finds the minimum element of the integer array
c     iarray. Note that iarray could actually have more than one
c     dimension. For example, if the array is really "ia", which has
c     dimensions of i1 and i2, this subroutine could be used by calling
c     it in the following manner: call jiarmn(ia,(i1*i2)). Use this
c     subroutine with caution if nmax is not the product of the true
c     (declared) dimensions.
c
c     To find the corresponding maximum value, use EQLIBU/jiarmx.f
c     instead.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       iarray = the array
c       nmax   = dimension or pseudo-dimension of the array
c
c
c     Output:
c
c       jiarmn = the minimum element of the array (zero if nmax .le. 0)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      integer iarray(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft,ix
c
c-----------------------------------------------------------------------
c
      jiarmn = 0
      if (nmax .le. 0) go to 999
c
c     Note the use of a local variable (ix) within the loop.
c     Note also that the loop is unrolled.
c
      ix = iarray(1)
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        ix = min(ix,iarray(i),iarray(i + 1),iarray(i + 2),iarray(i + 3),
     $       iarray(i + 4),iarray(i + 5),iarray(i + 6),iarray(i + 7))
      enddo
c
      do i = ileft + 1,nmax
        ix = min(ix,iarray(i))
      enddo
c
      jiarmn = ix
c
  999 continue
      end

      subroutine rd6w8(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $ csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $ dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $ iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $ iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $ jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $ ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $ mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $ nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $ nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $ nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $ nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $ nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $ phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $ rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $ toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $ uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $ uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $ uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $ xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
c
c     This subroutine reads the EQ6 input file in compact ("W") format
c     for version 8.0.
c
c     This subroutine is a near-clone of EQ6/rd6inw.f. However, the
c     present subroutine embodies only a pure read function (it does
c     only minimal checking of what is read to ensure that what
c     follows is readable). EQ6/rd6inw.f differs in that it also
c     writes an instant echo of what is read to the EQ6 output file.
c
c     The calling sequence of this subroutine is identical to that of
c     EQ6/rd6inw.f, EQ6/rd6ind.f, and XCON6/rd6d8.f.
c
c     This subroutine is called by:
c
c       XCON6/xcon6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ninpts = unit number of the stripped input file
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Principal output:
c
c       qrderr = flag denoting a read error
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,iktmax,imchmx,jetmax,kmax,nbtmax,nbt1mx,nctmax,
     $ ndctmx,nertmx,netmax,nffgmx,nodbmx,nopgmx,noprmx,noptmx,nordmx,
     $ nprpmx,nprsmx,nptkmx,nrctmx,nsrtmx,ntitmx,nttkmx,nxmdmx,nxopmx,
     $ nxpemx,nxrtmx
c
      integer ninpts,noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),
     $ igerti(jetmax,nertmx),iesrti(nsrtmx),imech(2,nrctmx),
     $ iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ ixrti(nxrtmx),jcode(nrctmx),jgerti(nertmx),jflgi(nbtmax),
     $ jgext(netmax),jreac(nrctmx),kxmod(nxmdmx),ndact(imchmx,2,nrctmx),
     $ ngexrt(jetmax,netmax),nrk(2,nrctmx),nsk(nrctmx)
c
      integer itermx,jpress,jtemp,kbt,kct,kdim,kmt,kprs,ksplmx,ksppmx,
     $ kstpmx,kxt,nbti,nffg,nert,net,nobswt,nprob,nprpti,nprsti,nrct,
     $ nsbswt,nsrt,ntitl1,ntitl2,ntrymx,nxmod,nxopex,nxopt,nxrt
c
      logical qend,qgexsh,qrderr
c
      character*80 utitl1(ntitmx),utitl2(ntitmx)
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 ubmtbi(nbtmax),uobsw(2,nbtmax),uprspi(nprsmx),
     $ usbsw(2,nbtmax),uxmod(nxmdmx),uzveci(kmax)
      character*24 ubsri(nbt1mx,nsrtmx),ucxri(iktmax,nxrtmx),
     $ udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),ugermo(nertmx),
     $ ugersi(ietmax,jetmax,nertmx),ugexmo(netmax),ugexp(netmax),
     $ uprphi(nprpmx),ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character*8 uesri(nctmax,nsrtmx),ugerji(jetmax,nertmx),
     $ ugexj(jetmax,netmax),uhfgex(ietmax,jetmax,netmax),
     $ uvfgex(ietmax,jetmax,netmax),uxkgex(ietmax,jetmax,netmax),
     $ uxopt(nxopmx)
c
      real*8 cbsri(nbt1mx,nsrtmx),cdac(ndctmx,imchmx,2,nrctmx),
     $ cesri(nctmax,nsrtmx),cgexj(jetmax,netmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),
     $ egersi(ietmax,jetmax,nertmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprphi(nprpmx),mprspi(nprsmx),mtbaqi(nbtmax),mtbi(nbtmax),
     $ mwtges(netmax),ptk(nptkmx),rkb(imchmx,2,nrctmx),
     $ rxbari(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),tgexp(netmax),
     $ trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),
     $ xgersi(ietmax,jetmax,nertmx),xhfgex(ietmax,jetmax,netmax),
     $ xlkffg(nffgmx),xlkgex(ietmax,jetmax,netmax),xlkmod(nxmdmx),
     $ xvfgex(ietmax,jetmax,netmax),zvclgi(kmax),zgexj(jetmax,netmax)
c
      real*8 awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,electr,o2maxi,o2mini,phmaxi,
     $ phmini,pressb,pressi,tempcb,tempci,timmxi,tistti,tolbt,toldl,
     $ tolsat,tolxsf,ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iki,ikti,je,jei,jeti,jj,j2,j3,kcol,krow,n,nbi,nci,ne,
     $ nei,ner,neti,nn,npi,nrc
c
      integer ilnobl
c
      character*80 uline
      character*24 uxf,uxg,uxs
      character*8 uendit,uxe,ux8
c
      real*8 mx,xx
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c-----------------------------------------------------------------------
c
c     The following is nonsense to avoid compiler "unused variable"
c     warnings. Here noutpt and nprob are not actually used. They are
c     included in the calling sequence to allow it to match that of
c     EQ6/rd6inw.f.
c
      noutpt = nttyo
      i = nprob
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     qend   = .true if the end of the input file has been encountered
c     qrderr = .true if the current problem can't be read because of
c                a read format error or a dimensional overflow
c
      qend = .false.
      qrderr = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Main title.
c
c     Note: if there are exactly ntitpa lines in the title, the title
c     need not be terminated by an 'endit.'. The 'endit.' if present
c     is here not considered to be part of the title.
c
      ntitl1 = 0
      read (ninpts,1000,end=100,err=990) uline
 1000 format(a80)
      go to 110
c
  100 qend = .true.
      go to 999
c
  110 continue
c
      if (uline(1:8) .ne. uendit(1:8)) then
        ntitl1 = 1
        utitl1(1) = uline
        do n = 2,ntitmx
          read (ninpts,1000,err=990) uline
          if (uline(1:8) .eq. uendit(1:8)) go to 120
          ntitl1 = n
          utitl1(n) = uline
        enddo
  120   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Temperature parameters.
c     Note: ttk(1) = ttk1, etc.
c
      read (ninpts,1100,err=990) jtemp,tempcb,ttk(1),ttk(2)
 1100 format(12x,i2,/12x,e12.5,/2(12x,e12.5))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pressure parameters.
c     Note: ptk(1) = ptk1, etc.
c
      read (ninpts,1120,err=990) jpress,pressb,ptk(1),ptk(2)
 1120 format(12x,i2,/12x,e12.5,/2(12x,e12.5))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of reactants.
c
      read (ninpts,1480,err=990) nrct
 1480 format(12x,i2)
c
      if (nrct .gt. nrctmx) then
        write (nttyo,1520) nrctmx
 1520   format(/' * Error - (XCON6/rd6w8) Have too many reactants',
     $  /7x,'The code is only dimensioned for ',i4,' reactants.',
     $  /7x,'Reduce the number of reactants or increase the',
     $  /7x,'dimensioning parameter nrctpa.')
        go to 990
      endif
c
c     Reactants.
c
      nsrt = 0
      nxrt = 0
      nert = 0
c
      do nrc = 1,nrct
c
c       Name, flags, and masses.
c
        read (ninpts,1530,err=990) ureac(nrc),jcode(nrc),jreac(nrc),
     $  morr(nrc),modr(nrc)
 1530   format(12x,a24,/12x,i2,22x,i2,/2(12x,e12.5))
        j2 = ilnobl(ureac(nrc))
c
        if (jcode(nrc) .eq. 1) then
c
c         Have a solid solution reactant.
c
          nxrt = nxrt + 1
c
          if (nxrt .gt. nxrtmx) then
            write (nttyo,1550) nxrtmx
 1550       format(/' * Error - (XCON6/rd6w8) Have too many solid',
     $      /7x,'solution reactants. The code is only dimensioned',
     $      /7x,'for ',i4,' such reactants. Reduce the number of',
     $      /7x,'such reactants or increase the dimensioning',
     $      ' parameter nxrtpa.')
            go to 990
          endif
c
          ikti = 0
          do i = 1,iktmax + 1
            read (ninpts,1560,err=990) uxs,xx
 1560       format(3x,a24,3x,e12.5)
c
            if (uxs(1:8) .eq. uendit(1:8)) go to 150
c
            ikti = ikti + 1
c
            if (ikti .gt. iktmax) then
              write (nttyo,1590) ureac(nrc)(1:j2),iktmax
 1590         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        ' end-members',/7x,'in the solid solution reactant ',
     $        a,'.',/7x,'The code is only dimensioned for ',
     $        i4,' end-members per',/7x,'solid solution. Reduce',
     $        ' the number of end-members or',
     $        /7x,'increase the dimensioning parameter iktpar.')
              go to 990
            endif
c
            ucxri(ikti,nxrt) = uxs
            rxbari(ikti,nxrt) = xx
          enddo
  150     ixrti(nxrt) = ikti
        elseif (jcode(nrc) .eq. 2) then
c
c         Have a special reactant.
c
          nsrt = nsrt + 1
c
          if (nsrt .gt. nsrtmx) then
            write (nttyo,1600) nsrtmx
 1600       format(/' * Error - (XCON6/rd6w8) Have too many special',
     $      /7x,'reactants. The code is only dimensioned for ',i4,
     $      /7x,'such reactants. Reduce the number of such reactants',
     $      /7x,'or increase the dimensioning parameter nsrtpa.')
            go to 990
          endif
c
          read (ninpts,1610,err=990) vreac(nrc)
 1610     format(12x,e12.5)
c
          nci = 0
          do n = 1,nctmax + 1
            read (ninpts,1630,err=990) uxe,xx
 1630       format(3x,a8,3x,e22.15)
            if (uxe(1:8) .eq. uendit(1:8)) go to 160
c
            nci = nci + 1
c
            if (nci .gt. nctmax) then
              write (nttyo,1660) ureac(nrc)(1:j2),nctmax
 1660         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        ' chemical',/7x,'elements in the special reactant ',a,
     $        '.',/7x,'The code is only dimensioned for ',i4,
     $        ' elements.',/7x,'Reduce the number of elements or',
     $        ' increase the',/7x,'dimensioning parameter nctpar.')
              go to 990
            endif
c
            uesri(nci,nsrt) = uxe
            cesri(nci,nsrt) = xx
          enddo
  160     iesrti(nsrt) = nci
c
          nbi = 0
          do n = 1,nbt1mx + 1
            read (ninpts,1670,err=990) uxs,xx
 1670       format(3x,a24,3x,e22.15)
            if (uxs(1:8) .eq. uendit(1:8)) go to 170
c
            nbi = nbi + 1
c
            if (nbi .gt. nbt1mx) then
              write (nttyo,1700) ureac(nrc)(1:j2),nbtmax
 1700         format(/' * Error - (XCON6/rd6w8) Have too many basis',
     $        ' basis species in the',/7x,'in the reaction for the',
     $        ' special reactant ',a,'.',/7x,'The code is only',
     $        ' dimensioned for ',i4,' basis species. Increase',
     $        /7x,'the dimensioning parameter nbtpar.')
              go to 990
            endif
c
            ubsri(nbi,nsrt) = uxs
            cbsri(nbi,nsrt) = xx
          enddo
  170     ibsrti(nsrt) = nbi
        elseif (jcode(nrc) .eq. 5) then
c
c         Have a generic ion exchanger reactant.
c
          nert = nert + 1
          ner = nert
c
          if (nert .gt. nertmx) then
            write (nttyo,1710) nertmx
 1710       format(/' * Error - (XCON6/rd6w8) Have too many generic',
     $      ' ion exchanger',/7x,'reactants. The code is only',
     $      ' dimensioned for ',i4,' such reactants.',/7x,'Reduce',
     $      ' the number of such reactants or increase the',
     $      /7x,'dimensioning parameter nertpa.')
            go to 990
          endif
c
          read (ninpts,1712,err=990) ugermo(ner)
 1712     format(12x,a24)
c
          jeti = 0
          do jj = 1,jetmax + 1
            read (ninpts,1716,err=990) uxs
 1716       format(3x,a24)
            if (uxs(1:8) .eq. uendit(1:8)) go to 154
c
            jeti = jeti + 1
            jei = jeti
c
            if (jeti .gt. jetmax) then
              write (nttyo,1718) ureac(nrc)(1:j2),jetmax
 1718         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        ' exchange sites',/7x,'in the generic ion exchanger',
     $        ' reactant ',a,'.',/7x,'The code is only dimensioned',
     $        ' for ',i4,' exchange sites per',/7x,'generic ion',
     $        ' exchanger. Reduce the number of exchange sites or',
     $        /7x,'increase the dimensioning parameter jetpar.')
              go to 990
            endif
c
            ugerji(jei,ner) = uxs
c
            neti = 0
            do nn = 1,netmax + 1
              read (ninpts,1720,err=990) uxs,xx
 1720         format(6x,a24,3x,e12.5)
              if (uxs(1:8) .eq. uendit(1:8)) go to 152
c
              neti = neti + 1
              nei = neti
c
              if (neti .gt. netmax) then
                j3 = ilnobl(ugerji(jei,nert))
                write (nttyo,1724) ureac(nrc)(1:j2),
     $          ugerji(jei,ner)(1:j3),netmax
 1724           format(/' * Error - (XCON6/rd6w8) Have too many',
     $          ' species on exchange',/7x,'site ',a,' of the generic',
     $          ' ion exchanger reactant',/7x,a,'. The code is only',
     $          ' dimensioned for species per',/7x,'exchange site.',
     $          ' Reduce the number of end-members or increase',
     $          /7x,'the dimensioning parameter netpar.')
                go to 990
              endif
c
              ugersi(nei,jei,ner) = uxs
              egersi(nei,jei,ner) = xx
              xgersi(nei,jei,ner) = xx
            enddo
  152       igerti(jei,ner) = neti
          enddo
  154     jgerti(ner) = jeti
        endif
c
c       Surface area parameters.
c
        read (ninpts,1740,err=990) nsk(nrc),sfcar(nrc),ssfcar(nrc),
     $  fkrc(nrc)
 1740   format(12x,i2,22x,e12.5,12x,e12.5,/12x,e12.5)
c
c       Rate law codes: nrk(1,nrc) = forward rate law code,
c       nrk(2,nrc) = backward rate law code.
c
        read (ninpts,1760,err=990) nrk(1,nrc),nrk(2,nrc)
 1760   format(12x,i2,22x,i2)
c
c       Read forward (dissolution, dissociation) rate data.
c
        if (nrk(1,nrc) .eq. -1) then
c
c         Use the backward rate law.
c
          continue
        elseif (nrk(1,nrc) .eq. 0) then
c
c         Illegal value.
c
          write (nttyo,1775) ureac(nrc)(1:j2)
 1775     format(/' * Error - (XCON6/rd6w8) The forward rate law code',
     $    /7x,'has an illegal value of 0 for ',a,'.')
          go to 990
        elseif (nrk(1,nrc) .eq. 1) then
c
c         Arbitrary kinetics (relative rates, indifferent to time).
c
          imech(1,nrc) = 3
c
          if (imech(1,nrc) .gt. imchmx) then
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
 1780       format(/' * Error - (XCON6/rd6w8) Have too many rate',
     $      /7x,'constants or corresponding mechanisms in the forward',
     $      /7x,'rate law for reactant ',a,'. The code is only',
     $      /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $      /7x,'Reduce the number of rate constants or increase the',
     $      /7x,'dimensioning parameter imchpa.')
            go to 990
          endif
c
          read (ninpts,1790,err=990) (rkb(i,1,nrc), i = 1,3)
 1790     format(3(12x,e12.5))
        elseif (nrk(1,nrc) .eq. 2) then
c
c         Transition state rate law. Up to imchmx parallel mechanisms
c         are allowed.
c
          read (ninpts,1810,err=990) imech(1,nrc)
 1810     format(12x,i2)
c
          if (imech(1,nrc) .gt. imchmx) then
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          do i = 1,imech(1,nrc)
            read (ninpts,1830,err=990) rkb(i,1,nrc),trkb(i,1,nrc),
     $      iact(i,1,nrc)
 1830       format(12x,e12.5,12x,e12.5,12x,i2)
c
            read (ninpts,1850,err=990) eact(i,1,nrc),hact(i,1,nrc)
 1850       format(12x,e12.5,12x,e12.5)
c
            read (ninpts,1870,err=990) ndact(i,1,nrc),csigma(i,1,nrc)
 1870       format(12x,i2,22x,e12.5)
c
            if (ndact(i,1,nrc) .gt. ndctmx) then
              write (nttyo,1890) i,ureac(nrc)(1:j2),ndctmx
 1890         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        /7x,'species in the activity product in term ',i2,
     $        /7x,'of the forward direction rate law for reactant',
     $        /7x,a,'. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter ndctpa.')
              go to 990
            endif
c
            do n = 1,ndact(i,1,nrc)
              read (ninpts,1910,err=990) udac(n,i,1,nrc),
     $        cdac(n,i,1,nrc)
 1910         format(12x,a24,12x,e12.5)
            enddo
          enddo
        elseif (nrk(1,nrc) .eq. 3) then
c
c         Linear rate law.
c
          imech(1,nrc) = 1
c
          if (imech(1,nrc) .gt. imchmx) then
            write (nttyo,1780) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          i = 1
          read (ninpts,1830,err=990) rkb(i,1,nrc),trkb(i,1,nrc),
     $    iact(i,1,nrc)
          read (ninpts,1850,err=990) eact(i,1,nrc),hact(i,1,nrc)
        else
c
          write (nttyo,1950) nrk(1,nrc),ureac(nrc)(1:j2)
 1950     format(/' * Error - (XCON6/rd6w8) The forward rate law code',
     $    /7x,'has an unrecognized value of ',i2,' for ',a,'.')
          go to 990
c
        endif
c
c       Read backward (precipitation, formation) rate data.
c
        if (nrk(2,nrc) .eq. -1) then
c
c         Use the forward rate law.
c
          continue
        elseif (nrk(2,nrc) .eq. 0) then
c
c         Use instantaneous partial equilibrium.
c
          continue
        elseif (nrk(2,nrc) .eq. 1) then
c
c         Arbitrary kinetics.
c
          imech(2,nrc) = 3
c
          if (imech(2,nrc) .gt. imchmx) then
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
 1960       format(/' * Error - (XCON6/rd6w8) Have too many rate',
     $      /7x,'constants or corresponding mechanisms in the backward',
     $      /7x,'rate law for reactant ',a,'. The code is only',
     $      /7x,'dimensioned for ',i2,' rate constants per rate law.',
     $      /7x,'Reduce the number of rate constants or increase the',
     $      /7x,'dimensioning parameter imchpa.')
            go to 990
          endif
c
          read (ninpts,1790,err=990) (rkb(i,2,nrc), i = 1,3)
        elseif (nrk(2,nrc) .eq. 2) then
c
c         Transition state rate law.
c
          read (ninpts,1810,err=990) imech(2,nrc)
c
          if (imech(2,nrc) .gt. imchmx) then
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          do i = 1,imech(2,nrc)
            read (ninpts,1830,err=990) rkb(i,2,nrc),trkb(i,2,nrc),
     $      iact(i,2,nrc)
c
            read (ninpts,1850,err=990) eact(i,2,nrc),hact(i,2,nrc)
c
            read (ninpts,1870,err=990) ndact(i,2,nrc),csigma(i,2,nrc)
c
            if (ndact(i,2,nrc) .gt. ndctmx) then
              write (nttyo,1970) i,ureac(nrc)(1:j2),ndctmx
 1970         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        /7x,'species in the activity product in term ',i2,
     $        /7x,'of the backward direction rate law for reactant',
     $        /7x,a,'. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter ndctpa.')
              go to 990
            endif
c
            do n = 1,ndact(i,2,nrc)
              read (ninpts,1910,err=990) udac(n,i,2,nrc),
     $        cdac(n,i,2,nrc)
            enddo
          enddo
        elseif (nrk(2,nrc) .eq. 3) then
c
c         Linear rate law.
c
          imech(2,nrc) = 1
c
          if (imech(2,nrc) .gt. imchmx) then
            write (nttyo,1960) ureac(nrc)(1:j2),imchmx
            go to 990
          endif
c
          i = 1
          read (ninpts,1830,err=990) rkb(i,2,nrc),trkb(i,2,nrc),
     $    iact(i,2,nrc)
          read (ninpts,1850,err=990) eact(i,2,nrc),hact(i,2,nrc)
        else
c
          write (nttyo,1980) nrk(2,nrc),ureac(nrc)(1:j2)
 1980     format(/' * Error - (XCON6/rd6w8) The backward rate law code',
     $    /7x,'has an unrecognized value of ',i2,' for ',a,'.')
          go to 990
c
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Starting, minimum, and maximum values of key run parameters.
c
      read (ninpts,1150,err=990) xistti,ximaxi,tistti,timmxi
 1150 format(2(12x,e12.5),/2(12x,e12.5))
c
      read (ninpts,1160,err=990) phmini,phmaxi,ehmini,ehmaxi,o2mini,
     $ o2maxi,awmini,awmaxi,kstpmx
 1160 format(2(12x,e12.5),/2(12x,e12.5),/2(12x,e12.5),/2(12x,e12.5),
     $ /12x,i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print interval parameters.
c
      read (ninpts,1170,err=990) dlxprn,dlxprl,dltprn,dltprl
 1170 format(2(12x,e12.5),12x,/2(12x,e12.5))
c
      read (ninpts,1180,err=990) dlhprn,dleprn,dloprn,dlaprn,ksppmx
 1180 format(2(12x,e12.5),12x,/2(12x,e12.5),/12x,i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Plot interval parameters.
c
      read (ninpts,1190,err=990) dlxplo,dlxpll,dltplo,dltpll
 1190 format(2(12x,e12.5),/2(12x,e12.5))
c
      read (ninpts,1195,err=990) dlhplo,dleplo,dloplo,dlaplo,ksplmx
 1195 format(2(12x,e12.5),/2(12x,e12.5),/12x,i12)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopt model option switches.
c     Note: iopt(1) = iopt1, etc.
c
      read (ninpts,1210,err=990) (iopt(i), i = 1,20)
 1210 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopr print option switches.
c     Note: iopr(1) = iopr1, etc.
c
      read (ninpts,1230,err=990) (iopr(i), i = 1,20)
 1230 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iodb debugging print option switches.
c     Note: iodb(1) = iodb1, etc.
c
      read (ninpts,1250,err=990) (iodb(i), i = 1,20)
 1250 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxopt options.
c
      read (ninpts,1300,err=990) nxopt
 1300 format(12x,i2)
c
      if (nxopt .gt. nxopmx) then
        write (nttyo,1320) nxopmx
 1320   format(/' * Error - (XCON6/rd6w8) Have too many mineral',
     $  /7x,'subset-selection suppression options. The code is',
     $  /7x,'only dimensioned for ',i3,' such options. Reduce the',
     $  /7x,'number of options or increase the dimensioning',
     $  /7x,'parameter nxoppa.')
        go to 990
      endif
c
c     Nxopt options.
c
      do n = 1,nxopt
        read (ninpts,1330,err=990) uxopt(n),uxcat(n)
 1330   format(12x,a6,1x,a24)
      enddo
c
      if (nxopt .gt. 0) then
        read (ninpts,1350,err=990) nxopex
 1350   format(12x,i2)
c
        if (nxopex .gt. nxpemx) then
          write (nttyo,1370) nxpemx
 1370     format(/' * Error - (XCON6/rd6w8) Have too many',
     $    /7x,'exceptions specified to the mineral subset-selection',
     $    /7x,'suppression options. The code is only dimensioned',
     $    /7x,'for ',i3,'exceptions. Reduce the number of exceptions',
     $    /7x,'or increase the dimensioning parameter nxpepa.')
          go to 990
        endif
c
        do n = 1,nxopex
          read (ninpts,1380,err=990) uxopex(n)
 1380     format(12x,a24)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nffg options.
c
      read (ninpts,1400,err=990) nffg
 1400 format(12x,i2)
c
      if (nffg .gt. nffgmx) then
        write (nttyo,1420) nffgmx
 1420   format(/' * Error - (XCON6/rd6w8) Have too many gases whose',
     $  /7x,'fugacities are to be fixed. The code is only dimensioned',
     $  /7x,'for ',i4,' such gases. Reduce the number of gases or',
     $  /7x,'increase the dimensioning parameter nffgpa.')
        go to 990
      endif
c
c     Nffg options.
c
      do n = 1,nffg
        read (ninpts,1430,err=990) uffg(n),moffg(n),xlkffg(n)
 1430   format(12x,a24,/12x,e12.5,12x,e12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum finite-difference order.
c
      read (ninpts,2010,err=990) nordmx
 2010 format(12x,i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Newton-Raphson convergence tolerances.
c
      read (ninpts,2020,err=990) tolbt,toldl
 2020 format(2(12x,e12.5))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of Newton-Raphson iterations.
c
      read (ninpts,2010,err=990) itermx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Search/find tolerance.
c
      read (ninpts,2022,err=990) tolxsf
 2022 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Saturation tolerance.
c
      read (ninpts,2024,err=990) tolsat
 2024 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Maximum number of phase assemblage tries.
c
      read (ninpts,2102,err=990) ntrymx
 2102 format(12x,i3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero-order step size (in Xi).
c
      read (ninpts,2080,err=990) dlxmx0
 2080 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     PRS transfer interval in Xi.
c
      read (ninpts,2000,err=990) dlxdmp
 2000 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Process the bottom half of the current input file.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Secondary title.
c
      ntitl2 = 0
      read (ninpts,1000,err=990) uline
c
      if (uline(1:8) .ne. uendit(1:8)) then
        ntitl2 = 1
        utitl2(1) = uline
        do n = 2,ntitmx
          read (ninpts,1000,err=990) uline
          if (uline(1:8) .eq. uendit(1:8)) go to 220
          utitl2(n) = uline
          ntitl2 = n
        enddo
  220   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Special basis switches.
c
      read (ninpts,2620,err=990) nsbswt
 2620 format(12x,i3)
c
      do n = 1,nsbswt
        read (ninpts,2640,err=990) usbsw(1,n)
 2640   format(9x,a48)
c
        read (ninpts,2660,err=990) usbsw(2,n)
 2660   format(15x,a48)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      read (ninpts,2680,err=990) tempci
 2680 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      read (ninpts,2700,err=990) pressi
 2700 format(12x,e12.5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ion exchanger creation. This section reads the directives for
c     creating ion exchange phases and species and their associated
c     intrinsic (including thermodynamic) properties. The data is
c     essentially that which might be read from a supporting data file.
c
      read (ninpts,2795) ux8
 2795 format(12x,a8)
      call lejust(ux8)
      call locase(ux8)
      qgexsh = ux8(1:2).eq.'.t' .or. ux8(1:1).eq. 't'
c
      read (ninpts,2800,err=990) net
 2800 format(12x,i3)
c
      if (net .gt. netmax) then
        write (nttyo,2820) netmax,net
 2820   format(/' * Error - (XCON6/rd6w8) Have exceeded the maximum',
     $  ' number of ',i3,/7x,'generic ion exchange phases while',
     $  ' reading the data to create',/7x,'such phases. Increase',
     $  ' the dimensioning parameter netpar',/7x,'to at least ',i3,'.')
        go to 990
      endif
c
      do ne = 1,net
        read (ninpts,2830,err=990) ugexp(ne)
 2830   format(12x,a24)
        j2 = ilnobl(ugexp(ne))
c
        read (ninpts,2850,err=990) mwtges(ne)
 2850   format(12x,e12.5)
c
        read (ninpts,2830,err=990) ugexmo(ne)
        j3 = ilnobl(ugexmo(ne))
c
        read (ninpts,2850,err=990) tgexp(ne)
c
        read (ninpts,2890,err=990) jgext(ne)
 2890   format(12x,i3)
c
        if (jgext(ne) .gt. jetmax) then
          write (nttyo,2910) jetmax,ugexp(ne)(1:j2),jgext(ne)
 2910     format(/' * Error - (XCON6/rd6w8) Have exceeded the maximum',
     $    ' number of ',i3,/7x,'exchange sites on a generic ion',
     $    ' exchange phase while reading',/7x,'the data to create',
     $    a,'. Increase the',/7x,'dimensioning parameter jetpar to',
     $    ' at least ',i3,'.')
          go to 990
        endif
c
        do je = 1,jgext(ne)
          read (ninpts,2930,err=990) ugexj(je,ne)
 2930     format(12x,a8)
          j3 = ilnobl(ugexj(je,ne))
c
          read (ninpts,2950,err=990) cgexj(je,ne),zgexj(je,ne)
 2950     format(12x,e12.5,12x,e12.5)
c
          read (ninpts,2890,err=990) ngexrt(je,ne)
c
          if (ngexrt(je,ne) .gt. ietmax) then
            write (nttyo,3020) netmax,ugexj(je,ne)(1:j3),
     $      ugexp(ne)(1:j2),ngexrt(je,ne)
 3020       format(/' * Error - (XCON6/rd6w8) Have exceeded the',
     $      ' maximum number of ',i3,/7x,'reactions for a site',
     $      ' belonging to a generic ion exchange',/7x,'phase while',
     $      ' reading the data for site ',a,' of exchange phase'
     $      /7x,a,'. Increase the dimensioning parameter',
     $      /7x,'ietpar to at least ',i3,'.')
            go to 990
          endif
c
          do n = 1,ngexrt(je,ne)
            read (ninpts,3030,err=990) ugexr(n,je,ne)
 3030       format(12x,a56)
            read (ninpts,3050,err=990) xlkgex(n,je,ne),uxkgex(n,je,ne)
 3050       format(12x,e12.5,12x,a8)
            read (ninpts,3050,err=990) xhfgex(n,je,ne),uhfgex(n,je,ne)
            read (ninpts,3050,err=990) xvfgex(n,je,ne),uvfgex(n,je,ne)
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Number of nxmod options.
c
      read (ninpts,3120,err=990) nxmod
 3120 format(12x,i2)
c
      if (nxmod .gt. nxmdmx) then
        write (nttyo,3140) nxmdmx
 3140   format(/' * Error - (XCON6/rd6w8) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i2,' such options. Reduce the number of such',
     $  /7x,'options or increase the dimensioning parameter nxmdpa.')
        go to 990
      endif
c
c     Nxmod options.
c
      do n = 1,nxmod
        read (ninpts,3150,err=990) uxmod(n),kxmod(n),xlkmod(n)
 3150   format(12x,a48,/12x,i2,22x,e12.5)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Iopg options.
c     Note: iopg(1) = iopg1, etc.
c
      read (ninpts,3170,err=990) (iopg(i), i = 1,20)
 3170 format(12x,10i5)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      read (ninpts,3220,err=990) kct,kbt,kmt,kxt,kdim,kprs
 3220 format(3(12x,i2,10x),/3(12x,i2,10x))
c
      nbti = kbt
c
      if (kct .gt. nctmax) then
        write (nttyo,3240) nctmax
 3240   format(/' * Error - (XCON6/rd6w8) Have too many chemical',
     $  /7x,'elements present. The code is only dimensioned',
     $  /7x,'for ',i3,' elements. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      if (kbt .gt. nbtmax) then
        write (nttyo,3250) nbtmax
 3250   format(/' * Error - (XCON6/rd6w8) Have too many basis',
     $  /7x,'species present. The code is only dimensioned',
     $  /7x,'for ',i3,' basis species. Reduce the number of elements',
     $  /7x,'or increase the dimensioning parameter nctpar.')
        go to 990
      endif
c
      if (kdim .gt. kmax) then
        write (nttyo,3260) kmax
 3260   format(/' * Error - (XCON6/rd6w8) Have too many matrix',
     $  /7x,'variables. The code is only dimensioned for ',i3,
     $  /7x,'matrix variables. Reduce the number of such variables',
     $  /7x,'or increase the dimensioning parameter kpar.')
        go to 990
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
c       ubmtbi = names of the data file basis species for which mass
c                  balances are defined
c       jflgi  = jflag input for basis species
c          0 = Retain as an active basis species
c         30 = Convert to a dependent species; fold the mass balance
c                total for this species into the mass balance totals
c                of basis species which remain active
c
      do nbi = 1,nbti
        read (ninpts,3340,err=990) ubmtbi(nbi),jflgi(nbi)
 3340   format(3x,a48,3x,i2)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Mass balance totals.
c
c       mtbi   = total number of moles of basis species in the
c                  equilibrium system (ES)
c       mtbaqi = total number of moles of basis species in the
c                  aqueous solution
c
      do nbi = 1,nbti
        read (ninpts,3410,err=990) mtbi(nbi),mtbaqi(nbi)
 3410   format(6x,e22.15,6x,e22.15)
      enddo
      read (ninpts,3430,err=990) electr
 3430 format(34x,e22.15)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switches.
c
      read (ninpts,2620,err=990) nobswt
c
      do n = 1,nobswt
        read (ninpts,2640,err=990) uobsw(1,n)
c
        read (ninpts,2660,err=990) uobsw(2,n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables.
c
c       uzveci = names of species or properties associated with the
c                  matrix column variables
c
      do krow = 1,kdim
        read (ninpts,3480,err=990) uzveci(krow)
 3480   format(3x,a48)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix variable values.
c
c       zvclg1 = values of matrix variables
c
      do kcol = 1,kdim
        read (ninpts,3520,err=990) zvclgi(kcol)
 3520   format(3x,e22.15)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize any non-zero values for the physically removed
c     system. Here mprphi and mprspi are arrays for the number of
c     moles of phases and species, respectively, in the PRS.
c
      nprpti = 0
      nprsti = 0
      if (kprs .gt. 0) then
        do npi = 1,nprpmx + 1
          read (ninpts,3610,err=990) uxf,mx
 3610     format(1x,a24,6x,e22.15)
          if (uxf(1:8) .eq. uendit(1:8)) go to 310
          nprpti = nprpti + 1
c
          if (nprpti .gt. nprpmx) then
            write (nttyo,3640) nprpmx
 3640       format(/' * Error - (XCON6/rd6w8) Have too many phases',
     $      /7x,'in the physically removed system (PRS) on the',
     $      /7x,'input file. The code is only dimensioned for ',i3,
     $      /7x,'such phases. Reduce the number of such phases',
     $      /7x,'or increase the dimensioning parameter nprppa.')
            go to 990
          endif
c
          uprphi(nprpti)(1:24) = uxf
          mprphi(nprpti) = mx
c
          do iki = 1,iktmax + 1
            read (ninpts,3650,err=990) uxg,mx
 3650       format(3x,a24,6x,e22.15)
            if (uxg(1:8) .eq. uendit(1:8)) go to 300
c
            if (iki .gt. iktmax) then
              j2 = ilnobl(uxf)
              write (nttyo,3680) uxf(1:j2),iktmax
 3680         format(/' * Error - (XCON6/rd6w8) Have too many',
     $        ' end-members',/7x,'in the PRS solid solution ',a,'.',
     $        /7x,'The code is only dimensioned for ',
     $        i4,' end-members per',/7x,'solid solution. Reduce',
     $        ' the number of end-members or',
     $        /7x,'increase the dimensioning parameter iktpar.')
              go to 990
            endif
c
            nprsti = nprsti + 1
c
            if (nprsti .gt. nprsmx) then
              write (nttyo,3690) nprsmx
 3690         format(/' * Error - (XCON6/rd6w8) Have too many species',
     $        /7x,'in the physically removed system (PRS) on the',
     $        /7x,'input file. The code is only dimensioned for ',i3,
     $        /7x,'such species. Reduce the number of such species',
     $        /7x,'or increase the dimensioning parameter nprspa.')
              go to 990
            endif
c
            uprspi(nprsti)(1:24) = uxg
            uprspi(nprsti)(25:48) = uxf
            mprspi(nprsti) = mx
          enddo
  300     continue
        enddo
c
  310   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 qrderr = .true.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine rd3d7(cspb,fep,iktmax,iodb,iopg,iopr,iopt,itermx,
     $ jflagb,jxmod,kxmod,ncompb,ninpts,nodbmx,nopgmx,noprmx,noptmx,
     $ nsq,nsqmax,ntitl,ntitmx,nttyo,nxmdmx,nxmod,nxtb,nxtmax,qend,
     $ qrderr,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,ubasis,
     $ uebal,umemb,uphas1,uphas2,uredox,usolb,uspecb,utitl,xbarb,
     $ uxmd24,xlkmod)
c
c     This subroutine reads the EQ3NR input file in menu-style ("D")
c     format for versions 7.0-7.2. It thus encompasses two version
c     levels.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,nodbmx,nopgmx,noprmx,noptmx,nsqmax,ntitmx,nxmdmx,
     $ nxtmax
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jflagb(nsqmax),jxmod(nxmdmx),kxmod(nxmdmx),ncompb(nxtmax)
c
      integer itermx,ninpts,nsq,ntitl,nttyo,nxmod,nxtb
c
      logical qend,qrderr
c
      character*80 utitl(ntitmx)
      character*24 ubasis(nsqmax),umemb(iktmax,nxtmax),uphas1(nsqmax),
     $ uphas2(nsqmax),usolb(nxtmax),uspecb(nsqmax),uxmd24(nxmdmx)
      character*24 uebal,uredox
c
      real*8 cspb(nsqmax),xbarb(iktmax,nxtmax),xlkmod(nxmdmx)
c
      real*8 fep,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat
c
c-----------------------------------------------------------------------
c
      include 'xcon3/x3op7.h'
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
c       nfldpa = maximum number of fields per line
c       nlchpa = character length of a line
c
      integer nfldpa,nlchpa
c
      parameter (nfldpa = 8,nlchpa = 80)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,idesc,idescx,iktb,ivar,j,jdesc,j1,j2,j3,n,ncount,
     $ nfldmx,nfldt,nfldtx,nlchmx,nmark,nmarks
      integer ilnobl
c
      logical qrdxcp
c
      character*(nlchpa) ufield(nfldpa)
      character*(nlchpa) uline1,uline2,ulscr
      character*(nlchpa) uheadr,uheadx
c
      character*80 ustr
c
      real*8 var
c
c-----------------------------------------------------------------------
c
      nfldmx = nfldpa
      nlchmx = nlchpa
c
      qrderr = .false.
c
c-----------------------------------------------------------------------
c
c     Title.
c
      qend = .false.
      read (ninpts,1000,end=100,err=990) uline1
 1000 format(a80)
      call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
      ustr = ufield(1)
      if (ustr(1:8) .ne. '--------') then
        j2 = ilnobl(uline1)
        write (nttyo,1010) uline1(1:j2)
 1010   format(/' * Error - (XCON3/rd3d7) The first line of a "D"',
     $  /7x,'format input file must begin with "|--------".',
     $  /7x,'The first line read from the old input file begins with-',
     $  /7x,'"',a,'".')
        go to 990
      endif
      go to 105
c
  100 qend = .true.
      go to 999
c
  105 do 110 n = 1,ntitmx + 1
        read (ninpts,1000,err=990) uline1
        call parsln(nfldmx,nfldt,nlchmx,ufield,uline1,ulscr)
        ustr = ufield(1)
        if (ustr(1:8) .eq. '--------') go to 120
        utitl(n) = ufield(1)
  110 continue
c
      write (nttyo,1015) ntitmx
 1015 format(/' * Error - (XCON3/rd3d7) Have too many lines in the',
     $ /7x,'main title. The code is only dimensioned for ',i4,
     $ /7x,'lines. Reduce the size of the title or increase the',
     $ /7x,'dimensioning parameter ntitpa.')
      go to 990
c
  120 ntitl = n - 1
c
c-----------------------------------------------------------------------
c
c     Temperature and density.
c
      tempc = 0.
      rho = 0.
c
      uheadx = 'Temperature (C)'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      tempc = var
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      rho = var
c
c-----------------------------------------------------------------------
c
c     Total dissolved salts.
c
      tdspkg = 0.
      tdspl = 0.
c
      uheadx = 'Total dissolved salts'
      nfldtx = 5
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nmark = 0
      ncount = 0
c
      do 125 n = 3,5
        j = index(ufield(n),'*')
        if (j .gt. 0) then
          ncount = ncount + 1
          if (ncount .eq. 1) nmark = n
        endif
  125 continue
c
      if (ncount .eq. 0) then
        j2 = ilnobl(uline1)
        write (nttyo,1017) uline1(1:j2)
 1017   format(/' * Warning - (XCON3/rd3d7) None of the options'
     $  /7x,'is marked with an asterisk on the line beginning with',
     $  /7x,'"',a,'".')
      endif
c
      if (ncount .gt. 1) then
        j2 = ilnobl(uline1)
        write (nttyo,1018) uline1(1:j2)
 1018   format(/' * Warning - (XCON3/rd3d7) More than one of the'
     $  /7x,'options is marked with an asterisk on the line',
     $  ' beginning with',
     $  /7x,'"',a,'".')
      endif
c
      ustr = ufield(2)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
c
      if (nmark .eq. 3) then
        tdspkg = var
      elseif (nmark .eq. 4) then
        tdspl = var
      endif
c
c-----------------------------------------------------------------------
c
c     Electrical balancing species.
c
      uebal = ' '
c
      uheadx = 'Electrical balancing'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nmark = 0
      ncount = 0
c
      do 127 n = 3,4
        j = index(ufield(n),'*')
        if (j .gt. 0) then
          ncount = ncount + 1
          if (ncount .eq. 1) nmark = n
        endif
  127 continue
c
      if (ncount .gt. 1) write (nttyo,1018) uline1
c
      uebal = ufield(2)
      if (nmark .eq. 3) uebal = 'pick1.'
      if (nmark .eq. 4) uebal = ' '
c
c-----------------------------------------------------------------------
c
c     Basis species and associated constraints. If a solid solution
c     end-member is part of a constraint, read the solid solution
c     composition here. Other solid solution compositions are read
c     in the following block.
c
      uheadx = 'SPECIES'
      nfldtx = 4
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nxtb = 0
      uredox = ' '
      fep = 0.
      qrdxcp = .false.
c
      nsq = 0
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
  130 ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 180
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) then
        j2 = ilnobl(uline1)
        write (nttyo,1030) nfldt,nfldtx,uline1(1:j2)
 1030   format(/' * Warning - (XCON3/rd3d7) Found ',i2,' fields',
     $  /7x,'where ',i2,' were expected on the line beginning with-',
     $  /7x,'"',a,'".')
      endif
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
c
      ustr = ufield(4)
      call locase(ustr)
c
      if (uheadr(1:8) .eq. 'redox') then
        fep = var
        if (ustr(1:6) .eq. 'logfo2') then
          iopt(1) = 0
        elseif (ustr(1:2) .eq. 'eh') then
          iopt(1) = -1
        elseif (ustr(1:2) .eq. 'pe') then
          iopt(1) = -2
        elseif (ustr(1:12) .eq. 'redox couple') then
          iopt(1) = 1
          qrdxcp = .true.
        else
          j2 = ilnobl(ustr)
          write (nttyo,1040) ustr(1:j2)
 1040     format(/" * Error - (XCON3/rd3d7) Can't identify the",
     $    /7x,'following redox option string- "',a,'". This must',
     $    /7x,'be one of "LogfO2", "Eh", "pe", or "redox couple".')
          go to 990
        endif
c
        nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        go to 130
      endif
c
      nsq = nsq + 1
c
      if (nsq .gt. nsqmax) then
        write (nttyo,1050) nsqmax
 1050   format(/' * Error - (XCON3/rd3d7) Have too many basis',
     $  /7x,'species. The code is only dimensioned for ',i3,
     $  /7x,'such species. Reduce the number of such species',
     $  /7x,'or increase the dimensioning parameter nsqpar.')
        go to 990
      endif
c
      uspecb(nsq) = ufield(1)
      if (qrdxcp) uredox = ufield(1)
      qrdxcp = .false.
      if (uspecb(nsq)(1:5).eq.'o2(g)' .or.
     $    uspecb(nsq)(1:5).eq.'O2(g)') then
        iopt(1) = -3
        uredox = ' '
      endif
      cspb(nsq) = var
c
      do 140 n = -1,njf7pa
        uheadx = ujflg7(n)
        call locase(uheadx)
        if (ustr(1:16) .eq. uheadx(1:16)) then
          jflagb(nsq) = n
          go to 150
        endif
  140 continue
c
      j2 = ilnobl(ustr)
      write (nttyo,1060) ustr(1:j2)
 1060 format(/" * Error - (XCON3/rd3d7) Can't identify the",
     $ /7x,'following jflag option string- "',a,'". This should',
     $ /7x,'be one of the strings defined in the ujflg7 array.')
      go to 990
c
  150 ustr = ufield(2)
      if (jflagb(nsq).ge.17 .and. jflagb(nsq).le.21) then
        uphas1(nsq) = ustr
      else
        ubasis(nsq) = ustr
      endif
c
      if (jflagb(nsq) .eq. 20) then
        nxtb = nxtb + 1
c
        if (nxtb .gt. nxtmax) then
          write (nttyo,1310) nxtmax
 1310     format(/' * Error - (XCON3/rd3d7) Have too many solid',
     $    /7x,'solutions present. The code is only dimensioned',
     $    /7x,'for ',i3,' solid solutions. Reduce the number of such',
     $    /7x,'phases or increase the dimensioning parameter nxtpar.')
          go to 990
        endif
c
        usolb(nxtb) = ustr
        iktb = 0
  160   nfldtx = 0
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
c
        if (ufield(1)(1:8) .eq. '        ') then
          nfldtx = 4
          if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
          iktb = iktb + 1
          if (iktb .eq. 1) uphas2(nsq) = ufield(2)
          umemb(iktb,nxtb) = ufield(2)
          ustr = ufield(3)
          call chreal(nttyo,qrderr,ustr,var)
          if (qrderr) go to 999
          xbarb(iktb,nxtb) = var
          go to 160
        else
          ncompb(nxtb) = iktb
          go to 130
        endif
      endif
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      go to 130
c
  180 continue
c
c-----------------------------------------------------------------------
c
c     Mole fractions of solid solutions.
c
      uheadx = 'input solid solutions'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .eq. '--------') go to 260
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      if (ustr(1:4) .eq. 'none') then
        nfldtx = 1
        call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $  nttyo,qrderr,ufield,uline1,ulscr)
        if (qrderr) go to 999
        ustr = ufield(1)
        call locase(ustr)
        if (ustr(1:8) .ne. '--------') then
          j2 = ilnobl(uline1)
          write (nttyo,1305) uline1(1:j2)
 1305     format(/' * Error - (XCON3/rd3d7) Found the line beginning',
     $    ' with-',/7x,'"',a,'"',
     $    /7x,'where a dashed separator line was expected.')
          go to 990
        endif
        go to 260
      endif
c
  220 nxtb = nxtb + 1
c
      if (nxtb .gt. nxtmax) then
        write (nttyo,1310) nxtmax
        go to 990
      endif
c
      usolb(nxtb) = ufield(1)
      iktb = 0
c
  230 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .ne. '        ') then
        ncompb(nxtb) = iktb
        if (ustr(1:8) .eq. '--------') go to 260
        go to 220
      endif
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      ustr = ufield(1)
      if (ustr(1:8) .ne. '        ') then
        ncompb(nxtb) = iktb
        go to 220
      endif
c
      iktb = iktb + 1
c
      if (iktb .gt. iktmax) then
        j2 = ilnobl(usolb(nxtb))
        write (nttyo,1330) usolb(nxtb)(1:j2),iktmax
 1330   format(/' * Error - (XCON3/rd3d7) Solid solution',
     $  /7x,'"',a,'" has too many end-members present.',
     $  /7x,'This code is only dimensioned for ',i3,' end-members',
     $  /7x,'per solid solution. Reduce the number of end-members',
     $  /7x,'or increase the dimensioning parameter iktpar.')
        go to 990
      endif
c
      umemb(iktb,nxtb) = ufield(2)
      ustr = ufield(3)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      xbarb(iktb,nxtb) = var
c
      go to 230
c
  260 continue
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      uheadx = 'suppressed species'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
c
      n = 0
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .eq. '--------') go to 570
c
      if (ustr(1:4) .eq. 'none') go to 560
c
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
  550 n = n + 1
c
      if (n .gt. nxmdmx) then
        write (nttyo,1132) nxmdmx
 1132   format(/' * Error - (XCON3/rd3d7) Have too many nxmod',
     $  /7x,'alter/suppress options. The code is only dimensioned',
     $  /7x,'for ',i3,' such options. Reduce the number of such',
     $  ' options',/7x,'or increase the dimensioning parameter',
     $  ' nxmdpa.')
        go to 990
      endif
c
      uxmd24(n) = ufield(1)
c
      ustr = ufield(2)
      call locase(ustr)
      if (ustr(1:7) .eq. 'aqueous') then
        jxmod(n) = 0
      elseif (ustr(1:7) .eq. 'mineral') then
        jxmod(n) = 1
      elseif (ustr(1:3) .eq. 'gas') then
        jxmod(n) = 2
      elseif (ustr(1:14) .eq. 'solid solution') then
        jxmod(n) = 3
      else
        j2 = ilnobl(ustr)
        write (nttyo,1135) ustr(1:j2)
 1135   format(/" * Error - (XCON3/rd3d7) Can't identify the",
     $  /7x,'following alter/suppress species type string- "',a,'".',
     $  /7x,'This must be one of "aqueous", "mineral", "gas",',
     $  /7x,' or "solid solution".')
        go to 990
      endif
c
      ustr = ufield(3)
      call locase(ustr)
      if (ustr(1:8) .eq. 'suppress') then
        kxmod(n) = -1
      elseif (ustr(1:7) .eq. 'replace') then
        kxmod(n) = 0
      elseif (ustr(1:8) .eq. 'augmentk') then
        kxmod(n) = 1
      elseif (ustr(1:8) .eq. 'augmentg') then
        kxmod(n) = 2
      else
        j2 = ilnobl(ustr)
        write (nttyo,1140) ustr(1:j2)
 1140   format(/" * Error - (XCON3/rd3d7) Can't identify the",
     $  /7x,'following alter/suppress option string- "',a,'".',
     $  /7x,'This must be one of "suppress", "replace", "augmentk",',
     $  /7x,' or "augmentg".')
        go to 990
      endif
c
      ustr = ufield(4)
      call chreal(nttyo,qrderr,ustr,var)
      if (qrderr) go to 999
      xlkmod(n) = var
c
  560 nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      call locase(ustr)
      if (ustr(1:8) .eq. '--------') go to 570
      nfldtx = 4
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      go to 550
c
  570 nxmod = n
c
c-----------------------------------------------------------------------
c
c     Options. These are iopt, iopg, and iopr option switches,
c     skipping ones which may be classified as development options.
c     The development options are read below, in a somewhat different
c     manner. The iodb option switches are read still further below,
c     in a manner similar to that employed here.
c
c     Note: iopt(1) = iopt1, etc.
c
      nfldtx = 1
      uheadx = 'options'
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
c
      i = 0
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 420
c
      ulscr = ufield(1)
      if (ulscr(1:2) .ne. '- ') then
        j = ilnobl(uline1(1:70))
        write (nttyo,1250) uline1(1:j)
 1250   format(/' * Error - (XCON3/rd3d7) Found the line beginning',
     $  ' with-',/7x,'"',a,'"',
     $  /7x,'where an iopt, iopg, iopr, or iodb option switch header',
     $  /7x,'was expected.')
        go to 990
      endif
c
c     Have found an option header.
c
  340 i = i + 1
      nmark = 0
      nmarks = 0
c
c     Put the option header string minus the preceding "- " string
c     into the variable uheadr.
c
      uheadr = ulscr(3:nlchmx)
      call locase(uheadr)
c
c     Remove the succeeding " -" string, if any.
c
      j = ilnobl(uheadr)
      if (uheadr(j - 1:j) .eq. ' -') uheadr(j:j) = ' '
c
c     Identify the corresponding option.
c
      do 370 idescx = 1,nop3pa
        uheadx = uopt3(idescx)
        call locase(uheadx)
        if (uheadr(1:40) .eq. uheadx(1:40)) then
          if (idescx .ne. i) then
            j2 = ilnobl(uopt3(idescx))
            j3 = ilnobl(uvar3(idescx))
            write (nttyo,1260) uopt3(idescx)(1:j2),
     $      uvar3(idescx)(1:j3),index3(idescx),i,idescx
 1260       format(/' * Warning - (XCON3/rd3d7) The input for the',
     $      /7x,'option whose identifying string which begins with-',
     $      /7x,'"',a,'"',/7x,'(',a,'(',i2,')) is out of order,',
     $      ' in place ',i3,' instead of place ',i3,'.')
          endif
          go to 380
        endif
  370 continue
c
      j2 = ilnobl(uheadr)
      write (nttyo,1270) uheadr(1:j2)
 1270 format(/" * Error - (XCON3/rd3d7) Can't identify the following",
     $ /7x,'iopt, iopg, iopr, or iodb option header-',
     $ /7x,'"',a,'".')
      go to 990
c
  380 continue
c
c     Read the first line after an option  header.
c
      jdesc = 0
  390 jdesc = jdesc + 1
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') then
        if (nmarks .gt. 1) then
          j2 = ilnobl(uopt3(idescx))
          j3 = ilnobl(uvar3(idescx))
          write (nttyo,1280) uopt3(idescx)(1:j2),
     $    uvar3(idescx)(1:j3),index3(idescx)
 1280     format(/' * Error - (XCON3/rd3d7) More than one choice',
     $    /7x,'was marked for the following option-',
     $    /7x,'"',a,'"',/9x,a,'(',i2,').')
          go to 990
        endif
        go to 420
      endif
c
c     Is the current line a new option header?
c
      if (ulscr(1:2) .eq. '- ') then
        if (nmarks .gt. 1) then
          j2 = ilnobl(uopt3(idescx))
          j3 = ilnobl(uvar3(idescx))
          write (nttyo,1280) uopt3(idescx)(1:j2),
     $    uvar3(idescx)(1:j3),index3(idescx)
          go to 990
        endif
        go to 340
      endif
c
      j = 1
      nmark = 0
      if (ulscr(1:1) .eq. '*') then
        j = 2
        nmark = 1
        nmarks = nmarks + 1
      endif
      uheadr = ulscr(j:nlchmx)
      call locase(uheadr)
      call lejust(uheadr)
c
      do 400 idesc = 1,nod3pa
        if (iopti3(idesc) .eq. idescx) then
          uheadx = udesc3(idesc)
          call locase(uheadx)
          if (uheadr(1:40) .eq. uheadx(1:40)) go to 410
        endif
  400 continue
c
      j = ilnobl(uheadr)
      j2 = ilnobl(uopt3(idescx))
      j3 = ilnobl(uvar3(idescx))
      write (nttyo,1290) uheadr(1:j),uopt3(idescx)(1:j2),
     $ uvar3(idescx)(1:j3),index3(idescx)
 1290 format(/" * Error - (XCON3/rd3d7) Can't identify the following",
     $ /7x,'option string-',/7x,'"',a,'".',
     $ /7x,'It was given for the following option-',
     $ /7x,'"',a,'"',/9x,a,'(',i2,').')
      go to 990
c
  410 if (nmark .eq. 1) then
        ustr = uvar3(idescx)
        call locase(ustr)
        if (ustr(1:4) .eq. 'iopt') then
          iopt(index3(idescx)) = ivalu3(idesc)
        elseif (ustr(1:4) .eq. 'iopg') then
          iopg(index3(idescx)) = ivalu3(idesc)
        elseif (ustr(1:4) .eq. 'iopr') then
          iopr(index3(idescx)) = ivalu3(idesc)
        elseif (ustr(1:4) .eq. 'iodb') then
          iodb(index3(idescx)) = ivalu3(idesc)
        else
          j = ilnobl(uheadr)
          j3 = ilnobl(uvar3(idescx))
          write (nttyo,1300) uvar3(idescx)(1:j3),uheadr(1:j)
 1300     format(/" * Error - (XCON3/rd3d7) Don't recognize the",
     $    /7x,'option type string "',a,'", which was given for',
     $    /7x,'the following option-',/7x,'"',a,'".')
          go to 990
        endif
      endif
c
      go to 390
c
  420 continue
c
c-----------------------------------------------------------------------
c
c     Iodb options.
c
c     Note: iodb(1) = iodb, etc.
c
      nfldtx = 1
      uheadx = 'debugging switches'
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        j2 = ilnobl(uheadx)
        j3 = ilnobl(uline1)
        write (nttyo,1020) uheadx(1:j2),uline1(1:j3)
 1020   format(/' * Error - (XCON3/rd3d7) Was expecting to find the',
     $  /7x,'header beginning with-',/7x,'"',a,'"',
     $  /7x,'on the line beginning with-',/7x,'"',a,'".')
        go to 990
      endif
c
      i = 0
  440 i = i + 1
      nfldtx = 1
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ulscr = ufield(1)
      if (ulscr(1:8) .eq. '--------') go to 470
c
      j = index(ulscr,' ')
      j2 = j - 1
      if (j2 .eq. 0) j2 = 1
      ustr = ulscr(1:j2)
      j1 = j + 1
      if (j1 .gt. nlchmx) j1 = nlchmx
      uheadr = ulscr(j1:nlchmx)
      call locase(uheadr)
      call lejust(uheadr)
      do 450 idescx = 1,ndb3pa
        uheadx = udebug(idescx)
        call locase(uheadx)
        if (uheadr(1:40) .eq. uheadx(1:40)) go to 460
  450 continue
c
      j2 = ilnobl(uheadr)
      write (nttyo,1110) uheadr(1:j2)
 1110 format(/" * Error - (XCON3/rd3d7) Can't identify the following",
     $ /7x,'iodb option header-',
     $ /7x,'"',a,'".')
      go to 990
c
  460 call chrint(ivar,nttyo,qrderr,ustr)
      if (qrderr) go to 999
      iodb(idbugi(idescx)) = ivar
      go to 440
c
  470 continue
c
c-----------------------------------------------------------------------
c
c     Development options. There are none.
c
      uheadx = 'development options'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      nfldtx = 1
      uheadx = 'none'
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
c-----------------------------------------------------------------------
c
c     Tolerances.
c
      uheadx = 'tolerances'
      nfldtx = 1
      call rdd2lh(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uheadr,uheadx,uline1,uline2,ulscr)
      if (qrderr) go to 999
      uheadr = ufield(1)
      call locase(uheadr)
      j2 = ilnobl(uheadx)
      j = index(uheadr,uheadx(1:j2))
      if (j .eq. 0) then
        write (nttyo,1020) uheadx,uline1
        go to 990
      endif
c
      i = 0
  510 i = i + 1
      nfldtx = 0
      call rdd1l(nfldmx,nfldt,nfldtx,ninpts,nlchmx,
     $ nttyo,qrderr,ufield,uline1,ulscr)
      if (qrderr) go to 999
      ustr = ufield(1)
      if (ustr(1:8) .eq. '--------') go to 520
c
      nfldtx = 3
      if (nfldt .ne. nfldtx) write (nttyo,1030) nfldt,nfldtx,uline1
c
      uheadr = ufield(1)
      call locase(uheadr)
c
      do 515 idescx = 1,nto3pa
        uheadx = utol3(idescx)
        call lejust(uheadx)
        call locase(uheadx)
        if (uheadr(1:32) .eq. uheadx(1:32)) go to 517
  515 continue
c
      j2 = ilnobl(uheadr)
      write (nttyo,1130) uheadr(1:j2)
 1130 format(/" * Error - (XCON3/rd3d7) Can't identify the following",
     $ /7x,'tolerance parameter header-',
     $ /7x,'"',a,'".')
      go to 990
c
  517 ustr = ufield(2)
      if (idescx .eq. 1) then
c
c       Tolbt.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolbt = var
      elseif (idescx .eq. 2) then
c
c       Toldl.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        toldl = var
      elseif (idescx .eq. 3) then
c
c       Tolsat.
c
        call chreal(nttyo,qrderr,ustr,var)
        if (qrderr) go to 999
        tolsat = var
      elseif (idescx .eq. 4) then
c
c       Itermx.
c
        call chrint(ivar,nttyo,qrderr,ustr)
        if (qrderr) go to 999
        itermx = ivar
      endif
c
      go to 510
c
  520 continue
c-----------------------------------------------------------------------
c
      go to 999
c
  990 qrderr = .true.
c
  999 continue
      end

      subroutine prtnca(ctb,jflag,jsflag,mrmlra,mwtsp,narn1,narn2,
     $ nbasp,nbaspd,nbt,nbtmax,noutpt,nstmax,qrho,rho,uspec,wfh2o)
c
c     This subroutine computes and prints a table of the numerical
c     composition of the aqueous solution in terms of mass balance
c     totals for component (basis) species in the 'd' basis set.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ctb    = array of molalities of the component (basis) species
c       rho    = the density of the aqueous solution
c       qrho   = .true. if a solution density value is available
c       uspec  = array of names of aqueous species
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt
c
      integer jflag(nstmax),jsflag(nstmax),nbasp(nbtmax),nbaspd(nbtmax)
      integer narn1,narn2,nbt
c
      logical qrho
c
      character(len=48) uspec(nstmax)
c
      real(8) ctb(nbtmax),mwtsp(nstmax)
      real(8) mrmlra,rho,wfh2o
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,ns1,ns2
c
      real(8) molrx,ppmv,ppmw
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(/11x,'--- Numerical Composition of the',
     $ ' Aqueous Solution ---')
c
      if (qrho) then
c
c       Have density data, include mg/L and Molarity.
c
        write (noutpt,1010)
 1010   format(/3x,'Species',20x,'mg/L',7x,'mg/kg.sol',4x,
     $  'Molarity',5x,'Molality',/)
c
        do nb = 1,nbt
          ns1 = nbaspd(nb)
          ns2 = nbasp(nb)
          if (ns1.ge.narn1 .and. ns1.le.narn2) then
            if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
              ppmw = 1000.*ctb(nb)*mwtsp(ns1)*wfh2o
              ppmv = ppmw*rho
              molrx = ctb(nb)*mrmlra
              write (noutpt,1020) uspec(ns1),ppmv,ppmw,molrx,ctb(nb)
 1020         format(1x,a24,1x,1pe12.5,1x,1pe12.5,1x,1pe12.5,
     $        1x,1pe12.5)
            endif
          endif
        enddo
      else
c
c       Have no density data, so do not include mg/L and Molarity.
c
        write (noutpt,1030)
 1030   format(/3x,'Species',18x,'mg/kg.sol',4x,'Molality',/)
c
        do nb = 1,nbt
          ns1 = nbaspd(nb)
          ns2 = nbasp(nb)
          if (ns1.ge.narn1 .and. ns1.le.narn2) then
            if (jsflag(ns2).lt.2 .and. jflag(ns2).ne.30) then
              ppmw = 1000.*ctb(nb)*mwtsp(ns1)*wfh2o
              write (noutpt,1040) uspec(ns1),ppmw,ctb(nb)
 1040         format(1x,a24,1x,1pe12.5,1x,1pe12.5)
            endif
          endif
        enddo
      endif
c
      write (noutpt,1050)
 1050 format(/3x,'Some of the above data may not be physically',
     $ ' significant.',/)
c
      end

      subroutine gdd(dgpit,fxi,gpit,ipbtmx,napmax,napt,palpha)
c
c     This subroutine computes the functions g(xi) and their ionic
c     strength derivatives (xi = alpha(i) * I**1/2). These functions
c     are used in Pitzer's equations. Note: alpha(i) = 0 implies
c     that g(xi) and its derivatives are zero.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       napt   = number of alpha coefficient pairs in the palpha array
c
c     Principal output:
c
c       gpit   = array of values for the g(x) function
c       dgpit  = array of values for the ionic strength derivatives
c                  of the g(x) function
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,napmax
c
      integer napt
c
      real(8) dgpit(2,ipbtmx,napmax),gpit(ipbtmx,napmax),
     $ palpha(ipbtmx,napmax)
      real(8) fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,nap
c
      real(8) alphai,dxdi,emx,gpx,gppx,x,xsq
c
c-----------------------------------------------------------------------
c
      do nap = 1,napt
        do i = 1,ipbtmx
          gpit(i,nap) = 0.
          dgpit(1,i,nap) = 0.
          dgpit(2,i,nap) = 0.
          alphai = palpha(i,nap)
          x = alphai * sqrt(fxi)
c
          if (x .ne. 0.) then
            xsq = x*x
            emx = exp(-x)
c
c           Calculate g(x).
c
            gpit(i,nap) = (2./xsq) * (1. - emx*(1. + x))
c
c           Calculate the derivatives with respect to x.
c
            gpx = (-2./(xsq*x)) * (2. - emx*(2. + x*(2. + x)))
            gppx = (-2./(xsq*xsq))
     $      * (-6. + emx*(6. + x*(6. + x*(3. + x))))
c
c           Calculate the derivatives with respect to ionic strength.
c
            dxdi = alphai/(2.*sqrt(fxi))
            dgpit(1,i,nap) = dxdi * gpx
            dgpit(2,i,nap) = dxdi * (gppx*dxdi - 0.5*gpx/fxi)
          endif
        enddo
      enddo
c
      end

      subroutine rdpz3(apsi,atheta,jpfcmx,nat,natmax,ndat0s,nerr,
     $ noutpt,npx3mx,npx3t,nthdt,nttyo,nwarn,uaqsp,uethfl,uthdtr,
     $ utripl,zaqsp)
c
c     This suboutine reads the following Pitzer interaction parameter
c     data from the DATA0 file:
c
c       S-theta(MM'X) (and S-theta (MXX')) and their temperature
c         derivatives
c       psi(MM'X) (and psi (MXX')) and their temperature derivatives
c
c     (Here M = a cation, M' = a second cation, X = an anion, and
c     X' = a second anion).
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       apsi   = array of coefficients for computing psi parameters
c       atheta = array of coefficients for computing S-theta parameters
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c       nthdt  = the number of distinct S-theta parameter entries
c                  (i.e., not counting duplicates)
c       npx3t  = the number of triplets of species for which Pitzer
c                  interaction parameters are defined
c       utripl = array of names in a species triplet
c       uthdtr = array of names of cc'a and aa'c triplets which
c                  provide the values used for coefficients for
c                  computing S-theta parameters for the cc' and aa'
c                  pairs
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jpfcmx,natmax,npx3mx
c
      integer ndat0s,noutpt,nttyo
c
      integer nat,nerr,npx3t,nthdt,nwarn
c
      character*24 uaqsp(natmax),uthdtr(3,npx3mx),utripl(3,npx3mx)
      character*8 uethfl
c
      real*8 atheta(jpfcmx,npx3mx),apsi(jpfcmx,npx3mx),zaqsp(natmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ier,ifound,iz1,iz2,iz3,j,j2,j3,j4,j5,j6,j7,j8,
     $ na,nc,nn,npx3,nthd,n1,n2,n3
c
      integer ilnobl
c
      logical qdup12,qdup13,qdup23
c
      character*80 uline
      character*24 unam1,unam2,unam3,uthd1,uthd2,uthd3,ux24a,ux24b,
     $ ux24c,u1,u2,u3
      character*8 uelemt,uterm,ux8
c
      real(8), dimension(:), allocatable :: athetx
c
      real(8) z1,z2,z3
c
c-----------------------------------------------------------------------
c
      data uelemt / 'elements'/
      data uterm  / '+-------'/
c
c-----------------------------------------------------------------------
c
c     Allocate work array.
c
      ALLOCATE(athetx(jpfcmx))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nthdt = 0
      npx3 = 0
c
c     Read the E-theta flag.
c
      uethfl = ' '
      read (ndat0s,1000,end=990,err=995) uline
 1000 format(a80)
      i = index(uline,'E-theta flag')
      if (i .eq. 0) then
        write (noutpt,1010)
        write (nttyo,1010)
 1010   format(/' * Error - (EQPT/rdpz3) The E-theta flag line is',
     $  ' missing from',
     $  /7x,'the DATA0 file. This line is specific to DATA0 files',
     $  /7x,"tied to Pitzer's equations. It should appear after",
     $  /7x,'the line containing "mixture parameters". The E-theta',
     $  /7x,'flag line should contain "E-theta flag = on" or',
     $  /7x,'"E-theta flag = off". A value of "on" causes inclusion',
     $  /7x,'of the higher-order electrostatic (E-theta) terms in',
     $  /7x,"Pitzer's",' equations. A value of "off" causes the',
     $  /7x,"exclusion of these terms. Most models based on Pitzer's",
     $  /7x,'equations are consistent with the inclusion of these',
     $  /7x,'terms, but some are not. The values of the mixture',
     $  /7x,'coefficients theta and psi are consistent with either',
     $  /7x,'the inclusion or the exclusion of these terms.')
        stop
      endif
      i = index(uline,'= on')
      if (i .gt. 0) then
        uethfl = uline(i + 2:i + 3)
      else
        i = index(uline,'= off')
        if (i .gt. 0) then
          uethfl = uline(i + 2:i + 4)
        else
          write (noutpt,1020) uline
          write (nttyo,1020) uline
 1020     format(/' * Error - (EQPT/rdpz3) The value of the E-theta',
     $    ' flag on the line:',
     $    //7x,'"',a32,'"',
     $    //7x,"isn't ",'"on" or "off", as is required.')
          stop
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     LOOP HERE for each species block
c
  100 continue
c
c     Skip past the block terminator line.
c
      read (ndat0s,1000,end=990,err=995) uline
      if (uline(1:8) .ne. uterm(1:8)) go to 100
c
c     Check for the end of the present superblock.
c
      read (ndat0s,1030,end=990,err=995) unam1,unam2,unam3
 1030 format(a24,2x,a24,2x,a24)
      if (unam1(1:8) .eq. uelemt(1:8)) then
c
c       Found the header for the elements block.
c
        npx3t = npx3
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Have another species triplet.
c
      npx3 = npx3 + 1
c
      j2 = ilnobl(unam1)
      j3 = ilnobl(unam2)
      j4 = ilnobl(unam3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for blank names.
c
      if (j2.le.0 .or. j3.le.0 .or. j4.le.0) then
        write (ux8,'(i5)') npx3
        call lejust(ux8)
        j5 = ilnobl(ux8)
        if (j2 .le. 0) then
          unam1 = '<blank>'
          j2 = ilnobl(unam1)
        endif
        if (j3 .le. 0) then
          unam2 = '<blank>'
          j3 = ilnobl(unam2)
        endif
        if (j4 .le. 0) then
          unam3 = '<blank>'
          j4 = ilnobl(unam3)
        endif
        write (noutpt,1040) ux8(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j4)
        write (nttyo,1040) ux8(1:j5),unam1(1:j2),unam2(1:j3),
     $  unam3(1:j4)
 1040   format(/' * Error - (EQPT/rdpz3) Have encountered a blank',
     $  ' species name',/7x,'in the species triplet for block ',a,
     $  ' of the superblock for',/7x,'Pitzer parameter data',
     $  ' corresponding to species triplets.',/7x,'The offending',
     $  ' triplet shows as ',a,', ',a,', ',a,'.')
        if (npx3 .gt. 1) then
          ux24a = utripl(1,npx3 - 1)
          ux24b = utripl(2,npx3 - 1)
          ux24c = utripl(3,npx3 - 1)
          if (ux24a(1:7).ne.'<blank>' .or.
     $      ux24b(1:7).ne.'<blank>' .or.
     $      ux24c(1:7).ne.'<blank>') then
            j6 = ilnobl(ux24a)
            j7 = ilnobl(ux24b)
            j8 = ilnobl(ux24c)
            write (noutpt,1050) ux24a(1:j6),ux24b(1:j7),ux24c(1:j8)
            write (nttyo,1050) ux24a(1:j6),ux24b(1:j7),ux24c(1:j8)
 1050       format(7x,'This block follows the one for ',a,
     $      ', ',a,', ',a,'.')
          endif
        endif
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of the three species (n1, n2, n3). These
c     indices point to the data read from the previously read
c     species blocks.
c
c     Get the index for the first species name.
c
c     Calling sequence substitutions:
c       n1 for na
c       unam1 for unams
c
      call gspidx(ier,n1,nat,natmax,uaqsp,unam1)
c
      if (ier .gt. 0) then
        if (unam1(1:7).ne.'<blank>' .and.
     $    unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
          write (noutpt,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
          write (nttyo,1100) unam1(1:j2),unam1(1:j2),unam2(1:j3),
     $    unam3(1:j4)
 1100     format(/' * Error - (EQPT/rdpz3) The aqueous species ',
     $    a,' appearing in',/7x,'the Pitzer parameter data block',
     $    ' for the species triplet',/7x,a,', ',a,', ',a,' does',
     $    ' not appear in an aqueous',/7x,'species data block.')
          nerr = nerr + 1
        endif
      endif
c
c     Get the index for the second species name.
c
      qdup12 = .false.
      if (unam2(1:24) .eq. unam1(1:24)) then
c
        qdup12 = .true.
        n2 = n1
      else
c
c       Calling sequence substitutions:
c         n2 for na
c         unam2 for unams
c
        call gspidx(ier,n2,nat,natmax,uaqsp,unam2)
c
        if (ier .gt. 0) then
          if (unam1(1:7).ne.'<blank>' .and.
     $      unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
            write (noutpt,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
            write (nttyo,1100) unam2(1:j3),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
            nerr = nerr + 1
          endif
        endif
      endif
c
c     Get the index for the third species name.
c
      qdup13 = .false.
      qdup23 = .false.
      if (unam3(1:24) .eq. unam1(1:24)) then
c
        qdup13 = .true.
        if (qdup12) qdup23 = .true.
        n3 = n1
      elseif (unam3(1:24) .eq. unam2(1:24)) then
c
        qdup23 = .true.
        if (qdup12) qdup13 = .true.
        n3 = n2
      else
c
c       Calling sequence substitutions:
c         n3 for na
c         unam3 for unams
c
        call gspidx(ier,n3,nat,natmax,uaqsp,unam3)
c
        if (ier .gt. 0) then
          if (unam1(1:7).ne.'<blank>' .and.
     $      unam2(1:7).ne.'<blank>' .and. unam3(1:7).ne.'<blank>') then
            write (noutpt,1100) unam3(1:j4),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
            write (nttyo,1100) unam3(1:j4),unam1(1:j2),unam2(1:j3),
     $      unam3(1:j4)
            nerr = nerr + 1
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (n1.ne.0 .and. n2.ne.0 .and. n3.ne.0) then
c
c       Get the charges.
c
        z1 = zaqsp(n1)
        z2 = zaqsp(n2)
        z3 = zaqsp(n3)
c
        iz1 = nint(z1)
        iz2 = nint(z2)
        iz3 = nint(z3)
c
c       Count the neutral species.
c
        nn = 0
        if (iz1 .eq. 0) nn = 1
        if (iz2 .eq. 0) nn = nn + 1
        if (iz3 .eq. 0) nn = nn + 1
c
c       Count the cations.
c
        nc = 0
        if (iz1 .gt. 0) nc = 1
        if (iz2 .gt. 0) nc = nc + 1
        if (iz3 .gt. 0) nc = nc + 1
c
c       Count the anions.
c
        na = 0
        if (iz1 .lt. 0) na = 1
        if (iz2 .lt. 0) na = na + 1
        if (iz3 .lt. 0) na = na + 1
c
c       Check for illegal species combinations. These checks depend
c       on the charge combinations; hence, they should not be made
c       unless the all the charges have been determined.
c
        call tripck(na,nc,nerr,nn,noutpt,nttyo,n1,n2,n3,
     $  qdup12,qdup13,qdup23,unam1,unam2,unam3)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the names before rearranging for storage.
c
      u1 = unam1
      u2 = unam2
      u3 = unam3
c
c     Rearrange for storage. The rules are:
c
c       If exactly one neutral is present:
c         neutral, cation, anion
c
c       If exactly two neutrals are present:
c         neutral 1, neutral 1, neutral2
c
c       If two cations are present:
c         cation 1, cation 2, anion
c
c       If two anions are present:
c         anion 1, anion 2, cation
c
c       If two species are of the same charge type,
c       store alphabetically.
c
      call artrip(iz1,iz2,iz3,na,nc,nn,n1,n2,n3,
     $ u1,u2,u3,z1,z2,z3)
c
c     Store the triplet names in the order required by the
c     storage rules. The triplet in the original order is
c     preserved in unam1, unam2, unam3 for use in error messages
c     and such.
c
      utripl(1,npx3) = u1
      utripl(2,npx3) = u2
      utripl(3,npx3) = u3
c
c     Read the S-theta and psi parameters.
c
      read (ndat0s,1160,end=990,err=995) athetx(1),apsi(1,npx3)
 1160 format(13x,f8.5,13x,f8.5)
c
c     Read the first source.
c
      read (ndat0s,1170,end=990,err=995) uline
 1170 format(13x,a24)
c
c     Read the first and second temperature derivatives of the
c     S-theta and psi parameters.
c
      read (ndat0s,1180,end=990,err=995) athetx(2),athetx(3)
      read (ndat0s,1180,end=990,err=995) apsi(2,npx3),apsi(3,npx3)
 1180 format(13x,e10.3,13x,e10.3)
c
c     Read the second source.
c
      read (ndat0s,1170,end=990,err=995) uline
c
c     Check for illegal inputs in the S-theta data fields.
c
      call thetck(athetx,jpfcmx,na,nc,nerr,nn,noutpt,nttyo,
     $ n1,n2,n3,unam1,unam2,unam3)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ((nc.eq.2 .and. na.eq.1) .or.
     $  (nc.eq.1 .and. na.eq.2)) then
c
c       Find the theta index for the two cations or two anions.
c
        ifound = 0
        do nthd = 1,nthdt
          uthd1 = uthdtr(1,nthd)
          uthd2 = uthdtr(2,nthd)
          uthd3 = uthdtr(3,nthd)
          if (u1.eq.uthd1 .and. u2.eq.uthd2) then
            ifound = 1
            j2 = ilnobl(u1)
            j3 = ilnobl(u2)
            j4 = ilnobl(u3)
            j5 = ilnobl(uthd1)
            j6 = ilnobl(uthd2)
            j7 = ilnobl(uthd3)
            do j = 1,jpfcmx
              write (ux8,'(i5)') j
              call lejust(ux8)
              j8 = ilnobl(ux8)
              if (abs(atheta(j,nthd) - athetx(j)) .gt. 1.e-6) then
                write (noutpt,1200) ux8(1:j8),u1(1:j2),u2(1:j3),
     $          u3(1:j4),athetx(j),uthd1(1:j5),uthd2(1:j6),
     $          uthd3(1:j7),atheta(j,nthd)
                write (nttyo,1200) ux8(1:j8),u1(1:j2),u2(1:j3),
     $          u3(1:j4),athetx(j),uthd1(1:j5),uthd2(1:j6),
     $          uthd3(1:j7),atheta(j,nthd)
 1200           format(/' * Warning - (EQPT/rdpz3) The S-theta',
     $          ' a(',a,') coefficient for the',/7x,'triplet ',
     $          a,', ',a,', ',a,' is ',e12.5,',',/7x,'whereas the',
     $          ' value previously read for the triplet',
     $          /7x,a,', ',a,', ',a,' is ',e12.5,'. The former',
     $          ' value will be ignored.')
                nwarn = nwarn + 1
              endif
            enddo
            go to 110
          endif
        enddo
  110   continue
c
        if (ifound .eq. 0) then
c
c         Found a new pair defining a theta parameter.
c
          nthdt = nthdt + 1
          nthd = nthdt
          uthdtr(1,nthd) = u1
          uthdtr(2,nthd) = u2
          uthdtr(3,nthd) = u3
          do j = 1,jpfcmx
            atheta(j,nthd) = athetx(j)
          enddo
        endif
      endif
c
c     Go back to read the next species block.
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdpz3) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
      stop
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/rdpz3) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
c     Deallocate work array.
c
      DEALLOCATE(athetx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine cdrssd(adhfs,adhfsd,advfs,advfsd,axhfs,axhfsd,
     $ axlks,axlksd,axvfs,axvfsd,cdrs,cdrsd,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,nbasp,nbaspd,nbtmax,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,
     $ nstmax,ntprmx)
c
c     This subroutine copies the reactions and reaction properties as
c     they are currently written into the 'd' set.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adhfs  = standard array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfs  = standard array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfs  = standard array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlks  = standard array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfs  = standard array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrs   = standard array of reaction coefficients
c       narxmx = number of coefficient elements of axlks per species
c                  per temperature range
c       nbtmax = maximum number of basis species
c       ndrs   = standard  array of indices of species corresponding to
c                  reaction coefficients
c       ndrsr  = standard pointer array for indices of species appearing
c                  in reactions
c       nstmax = maximum number of species
c       ntprmx = maximum number of temperature ranges
c
c     Principal output:
c
c       adhfsd = 'data file' array of coefficients for computing
c                  pressure derivatives of enthalpy functions as a
c                  function of temperature
c       advfsd = 'data file' array of coefficients for computing
c                  pressure derivatives of volume functions as a
c                  function of temperature
c       axhfsd = 'data file' array of coefficients for computing
c                  enthalpy functions as a function of temperature
c       axlksd = 'data file' array of coefficients for computing
c                  equilibrium constants as a function of temperature
c       axvfsd = 'data file' array of coefficients for computing
c                  volume functions as a function of temperature
c       cdrsd  = 'data file' array of reaction coefficients
c       ndrsd  = 'data file'  array of indices of species corresponding
c                  to reaction coefficients
c       ndrsrd = 'data file' pointer array for indices of species
c                  appearing in reactions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer nbasp(nbtmax),nbaspd(nbtmax),ndrs(ndrsmx),ndrsd(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrd(2,nstmax)
      integer ipch,ipcv
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsd(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksd(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsd(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsd(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jhmax,jvmax,nmax
c
c-----------------------------------------------------------------------
c
      nmax = narxmx*ntprmx*nstmax
      jhmax = narxmx*ntprmx*ipchmx*nstmax
      jvmax = narxmx*ntprmx*ipcvmx*nstmax
c
      call copyaa(axlks,axlksd,nmax)
c
      if (ipch .ge. 0) then
        call copyaa(axhfs,axhfsd,nmax)
        if (ipch .ge. 1) call copyaa(adhfs,adhfsd,jhmax)
      endif
c
      if (ipcv .ge. 0) then
        call copyaa(axvfs,axvfsd,nmax)
        if (ipcv .ge. 1) call copyaa(advfs,advfsd,jvmax)
      endif
c
      nmax = 2*nstmax
      call copyia(ndrsr,ndrsrd,nmax)
c
      call copyaa(cdrs,cdrsd,ndrsmx)
      call copyia(ndrs,ndrsd,ndrsmx)
c
      call copyia(nbasp,nbaspd,nbtmax)
c
      end

      subroutine cko2pr(delxi,dlxmin,do20,dxo0pr,dxo1pr,dxval0,
     $ eps100,iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,fo2lg0,
     $ fo2lg1,o20prn,o21prn,prcinf,qdump,tolxsu,xi0,xi1,xval0)
c
c     This subroutine checks to see that the next log fO2-based print
c     point is not exceeded. Because the log fO2 might be decreasing
c     or increasing, two potential target points (o20prn and o21prn)
c     must be addressed.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer nord
c
      logical qdump
c
      real*8 do20(nrd1mx),dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,dxo0pr,dxo1pr,eps100,prcinf,fo2lg0,o20prn,
     $ fo2lg1,o21prn,tolxsu,xi0,xi1,xval0,xtargv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,n
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxp,dxsv,tolsx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'log fO2 reaches a print point value             '/
      data unam24  /'                       '/
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
c
      dxo0pr = prcinf
      dxo1pr = prcinf
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The first search target is the currently defined log fO2-based
c     print point associated with the lesser log fO2 value.
c
      ilsign = +1
      xtargv = o20prn
      tolsx = tolxsu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for where the log fO2 reaches the lesser',
     $    ' of two print point values',/3x,'has failed. Dropping to',
     $    ' the minimum step size.')
        endif
        delxi = dlxmin
        go to 110
      endif
c
c     Estimate the log fO2 from a Taylor's series expansion.
c
      fo2lg1 = fo2lg0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        fo2lg1 = fo2lg1 + ( do20(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (fo2lg0 .le. (1. + tolxsu)*o20prn) then
c
c         The log fO2 at the base point is too close to the requested
c         lesser print point value.
c
          delxi = dlxmin
          dxo0pr = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) fo2lg0,o20prn,xi0,delxi
 1010       format(/3x,'The base point log fO2 of ',1pe11.4,' is',
     $      ' already very close',/3x,'to the requested lesser print',
     $      ' point value of',e11.4,/3x,'at Xi= ',e11.4,'. Have set',
     $      ' delxi equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 100
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((fo2lg1 - o20prn) .lt. -tolsx) then
c
          xval0 = fo2lg0
          do n = 1,nord
            dxval0(n) = do20(n)
          enddo
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dxo0pr = delxi
          if (ier .le. 0) go to 100
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dxo0pr = delxi
          go to 110
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(fo2lg1 - o20prn) .le. tolsx) then
          write (noutpt,1020) o20prn,xi1,delxi
 1020     format(/3x,"Taylor's series predict that the log fO2 is",
     $    ' at the requested',/3x,'lesser print point value of ',
     $    1pe11.4,' at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The second search target is the currently defined log fO2-based
c     print point associated with the greater log fO2 value.
c
      ilsign = -1
      xtargv = o21prn
      tolsx = tolxsu
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  200 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1100)
 1100     format(/3x,'A scan for where the log fO2 reaches the greater',
     $    ' of two print point values',/3x,'has failed. Dropping to',
     $    ' the minimum step size.')
        endif
        delxi = dlxmin
        go to 210
      endif
c
c     Estimate the log fO2 from a Taylor's series expansion.
c
      fo2lg1 = fo2lg0
      dxp = 1.
      do n = 1,nord
        dxp = dxp*delxi
        fo2lg1 = fo2lg1 + ( do20(n)/fctrl(n) )*dxp
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (fo2lg0 .ge. (1. - tolxsu)*o21prn) then
c
c         The log fO2 at the base point is too close to the requested
c         greater print point value.
c
          delxi = dlxmin
          dxo1pr = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1110) fo2lg0,o21prn,xi0,delxi
 1110       format(/3x,'The base point log fO2 of ',1pe11.4,' is',
     $      ' already very close',/3x,'to the requested greater print',
     $      ' point value of',e11.4,/3x,'at Xi= ',e11.4,'. Have set',
     $      ' delxi equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 200
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((fo2lg1 - o21prn) .gt. tolsx) then
c
          xval0 = fo2lg0
          do n = 1,nord
            dxval0(n) = do20(n)
          enddo
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dxo1pr = delxi
          if (ier .le. 0) go to 200
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dxo1pr = delxi
          go to 210
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(fo2lg1 - o21prn) .le. tolsx) then
          write (noutpt,1120) o21prn,xi1,delxi
 1120     format(/3x,"Taylor's series predict that the log fO2 is",
     $    ' at the requested',/3x,'greater print point value of ',
     $    1pe11.4,' at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  210 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (dxsv .gt. delxi) qdump = .false.
c
  999 continue
      end

      subroutine prtsip(affpd,iopr,ir1,ir2,jpflag,kpsat,kpsst,
     $ noprmx,noutpt,nptmax,sidrph,tolspf,ugroup,uphase)
c
c     This subroutine prints a table of saturation indices and
c     affinities of phases whose indices lie in the range ir1 to ir2.
c     The group corresponding to this range is described by ugroup.
c     The level of printing is controlled by the print control flag
c     iopr(7):
c
c       -1 = Don't print
c        0 = Print for those phases not undersaturated by
c              more than 10 kcal
c        1 = Print for all phases
c
c     This subroutine is called by:
c
c       EQLIB/prtsat.f
c
c-----------------------------------------------------------------------
c
c
c     Principal input:
c
c       affpd  = array of affinities of phases to form (precipitate),
c                  computed from the reactions read from the data file
c       iopr   = array of print control options
c       ir1    = start of the range of pure liquid phases
c       ir2    = end of the range of pure liquid phases
c       jpflag = array of phase status flags
c       kpsat  = number of saturated phases
c       kpsst  = number of supersaturated phases
c       sidrph = array of saturation indices of the various phases,
c                  computed from the reactions read from the data file
c       tolspf = saturation print flag tolerance, used to flag those
c                  phases which are close to saturation
c       ugroup = string describing the group of phases for which
c                  a table is to be printed
c       uphase = array of phase names
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noprmx,nptmax
c
      integer noutpt
c
      integer iopr(noprmx),jpflag(nptmax)
      integer ir1,ir2,kpsat,kpsst
c
      character*24 uphase(nptmax),ugroup
c
      real*8 affpd(nptmax),sidrph(nptmax)
      real*8 tolspf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,kount,np
c
      integer ilnobl
c
      real*8 afx
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(ugroup)
      write (noutpt,1000) ugroup(1:j2)
 1000 format(//11x,'--- Saturation States of ',a,' ---',
     $ //7x,'Phase   ',19x,'Log Q/K',4x,'Affinity, kcal',/)
      kount = 0
c
      do np = ir1,ir2
        if (jpflag(np) .lt. 2) then
          if (iopr(7).gt.0 .or. affpd(np).ge.-10.) then
            kount = kount + 1
            afx = abs(affpd(np))
            if (afx .le. tolspf) then
              kpsat = kpsat + 1
              write (noutpt,1010) uphase(np),sidrph(np),affpd(np)
 1010         format(5x,a24,3x,f10.5,3x,f10.5,5x,'SATD')
            elseif (affpd(np) .gt. tolspf) then
              kpsst = kpsst + 1
              write (noutpt,1020) uphase(np),sidrph(np),affpd(np)
 1020         format(5x,a24,3x,f10.5,3x,f10.5,5x,'SSATD')
            else
              write (noutpt,1030) uphase(np),sidrph(np),affpd(np)
 1030         format(5x,a24,3x,f10.5,3x,f10.5)
            endif
          endif
        endif
      enddo
c
      if (kount .le. 0) write (noutpt,1040)
 1040 format(5x,'None')
c
      if (iopr(7) .eq. 0) write (noutpt,1050)
 1050 format(/8x,'Phases with affinities less than -10 kcal are not',
     $' listed.')
c
      write (noutpt,1060)
 1060 format(1x)
c
      end

      real*8 function texp(x)
c
c     This subroutine is the function 10**x. The argument is tested in
c     order to avoid overflow.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       x      = argument
c
c     Output:
c
c       texp   = 10**x (maximum returned value is 1.e+125)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      real*8 x
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c       None
c
c-----------------------------------------------------------------------
c
c     Test for overflow. The recommended truncation limit on the
c     argument x is 125. On most systems, the real*8 exponent
c     range is at least 308, which provides sufficient cushion.
c     In considering how much cushion is enough, remember that
c     exponentiated numbers may be subsequently be squared (in which
c     case 1.e+125 gives rise to 1.e+250) or otherwise raised to some
c     positive power. If your machine has a smaller but still acceptable
c     exponent range (no less than 100), you should adjust the the limit
c     used below accordingly. For example, if your machine's exponent
c     range is 100, try a truncation limit of about 1.e+40. Your
c     machine's exponent range is actually computed by EQLIBU/flpars.f.
c
      if (x .ge. 125.) then
c
c       Avoid overflow.
c
com     BEGIN_MACHINE_DEPENDENT_CODE
com
com       Note: Some compilers may not allow use of the construction
com       "1.e+125" in the following setting. They may infer from the
com       "e" part that this is a REAL*4 number, and conclude that the
com       exponent is out of range. The "d" construction is appropriate
com       for any 32-bit machine. It shouldn't cause a problem on a
com       64-bit machine, such as a CRAY. If it should, however, change
com       to the "e" construction.
com
          texp = 1.d+125
cxx       texp = 1.e+125
com
com     END_MACHINE_DEPENDENT_CODE
c
      else
        texp = 10.**x
      endif
c
      end

      subroutine pderiv(akmat0,demop0,fdpe0,nord,nordmx,npet,
     $ npetmx,nrd1mx)
c
c     This subroutine computes estimates of the derivatives of the
c     numbers of moles of the phases present in the equilibrium
c     system. These derivatives (demop0) are computed from the
c     corresponding finite differences (fdpe0). The relation is:
c     (demop0) = (akmat0)(fdpe0).
c
c     Compare with:
c
c       EQ6/aderiv.f
c       EQ6/bderiv.f
c       EQ6/rderiv.f
c       EQ6/sderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nordmx,npetmx,nrd1mx
c
      integer nord,npet
c
      real*8 akmat0(nrd1mx,nrd1mx),demop0(nordmx,npetmx),
     $ fdpe0(nordmx,npetmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,npe
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
      do npe = 1,npet
        do n = 1,nord
          dx = 0.
          do k = n,nord
            dx = dx + fdpe0(k,npe)*akmat0(n,k)
          enddo
          demop0(n,npe) = dx
        enddo
      enddo
c
      end

      subroutine srch33(jtripl,unam1,unam2,unam3,utripl,npx3mx,npx3t)
c
c     This subroutine searches for the species triplet corresponding
c     to unam1, unam2, unam3 in the utripl array, and returns the
c     index jtripl of that triplet in that array. The variable jtripl
c     is returned as 0 if no match is found. The species names in
c     the triplet array must be in the same order to generate a match.
c
c     This subroutine is called by:
c
c       EQPT/wrpz3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       npx3t  = the number of aqueous species triplets in the utripl
c                  array
c       unam1  = the name of the first aqueous species in a triplet
c       unam2  = the name of the second aqueous species in a triplet
c       unam3  = the name of the third aqueous species in a triplet
c       utripl = array of aqueous species triplets
c
c     Principal output:
c
c       jtripl = the index of the triplet unam1, unam2, unam3 in the
c                  utripl array, if that triplet is present; else 0
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer npx3mx
c
      integer jtripl,npx3t
c
      character(len=24) unam1,unam2,unam3
      character(len=24) utripl(3,npx3mx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j
c
c-----------------------------------------------------------------------
c
      do j = 1,npx3t
        if (unam1(1:24) .eq. utripl(1,j)(1:24)) then
          if (unam2(1:24) .eq. utripl(2,j)(1:24)) then
            if (unam3(1:24) .eq. utripl(3,j)(1:24)) then
c
c             Found in the triplet in the utripl array.
c
              jtripl = j
              go to 999
            endif
          endif
        endif
      enddo
c
c     Did not find the triplet in the utripl array.
c
      jtripl = 0
c
  999 continue
      end

      subroutine bdslx(narn1,narn2,natmax,noutpt,nslt,nsltmx,
     $ nslx,nsxi,nsxx,nsxmax,nttyo)
c
c     This subroutine builds the nsxi and nsxx arrays. These are
c     pointer arrays used in connection with the S-lambda
c     parts of Pitzer's equations.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narn1  = start of aqueous species range
c       narn2  = end of aqueous species range
c       natmax = the maximum number of aqeuous species
c       nslx   = array of aqueous species indices defining pairs
c                  of species for which S-lambda data are present
c       nsltmx = the maximum number of pairs of aqueous species
c                  for which Pitzer interaction parameters are
c                  defined; the second dimension of the nslx array
c       nsxmax = the second dimension of the nsxx pointer array
c
c
c     Principal output:
c
c       nsxi   = range pointer array into the nsxx array:
c                  nsxi(1,na) and nsxi(2,na) are the first and last
c                  values of the second subscript (nsx) of the nsxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nsxt   = the total number of entries in the nsxx array
c       nsxx   = pointer array:
c                  nsxx(1,nsx) = the species index of the second
c                  species in the nsl-th pair, and nsxx(2,nsx) = nsl
c
c     Note: the usage of the nsxi and nsxx arrays is illustrated by
c     the following pseudo-code to evaluate the sum:
c     SUM(j) S-lambda(ij)m(j)
c
c       sum = 0.
c       do nsx = nsxi(1,i),nsxi(2,i)
c         j = nsxx(1,nsx)
c         nsl = nsxx(2,nsx)
c         sum = sum + S-lambda(nsl)*m(j)
c       enddo
c
c     This sum is actually evaluated in EQLIBG/gsgsm.f.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nsltmx,nsxmax
c
      integer nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
c
      integer narn1,narn2,noutpt,nslt,nttyo
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,na,nsx,ns,nsl
c
c-----------------------------------------------------------------------
c
      nsx = 1
c
c     The following loop assumes that water is the narn1-th species.
c
      do ns = narn1 + 1,narn2
        na = ns - narn1 + 1
c
c       Set the beginning of the range for the current species.
c
        nsxi(1,na) = nsx
c
c       Search column 1 of the nslx array for the ns-th species.
c
        do nsl = 1,nslt
          if (nslx(1,nsl) .eq. ns) then
c
c           Found one. Get the other aqueous species index and the
c           nsl index of the pair.
c
            nsxx(1,nsx) = nslx(2,nsl)
            nsxx(2,nsx) = nsl
            nsx = nsx + 1
            if (nsx .gt. nsxmax) then
              n = 2*nsltmx
              write (noutpt,1010) nsxmax,n
              write (nttyo,1010) nsxmax,n
 1010         format(/' * Error - (EQLIBG/bdslx) Have overflow of the',
     $        /7x,'S-lambda pointer array nsxx. Increase the ',
     $        'dimensioning',
     $        /7x,'parameter nsxpar from ',i5,' to no more than ',i5,
     $        '.')
              stop
            endif
          endif
        enddo
c
c       Search column 2.
c
        do nsl = 1,nslt
          if (nslx(2,nsl) .eq. ns) then
c
c           Found one. Skip if the species is also in the first column.
c
            if (ns .ne. nslx(1,nsl)) then
              nsxx(1,nsx) = nslx(1,nsl)
              nsxx(2,nsx) = nsl
              nsx = nsx + 1
              if (nsx .gt. nsxmax) then
                n = 2*nsltmx
                write (noutpt,1010) nsxmax,n
                write (nttyo,1010) nsxmax,n
                stop
              endif
            endif
          endif
        enddo
c
c       Set the end of the range for the current species.
c
        nsxi(2,na) = nsx - 1
      enddo
c
      end

      subroutine bspchk(jsflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $ noutpt,nrdxsp,nstmax,nttyo,uspeca)
c
c     This subroutine looks at each active auxiliary basis species.
c     It prints a warning if any other species in the corresponding
c     dissociation reaction is not present.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jsflag = array of status flags for species
c       nbaspd = array of indices of 'data file' basis species
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer noutpt,nttyo
c
      integer jsflag(nstmax),nbaspd(nbtmax),ndrsd(ndrsmx),
     $ ndrsrd(2,nstmax)
      integer nbtd,nrdxsp
c
      character(len=48) uspeca(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,jlene,n,nb,nr1,nr2,ns,nse,nt1
c
      character(len=56) uspe56,uspn56
c
c-----------------------------------------------------------------------
c
      do nb = 1,nbtd
        ns = nbaspd(nb)
        if (jsflag(ns) .le. 0) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          nt1 = nr2 - nr1 + 1
          if (nt1 .ge. 2) then
            do n = nr1,nr2
              nse = ndrsd(n)
              if (jsflag(nse) .gt. 0) then
                if (nse .ne. nrdxsp) then
c
c                 Calling sequence substitutions:
c                   jlene for jlen
c                   uspeca(nse) for unam48
c                   uspe56 for uspn56
c
                  call fmspnx(jlene,uspeca(nse),uspe56)
c
c                 Calling sequence substitutions:
c                   uspeca(ns) for unam48
c
                  call fmspnx(jlen,uspeca(ns),uspn56)
c
                  write (noutpt,1000) uspn56(1:jlen),uspe56(1:jlene)
                  write (nttyo,1000) uspn56(1:jlen),uspe56(1:jlene)
 1000             format(/' The auxiliary basis species ',a,
     $            ' is active even though',/3x,'it is a dependent',
     $            ' species of ',a,', which is not',/3x,'present',
     $            ' in the current model. This detached auxililary',
     $            ' basis species',/3x,'will behave much like a',
     $            ' strict basis species.')
                endif
              endif
            enddo
          endif
        endif
      enddo
  110 continue
c
      end

      subroutine ckfrsr(cbsr,csts,jcode,jflag,nbaspd,nbtd,nbtmax,
     $ nbt1mx,noutpt,nrct,nrctmx,nrndex,nsrtmx,nstmax,nsts,nstsmx,
     $ nstsr,nttyo,ureac,uspec)
c
c     This subroutine checks the reactions for special reactants. As
c     needed, it rewrites these reactions to eliminate any basis
c     species for which jflag = 30. Such species are not in the active
c     basis set, and there are no corresonding mass balances.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cbsr   = array of coefficients for reactions for special
c                  reactants
c       nbtmax = the maximum number of basis species
c       nbt1mx = the maximum number of basis species plus 1
c       nsrtmx = the maximum number of special reactants
c       ureac  = array of names of reactants
c       uspec  = array of names of species
c
c     Principal output:
c
c       cbsr   = array of coefficients for reactions for special
c                  reactants (modified if necessary)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nbt1mx,nrctmx,nsrtmx,nstmax,nstsmx
c
      integer noutpt,nttyo
c
      integer jcode(nrctmx),jflag(nstmax),nbaspd(nbtmax),nrndex(nrctmx),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer nbtd,nrct
c
      character*48 uspec(nstmax)
      character*24 ureac(nrctmx)
c
      real*8 cbsr(nbt1mx,nsrtmx),csts(nstsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nf
c
      integer jlen,j2,n,nb,nbb,nrc,nr1,nr2,ns,nsr
c
      integer ilnobl
c
      logical qcaught
c
      character*56 uspn56
c
      real*8 cx
c
c-----------------------------------------------------------------------
c
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 2) then
          nsr = nrndex(nrc)
          qcaught = .false.
          do nb = 1,nbtd
            ns = nbaspd(nb)
            cx = cbsr(nb,nsr)
            if (cx.ne.0. .and. jflag(ns).eq.30) then
              if (.not.qcaught) then
c
c               Write the original reaction.
c
                j2 = ilnobl(ureac(nrc))
                write (noutpt,1000) ureac(nrc)(1:j2)
                write (nttyo,1000) ureac(nrc)(1:j2)
 1000           format(/1x,'The reaction for special reactant ',a,
     $          ' is written in terms of',/1x,'one or more species',
     $          ' which are not in the active basis set. The',/1x,
     $          'currently written reaction is:')
c
                nf = noutpt
                call prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $          nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $          ureac,uspec)
                write (noutpt,1010)
 1010           format(/1x,'The following species are not in the',
     $          ' active basis set and will be eliminated',
     $          /1x,'from the reaction:',/)
c
                nf = nttyo
                call prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $          nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $          ureac,uspec)
                write (nttyo,1010)
c
                qcaught = .true.
              endif
c
c             Calling sequence substitutions:
c               uspec(ns) for unam48
c
              call fmspnx(jlen,uspec(ns),uspn56)
c
              write (noutpt,1020) uspn56(1:jlen)
              write (nttyo,1020) uspn56(1:jlen)
 1020         format(3x,a)
c
c             The reaction contains a non-zero reaction coefficient for
c             a species which is not in the active basis set. Rewrite
c             the reaction so that this species does not appear.
c
              nr1 = nstsr(1,ns)
              nr2 = nstsr(2,ns)
              do n = nr1,nr2
                nbb = nsts(n)
                cbsr(nbb,nsr) = cbsr(nbb,nsr) + csts(n)*cx
              enddo
              cbsr(nb,nsr) = 0.
            endif
          enddo
c
          if (qcaught) then
c
c           Write the modified reaction.
c
            write (noutpt,1070)
            write (nttyo,1070)
 1070       format(//1x,'The modified reaction is:')
c
            nf = noutpt
            call prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $      nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $      ureac,uspec)
            write (noutpt,1030)
 1030       format(/1x)
c
            nf = nttyo
            call prrsr(cbsr,jcode,nbaspd,nbtd,nbtmax,nbt1mx,
     $      nf,noutpt,nrc,nrctmx,nrndex,nsrtmx,nstmax,nttyo,
     $      ureac,uspec)
            write (nttyo,1030)
          endif
c
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gcscal(acflgc,delacf,narn1,narn2,nref,nstmax,zchar)
c
c     This subroutine rescales the activity coefficients of aqeuous
c     ionic species to make them consistent with a given pH scale,
c     which has been used to define the correction parameter "delacf".
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       acflgc = calculated activity coefficient array  (unscaled)
c       delacf = log gamma of the reference ion (new scale) -
c                  log gamma of the reference ion (old scale)
c       nref   = the species index of the reference ion
c       nstmax = the maximum number of species
c       zchar  = electrical charge array
c
c     Output:
c
c       acflgc = calculated activity coefficient array (scaled)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer narn1,narn2,nref
c
      real*8 acflgc(nstmax),zchar(nstmax)
      real*8 delacf
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,ns,nval
c
      real*8 zref
c
c-----------------------------------------------------------------------
c
      zref = zchar(nref)
c
c     Note that the loop can run from narn1 to narn2 without
c     causing a problem in the case of water because water has no
c     electrical charge. Note also that the loop is unrolled.
c
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do ns = narn1,ileft,8
        acflgc(ns) = acflgc(ns) + (zchar(ns)/zref)*delacf
        acflgc(ns + 1) = acflgc(ns + 1) + (zchar(ns + 1)/zref)*delacf
        acflgc(ns + 2) = acflgc(ns + 2) + (zchar(ns + 2)/zref)*delacf
        acflgc(ns + 3) = acflgc(ns + 3) + (zchar(ns + 3)/zref)*delacf
        acflgc(ns + 4) = acflgc(ns + 4) + (zchar(ns + 4)/zref)*delacf
        acflgc(ns + 5) = acflgc(ns + 5) + (zchar(ns + 5)/zref)*delacf
        acflgc(ns + 6) = acflgc(ns + 6) + (zchar(ns + 6)/zref)*delacf
        acflgc(ns + 7) = acflgc(ns + 7) + (zchar(ns + 7)/zref)*delacf
      enddo
c
      do ns = ileft + 1,narn2
        acflgc(ns) = acflgc(ns) + (zchar(ns)/zref)*delacf
      enddo
c
      end

      subroutine inbdot(azeroa,insgfa,nad1,narn1a,narn2a,nata,
     $ nata_asv,nerr,noutpt,nsta_asv,nttyo,uspeca)
c
c     This subroutine reads from the data file the block of individual
c     species parameters for the B-dot model of aqueous species
c     activity coefficients. For each solute species, these parameters
c     are its hard core diameter (azeroa) and its neutral species flag
c     (insgfa). The latter is relevant only for electrically neutral
c     species. If it is has a value of 0, the log activity coefficient
c     is set to zero; if it has a value of -1, the log activity
c     coefficient is represented by the Drummond (1981) polynomial.
c     Water (the solvent) is not subject to control by the insgfa flag.
c
c     This subroutine is called by:
c
c       EQLIB/indata.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c       uspeca = array of names of species read from the data file
c
c     Principal output:
c
c       azeroa = array of hard core diameters read from the data file
c       insgfa = array of flags for treating the activity coefficients
c                  of species that happen to be electrically neutral
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nata_asv,nsta_asv
c
      integer insgfa(nata_asv)
      integer nad1,narn1a,narn2a,nata,nerr,noutpt,nttyo
c
      character*48 uspeca(nsta_asv)
c
      real*8 azeroa(nata_asv)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer igx,j2,na,naz,ncount,ns
c
      integer ilnobl
c
      real*8 azdef,azx
c
      character*24 unam,unam1,unam2
      character*8 uendit
c
c-----------------------------------------------------------------------
c
      data uendit /'endit.  '/
c
c     The following variable is the default value for the hard core
c     diameter of an aqueous solute species. Note that hard core
c     diameters are given in units of 10**-8 cm.
c
      data azdef  /4.0/
c
c-----------------------------------------------------------------------
c
c     Initialize the azeroa and insgfa arrays to zero.
c
      do na = 1,nata_asv
        azeroa(na) = 0.
        insgfa(na) = 0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the block contents.
c
      naz = 0
c
c     Read the species name and azeroa and insgfa data.
c
  110 read (nad1) unam,azx,igx
c
c     Test for the end of the data block.
c
      if (unam(1:8) .eq. uendit(1:8)) go to 120
c
c     Find the species index, ns.
c
c     Calling sequence substitutions:
c       narn1a for nrn1a
c       narn2a for nrn2a
c
      call srchn(narn1a,narn2a,ns,nsta_asv,unam,uspeca)
c
c     If not found among the loaded species, skip.
c
      if (ns .le. 0) then
        j2 = ilnobl(unam)
        write (noutpt,1020) unam(1:j2)
        write (nttyo,1020) unam(1:j2)
 1020   format(/' * Warning - (EQLIB/inbdot) Have B-dot model',
     $  ' parameters listed',/7x,'for an aqueous species named ',a,
     $  ', but there is',/7x,'no data block for such a species.')
        go to 110
      endif
c
c     Compute the aqueous species index na.
c
      na = ns - narn1a + 1
c
c     Test for duplicate input.
c
      if (azeroa(na) .gt. 0.) then
        write (noutpt,1030) unam(1:j2),azx,igx,azeroa(na),insgfa(na)
        write (nttyo,1030) unam(1:j2),azx,igx,azeroa(na),insgfa(na)
 1030   format(/' * Warning - (EQLIB/inbdot) Have a duplicate entry',
     $  ' on the data file for',/7x,'the B-dot model parameters of',
     $  ' the species ',a,'.',/7x,'The duplicate entry values are:',
     $  //9x,'azero= ',f7.2,', insgf= ',i3,
     $  //7x,'The first entry values are:',
     $  //9x,'azero= ',f7.2,', insgf= ',i3,
     $  //7x,'The first entry values will be used.')
        go to 110
      endif
c
      naz = naz + 1
      if (naz .gt. nata) then
c
        write (noutpt,1040) nata
        write (nttyo,1040) nata
 1040   format(/' * Error - (EQLIB/inbdot) There are more entries',
     $  /7x,'for species with  B-dot model parameters than there are',
     $  /7x,'aqueous species, which number ',i4,'.')
        nerr = nerr + 1
        go to 999
      endif
c
      azeroa(na) = azx
      insgfa(na) = igx
      go to 110
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for solute species with no entries.
c
  120 do na = 1,nata
        if (azeroa(na) .le. 0.) go to 140
      enddo
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Assign the default value if needed.
c
  140 write (noutpt,1050) azdef
 1050 format(/' * Note - (EQLIB/inbdot) The following aqueous species',
     $ ' have been assigned',/7x,'a default hard core diameter of',
     $ ' ',f6.3,' x 10**-8 cm:',/)
      ncount = 0
      do ns = narn1a,narn2a
        na = ns - narn1a + 1
        if (azeroa(na) .le. 0.) then
          azeroa(na) = azdef
          if (ns .ne. narn1a) then
            if (ncount .le. 0) then
              unam1 = uspeca(ns)(1:24)
              ncount = 1
            else
              unam2 = uspeca(ns)(1:24)
              j2 = ilnobl(unam2)
              write (noutpt,1060) unam1,unam2(1:j2)
 1060         format(9x,a24,3x,a)
              ncount = 0
            endif
          endif
        endif
      enddo
c
      if (ncount .eq. 1) then
        j2 = ilnobl(unam1)
        write (noutpt,1070) unam1(1:j2)
 1070   format(9x,a)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine g1dat(ier,noutpt,nttyo,udastr,var)
c
c     This subroutine reads a number (var) from a string (udastr)
c
c     This subroutine is called by:
c
c       EQPT/gnenb.f
c       EQPT/rdpca.f
c       EQPT/rdpth.f
c       EQPT/rdpni.f
c       EQPT/rdpn2.f
c       EQPT/rdpnn.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       udastr = a string containing one numerical data field
c
c     Principal output:
c
c       ier    = error flag
c       var    = the number contained in that field
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ier
c
      character(len=80) udastr
c
      real(8) var
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jj,jlen
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
      var = 0.
      ier = 0
c
      call lejust(udastr)
      jj = index(udastr,' ')
      if (jj .eq. 0) jj = 81
      if (jj .lt. 80) udastr(jj:80) = ' '
      jlen = ilnobl(udastr)
c
      if (jlen .gt. 25) then
        write (noutpt,1000) udastr(1:jlen)
        write (nttyo,1000) udastr(1:jlen)
 1000   format(/' * Error - (EQPT/g1dat) Have found a data',
     $  ' field in the string:',/7x,'"',a,'"',/7x,'that appears',
     $  ' to exceed the allowed 25 characters.')
        ier = 1
      else
        read (udastr,1010,err=995) var
 1010   format(e25.18)
      endif
      go to 999
c
  995 ier = 1
c
  999 continue
      end

      subroutine initcv(uarray,nmax,uvalue)
c
c     This subroutine initializes the character array uarray to the
c     string contained in uvalue over the first nmax positions.
c     Normally, nmax would be the dimension of the 1D uarray. However,
c     nmax could be less than the true dimension. Also, uarray could
c     actually have more than one dimension. For example, if the array
c     is really ua, which has dimensions of i1 and i2, this subroutine
c     could be used by calling it in the following manner:
c     call initcv((ua,(i1*i2),uv). Use this subroutine with caution if
c     nmax is not the product of the true (declared) dimensions.
c
c     To initialize a character array to blanks, use EQLIBU/initcb.f
c     instead.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       uarray = the array
c       nmax   = dimension or pseudo-dimension of uarray
c       uvalue = the assigned value
c
c     Output:
c
c       uarray = uarray, with the first nmax positions set to the
c                  string contained in uv
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      character*(*) uarray(nmax),uvalue
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
      character*80 uv
c
c-----------------------------------------------------------------------
c
c     Note the assignment of the value to a local variable.
c     Note that the loop is unrolled.
c
      uv = uvalue
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        uarray(i) = uv
        uarray(i + 1) = uv
        uarray(i + 2) = uv
        uarray(i + 3) = uv
        uarray(i + 4) = uv
        uarray(i + 5) = uv
        uarray(i + 6) = uv
        uarray(i + 7) = uv
      enddo
c
      do i = ileft + 1,nmax
        uarray(i) = uv
      enddo
c
      end

      subroutine artrip(iz1,iz2,iz3,na,nc,nn,n1,n2,n3,
     $ u1,u2,u3,z1,z2,z3)
c
c     This suboutine arranges the members of a species triplet
c     according to the following rules:
c
c       If exactly one neutral is present:
c         neutral, cation, anion
c
c       If exactly two neutrals are present:
c         neutral 1, neutral 1, neutral2
c
c       If two cations are present:
c         cation 1, cation 2, anion
c
c       If two anions are present:
c         anion 1, anion 2, cation
c
c     This suboutine is called by:
c
c       EQPT/rdpz3.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       iz1    = (integer) charge of the first species in a triplet
c       iz2    = (integer) charge of the second species in a triplet
c       iz3    = (integer) charge of the third species in a triplet
c       na     = number of anions in a species triplet
c       nc     = number of cations in a species triplet
c       nn     = number of neutral species in a species triplet
c       u1     = first name in a species triplet
c       u2     = second name in a species triplet
c       u3     = third name in a species triplet
c       z1     = charge of the first species in a triplet
c       z2     = charge of the second species in a triplet
c       z3     = charge of the third species in a triplet
c
c     Principal output:
c
c       none     (u1, u2, u3 are rearranged)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iz1,iz2,iz3,na,nc,nn,n1,n2,n3
c
      character(len=24) u1,u2,u3
c
      real(8) z1,z2,z3
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nu,nx,izx
c
      character(len=24) ux24
c
      real(8) zx
c
c-----------------------------------------------------------------------
c
      if (nn .eq. 3) then
        if (n1.ne.n2 .or. n1.ne.n3) then
c
c         Have the combination nnn'.
c
c         Make sure that the unique neutral is in third place.
c
c         Find the unique neutral.
c
          if (n2 .eq. n3) nu = 1
          if (n1 .eq. n3) nu = 2
          if (n1 .eq. n2) nu = 3
c
          if (nu .eq. 1) then
c
c           The unique neutral is the first species. Switch it
c           with the third one.
c
            ux24 = u1
            u1 = u3
            u3 = ux24
c
            nx = n1
            n1 = n3
            n3 = nx
c
            zx = z1
            z1 = z3
            z3 = zx
c
            izx = iz1
            iz1 = iz3
            iz3 = izx
          elseif (nu .eq. 2) then
c
c           The unique neutral is the second species. Switch it
c           with the third one.
c
            ux24 = u2
            u2 = u3
            u3 = ux24
c
            nx = n2
            n2 = n3
            n3 = nx
c
            zx = z2
            z2 = z3
            z3 = zx
c
            izx = iz2
            iz2 = iz3
            iz3 = izx
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nn.eq.1 .and. nc.eq.1 .and. na.eq.1) then
c
c       Have the combination nca.
c
c       Make sure that the neutral is in first place.
c
        if (iz2 .eq. 0) then
c
          ux24 = u1
          u1 = u2
          u2 = ux24
c
          nx = n1
          n1 = n2
          n2 = nx
c
          zx = z1
          z1 = z2
          z2 = zx
c
          izx = iz1
          iz1 = iz2
          iz2 = izx
        elseif (iz3 .eq. 0) then
c
          ux24 = u1
          u1 = u3
          u3 = ux24
c
          nx = n1
          n1 = n3
          n3 = nx
c
          zx = z1
          z1 = z3
          z3 = zx
c
          izx = iz1
          iz1 = iz3
          iz3 = izx
        endif
c
c       Make sure that the cation is in second place. It
c       must presently be in second or third place.
c
        if (iz3 .gt. 0) then
c
          ux24 = u2
          u2 = u3
          u3 = ux24
c
          nx = n2
          n2 = n3
          n3 = nx
c
          zx = z2
          z2 = z3
          z3 = zx
c
          izx = iz2
          iz2 = iz3
          iz3 = izx
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nc.eq.2 .and. na.eq.1) then
c
c       Have the combination cc'a.
c
c       Make sure that the anion is in third place.
c
        if (iz1 .lt. 0) then
c
          ux24 = u1
          u1 = u3
          u3 = ux24
c
          nx = n1
          n1 = n3
          n3 = nx
c
          zx = z1
          z1 = z3
          z3 = zx
c
          izx = iz1
          iz1 = iz3
          iz3 = izx
        elseif (iz2 .lt. 0) then
c
          ux24 = u2
          u2 = u3
          u3 = ux24
c
          nx = n2
          n2 = n3
          n3 = nx
c
          zx = z2
          z2 = z3
          z3 = zx
c
          izx = iz2
          iz2 = iz3
          iz3 = izx
        endif
c
c       Put the two cations in alphabetical order.
c
        if (u1(1:24) .gt. u2(1:24)) then
c
          ux24 = u1
          u1 = u2
          u2 = ux24
c
          nx = n1
          n1 = n2
          n2 = nx
c
          zx = z1
          z1 = z2
          z2 = zx
c
          izx = iz1
          iz1 = iz2
          iz2 = izx
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (na.eq.2 .and. nc.eq.1) then
c
c       Have the combination aa'c.
c
C       Make sure that the cation is in third place.
c
        if (iz1 .gt. 0) then
c
          ux24 = u1
          u1 = u3
          u3 = ux24
c
          nx = n1
          n1 = n3
          n3 = nx
c
          zx = z1
          z1 = z3
          z3 = zx
c
          izx = iz1
          iz1 = iz3
          iz3 = izx
        elseif (iz2 .gt. 0) then
c
          ux24 = u2
          u2 = u3
          u3 = ux24
c
          nx = n2
          n2 = n3
          n3 = nx
c
          zx = z2
          z2 = z3
          z3 = zx
c
          izx = iz2
          iz2 = iz3
          iz3 = izx
        endif
c
c       Put the two anions in alphabetical order.
c
        if (u1(1:24) .gt. u2(1:24)) then
c
          ux24 = u1
          u1 = u2
          u2 = ux24
c
          nx = n1
          n1 = n2
          n2 = nx
c
          zx = z1
          z1 = z2
          z2 = zx
c
          izx = iz1
          iz1 = iz2
          iz2 = izx
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine cdakey(iopg,nopgmx,noutpt,nttyo,udakey,udatfi)
c
c     This subroutine checks the flag string "udakey" read from the data
c     file and checks it against a key-list to test whether or not
c     the data file used is consistent with the specified model for
c     aqueous species activity coefficients (determined by iopg(1)).
c     The string "udatfi" identifies the data file. The legal
c     combinations are:
c
c           Option                 iopg(1)      Legal key
c
c        Davies equation             -1          SEDH
c        B-dot equation               0          SEDH
c        Pitzer's equations           1          Pitzer
c        HC + DHC equations           2          SEDH
c
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c      Principal input:
c
c
c      Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nopgmx
c
      integer noutpt,nttyo
c
      integer iopg(nopgmx)
c
      character*8 udakey,udatfi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,j4,j5
c
      integer ilnobl
c
      character*8 uiakey,usedh,upitz,ux8
c
c-----------------------------------------------------------------------
c
      data usedh  /'SEDH    '/,upitz/'Pitzer  '/
c
c-----------------------------------------------------------------
c
c     Set the correct key.
c
      if (iopg(1) .eq. -1) then
        uiakey = usedh
      elseif (iopg(1) .eq. 0) then
        uiakey = usedh
      elseif (iopg(1) .eq. 1) then
        uiakey = upitz
      elseif (iopg(1) .eq. 2) then
        uiakey = usedh
      else
        write (ux8,'(i5)') iopg(1)
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1000) ux8(1:j2)
        write (nttyo,1000) ux8(1:j2)
 1000   format(/' * Error - (EQLIB/cdakey) The iopg(1) value of ',a,
     $  ' specified on',/7x,"the input file doesn't correspond to an",
     $  ' available model for the',/7x,'activity coefficients of',
     $  ' the aqueous species.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (udakey(1:8) .ne. uiakey(1:8)) then
c
c       Error, bad combination.
c
        write (ux8,'(i5)') iopg(1)
        call lejust(ux8)
        j2 = ilnobl(ux8)
        j3 = ilnobl(udatfi)
        j4 = ilnobl(uiakey)
        j5 = ilnobl(udakey)
        write (noutpt,1010) ux8(1:j2),udatfi(1:j3),uiakey(1:j4),
     $  udakey(1:j5)
        write (nttyo,1010) ux8(1:j2),udatfi(1:j3),uiakey(1:j4),
     $  udakey(1:j5)
 1010   format(/' * Error - (EQLIB/cdakey) The iopg(1) value of ',a,
     $  ' specified on',/7x,"the input file doesn't correspond to the",
     $  ' type of model for the',/7x,'activity coefficients of the',
     $  ' aqueous species required to use the',/7x,a,' data file.',
     $  ' The iopg1(1) value calls for using a ',a,' type model,',
     $  /7x,'while the data file is consistent with a ',a,' type',
     $  ' model. Change',/7x,'the iopg(1) value on the input file',
     $  ' or specify a compatible data file.')
        stop
      endif
c
      end

      subroutine chump(eps,irang,noutpt,nttyo)
c
c     This subroutine tests the floating point precision and exponent
c     range for adequacy for EQ3/6 calculations. This is essentially
c     a trap to insure that most floating point variables are real*8
c     and, if the computer is a VAX, that the code has been compiled
c     with the 'G_FLOATING' option (which increases the exponent range).
c
c     The machine epsilon and exponent range are respectively tested
c     against epstst and irgtst. The former should be no greater than
c     1.e-14. The latter should be at least 100, and the recommended
c     value is 300.
c
c     This subroutine is called by:
c
c        EQLIBU/flpars.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = the unit number of the output file
c       nttyo  = the unit number of the screen file
c
c     Output:
c
c       eps    = the real*8 machine epsilon
c       irang  = the real*8 exponent range
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer irang,noutpt,nttyo
c
      real*8 eps
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer irgtst
c
      logical qwarn
c
      real*8 epstst
c
c-----------------------------------------------------------------------
c
c     WARNING: Under no circumstances should the value of irgtst be
c     changed to a value less than 100. If decreased to from the
c     recommended value of 300, make a corresponding adjustment of the
c     overflow truncation limit in EQLIBU/texp.f or you will lose the
c     floating-point overflow protection built into this software.
c
      data irgtst /300/
c
      data epstst /1.e-14/
c
c-----------------------------------------------------------------------
c
      qwarn = .false.
      if (eps .gt. epstst) then
        write (noutpt,1007) eps,epstst
        write (nttyo,1007) eps,epstst
 1007   format(/' * Warning - (EQLIBU/chump) Have insufficient',
     $  ' floating point',/7x,'epsilon= ',1pe12.5,'. This parameter',
     $  ' should be no larger',/7x,'than ',1pe12.5,'. You need a',
     $  ' computer with better floating',/7x,'point characteristics',
     $  ' to run this software.')
        qwarn=.true.
      endif
c
      if (irang .lt. irgtst) then
        write (noutpt,1008) irang,irgtst
        write (nttyo,1008) irang,irgtst
 1008   format(/' * Warning - (EQLIBU/chump) Have insufficient',
     $  ' floating point',/7x,'exponent range= +/- ',i4,'. This should',
     $  ' be at least +/- ',i4,/7x,'to run this software. You need',
     $  ' a computer with better',/7x,'floating point characteristics.',
     $  ' Alternatively, you need to recompile',/7x,'with a special',
     $  ' compiler option.')
        if (irang.ge.37 .and. irang.le.39) then
          write (noutpt,1010)
          write (nttyo,1010)
 1010     format(/' * Note - (EQLIBU/chump) This computer appears to',
     $    ' be a VAX.',/7x,'If you run under VMS, try recompiling with',
     $    /7x,'the G_FLOATING option.',/7x,'This will increase the',
     $    ' exponent range to +/- 308. Some older',/7x,'VAXes do not',
     $    ' have the necessary hardware to implement this option.',
     $    /7x,'Also, there appears to be no equivalent to the',
     $    ' G_FLOATING option',/7x,'on VAXes running the ULTRIX',
     $    ' operating system. If you are',/7x,'running a VAX with',
     $    ' ULTRIX, activate the call to the system subroutine TRPFPE',
     $    /7x,'in this subroutine (EQLIBU/chump.f). This call is',
     $    ' normally commented.',/7x,'out. You might wish to consider',
     $    ' getting a computer which has better',/7x,'floating point',
     $    ' characteristics.')
        endif
        qwarn=.true.
      endif
c
      if (qwarn) then
        write (noutpt,1020)
        write (nttyo,1020)
 1020   format(/' * Warning - (EQLIBU/chump) Will continue execution.',
     $  ' You may encounter',/7x,'floating point overflows, especially',
     $  ' if you are running EQ3NR',/7x,'or EQ6. You may be able to',
     $  ' make some EQ3NR and EQ6 problems run',/7x,'by specifying',
     $  ' judicious basis switches on the input file.',/)
      endif
c
c-----------------------------------------------------------------------
c
com   BEGIN_VAX_DEPENDENT_CODING
com
com     The following VAX system call traps and repairs floating point
com     overflows when running under the ULTRIX operating system.
com     This call may have be to be activated (by de-commenting it) if
com     you are running on a VAX with ULTRIX. On some older VAXES, you
com     may have to substitute "TRAPOV" for "TRPFPE".
com
c       call trpfpe(0,1.d+30)
com
com   END_VAX_DEPENDENT_CODING
c
c-----------------------------------------------------------------------
c
      end

      subroutine prtrct(afrc1,aft1,imchmx,imech,iopt,modr,morr,
     $ noptmx,noutpt,nrct,nrctmx,nrk,rk,rreacn,rreac1,rrelr1,sfcar,
     $ ureac,wodr,wodrt,worr,worrt,xi1,xistsv)
c
c     This subroutine prints tables of data for irreversible reactions
c     and corresponding reaction rates.
c
c     This subroutine is called by:
c
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,noptmx,nrctmx
c
      integer noutpt
c
      integer imech(2,nrctmx),iopt(noptmx),nrk(2,nrctmx)
c
      integer nrct
c
      character*24 ureac(nrctmx)
c
      real*8 afrc1(nrctmx),modr(nrctmx),morr(nrctmx),
     $ rk(imchmx,2,nrctmx),rreacn(nrctmx),rreac1(nrctmx),
     $ rrelr1(nrctmx),sfcar(nrctmx),wodr(nrctmx),worr(nrctmx)
c
      real*8 aft1,wodrt,worrt,xi1,xistsv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j2,nrc
c
      integer ilnobl
c
      character*16 ux16
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(//21x,'--- Reactant Summary ---',//)
c
      if (xi1 .le. xistsv) write (noutpt,1010)
 1010 format(5x,'Definitions and conventions',
     $ //10x,'Delta x = x now - x at start',
     $ /10x,'Affinity is + for forward direction (destruction),',
     $ /10x,'            - for reverse direction (formation)',
     $ /10x,'Rates are + for forward direction (destruction),',
     $ /10x,'          - for reverse direction (formation)',/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1020)
 1020 format(/5x,'Reactant',18x,'Moles',5x,'Delta moles',
     $ 4x,'Mass, g',4x,'Delta mass, g',/)
c
      do nrc = 1,nrct
        write (noutpt,1030) ureac(nrc),morr(nrc),modr(nrc),
     $  worr(nrc),wodr(nrc)
 1030   format(2x,a24,4(2x,1pe11.4))
      enddo
      if (nrct .le. 0) write (noutpt,1040)
 1040 format(2x,'None')
c
      if (nrct .gt. 0) then
        write (noutpt,1050) worrt,wodrt
 1050   format(//20x,'Mass remaining= ',1pe11.4,' grams',
     $  /20x,'Mass destroyed= ',e11.4,' grams')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .gt. 0) then
        if (iopt(2) .le. 0) then
          write (noutpt,1070)
 1070     format(//5x,'Reactant',19x,'Affinity',5x,'Rel. Rate',
     $    /32x,'kcal/mol',6x,'mol/mol',/)
c
          do nrc = 1,nrct
            write (noutpt,1090) ureac(nrc),afrc1(nrc),rrelr1(nrc)
 1090       format(2x,a24,2x,f13.4,2x,1pe11.4)
          enddo
        else
          write (noutpt,1100)
 1100     format(//5x,'Reactant',17x,'Rel. Rate',6x,'Rate',9x,'Rate',
     $    /31x,'mol/mol',6x,'mol/s',6x,'mol/s/cm2',/)
c
          do nrc = 1,nrct
            write (noutpt,1110) ureac(nrc),rrelr1(nrc),rreac1(nrc),
     $      rreacn(nrc)
 1110       format(2x,a24,4(2x,1pe11.4))
          enddo
c
          write (noutpt,1120)
 1120     format(//5x,'Reactant',19x,'Affinity',3x,'Surface Area',
     $    /32x,'kcal/mol',7x,'cm2',/)
c
          do nrc = 1,nrct
            write (noutpt,1090) ureac(nrc),afrc1(nrc),sfcar(nrc)
          enddo
c
          write (noutpt,1130)
 1130     format(//5x,'Reactant',16x,'Rate Constants, mol/s/cm2',/)
c
          do nrc = 1,nrct
            write (noutpt,1090) ureac(nrc)
            if (nrk(1,nrc) .ge. 1) then
              write (noutpt,1140) (rk(i,1,nrc), i = 1,imech(1,nrc))
 1140         format(20x,'Forward ',4(2x,1pe11.4),/28x,4(2x,e11.4))
            endif
            if (nrk(2,nrc) .ge. 1) then
              write (noutpt,1150) (rk(i,2,nrc), i = 1,imech(2,nrc))
 1150         format(20x,'Backward',4(2x,1pe11.4),/28x,4(2x,e11.4))
            endif
          enddo
        endif
c
        write (ux16,'(f13.4)') aft1
        call lejust(ux16)
        j2 = ilnobl(ux16)
        write (noutpt,1160) ux16(1:j2)
 1160   format(//3x,'Affinity of the overall irreversible reaction= ',
     $  a,' kcal.',/3x,'Contributions from irreversible reactions',
     $  ' with no thermodynamic data',/3x,'are not included.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine intexi(al10,axhfs,axlks,axvfs,cegexs,cess,cdrs,
     $ cgexj,cpgexs,egexjf,iern1,iern2,ietmax,jern1,jern2,jetmax,
     $ jflag,jgext,jpflag,jsflag,jsitex,kern1,kern2,ketmax,kgexsa,
     $ mwtges,mwtsp,narn1,narn2,narxmx,narxt,nbasp,nbt,nbtmax,ncmpr,
     $ ndrs,ndrsmx,ndrsr,ness,nessmx,nessr,netmax,net,nern1,nern2,
     $ ngexro,ngexrt,ngexsa,ngexso,ngext,noutpt,nphasx,npt,nptmax,
     $ nst,nstmax,ntprt,ntprmx,nttyo,nvetmx,rconst,tgexp,ugexj,
     $ ugexmo,ugexmv,ugexp,ugexr,ugexs,ugexsr,uhfgex,uphase,uspec,
     $ uvfgex,uxkgex,xhfgex,xlkgex,xvfgex,zchar,zgexj)
c
c     This subroutine inteprets data read from the input file for the
c     generic ion exchange model. It composes the necessary generic
c     exchange phases and species and sets up the associated reactions
c     and thermodynamic properties.
c
c     "Ion exchange" may be strictly or loosely interpreted here,
c     depending on the models chosen. In the case of the Gapon and
c     Vanselow models, the interpretation is strict. For example, a
c     site must be negatively or positively charged, only ions of
c     the opposite sign may occupy it, and the formal exchange
c     capacity is exactly 100% utilized, save for a negligible
c     trace of unfilled positions. The end-member exchanger species
c     are electrically neutral, save for the trace unfilled site
c     species. In contrast, the "Site-mixing" model allows more
c     flexibility, including charged exchanger end-members, and
c     overloading or underloading of the formal exchange capacities.
c
c     Each exchanger species is specific to a given site (type of
c     site), and these species are organized in the species list such
c     that those belonging to a given site are listed contiguously.
c     An exchanger with only one site is treated in the same manner
c     as a phase composed of constituent species. In the case of an
c     exchanger with more than one site, each site is treated as a
c     kind of subphase, composed of its own constituent species.
c
c     To illustrate, an exchange phase with substrate Z and two exchange
c     sites is represented by:
c
c       (Na+,K+)3(Fe+++,Al+++)2(Z)
c
c     Here a pair of parentheses represents a site. Z represents the
c     substrate. The site it occupies is not an exchange site. There is
c     always one mole of substrate occupying this site. The first
c     exchange site, here called site A, contains a mixture of Na+
c     and K+ ions. There are 3 moles of this site per mole of substrate.
c     This site has an intrinsic charge (charge when the site is not
c     occupied) of -1. Thus, 3 moles of monovalent cations per mole of
c     substrate are required to attain electrical neutrality on this
c     site. The second exchange site, here called site B, contains a
c     mixture of Fe+++ and Al+++ ions. There are 2 moles of this site
c     per mole of substrate, and it has an intrinsic charge of -3.
c
c     The species for this example may be written as:
c
c       site A:
c
c         (Na+)3()2()
c         (K+)3()2()
c
c       site B:
c
c         ()3(Fe+++)2()
c         ()3(Al+++)2()
c
c       substrate site:
c
c         ()3()2(Z)
c
c     Here an empty pair of parentheses denotes an empty site.
c     However, an empty site is a definite part of the species.
c     An empty site makes no contribution to the molecular weight of
c     of such a species. Thus, the molecular weight of (Na+)3()2()
c     is 3 times the atomic weight of Na. The mass in grams of the
c     complete exchanger phase is the sum of the masses of all of
c     the constitutent species. The number of moles of the exchanger
c     phase is equal to the number of moles of the substrate.
c
c     One could conceivably define an exchanger with a non-unit
c     stoichiometry for the substrate component; e.g., something
c     like:
c
c       (Na+,K+)3(Fe+++,Al+++)2(Z')2
c
c     where Z' is a redefined substrate for the previous example.
c     However, there do not seem to be any advantages to introducing
c     or even allowing such a complexity. One can always define a
c     stoichiometric with unit substrate, in this example by taking
c     Z = 2*Z'.
c
c     The activity of such a species in the ideal case (implicitly in
c     the site mixing sense) is the mole fraction on the site for which
c     the species is defined, raised to the power equal to the
c     stoichiometric factor for the site. In the case of (Na+)3()2(),
c     the relation is:
c
c       a{(Na+)3()2()} = x{(Na+)3()2()}**3.
c
c     The origin of this relationship is as follows. Write a pseudo-
c     reaction in which the (Na+)3()2() species goes to a form of
c     itself, but with the stoichiometry redefined so that there is
c     one mole of the site of interest per mole of the exchanger
c     species:
c
c       (Na+)3()2() = 3(Na+)()[2/3]()[1/3]
c
c     Because this is a pseudo-reaction, reflecting only a change
c     in components, there is no change in the Gibbs energy, enthalpy,
c     or entropy. Alternatively, the equilibrium constant is unity.
c     Thus,
c
c       a{(Na+)3()2()} = a{(Na+)()[2/3]()[1/3]}**3
c
c     In the ideal case, it is clear that:
c
c       a{(Na+)()[2/3]()[1/3]} = x{(Na+)()[2/3]()[1/3]}
c
c     Thus,
c
c       a{(Na+)3()2()} = x{(Na+)()[2/3]()[1/3]}**3
c
c     The mole fractions of the Na+ species are not affected by the
c     stoichiometric arbitrariness in how the species are defined.
c     Hence:
c
c       x{(Na+)3()2()} = x{(Na+)()[2/3]()[1/3]}
c
c     Subsitution of this into the equaiton immediately above then
c     yields:
c
c       a{(Na+)3()2()} = x{(Na+)3()2()}**3.
c
c     This explains the origin of the site number appearing as an
c     exponent in the calculation of the activity of a component.
c
c     The above kinds of species are not end-members. End-members for
c     the above exchanger phase would be:
c
c       (Na+)3(Fe+++)2(Z)
c       (Na+)3(Al+++)2(Z)
c       (K+)3(Fe+++)2(Z)
c       (K+)3(Al+++)2(Z)
c
c     Note that for example:
c
c       a((Na+)3(Fe+++)2(Z)) = a((Na+)3()2())**3 a(()3(Fe+++)2())**2
c
c     Note that a factor of a(Z)**1 is missing from the right hand
c     side. This is because this factor has a fixed value of 1 by
c     definition. This would be true even if we allowed for the
c     formal possibility of an arbitrary number of moles of substrate
c     in the exchanger phase, because there is no mixing on the
c     substrate site. Thus, a(Z) = 1.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ugexj  = array of exchanger site names
c       ugexmo = array of strings identifying exchange models, which
c                  are used for composing ion exchange species and
c                  corresponding reactions; examples include:
c                    'Gapon'    = Gapon model
c                    'Vanselow' = Vanselow model
c                    'Site-mixing' = the general site-mixing model
c       ugexmv = array of valid strings identifying exchange models
c       ugexp  = array of exchanger phase names
c       ugexr  = array of strings containing compact representations
c                  of the exchange reactions; e.g., 'Na+ = Ca++' for a
c                  reaction in which Na+ on the exchanger is replaced
c                  by Ca++. One may make specifications such as
c                  'Na+ = ' in which case the ion goes into solution
c                  leaving a bare substrate. All reactions are
c                  normalized to the exchange (or loss) of one
c                  equivalent. The exact form of the reaction is
c                  otherwise dependent on the mixing law specifed in
c                  the element of the ugexmo array for the current
c                  exchanger.
c       ugexs  = array of exchange ions names
c       ugexsr = array of exchange ions names extracted from the
c                  ugexr array
c
c     Principal input/output:
c
c       uphase = array of phase names (extended to include the names
c                  of generic exchange phases)
c       uspec  = array of species names (extended to include the names
c                  of species belonging to generic exchange phases)
c
c     Principal output:
c
c       cegexs = array of coefficients giving the number of equivalents
c                  per mole of each exchanger species.
c       cpgexs = array of coefficients giving the number of moles of
c                  exchanger substrate per mole of each exchanger
c                  species.
c       egexjf = array of formal exchange capacities of the sites of
c                  the exchangers, defined in terms of equivalents per
c                  mole of exchanger substrate. The formal exchange
c                  capacity of an exchanger phase is the sum of these
c                  for all its exchange sites.
c       jern1  = array giving the start of the range in the species
c                  list corresponding to species in the je-th site
c                  of the ne-th exchanger.
c       jern2  = array giving the end of the range in the species
c                  list corresponding to species in the je-th site
c                  of the ne-th exchanger.
c       jgext  = array giving the number of exchange sites in each of
c                  the ion exchange phases
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,ketmax,narxmx,nbtmax,ndrsmx,nessmx,netmax,
     $ nptmax,nstmax,ntprmx,nvetmx
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jgext(netmax),jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),
     $ kern1(netmax),kern2(netmax),kgexsa(ketmax,netmax),narxt(ntprmx),
     $ nbasp(nbtmax),ncmpr(2,nptmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ ness(nessmx),nessr(2,nstmax),ngexro(ietmax,jetmax,netmax),
     $ ngexrt(jetmax,netmax),ngext(jetmax,netmax),
     $ ngexsa(ietmax,jetmax,netmax),ngexso(ietmax,jetmax,netmax),
     $ nphasx(nstmax)
c
      integer iern1,iern2,narn1,narn2,nbt,net,nern1,nern2,npt,nst,ntprt
c
      character*56 ugexr(ietmax,jetmax,netmax)
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax),ugexmv(nvetmx),ugexp(netmax),
     $ ugexs(ietmax,jetmax,netmax),ugexsr(2,ietmax,jetmax,netmax),
     $ uphase(nptmax)
      character*8 ugexj(jetmax,netmax),uhfgex(ietmax,jetmax,netmax),
     $ uvfgex(ietmax,jetmax,netmax),uxkgex(ietmax,jetmax,netmax)
c
      real*8 axhfs(narxmx,ntprmx,nstmax),axlks(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),cegexs(ietmax,jetmax,netmax),
     $ cess(nessmx),cdrs(ndrsmx),cgexj(jetmax,netmax),
     $ cpgexs(ietmax,jetmax,netmax),egexjf(jetmax,netmax),
     $ mwtges(netmax),mwtsp(nstmax),tgexp(netmax),xhfgex(ietmax,
     $ jetmax,netmax),xlkgex(ietmax,jetmax,netmax),
     $ xvfgex(ietmax,jetmax,netmax),zchar(nstmax),zgexj(jetmax,netmax)
c
      real*8 al10,rconst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ie,iee,iej,ieo,itot,j,je,jee,jj,jj2,jj3,j2,j3,j4,j5,j6,
     $ k,ke,kee,ke1,n,nb,nd2,ne,nee,nerr,nn,np,nrf1,nrf2,nr1,nr2,ns,
     $ nsba,nse,nsl,nspect,nss,nsse,nve,nvet
c
      integer ilnobl,nbasis
c
      logical qmoerr,qsperr
c
      character*56 ustr56
      character*24 ugexpd,ustr1,ustr1e,ustr2
      character*8 ugexjd
c
      real afhx,afvx,afxb,afx0,arcnst,bfx,cfactr,cgx,cfxi,cfxz,cx,
     $ efx,tfxb,tfx0,xx,zprod,zpx,zsi,zxj,zxjt
c
c-----------------------------------------------------------------------
c
c     Initialize some constants.
c
      nerr = 0
      arcnst = -al10*0.001*rconst
      tfx0 = 273.15
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Count the number of valid exchange model options.
c
      nvet = 0
      do nve = 1,nvetmx
        if (ugexmv(nve)(1:6) .ne. 'ERROR ') nvet = nvet + 1
      enddo
c
      if (net.gt.0 .and. nvet.le.0) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format (/' * Error - (EQLIB/intexi) Programming error trap:',
     $  /7x,'There are no programmed valid strings representing',
     $  /7x,'exchange models for the generic ion phases. Check the',
     $  /7x,'data statement which initializes the ugexmv array. This',
     $  /7x,'is located in the EQLIB INCLUDE file eqlo8d.h. If the',
     $  /7x,'INCLUDE files have been "pre-stuffed" in your source',
     $  /7x,'code, this data statement may be found in the main',
     $  /7x,'programs for EQ3NR and EQ6.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pass 1. Loop on exchanger phases. Check the input. Provide
c     defaults as necessary. build a list of exchanger species, and
c     map exchange ions to their aqueous species counterparts.
c     The exchange phases and species will be created (in the
c     sense of being added to the general lists of phases and species)
c     below in pass 2.
c
      do ne = 1,net
        call lejust(ugexp(ne))
        j4 = ilnobl(ugexp(ne))
c
        if (j4 .le. 0) then
c
c         Have a blank exchanger name. Assign a default name.
c
          call adgexp(ne,noutpt,nttyo,ugexpd)
          ugexp(ne) = ugexpd
          j4 = ilnobl(ugexp(ne))
        endif
c
c       Make sure that the phase name is unique among all exchangers.
c
        do nee = 1,ne - 1
          if (ugexp(ne)(1:24) .eq. ugexp(nee)(1:24)) then
            write (noutpt,1010) ugexp(ne)(1:j4),ne,nee
            write (nttyo,1010) ugexp(ne)(1:j4),ne,nee
 1010       format (/' * Error - (EQLIB/intexi) "',a,'" is the name',
     $      ' specified',/7x,'for exchanger phases ',i3,' and ',i3,
     $      '. Exchanger phase names,',/7x,'including any assigned',
     $      ' defaults, must be unique.')
           nerr = nerr + 1
          endif
        enddo
c
c       Check the prescribed exchange model.
c
        call lejust(ugexmo(ne))
c
c       Provide a default.
c
        if (ugexmo(ne)(1:3) .eq. '   ') then
          ugexmo(ne) = ugexmv(1)
          write (noutpt,1012) ugexp(ne)(1:j4),ugexmo(ne)(1:j2)
          write (nttyo,1012) ugexp(ne)(1:j4),ugexmo(ne)(1:j2)
 1012     format (/' * Warning - (EQLIB/intexi) No exchange model',
     $    ' was species for',/7x,'the exchanger phase ',a,'. The ',a,
     $    ' model has been',/7x,'assigned as a default.')
        endif
c
        j5 = ilnobl(ugexmo(ne))
        do nve = 1,nvetmx
          j6 = ilnobl(ugexmv(nve))
          if (ugexmo(ne)(1:j5) .eq. ugexmv(nve)(1:j6)) go to 130
        enddo
c
        write (noutpt,1020) ugexmo(ne)(1:j2),ugexp(ne)(1:j4)
        write (nttyo,1020) ugexmo(ne)(1:j2),ugexp(ne)(1:j4)
 1020   format (/" * Error - (EQLIB/intexi) Don't recognize the",
     $  ' exchange model type',/7x,'"',a,'" specified for the',
     $  ' generic exchanger phase ',a,'.',/7x,'Valid choices',
     $  ' include the following:',/)
c
        do nve = 1,nvetmx
          if (ugexmv(nve)(1:6) .ne. 'ERROR ') then
            j6 = ilnobl(ugexmv(nve))
            write (noutpt,1022) ugexmv(nve)(1:j6)
            write (nttyo,1022) ugexmv(nve)(1:j6)
 1022       format(9x,a)
          endif
        enddo
c
        j6 = ilnobl(ugexmv(1))
        write (noutpt,1024) ugexmv(1)(1:j6)
        write (nttyo,1024) ugexmv(1)(1:j6)
 1024   format(/7x,'A blank input defaults to "',a,'".')
        nerr = nerr + 1
c
  130   if (mwtges(ne) .le. 0) then
          mwtges(ne) = 100.
          write (noutpt,1030) ugexp(ne)(1:j4)
          write (nttyo,1030) ugexp(ne)(1:j4)
 1030     format (/" * Warning - (EQLIB/intexi) Don't have a valid",
     $    ' input for the',/7x,'molecular weight of the substrate for',
     $    ' exchange phase'/7x,a,'. Assigning a default value of',
     $    ' 100 grams/mol.')
        endif
c
        if (tgexp(ne) .eq. 0.) then
          tgexp(ne) = 25.0
          write (noutpt,1040) ugexp(ne)(1:j4)
          write (nttyo,1040) ugexp(ne)(1:j4)
 1040     format (/" * Warning - (EQLIB/intexi) Don't have a valid",
     $    ' input for the',/7x,'temperature reference required for',
     $    ' the thermodynamic data for',/7x,'exchange phase ',a,
     $    '. Assigning a default value of 25C.')
        endif
        cfactr = 1./(arcnst*(tgexp(ne) + 273.15))
c
c       Loop on sites.
c
        do je = 1,jgext(ne)
          call lejust(ugexj(je,ne))
          j3 = ilnobl(ugexj(je,ne))
c
c         Calculate the formally declared exchange capacity (in
c         equivalents per mole of exchanger substrate) of the
c         current site. The sign of this is opposite to that of the
c         charge on the site itself.
c
          egexjf(je,ne) = -cgexj(je,ne)*zgexj(je,ne)
c
c         Check the name of the current site.
c
          if (j3 .eq. 0) then
c
c           No name was given. Assign one (e.g., "S(1)" to site 1,
c           "S(2)" to site 2).
c
            call adgexj(je,noutpt,nttyo,ugexjd)
            ugexj(je,ne) = ugexjd
            j3 = ilnobl(ugexj(je,ne))
          endif
c
c         Make sure that the site name is unique among all sites for
c         the current exchanger phase.
c
          do jee = 1,je - 1
            if (ugexj(je,ne)(1:8) .eq. ugexj(jee,nee)(1:8)) then
              write (noutpt,1060) ugexj(je,ne)(1:j3),je,jee,
     $        ugexp(ne)(1:j4)
              write (nttyo,1060) ugexj(je,ne)(1:j3),je,jee,
     $        ugexp(ne)(1:j4)
 1060         format (/' * Error - (EQLIB/intexi) "',a,'" is the name',
     $        ' of',/7x,'sites ',i3,' and ',i3,' of exchanger phase ',
     $        a,'.',/7x,'Site names, including any assigned',
     $        ' defaults, must be unique',/7x,'for a given',
     $        ' exchanger phase.')
              nerr = nerr + 1
            endif
          enddo
c
c         Check the electrical charge of the site against the specified
c         exchange model.
c
          if (ugexmo(ne)(1:5).eq.'Gapon' .or.
     $      ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $      ugexmo(ne)(1:8).eq.'Vanselow' .or.
     $      ugexmo(ne)(1:9).eq.'Vanselow-') then
            if (zgexj(je,ne) .eq. 0.) then
              write (noutpt,1070) ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),
     $        ugexmo(ne)(1:j5)
              write (nttyo,1070) ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),
     $        ugexmo(ne)(1:j5)
 1070         format (/' * Error - (EQLIB/intexi) The electrical',
     $        ' charge of site ',a,''/7x,'of exchanger phase ',
     $        a,' is zero. This is not valid',/7x,'for the ',a,
     $        ' exchange model.')
              nerr = nerr + 1
            endif
          endif
c
c         Loop on condensed reactions read from the input file. Map
c         these to species corresponding to ions on the sites.
c
          qsperr = .false.
          do n = 1,ngexrt(je,ne)
            k = index(ugexr(n,je,ne),' == ')
            if (k .gt. 0) then
              ustr56 = ugexr(n,je,ne)(1:k - 1)
              call lejust(ustr56)
              ustr1 = ustr56(1:24)
              ustr56 = ugexr(n,je,ne)(k + 4:56)
              call lejust(ustr56)
              ustr2 = ustr56(1:24)
            else
              k = index(ugexr(n,je,ne),' = ')
              if (k .gt. 0) then
                ustr56 = ugexr(n,je,ne)(1:k - 1)
                call lejust(ustr56)
                ustr1 = ustr56(1:24)
                ustr56 = ugexr(n,je,ne)(k + 3:56)
                call lejust(ustr56)
                ustr2 = ustr56(1:24)
              else
                k = index(ugexr(n,je,ne),'==')
                if (k .gt. 0) then
                  ustr56 = ugexr(n,je,ne)(1:k - 1)
                  call lejust(ustr56)
                  ustr1 = ustr56(1:24)
                  ustr56 = ugexr(n,je,ne)(k + 2:56)
                  call lejust(ustr56)
                  ustr2 = ustr56(1:24)
                else
                  k = index(ugexr(n,je,ne),'=')
                  if (k .gt. 0) then
                    ustr56 = ugexr(n,je,ne)(1:k - 1)
                    call lejust(ustr56)
                    ustr1 = ustr56(1:24)
                    ustr56 = ugexr(n,je,ne)(k + 1:56)
                    call lejust(ustr56)
                    ustr2 = ustr56(1:24)
                  else
                    j2 = ilnobl(ugexr(n,je,ne))
                    write (noutpt,1080) ugexr(n,je,ne)(1:j2),
     $              ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
                    write (nttyo,1080) ugexr(n,je,ne)(1:j2),
     $              ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1080               format (/" * Error - (EQLIB/intexi) Can't decode",
     $              ' the condensed reaction string',/7x,'"',a,'",',
     $              ' which is given for site ',a,' of exchange',
     $              /7x,'phase ',a,'. The two species in the string',
     $              ' must be',/7x,'separated by " == ", " = ", "==",',
     $              ' or "=".')
                    ustr1 = 'Error'
                    ustr2 = 'Error'
                    nerr = nerr + 1
                    qsperr = .true.
                  endif
                endif
              endif
            endif
c
c           Prettify the strings in the ugexr array. Use "__" to
c           indicate a bare exchange site.
c
            if (ustr1(1:3) .eq. '   ') ustr1 = '__'
            if (ustr1(1:3) .eq. '_  ') ustr1 = '__'
            if (ustr2(1:3) .eq. '   ') ustr2 = '__'
            if (ustr2(1:3) .eq. '_  ') ustr2 = '__'
            ugexsr(1,n,je,ne) = ustr1
            ugexsr(2,n,je,ne) = ustr2
            j2 = ilnobl(ustr1)
            ugexr(n,je,ne)(j2 + 1:j2 + 3) = ' = '
            ugexr(n,je,ne)(j2 + 4:56) = ustr2
c
c           Make sure the two species in the reaction are not identical.
c
            if (ustr1(1:6) .ne. 'Error ') then
              if (ustr1(1:24) .eq. ustr2(1:24)) then
                j2 = ilnobl(ugexr(n,je,ne))
                if (ustr1(1:3) .eq. '__ ') then
                  write (noutpt,1090) ugexr(n,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
                  write (nttyo,1090) ugexr(n,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1090             format (/' * Error - (EQLIB/intexi) The condensed',
     $            ' exchange reaction "',a,'"',/7x,'for site ',a,
     $            ' of exchange phase ',a,' is an',/7x,'identity',
     $            " reaction. Such a reaction shouldn't appear on the",
     $            /7x,'input file.')
                else
                  write (noutpt,1100) ugexr(n,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
                  write (nttyo,1100) ugexr(n,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1100             format (/' * Error - (EQLIB/intexi) The condensed',
     $            ' exchange reaction "',a,'"',/7x,'for site ',a,
     $            ' of exchange phase ',a,' is invalid.',/7x,'The two',
     $            " species in the reaction can't be identical.")
                endif
                nerr = nerr + 1
                qsperr = .true.
              endif
            endif
          enddo
c
          if (qsperr) go to 200
c
c         Add a condensed reaction which involves one of the
c         exchangeable species and the bare site species, if none
c         such was included on the input.
c
          do n = 1,ngexrt(je,ne)
            ustr1 = ugexsr(1,n,je,ne)
            ustr2 = ugexsr(2,n,je,ne)
            if (ustr1(1:3) .eq. '__ ') go to 140
            if (ustr2(1:3) .eq. '__ ') go to 140
          enddo
c
          n = ngexrt(je,ne) + 1
          ngexrt(je,ne) = n
          ustr1 = ugexsr(1,1,je,ne)
          ustr2 = '__'
          ugexsr(1,n,je,ne) = ustr1
          ugexsr(2,n,je,ne) = ustr2
          j2 = ilnobl(ustr1)
          ugexr(n,je,ne) = ustr1
          ugexr(n,je,ne)(j2 + 1:j2 + 3) = ' = '
          ugexr(n,je,ne)(j2 + 4:56) = ustr2
          xlkgex(n,je,ne) = -12.0
          xhfgex(n,je,ne) = 0.
          xvfgex(n,je,ne) = 0.
          uxkgex(n,je,ne) = 'LogK/eq'
          uhfgex(n,je,ne) = 'kcal/eq'
          uvfgex(n,je,ne) = 'cm3/eq'
  140     continue
c
c         Add an identity reaction for the bare site species.
c         This is done to simplify the indexing relations between
c         exchanger species and corresponding reactions by making
c         them one to one. This simplification is important, because
c         the species must be created in a special order so that the
c         corresponding reaction properties for dissocation to the
c         bare site species can be calculated from the specified
c         exchange data without having to resort to matrix equations.
c
          n = ngexrt(je,ne) + 1
          ngexrt(je,ne) = n
          ustr1 = '__'
          ustr2 = '__'
          ugexsr(1,n,je,ne) = ustr1
          ugexsr(2,n,je,ne) = ustr2
          j2 = ilnobl(ustr1)
          ugexr(n,je,ne) = ustr1
          ugexr(n,je,ne)(j2 + 1:j2 + 3) = ' = '
          ugexr(n,je,ne)(j2 + 4:56) = ustr2
          xlkgex(n,je,ne) = 0.
          xhfgex(n,je,ne) = 0.
          xvfgex(n,je,ne) = 0.
          uxkgex(n,je,ne) = 'LogK/eq'
          uhfgex(n,je,ne) = 'kcal/eq'
          uvfgex(n,je,ne) = 'cm3/eq'
c
c         Put the names of the ions on the current site
c         in the ugexs array.
c
          nspect = 2
          ustr1 = ugexsr(1,1,je,ne)
          ustr2 = ugexsr(2,1,je,ne)
          ugexs(1,je,ne) = ustr1
          ugexs(2,je,ne) = ustr2
c
c         The last reaction is the identity reaction for the bare site
c         species, and it is guaranteed that a previous reaction
c         involves this species, so looping from 2,ngexrt(je,ne) - 1
c         is sufficient.
c
          do n = 2,ngexrt(je,ne) - 1
            do i = 1,2
              ustr1 = ugexsr(i,n,je,ne)
              do nn = 1,nspect
                if (ustr1(1:24) .eq. ugexs(nn,je,ne)) go to 150
              enddo
              nspect = nspect + 1
              ugexs(nspect,je,ne) = ustr1
  150         continue
            enddo
          enddo
c
          if (nspect .ne. ngexrt(je,ne)) then
            write (noutpt,1110) nspect,ngexrt(je,ne),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
            write (nttyo,1110) nspect,ngexrt(je,ne),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1110       format (/' * Error - (EQLIB/intexi) Have ',i3,' species',
     $      ' and ',i3,' reactions for',/7x,'site ',a,' of exchange',
     $      ' phase ',a,' after automatic',/7x,'additions to deal with',
     $      ' the bare site species. The number',/7x,'of species',
     $      ' (including the bare site species) must be equal to',
     $      /7x,'the number of reactions. Check the input. If you have',
     $      ' listed for',/7x,'a site for example two exchange',
     $      ' reactions such as "Na+ = K+" and',/7x,'"Rb+ = Cs+,"',
     $      ' you must include a third one to complete the linkage,',
     $       /7x,'such as "Na+ = Rb+".')
            nerr = nerr + 1
          endif
c
c         Map each exchange species to its aqueous species counterpart
c         (the exchangeable species).
c
          do ie = 1,nspect
            if (ugexs(ie,je,ne)(1:3) .eq. '__ ') then
              ngexsa(ie,je,ne) = 0
              go to 170
            endif
            j2 = ilnobl(ugexs(ie,je,ne))
c
            do nss = narn1,narn2
              if (ugexs(ie,je,ne)(1:24) .eq. uspec(nss)(1:24)) then
                ngexsa(ie,je,ne) = nss
                go to 170
              endif
            enddo
c
            write (noutpt,1130) ugexs(ie,je,ne)(1:j2),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
            write (nttyo,1130) ugexs(ie,je,ne)(1:j2),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1130       format (/' * Error - (EQLIB/intexi) The exchange species ',
     $      a,/7x,'specified for site ',a,' of exchange phase ',a,
     $      /7x,'does not correspond to any aqueous species read from',
     $      ' the data file.')
            nerr = nerr + 1
            qsperr = .true.
c
  170       continue
          enddo
c
          if (qsperr) go to 200
c
c         Test the electrical charges of the exchangeable species
c         and the charge of the site against the exchanger model.
c
          if (ugexmo(ne)(1:5).eq.'Gapon' .or.
     $      ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $      ugexmo(ne)(1:8).eq.'Vanselow' .or.
     $      ugexmo(ne)(1:9).eq.'Vanselow-') then
            do ie = 1,nspect
              nss = ngexsa(ie,je,ne)
              if (nss .gt. 0) then
                zpx = zchar(nss)*zgexj(je,ne)
                if (zpx .ge. 0.) then
                  write (noutpt,1150) ugexs(ie,je,ne)(1:j2),
     $            zchar(nss),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),
     $            ugexmo(ne)(1:j5)
                  write (nttyo,1150) ugexs(ie,je,ne)(1:j2),
     $            zchar(nss),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),
     $            ugexmo(ne)(1:j5)
 1150             format (/' * Error - (EQLIB/intexi) The electrical',
     $            ' charge of ',a,/7x,'is ',f5.1,'. This species',
     $            " can't be exchanged onto site ",a,/7x,'of exchanger',
     $            ' phase ',a,' because the site',/7x,'has the same',
     $            ' charge sign or zero charge. Opposite charge',
     $            /7x,'signs are required for the ',a,' exchange',
     $            ' model.')
                  nerr = nerr + 1
                endif
              endif
            enddo
          endif
c
c         Convert the input thermodynamic parameters for exchange or
c         dissociation reactions to standard units.
c
          do ie = 1,nspect
            call lejust(uxkgex(ie,je,ne))
            if (uxkgex(ie,je,ne)(1:3) .eq. '   ') then
              uxkgex(ie,je,ne) = 'LogK/eq'
            elseif (uxkgex(ie,je,ne)(1:8) .eq. 'kcal/eq ') then
              xlkgex(ie,je,ne) = cfactr*xlkgex(ie,je,ne)
              uxkgex(ie,je,ne) = 'LogK/eq'
            elseif (uxkgex(ie,je,ne)(1:8) .eq. 'kJ/eq   ') then
              xlkgex(ie,je,ne) = xlkgex(ie,je,ne)/4.184
              xlkgex(ie,je,ne) = cfactr*xlkgex(ie,je,ne)
              uxkgex(ie,je,ne) = 'LogK/eq'
            elseif (uxkgex(ie,je,ne)(1:8) .ne. 'LogK/eq ') then
              j2 = ilnobl(ugexr(ie,je,ne))
              j5 = ilnobl(uxkgex(ie,je,ne))
              write (noutpt,1170) uxkgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1170) uxkgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1170         format (/" * Error - (EQLIB/intexi) Don't recognize the",
     $        ' string "',a,'", which is',/7x,'given to define the',
     $        ' units for the xlkgex (log K) input for the',
     $        /7x,'reaction "',a,'" on site ',a,' of exchanger phase',
     $        /7x,a,'. The string must be blank (defaults to',
     $        ' "LogK/eq"),',/7x,'"LogK/eq", "kcal/eq", or "kJ/eq".')
              nerr = nerr + 1
            endif
c
            call lejust(uhfgex(ie,je,ne))
            if (uhfgex(ie,je,ne)(1:3) .eq. '   ') then
              uhfgex(ie,je,ne) = 'kcal/eq'
            elseif (uhfgex(ie,je,ne)(1:8) .eq. 'kJ/eq   ') then
              xhfgex(ie,je,ne) = xhfgex(ie,je,ne)/4.184
              uhfgex(ie,je,ne) = 'kcal/eq'
            elseif (uhfgex(ie,je,ne)(1:8) .ne. 'kcal/eq ') then
              j2 = ilnobl(ugexr(ie,je,ne))
              j5 = ilnobl(uhfgex(ie,je,ne))
              write (noutpt,1180) uhfgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1180) uhfgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1180         format (/" * Error - (EQLIB/intexi) Don't recognize the",
     $        ' string "',a,'", which is',/7x,'given to define the',
     $        ' units for the xhfgex (enthalpy) input for the',
     $        /7x,'reaction "',a,'" on site ',a,' of exchanger phase',
     $        /7x,a,'. The string must be blank (defaults to',
     $        ' "kcal/eq"),',/7x,'"kcal/eq", or "kJ/eq".')
              nerr = nerr + 1
            endif
c
            call lejust(uvfgex(ie,je,ne))
            if (uvfgex(ie,je,ne)(1:3) .eq. '   ') then
              uvfgex(ie,je,ne) = 'cm3/eq'
            elseif (uvfgex(ie,je,ne)(1:8) .ne. 'cm3/eq  ') then
              j2 = ilnobl(ugexr(ie,je,ne))
              j5 = ilnobl(uvfgex(ie,je,ne))
              write (noutpt,1190) uvfgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1190) uvfgex(ie,je,ne)(1:j5),
     $        ugexr(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1190         format (/" * Error - (EQLIB/intexi) Don't recognize the",
     $        ' string "',a,'", which is',/7x,'given to define the',
     $        ' units for the xvfgex (volume) input for the',
     $        /7x,'reaction "',a,' on site ',a,' of exchanger phase',
     $        /7x,a,'. The string must be blank (defaults to',
     $        ' "cm3/eq")',/7x,'or "cm3/eq".')
              nerr = nerr + 1
            endif
          enddo
c
  200     continue
        enddo
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      np = npt
      ns = nst
      nern1 = nst + 1
      iern1 = npt + 1
c
c     Pass 2. Loop on exchanger phases. Formally create exchanger phases
c     and species, and comute the corresponding reactions and
c     thermodynamic data for such species.
c
      do ne = 1,net
        j4 = ilnobl(ugexp(ne))
c
        if (npt .ge. nptmax) then
          write (noutpt,1240) nptmax,ugexp(ne)(1:j2)
          write (nttyo,1240) nptmax,ugexp(ne)(1:j2)
 1240     format (/' * Error - (EQLIB/intexi) The maximum ',i3,
     $    ' phases would be',/7x,'exceeded by creating the exchange',
     $    ' phase ',a,'. Increase',/7x,'the dimensioning parameter',
     $    ' nptpar.')
          stop
        endif
c
c       Add the current exchange phase to the list of phases.
c
        np = np + 1
        npt = np
        jpflag(np) = 0
        uphase(np) = ugexp(ne)
        ncmpr(1,np) = ns + 1
        tfxb = tgexp(ne)
c
c       Loop on sites.
c
        nsba = 0
        do je = 1,jgext(ne)
          j3 = ilnobl(ugexj(je,ne))
c
          nspect = ngexrt(je,ne)
c
c         Change the condensed reactions if necessary so that any
c         association reactions are converted to dissociation
c         reactions (e.g., for Na+, from "__ = Na+" to "Na+ = __").
c         Do not modify the last reaction, which is the identity
c         reaction for the bare site species.
c
          do ie = 1,nspect - 1
            if (ugexsr(1,ie,je,ne)(1:3) .eq. '__ ') then
              xlkgex(ie,je,ne) = -xlkgex(ie,je,ne)
              xhfgex(ie,je,ne) = -xhfgex(ie,je,ne)
              xvfgex(ie,je,ne) = -xvfgex(ie,je,ne)
              ugexsr(1,ie,je,ne)(1:24) = ugexsr(2,ie,je,ne)(1:24)
              ugexsr(2,ie,je,ne)(1:24) = '__ '
            endif
          enddo
c
c         Now convert all exchange reactions in this set to
c         dissociation reactions. To give an idea of what is happening,
c         a single exchange reaction "Ca++ = Na+" read from the input
c         file would now be expanded to the following condensed
c         reaction set:
c
c           1. Ca++ = Na+
c           2. Ca++ = __
c           3. __ = __
c
c         The corresponding species (corresponding in the set of having
c         matching indices) would be:
c
c           1. Ca++
c           2. Na+
c           3. __
c
c         Note that there is no formal correspondence in that species 2
c         (Na+) does not appear in reaction 2 (Ca++ = __). Also, the
c         base site species ("__") need not appear last, depending
c         on what condensed reactions were read from the input file.
c         The identity reaction for this species is guaranteed to
c         appear last, as it can't be read from the input file, and
c         is created in this position by the current subroutine in the
c         "Pass 1" section above.
c
c         The first step is to convert the set of existing condensed
c         reactions into a set of linearly independent dissociation
c         reactions. In the example, the set of reactions becomes:
c
c           1. Na+ = __
c           2. Ca++ = __
c           3. __ = __
c
c         Note that it is guaranteed that the last reaction is the
c         identity reaction for the bare site species and that at
c         least one of the remaining reactions is a dissociation
c         reaction. Tests performed above also guarantee that the
c         desired conversion is possible. Basically, the process
c         requires going through the reactions in an order which
c         insures that for each exchange reaction there currently
c         exists a dissociation reaction for one of the two species.
c
c         First, loop through the reactions, and mark all those which
c         are in the desired form (the identity reaction for the bare
c         site species and all reactions in dissociation format) by
c         setting a value of 1 in the corresponding element of the
c         ngexro array. It is guaranteed that there is at least one
c         reaction in dissociation format. Then repeatedly loop
c         through the remaining reactions, each time finding one to
c         transform from exchange to dissociation format by combining
c         it with a reaction in the processed set. Mark it as
c         transformed using the ngexro array. Repeated looping
c         is required to insure that all such reactions can be
c         transformed. Stop when no reactions remain in exchange
c         format.
c
c         The ngexro array will later be used to create a mapping
c         between the species and the reactions.
c
          do iee = 1,nspect
            ngexro(iee,je,ne) = 0
          enddo
c
          itot = 1
          ngexro(nspect,je,ne) = 1
c
          do ie = 1,nspect - 1
            ustr1 = ugexsr(1,ie,je,ne)
            ustr2 = ugexsr(2,ie,je,ne)
            if (ustr2(1:3) .eq. '__ ') then
              itot = itot + 1
              ngexro(ie,je,ne) = 1
            endif
          enddo
c
  210     if (itot .eq. nspect) go to 220
          do ie = 1,nspect - 1
            if (ngexro(ie,je,ne) .eq. 0) then
              ustr1 = ugexsr(1,ie,je,ne)
              ustr2 = ugexsr(2,ie,je,ne)
              do iee = 1,nspect - 1
                if (ngexro(iee,je,ne) .eq. 1) then
                  ustr1e = ugexsr(1,iee,je,ne)
                  if (ustr1e(1:24) .eq. ustr2(1:24)) then
                    itot = itot + 1
                    ngexro(ie,je,ne) = 1
                    ugexsr(1,ie,je,ne) = ustr1
                    ugexsr(2,ie,je,ne) = '__'
                    j2 = ilnobl(ustr1)
                    ugexr(ie,je,ne) = ustr1
                    ugexr(ie,je,ne)(j2 + 1:j2 + 3) = ' = '
                    ugexr(ie,je,ne)(j2 + 4:56) = '__'
                    xx = xlkgex(ie,je,ne) + xlkgex(iee,je,ne)
                    xlkgex(ie,je,ne) = xx
                    xx = xhfgex(ie,je,ne) + xhfgex(iee,je,ne)
                    xhfgex(ie,je,ne) = xx
                    xx = xvfgex(ie,je,ne) + xvfgex(iee,je,ne)
                    xvfgex(ie,je,ne) = xx
                    go to 210
                  elseif (ustr1e(1:24) .eq. ustr1(1:24)) then
                    itot = itot + 1
                    ngexro(ie,je,ne) = 1
                    ugexsr(1,ie,je,ne) = ustr2
                    ugexsr(2,ie,je,ne) = '__'
                    j2 = ilnobl(ustr2)
                    ugexr(ie,je,ne) = ustr2
                    ugexr(ie,je,ne)(j2 + 1:j2 + 3) = ' = '
                    ugexr(ie,je,ne)(j2 + 4:56) = '__'
                    xx = -xlkgex(ie,je,ne) + xlkgex(iee,je,ne)
                    xlkgex(ie,je,ne) = xx
                    xx = -xhfgex(ie,je,ne) + xhfgex(iee,je,ne)
                    xhfgex(ie,je,ne) = xx
                    xx = -xvfgex(ie,je,ne) + xvfgex(iee,je,ne)
                    xvfgex(ie,je,ne) = xx
                    go to 210
                  endif
                endif
              enddo
            endif
          enddo
c
          write (noutpt,1250) ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
          write (nttyo,1250) ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1250     format(/' * Error - (EQLIB/intexi) Programming error trap:',
     $    " Couldn't transform",/7x,'one or more  condensed reactions',
     $    ' for site ',a,' of exchange',/7x,'phase ',a,' from',
     $    ' exchange format to dissociation',/7x,'format. Check the',
     $    ' responsible coding.')
          stop
c
  220     continue
c
c         Now set up the ngexro array as a pointer array giving the
c         index of the reaction corresponding to a given species.
c
          itot = 0
          do ie = 1,nspect
            ngexro(ie,je,ne) = 0
            ustr1 = ugexs(ie,je,ne)
            do iee = 1,nspect
              if (ustr1(1:24) .eq. ugexsr(1,iee,je,ne)(1:24)) then
                itot = itot + 1
                ngexro(ie,je,ne) = iee
                go to 230
              endif
            enddo
c
            write (noutpt,1260) ugexs(ie,je,ne)(1:j2),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
            write (nttyo,1260) ugexs(ie,je,ne)(1:j2),
     $      ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1260       format(/' * Error - (EQLIB/intexi) Programming error trap:',
     $      " Couldn't find",/7x,'a condensed identity or dissociation',
     $      ' reaction for ',a,/7x,'on site ',a,' of exchange phase ',
     $      a,'. Check the',/7x,'responsible coding.')
            stop
c
  230       continue
          enddo
c
c         Order the species for creation, using the ngexso array.
c         Use the existing order, except that the bare site species
c         is created first.
c
          itot = 0
          do ie = 1,nspect
            if (ugexs(ie,je,ne)(1:3) .eq. '__ ') then
              itot = itot + 1
              ngexso(itot,je,ne) = ie
              go to 240
            endif
          enddo
  240     continue
          do ie = 1,nspect
            if (ugexs(ie,je,ne)(1:3) .ne. '__ ') then
              itot = itot + 1
              ngexso(itot,je,ne) = ie
            endif
          enddo
c
c         Create the species for the current site.
c
          jern1(je,ne) = ns + 1
c
c         Loop on ions on sites. Note that the bare exchanger species
c         will be created first.
c
          do ieo = 1,nspect
            ie = ngexso(ieo,je,ne)
            j2 = ilnobl(ugexs(ie,je,ne))
c
            if (nst .ge. nstmax) then
              write (noutpt,1290) nstmax,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1290) nstmax,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1290         format (/' * Error - (EQLIB/intexi) The maximum ',i4,
     $        ' species would be',/7x,'exceeded by creating an',
     $        ' exchange species for ',a,/7x,'on site ',a,
     $        ' of exchange phase ',a,'. Increase the',
     $        /7x,'dimensioning parameter nstpar.')
              stop
            endif
c
            ns = ns + 1
            nsl = nst
            nst = ns
            jsflag(ns) = 0
c
            jsitex(ns) = je
            nphasx(ns) = np
c
c           If the current species is the bare one for the current
c           site, add it to the set of strict basis species.
c
            nss = ngexsa(ie,je,ne)
            if (nss .eq. 0) then
              nbt = nbt + 1
              if (nbt .gt. nbtmax) then
                write (noutpt,1300) nbtmax,ugexs(ie,je,ne)(1:j2),
     $          ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
                write (nttyo,1300) nbtmax,ugexs(ie,je,ne)(1:j2),
     $          ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1300           format (/' * Error - (EQLIB/intexi) The maximum,',
     $          i3,' basis species would be',/7x,'exceeded by',
     $          ' adding a species for ',a,' on site ',a,/7x,'of',
     $          ' exchange phase ',a,'. Increase the dimensioning',
     $          /7x,'parameter nbtpar.')
                stop
              else
                nbasp(nbt) = ns
                jflag(ns) = 0
                nsba = ns
              endif
            endif
c
c           Get the index of the corresponding aqueous species
c           (the exchangeable species). Compute the stoichiometric
c           relationship between the exchanger species and the
c           corresponding aqueous species. This relationship depends
c           on the specified exchange model.
c
            nss = ngexsa(ie,je,ne)
            if (nss .gt. 0) then
              zsi = zchar(nss)
            else
              zsi = 0.
            endif
            zxj = zgexj(je,ne)
            zprod = zsi*zxj
c
c           Note: cfxi below is the reaction coefficient for the
c           exchangeable ion in the dissociation reaction for the
c           corresponding exchanger species. The dissociation reaction
c           is always written such that one mole of exchanger species
c           is dissociated.
c
            j5 = ilnobl(ugexmo(ne))
c
            if (nss .gt. 0) then
              if (ugexmo(ne)(1:5).eq.'Gapon' .or.
     $          ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $          ugexmo(ne)(1:8).eq.'Vanselow' .or.
     $          ugexmo(ne)(1:9).eq.'Vanselow-') then
c
c               Check electrical charges of the exchangeable ion and
c               the exchange site.
c
                qmoerr = .false.
                if (zsi .eq. 0.) then
                  write (noutpt,1320) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
                  write (nttyo,1320) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
 1320             format (/" * Error - (EQLIB/intexi) Can't create",
     $            ' a generic ion exchange species',/7x,'for ',a,
     $            ' on site ',a,' of exchange phase',/7x,a,
     $            ' for the ',a,' model because',/7x,'the',
     $            ' exchangeable ion has no electrical charge.')
                  nerr = nerr + 1
                  qmoerr = .true.
                endif
c
                if (zxj .eq. 0.) then
                  write (noutpt,1330) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
                  write (nttyo,1330) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
 1330             format (/" * Error - (EQLIB/intexi) Can't create",
     $            ' a generic ion exchange species',/7x,'for ',a,
     $            ' on site ',a,' of exchange phase',/7x,a,
     $            ' for the ',a,' model because',/7x,'the',
     $            ' the exchange site has no electrical charge.')
                  nerr = nerr + 1
                  qmoerr = .true.
                endif
c
                if (qmoerr) go to 270
c
                if (zprod .gt. 0.) then
                  write (noutpt,1340) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
                  write (nttyo,1340) ugexs(ie,je,ne)(1:j2),
     $            ugexj(je,ne)(1:j3),ugexp(ne)(1:j4),ugexmo(ne)(1:j5)
 1340             format (/" * Error - (EQLIB/intexi) Can't create",
     $            ' a generic ion exchange species',/7x,'for ',a,
     $            ' on site ',a,' of exchange phase',/7x,a,' for the ',
     $            a,' model because the exchangeable',/7x,'ion and',
     $            ' the exchange site have the same electrical',
     $            ' charge sign.')
                  nerr = nerr + 1
                  go to 270
                endif
              endif
            endif
c
            cgx = cgexj(je,ne)
            zxjt = cgx*zxj
c
c           cfxi = the number of moles of exchangeable ion per
c                    mole of the exchanger species
c           cfxz = the number of moles of exchanger substrate per
c                    mole of exchanger species
c
            if (nss .gt. 0) then
c
c             Have other than the bare site species.
c
              if (ugexmo(ne)(1:j5).eq.'Gapon' .or.
     $          ugexmo(ne)(1:6).eq.'Gapon-') then
c
c               Gapon (Gapon-?) model.
c
c                 For:
c
c                   cgexj(je,ne) = 1
c                   zgexj(je,ne) = -1
c                   "Na+ = Ca++"
c
c                 the species are:
c
c                   Na-Z and Ca[1/2]-Z
c
                cfxi = -cgx*zxj/zsi
                cfxz = -cfxi*zsi/zxjt
c
              elseif (ugexmo(ne)(1:j5).eq.'Vanselow' .or.
     $          ugexmo(ne)(1:9).eq.'Vanselow-') then
c
c               Vanselow (Vanselow-?) model.
c
c                 For:
c
c                   cgexj(je,ne) = 1
c                   zgexj(je,ne) = -1
c                   "Na+ = Ca++"
c
c                 the species are:
c
c                   Na-Z and Ca-Z2
c
                cfxi = -cgx*zxj*abs(zsi)/zsi
                cfxz = -cfxi*zsi/zxjt
c
              elseif (ugexmo(ne)(1:j5) .eq. 'Site-mixing') then
c
c               Site-mixing model.
c
                cfxi = cgx
                cfxz = 1.0
c
              else
                write (noutpt,1350) ugexmo(ne)(1:j5),ugexp(ne)(1:j4)
                write (nttyo,1350) ugexmo(ne)(1:j5),ugexp(ne)(1:j4)
 1350           format (/' * Error - (EQLIB/intexi.f) Programming',
     $          " error trap: Don't recognize the",/7x,'exchange',
     $          ' model type"',a,'" specified for the exchanger phase',
     $          /7x,a,'. Valid choices include "Gapon" and "Vanselow".',
     $          /7x,'Invalid choices should have been trapped above in',
     $          ' this subroutine.',/7x,'Check the coding at the',
     $          ' present point. Now trying to compute',/7x,'factors',
     $          ' for the compositions and reactions of species',
     $          ' belonging',/7x,'to this exchanger phase.')
                stop
              endif
            else
c
c             Have the bare site species.
c
              cfxi = cgx
              cfxz = 1.0
            endif
c
c           Here efx is the number of equivalents of exchangeable
c           ion appearing in the dissociation reaction.
c
            if (nss .gt. 0) then
c
c             Have other than the bare site species.
c
              zchar(ns) = cfxi*zsi - zxjt
              mwtsp(ns) = cfxi*mwtsp(nss)
              efx = abs(cfxi*zsi)
            else
c
c             Have the bare site species.
c
              zchar(ns) = zxjt
              mwtsp(ns) = 0.
              efx = 0.
            endif
c
c           Compose the full name of the exchanger species. The phase
c           part of the name is the exchange phase name. The species
c           part is a concatenation of the species part of the name of
c           the ion released in an exchange reaction (the aqueous
c           ion) and the site name. A blank space is included in the
c           concatenation between the two parts. The concatenation is
c           trimmed as necessary to fit into 24 characters.
c           Approximately two characters of the exchange ion name are
c           trimmed for each character of the site name. The full name
c           of the species should should then look like
c           "Na+ S(1)                Exchanger(A)". This algorithm
c           matches that in EQLIB/intgex.f. As formatted by
c           EQLIBU/fmspnm.f or EQLIBU/fmspnx.f, the name in this
c           example would appear as "Na+ S(1) Exchanger(A)".
c
c           Warning: the stoichiometry of the species can't be deduced
c           from the name alone. The the number of formula units of
c           exchangeable Na+ in site S(1) in the above example could be
c           1.0, 2.0, or some other number. The same is true for the
c           number of moles of the site itself per mole of exchanger.
c           Thus, "Na+ S(1) Exchanger(A)" has one stoichiometry for
c           the Vanselow model, but a different one for the Gapon model.
c
            jj2 = j2
            jj3 = j3
            nd2 = 0
  250       jj = jj2 + jj3 + 1
            if (jj .gt. 24) then
              if (nd2 .lt. 2) then
                jj2 = jj2 - 1
                nd2 = nd2 + 1
                go to 250
              else
                jj3 = jj3 - 1
                nd2 = 0
                go to 250
              endif
            endif
            uspec(ns) = ' '
            uspec(ns)(1:jj2) = ugexs(ie,je,ne)(1:jj2)
            uspec(ns)(jj2 + 1:jj2 + 1) = ' '
            uspec(ns)(jj2 + 2:jj) = ugexj(je,ne)(1:jj3)
            uspec(ns)(25:48) = ugexp(ne)(1:24)
c
c           Set up the elemental composition.
c
            nrf1 = nessr(2,nsl) + 1
            if (nss .gt. 0) then
              nr1 = nessr(1,nss)
              nr2 = nessr(2,nss)
              nrf2 = nrf1 + nr2 - nr1
            else
              nrf2 = nrf1
            endif
c
            if (nrf2 .gt. nessmx) then
              write (noutpt,1380) nessmx,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1380) nessmx,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1380         format (/' * Error - (EQLIB/intexi) The maximum ',i5,
     $        ' entries in the',/7x,'cess/ness arrays would be',
     $        ' exceeded by creating the',/7x,'exchange species',
     $        ' for ',a,' on site',/7x,a,' of exchange phase ',a,'.',
     $        ' Increase the',/7x,'dimensioning parameter nesspa.')
              stop
            endif
c
            nessr(1,ns) = nrf1
            nessr(2,ns) = nrf2
            if (nss .gt. 0) then
              k = nr1 - 1
              do n = nrf1,nrf2
                k = k + 1
                cess(n) = cfxi*cess(k)
                ness(n) = ness(k)
              enddo
            else
              n = nrf1
              cess(n) = 0.
              ness(n) = 0
            endif
c
c           Set up the corresponding reaction.
c
            nrf1 = ndrsr(2,nsl) + 1
            if (nss .gt. 0) then
c
c             Case of a non-bare site species.
c
              nrf2 = nrf1 + 2
            else
c
c             Case of the bare site species.
c
              nrf2 = nrf1
            endif
c
            if (nrf2 .gt. ndrsmx) then
              write (noutpt,1390) ndrsmx,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
              write (nttyo,1390) ndrsmx,ugexs(ie,je,ne)(1:j2),
     $        ugexj(je,ne)(1:j3),ugexp(ne)(1:j4)
 1390         format (/' * Error - (EQLIB/intexi) The maximum ',i5,
     $        ' entries in the',/7x,'cdrs/ndrs arrays would be',
     $        ' exceeded by creating the',/7x,'exchange species',
     $        ' for ',a,'on site',/7x,a,' of exchange phase ',a,'.',
     $        ' Increase the',/7x,'dimensioning parameter ndrspa.')
              stop
            endif
c
            ndrsr(1,ns) = nrf1
            ndrsr(2,ns) = nrf2
            if (nss .gt. 0) then
c
c             Case of a non-bare site species. Create a reaction in
c             which the species dissociates to the bare site species.
c
              n = nrf1
              cdrs(n) = -1.0
              ndrs(n) = ns
              n = n + 1
              cdrs(n) = cfxi
              ndrs(n) = nss
              n = n + 1
              cdrs(n) = cfxz
              ndrs(n) = nsba
            else
c
c             Case of the bare site species. Create a null reaction.
c             The bare site species then becomes a strict basis
c             species, though it doesn't actually formally correspond
c             to a chemical element.
c
              n = nrf1
              cdrs(n) = 0.
              ndrs(n) = 0
            endif
c
            if (nss .eq. 0) go to 270
c
c           Set up to the thermodynamic properties of the reaction
c           just created. This reaction should match one of the
c           existing condensed reactions.
c
            iee = ngexro(ie,je,ne)
c
c           Calculate the thermodynamic properties of the reaction.
c
            do j = 1,ntprt
              if (efx .ne. 0.) then
                afxb = efx*xlkgex(iee,je,ne)
                afhx = efx*xhfgex(iee,je,ne)
                afvx = efx*xvfgex(iee,je,ne)
              else
                afxb = xlkgex(iee,je,ne)
                afhx = xhfgex(iee,je,ne)
                afvx = xvfgex(iee,je,ne)
              endif
c
c             Here afxb is the log K value and tfxb the temperature (C)
c             at the base temperature. Use the van't Hoff relation to
c             find afx0, the log K at 0C. Approximate the van't Hoff
c             relation across the total temperature range using the
c             standard power series.
c
              bfx = -afhx/(arcnst*tfx0)
              afx0 = afxb + bfx*(tfxb/(tfxb + tfx0))
              axlks(1,j,ns) = afx0
              xx = -bfx
              do i = 2,narxt(j)
                xx = -xx/tfx0
                axlks(i,j,ns) = xx
              enddo
c
              axhfs(1,j,ns) = afhx
              axvfs(1,j,ns) = afvx
              do i = 2,narxt(j)
                axhfs(i,j,ns) = 0.
                axvfs(i,j,ns) = 0.
              enddo
            enddo
c
c           Is the aqueous species which goes onto the substrate a
c           basis species? If not, the reaction must be rewritten
c           in terms of equivalent basis species.
c
            nrf1 = ndrsr(1,ns)
            nrf2 = ndrsr(2,ns)
            do n = nrf1 + 1,nrf2
              nse = ndrs(n)
              if (nse.ge.narn1 .and. nse.le.narn2) then
c
c               Calling sequence substitutions:
c                 nse for ns
c
                nb = nbasis(nbasp,nbt,nbtmax,nse)
                if (nb .eq. 0) then
                  nbt = nbt + 1
                  if (nbt .gt. nbtmax) then
                    j6 = ilnobl(uspec(nse))
                    write (noutpt,1400) nbtmax,uspec(nse)(1:j6),
     $              ugexs(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),
     $              ugexp(ne)(1:j4)
                    write (nttyo,1400) nbtmax,uspec(nse)(1:j6),
     $              ugexs(ie,je,ne)(1:j2),ugexj(je,ne)(1:j3),
     $              ugexp(ne)(1:j4)
 1400               format (/' * Error - (EQLIB/intexi) The maximum,',
     $              i3,' basis species would be',/7x,'exceeded by',
     $              ' adding ',a,' in order to',/7x,'accomodate the',
     $              ' required setup for species ',a,/7x,'on site ',a,
     $              ' of exchange phase ',a,'.',/7x,'Increase the',
     $              ' dimensioning parameter nbtpar.')
                    stop
                  else
                    nbasp(nbt) = nse
                    jflag(nse) = 30
                  endif
                endif
              endif
            enddo
c
  270       continue
          enddo
c
c         Modify the ngexsa array if necessary so that the species
c         index of the bare site species appears in the first position
c         for the current site of the current exchange phase.
c
          do ie = 1,nspect
            nss = ngexsa(ie,je,ne)
            if (nss .eq. 0) then
              do i = 1,ie - 1
                iee = ie - i
                ngexsa(iee + 1,je,ne) = ngexsa(iee,je,ne)
              enddo
              ngexsa(1,je,ne) = 0
              go to 280
            endif
          enddo
  280     continue
c
          jern2(je,ne) = nst
          ngext(je,ne) = jern2(je,ne) - jern1(je,ne) + 1
        enddo
        ncmpr(2,np) = nst
      enddo
c
      nern2 = nst
      iern2 = npt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Pass 3. Loop on exchanger phases. Change the ordering of the
c     condensed reactions and associated data to match that of the
c     corresponding created species. Then eliminate the identity
c     reaction for the bare site species. This puts these data
c     in the desired form for writing on a pickup file.
c
c     In the example discussed above (input of a single exchange
c     reaction, Ca++ = Na+), the expanded set of condensed reactions
c     was:
c
c           1. Na+ = __
c           2. Ca++ = __
c           3. __ = __
c
c     The actual species created were processed in the order
c     __, Ca++, Na+. The bare site species is always processed first.
c     The other species are processed in order of appearance in the
c     condensed reactions read from the input file. Thus, the order of
c     creation of the corresponding reactions from the condensed
c     counterparts was:
c
c           1. (3. __ = __)
c           2. (2. Ca++ = __)
c           3. (1. Na+ = __)
c
c     Here the set of condensed reactions is changed to:
c
c           1. Ca++ = __
c           2. Na+ = __
c
c     As input, this is expanded to:
c
c           1. Ca++ = __
c           2. Na+ = __
c           3. __ = __
c
c     The actual species are then created in the same order as before,
c     (__, Ca++, Na+).
c
c     Note that less setup work is required for the case of the input
c     of two dissociation reactions than for the case of the input of
c     the single equivalent exchange reaction.
c
      do ne = 1,net
c
c       Loop on sites.
c
        do je = 1,jgext(ne)
          nspect = ngexrt(je,ne)
c
c         Re-arrange the condensed reactions so that their order
c         matches that of the local species list. This eliminates
c         the need for the ngexro pointer array to find the
c         condensed reaction for a given species in the local
c         species list.
c
          do ie = 1,nspect
            iee = ngexro(ie,je,ne)
            if (iee .ne. ie) then
c
c             Exchange positions.
c
              ustr56 = ugexr(iee,je,ne)
              ugexr(iee,je,ne) = ugexr(ie,je,ne)
              ugexr(ie,je,ne) = ustr56
              xx = xlkgex(iee,je,ne)
              xlkgex(iee,je,ne) = xlkgex(ie,je,ne)
              xlkgex(ie,je,ne) = xx
              xx = xhfgex(iee,je,ne)
              xhfgex(iee,je,ne) = xhfgex(ie,je,ne)
              xhfgex(ie,je,ne) = xx
              xx = xvfgex(iee,je,ne)
              xvfgex(iee,je,ne) = xvfgex(ie,je,ne)
              xvfgex(ie,je,ne) = xx
              do iej = 1,nspect
                if (ngexro(iej,je,ne) .eq. ie) go to 310
              enddo
  310         ngexro(iej,je,ne) = iee
              ngexro(ie,je,ne) = ie
            endif
          enddo
c
          do ie = 1,nspect
            iee = ngexso(ie,je,ne)
            if (iee .ne. ie) then
c
c             Exchange positions.
c
              ustr56 = ugexr(iee,je,ne)
              ugexr(iee,je,ne) = ugexr(ie,je,ne)
              ugexr(ie,je,ne) = ustr56
              xx = xlkgex(iee,je,ne)
              xlkgex(iee,je,ne) = xlkgex(ie,je,ne)
              xlkgex(ie,je,ne) = xx
              xx = xhfgex(iee,je,ne)
              xhfgex(iee,je,ne) = xhfgex(ie,je,ne)
              xhfgex(ie,je,ne) = xx
              xx = xvfgex(iee,je,ne)
              xvfgex(iee,je,ne) = xvfgex(ie,je,ne)
              xvfgex(ie,je,ne) = xx
              do iej = 1,nspect
                if (ngexso(iej,je,ne) .eq. ie) go to 320
              enddo
  320         ngexso(iej,je,ne) = iee
              ngexso(ie,je,ne) = ie
            endif
          enddo
c
c         Remove the identity reaction from the set of condensed
c         reactions.
c
          do ie = 1,nspect - 1
            iee = ie + 1
            ugexr(ie,je,ne) = ugexr(iee,je,ne)
            xlkgex(ie,je,ne) = xlkgex(iee,je,ne)
            xhfgex(ie,je,ne) = xhfgex(iee,je,ne)
            xvfgex(ie,je,ne) = xvfgex(iee,je,ne)
          enddo
          ie = nspect
          ugexr(ie,je,ne) = '__ = __ '
          xlkgex(ie,je,ne) = 0.
          xhfgex(ie,je,ne) = 0.
          xvfgex(ie,je,ne) = 0.
          nspect = nspect - 1
          ngexrt(je,ne) = nspect
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the cegexs array. This is an array of coefficients
c     giving the number of equivalents per mole of each exchanger
c     species. This supports the calculation of equivalent fractions.
c
      do ne = 1,net
        do je = 1,jgext(ne)
          ns = jern1(je,ne) - 1
          do ie = 1,ngext(je,ne)
            ns = ns + 1
            if (uspec(ns)(1:3) .eq. '__ ') then
            else
c
c             Have the bare site species.
c
              cegexs(ie,je,ne) = 0.
c
c             Have other than the bare site species.
c
              nr1 = ndrsr(1,ns)
              nr2 = ndrsr(2,ns)
              cx = 0.
              do n = nr1 + 1,nr2
                nse = ndrs(n)
c
c               There are contributions only from the aqueous
c               species. There is none from the bare site species,
c               which also appears in the reaction.
c
                if (nse.ge.narn1 .and. nse.le.narn2) then
                  cx = cx + cdrs(n)*zchar(nse)
                endif
              enddo
              cegexs(ie,je,ne) = cx
            endif
          enddo
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the cpgexs array. This is an array of coefficients
c     giving the number of moles of exchanger substrate (Z) per mole of
c     exchanger species (e.g., Na-Z, Ca-Z2). This supports the
c     calculation of the number of moles of the exchanger phase.
c
      do ne = 1,net
        j5 = ilnobl(ugexmo(ne))
        if (ugexmo(ne)(1:j5).eq.'Gapon' .or.
     $    ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $    ugexmo(ne)(1:j5) .eq. 'Site-mixing') then
c
c         Gapon (Gapon-?) or Site-mixing model.
c
          do je = 1,jgext(ne)
            do ie = 1,ngext(je,ne)
              cpgexs(ie,je,ne) = 1.0
            enddo
          enddo
c
        elseif (ugexmo(ne)(1:j5).eq.'Vanselow' .or.
     $    ugexmo(ne)(1:9).eq.'Vanselow-') then
c
c         Vanselow (Vanselow-?) model.
c
          do je = 1,jgext(ne)
            do ie = 1,ngext(je,ne)
              cpgexs(ie,je,ne) = cegexs(ie,je,ne)/egexjf(je,ne)
            enddo
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the kgexsa, kern1, and kern2 pointer arrays. The kgexsa
c     array contains the indices of the exchange species (e.g., Na+).
c     The latter two arrays point to the start and end of the range
c     in kgexsa corresponding to a given generic ion exchanger phase.
c     Here kgexsa(ke,ne) is the index of the ke-th species exchanging
c     on the ne-th generic ion exchanger phase.
c
      ke = 0
      do ne = 1,net
        ke1 = ke + 1
        kern1(ne) = ke1
c
        do je = 1,jgext(ne)
          do ie = 1,ngext(je,ne)
            nss = ngexsa(ie,je,ne)
c
c           Has this exchange species already been loaded because
c           because it appears in another site?
c
            do kee = ke1,ke
              nsse = kgexsa(kee,ne)
              if (nsse .eq. nss) go to 400
            enddo
c
c           Have an exchange species which has not already been
c           loaded. Load it.
c
            ke = ke + 1
            kgexsa(ke,ne) = nss
  400       continue
          enddo
        enddo
c
        kern2(ne) = ke
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine intchr(ivar,noutpt,nttyo,ustr)
c
c     This subroutine converts writes the integer variable ivar into the
c     character variable ustr, employing left justification and blank
c     fill. If right justification is desired, one should just write
c     the integer into the string.
c
c     The length of the string variable is unknown. A buffer variable
c     which is employed has a character length of ichpar. This limits
c     the size of the substring available for the input integer.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       ivar   = the input integer
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Output:
c
c       ustr   = the string variable in which the integer is to
c                  be written
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo,ivar
c
      character*(*) ustr
c
c-----------------------------------------------------------------------
c
c     Local parameter declarations.
c
      integer ichpar
c
      parameter (ichpar = 16)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,ilen
c
      integer ilnobl
c
      character*(ichpar) ux
c
c-----------------------------------------------------------------------
c
c     Write the integer into a character variable buffer.
c
      write (ux,1000,err = 100) ivar
c
c     The format below should specify an integer field which matches
c     the character length of the buffer variable (ichpar).
c
 1000 format(i16)
      go to 110
c
  100 write (noutpt,1010) ivar
      write (nttyo ,1010) ivar
 1010 format(/" * Error - (EQLIBU/intchr) Can't write the integer",
     $ /7x,'"',i16,'" into a character string due to formatted',
     $ /7x,'write error.')
      stop
c
c     Left justify.
c
  110 call lejust(ux)
c
c     Get the length of the integer string.
c
      j2 = ilnobl(ux)
c
c     Get the length of the string variable.
c
      ilen = len(ustr)
c
      if (j2 .gt. ilen) then
        write (noutpt,1020) ivar,j2,ilen
        write (nttyo ,1020) ivar,j2,ilen
 1020   format(/" * Error - (EQLIBU/intchr) Can't write the integer",
     $ /7x,'"',i16,'" into a string because the integer requires',i3,
     $ /7x,' characters, but the string variable has only ',i3,'.')
        stop
      endif
c
c     Load the string.
c
      ustr = ux(1:j2)
c
      end

      subroutine cdardx(actlg,actwlg,ah,ahrc,cdrsd,eh,ehfac,ehrc,
     $ farad,fo2lg,fo2lrc,jsflag,mosp,nbasp,nbaspd,nbt,nbtmax,ndrsd,
     $ ndrsmx,ndrsrd,no2gaq,nstmax,pe,perc,ph,xlke,xlksd)
c
c     This subroutine computes the default Eh, pe-, and Ah from the
c     default log fO2, and also computes the Eh, pe-, log fO2, and Ah
c     for each aqueous redox couple.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/cdappl.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       actlg  = array of log activities of species
c       cdrsd  = coefficients of reactions in the 'd' set
c       jsflag = array of species status flags
c       nbt    = the number of species in the basis set
c       ndrsd  = array of the indices of the species corresponding to
c                  the reaction coefficients in the cdrsd array
c       ndrsrd = array giving the range in the cdrsd and ndrsd arrays
c                  corresponding to the reaction for a given species
c       no2gaq = index of the fictive species aqueous O2(g)
c       xlke   = the log K for the "Eh" reaction
c
c     Principal output:
c
c       fo2lrc = array of couple-specific log fO2 values
c       ehrc   = array of couple-specific Eh values
c       perc   = array of couple-specific pe values
c       ahrc   = array of couple-specific Ah values
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,ndrsmx,nstmax
c
      integer jsflag(nstmax),nbasp(nbtmax),nbaspd(nbtmax),
     $ ndrsd(ndrsmx),ndrsrd(2,nstmax)
      integer nbt,no2gaq
c
      real*8 actlg(nstmax),ahrc(nbtmax),cdrsd(ndrsmx),ehrc(nbtmax),
     $ fo2lrc(nbtmax),mosp(nstmax),perc(nbtmax),xlksd(nstmax)
      real*8 actwlg,ah,eh,ehfac,farad,fo2lg,pe,ph,xlke
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nb,nr1,nr2,ns1,ns2,nse,nt
c
      real*8 ahfac,cx1,ehx,fo2lgx
c
c-----------------------------------------------------------------------
c
      ahfac = 0.001*farad
c
      do nb = 1,nbt
        fo2lrc(nb) = fo2lg
        ehrc(nb) = eh
        perc(nb) = pe
        ahrc(nb) = ah
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (jsflag(ns2) .ne. 0) go to 110
        nt = ndrsrd(2,ns1) - ndrsrd(1,ns1) + 1
        if (nt .lt. 2) go to 110
c
c       Test the reaction read from the data file to see if it contains
c       an entry for O2(g).
c
c       Calling sequence substitutions:
c         cdrsd for cdrs
c         ndrsd for ndrs
c         ndrsrd for ndrsr
c         no2gaq for nse
c         ns1 for ns
c
        cx1 = coefdr(cdrsd,ndrsd,ndrsmx,ndrsrd,no2gaq,ns1,nstmax)
        if (cx1 .eq. 0.) go to 110
c
        if (xlksd(ns1) .lt. 9999999.) then
          fo2lgx = xlksd(ns1)
          nr1 = ndrsrd(1,ns1)
          nr2 = ndrsrd(2,ns1)
          do n = nr1,nr2
            nse = ndrsd(n)
            if (nse .le. 0) go to 110
            if (nse .ne. no2gaq) then
              if (mosp(nse) .le. 0.) go to 110
              fo2lgx = fo2lgx - cdrsd(n)*actlg(nse)
            endif
          enddo
          fo2lgx = fo2lgx/cx1
          ehx = (ehfac/4.)*(fo2lgx - 4.*ph - 2.*actwlg - xlke)
c
          fo2lrc(nb) = fo2lgx
          ehrc(nb) = ehx
          perc(nb) = ehx/ehfac
          ahrc(nb) = ahfac*ehx
        endif
  110   continue
      enddo
c
      end

      subroutine chkinz(ier,imchmx,imech,iopt,jcode,kmax,kxt,nelect,
     $ noptmx,noutpt,no2gaq,nrct,nrctmx,nrk,nstmax,nttyo,rkb,ureac,
     $ uspeca,uzveci,zvclgi)
c
c     This subroutine checks the code input for various kinds of
c     errors and inconsistencies. Here ier accumulates the
c     number of errors caught.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,kmax,noptmx,nrctmx,nstmax
c
      integer noutpt,nttyo
c
      integer imech(2,nrctmx),iopt(noptmx),jcode(nrctmx),nrk(2,nrctmx)
c
      integer ier,kxt,nelect,no2gaq,nrct
c
      character*48 uspeca(nstmax),uzveci(kmax)
      character*24 ureac(nrctmx)
c
      real*8 rkb(imchmx,2,nrctmx),zvclgi(kmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,jlen,j2,kcol,nrc
c
      integer ilnobl
c
      character*56 uspn56
c
c-----------------------------------------------------------------------
c
      ier = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Rate law data.
c
c       nrk(1,nrc)= forward rate law code:
c
c         -1 = Use the backward rate law form (legal only if
c              nrk(2,nrc) = 2)
c          0 = Illegal value
c          1 = Relative rate
c          2 = Transition state theory net rate
c          3 = Linear rate
c
c       For the case nrk(1,nrc) = 2, the reactant must be
c       either a pure mineral (jcode = 0) or a solid solution
c       (jcode = 1).
c
c       nrk(2,nrc)= backward rate law code:
c
c         -1 = Use the forward rate law form (legal only if
c              nrk(1,nrc) = 2)
c          0 = No rate law specified; the reaction may be controlled
c              by partial equilibrium.
c          1 = Relative rate
c          2 = Transition state theory net rate
c          3 = Linear rate
c
c       For the case nrk(2,nrc) = 2, the reactant must be
c       either a pure mineral (jcode = 0) or a solid solution
c       (jcode = 1)
c
      do nrc = 1,nrct
        j2 = ilnobl(ureac(nrc))
c
        if (iopt(2) .le. 0) then
c
c         Check for rate law choices that can't be used without
c         an explicit time frame.
c
          if (nrk(2,nrc) .ge. 2) then
            write (noutpt,1000) ureac(nrc)(1:j2),nrk(2,nrc)
            write (nttyo,1000) ureac(nrc)(1:j2),nrk(2,nrc)
 1000       format(/' * Error - (EQ6/chkinz) The forward rate law code',
     $      /7x,'for ',a,' is ',i2,', which is not valid',
     $      /7x,'unless iopt(2) = 1 (the model has a time frame).')
            ier = ier + 1
          endif
c
          if (nrk(2,nrc) .ge. 2) then
            write (noutpt,1010) ureac(nrc)(1:j2),nrk(2,nrc)
            write (nttyo,1010) ureac(nrc)(1:j2),nrk(2,nrc)
 1010       format(/' * Error - (EQ6/chkinz) The backward rate law',
     $      ' code',/7x,'for ',a,' is ',i2,', which is not valid',
     $      /7x,'unless iopt(2) = 1 (the model has a time frame).')
            ier = ier + 1
          endif
        endif
c
c       Check for invalid forward and backward rate law combinations.
c       The following combinations are invalid:
c
c         nrk(1,nrc) = 1 and nrk(2,nrc) = 1
c         nrk(1,nrc) = 3 and nrk(2,nrc) = 3
c         nrk(1,nrc) = -1 and nrk(2,nrc) is not 2
c         nrk(2,nrc) = 0
c
c
        if (nrk(1,nrc).eq.1 .and. nrk(2,nrc).eq.1) then
          write (noutpt,1020) ureac(nrc)(1:j2)
          write (nttyo,1020) ureac(nrc)(1:j2)
 1020     format(' * Error - (EQ6/chkinz) The forward and backward',
     $    /7x,'rate law codes for ',a,' are both 1, which is not a',
     $    /7x,'valid combination.')
          ier = ier + 1
        endif
c
        if (nrk(1,nrc).eq.3 .and. nrk(2,nrc).eq.3) then
          write (noutpt, 1030) ureac(nrc)(1:j2)
          write (nttyo, 1030) ureac(nrc)(1:j2)
 1030     format(' * Error - (EQ6/chkinz) The forward and backward',
     $    /7x,'rate law codes for ',a,' are both 3, which is not a',
     $    /7x,'valid combination.')
          ier = ier + 1
        endif
c
        if (nrk(1,nrc) .eq. -1) then
          if (nrk(2,nrc) .ne. 2) then
            write (noutpt, 1040) ureac(nrc)(1:j2)
            write (nttyo, 1040) ureac(nrc)(1:j2)
 1040       format(' * Error - (EQ6/chkinz) The forward rate law code',
     $      /7x,'for ',a,' is -1, which is not a valid value  unless',
     $      /7x,'the backward rate law code is 2.')
            ier = ier + 1
          endif
        endif
c
        if (nrk(1,nrc) .eq. 0) then
          write (noutpt,1050) ureac(nrc)(1:j2)
          write (nttyo,1050) ureac(nrc)(1:j2)
 1050     format(' * Error - (EQ6/chkinz) The forward rate law code',
     $    /7x,'for ',a,' is 0, which is not a valid value.')
          ier = ier + 1
        endif
c
c       Check the parameters for the forward rate laws.
c
        if (nrk(1,nrc) .eq. 2) then
c
c         Transition state theory.
c
          do i = 1,imech(1,nrc)
            if (rkb(i,1,nrc) .lt. 0.) then
              write (noutpt,1060) i,rkb(i,1,nrc),ureac(nrc)(1:j2),
     $        nrk(1,nrc)
              write (nttyo,1060) i,rkb(i,1,nrc),ureac(nrc)(1:j2),
     $        nrk(1,nrc)
 1060         format (/' * Error - (EQ6/chkinz) Forward rate constant',
     $        /7x,i2,' has a value of ',1pe11.4,' for reactant'
     $        /7x,a,'. A negative rate constant is not valid for a',
     $        /7x,'forward rate code of ',i2,'.')
              ier = ier + 1
            endif
          enddo
c
          if (jcode(nrc) .gt. 1) then
            write (noutpt,1070) nrk(1,nrc),ureac(nrc)(1:j2)
            write (nttyo,1070) nrk(1,nrc),ureac(nrc)(1:j2)
 1070       format(/' * Error - (EQ6/chkinz) Have specified a',
     $      /7x,'forward rate law code of ',i2,' for reactant',
     $      /7x,a,'. This rate law incorporates an affinity',
     $      /7x,'dependence and can only be used for a reactant which',
     $      /7x,'is a mineral or solid solution.')
            ier = ier + 1
          endif
        elseif (nrk(1,nrc) .eq. 3) then
c
c         Linear rate law
c
          if (rkb(1,1,nrc) .lt. 0.) then
            write (noutpt,1060) i,rkb(1,1,nrc),ureac(nrc)(1:j2),
     $      nrk(1,nrc)
            write (nttyo,1060) i,rkb(1,1,nrc),ureac(nrc)(1:j2),
     $      nrk(1,nrc)
            ier = ier + 1
          endif
        endif
c
c       Check the parameters for the backward rate laws.
c
        if (nrk(2,nrc) .eq. -1) then
c
c         Use the forward rate law for the backward case.
c
          if (nrk(1,nrc) .ne. 2) then
            write (noutpt,1080) ureac(nrc)(1:j2),nrk(1,nrc)
            write (nttyo,1080) ureac(nrc)(1:j2),nrk(1,nrc)
 1080       format(' * Error - (EQ6/chkinz) The backward rate law',
     $      /7x,'code for ',a,' is  -1, which is invalid because',
     $      /7x,'the forward rate law code is ',i2,'.')
            ier = ier + 1
          endif
        elseif (nrk(2,nrc) .eq. 2) then
c
c         Transition state rate law.
c
          do i = 1,imech(2,nrc)
            if (rkb(i,2,nrc) .lt. 0.) then
              write (noutpt,1090) i,rkb(i,2,nrc),ureac(nrc)(1:j2),
     $        nrk(2,nrc)
              write (nttyo,1090) i,rkb(i,2,nrc),ureac(nrc)(1:j2),
     $        nrk(2,nrc)
 1090         format (/' * Error - (EQ6/chkinz) Backward rate constant',
     $        /7x,i2,' has a value of ',1pe11.4,' for reactant'
     $        /7x,a,'. A negative rate constant is not valid for a',
     $        /7x,'forward rate code of ',i2,'.')
              write (noutpt,1060) ureac(nrc)(1:j2)
              write (nttyo,1060) ureac(nrc)(1:j2)
              ier = ier + 1
            endif
          enddo
c
          if (jcode(nrc) .gt. 1) then
            write (noutpt,1100) nrk(2,nrc),ureac(nrc)(1:j2)
            write (nttyo,1100) nrk(2,nrc),ureac(nrc)(1:j2)
 1100       format(/' * Error - (EQ6/chkinz) Have specified a',
     $      /7x,'backward rate law code of ',i2,' for reactant',
     $      /7x,a,'. This rate law incorporates an affinity',
     $      /7x,'dependence and can only be used for a reactant which',
     $      /7x,'is a mineral or solid solution.')
            write (noutpt,1070)
            write (nttyo,1070)
            ier = ier + 1
          endif
c
        elseif (nrk(2,nrc) .eq. 3) then
c
c         Linear  rate law.
c
          if (rkb(1,2,nrc) .lt. 0.) then
            write (noutpt,1090) i,rkb(1,2,nrc),ureac(nrc)(1:j2),
     $      nrk(2,nrc)
            write (nttyo,1090) i,rkb(1,2,nrc),ureac(nrc)(1:j2),
     $      nrk(2,nrc)
            ier = ier + 1
          endif
c
          if (jcode(nrc) .gt. 1) then
            if (nrk(1,nrc).eq.3 .or. nrk(1,nrc).eq.1) then
              write (noutpt,1110) ureac(nrc)(1:j2),nrk(1,nrc)
              write (nttyo,1110) ureac(nrc)(1:j2),nrk(1,nrc)
 1110         format(' * Error - (EQ6/chkinz) The forward rate law',
     $        /7x,'code for reactant ',a,' may not be 3 if the',
     $        /7x,'backward rate law code is',i2,'. This is permitted',
     $        /7x,'only for a reactant which is a pure mineral or',
     $        /7x,'a solid solution..')
              ier = ier + 1
            endif
          endif
c
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix variable values.
c
c        zvclgi = logarithmic basis variable, starting estimate
c           or pick-up value
c
      do kcol = 1,kxt
        if (zvclgi(kcol) .le. -99999.) then
          if (uzveci(kcol)(1:8).ne.uspeca(no2gaq)(1:8) .and.
     $      uzveci(kcol)(1:8).ne.uspeca(nelect)(1:8)) then
            call fmspnx(jlen,uzveci(kcol),uspn56)
            write (noutpt,1200) uspn56(1:jlen)
            write (nttyo,1200) uspn56(1:jlen)
 1200       format(/' * Error - (EQ6/chkinz) The basis species ',a,
     $      /7x,'has a log number of moles (zvclgi) value less than',
     $      ' or equal to -99999.',/7x,'on the input file.')
            ier = ier + 1
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine jgibbs(aamatr,afcnst,affp,cdrs,cscale,csts,delvec,
     $ eps100,gmmatr,iindx1,iodb,ipivot,ipndx1,jpflag,kbt,kdim,kmax,
     $ km1,kmt,kx1,kxt,mtb,nbasp,nbtmax,ndrs,ndrsmx,ndrsr,nodbmx,
     $ noutpt,npadd,npdel,nptmax,nstmax,nsts,nstsmx,nstsr,nttyo,
     $ rhsvec,uphase,uspec,xlks)
c
c     This subroutine determines which one of a set of phases should be
c     removed from the equilibrium system when there is a mineralogic
c     phase rule violation. It has not yet been extended to handle
c     solid solutions.
c
c     It is assumed heres that a mineralogical phase rule violation
c     does in fact exist. This subroutine does not make an independent
c     confirmation.
c
c     This subroutine is called by:
c
c       EQ6/eqcalc.f.
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       npadd  = index of the last phase added to the equilibrium
c                  phase assemblage
c
c     Principal output:
c
c       npdel = index of the phase which should be deleted from the
c                 equilibrium phase assemblage in order to resolve
c                 the violation
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nodbmx,nptmax,nstmax,nstsmx
c
      integer noutpt,nttyo
c
      integer iindx1(kmax),iodb(nodbmx),ipivot(kmax),ipndx1(kmax),
     $ jpflag(nptmax),nbasp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer kbt,kdim,km1,kmt,kx1,kxt,npadd,npdel
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 aamatr(kmax,kmax),affp(nptmax),cdrs(ndrsmx),
     $ cscale(nstmax),csts(nstsmx),delvec(kmax),gmmatr(kmax,kmax),
     $ mtb(nbtmax),rhsvec(kmax),xlks(nstmax)
c
      real*8 afcnst,eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensions.
c
      integer isv_kmax
c
      SAVE isv_kmax
c
      integer, dimension(:), allocatable :: kmprv,ksprv
c
      SAVE kmprv,ksprv
c
      real(8), dimension(:), allocatable :: cscx
c
      SAVE cscx
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,idim,ier,irow1,irow2,j,jcol1,jcol2,jdim,j2,j3,j4,k,
     $ kcol,km,kmm,kp,kpadd,kpp,kpt,n,nb,np,npp,nr1,nr2,ns,nse,nss
c
      integer ilnobl
c
      logical qldep,qpr
c
      real*8 acx,acx2,affc,affmin,afscal,cx,mxx,mxxe,mxxm
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      data qpr    /.false./
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(kmprv)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_kmax = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (kmax .ne. isv_kmax) then
          DEALLOCATE(kmprv)
          DEALLOCATE(ksprv)
          DEALLOCATE(cscx)
          isv_kmax = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_kmax .eq. 0) then
        ALLOCATE(kmprv(kmax),ksprv(kmax))
        ALLOCATE(cscx(kmax))
        isv_kmax = kmax
      endif
c
c     Zero the contents of the local work arrays.
c
      do k = 1,kmax
        kmprv(k) = 0
        ksprv(k) = 0
      enddo
c
      do k = 1,kmax
        cscx(k) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .gt. 0) then
        if (kxt .ge. kx1) then
          write (noutpt,1000)
          write (nttyo,1000)
 1000     format(/' * Note - (EQ6/jgibbs) This subroutine finds the',
     $    ' phases or phases',/7x,'involved in a violation of the',
     $    ' mineralogic phase rule, but it',/7x,'presently considers',
     $    ' only pure minerals in the analysis.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Clear the Jacobian matrix for use as workspace.
c
      do i = 1,kdim
        do j = 1,kdim
          aamatr(i,j) = 0.
        enddo
      enddo
c
      do i = 1,kbt + 1
        kmprv(i) = 0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find the phases which are directly involved in the mineralogic
c     phase rule violation. For each possible phase, test to see if
c     the violation disappears when the phase is removed from the
c     tested assemblage.
c
      kpt = 0
      do km = km1,kmt
        ns = iindx1(km)
c
c       For each of the other minerals involved in the current
c       assemblage, set up a corresponding row which contains the
c       reaction coefficients of the basis species.
c
        idim = 0
        do kmm = km1,kmt
          if (kmm .ne. km) then
            nss = iindx1(kmm)
            idim = idim + 1
            do j = 1,kbt
              nb = iindx1(j)
              nse = nbasp(nb)
c
c             Calling sequence substitutions:
c               nss for ns
c
              cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,nss,nstmax)
              aamatr(idim,j) = cx
            enddo
          endif
        enddo
c
c       Test for linear dependence.
c
        irow1 = 1
        irow2 = idim
        jcol1 = 1
        jcol2 = kbt
        call lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,qldep)
c
        if (.not.qldep) then
c
c         Have not obtained linear dependence. The phase being tested
c         is involved in the violation. Note its matrix index in the
c         kmprv array.
c
          kpt = kpt + 1
          kmprv(kpt) = km
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kpt .ge. 1) then
        write (noutpt,1050)
        write (nttyo,1050)
 1050   format(/' * Note - (EQ6/jgibbs) The phases involved in the',
     $  ' mineralogic',/7x,'phase rule violation are:',/)
c
        do kp = 1,kpt
          km = kmprv(kp)
          ns = iindx1(km)
          np = ipndx1(km)
          j2 = ilnobl(uphase(np))
          write (noutpt,1060) np,uphase(np)(1:j2)
          write (nttyo,1060) np,uphase(np)(1:j2)
 1060     format(2x,i5,2x,a)
        enddo
c
        if (kpt .eq. 1) then
          write (noutpt,1070)
          write (nttyo,1070)
 1070     format(/' * Error (EQ6/jgibbs) Programming error trap:',
     $    ' Have a supposed',/7x,'mineralogical phase rule violation',
     $    ' involving only one phase.')
          stop
        endif
      else
        write (noutpt,1080)
        write (nttyo,1080)
 1080   format(/' * Error (EQ6/jgibbs) Programming error trap:',
     $  ' Have a supposed',/7x,'mineralogical phase rule violation',
     $  ' involving no phases.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now determine the affinity of each involved phase under the
c     assumption that the solution is saturated with respect to
c     the others.
c
      do kp = 1,kpt
        km = kmprv(kp)
        ns = iindx1(km)
        np = ipndx1(km)
        if (iodb(1) .gt. 0) then
c
          j2 = ilnobl(uphase(np))
          write (noutpt,1090) uphase(np)(1:j2)
 1090     format(/1x,'Hypothetical affinity calculation for ',a,':')
c
          write (noutpt,1100)
 1100     format(/3x,'Cognate minerals:',/)
          do kpp = 1,kpt
            if (kpp .ne. kp) then
              kmm = kmprv(kpp)
              npp = ipndx1(kmm)
              j3 = ilnobl(uphase(npp))
              write (noutpt,1110) uphase(npp)(1:j3)
 1110         format(5x,a)
            endif
          enddo
        endif
c
c       Once again, clear the Jacobian matrix for use as workspace.
c
        do i = 1,kdim
          do j = 1,kdim
            aamatr(i,j) = 0.
          enddo
        enddo
c
c       For each of the other minerals involved in the violation,
c       set up a corresponding row which contains the reaction
c       coefficients of the basis species. The objective is to
c       find a set of such coefficients which does not exhibit linear
c       dependence. Such dependence is possible because the number of
c       basis species appearing in these reactions may exceed the
c       number of "other" minerals. For example, if three ferric iron
c       minerals are present in the violating assemblage, Fe+++ is
c       a dependent species, and Fe++ is the strict basis species for
c       iron, then the reactions will be written in terms of O2(g), H+,
c       H2O, and Fe++ instead of in terms of Fe+++. Depending on what
c       is exactly in a given set, one or more of O2(g), H+, and H2O
c       may be redundant in terms of relating the current mineral to
c       to the current set of other minerals involved in the violation.
c
        do i = 1,kbt
          ksprv(i) = 0
        enddo
c
        idim = 0
        do kpp = 1,kpt
          if (kpp .ne. kp) then
            kmm = kmprv(kpp)
            nss = iindx1(kmm)
            idim = idim + 1
            do j = 1,kbt
              nb = iindx1(j)
              nse = nbasp(nb)
c
c             Calling sequence substitutions:
c               nss for ns
c
              cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,nss,nstmax)
              aamatr(idim,j) = cx
            enddo
          endif
        enddo
c
c       Factor the rows.
c
        irow1 = 1
        irow2 = idim
        jcol1 = 1
        jcol2 = kbt
        call lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,qldep)
c
        if (qldep) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1120) uphase(np)(1:j2)
          write (nttyo,1120) uphase(np)(1:j2)
 1120     format(/' * Error (EQ6/jgibbs) Programming error trap:',
     $    " Couldn't find a",/7x,'set of independent basis species',
     $    ' reaction coefficients needed',/7x,'to calculate the',
     $    ' hypothetical affinity of ',a,',',/7x,'which is involved',
     $    ' in a violation of the mineralogic phase rule.',/7x,
     $    'Previous testing should guarantee the existence of such',
     $    ' a set.',/7x,'Factoring shows linear dependence.')
          stop
        endif
c
        jdim = 0
        do i = 1,idim
          do kcol = jdim + 1,kbt
            if (abs(aamatr(i,kcol)) .ne. 0.) then
              jdim = jdim + 1
              ksprv(jdim) = kcol
              go to 100
            endif
          enddo
  100     continue
        enddo
c
        if (jdim .ne. idim) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1130) uphase(np)(1:j2),jdim,idim
          write (nttyo,1130) uphase(np)(1:j2),jdim,idim
 1130     format(/' * Error (EQ6/jgibbs) Programming error trap:',
     $    " Couldn't find a",/7x,'set of independent basis species',
     $    ' reaction coefficients needed',/7x,'to calculate the',
     $    ' hypothetical affinity of ',a,',',/7x,'which is involved',
     $    ' in a violation of the mineralogic phase rule.',/7x,
     $    'Previous testing should guarantee the existence of such',
     $    ' a set.',/7x,'Found ',i3,' independent species for ',i3,
     $    ' "other" phases.')
          stop
        endif
c
        if (iodb(1) .gt. 0) then
          write (noutpt,1140)
 1140     format(/3x,'Cognate independent basis species:',/)
          do j = 1,jdim
            kcol = ksprv(j)
            nb = iindx1(kcol)
            nse = nbasp(nb)
            j4 = ilnobl(uspec(nse))
            write (noutpt,1110) uspec(nse)(1:j4)
          enddo
        endif
c
c       Write the matrix for calculating the hypothetical affinity.
c
        j = 0
        do kpp = 1,kpt
          if (kpp .ne. kp) then
            kmm = kmprv(kpp)
            nss = iindx1(kmm)
            j = j + 1
            do i = 1,idim
              kcol = ksprv(i)
              nb = iindx1(kcol)
              nse = nbasp(nb)
c
c             Calling sequence substitutions:
c               nss for ns
c
              cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,nss,nstmax)
              aamatr(i,j) = cx
            enddo
          endif
        enddo
c
c       Write the right-hand-side vector for calculating the
c       hypothetical affinity.
c
        do j = 1,jdim
          kcol = ksprv(j)
          nb = iindx1(kcol)
          nse = nbasp(nb)
          cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
          rhsvec(j) = cx
        enddo
c
        if (iodb(1) .gt. 0) then
          write (noutpt,1150)
 1150     format(/3x,'Matrix:',/)
          do i = 1,idim
            write (noutpt,1160) (aamatr(i,j), j = 1,jdim)
 1160       format(5x,5(1pe10.3,2x),e10.3)
          enddo
c
          write (noutpt,1170)
 1170     format(/3x,'RHS vector:',/)
          do j = 1,jdim
            write (noutpt,1180) rhsvec(j)
 1180       format(5x,1pe10.3)
          enddo
        endif
c
c       Calling sequence substitutions:
c         idim for kdim
c
        call msolvr(aamatr,delvec,gmmatr,ier,ipivot,idim,kmax,
     $  noutpt,nttyo,qpr,rhsvec)
c
        if (ier .gt. 0) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1220) uphase(np)(1:j2)
          write (nttyo,1220) uphase(np)(1:j2)
 1220     format(/" * Error (EQ6/jgibbs) Can't resolve a violation of",
     $    ' the mineralogical',/7x,'phase rule involving ',a,' because',
     $    ' of a failure',/7x,'in the calculation of the hypothetical',
     $    ' affinity of this phase',/7x,'in the presence of the',
     $    ' other phases involved in the violation.',/7x,"Couldn't",
     $    ' solve the requisite matrix equation.')
          stop
        endif
c
        if (iodb(1) .gt. 0) then
          write (noutpt,1230)
 1230     format(/3x,'The interphase reaction is:',/)
          cx = 1.0
          j2 = ilnobl(uphase(np))
          write (noutpt,1240) cx,uphase(np)(1:j2)
 1240     format(4x,f7.3,2x,a)
          j = 0
          do kpp = 1,kpt
            if (kpp .ne. kp) then
              kmm = kmprv(kpp)
              npp = ipndx1(kmm)
              j = j + 1
              cx = delvec(j)
              if (cx .lt. 0.) then
                acx = -cx
                j3 = ilnobl(uphase(npp))
                write (noutpt,1250) acx,uphase(npp)(1:j3)
 1250           format(2x,'+ ',f7.3,2x,a)
              endif
            endif
          enddo
          write (noutpt,1260)
 1260     format(10x,'==')
          j = 0
          do kpp = 1,kpt
            if (kpp .ne. kp) then
              kmm = kmprv(kpp)
              npp = ipndx1(kmm)
              j = j + 1
              cx = delvec(j)
              if (cx .gt. 0.) then
                j3 = ilnobl(uphase(npp))
                write (noutpt,1250) cx,uphase(npp)(1:j3)
              endif
            endif
          enddo
        endif
c
        affc = -xlks(ns)
        j = 0
        do kpp = 1,kpt
          if (kpp .ne. kp) then
            j = j + 1
            kmm = kmprv(kpp)
            nss = iindx1(kmm)
            affc = affc + xlks(nss)*delvec(j)
          endif
        enddo
        affp(np) = afcnst*affc
c
        if (iodb(1) .gt. 0) then
          j2 = ilnobl(uphase(np))
          write (noutpt,1270) uphase(np)(1:j2),affp(np)
 1270     format(/3x,'The hypothetical affinity for ',a,' is ',f10.5,/)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Only phases with negative affinities are candidates to be
c     dropped. It is guaranteed that the last phase added will
c     not be one of these. The best approach to affinity scaling
c     is to find the phase which is limiting with respect to how
c     many moles can be created of the last phase added.
c
      kpadd = 0
      do kp = 1,kpt
        km = kmprv(kp)
        np = ipndx1(km)
        if (np .eq. npadd) then
          kpadd = kp
          go to 110
        endif
      enddo
c
      write (noutpt,1280)
      write (nttyo,1280)
 1280 format(/" * Note (EQ6/jgibbs) Don't know which phase was the",
     $ ' last one added'/7x,'to the ES phase assemblage. This',
     $ ' datum is needed to generate',/7x,'the optimum choice of',
     $ ' phase to delete from the assemblage',/7x,'to resolve the',
     $ ' present mineralogical phase rule violation.',/7x,'Will',
     $ ' generate a phase to delete using the available data.')
c
  110 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kpadd .eq. 0) then
c
c       Use the regular affinity scaling factors.
c
        do kp = 1,kpt
          km = kmprv(kp)
          ns = iindx1(km)
          cscx(kp) = cscale(ns)
        enddo
      else
c
c       Normalize the inter-phase reaction so that the last phase
c       added has a reaction coefficient of -1.0. Note that the
c       reaction at this point is set up for the last phase involved
c       in the violation.
c
        delvec(kpt) = -1.0
        cx = delvec(kpadd)
        if (cx .lt. 0.) cx = -cx
        do kp = 1,kpt
          delvec(kp) = delvec(kp)/cx
        enddo
c
c       Calculate the maximum possible mass of each phase. Define
c       the scaling factor as equivalent to the maximum number
c       of mole equivalents of the last phase added.
c
        do kp = 1,kpt
          cscx(kp) = 1.
          km = kmprv(kp)
          ns = iindx1(km)
          np = ipndx1(km)
          mxxm = 1.e+38
          nr1 = nstsr(1,ns)
          nr2 = nstsr(2,ns)
          do n = nr1,nr2
            nb = nsts(n)
            cx = csts(n)
            mxx = mtb(nb)
            if (mxx.gt.0. .and. cx.gt.0.) then
              mxxe = mxx/cx
              if (mxxe .lt. mxxm) mxxm = mxxe
            endif
          enddo
          acx = abs(delvec(kp))
          acx2 = acx*acx
c
c         Note: dividing mxxm by acx once gives the maximum number
c         of mole equivalents of the last phase addded. Dividing
c         mxmm by acx a second time is the equivalent of multiplying
c         the hypothetical affinity by the same factor, which normalizes
c         the affinities with respect to the corresponding reaction
c         stoichiometries. Such normalization causes each of the
c         hypothetical affinities to take on the same magnitude.
c
          cscx(kp) = mxxm/acx2
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .gt. 0) then
        if (kpadd .gt. 0) then
c
c         Write an example of the linking inter-phase reaction such
c         that the last phase added is on the right hand side. It is
c         presently on the left hand side, so reverse the reaction
c         coefficients.
c
          do kp = 1,kpt
            delvec(kp) = -delvec(kp)
          enddo
c
          write (noutpt,1340)
 1340     format(//3x,'The phases are linked by the reaction:',/)
c
          j = 0
          do kp = 1,kpt
            km = kmprv(kp)
            np = ipndx1(km)
            cx = delvec(kp)
            if (cx .lt. 0.) then
              acx = -cx
              j3 = ilnobl(uphase(np))
              if (j .eq. 0) then
                write (noutpt,1350) acx,uphase(np)(1:j3)
 1350           format(4x,f7.3,2x,a)
                j = j + 1
              else
                write (noutpt,1360) acx,uphase(np)(1:j3)
 1360           format(2x,'+ ',f7.3,2x,a)
              endif
            endif
          enddo
          write (noutpt,1370)
 1370     format(10x,'==')
          do kp = 1,kpt
            km = kmprv(kp)
            np = ipndx1(km)
            cx = delvec(kp)
            if (cx .gt. 0.) then
              j3 = ilnobl(uphase(np))
              write (noutpt,1360) cx,uphase(np)(1:j3)
            endif
          enddo
          write (noutpt,1380)
 1380     format(1x)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1) .gt. 0) then
c
c       Write a table of the results.
c
        write (noutpt,1420)
 1420   format(/8x,'Phase',22x,'Affinity',2x,'Scale Factor',2x,
     $  'Scaled Affinity',/)
        do kp = 1,kpt
          km = kmprv(kp)
          np = ipndx1(km)
          afscal = affp(np)/cscx(kp)
          write (noutpt,1430) uphase(np),affp(np),cscx(kp),afscal
 1430     format(6x,a24,3x,f10.5,3x,1pe10.3,3x,e10.3)
        enddo
        if (kpadd .eq. 0) then
          write (noutpt,1440)
 1440     format(/3x,'Scaling employs the regular affinity scaling',
     $    ' factors.',/)
        else
          j2 = ilnobl(uphase(npadd))
          write (noutpt,1450) uphase(npadd)(1:j2)
 1450     format(/3x,'Scaling is based on stoichiometric normalization',
     $    ' of the reactions',/3x,'from which the hypothetical',
     $    ' affinities are calculated and on the',/3x,'maximum number',
     $    ' of mole equivalents of each phase in terms of',/3x,a,
     $    ', the last phase added to the ES phase assemblage.',/)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the candidate to drop from the equilibrium phase
c     assemblage.
c
      npdel = 0
      affmin = 0.
      do kp = 1,kpt
        km = kmprv(kp)
        np = ipndx1(km)
        afscal = affp(np)/cscx(kp)
        if (afscal .lt. affmin) then
          if (affmin.ge.0. .or. npadd.ne.np) then
            affmin = afscal
            npdel = np
          endif
        endif
      enddo
c
      if (npdel .le. 0) then
        j2 = ilnobl(uphase(npdel))
        write (noutpt,1480) uphase(npdel)(1:j2)
        write (nttyo,1480) uphase(npdel)(1:j2)
 1480   format(/' * Error (EQ6/jgibbs) Programming error trap:',
     $  " Couldn't find",/7x,'a candidate phase to delete to',
     $  ' resolve the mineralogical',/7x,'phase rule violation.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chdxgz(delxi,dlxmx0,fdlim,fdzv0,iodb,iopt,jordlm,
     $ kdim,kmax,km1,kord,kxt,nodbmx,noptmx,nordmx,nordz,noutpt,
     $ nrd1mx,nsscmx,scalim,scfcz,sscrew,qmin,smp100,uzvec1,zklogu,
     $ zvec0,zvclg0)
c
c     This subroutine chooses a step size and order according to the
c     Gear accuracy criterion, examining the z vector and its
c     associated finite differences. Subroutine chdxgr.f performs
c     the same function for the r vector and its associated finite
c     differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nodbmx,noptmx,nordmx,nrd1mx,nsscmx
c
      integer noutpt
c
      integer iodb(nodbmx),iopt(noptmx)
c
      integer jordlm,kdim,km1,kord,kxt,nordz
c
      logical qmin
c
      character(len=48) uzvec1(kmax)
c
      real(8) fdzv0(nrd1mx,kmax),sscrew(nsscmx),zvclg0(kmax),zvec0(kmax)
c
      real(8) delxi,dlxmx0,fdlim,scalim,scfcz,smp100,zklogu
c
c-----------------------------------------------------------------------
c
c     Local variable declarations with global dimensions.
c
      integer isv_nordmx
c
      SAVE isv_nordmx
c
      integer, dimension(:), allocatable :: kkk
c
      SAVE kkk
c
      character(len=24), dimension(:), allocatable :: uscal
c
      SAVE uscal
c
      real(8), dimension(:), allocatable :: scmax,scraw
c
      SAVE scmax,scraw
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ip1,j2,j3,k,kcol,kcoli
c
      integer ilnobl
c
      character(len=24) ubas,uzt,uzn
c
      real*8 adx,delchg,dlxii,fctr,fctrmn,lxx0,mxx0,relchg,xip1
c
c-----------------------------------------------------------------------
c
      data ubas /'Basis variable          '/
c
c-----------------------------------------------------------------------
c
c     Allocate or reallocate local work arrays as needed.
c
      if (.not.ALLOCATED(kkk)) then
c
c       Local work arrays are not allocated. Zero the saved
c       array size variables. Note that only one array is tested
c       to see if it is allocated. It is assumed that all local
c       work arrays are either allocated or not.
c
        isv_nordmx = 0
      else
c
c       Local work arrays are allocated. Check to see if any of the
c       array size variables have changed. If so, deallocate
c       the corresponding local work arrays and zero the corresponding
c       saved size variables.
c
        if (nordmx .ne. isv_nordmx) then
          DEALLOCATE(kkk,uscal,scmax,scraw)
          isv_nordmx = 0
        endif
      endif
c
c     At this point, the saved array size values are zero if the
c     corresponding arrays need to be allocated.
c
      if (isv_nordmx .eq. 0) then
        ALLOCATE(kkk(0:nordmx))
        ALLOCATE(uscal(0:nordmx))
        ALLOCATE(scmax(0:nordmx),scraw(0:nordmx))
        isv_nordmx = nordmx
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero the contents of the local work arrays.
c
      do k = 0,nordmx
        kkk(k) = 0
      enddo
c
      do k = 0,nordmx
        uscal(k) = ' '
      enddo
c
      do k = 0,nordmx
        scmax(k) = 0.
        scraw(k) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kord .le. 0) then
        nordz = 0
        scfcz = dlxmx0/delxi
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the regular choice of orders. Here i is the order, which
c     technically runs from 0 to jordlm. Here jordlm + 1 is the hidden
c     extra order, which is used to constrain the error in using order
c     jordlm.
c
      do i = 0,jordlm
        scmax(i) = 0.
        scraw(i) = 0.
      enddo
c
c     For i = 0, take delxi = dlxmx0. This keeps delxi greater
c     than or equal to dlxmx0, except within searches, as for phase
c     boundaries.
c
      scmax(0) = dlxmx0/delxi
      scraw(0) = scmax(0)
      kkk(0) = 0
      uscal(0) = 'None'
c
c     Process the higher orders.
c
      do i = 1,jordlm
        ip1 = i + 1
        dlxii = delxi**(ip1)
        fctrmn = 1.e+38
        kkk(i) = 0
        uscal(i) = 'None'
c
c       Constrain the step size to satisfy the tolerance on the
c       fractional error of matrix variables.
c
        do kcol = 1,kdim
          qmin = kcol.ge.km1 .and. kcol.le.kxt
          lxx0 = zvclg0(kcol)
c
c         Skip the constraint for a mineral with a very small mass.
c
          if (.not.qmin .or. lxx0.gt.zklogu) then
c
            adx = abs(fdzv0(ip1,kcol))
            delchg = adx*dlxii
            if (delchg .ne. 0.) then
c
c             Taylor's series in a linear quantity (e.g., mass).
c
              mxx0 = zvec0(kcol)
              if (mxx0 .ge. smp100) then
                relchg = delchg/mxx0
              else
                relchg = fdlim
              endif
c
              fctr = sscrew(1)/relchg
              if (fctr .lt. fctrmn) then
                fctrmn = fctr
                uscal(i)(1:24) = ubas(1:24)
                kkk(i) = kcol
              endif
            endif
          endif
        enddo
c
        xip1 = ip1
        scmax(i) = fctrmn**(1./xip1)
        scraw(i) = scmax(i)
        if (scmax(i) .gt. scalim) scmax(i) = scalim
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(5) .ge. 2) then
        write (noutpt,1000)
 1000   format(/' --- Order and Scale Factor Data (chdxgz) ---',/)
        do i = 0,jordlm
          uzt = uscal(i)
          kcoli = kkk(i)
          if (uzt(1:24) .eq. ubas(1:24)) then
            uzn = uzvec1(kcoli)(1:24)
          else
            uzn = ' '
          endif
c
          write (noutpt,1010) i,scmax(i),scraw(i)
 1010     format('   Order= ',i2,', scale= ',f10.5,', raw scale= ',
     $    f10.5)
          j2 = ilnobl(uzt)
          j3 = ilnobl(uzn)
          if (j3 .gt. 0) then
            write (noutpt,1020) uzt(1:j2),uzn(1:j3)
 1020       format(5x,'Constrained by ',a,1x,a)
          else
            write (noutpt,1030) uzt(1:j2)
 1030       format(5x,'Constrained by ',a)
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Choose the order that gives the highest scale factor.
c
      scfcz = scmax(0)
      nordz = 0
      do i = 1,jordlm
        if (scmax(i) .gt. scfcz) then
          scfcz = scmax(i)
          nordz = i
        endif
      enddo
c
  999 continue
      end

      subroutine initcb(uarray,nmax)
c
c     This subroutine initializes the character array uarray to blanks
c     over the first nmax positions. Normally, nmax would be the
c     dimension of the 1D uarray. However, nmax could be less than the
c     true dimension. Also, uarray could actually have more than one
c     dimension. For example, if the array is really ub, having
c     dimensions of i1 and i2, this subroutine could be used by calling
c     it in the following manner: call initcb(ub,i1*i2)). Use this
c     subroutine with caution if nmax is not the product of the true
c     (declared) dimensions.
c
c     To initialize a character array to a non-blank string, use
c     EQLIBU/initcv.f instead.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       uarray = the array
c       nmax   = dimension or pseudo-dimension of uarray
c
c     Output:
c
c       uarray = uarray, with the first nmax positions set to zero
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      character*(*) uarray(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i
c
c-----------------------------------------------------------------------
c
c     Caution: efficiency may be best served by not unrolling the
c     following loop.
c
      do i = 1,nmax
        uarray(i) = ' '
      enddo
c
      end

      program eqpt
c
c     This is the main program of the EQPT code. Configuration
c     identification, the copyright statement, legal disclaimers,
c     and similar statements are contained in EQPT/aaaeqt.f, the
c     lead-off subroutine in the EQPT source code. A short description
c     of this program is also contained in that subroutine.
c
c-----------------------------------------------------------------------
c
      implicit none


c-----------------------------------------------------------------------
c     File path parameters
c-----------------------------------------------------------------------
      integer :: numargs
      character(1024) :: temppath
      character(:), allocatable :: data0path
      integer :: pathindices(2)
      character(:), allocatable :: basename
      character(:), allocatable :: ofile
      character(:), allocatable :: d1file
      character(:), allocatable :: d1ffile
      character(:), allocatable :: sfile
      character(:), allocatable :: d0sfile
c
c-----------------------------------------------------------------------
c
c     Dimensioning parameters:
c
c       iapxpa = maximum number of interaction coefficients for
c                  computing activity coefficients in solid solutions
c       ibpxpa = maximum number of site-mixing parameters for
c                  computing activity coefficients in solid solutions
c
      integer iapxpa,ibpxpa,iktpar
c
      parameter(iapxpa = 20,ibpxpa = 20)
c
c-----------------------------------------------------------------------
c
c     Array allocation size variables used in EQPT.
c
c       ipch_asv = The order for pressure corrections to enthalpy
c                    functions
c       ipcv_asv = The order for pressure corrections to volume
c                    functions; the maximum order for pressure
c                    corrections to log K and other Gibbs-energy-based
c                    functions is one greater than this
c       nap_asv  = The maximum number of distinct sets of Pitzer alpha
c                    parameters
c       narx_asv = The maximum number of coefficients per temperature
c                    range
c       nat_asv  = The number of aqueous species on the data file
c       nazt_asv = the number of aqeuous species on the data file for
c                    which hard core diameters are specified
c       nbt_asv  = The number of basis species on the data file
c       nct_asv  = The number of chemical elements on the data file
c       ngt_asv  = The number of gas species on the data file
c       nlt_asv  = The number of pure liquids on the data file
c       nmt_asv  = The number of pure minerals on the data file
c       npx2_asv = The number of pairs of species not of the same
c                    charge sign for which Pitzer parameters are
c                    defined; typically, one of the pair is a cation
c                    and the other is an anion, but one or both
c                    species may also be electrically neutral
c       npx3_asv = The number of triplets of species corresponding to
c                    aqueous electrolyte mixtures for which Pitzer
c                    parameters are defined; generally, no more than
c                    two of these may have an electrical charge number
c                    that is postive, negative, or zero
c       ntid_asv = The number of lines in the data file title
c       ntpr_asv = The number of temperature ranges
c       ipbt_asv = The greatest index for a Pitzer beta(n) coefficient
c                     (the first such index is zero); also the number
c                     number of Pitzer alpha coefficients in a set
c       jpfc_asv = The number of coefficients in a function for
c                    representing a Pitzer coefficient
c
c       ndb_asv  = maximum number of distinct points on the temperature
c                    grid; ndb_asv = ntpr_asv*(narx_asv - 1) + 1
c
      integer ipbt_asv,ipch_asv,ipcv_asv,jpfc_asv,narx_asv,nat_asv,
     $ nazt_asv,nbt_asv,nct_asv,ngt_asv,nlt_asv,nmt_asv,npx2_asv,
     $ npx3_asv,ntid_asv,ntpr_asv
c
      integer ndb_asv
c
c-----------------------------------------------------------------------
c
c     Array allocation size variables which are determined in EQPT
c     but only written on the DATA1 file for use by EQ3NR and EQ6.
c
c       ikt_asv  = The maximum number of end-member component species
c                    of any solid solution on the data filen
c       nlat_asv = The number of members in the set of Pitzer lambda
c                    coefficients
c       nmut_asv = The number of members in the set of Pitzer mu
c                    coefficients
c       npt_asv  = The number of phases of all types on the data file
c       nst_asv  = The number of species of all types on the data file
c       nxt_asv  = The number of solid-solution phases on the data file
c
      integer ikt_asv,nap_asv,nlat_asv,nmut_asv,npt_asv,nst_asv,nxt_asv
c
c-----------------------------------------------------------------------
c
c     Global variable declarations.
c
c     Dimensioning variables.
c
      integer iapxmx,ibpxmx,iktmax,ipbtmx,ipchmx,ipcvmx,jpfcmx,narxmx,
     $ natmax,naztmx,nbtmax,nctmax,ngtmax,nltmax,nmtmax,npx2mx,npx3mx,
     $ ntidmx,ntprmx,nxtmax
      integer nbtmx1,nbtmx2,ndbmax
c
c     File unit numbers.
c
      integer ndata0,ndata1,ndat0s,ndat1f,noutpt,nslist,nttyo
c
c     Other variables.
c
      integer, dimension(:), allocatable :: insgf,ipivot,issot,nacdpr,
     $ narxt,nentei,nentri
c
      integer ier,ipch,ipcv,irang,nazt,nat,nbt,nct,ncvaz,ndbptg,ndbptl,
     $ nerr,ngt,nlt,nmt,nmodwr,nsb,nthdt,ntitld,ntprt,nwarn,nxt
c
      logical, dimension(:), allocatable :: qpdaz
c
      logical qelect
c
      character(len=80), dimension(:), allocatable :: utitld
      character(len=24), dimension(:), allocatable :: uaqsp,uazp,
     $ udrsi,ugassp,uliqsp,uminsp,uspec,ussoph
      character(len=24), dimension(:,:), allocatable :: ussosp
      character(len=16), dimension(:), allocatable :: udbval
      character(len=8), dimension(:), allocatable :: uelem,uessi
c
      character(len=16) udbfmt
      character(len=8) uplatc,uplatm,uveeqt,usteqt,uveelu,ustelu
      character(len=8) uakey,uethfl
c
      real(8), dimension(:), allocatable :: atwt,azero,cdrsi,cessi,
     $ mtotr,zaqsp,zchar
      real(8), dimension(:,:), allocatable :: cdrs,cess
c
      real(8) cco2(5)
c
      real(8), dimension(:,:,:), allocatable :: xhfs,xlks,xvfs
      real(8), dimension(:,:,:,:), allocatable :: dhfs,dvfs
c
      real(8), dimension(:,:), allocatable :: adh,adhh,adhv,aphi,bdh,
     $ bdhh,bdhv,bdot,bdoth,bdotv,prehw,presg,xhfe,xlke,xvfe
      real(8), dimension(:,:,:), allocatable :: dadhh,dadhv,dbdhh,
     $ dbdhv,dbdth,dbdtv,dhfe,dvfe
c
      real(8), dimension(:), allocatable :: tmpcmx,xdbval
      real(8), dimension(:,:), allocatable :: apr,avgrid,tempc,tempcs
c
      real(8), dimension(:), allocatable :: tvec,tvecs
      real(8), dimension(:), allocatable :: cof,xvec,yvec
      real(8), dimension(:,:), allocatable :: aamatr,gmmatr
c
      real(8) pcvaz
c
      real(8) eps100,smp100,tdamax,tdamin,tvecmx
c
c-----------------------------------------------------------------------
c
c     Pitzer interaction parameter arrays.
c
      integer naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr,
     $ naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr
c
      integer, dimension(:), allocatable :: in2pr,in3tr
      integer, dimension(:,:), allocatable :: iaapr,icapr,iccpr,inapr,
     $ incpr,innpr
      integer, dimension(:,:), allocatable :: iaactr,ia2ctr,iccatr,
     $ ic2atr,incatr,in2ntr
c
      integer jassan,jassca,jassne,npx2t,npx3t
c
      integer ncvaa,ncvca,ncvcc,ncvna,ncvnc,ncvnn,ncvn2,
     $ ncvaac,ncvcca,ncvn2n,ncvnca
c
      integer npxca,npxth,npxni,npxnn,npxn2,npxpsi,npxzet,npxn2n
c
      logical, dimension(:), allocatable :: qpdaa,qpdca,qpdcc,qpdna,
     $ qpdnc,qpdnn,qpdn2
c
      logical, dimension(:), allocatable :: qpdaac,qpdcca,qpdnca,qpdn2n
c
      character(len=24), dimension(:,:), allocatable :: upair,uthdtr,
     $ utripl
c
      real(8), dimension(:,:), allocatable :: alpha,alphca,acphi,
     $ amua2c,amuaac,amucca,amuc2a,amunca,amun2n,amun3
      real(8), dimension(:,:,:), allocatable :: abeta,alamaa,alamca,
     $ alamcc,alamna,alamnc,alamnn,alamn2
c
      real(8), dimension(:,:), allocatable :: atheta,apsi
c
      real(8) pcvaa,pcvca,pcvcc,pcvna,pcvnc,pcvnn,pcvn2
c
      real(8) pcvaac,pcvcca,pcvn2n,pcvnca
c
c-----------------------------------------------------------------------
c
cXX
      real*8 apx(iapxpa),bpx(ibpxpa)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iexec0,itgenf,j,jexec0,jpdblo,jptffl,j2,j3,j4,k,n,
     $ natm1,nch,nco,nmax,npx2,npx2r1,npx2r2,nrecl,nthd,ntpr
c
      integer ilnobl
c
      logical q500fl
c
      character(len=16) uacfst
      character(len=11) utime0,utime1
      character(len=8) ux8,ux8a,ux8b
      character(len=9) udate0,udate1
      character(len=80) uline
c
      real(8) tcpu,texec0,trun,tuser
c
c-----------------------------------------------------------------------
c
      data nrecl /0/
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       On some systems, a BLOCK DATA subroutine must be declared in
c       an EXTERNAL statement to assure proper loading. On some other
c       systems, this is not necessary, but neither it is not harmful.
c       On yet some other systems, the EXTERNAL statement below may
c       cause a problem. If so, try commenting it out. If you still
c       have trouble, consult your local system documentation or
c       experiment to find out how to correctly handle a BLOCK DATA
c       subroutine on your system. The EXTERNAL statement below should
c       not cause a problem if you are using a compiler which is fully
c       compliant with the Fortran 90 standard. However, there is
c       no guarantee that it will be adequate to assure correct loading
c       of the BLOCK DATA subroutine.
c
        external bkdeqp
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       Define the console output device number. A value of 6 applies
c       in most cases.
c
        data nttyo  /6/
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     Get time and date at the start of execution. This information
c     will be used for time and date stamping.
c
      call initim(iexec0,jexec0,texec0,noutpt,nttyo,
     $ udate0,utime0)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Disable underflow trapping, if any.
c
      call undflw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set file unit numbers to zero.
c
      noutpt = 0
      ndata1 = 0
      ndat1f = 0
      nslist = 0
      ndata0 = 0
      ndat0s = 0
c
c     Open all output files.
c
      numargs = COMMAND_ARGUMENT_COUNT()
      if (numargs.eq.1) then
          call GET_COMMAND_ARGUMENT(1,temppath)
          data0path = TRIM(temppath)
      else
          write (0, *) 'usage: eqpt <data0>'
          stop
      end if

      call getbasename(data0path,pathindices)
      basename = data0path(pathindices(1):pathindices(2))

      call openin(noutpt,nttyo,data0path,'formatted',ndata0)

      ofile = basename // '.po'
      d1file = basename // '.d1'
      d1ffile = basename // '.d1f'
      sfile = basename // '.s'
      d0sfile = basename // '.d0s'

      call openou(noutpt,nttyo,ofile,'formatted',nrecl,noutpt)
      call openou(noutpt,nttyo,d1file,'unformatted',nrecl,ndata1)
      call openou(noutpt,nttyo,d1ffile,'formatted',nrecl,ndat1f)
      call openou(noutpt,nttyo,sfile,'formatted',nrecl,nslist)
      call openou(noutpt,nttyo,d0sfile,'formatted',nrecl,ndat0s)
c
c     Make a copy of the DATA0 file, stripped of comments.
c
      call stripl(ndata0,ndat0s)
      close(ndata0)
      ndata0 = 0
      rewind ndat0s
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get configuration identification data.
c
      call aaaeqt(usteqt,uveeqt)
      call aaaelu(ustelu,uveelu)
      call platfd(uplatc,uplatm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write configuration identification data, the copyright statement,
c     and any remaining statements or disclaimers.
c
      i = index(uveeqt,' ') - 1
      j = index(uveeqt,'.') - 1
      k = index(uplatc,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1000) uveeqt(1:i),uveeqt(1:j),uveeqt(1:i),
     $ uplatc(1:k)
      write (noutpt,1000) uveeqt(1:i),uveeqt(1:j),uveeqt(1:i),
     $ uplatc(1:k)
 1000 format(/' EQ3/6, Version ',a,' (EQ3/6-V',a,'-REL-V',a,'-',a,')')
c
      i = j
      j = index(usteqt,' ') - 1
      k = index(uplatm,' ') - 1
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1010) uveeqt(1:i),usteqt(1:j),uplatm(1:k)
      write (noutpt,1010) uveeqt(1:i),usteqt(1:j),uplatm(1:k)
 1010 format(' EQPT Data File Preprocessor Code (EQ3/6-V',a,
     $ '-EQPT-EXE-',a,'-',a,')')
c
      write (noutpt,1020)
      write (nttyo,1020)
 1020 format(' Supported by the following EQ3/6 libraries:')
c
      i = index(uveelu,'.') - 1
      j = index(ustelu,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1030) uveelu(1:i),ustelu(1:j),uplatm(1:k)
      write (noutpt,1030) uveelu(1:i),ustelu(1:j),uplatm(1:k)
 1030 format('   EQLIBU (EQ3/6-V',a,'-EQLIBU-LIB-',a,'-',a,')',/)
c
      write (nttyo,1040)
      write (noutpt,1040)
 1040 format(' Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The',
     $ ' Regents of the',/' University of California, Lawrence',
     $ ' Livermore National Laboratory.',/' All rights reserved.',/)
c
c     Write additional statements and disclaimers.
c
      call prcndi(noutpt,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the time and date on the output.
c
      j2 = ilnobl(udate0)
      write(noutpt,1070) utime0,udate0(1:j2)
      write(nttyo,1070) utime0,udate0(1:j2)
 1070 format(' Run',2x,a8,2x,a,//)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the platform's real*8 floating-point parameters.
c
      call flpars(eps100,irang,noutpt,nttyo,smp100)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize array dimension variables.
c
      iapxmx = iapxpa
      ibpxmx = ibpxpa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write header on the slist file.
c
      write (nslist,1090)
 1090 format(' EQPT Species List (SLIST) File:',//)
c
c     Initialize the cumulative error counter.
c
      nerr = 0
c
c     Initialize the cumulative warning counter.
c
      nwarn = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the first line of the data file to ensure that the
c     required header is present.
c
      call hdrchk(ndat0s,noutpt,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the aqueous species activity coefficient model type
c     (Extended Debye-Huckel, Pitzer, etc.) associated with this
c     data file. This subroutine scans the data file and counts
c     keywords to make the determination.
c
      call gakey(ndat0s,noutpt,nttyo,uakey)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scan the data file to determine the necessary array dimensions
c     and any corresponding structural information that will be
c     required before "reading" the data file.
c
c     First scan the data file title for embedded data.
c
      call ggridp(ipch_asv,ipcv_asv,itgenf,jpdblo,jpfc_asv,
     $ jptffl,narx_asv,ndat0s,ndb_asv,noutpt,ntid_asv,ntpr_asv,
     $ nttyo,q500fl,uakey)
c
c     Set the number of parameters in a Pitzer alpha set.
c
      ipbt_asv = 1
      if (uakey(1:8) .eq. 'Pitzer  ') ipbt_asv = 2
c
c     Rescan the data file to get other array dimensions.
c     Also get the actual numbers of basis species and chemical
c     elements on the data file.
c
      call gnenb(ipbt_asv,ikt_asv,jpdblo,jpfc_asv,nap_asv,
     $ nat_asv,nazt_asv,nbt_asv,nct_asv,ndat0s,ngt_asv,nlt_asv,
     4 nmt_asv,noutpt,npt_asv,npx2_asv,npx3_asv,nsb,nst_asv,nttyo,
     $ nxt_asv,uakey)
c
      nbt = nbt_asv
      nct = nct_asv
c
      if (nsb .ne. (nct + 1)) then
        write (ux8a,'(i5)') nsb
        call lejust(ux8a)
        j2 = ilnobl(ux8a)
        write (ux8b,'(i5)') nct
        call lejust(ux8b)
        j3 = ilnobl(ux8b)
        write(noutpt,1100) ux8a(1:j2),ux8b(1:j3)
        write(nttyo,1100) ux8a(1:j2),ux8b(1:j3)
 1100   format(/' * Error - (EQPT/eqpt) The number of strict basis',
     $  ' species',/7x,'must be the number of chemical elements plus',
     $  ' one. The number of',/7x,'strict basis species is ',a,',',
     $  ' but the number of chemical elements',/7x,'is ',a,'.')
        stop
      endif
c
      ipbt_asv = 1
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
        ipbt_asv = 2
c
c       The following array allocation variables are only used by
c       EQ3NR and EQ6.
c
        nlat_asv = npx2_asv + npx3_asv
        nmut_asv = npx2_asv + 2*npx3_asv
        nlat_asv = max(1,nlat_asv)
        nmut_asv = max(1,nmut_asv)
      endif
c
      iktmax = ikt_asv
      ipbtmx = ipbt_asv
      ipchmx = ipch_asv
      ipcvmx = ipcv_asv
      jpfcmx = jpfc_asv
      narxmx = narx_asv
      natmax = nat_asv
      naztmx = nazt_asv
      nbtmax = nbt_asv
      nctmax = nct_asv
      ndbmax = ndb_asv
      ngtmax = ngt_asv
      nltmax = nlt_asv
      nmtmax = nmt_asv
      npx2mx = npx2_asv
      npx3mx = npx3_asv
      ntidmx = ntid_asv
      ntprmx = ntpr_asv
      nxtmax = nxt_asv
c
      nbtmx1 = nbtmax + 1
      nbtmx2 = nbtmax + 2
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate the necessary arrays.
c
      ALLOCATE(ipivot(narx_asv))
      ALLOCATE(issot(nxt_asv))
      ALLOCATE(nacdpr(ntpr_asv))
      ALLOCATE(narxt(ntpr_asv))
      ALLOCATE(nentei(nct_asv))
      ALLOCATE(nentri(nbt_asv + 1))
c
      ALLOCATE(qpdaz(nat_asv))
c
      ALLOCATE(uaqsp(nat_asv))
      ALLOCATE(zaqsp(nat_asv))
c
      ALLOCATE(ugassp(ngt_asv))
      ALLOCATE(uliqsp(nlt_asv))
      ALLOCATE(uminsp(nmt_asv))
      ALLOCATE(ussoph(nxt_asv))
c
      ALLOCATE(utitld(ntid_asv))
c
      ALLOCATE(uspec(nbt_asv + 1))
      ALLOCATE(udrsi(nbt_asv + 1))
c
      ALLOCATE(ussosp(ikt_asv,nxt_asv))
c
      ALLOCATE(uelem(nct_asv))
      ALLOCATE(uessi(nct_asv))
c
      ALLOCATE(atwt(nct_asv))
      ALLOCATE(cdrsi(nbt_asv + 1))
      ALLOCATE(cessi(nct_asv))
      ALLOCATE(zchar(nbt_asv + 1))
      ALLOCATE(mtotr(nct_asv))
c
      ALLOCATE(cdrs(nbt_asv + 2,nbt_asv + 1))
      ALLOCATE(cess(nct_asv,nbt_asv + 1))
c
      ALLOCATE(dhfs(narx_asv,ntpr_asv,ipch_asv,nbt_asv + 1))
      ALLOCATE(dvfs(narx_asv,ntpr_asv,ipcv_asv,nbt_asv + 1))
      ALLOCATE(xhfs(narx_asv,ntpr_asv,nbt_asv + 1))
      ALLOCATE(xlks(narx_asv,ntpr_asv,nbt_asv + 1))
      ALLOCATE(xvfs(narx_asv,ntpr_asv,nbt_asv + 1))
c
      ALLOCATE(adh(narx_asv,ntpr_asv))
      ALLOCATE(adhh(narx_asv,ntpr_asv))
      ALLOCATE(adhv(narx_asv,ntpr_asv))
      ALLOCATE(aphi(narx_asv,ntpr_asv))
      ALLOCATE(bdh(narx_asv,ntpr_asv))
      ALLOCATE(bdhh(narx_asv,ntpr_asv))
      ALLOCATE(bdhv(narx_asv,ntpr_asv))
      ALLOCATE(bdot(narx_asv,ntpr_asv))
      ALLOCATE(bdoth(narx_asv,ntpr_asv))
      ALLOCATE(bdotv(narx_asv,ntpr_asv))
      ALLOCATE(prehw(narx_asv,ntpr_asv))
      ALLOCATE(presg(narx_asv,ntpr_asv))
      ALLOCATE(xhfe(narx_asv,ntpr_asv))
      ALLOCATE(xlke(narx_asv,ntpr_asv))
      ALLOCATE(xvfe(narx_asv,ntpr_asv))
c
      ALLOCATE(dadhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(dbdhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(dbdth(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(dhfe(narx_asv,ntpr_asv,ipch_asv))
c
      ALLOCATE(dadhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(dbdhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(dbdtv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(dvfe(narx_asv,ntpr_asv,ipcv_asv))
c
      ALLOCATE(apr(narx_asv,ntpr_asv))
      ALLOCATE(avgrid(narx_asv,ntpr_asv))
      ALLOCATE(tempc(narx_asv,ntpr_asv))
      ALLOCATE(tempcs(narx_asv,ntpr_asv))
      ALLOCATE(tmpcmx(ntpr_asv))
      ALLOCATE(udbval(ndb_asv))
      ALLOCATE(xdbval(ndb_asv))
c
      ALLOCATE(tvec(narx_asv))
      ALLOCATE(tvecs(narx_asv))
      ALLOCATE(cof(narx_asv))
      ALLOCATE(xvec(narx_asv))
      ALLOCATE(yvec(narx_asv))
c
      ALLOCATE(aamatr(narx_asv,narx_asv))
      ALLOCATE(gmmatr(narx_asv,narx_asv))
c
      if (uakey(1:8) .eq. 'SEDH    ') then
        ALLOCATE(uazp(nazt_asv))
        ALLOCATE(azero(nazt_asv))
        ALLOCATE(insgf(nazt_asv))
      endif
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
        ALLOCATE(alpha(ipbt_asv,npx2_asv))
        ALLOCATE(abeta(jpfc_asv,0:ipbt_asv,npx2_asv))
        ALLOCATE(acphi(jpfc_asv,npx2_asv))
c
        ALLOCATE(upair(2,npx2_asv))
        ALLOCATE(uthdtr(3,npx3_asv))
        ALLOCATE(utripl(3,npx3_asv))
c
        ALLOCATE(atheta(jpfc_asv,npx3_asv))
        ALLOCATE(apsi(jpfc_asv,npx3_asv))
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write some tallies on the OUTPUT file.
c
      write (noutpt,1120) nct,nbt
      write (nslist,1120) nct,nbt
 1120 format(11x,'Number of elements = ',i5,
     $ /11x,'Number of basis species = ',i5,/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the header on the DATA1 and DATA1f files. This begins with
c     the string 'data1' at the top of the files, followed by the
c     keystring for the type of aqueous species activity coefficient
c     model, and the array dimensions necessary to read the rest of
c     the DATA1 file.
c
      call wrhdr(ikt_asv,ipch_asv,ipcv_asv,jpfc_asv,nap_asv,
     $ narx_asv,nat_asv,nbt_asv,nct_asv,ndata1,ndat1f,ngt_asv,
     $ nlat_asv,nlt_asv,nmt_asv,nmut_asv,npt_asv,nst_asv,ntid_asv,
     $ ntpr_asv,nxt_asv,uakey)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the data file title on the various output files. Determine
c     certain embedded options apart from those that set dimensioning
c     parameters.
c
      ntitld = ntid_asv
      call rdwttl(ipch,ipcv,jpdblo,jpfcmx,jptffl,narxt,ndata1,
     $ ndat0s,ndat1f,noutpt,nslist,ntitld,ntidmx,ntprmx,ntprt,nttyo,
     $ uakey,utitld)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the miscellaneous parameters (write them after the chemical
c     elements block). Write the nominal temperature limits and the
c     upper limits of the temperature ranges here, however.
c
      call rdpar(adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,
     $ bdotv,cco2,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dvfe,
     $ ipch,ipchmx,ipcv,ipcvmx,itgenf,nacdpr,narxmx,narxt,ndat0s,
     $ ndbmax,ndbptg,ndbptl,nerr,noutpt,ntprmx,ntprt,nttyo,nwarn,
     $ prehw,presg,q500fl,tdamax,tdamin,tempc,uakey,udbfmt,udbval,
     $ xdbval,xhfe,xlke,xvfe)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read and write the element data.
c
      call rdwele(atwt,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,
     $ nerr,noutpt,nslist,nttyo,uelem)
c
c     Check the element names for uniqueness.
c
      call neleck(nct,nctmax,nerr,noutpt,nttyo,uelem)
c
      if (nerr .gt. 0) then
        write (ux8,'(i5)') nerr
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1160) ux8(1:j2)
        write (nttyo,1160) ux8(1:j2)
 1160   format(//' ',a,' errors(s) were encountered.',/)
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scale the grid temperature values for subsequent interpolation.
c
      do ntpr = 1,ntprt
c
        nmax = narxt(ntpr)
        do n = 1,nmax
          tvec(n) = tempc(n,ntpr)
        enddo
c
c       Calling sequence substitutions:
c         tvec for avx
c         tvecmx for avxmax
c         tvecs for avxs
c
        call scalx1(tvec,tvecmx,tvecs,ier,nmax)
        do n = 1,nmax
          tempcs(n,ntpr) = tvecs(n)
        enddo
        tmpcmx(ntpr) = tvecmx
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the interval parameter (nmodwr) for writing species and
c     phase names to nttyo. This is scaled to the number of chemical
c     elements.
c
      if (nct .gt. 50) then
        nmodwr = 20
      elseif (nct .gt. 30) then
        nmodwr = 10
      elseif (nct .gt. 20) then
        nmodwr = 5
      else
        nmodwr = 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpolate and write the miscellaneous parameters.
c
      call wrpar(aamatr,adh,adhh,adhv,aphi,apr,avgrid,bdh,bdhh,
     $ bdhv,bdot,bdoth,bdotv,cco2,cof,dadhh,dadhv,dbdhh,dbdhv,dbdth,
     $ dbdtv,dhfe,dvfe,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,ipivot,
     $ narxmx,narxt,ndata1,ndat1f,noutpt,ntprmx,ntprt,nttyo,presg,
     $ prehw,tdamax,tdamin,tempc,tempcs,tmpcmx,uakey,xhfe,xlke,xvfe,
     $ xvec,yvec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read and write aqueous species.
c
      call pcraq(aamatr,apr,atwt,avgrid,cdrs,cdrsi,cess,cessi,
     $ cof,dhfe,dhfs,dvfe,dvfs,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,
     $ ipivot,itgenf,mtotr,nacdpr,narxmx,narxt,nat,natmax,nbt,nbtmx1,
     $ nbtmx2,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,ndbmax,ndbptg,
     $ ndbptl,nentei,nentri,nerr,nmodwr,noutpt,nsb,nslist,ntprmx,ntprt,
     $ nttyo,nwarn,qelect,q500fl,tempc,tempcs,tmpcmx,uaqsp,udbfmt,
     $ udbval,udrsi,uelem,uessi,uspec,xdbval,xhfe,xhfs,xlke,xlks,xvfe,
     $ xvfs,xvec,yvec,zaqsp,zchar)
c
c     Read and write minerals, liquids, gases.
c
      call pcrsg(aamatr,apr,atwt,avgrid,cdrs,cdrsi,cess,cessi,
     $ cof,dhfe,dhfs,dvfe,dvfs,eps100,gmmatr,ipch,ipchmx,ipcv,ipcvmx,
     $ ipivot,itgenf,mtotr,nacdpr,narxmx,narxt,nat,natmax,nbt,nbtmx1,
     $ nbtmx2,nch,nco,nct,nctmax,ndata1,ndat0s,ndat1f,ndbmax,ndbptg,
     $ ndbptl,nentei,nentri,nerr,ngt,ngtmax,nlt,nltmax,nmodwr,nmt,
     $ nmtmax,noutpt,nsb,nslist,ntprmx,ntprt,nttyo,nwarn,qelect,
     $ q500fl,tempc,tempcs,tmpcmx,udbfmt,udbval,udrsi,uelem,uessi,
     $ ugassp,uliqsp,uminsp,uspec,xdbval,xhfe,xhfs,xlke,xlks,xvfe,
     $ xvfs,xvec,yvec,zchar)
c
c     Read and write solid solutions.
c
      call pcrss(apx,bpx,iapxmx,ibpxmx,iktmax,issot,nbtmx1,
     $ ndata1,ndat0s,ndat1f,nerr,nmodwr,nmt,nmtmax,noutpt,nslist,
     $ nttyo,nxt,nxtmax,uminsp,ussosp,ussoph)
c
c     Make sure that all aqueous species names are unique.
c
      call naqsck(nat,natmax,nerr,noutpt,nttyo,uaqsp)
c
c     Make sure that all pure mineral names are unique.
c
      call nminck(nerr,nmt,nmtmax,noutpt,nttyo,uminsp)
c
c     Make sure that all gas species names are unique.
c
      call ngasck(nerr,ngt,ngtmax,noutpt,nttyo,ugassp)
c
c     Make sure that all solid solution names are unique.
c
      call nssock(nerr,noutpt,nttyo,nxt,nxtmax,ussoph)
c
c     Make sure that all solid solution end-member names are unique
c     within each solid solution.
c
      call nxspck(iktmax,issot,nerr,noutpt,nttyo,nxt,nxtmax,
     $ ussoph,ussosp)
c
c     Validate the end-member names for the solid solutions. Each
c     end-member name must match that of a pure mineral.
c
      call vxspck(iktmax,issot,nerr,nmt,nmtmax,noutpt,nttyo,
     $ nxt,nxtmax,uminsp,ussoph,ussosp)
c
      if (nerr .gt. 0) then
        write (ux8,'(i5)') nerr
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1160) ux8(1:j2)
        write (nttyo,1160) ux8(1:j2)
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Rewind and position to read aqueous species activity coefficient
c     parameters.
c
      rewind(ndat0s)
c
      if (uakey(1:8) .eq. 'SEDH    ') then
        uacfst = 'bdot parameters '
      elseif (uakey(1:8) .eq. 'Pitzer  ') then
        if (jpdblo .eq. -1) then
          uacfst = 'single-salt para'
        else
          uacfst = 'ca combinations:'
        endif
      else
        j2 = ilnobl(uakey)
        write(noutpt,1200) uakey(1:j2)
        write(nttyo,1200) uakey(1:j2)
 1200   format(/' * Error - (EQPT/eqpt) Unrecognized data file',
     $  ' type = "',a,'".',/7x,'Allowed types are "SEDH" (Simple',
     $  ' Extended Debye-Huckel) and',/7x,'"Pitzer".')
        stop
      endif
c
  270 read(ndat0s,1210,end=280,err=280) uline
 1210 format(a)
      if (uline(1:16) .ne. uacfst(1:16)) go to 270
      go to 290
c
  280 j3 = ilnobl(uacfst)
      write(noutpt,1220) uacfst(1:j3)
      write(nttyo,1220) uacfst(1:j3)
 1220 format(/' * Error - (EQPT/eqpt) End-of-file hit or other read',
     $ /7x,'error occurred while searching for the block header',
     $ /7x,'beginning with "',a,'".')
      stop
c
  290 backspace(ndat0s)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Zero arrays for activity coefficient parameters.
c
      if (uakey(1:8) .eq. 'SEDH    ') then
c
c       Zero the azero array.
c
        call initaz(azero,naztmx)
c
c       Zero the insgf array.
c
        call initiz(insgf,naztmx)
      endif
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Zero the alpha array.
c
        nmax = ipbtmx*npx2mx
        call initaz(alpha,nmax)
c
c       Zero the abeta array.
c
        nmax = jpfcmx*(ipbtmx + 1)*npx2mx
        call initaz(abeta,nmax)
c
c       Zero the acphi array.
c
        nmax = jpfcmx*npx2mx
        call initaz(acphi,nmax)
c
c       Zero the atheta and apsi arrays.
c
        nmax = jpfcmx*npx3mx
        call initaz(atheta,nmax)
        call initaz(apsi,nmax)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the SEDH or Pitzer section.
c
      if (uakey(1:8) .eq. 'SEDH    ') then
c
c       Read hard core diameters and related parameters used
c       in the B-dot equation.
c
        call rdazp(azero,insgf,nazt,naztmx,ndat0s,nerr,noutpt,
     $  nttyo,uazp)
      endif
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Read Pitzer parameters.
c
        if (jpdblo .eq. -1) then
c
c         Read the data according to the old Pitzer data block
c         organization. There is one superblock for data
c         pertaining to pure aqueous electrolytes, another
c         for mixtures of such with a common ion. Parameters
c         involving neutral aqueous species are handled (awkwardly,
c         but with appropriate checks) within this structure as
c         noted below.
c
c         Read the beta(n) and Cphi parameters.
c           - normally for ca (cation-anion) combinations.
c           - lamda(0) values may be read in place of beta(0) values
c             for nn, nn', nc, and na combinations.
c           - mu values may be read in place of Cphi values for
c             nnn combinations.
c
          call rdpz2(abeta,alpha,acphi,ipbtmx,jpfcmx,nat,natmax,
     $    ndat0s,nerr,noutpt,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,
     $    zaqsp)
c
c         Read the S-theta and psi parameters.
c           - normally for cc'a and aa'c combinations.
c           - zeta values may be read in place of psi values for
c             nca combinations.
c           - mu values may be read in place of psi values for
c             nnn' and n'n'n combinations.
c
          call rdpz3(apsi,atheta,jpfcmx,nat,natmax,ndat0s,nerr,
     $    noutpt,npx3mx,npx3t,nthdt,nttyo,nwarn,uaqsp,uethfl,uthdtr,
     $    utripl,zaqsp)
        else
c
c         Read the data according to the new Pitzer data block
c         organization. There is one superblock for each allowed
c         species pair or triplet type. Note that for the "new"
c         organization, the E-theta flag is hardwired to 'on'.
c         That is because basically all modern implementations
c         of Pitzer's equations use the theoretically-based
c         higher-order electrostatic term formalism (which is
c         turned on by uethfl = 'on').
c
          uethfl = 'on'
          npx2t = 0
          npx3t = 0
c
c         Read ca (cation-anion) data.
c
          call rdpca(abeta,alpha,acphi,ipbtmx,jpfcmx,nat,natmax,
     $    ndat0s,nerr,noutpt,npxca,npx2mx,npx2t,nttyo,nwarn,uaqsp,
     $    upair,zaqsp)
c
c         Read cc' (cation-different cation) and aa' (anion-
c         different anion) data.
c
          call rdpth(abeta,ipbtmx,jpfcmx,nat,natmax,ndat0s,nerr,
     $    noutpt,npxth,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,zaqsp)
c
c         Read nc (neutral-cation) and na (neutral-anion) data.
c
          call rdpni(abeta,ipbtmx,jpfcmx,nat,natmax,ndat0s,nerr,
     $    noutpt,npxni,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,zaqsp)
c
c         Read nn (neutral-same neutral) data.
c
          call rdpn2(abeta,acphi,ipbtmx,jpfcmx,nat,natmax,
     $    ndat0s,nerr,noutpt,npxn2,npx2mx,npx2t,nttyo,nwarn,
     $    uaqsp,upair,zaqsp)
c
c         Read nn'(neutral-different neutral) data.
c
          call rdpnn(abeta,ipbtmx,jpfcmx,nat,natmax,ndat0s,nerr,
     $    noutpt,npxnn,npx2mx,npx2t,nttyo,nwarn,uaqsp,upair,zaqsp)
c
c         Read cc'a (cation-different cation-anion) and aa'c
c         (anion-different anion-cation) data.
c
          call rdppsi(apsi,jpfcmx,nat,natmax,ndat0s,nerr,noutpt,
     $    npxpsi,npx3mx,npx3t,nttyo,nwarn,uaqsp,utripl,zaqsp)
c
c         Read nca (neutral-cation--anion) data.
c
          call rdpzet(apsi,jpfcmx,nat,natmax,ndat0s,nerr,noutpt,
     $    npxzet,npx3mx,npx3t,nttyo,nwarn,uaqsp,utripl,zaqsp)
c
c         Read nnn' (neutral-neutral-different neutral) data.
c
          call rdpn2n(apsi,jpfcmx,nat,natmax,ndat0s,nerr,noutpt,
     $    npxn2n,npx3mx,npx3t,nttyo,nwarn,uaqsp,utripl,zaqsp)
c
c         Copy the theta data into arrays used with the old
c         Pitzer data block organization.
c
          nthdt = npxth
          nthd = 0
          npx2r1 = npxca + 1
          npx2r2 = npxca + npxth
          do npx2 = npx2r1,npx2r2
            nthd = nthd + 1
            uthdtr(1,nthd) = upair(1,npx2)
            uthdtr(2,nthd) = upair(2,npx2)
            uthdtr(3,nthd) = '<dummy>'
            do j = 1,jpfcmx
              atheta(j,nthd) = abeta(j,0,npx2)
            enddo
          enddo
c
        endif
      endif
c
      if (nerr .gt. 0) then
        write (ux8,'(i5)') nerr
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1160) ux8(1:j2)
        write (nttyo,1160) ux8(1:j2)
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test and write the SEDH data section of DATA1.
c
      if (uakey(1:8) .eq. 'SEDH    ') then
c
c       Validate the names of aqueous species used to specify azero
c       ('bdot') data. Each such name should correspond to an aqueous
c       species for which there is a species block on the data file.
c       Write a note for any exceptions.
c
        call vazpck(nat,natmax,nazt,naztmx,noutpt,nttyo,
     $  uaqsp,uazp)
c
c       Test and process all azero and insgf ('bdot') data.
c
        call tpraz(nat,natmax,nazt,naztmx,ncvaz,nerr,noutpt,nttyo,
     $  pcvaz,qpdaz,uaqsp,uazp)
c
c       Write the azero and insgf data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvaz
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1230)
 1230   format(//2x,'Aqueous species hard core diameter coverage:')
        natm1 = nat - 1
        write (noutpt,1240) ncvaz,natm1,ux8(1:j2)
 1240   format(/4x,i5,' aqueous species have hard core diameters',
     $  ' specified on the data file',/4x,i5,' aqueous solute',
     $  ' species are present on this file',/4x,'Coverage is ',a,
     $  ' per cent')
c
        if (nerr .gt. 0) then
          write (ux8,'(i5)') nerr
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1160) ux8(1:j2)
          write (nttyo,1160) ux8(1:j2)
          stop
        endif
c
c       Write hard core diameters and related parameters used
c       for example in the B-dot equation.
c
        call wrazp(azero,insgf,nazt,naztmx,ndata1,ndat1f,
     $  noutpt,nttyo,uazp)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test and write the Pitzer data section of DATA1.
c
      if (uakey(1:8) .eq. 'Pitzer  ') then
c
c       Count the numbers of aqueous solution cations, anions, and
c       neutrals, excluding any fictive redox species. These will
c       be used to compute the species pairs and triplets relevant
c       to Pitzer parameters.
c
        call coasst(jassan,jassca,jassne,nat,natmax,uaqsp,zaqsp)
c
c       Compute the number of each of the relevant types of these
c       species pairs and triplets (e.g., ca, cc', aa', nc, na, nn,
c       nn', cca, aac, nnn, nnn', and nca).
c
        call cpcomb(jassan,jassca,jassne,naapr,nat,ncapr,nccpr,
     $  nnapr,nncpr,nnnpr,nn2pr,naactr,na2ctr,nncatr,nccatr,nc2atr,
     $  nn2ntr,nn3tr)
c
c       Allocate the associated arrays.
c
        ALLOCATE(alphca(ipbt_asv,ncapr))
c
        ALLOCATE(alamaa(jpfc_asv,0:ipbt_asv,naapr))
        ALLOCATE(alamca(jpfc_asv,0:ipbt_asv,ncapr))
        ALLOCATE(alamcc(jpfc_asv,0:ipbt_asv,nccpr))
        ALLOCATE(alamna(jpfc_asv,0:ipbt_asv,nnapr))
        ALLOCATE(alamnc(jpfc_asv,0:ipbt_asv,nncpr))
        ALLOCATE(alamnn(jpfc_asv,0:ipbt_asv,nnnpr))
        ALLOCATE(alamn2(jpfc_asv,0:ipbt_asv,nn2pr))
c
        ALLOCATE(amua2c(jpfc_asv,na2ctr))
        ALLOCATE(amuc2a(jpfc_asv,nc2atr))
        ALLOCATE(amun3(jpfc_asv,nn3tr))
c
        ALLOCATE(amuaac(jpfc_asv,naactr))
        ALLOCATE(amucca(jpfc_asv,nccatr))
        ALLOCATE(amunca(jpfc_asv,nncatr))
        ALLOCATE(amun2n(jpfc_asv,nn2ntr))
c
        ALLOCATE(qpdaa(naapr))
        ALLOCATE(qpdca(ncapr))
        ALLOCATE(qpdcc(nccpr))
        ALLOCATE(qpdna(nnapr))
        ALLOCATE(qpdnc(nncpr))
        ALLOCATE(qpdnn(nnnpr))
        ALLOCATE(qpdn2(nn2pr))
c
        ALLOCATE(qpdaac(naactr))
        ALLOCATE(qpdcca(nccatr))
        ALLOCATE(qpdnca(nncatr))
        ALLOCATE(qpdn2n(nn2ntr))
c
        ALLOCATE(in2pr(nn2pr))
        ALLOCATE(in3tr(nn3tr))
c
        ALLOCATE(iaapr(2,naapr))
        ALLOCATE(icapr(2,ncapr))
        ALLOCATE(iccpr(2,nccpr))
        ALLOCATE(inapr(2,nnapr))
        ALLOCATE(incpr(2,nncpr))
        ALLOCATE(innpr(2,nnnpr))
c
        ALLOCATE(in2ntr(2,nn2ntr))
        ALLOCATE(ia2ctr(2,na2ctr))
        ALLOCATE(ic2atr(2,nc2atr))
        ALLOCATE(iaactr(3,naactr))
        ALLOCATE(iccatr(3,nccatr))
        ALLOCATE(incatr(3,nncatr))
c
c       Construct index arrays for those pairs and triplets.
c
        call bldspc(iaapr,icapr,iccpr,inapr,incpr,innpr,
     $  in2pr,iaactr,ia2ctr,iccatr,ic2atr,incatr,in2ntr,in3tr,
     $  jassan,jassca,jassne,nat,natmax,naapr,ncapr,nccpr,nnapr,
     $  nncpr,nnnpr,nn2pr,naactr,na2ctr,nncatr,nccatr,nc2atr,
     $  nn2ntr,nn3tr,uaqsp,zaqsp)
c
c       Note on subroutine and array naming for species pairs and
c       triplets associated with Pitzer coefficients:
c
c         ca   is represented by "ca"
c         cc'a is represented by "cca"
c         cca  is represented by "c2a"
c         aa'c is represented by "a2c"
c         aac  is represented by "aac"
c         cc' is represented by "cc"
c
c       Test and process all ca (cation-anion) parameters. This includes
c       the cca (repeated cation-anion) and aac (cation-repeated anion)
c       cases. The basic transformations are:
c
c         beta(n)(ca) -> lambda(n)(ca)   (n = 0,2)
c         Cphi(ca)    -> mu(cca) and mu(aac)
c
        call tprca(abeta,acphi,alamca,alpha,alphca,amua2c,amuc2a,
     $  icapr,ipbtmx,jpfcmx,natmax,na2ctr,ncapr,ncvca,nc2atr,nerr,
     $  noutpt,npx2mx,npx2t,nttyo,nwarn,pcvca,qpdca,uaqsp,upair,zaqsp)
c
c       Test and process the cc' (cation-different cation) parameters.
c       cases. The basic transformation is:
c
c         theta(cc') -> lambda(cc')
c
        call tprcc(alamcc,atheta,iccpr,ipbtmx,jpfcmx,natmax,
     $  nccpr,ncvcc,nerr,noutpt,npx3mx,nthdt,nttyo,nwarn,pcvcc,
     $  qpdcc,uaqsp,uthdtr)
c
c       Test and process the aa' (anion-different anion) parameters.
c       cases. The basic transformation is:
c
c         theta(aa') -> lambda(aa')
c
        call tpraa(alamaa,atheta,iaapr,ipbtmx,jpfcmx,naapr,
     $  natmax,ncvaa,nerr,noutpt,npx3mx,nthdt,nttyo,nwarn,pcvaa,
     $  qpdaa,uaqsp,uthdtr)
c
c       Test and process the nn (repeated-neutral) parameters. This
c       includes the nnn (doubly repeated neutral) cases. Note on
c       subroutine and array naming:
c
c         nn  is represented by "n2"
c         nn' is represented by "nn"
c
c         lambda(nn) -> lambda(nn)
c         mu(nnn)    -> mu(nnn)
c
        call tprn2(abeta,acphi,alamn2,amun3,in2pr,ipbtmx,
     $  jpfcmx,natmax,ncvn2,nerr,nn2pr,nn3tr,noutpt,npx2mx,npx2t,
     $  nttyo,nwarn,pcvn2,qpdn2,uaqsp,upair)
c
c       Test and process the nn' (neutral-different neutral) parameters.
c       See the above note on subroutine and array naming.
c
c         lambda(nn') -> lambda(nn')
c
        call tprnn(abeta,acphi,alamnn,innpr,in2pr,ipbtmx,
     $  jpfcmx,natmax,ncvnn,nerr,nnnpr,nn2pr,noutpt,npx2mx,npx2t,
     $  nttyo,nwarn,pcvnn,qpdnn,qpdn2,uaqsp,upair)
c
c       Test and process the nc (neutral-cation) parameters.
c
c         lambda(nc) -> lambda(nc)
c
        call tprnc(abeta,alamnc,incpr,ipbtmx,jpfcmx,natmax,
     $  ncvnc,nerr,nncpr,noutpt,npx2mx,npx2t,nttyo,nwarn,pcvnc,
     $  qpdnc,uaqsp,upair)
c
c       Test and process the na (neutral-anion) parameters.
c
c         lambda(na) -> lambda(na)
c
        call tprna(abeta,alamna,inapr,ipbtmx,jpfcmx,natmax,
     $  ncvna,nerr,nnapr,noutpt,npx2mx,npx2t,nttyo,nwarn,pcvna,
     $  qpdna,uaqsp,upair)
c
c       Test and process the cc'a (cation-different cation-anion)
c       parameters. Note that mu(cc'a) depends not only on psi(cc'a),
c       but also on mu(cca) and mu(c'c'a), hence indirectly on Cphi(ca)
c       and Cphi(c'a). Note on subroutine and array naming:
c
c         cc'a is represented by "cca"
c         cca  is represented by "c2a"
c
c         psi(cc'a) -> mu(cc'a)
c
        call tprcca(amucca,amuc2a,apsi,icapr,iccatr,ipbtmx,
     $  jpfcmx,natmax,ncapr,nccatr,ncvcca,nc2atr,nerr,noutpt,
     $  npx3mx,npx3t,nttyo,nwarn,pcvcca,qpdca,qpdcca,uaqsp,
     $  utripl,zaqsp)
c
c       Test and process the aa'c (anion-different anion-cation)
c       parameters. Note that mu(aa'c) depends not only on psi(aa'c),
c       but also on mu(aac) and mu(a'a'c), hence indirectly on Cphi(ca)
c       and Cphi(ca'). Note on subroutine and array naming:
c
c         aa'c is represented by "aac"
c         aac  is represented by "a2c"
c
c         psi(aa'c) -> mu(aa'c)
c
        call tpraac(amuaac,amua2c,apsi,iaactr,icapr,ipbtmx,
     $  jpfcmx,naactr,natmax,na2ctr,ncapr,ncvaac,nerr,noutpt,
     $  npx3mx,npx3t,nttyo,nwarn,pcvaac,qpdaac,qpdca,uaqsp,
     $  utripl,zaqsp)
c
c       Test and process the nnn' (repeated neutral-different neutral)
c       parameters. These are not processed with the nn' parameters
c       because there are two mu coefficients (nnn' and n'n'n) for
c       each lambda coefficient (nn'). Note on subroutine and array
c       naming:
c
c         nnn' is represented by "n2n"
c
c         mu(nnn') -> mu(nnn')
c
        call tprn2n(amun2n,apsi,innpr,in2pr,in2ntr,ipbtmx,
     $  jpfcmx,natmax,ncvn2n,nerr,nnnpr,nn2pr,nn2ntr,noutpt,npx3mx,
     $  npx3t,nttyo,nwarn,pcvn2n,qpdnn,qpdn2,qpdn2n,uaqsp,utripl)
c
c       Test and process the nca (neutral-cation-anion) parameters.
c
c         mu(nca) -> mu(nca)
c
        call tprnca(amunca,apsi,inapr,incatr,incpr,ipbtmx,
     $  jpfcmx,natmax,ncvnca,nerr,nnapr,nncatr,nncpr,noutpt,npx3mx,
     $  npx3t,nttyo,nwarn,pcvnca,qpdna,qpdnca,qpdnc,uaqsp,utripl)
c
c
c       What about the following combinations?
c
c         cc     (repeated cation)
c         aa     (repeated neutral)
c         ccc    (doubly repeated cation)
c         aaa    (doubly repeated cation)
c         ccc'   (repeated cation and a distinct cation)
c         aaa'   (repeated anion and a distinct anion)
c         cc'c'' (three distinct cations)
c         aa'a'' (three distinct anions)
c         nn'n'' (three distinct neutrals)
c         ncc'   (neutral and two distinct cations)
c         naa'   (neutral and two distinct anions)
c         nn'c   (two distinct neutrals and a cation)
c         nn'a   (two distinct neutrals and an anion)
c
c       Some (e.g., cc,  aa) are defined to be zero by convention.
c       Others (e.g., cc'c'' and nn'n'') correspond to quaternary
c       or higher mixtures. In any case, they are not used in the
c       normal Pitzer treatment of electrolyte solutions.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Write the cation-anion (ca) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvca
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1300)
 1300   format(//2x,'Cation-anion (ca) pair coverage:')
        write (noutpt,1310) ncvca,ncapr,ux8(1:j2)
 1310   format(/4x,i5,' pairs have Pitzer parameters specified on',
     $  ' the data file',/4x,i5,' pairs can be constructed from',
     $  ' the species present on this file',/4x,'Coverage is ',a,
     $  ' per cent')
c
c       Write the cation-distinct cation (cc') data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvcc
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1320)
 1320   format(//2x,"Cation-distinct cation (cc') pair coverage:")
        write (noutpt,1310) ncvcc,nccpr,ux8(1:j2)
c
c       Write the anion-distinct anion (aa') data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvaa
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1330)
 1330   format(//2x,"Anion-distinct anion (aa') pair coverage:")
        write (noutpt,1310) ncvaa,naapr,ux8(1:j2)
c
c       Write the repeated-neutral (nn) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvn2
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1340)
 1340   format(//2x,'Repeated-neutral (nn) pair coverage:')
        write (noutpt,1310) ncvn2,nn2pr,ux8(1:j2)
c
c       Write the neutral-distinct neutral (nn') data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvnn
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1350)
 1350   format(//2x,"Neutral-distinct neutral (nn') pair coverage:")
        write (noutpt,1310) ncvnn,nnnpr,ux8(1:j2)
c
c       Write the neutral-cation (nc) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvnc
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1360)
 1360   format(//2x,'Neutral-cation (nc) pair coverage:')
        write (noutpt,1310) ncvnc,nncpr,ux8(1:j2)
c
c       Write the neutral-anion (na) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvna
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1370)
 1370   format(//2x,'Neutral-anion (na) pair coverage:')
        write (noutpt,1310) ncvna,nnapr,ux8(1:j2)
c
c       Write the cation-distinct cation-anion (cc'a) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvcca
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1380)
 1380   format(//2x,"Cation-distinct cation-anion (cc'a) triplet",
     $  ' coverage:')
        write (noutpt,1390) ncvcca,nccatr,ux8(1:j2)
 1390   format(/4x,i5,' triplets have Pitzer parameters specified on',
     $  ' the data file',/4x,i5,' triplets can be constructed from',
     $  ' the species present on this file',/4x,'Coverage is ',a,
     $  ' per cent')
c
c
c       Write the anion-distinct anion-cation (aa'c) data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvaac
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1400)
 1400   format(//2x,"Anion-distinct anion-cation (aa'c) triplet",
     $  ' coverage:')
        write (noutpt,1390) ncvaac,naactr,ux8(1:j2)
c
c       Write the repeated neutral-distinct neutral (nnn') data
c       summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvn2n
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1410)
 1410   format(//2x,"Repeated neutral-distinct neutral (nnn')",
     $  ' triplet coverage:')
        write (noutpt,1390) ncvn2n,nn2ntr,ux8(1:j2)
c
c       Write the neutral-cation-anion data summary.
c
        ux8 = ' '
        write (ux8,'(f6.2)') pcvnca
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1420)
 1420   format(//2x,'Neutral-cation-anion (nca) triplet coverage:')
        write (noutpt,1390) ncvnca,nncatr,ux8(1:j2)
c
        if (nerr .gt. 0) then
          write (ux8,'(i5)') nerr
          call lejust(ux8)
          j2 = ilnobl(ux8)
          write (noutpt,1160) ux8(1:j2)
          write (nttyo,1160) ux8(1:j2)
          stop
        endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Write Pitzer parameters.
c
        call wrpz23(alphca,alamaa,alamca,alamcc,alamna,alamnc,
     $  alamnn,alamn2,amuaac,amua2c,amucca,amuc2a,amunca,amun2n,
     $  amun3,ipbtmx,iaapr,icapr,iccpr,inapr,incpr,innpr,in2pr,
     $  iaactr,ia2ctr,iccatr,ic2atr,incatr,in2ntr,in3tr,jpdblo,
     $  jpfcmx,natmax,naapr,ncapr,nccpr,nnapr,nncpr,nnnpr,nn2pr,
     $  naactr,na2ctr,nccatr,nc2atr,nncatr,nn2ntr,nn3tr,ndata1,
     $  ndat1f,noutpt,nttyo,uaqsp,uethfl)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      j2 = ilnobl(uakey)
      j3 = ilnobl(utitld(1))
      write (nttyo,1460) uakey(1:j2),utitld(1)(1:j3)
      write (noutpt,1460) uakey(1:j2),utitld(1)(1:j3)
 1460 format(//' Completed processing the ',a,' data file ',a,'.')
      write (noutpt,1470)
      write (nttyo,1470)
 1470 format(//' No errors were encountered.')
      if (nwarn .le. 0) then
        write (noutpt,1480)
        write (nttyo,1480)
 1480   format(/' No warnings were encountered.',//)
      else
        write (ux8,'(i5)') nwarn
        call lejust(ux8)
        j4 = ilnobl(ux8)
        write (noutpt,1490) ux8(1:j4)
        write (nttyo,1490) ux8(1:j4)
 1490   format(/' ',a,' warning(s) were encountered.',//)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get end time and date. Also get the run time. Optionally, on
c     a Unix platform, get the user and cpu times.
c
      call runtim(iexec0,jexec0,texec0,noutpt,nttyo,trun,
     $ tuser,tcpu,udate1,utime1)
c
      j2 = ilnobl(udate0)
      j3 = ilnobl(udate1)
      write (noutpt,1500) utime0,udate0(1:j2),utime1,udate1(1:j3)
      write (nttyo,1500) utime0,udate0(1:j2),utime1,udate1(1:j3)
 1500 format(10x,'Start time = ',a8,2x,a,/12x,
     $ 'End time = ',a8,2x,a)
c
c     Print the run, user, and cpu times.
c
      write (noutpt,1510) trun
      write (nttyo,1510)  trun
 1510 format(/10x,' Run time = ',g10.3,' seconds')
      if (tuser .gt. 0.) then
        write (noutpt,1520) tuser
        write (nttyo,1520)  tuser
 1520   format(10x,'User time = ',g10.3,' seconds')
      endif
      if (tcpu .gt. 0.) then
        write (noutpt,1530) tcpu
        write (nttyo,1530)  tcpu
 1530   format(10x,' Cpu time = ',g10.3,' seconds')
      endif
c
      write (noutpt,1540)
      write (nttyo,1540)
 1540 format(/' Normal exit')
c
c     Clear the IEEE flag for floating-point underflow, if such a
c     flag is present, to avoid getting an unnecessary system
c     warning message. Underflow is a normal condition in EQ3/6.
c     Make porting changes in the EQLIBU subroutine that is called
c     in this section. Do not make the porting changes here.
c
      call cliefu()
c
c     Close files.
c
      close(ndat0s,status='delete')
c
      close(noutpt)
      close(nslist)
      close(ndata1)
      close(ndat1f)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gdavie(acflgc,actwlc,adh,al10,fxi,narn1,narn2,nstmax,
     $ omega,sigmam,xbrwlc,zchsq2)
c
c     This subroutine computes activity coefficients of aqueous species
c     using the Davies (1961) equation. The activity of water is
c     computed from an expression that was derived from the Davies
c     equation using thermodynamic consistency relations.
c
c     This subroutine is called by:
c
c        EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adh    = Debye-Huckel A(gamma) parameter
c       omega  = water constant; ~55.51.
c       sigmam = sum of solute molalities
c       xbrwlc = log mole fraction of water
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       zchsq2 = one-half the charge squared array
c
c     Principal output:
c
c       acflgc = array of log activity coefficients
c       actwlc = log activity of water
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer narn1,narn2
c
      real*8 acflgc(nstmax),zchsq2(nstmax)
      real*8 actwlc,adh,al10,fxi,omega,sigmam,xbrwlc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ns
c
      real*8 factor,fxisqt,sga,sgx,xxp1
c
c-----------------------------------------------------------------------
c
      fxisqt = sqrt(fxi)
      xxp1 = 1. + fxisqt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute log lambda(w).
c
      sgx = (3./(fxisqt**3))*( xxp1 - (1./xxp1) - 2.*log(xxp1) )
      sga = sigmam/al10
      actwlc = ( -sga + 2.*adh*(fxi**1.5)*sgx/3.
     $ - 0.2*adh*fxi*fxi )/omega
      acflgc(narn1) = actwlc - xbrwlc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute log gamma(i).
c
      factor = (fxisqt/xxp1) - 0.2*fxi
      factor = -2*adh*factor
      do ns = narn1 + 1,narn2
        acflgc(ns) = zchsq2(ns)*factor
      enddo
c
      end

      subroutine gmsum(conc,musumw,nmut,nmutmx,nmux,nstmax,pmu,uspec)
c
c     This subroutine computes the following triple sum used in Pitzer's
c     equations:
c
c       SUM(ijk) mu(ijk)*m(i)*m(j)*m(k)
c
c     This sum is used to calculate the activity coefficient
c     of water.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of concentration values
c       nmu    = number of mu values
c       nmux   = array of triples of species indices
c       pmu    = array of mu values
c
c     Principal output:
c
c       musumw =  the sum: SUM(ijk) mu(ijk)*m(i)*m(j)*m(k)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmutmx,nstmax
c
      integer nmux(3,nmutmx)
      integer nmut
c
      character(len=48) uspec(nstmax)
c
      real(8) conc(nstmax),pmu(nmutmx)
      real(8) musumw
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nmu,ns1,ns2,ns3
c
      real(8) cx
c
c-----------------------------------------------------------------------
c
      musumw = 0.
      do nmu = 1,nmut
        ns1 = nmux(1,nmu)
        ns2 = nmux(2,nmu)
        ns3 = nmux(3,nmu)
        cx = 6.
        if (ns1.eq.ns2 .and. ns1.ne.ns3) cx = 3.
        if (ns2.eq.ns3 .and. ns1.ne.ns3) cx = 3.
        if (ns1.eq.ns2 .and. ns1.eq.ns3) cx = 1.
        musumw = musumw + cx*pmu(nmu)*conc(ns1)*conc(ns2)*conc(ns3)
      enddo
c
      end

      subroutine miidxz(ier,iindx1,ipndx1,jpflag,jsflag,kbt,kdim,
     $ kmax,km1,kmt,kx1,kxt,losp,ncmpr,noutpt,npt,nptmax,nstmax,
     $ nttyo,uspec,uzvec1,zvclg1,zvec1)
c
c     This subroutine modifies the matrix indexing originally read in
c     from the input file. Modification occurs whenever a phase
c     boundary is crossed.
c
c     This subroutine is called by:
c
c       EQ6/dumpdp.f
c       EQ6/eqcalc.f
c       EQ6/setffg.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nptmax,nstmax
c
      integer iindx1(kmax),ipndx1(kmax),jpflag(nptmax),jsflag(nstmax),
     $ ncmpr(2,nptmax)
c
      integer ier,kbt,kdim,km1,kmt,kx1,kxt,noutpt,npt,nttyo
c
      character*48 uspec(nstmax),uzvec1(kmax)
c
      real*8 losp(nstmax),zvclg1(kmax),zvec1(kmax)
c
c-----------------------------------------------------------------------
c
c     Local sequence variable declarations.
c
      integer jlen,kcol,nr1,nr2,np,ns,nt
c
      character*56 uspn56
c
      real*8 lxx
c
      real*8 texp
c
c-----------------------------------------------------------------------
c
      ier = 0
c
      kcol = kbt
c
c     Do non-aqueous phases with only one species.
c
      do np = 1,npt
        if (jpflag(np) .eq. -1) then
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .eq. 1) then
            ns = nr1
            kcol = kcol + 1
            if (kcol .le. kmax) then
              iindx1(kcol) = ns
              ipndx1(kcol) = np
              uzvec1(kcol) = uspec(ns)
              jsflag(ns) = -1
              lxx = losp(ns)
              zvclg1(kcol) = lxx
              zvec1(kcol) = texp(lxx)
            else
c
c             Calling sequence substitutions:
c               uspec(ns) for unam48
c
              call fmspnm(jlen,uspec(ns),uspn56)
c
              write (noutpt,1000) kmax,uspn56(1:jlen)
              write (nttyo,1000) kmax,uspn56(1:jlen)
 1000         format(/' * Warning - (EQ6/miidxz) Have exceeded the',
     $        ' maximum ',i4,' elements of the',/7x,'iindx1 array',
     $        ' while trying to add ',a,/7x,'as a member of the',
     $        ' equilibrium system. Increase the dimensioning',
     $        /7x,'parameter kpar.')
              ier = 1
            endif
          endif
        endif
      enddo
      km1 = kbt + 1
      kmt = kcol
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do non-aqueous phases with more than one species.
c
      do np = 2,npt
        if (jpflag(np) .eq. -1) then
          nr1 = ncmpr(1,np)
          nr2 = ncmpr(2,np)
          nt = nr2 - nr1 + 1
          if (nt .ge. 2) then
            do ns = nr1,nr2
              if (jsflag(ns) .eq. -1) then
                kcol = kcol + 1
                if (kcol .le. kmax) then
                  iindx1(kcol) = ns
                  ipndx1(kcol) = np
                  uzvec1(kcol) = uspec(ns)
                  jsflag(ns) = -1
                  lxx = losp(ns)
                  zvclg1(kcol) = lxx
                  zvec1(kcol) = texp(lxx)
                else
c
c                 Calling sequence substitutions:
c                   uspec(ns) for unam48
c
                  call fmspnm(jlen,uspec(ns),uspn56)
c
                  write (noutpt,1000) uspn56(1:jlen)
                  write (nttyo,1000) uspn56(1:jlen)
                  stop
                endif
              endif
            enddo
          endif
        endif
      enddo
c
      kx1 = kmt + 1
      kxt = kcol
      kdim = kcol
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine gpress(iopt,jpress,noptmx,noutpt,nptkmx,nttyo,presg,
     $ presh,press,pressb,time1,ptk,xi1)
c
c     This subroutine computes the pressure (press) as a function of
c     reaction progress (xi1) or time (time1).
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       jpress = pressure tracking flag
c       ptk    = pressure tracking coefficients
c       time1  = time variable
c       xi1    = reaction progress variable
c
c     Principal output:
c
c       press  = pressure, bars
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noptmx,nptkmx
c
      integer noutpt,nttyo
c
      integer iopt(noptmx)
      integer jpress
c
      real*8 ptk(nptkmx)
      real*8 presg,presh,press,pressb,time1,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real*8 presmx
c
c-----------------------------------------------------------------------
c
c     Maximum allowed pressure (bars):
c
      data presmx /90000./
c
c-----------------------------------------------------------------------
c
      if (jpress .eq. 0) then
c
c       The pressure corresponds to the data file reference presssure
c       curve.
c
        press = presg
      elseif (jpress .eq. 1) then
c
c       The pressure corresponds to the 1.013-bar/steam-saturation
c       presssure curve.
c
        press = presh
      elseif (jpress .eq. 2) then
c
c       Constant pressure.
c
        press = pressb
      elseif (jpress .eq. 3) then
c
c       Linear tracking in reaction progress.
c
        press = pressb + ptk(1)*xi1
      elseif (jpress .eq. 4) then
c
c       Linear tracking in time.
c
        press = pressb + ptk(1)*time1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Stop if the pressure isn't greater than 0.
c
      if (press .le. 0) then
        write (noutpt,1010) press
        write (nttyo,1010) press
 1010   format(/' * Error - (EQ6/gpress) The pressure must be',
     $  /7x,'greater than zero. The current pressure is ',1pg12.5,
     $  ' bars.')
        stop
      endif
c
c     Stop if press is greater than presmx.
c
      if (press .gt. presmx) then
        write (noutpt,1020) press,presmx,xi1
        write (nttyo,1020) press,presmx,xi1
 1020   format(/' * Error - (EQ6/gpress) The calculated pressure',
     $  /7x,'is ',1pg12.5," C, greater than the code's built-in",
     $  /7x,'maximum value of ',g12.5,' bars. Other limits',
     $  /7x,'associated with the supporting data file may also apply.',
     $  /7x,'The current value of reaction progress is ',
     $  g12.5,' moles.')
        if (iopt(2) .gt. 0) then
          write (noutpt,1030) time1
          write (nttyo,1030) time1
 1030     format(7x,'The current time value is ',g12.5,' seconds.')
        endif
        stop
      endif
c
  999 continue
      end

      subroutine gwdenp(adwipp,bdwipp,jcsort,mlmrra,mosp,mrmlra,
     $ mwtsp,narn1,narn2,nstmax,qdwipp,rhoc,rhowc,tdsgks,tdsglw,
     $ tdspkc,tdsplc,tempc,vosol,wfh2o,wftds,wkgwi,woh2o,
     $ wosol,wotds)
c
c     This subroutine gets the weights of solute, total dissolved
c     solutes, and aqueous solution, and obtains the density of
c     the aqueous solution by evaluating the WIPP brine density
c     model. It also computes some related parameters, such
c     as the solution volume and the molarity/molality ratio.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       adwipp = 'a' constant in the WIPP brine density model
c       bdwipp = 'b' constant in the WIPP brine density model
c       jcsort = array of species indices in order of increasing
c                  concentration, organized into blocks, one per phase
c       mosp   = numbers of moles of species
c       mwtsp  = molecular weights of species
c       mwtsp  = molecular weights of species
c
c     Principal output:
c
c       mlmrra = molality/molarity ratio
c       mrmlra = molarity/molality ratio
c       qdwipp = .true. if results from the WIPP brine density model
c                  are available
c       rhoc   = the solution density (g/mL), calculated from the WIPP
c                  brine density model
c       rhowc  = the solution density (g/L), calculated from the WIPP
c                  brine density model
c       tdsglw = TDS (total dissolved solutes) (g/L), calculated
c                  from the WIPP brine density model
c       tdsgks = TDS (total dissolved solutes) (g/kg.sol)
c       tdspkc = TDS (total dissolved solutes) (mg/kg.sol)
c       tdsplc = TDS (total dissolved solutes) (mg/L), calculated
c                  from the WIPP brine density model
c       vosol  = Volume (L) of aqueous solution
c       wfh2o  = weight (mass) fraction of water in aqueous solution
c       wftds  = weight (mass) fraction of solutes in aqueous solution
c       woh2o  = weight (mass) of solvent water
c       wosol  = weight (mass) of aqueous solution
c       wotds  = weight (mass) of total dissolved solutes
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
c
      integer narn1,narn2
c
      logical qdwipp
c
      real(8) mosp(nstmax),mwtsp(nstmax)
c
      real(8) adwipp,bdwipp,mlmrra,mrmlra,rhoc,rhowc,tdsgks,tdsglw,
     $ tdspkc,tdsplc,tempc,vosol,wfh2o,wftds,wkgwi,woh2o,wosol,wotds
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
c     None
c
c-----------------------------------------------------------------------
c
c     Calculate the weights (actually, the masses) of total dissolved
c     solutes, the solvent, and the solution, and also some related
c     quantities.
c
c     Get the total dissolved solute mass (wotds, g).
c
      call ctds(jcsort,mosp,mwtsp,narn1,narn2,nstmax,wotds)
c
c     Get the solvent mass (fixed at 1000 grams in EQ3NR, variable
c     in EQ6). The following works for either code.
c
      woh2o = mosp(narn1)*mwtsp(narn1)
c
c     Get the mass of aqueous solution.
c
      wosol =  woh2o + wotds
c
c     Get the weight fraction of solvent and the weight fraction
c     of total dissolved solutes.
c
      wfh2o = woh2o/wosol
      wftds = wotds/wosol
c
c     Get the inverse of the weight of solvent, in kg.
c
      wkgwi = 1000./woh2o
c
c     Get the TDS (g/kg.solution)
c
      tdsgks = 1000.*wftds
c
c     Get the TDS (mg/kg.solution)
c
      tdspkc = 1000.*tdsgks
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calculate the solution density (rhowc) from the WIPP brine
c     density model if the temperature lies in the range 20-30 C.
c     This model is a fit to NaCl solution data having the form:
c
c       density (g/L) = a + b x TDS (g/L)
c
c     where a = 1000.96 and b = 0.639963. Note that this formulation
c     requires knowing TDS in g/L (tdsglw), which prevents a direct
c     evaluation using the above form because the density is not
c     available in the appropriate units. Also calculate the molarity/
c     molality conversion ratio (mrmlra, molarity = mrmlra x molality)
c     and its inverse.
c
      qdwipp = .false.
      rhowc = 0.
      vosol = 0.
      tdsglw = 0.
      mrmlra = 0.
      mlmrra = 0.
      rhoc = 0.
      tdsplc = 0.
c
      if (tempc.ge.20. .and. tempc.le.30.) then
c
c       Note that wfh2o corresponds to Nw, the "solvent fraction"
c       in the density calculations writeup. Here wftds corresponds
c       to "(1 - Nw)".
c
        qdwipp = .true.
        rhowc = adwipp/(1.0 - bdwipp*wftds)
        vosol = wosol/rhowc
        tdsglw = rhowc*wftds
        mrmlra = 0.001*wfh2o*rhowc
        if (mrmlra .gt. 0.) then
          mlmrra = 1./mrmlra
        else
          mlmrra = 1.e+38
        endif
        rhoc = 0.001*rhowc
        tdsplc = 1000.*tdsglw
      endif
c
  999 continue
      end

      subroutine adalph(alpha,ipbtmx,iz1,iz2,npx2,npx2mx)
c
c     This subroutine assigns standard values of the Pitzer
c     alpha parameters for the npx2-th species pair. The standard
c     values depend on the charge combination.
c
c     This subroutine is called by:
c
c       EQPT/rdpca.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndat0s = unit number of the stripped DATA0 file
c
c     Principal output:
c
c       nazt   = the number of specified hard core diameters
c       uazp   = array of aqueous species names used to specify
c                  hard core diamters on the data file
c       azero  = array of corresponding hard core diameters
c       insgf  = array of corresponding neutral species
c                  activity coefficient flags
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,npx2mx
c
      integer iz1,iz2,npx2
c
      real(8) alpha(ipbtmx,npx2mx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,iaz1,iaz2
c
c-----------------------------------------------------------------------
c
c     Assign standard alpha values for the npx2-th species pair,
c     according the charge combination.
c
      iaz1 = abs(iz1)
      iaz2 = abs(iz2)
c
      do i = 1,ipbtmx
        alpha(i,npx2) = 0.
      enddo
c
      if (iaz1.gt.0 .or. iaz2.gt.0) then
        if (iaz1.eq.1 .or. iaz2.eq.1) then
          alpha(1,npx2) = 2.
        else
          alpha(1,npx2) = 1.4
          alpha(2,npx2) = 12.0
        endif
      endif
c
      end

      subroutine openin(noutpt,nttyo,ufiln,uform,ilu)
c
c     This subroutine opens an input type file. The file must already
c     exist. An unused logical unit number is obtained.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = the unit number of the output file
c       nttyo  = the unit number of the screen file
c       ufiln  = the name of the file to open
c       uform  = the file format, 'formatted' or 'unformatted'
c
c     Output:
c
c       ilu     = the logical unit number of opened file
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
c     Note- the character length for the variables ufiln and uform
c     can not be exactly specified.
c
      integer ilu,noutpt,nttyo
c
      character*(*) ufiln,uform
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nerr
c
      integer ilnobl
c
      logical qex
c
      character*8 uformo
c
c-----------------------------------------------------------------------
c
      j2 = ilnobl(ufiln)
c
c     Check to make sure the file exists.
c
      inquire(file=ufiln,exist=qex,formatted=uformo)
      if (.not.qex) then
        if (noutpt .gt. 0) write (noutpt,1000) ufiln(1:j2)
        write (nttyo,1000) ufiln(1:j2)
 1000   format(/' * Error - (EQLIBU/openin) The file "',a,'"',
     $  /7x,'does not exist.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the file format.
c
      if (uform.eq.'formatted' .and. uformo.eq.'no') then
        if (noutpt .gt. 0) write (noutpt,1010) ufiln(1:j2)
        write (nttyo,1010) ufiln(1:j2)
 1010   format(/' * Error - (EQLIBU/openin) The file "',a,'"',
     $  /7x,'should be formatted, but it is not.')
        stop
      endif
c
      if (uform.eq.'unformatted' .and .uformo.eq.'yes') then
c       if (noutpt .gt. 0) write (noutpt,1020) ufiln(1:j2)
c       write (nttyo,1020) ufiln(1:j2)
c1020   format(/' * Error - (EQLIBU/openin) The file "',a,'"',
c    $  /7x,'should be unformatted, but it is not.')
c     stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the next available logical unit number.
c
      call getlu(ilu,nerr)
      if (nerr .ne. 0) then
        if (noutpt .gt. 0) write (noutpt,1050) ufiln(1:j2)
        write (nttyo,1050) ufiln(1:j2)
 1050   format(/' * Error - (EQLIBU/openin) No logical unit number',
     $  /7x,'is available for the file "',a,'".')
      stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      open(ilu,file=ufiln,form=uform,status='old',err=10)
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
   10 continue
      if (noutpt .gt. 0) write (noutpt,1060) ufiln(1:j2)
      write (nttyo,1060) ufiln(1:j2)
 1060 format(/" * Error - (EQLIBU/openin) Can't open the file",
     $ /7x,'"',a,'".')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cfracf(cdrs,csts,efac,jcsort,jflag,jssort,kmax,mosp,
     $ narn1,narn2,nbasp,nbaspd,nbt,nbtmax,ndrs,ndrsmx,ndrsr,nern1,
     $ nern2,nfac,nst,nstmax,nsts,nstsmx,nstsr,q6mode,weight)
c
c     This subroutine determines the dominant species and the associated
c     exponents required for continued fraction corrections. The data
c     are returned without any filtering as to their applicability.
c     particularly when the calling prgram is EQ3NR. For example, data
c     may be returned for mass balances for H+ or O2(g,aq), when
c     no such balances are used.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c       EQ6/optmzr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       mosp   = array containing the number of moles variables for the
c                  species; the conc array may be substituted for this
c                  in some calls
c       jcsort = array of species indices in sorted order within phase
c                  ranges
c       jssort = array of species indices in sorted order, ignoring
c                  phase ranges
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6NR
c
c
c     Principal output:
c
c       efac   = array of exponents for continued fraction corrections
c       nfac   = array of indices of dominant species
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nstmax,nstsmx
c
      integer jcsort(nstmax),jflag(nstmax),jssort(nstmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),nfac(nbtmax),
     $ nsts(nstsmx),nstsr(2,nstmax)
c
      integer narn1,narn2,nbt,nern1,nern2,nst
c
      logical q6mode
c
      real*8 cdrs(ndrsmx),csts(nstsmx),efac(nbtmax),mosp(nstmax),
     $ weight(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nb,nr1,ns,nse,nsi,nss
c
      real*8 cx,stx,wsi
      real*8 coefdr,coefst
c
c-----------------------------------------------------------------------
c
c     Initialize the nfac and efac arrays.
c
      do nb = 1,nbt
        nfac(nb) = 0
        efac(nb) = 1.0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop over all mass balances, used or not.
c
      do nb = 1,nbt
        nse = nbasp(nb)
c
        if (jflag(nse) .eq. 0) then
c
          do ns = 1,nst
            weight(ns) = 0.
          enddo
c
          do nss = narn1,narn2
            ns = jcsort(nss)
            weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
          enddo
c
          if (q6mode) then
            do nss = nern1,nern2
              ns = jcsort(nss)
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            enddo
          endif
c
c         Find the species (nfac) that makes the largest contribution
c         to the mass balance. Get the exponent (efac) required for the
c         continued fraction correction.
c
          call fdomsp(jssort,mosp,nsi,nst,nstmax,weight,wsi)
c
c         Get the exponent (efac) required for the continued fraction
c         correction.
c
          nfac(nb) = nsi
          ns = nbaspd(nb)
          if (nse .eq. ns) then
            efac(nb) = 1./wsi
          else
            cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
            nr1 = ndrsr(1,ns)
            stx = -cx/cdrs(nr1)
            efac(nb) = 1./(stx*wsi)
          endif
        endif
      enddo
c
      end

      subroutine d1ztay(delxi,dzvc0,d1zvc1,kdim,kmax,nord,nrd1mx)
c
c     This subroutine computes the Taylor's series expansions for the
c     first derivatives of the master variables. These expansions are
c     used to find points of reaction progress at which such variables
c     maximize. At such points, for example in the fluid-centered
c     flow-through open system model,it may be necessary to transfer
c     mass of a corresponding phase from the ES to the PRS.
c
c     See also:
c
c       EQ6/d2ztay.f
c       EQ6/ztaylr.f
c
c     This subroutine is called by:
c
c       EQ6/eqcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       delxi  = the step size (in reaction progress)
c       dzvc0  = the dz/d(xi) vector at the base point
c       kdim   = the number of elements in the z vector
c       kmax   = the maximum number of elements in the z vector
c       nord   = the order of the truncated Taylor's series
c       nrd1mx = the maximum order of the truncated Taylor's series + 1
c
c     Principal output:
c
c       d1zvc1 = the dz/d(xi) vector at the new point
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nrd1mx
c
      integer kdim,nord
c
      real*8 dzvc0(nrd1mx,kmax),d1zvc1(kmax)
c
      real*8 delxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jk,kcol
c
      real*8 dxp,d1z
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      if (nord .gt. 0) then
        do kcol = 1,kdim
          d1z = dzvc0(1,kcol)
          if (nord .gt. 1) then
            jk = nord - 1
            dxp = 1.
            do j = 1,jk
              dxp = dxp*delxi
              d1z = d1z + ( dzvc0(j + 1,kcol)/fctrl(j) )*dxp
            enddo
          endif
          d1zvc1(kcol) = d1z
        enddo
      endif
c
      end

      subroutine suprdx(jflag,jsflag,narn1a,narn2a,ndrsd,ndrsmx,
     $ ndrsrd,nrdxsp,nsta,nstmax,uspeca)
c
c     This subroutine executes the option to suppress all redox
c     reactions. This is not the same as suppressing all redox
c     species. An auxiliary basis species (say Oxalate-) that is
c     in the active basis set (and hence has its own mass balance
c     relation) is detached from any other species in the active
c     basis set, including the redox species. It should not be
c     suppressed as part of a general suppression of redox. For
c     example, if Oxalate- is given its own mass balance relation,
c     then equilibirum of its associated reaction, which is of redox
c     type linking it to HCO3-, would be overridden. Tn effect,
c     Oxalate- would be treated as being composed of a pseudo-element.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ndrsmx,nstmax
c
      integer jflag(nstmax),jsflag(nstmax),ndrsd(ndrsmx),
     $ ndrsrd(2,nstmax)
c
      integer narn1a,narn2a,nrdxsp,nsta
c
      character(len=48) uspeca(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer kcount,n,ncount,nr1,nr2,ns,nse
c
c-----------------------------------------------------------------------
c
      ncount = 0
c
c     First, suppress any species whose associated reaction involves
c     the redox species, unless equilibrium for that reaction has been
c     over-ridden. Currently, such an over-ride is possible only for
c     certain aqueous species. For them, this condition is marked by
c     jflag is not 30.
c
      do ns = 1,narn1a - 1
c
c       Species preceding the block of aqueous species. There
c       should be none.
c
        if (jsflag(ns) .lt. 2) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          do n = nr1 + 1,nr2
            nse = ndrsd(n)
            if (nse .eq. nrdxsp) then
              jsflag(ns) = 2
              ncount = ncount + 1
              go to 100
            endif
          enddo
  100     continue
        endif
      enddo
c
      do ns = narn1a,narn2a
c
c       Aqueous species.
c
        if (jflag(ns) .eq. 30) then
          if (jsflag(ns) .lt. 2) then
            nr1 = ndrsrd(1,ns)
            nr2 = ndrsrd(2,ns)
            do n = nr1 + 1,nr2
              nse = ndrsd(n)
              if (nse .eq. nrdxsp) then
                jsflag(ns) = 2
                ncount = ncount + 1
                go to 110
              endif
            enddo
  110       continue
          endif
        endif
      enddo
c
      do ns = narn2a + 1,nsta
c
c       Species following the block of aqueous species.
c
        if (jsflag(ns) .lt. 2) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          do n = nr1 + 1,nr2
            nse = ndrsd(n)
            if (nse .eq. nrdxsp) then
              jsflag(ns) = 2
              ncount = ncount + 1
              go to 120
            endif
          enddo
  120     continue
        endif
      enddo
c
      if (ncount .le. 0) go to 999
c
c     Now check to insure that any species that are actively linked
c     to species that are now suppressed are themselves suppressed.
c
  210 kcount = 0
c
      do ns = 1,narn1a - 1
c
c       Species preceding the block of aqueous species. There
c       should be none.
c
        if (jsflag(ns) .lt. 2) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          do n = nr1 + 1,nr2
            nse = ndrsd(n)
            if (jsflag(nse) .ge. 2) then
              jsflag(ns) = 2
              kcount = kcount + 1
              ncount = ncount + 1
              go to 220
            endif
          enddo
  220     continue
        endif
      enddo
c
      do ns = narn1a,narn2a
c
c       Aqueous species.
c
        if (jflag(ns) .eq. 30) then
          if (jsflag(ns) .lt. 2) then
            nr1 = ndrsrd(1,ns)
            nr2 = ndrsrd(2,ns)
            do n = nr1 + 1,nr2
              nse = ndrsd(n)
              if (jsflag(nse) .ge. 2) then
                jsflag(ns) = 2
                kcount = kcount + 1
                ncount = ncount + 1
                go to 230
              endif
            enddo
  230       continue
          endif
        endif
      enddo
c
      do ns = narn2a + 1,nsta
c
c       Species following the block of aqueous species.
c
        if (jsflag(ns) .lt. 2) then
          nr1 = ndrsrd(1,ns)
          nr2 = ndrsrd(2,ns)
          do n = nr1 + 1,nr2
            nse = ndrsd(n)
            if (jsflag(nse) .ge. 2) then
              jsflag(ns) = 2
              kcount = kcount + 1
              ncount = ncount + 1
              go to 240
            endif
          enddo
  240     continue
        endif
      enddo
c
      if (kcount .gt. 0) go to 210
c
  999 continue
c
      end

      subroutine gsdsm(conc,dpslm,nslt,nsltmx,nslx,nstmax,
     $ spsum,spsump,uspec)
c
c     This subroutine computes the following second order sums used
c     in Pitzer's equations:
c
c       spsum:  SUM(jk) S-lambda'(jk)*m(j)*m(k)
c       spsump: SUM(jk) S-lambda''(jk)*m(j)*m(k)
c
c     Here jk always refers to a cation-anion pair. Note that:
c
c       spsum  = 2 * SUM(ca) B'(ca)m(a)m(c)
c       spsump = 2 * SUM(ca) B''(ca)m(a)m(c)
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c      Principal input:
c
c       conc   = array of concentration values
c       nslt   = number of S-lambda functions
c       nslx   = array of S-lambda species index pairs
c       dpslm  = array of ionic strength derivatives of S-lambda
c                  functions
c
c     Principal output:
c
c       spsum  = the sum: SUM(jk) S-lambda'(jk)*m(j)*m(k)
c       spsump = the sum: SUM(jk) S-lambda''(jk)*m(j)*m(k)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nsltmx,nstmax
c
      integer nslx(2,nsltmx)
      integer nslt
c
      character(len=48) uspec(nstmax)
c
      real(8) conc(nstmax),dpslm(2,nsltmx)
c
      real(8) spsum,spsump
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nsl,ns2,ns3
c
      real(8) cp
c
c-----------------------------------------------------------------------
c
      spsum = 0.
      spsump = 0.
      do nsl = 1,nslt
        ns2 = nslx(1,nsl)
        ns3 = nslx(2,nsl)
        cp = conc(ns2)*conc(ns3)
        spsum = spsum + dpslm(1,nsl)*cp
        spsump = spsump + dpslm(2,nsl)*cp
      enddo
      spsum = 2.*spsum
      spsump = 2.*spsump
c
      end

      subroutine abswpk(beta,cdrs,csts,efac,ibswx,iebal,iindx1,
     $ jcsort,jflag,jssort,kbt,kmax,mosp,narn1,narn2,nbasp,nbaspd,
     $ nbt,nbtmax,ndrs,ndrsmx,ndrsr,nelect,nhydr,no2gaq,nstmax,
     $ nsts,nstsmx,nstsr,qbswx,q6mode,weight)
c
c     This subroutine determines the dominant species and the associated
c     factors required for continued fraction corrections.
c
c     This subroutine is called by:
c
c       EQLIB/absswa.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       beta   = array of normalized Newton-Raphson residual functions
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6
c
c     Principal output:
c
c       ibswx  = array of species indices of candidates for switching
c                  into the active basis set
c       qbswx  = flag denoting that candidates were found for
c                  basis switching
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nstmax,nstsmx
c
      integer ibswx(nbtmax),iindx1(kmax),jcsort(nstmax),jflag(nstmax),
     $ jssort(nstmax),nbasp(nbtmax),nbaspd(nbtmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax),nsts(nstsmx),nstsr(2,nstmax)
c
      integer iebal,kbt,narn1,narn2,nbt,nelect,nhydr,no2gaq
c
      logical qbswx,q6mode
c
      real(8) beta(kmax),cdrs(ndrsmx),csts(nstsmx),efac(nbtmax),
     $ mosp(nstmax),weight(nstmax)
c
      real(8) coefdr,coefst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ix,iy,krow,nb,ns,nse,nsi,nsj
c
      logical qskip
c
      real(8) btest,cx,wsi
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that nbt and jssort
c     are not used.
c
      ix = nbt
      iy = ix
      nbt = iy
c
      ix = jssort(1)
      iy = ix
      jssort(1) = iy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set flag indicating that candidates for basis switching exist.
c
      qbswx = .false.
c
c     Clear the ibswx array.
c
      call initiz(ibswx,nbtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Loop over all mass balance relations.
c
      do krow = 1,kbt
        nb = iindx1(krow)
        nse = nbaspd(nb)
        nsj = nbasp(nb)
c
        if (nse.ne.narn1 .and. nse.ne.nhydr .and. nb.ne.iebal .and.
     $    nse.ne.no2gaq .and.nse.ne.nelect) then
c
c         If the current species is not H2O, H+, O2(g,aq), or e-,
c         and is not being used for electrical balancing in EQ3NR,
c         consider a switch.
c
c         Pick a candidate for automatic basis switching if a
c         continued fraction correction would be large. Store
c         the index of the candidate, if any, in the array ibswx.
c
          btest = (beta(krow) + 1.)**efac(nb)
          if (btest .ge. 10.) then
c
            do ns = narn1,narn2
              weight(ns) = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
            enddo
c
c           Screen out species in the mass balance that are not
c           linked by current reaction with the current basis species.
c           Do this by setting the corresonding weights to zero.
c
            do ns = narn1,narn2
              if (jflag(ns) .eq. 30) then
c
c               Calling sequence substitutions:
c                 nsj for nse
c
                cx = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nsj,ns,nstmax)
                if (cx .eq. 0.) weight(ns) = 0.
              endif
            enddo
c
            call fbassw(jcsort,jflag,mosp,narn1,narn2,nse,nsi,nsj,
     $      nstmax,weight,wsi)
c
            if (nsi .gt. 0) then
              ibswx(nb) = nsi
              qbswx = .true.
            endif
          endif
        endif
      enddo
c
      end

      subroutine sderiv(akmat0,demos0,fdse0,nord,nordmx,nrd1mx,
     $ nset,nsetmx)
c
c     This subroutine computes estimates of the derivatives of the
c     numbers of moles of selected species in the equilibrium system.
c     These species include H2O(l) for the aqueous solution and all
c     species of the non-aqueous phases. These derivatives (demos0)
c     are computed from the corresponding finite differences (fdse0).
c     The relation is: (demos0) = (akmat0)(fdse0).
c
c     Compare with:
c
c       EQ6/aderiv.f
c       EQ6/bderiv.f
c       EQ6/pderiv.f
c       EQ6/rderiv.f
c       EQ6/zderiv.f
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nordmx,nrd1mx,nsetmx
c
      integer nord,nset
c
      real*8 akmat0(nrd1mx,nrd1mx),demos0(nordmx,nsetmx),
     $ fdse0(nordmx,nsetmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,n,nse
c
      real*8 dx
c
c-----------------------------------------------------------------------
c
      do nse = 1,nset
        do n = 1,nord
          dx = 0.
          do k = n,nord
            dx = dx + fdse0(k,nse)*akmat0(n,k)
          enddo
          demos0(n,nse) = dx
        enddo
      enddo
c
      end

      subroutine prtgex(acflg,actlg,affpd,affsd,cegexs,conc,
     $ egexjc,egexjf,egexpa,egexpc,egexs,egexw,iern1,iern2,ietmax,
     $ jern1,jern2,jetmax,jgext,kern1,kern2,ketmax,kgexsa,moph,
     $ mosp,netmax,ngexsa,ngext,noutpt,np,nptmax,nstmax,sidrph,
     $ sidrsp,tolspf,ugexj,ugexmo,uspec,uphase,xbar,xbarlg,xgexw,
     $ wkgwi)
c
c     This subroutine prints tables describing the state and properties
c     of the np-th phase (a generic ion exchanger). It is analogous to
c     EQLIB/prtsso.f, which prints the same tables for solid solution
c     phases.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of log activity coefficients
c       actlg  = array of log activities of species
c       affpd  = array of phase affinities
c       affsd  = array of species affinities
c       sidrph = array of phase saturation indices
c       sidrsp = array of species saturation indices
c       tolspf = saturation print flag tolerance, used to flag those
c                  phases which are close to saturation
c       uphase = array of phase names
c       xbar   = array of mole fractions of species
c       xbarlg = array of log mole fractions of species
c
c     Principal output:
c
c       None
c
c----------------------------------------------------------------------
c
      implicit none
c
c----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ietmax,jetmax,ketmax,netmax,nptmax,nstmax
c
      integer noutpt
c
      integer jern1(jetmax,netmax),jern2(jetmax,netmax),jgext(netmax),
     $ kern1(netmax),kern2(netmax),kgexsa(ketmax,netmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax)
c
      integer iern1,iern2,np
c
      character*48 uspec(nstmax)
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
c
      real*8 acflg(nstmax),actlg(nstmax),affpd(nptmax),affsd(nstmax),
     $ cegexs(ietmax,jetmax,netmax),conc(nstmax),egexjc(jetmax,netmax),
     $ egexjf(jetmax,netmax),egexpa(netmax),egexpc(netmax),
     $ egexs(ietmax,jetmax,netmax),egexw(ketmax,netmax),moph(nptmax),
     $ mosp(nstmax),sidrph(nptmax),sidrsp(nstmax),xbar(nstmax),
     $ xbarlg(nstmax),xgexw(ketmax,netmax)
c
      real*8 tolspf,wkgwi
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ie,je,j2,j3,j4,ke,nr1,nr2,ne,ns,nss
c
      integer ilnobl
c
      character*24 ux24
c
      real*8 aafx,afx,cxp,elx,ex,expkg,mxp,xlx,xx
c
      real*8 tlg
c
c----------------------------------------------------------------------
c
      mxp = moph(np)
      j2 = ilnobl(uphase(np))
c
      if (np.lt.iern1 .or. np.gt. iern2) then
        write (noutpt,1000) uphase(np)(1:j2)
        write (noutpt,1000) uphase(np)(1:j2)
 1000   format(/' * Error - (EQLIB/prtgex) Programming error trap:',
     $  /7x,"Can't write an output table for ",a," because",
     $  /7x,"it isn't a generic ion exchanger.")
        stop
      endif
c
      ne = np - iern1 + 1
c
      write (noutpt,1010) uphase(np)(1:j2)
 1010 format(/16x,'--- ',a,' ---',/)
c
      cxp = mxp*wkgwi
      j3 = ilnobl(ugexmo(ne))
      write (noutpt,1020) ugexmo(ne)(1:j3),mxp,cxp
 1020 format(/5x,'Exchanger model= ',a,
     $ /5x,'Amount of substrate (Z)= ',1pe11.4,
     $ ' mol',/5x,'Concentration of substrate= ',e11.4)
c
      if (egexpc(ne) .ne. 0.) then
        ex = egexpc(ne)*mxp
        expkg = ex*wkgwi
        write (noutpt,1024) egexpc(ne),ex,expkg
 1024   format(/5x,'Apparent cation exchange capacity= ',1pe11.4,
     $  ' eq/mol',/5x,'Total exchangeable cations= ',e11.4,' eq',
     $  /5x,'Total exchangeable cations= ',e11.4,' eq/kg.H2O')
      endif
c
      if (egexpa(ne) .ne. 0.) then
        ex = egexpa(ne)*mxp
        expkg = ex*wkgwi
        write (noutpt,1030) egexpa(ne),ex,expkg
 1030   format(/5x,'Apparent anion exchange capacity= ',1pe11.4,
     $  ' eq/mol',/5x,'Total exchangeable anions= ',e11.4,' eq',
     $  /5x,'Total exchangeable anions= ',e11.4,' eq/kg.H2O')
      endif
c
      do je = 1,jgext(ne)
        j4 = ilnobl(ugexj(je,ne))
        ex = egexjc(je,ne)*mxp
        expkg = ex*wkgwi
        write (noutpt,1040) ugexj(je,ne)(1:j4),egexjf(je,ne),
     $  egexjc(je,ne),ex,expkg
 1040   format(/7x,'Site: ',a,//9x,'Formal exchange capacity= ',
     $  1pe11.4,' eq/mol',/9x,'Apparent exchange capacity= ',
     $  e11.4,' eq/mol',/9x,'Total exchangeable ions= ',
     $  e11.4,' eq',/9x,'Total exchangeable ions= ',
     $  e11.4,' eq/kg.H2O',/)
c
c       Print equivalents and equivalents/kg.H2O.
c
        write (noutpt,1070)
 1070   format(/13x,'Component',19x,'eq',10x,'eq/kg.H2O',/)
c
        ns = jern1(je,ne) - 1
        do ie = 1,ngext(je,ne)
          ns = ns + 1
          ex = cegexs(ie,je,ne)*mosp(ns)
          expkg = ex*wkgwi
          nss = ngexsa(ie,je,ne)
          if (nss .le. 0) then
            ux24 = '__ '
          else
            ux24 = uspec(nss)
          endif
          if (nss .gt. 0) write (noutpt,1080) ux24,ex,expkg
 1080     format(10x,a24,3x,1pe11.4,3x,e11.4)
        enddo
c
c       Print equivalent fractions.
c
        write (noutpt,1110)
 1110   format(//13x,'Component',20x,'e',11x,'Log e',/)
c
        ns = jern1(je,ne) - 1
        do ie = 1,ngext(je,ne)
          ns = ns + 1
          ex = egexs(ie,je,ne)
          nss = ngexsa(ie,je,ne)
          if (nss .gt. 0) then
            ux24 = uspec(nss)
            elx = tlg(ex)
            write (noutpt,1130) ux24,ex,elx
 1130       format(10x,a24,3x,1pe11.4,3x,0pf9.4)
          endif
        enddo
        write (noutpt,1090)
 1090   format(1x)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1140)
 1140 format(/6x,'Whole-Phase Equivalent Fractions',
     $ //4x,'Component',20x,'e',11x,'Log e',/)
c
      do ke = kern1(ne),kern2(ne)
        nss = kgexsa(ke,ne)
        if (nss .gt. 0) then
          ex = egexw(ke,ne)
          elx = tlg(ex)
          write (noutpt,1160) uspec(nss),ex,elx
 1160     format(1x,a24,3x,1pe11.4,3x,0pf9.4)
        endif
      enddo
c
      write (noutpt,1170)
 1170 format(//6x,'Whole-Phase Mole Fractions',
     $ //4x,'Component',20x,'x',11x,'Log x',/)
c
      do ke = kern1(ne),kern2(ne)
        nss = kgexsa(ke,ne)
        if (nss .gt. 0) then
          xx = xgexw(ke,ne)
          xlx = tlg(xx)
          write (noutpt,1160) uspec(nss),xx,xlx
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print mole fractions, activity coefficients, and activities.
c
      write (noutpt,1180)
 1180 format(//6x,'Thermodynamic Summary',
     $ //4x,'Component',20x,'x',11x,'Log x',3x,'Log lambda',2x,
     $ 'Log activity',/)
c
      do je = 1,jgext(ne)
        nr1 = jern1(je,ne)
        nr2 = jern2(je,ne)
        do ns = nr1,nr2
          if (xbar(ns) .gt. 0.) then
            write (noutpt,1190) uspec(ns),xbar(ns),xbarlg(ns),
     $      acflg(ns),actlg(ns)
 1190       format(1x,a24,3x,1pe11.4,3(3x,0pf9.4))
          endif
        enddo
        write (noutpt,1090)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print saturation states and affinities.
c
      write (noutpt,1200)
 1200 format(/4x,'Exchanger',21x,'Log Q/K',9x,'Aff, kcal',4x,'State',/)
      afx = affpd(np)
      aafx = abs(afx)
      if (aafx .le. tolspf) then
        write (noutpt,1210) uphase(np),sidrph(np),affpd(np)
 1210   format(1x,a24,2x,2(3x,f13.4),3x,'SATD')
      elseif (afx .gt. tolspf) then
        write (noutpt,1220) uphase(np),sidrph(np),affpd(np)
 1220   format(1x,a24,2x,2(3x,f13.4),3x,'SSATD')
      else
        write (noutpt,1230) uphase(np),sidrph(np),affpd(np)
 1230   format(1x,a24,2x,2(3x,f13.4))
      endif
      write (noutpt,1090)
c
      do je = 1,jgext(ne)
        nr1 = jern1(je,ne)
        nr2 = jern2(je,ne)
        do ns = nr1,nr2
          if (xbar(ns) .gt. 0.) then
            afx = affsd(ns)
            aafx = abs(afx)
            if (aafx .le. tolspf) then
              write (noutpt,1240) uspec(ns),sidrsp(ns),affsd(ns)
 1240         format(3x,a24,2(3x,f13.4),3x,'SATD')
            elseif (afx .gt. tolspf) then
              write (noutpt,1250) uspec(ns),sidrsp(ns),affsd(ns)
 1250         format(3x,a24,2(3x,f13.4),3x,'SSATD')
            else
              write (noutpt,1260) uspec(ns),sidrsp(ns),affsd(ns)
 1260         format(3x,a24,2(3x,f13.4))
            endif
          endif
        enddo
        write (noutpt,1090)
      enddo
c
      end

      subroutine escalc(csts,iindx1,jcsort,kbt,kmax,moph,mosp,mtb,
     $ mtb0,nbaspd,nbt,nbtmax,ncmpr,noutpt,npt,nptmax,nstmax,nsts,
     $ nstsmx,nstsr,qprflg,uspec)
c
c     This subroutine recomputes the mass balance totals for the
c     Equilibrium System (ES). Normally, this is done immediately
c     after a shift of material from the ES to the Physically Removed
c     System (PRS). The calculation is performed by summing over what
c     remains in the ES, so it is not sensitive to the nature of
c     the material that was transferred.
c
c     This subroutine is called by:
c
c       EQ6/dumpdp.f
c       EQ6/pshfta.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nptmax,nstmax,nstsmx
c
      integer noutpt
c
      integer iindx1(kmax),jcsort(nstmax),nbaspd(nbtmax),
     $ ncmpr(2,nptmax),nsts(nstsmx),nstsr(2,nstmax)
c
      integer kbt,nbt,npt
c
      logical qprflg
c
      character*48 uspec(nstmax)
c
      real*8 csts(nstsmx),moph(nptmax),mosp(nstmax),mtb(nbtmax),
     $ mtb0(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer kcol,n,nb,np,nrn1,nrn2,nr1,nr2,ns,nss
c
c-----------------------------------------------------------------------
c
      call copyaa(mtb,mtb0,nbt)
c
      do nb = 1,nbt
        mtb(nb) = 0.
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do np = 1,npt
        if (moph(np) .gt. 0.) then
          nrn1 = ncmpr(1,np)
          nrn2 = ncmpr(2,np)
          do nss = nrn1,nrn2
            ns = jcsort(nss)
            if (mosp(ns) .gt. 0.) then
              nr1 = nstsr(1,ns)
              nr2 = nstsr(2,ns)
              do n = nr1,nr2
                nb = nsts(n)
                mtb(nb) = mtb(nb) + csts(n)*mosp(ns)
              enddo
            endif
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qprflg) then
        write (noutpt,1000)
 1000   format(/'   --- Mass Balance Totals ---',
     $  //3x,'Species',20x,'Old',10x,'New',/)
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbaspd(nb)
          write (noutpt,1010) uspec(ns),mtb0(nb),mtb(nb)
 1010     format(1x,a24,2(2x,1pe12.5))
        enddo
        write (noutpt,1020)
 1020   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      call copyaa(mtb,mtb0,nbt)
c
      end

      subroutine elim(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $ axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $ ipcv,ipcvmx,jsflag,narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,
     $ nse,nst,nstmax,ntprmx,noutpt,nttyo,uspec)
c
c     This subroutine rewrites reaction equations so that the auxiliary
c     basis species with index nse and jflag = 30 is eliminated from
c     all reactions except the one linking it with its corresponding
c     strict basis variable. The polynomial coefficients for computing
c     the equilibrium coefficients are recomputed accordingly.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,ndrsmx,nstmax,ntprmx
c
      integer jsflag(nstmax),ndrs(ndrsmx),ndrsx(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrx(2,nstmax)
      integer ipch,ipcv,nse,nst,noutpt,nttyo
c
      character*48 uspec(nstmax)
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsx(ndrsmx)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j,jlen,n,nnx,nre1,nre2,nr1,nr2,ns,nss,nt
c
      character*56 uspn56
c
      real*8 cx,cxe,cxee,cxse,cxss,stofac
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
c
      nt = ndrsr(2,nse) - ndrsr(1,nse) + 1
      if (nt .lt. 2) then
c
c       Calling sequence substitutions:
c         uspec(nse) for unam48
c
        call fmspnx(jlen,uspec(nse),uspn56)
        write (noutpt,1000) uspn56(1:jlen)
        write (nttyo,1000) uspn56(1:jlen)
 1000   format(/' * Error - (EQLIB/elim) The species ',a,
     $  /7x,'is in the strict basis and therefore can not be',
     $  ' eliminated',/7x,'from the working basis set.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Calling sequence substitutions:
c       nse for ns
c
      cxee = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,nse,nstmax)
      nre1 = ndrsr(1,nse)
      nre2 = ndrsr(2,nse)
c
      nnx = 0
      do ns = 1,nst
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        ndrsrx(1,ns) = nnx + 1
        cxe = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nse,ns,nstmax)
        if (ns.eq.nse .or. cxe.eq.0. .or. jsflag(ns).ge.2) then
c
c         Have found a reaction that is not to be changed.
c
          do n = nr1,nr2
            nnx = nnx + 1
            if (nnx .gt. ndrsmx) then
c
c             Calling sequence substitutions:
c               uspec(nse) for unam48
c
              call fmspnx(jlen,uspec(nse),uspn56)
              write (noutpt,1005) ndrsmx,uspn56(1:jlen),ndrsmx
              write (nttyo,1005) ndrsmx,uspn56(1:jlen),ndrsmx
 1005         format(/' * Error - (EQLIB/elim) The maximum ',i7,
     $        ' entries in the',/7x,'cdrs and ndrs arrays has been',
     $        ' exceeded in trying to eliminate',/7x,'the species ',
     $        a,' from the working basis set.',/7x,'Increase the',
     $        ' dimensioning  parameter ndrspa from its current',
     $        /7x,'value of ',i6,'.')
              stop
            endif
            cdrsx(nnx) = cdrs(n)
            ndrsx(nnx) = ndrs(n)
          enddo
          ndrsrx(2,ns) = nnx
c
c         Log K coefficients.
c
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = axlks(i,j,ns)
            enddo
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axhfsx(i,j,ns) = axhfs(i,j,ns)
              enddo
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axvfsx(i,j,ns) = axvfs(i,j,ns)
              enddo
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
                enddo
              enddo
            enddo
          endif
c
        else
c
          stofac = cxe/cxee
c
c         Do species appearing in the existing reaction for the ns-th
c         species.
c
          do n = nr1,nr2
            nss = ndrs(n)
c
c           Calling sequence substitutions:
c             nss for nse
c             nse for ns
c
            cxse = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nss,nse,nstmax)
            cx = cdrs(n) - stofac*cxse
            if (abs(cx) .le. eps100) cx = 0.
            if (cx .ne. 0.) then
              nnx = nnx + 1
              if (nnx .gt. ndrsmx) then
c
c               Calling sequence substitutions:
c                 uspec(nse) for unam48
c
                call fmspnx(jlen,uspec(nse),uspn56)
                write (noutpt,1005) ndrsmx,uspn56(1:jlen),ndrsmx
                write (nttyo,1005) ndrsmx,uspn56(1:jlen),ndrsmx
                stop
              endif
              cdrsx(nnx) = cx
              ndrsx(nnx) = nss
            endif
          enddo
c
c         Do species appearing in the existing reaction for the nse-th
c         species but not in that for the ns-th species.
c
          do n = nre1,nre2
            nss = ndrs(n)
c
c           Calling sequence substitutions:
c             nss for nse
c             nse for ns
c
            cxse = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nss,nse,nstmax)
c
c           Calling sequence substitutions:
c             nss for nse
c
            cxss = coefdr(cdrs,ndrs,ndrsmx,ndrsr,nss,ns,nstmax)
            if (cxss .eq. 0.) then
              cx = -stofac*cxse
              if (abs(cx) .le. eps100) cx = 0.
              if (cx .ne. 0.) then
                nnx = nnx + 1
                if (nnx .gt. ndrsmx) then
c
c                 Calling sequence substitutions:
c                   uspec(nse) for unam48
c
                  call fmspnx(jlen,uspec(nse),uspn56)
                  write (noutpt,1005) ndrsmx,uspn56(1:jlen),ndrsmx
                  write (nttyo,1005) ndrsmx,uspn56(1:jlen),ndrsmx
                  stop
                endif
                cdrsx(nnx) = cx
                ndrsx(nnx) = nss
              endif
            endif
          enddo
c
c         If the new reaction has no entries, put in a null entry.
c
          if (nnx .lt. ndrsrx(1,ns)) then
            nnx = nnx + 1
            if (nnx .gt. ndrsmx) then
c
c             Calling sequence substitutions:
c               uspec(nse) for unam48
c
              call fmspnx(jlen,uspec(nse),uspn56)
              write (noutpt,1005) ndrsmx,uspn56(1:jlen),ndrsmx
              write (nttyo,1005) ndrsmx,uspn56(1:jlen),ndrsmx
              stop
            endif
            cdrsx(nnx) = 0.
            ndrsx(nnx) = 0
          endif
          ndrsrx(2,ns) = nnx
c
c         Log K coefficients.
c
          do j = 1,ntprmx
            if (axlks(1,j,ns) .lt. 9999999.) then
              do i = 1,narxmx
                axlksx(i,j,ns) = axlks(i,j,ns) - stofac*axlks(i,j,nse)
              enddo
            endif
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients.
c
            do j = 1,ntprmx
              if (axhfs(1,j,ns) .lt. 9999999.) then
                do i = 1,narxmx
                  axhfsx(i,j,ns) = axhfs(i,j,ns) - stofac*axhfs(i,j,nse)
                enddo
              endif
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = adhfs(i,j,ipc,ns)
     $            - stofac*adhfs(i,j,ipc,nse)
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients.
c
            do j = 1,ntprmx
              if (axvfs(1,j,ns) .lt. 9999999.) then
                do i = 1,narxmx
                  axvfsx(i,j,ns) = axvfs(i,j,ns) - stofac*axvfs(i,j,nse)
                enddo
              endif
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = advfs(i,j,ipc,ns)
     $            - stofac*advfs(i,j,ipc,nse)
                enddo
              enddo
            enddo
          endif
c
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the new reactions into the standard arrays.
c
      call cdrscx(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,axlks,
     $ axlksx,axvfs,axvfsx,cdrs,cdrsx,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,nstmax,ntprmx)
c
      end

      subroutine swtchb(adhfsd,adhfsx,advfsd,advfsx,axhfsd,axhfsx,
     $ axlksd,axlksx,axvfsd,axvfsx,cdrsd,cdrsx,ipch,ipchmx,ipcv,
     $ ipcvmx,narxmx,nbaspd,nbtmax,nbw,nb1,nb2,ndrsd,ndrsmx,ndrsx,
     $ ndrsrd,ndrsrx,noutpt,ns1,ns2,nsta,nstmax,ntprmx,nttyo,uspeca)
c
c     This subroutine performs a special kind of basis switch. It
c     interchanges the status of a strict basis species with an
c     auxiliary basis species. The effect of this action is equivalent
c     to modifying the data file so that a different basis species is
c     the strict basis species corresponding to a chemical element.
c
c     Here nb1 is the basis index of the species originally in the
c     strict set, and nb2 is the basis index of the species originally
c     in the auxiliary basis set. Here also ns1 and ns2 are the
c     corresponding species indices. The species indices are not
c     interchanged by the switch. The basis indices, as represented by
c     the contents of the nbaspd array, are interchanged.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,nbtmax,ndrsmx,nstmax,ntprmx
c
      integer noutpt,nttyo
c
      integer nbaspd(nbtmax),ndrsd(ndrsmx),ndrsx(ndrsmx),
     $ ndrsrd(2,nstmax),ndrsrx(2,nstmax)
      integer ipch,ipcv,nbw,nb1,nb2,ns1,ns2,nsta
c
      character*48 uspeca(nstmax)
c
      real*8 adhfsd(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfsd(narxmx,ntprmx,nstmax),axhfsx(narxmx,ntprmx,nstmax),
     $ axlksd(narxmx,ntprmx,nstmax),axlksx(narxmx,ntprmx,nstmax),
     $ axvfsd(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrsd(ndrsmx),cdrsx(ndrsmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j,jlen,jlen1,jlen2,n,nerr,nrl1,nrl2,nr1,nr2,ns,nsi,
     $ nt1,nt2,nx
c
      character*56 uspn56,usp156,usp256
c
      real*8 axx,cx,cx12
c
      real*8 coefdr
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
c     Calling sequence substitutions:
c       jlen1 for jlen
c       uspeca(ns1) for unam48
c       usp156 for uspn56
c
      call fmspnx(jlen1,uspeca(ns1),usp156)
c
c     Calling sequence substitutions:
c       jlen2 for jlen
c       uspeca(ns2) for unam48
c       usp256 for uspn56
c
      call fmspnx(jlen2,uspeca(ns2),usp256)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nb1 .eq. nb2) then
        write (noutpt,1004) usp156(1:jlen1)
        write (nttyo,1004) usp156(1:jlen1)
 1004   format(/" * Error - (EQLIB/swtchb) Can't make a special basis",
     $  ' switch',/7x,'replacing ',a,' with itself.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nb2 .lt. nb1) then
        write (noutpt,1006) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1006) usp156(1:jlen1),usp256(1:jlen2)
 1006   format(/" * Error - (EQLIB/swtchb) Can't make a special",
     $  ' switch',/7x,'replacing ',a,' with ',a,' because these',
     $  ' species are',/7x,'not in the proper hierarchical order.',
     $  ' The former must appear before',/7x,'the latter in the list',
     $  ' of basis species at the time the special switch',
     $  /7x,'is executed. Check the ordering on the data file and any',
     $  /7x,'changes made by previously executed special basis',
     $  ' switches.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that the first species is in the strict basis set.
c
      nt1 = ndrsrd(2,ns1) - ndrsrd(1,ns1) + 1
      if (nt1 .ge. 2) then
        write (noutpt,1010) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1010) usp156(1:jlen1),usp256(1:jlen2)
 1010   format(/" * Error - (EQLIB/swtchb) Can't make a special",
     $  ' switch',/7x,'replacing ',a,' with ',a,' because the',
     $  ' former species',/7x,'is not currently in the strict',
     $  ' basis set.',/7x,'Check the status of this species on',
     $  ' the data file and any',/7x,'changes made by previously',
     $  ' executed special basis switches.')
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the linking reaction.
c
      nt2 = ndrsrd(2,ns2) - ndrsrd(1,ns2) + 1
      if (nt2 .lt. 2) then
c
c       The second species must not be in the strict basis, because
c       there is then no possibility of a linking reaction.
c
        write (noutpt,1030) usp156(1:jlen1),usp256(1:jlen2)
        write (nttyo,1030) usp156(1:jlen1),usp256(1:jlen2)
 1030   format(/" * Error - (EQLIB/swtchb) Can't make a special",
     $  ' switch',/7x,'replacing ',a,' with ',a,' because the',
     $  ' latter species',/7x,'is currently in the strict basis',
     $  ' set, precluding.',/7x,'the possibility of it having a',
     $  ' reaction linking it to the',/7x,'former. Check the status',
     $  ' of the latter species on the',/7x,'data file and any',
     $  ' changes made by previously executed',/7x,'special',
     $  /7x,'basis switches.')
        nerr = nerr + 1
      else
c
c       Make sure that the first species appears as a product in
c       the reaction belonging to the second species.
c
c       Calling sequence substitutions:
c         cdrsd for cdrs
c         ndrsd for ndrs
c         ndrsrd for ndrsr
c         ns1 for nse
c         ns2 for ns
c
        cx12 = coefdr(cdrsd,ndrsd,ndrsmx,ndrsrd,ns1,ns2,nstmax)
        if (cx12 .eq. 0.) then
          write (noutpt,1040) usp156(1:jlen1),usp256(1:jlen2)
          write (nttyo,1040) usp156(1:jlen1),usp256(1:jlen2)
 1040     format(/" * Error - (EQLIB/swtchb) Can't make a special",
     $    ' switch',/7x,'replacing ',a,' with ',a,' because the',
     $    ' former species',/7x,'does not appear in the reaction',
     $    ' for the former species. Check',/7x,'the reaction',
     $    ' on the data file and any changes made by',
     $    /7x,'previously executed special basis switches.')
          ns = ns2
c
c         Calling sequence substitutions:
c           cdrsd for cdrs
c           ndrsd for ndrs
c           ndrsrd for ndrsr
c           noutpt for nf
c           uspeca for uspec
c
          call prreac(cdrsd,ndrsd,ndrsmx,ndrsrd,noutpt,ns,nstmax,uspeca)
          nerr = nerr + 1
        endif
      endif
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1050) usp156(1:jlen1),usp256(1:jlen2)
      write (nttyo,1050) usp156(1:jlen1),usp256(1:jlen2)
 1050 format(/' Making a special basis switch: replacing ',a,
     $ ' with ',a,'.'/)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nb1 .eq. nbw) then
        write (noutpt,1052) usp156(1:jlen1)
        write (nttyo,1052) usp156(1:jlen1)
 1052   format(/' * Warning - (EQLIB/swtchb) Making a special basis',
     $  ' switch',/7x,'replacing ',a,' with another species.')
      endif
c
      if (nb2 .eq. nbw) then
        write (noutpt,1054) usp256(1:jlen2)
        write (nttyo,1054) usp256(1:jlen2)
 1054   format(/' * Warning - (EQLIB/swtchb) Making a special basis',
     $  ' switch',/7x,'replacing a species with ',a,'.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the existing linking reaction.
c
c     Calling sequence substitutions:
c       cdrsd for cdrs
c       ndrsd for ndrs
c       ndrsrd for ndrsr
c       noutpt for nf
c       ns2 for ns
c       uspeca for uspec
c
      call prreac(cdrsd,ndrsd,ndrsmx,ndrsrd,noutpt,ns2,nstmax,uspeca)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nrl1 = ndrsrd(1,ns2)
      nrl2 = ndrsrd(2,ns2)
c
      nx = 0
      do ns = 1,nsta
        nr1 = ndrsrd(1,ns)
        nr2 = ndrsrd(2,ns)
        ndrsrx(1,ns) = nx + 1
c
c       Calling sequence substitutions:
c         uspeca(ns) for unam48
c
        call fmspnx(jlen,uspeca(ns),uspn56)
c
        if (ns .eq. ns1) then
c
c         Invert the linking reaction. Put the coefficient for the
c         ns1-th species first in the range.
c
          nx = nx + 1
          if (nx .gt. ndrsmx) then
            write (noutpt,1060) ndrsmx,usp156(1:jlen1),usp256(1:jlen2),
     $      uspn56(1:jlen),ndrsmx
            write (nttyo,1060) ndrsmx,usp156(1:jlen1),usp256(1:jlen2),
     $      uspn56(1:jlen),ndrsmx
 1060       format(/' * Error - (EQLIB/swtchb) The maximum ',i7,
     $      ' entries in the',/7x,'cdrsd and ndrsd arrays has been',
     $      ' exceeded in trying to',/7x,'make a special basis switch',
     $      ' replacing ',a,' with',/7x,a,' while writing the reaction',
     $      ' for ',a,'. Increase',/7x,'the dimensioning parameter',
     $      ' ndrspa from its present value of ',i7,'.')
            stop
          endif
          cdrsx(nx) = -cx12
          ndrsx(nx) = ns
          do n = nrl1,nrl2
            if (ndrsd(n) .ne. ns) then
              nx = nx + 1
              if (nx .gt. ndrsmx) then
                write (noutpt,1060) ndrsmx,usp156(1:jlen1),
     $          usp256(1:jlen2),uspn56(1:jlen),ndrsmx
                write (nttyo,1060) ndrsmx,usp156(1:jlen1),
     $          usp256(1:jlen2),uspn56(1:jlen),ndrsmx
                stop
              endif
              cdrsx(nx) = -cdrsd(n)
              ndrsx(nx) = ndrsd(n)
            endif
          enddo
          ndrsrx(2,ns) = nx
c
c         Log K coefficients.
c
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = -axlksd(i,j,ns2)
            enddo
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axhfsx(i,j,ns) = -axhfsd(i,j,ns2)
              enddo
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = -adhfsd(i,j,ipc,ns2)
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axvfsx(i,j,ns) = -axvfsd(i,j,ns2)
              enddo
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = -advfsd(i,j,ipc,ns2)
                enddo
              enddo
            enddo
          endif
c
        elseif (ns .eq. ns2) then
c
c         Write a null reaction.
c
          nx = nx + 1
          if (nx .gt. ndrsmx) then
            write (noutpt,1060) ndrsmx,usp156(1:jlen1),
     $      usp256(1:jlen2),uspn56(1:jlen),ndrsmx
            write (nttyo,1060) ndrsmx,usp156(1:jlen1),
     $      usp256(1:jlen2),uspn56(1:jlen),ndrsmx
            stop
          endif
          cdrsx(nx) = 0.
          ndrsx(nx) = 0
          ndrsrx(2,ns) = nx
c
c         Log K coefficients. Log K = 0 for a strict basis species.
c
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = 0.
            enddo
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients. This function is the
c           partial molar enthalpy of formation for a strict
c           basis species.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axx = axhfsd(i,j,ns)
                do n = nr1 + 1,nr2
                  nsi = ndrsd(n)
                  cx = cdrsd(n)
                  axx = axx - cx*axhfsd(i,j,nsi)
                enddo
                cx = cdrsd(nr1)
                axhfsx(i,j,ns) = axx/cx
              enddo
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  axx = adhfsd(i,j,ipc,ns)
                  do n = nr1 + 1,nr2
                    nsi = ndrsd(n)
                    cx = cdrsd(n)
                    axx = axx - cx*adhfsd(i,j,ipc,nsi)
                  enddo
                  cx = cdrsd(nr1)
                  adhfsx(i,j,ipc,ns) = axx/cx
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients. This function is the
c           partial molar volume for a strict basis species.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axx = axvfsd(i,j,ns)
                do n = nr1 + 1,nr2
                  nsi = ndrsd(n)
                  cx = cdrsd(n)
                  axx = axx - cx*axvfsd(i,j,nsi)
                enddo
                cx = cdrsd(nr1)
                axvfsx(i,j,ns) = axx/cx
              enddo
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  axx = advfsd(i,j,ipc,ns)
                  do n = nr1 + 1,nr2
                    nsi = ndrsd(n)
                    cx = cdrsd(n)
                    axx = axx - cx*advfsd(i,j,ipc,nsi)
                  enddo
                  cx = cdrsd(nr1)
                  advfsx(i,j,ipc,ns) = axx/cx
                enddo
              enddo
            enddo
          endif
c
        else
c
c         Copy as is reactions for all other species.
c
          do n = nr1,nr2
            nx = nx + 1
            if (nx .gt. ndrsmx) then
              write (noutpt,1060) ndrsmx,usp156(1:jlen1),
     $        usp256(1:jlen2),uspn56(1:jlen),ndrsmx
              write (nttyo,1060) ndrsmx,usp156(1:jlen1),
     $        usp256(1:jlen2),uspn56(1:jlen),ndrsmx
              stop
            endif
            cdrsx(nx) = cdrsd(n)
            ndrsx(nx) = ndrsd(n)
          enddo
          ndrsrx(2,ns) = nx
c
c         Log K coefficients.
c
          do j = 1,ntprmx
            do i = 1,narxmx
              axlksx(i,j,ns) = axlksd(i,j,ns)
            enddo
          enddo
c
          if (ipch .ge. 0) then
c
c           Enthalpy function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axhfsx(i,j,ns) = axhfsd(i,j,ns)
              enddo
            enddo
            do ipc = 1,ipch
              do j = 1,ntprmx
                do i = 1,narxmx
                  adhfsx(i,j,ipc,ns) = adhfsd(i,j,ipc,ns)
                enddo
              enddo
            enddo
          endif
c
          if (ipcv .ge. 0) then
c
c           Volume function coefficients.
c
            do j = 1,ntprmx
              do i = 1,narxmx
                axvfsx(i,j,ns) = axvfsd(i,j,ns)
              enddo
            enddo
            do ipc = 1,ipcv
              do j = 1,ntprmx
                do i = 1,narxmx
                  advfsx(i,j,ipc,ns) = advfsd(i,j,ipc,ns)
                enddo
              enddo
            enddo
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the new reactions in the 'x' set into the standard arrays
c     in the 'd' set.
c
c     Calling sequence substitutions:
c       adhfsd for adhfs
c       advfsd for advfs
c       axhfsd for axhfs
c       axlksd for axlks
c       axvfsd for avhfs
c       cdrsd for cdrs
c       ndrsd for ndrs
c       ndrsrd for ndrsr
c
      call cdrscx(adhfsd,adhfsx,advfsd,advfsx,axhfsd,axhfsx,axlksd,
     $ axlksx,axvfsd,axvfsx,cdrsd,cdrsx,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,ndrsd,ndrsmx,ndrsx,ndrsrd,ndrsrx,nstmax,ntprmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Print the new linking reaction.
c
c     Calling sequence substitutions:
c       cdrsd for cdrs
c       ndrsd for ndrs
c       ndrsrd for ndrsr
c       ns1 for ns
c       noutpt for nf
c       uspeca for uspec
c
      call prreac(cdrsd,ndrsd,ndrsmx,ndrsrd,noutpt,ns1,nstmax,uspeca)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interchange the basis indices.
c
      nbaspd(nb1) = ns2
      nbaspd(nb2) = ns1
c
      if (nb1 .eq. nbw) then
        nbw = nb2
      elseif (nb2 .eq. nbw) then
        nbw = nb1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chsgex(adhfs,adhfsd,adhfsx,advfs,advfsd,advfsx,
     $ axhfs,axhfsd,axhfsx,axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx,
     $ cdrs,cdrsd,cdrsx,eps100,iern1,ipch,ipchmx,ipcv,ipcvmx,jern1,
     $ jetmax,jflag,jgext,jsflag,narn1,narxmx,narxt,nbasp,nbaspd,
     $ nbaspx,nbt,nbtmax,nbw,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ndrsrx,
     $ ndrsx,nern1,nern2,net,netmax,ngext,noutpt,nphasx,nst,nstmax,
     $ ntprmx,ntprt,nttyo,qbassw,qbswok,ugexmo,uspec)
c
c     This subroutine changes the original setup of component species
c     of generic ion exchanger phases for certain exchange models
c     (e.g., Gapon, Vanselow). It switches bare site species out of
c     the active basis set; e.g., it replaces __-Z with Na-Z. The
c     thermodynamic properties and the jsflag status array element
c     for each such base site species are changed to effectively take
c     this species out of the model. It persists only as a reference
c     for the mass balance of the corresponding exchanger substrate.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narxmx = number of coefficient elements of axlks per species
c                  per temperature range
c       nbtmax = maximum number of basis species
c       nstmax = maximum number of species
c       ntprmx = maximum number of temperature ranges
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,jetmax,narxmx,nbtmax,ndrsmx,netmax,nstmax,
     $ ntprmx
c
      integer noutpt,nttyo
c
      integer jern1(jetmax,netmax),jflag(nstmax),jgext(netmax),
     $ jsflag(nstmax),narxt(ntprmx),nbasp(nbtmax),nbaspd(nbtmax),
     $ nbaspx(nbtmax),ndrs(ndrsmx),ndrsd(ndrsmx),ndrsr(2,nstmax),
     $ ndrsrd(2,nstmax),ndrsx(ndrsmx),ndrsrx(2,nstmax),
     $ ngext(jetmax,netmax),nphasx(nstmax)
c
      integer iern1,ipch,ipcv,narn1,nbt,nbw,nern1,nern2,net,nst,ntprt
c
      logical qbassw,qbswok
c
      character*24 ugexmo(netmax)
      character*48 uspec(nstmax)
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsx(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsx(narxmx,ntprmx,ipcvmx,nstmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsd(narxmx,ntprmx,nstmax),
     $ axhfsx(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksd(narxmx,ntprmx,nstmax),
     $ axlksx(narxmx,ntprmx,nstmax),axvfs(narxmx,ntprmx,nstmax),
     $ axvfsd(narxmx,ntprmx,nstmax),axvfsx(narxmx,ntprmx,nstmax),
     $ cdrs(ndrsmx),cdrsd(ndrsmx),cdrsx(ndrsmx)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ie,j,je,j2,nb,ne,np,ns,ns1,ns2
c
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Copy the existing nbasp set into the nbaspx array.
c
      do nb = 1,nbt
        nbaspx(nb) = nbasp(nb)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Switch bare site species of generic ion exchange phases with
c     certain exchange models (e.g., Gapon, Vanselow) out of the
c     basis set. E.g., use Na-Z instead of __-Z.
c
      do nb = 1,nbt
        ns1 = nbaspx(nb)
        if (ns1.ge.nern1 .and. ns1.le.nern2) then
          np = nphasx(ns1)
          ne = np - iern1 + 1
          j2 = ilnobl(ugexmo(ne))
          if (ugexmo(ne)(1:j2).eq.'Gapon' .or.
     $      ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $      ugexmo(ne)(1:j2).eq.'Vanselow' .or.
     $      ugexmo(ne)(1:9).eq.'Vanselow-') then
c
c           Theoretically, the test below should be unnecessary,
c           as the only exchanger species presently in the basis
c           set should be bare site species.
c
            if (uspec(ns1)(1:3) .eq. '__ ') then
c
c             Set up to switch the bare exchanger species with the
c             next species in the same site.
c
              ns2 = ns1 + 1
              nbasp(nb) = ns2
            endif
c
          endif
        endif
      enddo
c
c     Make the switches.
c
      do nb = 1,nbt
        ns1 = nbaspx(nb)
        ns2 = nbasp(nb)
        if (ns1 .ne. ns2) then
          call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $    axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $    ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $    nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $    ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Now for certain models (e.g., Gapon, Vanselow) adjust the
c     thermodynamic data for the bare site species so that these
c     species are effectively taken out of the model.
c
      do ne = 1,net
        j2 = ilnobl(ugexmo(ne))
        if (ugexmo(ne)(1:j2).eq.'Gapon' .or.
     $    ugexmo(ne)(1:6).eq.'Gapon-' .or.
     $    ugexmo(ne)(1:j2).eq.'Vanselow' .or.
     $    ugexmo(ne)(1:9).eq.'Vanselow-') then
c
          do je = 1,jgext(ne)
            ns = jern1(je,ne) - 1
            do ie = 1,ngext(je,ne)
              ns = ns + 1
c
              if (uspec(ns)(1:3) .eq. '__ ') then
c
c               Null the thermodynamic properties of the
c               bare site species.
c
                do j = 1,ntprt
                  axlks(1,j,ns) = +9999999.
                  axhfs(1,j,ns) = 0.
                  axvfs(1,j,ns) = 0.
                  do i = 2,narxt(j)
                    axlks(i,j,ns) = 0.
                    axhfs(i,j,ns) = 0.
                    axvfs(i,j,ns) = 0.
                  enddo
                enddo
                jsflag(ns) = 2
              endif
c
            enddo
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make the 'd' set consistent with the ion exchanger part of the
c     ordinary set as it now exists. Do not modify other parts of the
c     'd' set. This action will leave, say, Na-Z in the 'd' set in
c     place of __-Z, which was the basis species on which the
c     exchanger substrate mass balance was defined. The only memory
c     of this definition is contained in the nbaspi array. Note
c     that the 'd' set reactions for exchangers will now include
c     the effects of eliminations of other basis species from the
c     active basis set.
c
c     The effects of eliminations on exchanger reactions could be
c     overcome by saving the exchanger reactions and associated data
c     prior to making the eliminations. However, new arrays would be
c     required to do that. It doesn't seem worthwhile at the present
c     time.
c
      call mdrgex(adhfs,adhfsd,adhfsx,advfs,advfsd,advfsx,
     $ axhfs,axhfsd,axhfsx,axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx,
     $ cdrs,cdrsd,cdrsx,ipch,ipchmx,ipcv,ipcvmx,narxmx,nbasp,nbaspd,
     $ nbtmax,ndrs,ndrsd,ndrsx,ndrsmx,ndrsr,ndrsrd,ndrsrx,nern1,
     $ nern2,noutpt,nst,nstmax,ntprmx,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cmpdat(adhfs,adhfsd,advfs,advfsd,amu,amua,apx,
     $ apxa,aslm,aslma,atwt,atwta,axhfs,axhfsd,axlks,axlksd,axvfs,
     $ axvfsd,azero,azeroa,bpx,bpxa,cdrs,cdrsd,cess,cessa,iapxmx,
     $ iapxt,iapxta,iaqsla,iaqsln,ibpxmx,ibpxt,ibpxta,ilrn1,ilrn2,
     $ imrn1,imrn2,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,insgf,insgfa,
     $ iopg,ixrn1,ixrn1a,ixrn2,ixrn2a,jflag,jpfcmx,jpflag,jsflag,
     $ jsitex,jsol,jsola,mwtsp,mwtspa,nalpaa,nalpha,napmax,napt,
     $ napta,narn1,narn1a,narn2,narn2a,narxmx,nat,natmax,nbasp,
     $ nbaspd,nbmap,nbt,nbtd,nbti,nbtmax,nchlor,ncmap,ncmpr,ncmpra,
     $ nct,ncta,nctmax,ndecsp,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ness,
     $ nessa,nessmx,nessr,nessra,ngrn1,ngrn1a,ngrn2,ngrn2a,ngt,
     $ nlrn1,nlrn1a,nlrn2,nlrn2a,nlt,nmrn1,nmrn1a,nmrn2,nmrn2a,nmt,
     $ nmut,nmuta,nmutmx,nmux,nmuxa,nopgmx,nslt,nsltmx,nslta,nslx,
     $ nslxa,nphasx,npt,npta,nptmax,nsmap,nsta,nst,nstmax,ntf1,ntf1a,
     $ ntf1mx,ntf1t,ntf1ta,ntf2,ntf2a,ntf2mx,ntf2t,ntf2ta,ntprmx,
     $ nxrn1,nxrn1a,nxrn2,nxrn2a,nxt,nxtmax,palpaa,palpha,qchlor,
     $ tf1,tf1a,tf2,tf2a,uelem,uelema,uphasa,uphase,uptypa,uptype,
     $ uspec,uspeca,vosp0,vosp0a,zchar,zchara)
c
c     This sburoutine compresses the data read from the data file. The
c     objective is to write data arrays (and associated variables)
c     which exclude data belonging to phases and species that are not
c     required by the current problem. Such phases are marked by
c     the condition jpflag = 2. If a phase is not needed, none of its
c     constituent species are needed. If a phase is needed, any
c     constituent species that are not needed are marked by the
c     condition jsflag = 2.
c
c     The data read from the data file are stored in arrays (and a
c     few important variables) which are characterized by an 'a'
c     suffix, but which otherwise have the same names as the working
c     arrays (and associated variables) which are created by this
c     compression. Thus, the number of species read from the data
c     file is nsta. The number remaining after compression is nst.
c     The array of reaction coefficients read from the data file is
c     cdrsd. The array created by the compression is cdrs.
c
c     During compression, the basis set is compressed from nbtd elements
c     in the nbaspd array to nbt elements in the nbasp array. Here nbasp
c     and nbt are basically used as workspace. At the end of this
c     subroutine, the nbaspd is set equal to the compressed nbasp array
c     and nbtd is set equal to nbt.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,ibpxmx,ipbtmx,ipchmx,ipcvmx,jpfcmx,napmax,narxmx,
     $ natmax,nbtmax,nctmax,ndrsmx,nessmx,nmutmx,nopgmx,nptmax,nsltmx,
     $ nstmax,ntf1mx,ntf2mx,ntprmx,nxtmax
c
      integer iapxt(nxtmax),iapxta(nxtmax),ibpxt(nxtmax),ibpxta(nxtmax),
     $ insgf(natmax),insgfa(natmax),iopg(nopgmx),jflag(nstmax),
     $ jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),jsol(nxtmax),
     $ jsola(nxtmax),nalpaa(nsltmx),nalpha(nsltmx),nbasp(nbtmax),
     $ nbaspd(nbtmax),nbmap(nbtmax),ncmap(nctmax),ncmpr(2,nptmax),
     $ ncmpra(2,nptmax),ndecsp(nbtmax),ndrs(ndrsmx),ndrsd(ndrsmx),
     $ ndrsr(2,nstmax),ndrsrd(2,nstmax),ness(nessmx),nessa(nessmx),
     $ nessr(2,nstmax),nessra(2,nstmax),nmux(3,nmutmx),nmuxa(3,nmutmx),
     $ nphasx(nstmax),nslx(2,nsltmx),nslxa(2,nsltmx),nsmap(nstmax),
     $ ntf1(ntf1mx),ntf1a(ntf1mx),ntf2(ntf2mx),ntf2a(ntf2mx)
c
      integer iaqsla,iaqsln,ilrn1,ilrn2,imrn1,imrn2,ipch,ipcv,ixrn1,
     $ ixrn1a,ixrn2,ixrn2a,napt,napta,narn1,narn1a,narn2,narn2a,nat,nbt,
     $ nbtd,nbti,nchlor,nct,ncta,ngrn1,ngrn1a,ngrn2,ngrn2a,ngt,nlrn1,
     $ nlrn1a,nlrn2,nlrn2a,nlt,nmrn1,nmrn1a,nmrn2,nmrn2a,nmt,nmut,nmuta,
     $ nslt,nslta,npt,npta,nsta,nst,ntf1t,ntf1ta,ntf2t,ntf2ta,nxrn1,
     $ nxrn1a,nxrn2,nxrn2a,nxt
c
      logical qchlor
c
      character*8 uelem(nctmax),uelema(nctmax)
      character*48 uspec(nstmax),uspeca(nstmax)
      character*24 uphasa(nptmax),uphase(nptmax),uptypa(nptmax),
     $ uptype(nptmax)
c
      real*8 adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),apx(iapxmx,nxtmax),
     $ apxa(iapxmx,nxtmax),atwt(nctmax),atwta(nctmax),
     $ axhfs(narxmx,ntprmx,nstmax),axhfsd(narxmx,ntprmx,nstmax),
     $ axlks(narxmx,ntprmx,nstmax),axlksd(narxmx,ntprmx,nstmax),
     $ axvfs(narxmx,ntprmx,nstmax),axvfsd(narxmx,ntprmx,nstmax),
     $ azero(natmax),azeroa(natmax)
c
      real*8 amu(jpfcmx,nmutmx),amua(jpfcmx,nmutmx),
     $ aslm(jpfcmx,0:ipbtmx,nsltmx),aslma(jpfcmx,0:ipbtmx,nsltmx),
     $ bpx(ibpxmx,nxtmax),bpxa(ibpxmx,nxtmax),cdrs(ndrsmx),
     $ cdrsd(ndrsmx),cess(nessmx),cessa(nessmx),mwtsp(nstmax),
     $ mwtspa(nstmax),palpaa(ipbtmx,napmax),palpha(ipbtmx,napmax),
     $ tf1(ntf1mx),tf1a(ntf1mx),tf2(ntf2mx),tf2a(ntf2mx),vosp0(nstmax),
     $ vosp0a(nstmax),zchar(nstmax),zchara(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j,n,na,naa,nap,napa,nb,nba,nbi,nc,nca,nd,ne,nmu,
     $ nmua,nqt,nsa,np,npa,nrn1a,nrn2a,nr1,nr1a,nr2,nr2a,ns,nsl,nsla,
     $ ns1,ns1a,ns2,ns2a,ns3,ns3a,nx,nxa
c
c-----------------------------------------------------------------------
c
c     As long as the aqueous phase itself is not eliminated by
c     compression, keep the chloride ion from being eliminated
c     even if it is not present in the system to be modeled.
c     This allows the interpretation of NBS pH, which requires
c     the activity coefficient of the chloride ion.
c
      qchlor = .false.
      if (jpflag(iaqsla) .le. 0) then
        if (jsflag(nchlor) .eq. 2) then
          jsflag(nchlor) = 0
          qchlor = .true.
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The nsmap array is a pointer array. Here nsmap(nsa) = ns,
c     where nsa is the index of a species before compression and ns
c     is that of the same species after compression. If the species
c     is eliminated by the compression, nsmap(nsa) = 0.
c
      do nsa = 1,nsta
        nsmap(nsa) = 0
      enddo
c
      np = 0
      ns = 0
      ne = 0
      nd = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do npa = 1,npta
        if (jpflag(npa) .lt. 2) then
          np = np + 1
          jpflag(np) = jpflag(npa)
          uphase(np) = uphasa(npa)
          uptype(np) = uptypa(npa)
          nrn1a = ncmpra(1,npa)
          nrn2a = ncmpra(2,npa)
c
c         Loop over all the species belonging to this phase.
c         At least one species should have jsflag .lt. 2.
c
          ncmpr(1,np) = ns + 1
          do nsa = nrn1a,nrn2a
            if (jsflag(nsa) .lt. 2) then
              ns = ns + 1
              nsmap(nsa) = ns
              jsflag(ns) = jsflag(nsa)
              uspec(ns) = uspeca(nsa)
              mwtsp(ns) = mwtspa(nsa)
              zchar(ns) = zchara(nsa)
              vosp0(ns) = vosp0a(nsa)
              jsitex(ns) = 1
              nphasx(ns) = np
c
              nr1a = nessra(1,nsa)
              nr2a = nessra(2,nsa)
              nessr(1,ns) = ne + 1
              do n = nr1a,nr2a
                ne = ne + 1
                ness(ne) = nessa(n)
                cess(ne) = cessa(n)
              enddo
              nessr(2,ns) = ne
c
              nr1a = ndrsrd(1,nsa)
              nr2a = ndrsrd(2,nsa)
              ndrsr(1,ns) = nd + 1
              do n = nr1a,nr2a
                nd = nd + 1
                ndrs(nd) = ndrsd(n)
                cdrs(nd) = cdrsd(n)
              enddo
              ndrsr(2,ns) = nd
c
              do j = 1,ntprmx
                do i = 1,narxmx
                  axlks(i,j,ns) = axlksd(i,j,nsa)
                enddo
              enddo
c
              if (ipch .ge. 0) then
                do j = 1,ntprmx
                  do i = 1,narxmx
                    axhfs(i,j,ns) = axhfsd(i,j,nsa)
                  enddo
                enddo
                do ipc = 1,ipch
                  do j = 1,ntprmx
                    do i = 1,narxmx
                      adhfs(i,j,ipc,ns) = adhfsd(i,j,ipc,nsa)
                    enddo
                  enddo
                enddo
              endif
c
              if (ipcv .ge. 0) then
                do j = 1,ntprmx
                  do i = 1,narxmx
                    axvfs(i,j,ns) = axvfsd(i,j,nsa)
                  enddo
                enddo
                do ipc = 1,ipcv
                  do j = 1,ntprmx
                    do i = 1,narxmx
                      advfs(i,j,ipc,ns) = advfsd(i,j,ipc,nsa)
                    enddo
                  enddo
                enddo
              endif
c
            endif
          enddo
c
          ncmpr(2,np) = ns
        endif
      enddo
      npt = np
      nst = ns
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Suppress the aqueous chloride ion if it is not present.
c
      if (qchlor) then
        ns = nsmap(nchlor)
        jsflag(ns) = 2
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update the jflag array.
c
      do nsa = 1,nsta
        ns = nsmap(nsa)
        if (ns .gt. 0) jflag(ns) = jflag(nsa)
      enddo
c
      do ns = nst + 1,nsta
        jflag(ns) = 0
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update the species indices stored in the ndrs array.
c
      do n = 1,nd
        nsa = ndrs(n)
        if (nsa .gt. 0.) ndrs(n) = nsmap(nsa)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update species range pointers.
c
c     Calling sequence substitutions:
c       narn1 for nlim1
c       narn2 for nlim2
c       narn1a for nlim1a
c       narn2a for nlim2a
c       nat for ntot
c
      call cnvndx(narn1,narn1a,narn2,narn2a,nsmap,nstmax,nat)
c
c     Calling sequence substitutions:
c       nmrn1 for nlim1
c       nmrn2 for nlim2
c       nmrn1a for nlim1a
c       nmrn2a for nlim2a
c       nmt for ntot
c
      call cnvndx(nmrn1,nmrn1a,nmrn2,nmrn2a,nsmap,nstmax,nmt)
c
c     Calling sequence substitutions:
c       nlrn1 for nlim1
c       nlrn2 for nlim2
c       nlrn1a for nlim1a
c       nlrn2a for nlim2a
c       nlt for ntot
c
      call cnvndx(nlrn1,nlrn1a,nlrn2,nlrn2a,nsmap,nstmax,nlt)
c
c     Calling sequence substitutions:
c       ngrn1 for nlim1
c       ngrn2 for nlim2
c       ngrn1a for nlim1a
c       ngrn2a for nlim2a
c       ngt for ntot
c
      call cnvndx(ngrn1,ngrn1a,ngrn2,ngrn2a,nsmap,nstmax,ngt)
c
c     Note- nxt is the number of solid solution phases, not the
c     number of solid solution species. Hence the use of nqt below
c     for the number of species in solid solution phases. This
c     variable (nqt) is not used elsewhere in this code.
c
c     Calling sequence substitutions:
c       nxrn1 for nlim1
c       nxrn2 for nlim2
c       nxrn1a for nlim1a
c       nxrn2a for nlim2a
c       nqt for ntot
c
      call cnvndx(nxrn1,nxrn1a,nxrn2,nxrn2a,nsmap,nstmax,nqt)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the phase index of the aqueous solution.
c
      iaqsln = nphasx(narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update phase range pointers for pure liquids, pure solids,
c     and solid solutions.
c
      if (nlrn1 .le. 0) then
        ilrn1 = 0
        ilrn2 = -1
      else
        ilrn1 = nphasx(nlrn1)
        ilrn2 = nphasx(nlrn2)
      endif
c
      if (nmrn1 .le. 0) then
        imrn1 = 0
        imrn2 = -1
      else
        imrn1 = nphasx(nmrn1)
        imrn2 = nphasx(nmrn2)
      endif
c
      if (nxrn1 .le. 0) then
        nxt = 0
        ixrn1 = 0
        ixrn2 = -1
      else
        ixrn1 = nphasx(nxrn1)
        ixrn2 = nphasx(nxrn2)
        nxt = ixrn2 - ixrn1 + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compress the basis set. Use the nbmap array as a pointer array
c     analogous to the nsmap array.
c
      nb = 0
      do nba = 1,nbtd
        nbmap(nba) = 0
        nsa = nbaspd(nba)
        ns = nsmap(nsa)
        if (ns .gt. 0) then
          nb = nb + 1
          nbmap(nba) = nb
          nbasp(nb) = ns
        endif
      enddo
      nbt = nb
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Reset the ndecsp basis pointer array.
c
      do nbi = 1,nbti
        nba = ndecsp(nbi)
        if (nba .gt. 0) ndecsp(nbi) = nbmap(nba)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compress the set of chemical elements. Use the ncmap
c     array as a pointer array analogous to the nsmap array.
c
      nc = 0
      do nca = 1,ncta
        ncmap(nca) = 0
        do nba = 1,nbtd
          nsa = nbaspd(nba)
          ns = nsmap(nsa)
          if (ns .gt. 0) then
            nr1 = nessra(1,nsa)
            nr2 = nessra(2,nsa)
            do n = nr1,nr2
              if (nessa(n) .eq. nca) then
                nc = nc + 1
                ncmap(nca) = nc
                uelem(nc) = uelema(nca)
                atwt(nc) = atwta(nca)
                go to 460
              endif
            enddo
          endif
        enddo
  460   continue
      enddo
      nct = nc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Update the element indices stored in the ness array.
c
      do n = 1,ne
        nca = ness(n)
        if (nca .gt. 0) ness(n) = ncmap(nca)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Redefine the nbaspd array so that it matches the compressed
c     nbasp array.
c
      do nb = 1,nbtd
        nbaspd(nb) = 0
      enddo
c
      do nb = 1,nbt
        nbaspd(nb) = nbasp(nb)
      enddo
      nbtd = nbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Create compressed activity coefficient data for solution
c     phases other than the aqueous solution.
c
cXX   Note- the scheme below is not entirely satisfactory, as it
cXX   does not account for the effects of compression of component
cXX   species. The problem is that the apx-apxa arrays do not have
cXX   the data explcitly tied to the corresponding pairs or larger
cXX   groups of species. Revisit this issue when solid solutions
cXX   are redone.
c
      nxa = 0
      nx = 0
      do npa = ixrn1a,ixrn2a
        nxa = npa - ixrn1a + 1
        if (jpflag(npa) .lt. 2) then
          nx = nx + 1
          jsol(nx) = jsola(nxa)
c
          iapxt(nx) = iapxta(nxa)
          do i = 1,iapxta(nx)
            apx(i,nx) = apxa(i,nxa)
          enddo
c
          ibpxt(nx) = ibpxta(nxa)
          do i = 1,ibpxta(nx)
            bpx(i,nx) = bpxa(i,nxa)
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Create compressed arrays for titration factors.
c
      ntf1t = 0
      do n = 1,ntf1ta
        nsa = ntf1a(n)
        ns = nsmap(nsa)
        if (ns .gt. 0) then
          ntf1t = ntf1t + 1
          ntf1(ntf1t) = ns
          tf1(ntf1t) = tf1a(n)
        endif
      enddo
c
      ntf2t = 0
      do n = 1,ntf2ta
        nsa = ntf2a(n)
        ns = nsmap(nsa)
        if (ns .gt. 0) then
          ntf2t = ntf2t + 1
          ntf2(ntf2t) = ns
          tf2(ntf2t) = tf2a(n)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Create compressed arrays for hard core diameters, neutral
c     solute species flags, and hydration numbers.
c
      na = 0
      do nsa = narn1a,narn2a
        ns = nsmap(nsa)
        if (ns .gt. 0) then
          naa = nsa - narn1a + 1
          na = na + 1
          azero(na) = azeroa(naa)
          insgf(na) = insgfa(naa)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 1) then
c
c       Create compressed arrays for the parameters belonging to
c       Pitzer's equations.
c
        nsl = 0
        do nsla = 1,nslta
          ns1a = nslxa(1,nsla)
          ns2a = nslxa(2,nsla)
          ns1 = nsmap(ns1a)
          ns2 = nsmap(ns2a)
          n = ns1*ns2
          if (n .gt. 0) then
            nsl = nsl + 1
c
            nalpha(nsl) = nalpaa(nsla)
c
            nslx(1,nsl) = ns1
            nslx(2,nsl) = ns2
            do i = 0,ipbtmx
              do j = 1,jpfcmx
                aslm(j,i,nsl) = aslma(j,i,nsla)
              enddo
            enddo
          endif
        enddo
        nslt = nsl
c
c       Copy, but don't compress, the Pitzer alpha parameters.
c
        do napa = 1,napta
          nap = napa
          do i = 1,ipbtmx
            palpha(i,nap) = palpaa(i,napa)
          enddo
        enddo
        napt = napta
c
        nmu = 0
        do nmua = 1,nmuta
          ns1a = nmuxa(1,nmua)
          ns2a = nmuxa(2,nmua)
          ns3a = nmuxa(3,nmua)
          ns1 = nsmap(ns1a)
          ns2 = nsmap(ns2a)
          ns3 = nsmap(ns3a)
          n = ns1*ns2*ns3
          if (n .gt. 0) then
            nmu = nmu + 1
            nmux(1,nmu) = ns1
            nmux(2,nmu) = ns2
            nmux(3,nmu) = ns3
            do j = 1,jpfcmx
              amu(j,nmu) = amua(j,nmua)
            enddo
          endif
        enddo
        nmut = nmu
      endif
c
c
      end

      subroutine stpkmd(cbsri,cbsr1,cdac,cesri,cesr1,csigma,eact,
     $ fkrc,hact,iact,ibsrti,ibsrt1,iesrti,iesrt1,iktmax,imchmx,
     $ imech,iopt,ixrti,jcode,jreac,modr,morr,morrw1,nbt1mx,nctmax,
     $ ndact,ndctmx,noptmx,noutpt,nprob,nrct,nrctmx,nrk,nsk,nsrt,
     $ nsrtmx,ntitl1,ntitmx,nttyo,nxrt,nxrtmx,rkb,rxbari,sfcar,
     $ ssfcar,trkb,ubsri,ubsr1,ucxri,udac,uesri,uesr1,ureac,ureac1,
     $ utitl1,vreac)
c
c     This subroutine sets up certain variables and arrays for writing
c     the top half of an EQ6 input file when one of the advanced pickup
c     file options is selected. Presently there is only one such option,
c     which is to replace the set of reactants by a special reactant
c     defined as the aqueous solution at the last point of reaction
c     progress. This subroutine is somewhat analogous to EQ3NR/stpk36.f,
c     which sets up certain variables and arrays for the advanced
c     pickup file options for EQ3NR.
c
c     This subroutine should only be called if iopt(1) is greater than
c     zero.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,nbt1mx,nctmax,ndctmx,noptmx,nsrtmx,ntitmx,
     $ nrctmx,nxrtmx
c
      integer noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),iesrti(nsrtmx),
     $ imech(2,nrctmx),iopt(noptmx),ixrti(nxrtmx),jcode(nrctmx),
     $ jreac(nrctmx),ndact(imchmx,2,nrctmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ibsrt1,iesrt1,nprob,nrct,nsrt,ntitl1,nxrt
c
      character*80 utitl1(ntitmx)
      character*24 ubsri(nbt1mx,nsrtmx),ubsr1(nbt1mx),
     $ ucxri(iktmax,nxrtmx),udac(ndctmx,imchmx,2,nrctmx),ureac(nrctmx)
      character*8 uesri(nctmax,nsrtmx),uesr1(nctmax)
c
      character*24 ureac1
c
      real*8 cbsri(nbt1mx,nsrtmx),cbsr1(nbt1mx),
     $ cdac(ndctmx,imchmx,2,nrctmx),cesri(nctmax,nsrtmx),cesr1(nctmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),morr(nrctmx),
     $ rkb(imchmx,2,nrctmx),rxbari(iktmax,nxrtmx),sfcar(nrctmx),
     $ ssfcar(nrctmx),trkb(imchmx,2,nrctmx),vreac(nrctmx)
c
      real*8 morrw1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,nmax
c
c-----------------------------------------------------------------------
c
      if (iopt(20) .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the initial part of the new main title.
c
      call initcb(utitl1,ntitmx)
      ntitl1 = 25
      utitl1(1) = 'EQ6 input file name= sample.6i'
      utitl1(2) = 'Description= "Sample"'
      utitl1(3) = 'Version level= 8.0'
      utitl1(4) = 'Revised mm/dd/yy    Revisor= Username'
      utitl1(6) = '  This is a sample EQ6 input file written as an EQ6 P
     $ICKUP file.'
      utitl1(7) = 'The EQ6 input file used to generate this output is id
     $entified in'
      utitl1(8) = 'the second title given below.'
      utitl1(10) = '  You are expected to modify this EQ6 input file to
     $meet your own needs.'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Delete all current reactants.
c
      nrct = 0
      call initiz(jcode,nrctmx)
      call initiz(jreac,nrctmx)
      call initiz(nsk,nrctmx)
c
      nsrt = 0
      call initiz(ibsrti,nsrtmx)
      call initiz(iesrti,nsrtmx)
c
      nmax = nbt1mx*nsrtmx
      call initaz(cbsri,nmax)
      call initcb(ubsri,nmax)
c
      nmax = nctmax*nsrtmx
      call initaz(cesri,nmax)
      call initcb(uesri,nmax)
c
      call initiz(ixrti,nxrtmx)
c
      nxrt = 0
      nmax = iktmax*nxrtmx
      call initaz(rxbari,nmax)
      call initcb(ucxri,nmax)
c
      call initcb(ureac,nrctmx)
      call initaz(fkrc,nrctmx)
      call initaz(sfcar,nrctmx)
      call initaz(ssfcar,nrctmx)
c
      nmax = 2*nrctmx
      call initiz(imech,nmax)
      call initiz(nrk,nmax)
c
      nmax = imchmx*2*nrctmx
      call initaz(csigma,nmax)
      call initaz(rkb,nmax)
      call initaz(trkb,nmax)
      call initaz(eact,nmax)
      call initaz(hact,nmax)
      call initiz(iact,nmax)
      call initiz(ndact,nmax)
c
      nmax = ndctmx*imchmx*2*nrctmx
      call initaz(cdac,nmax)
      call initcb(udac,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write an EQ6 input file in which "Fluid 2" is the sole reactant
c     added to the equilibrium system (ES) containing "Fluid 1" and
c     possible other phases. "Fluid 2" is defined as a special
c     reactant and appears in the top half of the file. It is the
c     aqueous solution from the end of the first reaction-path problem
c     of one or more such problems included on the current EQ6 input
c     file. "Fluid 1" is the aqueous solution from the end of the
c     current such problem, and the whole ES described is that at
c     the end of this problem.
c
c     If this option is chosen for the first (perhaps the only)
c     problem on the EQ6 input file, the pickup file produced
c     is set up for mixing of "Fluid 2" with an ES containing an
c     identical aqueous solution. This would normally be not very
c     useful as a whole, thought the top and bottom halves might be
c     separately useful.
c
      utitl1(12) = '  This sample file has "Fluid 2" mixing into an equi
     $librium system (ES)'
      utitl1(13) = 'which contains "Fluid 1". "Fluid 2" is the aqueous s
     $olution at the end'
      utitl1(14) = 'of the first EQ6 problem. "Fluid 1" is the aqueous s
     $olution at the'
      utitl1(15) = 'end of the current EQ6 problem, and the ES is the co
     $rresponding ES.'
c
      if (nprob .eq. 1) then
        utitl1(17) = '  Warning: This EQ6 input file is set up to mix Fl
     $"uid 2" with an ES'
        utitl1(18) = 'containing the identical aqueous solution. You may
     $ wish to change'
        utitl1(19) = 'the bottom half of this file so that this fluid mi
     $xes with something else.'
      endif
c
c     Note: "Fluid 2" as a special reactant is defined in EQ6/path.f.
c
      nrct = 1
      nsrt = 1
      ureac(1) = ureac1
      jcode(1) = 2
      jreac(1) = 0
      morr(1) = morrw1
      modr(1) = 0.
      nrk(1,1) = 1
      rkb(1,1,1) = 1.0
c
      vreac(1) = 1.0
c
      iesrti(1) = iesrt1
      do n = 1,iesrt1
        uesri(n,1) = uesr1(n)
        cesri(n,1) = cesr1(n)
      enddo
c
      ibsrti(1) = ibsrt1
      do n = 1,ibsrt1
        ubsri(n,1) = ubsr1(n)
        cbsri(n,1) = cbsr1(n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine aaaeq6(usteq6,uveeq6)
c
c     EQ6: EQ6 Reaction-Path Code
c     EQ3/6 version 8.0a R43a (Patched 10/01/2009)
c
c     Last revised 04/24/02 by TJW
c
c
c     Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The Regents
c     of the University of California, Lawrence Livermore National
c     Laboratory. All rights reserved.
c
c     This work was produced at the University of California,
c     Lawrence Livermore National Laboratory (UC LLNL) under
c     contract no. W-7405-ENG-48 between the U.S. Department of
c     Energy (DOE) and The Regents of the University of California
c     (University) for the operation of UC LLNL. Copyright is
c     reserved to the University for purposes of controlled
c     dissemination, commercialization through formal licensing,
c     or other disposition under terms of Contract 48; DOE
c     policies, regulations, and orders; and U.S. statutes.
c
c
c                            DISCLAIMER
c
c     This computer code was prepared as an account of work
c     sponsored by an agency of the United States Government.
c     Neither the United States Government nor the University of
c     California nor any of their employees, makes any warranty,
c     express or implied, or assumes any liability or responsibility
c     for the accuracy, completeness, or usefulness of any
c     information, apparatus, product, or process disclosed, or
c     represents that its use would not infringe privately-owned
c     rights. Reference herein to any specific commercial products,
c     process, or service by trade name, trademark, manufacturer,
c     or otherwise, does not necessarily constitute or imply its
c     endorsement, recommendation, or favoring by the United States
c     Government or the University of California. The views and
c     opinions of authors expressed herein do not necessarily state
c     or reflect those of the United States government or the
c     University of California, and shall not be used for
c     advertising or product endorsement purposes.
c
c
c-----------------------------------------------------------------------
c
c     See the readme.txt file that came with this software for further
c     information, including contact information and references.
c
c
c-----------------------------------------------------------------------
c
c     This code computes reaction-path models of water/rock and water/
c     rock/waste systems. A model of an aqueous solution must first
c     be created using the EQ3NR code. Problems are composed by choosing
c     substances to react with this water. Such a substance can include
c     another aqueous solution. Thermodynamic data are used in the
c     calculations. Kinetic data of some sort is also required. The
c     code predicts rates of reaction, changes in fluid composition
c     (including pH and Eh), and the precipitation and possible
c     re-dissolution of secondary phases. The temperature and pressure
c     may vary along a reaction path. This code primarily models the
c     chemistry in a small box. It can also model the reaction of a
c     packet of water (the first packet) traversing a reactive medium.
c     This system differs in that secondary minerals are left behind
c     and can't re-dissolve. The fugacities of selected gases may be
c     fixed to simulate reaction in the presence of a large gas volume,
c     such as the atmosphere. This code is similar in function to such
c     codes as CHILLER, REACT, and SOLMINEQ.88.
c
c     The user defines the run parameters on the file called input.
c     The file called DATA1 provides the basic supporting thermodynamic,
c     etc., data. EQ6 writes a pickup file and an output file called
c     output. The pickup file is an EQ6 input file which can be used
c     to restart a calculation. This code also writes data to the
c     tab file. This is an ASCII file containing tables which can be
c     used in graphics post-processing. This code also creates a tabx
c     (scrambled tab) file. Normally this is just used at the end of
c     a run to write the tab file. However, an option exists to use it
c     to create a tab file that spans more than one run.
c
c     This code requires subroutines from the following EQ3/6 libraries:
c
c       EQLIB
c       EQLIBG
c       EQLIBU
c
c
c-----------------------------------------------------------------------
c
c     This subroutine is designed to ensure that the copyright statement
c     and legal and other disclaimers appear at the beginning of the
c     concatenated source code for EQ6. Concatenation is normally
c     alphabetical, hence the form of the name. This subroutine returns
c     the stage and version numbers of this computer code.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       None
c
c     Output:
c
c       usteq6 = EQ6 stage number
c       uveeq6 = EQ6 version number
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      character*8 usteq6,uveeq6
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*8 ust,uve
c
c-----------------------------------------------------------------------
c
      data ust /'R43a    '/
      data uve /'8.0a    '/
c
c-----------------------------------------------------------------------
c
      usteq6 = ust
      uveeq6 = uve
c
      end

      subroutine wr3w6(cspb,fep,iktmax,iodb,iopg,iopr,iopt,
     $ itermx,jflagb,jxmod,kxmod,ncompb,newin,nodbmx,nopgmx,
     $ noprmx,noptmx,nsq,nsqmax,ntitl,ntitmx,nxmdmx,nxmod,
     $ nxtb,nxtmax,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat,
     $ uacion,ubasis,uebal,umemb,uphas1,uphas2,uredox,usolb,
     $ uspecb,utitl,xbarb,uxmd24,xlkmod)
c
c     This subroutine writes the EQ3NR input file in compact ("W")
c     format for versions 6.0-6.1.
c
c     This subroutine is called by:
c
c       XCON3/xcon3.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,nodbmx,nopgmx,noprmx,noptmx,nsqmax,ntitmx,nxmdmx,
     $ nxtmax
c
      integer iodb(nodbmx),iopg(nopgmx),iopr(noprmx),iopt(noptmx),
     $ jflagb(nsqmax),jxmod(nxmdmx),kxmod(nxmdmx),ncompb(nxtmax)
c
      integer itermx,newin,nsq,ntitl,nxmod,nxtb
c
      character*80 utitl(ntitmx)
      character*24 ubasis(nsqmax),umemb(iktmax,nxtmax),uphas1(nsqmax),
     $ uphas2(nsqmax),usolb(nxtmax),uspecb(nsqmax),uxmd24(nxmdmx)
      character*24 uacion,uebal,uredox
c
      real*8 cspb(nsqmax),xbarb(iktmax,nxtmax),xlkmod(nxmdmx)
c
      real*8 fep,rho,tempc,tdspkg,tdspl,tolbt,toldl,tolsat
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ikb,iktb,j2,n,ns,nxb
      integer ilnobl
c
c-----------------------------------------------------------------------
c
c     Write the new input file.
c
c     Title.
c
      do 110 n = 1,ntitl
        j2 = ilnobl(utitl(n))
        write (newin,1000) utitl(n)(1:j2)
 1000 format(a)
  110 continue
      if (ntitl .lt. ntitmx) write (newin,1010)
 1010 format('endit.')
c
c-----------------------------------------------------------------------
c
c     Temperature.
c
      write (newin,1040) tempc
 1040 format(5x,'tempc= ',1pe12.5)
c
c     Density, total dissolved salts (per kg), and total dissolved
c     salts (per liter).
c
      write (newin,1050) rho,tdspkg,tdspl
 1050 format (7x,'rho= ',1pe12.5,4x,'tdspkg= ',1pe12.5,5x,
     $ 'tdspl= ',1pe12.5)
c
c     Redox parameter and name of redox species defining a controlling
c     couple, if any.
c
      j2 = ilnobl(uredox)
      write (newin,1060) fep,uredox(1:j2)
 1060 format (7x,'fep= ',1pe12.5,4x,'uredox= ',a)
c
c     Convergence tolerances (tolbt and toldl) and saturation
c     tolerance (tolsat).
c
      write (newin,1070) tolbt,toldl,tolsat
 1070 format (5x,'tolbt= ',1pe12.5,5x,'toldl= ',1pe12.5,4x,'tolsat= ',
     $ 1pe12.5)
c
c     Maximum number of iterations.
c
      write (newin,1080) itermx
 1080 format (4x,'itermx= ',i2)
c
c-----------------------------------------------------------------------
c
      write (newin,1090)
 1090 format('*',15x,'1    2    3    4    5    6    7    8    9   10')
c
c     Iopt option switches.
c     Note: iopt(1) = iopt1, etc.
c
      write (newin,1100) (iopt(i), i = 1,10)
 1100 format(2x,'iopt1-10= ',10i5)
c
c     Iopg option switches.
c     Note: iopg(1) = iopg1, etc.
c
      write (newin,1110) (iopg(i), i = 1,10)
 1110 format(2x,'iopg1-10= ',10i5)
c
c     Iopr option switches.
c     Note: iopr(1) = iopr1, etc.
c
      write (newin,1120) (iopr(i), i = 1,20)
 1120 format(2x,'iopr1-10= ',10i5,/1x,'iopr11-20= ',10i5)
c
c     Iodb option switches.
c     Note: iodb(1) = iodb1, etc.
c
      write (newin,1130) (iodb(i), i = 1,10)
 1130 format(2x,'iodb1-10= ',10i5)
c
c-----------------------------------------------------------------------
c
c     Species for electrical balancing.
c
      j2 = ilnobl(uebal)
      write (newin,1150) uebal(1:j2)
 1150 format(5x,'uebal= ',a)
c
c-----------------------------------------------------------------------
c
c     Species for defining equivalent stoichiometric ionic strength.
c
      j2 = ilnobl(uacion)
      write (newin,1160) uacion(1:j2)
 1160 format(4x,'uacion= ',a)
c
c-----------------------------------------------------------------------
c
c     Nxmod options.
c
      write (newin,1200) nxmod
 1200 format(5x,'nxmod= ',i2)
c
      if (nxmod .gt. 0) then
        do 420 n = 1,nxmod
          j2 = ilnobl(uxmd24(n))
          write (newin,1220) uxmd24(n)(1:j2),jxmod(n),kxmod(n),
     $    xlkmod(n)
 1220     format(3x,'species= ',a,/6x,'type= ',i2,14x,'option= ',
     $    i2,14x,'xlkmod= ',1pe12.5)
  420   continue
      endif
c
c-----------------------------------------------------------------------
c
c     Basis species and associated constraints.
c
      do 440 ns = 1,nsq
        j2 = ilnobl(uspecb(ns))
        write (newin,1240) uspecb(ns)(1:j2)
 1240   format('data file master species= ',a)
        j2 = ilnobl(ubasis(ns))
        write (newin,1250) ubasis(ns)(1:j2)
 1250   format(3x,'switch with species= ',a)
        write (newin,1260) jflagb(ns),cspb(ns)
 1260   format(3x,'jflag= ',i2,3x,'csp= ',1pg12.5)
        if (jflagb(ns).ge.17 .and. jflagb(ns).le.21) then
          j2 = ilnobl(uphas2(ns))
          write (newin,1270) uphas1(ns),uphas2(ns)(1:j2)
 1270     format(2x,'uphas1= ',a24,3x,'uphas2= ',a)
        endif
  440 continue
      write (newin,1280)
 1280 format('endit.')
c
c-----------------------------------------------------------------------
c
c     Mole fractions of solid solutions.
c
      if (iopt(4) .ge. 2) then
        write (newin,1300)
 1300   format('*   Solid solution compositions')
        do 460 nxb = 1,nxtb
          j2 = ilnobl(usolb(nxb))
          write (newin,1310) usolb(nxb)(1:j2)
 1310     format(3x,a)
          iktb = ncompb(nxb)
          do 450 ikb = 1,iktb
            write (newin,1320) umemb(ikb,nxb),xbarb(ikb,nxb)
 1320       format(6x,a24,3x,f10.4)
  450     continue
          write (newin,1330)
 1330     format(6x,'endit.')
  460   continue
        write (newin,1340)
 1340   format(3x,'endit.')
      endif
c
c-----------------------------------------------------------------------
c
  999 continue
      end

      subroutine search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $ nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $ xtargv,xval0)
c
c     This subroutine finds the value of delxi at which occurs an event
c     whose type is described by the string in the usearch variable.
c
c     This subroutine is called by:
c
c       EQ6/chksar.f
c       EQ6/chksir.f
c       EQ6/chksrr.f
c       EQ6/chktmx.f
c       EQ6/chktpl.f
c       EQ6/chktpr.f
c       EQ6/ckawmn.f
c       EQ6/ckawmx.f
c       EQ6/ckehmn.f
c       EQ6/ckehmx.f
c       EQ6/cko2mn.f
c       EQ6/cko2mx.f
c       EQ6/ckphmn.f
c       EQ6/ckphmx.f
c       EQ6/fpbdpp.f
c       EQ6/fpbflo.f
c       EQ6/fpbnpp.f
c       EQ6/fpexrc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       unam24 = name of entity, one of whose properties is involved in
c                  the search
c       ilsign = expected sign of the residual function at the
c                  left boundary (delxi = 0)
c       tolsx  = the convergence tolerance
c
c     Principal output:
c
c       ier     = error flag
c                   = 1  the search did not converge
c                   = 2  event being searched for appears to have
c                          occurred prior to the interval being
c                          searched
c                   = 3  event being searched for doesn't appear to
c                          occur in the interval being searched
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer ier,ilsign,nord
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,eps100,tolsx,xtargv,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer iter,j2,j3
c
      integer ilnobl
c
      real*8 x(2),y(2)
c
      real*8 adx,ares,ares0,resfnc,resx,slope,xleft,xnew,xright
c
c-----------------------------------------------------------------------
c
      ier = 0
c
c     The following local variables are signficant:
c
c       iter   = iteration counter
c       resfnc = convergence function
c
      iter = 0
      resfnc = 0.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      j2 = ilnobl(usearch)
      j3 = ilnobl(unam24)
c
      if (iodb(7) .ge. 1) then
        write (noutpt,1000) usearch(1:j2)
 1000   format(/3x,'--- Search for where ',a,' ---',/)
        if (j3 .gt. 0) write (noutpt,1010) unam24(1:j3)
 1010   format(9x,'The entity involved is ',a,'.',/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the entering value of delxi in xright.
c
c       xleft  = the left boundary of the interval being examined
c       xright = the right boundary
c
      xleft = 0.
      xright = delxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the left boundary point.
c
c       The current left point is ( x(1),y(1) ).
c       The current right point is ( x(2),y(2) ).
c
      x(1) = xleft
      delxi = xleft
c
      call sfncge(delxi,xval0,xtargv,dxval0,nord,nrd1mx,resx)
c
      y(1) = resx
      ares0 = abs(resx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(7) .ge. 1) write (noutpt,1020) iter,x(1),resx,resfnc
 1020 format(3x,'iter= ',i2,' delxi= ',1pe11.4,' residual= ',e11.4,
     $ ' resfnc=',e11.4)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for a direct hit on the left boundary.
c
      if (ares0 .le. 0.) then
        delxi = dlxmin
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ( (resx.lt.0 .and. ilsign.gt.0) .or.
     $  (resx.gt.0 .and. ilsign.lt.0) ) then
        write (noutpt,1030) usearch(1:j2)
        write (nttyo,1030) usearch(1:j2)
 1030   format(/' * Note - (EQ6/search) A search for where ',a,
     $  /7x,' indicates that the event has been stepped over.')
        if (j3 .gt. 0) then
          write (noutpt,1040) unam24(1:j3)
          write (nttyo,1040) unam24(1:j3)
 1040     format(7x,'The entity involved is ',a,'.')
        endif
        ier = 2
        delxi = dlxmin
        write (noutpt,1050) delxi
        write (nttyo,1050) delxi
 1050   format(7x,'The step size will be set to ',1pe11.4,'.')
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the right boundary point.
c
  100 x(2) = xright
      delxi = xright
c
      call sfncge(delxi,xval0,xtargv,dxval0,nord,nrd1mx,resx)
c
      y(2) = resx
      ares = abs(resx)
c
      if (iodb(7) .ge. 1) write (noutpt,1020) iter,x(2),resx,resfnc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for a direct hit on the right boundary.
c
      if (ares .le. 0.) then
        delxi = xright
        go to 999
      endif
c
      ares = min(ares0,ares)
c
      if ( (resx.lt.0 .and. ilsign.lt.0) .or.
     $  (resx.gt.0 .and. ilsign.gt.0) ) then
        write (noutpt,1120) usearch(1:j2)
        write (nttyo,1120) usearch(1:j2)
 1120   format(/' * Note - (EQ6/search) A search for where ',a,
     $  /7x,'indicates that the event being searched for does',
     $  /7x,'not take place in the interval being examined.')
        if (j3 .gt. 0) then
          write (noutpt,1040) unam24(1:j3)
          write (nttyo,1040) unam24(1:j3)
        endif
        write (noutpt,1130)
        write (nttyo,1130)
 1130   format(7x,'The step size will not be decreased.')
        ier = 3
        delxi = xright
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find a new point. Each new point will replace either the
c     left point or the right point, depending on the value of
c     the residual. At least one iteration is required. The
c     secant method is the principal algorithm for generating a
c     new point. However, if convergence is slow, interval halving
c     may occasionally be used instead.
c
  110 iter = iter + 1
      ares0 = ares
c
      if (iodb(7) .ge. 2) write (noutpt,1140) x(1),x(2)
 1140 format(7x,'Left point= ',1pe11.4,', Right point= ',e11.4)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iter.le.4 .or. resfnc.ge.0.5 .or. mod(iter,4).ne.0) then
c
c       Secant method.
c
        if (iodb(7) .ge. 1) write (noutpt,1150)
 1150   format(3x,'Secant method')
        slope =  (y(2) - y(1) )/( x(2) - x(1) )
        xnew = x(1) - (y(1)/slope)
      else
c
c       Interval halving method.
c
        if (iodb(7) .ge. 1) write (noutpt,1160)
 1160   format(3x,'Interval halving')
        xnew = 0.5*( x(1) + x(2) )
      endif
      delxi = xnew
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      call sfncge(delxi,xval0,xtargv,dxval0,nord,nrd1mx,resx)
c
      ares = abs(resx)
      resfnc = (ares0 - ares)/ares0
      if (iodb(7) .ge. 1) write (noutpt,1020) iter,xnew,resx,resfnc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Note there are multiple convergence tests.
c
      if (ares .le. tolsx) go to 999
c
      if (xnew .gt. 0.) then
c
c       Check for underflow of the most recent correction.
c
        adx = abs((xnew - x(1))/xnew)
        if (adx .le. eps100) go to 999
      endif
c
      if (abs(xnew - x(1)) .le. dlxmin) then
c
c       Check for correction within the limit of the minimum
c       step size.
c
        delxi = max(delxi,dlxmin)
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iter .ge. 50) then
        delxi = max(x(1),dlxmin)
        write (noutpt,1170) usearch(1:j2)
        write (nttyo,1170) usearch(1:j2)
 1170   format(/' * Note - (EQ6/search) A search for where ',a,
     $  /7x,'has failed to converge within the maximum number of',
     $  ' iterations.')
        if (j3 .gt. 0) then
          write (noutpt,1040) unam24(1:j3)
          write (nttyo,1040) unam24(1:j3)
        endif
        write (noutpt,1180) delxi
        write (nttyo,1180) delxi
 1180   format(7x,'The step size will be set to a "safe" value of ',
     $  1pe11.4)
        ier = 1
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if ( (resx.lt.0 .and. ilsign.lt.0 ) .or.
     $  (resx.gt.0 .and. ilsign.gt.0) ) then
        x(1) = xnew
        y(1) = resx
      else
        x(2) = xnew
        y(2) = resx
      endif
c
      go to 110
c
  999 continue
      end

      subroutine wrazp(azero,insgf,nazt,naztmx,ndata1,ndat1f,
     $ noutpt,nttyo,uazp)
c
c     This subroutine writes on the DATA1 and DATA1F files the "bdot"
c     data read from the DATA0 file by EQPT/rdazp.f.
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ndata1 = unit number of the DATA1 file
c       ndat1f = unit number of the DATA1F file
c       nazt   = the number of elements in the uazp array
c       uazp   = array containing lines of data
c       azero  = array of corresponding hard core diameters
c       insgf  = array of corresponding neutral species
c                  activity coefficient flags
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer naztmx
c
      integer ndata1,ndat1f,noutpt,nttyo
c
      integer nazt
c
      integer insgf(naztmx)
c
      character*24 uazp(naztmx)
c
      real*8 azero(naztmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ineu,naz
c
      character*72 uterm,utermc
      character*24 uendit
c
      real*8 zero
c
c-----------------------------------------------------------------------
c
      data uendit / 'endit.' /
c
c-----------------------------------------------------------------------
c
      uterm(1:48) = '+-----------------------------------------------'
      uterm(49:72) = '------------------------'
      utermc = uterm
      utermc(1:1) = '*'
c
c     Write the azero ('bdot') data on the DATA1 and DATA1F files.
c
      do naz = 1,nazt
        write (ndata1) uazp(naz),azero(naz),insgf(naz)
        write (ndat1f,1010) uazp(naz),azero(naz),insgf(naz)
 1010   format(a24,2x,f7.1,2x,i2)
      enddo
c
c     Write the block terminator.
c
      zero = 0.
      ineu = 0
      write (ndata1) uendit,zero,ineu
      write (ndat1f,1010) uendit,zero,ineu
      write (ndat1f,1020) utermc(1:72)
 1020 format(a)
c
      end

      subroutine lambda(acflgc,afcnst,bpx,ibpxmx,ibpxt,iktmax,ixrn1,
     $ ixrn2,jsol,ncmpr,noutpt,np,nptmax,nstmax,nttyo,nxtmax,wfac,
     $ xbar,xbarlg,uphase,uspec)
c
c     This subroutine computes activity coefficients for the components
c     of the np-th phase, which is a solid solution.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQ3NR/eq3nr.f
c       EQ6/raff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       afcnst = affinity constant, 2.303RT/1000
c       bpx    = array of site-mixing parameters for solid solution
c                  activity coefficients
c       ibpxt  = array of the numbers of non-zero site-mixing
c                  paramters for computing activity coefficients in
c                  solid solutions
c       jsol   = array of activity coefficient model flags
c       ncmpr  = species range pointer array for phases
c       noutpt = unit number of the output file
c       nttyo  = unity number of the tty output file
c       nx     = solid solution index
c       nxtmax = array dimension, maximum number of solid solutions
c       wfac   = array of non-ideal mixing parameters calculated from
c                   the apx array
c       xbar   = array of mole fractions
c       xbarlg = array of log mole fraction values
c       wterm  = array of temperature-dependent coefficients for
c                  solid solution activity coefficients
c
c     Principal output:
c
c       acflgc  = array of activity coefficients
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ibpxmx,iktmax,nptmax,nstmax,nxtmax
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),jsol(nxtmax),ncmpr(2,nptmax)
      integer ixrn1,ixrn2,np
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 acflgc(nstmax),bpx(ibpxmx,nxtmax),xbar(nstmax),
     $ xbarlg(nstmax),wfac(iktmax,nxtmax)
      real*8 afcnst
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ix,iy,j2,k,nr1,nr2,ns,nt,nx
c
      integer ilnobl
c
      character*48 ux48,uy48
c
      real*8 stxm1,xx,xy
c
c-----------------------------------------------------------------------
c
c     Note: the following statements don't really do anything except
c     cause the compiler not to complain that ixrn2, uspec, afcnst,
c     xbar, and wfac are not used.
c
      ix = ixrn2
      iy = ix
      ixrn2 = iy
c
      ux48 = uspec(1)
      uy48 = ux48
      uspec(1) = uy48
c
      xx = afcnst
      xy = xx
      afcnst = xy
c
      xx = xbar(1)
      xy = xx
      xbar(1) = xy
c
      xx = wfac(1,1)
      xy = xx
      wfac(1,1) = xy
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      nx = np - ixrn1 + 1
cXX   Temporarily make all solid solutions ideal (for version 8.0).
cXX   Non-ideal solid solutions will be reintroduced in some later
cXX   version.
      if (jsol(nx) .ne. 1) jsol(nx) = 1
cXX
      k = jsol(nx)
c
      nr1 = ncmpr(1,np)
      nr2 = ncmpr(2,np)
      nt = nr2 - nr1 + 1
      if (nt .le. 0) then
        j2 = ilnobl(uphase(np))
        write (noutpt,1000) uphase(np)(1:j2)
        write (nttyo,1000) uphase(np)(1:j2)
 1000   format(/' * Error - (EQLIBG/lambda) Programming error trap:',
     $  ' Have no',/7x,'components present for solid solution ',a,'.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (k .eq. 1) then
c
        if (ibpxt(nx) .eq. 0.) then
c
c         Molecular mixing ideal solution.
c
          do ns = nr1,nr2
            acflgc(ns) = 0.
          enddo
        else
c
c         Site mixing ideal solution.
c
          stxm1 = bpx(1,nx) - 1.0
          do ns = nr1,nr2
            acflgc(ns) = stxm1*xbarlg(ns)
          enddo
        endif
c
      else
        j2 = ilnobl(uphase(np))
        write (noutpt,1010) jsol(nx),nx,uphase(np)(1:j2)
        write (nttyo,1010) jsol(nx),nx,uphase(np)(1:j2)
 1010   format(/' * Error - (EQLIBG/lambda) Programming error trap:',
     $  ' Have an',/7x,'undefined value of ',i3,' for jsol(',i3,'),',
     $  ' the activity'/7x,'coefficient model flag for solid',
     $  ' solution ',a,'.')
        stop
      endif
c
      end

      subroutine elesck(cessi,nbtmx1,nctmax,ncts,nentei,nerr,noutpt,
     $ ns,nttyo,qblkes,qzeres,uessi,usblkf,uspec)
c
c     This subroutine conducts tests on the elemental composition
c     specified for a species. It detects any blank and duplicate
c     element names in the composition and any zero-valued
c     stoichiometric coefficients.
c
c     Note: any blank names are replaced by the string '<blank>'.
c
c     This subroutine is called by:
c
c       EQPT/pcraq.f
c       EQPT/pcrsg.f
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmx1,nctmax
c
      integer noutpt,nttyo
c
      integer nentei(nctmax)
c
      integer ncts,nerr,ns
c
      logical qblkes,qzeres
c
      character(len=24) uspec(nbtmx1)
      character(len=24) usblkf
      character(len=8) uessi(nctmax)
c
      real(8) cessi(nctmax)
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer j2,j3,j4,n,ncount
c
      integer ilnobl
c
      logical qdupes
c
      character*8 ux8
c
c-----------------------------------------------------------------------
c
c     Check for blank element names.
c
      qblkes = .false.
      ncount = 0
      do n = 1,ncts
        j3 = ilnobl(uessi(n))
        if (j3 .le. 0) then
          ncount = ncount + 1
          uessi(n) = '<blank>'
        endif
      enddo
c
      if (ncount .gt. 0) then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1000) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1000) uspec(ns)(1:j2),usblkf(1:j4)
 1000   format(/' * Error - (EQPT/elesck) The species ',a,
     $  ' appearing',/7x,'on the data file in the ',a,' superblock',
     $  ' has a specified',/7x,'composition with blank chemical',
     $  ' element names',/7x,'in the following positions:',/)
        do n = 1,ncts
          if (uessi(n)(1:7) .eq. '<blank>') then
            write (ux8,'(i5)') n
            call lejust(ux8)
            j4 = ilnobl(ux8)
            write (noutpt,1010) ux8(1:j4)
            write (nttyo,1010) ux8(1:j4)
 1010       format(9x,a)
          endif
        enddo
        qblkes = .true.
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for a chemical element appearing more than once in the
c     composition.
c
      call nelcck(nctmax,ncts,nentei,nerr,qdupes,uessi)
c
      if (qdupes)  then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1040) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1040) uspec(ns)(1:j2),usblkf(1:j4)
 1040   format(/' * Error - (EQPT/elesck) The species ',a,
     $  ' appearing',/7x,'on the data file in the ',a,' superblock',
     $  ' has a specified',/7x,'elemental composition for which',
     $  ' there is more than one entry',/7x,'for the following',
     $  ' element(s):',/)
        do n = 1,ncts
          if (nentei(n) .gt. 1) then
            write (ux8,'(i5)') nentei(n)
            call lejust(ux8)
            j3 = ilnobl(ux8)
            j4 = ilnobl(uessi(n))
            write (noutpt,1050) uessi(n)(1:j4),ux8(1:j3)
            write (nttyo,1050) uessi(n)(1:j4),ux8(1:j3)
 1050       format(9x,a,' (',a,' entries)')
          endif
        enddo
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for zero-valued stoichiometric coefficients.
c
      qzeres = .false.
      do n = 1,ncts
        if (cessi(n) .eq. 0.) qzeres = .true.
      enddo
c
      if (qzeres) then
        j2 = ilnobl(uspec(ns))
        j4 = ilnobl(usblkf)
        write (noutpt,1080) uspec(ns)(1:j2),usblkf(1:j4)
        write (nttyo,1080) uspec(ns)(1:j2),usblkf(1:j4)
 1080   format(/' * Error - (EQPT/elesck) The species ',a,
     $  ' appearing',/7x,'on the data file in the ',a,' superblock',
     $  ' has an elemental',/7x,'composition with zero-valued',
     $  ' coefficients for the following elements:',/)
        do n = 1,ncts
          if (cessi(n) .eq. 0.) then
            ux8 = uessi(n)
            j3 = ilnobl(ux8)
            write (noutpt,1090) ux8(1:j3)
            write (nttyo,1090) ux8(1:j3)
 1090       format(9x,a)
          endif
        enddo
        nerr = nerr + 1
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 return
      end

      subroutine intsbs(nb1,nb2,nbaspd,nbtd,nbtmax,noutpt,ns1,ns2,
     $ nsbsw,nstmax,nttyo,usbsw,uspeca)
c
c     This subroutine interprets the nsbsw-th directive read from the
c     input file for effecting special basis switching. The roles of
c     a strict basis species and an auxiliary basis species are
c     switched by this process. The name of the former species is
c     usbsw(1,nsbsw), that of the latter is usbsw(2,nsbsw). Here nb1
c     is the basis index of the strict basis species and nb2 is that
c     of the auxiliary basis species. Here also ns1 and ns2 are the
c     corresponding species indices.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer nbaspd(nbtmax)
      integer nb1,nb2,nbtd,ns1,ns2,nsbsw
c
      character*48 usbsw(2,nbtmax),uspeca(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,j2,nerr
c
      integer ilnobl
c
      character*48 ublk48,unam48
      character*56 uspn56
      character*8 ux8
c
c-----------------------------------------------------------------------
c
      data ublk48/'                                                '/
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      do nb1 = 1,nbtd
        ns1 = nbaspd(nb1)
        if (usbsw(1,nsbsw)(1:48) .eq. uspeca(ns1)(1:48)) go to 120
      enddo
c
      nerr = nerr + 1
c
      unam48 = usbsw(1,nsbsw)
      call fmspnx(jlen,unam48,uspn56)
      write (noutpt,1000) uspn56(1:jlen)
      write (nttyo,1000) uspn56(1:jlen)
 1000 format(/' * Error - (EQLIB/intsbs) Invalid special basis',
     $ ' directive on the',/7x,'input file: ',a,' is not in the basis',
     $ ' set and therefore',/7x,'can not be specified in a special',
     $ ' basis switch.')
c
  120 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (usbsw(2,nsbsw)(1:48) .eq. ublk48(1:48)) then
        nb2 = nb1
        ns2 = ns1
      else
        do nb2 = 1,nbtd
          ns2 = nbaspd(nb2)
          if (usbsw(2,nsbsw)(1:48) .eq. uspeca(ns2)(1:48)) go to 140
        enddo
c
        nerr = nerr + 1
c
        unam48 = usbsw(2,nsbsw)
        call fmspnx(jlen,unam48,uspn56)
        write (noutpt,1000) uspn56(1:jlen)
        write (nttyo,1000) uspn56(1:jlen)
c
  140   continue
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Stop if name match errors have been encountered.
c
      if (nerr .gt. 0) then
        write (ux8,'(i5)') nerr
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1020) ux8(1:j2)
        write (nttyo,1020) ux8(1:j2)
 1020   format(/' * Error - (EQLIB/intsbs) ',a,' errors were',
     $  /7x,'encountered in interpreting special basis switches',
     $  /7x,'specified on the input file.')
        stop
      endif
c
      end

      subroutine srchne(nrn1a,nrn2a,ns,nsta_asv,unam,uspeca)
c
c     This subroutine matches the species name unam with the
c     corresponding entry in the nrn1a-th through nrn2a-th range of
c     the species name array uspeca. Only the first 24 characters are
c     compared (uspeca has 48 characters, unam only 24). This
c     subroutine returns the species index ns. If there is no match,
c     the species name is converted to all lower case and the code again
c     searches for a match. If none is found, the species name is
c     coverted to all upper case and the code again searches for a
c     match. If no match is found, ns is returned with a value of 0.
c
c     This subroutine is much like EQLIB/srchn.f, except that if no
c     match is found, the above-noted case conversions are tried in
c     an effort to find a match.
c
c     This subroutine is called by:
c
c       None
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nrn1a  = start of the range of species to search
c       nrn2a  = end of the range of species to search
c       unam   = name of the species whose index is to be found
c       uspeca = array of species names
c
c     Principal output:
c
c       ns     = index of the species whose name is unam
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nsta_asv
c
      integer nrn1a,nrn2a,ns
c
      character*48 uspeca(nsta_asv)
      character*24 unam
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer k,nfa,nfacap,nfdif,nfz,nfzcap,nlettr
c
      character*24 unamlc,unamuc
      character*1 ulettr
c
c-----------------------------------------------------------------------
c
c     Determine the ranges of upper and lower case letters.
c
      nfa = ichar('a')
      nfz = ichar('z')
      nfacap = ichar('A')
      nfzcap = ichar('Z')
      nfdif = ichar('A') - ichar('a')
c
c     Try the species name as is.
c
      call srchn(nrn1a,nrn2a,ns,nsta_asv,unam,uspeca)
c
      if (ns .le. 0) then
c
c       Convert to lower case.
c
        unamlc = unam
        do k = 1,24
          ulettr = unam(k:k)
          nlettr = ichar(ulettr)
          if (nlettr.ge.nfacap .and. nlettr.le.nfzcap)
     $    unamlc(k:k) = char(nlettr - nfdif)
        enddo
c
c       Test to see if this is different. If so, try it.
c
        if (unamlc .ne. unam) then
c
c         Calling sequence substitutions:
c           unamlc for unam
c
          call srchn(nrn1a,nrn2a,ns,nsta_asv,unamlc,uspeca)
        endif
      endif
c
      if (ns .le. 0) then
c
c       Convert to upper case.
c
        unamuc = unam
        do k = 1,24
          ulettr = unam(k:k)
          nlettr = ichar(ulettr)
          if (nlettr.ge.nfa .and. nlettr.le.nfz)
     $    unamuc(k:k) = char(nlettr + nfdif)
        enddo
c
c       Test to see if this is different. If so, try it.
c
        if (unamuc. ne. unam) then
c
c         Calling sequence substitutions:
c           unamuc for unam
c
          call srchn(nrn1a,nrn2a,ns,nsta_asv,unamuc,uspeca)
        endif
      endif
c
      end

      subroutine initim(iexec0,jexec0,texec0,noutpt,nttyo,
     $ udate0,utime0)
c
c     This subroutine gets the time and date of the start of execution.
c     It also calculates the data in the form needed to compute the
c     actual run time at the end of execution (see EQLIBU/runtim.f).
c     This routine should be called at the start of execution.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       noutpt = unit number of the output file
c       nttyo  = unit number of the screen file
c
c     Output:
c
c       texec0 = time at the start of execution, since midnight,
c                  in seconds
c       iexec0 = day of the year at the start of execution
c       jexec0 = the last two digits of the year at the start of
c                  execution
c       udate0 = the date at the start of execution
c       utime0 = the time at the start of execution
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer iexec0,jexec0
c
      character*11 utime0
      character*9 udate0
c
      real*8 texec0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ndays(12)
c
      integer mo,mm,dd,yy,hr,hs,mi,se
      integer j2,j3
c
      integer ilnobl
c
      logical qleapy
c
      character*8 umonth(12)
      character*8 ux
      character*3 um
c
c-----------------------------------------------------------------------
c
      data (umonth(mo), mo = 1,12) /'Jan','Feb','Mar','Apr','May',
     $ 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/
c
      data ndays(1) /31/
      data (ndays(mo), mo = 3,12) /31,30,31,30,31,31,30,31,30,31/
c
c-----------------------------------------------------------------------
c
c     Get the time and date.
c
c     Calling sequence substitutions:
c       udate0 for udate
c       utime0 for utime
c
      call timdat(udate0,utime0)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the data needed to calculate the actual run time (this
c     will be used by EQLIBU/runtim.f).
c
      ux = udate0(1:2)
      read (ux,1000,err=900) dd
 1000 format(i2)
c
      um = udate0(3:5)
      do mo = 1,12
        if (umonth(mo)(1:3) .eq. um(1:3)) then
          mm = mo
          go to 110
        endif
      enddo
c
      j2 = ilnobl(um)
      j3 = ilnobl(udate0)
      write (noutpt,1010) um(1:j2),udate0(1:j3)
      write (nttyo,1010) um(1:j2),udate0(1:j3)
 1010 format(/' * Error - (EQLIBU/initim) The string "',a,'"',
     $ " doesn't match the standard",/7x,'abbreviation for any',
     $ ' month. This was extracted from the string "',a,'",',
     $ /7x,'which should contain the date at the start of',
     $ ' execution. Check',/7x,'porting modifications in',
     $ ' EQLIBU/timdat.f.')
      stop
c
  110 if (udate0(8:9) .ne. '  ') then
        ux = udate0(6:9)
        read (ux,1020,err=900) yy
 1020   format(i4)
      else
        ux = udate0(6:7)
        read (ux,1000,err=900) yy
      endif
c
      ux = utime0(1:2)
      read (ux,1000,err=910) hr
c
      ux = utime0(4:5)
      read (ux,1000,err=910) mi
c
      ux = utime0(7:8)
      read (ux,1000,err=910) se
c
      ux = utime0(10:11)
      read (ux,1000,err=910) hs
c
      texec0 = hr*3600. + mi*60. + se*1. + hs*0.01
c
c     Get the number of days in February of the current year.
c
      ndays(2) = 28
      call tleapy(yy,qleapy)
      if (qleapy) ndays(2) = 29
c
      iexec0 = dd
      if (mm .gt. 1) then
        do mo = 1, mm - 1
          iexec0 = iexec0 + ndays(mo)
        enddo
      endif
      jexec0 = yy
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  900 j3 = ilnobl(udate0)
      write (noutpt,1030) udate0(1:j3)
      write (nttyo,1030) udate0(1:j3)
 1030 format(/' * Error - (EQLIBU/initim) The date at the start of',
     $ ' execution (udate0)'/7x,'must be a string in the format "',
     $ 'ddMmmccyy" (e.g., 23Sep1997) or',/7x,'"ddmmyy", (e.g.,',
     $ ' 23Sep97). The actual string "',a,'"'," isn't",/7x,'in',
     $ ' compliance with this requirement. Check porting',
     $ ' modifications.',/7x,'in EQLIBU/timdat.f.')
      stop
c
  910 j3 = ilnobl(utime0)
      write (noutpt,1040) utime0(1:j3)
      write (nttyo,1040) utime0(1:j3)
 1040 format(/' * Error - (EQLIBU/initim) The time at the start of',
     $ ' execution (utime0)'/7x,'must be a string in the format "',
     $ 'hh:mm:ss:hs" (e.g., 15:32:19:28).',7x,'The actual string "',
     $ a,'"'," isn't in compliance with this requirement.",
     $ /7x, 'Check porting modifications in EQLIBU/timdat.f.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine ca3bar(azero,a3bar,a3bars,conc,jcsort,narn1,
     $ narn2,natmax,nstmax,sigmam)
c
c     This subroutine calculates the characteristic average cubed
c     distance of closest approach for each aqueous solute species
c     (a3bars) and the average cubed distance of closest approach for
c     all solute species (a3bar). These quantities appear in the
c     first order term representing hard core repulsion in models
c     of aqueous species activity coefficients. In the calculation
c     of these quantities, the weighting factor corresponding to a
c     species is its molality.
c
c     This subroutine is called by:
c
c       EQLIBG/gcoeff.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       azero  = array of hard core diameters
c       conc   = array of species concentrations
c       sigmam = sum of the molalities of the aqueous solute species
c
c     Prinicpal output:
c
c       a3bars = characteristic average cubed distance of closest
c                  approach array
c       a3bar  = average cubed distance of closest approach
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 azero(natmax),a3bars(natmax),conc(nstmax)
      real*8 a3bar,sigmam
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,na,nnn,ns,nsj,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,
     $ ns7,nval
c
      real*8 aij,aij0,aij1,aij2,aij3,aij4,aij5,aij6,aij7,azi,cw,sx
c
c-----------------------------------------------------------------------
c
      do na = 1,narn2 - narn1 + 1
        a3bars(na) = 0
      enddo
      a3bar = 0
      if (sigmam .le. 0.) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the average value of the cube of the distance of closest
c     approach for each aqueous solute species. Logically, this could be
c     represented by:
c
c       do ns = narn1 + 1,narn2
c         na = ns - narn1 + 1
c         sx = 0.
c         do nsj = narn1 + 1,narn2
c           naj = nsj - narn1 + 1
c           aij = 0.5*(azero(na) + azero(naj))
c           sx = sx + conc(nsj)*(aij**3)
c         enddo
c         a3bars(na) = sx/sigmam
c       enddo
c
c     In doing a sorted summation in the inner loop, a complication
c     arises in that water (ns = narn1) must be included in the
c     range of the loop, because the jcsort array is organized to
c     contain the species indices sorted according to increasing
c     concentration within phase ranges. There is no available
c     sorting among aqueous solute species only. This complication
c     is dealt with by temporarily setting the concentration of water
c     (conc(narn1)) to zero. Note the use of a local variable (sx)
c     within the loop. Note also that the loop is unrolled.
c
      cw = conc(narn1)
      conc(narn1) = 0.
      nnn = narn1 - 1
      nval = narn2 - nnn
      ileft = (nval/8)*8 + nnn
c
      do ns = narn1 + 1,narn2
        na = ns - narn1 + 1
        azi = azero(na)
        sx = 0.
c
        do nss = narn1,ileft,8
          ns0 = jcsort(nss)
          ns1 = jcsort(nss + 1)
          ns2 = jcsort(nss + 2)
          ns3 = jcsort(nss + 3)
          ns4 = jcsort(nss + 4)
          ns5 = jcsort(nss + 5)
          ns6 = jcsort(nss + 6)
          ns7 = jcsort(nss + 7)
          aij0 = 0.5*(azi + azero(ns0 - nnn))
          aij1 = 0.5*(azi + azero(ns1 - nnn))
          aij2 = 0.5*(azi + azero(ns2 - nnn))
          aij3 = 0.5*(azi + azero(ns3 - nnn))
          aij4 = 0.5*(azi + azero(ns4 - nnn))
          aij5 = 0.5*(azi + azero(ns5 - nnn))
          aij6 = 0.5*(azi + azero(ns6 - nnn))
          aij7 = 0.5*(azi + azero(ns7 - nnn))
          sx = sx + conc(ns0)*(aij0**3) + conc(ns1)*(aij1**3)
     $            + conc(ns2)*(aij2**3) + conc(ns3)*(aij3**3)
     $            + conc(ns4)*(aij4**3) + conc(ns5)*(aij5**3)
     $            + conc(ns6)*(aij6**3) + conc(ns7)*(aij7**3)
        enddo
c
        do nss = ileft + 1,narn2
          nsj = jcsort(nss)
          aij = 0.5*(azi + azero(nsj - nnn))
          sx = sx + conc(ns)*(aij**3)
        enddo
c
        a3bars(na) = sx/sigmam
      enddo
c
      conc(narn1) = cw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the average value of the cube of the distance of closest
c     approach for all aqeuous solute species. Logically, this could be
c     represented by:
c
c       sx = 0.
c       do ns = narn1 + 1,narn2
c         na = ns - narn1 + 1
c         sx = sx + conc(ns)*a3bars(na)
c       enddo
c       a3bar = sx/sigmam
c
c     Because a3bars(narn1) is defined to be zero, a sorted summation
c     can be safely made by looping from narn1 to narn2. Note the use
c     of a local variable (sx) within the loop. Note also that the loop
c     is unrolled.
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        ns1 = jcsort(nss + 1)
        ns2 = jcsort(nss + 2)
        ns3 = jcsort(nss + 3)
        ns4 = jcsort(nss + 4)
        ns5 = jcsort(nss + 5)
        ns6 = jcsort(nss + 6)
        ns7 = jcsort(nss + 7)
        sx = sx + conc(ns0)*a3bars(ns0 - nnn)
     $          + conc(ns1)*a3bars(ns1 - nnn)
     $          + conc(ns2)*a3bars(ns2 - nnn)
     $          + conc(ns3)*a3bars(ns3 - nnn)
     $          + conc(ns4)*a3bars(ns4 - nnn)
     $          + conc(ns5)*a3bars(ns5 - nnn)
     $          + conc(ns6)*a3bars(ns6 - nnn)
     $          + conc(ns7)*a3bars(ns7 - nnn)
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        sx = sx + conc(ns)*a3bars(ns - nnn)
      enddo
c
      a3bar = sx/sigmam
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine tpadv(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdoth,abdot,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $ adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $ al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,axhfs,
     $ axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dhfs,
     $ dhfsd,dvfe,dvfs,dvfsd,eact,ehfac,farad,hact,iact,iapxmx,iktmax,
     $ imchmx,imech,iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,
     $ ixrn2,jpfcmx,jpress,jptffl,jsol,jtemp,narxmx,narxt,narxth,nbasp,
     $ nbaspd,nbt,nbtd,nbtmax,ncmpr,ndrsr,ndrsrd,nmut,nmutmx,nopgmx,
     $ noptmx,noutpt,nptkmx,nptmax,nrct,nrctmx,nrk,nslt,nsltmx,nst,
     $ nstmax,ntpr,ntprmx,ntprt,nttkmx,nttyo,nweope,nwndpc,nxt,nxtmax,
     $ pmu,presg,presh,press,pressb,pressd,pslamn,ptk,rcnstv,rconst,rk,
     $ rkb,rtcnst,tempc,tempcb,tempcd,tempcu,tempk,time1,trkb,ttk,
     $ uphase,uspec,wfac,xhfe,xhfs,xhfsd,xi1,xlke,xlks,xlksd,xvfe,
     $ xvfs,xvfsd)
c
c     This subroutine changes the temperature and pressure and
c     recomputes all temperature-pressure dependent data. Here tempcd
c     and pressd are the last temperature and pressure, respectively,
c     at which the data were evaluated.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c       EQ6/eqshel.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iapxmx,iktmax,imchmx,ipbtmx,ipchmx,ipcvmx,jpfcmx,narxmx,
     $ nbtmax,nmutmx,nopgmx,noptmx,nptkmx,nptmax,nrctmx,nsltmx,nstmax,
     $ ntprmx,nttkmx,nxtmax
c
      integer noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),imech(2,nrctmx),iopg(nopgmx),
     $ iopt(noptmx),jsol(nxtmax),narxt(ntprmx),narxth(2),nbasp(nbtmax),
     $ nbaspd(nbtmax),ncmpr(2,nptmax),ndrsr(2,nstmax),ndrsrd(2,nstmax),
     $ nrk(2,nrctmx)
c
      integer ipch,ipcv,ixrn1,ixrn2,jpress,jptffl,jtemp,nbt,nbtd,nmut,
     $ nrct,nslt,nst,ntpr,ntprt,nweope,nwndpc,nxt
c
      character*48 uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 tempcu(ntprmx)
c
      real*8 aadh(narxmx,ntprmx),aadhh(narxmx,ntprmx),
     $ aadhv(narxmx,ntprmx),aaphi(narxmx,ntprmx),
     $ abdh(narxmx,ntprmx),abdhh(narxmx,ntprmx),abdhv(narxmx,ntprmx),
     $ abdot(narxmx,ntprmx),abdoth(narxmx,ntprmx),abdotv(narxmx,ntprmx),
     $ adadhh(narxmx,ntprmx,ipchmx),adadhv(narxmx,ntprmx,ipcvmx),
     $ adbdhh(narxmx,ntprmx,ipchmx),adbdhv(narxmx,ntprmx,ipcvmx),
     $ adbdth(narxmx,ntprmx,ipchmx),adbdtv(narxmx,ntprmx,ipcvmx),
     $ adhfe(narxmx,ntprmx,ipchmx),adhfs(narxmx,ntprmx,ipchmx,nstmax),
     $ adhfsd(narxmx,ntprmx,ipchmx,nstmax),advfe(narxmx,ntprmx,ipcvmx),
     $ advfs(narxmx,ntprmx,ipcvmx,nstmax),
     $ advfsd(narxmx,ntprmx,ipcvmx,nstmax),
     $ aprehw(narxmx,ntprmx),apresg(narxmx,ntprmx),apresh(5,2),
     $ axhfe(narxmx,ntprmx),axhfs(narxmx,ntprmx,nstmax),
     $ axhfsd(narxmx,ntprmx,nstmax),axlke(narxmx,ntprmx),
     $ axlks(narxmx,ntprmx,nstmax),axlksd(narxmx,ntprmx,nstmax),
     $ axvfe(narxmx,ntprmx),axvfs(narxmx,ntprmx,nstmax),
     $ axvfsd(narxmx,ntprmx,nstmax)
c
      real*8 dadhh(ipchmx),dadhv(ipcvmx),dbdhh(ipchmx),dbdhv(ipcvmx),
     $ dbdth(ipchmx),dbdtv(ipcvmx),dhfe(ipchmx),dhfs(ipchmx,nstmax),
     $ dhfsd(ipchmx,nstmax),dvfe(ipcvmx),dvfs(ipcvmx,nstmax),
     $ dvfsd(ipcvmx,nstmax),xhfs(nstmax),xhfsd(nstmax),xlks(nstmax),
     $ xlksd(nstmax),xvfs(nstmax),xvfsd(nstmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ prehw,presg,presh,press,xhfe,xlke,xvfe
c
      real*8 amu(jpfcmx,nmutmx),aslm(jpfcmx,0:ipbtmx,nsltmx),
     $ pmu(nmutmx),pslamn(0:ipbtmx,nsltmx)
c
      real*8 apx(iapxmx,nxtmax),wfac(iktmax,nxtmax)
c
      real*8 eact(imchmx,2,nrctmx),hact(imchmx,2,nrctmx),
     $ ptk(nptkmx),rk(imchmx,2,nrctmx),rkb(imchmx,2,nrctmx),
     $ trkb(imchmx,2,nrctmx),ttk(nttkmx)
c
      real*8 afcnst,al10,avcnst,ehfac,farad,pressb,pressd,rcnstv,
     $ rconst,rtcnst,tempc,tempcb,tempcd,tempk,time1,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nwpclm
c
      logical qnewp,qnewt
c
      real*8 dp,dt,pxl,pxu,toldt,toldp
c
c-----------------------------------------------------------------------
c
c     nwpclm  = maximum number of repeated warnings regarding problems
c                associated with pressure corrections
c     nwndpc = number of warnings of no data to support pressure
c                corrections
c     nweope = number of warnings of excursions outside the recommended
c                pressure envelope
c
      data nwpclm /5/
c
c     toldt = tolerance for recalculating temperature-dependent data (C)
c     toldp = tolerance for recalculating pressure-dependent data (bars)
c
      data toldt / 1.e-4 /, toldp /1.e-4 /
c
c-----------------------------------------------------------------------
c
c     Compute the new temperature.
c
      call gtemp(afcnst,al10,iopt,jtemp,noptmx,noutpt,nttkmx,
     $ nttyo,rconst,rtcnst,tempc,tempcb,tempk,time1,ttk,xi1)
c
      dt = tempc - tempcd
      qnewt = .false.
      if (abs(dt) .gt. toldt) then
c
c       Determine the corresponding temperature range flag.
c
        call gntpr(ntpr,ntprmx,ntprt,tempc,tempcu)
c
        qnewt = .true.
c
c       Compute thermodynamic data for the current temperature.
c
        call evdata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $  abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $  adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $  al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,
     $  axhfs,axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,
     $  bdhv,bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,
     $  dhfe,dhfs,dhfsd,dvfe,dvfs,dvfsd,ehfac,farad,iapxmx,iktmax,
     $  iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,ixrn2,jpfcmx,
     $  jptffl,jsol,narxmx,narxt,narxth,ncmpr,nmut,nmutmx,nopgmx,
     $  noptmx,noutpt,nptmax,nslt,nsltmx,nst,nstmax,ntpr,ntprmx,nttyo,
     $  nxt,nxtmax,pmu,prehw,presg,presh,press,pslamn,rconst,rcnstv,
     $  rtcnst,tempc,tempk,uphase,uspec,wfac,xhfe,xhfs,xhfsd,xlke,xlks,
     $  xlksd,xvfe,xvfs,xvfsd)
c
c       Compute kinetic data for the current temperature.
c
        call evratc(eact,hact,iact,imchmx,imech,nrct,nrctmx,nrk,
     $  rk,rkb,rtcnst,tempk,trkb)
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the new pressure.
c
      call gpress(iopt,jpress,noptmx,noutpt,nptkmx,nttyo,presg,
     $ presh,press,pressb,time1,ptk,xi1)
c
c     Skip pressure corrections if the pressure is tracking on the
c     data file reference pressure curve.
c
      if (jpress .le. 0) go to 990
c
c     Skip pressure corrections if the temperature and pressure
c     haven't changed significantly.
c
      dp = press - pressd
      qnewp = abs(dp) .gt. toldp
      if (.not.qnewt .and. .not.qnewp) go to 990
c
c     Skip pressure corrections if the pressure happens to match the
c     data file reference pressure curve value.
c
      dp = press - presg
      if (abs(dp) .le. toldp) go to 990
c
c     Make pressure corrections, if the requisite data are available.
c
      if (ipcv .lt. 0) then
c
c       There are no data to support needed pressure corrections.
c
        if (nwndpc .le. nwpclm) then
          write (noutpt,1000) press,presg,dp
          write (nttyo,1000) press,presg,dp
 1000     format(/' * Warning - (EQ6/tpadv) The supporting data file',
     $    /7x,'contains no data to support making thermodynamic',
     $    /7x,'pressure corrections. No such corrections will be made.',
     $    /7x,'The current pressure is ',1pg12.5,' bars, the standard',
     $    /7x,'grid pressure is ',g12.5,' bars, and the pressure',
     $    /7x,'difference is ',g12.5,' bars.')
          if (nwndpc .eq. nwpclm) then
            write (noutpt,1010)
            write (nttyo,1010)
 1010       format(/' This warning will not be repeated during the',
     $      /7x,'rest of this run.')
          endif
          nwndpc = nwndpc + 1
        endif
      else
        if (abs(dp) .gt. prehw) then
c
c         The pressure is outside the recommended envelope.
c
          pxu = presg + prehw
          pxl = presg - prehw
          if (pxl .le. 0.) pxl = 0.
          write (noutpt,1020) press,pxl,pxu,tempc
          write (nttyo,1020) press,pxl,pxu,tempc
 1020     format(/' * Warning - (EQ6/tpadv) The current pressure',
     $    /7x,'of ',1pg12.5,' bars is outside the recommended',
     $    /7x,'pressure envelope of ',g12.5,' to ',g12.5,' bars',
     $    /7x,'at ',0pf6.2,' C.')
          if (nweope .eq. nwpclm) then
            write (noutpt,1010)
            write (nttyo,1010)
          endif
          nweope = nweope + 1
        endif
c
c       Make pressure corrections to the thermodynamic data.
c
        call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $  nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $  xlks,xvfs)
c
c       Calling sequence substitutions:
c         dhfsd for dhfs
c         dvfsd for dvfs
c         nbaspd for nbasp
c         nbtd for nbt
c         ndrsrd for ndrsr
c         xhfsd for xhfs
c         xlksd for xlks
c         xvfsd for xvfs
c
        call pcorrx(avcnst,dhfsd,dvfsd,ipch,ipchmx,ipcv,ipcvmx,
     $  nbaspd,nbtd,nbtmax,ndrsrd,nst,nstmax,presg,press,xhfsd,
     $  xlksd,xvfsd)
c
c       Make pressure corrections to the kinetic data.
c
c         Presently there are no such corrections.
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 tempcd = tempc
      pressd = press
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
c
      end

      subroutine prtntt(nat,nata,natmax,nbt,nbta,nbtmax,nct,ncta,
     $ nctmax,ngt,ngta,ngtmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,noutpt,
     $ npt,npta,nptmax,nst,nsta,nstmax,nxt,nxta,nxtmax)
c
c     This subroutine prints a table of statistics for species, phases,
c     and groups thereof showing for each entity the number on the data
c     file, the number the software is dimensioned for, and the number
c     appearing in the current problem.
c
c     This subroutine is called by:
c
c       EQ3NR/echox.f
c       EQ6/echoz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nbtmax,nctmax,ngtmax,nltmax,nmtmax,nptmax,nstmax,
     $ nxtmax
c
      integer noutpt
c
      integer nat,nata,nbt,nbta,nct,ncta,ngt,ngta,nlt,nlta,nmt,nmta,
     $ npt,npta,nst,nsta,nxt,nxta
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*24 ux
c
c-----------------------------------------------------------------------
c
      write (noutpt,1000)
 1000 format(/7x,'--- Numbers of Phases, Species, and Groups Thereof',
     $ '---',//7x,'Entity',15x,'Date Base',4x,'Dimension',3x,
     $ 'Current Problem',/)
c
      ux = 'Chemical Elements       '
      write (noutpt,1010) ux,ncta,nctmax,nct
 1010 format(3x,a24,3x,i5,7x,i5,7x,i5)
c
      ux = 'Basis Species'
      write (noutpt,1010) ux,nbta,nbtmax,nbt
c
      ux = 'Phases'
      write (noutpt,1010) ux,npta,nptmax,npt
c
      ux = 'Species'
      write (noutpt,1010) ux,nsta,nstmax,nst
c
      ux = 'Aqueous Species'
      write (noutpt,1010) ux,nata,natmax,nat
c
      ux = 'Pure Minerals'
      write (noutpt,1010) ux,nmta,nmtmax,nmt
c
      ux = 'Pure Liquids'
      write (noutpt,1010) ux,nlta,nltmax,nlt
c
      ux = 'Gas Species'
      write (noutpt,1010) ux,ngta,ngtmax,ngt
c
      ux = 'Solid Soutions'
      write (noutpt,1020) ux,nxta,nxtmax,nxt
 1020 format(3x,a24,3x,i5,7x,i5,7x,i5,/)
c
      end

      subroutine makrsr(cbsri,cesri,cess,eps100,ibsrti,iesrti,jcode,
     $ nbt1mx,nct,nctmax,ness,nessmx,nessr,noutpt,nrct,nrctmx,nsrtmx,
     $ nstmax,nttyo,ubsri,uelem,uesri,ureac,uspec,zchar)
c
c     This subroutine makes a reaction for a special reactant. The
c     reaction is written in terms of the special reactant and strict
c     basis species only, and is charge balanced.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       cesri  = array of coefficients for chemical elements composing
c                  special reactants
c       ibsrti = array of numbers of species in reactions for special
c                  reactants
c       iesrti = array of numbers of chemical elements composing special
c                  reactants
c       jcode  = flag array denoting the types of reactants
c       nbt1mx = the maximum number of basis species plus 1
c       nct    = the number of chemical elements
c       nctmax = the maximum number of chemical elements
c       ness   = array of indices of chemical elements composing
c                  species
c       nessmx = the maximum number of entries in the cess or ness array
c       nessr  = pointer array giving the ranges in the cess and ness
c                  arrays giving the compositions of species
c       nrctmx = the maximum number of reactants
c       nsrtmx = the maximum number of special reactants
c       uelem  = array of names of chemical elements
c       uesri  = array of names of chemical elements composing special
c                  reactants
c       ureac  = array of names of reactants
c       uspec  = array of names of species
c       zchar  = array of electrical charges of species
c
c     Principal output:
c
c       cbsri  = array of coefficients for reactions for special
c                  reactants
c       ibsrti = array of numbers of species in reactions for special
c                  reactants
c       ubsri  = array of names of species in reactions for special
c                  reactants
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbt1mx,nctmax,nessmx,nrctmx,nsrtmx,nstmax
c
      integer noutpt,nttyo
c
      integer ibsrti(nsrtmx),iesrti(nsrtmx),jcode(nrctmx),
     $ ness(nessmx),nessr(2,nstmax)
c
      integer nct,nrct
c
      character*48 uspec(nstmax)
      character*24 ubsri(nbt1mx,nsrtmx),ureac(nrctmx)
      character*8 uelem(nctmax),uesri(nctmax,nsrtmx)
c
      real*8 cbsri(nbt1mx,nsrtmx),cess(nessmx),cesri(nctmax,nsrtmx),
     $ zchar(nstmax)
c
      real*8 eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,n,nc,nch,nci,ncih,ncio,nco,nerr,nn,nrc,nr1,nr2,
     $ ns,nsr
c
      integer ilnobl
c
      real*8 ctxo,ctxh,cx,cxe,cxh,cxo,ztx
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
      nco = 0
      do nc = 1,nct
        if (uelem(nc)(1:2) .eq. 'O ') then
          nco = nc
          go to 100
        endif
      enddo
  100 continue
c
      nch = 0
      do nc = 1,nct
        if (uelem(nc)(1:2) .eq. 'H ') then
          nch = nc
          go to 110
        endif
      enddo
  110 continue
c
      nsr = 0
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 2) then
          nsr = nsr + 1
          if (ibsrti(nsr) .eq. 0) then
            cbsri(1,nsr) = -1.0
            ubsri(1,nsr) = ureac(nrc)
            n = 1
c
            ncio = 0
            do nci = 1,iesrti(nsr)
              if (uesri(nci,nsr)(1:2) .eq. 'O ') then
                ncio = nci
                go to 120
              endif
            enddo
  120       continue
c
            ncih = 0
            do nci = 1,iesrti(nsr)
              if (uesri(nci,nsr)(1:2) .eq. 'H ') then
                ncih = nci
                go to 130
              endif
            enddo
  130       continue
c
            ctxo = 0.
            ctxh = 0.
            if (ncio .gt. 0) ctxo = -cesri(ncio,nsr)
            if (ncih .gt. 0) ctxh = -cesri(ncih,nsr)
            ztx = 0.
c
c           Map all chemical elements except H and O.
c
            do nci = 1,iesrti(nsr)
              if (nci.ne.ncio .and. nci.ne.ncih) then
                do nc = 1,nct
                  if (uesri(nci,nsr)(1:8) .eq. uelem(nc)(1:8)) then
                    n = n + 1
                    ns = nc
                    nr1 = nessr(1,ns)
                    nr2 = nessr(2,ns)
c
                    cxe = 0.
                    cxo = 0.
                    cxh = 0.
                    do nn = nr1,nr2
                      if (ness(nn) .eq. nco) then
                        cxo = cess(nn)
                      elseif (ness(nn) .eq. nch) then
                        cxh = cess(nn)
                      else
                        cxe = cess(nn)
                      endif
                    enddo
                    if (cxe .eq. 0.) then
                      if (cxh.ne.0. .and. cxo.eq.0.) then
                        cxe = cxh
                        cxh = 0.
                      elseif (cxo.ne.0. .and. cxh.eq.0.) then
                        cxe = cxo
                        cxo = 0.
                      elseif (cxo.ne.0. .and. cxh.ne.0.) then
                        cxe = cxo
                        cxo = 0.
                      endif
                    endif
c
                    cx = cesri(nci,nsr)/cxe
                    cbsri(n,nsr) = cx
                    ubsri(n,nsr) = uspec(ns)(1:24)
                    ctxo = ctxo + cxo*cx
                    ctxh = ctxh + cxh*cx
                    ztx = ztx + zchar(ns)*cx
                    go to 140
                  endif
                enddo
                j2 = ilnobl(uesri(nci,nsr))
                j3 = ilnobl(ureac(nrc))
                write (noutpt,1000) uesri(nci,nsr)(1:j2),
     $          ureac(nrc)(1:j3)
                write (nttyo,1000) uesri(nci,nsr)(1:j2),
     $          ureac(nrc)(1:j3)
 1000           format(/" * Error - (EQ6/makrsr) Can't map the",
     $          /7x,'chemical element ',a,', which appears in the'
     $          /7x,'composition for the special reactant ',a,',',
     $          /7x,'into a corresponding basis species to use in',
     $          /7x,'composing reaction for that reactant.')
                nerr = nerr + 1
  140           continue
              endif
            enddo
c
c           Get H+ from charge balance.
c
            if (abs(ztx) .gt. eps100) then
              n = n + 1
              cx = -ztx
              cbsri(n,nsr) = cx
              ubsri(n,nsr) = 'H+ '
              ztx = ztx + cx
              ctxh = ctxh + cx
            endif
c
c           Get H2O from H balance.
c
            if (abs(ctxh) .gt. eps100) then
              n = n + 1
              cx = -0.5*ctxh
              cbsri(n,nsr) = cx
              ubsri(n,nsr) = 'H2O '
              ctxo = ctxo + cx
              ctxh = ctxh + 2.*cx
            endif
c
c           Get O2(g) from O balance.
c
            if (abs(ctxo) .gt. eps100) then
              n = n + 1
              cx = -0.5*ctxo
              cbsri(n,nsr) = cx
              ubsri(n,nsr) = 'O2(g)'
              ctxo = ctxo + 2.*cx
            endif
c
c           Check the balances on H, O, and charge.
c
            if (abs(ctxh).gt.eps100 .or. abs(ctxo).gt.eps100 .or.
     $        abs(ztx).gt.eps100) then
              j2 = ilnobl(ureac(nrc))
              write (noutpt,1110) ureac(nrc)(1:j2)
              write (nttyo,1110) ureac(nrc)(1:j2)
 1110         format(/' * Error - (EQ6/makrsr) The reaction which',
     $        /7x,'was composed for the special reactant "',a,'"',
     $        /7x,'fails to satisfy all balance conditions.')
              nerr = nerr + 1
            endif
c
            ibsrti(nsr) = n
          endif
        endif
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine garmat(act,afrc1,aimatr,al10,armatr,cdac,cdacb,
     $ cdrs,csigma,csts,delvec,dlogxw,dvjdte,eact,eps100,fkrc,gmmatr,
     $ hact,iact,idirec,iindx1,iktmax,imchmx,imech,ipivot,jcode,jreac,
     $ jtemp,kbt,kdim,kmax,mmmatr,morr,mwtrc,nbasp,nbt,nbtmax,ncmpr,
     $ ndac,ndacb,ndact,ndctmx,ndrs,ndrsmx,ndrsr,noutpt,nptmax,nrct,
     $ nrctmx,nrct1,nrk,nrndex,nsk,nstmax,nsts,nstsmx,nstsr,nttkmx,
     $ nttyo,nxridx,nxrtmx,rirec1,rk,rkb,rreac1,rrelr1,rrxfi1,rtcnst,
     $ rxbar,sfcar,sgmatr,ssfcar,tempc,tempcb,tempk,ttk,ureac,whcfac,
     $ xi1,xlks,xxmatr,xymatr)
c
c     This subroutine calculates the Jacobian matrix J[r] (armatr)
c     used by the higher-order (stiff) ODE integrator.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       armatr = the Jacobian matrix J[r]
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,kmax,nbtmax,ndctmx,ndrsmx,nrctmx,nptmax,
     $ nstmax,nstsmx,nttkmx,nxrtmx
c
      integer noutpt,nttyo
c
      integer jtemp,kbt,kdim,nbt,nrct,nrct1
c
      integer iact(imchmx,2,nrctmx),idirec(nrctmx),iindx1(kmax),
     $ imech(2,nrctmx),ipivot(kmax),jcode(nrctmx),jreac(nrctmx),
     $ nbasp(nbtmax),ndac(ndctmx,imchmx,2,nrctmx),ncmpr(2,nptmax),
     $ ndacb(nbt,imchmx,2,nrct),ndact(imchmx,2,nrctmx),
     $ ndrs(ndrsmx),ndrsr(2,nstmax),nrk(2,nrctmx),nrndex(nrctmx),
     $ nsk(nrctmx),nsts(nstsmx),nstsr(2,nstmax),nxridx(nrctmx)
c
      character*24 ureac(nrctmx)
c
      real(8) act(nstmax),afrc1(nrctmx),aimatr(kmax,kmax),
     $ armatr(nrct1,nrct1),cdac(ndctmx,imchmx,2,nrctmx),
     $ cdacb(nbt,imchmx,2,nrct),cdrs(ndrsmx),csigma(imchmx,2,nrctmx),
     $ csts(nstsmx),delvec(kmax),dlogxw(nbtmax),dvjdte(nrct),
     $ eact(imchmx,2,nrctmx),fkrc(nrctmx),gmmatr(kmax,kmax),
     $ hact(imchmx,2,nrctmx),mmmatr(nrct,kmax),morr(nrctmx),
     $ mwtrc(nrctmx),rk(imchmx,2,nrctmx),rkb(imchmx,2,nrctmx),
     $ rreac1(nrctmx),rrelr1(nrctmx),rrxfi1(imchmx,nrctmx),
     $ rxbar(iktmax,nxrtmx),sfcar(nrctmx),sgmatr(nrct,kmax),
     $ ssfcar(nrctmx),ttk(nttkmx),xlks(nstmax),xxmatr(kmax,nrct),
     $ xymatr(nrct,nrct1)
c
      real(8) al10,eps100,rirec1,rtcnst,tempc,tempcb,tempk,whcfac,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,id,idj,idn,ik,j,k,kcol,kk,krow,n,nb,np,nrc,nr1,nr2,
     $ ns,nxr
c
      real(8) ax,cx,cxs,dxy,rt2,sx,vx,xx
c
      real(8) coefst
c
c-----------------------------------------------------------------------
c
c     Zero the matrix J[r] (armatr).
c
      do j = 1,nrct1
        do k = 1,nrct1
          armatr(j,k) = 0.
        enddo
      enddo
c
c     Calculate the matrix M (mmmatr). This incorporates the
c     dependency of rate laws on the thermodynamic activities of
c     species (currently all such species must be of type aqueous).
c
      call gmmmat(act,afrc1,cdac,cdacb,cdrs,csigma,eps100,
     $ fkrc,idirec,iindx1,iktmax,imchmx,imech,jcode,jreac,kbt,kdim,
     $ kmax,mmmatr,nbasp,nbt,nbtmax,ncmpr,ndac,ndacb,ndact,ndctmx,
     $ ndrs,ndrsmx,ndrsr,noutpt,nptmax,nrct,nrctmx,nrk,nrndex,nstmax,
     $ nttyo,nxridx,nxrtmx,rk,rtcnst,rxbar,sfcar,ureac,xlks)
c
c     Now calculate the matrix SIGMA (sgmatr) from matrix M and the
c     array W-squiggle (dlogxw) array.
c
      do nrc = 1,nrct
        do k = 1,kmax
          sgmatr(nrc,k) = 0.
        enddo
      enddo
c
      do nrc = 1,nrct
        if (jreac(nrc) .le. 0) then
          sx = 0.
          do kk = 2,kbt
            sx = sx + mmmatr(nrc,kk)
          enddo
          sgmatr(nrc,1) = al10*(mmmatr(nrc,1)*dlogxw(1) - sx)
          do k = 2,kbt
            sgmatr(nrc,k) = al10*(mmmatr(nrc,1)*dlogxw(k)
     $      + mmmatr(nrc,k))
          enddo
        endif
      enddo
c
c     Calculate the matrix PHI (aimatr), which is the inverse of
c     the Jacobian matrix J[z] used by the algebraic equation solver.
c
      call ginvrt(aimatr,delvec,gmmatr,ipivot,kdim,kmax)
c
c     Emulate the matrix multiplication PHI*THETA. Put the result
c     in a scratch matrix (xxmatr). Note that xxmatr must have zero
c     rows for reactants that are not pure minerals or solid solutions.
c     Those are currently the only types that may have rate dependencies
c     on activities. That might change in the future. Also, in the row-
c     column multiplication, contributions are included only over the
c     index range (1, kbt), not (1, kdim), which would be the general
c     case. That is because the SIGMA array has no non-zero columns
c     beyond the kbt-th. That in turn results because all of the
c     currently allowed rate dependencies on thermodynamic activities
c     are restricted to those of aqueous species.
c
      do krow = 1,kmax
        do nrc = 1,nrct
          xxmatr(krow,nrc) = 0.
        enddo
      enddo
c
      do krow = 1,kdim
        do nrc = 1,nrct
          if (jreac(nrc) .le. 0) then
            if (jcode(nrc) .eq. 0) then
c
c             Pure mineral.
c
              np = nrndex(nrc)
              ns = ncmpr(1,np)
              xx = 0.
              do kcol = 1,kbt
                nb = iindx1(kcol)
                cx = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
                xx = xx + aimatr(krow,kcol)*cx
              enddo
              xxmatr(krow,nrc) = xx
            elseif (jcode(nrc) .eq. 1) then
c
c             Solid solution.
c
              nxr = nxridx(nrc)
              np = nrndex(nrc)
              nr1 = ncmpr(1,np)
              nr2 = ncmpr(2,np)
              xx = 0.
              do kcol = 1,kbt
                nb = iindx1(kcol)
                cx = 0.
                ik = 0
                do ns = nr1,nr2
                  ik = ik + 1
                  cxs = coefst(csts,nsts,nstsmx,nstsr,nb,ns,nstmax)
                  cx = cx + rxbar(ik,nxr)*cxs
                enddo
                xx = xx + aimatr(krow,kcol)*cx
              enddo
              xxmatr(krow,nrc) = xx
            else
              xxmatr(krow,nrc) = 0.
            endif
          endif
        enddo
      enddo
c
c     Calculate the product SIGMA*PHI*THETA, storing the result in
c     scratch matrix xymatr. This operation does not put anything
c     in the last (nrct1-th) column of xymatr. That column is
c     associated with explicit time dependency of the rate
c     equations. It is only used if the r vector of "rates
c     represented by finite differences" is composed of relative
c     rates plus the inverse rate.
c
      do nrc = 1,nrct
        do j = 1,nrct1
          xymatr(nrc,j) = 0.
        enddo
      enddo
c
      do nrc = 1,nrct
        if (jreac(nrc) .le. 0) then
          do j = 1,nrct
            xx = 0.
            do k = 1,kbt
              xx = xx + sgmatr(nrc,k)*xxmatr(k,j)
            enddo
            xymatr(nrc,j) = xx
          enddo
        endif
      enddo
c
c     Emulate the matrix addition SIGMA*PHI*THETA + ZETA.
c     The ZETA matrix addresses the dependencies of rates on
c     surface areas. This coordinates with EQ6\csfar.f, which
c     evaluates surface area models. Here again, the last (nrct1-th)
c     column of xymatr is not used.
c
      do nrc = 1,nrct
        if (jreac(nrc) .le. 0) then
c
          id = idirec(nrc)
          if (nrk(id,nrc) .eq. 1) then
c
c           The rate law is TST-type, therefore there is a surface
c           area dependency.
c
            if (jcode(nrc).eq.0 .or. jcode(nrc).eq.1) then
              np = nrndex(nrc)
              n = ndrsr(1,ns)
              cx = cdrs(n)
            else
              write (noutpt,"(' Illegal jcode value in garmat.f')")
              write (nttyo,"(' Illegal jcode value in garmat.f')")
              stop
            endif
c
            sx = 0.
            if (nsk(nrc) .eq. 0) then
c
c             Constant surface area.
c
              continue
            elseif (nsk(nrc) .eq. 1) then
c
c             Constant specific surface area.
c
              if (sfcar(nrc) .gt. 0.)
     $        sx = rreac1(nrc)*cx*ssfcar(nrc)*mwtrc(nrc)/sfcar(nrc)
            elseif (nsk(nrc) .eq. 2) then
c
c             Constant particle number surface area growth law.
c
              if (morr(nrc) .gt. 0.)
     $        sx = 2.*rreac1(nrc)*cx/(3.*morr(nrc))
            else
              write (noutpt,"(' Illegal nsk value in garmat.f')")
              write (nttyo,"(' Illegal nsk value in garmat.f')")
              stop
            endif
            xymatr(nrc,nrc) = xymatr(nrc,nrc) + sx
          endif
        endif
      enddo
c
c     Overlay for variable temperature. This coordinates with
c     EQ6\evratc.f, which calculates rate constants as a function
c     of temperature, and with EQ6\gtemp.f, which calculates the
c     temperature as a specified function of either Xi or t.
c
      do nrc = 1,nrct
        dvjdte(nrc) = 0.
      enddo
c
      if (jtemp .gt. 0) then
c
c       Calculate temperature derivatives of the rates, following
c       through the temperature dependency of the rate constants.
c       This is needed only if the temperature is a function of
c       Xi or t.
c
        rt2 = rtcnst*tempk
        do nrc = 1,nrct
          if (jreac(nrc) .le. 0) then
            id = idirec(nrc)
            if (nrk(id,nrc) .ge. 2) then
              do i = 1,imech(id,nrc)
                if (iact(i,id,nrc) .eq. 0) then
c
c                 No temperature dependence.
c
                  continue
                elseif (iact(i,id,nrc) .eq. 1) then
c
c                 Constant activation energy.
c
                  dvjdte(nrc) = dvjdte(nrc)
     $            + rrxfi1(i,nrc)*eact(i,id,nrc)/rt2
                elseif (iact(i,id,nrc) .eq. 2) then
c
c                 Constant activation enthalpy.
c
                  dvjdte(nrc) = dvjdte(nrc)
     $            + rrxfi1(i,nrc)*eact(i,id,nrc)/rt2
                endif
              enddo
            endif
          endif
        enddo
      endif
c
      if (jtemp .eq. 0) then
c
c       Constant temperature.
c
        continue
      elseif (jtemp .eq. 1) then
c
c       Temperature is a linear function of Xi.
c       tempc = tempcb + ttk(1)*Xi
c
        do nrc = 1,nrct
          id = idirec(nrc)
          if (jreac(nrc).le.0 .and. nrk(id,nrc).ge.2) then
            dxy = dvjdte(nrc)*ttk(1)
            do j = 1,nrct
              idj = idirec(j)
              if (jreac(j).le.0 .and. nrk(idj,j).ge.2) then
                xymatr(nrc,j) = xymatr(nrc,j) + dxy
              endif
            enddo
          endif
        enddo
      elseif (jtemp .eq. 2) then
c
c       Temperature is a linear function of time.
c       tempc = tempcb + ttk(1)*time1
c
        do nrc = 1,nrct
          id = idirec(nrc)
          if (jreac(nrc).le.0 .and. nrk(id,nrc).ge.2) then
            dxy = dvjdte(nrc)*ttk(1)
            xymatr(nrc,nrct1) = xymatr(nrc,nrct1) + dxy
          endif
        enddo
      elseif (jtemp .eq. 3) then
c
c       Fluid mixing tracking.
c       tempc = (tempcb*ttk(1) + Xi*ttk(2))/(Xi + ttk(1))
c
        do nrc = 1,nrct
          id = idirec(nrc)
          if (jreac(nrc).le.0 .and. nrk(id,nrc).ge.2) then
            dxy = dvjdte(nrc)*((ttk(2) - tempc)/(xi1 + ttk(1)))
            do j = 1,nrct
              idj = idirec(j)
              if (jreac(j).le.0 .and. nrk(idj,j).ge.2) then
                xymatr(nrc,j) = xymatr(nrc,j) + dxy
              endif
            enddo
          endif
        enddo
c
      endif
c
c     Multiply xymatr by the scalar w (whcfac).
c
      do nrc = 1,nrct
        do j = 1,nrct1
          xymatr(nrc,j) = whcfac*xymatr(nrc,j)
        enddo
      enddo
c
c     Emulate the matrix multiplication V*xymatr, which yields
c     the equivalent of J[r] + I. Note that V is nrct1 by nrct,
c     while xymatr is nrct by nrct1. Thus, J[r] and the I in question
c     are nrct1 by nrct1.
c
      do nrc = 1,nrct
        id = idirec(nrc)
        if (jreac(nrc) .le. 0) then
          if (nrk(id,nrc) .eq. 1) then
c
c           The current row of V corresponds to a reactant constrained
c           by a specified relative rate. V(nrc,nrc) = 1.0 and all
c           other elements of this row are zero.
c
            armatr(nrc,j) = xymatr(nrc,j)
          elseif (nrk(id,nrc).ge.2) then
c
c           The current row of V corresponds to a reactant constrained
c           by an absolute rate.
c
            do j = 1,nrct
              ax = 0.
              do n = 1,nrct
                idn = idirec(n)
                if (jreac(n) .le. 0) then
                  if (nrk(idn,n) .ge. 2) then
                    if (n .eq. nrc) then
                      vx = rirec1*(1.0 - rrelr1(nrc))
                    else
                      vx = -rirec1*rrelr1(nrc)
                    endif
                    ax = ax + vx*xymatr(n,j)
                  endif
                endif
                armatr(nrc,j) = ax
              enddo
            enddo
          endif
        endif
      enddo
c
c     Now get the nrct1-th row.
c
      vx = -rirec1**2
      do j = 1,nrct
        ax = 0.
        do n = 1,nrct
          idn = idirec(n)
          if (jreac(n) .le. 0) then
            if (nrk(idn,n) .ge. 2) then
              ax = ax + vx*xymatr(n,j)
            endif
          endif
          armatr(nrct1,j) = ax
        enddo
      enddo
c
c     Finish getting J[r] by substracting the unit matrix.
c
      do nrc = 1,nrct1
        armatr(nrc,nrc) = armatr(nrc,nrc) - 1.0
      enddo
c
      end

      subroutine betars(alphar,betar,btrfnc,btrmax,btrmxo,ibtrmx,
     $ nrct,nrct1,nrctmx,rirec1,rirecp,rrelr1,rrelrp)
c
c     This subroutine calculates residual functions for the ODE
c     integrator.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c       alphar = array of alpha[r] residuals
c       betar  = array of beta[r] residuals
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nrctmx
c
      integer ibtrmx,nrct,nrct1
c
      real(8) alphar(nrct1),betar(nrct1),rrelr1(nrctmx),rrelrp(nrctmx)
c
      real(8) btrfnc,btrmax,btrmxo,rirec1,rirecp
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nrc
c
      integer iarmxn
c
c-----------------------------------------------------------------------
c
c     Calculate absolute (alphar) and normalized (betar) residuals.
c
      do nrc = 1,nrct
        alphar(nrc) = rrelr1(nrc) - rrelrp(nrc)
        betar(nrc) = 0.
        if (rrelrp(nrc) .ne. 0.) betar(nrc) = alphar(nrc)/rrelrp(nrc)
      enddo
c
      alphar(nrct1) = rirec1 - rirecp
      if (rirecp .ne. 0.) betar(nrct1) = alphar(nrct1)/rirecp
c
c     Find the max norm of the normalized residual vector (betar).
c
      ibtrmx = iarmxn(betar,nrct1)
      btrmax = 0.
      if (ibtrmx .gt. 0) btrmax = abs(betar(ibtrmx))
c
c     Calculate the betar improvement function (btrfnc).
c
      btrfnc = 0.
      if (btrmxo .gt. 0.) btrfnc = (btrmxo -btrmax)/btrmxo
c
      btrmxo = btrmax
c
      end

      subroutine stpk36(awmaxi,awmini,cbsri,cbsr1,cdac,cesri,cesr1,
     $ csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $ dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,eact,ehmaxi,ehmini,fkrc,hact,iact,
     $ ibsrti,ibsrt1,iesrti,iesrt1,iktmax,imchmx,imech,iopt,itermx,
     $ ixrti,jcode,jpress,jreac,jtemp,ksplmx,ksppmx,kstpmx,modr,
     $ moffg,morr,mprphi,mprspi,nbt1mx,nctmax,ndact,ndctmx,nffg,
     $ nffgmx,noptmx,nordmx,noutpt,nprob,nprpmx,nprpti,nprsmx,
     $ nprsti,nptkmx,nrct,nrctmx,nrk,nsk,nsrt,nsrtmx,ntitl1,ntitmx,
     $ ntrymx,nttkmx,nttyo,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,
     $ o2maxi,o2mini,phmaxi,phmini,ptk,press,pressb,rkb,rxbari,
     $ sfcar,ssfcar,tempc,tempcb,tempc1,timmxi,tistti,tolsat,
     $ tolxsf,trkb,ttk,ubsri,ubsr1,ucxri,udac,uesri,uesr1,uffg,
     $ uprphi,uprspi,ureac,ureac1,utitl1,uxcat,uxopex,uxopt,vreac,
     $ ximaxi,xistti,xlkffg)
c
c     This subroutine sets up certain variables and arrays for writing
c     the top half of an EQ6 input file. There are currently three
c     options for the form and content of this part of this file.
c     (see below). EQ3NR/setpk3.f performs a somewhat similiar function
c     for data to be written on the normal EQ3NR pickup file, or the
c     bottom half of an EQ6 input file.
c
c     This subroutine should only be called if iopt(19) is greater than
c     zero.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer iktmax,imchmx,nbt1mx,nctmax,ndctmx,nffgmx,noptmx,nordmx,
     $ nprpmx,nprsmx,nptkmx,nsrtmx,ntitmx,nttkmx,nrctmx,nxopmx,nxpemx,
     $ nxrtmx
c
      integer noutpt,nttyo
c
      integer iact(imchmx,2,nrctmx),ibsrti(nsrtmx),iesrti(nsrtmx),
     $ imech(2,nrctmx),iopt(noptmx),ixrti(nxrtmx),jcode(nrctmx),
     $ jreac(nrctmx),ndact(imchmx,2,nrctmx),nrk(2,nrctmx),nsk(nrctmx)
c
      integer ibsrt1,iesrt1,itermx,jpress,jtemp,ksplmx,ksppmx,
     $ kstpmx,nffg,nprob,nprpti,nprsti,nrct,nsrt,ntitl1,ntrymx,
     $ nxopex,nxopt,nxrt
c
      character(len=80) utitl1(ntitmx)
      character(len=48) uprspi(nprsmx)
      character(len=24) ubsri(nbt1mx,nsrtmx),ubsr1(nbt1mx),
     $ ucxri(iktmax,nxrtmx),udac(ndctmx,imchmx,2,nrctmx),uffg(nffgmx),
     $ uprphi(nprpmx),ureac(nrctmx),uxcat(nxopmx),uxopex(nxpemx)
      character(len=8) uesri(nctmax,nsrtmx),uesr1(nctmax),uxopt(nxopmx)
c
      character(len=24) ureac1
c
      real(8) cbsri(nbt1mx,nsrtmx),cbsr1(nbt1mx),
     $ cdac(ndctmx,imchmx,2,nrctmx),cesri(nctmax,nsrtmx),cesr1(nctmax),
     $ csigma(imchmx,2,nrctmx),eact(imchmx,2,nrctmx),fkrc(nrctmx),
     $ hact(imchmx,2,nrctmx),modr(nrctmx),moffg(nffgmx),morr(nrctmx),
     $ mprphi(nprpmx),mprspi(nprsmx),ptk(nptkmx),rkb(imchmx,2,nrctmx),
     $ rxbari(iktmax,nxrtmx),sfcar(nrctmx),ssfcar(nrctmx),
     $ trkb(imchmx,2,nrctmx),ttk(nttkmx),vreac(nrctmx),xlkffg(nffgmx)
c
      real(8) awmaxi,awmini,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $ dlxplo,dlxprl,dlxprn,ehmaxi,ehmini,o2maxi,o2mini,phmaxi,phmini,
     $ press,pressb,tempc,tempcb,tempc1,timmxi,tistti,tolsat,tolxsf,
     $ ximaxi,xistti
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,n,nmax
c
      integer ilnobl
c
      character(len=8) ux8
c
c-----------------------------------------------------------------------
c
      if (iopt(19) .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set up the initial part of the new main title.
c
      call initcb(utitl1,ntitmx)
      ntitl1 = 25
      utitl1(1) = 'EQ6 input file name= sample.6i'
      utitl1(2) = 'Description= "Sample"'
      utitl1(3) = 'Version level= 8.0'
      utitl1(4) = 'Revised mm/dd/yy    Revisor= Username'
      utitl1(6) = '  This is a sample EQ6 input file written as an EQ3NR
     $ pickup file.'
      utitl1(7) = 'The EQ3NR input file used to generate this output is
     $identified in'
      utitl1(8) = 'the second title given below.'
      utitl1(10) = '  You are expected to modify this EQ6 input file to
     $meet your own needs.'
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set various EQ6 input file variables.
c
      ksplmx = 0
      ksppmx = 0
      kstpmx = 500
      ntrymx = 0
      itermx = 0
c
      xistti = 0.
      ximaxi = 1.0
c
      tistti = 0.
      timmxi = 1.e+38
c
      awmaxi = 1.e+38
      awmini = -1.e+38
      ehmaxi = 1.e+38
      ehmini = -1.e+38
      o2maxi = 1.e+38
      o2mini = -1.e+38
      phmaxi = 1.e+38
      phmini = -1.e+38
c
      dlxdmp = 0.
      dlxmx0 = 0.
c
      dlxprn = 0.
      dlxprl = 0.5
      dlxplo = 0.
      dlxpll = 0.
c
      dltprn = 1.e+38
      dltprl = 1.e+38
      dltplo = 1.e+38
      dltpll = 1.e+38
c
      dlaprn = 1.e+38
      dleprn = 1.e+38
      dlhprn = 1.e+38
      dloprn = 1.e+38
      dlaplo = 1.e+38
      dleplo = 1.e+38
      dlhplo = 1.e+38
      dloplo = 1.e+38
c
      tolsat = 0.
      tolxsf = 0.
      nordmx = 6
c
      jtemp = 0
      call initaz(ttk,nttkmx)
      tempcb = tempc
c
      if (iopt(19) .eq. 3) then
        if (abs(tempc - tempc1) .gt. 1.e-6) then
c
c         Set up for non-isothermal fluid-mixing.
c
          jtemp = 3
          ttk(2) = tempc1
          ttk(1) = 1.0
        endif
      endif
c
      jpress = 0
      call initaz(ptk,nptkmx)
      pressb = press
c
      nrct = 0
      call initiz(jcode,nrctmx)
      call initiz(jreac,nrctmx)
      call initiz(nsk,nrctmx)
c
      nsrt = 0
      call initiz(ibsrti,nsrtmx)
      call initiz(iesrti,nsrtmx)
c
      nmax = nbt1mx*nsrtmx
      call initaz(cbsri,nmax)
      call initcb(ubsri,nmax)
c
      nmax = nctmax*nsrtmx
      call initaz(cesri,nmax)
      call initcb(uesri,nmax)
c
      call initiz(ixrti,nxrtmx)
c
      nxrt = 0
      nmax = iktmax*nxrtmx
      call initaz(rxbari,nmax)
      call initcb(ucxri,nmax)
c
      call initcb(ureac,nrctmx)
      call initaz(fkrc,nrctmx)
      call initaz(sfcar,nrctmx)
      call initaz(ssfcar,nrctmx)
c
      nmax = 2*nrctmx
      call initiz(imech,nmax)
      call initiz(nrk,nmax)
c
      nmax = imchmx*2*nrctmx
      call initaz(csigma,nmax)
      call initaz(rkb,nmax)
      call initaz(trkb,nmax)
      call initaz(eact,nmax)
      call initaz(hact,nmax)
      call initiz(iact,nmax)
      call initiz(ndact,nmax)
c
      nmax = ndctmx*imchmx*2*nrctmx
      call initaz(cdac,nmax)
      call initcb(udac,nmax)
c
      nffg = 0
      call initcb(uffg,nffgmx)
      call initaz(moffg,nffgmx)
      call initaz(xlkffg,nffgmx)
c
      nxopt = 0
      call initcb(uxopt,nxopmx)
      call initcb(uxcat,nxopmx)
      nxopex = 0
      call initcb(uxopex,nxpemx)
c
      nprpti = 0
      call initaz(mprphi,nprpmx)
      call initcb(uprphi,nprpmx)
c
      nprsti = 0
      call initaz(mprspi,nprsmx)
      call initcb(uprspi,nprsmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(19) .eq. 1) then
c
c       Write an EQ6 input file with a single dissolving reactant,
c       Quartz. Its dissolution is controlled by a specified
c       relative rate of 1.0. The basic purpose of this option is
c       to provide a template for a file on which the reactants
c       react according to specified relative rates. It is intended
c       that the user then modify this template to describe the
c       problem actually desired.
c
        utitl1(12) = '  This sample file has Quartz dissolving at a rela
     $tive rate of 1.0.'
        utitl1(13) = 'It may or may not actually run. For example, Quart
     $z may not appear'
        utitl1(14) = 'on the supporting data file.'
c
        nrct = 1
        ureac(1) = 'Quartz'
        jcode(1) = 0
        jreac(1) = 0
        morr(1) = 1.0
        modr(1) = 0.
        nrk(1,1) = 1
        rkb(1,1,1) = 1.0
c
      elseif (iopt(19) .eq. 2) then
c
c       Write an EQ6 input file with a single dissolving reactant,
c       Albite. Its dissolution is controlled by a specified
c       TST rate law. The basic purpose of this option is to
c       provide a template for a file on which the reactants
c       react according to specified TST rate laws. It is intended
c       that the user then modify this template to describe the
c       problem actually desired.
c
        utitl1(12) = '  This sample file has Albite dissolving according
     $ to a TST rate law.'
        utitl1(13) = 'It may or may not actually run. For example, Albit
     $e may not appear'
        utitl1(14) = 'on the supporting data file.'
        utitl1(16) = '  The kinetic data shown here are taken from Knaus
     $s and Wolery (1986). You'
        utitl1(17) = 'may or may not wish to use these particular data.
     $In any case, you are'
        utitl1(18) = 'entirely responsible for the data that you do use.
     $'
        utitl1(20) = '                            References'
        utitl1(22) = 'Knauss, K.G., and Wolery, T.J., 1986, Dependence o
     $f albite dissolution'
        utitl1(23) = '  kinetics on pH and time at 25C and 70C, Geochimi
     $ca et Cosmochimica Acta,'
c
        utitl1(24) = '  v. 50, p. 2481-2497.'
        nrct = 1
        ureac(1) = 'Albite'
        jcode(1) = 0
        jreac(1) = 0
        morr(1) = 1.0
        modr(1) = 0.
        nsk(1) = 0
        sfcar(1) = 1.0e+4
        fkrc(1) = 1.0
c
        nrk(1,1) = 1
        nrk(2,1) = -1
        imech(1,1) = 3
c
c       Acid range.
c
        rkb(1,1,1) = 1.00e-15
        trkb(1,1,1) = 25.0
        iact(1,1,1) = 2
        hact(1,1,1) = 28.47
        csigma(1,1,1) = 1.0
        ndact(1,1,1) = 1
        udac(1,1,1,1) = 'H+'
        cdac(1,1,1,1) = 1.0
c
c       Neutral range.
c
        rkb(2,1,1) = 3.98e-17
        trkb(2,1,1) = 25.0
        iact(2,1,1) = 2
        hact(2,1,1) = 12.89
        csigma(2,1,1) = 1.0
        ndact(2,1,1) = 0
c
c       Alkaline range.
c
        rkb(3,1,1) = 5.01e-21
        trkb(3,1,1) = 25.0
        iact(3,1,1) = 2
        hact(3,1,1) = 7.68
        csigma(3,1,1) = 1.0
        ndact(3,1,1) = 1
        udac(1,3,1,1) = 'H+'
        cdac(1,3,1,1) = -0.5
c
      elseif (iopt(19) .eq. 3) then
c
c       Write an EQ6 input file for a fluid mixing calculation in
c       which "Fluid 2" is mixed into "Fluid 1". Note that "Fluid 2"
c       appears first on the EQ3NR input file, beflore "Fluid 1".
c       It appears as a special reactant ont he top half of the EQ6
c       input file. "Fluid 1" is the starting aqueous solution in the
c       equilibrium system, and appears in the bottom half. If this
c       option is chosen for the first and only problem on the EQ3NR
c       input file, the pickup file produced is set up for mixing of
c       this fluid with itself. This would normally be useful only
c       as a template.
c
c       Set iopt(17) for the first fluid ("Fluid 2") to -1, so no
c       pickup file is produced (iopt(19) can be set to 0). For the
c       second fluid ("Fluid 1"), set iopt(17) equal to 0 and
c       iopt(19) equal to 3.
c
        utitl1(12) = '  This sample file has "Fluid 2" mixing into "Flui
     $d 1". "Fluid 2" was the'
        utitl1(13) = 'first aqueous solution on the EQ3NR input file, "F
     $luid 1" was the second.'
        utitl1(14) = 'The option switch iopt(19) was set to 3 for the la
     $tter to produce the'
        utitl1(15) = 'present EQ6 input file.'
        if (jtemp .eq. 0) then
          utitl1(16) = ' '
          utitl1(17) = '  Mixing will be isothermal as specified below.'
        elseif (jtemp .eq. 3) then
          utitl1(16) = ' '
          utitl1(17) = '  Mixing will be non-isothermal as specified bel
     $ow.'
        endif
c
        if (nprob .eq. 1) then
          utitl1(18) = ' '
          utitl1(19) = '  Warning: This EQ6 input file is set up to mix
     $a fluid with itself.'
        endif
c
        nrct = 1
        nsrt = 1
        ureac(1) = ureac1
        jcode(1) = 2
        jreac(1) = 0
        morr(1) = 1.0
        modr(1) = 0.
        nrk(1,1) = 1
        rkb(1,1,1) = 1.0
c
        vreac(1) = 1.0
c
        iesrti(1) = iesrt1
        do n = 1,iesrt1
          uesri(n,1) = uesr1(n)
          cesri(n,1) = cesr1(n)
        enddo
c
        ibsrti(1) = ibsrt1
        do n = 1,ibsrt1
          ubsri(n,1) = ubsr1(n)
          cbsri(n,1) = cbsr1(n)
        enddo
c
      else
c
c       Unknown option switch value.
c
        write (ux8,"(i5)") iopt(19)
        call lejust(ux8)
        j2 = ilnobl(ux8)
        write (noutpt,1000) ux8(1:j2)
        write (nttyo,1000) ux8(1:j2)
 1000   format(/' * Error - (EQ3NR/stpk36) Programming error trap:',
     $  ' The "Advanced EQ3NR',/7x,'PICKUP File Options" switch',
     $  ' iopt(19) has an unknown value of ',a,'.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine fpbnpp(affp,affp0,aftarg,daffp0,delxi,dlxmin,dxval0,
     $ eps100,iodb,iopt,jpflag,nodbmx,noptmx,nord,nordmx,noutpt,npchk,
     $ npt,nptmax,nrd1mx,nttyo,tolaft,tolsat,uphase,xi0,xi1,xval0)
c
c     This subroutine finds the phase boundary at which a phase appears
c     in the equilibrium system (ES). Note that the phase affinities
c     are tracked using finite differences.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nordmx,noptmx,nptmax,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),iopt(noptmx),jpflag(nptmax),npchk(nptmax)
c
      integer nord,npt
c
      character*24 uphase(nptmax)
c
      real*8 affp(nptmax),affp0(nptmax),daffp0(nordmx,nptmax),
     $ dxval0(nrd1mx)
c
      real*8 aftarg,delxi,dlxmin,eps100,tolaft,tolsat,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      character*48 usearch
      character*24 unam24
c
      integer icount,ier,ilsign,j2,kpsst,n,np,npsst
c
      integer ilnobl
c
      real*8 afx,dxsv,tolsx,xtargv,xval
c
c-----------------------------------------------------------------------
c
      data usearch /'a phase just supersaturates                     '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is not where the affinity is zero, but aftarg.
c     The interval for convergence is (tolsat,tolsst).  The target
c     (aftarg) is the midpoint of this interval.
c
      ilsign = -1
      xtargv = aftarg
      tolsx = tolaft
      dxsv = delxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for product phases just supersaturating',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Estimate the affinities of formation of the various phases from
c     Taylor's series expansions.
c
      call ataylr(delxi,daffp0,nord,nordmx,npt,nptmax,affp0,affp)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any predicted supersaturations. Note that these count only
c     if they exceed the tolerance tolsat.
c
      xval = 0.
      npsst = 0
      kpsst = 0
      unam24 = ' '
      do np = 1,npt
        afx = affp(np)
        if (afx .ge. tolsat) then
          if (jpflag(np).le.0 .and. jpflag(np).ne.-1) then
            if (npchk(np) .ne. 1) then
              kpsst = kpsst + 1
              if (afx .gt. xval) then
                xval = affp(np)
                npsst = np
                unam24 = uphase(np)
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kpsst .gt. 0) then
        if (delxi .gt. dlxmin) then
          if (abs(xval - xtargv) .gt. tolsx) then
c
            xval0 = affp0(npsst)
            do n = 1,nord
              dxval0(n) = daffp0(n,npsst)
            enddo
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 999
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0 .or. iopt(3).ge.1) then
        if (kpsst .gt. 0) then
          write (noutpt,1010) xi1,delxi
 1010     format(/3x,"Taylor's series predict the appearance of the",
     $    ' following',/3x,'phases in the ES at Xi= ',1pe11.4,
     $    ', delxi= ',e11.4,':',/)
c
          do np = 1,npt
            afx = affp(np)
            if (abs(afx - xtargv) .le. tolsx) then
              if (jpflag(np).le.0 .and. jpflag(np).ne.-1) then
                if (npchk(np) .ne. 1) then
                  j2 = ilnobl(uphase(np))
                  write (noutpt,1020) uphase(np)(1:j2)
 1020             format(5x,a)
                endif
              endif
            endif
          enddo
c
        endif
      endif
c
      if (iopt(3) .ge. 1) delxi = dxsv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine prtsso(acflg,actlg,affpd,affsd,ixrn1,ixrn2,
     $ jsol,jsomax,ncmpr,noutpt,np,nptmax,nstmax,nxtmax,sidrph,
     $ sidrsp,tolspf,uspec,uphase,uxtype,xbar,xbarlg)
c
c     This subroutine prints tables describing the state and properties
c     of the np-th phase (a solid solution).
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c----------------------------------------------------------------------
c
c     Principal input:
c
c       acflg  = array of log activity coefficients
c       actlg  = array of log activities of species
c       affpd  = array of phase affinities
c       affsd  = array of species affinities
c       sidrph = array of phase saturation indices
c       sidrsp = array of species saturation indices
c       tolspf = saturation print flag tolerance, used to flag those
c                  phases which are close to saturation
c       uphase = array of phase names
c       xbar   = array of mole fractions of species
c       xbarlg = array of log mole fractions of species
c
c     Principal output:
c
c       None
c
c----------------------------------------------------------------------
c
      implicit none
c
c----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer jsomax,nptmax,nstmax,nxtmax
c
      integer noutpt
c
      integer jsol(nxtmax),ncmpr(2,nptmax)
      integer ixrn1,ixrn2,np
c
      character*48 uspec(nstmax)
      character*32 uxtype(jsomax)
      character*24 uphase(nptmax)
c
      real*8 acflg(nstmax),actlg(nstmax),affpd(nptmax),affsd(nstmax),
     $ sidrph(nptmax),sidrsp(nstmax),xbar(nstmax),xbarlg(nstmax)
c
      real*8 tolspf
c
c----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,j3,k,nr1,nr2,ns,nx
c
      integer ilnobl
c
      real*8 aafx,afx
c
c----------------------------------------------------------------------
c
      j2 = ilnobl(uphase(np))
c
      if (np.lt.ixrn1 .or. np.gt. ixrn2) then
        write (noutpt,1000) uphase(np)(1:j2)
        write (noutpt,1000) uphase(np)(1:j2)
 1000   format(/' * Error - (EQLIB/prtsso) Programming error trap:',
     $  /7x,"Can't write an output table for ",a," because",
     $  /7x,"it isn't a solid solution.")
        stop
      endif
c
      nr1 = ncmpr(1,np)
      nr2 = ncmpr(2,np)
c
      nx = np - ixrn1 + 1
      k = jsol(nx)
c
      j3 = ilnobl(uxtype(k))
      write (noutpt,1010) uphase(np)(1:j2),uxtype(k)(1:j3)
 1010 format(/16x,'--- ',a,' ---'//3x,a,/)
c
c     Print mole fractions, activity coefficients, and activities.
c
      write (noutpt,1020)
 1020 format(4x,'Component',20x,'x',11x,'Log x',3x,'Log lambda',2x,
     $ 'Log activity',/)
c
      do ns = nr1,nr2
        if (xbar(ns) .le. 0.) then
          write (noutpt,1030) uspec(ns),xbar(ns)
        else
          write (noutpt,1030) uspec(ns),xbar(ns),xbarlg(ns),
     $    acflg(ns),actlg(ns)
 1030     format(1x,a24,3x,1pe11.4,3(3x,0pf9.4))
        endif
      enddo
      write (noutpt,1040)
 1040 format(1x)
c
c     Print saturation states and affinities.
c
      write (noutpt,1100)
 1100 format(/4x,'Mineral',23x,'Log Q/K',9x,'Aff, kcal',4x,'State',/)
      afx = affpd(np)
      aafx = abs(afx)
      if (aafx .le. tolspf) then
        write (noutpt,1110) uphase(np),sidrph(np),affpd(np)
 1110   format(1x,a24,2x,2(3x,f13.4),3x,'SATD')
      elseif (afx .gt. tolspf) then
        write (noutpt,1120) uphase(np),sidrph(np),affpd(np)
 1120   format(1x,a24,2x,2(3x,f13.4),3x,'SSATD')
      else
        write (noutpt,1130) uphase(np),sidrph(np),affpd(np)
 1130   format(1x,a24,2x,2(3x,f13.4))
      endif
c
      do ns = nr1,nr2
        if (xbar(ns) .gt. 0.) then
          afx = affsd(ns)
          aafx = abs(afx)
          if (aafx .le. tolspf) then
            write (noutpt,1140) uspec(ns),sidrsp(ns),affsd(ns)
 1140       format(3x,a24,2(3x,f13.4),3x,'SATD')
          elseif (afx .gt. tolspf) then
            write (noutpt,1150) uspec(ns),sidrsp(ns),affsd(ns)
 1150       format(3x,a24,2(3x,f13.4),3x,'SSATD')
          else
            write (noutpt,1160) uspec(ns),sidrsp(ns),affsd(ns)
 1160       format(3x,a24,2(3x,f13.4))
          endif
        endif
      enddo
      write (noutpt,1070)
 1070 format(1x)
c
      end

      subroutine rdpar(adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,
     $ bdotv,cco2,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,dvfe,
     $ ipch,ipchmx,ipcv,ipcvmx,itgenf,nacdpr,narxmx,narxt,ndat0s,
     $ ndbmax,ndbptg,ndbptl,nerr,noutpt,ntprmx,ntprt,nttyo,nwarn,
     $ prehw,presg,q500fl,tdamax,tdamin,tempc,uakey,udbfmt,udbval,
     $ xdbval,xhfe,xlke,xvfe)
c
c     This subroutine reads the data describing the temperature grid
c     and data for miscellaneous parameters which are represented
c     on this grid from the DATA0 file. Such parameters include the
c     pressure, the Debye-Huckel parameters A(gamma,10), B(gamma),
c     and A(phi), the B-dot parameter of Helgeson (1969), and the
c     equilibrium constant for the "Eh" reaction. Depending on the
c     values of the ipch and ipcv flags, pressure derivatives of
c     various order of these parameters may also be read. If pressure
c     corrections are available, a grid for the half-width of the
c     pressure correction band is also read. This subroutine also
c     reads the nominal temperature limits for the data file. These
c     limits are written on the DATA1 and DATA1F files. This suboutine
c     also reads the coefficients needed to calculate the acivity
c     coefficient of CO2(aq) using the Drummond (1981) equation.
c
c     The counter nerr is incremented by one for each error encountered.
c     The counter nwarn is similarly incremented for each warning.
c
c     This suboutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ipch   = enthalpy functions data grid flag:
c                  -1 = no enthalpy grids
c                   0 = enthalpy grids present
c                   1 = grids present for the enthalpy and its first
c                         pressure derivative
c                   2 = grids present for the enthalpy and its first
c                         and second pressure derivatives
c       ipcv   = volume functions data flag:
c                  -1 = no volume grids
c                   0 = volume grids present
c                   1 = grids present for the volume and its first
c                         pressure derivative
c                   2 = grids present for the volume and its first
c                         and second pressure derivatives
c       ndat0s = unit number of the stripped DATA0 file
c       narxt  = array of numbers of coefficients in the temperature
c                  ranges
c       ntprt  = the number of temperature ranges on the standard
c                  temperature grid
c       uakey  = string specifying the type of data file ("SEDH" or
c                  "Pitzer") being processed
c
c     Principal output:
c
c       adh    = array of A(gamma,10) values on the standard
c                  temperature grid
c       adhh   = array of A(H) values on the standard temperature
c                  grid; A(H) contains but is not equal to
c                  dA(gamma,10)/dT
c       adhv   = array of A(V) values on the standard temperature
c                  grid; A(V) contains but is not equal to
c                  dA(gamma,10)/dP
c       aphi   = array of A(phi) values on the standard temperature
c                  grid; A(phi) = A(gamma,e)/3 = 2.303A(gamma,10)/3,
c                  so the pressure derivatives of A(phi) are obtained
c                  from A(V) and dnA(V)/dPn.
c       bdh    = array of B(gamma) values on the standard temperature
c                  grid
c       bdhh   = array of B(H) values on the standard temperature grid
c       bdhv   = array of B(V) values on the standard temperature grid
c       bdot   = array of B-dot values on the standard temperature
c                  grid
c       bdoth  = array of B-dot(H)values on the standard temperature
c                  grid
c       bdotv  = array of B-dot(V) values on the standard temperature
c                  grid
c       cco2   = array of coefficients for the Drummond (1981)
c                  equation
c       dadhh  = array of dnA(H)/dPn values on the standard temperature
c                  grid
c       dadhv  = array of dnA(V)/dPn values on the standard temperature
c                  grid
c       dbdhh  = array of dnB(H)/dPn values on the standard temperature
c                  grid
c       dbdhv  = array of dnA(V)/dPn values on the standard temperature
c                  grid
c       dbdth  = array of dnB-dot(H)/dPn values on the standard
c                  temperature grid
c       dbdtv  = array of dnB-dot(V)/dPn values on the standard
c                  temperature grid
c       dhfe   = array of pressure derivatives of the enthalpy of
c                  reaction for the "Eh" reaction on the standard
c                  temperature grid
c       dvfe   = array of pressure derivatives of the volume of
c                  reaction for the "Eh" reaction on the standard
c                  temperature grid
c       ndbptg = the number of distinct points on the standard
c                  temperature grid.
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c       presg  = array of standard pressures on the standard
c                  temperature grid
c       prehw  = array of half-width values for the standard pressure
c                  envelope on the standard temperature grid
c       tdamax = the nominal maximum temperature (C) for which the
c                  data file is valid
c       tdamin = the nominal minimum temperature (C) for which the
c                  data file is valid
c       tempc  = array of temperatures defining the standard
c                  temperature grid
c       udbfmt = the format used when reading a line of data on the
c                  standard temperature grid
c       xlke   = array of log K values for the "Eh" reaction
c                  on the standard temperature grid
c       xhfe   = array of enthalpy of reaction values for the "Eh"
c                  reaction hon the standard temperature grid
c       xvfe   = array of volume of reaction values for the "Eh"
c                  reaction on the standard temperature grid
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipchmx,ipcvmx,narxmx,ndbmax,ntprmx
c
      integer ndat0s,noutpt,nttyo
c
      integer nacdpr(ntprmx),narxt(ntprmx)
c
      integer ipch,ipcv,itgenf,ndbptg,ndbptl,nerr,ntprt,nwarn
c
      logical q500fl
c
      character(len=16) udbval(ndbmax)
c
      character(len=16) udbfmt
      character(len=8) uakey
c
      real(8) tdamax,tdamin
c
      real(8) cco2(5)
c
      real(8) adh(narxmx,ntprmx),adhh(narxmx,ntprmx),
     $ adhv(narxmx,ntprmx),aphi(narxmx,ntprmx),bdh(narxmx,ntprmx),
     $ bdhh(narxmx,ntprmx),bdhv(narxmx,ntprmx),bdot(narxmx,ntprmx),
     $ bdoth(narxmx,ntprmx),bdotv(narxmx,ntprmx),
     $ dadhh(narxmx,ntprmx,ipchmx),dadhv(narxmx,ntprmx,ipcvmx),
     $ dbdhh(narxmx,ntprmx,ipchmx),dbdhv(narxmx,ntprmx,ipcvmx),
     $ dbdth(narxmx,ntprmx,ipchmx),dbdtv(narxmx,ntprmx,ipcvmx),
     $ dhfe(narxmx,ntprmx,ipchmx),dvfe(narxmx,ntprmx,ipcvmx),
     $ prehw(narxmx,ntprmx),presg(narxmx,ntprmx),tempc(narxmx,ntprmx),
     $ xdbval(ndbmax),xhfe(narxmx,ntprmx),xlke(narxmx,ntprmx),
     $ xvfe(narxmx,ntprmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ipc,j2,j3,n,ndbloc,ntpr
c
      integer ilnobl
c
      logical qend,qerr,q500nd
c
      character(len=24) ux24,ux24lc
      character(len=80) ulbufa,ulbufb,uline,ustr80
c
c-----------------------------------------------------------------------
c
c     Skip to the 'Temperature limits' line.
c
      ux24 = 'Temperature limits (degC'
      ux24lc = ux24
      call locase(ux24lc)
  100 read (ndat0s,1000,end=110,err=995) ustr80
 1000 format(a)
      call lejust(ustr80)
      call locase(ustr80)
      if (ustr80(1:24) .ne. ux24lc(1:24)) go to 100
      go to 120
c
  110 j2 = ilnobl(ux24)
      write (noutpt,1010) ux24(1:j2)
      write (nttyo,1010) ux24(1:j2)
 1010 format(/' * Error - (EQPT/rdpar) Unexpectedly encountered',
     $ ' end-of-file',/7x,'while searching the DATA0 file for the',
     $ ' find the line containing',/7x,'"',a,'".')
      stop
  120 continue
c
c     Read in the parameters. First, read the nominal temperature
c     limits.
c
      read (ndat0s,1002,end=990,err=995) tdamin,tdamax
 1002 format(5x,2f10.4)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the standard temperature grid. The format of this grid will
c     be analyzed and will serve as a template for that of subsequent
c     data presented on this grid. The original EQ3/6 format was
c     four points per line. Up to six points per line are now possible.
c     The format will be determined by counting the number of data
c     points on the first line.
c
c       ndbptl = maximum number of data points per line (1-6)
c       ndbptg = number of data points in the entire grid
c       ndbloc = number of lines containing the grid
c
      ndbptg = narxt(1)
      do ntpr = 2,ntprt
        ndbptg = ndbptg + narxt(ntpr) - 1
      enddo
c
      ux24 = 'Temperatures            '
      ux24lc = ux24
      call locase(ux24lc)
      read (ndat0s,1000,end=990,err=995) ustr80
      call lejust(ustr80)
      call locase(ustr80)
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        ux24 = 'Temperature grid (degC) '
        ux24lc = ux24
        call locase(ux24lc)
      endif
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        ux24 = 'Temperature grid (C)    '
        ux24lc = ux24
        call locase(ux24lc)
      endif
c
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        j2 = ilnobl(ux24)
        j3 = ilnobl(ustr80)
        j3 = min(j3,24)
        write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
        write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
 1020   format(/' * Error - (EQPT/rdpar) Found the string "',a,'"',
     $  /7x,'on the DATA0 file where the string "',a,'"',
     $  /7x,'was expected.')
        stop
      endif
c
c     Analyze the grid format.
c
      read (ndat0s,1030,end=990,err=995) uline
 1030 format(a80)
      backspace(ndat0s)
c
      ulbufa = uline
      ulbufb = ' '
      ndbptl = 0
      do n = 1,6
        call lejust(ulbufa)
        i = index(ulbufa,' ')
        if (i .le. 1) go to 130
        ndbptl = ndbptl + 1
        ulbufb = ulbufa(i:80)
        ulbufa = ulbufb
      enddo
  130 continue
c
      ndbloc = ndbptg/ndbptl
      if (mod(ndbptg,ndbptl) .gt. 0) ndbloc = ndbloc + 1
      udbfmt = '( (5x,6f10.4) )'
      write (udbfmt(7:7),'(i1)') ndbptl
c
c     The format analysis is complete.
c     Read the temperatures on the log K temperature grid.
c     Return the data in the xdbval holding array.
c
      q500nd = .false.
      call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $ udbval,xdbval)
      if (qend) go to 990
      if (qerr) go to 995
c     read (ndat0s,udbfmt,end=990,err=995) (xdbval(i), i = 1,ndbptg)
c
c     Load the data into the tempc array.
c
c     Calling sequence substitutions:
c       tempc for zdbval
c
      call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $ xdbval,tempc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the standard pressure grid.
c
      ux24 = 'Pressures               '
      ux24lc = ux24
      call locase(ux24lc)
      read (ndat0s,1000,end=990,err=995) ustr80
      call lejust(ustr80)
      call locase(ustr80)
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        ux24 = 'Pressure grid (bars)    '
        ux24lc = ux24
        call locase(ux24lc)
      endif
c
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        j2 = ilnobl(ux24)
        j3 = ilnobl(ustr80)
        j3 = min(j3,24)
        write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
        write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
        stop
      endif
c
c     Read the pressures on the log K temperature grid.
c     Return the data in the xdbval holding array.
c
      q500nd = .false.
      call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $ udbval,xdbval)
      if (qend) go to 990
      if (qerr) go to 995
c
c     Load the data into the presg array.
c
c     Calling sequence substitutions:
c       presg for zdbval
c
      call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $ xdbval,presg)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ipcv .ge. 0) then
c
c       Read the standard pressure envelope half-width.
c
        ux24 = 'Pressure envelope half-w'
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the pressure half-widths on the log K temperature grid.
c       Return the data in the xdbval holding array.
c
        q500nd = .false.
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the prehw array.
c
c       Calling sequence substitutions:
c         prehw for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,prehw)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq .'SEDH    ') then
c
c       Read the grid for the Debye-Huckel A(gamma,10) parameter and
c       the grids for related parameters.
c
        ux24 = 'Debye Huckel A (ADH)    '
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Debye-Huckel A_gamma (kg'
          ux24lc = ux24
          call locase(ux24lc)
        endif
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Debye-Huckel A_gamma    '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the Debye-Huckel A(gamma,10) values on the log K
c       temperature grid. Return the data in the xdbval holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the adh array.
c
c       Calling sequence substitutions:
c         adh for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,adh)
c
        if (ipch .ge. 0) then
c
c         Read the grid for the Debye-Huckel A(H) parameter.
c
          ux24 = 'Debye-Huckel A_H (kcal*k'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel A_H        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel A(H) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the adhh array.
c
c         Calling sequence substitutions:
c           adhh for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,adhh)
c
          do ipc = 1,ipch
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel A(H) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dadhh array.
c
c           Calling sequence substitutions:
c             dadhh for zdbval
c             ipchmx for ipcmax
c
            call ldbar3(ipc,ipchmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dadhh)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Read the grid for the Debye-Huckel A(V) parameter.
c
          ux24 = 'Debye-Huckel A_V (cm**3*'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel A_V        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel A(V) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the adhv array.
c
c         Calling sequence substitutions:
c           adhv for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,adhv)
c
          do ipc = 1,ipcv
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel A(V) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dadhv array.
c
c           Calling sequence substitutions:
c             dadhv for zdbval
c             ipcvmx for ipcmax
c
            call ldbar3(ipc,ipcvmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dadhv)
          enddo
        endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Read the grid for the Debye-Huckel B(gamma) parameter and
c
        ux24 = 'Debye Huckel B (BDH)    '
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Debye-Huckel B_gamma (kg'
          ux24lc = ux24
          call locase(ux24lc)
        endif
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Debye-Huckel B_gamma    '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the Debye-Huckel B(gamma) values on the log K temperature
c       grid. Return the data in the xdbval holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the bdh array.
c
c       Calling sequence substitutions:
c         bdh for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,bdh)
c
        if (ipch .ge. 0) then
c
c         Read the grid for the Debye-Huckel B(H) parameter.
c
          ux24 = 'Debye-Huckel B_H (cal*kg'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel B_H        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel B(H) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the bdhh array.
c
c         Calling sequence substitutions:
c           bdhh for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,bdhh)
c
          do ipc = 1,ipch
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel B(H) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dbdhh array.
c
c           Calling sequence substitutions:
c             dbdhh for zdbval
c             ipchmx for ipcmax
c
            call ldbar3(ipc,ipchmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dbdhh)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Read the grid for the Debye-Huckel B(V) parameter.
c
          ux24 = 'Debye-Huckel B_V (cm**2*'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel B_V        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel B(V) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the bdhv array.
c
c         Calling sequence substitutions:
c           bdhv for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,bdhv)
c
          do ipc = 1,ipcv
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel B(V) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dbdhv array.
c
c           Calling sequence substitutions:
c             dbdhv for zdbval
c             ipcvmx for ipcmax
c
            call ldbar3(ipc,ipcvmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dbdhv)
          enddo
        endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Read the grid for the B-dot parameter and the grids for
c       related parameters.
c
        ux24 = 'Bdot                    '
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'B-dot                   '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the B-dot values on the log K temperature grid.
c       Return the data in the xdbval holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the bdot array.
c
c       Calling sequence substitutions:
c         bdot for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,bdot)
c
        if (ipch .ge. 0) then
c
c         Read the grid for the B-dot(H) parameter.
c
          ux24 = 'B-dot_H                 '
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the B-dot(H) values on the log K temperature grid
c         Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the bdoth array.
c
c         Calling sequence substitutions:
c           bdoth for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,bdoth)
c
          do ipc = 1,ipch
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the B-dot(H) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dbdth array.
c
c           Calling sequence substitutions:
c             dbdth for zdbval
c             ipchmx for ipcmax
c
            call ldbar3(ipc,ipchmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dbdth)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Read the grid for the B-dot(V) parameter.
c
          ux24 = 'B-dot_V                 '
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the B-dot(V) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the bdotv array.
c
c         Calling sequence substitutions:
c           bdotv for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,bdotv)
c
          do ipc = 1,ipcv
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the B-dot(V) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dbdtv array.
c
c           Calling sequence substitutions:
c             dbdtv for zdbval
c             ipcvmx for ipcmax
c
            call ldbar3(ipc,ipcvmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dbdtv)
          enddo
        endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c       Read the coefficients for computing the activity coefficient
c       of CO2(aq) from the Drummond (1981) equation.
c
        ux24 = 'Cco2   (coefficients for'
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Cco2                    '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
        read (ndat0s,1060,end=990,err=995) (cco2(n), n = 1,5)
 1060   format(5x,f10.4,11x,f12.7,/10x,f5.1,11x,f12.4,/5x,f10.6)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (uakey(1:8) .eq .'Pitzer  ') then
c
c       Read the grid for the Debye-Huckel A(phi) parameter and
c       the grids for related parameters.
c
        ux24 = 'Debye Huckel Aphi       '
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Debye_Huckel A_phi      '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the Debye-Huckel A(phi) values on the log K temperature
c       grid. Return the data in the xdbval holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the aphi array.
c
c       Calling sequence substitutions:
c         aphi for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,aphi)
c
        if (ipch .ge. 0) then
c
c         Read the grid for the Debye-Huckel A(H) parameter.
c
          ux24 = 'Debye-Huckel A_H (kcal*k'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel A_H        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel A(H) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the adhh array.
c
c         Calling sequence substitutions:
c           adhh for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,adhh)
c
          do ipc = 1,ipch
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel A(H) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dadhh array.
c
c           Calling sequence substitutions:
c             dadhh for zdbval
c             ipchmx for ipcmax
c
            call ldbar3(ipc,ipchmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dadhh)
          enddo
        endif
c
        if (ipcv .ge. 0) then
c
c         Read the grid for the Debye-Huckel A(V) parameter.
c
          ux24 = 'Debye-Huckel A_V (cm**3*'
          ux24lc = ux24
          call locase(ux24lc)
          read (ndat0s,1000,end=990,err=995) ustr80
          call lejust(ustr80)
          call locase(ustr80)
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            ux24 = 'Debye-Huckel A_V        '
            ux24lc = ux24
            call locase(ux24lc)
          endif
c
          if (ustr80(1:24) .ne. ux24lc(1:24)) then
            j2 = ilnobl(ux24)
            j3 = ilnobl(ustr80)
            j3 = min(j3,24)
            write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
            write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
            stop
          endif
c
c         Read the Debye-Huckel A(V) values on the log K temperature
c         grid. Return the data in the xdbval holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the adhv array.
c
c         Calling sequence substitutions:
c           adhv for zdbval
c
          call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $    xdbval,adhv)
c
          do ipc = 1,ipcv
c
            read (ndat0s,1000,end=990,err=995) ustr80
c
c           Read the Debye-Huckel A(V) pressure derivatives on the
c           log K temperature grid. Return the data in the xdbval
c           holding array.
c
            q500nd = q500fl
            call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $      udbval,xdbval)
            if (qend) go to 990
            if (qerr) go to 995
c
c           Load the data into the dadhv array.
c
c           Calling sequence substitutions:
c             dadhv for zdbval
c             ipcvmx for ipcmax
c
            call ldbar3(ipc,ipcvmx,nacdpr,narxmx,narxt,ndbmax,
     $      ntprmx,ntprt,xdbval,dadhv)
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the grid for the log K of the "Eh" reaction and the grids
c     for related parameters.
c
      ux24 = 'log k for eh reaction   '
      ux24lc = ux24
      call locase(ux24lc)
      read (ndat0s,1000,end=990,err=995) ustr80
      call lejust(ustr80)
      call locase(ustr80)
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        ux24 = 'Eh reaction: logKr (2H2O'
        ux24lc = ux24
        call locase(ux24lc)
      endif
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        ux24 = 'Eh reaction: logKr      '
        ux24lc = ux24
        call locase(ux24lc)
      endif
c
      if (ustr80(1:24) .ne. ux24lc(1:24)) then
        j2 = ilnobl(ux24)
        j3 = ilnobl(ustr80)
        j3 = min(j3,24)
        write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
        write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
        stop
      endif
c
c     Read the "Eh" reaction log K values on the log K temperature
c     grid. Return the data in the xdbval holding array.
c
      q500nd = q500fl
      call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $ udbval,xdbval)
      if (qend) go to 990
      if (qerr) go to 995
c
c     Load the data into the xlke array.
c
c     Calling sequence substitutions:
c       xlke for zdbval
c
      call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $ xdbval,xlke)
c
      if (ipch .ge. 0) then
c
c       Read the grid for the enthalpy of reaction of the "Eh"
c       reaction.
c
        ux24 = 'Eh reaction: delh0r (kca'
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Eh reaction: delH0r     '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the "Eh" reaction enthalpy function values on the
c       log K temperature grid. Return the data in the xdbval
c       holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xhfe array.
c
c       Calling sequence substitutions:
c         xhfe for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,xhfe)
c
        do ipc = 1,ipch
c
          read (ndat0s,1000,end=990,err=995) ustr80
c
c         Read the "Eh" reaction enthalpy function derivatives on
c         the log K temperature grid. Return the data in the xdbval
c         holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the dhfe array.
c
c         Calling sequence substitutions:
c           dhfe for zdbval
c           ipchmx for ipcmax
c
          call ldbar3(ipc,ipchmx,nacdpr,narxmx,narxt,ndbmax,
     $    ntprmx,ntprt,xdbval,dhfe)
        enddo
      endif
c
      if (ipcv .ge. 0) then
c
c       Read the grid for the volume of reaction of the "Eh"
c       reaction.
c
        ux24 = 'Eh reaction: delv0r (cm*'
        ux24lc = ux24
        call locase(ux24lc)
        read (ndat0s,1000,end=990,err=995) ustr80
        call lejust(ustr80)
        call locase(ustr80)
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          ux24 = 'Eh reaction: delV0r     '
          ux24lc = ux24
          call locase(ux24lc)
        endif
c
        if (ustr80(1:24) .ne. ux24lc(1:24)) then
          j2 = ilnobl(ux24)
          j3 = ilnobl(ustr80)
          j3 = min(j3,24)
          write (noutpt,1020) ustr80(1:j3),ux24(1:j2)
          write (nttyo,1020) ustr80(1:j3),ux24(1:j2)
          stop
        endif
c
c       Read the "Eh" reaction volume function values on the
c       log K temperature grid. Return the data in the xdbval
c       holding array.
c
        q500nd = q500fl
        call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $  udbval,xdbval)
        if (qend) go to 990
        if (qerr) go to 995
c
c       Load the data into the xvfe array.
c
c       Calling sequence substitutions:
c         xvfe for zdbval
c
        call ldbar2(nacdpr,narxmx,narxt,ndbmax,ntprmx,ntprt,
     $  xdbval,xvfe)
c
        do ipc = 1,ipcv
c
          read (ndat0s,1000,end=990,err=995) ustr80
c
c         Read the "Eh" reaction volume function derivatives on
c         the log K temperature grid. Return the data in the xdbval
c         holding array.
c
          q500nd = q500fl
          call rdgrid(ndat0s,ndbmax,ndbptg,ndbptl,qend,qerr,q500nd,
     $    udbval,xdbval)
          if (qend) go to 990
          if (qerr) go to 995
c
c         Load the data into the dvfe array.
c
c         Calling sequence substitutions:
c           dvfe for zdbval
c           ipcvmx for ipcmax
c
          call ldbar3(ipc,ipcvmx,nacdpr,narxmx,narxt,ndbmax,ntprmx,
     $    ntprt,xdbval,dvfe)
        enddo
      endif
c
      read (ndat0s,1000,end=990,err=995) ustr80
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 write (noutpt,2000)
      write (nttyo,2000)
 2000 format(/' * Error - (EQPT/rdpar) Unexpectedly encountered',
     $ /7x,'end-of-file while reading the DATA0 file.')
      stop
c
  995 write (noutpt,2010)
      write (nttyo,2010)
 2010 format(/' * Error - (EQPT/rdpar) Encountered a read format',
     $ /7x,'error while reading the DATA0 file.')
      stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine tprcca(amucca,amuc2a,apsi,icapr,iccatr,ipbtmx,
     $ jpfcmx,natmax,ncapr,nccatr,ncvcca,nc2atr,nerr,noutpt,
     $ npx3mx,npx3t,nttyo,nwarn,pcvcca,qpdca,qpdcca,uaqsp,
     $ utripl,zaqsp)
c
c     Test and process the Pitzer data for cc'a (cation, different
c     cation, anion) triplets read from the DATA0 file. Find and flag
c     errors, such as duplication of data (e.g., two data blocks for
c     the same cc'a triplet). Calculate the conventional primitive
c     Pitzer parameters from the observable compound parameters read
c     from the data file:
c
c       psi(cc'a) -> mu(cc'a)
c
c     Note: mu(cc'a) depends on cphi(ca) and cphi(c'a) as well as
c     psi(cc'a).
c
c     Check the coverage of entered Pitzer data against all possible
c     cc'a triplets that can be composed of the cations and anions
c     present on the data file.
c
c     This subroutine is complementary to tpraac.f, which does the
c     same thing for aa'c (anion, different anion, cation) triplets.
c
c     This subroutine is called by:
c
c       EQPT/eqpt.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nat    = the number of aqueous species
c       uaqsp  = array of names of aqueous species
c
c     Principal output:
c
c       nerr   = cumulative error counter
c       nwarn  = cumulative warning counter
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ipbtmx,jpfcmx,natmax,ncapr,nccatr,nc2atr,npx3mx
c
      integer noutpt,nttyo
c
      integer icapr(2,ncapr),iccatr(3,nccatr)
c
      integer ncvcca,nerr,npx3t,nwarn
c
      logical qpdca(ncapr),qpdcca(nccatr)
c
      character(len=24) uaqsp(natmax),utripl(3,npx3mx)
c
      real*8 apsi(jpfcmx,npx3mx),amucca(jpfcmx,nccatr),
     $ amuc2a(jpfcmx,nc2atr),zaqsp(natmax)
c
      real*8 pcvcca
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ii,j,jj,jt,jtripl,j2,j3,j4,j5,j6,k,n,ncount,ndupl,
     $ nlistl,nn,nodatc
c
      integer ilnobl
c
      logical qfound1,qfound2
c
      character(len=80) ustr80
      character(len=24) unam1,unam2,unam3
      character(len=8) ux8
c
      real(8), dimension(:), allocatable :: amu1,amu2
c
      real(8) z1,z2
c
c-----------------------------------------------------------------------
c
c     Limit on the list of triplets for which no data were found.
c
      data nlistl / 20 /
c
c-----------------------------------------------------------------------
c
c     Allocate work space arrays.
c
      ALLOCATE(amu1(jpfcmx))
      ALLOCATE(amu2(jpfcmx))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the data arrays.
c
      do n = 1,nccatr
        qpdcca(n) = .false.
        do j = 1,jpfcmx
          amucca(j,n) = 0.
        enddo
      enddo
c
c     Check the entered data for cc'a triplets.
c
      nodatc = 0
c
      do n = 1,nccatr
        i = iccatr(1,n)
        j = iccatr(2,n)
        k = iccatr(3,n)
        unam1 = uaqsp(i)
        unam2 = uaqsp(j)
        unam3 = uaqsp(k)
        j2 = ilnobl(unam1)
        j3 = ilnobl(unam2)
        j4 = ilnobl(unam3)
        z1 = zaqsp(i)
        z2 = zaqsp(j)
c
c       Search for unam1, unam2, unam3 in the utripl array.
c       That array corresponds to the species triplets blocks.
c
        call srch33(jtripl,unam1,unam2,unam3,utripl,npx3mx,npx3t)
c
        if (jtripl .le. 0) then
c
c         No data block was found on the DATA0 file.
c         Note that qpdcca(n) is left with a value of .false.
c
          nodatc = nodatc + 1
c
        else
c
c         Have found an entry.
c
          qpdcca(n) = .true.
c
c         Check for duplicate data sets.
c
          ndupl = 0
          do jt = jtripl + 1,npx3t
            if (unam1(1:24) .eq. utripl(1,jt)(1:24)) then
              if (unam2(1:24) .eq. utripl(2,jt)(1:24)) then
                if (unam3(1:24) .eq. utripl(3,jt)(1:24)) then
                  ndupl = ndupl + 1
                endif
              endif
            endif
          enddo
c
          if (ndupl .gt. 0) then
            if (ndupl .eq. 1) then
              write (noutpt,1010) unam1(1:j2),unam2(1:j3),unam3(1:j4)
              write (nttyo,1010) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1010         format(/' * Error - (EQPT/tprcca) Have found a',
     $        ' duplicate data block',/7x,'on the DATA0 file',
     $        " for the cc'a triplet",/7x,a,', ',a,', ',a,'.')
            else
              ux8 = ' '
              write (ux8,'(i5)') ndupl
              call lejust(ux8)
              j6 = ilnobl(ux8)
              write (noutpt,1020) ux8(1:j6),unam1(1:j2),unam2(1:j3),
     $        unam3(1:j4)
              write (nttyo,1020) ux8(1:j6),unam1(1:j2),unam2(1:j3),
     $        unam3(1:j4)
 1020         format(/' * Error - (EQPT/tprcca) Have found ',a,
     $        ' duplicate data blocks',/7x,'on the DATA0 file',
     $        " for the cc'a triplet",/7x,a,', ',a,', ',a,'.')
            endif
            nerr = nerr + ndupl
          endif
c
c         Get the data for the two constituent binary systems.
c
          qfound1 = .false.
          do j = 1,jpfcmx
            amu1(j) = 0.
          enddo
c
          do nn = 1,ncapr
            ii = icapr(1,nn)
            if (uaqsp(ii)(1:24) .eq. unam1(1:24)) then
              jj = icapr(2,nn)
              if (uaqsp(jj)(1:24) .eq. unam3(1:24)) then
                if (qpdca(nn)) then
                  qfound1 = .true.
                  do j = 1,jpfcmx
                    amu1(j) = amuc2a(j,nn)
                  enddo
                  go to 130
                endif
              endif
            endif
          enddo
  130     continue
c
          qfound2 = .false.
          do j = 1,jpfcmx
            amu2(j) = 0.
          enddo
c
          do nn = 1,ncapr
            ii = icapr(1,nn)
            if (uaqsp(ii)(1:24) .eq. unam2(1:24)) then
              jj = icapr(2,nn)
              if (uaqsp(jj)(1:24) .eq. unam3(1:24)) then
                if (qpdca(nn)) then
                  qfound2 = .true.
                  do j = 1,jpfcmx
                    amu2(j) = amuc2a(j,nn)
                  enddo
                  go to 140
                endif
              endif
            endif
          enddo
  140     continue
c
          if (qfound1 .and. qfound2) then
            do j = 1,jpfcmx
              amucca(j,n) = (apsi(j,jtripl) +
     $        3.0*((z2/z1)*amu1(j) + (z1/z2)*amu2(j)))/6.
            enddo
          else
c
c           Certain required data were not found on the DATA0 file.
c
            write (noutpt,1030) unam1(1:j2),unam2(1:j3),unam3(1:j4)
            write (nttyo,1030) unam1(1:j2),unam2(1:j3),unam3(1:j4)
 1030       format(/' * Error - (EQPT/tprcca) Have data on the DATA0',
     $      " file for the cc'a",/7x,'triplet ',a,', ',a,', ',a,', but',
     $      " don't have the",/7x,'required data for the following',
     $      ' cation-anion pair(s):',/)
c
            if (.not.qfound1) then
              write (noutpt,1040) unam1(1:j2),unam3(1:j4)
              write (nttyo,1040) unam1(1:j2),unam3(1:j4)
 1040         format(9x,a,', ',a)
            endif
c
            if (.not.qfound2) then
              write (noutpt,1040) unam2(1:j3),unam3(1:j4)
              write (nttyo,1040) unam2(1:j3),unam3(1:j4)
            endif
c
            nerr = nerr + 1
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nodatc .gt. 0) then
        write (noutpt,1060)
        write (nttyo,1060)
 1060   format(/' * Warning - (EQPT/tprcca) Did not find a data',
     $  ' block on the DATA0 file',/7x,'for any of the following',
     $  " cc'a triplets:",/)
c
        ncount = 0
        do n = 1,nccatr
          if (.not.qpdcca(n)) then
            ncount = ncount + 1
            i = iccatr(1,n)
            j = iccatr(2,n)
            k = iccatr(3,n)
            unam1 = uaqsp(i)
            unam2 = uaqsp(j)
            unam3 = uaqsp(k)
            j2 = ilnobl(unam1)
            j3 = ilnobl(unam2)
            j4 = ilnobl(unam3)
            ustr80 = unam1(1:j2) // ', ' // unam2(1:j3) // ', ' //
     $      unam3(1:j4)
            j5 = ilnobl(ustr80)
            write (noutpt,1070) ustr80(1:j5)
            write (nttyo,1070) ustr80(1:j5)
 1070       format(9x,a)
            if (ncount .eq. nlistl) go to 200
          endif
        enddo
  200   continue
c
        nn = nodatc - ncount
        if (nn .gt. 0) then
          write (ux8,'(i5)') nn
          call lejust(ux8)
          j3 = ilnobl(ux8)
          write (noutpt,1080) ux8(1:j3)
          write (nttyo,1080) ux8(1:j3)
 1080     format(/9x,'plus ',a,' others')
        endif
        write (noutpt,1090)
        write (nttyo,1090)
 1090   format(1x)
        nwarn = nwarn + 1
      endif
c
      ncvcca = nccatr - nodatc
      pcvcca = (100.*ncvcca)/float(nccatr)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Deallocate work space arrays.
c
      DEALLOCATE(amu1)
      DEALLOCATE(amu2)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine dawfix(aamatr,cdrs,eps100,gmmatr,iindx1,iodb,
     $ irdxc3,jflag,jjndex,kbt,kkndex,kmax,narn1,nbasp,nbtmax,ncosp,
     $ ndrs,ndrsmx,ndrsr,nelect,nhydr,nodbmx,no2gaq,noutpt,nstmax,
     $ qawfix,uspec)
c
c     This subroutine determines if the activity of water is directly
c     or indirectly fixed. For example, the user might directly specify
c     the activity of water. Alternatively, a set of solubility
c     constraints (e.g., gysum + anhydrite) might indirectly fix it.
c     If the activity of water is fixed directly or indirectly, the
c     the flag 'qawfix' is returned with a value of '.true.'.
c
c     This subroutine is called by:
c
c       EQ3NR/arrset.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,ndrsmx,nodbmx,nstmax
c
      integer noutpt
c
      integer iindx1(kmax),iodb(nodbmx),jjndex(nbtmax),jflag(nstmax),
     $ kkndex(nbtmax),ncosp(nbtmax),nbasp(nbtmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax)
c
      integer irdxc3,kbt,narn1,nelect,nhydr,no2gaq
c
      logical qawfix
c
      character*48 uspec(nstmax)
c
      real(8) aamatr(kmax,kmax),cdrs(ndrsmx),gmmatr(kmax,kmax)
c
      real(8) eps100
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ibt,icol,ihydr,io2gaq,irow,irow1,irow2,iwater,j2,jcol,
     $ jcol1,jcol2,krow,nb,nb1,ns,ns1,ns2
c
      integer ilnobl
c
      logical qldep,qx
c
      real(8) coefdr
c
c-----------------------------------------------------------------------
c
      qawfix = .false.
c
c     Check for directly specified water activity. Note that the
c     following assumes that water is the first aqueous species
c     (e.g., it has the species index narn1).
c
      if (jflag(narn1) .eq. 16) then
        qawfix = .true.
        go to 999
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Build a matrix to test for water activity fixed by simultaneous
c     equilibria.
c
      ibt = 0
      iwater = 0
      ihydr = 0
      io2gaq = 0
c
      do krow = 1,kbt
        nb = iindx1(krow)
        ns = nbasp(nb)
        kkndex(nb) = 0
        qx = .false.
        if (ns .eq. narn1) then
          qx = .true.
        elseif (ns.eq.nelect .or. ns.eq.no2gaq) then
          qx = irdxc3 .ne. 0
        else
          qx = jflag(ns).eq.25 .or. jflag(ns).eq.27
        endif
c
        if (qx) then
          ibt = ibt + 1
          jjndex(ibt) = nb
          kkndex(nb) = 1
          if (ns .eq. narn1) iwater = ibt
          if (ns .eq. nhydr) ihydr = ibt
          if (ns .eq. no2gaq) io2gaq = ibt
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the matrix dimension. Unless it is greater than or equal to
c     two, the activity of water is not fixed indirectly.
c
      if (ibt .lt. 2) go to 999
c
c     Build the matrix.
c
      do icol = 1,ibt
        do irow = 1,ibt
          aamatr(irow,icol) = 0.
        enddo
      enddo
c
      do irow = 1,ibt
        nb = jjndex(irow)
        ns = nbasp(nb)
        if (ns .eq. narn1) then
c
c         Water.
c
          aamatr(irow,irow) = 1.0
        elseif (jflag(ns) .eq. 27) then
c
c         Aqueous homogenous equilibrium.
c
          do icol = 1,ibt
            nb1 = jjndex(icol)
            ns1 = nbasp(nb1)
c
c           Calling sequence substitutions:
c             ns1 for nse
c
            aamatr(irow,icol)
     $       = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns,nstmax)
          enddo
        elseif (jflag(ns) .eq. 25) then
c
c         Heterogeneous equilibrium.
c
          ns2 = ncosp(nb)
          do icol = 1,ibt
            ns1 = jjndex(icol)
c
c           Calling sequence substitutions:
c             ns1 for nse
c             ns2 for ns
c
            aamatr(irow,icol)
     $       = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns2,nstmax)
          enddo
        elseif (irdxc3 .lt. 0) then
c
c         Eh (an input pe- has been converted to Eh).
c
          aamatr(irow,iwater) = -2.
          aamatr(irow,io2gaq) = 1.
          if (ihydr .gt. 0) aamatr(irow,ihydr) = 4.
        else
c
c         Aqueous redox couple.
c
          ns2 = irdxc3
          do icol = 1,ibt
            ns1 = jjndex(icol)
            if (kkndex(ns1) .ge. 1) then
c
c             Calling sequence substitutions:
c               ns1 for nse
c               ns2 for ns
c
              aamatr(irow,icol)
     $        = coefdr(cdrs,ndrs,ndrsmx,ndrsr,ns1,ns2,nstmax)
            endif
          enddo
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(3) .ge. 3) then
        write (noutpt,1000)
 1000   format(/10x,'--- Matrix to Test for Fixed Activity of Water',
     $  ' ---',/)
        do irow = 1,ibt
          write (noutpt,1010) (aamatr(irow,icol), icol = 1,ibt)
 1010     format(2x,10(f7.2,2x))
        enddo
        write (noutpt,1020)
 1020   format(/1x)
c
        do irow = 1,ibt
          nb = jjndex(irow)
          ns = nbasp(nb)
          j2 = ilnobl(uspec(ns)(1:24))
          write (noutpt,1030) irow,uspec(ns)(1:j2)
 1030     format(2x,i3,2x,a)
c
          if (ns .eq. narn1) then
            write (noutpt,1040)
 1040       format(/10x,'Mole fraction definition',/)
          elseif (jflag(ns) .eq. 27) then
c
c           Calling sequence substitutions:
c             noutpt for nf
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns,nstmax,uspec)
          elseif (jflag(ns) .eq. 25) then
            ns2 = ncosp(ns)
c
c           Calling sequence substitutions:
c             noutpt for nf
c             ns2 for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns2,nstmax,uspec)
          elseif (irdxc3 .lt. 0) then
            write (noutpt,1050)
 1050       format(/10x,'2 H2O(l) = 4 H+ + 4 e- + O2(g)',/)
          else
            ns2 = irdxc3
c
c           Calling sequence substitutions:
c             noutpt for nf
c             ns2 for ns
c
            call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns2,nstmax,uspec)
          endif
          write (noutpt,1020)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make a copy of the matrix.
c
      do irow = 1,ibt
        do jcol = 1,ibt
          gmmatr(irow,jcol) = aamatr(irow,jcol)
        enddo
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test for linear dependence omitting the water row and column.
c     The original matrix is overwritten in the process.
c
      irow1 = 2
      irow2 = ibt
      jcol1 = 2
      jcol2 = ibt
      call lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,qldep)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qldep) then
c
c       Have linear dependence omitting the water column. Test for
c       linear dependence with the water column (still omitting the
c       water row).
c
c       Restore the matrix from the copy.
c
        do irow = 1,ibt
          do jcol = 1,ibt
            aamatr(irow,jcol) = gmmatr(irow,jcol)
          enddo
        enddo
c
        jcol1 = 1
        call lindep(aamatr,eps100,irow1,irow2,jcol1,jcol2,kmax,qldep)
        qawfix = .not.qldep
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine elmdd(aphi,el,elp,elpp,fxi,ijz,qpit75)
c
c     This subroutine calculates the E-lambda function (el) and its
c     first two derivatives (elp and elpp) with respect to ionic
c     strength (fxi) for the charge pair product ijz. The E-lambda
c     function and its derivatives are used to evaluate Pitzer's
c     equations. Here aphi is the Debye-Huckel A(phi) parameter.
c
c     Note: el = elp = elpp = 0 if ijz is less than or equal to 0.
c
c     This subroutine is called by:
c
c       EQLIBG/gelam.f.
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       aphi   = Debye-Huckel A(phi) parameter
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       ijz    = input charge product
c
c     Principal output:
c
c       el     = array of values of E-lambda functions
c       elp    = array of first ionic strength derivatives of
c                  E-lambda functions
c       elpp   = array of second ionic strength derivatives of
c                  E-lambda functions
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer ijz
c
      logical qpit75
c
      real(8) aphi,el,elp,elpp,fxi
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real(8) ck,cx,dhj0,d2hj0,hj0,hj1,hj2,ri,sjp,sjpp,x,fxisqt,xp,xpp
c
c-----------------------------------------------------------------------
c
      el = 0.
      elp = 0.
      elpp = 0.
c
      if (ijz .gt. 0.) then
c
        fxisqt = sqrt(fxi)
        cx = 3.*ijz*aphi
        x = 2.*cx*fxisqt
c
c       Compute x' and x''.
c
        xp = cx/fxisqt
        xpp = -(0.5*xp)/fxi
c
c       Get J0(x) and related functions.
c
        if (.not.qpit75) then
c
c         Use the Chebyshev polynomial approximation
c         of Harvie (1981). This is what should normally
c         be used. Note that hj1 and hj2 are outputs
c         that are not used.
c
          call ghj0(dhj0,d2hj0,hj0,hj1,hj2,x)
        else
c
c         Use the less accurate approximation of
c         Pitzer (1975).
c
c         Calling sequence substitutions:
c           dhj0 for dpj0
c           d2hj0 for d2pj0
c           hj0 for pj0
c
          call gpj0(dhj0,d2hj0,hj0,x)
        endif
c
c       Convert these to derivatives with respect to I.
c
        sjp = dhj0*xp
        sjpp = dhj0*xpp + d2hj0*xp*xp
c
        ck = 0.25*ijz
        ri = 1./fxi
c
        el = ri*ck*hj0
        elp = ri*(ck*sjp - el)
        elpp = ri*(ck*sjpp - 2.*elp)
      endif
c
      end

      program eq6
c
c     This is the main program of the EQ6 code. Configuration
c     identification, the copyright statement, legal disclaimers,
c     and similar statements are contained in EQ6/aaaeq6.f, the
c     lead-off subroutine in the EQ3NR source code. A short description
c     of this program is also contained in that subroutine.
c
c-----------------------------------------------------------------------
c
c     Modules.
c
c     The module mod6pt contains data required to evaluate Pitzer's
c     equations.
c
      use mod6pt
c
c     The module mod6xf contains most of the standard-state
c     thermodynamic data.
c
      use mod6xf
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqlpar.h'
c
      include 'eqlib/eqldv.h'
      include 'eqlib/eqlge.h'
      include 'eqlib/eql1s.h'
c
      include 'eqlib/eqlo8.h'

c-----------------------------------------------------------------------
c     File path parameters
c-----------------------------------------------------------------------
      integer :: numargs
      character(1024) :: temppath
      character(:), allocatable :: data1path
      character(:), allocatable :: sixipath
      integer :: pathindices(2)
      character(:), allocatable :: basename
      character(:), allocatable :: ofile
      character(:), allocatable :: pfile
      character(:), allocatable :: bafile
      character(:), allocatable :: bbfile
      character(:), allocatable :: ifile
      character(:), allocatable :: tfile
      character(:), allocatable :: txfile
      character(:), allocatable :: tsfile
c
c-----------------------------------------------------------------------
c
      integer, parameter :: nllnpa = 7200
c
c-----------------------------------------------------------------------
c
c     Array allocation size variables used in EQ6.
c
c       General size variables:
c
c         ntid_asv  = the number of lines in the data file title
c         ntit_asv  = the number of lines in any title appearing
c                       on an input or pickup file
c
c
c       Size variables associated with the description of thermodynamic
c       data:
c
c         ipch_asv  = the order for pressure corrections to enthalpy
c                       functions
c         ipcv_asv  = the order for pressure corrections to volume
c                       functions; the maximum order for pressure
c                       corrections to log K and other Gibbs-energy-
c                       based functions is one greater than this
c         ipbt_asv  = the maximum number of Pitzer alpha parameters
c                       for any species pair
c         jpfc_asv  = the number of coefficients in the Pitzer parameter
c                       temperature function
c         narx_asv  = maximum number of coefficients per temperature
c                       range
c         ntpr_asv  = number of temperature ranges
c
c
c       Size variables required to read other data from the
c       supporting data file:
c
c       Size variables required to read other data from the
c       supporting data file:
c
c         ikta_asv  = the maximum number of end-member components
c                       of any solid solution on the data file
c         nata_asv  = the number of aqueous species on the data file
c         nbta_asv  = the number of basis species on the data file
c         ncta_asv  = the number of chemical elements on the data file
c         ngta_asv  = the number of gas species on the data file
c         nlta_asv  = the number of pure liquids on the data file
c         nmta_asv  = the number of pure minerals on the data file
c
c         napa_asv  = number of distinct sets of Pitzer alpha
c                       parameters on the data file
c         nmuta_asv = the number of triplets of ions on the data file
c                       for which distinct Pitzer mu coefficients
c                       are defined
c         nslta_asv = the number of pairs of ions on the data file
c                       for which distinct Pitzer lambda coefficients
c                       are defined
c
c
c       Size variables required to hold the compressed set of such
c       data:
c
c         ikt_asv   = the maximum number of end-member components
c                       of any solid solution in the compressed set
c         nat_asv   = the number of aqueous species in the compressed
c                       set
c         nbt_asv   = the number of basis species in the compressed set
c         nct_asv   = the number of chemical elements in the compressed
c                       set
c         ngt_asv   = the number of gas species in the compressed set
c         nlt_asv   = the number of pure liquids in the compressed set
c         nmt_asv   = the number of pure minerals in the compressed set
c
c         nap_asv   = the number of distinct sets of Pitzer alpha
c                       parameters in the compressed set
c         nmut_asv  = the number of triplets of ions in the compressed
c                       set for which distinct Pitzer mu coefficients
c                       are defined
c         nslt_asv  = the number of pairs of ions in the compressed set
c                       for which distinct Pitzer lambda coefficients
c                       are defined
c
c
      integer ntid_asv
c
      integer ipch_asv,ipcv_asv,ipbt_asv,jpfc_asv,narx_asv,ntpr_asv
c
      integer nazm_asv,nazp_asv
c
      integer ikta_asv,napa_asv,nata_asv,nbta_asv,ncta_asv,ndrsa_asv,
     $ nessa_asv,ngta_asv,nlta_asv,nmta_asv,nmuta_asv,nslta_asv,
     $ npta_asv,nsta_asv,nxta_asv
c
      integer iapxa_asv,ibpxa_asv
c
      integer nbta1_asv
c
      integer ntf1a_asv,ntf2a_asv
c
      integer ikt_asv,nap_asv,nat_asv,nbt_asv,nct_asv,ndrs_asv,
     $ ness_asv,ngt_asv,nlt_asv,nmt_asv,nmut_asv,nslt_asv,npt_asv,
     $ nst_asv,nxt_asv
c
      integer iapx_asv,ibpx_asv
c
      integer ntit_asv,nxmd_asv
c
      integer nbt1_asv,nmx_asv,nsts_asv,nsx_asv
c
      integer ntf1_asv,ntf2_asv
c
      integer k_asv,npet_asv,nset_asv
c
      integer imch_asv,ndct_asv,nert_asv,nffg_asv,nprp_asv,nprs_asv,
     $ nptk_asv,nrct_asv,nsrt_asv,nttk_asv,nxop_asv,nxpe_asv,nxrt_asv
c
c-----------------------------------------------------------------------
c
      integer nad1,nbkupa,nbkupb,newin,ninpt,ninpts,noutpt,ntab,ntabs,
     $ ntabx,nttyo
c
      integer iodb(nodb_par),iopg(nopg_par),iopr(nopr_par),
     $ iopt(nopt_par)
c
      integer igerti(jet_par,nert_par),jgerti(nert_par)
c
      integer, dimension(:), allocatable :: iapxt,ibpxt,ibsrti,iesrti,
     $ iffg,iindx1,insgf,ipndx1,ixrti,jcode,jffg,jflag,jflagd,jflgi,
     $ jpflag,jreac,jsflag,jsitex,jsol,kxmod
c
      integer, dimension(:), allocatable :: narxt,nbasp,nbaspd,nbaspi,
     $ nbaspx,nbmap,ncmap,ndecsp,ndrs,ndrsd,ndrsx,ness,npchk,nphasx,
     $ nrndex,nsk,nsmap,nsts,ntf1,ntf2,nxridx
c
      integer, dimension(:,:), allocatable :: imech,ncmpr,ndrsr,ndrsrd,
     $ ndrsrx,nessr,nrk,nstsr
c
      integer, dimension(:,:,:), allocatable :: iact,ndact
c
      integer, dimension(:,:,:,:), allocatable :: ndac
c
      integer iern1,iern2,ifrn1,ifrn2,ilrn1,ilrn2,imrn1,imrn2,
     $ ixrn1,ixrn2
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer nat,nbt,nct,net,ngt,nlt,nmt,npt,nst,nxt
c
      integer narn1,narn2,nern1,nern2,nfrn1,nfrn2,ngrn1,ngrn2,
     $ nlrn1,nlrn2,nmrn1,nmrn2,nxrn1,nxrn2
c
      integer kprs,nbti,nprpti,nprsti
c
      integer i,ie,ier,iaqsla,iaqsln,ielam,iexec0,igas,ilevel,ipch,ipcv,
     $ irang,itermx,ixrn1a,ixrn2a,izmax,j,je,jexec0,jlen,jpdblo,jpress,
     $ jptffl,jtemp,j2,j3,k,kbt,kcol,kct,kdim,kelect,khydr,khydx,klim,
     $ km1,kmt,kobswt,ko2gaq,krdxsp,ksplmx,ksppmx,kstpmx,kwater,kx1,kxt
c
      integer n,napta,narn1a,narn2a,nart,nata,nb,nbta,nbtafd,nbtd,nbw,
     $ nbwa,nb1,nb2,nchloa,nchlor,ncta,ne,neleca,nelect,ner,nerr,nert,
     $ nffg,ngrn1a,ngrn2a,ngrt,ngta,nhydr,nhydra,nhydx,nhydxa,nllnmx,
     $ nlrn1a,nlrn2a,nlta,nmax,nmrn1a,nmrn2a,nmrt,nmta,nmuta,nobswt,
     $ no2gaa,no2gaq,np,npi,npslmx,npta,nprob,nrc,nrct,nrdxsa,nrdxsp,
     $ nrecl,nrr1,nrr2,nr1,nr2,nsbsw,nsbswt,ns,nse,nsi,nslta,nsrt,nss,
     $ nsslmx,nsta,ns1,ns2,nt,ntf1t,ntf1ta,ntf2t,ntf2ta,ntitld,ntitl1,
     $ ntitl2,ntpr,ntprh,ntprt,ntrymx,nxmod,nxopex,nxopt,nxrn1a,nxrn2a,
     $ nxrt,nxta
c
      integer ilnobl,nbasis
c
      logical qbassw,qbswok,qchlor,qcnpre,qcntmp,qcwrpj,qdwipp,qecon,
     $ qelim,qend,qex,qgexsh,qhawep,qloffg,qop,qoptmz,qpit75,qrderr,
     $ qredox,qscon,qtatxt
c
      character*24 ugersi(iet_par,jet_par,nert_par),ugermo(nert_par)
      character*8 ugerji(jet_par,nert_par)
c
      character(len=80), dimension(:), allocatable :: utitl1,utitl2
      character(len=48), dimension(:), allocatable :: ubasp,ubmtbi,
     $ uprspi,uspec,uxmod,uzveci,uzvec1
      character(len=24), dimension(:), allocatable :: uffg,uphase,
     $ uprphi,uptype,ureac,uxcat,uxopex
      character(len=8), dimension(:), allocatable :: uelem,uxopt
c
      character(len=48), dimension(:,:), allocatable :: uobsw,usbsw
      character(len=24), dimension(:,:), allocatable :: ubsri,ucxri
      character(len=8), dimension(:,:), allocatable :: uesri
c
      character(len=24), dimension(:,:,:,:), allocatable :: udac
c
      character(len=nllnpa) ulinex
      character(len=80) ux80
      character(len=56) uspn56
      character(len=32) uactop
      character(len=24) unamsp,unamph,ux
      character(len=24) uaqsln,ublk24
      character(len=11) utime0,utime1
      character(len=9) udate0,udate1
      character(len=8) udatfi,ufixf,udakey,uinfor,uplatc,uplatm,
     $ ustelg,ustelu,usteql,usteq6,uveelg,uveelu,uveeql,uveeq6,ux8
c
      real*8 sscrew(nssc_par)
      real*8 cco2(5)
c
      real*8 egers(iet_par,jet_par,nert_par),
     $ egersi(iet_par,jet_par,nert_par),
     $ mrgers(iet_par,jet_par,nert_par),
     $ xgers(iet_par,jet_par,nert_par),
     $ xgersi(iet_par,jet_par,nert_par)
c
      real*8 cegexs(iet_par,jet_par,net_par),
     $ cpgexs(iet_par,jet_par,net_par),egexjf(jet_par,net_par),
     $ mrgexs(iet_par,jet_par,net_par)
c
      real(8), dimension(:), allocatable :: atwt,azero,cdrs,
     $ cdrsd,cdrsx,cess,cscale,csts,elecsr,fkrc,loph,losp,
     $ modr,moffg,moph,morr,mosp,mprph,mprphi,mprsp,mprspi,mtb,
     $ mtbaq,mtbaqi,mtbi,mte,mteaq,mwtrc,mwtsp,ptk,sfcar,ssfcar,
     $ tempcu,tf1,tf2,ttk,xlkffg,xlkmod,vosp0,vreac,zchar,zchcu6,
     $ zchsq2,zvclgi,zvclg1,zvec1
c
      real(8), dimension(:,:), allocatable :: cbsr,cesr,rxbar
      real(8), dimension(:,:), allocatable :: cbsri,cesri,rxbari
      real(8), dimension(:,:,:), allocatable :: csigma,eact,hact,
     $ rk,rkb,trkb
      real(8), dimension(:,:,:,:), allocatable :: cdac
c
      real(8), dimension(:), allocatable :: dadhh,dadhv,dbdhh,dbdhv,
     $ dbdth,dbdtv
c
      real(8), dimension(:,:), allocatable :: apx,bpx,wfac
c
      real(8), dimension(:,:), allocatable :: aadh,aadhh,aadhv,aaphi,
     $ abdh,abdhh,abdhv,abdot,abdoth,abdotv
c
      real(8), dimension(:,:,:), allocatable :: adadhh,adadhv,adbdhh,
     $ adbdhv,adbdth,adbdtv
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 afcnst,aftarg,al10,avcnst,awmax,awmaxi,awmin,awmini,
     $ dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,dloprn,dltpll,
     $ dltplo,dltprl,dltprn,dlxmax,dlxdmp,dlxmin,dlxmx0,dlxpll,dlxplo,
     $ dlxprl,dlxprn,ehfac,ehmax,ehmaxi,ehmin,ehmini,electr,eps100,
     $ farad,o2max,o2maxi,o2min,o2mini,phmax,phmaxi,phmin,phmini,
     $ prcinf,press,pressb,pressd,pressi,rconst,rcnstv,rtcnst,
     $ smp100,tcpu,tdamax,tdamin,tempc,tempcb,tempcd,tempci,tempk,
     $ texec0,timemx,timmxi,time1,tistrt,tistti,tolaft,tolbt,toldl,
     $ tolsat,tolsst,tolxsf,tolxst,tolxsu,trun,tuser,ximax,ximaxi,
     $ xistrt,xistti,xi1,x10,zkfac,zklgmn,zklogl,zklogu
c
      real*8 av,azch,azchmx,dp,dt,ex,gx,xx,zx
c
cXX   real*8 vpgstp
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Data file original contents. These
c     variables and arrays remain unchanged after being filled by
c     reading the data file. These data comprise the 'a' set.
c
      integer, dimension(:), allocatable :: iapxta,ibpxta,insgfa,jsola,
     $ nbaspa,ndrsa,nessa
c
      integer, dimension(:,:), allocatable :: ncmpra,ndrsra,nessra
c
      real(8), dimension(:,:,:), allocatable :: axhfsa,axlksa,axvfsa
c
      real(8), dimension(:,:,:,:), allocatable :: adhfsa,advfsa
c
      real(8), dimension(:), allocatable :: atwta,azeroa,cdrsa,cessa,
     $ mwtspa,vosp0a,zchara
c
      real(8), dimension(:,:), allocatable :: apxa,bpxa
c
      character(len=80), dimension(:), allocatable :: utitld
      character(len=48), dimension(:), allocatable :: uspeca
      character(len=24), dimension(:), allocatable :: uphasa,uptypa
      character(len=8), dimension(:), allocatable :: uelema
c
c     Pitzer's equations subset.
c
      integer, dimension(:), allocatable :: nalpaa
      integer, dimension(:,:), allocatable :: nmuxa,nslxa
c
      real(8) , dimension(:,:), allocatable :: amua,palpaa
      real(8) , dimension(:,:,:), allocatable :: aslma
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Variables closely associated with the
c     'a' set.
c
      logical, dimension(:), allocatable :: qclnsa
c
c-----------------------------------------------------------------------
c
c     Variable declarations: Pseudo-data file original contents.
c
      integer, dimension(:), allocatable :: ntf1a,ntf2a
c
      real(8), dimension(:), allocatable :: tf1a,tf2a
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       On some systems, a BLOCK DATA subroutine must be declared in an
c       EXTERNAL statement to assure proper loading. On some other
c       systems, this is not necessary, but neither it is not harmful.
c       On yet some other systems, the EXTERNAL statement below may
c       cause a problem. If so, try commenting it out. If you still
c       have trouble, consult your local system documentation or
c       experiment to find out how to correctly handle a BLOCK DATA
c       subroutine on your system. The EXTERNAL statement below should
c       not cause a problem if you are using a compiler which is fully
c       compliant with the Fortran 90 standard. However, there is
c       no guarantee that it will be adequate to assure correct loading
c       of the BLOCK DATA subroutine.
c
        external bkdeq6
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     Special data base of coefficients for the HCO3-CO3-OH total
c     alkalinity.
c
      include 'eqlib/eqltf1.h'
c
c     Special data base of coefficients for the extended total
c     alkalinity.
c
      include 'eqlib/eqltf2.h'
c
c-----------------------------------------------------------------------
c
c     Other data statements.
c
      data uaqsln /'Aqueous solution        '/
      data ublk24 /'                        '/
      data ufixf  /'fix_f   '/
c
c     Set practical infinity.
c
      data prcinf/1.e+38/
c
c-----------------------------------------------------------------------
c
c     BEGIN_MACHINE_DEPENDENT_CODE
c
c       Define the console output device number. A value of 6 applies
c       in most cases.
c
        data nttyo  /6/
c
c     END_MACHINE_DEPENDENT_CODE
c
c-----------------------------------------------------------------------
c
c     Get time and date at the start of execution. This information
c     will be used for time and date stamping.
c
      call initim(iexec0,jexec0,texec0,noutpt,nttyo,
     $ udate0,utime0)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Disable underflow trapping, if any.
c
      call undflw
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set file unit numbers to zero.
c
      noutpt = 0
      nad1 = 0
      nbkupa = 0
      nbkupb = 0
      ninpt = 0
      ninpts = 0
      newin = 0
      ntab = 0
      ntabs = 0
      ntabx = 0
      nrecl = 0
c
c     Open all files execpt pickup, tab, tabs, and tabx.
c
      numargs = COMMAND_ARGUMENT_COUNT()
      if (numargs.eq.2) then
          call GET_COMMAND_ARGUMENT(1,temppath)
          data1path = TRIM(temppath)
          temppath(:)=''
          call GET_COMMAND_ARGUMENT(2,temppath)
          sixipath = TRIM(temppath)
      else
          write (0, *) 'usage: eq6 <data1> <6i>'
          stop
      end if

      call getbasename(sixipath, pathindices)
      basename = sixipath(pathindices(1):pathindices(2))

      ofile = basename // '.6o'
      pfile = basename // '.6p'
      bafile = basename // '.6ba'
      bbfile = basename // '.6bb'
      ifile = basename // '.6ib'
      tfile = basename // '.6t'
      txfile = basename // '.6tx'
      tsfile = basename // '.6ts'

      call openin(noutpt,nttyo,data1path,'unformatted',nad1)
      call openin(noutpt,nttyo,sixipath,'formatted',ninpt)

      call openou(noutpt,nttyo,ofile,'formatted',nrecl,noutpt)
      call openou(noutpt,nttyo,ifile,'formatted',nrecl,ninpts)
c
c     Make a copy of the input file, stripped of comments.
c
      call stripl(ninpt,ninpts)
      close (ninpt)
      ninpt = 0
      rewind ninpts
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get configuration identification data.
c
      call aaaeq6(usteq6,uveeq6)
      call aaaeql(usteql,uveeql)
      call aaaelg(ustelg,uveelg)
      call aaaelu(ustelu,uveelu)
      call platfd(uplatc,uplatm)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write configuration identification data, the copyright statement,
c     and any remaining statements or disclaimers.
c
      i = index(uveeq6,' ') - 1
      j = index(uveeq6,'.') - 1
      k = index(uplatc,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1000) uveeq6(1:i),uveeq6(1:j),uveeq6(1:i),
     $ uplatc(1:k)
      write (noutpt,1000) uveeq6(1:i),uveeq6(1:j),uveeq6(1:i),
     $ uplatc(1:k)
 1000 format(/' EQ3/6, Version ',a,' (EQ3/6-V',a,'-REL-V',a,'-',a,')')
c
      i = j
      j = index(usteq6,' ') - 1
      k = index(uplatm,' ') - 1
      if (j .le. 0) j = 8
      if (k .le. 0) k = 8
      write (nttyo,1010) uveeq6(1:i),usteq6(1:j),uplatm(1:k)
      write (noutpt,1010) uveeq6(1:i),usteq6(1:j),uplatm(1:k)
 1010 format(' EQ6 Reaction-Path Code (EQ/36-V',a,'-EQ6-EXE-',
     $ a,'-',a,')')
c
      write (noutpt,1020)
      write (nttyo,1020)
 1020 format(' Supported by the following EQ3/6 libraries:')
c
      i = index(uveeql,'.') - 1
      j = index(usteql,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1030) uveeql(1:i),usteql(1:j),uplatm(1:k)
      write (noutpt,1030) uveeql(1:i),usteql(1:j),uplatm(1:k)
 1030 format('   EQLIB (EQ3/6-V',a,'-EQLIB-LIB-',a,'-',a,')')
c
      i = index(uveelg,'.') - 1
      j = index(ustelg,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1040) uveelg(1:i),ustelg(1:j),uplatm(1:k)
      write (noutpt,1040) uveelg(1:i),ustelg(1:j),uplatm(1:k)
 1040 format('   EQLIBG (EQ3/6-V',a,'-EQLIBG-LIB-',a,'-',a,')')
c
      i = index(uveelu,'.') - 1
      j = index(ustelu,' ') - 1
      if (i .le. 0) i = 8
      if (j .le. 0) j = 8
      write (nttyo,1050) uveelu(1:i),ustelu(1:j),uplatm(1:k)
      write (noutpt,1050) uveelu(1:i),ustelu(1:j),uplatm(1:k)
 1050 format('   EQLIBU (EQ3/6-V',a,'-EQLIBU-LIB-',a,'-',a,')',/)
c
      write (nttyo,1060)
      write (noutpt,1060)
 1060 format(' Copyright (c) 1987, 1990-1993, 1995, 1997, 2002 The',
     $ ' Regents of the',/' University of California, Lawrence',
     $ ' Livermore National Laboratory.',/' All rights reserved.',/)
c
c     Write additional statements and disclaimers.
c
      call prcndi(noutpt,nttyo)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write the time and date on the output.
c
      j2 = ilnobl(udate0)
      write(noutpt,1080) utime0,udate0(1:j2)
      write(nttyo,1080) utime0,udate0(1:j2)
 1080 format(' Run',2(2x,a8,2x,a),//)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the platform's real*8 floating-point parameters.
c
      call flpars(eps100,irang,noutpt,nttyo,smp100)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize array dimension variables.
c
c     The following are common with EQ3NR.
c
      ietmax = iet_par
      jetmax = jet_par
      ketmax = ket_par
      netmax = net_par
c
      jsomax = jso_par
      nodbmx = nodb_par
      nopgmx = nopg_par
      noprmx = nopr_par
      noptmx = nopt_par
      nvetmx = nvet_par
c
      nxmd_asv = nxmd_par
      nxmdmx = nxmd_asv
c
      ntit_asv = ntit_par
      ntitmx = ntit_asv
c
      iapxa_asv = iapxa_par
      ibpxa_asv = ibpxa_par
c
c     The following are common with EQ3NR, but are only needed by that
c     code to write a full EQ6 input file as its pickup file.
c
      nrct_asv = nrct_par
      nert_asv = nert_par
      nsrt_asv = nsrt_par
      nxrt_asv = nxrt_par
      imch_asv = imch_par
      ndct_asv = ndct_par
      nffg_asv = nffg_par
      nprp_asv = nprp_par
      nprs_asv = nprs_par
      nptk_asv = nptk_par
      nttk_asv = nttk_par
      nxop_asv = nxop_par
      nxpe_asv = nxpe_par
c
      nrctmx = nrct_asv
      nertmx = nert_asv
      nsrtmx = nsrt_asv
      nxrtmx = nxrt_asv
      imchmx = imch_asv
      ndctmx = ndct_asv
      nffgmx = nffg_asv
      nprpmx = nprp_asv
      nprsmx = nprs_asv
      nptkmx = nptk_asv
      nttkmx = nttk_asv
      nxopmx = nxop_asv
      nxpemx = nxpe_asv
c
c     The following are unique to EQ6.
c
      nsscmx = nssc_par
      nllnmx = nllnpa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the following floating-point constants:
c
c       rconst = the gas constant: 1.98726 cal/mole-K
c       rcnstv = the gas constant: 83.14510 bar-cm3/mol-K
c       vpgstp  = the volume of a perfect gas at STP: 22413.6 cm3
c       farad  = the Faraday constant: 23062.3 cal/equiv-volt
c       al10   = ln 10; =~ 2.3026
c
      rconst = 1.98726
      rcnstv = 83.14510
cXX   vpgstp = 22413.6
      farad = 23062.3
      x10 = 10.
      al10 = log(x10)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the header section of the DATA1 file. This section consists
c     of a record containing the string 'data1' (to ensure that the file
c     is indeed a DATA1 file), a record containing the keystring for the
c     activity coefficient model for aqueous species to which this data
c     file corresponds, and the array allocation size variables required
c     to allocate sufficient array space to store the rest of the data
c     on this data file.
c
      call indath(ikta_asv,ipbt_asv,ipch_asv,ipcv_asv,
     $ jpfc_asv,nad1,napa_asv,narx_asv,nata_asv,nbta_asv,
     $ ncta_asv,ngta_asv,nlta_asv,nmta_asv,npta_asv,nmuta_asv,
     $ noutpt,nslta_asv,nsta_asv,ntid_asv,ntpr_asv,nttyo,
     $ nxta_asv,udakey)
c
c     The value of nbta_asv at this point matches the number of
c     formally declared basis species on the data file. That is
c     the number of species in the "strict" and "auxiliary" basis
c     set sections of the aqueous species superblock. Save this
c     as nbtafd. Other species can be added to the basis set in
c     this version of EQ3/6. Thus, nbta_asv at this point is not
c     the "final answer."
c
      nbtafd = nbta_asv
c
c     Increase the values of some allocation size variables to allow
c     for some species, phases, etc., to created by this software.
c     Examples: generic ion exchanger phases and species.
c
      nbta_asv = nbta_asv + jet_par*net_par + 10
      npta_asv = npta_asv + net_par + 10
      nsta_asv = nsta_asv + iet_par*jet_par*net_par + 10
c
c     Set the values of some secondary allocation size variables.
c
      nbta1_asv = nbta_asv + 1
      ndrsa_asv = 7*nsta_asv
      nessa_asv = 5*nsta_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data read from the rest of the DATA1
c     file.
c
      ALLOCATE(iapxta(nxta_asv))
      ALLOCATE(ibpxta(nxta_asv))
      ALLOCATE(insgfa(nata_asv))
      ALLOCATE(jsola(nxta_asv))
      ALLOCATE(narxt(ntpr_asv))
      ALLOCATE(nbaspa(nbta_asv))
      ALLOCATE(ndrsa(ndrsa_asv))
      ALLOCATE(nessa(nessa_asv))
c
      ALLOCATE(ncmpra(2,npta_asv))
      ALLOCATE(ndrsra(2,nsta_asv))
      ALLOCATE(nessra(2,nsta_asv))
c
      ALLOCATE(qclnsa(nsta_asv))
c
      ALLOCATE(utitld(ntid_asv))
      ALLOCATE(uspeca(nsta_asv))
      ALLOCATE(uphasa(npta_asv))
      ALLOCATE(uptypa(npta_asv))
      ALLOCATE(uelema(ncta_asv))
      ALLOCATE(ubasp(nbta_asv))
c
      ALLOCATE(tempcu(ntpr_asv))
c
      ALLOCATE(aprehw(narx_asv,ntpr_asv))
      ALLOCATE(apresg(narx_asv,ntpr_asv))
c
      ALLOCATE(aadh(narx_asv,ntpr_asv))
      ALLOCATE(aadhh(narx_asv,ntpr_asv))
      ALLOCATE(aadhv(narx_asv,ntpr_asv))
      ALLOCATE(aaphi(narx_asv,ntpr_asv))
      ALLOCATE(abdh(narx_asv,ntpr_asv))
      ALLOCATE(abdhh(narx_asv,ntpr_asv))
      ALLOCATE(abdhv(narx_asv,ntpr_asv))
      ALLOCATE(abdot(narx_asv,ntpr_asv))
      ALLOCATE(abdoth(narx_asv,ntpr_asv))
      ALLOCATE(abdotv(narx_asv,ntpr_asv))
c
      ALLOCATE(axhfe(narx_asv,ntpr_asv))
      ALLOCATE(axlke(narx_asv,ntpr_asv))
      ALLOCATE(axvfe(narx_asv,ntpr_asv))
c
      ALLOCATE(adadhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adadhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adbdhh(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adbdhv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adbdth(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(adbdtv(narx_asv,ntpr_asv,ipcv_asv))
      ALLOCATE(adhfe(narx_asv,ntpr_asv,ipch_asv))
      ALLOCATE(advfe(narx_asv,ntpr_asv,ipcv_asv))
c
      ALLOCATE(axhfsa(narx_asv,ntpr_asv,nsta_asv))
      ALLOCATE(axlksa(narx_asv,ntpr_asv,nsta_asv))
      ALLOCATE(axvfsa(narx_asv,ntpr_asv,nsta_asv))
c
      ALLOCATE(adhfsa(narx_asv,ntpr_asv,ipch_asv,nsta_asv))
      ALLOCATE(advfsa(narx_asv,ntpr_asv,ipcv_asv,nsta_asv))
c
      ALLOCATE(atwta(ncta_asv))
      ALLOCATE(cdrsa(ndrsa_asv))
      ALLOCATE(cessa(nessa_asv))
      ALLOCATE(mwtspa(nsta_asv))
      ALLOCATE(vosp0a(nsta_asv))
      ALLOCATE(zchara(nsta_asv))
c
      ALLOCATE(apxa(iapxa_asv,nxta_asv))
      ALLOCATE(bpxa(ibpxa_asv,nxta_asv))
c
c     SEDH data.
c
      ALLOCATE(azeroa(nata_asv))
c
c     Pitzer data.
c
      ALLOCATE(nalpaa(nslta_asv))
      ALLOCATE(nmuxa(3,nmuta_asv))
      ALLOCATE(nslxa(2,nslta_asv))
c
      ALLOCATE(amua(jpfc_asv,nmuta_asv))
c
      ALLOCATE(aslma(jpfc_asv,0:ipbt_asv,nslta_asv))
      ALLOCATE(palpaa(ipbt_asv,napa_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Read the remainder of the DATA1 file. The image of the data file
c     is stored in arrays and variables that typically end in 'a.'
c     A subset of this is the reaction data. The variable nbta and
c     the arrays nbaspa, cdrsa, ndrsa, ndrsra, and axlksa comprise
c     what is called the 'a' set of reaction data. These are not
c     modified by any code manipulations.
c
      call indata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,
     $ adbdtv,adhfe,adhfsa,advfe,advfsa,amua,aprehw,apresg,
     $ apxa,aslma,atwta,axhfe,axhfsa,axlke,axlksa,axvfe,axvfsa,
     $ azeroa,bpxa,cco2,cdrsa,cessa,eps100,iapxa_asv,iapxta,
     $ iaqsla,ibpxa_asv,ibpxta,ielam,igas,ikta_asv,insgfa,ipbt_asv,
     $ ipch,ipch_asv,ipcv,ipcv_asv,ixrn1a,ixrn2a,jpdblo,jpfc_asv,
     $ jptffl,jsola,mwtspa,nad1,nalpaa,napa_asv,napta,narn1a,narn2a,
     $ narx_asv,narxt,nata,nata_asv,nbaspa,nbta,nbta_asv,nbtafd,
     $ nbta1_asv,ncmpra,ncta,ncta_asv,ndrsa,ndrsa_asv,ndrsra,nessa,
     $ nessa_asv,nessra,ngrn1a,ngrn2a,ngta,ngta_asv,nlrn1a,nlrn2a,
     $ nlta,nlta_asv,nmrn1a,nmrn2a,nmta,nmta_asv,nmuta,nmuta_asv,
     $ nmuxa,noutpt,npta,npta_asv,nslta,nslta_asv,nslxa,nsta,
     $ nsta_asv,ntid_asv,ntitld,ntpr_asv,ntprt,nttyo,nxrn1a,nxrn2a,
     $ nxta,nxta_asv,qclnsa,palpaa,tdamax,tdamin,tempcu,ubasp,
     $ udakey,udatfi,uelema,uspeca,uphasa,uptypa,utitld,vosp0a,
     $ zchara)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data extracted from the pseudo-data
c     files.
c
      ntf1a_asv = ntf1a_par
      ALLOCATE(ntf1a(ntf1a_asv))
      ALLOCATE(tf1a(ntf1a_asv))
c
      ntf2a_asv = ntf2a_par
      ALLOCATE(ntf2a(ntf2a_asv))
      ALLOCATE(tf2a(ntf2a_asv))
c
      ntf1mx = ntf1a_asv
      ntf2mx = ntf2a_asv
      ntfxmx = ntf1mx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the coefficients for calculating the HCO3-CO3-OH total
c     alkalinity. These are actually set in a pseudo-data file in the
c     EQLIB INCLUDE file eqltf1.h. The subroutine called here assigns
c     the coefficients to the species read from the data file.
c
c     Calling sequence substitutions:
c       ntf1a for ntfxa
c       ntf1mx for ntfxmx
c       ntf1ta for ntfxta
c       tf1a for tfxa
c       utf1xd for utfxxd
c
      call inttfx(narn1a,narn2a,noutpt,nsta_asv,ntf1a,ntf1mx,
     $ ntf1ta,nttyo,tf1a,uspeca,utf1xd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the coefficients for calculating the extended total
c     alkalinity. These are actually set in a pseudo-data file in the
c     EQLIB INCLUDE file eqltf2.h. The subroutine called here assigns
c     the coefficients to the species read from the data file.
c
c     Calling sequence substitutions:
c       ntf2a for ntfxa
c       ntf2mx for ntfxmx
c       ntf2ta for ntfxta
c       tf2a for tfxa
c       utf2xd for utfxxd
c
      call inttfx(narn1a,narn2a,noutpt,nsta_asv,ntf2a,ntf2mx,
     $ ntf2ta,nttyo,tf2a,uspeca,utf2xd)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of H+, OH-, Cl-, fictive aqueous O2(g), and
c     fictive aqueous e-. This will be repeated after data compression.
c
c     Calling sequence substitutions:
c       narn1a for narn1
c       narn2a for narn2
c       nchloa for nchlor
c       neleca for nelect
c       nhydra for nhydr
c       nhydxa for nhydx
c       no2gaa for no2gaq
c       nsta_asv for nstmax
c       uspeca for uspec
c
      call gspion(narn1a,narn2a,nchloa,neleca,nhydra,nhydxa,noutpt,
     $ no2gaa,nsta_asv,nttyo,uspeca)
c
c     Calling sequence substitutions:
c       nbaspa for nbasp
c       nbta_asv for nbtmax
c       nbta for nbt
c       ncta for nct
c       ndrsra for ndrsr
c       nrdxsa for nrdxsp
c       nsta_asv for nstmax
c       uspeca for uspec
c
      call grdxsp(nbaspa,nbta,nbta_asv,ncta,ndrsra,noutpt,
     $ nrdxsa,nsta_asv,nttyo,uspeca)
c
c     Get the basis index of water.
c
c     Calling sequence substitutions:
c       nbaspa for nbasp
c       nbta for nbt
c       nbta_asv for nbtmax
c       narn1a for ns
c
      nbwa = nbasis(nbaspa,nbta,nbta_asv,narn1a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up the remaining array allocation variables required to
c     allocate variables needed to store the dta to be read from the
c     input file.
c
c     The following value of k_asv is special to EQ6.
c     A smaller value is adequate for EQ3NR.
c
      k_asv = 2*nbta_asv + 5
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to store the data to be read from the input
c     file.
c
      ALLOCATE(jflgi(nbta_asv))
      ALLOCATE(nbaspi(nbta_asv))
c
      ALLOCATE(mtbaqi(nbta_asv))
      ALLOCATE(mtbi(nbta_asv))
      ALLOCATE(zvclgi(k_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Setup up the remaining required array allocation variables.
c     At the present time, just set the regular variables which
c     correspond to specific variables required for the 'a' set
c     of data (e.g., nbt_asv to nbta_asv) to the values of the
c     corresponding 'a' set variables.
c
c     Primary allocation variables.
c
      nat_asv = nata_asv
      nbt_asv = nbta_asv
      nct_asv = ncta_asv
      ngt_asv = ngta_asv
      nlt_asv = nlta_asv
      nmt_asv = nmta_asv
      npt_asv = npta_asv
      nst_asv = nsta_asv
      nxt_asv = nxta_asv
c
      nap_asv = napa_asv
      nslt_asv = nslta_asv
      nmut_asv = nmuta_asv
c
      ikt_asv = ikta_asv
      iapx_asv = iapxa_asv
      ibpx_asv = ibpxa_asv
c
      ntf1_asv = ntf1a_asv
      ntf2_asv = ntf2a_asv
c
c     Secondary allocation variables.
c
      nbt1_asv = nbt_asv + 1
      ndrs_asv = 7*nst_asv
      ness_asv = 5*nst_asv
      nmx_asv = 3*nmut_asv
      nsx_asv = 2*nslt_asv
c
      npet_asv = nbt_asv + 5
      nset_asv = 20*npet_asv
c
c     Note: nazp_asv and nazm_asv could be better calculated after
c     compression of the set of aqueous species.
c
      azchmx = 0.
      do ns = narn1a,narn2a
        azch = abs(zchara(ns))
        azchmx = max(azch,azchmx)
      enddo
      nazp_asv = nint(azchmx)
      nazm_asv = -nazp_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize array dimension variables corresponding to allocation
c     size variables associated with run-time dimensioning.
c
      iapxmx = iapx_asv
      ibpxmx = ibpx_asv
      iktmax = ikt_asv
      ipchmx = ipch_asv
      ipcvmx = ipcv_asv
      ipbtmx = ipbt_asv
      jpfcmx = jpfc_asv
c
      kmax = k_asv
c
      napmax = nap_asv
      narxmx = narx_asv
      natmax = nat_asv
      nazpmx = nazp_asv
      nazmmx = nazm_asv
      nbtmax = nbt_asv
      nbt1mx = nbt1_asv
      nctmax = nct_asv
      ndrsmx = ndrs_asv
      nessmx = ness_asv
      ngtmax = ngt_asv
      nltmax = nlt_asv
      nmtmax = nmt_asv
      nmutmx = nmut_asv
      npetmx = npet_asv
      nptmax = npt_asv
      nsetmx = nset_asv
      nsltmx = nslt_asv
      nstmax = nst_asv
      ntidmx = ntid_asv
      ntprmx = ntpr_asv
      nxtmax = nxt_asv
c
      nmxmax = nmx_asv
      nsxmax = nsx_asv
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate the rest of the necessary arrays.
c
      ALLOCATE(iindx1(k_asv))
      ALLOCATE(ipndx1(k_asv))
c
      ALLOCATE(insgf(nat_asv))
c
      ALLOCATE(nbasp(nbt_asv))
      ALLOCATE(nbaspd(nbt_asv))
      ALLOCATE(nbaspx(nbt_asv))
      ALLOCATE(nbmap(nbt_asv))
      ALLOCATE(ndecsp(nbt_asv))
c
      ALLOCATE(ncmap(nct_asv))
c
      ALLOCATE(ndrs(ndrs_asv))
      ALLOCATE(ndrsd(ndrs_asv))
      ALLOCATE(ndrsx(ndrs_asv))
c
      ALLOCATE(ness(ness_asv))
c
      ALLOCATE(jpflag(npt_asv))
      ALLOCATE(ncmpr(2,npt_asv))
c
      ALLOCATE(jflag(nst_asv))
      ALLOCATE(jflagd(nst_asv))
      ALLOCATE(jsflag(nst_asv))
      ALLOCATE(jsitex(nst_asv))
      ALLOCATE(nphasx(nst_asv))
      ALLOCATE(nsmap(nst_asv))
c
      ALLOCATE(ntf1(ntf1_asv))
      ALLOCATE(ntf2(ntf2_asv))
c
      ALLOCATE(kxmod(nxmd_asv))
c
      ALLOCATE(iapxt(nxt_asv))
      ALLOCATE(ibpxt(nxt_asv))
      ALLOCATE(jsol(nxt_asv))
c
      ALLOCATE(ndrsr(2,nst_asv))
      ALLOCATE(ndrsrd(2,nst_asv))
      ALLOCATE(ndrsrx(2,nst_asv))
      ALLOCATE(nessr(2,nst_asv))
c
      ALLOCATE(utitl1(ntit_asv))
      ALLOCATE(utitl2(ntit_asv))
c
      ALLOCATE(ubmtbi(nbt_asv))
c
      ALLOCATE(uobsw(2,nbt_asv))
      ALLOCATE(usbsw(2,nbt_asv))
c
      ALLOCATE(uspec(nst_asv))
      ALLOCATE(uxmod(nxmd_asv))
      ALLOCATE(uzveci(k_asv))
      ALLOCATE(uzvec1(k_asv))
c
      ALLOCATE(uphase(npt_asv))
      ALLOCATE(uptype(npt_asv))
c
      ALLOCATE(uelem(nct_asv))
c
      ALLOCATE(apx(iapx_asv,nxt_asv))
      ALLOCATE(bpx(ibpx_asv,nxt_asv))
      ALLOCATE(wfac(ikt_asv,nxt_asv))
c
      ALLOCATE(loph(npt_asv))
      ALLOCATE(moph(npt_asv))
c
      ALLOCATE(azero(nat_asv))
      ALLOCATE(atwt(nct_asv))
c
      ALLOCATE(zvclg1(k_asv))
      ALLOCATE(zvec1(k_asv))
c
      ALLOCATE(mtb(nbt_asv))
      ALLOCATE(mtbaq(nbt_asv))
c
      ALLOCATE(mte(nct_asv))
      ALLOCATE(mteaq(nct_asv))
c
      ALLOCATE(cdrs(ndrs_asv))
      ALLOCATE(cdrsd(ndrs_asv))
      ALLOCATE(cdrsx(ndrs_asv))
      ALLOCATE(losp(nst_asv))
      ALLOCATE(mosp(nst_asv))
      ALLOCATE(mwtsp(nst_asv))
      ALLOCATE(vosp0(nst_asv))
      ALLOCATE(zchar(nst_asv))
      ALLOCATE(zchcu6(nst_asv))
      ALLOCATE(zchsq2(nst_asv))
c
      ALLOCATE(cess(ness_asv))
      ALLOCATE(tf1(ntf1_asv))
      ALLOCATE(tf2(ntf2_asv))
      ALLOCATE(xlkmod(nxmd_asv))
c
      ALLOCATE(dadhh(ipch_asv))
      ALLOCATE(dadhv(ipcv_asv))
      ALLOCATE(dbdhh(ipch_asv))
      ALLOCATE(dbdhv(ipcv_asv))
      ALLOCATE(dbdth(ipch_asv))
      ALLOCATE(dbdtv(ipcv_asv))
c
      ALLOCATE(dhfe(ipch_asv))
      ALLOCATE(dvfe(ipcv_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate standard-state data arrays for module mod6xf.
c     The coefficient arrays here correspond to the 'a' set
c     arrays read from the data file. The present coefficient
c     arrays (and the other arrays) correspond to a compressed
c     set of species.
c
      ALLOCATE(xhfs(nst_asv))
      ALLOCATE(xhfsd(nst_asv))
      ALLOCATE(xlks(nst_asv))
      ALLOCATE(xlksd(nst_asv))
      ALLOCATE(xvfs(nst_asv))
      ALLOCATE(xvfsd(nst_asv))
c
      ALLOCATE(dhfs(ipch_asv,nst_asv))
      ALLOCATE(dhfsd(ipch_asv,nst_asv))
      ALLOCATE(dvfs(ipcv_asv,nst_asv))
      ALLOCATE(dvfsd(ipcv_asv,nst_asv))
c
      ALLOCATE(axhfs(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axhfsd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axhfsx(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlks(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlksd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axlksx(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfs(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfsd(narx_asv,ntpr_asv,nst_asv))
      ALLOCATE(axvfsx(narx_asv,ntpr_asv,nst_asv))
c
      ALLOCATE(adhfs(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(adhfsd(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(adhfsx(narx_asv,ntpr_asv,ipch_asv,nst_asv))
      ALLOCATE(advfs(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
      ALLOCATE(advfsd(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
      ALLOCATE(advfsx(narx_asv,ntpr_asv,ipcv_asv,nst_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate Pitzer data arrays for module mod6pt.
c
      ALLOCATE(nalpha(nslt_asv))
c
      ALLOCATE(nmux(3,nmut_asv))
      ALLOCATE(nmxi(2,nat_asv))
      ALLOCATE(nmxx(3,nmx_asv))
      ALLOCATE(nslx(2,nslt_asv))
      ALLOCATE(nsxi(2,nat_asv))
      ALLOCATE(nsxx(2,nsx_asv))
c
      ALLOCATE(amu(jpfc_asv,nmut_asv))
      ALLOCATE(pmu(nmut_asv))
c
      ALLOCATE(aslm(jpfc_asv,0:ipbtmx,nslt_asv))
      ALLOCATE(pslm(nslt_asv))
      ALLOCATE(dpslm(2,nslt_asv))
      ALLOCATE(pslamn(0:ipbt_asv,nslt_asv))
c
      ALLOCATE(gpit(ipbt_asv,nap_asv))
      ALLOCATE(dgpit(2,ipbt_asv,nap_asv))
      ALLOCATE(palpha(ipbt_asv,nap_asv))
c
      ALLOCATE(elam(nazp_asv,nazp_asv))
      ALLOCATE(delam(2,nazp_asv,nazp_asv))
      ALLOCATE(pelm(nazp_asv,nazp_asv))
      ALLOCATE(dpelm(2,nazp_asv,nazp_asv))
      ALLOCATE(selm(nazm_asv:nazp_asv))
      ALLOCATE(dselm(2,nazm_asv:nazp_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate still more arrays.
c
      ALLOCATE(iffg(nffg_asv))
      ALLOCATE(jffg(nffg_asv))
      ALLOCATE(npchk(npt_asv))
c
      ALLOCATE(cscale(nst_asv))
c
      ALLOCATE(jcode(nrct_asv))
      ALLOCATE(jreac(nrct_asv))
      ALLOCATE(nsk(nrct_asv))
      ALLOCATE(nrndex(nrct_asv))
      ALLOCATE(nxridx(nrct_asv))
c
      ALLOCATE(imech(2,nrct_asv))
      ALLOCATE(nrk(2,nrct_asv))
c
      ALLOCATE(iact(imch_asv,2,nrct_asv))
      ALLOCATE(ndact(imch_asv,2,nrct_asv))
c
      ALLOCATE(ibsrti(nsrt_asv))
      ALLOCATE(iesrti(nsrt_asv))
c
      ALLOCATE(ixrti(nxrt_asv))
      ALLOCATE(ndac(ndct_asv,imch_asv,2,nrct_asv))
c
      ALLOCATE(uprspi(nprs_asv))
c
      ALLOCATE(uprphi(nprp_asv))
      ALLOCATE(ubsri(nbt1_asv,nsrt_asv))
      ALLOCATE(ucxri(ikt_asv,nxrt_asv))
      ALLOCATE(udac(ndct_asv,imch_asv,2,nrct_asv))
      ALLOCATE(uffg(nffg_asv))
      ALLOCATE(ureac(nrct_asv))
      ALLOCATE(uxcat(nxop_asv))
      ALLOCATE(uxopt(nxop_asv))
      ALLOCATE(uxopex(nxpe_asv))
      ALLOCATE(uesri(nct_asv,nsrt_asv))
c
      ALLOCATE(cbsr(nbt1_asv,nsrt_asv))
      ALLOCATE(cbsri(nbt1_asv,nsrt_asv))
      ALLOCATE(cdac(ndct_asv,imch_asv,2,nrct_asv))
      ALLOCATE(cesr(nct_asv,nsrt_asv))
      ALLOCATE(cesri(nct_asv,nsrt_asv))
      ALLOCATE(csigma(imch_asv,2,nrct_asv))
      ALLOCATE(eact(imch_asv,2,nrct_asv))
      ALLOCATE(elecsr(nsrt_asv))
      ALLOCATE(hact(imch_asv,2,nrct_asv))
      ALLOCATE(rk(imch_asv,2,nrct_asv))
      ALLOCATE(rkb(imch_asv,2,nrct_asv))
      ALLOCATE(trkb(imch_asv,2,nrct_asv))
      ALLOCATE(fkrc(nrct_asv))
      ALLOCATE(modr(nrct_asv))
      ALLOCATE(morr(nrct_asv))
      ALLOCATE(mwtrc(nrct_asv))
      ALLOCATE(sfcar(nrct_asv))
      ALLOCATE(ssfcar(nrct_asv))
      ALLOCATE(vreac(nrct_asv))
      ALLOCATE(moffg(nffg_asv))
      ALLOCATE(xlkffg(nffg_asv))
      ALLOCATE(mprph(npt_asv))
      ALLOCATE(mprphi(nprp_asv))
      ALLOCATE(mprsp(nst_asv))
      ALLOCATE(mprspi(nprs_asv))
      ALLOCATE(ptk(nptk_asv))
      ALLOCATE(ttk(nttk_asv))
      ALLOCATE(rxbar(ikt_asv,nxrt_asv))
      ALLOCATE(rxbari(ikt_asv,nxrt_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Allocate arrays to handle mass balance coefficients.
c
      nsts_asv = 10*nst_asv
      nstsmx = nsts_asv
c
      ALLOCATE(nsts(nsts_asv))
      ALLOCATE(nstsr(2,nst_asv))
      ALLOCATE(csts(nsts_asv))
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the problem counter.
c
      nprob = 0
c
c     The label below is a return point for processing an additional
c     problem specifed on the input file.
c
   20 nprob = nprob + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set special species indices.
c
      nchlor = nchloa
      nhydr = nhydra
      nhydx = nhydxa
      no2gaq = no2gaa
      nelect = neleca
      nrdxsp = nrdxsa
      nbw = nbwa
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize certain arrays to zeros, blanks, etc.
c
      call initiz(iopt,noptmx)
      call initiz(iopg,nopgmx)
      call initiz(iopr,noprmx)
      call initiz(iodb,nodbmx)
c
      call initcb(uzveci,kmax)
      call initcb(uzvec1,kmax)
      call initaz(zvclg1,kmax)
      call initaz(zvec1,kmax)
c
c     Note: cspi and uspi are not used in EQ6.
c
      call initiz(jflgi,nbtmax)
c
      call initcb(utitl1,ntitmx)
      call initcb(utitl2,ntitmx)
c
      call initcb(ubmtbi,nbtmax)
c
      nmax = 2*nbtmax
      call initcb(usbsw,nmax)
      call initcb(uobsw,nmax)
c
      nmax = nbt_asv
      call initiz(nbasp,nmax)
      call initiz(nbaspd,nmax)
      call initiz(nbaspx,nmax)
c
      nmax = nst_asv
      call initiz(jflag,nmax)
      call initiz(jflagd,nmax)
      call initiz(jsflag,nmax)
      call initcb(uspec,nmax)
      call initaz(vosp0,nmax)
      call initaz(xlks,nmax)
      call initaz(zchar,nmax)
      call initaz(zchsq2,nmax)
      call initaz(zchcu6,nmax)
c
cxxxxxxxxxxxx
      call initaz(cdrs,ndrsmx)
      call initaz(cdrsx,ndrsmx)
      call initiz(ndrs,ndrsmx)
      call initiz(ndrsx,ndrsmx)
c
cxxxxxxxxxxxx
      nmax = 2*nst_asv
      call initiz(ndrsr,nmax)
      call initiz(ndrsrx,nmax)
c
      nmax = narx_asv*ntpr_asv*nst_asv
      call initaz(axlks,nmax)
      call initaz(axhfs,nmax)
      call initaz(axvfs,nmax)
cxxxxxxxxxxxx
      call initaz(axlksx,nmax)
      call initaz(axhfsx,nmax)
      call initaz(axvfsx,nmax)
c
      nmax = narxmx*ntprmx*ipchmx*nstmax
      call initaz(adhfs,nmax)
      call initaz(adhfsx,nmax)
c
      nmax = narxmx*ntprmx*ipcvmx*nstmax
      call initaz(advfs,nmax)
      call initaz(advfsx,nmax)
cxxxxxxxxxxxx
c
      call initiz(iffg,nffgmx)
      call initiz(jffg,nffgmx)
c
      call initcb(uffg,nffgmx)
      call initaz(moffg,nffgmx)
      call initaz(xlkffg,nffgmx)
c
      call initiz(jcode,nrctmx)
      call initiz(jreac,nrctmx)
      call initiz(nsk,nrctmx)
c
      call initcb(ureac,nrctmx)
      call initaz(fkrc,nrctmx)
      call initaz(modr,nrctmx)
      call initaz(morr,nrctmx)
      call initaz(sfcar,nrctmx)
      call initaz(ssfcar,nrctmx)
c
      nmax = 2*nrctmx
      call initiz(imech,nmax)
      call initiz(nrk,nmax)
c
      nmax = imchmx*2*nrctmx
      call initaz(csigma,nmax)
      call initaz(rkb,nmax)
      call initaz(trkb,nmax)
      call initaz(eact,nmax)
      call initaz(hact,nmax)
      call initiz(iact,nmax)
      call initiz(ndact,nmax)
c
      nmax = ndctmx*imchmx*2*nrctmx
      call initaz(cdac,nmax)
      call initcb(udac,nmax)
c
      call initcb(ugexp,netmax)
c
      do ne = 1,netmax
        jgext(ne) = 0
        kern1(ne) = 0
        kern2(ne) = 0
      enddo
c
      nmax = jetmax*netmax
      call initiz(jern1,nmax)
      call initiz(jern2,nmax)
      call initiz(ngext,nmax)
      call initiz(ngexrt,nmax)
      call initaz(egexjf,nmax)
c
      nmax = ietmax*jetmax*netmax
      call initaz(cegexs,nmax)
      call initaz(cpgexs,nmax)
      call initaz(mrgexs,nmax)
      call initiz(ngexro,nmax)
      call initiz(ngexso,nmax)
      call initiz(ngexsa,nmax)
c
      nmax = ietmax*jetmax*nertmx
      call initaz(egersi,nmax)
      call initaz(xgersi,nmax)
c
      nmax = ketmax*netmax
      call initiz(kgexsa,nmax)
c
      nmax = iktmax*nxrtmx
      call initaz(rxbari,nmax)
c
      nmax = iapxmx*nxtmax
      call initaz(apx,nmax)
c
      nmax = ibpxmx*nxtmax
      call initaz(bpx,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine the problem input format.
c
      read (ninpts,1090,end=105,err=107) ux8
 1090 format(a8)
      backspace ninpts
      uinfor = 'W'
      if (ux8(1:8) .eq. '|-------') uinfor = 'D'
c
c     Read the problem input.
c
      if (uinfor(1:1) .eq. 'W') then
c
c       Compact (W) format.
c
        call rd6inw(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $  csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $  dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $  dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $  iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $  iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $  jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $  ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $  mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $  nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $  nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $  nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $  nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $  nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $  phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $  rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $  toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $  uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $  uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $  uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $  xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
      else
c
c       Menu-style (D) format.
c
        call rd6ind(awmaxi,awmini,cbsri,cdac,cesri,cgexj,
     $  csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,dloplo,
     $  dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmx0,dlxpll,
     $  dlxplo,dlxprl,dlxprn,eact,egersi,ehmaxi,ehmini,electr,fkrc,
     $  iact,ibsrti,iesrti,ietmax,iktmax,imchmx,imech,iodb,iopg,
     $  iopr,iopt,igerti,itermx,ixrti,jcode,jgerti,jetmax,jflgi,
     $  jgext,jpress,jreac,jtemp,kbt,kct,kdim,kmax,kmt,kprs,ksplmx,
     $  ksppmx,kstpmx,kxmod,kxt,hact,modr,moffg,morr,mprphi,mprspi,
     $  mtbaqi,mtbi,mwtges,nbti,nbtmax,nbt1mx,nctmax,ndact,ndctmx,
     $  nert,nertmx,net,netmax,nffg,nffgmx,ngexrt,ninpts,nobswt,
     $  nodbmx,nopgmx,noprmx,noptmx,nordmx,noutpt,nprob,nprpmx,
     $  nprpti,nprsmx,nprsti,nptkmx,nrct,nrctmx,nrk,nsbswt,nsk,
     $  nsrt,nsrtmx,ntitl1,ntitl2,ntitmx,ntrymx,nttkmx,nttyo,nxmdmx,
     $  nxmod,nxopex,nxopmx,nxopt,nxpemx,nxrt,nxrtmx,o2maxi,o2mini,
     $  phmaxi,phmini,pressb,pressi,ptk,qend,qgexsh,qrderr,rkb,
     $  rxbari,sfcar,ssfcar,tempcb,tempci,tgexp,timmxi,tistti,tolbt,
     $  toldl,tolsat,tolxsf,trkb,ttk,ubmtbi,ubsri,ucxri,udac,uesri,
     $  uffg,ugerji,ugermo,ugersi,ugexj,ugexmo,ugexp,ugexr,uhfgex,
     $  uobsw,uprphi,uprspi,ureac,usbsw,utitl1,utitl2,uvfgex,uxcat,
     $  uxkgex,uxmod,uxopex,uxopt,uzveci,vreac,xgersi,xhfgex,ximaxi,
     $  xistti,xlkffg,xlkgex,xlkmod,xvfgex,zgexj,zvclgi)
      endif
c
      go to 109
  105 qend = .true.
      go to 109
  107 qrderr = .true.
  109 continue
c
      if (qrderr) then
        write (noutpt,1100)
        write (nttyo,1100)
 1100   format(/' * Error - (EQ6/eq6) Encountered an error while',
     $  ' reading the input file.',/7x,'The line associated with',
     $  ' the problem should be the last one',/7x,'echoed on the',
     $  ' output file or the first line immediately thereafter.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qend) then
c
        write (noutpt,1110)
        write (nttyo,1110)
 1110   format(/' No further input found.',/)
c
c       Make porting changes in the EQLIBU routines that are called in
c       this section. Do not make the porting changes here.
c
c       Get end time and date. Also get the run, user, and cpu times.
c
        call runtim(iexec0,jexec0,texec0,noutpt,nttyo,trun,
     $  tuser,tcpu,udate1,utime1)
c
        j2 = ilnobl(udate0)
        j3 = ilnobl(udate1)
        write (noutpt,1120) utime0,udate0(1:j2),utime1,udate1(1:j3)
        write (nttyo,1120) utime0,udate0(1:j2),utime1,udate1(1:j3)
 1120   format(10x,'Start time = ',a8,2x,a,/12x,
     $  'End time = ',a8,2x,a)
c
c       Print the run, user, and cpu times.
c
        write (noutpt,1140) trun
        write (nttyo,1140)  trun
 1140   format(/10x,' Run time = ',g10.3,' seconds')
        if (tuser .gt. 0.) then
          write (noutpt,1150) tuser
          write (nttyo,1150)  tuser
 1150     format(10x,'User time = ',g10.3,' seconds')
        endif
        if (tcpu .gt. 0.) then
          write (noutpt,1160) tcpu
          write (nttyo,1160)  tcpu
 1160     format(10x,' Cpu time = ',g10.3,' seconds')
        endif
c
        write (noutpt,1170)
        write (nttyo,1170)
 1170   format(/' Normal exit')
c
c       BEGIN_MACHINE_DEPENDENT_CODE
c
c         Clear the IEEE flag for floating-point underflow, if such a
c         flag is present, to avoid getting an unnecessary system
c         warning message. Underflow is a normal condition in EQ3/6.
c         Make porting changes in the EQLIBU subroutine that is called
c         in this section. Do not make the porting changes here.
c
          call cliefu()
c
c       END_MACHINE_DEPENDENT_CODE
c
c       Close and delete the stripped input file and the tabs file.
c
        close (ninpts,status='delete')
        if (ntabs .gt. 0) close (ntabs,status='delete')
c
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Scan the input file title for option strings.
c
c     Scan the input file title for the USEOLDPITZERMU string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), set up
c     set to calculate activity coefficients using recalculated
c     observable third-order parameters (Cphi, psi, zeta) instead
c     of their conventional mu equivalents.
c
      qhawep = .true.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl1
          ux80 = utitl1(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzermu')
          if (i .gt. 0) then
            qhawep = .false.
            go to 106
          endif
        enddo
c
        do n = 1,ntitl2
          ux80 = utitl2(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzermu')
          if (i .gt. 0) then
            qhawep = .false.
            if (ntitl1 .lt. ntitmx) then
              ntitl1 = ntitl1 + 1
              utitl1(ntitl1) = utitl2(n)
            else
              write (noutpt,1180)
              write (nttyo,1180)
 1180         format(/' * Note - (EQ6/eq6) Found the USEOLDPITZERMU',
     $        ' option string',/7x,'in the secondary input file title',
     $        ' but cannot add it',/7x,'to the main title. The option',
     $        ' will not carry over to any',/7x,'PICKUP file that may',
     $        ' be written at the end of the present run.')
            endif
            go to 106
          endif
        enddo
  106   continue
      endif
c
      if (.not.qhawep) then
        write (noutpt,1190)
        write (nttyo,1190)
 1190   format(/' * Note - (EQ6/eq6) Found the USEOLDPITZERMU',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will evaluate the Pitzer',/7x,'equations using the',
     $  ' lambda-mu format. Implied psi coefficients',/7x,'not',
     $  ' on the supporting data file will not be effectively',
     $  ' treated',/7x,'as having zero values. Rather, the',
     $  ' corresponding mu coefficients',/7x,'will be treated as',
     $  ' having zero values. In effect, an implied',/7x,'psi',
     $  ' coefficient value will include contributions from',
     $  ' the',/7x,'two cognate Cphi coefficients that appear',
     $  ' in the psi-mu',/7x,'breakdown equation.')
      endif
c
c     Scan the input file title for the USEOLDPITZER75 string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), use
c     the older approximation given by Pitzer (1975) for calculating
c     the higher-order electrostatic terms.
c
      qpit75 = .false.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl1
          ux80 = utitl1(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzer75')
          if (i .gt. 0) then
            qpit75 = .true.
            go to 170
          endif
        enddo
c
        do n = 1,ntitl2
          ux80 = utitl2(n)
          call locase(ux80)
          i = index(ux80,'useoldpitzer75')
          if (i .gt. 0) then
            qpit75 = .true.
            if (ntitl1 .lt. ntitmx) then
              ntitl1 = ntitl1 + 1
              utitl1(ntitl1) = utitl2(n)
            else
              write (noutpt,1192)
              write (nttyo,1192)
 1192         format(/' * Warning - (EQ6/eq6) Found the USEOLDPITZER75',
     $        ' option string',/7x,'in the secondary input file title',
     $        ' but cannot add it',/7x,'to the main title. The option',
     $        ' will not carry over to any',/7x,'PICKUP file that may',
     $        ' be written at the end of the present run.')
            endif
            go to 170
          endif
        enddo
  170   continue
      endif
c
      if (qpit75) then
        write (noutpt,1193)
        write (nttyo,1193)
 1193   format(/' * Warning - (EQ6/eq6) Found the USEOLDPITZER75',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will evaluate the Pitzer',/7x,'equations using the',
     $  ' old Pitzer (1975) approximation for',/7x,'higher order',
     $  ' electrostatic terms, not the later Harvie (1981)',
     $  /7x,'approximation that is now used nearly universally',
     $  ' to evaluate',/7x,'the Pitzer equations.')
      endif
c
c     Scan the input file title for the WRITEPITZERJTABLES string.
c     If found and if iopg(1) = 1 (use Pitzer's equations), calculate
c     and output tables of the J(x) and J'(x) functions. This is a
c     one-time only option. It is not carried forward on the PICKUP
c     file.
c
      qcwrpj = .false.
      if (iopg(1) .eq. 1) then
        do n = 1,ntitl1
          ux80 = utitl1(n)
          call locase(ux80)
          i = index(ux80,'writepitzerjtables')
          if (i .gt. 0) then
            qcwrpj = .true.
            go to 180
          endif
        enddo
c
        do n = 1,ntitl2
          ux80 = utitl2(n)
          call locase(ux80)
          i = index(ux80,'writepitzerjtables')
          if (i .gt. 0) then
            qcwrpj = .true.
            go to 180
          endif
        enddo
  180   continue
      endif
c
      if (qcwrpj) then
        write (noutpt,1194)
        write (nttyo,1194)
 1194   format(/' * Note - (EQ6/eq6) Found the WRITEPITZERJTABLES',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will calculate the Pitzer',/7x,"J(x) and J'(x) functions",
     $  ' for higher order electrostatic terms and',/7x,'write output',
     $  ' tables for both the Pitzer (1975) and Harvie (1981)',/7x,
     $  'approximations.')
      endif
c
c     Scan the input file title for the TURNOFFOPTIMIZER string.
c     If found, turn off the pre-Newton-Raphson optimizer.
c
      qoptmz = .true.
      do n = 1,ntitl1
        ux80 = utitl1(n)
        call locase(ux80)
        i = index(ux80,'turnoffoptimizer')
        if (i .gt. 0) then
          qoptmz = .false.
          go to 110
        endif
      enddo
c
      do n = 1,ntitl2
        ux80 = utitl2(n)
        call locase(ux80)
        i = index(ux80,'turnoffoptimizer')
        if (i .gt. 0) then
          qoptmz = .false.
          if (ntitl1 .lt. ntitmx) then
            ntitl1 = ntitl1 + 1
            utitl1(ntitl1) = utitl2(n)
          else
            write (noutpt,1195)
            write (nttyo,1195)
 1195       format(/' * Warning - (EQ6/eq6) Found the TURNOFFOPTIMIZER',
     $      ' option string',/7x,'in the secondary input file title',
     $      ' but cannot add it',/7x,'to the main title. The option',
     $      ' will not carry over to any',/7x,'PICKUP file that may',
     $      ' be written at the end of the present run.')
          endif
          go to 110
        endif
      enddo
  110 continue
c
      if (.not.qoptmz) then
        write (noutpt,1197)
        write (nttyo,1197)
 1197   format(/' * Note - (EQ6/eq6) Found the TURNOFFOPTIMIZER',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will turn off the',/7x,'pre-Newton-Raphson optimizer.',
     $  ' This may help if Newton-Raphson',/7x,'iteration fails',
     $  ' to converge due to insufficient optimizer',
     $  /7x,'performance. This is most likely to be a problem',
     $  ' when the',/7x,'phase assemblage changes.')
      endif
c
c     Scan the input file title for the TABFILEASTXT string. If found,
c     found, make the TAB file an ordinary text file (the old style
c     TAB file) instead of as a comma separated value (.csv) file.
c
      qtatxt = .false.
      do n = 1,ntitl1
        ux80 = utitl1(n)
        call locase(ux80)
        i = index(ux80,'tabfileastxt')
        if (i .gt. 0) then
          qtatxt = .true.
          go to 210
        endif
      enddo
c
      do n = 1,ntitl2
        ux80 = utitl2(n)
        call locase(ux80)
        i = index(ux80,'tabfileastxt')
        if (i .gt. 0) then
          qtatxt = .true.
          if (ntitl1 .lt. ntitmx) then
            ntitl1 = ntitl1 + 1
            utitl1(ntitl1) = utitl2(n)
          else
            write (noutpt,1196)
            write (nttyo,1196)
 1196       format(/' * Warning - (EQ6/eq6) Found the TABFILEASTXT',
     $      ' option string',/7x,'in the secondary input file title',
     $      ' but cannot add it',/7x,'to the main title. The option',
     $      ' will not carry over to any',/7x,'PICKUP file that may',
     $      ' be written at the end of the present run.')
          endif
          go to 210
        endif
      enddo
  210 continue
c
      if (qtatxt) then
        write (noutpt,1198)
        write (nttyo,1198)
 1198   format(/' * Note - (EQ6/eq6) Found the TABFILEASTXT',
     $  ' option string',/7x,'in one of the input file titles.',
     $  ' Will write the TAB',/7x,'file as an ordinary text file',
     $  ' instead of the default csv',/7x,'(comma-separated-variable)',
     $  ' file. The data content may not',/7x,'be the same for both',
     $  ' files.')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check consistency between the activity coefficient option and the
c     data1 file.
c
      call cdakey(iopg,nopgmx,noutpt,nttyo,udakey,udatfi)
c
c     Get the name of the option for calculating the activity
c     coefficients of aqueous species.
c
      call nactop(iopg,nopgmx,noutpt,nttyo,uactop)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(16) .ge. 0) then
        inquire(file=bafile,opened=qop)
        if (.not.qop) call openou(noutpt,nttyo,bafile,'formatted',
     $  nrecl,nbkupa)
        if (iopt(16) .eq. 0) then
          inquire(file=bbfile,opened=qop)
          if (.not.qop) call openou(noutpt,nttyo,bbfile,'formatted',
     $    nrecl,nbkupb)
        endif
      endif
c
      if (iopt(17) .ge. 0) then
        inquire(file=pfile,opened=qop)
        if (.not.qop) call openou(noutpt,nttyo,pfile,'formatted',
     $  nrecl,newin)
      endif
c
      if (nprob.gt.1 .and. iopt(18).ge.1) iopt(18) = 0
      if (iopt(18) .ge. 1) then
        inquire(file=txfile,exist=qex)
        if (qex) then
          call openin(noutpt,nttyo,txfile,'formatted',ntabx)
          do i = 1,10000
            read (ntabx,1200,end=200) ux8
 1200       format(a8)
          enddo
  200     continue
        else
          write (noutpt,1210)
          write (nttyo,1210)
 1210     format(/' * Error - (EQ6/eq6) Have iopt(18)= 1, but there',
     $    /7x,'is no existing tabx file to which to append.')
          stop
        endif
      endif
c
      if (iopt(18) .ge. 0) then
c
c       Set up the TAB, TABS, and TABX files.
c
c       For the .csv form, the record length (nrecl) must match the
c       maximum character lengths of the table tag (8 characters)
c       and the ulinex variable (nllnmx characters), plus two
c       (for one comma trailing the table tag and another trailing
c       The ulinex variable).
c
        nrecl = nllnmx + 10
        if (qtatxt) nrecl = 128
c
        inquire(file=tfile,opened=qop)
        if (.not.qop) call openou(noutpt,nttyo,tfile,'formatted',
     $  nrecl,ntab)
c
        inquire(file=tsfile,opened=qop)
        if (.not.qop) then
          call openou(noutpt,nttyo,tsfile,'formatted',nrecl,ntabs)
        else
          rewind ntabs
        endif
c
        nrecl = nllnmx + 10
        if (qtatxt) nrecl = 129
c
        inquire(file=txfile,opened=qop)
        if (.not.qop) then
          call openou(noutpt,nttyo,txfile,'formatted',nrecl,ntabx)
        endif
        if (iopt(18) .eq. 0) rewind ntabx
c
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     qecon = .true. denotes economy mode.
c     qscon = .true. denotes super economy mode.
c
      qecon = .false.
      qscon = .false.
      if (iopt(1).lt.2 .and. iopt(2).le.0) then
        if (iopt(13) .ge. 1) qecon = .true.
        if (iopt(13) .ge. 2) qscon = .true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set default values of run control parameters read from the
c     data file. Put any out-of-range values into acceptable range.
c
      tolxst = 0.
      tolxsu = 0.
      call dfaltz(dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltplo,dltpll,dltprl,dltprn,dlxdmp,dlxmx0,
     $ dlxplo,dlxpll,dlxprl,dlxprn,iopt,itermx,ksplmx,ksppmx,kstpmx,
     $ net,noptmx,nordmx,nrct,noutpt,ntrymx,nttyo,prcinf,qecon,qscon,
     $ timmxi,tistti,tolbt,toldl,tolsat,tolxsf,tolxst,tolxsu,
     $ ximaxi,xistti)
      nrd1mx = nordmx + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .gt. 0) then
c
c       Disallow print and plot intervals in log time space if the
c       starting time is less than zero.
c
        if (tistti.lt.0. .or. timmxi.lt.0.) then
          dltprl = prcinf
          dltpll = prcinf
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set other run control parameters.
c
      call setrcp(aftarg,dlxmax,dlxmin,dlxmx0,npslmx,nsscmx,
     $ nsslmx,prcinf,sscrew,tolaft,tolsat,tolsst,zkfac,zklgmn,
     $ zklogl,zklogu)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set some parameters using the data read from the input file.
c
      nart = 0
      ngrt = 0
      nmrt = 0
      do nrc = 1,nrct
        if (jcode(nrc) .eq. 0) then
          nmrt = nmrt + 1
        elseif (jcode(nrc) .eq. 3) then
          nart = nart + 1
        elseif (jcode(nrc) .eq. 4) then
          ngrt = ngrt + 1
        endif
      enddo
c
      km1 = kbt + 1
      kx1 = kmt + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set the starting and maximum values of reaction progress and
c     time to the input values. Note that the values of the input
c     variables will be changed prior to writing data on a backup
c     or pickup file.
c
      xistrt = xistti
      ximax = ximaxi
      tistrt = tistti
      timemx = timmxi
c
      xi1 = xistrt
      time1 = tistrt
c
c     Set the values of other run control parameters. These parameters
c     are also associated with mechanisms for terminating the current
c     reaction path; for example, if pH decreases to phmin, or increases
c     to phmax.
c
      phmin = phmini
      phmax = phmaxi
      ehmin = ehmini
      ehmax = ehmaxi
      o2min = o2mini
      o2max = o2maxi
      awmin = awmini
      awmax = awmaxi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check the input reactant data for various kinds of errors
c     and inconsistencies.
c
      call chkinz(ier,imchmx,imech,iopt,jcode,kmax,kxt,nelect,
     $ noptmx,noutpt,no2gaq,nrct,nrctmx,nrk,nstmax,nttyo,rkb,ureac,
     $ uspeca,uzveci,zvclgi)
c
      if (ier .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set some defaults.
c
      do nrc = 1,nrct
        if (fkrc(nrc) .le. 0.) fkrc(nrc) = 1.0
        if (sfcar(nrc) .lt. 0.) sfcar(nrc) = 0.
        if (ssfcar(nrc) .lt. 0.) ssfcar(nrc) = 0.
        do j = 1,2
          if (nrk(j,nrc) .eq. 2) then
            if (imech(j,nrc) .le. 0) imech(j,nrc) = 1
            do i = 1,imech(j,nrc)
              if (csigma(i,j,nrc) .le. 0.) csigma(i,j,nrc) = 1.
            enddo
          endif
        enddo
      enddo
c
      do n = 1,nsbswt
        if (usbsw(1,n)(1:24) .eq. ublk24(1:24))
     $  usbsw(1,n)(1:24) = uaqsln
        if (usbsw(2,n)(1:24) .eq. ublk24(1:24))
     $  usbsw(2,n)(1:24) = uaqsln
      enddo
c
      do n = 1,nobswt
        if (uobsw(1,n)(1:24) .eq. ublk24(1:24))
     $  uobsw(1,n)(1:24) = uaqsln
        if (uobsw(2,n)(1:24) .eq. ublk24(1:24))
     $  uobsw(2,n)(1:24) = uaqsln
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the 'a' set of reaction data into the 'd' set. The 'a'
c     set remains a faithful image of the data file. The 'd' set
c     at this stage is subject to modification. The number of basis
c     species may be increased in response to input file directives.
c     Thus, nbtd may become greater than nbta, and the basis species
c     pointer array nbaspd lengthened with respect to nbaspa. The
c     'd' set at this stage may also be modified by directives on the
c     input file to execute special basis switching. This redefines
c     which of the basis species are the strict basis species, and
c     according causes reactions and attendant thermodynamic data to
c     be rewritten. Modifications of the 'd' set at this stage
c     support options affecting problem definition. After the data
c     have been compressed to eliminate unnecessary species, the 'd'
c     set will be redfined. This second stage form is equivalent to
c     a compressed version of the first stage form with additional
c     input file directed modifications.
c
c     Calling sequence substitutions:
c       adhfsa for adhfs
c       advfsa for advfs
c       axhfsa for axhfs
c       axlksa for axlks
c       axvfsa for axvfs
c       cdrsa for cdrs
c       nbaspa for nbasp
c       ndrsa for ndrs
c       ndrsra for ndrsr
c
      call cdrssd(adhfsa,adhfsd,advfsa,advfsd,axhfsa,axhfsd,
     $ axlksa,axlksd,axvfsa,axvfsd,cdrsa,cdrsd,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,nbaspa,nbaspd,nbtmax,ndrsa,ndrsd,ndrsmx,ndrsra,ndrsrd,
     $ nstmax,ntprmx)
      nbtd = nbta
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the basis index of water (nbw).
c
c     Calling sequence substitutions:
c       nbaspd for nbasp
c       nbtd for nbt
c       narn1a for ns
c
      nbw = nbasis(nbaspd,nbtd,nbtmax,narn1a)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute special basis switching to redefine which basis species
c     are the strict basis species in the 'd' set of reaction data
c     (nbtd/nbaspd/cdrsd/ndrsd/ndrsrd/axlksd). This type of basis
c     switching is executed to assist in problem definition. Ordinary
c     basis switching, executed later in this code, is done only
c     for numerical purposes.
c
      if (nsbswt .gt. 0) then
c
        do nsbsw = 1,nsbswt
c
c         Interpret the directive for the nsbsw-th switch.
c
          call intsbs(nb1,nb2,nbaspd,nbtd,nbtmax,noutpt,ns1,ns2,
     $    nsbsw,nstmax,nttyo,usbsw,uspeca)
c
c         Execute the switch.
c
          call swtchb(adhfsd,adhfsx,advfsd,advfsx,axhfsd,axhfsx,
     $    axlksd,axlksx,axvfsd,axvfsx,cdrsd,cdrsx,ipch,ipchmx,ipcv,
     $    ipcvmx,narxmx,nbaspd,nbtmax,nbw,nb1,nb2,ndrsd,ndrsmx,ndrsx,
     $    ndrsrd,ndrsrx,noutpt,ns1,ns2,nsta,nstmax,ntprmx,nttyo,uspeca)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize some arrays.
c
c     Note: csp and nsp are not used in EQ6.
c
      call initiz(ndecsp,nbtmax)
c
c     Note: mtb, mtbaq, mte, and mteaq are not used in EQ3NR.
c
      call initaz(mtb,nbtmax)
      call initaz(mtbaq,nbtmax)
      call initaz(mte,nctmax)
      call initaz(mteaq,nctmax)
c
c     Note: conc and conclg are initialized in EQ6/path.f.
c
      call initaz(moph,nptmax)
      call initaz(mosp,nstmax)
      av = -99999.
      call initav(loph,nptmax,av)
      call initav(losp,nstmax,av)
c
c     Note: mprsp is not used in EQ3NR.
c
      call initaz(mprsp,nstmax)
c
c     Note: acflg, acflgo, act, actlg, xbar, and xbarlg, are initialized
c     in EQ6/path.f.
c
c     Note: npchk and mprph are not used in EQ3NR.
c
      call initiz(npchk,nptmax)
      call initaz(mprph,nptmax)
c
c     Note: zvec0 and zvclg0 are initialized in EQ6/path.f.
c
      call initiz(iindx1,kmax)
      call initiz(ipndx1,kmax)
c
      call initaz(zvec1,kmax)
c
      av = -99999.
      call initav(zvclg1,kmax,av)
c
c     Note: the following are not used in EQ3NR.
c
      nmax = imchmx*2*nrctmx
      call initaz(rk,nmax)
c
      nmax = ndctmx*imchmx*2*nrctmx
      call initiz(ndac,nmax)
c
      nmax = iktmax*nxrtmx
      call initaz(rxbar,nmax)
c
      nmax = nctmax*nsrtmx
      call initaz(cesr,nmax)
c
      nmax = nbt1mx*nsrtmx
      call initaz(cbsr,nmax)
c
      nmax = ietmax*jetmax*nertmx
      call initaz(egers,nmax)
      call initaz(xgers,nmax)
      call initaz(mrgers,nmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret the data file basis species listed on the input file.
c     "Data file" basis species to be created according to instructions
c     read from the input file (e.g., for generic ion exchangers)
c     will be ignored at this point, as creation occurs later in
c     this code.
c
      call intbs6(jflag,jflgi,kmax,narn1a,narn2a,nbaspd,nbtd,
     $ nbti,nbtmax,ndrsrd,ndecsp,noutpt,nsta,nstmax,nttyo,uspeca,
     $ ubmtbi)
c
c     Set jflag to -1 for species that can not appear in the system.
c
      call jflaux(jflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,
     $ ndrsrd,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the temperature-tracking input.
c
      if (jtemp .eq. 0) then
        continue
      elseif (jtemp .eq. 1) then
        if (ttk(1) .eq. 0.) then
          write (noutpt,2110)
          write (nttyo,2110)
 2110     format(/' * Note (EQ6/eq6) The specified temperature',
     $    /7x,'derivative for computing the temperature as a linear',
     $    /7x,'function of Xi is zero. The temperature is therefore',
     $    /7x,'constant. Will reset the temperature-tracking flag',
     $    /7x,'jtemp from 1 to 0.')
          jtemp = 0
        endif
      elseif (jtemp .eq. 2) then
        if (ttk(1) .eq. 0.) then
          write (noutpt,2120)
          write (nttyo,2120)
 2120     format(/' * Note (EQ6/eq6) The specified temperature',
     $    /7x,'derivative for computing the temperature as a linear',
     $    /7x,'function of time is zero. The temperature is therefore',
     $    /7x,'constant. Will reset the temperature-tracking flag',
     $    /7x,'jtemp from 2 to 0.')
          jtemp = 0
        endif
      elseif (jtemp .eq. 3) then
        if (ttk(1) .eq. 0.) then
          write (noutpt,2130)
          write (nttyo,2130)
 2130     format(/' * Note (EQ6/eq6) The specified mass factor',
     $    /7x,'ratio (ttk(1) for computing the temperature from',
     $    /7x,'a fluid mixing ratio (jtemp = 3) was zero. This is',
     $    /7x,'not a valid value. Will change this to 1.0. This',
     $    /7x,'parameter affects the relation between the fluid',
     $    /7x,'mixing ratio and Xi. A value of 1.0 corresponds to',
     $    /7x,'a 1:1 mixing ratio.')
        endif
      else
        write (noutpt,2140) jtemp
        write (nttyo,2140) jtemp
 2140   format(/' * Error - (EQ6/eq6) The temperature tracking',
     $  /7x,'flag (jtemp) has an unknown value of ',i2,'.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test the pressure-tracking input.
c
      if (jpress .eq. 0) then
        continue
      elseif (jpress .eq. 1) then
        continue
      elseif (jpress .eq. 2) then
        continue
      elseif (jpress .eq. 3) then
        if (ptk(1) .eq. 0.) then
          write (noutpt,2150)
          write (nttyo,2150)
 2150     format(/' * Note (EQ6/eq6) The specified pressure',
     $    /7x,'derivative for computing the pressure as a linear',
     $    /7x,'function of Xi is zero. The pressure is therefore',
     $    /7x,'constant. Will reset the pressure-tracking flag',
     $    /7x,'jpress from 3 to 2.')
          jpress = 0
        endif
      elseif (jpress .eq. 4) then
        if (ptk(1) .eq. 0.) then
          write (noutpt,2160)
          write (nttyo,2160)
 2160     format(/' * Note (EQ6/eq6) The specified pressure',
     $    /7x,'derivative for computing the pressure as a linear',
     $    /7x,'function of time is zero. The pressure is therefore',
     $    /7x,'constant. Will reset the pressure-tracking flag',
     $    /7x,'jpress from 4 to 2.')
          jpress = 0
        endif
      else
        write (noutpt,2170) jpress
        write (nttyo,2170) jpress
 2170   format(/' * Error - (EQ6/eq6) The pressure tracking',
     $  /7x,'flag (jpress) has an unknown value of ',i2,'.')
        stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the initial temperature.
c
      call gtemp(afcnst,al10,iopt,jtemp,noptmx,noutpt,nttkmx,
     $ nttyo,rconst,rtcnst,tempc,tempcb,tempk,time1,ttk,xi1)
c
c     Determine the corresponding temperature range flag.
c
      call gntpr(ntpr,ntprmx,ntprt,tempc,tempcu)
c
c     Check for constant temperature.
c
      qcntmp = jtemp .eq. 0
c
c     Check for a temperature jump.
c
      dt = tempc - tempci
      if (abs(dt) .gt. 1.e-4) then
        write (noutpt,1300) tempc,tempci
        write (nttyo,1300) tempc,tempci
 1300   format(/' * Note - (EQ6/eq6) The temperature is jumping from',
     $  /7x,'the previous run:',/,
     $  /'     Initial temperature      = ',f10.4,' C',
     $  /'     Previous run temperature = ',f10.4,' C')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the data file reference grid pressure at the initial
c     temperature.
c
c     Calling sequence substitutions:
c       apresg for arr
c       presg for prop
c
      call evdat2(apresg,narxmx,narxt,ntpr,ntprmx,presg,tempc)
c
c     Compute the 1.013-bar/steam-saturation curve pressure at the
c     initial temperature.
c
      if (tempc .le. 100.) then
        ntprh = 1
      else
        ntprh = 2
      endif
c
c     Calling sequence substitutions:
c       apresh for arr
c       5 for narxmx
c       narxth for narxt
c       ntprh for ntpr
c       2 for ntprmx
c       presh for prop
c
      call evdat2(apresh,5,narxth,ntprh,2,presh,tempc)
c
c     Compute the initial pressure.
c
      call gpress(iopt,jpress,noptmx,noutpt,nptkmx,nttyo,presg,
     $ presh,press,pressb,time1,ptk,xi1)
c
c     Check for constant pressure.
c
      qcnpre = jpress.eq.2 .or. (jpress.eq.0 .and. qcntmp) .or.
     $ (jpress.eq.1 .and. qcntmp)
c
c     Check for a pressure jump.
c
      dp = press - pressi
      if (abs(dp) .gt. 1.e-4) then
        write (noutpt,1310) press,pressi
        write (nttyo,1310) press,pressi
 1310   format(/' * Note - (EQ6/eq6) The pressure is jumping from',
     $  /7x,'the previous run:',/,
     $  /'     Initial pressure      = ',1pg12.5,' bars',
     $  /'     Previous run pressure = ',1pg12.5,' bars')
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Set species status flags.
c
      call flgset(axlksd,iopt,jflag,jpflag,jsflag,kxmod,narn1a,
     $ narn2a,narxmx,nbaspd,nbtd,nbtmax,ncmpra,ncta,ndrsd,ndrsmx,
     $ ndrsrd,noptmx,noutpt,npta,nptmax,nrdxsp,nsta,nstmax,ntpr,
     $ ntprmx,nttyo,nxmdmx,nxmod,uphasa,uptypa,uspeca,uxmod)
c
      if (iopt(15) .ge. 1) then
c
c       Execute the option to suppress all redox reactions.
c
        call suprdx(jflag,jsflag,narn1a,narn2a,ndrsd,ndrsmx,
     $  ndrsrd,nrdxsp,nsta,nstmax,uspeca)
      endif
c
c     Execute the pure mineral subset selection suppression options.
c
      call mincsp(cdrsd,jpflag,jsflag,nbaspd,nbtd,nbtmax,ncmpra,
     $ ndrsd,ndrsmx,ndrsrd,nmrn1a,nmrn2a,noutpt,npta,nptmax,nstmax,
     $ nttyo,nxopex,nxopmx,nxopt,nxpemx,uspeca,uxcat,uxopex,uxopt)
c
c     Check the jpflag array to make sure it is consistent with the
c     jsflag array.
c
      call flgchk(jpflag,jsflag,ncmpra,npta,nptmax,nstmax,qclnsa)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Examine each active auxiliary basis species. Print a warning if
c     any other species in the corresponding dissociation reaction is
c     not present in the model.
c
      call bspchk(jsflag,nbaspd,nbtd,nbtmax,ndrsd,ndrsmx,ndrsrd,
     $ noutpt,nrdxsp,nstmax,nttyo,uspeca)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do data array compression. Write working data arrays that
c     don't include phases and species that aren't necessary
c     for the current problem.
c
      call cmpdat(adhfs,adhfsd,advfs,advfsd,amu,amua,apx,
     $ apxa,aslm,aslma,atwt,atwta,axhfs,axhfsd,axlks,axlksd,axvfs,
     $ axvfsd,azero,azeroa,bpx,bpxa,cdrs,cdrsd,cess,cessa,iapxmx,
     $ iapxt,iapxta,iaqsla,iaqsln,ibpxmx,ibpxt,ibpxta,ilrn1,ilrn2,
     $ imrn1,imrn2,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,insgf,insgfa,
     $ iopg,ixrn1,ixrn1a,ixrn2,ixrn2a,jflag,jpfcmx,jpflag,jsflag,
     $ jsitex,jsol,jsola,mwtsp,mwtspa,nalpaa,nalpha,napmax,napt,
     $ napta,narn1,narn1a,narn2,narn2a,narxmx,nat,natmax,nbasp,
     $ nbaspd,nbmap,nbt,nbtd,nbti,nbtmax,nchlor,ncmap,ncmpr,ncmpra,
     $ nct,ncta,nctmax,ndecsp,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ness,
     $ nessa,nessmx,nessr,nessra,ngrn1,ngrn1a,ngrn2,ngrn2a,ngt,
     $ nlrn1,nlrn1a,nlrn2,nlrn2a,nlt,nmrn1,nmrn1a,nmrn2,nmrn2a,nmt,
     $ nmut,nmuta,nmutmx,nmux,nmuxa,nopgmx,nslt,nsltmx,nslta,nslx,
     $ nslxa,nphasx,npt,npta,nptmax,nsmap,nsta,nst,nstmax,ntf1,ntf1a,
     $ ntf1mx,ntf1t,ntf1ta,ntf2,ntf2a,ntf2mx,ntf2t,ntf2ta,ntprmx,
     $ nxrn1,nxrn1a,nxrn2,nxrn2a,nxt,nxtmax,palpaa,palpha,qchlor,
     $ tf1,tf1a,tf2,tf2a,uelem,uelema,uphasa,uphase,uptypa,uptype,
     $ uspec,uspeca,vosp0,vosp0a,zchar,zchara)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Get the indices of special species after compression.
c
c     Get the indices of H+, OH-, Cl-, fictive aqueous O2(g), and
c     fictive aqueous e-.
c
      call gspion(narn1,narn2,nchlor,nelect,nhydr,nhydx,noutpt,
     $ no2gaq,nstmax,nttyo,uspec)
c
c     Get the index of the redox basis species.
c
c     Calling sequence substitutions:
c       nbaspd for nbasp
c       nbtd for nbt
c       ndrsrd for ndrsr
c
      call grdxsp(nbaspd,nbtd,nbtmax,nct,ndrsrd,noutpt,
     $ nrdxsp,nstmax,nttyo,uspec)
c
c     Get the basis index of water (nbw).
c
c     Calling sequence substitutions:
c       nbaspd for nbasp
c       nbtd for nbt
c       narn1 for ns
c
      nbw = nbasis(nbaspd,nbtd,nbtmax,narn1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Examine each active auxiliary basis species. Change the
c     corresponding log K polynomial coefficients so that log K is
c     fixed at a value of -99999 if any other species in the
c     corresponding dissociation reaction is not in the model.
c
      call bsplkp(axlks,narxmx,nbasp,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,nstmax,ntprmx)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret input file directives to create generic ion-exchange
c     phases and species.
c
      call intexi(al10,axhfs,axlks,axvfs,cegexs,cess,cdrs,
     $ cgexj,cpgexs,egexjf,iern1,iern2,ietmax,jern1,jern2,jetmax,
     $ jflag,jgext,jpflag,jsflag,jsitex,kern1,kern2,ketmax,kgexsa,
     $ mwtges,mwtsp,narn1,narn2,narxmx,narxt,nbasp,nbt,nbtmax,ncmpr,
     $ ndrs,ndrsmx,ndrsr,ness,nessmx,nessr,netmax,net,nern1,nern2,
     $ ngexro,ngexrt,ngexsa,ngexso,ngext,noutpt,nphasx,npt,nptmax,
     $ nst,nstmax,ntprt,ntprmx,nttyo,nvetmx,rconst,tgexp,ugexj,
     $ ugexmo,ugexmv,ugexp,ugexr,ugexs,ugexsr,uhfgex,uphase,uspec,
     $ uvfgex,uxkgex,xhfgex,xlkgex,xvfgex,zchar,zgexj)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Set jflag values for the exchanger species.
c
        do ne = 1,net
          do je = 1,jgext(ne)
            nrr1 = jern1(je,ne)
            nrr2 = jern2(je,ne)
            do ns = nrr1,nrr2
c
c             Calling sequence substitutions:
c               nbaspd for nbasp
c
              nb = nbasis(nbasp,nbt,nbtmax,ns)
              if (nb .eq. 0) jflag(ns) = 30
            enddo
          enddo
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Echo a table for the generic ion exchangers, describing the
c       setup of species, reactions, and corresponding thermodynamic
c       data.
c
        call echgex(axlks,cdrs,cgexj,iern1,iern2,jern1,jern2,
     $  jetmax,jgext,jpflag,jsflag,narxmx,narxt,ndrs,ndrsmx,ndrsr,
     $  netmax,noutpt,nptmax,ntprmx,ntprt,nstmax,press,tempc,ugexj,
     $  ugexmo,uphase,uspec,xlks)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Alter any log K values as directed by the input file
c     (actually, it is the set of interpolating polynomial
c     coefficients which is altered).
c
      if (nxmod .gt. 0) then
        call alters(afcnst,apresg,axlks,cdrs,kxmod,narxmx,narxt,
     $  ndrs,ndrsmx,ndrsr,noutpt,npt,nptmax,nst,nstmax,ntpr,ntprmx,
     $  nttyo,nxmdmx,nxmod,tempc,uphase,uspec,uxmod,xlkmod)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Create fictive minerals for the fixed fugacity option.
c
      nfrn1 = nst + 1
      nfrn2 = nst
      ifrn1 = npt + 1
      ifrn2 = npt
      if (nffg .gt. 0) then
        call nlkffg(axlks,cess,cdrs,iffg,ifrn1,ifrn2,jffg,jpflag,
     $  jsflag,mwtsp,narxmx,ncmpr,ndrs,ndrsmx,ndrsr,ness,nessmx,nessr,
     $  nffg,nffgmx,nfrn1,nfrn2,ngrn1,ngrn2,noutpt,nphasx,npt,nptmax,
     $  nst,nstmax,ntpr,ntprmx,nttyo,qcntmp,uffg,ufixf,uphase,uspec,
     $  vosp0,xlkffg)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make up (z**2)/2 and (z**3)/6 for later use.
c
      do ns = 1,nst
        zx = 0.5*zchar(ns)*zchar(ns)
        zchsq2(ns) = zx
        zchcu6(ns) = (zx*zchar(ns))/3.
      enddo
c
c     Get the max norm of the electrical charges of the aqueous
c     species (izmax).
c
      call zsrt(izmax,narn1,narn2,nstmax,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Determine if the model to be calculated has a redox aspect.
c     Note: the iopt(15) option may be been excecuted above.
c
      call tstrdx(cdrs,iodb,iopt,jflag,jsflag,narn1,narn2,
     $ ndrs,ndrsmx,ndrsr,nodbmx,noptmx,noutpt,nrdxsp,nstmax,
     $ qredox,uspec)
c
c     If there is no redox aspect, make sure that all active redox
c     reactions are suppressed.
c
      if (.not.qredox .and. iopt(15).le.0) then
c
c       Calling sequence substitutions:
c         narn1 for narn1a
c         narn2 for narn2a
c         ndrs for ndrsd
c         ndrsr for ndrsrd
c         nst for nsta
c         uspec for uspeca
c
        call suprdx(jflag,jsflag,narn1,narn2,ndrs,ndrsmx,
     $  ndrsr,nrdxsp,nst,nstmax,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret the mass balance totals. Construct the mtb and mtbaq
c     arrays.
c
      call intmtb(mtb,mtbaq,mtbaqi,mtbi,nbasp,nbt,nbti,nbtmax,
     $ noutpt,nstmax,nttyo,ubmtbi,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret matrix variables. Construct the iindx1 and zvclg1
c     arrays. Note that new fictive fugacity-fixing phases will not
c     yet appear in the matrix after this has been done.
c
      call intmat(iaqsln,iindx1,ipndx1,kbt,kdim,kelect,khydr,
     $ khydx,kmax,km1,kmt,ko2gaq,kwater,kx1,kxt,narn1,narn2,nbasp,
     $ nbt,nbti,nbtmax,ncmpr,nelect,nern1,nern2,nhydr,nhydx,nobswt,
     $ noutpt,no2gaq,nphasx,npt,nptmax,nstmax,nttyo,qloffg,ubmtbi,
     $ ufixf,uobsw,uphase,uspec,uzveci,uzvec1,zvclgi,zvclg1,zvec1)
c
       krdxsp = ko2gaq
       nrdxsp = no2gaq
       if (krdxsp .eq. 0) then
         krdxsp = kelect
         nrdxsp = nelect
       endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nsrt .gt. 0) then
c
c       Construct reactions for special reactants in cases for
c       which a reaction was not read from the input file.
c
        call makrsr(cbsri,cesri,cess,eps100,ibsrti,iesrti,jcode,
     $  nbt1mx,nct,nctmax,ness,nessmx,nessr,noutpt,nrct,nrctmx,nsrtmx,
     $  nstmax,nttyo,ubsri,uelem,uesri,ureac,uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Interpret reactant names and associated properties read from the
c     input file.
c
      call intrct(cbsr,cbsri,cesr,cesri,egers,egersi,ibsrti,
     $ iern1,iern2,iesrti,ietmax,igerti,iktmax,imrn1,imrn2,ixrn1,
     $ ixrn2,ixrti,jcode,jetmax,jgerti,jgext,narn1,narn2,nbaspd,
     $ nbt,nbtmax,nbt1mx,ncmpr,nct,nctmax,nertmx,netmax,ngexsa,
     $ ngext,ngrn1,ngrn2,noutpt,nptmax,nrct,nrctmx,nrndex,nsrtmx,
     $ nstmax,nttyo,nxridx,nxrtmx,rxbar,rxbari,ubsri,ucxri,uelem,
     $ uesri,ugerji,ugermo,ugersi,ugexj,ugexmo,uphase,ureac,uspec,
     $ xgers,xgersi)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nert .gt. 0) then
c
c       Calculate the mole ratios (mrgers) for species on exchange
c       sites of generic ion exchanger reactants. The mole ratio is the
c       moles of exchanger species (specific to a site) per mole of
c       exchanger substrate. These mole ratios are used to compute mass
c       balance increments. They are calculated from the corresponding
c       equivalent fractions (egers). Note that these mole ratios and
c       equivalent fractions are model-independent, unlike the
c       corresponding mole fractions.
c
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 5) then
            ner = nxridx(nrc)
            np = nrndex(nrc)
            ne = np - iern1 + 1
            do je = 1,jgext(ne)
              ex = zgexj(je,ne)*cgexj(je,ne)
              do ie = 1,ngext(je,ne)
                nss = ngexsa(ie,je,ne)
                if (nss .gt. 0) then
                  mrgers(ie,je,ner) = -ex*egers(ie,je,ner)/zchar(nss)
                endif
              enddo
            enddo
          endif
        enddo
c
c       Calculate the mole fractions (xgers) for species on exchange
c       sites of generic ion exchanger reactants.
c
        do nrc = 1,nrct
          if (jcode(nrc) .eq. 5) then
            ner = nxridx(nrc)
            np = nrndex(nrc)
            ne = np - iern1 + 1
            do je = 1,jgext(ne)
              xx = 0.
              do ie = 1,ngext(je,ne)
                xx = xx  + mrgers(ie,je,ner)
              enddo
              do ie = 1,ngext(je,ne)
                xgers(ie,je,ner) = mrgers(ie,je,ner)/xx
              enddo
            enddo
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nsrt .gt. 0) then
c
c       Make sure that reactions for special reactants are charge
c       balanced.
c
        call chzrsr(cbsr,elecsr,eps100,jcode,nbasp,nbt,nbtmax,
     $  nbt1mx,noutpt,nrct,nrctmx,nrndex,nsrtmx,nstmax,nttyo,ureac,
     $  uspec,zchar)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any basis species in the matrix with jflag = 30 and
c     eliminate them from the matrix. Adjust as necessary the total
c     masses of those basis species which remain in the matrix.
c
      call combmb(cdrs,iindx1,ipndx1,jflag,kbt,kdim,km1,kmax,
     $ kmt,kx1,kxt,mtb,mtbaq,ndrsmx,nbasp,nbt,nbtmax,ndrs,ndrsr,
     $ noutpt,nstmax,nttyo,uspec,uzvec1,zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize the error counter.
c
      nerr = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Make sure that no mineral species in the equilibrium system (ES)
c     has been suppressed.
c
      do kcol = km1,kxt
        np = ipndx1(kcol)
        ns = iindx1(kcol)
        if (jsflag(ns) .gt. 0) then
c
c         Calling sequence substitutions:
c           uspec(ns) for unam48
c
          call fmspnm(jlen,uspec(ns),uspn56)
          write (noutpt,1350) uspn56(1:jlen)
          write (nttyo,1350) uspn56(1:jlen)
 1350     format(/' * Error - (EQ6/eq6) The species ',a," can't be",
     $    /7x,'suppressed because it is present in the equilibrium',
     $    ' system.')
          nerr = nerr + 1
        else
          jpflag(np) = -1
          jsflag(ns) = -1
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see that no species in the strict basis has a jflag
c     value of 30 at this point.
c
      do nb = 1,nbt
        ns = nbasp(nb)
        nt = ndrsr(2,ns) - ndrsr(1,ns) + 1
        if (nt .lt. 2) then
          if (jflag(ns) .eq. 30) then
            ux = uspec(ns)(1:24)
            j2 = ilnobl(ux)
            write (ux8,'(i5)') jflag(ns)
            call lejust(ux8)
            j3 = ilnobl(ux8)
            write (noutpt,1360) uspec(ns)(1:j2),ux8(1:j3)
            write (nttyo,1360) uspec(ns)(1:j2),ux8(1:j3)
 1360       format(/' * Error - (EQ6/eq6) The species ',a," can't have",
     $      /7x,'a jflag value of ',a,', because this species is in',
     $      ' the strict basis set.')
            nerr = nerr + 1
          endif
        endif
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Redefine the 'd' set of reactions and attendant data to
c     match the ordinary set as it presently exists. The ordinary
c     set will be futher subjected to eliminations from the active
c     basis set and ordinary basis switching.
c
      call cdrssd(adhfs,adhfsd,advfs,advfsd,axhfs,axhfsd,
     $ axlks,axlksd,axvfs,axvfsd,cdrs,cdrsd,ipch,ipchmx,ipcv,ipcvmx,
     $ narxmx,nbasp,nbaspd,nbtmax,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,
     $ nstmax,ntprmx)
      nbtd = nbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute affinity scaling factors. Note that these are
c     defined in terms of the reactions before any eliminations
c     or ordinary basis switches are made.
c
      call gafscl(cdrsd,cscale,ndrsmx,ndrsrd,nst,nstmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopg(1) .eq. 1) then
c
c       Build the S-lambda index arrays nsxi and nsxx.
c
        call bdslx(narn1,narn2,natmax,noutpt,nslt,nsltmx,
     $  nslx,nsxi,nsxx,nsxmax,nttyo)
c
c       Build the mu index arrays nmxi and nmxx.
c
        call bdmlx(narn1,narn2,natmax,nmut,nmutmx,nmux,nmxi,
     $  nmxmax,nmxx,noutpt,nttyo)
c
        if (iopr(10) .gt. 0) then
c
c         Write tables concerning Pitzer interaction coefficients.
c
          call ptztab(iopr,narn1,narn2,natmax,nmutmx,nmux,nmxi,
     $    nmxmax,nmxx,noprmx,noutpt,nsltmx,nslx,nstmax,nsxi,nsxmax,
     $    nsxx,uspec)
        endif
c
c       Print warnings for species lacking Pitzer coefficients.
c
        call ptzchk(narn1,narn2,natmax,nmxi,noutpt,nstmax,nsxi,
     $  nttyo,uspec)
c
c       Transform conventional mu data to corresponding C, psi,
c       and zeta data (data originally defined in mu form is
c       not affected).
c
cxxxxxxxxxxx
        if (qhawep) then
          call rc3ocf(amu,jpfcmx,ifcphi1,ifcphi2,ifnnn,ifn2n,
     $    ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,
     $    ilpsi2,ilzeta,iodb,nmux,nmut,nmutmx,nodbmx,noutpt,nstmax,
     $    nttyo,uspec,zchar)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the thermodynamic parameters that are functions of
c     temperature.
c
       call evdata(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,adbdtv,
     $ adh,adhfe,adhh,adhv,adhfs,adhfsd,advfe,advfs,advfsd,afcnst,
     $ al10,amu,aslm,aphi,aprehw,apresg,apresh,apx,avcnst,axhfe,
     $ axhfs,axhfsd,axlke,axlks,axlksd,axvfe,axvfs,axvfsd,bdh,bdhh,
     $ bdhv,bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,
     $ dhfe,dhfs,dhfsd,dvfe,dvfs,dvfsd,ehfac,farad,iapxmx,iktmax,
     $ iopg,iopt,ipbtmx,ipch,ipchmx,ipcv,ipcvmx,ixrn1,ixrn2,jpfcmx,
     $ jptffl,jsol,narxmx,narxt,narxth,ncmpr,nmut,nmutmx,nopgmx,
     $ noptmx,noutpt,nptmax,nslt,nsltmx,nst,nstmax,ntpr,ntprmx,nttyo,
     $ nxt,nxtmax,pmu,prehw,presg,presh,press,pslamn,rconst,rcnstv,
     $ rtcnst,tempc,tempk,uphase,uspec,wfac,xhfe,xhfs,xhfsd,xlke,xlks,
     $ xlksd,xvfe,xvfs,xvfsd)
c
c     Compute the rate parameters that are functions of temperature.
c
      call evratc(eact,hact,iact,imchmx,imech,nrct,nrctmx,nrk,
     $ rk,rkb,rtcnst,tempk,trkb)
c
      tempcd = tempc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check for thermodynamic pressure corrections.
c
      dp = press - presg
      if (abs(dp) .ge. 1.e-4) then
        if (ipcv .lt. 0) then
c
c         There are no data to support needed pressure corrections.
c
          write (noutpt,1370) press,presg,dp
          write (nttyo,1370) press,presg,dp
 1370     format(/' * Warning - (EQ6/eq6) The supporting data file',
     $    /7x,'contains no data to support making thermodynamic',
     $    /7x,'pressure corrections. No such corrections will be made.',
     $    /7x,'The current pressure is ',1pg12.5,' bars, the standard',
     $    /7x,'grid pressure is ',g12.5,' bars, and the pressure',
     $    /7x,'difference is ',g12.5,' bars.')
        else
c
c         Make pressure corrections to the thermodynamic data.
c
          call pcorrm(adh,adhh,adhv,al10,aphi,avcnst,bdh,bdhh,bdhv,
     $    bdot,bdoth,bdotv,dadhh,dadhv,dbdhh,dbdhv,dbdth,dbdtv,dhfe,
     $    dvfe,iopg,ipch,ipchmx,ipcv,ipcvmx,nopgmx,presg,press,rcnstv,
     $    tempk,xhfe,xlke,xvfe)
c
          call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $    nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $    xlks,xvfs)
c
c         Calling sequence substitutions:
c           dhfsd for dhfs
c           dvfsd for dvfs
c           nbaspd for nbasp
c           nbtd for nbt
c           ndrsrd for ndrsr
c           xhfsd for xhfs
c           xlksd for xlks
c           xvfsd for xvfs
c
          call pcorrx(avcnst,dhfsd,dvfsd,ipch,ipchmx,ipcv,ipcvmx,
     $    nbaspd,nbtd,nbtmax,ndrsrd,nst,nstmax,presg,press,xhfsd,
     $    xlksd,xvfsd)
        endif
      endif
c
      pressd = press
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      write (noutpt,1400)
 1400 format(//21x,'--- Inactive Species ---',/)
c
      k = 0
      klim = 20
      do ns = 1,nst
        if (jsflag(ns) .eq. 1) then
          if (ns .ne. no2gaq) then
            k = k + 1
            if (k .le. klim) then
c
c             Calling sequence substitutions:
c               uspec(ns) for unam48
c
              call fmspnm(jlen,uspec(ns),uspn56)
              write (noutpt,1410) uspn56(1:jlen)
 1410         format(4x,a)
            endif
          endif
        endif
      enddo
c
      if (k .gt. klim) then
        i = k - klim
        write (noutpt,1420) i
 1420   format(/6x,'plus ',i4,' others',/)
      elseif (k .le. 0) then
        write (noutpt,1430)
 1430   format(4x,'None',/)
      else
        write (noutpt,1440)
 1440   format(1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Call EQLIB/elim.f to rewrite the reaction equations (cdrs/ndrs/
c     ndrsr arrays) so that auxiliary basis variables with jflag = 30
c     are eliminated from the active basis set.
c
      qelim = .false.
      do nb = 1,nbt
        nse = nbasp(nb)
        nt = ndrsr(2,nse) - ndrsr(1,nse) + 1
        if (nt.ge.2 .and. jflag(nse).eq.30) then
          if (jsflag(nse) .gt. 0) then
            mtb(nb) = 0.
            mtbaq(nb) = 0.
          else
            qelim = .true.
            call elim(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jsflag,narxmx,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,
     $      nse,nst,nstmax,ntprmx,noutpt,nttyo,uspec)
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute mass balance coefficients using the active part of the
c     original basis set.
c
      call gcsts(cdrs,csts,jflag,nbaspd,nbt,nbtmax,ndrs,ndrsmx,
     $ ndrsr,noutpt,nsts,nstsmx,nstsr,nst,nstmax,nttyo,uspec)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Copy the existing nbasp array into the nbaspi array. The
c     main purpose of this is to recall what the basis set was
c     when mass balance relationships were defined. In particular,
c     this array holds the basis set as it was prior to the switching
c     out of bare exchangerspecies. This information will be used
c     in describing mass balance totals. In particular, it will be
c     needed to write the pickup file.
c
      do nb = 1,nbt
        nbaspi(nb) = nbasp(nb)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (net .gt. 0) then
c
c       Switch bare site species of generic ion exchange phases with
c       certain models such as Gapon and Vanselow out of the basis set.
c       Then suppress these bare site species so that they appear in the
c       model only in association with corresponding mass balances.
c       Changes are made here to the ion exchanger sections of both the
c       ordinary and the 'd' sets of reactions and associated data.
c
        call chsgex(adhfs,adhfsd,adhfsx,advfs,advfsd,advfsx,
     $  axhfs,axhfsd,axhfsx,axlks,axlksd,axlksx,axvfs,axvfsd,axvfsx,
     $  cdrs,cdrsd,cdrsx,eps100,iern1,ipch,ipchmx,ipcv,ipcvmx,jern1,
     $  jetmax,jflag,jgext,jsflag,narn1,narxmx,narxt,nbasp,nbaspd,
     $  nbaspx,nbt,nbtmax,nbw,ndrs,ndrsd,ndrsmx,ndrsr,ndrsrd,ndrsrx,
     $  ndrsx,nern1,nern2,net,netmax,ngext,noutpt,nphasx,nst,nstmax,
     $  ntprmx,ntprt,nttyo,qbassw,qbswok,ugexmo,uspec)
c
        do kcol = 1,kbt
          nb = iindx1(kcol)
          ns = nbasp(nb)
          if (ns.ge.nern1 .and. ns.le.nern2) uzvec1(kcol) = uspec(ns)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nsrt .gt. 0) then
c
c       Check the reactions for the special reactants. Rewrite these
c       reactions to eliminate any basis species for which jflag = 30.
c
        call ckfrsr(cbsr,csts,jcode,jflag,nbaspd,nbtd,nbtmax,
     $  nbt1mx,noutpt,nrct,nrctmx,nrndex,nsrtmx,nstmax,nsts,nstsmx,
     $  nstsr,nttyo,ureac,uspec)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(5) .gt. 0) then
c
c       Clear the ES solids read from the input file. Fictive
c       fugacity-fixing minerals are not cleared.
c
        write (noutpt,1470)
        write (nttyo,1470)
 1470   format(/' * Note (EQ6/eq6) Clearing equilibrium system',
     $  ' (ES) solids',/7x,'read from the input file.')
c
        call clress(csts,iindx1,ipndx1,jpflag,jsflag,kdim,kmax,
     $  km1,kmt,kx1,kxt,loph,losp,moph,mosp,mtb,mtbaq,nbt,nbtmax,
     $  nptmax,nstmax,nsts,nstsmx,nstsr,ufixf,uzvec1,zvec1,zvclg1)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Save the present configuration of the jflag array. This will
c     be used to support calculation of saturation indices and
c     affinities for the 'd' set of reactions.
c
      call copyia(jflag,jflagd,nbtmax)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Execute any ordinary basis switching directives from the input
c     file.
c
      kobswt = 0
      if (nobswt .gt. 0) then
c
c       Copy the existing nbasp set into the nbaspx array.
c
        call copyia(nbasp,nbaspx,nbt)
c
c       Interpret the switches.
c
        call intbsw(nbasp,nbaspx,nbt,nbtmax,nobswt,noutpt,nst,
     $  nstmax,nttyo,uobsw,uspec)
c
c       Execute the switches.
c
        do nb = 1,nbt
          ns1 = nbaspx(nb)
          ns2 = nbasp(nb)
          if (ns1 .ne. ns2) then
            call switch(adhfs,adhfsx,advfs,advfsx,axhfs,axhfsx,
     $      axlks,axlksx,axvfs,axvfsx,cdrs,cdrsx,eps100,ipch,ipchmx,
     $      ipcv,ipcvmx,jflag,jsflag,narn1,narxmx,nbasp,nbaspd,nbaspx,
     $      nb,nbt,nbtmax,nbw,ndrs,ndrsmx,ndrsx,ndrsr,ndrsrx,noutpt,
     $      ns2,nst,nstmax,ntprmx,nttyo,qbassw,qbswok,uspec)
            kobswt = kobswt + 1
          endif
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Put new fixed fugacity minerals into the matrix if the
c     corresponding added masses are positive. Keep old ones
c     in if the corresponding net masses are positive. If necessary,
c     recalculate the mass balance totals. Note: this call is
c     necessary even if nffg = 0, because it completes the
c     elimination of any fictive fugacity-fixing phases left over
c     from a previous run.
c
      call setffg(csts,iindx1,iffg,ipndx1,jpflag,jsflag,kbt,
     $ kdim,kmax,km1,kmt,kx1,kxt,losp,moffg,mtb,mtbaq,nbaspd,nbt,
     $ nbtmax,ncmpr,nffg,nffgmx,noutpt,nphasx,npt,nptmax,nstmax,
     $ nsts,nstsmx,nstsr,nttyo,qloffg,uffg,uspec,uzvec1,zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute equilibrium constants, etc., for the ordinary set
c     if the reactions have been modified by elimination of
c     auxiliary basis species or by basis switching. The presence
c     of generic ion exchangers (net > 0) implies intrinsic or
c     hidden basis switching.
c
      if (qelim .or. kobswt.gt.0 .or. net.gt.0) then
c
        call evdatr(adhfs,advfs,axhfs,axlks,axvfs,dhfs,dvfs,
     $  ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $  tempc,xhfs,xlks,xvfs)
c
        if (ipcv .ge. 0) then
          call pcorrx(avcnst,dhfs,dvfs,ipch,ipchmx,ipcv,ipcvmx,
     $    nbasp,nbt,nbtmax,ndrsr,nst,nstmax,presg,press,xhfs,
     $    xlks,xvfs)
        endif
      endif
      kobswt = 0
c
c     Recompute equilibrium constants, etc., for the 'd' set
c     if generic ion exchangers are present. If so, the subset
c     of the 'd' set reactions dealing with such exchangers
c     was modified above by the call to EQLIB/chsgex.f.
c
      if (net .gt. 0) then
c
c       Calling sequence substitutions:
c         adhfsd for adhfs
c         advfsd for advfs
c         axhfsd for axhfs
c         axlksd for axlks
c         axvfsd for avhfs
c         dhfsd for dhfs
c         dvfsd for dvfs
c         xhfsd for xhfs
c         xlksd for xlks
c         xvfsd for xvfs
c
        call evdatr(adhfsd,advfsd,axhfsd,axlksd,axvfsd,dhfsd,dvfsd,
     $  ipch,ipchmx,ipcv,ipcvmx,narxmx,narxt,nst,nstmax,ntpr,ntprmx,
     $  tempc,xhfsd,xlksd,xvfsd)
c
c       Calling sequence substitutions:
c         dhfsd for dhfs
c         dvfsd for dvfs
c         nbaspd for nbasp
c         nbtd for nbt
c         ndrsrd for ndrsr
c         xhfsd for xhfs
c         xlksd for xlks
c         xvfsd for xvfs
c
        if (ipcv .ge. 0) then
          call pcorrx(avcnst,dhfsd,dvfsd,ipch,ipchmx,ipcv,ipcvmx,
     $    nbaspd,nbtd,nbtmax,ndrsrd,nst,nstmax,presg,press,xhfsd,
     $    xlksd,xvfsd)
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopr(2) .ge. 1) then
c
c     Calling sequence substitutions:
c       noutpt for nf
c
        ilevel = iopr(2)
        call echolk(axlks,cdrs,ilevel,jsflag,narxmx,ndrs,ndrsmx,
     $  ndrsr,noutpt,nst,ntprmx,nstmax,press,tempc,uspec,xlks)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nrct .le. 0) go to 350
c
c     Process the input reactant data.
c
c     Get local indices of reactants, check their names, and set up
c     their molecular weights and molar volumes.
c
      call rsetup(atwt,cbsr,cesr,iern1,ietmax,iindx1,iktmax,
     $ jcode,jern1,jern2,jetmax,jgext,kbt,kmax,mwtges,mwtrc,mwtsp,
     $ nbaspd,nbt,nbtmax,nbt1mx,ncmpr,nct,nctmax,nertmx,netmax,ngext,
     $ noutpt,nptmax,nrct,nrctmx,nrndex,nsrtmx,nstmax,nsts,nstsmx,
     $ nstsr,nttyo,nxridx,nxrtmx,rxbar,ureac,uspec,vosp0,vreac,xgers)
c
c     Calculate surface area parameters.
c
      do nrc = 1,nrct
        gx = morr(nrc)*mwtrc(nrc)
        if (nsk(nrc).eq.0 .or. nsk(nrc).eq.2) then
c
c         Calculate the surface area (cm2) from the specific surface
c         area (cm2/g).
c
          ssfcar(nrc) = 0.
          if (gx .gt. 0.) ssfcar(nrc) = sfcar(nrc)/gx
        elseif (nsk(nrc) .eq. 1) then
c
c         Calculate the specific surface area (cm2/g) from the
c         surface area (cm2).
c
          sfcar(nrc) = ssfcar(nrc)*gx
        else
          j2 = ilnobl(ureac(nrc))
          write (noutpt,3110) nsk(nrc),ureac(nrc)(1:j2)
          write (nttyo,3110) nsk(nrc),ureac(nrc)(1:j2)
 3110     format(/' * Error - (EQ6/eq6) The surface area code nsk',
     $    /7x,'has an unrecognized value of ',i3,' for reactant',
     $    /7x,a,'.')
          nerr = nerr + 1
        endif
      enddo
c
c     Set backward/precipitation kinetics flag array, npchk.
c
      do nrc = 1,nrct
        if (nrk(2,nrc) .ne. 0) then
          if (jcode(nrc).eq.0 .or. jcode(nrc).eq.1) then
            do np = 1,npt
            if (ureac(nrc) .eq. uphase(np)) then
              npchk(np) = 1
              go to 300
            endif
            enddo
          endif
        endif
  300   continue
      enddo
c
c     Check names for activity terms in rate equations.
c
      do nrc = 1,nrct
c
        if (nrk(1,nrc) .eq. 2) then
          do i = 1,imech(1,nrc)
            if (ndact(i,1,nrc) .gt. 0) then
              do n = 1,ndact(i,1,nrc)
                unamsp = udac(n,i,1,nrc)
                do ns = 1,nst
                  if (unamsp(1:24) .eq. uspec(ns)(1:24)) go to 310
                enddo
                j3 = ilnobl(unamsp)
                j2 = ilnobl(ureac(nrc))
                write (noutpt,1500) unamsp(1:j3),ureac(nrc)(1:j2)
                write (nttyo,1500) unamsp(1:j3),ureac(nrc)(1:j2)
 1500           format(/" * Error - (EQ6/eq6) Can't match the species",
     $          /7x,'name "',a,'" appearing in the rate law for',
     $          /7x,'with any species present in the model system.')
                nerr = nerr + 1
  310           ndac(n,i,1,nrc) = ns
              enddo
            endif
          enddo
        endif
c
        if (nrk(2,nrc) .eq. 2) then
          do i = 1,imech(2,nrc)
            if (ndact(i,2,nrc) .gt. 0) then
              do n = 1,ndact(i,2,nrc)
                unamsp = udac(n,i,2,nrc)
                do ns = 1,nst
                  if (unamsp(1:24) .eq. uspec(ns)(1:24)) go to 320
                enddo
                j3 = ilnobl(unamsp)
                j2 = ilnobl(ureac(nrc))
                write (noutpt,1500) unamsp(1:j3),ureac(nrc)(1:j2)
                write (noutpt,1500) unamsp(1:j3),ureac(nrc)(1:j2)
                nerr = nerr + 1
  320           ndac(n,i,2,nrc) = ns
              enddo
            endif
          enddo
        endif
c
      enddo
c
      if (nerr .gt. 0) stop
c
  350 continue
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Initialize non-aqueous phases in the physically removed system
c     (PRS).
c
      if (nprpti .gt. 0) then
        nerr = 0
        npi = 0
        unamph = ' '
        do nsi = 1,nprsti
          unamsp(1:24) = uprspi(nsi)(1:24)
          if (unamph(1:24) .ne. uprspi(nsi)(25:48)) then
c
c           Have found another phase.
c
            npi = npi + 1
            unamph(1:24) = uprphi(npi)(1:24)
            do np = 1,npt
              if (unamph(1:24) .eq. uphase(np)(1:24)) go to 370
            enddo
c
            j2 = ilnobl(unamph)
            write (noutpt,1530) unamph(1:j2)
            write (nttyo,1530) unamph(1:j2)
 1530       format(/' * Error - (EQ6/eq6) The phase ',a,' is listed',
     $      /7x,'as present in the physically removed system (PRS)',
     $      ' on the input file,',/7x,"but it isn't in the data file",
     $      ' set (after compression).',/7x,'You may be using the',
     $      ' wrong data file.')
            nerr = nerr + 1
            go to 380
c
  370       mprph(np) = mprphi(npi)
            nr1 = ncmpr(1,np)
            nr2 = ncmpr(2,np)
            do ns = nr1,nr2
              if (unamsp(1:24) .eq. uspec(ns)(1:24)) then
                mprsp(ns) = mprspi(nsi)
                go to 380
              endif
            enddo
c
            j2 = ilnobl(unamph)
            j3 = ilnobl(unamsp)
            write (noutpt,1540) unamsp(1:j3),unamph(1:j2)
            write (nttyo,1540) unamsp(1:j3),unamph(1:j2)
 1540       format(/' * Error - (EQ6/eq6) The species ',a,' of phase',
     $      /7x,a,' is listed as present in the physically removed',
     $      /7x,'system (PRS) on the input file, but this species',
     $      " isn't in the",/7x,'data file set (after compression).',
     $      ' You may be using the wrong',/7x,'data file.')
            nerr = nerr + 1
c
          else
c
c           Have found another species belonging to the same phase.
c
            do ns = nr1,nr2
              if (unamsp(1:24) .eq. uspec(ns)(1:24)) then
                mprsp(ns) = mprspi(nsi)
                go to 380
              endif
            enddo
c
            j2 = ilnobl(unamph)
            j3 = ilnobl(unamsp)
            write (noutpt,1540) unamsp(1:j3),unamph(1:j2)
            write (nttyo,1540) unamsp(1:j3),unamph(1:j2)
            nerr = nerr + 1
          endif
  380     continue
        enddo
c
        if (nerr .gt. 0) stop
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(9) .gt. 0) then
c
c       Clear the PRS solids read from the input file.
c
        write (noutpt,1570)
        write (nttyo,1570)
 1570   format(/' * Note (EQ6/eq6) Clearing physically removed',
     $  ' system (PRS) solids',/7x,'read from the input file.')
        call initaz(mprsp,nstmax)
        call initaz(mprph,nptmax)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Write an echo of the input problem, including defaults, on
c     the output file.
c
      call echoz(axlks,awmaxi,awmini,azero,cbsr,cdac,cdrs,
     $ cesr,csigma,dlaplo,dlaprn,dleplo,dleprn,dlhplo,dlhprn,
     $ dloplo,dloprn,dltpll,dltplo,dltprl,dltprn,dlxdmp,dlxmax,
     $ dlxmx0,dlxpll,dlxplo,dlxprl,dlxprn,eact,ehmaxi,ehmini,iktmax,
     $ imchmx,imech,iodb,iopg,iopr,iopt,itermx,jcode,jpress,jtemp,
     $ jsflag,ksplmx,ksppmx,kstpmx,kxmod,mwtrc,narn1,narn2,narxmx,
     $ nat,nata,natmax,nbaspd,nbt,nbta,nbtd,nbtmax,nbt1mx,ncmpr,nct,
     $ ncta,nctmax,ndact,ndctmx,ndrs,ndrsmx,ndrsr,nffgmx,ngt,ngta,
     $ ngtmax,nlt,nlta,nltmax,nmt,nmta,nmtmax,nodbmx,nopgmx,noprmx,
     $ noptmx,nordmx,noutpt,npslmx,npt,npta,nptkmx,nptmax,nrct,nrctmx,
     $ nrk,nrndex,nsk,nsrt,nsrtmx,nsscmx,nsslmx,nst,nsta,nstmax,ntprmx,
     $ ntrymx,nttkmx,nttyo,nxmdmx,nxmod,nxopmx,nxopex,nxopt,nxpemx,
     $ nxridx,nxrt,nxrtmx,nxt,nxta,nxtmax,o2maxi,o2mini,phmaxi,
     $ phmini,press,pressb,ptk,qredox,rkb,rxbar,sscrew,tempc,tempcb,
     $ tempk,timmxi,tistti,tolbt,toldl,tolsat,tolsst,tolxsf,tolxst,
     $ tolxsu,trkb,ttk,uactop,udac,uelem,uffg,ureac,uspec,uxcat,uxmod,
     $ uxopex,uxopt,vreac,xistti,ximaxi,xlkmod,xlks,zkfac,zklgmn,
     $ zklogl,zklogu)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Roll over the main title to the secondary title.
c
      ntitl2 = ntitl1
      do n = 1,ntitl1
        utitl2(n) = utitl1(n)
      enddo
c
      if (utitl1(1)(7:37) .ne. 'This main title is a carry-over') then
        if (ntitl1 .lt. ntitmx) then
          do n = ntitl1,1,-1
            utitl1(n + 1) = utitl1(n)
          enddo
          utitl1(1) =
     $    'Note: This main title is a carry-over from a previous run.'
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qcwrpj) then
c
c       Write tables of the Pitzer J(x) and J'(x) functions.
c
        call cwrpjt(noutpt)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Trace the reaction path.
c
      call path(aadh,aadhh,aadhv,aaphi,abdh,abdhh,abdhv,
     $ abdot,abdoth,abdotv,adadhh,adadhv,adbdhh,adbdhv,adbdth,
     $ adbdtv,adh,adhh,adhv,afcnst,aftarg,al10,aphi,apx,atwt,
     $ avcnst,awmax,awmaxi,awmin,awmini,azero,bdh,bdhh,bdhv,bdot,
     $ bdoth,bdotv,bpx,cbsr,cbsri,cco2,cdac,cdrs,cdrsd,cdrsx,
     $ cegexs,cesr,cesri,cess,cpgexs,cscale,csigma,csts,dadhh,
     $ dadhv,dbdhh,dbdhv,dbdth,dbdtv,dlaplo,dlaprn,dleplo,dleprn,
     $ dlhplo,dlhprn,dloplo,dloprn,dltplo,dltpll,dltprl,dltprn,
     $ dlxdmp,dlxmax,dlxmin,dlxmx0,dlxplo,dlxpll,dlxprl,dlxprn,
     $ eact,egers,egersi,egexjf,ehfac,ehmax,ehmaxi,ehmin,ehmini,
     $ elecsr,electr,eps100,farad,fkrc,hact,iact,iapxt,iaqsln,
     $ ibpxt,ibsrti,ielam,iern1,iern2,iesrti,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifrn1,ifrn2,ifzeta,igas,igerti,
     $ iindx1,ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilrn1,
     $ ilrn2,ilzeta,imech,imrn1,imrn2,insgf,iodb,iopg,iopr,iopt,
     $ ipch,ipndx1,ipcv,irang,itermx,ixrn1,ixrn2,ixrti,izmax,
     $ jcode,jffg,jflag,jflagd,jflgi,jgerti,jpflag,jpress,jptffl,
     $ jreac,jsflag,jsitex,jsol,jtemp,kbt,kct,kdim,kelect,khydr,
     $ khydx,km1,kmt,ko2gaq,kprs,krdxsp,ksplmx,ksppmx,kstpmx,kwater,
     $ kxmod,kx1,kxt,loph,losp,modr,moffg,moph,morr,mosp,mprph,
     $ mprphi,mprsp,mprspi,mrgers,mrgexs,mtb,mtbi,mtbaq,mtbaqi,
     $ mte,mteaq,mwtrc,mwtsp,narn1,narn2,narxt,nat,nbasp,nbaspd,
     $ nbaspi,nbaspx,nbkupa,nbkupb,nbt,nbtd,nbti,nbw,nchlor,
     $ ncmpr,nct,ndac,ndact,nelect,nern1,nern2,ness,nessr,net,
     $ ndrs,ndrsd,ndrsx,ndrsr,ndrsrd,ndrsrx,nert,newin,nffg,
     $ nfrn1,nfrn2,ngrn1,ngrn2,ngt,nhydr,nhydx,nllnmx,nlrn1,
     $ nlrn2,nlt,nmrn1,nmrn2,nmrt,nmt,nobswt,noutpt,no2gaq,npchk,
     $ nphasx,nprob,nprpti,nprsti,npslmx,npt,nrct,nrdxsp,nrk,
     $ nrndex,nsbswt,nsk,nsrt,nsslmx,nst,nsts,nstsr,ntabx,ntf1,
     $ ntf1t,ntf2,ntf2t,ntitl1,ntitl2,ntitld,ntpr,ntprt,ntrymx,
     $ nttyo,nxmod,nxopex,nxopt,nxridx,nxrn1,nxrn2,nxrt,nxt,o2max,
     $ o2maxi,o2min,o2mini,phmax,phmaxi,phmin,phmini,prcinf,
     $ press,pressb,pressd,pressi,ptk,qcnpre,qcntmp,qdwipp,
     $ qecon,qgexsh,qhawep,qoptmz,qpit75,qredox,qscon,qtatxt,
     $ rconst,rcnstv,rk,rkb,rtcnst,rxbar,rxbari,sfcar,smp100,
     $ sscrew,ssfcar,tempc,tempcb,tempcd,tempci,tempcu,tempk,
     $ tf1,tf2,timemx,time1,timmxi,tistrt,tistti,trkb,ttk,tolaft,
     $ tolbt,toldl,tolsat,tolsst,tolxsf,tolxst,tolxsu,uaqsln,
     $ ubmtbi,ubsri,ucxri,udac,uelem,uesri,uffg,ufixf,ugerji,
     $ ugermo,ugersi,uinfor,ulinex,uobsw,uphase,uplatm,uprphi,
     $ uprspi,ureac,usbsw,uspec,usteq6,utitl1,utitl2,utitld,
     $ uveeq6,uxcat,uxmod,uxopex,uxopt,uzvec1,uzveci,vosp0,vreac,
     $ wfac,xgers,xgersi,ximax,ximaxi,xistrt,xistti,xi1,xlkffg,
     $ xlkmod,zchar,zchcu6,zchsq2,zklgmn,zklogl,zklogu,zvclgi,
     $ zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Descramble the tabx file onto the scratch tab file, then copy
c     the scratch tab file onto the tab file.
c
      if (iopt(18) .ge. 0) then
        if (qtatxt) then
c
c         The TAB file is an ordinary text file.
c
c         Calling sequence substitutions:
c           ntabx for nf1
c           ntabs for nf2
c
          call dscrax(ntabx,ntabs,nllnmx,ulinex)
c
c         Calling sequence substitutions:
c           ntabs for nf1
c           ntab for nf2
c
          call fcopyx(ntabs,ntab,nllnmx,ulinex)
c
        else
c
c         The TAB file is a .csv file.
c
          call dscramc(ntabx,ntabs,nllnmx,ulinex)
c
c         Calling sequence substitutions:
c           ntabs for nf1
c           ntab for nf2
c
          call fcopyx(ntabs,ntab,nllnmx,ulinex)
        endif
      endif
c
      go to 20
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine initii(iarray,nmax)
c
c     This subroutine initializes each element of the integer array
c     iarray its index value over the first nmax positions. Normally,
c     nmax would be the dimension of the 1D iarray. However, nmax could
c     be less than the true dimension. Also, iarray could actually have
c     more than one dimension. For example, if the array is really ib,
c     which has dimensions of i1 and i2, this subroutine could be used
c     by calling it in the following manner: call initii(ib,(i1*i2)).
c     Use this subroutine with caution if nmax is not the product of the
c     true (declared) dimensions.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       iarray = the array
c       nmax   = dimension or pseudo-dimension of iarray
c
c     Output:
c
c       iarray = iarray, with the first nmax positions set to the
c                  corresponding index values
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      integer iarray(nmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft
c
c-----------------------------------------------------------------------
c
c     Note that the loop is unrolled.
c
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        iarray(i) = i
        iarray(i + 1) = i + 1
        iarray(i + 2) = i + 2
        iarray(i + 3) = i + 3
        iarray(i + 4) = i + 4
        iarray(i + 5) = i + 5
        iarray(i + 6) = i + 6
        iarray(i + 7) = i + 7
      enddo
c
      do i = ileft + 1,nmax
        iarray(i) = i
      enddo
c
      end

      subroutine intbs3(covali,ier,jflag,jflgi,narn1a,narn2a,nbaspd,
     $ nbtd,nbti,nbtmax,ndrsrd,ndecsp,noutpt,nrdxsp,nsta,nstmax,
     $ nttyo,uspeca,uspeci)
c
c     This subroutine interprets the basis species listed on the input
c     file. It sets up the jflag arrays.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer jflag(nstmax),jflgi(nbtmax),nbaspd(nbtmax),
     $ ndecsp(nbtmax),ndrsrd(2,nstmax)
c
      integer ier,narn1a,narn2a,nbtd,nbti,noutpt,nrdxsp,nsta,nt,nttyo
c
      character(len=48) uspeca(nstmax),uspeci(nbtmax)
c
      real(8) covali(nbtmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j2,nb,nbi,ns
c
      integer ilnobl,nbasis
c
c-----------------------------------------------------------------------
c
      ier = 0
c
      do ns = 1,nsta
        jflag(ns) = 0
      enddo
c
      do ns = narn1a,narn2a
        jflag(ns) = 30
      enddo
c
      do nb = 1,nbtd
        ns = nbaspd(nb)
        nt = ndrsrd(2,ns) - ndrsrd(1,ns) + 1
        if (nt .lt. 2) jflag(ns) = -1
      enddo
c
      jflag(narn1a) = 0
      if (nrdxsp .gt. 0) jflag(nrdxsp) = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do nbi = 1,nbti
        j2 = ilnobl(uspeci(nbi)(1:24))
        do ns = 1,nsta
          if (uspeca(ns)(1:24) .eq. uspeci(nbi)(1:24)) then
            if (ndecsp(nbi) .gt. 0) then
              write (noutpt,1000) uspeci(nbi)(1:j2)
              write (nttyo,1000) uspeci(nbi)(1:j2)
 1000         format(/' * Error - (EQ3NR/intbs3) More than one',
     $        ' constraint was specified',/7x,'on the input file for',
     $        /7x,'the species ',a,'.')
              ier = ier + 1
            else
              if (jflgi(nbi).le.15 .and. covali(nbi).le.0.)
     $        jflgi(nbi) = -1
              jflag(ns) = jflgi(nbi)
c
c             Calling sequence substitutions:
c               nbaspd for nbasp
c               nbtd for nbt
c
              nb = nbasis(nbaspd,nbtd,nbtmax,ns)
              if (nb .eq. 0) then
c
c               Add a species to the working basis set.
c
                nbtd = nbtd + 1
                if (nbtd .gt. nbtmax) then
                  write (noutpt,1005) nbtmax,uspeci(nbi)(1:j2)
                  write (nttyo,1005) nbtmax,uspeci(nbi)(1:j2)
 1005             format(/' * Error - (EQ3NR/intbs3) The maximum ',i7,
     $            ' basis species have been exceeded',/7x,'while',
     $            ' trying to load ',a,'. Increase the dimensioning',
     $            /7x,'parameter nbtpar.')
                  ier = ier + 1
                  go to 115
                endif
                nb = nbtd
                nbaspd(nb) = ns
              endif
              ndecsp(nbi) = nb
            endif
            go to 115
          endif
        enddo
c
        write (noutpt,1010) uspeci(nbi)(1:j2)
        write (nttyo,1010) uspeci(nbi)(1:j2)
 1010   format(/' * Error - (EQ3NR/intbs3) The species ',a,' is',
     $  /7x,"on the input file, but it isn't on the supporting",
     $  ' data file.')
        ier = ier + 1
c
  115   continue
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine bdmlx(narn1,narn2,natmax,nmut,nmutmx,nmux,nmxi,
     $ nmxmax,nmxx,noutpt,nttyo)
c
c     This subroutine builds the nmxi and nmxx arrays. These are
c     pointer arrays used in connection with the mu parts of
c     Pitzer's equations.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       narn1  = start of range of aqueous species
c       narn2  = end of range of aqueous species
c       natmax = the maximum number of aqeuous species
c       nmux   = array of aqueous species indices defining triplets
c                  of species for which mu data are present
c       nmutmx = the maximum number of triplets of aqueous species
c                  for which Pitzer interaction parameters are
c                  defined; the second dimension of the nmux array
c       nmxmax = the second dimension of the nmxx pointer array
c
c     Principal output:
c
c       nmxi   = range pointer array into the nmxx array:
c                  nmxi(1,na) and nmxi(2,na) are the first and last
c                  values of the second subscript (nmx) of the nmxx
c                  array for entries pertaining to the na-th
c                  aqueous species (ns-th species)
c       nmxx   = pointer array:
c                  nmxx(1,nmx) = the species index of the second
c                  species in the nmu-th triplet, nmxx(2,nmx) is the
c                  species index of the third species, and
c                  nmxx(3,nmx) = nmu
c
c     Note: the usage of the nmxi and nmxx arrays is illustrated by
c     the following pseudo-code to evaluate SUM(jk) mu(ijk)m(j)m(k),
c     where i, j, and k are species indices and na is the aqueous
c     species index of the i-th species:
c
c       sum = 0.
c       i = na + narn1 - 1
c       do nmx = nmxi(1,na),nmxi(2,na)
c         j = nmxx(1,nmx)
c         k = nmxx(2,nmx)
c         nmu = nmxx(3,nmx)
c         sum = sum + mu(nmu)*m(j)*m(k)
c       enddo
c       sum = 2.*sum
c
c     This sum is actually evaluated in EQLIBG/gmdsm.f.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer natmax,nmutmx,nmxmax
c
      integer nmux(3,nmutmx),nmxi(2,natmax),nmxx(3,nmxmax)
c
      integer narn1,narn2,nmut,noutpt,nttyo
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer n,na,nmu,nmx,ns
c
c-----------------------------------------------------------------------
c
      nmx = 1
c
c     The following loop assumes that water is the narn1-th species.
c
      do ns = narn1 + 1,narn2
c
        na = ns - narn1 + 1
c
c       Set the beginning of the range for the current species.
c
        nmxi(1,na) = nmx
c
c       Search column 1 of the nmux array for the na-th aqueous species.
c
        do nmu = 1,nmut
          if (nmux(1,nmu) .eq. ns) then
c
c           Found one. Get the other two aqueous species indices and the
c           nmx index of the triplet.
c
            nmxx(1,nmx) = nmux(2,nmu)
            nmxx(2,nmx) = nmux(3,nmu)
            nmxx(3,nmx) = nmu
            nmx = nmx + 1
            if (nmx .gt. nmxmax) then
              n = 3*nmxmax
              write (noutpt,1010) nmxmax,n
              write (nttyo,1010) nmxmax,n
 1010         format(/' * Error - (EQLIBG/bdmlx) Have overflow of the',
     $        /7x,'mu pointer array nmxx. Increase the dimensioning',
     $        /7x,'parameter nmxpar from ',i5,' to no more than ',
     $        i5,'.')
              stop
            endif
          endif
        enddo
c
c       Search column 2.
c
        do nmu = 1,nmut
          if (nmux(2,nmu) .eq. ns) then
c
c           Found one. Skip if the same species is also in the first
c           column.
c
            if (ns .ne. nmux(1,nmu)) then
              nmxx(1,nmx) = nmux(1,nmu)
              nmxx(2,nmx) = nmux(3,nmu)
              nmxx(3,nmx) = nmu
              nmx = nmx + 1
              if (nmx .gt. nmxmax) then
                n = 3*nmxmax
                write (noutpt,1010) nmxmax,n
                write (nttyo,1010) nmxmax,n
                stop
              endif
            endif
          endif
        enddo
c
c       Search column 3.
c
        do nmu = 1,nmut
          if (nmux(3,nmu) .eq. ns) then
c
c           Found one. Skip if the species is also in column 1 or
c           column 2.
c
            if (ns.ne.nmux(1,nmu) .and. ns.ne.nmux(2,nmu)) then
              nmxx(1,nmx) = nmux(1,nmu)
              nmxx(2,nmx) = nmux(2,nmu)
              nmxx(3,nmx) = nmu
              nmx = nmx + 1
              if (nmx .gt. nmxmax) then
                n = 3*nmxmax
                write (noutpt,1010) nmxmax,n
                write (nttyo,1010) nmxmax,n
              stop
            endif
          endif
        endif
        enddo
c
c       Set the end of the range for the current species.
c
        nmxi(2,na) = nmx - 1
      enddo
c
      end

      subroutine gpj0(dpj0,d2pj0,pj0,x)
c
c     This subroutine evaluates the function J0(x) (pj0) and its
c     first and second derivatives with respect to x (dpj0 and
c     d2pj0). The evaluation here uses an approximation given by
c     Pitzer (1975, eq. 47). Most modern usage of Pitzer's equations
c     is consistent with the later approximation of Harvie (1981).
c
c     These functions are used to compute E-lambda and E-theta
c     coefficients and their derivatives with respect to ionic
c     strength. They describe the higher-order electrostatic effects
c     in Pitzer's equations.
c
c     It is important to note that the tabulation of J(x) and J'(x)
c     in Table II of Pitzer (1975) is not for the approximation
c     represented by eq. 47. Pitzer (1975) does not provide such a
c     table for the eq. 47 approximation.
c
c                            References
c
c     Harvie, C. E. 1981. Theoretical Investigations in Geochemistry
c       and Atom Surface Scattering. Ph.D. dissertation, University
c       of California, San Diego (Available as #8203026 from
c       University Microfilms International, Ann Arbor, Michigan).
c
c     Pitzer, K.S. 1975. Thermodynamics of electrolytes. V. Effects
c       of higher-order electrostatic terms. Journal of Solution
c       Chemistry, v. 4, p. 249-265.
c
c     This subroutine is called by:
c
c       EQLIBG/elmdd.f
c       EQLIBG/cwrpjt.f
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       x      = independent variable
c
c     Output:
c
c       dpj0   = the derivative dJ0(x)/dx
c       d2pj0  = the derivative d2 J0(x)/dx2
c       pj0    = the function J0(x)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      real(8) dpj0,d2pj0,pj0,x
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      real(8) alx,bk2,bk3,c1,c2,c3,c4,xc2,c3xc4,ec3xc4,t,xc2p
c
c-----------------------------------------------------------------------
c
c     These parameters are those for eq. 47 given in Table III of
c     Pitzer (1975).
c
      data c1,c2,c3,c4 /4.581,0.7237,0.0120,0.528/
c
c-----------------------------------------------------------------------
c
      pj0 = 0.
      dpj0 = 0.
      d2pj0 = 0.
c
      if (x .le. 0.) go to 999
c
      alx = log(x)
c
      xc2 = exp(-c2 * alx)
      c3xc4 = c3*exp(c4 * alx)
      ec3xc4 = exp(-c3xc4)
c
      pj0 = x / (4. + c1*xc2*ec3xc4)
c
      t = c4*c3xc4
      xc2p = exp((-c2 - 1.)*alx)
      bk2 = c1*xc2p *(c2 + t)*ec3xc4
c
      dpj0 = (pj0 / x)*(1. + pj0*bk2)
c
      bk3 = (t/x)*((c4 / (c2 + t)) - (c2 + 1.) / t)
      d2pj0 = ((dpj0 / pj0) - 1. / x)*(2.*dpj0 + pj0*bk3)
c
  999 continue
      end

      subroutine evratc(eact,hact,iact,imchmx,imech,nrct,nrctmx,nrk,
     $ rk,rkb,rtcnst,tempk,trkb)
c
c     This subroutine evaluates rate constants as functions of
c     temperature. There are two alternative treatments. One assumes
c     a constant activation energy. The other assumes a constant
c     activation enthalpy.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c       EQ6/tpadv.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer imchmx,nrctmx
c
      integer iact(imchmx,2,nrctmx),imech(2,nrctmx),nrk(2,nrctmx)
c
      integer nrct
c
      real*8 eact(imchmx,2,nrctmx),hact(imchmx,2,nrctmx),
     $ rk(imchmx,2,nrctmx),rkb(imchmx,2,nrctmx),trkb(imchmx,2,nrctmx)
c
      real*8 rtcnst,tempk
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,nrc
c
      real*8 tfx,tk1
c
c-----------------------------------------------------------------------
c
      do nrc = 1,nrct
c
c       Forward rate laws (forward equates to dissolution,
c       dissociation, or other means of destruction).
c
        if (nrk(1,nrc) .ge. 1) then
          do i = 1,imech(1,nrc)
            if (iact(i,1,nrc) .eq. 0) then
c
c             No temperature dependence.
c
              rk(i,1,nrc) = rkb(i,1,nrc)
            elseif (iact(i,1,nrc) .eq. 1) then
c
c             Constant activation energy.
c
              tk1 = trkb(i,1,nrc) + 273.15
              tfx = (eact(i,1,nrc)/rtcnst) * ((tempk/tk1) - 1.)
              rk(i,1,nrc) = rkb(i,1,nrc)*exp(tfx)
            elseif (iact(i,1,nrc) .eq. 2) then
c
c             Constant activation enthalpy.
c
              tk1 = trkb(i,1,nrc) + 273.15
              tfx = (hact(i,1,nrc)/rtcnst) * ((tempk/tk1) - 1.)
              rk(i,1,nrc) = rkb(i,1,nrc)*(tempk/tk1)*exp(tfx)
            endif
          enddo
        endif
c
c       Backward rate laws (backward equates to precipitation,
c       association, or other means of formation).
c
        if (nrk(2,nrc) .ge. 1) then
          do i = 1,imech(2,nrc)
            if (iact(i,2,nrc) .eq. 0) then
c
c             No temperature dependence.
c
              rk(i,2,nrc) = rkb(i,2,nrc)
            elseif (iact(i,2,nrc) .eq. 1) then
c
c             Constant activation energy.
c
              tk1 = trkb(i,2,nrc) + 273.15
              tfx = (eact(i,2,nrc)/rtcnst) * ((tempk/tk1) - 1.)
              rk(i,2,nrc) = rkb(i,2,nrc)*exp(tfx)
            elseif (iact(i,2,nrc) .eq. 2) then
c
c             Constant activation enthalpy.
c
              tk1 = trkb(i,2,nrc) + 273.15
              tfx = (hact(i,2,nrc)/rtcnst) * ((tempk/tk1) - 1.)
              rk(i,2,nrc) = rkb(i,2,nrc)*(tempk/tk1)*exp(tfx)
            endif
          enddo
        endif
      enddo
c
      end

      subroutine prtvpa(abar,acfw,acfwlg,actw,actwlg,a3bar,fje,
     $ fjest,fo2,fo2lg,fxi,fxist,iopg,mlmrra,mrmlra,nopgmx,noutpt,
     $ osc,oscst,qrho,rhoc,rhowc,sigmam,sigmst,tdsglw,tdspkc,
     $ tdsplc,vosol,wfh2o,wftds,woh2o,wosol,wotds,xbarw,xbrwlg)
c
c     This subroutine prints a table of various aqueous solution
c     parameters.
c
c     This subroutine is called by:
c
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       abar   = average hard core diameter
c       acfw   = activity coefficient of water
c       acfwlg = log activity coefficient of water
c       actw   = activity of water
c       actwlg = log activity of water
c       a3bar  = average cubed hard core diameter
c       fje    = the ionic asymmetry (the 3rd-order electrostatic
c                  moment function J)
c       fjest  = stoichiometric ionic asymmetry
c       fo2    = oxygen fugacity
c       fo2lg  = log oxygen fugacity
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c       fxist  = stoichiometric ionic strength
c       mlmrra = molality/molarity ratio
c       mrmlra = molarity/molality ratio
c       osc    = osmotic coefficient
c       oscst  = stoichiometric osmotic coefficient
c       qrho   = .true. if a solution density value is available
c       rhoc   = the solution density (g/mL)
c       rhowc  = the solution density (g/L)
c       sigmam = sum of solute molalities
c       sigmst = sum of stoichiometric solute molalities
c       tdsglw = TDS (total dissolved solutes) (g/L)
c       tdspkc = TDS (total dissolved solutes) (mg/kg.sol)
c       tdsplc = TDS (total dissolved solutes) (mg/L)
c       vosol  = Volume (L) of aqueous solution
c       wfh2o  = weight (mass) fraction of water in aqueous solution
c       wftds  = weight (mass) fraction of solutes in aqueous solution
c       woh2o  = weight (mass) of solvent water
c       wosol  = weight (mass) of aqueous solution
c       wotds  = weight (mass) of total dissolved solutes
c       xbarw  = mole fraction of water in aqueous solution
c       xbrwlg = log mole fraction of water in aqueous solution
c
c     Principal output:
c
c       None
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nopgmx
c
      integer noutpt
c
      integer iopg(nopgmx)
c
      logical qrho
c
      real(8) abar,acfw,acfwlg,actw,actwlg,a3bar,fje,fjest,fo2,fo2lg,
     $ fxi,fxist,osc,oscst,sigmam,sigmst,vosol,wfh2o,wftds,woh2o,wosol,
     $ wotds,xbarw,xbrwlg
c
      real(8) mlmrra,mrmlra,rhoc,rhowc,tdsglw,tdspkc,tdsplc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j1,j2,j3
c
      integer ilnobl
c
      character(len=16) ux16a,ux16b,ux16c
c
c-----------------------------------------------------------------------
c
      if (fo2lg .gt. -99999.) then
        write (ux16a,'(1pg12.5)') fo2
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (ux16b,'(1pg12.5)') fo2lg
        call lejust(ux16b)
        j2 = ilnobl(ux16b)
        write (noutpt,1000) ux16a(1:j1),ux16b(1:j2)
 1000   format(//20x,'Oxygen fugacity= ',a,' bars',
     $ /16x,'Log oxygen fugacity= ',a)
      else
        write (noutpt,1010)
 1010   format(/8x,'Oxygen fugacity is not defined.')
      endif
c
      write (ux16a,'(1pg12.5)') actw
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') actwlg
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1020) ux16a(1:j1),ux16b(1:j2)
 1020 format(/18x,'Activity of water= ',a,
     $ /14x,'Log activity of water= ',a)
c
      write (ux16a,'(1pg12.5)') xbarw
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') xbrwlg
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1030) ux16a(1:j1),ux16b(1:j2)
 1030 format(/13x,'Mole fraction of water= ',a,
     $ /9x,'Log mole fraction of water= ',a)
c
      write (ux16a,'(1pg12.5)') acfw
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') acfwlg
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1040) ux16a(1:j1),ux16b(1:j2)
 1040 format(/6x,'Activity coefficient of water= ',a,
     $ /2x,'Log activity coefficient of water= ',a)
c
      write (ux16a,'(1pg12.5)') osc
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') oscst
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1050) ux16a(1:j1),ux16b(1:j2)
 1050 format(/16x,'Osmotic coefficient= ',a,
     $ /1x,'Stoichiometric osmotic coefficient= ',a)
c
      write (ux16a,'(1pg12.5)') sigmam
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') sigmst
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1060) ux16a(1:j1),ux16b(1:j2)
 1060 format(/18x,'Sum of molalities= ',a,
     $ /3x,'Sum of stoichiometric molalities= ',a)
c
      write (ux16a,'(1pg12.5)') fxi
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') fxist
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1070) ux16a(1:j1),ux16b(1:j2)
 1070 format(/17x,'Ionic strength (I)= ',a,' molal',
     $ /6x,'Stoichiometric ionic strength= ',a,' molal')
c
      write (ux16a,'(1pg12.5)') fje
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') fjest
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1080) ux16a(1:j1),ux16b(1:j2)
 1080 format(/16x,'Ionic asymmetry (J)= ',a,' molal',
     $ /5x,'Stoichiometric ionic asymmetry= ',a,' molal')
c
      if (iopg(1) .eq. 2) then
        write (ux16a,'(1pg12.5)') abar
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (ux16b,'(1pg12.5)') a3bar
        call lejust(ux16b)
        j2 = ilnobl(ux16b)
        write (noutpt,1090) ux16a(1:j1),ux16b(1:j2)
 1090   format(/31x,'Abar = ',a,/30x,'A3bar = ',a)
      endif
c
      write (ux16a,'(1pg12.5)') woh2o
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') wotds
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (ux16c,'(1pg12.5)') wosol
      call lejust(ux16c)
      j3 = ilnobl(ux16c)
      write (noutpt,1100) ux16a(1:j1),ux16b(1:j2),ux16c(1:j3)
 1100 format(/23x,'Solvent mass= ',a,' g',
     $ /17x,'Solutes (TDS) mass= ',a,' g',
     $ /14x,'Aqueous solution mass= ',a,' g')
c
      if (qrho) then
        write (ux16a,'(1pg12.5)') vosol
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (noutpt,1110) ux16a(1:j1)
 1110   format(/12x,'Aqueous solution volume= ',a,' L')
      endif
c
      write (ux16a,'(1pg12.5)') wfh2o
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (ux16b,'(1pg12.5)') wftds
      call lejust(ux16b)
      j2 = ilnobl(ux16b)
      write (noutpt,1120) ux16a(1:j1),ux16b(1:j2)
 1120 format(/19x,'Solvent fraction= ',a,' kg.H2O/kg.sol',
     $ /20x,'Solute fraction= ',a,' kg.tds/kg.sol')
c
      write (ux16a,'(1pg12.5)') tdspkc
      call lejust(ux16a)
      j1 = ilnobl(ux16a)
      write (noutpt,1140) ux16a(1:j1)
 1140 format(/6x,'Total dissolved solutes (TDS)= ',a,' mg/kg.sol')
c
      if (qrho) then
        write (ux16a,'(1pg12.5)') tdsplc
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (ux16b,'(1pg12.5)') tdsglw
        call lejust(ux16b)
        j2 = ilnobl(ux16b)
        write (noutpt,1210) ux16a(1:j1),ux16b(1:j2)
 1210   format(32x,'TDS= ',a,' mg/L',/32x,'TDS= ',a,' g/L')
c
        write (ux16a,'(1pg12.5)') rhoc
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (ux16b,'(1pg12.5)') rhowc
        call lejust(ux16b)
        j2 = ilnobl(ux16b)
        write (noutpt,1220) ux16a(1:j1),ux16b(1:j2)
 1220   format(/19x,'Solution density= ',a,' g/mL',
     $  /19x,'Solution density= ',a,' g/L')
c
        write (ux16a,'(1pg12.5)') mrmlra
        call lejust(ux16a)
        j1 = ilnobl(ux16a)
        write (ux16b,'(1pg12.5)') mlmrra
        call lejust(ux16b)
        j2 = ilnobl(ux16b)
        write (noutpt,1240) ux16a(1:j1),ux16b(1:j2)
 1240   format(/18x,'Molarity/molality= ',a,' kg.H2O/L',
     $  /18x,'Molality/molarity= ',a,' L/kg.H2O')
      endif
c
      write (noutpt,1300)
 1300 format(1x)
c
      end

      subroutine chkstc(actw,awmax,awmin,eh,ehmax,ehmin,fo2lg,iopt,
     $ jreac,kstep,kstpmx,noptmx,noutpt,nrct,nrctmx,nttyo,o2max,o2min,
     $ ph,phmax,phmin,prcinf,qaft1,qcnpre,qcntmp,qconst,qredox,qstop,
     $ qvhfxi,qvlsow,timemx,time1,tolxst,tolxsu,ximax,xi1)
c
c     This subroutine checks for conditions which call for terminating
c     the current reaction path calculation.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kstpmx,noptmx,nrctmx
c
      integer noutpt,nttyo
c
      integer iopt(noptmx),jreac(nrctmx)
c
      integer kstep,nrct
c
      logical qaft1,qcnpre,qcntmp,qconst,qredox,qstop,qvhfxi,qvlsow
c
      real*8 actw,awmax,awmin,eh,ehmax,ehmin,fo2lg,o2max,o2min,
     $ ph,phmax,phmin,prcinf,timemx,time1,tolxst,tolxsu,ximax,xi1
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer nrc,nrrct
c
      real*8 tres
c
c-----------------------------------------------------------------------
c
      qstop = .false.
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (xi1 .ge. ximax) then
        write (noutpt,1000)
        write (nttyo,1000)
 1000   format(/3x,'Have reached the maximum value of Xi.')
        qstop = .true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iopt(2) .ge. 1) then
        if (timemx .lt. prcinf) then
          tres = (time1 - timemx)/timemx
          if (abs(tres) .le. tolxst) then
            write (noutpt,1010)
            write (nttyo,1010)
 1010       format(/3x,'Have reached the maximum value of time.')
            qstop = .true.
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (phmin .gt. -prcinf) then
        if (abs(ph - phmin) .le. tolxsu) then
          write (noutpt,1020)
          write (nttyo,1020)
 1020     format(/3x,'Have reached the minimum value of pH.')
          qstop = .true.
        elseif (ph .lt. phmin) then
          write (noutpt,1030)
          write (nttyo,1030)
 1030     format(/3x,'The pH is below the minimum value.')
          qstop = .true.
        endif
      endif
c
      if (phmax .lt. prcinf) then
        if (abs(ph - phmax) .le. tolxsu) then
          write (noutpt,1040)
          write (nttyo,1040)
 1040     format(/3x,'Have reached the maximum value of pH.')
          qstop = .true.
        elseif (ph .gt. phmax) then
          write (noutpt,1050)
          write (nttyo,1050)
 1050     format(/3x,'The pH is above the maximum value.')
          qstop = .true.
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
        if (ehmin .gt. -prcinf) then
          if (abs(eh - ehmin) .le. tolxsu) then
            write (noutpt,1060)
            write (nttyo,1060)
 1060       format(/3x,'Have reached the minimum value of Eh (v).')
            qstop = .true.
          elseif (eh .lt. ehmin) then
            write (noutpt,1070)
            write (nttyo,1070)
 1070       format(/3x,'The Eh (v) is below the minimum value.')
            qstop = .true.
          endif
        endif
c
        if (ehmax .lt. prcinf) then
          if (abs(eh - ehmax) .le. tolxsu) then
            write (noutpt,1080)
            write (nttyo,1080)
 1080       format(/3x,'Have reached the maximum value of Eh (v).')
            qstop = .true.
          elseif (eh .gt. ehmax) then
            write (noutpt,1090)
            write (nttyo,1090)
 1090       format(/3x,'The Eh (v) is above the maximum value.')
            qstop = .true.
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qredox) then
        if (o2min .gt. -prcinf) then
          if (abs(fo2lg - o2min) .le. tolxsu) then
            write (noutpt,1100)
            write (nttyo,1100)
 1100       format(/3x,'Have reached the minimum value of log fO2.')
            qstop = .true.
          elseif (fo2lg .lt. o2min) then
            write (noutpt,1110)
            write (nttyo,1110)
 1110       format(/3x,'The log fO2 is below the minimum value.')
            qstop = .true.
          endif
        endif
c
        if (o2max .lt. prcinf) then
          if (abs(fo2lg - o2max) .le. tolxsu) then
            write (noutpt,1120)
            write (nttyo,1120)
 1120       format(/3x,'Have reached the maximum value of log fO2.')
            qstop = .true.
          elseif (fo2lg .gt. o2max) then
            write (noutpt,1130)
            write (nttyo,1130)
 1130       format(/3x,'The log fO2 is above the maximum value.')
            qstop = .true.
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (awmin .gt. -prcinf) then
        if (abs(actw - awmin) .le. tolxsu) then
          write (noutpt,1140)
          write (nttyo,1140)
 1140     format(/3x,'Have reached the minimum value of the',
     $    ' activity of water.')
          qstop = .true.
        elseif (actw .lt. awmin) then
          write (noutpt,1150)
          write (nttyo,1150)
 1150     format(/3x,'The activity of water is below the minimum',
     $    ' value.')
          qstop = .true.
        endif
      endif
c
      if (awmax .lt. prcinf) then
        if (abs(actw - awmax) .le. tolxsu) then
          write (noutpt,1160)
          write (nttyo,1160)
 1160     format(/3x,'Have reached the maximum value of the',
     $    ' activity of water.')
          qstop = .true.
        elseif (actw .gt. awmax) then
          write (noutpt,1170)
          write (nttyo,1170)
 1170     format(/3x,'The activity of water is above the maximum',
     $    ' value.')
          qstop = .true.
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (kstep .ge. kstpmx) then
        write (noutpt,1200)
        write (nttyo,1200)
 1200   format(/3x,'Have done the maximum number of steps.')
        qstop = .true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qconst) then
        write (noutpt,1400)
        write (nttyo,1400)
 1400   format(/3x,'All irreversible reaction rates are now zero.')
        qstop=.true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qaft1) then
        write (noutpt,1410)
        write (nttyo,1410)
 1410   format(/3x,'The total affinity is repeatedly nearly zero.')
        qstop=.true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Test to see if any reactants remain active. If none, terminate
c     the run unless the temperature or pressure are changing.
c
      if (nrct .gt. 0) then
        if (qcntmp .and. qcnpre) then
          nrrct = 0
          do nrc = 1,nrct
            if (jreac(nrc) .eq. 0) nrrct = nrrct + 1
          enddo
          if (nrrct .le. 0) then
            write (noutpt,1420)
            write (nttyo,1420)
 1420       format(/3x,'Each reactant is now saturated or exhausted.')
            qstop = .true.
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qvlsow) then
        write (noutpt,1430)
        write (nttyo,1430)
 1430   format(/3x,'Have very nearly exhausted solvent water.')
        qstop=.true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (qvhfxi) then
        write (noutpt,1440)
        write (nttyo,1440)
 1440   format(/3x,'Have extremely high ionic strength.')
        qstop=.true.
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine grdxsp(nbasp,nbt,nbtmax,nct,ndrsr,noutpt,
     $ nrdxsp,nstmax,nttyo,uspec)
c
c     This subroutine finds the redox basis species (nrdxsp).
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       nbasp  = array of indices of basis species
c
c     Principal output:
c
c       nrdxsp = species index of the redox basis species (= 0 if
c                there is none)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nbtmax,nstmax
c
      integer noutpt,nttyo
c
      integer nbasp(nbtmax),ndrsr(2,nstmax)
      integer nbt,nct,nrdxsp
c
      character(len=48) uspec(nstmax)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer jlen,nb,nr1,nr2,ns,nt1
c
      character(len=56) uspn56
c
c-----------------------------------------------------------------------
c
c     The redox basis species, if it exists, folllows the other strict
c     basis species, each of which must associate one-to-one with a
c     chemical element. The strategy is to test the basis species after
c     those to see if it is a strict basis species (has no associated
c     real reaction). If that is the case, then it is the redox species
c     (species index nrdxsp). If the redox species doesn't exist, nrdxsp
c     is returned as zero.
c
      nrdxsp = 0
c
c     Get the candidate basis index (nb).
c
      nb = nct + 1
      if (nb .le. nbt) then
c
c       This index is in range.
c
        ns = nbasp(nb)
        nr1 = ndrsr(1,ns)
        nr2 = ndrsr(2,ns)
        nt1 = nr2 - nr1 + 1
        if (nt1 .lt. 2) then
c
c         The candidate species is a strict basis species.
c         It must be the redox species.
c
          nrdxsp = ns
        endif
      endif
c
      if (nrdxsp .gt. 0) then
c
c       Calling sequence substitutions:
c         uspec(nrdxsp) for unam48
c
        call fmspnx(jlen,uspec(nrdxsp),uspn56)
c
        write (noutpt,1000) uspn56(1:jlen)
        write (nttyo,1000) uspn56(1:jlen)
 1000   format(/' The redox basis species is ',a,'.')
      else
        write (noutpt,1010)
        write (nttyo,1010)
 1010   format(' No redox basis species was found.')
      endif
c
      end

      subroutine alters(afcnst,apresg,axlks,cdrs,kxmod,narxmx,narxt,
     $ ndrs,ndrsmx,ndrsr,noutpt,npt,nptmax,nst,nstmax,ntpr,ntprmx,
     $ nttyo,nxmdmx,nxmod,tempc,uphase,uspec,uxmod,xlkmod)
c
c     This subroutine alters the log K values of reactions for the
c     destruction of the specified species after they are read from
c     the data file. This is done before the reactions are rewritten
c     by any basis switching. The reactions are identified on the
c     input file by the names (uxmod) of the associated species.
c     The log K values (actually here the corresponding interpolating
c     polynomial coefficients) are altered according the following
c     options:
c
c       kxmod = 0   Replace the log K value by xlkmod
c       kxmod = 1   Augment the log K value by xlkmod
c       kxmod = 2   Destablize the associated species by xlkmod kcal
c                    (at the temperature at the start of the run)
c
c     This subroutine maps any kxmod = 0 or 2 options into the
c     equivalent kxmod = 1 option. An unaltered pickup file (written
c     by EQ3NR or EQ6) therefore may have only the kxmod = 1 alter
c     option in addition to the kxmod = -1 suppression option (which
c     is handled by EQLIB/supprs.f). The effect of this is that if
c     temperature in EQ6 is a function of reaction progress, the
c     log K at any temperature is augmented by a constant amount.
c
c     Note that uxmod is a 48-character name with a 24-character
c     species part followed by a 24-character phase part. If the phase
c     part is blank, which would normally be the case, name matching
c     is done only on the species part. That way, for example,
c     directing the code to change the log K of 'albite' means that
c     the code makes the change for 'albite'  in 'albite,' 'albite' in
c     'plagioclase,' and 'albite' in (Na,K)-feldspar.'
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       axlks  = array of polynomial coefficients for computing log K
c                  values (altered by the options carried out by this
c                  subroutine)
c       kxmod  = array of flag variables defining the type of nxmod
c                  options
c       nxmod  = the number of 'nxmod' alter/suppress options
c       uxmod  = array of names of species whose thermodynamic data
c                  are to be altered
c       xlkmod = array of values used by the 'nxmod' options to replace
c                  or augment the the log K values
c
c     Principal output:
c
c       axlks  = array of polynomial coefficients for computing log K
c                  values
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ndrsmx,nptmax,nstmax,ntprmx,nxmdmx
c
      integer noutpt,nttyo
c
      integer kxmod(nxmdmx),narxt(ntprmx),ndrs(ndrsmx),ndrsr(2,nstmax)
      integer npt,nst,ntpr,nxmod
c
      character*48 uxmod(nxmdmx),uspec(nstmax)
      character*24 uphase(nptmax)
c
      real*8 axlks(narxmx,ntprmx,nstmax),apresg(narxmx,ntprmx),
     $ cdrs(ndrsmx),xlkmod(nxmdmx)
      real*8 afcnst,tempc
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer j,jlen,j2,n,nchar,nerr,nhits,nn,np,nr1,nr2,ns,nt
c
      integer ilnobl
c
      character*56 uspn56
      character*48 unam48
      character*24 ublk24
      character*8 ufix
c
      real*8 cds,pgrid,xlkdel,xlknew,xlkold
c
c-----------------------------------------------------------------------
c
      data ublk24 /'                        '/
      data ufix   /'fix_    '/
c
c-----------------------------------------------------------------------
c
      nerr = 0
      if (nxmod .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the grid pressure.
c
c     Calling sequence substitutions:
c       apresg for arr
c       pgrid for prop
c
      call evdat2(apresg,narxmx,narxt,ntpr,ntprmx,pgrid,tempc)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do n = 1,nxmod
        if (kxmod(n) .lt. 0) go to 130
        unam48 = uxmod(n)
        xlkdel = xlkmod(n)
c
        nchar = 24
        if (unam48(25:48) .ne. ublk24(1:24)) nchar = 48
c
        nhits = 0
        do ns = 1,nst
          if (unam48(1:nchar) .ne. uspec(ns)(1:nchar)) go to 120
c
          nhits = nhits + 1
          nr1 = ndrsr(1,ns)
          nr2 = ndrsr(2,ns)
          nt = nr2 - nr1 + 1
          if (nt .lt. 2) then
            call fmspnm(jlen,unam48,uspn56)
            write (noutpt,1005) uspn56(1:jlen)
            write (nttyo,1005) uspn56(1:jlen)
 1005       format(/' * Error - (EQLIB/alters) The species ',a,
     $      /7x,'is in the strict basis set, so it can not be affected',
     $      /7x,'by the  specifed nxmod alter option.')
            nerr = nerr + 1
            if (nchar .eq. 48) go to 130
            go to 120
          endif
c
c         Calling sequence substitutions:
c           axlks for arr
c           ns for k
c           nstmax for nmax
c           xlkold for prop
c
          call evdat3(axlks,ns,nstmax,narxmx,narxt,ntpr,ntprmx,xlkold,
     $    tempc)
c
c         Map the kxmod = 0 and kxmod = 2 options to the kxmod = 1
c         option.
c
          if (kxmod(n) .eq. 0) then
            kxmod(n) = 1
            xlkdel = xlkdel - xlkold
            xlkmod(n) = xlkdel
          elseif (kxmod(n) .eq. 2) then
            do nn = nr1,nr2
              if (ndrs(nn) .eq. ns) then
                cds = cdrs(nn)
                go to 110
              endif
            enddo
  110       if (cds .le. 0) then
              call fmspnm(jlen,unam48,uspn56)
              write (noutpt,1010) uspn56(1:jlen)
              write (nttyo,1010) uspn56(1:jlen)
 1010         format(/" * Error - (EQLIB/alters) Couldn't find a",
     $        ' non-zero reaction coefficient',/7x,'for the species ',
     $        a,', which is',/7x,'specified in an nxmod alter option.',
     $        " Therefore can't alter the",/7x,'corresponding',
     $        ' equilibrium constant.')
              nerr = nerr + 1
              if (nchar .eq. 48) go to 130
              go to 120
            endif
            xlkdel = -cds*xlkdel/afcnst
            kxmod(n) = 1
            xlkmod(n) = xlkdel
          endif
c
c         Change the polynomial coefficients.
c
          do j = 1,ntprmx
            axlks(1,j,ns) = axlks(1,j,ns) + xlkdel
          enddo
c
c         Calling sequence substitutions:
c           noutpt for nf
c
          call prreac(cdrs,ndrs,ndrsmx,ndrsr,noutpt,ns,nstmax,uspec)
c
c         Calling sequence substitutions:
c           nttyo for nf
c
          call prreac(cdrs,ndrs,ndrsmx,ndrsr,nttyo,ns,nstmax,uspec)
          xlknew = xlkold + xlkdel
          write (noutpt,1020) tempc,pgrid,xlkold,xlknew
          write (nttyo,1020) tempc,pgrid,xlkold,xlknew
 1020     format(/7x,'The log K of the above reaction at ',f10.3,'C',
     $    /7x,'and ',f10.3,' bars was changed from',
     $    f10.4,' to ',f10.4,'.',/)
          if (nchar .eq. 48) go to 130
c
  120     continue
        enddo
c
        if (nhits .le. 0) then
          call fmspnm(jlen,unam48,uspn56)
          write (noutpt,1025) uspn56(1:jlen)
          write (nttyo,1025) uspn56(1:jlen)
 1025     format(/" * Error- (EQLIB/alters) Can't find the species",
     $    /7x,a,', which is specified in an nxmod alter option.',
     $    ' Check to make sure',/7x,'that a species of this name',
     $    ' appears on the supporting data file.')
c
          j2 = ilnobl(unam48(1:24))
          do np = 1,npt
            if (unam48(1:24) .eq. uphase(np)(1:24)) then
              write (noutpt,1030) unam48(1:j2)
              write (nttyo,1030) unam48(1:j2)
 1030         format(/' * Note - (EQLIB/alters) The entity "',a,'"',
     $        ' specified',/7x,'in an nxmod alter option is a phase,',
     $        ' not a species. Such an option applies only to species.')
              go to 130
            endif
          enddo
        endif
c
c       Check to see that the species is not a fictive fugacity
c       fixing species.
c
        if (unam48(1:4) .eq. ufix(1:4)) then
          call fmspnm(jlen,unam48,uspn56)
          write (noutpt,1035) uspn56(1:jlen)
          write (nttyo,1035) uspn56(1:jlen)
 1035     format(/' * Note - (EQLIB/alters) The species "',a,
     $    '" specified',/7x,'in an nxmod alter option comprises a',
     $    ' fictive fugacity-fixing.',/7x,' phase. Such an option',
     $    " can't be applied to this kind of species.")
        endif
c
  130   continue
      enddo
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine setpk3(electr,iindx1,jflag,jflgi,kbt,kdim,kmax,
     $ kmt,kprs,kwater,kxt,mtb,mtbi,mtbaq,mtbaqi,narn1,narn2,nbasp,
     $ nbaspd,nbaspi,nbti,nbtmax,ndrsrd,nern1,nern2,nobswt,nstmax,
     $ ntitl,ntitl2,ntitmx,omeglg,press,pressi,scamas,sigzi,tempc,
     $ tempci,ubmtbi,uobsw,uspec,utitl,utitl2,uzveci,uzvec1,
     $ zvclgi,zvclg1)
c
c     This subroutine sets up certain variables and arrays for writing
c     on the pickup file. This subroutine must be called prior to
c     writing a pickup file.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer kmax,nbtmax,nstmax,ntitmx
c
      integer iindx1(kmax),jflag(nstmax),jflgi(nbtmax),nbasp(nbtmax),
     $ nbaspd(nbtmax),nbaspi(nbtmax),ndrsrd(2,nstmax)
c
      integer kbt,kdim,kmt,kprs,kwater,kxt,narn1,narn2,nern1,nern2,
     $ nbti,nobswt,ntitl,ntitl2
c
      character(len=80) utitl(ntitmx),utitl2(ntitmx)
      character(len=48) ubmtbi(nbtmax),uobsw(2,nbtmax),uspec(nstmax),
     $ uzveci(kmax),uzvec1(kmax)
c
      real(8) mtb(nbtmax),mtbi(nbtmax),mtbaq(nbtmax),mtbaqi(nbtmax),
     $ zvclgi(kmax),zvclg1(kmax)
c
      real(8) electr,omeglg,press,pressi,scamas,sigzi,tempc,tempci
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer kcol,krow,n,nb,nbi,nerr,nsi,ns1,ns2,nt1
c
      real(8) lscama
c
      real(8) tlg
c
c-----------------------------------------------------------------------
c
      nerr = 0
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Old title.
c
      ntitl2 = ntitl
      do n = 1,ntitl
        utitl2(n) = utitl(n)
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original temperature.
c
      tempci = tempc
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Original pressure.
c
      pressi = press
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Index limits.
c
      kprs = 0
c
      kmt = kdim
      kxt = kdim
      nbti = kbt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Species for which mass balances are defined.
c
c       ubmtbi = names of the data file basis species for which mass
c                  balances are defined
c       jflgi  = jflag input for basis species
c          0 = Retain as an active basis species
c         30 = Convert to a dependent species; fold the mass balance
c                total for this species into the mass balance totals
c                of basis species which remain active
c
      do krow = 1,kbt
        nb = iindx1(krow)
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        nbi = krow
        nsi = nbaspi(nb)
        ubmtbi(nbi) = uspec(nsi)
c
        if (ns1.ge.narn1 .and. ns1.le.narn2) then
          mtbi(nbi) = scamas*mtb(nb)
          mtbaqi(nbi) = scamas*mtbaq(nb)
          nt1 = ndrsrd(2,ns1) - ndrsrd(1,ns1) + 1
          if (nt1 .lt. 2) then
c
c           Have a strict basis species associated with the current
c           mass balance.
c
            jflgi(nbi) = jflag(ns2)
          else
c
c           Have an auxiliary basis species associated with the current
c           mass balance.
c
            jflgi(nbi) = 30
          endif
        elseif (ns1.ge.nern1 .and. ns1.le.nern2) then
          mtbi(nbi) = mtb(nb)
          mtbaqi(nbi) = mtbaq(nb)
          jflgi(nbi) = jflag(ns2)
        else
          mtbi(nbi) = mtb(nb)
          mtbaqi(nbi) = mtbaq(nb)
          jflgi(nbi) = jflag(ns2)
        endif
c
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Electrical balance.
c
      electr = scamas*sigzi
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Ordinary basis switching directives.
c
      n = 0
      do kcol = 1,kbt
        nb = iindx1(kcol)
        ns1 = nbaspd(nb)
        ns2 = nbasp(nb)
        if (ns1 .ne. ns2) then
          n = n + 1
          uobsw(1,n) = uspec(ns1)
          uobsw(2,n) = uspec(ns2)
        endif
      enddo
      nobswt = n
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Matrix column variables and corresponding values.
c
      lscama = tlg(scamas)
      zvclg1(kwater) = omeglg
      do kcol = 1,kdim
        nb = iindx1(kcol)
        ns2 = nbasp(nb)
        uzveci(kcol) = uzvec1(kcol)
        if (ns2.ge.narn1 .and. ns2.le.narn2) then
          zvclgi(kcol) = zvclg1(kcol) + lscama
        elseif (ns2.ge.nern1 .and. ns2.le.nern2) then
          zvclgi(kcol) = zvclg1(kcol)
        else
          zvclgi(kcol) = zvclg1(kcol)
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine chksar(afrc0,afrcp,dafrc0,delxi,dlxmin,dxval0,
     $ eps100,iodb,jreac,nodbmx,noutpt,nord,nordmx,nrct,nrctmx,
     $ nrd1mx,nrk,nttyo,tolsar,ureac,xi0,xi1,xval0)
c
c     This subroutine checks the signs of the affinities of the
c     reactants. It finds the point of reaction progress at which the
c     affinity of any irreversible reaction changes sign. The reactant
c     affinities are tracked using finite differences.
c
c     This mechanism is used for two purposes. One is to insure that
c     a rate law for say the forward direction is not extrapolated
c     to the region of unfavorable affinity when a distinct rate
c     law is specified for the opposite direction. The second purpose
c     of this mechanism is to find the point at which a formerly
c     exhausted reactant must be reactivated so that it can be
c     precipitated according to a specified rate law (not a partial
c     equilibrium condition).
c
c     Note the following:
c
c       jreac = reactant status flag:
c
c                  0 = set to react
c                 -1 = saturated, but the remaining reactant mass
c                        continues to react irreversibly
c                  1 = exhausted
c                  2 = saturated; the status of any remaining reactant
c                        mass is changed to that of a product phase
c
c     When jreac = -1 or 2, the affinity is zero by definition. In this
c     case, finite-difference expressions of the affinity should be
c     avoided because the affinity values used to build them may
c     reflect somewhat random non-zero values consistent with the
c     applied convergence tolerances. The corresponding finite
c     differences may therefore behave wildly.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nordmx,nrctmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx),jreac(nrctmx),nrk(2,nrctmx)
c
      integer nord,nrct
c
      character*24 ureac(nrctmx)
c
      real*8 afrc0(nrctmx),afrcp(nrctmx),dafrc0(nordmx,nrctmx),
     $ dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,eps100,tolsar,xi0,xi1,xval0
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,j2,krzero,n,nrc,nrzero
c
      integer ilnobl
c
      character*48 usearch
      character*24 unam24
c
      real*8 aaxxp,atgsar,axx,axx0,axxp,dxp,tolsx,xtargv,xval
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'a reactant affinity changes sign                '/
c
c-----------------------------------------------------------------------
c
      if (nord .le. 0) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is not where a reactant affinity is zero. The
c     magnitude of the search target is atgsar = 0.5*tolsar. The search
c     tolerance has the same value. Thus, in the case of a reactant
c     affinity going from positive to negative values, the search target
c     is -atgsar and the interval for convergence is (-tolsar,0.). In
c     the case of a reactant affinity going from negative to positive
c     values, the search target is atgsar, and the interval for
c     convergence is (0.,tolsar).
c
      atgsar = 0.5*tolsar
      tolsx = atgsar
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 50) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for reactant affinities changing sign',
     $    ' has failed.',/3x,'Dropping to the minimum step size.')
        endif
        delxi = dlxmin
        go to 999
      endif
c
c     Estimate the reactant affinities from Taylor's series expansions.
c     Avoid using Taylor's series for reactants whose affinities must
c     be zero.
c
      do nrc = 1,nrct
        afrcp(nrc) = 0.
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq. 1) then
          axx = afrc0(nrc)
          dxp = 1.
          do n = 1,nord
            dxp = dxp*delxi
            axx = axx + ( dafrc0(n,nrc)/fctrl(n) )*dxp
          enddo
          afrcp(nrc) = axx
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Find any cross-overs. Note that there are two kinds, positive to
c     negative, and negative to positive.
c
      xval = 0.
      nrzero = 0
      krzero = 0
      unam24 = ' '
      do nrc = 1,nrct
        if (jreac(nrc).eq.0 .or. jreac(nrc).eq. 1) then
          axx0 = afrc0(nrc)
          axxp = afrcp(nrc)
          if (axx0 .gt. 0.) then
            if (axxp .lt. -tolsar) then
c
c             A case has been found in which the cross over tolerance
c             is exceeded for the positive to negative case.
c
              if (nrk(2,nrc) .ne. 0) then
c
c               The case is not one in which precipitation is to be
c               governed by instantaneous equilibrium. In that case,
c               let other controls apply.
c
                krzero = krzero + 1
                aaxxp = -axxp
                if (aaxxp .gt. xval) then
                  xval = aaxxp
                  nrzero = nrc
                  unam24 = ureac(nrc)
                  ilsign = 1
                  xtargv = -atgsar
                endif
              endif
            endif
          elseif (axx0 .lt. 0.) then
            if (axxp .gt. tolsar) then
c
c             A case has been found in which the cross over tolerance
c             is exceeded for the negative to positive case.
c
              if (jreac(nrc) .ne. 1) then
c
c               The case is not one in which any new forward reaction
c               is impossible because the reactant is exhausted.
c               That case may be ignored.
c
                krzero = krzero + 1
                aaxxp = axxp
                if (aaxxp .gt. xval) then
                  xval = aaxxp
                  nrzero = nrc
                  unam24 = ureac(nrc)
                  ilsign = -1
                  xtargv = atgsar
                endif
              endif
            endif
          endif
        endif
      enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (krzero .gt. 0) then
        if (delxi .gt. dlxmin) then
          if (abs(xval - xtargv) .gt. tolsx) then
c
            xval0 = afrc0(nrzero)
            do n = 1,nord
              dxval0(n) = dafrc0(n,nrzero)
            enddo
c
            call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $      nodbmx,nord,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $      xtargv,xval0)
c
            if (ier .le. 0) go to 100
            if (ier .ge. 2) then
c
c             Note: if ier = 1, the returned "safe" value of delxi
c             is used.
c
              delxi = dlxmin
            endif
            go to 999
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
c
c       Print any occurrences of reactant affinity sign changes.
c
        if (krzero .gt. 0) then
          do nrc = 1,nrct
            if (jreac(nrc).eq.0 .or. jreac(nrc).eq. 1) then
              axx0 = afrc0(nrc)
              axxp = afrcp(nrc)
              if (abs(axxp) .le. tolsx) then
                if (axx0.gt.tolsx .and. dafrc0(1,nrc).lt.0.) then
                  if (nrk(2,nrc) .ne. 0) then
                    j2 = ilnobl(ureac(nrc))
                    write (noutpt,1010) ureac(nrc)(1:j2),xi1,delxi
 1010               format(/3x,"Taylor's series predict that the",
     $              ' affinity for reactant',/3x,a,' has decreased to',
     $              ' nearly zero at Xi= ',1pe12.5,',',/3x,'delxi= ',
     $              1pe12.5,'.')
                  endif
                elseif (axx0.lt.tolsx .and. dafrc0(1,nrc).gt.0.) then
                  j2 = ilnobl(ureac(nrc))
                  write (noutpt,1020) ureac(nrc)(1:j2),xi1,delxi
 1020             format(/3x,"Taylor's series predict that the",
     $            ' affinity for reactant',/3x,a,' has increased to',
     $            ' nearly zero at Xi= ',1pe12.5,',',/3x,'delxi= ',
     $            1pe12.5,'.')
                endif
              endif
            endif
          enddo
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine newton(aamatr,abar,acflg,acflgo,act,actlg,actwlc,
     $ adh,adhh,adhv,afcnst,alpha,al10,amtb,aphi,azero,a3bar,a3bars,
     $ bacfmx,bbig,beta,betamx,betao,bdh,bdhh,bdhv,bdot,bdoth,bdotv,
     $ bfje,bfxi,bgamx,bneg,bpx,bsigmm,cco2,cdrs,cdrtw,cdrw,cegexs,
     $ cgexj,cjbasp,cnufac,conc,conclg,coval,cpgexs,csts,delam,
     $ delmax,delvco,delvec,dgpit,dlogxw,dpelm,dpslm,dselm,egexjc,
     $ egexjf,egexs,eh,ehfac,elam,eps100,fje,fjeo,fo2,fo2lg,fsort,
     $ fugac,fugalg,fxi,fxio,gmmatr,gpit,ibpxt,idelmx,iebal,ielam,
     $ ier,iern1,iern2,ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,
     $ ifrn1,ifrn2,ifzeta,igas,igstak,iindx1,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilrn1,ilrn2,ilzeta,imrn1,imrn2,insgf,
     $ iodb,iopg,ipivot,ipndx1,irdxc3,istack,iter,itermx,ixbasp,
     $ ixrn1,ixrn2,izmax,jcsort,jern1,jern2,jflag,jgext,jgsort,
     $ jgstak,jjsort,jpflag,jsflag,jsitex,jsol,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,loph,
     $ losp,lsort,mgext,moph,mosp,mrgexs,mtb,nalpha,napt,narn1,
     $ narn2,nbasp,nbt,nbw,nchlor,ncmpr,ncosp,ndrs,ndrsr,nelect,
     $ nern1,nern2,net,ngexsa,ngext,ngrn1,ngrn2,ngt,nhydr,nmut,nmux,
     $ nmxi,nmxx,noutpt,no2gaq,nphasx,npt,nredox,nslt,nslx,nst,nsts,
     $ nstsr,nsxi,nsxx,ntfx,ntfxt,nttyo,omega,omeglg,palpha,pelm,
     $ pmu,press,pslamn,pslm,qhawep,qpit75,qredox,q6mode,rhsvec,
     $ screwd,screwn,selm,sigmam,sigmmo,tempk,tfx,tolbt,toldl,ubacmx,
     $ ubbig,ubetmx,ubgamx,ubneg,ugexj,ugexmo,ulbeta,uldel,uphase,
     $ uspec,uzvec1,weight,wfac,xbar,xbarlg,xbarw,xbarwc,xbrwlc,
     $ xbrwlg,xlke,xlks,zchar,zchsq2,zchcu6,zgexj,zvclg1,zvec1)
c
c     This subroutine performs hybrid Newton-Raphson iteration to solve
c     for the equilibrium state of a chemical system.
c
c     This subroutine is called by:
c
c       EQ3NR/eq3nr.f
c       EQ6/eqcalc.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       ielam  = flag to not use (-1) or use (0) "higher order"
c                  (higher than 2nd order) electrostatic terms in
c                  those activity coefficient models which contain
c                  provision for such terms
c       screwd = under-relaxation control parameter. It is used to
c                  reduce the magnitude of the del vector, if necessary
c                  so that the magnitude of the largest element of that
c                  vector does not exceed screwd.
c       screwn = under-relaxation control parameter
c       tolbt  = convergence tolerance on betamx
c       toldl  = convergence tolerance on delmax
c       ulbeta = label for the quantity type for beta vector;
c                  e.g., 'conc' or 'moles'
c       uldel  = label for the quantity type for del corrections;
c                 e.g., 'conc' or 'moles'
c       uspec  = aqueous species name array
c       uzvec1 = name array corresponding to zvclg1
c       iodb   = array of debugging print options
c       itermx = maximum number of iterations
c       kdim   = dimension of aamatr
c       narn1  = start of species range for aqueous solution
c       narn2  = end of species range for aqueous solution
c       nbasp  = array of basis species
c       nbt    = number of basis species
c       ncmpr  = species range array for phases
c       nern1  = start of species range for generic ion exchangers
c       nern2  = end of species range for generic ion exchangers
c       nst    = number of aqeuous species
c       q6mode = flag denoting usage for EQ3NR or EQ6:
c                  .false. = EQ3NR
c                  .true.  = EQ6NR
c       wfac   = array of solid solution non-ideality parameters
c
c     Principal input/output:
c
c       zvclg1 = the 'log z' array, the array corrected by
c                  Newton-Raphson iteration
c       conc   = concentration array
c       acflg  = activity coefficient array
c       fje    = the ionic asymmetry (the 3rd-order electrostatic
c                  moment function J)
c       fxi    = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c
c     Principal work space/output:
c
c       aamatr = Jacobian matrix
c       abar   = average ion size
c       a3bar  = average cube of the distance of closest approach
c                  for all solute species
c       a3bars = characteristic average cube of the distance of closest
c                  approach for a solute species
c       gmmatr = copy of aamatr
c       delvec = correction array
c       rhsvec = right hand side vector
c       beta   = normalized residual function array
c       alpha  = residual function array
c       acflgo = copy of activity coefficient array
c       betao  = old beta array
c       delvco = old del array
c       betamx = norm (largest magnitude) of the beta array
c       bbig   = largest magnitude positive mass balance residual
c       bneg   = largest magnitude negative mass balance residual
c       bacfmx = norm (largest magnitude) activity coefficient residual
c       ubbig  = name of species corresponding to bbig
c       ubneg  = name of species corresponding to bneg
c       ubacmx = name of species corresponding to bacfmx
c       ipivot = the pivot vector
c       iter   = Newton-Raphson iteration number
c       idelmx = kcol index corresponding to delmax
c       ier    = error flag (mostly returned from EQLIB/nrstep.f):
c                  =  0  Okay
c                  =  1  Encountered a zero matrix
c                  =  2  Encountered a non-zero, computationally
c                          singular matrix
c                  =  3  Iteration was diverging
c                  =  4  Hit the maximum number of iterations (itermx)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      include 'eqlib/eqldv.h'
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer noutpt,nttyo
c
      integer ibpxt(nxtmax),igstak(ngtmax),iindx1(kmax),insgf(natmax),
     $ iodb(nodbmx),iopg(nopgmx),ipivot(kmax),ipndx1(kmax),
     $ istack(nstmax),ixbasp(nbtmax),jcsort(nstmax),
     $ jern1(jetmax,netmax),jern2(jetmax,netmax),jflag(nstmax),
     $ jgext(netmax),jgsort(ngtmax),jgstak(ngtmax),jjsort(nstmax),
     $ jpflag(nptmax),jsflag(nstmax),jsitex(nstmax),jsol(nxtmax),
     $ jssort(nstmax),jstack(nstmax),kction(nbtmax),nbasp(nbtmax),
     $ ncmpr(2,nptmax),ncosp(nbtmax),ndrs(ndrsmx),ndrsr(2,nstmax),
     $ ngexsa(ietmax,jetmax,netmax),ngext(jetmax,netmax),nphasx(nstmax),
     $ nsts(nstsmx),nstsr(2,nstmax),ntfx(ntfxmx)
c
      integer nalpha(nsltmx),nmux(3,nmutmx),nmxi(2,natmax),
     $ nmxx(3,nmxmax),nslx(2,nsltmx),nsxi(2,natmax),nsxx(2,nsxmax)
c
      integer napt,nmut,nslt
c
      integer ifcphi1,ifcphi2,ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,
     $ ilcphi1,ilcphi2,ilnnn,iln2n,ilpsi1,ilpsi2,ilzeta
c
      integer idelmx,iebal,ielam,ier,iern1,iern2,ifrn1,ifrn2,igas,ilrn1,
     $ ilrn2,imrn1,imrn2,iter,itermx,irdxc3,ixrn1,ixrn2,izmax,kbt,kdim,
     $ kelect,khydr,km1,kmt,ko2gaq,kwater,kx1,kxt,narn1,narn2,nbt,nbw,
     $ nchlor,nelect,nern1,nern2,net,ngrn1,ngrn2,ngt,nhydr,no2gaq,npt,
     $ nredox,nst,ntfxt
c
      logical qhawep,qpit75,qredox,q6mode
c
      character*48 uspec(nstmax),uzvec1(kmax)
      character*48 ubbig,ubetmx,ubgamx,ubneg,ubacmx
      character*24 ugexmo(netmax),uphase(nptmax)
      character*8 ugexj(jetmax,netmax)
      character*8 ulbeta(kmax),uldel(kmax)
c
      real*8 dgpit(2,ipbtmx,napmax),dpslm(2,nsltmx),
     $ gpit(ipbtmx,napmax),palpha(ipbtmx,napmax),pmu(nmutmx),
     $ pslamn(0:ipbtmx,nsltmx),pslm(nsltmx)
c
      real*8 delam(2,nazpmx,nazpmx),dpelm(2,nazpmx,nazpmx),
     $ dselm(2,nazmmx:nazpmx),elam(nazpmx,nazpmx),pelm(nazpmx,nazpmx),
     $ selm(nazmmx:nazpmx)
c
      real*8 aamatr(kmax,kmax),acflg(nstmax),acflgo(nstmax),
     $ act(nstmax),actlg(nstmax),alpha(kmax),amtb(nbtmax),azero(natmax),
     $ a3bars(natmax),beta(kmax),betao(kmax),bpx(ibpxmx,nxtmax),
     $ cco2(5),cdrs(ndrsmx),cdrtw(nstmax),cdrw(nstmax),
     $ cegexs(ietmax,jetmax,netmax),cgexj(jetmax,netmax),cjbasp(nbtmax),
     $ cnufac(nstmax),conc(nstmax),conclg(nstmax),coval(nbtmax),
     $ cpgexs(ietmax,jetmax,netmax),csts(nstsmx),delvco(kmax),
     $ delvec(kmax),dlogxw(nbtmax),egexjc(jetmax,netmax),
     $ egexs(ietmax,jetmax,netmax),egexjf(jetmax,netmax)
c
      real*8 fsort(ngtmax),fugac(ngtmax),fugalg(ngtmax),
     $ gmmatr(kmax,kmax),loph(nptmax),losp(nstmax),lsort(nstmax),
     $ mgext(jetmax,netmax),moph(nptmax),mosp(nstmax),
     $ mrgexs(ietmax,jetmax,netmax),mtb(nbtmax),rhsvec(kmax),
     $ tfx(ntfxmx),weight(nstmax),wfac(iktmax,nxtmax),
     $ xbar(nstmax),xbarlg(nstmax),xlks(nstmax),zchar(nstmax),
     $ zchsq2(nstmax),zchcu6(nstmax),zgexj(jetmax,netmax),
     $ zvclg1(kmax),zvec1(kmax)
c
      real*8 adh,adhh,adhv,aphi,bdh,bdhh,bdhv,bdot,bdoth,bdotv
c
      real*8 abar,actwlc,afcnst,al10,a3bar,bacfmx,bbig,betamx,bfje,
     $ bfxi,bgamx,bneg,bsigmm,delmax,eh,ehfac,eps100,fje,fjeo,fo2,
     $ fo2lg,fxi,fxio,omega,omeglg,press,screwd,screwn,sigmam,sigmmo,
     $ tempk,tolbt,toldl,xbarw,xbarwc,xbrwlc,xbrwlg,xlke
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ibetmx,jlen,j2,kcol,negbfc,negdfc,negxfc,noibfc,npconv,
     $ npobfc,npodfc,ns
c
      integer ilnobl
c
      logical qcacf,qcbeta,qcdel,qcgam,qconv,qcsigm,qcfxi,qpracf,qxbarw
c
      character*56 uspn56
      character*8 udelmx,utb,utd
c
      real*8 betfnc,betmxo,btfcnr,bx,dx,chfacf,chfsgm,delfnc,rdx,
     $ rlxfac,rlxgam
c
c-----------------------------------------------------------------------
c
      iter = 0
      ier = 0
      ibetmx = 0
      idelmx = 0
      npconv = 0
c
      delmax = 0.
      betmxo = 0.
      betfnc = 0.
      delfnc = 0.
      btfcnr = 0.
      rlxfac = 1.
      rlxgam = 1.
      negdfc = 0
      negbfc = 0
      negxfc = 0
      noibfc = 0
      npodfc = 0
      npobfc = 0
c
      do kcol = 1,kdim
        delvec(kcol) = 0.
      enddo
c
      qpracf = iodb(4) .ge. 4
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(4) .ge. 2) then
c
c       Debugging prints- state of the system prior to hybrid
c       Newton-Raphson iteration.
c
        write (noutpt,1000)
 1000   format(/8x,'Name',36x,'zvclg1',/)
        do kcol = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(kcol) for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          jlen = min(jlen,38)
          write (noutpt,1010) kcol,uspn56(1:jlen),zvclg1(kcol)
 1010     format(1x,i3,2x,a,t46,1pe12.5)
        enddo
        write (noutpt,1015)
 1015   format(1x)
      endif
c
      if (qpracf) then
        write (noutpt,1020) sigmam,fxi,fje,xbrwlc,xbarwc
 1020   format(/3x,'sigmam= ',1pe12.5,/6x,'fxi= ',e12.5,
     $  /6x,'fje= ',e12.5,
     $  //6x,'xbrwlc= ',0pf10.5,/6x,'xbarwc= ',1pe12.5)
c
        write (noutpt,1030)
 1030   format(/9x,'Species',21x,'gamma',/)
        do ns = narn1,narn2
          write (noutpt,1040) ns,uspec(ns),acflg(ns)
 1040     format(1x,i4,2x,a24,2x,1pe12.5)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Compute the Newton-Raphson residual functions.
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The label below is the return point for iter >= 1.
c
  100 sigmmo = sigmam
      fxio = fxi
      fjeo = fje
c
c     Save the activity coefficients.
c
      call copyaa(acflg,acflgo,nst)
c
      bx = 0.
      dx = 0.
      if (ibetmx .gt. 0) bx = beta(ibetmx)
      if (idelmx .gt. 0) dx = delvec(idelmx)
c
c     Calculate the beta convergence function.
c
      betfnc = 0.
      if (betmxo .gt. 0.) betfnc = (betmxo - betamx)/betmxo
      betmxo = betamx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(4) .ge. 2) then
        write (noutpt,1100)
 1100   format(/8x,'Name',37x,'Beta',/)
        do kcol = 1,kdim
c
c         Calling sequence substitutions:
c           uzvec1(kcol) for unam48
c
          call fmspnx(jlen,uzvec1(kcol),uspn56)
          jlen = min(jlen,38)
          write (noutpt,1110) kcol,uspn56(1:jlen),beta(kcol)
 1110     format(1x,i3,2x,a,t46,1pe12.5)
        enddo
        write (noutpt,1120)
 1120   format(/1x)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(4) .ge. 1) then
        ubetmx = ' '
        utb = ' '
        udelmx = ' '
        utd = ' '
c
        if (ibetmx .gt. 0) then
          utb = ulbeta(ibetmx)
          ubetmx = uzvec1(ibetmx)
        endif
c
        if (idelmx .gt. 0) then
          utd = uldel(idelmx)
          udelmx = uzvec1(idelmx)
        endif
c
        write (noutpt,1200) iter
 1200   format(' iter= ',i3)
c
        if (abs(rlxgam) .le. eps100) then
          write (noutpt,1210)
 1210     format(7x,'Gammas are fixed')
        elseif (abs(rlxgam - 1.0) .gt. eps100) then
          write (noutpt,1220) rlxgam
 1220     format(7x,'Gamma relaxation factor= ',g12.5)
        endif
c
        write (noutpt,1230) utd,udelmx,dx,delfnc
 1230   format(5x,'delvec(',2a8,')= ',1pe12.5,', delfnc= ',e12.5)
c
        if (abs(rlxfac - 1.0) .gt. eps100) then
          rdx = rlxfac*dx
          write (noutpt,1240) rlxfac,utd,udelmx,rdx
 1240     format(7x,'Relaxation factor= ',g12.5,
     $    /5x,'Relaxed delvec(',2a8,')= ',1pe12.5)
        endif
c
        write (noutpt,1250) utb,ubetmx,bx,betfnc
 1250   format(7x,'beta(',2a8,')= ',1pe12.5,', betfnc= ',e12.5)
c
c       Calling sequence substitutions:
c         ubbig for unam48
c
        call fmspnx(jlen,ubbig,uspn56)
        write (noutpt,1260) bbig,uspn56(1:jlen)
 1260   format(9x,'bbig= ',1pe12.5,',   ubbig= ',a)
c
c       Calling sequence substitutions:
c         ubneg for unam48
c
        call fmspnx(jlen,ubneg,uspn56)
        write (noutpt,1270) bneg,uspn56(1:jlen)
 1270   format(9x,'bneg= ',1pe12.5,',   ubneg= ',a)
c
        j2 = ilnobl(ubgamx(1:24))
        write (noutpt,1280) bgamx,ubgamx(1:j2)
 1280   format(8x,'bgamx= ',1pe12.5,',  ubgamx= ',a)
        write (noutpt,1290) bsigmm,bfxi,bfje
 1290   format(7x,'bsigmm= ',1pe12.5,/9x,'bfxi= ',e12.5,
     $  /9x,'bfje= ',1pe12.5)
        write (noutpt,1300) btfcnr
 1300   format(7x,'btfcnr= ',1pe12.5,/)
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Check to see if the iteration satisfies the convergence criteria.
c     Both residual functions and correction terms are tested.
c     Iteration may terminate acceptably without satisfying the
c     constraint on the correction terms (see below).
c
      qcbeta = betamx .le. tolbt
      qcdel = delmax .le. toldl
      qconv = qcbeta .and. qcdel
      qcsigm = abs(bsigmm) .le. tolbt
      qcfxi = abs(bfxi) .le. tolbt
      qcgam = bgamx .le. tolbt
      qcacf = qcsigm .and. qcfxi .and. qcgam
c
cXX   Redefine qcacf when the activity coefficients of species in
cXX   non-aqueous phases are updated numerically the same as those
cXX   of aqueous species.
c     qcacf = bacfmx .le. tolbt
c
c     Force to run at least one iteration
c
      if (iter .ge. 1) then
c
c       Test for convergence
c
        if (qconv .and. qcacf) go to 999
      endif
c
      qxbarw = .false.
cXX   qxbarw = abs(bsigmm).le.0.05 .and. bgamx.le.0.05 .and.
cXX  $ abs(rlxgam - 1.0).le.eps100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Do a Newton-Raphson step.
c
      call nrstep(aamatr,acflg,act,actlg,afcnst,alpha,al10,amtb,
     $ bbig,beta,betamx,betao,betfnc,betmxo,bneg,bpx,btfcnr,cdrs,cdrtw,
     $ cdrw,cegexs,cgexj,cjbasp,cnufac,conc,conclg,cpgexs,csts,coval,
     $ delfnc,delmax,delvco,delvec,dlogxw,egexjc,egexjf,egexs,eh,ehfac,
     $ eps100,fo2,fo2lg,fsort,fugac,fugalg,gmmatr,ibetmx,ibpxmx,idelmx,
     $ iebal,ier,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,iindx1,
     $ ilrn1,ilrn2,imrn1,imrn2,iodb,ipivot,ipndx1,irdxc3,istack,iter,
     $ itermx,ixbasp,ixrn1,ixrn2,jcsort,jern1,jern2,jetmax,jflag,jgext,
     $ jgsort,jgstak,jjsort,jpflag,jsflag,jsitex,jssort,jstack,kbt,
     $ kction,kdim,kelect,khydr,kmax,kmt,km1,ko2gaq,kwater,kxt,kx1,
     $ loph,losp,lsort,mgext,moph,mosp,mrgexs,mtb,narn1,narn2,nbasp,
     $ nbt,nbtmax,nbw,ncmpr,ncosp,ndrs,ndrsmx,ndrsr,negbfc,negdfc,
     $ negxfc,nelect,nern1,nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,
     $ ngtmax,nhydr,nodbmx,noibfc,noutpt,no2gaq,npconv,nphasx,npobfc,
     $ npodfc,npt,nptmax,nredox,nst,nstmax,nsts,nstsmx,nstsr,ntfx,
     $ ntfxmx,ntfxt,nttyo,nxtmax,omega,omeglg,press,qcacf,qcbeta,
     $ qredox,qxbarw,q6mode,rhsvec,rlxfac,screwd,screwn,sigmam,sigmmo,
     $ tfx,ubetmx,ubbig,ubneg,ugexj,ugexmo,uphase,uspec,uzvec1,weight,
     $ xbar,xbarlg,xbarw,xbarwc,xbrwlc,xbrwlg,xlke,xlks,zchar,zgexj,
     $ zvclg1,zvec1)
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (ier .gt. 0) then
c
c       Iteration has been stopped.
c
        if (qcbeta .and. qcgam) then
c
c         Have pseudo-convergence. Reset ier to 0.
c
          ier = 0
          if (iodb(4) .ge. 1) then
            write (noutpt,1310)
 1310       format('  Hybrid Newton-Raphson iteration has',
     $      ' pseudo-converged.')
            do kcol = 1,kdim
              if (abs(delvec(kcol)) .gt. toldl) then
c
c               Calling sequence substitutions:
c                 uzvec1(kcol) for unam48
c
                call fmspnx(jlen,uzvec1(kcol),uspn56)
                write (noutpt,1320) uspn56(1:jlen),delvec(kcol)
 1320           format(11x,'delvec(',a,') = ',g12.5)
              endif
            enddo
          endif
          go to 999
        else
c
c         Iteration has failed.
c
          write (noutpt,1330) iter
 1330     format('  Hybrid Newton-Raphson iteration has gone sour',
     $    ' (iter= ',i3,').')
          go to 999
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     Recompute sigmam, fxi, and fje. Recompute the activity
c     coefficients. Then recompute the concentrations of dependent
c     species. After that, recalculate the Newton-Raphson residual
c     functions. Finally, go back and see whether or not to do another
c     iteration.
c
      if (iodb(4) .ge. 2) write (noutpt,1340)
 1340 format(/3x,'--- Post-Newton-Raphson update of activity',
     $ ' coefficients ---',/)
c
c     Determine the maximum allowed change factors for "Sigma m",
c     etc. (chfsgm) and the log activity coefficients for aqueous
c     species (chfacf).
c
      chfsgm = 1.5
      if (sigmam .le. 2.e-1) chfsgm = 5.
      if (sigmam .le. 1.e-2) chfsgm = 10.
      chfacf = 0.50
c
      call ngcadv(abar,acflg,acflgo,actwlc,adh,adhh,adhv,
     $ afcnst,al10,aphi,azero,a3bar,a3bars,bacfmx,bdh,bdhh,bdhv,
     $ bdot,bdoth,bdotv,bgamx,bpx,bsigmm,bfje,bfxi,cco2,cgexj,
     $ chfacf,chfsgm,conc,delam,dgpit,dpelm,dpslm,dselm,elam,
     $ eps100,fje,fjeo,fxi,fxio,gpit,ibpxt,ielam,ifcphi1,ifcphi2,
     $ ifnnn,ifn2n,ifpsi1,ifpsi2,ifzeta,ilcphi1,ilcphi2,ilnnn,
     $ iln2n,ilpsi1,ilpsi2,ilzeta,insgf,iopg,iter,ipndx1,ixrn1,
     $ ixrn2,izmax,jcsort,jern1,jern2,jgext,jsol,kx1,kxt,nalpha,
     $ napt,narn1,narn2,nchlor,ncmpr,net,nhydr,nmut,nmux,nmxi,
     $ nmxx,noutpt,nslt,nslx,nst,nsxi,nsxx,nttyo,omega,palpha,
     $ pelm,pmu,press,pslamn,pslm,qhawep,qpit75,qpracf,q6mode,
     $ rlxgam,selm,sigmam,sigmmo,tempk,ubacmx,ubgamx,uphase,
     $ uspec,wfac,xbar,xbarlg,xbarwc,xbrwlc,zchar,zchcu6,zchsq2)
c
c     Recalculate the concentrations, etc., of dependent species.
c
      call ncmpex(acflg,act,actlg,cdrs,cegexs,cgexj,conc,
     $ conclg,cpgexs,egexjc,egexjf,egexs,eps100,fo2,fo2lg,fsort,
     $ fugac,fugalg,iern1,iern2,ietmax,ifrn1,ifrn2,igas,igstak,
     $ iindx1,ilrn1,ilrn2,imrn1,imrn2,istack,ixrn1,ixrn2,jcsort,
     $ jern1,jern2,jetmax,jflag,jgext,jgsort,jgstak,jjsort,jpflag,
     $ jsflag,jsitex,jssort,jstack,kbt,kdim,kelect,kmax,km1,ko2gaq,
     $ kwater,kxt,loph,losp,lsort,mgext,mrgexs,mtb,moph,mosp,narn1,
     $ narn2,nbasp,nbt,nbtmax,ncmpr,ndrs,ndrsmx,ndrsr,nelect,nern1,
     $ nern2,netmax,ngexsa,ngext,ngrn1,ngrn2,ngt,ngtmax,noutpt,
     $ no2gaq,nphasx,npt,nptmax,nst,nstmax,nttyo,omega,omeglg,
     $ press,qxbarw,q6mode,ugexj,ugexmo,uphase,uspec,xbar,xbarlg,
     $ xbarw,xbarwc,xbrwlc,xbrwlg,xlks,zchar,zgexj,zvclg1,zvec1)
c
c     Recalculate the Newton-Raphson residual functions.
c
      call betas(acflg,actlg,afcnst,alpha,amtb,bbig,beta,
     $ betamx,bneg,cdrs,conc,conclg,coval,csts,eh,ehfac,fo2lg,
     $ ibetmx,iebal,iindx1,irdxc3,jcsort,jflag,jsflag,jssort,kbt,
     $ kdim,kelect,khydr,kmax,km1,ko2gaq,kwater,kxt,mtb,mosp,
     $ narn1,narn2,nbasp,nbtmax,ncosp,ndrs,ndrsmx,ndrsr,nelect,
     $ nern1,nern2,nhydr,noutpt,no2gaq,nredox,nst,nstmax,nsts,
     $ nstsmx,nstsr,ntfx,ntfxmx,ntfxt,nttyo,omega,qredox,q6mode,
     $ tfx,ubbig,ubneg,ubetmx,uspec,uzvec1,weight,xbrwlg,xlke,
     $ xlks,zchar)
c
      go to 100
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  999 continue
      end

      subroutine cfxi(conc,fxic,jcsort,narn1,narn2,nstmax,zchsq2)
c
c     This subroutine calculates the ionic strength. Note that a sorted
c     summation is used.
c
c     This subroutine is called by:
c
c       EQLIB/ngcadv.f
c       EQ3NR/arrset.f
c       EQ3NR/scripx.f
c       EQ6/scripz.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c       conc   = array of species concentrations
c       jcsort = array of species indices, in order of increasing
c                  concentration, but with sorting restricted to within
c                  phase ranges
c       narn1  = start of the range of aqueous species
c       narn2  = end of the range of aqueous species
c       zchsq2 = array of one-half the electrical charge squared
c
c     Principal output:
c
c       fxic   = the ionic strength (the 2nd-order electrostatic
c                  moment function I)
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nstmax
c
      integer jcsort(nstmax)
      integer narn1,narn2
c
      real*8 conc(nstmax),zchsq2(nstmax)
      real*8 fxic
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer ileft,ns,nss,ns0,ns1,ns2,ns3,ns4,ns5,ns6,ns7,nval
c
      real*8 xx
c
c-----------------------------------------------------------------------
c
c     Logically, this could be represented by:
c
c       fxic = 0.
c       do ns = narn1 + 1,narn2
c         fxic = fxic + conc(ns)*zchsq2(ns)
c       enddo
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     In doing a sorted summation, a complication arises in that
c     water (ns = narn1) must be included in the range of the
c     loop, because the jcsort array is organized to contain the
c     species indices sorted according to increasing concentration
c     within phase ranges. There is no available sorting among
c     aqueous solute species only. Because the electrical charge
c     of water is zero, the calculation can be made looping from
c     narn1 to narn2. It is not necessary to temporarily set the
c     concentration of water (conc(narn1)) to zero. Note the use
c     of a local variable (xx) within the loop. Note also that the
c     loop is unrolled.
c
      xx = 0.
      nval = narn2 - narn1 + 1
      ileft = (nval/8)*8 + narn1 - 1
c
      do nss = narn1,ileft,8
        ns0 = jcsort(nss)
        ns1 = jcsort(nss + 1)
        ns2 = jcsort(nss + 2)
        ns3 = jcsort(nss + 3)
        ns4 = jcsort(nss + 4)
        ns5 = jcsort(nss + 5)
        ns6 = jcsort(nss + 6)
        ns7 = jcsort(nss + 7)
        xx = xx + conc(ns0)*zchsq2(ns0) + conc(ns1)*zchsq2(ns1)
     $          + conc(ns2)*zchsq2(ns2) + conc(ns3)*zchsq2(ns3)
     $          + conc(ns4)*zchsq2(ns4) + conc(ns5)*zchsq2(ns5)
     $          + conc(ns6)*zchsq2(ns6) + conc(ns7)*zchsq2(ns7)
      enddo
c
      do nss = ileft + 1,narn2
        ns = jcsort(nss)
        xx = xx + conc(ns)*zchsq2(ns)
      enddo
c
      fxic = xx
c
      end

      subroutine nlkffg(axlks,cess,cdrs,iffg,ifrn1,ifrn2,jffg,jpflag,
     $ jsflag,mwtsp,narxmx,ncmpr,ndrs,ndrsmx,ndrsr,ness,nessmx,nessr,
     $ nffg,nffgmx,nfrn1,nfrn2,ngrn1,ngrn2,noutpt,nphasx,npt,nptmax,
     $ nst,nstmax,ntpr,ntprmx,nttyo,qcntmp,uffg,ufixf,uphase,uspec,
     $ vosp0,xlkffg)
c
c     This subroutine sets up ficitive minerals, each of which is used
c     to fixing the fugacity of a specified gas. The fugacity is
c     actually fixed only if the corresponding ficitive mineral is in
c     equilibrium with the aqueous system. Otherwise, the fugacity may
c     be less than the specified fugacity value.
c
c     This subroutine is called by:
c
c       EQ6/eq6.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer narxmx,ndrsmx,nessmx,nffgmx,nptmax,nstmax,ntprmx
c
      integer noutpt,nttyo
c
      integer iffg(nffgmx),jffg(nffgmx),jpflag(nptmax),jsflag(nstmax),
     $ ncmpr(2,nptmax),ness(nessmx),nessr(2,nstmax),ndrs(ndrsmx),
     $ ndrsr(2,nstmax),nphasx(nstmax)
c
      integer ifrn1,ifrn2,nffg,nfrn1,nfrn2,ngrn1,ngrn2,npt,nst,ntpr
c
      logical qcntmp
c
      character*48 uspec(nstmax)
      character*24 uffg(nffgmx),uphase(nptmax)
      character*8 ufixf
c
      real*8 axlks(narxmx,ntprmx,nstmax),cess(nessmx),cdrs(ndrsmx),
     $ mwtsp(nstmax),vosp0(nstmax),xlkffg(nffgmx)
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,j,j2,k,n,nerr,nerr1,ng,nn,np,nrf1,nrf2,nr1,nr2,ns,
     $ nsl,nss
c
      integer ilnobl
c
      character*24 ux24
c
c-----------------------------------------------------------------------
c
      nerr = 0
      np = npt
      ns = nst
      nfrn1 = nst + 1
      ifrn1 = npt + 1
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      do n = 1,nffg
c
        do nss = ngrn1,ngrn2
          if (uffg(n)(1:24) .eq. uspec(nss)(1:24)) go to 105
        enddo
        j2 = ilnobl(uffg(n))
        write (noutpt,1000) uffg(n)(1:j2)
        write (nttyo,1000) uffg(n)(1:j2)
 1000   format (/' * Error - (EQ6/nlkffg) ',a,' was not on the',
     $  /7x,'data file, so its fugacity can not be fixed.')
        nerr = nerr + 1
        go to 200
c
  105   nerr1 = 0
c
        if (npt .ge. nptmax) then
          j2 = ilnobl(uffg(n))
          write (noutpt,1010) nptmax,uffg(n)(1:j2)
          write (nttyo,1010) nptmax,uffg(n)(1:j2)
 1010     format (/' * Error - (EQ6/nlkffg) The maximum ',i3,' phases',
     $    /7x,'would be exceeded by by creating a fugacity fixing',
     $    ' phase',
     $    /7x,'for ',a,'. Increase the dimensioning variable nptpar.')
          nerr1 = nerr1 + 1
          nerr = nerr + 1
        endif
c
        if (nst .ge. nstmax) then
          j2 = ilnobl(uffg(n))
          write (noutpt,1020) nstmax,uffg(n)(1:j2)
          write (nttyo,1020) nstmax,uffg(n)(1:j2)
 1020     format (/' * Error - (EQ6/nlkffg) The maximum ',i3,' species',
     $    /7x,'would be exceeded by creating a fugacity fixing phase',
     $    /7x,'for ',a,'. Increase the dimensioning parameter nstpar.')
          nerr1 = nerr1 + 1
          nerr = nerr + 1
        endif
c
        if (nerr1 .gt. 0) go to 200
c
        np = np + 1
        npt = np
        ns = ns + 1
        nsl = nst
        nst = ns
        iffg(n) = ns
        nphasx(ns) = np
        ncmpr(1,np) = ns
        ncmpr(2,np) = ns
        ng = nss - ngrn1 + 1
        jffg(n) = ng
        jpflag(np) = 0
        jsflag(ns) = 0
c
        ux24 = ufixf(1:5)
        ux24(6:24) = uspec(nss)(1:19)
        uspec(ns)(1:24) = ux24
        uspec(ns)(25:48) = ux24
        uphase(np) = ux24
c
        mwtsp(ns) = mwtsp(nss)
        vosp0(ns) = 0.
c
        nr1 = nessr(1,nss)
        nr2 = nessr(2,nss)
        nrf1 = nessr(2,nsl) + 1
        nrf2 = nrf1 + nr2 - nr1
        if (nrf2 .gt. nessmx) then
          ux24 = uspec(ns)(1:24)
          j2 = ilnobl(ux24)
          write (noutpt,1030) nessmx,uspec(ns)(1:j2)
          write (nttyo,1030) nessmx,uspec(ns)(1:j2)
 1030     format (/' * Error - (EQ6/nlkffg) The maximum ',i5,' entries',
     $    /7x,'in the cess/ness arrays would be exceeded by creating',
     $    /7x,'the species ',a,'. Increase the dimensioning',
     $    /7x,'parameter nesspa.')
          nerr = nerr + 1
          go to 115
        endif
        nessr(1,ns) = nrf1
        nessr(2,ns) = nrf2
        k = nr1 - 1
        do nn = nrf1,nrf2
          k = k + 1
          cess(nn) = cess(k)
          ness(nn) = ness(k)
        enddo
c
  115   nr1 = ndrsr(1,nss)
        nr2 = ndrsr(2,nss)
        nrf1 = ndrsr(2,nsl) + 1
        nrf2 = nrf1 + nr2 - nr1
        if (nrf2 .gt. ndrsmx) then
          ux24 = uspec(ns)(1:24)
          j2 = ilnobl(ux24)
          write (noutpt,1040) ndrsmx,uspec(ns)(1:j2)
          write (nttyo,1040) ndrsmx,uspec(ns)(1:j2)
 1040     format (/' * Error - (EQ6/nlkffg) The maximum ',i5,' entries',
     $    /7x,'in the cdrs/ndrs arrays would be exceeded by creating',
     $    /7x,'the species ',a,'. Increase the dimensioning',
     $    /7x,'parameter ndrspa.')
          nerr = nerr + 1
          go to 125
        endif
        ndrsr(1,ns) = nrf1
        ndrsr(2,ns) = nrf2
        k = nr1 - 1
        do nn = nrf1,nrf2
          k = k + 1
          cdrs(nn) = cdrs(k)
          ndrs(nn) = ndrs(k)
        enddo
        ndrs(nrf1) = ns
c
  125   do i = 1,narxmx
          do j = 1,ntprmx
            axlks(i,j,ns) = axlks(i,j,nss)
          enddo
        enddo
c
c       Alter log K values of fixed fugacity solid.
c
        do j = 1,ntprmx
          if (axlks(1,j,ns) .lt. 9999999.) then
            axlks(1,j,ns) = axlks(1,j,ns) + xlkffg(n)
          else
            if (j.eq.ntpr .or. .not.qcntmp) then
              j2 = ilnobl(uffg(n))
              write (noutpt,1050) uffg(n)(1:j2),j
              write (nttyo,1050) uffg(n)(1:j2),j
 1050         format (/" * Error - (EQ6/nlkffg) Can't fix the fugacity",
     $        /7x,' of ',a,' in temperature range ',i2,' because',
     $        /7x,'actual thermodynamic data are lacking.')
              nerr = nerr + 1
            endif
          endif
        enddo
c
  200   continue
      enddo
c
      nfrn2 = nst
      ifrn2 = npt
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (nerr .gt. 0) stop
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      end

      subroutine chktmx(delxi,dlxmin,dlxtmx,drir0,dxval0,eps100,
     $ iodb,nodbmx,nord,noutpt,nrd1mx,nttyo,prcinf,qdump,qriinf,
     $ rirec0,timemx,time0,time1,tolxst,xi0,xi1,xval0)
c
c     This subroutine checks to see that the requested maximum value of
c     time is not exceeded.
c
c     This subroutine is called by:
c
c       EQ6/path.f
c
c-----------------------------------------------------------------------
c
c     Principal input:
c
c
c     Principal output:
c
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nodbmx,nrd1mx
c
      integer noutpt,nttyo
c
      integer iodb(nodbmx)
c
      integer nord
c
      logical qdump,qriinf
c
      real*8 drir0(nrd1mx),dxval0(nrd1mx)
c
      real*8 delxi,dlxmin,dlxtmx,eps100,prcinf,rirec0,timemx,time0,
     $ time1,tolxst,xi0,xi1,xval0,xtargv
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer icount,ier,ilsign,n,nordp1
c
      character*48 usearch
      character*24 unam24
c
      real*8 dxp,dxsv,tolsx
c
      real*8 fctrl
c
c-----------------------------------------------------------------------
c
      data usearch /'time reaches the requested maximum value        '/
      data unam24  /'                       '/
c
c-----------------------------------------------------------------------
c
      dxsv = delxi
c
      nordp1 = nord + 1
      dlxtmx = prcinf
      if (timemx .le. 0.) go to 999
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c     The search target is the requested limit on the time. The interval
c     for convergence is ((1. - tolxst)*timemx,(1. + tolxst)*timemx)).
c
      ilsign = -1
      xtargv = timemx
      tolsx = tolxst*timemx
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      icount = -1
  100 xi1 = xi0 + delxi
      icount = icount + 1
      if (icount .gt. 10) then
        if (iodb(1).gt.0 .or. iodb(5).gt.0) then
          write (noutpt,1000)
 1000     format(/3x,'A scan for where time reaches the requested',
     $    ' maximum value',/3x,'has failed. Dropping to the minimum',
     $    ' step size.')
        endif
        delxi = dlxmin
        go to 990
      endif
c
c     Estimate the time from a Taylor's series expansion.
c
      if (qriinf) then
        time1 = prcinf
      else
        time1 = time0 + rirec0*delxi
        dxp = delxi
        do n = 1,nord
          dxp = dxp*delxi
          time1 = time1 + ( drir0(n)*dxp )/fctrl(n + 1)
        enddo
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if (time0 .gt. (1. - tolxst)*timemx) then
c
c         The time at the base point is too close to the requested
c         maximum value.
c
          delxi = dlxmin
          dlxtmx = delxi
          if (iodb(1).gt.0 .or. iodb(5).gt.0) then
            write (noutpt,1010) time0,timemx,xi0,delxi
 1010       format(/3x,'The base point time of ',1pe11.4,' seconds',
     $      ' is already very close',/3x,'to the requested value of ',
     $      e11.4,' seconds',/3x,'at Xi= ',e11.4,'. Have set delxi',
     $      ' equal to the minimum',/7x,'value of ',e11.4,'.')
            go to 100
          endif
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (delxi .gt. dlxmin) then
        if ((time1 - timemx) .gt. tolsx) then
c
          xval0 = time0
          dxval0(1) = rirec0
          do n = 2,nordp1
            dxval0(n) = drir0(n - 1)
          enddo
c
c         Calling sequence substitutions:
c           nordp1 for nord
c
          call search(delxi,dlxmin,dxval0,eps100,ier,ilsign,iodb,
     $    nodbmx,nordp1,noutpt,nrd1mx,nttyo,tolsx,unam24,usearch,
     $    xtargv,xval0)
c
          dlxtmx = delxi
          if (ier .le. 0) go to 100
          if (ier .ge. 2) then
c
c           Note: if ier = 1, the returned "safe" value of delxi
c           is used.
c
            delxi = dlxmin
          endif
          dlxtmx = delxi
          go to 990
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
      if (iodb(1).gt.0 .or. iodb(5).gt.0) then
        if (abs(time1 - timemx) .le. tolsx) then
          write (noutpt,1020) timemx,xi1,delxi
 1020     format(/3x,"Taylor's series predict that the model time is",
     $    ' at the requested',/3x,'maximum value of ',1pe11.4,
     $    ' seconds at Xi= ',e11.4,',',/3x,'delxi= ',e11.4,'.')
        endif
      endif
c
c* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
  990 if (dxsv .gt. delxi) qdump = .false.
c
  999 continue
      end

      subroutine initiv(iarray,nmax,ivalue)
c
c     This subroutine initializes the integer array iarray to ivalue
c     over the first nmax positions. Normally, nmax would be the
c     dimension of the 1D iarray. However, nmax could be less than the
c     true dimension. Also, iarray could actually have more than one
c     dimension. For example, if the array is really ia, which has
c     dimensions of i1 and i2, this subroutine could be used by calling
c     it in the following manner: call initiv(ia,(i1*i2),ivalue).
c     Use this subroutine with caution if nmax is not the product of the
c     true (declared) dimensions.
c
c     To initialize an integer array to a zero value, use
c     EQLIBU/initiz.f instead.
c
c     This subroutine is called by:
c
c       Any
c
c-----------------------------------------------------------------------
c
c     Input:
c
c       iarray = the array
c       nmax   = dimension or pseudo-dimension of array
c       ivalue = the initialization value
c
c     Output:
c
c       iarray = iarray, with the first nmax positions set to the
c                initialization value
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
c     Calling sequence variable declarations.
c
      integer nmax
c
      integer iarray(nmax),ivalue
c
c-----------------------------------------------------------------------
c
c     Local variable declarations.
c
      integer i,ileft,iv
c
c-----------------------------------------------------------------------
c
c     Note the assignment of the value to a local variable.
c     Note that the loop is unrolled.
c
      iv = ivalue
      ileft = (nmax/8)*8
c
      do i = 1,ileft,8
        iarray(i) = iv
        iarray(i + 1) = iv
        iarray(i + 2) = iv
        iarray(i + 3) = iv
        iarray(i + 4) = iv
        iarray(i + 5) = iv
        iarray(i + 6) = iv
        iarray(i + 7) = iv
      enddo
c
      do i = ileft + 1,nmax
        iarray(i) = iv
      enddo
c
      end
